IDENTIFICATION DIVISION.
PROGRAM-ID. IFCOBREP.
AUTHOR. ANDREI SORIN.
INSTALLATION. IRVINE FASTENERS.
DATE-WRITTEN. 2007-2014.
* Process REPLACE statements in IFOP
* (C) Copyright 2007-2014 Andrei Sorin <a.sorin@andsor.ca>
* IFOP documentation files: NOTES.TXT, INFO.TXT, DATABASE.TXT, MENUS.TXT

* This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
OBJECT-COMPUTER. VAX-VMS.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
    SELECT OLDFL ASSIGN "OLDFL" STATUS DSTAT.
    SELECT NEWFL ASSIGN "NEWFL" STATUS DSTAT.
I-O-CONTROL.
    APPLY EXTENSION 200 ON NEWFL.
DATA DIVISION.
FILE SECTION.
FD  OLDFL RECORD VARYING 0 TO 255 DEPENDING RL-O.
01  O-RECORD PIC X(255).
FD  NEWFL RECORD VARYING 0 TO 255 DEPENDING RL-N.
01  N-RECORD PIC X(255).

WORKING-STORAGE SECTION.
01  DCL-FIELDS.
    02 DSTAT PIC XX.
    02 DCL-LINE. 03 DCL-F1 PIC X(7). 03 DCL-F2 PIC X(11). 03 DCL-F3 PIC XX.
      03 DCL-F4 PIC BBBX(30).
01  LIBRARY-FIELDS.
    02 LIB-RET PIC S9(9) COMP.
    02 LIB-S1 PIC X(250). 02 LIB-W1 PIC S9(4) COMP. 02 LIB-L1 PIC S9(9) COMP.
01  PARAMETER-FIELDS.
    02 A-A1 PIC X(250). 02 A-N1 PIC S9(5) COMP-3.
01  WORK-FIELDS.
    02 IX1 PIC S9(5) COMP-3. 02 IX2 PIC S9(5) COMP-3. 02 WA1 PIC X(10).
01  REPLACE-FIELDS.
    02 RL-O PIC 999 COMP-3. 02 RL-N PIC 999 COMP-3.
    02 KFIR PIC 9 COMP-3. 02 KDEF PIC 9 COMP-3. 02 KREP PIC 9 COMP-3.
    02 RN PIC S999 COMP-3.
    02 STBL. 03 SFLDS OCCURS 6.
      04 STR1 PIC X(20). 04 STR2 PIC X(150).
      04 LEN1 PIC 999 COMP-3. 04 LEN2 PIC 999 COMP-3.

PROCEDURE DIVISION.
DECLARATIVES.
SEC-001 SECTION 0.
    USE AFTER ERROR PROCEDURE INPUT.
USE-1. MOVE "INPUT" TO DCL-F1 PERFORM USE-DIS.
SEC-002 SECTION 0.
    USE AFTER ERROR PROCEDURE OUTPUT.
USE-2. MOVE "OUTPUT" TO DCL-F1 PERFORM USE-DIS.
USE-DIS. MOVE "DISK ERROR" TO DCL-F2 MOVE DSTAT TO DCL-F3.
    MOVE RMS-CURRENT-FILENAME TO DCL-F4.
    DISPLAY DCL-LINE LINE 24 REVERSED ERASE LINE.
END DECLARATIVES.

SEC-0 SECTION 0.
L0. GO L1.
STR-LTH. CALL "STR$TRIM" USING DESCRIPTOR LIB-S1 A-A1 REFERENCE LIB-W1.
    MOVE LIB-W1 TO A-N1.

L1. OPEN INPUT OLDFL OUTPUT NEWFL MOVE 0 TO KFIR KDEF KREP.
L3. READ OLDFL END GO L9. IF RL-O=0 OR O-RECORD(1:1)="*" GO L4.
    IF O-RECORD(1:14)="    REPLACE ==" INITIALIZE STBL RN GO L6.
    IF KDEF=1 GO L6.
    IF O-RECORD(1:15)="    REPLACE OFF" MOVE 0 TO KREP GO L76.
    IF KREP=0 GO L4. MOVE 0 TO RN.
L33. ADD 1 TO RN IF RN>5 OR LEN1(RN)=0 GO L4.
L35. MOVE 0 TO LIB-L1.
    CALL "STR$POSITION" USING DESCRIPTOR O-RECORD(1:RL-O) STR1(RN)(1:LEN1(RN))
      REFERENCE LIB-L1 GIVING LIB-RET IF LIB-RET=0 GO L33.
    MOVE LIB-RET TO IX1.
    MOVE O-RECORD(IX1 + LEN1(RN):RL-O - IX1 - LEN1(RN) + 1)
      TO O-RECORD(IX1 + LEN2(RN):).
    MOVE STR2(RN) TO O-RECORD(IX1:LEN2(RN)).
    COMPUTE RL-O=RL-O + LEN2(RN) - LEN1(RN) GO L35.
L4. IF KFIR=0 MOVE 1 TO KFIR GO L8. GO L78.
L6. IF RN=5 GO L70.
    UNSTRING O-RECORD DELIMITED "==" INTO WA1 STR1(6) WA1 STR2(6).
    MOVE STR1(6) TO A-A1 PERFORM STR-LTH MOVE A-N1 TO LEN1(6).
    MOVE STR2(6) TO A-A1 PERFORM STR-LTH MOVE A-N1 TO LEN2(6).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>RN OR LEN1(6)>LEN1(IX1) CONTINUE END-PERFORM.
    PERFORM VARYING IX2 FROM RN BY -1 UNTIL IX2<IX1
      MOVE SFLDS(IX2) TO SFLDS(IX2 + 1) END-PERFORM.
    MOVE SFLDS(6) TO SFLDS(IX1) ADD 1 TO RN.
L70. IF O-RECORD(RL-O:1)="." MOVE 0 TO KDEF MOVE 1 TO KREP ELSE MOVE 1 TO KDEF.
L76. MOVE "*" TO O-RECORD(1:1).
L78. WRITE N-RECORD.
L8. MOVE O-RECORD TO N-RECORD MOVE RL-O TO RL-N GO L3.

L9. WRITE N-RECORD.
    CLOSE OLDFL NEWFL.
    STOP RUN.

END-OF-PROGRAM.

