IDENTIFICATION DIVISION.
PROGRAM-ID. IFCREATE.
AUTHOR. ANDREI SORIN.
INSTALLATION. IRVINE FASTENERS.
DATE-WRITTEN. 2015.
* Create the data files used by IFOP
* (C) Copyright 2015 Andrei Sorin <a.sorin@andsor.ca>
* IFOP documentation files: NOTES.TXT, INFO.TXT, DATABASE.TXT, MENUS.TXT

* This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
OBJECT-COMPUTER. VAX-VMS.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
    SELECT MAINTA ASSIGN "MAINTA" STATUS DSTAT.
    SELECT MAINTB ASSIGN "MAINTB" STATUS DSTAT.
    SELECT MAINTC ASSIGN "MAINTC" STATUS DSTAT.
    SELECT REPFL ASSIGN "REPFL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY RP-KEY.
    SELECT SORTFL ASSIGN "SORTFL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SR-KEY.
    SELECT SORCFL ASSIGN "SORCFL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SC-KEY.
    SELECT PRINTFL ASSIGN PRINTER.
    SELECT USERS ASSIGN "USERS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY US-KEY
      ALTERNATE RECORD KEY US-KN.
    SELECT GLTOOLCOST ASSIGN "GLTOOLCOST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GTC-KEY.
    SELECT TRAUDIT ASSIGN "TRAUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YT-KEY.
    SELECT AUDIT ASSIGN "AUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AU-KEY.
    SELECT INFOFL ASSIGN "INFOFL" STATUS DSTAT
      ORGANIZATION RELATIVE ACCESS RANDOM RELATIVE KEY IF-KEY.
    SELECT EDINFO ASSIGN "EDINFO" STATUS DSTAT
      ORGANIZATION RELATIVE ACCESS RANDOM RELATIVE KEY EI-KEY.
    SELECT EDI ASSIGN "EDI" STATUS DSTAT.
    SELECT EXPFL ASSIGN "EXPFL" STATUS DSTAT.
    SELECT DOCFL ASSIGN "DOCFL" STATUS DSTAT.
    SELECT LABFL ASSIGN "LABFL" STATUS DSTAT.
    SELECT LASFL ASSIGN "LASFL" STATUS DSTAT.
    SELECT DATFL ASSIGN "DATFL" STATUS DSTAT.
    SELECT TABLES ASSIGN "TABLES" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY T-KEY.
    SELECT SIXIN ASSIGN "SIXIN" STATUS DSTAT.
    SELECT PCLIN ASSIGN "PCLIN" STATUS DSTAT.
    SELECT DRAWINGS ASSIGN "DRAWINGS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DR-KEY.
    SELECT PDRAWINGS ASSIGN "PDRAWINGS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DG-KEY.
    SELECT LABELS ASSIGN "LABELS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LA-KEY
      ALTERNATE RECORD KEY LA-KL DUPLICATES.
    SELECT SHIPVIA ASSIGN "SHIPVIA" STATUS DSTAT
      ORGANIZATION RELATIVE ACCESS RANDOM RELATIVE KEY SV-KEY.
    SELECT PACKING ASSIGN "PACKING" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PK-KEY.
    SELECT SALTOT ASSIGN "SALTOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ST-KEY.
    SELECT SALHIST ASSIGN "SALHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SH-KEY
      ALTERNATE RECORD KEY SH-KP.
    SELECT LOTHIST ASSIGN "LOTHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LN-KEY
      ALTERNATE RECORD KEY LN-KL DUPLICATES
      ALTERNATE RECORD KEY LN-KI DUPLICATES.
    SELECT SALSUM ASSIGN "SALSUM" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SM-KEY
      ALTERNATE RECORD KEY SM-KP.
    SELECT STATEMENT ASSIGN "STATEMENT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SW-KEY.
    SELECT TRANS ASSIGN "TRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TR-KEY
      ALTERNATE RECORD KEY TR-KI
      ALTERNATE RECORD KEY TR-KB DUPLICATES.
    SELECT SALESMAN ASSIGN "SALESMAN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SN-KEY.
    SELECT CUSCONT ASSIGN "CUSCONT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY CY-KEY.
    SELECT CUSTOMER ASSIGN "CUSTOMER" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY C-KEY
      ALTERNATE RECORD KEY C-KN DUPLICATES.
    SELECT PRODUCT ASSIGN "PRODUCT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY P-KEY.
    SELECT ITPRODUCT ASSIGN "DUA1:[ITMAIN]PRODUCT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ITP-KEY.
    SELECT ALTERNATES ASSIGN "ALTERNATES" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AL-KEY.
    SELECT NUTBOLT ASSIGN "NUTBOLT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY NU-KEY.
    SELECT OPERATIONS ASSIGN "OPERATIONS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OP-KEY.
    SELECT ITOPERATIONS ASSIGN "DUA1:[ITMAIN]OPERATIONS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ITOP-KEY.
    SELECT COSTHIST ASSIGN "COSTHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY CU-KEY.
    SELECT QUOTORD ASSIGN "QUOTORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QO-KEY.
    SELECT QUOTLIN ASSIGN "QUOTLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QL-KEY.
    SELECT PRICE ASSIGN "PRICE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IO-KEY
      ALTERNATE RECORD KEY IO-KP.
    SELECT PRICEHIST ASSIGN "PRICEHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY NJ-KEY.
    SELECT SUBCON ASSIGN "SUBCON" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SJ-KEY.
    SELECT SUBINV ASSIGN "SUBINV" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SL-KEY
      ALTERNATE RECORD KEY SL-KS DUPLICATES.
    SELECT BIN ASSIGN "BIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY B-KEY
      ALTERNATE RECORD KEY B-KP DUPLICATES.
    SELECT QBIN ASSIGN "QBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QB-KEY
      ALTERNATE RECORD KEY QB-KP DUPLICATES.
    SELECT PART ASSIGN "PART" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PH-KEY
      ALTERNATE RECORD KEY PH-KD DUPLICATES
      ALTERNATE RECORD KEY PH-KA
      ALTERNATE RECORD KEY PH-KV.
    SELECT IFPART ASSIGN "DUA1:[IFMAIN]PART" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFPH-KEY
      ALTERNATE RECORD KEY IFPH-KD DUPLICATES
      ALTERNATE RECORD KEY IFPH-KA
      ALTERNATE RECORD KEY IFPH-KV.
    SELECT PURBIN ASSIGN "PURBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BH-KEY
      ALTERNATE RECORD KEY BH-KP.
    SELECT TOOLS ASSIGN "TOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TS-KEY.
    SELECT IFTOOLS ASSIGN "DUA1:[IFMAIN]TOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFTS-KEY.
    SELECT ARCTOOLS ASSIGN "ARCTOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TY-KEY.
    SELECT TOOLPROD ASSIGN "TOOLPROD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TP-KEY.
    SELECT IFTOOLPROD ASSIGN "DUA1:[IFMAIN]TOOLPROD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFTP-KEY.
    SELECT HEAT ASSIGN "HEAT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HE-KEY.
    SELECT LOT ASSIGN "LOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LT-KEY
      ALTERNATE RECORD KEY LT-KP.
    SELECT HTRANS ASSIGN "HTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HT-KEY.
    SELECT SHIPTO ASSIGN "SHIPTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SA-KEY.
    SELECT BILLTO ASSIGN "BILLTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BT-KEY.
    SELECT SOLDTO ASSIGN "SOLDTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY UH-KEY.
    SELECT SAORD ASSIGN "SAORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY O-KEY
      ALTERNATE RECORD KEY O-KC DUPLICATES.
    SELECT SALIN ASSIGN "SALIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY L-KEY
      ALTERNATE RECORD KEY L-KP DUPLICATES.
    SELECT SHIPORD ASSIGN "SHIPORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HO-KEY
      ALTERNATE RECORD KEY HO-KB DUPLICATES
      ALTERNATE RECORD KEY HO-KV DUPLICATES.
    SELECT SHIPLIN ASSIGN "SHIPLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HL-KEY
      ALTERNATE RECORD KEY HL-KP DUPLICATES.
    SELECT BINALLOC ASSIGN "BINALLOC" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BA-KEY.
    SELECT TMPORD ASSIGN "TMPORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YO-KEY.
    SELECT TMPLIN ASSIGN "TMPLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YL-KEY.
    SELECT INTMPORD ASSIGN "DUA1:[INMAIN]TMPORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY INYO-KEY.
    SELECT ACKORD ASSIGN "ACKORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AKO-KEY.
    SELECT ACKLIN ASSIGN "ACKLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AKL-KEY.
    SELECT CFORD ASSIGN "CFORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY FO-KEY.
    SELECT CFLIN ASSIGN "CFLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY FL-KEY.
    SELECT PURORD ASSIGN "PURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OK-KEY
      ALTERNATE RECORD KEY OK-KV.
    SELECT PURLIN ASSIGN "PURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LK-KEY
      ALTERNATE RECORD KEY LK-KP DUPLICATES.
    SELECT IFPURORD ASSIGN "DUA1:[IFMAIN]PURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFOK-KEY
      ALTERNATE RECORD KEY IFOK-KV.
    SELECT IFPURLIN ASSIGN "DUA1:[IFMAIN]PURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFLK-KEY
      ALTERNATE RECORD KEY IFLK-KP DUPLICATES.
    SELECT TMPURORD ASSIGN "TMPURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YOK-KEY.
    SELECT TMPURLIN ASSIGN "TMPURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YLK-KEY.
    SELECT PARTRANS ASSIGN "PARTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PT-KEY.
    SELECT PRODTRANS ASSIGN "PRODTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PE-KEY.
    SELECT PLANT ASSIGN "PLANT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PL-KEY
      ALTERNATE RECORD KEY PL-KO DUPLICATES
      ALTERNATE RECORD KEY PL-KR DUPLICATES.
    SELECT MATREL ASSIGN "MATREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MT-KEY
      ALTERNATE RECORD KEY MT-KP DUPLICATES.
    SELECT DAYREL ASSIGN "DAYREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DY-KEY
      ALTERNATE RECORD KEY DY-KP DUPLICATES.
    SELECT DELJITEX ASSIGN "DELJITEX" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DX-KEY.
    SELECT MACHINE ASSIGN "MACHINE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY M-KEY.
    SELECT ITMACHINE ASSIGN "DUA1:[ITMAIN]MACHINE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ITM-KEY.
    SELECT MACTYPE ASSIGN "MACTYPE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ME-KEY.
    SELECT MACSCHED ASSIGN "MACSCHED" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MQ-KEY.
    SELECT PRODORD ASSIGN "PRODORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY R-KEY
      ALTERNATE RECORD KEY R-KP DUPLICATES.
    SELECT WORKSHEET ASSIGN "WORKSHEET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY J-KEY
      ALTERNATE RECORD KEY J-KM DUPLICATES
      ALTERNATE RECORD KEY J-KN DUPLICATES
      ALTERNATE RECORD KEY J-KD DUPLICATES.
    SELECT BUCKET ASSIGN "BUCKET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BU-KEY
      ALTERNATE RECORD KEY BU-KN DUPLICATES.
    SELECT PHYSINV ASSIGN "PHYSINV" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PI-KEY
      ALTERNATE RECORD KEY PI-KM DUPLICATES.
    SELECT MILL ASSIGN "MILL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ML-KEY
      ALTERNATE RECORD KEY ML-KD DUPLICATES.
    SELECT MNTMAST ASSIGN "MNTMAST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MF-KEY.
    SELECT MNTORD ASSIGN "MNTORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY VO-KEY
      ALTERNATE RECORD KEY VO-KN.
    SELECT MNTLIN ASSIGN "MNTLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY VL-KEY.
    SELECT MNTMAC ASSIGN "MNTMAC" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MK-KEY.
    SELECT VENDOR ASSIGN "VENDOR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY V-KEY
      ALTERNATE RECORD KEY V-KN DUPLICATES.
    SELECT APTR ASSIGN "APTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AT-KEY
      ALTERNATE RECORD KEY AT-KD.
    SELECT INAPTR ASSIGN "DUA1:[INMAIN]APTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY INAT-KEY
      ALTERNATE RECORD KEY INAT-KD.
    SELECT APCHQ ASSIGN "APCHQ" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AH-KEY.
    SELECT GLDIST ASSIGN "GLDIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY G-KEY.
    SELECT GLTR ASSIGN "GLTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GT-KEY.
    SELECT PURHIST ASSIGN "PURHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PU-KEY
      ALTERNATE RECORD KEY PU-KV.
    SELECT EMPL ASSIGN "EMPLOYEE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY E-KEY.
    SELECT LDTBL ASSIGN "LDTBL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GP-KEY.
    SELECT LDTR ASSIGN "LDTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LY-KEY.
    SELECT GLAP ASSIGN "GLAP" STATUS DSTAT.
    SELECT IFGFL ASSIGN "IFGFL" STATUS DSTAT.
    SELECT BNCHQ ASSIGN "BNCHQ" STATUS DSTAT.
    SELECT BNCLR ASSIGN "BNCLR" STATUS DSTAT.
I-O-CONTROL.
    APPLY PRINT-CONTROL ON PRINTFL.
DATA DIVISION.
FILE SECTION.
FD  MAINTA VALUE OF ID MFA-ID BLOCK 1024.
01  MFA-RECORD PIC X(320).

FD  MAINTB VALUE OF ID MFB-ID BLOCK 1024.
01  MFB-RECORD PIC X(320).

FD  MAINTC VALUE OF ID MFC-ID BLOCK 1024.
01  MFC-RECORD PIC X(320).

FD  REPFL VALUE OF ID REP-ID BLOCK 2048.
01  RP-RECORD PIC X(135).
01  RP-REC.
    02 RP-KEY PIC X(48).

FD  SORTFL VALUE OF ID SORT-ID BLOCK 2048.
01  SR-RECORD PIC X(115).
01  SR-REC.
    02 SR-KEY PIC X(30).

FD  SORCFL VALUE OF ID SORC-ID BLOCK 2048.
01  SC-RECORD PIC X(115).
01  SC-REC.
    02 SC-KEY PIC X(30).

FD  PRINTFL VALUE OF ID PR-ID.
01  PREC PIC X(132).

FD  USERS.
01  US-RECORD PIC X(1500).
01  US-REC.
    02 US-KEY.
      03 US-USER PIC X(12).
    02 US-KN.
      03 US-NUM PIC 99.
    02 US-TDX OCCURS 24. 03 US-TD PIC X OCCURS 40.
    02 US-PR-FILE PIC X(8).
    02 US-PR-NO PIC 99.
    02 US-PR-EXT PIC XXX.
    02 US-PR-QUEUE PIC X(10).
    02 US-PC PIC 9.
    02 US-NAME PIC X(24).
    02 US-PRNM PIC XX.
    02 US-CFLD PIC 99 OCCURS 10.
    02 US-PFLD PIC 99 OCCURS 10.

FD  GLTOOLCOST.
01  GTC-RECORD PIC X(30).
01  GTC-REC.
    02 GTC-KEY.
      03 GTC-GL PIC 9(18).

FD  TRAUDIT.
01  YT-RECORD PIC X(75).
01  YT-REC.
    02 YT-KEY.
      03 YT-CUS PIC X(6).
      03 YT-INV PIC 9(6).
      03 YT-DATE PIC 9(6).
      03 YT-TIME PIC 9(8).

FD  AUDIT BLOCK 2048.
01  AU-RECORD PIC X(650).
01  AU-REC.
    02 AU-KEY.
      03 AU-K PIC 99.
      03 AU-L PIC 99.
      03 AU-DATE PIC 9(6).
      03 AU-TIME PIC 9(8).

FD  INFOFL.
01  IF-RECORD PIC X(1800).
01  IF-REC.
    02 IF-ORDNO PIC 9(6).
    02 IF-INVNO PIC 9(6).
    02 IF-PST PIC 99.
    02 IF-BLNO PIC 9(7).
    02 IF-SPINVNO PIC 9(6).
    02 IF-GST PIC 99.
    02 IF-RNO PIC 9(6) OCCURS 10.
    02 IF-PRINTER PIC 9.
    02 IF-GMR-DATE PIC 9(6).
    02 IF-FILL1 PIC X(18).
    02 OCCURS 15. 03 IF-OFF-DATE1 PIC 9(6). 03 IF-OFF-DATE2 PIC 9(6).
    02 IF-RMSUR PIC 9(4)V999.
    02 IF-SURCH PIC V999 OCCURS 9.
    02 IF-FILL2 PIC X(5).
    02 IF-SHP-SAVNO PIC 9(6).
    02 IF-DXNO PIC 9(4).
    02 IF-HST PIC 99.
    02 IF-QST PIC 99V9.
    02 IF-SALMTD-IG PIC S9(6)V99.
    02 IF-SAV-SAL-IG PIC S9(6)V99.
    02 IF-QUOTNO PIC 9(6).
    02 IF-LABNO PIC 9(8).
    02 OCCURS 5. 03 IF-EXCHX. 04 IF-EXCH PIC 9V9(4) OCCURS 12.
    02 IF-EXCH-AP PIC 9V9(4).
    02 IF-SHP-IND PIC 9.
    02 IF-SHP-DATE PIC 9(6).
    02 IF-SAV-SAL PIC S9(6)V99 OCCURS 5.
    02 IF-FILL3 PIC X(9).
    02 IF-CST-NUM PIC 99 OCCURS 8.
    02 IF-CST-PERIOD PIC X(10) OCCURS 8.
    02 IF-ITORDNO PIC 9(5).
    02 IF-EXCH-YY PIC 99.
    02 IF-DEM-DATE PIC 9(6).
    02 IF-CST-FREIGHT PIC 99V999.
    02 IF-MAINTNO PIC 9(6).
    02 IF-PRNSEQ PIC 99.
    02 IF-RMPROC PIC 999V99 OCCURS 8.
    02 IF-RMPROC-A PIC 999V99 OCCURS 2.
    02 IF-RMCLEAN PIC 999V99 OCCURS 8.
    02 IF-SALMTD PIC S9(7)V99 OCCURS 8.
    02 OCCURS 2. 03 IF-SALVAL PIC S9(8)V99 OCCURS 27.
    02 IF-USALMTD PIC S9(6)V99 OCCURS 5.
    02 IF-SAV-USAL PIC S9(6)V99 OCCURS 5.

FD  EDINFO.
01  EI-RECORD PIC X(120).
01  EI-REC.
    02 EI-TOW-ISA PIC 9(6).
    02 EI-GMC-ISA PIC 9(6).
    02 EI-CONTRL-ISA PIC 9(6).
    02 EI-CHRY-ISA PIC 9(6).
    02 EI-RBW-ISA PIC 9(6).
    02 EI-AOS-ISA PIC 9(6).
    02 EI-DANA-ISA PIC 9(6).
    02 EI-TRW-ISA PIC 9(6).
    02 EI-UTA-ISA PIC 9(6).
    02 EI-MGM-ISA PIC 9(6).
    02 EI-WOOD-ISA PIC 9(6).
    02 EI-MOD-ISA PIC 9(6).
    02 EI-BEN-ISA PIC 9(6).
    02 EI-VEN-ISA PIC 9(6).

FD  EDI VALUE OF ID EDI-ID RECORD VARYING 0 TO 400 DEPENDING EDI-SZ.
01  ED-RECORD PIC X(400).

FD  EXPFL VALUE OF ID EXP-ID RECORD VARYING 0 TO 500 DEPENDING EXP-SZ.
01  EXP-RECORD PIC X(500).

FD  DOCFL VALUE OF ID DOC-ID RECORD VARYING 0 TO 132 DEPENDING DOC-SZ.
01  DOC-RECORD PIC X(132).

FD  LABFL VALUE OF ID LAB-ID RECORD VARYING 0 TO 500 DEPENDING LAB-SZ.
01  LAB-RECORD PIC X(500).

FD  LASFL VALUE OF ID LAS-ID.
01  LAS-RECORD PIC X(512).

FD  DATFL VALUE OF ID DAT-ID RECORD VARYING 0 TO 200 DEPENDING DAT-SZ.
01  DAT-RECORD PIC X(200).

FD  TABLES.
01  T-RECORD PIC X(60).
01  T-REC.
    02 T-KEY.
      03 T-TBL PIC 99.
      03 T-NO PIC 999.
    02 T-LINE PIC X(45).

FD  SIXIN VALUE OF ID SIX-ID RECORD VARYING 0 TO 900 DEPENDING SIX-SZ.
01  SIN-RECORD PIC X(900).

FD  PCLIN VALUE OF ID PIN-ID.
01  PIN-RECORD PIC X(512).

FD  DRAWINGS BLOCK 4096 RECORD VARYING 13 TO 900 DEPENDING SIX-SZ.
01  DR-RECORD PIC X(900).
01  DR-REC.
    02 DR-KEY.
      03 DR-DRAW PIC X(8).
      03 DR-PAGE PIC 9.
      03 DR-LINE PIC 9(4).

FD  PDRAWINGS BLOCK 4096.
01  DG-RECORD PIC X(525).
01  DG-REC.
    02 DG-KEY.
      03 DG-DRAW PIC X(8).
      03 DG-PAGE PIC 9.
      03 DG-LINE PIC 9(4).

FD  LABELS.
01  LA-RECORD PIC X(240).
01  LA-REC.
    02 LA-KEY.
      03 LA-NO PIC 9(8).
    02 LA-KL.
      03 LA-ZLYEAR PIC 9(4).
      03 LA-ZLOT PIC 9(7).
      03 LA-ZDATE PIC 9(6).
      03 LA-ZTIME PIC 9(8).

FD  SHIPVIA.
01  SV-RECORD PIC X(120).

FD  PACKING.
01  PK-RECORD PIC X(115).
01  PK-REC.
    02 PK-KEY.
      03 PK-NO PIC 999.

FD  SALTOT.
01  ST-RECORD PIC X(60).
01  ST-REC.
    02 ST-KEY.
      03 ST-TER PIC 99.
      03 ST-CAT PIC 99.
      03 ST-YY PIC 99.
      03 ST-MM PIC 99.
      03 ST-DD PIC 99.
      03 ST-US PIC 9.

FD  SALHIST BLOCK 2048.
01  SH-RECORD PIC X(135).
01  SH-REC.
    02 SH-KEY.
      03 SH-CUS PIC X(6).
      03 SH-PROD PIC X(12).
      03 SH-CDATE PIC 9(6).
      03 SH-CTIME PIC 9(8).
    02 SH-KP.
      03 SH-KPROD PIC X(12).
      03 SH-KCUS PIC X(6).
      03 SH-KDATE PIC 9(6).
      03 SH-KTIME PIC 9(8).

FD  LOTHIST.
01  LN-RECORD PIC X(90).
01  LN-REC.
    02 LN-KEY.
      03 LN-CUS PIC X(6).
      03 LN-DATE PIC 9(6).
      03 LN-TIME PIC 9(8).
    02 LN-KL.
      03 LN-LOT PIC 9(7).
    02 LN-KI.
      03 LN-INV PIC 9(6).

FD  SALSUM.
01  SM-RECORD PIC X(115).
01  SM-REC.
    02 SM-KEY.
      03 SM-CUS PIC X(6).
      03 SM-PROD PIC X(12).
    02 SM-KP.
      03 SM-KPROD PIC X(12).
      03 SM-KCUS PIC X(6).

FD  STATEMENT.
01  SW-RECORD PIC X(50).
01  SW-REC.
    02 SW-KEY.
      03 SW-CUS PIC X(6).
      03 SW-DATE PIC 9(6).
      03 SW-LINE PIC 9(4).

FD  TRANS.
01  TR-RECORD PIC X(75).
01  TR-REC.
    02 TR-KEY.
      03 TR-CUS PIC X(6).
      03 TR-KI.
        04 TR-INV PIC 9(6).
    02 TR-KB.
      03 TR-BL PIC 9(7).
      03 TR-BINV PIC 9(6).

FD  SALESMAN.
01  SN-RECORD PIC X(115).
01  SN-REC.
    02 SN-KEY.
      03 SN-NO PIC 99.

FD  CUSCONT.
01  CY-RECORD PIC X(1500).
01  CY-REC.
    02 CY-KEY.
      03 CY-NO PIC X(6).

FD  CUSTOMER BLOCK 2048.
01  C-RECORD PIC X(390).
01  C-REC.
    02 C-KEY.
      03 C-NO PIC X(6).
    02 C-TER PIC 99 COMP-3.
    02 C-PROV PIC 99 COMP-3.
    02 C-SAL PIC 99 COMP-3.
    02 C-KN.
      03 C-NAME PIC X(32).

FD  PRODUCT BLOCK 3584.
01  P-RECORD PIC X(1150).
01  P-REC.
    02 P-KEY.
      03 P-NO PIC X(12).

FD  ITPRODUCT BLOCK 3584.
01  ITP-RECORD PIC X(1150).
01  ITP-REC.
    02 ITP-KEY.
      03 ITP-NO PIC X(12).

FD  ALTERNATES.
01  AL-RECORD PIC X(50).
01  AL-REC.
    02 AL-KEY.
      03 AL-PROD PIC X(12).
      03 AL-ALT PIC X(12).

FD  NUTBOLT.
01  NU-RECORD PIC X(50).
01  NU-REC.
    02 NU-KEY.
      03 NU-NUT PIC X(12).
      03 NU-BOLT PIC X(12).

FD  OPERATIONS.
01  OP-RECORD PIC X(115).
01  OP-REC.
    02 OP-KEY.
      03 OP-PROD PIC X(12).
      03 OP-MAC PIC 99.

FD  ITOPERATIONS.
01  ITOP-RECORD PIC X(115).
01  ITOP-REC.
    02 ITOP-KEY.
      03 ITOP-PROD PIC X(12).
      03 ITOP-MAC PIC 99.

FD  COSTHIST BLOCK 2048.
01  CU-RECORD PIC X(390).
01  CU-REC.
    02 CU-KEY.
      03 CU-PROD PIC X(12).

FD  QUOTORD.
01  QO-RECORD PIC X(1500).
01  QO-REC.
    02 QO-KEY.
      03 QO-NO PIC 9(6).

FD  QUOTLIN.
01  QL-RECORD PIC X(480).
01  QL-REC.
    02 QL-KEY.
      03 QL-NO PIC 9(6).
      03 QL-LINE PIC 99.

FD  PRICE.
01  IO-RECORD PIC X(115).
01  IO-REC.
    02 IO-KEY.
      03 IO-CUS PIC X(6).
      03 IO-PROD PIC X(12).
    02 IO-KP.
      03 IO-KPROD PIC X(12).
      03 IO-KCUS PIC X(6).

FD  PRICEHIST.
01  NJ-RECORD PIC X(115).
01  NJ-REC.
    02 NJ-KEY.
      03 NJ-CUS PIC X(6).
      03 NJ-PROD PIC X(12).
      03 NJ-CDATE PIC 9(6).

FD  SUBCON BLOCK 1024.
01  SJ-RECORD PIC X(320).
01  SJ-REC.
    02 SJ-KEY.
      03 SJ-MAC PIC 9(4).
      03 SJ-MO PIC 9(6).
      03 SJ-SUFFIX PIC X.
      03 SJ-LOT PIC 9(7).
      03 SJ-PROD PIC X(12).

FD  SUBINV.
01  SL-RECORD PIC X(115).
01  SL-REC.
    02 SL-KEY.
      03 SL-MAC PIC 9(4).
      03 SL-MO PIC 9(6).
      03 SL-SUFFIX PIC X.
      03 SL-LOT PIC 9(7).
      03 SL-PROD PIC X(12).
      03 SL-KSLIP PIC X(10).
      03 SL-SEQ PIC 99.
    02 SL-KS.
      03 SL-SLIP PIC X(10).
      03 SL-ORD PIC X(8).

FD  BIN BLOCK 2048.
01  B-RECORD PIC X(60).
01  B-REC.
    02 B-KEY.
      03 B-NO PIC X(5).
    02 B-KP.
      03 B-PROD PIC X(12).
      03 B-LYEAR PIC 9(4).
      03 B-LOT PIC 9(7).
      03 B-DATE PIC 9(6).

FD  QBIN.
01  QB-RECORD PIC X(115).
01  QB-REC.
    02 QB-KEY.
      03 QB-NO PIC X(5).
    02 QB-KP.
      03 QB-PROD PIC X(12).
      03 QB-LYEAR PIC 9(4).
      03 QB-LOT PIC 9(7).
      03 QB-DATE PIC 9(6).

FD  PART BLOCK 4096.
01  PH-RECORD PIC X(570).
01  PH-REC.
    02 PH-KEY.
      03 PH-NO PIC X(12).
    02 PH-KD.
      03 PH-DRAW PIC X(12).
    02 PH-KA.
      03 PH-ALT PIC 9(12).
      03 PH-KANO PIC X(12).
    02 PH-KV.
      03 PH-VNUM PIC X(24).
      03 PH-KVNO PIC X(12).

FD  IFPART BLOCK 4096.
01  IFPH-RECORD PIC X(570).
01  IFPH-REC.
    02 IFPH-KEY.
      03 IFPH-NO PIC X(12).
    02 IFPH-KD.
      03 IFPH-DRAW PIC X(12).
    02 IFPH-KA.
      03 IFPH-ALT PIC 9(12).
      03 IFPH-KANO PIC X(12).
    02 IFPH-KV.
      03 IFPH-VNUM PIC X(24).
      03 IFPH-KVNO PIC X(12).

FD  PURBIN BLOCK 2048.
01  BH-RECORD PIC X(115).
01  BH-REC.
    02 BH-KEY.
      03 BH-NO PIC X(8).
    02 BH-KP.
      03 BH-PART PIC X(12).
      03 BH-DATE PIC 9(6).
      03 BH-KNO PIC X(8).

FD  TOOLS.
01  TS-RECORD PIC X(3300).
01  TS-REC.
    02 TS-KEY.
      03 TS-PROD PIC X(12).
      03 TS-MAC PIC 99.

FD  IFTOOLS.
01  IFTS-RECORD PIC X(3300).
01  IFTS-REC.
    02 IFTS-KEY.
      03 IFTS-PROD PIC X(12).
      03 IFTS-MAC PIC 99.

FD  ARCTOOLS.
01  TY-RECORD PIC X(3400).
01  TY-REC.
    02 TY-KEY.
      03 TY-PROD PIC X(12).
      03 TY-MAC PIC 99.
      03 TY-ID PIC X.

FD  TOOLPROD.
01  TP-RECORD PIC X(50).
01  TP-REC.
    02 TP-KEY.
      03 TP-TOOL PIC X(12).
      03 TP-PROD PIC X(12).
      03 TP-MAC PIC 99.
      03 TP-FLD PIC 999.

FD  IFTOOLPROD.
01  IFTP-RECORD PIC X(50).
01  IFTP-REC.
    02 IFTP-KEY.
      03 IFTP-TOOL PIC X(12).
      03 IFTP-PROD PIC X(12).
      03 IFTP-MAC PIC 99.
      03 IFTP-FLD PIC 999.

FD  HEAT.
01  HE-RECORD PIC X(75).
01  HE-REC.
    02 HE-KEY.
      03 HE-NO PIC X(10).

FD  LOT BLOCK 2048.
01  LT-RECORD PIC X(500).
01  LT-REC.
    02 LT-KEY.
      03 LT-NO PIC 9(7).
    02 LT-KP.
      03 LT-PROD PIC X(12).
      03 LT-LYEAR PIC 9(4).
      03 LT-LOT PIC 9(7).

FD  HTRANS.
01  HT-RECORD PIC X(240).
01  HT-REC.
    02 HT-KEY.
      03 HT-INVLN.
        04 HT-INV PIC 9(6).
        04 HT-LN PIC 99.
      03 HT-LYEAR PIC 9(4).
      03 HT-LOT PIC 9(7).

FD  SHIPTO.
01  SA-RECORD PIC X(150).
01  SA-REC.
    02 SA-KEY.
      03 SA-CUS PIC X(6).
      03 SA-TO PIC 99.
    02 SA-NO REDEFINES SA-KEY PIC X(8).

FD  BILLTO.
01  BT-RECORD PIC X(240).
01  BT-REC.
    02 BT-KEY.
      03 BT-CUS PIC X(6).
      03 BT-TO PIC 99.

FD  SOLDTO.
01  UH-RECORD PIC X(240).
01  UH-REC.
    02 UH-KEY.
      03 UH-NO PIC X(6).

FD  SAORD.
01  O-RECORD PIC X(480).
01  O-REC.
    02 O-KEY.
      03 O-NO PIC 9(6).
    02 O-KC.
      03 O-CUS PIC X(6).
      03 O-DATE PIC 9(6).

FD  SALIN.
01  L-RECORD PIC X(150).
01  L-REC.
    02 L-KEY.
      03 L-ORD PIC 9(6).
      03 L-LINE PIC 99.
    02 L-NO REDEFINES L-KEY PIC 9(8).
    02 L-TER PIC 99 COMP-3.
    02 L-CUS PIC X(6).
    02 L-KP.
      03 L-PROD PIC X(12).
      03 L-DATE-REQ PIC 9(6).

FD  SHIPORD.
01  HO-RECORD PIC X(240).
01  HO-REC.
    02 HO-KEY.
      03 HO-ORD PIC 9(6).
      03 HO-SEQ PIC 99.
    02 HO-NO REDEFINES HO-KEY PIC 9(8).
    02 HO-ORDSEQ REDEFINES HO-KEY PIC 9(8).
    02 HO-KB.
      03 HO-BL PIC 9(7).
    02 HO-KV.
      03 HO-VIA PIC 99.
      03 HO-CUS PIC X(6).
      03 HO-DATE-REQ PIC 9(6).

FD  SHIPLIN.
01  HL-RECORD PIC X(240).
01  HL-REC.
    02 HL-KEY.
      03 HL-ORDSEQ PIC 9(8).
      03 REDEFINES HL-ORDSEQ.
        04 HL-ORD PIC 9(6).
        04 HL-SEQ PIC 99.
      03 HL-LINE PIC 99.
    02 HL-NO REDEFINES HL-KEY PIC 9(10).
    02 HL-KP.
      03 HL-PROD PIC X(12).
      03 HL-DATE-REQ PIC 9(6).

FD  BINALLOC.
01  BA-RECORD PIC X(50).
01  BA-REC.
    02 BA-KEY.
      03 BA-NO PIC 9(10).
      03 REDEFINES BA-NO.
        04 BA-ORDSEQ PIC 9(8).
        04 REDEFINES BA-ORDSEQ.
          05 BA-ORD PIC 9(6).
          05 BA-SEQ PIC 99.
        04 BA-LINE PIC 99.
      03 BA-BIN PIC X(5).

FD  TMPORD.
01  YO-RECORD PIC X(480).
01  YO-REC.
    02 YO-KEY.
      03 YO-K PIC X(6).
      03 YO-SEQ PIC 9(4).

FD  TMPLIN.
01  YL-RECORD PIC X(240).
01  YL-REC.
    02 YL-KEY.
      03 YL-K PIC X(8).
      03 YL-SEQ PIC 9(4).

FD  INTMPORD.
01  INYO-RECORD PIC X(480).
01  INYO-REC.
    02 INYO-KEY.
      03 INYO-K PIC X(6).
      03 INYO-SEQ PIC 9(4).

FD  ACKORD.
01  AKO-RECORD PIC X(480).
01  AKO-REC.
    02 AKO-KEY.
      03 AKO-NO PIC 9(6).

FD  ACKLIN.
01  AKL-RECORD PIC X(150).
01  AKL-REC.
    02 AKL-KEY.
      03 AKL-ORD PIC 9(6).
      03 AKL-LINE PIC 99.
    02 AKL-NO REDEFINES AKL-KEY PIC 9(8).

FD  CFORD BLOCK 1024.
01  FO-RECORD PIC X(320).
01  FO-REC.
    02 FO-KEY.
      03 FO-BL PIC 9(7).

FD  CFLIN.
01  FL-RECORD PIC X(115).
01  FL-REC.
    02 FL-KEY.
      03 FL-BL PIC 9(7).
      03 FL-SEQ PIC 9(4).

FD  PURORD BLOCK 1024.
01  OK-RECORD PIC X(190).
01  OK-REC.
    02 OK-KEY.
      03 OK-NO PIC X(8).
    02 OK-KV.
      03 OK-VENDOR PIC 9(4).
      03 OK-ZNO PIC X(8).

FD  PURLIN.
01  LK-RECORD PIC X(980).
01  LK-REC.
    02 LK-KEY.
      03 LK-ORD PIC X(8).
      03 LK-LINE PIC 99.
    02 LK-NO REDEFINES LK-KEY PIC X(10).
    02 LK-KP.
      03 LK-PART PIC X(12).
      03 LK-DATE-REQ PIC 9(6).

FD  IFPURORD BLOCK 1024.
01  IFOK-RECORD PIC X(190).
01  IFOK-REC.
    02 IFOK-KEY.
      03 IFOK-NO PIC X(8).
    02 IFOK-KV PIC X(12).

FD  IFPURLIN.
01  IFLK-RECORD PIC X(980).
01  IFLK-REC.
    02 IFLK-KEY.
      03 IFLK-ORD PIC X(8).
      03 IFLK-LINE PIC 99.
    02 IFLK-NO REDEFINES IFLK-KEY PIC X(10).
    02 IFLK-KP.
      03 IFLK-PART PIC X(12).
      03 IFLK-DATE-REQ PIC 9(6).

FD  TMPURORD.
01  YOK-RECORD PIC X(240).
01  YOK-REC.
    02 YOK-KEY.
      03 YOK-ORD PIC X(8).
      03 YOK-SEQ PIC 9(4).

FD  TMPURLIN.
01  YLK-RECORD PIC X(980).
01  YLK-REC.
    02 YLK-KEY.
      03 YLK-ORD PIC X(8).
      03 YLK-SEQ PIC 9(4).
      03 YLK-LINE PIC 99.

FD  PARTRANS.
01  PT-RECORD PIC X(115).
01  PT-REC.
    02 PT-KEY.
      03 PT-PART PIC X(12).
      03 PT-DATE PIC 9(6).
      03 PT-TIME PIC 9(8).

FD  PRODTRANS.
01  PE-RECORD PIC X(115).
01  PE-REC.
    02 PE-KEY.
      03 PE-PROD PIC X(12).
      03 PE-DATE PIC 9(6).
      03 PE-TIME PIC 9(8).

FD  PLANT.
01  PL-RECORD PIC X(115).
01  PL-REC.
    02 PL-KEY.
      03 PL-PLANT PIC X(10).
      03 PL-PROD PIC X(12).
    02 PL-KO.
      03 PL-ORD PIC 9(6).
    02 PL-KR.
      03 PL-RECEIVER PIC XXX.

FD  MATREL.
01  MT-RECORD PIC X(980).
01  MT-REC.
    02 MT-KEY.
      03 MT-PLANT PIC X(10).
      03 MT-PROD PIC X(12).
      03 MT-SEQ PIC 99.
    02 MT-KP.
      03 MT-KPROD PIC X(12).
      03 MT-KPLANT PIC X(10).

FD  DAYREL.
01  DY-RECORD PIC X(1500).
01  DY-REC.
    02 DY-KEY.
      03 DY-PLANT PIC X(10).
      03 DY-PROD PIC X(12).
      03 DY-SEQ PIC 99.
    02 DY-KP.
      03 DY-KPROD PIC X(12).
      03 DY-KPLANT PIC X(10).

FD  DELJITEX.
01  DX-RECORD PIC X(2000).
01  DX-REC.
    02 DX-KEY.
      03 DX-NO PIC 9(4).

FD  MACHINE.
01  M-RECORD PIC X(150).
01  M-REC.
    02 M-KEY.
      03 M-NO PIC 9(4).

FD  ITMACHINE.
01  ITM-RECORD PIC X(150).
01  ITM-REC.
    02 ITM-KEY.
      03 ITM-NO PIC 9(4).

FD  MACTYPE.
01  ME-RECORD PIC X(50).
01  ME-REC.
    02 ME-KEY.
      03 ME-NO PIC 99.

FD  MACSCHED BLOCK 2048.
01  MQ-RECORD PIC X(650).
01  MQ-REC.
    02 MQ-KEY.
      03 MQ-MAC PIC 99.

FD  PRODORD BLOCK 2048.
01  R-RECORD PIC X(115).
01  R-REC.
    02 R-KEY.
      03 R-NO PIC 9(6).
    02 R-KP.
      03 R-PROD PIC X(12).
      03 R-DATE PIC 9(6).

FD  WORKSHEET BLOCK 2048.
01  J-RECORD PIC X(240).
01  J-REC.
    02 J-KEY.
      03 J-NO PIC 9(6).
      03 J-KM.
        04 J-MAC PIC 9(4).
        04 J-DATE PIC 9(6).
        04 J-SHIFT PIC 9.
        04 J-EMP PIC 9(4).
    02 J-KN.
      03 J-KNO PIC 9(6).
      03 J-KD.
        04 J-KDATE PIC 9(6).
        04 J-KSHIFT PIC 9.
        04 J-KMAC PIC 9(4).

FD  BUCKET.
01  BU-RECORD PIC X(50).
01  BU-REC.
    02 BU-KEY.
      03 BU-JKEY.
        04 BU-NO PIC 9(6).
        04 BU-MAC PIC 9(4).
        04 BU-DATE PIC 9(6).
        04 BU-SHIFT PIC 9.
        04 BU-EMP PIC 9(4).
      03 BU-NUM PIC 9(4).
    02 BU-KN.
      03 BU-KNUM PIC 9(4).
      03 BU-ZDATE PIC 9(6).

FD  PHYSINV.
01  PI-RECORD PIC X(50).
01  PI-REC.
    02 PI-KEY.
      03 PI-NO PIC 9(6).
    02 PI-KM.
      03 PI-MO PIC 9(6).

FD  MILL.
01  ML-RECORD PIC X(240).
01  ML-REC.
    02 ML-KEY.
      03 ML-CYCLE PIC X(4).
      03 ML-DIAM PIC X(6).
    02 ML-KD.
      03 ML-KDIAM PIC X(6).
      03 ML-ZDATE PIC 9(6) COMP-3.

FD  MNTMAST.
01  MF-RECORD PIC X(980).
01  MF-REC.
    02 MF-KEY.
      03 MF-MAC PIC 999.
      03 MF-SEC PIC 99.
      03 MF-LEVEL PIC 99.

FD  MNTORD BLOCK 2048.
01  VO-RECORD PIC X(650).
01  VO-REC.
    02 VO-KEY.
      03 VO-NO PIC 9(6).
    02 VO-KN.
      03 VO-ZNO PIC 9(6).

FD  MNTLIN.
01  VL-RECORD PIC X(60).
01  VL-REC.
    02 VL-KEY.
      03 VL-NO PIC 9(6).
      03 VL-TYPE PIC 9.
      03 VL-ID PIC X(12).
      03 VL-PROC REDEFINES VL-ID PIC 999.
      03 VL-PART REDEFINES VL-ID PIC X(12).
      03 VL-DATE PIC 9(6).
      03 VL-SHIFT PIC 9.
      03 VL-EMP PIC 9(4).

FD  MNTMAC.
01  MK-RECORD PIC X(115).
01  MK-REC.
    02 MK-KEY.
      03 MK-NO PIC 999.

FD  VENDOR.
01  V-RECORD PIC X(480).
01  V-REC.
    02 V-KEY.
      03 V-DIV PIC 99.
      03 V-NO PIC 9(4).
    02 V-KN.
      03 V-NAME PIC X(36).

FD  APTR BLOCK 2048.
01  AT-RECORD PIC X(650).
01  AT-REC.
    02 AT-KEY.
      03 AT-DIV PIC 99.
      03 AT-VEN PIC 9(4).
      03 AT-TYPE PIC 9.
      03 AT-INV PIC X(15).
    02 AT-KD.
      03 AT-KDIV PIC 99.
      03 AT-KVEN PIC 9(4).
      03 AT-ZDATE PIC 9(6).
      03 AT-KTYPE PIC 9.
      03 AT-KINV PIC X(15).

FD  INAPTR BLOCK 2048.
01  INAT-RECORD PIC X(650).
01  INAT-REC.
    02 INAT-KEY.
      03 INAT-DIV PIC 99.
      03 INAT-VEN PIC 9(4).
      03 INAT-TYPE PIC 9.
      03 INAT-INV PIC X(15).
    02 INAT-KD.
      03 INAT-KDIV PIC 99.
      03 INAT-KVEN PIC 9(4).
      03 INAT-ZDATE PIC 9(6).
      03 INAT-KTYPE PIC 9.
      03 INAT-KINV PIC X(15).

FD  APCHQ.
01  AH-RECORD PIC X(50).
01  AH-REC.
    02 AH-KEY.
      03 AH-DIV PIC 99.
      03 AH-US PIC 9.
      03 AH-NO PIC 9(6).

FD  GLDIST.
01  G-RECORD PIC X(115).
01  G-REC.
    02 G-KEY.
      03 G-DIV PIC 99.
      03 G-GL PIC 9(18).

FD  GLTR.
01  GT-RECORD PIC X(75).
01  GT-REC.
    02 GT-KEY.
      03 GT-DIV PIC 99.
      03 GT-VEN PIC 9(4).
      03 GT-INV PIC X(15).
      03 GT-TYPE PIC 9.
      03 GT-SYS PIC 9.
      03 GT-GL PIC 9(18).

FD  PURHIST BLOCK 2048.
01  PU-RECORD PIC X(130).
01  PU-REC.
    02 PU-KEY.
      03 PU-DIV PIC 99.
      03 PU-PART PIC X(12).
      03 PU-ZDATE PIC 9(6).
      03 PU-ZTIME PIC 9(8).
    02 PU-KV.
      03 PU-VDIV PIC 99.
      03 PU-VENDOR PIC 9(4).
      03 PU-ZVDATE PIC 9(6).
      03 PU-ZVTIME PIC 9(8).

FD  EMPL VALUE OF ID EMPL-ID BLOCK 2560.
01  E-RECORD PIC X(1250).
01  E-REC.
    02 E-KEY.
      03 E-DIV PIC 99.
      03 E-NO PIC 9(4).

FD  LDTBL VALUE OF ID LDTBL-ID.
01  GP-RECORD PIC X(50).
01  GP-REC.
    02 GP-KEY.
      03 GP-DIV PIC 99.
      03 GP-CODE PIC 999.

FD  LDTR VALUE OF ID LDTR-ID.
01  LY-RECORD PIC X(50).
01  LY-REC.
    02 LY-KEY.
      03 LY-DIV PIC 99.
      03 LY-CODE PIC 999.
      03 LY-DEPT PIC 99.
      03 LY-SECT PIC 99.
      03 LY-YY PIC 99.
      03 LY-MM PIC 99.
      03 LY-PER PIC 99.
      03 LY-SEQ PIC 9.
      03 LY-CONTRA PIC 9(7).

FD  GLAP VALUE OF ID GLAP-ID.
01  GLK-RECORD PIC X(253).

FD  IFGFL VALUE OF ID IFG-ID.
01  HC-RECORD PIC X(103).

FD  BNCHQ VALUE OF ID BNCHQ-ID.
01  CZ-RECORD PIC X(700).

FD  BNCLR VALUE OF ID BNCLR-ID.
01  BZ-RECORD PIC X(80).

WORKING-STORAGE SECTION.
01  ERR-LINE. 02 PIC X(6) VALUE "***** ". 02 ERR-MESG PIC X(73).
01  CKEY.
    02 CK1 PIC X.
      88 KP-TAB VALUE X"09". 88 KP-RETURN VALUE X"0D".
    02 CK2 PIC X(4).
      88 KPF1 VALUE "P". 88 KPF2 VALUE "Q". 88 KPF3 VALUE "R". 88 KPF4 VALUE "S".
      88 KP-UP VALUE "A". 88 KP-DOWN VALUE "B". 88 KP-RIGHT VALUE "C". 88 KP-LEFT VALUE "D".
      88 KP-SELECT VALUE "4~". 88 KP-PREV VALUE "5~". 88 KP-NEXT VALUE "6~".
01  DECLARATIVES-FIELDS.
    02 DSTAT PIC XX. 02 DCL-ERRNO PIC 9(4) COMP-3.
    02 DCL-LINE. 03 DCL-F1 PIC X(7). 03 DCL-F2 PIC X(11). 03 DCL-F3 PIC XX.
      03 DCL-F4 PIC BBBX(30). 03 DCL-F5 PIC Z(4)9.

01  KEY-FIELDS.
    02 IF-KEY PIC 99. 02 EI-KEY PIC 99. 02 SV-KEY PIC 999.
01  PRINTFL-FIELDS.
    02 PR-ID. 03 PR-NAME PIC XX. 03 PR-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
01  DOCFL-FIELDS.
    02 DOC-ID. 03 DOC-NAME PIC XX. 03 DOC-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 DOC-SZ PIC 999 COMP-3.
01  LABFL-FIELDS.
    02 LAB-ID. 03 LAB-NAME PIC XXX. 03 LAB-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 LAB-SZ PIC 999 COMP-3.
01  DATFL-FIELDS.
    02 DAT-ID PIC X(8). 02 DAT-SZ PIC 999 COMP-3.
01  EXPFL-FIELDS.
    02 EXP-ID. 03 PIC XX VALUE "FL". 03 EXP-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 EXP-SZ PIC 9(4) COMP-3.
01  LASFL-FIELDS.
    02 LAS-ID. 03 PIC XXX VALUE "LAS". 03 LAS-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".

01  FID-FIELDS.
    02 MFA-ID. 03 PIC X(6) VALUE "MAINTA". 03 MFA-NUM PIC 99. 03 MFA-TIM PIC 9(8).
    02 MFB-ID. 03 PIC X(6) VALUE "MAINTB". 03 MFB-NUM PIC 99. 03 MFB-TIM PIC 9(8).
    02 MFC-ID. 03 PIC X(6) VALUE "MAINTC". 03 MFC-NUM PIC 99. 03 MFC-TIM PIC 9(8).
    02 REP-ID. 03 PIC X(5) VALUE "REPFL". 03 REP-NUM PIC 99. 03 REP-TIM PIC 9(8).
    02 SORT-ID. 03 PIC X(6) VALUE "SORTFL". 03 SORT-NUM PIC 99. 03 SORT-TIM PIC 9(8).
    02 SORC-ID. 03 PIC X(6) VALUE "SORCFL". 03 SORC-NUM PIC 99. 03 SORC-TIM PIC 9(8).
    02 EMPL-ID. 03 PIC X(9) VALUE "DUA1:[PAY". 03 EMPL-DIV PIC 99. 03 PIC X(9) VALUE "]EMPLOYEE".
    02 LDTBL-ID. 03 PIC X(9) VALUE "DUA1:[PAY". 03 LDTBL-DIV PIC 99. 03 PIC X(6) VALUE "]LDTBL".
    02 LDTR-ID. 03 PIC X(9) VALUE "DUA1:[PAY". 03 LDTR-DIV PIC 99. 03 PIC X(5) VALUE "]LDTR".
    02 GLAP-ID. 03 GLAP-NAME PIC X(4). 03 GLAP-NUM PIC 99. 03 GLAP-BATCH PIC 99.
    02 BNCHQ-ID. 03 PIC X(13) VALUE "DUA1:[IFMAIN]". 03 BNCHQ-NAME PIC X(7).
    02 BNCLR-ID. 03 PIC X(13) VALUE "DUA1:[IFMAIN]". 03 BNCLR-NAME PIC X(7).
    02 IFG-ID PIC XXX. 02 PIN-ID PIC X(10). 02 SIX-ID PIC X(10).

01  INDEX-FIELDS.
    02 IX1 PIC S9(7) COMP-3. 02 IX2 PIC S9(7) COMP-3.
01  SIXEL-FIELDS.
    02 SIX-SZ PIC 9(4) COMP-3.
01  EDI-FIELDS.
    02 EDI-ID PIC X(8). 02 EDI-SZ PIC 999 COMP-3.

PROCEDURE DIVISION.
DECLARATIVES.
SEC-001 SECTION 0.
    USE AFTER ERROR PROCEDURE INPUT.
USE-1. MOVE "INPUT" TO DCL-F1 PERFORM USE-DIS.
SEC-002 SECTION 0.
    USE AFTER ERROR PROCEDURE OUTPUT.
USE-2. MOVE "OUTPUT" TO DCL-F1 PERFORM USE-DIS.
SEC-003 SECTION 0.
    USE AFTER ERROR PROCEDURE I-O.
USE-3. IF NOT(DSTAT="02" OR "90" OR "92") MOVE "I-O" TO DCL-F1 PERFORM USE-DIS.
SEC-004 SECTION 0.
    USE AFTER ERROR PROCEDURE EXTEND.
USE-4. MOVE "EXTEND" TO DCL-F1 PERFORM USE-DIS.
USE-DIS. ADD 1 TO DCL-ERRNO MOVE "DISK ERROR" TO DCL-F2 MOVE DSTAT TO DCL-F3.
    MOVE RMS-CURRENT-FILENAME TO DCL-F4 MOVE DCL-ERRNO TO DCL-F5.
    DISPLAY DCL-LINE LINE 24 REVERSED ERASE LINE.
END DECLARATIVES.

SEC-0 SECTION 0.
MN0. MOVE 0 TO DCL-ERRNO GO MN1.

MN1.
    OPEN OUTPUT INFOFL EDINFO LABELS TABLES SHIPVIA PACKING SALHIST SALSUM
      TRANS CUSTOMER PRODUCT ALTERNATES NUTBOLT OPERATIONS PRICE BIN PART
      PURBIN TOOLS TOOLPROD HEAT LOT SHIPTO SAORD SALIN PURORD PURLIN PARTRANS
      PRODTRANS PLANT MATREL DAYREL MACHINE MACTYPE PRODORD WORKSHEET BUCKET
      MILL VENDOR APTR APCHQ GLDIST GLTR PURHIST COSTHIST.
    CLOSE INFOFL EDINFO LABELS TABLES SHIPVIA PACKING SALHIST SALSUM
      TRANS CUSTOMER PRODUCT ALTERNATES NUTBOLT OPERATIONS PRICE BIN PART
      PURBIN TOOLS TOOLPROD HEAT LOT SHIPTO SAORD SALIN PURORD PURLIN PARTRANS
      PRODTRANS PLANT MATREL DAYREL MACHINE MACTYPE PRODORD WORKSHEET BUCKET
      MILL VENDOR APTR APCHQ GLDIST GLTR PURHIST COSTHIST.

    OPEN OUTPUT USERS GLTOOLCOST TRAUDIT AUDIT SALTOT LOTHIST STATEMENT
      SALESMAN CUSCONT QUOTORD QUOTLIN PRICEHIST SUBCON SUBINV QBIN ARCTOOLS
      HTRANS BILLTO SOLDTO SHIPORD SHIPLIN BINALLOC TMPORD TMPLIN ACKORD ACKLIN
      CFORD CFLIN TMPURORD TMPURLIN DELJITEX MACSCHED PHYSINV MNTMAST MNTORD
      MNTLIN MNTMAC DRAWINGS PDRAWINGS.
    CLOSE USERS GLTOOLCOST TRAUDIT AUDIT SALTOT LOTHIST STATEMENT
      SALESMAN CUSCONT QUOTORD QUOTLIN PRICEHIST SUBCON SUBINV QBIN ARCTOOLS
      HTRANS BILLTO SOLDTO SHIPORD SHIPLIN BINALLOC TMPORD TMPLIN ACKORD ACKLIN
      CFORD CFLIN TMPURORD TMPURLIN DELJITEX MACSCHED PHYSINV MNTMAST MNTORD
      MNTLIN MNTMAC DRAWINGS PDRAWINGS.

    MOVE 30 TO EMPL-DIV LDTBL-DIV LDTR-DIV.
    OPEN OUTPUT EMPL LDTBL LDTR.
    CLOSE EMPL LDTBL LDTR.

    OPEN I-O INFOFL MOVE LOW-VALUES TO IF-RECORD INITIALIZE IF-REC.
    MOVE 1 TO IF-KEY WRITE IF-RECORD CLOSE INFOFL.

    OPEN I-O EDINFO MOVE LOW-VALUES TO EI-RECORD INITIALIZE EI-REC.
    MOVE 1 TO EI-KEY WRITE EI-RECORD CLOSE EDINFO.

    OPEN I-O USERS MOVE LOW-VALUES TO US-RECORD INITIALIZE US-REC.
    MOVE "USER1" TO US-USER MOVE 1 TO US-NUM.
    MOVE 1 TO US-PC MOVE "PR" TO US-PRNM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>24 MOVE ALL "1" TO US-TDX(IX1) END-PERFORM.
    WRITE US-RECORD CLOSE USERS.

    STOP RUN.
END-OF-PROGRAM.

