IDENTIFICATION DIVISION.
PROGRAM-ID. IFMAINT.
AUTHOR. ANDREI SORIN.
INSTALLATION. IRVINE FASTENERS.
DATE-WRITTEN. 1990-2014.
* Year-end maintenance for IFOP data files
* (C) Copyright 1990-2014 Andrei Sorin <a.sorin@andsor.ca>
* IFOP documentation files: NOTES.TXT, INFO.TXT, DATABASE.TXT, MENUS.TXT

* This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
OBJECT-COMPUTER. VAX-VMS.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
    SELECT PRINTFL ASSIGN PRINTER.
    SELECT MAINTFL ASSIGN PRINTER.

    SELECT OTRAUDIT ASSIGN "DUA2:[MAINT]TRAUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OYT-KEY.
    SELECT TRAUDIT ASSIGN "TRAUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YT-KEY.

    SELECT OAUDIT ASSIGN "DUA2:[MAINT]AUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OAU-KEY.
    SELECT AUDIT ASSIGN "AUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AU-KEY.

    SELECT OCOSTHIST ASSIGN "DUA2:[MAINT]COSTHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OCU-KEY.
    SELECT COSTHIST ASSIGN "COSTHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY CU-KEY.

    SELECT OOPERATIONS ASSIGN "DUA2:[MAINT]OPERATIONS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OOP-KEY.
    SELECT OPERATIONS ASSIGN "OPERATIONS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OP-KEY.

    SELECT OLABELS ASSIGN "DUA2:[MAINT]LABELS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OLA-KEY
      ALTERNATE RECORD KEY OLA-KL DUPLICATES.
    SELECT LABELS ASSIGN "LABELS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LA-KEY
      ALTERNATE RECORD KEY LA-KL DUPLICATES.

    SELECT OSALTOT ASSIGN "DUA2:[MAINT]SALTOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OST-KEY.
    SELECT SALTOT ASSIGN "SALTOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ST-KEY.

    SELECT OSUBCON ASSIGN "DUA2:[MAINT]SUBCON" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OSJ-KEY.
    SELECT SUBCON ASSIGN "SUBCON" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SJ-KEY.

    SELECT OSUBINV ASSIGN "DUA2:[MAINT]SUBINV" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OSL-KEY
      ALTERNATE RECORD KEY OSL-KS DUPLICATES.
    SELECT SUBINV ASSIGN "SUBINV" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SL-KEY
      ALTERNATE RECORD KEY SL-KS DUPLICATES.

    SELECT OPRODUCT ASSIGN "DUA2:[MAINT]PRODUCT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OPP-KEY.
    SELECT PRODUCT ASSIGN "PRODUCT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY P-KEY.

    SELECT OCUSTOMER ASSIGN "DUA2:[MAINT]CUSTOMER" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OC-KEY
      ALTERNATE RECORD KEY OC-KN DUPLICATES.
    SELECT CUSTOMER ASSIGN "CUSTOMER" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY C-KEY
      ALTERNATE RECORD KEY C-KN DUPLICATES.

    SELECT OSHIPTO ASSIGN "DUA2:[MAINT]SHIPTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OSA-KEY.
    SELECT SHIPTO ASSIGN "SHIPTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SA-KEY.

    SELECT OTRANS ASSIGN "DUA2:[MAINT]TRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OTR-KEY
      ALTERNATE RECORD KEY OTR-KI
      ALTERNATE RECORD KEY OTR-KB DUPLICATES.
    SELECT TRANS ASSIGN "TRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TR-KEY
      ALTERNATE RECORD KEY TR-KI
      ALTERNATE RECORD KEY TR-KB DUPLICATES.

    SELECT OBIN ASSIGN "DUA2:[MAINT]BIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OB-KEY
      ALTERNATE RECORD KEY OB-KP DUPLICATES.
    SELECT BIN ASSIGN "BIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY B-KEY
      ALTERNATE RECORD KEY B-KP DUPLICATES.

    SELECT OPURBIN ASSIGN "DUA2:[MAINT]PURBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OBH-KEY
      ALTERNATE RECORD KEY OBH-KP.
    SELECT PURBIN ASSIGN "PURBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BH-KEY
      ALTERNATE RECORD KEY BH-KP.

    SELECT OMILL ASSIGN "DUA2:[MAINT]MILL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OML-KEY
      ALTERNATE RECORD KEY OML-KD DUPLICATES.
    SELECT MILL ASSIGN "MILL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ML-KEY
      ALTERNATE RECORD KEY ML-KD DUPLICATES.

    SELECT OSAORD ASSIGN "DUA2:[MAINT]SAORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OO-KEY
      ALTERNATE RECORD KEY OO-KC DUPLICATES.
    SELECT SAORD ASSIGN "SAORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY O-KEY
      ALTERNATE RECORD KEY O-KC DUPLICATES.

    SELECT OSALIN ASSIGN "DUA2:[MAINT]SALIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OL-KEY
      ALTERNATE RECORD KEY OL-KP DUPLICATES.
    SELECT SALIN ASSIGN "SALIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY L-KEY
      ALTERNATE RECORD KEY L-KP DUPLICATES.

    SELECT OLOT ASSIGN "DUA2:[MAINT]LOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OLT-KEY
      ALTERNATE RECORD KEY OLT-KP.
    SELECT LOT ASSIGN "LOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LT-KEY
      ALTERNATE RECORD KEY LT-KP.

    SELECT OVENDOR ASSIGN "DUA2:[MAINT]VENDOR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OV-KEY
      ALTERNATE RECORD KEY OV-KN DUPLICATES.
    SELECT VENDOR ASSIGN "VENDOR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY V-KEY
      ALTERNATE RECORD KEY V-KN DUPLICATES.

    SELECT OPART ASSIGN "DUA2:[MAINT]PART" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OPH-KEY
      ALTERNATE RECORD KEY OPH-KD DUPLICATES
      ALTERNATE RECORD KEY OPH-KA
      ALTERNATE RECORD KEY OPH-KV.
    SELECT PART ASSIGN "PART" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PH-KEY
      ALTERNATE RECORD KEY PH-KD DUPLICATES
      ALTERNATE RECORD KEY PH-KA
      ALTERNATE RECORD KEY PH-KV.

    SELECT OAPTR ASSIGN "DUA2:[MAINT]APTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OAT-KEY
      ALTERNATE RECORD KEY OAT-KD.
    SELECT APTR ASSIGN "APTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AT-KEY
      ALTERNATE RECORD KEY AT-KD.

    SELECT OAPCHQ ASSIGN "DUA2:[MAINT]APCHQ" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OAH-KEY.
    SELECT APCHQ ASSIGN "APCHQ" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AH-KEY.

    SELECT OHEAT ASSIGN "DUA2:[MAINT]HEAT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OHE-KEY.
    SELECT HEAT ASSIGN "HEAT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HE-KEY.

    SELECT OPURORD ASSIGN "DUA2:[MAINT]PURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OOK-KEY
      ALTERNATE RECORD KEY OOK-KV.
    SELECT PURORD ASSIGN "PURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OK-KEY
      ALTERNATE RECORD KEY OK-KV.

    SELECT OPURLIN ASSIGN "DUA2:[MAINT]PURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OLK-KEY
      ALTERNATE RECORD KEY OLK-KP DUPLICATES.
    SELECT PURLIN ASSIGN "PURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LK-KEY
      ALTERNATE RECORD KEY LK-KP DUPLICATES.

    SELECT OMNTORD ASSIGN "DUA2:[MAINT]MNTORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OVO-KEY
      ALTERNATE RECORD KEY OVO-KN.
    SELECT MNTORD ASSIGN "MNTORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY VO-KEY
      ALTERNATE RECORD KEY VO-KN.

    SELECT OMNTLIN ASSIGN "DUA2:[MAINT]MNTLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OVL-KEY.
    SELECT MNTLIN ASSIGN "MNTLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY VL-KEY.

    SELECT OPARTRANS ASSIGN "DUA2:[MAINT]PARTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OPT-KEY.
    SELECT PARTRANS ASSIGN "PARTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PT-KEY.

    SELECT OPRODTRANS ASSIGN "DUA2:[MAINT]PRODTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OPE-KEY.
    SELECT PRODTRANS ASSIGN "PRODTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PE-KEY.

    SELECT OTOOLPROD ASSIGN "DUA2:[MAINT]TOOLPROD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OTP-KEY.
    SELECT TOOLPROD ASSIGN "TOOLPROD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TP-KEY.

    SELECT OTMPURORD ASSIGN "DUA2:[MAINT]TMPURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OYOK-KEY.
    SELECT TMPURORD ASSIGN "TMPURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YOK-KEY.

    SELECT OTMPURLIN ASSIGN "DUA2:[MAINT]TMPURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OYLK-KEY.
    SELECT TMPURLIN ASSIGN "TMPURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YLK-KEY.

    SELECT OSTATEMENT ASSIGN "DUA2:[MAINT]STATEMENT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OSW-KEY.
    SELECT STATEMENT ASSIGN "STATEMENT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SW-KEY.

    SELECT OGLTR ASSIGN "DUA2:[MAINT]GLTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OGT-KEY.
    SELECT GLTR ASSIGN "GLTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GT-KEY.

    SELECT OPURHIST ASSIGN "DUA2:[MAINT]PURHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OPU-KEY
      ALTERNATE RECORD KEY OPU-KV.
    SELECT PURHIST ASSIGN "PURHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PU-KEY
      ALTERNATE RECORD KEY PU-KV.

    SELECT OSALHIST ASSIGN "DUA2:[MAINT]SALHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OSH-KEY
      ALTERNATE RECORD KEY OSH-KP.
    SELECT SALHIST ASSIGN "SALHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SH-KEY
      ALTERNATE RECORD KEY SH-KP.

    SELECT OACKORD ASSIGN "DUA2:[MAINT]ACKORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OAKO-KEY.
    SELECT ACKORD ASSIGN "ACKORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AKO-KEY.

    SELECT OACKLIN ASSIGN "DUA2:[MAINT]ACKLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OAKL-KEY.
    SELECT ACKLIN ASSIGN "ACKLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AKL-KEY.

    SELECT OPRODORD ASSIGN "DUA2:[MAINT]PRODORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OR-KEY
      ALTERNATE RECORD KEY OR-KP DUPLICATES.
    SELECT PRODORD ASSIGN "PRODORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY R-KEY
      ALTERNATE RECORD KEY R-KP DUPLICATES.

    SELECT OWORKSHEET ASSIGN "DUA2:[MAINT]WORKSHEET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OJ-KEY
      ALTERNATE RECORD KEY OJ-KM DUPLICATES
      ALTERNATE RECORD KEY OJ-KN DUPLICATES
      ALTERNATE RECORD KEY OJ-KD DUPLICATES.
    SELECT WORKSHEET ASSIGN "WORKSHEET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY J-KEY
      ALTERNATE RECORD KEY J-KM DUPLICATES
      ALTERNATE RECORD KEY J-KN DUPLICATES
      ALTERNATE RECORD KEY J-KD DUPLICATES.

    SELECT OBUCKET ASSIGN "DUA2:[MAINT]BUCKET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OBU-KEY
      ALTERNATE RECORD KEY OBU-KN DUPLICATES.
    SELECT BUCKET ASSIGN "BUCKET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BU-KEY
      ALTERNATE RECORD KEY BU-KN DUPLICATES.

    SELECT OMATREL ASSIGN "DUA2:[MAINT]MATREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OMT-KEY
      ALTERNATE RECORD KEY OMT-KP DUPLICATES.
    SELECT MATREL ASSIGN "MATREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MT-KEY
      ALTERNATE RECORD KEY MT-KP DUPLICATES.

    SELECT ODAYREL ASSIGN "DUA2:[MAINT]DAYREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ODY-KEY
      ALTERNATE RECORD KEY ODY-KP DUPLICATES.
    SELECT DAYREL ASSIGN "DAYREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DY-KEY
      ALTERNATE RECORD KEY DY-KP DUPLICATES.

    SELECT OTOOLS ASSIGN "DUA2:[MAINT]TOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OTS-KEY.
    SELECT TOOLS ASSIGN "TOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TS-KEY.

    SELECT OSALSUM ASSIGN "DUA2:[MAINT]SALSUM" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OSM-KEY
      ALTERNATE RECORD KEY OSM-KP.
    SELECT SALSUM ASSIGN "SALSUM" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SM-KEY
      ALTERNATE RECORD KEY SM-KP.

    SELECT OQBIN ASSIGN "DUA2:[MAINT]QBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OQB-KEY
      ALTERNATE RECORD KEY OQB-KP DUPLICATES.
    SELECT QBIN ASSIGN "QBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QB-KEY
      ALTERNATE RECORD KEY QB-KP DUPLICATES.

    SELECT OALTERNATES ASSIGN "DUA2:[MAINT]ALTERNATES" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OAL-KEY.
    SELECT ALTERNATES ASSIGN "ALTERNATES" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AL-KEY.

    SELECT ODELJITEX ASSIGN "DUA2:[MAINT]DELJITEX" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ODX-KEY.
    SELECT DELJITEX ASSIGN "DELJITEX" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DX-KEY.

I-O-CONTROL.
    APPLY PRINT-CONTROL ON PRINTFL MAINTFL.

DATA DIVISION.
FILE SECTION.
FD  PRINTFL VALUE OF ID "MAINT_ERR.PRN".
01  PREC PIC X(132).
FD  MAINTFL VALUE OF ID "MAINT_LOG.PRN".
01  MREC PIC X(132).
01  MREC1.
    02 MA11 PIC X(12). 02 MA12 PIC 99/99/99.
01  MREC2.
    02 MA13 PIC X(15). 02 MA14 PIC Z(6)9. 02 PIC X(5). 02 MA15 PIC 9(8).

FD  OTRAUDIT.
01  OYT-RECORD PIC X(75).
01  OYT-REC.
    02 OYT-KEY.
      03 OYT-CUS PIC X(6).
      03 OYT-INV PIC 9(6).
      03 OYT-DATE PIC 9(6).
      03 OYT-TIME PIC 9(8).
FD  TRAUDIT.
01  YT-RECORD PIC X(75).
01  YT-REC.
    02 YT-KEY.
      03 YT-CUS PIC X(6).
      03 YT-INV PIC 9(6).
      03 YT-DATE PIC 9(6).
      03 YT-TIME PIC 9(8).

FD  OAUDIT BLOCK 2048.
01  OAU-RECORD PIC X(650).
01  OAU-REC.
    02 OAU-KEY.
      03 OAU-K PIC 99.
      03 OAU-L PIC 99.
      03 OAU-DATE PIC 9(6).
      03 OAU-TIME PIC 9(8).
FD  AUDIT BLOCK 2048.
01  AU-RECORD PIC X(650).
01  AU-REC.
    02 AU-KEY.
      03 AU-K PIC 99.
      03 AU-L PIC 99.
      03 AU-DATE PIC 9(6).
      03 AU-TIME PIC 9(8).

FD  OCOSTHIST BLOCK 2048.
01  OCU-RECORD PIC X(390).
01  OCU-REC.
    02 OCU-KEY.
      03 OCU-PROD PIC X(12).
FD  COSTHIST BLOCK 2048.
01  CU-RECORD PIC X(390).
01  CU-REC.
    02 CU-KEY.
      03 CU-PROD PIC X(12).

FD  OOPERATIONS.
01  OOP-RECORD PIC X(115).
01  OOP-REC.
    02 OOP-KEY.
      03 OOP-PROD PIC X(12).
      03 OOP-MAC PIC 99.
FD  OPERATIONS.
01  OP-RECORD PIC X(115).
01  OP-REC.
    02 OP-KEY.
      03 OP-PROD PIC X(12).
      03 OP-MAC PIC 99.

FD  OLABELS.
01  OLA-RECORD PIC X(240).
01  OLA-REC.
    02 OLA-KEY.
      03 OLA-NO PIC 9(8).
    02 OLA-KL.
      03 OLA-ZLYEAR PIC 9(4).
      03 OLA-ZLOT PIC 9(7).
      03 OLA-ZDATE PIC 9(6).
      03 OLA-ZTIME PIC 9(8).
FD  LABELS.
01  LA-RECORD PIC X(240).
01  LA-REC.
    02 LA-KEY.
      03 LA-NO PIC 9(8).
    02 LA-KL.
      03 LA-ZLYEAR PIC 9(4).
      03 LA-ZLOT PIC 9(7).
      03 LA-ZDATE PIC 9(6).
      03 LA-ZTIME PIC 9(8).

FD  OSALTOT.
01  OST-RECORD PIC X(60).
01  OST-REC.
    02 OST-KEY.
      03 OST-TER PIC 99.
      03 OST-CAT PIC 99.
      03 OST-YY PIC 99.
      03 OST-MM PIC 99.
      03 OST-DD PIC 99.
      03 OST-US PIC 9.
FD  SALTOT.
01  ST-RECORD PIC X(60).
01  ST-REC.
    02 ST-KEY.
      03 ST-TER PIC 99.
      03 ST-CAT PIC 99.
      03 ST-YY PIC 99.
      03 ST-MM PIC 99.
      03 ST-DD PIC 99.
      03 ST-US PIC 9.

FD  OSUBCON BLOCK 1024.
01  OSJ-RECORD PIC X(320).
01  OSJ-REC.
    02 OSJ-KEY.
      03 OSJ-MAC PIC 9(4).
      03 OSJ-MO PIC 9(6).
      03 OSJ-SUFFIX PIC X.
      03 OSJ-LOT PIC 9(7).
      03 OSJ-PROD PIC X(12).
FD  SUBCON BLOCK 1024.
01  SJ-RECORD PIC X(320).
01  SJ-REC.
    02 SJ-KEY.
      03 SJ-MAC PIC 9(4).
      03 SJ-MO PIC 9(6).
      03 SJ-SUFFIX PIC X.
      03 SJ-LOT PIC 9(7).
      03 SJ-PROD PIC X(12).

FD  OSUBINV.
01  OSL-RECORD PIC X(115).
01  OSL-REC.
    02 OSL-KEY.
      03 OSL-MAC PIC 9(4).
      03 OSL-MO PIC 9(6).
      03 OSL-SUFFIX PIC X.
      03 OSL-LOT PIC 9(7).
      03 OSL-PROD PIC X(12).
      03 OSL-KSLIP PIC X(10).
      03 OSL-SEQ PIC 99.
    02 OSL-KS.
      03 OSL-SLIP PIC X(10).
      03 OSL-ORD PIC X(8).
FD  SUBINV.
01  SL-RECORD PIC X(115).
01  SL-REC.
    02 SL-KEY.
      03 SL-MAC PIC 9(4).
      03 SL-MO PIC 9(6).
      03 SL-SUFFIX PIC X.
      03 SL-LOT PIC 9(7).
      03 SL-PROD PIC X(12).
      03 SL-KSLIP PIC X(10).
      03 SL-SEQ PIC 99.
    02 SL-KS.
      03 SL-SLIP PIC X(10).
      03 SL-ORD PIC X(8).

* use OPP- since OP- is OPERATIONS
FD  OPRODUCT BLOCK 3584.
01  OPP-RECORD PIC X(1150).
01  OPP-REC.
    02 OPP-KEY.
      03 OPP-NO PIC X(12).
FD  PRODUCT BLOCK 3584.
01  P-RECORD PIC X(1150).
01  P-REC.
    02 P-KEY.
      03 P-NO PIC X(12).

FD  OCUSTOMER BLOCK 2048.
01  OC-RECORD PIC X(390).
01  OC-REC.
    02 OC-KEY.
      03 OC-NO PIC X(6).
    02 OC-TER PIC 99 COMP-3.
    02 OC-PROV PIC 99 COMP-3.
    02 OC-SAL PIC 99 COMP-3.
    02 OC-KN.
      03 OC-NAME PIC X(32).
FD  CUSTOMER BLOCK 2048.
01  C-RECORD PIC X(390).
01  C-REC.
    02 C-KEY.
      03 C-NO PIC X(6).
    02 C-TER PIC 99 COMP-3.
    02 C-PROV PIC 99 COMP-3.
    02 C-SAL PIC 99 COMP-3.
    02 C-KN.
      03 C-NAME PIC X(32).

FD  OSHIPTO.
01  OSA-RECORD PIC X(150).
01  OSA-REC.
    02 OSA-KEY.
      03 OSA-CUS PIC X(6).
      03 OSA-TO PIC 99.
    02 OSA-NO REDEFINES OSA-KEY PIC X(8).
FD  SHIPTO.
01  SA-RECORD PIC X(150).
01  SA-REC.
    02 SA-KEY.
      03 SA-CUS PIC X(6).
      03 SA-TO PIC 99.
    02 SA-NO REDEFINES SA-KEY PIC X(8).

FD  OTRANS.
01  OTR-RECORD PIC X(75).
01  OTR-REC.
    02 OTR-KEY.
      03 OTR-CUS PIC X(6).
      03 OTR-KI.
        04 OTR-INV PIC 9(6).
    02 OTR-KB.
      03 OTR-BL PIC 9(7).
      03 OTR-BINV PIC 9(6).
FD  TRANS.
01  TR-RECORD PIC X(75).
01  TR-REC.
    02 TR-KEY.
      03 TR-CUS PIC X(6).
      03 TR-KI.
        04 TR-INV PIC 9(6).
    02 TR-KB.
      03 TR-BL PIC 9(7).
      03 TR-BINV PIC 9(6).
    02 TR-ORD PIC 9(6) COMP-3.
    02 TR-DATE PIC 9(6) COMP-3.
    02 TR-AMT PIC S9(7)V99 COMP-3.

FD  OBIN BLOCK 2048.
01  OB-RECORD PIC X(60).
01  OB-REC.
    02 OB-KEY.
      03 OB-NO PIC X(5).
    02 OB-KP.
      03 OB-PROD PIC X(12).
      03 OB-LYEAR PIC 9(4).
      03 OB-LOT PIC 9(7).
      03 OB-DATE PIC 9(6).
FD  BIN BLOCK 2048.
01  B-RECORD PIC X(60).
01  B-REC.
    02 B-KEY.
      03 B-NO PIC X(5).
    02 B-KP.
      03 B-PROD PIC X(12).
      03 B-LYEAR PIC 9(4).
      03 B-LOT PIC 9(7).
      03 B-DATE PIC 9(6).

FD  OPURBIN BLOCK 2048.
01  OBH-RECORD PIC X(115).
01  OBH-REC.
    02 OBH-KEY.
      03 OBH-NO PIC X(8).
    02 OBH-KP.
      03 OBH-PART PIC X(12).
      03 OBH-DATE PIC 9(6).
      03 OBH-KNO PIC X(8).
FD  PURBIN BLOCK 2048.
01  BH-RECORD PIC X(115).
01  BH-REC.
    02 BH-KEY.
      03 BH-NO PIC X(8).
    02 BH-KP.
      03 BH-PART PIC X(12).
      03 BH-DATE PIC 9(6).
      03 BH-KNO PIC X(8).

FD  OMILL.
01  OML-RECORD PIC X(240).
01  OML-REC.
    02 OML-KEY.
      03 OML-CYCLE PIC X(4).
      03 OML-DIAM PIC X(6).
    02 OML-KD.
      03 OML-KDIAM PIC X(6).
      03 OML-ZDATE PIC 9(6) COMP-3.
FD  MILL.
01  ML-RECORD PIC X(240).
01  ML-REC.
    02 ML-KEY.
      03 ML-CYCLE PIC X(4).
      03 ML-DIAM PIC X(6).
    02 ML-KD.
      03 ML-KDIAM PIC X(6).
      03 ML-ZDATE PIC 9(6) COMP-3.

FD  OSAORD.
01  OO-RECORD PIC X(480).
01  OO-REC.
    02 OO-KEY.
      03 OO-NO PIC 9(6).
    02 OO-KC.
      03 OO-CUS PIC X(6).
      03 OO-DATE PIC 9(6).
FD  SAORD.
01  O-RECORD PIC X(480).
01  O-REC.
    02 O-KEY.
      03 O-NO PIC 9(6).
    02 O-KC.
      03 O-CUS PIC X(6).
      03 O-DATE PIC 9(6).

FD  OSALIN.
01  OL-RECORD PIC X(150).
01  OL-REC.
    02 OL-KEY.
      03 OL-ORD PIC 9(6).
      03 OL-LINE PIC 99.
    02 OL-NO REDEFINES OL-KEY PIC 9(8).
    02 OL-TER PIC 99 COMP-3.
    02 OL-CUS PIC X(6).
    02 OL-KP.
      03 OL-PROD PIC X(12).
      03 OL-DATE-REQ PIC 9(6).
FD  SALIN.
01  L-RECORD PIC X(150).
01  L-REC.
    02 L-KEY.
      03 L-ORD PIC 9(6).
      03 L-LINE PIC 99.
    02 L-NO REDEFINES L-KEY PIC 9(8).
    02 L-TER PIC 99 COMP-3.
    02 L-CUS PIC X(6).
    02 L-KP.
      03 L-PROD PIC X(12).
      03 L-DATE-REQ PIC 9(6).

FD  OLOT BLOCK 2048.
01  OLT-RECORD PIC X(500).
01  OLT-REC.
    02 OLT-KEY.
      03 OLT-NO PIC 9(7).
      03 REDEFINES OLT-NO. 04 OLT-Y PIC 9. 04 PIC 9(6).
    02 OLT-KP.
      03 OLT-PROD PIC X(12).
      03 OLT-LYEAR PIC 9(4).
      03 OLT-LOT PIC 9(7).
FD  LOT BLOCK 2048.
01  LT-RECORD PIC X(500).
01  LT-REC.
    02 LT-KEY.
      03 LT-NO PIC 9(7).
      03 REDEFINES LT-NO. 04 LT-Y PIC 9. 04 PIC 9(6).
    02 LT-KP.
      03 LT-PROD PIC X(12).
      03 LT-LYEAR PIC 9(4).
      03 LT-LOT PIC 9(7).

FD  OVENDOR.
01  OV-RECORD PIC X(480).
01  OV-REC.
    02 OV-KEY.
      03 OV-DIV PIC 99.
      03 OV-NO PIC 9(4).
    02 OV-KN.
      03 OV-NAME PIC X(36).
FD  VENDOR.
01  V-RECORD PIC X(480).
01  V-REC.
    02 V-KEY.
      03 V-DIV PIC 99.
      03 V-NO PIC 9(4).
    02 V-KN.
      03 V-NAME PIC X(36).

FD  OPART BLOCK 4096.
01  OPH-RECORD PIC X(570).
01  OPH-REC.
    02 OPH-KEY.
      03 OPH-NO PIC X(12).
    02 OPH-KD.
      03 OPH-DRAW PIC X(12).
    02 OPH-KA.
      03 OPH-ALT PIC 9(12).
      03 OPH-KANO PIC X(12).
    02 OPH-KV.
      03 OPH-VNUM PIC X(24).
      03 OPH-KVNO PIC X(12).
FD  PART BLOCK 4096.
01  PH-RECORD PIC X(570).
01  PH-REC.
    02 PH-KEY.
      03 PH-NO PIC X(12).
    02 PH-KD.
      03 PH-DRAW PIC X(12).
    02 PH-KA.
      03 PH-ALT PIC 9(12).
      03 PH-KANO PIC X(12).
    02 PH-KV.
      03 PH-VNUM PIC X(24).
      03 PH-KVNO PIC X(12).

FD  OAPTR BLOCK 2048.
01  OAT-RECORD PIC X(650).
01  OAT-REC.
    02 OAT-KEY.
      03 OAT-DIV PIC 99.
      03 OAT-VEN PIC 9(4).
      03 OAT-TYPE PIC 9.
      03 OAT-INV PIC X(15).
    02 OAT-KD.
      03 OAT-KDIV PIC 99.
      03 OAT-KVEN PIC 9(4).
      03 OAT-ZDATE PIC 9(6).
      03 OAT-KTYPE PIC 9.
      03 OAT-KINV PIC X(15).
FD  APTR BLOCK 2048.
01  AT-RECORD PIC X(650).
01  AT-REC.
    02 AT-KEY.
      03 AT-DIV PIC 99.
      03 AT-VEN PIC 9(4).
      03 AT-TYPE PIC 9.
      03 AT-INV PIC X(15).
    02 AT-KD.
      03 AT-KDIV PIC 99.
      03 AT-KVEN PIC 9(4).
      03 AT-ZDATE PIC 9(6).
      03 AT-KTYPE PIC 9.
      03 AT-KINV PIC X(15).

FD  OAPCHQ.
01  OAH-RECORD PIC X(50).
01  OAH-REC.
    02 OAH-KEY.
      03 OAH-DIV PIC 99.
      03 OAH-US PIC 9.
      03 OAH-NO PIC 9(6).
FD  APCHQ.
01  AH-RECORD PIC X(50).
01  AH-REC.
    02 AH-KEY.
      03 AH-DIV PIC 99.
      03 AH-US PIC 9.
      03 AH-NO PIC 9(6).

FD  OHEAT.
01  OHE-RECORD PIC X(75).
01  OHE-REC.
    02 OHE-KEY.
      03 OHE-NO PIC X(10).
FD  HEAT.
01  HE-RECORD PIC X(75).
01  HE-REC.
    02 HE-KEY.
      03 HE-NO PIC X(10).

FD  OPURORD BLOCK 1024.
01  OOK-RECORD PIC X(190).
01  OOK-REC.
    02 OOK-KEY.
      03 OOK-NO PIC X(8).
    02 OOK-KV.
      03 OOK-VENDOR PIC 9(4).
      03 OOK-ZNO PIC X(8).
FD  PURORD BLOCK 1024.
01  OK-RECORD PIC X(190).
01  OK-REC.
    02 OK-KEY.
      03 OK-NO PIC X(8).
    02 OK-KV.
      03 OK-VENDOR PIC 9(4).
      03 OK-ZNO PIC X(8).
    02 OK-STATUS PIC 9 COMP-3.
    02 OK-HOLD PIC 9 COMP-3.
    02 OK-ITORD PIC 9 COMP-3.
    02 OK-BLANKET PIC 9 COMP-3.
    02 OK-DATE PIC 9(6) COMP-3.

FD  OPURLIN.
01  OLK-RECORD PIC X(980).
01  OLK-REC.
    02 OLK-KEY.
      03 OLK-ORD PIC X(8).
      03 OLK-LINE PIC 99.
    02 OLK-NO REDEFINES OLK-KEY PIC X(10).
    02 OLK-KP.
      03 OLK-PART PIC X(12).
      03 OLK-DATE-REQ PIC 9(6).
FD  PURLIN.
01  LK-RECORD PIC X(980).
01  LK-REC.
    02 LK-KEY.
      03 LK-ORD PIC X(8).
      03 LK-LINE PIC 99.
    02 LK-NO REDEFINES LK-KEY PIC X(10).
    02 LK-KP.
      03 LK-PART PIC X(12).
      03 LK-DATE-REQ PIC 9(6).
    02 LK-BLANKET PIC 9 COMP-3.
    02 LK-QTY PIC S9(9) COMP-3.
    02 LK-QTY-REC PIC S9(9) COMP-3.

FD  OMNTORD BLOCK 2048.
01  OVO-RECORD PIC X(650).
01  OVO-REC.
    02 OVO-KEY.
      03 OVO-NO PIC 9(6).
    02 OVO-KN.
      03 OVO-ZNO PIC 9(6).
FD  MNTORD BLOCK 2048.
01  VO-RECORD PIC X(650).
01  VO-REC.
    02 VO-KEY.
      03 VO-NO PIC 9(6).
    02 VO-KN.
      03 VO-ZNO PIC 9(6).
    02 VO-MAC PIC 999 COMP-3.
    02 VO-SEC PIC 99 COMP-3.
    02 VO-LEVEL PIC 99 COMP-3.
    02 VO-TYPE PIC 9 COMP-3.
    02 VO-PRIOR PIC 9 COMP-3.
    02 VO-DATE PIC 9(6) COMP-3.

FD  OMNTLIN.
01  OVL-RECORD PIC X(60).
01  OVL-REC.
    02 OVL-KEY.
      03 OVL-NO PIC 9(6).
      03 OVL-TYPE PIC 9.
      03 OVL-ID PIC X(12).
      03 OVL-PROC REDEFINES OVL-ID PIC 999.
      03 OVL-PART REDEFINES OVL-ID PIC X(12).
      03 OVL-DATE PIC 9(6).
      03 OVL-SHIFT PIC 9.
      03 OVL-EMP PIC 9(4).
FD  MNTLIN.
01  VL-RECORD PIC X(60).
01  VL-REC.
    02 VL-KEY.
      03 VL-NO PIC 9(6).
      03 VL-TYPE PIC 9.
      03 VL-ID PIC X(12).
      03 VL-PROC REDEFINES VL-ID PIC 999.
      03 VL-PART REDEFINES VL-ID PIC X(12).
      03 VL-DATE PIC 9(6).
      03 VL-SHIFT PIC 9.
      03 VL-EMP PIC 9(4).

FD  OPARTRANS.
01  OPT-RECORD PIC X(115).
01  OPT-REC.
    02 OPT-KEY.
      03 OPT-PART PIC X(12).
      03 OPT-DATE PIC 9(6).
      03 OPT-TIME PIC 9(8).
FD  PARTRANS.
01  PT-RECORD PIC X(115).
01  PT-REC.
    02 PT-KEY.
      03 PT-PART PIC X(12).
      03 PT-DATE PIC 9(6).
      03 PT-TIME PIC 9(8).

FD  OPRODTRANS.
01  OPE-RECORD PIC X(115).
01  OPE-REC.
    02 OPE-KEY.
      03 OPE-PROD PIC X(12).
      03 OPE-DATE PIC 9(6).
      03 OPE-TIME PIC 9(8).
FD  PRODTRANS.
01  PE-RECORD PIC X(115).
01  PE-REC.
    02 PE-KEY.
      03 PE-PROD PIC X(12).
      03 PE-DATE PIC 9(6).
      03 PE-TIME PIC 9(8).

FD  OTOOLPROD.
01  OTP-RECORD PIC X(50).
01  OTP-REC.
    02 OTP-KEY.
      03 OTP-TOOL PIC X(12).
      03 OTP-PROD PIC X(12).
      03 OTP-MAC PIC 99.
      03 OTP-FLD PIC 999.
FD  TOOLPROD.
01  TP-RECORD PIC X(50).
01  TP-REC.
    02 TP-KEY.
      03 TP-TOOL PIC X(12).
      03 TP-PROD PIC X(12).
      03 TP-MAC PIC 99.
      03 TP-FLD PIC 999.

FD  OTMPURORD.
01  OYOK-RECORD PIC X(240).
01  OYOK-REC.
    02 OYOK-KEY.
      03 OYOK-ORD PIC X(8).
      03 OYOK-SEQ PIC 9(4).
FD  TMPURORD.
01  YOK-RECORD PIC X(240).
01  YOK-REC.
    02 YOK-KEY.
      03 YOK-ORD PIC X(8).
      03 YOK-SEQ PIC 9(4).

FD  OTMPURLIN.
01  OYLK-RECORD PIC X(980).
01  OYLK-REC.
    02 OYLK-KEY.
      03 OYLK-ORD PIC X(8).
      03 OYLK-SEQ PIC 9(4).
      03 OYLK-LINE PIC 99.
FD  TMPURLIN.
01  YLK-RECORD PIC X(980).
01  YLK-REC.
    02 YLK-KEY.
      03 YLK-ORD PIC X(8).
      03 YLK-SEQ PIC 9(4).
      03 YLK-LINE PIC 99.

FD  OSTATEMENT.
01  OSW-RECORD PIC X(50).
01  OSW-REC.
    02 OSW-KEY.
      03 OSW-CUS PIC X(6).
      03 OSW-DATE PIC 9(6).
      03 OSW-LINE PIC 9(4).
FD  STATEMENT.
01  SW-RECORD PIC X(50).
01  SW-REC.
    02 SW-KEY.
      03 SW-CUS PIC X(6).
      03 SW-DATE PIC 9(6).
      03 SW-LINE PIC 9(4).

FD  OGLTR.
01  OGT-RECORD PIC X(75).
01  OGT-REC.
    02 OGT-KEY.
      03 OGT-DIV PIC 99.
      03 OGT-VEN PIC 9(4).
      03 OGT-INV PIC X(15).
      03 OGT-TYPE PIC 9.
      03 OGT-SYS PIC 9.
      03 OGT-GL PIC 9(18).
    02 OGT-AMT PIC S9(9)V99 COMP-3.
    02 OGT-FILL1 PIC X.
    02 OGT-YY PIC 99 COMP-3.
FD  GLTR.
01  GT-RECORD PIC X(75).
01  GT-REC.
    02 GT-KEY.
      03 GT-DIV PIC 99.
      03 GT-VEN PIC 9(4).
      03 GT-INV PIC X(15).
      03 GT-TYPE PIC 9.
      03 GT-SYS PIC 9.
      03 GT-GL PIC 9(18).
    02 GT-AMT PIC S9(9)V99 COMP-3.
    02 GT-FILL1 PIC X.
    02 GT-YY PIC 99 COMP-3.

FD  OPURHIST BLOCK 2048.
01  OPU-RECORD PIC X(130).
01  OPU-REC.
    02 OPU-KEY.
      03 OPU-DIV PIC 99.
      03 OPU-PART PIC X(12).
      03 OPU-ZDATE PIC 9(6).
      03 OPU-ZTIME PIC 9(8).
    02 OPU-KV.
      03 OPU-VDIV PIC 99.
      03 OPU-VENDOR PIC 9(4).
      03 OPU-ZVDATE PIC 9(6).
      03 OPU-ZVTIME PIC 9(8).
FD  PURHIST BLOCK 2048.
01  PU-RECORD PIC X(130).
01  PU-REC.
    02 PU-KEY.
      03 PU-DIV PIC 99.
      03 PU-PART PIC X(12).
      03 PU-ZDATE PIC 9(6).
      03 PU-ZTIME PIC 9(8).
    02 PU-KV.
      03 PU-VDIV PIC 99.
      03 PU-VENDOR PIC 9(4).
      03 PU-ZVDATE PIC 9(6).
      03 PU-ZVTIME PIC 9(8).

FD  OSALHIST BLOCK 2048.
01  OSH-RECORD PIC X(135).
01  OSH-REC.
    02 OSH-KEY.
      03 OSH-CUS PIC X(6).
      03 OSH-PROD PIC X(12).
      03 OSH-CDATE PIC 9(6).
      03 OSH-CTIME PIC 9(8).
    02 OSH-KP.
      03 OSH-KPROD PIC X(12).
      03 OSH-KCUS PIC X(6).
      03 OSH-KDATE PIC 9(6).
      03 OSH-KTIME PIC 9(8).
FD  SALHIST BLOCK 2048.
01  SH-RECORD PIC X(135).
01  SH-REC.
    02 SH-KEY.
      03 SH-CUS PIC X(6).
      03 SH-PROD PIC X(12).
      03 SH-CDATE PIC 9(6).
      03 SH-CTIME PIC 9(8).
    02 SH-KP.
      03 SH-KPROD PIC X(12).
      03 SH-KCUS PIC X(6).
      03 SH-KDATE PIC 9(6).
      03 SH-KTIME PIC 9(8).

FD  OACKORD.
01  OAKO-RECORD PIC X(480).
01  OAKO-REC.
    02 OAKO-KEY.
      03 OAKO-NO PIC 9(6).
FD  ACKORD.
01  AKO-RECORD PIC X(480).
01  AKO-REC.
    02 AKO-KEY.
      03 AKO-NO PIC 9(6).

FD  OACKLIN.
01  OAKL-RECORD PIC X(150).
01  OAKL-REC.
    02 OAKL-KEY.
      03 OAKL-ORD PIC 9(6).
      03 OAKL-LINE PIC 99.
    02 OAKL-NO REDEFINES OAKL-KEY PIC 9(8).
FD  ACKLIN.
01  AKL-RECORD PIC X(150).
01  AKL-REC.
    02 AKL-KEY.
      03 AKL-ORD PIC 9(6).
      03 AKL-LINE PIC 99.
    02 AKL-NO REDEFINES AKL-KEY PIC 9(8).

FD  OPRODORD BLOCK 2048.
01  OR-RECORD PIC X(115).
01  OR-REC.
    02 OR-KEY.
      03 OR-NO PIC 9(6).
    02 OR-KP.
      03 OR-PROD PIC X(12).
      03 OR-DATE PIC 9(6).
FD  PRODORD BLOCK 2048.
01  R-RECORD PIC X(115).
01  R-REC.
    02 R-KEY.
      03 R-NO PIC 9(6).
    02 R-KP.
      03 R-PROD PIC X(12).
      03 R-DATE PIC 9(6).
    02 R-QTY-ORD PIC S9(9) COMP-3.
    02 R-QTY-LEFT PIC S9(9) COMP-3.

FD  OWORKSHEET BLOCK 2048.
01  OJ-RECORD PIC X(240).
01  OJ-REC.
    02 OJ-KEY.
      03 OJ-NO PIC 9(6).
      03 OJ-KM.
        04 OJ-MAC PIC 9(4).
        04 OJ-DATE PIC 9(6).
        04 OJ-SHIFT PIC 9.
        04 OJ-EMP PIC 9(4).
    02 OJ-KN.
      03 OJ-KNO PIC 9(6).
      03 OJ-KD.
        04 OJ-KDATE PIC 9(6).
        04 OJ-KSHIFT PIC 9.
        04 OJ-KMAC PIC 9(4).
FD  WORKSHEET BLOCK 2048.
01  J-RECORD PIC X(240).
01  J-REC.
    02 J-KEY.
      03 J-NO PIC 9(6).
      03 J-KM.
        04 J-MAC PIC 9(4).
        04 J-DATE PIC 9(6).
        04 J-SHIFT PIC 9.
        04 J-EMP PIC 9(4).
    02 J-KN.
      03 J-KNO PIC 9(6).
      03 J-KD.
        04 J-KDATE PIC 9(6).
        04 J-KSHIFT PIC 9.
        04 J-KMAC PIC 9(4).

FD  OBUCKET.
01  OBU-RECORD PIC X(50).
01  OBU-REC.
    02 OBU-KEY.
      03 OBU-JKEY.
        04 OBU-NO PIC 9(6).
        04 OBU-MAC PIC 9(4).
        04 OBU-DATE PIC 9(6).
        04 OBU-SHIFT PIC 9.
        04 OBU-EMP PIC 9(4).
      03 OBU-NUM PIC 9(4).
    02 OBU-KN.
      03 OBU-KNUM PIC 9(4).
      03 OBU-ZDATE PIC 9(6).
FD  BUCKET.
01  BU-RECORD PIC X(50).
01  BU-REC.
    02 BU-KEY.
      03 BU-JKEY.
        04 BU-NO PIC 9(6).
        04 BU-MAC PIC 9(4).
        04 BU-DATE PIC 9(6).
        04 BU-SHIFT PIC 9.
        04 BU-EMP PIC 9(4).
      03 BU-NUM PIC 9(4).
    02 BU-KN.
      03 BU-KNUM PIC 9(4).
      03 BU-ZDATE PIC 9(6).

FD  OMATREL.
01  OMT-RECORD PIC X(980).
01  OMT-REC.
    02 OMT-KEY.
      03 OMT-PLANT PIC X(10).
      03 OMT-PROD PIC X(12).
      03 OMT-SEQ PIC 99.
    02 OMT-KP.
      03 OMT-KPROD PIC X(12).
      03 OMT-KPLANT PIC X(10).
FD  MATREL.
01  MT-RECORD PIC X(980).
01  MT-REC.
    02 MT-KEY.
      03 MT-PLANT PIC X(10).
      03 MT-PROD PIC X(12).
      03 MT-SEQ PIC 99.
    02 MT-KP.
      03 MT-KPROD PIC X(12).
      03 MT-KPLANT PIC X(10).

FD  ODAYREL.
01  ODY-RECORD PIC X(1500).
01  ODY-REC.
    02 ODY-KEY.
      03 ODY-PLANT PIC X(10).
      03 ODY-PROD PIC X(12).
      03 ODY-SEQ PIC 99.
    02 ODY-KP.
      03 ODY-KPROD PIC X(12).
      03 ODY-KPLANT PIC X(10).
FD  DAYREL.
01  DY-RECORD PIC X(1500).
01  DY-REC.
    02 DY-KEY.
      03 DY-PLANT PIC X(10).
      03 DY-PROD PIC X(12).
      03 DY-SEQ PIC 99.
    02 DY-KP.
      03 DY-KPROD PIC X(12).
      03 DY-KPLANT PIC X(10).

FD  OTOOLS.
01  OTS-RECORD PIC X(3300).
01  OTS-REC.
    02 OTS-KEY.
      03 OTS-PROD PIC X(12).
      03 OTS-MAC PIC 99.
FD  TOOLS.
01  TS-RECORD PIC X(3300).
01  TS-REC.
    02 TS-KEY.
      03 TS-PROD PIC X(12).
      03 TS-MAC PIC 99.

FD  OSALSUM.
01  OSM-RECORD PIC X(115).
01  OSM-REC.
    02 OSM-KEY.
      03 OSM-CUS PIC X(6).
      03 OSM-PROD PIC X(12).
    02 OSM-KP.
      03 OSM-KPROD PIC X(12).
      03 OSM-KCUS PIC X(6).
FD  SALSUM.
01  SM-RECORD PIC X(115).
01  SM-REC.
    02 SM-KEY.
      03 SM-CUS PIC X(6).
      03 SM-PROD PIC X(12).
    02 SM-KP.
      03 SM-KPROD PIC X(12).
      03 SM-KCUS PIC X(6).

FD  OQBIN.
01  OQB-RECORD PIC X(115).
01  OQB-REC.
    02 OQB-KEY.
      03 OQB-NO PIC X(5).
    02 OQB-KP.
      03 OQB-PROD PIC X(12).
      03 OQB-LYEAR PIC 9(4).
      03 OQB-LOT PIC 9(7).
      03 OQB-DATE PIC 9(6).
FD  QBIN.
01  QB-RECORD PIC X(115).
01  QB-REC.
    02 QB-KEY.
      03 QB-NO PIC X(5).
    02 QB-KP.
      03 QB-PROD PIC X(12).
      03 QB-LYEAR PIC 9(4).
      03 QB-LOT PIC 9(7).
      03 QB-DATE PIC 9(6).

FD  OALTERNATES.
01  OAL-RECORD PIC X(50).
01  OAL-REC.
    02 OAL-KEY.
      03 OAL-PROD PIC X(12).
      03 OAL-ALT PIC X(12).
FD  ALTERNATES.
01  AL-RECORD PIC X(50).
01  AL-REC.
    02 AL-KEY.
      03 AL-PROD PIC X(12).
      03 AL-ALT PIC X(12).

FD  ODELJITEX.
01  ODX-RECORD PIC X(2000).
01  ODX-REC.
    02 ODX-KEY.
      03 ODX-NO PIC 9(4).
FD  DELJITEX.
01  DX-RECORD PIC X(2000).
01  DX-REC.
    02 DX-KEY.
      03 DX-NO PIC 9(4).

WORKING-STORAGE SECTION.
01  DATE-FIELDS.
    02 D-DT PIC 9(6). 02 REDEFINES D-DT. 03 D-MM PIC 99. 03 D-DD PIC 99. 03 D-YY PIC 99.
    02 D-DATE PIC 9(6) COMP-3. 02 D-DAYS PIC S9(9) COMP-3.
    02 D-YEAR PIC 9(4) COMP-3. 02 D-JDAY PIC 999 COMP-3.
    02 D-LOT PIC 9(7). 02 REDEFINES D-LOT. 03 D-LOTY PIC 9. 03 D-LOTD PIC 999.
    02 D-YEAR1 PIC 9(4) COMP-3. 02 D-YEAR2 PIC 9(4) COMP-3.
    02 D-ERR PIC 9 COMP-3. 02 D-PF PIC 9 COMP-3. 02 D-S1 PIC 9 COMP-3.
    02 D-N1 PIC S9(9) COMP-3. 02 D-N2 PIC S9(9) COMP-3.
    02 D-X1 PIC S999 COMP-3. 02 D-X2 PIC S999 COMP-3.
    02 D-XL1 PIC S99 COMP-3. 02 D-XL2 PIC S99 COMP-3.
    02 D-T1 PIC S9(9) COMP-3. 02 D-T2 PIC S9(9) COMP-3.
    02 D-R1 PIC S9(9) COMP-3. 02 D-R2 PIC S9(9) COMP-3. 02 D-R3 PIC S9(9) COMP-3.
    02 D-M1 PIC S9(9) COMP-3. 02 D-P1 PIC S9(9) COMP-3.
    02 D-W1 PIC S9(9) COMP-3. 02 D-Y1 PIC S9(9) COMP-3.
    02 D-TIME PIC 9(4). 02 D-STIME PIC 9(8). 02 D-TT PIC 99.
    02 D-PRDATE PIC 99/99/99. 02 D-PRTIME PIC X(5). 02 D-PRSTIME PIC X(8).
    02 SYS-DATE PIC 9(6). 02 SYS-YEAR PIC 9(4). 02 SYS-WDAY PIC 9. 02 SYS-TIME PIC 9(8).
    02 SYS-JDATE PIC 9(5). 02 REDEFINES SYS-JDATE. 03 SYS-YY PIC 99. 03 SYS-DDD PIC 999.
    02 D-TBL1 PIC X(70) VALUE "MONDAY   .TUESDAY  .WEDNESDAY.THURSDAY .FRIDAY   .SATURDAY .SUNDAY   .".
    02 REDEFINES D-TBL1. 03 OCCURS 7. 04 D-DAYNM PIC X(9). 04 PIC X.
    02 D-TBL2 PIC X(120) VALUE "JANUARY  .FEBRUARY .MARCH    .APRIL    .MAY      .JUNE     .JULY     .AUGUST   .SEPTEMBER.OCTOBER  .NOVEMBER .DECEMBER .".
    02 REDEFINES D-TBL2. 03 OCCURS 12. 04 D-MTHNM PIC X(9). 04 PIC X.
    02 D-TBL3.
      03 PIC X(52) VALUE "000.031.059.090.120.151.181.212.243.273.304.334.365.".
      03 PIC X(52) VALUE "000.031.060.091.121.152.182.213.244.274.305.335.366.".
    02 REDEFINES D-TBL3. 03 OCCURS 2. 04 OCCURS 13. 05 D-MNUM PIC 999. 05 PIC X.
    02 D-TBL4 PIC X(36) VALUE "00000.07305.14610.21915.29220.36525.".
    02 REDEFINES D-TBL4. 03 OCCURS 6. 04 D-LNUM PIC 9(5). 04 PIC X.
    02 D-TBL5 PIC X(105) VALUE "0000.0365.0730.1096.1461.1826.2191.2557.2922.3287.3652.4018.4383.4748.5113.5479.5844.6209.6574.6940.7305.".
    02 REDEFINES D-TBL5. 03 OCCURS 21. 04 D-YNUM PIC 9(4). 04 PIC X.
01  DECLARATIVES-FIELDS.
    02 DSTAT PIC XX. 02 DCL-ERRNO PIC 9(4) COMP-3.
    02 DCL-LINE. 03 DCL-F1 PIC X(7). 03 DCL-F2 PIC X(11). 03 DCL-F3 PIC XX.
      03 DCL-F4 PIC BBBX(30). 03 DCL-F5 PIC Z(4)9.
01  GENERAL-FIELDS.
    02 WS-PR PIC 99 COMP-3.
01  MAINTENANCE-FIELDS.
    02 VMSCOM PIC X(150).
    02 NREC PIC 9(7) COMP-3. 02 NREC1 PIC 9(7) COMP-3. 02 NREC2 PIC 9(7) COMP-3.
    02 SALTOT-YEAR PIC 9(4). 02 GLTR-YEAR PIC 9(4). 02 LOT-Y PIC 9.
    02 PURHIST-DATE PIC 9(6). 02 SALHIST-DATE PIC 9(6). 02 PRODORD-DATE PIC 9(6).
    02 STATEMENT-DATE PIC 9(6). 02 PURORD-DATE PIC 9(6). 02 MNTORD-DATE PIC 9(6).

PROCEDURE DIVISION.
DECLARATIVES.
SEC-001 SECTION 0.
    USE AFTER ERROR PROCEDURE INPUT.
USE-1. MOVE "INPUT" TO DCL-F1 PERFORM USE-PR.
SEC-002 SECTION 0.
    USE AFTER ERROR PROCEDURE OUTPUT.
USE-2. MOVE "OUTPUT" TO DCL-F1 PERFORM USE-PR.
SEC-003 SECTION 0.
    USE AFTER ERROR PROCEDURE I-O.
USE-3. IF NOT(DSTAT="02" OR "90" OR "92") MOVE "I-O" TO DCL-F1 PERFORM USE-PR.
SEC-004 SECTION 0.
    USE AFTER ERROR PROCEDURE EXTEND.
USE-4. MOVE "EXTEND" TO DCL-F1 PERFORM USE-PR.
USE-PR. MOVE "DISK ERROR" TO DCL-F2 MOVE DSTAT TO DCL-F3.
    MOVE RMS-CURRENT-FILENAME TO DCL-F4.
    OPEN EXTEND PRINTFL MOVE DCL-LINE TO PREC WRITE PREC MOVE " " TO PREC.
    CLOSE PRINTFL.
    MOVE "COPY MAINT_ERR.PRN MAINTERR.PRN" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
* see note under MR-TIME
END DECLARATIVES.

SEC-0 SECTION 0.
M0. GO L0.
AX-SYS-DATE. ACCEPT D-DT FROM DATE PERFORM D-YN MOVE D-DATE TO SYS-DATE.
    ACCEPT D-DT FROM DATE PERFORM D-SHDT MOVE D-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO SYS-YEAR.
    ACCEPT SYS-WDAY FROM DAY-OF-WEEK ACCEPT SYS-JDATE FROM DAY ACCEPT SYS-TIME FROM TIME.
D-SHDT. MOVE D-MM TO D-T1 MOVE D-DD TO D-MM MOVE D-YY TO D-DD MOVE D-T1 TO D-YY.
D-SHDT2. PERFORM D-SHDT 2 TIMES.
D-CHKDT. MOVE 0 TO D-ERR PERFORM D-LEAP.
    IF D-MM=0 OR>12 OR D-DD=0 MOVE 1 TO D-ERR
      ELSE IF D-DD>D-MNUM(D-XL1,D-MM + 1) - D-MNUM(D-XL1,D-MM) MOVE 1 TO D-ERR.
D-LEAP. DIVIDE D-YY BY 4 GIVING D-XL2 REMAINDER D-XL1.
    IF D-XL1=0 MOVE 2 TO D-XL1 ELSE MOVE 1 TO D-XL1.
D-NY. PERFORM D-NM PERFORM D-SHDT2.
D-YN. IF D-DT NOT NUMERIC MOVE 0 TO D-DT. PERFORM D-SHDT PERFORM D-MN.
D-MN. IF D-DT NOT NUMERIC MOVE 0 TO D-DT.
    MOVE D-YY TO D-T1 IF D-YY<70 ADD 100 TO D-T1.
    PERFORM D-CHKDT IF D-ERR=1 MOVE 0 TO D-DATE
      ELSE PERFORM D-LEAP COMPUTE D-DATE=
       36524 + (D-T1 - 70) * 365 + (D-T1 - 69) / 4 + D-MNUM(D-XL1,D-MM) + D-DD.
D-NM. PERFORM D-NM1 THRU D-NM9.
D-NM1. IF D-DATE=0 MOVE 0 TO D-DT D-YEAR GO D-NM9.
    COMPUTE D-T1=D-DATE - 36524.
    IF D-T1<=0 MOVE 010170 TO D-DT MOVE 1970 TO D-YEAR GO D-NM9.
    IF D-T1>36525 MOVE 123169 TO D-DT MOVE 2069 TO D-YEAR GO D-NM9.
    PERFORM VARYING D-X1 FROM 5 BY -1 UNTIL D-T1>D-LNUM(D-X1) CONTINUE END-PERFORM.
    COMPUTE D-T1=D-T1 - D-LNUM(D-X1).
    PERFORM VARYING D-X2 FROM 20 BY -1 UNTIL D-T1>D-YNUM(D-X2) CONTINUE END-PERFORM.
    COMPUTE D-T1=D-T1 - D-YNUM(D-X2) MOVE D-T1 TO D-JDAY.
    COMPUTE D-T2=70 + 20 * (D-X1 - 1) + (D-X2 - 1) COMPUTE D-YEAR=1900 + D-T2.
    IF D-T2>=100 SUBTRACT 100 FROM D-T2. MOVE D-T2 TO D-YY PERFORM D-LEAP.
    PERFORM VARYING D-MM FROM 12 BY -1 UNTIL D-T1>D-MNUM(D-XL1,D-MM) CONTINUE END-PERFORM.
    COMPUTE D-DD=D-T1 - D-MNUM(D-XL1,D-MM).
D-NM9. EXIT.
D-NC. PERFORM D-NM COMPUTE D-N1=D-YEAR * 10000 + D-MM * 100 + D-DD.
D-YCONV. IF D-Y1<70 ADD 2000 TO D-Y1 ELSE ADD 1900 TO D-Y1.

MR-LINE. WRITE MREC AFTER WS-PR MOVE " " TO MREC MOVE 1 TO WS-PR.
MR-TIME. OPEN EXTEND MAINTFL.
    MOVE NREC TO MA14 ACCEPT MA15 FROM TIME PERFORM MR-LINE MOVE 0 TO NREC.
    CLOSE MAINTFL.
    MOVE "COPY MAINT_LOG.PRN MAINTLOG.PRN" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
* to display current contents, use TYPE MAINTLOG.PRN or MAINTERR.PRN; avoid TYPE MAINT_LOG.PRN or MAINT_ERR.PRN
* while this program is running - it causes fatal error if done while the .PRN file is being opened or written to.

L0. OPEN OUTPUT PRINTFL MAINTFL CLOSE PRINTFL MAINTFL.
    MOVE 0 TO NREC MOVE 1 TO WS-PR MOVE " " TO PREC MREC PERFORM AX-SYS-DATE.

*   'LAST USED' SAYS 'JAN' BUT MAY BE 'DEC 31' OF PREV YEAR

*   SALTOT: KEEP LAST 1 YEAR
*   (LAST USED  JAN 2014  WITH '2013')
    MOVE 2013 TO SALTOT-YEAR.

*   LOT: DELETE 10-YEAR-OLD LOTS WITH NEXT YEAR'S DATE
*   (LAST USED  JAN 2014  WITH '4')
    MOVE 4 TO LOT-Y.

*   STATEMENT: KEEP LAST 1 YEAR
*   (LAST USED  JAN 2014  WITH '130101' YYMMDD)
    MOVE 130101 TO D-DT PERFORM D-YN MOVE D-DATE TO STATEMENT-DATE.

*   GLTR: KEEP LAST 1 YEAR
*   (LAST USED  JAN 2014  WITH '2013')
    MOVE 2013 TO GLTR-YEAR.

*   PURORD/PURLIN: KEEP LAST 2 YEARS
*   (LAST USED  JAN 2014  WITH '120101' YYMMDD)
    MOVE 120101 TO D-DT PERFORM D-YN MOVE D-DATE TO PURORD-DATE.

*   MNTORD/MNTLIN: KEEP LAST 7 YEARS
*   (LAST USED  JAN 2014  WITH '070101' YYMMDD)
    MOVE 070101 TO D-DT PERFORM D-YN MOVE D-DATE TO MNTORD-DATE.

*   PURHIST: KEEP LAST 4 YEARS
*   (LAST USED  JAN 2014  WITH '100101' YYMMDD)
    MOVE 100101 TO D-DT PERFORM D-YN MOVE D-DATE TO PURHIST-DATE.

*   SALHIST: KEEP LAST 4 YEARS
*   (LAST USED  JAN 2014  WITH '100101' YYMMDD)
    MOVE 100101 TO D-DT PERFORM D-YN MOVE D-DATE TO SALHIST-DATE.

*   PRODORD/WORKSHEET/BUCKET: KEEP LAST 1 YEAR
*   (LAST USED  JAN 2014  WITH '130101' YYMMDD)
    MOVE 130101 TO D-DT PERFORM D-YN MOVE D-DATE TO PRODORD-DATE.

* allow for macro expansion, max line length 250
    REPLACE
      ==FILES-1== BY ==TRAUDIT AUDIT COSTHIST OPERATIONS LABELS SALTOT SUBCON SUBINV PRODUCT CUSTOMER SHIPTO TRANS BIN PURBIN MILL SAORD SALIN==
      ==OFILES-1== BY ==OTRAUDIT OAUDIT OCOSTHIST OOPERATIONS OLABELS OSALTOT OSUBCON OSUBINV OPRODUCT OCUSTOMER OSHIPTO OTRANS OBIN OPURBIN OMILL OSAORD OSALIN==
      ==FILES-2== BY ==LOT VENDOR PART APTR APCHQ HEAT PURORD PURLIN MNTORD MNTLIN PARTRANS PRODTRANS TOOLPROD TMPURORD TMPURLIN STATEMENT GLTR==
      ==OFILES-2== BY ==OLOT OVENDOR OPART OAPTR OAPCHQ OHEAT OPURORD OPURLIN OMNTORD OMNTLIN OPARTRANS OPRODTRANS OTOOLPROD OTMPURORD OTMPURLIN OSTATEMENT OGLTR==
      ==FILES-3== BY ==PURHIST SALHIST ACKORD ACKLIN PRODORD WORKSHEET BUCKET MATREL DAYREL TOOLS SALSUM QBIN ALTERNATES DELJITEX==
      ==OFILES-3== BY ==OPURHIST OSALHIST OACKORD OACKLIN OPRODORD OWORKSHEET OBUCKET OMATREL ODAYREL OTOOLS OSALSUM OQBIN OALTERNATES ODELJITEX==.

    MOVE "PURGE *.DAT" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "DEL DUA2:[MAINT]*.DAT.*" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.

    MOVE "COPY TRAUDIT.DAT, AUDIT.DAT, COSTHIST.DAT, OPERATIONS.DAT, LABELS.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY SALTOT.DAT, SUBCON.DAT, SUBINV.DAT, PRODUCT.DAT, CUSTOMER.DAT, SHIPTO.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY TRANS.DAT, BIN.DAT, PURBIN.DAT, MILL.DAT, SAORD.DAT, SALIN.DAT, LOT.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY VENDOR.DAT, PART.DAT, APTR.DAT, APCHQ.DAT, HEAT.DAT, PURORD.DAT, PURLIN.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY MNTORD.DAT, MNTLIN.DAT, PARTRANS.DAT, PRODTRANS.DAT, TOOLPROD.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY TMPURORD.DAT, TMPURLIN.DAT, STATEMENT.DAT, GLTR.DAT, PURHIST.DAT, SALHIST.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY ACKORD.DAT, ACKLIN.DAT, PRODORD.DAT, WORKSHEET.DAT, BUCKET.DAT, MATREL.DAT, DAYREL.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.
    MOVE "COPY TOOLS.DAT, SALSUM.DAT, QBIN.DAT, ALTERNATES.DAT, DELJITEX.DAT DUA2:[MAINT]" TO VMSCOM CALL "LIB$SPAWN" USING DESCRIPTOR VMSCOM.

    OPEN INPUT OFILES-1.
    OPEN OUTPUT FILES-1.
    CLOSE FILES-1.
    OPEN I-O FILES-1.

    OPEN INPUT OFILES-2.
    OPEN OUTPUT FILES-2.
    CLOSE FILES-2.
    OPEN I-O FILES-2.

    OPEN INPUT OFILES-3.
    OPEN OUTPUT FILES-3.
    CLOSE FILES-3.
    OPEN I-O FILES-3.

    OPEN EXTEND MAINTFL MOVE "IFMAINT" TO MA11.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO MA12 PERFORM MR-LINE 2 TIMES.
    MOVE "FILE           RECORDS     TIME" TO PREC PERFORM MR-LINE 2 TIMES.
    CLOSE MAINTFL PERFORM MR-TIME.

    MOVE " " TO OYT-KEY START OTRAUDIT KEY>OYT-KEY INVALID GO L098.
L09. READ OTRAUDIT NEXT INTO YT-RECORD END GO L098.
    WRITE YT-RECORD ADD 1 TO NREC GO L09.
L098. MOVE "TRAUDIT" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OAU-KEY START OAUDIT KEY>OAU-KEY INVALID GO L118.
L11. READ OAUDIT NEXT INTO AU-RECORD END GO L118.
    WRITE AU-RECORD ADD 1 TO NREC GO L11.
L118. MOVE "AUDIT" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OCU-KEY START OCOSTHIST KEY>OCU-KEY INVALID GO L138.
L13. READ OCOSTHIST NEXT INTO CU-RECORD END GO L138.
    WRITE CU-RECORD ADD 1 TO NREC GO L13.
L138. MOVE "COSTHIST" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OOP-KEY START OOPERATIONS KEY>OOP-KEY INVALID GO L158.
L15. READ OOPERATIONS NEXT INTO OP-RECORD END GO L158.
    WRITE OP-RECORD ADD 1 TO NREC GO L15.
L158. MOVE "OPERATIONS" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OLA-KEY START OLABELS KEY>OLA-KEY INVALID GO L178.
L17. READ OLABELS NEXT INTO LA-RECORD END GO L178.
    WRITE LA-RECORD ADD 1 TO NREC GO L17.
L178. MOVE "LABELS" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OST-KEY START OSALTOT KEY>OST-KEY INVALID GO L198.
L19. READ OSALTOT NEXT INTO ST-RECORD END GO L198.
    MOVE ST-YY TO D-Y1 PERFORM D-YCONV IF D-Y1<SALTOT-YEAR GO L19.
    WRITE ST-RECORD ADD 1 TO NREC GO L19.
L198. MOVE "SALTOT" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OSJ-KEY START OSUBCON KEY>OSJ-KEY INVALID GO L218.
L21. READ OSUBCON NEXT INTO SJ-RECORD END GO L218.
    WRITE SJ-RECORD ADD 1 TO NREC GO L21.
L218. MOVE "SUBCON" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OSL-KEY START OSUBINV KEY>OSL-KEY INVALID GO L238.
L23. READ OSUBINV NEXT INTO SL-RECORD END GO L238.
    WRITE SL-RECORD ADD 1 TO NREC GO L23.
L238. MOVE "SUBINV" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OPP-KEY START OPRODUCT KEY>OPP-KEY INVALID GO L258.
L25. READ OPRODUCT NEXT INTO P-RECORD END GO L258.
    WRITE P-RECORD ADD 1 TO NREC GO L25.
L258. MOVE "PRODUCT" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OC-KEY START OCUSTOMER KEY>OC-KEY INVALID GO L278.
L27. READ OCUSTOMER NEXT INTO C-RECORD END GO L278.
    WRITE C-RECORD ADD 1 TO NREC GO L27.
L278. MOVE "CUSTOMER" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OSA-KEY START OSHIPTO KEY>OSA-KEY INVALID GO L298.
L29. READ OSHIPTO NEXT INTO SA-RECORD END GO L298.
    MOVE SA-CUS TO OC-KEY READ OCUSTOMER INVALID GO L29.
    WRITE SA-RECORD ADD 1 TO NREC GO L29.
L298. MOVE "SHIPTO" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OTR-KEY START OTRANS KEY>OTR-KEY INVALID GO L318.
L31. READ OTRANS NEXT INTO TR-RECORD END GO L318.
    IF TR-AMT=0 GO L31.
    WRITE TR-RECORD ADD 1 TO NREC GO L31.
L318. MOVE "TRANS" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OB-KEY START OBIN KEY>OB-KEY INVALID GO L338.
L33. READ OBIN NEXT INTO B-RECORD END GO L338.
    WRITE B-RECORD ADD 1 TO NREC GO L33.
L338. MOVE "BIN" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OBH-KEY START OPURBIN KEY>OBH-KEY INVALID GO L358.
L35. READ OPURBIN NEXT INTO BH-RECORD END GO L358.
    WRITE BH-RECORD ADD 1 TO NREC GO L35.
L358. MOVE "PURBIN" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OML-KEY START OMILL KEY>OML-KEY INVALID GO L378.
L37. READ OMILL NEXT INTO ML-RECORD END GO L378.
    WRITE ML-RECORD ADD 1 TO NREC GO L37.
L378. MOVE "MILL" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OO-KEY START OSAORD KEY>OO-KEY INVALID GO L398.
L39. READ OSAORD NEXT INTO O-RECORD END GO L398.
    WRITE O-RECORD ADD 1 TO NREC GO L39.
L398. MOVE "SAORD" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OL-KEY START OSALIN KEY>OL-KEY INVALID GO L418.
L41. READ OSALIN NEXT INTO L-RECORD END GO L418.
    WRITE L-RECORD ADD 1 TO NREC GO L41.
L418. MOVE "SALIN" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OLT-KEY START OLOT KEY>OLT-KEY INVALID GO L438.
L43. READ OLOT NEXT INTO LT-RECORD END GO L438.
    IF LT-Y=LOT-Y GO L43.
    WRITE LT-RECORD ADD 1 TO NREC GO L43.
L438. MOVE "LOT" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OV-KEY START OVENDOR KEY>OV-KEY INVALID GO L458.
L45. READ OVENDOR NEXT INTO V-RECORD END GO L458.
    WRITE V-RECORD ADD 1 TO NREC GO L45.
L458. MOVE "VENDOR" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OPH-KEY START OPART KEY>OPH-KEY INVALID GO L478.
L47. READ OPART NEXT INTO PH-RECORD END GO L478.
    WRITE PH-RECORD ADD 1 TO NREC GO L47.
L478. MOVE "PART" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OAT-KEY START OAPTR KEY>OAT-KEY INVALID GO L498.
L49. READ OAPTR NEXT INTO AT-RECORD END GO L498.
    WRITE AT-RECORD ADD 1 TO NREC GO L49.
L498. MOVE "APTR" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OAH-KEY START OAPCHQ KEY>OAH-KEY INVALID GO L518.
L51. READ OAPCHQ NEXT INTO AH-RECORD END GO L518.
    WRITE AH-RECORD ADD 1 TO NREC GO L51.
L518. MOVE "APCHQ" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OHE-KEY START OHEAT KEY>OHE-KEY INVALID GO L538.
L53. READ OHEAT NEXT INTO HE-RECORD END GO L538.
    WRITE HE-RECORD ADD 1 TO NREC GO L53.
L538. MOVE "HEAT" TO MA13 PERFORM MR-TIME.

    MOVE 0 TO NREC1.
    MOVE " " TO OOK-KEY START OPURORD KEY>OOK-KEY INVALID GO L558.
L55. READ OPURORD NEXT INTO OK-RECORD END GO L558.
    IF OK-BLANKET=1 OR OK-DATE>=PURORD-DATE GO L554.
    MOVE OK-NO TO OLK-ORD MOVE 0 TO OLK-LINE.
    START OPURLIN KEY>OLK-KEY INVALID GO L552.
L551. READ OPURLIN NEXT INTO LK-RECORD END GO L552. IF LK-ORD NOT=OK-NO GO L552.
    IF LK-QTY-REC<LK-QTY GO L554. GO L551.
L552. GO L55.
L554. WRITE OK-RECORD ADD 1 TO NREC.
    MOVE OK-NO TO OLK-ORD MOVE 0 TO OLK-LINE.
    START OPURLIN KEY>OLK-KEY INVALID GO L556.
L555. READ OPURLIN NEXT INTO LK-RECORD END GO L556. IF LK-ORD NOT=OK-NO GO L556.
    WRITE LK-RECORD ADD 1 TO NREC1 GO L555.
L556. GO L55.
L558. MOVE "PURORD" TO MA13 PERFORM MR-TIME.
    MOVE "PURLIN" TO MA13 MOVE NREC1 TO NREC PERFORM MR-TIME.

    MOVE 0 TO NREC1.
    MOVE " " TO OVO-KEY START OMNTORD KEY>OVO-KEY INVALID GO L578.
L57. READ OMNTORD NEXT INTO VO-RECORD END GO L578.
    IF VO-DATE<MNTORD-DATE GO L57. WRITE VO-RECORD ADD 1 TO NREC.
    INITIALIZE OVL-KEY MOVE VO-NO TO OVL-NO.
    START OMNTLIN KEY>OVL-KEY INVALID GO L574.
L573. READ OMNTLIN NEXT INTO VL-RECORD END GO L574. IF VL-NO NOT=VO-NO GO L574.
    WRITE VL-RECORD ADD 1 TO NREC1 GO L573.
L574. GO L57.
L578. MOVE "MNTORD" TO MA13 PERFORM MR-TIME.
    MOVE "MNTLIN" TO MA13 MOVE NREC1 TO NREC PERFORM MR-TIME.

    MOVE " " TO OPT-KEY START OPARTRANS KEY>OPT-KEY INVALID GO L598.
L59. READ OPARTRANS NEXT INTO PT-RECORD END GO L598.
    WRITE PT-RECORD ADD 1 TO NREC GO L59.
L598. MOVE "PARTRANS" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OPE-KEY START OPRODTRANS KEY>OPE-KEY INVALID GO L618.
L61. READ OPRODTRANS NEXT INTO PE-RECORD END GO L618.
    WRITE PE-RECORD ADD 1 TO NREC GO L61.
L618. MOVE "PRODTRANS" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OTP-KEY START OTOOLPROD KEY>OTP-KEY INVALID GO L638.
L63. READ OTOOLPROD NEXT INTO TP-RECORD END GO L638.
    WRITE TP-RECORD ADD 1 TO NREC GO L63.
L638. MOVE "TOOLPROD" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OYOK-KEY START OTMPURORD KEY>OYOK-KEY INVALID GO L658.
L65. READ OTMPURORD NEXT INTO YOK-RECORD END GO L658.
    WRITE YOK-RECORD ADD 1 TO NREC GO L65.
L658. MOVE "TMPURORD" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OYLK-KEY START OTMPURLIN KEY>OYLK-KEY INVALID GO L678.
L67. READ OTMPURLIN NEXT INTO YLK-RECORD END GO L678.
    WRITE YLK-RECORD ADD 1 TO NREC GO L67.
L678. MOVE "TMPURLIN" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OSW-KEY START OSTATEMENT KEY>OSW-KEY INVALID GO L698.
L69. READ OSTATEMENT NEXT INTO SW-RECORD END GO L698.
    IF SW-DATE<STATEMENT-DATE GO L69.
    WRITE SW-RECORD ADD 1 TO NREC GO L69.
L698. MOVE "STATEMENT" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OGT-KEY START OGLTR KEY>OGT-KEY INVALID GO L718.
L71. READ OGLTR NEXT INTO GT-RECORD END GO L718.
    MOVE GT-YY TO D-Y1 PERFORM D-YCONV IF D-Y1<GLTR-YEAR GO L71.
    WRITE GT-RECORD ADD 1 TO NREC GO L71.
L718. MOVE "GLTR" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OPU-KEY START OPURHIST KEY>OPU-KEY INVALID GO L738.
L73. READ OPURHIST NEXT INTO PU-RECORD END GO L738.
    IF 999999 - PU-ZDATE<PURHIST-DATE GO L73.
    WRITE PU-RECORD ADD 1 TO NREC GO L73.
L738. MOVE "PURHIST" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OSH-KEY START OSALHIST KEY>OSH-KEY INVALID GO L758.
L75. READ OSALHIST NEXT INTO SH-RECORD END GO L758.
    IF SH-CDATE<SALHIST-DATE GO L75.
    WRITE SH-RECORD ADD 1 TO NREC GO L75.
L758. MOVE "SALHIST" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OAKO-KEY START OACKORD KEY>OAKO-KEY INVALID GO L778.
L77. READ OACKORD NEXT INTO AKO-RECORD END GO L778.
    WRITE AKO-RECORD ADD 1 TO NREC GO L77.
L778. MOVE "ACKORD" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OAKL-KEY START OACKLIN KEY>OAKL-KEY INVALID GO L798.
L79. READ OACKLIN NEXT INTO AKL-RECORD END GO L798.
    WRITE AKL-RECORD ADD 1 TO NREC GO L79.
L798. MOVE "ACKLIN" TO MA13 PERFORM MR-TIME.

    MOVE 0 TO NREC1 NREC2.
    MOVE " " TO OR-KEY START OPRODORD KEY>OR-KEY INVALID GO L828.
L81. READ OPRODORD NEXT INTO R-RECORD END GO L828.
    IF R-DATE<PRODORD-DATE - 365 GO L81. IF R-QTY-LEFT>0 GO L82.
    MOVE R-NO TO J-KNO MOVE PRODORD-DATE TO J-KDATE MOVE 0 TO J-KSHIFT J-KMAC MOVE J-KN TO OJ-KN.
    START OWORKSHEET KEY>OJ-KN INVALID GO L814.
    READ OWORKSHEET NEXT INTO J-RECORD END GO L814. IF J-KNO=R-NO GO L82.
L814. GO L81.
L82. WRITE R-RECORD ADD 1 TO NREC.
    INITIALIZE J-KEY MOVE R-NO TO J-NO MOVE J-KEY TO OJ-KEY.
    START OWORKSHEET KEY>OJ-KEY INVALID GO L826.
L821. READ OWORKSHEET NEXT INTO J-RECORD END GO L826. IF J-NO NOT=R-NO GO L826.
    WRITE J-RECORD ADD 1 TO NREC1.
    MOVE J-KEY TO BU-JKEY MOVE 0 TO BU-NUM MOVE BU-KEY TO OBU-KEY.
    START OBUCKET KEY>OBU-KEY INVALID GO L824.
L823. READ OBUCKET NEXT INTO BU-RECORD END GO L824. IF BU-JKEY NOT=J-KEY GO L824.
    WRITE BU-RECORD ADD 1 TO NREC2 GO L823.
L824. GO L821.
L826. GO L81.
L828. MOVE "PRODORD" TO MA13 PERFORM MR-TIME.
    MOVE "WORKSHEET" TO MA13 MOVE NREC1 TO NREC PERFORM MR-TIME.
    MOVE "BUCKET" TO MA13 MOVE NREC2 TO NREC PERFORM MR-TIME.

    MOVE " " TO OMT-KEY START OMATREL KEY>OMT-KEY INVALID GO L838.
L83. READ OMATREL NEXT INTO MT-RECORD END GO L838.
    WRITE MT-RECORD ADD 1 TO NREC GO L83.
L838. MOVE "MATREL" TO MA13 PERFORM MR-TIME.

    MOVE " " TO ODY-KEY START ODAYREL KEY>ODY-KEY INVALID GO L858.
L85. READ ODAYREL NEXT INTO DY-RECORD END GO L858.
    WRITE DY-RECORD ADD 1 TO NREC GO L85.
L858. MOVE "DAYREL" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OTS-KEY START OTOOLS KEY>OTS-KEY INVALID GO L878.
L87. READ OTOOLS NEXT INTO TS-RECORD END GO L878.
    WRITE TS-RECORD ADD 1 TO NREC GO L87.
L878. MOVE "TOOLS" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OSM-KEY START OSALSUM KEY>OSM-KEY INVALID GO L898.
L89. READ OSALSUM NEXT INTO SM-RECORD END GO L898.
    WRITE SM-RECORD ADD 1 TO NREC GO L89.
L898. MOVE "SALSUM" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OQB-KEY START OQBIN KEY>OQB-KEY INVALID GO L918.
L91. READ OQBIN NEXT INTO QB-RECORD END GO L918.
    WRITE QB-RECORD ADD 1 TO NREC GO L91.
L918. MOVE "QBIN" TO MA13 PERFORM MR-TIME.

    MOVE " " TO OAL-KEY START OALTERNATES KEY>OAL-KEY INVALID GO L938.
L93. READ OALTERNATES NEXT INTO AL-RECORD END GO L938.
    WRITE AL-RECORD ADD 1 TO NREC GO L93.
L938. MOVE "ALTERNATES" TO MA13 PERFORM MR-TIME.

    MOVE " " TO ODX-KEY START ODELJITEX KEY>ODX-KEY INVALID GO L958.
L95. READ ODELJITEX NEXT INTO DX-RECORD END GO L958.
    WRITE DX-RECORD ADD 1 TO NREC GO L95.
L958. MOVE "DELJITEX" TO MA13 PERFORM MR-TIME.

    CLOSE OFILES-1.
    CLOSE FILES-1.
    CLOSE OFILES-2.
    CLOSE FILES-2.
    CLOSE OFILES-3.
    CLOSE FILES-3.
    STOP RUN.
END-OF-PROGRAM.

