IDENTIFICATION DIVISION.
PROGRAM-ID. IFOP.
AUTHOR. ANDREI SORIN.
INSTALLATION. IRVINE FASTENERS.
DATE-WRITTEN. 1979-2015.
* Manufacturing Resource Planning system
* (C) Copyright 1979-2015 Andrei Sorin <a.sorin@andsor.ca>
* IFOP documentation files: NOTES.TXT, INFO.TXT, DATABASE.TXT, MENUS.TXT

* This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
*   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

ENVIRONMENT DIVISION.
CONFIGURATION SECTION.
OBJECT-COMPUTER. VAX-VMS.
SPECIAL-NAMES.
    SWITCH 1 ON SW-1 SWITCH 2 ON SW-2 SWITCH 3 ON SW-3.
INPUT-OUTPUT SECTION.
FILE-CONTROL.
    SELECT MAINTA ASSIGN "MAINTA" STATUS DSTAT.
    SELECT MAINTB ASSIGN "MAINTB" STATUS DSTAT.
    SELECT MAINTC ASSIGN "MAINTC" STATUS DSTAT.
    SELECT REPFL ASSIGN "REPFL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY RP-KEY.
    SELECT SORTFL ASSIGN "SORTFL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SR-KEY.
    SELECT SORCFL ASSIGN "SORCFL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SC-KEY.
    SELECT PRINTFL ASSIGN PRINTER.
    SELECT USERS ASSIGN "USERS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY US-KEY
      ALTERNATE RECORD KEY US-KN.
    SELECT GLTOOLCOST ASSIGN "GLTOOLCOST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GTC-KEY.
    SELECT TRAUDIT ASSIGN "TRAUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YT-KEY.
    SELECT AUDIT ASSIGN "AUDIT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AU-KEY.
    SELECT INFOFL ASSIGN "INFOFL" STATUS DSTAT
      ORGANIZATION RELATIVE ACCESS RANDOM RELATIVE KEY IF-KEY.
    SELECT EDINFO ASSIGN "EDINFO" STATUS DSTAT
      ORGANIZATION RELATIVE ACCESS RANDOM RELATIVE KEY EI-KEY.
    SELECT EDI ASSIGN "EDI" STATUS DSTAT.
    SELECT EXPFL ASSIGN "EXPFL" STATUS DSTAT.
    SELECT DOCFL ASSIGN "DOCFL" STATUS DSTAT.
    SELECT LABFL ASSIGN "LABFL" STATUS DSTAT.
    SELECT LASFL ASSIGN "LASFL" STATUS DSTAT.
    SELECT DATFL ASSIGN "DATFL" STATUS DSTAT.
    SELECT TABLES ASSIGN "TABLES" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY T-KEY.
    SELECT SIXIN ASSIGN "SIXIN" STATUS DSTAT.
    SELECT PCLIN ASSIGN "PCLIN" STATUS DSTAT.
    SELECT DRAWINGS ASSIGN "DRAWINGS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DR-KEY.
    SELECT PDRAWINGS ASSIGN "PDRAWINGS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DG-KEY.
    SELECT LABELS ASSIGN "LABELS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LA-KEY
      ALTERNATE RECORD KEY LA-KL DUPLICATES.
    SELECT SHIPVIA ASSIGN "SHIPVIA" STATUS DSTAT
      ORGANIZATION RELATIVE ACCESS RANDOM RELATIVE KEY SV-KEY.
    SELECT PACKING ASSIGN "PACKING" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PK-KEY.
    SELECT SALTOT ASSIGN "SALTOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ST-KEY.
    SELECT SALHIST ASSIGN "SALHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SH-KEY
      ALTERNATE RECORD KEY SH-KP.
    SELECT LOTHIST ASSIGN "LOTHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LN-KEY
      ALTERNATE RECORD KEY LN-KL DUPLICATES
      ALTERNATE RECORD KEY LN-KI DUPLICATES.
    SELECT SALSUM ASSIGN "SALSUM" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SM-KEY
      ALTERNATE RECORD KEY SM-KP.
    SELECT STATEMENT ASSIGN "STATEMENT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SW-KEY.
    SELECT TRANS ASSIGN "TRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TR-KEY
      ALTERNATE RECORD KEY TR-KI
      ALTERNATE RECORD KEY TR-KB DUPLICATES.
    SELECT SALESMAN ASSIGN "SALESMAN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SN-KEY.
    SELECT CUSCONT ASSIGN "CUSCONT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY CY-KEY.
    SELECT CUSTOMER ASSIGN "CUSTOMER" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY C-KEY
      ALTERNATE RECORD KEY C-KN DUPLICATES.
    SELECT PRODUCT ASSIGN "PRODUCT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY P-KEY.
    SELECT ITPRODUCT ASSIGN "DUA1:[ITMAIN]PRODUCT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ITP-KEY.
    SELECT ALTERNATES ASSIGN "ALTERNATES" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AL-KEY.
    SELECT NUTBOLT ASSIGN "NUTBOLT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY NU-KEY.
    SELECT OPERATIONS ASSIGN "OPERATIONS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OP-KEY.
    SELECT ITOPERATIONS ASSIGN "DUA1:[ITMAIN]OPERATIONS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ITOP-KEY.
    SELECT COSTHIST ASSIGN "COSTHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY CU-KEY.
    SELECT QUOTORD ASSIGN "QUOTORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QO-KEY.
    SELECT QUOTLIN ASSIGN "QUOTLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QL-KEY.
    SELECT PRICE ASSIGN "PRICE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IO-KEY
      ALTERNATE RECORD KEY IO-KP.
    SELECT PRICEHIST ASSIGN "PRICEHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY NJ-KEY.
    SELECT SUBCON ASSIGN "SUBCON" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SJ-KEY.
    SELECT SUBINV ASSIGN "SUBINV" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SL-KEY
      ALTERNATE RECORD KEY SL-KS DUPLICATES.
    SELECT BIN ASSIGN "BIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY B-KEY
      ALTERNATE RECORD KEY B-KP DUPLICATES.
    SELECT QBIN ASSIGN "QBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY QB-KEY
      ALTERNATE RECORD KEY QB-KP DUPLICATES.
    SELECT PART ASSIGN "PART" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PH-KEY
      ALTERNATE RECORD KEY PH-KD DUPLICATES
      ALTERNATE RECORD KEY PH-KA
      ALTERNATE RECORD KEY PH-KV.
    SELECT IFPART ASSIGN "DUA1:[IFMAIN]PART" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFPH-KEY
      ALTERNATE RECORD KEY IFPH-KD DUPLICATES
      ALTERNATE RECORD KEY IFPH-KA
      ALTERNATE RECORD KEY IFPH-KV.
    SELECT PURBIN ASSIGN "PURBIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BH-KEY
      ALTERNATE RECORD KEY BH-KP.
    SELECT TOOLS ASSIGN "TOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TS-KEY.
    SELECT IFTOOLS ASSIGN "DUA1:[IFMAIN]TOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFTS-KEY.
    SELECT ARCTOOLS ASSIGN "ARCTOOLS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TY-KEY.
    SELECT TOOLPROD ASSIGN "TOOLPROD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY TP-KEY.
    SELECT IFTOOLPROD ASSIGN "DUA1:[IFMAIN]TOOLPROD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFTP-KEY.
    SELECT HEAT ASSIGN "HEAT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HE-KEY.
    SELECT LOT ASSIGN "LOT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LT-KEY
      ALTERNATE RECORD KEY LT-KP.
    SELECT HTRANS ASSIGN "HTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HT-KEY.
    SELECT SHIPTO ASSIGN "SHIPTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY SA-KEY.
    SELECT BILLTO ASSIGN "BILLTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BT-KEY.
    SELECT SOLDTO ASSIGN "SOLDTO" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY UH-KEY.
    SELECT SAORD ASSIGN "SAORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY O-KEY
      ALTERNATE RECORD KEY O-KC DUPLICATES.
    SELECT SALIN ASSIGN "SALIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY L-KEY
      ALTERNATE RECORD KEY L-KP DUPLICATES.
    SELECT SHIPORD ASSIGN "SHIPORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HO-KEY
      ALTERNATE RECORD KEY HO-KB DUPLICATES
      ALTERNATE RECORD KEY HO-KV DUPLICATES.
    SELECT SHIPLIN ASSIGN "SHIPLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY HL-KEY
      ALTERNATE RECORD KEY HL-KP DUPLICATES.
    SELECT BINALLOC ASSIGN "BINALLOC" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BA-KEY.
    SELECT TMPORD ASSIGN "TMPORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YO-KEY.
    SELECT TMPLIN ASSIGN "TMPLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YL-KEY.
    SELECT INTMPORD ASSIGN "DUA1:[INMAIN]TMPORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY INYO-KEY.
    SELECT ACKORD ASSIGN "ACKORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AKO-KEY.
    SELECT ACKLIN ASSIGN "ACKLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AKL-KEY.
    SELECT CFORD ASSIGN "CFORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY FO-KEY.
    SELECT CFLIN ASSIGN "CFLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY FL-KEY.
    SELECT PURORD ASSIGN "PURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY OK-KEY
      ALTERNATE RECORD KEY OK-KV.
    SELECT PURLIN ASSIGN "PURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LK-KEY
      ALTERNATE RECORD KEY LK-KP DUPLICATES.
    SELECT IFPURORD ASSIGN "DUA1:[IFMAIN]PURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFOK-KEY
      ALTERNATE RECORD KEY IFOK-KV.
    SELECT IFPURLIN ASSIGN "DUA1:[IFMAIN]PURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY IFLK-KEY
      ALTERNATE RECORD KEY IFLK-KP DUPLICATES.
    SELECT TMPURORD ASSIGN "TMPURORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YOK-KEY.
    SELECT TMPURLIN ASSIGN "TMPURLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY YLK-KEY.
    SELECT PARTRANS ASSIGN "PARTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PT-KEY.
    SELECT PRODTRANS ASSIGN "PRODTRANS" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PE-KEY.
    SELECT PLANT ASSIGN "PLANT" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PL-KEY
      ALTERNATE RECORD KEY PL-KO DUPLICATES
      ALTERNATE RECORD KEY PL-KR DUPLICATES.
    SELECT MATREL ASSIGN "MATREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MT-KEY
      ALTERNATE RECORD KEY MT-KP DUPLICATES.
    SELECT DAYREL ASSIGN "DAYREL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DY-KEY
      ALTERNATE RECORD KEY DY-KP DUPLICATES.
    SELECT DELJITEX ASSIGN "DELJITEX" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY DX-KEY.
    SELECT MACHINE ASSIGN "MACHINE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY M-KEY.
    SELECT ITMACHINE ASSIGN "DUA1:[ITMAIN]MACHINE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ITM-KEY.
    SELECT MACTYPE ASSIGN "MACTYPE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ME-KEY.
    SELECT MACSCHED ASSIGN "MACSCHED" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MQ-KEY.
    SELECT PRODORD ASSIGN "PRODORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY R-KEY
      ALTERNATE RECORD KEY R-KP DUPLICATES.
    SELECT WORKSHEET ASSIGN "WORKSHEET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY J-KEY
      ALTERNATE RECORD KEY J-KM DUPLICATES
      ALTERNATE RECORD KEY J-KN DUPLICATES
      ALTERNATE RECORD KEY J-KD DUPLICATES.
    SELECT BUCKET ASSIGN "BUCKET" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY BU-KEY
      ALTERNATE RECORD KEY BU-KN DUPLICATES.
    SELECT PHYSINV ASSIGN "PHYSINV" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PI-KEY
      ALTERNATE RECORD KEY PI-KM DUPLICATES.
    SELECT MILL ASSIGN "MILL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY ML-KEY
      ALTERNATE RECORD KEY ML-KD DUPLICATES.
    SELECT MNTMAST ASSIGN "MNTMAST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MF-KEY.
    SELECT MNTORD ASSIGN "MNTORD" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY VO-KEY
      ALTERNATE RECORD KEY VO-KN.
    SELECT MNTLIN ASSIGN "MNTLIN" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY VL-KEY.
    SELECT MNTMAC ASSIGN "MNTMAC" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY MK-KEY.
    SELECT VENDOR ASSIGN "VENDOR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY V-KEY
      ALTERNATE RECORD KEY V-KN DUPLICATES.
    SELECT APTR ASSIGN "APTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AT-KEY
      ALTERNATE RECORD KEY AT-KD.
    SELECT INAPTR ASSIGN "DUA1:[INMAIN]APTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY INAT-KEY
      ALTERNATE RECORD KEY INAT-KD.
    SELECT APCHQ ASSIGN "APCHQ" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY AH-KEY.
    SELECT GLDIST ASSIGN "GLDIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY G-KEY.
    SELECT GLTR ASSIGN "GLTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GT-KEY.
    SELECT PURHIST ASSIGN "PURHIST" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY PU-KEY
      ALTERNATE RECORD KEY PU-KV.
    SELECT EMPL ASSIGN "EMPLOYEE" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY E-KEY.
    SELECT LDTBL ASSIGN "LDTBL" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY GP-KEY.
    SELECT LDTR ASSIGN "LDTR" STATUS DSTAT
      ORGANIZATION INDEXED ACCESS DYNAMIC RECORD KEY LY-KEY.
    SELECT GLAP ASSIGN "GLAP" STATUS DSTAT.
    SELECT IFGFL ASSIGN "IFGFL" STATUS DSTAT.
    SELECT BNCHQ ASSIGN "BNCHQ" STATUS DSTAT.
    SELECT BNCLR ASSIGN "BNCLR" STATUS DSTAT.
I-O-CONTROL.
    APPLY PRINT-CONTROL ON PRINTFL
     APPLY EXTENSION 10 ON MAINTA MAINTB MAINTC REPFL SORTFL SORCFL
      APPLY LOCK-HOLDING ON USERS GLTOOLCOST TRAUDIT AUDIT INFOFL EDINFO TABLES
       DRAWINGS PDRAWINGS LABELS SHIPVIA PACKING SALTOT SALHIST LOTHIST SALSUM
       STATEMENT TRANS SALESMAN CUSCONT CUSTOMER PRODUCT ITPRODUCT ALTERNATES
       NUTBOLT OPERATIONS ITOPERATIONS COSTHIST QUOTORD QUOTLIN PRICE PRICEHIST
       SUBCON SUBINV BIN QBIN PART IFPART PURBIN TOOLS IFTOOLS ARCTOOLS TOOLPROD
       IFTOOLPROD HEAT LOT HTRANS SHIPTO BILLTO SOLDTO SAORD SALIN SHIPORD
       SHIPLIN BINALLOC TMPORD TMPLIN INTMPORD ACKORD ACKLIN CFORD CFLIN PURORD
       PURLIN IFPURORD IFPURLIN TMPURORD TMPURLIN PARTRANS PRODTRANS PLANT
       MATREL DAYREL DELJITEX MACHINE ITMACHINE MACTYPE MACSCHED PRODORD
       WORKSHEET BUCKET PHYSINV MILL MNTMAST MNTORD MNTLIN MNTMAC VENDOR APTR
       INAPTR APCHQ GLDIST GLTR PURHIST EMPL LDTBL LDTR.
DATA DIVISION.
FILE SECTION.
FD  MAINTA VALUE OF ID MFA-ID BLOCK 1024.
01  MFA-RECORD PIC X(320).
01  MFA-REC1.
    02 MFA-F2 PIC XXX.
01  MFA-REC2.
    02 PIC XXX. 02 MFA-F3 PIC X(15). 02 MFA-F4 PIC X(12). 02 MFA-F5 PIC 9(6) COMP-3.
01  MFA-REC3.
    02 PIC XXX. 02 MFA-F6 PIC X(10).
01  MFA-REC4.
    02 PIC XXX. 02 MFA-F8 PIC XXX. 02 MFA-F9 PIC S9(7) COMP-3. 02 MFA-F10 PIC XX.
    02 MFA-F11 PIC 9(5)V999 COMP-3. 02 MFA-F12 PIC XX. 02 MFA-F13 PIC X(12).
01  MFA-REC5.
    02 PIC XXX. 02 MFA-F15 PIC S9(7) COMP-3. 02 MFA-F16 PIC XX.
    02 MFA-F17 PIC 9(6) COMP-3.
01  MFA-REC6.
    02 PIC XXX. 02 MFA-F19 PIC S999 COMP-3. 02 MFA-F20 PIC S9(7) COMP-3.
01  MFA-REC7.
    02 MFA-F24 PIC X(12).
01  MFA-REC8.
    02 MFA-F26 PIC XXX.
01  MFA-REC9.
    02 PIC XXX. 02 MFA-F27 PIC X(14). 02 MFA-F28 PIC X(20). 02 MFA-F29 PIC X(20).
01  MFA-REC10.
    02 PIC XXX. 02 MFA-F30 PIC X(14). 02 MFA-F31 PIC X(30).
01  MFA-REC11.
    02 MFA-F33 PIC 99 COMP-3. 02 MFA-F34 PIC S9(9) COMP-3 OCCURS 4.
01  MFA-REC12.
    02 MFA-F37 PIC 9(4) COMP-3. 02 MFA-F38 PIC X(36). 02 MFA-F39 PIC 9(6) COMP-3.
    02 MFA-F40 PIC S9(9)V99 COMP-3. 02 MFA-F41 PIC S9(9)V99 COMP-3.

FD  MAINTB VALUE OF ID MFB-ID BLOCK 1024.
01  MFB-RECORD PIC X(320).
01  MFB-REC1.
    02 MFB-F1 PIC X(12). 02 MFB-F2 PIC S9(9) COMP-3. 02 MFB-F3 PIC 9(6) COMP-3.
01  MFB-REC2.
    02 MFB-F4 PIC 9. 02 MFB-F5 PIC X(80).

FD  MAINTC VALUE OF ID MFC-ID BLOCK 1024.
01  MFC-RECORD PIC X(320).

FD  REPFL VALUE OF ID REP-ID BLOCK 2048.
01  RP-RECORD PIC X(135).
01  RP-REC.
    02 RP-KEY PIC X(48).
*      FILLER X(87)
01  RP-REC1.
    02 RP-KEY-R1.
      03 RP-F2 PIC 9. 03 RP-F3 PIC 99. 03 RP-F4 PIC 99. 03 PIC X(43).
    02 RP-F5 PIC 9(6) COMP-3.
01  RP-REC2.
    02 RP-KEY-R2.
      03 RP-F6 PIC XX. 03 RP-F7 PIC X(24). 03 PIC X(22).
01  RP-REC3.
    02 RP-KEY-R3.
      03 RP-F8 PIC 99. 03 RP-F9 PIC 9. 03 RP-F10 PIC 99. 03 RP-F11 PIC 9(6).
      03 RP-F12 PIC X(6). 03 PIC X(31).
01  RP-REC4.
    02 RP-KEY-R4.
      03 RP-F13 PIC 99. 03 RP-F14 PIC 99. 03 RP-F15 PIC X(12).
      03 RP-F15A PIC 9(6). 03 PIC X(26).
    02 RP-F16 PIC S9(7)V99 COMP-3. 02 RP-F16A PIC S9(7) COMP-3.
    02 RP-F16B PIC S9(5) COMP-3.
01  RP-REC5.
    02 RP-KEY-R5.
      03 RP-F17 PIC 99. 03 RP-F18 PIC X(12). 03 PIC X(34).
01  RP-REC6.
    02 RP-KEY-R6.
      03 RP-F19 PIC 99. 03 RP-F20 PIC X(12). 03 PIC X(34).
01  RP-REC7.
    02 RP-KEY-R7.
      03 RP-F21 PIC 9(6). 03 RP-F21A REDEFINES RP-F21 PIC X(6).
      03 RP-F21B PIC 9(9). 03 RP-F22 PIC X(12). 03 PIC X(21).
01  RP-REC8.
    02 RP-KEY-R8.
      03 RP-F23 PIC 99. 03 RP-F24 PIC 9. 03 RP-F25 PIC 99. 03 RP-F26 PIC 9(6).
      03 RP-F27 PIC X(12). 03 RP-F28 PIC X(6). 03 PIC X(19).
01  RP-REC9.
    02 RP-KEY-R9.
      03 RP-F29 PIC 99. 03 RP-F30 PIC 99. 03 RP-F31 PIC X(12). 03 PIC X(32).
01  RP-REC10.
    02 RP-KEY-R10.
      03 RP-F32 PIC 99. 03 RP-F33 PIC X(12). 03 PIC X(34).
01  RP-REC11.
    02 RP-KEY-R11.
      03 RP-F34 PIC 99. 03 RP-F35 PIC 99. 03 RP-F36 PIC 9(4). 03 RP-F37 PIC 9(6).
      03 RP-F38 PIC 9. 03 RP-F39 PIC 9(4). 03 PIC X(29).
01  RP-REC12.
    02 RP-KEY-R12.
      03 RP-F40 PIC X(6). 03 RP-F40A PIC X(12). 03 RP-F41 PIC 9(6).
      03 RP-F42 PIC 9(6). 03 RP-F43 PIC 99. 03 PIC X(16).
    02 RP-F44 PIC S9(9) COMP-3.
01  RP-REC13.
    02 RP-KEY-R13.
      03 RP-F45 PIC 99. 03 RP-F47 PIC 9(9). 03 RP-F48 PIC X(12). 03 PIC X(25).
    02 RP-F49 PIC S9(9) COMP-3. 02 RP-F50 PIC S9(9) COMP-3.
01  RP-REC14.
    02 RP-KEY-R14.
      03 RP-F51 PIC 99. 03 RP-F51A PIC 9V9(4). 03 RP-F52 PIC 99.
      03 RP-F53 PIC X(12). 03 RP-F54 PIC X(6). 03 RP-F55 PIC X(8).
      03 RP-F56 PIC X(6). 03 PIC X(7).
01  RP-REC15.
    02 RP-KEY-R15.
      03 RP-F57 PIC X(12). 03 RP-F58 PIC 9. 03 RP-F59 PIC 9V9(4).
      03 RP-F60 PIC X(12). 03 PIC X(18).
01  RP-REC16.
    02 RP-KEY-R16.
      03 RP-F61 PIC 9(4). 03 RP-F62 PIC 9. 03 RP-F62A PIC 9(4).
      03 RP-F63 PIC 9(6). 03 RP-F64 PIC 9(6). 03 PIC X(27).
01  RP-REC17.
    02 RP-KEY-R17.
      03 RP-F65 PIC 9(4). 03 RP-F66 PIC X(12). 03 RP-F67 PIC 9(6).
      03 RP-F68 PIC X(21). 03 PIC X(5).
01  RP-REC18.
    02 RP-KEY-R18.
      03 RP-F70 PIC 9(4). 03 RP-F71 PIC X(12). 03 RP-F72 PIC 9(6).
      03 RP-F72A PIC X(21). 03 PIC X(5).
01  RP-REC19.
    02 RP-KEY-R19.
      03 RP-F73 PIC 99. 03 RP-F74 PIC X(12). 03 PIC X(34).
01  RP-REC20.
    02 RP-KEY-R20.
      03 RP-F75 PIC 999. 03 RP-F76 PIC X(12). 03 PIC X(33).
01  RP-REC21.
    02 RP-KEY-R21.
      03 RP-F77 PIC 99. 03 RP-F78 PIC X(12). 03 RP-F79 PIC 9(6).
      03 RP-F80 PIC X(8). 03 PIC X(20).
01  RP-REC22.
    02 RP-KEY-R22.
      03 RP-F81 PIC X(6). 03 RP-F82 PIC X(8). 03 RP-F83 PIC X(32). 03 PIC XX.
01  RP-REC23.
    02 RP-KEY-R23.
      03 RP-F84 PIC 9(6). 03 RP-F85 PIC X(6). 03 PIC X(36).
01  RP-REC24.
    02 RP-KEY-R24.
      03 RP-F86 PIC 99. 03 RP-F87 PIC X(12). 03 RP-F88 PIC X(6). 03 PIC X(28).
01  RP-REC25.
    02 RP-KEY-R25.
      03 RP-F89 PIC X(12). 03 RP-F90 PIC 9(6). 03 RP-F91 PIC X(26). 03 PIC X(4).
01  RP-REC26.
    02 RP-KEY-R26.
      03 RP-F92 PIC X(6). 03 RP-F93 PIC X(5). 03 RP-F94 PIC 9(6).
      03 RP-F95 PIC X(6). 03 PIC X(25).
01  RP-REC27.
    02 RP-KEY-R27.
      03 RP-F96 PIC 9. 03 RP-F97 PIC X(12). 03 RP-F98 PIC 9(6).
      03 RP-F99 PIC X(6). 03 PIC X(23).
    02 RP-F100 PIC 999 COMP-3.
01  RP-REC28.
    02 RP-KEY-R28.
      03 RP-F101 PIC X(26). 03 RP-F102 PIC X(22).
01  RP-REC29.
    02 RP-KEY-R29.
      03 RP-F103 PIC 9. 03 RP-F103A PIC 9. 03 RP-F104 PIC X(14).
      03 RP-F105 PIC X(12). 03 PIC X(20).
    02 RP-F106 PIC S9(9) COMP-3.
01  RP-REC30.
    02 RP-KEY-R30.
      03 RP-F107 PIC 999. 03 RP-F108 PIC 99. 03 RP-F109 PIC X(14).
      03 RP-F110 PIC X(12). 03 PIC X(17).
01  RP-REC31.
    02 RP-KEY-R31.
      03 RP-F111 PIC 9(4). 03 RP-F112 PIC X(8). 03 PIC X(36).
01  RP-REC32.
    02 RP-KEY-R32.
      03 RP-F113 PIC 9(18). 03 RP-F114 PIC 9(4). 03 RP-F115 PIC X(15).
      03 RP-F116 PIC 9. 03 RP-F117 PIC 9. 03 PIC X(9).
01  RP-REC33.
    02 RP-KEY-R33.
      03 RP-F119 PIC 9(18). 03 RP-F120 PIC X(28). 03 PIC XX.
01  RP-REC34.
    02 RP-KEY-R34.
      03 RP-F121 PIC 9(6). 03 RP-F122 PIC 99. 03 RP-F123 PIC 99.
      03 RP-F124 PIC 9(7). 03 RP-F124A PIC X(23). 03 PIC X(8).
01  RP-REC35.
    02 RP-KEY-R35.
      03 RP-F125 PIC 9(18). 03 RP-F126. 04 RP-F127 PIC 9(4). 04 RP-F128 PIC X(15).
      03 REDEFINES RP-F126. 04 RP-F129 PIC X(15).
      03 REDEFINES RP-F126. 04 RP-F130 PIC 9(9)V99.
      03 RP-F131 PIC 9. 03 RP-F132 PIC 9. 03 RP-F133 PIC 999. 03 PIC X(6).
    02 RP-F134 PIC X(41).
01  RP-REC36.
    02 RP-KEY-R36.
      03 RP-F135 PIC 99. 03 RP-F136 PIC X(12). 03 PIC X(34).
01  RP-REC37.
    02 RP-KEY-R37.
      03 RP-F137 PIC X(14). 03 RP-F138 PIC X(12). 03 RP-F139 PIC 999.
      03 RP-F140 PIC X(12). 03 RP-F141 PIC 99. 03 PIC X(5).
    02 RP-F142 PIC X(12).
01  RP-REC38.
    02 RP-KEY-R38.
      03 RP-F143 PIC X(21). 03 RP-F143A PIC X(15). 03 RP-F144 PIC X(12).
01  RP-REC39.
    02 RP-KEY-R39.
      03 RP-F145 PIC X(14). 03 RP-F146 PIC X(12). 03 RP-F147 PIC X(12).
      03 RP-F148 PIC X(6). 03 PIC X(4).
    02 RP-F149 PIC S9(5) COMP-3. 02 RP-F150 PIC 9(6) COMP-3.
01  RP-REC40.
    02 RP-KEY-R40.
      03 RP-F151 PIC X(12). 03 RP-F151A REDEFINES RP-F151 PIC 9(12).
      03 RP-F152 PIC 9(11). 03 PIC X(25).
01  RP-REC41.
    02 RP-KEY-R41.
      03 RP-F153 PIC 99. 03 RP-F154 PIC X(24). 03 PIC X(22).
01  RP-REC42.
    02 RP-KEY-R42.
      03 RP-F155 PIC X(32). 03 RP-F155A PIC X(12). 03 PIC X(4).
01  RP-REC43.
    02 RP-KEY-R43.
      03 RP-F156 PIC 9(6). 03 RP-F157 PIC 99. 03 RP-F158 PIC X(6).
      03 RP-F159 PIC X(6). 03 RP-F160 PIC X(12). 03 RP-F161 PIC 9(6). 03 PIC X(10).
    02 RP-F162 PIC S9(7) COMP-3.
01  RP-REC44.
    02 RP-KEY-R44.
      03 RP-F164 PIC 9(9). 03 PIC X(39).
    02 RP-F165 PIC X(6). 02 RP-F166 PIC S9(9) COMP-3 OCCURS 3.
01  RP-REC45.
    02 RP-KEY-R45.
      03 RP-F167 PIC X(10). 03 RP-F168 PIC 9(6). 03 RP-F169 PIC X(10).
      03 RP-F170 PIC X(12). 03 PIC X(10).
    02 RP-F171 PIC 9(5) COMP-3.
01  RP-REC46.
    02 RP-KEY-R46.
      03 RP-F172 PIC X(12). 03 RP-F173 PIC 99. 03 RP-F174 PIC X(12). 03 PIC X(22).
01  RP-REC47.
    02 RP-KEY-R47.
      03 RP-F175 PIC 9(4). 03 RP-F175A PIC 9(12). 03 RP-F176 PIC X(12). 03 PIC X(20).
01  RP-REC48.
    02 RP-KEY-R48.
      03 RP-F177 PIC 9(4). 03 RP-F178 PIC X(28). 03 PIC X(16).
01  RP-REC49.
    02 RP-KEY-R49.
      03 RP-F179 PIC 9(6). 03 RP-F180 PIC X(8). 03 PIC X(34).
01  RP-REC50.
    02 RP-KEY-R50.
      03 RP-F181 PIC 9(6). 03 RP-F182 PIC X(10). 03 PIC X(32).
01  RP-REC51.
    02 RP-KEY-R51.
      03 RP-F183 PIC 9. 03 RP-F183A PIC 9. 03 RP-F184 PIC X(32).
      03 RP-F185 PIC X(6). 03 PIC X(8).
01  RP-REC52.
    02 RP-KEY-R52.
      03 RP-F186 PIC 999. 03 RP-F187 PIC X(12). 03 PIC X(33).
01  RP-REC53.
    02 RP-KEY-R53.
      03 RP-F188 PIC 99. 03 RP-F189 PIC 999. 03 RP-F190 PIC 9(6).
      03 RP-F191 PIC X(12). 03 RP-F192 PIC X(6). 03 PIC X(19).
    02 RP-F193 PIC S9(9) COMP-3. 02 RP-F194 PIC S9(9) COMP-3.
01  RP-REC54.
    02 RP-KEY-R54.
      03 RP-F195 PIC 9(4). 03 RP-F196 PIC 99. 03 RP-F197 PIC 99.
      03 RP-F198 PIC 999. 03 RP-F199 PIC 9(5). 03 PIC X(32).
    02 RP-F200 PIC S999 COMP-3. 02 RP-F200A PIC 9(6) COMP-3.
01  RP-REC55.
    02 RP-KEY-R55.
      03 RP-F201 PIC X(12). 03 RP-F202 PIC X(12). 03 RP-F203 PIC 9(5). 03 PIC X(19).
    02 RP-F204 PIC 9 COMP-3. 02 RP-F205 PIC S9(7)V99 COMP-3.
    02 RP-F205A PIC S9(7)V99 COMP-3.
01  RP-REC56.
    02 RP-KEY-R56.
      03 RP-F206 PIC 99. 03 RP-F207 PIC 99. 03 RP-F208 PIC 99.
      03 RP-F209 PIC X(12). 03 PIC X(30).
    02 RP-F210 PIC S9(9) COMP-3. 02 RP-F211 PIC S9(7)V99 COMP-3 OCCURS 4.
01  RP-REC57.
    02 RP-KEY-R57.
      03 RP-F212 PIC X(12). 03 PIC X(36).
01  RP-REC58.
    02 RP-KEY-R58.
      03 RP-F213 PIC X(26). 03 RP-F214 PIC X(22).
01  RP-REC59.
    02 RP-KEY-R59.
      03 RP-F215 PIC 9. 03 RP-F215A PIC 999. 03 RP-F215B PIC 9(8).
      03 RP-F216 PIC X(30). 03 RP-F217 PIC 9(4). 03 PIC XX.
01  RP-REC60.
    02 RP-KEY-R60.
      03 RP-F218 PIC 99. 03 RP-F219 PIC 99. 03 RP-F220 PIC X(8). 03 PIC X(36).
01  RP-REC61.
    02 RP-KEY-R61.
      03 RP-F221 PIC X(6). 03 RP-F222 PIC X(12). 03 RP-F223 PIC 9(6).
      03 RP-F224 PIC X(8). 03 PIC X(16).
01  RP-REC62.
    02 RP-KEY-R62.
      03 RP-F225 PIC 9(4). 03 RP-F226 PIC 999. 03 RP-F227 PIC X(12).
      03 RP-F228 PIC 9(6). 03 RP-F228A PIC X. 03 RP-F228B PIC 9(7). 03 PIC X(15).
01  RP-REC63.
    02 RP-KEY-R63.
      03 RP-F229 PIC 9(7). 03 RP-F230 PIC X(30). 03 PIC X(11).
01  RP-REC64.
    02 RP-KEY-R64.
      03 RP-F231 PIC X(12). 03 PIC X(36).
01  RP-REC65.
    02 RP-KEY-R65.
      03 RP-F233 PIC 99. 03 RP-F234 PIC 9(9). 03 PIC X(37).
    02 RP-F235 PIC X(6).
01  RP-REC66.
    02 RP-KEY-R66.
      03 RP-F236 PIC X(10). 03 RP-F237 PIC 9(6). 03 RP-F237A PIC 99. 03 PIC X(30).
    02 RP-F238 PIC X(12). 02 RP-F239 PIC 999 COMP-3. 02 RP-F240 PIC 999 COMP-3.
    02 RP-F241 PIC S9(9) COMP-3. 02 RP-F242 PIC 9(6) COMP-3.
    02 RP-F243 PIC 9(6) COMP-3. 02 RP-F244 PIC 9 COMP-3. 02 RP-F245 PIC S9(9) COMP-3.
01  RP-REC67.
    02 RP-KEY-R67.
      03 RP-F246 PIC 9. 03 RP-F247 PIC X(12). 03 PIC X(35).
01  RP-REC68.
    02 RP-KEY-R68.
      03 RP-F248 PIC 99. 03 RP-F249 PIC 99. 03 RP-F250 PIC X(12). 03 PIC X(32).
01  RP-REC69.
    02 RP-KEY-R69.
      03 RP-F251 PIC 99. 03 RP-F252 PIC X(12). 03 PIC X(34).
01  RP-REC70.
    02 RP-KEY-R70.
      03 RP-F253 PIC 9(6). 03 RP-F254 PIC 99. 03 RP-F255 PIC 9(6). 03 PIC X(34).
    02 RP-F256 PIC S9(9) COMP-3 OCCURS 5.
01  RP-REC71.
    02 RP-KEY-R71.
      03 RP-F257 PIC 9(9). 03 RP-F258 PIC X(12). 03 PIC X(27).
01  RP-REC72.
    02 RP-KEY-R72.
      03 RP-F259 PIC 99. 03 RP-F260 PIC 99. 03 RP-F261 PIC X(4).
      03 RP-F261A PIC 9(6). 03 PIC X(34).
    02 RP-F262 PIC S9(5)V9 COMP-3. 02 RP-F263 PIC S9(5)V9 COMP-3 OCCURS 6.
01  RP-REC73.
    02 RP-KEY-R73.
      03 RP-F264 PIC 99. 03 RP-F265 PIC X(12). 03 RP-F267 PIC 9(4). 03 PIC X(30).
    02 RP-F268 PIC S9(7)V999 COMP-3.
01  RP-REC74.
    02 RP-KEY-R74.
      03 RP-F269 PIC X(12). 03 RP-F270 PIC 9(6). 03 RP-F270A PIC 9.
      03 RP-F271 PIC 999. 03 PIC X(26).
    02 RP-F272 PIC S9(9) COMP-3. 02 RP-F273 PIC S9(7)V999 COMP-3.
    02 RP-F274 PIC S9(9) COMP-3.
01  RP-REC75.
    02 RP-KEY-R75.
      03 RP-F275 PIC X(12). 03 RP-F276 PIC 9(6). 03 RP-F277 PIC 9(4). 03 PIC X(26).
    02 RP-F278 PIC S9(5) COMP-3. 02 RP-F279 PIC S9(5)V999 COMP-3.
    02 RP-F280 PIC S9(5) COMP-3.
01  RP-REC76.
    02 RP-KEY-R76.
      03 RP-F282 PIC 9. 03 RP-F283 PIC 99. 03 PIC X(45).
    02 RP-F284 PIC S9(9) COMP-3 OCCURS 4.
01  RP-REC77.
    02 RP-KEY-R77.
      03 RP-F285 PIC XXX. 03 RP-F286 PIC X(22). 03 PIC X(23).
01  RP-REC78.
    02 RP-KEY-R78.
      03 RP-F287 PIC X(30). 03 PIC X(18).
01  RP-REC79.
    02 RP-KEY-R79.
      03 RP-F288 PIC X(12). 03 RP-F289 PIC 9. 03 RP-F290 PIC 9(6). 03 PIC X(29).
    02 RP-F291 PIC 9(6) COMP-3. 02 RP-F292 PIC S9(9) COMP-3.
01  RP-REC80.
    02 RP-KEY-R80.
      03 RP-F293 PIC X(5). 03 RP-F294 PIC X(15). 03 PIC X(28).
01  RP-REC81.
    02 RP-KEY-R81.
      03 RP-F295 PIC 99. 03 RP-F296 PIC 9(6). 03 RP-F297 PIC X(28).
      03 RP-F297A PIC X(12).
01  RP-REC82.
    02 RP-KEY-R82.
      03 RP-F298 PIC 99. 03 RP-F299 PIC 99V99. 03 RP-F300 PIC X(6).
      03 RP-F301 PIC 9(6). 03 RP-F302 PIC 9(6). 03 RP-F303 PIC X(12).
      03 RP-F304 PIC 99. 03 PIC X(10).
    02 RP-F305 PIC S9(9) COMP-3. 02 RP-F306 PIC S9(7)V99 COMP-3.
    02 RP-F307 PIC 9 COMP-3.
01  RP-REC83.
    02 RP-KEY-R83.
      03 RP-F308 PIC X(10). 03 RP-F309 PIC X(12). 03 RP-F310 PIC X(8). 03 PIC X(18).
    02 RP-F312 PIC 9(6) COMP-3.
01  RP-REC84.
    02 RP-KEY-R84.
      03 RP-F313 PIC 9. 03 RP-F313A PIC 999. 03 RP-F314 PIC 9.
      03 RP-F315 PIC 9(6). 03 PIC X(37).
01  RP-REC85.
    02 RP-KEY-R85.
      03 RP-F316 PIC 9. 03 RP-F316A PIC 999. 03 RP-F317 PIC 9.
      03 RP-F318 PIC 9(6). 03 PIC X(37).
01  RP-REC86.
    02 RP-KEY-R86.
      03 RP-F320 PIC X(12). 03 RP-F321 PIC 9(6). 03 RP-F322 PIC 9(6). 03 PIC X(24).
    02 RP-F323 PIC S9(9) COMP-3.
01  RP-REC87.
    02 RP-KEY-R87.
      03 RP-F325 PIC X(12). 03 RP-F326 PIC 9(4). 03 PIC X(32).
    02 RP-F327 PIC S9(7)V999 COMP-3. 02 RP-F328 PIC S9(9) COMP-3.
01  RP-REC88.
    02 RP-KEY-R88.
      03 RP-F329 PIC 9. 03 RP-F329A PIC 9. 03 RP-F330 PIC X(24).
      03 RP-F331 PIC X(22).
01  RP-REC89.
    02 RP-KEY-R89.
      03 RP-F333 PIC 9. 03 RP-F334 PIC X(36). 03 RP-F335 PIC X(6). 03 PIC X(5).
    02 RP-F336 PIC 9(6). 02 RP-F337 PIC X(36).
01  RP-REC90.
    02 RP-KEY-R90.
      03 RP-F338 PIC X(10). 03 PIC X(38).
01  RP-REC91.
    02 RP-KEY-R91.
      03 RP-F339 PIC X(20). 03 RP-F340 PIC X(12). 03 PIC X(16).
01  RP-REC92.
    02 RP-KEY-R92.
      03 RP-F341 PIC 999. 03 RP-F342 PIC X(12). 03 PIC X(33).
    02 OCCURS 2. 03 RP-F344 PIC S9(7)V99 COMP-3.
      03 RP-F345 PIC S9(9) COMP-3. 03 RP-F346 PIC S9(7) COMP-3.
    02 OCCURS 3. 03 RP-F347 PIC 999 COMP-3. 03 RP-F348 PIC 9(4)V999 COMP-3.
01  RP-REC93.
    02 RP-KEY-R93.
      03 RP-F349 PIC 9. 03 RP-F350 PIC X(6). 03 RP-F351 PIC X(12). 03 PIC X(29).
    02 RP-F352 PIC S9(9) COMP-3. 02 RP-F353 PIC S9(9) COMP-3.
    02 RP-F354 PIC S9(7)V99 COMP-3.
01  RP-REC94.
    02 RP-KEY-R94.
      03 RP-F355 PIC 99. 03 RP-F356 PIC X(12). 03 RP-F357 PIC X(6).
      03 RP-F358 PIC 9(6). 03 RP-F359 PIC 9(8). 03 PIC X(14).
01  RP-REC95.
    02 RP-KEY-R95.
      03 RP-F360 PIC 999. 03 RP-F361 PIC X(12). 03 PIC X(33).
    02 RP-F362 PIC S9(7) COMP-3.
01  RP-REC96.
    02 RP-KEY-R96.
      03 RP-F363 PIC X(6). 03 RP-F364 PIC 9(6). 03 PIC X(36).
    02 RP-F365 PIC 9(6) COMP-3. 02 RP-F366 PIC S9(7)V99 COMP-3. 02 RP-F367 PIC 9 COMP-3.
01  RP-REC97.
    02 RP-KEY-R97.
      03 RP-F368 PIC 9. 03 RP-F368A PIC 9(9). 03 PIC X(38).
    02 RP-F369 PIC 9(4). 02 RP-F370 PIC S9(9) COMP-3. 02 RP-F371 PIC S9(9)V99 COMP-3.
    02 RP-F372 PIC S9(9)V99 COMP-3.
01  RP-REC98.
    02 RP-KEY-R98.
      03 RP-F373 PIC 99. 03 RP-F374 PIC X(12). 03 PIC X(34).
01  RP-REC99.
    02 RP-KEY-R99.
      03 RP-F375 PIC X(12). 03 RP-F376 PIC 9(5). 03 PIC X(31).
    02 RP-F378 PIC 9 COMP-3. 02 RP-F379 PIC S9(7)V99 COMP-3.
    02 RP-F380 PIC S9(7)V99 COMP-3.
01  RP-REC100.
    02 RP-KEY-R100.
      03 RP-F381 PIC 9. 03 RP-F382 PIC 9(9). 03 RP-F383 PIC X(12). 03 PIC X(26).
    02 RP-F384 PIC S9(9) COMP-3. 02 RP-F385 PIC S9(9) COMP-3.
    02 RP-F386 PIC S9(7)V99 COMP-3.
01  RP-REC101.
    02 RP-KEY-R101.
      03 RP-F387 PIC X(12). 03 RP-F388 PIC 9. 03 RP-F389 PIC 9V9(4).
      03 RP-F390 PIC 9. 03 RP-F391 PIC 99. 03 RP-F392 PIC 9(6).
      03 RP-F393 PIC X(12). 03 RP-F394 PIC X(6). 03 PIC XXX.
01  RP-REC102.
    02 RP-KEY-R102.
      03 RP-F396 PIC 99. 03 RP-F397 PIC 99. 03 RP-F398 PIC 9(4).
      03 RP-F399 PIC X(12). 03 PIC X(28).
    02 RP-F400 PIC 9 COMP-3. 02 RP-F401 PIC S9(7)V999 COMP-3.
    02 RP-F402 PIC S9(9) COMP-3. 02 RP-F403 PIC S9(9) COMP-3.
    02 RP-F404 PIC X(10). 02 RP-F405 PIC X(32). 02 RP-F406 PIC S9(7)V999 COMP-3.
01  RP-REC103.
    02 RP-KEY-R103.
      03 RP-F407 PIC 9. 03 RP-F408 PIC X(12). 03 RP-F409 REDEFINES RP-F408 PIC 9.
      03 RP-F410 PIC X(12). 03 PIC X(23).
    02 RP-F411 PIC S9(7)V999 COMP-3. 02 RP-F412 PIC S9(9) COMP-3.
    02 RP-F413 PIC S9(9) COMP-3. 02 RP-F414 PIC X(12). 02 RP-F415 PIC X(32).
01  RP-REC104.
    02 RP-KEY-R104.
      03 RP-F416 PIC 99. 03 RP-F417 PIC 99. 03 RP-F418 PIC 9. 03 RP-F419 PIC 999.
      03 PIC X(40).
    02 RP-F421 PIC X(30). 02 RP-F422 PIC X(30). 02 RP-F423 PIC S9(7)V99 COMP-3.
01  RP-REC105.
    02 RP-KEY-R105.
      03 RP-F424 PIC 9(6). 03 PIC X(42).
    02 RP-F425 PIC 9(6) COMP-3. 02 RP-F426 PIC 9 COMP-3. 02 RP-F427 PIC S9(7)V99 COMP-3.
    02 RP-F428 PIC S9(9) COMP-3. 02 RP-F429 PIC S9(9) COMP-3.
01  RP-REC106.
    02 RP-KEY-R106.
      03 RP-F431 PIC 99. 03 RP-F432 PIC 9(6). 03 PIC X(40).
    02 RP-F433 PIC 9(6) COMP-3. 02 RP-F434 PIC X(12). 02 RP-F435 PIC S9(7) COMP-3.
    02 RP-F436 PIC S9(7) COMP-3. 02 RP-F437 PIC S999V99 COMP-3 OCCURS 9.
01  RP-REC107.
    02 RP-KEY-R107.
      03 RP-F440 PIC X(12). 03 RP-F441 PIC 999. 03 RP-F442 PIC 9(6).
      03 RP-F443 PIC 9(6). 03 RP-F444 PIC 99. 03 PIC X(19).
    02 RP-F445 PIC S9(9) COMP-3. 02 RP-F446 PIC 99 COMP-3.
01  RP-REC108.
    02 RP-KEY-R108.
      03 RP-F448 PIC 999. 03 RP-F449 PIC X(6). 03 PIC X(39).
    02 RP-F450 PIC 9(6) COMP-3.
01  RP-REC109.
    02 RP-KEY-R109.
      03 RP-F452 PIC X(15). 03 PIC X(33).
    02 RP-F453 PIC 9(4) COMP-3. 02 RP-F454 PIC 9(6) COMP-3. 02 RP-F455 PIC S9(9) COMP-3.
    02 RP-F456 PIC S9(9) COMP-3. 02 RP-F457 PIC S9(7)V99 COMP-3.
01  RP-REC110.
    02 RP-KEY-R110.
      03 RP-F460 PIC 99. 03 RP-F461 PIC 999. 03 PIC X(43).
    02 RP-F462 PIC S9(9) COMP-3. 02 RP-F463 PIC S9(9) COMP-3.
    02 RP-F464 PIC S9(9) COMP-3.
01  RP-REC111.
    02 RP-KEY-R111.
      03 RP-F466 PIC X(6). 03 RP-F467 PIC 9(6). 03 RP-F468 PIC 999. 03 PIC X(33).
    02 RP-F469 PIC S9(7)V99 COMP-3. 02 RP-F470 PIC S9V99 COMP-3.
    02 RP-F471 PIC XXX. 02 RP-F472 PIC 9(6) COMP-3. 02 RP-F473 PIC 9 COMP-3.
01  RP-REC112.
    02 RP-KEY-R112.
      03 RP-F475 PIC 9(6). 03 RP-F476 PIC 9(6). 03 RP-F477 PIC X(32). 03 PIC X(4).

FD  SORTFL VALUE OF ID SORT-ID BLOCK 2048.
01  SR-RECORD PIC X(115).
01  SR-REC.
    02 SR-KEY PIC X(30).
*      FILLER X(85)
01  SR-REC1.
    02 SR-KEY-R1.
      03 SR-F1 PIC X(5). 03 PIC X(25).
    02 SR-F2 PIC S9(7) COMP-3.
01  SR-REC2.
    02 SR-KEY-R2.
      03 SR-F3 PIC X(12). 03 PIC X(18).
01  SR-REC3.
    02 SR-KEY-R3.
      03 SR-F4 PIC 9(6). 03 PIC X(24).
    02 SR-F5 PIC S9(9) COMP-3.
01  SR-REC4.
    02 SR-KEY-R4.
      03 SR-F6. 04 SR-F6A PIC 9(18). 04 SR-F6B PIC 99.
      03 SR-F7 PIC 99. 03 PIC X(8).
    02 SR-F8 PIC X(25). 02 SR-F9 PIC S9(9)V99 COMP-3.
01  SR-REC5.
    02 SR-KEY-R5.
      03 SR-F10 PIC X(12). 03 PIC X(18).
    02 SR-F11 PIC X.
01  SR-REC6.
    02 SR-KEY-R6.
      03 SR-F13 PIC X(12). 03 PIC X(18).
01  SR-REC7.
    02 SR-KEY-R7.
      03 SR-F14 PIC 999. 03 SR-F15 PIC 9(6). 03 SR-F16 PIC 9(4). 03 PIC X(17).
    02 SR-F17 PIC S9(9) COMP-3. 02 SR-F18 PIC S9(9) COMP-3. 02 SR-F19 PIC S9(4)V9 COMP-3.
    02 SR-F20 PIC 9(4)V99 COMP-3. 02 SR-F20A PIC X(50). 02 SR-F20B PIC 9 COMP-3.
01  SR-REC8.
    02 SR-KEY-R8.
      03 SR-F21 PIC X(12). 03 SR-F22 PIC 9. 03 SR-F23 PIC 9(4). 03 PIC X(13).
    02 SR-F24 PIC S9(9) COMP-3.
01  SR-REC9.
    02 SR-KEY-R9.
      03 SR-F25 PIC 9. 03 SR-F25A PIC 99. 03 SR-F25B PIC 999. 03 PIC X(25).
    02 SR-F26 PIC S9(9)V99 COMP-3 OCCURS 2.
01  SR-REC10.
    02 SR-KEY-R10.
      03 SR-F27 PIC 9. 03 SR-F28 PIC X(12).
      03 SR-F29. 04 SR-F30 PIC 9(6). 04 SR-F30A PIC 9(6). 04 PIC XX.
      03 REDEFINES SR-F29. 04 SR-F31 PIC X(10). 04 SR-F32 PIC 9(4).
      03 PIC XXX.
    02 SR-F33 PIC S9(9) COMP-3. 02 SR-F34 PIC X(6). 02 SR-F34A PIC 9 COMP-3.
01  SR-REC11.
    02 SR-KEY-R11.
      03 SR-F35 PIC 9(4). 03 SR-F36 PIC X(8). 03 SR-F36A REDEFINES SR-F36 PIC 99.
      03 PIC X(18).
    02 SR-F37 PIC S9(9) COMP-3. 02 SR-F37A PIC S9(9) COMP-3. 02 SR-F37B PIC S9(9)V99 COMP-3.
01  SR-REC12.
    02 SR-KEY-R12.
      03 SR-F38 PIC X(12). 03 SR-F39 PIC X(12). 03 PIC X(6).
    02 SR-F40 PIC X(32).
01  SR-REC13.
    02 SR-KEY-R13.
      03 SR-F42 PIC 99. 03 PIC X(28).
    02 SR-F43 PIC S9(9) COMP-3. 02 SR-F44 PIC S9(9) COMP-3.
01  SR-REC14.
    02 SR-KEY-R14.
      03 SR-F45. 04 SR-F45A PIC X(10). 04 SR-F45B PIC X(12).
      03 SR-F46 PIC 9(6). 03 SR-F47 PIC 9. 03 PIC X.
    02 SR-F48 PIC X. 02 SR-F49 PIC 9(6) COMP-3. 02 SR-F50 PIC S9(7) COMP-3.
01  SR-REC15.
    02 SR-KEY-R15.
      03 SR-F51 PIC 9. 03 SR-F51A PIC 99. 03 SR-F52 PIC 9(8).
      03 SR-F53 PIC X(12). 03 PIC X(7).
    02 SR-F54 PIC X(32). 02 SR-F55 PIC 99. 02 SR-F56 PIC 9(6).
01  SR-REC16.
    02 SR-KEY-R16.
      03 SR-F57 PIC 99. 03 SR-F58 PIC 99. 03 PIC X(26).
    02 SR-F59 PIC S9(5) COMP-3.
01  SR-REC17.
    02 SR-KEY-R17.
      03 SR-F60 PIC X(12). 03 SR-F61 PIC 9(5). 03 PIC X(13).
    02 SR-F62 PIC 9(6) COMP-3. 02 SR-F63 PIC S9(7)V99 COMP-3. 02 SR-F64 PIC XX.
    02 SR-F65 PIC 9 COMP-3. 02 SR-F65A PIC X(60).
01  SR-REC18.
    02 SR-KEY-R18.
      03 SR-F66 PIC 9. 03 SR-F67 PIC 99. 03 SR-F68 PIC X(12).
      03 SR-F69 PIC 9(6). 03 SR-F70 PIC 9(6). 03 SR-F70A PIC 99. 03 PIC X.
    02 SR-F71 PIC 9(9) COMP-3. 02 SR-F71A PIC 9(9) COMP-3. 02 SR-F71B PIC X(32).
01  SR-REC19.
    02 SR-KEY-R19.
      03 SR-F72. 04 SR-F73 PIC X(12). 04 SR-F74 PIC X.
      03 SR-F75 PIC 9(6). 03 SR-F75A PIC X(10). 03 SR-F76 PIC 9.
01  SR-REC20.
    02 SR-KEY-R20.
      03 SR-F77 PIC 9(6). 03 SR-F78 PIC 999. 03 SR-F79 PIC 9(6).
      03 SR-F80 PIC 99. 03 PIC X(13).
    02 SR-F81 PIC X(12). 02 SR-F82 PIC S9(9) COMP-3. 02 SR-F82A PIC 9 COMP-3.
01  SR-REC21.
    02 SR-KEY-R21.
      03 SR-F83 PIC X(12). 03 SR-F84 PIC X(8). 03 SR-F85 PIC 99. 03 PIC X(8).
01  SR-REC22.
    02 SR-KEY-R22.
      03 SR-F87 PIC X(12). 03 PIC X(18).
    02 SR-F88 PIC S9(9) COMP-3. 02 SR-F89 PIC S9(9) COMP-3. 02 SR-F90 PIC S9(9)V99 COMP-3.
01  SR-REC23.
    02 SR-KEY-R23.
      03 SR-F91 PIC 9(4). 03 PIC X(26).
01  SR-REC24.
    02 SR-KEY-R24.
      03 SR-F92 PIC 9. 03 PIC X(29).
    02 SR-F93 PIC S9(9) COMP-3. 02 SR-F94 PIC S9(9) COMP-3.
01  SR-REC25.
    02 SR-KEY-R25.
      03 SR-F95 PIC 9(6). 03 SR-F95A PIC X(12). 03 PIC X(12).
    02 SR-F96 PIC S9(5) COMP-3.
01  SR-REC26.
    02 SR-KEY-R26.
      03 SR-F97 PIC X(15). 03 PIC X(15).
    02 SR-F98 PIC X(6). 02 SR-F99 PIC S9(9) COMP-3 OCCURS 3.
01  SR-REC27.
    02 SR-KEY-R27.
      03 SR-F100 PIC 9(6). 03 PIC X(24).
01  SR-REC28.
    02 SR-KEY-R28.
      03 SR-F101 PIC X(10). 03 SR-F102 PIC X(12). 03 PIC X(8).
01  SR-REC29.
    02 SR-KEY-R29.
      03 SR-F103 PIC X(12). 03 SR-F104 PIC 99. 03 PIC X(16).
    02 OCCURS 2. 03 SR-F105 PIC S9(9) COMP-3. 03 SR-F106 PIC S9(9) COMP-3.
01  SR-REC30.
    02 SR-KEY-R30.
      03 SR-F107 PIC 99. 03 SR-F108 PIC 99. 03 SR-F109 PIC 9(4). 03 PIC X(22).
    02 SR-F110 PIC S9(9) COMP-3. 02 SR-F111 PIC S9(9)V99 COMP-3. 02 SR-F112 PIC X(10).
01  SR-REC31.
    02 SR-KEY-R31.
      03 SR-F113 PIC 99. 03 SR-F114 PIC 99. 03 SR-F115 PIC 9(4). 03 PIC X(22).
    02 SR-F116 PIC S9(9) COMP-3. 02 SR-F117 PIC S9(9) COMP-3. 02 SR-F118 PIC S9(7)V99 COMP-3.
    02 SR-F119 PIC S9(7)V99 COMP-3. 02 SR-F120 PIC X(10).
01  SR-REC32.
    02 SR-KEY-R32.
      03 SR-F121 PIC 9. 03 SR-F122 PIC 99. 03 PIC X(27).
    02 SR-F123 PIC S9(9) COMP-3 OCCURS 3.
01  SR-REC33.
    02 SR-KEY-R33.
      03 SR-F124 PIC 999. 03 PIC X(27).
    02 OCCURS 2. 03 SR-F125 PIC S9(9)V99 COMP-3 OCCURS 2.
01  SR-REC34.
    02 SR-KEY-R34.
      03 SR-F127 PIC 9(4). 03 PIC X(26).
    02 SR-F128 PIC S9(9) COMP-3. 02 SR-F129 PIC S9(9)V99 COMP-3.
    02 SR-F130 PIC S9(9)V99 COMP-3.
01  SR-REC35.
    02 SR-KEY-R35.
      03 SR-F131 PIC 99. 03 SR-F132 PIC X(12). 03 PIC X(16).
    02 SR-F133X. 03 SR-F133 PIC S9(9) COMP-3 OCCURS 5.
01  SR-REC36.
    02 SR-KEY-R36.
      03 SR-F134 PIC XX. 03 SR-F135 PIC 9(6). 03 SR-F136 PIC 9(8). 03 PIC X(14).
01  SR-REC37.
    02 SR-KEY-R37.
      03 SR-F137 PIC 9(7). 03 SR-F138 PIC 9(5). 03 PIC X(18).
    02 SR-F139 PIC S9(7)V99 COMP-3.
01  SR-REC38.
    02 SR-KEY-R38.
      03 SR-F140 PIC X(8). 03 SR-F141 PIC X(12). 03 SR-F142 PIC 9(6). 03 PIC X(4).
    02 SR-F143 PIC S999 COMP-3. 02 SR-F144 PIC S9(9) COMP-3. 02 SR-F145 PIC X(26).
    02 SR-F146 PIC S999 COMP-3. 02 SR-F147 PIC S9(9) COMP-3. 02 SR-F148 PIC 99 COMP-3.
    02 SR-F149 PIC 9 COMP-3.
01  SR-REC39.
    02 SR-KEY-R39.
      03 SR-F150 PIC X(12). 03 PIC X(18).
    02 SR-F151 PIC S9(9) COMP-3. 02 SR-F152 PIC S9(9) COMP-3. 02 SR-F153 PIC S9(7)V99 COMP-3.
01  SR-REC40.
    02 SR-KEY-R40.
      03 SR-F154 PIC 99. 03 PIC X(28).
    02 SR-F155 PIC S9(9) COMP-3. 02 SR-F156 PIC S9(9) COMP-3.
01  SR-REC41.
    02 SR-KEY-R41.
      03 SR-F157 PIC 9(7). 03 SR-F158 PIC X(8). 03 PIC X(15).
    02 SR-F159 PIC S9(7) COMP-3. 02 SR-F160 PIC S9(7)V99 COMP-3.
    02 SR-F161 PIC 9(6) COMP-3. 02 SR-F162 PIC X(12). 02 SR-F163 PIC X(20).
01  SR-REC42.
    02 SR-KEY-R42.
      03 SR-F164 PIC X(12). 03 PIC X(18).
    02 SR-F165 PIC S9(9) COMP-3. 02 SR-F166 PIC S9(9) COMP-3. 02 SR-F167 PIC S9(7)V99 COMP-3.
    02 SR-F168X. 03 SR-F168 PIC X(6) OCCURS 5.
01  SR-REC43.
    02 SR-KEY-R43.
      03 SR-F169 PIC 999. 03 PIC X(27).
    02 SR-F170 PIC S9(7) COMP-3.
01  SR-REC44.
    02 SR-KEY-R44.
      03 SR-F172 PIC X(12). 03 PIC X(18).
01  SR-REC45.
    02 SR-KEY-R45.
      03 SR-F173 PIC 9(6). 03 PIC X(24).
    02 SR-F174 PIC S9(7) COMP-3.
01  SR-REC46.
    02 SR-KEY-R46.
      03 SR-F175 PIC X(12). 03 PIC X(18).
01  SR-REC47.
    02 SR-KEY-R47.
      03 SR-F176 PIC X(12). 03 SR-F177 PIC 99. 03 PIC X(16).
    02 SR-F178 PIC S9(9) COMP-3. 02 SR-F179 PIC S9(9) COMP-3.
01  SR-REC48.
    02 SR-KEY-R48.
      03 SR-F181 PIC X(6). 03 SR-F182 REDEFINES SR-F181 PIC 9(6).
      03 SR-F183 PIC X(12). 03 SR-F184 PIC 9(6). 03 PIC X(6).
    02 SR-F185 PIC S9(9) COMP-3. 02 SR-F186 PIC S9(9) COMP-3.
    02 SR-F187 PIC S9(9)V99 COMP-3. 02 SR-F188 PIC S9(5)V99 COMP-3.
    02 SR-F189 PIC 99 COMP-3. 02 SR-F190 PIC 9(6) COMP-3. 02 SR-F191 PIC 9(6) COMP-3.
    02 SR-F192 PIC 9(6) COMP-3. 02 SR-F193 PIC S9(5)V99 COMP-3.
    02 SR-F194 PIC 9 COMP-3. 02 SR-F195 PIC S9(9) COMP-3. 02 SR-F196 PIC X(12).
01  SR-REC49.
    02 SR-KEY-R49.
      03 SR-F198 PIC 9. 03 SR-F199 PIC X(12). 03 SR-F200 PIC 9.
      03 SR-F201 PIC 9V9(4). 03 PIC X(11).
    02 SR-F202 PIC S9(7) COMP-3.

FD  SORCFL VALUE OF ID SORC-ID BLOCK 2048.
01  SC-RECORD PIC X(115).
01  SC-REC.
    02 SC-KEY PIC X(30).
*      FILLER X(85)
01  SC-REC1.
    02 SC-KEY-R1.
      03 SC-F1 PIC 9(4). 03 SC-F2 PIC 9(7). 03 PIC X(19).
01  SC-REC2.
    02 SC-KEY-R2.
      03 SC-F3 PIC 99. 03 PIC X(28).
    02 SC-F4 PIC S9(9) COMP-3. 02 SC-F5 PIC S9(9) COMP-3.
01  SC-REC3.
    02 SC-KEY-R3.
      03 SC-F6 PIC X(6). 03 PIC X(24).
    02 SC-F7 PIC S9(9) COMP-3. 02 SC-F8 PIC S9(9) COMP-3. 02 SC-F9 PIC S9(9)V99 COMP-3.
    02 SC-F10 PIC S9(9)V99 COMP-3. 02 SC-F11 PIC S9(9)V99 COMP-3.
    02 SC-F12 PIC S9(9)V99 COMP-3.
01  SC-REC4.
    02 SC-KEY-R4.
      03 SC-F13 PIC X(12). 03 SC-F14 PIC X(12). 03 PIC X(6).
    02 SC-F15 PIC 99 COMP-3 OCCURS 4.
    02 OCCURS 2. 03 SC-F16 PIC S9(9) COMP-3. 03 SC-F17 PIC S9(9) COMP-3.

FD  PRINTFL VALUE OF ID PR-ID.
01  PREC PIC X(132).
01  PREC2.
    02 FA7 PIC ZZ9. 02 FA8 PIC X. 02 FA9 PIC ZZ9. 02 FA10 PIC BBX(25).
01  PREC3.
    02 FA11 PIC X(13). 02 FA12 PIC X(15). 02 FA13 PIC X(26).
    02 FA14 PIC Z(5),ZZ9-. 02 FA15 PIC Z(5),ZZ9-. 02 FA15A PIC ZZZ.
    02 FA16 PIC Z(5),ZZ9-. 02 FA16A PIC Z(4)9. 02 FA17 PIC Z(4),ZZ9-.
    02 FA17A PIC 9. 02 FA18 PIC ZZ,ZZ9.999. 02 FA19 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA20 PIC BBX. 02 FA21 PIC BBX.
01  PREC4.
    02 OCCURS 5. 03 FA22 PIC X(8). 03 FA23 PIC BX(17).
01  PREC5.
    02 FA24 PIC X(9). 02 FA25 PIC X(12). 02 FA25A PIC Z9. 02 FA26 PIC BBBX(32).
    02 FA27 PIC ZZZ,ZZZ,ZZ9-. 02 FA28 PIC BB99/99/99. 02 FA29 PIC ZZZ,ZZ9-.
    02 FA30 PIC BBX(10).
01  PREC6.
    02 FA31 PIC Z99. 02 FA32 PIC 9(4).
01  PREC7.
    02 FA33 PIC BX(40).
01  PREC8.
    02 PIC X(33). 02 FA34 PIC X(20).
01  PREC9.
    02 PIC X(59). 02 FA36 PIC 99/99/99. 02 FA37 REDEFINES FA36 PIC X(8).
    02 FA37A PIC BBBX(4). 02 FA37B PIC ZZ9.
01  PREC10.
    02 FA38 PIC BX(40). 02 FA39 PIC X(15).
01  PREC11.
    02 FA40 PIC B(15)X(50).
01  PREC12.
    02 FA41 PIC BX(79).
01  PREC13.
    02 FA43 PIC Z(7)9-. 02 FA43A REDEFINES FA43 PIC X(9). 02 FA44 PIC X(4).
    02 FA45 PIC BBX(14). 02 FA46 PIC X(35). 02 FA47 PIC ZZZ,ZZ9.999. 02 FA48 PIC BX(4).
01  PREC14.
    02 FA52 PIC X(40). 02 FA53 PIC Z(4),ZZ9.
01  PREC15.
    02 FA57 PIC X(16). 02 FA58 PIC X(10) OCCURS 11.
01  PREC16.
    02 FA59 PIC X(10) OCCURS 13.
01  PREC17.
    02 FA60 PIC XXX. 02 FA61 PIC ZZZ9. 02 FA62 PIC BBX(45).
01  PREC18.
    02 FA63 PIC X(12). 02 FA64 PIC ZZ9. 02 FA65 PIC BBX(36).
01  PREC19.
    02 PIC X(45). 02 FA66 PIC X(7). 02 FA67 PIC Z9. 02 FA68 PIC X.
01  PREC20.
    02 FA69 PIC X(10). 02 FA70 PIC BBX(12). 02 FA71 PIC Z(7)9.
    02 OCCURS 4. 03 FA72 PIC Z(9),ZZ9+. 03 FA73 PIC BX. 03 FA74 PIC Z99/99/99.
01  PREC21.
    02 FA75 PIC XXX. 02 FA75A PIC ZZZ9. 02 FA75B PIC BBX(45).
01  PREC22.
    02 FA76 PIC ZZ9. 02 FA76A PIC X. 02 FA77 PIC ZZ9. 02 FA78 PIC BBX(25).
01  PREC23.
    02 FA79 PIC X(12). 02 FA80 PIC BBX(32). 02 FA81 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA82 PIC Z(4),ZZ9.99-. 02 FA83 PIC Z,ZZZ,ZZ9-. 02 FA84 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA85 PIC ZZ,ZZZ,ZZ9.99-. 02 FA86 PIC ZZ,ZZZ,ZZ9.99-. 02 FA86A PIC Z(4)9-.
    02 FA86B PIC BX.
01  PREC24.
    02 FA87 PIC X(14). 02 FA88 PIC BBX(12). 02 FA89 PIC B(6)X(12).
    02 FA90 PIC B(4)X(6). 02 FA91 PIC Z(5)9-. 02 FA92 PIC BB99/99/99.
01  PREC25.
    02 FA94 PIC X(32). 02 FA95 PIC BBX(14). 02 FA96 PIC X(32).
01  PREC26.
    02 OCCURS 8. 03 FA97 PIC X. 03 FA98 PIC X(8). 03 FA99 PIC 9. 03 PIC X(6).
01  PREC27.
    02 FA100 PIC ZZZ9. 02 FA101 PIC BX(15). 02 FA103 PIC Z99/99/99.
    02 FA104 PIC Z99/99/99. 02 FA105 PIC Z99/99/99. 02 FA106 PIC Z(7).
    02 FA106A PIC BX(17). 02 FA107X. 03 FA107 PIC B9(6)B999B99B9(7).
    02 FA108 PIC ZZ,ZZZ,ZZ9.99-. 02 FA109 PIC X. 02 FA110 PIC XX.
    02 FA110A PIC Z9.9(4). 02 FA111 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC28.
    02 FA112 PIC X(36).
01  PREC29.
    02 FA113 PIC ZZZ9. 02 FA114 PIC BBX(36).
01  PREC30.
    02 PIC X(12). 02 FA115 PIC X(15). 02 FA116 PIC ZZZ99/99/99.
    02 FA117 PIC ZZ99/99/99. 02 FA118 PIC Z(7)9. 02 FA119 PIC ZZZ,ZZZ,ZZ9.99-.
    02 FA120 PIC Z(4),ZZ9.99-. 02 FA121 PIC ZZZ,ZZZ,ZZ9.99-. 02 FA122 PIC X.
    02 FA123 PIC XX.
01  PREC31.
    02 FA124 PIC X(6). 02 FA125 PIC X(10). 02 FA126 PIC Z(7),ZZ9.99-.
    02 FA127 PIC X. 02 FA128 PIC XX.
01  PREC32.
    02 FA129 PIC X(16). 02 FA130 PIC ZZ9. 02 FA130A PIC BBX(45).
01  PREC33.
    02 FA131 PIC ZZZ9. 02 FA132 PIC BBX(36). 02 FA133 PIC ZZ.ZZ.
    02 FA133A REDEFINES FA133 PIC BBXXX. 02 FA134 PIC Z(6),ZZ9.99- OCCURS 2.
    02 PIC X(6). 02 FA135 PIC Z(5),ZZ9- OCCURS 4. 02 FA136 PIC ZZZ99/99/99.
01  PREC34.
    02 FA138 PIC ZZZ9. 02 FA139 PIC BBX(36). 02 FA140 PIC Z(8)9.
    02 FA141 PIC BBBX(10). 02 FA142 PIC ZZZ,ZZZ,ZZ9.99- OCCURS 3.
01  PREC35.
    02 FA143 PIC ZZZ9. 02 FA143A PIC BXB. 02 FA143B PIC ZZZ9.
    02 FA144 PIC BBBX. 02 FA144A REDEFINES FA144 PIC ZZZ9.
    02 FA145 PIC B(7)99/99/99. 02 FA146 PIC B(4)99/99/99.
01  PREC36.
    02 FA147 PIC X(6). 02 FA148 PIC ZZ99. 02 FA149 PIC B(5)X(40).
01  PREC37.
    02 FA150 PIC Z9. 02 FA151 PIC BBBX(30). 02 FA151A PIC Z(4)9.99.
01  PREC38.
    02 FA152 PIC 9(6)B999B99B9(7). 02 FA153 PIC BBX(25).
    02 FA154 PIC ZZZ,ZZZ,ZZ9.99-. 02 FA155 PIC ZZZ,ZZZ,ZZ9-. 02 FA156 PIC XXX.
01  PREC39.
    02 PIC X(49). 02 FA157 PIC ZZZ9. 02 FA158 PIC BX(36). 02 FA159 PIC BX.
    02 FA160 PIC BX(15). 02 FA161 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC40.
    02 FA163 PIC 9(6).
01  PREC41.
    02 FA164 PIC 9(6)B999.
01  PREC42.
    02 FA173 PIC 9(6)B999B99B9(7). 02 FA174 PIC B(4)X(29).
    02 FA175 PIC 9(6)B9(6)B9(4)B99.
01  PREC43.
    02 FA176 PIC Z(5)9. 02 FA177 PIC ZZ99/99/99. 02 FA178 PIC Z(4),ZZZ,ZZ9.99-.
    02 FA179 PIC Z(4),ZZZ,ZZ9-. 02 FA180 PIC Z(4),ZZZ,ZZ9-.
01  PREC44.
    02 FA182 PIC X(7). 02 FA183 PIC ZZZ9. 02 FA184 PIC BBX(36).
01  PREC45.
    02 FA185 PIC X(8). 02 FA186 PIC Z99/99/99. 02 FA187 PIC Z99/99/99.
    02 FA188 PIC ZZZ,ZZZ,ZZ9-. 02 FA188A PIC ZZ,ZZZ,ZZ9-. 02 FA189 PIC BX(6).
    02 FA190 PIC X(13). 02 FA191 PIC X(32). 02 FA192 PIC Z(4),ZZ9.999.
    02 FA193 PIC BX(4). 02 FA194 PIC Z(4),ZZ9.99.
01  PREC46.
    02 FA195 PIC X(17). 02 FA196 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC47.
    02 FA197 PIC X(8). 02 FA198 PIC 9(4). 02 FA199 PIC B(26)X(13).
    02 FA200 PIC X(12). 02 FA201 PIC B(10)X(5). 02 FA202 PIC Z9.
01  PREC48.
    02 FA203 PIC X(49). 02 FA204 PIC X(10). 02 FA205 PIC X(15).
    02 FA206 REDEFINES FA205 PIC 99/99/99.
01  PREC49.
    02 FA207 PIC X(7). 02 FA208 PIC X(8).
01  PREC50.
    02 PIC X(14). 02 FA209 PIC X(45).
01  PREC51.
    02 FA210 PIC Z(4),ZZ9-. 02 FA211 REDEFINES FA210 PIC ZZZ9.999-.
    02 FA212 PIC X(5). 02 FA213 PIC X(32).
    02 REDEFINES FA213. 03 FA214 PIC X(12). 03 FA215 PIC B(6)X(5). 03 FA216 PIC X(9).
    02 REDEFINES FA213. 03 FA217 PIC X(12). 03 FA218 PIC Z(7)9. 03 FA219 PIC X.
      03 FA220 PIC X. 03 FA221 PIC ZZ9(7).
    02 REDEFINES FA213. 03 FA222 PIC 999. 03 FA223 PIC BX(28).
    02 REDEFINES FA213. 03 FA224 PIC X(8). 03 FA225 PIC BX(23).
    02 FA226 PIC Z(4),ZZ9.999. 02 FA227 PIC BX(4). 02 FA228 PIC Z(5),ZZ9.99-.
    02 FA229 PIC X(4).
01  PREC52.
    02 PIC X(49). 02 FA230 PIC X(5). 02 FA230A PIC 9(6)B999B99B9(7).
01  PREC53.
    02 FA231 PIC X(9). 02 FA232 PIC Z9. 02 FA233 PIC BBX(45).
    02 FA234 PIC B(10)X(9). 02 FA235 PIC X(32). 02 PIC X(12). 02 FA236 PIC X(11).
01  PREC54.
    02 FA237 PIC X(5). 02 FA238 PIC BBX(12). 02 FA239 PIC BBX(32).
    02 FA240 PIC Z(4)9. 02 FA241 PIC ZZZ,ZZ9. 02 FA242 PIC Z(6),ZZ9.
    02 FA243 PIC ZZZ,ZZZ,ZZ9. 02 FA244 PIC Z(6),ZZ9. 02 FA244A PIC B(5)X.
01  PREC55.
    02 FA245 PIC X(8). 02 FA246 PIC BBX(12). 02 FA247 PIC BBX(32).
    02 FA248 PIC Z(4),ZZZ-. 02 FA249 PIC Z(4)9. 02 FA250 PIC Z(6)9-.
    02 FA250A PIC BBX(10).
01  PREC56.
    02 FA251 PIC X(39). 02 FA252 PIC B(15)X(55). 02 FA253 PIC B(12)X(11).
01  PREC57.
    02 FA255 PIC 9(6)B999B99B9(7). 02 FA256 PIC BBX(25).
    02 FA257 PIC ZZZ,ZZZ,ZZ9-. 02 FA258 PIC ZZZ,ZZZ,ZZ9.99-. 02 FA259 PIC XXX.
    02 FA260 PIC BBBX(12). 02 FA261 PIC ZZZ9. 02 FA262 PIC Z(6)9.
01  PREC58.
    02 FA263 PIC X(18). 02 FA264 PIC ZZ9(6) OCCURS 10.
01  PREC59.
    02 PIC X(7). 02 FA265 PIC ZZ9. 02 FA266 PIC BBX(30).
01  PREC60.
    02 FA267 PIC X(6). 02 FA268 PIC 99/99/99.
01  PREC61.
    02 FA269 PIC B(9)X(8). 02 PIC X(17). 02 FA270 PIC X(16). 02 PIC X(16).
    02 FA270A PIC ZZZ,ZZ9.999.
01  PREC62.
    02 FA271 PIC BX(20). 02 FA272 PIC Z(9)9-. 02 FA272A REDEFINES FA272 PIC B(4)X(7).
    02 PIC X(14). 02 FA273 PIC X(32).
01  PREC63.
    02 PIC X(55). 02 FA274 PIC X(15). 02 FA275 PIC 99/99/99.
01  PREC64.
    02 PIC X(12). 02 FA276 PIC Z9. 02 PIC X(11). 02 FA277 PIC 99/99/99.
01  PREC65.
    02 FA278 PIC B(11)ZZ9. 02 FA279 PIC BBX(45). 02 FA280 PIC Z(5),ZZ9- OCCURS 2.
01  PREC66.
    02 FA281 PIC X(14). 02 FA282 PIC BBX(12). 02 FA283 PIC B(6)X(12).
    02 FA284 PIC B(15)X(12). 02 FA285 PIC ZZZ9. 02 FA286 PIC B(5)X(20).
01  PREC67.
    02 FA287 PIC X(9). 02 FA288 PIC BX(11). 02 FA289 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA290. 03 FA290A PIC ZZ,ZZZ,ZZ9-. 03 FA290B PIC ZZ9.99-.
    02 REDEFINES FA290. 03 FA290C PIC ZZZ,ZZ9-. 03 FA290D PIC ZZ,ZZ9.99-.
    02 FA291 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA292. 03 FA292A PIC ZZ,ZZZ,ZZ9-. 03 FA292B PIC ZZ9.99-.
    02 REDEFINES FA292. 03 FA292C PIC ZZZ,ZZ9-. 03 FA292D PIC ZZ,ZZ9.99-.
    02 FA293 PIC ZZ9.9-. 02 FA294 PIC ZZZ,ZZZ,ZZ9.99-.
    02 FA295. 03 FA295A PIC ZZZ,ZZZ,ZZ9-. 03 FA295B PIC ZZ9.99-.
    02 REDEFINES FA295. 03 FA295C PIC Z(4),ZZ9-. 03 FA295D PIC ZZ,ZZ9.99-.
    02 FA296 PIC ZZ9.9-.
01  PREC68.
    02 FA297 PIC X(15). 02 FA298 PIC ZZ9. 02 FA299 PIC Z(5)9.
01  PREC69.
    02 PIC X(5). 02 FA302 PIC X(16).
01  PREC70.
    02 FA303 PIC X(46). 02 FA304 PIC XXX.
01  PREC71.
    02 FA305 PIC X(12). 02 FA306 PIC ZZZ9. 02 FA307 PIC Z(6)9.999.
    02 FA308 PIC Z(8)9.999. 02 FA309 PIC Z(8)9.999. 02 PIC X(4).
    02 FA310 PIC BXX OCCURS 10.
01  PREC72.
    02 FA311 PIC ZZZ9. 02 FA312 PIC BBX(36).
01  PREC73.
    02 FA313 PIC ZZZ9. 02 FA314 PIC BBX(36).
01  PREC74.
    02 PIC X(42). 02 FA315 PIC BBX(8). 02 FA316 PIC Z(4),ZZZ,ZZ9-.
    02 FA317 PIC Z(4),ZZZ,ZZ9.99-. 02 FA318 PIC Z(4),ZZZ,ZZ9.99-.
01  PREC75.
    02 PIC X(42). 02 FA320 PIC ZZZ9. 02 FA321 PIC Z(4),ZZZ,ZZ9-.
    02 FA322 PIC ZZZ,ZZZ,ZZ9-. 02 FA323 PIC Z(4),ZZZ,ZZ9.99-.
01  PREC76.
    02 FA326 PIC X(12). 02 FA327 PIC BX(24).
01  PREC77.
    02 FA328 PIC X(14). 02 OCCURS 5. 03 FA329 PIC 9(6)B999B99B9(7). 03 FA330 PIC XX.
01  PREC78.
    02 PIC X(24). 02 FA331 PIC X(12). 02 FA331A PIC BBX(8). 02 FA331B PIC BX(15).
    02 FA332 PIC Z99/99/99. 02 FA333 PIC ZZ,ZZZ,ZZ9-. 02 FA335 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA336 PIC ZZZ,ZZ9.999. 02 FA337 PIC ZZ,ZZZ,ZZ9.99-.
    02 FA337A PIC B(6)XXX. 02 REDEFINES FA337A. 03 FA337B PIC Z(7)9. 03 FA337C PIC X.
01  PREC79.
    02 FA338 PIC Z9. 02 FA339 PIC Z(5)9. 02 FA339A PIC BBX(36).
    02 FA340 PIC ZZZ,ZZZ,ZZ9-. 02 FA340A PIC ZZZ,ZZZ,ZZ9.99-. 02 FA340B PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC80.
    02 PIC X(24). 02 FA341 PIC X(12). 02 FA341A PIC BBX(8). 02 FA341B PIC BX(15).
    02 FA342 PIC Z99/99/99. 02 FA343 PIC ZZ,ZZZ,ZZ9-. 02 FA344 PIC ZZ,ZZZ,ZZ9-.
    02 FA345 PIC ZZ,ZZZ,ZZ9.99-. 02 FA346 PIC ZZZ,ZZ9.999. 02 FA347 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC81.
    02 FA348 PIC X(15) OCCURS 8.
01  PREC82.
    02 FA349 PIC ZZZ9. 02 FA349A PIC BX(24). 02 FA350 PIC Z(4)9.
    02 FA351 PIC B(4)X(12). 02 FA352 PIC Z(6)9. 02 FA353 PIC X. 02 FA354 PIC X.
    02 FA355 PIC Z9(7).
    02 OCCURS 3. 03 FA356. 04 FA356A PIC Z(5)9-. 04 FA356B PIC ZZZ,ZZ9-.
      03 REDEFINES FA356. 04 FA356C PIC Z(6),ZZZ,ZZ9-.
    02 FA357 PIC Z(9)9. 02 FA357A PIC ZZ99/99/99.
01  PREC83.
    02 FA358 PIC X(27). 02 PIC X(20). 02 FA359 PIC 99. 02 FA360 PIC Z99.
    02 FA361 PIC ZZZ99.
01  PREC84.
    02 FA362 PIC X(36). 02 PIC X(34). 02 FA362A PIC X(4). 02 FA362B PIC ZZ9.
01  PREC85.
    02 FA363 PIC X(26). 02 FA364 PIC X(7).
01  PREC86.
    02 PIC X(68). 02 FA366 PIC Z(6)9.
01  PREC87.
    02 FA367 PIC Z9. 02 FA368 PIC BX(4)BB. 02 FA369 PIC X(32).
    02 REDEFINES FA369. 03 FA369A PIC X(17). 03 FA369B PIC ZZ,ZZZ,ZZ9. 03 FA369C PIC BXXXB.
    02 FA370 PIC ZZZ,ZZ9. 02 FA371 PIC BXXX.
01  PREC88.
    02 PIC X(9). 02 FA372 PIC X(4). 02 FA372A PIC 9(7). 02 FA373 PIC BBBX(10).
    02 FA374 PIC Z(5)9. 02 FA374A PIC X. 02 FA374B PIC X.
01  PREC89.
    02 PIC X(9). 02 FA375 PIC X(12). 02 FA376 PIC ZZ9. 02 FA376A PIC B(4)X(7).
    02 FA376B PIC X(6).
01  PREC90.
    02 PIC X(9). 02 FA377 PIC X(50).
01  PREC91.
    02 FA378 PIC X(12). 02 FA379 PIC BBX(32). 02 FA380 PIC ZZZ,ZZZ,ZZ9-.
    02 FA381 PIC ZZ99/99/99.
01  PREC92.
    02 FA383 PIC X(8). 02 FA384 PIC ZZZ9. 02 FA385 PIC BBBX(8). 02 FA386 PIC ZZZ9.
    02 FA387 PIC BBBX(6). 02 FA388 PIC Z(5)9. 02 FA389 PIC BBBXXX.
01  PREC93.
    02 FA391 PIC X(13). 02 FA392 PIC ZZ9.
01  PREC94.
    02 FA393 PIC X(15) OCCURS 8.
01  PREC95.
    02 OCCURS 6. 03 FA394 PIC ZZZ9. 03 FA395 PIC Z(6)9. 03 PIC X(8).
01  PREC96.
    02 FA396 PIC X(8) OCCURS 15.
01  PREC97.
    02 FA397 PIC Z(5)9 OCCURS 20.
01  PREC98.
    02 PIC X(5). 02 FA398 PIC X(10). 02 FA399 PIC B(5)X(5). 02 FA400 PIC X(8).
01  PREC99.
    02 PIC X(5). 02 FA401 PIC X(40).
01  PREC100.
    02 PIC X(33). 02 FA402 PIC X(4). 02 FA403 PIC ZZ9. 02 FA404 PIC BBXX. 02 FA405 PIC ZZ9.
01  PREC101.
    02 PIC X(49). 02 FA406 PIC X(45).
01  PREC102.
    02 FA408 PIC X(9). 02 FA409 PIC 99/99/99. 02 FA410 PIC Z(6)9. 02 FA410A PIC XXX.
    02 FA411 PIC BX(13). 02 FA412 PIC X(8). 02 FA413 PIC X(37).
01  PREC103.
    02 PIC X(61). 02 FA414 PIC X(4). 02 FA415 PIC X(5).
01  PREC104.
    02 PIC X(97). 02 FA416 PIC X(12).
01  PREC105.
    02 FA417 PIC X(9). 02 FA418 PIC X(10). 02 FA419 PIC X(27). 02 FA420 PIC 99/99/99.
    02 PIC X(12). 02 FA421 PIC X(4). 02 FA422 PIC XXX.
01  PREC106.
    02 PIC X(70). 02 FA423 PIC X(16). 02 FA424 PIC BX(10). 02 FA425 PIC BX(9).
01  PREC107.
    02 FA426 PIC X(14). 02 FA427 PIC X(8) OCCURS 6.
01  PREC108.
    02 FA428 PIC B(5)X(41). 02 FA429 PIC ZZZ,ZZZ,ZZ9-.
01  PREC109.
    02 PIC X(5). 02 FA430 PIC X(65).
01  PREC110.
    02 FA431 PIC X(13). 02 FA432 PIC X(32). 02 FA433 PIC Z(4),ZZZ,ZZZ-.
    02 FA434 PIC Z(4)9.99.
01  PREC111.
    02 PIC X(13). 02 FA435 PIC X(57).
01  PREC112.
    02 PIC X(70). 02 FA436 PIC X(5). 02 FA437 PIC BX. 02 FA438 PIC 9(7).
    02 FA439 PIC XB. 02 FA440 PIC ZZZ. 02 FA441 PIC BXB. 02 FA442 PIC Z(5).
    02 FA443 PIC Z(4),ZZ9. 02 FA444 PIC BX.
01  PREC113.
    02 PIC X(5). 02 FA445 PIC X(40).
01  PREC114.
    02 PIC X(93). 02 FA446 PIC X(4). 02 FA447 PIC ZZ9.
01  PREC115.
    02 FA448 PIC X(9). 02 FA449 PIC 99/99/99. 02 FA450 PIC Z(7)9.
    02 FA451 PIC BBBX(13). 02 FA453 PIC X(21). 02 FA454 PIC Z(8). 02 FA455 PIC Z(7).
01  PREC116.
    02 FA457 PIC X(9). 02 FA458 PIC X(10). 02 FA459 PIC X(26). 02 FA460 PIC X(4).
    02 FA461 PIC X(4). 02 FA462 PIC 99/99/99. 02 FA463 PIC Z(7)9.
    02 FA464 PIC BBX(9). 02 FA465 PIC Z(5),ZZ9. 02 FA466 PIC Z(5),ZZ9.
    02 FA467 PIC Z(5),ZZ9.
01  PREC117.
    02 PIC X(13). 02 FA470 PIC X(65).
01  PREC118.
    02 FA471 PIC X(13). 02 FA472 PIC X(32).
    02 FA473 PIC Z(5),ZZ9-. 02 FA473A REDEFINES FA473 PIC BBX(7).
    02 FA474 PIC Z(4),ZZZ,ZZ9-.
    02 REDEFINES FA474. 03 FA474A PIC ZZ,ZZ9.99-. 03 FA474B PIC XXX.
    02 FA475X. 03 FA475 PIC Z(4)9.999. 03 FA475A REDEFINES FA475 PIC ZZZ9.9(4).
    02 FA476 PIC BX(4). 02 FA477 PIC X(12). 02 FA478 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC119.
    02 PIC X(8). 02 FA481 PIC X(40).
01  PREC120.
    02 PIC X(47). 02 FA482 PIC 99/99/99. 02 FA483 PIC BBBX(6).
01  PREC121.
    02 FA484 PIC ZZZ99/99/99. 02 FA485 PIC Z(5),ZZZ.ZZ-. 02 PIC XX.
    02 FA486 PIC ZZZ,ZZZ.ZZ- OCCURS 4.
01  PREC122.
    02 PIC X(61). 02 FA487 PIC X(5). 02 FA488 PIC Z9.
01  PREC123.
    02 FA489 PIC ZZ99/99/99. 02 FA489A PIC BBBX(9). 02 FA490 PIC Z(7)9BBB.
    02 FA491 PIC Z(4),ZZ9.99- OCCURS 3.
01  PREC124.
    02 FA492 PIC ZZ9. 02 FA493 PIC BBBX(36). 02 FA494 PIC Z(7)9.
    02 FA495 PIC Z(8)9.999. 02 FA496 PIC BBX. 02 FA497 PIC Z(10)9.999.
01  PREC125.
    02 FA498 PIC X(6). 02 FA499 PIC BBX(32). 02 FA500 PIC BBX(24).
01  PREC126.
    02 PIC X(8). 02 FA501 PIC X(12). 02 FA502 PIC BBX(32). 02 FA503 PIC Z(6)9.
    02 FA503A PIC BBX(9). 02 FA504 PIC Z99/99/99. 02 FA505 PIC ZZZ,ZZZ,ZZ9-.
    02 FA506 PIC ZZZ,ZZZ,ZZ9-. 02 FA507 PIC ZZZ,ZZZ,ZZ9-. 02 FA508 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC127.
    02 FA510 PIC ZZ9. 02 FA511 PIC BBBX(30). 02 FA512 PIC BBX(10).
    02 FA513 PIC Z(5),ZZZ,ZZ9. 02 FA514 PIC Z(6)9. 02 FA515 PIC Z(5)9.999.
    02 FA515A PIC BXXX. 02 FA516 PIC ZZ9.99. 02 FA517 PIC Z(6)9. 02 FA518 PIC BX(32).
01  PREC128.
    02 PIC X(41). 02 FA519 PIC ZZ9. 02 PIC X(7). 02 FA520 PIC ZZZ,ZZ9.99.
01  PREC129.
    02 FA524 PIC X(6). 02 FA525 PIC Z9. 02 FA526 PIC BBX(45).
01  PREC130.
    02 FA527 PIC ZZ9. 02 FA528 PIC BX(28). 02 FA530 PIC Z(7)9. 02 FA531 PIC BBX(13).
    02 FA532 PIC X(28). 02 FA533 PIC BBX. 02 FA534 PIC ZZ9.99.
    02 FA535 PIC ZZZ,ZZZ,ZZ9. 02 FA536 PIC Z(4),ZZ9. 02 FA537 PIC Z(4),ZZ9.
    02 FA538 PIC ZZZ,ZZZ,ZZ9. 02 FA539 PIC BX.
01  PREC131.
    02 FA543 PIC B(4)X(12). 02 FA544 PIC BBX(32). 02 FA545 PIC Z(7)9.
    02 FA546 PIC ZZZ99/99/99. 02 FA547 PIC Z(6),ZZZ,ZZ9-. 02 FA548 PIC XXX.
01  PREC132.
    02 FA549 PIC X(6). 02 FA550 PIC BBX(32).
01  PREC133.
    02 FA551 PIC X(14). 02 FA552 PIC X(36). 02 FA553 PIC Z(5),ZZZ,ZZ9- OCCURS 3.
01  PREC134.
    02 FA554 PIC X(14). 02 FA555X. 03 FA555 PIC ZZZ. 02 FA557 PIC B(4)X(11).
    02 FA558 PIC ZZZ OCCURS 6.
01  PREC135.
    02 FA561 PIC X(14). 02 FA562 PIC X(36). 02 FA563 PIC Z(6),ZZZ,ZZ9-.
    02 FA564 PIC Z(6),ZZZ,ZZ9-.
01  PREC136.
    02 FA566 PIC X(4). 02 FA567 PIC 99BB. 02 FA568 PIC X(45).
01  PREC137.
    02 FA569 PIC X(16) OCCURS 8.
01  PREC138.
    02 FA570 PIC Z(5)9. 02 FA571 PIC ZZ9. 02 FA572 PIC BBX(6).
    02 FA573 PIC BBX(12). 02 FA574 PIC ZZZ9. 02 FA575 PIC BBX(34).
    02 FA576 PIC X(12). 02 FA577 PIC ZZZ,ZZZ,ZZ9. 02 FA578 PIC ZZZ,ZZ9.
    02 FA579 PIC Z(4)99/99/99. 02 FA580 PIC ZZ99/99/99. 02 FA581 PIC BX.
    02 FA582 PIC ZZZ9-.
01  PREC139.
    02 FA583 PIC X(11). 02 FA584 PIC X(19). 02 FA585 PIC XX.
    02 FA586 PIC ZZ9 OCCURS 10.
01  PREC140.
    02 FA587 PIC X(25). 02 FA588 PIC X(8). 02 FA589 PIC ZZZ,ZZ9-.
01  PREC141.
    02 FA590 PIC X(8). 02 FA591 PIC X(32). 02 FA592 PIC Z(4),ZZZ,ZZ9.99-.
    02 FA593 PIC ZZZ,ZZZ,ZZ9.99-. 02 FA594 PIC ZZZ,ZZZ,ZZ9.99-.
    02 FA595 PIC Z(5),ZZZ,ZZ9. 02 FA596 PIC ZZZ,ZZZ,ZZ9-. 02 FA597 PIC B(7)X.
01  PREC142.
    02 FA598 PIC X(15) OCCURS 8.
01  PREC143.
    02 PIC X(12). 02 FA600 PIC X(20).
    02 REDEFINES FA600. 03 FA600A PIC X(10). 03 FA600B PIC 99/99/99.
    02 FA601 PIC ZZZ,ZZ9-. 02 PIC X(15). 02 FA602 PIC X(36). 02 FA603 PIC ZZ,ZZ9-.
01  PREC144.
    02 FA605 PIC Z9. 02 FA606 PIC BBX(40).
01  PREC145.
    02 FA607 PIC X(4). 02 FA608 PIC Z9B(4). 02 FA609 PIC X(15) OCCURS 8.
01  PREC146.
    02 FA610 PIC X(5). 02 FA611 PIC Z9. 02 FA612 PIC BBX(45).
01  PREC147.
    02 FA613 PIC X(12). 02 FA614 PIC BBX(32) OCCURS 3.
01  PREC148.
    02 FA615 PIC Z(5)9. 02 FA616 PIC Z(7)9. 02 FA617 PIC X. 02 FA618 PIC 99.
    02 FA619 PIC Z(7),ZZZ,ZZ9- OCCURS 5.
01  PREC149.
    02 FA620 PIC X(12). 02 FA621 PIC BBX(32). 02 FA622 PIC BBX(13).
    02 FA623 PIC ZZZ9. 02 FA624 PIC BBX(6). 02 FA625 PIC Z(4),ZZZ,ZZ9.
01  PREC150.
    02 FA626 PIC X(30). 02 FA627 PIC X(14). 02 FA628 PIC 99/99/99.
    02 FA629 PIC B(5)X(10). 02 FA630 PIC 99/99/99.
01  PREC151.
    02 FA634 PIC X(9). 02 FA635 PIC X(30). 02 FA636 PIC BBX(9).
    02 FA637 PIC B(10)X(9). 02 FA638 PIC X(45).
01  PREC152.
    02 FA640 PIC X(4). 02 FA641 PIC ZZ9. 02 FA642 PIC BX(7). 02 FA643 PIC BBXXX.
    02 FA644 PIC ZZZ,ZZ9. 02 FA645 PIC BXX.
01  PREC153.
    02 PIC X(40). 02 FA646 PIC X(5). 02 FA647 PIC X(10).
01  PREC154.
    02 PIC X(40). 02 FA648 PIC X(6). 02 FA649 PIC X(10). 02 FA650 PIC B(5)X(14).
    02 FA651 PIC X(10).
01  PREC155.
    02 PIC X(40). 02 FA653 PIC X(18). 02 FA654 PIC X(5)B(5). 02 FA655 PIC X(20).
01  PREC156.
    02 FA657 PIC X(20). 02 OCCURS 5. 03 FA658 PIC X(20). 03 PIC XX.
01  PREC157.
    02 FA660 PIC X(12). 02 OCCURS 10. 03 FA661 PIC XXX. 03 FA662 PIC X(9).
01  PREC158.
    02 PIC X(40). 02 FA665 PIC X(6). 02 FA666 PIC X(10).
01  PREC159.
    02 OCCURS 4. 03 PIC X(8). 03 FA668 PIC Z(4)9. 03 FA669 PIC BXX. 03 FA670 PIC BBX(15).
01  PREC160.
    02 FA671 PIC Z(9)9 OCCURS 12.
01  PREC161.
    02 FA672 PIC Z(5)9. 02 FA674 PIC BBX. 02 FA675 PIC B(4)X(70).
    02 FA676 PIC BBX(30).
01  PREC162.
    02 PIC X(8). 02 FA678 PIC 99/99/99. 02 FA679 PIC Z(4)9. 02 FA680 PIC Z(4)9.
    02 FA681 PIC BBX(25). 02 FA682 PIC Z(5)9.9.
01  PREC163.
    02 FA686 PIC X(15). 02 FA687 PIC ZZ,ZZ9.9.
01  PREC164.
    02 FA688 PIC X(12). 02 FA689 PIC BBX(14). 02 FA690 PIC BBX(32).
    02 FA691 PIC B(5)ZZZ,ZZ9. 02 FA692 PIC B(12)ZZZ,ZZ9.
01  PREC165.
    02 FA693 PIC Z9. 02 PIC XX. 02 FA694 PIC X(22). 02 FA695 PIC Z(8)9. 02 FA696 PIC BBX(10).
01  PREC166.
    02 FA697 PIC ZZ9. 02 FA698 PIC BBX(31). 02 FA699 PIC BBBX(22).
    02 FA700 PIC BBBX(10). 02 FA701 PIC Z(5)9.
01  PREC167.
    02 FA704 PIC Z9. 02 FA705 PIC BBX(45).
01  PREC168.
    02 FA706 PIC Z(10)9. 02 FA707 PIC B(4)X(12). 02 FA708 PIC BBX(32).
01  PREC169.
    02 FA710 PIC 99/99/99. 02 FA711 PIC Z(5),ZZ9.99-. 02 FA712 PIC XXX.
01  PREC170.
    02 PIC X(10). 02 FA713 PIC X(12). 02 FA714 PIC Z(4),ZZ9.99-. 02 FA715 PIC BX(12).
    02 FA716 PIC Z99/99/99. 02 FA717 PIC ZZZ9. 02 FA718 PIC Z(5),ZZ9-.
    02 FA719 PIC XX. 02 FA720 PIC Z(4)9.9(5)-. 02 FA721 PIC BX(15).
    02 FA722 PIC Z(4),ZZ9.99-. 02 FA722A PIC XX.
01  PREC171.
    02 FA725 PIC X(12). 02 FA726 PIC BBX(32)BB. 02 FA727 PIC BBX(12) OCCURS 6.
01  PREC172.
    02 PIC X(43). 02 FA728 PIC Z(5)9.
    02 FA729 PIC B(14)X(10). 02 FA730 REDEFINES FA729 PIC B(9)9B9B9B9B9B9B9B9.
01  PREC173.
    02 FA731 PIC B(7)X(39)B(11). 02 FA732 PIC $(4),$$$,$$9.99. 02 FA733 PIC X.
01  PREC174.
    02 FA734 PIC B(14)X(36).
01  PREC175.
    02 FA735 PIC BB99/99/99. 02 FA736 PIC BX(18). 02 FA737 PIC BBZ(4),ZZ9.99-.
    02 FA738 PIC X(15)B. 02 FA739 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC176.
    02 FA740 PIC X(10). 02 FA740A PIC Z(6)9. 02 FA740B PIC BBX(10).
    02 FA741 PIC Z(6)9. 02 FA741A PIC BBX(36).
01  PREC177.
    02 FA742 PIC BBZ(4),ZZ9.99-. 02 FA743 PIC B(8)X(9). 02 FA744 PIC Z(4),ZZ9.99-.
    02 PIC X(16). 02 FA745 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC178.
    02 FA746 PIC X(8). 02 FA747 PIC Z(5)9. 02 FA748 PIC BX(30).
    02 FA749 PIC Z99/99/99. 02 FA750 PIC Z99/99/99. 02 FA751 PIC BBBX.
    02 FA752 PIC BBBX.
01  PREC179.
    02 FA753 PIC B(15)X(15). 02 FA754 PIC BX(15). 02 FA755 PIC BX(12).
    02 FA756 PIC BX(14).
01  PREC180.
    02 FA760 PIC ZZZ9. 02 FA761 PIC BX(4). 02 FA762 PIC Z(6)9. 02 FA763 PIC X.
    02 FA764 PIC X. 02 FA765 PIC Z9(7). 02 FA765A PIC BX(6). 02 FA766 PIC BBX(12).
    02 FA767 PIC ZZ,ZZZ,ZZ9-. 02 FA768 PIC X(4). 02 FA769 PIC Z(4)9.999.
    02 FA770 PIC BX(4). 02 FA771 PIC Z(4),ZZ9.99-.
01  PREC181.
    02 FA772 PIC X(37)X(10). 02 FA773 PIC 9(6)B999B99B9(7).
    02 FA773A PIC B(25)X(30).
01  PREC182.
    02 FA774 PIC Z9. 02 FA775 PIC BBX(12). 02 FA776 PIC BBX(32).
    02 FA777 PIC BBX(8). 02 FA778 PIC BBX(25). 02 FA779 PIC ZZZ,ZZZ,ZZ9.
    02 FA780 PIC Z(4)9.999. 02 FA781 PIC Z(5)9.99. 02 FA782 PIC ZZZ9.
    02 FA783 PIC B(10)X.
01  PREC183.
    02 FA787 PIC X(32). 02 FA788 PIC B(5)X(30).
    02 FA790 PIC B(5)X(14). 02 FA791 PIC Z(6)9. 02 FA792 PIC B(5)X(8).
    02 FA793 PIC Z99/99/99.
01  PREC184.
    02 FA796 PIC XX. 02 FA797 PIC X(75).
01  PREC185.
    02 OCCURS 6. 03 FA798 PIC XB. 03 FA799 PIC X(16).
01  PREC186.
    02 FA800 PIC X(5). 02 FA801 PIC 99/99/99. 02 PIC X(4).
    02 FA802 PIC BX(22) OCCURS 5.
01  PREC187.
    02 FA803 PIC X(6). 02 FA804 PIC BBX(32). 02 FA805 PIC Z(7)9.
    02 FA806 PIC ZZ99/99/99. 02 FA807 PIC Z(5),ZZZ,ZZ9.99-. 02 FA808 PIC BXXX.
01  PREC188.
    02 FA810 PIC X(13). 02 FA811 PIC X(15). 02 FA812 PIC X(32).
    02 FA813 PIC Z(5),ZZ9-. 02 FA814 PIC Z(5),ZZ9-. 02 FA815 PIC Z(5),ZZ9-.
    02 FA816 PIC ZZZ,ZZ9.999. 02 FA817 PIC Z(5),ZZ9-. 02 FA818 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC189.
    02 FA820 PIC ZZZ9. 02 FA821 PIC BBX(36). 02 FA822 PIC Z(8)9.
    02 FA823 PIC BBBX(10). 02 FA824 PIC ZZZ,ZZZ,ZZ9.99-. 02 FA825 PIC ZZ99/99/99.
    02 FA826 PIC Z(6)9.
01  PREC190.
    02 FA827 PIC ZZ9. 02 FA828 PIC BBX(45).
    02 OCCURS 2. 03 PIC X(4). 03 FA829 PIC Z(5),ZZZ,ZZ9.99- OCCURS 2.
01  PREC191.
    02 FA830 PIC 99. 02 FA831 PIC BX(30). 02 FA832 PIC BBX(12). 02 FA833 PIC BBX(32).
    02 FA834 PIC Z(6)9. 02 FA835 PIC Z(8)9.
    02 FA836 PIC Z(5),ZZZ,ZZ9-. 02 FA837 PIC Z(5),ZZZ,ZZ9-. 02 FA838 PIC BXXX.
01  PREC192.
    02 FA840 PIC X(12). 02 FA841 PIC Z(5),ZZZ,ZZ9-. 02 FA842 PIC Z(5),ZZZ,ZZ9-.
01  PREC193.
    02 FA843 PIC ZZZ9. 02 FA844 PIC BBX(12). 02 FA845 PIC BX(32).
    02 FA846 PIC Z99. 02 FA847 PIC Z(5),ZZZ,ZZ9-. 02 FA848 PIC ZZZ,ZZZ,ZZ9-.
    02 FA849 PIC ZZZ,ZZZ,ZZ9-. 02 FA850 PIC ZZ,ZZZ,ZZ9-. 02 FA851 PIC Z(4)9.9-.
    02 FA852 PIC ZZZ,ZZZ,ZZ9-. 02 FA853 PIC Z(4)9.9-.
01  PREC194.
    02 FA854 PIC ZZZ9. 02 FA855 PIC BBX(37). 02 FA856 PIC X(37).
    02 FA857 PIC X(25). 02 FA858 PIC X(7). 02 FA859 PIC Z(4)9. 02 FA860 PIC Z(9)9.
* ...

01  PREC203.
    02 FD10 PIC X(14). 02 FD11 PIC X(34). 02 FD12 PIC X(7). 02 FD13 PIC X(8).
    02 FD14 PIC ZZ9. 02 FD15 PIC BBBX(6). 02 FD16 PIC ZZZ,ZZZ,ZZ9.
    02 FD17 PIC ZZZ,ZZZ,ZZ9.
01  PREC204.
    02 FD18 PIC X(12). 02 FD18A PIC X(6).
    02 OCCURS 2. 03 FD19 PIC X(14). 03 FD19A PIC X(32). 03 PIC X(11).
01  PREC205.
    02 FD20 PIC ZZ9. 02 FD21 PIC BX(30)BB. 02 FD22 PIC X. 02 PIC XX.
    02 OCCURS 7. 03 FD24 PIC X(12).
      03 REDEFINES FD24. 04 FD25 PIC B(4)99/99.
      03 REDEFINES FD24. 04 FD27 PIC ZZZ.ZZ. 04 FD28 PIC ZZ.ZZ.
    02 FD30 PIC X(9). 02 FD31 REDEFINES FD30 PIC Z(7)9.
01  PREC206.
    02 FD33 PIC Z(5)9. 02 FD33A PIC X. 02 FD33B PIC 9. 02 FD33C PIC X.
    02 FD34 PIC BBX(12). 02 PIC X(33). 02 FD35 PIC ZZ,ZZ9.99.
    02 FD36 PIC ZZ,ZZ9.99. 02 FD37 PIC Z(4),ZZZ,ZZ9- OCCURS 3. 02 FD38 PIC Z(8)9-.
01  PREC207.
    02 OCCURS 6. 03 FD39 PIC Z(8)9. 03 FD39A PIC X(12).
01  PREC208.
    02 FD40 PIC ZZ9. 02 FD41 PIC BBBX(40). 02 FD41A PIC Z(4)9.
    02 FD42 PIC B(8)X(4). 02 FD43 PIC B(10)XX. 02 FD44 PIC B(9)X(7).
    02 FD45 PIC B(11)X(4). 02 FD45A PIC B(6)X(10).
01  PREC209.
    02 FD46 PIC X(5). 02 FD47 PIC Z(5)9. 02 FD48 PIC BBBX(5). 02 FD49 PIC ZZZ9.
    02 FD50 PIC BBBX(6). 02 FD51 PIC X(12). 02 FD52 PIC BBBX(24).
    02 FD53 PIC Z(4),ZZ9. 02 FD54 PIC BXB. 02 FD55 PIC Z(4),ZZ9.
01  PREC210.
    02 FD56 PIC X(12). 02 FD57 PIC 99. 02 FD58 PIC BBBX(40). 02 FD59 PIC X(7).
    02 FD60 PIC ZZZ,ZZ9. 02 FD61 PIC BBX(20).
01  PREC211.
    02 FD63X. 03 FD63 PIC Z(4)9B(11). 02 FD64 PIC ZZZ,ZZ9B(7).
    02 FD65 PIC ZZ9B(7). 02 FD66 PIC ZZZ,ZZ9B(7). 02 FD67 PIC ZZ9B(11).
    02 FD68 PIC ZZ9.
01  PREC212.
    02 FD71 PIC X(45). 02 FD72 PIC ZZ9. 02 FD73 PIC BX(5).
01  PREC213.
    02 FD74 PIC B(4)X(10). 02 FD75 PIC X(12). 02 FD76 PIC X(6).
    02 FD77 PIC X(11). 02 FD78 PIC X(32). 02 FD79 PIC X(18). 02 FD80 PIC Z(5)9.
    02 FD80A PIC Z(7)9. 02 FD80B PIC B(5)XX.
01  PREC214.
    02 FD81 PIC X(11). 02 FD82 PIC Z(5)9. 02 FD83 PIC ZZ9.
    02 FD84 PIC ZZZ,ZZZ,ZZ9-. 02 FD85 PIC BX(13). 02 FD86 PIC X(32).
    02 FD87 PIC ZZZ,ZZZ,ZZ9-.
01  PREC215.
    02 FD88 PIC X(12). 02 FD89 PIC X(14). 02 FD90 PIC Z(5)9. 02 PIC X(5).
    02 OCCURS 5. 03 PIC XXX. 03 FD91 PIC ZZZ,ZZ9. 03 FD92 PIC Z99/99/99.
01  PREC216.
    02 PIC X(34). 02 FD93 PIC X(4). 02 OCCURS 3. 03 FD94 PIC B(6)X(24).
01  PREC217.
    02 OCCURS 5. 03 FD95 PIC X(12). 03 FD96 PIC ZZZ9. 03 PIC X(10).
01  PREC218.
    02 FD97 PIC X(9). 02 FD98 PIC XXX. 02 FD99 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC219.
    02 FD100 PIC X(6). 02 FD101 PIC BBX(32).
    02 REDEFINES FD101. 03 PIC BBX(17). 03 FD101A PIC XXX.
    02 FD102 PIC Z(6)9. 02 FD103 PIC ZZZ,ZZZ,ZZ9.99-. 02 FD104 PIC ZZZ9.99-.
    02 FD105 PIC BBX. 02 FD106 PIC ZZZ99/99/99. 02 FD107 PIC BBX. 02 FD108 PIC BXX.
01  PREC220.
    02 FD109 PIC XXX. 02 FD110 PIC BBBX(6). 02 FD110A PIC Z(5)9.
    02 FD111 PIC BBBX(6). 02 FD111A PIC X(12). 02 FD112 PIC BBBX(4).
    02 FD112A PIC 9(7). 02 FD113 PIC BBBX(6). 02 FD113A PIC X(5).
    02 FD114 PIC BBBX(4). 02 FD114A PIC X(5). 02 FD115 PIC BBBX(5).
    02 FD115A PIC Z(4)9-. 02 FD116 PIC BBBX(4). 02 FD116A PIC ZZ,ZZZ,ZZ9-.
    02 FD117 PIC BBBX(8). 02 FD117A PIC Z(4)9. 02 FD117B PIC BBXXX.
01  PREC221.
    02 PIC X(18). 02 OCCURS 3. 03 FD118 PIC BBBX(7). 03 FD119 PIC Z(8)9-.
01  PREC222.
    02 FD121 PIC X(7). 02 FD122 PIC X(5). 02 FD123 PIC Z(5)9.
    02 FD124 PIC BBX(6). 02 FD125 PIC X(14). 02 FD126 PIC X(4).
    02 FD127 PIC Z(6),ZZ9-. 02 FD129 PIC BBX(5). 02 FD129A PIC 99/99/99BB.
    02 FD130 PIC X(12). 02 FD130A PIC Z(5)9. 02 FD130B PIC X. 02 FD130C PIC 99BB.
01  PREC223.
    02 FD131 PIC X(10). 02 FD132 PIC X(14). 02 FD133 REDEFINES FD132 PIC ZZ,ZZZ,ZZ9.99-.
    02 FD134 REDEFINES FD132 PIC ZZ9. 02 FD135 REDEFINES FD132 PIC 99/99/99.
01  PREC224.
    02 FD136 PIC ZZ9. 02 FD137 PIC BBBX(20). 02 FD138 PIC Z(8)9.
    02 FD139 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC225.
    02 FD140 PIC B(6)X(6). 02 FD141 PIC Z(7)9. 02 FD142 PIC ZZ99/99/99.
    02 FD143 PIC Z(5),ZZ9.99-. 02 FD144 PIC Z(5),ZZ9.99-. 02 FD145 PIC Z(5),ZZ9.99-.
    02 FD146 PIC Z(5),ZZ9.99-. 02 FD147 PIC Z(8)9. 02 FD148 PIC BBBX.
01  PREC226.
    02 PIC X(74). 02 FD149 PIC X(29).
01  PREC227.
    02 FD150 PIC Z9. 02 FD151 PIC Z(6)9. 02 FD152 PIC B(4)X(15).
    02 FD153 PIC ZZ99/99/99. 02 FD154 PIC Z(4),ZZ9.99-. 02 FD155 PIC BBXXX.
01  PREC228.
    02 FD157 PIC Z9. 02 FD158 PIC BBBX(6). 02 FD159 PIC Z(7)9. 02 FD160 PIC Z(8)9.
    02 FD161 PIC ZZ99/99/99. 02 FD162 PIC Z(4),ZZ9.99-. 02 FD163 PIC BBXXX.
01  PREC229.
    02 FD165 PIC X(5). 02 FD166 PIC Z(6)9. 02 FD167 PIC BBBX(5).
    02 FD168 PIC Z(5)9. 02 FD169 PIC BBBX(4). 02 FD170 PIC Z9.
    02 FD175 PIC BBBX(8). 02 FD176 PIC ZZZ9 OCCURS 9.
    02 FD177 PIC BBBX(7). 02 FD178 PIC ZZZ9.
01  PREC230.
    02 FD181 PIC X(6). 02 FD182 PIC X(12). 02 FD183 PIC BBBX(12).
01  PREC231.
    02 OCCURS 3. 03 FD187 PIC B(10)X(5). 03 FD188 PIC Z(7)9-.
      03 FD189 PIC Z(7)9-. 03 FD190 PIC ZZ9(7).
01  PREC232.
    02 FD191 PIC X(6). 02 FD192 PIC XX. 02 FD193 PIC BBBX(5). 02 FD194 PIC X(8).
    02 FD195 PIC X(7). 02 FD196 PIC X(8).
01  PREC233.
    02 FD197 PIC Z(5)9. 02 FD198 PIC BBX(6). 02 FD199 PIC BBX(32). 02 FD200 PIC BBXXX.
01  PREC234.
    02 FD201 PIC X(20). 02 FD202 PIC ZZ,ZZZ,ZZ9.99- OCCURS 8.
01  PREC235.
    02 FD203 PIC X(10). 02 FD204 PIC X(12).
01  PREC236.
    02 FD205 PIC 99. 02 FD206 PIC BX(12). 02 PIC X(4). 02 FD207 PIC Z9.
    02 FD208 PIC BBBX(6). 02 FD209 PIC Z(7)9. 02 FD209A PIC BBX.
    02 FD210 PIC ZZZ,ZZZ,ZZ9 OCCURS 3. 02 FD212 PIC ZZ99/99/99.
    02 FD213 PIC Z(4),ZZZ,ZZ9 OCCURS 4.
01  PREC237.
    02 FD214 PIC X(12). 02 FD215 PIC 99. 02 FD216 PIC BBBX(40).
01  PREC238.
    02 FD217 PIC 99. 02 FD217A PIC BBX(12). 02 FD218 PIC BBX(32).
    02 FD219 PIC Z(5),ZZZ,ZZ9- OCCURS 5.
01  PREC239.
    02 FD221 PIC X(9). 02 FD222 PIC Z9. 02 FD223 PIC BBX(30).
01  PREC240.
    02 FD224 PIC X(6). 02 FD225 PIC BX(32). 02 FD226 PIC B99/99/99.
    02 FD227 PIC ZZ,ZZZ,ZZ9.99- OCCURS 6.
01  PREC241.
    02 FD228 PIC Z(7)99/99/99. 02 FD229 PIC Z(7)9. 02 FD230 PIC BBX(9).
    02 FD231 PIC Z(7)9. 02 FD232 PIC ZZ,ZZZ,ZZ9.99 OCCURS 2.
01  PREC242.
    02 FD233 PIC ZZ9. 02 FD234 PIC ZZ9. 02 FD235 PIC Z(5)9. 02 FD236 PIC BX(10).
    02 FD237 PIC BBX(12). 02 FD238 PIC BX(32). 02 FD239 PIC Z(4),ZZZ,ZZ9-.
    02 FD240 PIC Z(4),ZZZ,ZZ9-. 02 FD241 PIC ZZZ,ZZZ,ZZ9.99-. 02 FD242 PIC XXX.
01  PREC243.
    02 PIC X(25).
    02 FD243 PIC Z(4)9. 02 REDEFINES FD243. 03 FD244 PIC Z9. 03 FD245 PIC ZZ9.
    02 FD246 PIC BBX(20).
01  PREC244.
    02 FD247 PIC X(12). 02 FD248 REDEFINES FD247 PIC Z(4)9. 02 FD249 PIC BBX(12).
    02 FD250 PIC BX(32). 02 FD251 PIC Z(4),ZZZ,ZZ9-. 02 FD252 PIC Z(4),ZZZ,ZZ9-.
    02 FD253 PIC ZZZ,ZZZ,ZZ9.99-. 02 FD254 PIC XXX.
01  PREC245.
    02 PIC X(20). 02 FD255 PIC X(12). 02 FD256 REDEFINES FD255 PIC Z(11)9.
    02 FD257 PIC BBX(20).
01  PREC246.
    02 FD260 PIC X(27). 02 PIC X(20). 02 FD261 PIC 99. 02 FD262 PIC Z99.
    02 FD263 PIC ZZZ99.
01  PREC247.
    02 FD264 PIC X(32). 02 FD264A PIC BBBX(11). 02 FD265 PIC BBX(30).
01  PREC248.
    02 FD266 PIC X(26). 02 FD267 PIC X(26). 02 FD268 PIC X(10).
01  PREC249.
    02 FD269 PIC Z(6)9. 02 FD270 PIC BBX(17). 02 FD271 PIC BXX.
    02 FD271A PIC ZZZ9. 02 FD272 PIC BX(7). 02 FD273 PIC Z(6),ZZ9.
    02 FD273A PIC B(10)X(7).
01  PREC250.
    02 FD274 PIC B(10)X(50).
01  PREC251.
    02 PIC X(68). 02 FD275 PIC Z(6)9.
01  PREC252.
    02 FD276 PIC X(7). 02 FD277 PIC X(14). 02 FD278 PIC X(32). 02 FD279 PIC Z(7)9.
    02 FD280 PIC XXX. 02 FD281 PIC BX. 02 FD282 PIC 9(7). 02 FD283 PIC XBB.
    02 FD284 PIC ZZZ. 02 FD285 PIC BXB. 02 FD286 PIC Z(4). 02 FD287 PIC Z(5),ZZ9.
    02 FD288 PIC BX. 02 PIC X(10). 02 FD289 PIC ZZ9. 02 FD290 PIC Z(7),ZZ9.
01  PREC253.
    02 FD293 PIC ZZZ9. 02 FD294 PIC BBX(32).
01  PREC254.
    02 FD295 PIC ZZZ9. 02 FD296 PIC BBX(12). 02 FD297 PIC B(4)X(5). 02 FD298 PIC X(9).
01  PREC255.
    02 FD299 PIC B(6)X(45).
01  PREC256.
    02 FD300 PIC X(55). 02 FD301 PIC X(21).
01  PREC257.
    02 PIC X(55). 02 FD302 PIC X(6). 02 FD303 PIC 99/99/99.
01  PREC258.
    02 PIC X(55). 02 FD304 PIC X(8). 02 FD305 PIC Z(6)9.
01  PREC259.
    02 FD306 PIC B(10)X(16). 02 FD307 PIC $,$$$,$$9.99.
01  PREC260.
    02 FD308 PIC X(60).
01  PREC261.
    02 FD311 PIC Z(5)9. 02 FD311A PIC Z(7)9. 02 FD311B PIC X. 02 FD311C PIC 99.
    02 FD312 PIC BBX(14). 02 FD313 PIC X(34). 02 FD314 PIC 99/99/99B.
    02 FD315 PIC Z(4),ZZZ,ZZ9- OCCURS 4.
01  PREC262.
    02 FD316 PIC ZZZ9. 02 FD317 PIC BX(17). 02 FD318 PIC ZZZ9. 02 FD319 PIC BX(9).
01  PREC263.
    02 PIC X(5). 02 FD320 PIC X(9). 02 FD321 PIC ZZZ,ZZZ,ZZ9.
    02 FD322 PIC BX(5). 02 FD323 PIC ZZ9. 02 FD324 PIC X(20).
01  PREC264.
    02 FD326 PIC X(6). 02 FD327 PIC Z(5)9. 02 FD328 PIC BBX.
01  PREC265.
    02 FD329 PIC X(9). 02 FD330 PIC Z9. 02 FD330A PIC BX(13).
01  PREC266.
    02 PIC X(57). 02 FD331 PIC X(6). 02 FD332 PIC 99/99/99. 02 FD333 PIC BBBX(5).
01  PREC267.
    02 PIC X(57). 02 FD336 PIC X(8). 02 FD337 PIC X(6).
01  PREC268.
    02 PIC X(57). 02 FD338 PIC X(12). 02 FD339 PIC X(10).
01  PREC269.
    02 FD340 PIC X(8). 02 FD341 PIC BX(4). 02 FD342 PIC ZZ9. 02 FD343 PIC ZZ9.
    02 FD344 PIC BBX(30).
01  PREC270.
    02 FD345 PIC X(10). 02 FD346 PIC X(70).
01  PREC271.
    02 FD347 PIC X(5). 02 FD348 PIC Z9.
01  PREC272.
    02 FD350 PIC X(12). 02 FD351 REDEFINES FD350 PIC ZZ9. 02 FD352 PIC BX(25).
    02 FD353 PIC Z99/99/99. 02 FD354 PIC BX. 02 FD355 PIC ZZZ9. 02 FD356 PIC BX(20).
    02 FD357 PIC Z(4)9-. 02 FD358 REDEFINES FD357 PIC ZZZ9.9.
01  PREC273.
    02 FD360 PIC X(52). 02 FD361 PIC BX(12). 02 FD362 PIC BBX. 02 FD364 PIC X(8).
    02 FD365 PIC BBBX(6). 02 FD366 PIC BBBX(20). 02 FD367 PIC X.
01  PREC274.
    02 FD368 PIC X(15) OCCURS 8.
01  PREC275.
    02 FD370 PIC X(12). 02 FD371 PIC BBX(32). 02 FD372 PIC ZZZ9.
    02 FD373 PIC BX(10). 02 FD374 PIC ZZZ,ZZ9.999. 02 FD375 PIC Z(4),ZZZ,ZZ9-.
    02 FD376 PIC Z(4),ZZZ,ZZ9.99-. 02 FD377 PIC XXX.
01  PREC276.
    02 FD378 PIC ZZ9. 02 FD379 PIC ZZ9. 02 FD380 PIC Z(5)9. 02 FD381 PIC BX(10).
    02 FD382 PIC Z(5),ZZZ,ZZ9-. 02 FD383 PIC Z(4),ZZZ,ZZ9.99-.
01  PREC277.
    02 FD384 PIC ZZZ9. 02 FD385 PIC BBX(36).
01  PREC278.
    02 FD386 PIC B(6)X(15). 02 FD387 PIC ZZ99/99/99.
    02 FD388 PIC ZZ,ZZZ,ZZ9.99- OCCURS 6.
01  PREC279.
    02 FD390 PIC X(12). 02 FD391 PIC BBX(32).
01  PREC280.
    02 FD393 PIC B(14)X(5). 02 FD394 PIC ZZ9(7). 02 FD395 PIC ZZ99/99/99B.
    02 FD396 PIC ZZZ,ZZZ,ZZ9- OCCURS 6.
01  PREC281.
    02 FD398 PIC X(12). 02 FD399 PIC BBX(32).
01  PREC282.
    02 FD400 PIC B(14)X(8). 02 FD401 PIC BBX(10). 02 FD402 PIC ZZ99/99/99B.
    02 FD403 PIC ZZZ,ZZZ,ZZ9- OCCURS 6.
01  PREC283.
    02 FD405 PIC X(12).
    02 OCCURS 2. 03 FD407 PIC Z(4),ZZZ,ZZ9-. 03 FD408 PIC ZZ,ZZZ,ZZ9.99-.
      03 FD409 PIC ZZZ9. 03 FD410 PIC ZZ,ZZZ,ZZ9.99-. 03 FD411 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC284.
    02 PIC X(12). 02 OCCURS 2. 03 FD414 PIC BBX(21)B. 03 FD415 PIC XXX.
      03 FD416 PIC X. 03 FD417 PIC XXX. 03 FD418 PIC Z9(4). 03 FD419 PIC BX(21)B.
01  PREC285.
    02 FD420 PIC X(8). 02 FD421 PIC 999. 02 FD422 PIC BX(10). 02 FD423 PIC BBBX(30).
01  PREC286.
    02 FD425 PIC X(8). 02 FD426 PIC Z(6)9. 02 FD427 PIC ZZ,ZZZ,ZZ9.99-.
    02 FD428 PIC BXXX. 02 FD429 PIC BBX(5). 02 FD429A PIC BX(10).
    02 FD429B PIC BBX(7). 02 FD429C PIC BX(36).
01  PREC287.
    02 FD430 PIC X(8). 02 FD431 PIC Z(6)9. 02 FD432 PIC ZZ,ZZZ,ZZ9.99-.
    02 FD433 PIC BXXX.
01  PREC288.
    02 FD434 PIC X(12). 02 FD435 PIC BBX(32). 02 FD436 PIC ZZZ9.
    02 FD437 PIC Z(5)9.999 OCCURS 6. 02 PIC XXX. 02 FD438 PIC BXX OCCURS 6.
01  PREC289.
    02 PIC X(9). 02 OCCURS 5. 03 FD440 PIC B(5)X(6). 03 FD440A PIC X.
      03 FD441 PIC ZZZ9.999. 03 FD442 PIC BX.
01  PREC290.
    02 FD443 PIC X(4). 02 FD444 PIC 99. 02 FD445 PIC BBX(45).
01  PREC291.
    02 FD446 PIC X(6). 02 FD447 PIC BBX(32).
01  PREC292.
    02 FD448 PIC Z(5)9. 02 FD449 PIC ZZZ9. 02 FD450 PIC BBBX(12).
    02 FD451 PIC BBX(32). 02 FD452 PIC Z(6)9.999. 02 FD453 PIC Z(7)9.999.
    02 FD454 PIC Z(5),ZZZ,ZZ9-. 02 FD454A REDEFINES FD454 PIC B(6)X(7).
01  PREC293.
    02 FD455 PIC ZZ9. 02 FD455A PIC BX. 02 FD456 PIC Z(5)9.
    02 FD457 PIC Z(5)99B999. 02 FD458 PIC Z(11)9. 02 FD459 PIC Z(6),ZZZ,ZZ9.99.
    02 FD460 PIC Z(7)9. 02 FD461 PIC Z(8)9(4). 02 FD462 PIC ZZZ9(13).
    02 FD463 PIC ZZ999. 02 FD464 PIC Z(7)9(5). 02 FD465 PIC ZZZ9(9).
    02 FD466 PIC ZZ999B99. 02 FD467 PIC ZZ999B99.
01  PREC294.
    02 FD468 PIC X(48). 02 OCCURS 3. 03 FD469 PIC ZZZ9.9. 03 FD470 PIC X.
01  PREC295.
    02 FD471 PIC X(12). 02 FD472 PIC BBX(32). 02 FD473 PIC Z(4),ZZ9.999.
    02 FD474 PIC Z(4),ZZ9.999. 02 FD475 PIC Z(4),ZZ9.999-. 02 FD476 PIC Z(9)9-.
    02 FD477 PIC Z(9)9. 02 PIC XX. 02 FD478 PIC BXX OCCURS 6.
01  PREC296.
    02 FD480 PIC X(12). 02 FD481 PIC ZZ9. 02 PIC XX.
    02 FD482 PIC Z(4),ZZZ,ZZ9 OCCURS 7. 02 PIC X(4).
    02 FD483 PIC Z(4),ZZZ,ZZ9 OCCURS 2.
01  PREC297.
    02 PIC X(109). 02 FD485 PIC 99/99/99. 02 PIC X(4). 02 FD486 PIC 99/99/99.
01  PREC298.
    02 PIC X(17). 02 FD487 PIC B(4)99/99/99 OCCURS 7.
    02 PIC X(8). 02 FD488 PIC 99/99/99.
01  PREC299.
    02 FD490 PIC ZZ9. 02 FD491 PIC BBBX(20). 02 FD492 PIC Z(8)9.
    02 FD493 PIC ZZZ,ZZZ,ZZ9.99-. 02 FD494 PIC Z(9)9. 02 FD495 PIC ZZ,ZZZ,ZZ9.99-.
01  PREC300.
    02 FD497 PIC X(10). 02 FD498 PIC X(14). 02 FD498A REDEFINES FD498 PIC ZZ,ZZZ,ZZ9.99-.
    02 FD498B REDEFINES FD498 PIC ZZ9. 02 FD498C REDEFINES FD498 PIC 99/99/99.
01  PREC301.
    02 FD500 PIC 99/99/99. 02 FD501 PIC BBX(12). 02 FD502 PIC ZZZ9.
    02 FD503 PIC BBBX(6). 02 FD504 PIC ZZZ,ZZZ,ZZ9.
01  PREC302.
    02 FD506 PIC Z9. 02 FD507 PIC Z(6)9. 02 FD508 PIC ZZ99/99/99. 02 FD509 PIC BBX(12).
    02 OCCURS 9. 03 FD510 PIC Z(4)9.99. 03 FD510A REDEFINES FD510 PIC B(5)X.
    02 FD511 PIC Z(4),ZZZ,ZZ9. 02 FD512 PIC ZZZ,ZZZ,ZZ9.
01  PREC303.
    02 FD513 PIC X(12). 02 FD514 PIC Z(4)9. 02 FD515 PIC ZZ99/99/99.
    02 FD516 PIC Z(7)9. 02 FD517 PIC Z(6),ZZZ,ZZ9-. 02 FD518 PIC Z(6)9.
01  PREC304.
    02 FD520 PIC Z(5)9. 02 FD521 PIC ZZ99/99/99. 02 FD522 PIC BBX(12).
    02 FD523 PIC ZZ,ZZZ,ZZ9-. 02 FD524 PIC ZZ,ZZZ,ZZ9-. 02 FD525 PIC ZZ,ZZZ,ZZ9-.
    02 FD526 PIC ZZ,ZZZ,ZZ9-. 02 FD527 PIC Z(5)9-. 02 FD528 PIC ZZZ99/99/99.
    02 FD529 PIC BBBX. 02 FD530 PIC B(23)X. 02 FD531 PIC B(4)X. 02 FD532 PIC B(4)X.
01  PREC305.
    02 FD534 PIC X(15). 02 FD535 PIC ZZ99/99/99. 02 FD536 PIC ZZZ,ZZZ,ZZ9-.
    02 FD537 PIC ZZZ,ZZZ,ZZ9-. 02 FD538 PIC ZZZ,ZZZ,ZZ9.99-. 02 FD539 PIC Z(5)9.
    02 FD540 PIC BBX(36).
01  PREC306.
    02 FD542 PIC Z9. 02 FD543 PIC BBX(30). 02 FD544 PIC Z(5),ZZ9.
    02 FD545 PIC Z(5),ZZ9. 02 FD546 PIC Z(4)9. 02 FD546A PIC X.
    02 FD547 PIC Z(5),ZZ9. 02 FD548 PIC Z(6)9.9.
01  PREC307.
    02 FD550 PIC X(7). 02 FD551 PIC 99. 02 FD552 PIC Z99.
01  PREC308.
    02 FD553 PIC Z9. 02 FD554 PIC BX(15).
01  PREC309.
    02 FD555 PIC ZZ9. 02 FD556 PIC B(4)X(45).
01  PREC310.
    02 PIC X(7). 02 FD557 PIC ZZ9.
01  PREC311.
    02 PIC X(7). 02 FD558 PIC ZZZ9 OCCURS 4.
01  PREC312.
    02 PIC X(7). 02 FD559 PIC Z(5)9. 02 FD560 PIC ZZZ9. 02 FD561 PIC ZZ9.
01  PREC313.
    02 PIC X(7). 02 FD562 PIC ZZZ9.99. 02 FD563 PIC BX(39).
01  PREC314.
    02 PIC X(7). 02 FD564 PIC Z9. 02 FD565 PIC BX(25).
01  PREC315.
    02 PIC X(7). 02 FD566 PIC Z9.
01  PREC316.
    02 PIC X(7). 02 FD567 PIC ZZ9. 02 FD568 PIC BX(31). 02 FD569 PIC ZZ9.
    02 FD570 PIC ZZ9. 02 FD571 PIC ZZZ9.
01  PREC317.
    02 FD573 PIC X(12). 02 FD574 PIC BBX(32). 02 FD575 PIC ZZZ9.
    02 FD576 PIC ZZZ9. 02 FD577 PIC Z(6)9. 02 FD578 PIC BBX(6).
    02 FD579 PIC BX(6). 02 FD580 PIC BX(8). 02 FD581 PIC BX(13).
    02 FD582 PIC BBX. 02 FD583 PIC Z(5)9.99. 02 FD584 PIC ZZZ9.99.
01  PREC318.
    02 FD585 PIC X(22). 02 FD586 PIC X(4). 02 FD587 PIC BX(45).
01  PREC319.
    02 FD588 PIC X(9). 02 FD589 PIC X(36). 02 FD590 PIC X(32).
    02 REDEFINES FD590. 03 FD591 PIC X(10). 03 FD592 PIC Z(5)9.
      03 FD593 PIC B(9)X(5). 03 FD594 PIC Z9.
    02 REDEFINES FD590. 03 FD595 PIC X(6). 03 FD596 PIC 99/99/99.
    02 REDEFINES FD590. 03 FD597 PIC X(10). 03 FD598 PIC X(6).
    02 REDEFINES FD590. 03 FD599 PIC X(14). 03 FD600 PIC 99.
    02 REDEFINES FD590. 03 FD601 PIC X(16). 03 FD602 PIC X(9).
    02 REDEFINES FD590. 03 FD603 PIC X(15). 03 FD604 PIC 99/99/99.
    02 REDEFINES FD590. 03 FD605 PIC X(7). 03 FD606 PIC X(6).
    02 REDEFINES FD590. 03 FD607 PIC X(5). 03 FD608 PIC X(15).
    02 REDEFINES FD590. 03 FD609 PIC X(9). 03 FD610 PIC X.
      03 FD611 PIC BBBX(11). 03 FD612 PIC X.
01  PREC320.
    02 FD615 PIC X(15). 02 FD616 PIC X(15). 02 FD617 PIC B(15)X(8).
    02 FD618 PIC Z(4)9.99-. 02 FD619 PIC XXX.
01  PREC321.
    02 FD620 PIC X(12). 02 FD621 PIC Z(4),ZZZ,ZZ9-.
    02 FD622 REDEFINES FD621 PIC B(5)X(8). 02 FD623 REDEFINES FD621 PIC Z,ZZZ,ZZ9.99-.
    02 FD624X. 03 FD624 PIC Z(4)9.999. 02 FD625 PIC BBBXXBB. 02 FD626 PIC X(21).
    02 FD627 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC322.
    02 FD629 PIC X(20). 02 FD630 PIC 99/99/99.
01  PREC323.
    02 FD631 PIC X(8). 02 FD632 PIC X(32). 02 FD633 PIC ZZ,ZZZ,ZZ9.99-.
    02 FD634 PIC Z(8)9. 02 FD635 PIC ZZ,ZZZ,ZZ9.99-. 02 FD636 PIC X.
    02 FD637 PIC ZZ99/99/99. 02 PIC X. 02 FD638 PIC ZZZ9 OCCURS 3.
01  PREC324.
    02 FD640 PIC 9(6)B999B99B9(7). 02 FD641 PIC B(4)X(28). 02 FD642 PIC 999BB.
    02 FD643 PIC 9(6)B9(6)B9(4)B99. 02 FD644 PIC Z(4),ZZZ,ZZ9.99-.
* ...

01  PREC401.
    02 FF1 PIC X(6). 02 FF2 PIC 99/99/99. 02 PIC X(10).
    02 FF3X. 03 FF3 PIC X(45). 03 PIC XXX. 03 FF4 PIC X(52).
      03 REDEFINES FF4. 04 PIC X(5). 04 FF5 PIC X(20). 04 FF5A PIC X(27).
        04 REDEFINES FF5A. 05 FF5B PIC 99/99/99. 05 FF5C PIC BXB. 05 FF5D PIC 99/99/99.
        04 REDEFINES FF5A. 05 FF5E PIC 99/99. 05 FF5F PIC BXB. 05 FF5G PIC 99/99.
    02 FF8 PIC X(5). 02 FF9 PIC ZZ9.
01  PREC402.
    02 FF1Y PIC X(6). 02 FF2Y PIC 99/99/99. 02 PIC X(10).
    02 FF3Y PIC X(45). 02 PIC XXX. 02 FF8Y PIC X(5). 02 FF9Y PIC ZZ9.
01  PREC403.
    02 FF11 PIC Z9. 02 FF12 PIC BBX(45).
01  PREC404.
    02 FF13 PIC X(14). 02 FF14 PIC X(32). 02 FF15 PIC Z(6),ZZZ,ZZZ- OCCURS 5.
01  PREC405.
    02 FF16 PIC X(14). 02 FF17 PIC X(32). 02 FF18 PIC ZZZ,ZZZ,ZZ9- OCCURS 5.
    02 FF18A PIC 9. 02 FF19 PIC ZZZ9.99. 02 FF20 PIC ZZZ,ZZZ,ZZZ-.
    02 FF21 PIC ZZ9. 02 FF21A PIC BXX.
01  PREC406.
    02 FF22 PIC X(4). 02 FF23 PIC Z9. 02 FF24 PIC BBX(45).
01  PREC407.
    02 FF25 PIC X(8). 02 FF26 PIC X(32). 02 FF27 PIC ZZ,ZZZ,ZZ9.99- OCCURS 6.
    02 FF27A PIC Z(6)9.
01  PREC408.
    02 PIC X(5). 02 FF28 PIC ZZ,ZZZ,ZZ9. 02 FF29 PIC B(4)XXX. 02 FF30 PIC ZZ,ZZZ,ZZ9.
01  PREC409.
    02 FF31 PIC X(6). 02 FF32 PIC BBX(32). 02 FF33 PIC Z(7)9. 02 FF34 PIC BBBX(9).
    02 FF35 PIC ZZZ99/99/99. 02 FF36 PIC ZZ99/99/99. 02 FF36A REDEFINES FF36 PIC BBX(8).
    02 FF37 PIC ZZZ,ZZZ,ZZ9.99-. 02 FF37A REDEFINES FF37 PIC ZZZ,ZZZ,ZZ9-.
    02 FF38 PIC ZZZ,ZZZ,ZZ9.99-. 02 FF39 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC410.
    02 FF40 PIC X(12). 02 FF40A PIC BX(32). 02 FF41 PIC BBX(26).
    02 FF42 PIC BBX(5). 02 FF43 PIC Z(6)9. 02 FF44 PIC Z99/99/99.
    02 FF45 PIC ZZZ,ZZZ,ZZ9-. 02 FF45A REDEFINES FF45 PIC BBBX(8).
    02 FF46 PIC ZZZ,ZZZ,ZZ9-. 02 FF47 PIC ZZZ,ZZZ,ZZ9-.
01  PREC411.
    02 FF48 PIC X(9). 02 FF49 PIC Z9. 02 FF50 PIC BBX(45).
01  PREC412.
    02 PIC X(35). 02 FF51 PIC Z(7)99/99/99 OCCURS 5.
01  PREC413.
    02 PIC X(36). 02 OCCURS 6.
      03 FF53 PIC ZZZ,ZZZ,ZZ9.99-. 03 FF54 REDEFINES FF53 PIC Z(6),ZZZ,ZZ9-.
01  PREC414.
    02 PIC X(12). 02 FF55 PIC X(15) OCCURS 8.
01  PREC415.
    02 FF56. 03 FF57 PIC X(10). 03 FF58 PIC 99. 02 FF59 PIC BBX(32).
    02 FF60 PIC Z(4),ZZZ,ZZ9- OCCURS 2. 02 FF61 PIC Z(9),ZZ9.99- OCCURS 2.
01  PREC416.
    02 FF62 PIC X(14). 02 REDEFINES FF62. 03 FF64 PIC X(10). 03 FF64A PIC 99BB.
    02 FF65 PIC X(34). 02 FF66 PIC ZZZ,ZZZ,ZZ9-. 02 FF67 PIC Z(4),ZZ9.99.
    02 FF68 PIC Z(4),ZZZ,ZZ9-. 02 FF69 PIC Z(4),ZZ9. 02 FF70 PIC Z(5),ZZ9-.
    02 FF71 PIC Z(4)9BBB. 02 FF72 PIC X(15).
01  PREC417.
    02 FF73 PIC X(5). 02 FF73A PIC ZZZ9. 02 FF74 PIC BBBX(12). 02 FF75 PIC BBX(32).
    02 FF76 PIC Z(5),ZZZ,ZZ9-. 02 FF76A PIC Z(5),ZZZ,ZZ9-. 02 FF77 PIC Z(4)9(7).
    02 FF77A PIC BBXX. 02 FF77B PIC Z99/99/99. 02 FF77C PIC ZZZ,ZZZ,ZZ9-.
    02 FF77D PIC BX(6).
01  PREC418.
    02 FF78 PIC X(10) OCCURS 12.
01  PREC419.
    02 FF80 PIC X(18). 02 FF81 PIC X(19). 02 FF82 PIC ZZZ9. 02 FF83 PIC BXXB.
    02 FF84 PIC ZZZ9. 02 FF85 PIC BBX. 02 FF85A PIC ZZ9.9. 02 FF85B PIC XXX.
01  PREC420.
    02 FF86 PIC XXX. 02 FF87 PIC BBBX(5). 02 FF87A PIC X(12).
    02 FF88 PIC BBBX(5). 02 FF88A PIC X(8). 02 FF89 PIC BBBXXX. 02 FF89A PIC X(8).
    02 FF90 PIC B(6)X(4). 02 FF90A PIC ZZZ,ZZZ,ZZ9-. 02 FF91 PIC B(5)X(5).
    02 FF91A PIC X(10).
01  PREC421.
    02 FF94 PIC X(16) OCCURS 8.
01  PREC422.
    02 FF96 PIC B(6)X(5). 02 FF96A PIC 9. 02 FF97 PIC B(6)X(6).
    02 FF97A PIC ZZ9-. 02 FF98 PIC B(5)X(11). 02 FF98A PIC Z(4)9.
    02 FF99 PIC B(5)X(5). 02 FF99A PIC X(10).
01  PREC423.
    02 FF101 PIC X(25). 02 FF102 PIC X(8). 02 FF103 PIC ZZZ,ZZ9-.
01  PREC424.
    02 FF104 PIC X(8). 02 FF105 PIC ZZ9BB. 02 FF106 PIC X(60).
01  PREC425.
    02 FF107 PIC Z9. 02 FF108 PIC BX(12). 02 FF109 PIC BX(30). 02 FF109A PIC BBX(6).
    02 FF110 PIC Z(6)9. 02 FF110A PIC BBX. 02 FF111 PIC Z(4),ZZZ,ZZ9.
    02 FF112 PIC BX. 02 FF113 PIC ZZ99/99/99. 02 FF114 PIC ZZ99/99/99B.
    02 FF115 PIC XX. 02 FF116 PIC BX. 02 FF117 PIC Z(6)9 OCCURS 4.
01  PREC426.
    02 FF118 PIC Z(6),ZZ9. 02 FF119 PIC BBX(6). 02 FF120 PIC X(14).
    02 FF121 PIC X(32). 02 FF122 PIC Z(4),ZZ9.999. 02 FF123 PIC BX(4).
    02 FF124 PIC Z(4),ZZ9.99.
01  PREC427.
    02 FF125 PIC Z(5)9. 02 FF126 PIC Z(5)9. 02 FF127 PIC BBX(36).
    02 FF128 PIC ZZ99/99/99. 02 FF129 PIC Z(6)99/99/99. 02 FF130 PIC Z(4)99/99/99.
01  PREC428.
    02 FF131 PIC X(8). 02 FF132 PIC X(32). 02 FF133 PIC Z(4),ZZZ,ZZ9.99-.
    02 FF134 PIC Z(5),ZZZ,ZZ9. 02 FF135 PIC ZZZ,ZZZ,ZZ9-.
01  PREC429.
    02 FF136 PIC Z(7)9 OCCURS 16.
01  PREC430.
    02 OCCURS 5. 03 PIC X(21). 03 FF137 PIC 9(4).
01  PREC431.
    02 PIC X(7). 02 OCCURS 5. 03 FF138 PIC Z(6),ZZZ,ZZ9. 03 FF139 PIC ZZZ,ZZZ,ZZ9.
01  PREC432.
    02 FF140 PIC X(8). 02 FF141 PIC X(32).
01  PREC433.
    02 FF142 PIC X(14). 02 FF143 PIC X(32).
01  PREC434.
    02 FF145 PIC ZZ9. 02 FF146 PIC BBBX(12). 02 FF147 PIC BBX(40).
    02 FF148 PIC B(8)ZZ9. 02 FF149 PIC B(16)Z9.
01  PREC435.
    02 FF151 PIC Z(5)9. 02 FF152 PIC Z(4)9. 02 FF153 PIC ZZ99/99/99.
    02 FF154 PIC BBX. 02 FF155 PIC BBX(12). 02 FF156 PIC BBX(32).
01  PREC436.
    02 FF158 PIC X(6). 02 FF159 PIC BX(8). 02 FF160 PIC ZZ99/99/99.
    02 FF161 PIC Z(7)9. 02 FF162 PIC BBBX(12). 02 FF163 PIC BBX(6).
    02 FF164 PIC BBX(32). 02 FF165 PIC Z(4),ZZZ,ZZ9-.
01  PREC437.
    02 FF166 PIC X(20). 02 FF167 PIC X(9) OCCURS 5.
01  PREC438.
    02 FF168 PIC Z9. 02 FF169 PIC Z(5),ZZZ,ZZ9-. 02 FF169A PIC Z(5),ZZZ,ZZ9-.
01  PREC439.
    02 FF170 PIC Z(5)9. 02 FF171 PIC ZZ99/99/99. 02 FF172 PIC Z(7)9.
    02 FF173 PIC Z(7)9. 02 FF173A PIC Z(10)9. 02 FF174 PIC Z(7),ZZZ,ZZ9-.
    02 FF175 PIC Z(5),ZZZ,ZZ9-.
01  PREC440.
    02 FF176 PIC Z(5)9. 02 FF177 PIC Z(7)9. 02 FF178 PIC ZZ99/99/99.
    02 FF179 PIC ZZZ9. 02 FF180 PIC Z(6),ZZZ,ZZ9-. 02 FF181 PIC Z(4),ZZZ,ZZ9-.
    02 FF182 PIC Z(7),ZZZ,ZZ9-. 02 FF183 PIC Z(6),ZZZ,ZZ9-.
    02 FF184 PIC Z(4),ZZZ,ZZ9-. 02 FF185 PIC B(6)XXX.
01  PREC441.
    02 FF186 PIC X(12). 02 FF187 PIC BBX(32). 02 FF188 PIC ZZ9. 02 FF188A PIC X.
    02 FF189 PIC BX(12). 02 FF190 PIC BBX(6). 02 FF191 PIC BBBX.
    02 FF192 PIC Z(7),ZZZ,ZZ9-. 02 FF193 PIC Z(4),ZZZ,ZZ9-.
    02 FF194 PIC Z(4),ZZZ,ZZ9-. 02 FF195 PIC ZZ99/99/99.
01  PREC442.
    02 FF198 PIC X(6). 02 FF199 PIC BBX(12). 02 FF200 PIC BBX(32).
    02 FF201 PIC ZZZ,ZZ9-. 02 FF202 PIC ZZ99/99/99. 02 FF202A PIC ZZ99/99/99.
    02 FF203 PIC ZZ,ZZZ,ZZ9.99. 02 FF203A PIC Z(11)9.
01  PREC443.
    02 FF204 PIC X(4). 02 FF205 PIC Z9. 02 FF206 PIC BBX(45).
01  PREC444.
    02 FF208 PIC X(12). 02 FF209 PIC BBX(32). 02 FF210 PIC ZZZ,ZZZ,ZZ9-.
    02 FF211 PIC ZZZ,ZZZ,ZZ9-.
01  PREC445.
    02 FF212 PIC X(12). 02 FF213 PIC BBX(14). 02 FF214 PIC BBX(32).
    02 FF215 PIC Z(6)9. 02 FF216 PIC Z(4),ZZ9-. 02 FF217 PIC Z(5),ZZ9-.
    02 FF218 PIC Z(5),ZZ9-. 02 FF219 PIC ZZZ,ZZ9. 02 FF220 PIC ZZ,ZZ9.
    02 FF221 PIC Z(4),ZZ9. 02 FF221A PIC BBBX(8).
01  PREC446.
    02 PIC X(26). 02 FF222 PIC X(16). 02 FF223 PIC ZZ9. 02 FF224 PIC X(9).
    02 FF225 PIC 99/99/99. 02 FF226 PIC BXB. 02 FF227 PIC 99/99/99.
01  PREC447.
    02 FF229 PIC X(12). 02 PIC XX. 02 FF230 PIC BX OCCURS 45.
01  PREC448.
    02 FF234 PIC X(10). 02 FF235 PIC ZZ99/99/99. 02 FF236 PIC BBX(10).
    02 FF237 PIC BBX(12). 02 FF238 PIC Z(5)9. 02 FF239 PIC Z(6),ZZ9.
    02 FF239A PIC BXX.
01  PREC449.
    02 FF240 PIC X(6). 02 FF241 PIC X(6). 02 FF242 PIC ZZ9. 02 FF243 PIC Z(10).
    02 FF244 PIC Z(8)9. 02 FF245 PIC ZZZ99/99/99. 02 FF246 PIC ZZ99/99/99.
    02 OCCURS 4. 03 FF247 PIC B(5)X(5). 03 FF247A PIC X. 03 FF247B PIC Z(4)9.
01  PREC450.
    02 FF249 PIC X(8). 02 FF249A PIC Z(4),ZZ9.
01  PREC451.
    02 FF250 PIC Z(5)9. 02 FF251 PIC BBX(14). 02 FF252 PIC X(32).
    02 FF253 PIC ZZ99/99/99. 02 FF255 PIC Z(4),ZZZ,ZZ9-.
    02 FF256 PIC ZZZ,ZZZ,ZZ9-. 02 FF256A PIC XX. 02 FF257 PIC Z(4),ZZZ,ZZ9-.
01  PREC452.
    02 FF259 PIC X(16). 02 FF260 PIC X(25).
01  PREC453.
    02 PIC X(16). 02 FF261 PIC X(9). 02 FF262 PIC 99/99/99.
    02 FF263 PIC B(4)X(9). 02 FF264 PIC 99/99/99. 02 FF265 PIC B(4)X(7).
    02 FF266 PIC X(8). 02 FF267 PIC BBBX(7). 02 FF268 PIC Z(4),ZZ9.
    02 FF268A PIC BBX(4).
01  PREC454.
    02 FF269 PIC 99/99/99. 02 FF270 PIC BX(5). 02 FF271 PIC X(12). 02 FF272 PIC BX(8).
    02 FF273 PIC BX(8). 02 FF274 PIC ZZ,ZZZ,ZZ9-. 02 PIC X(13). 02 FF277 PIC Z9.
    02 FF278 PIC Z(4)9-. 02 FF279 PIC Z(5),ZZZ. 02 FF280 PIC BBX(10).
01  PREC455.
    02 FF284 PIC X(12). 02 FF285 PIC BBX(32). 02 FF286 PIC B(4)X(5).
    02 FF287 PIC ZZZ,ZZ9. 02 FF287A PIC B(4)X(15). 02 FF287B PIC Z99/99/99.
01  PREC456.
    02 PIC X(16). 02 FF288 PIC X(9). 02 FF289 PIC 99/99/99.
    02 FF291 PIC B(5)X(11). 02 FF292 PIC 99/99/99. 02 FF293 PIC B(5)X(6).
    02 FF294 PIC X(8). 02 FF295 PIC BBBX(4). 02 FF296 PIC ZZZ9.
    02 FF297 PIC BBX(4).
01  PREC457.
    02 FF300 PIC Z(5)9. 02 FF301 PIC BBX(14). 02 FF302 PIC X(32).
    02 FF303 PIC ZZ99/99/99. 02 FF305 PIC Z(5),ZZZ,ZZ9-. 02 FF305A PIC XX.
    02 FF306 PIC ZZ9. 02 FF307 PIC Z(6),ZZZ,ZZ9-.
01  PREC458.
    02 PIC X(26). 02 FF308 PIC X(16). 02 FF309 PIC ZZ9. 02 FF310 PIC X(9).
    02 FF311 PIC 99/99/99. 02 FF312 PIC BXB. 02 FF313 PIC 99/99/99.
01  PREC459.
    02 FF314 PIC X(12). 02 FF315 PIC ZZZ9. 02 FF316 PIC B(4)X(12).
    02 FF317 PIC BBX(32).
01  PREC460.
    02 FF318 PIC X(12). 02 FF319 PIC X(7). 02 FF320 PIC Z(5)9.
    02 FF321 PIC ZZ99/99/99. 02 FF322 PIC BBX(12). 02 FF323 PIC Z(4),ZZZ,ZZ9-.
    02 FF324 PIC Z(8)9. 02 FF325 PIC BBX(50).
01  PREC461.
    02 FF327 PIC X(7). 02 FF328 PIC X(14). 02 FF329 PIC X(32).
    02 FF330 PIC ZZZ,ZZZ,ZZ9-. 02 FF331 PIC Z9(7). 02 FF332 PIC ZZ99/99/99.
    02 FF333 PIC Z(6)9.
01  PREC462.
    02 PIC X(75). 02 FF335 PIC X(50).
01  PREC463.
    02 FF336 PIC X(19). 02 FF337 PIC X.
01  PREC464.
    02 FF338 PIC X(15) OCCURS 8.
01  PREC465.
    02 FF339 PIC X(14). 02 FF340 PIC B(4)X(12) OCCURS 7.
01  PREC466.
    02 FF341 PIC X(8). 02 FF342 PIC X(32). 02 FF343 PIC Z(4),ZZZ,ZZ9.99-.
    02 FF344 PIC Z(4),ZZZ,ZZ9- OCCURS 2. 02 FF345 PIC B(4)X(5).
01  PREC467.
    02 FF346 PIC X(6). 02 FF347 PIC ZZ99. 02 FF348 PIC B(5)X(32).
    02 FF349 PIC BBX(32). 02 FF350 PIC BBX(32). 02 FF350A PIC BBX(10).
01  PREC468.
    02 FF351 PIC X(4). 02 FF351A PIC Z9. 02 FF352 PIC BBX(12).
    02 FF353 PIC ZZ99/99/99. 02 FF354 PIC ZZZ,ZZZ,ZZ9-. 02 FF354A PIC ZZ,ZZZ,ZZZ-.
    02 FF355 PIC Z(6)9. 02 FF355A PIC X. 02 FF355B PIC 99. 02 FF356 PIC BBX(32).
01  PREC469.
    02 FF357 PIC X(21). 02 FF358 PIC BXB. 02 FF359 PIC X(10)BB.
    02 OCCURS 3. 03 FF360 PIC ZZZ,ZZZ,ZZZ.ZZ-. 03 PIC X(4).
* note 5.1
01  PREC470.
    02 PIC X(67). 02 FF361 PIC X(4). 02 FF362 PIC ZZ9. 02 FF363 PIC BXX.
    02 FF364 PIC ZZ9.
01  PREC471.
    02 PIC X(51). 02 FF365 PIC Z(6)9.
01  PREC472.
    02 PIC X(11). 02 FF366 PIC X. 02 FF366A PIC B(10)X.
01  PREC473.
    02 PIC XXX. 02 FF367 PIC X(36). 02 FF368 PIC B(5)X(36).
01  PREC474.
    02 PIC XX. 02 FF370 PIC X. 02 PIC X(7). 02 FF371 PIC X. 02 PIC X(39).
    02 FF372 PIC 99/99/99. 02 FF373 PIC BBBX(12).
01  PREC475.
    02 PIC X(51). 02 FF374 PIC X. 02 FF375 PIC B(5)X.
01  PREC476.
    02 PIC X(10). 02 FF376 PIC X(30). 02 PIC X(7). 02 FF377 PIC 99/99/99.
01  PREC477.
    02 PIC XXX. 02 FF378 PIC ZZZ9. 02 FF379 PIC BX(8). 02 FF380 PIC BXX.
    02 FF381 PIC ZZ9. 02 FF382 PIC BX(7). 02 PIC X(5). 02 FF383 PIC XXX.
    02 FF384 PIC Z(4)9. 02 FF385 PIC XX. 02 PIC X(28). 02 FF386 PIC ZZZ9.99.
01  PREC478.
    02 PIC XX. 02 FF387 PIC XXX. 02 FF388 PIC BXX. 02 FF389 PIC BBX.
    02 FF390 PIC BBBX(32).
    02 REDEFINES FF390. 03 FF390A PIC Z(5)9. 03 FF390B PIC BX(28).
    02 REDEFINES FF390. 03 FF390C PIC ZZZ9. 03 FF390D PIC BX(22). 03 FF390E PIC BX(7).
    02 FF391 PIC BXXX. 02 FF391A PIC BXX. 02 FF391B PIC Z(7)9.
    02 FF392 PIC Z(4)9.999. 02 FF393 PIC XX. 02 FF394 PIC Z(5)9.99.
01  PREC479.
    02 PIC X(58). 02 FF395 PIC Z9.
01  PREC480.
    02 PIC X(18). 02 FF396 PIC X(24).
01  PREC481.
    02 PIC X(14). 02 FF397 PIC X(9). 02 FF398 PIC X(12). 02 FF399 PIC B(5)X(15).
01  PREC482.
    02 PIC X(10). 02 FF400 PIC X(30). 02 PIC X(9). 02 FF401 PIC X(12).
    02 PIC X(6). 02 FF402 PIC X(12).
01  PREC483.
    02 PIC X(14). 02 FF404 PIC X(60).
* note 5.2
01  PREC484.
    02 FF408 PIC Z99. 02 FF409 PIC Z99. 02 FF410 PIC Z(4)9. 02 FF411 PIC BBBX(12).
    02 FF412 PIC BBX(32). 02 FF413 PIC Z(5),ZZZ,ZZ9. 02 FF414 PIC Z(5),ZZ9.99.
    02 FF415 PIC Z(4),ZZ9.999. 02 FF416 PIC Z(6),ZZ9.99. 02 FF417 PIC BXXX.
01  PREC485.
    02 FF419 PIC X(8). 02 FF420 PIC BXB. 02 FF421 PIC X(10).
    02 OCCURS 2. 03 PIC X. 03 OCCURS 2.
      04 FF422 PIC Z(5),ZZ9-. 04 FF423 PIC ZZ9.99-. 04 FF424 PIC ZZZ,ZZ9.9-.
01  PREC486.
    02 OCCURS 4. 03 FF426 PIC X(14). 03 FF427 PIC X(16).
01  PREC487.
    02 FF428 PIC Z(5)9. 02 FF429 PIC Z(4)9. 02 FF430 PIC ZZ99/99/99.
    02 FF431 PIC BBX. 02 FF432 PIC Z(5)9. 02 FF433 PIC BBBX(12).
    02 FF433A PIC Z(6)9.
01  PREC488.
    02 FF434 PIC X(8). 02 FF435 PIC Z99/99/99. 02 FF436 PIC Z(6)9.
    02 FF437 PIC BBX(12). 02 FF438 PIC ZZZ9.
    02 FF439. 03 OCCURS 10. 04 FF440 PIC Z(4)9. 04 FF441 PIC X. 04 FF442 PIC ZZ9.
    02 REDEFINES FF439. 03 OCCURS 10. 04 FF443 PIC ZZZ9. 04 FF444 PIC X. 04 FF445 PIC ZZZ9.
01  PREC489.
    02 FF446 PIC X(6). 02 FF446A PIC BBX(32). 02 FF447 PIC Z(4)9. 02 FF447A PIC X.
    02 FF448 PIC Z.999.
01  PREC490.
    02 OCCURS 8. 03 FF449 PIC X. 03 FF450 PIC X(14).
01  PREC491.
    02 FF451 PIC X(4). 02 FF452 PIC Z9. 02 FF453 PIC BBX(45).
01  PREC492.
    02 FF454 PIC X(14). 02 FF455 PIC X(32). 02 FF456 PIC ZZZ,ZZZ,ZZ9-.
    02 FF457 PIC ZZZ9.99. 02 FF458 PIC ZZZ,ZZZ,ZZ9-. 02 FF459 PIC Z(4)9.
    02 FF460 PIC BX(10). 02 FF461 PIC ZZZ,ZZ9.999. 02 FF462 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC493.
    02 FF464 PIC X(14). 02 FF465 PIC X(32). 02 FF466 PIC Z(6)9.
    02 FF466A PIC ZZZ,ZZZ,ZZ9-. 02 FF467 PIC Z(5)9. 02 FF468 PIC BX(10).
    02 FF469 PIC ZZZ,ZZ9.999. 02 FF470 PIC ZZ,ZZZ,ZZ9-. 02 FF471 PIC ZZ,ZZZ,ZZ9-.
    02 FF472 PIC ZZZ,ZZZ,ZZ9.99-. 02 FF473 PIC XX.
01  PREC494.
    02 FF474 PIC X(14). 02 FF475 PIC X(32). 02 FF476 PIC Z(6)9.
    02 FF476A PIC Z(4),ZZ9-. 02 FF477 PIC Z(5)9. 02 FF478 PIC BX(10).
    02 FF479 PIC Z(4)9.999. 02 FF480 PIC ZZZ9.99. 02 FF481 PIC ZZ,ZZ9-.
    02 FF482 PIC Z,ZZZ,ZZ9.99-. 02 FF483 PIC XX.
01  PREC495.
    02 FF485 PIC X(4). 02 FF486 PIC Z9. 02 FF487 PIC BBX(32).
    02 FF488 PIC Z(5),ZZZ,ZZ9- OCCURS 4. 02 FF489 PIC BBXX.
01  PREC496.
    02 FF491 PIC X(6). 02 FF492 PIC BBX(32). 02 FF493 PIC Z(6)9. 02 FF494 PIC ZZ99/99/99.
    02 FF495 PIC BBX(12). 02 FF496 PIC ZZZ,ZZZ,ZZ9-. 02 FF497 PIC Z(4),ZZ9.99-.
    02 FF498 PIC ZZ9.99. 02 FF499 PIC Z(4),ZZ9.99-. 02 FF500 PIC XXX.
01  PREC497.
    02 FF501 PIC Z9. 02 FF502 PIC BBX(30).
01  PREC498.
    02 FF503 PIC X(5). 02 FF504 PIC BX(6). 02 FF505 PIC BBX(32).
01  PREC499.
    02 FF506. 03 FF507 PIC X(9). 03 FF508. 04 FF509 PIC Z9. 04 PIC X(7).
    02 FF510 PIC X(14). 02 FF511 PIC Z(4),ZZZ,ZZ9-.
01  PREC500.
    02 FF512 PIC X(6). 02 FF513 PIC BBX(32). 02 FF514 PIC Z(5)9.
    02 FF515 PIC BBX(45).
01  PREC501.
    02 FF516 PIC ZZ9. 02 FF517 PIC ZZ9. 02 FF518 PIC Z(5)9. 02 FF519 PIC BX(10).
    02 FF520 PIC Z(5),ZZZ,ZZ9-. 02 FF521 PIC Z(5),ZZZ,ZZ9-. 02 FF522 PIC ZZZ,ZZ9-.
    02 FF523 PIC Z(4),ZZ9.99-. 02 FF524 PIC ZZZ,ZZZ,ZZ9.99-.
01  PREC502.
    02 FF527 PIC X(13). 02 FF528 PIC X(25).
01  PREC503.
    02 FF530 PIC X(10). 02 FF531 PIC Z(5)9. 02 FF532 PIC Z(4)9(7).
    02 FF533 PIC BBX(8). 02 FF534 PIC Z(5)9. 02 FF535 PIC ZZZ,ZZZ,ZZ9-.
    02 FF536 PIC Z(4),ZZ9-. 02 FF537 PIC ZZ,ZZ9.999. 02 FF537A PIC BX(4).
    02 FF538 PIC BX(9). 02 FF539 PIC ZZZ,ZZ9.99-. 02 FF540 PIC X(8).
01  PREC504.
    02 PIC X(36). 02 FF541X. 03 FF541 PIC 9(6)B999B99B9(7). 02 FF542 PIC Z(5),ZZ9.99-.
    02 FF543 PIC BBBX. 02 FF544 PIC ZZZ,ZZ9.99- OCCURS 5.
01  PREC505.
    02 FF545 PIC X(17). 02 FF546 PIC 99/99/99.
01  PREC506.
    02 FF550 PIC X(9). 02 FF551 PIC Z9. 02 FF552 PIC BBX(45).
01  PREC507.
    02 FF553 PIC X(12). 02 FF554 PIC BX(32). 02 FF555 PIC Z(4),ZZZ,ZZ9- OCCURS 5.
01  PREC508.
    02 FF556 PIC X(6). 02 FF557 PIC 99/99/99. 02 FF558 PIC B(4)X(6).
    02 FF559 PIC 99B99. 02 FF560 PIC B(4)X(8). 02 FF561 PIC X(10).
01  PREC509.
    02 FF562 PIC X(8). 02 FF563 PIC BBX(8). 02 FF564 PIC BX(5). 02 FF565 PIC Z(5),ZZZ.
    02 FF566 PIC Z(7),ZZZ. 02 FF567 PIC ZZZ/ZZ/ZZ. 02 FF568 PIC BX(12).
    02 FF569 PIC Z(7),ZZZ. 02 FF570 PIC ZZZ/ZZ/ZZ. 02 FF571 PIC BX(12).
    02 FF572 PIC Z(6)/ZZ/ZZ. 02 FF573 PIC BX(12).
01  PREC510.
    02 FF575 PIC Z(5)9. 02 FF576 PIC ZZZ9. 02 FF577 PIC BBBX(12).
    02 FF578 PIC BBX(32). 02 FF579 PIC Z(5),ZZZ,ZZ9-.
01  PREC511.
    02 FF582 PIC B(13)X(12). 02 FF583 PIC BBX(14). 02 FF584 PIC BBX(32).
    02 FF585 PIC Z(4)9. 02 FF586 PIC Z(7),ZZ9. 02 FF587 PIC Z(8),ZZ9.
    02 FF588 PIC Z(8)9-.
01  PREC512.
    02 FF590 PIC X(12). 02 FF591 PIC Z99/99/99.
01  PREC513.
    02 FF592 PIC X(11). 02 FF593 PIC Z,ZZZ,ZZ9.99.
01  PREC514.
    02 FF594 PIC X(23). 02 FF595 PIC BX(8).
01  PREC515.
    02 FF597 PIC Z(6)9. 02 FF598 PIC BBX(8). 02 FF599 PIC Z(5),ZZ9-.
    02 FF600 PIC Z(4),ZZ9.99-. 02 FF601 PIC Z99/99/99. 02 FF602 PIC BBX(12).
    02 FF603 PIC BBX(20).
01  PREC516.
    02 FF605 PIC X(6). 02 FF606 PIC BBX(32). 02 FF607 PIC Z(8)9.
    02 FF608 PIC Z(7)9. 02 FF609 PIC Z(7)9. 02 FF610 PIC ZZ99/99/99.
    02 FF611 PIC BBX(9). 02 FF612 PIC Z(5),ZZ9.99-.
* ...

01  PREC601.
    02 FG1 PIC Z(4)9. 02 FG2 PIC Z(6),ZZ9.
01  PREC602.
    02 FG3 PIC X(8). 02 FG4 PIC BBX(12). 02 FG5 PIC Z9. 02 FG6 PIC Z(5)9.
    02 FG7 PIC Z(6),ZZ9. 02 FG8 PIC BBX(10). 02 FG9 PIC Z99/99/99.
    02 FG10 PIC BBX(17).
01  PREC603.
    02 FG12 PIC Z9. 02 FG13 PIC BBBX(12). 02 FG14 PIC ZZ9. 02 FG15 PIC BBBX(12).
    02 FG16 PIC Z(7)9. 02 FG17 PIC ZZZ9. 02 FG17A PIC Z(4)9.9. 02 FG17B PIC ZZZ9.9.
    02 FG17C PIC ZZZ9. 02 FG18 PIC BBBX(8). 02 FG19 PIC ZZZ9.
01  PREC604.
    02 FG21 PIC X(12). 02 FG22 PIC BBX(32). 02 FG23 PIC ZZZ,ZZ9.999.
    02 FG24 PIC BBX(4). 02 FG25 PIC Z(5),ZZ9-. 02 FG26 PIC Z(5),ZZ9.99-.
01  PREC605.
    02 FG28 PIC ZZ9. 02 FG29 PIC ZZ9. 02 FG30 PIC Z(5)9. 02 FG31 PIC BBXXX.
    02 FG32 PIC BBBX(30). 02 FG33 PIC Z(6),ZZ9.99-. 02 FG34 PIC XX.
01  PREC606.
    02 FG36 PIC X(12). 02 FG37 PIC X(12). 02 FG38 PIC Z(7)9. 02 FG39 PIC BBX(6).
    02 FG39A PIC BBX(6). 02 FG40 PIC BBXX. 02 FG41 PIC B(5)X(10). 02 FG42 PIC BXX.
    02 FG43 PIC B(4)XX. 02 FG44 PIC ZZZ99/99/99. 02 FG44A PIC ZZZ99/99/99.
    02 FG44B PIC Z99/99/99. 02 FG44C PIC Z(6),ZZ9.
01  PREC607.
    02 PIC X(9). 02 OCCURS 5. 03 FG45 PIC BXX. 03 FG45A PIC X. 03 FG45B PIC X(10).
01  PREC608.
    02 PIC X(6). 02 OCCURS 6. 03 FG48 PIC Z(6),ZZ9. 03 FG49 PIC Z99/99/99.
      03 FG50 PIC BX.
01  PREC609.
    02 FG52 PIC B(4)X(40) OCCURS 3.
01  PREC610.
    02 FG53 PIC X(12). 02 FG53A PIC ZZ,ZZZ,ZZ9-. 02 FG54X. 03 FG54 PIC ZZZ,ZZZ,ZZ9.
    02 PIC X(4). 02 OCCURS 5. 03 FG55 PIC ZZZ,ZZZ,ZZ9-. 03 FG56X. 04 FG56 PIC 99/99.
01  PREC611.
    02 FG57 PIC X(10). 02 FG58 PIC BBX(8). 02 FG59 PIC Z(7)9. 02 FG60 PIC ZZ99/99/99.
    02 FG61 PIC BBBXX. 02 FG62 PIC B(5)X(10). 02 FG63 PIC BBX(60).
01  PREC612.
    02 PIC X(5). 02 OCCURS 6. 03 FG65 PIC ZZZ,ZZ9. 03 FG66 PIC Z99/99/99. 03 PIC XXX.
01  PREC613.
    02 PIC X(5). 02 OCCURS 5. 03 FG67 PIC XX. 03 FG68 PIC X. 03 FG69 PIC X(10). 03 PIC XX.
01  PREC614.
    02 FG70 PIC B(4)X(40) OCCURS 3.
01  PREC615.
    02 FG71 PIC X(12). 02 FG72 PIC ZZ9. 02 FG72A PIC ZZ9. 02 FG73 PIC Z(7),ZZ9-.
    02 FG74 PIC Z(4),ZZZ,ZZ9-. 02 FG75 PIC Z(4),ZZ9.9-. 02 FG76 PIC Z(4),ZZ9.99-.
    02 FG77 PIC ZZZ,ZZZ,ZZ9-. 02 FG77A PIC Z(4)9.9-. 02 FG78 PIC Z(4),ZZZ,ZZ9-.
    02 FG79 PIC Z(6)9.9-. 02 FG80 PIC B(9)X.
01  PREC616.
    02 FG81 PIC Z(8),ZZZ,ZZ9-. 02 FG82 PIC Z(7),ZZZ,ZZ9-. 02 FG83 PIC Z(6),ZZZ,ZZ9-.
    02 FG84 PIC Z(8),ZZZ,ZZ9-. 02 FG85 PIC Z(8),ZZZ,ZZ9-.
01  PREC617.
    02 FG86 PIC 99B. 02 FG87 PIC X(13). 02 FG88 PIC X(32). 02 FG89 PIC Z(7)9.
    02 FG90 PIC ZZZ,ZZZ,ZZ9. 02 FG91 PIC BX. 02 FG92 PIC ZZ99/99/99.
    02 FG93 PIC ZZ99/99/99. 02 FG94 PIC Z(6)9 OCCURS 4.
01  PREC618.
    02 FG97 PIC X(12). 02 FG98 PIC ZZZ9BB. 02 FG99 PIC X(60).
01  PREC619.
    02 FG100 PIC X(12). 02 FG101 PIC Z99/99/99. 02 FG102 PIC BBX(12).
    02 FG103 PIC Z99/99/99. 02 FG104 PIC B(4)X(5). 02 FG104A PIC ZZZ9.
    02 FG104B PIC ZZZ,ZZ9. 02 FG104C PIC BXX. 02 FG104D PIC BX.
    02 FG105 PIC BBBX(9). 02 FG106 PIC X(50).
01  PREC620.
    02 FG107 PIC B(5)X(12). 02 FG108 PIC Z(5),ZZ9. 02 FG108A PIC BXXX.
    02 FG109 PIC Z(5),ZZ9. 02 FG109A PIC BXXX. 02 FG110 PIC BBBX(12).
01  PREC621.
    02 FG111 PIC X(12). 02 FG112 PIC Z99/99/99. 02 FG113 PIC Z(5),ZZ9.99.
    02 FG114 PIC BBX(16). 02 FG115 PIC BX(8). 02 FG116 PIC BX(12).
    02 FG117 PIC BX(10). 02 FG118 PIC Z99/99/99. 02 FG119 PIC Z(5),ZZZ.ZZ- OCCURS 3.
01  PREC622.
    02 PIC X(52). 02 FG120 PIC X(20). 02 FG121 PIC X(9). 02 FG122 PIC 99/99/99.
    02 FG123 PIC X.
01  PREC623.
    02 FG124 PIC ZZZ9. 02 FG125 PIC BBBX(30). 02 FG126 PIC ZZZ9. 02 FG126A PIC ZZ9.
    02 FG127 PIC Z(8)9. 02 FG127A PIC ZZ9. 02 FG128 PIC Z(5)9.
    02 FG129 PIC Z(4)9.99. 02 FG129A PIC Z(7)9. 02 FG129B PIC BBXX.
01  PREC624.
    02 FG130 PIC X(7). 02 FG131 PIC X(12). 02 FG132 PIC X(20). 02 FG133 PIC B(4)X(60).
01  PREC625.
    02 FG134 PIC X(10). 02 FG134A PIC BBX(10). 02 FG134B PIC BXX.
    02 FG135 PIC B(4)XX. 02 FG136 PIC ZZZ99/99/99. 02 FG136A PIC ZZZ99/99/99.
    02 FG136B PIC Z99/99/99.
01  PREC626.
    02 FG137 PIC BBBX(12). 02 FG137A PIC BX(10). 02 FG137B PIC Z(6)9.
    02 FG137C PIC BBXXX. 02 FG138 PIC BBX(6). 02 FG138A PIC BBX(6).
    02 FG139 PIC BBXX. 02 PIC X(4).
    02 OCCURS 5. 03 FG140 PIC BXX. 03 FG140A PIC X. 03 FG140B PIC X(10).
01  PREC627.
    02 PIC X(6). 02 OCCURS 6. 03 FG141 PIC Z(6),ZZ9. 03 FG142 PIC Z99/99/99.
      03 FG143 PIC BX.
01  PREC628.
    02 FG144 PIC X(10). 02 FG145 PIC Z(5)9. 02 FG146 PIC BBBXXX.
    02 OCCURS 5. 03 PIC XXX. 03 FG147 PIC ZZZ,ZZ9. 03 FG148 PIC Z99/99/99.
01  PREC629.
    02 FG152 PIC B(4)X(40) OCCURS 3.
01  PREC630.
    02 FG153 PIC B(4)X(40) OCCURS 3.
01  PREC631.
    02 FG154 PIC X(62).
    02 OCCURS 5. 03 FG155 PIC BXX. 03 FG156 PIC X. 03 FG157 PIC X(10).
01  PREC632.
    02 FG158 PIC X(10). 02 FG158A PIC BBX(8). 02 FG159 PIC BBX(12).
    02 FG160 PIC BBX(32). 02 FG161 PIC ZZ99/99/99. 02 FG162 PIC ZZZ9-.
    02 FG163 PIC ZZZ9. 02 FG164 PIC ZZZ,ZZ9.999. 02 FG165 PIC ZZZ,ZZZ,ZZ9-.
    02 FG166 PIC ZZ,ZZZ,ZZ9.99-. 02 FG167 PIC XX.
01  PREC633.
    02 FG168 PIC X(4). 02 FG169 PIC BX(30). 02 FG170 PIC BX(13). 02 FG171 PIC Z(6)9.
    02 FG172 PIC Z99/99/99. 02 FG173 PIC BBX. 02 FG174 PIC BBBX(6). 02 FG175 PIC BBX(53).
01  PREC634.
    02 FG177 PIC X(4). 02 FG178 PIC BX(30). 02 FG179 PIC BX(13). 02 FG180 PIC Z(6)9.
    02 FG181 PIC Z99/99/99. 02 FG182 PIC BBX. 02 FG183 PIC BBBX(6). 02 FG184 PIC BBX(53).
01  PREC635.
    02 FG186 PIC X(8). 02 FG187 PIC X(36). 02 FG188 PIC X(30).
    02 FG189 PIC Z(4),ZZZ,ZZ9- OCCURS 4.
01  PREC636.
    02 PIC X(8). 02 FG195 PIC Z(5)9. 02 FG196 PIC ZZ99/99/99.
    02 FG197 PIC ZZ,ZZZ,ZZ9.99- OCCURS 6.
01  PREC637.
    02 FG200 PIC X(20). 02 FG201 PIC BB9. 02 FG202 PIC BBX(6).
    02 OCCURS 5. 03 FG203 PIC B(10)9. 03 FG204 PIC BBBX. 03 FG205 PIC BBBX.
01  PREC638.
    02 FG208 PIC Z9. 02 FG209 PIC Z(5),ZZZ,ZZ9-. 02 FG210 PIC Z(5),ZZZ,ZZ9-.
01  PREC639.
    02 FG211 PIC X(10). 02 FG211A PIC BBX(8). 02 FG211B PIC ZZ.ZZBB.
    02 OCCURS 15. 03 FG213 PIC ZZ.Z(4).
      03 FG214 REDEFINES FG213 PIC ZZ.ZZ. 03 FG215 REDEFINES FG213 PIC ZZ.ZZZ.
01  PREC640.
    02 PIC X(37). 02 FG218 PIC X(58).
01  PREC641.
    02 FG219 PIC X(9). 02 FG220 PIC X(42). 02 FG221 PIC X(9). 02 FG222 PIC X(42).
    02 PIC X(9). 02 FG223 PIC X(12). 02 FG224 PIC X(9). 02 FG225 REDEFINES FG224 PIC Z(6)9.
01  PREC642.
    02 FG226 PIC ZZ9. 02 FG227 PIC BBBX(14). 02 FG228 PIC X(32).
    02 FG229 PIC ZZZ,ZZZ,ZZ9-. 02 FG229A PIC ZZZ,ZZZ,ZZ9-.
01  PREC643.
    02 FG230 PIC ZZB(4). 02 FG231 PIC X(12). 02 FG232 PIC X(9).
    02 OCCURS 15. 03 FG233 PIC ZZ.9999.
      03 FG234 REDEFINES FG233 PIC ZZ.99. 03 FG235 REDEFINES FG233 PIC ZZ.999.
01  PREC644.
    02 PIC X(18). 02 FG235A PIC X(12).
01  PREC645.
    02 FG236 PIC X(48). 02 FG237 PIC X(84).
01  PREC646.
    02 FG238 PIC X(6).
01  PREC647.
    02 FG240 PIC X(5). 02 FG241 PIC Z99/99/99. 02 PIC X(10). 02 FG242 PIC X(54).
    02 PIC X(10). 02 FG243 PIC X(44).
01  PREC648.
    02 PIC X(6). 02 FG244 PIC X(14). 02 FG245 PIC X(34).
01  PREC649.
    02 PIC X(6). 02 FG246 PIC X(12). 02 FG247 PIC X(12).
01  PREC650.
    02 FG250 PIC 9(7). 02 FG251 PIC BX(12). 02 FG252 PIC BX(32).
    02 FG253 PIC Z(6)9. 02 FG253A PIC X. 02 FG253B PIC XX. 02 FG254 PIC X(10).
    02 FG255 PIC ZZ,ZZZ,ZZ9-. 02 FG256 PIC ZZ,ZZZ,ZZ9-. 02 FG257 PIC BX(15).
01  PREC651.
    02 FG258 PIC ZZ9. 02 FG259 PIC Z(5)9. 02 FG260 PIC Z(4),ZZ9.99.
01  PREC652.
    02 FG261 PIC X(6). 02 FG262 PIC Z(7)9. 02 FG263 PIC ZZ99/99/99.
    02 FG264 PIC Z(5),ZZ9.99-. 02 FG265 PIC Z(5),ZZ9.99-. 02 FG266 PIC Z(5),ZZ9.99-.
    02 FG267 PIC Z(5),ZZ9.99-. 02 FG268 PIC Z(9)9. 02 FG269 PIC B(4)X.
    02 FG269A PIC BBBXX. 02 FG270 PIC BBBX(12). 02 FG270A PIC ZZ99/99/99.
01  PREC653.
    02 FG271 PIC ZZ9. 02 FG272 PIC BBX(14). 02 FG273 PIC X(32).
    02 FG274 PIC Z(7)9. 02 FG275 PIC ZZ99/99/99. 02 FG276 PIC Z(6),ZZZ,ZZ9-.
    02 FG277 PIC Z(4),ZZZ,ZZ9.99-. 02 FG277A PIC BXXX. 02 FG278 PIC Z(4),ZZZ,ZZ9-.
    02 FG279 PIC B(6)XXX. 02 REDEFINES FG279. 03 FG280 PIC Z(7)9. 03 FG281 PIC X.
01  PREC654.
    02 FG282 PIC X(8). 02 FG283 PIC X(34). 02 FG284 PIC X(9).
01  PREC655.
    02 FG285 PIC X(14). 02 FG286 PIC X(32).
01  PREC656.
    02 FG287 PIC X(8). 02 FG288 PIC X(32). 02 FG289 PIC Z(7)9.
    02 FG290 PIC ZZ99/99/99. 02 FG291 PIC Z(6),ZZZ,ZZ9-.
    02 FG292 PIC Z(4),ZZZ,ZZ9.99-. 02 FG292A PIC BXXX. 02 FG293 PIC Z(4),ZZZ,ZZ9-.
01  PREC657.
    02 FG294 PIC X(4). 02 FG294A PIC Z9. 02 FG294B PIC BBX(45).
01  PREC658.
    02 FG295 PIC X(14). 02 FG296 PIC ZZ99/99/99. 02 FG297 PIC Z(5),ZZ9.99-.
    02 FG298 PIC BXXX.
01  PREC659.
    02 FG299 PIC X(10). 02 FG300 PIC Z(7)9. 02 FG301 PIC BBX(12).
    02 FG302 PIC BBX(32). 02 FG303 PIC Z(5)9. 02 FG304 PIC Z(5)9.
    02 FG306 PIC ZZZ,ZZZ,ZZ9-. 02 FG307 PIC Z99/99/99. 02 FG308 PIC Z99/99/99.
    02 FG309 PIC BBXXX. 02 REDEFINES FG309. 03 FG309A PIC ZZZ9. 03 FG309B PIC X.
    02 FG310 PIC Z(4),ZZZ,ZZ9-.
01  PREC660.
    02 FG311 PIC Z(5)9. 02 FG312 PIC BBX(8). 02 FG313 PIC ZZ99/99/99.
    02 FG314 PIC BX. 02 FG315 PIC Z(5)9. 02 FG316 PIC BBX(12).
    02 FG317 PIC BBX(32). 02 FG317A PIC BBX(20). 02 FG317B PIC Z(5),ZZ9.99.
01  PREC661.
    02 FG318 PIC ZZ9. 02 FG319 PIC BBX(45).
01  PREC662.
    02 PIC X(5). 02 FG320 PIC X(12). 02 FG321 PIC BBX(32).
01  PREC663.
    02 FG322 PIC X(4). 02 FG323 PIC 99. 02 FG324 PIC BBX(45).
01  PREC664.
    02 FG325 PIC X(14). 02 FG326 PIC X(32). 02 FG327 PIC Z(5),ZZZ,ZZ9-.
    02 FG328 PIC Z(5),ZZ9.99. 02 FG329 PIC Z(5),ZZZ,ZZ9-.
01  PREC665.
    02 FG330 PIC X(27). 02 FG331 PIC ZZZ9.
01  PREC666.
    02 FG332 PIC X(8). 02 FG333 PIC X(32). 02 FG334 PIC ZZ,ZZZ,ZZ9.99-.
    02 FG335 PIC Z(7)9. 02 FG336 PIC Z(8)9. 02 FG337 PIC Z(10)9.
01  PREC667.
    02 PIC X(14). 02 FG338 PIC 9(4). 02 PIC X(12). 02 FG339 PIC 9(4).
    02 PIC X(12). 02 FG340 PIC 9(4).
01  PREC668.
    02 FG341 PIC X(11). 02 FG342 PIC Z(8)9.9. 02 FG343 PIC Z(13)9.9.
    02 PIC X(7). 02 FG344 PIC ZZZ,ZZZ,ZZ9. 02 FG345 PIC Z(8)9-.
01  PREC669.
    02 FG347 PIC Z9. 02 FG348 PIC BBBX(32)B. 02 FG349 PIC ZZZ,ZZZ,ZZ9- OCCURS 3.
    02 FG350 PIC Z(4)9-.
01  PREC670.
    02 FG352 PIC X(32)B. 02 FG353 PIC ZZZ,ZZZ,ZZ9- OCCURS 3. 02 FG354 PIC Z(4)9-.
01  PREC671.
    02 FG355 PIC X(25)B(5). 02 FG355A PIC ZZZ,ZZZ,ZZ9- OCCURS 3.
01  PREC672.
    02 FG356 PIC X(15) OCCURS 8.
01  PREC673.
    02 FG357 PIC Z9. 02 FG358 PIC ZZZ9. 02 FG359 PIC BBBX(4). 02 FG360 PIC Z(7)9.
    02 FG361 PIC Z(6),ZZ9.9. 02 FG362 PIC BXXX. 02 PIC XXX.
    02 FG363 PIC Z(4),ZZZ.Z OCCURS 6.
01  PREC674.
    02 FG366 PIC X(7). 02 FG367 PIC X(10). 02 FG368 PIC BBBX(7).
    02 FG369 PIC 99/99/99. 02 FG370 PIC ZZ99/99/99. 02 FG371 PIC X.
    02 FG372 PIC 99/99/99. 02 FG373 PIC BBBX(7). 02 FG373A PIC X(5).
    02 FG374 PIC BBX(11). 02 FG374A PIC X(5). 02 FG375 PIC BBBX(5).
    02 FG375A PIC X(20). 02 FG376 PIC BBX(6). 02 FG376A PIC XX.
01  PREC675.
    02 FG378 PIC B(4)X(70).
01  PREC676.
    02 PIC X(16). 02 OCCURS 4. 03 FG379 PIC Z(8),ZZ9. 03 FG380 PIC Z99/99/99.
      03 FG380A PIC BX(5).
01  PREC677.
    02 OCCURS 3. 03 PIC X(4). 03 FG381 PIC X(40).
01  PREC678.
    02 FG382 PIC X(11). 02 FG383 PIC Z(5)9. 02 FG384 PIC BBX.
    02 FG385 PIC Z(4),ZZ9. 02 FG386 PIC BXXX.
    02 PIC X(12). 02 OCCURS 2. 03 FG389 PIC B(6)X(9). 03 FG390 PIC ZZZ,ZZZ,ZZ9.
      03 FG391 PIC Z99/99/99. 03 FG392 PIC X. 03 FG393 PIC 99/99/99.
01  PREC679.
    02 FG394 PIC X(8). 02 FG395 PIC X(10). 02 FG396 PIC BBBX(7).
    02 FG397 PIC 99/99/99. 02 FG398 PIC ZZ99/99/99. 02 FG399 PIC X.
    02 FG400 PIC 99/99/99. 02 FG401 PIC BBBX(6). 02 FG402 PIC X(20).
    02 FG403 PIC BBBX(10). 02 FG404 PIC XX.
01  PREC680.
    02 FG408 PIC X(11). 02 FG409 PIC X(10). 02 FG410 PIC Z(6)9.
    02 FG411 PIC BBX(12). 02 FG412 PIC BX. 02 FG413 PIC BBBX(6).
    02 FG414 PIC Z(4)9. 02 FG415 PIC BXXX.
01  PREC681.
    02 PIC X(44). 02 OCCURS 2. 03 FG418 PIC B(6)X(9). 03 FG419 PIC ZZZ,ZZZ,ZZ9.
      03 FG420 PIC Z99/99/99. 03 FG421 PIC X. 03 FG422 PIC 99/99/99.
01  PREC682.
    02 FG424 PIC B(4)X(70).
01  PREC683.
    02 PIC X(6). 02 OCCURS 6. 03 FG425 PIC Z(5),ZZ9. 03 FG426 PIC Z99/99/99.
      03 FG427 PIC BXX.
01  PREC684.
    02 OCCURS 3. 03 PIC X(4). 03 FG430 PIC X(40).
01  PREC685.
    02 FG431. 03 FG432 PIC X(9). 03 FG433 PIC Z9. 02 PIC X.
    02 FG435 PIC X(14). 02 FG436 PIC Z(4),ZZZ,ZZ9-.
01  PREC686.
    02 PIC X(12). 02 FG438 PIC X(19). 02 FG439 PIC ZZZ9. 02 FG440 PIC BXXB.
    02 FG441 PIC ZZZ9. 02 FG442 PIC BBX. 02 FG443 PIC ZZ9.9. 02 FG444 PIC XXX.
01  PREC687.
    02 FG446 PIC X(26) OCCURS 5.
01  PREC688.
    02 FG447 PIC X(12). 02 FG448 PIC BBXX. 02 FG449 PIC B(6)XX.
    02 FG450 PIC ZZ99/99/99.
01  PREC689.
    02 FG452 PIC BBBXXX. 02 FG453 PIC BBX(12). 02 FG454 PIC BX(10).
    02 FG455 PIC Z(6)9. 02 FG456 PIC BBXXX. 02 FG457 PIC ZZZ,ZZZ,ZZ9-.
    02 FG458 PIC XX. 02 FG459 PIC Z(4)9.999. 02 FG460 PIC BXX.
    02 FG461 PIC ZZZ,ZZZ,ZZ9-. 02 FG462 PIC Z99/99/99.
01  PREC690.
    02 OCCURS 3. 03 FG464 PIC X(13). 03 FG465 PIC X(5). 03 FG466 PIC X(13).
      03 PIC X(13).
01  PREC691.
    02 FG467 PIC X(12). 02 FG468 PIC Z99/99/99. 02 FG469 PIC BBX(12).
    02 FG470 PIC Z99/99/99. 02 FG471 PIC BBX(10). 02 FG472 PIC BX(10).
    02 FG473 PIC BBX(30) OCCURS 2.
01  PREC692.
    02 FG474 PIC B(5)X(12). 02 FG475 PIC Z(5),ZZ9. 02 FG475A PIC BXXX.
    02 FG476 PIC Z(5),ZZ9. 02 FG476A PIC BXXX. 02 FG477 PIC BBBX(12).
01  PREC693.
    02 FG478 PIC X(6). 02 FG479 PIC BBX(32).
01  PREC694.
    02 FG480 PIC B(8)X(12). 02 FG481 PIC BBX(32). 02 FG482 PIC ZZZ,ZZZ,ZZ9-.
    02 FG483 PIC ZZZ,ZZZ,ZZ9-. 02 FG484 PIC Z,ZZZ,ZZ9.99-. 02 FG485 PIC XX.
01  PREC695.
    02 FG486 PIC B(8)X(20). 02 FG487 PIC ZZ9.99. 02 FG488 PIC X(10).

FD  USERS.
01  US-RECORD PIC X(1500).
01  US-REC.
    02 US-KEY.
      03 US-USER PIC X(12).
    02 US-KN.
      03 US-NUM PIC 99.
    02 US-TDX OCCURS 24. 03 US-TD PIC X OCCURS 40.
    02 US-PR-FILE PIC X(8).
    02 US-PR-NO PIC 99.
    02 US-PR-EXT PIC XXX.
    02 US-PR-QUEUE PIC X(10).
    02 US-PC PIC 9.
    02 US-NAME PIC X(24).
    02 US-PRNM PIC XX.
    02 US-CFLD PIC 99 OCCURS 10.
    02 US-PFLD PIC 99 OCCURS 10.
*      FILLER X(436)

FD  GLTOOLCOST.
01  GTC-RECORD PIC X(30).
01  GTC-REC.
    02 GTC-KEY.
      03 GTC-GL PIC 9(18).
    02 GTC-AMT PIC S9(7)V99 COMP-3.
*      FILLER X(7)

FD  TRAUDIT.
01  YT-RECORD PIC X(75).
01  YT-REC.
    02 YT-KEY.
      03 YT-CUS PIC X(6).
      03 YT-INV PIC 9(6).
      03 YT-DATE PIC 9(6).
      03 YT-TIME PIC 9(8).
    02 YT-TYPE PIC 9 COMP-3.
    02 YT-AMT PIC S9(7)V99 COMP-3.
    02 YT-IDATE PIC 9(6) COMP-3.
    02 YT-TDATE PIC 9(6) COMP-3.
    02 YT-TERMS PIC X(6).
*      FILLER X(29)

FD  AUDIT BLOCK 2048.
01  AU-RECORD PIC X(650).
01  AU-REC.
    02 AU-KEY.
      03 AU-K PIC 99.
      03 AU-L PIC 99.
      03 AU-DATE PIC 9(6).
      03 AU-TIME PIC 9(8).
    02 AU-IND PIC 9 COMP-3.
    02 AU-DATA PIC X(631).

FD  INFOFL.
01  IF-RECORD PIC X(1800).
01  IF-REC.
    02 IF-ORDNO PIC 9(6).
    02 IF-INVNO PIC 9(6).
    02 IF-PST PIC 99.
    02 IF-BLNO PIC 9(7).
    02 IF-SPINVNO PIC 9(6).
    02 IF-GST PIC 99.
    02 IF-RNO PIC 9(6) OCCURS 10.
    02 IF-PRINTER PIC 9.
    02 IF-GMR-DATE PIC 9(6).
    02 IF-FILL1 PIC X(18).
    02 OCCURS 15. 03 IF-OFF-DATE1 PIC 9(6). 03 IF-OFF-DATE2 PIC 9(6).
    02 IF-RMSUR PIC 9(4)V999.
    02 IF-SURCH PIC V999 OCCURS 9.
    02 IF-FILL2 PIC X(5).
    02 IF-SHP-SAVNO PIC 9(6).
    02 IF-DXNO PIC 9(4).
    02 IF-HST PIC 99.
    02 IF-QST PIC 99V9.
    02 IF-SALMTD-IG PIC S9(6)V99.
    02 IF-SAV-SAL-IG PIC S9(6)V99.
    02 IF-QUOTNO PIC 9(6).
    02 IF-LABNO PIC 9(8).
    02 OCCURS 5. 03 IF-EXCHX. 04 IF-EXCH PIC 9V9(4) OCCURS 12.
    02 IF-EXCH-AP PIC 9V9(4).
    02 IF-SHP-IND PIC 9.
    02 IF-SHP-DATE PIC 9(6).
    02 IF-SAV-SAL PIC S9(6)V99 OCCURS 5.
    02 IF-FILL3 PIC X(9).
    02 IF-CST-NUM PIC 99 OCCURS 8.
    02 IF-CST-PERIOD PIC X(10) OCCURS 8.
    02 IF-ITORDNO PIC 9(5).
    02 IF-EXCH-YY PIC 99.
    02 IF-DEM-DATE PIC 9(6).
    02 IF-CST-FREIGHT PIC 99V999.
    02 IF-MAINTNO PIC 9(6).
    02 IF-PRNSEQ PIC 99.
    02 IF-RMPROC PIC 999V99 OCCURS 8.
    02 IF-RMPROC-A PIC 999V99 OCCURS 2.
    02 IF-RMCLEAN PIC 999V99 OCCURS 8.
    02 IF-SALMTD PIC S9(7)V99 OCCURS 8.
    02 OCCURS 2. 03 IF-SALVAL PIC S9(8)V99 OCCURS 27.
    02 IF-USALMTD PIC S9(6)V99 OCCURS 5.
    02 IF-SAV-USAL PIC S9(6)V99 OCCURS 5.
*      FILLER X(147)

FD  EDINFO.
01  EI-RECORD PIC X(120).
01  EI-REC.
    02 EI-TOW-ISA PIC 9(6).
    02 EI-GMC-ISA PIC 9(6).
    02 EI-CONTRL-ISA PIC 9(6).
    02 EI-CHRY-ISA PIC 9(6).
    02 EI-RBW-ISA PIC 9(6).
    02 EI-AOS-ISA PIC 9(6).
    02 EI-DANA-ISA PIC 9(6).
    02 EI-TRW-ISA PIC 9(6).
    02 EI-UTA-ISA PIC 9(6).
    02 EI-MGM-ISA PIC 9(6).
    02 EI-WOOD-ISA PIC 9(6).
    02 EI-MOD-ISA PIC 9(6).
    02 EI-BEN-ISA PIC 9(6).
    02 EI-VEN-ISA PIC 9(6).
*      FILLER X(36)

FD  EDI VALUE OF ID EDI-ID RECORD VARYING 0 TO 400 DEPENDING EDI-SZ.
01  ED-RECORD PIC X(400).

FD  EXPFL VALUE OF ID EXP-ID RECORD VARYING 0 TO 500 DEPENDING EXP-SZ.
01  EXP-RECORD PIC X(500).
* note 244.2

FD  DOCFL VALUE OF ID DOC-ID RECORD VARYING 0 TO 132 DEPENDING DOC-SZ.
01  DOC-RECORD PIC X(132).

FD  LABFL VALUE OF ID LAB-ID RECORD VARYING 0 TO 500 DEPENDING LAB-SZ.
01  LAB-RECORD PIC X(500).

FD  LASFL VALUE OF ID LAS-ID.
01  LAS-RECORD PIC X(512).

FD  DATFL VALUE OF ID DAT-ID RECORD VARYING 0 TO 200 DEPENDING DAT-SZ.
01  DAT-RECORD PIC X(200).
* note 279
01  DAT-REC-AR.
    02 DAT-R1 PIC 99.
    02 DAT-R2 PIC 9(6).
    02 DAT-R3 PIC XX.
    02 DAT-R4 PIC 9(7).
    02 DAT-R5 PIC X(6).
    02 DAT-R6 PIC 9(8).
    02 DAT-R7 PIC X(9).
    02 DAT-R8 PIC 9(6).
    02 DAT-R9 PIC -9(5).99.
    02 DAT-R10 PIC -9(7).99.
    02 DAT-R11 PIC XXX.
    02 DAT-R12 PIC 9.
01  DAT-REC-AP.
    02 DAT-P1 PIC 99.
    02 DAT-P2 PIC X(15).
    02 DAT-P3 PIC XX.
    02 DAT-P4 PIC 9(4).
    02 DAT-P5 PIC 9(8).
    02 DAT-P6 PIC X(18).
    02 DAT-P7 PIC X(8).
    02 DAT-P8 PIC -9(5).99.
    02 DAT-P9 PIC -9(7).99.
    02 DAT-P10 PIC XXX.
    02 DAT-P11 PIC 9.

FD  TABLES.
01  T-RECORD PIC X(60).
01  T-REC.
    02 T-KEY.
      03 T-TBL PIC 99.
      03 T-NO PIC 999.
    02 T-LINE PIC X(45).
    02 REDEFINES T-LINE.
      03 T-OPM PIC 999.
    02 REDEFINES T-LINE.
      03 T-DIS PIC 999 OCCURS 4.
    02 REDEFINES T-LINE.
      03 T-GH1 PIC 9(6). 03 T-GH2 PIC 999. 03 T-GH3 PIC 99.
    02 REDEFINES T-LINE.
      03 T-PLR PIC 9(4)V99. 03 T-PLS PIC X(39).
    02 REDEFINES T-LINE.
      03 T-CTA PIC XXX. 03 T-CTX PIC X. 03 T-CTN PIC X(20).
    02 REDEFINES T-LINE.
      03 T-TE1 PIC 99. 03 T-TE2 PIC X(25).
    02 REDEFINES T-LINE.
      03 T-GP1 PIC 99.
    02 REDEFINES T-LINE.
      03 T-PCN PIC 999. 03 T-PCX1 PIC X. 03 T-PCD PIC X(31). 03 T-PCX2 PIC X.
      03 T-PCI PIC 99. 03 T-PCU PIC 99. 03 T-PCX3 PIC X. 03 T-PCS PIC 999.
*      FILLER X(10)
* note 173

FD  SIXIN VALUE OF ID SIX-ID RECORD VARYING 0 TO 900 DEPENDING SIX-SZ.
01  SIN-RECORD PIC X(900).
01  SIN-REC.
    02 SIN-DRAW PIC X(8).
    02 SIN-PAGE PIC 9.
    02 SIN-NLINES PIC 9(4).

FD  PCLIN VALUE OF ID PIN-ID.
01  PIN-RECORD PIC X(512).
01  PIN-REC.
    02 PIN-DRAW PIC X(8).
    02 PIN-PAGE PIC 9.
    02 PIN-NLINES PIC 9(4).

FD  DRAWINGS BLOCK 4096 RECORD VARYING 13 TO 900 DEPENDING SIX-SZ.
01  DR-RECORD PIC X(900).
01  DR-REC.
    02 DR-KEY.
      03 DR-DRAW PIC X(8).
      03 DR-PAGE PIC 9.
      03 DR-LINE PIC 9(4).
    02 DR-DATA PIC X(887).
    02 REDEFINES DR-DATA.
      03 DR-NLINES PIC 9(4).
      03 DR-DATE PIC 9(6).
      03 DR-TIME PIC 9(8).

FD  PDRAWINGS BLOCK 4096.
01  DG-RECORD PIC X(525).
01  DG-REC.
    02 DG-KEY.
      03 DG-DRAW PIC X(8).
      03 DG-PAGE PIC 9.
      03 DG-LINE PIC 9(4).
    02 DG-DATA PIC X(512).
    02 REDEFINES DG-DATA.
      03 DG-NLINES PIC 9(4).
      03 DG-DATE PIC 9(6).
      03 DG-TIME PIC 9(8).

FD  LABELS.
01  LA-RECORD PIC X(240).
01  LA-REC.
    02 LA-KEY.
      03 LA-NO PIC 9(8).
    02 LA-KL.
      03 LA-ZLYEAR PIC 9(4).
      03 LA-ZLOT PIC 9(7).
      03 LA-ZDATE PIC 9(6).
      03 LA-ZTIME PIC 9(8).
    02 LA-PR PIC 9 COMP-3.
    02 LA-USER PIC X(12).
    02 LA-SRC PIC 9 COMP-3.
    02 LA-TYPE PIC 99 COMP-3.
    02 LA-LOT PIC 9(7) COMP-3.
    02 LA-PROD PIC X(12).
    02 LA-DATE PIC 9(6) COMP-3.
    02 LA-CUS PIC X(6).
    02 LA-CUSORD PIC X(9).
    02 LA-FILL1 PIC XX.
    02 LA-QPACK PIC 9(5) COMP-3.
    02 LA-QTY PIC 9(5) COMP-3.
    02 LA-ORD PIC 9(6) COMP-3.
    02 LA-KANBAN PIC X(10).
    02 LA-LABINF PIC X(115).
*      FILLER X(19)

FD  SHIPVIA.
01  SV-RECORD PIC X(120).
01  SV-REC.
    02 SV-CARRIER PIC X(40).
    02 SV-SCAC PIC X(4).
    02 SV-METHOD PIC XX.
    02 SV-POOL PIC X(7).
    02 SV-EQNUM PIC X(10).
    02 SV-EQINIT PIC X(4).
    02 SV-SORT PIC 99 COMP-3.
*      FILLER X(51)

FD  PACKING.
01  PK-RECORD PIC X(115).
01  PK-REC.
    02 PK-KEY.
      03 PK-NO PIC 999.
    02 PK-PART PIC X(12).
    02 PK-DESC PIC X(40).
    02 PK-MAX PIC 99 COMP-3.
    02 PK-PALLET PIC 999 COMP-3.
*      FILLER X(56)

FD  SALTOT.
01  ST-RECORD PIC X(60).
01  ST-REC.
    02 ST-KEY.
      03 ST-TER PIC 99.
      03 ST-CAT PIC 99.
      03 ST-YY PIC 99.
      03 ST-MM PIC 99.
      03 ST-DD PIC 99.
      03 ST-US PIC 9.
    02 ST-AMT PIC S9(7)V99 COMP-3.
    02 ST-WEIGHT PIC S9(7) COMP-3.
    02 ST-QTY PIC S9(7) COMP-3.
    02 ST-SURCHARGE PIC S9(7)V99 COMP-3.
*      FILLER X(31)

FD  SALHIST BLOCK 2048.
01  SH-RECORD PIC X(135).
01  SH-REC.
    02 SH-KEY.
      03 SH-CUS PIC X(6).
      03 SH-PROD PIC X(12).
      03 SH-CDATE PIC 9(6).
      03 SH-CTIME PIC 9(8).
    02 SH-KP.
      03 SH-KPROD PIC X(12).
      03 SH-KCUS PIC X(6).
      03 SH-KDATE PIC 9(6).
      03 SH-KTIME PIC 9(8).
    02 SH-ORD PIC 9(6) COMP-3.
    02 SH-INVNO PIC 9(6) COMP-3.
    02 SH-CUSORD PIC X(9).
    02 SH-DATE PIC 9(6) COMP-3.
    02 SH-QTY PIC S9(9) COMP-3.
    02 SH-AMT PIC S9(7)V99 COMP-3.
    02 SH-WEIGHT PIC S9(7) COMP-3.
    02 SH-CAT PIC 99 COMP-3.
    02 SH-BL PIC 9(7) COMP-3.
    02 SH-US PIC 9 COMP-3.
    02 SH-DATE-REQ PIC 9(6) COMP-3.
    02 SH-SHIPTO PIC 99 COMP-3.
    02 SH-SAL PIC 99 COMP-3.
    02 SH-SALCOM PIC 99V99 COMP-3.
    02 SH-FILL1 PIC X.
    02 SH-SUR PIC 9 COMP-3.
    02 SH-SURCHARGE PIC S9(5)V99 COMP-3.
*      FILLER X(12)
* note 287.1

FD  LOTHIST.
01  LN-RECORD PIC X(90).
01  LN-REC.
    02 LN-KEY.
      03 LN-CUS PIC X(6).
      03 LN-DATE PIC 9(6).
      03 LN-TIME PIC 9(8).
    02 LN-KL.
      03 LN-LOT PIC 9(7).
    02 LN-KI.
      03 LN-INV PIC 9(6).
    02 LN-PROD PIC X(12).
    02 LN-QTY PIC S9(7) COMP-3.
    02 LN-QTY-PACK PIC 9(5) COMP-3.
    02 LN-CARTONS PIC 999 COMP-3.
    02 LN-PARTIAL PIC 9 COMP-3.
    02 LN-ORD PIC 9(6) COMP-3.
    02 LN-BL PIC 9(7) COMP-3.
    02 LN-CUSORD PIC X(9).
    02 LN-SHIPTO PIC 99 COMP-3.
*      FILLER X(16)

FD  SALSUM.
01  SM-RECORD PIC X(115).
01  SM-REC.
    02 SM-KEY.
      03 SM-CUS PIC X(6).
      03 SM-PROD PIC X(12).
    02 SM-KP.
      03 SM-KPROD PIC X(12).
      03 SM-KCUS PIC X(6).
    02 OCCURS 5.
      03 SM-QTY PIC S9(9) COMP-3.
      03 SM-AMT PIC S9(9) COMP-3.
*      FILLER X(29)

FD  STATEMENT.
01  SW-RECORD PIC X(50).
01  SW-REC.
    02 SW-KEY.
      03 SW-CUS PIC X(6).
      03 SW-DATE PIC 9(6).
      03 SW-LINE PIC 9(4).
    02 SW-DATA PIC X(30).
    02 REDEFINES SW-DATA.
      03 SW-BAL PIC S9(7)V99 COMP-3 OCCURS 6.
    02 REDEFINES SW-DATA.
      03 SW-TDATE PIC 9(6) COMP-3.
      03 SW-INV PIC 9(6) COMP-3.
      03 SW-AMT PIC S9(7)V99 COMP-3.
      03 SW-CUSORD PIC X(9).
      03 SW-BL PIC 9(7) COMP-3.
*      FILLER X(4)

FD  TRANS.
01  TR-RECORD PIC X(75).
01  TR-REC.
    02 TR-KEY.
      03 TR-CUS PIC X(6).
      03 TR-KI.
        04 TR-INV PIC 9(6).
    02 TR-KB.
      03 TR-BL PIC 9(7).
      03 TR-BINV PIC 9(6).
    02 TR-ORD PIC 9(6) COMP-3.
    02 TR-DATE PIC 9(6) COMP-3.
    02 TR-AMT PIC S9(7)V99 COMP-3.
    02 TR-AMT-ORIG PIC S9(7)V99 COMP-3.
    02 TR-CUSORD PIC X(9).
    02 TR-DATE-PAY PIC 9(6) COMP-3.
    02 TR-TERMS PIC X(6).
    02 TR-DATE-PREV PIC 9(6) COMP-3 OCCURS 2.
*      FILLER X(5)

FD  SALESMAN.
01  SN-RECORD PIC X(115).
01  SN-REC.
    02 SN-KEY.
      03 SN-NO PIC 99.
    02 SN-SALCOM PIC 99V99 COMP-3.
    02 SN-NAME PIC X(30).
*      FILLER X(80)

FD  CUSCONT.
01  CY-RECORD PIC X(1500).
01  CY-REC.
    02 CY-KEY.
      03 CY-NO PIC X(6).
    02 OCCURS 10.
      03 CY-FIRST PIC X(10).
      03 CY-LAST PIC X(10).
      03 CY-POSITION PIC X(10).
      03 CY-PHONE PIC X(13).
      03 CY-EXT PIC X(4).
      03 CY-FAX PIC X(13).
      03 CY-EMAIL PIC X(30).
      03 CY-CITY PIC X(15).
      03 CY-STATE PIC XXX.
      03 CY-COUNTRY PIC X(5).
      03 CY-FILL1 PIC X(17).
*      FILLER X(194)

FD  CUSTOMER BLOCK 2048.
01  C-RECORD PIC X(390).
01  C-REC.
    02 C-KEY.
      03 C-NO PIC X(6).
    02 C-TER PIC 99 COMP-3.
    02 C-PROV PIC 99 COMP-3.
    02 C-SAL PIC 99 COMP-3.
    02 C-KN.
      03 C-NAME PIC X(32).
    02 C-ADD1 PIC X(24).
    02 C-ADD2 PIC X(24).
    02 C-EDICF PIC 9 COMP-3.
    02 C-US PIC 9 COMP-3.
    02 C-MTEST PIC 9 COMP-3.
    02 C-SURLN PIC 9 COMP-3.
    02 C-HOLD PIC 9 COMP-3.
    02 C-VIA PIC 99 COMP-3.
    02 C-STAT PIC 9 COMP-3.
    02 C-BACK PIC 9 COMP-3.
    02 C-INS PIC 9(7) COMP-3.
    02 C-CREDIT PIC 9(8) COMP-3.
    02 C-DB PIC XXX.
    02 C-GST PIC X(8).
    02 C-PST PIC X(8).
    02 C-TOT PIC S9(7)V99 COMP-3.
    02 C-CUR PIC S9(7)V99 COMP-3.
    02 C-30 PIC S9(7)V99 COMP-3.
    02 C-60 PIC S9(7)V99 COMP-3.
    02 C-90 PIC S9(7)V99 COMP-3.
    02 C-120 PIC S9(7)V99 COMP-3.
    02 C-MTD PIC S9(9) COMP-3.
    02 C-YTD PIC S9(9) COMP-3.
    02 C-ORD PIC S9(7)V99 COMP-3.
    02 C-TYPE PIC X.
    02 C-POST PIC X(10).
    02 C-SUPPLIER PIC X(15).
    02 C-INFO PIC X(30) OCCURS 3.
    02 C-LAST PIC S9(9) COMP-3.
    02 C-BLAST PIC S9(9) COMP-3.
    02 C-CONTRA PIC 9(7) COMP-3.
    02 C-CRDATE PIC 9(6) COMP-3.
    02 C-INACTIVE PIC 9 COMP-3.
    02 C-PAY-NUM PIC S9(5) COMP-3 OCCURS 3.
    02 C-PAY-DAYS PIC S9(7) COMP-3 OCCURS 3.
    02 C-CLASS PIC X.
    02 C-TOT-TMP PIC S9(9) COMP-3 OCCURS 3.
    02 C-FILL1 PIC X.
    02 C-AUTO PIC 99 COMP-3.
    02 C-BROKER PIC 99 COMP-3.
    02 C-LABEL PIC 99 COMP-3.
    02 C-TERMS PIC 99 COMP-3.
    02 C-MCUS PIC X(6).
    02 C-IRS PIC X(15).
    02 C-FILL2 PIC X(4).
    02 C-SUR PIC 9 COMP-3.
    02 C-DATE-PAY PIC 9(6) COMP-3.
*      FILLER X(5)

FD  PRODUCT BLOCK 3584.
01  P-RECORD PIC X(1150).
01  P-REC.
    02 P-KEY.
      03 P-NO PIC X(12).
    02 P-GEN PIC X(12).
    02 P-PUR-PART PIC X(12).
    02 P-CAT PIC 99 COMP-3.
    02 P-FAMILY PIC 99 COMP-3.
    02 P-INACTIVE PIC 9 COMP-3.
    02 P-DESC PIC X(32).
    02 P-FINDESC PIC X(32).
    02 P-PRDESC PIC X(18).
    02 P-EDESC1 PIC X(32).
    02 P-EDESC2 PIC X(32).
    02 P-PRINT PIC 9(6) COMP-3.
    02 P-PRINT-REV PIC XX.
    02 P-DIAM PIC X(6).
    02 P-GRADE PIC X(8).
    02 P-WIRE PIC 9V9(4) COMP-3.
    02 P-ORD PIC 9(6) COMP-3.
    02 P-PID PIC X(7).
    02 P-CHGPR PIC 9 COMP-3.
    02 P-DATE PIC 9(6) COMP-3.
    02 P-CRDATE PIC 9(6) COMP-3.
    02 P-CUSPART PIC X(16).
    02 P-FILL1 PIC X(8).
    02 P-VENDOR PIC 9(6) COMP-3.
    02 P-ALT-V PIC 9(6) COMP-3.
    02 P-CUS PIC X(6).
    02 P-NUT PIC X(12).
    02 P-WEIGHT-NUT PIC 9(4)V99 COMP-3.
    02 P-WEIGHT PIC 9(4)V99 COMP-3.
    02 P-GROSS PIC 9(4)V99 COMP-3.
    02 P-HAND PIC S9(9) COMP-3.
    02 P-ORDER PIC S9(9) COMP-3.
    02 P-DEMAND PIC S9(9) COMP-3.
    02 P-FDEMAND PIC S9(9) COMP-3.
    02 P-PROCESS PIC S9(9) COMP-3.
    02 P-BANK PIC S9(9) COMP-3.
    02 P-TORDER PIC S9(9) COMP-3.
    02 P-ROP PIC S9(9) COMP-3.
    02 P-MTD PIC S9(9) COMP-3.
    02 P-YTD PIC S9(9) COMP-3.
    02 P-LAST PIC S9(9) COMP-3.
    02 P-PREV PIC S9(9) COMP-3.
    02 P-W-MTD PIC S9(9) COMP-3.
    02 P-W-YTD PIC S9(9) COMP-3.
    02 P-A-MTD PIC S9(7)V99 COMP-3.
    02 P-A-YTD PIC S9(7)V99 COMP-3.
    02 P-MODE PIC XX.
    02 P-PRICE1 PIC 9(4)V999 COMP-3.
    02 P-PRICE2 PIC 9(4)V999 COMP-3.
    02 P-MARKET PIC 99 COMP-3.
    02 P-ALERT PIC 999 COMP-3.
    02 P-MAC PIC 99 COMP-3.
    02 P-ALT-MAC PIC 99 COMP-3.
    02 P-RATE PIC 9(6) COMP-3.
    02 P-COST PIC 9(4)V999 COMP-3.
    02 P-LEAD PIC 99 COMP-3.
    02 P-EST PIC S9(9) COMP-3.
    02 P-LEVEL PIC 9 COMP-3.
    02 P-PACKING PIC 99 COMP-3.
    02 P-QTY-PACK PIC 9(5) COMP-3.
    02 P-CONT PIC X.
    02 P-TCOLOR PIC 99 COMP-3.
    02 P-CLEAN PIC 9 COMP-3.
    02 P-PROC PIC 9 COMP-3.
    02 P-PLSPEC PIC 999 COMP-3.
    02 P-UPC PIC 9(5) COMP-3.
    02 P-HCODE PIC 99 COMP-3.
    02 P-TAX PIC 99 COMP-3.
    02 P-PVAL OCCURS 28.
      03 P-PCHAR PIC 999 COMP-3.
      03 P-PMIN PIC 99V9(4) COMP-3.
      03 P-PMAX PIC 99V9(4) COMP-3.
    02 OCCURS 15.
      03 P-SMIN PIC 9(5)V9(4) COMP-3.
      03 P-SMAX PIC 9(5)V9(4) COMP-3.
      03 P-SUNIT PIC X(5).
    02 P-SDECARB PIC X(6).
    02 OCCURS 18.
      03 P-HMIN PIC 9(6) COMP-3.
      03 P-HMAX PIC 9(6) COMP-3.
    02 P-LABELS PIC 9 COMP-3.
    02 P-TCOST PIC S9(4)V999 COMP-3.
    02 P-INC-NUT PIC 9 COMP-3.
    02 P-PPAP PIC 9 COMP-3.
    02 P-QUOTNO PIC 9(10) COMP-3.
    02 P-SPEC PIC X(20).
    02 P-PWEIGHT PIC 9(4)V99 COMP-3.
    02 P-LPRICE PIC 9(4)V999 COMP-3.
    02 P-LUS PIC 9 COMP-3.
    02 P-LDATE PIC 9(6) COMP-3.
    02 P-BEG-HAND PIC S9(9) COMP-3 OCCURS 3.
    02 P-GDATE PIC 9(6) COMP-3.
    02 P-NDATE PIC 9(6) COMP-3.
*      FILLER X(0)
* note 160.1

FD  ITPRODUCT BLOCK 3584.
01  ITP-RECORD PIC X(1150).
01  ITP-REC.
    02 ITP-KEY.
      03 ITP-NO PIC X(12).

* note 209
FD  ALTERNATES.
01  AL-RECORD PIC X(50).
01  AL-REC.
    02 AL-KEY.
      03 AL-PROD PIC X(12).
      03 AL-ALT PIC X(12).
*      FILLER X(26)

FD  NUTBOLT.
01  NU-RECORD PIC X(50).
01  NU-REC.
    02 NU-KEY.
      03 NU-NUT PIC X(12).
      03 NU-BOLT PIC X(12).
    02 NU-CAT PIC 99 COMP-3.
    02 NU-NUM PIC 99 COMP-3.
*      FILLER X(22)

FD  OPERATIONS.
01  OP-RECORD PIC X(115).
01  OP-REC.
    02 OP-KEY.
      03 OP-PROD PIC X(12).
      03 OP-MAC PIC 99.
    02 OP-OP OCCURS 12.
      03 OP-OPER PIC 999 COMP-3.
      03 OP-COST PIC 9(4)V999 COMP-3.
      03 OP-CMODE PIC X.
    02 OP-SPEED PIC 999 COMP-3.
    02 OP-EFF PIC 99 COMP-3.
*      FILLER X(13)
* note 160.2

FD  ITOPERATIONS.
01  ITOP-RECORD PIC X(115).
01  ITOP-REC.
    02 ITOP-KEY.
      03 ITOP-PROD PIC X(12).
      03 ITOP-MAC PIC 99.

FD  COSTHIST BLOCK 2048.
01  CU-RECORD PIC X(390).
01  CU-REC.
    02 CU-KEY.
      03 CU-PROD PIC X(12).
    02 CU-HIST OCCURS 8.
      03 CU-NUM PIC 99 COMP-3.
      03 CU-MAC PIC 99 COMP-3.
      03 CU-TOT PIC S9(5)V999 COMP-3 OCCURS 4.
      03 CU-NTOT PIC S9(5)V999 COMP-3 OCCURS 4.
*      FILLER X(26)

FD  QUOTORD.
01  QO-RECORD PIC X(1500).
01  QO-REC.
    02 QO-KEY.
      03 QO-NO PIC 9(6).
    02 QO-DATE PIC 9(6) COMP-3.
    02 QO-CUS PIC X(6).
    02 QO-NAME PIC X(32).
    02 QO-ADD1 PIC X(32).
    02 QO-ADD2 PIC X(32).
    02 QO-POST PIC X(10).
    02 QO-US PIC 9 COMP-3.
    02 QO-EXCH PIC 9V9(4) COMP-3.
    02 QO-FILL1 PIC X(47).
    02 QO-NOTE PIC X(75) OCCURS 10.
    02 QO-LINES PIC 99 COMP-3.
    02 QO-INFO PIC X(30) OCCURS 3.
*      FILLER X(485)

FD  QUOTLIN.
01  QL-RECORD PIC X(480).
01  QL-REC.
    02 QL-KEY.
      03 QL-NO PIC 9(6).
      03 QL-LINE PIC 99.
    02 OCCURS 12.
      03 QL-OPER PIC 999 COMP-3.
      03 QL-OPCOST PIC 9(4)V999 COMP-3.
      03 QL-CMODE PIC X.
    02 QL-STATUS PIC 9 COMP-3.
    02 QL-DEL PIC 9 COMP-3.
    02 QL-PROD PIC X(12).
    02 QL-DESC PIC X(32).
    02 QL-EDESC1 PIC X(32).
    02 QL-EDESC2 PIC X(32).
    02 QL-FINDESC PIC X(32).
    02 QL-PRDESC PIC X(18).
    02 QL-CAT PIC 99 COMP-3.
    02 QL-FAMILY PIC 99 COMP-3.
    02 QL-MODE PIC XX.
    02 QL-MAC PIC 99 COMP-3.
    02 QL-RATE PIC 9(6) COMP-3.
    02 QL-WEIGHT PIC 9(4)V99 COMP-3.
    02 QL-GROSS PIC 9(4)V99 COMP-3.
    02 QL-DIAM PIC X(6).
    02 QL-GRADE PIC X(8).
    02 QL-PROC PIC 9 COMP-3.
    02 QL-CLEAN PIC 9 COMP-3.
    02 QL-PRICE1 PIC 9(4)V999 COMP-3.
    02 QL-PRICE2 PIC 9(4)V999 COMP-3.
    02 QL-COST PIC 9(4)V999 COMP-3.
    02 QL-PACKING PIC 99 COMP-3.
    02 QL-QTY-PACK PIC 9(5) COMP-3.
    02 QL-EST PIC S9(9) COMP-3.
    02 QL-DELIVERY PIC 99 COMP-3.
*      FILLER X(168)

FD  PRICE.
01  IO-RECORD PIC X(115).
01  IO-REC.
    02 IO-KEY.
      03 IO-CUS PIC X(6).
      03 IO-PROD PIC X(12).
    02 IO-KP.
      03 IO-KPROD PIC X(12).
      03 IO-KCUS PIC X(6).
    02 IO-PRICE PIC 9(4)V999 COMP-3.
    02 IO-NOTE PIC X(50).
    02 IO-AUTH PIC XXX.
    02 IO-DATE PIC 9(6) COMP-3.
    02 IO-SUR PIC 9 COMP-3.
    02 IO-SURCH PIC 99V999 COMP-3.
*      FILLER X(14)

FD  PRICEHIST.
01  NJ-RECORD PIC X(115).
01  NJ-REC.
    02 NJ-KEY.
      03 NJ-CUS PIC X(6).
      03 NJ-PROD PIC X(12).
      03 NJ-CDATE PIC 9(6).
    02 NJ-PRICE PIC 9(4)V999 COMP-3.
    02 NJ-NOTE PIC X(50).
    02 NJ-AUTH PIC XXX.
    02 NJ-DATE PIC 9(6) COMP-3.
    02 NJ-SUR PIC 9 COMP-3.
    02 NJ-SURCH PIC 99V999 COMP-3.
*      FILLER X(26)

FD  SUBCON BLOCK 1024.
01  SJ-RECORD PIC X(320).
01  SJ-REC.
    02 SJ-KEY.
      03 SJ-MAC PIC 9(4).
      03 SJ-MO PIC 9(6).
      03 SJ-SUFFIX PIC X.
      03 SJ-LOT PIC 9(7).
      03 SJ-PROD PIC X(12).
    02 SJ-NPADS PIC 999 COMP-3.
    02 SJ-BPADS PIC 99 COMP-3.
    02 SJ-DATE PIC 9(6) COMP-3.
    02 SJ-OUTCON PIC 999 COMP-3.
    02 SJ-BUCKETS PIC S999 COMP-3.
    02 SJ-WEIGHT PIC S9(7) COMP-3.
    02 SJ-OBUCKETS PIC S999 COMP-3.
    02 SJ-OWEIGHT PIC S9(7) COMP-3.
    02 SJ-IBUCKETS PIC S999 COMP-3.
    02 SJ-IWEIGHT PIC S9(7) COMP-3.
    02 SJ-SBUCKETS PIC S999 COMP-3.
    02 SJ-SWEIGHT PIC S9(7) COMP-3.
    02 SJ-VEN PIC 9(4) COMP-3.
    02 SJ-VIA PIC 99 COMP-3.
    02 SJ-NAME PIC X(36).
    02 SJ-ADD1 PIC X(36).
    02 SJ-ADD2 PIC X(24).
    02 SJ-POST PIC X(7).
    02 SJ-NOTE PIC X(50).
    02 SJ-USER PIC X(12).
    02 SJ-NCARTONS PIC 9(5) COMP-3.
    02 SJ-BCARTONS PIC 99 COMP-3.
    02 SJ-NSKIDS PIC 999 COMP-3.
    02 SJ-BSKIDS PIC 99 COMP-3.
    02 SJ-FILL1 PIC X.
    02 SJ-WEX PIC 9 COMP-3.
    02 SJ-COST PIC 9(4)V999 COMP-3.
    02 SJ-CMODE PIC X.
    02 SJ-BL PIC 9(7) COMP-3 OCCURS 15.
    02 SJ-COFC PIC X(6).
*      FILLER X(4)

FD  SUBINV.
01  SL-RECORD PIC X(115).
01  SL-REC.
    02 SL-KEY.
      03 SL-MAC PIC 9(4).
      03 SL-MO PIC 9(6).
      03 SL-SUFFIX PIC X.
      03 SL-LOT PIC 9(7).
      03 SL-PROD PIC X(12).
      03 SL-KSLIP PIC X(10).
      03 SL-SEQ PIC 99.
    02 SL-KS.
      03 SL-SLIP PIC X(10).
      03 SL-ORD PIC X(8).
    02 SL-IND PIC 9 COMP-3.
    02 SL-QTY PIC S9(9) COMP-3.
    02 SL-WEIGHT PIC S9(7) COMP-3.
    02 SL-PALLETS PIC S999 COMP-3.
    02 SL-TRUCK PIC 9 COMP-3.
    02 SL-LTLOAD PIC 9 COMP-3.
    02 SL-METRO PIC 9 COMP-3.
    02 SL-INV-DATE PIC 9(6) COMP-3.
    02 SL-RBUCKETS PIC S999 COMP-3.
    02 SL-JMAC PIC 9(4) COMP-3.
    02 SL-JDATE PIC 9(6) COMP-3.
    02 SL-JRET PIC 9 COMP-3.
*      FILLER X(26)

FD  BIN BLOCK 2048.
01  B-RECORD PIC X(60).
01  B-REC.
    02 B-KEY.
      03 B-NO PIC X(5).
    02 B-KP.
      03 B-PROD PIC X(12).
      03 B-LYEAR PIC 9(4).
      03 B-LOT PIC 9(7).
      03 B-DATE PIC 9(6).
    02 B-QTY PIC S9(9) COMP-3.
    02 B-QTY-AL PIC S9(9) COMP-3.
    02 B-CONT PIC X.
    02 B-QTY-PACK PIC 9(5) COMP-3.
    02 B-IND PIC 9 COMP-3.
    02 B-QREASON PIC XX.
*      FILLER X(9)

FD  QBIN.
01  QB-RECORD PIC X(115).
01  QB-REC.
    02 QB-KEY.
      03 QB-NO PIC X(5).
    02 QB-KP.
      03 QB-PROD PIC X(12).
      03 QB-LYEAR PIC 9(4).
      03 QB-LOT PIC 9(7).
      03 QB-DATE PIC 9(6).
    02 QB-DM PIC 9(6) COMP-3.
    02 QB-QTY PIC S9(9) COMP-3.
    02 QB-NOTE PIC X(50).
*      FILLER X(22)

FD  PART BLOCK 4096.
01  PH-RECORD PIC X(570).
01  PH-REC.
    02 PH-KEY.
      03 PH-NO PIC X(12).
    02 PH-KD.
      03 PH-DRAW PIC X(12).
    02 PH-KA.
      03 PH-ALT PIC 9(12).
      03 PH-KANO PIC X(12).
    02 PH-KV.
      03 PH-VNUM PIC X(24).
      03 PH-KVNO PIC X(12).
    02 PH-CAT PIC 999 COMP-3.
    02 PH-REV PIC X.
    02 PH-ASM PIC 9 COMP-3.
    02 PH-MTYPE PIC 99 COMP-3.
    02 PH-CRDATE PIC 9(6) COMP-3.
    02 PH-BLINES PIC 999 COMP-3.
    02 PH-DESC1 PIC X(32).
    02 PH-DESC2 PIC X(32).
    02 PH-MATERIAL PIC X(20).
    02 PH-TAX PIC 99 COMP-3.
    02 PH-HCODE PIC 99 COMP-3.
    02 PH-UNIT PIC X(4).
    02 PH-MODE PIC X(4).
    02 PH-LIFE PIC 9(6) COMP-3.
    02 PH-VENDOR PIC 9(4) COMP-3 OCCURS 3.
    02 PH-PRICE PIC 9(6)V999 COMP-3 OCCURS 3.
    02 PH-LDCOST PIC 9(6)V999 COMP-3.
    02 PH-TCOST PIC 9(6)V999 COMP-3.
    02 PH-HAND PIC S9(7) COMP-3.
    02 PH-ORDER PIC S9(7) COMP-3.
    02 PH-DEMAND PIC S9(7) COMP-3.
    02 PH-LEVEL PIC 9 COMP-3.
    02 PH-EOQ PIC 9(5) COMP-3.
    02 PH-ROP PIC S9(7) COMP-3.
    02 PH-MTD PIC S9(7) COMP-3.
    02 PH-YTD PIC S9(7) COMP-3.
    02 PH-LAST PIC S9(7) COMP-3.
    02 PH-AMTD PIC S9(7)V99 COMP-3.
    02 PH-AYTD PIC S9(7)V99 COMP-3.
    02 PH-ALAST PIC S9(7)V99 COMP-3.
    02 PH-DATE PIC 9(6) COMP-3.
    02 PH-PROC-HAND PIC S9(7) COMP-3 OCCURS 9.
    02 PH-PROC-DEMAND PIC S9(7) COMP-3 OCCURS 9.
    02 PH-DATE-REQ PIC 9(6) COMP-3 OCCURS 2.
    02 PH-QTY-REQ PIC 9(6) COMP-3.
    02 PH-ASM-MAC PIC 99 COMP-3.
    02 PH-ASM-HAND PIC S9(7) COMP-3.
    02 PH-ASM-DEMAND PIC S9(7) COMP-3.
    02 PH-BEG-HAND PIC S9(7) COMP-3 OCCURS 3.
    02 PH-NOTE PIC X(70) OCCURS 2.
    02 PH-QTY-TMP PIC S9(9) COMP-3.
    02 PH-QTYA-TMP PIC S9(9) COMP-3.
    02 PH-QTYB-TMP PIC S9(9) COMP-3.
    02 PH-ALIFE PIC 9(6) COMP-3.
*      FILLER X(24)
* note 85.3

FD  IFPART BLOCK 4096.
01  IFPH-RECORD PIC X(570).
01  IFPH-REC.
    02 IFPH-KEY.
      03 IFPH-NO PIC X(12).
    02 IFPH-KD.
      03 IFPH-DRAW PIC X(12).
    02 IFPH-KA.
      03 IFPH-ALT PIC 9(12).
      03 IFPH-KANO PIC X(12).
    02 IFPH-KV.
      03 IFPH-VNUM PIC X(24).
      03 IFPH-KVNO PIC X(12).

FD  PURBIN BLOCK 2048.
01  BH-RECORD PIC X(115).
01  BH-REC.
    02 BH-KEY.
      03 BH-NO PIC X(8).
    02 BH-KP.
      03 BH-PART PIC X(12).
      03 BH-DATE PIC 9(6).
      03 BH-KNO PIC X(8).
    02 BH-QTY PIC S9(9) COMP-3.
    02 BH-QTY-AL PIC S9(9) COMP-3.
    02 BH-HEAT PIC X(10).
    02 BH-PO PIC X(10).
    02 BH-PCODE PIC 9 COMP-3.
    02 BH-COILS PIC S999 COMP-3.
    02 BH-TMP-PART PIC X(12).
    02 BH-TMP-QTY PIC S9(9) COMP-3.
    02 BH-TMP-HEAT PIC X(10).
    02 BH-TMP-PCODE PIC 9 COMP-3.
    02 BH-TMP-COILS PIC S999 COMP-3.
*      FILLER X(17)
* note 249

FD  TOOLS.
01  TS-RECORD PIC X(3300).
01  TS-REC.
    02 TS-KEY.
      03 TS-PROD PIC X(12).
      03 TS-MAC PIC 99.
    02 TS-TOOL PIC X(12) OCCURS 250.
    02 TS-IND PIC 9 COMP-3.
    02 TS-NOTE PIC X(60) OCCURS 3.
    02 TS-PLNUM PIC X(8).
*      FILLER X(97)
* note 85.4
* note 110.1

FD  IFTOOLS.
01  IFTS-RECORD PIC X(3300).
01  IFTS-REC.
    02 IFTS-KEY.
      03 IFTS-PROD PIC X(12).
      03 IFTS-MAC PIC 99.

FD  ARCTOOLS.
01  TY-RECORD PIC X(3400).
01  TY-REC.
    02 TY-KEY.
      03 TY-PROD PIC X(12).
      03 TY-MAC PIC 99.
      03 TY-ID PIC X.
    02 TY-TSREC PIC X(3300).
    02 TY-DATE PIC 9(6) COMP-3.
    02 TY-NOTE PIC X(50).
*      FILLER X(31)
* note 110.2

FD  TOOLPROD.
01  TP-RECORD PIC X(50).
01  TP-REC.
    02 TP-KEY.
      03 TP-TOOL PIC X(12).
      03 TP-PROD PIC X(12).
      03 TP-MAC PIC 99.
      03 TP-FLD PIC 999.
*      FILLER X(21)
* note 85.5

FD  IFTOOLPROD.
01  IFTP-RECORD PIC X(50).
01  IFTP-REC.
    02 IFTP-KEY.
      03 IFTP-TOOL PIC X(12).
      03 IFTP-PROD PIC X(12).
      03 IFTP-MAC PIC 99.
      03 IFTP-FLD PIC 999.

FD  HEAT.
01  HE-RECORD PIC X(75).
01  HE-REC.
    02 HE-KEY.
      03 HE-NO PIC X(10).
    02 HE-DATE PIC 9(6) COMP-3.
    02 HE-GRADE PIC X(8).
    02 HE-C PIC 9V99 COMP-3.
    02 HE-MN PIC 9V99 COMP-3.
    02 HE-P PIC V999 COMP-3.
    02 HE-S PIC V999 COMP-3.
    02 HE-SI PIC 9V99 COMP-3.
    02 HE-CU PIC 9V99 COMP-3.
    02 HE-NI PIC 9V99 COMP-3.
    02 HE-CR PIC 9V99 COMP-3.
    02 HE-MO PIC V999 COMP-3.
    02 HE-SN PIC V999 COMP-3.
    02 HE-AL PIC V999 COMP-3.
    02 HE-B PIC V9999 COMP-3.
    02 HE-V PIC V999 COMP-3.
    02 HE-CO PIC V999 COMP-3.
    02 HE-N PIC V9999 COMP-3.
    02 HE-DIVAL PIC 9V99 COMP-3.
*      FILLER X(19)

FD  LOT BLOCK 2048.
01  LT-RECORD PIC X(500).
01  LT-REC.
    02 LT-KEY.
      03 LT-NO PIC 9(7).
    02 LT-KP.
      03 LT-PROD PIC X(12).
      03 LT-LYEAR PIC 9(4).
      03 LT-LOT PIC 9(7).
    02 LT-EMP PIC 9(4) COMP-3.
    02 LT-BMLOT PIC 9(7) COMP-3.
    02 LT-ALOT PIC X(10).
    02 LT-QUAR PIC 9 COMP-3.
    02 LT-LAB PIC 9 COMP-3.
    02 LT-HEAT PIC X(10).
    02 LT-GRADE PIC X(8).
    02 LT-GRADE-OVR PIC 9(4) COMP-3.
    02 LT-SPEC PIC X(20).
    02 LT-FINISH PIC X(15).
    02 LT-MO PIC 9(6) COMP-3.
    02 LT-SUFFIX PIC X.
    02 LT-BUCKETS PIC S999 COMP-3.
    02 LT-QTY PIC S9(9) COMP-3.
    02 LT-WEIGHT PIC S9(9) COMP-3.
    02 LT-COUNTRY PIC 99 COMP-3.
    02 LT-NOTE PIC X(50).
    02 OCCURS 15.
      03 LT-MECH PIC X(10).
      03 LT-UNIT PIC X(5).
    02 LT-MECH-1 PIC X(20).
    02 LT-MECH-5 PIC X(20).
    02 LT-MECH-6 PIC X(35).
*      FILLER X(26)

FD  HTRANS.
01  HT-RECORD PIC X(240).
01  HT-REC.
    02 HT-KEY.
      03 HT-INVLN.
        04 HT-INV PIC 9(6).
        04 HT-LN PIC 99.
      03 HT-LYEAR PIC 9(4).
      03 HT-LOT PIC 9(7).
    02 HT-IND PIC 9 COMP-3.
    02 HT-CUSORD PIC X(9).
    02 HT-BL PIC 9(7) COMP-3.
    02 HT-CUS PIC X(6).
    02 HT-SHIPTO PIC 99 COMP-3.
    02 HT-NAME PIC X(32).
    02 HT-ADD1 PIC X(24).
    02 HT-ADD2 PIC X(24).
    02 HT-POST PIC X(10).
    02 HT-PROD PIC X(12).
    02 HT-QTY PIC S9(9) COMP-3.
    02 HT-CUSPART PIC X(25).
*      FILLER X(67)

FD  SHIPTO.
01  SA-RECORD PIC X(150).
01  SA-REC.
    02 SA-KEY.
      03 SA-CUS PIC X(6).
      03 SA-TO PIC 99.
    02 SA-NO REDEFINES SA-KEY PIC X(8).
    02 SA-NAME PIC X(32).
    02 SA-ADD1 PIC X(32).
    02 SA-ADD2 PIC X(32).
    02 SA-POST PIC X(10).
*      FILLER X(36)

FD  BILLTO.
01  BT-RECORD PIC X(240).
01  BT-REC.
    02 BT-KEY.
      03 BT-CUS PIC X(6).
      03 BT-TO PIC 99.
    02 BT-LINE PIC X(50) OCCURS 4.
*      FILLER X(32)

FD  SOLDTO.
01  UH-RECORD PIC X(240).
01  UH-REC.
    02 UH-KEY.
      03 UH-NO PIC X(6).
    02 UH-LINE PIC X(40) OCCURS 5.
*      FILLER X(34)

FD  SAORD.
01  O-RECORD PIC X(480).
01  O-REC.
    02 O-KEY.
      03 O-NO PIC 9(6).
    02 O-KC.
      03 O-CUS PIC X(6).
      03 O-DATE PIC 9(6).
    02 O-NAME PIC X(32).
    02 O-ADD1 PIC X(24).
    02 O-ADD2 PIC X(24).
    02 O-POST PIC X(10).
    02 O-SHIPTO PIC 99 COMP-3.
    02 O-LINES PIC 99 COMP-3.
    02 O-BLANKET PIC 9 COMP-3.
    02 O-SPECIAL PIC 9 COMP-3.
    02 O-ACK PIC 9 COMP-3.
    02 O-TER PIC 99 COMP-3.
    02 O-SAL PIC 99 COMP-3.
    02 O-SALCOM PIC 99V99 COMP-3.
    02 O-SALCONT PIC X(15).
    02 O-TERMS PIC X(6).
    02 O-VIA PIC 99 COMP-3.
    02 O-FOB PIC X(15).
    02 O-PPD PIC X.
    02 O-TEXT PIC 99 COMP-3 OCCURS 4.
    02 O-PLINE PIC X(45) OCCURS 2.
    02 O-FRATE PIC S999V99 COMP-3.
    02 O-FLOT PIC S9(5)V99 COMP-3.
    02 O-FREIGHT PIC S9(5)V99 COMP-3.
    02 O-FREIGHT-OVS PIC S9(5)V99 COMP-3.
    02 O-CUSORD PIC X(9).
    02 O-INVNO PIC 9(6) COMP-3.
    02 O-SID PIC 9(6) COMP-3.
    02 O-BL PIC 9(7) COMP-3.
    02 O-INV-DATE PIC 9(6) COMP-3.
    02 O-DATE-REQ PIC 9(6) COMP-3.
    02 O-PALLETS PIC 999 COMP-3.
    02 O-PACKS PIC 9(4) COMP-3 OCCURS 12.
    02 O-TOTAL PIC S9(7)V99 COMP-3.
    02 O-NON-SAL PIC S9(5)V99 COMP-3.
    02 O-NET PIC S9(7) COMP-3.
    02 O-GROSS PIC 9(8) COMP-3.
    02 O-SURTOT PIC S9(7)V99 COMP-3.
    02 O-GST PIC S9(5)V99 COMP-3.
    02 O-PST PIC S9(5)V99 COMP-3.
    02 O-HST PIC S9(5)V99 COMP-3.
    02 O-QST PIC S9(5)V99 COMP-3.
    02 O-PAYER PIC X.
    02 O-US PIC 9 COMP-3.
*      FILLER X(98)
* note 184.1

FD  SALIN.
01  L-RECORD PIC X(150).
01  L-REC.
    02 L-KEY.
      03 L-ORD PIC 9(6).
      03 L-LINE PIC 99.
    02 L-NO REDEFINES L-KEY PIC 9(8).
    02 L-TER PIC 99 COMP-3.
    02 L-CUS PIC X(6).
    02 L-KP.
      03 L-PROD PIC X(12).
      03 L-DATE-REQ PIC 9(6).
    02 L-PRICE PIC 9(4)V999 COMP-3.
    02 L-DISC PIC 99 COMP-3.
    02 L-QTY PIC S9(9) COMP-3.
    02 L-QTY-LEFT PIC S9(9) COMP-3.
    02 L-QTY-THIS PIC S9(9) COMP-3.
    02 L-PLATING PIC 99 COMP-3.
    02 L-ADJ PIC 9 COMP-3.
    02 L-REORDER PIC 9 COMP-3.
    02 L-MODE PIC XX.
    02 L-CAT PIC 99 COMP-3.
    02 L-EXTA PIC S9(7)V99 COMP-3.
    02 L-WEIGHT PIC S9(5) COMP-3.
    02 L-MODYR PIC 99 COMP-3.
    02 L-CONT PIC X.
    02 L-RC PIC X(12).
    02 L-NUT PIC X(12).
    02 L-WEIGHT-NUT PIC S9(5) COMP-3.
    02 L-CUSPART PIC X(25).
    02 L-SPECIAL PIC 9 COMP-3.
    02 L-SUR PIC 9 COMP-3.
*      FILLER X(22)
* note 184.2

FD  SHIPORD.
01  HO-RECORD PIC X(240).
01  HO-REC.
    02 HO-KEY.
      03 HO-ORD PIC 9(6).
      03 HO-SEQ PIC 99.
    02 HO-NO REDEFINES HO-KEY PIC 9(8).
    02 HO-ORDSEQ REDEFINES HO-KEY PIC 9(8).
    02 HO-KB.
      03 HO-BL PIC 9(7).
    02 HO-KV.
      03 HO-VIA PIC 99.
      03 HO-CUS PIC X(6).
      03 HO-DATE-REQ PIC 9(6).
    02 HO-IND PIC 9 COMP-3.
    02 HO-BIND PIC 9 COMP-3.
    02 HO-INVNO PIC 9(6) COMP-3.
    02 HO-NOALLOC PIC 9 COMP-3.
    02 HO-SID PIC 9(6) COMP-3.
    02 HO-NET PIC S9(7) COMP-3.
    02 HO-GROSS PIC 9(8) COMP-3.
    02 HO-PALLETS PIC 999 COMP-3.
    02 HO-FILL1 PIC X(24).
    02 HO-CUSORD PIC X(9).
    02 HO-TOTAL PIC S9(7)V99 COMP-3.
    02 HO-FREIGHT PIC S9(5)V99 COMP-3.
    02 HO-GST PIC S9(5)V99 COMP-3.
    02 HO-PST PIC S9(5)V99 COMP-3.
    02 HO-HST PIC S9(5)V99 COMP-3.
    02 HO-QST PIC S9(5)V99 COMP-3.
    02 HO-SHQUAL PIC XXX.
    02 HO-SHTIME PIC 9(4) COMP-3.
    02 HO-TPLANT PIC X(10).
    02 HO-DOCK PIC X(8).
    02 HO-CUSID PIC X(12).
    02 HO-DXNO PIC 9(4) COMP-3.
    02 HO-PACKS PIC 9(4) COMP-3 OCCURS 12.
*      FILLER X(56)

FD  SHIPLIN.
01  HL-RECORD PIC X(240).
01  HL-REC.
    02 HL-KEY.
      03 HL-ORDSEQ PIC 9(8).
      03 REDEFINES HL-ORDSEQ.
        04 HL-ORD PIC 9(6).
        04 HL-SEQ PIC 99.
      03 HL-LINE PIC 99.
    02 HL-NO REDEFINES HL-KEY PIC 9(10).
    02 HL-KP.
      03 HL-PROD PIC X(12).
      03 HL-DATE-REQ PIC 9(6).
    02 HL-CUSORD PIC X(9).
    02 HL-LABINF PIC X(115).
    02 HL-CONT PIC X.
    02 HL-QTY PIC S9(7) COMP-3.
    02 HL-QTY-LEFT PIC S9(9) COMP-3.
    02 HL-QTY-THIS PIC S9(9) COMP-3.
    02 HL-BDATA.
      03 HL-QTY-AL PIC S9(7) COMP-3.
      03 HL-WEIGHT-AL PIC S9(7) COMP-3.
      03 HL-QTY-ALPREV PIC S9(7) COMP-3.
      03 HL-WEIGHT-ALPREV PIC S9(7) COMP-3.
      03 HL-FILL1 PIC XX.
      03 HL-OLD PIC 9 COMP-3.
      03 HL-ERR PIC 9 COMP-3.
    02 HL-NDATA.
      03 HL-QTY-NAL PIC S9(7) COMP-3.
      03 HL-WEIGHT-NAL PIC S9(7) COMP-3.
      03 HL-QTY-NALPREV PIC S9(7) COMP-3.
      03 HL-WEIGHT-NALPREV PIC S9(7) COMP-3.
      03 HL-FILL2 PIC XX.
      03 HL-NOLD PIC 9 COMP-3.
      03 HL-NERR PIC 9 COMP-3.
    02 HL-PAGE PIC 9 COMP-3.
    02 HL-USE PIC 9 COMP-3.
    02 HL-QTY-DIFF PIC S9(7) COMP-3.
    02 HL-QTY-NEW PIC S9(7) COMP-3.
    02 HL-ACARTONS PIC 999 COMP-3.
    02 HL-ALABELS PIC 999 COMP-3.
*      FILLER X(19)

FD  BINALLOC.
01  BA-RECORD PIC X(50).
01  BA-REC.
    02 BA-KEY.
      03 BA-NO PIC 9(10).
      03 REDEFINES BA-NO.
        04 BA-ORDSEQ PIC 9(8).
        04 REDEFINES BA-ORDSEQ.
          05 BA-ORD PIC 9(6).
          05 BA-SEQ PIC 99.
        04 BA-LINE PIC 99.
      03 BA-BIN PIC X(5).
    02 BA-PROD PIC X(12).
    02 BA-LOT PIC 9(7) COMP-3.
    02 BA-QTY PIC S9(7) COMP-3.
    02 BA-QTY-PACK PIC 9(5) COMP-3.
    02 BA-CARTONS PIC 999 COMP-3.
    02 BA-PARTIAL PIC 9 COMP-3.
    02 BA-IND PIC 9 COMP-3.
    02 BA-BN PIC 9 COMP-3.
    02 BA-LABELS PIC 999 COMP-3.
*      FILLER X(5)

FD  TMPORD.
01  YO-RECORD PIC X(480).
01  YO-REC.
    02 YO-KEY.
      03 YO-K PIC X(6).
      03 YO-SEQ PIC 9(4).
    02 YO-DATA PIC X(470).
* note 276.1

FD  TMPLIN.
01  YL-RECORD PIC X(240).
01  YL-REC.
    02 YL-KEY.
      03 YL-K PIC X(8).
      03 YL-SEQ PIC 9(4).
    02 YL-DATA PIC X(228).

FD  INTMPORD.
01  INYO-RECORD PIC X(480).
01  INYO-REC.
    02 INYO-KEY.
      03 INYO-K PIC X(6).
      03 INYO-SEQ PIC 9(4).
    02 INYO-DATA PIC X(470).

FD  ACKORD.
01  AKO-RECORD PIC X(480).
01  AKO-REC.
    02 AKO-KEY.
      03 AKO-NO PIC 9(6).

FD  ACKLIN.
01  AKL-RECORD PIC X(150).
01  AKL-REC.
    02 AKL-KEY.
      03 AKL-ORD PIC 9(6).
      03 AKL-LINE PIC 99.
    02 AKL-NO REDEFINES AKL-KEY PIC 9(8).

FD  CFORD BLOCK 1024.
01  FO-RECORD PIC X(320).
01  FO-REC.
    02 FO-KEY.
      03 FO-BL PIC 9(7).
    02 FO-SID PIC 9(7) COMP-3.
    02 FO-VIA PIC 99 COMP-3.
    02 FO-IND PIC 9 COMP-3.
    02 FO-PIND PIC 9 COMP-3 OCCURS 8.
    02 FO-CUS PIC X(6).
    02 FO-SHIPTO PIC 99 COMP-3.
    02 FO-NAME PIC X(32).
    02 FO-ADD1 PIC X(24).
    02 FO-ADD2 PIC X(24).
    02 FO-POST PIC X(10).
    02 FO-DATE PIC 9(6) COMP-3.
    02 FO-INV-DATE PIC 9(6) COMP-3.
    02 FO-LINES PIC 9(4) COMP-3.
    02 FO-STATE PIC XX.
    02 FO-PAYER PIC X.
    02 FO-FOB PIC X(15).
    02 FO-ENTRY PIC X(8).
    02 FO-BORDER PIC X(8).
    02 FO-FILL1 PIC X(10).
    02 FO-GROSS PIC 9(8) COMP-3.
    02 FO-NET PIC 9(8) COMP-3.
    02 FO-PALLETS PIC 999 COMP-3.
    02 FO-FILL2 PIC X(7).
    02 FO-FRATE PIC 9(4)V99 COMP-3.
    02 FO-TOTAL PIC S9(7)V99 COMP-3.
    02 FO-EQCODE PIC XX.
    02 FO-EQINIT PIC X(4).
    02 FO-EQNUM PIC X(10).
    02 FO-ETRESP PIC X.
    02 FO-ETNUM PIC X(8).
    02 FO-ORD PIC 9(6) COMP-3.
    02 FO-CARRID PIC X(11).
    02 FO-TQTY PIC S9(9) COMP-3.
    02 FO-DOCK PIC X(8).
    02 FO-FILL3 PIC X(8).
    02 FO-DXNO PIC 9(4) COMP-3.
    02 FO-INVNO PIC 9(6) COMP-3.
    02 FO-PACKS PIC 9(4) COMP-3 OCCURS 12.
*      FILLER X(13)

FD  CFLIN.
01  FL-RECORD PIC X(115).
01  FL-REC.
    02 FL-KEY.
      03 FL-BL PIC 9(7).
      03 FL-SEQ PIC 9(4).
    02 FL-PROD PIC X(12).
    02 FL-QTY PIC S9(9) COMP-3.
    02 FL-PRICE PIC 9(4)V999 COMP-3.
    02 FL-MODE PIC X.
    02 FL-EXT PIC S9(7)V99 COMP-3.
    02 FL-DXNO PIC 9(4) COMP-3.
    02 FL-QTY-CUM PIC S9(9) COMP-3.
    02 FL-CUSORD PIC X(9).
    02 FL-RC PIC X(12).
    02 FL-PKSLIP PIC 9(7) COMP-3.
    02 FL-MODYR PIC 99 COMP-3.
    02 FL-CARTONS PIC 9(5) COMP-3.
    02 OCCURS 2. 03 OCCURS 3.
      04 FL-COUNTRY PIC 99 COMP-3.
      04 FL-CQTY PIC S9(9) COMP-3.
*      FILLER X(21)

FD  PURORD BLOCK 1024.
01  OK-RECORD PIC X(190).
01  OK-REC.
    02 OK-KEY.
      03 OK-NO PIC X(8).
    02 OK-KV.
      03 OK-VENDOR PIC 9(4).
      03 OK-ZNO PIC X(8).
    02 OK-STATUS PIC 9 COMP-3.
    02 OK-HOLD PIC 9 COMP-3.
    02 OK-ITORD PIC 9 COMP-3.
    02 OK-BLANKET PIC 9 COMP-3.
    02 OK-DATE PIC 9(6) COMP-3.
    02 OK-DATE-REQ PIC 9(6) COMP-3.
    02 OK-FOB PIC X(15).
    02 OK-TERMS PIC X(12).
    02 OK-SHIPTO PIC X(20).
    02 OK-CARRIER PIC X(15).
    02 OK-US PIC 9 COMP-3.
    02 OK-PSTPAY PIC 9 COMP-3.
    02 OK-FILL1 PIC X(4).
    02 OK-DISC PIC S9(7)V99 COMP-3.
    02 OK-FREIGHT PIC S9(7)V99 COMP-3.
    02 OK-FRPAY PIC 9 COMP-3.
    02 OK-GST PIC S9(7)V99 COMP-3.
    02 OK-PST PIC S9(7)V99 COMP-3.
    02 OK-INV-DATE-LAST PIC 9(6) COMP-3.
    02 OK-BLANKET-ORD PIC X(8).
    02 OK-DUE-DATE-LAST PIC 9(6) COMP-3.
    02 OK-TEXT PIC 99 COMP-3 OCCURS 5.
    02 OK-INV PIC X(15).
    02 OK-EFF-DATE-LAST PIC 9(6) COMP-3.
    02 OK-USER PIC X(12).
    02 OK-SUBCON PIC 9 COMP-3.
*      FILLER X(11)
* note 85.1
* note 86.1

FD  PURLIN.
01  LK-RECORD PIC X(980).
01  LK-REC.
    02 LK-KEY.
      03 LK-ORD PIC X(8).
      03 LK-LINE PIC 99.
    02 LK-NO REDEFINES LK-KEY PIC X(10).
    02 LK-KP.
      03 LK-PART PIC X(12).
      03 LK-DATE-REQ PIC 9(6).
    02 LK-BLANKET PIC 9 COMP-3.
    02 LK-QTY PIC S9(9) COMP-3.
    02 LK-QTY-REC PIC S9(9) COMP-3.
    02 LK-PRICE PIC 9(6)V999 COMP-3.
    02 LK-TOTAL PIC S9(7)V99 COMP-3.
    02 LK-DESC.
      03 LK-DESC1 PIC X(32). 03 LK-DESC2 PIC X(32).
    02 LK-DRAW PIC X(12).
    02 LK-REV PIC X.
    02 LK-NOTES. 03 LK-NOTE PIC X(45) OCCURS 15.
    02 LK-MTYPE PIC 99 COMP-3.
    02 LK-CAT PIC 999 COMP-3.
    02 LK-GL PIC 9(18).
    02 LK-UNIT PIC X(4).
    02 LK-MODE PIC X(4).
    02 LK-TOTAL-REC PIC S9(7)V99 COMP-3.
    02 LK-QTY-LAST PIC S9(7)V999 COMP-3.
    02 LK-TOTAL-LAST PIC S9(7)V99 COMP-3.
    02 LK-DISC PIC 99 COMP-3.
    02 LK-DATE-LAST PIC 9(6) COMP-3.
    02 LK-DISC-DESC PIC X(9).
    02 LK-DATE-TMP PIC 9(6) COMP-3.
    02 LK-FILL1 PIC X(19).
    02 LK-SUB.
      03 LK-SUB-MAC PIC 9(4) COMP-3.
      03 LK-SUB-MO PIC 9(6) COMP-3.
      03 LK-SUB-SUFFIX PIC X.
      03 LK-SUB-LOT PIC 9(7) COMP-3.
      03 LK-SUB-PROD PIC X(12).
    02 LK-CHARGE-LAST PIC X(8).
*      FILLER X(63)
* note 85.2
* note 86.2

FD  IFPURORD BLOCK 1024.
01  IFOK-RECORD PIC X(190).
01  IFOK-REC.
    02 IFOK-KEY.
      03 IFOK-NO PIC X(8).
    02 IFOK-KV PIC X(12).

FD  IFPURLIN.
01  IFLK-RECORD PIC X(980).
01  IFLK-REC.
    02 IFLK-KEY.
      03 IFLK-ORD PIC X(8).
      03 IFLK-LINE PIC 99.
    02 IFLK-NO REDEFINES IFLK-KEY PIC X(10).
    02 IFLK-KP.
      03 IFLK-PART PIC X(12).
      03 IFLK-DATE-REQ PIC 9(6).

FD  TMPURORD.
01  YOK-RECORD PIC X(240).
01  YOK-REC.
    02 YOK-KEY.
      03 YOK-ORD PIC X(8).
      03 YOK-SEQ PIC 9(4).
    02 YOK-PR PIC 9 COMP-3.
    02 YOK-USER PIC X(12).
    02 YOK-DATA PIC X(190).
*      FILLER X(26)

FD  TMPURLIN.
01  YLK-RECORD PIC X(980).
01  YLK-REC.
    02 YLK-KEY.
      03 YLK-ORD PIC X(8).
      03 YLK-SEQ PIC 9(4).
      03 YLK-LINE PIC 99.
    02 YLK-DATA PIC X(966).

FD  PARTRANS.
01  PT-RECORD PIC X(115).
01  PT-REC.
    02 PT-KEY.
      03 PT-PART PIC X(12).
      03 PT-DATE PIC 9(6).
      03 PT-TIME PIC 9(8).
    02 PT-TRANS PIC XXX.
    02 PT-FILL1 PIC X(12).
    02 PT-QTY PIC S9(9) COMP-3.
    02 PT-MO PIC 9(6) COMP-3.
    02 PT-FILL2 PIC XX.
    02 PT-PO PIC X(10).
    02 PT-PCODE PIC 9 COMP-3.
    02 PT-COILS PIC S999 COMP-3.
    02 PT-CWEIGHT PIC 9(5) COMP-3.
    02 PT-HEAT PIC X(10).
    02 PT-USER PIC X(12).
    02 PT-FBIN PIC X(8).
    02 PT-TBIN PIC X(8).
*      FILLER X(10)
* note 287.2

FD  PRODTRANS.
01  PE-RECORD PIC X(115).
01  PE-REC.
    02 PE-KEY.
      03 PE-PROD PIC X(12).
      03 PE-DATE PIC 9(6).
      03 PE-TIME PIC 9(8).
    02 PE-TRANS PIC XXX.
    02 PE-FBIN PIC X(5).
    02 PE-TBIN PIC X(5).
    02 PE-LOT PIC 9(7) COMP-3.
    02 PE-NO PIC 9(6) COMP-3.
    02 PE-QTY PIC S9(9) COMP-3.
    02 PE-QTY-PACK PIC 9(5) COMP-3.
    02 PE-CARTONS PIC S9(5) COMP-3.
    02 PE-CONT PIC X.
*      FILLER X(56)

FD  PLANT.
01  PL-RECORD PIC X(115).
01  PL-REC.
    02 PL-KEY.
      03 PL-PLANT PIC X(10).
      03 PL-PROD PIC X(12).
    02 PL-KO.
      03 PL-ORD PIC 9(6).
    02 PL-KR.
      03 PL-RECEIVER PIC XXX.
    02 PL-ISSUER PIC X(9).
    02 PL-NAME PIC X(30).
    02 PL-DOCK PIC XXX.
    02 PL-EDIFACT PIC 9 COMP-3.
    02 PL-REP PIC XX.
*      FILLER X(39)

FD  MATREL.
01  MT-RECORD PIC X(980).
01  MT-REC.
    02 MT-KEY.
      03 MT-PLANT PIC X(10).
      03 MT-PROD PIC X(12).
      03 MT-SEQ PIC 99.
    02 MT-KP.
      03 MT-KPROD PIC X(12).
      03 MT-KPLANT PIC X(10).
    02 MT-TYPE PIC 99 COMP-3.
    02 MT-SEP PIC X.
    02 MT-DATE PIC 9(6) COMP-3.
    02 MT-ISA-KEY PIC X(19).
    02 MT-QTY-SHIP PIC S9(9) COMP-3.
    02 MT-IXF PIC 99 COMP-3.
    02 MT-IXL PIC 99 COMP-3.
    02 MT-IXI PIC 99 COMP-3.
    02 MT-LIN. 03 OCCURS 5. 04 MT-LCODE PIC XX. 04 MT-LVAL PIC X(10).
    02 MT-INFO. 03 MT-IFLINE PIC X(40) OCCURS 6.
    02 MT-FST. 03 OCCURS 30. 04 MT-FQTY PIC S9(7) COMP-3. 04 MT-FPERIOD PIC X.
      04 MT-FDATE PIC 9(6) COMP-3. 04 MT-FRD PIC 9 COMP-3.
    02 MT-SOURCE PIC X(10).
    02 MT-BFR-TYPE PIC XX.
    02 MT-BFR-NUM PIC X(10).
    02 MT-BFR-SCHED PIC XX.
    02 MT-BFR-FDATE PIC 9(6) COMP-3.
    02 MT-BFR-TDATE PIC 9(6) COMP-3.
    02 MT-BFR-DATE PIC 9(6) COMP-3.
    02 MT-REP PIC XX.
    02 MT-FILL1 PIC X.
    02 MT-STATUS PIC XX.
    02 MT-LF PIC X(6).
    02 MT-DOCK PIC X(8).
    02 MT-RUN-KEY PIC X(14).
*      FILLER X(228)

FD  DAYREL.
01  DY-RECORD PIC X(1500).
01  DY-REC.
    02 DY-KEY.
      03 DY-PLANT PIC X(10).
      03 DY-PROD PIC X(12).
      03 DY-SEQ PIC 99.
    02 DY-KP.
      03 DY-KPROD PIC X(12).
      03 DY-KPLANT PIC X(10).
    02 DY-TYPE PIC 99 COMP-3.
    02 DY-SEP PIC X.
    02 DY-DATE PIC 9(6) COMP-3.
    02 DY-ISA-KEY PIC X(19).
    02 DY-IXL PIC 99 COMP-3.
    02 DY-IXI PIC 99 COMP-3.
    02 DY-IXF PIC 99 COMP-3.
    02 DY-LIN. 03 OCCURS 5. 04 DY-LCODE PIC XX. 04 DY-LVAL PIC X(10).
    02 DY-INFO. 03 DY-IFLINE PIC X(40) OCCURS 16.
    02 DY-FST. 03 OCCURS 30. 04 DY-FQTY PIC S9(7) COMP-3. 04 DY-FDATE PIC 9(6) COMP-3.
      04 DY-FQUAL PIC XXX. 04 DY-FTIME PIC 9(4) COMP-3. 04 DY-FRD PIC 9 COMP-3.
    02 DY-BSS PIC X(60).
    02 DY-ORD PIC 9(6) COMP-3.
    02 DY-SCHEDULE PIC XX.
    02 DY-LF PIC X(10).
    02 DY-DXNO PIC 9(4) COMP-3.
    02 DY-FILL1 PIC X(9).
    02 DY-LABINF PIC X(115).
    02 DY-CUSORD PIC X(9).
    02 DY-DOCK PIC X(8).
*      FILLER X(44)

FD  DELJITEX.
01  DX-RECORD PIC X(2000).
01  DX-REC.
    02 DX-KEY.
      03 DX-NO PIC 9(4).
    02 DX-DATE PIC 9(6) COMP-3.
    02 DX-DATA PIC X(1800).
    02 DX-TYPE PIC 99 COMP-3.
*      FILLER X(190)
* note 187

FD  MACHINE.
01  M-RECORD PIC X(150).
01  M-REC.
    02 M-KEY.
      03 M-NO PIC 9(4).
    02 M-GROUP PIC 99.
    02 M-TYPE PIC 99.
    02 M-TQTY PIC 9(9) COMP-3.
    02 M-RNO PIC 9(6) COMP-3.
    02 M-HOURS PIC 99 COMP-3.
    02 M-DESC1 PIC X(30).
    02 M-DESC2 PIC X(30).
    02 M-OPDESC PIC X(10).
    02 M-COST PIC 9(4)V999 COMP-3.
    02 M-CMODE PIC X.
    02 M-TWEIGHT PIC 9(4)V99 COMP-3.
    02 M-SECT PIC 99 COMP-3.
    02 M-LDAYS PIC 999 COMP-3.
    02 M-PLT-IND PIC 9 COMP-3.
    02 M-LOT-CHARGE PIC 999V99 COMP-3.
    02 M-BATCH-CHARGE PIC 999V99 COMP-3.
    02 M-SURCHARGE PIC 99V99 COMP-3.
    02 M-VENDOR PIC 9(4) COMP-3.
    02 M-TCOST PIC 9(4)V999 COMP-3.
    02 M-SPEED PIC 999 COMP-3.
    02 M-EFF PIC 99 COMP-3.
    02 M-FREIGHT PIC 99V999 COMP-3.
    02 M-HCOST PIC 9(4)V999 COMP-3.
    02 M-INACTIVE PIC 9 COMP-3.
    02 M-CLFREQ PIC 9(5) COMP-3.
    02 M-CLDATE PIC 9(6) COMP-3.
*      FILLER X(13)
* note 160.3

FD  ITMACHINE.
01  ITM-RECORD PIC X(150).
01  ITM-REC.
    02 ITM-KEY.
      03 ITM-NO PIC 9(4).

FD  MACTYPE.
01  ME-RECORD PIC X(50).
01  ME-REC.
    02 ME-KEY.
      03 ME-NO PIC 99.
    02 ME-DESC PIC X(36).
    02 ME-CONTRIB PIC 9(4) COMP-3.
    02 ME-COST PIC 9(4)V999 COMP-3.
    02 ME-CMODE PIC X.
    02 ME-TOOLCOST PIC 9(4)V999 COMP-3.
*      FILLER X(0)

FD  MACSCHED BLOCK 2048.
01  MQ-RECORD PIC X(650).
01  MQ-REC.
    02 MQ-KEY.
      03 MQ-MAC PIC 99.
    02 OCCURS 15.
      03 MQ-MO PIC 9(6) COMP-3.
      03 MQ-COM PIC X(30).
    02 MQ-REV PIC 99 COMP-3.
    02 MQ-PDT PIC X(15).
*      FILLER X(121)

FD  PRODORD BLOCK 2048.
01  R-RECORD PIC X(115).
01  R-REC.
    02 R-KEY.
      03 R-NO PIC 9(6).
    02 R-KP.
      03 R-PROD PIC X(12).
      03 R-DATE PIC 9(6).
    02 R-QTY-ORD PIC S9(9) COMP-3.
    02 R-QTY-LEFT PIC S9(9) COMP-3.
    02 R-QTY-PROD PIC S9(9) COMP-3.
    02 R-LDATE PIC 9(6) COMP-3 OCCURS 3.
    02 R-SPORD PIC 9(6) COMP-3.
    02 R-SPLINE PIC 99 COMP-3.
    02 R-FIN PIC 9 COMP-3.
    02 R-LAST-DATE PIC 9(6) COMP-3.
    02 R-FILL1 PIC X.
    02 R-PUR PIC 9 COMP-3.
    02 R-TICKET PIC 9 COMP-3.
    02 R-SPMOD PIC 9 COMP-3.
    02 R-ALLOC PIC 9 COMP-3.
    02 R-SUR PIC 9 COMP-3.
    02 R-IND PIC 9 COMP-3.
    02 R-QTY-REC PIC S9(9) COMP-3.
    02 R-OLD-LEFT PIC S9(9) COMP-3.
    02 R-OLD-PROD PIC S9(9) COMP-3.
    02 R-COILS PIC 999V9 COMP-3.
    02 R-LMAT PIC 9 COMP-3.
    02 R-LPROC PIC 9 COMP-3.
    02 R-LTOOLS PIC 9 COMP-3.
    02 R-TMP PIC S999V99 COMP-3 OCCURS 4.
    02 R-ORIG-ORD PIC S9(9) COMP-3.
*      FILLER X(7)

FD  WORKSHEET BLOCK 2048.
01  J-RECORD PIC X(240).
01  J-REC.
    02 J-KEY.
      03 J-NO PIC 9(6).
      03 J-KM.
        04 J-MAC PIC 9(4).
        04 J-DATE PIC 9(6).
        04 J-SHIFT PIC 9.
        04 J-EMP PIC 9(4).
    02 J-KN.
      03 J-KNO PIC 9(6).
      03 J-KD.
        04 J-KDATE PIC 9(6).
        04 J-KSHIFT PIC 9.
        04 J-KMAC PIC 9(4).
    02 J-NAME PIC X(20).
    02 J-PROD PIC X(12).
    02 J-HOURS PIC 99V99 COMP-3.
    02 J-QTY PIC S9(9) COMP-3.
    02 J-WEIGHT PIC S9(9) COMP-3.
    02 J-AWEIGHT PIC S9(9) COMP-3.
    02 J-NOTE PIC X(70).
    02 REDEFINES J-NOTE. 03 J-LOT PIC 9(7) OCCURS 10.
    02 J-BKEMPTY PIC 9 COMP-3.
    02 J-BKTOT PIC 99 COMP-3.
    02 J-DHOURS PIC 9V99 COMP-3 OCCURS 9.
    02 J-BKWRONG PIC 9 COMP-3.
*      FILLER X(62)

FD  BUCKET.
01  BU-RECORD PIC X(50).
01  BU-REC.
    02 BU-KEY.
      03 BU-JKEY.
        04 BU-NO PIC 9(6).
        04 BU-MAC PIC 9(4).
        04 BU-DATE PIC 9(6).
        04 BU-SHIFT PIC 9.
        04 BU-EMP PIC 9(4).
      03 BU-NUM PIC 9(4).
    02 BU-KN.
      03 BU-KNUM PIC 9(4).
      03 BU-ZDATE PIC 9(6).
    02 BU-WEIGHT PIC 9(4) COMP-3.
    02 BU-SEQ PIC 99 COMP-3.
*      FILLER X(10)

FD  PHYSINV.
01  PI-RECORD PIC X(50).
01  PI-REC.
    02 PI-KEY.
      03 PI-NO PIC 9(6).
    02 PI-KM.
      03 PI-MO PIC 9(6).
    02 PI-DATE PIC 9(6) COMP-3.
    02 PI-QTY PIC S9(9) COMP-3.
    02 PI-WEIGHT PIC S9(9) COMP-3.
    02 PI-CODE PIC 99 COMP-3.
    02 PI-LOCATION PIC 99 COMP-3.
*      FILLER X(20)

FD  MILL.
01  ML-RECORD PIC X(240).
01  ML-REC.
    02 ML-KEY.
      03 ML-CYCLE PIC X(4).
      03 ML-DIAM PIC X(6).
    02 ML-KD.
      03 ML-KDIAM PIC X(6).
      03 ML-ZDATE PIC 9(6) COMP-3.
    02 ML-DATE PIC 9(6) COMP-3.
    02 ML-WEI-MAX PIC 9(7) COMP-3.
    02 ML-WEI-REQ PIC 9(7) COMP-3.
    02 ML-STATUS PIC 9 COMP-3.
    02 ML-GNUM PIC 99 COMP-3.
    02 ML-GRADE PIC X(5) OCCURS 10.
    02 ML-WEI PIC 9(7) COMP-3 OCCURS 10.
*      FILLER X(115)

FD  MNTMAST.
01  MF-RECORD PIC X(980).
01  MF-REC.
    02 MF-KEY.
      03 MF-MAC PIC 999.
      03 MF-SEC PIC 99.
      03 MF-LEVEL PIC 99.
    02 MF-FILL1 PIC XXX.
    02 MF-EST-HOURS PIC 999 COMP-3.
    02 MF-NOTE PIC X(70) OCCURS 3.
    02 OCCURS 20.
      03 MF-PROC PIC 999 COMP-3.
      03 MF-HOURS PIC 999V9 COMP-3.
    02 OCCURS 40.
      03 MF-PART PIC X(12).
      03 MF-QTY PIC S999 COMP-3.
*      FILLER X(98)

FD  MNTORD BLOCK 2048.
01  VO-RECORD PIC X(650).
01  VO-REC.
    02 VO-KEY.
      03 VO-NO PIC 9(6).
    02 VO-KN.
      03 VO-ZNO PIC 9(6).
    02 VO-MAC PIC 999 COMP-3.
    02 VO-SEC PIC 99 COMP-3.
    02 VO-LEVEL PIC 99 COMP-3.
    02 VO-TYPE PIC 9 COMP-3.
    02 VO-PRIOR PIC 9 COMP-3.
    02 VO-DATE PIC 9(6) COMP-3.
    02 VO-TIME PIC 9(4) COMP-3.
    02 VO-USER PIC X(12).
    02 VO-MDESC1 PIC X(30).
    02 VO-MDESC2 PIC X(30).
    02 VO-DEPT PIC 99 COMP-3.
    02 VO-SECT PIC 99 COMP-3.
    02 VO-NOTE PIC X(70) OCCURS 3.
    02 VO-STATUS PIC 9 COMP-3.
    02 VO-DN-DATE PIC 9(6) COMP-3.
    02 VO-DN-TIME PIC 9(4) COMP-3.
    02 VO-COMMENT PIC X(70) OCCURS 4.
    02 VO-MAC-IND PIC 9 COMP-3.
*      FILLER X(48)

FD  MNTLIN.
01  VL-RECORD PIC X(60).
01  VL-REC.
    02 VL-KEY.
      03 VL-NO PIC 9(6).
      03 VL-TYPE PIC 9.
      03 VL-ID PIC X(12).
      03 VL-PROC REDEFINES VL-ID PIC 999.
      03 VL-PART REDEFINES VL-ID PIC X(12).
      03 VL-DATE PIC 9(6).
      03 VL-SHIFT PIC 9.
      03 VL-EMP PIC 9(4).
    02 VL-HOURS PIC 999V9 COMP-3.
    02 VL-QTY PIC S999 COMP-3.
    02 VL-VEN PIC 9 COMP-3.
    02 VL-AMT PIC S9(7)V99 COMP-3.
*      FILLER X(19)

FD  MNTMAC.
01  MK-RECORD PIC X(115).
01  MK-REC.
    02 MK-KEY.
      03 MK-NO PIC 999.
    02 MK-DESC1 PIC X(30).
    02 MK-DESC2 PIC X(30).
    02 MK-DEPT PIC 99 COMP-3.
    02 MK-SECT PIC 99 COMP-3.
*      FILLER X(48)

FD  VENDOR.
01  V-RECORD PIC X(480).
01  V-REC.
    02 V-KEY.
      03 V-DIV PIC 99.
      03 V-NO PIC 9(4).
    02 V-KN.
      03 V-NAME PIC X(36).
    02 V-ADD1 PIC X(36).
    02 V-ADD2 PIC X(24).
    02 V-POST PIC X(7).
    02 V-SNAME PIC X(36).
    02 V-SADD1 PIC X(36).
    02 V-SADD2 PIC X(24).
    02 V-SPOST PIC X(7).
    02 V-CONTACT PIC X(30) OCCURS 4.
    02 V-CRDATE PIC 9(6) COMP-3.
    02 V-SIND PIC 9 COMP-3.
    02 V-DISC PIC 99V99 COMP-3.
    02 V-CONTRA PIC 9(7) COMP-3.
    02 V-PAY PIC 9 COMP-3.
    02 V-CLASS PIC 999 COMP-3.
    02 V-GST-IND PIC 9 COMP-3.
    02 V-FREIGHT-STD PIC 999V99 COMP-3.
    02 V-FREIGHT-RATE PIC 99V99 COMP-3.
    02 V-FRPAY PIC 9 COMP-3.
    02 V-INV-DATE PIC 9(6) COMP-3.
    02 V-GROSS PIC S9(9)V99 COMP-3 OCCURS 2.
    02 V-NET PIC S9(9)V99 COMP-3 OCCURS 2.
    02 V-PUR-YTD PIC S9(9) COMP-3 OCCURS 2.
    02 V-PUR-LAST PIC S9(9) COMP-3 OCCURS 2.
    02 V-PUR-2 PIC S9(9) COMP-3 OCCURS 2.
    02 V-DISC-YTD PIC S9(9) COMP-3 OCCURS 2.
*      FILLER X(57)

FD  APTR BLOCK 2048.
01  AT-RECORD PIC X(650).
01  AT-REC.
    02 AT-KEY.
      03 AT-DIV PIC 99.
      03 AT-VEN PIC 9(4).
      03 AT-TYPE PIC 9.
      03 AT-INV PIC X(15).
    02 AT-KD.
      03 AT-KDIV PIC 99.
      03 AT-KVEN PIC 9(4).
      03 AT-ZDATE PIC 9(6).
      03 AT-KTYPE PIC 9.
      03 AT-KINV PIC X(15).
    02 AT-IND PIC 9 COMP-3.
    02 AT-MANUAL PIC 9 COMP-3.
    02 OCCURS 10.
      03 AT-GL PIC 9(18).
      03 AT-AMT PIC S9(7)V99 COMP-3.
      03 AT-QTY PIC S9(9) COMP-3.
    02 AT-EXCH PIC 99V9(4) COMP-3.
    02 AT-MEMO PIC X(18).
    02 AT-PROJECT PIC 9(6) COMP-3.
    02 AT-DATE PIC 9(6) COMP-3.
    02 AT-INV-DATE PIC 9(6) COMP-3.
    02 AT-EFF-DATE PIC 9(6) COMP-3.
    02 AT-DUE-DATE PIC 9(6) COMP-3.
    02 AT-GROSS PIC S9(7)V99 COMP-3.
    02 AT-NET PIC S9(7)V99 COMP-3.
    02 AT-DISC PIC S9(7)V99 COMP-3.
    02 AT-TOTAL PIC S9(7)V99 COMP-3.
    02 AT-PST PIC S9(7)V99 COMP-3.
    02 AT-GST PIC S9(7)V99 COMP-3.
    02 AT-FREIGHT PIC S9(7)V99 COMP-3.
    02 AT-FRPAY PIC 9 COMP-3.
    02 AT-FGL PIC 9(18).
    02 AT-ORD PIC X(8).
    02 AT-CHQNO PIC 9(6) COMP-3.
    02 AT-CHQDATE PIC X(10).
    02 AT-WIND PIC 9 COMP-3.
    02 AT-NAME PIC X(30).
    02 AT-ADD1 PIC X(30).
    02 AT-ADD2 PIC X(24).
    02 AT-POST PIC X(7).
    02 AT-EXP-DATE PIC 9(6) COMP-3.
*      FILLER X(104)
* note 276.2

FD  INAPTR BLOCK 2048.
01  INAT-RECORD PIC X(650).
01  INAT-REC.
    02 INAT-KEY.
      03 INAT-DIV PIC 99.
      03 INAT-VEN PIC 9(4).
      03 INAT-TYPE PIC 9.
      03 INAT-INV PIC X(15).
    02 INAT-KD.
      03 INAT-KDIV PIC 99.
      03 INAT-KVEN PIC 9(4).
      03 INAT-ZDATE PIC 9(6).
      03 INAT-KTYPE PIC 9.
      03 INAT-KINV PIC X(15).

FD  APCHQ.
01  AH-RECORD PIC X(50).
01  AH-REC.
    02 AH-KEY.
      03 AH-DIV PIC 99.
      03 AH-US PIC 9.
      03 AH-NO PIC 9(6).
    02 AH-VEN PIC 9(4) COMP-3.
    02 AH-CHQDATE PIC X(10).
    02 AH-NET PIC S9(7)V99 COMP-3.
    02 AH-GROSS PIC S9(7)V99 COMP-3.
    02 AH-MDATE PIC 9(6) COMP-3.
    02 AH-CHNDATE PIC 9(6) COMP-3.
*      FILLER X(10)

FD  GLDIST.
01  G-RECORD PIC X(115).
01  G-REC.
    02 G-KEY.
      03 G-DIV PIC 99.
      03 G-GL PIC 9(18).
    02 G-DESC PIC X(25).
    02 G-NGL PIC 9(18).
*      FILLER X(52)

FD  GLTR.
01  GT-RECORD PIC X(75).
01  GT-REC.
    02 GT-KEY.
      03 GT-DIV PIC 99.
      03 GT-VEN PIC 9(4).
      03 GT-INV PIC X(15).
      03 GT-TYPE PIC 9.
      03 GT-SYS PIC 9.
      03 GT-GL PIC 9(18).
    02 GT-AMT PIC S9(9)V99 COMP-3.
    02 GT-FILL1 PIC X.
    02 GT-YY PIC 99 COMP-3.
    02 GT-MM PIC 99 COMP-3.
    02 GT-QTY PIC S9(9) COMP-3.
    02 GT-INV-DATE PIC 9(6) COMP-3.
*      FILLER X(14)

FD  PURHIST BLOCK 2048.
01  PU-RECORD PIC X(130).
01  PU-REC.
    02 PU-KEY.
      03 PU-DIV PIC 99.
      03 PU-PART PIC X(12).
      03 PU-ZDATE PIC 9(6).
      03 PU-ZTIME PIC 9(8).
    02 PU-KV.
      03 PU-VDIV PIC 99.
      03 PU-VENDOR PIC 9(4).
      03 PU-ZVDATE PIC 9(6).
      03 PU-ZVTIME PIC 9(8).
    02 PU-INV PIC X(15).
    02 PU-ORD PIC X(8).
    02 PU-CAT PIC 999 COMP-3.
    02 PU-QTY PIC S9(7) COMP-3.
    02 PU-AMT PIC S9(7)V99 COMP-3.
    02 PU-GL PIC 9(18).
    02 PU-LDCOST PIC 9(6)V999 COMP-3.
    02 PU-MODE PIC X(4).
    02 PU-DATE-REQ PIC 9(6) COMP-3.
    02 PU-INV-DATE PIC 9(6) COMP-3.
    02 PU-ALDCOST PIC 9(6)V999 COMP-3.
*      FILLER X(8)
* note 287.3

* note 194
FD  EMPL VALUE OF ID EMPL-ID BLOCK 2560.
01  E-RECORD PIC X(1250).
01  E-REC.
    02 E-KEY.
      03 E-DIV PIC 99.
      03 E-NO PIC 9(4).
    02 E-NAME PIC X(30).
    02 E-ADD1 PIC X(30).
    02 E-ADD2 PIC X(24).
    02 E-POST PIC X(7).
    02 E-DEPT PIC 99 COMP-3.
    02 E-PROV-CODE PIC 99 COMP-3.
    02 E-SIN PIC 9(9) COMP-3.
    02 E-VACINC-IND PIC 9 COMP-3.
    02 E-STATUS PIC X.
    02 E-POSITION PIC X(20).
    02 E-BIRTH-YDATE PIC 9(6) COMP-3.
    02 E-HIRED-YDATE PIC 9(6) COMP-3.
    02 E-VAC-WEEKS PIC 9 COMP-3.
    02 E-UNION-CODE PIC 9 COMP-3.
    02 E-LIFE PIC 9(4) COMP-3.
    02 E-EHB PIC X.
    02 E-OHIP PIC X.
    02 E-PAY-PER PIC 9 COMP-3.
    02 E-TAX-IND PIC 9 COMP-3.
    02 E-UIC-IND PIC 9 COMP-3.
    02 E-CPP-IND PIC 9 COMP-3.
    02 E-SALARY PIC 9(4)V99 COMP-3.
    02 E-RATE PIC 99V99 COMP-3.
    02 E-PHONE PIC 9(10) COMP-3.
    02 E-FED-TAXCRED PIC 9(6) COMP-3.
    02 E-COMPEN-PERC PIC 99V999 COMP-3.
    02 E-VAC-PERC PIC 99V999 COMP-3.
    02 E-VAC-CURRENT PIC S9(5)V99 COMP-3.
    02 E-VAC-PRIOR PIC S9(5)V99 COMP-3.
    02 E-CONTRA PIC 9(7) COMP-3.
    02 E-VOLTAX PIC 9(4)V99 COMP-3.
    02 E-VAC-HCURRENT PIC S999V99 COMP-3.
    02 E-VAC-HPRIOR PIC S999V99 COMP-3.
    02 E-ONPRM-YTD PIC 9(4)V99 COMP-3.
    02 E-FILL1 PIC XX.
    02 E-PENSEARN-YTD PIC 9(6)V99 COMP-3.
    02 E-GROSS-YTD PIC 9(6)V99 COMP-3.
    02 E-TAXBEN-YTD PIC 9(5)V99 COMP-3.
    02 E-COMM-YTD PIC 9(4)V99 COMP-3.
    02 E-INSEARN-YTD PIC 9(6)V99 COMP-3.
    02 E-TOT-HOURS-YTD PIC 9(4)V99 COMP-3.
    02 E-PREM-HOURS-YTD PIC 9(4)V99 COMP-3.
    02 E-TAX-YTD PIC 9(6)V99 COMP-3.
    02 E-CPP-YTD PIC 9(4)V99 COMP-3.
    02 E-UIC-YTD PIC 9(4)V99 COMP-3.
    02 E-COMPEN-YTD PIC 9(4)V99 COMP-3.
    02 E-DUES-YTD PIC 9(4)V99 COMP-3.
    02 E-NET-YTD PIC 9(6)V99 COMP-3.
    02 E-PER-HOURS PIC 999V99 COMP-3.
    02 E-TAXBEN-AMT PIC 9(5)V99 COMP-3.
    02 E-TAXBEN-LIM PIC 9(5)V99 COMP-3.
    02 E-DUES-AMT PIC 99V99 COMP-3.
    02 E-CRED PIC 999V99 COMP-3.
    02 E-WELFARE PIC 99V99 COMP-3.
    02 E-DEL PIC 9 COMP-3.
    02 E-COMPEN-ADJ PIC 9(5)V99 COMP-3.
    02 E-VOLTAX-YTD PIC 9(4)V99 COMP-3.
    02 E-SENIORITY-YDATE PIC 9(6) COMP-3.
    02 E-SECT PIC 99 COMP-3.
    02 E-BON-YTD PIC 9(6)V99 COMP-3.
    02 E-BONTAX-YTD PIC 9(6)V99 COMP-3.
    02 E-DEDUCTIONS PIC 9(5) COMP-3.
    02 E-AUTO-YTD PIC 9(4)V99 COMP-3.
    02 E-LOAN-YTD PIC 9(4)V99 COMP-3.
    02 E-BANK-ID PIC 999 COMP-3.
    02 E-BANK-TRANSIT PIC 9(5) COMP-3.
    02 E-ON-TAXCRED PIC 9(6) COMP-3.
    02 E-COLA PIC 9 COMP-3.
    02 E-COMPEN-ELIG PIC 9 COMP-3.
    02 E-FILL2 PIC X.
    02 E-SUPPORT PIC 9(4)V99 COMP-3.
    02 E-SUPPORT-YTD PIC 9(6)V99 COMP-3.
    02 E-PER-NOT PIC 99 COMP-3.
    02 E-UNIFORM PIC 9(4)V99 COMP-3.
    02 E-UNIFORM-DELINQ PIC 9(4)V99 COMP-3.
    02 E-DATE-HIST PIC 9(6) COMP-3 OCCURS 53.
    02 E-HOURS-HIST PIC 999V99 COMP-3 OCCURS 53.
    02 E-INSEARN-HIST PIC 9(4)V99 COMP-3 OCCURS 53.
    02 E-INSWEEK-LAST PIC 99 COMP-3.
    02 E-INSEARN-LAST PIC 9(6)V99 COMP-3.
    02 E-VACPAY-IND PIC 9 COMP-3.
    02 E-CSB-AMT PIC 9(4)V99 COMP-3.
    02 E-CPP-ADJ PIC S999V99 COMP-3.
    02 E-UIC-ADJ PIC S999V99 COMP-3.
    02 E-BANK-ACCOUNT PIC X(12).
    02 E-TOT-HOURS-CUR PIC 999V99 COMP-3.
    02 E-PREM-HOURS-CUR PIC 999V99 COMP-3.
    02 E-GARNISHEE PIC 9(4)V99 COMP-3.
    02 E-COMPEN-NUM PIC 9(9).
    02 E-COMPEN-VOL PIC 999V99 COMP-3.
    02 E-ROE-DATE PIC 9(6) COMP-3.
*      FILLER X(269)

FD  LDTBL VALUE OF ID LDTBL-ID.
01  GP-RECORD PIC X(50).
01  GP-REC.
    02 GP-KEY.
      03 GP-DIV PIC 99.
      03 GP-CODE PIC 999.
    02 GP-FILL1 PIC 999 COMP-3.
    02 GP-DESC PIC X(25).
    02 GP-GL PIC 9(6) COMP-3.
*      FILLER X(14)

FD  LDTR VALUE OF ID LDTR-ID.
01  LY-RECORD PIC X(50).
01  LY-REC.
    02 LY-KEY.
      03 LY-DIV PIC 99.
      03 LY-CODE PIC 999.
      03 LY-DEPT PIC 99.
      03 LY-SECT PIC 99.
      03 LY-YY PIC 99.
      03 LY-MM PIC 99.
      03 LY-PER PIC 99.
      03 LY-SEQ PIC 9.
      03 LY-CONTRA PIC 9(7).
    02 LY-FILL1 PIC X.
    02 LY-AMT PIC S9(7)V99 COMP-3.
    02 LY-HOURS PIC 9(4)V99 COMP-3.
    02 LY-AMT-A PIC S9(5)V99 COMP-3.
*      FILLER X(15)

FD  GLAP VALUE OF ID GLAP-ID.
01  GLK-RECORD PIC X(253).
* common key fields
01  GLK-REC.
    02 GLK-REC-TYPE PIC X.
    02 GLK-LEDGER PIC X(4).
    02 GLK-YEAR PIC 9(4).
    02 GLK-ENTITY PIC X(4).
    02 GLK-JOURNAL PIC X(4).
    02 GLK-PERIOD PIC 99.
    02 GLK-BATCH PIC 9(4).
*      FILLER X(230)
* record type 1
01  GLM-REC.
    02 GLM-KEY PIC X(23).
    02 GLM-JOURNAL-TYPE PIC XX.
    02 GLM-JOURNAL-DESC PIC X(26).
    02 GLM-TRAN-CODE PIC XX.
    02 GLM-REV-JOURNAL PIC X(4).
    02 GLM-BATCH-STATUS PIC XX.
    02 GLM-CTL-DEBITS PIC S9(12)V99 SIGN LEADING SEPARATE.
    02 GLM-CTL-CREDITS PIC S9(12)V99 SIGN LEADING SEPARATE.
    02 GLM-CTL-LINES PIC 9(6).
    02 GLM-ENTRY-CDATE PIC 9(8).
    02 GLM-PROCESS-DATE PIC X(8).
    02 GLM-BAL-REQD-SW PIC X.
    02 GLM-BACKUP-SW PIC X.
    02 GLM-OPT-FIELD PIC X(12).
    02 GLM-ASSIGNED-BATCH PIC 9(4).
    02 GLM-EFFECTIVE-CDATE PIC 9(8).
    02 GLM-SOURCE-SYSTEM PIC X(4).
    02 GLM-TRANSL_JRNL_SW PIC X.
    02 GLM-TRANSL_FROM_SEG PIC X(4).
    02 GLM-FILL1 PIC X(107).
* record type 2
01  GLD-REC.
    02 GLD-KEY PIC X(23).
    02 GLD-LINE PIC 9(6).
    02 GLD-ACCT-ID PIC X(28).
    02 GLD-LINE-DESC PIC X(50).
    02 GLD-TRAN-CODE PIC XX.
    02 GLD-LINE-STATUS PIC XX.
    02 GLD-DEBIT PIC S9(12)V99 SIGN LEADING SEPARATE.
    02 GLD-CREDIT PIC S9(12)V99 SIGN LEADING SEPARATE.
    02 GLD-UPDATE-SW PIC XX.
    02 GLD-OPT-FIELD PIC X(12).
    02 GLD-POSTED-SW PIC XX.
    02 GLD-EFFECTIVE-CDATE PIC 9(8).
    02 GLD-REF1 PIC X(15).
    02 GLD-REF2 PIC X(15).
    02 GLD-REF3 PIC X(10).
    02 GLD-REF4 PIC X(10).
    02 GLD-STAT-AMT PIC S9(12)V99 SIGN LEADING SEPARATE.
    02 GLD-FILL1 PIC X(23).

FD  IFGFL VALUE OF ID IFG-ID.
01  HC-RECORD PIC X(103).
01  HC-REC1.
    02 HC-NO1 PIC X(5).
    02 HC-NAME PIC X(80).
01  HC-REC2.
    02 HC-NO2 PIC X(5).
    02 HC-ADD1 PIC X(40).
    02 HC-ADD2 PIC X(40).
    02 HC-NREC REDEFINES HC-ADD2 PIC B(35)Z(4)9.
    02 HC-ADD3 PIC X(15).
    02 HC-PAYCUR PIC X.
    02 HC-CODE PIC XX.
01  HC-REC3.
    02 HC-NO3 PIC X(5).
    02 HC-CREDIT PIC -9(8).
    02 HC-TOT PIC -9(8).99.
    02 HC-CUR PIC -9(8).99.
    02 HC-30 PIC -9(8).99.
    02 HC-60 PIC -9(8).99.
    02 HC-90 PIC -9(8).99.
    02 HC-120 PIC -9(8).99.
    02 HC-RACKS PIC -9(8).99.

FD  BNCHQ VALUE OF ID BNCHQ-ID.
01  CZ-RECORD PIC X(700).
01  CZ-REC-OH.
    02 CZ-H1 PIC X(4).
    02 CZ-H2 PIC XXX.
    02 CZ-H3 PIC X(8).
    02 CZ-H4 PIC 9(13).
    02 CZ-H5 PIC 9(6).
    02 CZ-H6 PIC X(4).
01  CZ-REC-OD.
    02 CZ-D1 PIC 9(13).
    02 CZ-D2 PIC 9(10).
    02 CZ-D3 PIC 9(9)V99.
    02 CZ-D4 PIC 9(6).
    02 CZ-D5 PIC X(15).
    02 CZ-D6 PIC X.
    02 CZ-D7 PIC X(60) OCCURS 10.
01  CZ-REC-OT.
    02 CZ-T1 PIC X(4).
    02 CZ-T2 PIC 9(9).
    02 CZ-T3 PIC 9(11)V99.

FD  BNCLR VALUE OF ID BNCLR-ID.
01  BZ-RECORD PIC X(80).
01  BZ-REC-IA.
    02 BZ-A1 PIC X.
    02 BZ-A2 PIC 9(9).
    02 BZ-A3 PIC 9(5).
    02 BZ-A4 PIC 9(4).
    02 BZ-A5 PIC 9(6).
    02 BZ-A6 PIC 9(5).
01  BZ-REC-IB.
    02 BZ-B1 PIC X.
    02 BZ-B2 PIC 9(9).
    02 BZ-B3 PIC 9(9)V99.
    02 BZ-B4 PIC 9(4).
    02 BZ-B5 PIC 9(13).
    02 BZ-B6 PIC 999.
    02 BZ-B7 PIC 9(5).
    02 BZ-B8 PIC 9(12).
    02 BZ-B9 PIC 9(9).
    02 BZ-B10 PIC 9(5).
01  BZ-REC-IT.
    02 PIC X.
* '-IT' identical to '-IZ'
01  BZ-REC-IZ.
    02 BZ-Z1 PIC X.
    02 BZ-Z2 PIC 9(9).
    02 BZ-Z3 PIC 9(5).
    02 BZ-Z4 PIC 9(4).
    02 BZ-Z5 PIC 9(12)V99.
    02 BZ-Z6 PIC 9(8).

WORKING-STORAGE SECTION.
01  ERR-LINE. 02 PIC X(6) VALUE "***** ". 02 ERR-MESG PIC X(73).
01  CKEY.
    02 CK1 PIC X.
      88 KP-TAB VALUE X"09". 88 KP-RETURN VALUE X"0D".
    02 CK2 PIC X(4).
      88 KPF1 VALUE "P". 88 KPF2 VALUE "Q". 88 KPF3 VALUE "R". 88 KPF4 VALUE "S".
      88 KP-UP VALUE "A". 88 KP-DOWN VALUE "B". 88 KP-RIGHT VALUE "C". 88 KP-LEFT VALUE "D".
      88 KP-SELECT VALUE "4~". 88 KP-PREV VALUE "5~". 88 KP-NEXT VALUE "6~".
01  DECLARATIVES-FIELDS.
    02 DSTAT PIC XX. 02 DCL-ERRNO PIC 9(4) COMP-3.
    02 DCL-LINE. 03 DCL-F1 PIC X(7). 03 DCL-F2 PIC X(11). 03 DCL-F3 PIC XX.
      03 DCL-F4 PIC BBBX(30). 03 DCL-F5 PIC Z(4)9.

01  DATE-FIELDS.
    02 D-DT PIC 9(6). 02 REDEFINES D-DT. 03 D-MM PIC 99. 03 D-DD PIC 99. 03 D-YY PIC 99.
    02 D-DATE PIC 9(6) COMP-3. 02 D-DAYS PIC S9(9) COMP-3.
    02 D-YEAR PIC 9(4) COMP-3. 02 D-JDAY PIC 999 COMP-3.
    02 D-LOT PIC 9(7). 02 REDEFINES D-LOT. 03 D-LOTY PIC 9. 03 D-LOTD PIC 999.
    02 D-YEAR1 PIC 9(4) COMP-3. 02 D-YEAR2 PIC 9(4) COMP-3.
    02 D-ERR PIC 9 COMP-3. 02 D-PF PIC 9 COMP-3. 02 D-S1 PIC 9 COMP-3.
    02 D-N1 PIC S9(9) COMP-3. 02 D-N2 PIC S9(9) COMP-3.
    02 D-X1 PIC S999 COMP-3. 02 D-X2 PIC S999 COMP-3.
    02 D-XL1 PIC S99 COMP-3. 02 D-XL2 PIC S99 COMP-3.
    02 D-T1 PIC S9(9) COMP-3. 02 D-T2 PIC S9(9) COMP-3.
    02 D-R1 PIC S9(9) COMP-3. 02 D-R2 PIC S9(9) COMP-3. 02 D-R3 PIC S9(9) COMP-3.
    02 D-M1 PIC S9(9) COMP-3. 02 D-P1 PIC S9(9) COMP-3.
    02 D-W1 PIC S9(9) COMP-3. 02 D-Y1 PIC S9(9) COMP-3.
    02 D-TIME PIC 9(4). 02 D-STIME PIC 9(8). 02 D-TT PIC 99.
    02 D-PRDATE PIC 99/99/99. 02 D-PRTIME PIC X(5). 02 D-PRSTIME PIC X(8).
    02 SYS-DATE PIC 9(6). 02 SYS-YEAR PIC 9(4). 02 SYS-WDAY PIC 9. 02 SYS-TIME PIC 9(8).
    02 SYS-JDATE PIC 9(5). 02 REDEFINES SYS-JDATE. 03 SYS-YY PIC 99. 03 SYS-DDD PIC 999.
    02 D-TBL1 PIC X(70) VALUE "MONDAY   .TUESDAY  .WEDNESDAY.THURSDAY .FRIDAY   .SATURDAY .SUNDAY   .".
    02 REDEFINES D-TBL1. 03 OCCURS 7. 04 D-DAYNM PIC X(9). 04 PIC X.
    02 D-TBL2 PIC X(120) VALUE "JANUARY  .FEBRUARY .MARCH    .APRIL    .MAY      .JUNE     .JULY     .AUGUST   .SEPTEMBER.OCTOBER  .NOVEMBER .DECEMBER .".
    02 REDEFINES D-TBL2. 03 OCCURS 12. 04 D-MTHNM PIC X(9). 04 PIC X.
    02 D-TBL3.
      03 PIC X(52) VALUE "000.031.059.090.120.151.181.212.243.273.304.334.365.".
      03 PIC X(52) VALUE "000.031.060.091.121.152.182.213.244.274.305.335.366.".
    02 REDEFINES D-TBL3. 03 OCCURS 2. 04 OCCURS 13. 05 D-MNUM PIC 999. 05 PIC X.
    02 D-TBL4 PIC X(36) VALUE "00000.07305.14610.21915.29220.36525.".
    02 REDEFINES D-TBL4. 03 OCCURS 6. 04 D-LNUM PIC 9(5). 04 PIC X.
    02 D-TBL5 PIC X(105) VALUE "0000.0365.0730.1096.1461.1826.2191.2557.2922.3287.3652.4018.4383.4748.5113.5479.5844.6209.6574.6940.7305.".
    02 REDEFINES D-TBL5. 03 OCCURS 21. 04 D-YNUM PIC 9(4). 04 PIC X.
01  KEY-FIELDS.
    02 IF-KEY PIC 99. 02 EI-KEY PIC 99. 02 SV-KEY PIC 999.
01  USER-FIELDS.
    02 USN-USER PIC X(12). 02 USN-NUM PIC 99. 02 USN-OP PIC 99 COMP-3.
    02 USN-KSYS PIC 9 COMP-3. 02 USN-KPRT PIC 9 COMP-3. 02 USN-KPC PIC 9 COMP-3.
    02 USN-PRNM PIC XX. 02 USN-TDX. 03 USN-TD PIC X OCCURS 40.
01  TABLE-FIELDS.
    02 TBF-TBL.
      03 PIC X(72) VALUE "TERRITORY         PRODUCT CATEGORY  STD. TEXT         BROKER NAME".
      03 PIC X(72) VALUE "PROCESS TIME      DISCOUNT          PART G/L          STD. DESCRIPTION".
      03 PIC X(72) VALUE "COMMODITY CLASS   PART CATEGORY     PLATING           PROVINCE".
      03 PIC X(72) VALUE "TICKET COLOUR     COUNTRY OF ORIGIN HARMONY SYSTEM    CUSTOMER TERMS".
      03 PIC X(72) VALUE "PRODUCT MARKET    PRODUCT FAMILY    MACHINE GROUP     PLATING SPEC".
      03 PIC X(72) VALUE "(NOT USED)        MACHINE TYPE G/L  FRENCH STD. DESCR.PHYSICAL SPECS".
    02 REDEFINES TBF-TBL. 03 TBF-DESC PIC X(18) OCCURS 24.

01  GENERAL-FIELDS.
    02 WS-DIV PIC 99. 88 IFAST VALUE 21. 88 ITOOL VALUE 31. 88 INUT VALUE 41.
    02 WS-PDIV PIC 99. 02 WS-DIV-NAME PIC X(20). 02 WS-FOB PIC X(12).
    02 WS-GL PIC 9(18). 02 REDEFINES WS-GL.
      03 WS-GL1 PIC 9(6). 03 WS-GL2 PIC 999. 03 WS-GL3 PIC 99. 03 WS-GL4 PIC 9(7).
    02 WS-NGL PIC 9(18). 02 REDEFINES WS-NGL.
      03 WS-NGL1 PIC 9(6). 03 WS-NGL2 PIC 9(6). 03 WS-NGL3 PIC 9(4). 03 WS-NGL4 PIC 99.
    02 WS-CHQNO PIC 9(6). 02 WS-EXCH PIC 9V9(4) COMP-3. 02 WS-EFF-DATE PIC 9(6) COMP-3.
    02 WS-KHD PIC 9 COMP-3. 02 WS-HBOX PIC 9(6) COMP-3. 02 WS-CHNDATE PIC 9(6) COMP-3.
    02 WS-CHQDATE PIC X(10). 02 WS-CHLDATE PIC 9(8) COMP-3.
    02 WS-TAXID PIC X(16) VALUE "472389022 RM0001".
    02 WS-NAME PIC X(16) VALUE "IRVINE FASTENERS".
    02 WS-ADD1 PIC X(19) VALUE "160 RICHMOND STREET".
    02 WS-ADD2 PIC X(27) VALUE "SPRINGHILL, ONTARIO, CANADA".
    02 WS-POST PIC X(7) VALUE "N1K 5R6".
    02 WS-PAGE PIC 9(4) COMP-3. 02 WS-LINES PIC 99 COMP-3. 02 WS-PR PIC 99 COMP-3.
01  PRINTFL-FIELDS.
    02 PR-ID. 03 PR-NAME PIC XX. 03 PR-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 PR-NUM PIC 99. 02 PR-QUEUE PIC X(10).
    02 PR-IX1 PIC S9(7) COMP-3. 02 PR-IXP PIC S999 COMP-3.
01  DOCFL-FIELDS.
    02 DOC-ID. 03 DOC-NAME PIC XX. 03 DOC-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 DOC-QUEUE PIC X(10). 02 DOC-SZ PIC 999 COMP-3. 02 DOC-LINES PIC 999 COMP-3.
    02 DOC-PR PIC 99 COMP-3. 02 DOC-PAGE PIC 9(4) COMP-3.
01  LABFL-FIELDS.
    02 LAB-ID. 03 LAB-NAME PIC XXX. 03 LAB-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 LAB-QUEUE PIC X(10). 02 LAB-PTR PIC 999 COMP-3. 02 LAB-SZ PIC 999 COMP-3.
01  DATFL-FIELDS.
    02 DAT-ID PIC X(8). 02 DAT-SZ PIC 999 COMP-3.
01  EXPFL-FIELDS.
    02 EXP-ID. 03 PIC XX VALUE "FL". 03 EXP-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 EXP-SZ PIC 9(4) COMP-3. 02 EXP-MAX PIC 9(4) COMP-3 VALUE 500.
    02 EXP-IX1 PIC S999 COMP-3. 02 EXP-IXL PIC S999 COMP-3.
    02 EXP-FLD PIC X(50).
    02 REDEFINES EXP-FLD. 03 EXP-A PIC X(50).
    02 REDEFINES EXP-FLD. 03 EXP-N PIC -(11)9.
    02 REDEFINES EXP-FLD. 03 EXP-L PIC -(9)9.9.
    02 REDEFINES EXP-FLD. 03 EXP-D PIC -(9)9.99.
    02 REDEFINES EXP-FLD. 03 EXP-T PIC -(9)9.999.
    02 REDEFINES EXP-FLD. 03 EXP-V PIC -(9)9.9(4).
    02 REDEFINES EXP-FLD. 03 EXP-Q PIC -(9)9.9(5).
    02 REDEFINES EXP-FLD. 03 EXP-DT PIC 99/99/99.
01  LASFL-FIELDS.
    02 LAS-ID. 03 PIC XXX VALUE "LAS". 03 LAS-FLN PIC 99. 03 PIC X(4) VALUE ".PRN".
    02 LAS-QUEUE PIC X(10). 02 LAS-PTR PIC 9(4) COMP-3.
    02 LAS-FLD PIC X(250).
    02 REDEFINES LAS-FLD. 03 FJ-N1 PIC 9.
    02 REDEFINES LAS-FLD. 03 FJ-N2 PIC Z9.
    02 REDEFINES LAS-FLD. 03 FJ-N3 PIC ZZ9.
    02 REDEFINES LAS-FLD. 03 FJ-N4 PIC ZZZ9.
    02 REDEFINES LAS-FLD. 03 FJ-N5 PIC Z(4)9.
    02 REDEFINES LAS-FLD. 03 FJ-N6 PIC Z(5)9.
    02 REDEFINES LAS-FLD. 03 FJ-N7 PIC Z(6)9.
    02 REDEFINES LAS-FLD. 03 FJ-D12 PIC 9.99.
    02 REDEFINES LAS-FLD. 03 FJ-D21 PIC Z9.9.
    02 REDEFINES LAS-FLD. 03 FJ-D31 PIC ZZ9.9.
    02 REDEFINES LAS-FLD. 03 FJ-D24 PIC Z9.9(4).
    02 REDEFINES LAS-FLD. 03 FJ-C4 PIC Z,ZZ9.
    02 REDEFINES LAS-FLD. 03 FJ-C8 PIC ZZ,ZZZ,ZZ9.
    02 REDEFINES LAS-FLD. 03 FJ-NDT PIC 99/99/99.
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ12 PIC Z(5)9. 03 FJ13 PIC B(4)99/99/99.
      03 FJ14 PIC BBBX(8). 03 FJ15 PIC BBBX(6). 03 FJ16 PIC 99/99/99.
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ17 PIC X(9). 03 FJ18 PIC X(8). 03 FJ19 PIC X(32).
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ20 PIC X(22). 03 FJ21 PIC X(32).
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ22 PIC X(4). 03 FJ23 PIC ZZZ,ZZZ,ZZ9.
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ24 PIC X(7). 03 FJ25 PIC ZZZ9.99. 03 FJ26 PIC BXX.
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ27 PIC X(4). 03 FJ28 PIC X(20). 03 FJ29 PIC X(5).
      03 FJ30 PIC Z9. 03 FJ31 PIC BX(30).
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ32 PIC Z9.9. 03 FJ33 PIC BX(5). 03 FJ34 PIC Z(4)9.
      03 FJ35 PIC BX(7). 03 FJ36 PIC BX(10). 03 FJ37 PIC BBX(15)B.
      03 FJ38 PIC Z(4)9. 03 FJ39 PIC X(4).
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ40 PIC X(72).
    02 REDEFINES LAS-FLD.
      03 PIC X(10). 03 FJ41 PIC X(4). 03 FJ42 PIC X(45).

    02 LAS-PAGE PIC S99 COMP-3. 02 LAS-NPAGE PIC S99 COMP-3.
    02 LAS-SDATE. 03 LAS-SD1 PIC Z9. 03 LAS-SD2 PIC BXXX. 03 LAS-SD3 PIC B9(4).
    02 LAS-FDATE. 03 LAS-FD1 PIC 99/99/99.
      03 LAS-FD2 PIC ZZ99. 03 PIC X VALUE ":". 03 LAS-FD3 PIC 99.
    02 LAS-FPAGE. 03 PIC X(5) VALUE "PAGE ". 03 LAS-FPAGE1 PIC 9.
      03 PIC X(4) VALUE " OF ". 03 LAS-FPAGE2 PIC 9.
    02 LAS-ROW PIC 999 COMP-3. 02 LAS-COL PIC 999 COMP-3.
    02 LAS-IXN PIC S999 COMP-3. 02 LAS-IX1 PIC S999 COMP-3. 02 LAS-IX2 PIC S999 COMP-3.
    02 LAS-FL1 PIC S999 COMP-3. 02 LAS-FL2 PIC S999 COMP-3.

    02 LAS-BAR39 PIC X(44) VALUE "1234567890ABCDEFGHIJKLMNOPQRSTUVWXYZ-. *$/+%".
    02 LAS-BARTBL.
      03 PIC X(40) VALUE "194.394.134.594.154.354.794.174.374.574.".
      03 PIC X(40) VALUE "196.396.136.596.156.356.796.176.376.576.".
      03 PIC X(40) VALUE "198.398.138.598.158.358.798.178.378.578.".
      03 PIC X(40) VALUE "192.392.132.592.152.352.792.172.372.572.".
      03 PIC X(16) VALUE "246.248.268.468.".
    02 REDEFINES LAS-BARTBL. 03 OCCURS 44. 04 LAS-BARL PIC 9 OCCURS 3. 04 PIC X.
    02 LAS-BARCHAR. 03 LAS-BARC PIC 9 OCCURS 10. 02 LAS-BARCH PIC X.
    02 LAS-BARX PIC 99 COMP-3. 02 LAS-BARH PIC 999 COMP-3.
    02 LAS-BARV PIC 9 COMP-3. 02 LAS-BARN PIC 99 COMP-3.

    02 LAS-PO90. 03 PIC X VALUE X"1B". 03 PIC X(5) VALUE "&a90P".
    02 LAS-RMOVE. 03 PIC X VALUE X"1B". 03 PIC XXX VALUE "*p+".
      03 LAS-RMX PIC 9(4). 03 PIC X VALUE "X".
    02 LAS-DMOVE. 03 PIC X VALUE X"1B". 03 PIC XXX VALUE "*p+".
      03 LAS-DMY PIC 9(4). 03 PIC X VALUE "Y".
    02 LAS-POS. 03 PIC X VALUE X"1B". 03 PIC XX VALUE "*p".
      03 LAS-POSX PIC 9(4). 03 PIC X VALUE "x".
      03 LAS-POSY PIC 9(4). 03 PIC X VALUE "Y".
    02 LAS-PCR. 03 PIC X VALUE X"1B". 03 PIC XX VALUE "&a".
      03 LAS-PCRX PIC 9(4). 03 PIC X VALUE "c".
      03 LAS-PCRY PIC 9(4). 03 PIC X VALUE "R".
    02 LAS-STYLE. 03 PIC X VALUE X"1B". 03 PIC XX VALUE "(s".
      03 LAS-STYP PIC 99.99. 03 PIC X VALUE "h".
      03 LAS-STYI PIC 9. 03 PIC X VALUE "s".
      03 LAS-STYB PIC 9. 03 PIC X VALUE "B".
    02 LAS-AREA. 03 PIC X VALUE X"1B". 03 PIC XX VALUE "*c".
      03 LAS-AREX PIC 9(4). 03 PIC X VALUE "a".
      03 LAS-AREY PIC 9(4). 03 PIC X VALUE "b".
      03 LAS-AREF PIC 9. 03 PIC X VALUE "P".

01  EPSON-FIELDS.
    02 EPS-INIT PIC XX VALUE X"1B40". 02 EPS-FF PIC X VALUE X"0C".
    02 EPS-CONDY PIC X VALUE X"0F". 02 EPS-CONDN PIC X VALUE X"12".
    02 EPS-SKIPY PIC XX VALUE X"1B4E". 02 EPS-SKIPN PIC XX VALUE X"1B4F".
    02 EPS-PGLIN. 03 PIC XX VALUE X"1B43". 03 EPS-PGL PIC X.
    02 EPS-ALIGN PIC X(14) VALUE X"1B401B4F1B43400C1B41060A1B40".

01  FID-FIELDS.
    02 MFA-ID. 03 PIC X(6) VALUE "MAINTA". 03 MFA-NUM PIC 99. 03 MFA-TIM PIC 9(8).
    02 MFB-ID. 03 PIC X(6) VALUE "MAINTB". 03 MFB-NUM PIC 99. 03 MFB-TIM PIC 9(8).
    02 MFC-ID. 03 PIC X(6) VALUE "MAINTC". 03 MFC-NUM PIC 99. 03 MFC-TIM PIC 9(8).
    02 REP-ID. 03 PIC X(5) VALUE "REPFL". 03 REP-NUM PIC 99. 03 REP-TIM PIC 9(8).
    02 SORT-ID. 03 PIC X(6) VALUE "SORTFL". 03 SORT-NUM PIC 99. 03 SORT-TIM PIC 9(8).
    02 SORC-ID. 03 PIC X(6) VALUE "SORCFL". 03 SORC-NUM PIC 99. 03 SORC-TIM PIC 9(8).
    02 EMPL-ID. 03 PIC X(9) VALUE "DUA1:[PAY". 03 EMPL-DIV PIC 99. 03 PIC X(9) VALUE "]EMPLOYEE".
    02 LDTBL-ID. 03 PIC X(9) VALUE "DUA1:[PAY". 03 LDTBL-DIV PIC 99. 03 PIC X(6) VALUE "]LDTBL".
    02 LDTR-ID. 03 PIC X(9) VALUE "DUA1:[PAY". 03 LDTR-DIV PIC 99. 03 PIC X(5) VALUE "]LDTR".
    02 GLAP-ID. 03 GLAP-NAME PIC X(4). 03 GLAP-NUM PIC 99. 03 GLAP-BATCH PIC 99.
    02 BNCHQ-ID. 03 PIC X(13) VALUE "DUA1:[IFMAIN]". 03 BNCHQ-NAME PIC X(7).
    02 BNCLR-ID. 03 PIC X(13) VALUE "DUA1:[IFMAIN]". 03 BNCLR-NAME PIC X(7).
    02 IFG-ID PIC XXX. 02 PIN-ID PIC X(10). 02 SIX-ID PIC X(10).
01  OLDKEY-FIELDS.
    02 OLD-N PIC S9(11) COMP-3. 02 OLD-M PIC S9(11) COMP-3.
    02 OLD-T PIC S9(11) COMP-3. 02 OLD-G PIC S9(11) COMP-3.
    02 OLD-A PIC X(20). 02 OLD-B PIC X(20). 02 OLD-C PIC X(20).
    02 OLD-D PIC S9(9)V99 COMP-3. 02 OLD-V PIC S9(9)V9(4) COMP-3.
    02 OLD-NAME PIC X(32). 02 OLD-DESC PIC X(32).
    02 OLD-INVLN. 03 OLD-INV PIC 9(6). 03 OLD-LN PIC 99.
01  INDICATOR-FIELDS.
    02 INQ-IND PIC 9 COMP-3. 02 TOT-IND PIC 9 COMP-3. 02 SUM-IND PIC 9 COMP-3.
    02 USD-IND PIC 9 COMP-3. 02 CAU-IND PIC 9 COMP-3. 02 CFO-IND PIC 9 COMP-3.
01  SELECTION-FIELDS.
    02 SEL-N PIC 99 COMP-3.
      88 Y1 VALUE 1. 88 Y2 VALUE 2. 88 Y3 VALUE 3. 88 Y4 VALUE 4. 88 Y5 VALUE 5.
      88 Y6 VALUE 6. 88 Y7 VALUE 7. 88 Y8 VALUE 8. 88 Y9 VALUE 9. 88 Y10 VALUE 10.
01  STRING-FIELDS.
    02 STR-NUM PIC 9(4) COMP. 02 REDEFINES STR-NUM. 03 STR-BL PIC X. 03 STR-BH PIC X.
    02 STR-IX1 PIC S999 COMP-3.

01  VIDEO-FIELDS.
    02 IXT PIC 99 COMP-3. 02 IXTSV PIC 99 COMP-3.
    02 IXU PIC 999 COMP-3. 02 IXV PIC 999 COMP-3. 02 IXCOL PIC S999 COMP-3.
    02 TXS PIC 9(4) COMP-3. 02 TXW PIC 99 COMP-3.
    02 TXF PIC 999 COMP-3. 02 TXC PIC 999 COMP-3.
    02 TSA PIC 9 COMP-3. 02 TCH PIC X. 02 TLTH PIC 999 COMP-3.
    02 TSTR PIC X(2000). 02 TFLD. 03 TFC PIC X OCCURS 132.
    02 TCLSF PIC X(4) VALUE X"1B5B304A". 02 TCLSU PIC X(4) VALUE X"1B5B314A".
    02 TCLS PIC X(4) VALUE X"1B5B324A". 02 TNORM PIC X(4) VALUE X"1B5B306D".
    02 TBOLD PIC X(4) VALUE X"1B5B316D". 02 TREV PIC X(4) VALUE X"1B5B376D".
    02 TPOS PIC X(9) VALUE X"1B5B30303B30303066".
    02 REDEFINES TPOS. 03 PIC XX. 03 TROW PIC 99. 03 PIC X. 03 TCOL PIC 999.
    02 TW80 PIC X(5) VALUE X"1B5B3F336C". 02 TW132 PIC X(5) VALUE X"1B5B3F3368".
    02 TWIDTH PIC 999 COMP-3. 02 TSTART PIC 99 COMP-3.
    02 TMSG PIC X(80). 02 TX1 PIC 99 COMP-3.

01  INPUT-FIELDS.
    02 XA1 PIC X. 02 XA2 PIC XX. 02 XA3 PIC XXX. 02 XA4 PIC X(4). 02 XA5 PIC X(5).
    02 XN1 PIC 9. 02 XN2 PIC 99. 02 XN3 PIC 999. 02 XN4 PIC 9(4).

    02 TD-INP1. 03 IA1 PIC X(6). 03 IA2 PIC 99.
    02 TD-INP2. 03 IA3 PIC X(12).
    02 TD-INP3. 03 IA4 PIC X(12). 03 IA5 PIC 9(4).
    02 TD-INP4. 03 IA6 PIC 999.
    02 TD-INP5. 03 IA7 PIC X(6).
    02 TD-INP6. 03 IA8 PIC 99. 03 IA9 PIC X(12). 03 IA10 PIC 9(6).
    02 TD-INP7. 03 IA11 PIC 9(4).
    02 TD-INP8. 03 IA12 PIC 999.
    02 TD-INP9. 03 IA13 PIC X(12).
    02 TD-INP10. 03 IA14 PIC X(12).
    02 TD-INP11. 03 IA15 PIC X(6).
    02 TD-INP12. 03 IA16 PIC X(6).
    02 TD-INP13. 03 IA17 PIC 9(6).
    02 TD-INP14. 03 IA18 PIC X(6). 03 IA19 PIC X(12).
    02 TD-INP15. 03 IA20 PIC X(12). 03 IA21 PIC X(6).
    02 TD-INP16. 03 IA22 PIC X(12).
    02 TD-INP17. 03 IA23 PIC X(12).
    02 TD-INP18. 03 IA24 PIC X(8).
    02 TD-INP19. 03 IA25 PIC X(12).
    02 TD-INP20. 03 IA26 PIC 9(4).
    02 TD-INP21. 03 IA27 PIC X(12).
    02 TD-INP22. 03 IA28 PIC X(12).
    02 TD-INP23. 03 IA29 PIC X(12).
    02 TD-INP24. 03 IA30 PIC 9(4).
    02 TD-INP25. 03 IA31 PIC 9(6).
    02 TD-INP26. 03 IA32 PIC X(12).
    02 TD-INP27. 03 IA33 PIC X(12).
    02 TD-INP28. 03 IA34 PIC X(12).
    02 TD-INP29. 03 IA35 PIC X(12).
    02 TD-INP30. 03 IA36 PIC 9(7).
    02 TD-INP31. 03 IA37 PIC 9(4).
    02 TD-INP32. 03 IA38 PIC 9(6).
    02 TD-INP33. 03 IA39 PIC 9(6).
    02 TD-INP34. 03 IA40 PIC X(12).
    02 TD-INP35. 03 IA41 PIC X(6). 03 IA42 PIC X(12). 03 IA43 PIC 9(6). 03 IA44 PIC 9(6).
    02 TD-INP36. 03 IA45 PIC X(4).
    02 TD-INP37. 03 IA46 PIC 9(7).
    02 TD-INP38. 03 IA47 PIC 9(6).
    02 TD-INP39. 03 IA48 PIC X(6). 03 IA49 PIC X(12).
    02 TD-INP40. 03 IA50 PIC X(6).

    02 TD-INP-R1.
      03 IE11 PIC 9(4). 03 IE12 PIC 9(4). 03 IE13 PIC 9(6). 03 IE14 PIC XXX.
    02 TD-INP-R2.
      03 IE21 PIC X(10). 03 IE22 PIC X(5). 03 IE23 PIC 9(6). 03 IE24 PIC 9(6).
      03 IE25 PIC X(12). 03 IE26 PIC S9(9). 03 IE27 PIC 9(7). 03 IE28 PIC X(50).
    02 TD-INP-R3.
      03 IE31 PIC X(6). 03 IE32 PIC 9(6). 03 IE33 PIC S9(7)V99. 03 IE34 PIC S9V99.
      03 IE35 PIC XXX. 03 IE36 PIC 9(6). 03 IE37 PIC 9.
    02 TD-INP-R4.
      03 IE41 PIC XXX. 03 IE42 PIC 9(6). 03 IE43 PIC X(12). 03 IE44 PIC 9(7).
      03 IE45 PIC X(5). 03 IE46 PIC X(5). 03 IE47 PIC S9(5). 03 IE48 PIC S9(9).
      03 IE49 PIC 9(5). 03 IE49A PIC XXX.
    02 TD-INP-R5.
      03 IE51 PIC XXX. 03 IE52 PIC X(12). 03 IE52A PIC 9. 03 IE53 PIC X(8).
      03 IE54 PIC X(8). 03 IE55 PIC S9(9). 03 IE55A PIC X(10). 03 IE56 PIC 9.
      03 IE57 PIC S999. 03 IE58 PIC 9(5). 03 IE59 PIC X(10).
    02 TD-INP-R6.
      03 IE601 PIC 9(7). 03 IE602 PIC 9(6). 03 IE603 PIC 99.
      03 IE605 PIC 9(4) OCCURS 12. 03 IE607 PIC 999.
      03 IE608 PIC XX. 03 IE610 PIC X(8). 03 IE612 PIC X(8).
    02 TD-INP-R6A.
      03 IE621 PIC X(12). 03 OCCURS 23.
        04 IE623 PIC X(5). 04 IE624 PIC S9(7). 04 IE625 PIC S9(7). 04 IE626 PIC 9(7).
    02 TD-INP-R7.
      03 IE71 PIC 9(6). 03 IE72 PIC XXX. 03 IE73 PIC X(12). 03 IE74 PIC S9(9).
      03 IE76 PIC 9(6). 03 IE77 PIC S9(6). 03 IE78 PIC S99. 03 IE79 PIC S9(9) OCCURS 3.
    02 TD-INP-R8.
      03 IE81 PIC 9(6). 03 IE82 PIC 9(4). 03 IE83 PIC X(12). 03 IE84 PIC 9.
      03 IE85 PIC 9(9). 03 IE86 PIC 9(9).
    02 TD-INP-R9.
      03 IE91 PIC 9(6). 03 IE92 PIC S9(7)V99. 03 IE93 PIC 9. 03 IE94 PIC X(10).
      03 IE95 PIC X(36).
    02 TD-INP-R10.
      03 IE101 PIC 9(6). 03 IE102 PIC S9(7)V99. 03 IE103 PIC 9.

01  TD-SCREEN PIC X(3300).
01  TD-RL1 REDEFINES TD-SCREEN.
    02 TLN PIC X(80) OCCURS 25.
01  TD-RL2 REDEFINES TD-SCREEN.
    02 OCCURS 25.
      03 TLN-F PIC X(80).
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF12 PIC X(20). 04 PIC X(5). 04 TF13 PIC X(9).
    04 TF14 PIC BBXXX. 04 TF15 PIC Z99. 04 TF16 PIC Z9(4).
      03 REDEFINES TLN-F.
    04 PIC X(22). 04 TF20 PIC X(12). 04 TF21 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(14). 04 TF22 PIC X(12).
      03 REDEFINES TLN-F.
    04 PIC X(15). 04 TF23 PIC X(6).
      03 REDEFINES TLN-F.
    04 PIC X(15). 04 TF24 PIC X(6). 04 TF25 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF26 PIC X(5).
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF27 PIC X(5).
      03 REDEFINES TLN-F.
    04 PIC X(26). 04 TF28 PIC X(8).
      03 REDEFINES TLN-F.
    04 PIC X(21). 04 TF29 PIC X(8). 04 TF30 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(39). 04 TF31 PIC ZZZ9. 04 TF32 PIC BBX(30).
      03 REDEFINES TLN-F.
    04 OCCURS 4. 05 TF33 PIC X(12). 05 TF34 PIC ZZ9. 05 PIC X(5).
      03 REDEFINES TLN-F.
    04 PIC X(72). 04 TF37 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(14). 04 TF38 PIC X. 04 PIC X(18). 04 TF39 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF40 PIC Z9.
      03 REDEFINES TLN-F.
    04 PIC X(14). 04 TF41 PIC Z9.
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF42 PIC 9. 04 TF43 PIC ZZ9.999.
      03 REDEFINES TLN-F.
    04 PIC X(39). 04 TF44 PIC X(6). 04 PIC XX. 04 TF45 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(14). 04 TF46 PIC X(15). 04 TF47 REDEFINES TF46 PIC ZZ,ZZZ,ZZ9.
    04 TF48 REDEFINES TF46 PIC 9(7).
      03 REDEFINES TLN-F.
    04 PIC X(41). 04 TF49 PIC ZZ,ZZZ,ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(55). 04 TF50 PIC X(25).
      03 REDEFINES TLN-F.
    04 PIC X(68). 04 TF51 PIC Z9. 04 TF52 PIC Z(4)9. 04 TF53 PIC BX(4).
      03 REDEFINES TLN-F.
    04 TF56 PIC Z(5)9. 04 TF56A PIC BBX. 04 TF57 PIC Z(4),ZZZ,ZZ9-.
    04 TF57A PIC Z(6),ZZZ,ZZ9-. 04 TF58 PIC Z(4),ZZZ,ZZ9-.
    04 TF59 PIC ZZZ99/99/99. 04 TF60 PIC Z(5)99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF61 PIC X(14). 04 TF62 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(30). 04 TF63 PIC X(14). 04 TF63A PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(56). 04 TF63B PIC ZZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 TF64 PIC BX(5). 04 TF64A PIC ZZ9(7). 04 TF64B PIC BBBX.
    04 TF65 PIC Z(5),ZZZ,ZZ9-. 04 TF66 PIC ZZZ99/99/99. 04 TF67 PIC ZZZ,ZZZ,ZZ9-.
    04 TF68 PIC Z(5),ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(28). 04 TF70 PIC X(6). 04 TF71 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC XX. 04 TF73 PIC Z(5),ZZ9.99- OCCURS 6.
      03 REDEFINES TLN-F.
    04 TF73A PIC 99/99/99. 04 TF74 PIC Z(7)9. 04 TF74A PIC B(4)X(9).
    04 TF75 PIC Z(5),ZZZ,ZZ9.99-. 04 TF76 PIC ZZ,ZZZ,ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF77 PIC Z(5)9. 04 PIC X(18). 04 TF78 PIC Z(5)9.
    04 PIC X(16). 04 TF79 PIC X(6).
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF81 PIC X(38).
      03 REDEFINES TLN-F.
    04 PIC X(65). 04 TF82 PIC X(15). 04 TF83 REDEFINES TF82 PIC 99/99/99.
    04 TF84 REDEFINES TF82 PIC Z(7)9. 04 TF86 REDEFINES TF82 PIC Z(4),ZZ9.99-.
    04 TF87 REDEFINES TF82 PIC Z(7),ZZ9-.
    04 REDEFINES TF82. 05 TF87A PIC ZZZ9. 05 TF87B PIC ZZZ9.
    04 REDEFINES TF82. 05 TF87C PIC XXX. 05 TF87D PIC BBBX(8).
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF88 PIC X(12). 04 TF89 REDEFINES TF88 PIC Z9.
    04 TF90 REDEFINES TF88 PIC ZZZ9.999. 04 TF91 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(15). 04 TF92 PIC ZZZ,ZZZ,ZZ9-. 04 TF92A REDEFINES TF92 PIC B(4)X(8).
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF93 PIC 99. 04 TF94 PIC B(4)X(24). 04 TF95 PIC Z(4)9.999.
    04 TF96 PIC Z,ZZZ,ZZ9.99-. 04 TF97 PIC Z(8),ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(17). 04 TF98 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF99 PIC X(22).
      03 REDEFINES TLN-F.
    04 PIC X(22). 04 TF102 PIC X(6). 04 TF103 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 TF104 PIC Z(7)9. 04 TF104A PIC B(5)X. 04 TF105 PIC ZZZ99/99/99.
    04 TF106 PIC ZZZ99/99/99. 04 TF107 PIC Z(6)9. 04 TF108 PIC B(4)X(9).
      03 REDEFINES TLN-F.
    04 PIC X(26). 04 TF109 PIC Z(5)9. 04 PIC X(10). 04 TF110 PIC X(8).
    04 TF110A PIC X(29).
      03 REDEFINES TLN-F.
    04 TF111 PIC ZZZ9. 04 TF112 PIC BBBX(12).
    04 OCCURS 3. 05 TF113 PIC Z(5),ZZZ,ZZ9-. 05 TF114 REDEFINES TF113 PIC B(6)X(8).
      03 REDEFINES TLN-F.
    04 PIC X(29). 04 TF116 PIC ZZ9. 04 TF117 PIC BBX(10).
      03 REDEFINES TLN-F.
    04 TF118 PIC Z(5)9. 04 TF118A PIC X. 04 TF118B PIC X. 04 TF118C PIC Z9(7).
    04 TF119 PIC BBX(12). 04 OCCURS 4. 05 TF120 PIC ZZZ9-. 05 TF121 PIC ZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(20). 04 TF122 PIC Z(5)9. 04 TF123 PIC BX. 04 PIC X(15).
    04 TF125 PIC X(4). 04 TF126 PIC ZZ9. 04 TF127 PIC ZZ9. 04 PIC X(12).
    04 TF128 PIC 9. 04 TF128A PIC BX(13).
      03 REDEFINES TLN-F.
    04 TF129 PIC X(10). 04 TF129A PIC X(70).
      03 REDEFINES TLN-F.
    04 TF130 PIC X(12). 04 TF131 REDEFINES TF130 PIC ZZ9. 04 TF132 PIC BX(25).
    04 TF133 PIC Z99/99/99. 04 TF134 PIC BX. 04 TF135 PIC ZZZ9. 04 TF136 PIC BX(20).
    04 TF137 PIC Z(4)9-. 04 TF138 REDEFINES TF137 PIC ZZZ9.9.
      03 REDEFINES TLN-F.
    04 PIC X(9). 04 TF139 PIC X(6).
      03 REDEFINES TLN-F.
    04 PIC X(7). 04 TF142 PIC 99/99/99. 04 TF143 PIC BBX(5).
      03 REDEFINES TLN-F.
    04 TF144 PIC X(12). 04 TF145 PIC Z99/99/99. 04 TF146 PIC BBX(5).
      03 REDEFINES TLN-F.
    04 PIC X(50). 04 TF147 PIC X(30).
      03 REDEFINES TLN-F.
    04 PIC X(34). 04 TF148 PIC X(14). 04 TF149 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF150 PIC 99/99/99. 04 TF151 PIC BX(5). 04 TF152 PIC X(6). 04 TF153 PIC X(5).
    04 TF154 PIC ZZ,ZZZ,ZZ9-. 04 TF155 PIC Z9(7). 04 TF156 PIC Z(7).
    04 TF157 PIC Z(5)-. 04 TF158 PIC Z(4),ZZZ. 04 TF159 PIC BBBX.
      03 REDEFINES TLN-F.
    04 TF160 PIC X(12). 04 TF161 PIC ZZ9. 04 TF162 PIC BBX. 04 TF163 PIC ZZ99/99/99.
    04 TF164 PIC BBX(50).
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF165 PIC ZZZ9. 04 TF166 PIC BBX(36).
      03 REDEFINES TLN-F.
    04 TF167 PIC 99/99/99. 04 TF168 PIC BBX(15). 04 TF169 PIC BBX(8).
    04 TF170 PIC BBX(12). 04 TF171 PIC Z(5),ZZ9-. 04 TF172 PIC Z(5),ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF173 PIC X(15). 04 TF174 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF175 PIC 99/99/99. 04 TF176 PIC BXXX. 04 TF177 PIC BBX(8).
    04 TF178 PIC BX(8). 04 TF179 PIC ZZ,ZZZ,ZZ9-. 04 TF180 PIC ZZ9.
    04 TF181 PIC Z(5)9-. 04 TF182 PIC Z(4),ZZ9. 04 TF183 PIC BBBX(10).
      03 REDEFINES TLN-F.
    04 TF185 PIC 99/99/99. 04 TF186 PIC BX(5). 04 TF187 PIC BBXXX.
    04 TF188 PIC BBX(6). 04 TF189 PIC BX(6). 04 TF190 PIC Z(5)9-.
    04 TF191 PIC BBX(12).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF192 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 TF193 PIC 99/99/99. 04 TF194 PIC BXXX. 04 TF195 PIC BBX(6).
    04 TF196 PIC BX(6). 04 TF197 PIC ZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(22). 04 TF198 PIC 9(7).
      03 REDEFINES TLN-F.
    04 PIC X(26). 04 TF199 PIC 9(6).
      03 REDEFINES TLN-F.
    04 PIC X(35). 04 TF200 PIC X(12). 04 TF201 PIC BX(32).
      03 REDEFINES TLN-F.
    04 TF202 PIC X(6). 04 TF203 PIC BX(32). 04 TF204 PIC Z99/99/99.
    04 TF205 PIC Z(7)9. 04 TF206 REDEFINES TF205 PIC Z9(7).
    04 TF207 PIC BBX(9). 04 TF208 PIC Z(4),ZZ9. 04 TF209 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF210 PIC X(12).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF212 PIC ZZZ9. 04 TF213 PIC BBX(36).
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF214 PIC X(12). 04 PIC X(13). 04 TF215 PIC X(20).
    04 PIC X(10). 04 TF216 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF217 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF218 PIC ZZ9. 04 PIC X(11). 04 TF219 PIC X(4).
    04 PIC X(11). 04 TF220 PIC X(4). 04 PIC X(21). 04 TF221 PIC X(14).
      03 REDEFINES TLN-F.
    04 PIC X(45). 04 TF222 PIC ZZZ,ZZ9. 04 PIC X(19). 04 TF223 PIC ZZZ,ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(35). 04 TF224 PIC Z(5),ZZ9- OCCURS 3.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF225 PIC X(20). 04 PIC X(25). 04 TF226 PIC X(24).
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF227 PIC Z(5)9.999. 04 PIC X(8).
    04 OCCURS 3. 05 PIC X(12). 05 TF228 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(30). 04 OCCURS 3. 05 PIC X(6). 05 TF229 PIC Z(5)9.999.
      03 REDEFINES TLN-F.
    04 PIC X(17). 04 TF230 PIC Z(4),ZZ9. 04 TF231 PIC Z(6)9. 04 TF232 PIC ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF233 PIC Z(4),ZZ9-. 04 PIC X(20). 04 TF234 PIC ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(27). 04 TF235 PIC ZZ,ZZZ,ZZ9-. 04 PIC X(8). 04 TF236 PIC ZZ,ZZZ,ZZ9-.
    04 PIC X(12). 04 TF237 PIC ZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF238 PIC ZZ,ZZZ,ZZ9.99-. 04 PIC X(5). 04 TF239 PIC ZZ,ZZZ,ZZ9.99-.
    04 PIC X(9). 04 TF240 PIC ZZ,ZZZ,ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF241 PIC Z9. 04 PIC X(14). 04 TF242 PIC Z9.
    04 PIC X(19). 04 TF243 PIC Z9. 04 PIC X(21). 04 TF244 PIC 99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(25). 04 TF245 PIC 99/99/99. 04 PIC X(9). 04 TF246 PIC Z(4)9.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF247 PIC Z(4),ZZ9-. 04 TF247A PIC X(60).
    04 REDEFINES TF247A. 05 TF248 PIC B(4)X(16). 05 TF249 PIC Z,ZZ9-.
    04 REDEFINES TF247A. 05 OCCURS 5. 06 TF250 PIC ZZ9. 06 TF251 PIC X. 06 TF252 PIC Z(7)-.
      03 REDEFINES TLN-F.
    04 PIC X(28). 04 TF253 PIC X(8).
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF254 PIC X(12). 04 PIC X(8). 04 TF255 PIC ZZZ,ZZZ,ZZ9-.
    04 PIC X(27). 04 TF256 PIC 99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF257 PIC X(10).
      03 REDEFINES TLN-F.
    04 PIC X(9). 04 TF257A PIC Z9. 04 PIC X(18). 04 TF257B PIC ZZ9.
    04 PIC X(18). 04 TF257C PIC ZZ,ZZ9. 04 PIC X(14). 04 TF257D PIC X(10).
      03 REDEFINES TLN-F.
    04 PIC X(27). 04 TF258 PIC X(15). 04 TF259 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(69). 04 TF260 PIC ZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 TF261 PIC X(8). 04 TF262 PIC ZZZ,ZZZ,ZZ9-. 04 TF262A PIC BB99/99/99.
    04 TF263 PIC BBX(10). 04 TF264 PIC ZZZ9. 04 TF265 PIC Z(6)9.
    04 TF266 PIC Z(5),ZZ9. 04 TF267 PIC BBBX(10).
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF268 PIC X(8).
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF269 PIC X(8).
      03 REDEFINES TLN-F.
    04 PIC X(35). 04 TF270 PIC X(12).
      03 REDEFINES TLN-F.
    04 TF271 PIC X(8). 04 TF272 PIC X(12). 04 TF273 PIC ZZZ,ZZ9-.
    04 TF274 PIC BB99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(72). 04 TF277 PIC ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 TF278 PIC X(8). 04 TF279 PIC Z(5)9. 04 TF280 PIC BBX(36).
    04 TF281 PIC ZZZ,ZZZ,ZZ9-. 04 TF281A REDEFINES TF281 PIC BBBX(9).
    04 TF282 PIC Z(4),ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF283 PIC X(8).
      03 REDEFINES TLN-F.
    04 PIC X(17). 04 TF285 PIC X(8). 04 PIC X(14). 04 TF286 PIC ZZZ9.
    04 PIC X(18). 04 TF287 PIC Z(4),ZZ9.99.
      03 REDEFINES TLN-F.
    04 PIC X(39). 04 TF288 PIC X(36).
      03 REDEFINES TLN-F.
    04 PIC X(29). 04 TF289 PIC X(15). 04 TF290 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF292 PIC X(12). 04 TF293 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(14). 04 TF294 PIC ZZZ,ZZZ,ZZ9-. 04 PIC X(32). 04 TF295 PIC 99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(17). 04 TF296 PIC 9. 04 PIC X(19). 04 TF297 PIC Z(5)9.
    04 TF298 PIC X. 04 TF299 PIC 99. 04 PIC X(26). 04 TF300 PIC X(5).
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF301 PIC Z(5)9. 04 PIC X(14). 04 TF302 PIC 9.
    04 PIC X(21). 04 TF303 PIC 99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(25). 04 TF304 PIC Z(5)9. 04 TF305 PIC XXX.
    04 PIC X(9). 04 TF306 PIC X(6). 04 TF307 PIC BX(29).
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF308 PIC ZZZ9. 04 TF309 PIC BBX(25).
      03 REDEFINES TLN-F.
    04 PIC X. 04 TF310 PIC X(22). 04 PIC XXX. 04 TF311 PIC X(45).
      03 REDEFINES TLN-F.
    04 PIC X(7). 04 TF312 PIC Z(5)9. 04 TF313 PIC X. 04 TF314 PIC X.
    04 PIC X(10). 04 TF315 PIC X(20).
      03 REDEFINES TLN-F.
    04 PIC X(7). 04 TF316 PIC X(10). 04 PIC X(12). 04 TF317 PIC X(8).
    04 TF318 PIC X. 04 TF319 PIC 9(4). 04 TF320 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(9). 04 TF321 PIC X(15). 04 PIC X(17). 04 TF322 PIC Z9.
      03 REDEFINES TLN-F.
    04 PIC X(63). 04 TF323 PIC X(10).
      03 REDEFINES TLN-F.
    04 PIC X(5). 04 TF324 PIC Z(4),ZZ9-. 04 PIC X(13). 04 TF325 PIC Z(4),ZZ9-.
    04 PIC X(14). 04 TF326 PIC ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(9). 04 TF327 PIC X(50).
      03 REDEFINES TLN-F.
    04 PIC X(27). 04 TF328 PIC 9(7). 04 PIC X(14). 04 TF329 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF331 PIC 9(7). 04 TF332 PIC ZZ99/99/99. 04 TF333 PIC BX(8).
    04 TF334 PIC BBX. 04 TF335 PIC Z(6)9. 04 TF336 PIC BBX(12).
    04 TF337 PIC Z(5)9. 04 TF338 PIC BBX(12). 04 TF339 PIC BBX.
      03 REDEFINES TLN-F.
    04 PIC X(16). 04 TF340 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(16). 04 TF341 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF342 PIC X(45).
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF343 PIC X(12). 04 TF344 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 TF345 PIC X(12). 04 TF346 PIC BBX(32). 04 TF347 PIC BX(6).
    04 TF348 PIC ZZZ9. 04 TF349 PIC ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(21). 04 TF350 PIC Z(5)9. 04 TF350A PIC BX. 04 TF350B PIC 9.
    04 TF350C PIC X. 04 TF351 PIC BBX(13). 04 TF352 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF354 PIC ZZZ9. 04 TF355 PIC Z99/99/99. 04 TF356 PIC BXX.
    04 TF357. 05 TF357A PIC X(20). 05 TF357B PIC Z9.99.
    04 REDEFINES TF357. 05 PIC X(19). 05 TF357C PIC ZZ9.99.
    04 TF358 PIC ZZ,ZZZ,ZZ9-. 04 TF360X. 05 TF360 PIC Z(4),ZZ9-.
    04 TF361 PIC Z(4),ZZZ-. 04 TF361A PIC X. 04 TF362 PIC Z(5),ZZ9.
      03 REDEFINES TLN-F.
    04 TF363 PIC X(8). 04 TF363A PIC Z9(7) OCCURS 9.
      03 REDEFINES TLN-F.
    04 PIC X(6). 04 TF364 PIC X(70).
      03 REDEFINES TLN-F.
    04 PIC X(6). 04 TF365 PIC X(8).
    04 OCCURS 5. 05 TF366 PIC X. 05 TF367 PIC Z(4)9. 05 TF368 PIC X.
        05 TF369 PIC ZZZ9. 05 TF370 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(16). 04 TF371 PIC X(12).
    04 REDEFINES TF371. 05 TF371A PIC X. 05 TF371B PIC BBXX.
    04 TF372 REDEFINES TF371 PIC 9(7). 04 TF373 REDEFINES TF371 PIC ZZZ,ZZZ,ZZ9-.
    04 TF374 REDEFINES TF371 PIC 99/99/99.
    04 TF375 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(21). 04 TF376 PIC 99. 04 TF377 PIC BBX(40).
      03 REDEFINES TLN-F.
    04 TF378 PIC X(6). 04 TF379 PIC BX(20). 04 TF379A PIC BBX(9). 04 TF380 PIC Z(6)9.
    04 TF380A PIC XXX. 04 TF381 PIC Z99/99/99. 04 TF382 PIC Z(4)9.
    04 TF383 PIC Z(5),ZZZ. 04 TF384 PIC ZZZ9. 04 TF385 PIC ZZ9. 04 TF386 PIC XX.
      03 REDEFINES TLN-F.
    04 PIC X(50). 04 TF387 PIC X. 04 TF388 PIC X(5). 04 TF389 PIC X(6).
    04 TF390 PIC Z(5),ZZ9. 04 TF391 PIC BXX. 04 TF392 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF393 PIC 9. 04 TF394 PIC XX. 04 PIC X(12).
    04 TF395 PIC 99/99/99. 04 PIC X(21). 04 TF396 PIC 99. 04 TF397 PIC BX(25).
      03 REDEFINES TLN-F.
    04 TF400 PIC Z9. 04 TF401 PIC BBX(12). 04 TF402 PIC BBX(32).
    04 TF403 PIC Z(5),ZZ9. 04 TF404 PIC Z(6),ZZ9. 04 TF404A PIC Z(6),ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(23). 04 TF405 PIC Z(6)9.
    04 PIC X(10). 04 TF406 PIC X(7). 04 TF407 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF408 PIC Z(6)9. 04 TF409 PIC Z(7)9. 04 TF410 PIC BBX(9).
    04 TF411 PIC Z(4)99/99/99. 04 TF412 PIC Z(4),ZZ9.99-. 04 TF413 PIC Z(6),ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF414 PIC X(11). 04 PIC X(58). 04 TF415 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(25). 04 TF417 PIC X(14). 04 TF418 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF419 PIC X(14). 04 TF420 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF421 PIC X(6). 04 TF421A PIC BBX(32).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF422 PIC X(9).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF423 PIC Z,ZZZ,ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF424 PIC 99/99/99. 04 TF424A PIC ZZZ99/99/99.
    04 TF424B PIC ZZZ99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF425 PIC Z(6)9.
      03 REDEFINES TLN-F.
    04 PIC X(68). 04 TF427 PIC ZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 TF428 PIC X(8). 04 TF428A PIC BBX(12). 04 TF429 PIC ZZZ,ZZZ,ZZ9-.
    04 TF430 PIC BB99/99/99. 04 TF431 PIC Z(4)9. 04 TF432 PIC Z(6)9.
    04 TF433 PIC Z(5),ZZ9. 04 TF434 PIC BBBX(10).
      03 REDEFINES TLN-F.
    04 PIC X(38). 04 TF435 PIC X(30).
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF436 PIC ZZZ9. 04 PIC XX. 04 TF437 PIC X(36).
      03 REDEFINES TLN-F.
    04 PIC X(38). 04 TF438 PIC X(24). 04 PIC X(6). 04 TF439 PIC X(7).
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF440 PIC 9(7). 04 PIC X(14). 04 TF441 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF442 PIC Z9.99. 04 PIC X(14). 04 TF443 PIC 9.
    04 PIC X(21). 04 TF444 PIC ZZ9. 04 PIC X(18). 04 TF445 PIC 99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(15). 04 TF446 PIC ZZZ,ZZZ,ZZ9.99-. 04 TF447 REDEFINES TF446 PIC ZZZ,ZZZ,ZZ9-.
    04 TF448 PIC ZZZ,ZZZ,ZZ9.99-. 04 TF449 REDEFINES TF448 PIC ZZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(47). 04 TF450 PIC ZZ9.99. 04 PIC X(20). 04 TF451 PIC Z9.99.
      03 REDEFINES TLN-F.
    04 PIC X(59). 04 TF452 PIC X.
      03 REDEFINES TLN-F.
    04 TF453 PIC X(15). 04 TF454 PIC BX(8). 04 TF455 PIC ZZZ99/99/99.
    04 TF456 PIC Z99/99/99. 04 TF457 PIC Z99/99/99. 04 TF458 PIC Z(4),ZZ9.99-.
    04 TF459 PIC Z(4),ZZ9.99-. 04 TF460 PIC XX.
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF462 PIC ZZZ9. 04 TF463 PIC BBBX(36).
      03 REDEFINES TLN-F.
    04 PIC X(41). 04 TF464 PIC X. 04 TF465 PIC X(11). 04 TF466 PIC Z(4),ZZ9.99-.
    04 TF467 PIC Z(4),ZZ9.99-. 04 TF468 PIC XX. 04 TF469 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(31). 04 TF470 PIC X(15). 04 TF471 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF472 PIC 99/99/99. 04 TF473 PIC BBX(8). 04 TF474 PIC Z(5)9.
    04 TF475 PIC BBX(33). 04 TF476 PIC Z(4),ZZ9-. 04 TF477 PIC Z(4),ZZ9.999.
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF480 PIC X(15). 04 TF481 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF482 PIC X(14). 04 TF483 PIC X(32). 04 TF484 PIC ZZZ9. 04 TF485 PIC Z(7)9.
    04 TF486 PIC Z(6),ZZZ,ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF487 PIC ZZZ9. 04 TF488 PIC BBBX(36).
      03 REDEFINES TLN-F.
    04 TF489 PIC X(15). 04 TF490 PIC Z(6)9. 04 TF491 PIC BBX(10). 04 PIC X(19).
    04 TF494 PIC Z(4),ZZ9.99-. 04 TF495 PIC Z(4),ZZ9.99-. 04 TF496 PIC XX.
      03 REDEFINES TLN-F.
    04 PIC XXX. 04 TF498 PIC X(70).
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF499 PIC X(12).
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF500 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF501 PIC Z(5)9. 04 TF501A PIC BBX. 04 TF502 PIC BBBX(6).
    04 TF503 PIC BBX(4). 04 TF504 PIC ZZ9. 04 TF505 PIC ZZ9. 04 TF506 PIC BBX(12).
    04 TF507 PIC Z99/99/99. 04 TF508 PIC BX(5). 04 TF508A PIC BBX(13).
      03 REDEFINES TLN-F.
    04 PIC X(7). 04 TF509 PIC X(70).
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF510 PIC X(10).
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF511 PIC 9(7).
      03 REDEFINES TLN-F.
    04 PIC X(29). 04 TF512 PIC X(10). 04 PIC X(12). 04 TF513 PIC 99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(16). 04 TF514 PIC X(6). 04 TF515 REDEFINES TF514 PIC Z.ZZZZ.
    04 TF516 REDEFINES TF514 PIC Z.ZZ. 04 TF517 REDEFINES TF514 PIC Z.ZZZ.
      03 REDEFINES TLN-F.
    04 PIC X(11). 04 TF518 PIC X(10).
      03 REDEFINES TLN-F.
    04 PIC X. 04 TF519 PIC X(13).
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF520 PIC X(8). 04 PIC X(14). 04 TF521 PIC Z.ZZ.
      03 REDEFINES TLN-F.
    04 PIC X(32). 04 TF522 PIC 9(7).
      03 REDEFINES TLN-F.
    04 PIC X. 04 TF523 PIC X(22).
      03 REDEFINES TLN-F.
    04 PIC X(28). 04 TF524 PIC ZZZ9. 04 TF525 PIC BX(36).
      03 REDEFINES TLN-F.
    04 TF526 PIC X(8). 04 TF527 PIC ZZ99/99/99. 04 TF528 PIC ZZ99/99/99.
    04 TF529 PIC ZZ99/99/99. 04 TF530 PIC ZZ99/99/99. 04 TF531 PIC BBX(15).
    04 TF532 PIC BBX(8).
      03 REDEFINES TLN-F.
    04 PIC X. 04 TF533 PIC X(13).
      03 REDEFINES TLN-F.
    04 PIC X(25). 04 TF534 PIC X(8). 04 TF535 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF536 PIC X(14). 04 TF537 PIC X(32).
      03 REDEFINES TLN-F.
    04 TF538 PIC X(12). 04 TF539 PIC BX(28). 04 TF540 PIC ZZZ9.999.
    04 TF541 PIC BXX. 04 TF541A PIC ZZ9. 04 TF541B PIC Z(4)9.999.
    04 TF542 PIC BBBXXX. 04 TF543 PIC ZZ99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF545 PIC X(50).
      03 REDEFINES TLN-F.
    04 PIC X(33). 04 TF546 PIC X(12). 04 TF547 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 TF548 PIC ZZZ99/99/99. 04 TF549 PIC Z(7)9.999. 04 TF550 PIC BXX.
    04 TF550A PIC ZZ9. 04 TF550B PIC Z(4)9.999. 04 TF551 PIC BBXXX.
    04 TF552 PIC ZZZ99/99/99.
      03 REDEFINES TLN-F.
    04 PIC X(15). 04 TF554 PIC X(50).
      03 REDEFINES TLN-F.
    04 PIC X(28). 04 TF555 PIC ZZZ9.999.
      03 REDEFINES TLN-F.
    04 PIC X(7). 04 TF556 PIC ZZZ9.999. 04 TF557 PIC BBX. 04 PIC X(17).
    04 TF558 PIC ZZZ9.999.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF559 PIC X(10). 04 PIC X(26). 04 TF560 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF561 PIC ZZZ9. 04 TF562 PIC BBBX(40).
      03 REDEFINES TLN-F.
    04 PIC X(45). 04 TF563 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(20). 04 TF564 PIC ZZZ,ZZZ,ZZ9. 04 PIC X(11). 04 TF565 PIC ZZ9.
    04 PIC X(20). 04 TF566 PIC Z9.
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF567 PIC Z9.
      03 REDEFINES TLN-F.
    04 PIC X(21). 04 TF568 PIC X(30).
      03 REDEFINES TLN-F.
    04 PIC X(18). 04 TF569 PIC ZZZ9.99.
      03 REDEFINES TLN-F.
    04 PIC X(14). 04 TF570 PIC Z(5)9. 04 PIC X(17). 04 TF570A PIC Z9.999.
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF571 PIC ZZ9.99. 04 PIC X(19). 04 TF572 PIC ZZ9.99.
    04 PIC X(18). 04 TF573 PIC Z9.99.
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF574 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(42). 04 TF576 PIC X(19). 04 TF577 PIC X(6). 04 TF578 PIC X(12).
    04 TF579 PIC X.
      03 REDEFINES TLN-F.
    04 PIC X(42). 04 TF580 PIC X(32).
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF581 PIC XXX.
      03 REDEFINES TLN-F.
    04 PIC X(18). 04 TF582 PIC X(12).
      03 REDEFINES TLN-F.
    04 PIC X(22). 04 TF583 PIC X. 04 TF584 PIC BBX(6). 04 TF585 PIC Z(7).
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF586 PIC Z(10).
      03 REDEFINES TLN-F.
    04 PIC X(58). 04 TF587 PIC ZZZ9.999. 04 TF588 PIC Z(5)9.999. 04 TF589 PIC BBXX.
      03 REDEFINES TLN-F.
    04 PIC X(58). 04 TF590 PIC ZZZ9.999. 04 TF591 PIC BBBX.
      03 REDEFINES TLN-F.
    04 PIC X(57). 04 TF592 PIC ZZZ9.99. 04 TF593 PIC Z(4)9.99. 04 TF594 PIC Z(5).ZZ.
      03 REDEFINES TLN-F.
    04 PIC X(66). 04 TF595 PIC Z9. 04 TF596 PIC ZZZ9. 04 TF597 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(57). 04 TF598 PIC ZZZ,ZZZ,ZZ9-. 04 TF599 PIC ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(57). 04 TF600 PIC ZZZ,ZZZ,ZZ9-. 04 TF601 PIC ZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(58). 04 TF603 PIC 99/99/99. 04 TF604 PIC BB99/99/99. 04 TF605 PIC BX.
      03 REDEFINES TLN-F.
    04 PIC X(13). 04 TF606 PIC ZZ9. 04 TF607 PIC BBX(20).
      03 REDEFINES TLN-F.
    04 PIC X(23). 04 TF608 PIC Z9. 04 TF609 PIC Z(6)9. 04 TF610 PIC Z(4)9.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF611 PIC X(6). 04 TF612 PIC ZZ9. 04 TF613 PIC ZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(17). 04 TF615 PIC X(6). 04 TF616 PIC X(8).
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF617 PIC Z9. 04 TF618 PIC Z(5)9. 04 TF619 PIC BX.
      03 REDEFINES TLN-F.
    04 PIC X(22). 04 TF620 PIC Z9. 04 TF621 PIC BX.
      03 REDEFINES TLN-F.
    04 PIC X(10). 04 TF622 PIC Z9.
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF623 PIC ZZZ,ZZZ,ZZ9-. 04 TF624 REDEFINES TF623 PIC Z(4),ZZ9.99-.
    04 PIC X. 04 TF625 PIC ZZZ,ZZZ,ZZ9-. 04 TF626 REDEFINES TF625 PIC Z(4),ZZ9.99-.
      03 REDEFINES TLN-F.
    04 PIC X(24). 04 TF627 PIC ZZZ,ZZZ,ZZ9-.
      03 REDEFINES TLN-F.
    04 PIC X(8). 04 TF628 PIC X(72).
      03 REDEFINES TLN-F.
    04 PIC X(19). 04 TF629 PIC X(12). 04 TF630 PIC BBX(32).
      03 REDEFINES TLN-F.
    04 TF631 PIC 9(7). 04 TF632 PIC ZZ99/99/99. 04 TF633 PIC Z(7)9.
    04 TF633A PIC X. 04 TF633B PIC X. 04 TF634 PIC ZZ,ZZZ,ZZ9-.
    04 TF635 PIC ZZ,ZZZ,ZZ9-. 04 TF636 PIC BBX(15).
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF637 PIC ZZZ9.
      03 REDEFINES TLN-F.
    04 PIC X(12). 04 TF638 PIC ZZZ9. 04 TF639 PIC BBX(30).

01  TD-RW1 REDEFINES TD-SCREEN.
    02 TLNW PIC X(132) OCCURS 25.
01  TD-RW2 REDEFINES TD-SCREEN.
    02 OCCURS 25.
      03 TLNW-H PIC X(132).
      03 REDEFINES TLNW-H.
    04 PIC X(30). 04 TH11 PIC X(12).
    04 PIC X(14). 04 TH12 PIC Z9. 04 TH13 PIC BBX(30).
      03 REDEFINES TLNW-H.
    04 PIC X(6). 04 TH14 PIC 9. 04 PIC X(4). 04 TH15 PIC 9.
    04 PIC X(18). 04 TH17 PIC X(32). 04 PIC X(14). 04 TH18 PIC Z(5)9.
      03 REDEFINES TLNW-H.
    04 TH19 PIC X(63). 04 PIC X(6). 04 TH20 PIC X(63).
      03 REDEFINES TLNW-H.
    04 PIC X(30). 04 TH21 PIC X(12).
    04 PIC X(14). 04 TH22 PIC Z9. 04 TH23 PIC BBX(30).
      03 REDEFINES TLNW-H.
    04 PIC X(6). 04 TH24 PIC 9. 04 PIC X(4). 04 TH25 PIC 9.
    04 PIC X(18). 04 TH27 PIC X(32). 04 PIC X(14). 04 TH28 PIC Z(5)9.
      03 REDEFINES TLNW-H.
    04 PIC X(21). 04 TH30 PIC X(8). 04 PIC X(13). 04 TH31 PIC X.
    04 PIC X(13). 04 TH32 PIC 9. 04 PIC X(17). 04 TH33 PIC 99/99/99.
    04 PIC X(16). 04 TH34 PIC 99/99/99. 04 PIC X(13). 04 TH35 PIC Z(4),ZZ9.99-.
      03 REDEFINES TLNW-H.
    04 PIC X(9). 04 TH36 PIC ZZZ9. 04 TH37 PIC BBX(36).
    04 PIC X(15). 04 TH38 PIC X(20). 04 PIC X(11). 04 TH39 PIC X(15).
      03 REDEFINES TLNW-H.
    04 PIC X(9). 04 TH40 PIC X(15). 04 PIC X(13). 04 TH41 PIC X(12).
    04 PIC X(10). 04 TH42 PIC X. 04 PIC X(10). 04 TH43 PIC X.
    04 PIC X(16). 04 TH44 PIC ZZZ9 OCCURS 5.
      03 REDEFINES TLNW-H.
    04 TH45 PIC ZZZ,ZZZ,ZZ9-. 04 TH45A REDEFINES TH45 PIC BBBX(9).
    04 TH46 PIC X(4). 04 TH47 PIC Z(4),ZZZ,ZZ9. 04 TH48 PIC ZZ99/99/99.
    04 TH49 PIC BBX(12). 04 TH51 PIC BBX(32). 04 TH52 PIC Z(4),ZZ9.999.
    04 TH53 PIC BX(4). 04 TH54 PIC BX(8). 04 TH55 PIC Z(5),ZZ9.99.
      03 REDEFINES TLNW-H.
    04 PIC X(21). 04 TH57 PIC X(12).
      03 REDEFINES TLNW-H.
    04 TH58 PIC X(12). 04 TH58A PIC BBX(14). 04 TH59 PIC BBX(20).
    04 TH60 PIC BBX(32). 04 TH61 PIC Z(4),ZZ9-. 04 TH62 PIC Z(5),ZZ9-.
    04 TH63 PIC Z(4),ZZ9-. 04 TH64 PIC Z(5)9. 04 TH65 PIC Z(5)9.
    04 TH66 PIC Z(5)9.
      03 REDEFINES TLNW-H.
    04 PIC X(32). 04 TH67 PIC X(8). 04 TH67A PIC X(32).
      03 REDEFINES TLNW-H.
    04 TH68 PIC X. 04 TH69 PIC X(14). 04 TH70 PIC X(32). 04 TH71 PIC X.
      03 REDEFINES TLNW-H.
    04 PIC X(7). 04 OCCURS 5. 05 TH72 PIC Z(6),ZZZ,ZZ9. 05 TH73 PIC ZZZ,ZZZ,ZZ9.
      03 REDEFINES TLNW-H.
    04 PIC X(31). 04 TH74 PIC X(14). 04 TH75 PIC X(32).
      03 REDEFINES TLNW-H.
    04 TH76 PIC X. 04 TH77 PIC X(8). 04 TH78 PIC X(32). 04 TH79 PIC X.
      03 REDEFINES TLNW-H.
    04 OCCURS 5. 05 PIC X(21). 05 TH80 PIC 9(4).
      03 REDEFINES TLNW-H.
    04 TH82 PIC X(6). 04 TH83 PIC BX(28). 04 TH84 PIC BBX(22).
    04 TH84A PIC BBX(9). 04 TH85 PIC Z(6)9. 04 TH85A PIC BBX(12).
    04 TH86 PIC Z99/99/99. 04 TH86A REDEFINES TH86 PIC Z(4)99/99.
    04 TH87 PIC Z(4),ZZZ,ZZ9-. 04 TH88 PIC Z(4),ZZZ,ZZ9-. 04 TH88A PIC BBXXX.
      03 REDEFINES TLNW-H.
    04 TH89 PIC X(5). 04 TH90 PIC BX(10). 04 TH91 PIC BBX(30).
      03 REDEFINES TLNW-H.
    04 PIC X(28). 04 TH94 PIC X(15). 04 TH95 PIC X(36).
      03 REDEFINES TLNW-H.
    04 PIC X(85). 04 TH96 PIC X(12). 04 TH97 PIC BBX(32).
      03 REDEFINES TLNW-H.
    04 PIC X(6). 04 TH98 PIC 9. 04 PIC X(4). 04 TH99 PIC 9.
    04 PIC X(17). 04 TH100 PIC Z9. 04 PIC XX. 04 TH101 PIC X(30).
      03 REDEFINES TLNW-H.
    04 TH103 PIC X(63). 04 PIC X(6). 04 TH104 PIC X(63).
      03 REDEFINES TLNW-H.
    04 TH105 PIC X(35). 04 PIC X(13). 04 TH106 PIC X(12). 04 PIC X(5).
    04 TH107 PIC X(22). 04 PIC X(15). 04 TH108 PIC Z9.
      03 REDEFINES TLNW-H.
    04 PIC X(48). 04 TH109 PIC X(32). 04 PIC X(22). 04 TH110 PIC X(30).
      03 REDEFINES TLNW-H.
    04 PIC X(14). 04 TH111 PIC ZZZ9.999. 04 TH112 PIC BBX(9).
      03 REDEFINES TLNW-H.
    04 PIC X(19). 04 TH113 PIC ZZZ9.99. 04 TH114 PIC Z(4)9.99. 04 TH115 PIC BBX(8).
      03 REDEFINES TLNW-H.
    04 PIC X(13). 04 TH116 PIC ZZZ9 OCCURS 12.
      03 REDEFINES TLNW-H.
    04 TH117 PIC BX(22). 04 REDEFINES TH117. 05 TH118 PIC BX(9). 05 TH119 PIC X(5).
    04 TH120 PIC ZZZ9.999-.
    04 PIC X(5). 04 TH122 PIC ZZZ9. 04 TH123 PIC BX(20). 04 TH124 PIC Z(4)9.999-.
    04 PIC X(5). 04 TH125 PIC ZZZ9. 04 TH126 PIC BX(20). 04 TH127 PIC Z(4)9.999-.
      03 REDEFINES TLNW-H.
    04 TH128 PIC X(7). 04 TH129 PIC X(12).
      03 REDEFINES TLNW-H.
    04 PIC X(36). 04 TH130 PIC X(33).
      03 REDEFINES TLNW-H.
    04 TH131 PIC X. 04 TH132 PIC X(22). 04 PIC X(9). 04 TH133 PIC X.
    04 PIC XXX. 04 TH134 PIC X. 04 TH135 PIC X(26). 04 PIC X(9). 04 TH136 PIC X.
    04 PIC X(4). 04 TH137 PIC X. 04 TH138 PIC X(26). 04 PIC X(9). 04 TH139 PIC X.
    04 PIC XX. 04 TH140 PIC X(6). 04 TH141 PIC Z(5)9. 04 TH142 PIC X.
      03 REDEFINES TLNW-H.
    04 PIC X(25). 04 TH143 PIC Z(4)9.999-.
      03 REDEFINES TLNW-H.
    04 PIC X(117). 04 TH144 PIC X(15).
      03 REDEFINES TLNW-H.
    04 PIC X(117). 04 TH145 PIC BXX OCCURS 5.
      03 REDEFINES TLNW-H.
    04 PIC X(124). 04 TH146 PIC ZZZ9.999.
      03 REDEFINES TLNW-H.
    04 TH147 PIC X(52). 04 PIC X(7). 04 TH148 PIC X(52).
      03 REDEFINES TLNW-H.
    04 TH149 PIC Z99. 04 TH150 PIC BBX(12). 04 TH151 PIC X(115).
      03 REDEFINES TLNW-H.
    04 TH153 PIC BX(6). 04 TH154 PIC X(125).
      03 REDEFINES TLNW-H.
    04 PIC X(32). 04 TH155 PIC X(8). 04 TH156 PIC X(32).
      03 REDEFINES TLNW-H.
    04 PIC X(31). 04 TH157 PIC X(14). 04 TH158 PIC X(32).
      03 REDEFINES TLNW-H.
    04 PIC X(54). 04 TH160 PIC X(5). 04 TH161 PIC BX(12). 04 TH162 PIC BBX(4).
    04 TH163 PIC Z9(7).
      03 REDEFINES TLNW-H.
    04 PIC X(29). 04 TH165 PIC X(6). 04 PIC XX. 04 TH166 PIC X(32).
      03 REDEFINES TLNW-H.
    04 TH167 PIC ZZ9. 04 TH168 PIC B(8)X(32). 04 TH169 PIC BBX(32).
    04 TH170 PIC BBX(32). 04 TH171 PIC BBX(10).

01  LITERAL-FIELDS.
    02 LIT-NY PIC XX VALUE "NY". 02 LIT-YN PIC XX VALUE "YN".
    02 LIT-MRT PIC XXX VALUE "MRT". 02 LIT-XDAN PIC X(4) VALUE "XDAN".
    02 LIT-AMS PIC XXX VALUE "AMS". 02 LIT-PE PIC XX VALUE "PE".
    02 LIT-CURTBL PIC X(6) VALUE "CN$US$". 02 REDEFINES LIT-CURTBL. 03 LIT-CUR PIC XXX OCCURS 2.
    02 LIT-Q9 PIC S9(9) COMP-3 VALUE 999999999. 02 LIT-BL PIC X(7) VALUE "BLANKET".
    02 LIT-ALP9 PIC X(36) VALUE ALL "9". 02 LIT-NUM9 PIC S9(11)V99 VALUE -99999999999.99.
    02 LIT-SP PIC X(40) VALUE ALL " ". 02 LIT-ALPHA PIC X(26) VALUE "ABCDEFGHIJKLMNOPQRSTUVWXYZ".
    02 LIT-BARE PIC X(10) VALUE "BARE METAL". 02 LIT-PICK PIC X(4) VALUE "PICK".
    02 LIT-TAB PIC X VALUE X"09". 02 LIT-LOGFL PIC X(15) VALUE "IFOPSUBPROC.LOG".
01  WEIGHT-FIELDS.
    02 WEI-LB PIC 9V9(5) COMP-3 VALUE 0.45359. 02 WEI-COIL PIC 9(4) COMP-3 VALUE 3300.
    02 WEI-PALLET PIC 99 COMP-3 VALUE 18. 02 WEI-PAD PIC 9V99 COMP-3 VALUE 0.61.
    02 WEI-TBL.
      03 PIC X(63) VALUE "001.CARTONS         .040.TRIWALLS        .250.BUCKETS         .".
      03 PIC X(63) VALUE "150.SMALL BUCKETS   .235.SPECIAL BUCKETS .429.SMALL BINS      .".
      03 PIC X(63) VALUE "648.LARGE BINS      .047.YELLOW BINS     .187.CONTRACTOR BINS .".
      03 PIC X(63) VALUE "000.                .000.                .000.                .".
    02 REDEFINES WEI-TBL. 03 OCCURS 12.
      04 WEI-WT PIC 999. 04 PIC X. 04 WEI-PK PIC X(16). 04 PIC X.
* note 10

01  LIBRARY-FIELDS.
    02 LIB-RET PIC S9(9) COMP.
      88 LIB-RET-NORMAL VALUE EXTERNAL SS$_NORMAL.
      88 LIB-RET-NOMOREPROC VALUE EXTERNAL SS$_NOMOREPROC.
    02 LIB-S1 PIC X(250). 02 LIB-F1 COMP-1.
    02 LIB-W1 PIC S9(4) COMP. 02 LIB-W2 PIC S9(4) COMP.
    02 LIB-L1 PIC S9(9) COMP. 02 LIB-L2 PIC S9(9) COMP.
01  JPI-FIELDS.
    02 JPI-PIDADR PIC S9(9) COMP. 88 JPI-CUR VALUE 0. 88 JPI-ALL VALUE -1.
    02 JPI-LIST.
      03 JPI-L1.
        04 PIC S9(4) COMP VALUE 12.
        04 PIC S9(4) COMP VALUE EXTERNAL JPI$_USERNAME.
        04 POINTER VALUE REFERENCE JPI-USERNAME.
        04 POINTER VALUE REFERENCE JPI-USERLTH.
      03 PIC S9(9) COMP VALUE 0.
    02 JPI-USERNAME PIC X(12). 02 JPI-USERLTH PIC S9(9) COMP.
01  INDEX-FIELDS.
    02 IX1 PIC S9(7) COMP-3. 02 IX2 PIC S9(7) COMP-3.
    02 IX3 PIC S9(7) COMP-3. 02 IX4 PIC S9(7) COMP-3.
01  WORK-FIELDS.
    02 WA1 PIC X(80). 02 WA2 PIC X(80). 02 WA3 PIC X(80). 02 WA4 PIC X(80).
    02 WS1 PIC 9 COMP-3. 02 WS2 PIC 9 COMP-3.
    02 WN1 PIC S9(13) COMP-3. 02 WN2 PIC S9(13) COMP-3.
    02 WN3 PIC S9(13) COMP-3. 02 WN4 PIC S9(13) COMP-3.
    02 WL1 PIC S9(13)V9 COMP-3. 02 WL2 PIC S9(13)V9 COMP-3.
    02 WD1 PIC S9(13)V99 COMP-3. 02 WD2 PIC S9(13)V99 COMP-3.
    02 WD3 PIC S9(13)V99 COMP-3. 02 WD4 PIC S9(13)V99 COMP-3.
    02 WT1 PIC S9(13)V999 COMP-3. 02 WT2 PIC S9(13)V999 COMP-3.
    02 WV1 PIC S9(13)V9(4) COMP-3. 02 WV2 PIC S9(13)V9(4) COMP-3.
01  PARAMETER-FIELDS.
    02 A-X1 PIC S9(7) COMP-3. 02 A-X2 PIC S9(7) COMP-3.
    02 A-X3 PIC S9(7) COMP-3. 02 A-X4 PIC S9(7) COMP-3.
    02 A-A1 PIC X(200). 02 A-A2 PIC X(200). 02 A-A3 PIC X(200).
    02 A-S1 PIC 9 COMP-3. 02 A-S2 PIC 9 COMP-3.
    02 A-N1 PIC S9(13) COMP-3. 02 A-N2 PIC S9(13) COMP-3.
    02 A-N3 PIC S9(13) COMP-3. 02 A-N4 PIC S9(13) COMP-3.
    02 A-N5 PIC S9(13) COMP-3. 02 A-N6 PIC S9(13) COMP-3.
    02 A-L1 PIC S9(13)V9 COMP-3. 02 A-L2 PIC S9(13)V9 COMP-3.
    02 A-D1 PIC S9(13)V99 COMP-3. 02 A-D2 PIC S9(13)V99 COMP-3.
    02 A-D3 PIC S9(13)V99 COMP-3. 02 A-D4 PIC S9(13)V99 COMP-3.
    02 A-T1 PIC S9(13)V999 COMP-3. 02 A-T2 PIC S9(13)V999 COMP-3.
    02 A-V1 PIC S9(13)V9(4) COMP-3. 02 A-V2 PIC S9(13)V9(4) COMP-3.
    02 A-U1 PIC 9(18). 02 A-U2 PIC 9(18).
01  DISPLAY-FIELDS.
    02 DSP-N11 PIC 9. 02 DSP-N12 PIC 9.
    02 DSP-N21 PIC Z9. 02 DSP-N22 PIC Z9.
    02 DSP-N31 PIC ZZ9. 02 DSP-N32 PIC ZZ9.
    02 DSP-N41 PIC ZZZ9. 02 DSP-N42 PIC ZZZ9.
    02 DSP-N51 PIC Z(4)9. 02 DSP-N52 PIC Z(4)9.
    02 DSP-N61 PIC Z(5)9. 02 DSP-N62 PIC Z(5)9.
    02 DSP-N71 PIC Z(6)9. 02 DSP-N72 PIC Z(6)9.
    02 DSP-C61 PIC ZZZ,ZZ9-. 02 DSP-C62 PIC ZZZ,ZZ9-.
    02 DSP-C81 PIC ZZ,ZZZ,ZZ9-. 02 DSP-C82 PIC ZZ,ZZZ,ZZ9-.
    02 DSP-F21 PIC 99. 02 DSP-F22 PIC 99.
    02 DSP-F31 PIC 999. 02 DSP-F32 PIC 999.
    02 DSP-F71 PIC 9(7). 02 DSP-F72 PIC 9(7).
    02 DSP-F81 PIC 9(8). 02 DSP-F82 PIC 9(8).
    02 DSP-GL1 PIC 9(6)B999B99B9(7). 02 DSP-GL2 PIC 9(6)B999B99B9(7).
    02 DSP-DT1 PIC 99/99/99. 02 DSP-DT2 PIC 99/99/99.

01  MESSAGE-FIELDS.
    02 MSG-M1 PIC X(26) VALUE "THIS IS AN EDI TRANSACTION".
    02 MSG-M2 PIC X(41) VALUE "CUSTOMS CLEARANCE BY FEDEX TRADE NETWORKS".
    02 MSG-M3 PIC X(50) VALUE "SHIPMENT DESTINED FOR MEXICO, ENTER UNDER T&E BOND".
    02 MSG-M4.
      03 MSG-M4A PIC X(57) VALUE "ALL PALLETS INCLUDED IN THIS SHIPMENT WERE MADE IN CANADA".
      03 MSG-M4B PIC X(22) VALUE "  FROM CANADIAN LUMBER".
    02 MSG-M5.
      03 MSG-M5A PIC X(58) VALUE "AMERICAN AXLE & MANUFACTURING DE MEXICO S. DE R.L. DE C.V.".
      03 MSG-M5B PIC X(12) VALUE "C/O EXL INC.".
      03 MSG-M5C PIC X(57) VALUE "14207 ATLANTA DR., INTERAMERICA PARK, LAREDO, TEXAS 78045".
      03 MSG-M5D PIC X(39) VALUE "TEL 956-725-0537 X104, FAX 956-729-1350".
    02 MSG-M6.
      03 MSG-M6A PIC X(11) VALUE "BILLING TO:".
      03 MSG-M6B PIC X(52) VALUE "AMERICAN AXLE & MANUFACTURING DE MEXICO S.A. DE C.V.".
      03 MSG-M6C PIC X(12) VALUE "CISCO #44595".
      03 MSG-M6D PIC X(57) VALUE "C/O NOLAN & CUNNINGS, P.O.BOX 2111, WARREN, MI 48090-2111".
    02 MSG-M7.
      03 MSG-M7A PIC X(10) VALUE "CONSIGNEE:".
      03 MSG-M7B PIC X(42) VALUE "AAM MAQUILADORA MEXICO, S. DE R.L. DE C.V.".
      03 MSG-M7C PIC X(37) VALUE "AVE. COMERCIANTES #1300,  P.I. FIPASI".
      03 MSG-M7D PIC X(60) VALUE "SILAO, GUANAJUATO   C.P. 36100, MEXICO   R.F.C. AMM060130M44".
    02 MSG-M8 PIC X(32) VALUE "F.T.A. CERTS ON FILE WITH BROKER".
    02 MSG-M9.
      03 MSG-M9A PIC X(54) VALUE "THIS IS NOT A SALE. SHIPPED TO U.S. FOR PROCESSING AND".
      03 MSG-M9B PIC X(59) VALUE "  WILL BE RETURNED TO CANADA UPON COMPLETION OF PROCESSING.".
    02 MSG-M10.
      03 MSG-M10A PIC X(51) VALUE "THIS SHIPMENT IS A TRANSFER OF PRODUCT IN INVENTORY".
      03 MSG-M10B PIC X(38) VALUE "  TO AN AFFILIATE AT COST (NOT A SALE)".

01  SCANNER-FIELDS.
    02 SCN-BIN PIC X(6). 02 SCN-LVL PIC XX.
    02 SCN-ALOT. 03 SCN-AL PIC X. 03 SCN-LOT PIC 9(7).
    02 SCN-APROD. 03 SCN-AP PIC X. 03 SCN-PROD PIC X(12).

01  SIXEL-FIELDS.
    02 SIX-SZ PIC 9(4) COMP-3.
    02 SIX-DISP PIC X(1000). 02 SIX-IXW PIC 9(5) COMP-3. 02 SIX-FLD PIC X(50).
    02 TX-SCR. 03 PIC X VALUE X"9B". 03 TX-SCR-T PIC 99.
      03 PIC X VALUE ";". 03 TX-SCR-B PIC 99. 03 PIC X VALUE "r".
    02 TX-CUR. 03 PIC X VALUE X"9B". 03 TX-CUR-R PIC 99. 03 PIC X VALUE ";".
      03 TX-CUR-C PIC 99. 03 PIC X VALUE "H".
    02 TX-PG. 03 PIC X VALUE X"9B". 03 TX-PG-N PIC 9. 03 PIC XX VALUE " P".
    02 TX-SIXSCR. 03 PIC X VALUE X"9B". 03 PIC X(4) VALUE "?80h".
    02 TX-SIXY. 03 PIC X VALUE X"90". 03 PIC X(19) VALUE "0;1;0;q""1;1;800;480".
    02 TX-SIXN. 03 PIC X VALUE X"9C".
    02 TX-CURY. 03 PIC X VALUE X"9B". 03 PIC X(4) VALUE "?25h".
    02 TX-CURN. 03 PIC X VALUE X"9B". 03 PIC X(4) VALUE "?25l".
    02 TX-INS. 03 PIC X VALUE X"9B". 03 TX-INS-N PIC 99. 03 PIC XX VALUE "L".
    02 TX-DEL. 03 PIC X VALUE X"9B". 03 TX-DEL-N PIC 99. 03 PIC XX VALUE "M".
    02 TX-CLS. 03 PIC X VALUE X"9B". 03 PIC XX VALUE "2J".
    02 TX-CLL. 03 PIC X VALUE X"9B". 03 PIC XX VALUE "2K".
    02 TX-L25Y. 03 PIC X VALUE X"9B". 03 PIC XXX VALUE "1$}".
      03 PIC X VALUE X"9B". 03 PIC XXX VALUE "2$~".
    02 TX-L25N. 03 PIC X VALUE X"9B". 03 PIC XXX VALUE "0$}".
01  SDRAWING-FIELDS.
    02 SDR-KER PIC 9 COMP-3. 02 SDR-MESG PIC X(80).
    02 SDR-TP PIC 9 COMP-3. 02 SDR-INP PIC X(12).
    02 OCCURS 2. 03 SDR-DRAW PIC X(8). 03 SDR-PROD PIC X(12).
      03 SDR-PAGE PIC 9 COMP-3. 03 SDR-MAX PIC S999 COMP-3. 03 SDR-LINE PIC S999 COMP-3.
    02 SDR-OP PIC 9 COMP-3. 02 SDR-START PIC S999 COMP-3 VALUE 31.
    02 SDR-FIRST PIC S999 COMP-3. 02 SDR-NUM PIC S999 COMP-3.
    02 SDR-PG PIC 9 COMP-3. 02 SDR-NPG PIC 9 COMP-3.
01  PDRAWING-FIELDS.
    02 PDR-TP PIC 9 COMP-3. 02 PDR-INP PIC X(12). 02 PDR-DRAW PIC X(8) OCCURS 5.
    02 PDR-NUM PIC S99 COMP-3. 02 PDR-IX1 PIC S99 COMP-3.

01  EDI-FIELDS.
    02 EDI-ID PIC X(8). 02 EDI-SZ PIC 999 COMP-3.
    02 ED-LABINF. 03 ED-PKG11 PIC X(8). 03 ED-PKG12 PIC X(8).
      03 ED-PKG13 PIC X(25). 03 ED-PKG14 PIC X(20). 03 ED-PKG15 PIC X(20).
      03 ED-PKG16 PIC X(24). 03 ED-PKG17 PIC X(10).
    02 ED-SAT-DATA. 03 ED-SKAN.
      04 ED-SKAN-A PIC X. 04 ED-SKAN-ND PIC 9 COMP-3.
      04 ED-SKAN-N PIC 9(5) COMP-3 OCCURS 2.
    02 ED-DELP-DATA. 03 ED-DSTOR PIC X(8). 03 ED-DSCHEDNO PIC X(15).
      03 ED-DKNUM PIC 99 COMP-3. 03 ED-DKVAL PIC X(10) OCCURS 30.
    02 ED-AMAX-DATA. 03 ED-ADOCK PIC X(8). 03 ED-AGROUP PIC X(8).
      03 ED-APDATA OCCURS 30. 04 ED-AKAN PIC X(8). 04 ED-AORD PIC X(9).
        04 ED-ASERIAL PIC 9(8) COMP-3.
        04 OCCURS 5. 05 ED-ACARTONS PIC 99 COMP-3. 05 ED-ALOT PIC 9(7) COMP-3.
      03 ED-APLANT PIC X(10). 03 ED-APROD PIC X(12). 03 ED-AFDATE PIC 9(6) COMP-3.
    02 ED-GMC-DATA. 03 ED-GNAD PIC X(80).
    02 ED-BEN-DATA. 03 ED-BXL PIC 99 COMP-3.
      03 ED-BLIN. 04 OCCURS 5. 05 ED-BLCODE PIC XX. 05 ED-BLVAL PIC X(10).
    02 ED-GMC-CL PIC XXX VALUE "DFC". 02 ED-CHRY-CL PIC X(5) VALUE "42865".
    02 ED-MGM-CL PIC X(5) VALUE "42832". 02 ED-WOOD-CL PIC X(4) VALUE "IFLS".
    02 ED-DANA-CL PIC X(4) VALUE "6843". 02 ED-REMIT-CL PIC X(4) VALUE "IFLS".
    02 ED-MOD-CL PIC X(5) VALUE "20312". 02 ED-BEN-CL PIC X(4) VALUE "IFLS".
    02 ED-MOD-REL PIC XXX VALUE "472".
    02 ED-DUNS PIC X(9). 02 ED-DUNS2 PIC X(9). 02 ED-DUNS3 PIC X(9).
    02 ED-PLNAME PIC X(30).
    02 ED-NL PIC X. 02 ED-SEP PIC X. 02 ED-DEL PIC X. 02 ED-SUBSEP PIC X.
    02 ED-LINE PIC X(80). 02 ED-FIELD PIC X(80). 02 ED-A PIC X.
    02 ED-LTH PIC 999 COMP-3. 02 ED-PTR PIC 999 COMP-3. 02 ED-QQUAL PIC XXX.
    02 ED-VAL PIC S9(13)V9(5) COMP-3. 02 ED-KN PIC 9 COMP-3. 02 ED-VCA. 03 ED-VCN PIC 9.
    02 ED-ANUM PIC X(12). 02 ED-ADATE PIC X(12). 02 ED-NUM PIC 9(9).
    02 ED-T1 PIC S9(15) COMP-3. 02 ED-T2 PIC S9(15) COMP-3.
    02 ED-IX1 PIC 9(6) COMP-3. 02 ED-IX2 PIC 9(6) COMP-3.
    02 ED-DX1 PIC 99 COMP-3. 02 ED-DX2 PIC 99 COMP-3.
    02 ED-DTM PIC 9(12). 02 ED-DQUAL PIC XXX. 02 ED-DFQUAL PIC XXX.
    02 ED-CCYYMMDD PIC 9(8). 02 REDEFINES ED-CCYYMMDD. 03 ED-CC PIC 99. 03 ED-YYMMDD PIC 9(6).
    02 ED-TIME PIC 9(8). 02 REDEFINES ED-TIME. 03 ED-HHMM PIC 9(4). 03 PIC 9(4).
    02 ED-SENDER-QUAL PIC XX. 02 ED-RECEIVER-QUAL PIC XX.
    02 ED-ISA-VERSION PIC X(5). 02 ED-GS-VERSION PIC X(12).
    02 ED-SENDER-ID PIC X(15). 02 ED-RECEIVER-ID PIC X(15).
    02 ED-ISA-NUM PIC 9(9). 02 ED-GS-NUM PIC 9(4). 02 ED-ST-NUM PIC 9(4).
    02 ED-ISA-TOT PIC 9(5). 02 ED-GS-TOT PIC 9(6). 02 ED-ST-TOT PIC 9(6).
    02 ED-A11 PIC X. 02 ED-A12 PIC X.
    02 ED-A21 PIC XX. 02 ED-A22 PIC XX.
    02 ED-A31 PIC XXX. 02 ED-A32 PIC XXX.
    02 ED-A41 PIC X(4). 02 ED-A42 PIC X(4).
    02 ED-A51 PIC X(5). 02 ED-A52 PIC X(5).
    02 ED-A61 PIC X(6). 02 ED-A62 PIC X(6).
    02 ED-A101 PIC X(10). 02 ED-A102 PIC X(10).
    02 ED-A201 PIC X(20). 02 ED-A202 PIC X(20).
    02 ED-N11 PIC 9. 02 ED-N12 PIC 9.
    02 ED-N21 PIC 99. 02 ED-N22 PIC 99.
    02 ED-N31 PIC 999. 02 ED-N32 PIC 999.
    02 ED-N41 PIC 9(4). 02 ED-N42 PIC 9(4).
    02 ED-N51 PIC 9(4). 02 ED-N52 PIC 9(4).
    02 ED-N61 PIC 9(6). 02 ED-N62 PIC 9(6).
    02 ED-N71 PIC 9(7). 02 ED-N72 PIC 9(7).
    02 ED-N81 PIC 9(8). 02 ED-N82 PIC 9(8).
    02 ED-N91 PIC 9(9). 02 ED-N92 PIC 9(9).
    02 ED-D71 PIC 9(7).99. 02 ED-D72 PIC 9(7).99.
    02 ED-T41 PIC 9(4).999. 02 ED-T42 PIC 9(4).999.
    02 ED-P51 PIC 9.9(5). 02 ED-P52 PIC 9.9(5).
    02 ED-HEAD1 PIC X(83) VALUE
      "EXCEPTION LIST - PLANT-PRODUCT PAIRS IN THE INPUT FILE, NOT FOUND IN THE PLANT FILE".
    02 ED-TYPE PIC 99 COMP-3. 88 ED-NONEDI VALUE 0.
      88 ED-AOS VALUE 1. 88 ED-CHRY VALUE 2. 88 ED-GMC VALUE 3.
      88 ED-TRW VALUE 4. 88 ED-UTA VALUE 5. 88 ED-FLEX VALUE 6.
      88 ED-SKF VALUE 7. 88 ED-RBW VALUE 8. 88 ED-AMAX VALUE 9.
      88 ED-KSR VALUE 10. 88 ED-FAB VALUE 11. 88 ED-GRAH VALUE 12.
      88 ED-DELP VALUE 13. 88 ED-MGM VALUE 14. 88 ED-WOOD VALUE 15.
      88 ED-QSS VALUE 16. 88 ED-INM VALUE 17. 88 ED-DANA VALUE 18.
      88 ED-DRI VALUE 19. 88 ED-MOD VALUE 20. 88 ED-BEN VALUE 21.
      88 ED-VEN VALUE 22.
* note 73.1
    02 AUTO-CODE PIC 99 COMP-3. 88 AUTO-NONEDI VALUE 0.
      88 AUTO-AOS VALUE 1. 88 AUTO-CHRY VALUE 2. 88 AUTO-GMC VALUE 3.
      88 AUTO-TRW VALUE 4. 88 AUTO-UTA VALUE 5. 88 AUTO-FLEX VALUE 6.
      88 AUTO-SKF VALUE 7. 88 AUTO-RBW VALUE 8. 88 AUTO-AMAX VALUE 9.
      88 AUTO-KSR VALUE 10. 88 AUTO-FAB VALUE 11. 88 AUTO-GRAH VALUE 12.
      88 AUTO-DELP VALUE 13. 88 AUTO-MGM VALUE 14. 88 AUTO-WOOD VALUE 15.
      88 AUTO-QSS VALUE 16. 88 AUTO-INM VALUE 17. 88 AUTO-DANA VALUE 18.
      88 AUTO-DRI VALUE 19. 88 AUTO-MOD VALUE 20. 88 AUTO-BEN VALUE 21.
      88 AUTO-VEN VALUE 22.
01  DX-FIELDS.
    02 DX-IXP PIC S99 COMP-3. 02 DX-IXL PIC S99 COMP-3. 02 DX-CNUM PIC 99 COMP-3.
    02 DX-PULLS PIC S99 COMP-3. 02 DX-CTNS PIC 99 COMP-3. 02 DX-SERIAL PIC 9(8) COMP-3.

01  COUNTRY-FIELDS.
    02 COU-CTBL. 03 OCCURS 2. 04 OCCURS 3.
      05 COU-COUNTRY PIC 99 COMP-3. 05 COU-QTY PIC 9(7) COMP-3.
      05 COU-PROD PIC X(12). 05 COU-DESC PIC X(32). 05 COU-WEIGHT PIC 9(5) COMP-3.
      05 COU-PRICE PIC 9(4)V999 COMP-3. 05 COU-MODE PIC X.
      05 COU-EXT PIC S9(7)V99 COMP-3. 05 COU-HCODE PIC 99 COMP-3.
01  RELEASE-FIELDS.
    02 REL-FQTY PIC S9(7) COMP-3. 02 REL-FDATE PIC 9(6) COMP-3.
    02 REL-ISA-KEY. 03 REL-IDATE PIC 9(6). 03 REL-ITIME PIC 9(4). 03 REL-INUM PIC 9(9).
    02 REL-RUN-KEY. 03 REL-RDATE PIC 9(6). 03 REL-RTIME PIC 9(8).
    02 REL-PLANT PIC X(10). 02 REL-PROD PIC X(12). 02 REL-ORD PIC 9(6) COMP-3.
    02 REL-OPLANT PIC X(10).
01  CALCULATION-FIELDS.
    02 CL-PRICE PIC 9(6)V999 COMP-3. 02 CL-MODE PIC X(4). 02 CL-DISC PIC 99 COMP-3.
    02 CL-QTY PIC S9(9)V999 COMP-3. 02 CL-AMT PIC S9(9)V99 COMP-3.
    02 CL-WEIGHT PIC S9(9)V99 COMP-3. 02 CL-WEIGHT-I PIC S9(9) COMP-3.
    02 CL-SUR PIC 9 COMP-3. 02 CL-SURCH PIC 9V999 COMP-3. 02 CL-KSM PIC 9 COMP-3.
    02 CL-D1 PIC S9(9)V99 COMP-3. 02 CL-T1 PIC S9(9)V999 COMP-3.
    02 CL-IXD PIC 99 COMP-3. 02 CL-IXP PIC 99 COMP-3. 02 CL-DTXT PIC X(20).
    02 CL-ADIS. 03 CL-NDIS PIC 999. 03 CL-TDIS REDEFINES CL-NDIS PIC V999.
    02 CL-C PIC X.
01  CUSTOMER-FIELDS.
    02 CUS-LINE PIC X(40) OCCURS 5.
01  PRODUCT-FIELDS.
    02 PRO-NSV PIC X(12). 02 PRO-CATSV PIC 99 COMP-3. 02 PRO-CUSV PIC X(6).
    02 PRO-NO. 03 PRO-PR PIC 99 OCCURS 3. 03 PIC X(6). 02 PRO-LTH PIC 99 COMP-3.
    02 PRO-IX1 PIC 99 COMP-3. 02 PRO-DESC-TBL. 03 PRO-DESC PIC X(32) OCCURS 5.
    02 PRO-PRINT PIC X(13). 02 REDEFINES PRO-PRINT. 03 PRO-PRT1 PIC XX.
      03 PRO-PRT2 PIC 9(4). 03 PRO-PRT3 PIC BX(4). 03 PRO-PRT4 PIC XX.
    02 PRO-OPDESC. 03 PRO-OPLINE PIC X(72) OCCURS 2. 03 PIC X(12).
    02 PRO-SPDESC. 03 PIC X(7) VALUE "SPEED: ". 03 PRO-SPN PIC ZZ9. 03 PIC X(4) VALUE " PPM".
    02 PRO-AWIRE PIC X(6). 02 PRO-WIRE REDEFINES PRO-AWIRE PIC 9.9(4).
    02 PRO-NUT PIC X(12). 02 PRO-NNUT PIC 99 COMP-3. 02 PRO-GROSS PIC 9(4)V99 COMP-3.
    02 PRO-KS PIC 9 COMP-3. 02 PRO-DEM-DATE PIC 9(6) COMP-3.
    02 PRO-ENG PIC XXX. 02 PRO-QUAL PIC X(10). 02 PRO-HARM PIC X(13).
    02 PRO-SIND PIC 9 COMP-3. 02 PRO-NIND PIC 9 COMP-3. 02 PRO-CAT PIC 99 COMP-3.
01  GENERIC-FIELDS.
    02 GEN-IND PIC 9 COMP-3. 02 GEN-ALT PIC X(12).
    02 GEN-NUT PIC X(12). 02 GEN-WEIGHT-NUT PIC 9(4)V99 COMP-3.
    02 GEN-MSG. 03 PIC X(14) VALUE "SEE GEN PROD". 03 GEN-PN PIC X(12).
01  PART-FIELDS.
    02 PART-ALT PIC 9(12). 02 REDEFINES PART-ALT. 03 PART-ALT1 PIC 9(4) OCCURS 3.
    02 PART-PRINT PIC X(14). 02 REDEFINES PART-PRINT. 03 PART-PRT1 PIC 9(4).
      03 PART-PRT1A PIC X. 03 PART-PRT2 PIC 9(4). 03 PART-PRT2A PIC X. 03 PART-PRT3 PIC 9(4).
    02 PART-CODE PIC 9 COMP-3.
      88 PART-MAT VALUE 1. 88 PART-TOOL VALUE 2. 88 PART-MAINT VALUE 3.
    02 PART-NO PIC X(12).
    02 PART-PROCESS. 03 PIC X VALUE "A". 03 PART-PA PIC 9. 03 PIC XX VALUE "-C".
      03 PART-PC PIC 9.
01  EXTENSION-FIELDS.
    02 EXT-D. 03 EXT-DA PIC X. 03 EXT-DN1 PIC 9B. 03 EXT-DN2 REDEFINES EXT-DN1 PIC 99.
    02 EXT-S PIC 99.

01  UPD-FIELDS.
    02 UPD-IX1 PIC 99 COMP-3. 02 UPD-WN1 PIC S9(9) COMP-3. 02 UPD-WD1 PIC S9(9)V99 COMP-3.
    02 UPD-Q1 PIC S9(9) COMP-3. 02 UPD-Q2 PIC S9(9) COMP-3. 02 UPD-Q3 PIC S9(9) COMP-3.
    02 UPD-PROD PIC X(12). 02 UPD-TOOL PIC X(12).
01  SHB-FIELDS.
    02 SHB-PART PIC X(12). 02 SHB-IX1 PIC 99 COMP-3. 02 SHB-COL PIC 99 COMP-3.
    02 SHB-TDS1 PIC X(80).
    02 REDEFINES SHB-TDS1. 03 OCCURS 3.
      04 SHB-TS1 PIC B(8)X(8). 04 SHB-TS2 PIC X. 04 SHB-TS3 PIC Z(6)9-.
    02 REDEFINES SHB-TDS1. 03 OCCURS 2.
      04 SHB-TS5 PIC B(8)X(8). 04 SHB-TS6 PIC X. 04 SHB-TS7 PIC Z9.
      04 SHB-TS8 PIC BX. 04 SHB-TS9 PIC Z(4)9-. 04 SHB-TS10 PIC BX.
      04 SHB-TS11 PIC BX(10).
01  CTA-FIELDS.
    02 CTA-OP PIC 9 COMP-3. 02 CTA-N PIC 9 COMP-3.
    02 CTA-STOTALS. 03 CTA-STOT PIC S9(9) COMP-3 OCCURS 4.
    02 CTA-GTOTALS. 03 CTA-GTOT PIC S9(9) COMP-3 OCCURS 4.
01  GRT-FIELDS.
    02 GRT-GL PIC 9(18). 02 REDEFINES GRT-GL.
      03 GRT-GL1 PIC 9(6). 03 GRT-GL2 PIC 999. 03 GRT-GL3 PIC 99. 03 GRT-GL4 PIC 9(7).
    02 GRT-KCAN PIC 9 COMP-3. 02 GRT-TYPE PIC 9. 02 GRT-SYS PIC 9.
    02 GRT-VEN PIC 9(4). 02 GRT-INV PIC X(15). 02 GRT-INV-DATE PIC 9(6) COMP-3.
    02 GRT-AMT PIC S9(9)V99 COMP-3. 02 GRT-QTY PIC S9(9) COMP-3.
    02 GRT-EXCHANGE PIC S9(7)V99 COMP-3. 02 GRT-FREIGHT PIC S9(7)V99 COMP-3.
    02 GRT-IX1 PIC 99 COMP-3. 02 GRT-FAMT PIC S9(7)V99 COMP-3 OCCURS 10.
    02 GRT-PTABLE.
      03 PIC X(95) VALUE "342231000000000000.342232000000000000.135321000000000000.135322000000000000.346801000000000000.".
      03 PIC X(95) VALUE "341922000000000114.426399000000000000.235871049060000000.236403000000000000.233205049060000000.".
    02 REDEFINES GRT-PTABLE. 03 OCCURS 10. 04 GRT-PGL PIC 9(18). 04 PIC X.
01  APS-FIELDS.
    02 APS-IXT PIC 99 COMP-3. 02 APS-COL PIC 99 COMP-3.
    02 APS-SN PIC 99 COMP-3. 02 APS-VEN PIC 9(4) COMP-3. 02 APS-IX1 PIC 99 COMP-3.
    02 OCCURS 24.
      03 APS-VEN1 PIC 9(4) COMP-3. 03 APS-VEN2 PIC 9(4) COMP-3.
      03 APS-PAY PIC 9 COMP-3. 03 APS-KDUE PIC 9 COMP-3. 03 APS-DATE PIC 9(6) COMP-3.
01  DSA-FIELDS.
    02 DSA-LN. 03 DSA-LINE PIC X(39) OCCURS 4. 02 DSA-LNA PIC X(30).
    02 DSA-LTH PIC S999 COMP-3 VALUE 39.
    02 DSA-IX1 PIC S999 COMP-3. 02 DSA-IXT PIC S999 COMP-3.
    02 DSA-IXL PIC S999 COMP-3. 02 DSA-IXA PIC S999 COMP-3.
    02 DSA-VAL PIC 9(9)V99.
    02 REDEFINES DSA-VAL. 03 DSA-VALD PIC 999 OCCURS 3. 03 DSA-VALC PIC 99.
    02 DSA-AMT PIC 999. 02 REDEFINES DSA-AMT. 03 DSA-AMA PIC 9 OCCURS 3.
    02 DSA-TBL1 PIC X(54) VALUE
      "ONE  .TWO  .THREE.FOUR .FIVE .SIX  .SEVEN.EIGHT.NINE .".
    02 REDEFINES DSA-TBL1. 03 OCCURS 9. 04 DSA-DES1 PIC X(5). 04 PIC X.
    02 DSA-TBL2 PIC X(100) VALUE
      "TEN      .ELEVEN   .TWELVE   .THIRTEEN .FOURTEEN .FIFTEEN  .SIXTEEN  .SEVENTEEN.EIGHTEEN .NINETEEN .".
    02 REDEFINES DSA-TBL2. 03 OCCURS 10. 04 DSA-DES2 PIC X(9). 04 PIC X.
    02 DSA-TBL3 PIC X(72) VALUE
      "       .TWENTY .THIRTY .FORTY  .FIFTY  .SIXTY  .SEVENTY.EIGHTY .NINETY .".
    02 REDEFINES DSA-TBL3. 03 OCCURS 9. 04 DSA-DES3 PIC X(7). 04 PIC X.
    02 DSA-TBL4 PIC X(18) VALUE "MILLION .THOUSAND.".
    02 REDEFINES DSA-TBL4. 03 OCCURS 2. 04 DSA-DES4 PIC X(8). 04 PIC X.

01  COSTING-FIELDS.
    02 CST-IXE PIC S999 COMP-3. 02 CST-ERR PIC XX OCCURS 10. 02 CST-LOP PIC S999 COMP-3.
    02 CST-IXO PIC S999 COMP-3. 02 CST-IXT PIC S999 COMP-3. 02 CST-IXP PIC S999 COMP-3.
    02 CST-IXL PIC S999 COMP-3. 02 CST-KPACK PIC 9 COMP-3. 02 CST-KL PIC 9 COMP-3.
    02 CST-ITHOURS PIC S99V999 COMP-3. 02 CST-AMO PIC 9(6) COMP-3.
    02 CST-ACTBL. 03 OCCURS 12.
      04 CST-ACODE PIC 9(4) COMP-3. 04 CST-AHOURS PIC S999V99 COMP-3.
      04 CST-AQTY PIC S9(7) COMP-3.
    02 CST-KQ PIC 9 COMP-3. 02 CST-KN PIC 9 COMP-3. 02 CST-KPRI PIC 9 COMP-3.
    02 CST-KTOOL PIC 9 COMP-3. 02 CST-KPUR PIC 9 COMP-3. 02 CST-KDSP PIC 9 COMP-3.
    02 CST-MAC PIC 99. 02 CST-WAMT PIC S9(5)V999 COMP-3. 02 CST-MODE PIC 9 COMP-3.
    02 CST-PRICE PIC 9(4)V999 COMP-3. 02 CST-PRICE-SUG PIC S9(5)V999 COMP-3.
    02 CST-PACKING PIC 99 COMP-3. 02 CST-MULT PIC 9V9(5) COMP-3.
    02 CST-GROSS PIC 9(4)V99 COMP-3. 02 CST-NET PIC 9(4)V99 COMP-3.
    02 CST-GMULT PIC 9V9(5) COMP-3. 02 CST-NMULT PIC 9V9(5) COMP-3.
    02 CST-ALT PIC X(12). 02 CST-PNO PIC X(12). 02 CST-MAT PIC X(12).
    02 CST-PROCESS PIC X(5). 02 CST-NUT PIC X(12).
    02 CST-CUTOT PIC S9(5)V999 COMP-3 OCCURS 3.
    02 CST-DF1. 03 CST-DF11 PIC BX(10). 03 CST-DF12 PIC ZZ9. 03 CST-DF13 PIC Z(7)9.999.
      03 CST-DF14 PIC Z(8)9.999. 03 CST-DF15 PIC Z(8)9.999.
    02 CST-DF2. 03 CST-DF21 PIC X. 03 CST-DF22 PIC X(5). 03 CST-DF23 PIC ZZ9-.
      03 CST-DF24 PIC X(4). 03 CST-DF25 PIC ZZZ9.999-. 03 CST-DF26 PIC X.
      03 CST-DF27 PIC ZZZ9.999. 03 CST-DF28 PIC X.
    02 CST-DFLDS.
      03 CST-M-TOT PIC S9(5)V999 COMP-3. 03 CST-M-MAT PIC S9(5)V999 COMP-3.
      03 CST-M-PROC PIC S9(5)V999 COMP-3.
      03 CST-T-TOT PIC S9(5)V999 COMP-3. 03 CST-T-FREIGHT PIC S9(5)V999 COMP-3.
      03 OCCURS 5. 04 CST-T-CODE PIC 9(4) COMP-3. 04 CST-T-AMT PIC S9(5)V999 COMP-3.
      03 CST-C-TOT PIC S9(5)V999 COMP-3. 03 CST-C-TOOLS PIC S9(5)V999 COMP-3.
      03 CST-C-CARTONS PIC S9(5)V999 COMP-3.
      03 OCCURS 10. 04 CST-C-CODE PIC 9(4) COMP-3. 04 CST-C-AMT PIC S9(5)V999 COMP-3.
        04 CST-C-LABOUR PIC S9(5)V999 COMP-3. 04 CST-C-OVERHEAD PIC S9(5)V999 COMP-3.
      03 CST-N-TOT PIC S9(5)V999 COMP-3. 03 CST-OVERHEAD PIC S9(5)V999 COMP-3.
      03 CST-DIRECT PIC S9(5)V999 COMP-3. 03 CST-MFG PIC S9(5)V999 COMP-3.
* note 135
    02 CSV-DFLDS.
      03 CSV-M-TOT PIC S9(5)V999 COMP-3. 03 CSV-M-MAT PIC S9(5)V999 COMP-3.
      03 CSV-M-PROC PIC S9(5)V999 COMP-3.
      03 CSV-T-TOT PIC S9(5)V999 COMP-3. 03 CSV-T-FREIGHT PIC S9(5)V999 COMP-3.
      03 OCCURS 5. 04 CSV-T-CODE PIC 9(4) COMP-3. 04 CSV-T-AMT PIC S9(5)V999 COMP-3.
      03 CSV-C-TOT PIC S9(5)V999 COMP-3. 03 CSV-C-TOOLS PIC S9(5)V999 COMP-3.
      03 CSV-C-CARTONS PIC S9(5)V999 COMP-3.
      03 OCCURS 10. 04 CSV-C-CODE PIC 9(4) COMP-3. 04 CSV-C-AMT PIC S9(5)V999 COMP-3.
        04 CSV-C-LABOUR PIC S9(5)V999 COMP-3. 04 CSV-C-OVERHEAD PIC S9(5)V999 COMP-3.
      03 CSV-N-TOT PIC S9(5)V999 COMP-3. 03 CSV-OVERHEAD PIC S9(5)V999 COMP-3.
      03 CSV-DIRECT PIC S9(5)V999 COMP-3. 03 CSV-MFG PIC S9(5)V999 COMP-3.

01  MAINTENANCE-FIELDS.
    02 MNT-IMAC PIC X(4). 02 REDEFINES MNT-IMAC. 03 MNT-IN PIC 9 OCCURS 4.
    02 MNT-KERR PIC 9 COMP-3. 02 MNT-IX1 PIC S999 COMP-3. 02 MNT-IX2 PIC S999 COMP-3.
    02 MNT-MAC PIC 999. 02 MNT-KM PIC 9 COMP-3. 02 MNT-LTH PIC 9 COMP-3.
    02 MNT-DESC1 PIC X(30). 02 MNT-DESC2 PIC X(30).
01  PROCESS-FIELDS.
    02 PROC-CODE PIC 99 COMP-3.
      88 PROC-PRIMARY VALUE 1. 88 PROC-HEAT VALUE 2. 88 PROC-PACK VALUE 3.
      88 PROC-OUTCON VALUE 4. 88 PROC-INCON VALUE 5. 88 PROC-TAP VALUE 6.
      88 PROC-THREAD VALUE 7. 88 PROC-RECEIVE VALUE 8. 88 PROC-LOTINSP VALUE 9.
      88 PROC-ADJUST VALUE 10. 88 PROC-PHYSINV VALUE 11. 88 PROC-MAINT VALUE 12.
      88 PROC-REJECT VALUE 13. 88 PROC-DEFECT VALUE 14. 88 PROC-BOLTNUT VALUE 15.
      88 PROC-MANUSORT VALUE 16. 88 PROC-AUTOSORT VALUE 17. 88 PROC-INSPECT VALUE 18.
      88 PROC-RETURN VALUE 19. 88 PROC-SCRAP VALUE 20.
      88 PROC-XINSPECT VALUE 51. 88 PROC-XRECEIVE VALUE 52.
01  MACHINE-FIELDS.
    02 MAC-NUM PIC 99 COMP-3 VALUE 36. 02 MAC-IX1 PIC S99 COMP-3.
    02 MAC-TBL1 PIC X(148) VALUE
      "01..02..03..04..05..06..07..09..10..11..12..13..14..15..16..17..18..19..20..21..22..23..24..25..26..27..28..29..30..31..32..33..34..36..37..38..54..".
    02 REDEFINES MAC-TBL1. 03 OCCURS 37. 04 MAC-MAC PIC 99. 04 PIC XX.
    02 MAC-TBL2 PIC X(148) VALUE
      "060.060.060.045.060.090.120.051.081.102.132.144.150.120.027.033.084.069.048.020.108.042.066.054.033.054.048.072.072.042.126.126.126.069.039.069.000.".
    02 REDEFINES MAC-TBL2. 03 OCCURS 37. 04 MAC-MIN PIC 999. 04 PIC X.
    02 MAC-TBL3 PIC X(148) VALUE
      "150.150.150.113.150.225.250.128.203.250.250.250.250.250.068.083.210.173.120.050.250.085.120.135.081.135.120.180.180.105.220.220.220.086.097.086.005.".
    02 REDEFINES MAC-TBL3. 03 OCCURS 37. 04 MAC-MAX PIC 999. 04 PIC X.
01  CLEANING-FIELDS.
    02 CLN-TBL.
      03 PIC X(72) VALUE "086-C25/P5/L2    .087-C25/P5/S3    .592-M25/P/Polymer.174-C5/M25/P7/L2 .".
      03 PIC X(72) VALUE "                 .                 .078-C25/L3       .".
    02 REDEFINES CLN-TBL. 03 OCCURS 8. 04 CLN-DESC PIC X(17). 04 PIC X.

01  MECHANICAL-FIELDS.
    02 MEC-VAL PIC X(45). 02 MEC-UNIT PIC X(5). 02 MEC-VLTH PIC 999 COMP-3.
    02 MEC-VN PIC 9(5). 02 MEC-CA. 03 MEC-CN PIC 9. 02 MEC-IX1 PIC 99 COMP-3.
    02 MEC-NUM PIC 9(7) COMP-3. 02 MEC-DEC PIC 9(5) COMP-3.
    02 MEC-MFLDS.
      03 MEC-TITLE. 04 MEC-TL0 PIC X(48). 04 MEC-TL1 PIC X(84) OCCURS 5.
      03 REDEFINES MEC-TITLE. 04 PIC X(48). 04 MEC-TA PIC X(28) OCCURS 15.
      03 MEC-LINES.
        04 MEC-FL0 PIC X(48). 04 REDEFINES MEC-FL0.
          05 MEC-FL01 PIC ZZB. 05 MEC-FL03X. 06 MEC-FL03 PIC BB9(7)B.
          05 MEC-FL04 PIC Z(6). 05 MEC-FL05 PIC BBX(20).
        04 MEC-FL1 PIC X(84) OCCURS 5.
      03 REDEFINES MEC-LINES. 04 PIC X(48). 04 MEC-FA PIC X(28) OCCURS 15.
      03 MEC-LD1 PIC X(48). 03 REDEFINES MEC-LD1.
        04 PIC XXX. 04 MEC-LD11 PIC ZZ9(7). 04 MEC-LD12 PIC BX(8).
01  CHEMISTRY-FIELDS.
    02 CHM-TBL.
      03 PIC X(70) VALUE "C  CARBON    .MN MANGANESE .P  PHOSPHORUS.S  SULPHUR   .SI SILICON   .".
      03 PIC X(70) VALUE "CU COPPER    .NI NICKEL    .CR CHROMIUM  .MO MOLYBDENUM.SN TIN       .".
      03 PIC X(70) VALUE "AL ALUMINUM  .B  BORON     .V  VANADIUM  .CO COBALT    .N  NITROGEN  .".
    02 REDEFINES CHM-TBL. 03 OCCURS 15. 04 CHM-DESC PIC X(13). 04 PIC X.
    02 CHM-HTITLE PIC X(126) VALUE
      "HEAT NO.    GRADE       C      MN     P      S      SI     CU     NI     CR     MO     SN     AL     B      V      CO     N".
*      ..........  ........  .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:....

01  CHARACTERISTICS-FIELDS.
    02 CAR-CH PIC 99 COMP-3. 02 CAR-UNIT PIC X(10). 02 CAR-UNIT-A PIC X(5).
    02 CAR-INSTRUMENT PIC X(22). 02 CAR-INSTR-A PIC X(14) OCCURS 2.
    02 CAR-FLD PIC 9(5)V9(4) COMP-3.
    02 CAR-N0 PIC 9(5) COMP-3. 02 CAR-N1 PIC 9(5)V9 COMP-3.
    02 CAR-N3 PIC 9(5)V999 COMP-3. 02 CAR-N4 PIC 9(5)V9(4) COMP-3.
    02 CAR-VAL PIC 9(6) COMP-3. 02 CAR-TVAL REDEFINES CAR-VAL PIC 999V999 COMP-3.

    02 CAR-INSTR-TABLE.
      03 PIC X(78) VALUE "VERNIER     .            :MICROMETER  .            :PITCH       .MICROMETER  :".
      03 PIC X(78) VALUE "TRI ROLL    .            :GO/NO GO    .THREAD GAUGE:GO/NO GO    .PLUG GAUGE  :".
      03 PIC X(78) VALUE "VISUAL      .            :MICROSCOPE  .            :PERMASCOPE  .            :".
      03 PIC X(78) VALUE "TIMER       .            :FURNACE     .CHART       :ROCKWELL    .TESTER      :".
      03 PIC X(78) VALUE "SUPERFICIAL .ROCKWELL    :TENSILE     .TESTER      :SALT SPRAY  .CABINET     :".
      03 PIC X(78) VALUE "CONTROLLER  .            :TEMPERATURE .CONTROLLER  :OPTICAL     .COMPARATOR  :".
      03 PIC X(78) VALUE "SPECIAL     .GAUGE       :TRI         .MICROMETER  :DEEP ETCH   .            :".
      03 PIC X(78) VALUE "LAB TEST    .            :CONCENTR.   .GAUGE       :UNIVERSAL   .GAUGE       :".
      03 PIC X(78) VALUE "PIN         .GAUGE       :".
    02 REDEFINES CAR-INSTR-TABLE. 03 OCCURS 27. 04 OCCURS 2. 05 CAR-INSTR-DESC PIC X(12). 05 PIC X.
    02 CAR-INSTR-NUM PIC 99 COMP-3 VALUE 25.

    02 CAR-UNIT-TABLE.
      03 PIC X(66) VALUE "INCH      .MM        .GO/NO GO  .OK/NOT OK .%         .HRS       .".
      03 PIC X(66) VALUE "MIN       .SEC       .1=ON/2=OFF.KSI       .DEG F     .LBS       .".
      03 PIC X(66) VALUE "HRC       .HRBS      .HR30N     .HR15N     .DEGREES   .12 INCH   .".
      03 PIC X(66) VALUE "MARKINGS  .".
    02 REDEFINES CAR-UNIT-TABLE. 03 OCCURS 24. 04 CAR-UNIT-DESC PIC X(10). 04 PIC X.
    02 CAR-UNITA-TABLE.
      03 PIC X(36) VALUE "INCH .MM   .GO/NO.OK/NO.%    .HRS  .".
      03 PIC X(36) VALUE "MIN  .SEC  .1=ON .KSI  .DEG F.LBS  .".
      03 PIC X(36) VALUE "HRC  .HRBS .HR30N.HR15N.DEGRS.12 IN.".
      03 PIC X(36) VALUE "MRKGS.".
    02 REDEFINES CAR-UNITA-TABLE. 03 OCCURS 24. 04 CAR-UNITA-DESC PIC X(5). 04 PIC X.
    02 CAR-UNIT-NUM PIC 99 COMP-3 VALUE 19.

* note 192
    02 CAR-DATA PIC X(44). 02 REDEFINES CAR-DATA.
      03 CAR-NUM PIC 999. 03 PIC X. 03 CAR-DESC PIC X(31). 03 PIC X.
      03 CAR-IN PIC 99. 03 CAR-UN PIC 99. 03 PIC X. 03 CAR-SAMPLE PIC 999.

    02 CAR-PHYS-NUM PIC 99 COMP-3 VALUE 28.

    02 CAR-HEAT-TABLE.
      03 PIC X(44) VALUE "001.AUSTENITIZING TEMPERATURE      .1111.000".
      03 PIC X(44) VALUE "002.TEMPERING TEMPERATURE          .1111.000".
      03 PIC X(44) VALUE "003.AS QUENCHED HARDNESS           .1213.000".
      03 PIC X(44) VALUE "004.TEMPERED HARDNESS              .1213.000".
      03 PIC X(44) VALUE "005.TEMPERED HARDNESS              .1214.000".
      03 PIC X(44) VALUE "006.SURFACE HARDNESS               .1315.000".
      03 PIC X(44) VALUE "007.SURFACE HARDNESS               .1316.000".
      03 PIC X(44) VALUE "008.AXIAL TENSILE                  .1412.000".
      03 PIC X(44) VALUE "009.SIX DEGREE WEDGE TENSILE       .1412.000".
      03 PIC X(44) VALUE "010.TEN DEGREE WEDGE TENSILE       .1412.000".
      03 PIC X(44) VALUE "011.CASE DEPTH                     .0801.000".
      03 PIC X(44) VALUE "012.WALMIL SETTING                 .1008.000".
      03 PIC X(44) VALUE "013.VIBRATORY FEEDER  ON SETTING   .1008.000".
      03 PIC X(44) VALUE "014.VIBRATORY FEEDER OFF SETTING   .1008.000".
      03 PIC X(44) VALUE "015.BELT SPEED SETTING             .1607.000".
      03 PIC X(44) VALUE "016.OIL TEMPERATURE                .1711.000".
      03 PIC X(44) VALUE "017.OIL AGITATION                  .0709.000".
      03 PIC X(44) VALUE "018.                               .0000.000".
    02 REDEFINES CAR-HEAT-TABLE. 03 CAR-HEAT PIC X(44) OCCURS 18.
    02 CAR-HEAT-NUM PIC 99 COMP-3 VALUE 18.

    02 CAR-MECH-TABLE.
      03 PIC X(44) VALUE "001.HARDNESS                       .1213.000".
      03 PIC X(44) VALUE "002.HARDNESS AFTER 24 HRS          .1213.000".
      03 PIC X(44) VALUE "003.SURFACE HARDNESS               .1215.000".
      03 PIC X(44) VALUE "004.PROOF LOAD                     .1410.000".
      03 PIC X(44) VALUE "005.WEDGE TENSILE STRENGTH         .1410.000".
      03 PIC X(44) VALUE "006.ULTIMATE TENSILE STRENGTH      .1410.000".
      03 PIC X(44) VALUE "007.YIELD STRENGTH                 .1410.000".
      03 PIC X(44) VALUE "008.ELONGATION                     .0105.000".
      03 PIC X(44) VALUE "009.REDUCTION OF AREA              .0205.000".
      03 PIC X(44) VALUE "010.DECARB CLASS                   .0804.000".
      03 PIC X(44) VALUE "011.CASE DEPTH                     .0801.000".
      03 PIC X(44) VALUE "012.PLATING THICKNESS              .0901.000".
      03 PIC X(44) VALUE "013.SALT SPRAY HOURS               .1506.000".
      03 PIC X(44) VALUE "014.TEMPERING TEMPERATURE          .1111.000".
      03 PIC X(44) VALUE "015.                               .0000.000".
    02 REDEFINES CAR-MECH-TABLE. 03 CAR-MECH PIC X(44) OCCURS 15.
    02 CAR-MECH-NUM PIC 99 COMP-3 VALUE 15.

01  BARCODE-FIELDS.
    02 BAR-MM PIC 99. 02 BAR-DD PIC 99. 02 BAR-YY PIC 99. 02 BAR-YEAR PIC 9(4).
    02 BAR-DATE PIC 9(6). 02 BAR-NDATE PIC X(8). 02 BAR-LDATE PIC X(8).
    02 BAR-CDATE PIC X(10). 02 BAR-ADATE PIC X(11). 02 BAR-SDATE PIC X(9).
    02 BAR-ERR PIC 9 COMP-3. 02 BAR-INSPTXT PIC X(36). 02 BAR-IXP PIC S9(5) COMP-3.
    02 BAR-IXL PIC S9(5) COMP-3. 02 BAR-IX1 PIC S9(5) COMP-3. 02 BAR-A31 PIC XXX.
    02 BAR-UDX PIC 99 COMP-3. 02 BAR-UPC PIC 9(5).
    02 BAR-NTX PIC 999. 02 BAR-NTD PIC 999.
    02 BAR-LABQTY PIC 9(4). 02 BAR-QSER PIC 9.
    02 BAR-HEAT PIC X(10). 02 BAR-KHT PIC 9 COMP-3.
    02 BAR-SERIAL PIC 9(8). 02 BAR-SX PIC 99 COMP-3.
    02 BAR-PROD PIC X(12). 02 BAR-PX PIC 99 COMP-3.
    02 BAR-PART PIC X(16). 02 BAR-HX PIC 99 COMP-3.
    02 BAR-CUSPART PIC X(16). 02 BAR-FX PIC 99 COMP-3.
    02 BAR-SUPPLIER PIC X(9). 02 BAR-EX PIC 99 COMP-3.
    02 BAR-ENG PIC XXX. 02 BAR-NX PIC 99 COMP-3.
    02 BAR-LOT PIC 9(7). 02 BAR-LX PIC 99 COMP-3.
    02 BAR-QTY PIC 9(5). 02 BAR-QX PIC 99 COMP-3.
    02 BAR-PKQTY PIC 9(5). 02 BAR-KX PIC 99 COMP-3.
    02 BAR-PLQTY PIC 9(6). 02 BAR-TX PIC 99 COMP-3.
    02 BAR-CUSORD PIC X(9). 02 BAR-CX PIC 99 COMP-3.
    02 BAR-WEIGHT PIC 9(4). 02 BAR-WX PIC 99 COMP-3.
    02 BAR-CARTONS PIC 99. 02 BAR-RX PIC 99 COMP-3.
    02 BAR-KANBAN PIC X(10). 02 BAR-AX PIC 99 COMP-3.
    02 BAR-PKSLIP PIC 9(6). 02 BAR-GX PIC 99 COMP-3.
    02 BAR-P11X PIC 99 COMP-3. 02 BAR-P12X PIC 99 COMP-3.
    02 BAR-DESC. 03 BAR-DESC-A PIC X(16). 03 BAR-DESC-B PIC X(16).
      03 BAR-DESC-EXT PIC X(32). 03 BAR-DESC-FIN PIC X(32).
      03 BAR-DESC-FR PIC X(36).
    02 BAR-LINE PIC X(36) OCCURS 2.
    02 BAR-CUS PIC X(6). 02 BAR-ORDSEQ PIC 9(8). 02 BAR-COUNTRY PIC X(20).
    02 BAR-NAMAD. 03 BAR-NAME PIC X(32).
      03 BAR-ADD1 PIC X(24). 03 BAR-ADD2 PIC X(24). 03 BAR-POST PIC X(10).
    02 BAR-LICENSE. 03 BAR-LI1 PIC XX. 03 BAR-LI2 PIC 9(9). 03 BAR-LI3 PIC 9(8).
    02 BAR-VENSER. 03 BAR-VE1 PIC X(4). 03 BAR-VE2 PIC 9(5).
    02 BAR-A. 03 PIC X(7) VALUE "^FT^A0,". 03 BAR-AH PIC 999. 03 PIC X VALUE ",".
      03 BAR-AW PIC 999. 03 PIC XXX VALUE "^FD".
    02 BAR-B. 03 PIC XXX VALUE "^FT". 03 BAR-BX PIC 9(4). 03 PIC X VALUE ",".
      03 BAR-BY PIC 9(4). 03 PIC X(14) VALUE "^A0,1,1^FD ^FS".
    02 BAR-MX. 03 BAR-MXL PIC 99 COMP-3.
      03 OCCURS 8. 04 BAR-MXPN PIC X(8). 04 BAR-MXNC PIC 99 COMP-3.
        04 BAR-MXTQ PIC 9(5) COMP-3. 04 BAR-MXPQ PIC 9(5) COMP-3.
      03 BAR-MX-LITX PIC X(45) VALUE "0582.0551.0582.0551.0533.0502.0533.0502.0502.".
      03 BAR-MX-TBLX. 04 OCCURS 9. 05 BAR-MXX PIC 9(4). 05 PIC X.
      03 BAR-MX-LITY PIC X(45) VALUE "0020.0020.0200.0210.0020.0050.0180.0210.0140.".
      03 BAR-MX-TBLY. 04 OCCURS 9. 05 BAR-MXY PIC 9(4). 05 PIC X.
    02 BAR-MSG1.
      03 PIC X(38) VALUE "Electroplated B7 stud and 2H nut".
      03 PIC X(38) VALUE "assemblies should not be used in".
      03 PIC X(38) VALUE "applications where they are exposed to".
      03 PIC X(38) VALUE "temperatures in excess of 300 deg. F.".
      03 PIC X(38) VALUE "Such usage may subject the studs and".
      03 PIC X(38) VALUE "nuts to LIQUID METAL EMBRITTLEMENT.".
    02 REDEFINES BAR-MSG1. 03 BAR-MES1 PIC X(38) OCCURS 6.
    02 BAR-FROM PIC X(53) VALUE "IRVINE FASTENERS, SPRINGHILL, ONTARIO, CANADA N1K 5R6".
    02 BAR-FROM-NAME PIC X(16) VALUE "IRVINE FASTENERS".
    02 BAR-FROM-LOC1 PIC X(22) VALUE "SPRINGHILL ONT N1K 5R6".
    02 BAR-FROM-LOC2 PIC X(27) VALUE "SPRINGHILL, ONTARIO N1K 5R6".
    02 BAR-FROM-LOC3 PIC X(35) VALUE "SPRINGHILL, ONTARIO, CANADA N1K 5R6".

01  TOOL-FIELDS.
    02 TL-NUM PIC 999 COMP-3. 02 TL-TYPE PIC 99 COMP-3. 02 TL-NTYPE PIC 99 COMP-3.
    02 TL-SCRN PIC 9 COMP-3. 02 TL-NS PIC 9 COMP-3.
    02 TL-IXF PIC 999 COMP-3. 02 TL-IXA PIC 999 COMP-3.
    02 TL-R1 PIC 99 COMP-3. 02 TL-R2 PIC 99 COMP-3.
    02 TL-ASTN PIC 9. 02 TL-ACAT PIC 9.
    02 TL-DATA PIC X(100).
    02 REDEFINES TL-DATA.
      03 TL-DESC PIC X(20). 03 PIC X. 03 TL-FLD PIC 999. 03 PIC X.
      03 TL-STN PIC 9. 03 TL-CAT PIC 9. 03 TL-LOC PIC 9. 03 PIC X.
      03 TL-PAGE PIC 9. 03 PIC X. 03 TL-ROW PIC 99. 03 PIC X. 03 TL-COL PIC 999.
      03 PIC X. 03 TL-MAND PIC 9. 03 TL-SETUP PIC 9. 03 PIC X(60).
    02 REDEFINES TL-DATA.
      03 PIC X(28). 03 TL-INF PIC X(12). 03 TL-TINF PIC X(12) OCCURS 5.
* note 110.3
    02 TL-LREC PIC X(3300). 02 REDEFINES TL-LREC.
      03 TL-LPROD PIC X(12). 03 TL-LMAC PIC 99. 03 TL-LTOOL PIC X(12) OCCURS 250.

* note 105.1
    02 TL-BTABLE.
      03 PIC X(100) VALUE "DRAW DIE            .001.000_0.00.000.00_1.04.012.11_1.04.012.11_1.04.012.11_1.04.012.11_1.04.012.11".
      03 PIC X(100) VALUE "FEEDROLLS 1         .002.000_0.00.000.00_1.04.040.10_1.04.040.10_1.04.040.10_1.04.040.10_1.04.040.10".
      03 PIC X(100) VALUE "FEEDROLLS 2         .040.000_0.00.000.00_1.04.055.00_1.04.055.00_1.04.055.00_1.04.055.00_1.04.055.00".
      03 PIC X(100) VALUE "QUILL               .003.000_0.00.000.00_1.04.079.11_1.04.079.11_1.04.079.11_1.04.079.11_1.04.079.11".
      03 PIC X(100) VALUE "CUTTER              .004.000_0.00.000.00_1.05.010.11_1.05.010.11_1.04.104.11_1.04.104.11_1.04.104.11".
      03 PIC X(100) VALUE "CUTTER HOLDER       .032.000_0.00.000.00_1.05.042.10_1.05.042.10_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "POINTER DIES        .120.000_0.00.000.00_0.00.000.00_0.00.000.00_1.05.092.11_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "GRIP JAWS           .121.000_0.00.000.00_0.00.000.00_0.00.000.00_1.05.120.11_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "1ST TR FINGERS LEFT .023.000_0.00.000.00_1.07.028.11_1.07.028.11_1.06.028.11_1.06.028.11_1.06.028.11".
      03 PIC X(100) VALUE "1ST TR FINGERS RIGHT.024.000_0.00.000.00_1.07.043.11_1.07.043.11_1.06.043.11_1.06.043.11_1.06.043.11".
      03 PIC X(100) VALUE "2ND TR FINGERS LEFT .025.000_0.00.000.00_0.00.000.00_1.07.065.11_1.06.065.11_1.06.065.11_1.06.065.11".
      03 PIC X(100) VALUE "2ND TR FINGERS RIGHT.026.000_0.00.000.00_0.00.000.00_1.07.080.11_1.06.080.11_1.06.080.11_1.06.080.11".
      03 PIC X(100) VALUE "3RD TR FINGERS LEFT .027.000_0.00.000.00_0.00.000.00_0.00.000.00_1.07.028.11_1.07.028.11_1.07.028.11".
      03 PIC X(100) VALUE "3RD TR FINGERS RIGHT.028.000_0.00.000.00_0.00.000.00_0.00.000.00_1.07.043.11_1.07.043.11_1.07.043.11".
      03 PIC X(100) VALUE "4TH TR FINGERS LEFT .029.000_0.00.000.00_0.00.000.00_0.00.000.00_1.07.065.11_0.00.000.00_1.07.065.11".
      03 PIC X(100) VALUE "4TH TR FINGERS RIGHT.030.000_0.00.000.00_0.00.000.00_0.00.000.00_1.07.080.11_0.00.000.00_1.07.080.11".

      03 PIC X(100) VALUE "1ST FRONT INSERT    .031.162_0.00.000.00_1.09.027.10_1.09.027.10_1.09.027.10_1.09.027.10_1.09.027.10".
      03 PIC X(100) VALUE "1ST MIDDLE INSERT 1 .033.163_0.00.000.00_1.09.060.10_1.09.060.10_1.09.060.10_1.09.060.10_1.09.060.10".
      03 PIC X(100) VALUE "1ST MIDDLE INSERT 2 .034.166_0.00.000.00_1.09.075.00_1.09.075.00_1.09.075.00_1.09.075.00_1.09.075.00".
      03 PIC X(100) VALUE "1ST POINTER          046.160_0.00.000.00_1.09.101.10_1.09.101.00_1.09.101.00_1.09.101.00_1.09.101.00".
      03 PIC X(100) VALUE "1ST BACK INSERT 1   .035.164_0.00.000.00_1.10.027.00_1.10.027.10_1.10.027.00_1.10.027.00_1.10.027.00".
      03 PIC X(100) VALUE "1ST BACK INSERT 2   .036.167_0.00.000.00_1.10.042.00_1.10.042.00_1.10.042.00_1.10.042.00_1.10.042.00".
      03 PIC X(100) VALUE "1ST DIE CASE        .045.161_0.00.000.00_1.10.069.10_1.10.069.10_1.10.069.10_1.10.069.10_1.10.069.10".
      03 PIC X(100) VALUE "1ST BACKPLATE       .037.100_0.00.000.00_1.10.097.00_1.10.097.00_1.10.097.00_0.00.000.00_1.10.097.00".
      03 PIC X(100) VALUE "1ST K.O. PIN        .038.100_0.00.000.00_1.11.023.11_1.11.023.11_1.11.023.11_1.11.023.11_1.11.023.11".
      03 PIC X(100) VALUE "1ST BUTTONS 1       .049.100_0.00.000.00_1.11.049.11_1.11.049.11_1.11.049.11_0.00.000.00_1.11.049.11".
      03 PIC X(100) VALUE "1ST BUTTONS 2       .066.100_0.00.000.00_0.00.000.00_1.11.064.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "1ST SLEEVE          .047.100_0.00.000.00_0.00.000.00_1.11.090.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "1ST INTERMEDIATE ROD.064.100_0.00.000.00_0.00.000.00_1.12.031.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "1ST ASSEMBLED PIN   .060.130_0.00.000.00_0.00.000.00_1.12.063.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "1ST ASSEMBLED DIE   .044.110_0.00.000.00_1.11.082.11_1.12.096.11_1.11.082.11_1.11.056.11_1.11.082.11".

      03 PIC X(100) VALUE "2ND FRONT INSERT    .048.262_0.00.000.00_0.00.000.00_1.14.027.10_1.12.027.10_1.13.027.10_1.12.027.10".
      03 PIC X(100) VALUE "2ND MIDDLE INSERT 1 .050.263_0.00.000.00_0.00.000.00_1.14.060.10_1.12.060.10_1.13.060.10_1.12.060.10".
      03 PIC X(100) VALUE "2ND MIDDLE INSERT 2 .051.266_0.00.000.00_0.00.000.00_1.14.075.00_1.12.075.00_1.13.075.00_1.12.075.00".
      03 PIC X(100) VALUE "2ND POINTER         .063.260_0.00.000.00_0.00.000.00_1.14.101.10_1.12.101.10_1.13.101.10_1.12.101.10".
      03 PIC X(100) VALUE "2ND BACK INSERT 1   .052.264_0.00.000.00_0.00.000.00_1.15.027.00_1.13.027.00_1.14.027.00_1.13.027.00".
      03 PIC X(100) VALUE "2ND BACK INSERT 2   .053.267_0.00.000.00_0.00.000.00_1.15.042.00_1.13.042.00_1.14.042.00_1.13.042.00".
      03 PIC X(100) VALUE "2ND DIE CASE        .062.261_0.00.000.00_0.00.000.00_1.15.069.10_1.13.069.10_1.14.069.10_1.13.069.10".
      03 PIC X(100) VALUE "2ND NUT             .097.200_0.00.000.00_0.00.000.00_1.15.092.00_1.13.092.00_0.00.000.00_1.13.092.00".
      03 PIC X(100) VALUE "2ND BACKPLATE       .054.200_0.00.000.00_0.00.000.00_1.15.120.00_1.13.120.00_0.00.000.00_1.13.120.00".
      03 PIC X(100) VALUE "2ND K.O. PIN        .055.200_0.00.000.00_0.00.000.00_1.16.023.11_1.14.023.11_1.15.023.11_1.14.023.11".
      03 PIC X(100) VALUE "2ND BUTTONS 1       .098.200_0.00.000.00_0.00.000.00_1.16.049.11_1.14.049.11_0.00.000.00_1.14.049.11".
      03 PIC X(100) VALUE "2ND BUTTONS 2       .099.200_0.00.000.00_0.00.000.00_1.16.064.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "2ND SLEEVE          .100.200_0.00.000.00_0.00.000.00_1.16.090.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "2ND INTERMEDIATE ROD.101.200_0.00.000.00_0.00.000.00_1.17.031.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "2ND ASSEMBLED PIN   .102.230_0.00.000.00_0.00.000.00_1.17.063.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "2ND ASSEMBLED DIE   .061.210_0.00.000.00_0.00.000.00_1.17.096.11_1.14.082.11_1.15.056.11_1.14.082.11".

      03 PIC X(100) VALUE "3RD FRONT INSERT    .065.362_0.00.000.00_0.00.000.00_0.00.000.00_1.15.027.10_1.17.027.10_1.15.027.10".
      03 PIC X(100) VALUE "3RD MIDDLE INSERT 1 .067.363_0.00.000.00_0.00.000.00_0.00.000.00_1.15.060.10_1.17.060.10_1.15.060.10".
      03 PIC X(100) VALUE "3RD MIDDLE INSERT 2 .068.366_0.00.000.00_0.00.000.00_0.00.000.00_1.15.075.00_1.17.075.00_1.15.075.00".
      03 PIC X(100) VALUE "3RD POINTER         .059.360_0.00.000.00_0.00.000.00_0.00.000.00_1.15.101.10_1.17.101.10_1.15.101.10".
      03 PIC X(100) VALUE "3RD BACK INSERT 1   .069.364_0.00.000.00_0.00.000.00_0.00.000.00_1.16.027.00_1.18.027.00_1.16.027.00".
      03 PIC X(100) VALUE "3RD BACK INSERT 2   .070.367_0.00.000.00_0.00.000.00_0.00.000.00_1.16.042.00_1.18.042.00_1.16.042.00".
      03 PIC X(100) VALUE "3RD DIE CASE        .077.361_0.00.000.00_0.00.000.00_0.00.000.00_1.16.069.10_1.18.069.10_1.16.069.10".
      03 PIC X(100) VALUE "3RD BACKPLATE       .071.300_0.00.000.00_0.00.000.00_0.00.000.00_1.16.097.00_0.00.000.00_1.16.097.00".
      03 PIC X(100) VALUE "3RD K.O. PIN        .072.300_0.00.000.00_0.00.000.00_0.00.000.00_1.17.023.11_1.19.023.11_1.17.023.11".
      03 PIC X(100) VALUE "3RD BUTTONS 1       .103.300_0.00.000.00_0.00.000.00_0.00.000.00_1.17.049.11_0.00.000.00_1.17.049.01".
      03 PIC X(100) VALUE "3RD BUTTONS 2       .104.300_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "3RD NUT             .105.300_0.00.000.00_0.00.000.00_0.00.000.00_1.17.071.00_1.19.045.00_1.17.071.00".
      03 PIC X(100) VALUE "3RD ASSEMBLED PIN   .106.330_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "3RD ASSEMBLED DIE   .042.310_0.00.000.00_0.00.000.00_0.00.000.00_1.17.105.11_1.19.079.11_1.17.105.11".

      03 PIC X(100) VALUE "4TH FRONT INSERT    .107.462_0.00.000.00_0.00.000.00_0.00.000.00_1.18.027.00_0.00.000.00_1.18.027.00".
      03 PIC X(100) VALUE "4TH MIDDLE INSERT 1 .108.463_0.00.000.00_0.00.000.00_0.00.000.00_1.18.060.00_0.00.000.00_1.18.060.00".
      03 PIC X(100) VALUE "4TH MIDDLE INSERT 2 .109.466_0.00.000.00_0.00.000.00_0.00.000.00_1.18.075.00_0.00.000.00_1.18.075.00".
      03 PIC X(100) VALUE "4TH POINTER         .110.460_0.00.000.00_0.00.000.00_0.00.000.00_1.18.101.00_0.00.000.00_1.18.101.00".
      03 PIC X(100) VALUE "4TH BACK INSERT 1   .111.464_0.00.000.00_0.00.000.00_0.00.000.00_1.19.027.00_0.00.000.00_1.19.027.00".
      03 PIC X(100) VALUE "4TH BACK INSERT 2   .112.467_0.00.000.00_0.00.000.00_0.00.000.00_1.19.042.00_0.00.000.00_1.19.042.00".
      03 PIC X(100) VALUE "4TH DIE CASE        .113.461_0.00.000.00_0.00.000.00_0.00.000.00_1.19.069.00_0.00.000.00_1.19.069.00".
      03 PIC X(100) VALUE "4TH BACKPLATE       .114.400_0.00.000.00_0.00.000.00_0.00.000.00_1.19.097.00_0.00.000.00_1.19.097.00".
      03 PIC X(100) VALUE "4TH K.O. PIN        .115.400_0.00.000.00_0.00.000.00_0.00.000.00_1.20.023.01_0.00.000.00_1.20.023.00".
      03 PIC X(100) VALUE "4TH BUTTONS 1       .116.400_0.00.000.00_0.00.000.00_0.00.000.00_1.20.049.01_0.00.000.00_1.20.049.00".
      03 PIC X(100) VALUE "4TH BUTTONS 2       .117.400_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH ASSEMBLED PIN   .118.430_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH ASSEMBLED DIE   .119.410_0.00.000.00_0.00.000.00_0.00.000.00_1.20.082.01_0.00.000.00_1.20.082.00".

      03 PIC X(100) VALUE "TRIM PUNCH          .009.000_0.00.000.00_0.00.000.00_0.00.000.00_1.22.014.01_1.21.014.01_1.22.014.11".
      03 PIC X(100) VALUE "TRIM PUNCH MIDDLE   .014.000_0.00.000.00_0.00.000.00_0.00.000.00_1.22.039.00_1.21.039.00_1.22.039.10".
      03 PIC X(100) VALUE "TRIM PUNCH CASE     .093.000_0.00.000.00_0.00.000.00_0.00.000.00_1.22.062.00_1.21.062.00_1.22.062.10".
      03 PIC X(100) VALUE "TRIM PUNCH NUT      .094.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_1.21.084.00_1.22.084.00".
      03 PIC X(100) VALUE "TRIM PUNCH BACKPLATE.012.000_0.00.000.00_0.00.000.00_0.00.000.00_1.23.013.00_1.22.013.00_1.23.013.10".
      03 PIC X(100) VALUE "TRIM PUNCH K.O. PIN .013.000_0.00.000.00_0.00.000.00_0.00.000.00_1.23.041.01_1.22.041.01_1.23.041.11".
      03 PIC X(100) VALUE "TRIM PUNCH BUTTONS 1.095.000_0.00.000.00_0.00.000.00_0.00.000.00_1.23.067.01_0.00.000.00_1.23.067.11".
      03 PIC X(100) VALUE "TRIM PUNCH BUTTONS 2.096.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".

      03 PIC X(100) VALUE "1ST PUNCH CASE      .039.171_0.00.000.00_2.04.022.00_2.04.022.00_2.04.022.10_2.04.022.10_2.04.022.00".
      03 PIC X(100) VALUE "1ST PUNCH INSERT 1  .078.172_0.00.000.00_2.04.048.00_2.04.048.00_2.04.048.10_2.04.048.10_2.04.048.00".
      03 PIC X(100) VALUE "1ST PUNCH INSERT 2  .079.175_0.00.000.00_2.04.063.00_2.04.063.00_2.04.063.00_2.04.063.00_2.04.063.00".
      03 PIC X(100) VALUE "1ST PUNCH PIN       .043.100_0.00.000.00_2.05.022.00_2.05.022.00_2.05.022.00_2.05.022.00_2.05.022.00".
      03 PIC X(100) VALUE "1ST PUNCH PLUG      .080.100_0.00.000.00_2.05.045.00_2.05.045.00_2.05.045.00_2.05.045.00_2.05.045.00".
      03 PIC X(100) VALUE "1ST PUNCH ASSEMBLY  .081.120_0.00.000.00_2.05.072.11_2.05.072.11_2.05.072.11_2.05.072.11_2.05.072.11".

      03 PIC X(100) VALUE "2ND PUNCH CASE      .056.271_0.00.000.00_2.07.022.10_2.07.022.00_2.07.022.01_2.07.022.10_2.07.022.00".
      03 PIC X(100) VALUE "2ND PUNCH INSERT 1  .057.272_0.00.000.00_2.07.048.10_2.07.048.00_2.07.048.01_2.07.048.10_2.07.048.10".
      03 PIC X(100) VALUE "2ND PUNCH INSERT 2  .058.275_0.00.000.00_2.07.063.00_2.07.063.00_2.07.063.00_2.07.063.00_2.07.063.00".
      03 PIC X(100) VALUE "2ND PUNCH PIN       .082.200_0.00.000.00_2.08.022.00_2.08.022.00_2.08.022.00_2.08.022.00_2.08.022.00".
      03 PIC X(100) VALUE "2ND PUNCH PLUG      .083.200_0.00.000.00_2.08.045.00_2.08.045.00_2.08.045.00_2.08.045.00_2.08.045.00".
      03 PIC X(100) VALUE "2ND PUNCH ASSEMBLY  .084.220_0.00.000.00_2.08.072.11_2.08.072.11_2.08.072.11_2.08.072.11_2.08.072.11".

      03 PIC X(100) VALUE "3RD PUNCH CASE      .073.371_0.00.000.00_0.00.000.00_2.10.022.01_2.10.022.01_2.10.022.01_2.10.022.00".
      03 PIC X(100) VALUE "3RD PUNCH INSERT 1  .074.372_0.00.000.00_0.00.000.00_2.10.048.01_2.10.048.01_2.10.048.01_2.10.048.10".
      03 PIC X(100) VALUE "3RD PUNCH INSERT 2  .075.375_0.00.000.00_0.00.000.00_2.10.063.00_2.10.063.00_2.10.063.00_2.10.063.00".
      03 PIC X(100) VALUE "3RD PUNCH PIN       .076.370_0.00.000.00_0.00.000.00_2.11.022.01_2.11.022.00_2.11.022.11_2.11.022.00".
      03 PIC X(100) VALUE "3RD PUNCH PLUG      .085.300_0.00.000.00_0.00.000.00_2.11.045.00_2.11.045.00_2.11.045.00_2.11.045.00".
      03 PIC X(100) VALUE "3RD PUNCH ASSEMBLY  .086.320_0.00.000.00_0.00.000.00_2.11.072.11_2.11.072.11_2.11.072.11_2.11.072.11".

      03 PIC X(100) VALUE "4TH PUNCH CASE      .005.471_0.00.000.00_0.00.000.00_0.00.000.00_2.13.022.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH PUNCH INSERT 1  .006.472_0.00.000.00_0.00.000.00_0.00.000.00_2.13.048.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH PUNCH INSERT 2  .007.475_0.00.000.00_0.00.000.00_0.00.000.00_2.13.063.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH PUNCH PIN       .008.400_0.00.000.00_0.00.000.00_0.00.000.00_2.14.022.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH PUNCH PLUG      .087.400_0.00.000.00_0.00.000.00_0.00.000.00_2.14.045.00_0.00.000.00_0.00.000.00".
      03 PIC X(100) VALUE "4TH PUNCH ASSEMBLY  .088.420_0.00.000.00_0.00.000.00_0.00.000.00_2.14.072.01_0.00.000.00_0.00.000.00".

      03 PIC X(100) VALUE "TRIM DIE            .010.000_0.00.000.00_0.00.000.00_2.13.012.00_2.16.012.01_2.13.012.01_2.13.012.11".
      03 PIC X(100) VALUE "TRIM DIE FILLER     .011.000_0.00.000.00_0.00.000.00_2.13.037.00_2.16.037.00_2.13.037.00_2.13.037.11".
      03 PIC X(100) VALUE "TRIM DIE CASE       .089.000_0.00.000.00_0.00.000.00_2.13.060.00_2.16.060.00_2.13.060.00_2.13.060.00".

      03 PIC X(100) VALUE "POINTER PLATE       .016.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.15.029.10".
      03 PIC X(100) VALUE "POINTER GUIDE TIP   .017.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.15.057.10".
      03 PIC X(100) VALUE "POINTER SP CUTR HOLD.015.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.15.097.00".

      03 PIC X(100) VALUE "GRIP JAWS STATIONARY.019.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.16.029.10".
      03 PIC X(100) VALUE "GRIP JAWS MOVABLE   .020.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.16.055.10".
      03 PIC X(100) VALUE "GRIP JAWS BLOCK     .018.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.16.079.10".

      03 PIC X(100) VALUE "THREAD IN GUIDE TIP .090.000_0.00.000.00_2.10.039.10_2.15.039.10_2.18.039.10_2.15.039.00_2.18.039.10".
      03 PIC X(100) VALUE "THREAD OUT GUIDE TIP.091.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.18.073.10".
      03 PIC X(100) VALUE "THREAD DIE 1        .021.000_0.00.000.00_2.11.035.10_2.16.035.10_2.19.035.10_2.16.035.10_2.19.035.11".
      03 PIC X(100) VALUE "THREAD DIE 2        .041.000_0.00.000.00_2.11.050.00_2.16.050.00_2.19.050.00_2.16.050.00_2.19.050.00".
      03 PIC X(100) VALUE "KNURL DIE 1         .022.000_0.00.000.00_2.11.079.01_2.16.079.01_2.19.079.00_2.16.079.00_2.19.079.01".
      03 PIC X(100) VALUE "KNURL DIE 2         .092.000_0.00.000.00_2.11.094.01_2.16.094.01_2.19.094.00_2.16.094.00_2.19.094.01".
    02 REDEFINES TL-BTABLE. 03 TL-BTBL PIC X(100) OCCURS 121.
    02 TL-BTOOLS PIC 999 COMP-3 VALUE 121.

    02 TL-NTABLE.
      03 PIC X(40) VALUE "1ST DIE             .001.000_1.04.023.11".
      03 PIC X(40) VALUE "1ST PUNCH           .002.000_1.04.048.11".
      03 PIC X(40) VALUE "1ST EJECTOR         .003.000_1.04.075.11".
      03 PIC X(40) VALUE "2ND DIE             .004.000_1.06.023.11".
      03 PIC X(40) VALUE "2ND PUNCH PIN       .005.000_1.06.052.11".
      03 PIC X(40) VALUE "BACKING PUNCH       .006.000_1.06.085.11".
      03 PIC X(40) VALUE "CROWNER             .007.000_1.06.112.11".
      03 PIC X(40) VALUE "EJECTOR SLEEVE      .008.000_1.07.034.11".
      03 PIC X(40) VALUE "WASHER FACE INSERT  .009.000_1.07.072.11".
      03 PIC X(40) VALUE "SLOTTED KEY         .010.000_1.07.103.11".
      03 PIC X(40) VALUE "PIERCING DIE        .011.000_1.09.032.11".
      03 PIC X(40) VALUE "PIERCING PUNCH      .012.000_1.09.066.11".
      03 PIC X(40) VALUE "NIB TAP             .013.000_1.11.011.11".
      03 PIC X(40) VALUE "TAP SHANK           .014.000_1.11.039.11".
      03 PIC X(40) VALUE "COUPLER             .015.000_1.11.066.11".
    02 REDEFINES TL-NTABLE. 03 TL-NTBL PIC X(40) OCCURS 15.
    02 TL-NTOOLS PIC 999 COMP-3 VALUE 15.

    02 TL-XTABLE.
      03 PIC X(88) VALUE "DRAW DIE            .001.000_1.03.012.11_1.03.012.11_1.03.012.11_1.03.012.11_1.03.012.11".
      03 PIC X(88) VALUE "QUILL               .002.000_1.03.037.11_1.03.037.11_1.03.037.11_1.03.037.11_1.03.037.11".
      03 PIC X(88) VALUE "CUTTER              .003.000_1.03.063.11_1.03.063.11_1.03.063.11_1.03.063.11_1.03.063.11".
      03 PIC X(88) VALUE "UPPER FEEDBLOCK     .004.000_1.03.104.11_0.00.000.00_1.03.104.11_1.03.104.11_1.03.104.11".
      03 PIC X(88) VALUE "LOWER FEEDBLOCK     .005.000_1.03.119.11_0.00.000.00_1.03.119.11_1.03.119.11_1.03.119.11".
      03 PIC X(88) VALUE "FEEDROLLS           .155.000_0.00.000.00_1.03.092.11_0.00.000.00_0.00.000.00_0.00.000.00".

      03 PIC X(88) VALUE "1ST FRONT INSERT 1  .006.162_1.05.031.10_1.05.031.10_1.05.031.10_1.05.031.10_1.05.031.10".
      03 PIC X(88) VALUE "1ST FRONT INSERT 2  .007.163_1.05.046.00_1.05.046.00_1.05.046.00_1.05.046.00_1.05.046.00".
      03 PIC X(88) VALUE "1ST DIE SLEEVE      .008.160_1.05.076.10_1.05.076.10_1.05.076.10_1.05.076.10_1.05.076.10".
      03 PIC X(88) VALUE "1ST ASSEMBLED DIE   .009.110_1.05.110.11_1.05.110.11_1.05.110.11_1.05.110.11_1.05.110.11".
      03 PIC X(88) VALUE "1ST MIDDLE INSERT 1 .010.163_1.06.031.10_1.06.031.10_1.06.031.10_1.06.031.10_1.06.031.10".
      03 PIC X(88) VALUE "1ST MIDDLE INSERT 2 .011.166_1.06.046.00_1.06.046.00_1.06.046.00_1.06.046.00_1.06.046.00".
      03 PIC X(88) VALUE "1ST MIDDLE INSERT 3 .187.166_0.00.000.00_0.00.000.00_0.00.000.00_1.06.061.00_1.06.061.00".
      03 PIC X(88) VALUE "1ST DIE CASE        .012.161_1.06.076.10_1.06.076.10_1.06.076.10_1.06.110.10_1.06.110.10".
      03 PIC X(88) VALUE "1ST POINTER INSERT 1.013.160_1.07.031.10_1.07.031.10_1.07.031.10_1.07.031.10_1.07.031.10".
      03 PIC X(88) VALUE "1ST POINTER INSERT 2.014.160_1.07.046.00_1.07.046.00_1.07.046.00_1.07.046.00_1.07.046.00".
      03 PIC X(88) VALUE "1ST K.O. PIN        .015.100_1.07.076.11_1.07.076.11_1.07.076.11_1.07.076.11_1.07.076.11".
      03 PIC X(88) VALUE "1ST BUTTON DISC     .128.100_1.07.110.10_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "1ST BACK INSERT 1   .016.164_1.08.031.10_1.08.031.10_1.08.031.10_1.08.031.10_1.08.031.10".
      03 PIC X(88) VALUE "1ST BACK INSERT 2   .017.167_1.08.046.00_1.08.046.00_1.08.046.00_1.08.046.00_1.08.046.00".
      03 PIC X(88) VALUE "1ST BACK INSERT 3   .188.167_0.00.000.00_0.00.000.00_0.00.000.00_1.08.061.00_1.08.061.00".
      03 PIC X(88) VALUE "1ST K.O. BUTTON     .018.100_1.08.076.11_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "1ST FILLER DISC     .114.100_1.08.110.00_1.08.076.00_1.08.076.00_1.08.110.00_1.08.110.00".

      03 PIC X(88) VALUE "2ND FRONT INSERT 1  .019.262_1.10.031.10_1.10.031.10_1.10.031.10_1.10.031.10_1.10.031.10".
      03 PIC X(88) VALUE "2ND FRONT INSERT 2  .020.263_1.10.046.00_1.10.046.00_1.10.046.00_1.10.046.00_1.10.046.00".
      03 PIC X(88) VALUE "2ND DIE SLEEVE      .021.260_1.10.076.10_1.10.076.10_1.10.076.10_1.10.076.10_1.10.076.10".
      03 PIC X(88) VALUE "2ND ASSEMBLED DIE   .022.210_1.10.110.11_1.10.110.11_1.10.110.11_1.10.110.11_1.10.110.11".
      03 PIC X(88) VALUE "2ND MIDDLE INSERT 1 .023.263_1.11.031.10_1.11.031.10_1.11.031.10_1.11.031.10_1.11.031.10".
      03 PIC X(88) VALUE "2ND MIDDLE INSERT 2 .024.266_1.11.046.00_1.11.046.00_1.11.046.00_1.11.046.00_1.11.046.00".
      03 PIC X(88) VALUE "2ND MIDDLE INSERT 3 .189.266_0.00.000.00_0.00.000.00_0.00.000.00_1.11.061.00_1.11.061.00".
      03 PIC X(88) VALUE "2ND DIE CASE        .025.261_1.11.076.10_1.11.076.10_1.11.076.10_1.11.110.10_1.11.110.10".
      03 PIC X(88) VALUE "2ND POINTER INSERT 1.026.260_1.12.031.10_1.12.031.10_1.12.031.10_1.12.031.10_1.12.031.10".
      03 PIC X(88) VALUE "2ND POINTER INSERT 2.027.260_1.12.046.00_1.12.046.00_1.12.046.00_1.12.046.00_1.12.046.00".
      03 PIC X(88) VALUE "2ND K.O. PIN        .028.200_1.12.076.11_1.12.076.11_1.12.076.11_1.12.076.11_1.12.076.11".
      03 PIC X(88) VALUE "2ND BUTTON DISC     .129.200_1.12.110.10_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "2ND BACK INSERT 1   .029.264_1.13.031.10_1.13.031.10_1.13.031.10_1.13.031.10_1.13.031.10".
      03 PIC X(88) VALUE "2ND BACK INSERT 2   .030.267_1.13.046.00_1.13.046.00_1.13.046.00_1.13.046.00_1.13.046.00".
      03 PIC X(88) VALUE "2ND BACK INSERT 3   .190.267_0.00.000.00_0.00.000.00_0.00.000.00_1.13.061.00_1.13.061.00".
      03 PIC X(88) VALUE "2ND K.O. BUTTON     .031.200_1.13.076.11_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "2ND FILLER DISC     .115.200_1.13.110.00_1.13.076.00_1.13.076.00_1.13.110.00_1.13.110.00".

      03 PIC X(88) VALUE "3RD FRONT INSERT 1  .032.362_1.15.031.10_1.15.031.10_1.15.031.10_1.15.031.10_1.15.031.10".
      03 PIC X(88) VALUE "3RD FRONT INSERT 2  .033.363_1.15.046.00_1.15.046.00_1.15.046.00_1.15.046.00_1.15.046.00".
      03 PIC X(88) VALUE "3RD DIE SLEEVE      .034.360_1.15.076.10_1.15.076.10_1.15.076.10_1.15.076.10_1.15.076.10".
      03 PIC X(88) VALUE "3RD ASSEMBLED DIE   .035.310_1.15.110.11_1.15.110.11_1.15.110.11_1.15.110.11_1.15.110.11".
      03 PIC X(88) VALUE "3RD MIDDLE INSERT 1 .036.363_1.16.031.10_1.16.031.10_1.16.031.10_1.16.031.10_1.16.031.10".
      03 PIC X(88) VALUE "3RD MIDDLE INSERT 2 .037.366_1.16.046.00_1.16.046.00_1.16.046.00_1.16.046.00_1.16.046.00".
      03 PIC X(88) VALUE "3RD MIDDLE INSERT 3 .191.366_0.00.000.00_0.00.000.00_0.00.000.00_1.16.061.00_1.16.061.00".
      03 PIC X(88) VALUE "3RD DIE CASE        .038.361_1.16.076.10_1.16.076.10_1.16.076.10_1.16.110.10_1.16.110.10".
      03 PIC X(88) VALUE "3RD POINTER INSERT 1.039.360_1.17.031.10_1.17.031.10_1.17.031.10_1.17.031.10_1.17.031.10".
      03 PIC X(88) VALUE "3RD POINTER INSERT 2.040.360_1.17.046.00_1.17.046.00_1.17.046.00_1.17.046.00_1.17.046.00".
      03 PIC X(88) VALUE "3RD K.O. PIN        .041.300_1.17.076.11_1.17.076.11_1.17.076.11_1.17.076.11_1.17.076.11".
      03 PIC X(88) VALUE "3RD BUTTON DISC     .130.300_1.17.110.10_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "3RD BACK INSERT 1   .042.364_1.18.031.10_1.18.031.10_1.18.031.10_1.18.031.10_1.18.031.10".
      03 PIC X(88) VALUE "3RD BACK INSERT 2   .043.367_1.18.046.00_1.18.046.00_1.18.046.00_1.18.046.00_1.18.046.00".
      03 PIC X(88) VALUE "3RD BACK INSERT 3   .192.367_0.00.000.00_0.00.000.00_0.00.000.00_1.18.061.00_1.18.061.00".
      03 PIC X(88) VALUE "3RD K.O. BUTTON     .044.300_1.18.076.11_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "3RD FILLER DISC     .116.300_1.18.110.00_1.18.076.00_1.18.076.00_1.18.110.00_1.18.110.00".

      03 PIC X(88) VALUE "4TH FRONT INSERT 1  .045.462_1.20.031.10_1.20.031.10_1.20.031.10_1.20.031.10_1.20.031.10".
      03 PIC X(88) VALUE "4TH FRONT INSERT 2  .046.463_1.20.046.00_1.20.046.00_1.20.046.00_1.20.046.00_1.20.046.00".
      03 PIC X(88) VALUE "4TH DIE SLEEVE      .047.460_1.20.076.10_1.20.076.10_1.20.076.10_1.20.076.10_1.20.076.10".
      03 PIC X(88) VALUE "4TH ASSEMBLED DIE   .048.410_1.20.110.11_1.20.110.11_1.20.110.11_1.20.110.11_1.20.110.11".
      03 PIC X(88) VALUE "4TH MIDDLE INSERT 1 .049.463_1.21.031.10_1.21.031.10_1.21.031.10_1.21.031.10_1.21.031.10".
      03 PIC X(88) VALUE "4TH MIDDLE INSERT 2 .050.466_1.21.046.00_1.21.046.00_1.21.046.00_1.21.046.00_1.21.046.00".
      03 PIC X(88) VALUE "4TH MIDDLE INSERT 3 .193.466_0.00.000.00_0.00.000.00_0.00.000.00_1.21.061.00_1.21.061.00".
      03 PIC X(88) VALUE "4TH DIE CASE        .051.461_1.21.076.10_1.21.076.10_1.21.076.10_1.21.110.10_1.21.110.10".
      03 PIC X(88) VALUE "4TH BUTTON DISC     .131.460_1.21.110.10_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "4TH POINTER INSERT 1.052.460_1.22.031.10_1.22.031.10_1.22.031.10_1.22.031.10_1.22.031.10".
      03 PIC X(88) VALUE "4TH POINTER INSERT 2.053.460_1.22.046.00_1.22.046.00_1.22.046.00_1.22.046.00_1.22.046.00".
      03 PIC X(88) VALUE "4TH K.O. PIN        .054.400_1.22.076.11_1.22.076.11_1.22.076.11_1.22.076.11_1.22.076.11".
      03 PIC X(88) VALUE "4TH EJECTOR PIN     .084.400_1.22.110.11_1.22.110.11_1.22.110.11_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "4TH BACK INSERT 1   .055.464_1.23.031.10_1.23.031.10_1.23.031.10_1.23.031.10_1.23.031.10".
      03 PIC X(88) VALUE "4TH BACK INSERT 2   .056.467_1.23.046.00_1.23.046.00_1.23.046.00_1.23.046.00_1.23.046.00".
      03 PIC X(88) VALUE "4TH BACK INSERT 3   .194.467_0.00.000.00_0.00.000.00_0.00.000.00_1.23.061.00_1.23.061.00".
      03 PIC X(88) VALUE "4TH K.O. BUTTON     .057.400_1.23.076.11_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "4TH FILLER DISC     .117.400_1.23.110.00_1.23.076.00_1.23.076.00_1.23.110.00_1.23.110.00".

      03 PIC X(88) VALUE "5TH FRONT INSERT 1  .156.562_0.00.000.00_0.00.000.00_0.00.000.00_2.04.031.10_2.04.031.10".
      03 PIC X(88) VALUE "5TH FRONT INSERT 2  .157.563_0.00.000.00_0.00.000.00_0.00.000.00_2.04.046.00_2.04.046.00".
      03 PIC X(88) VALUE "5TH DIE SLEEVE      .158.560_0.00.000.00_0.00.000.00_0.00.000.00_2.04.076.10_2.04.076.10".
      03 PIC X(88) VALUE "5TH ASSEMBLED DIE   .159.510_0.00.000.00_0.00.000.00_0.00.000.00_2.04.110.11_2.04.110.11".
      03 PIC X(88) VALUE "5TH MIDDLE INSERT 1 .160.563_0.00.000.00_0.00.000.00_0.00.000.00_2.05.031.10_2.05.031.10".
      03 PIC X(88) VALUE "5TH MIDDLE INSERT 2 .161.566_0.00.000.00_0.00.000.00_0.00.000.00_2.05.046.00_2.05.046.00".
      03 PIC X(88) VALUE "5TH MIDDLE INSERT 3 .195.566_0.00.000.00_0.00.000.00_0.00.000.00_2.05.061.00_2.05.061.00".
      03 PIC X(88) VALUE "5TH DIE CASE        .162.561_0.00.000.00_0.00.000.00_0.00.000.00_2.05.110.10_2.05.110.10".
      03 PIC X(88) VALUE "5TH BUTTON DISC     .163.560_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "5TH POINTER INSERT 1.164.560_0.00.000.00_0.00.000.00_0.00.000.00_2.06.031.10_2.06.031.10".
      03 PIC X(88) VALUE "5TH POINTER INSERT 2.165.560_0.00.000.00_0.00.000.00_0.00.000.00_2.06.046.00_2.06.046.00".
      03 PIC X(88) VALUE "5TH K.O. PIN        .166.500_0.00.000.00_0.00.000.00_0.00.000.00_2.06.076.11_2.06.076.11".
      03 PIC X(88) VALUE "5TH EJECTOR PIN     .167.500_0.00.000.00_0.00.000.00_0.00.000.00_2.06.110.11_0.00.000.00".
      03 PIC X(88) VALUE "5TH BACK INSERT 1   .168.564_0.00.000.00_0.00.000.00_0.00.000.00_2.07.031.10_2.07.031.10".
      03 PIC X(88) VALUE "5TH BACK INSERT 2   .169.567_0.00.000.00_0.00.000.00_0.00.000.00_2.07.046.00_2.07.046.00".
      03 PIC X(88) VALUE "5TH BACK INSERT 3   .196.567_0.00.000.00_0.00.000.00_0.00.000.00_2.07.061.00_2.07.061.00".
      03 PIC X(88) VALUE "5TH K.O. BUTTON     .170.500_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "5TH FILLER DISC     .171.500_0.00.000.00_0.00.000.00_0.00.000.00_2.07.110.00_2.07.110.00".

      03 PIC X(88) VALUE "6TH FRONT INSERT 1  .206.662_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.09.031.10".
      03 PIC X(88) VALUE "6TH FRONT INSERT 2  .207.663_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.09.046.00".
      03 PIC X(88) VALUE "6TH DIE SLEEVE      .208.660_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.09.076.10".
      03 PIC X(88) VALUE "6TH ASSEMBLED DIE   .209.610_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.09.110.11".
      03 PIC X(88) VALUE "6TH MIDDLE INSERT 1 .210.663_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.10.031.10".
      03 PIC X(88) VALUE "6TH MIDDLE INSERT 2 .211.666_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.10.046.00".
      03 PIC X(88) VALUE "6TH MIDDLE INSERT 3 .212.666_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.10.061.00".
      03 PIC X(88) VALUE "6TH DIE CASE        .213.661_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.10.110.10".
      03 PIC X(88) VALUE "6TH BUTTON DISC     .214.660_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "6TH POINTER INSERT 1.215.660_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.11.031.10".
      03 PIC X(88) VALUE "6TH POINTER INSERT 2.216.660_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.11.046.00".
      03 PIC X(88) VALUE "6TH K.O. PIN        .217.600_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.11.076.11".
      03 PIC X(88) VALUE "6TH EJECTOR PIN     .218.600_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.11.110.11".
      03 PIC X(88) VALUE "6TH BACK INSERT 1   .219.664_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.12.031.10".
      03 PIC X(88) VALUE "6TH BACK INSERT 2   .220.667_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.12.046.00".
      03 PIC X(88) VALUE "6TH BACK INSERT 3   .221.667_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.12.061.00".
      03 PIC X(88) VALUE "6TH K.O. BUTTON     .222.600_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "6TH FILLER DISC     .223.600_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_2.12.110.00".

      03 PIC X(88) VALUE "1ST PUNCH FRONT INS .058.172_2.04.030.10_2.04.030.10_2.04.030.10_2.09.030.10_2.14.030.10".
      03 PIC X(88) VALUE "1ST PUNCH FILLER    .059.170_2.04.059.11_2.04.059.11_2.04.059.11_2.09.059.11_2.14.059.11".
      03 PIC X(88) VALUE "1ST PUNCH CASE      .060.171_2.04.093.11_2.04.093.11_2.04.093.11_2.09.093.11_2.14.093.11".
      03 PIC X(88) VALUE "1ST PUNCH BACK INS  .061.174_2.05.030.10_2.05.030.10_2.05.030.10_2.10.030.10_2.15.030.10".
      03 PIC X(88) VALUE "1ST PUNCH BACKPLATE .062.170_2.05.059.10_2.05.059.10_2.05.059.10_2.10.059.10_2.15.059.10".
      03 PIC X(88) VALUE "1ST PUNCH FL BUSHING.063.170_2.05.093.10_2.05.093.10_2.05.093.10_2.10.093.10_2.15.093.10".
      03 PIC X(88) VALUE "1ST PUNCH PIN       .064.170_2.06.030.10_2.06.030.10_2.06.030.10_2.11.030.10_2.16.030.10".
      03 PIC X(88) VALUE "1ST PUNCH P.K.O. PIN.065.170_2.06.059.10_2.06.059.10_2.06.059.10_2.11.059.10_2.16.059.10".
      03 PIC X(88) VALUE "1ST PUNCH FILLER BLK.066.170_2.06.093.10_2.06.093.10_2.06.093.10_2.11.093.10_2.16.093.10".
      03 PIC X(88) VALUE "1ST PUNCH ASSEMBLY  .135.120_2.06.120.11_2.06.120.11_2.06.120.11_2.11.120.11_2.16.120.11".

      03 PIC X(88) VALUE "2ND PUNCH FRONT INS .067.272_2.08.030.10_2.08.030.10_2.08.030.10_2.13.030.10_2.18.030.10".
      03 PIC X(88) VALUE "2ND PUNCH FILLER    .068.270_2.08.059.10_2.08.059.10_2.08.059.10_2.13.059.10_2.18.059.10".
      03 PIC X(88) VALUE "2ND PUNCH CASE      .069.271_2.08.093.10_2.08.093.10_2.08.093.10_2.13.093.10_2.18.093.10".
      03 PIC X(88) VALUE "2ND PUNCH BACK INS  .070.274_2.09.030.10_2.09.030.10_2.09.030.10_2.14.030.10_2.19.030.10".
      03 PIC X(88) VALUE "2ND PUNCH BACKPLATE .071.270_2.09.059.10_2.09.059.10_2.09.059.10_2.14.059.10_2.19.059.10".
      03 PIC X(88) VALUE "2ND PUNCH FL BUSHING.072.270_2.09.093.10_2.09.093.10_2.09.093.10_2.14.093.10_2.19.093.10".
      03 PIC X(88) VALUE "2ND PUNCH PIN       .073.270_2.10.030.10_2.10.030.10_2.10.030.10_2.15.030.10_2.20.030.10".
      03 PIC X(88) VALUE "2ND PUNCH P.K.O. PIN.074.270_2.10.059.10_2.10.059.10_2.10.059.10_2.15.059.10_2.20.059.10".
      03 PIC X(88) VALUE "2ND PUNCH FILLER BLK.075.270_2.10.093.10_2.10.093.10_2.10.093.10_2.15.093.10_2.20.093.10".
      03 PIC X(88) VALUE "2ND PUNCH ASSEMBLY  .136.220_2.10.120.11_2.10.120.11_2.10.120.11_2.15.120.11_2.20.120.11".

      03 PIC X(88) VALUE "3RD PUNCH FRONT INS .076.372_2.12.030.10_2.12.030.10_2.12.030.10_2.17.030.10_3.04.030.10".
      03 PIC X(88) VALUE "3RD PUNCH FILLER    .077.370_2.12.059.10_2.12.059.10_2.12.059.10_2.17.059.10_3.04.059.10".
      03 PIC X(88) VALUE "3RD PUNCH CASE      .078.371_2.12.093.10_2.12.093.10_2.12.093.10_2.17.093.10_3.04.093.10".
      03 PIC X(88) VALUE "3RD PUNCH BACK INS  .079.374_2.13.030.10_2.13.030.10_2.13.030.10_2.18.030.10_3.05.030.10".
      03 PIC X(88) VALUE "3RD PUNCH BACKPLATE .080.370_2.13.059.10_2.13.059.10_2.13.059.10_2.18.059.10_3.05.059.10".
      03 PIC X(88) VALUE "3RD PUNCH FL BUSHING.081.370_2.13.093.10_2.13.093.10_2.13.093.10_2.18.093.10_3.05.093.10".
      03 PIC X(88) VALUE "3RD PUNCH PIN       .082.370_2.14.030.10_2.14.030.10_2.14.030.10_2.19.030.10_3.06.030.10".
      03 PIC X(88) VALUE "3RD PUNCH P.K.O. PIN.083.370_2.14.059.10_2.14.059.10_2.14.059.10_2.19.059.10_3.06.059.10".
      03 PIC X(88) VALUE "3RD PUNCH FILLER BLK.110.370_2.14.093.10_2.14.093.10_2.14.093.10_2.19.093.10_3.06.093.10".
      03 PIC X(88) VALUE "3RD PUNCH ASSEMBLY  .137.320_2.14.120.11_2.14.120.11_2.14.120.11_2.19.120.11_3.06.120.11".

      03 PIC X(88) VALUE "4TH PUNCH FRONT INS .085.472_2.16.030.10_2.16.030.10_2.16.030.10_3.04.030.10_3.08.030.10".
      03 PIC X(88) VALUE "4TH PUNCH FILLER    .086.470_2.16.059.10_2.16.059.10_2.16.059.10_3.04.059.10_3.08.059.10".
      03 PIC X(88) VALUE "4TH PUNCH CASE      .087.471_2.16.093.10_2.16.093.10_2.16.093.10_3.04.093.10_3.08.093.10".
      03 PIC X(88) VALUE "4TH PUNCH BACK INS  .088.474_2.17.030.10_2.17.030.10_2.17.030.10_3.05.030.10_3.09.030.10".
      03 PIC X(88) VALUE "4TH PUNCH BACKPLATE .089.470_2.17.059.10_2.17.059.10_2.17.059.10_3.05.059.10_3.09.059.10".
      03 PIC X(88) VALUE "4TH PUNCH FL BUSHING.090.470_2.17.093.10_2.17.093.10_2.17.093.10_3.05.093.10_3.09.093.10".
      03 PIC X(88) VALUE "4TH PUNCH PIN       .091.470_2.18.030.01_2.18.030.10_2.18.030.01_3.06.030.10_3.10.030.10".
      03 PIC X(88) VALUE "4TH PUNCH P.K.O. PIN.092.470_2.18.059.10_2.18.059.10_2.18.059.10_3.06.059.10_3.10.059.10".
      03 PIC X(88) VALUE "4TH PUNCH FILLER BLK.111.470_2.18.093.10_2.18.093.10_2.18.093.10_3.06.093.10_3.10.093.10".
      03 PIC X(88) VALUE "4TH PUNCH INS SLEEVE.112.470_2.19.030.10_2.19.030.10_2.19.030.10_3.07.030.10_0.00.000.00".
      03 PIC X(88) VALUE "4TH PUNCH FILLER PIN.113.470_2.19.059.01_2.19.059.10_2.19.059.01_3.07.059.10_0.00.000.00".
      03 PIC X(88) VALUE "4TH PUNCH SPRING    .093.470_2.19.093.10_2.19.093.10_2.19.093.10_3.07.093.10_0.00.000.00".
      03 PIC X(88) VALUE "4TH PUNCH ASSEMBLY  .138.420_2.19.120.11_2.19.120.11_2.19.120.11_3.07.120.11_3.10.120.11".

      03 PIC X(88) VALUE "5TH PUNCH FRONT INS .172.572_0.00.000.00_0.00.000.00_0.00.000.00_3.09.030.10_3.12.030.10".
      03 PIC X(88) VALUE "5TH PUNCH FILLER    .173.570_0.00.000.00_0.00.000.00_0.00.000.00_3.09.059.10_3.12.059.10".
      03 PIC X(88) VALUE "5TH PUNCH CASE      .174.571_0.00.000.00_0.00.000.00_0.00.000.00_3.09.093.10_3.12.093.10".
      03 PIC X(88) VALUE "5TH PUNCH BACK INS  .175.574_0.00.000.00_0.00.000.00_0.00.000.00_3.10.030.10_3.13.030.10".
      03 PIC X(88) VALUE "5TH PUNCH BACKPLATE .176.570_0.00.000.00_0.00.000.00_0.00.000.00_3.10.059.10_3.13.059.10".
      03 PIC X(88) VALUE "5TH PUNCH FL BUSHING.177.570_0.00.000.00_0.00.000.00_0.00.000.00_3.10.093.10_3.13.093.10".
      03 PIC X(88) VALUE "5TH PUNCH PIN       .178.570_0.00.000.00_0.00.000.00_0.00.000.00_3.11.030.10_3.14.030.10".
      03 PIC X(88) VALUE "5TH PUNCH P.K.O. PIN.179.570_0.00.000.00_0.00.000.00_0.00.000.00_3.11.059.10_3.14.059.10".
      03 PIC X(88) VALUE "5TH PUNCH FILLER BLK.180.570_0.00.000.00_0.00.000.00_0.00.000.00_3.11.093.10_3.14.093.10".
      03 PIC X(88) VALUE "5TH PUNCH INS SLEEVE.181.570_0.00.000.00_0.00.000.00_0.00.000.00_3.12.030.10_3.15.030.10".
      03 PIC X(88) VALUE "5TH PUNCH FILLER PIN.182.570_0.00.000.00_0.00.000.00_0.00.000.00_3.12.059.10_3.15.059.10".
      03 PIC X(88) VALUE "5TH PUNCH SPRING    .183.570_0.00.000.00_0.00.000.00_0.00.000.00_3.12.093.10_3.15.093.10".
      03 PIC X(88) VALUE "5TH PUNCH ASSEMBLY  .184.520_0.00.000.00_0.00.000.00_0.00.000.00_3.12.120.11_3.15.120.11".

      03 PIC X(88) VALUE "6TH PUNCH FRONT INS .224.672_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.17.030.10".
      03 PIC X(88) VALUE "6TH PUNCH FILLER    .225.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.17.059.10".
      03 PIC X(88) VALUE "6TH PUNCH CASE      .226.671_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.17.093.10".
      03 PIC X(88) VALUE "6TH PUNCH BACK INS  .227.674_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.18.030.10".
      03 PIC X(88) VALUE "6TH PUNCH BACKPLATE .228.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.18.059.10".
      03 PIC X(88) VALUE "6TH PUNCH FL BUSHING.229.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.18.093.10".
      03 PIC X(88) VALUE "6TH PUNCH PIN       .230.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.19.030.10".
      03 PIC X(88) VALUE "6TH PUNCH P.K.O. PIN.231.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.19.059.10".
      03 PIC X(88) VALUE "6TH PUNCH FILLER BLK.232.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.19.093.10".
      03 PIC X(88) VALUE "6TH PUNCH INS SLEEVE.233.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.20.030.10".
      03 PIC X(88) VALUE "6TH PUNCH FILLER PIN.234.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.20.059.10".
      03 PIC X(88) VALUE "6TH PUNCH SPRING    .235.670_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.20.093.10".
      03 PIC X(88) VALUE "6TH PUNCH ASSEMBLY  .236.620_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_3.20.120.11".

      03 PIC X(88) VALUE "1ST TR FINGERS LEFT .100.000_2.21.028.11_2.21.028.11_2.21.028.11_3.14.028.11_4.04.028.11".
      03 PIC X(88) VALUE "1ST TR FINGERS RIGHT.101.000_2.21.043.11_2.21.043.11_2.21.043.11_3.14.043.11_4.04.043.11".
      03 PIC X(88) VALUE "2ND TR FINGERS LEFT .102.000_2.21.064.11_2.21.064.11_2.21.064.11_3.14.064.11_4.04.064.11".
      03 PIC X(88) VALUE "2ND TR FINGERS RIGHT.103.000_2.21.079.11_2.21.079.11_2.21.079.11_3.14.079.11_4.04.079.11".
      03 PIC X(88) VALUE "3RD TR FINGERS LEFT .104.000_2.22.028.11_2.22.028.11_2.22.028.11_3.15.028.11_4.04.100.11".
      03 PIC X(88) VALUE "3RD TR FINGERS RIGHT.105.000_2.22.043.11_2.22.043.11_2.22.043.11_3.15.043.11_4.04.115.11".
      03 PIC X(88) VALUE "4TH TR FINGERS LEFT .106.000_2.22.064.11_2.22.064.11_2.22.064.11_3.15.064.11_4.05.028.11".
      03 PIC X(88) VALUE "4TH TR FINGERS RIGHT.107.000_2.22.079.11_2.22.079.11_2.22.079.11_3.15.079.11_4.05.043.11".
      03 PIC X(88) VALUE "5TH TR FINGERS LEFT .185.000_0.00.000.00_0.00.000.00_0.00.000.00_3.15.100.11_4.05.064.11".
      03 PIC X(88) VALUE "5TH TR FINGERS RIGHT.186.000_0.00.000.00_0.00.000.00_0.00.000.00_3.15.115.11_4.05.079.11".
      03 PIC X(88) VALUE "6TH TR FINGERS LEFT .204.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_4.05.100.11".
      03 PIC X(88) VALUE "6TH TR FINGERS RIGHT.205.000_0.00.000.00_0.00.000.00_0.00.000.00_0.00.000.00_4.05.115.11".

      03 PIC X(88) VALUE "PTR UPPER GUIDE     .095.000_3.04.033.11_3.04.033.11_3.04.033.11_4.04.033.11_4.07.033.11".
      03 PIC X(88) VALUE "PTR REAR UPPER GUIDE.118.000_3.04.067.11_3.04.067.11_3.04.067.11_4.04.067.11_4.07.067.11".
      03 PIC X(88) VALUE "PTR PLATE           .094.000_3.04.090.11_3.04.090.11_3.04.090.11_4.04.090.11_4.07.090.11".
      03 PIC X(88) VALUE "PTR FILLER BLOCK    .096.000_3.04.120.11_3.04.120.11_3.04.120.11_4.04.120.11_4.07.120.11".
      03 PIC X(88) VALUE "PTR STATIONARY JAW  .097.000_3.05.036.11_3.05.036.11_3.05.036.11_4.05.036.11_4.08.036.11".
      03 PIC X(88) VALUE "PTR MOVABLE JAW     .098.000_3.05.066.11_3.05.066.11_3.05.066.11_4.05.066.11_4.08.066.11".
      03 PIC X(88) VALUE "PTR INJECTION FINGER.119.000_3.06.041.11_3.06.041.11_3.06.041.11_4.06.041.11_4.09.041.11".
      03 PIC X(88) VALUE "PTR HOOK FINGER     .120.000_3.06.071.11_3.06.071.11_3.06.071.11_4.06.071.11_4.09.071.11".
      03 PIC X(88) VALUE "PTR SEPARATOR PIN   .143.000_3.07.035.11_3.07.035.11_3.07.035.11_4.07.035.11_4.10.035.11".
      03 PIC X(88) VALUE "PTR PRESS PIN       .121.000_3.07.063.11_3.07.063.11_3.07.063.11_4.07.063.11_4.10.063.11".
      03 PIC X(88) VALUE "PTR PRESS PIN HOLDER.122.000_3.07.098.11_3.07.098.11_3.07.098.11_4.07.098.11_4.10.098.11".
      03 PIC X(88) VALUE "PTR PUSHER GUIDE    .123.000_3.08.034.11_3.08.034.11_3.08.034.11_4.08.034.11_4.11.034.11".
      03 PIC X(88) VALUE "PTR SEPARATOR GUIDE .099.000_3.08.068.11_3.08.068.11_3.08.068.11_4.08.068.11_4.11.068.11".
      03 PIC X(88) VALUE "PTR INS DISCHG RAIL .144.000_3.09.043.11_3.09.043.11_3.09.043.11_4.09.043.11_4.12.043.11".
      03 PIC X(88) VALUE "PTR OUT DISCHG RAIL .145.000_3.09.084.11_3.09.084.11_3.09.084.11_4.09.084.11_4.12.084.11".
      03 PIC X(88) VALUE "PTR CUTTER HOLDER 1 .146.000_3.10.035.00_3.10.035.00_3.10.035.00_4.10.035.00_4.13.035.00".
      03 PIC X(88) VALUE "PTR CUTTER HOLDER 2 .147.000_3.10.050.00_3.10.050.00_3.10.050.00_4.10.050.00_4.13.050.00".
      03 PIC X(88) VALUE "PTR CUTTER INSERT 1 .148.000_3.10.081.00_3.10.081.00_3.10.081.00_4.10.081.00_4.13.081.00".
      03 PIC X(88) VALUE "PTR CUTTER INSERT 2 .149.000_3.10.096.00_3.10.096.00_3.10.096.00_4.10.096.00_4.13.096.00".

      03 PIC X(88) VALUE "THRD INNER GUIDE TOP.150.000_0.00.000.00_3.12.037.11_0.00.000.00_4.12.037.11_4.15.037.11".
      03 PIC X(88) VALUE "THRD INNER GUIDE BTM.151.000_0.00.000.00_3.12.074.11_0.00.000.00_4.12.074.11_4.15.074.11".
      03 PIC X(88) VALUE "THRD INNER GUIDE TIP.125.000_3.12.037.11_0.00.000.00_3.12.037.11_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "THRD OUTER GUIDE TIP.124.000_3.12.071.11_3.12.108.11_3.12.071.11_4.12.108.11_4.15.108.11".
      03 PIC X(88) VALUE "THREADER INJECTOR   .126.000_3.12.107.11_0.00.000.00_3.12.107.11_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "THREADER SEPARATOR  .152.000_0.00.000.00_3.13.040.11_0.00.000.00_4.13.040.11_4.16.040.11".
      03 PIC X(88) VALUE "THRD CARRIER FINGER .153.000_0.00.000.00_3.13.073.11_0.00.000.00_4.13.073.11_4.16.073.11".
      03 PIC X(88) VALUE "THRD STARTER PUSHER .154.000_0.00.000.00_3.13.106.11_0.00.000.00_4.13.106.11_4.16.106.11".
      03 PIC X(88) VALUE "THRD DIE WEAR PLATE .197.000_0.00.000.00_0.00.000.00_0.00.000.00_4.14.043.11_4.17.043.11".
      03 PIC X(88) VALUE "THREAD DIE 1        .108.000_3.13.033.11_3.14.033.11_3.13.033.11_4.14.073.11_4.17.073.11".
      03 PIC X(88) VALUE "THREAD DIE 2        .127.000_3.13.048.01_3.14.048.01_3.13.048.01_4.14.088.01_4.17.088.01".
      03 PIC X(88) VALUE "THRD TOP DIE SPCR 1 .198.000_0.00.000.00_0.00.000.00_0.00.000.00_4.15.037.01_4.18.037.01".
      03 PIC X(88) VALUE "THRD TOP DIE SPCR 2 .199.000_0.00.000.00_0.00.000.00_0.00.000.00_4.15.052.01_4.18.052.01".
      03 PIC X(88) VALUE "THRD BTM DIE SPCR 1 .200.000_0.00.000.00_0.00.000.00_0.00.000.00_4.15.089.01_4.18.089.01".
      03 PIC X(88) VALUE "THRD BTM DIE SPCR 2 .201.000_0.00.000.00_0.00.000.00_0.00.000.00_4.15.104.01_4.18.104.01".
      03 PIC X(88) VALUE "KNURL DIE 1         .109.000_3.14.032.11_3.15.032.11_3.14.032.11_4.16.032.11_4.19.032.11".
      03 PIC X(88) VALUE "KNURL DIE 2         .132.000_3.14.047.01_3.15.047.01_3.14.047.01_4.16.047.01_4.19.047.01".
      03 PIC X(88) VALUE "KNURL DIE 3         .133.000_3.14.062.01_3.15.062.01_3.14.062.01_4.16.062.01_4.19.062.01".
      03 PIC X(88) VALUE "KNURL DIE 4         .134.000_3.14.077.01_3.15.077.01_3.14.077.01_4.16.077.01_4.19.077.01".
      03 PIC X(88) VALUE "THREAD DIE SPACER 1 .139.000_3.15.040.01_3.16.040.01_3.15.040.01_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "THREAD DIE SPACER 2 .140.000_3.15.055.01_3.16.055.01_3.15.055.01_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "KNURL DIE SPACER 1  .141.000_3.15.091.01_3.16.091.01_3.15.091.01_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "KNURL DIE SPACER 2  .142.000_3.15.106.01_3.16.106.01_3.15.106.01_0.00.000.00_0.00.000.00".
      03 PIC X(88) VALUE "TOP KNURL DIE SPCR 1.202.000_0.00.000.00_0.00.000.00_0.00.000.00_4.17.043.01_4.20.043.01".
      03 PIC X(88) VALUE "TOP KNURL DIE SPCR 2.203.000_0.00.000.00_0.00.000.00_0.00.000.00_4.17.058.01_4.20.058.01".
    02 REDEFINES TL-XTABLE. 03 TL-XTBL PIC X(88) OCCURS 236.
    02 TL-XTOOLS PIC 999 COMP-3 VALUE 236.

    02 TL-YTABLE.
      03 PIC X(40) VALUE "DRAW DIE            .001.000_1.03.012.11".
      03 PIC X(40) VALUE "FEEDROLLS           .002.000_1.03.040.10".
      03 PIC X(40) VALUE "QUILL               .003.000_1.03.064.11".
      03 PIC X(40) VALUE "CUTTER              .004.000_1.03.089.11".

      03 PIC X(40) VALUE "1ST FRONT INSERT    .013.162_1.05.027.10".
      03 PIC X(40) VALUE "1ST MIDDLE INSERT   .014.163_1.05.059.00".
      03 PIC X(40) VALUE "1ST BACK INSERT     .015.164_1.05.089.10".
      03 PIC X(40) VALUE "1ST IDLE 1          .016.100_1.06.019.10".
      03 PIC X(40) VALUE "1ST IDLE 2          .017.100_1.06.034.00".
      03 PIC X(40) VALUE "1ST MIDDLE          .018.100_1.06.059.10".
      03 PIC X(40) VALUE "1ST BACK 1          .019.100_1.06.082.10".
      03 PIC X(40) VALUE "1ST BACK 2          .020.100_1.06.097.00".
      03 PIC X(40) VALUE "1ST SLEEVE          .021.100_1.07.021.10".
      03 PIC X(40) VALUE "1ST NUT             .022.100_1.07.044.00".
      03 PIC X(40) VALUE "1ST FILLER          .023.100_1.07.069.00".
      03 PIC X(40) VALUE "1ST DIE CASE        .027.161_1.07.096.10".
      03 PIC X(40) VALUE "1ST K.O. PIN        .024.100_1.08.023.10".
      03 PIC X(40) VALUE "1ST SEGMENTS        .025.100_1.08.050.10".
      03 PIC X(40) VALUE "1ST CROSS PIN       .026.100_1.08.078.10".
      03 PIC X(40) VALUE "1ST ASSEMBLED DIE   .028.110_1.08.110.11".

      03 PIC X(40) VALUE "2ND FRONT INSERT    .029.262_1.10.027.10".
      03 PIC X(40) VALUE "2ND MIDDLE INSERT   .030.263_1.10.059.00".
      03 PIC X(40) VALUE "2ND BACK INSERT     .031.264_1.10.089.10".
      03 PIC X(40) VALUE "2ND IDLE 1          .032.200_1.11.019.10".
      03 PIC X(40) VALUE "2ND IDLE 2          .033.200_1.11.034.00".
      03 PIC X(40) VALUE "2ND POINTER         .034.200_1.11.060.00".
      03 PIC X(40) VALUE "2ND BACK 1          .035.200_1.11.082.10".
      03 PIC X(40) VALUE "2ND BACK 2          .036.200_1.11.097.00".
      03 PIC X(40) VALUE "2ND SLEEVE          .037.200_1.12.021.10".
      03 PIC X(40) VALUE "2ND NUT             .038.200_1.12.044.00".
      03 PIC X(40) VALUE "2ND FILLER          .039.200_1.12.069.00".
      03 PIC X(40) VALUE "2ND DIE CASE        .043.261_1.12.096.10".
      03 PIC X(40) VALUE "2ND K.O. PIN        .040.200_1.13.023.10".
      03 PIC X(40) VALUE "2ND SEGMENTS        .041.200_1.13.050.10".
      03 PIC X(40) VALUE "2ND CROSS PIN       .042.200_1.13.078.10".
      03 PIC X(40) VALUE "2ND ASSEMBLED DIE   .044.210_1.13.110.11".

      03 PIC X(40) VALUE "3RD FRONT INSERT    .045.362_1.15.027.10".
      03 PIC X(40) VALUE "3RD MIDDLE INSERT   .046.363_1.15.059.00".
      03 PIC X(40) VALUE "3RD BACK INSERT     .047.364_1.15.089.10".
      03 PIC X(40) VALUE "3RD IDLE 1          .048.300_1.16.019.10".
      03 PIC X(40) VALUE "3RD IDLE 2          .049.300_1.16.034.00".
      03 PIC X(40) VALUE "3RD MIDDLE          .050.300_1.16.059.10".
      03 PIC X(40) VALUE "3RD BACK 1          .051.300_1.16.082.10".
      03 PIC X(40) VALUE "3RD BACK 2          .052.300_1.16.097.00".
      03 PIC X(40) VALUE "3RD SLEEVE          .053.300_1.17.021.10".
      03 PIC X(40) VALUE "3RD NUT             .054.300_1.17.044.00".
      03 PIC X(40) VALUE "3RD FILLER          .055.300_1.17.069.00".
      03 PIC X(40) VALUE "3RD DIE CASE        .059.361_1.17.096.10".
      03 PIC X(40) VALUE "3RD K.O. PIN        .056.300_1.18.023.10".
      03 PIC X(40) VALUE "3RD SEGMENTS        .057.300_1.18.050.10".
      03 PIC X(40) VALUE "3RD CROSS PIN       .058.300_1.18.078.10".
      03 PIC X(40) VALUE "3RD ASSEMBLED DIE   .060.310_1.18.110.11".

      03 PIC X(40) VALUE "4TH FRONT INSERT    .061.462_1.20.027.00".
      03 PIC X(40) VALUE "4TH MIDDLE INSERT   .062.463_1.20.059.00".
      03 PIC X(40) VALUE "4TH BACK INSERT     .063.464_1.20.089.00".
      03 PIC X(40) VALUE "4TH IDLE 1          .064.400_1.21.019.00".
      03 PIC X(40) VALUE "4TH IDLE 2          .065.400_1.21.034.00".
      03 PIC X(40) VALUE "4TH MIDDLE          .066.400_1.21.059.00".
      03 PIC X(40) VALUE "4TH BACK 1          .067.400_1.21.082.00".
      03 PIC X(40) VALUE "4TH BACK 2          .068.400_1.21.097.00".
      03 PIC X(40) VALUE "4TH SLEEVE          .069.400_1.22.021.00".
      03 PIC X(40) VALUE "4TH NUT             .070.400_1.22.044.00".
      03 PIC X(40) VALUE "4TH FILLER          .071.400_1.22.069.00".
      03 PIC X(40) VALUE "4TH DIE CASE        .075.461_1.22.096.00".
      03 PIC X(40) VALUE "4TH K.O. PIN        .072.400_1.23.023.00".
      03 PIC X(40) VALUE "4TH SEGMENTS        .073.400_1.23.050.00".
      03 PIC X(40) VALUE "4TH CROSS PIN       .074.400_1.23.078.00".
      03 PIC X(40) VALUE "4TH ASSEMBLED DIE   .076.410_1.23.110.00".

      03 PIC X(40) VALUE "4TH STN TRIM PUNCH  .077.400_2.04.029.10".
      03 PIC X(40) VALUE "4TH STN PCH FILLER 1.078.400_2.04.054.10".
      03 PIC X(40) VALUE "4TH STN PCH FILLER 2.079.400_2.04.069.00".
      03 PIC X(40) VALUE "4TH STN SLEEVE      .080.400_2.05.025.10".
      03 PIC X(40) VALUE "4TH STN NUT         .081.400_2.05.047.00".
      03 PIC X(40) VALUE "4TH STN SL FILLER   .082.400_2.05.072.00".
      03 PIC X(40) VALUE "4TH STN K.O. PIN    .083.400_2.06.027.10".
      03 PIC X(40) VALUE "4TH STN SEGMENTS    .084.400_2.06.054.10".
      03 PIC X(40) VALUE "4TH STN CROSS PIN   .085.400_2.06.082.10".

      03 PIC X(40) VALUE "1ST PUNCH CASE      .086.171_2.08.022.10".
      03 PIC X(40) VALUE "1ST PUNCH INSERT 1  .087.172_2.08.048.10".
      03 PIC X(40) VALUE "1ST PUNCH INSERT 2  .088.175_2.08.063.00".
      03 PIC X(40) VALUE "1ST PUNCH PIN       .089.100_2.08.085.00".
      03 PIC X(40) VALUE "1ST PUNCH PLUG      .090.100_2.09.022.00".
      03 PIC X(40) VALUE "1ST PUNCH BACKPLATE .091.100_2.09.050.00".
      03 PIC X(40) VALUE "1ST PUNCH ASSEMBLY  .092.120_2.09.077.11".

      03 PIC X(40) VALUE "2ND PUNCH CASE      .093.271_2.11.022.10".
      03 PIC X(40) VALUE "2ND PUNCH INSERT 1  .094.272_2.11.048.10".
      03 PIC X(40) VALUE "2ND PUNCH INSERT 2  .095.275_2.11.063.00".
      03 PIC X(40) VALUE "2ND PUNCH PIN       .096.200_2.11.085.00".
      03 PIC X(40) VALUE "2ND PUNCH PLUG      .097.200_2.12.022.00".
      03 PIC X(40) VALUE "2ND PUNCH BACKPLATE .098.200_2.12.050.00".
      03 PIC X(40) VALUE "2ND PUNCH ASSEMBLY  .099.220_2.12.077.11".

      03 PIC X(40) VALUE "3RD PUNCH CASE      .100.371_2.14.022.10".
      03 PIC X(40) VALUE "3RD PUNCH INSERT 1  .101.372_2.14.048.10".
      03 PIC X(40) VALUE "3RD PUNCH INSERT 2  .102.375_2.14.063.00".
      03 PIC X(40) VALUE "3RD PUNCH PIN       .103.300_2.14.085.00".
      03 PIC X(40) VALUE "3RD PUNCH PLUG      .104.300_2.15.022.00".
      03 PIC X(40) VALUE "3RD PUNCH BACKPLATE .105.300_2.15.050.00".
      03 PIC X(40) VALUE "3RD PUNCH ASSEMBLY  .106.320_2.15.077.11".

      03 PIC X(40) VALUE "TRIM DIE            .107.000_2.17.031.10".
      03 PIC X(40) VALUE "TRIM DIE CASE       .108.000_2.17.054.10".
      03 PIC X(40) VALUE "TRIM DIE PIN        .109.000_2.17.076.00".
      03 PIC X(40) VALUE "TRIM DIE PLUG       .110.000_2.17.099.00".

      03 PIC X(40) VALUE "1ST TR FINGERS LEFT .005.000_2.19.028.11".
      03 PIC X(40) VALUE "1ST TR FINGERS RIGHT.006.000_2.19.043.11".
      03 PIC X(40) VALUE "2ND TR FINGERS LEFT .007.000_2.19.065.11".
      03 PIC X(40) VALUE "2ND TR FINGERS RIGHT.008.000_2.19.080.11".
      03 PIC X(40) VALUE "3RD TR FINGERS LEFT .009.000_2.20.028.11".
      03 PIC X(40) VALUE "3RD TR FINGERS RIGHT.010.000_2.20.043.11".
      03 PIC X(40) VALUE "4TH TR FINGERS LEFT .011.000_2.20.065.11".
      03 PIC X(40) VALUE "4TH TR FINGERS RIGHT.012.000_2.20.080.11".

      03 PIC X(40) VALUE "PTR UPPER GUIDE     .111.000_3.04.033.00".
      03 PIC X(40) VALUE "PTR REAR UPPER GUIDE.112.000_3.04.067.00".
      03 PIC X(40) VALUE "PTR PUSHER GUIDE    .113.000_3.05.034.00".
      03 PIC X(40) VALUE "PTR SEPARATOR GUIDE .114.000_3.05.068.00".
      03 PIC X(40) VALUE "PTR FILLER PLATE    .115.000_3.05.099.00".
      03 PIC X(40) VALUE "PTR STATIONARY JAW  .116.000_3.06.036.00".
      03 PIC X(40) VALUE "PTR MOVABLE JAW     .117.000_3.06.066.00".
      03 PIC X(40) VALUE "PTR PLATE           .118.000_3.06.090.00".
      03 PIC X(40) VALUE "PTR HOOK FINGER     .119.000_3.07.033.00".
      03 PIC X(40) VALUE "PTR INJECTOR FINGER .120.000_3.07.067.00".
      03 PIC X(40) VALUE "PTR SEPARATOR PIN   .121.000_3.07.099.00".
      03 PIC X(40) VALUE "PTR PRESS PIN       .122.000_3.08.031.00".
      03 PIC X(40) VALUE "PTR PRESS PIN HOLDER.123.000_3.08.066.00".
      03 PIC X(40) VALUE "PTR INS DISCHG RAIL .124.000_3.09.043.00".
      03 PIC X(40) VALUE "PTR OUT DISCHG RAIL .125.000_3.09.084.00".
      03 PIC X(40) VALUE "PTR CUTTER HOLDER 1 .126.000_3.10.035.00".
      03 PIC X(40) VALUE "PTR CUTTER HOLDER 2 .127.000_3.10.050.00".
      03 PIC X(40) VALUE "PTR CUTTER INSERT 1 .128.000_3.10.082.00".
      03 PIC X(40) VALUE "PTR CUTTER INSERT 2 .129.000_3.10.097.00".
      03 PIC X(40) VALUE "PTR L.H. GUIDE BLOCK.130.000_3.11.038.00".
      03 PIC X(40) VALUE "PTR R.H. GUIDE BLOCK.131.000_3.11.073.00".
      03 PIC X(40) VALUE "PTR SPRING PLATE    .132.000_3.11.104.00".

      03 PIC X(40) VALUE "THREADER GUIDE TIP  .133.000_3.13.032.10".
      03 PIC X(40) VALUE "THREADER STOPPER    .134.000_3.13.058.00".
      03 PIC X(40) VALUE "THREADER INJECTOR   .135.000_3.13.085.00".
      03 PIC X(40) VALUE "THREAD DIE 1        .136.000_3.14.034.10".
      03 PIC X(40) VALUE "THREAD DIE 2        .137.000_3.14.049.10".
    02 REDEFINES TL-YTABLE. 03 TL-YTBL PIC X(40) OCCURS 137.
    02 TL-YTOOLS PIC 999 COMP-3 VALUE 137.

    02 TL-STABLE.
      03 PIC X(40) VALUE "THREAD DIE 1        .001.000_1.04.015.11".
      03 PIC X(40) VALUE "THREAD DIE 2        .002.000_1.04.030.11".
    02 REDEFINES TL-STABLE. 03 TL-STBL PIC X(40) OCCURS 2.
    02 TL-STOOLS PIC 999 COMP-3 VALUE 2.

    02 TL-PTABLE.
      03 PIC X(40) VALUE "THREAD DIE 1        .001.000_1.04.015.11".
      03 PIC X(40) VALUE "THREAD DIE 2        .002.000_1.04.030.11".
      03 PIC X(40) VALUE "NIB TAP             .003.000_1.06.011.11".
      03 PIC X(40) VALUE "TAP SHANK           .004.000_1.06.039.11".
      03 PIC X(40) VALUE "COUPLER             .005.000_1.06.066.11".
    02 REDEFINES TL-PTABLE. 03 TL-PTBL PIC X(40) OCCURS 5.
    02 TL-PTOOLS PIC 999 COMP-3 VALUE 5.

* note 270
01  XM-FIELDS.
    02 XM-F PIC X(23000).
    02 REDEFINES XM-F.
      03 XM-F1 PIC X(63) OCCURS 228.
    02 REDEFINES XM-F.
      03 XM-F2 PIC X(132) OCCURS 171.
    02 REDEFINES XM-F.
      03 XM-F4 PIC X(132) OCCURS 120.
    02 REDEFINES XM-F.
      03 XM-F5 PIC X(63) OCCURS 228.
    02 REDEFINES XM-F.
      03 OCCURS 1000.
        04 XM-F6 PIC 99 COMP-3. 04 XM-F7 PIC 99 COMP-3. 04 XM-F8 PIC 9(6) COMP-3.

01  RANGE-FIELDS PIC X(512).
01  REDEFINES RANGE-FIELDS.
    02 DATE0 PIC 9(6) COMP-3.
    02 DATE1 PIC 9(6) COMP-3. 02 DATE2 PIC 9(6) COMP-3.
    02 MTH1 PIC 99 COMP-3. 02 MTH2 PIC 99 COMP-3.
    02 CUS1 PIC X(6). 02 CUS2 PIC X(6).
    02 PROD1 PIC X(12). 02 PROD2 PIC X(12).
    02 PART1 PIC X(12). 02 PART2 PIC X(12).
    02 BIN1 PIC X(5). 02 BIN2 PIC X(5).
    02 PBIN1 PIC X(8). 02 PBIN2 PIC X(8).
    02 CAT1 PIC 99 COMP-3. 02 CAT2 PIC 99 COMP-3.
    02 PCAT1 PIC 999 COMP-3. 02 PCAT2 PIC 999 COMP-3.
    02 MAT1 PIC X(12). 02 MAT2 PIC X(12).
    02 WIRE1 PIC 9V9(4) COMP-3. 02 WIRE2 PIC 9V9(4) COMP-3.
    02 MAC1 PIC 9(4) COMP-3. 02 MAC2 PIC 9(4) COMP-3.
    02 GROUP1 PIC 99 COMP-3. 02 GROUP2 PIC 99 COMP-3.
    02 VEN1 PIC 9(4) COMP-3. 02 VEN2 PIC 9(4) COMP-3.
    02 HEAT1 PIC X(10). 02 HEAT2 PIC X(10).
    02 PLANT1 PIC X(10). 02 PLANT2 PIC X(10).
    02 LOT1 PIC 9(7) COMP-3. 02 LOT2 PIC 9(7) COMP-3.
    02 ORD1 PIC 9(6) COMP-3. 02 ORD2 PIC 9(6) COMP-3.
    02 QUOT1 PIC 9(6) COMP-3. 02 QUOT2 PIC 9(6) COMP-3.
    02 SPEC1 PIC 999 COMP-3. 02 SPEC2 PIC 999 COMP-3.
    02 IMAC1 PIC X(4). 02 IMAC2 PIC X(4).
    02 FAM1 PIC 99 COMP-3. 02 FAM2 PIC 99 COMP-3.
    02 REP1 PIC XX. 02 REP2 PIC XX.
    02 RCV1 PIC XXX. 02 RCV2 PIC XXX.
    02 EMP1 PIC 9(4) COMP-3. 02 EMP2 PIC 9(4) COMP-3.
    02 GLAC1 PIC 9(18) COMP-3. 02 GLAC2 PIC 9(18) COMP-3.
    02 RANGE-R PIC X(240).
    02 REDEFINES RANGE-R.
      03 OCCURS 10. 04 RALP1 PIC X(12). 04 RALP2 PIC X(12).
    02 REDEFINES RANGE-R.
      03 OCCURS 10. 04 RNUM1 PIC 9(7) COMP-3. 04 RNUM2 PIC 9(7) COMP-3.
    02 REDEFINES RANGE-R.
      03 OCCURS 10. 04 RGL PIC 9(18).
01  PARAM-FIELDS PIC X(148).
01  REDEFINES PARAM-FIELDS.
    02 S-A1 PIC X(55). 02 S-A2 PIC X(55).
    02 S-S1 PIC 9 COMP-3. 02 S-S2 PIC 9 COMP-3. 02 S-S3 PIC 9 COMP-3.
    02 S-S4 PIC 9 COMP-3. 02 S-S5 PIC 9 COMP-3. 02 S-S6 PIC 9 COMP-3.
    02 S-N1 PIC S9(9) COMP-3. 02 S-N2 PIC S9(9) COMP-3.
    02 S-N3 PIC S9(9) COMP-3. 02 S-N4 PIC S9(9) COMP-3.
    02 S-D1 PIC S9(9)V99 COMP-3. 02 S-D2 PIC S9(9)V99 COMP-3.
01  BATCH-FIELDS.
    02 S-CD PIC 9(4) COMP-3. 02 S-CDL PIC 99 COMP-3. 02 S-CDB PIC 9(4) COMP-3.
    02 S-DF PIC X. 02 S-IX PIC 99 COMP-3.
    02 S-DEF-CODE PIC 9 COMP-3. 88 S-DEF VALUE 1.
    02 S-BAT-CODE PIC 9 COMP-3. 88 S-BAT VALUE 1.
    02 S-TBL OCCURS 30.
      03 S-SCD PIC 9(4) COMP-3. 03 S-PR-NUM PIC 99. 03 S-SEL-N PIC 99 COMP-3.
      03 S-TOT-IND PIC 9 COMP-3. 03 S-SUM-IND PIC 9 COMP-3.
      03 S-RANGE-FIELDS PIC X(512). 03 S-PARAM-FIELDS PIC X(148).
* note 57

01  MENU-FIELDS.
    02 MN-S PIC XXX.
    02 REDEFINES MN-S. 03 MN-S1 PIC X. 03 MN-S2 PIC 99.
    02 REDEFINES MN-S. 03 MN-N PIC 999.
    02 MN-SEL PIC X. 02 MN-OSEL PIC X.
    02 MN-OP PIC 99 COMP-3. 02 MN-FUNC PIC 99 COMP-3.
    02 MN-MTBL PIC X(24) VALUE "GSBIMECFATP------------Z".

* G: GENERAL FUNCTIONS

01  CI-FIELDS.
    02 CI-NO PIC X(6). 02 CI-IXL PIC S99 COMP-3.
* note 205.1
01  IV-FIELDS.
    02 IV-TRANS PIC XXX. 02 IV-NO PIC 9(6) COMP-3. 02 IV-PROD PIC X(12).
    02 IV-LOT PIC 9(7) COMP-3. 02 IV-FBIN PIC X(5). 02 IV-TBIN PIC X(5).
    02 IV-CARTONS PIC S9(5) COMP-3. 02 IV-QTY-PACK PIC 9(5) COMP-3.
    02 IV-WEIGHT PIC S9(5) COMP-3. 02 IV-QTY PIC S9(9) COMP-3.
    02 IV-FQTY PIC S9(9) COMP-3. 02 IV-SQTY PIC S9(9) COMP-3.
    02 IV-Q1 PIC S9(9) COMP-3. 02 IV-Q2 PIC S9(9) COMP-3.
    02 IV-CONT PIC X. 02 IV-MAC PIC 999 COMP-3. 02 IV-DATE PIC 9(6) COMP-3.
    02 IV-NUM PIC S999 COMP-3. 02 IV-KRP PIC 9 COMP-3. 02 IV-KQ PIC 9 COMP-3.
01  OR-FIELDS.
    02 OR-PREV-NO PIC 9(6). 02 OR-LINE PIC 99 COMP-3. 02 OR-NL PIC 99 COMP-3.
    02 OR-PRICE1 PIC 9(4)V999 COMP-3. 02 OR-PRICE2 PIC 9(4)V999 COMP-3.
    02 OR-OCUS PIC X(6). 02 OR-OVIA PIC 99 COMP-3. 02 OR-ODATE-REQ PIC 9(6) COMP-3.
    02 OR-QTY PIC S9(9) COMP-3. 02 OR-KSHP PIC 9 COMP-3. 02 OR-KMOD PIC 9 COMP-3.
    02 OR-IX1 PIC 9(4) COMP-3.
01  WF-FIELDS.
    02 WF-FILE PIC X(8). 02 WF-NO PIC 99. 02 WF-EXT PIC XXX. 02 WF-QUEUE PIC X(10).
01  TO-FIELDS.
    02 TO-QTY-ORD PIC S9(9) COMP-3.
01  ON-FIELDS.
    02 ON-KALL PIC 9 COMP-3.
01  BI-FIELDS.
    02 BI-PNO PIC X(12). 02 BI-PROD PIC X(12). 02 BI-OPLANT PIC X(10).
    02 BI-NUM PIC 99 COMP-3. 02 BI-KOPN PIC 9 COMP-3.
01  SF-FIELDS.
    02 SF-DF. 03 SF-DF1 PIC Z(4). 03 SF-DF2 PIC Z(6),ZZ9-.
      03 SF-DF3 PIC Z(4),ZZ9.99-. 03 SF-DF4 PIC XX. 03 SF-DF5 PIC ZZZ,ZZ9.99-.
      03 SF-DF7 PIC ZZ9. 03 SF-DF8 PIC X. 03 SF-DF9 PIC ZZZ,ZZ9.99-.
      03 SF-DF10 PIC Z(4),ZZ9-. 03 SF-DF11 PIC BB99/99/99. 03 SF-DF12 PIC Z(7)9.
      03 SF-DF13 PIC Z(8)9. 03 SF-DF14 PIC Z(6)9. 03 SF-DF15 PIC BBX(9).
01  DE-FIELDS.
    02 DE-PDATE PIC 9(6) COMP-3. 02 DE-CARTONS PIC S9(5) COMP-3.
    02 DE-QTY-PACK PIC 9(5) COMP-3. 02 DE-WEIGHT-PACK PIC 9(7) COMP-3.
    02 DE-SQTY PIC S9(9) COMP-3. 02 DE-SWEIGHT PIC S9(9) COMP-3.
    02 DE-OPT PIC X. 02 DE-IXT PIC 99 COMP-3. 02 DE-IXU PIC 999 COMP-3.
    02 DE-BNUM PIC 9(4). 02 DE-BDATE PIC 9(6) COMP-3. 02 DE-BSEQ PIC 99 COMP-3.
    02 DE-JKEY PIC X(21). 02 DE-KMOP PIC 9 COMP-3.
    02 DE-H1 PIC 99 COMP-3. 02 DE-H2 PIC 99 COMP-3. 02 DE-M1 PIC 99 COMP-3.
    02 DE-M2 PIC 99 COMP-3. 02 DE-DH PIC 99 COMP-3. 02 DE-DM PIC 99 COMP-3.
    02 DE-HTBL. 03 OCCURS 9. 04 DE-HH PIC 9 COMP-3. 04 DE-MM PIC 99 COMP-3.
    02 DE-LKEY. 03 DE-LNO PIC 9(6). 03 DE-LMAC PIC 9(4). 03 DE-LDATE PIC 9(6).
      03 DE-LSHIFT PIC 9. 03 DE-LEMP PIC 9(4).
    02 DE-LNAME PIC X(20). 02 DE-LPROD PIC X(12).
    02 DE-DF1. 03 DE-DF1A PIC ZZZ9. 03 DE-DF1B PIC X. 03 DE-DF1C PIC ZZZ9.
01  QS-FIELDS.
    02 QS-DTL PIC X.
    02 QS-MTOTALS. 03 QS-MHOURS PIC 999V99 COMP-3. 03 QS-MQTY PIC S9(9) COMP-3.
      03 QS-MWEIGHT PIC S9(9) COMP-3. 03 QS-MAWEIGHT PIC S9(9) COMP-3.
    02 QS-BTBL. 03 QS-BKT OCCURS 41.
      04 QS-BS PIC 99 COMP-3. 04 QS-BN PIC 9(4) COMP-3. 04 QS-BW PIC 9(4) COMP-3.
01  MC-FIELDS.
    02 MC-NO PIC X(6). 02 MC-OP PIC 9. 02 MC-FLD PIC 99.
01  MP-FIELDS.
    02 MP-NO PIC X(12). 02 MP-OP PIC 9. 02 MP-FLD PIC 99. 02 MP-GEN PIC X(12).
01  MB-FIELDS.
    02 MB-NO PIC X(5). 02 MB-OP PIC 9. 02 MB-FLD PIC 99.
    02 MB-FBIN. 03 MB-FP PIC XX. 03 MB-FN PIC 999.
    02 MB-TBIN. 03 MB-TP PIC XX. 03 MB-TN PIC 999.
01  MS-FIELDS.
    02 MS-OP PIC 9. 02 MS-FLD PIC 99.
    02 MS-NO. 03 MS-CUS PIC X(6). 03 MS-TO PIC 99.
01  MJ-FIELDS.
    02 MJ-NO PIC 9(4). 02 MJ-OP PIC 9. 02 MJ-FLD PIC 99.
01  MO-FIELDS.
    02 MO-SEL PIC 99 COMP-3. 02 MO-IX1 PIC S9(7) COMP-3.
    02 MO-PROD PIC X(12). 02 MO-OP PIC 9. 02 MO-KFIN PIC 9 COMP-3.
    02 MO-OPER1 PIC 999 COMP-3. 02 MO-OPER2 PIC 999 COMP-3.
    02 MO-COST PIC 9(4)V999 COMP-3. 02 MO-CMODE PIC X. 02 MO-LINE PIC 99 COMP-3.
    02 MO-SPROD PIC X(12). 02 MO-SMAC PIC 99.
    02 MO-MSG1 PIC X(30) VALUE "*** NO MACHINE/PROCESS RECORD".
01  CN-FIELDS.
    02 CN-NAME PIC X(25). 02 CN-LTH PIC 99 COMP-3. 02 CN-KFIN PIC 9 COMP-3.
01  DH-FIELDS.
    02 DH-SEL PIC 99 COMP-3. 02 DH-DATE PIC 9(6) COMP-3. 02 DH-NUM PIC 9(4) COMP-3.
    02 DH-N PIC S999 COMP-3. 02 DH-WEIGHT PIC 9(4) COMP-3. 02 DH-MAC PIC 999 COMP-3.
    02 DH-KEY PIC X(25) OCCURS 3.
01  JC-FIELDS.
    02 JC-SEL PIC 99 COMP-3. 02 JC-QTY PIC 999.
    02 JC-1.
      03 OCCURS 10.
        04 JC-CNO PIC X(6). 04 JC-CSHIP PIC 99 COMP-3. 04 JC-CQTY PIC 999 COMP-3.
      03 JC-NAME PIC X(32). 03 JC-ADD1 PIC X(32). 03 JC-ADD2 PIC X(32). 03 JC-POST PIC X(10).
      03 JC-NUM PIC 99 COMP-3. 03 JC-KMAN PIC 9 COMP-3.
      03 JC-IXT PIC 99 COMP-3. 03 JC-IXC PIC 99 COMP-3.
    02 JC-2.
      03 JC-INSP PIC XX.
    02 JC-4.
      03 JC-BIN. 04 JC-BR PIC 99. 04 JC-BL PIC X. 04 JC-BC PIC 99.
      03 JC-BR1 PIC 99 COMP-3. 03 JC-BR2 PIC 99 COMP-3.
      03 JC-BC1 PIC 99 COMP-3. 03 JC-BC2 PIC 99 COMP-3.
      03 JC-BN1 PIC 99 COMP-3. 03 JC-BN2 PIC 99 COMP-3.
      03 JC-BL1 PIC X. 03 JC-BL2 PIC X.
      03 JC-LTBL PIC X(36) VALUE "089.089.089.091.087.087.090.091.080.".
      03 REDEFINES JC-LTBL. 04 OCCURS 9. 05 JC-LSZ PIC 999. 05 PIC X.
    02 JC-5.
      03 JC-TLINE1 PIC X(35) OCCURS 3. 03 JC-TLINE2 PIC X(35) OCCURS 3.
    02 JC-6.
      03 JC-PTBL PIC X(32) VALUE "0350.AE.0650.BF.0950.CG.1250.DH.".
      03 REDEFINES JC-PTBL. 04 OCCURS 4.
        05 JC-PY PIC 9(4). 05 PIC X. 05 JC-PLVL PIC X OCCURS 2. 05 PIC X.
01  AQ-FIELDS.
    02 AQ-PROD PIC X(12).
01  UE-FIELDS.
    02 UE-DRAW PIC X(8).
01  MU-FIELDS.
    02 MU-OP PIC 9 COMP-3. 02 MU-KFIN PIC 9 COMP-3.
01  MV-FIELDS.
    02 MV-OP PIC 9 COMP-3. 02 MV-KFIN PIC 9 COMP-3.
01  JP-FIELDS.
    02 JP-MAC PIC 99 COMP-3. 02 JP-IXL PIC S99 COMP-3.
    02 JP-LND. 03 JP-LD1 PIC Z9. 03 JP-LD2 PIC X. 03 JP-LD3 PIC Z(6)9.
      03 JP-LD3A PIC BBBX. 03 JP-LD4 PIC BBBX(12). 03 JP-LD5 PIC BBX(32).
      03 JP-LD6 PIC ZZZ,ZZZ,ZZ9. 03 JP-LD7 PIC BBX(12). 03 JP-LD8 PIC ZZZ9.9.
      03 JP-LD9 PIC BBX(30). 03 JP-LD10 PIC Z(4).

* S: SHIPPING FUNCTIONS

01  LR-FIELDS.
    02 LR-R PIC S9(9) COMP-3. 02 LR-Q PIC S9(9) COMP-3.
01  LQ-FIELDS.
    02 LQ-VIA PIC 999. 02 LQ-S1 PIC 9 COMP-3. 02 LQ-S2 PIC 9 COMP-3.
    02 LQ-KF PIC 9 COMP-3. 02 LQ-KE PIC 9 COMP-3. 02 LQ-SAVNO PIC 9(8) COMP-3.
    02 LQ-CWT PIC S9(7) COMP-3. 02 LQ-PWT PIC S9(7) COMP-3.
01  LF-FIELDS.
    02 LF-PHONE PIC X(30). 02 LF-FDOCK PIC X(11).
01  LG-FIELDS.
    02 LG-KMAT PIC 9 COMP-3. 02 LG-KGM PIC 9 COMP-3. 02 LG-KAM PIC 9 COMP-3.
    02 LG-KOT PIC 9 COMP-3. 02 LG-PNUM PIC 99 COMP-3.
    02 LG-PR1 PIC 99 COMP-3. 02 LG-PR2 PIC 99 COMP-3. 02 LG-STEP PIC 9 COMP-3.
    02 LG-QTY PIC S9(9) COMP-3. 02 LG-AQTY PIC S9(9) COMP-3.
    02 LG-NQTY PIC S9(9) COMP-3. 02 LG-TQTY PIC S9(9) COMP-3.
    02 LG-IX1 PIC 99 COMP-3. 02 LG-IXP PIC 99 COMP-3.
    02 LG-IXE PIC 99 COMP-3. 02 LG-IXM PIC 99 COMP-3.
    02 LG-DATE-MIN PIC 9(6) COMP-3. 02 LG-DATE-MAX PIC 9(6) COMP-3.
    02 LG-DATE-CHK PIC 9(6) COMP-3. 02 LG-DATE-MOD PIC 9(6) COMP-3.
    02 LG-SKEY. 03 LG-SPLANT PIC X(10). 03 LG-SPROD PIC X(12).
    02 LG-DF1. 03 LG-DF1A PIC XXX. 03 LG-DF1B PIC X. 03 LG-DF1C PIC 9.
      03 LG-DF1D PIC X. 03 LG-DF1E PIC Z(4),ZZ9. 03 LG-DF1F PIC ZZ99/99/99.
    02 OCCURS 2. 03 LG-EFLD PIC X(24) OCCURS 10.
    02 LG-ONUM PIC 99 COMP-3. 02 LG-NNUM PIC 99 COMP-3.
01  LH-FIELDS.
    02 LH-SEL PIC 99 COMP-3. 02 LH-NUM PIC S999 COMP-3.
    02 LH-MODYR PIC 99 COMP-3. 02 LH-PLANT PIC X(10). 02 LH-IND PIC 9 COMP-3.
01  CD-FIELDS.
    02 CD-KFIN PIC 9 COMP-3.
01  GB-FIELDS.
    02 GB-PR1 PIC 99 COMP-3. 02 GB-PR2 PIC 99 COMP-3. 02 GB-PR3 PIC 99 COMP-3.
    02 GB-GMFL PIC X(8). 02 GB-ADFL PIC X(8).
    02 GB-GDATE PIC 9(6) COMP-3. 02 GB-NDATE PIC 9(6) COMP-3.
01  NG-FIELDS.
    02 NG-RECEIVER PIC XXX. 02 NG-ISSUER PIC X(9). 02 NG-NUM PIC 999 COMP-3.
01  FC-FIELDS.
    02 FC-OP PIC 99 COMP-3.
    02 FC-PROD PIC X(12). 02 FC-QPACK PIC 9(5) COMP-3. 02 FC-LOT PIC 9(7) COMP-3.
    02 FC-LABQTY PIC 9(4) COMP-3. 02 FC-QSER PIC 9 COMP-3. 02 FC-DATE PIC 9(6) COMP-3.
    02 FC-CUSORD PIC X(9). 02 FC-KANBANX. 03 FC-KANBAN PIC X(10) OCCURS 5.
01  FV-FIELDS.
    02 FV-KAN PIC X(8).
01  FH-FIELDS.
    02 FH-OP PIC 99 COMP-3. 02 FH-PROD PIC X(12). 02 FH-KAN-N PIC 9(5) COMP-3.
01  FQ-FIELDS.
    02 FQ-IXT PIC 99 COMP-3. 02 FQ-IXL PIC 99 COMP-3. 02 FQ-IXP PIC 99 COMP-3.
    02 FQ-KFIR PIC 9 COMP-3. 02 FQ-NUMLAB PIC 99 COMP-3.
    02 FQ-TQTY PIC 9(5) COMP-3. 02 FQ-TGROSS PIC 9(6) COMP-3.
    02 FQ-TCARTONS PIC 99 COMP-3. 02 FQ-PCARTONS PIC 99 COMP-3.
    02 FQ-PKQTY PIC 9(5) COMP-3. 02 FQ-PLQTY PIC 9(6) COMP-3.
    02 FQ-LOT PIC 9(7) COMP-3. 02 FQ-WEIGHT PIC 9(4)V99 COMP-3.
    02 FQ-CUS PIC X(6). 02 FQ-PROD PIC X(12). 02 FQ-CUSORD PIC X(9).
    02 FQ-2. 03 FQ-DOCK PIC X(8). 03 FQ-KDK PIC 9 COMP-3.
      03 OCCURS 8. 04 FQ-PN PIC X(8). 04 FQ-NC PIC 99 COMP-3.
        04 FQ-TQ PIC 9(5) COMP-3. 04 FQ-PQ PIC 9(5) COMP-3.
    02 FQ-6. 03 FQ-ENG PIC XXX. 03 FQ-PKSLIP PIC 9(6) COMP-3.
      03 FQ-WTBL OCCURS 10. 04 FQ-WPROD PIC X(12). 04 FQ-WLOT PIC 9(7) COMP-3.
        04 FQ-WENG PIC XXX. 04 FQ-WC PIC 999 COMP-3. 04 FQ-WQPK PIC 9(5) COMP-3.
        04 FQ-WQTY PIC 9(6) COMP-3.
01  LC-FIELDS.
    02 LC-DIR PIC X(10). 02 LC-DATE-MAX PIC 9(6) COMP-3.
01  KB-FIELDS.
    02 KB-GDATE PIC 9(6) COMP-3. 02 KB-NDATE PIC 9(6) COMP-3.
01  LB-FIELDS.
    02 LB-STEP PIC 9 COMP-3.
    02 LB-GDATE PIC 9(6) COMP-3. 02 LB-NDATE PIC 9(6) COMP-3.
    02 LB-ADATE PIC 9(6) COMP-3. 02 LB-BDATE PIC 9(6) COMP-3. 02 LB-LDATE PIC 9(6) COMP-3.
    02 LB-TQTY PIC S9(9) COMP-3. 02 LB-AQTY PIC S9(9) COMP-3.
01  LS-FIELDS.
    02 LS-VIA PIC 999 COMP-3. 02 LS-CUS PIC X(6). 02 LS-MAXW PIC 9(6) COMP-3.
    02 LS-TOTW PIC S9(9) COMP-3. 02 LS-ORDW PIC S9(9) COMP-3.
    02 LS-TOTN PIC 999 COMP-3. 02 LS-IX1 PIC 99 COMP-3. 02 LS-IXT PIC 99 COMP-3.
    02 LS-PORD PIC 9(6). 02 LS-PSEQ PIC 99. 02 LS-KEND PIC 9 COMP-3.
    02 LS-QTY PIC S9(7) COMP-3. 02 LS-AQTY PIC S9(7) COMP-3.
    02 LS-WEIGHT PIC S9(7) COMP-3. 02 LS-AWEIGHT PIC S9(7) COMP-3.
    02 LS-EX PIC 9 COMP-3. 02 LS-KOT PIC 9 COMP-3.
    02 LS-DF1 PIC ZZZ,ZZ9.
    02 LS-DS1. 03 LS-DS1A PIC ZZ9. 03 LS-DS1B PIC BX(7). 03 LS-DS1C PIC X(17).
      03 LS-DS1D PIC X(16). 03 LS-DS1E PIC ZZZ,ZZ9.
    02 LS-DS2. 03 LS-DS2A PIC X(6)B. 03 LS-DS2B PIC Z(5)9. 03 LS-DS2C PIC X.
      03 LS-DS2D PIC 9. 03 LS-DS2E PIC BX(22).
    02 LS-DS3. 03 LS-DS3A PIC Z(5)9. 03 LS-DS3B PIC BBX(6).
      03 LS-DS3C PIC BBX(32). 03 LS-DS3D PIC ZZ99/99/99.
      03 LS-DS3E PIC Z(5),ZZ9-. 03 LS-DS3F REDEFINES LS-DS3E PIC BBBX(7).
01  ID-FIELDS.
    02 ID-PGTOT PIC 99 COMP-3. 02 ID-LNUM PIC 99 COMP-3. 02 ID-LIN PIC 99 COMP-3.
    02 ID-KL PIC 9 COMP-3. 02 ID-KT PIC 9 COMP-3. 02 ID-KB PIC 9 COMP-3.
    02 ID-KFIR PIC 9 COMP-3. 02 ID-KGM PIC 9 COMP-3. 02 ID-KEPS PIC 9 COMP-3.
    02 ID-QTY PIC S9(9) COMP-3. 02 ID-TQTY PIC S9(9) COMP-3.
    02 ID-AQTY PIC S9(9) COMP-3. 02 ID-BQTY PIC S9(9) COMP-3.
    02 ID-PQTY PIC S9(9) COMP-3. 02 ID-BINS PIC S999 COMP-3.
    02 ID-CARTONS PIC S999 COMP-3. 02 ID-PALLETS PIC S999 COMP-3.
    02 ID-OLD PIC 9 COMP-3. 02 ID-ERR PIC 9 COMP-3.
    02 ID-MAXLN PIC 99 COMP-3 VALUE 49. 02 ID-PREC-SV PIC X(132).
    02 ID-KAN-N PIC 9(5) COMP-3.
    02 ID-MSG1 PIC X(60) VALUE "THIS PRODUCT MUST BE CHECKED FOR CONDITION PRIOR TO SHIPMENT".
    02 ID-MSG2 PIC X(39) VALUE "*** ERROR: NOTHING ALLOCATED. REQUIRED:".
    02 ID-MSG3 PIC X(41) VALUE "*** ERROR: PARTIALLY ALLOCATED. REQUIRED:".
01  IN-FIELDS.
    02 IN-BL PIC 9(7). 02 IN-INVNO PIC 9(6). 02 IN-CUS PIC X(6).
    02 IN-BIN PIC X(5). 02 IN-LOT PIC 9(7) COMP-3. 02 IN-DATE PIC 9(6) COMP-3.
    02 IN-IXA PIC 99 COMP-3. 02 IN-QTY PIC S9(7) COMP-3.
    02 IN-QTY-AL PIC S9(7) COMP-3. 02 IN-QTY-NEW PIC S9(7) COMP-3.
    02 IN-PROD PIC X(12). 02 IN-GEN PIC X(12).
    02 IN-CNUM PIC S999 COMP-3. 02 IN-CTYPE PIC 9 COMP-3. 02 IN-CDESC PIC X(7).
    02 IN-CPROD PIC X(12). 02 IN-CPRICE PIC 999V99 COMP-3. 02 IN-CWEIGHT PIC 999 COMP-3.
    02 IN-NET PIC S9(7) COMP-3. 02 IN-GROSS PIC S9(7) COMP-3.
    02 IN-TOT-NET PIC S9(7) COMP-3. 02 IN-TOT-GROSS PIC S9(7) COMP-3.
    02 IN-DF1 PIC Z(5)9. 02 IN-DF2 PIC Z(6)9-. 02 IN-DF3 PIC Z(8)9-.
    02 IN-DF4 PIC Z(6)9. 02 IN-DF5 PIC 9(7).
01  LV-FIELDS.
    02 LV-DATE PIC 9(6) COMP-3. 02 LV-MTD PIC S9(9) COMP-3. 02 LV-YTD PIC S9(9) COMP-3.
    02 LV-TOTAL PIC S9(7)V99 COMP-3. 02 LV-NONS PIC S9(7)V99 COMP-3.
    02 LV-GST PIC S9(7)V99 COMP-3. 02 LV-HST PIC S9(7)V99 COMP-3.
    02 LV-PST PIC S9(7)V99 COMP-3. 02 LV-QST PIC S9(7)V99 COMP-3.
    02 LV-FREIGHT PIC S9(5)V99 COMP-3. 02 LV-FREIGHT-OVS PIC S9(5)V99 COMP-3.
    02 LV-QTY-NUT PIC S9(7) COMP-3. 02 LV-AMT-NUT PIC S9(7)V99 COMP-3.
    02 LV-KN PIC 9 COMP-3. 02 LV-CAT-NUT PIC 99 COMP-3. 02 LV-SUR PIC 9 COMP-3.
    02 LV-SURCHARGE PIC S9(5)V99 COMP-3. 02 LV-SURTOT PIC S9(7)V99 COMP-3.
01  IR-FIELDS.
    02 IR-IXN PIC 99 COMP-3. 02 IR-LN2 PIC 99 COMP-3.
01  GS-FIELDS.
    02 GS-BL PIC 9(7). 02 GS-VEN PIC 9(4) COMP-3. 02 GS-VIA PIC 99 COMP-3.
    02 GS-NAME PIC X(36). 02 GS-ADD1 PIC X(36). 02 GS-ADD2 PIC X(24). 02 GS-POST PIC X(7).
    02 GS-KADD PIC 9 COMP-3. 02 GS-KALT PIC 9 COMP-3.
    02 GS-CARRIER PIC X(40). 02 GS-COFC PIC X(6).
    02 GS-OBUCKETS PIC S99 COMP-3. 02 GS-OWEIGHT PIC S9(5) COMP-3.
    02 GS-QTY PIC S9(9) COMP-3. 02 GS-SJKEY PIC X(30).
    02 GS-NCARTONS PIC 9(5) COMP-3. 02 GS-BCARTONS PIC 99 COMP-3.
    02 GS-NSKIDS PIC 999 COMP-3. 02 GS-BSKIDS PIC 99 COMP-3.
    02 GS-NPADS PIC 999 COMP-3. 02 GS-BPADS PIC 99 COMP-3.
    02 GS-DF1 PIC Z9-. 02 GS-DF2 PIC ZZ,ZZ9-. 02 GS-DF3 PIC ZZ,ZZZ,ZZ9.
01  GQ-FIELDS.
    02 GQ-WTOTALS. 03 GQ-WTOT PIC S9(9) COMP-3 OCCURS 3.
01  GR-FIELDS.
    02 GR-BPR PIC 99 COMP-3. 02 GR-CPR PIC 99 COMP-3. 02 GR-PPR PIC 99 COMP-3.
    02 GR-NAME PIC X(36). 02 GR-ADD1 PIC X(36). 02 GR-ADD2 PIC X(24). 02 GR-POST PIC X(7).
    02 GR-UNAME PIC X(24). 02 GR-RPSAV PIC X(48). 02 GR-NUMLIN PIC 99 COMP-3.
    02 GR-NPG PIC 99 COMP-3. 02 GR-LNP PIC 99 COMP-3.
    02 GR-LN1 PIC 99 COMP-3. 02 GR-LN2 PIC 99 COMP-3. 02 GR-LNN PIC 99 COMP-3.
    02 GR-LN PIC 99 COMP-3. 02 GR-KDUP PIC 9 COMP-3. 02 GR-PROD PIC X(12).
    02 GR-TBUCKETS PIC S999 COMP-3. 02 GR-TWEIGHT PIC S9(7) COMP-3.
    02 GR-SQTY PIC S9(7) COMP-3. 02 GR-TOTAL PIC S9(5)V99 COMP-3.
    02 GR-TARE PIC S9(5) COMP-3. 02 GR-NCARTONS PIC 9(5) COMP-3.
    02 GR-BCARTONS PIC 99 COMP-3. 02 GR-PCARTONS PIC 99V999 COMP-3.
    02 GR-NSKIDS PIC 999 COMP-3. 02 GR-BSKIDS PIC 99 COMP-3. 02 GR-PSKIDS PIC 99V999 COMP-3.
    02 GR-NPADS PIC 999 COMP-3. 02 GR-BPADS PIC 99 COMP-3. 02 GR-PPADS PIC 99V999 COMP-3.
01  GC-FIELDS.
    02 GC-IBUCKETS PIC S99 COMP-3. 02 GC-IRBUCKETS PIC S999 COMP-3.
    02 GC-IWEIGHT PIC S9(5) COMP-3. 02 GC-IPALLETS PIC S999 COMP-3.
    02 GC-ICARTONS PIC S9(5) COMP-3. 02 GC-IQTY PIC S9(7) COMP-3.
    02 GC-ITRUCK PIC 9 COMP-3. 02 GC-ILTLOAD PIC 9 COMP-3. 02 GC-IMETRO PIC 9 COMP-3.
    02 GC-BL PIC 9(7) COMP-3. 02 GC-NBL PIC 99 COMP-3.
    02 OCCURS 15. 03 GC-OBL PIC 9(7) COMP-3. 03 GC-OCL PIC 9 COMP-3.
    02 GC-SLIP PIC X(10). 02 GC-MAC PIC 9(4) COMP-3. 02 GC-DATE PIC 9(6) COMP-3.
    02 GC-QTY-PACK PIC 9(5) COMP-3. 02 GC-KR PIC 9 COMP-3.
    02 GC-ORD PIC X(8). 02 GC-PART PIC X(12).
    02 GC-DF1 PIC Z9-. 02 GC-DF2 PIC ZZ,ZZ9-. 02 GC-DF3 PIC Z(4),ZZ9-.

* I: PHYSICAL INVENTORY FUNCTIONS

01  DB-FIELDS.
    02 DB-NO PIC 9(6) COMP-3. 02 DB-DATE PIC 9(6) COMP-3.
    02 DB-WEIGHT PIC 9(9) COMP-3. 02 DB-CARTONS PIC 9(5) COMP-3.
    02 DB-QTY PIC 9(9) COMP-3. 02 DB-QTY-PACK PIC 9(5) COMP-3.
    02 DB-CODE PIC 99 COMP-3. 02 DB-LOCATION PIC 99 COMP-3.
01  HI-FIELDS.
    02 HI-T1 PIC 9(6) COMP-3. 02 HI-T2 PIC 9(6) COMP-3.
01  HU-FIELDS.
    02 HU-STEP PIC 9 COMP-3.
01  HS-FIELDS.
    02 HS-KUP PIC 9 COMP-3.
    02 HS-MTOTALS. 03 HS-MLQ PIC S9(9) COMP-3.
      03 HS-MW PIC S9(9) COMP-3. 03 HS-MQ PIC S9(9) COMP-3.
      03 HS-MDW PIC S9(9) COMP-3. 03 HS-MDQ PIC S9(9) COMP-3.
      03 HS-MSW PIC S9(9) COMP-3. 03 HS-MSQ PIC S9(9) COMP-3.
    02 HS-GTOTALS. 03 HS-GLQ PIC S9(9) COMP-3.
      03 HS-GW PIC S9(9) COMP-3. 03 HS-GQ PIC S9(9) COMP-3.
      03 HS-GDW PIC S9(9) COMP-3. 03 HS-GDQ PIC S9(9) COMP-3.
      03 HS-GSW PIC S9(9) COMP-3. 03 HS-GSQ PIC S9(9) COMP-3.
01  HV-FIELDS.
    02 HV-STEP PIC 9 COMP-3.
    02 HV-STOTALS. 03 HV-SQ PIC S9(9) COMP-3. 03 HV-SR PIC S9(9) COMP-3.
      03 HV-SW PIC S9(9) COMP-3. 03 HV-SD PIC S9(9) COMP-3.
    02 HV-GTOTALS. 03 HV-GQ PIC S9(9) COMP-3. 03 HV-GR PIC S9(9) COMP-3.
      03 HV-GW PIC S9(9) COMP-3. 03 HV-GD PIC S9(9) COMP-3.
    02 HV-XTOTALS. 03 HV-XQ PIC S9(9) COMP-3. 03 HV-XR PIC S9(9) COMP-3.
      03 HV-XW PIC S9(9) COMP-3. 03 HV-XD PIC S9(9) COMP-3.
01  HB-FIELDS.
    02 HB-RN PIC 99 COMP-3. 02 HB-IX1 PIC 99 COMP-3. 02 HB-BIN PIC X(5).
01  HD-FIELDS.
    02 HD-RN PIC 99 COMP-3. 02 HD-IX1 PIC 99 COMP-3. 02 HD-BIN PIC X(8).
01  WC-FIELDS.
    02 WC-OPROD PIC X(12). 02 WC-QTY PIC S9(9) COMP-3.

* B: Q BINS FUNCTIONS

01  QM-FIELDS.
    02 QM-OP PIC 9 COMP-3. 02 QM-KFIN PIC 9 COMP-3.
    02 QM-TBL PIC X(44) VALUE "ADD BIN   .MODIFY BIN.DELETE BIN.EMPTY BIN .".
    02 REDEFINES QM-TBL. 03 OCCURS 4. 04 QM-DES PIC X(10). 04 PIC X.

* P: PURCHASING AND ACCOUNTS PAYABLE FUNCTIONS

01  PM-FIELDS.
    02 PM-NO PIC X(12). 02 PM-OP PIC 9. 02 PM-FLD PIC 99.
    02 PM-S PIC 99. 02 PM-SMAX PIC 99. 02 PM-LTH PIC 99 COMP-3.
01  BM-FIELDS.
    02 BM-NO PIC X(8). 02 BM-OP PIC 9. 02 BM-FLD PIC 99.
01  PB-FIELDS.
    02 PB-KFIN PIC 9 COMP-3. 02 PB-KQ PIC 9 COMP-3.
01  SU-FIELDS.
    02 SU-DATE PIC 9(6) COMP-3. 02 SU-BDATE PIC 9(6) COMP-3. 02 SU-TRANS PIC XXX.
    02 SU-PART PIC X(12). 02 SU-OMO PIC 9(6) COMP-3. 02 SU-MO PIC 9(6) COMP-3.
    02 SU-QTY PIC S9(9) COMP-3. 02 SU-FBIN PIC X(8). 02 SU-TBIN PIC X(8).
    02 SU-PO PIC X(10). 02 SU-PCODE PIC 9 COMP-3. 02 SU-COILS PIC S999 COMP-3.
    02 SU-CWEIGHT PIC 9(5) COMP-3. 02 SU-HEAT PIC X(10). 02 SU-KADD PIC 9 COMP-3.
01  OM-FIELDS.
    02 OM-LINE PIC 99 COMP-3. 02 OM-PF PIC 9 COMP-3. 02 OM-KNF PIC 9 COMP-3.
    02 OM-TOTAL PIC S9(7)V99 COMP-3. 02 OM-PQTY PIC S9(7) COMP-3.
    02 OM-ODATE-REQ PIC 9(6) COMP-3. 02 OM-KMOD PIC 9 COMP-3.
    02 OM-AF1 PIC S9(7) COMP-3. 02 OM-AF2 PIC S9(9) COMP-3.
    02 OM-AF3 PIC S9(7)V99 COMP-3.
01  OS-FIELDS.
    02 OS-KALL PIC 9 COMP-3.
01  PP-FIELDS.
    02 PP-ORD1 PIC X(8). 02 PP-ORD2 PIC X(8). 02 PP-KIT PIC 9 COMP-3.
01  CV-FIELDS.
    02 CV-NUM PIC X(24). 02 CV-LTH PIC 99 COMP-3. 02 CV-KFIN PIC 9 COMP-3.
01  OB-FIELDS.
    02 OB-IXN PIC 9(4) COMP-3. 02 OB-KFIN PIC 9 COMP-3. 02 OB-DAYS PIC 9 COMP-3.
    02 OB-CL-REQ PIC S999V9 COMP-3. 02 OB-CL-IREQ PIC S999 COMP-3.
    02 OB-CL-TOT PIC S999V9 COMP-3. 02 OB-CL-USED PIC S999V9 COMP-3.
    02 OB-CL-ISS PIC S999 COMP-3.
    02 OB-QTY-PROD PIC S9(9) COMP-3. 02 OB-RATE PIC S9(5) COMP-3.
    02 OB-HOURS PIC S999 COMP-3. 02 OB-MAC-HOURS PIC S999 COMP-3.
01  OC-FIELDS.
    02 OC-TCOILS PIC S999 COMP-3. 02 OC-TPAGE PIC 99 COMP-3.
    02 OC-PAGE PIC 99 COMP-3. 02 OC-KFIR PIC 9 COMP-3. 02 OC-MAC PIC 99 COMP-3.
    02 OC-PROWS PIC 99 COMP-3. 02 OC-ROWS PIC 99 COMP-3.
    02 OC-CTOT PIC S999 COMP-3. 02 OC-WTOT PIC S9(9) COMP-3.
    02 OC-KEY PIC X(30). 02 OC-KM PIC X(30). 02 OC-KP PIC X(30).
    02 OC-YLINE PIC 9(4) COMP-3. 02 OC-YTEXT PIC 9(4) COMP-3.
    02 OC-DF1. 03 OC-DF1A PIC Z9. 03 OC-DF1B PIC BXXB. 03 OC-DF1C PIC 9.
    02 OC-DF2 PIC BX(20). 02 OC-DF3. 03 OC-DF3A PIC 99V9.
    02 OC-DF4. 03 OC-DF4A PIC BBX. 03 OC-DF4B PIC 9. 02 OC-DF5 PIC Z(4),ZZ9.
    02 OC-DF6 PIC Z99/99/99.
01  SI-FIELDS.
    02 SI-PREFIX PIC X(5). 02 SI-PLTH PIC 9 COMP-3. 02 SI-TOT PIC S9(9) COMP-3.
01  BP-FIELDS.
    02 BP-NO PIC X(8). 02 BP-LINE PIC 99 COMP-3. 02 BP-NLINE PIC 99 COMP-3.
    02 BP-KNF PIC 9 COMP-3. 02 BP-AF1 PIC 9(7) COMP-3. 02 BP-AF2 PIC 9(7)V99 COMP-3.
01  VM-FIELDS.
    02 VM-NO PIC 9(4). 02 VM-OP PIC 9. 02 VM-FLD PIC 99.
01  AG-FIELDS.
    02 AG-IXE PIC 99 COMP-3.
    02 AG-IFA. 03 AG-IFN PIC 9(6). 02 AG-MNTORD PIC 9(6) COMP-3 OCCURS 10.
01  IG-FIELDS.
    02 IG-VEN PIC 9(4) COMP-3. 02 IG-FOB PIC X(15). 02 IG-US PIC 9 COMP-3.
    02 IG-QTY PIC S9(9) COMP-3. 02 IG-WQTY PIC S9(9) COMP-3.
    02 IG-QTY-SV PIC S9(9) COMP-3. 02 IG-IXE PIC 99 COMP-3. 02 IG-IXR PIC 99 COMP-3.
    02 IG-ORD PIC X(8) OCCURS 23. 02 IG-NORD PIC 99 COMP-3.
    02 IG-LK-KEY PIC X(10). 02 IG-LK-PART PIC X(12). 02 IG-LK-LINE PIC 99 COMP-3.
    02 IG-LK-QTY-LAST PIC S9(7)V999 COMP-3. 02 IG-LK-TOTAL-LAST PIC S9(7)V99 COMP-3.
    02 IG-COR PIC 9 COMP-3. 02 IG-NUMLN PIC 99 COMP-3. 02 IG-LNO PIC 99 COMP-3.
    02 IG-PSTPAY PIC 9 COMP-3. 02 IG-LDCOST PIC 9(6)V999 COMP-3.
    02 IG-AMT PIC S9(9)V99 COMP-3. 02 IG-LDAMT PIC S9(9)V99 COMP-3.
    02 IG-BIN-FIELDS.
      03 IG-TRANS PIC XXX. 03 IG-PCODE PIC 9 COMP-3. 03 IG-PART PIC X(12).
      03 IG-FBIN PIC X(8). 03 IG-TBIN PIC X(8). 03 IG-PO PIC X(10).
      03 IG-BQTY PIC 9(9) COMP-3. 03 IG-COILS PIC 999 COMP-3.
      03 IG-CWEIGHT PIC 9(5) COMP-3. 03 IG-HEAT PIC X(10).
01  DC-FIELDS.
    02 DC-AMT PIC S9(7)V99 COMP-3.
01  OV-FIELDS.
    02 OV-KALL PIC 9 COMP-3.
01  VT-FIELDS.
    02 VT-TOTALS. 03 OCCURS 2. 04 VT-TOT PIC S9(9)V99 COMP-3 OCCURS 2.
01  PQ-FIELDS.
    02 PQ-KFIN PIC 9 COMP-3.
01  VN-FIELDS.
    02 VN-NAME PIC X(25). 02 VN-LTH PIC 99 COMP-3. 02 VN-KFIN PIC 9 COMP-3.
01  WG-FIELDS.
    02 WG-KBM PIC 9 COMP-3. 02 WG-AMT PIC S9(7)V99 COMP-3.
    02 WG-NAM PIC X(8). 02 WG-ACC PIC 9(13).
    02 WG-CNUM PIC 9(5) COMP-3. 02 WG-CTOT PIC 9(7)V99 COMP-3.
01  DN-FIELDS.
    02 DN-KFIN PIC 9 COMP-3. 02 DN-NET PIC S9(7)V99 COMP-3.
* note 272.1
01  LZ-FIELDS.
    02 LZ-WEIGHT PIC S9(7) COMP-3.
01  RE-FIELDS.
    02 RE-OP PIC 9 COMP-3. 02 RE-KFIN PIC 9 COMP-3. 02 RE-DAYS PIC S99 COMP-3.
    02 RE-LN1. 03 OCCURS 5.
      04 RE-DF1 PIC B(5)X(5). 04 RE-DF2 PIC X. 04 RE-DF3 PIC Z(4)9.

* T: TOOLS FUNCTIONS

01  EP-FIELDS.
    02 EP-OP PIC 9 COMP-3. 02 EP-KTS PIC 9 COMP-3. 02 EP-KTY PIC 9 COMP-3.
    02 EP-PROD PIC X(12). 02 EP-MAC PIC 99 COMP-3. 02 EP-ID PIC X.
    02 EP-IXT PIC 99 COMP-3. 02 EP-MESG PIC X(20).
01  EO-FIELDS.
    02 EO-PROD PIC X(12). 02 EO-LTH PIC 99 COMP-3.
01  TW-FIELDS.
    02 TW-PLNUM PIC X(8). 02 TW-NOTE PIC X(60) OCCURS 3.
01  UD-FIELDS.
    02 UD-STEP PIC 9 COMP-3. 02 UD-DRAW PIC X(8). 02 UD-PG PIC 9.
    02 UD-NLINES PIC 9(4). 02 UD-KH PIC 9 COMP-3.
01  FW-FIELDS.
    02 FW-NOTE PIC X(70) OCCURS 2.
01  GH-FIELDS.
    02 GH-CAT PIC 9 COMP-3. 02 GH-STN PIC 9 COMP-3. 02 GH-IXF PIC 999 COMP-3.
    02 GH-BTOT PIC 999 COMP-3. 02 GH-KFIR PIC 9 COMP-3. 02 GH-KSRT PIC 9 COMP-3.
    02 GH-PART PIC X(12). 02 GH-DESC1 PIC X(32). 02 GH-DESC2 PIC X(32).
01  QH-FIELDS.
    02 QH-RN PIC 99 COMP-3. 02 QH-IXN PIC 9(4) COMP-3. 02 QH-YPOS PIC 9(4) COMP-3.
    02 QH-MAC PIC 99 COMP-3. 02 QH-MAT PIC X(15). 02 QH-DRAW PIC X(12).
    02 QH-CNUM PIC 99 COMP-3.
01  TE-FIELDS.
    02 TE-SEL PIC 99 COMP-3. 02 TE-NUM PIC 9(5) COMP-3. 02 TE-IXD PIC S999 COMP-3.
    02 TE-PART1 PIC X(12). 02 TE-PART2 PIC X(12). 02 TE-KMOD PIC 9 COMP-3.
    02 TE-NSUFFIX PIC 999. 02 TE-N1 PIC 999. 02 TE-N2 PIC 999.
    02 TE-LSUFFIX PIC 99 COMP-3. 02 TE-L1 PIC 99 COMP-3. 02 TE-L2 PIC 99 COMP-3.
    02 TE-MAC PIC 99.
    02 TE-2.
      03 TE-PREFIX PIC XX.
    02 TE-3.
      03 TE-PARTX PIC X(10). 03 TE-LTH PIC 99 COMP-3. 03 TE-FLD PIC 99 COMP-3.
      03 TE-DRAW PIC X(12). 03 TE-REV PIC X. 03 TE-DESC1 PIC X(32).
      03 TE-CAT PIC 999 COMP-3. 03 TE-LIFE PIC 9(6) COMP-3. 03 TE-EOQ PIC 9(5) COMP-3.
      03 TE-MTYPE PIC 99 COMP-3. 03 TE-VENDOR-1 PIC 9(4) COMP-3.
      03 TE-PRICE-1 PIC 9(6)V999 COMP-3. 03 TE-ROP PIC S9(7) COMP-3.
      03 TE-LEVEL PIC 9 COMP-3.
    02 TE-4.
      03 TE-T1 PIC 999 COMP-3. 03 TE-T2 PIC 999 COMP-3.
    02 TE-7.
      03 TE-CHAR PIC X.
01  TA-FIELDS.
    02 TA-KFIN PIC 9 COMP-3. 02 TA-PROD PIC X(12). 02 TA-MAC PIC 99.
01  TN-FIELDS.
    02 TN-IMO PIC 9(6). 02 TN-MO1 PIC 9(6). 02 TN-MO2 PIC 9(6).
    02 TN-PROD1 PIC X(12). 02 TN-PROD2 PIC X(12).
    02 TN-PDESC1 PIC X(32). 02 TN-PDESC2 PIC X(32).
    02 TN-MAC1 PIC 99. 02 TN-MAC2 PIC 99. 02 TN-MTYPE PIC 99 COMP-3.
    02 TN-MDESC1 PIC X(30). 02 TN-MDESC2 PIC X(30).
    02 TN-COL PIC 9 COMP-3. 02 TN-ROW PIC 99 COMP-3. 02 TN-LAST PIC 999 COMP-3.
    02 TN-PAGE PIC S99 COMP-3. 02 TN-NPAGE PIC S99 COMP-3. 02 TN-NFLD PIC S999 COMP-3.
    02 TN-ALINES PIC 9 COMP-3. 02 TN-BTOT PIC 999 COMP-3. 02 TN-KFIR PIC 9 COMP-3.
    02 TN-IXP PIC 999 COMP-3.
* note 121
    02 TN-DF. 03 TN-DF1 PIC X(20). 03 TN-DF2 PIC BBX(12). 03 TN-DF3 PIC BX(14).
      03 TN-DF4 PIC BX(6). 03 TN-DF5 PIC Z(4)9. 03 TN-DF6 PIC B9.
    02 TN-HD PIC X(63) VALUE "TOOLS REQUIRED        TOOL M #     TOOL DWG #     LOCTN  IN STK".
01  TM-FIELDS.
    02 TM-OP PIC 9 COMP-3. 02 TM-KFIN PIC 9 COMP-3. 02 TM-DESC PIC X(32).
    02 TM-PROD PIC X(12). 02 TM-IXM PIC 99 COMP-3.
    02 TM-ROW PIC 99 COMP-3. 02 TM-KR PIC 9 COMP-3.
    02 TM-MSTR. 03 TM-MNO PIC ZZ9 OCCURS 5.
    02 TM-SPROD PIC X(12). 02 TM-SMAC PIC 99.
01  TQ-FIELDS.
    02 TQ-IMO PIC 9(6). 02 TQ-IPROD PIC X(12).
    02 TQ-MO PIC 9(6). 02 TQ-PROD PIC X(12). 02 TQ-MAC PIC 99.
    02 TQ-PDESC PIC X(32). 02 TQ-MDESC PIC X(30).
    02 TQ-COL PIC 9 COMP-3. 02 TQ-ROW PIC 99 COMP-3. 02 TQ-LAST PIC 999 COMP-3.
    02 TQ-PAGE PIC S99 COMP-3. 02 TQ-NPAGE PIC S99 COMP-3. 02 TQ-NFLD PIC S999 COMP-3.
    02 TQ-ALINES PIC 9 COMP-3. 02 TQ-BTOT PIC 999 COMP-3. 02 TQ-KFIR PIC 9 COMP-3.
    02 TQ-IXP PIC 999 COMP-3. 02 TQ-PA. 03 TQ-PN PIC 9.
* note 123
    02 TQ-DF. 03 TQ-DF1 PIC X(20). 03 TQ-DF2 PIC BBX(12). 03 TQ-DF3 PIC BX(14).
      03 TQ-DF4 PIC BX(6). 03 TQ-DF5 PIC Z(4)9. 03 TQ-DF6 PIC B9.
    02 REDEFINES TQ-DF. 03 PIC X(35). 03 TQ-DF11 PIC X(28).
    02 TQ-HD PIC X(63) VALUE "TOOLS REQUIRED        TOOL M #     TOOL DWG #     LOCTN  IN STK".
    02 TQ-HEADLN PIC X(69) VALUE "product`mac`tool description`tool M #`tool dwg #`location`in stk`bins".
01  FS-FIELDS.
    02 FS-KFIR PIC 9 COMP-3. 02 FS-NUM PIC S999 COMP-3. 02 FS-BTOT PIC 999 COMP-3.
    02 FS-DF. 03 FS-DF1 PIC X(20). 03 FS-DF2 PIC BBX(12). 03 FS-DF3 PIC BX(14).
      03 FS-DF4 PIC BX(6). 03 FS-DF5 PIC Z(4)9. 03 FS-DF6 PIC B9.
      03 FS-DF7 PIC Z(6)9. 03 FS-DF8 PIC BBX(8).
01  TJ-FIELDS.
    02 TJ-IMO PIC 9(6). 02 TJ-IPROD PIC X(12). 02 TJ-MIN PIC S9(5) COMP-3.
    02 TJ-MO PIC 9(6). 02 TJ-PROD PIC X(12). 02 TJ-MAC PIC 99.
    02 TJ-PDESC PIC X(32). 02 TJ-MDESC PIC X(30). 02 TJ-LAST PIC 999 COMP-3.
    02 TJ-PAGE PIC S99 COMP-3. 02 TJ-NPAGE PIC S99 COMP-3. 02 TJ-NLINE PIC S999 COMP-3.
    02 TJ-IXP PIC 999 COMP-3. 02 TJ-PA. 03 TJ-PN PIC 9.
* note 125
    02 TJ-DF. 03 TJ-DF1 PIC X(20). 03 TJ-DF2 PIC BBX(12). 03 TJ-DF3 PIC BX(14).
      03 TJ-DF4 PIC Z(8)9-. 03 TJ-DF5 PIC Z(6)9-. 03 TJ-DF6 PIC BBX(8).
      03 TJ-DF7 PIC ZZZ9. 03 TJ-DF8 PIC ZZ99/99/99. 03 TJ-DF9 PIC Z(5)9.
      03 TJ-DF10 PIC BX(34).
    02 REDEFINES TJ-DF. 03 PIC X(35). 03 TJ-DF11 PIC X(24).
01  DQ-FIELDS.
    02 DQ-DRAW PIC X(12). 02 DQ-LTH PIC 99 COMP-3.

* M: METALLURGICAL TEST, QA, AND PACKING LABELS FUNCTIONS

01  HM-FIELDS.
    02 HM-HEAT PIC X(10). 02 HM-OP PIC 9 COMP-3. 02 HM-FLD PIC 99 COMP-3.
01  HQ-FIELDS.
    02 HQ-HEAT PIC X(10).
01  IS-FIELDS.
    02 IS-LOT PIC 9(7) COMP-3. 02 IS-OP PIC 9 COMP-3. 02 IS-FLD PIC 99 COMP-3.
    02 IS-SLOT PIC 9(7) COMP-3. 02 IS-MAC PIC 999 COMP-3. 02 IS-KREW PIC 9 COMP-3.
    02 IS-SQTY PIC S9(9) COMP-3. 02 IS-SWEIGHT PIC S9(9) COMP-3.
    02 IS-MTBL PIC X(45) VALUE "20.10.10.10.20.35.10.10.10.10.10.10.10.10.00.".
    02 REDEFINES IS-MTBL. 03 OCCURS 15. 04 IS-MSZ PIC 99. 04 PIC X.
01  IL-FIELDS.
    02 IL-LOT PIC 9(7) COMP-3.
01  CE-FIELDS.
    02 CE-LOT PIC 9(7) COMP-3. 02 CE-PROD PIC X(12). 02 CE-TQTY PIC S9(5) COMP-3.
    02 CE-TDS. 03 CE-TS1 PIC 99/99/99. 03 CE-TS2 PIC BX(8). 03 CE-TS3 PIC BBX.
      03 CE-TS4 PIC Z(6)9. 03 CE-TS5 PIC BBX(12). 03 CE-TS6 PIC Z(5)9.
      03 CE-TS7 PIC B(5)X(12). 03 CE-TS8 PIC BX.
01  CQ-FIELDS.
    02 CQ-LOT PIC 9(7).
01  UL-FIELDS.
    02 UL-OP PIC 9 COMP-3.
01  JE-FIELDS.
    02 JE-SEL PIC 99 COMP-3. 02 JE-NUM PIC 9(5) COMP-3. 02 JE-IXC PIC 999 COMP-3.
    02 JE-FROW PIC 99 COMP-3.
    02 JE-PRINT PIC 9(6) COMP-3. 02 JE-PRINT-REV PIC XX.
    02 JE-OSPEC PIC X(20). 02 JE-NSPEC PIC X(20).
    02 JE-ODESC PIC X(32). 02 JE-NDESC PIC X(32).
01  QK-FIELDS.
    02 QK-INV PIC 9(6). 02 QK-KFIR PIC 9 COMP-3.
01  BG-FIELDS.
    02 BG-PRINT PIC 9(6) COMP-3. 02 BG-KFIN PIC 9 COMP-3.
01  SB-FIELDS.
    02 SB-RN PIC 99 COMP-3. 02 SB-IXN PIC 9(4) COMP-3. 02 SB-YPOS PIC 9(4) COMP-3.
    02 SB-MAT PIC X(15). 02 SB-DRAW PIC X(12).
01  VA-FIELDS.
    02 VA-PROD PIC X(12). 02 VA-FUNC PIC 9 COMP-3. 02 VA-PID PIC X(7).
    02 VA-PVAL OCCURS 28. 03 PIC 999 COMP-3. 03 PIC 99V9(4) COMP-3. 03 PIC 99V9(4) COMP-3.
    02 VA-PCHAR PIC 999 COMP-3.
01  VW-FIELDS.
    02 VW-STEP PIC 9 COMP-3.
01  VJ-FIELDS.
    02 VJ-PROD PIC X(12).
01  VC-FIELDS.
    02 VC-PROD PIC X(12). 02 VC-HMIN PIC 9(6) COMP-3. 02 VC-HMAX PIC 9(6) COMP-3.
01  OT-FIELDS.
    02 OT-SEL PIC 99 COMP-3. 02 OT-KAS PIC 9 COMP-3. 02 OT-TNUM PIC S999 COMP-3.
    02 OT-QTY PIC S9(9) COMP-3. 02 OT-WEIGHT PIC S9(9) COMP-3.
    02 OT-TQTY PIC S9(9) COMP-3. 02 OT-TWEIGHT PIC S9(9) COMP-3.
    02 OT-MO PIC 9(4) COMP-3 OCCURS 20. 02 OT-NM PIC S99 COMP-3.
01  VD-FIELDS.
    02 VD-CODE PIC 9 COMP-3. 02 VD-Q PIC X. 02 VD-QR PIC XX. 02 VD-LOT PIC 9(7).
01  VF-FIELDS.
    02 VF-PROD PIC X(12).
01  IT-FIELDS.
    02 IT-RN PIC 999 COMP-3. 02 IT-IX1 PIC 999 COMP-3.
    02 IT-KB PIC 9 COMP-3. 02 IT-KP PIC 9 COMP-3.
01  MR-FIELDS.
    02 MR-LN PIC 99 COMP-3. 02 MR-QTY PIC S9(7) COMP-3.
01  PS-FIELDS.
    02 PS-YLOT1 PIC 9(11) COMP-3. 02 PS-YLOT2 PIC 9(11) COMP-3.
    02 PS-YLOT PIC 9(11) COMP-3.
01  DA-FIELDS.
    02 DA-CODE PIC 9 COMP-3.
    02 DA-DESC PIC X(32). 02 DA-PRINT PIC 9(4). 02 DA-ROP PIC 9(9) COMP-3.
    02 DA-DESC1 PIC X(20). 02 DA-DESC2 PIC X(20).
    02 DA-LTH1 PIC 99 COMP-3. 02 DA-LTH2 PIC 99 COMP-3.
    02 DA-AWIRE1 PIC X(6). 02 DA-AWIRE2 PIC X(6).
01  VG-FIELDS.
    02 VG-SEL PIC 9 COMP-3. 02 VG-PM PIC XXX.
01  VS-FIELDS.
    02 VS-PROD PIC X(12). 02 VS-KMOD PIC 9 COMP-3. 02 VS-NUM PIC S9(5) COMP-3.
    02 VS-GRADE PIC X(8). 02 VS-WIRE PIC 9V9(4) COMP-3. 02 VS-SPEC PIC X(20).
    02 OCCURS 18. 03 VS-HMIN PIC 9(6) COMP-3. 03 VS-HMAX PIC 9(6) COMP-3.
01  UQ-FIELDS.
    02 UQ-LOT PIC 9(7) COMP-3.
01  VY-FIELDS.
    02 VY-HEADLN.
      03 PIC X(80) VALUE "part no.`description`extended descr 1`extended descr 2`finish descr`print descr`".
      03 PIC X(44) VALUE "print no. and rev`plt spec code`plating spec".

* E: EDI FUNCTIONS

01  CW-FIELDS.
    02 CW-DT1 PIC 9(6) COMP-3. 02 CW-DT2 PIC 9(6) COMP-3.
    02 CW-L1 PIC S999 COMP-3. 02 CW-L2 PIC S999 COMP-3. 02 CW-YPOS PIC 9(4) COMP-3.
    02 CW-N PIC S999 COMP-3. 02 CW-IXN PIC S999 COMP-3.
    02 CW-NP PIC S999 COMP-3. 02 CW-NR PIC S999 COMP-3.
01  CB-FIELDS.
    02 CB-UNAME PIC X(24). 02 CB-NPG PIC 99 COMP-3. 02 CB-LNP PIC 99 COMP-3.
    02 CB-LN1 PIC 99 COMP-3. 02 CB-LN2 PIC 99 COMP-3. 02 CB-LNN PIC 99 COMP-3.
    02 CB-IX1 PIC S999 COMP-3. 02 CB-IX2 PIC S999 COMP-3.
01  UC-FIELDS.
    02 UC-OP PIC 99 COMP-3. 02 UC-XIND. 03 UC-IND PIC 9 COMP-3 OCCURS 15.
01  CC-FIELDS.
    02 CC-LNUM PIC 99. 02 CC-PNUM PIC 99. 02 CC-RC PIC X(8).
    02 CC-RCQTY PIC 9(4) COMP-3. 02 CC-RCQTY-CUM PIC 9(6) COMP-3.
    02 CC-PROD PIC X(8). 02 CC-QUAL PIC XX.
01  IC-FIELDS.
    02 IC-KSPO PIC 9 COMP-3. 02 IC-KSAT PIC 9 COMP-3. 02 IC-KSATSRV PIC 9 COMP-3.
    02 IC-KSHAN PIC 9 COMP-3. 02 IC-KMEX PIC 9 COMP-3.
    02 IC-QUAL PIC XX. 02 IC-IXC PIC S99 COMP-3. 02 IC-SERIAL PIC 9(8) COMP-3.
    02 IC-LNUM PIC 999 COMP-3. 02 IC-CARTONS PIC 9(5) COMP-3. 02 IC-PROD PIC X(8).
01  UA-FIELDS.
    02 UA-OP PIC 99 COMP-3.
01  AC-FIELDS.
    02 AC-OP PIC 99 COMP-3. 02 AC-KFIN PIC 9 COMP-3. 02 AC-STEP PIC 9 COMP-3.
    02 AC-SCHEDULE PIC XX. 02 AC-BSS PIC X(60). 02 AC-NOTE PIC X(60).
    02 AC-N-SI PIC X(10). 02 AC-N-ST PIC X(10).
    02 AC-LF PIC X(10). 02 AC-DOCK PIC X(8). 02 AC-DXNO PIC 9(4) COMP-3.
    02 AC-CUM-ATH PIC S9(9) COMP-3. 02 AC-CUM PIC S9(9) COMP-3.
    02 AC-IXL PIC S99 COMP-3. 02 AC-IXI PIC S99 COMP-3. 02 AC-IXF PIC S99 COMP-3.
    02 AC-TEXT PIC X(60) OCCURS 3. 02 AC-IXN PIC S99 COMP-3.
    02 AC-LIN. 03 OCCURS 5. 04 AC-LCODE PIC XX. 04 AC-LVAL PIC X(10).
    02 AC-INFO. 03 AC-IFLINE PIC X(40) OCCURS 16.
    02 AC-FST. 03 OCCURS 30.
      04 AC-FQTY PIC S9(7) COMP-3. 04 AC-FDATE PIC 9(6) COMP-3.
      04 AC-FQUAL PIC XXX. 04 AC-FTIME PIC 9(4) COMP-3. 04 AC-FRD PIC 9 COMP-3.
01  IP-FIELDS.
    02 IP-OP PIC 99 COMP-3. 02 IP-STEP PIC 9 COMP-3. 02 IP-FIN PIC 9 COMP-3.
    02 IP-QUAL PIC XX. 02 IP-RELNO PIC X(20). 02 IP-KSHAN PIC 9 COMP-3.
    02 IP-MI PIC 99 COMP-3.
      88 IP-SAT VALUE 1. 88 IP-DELP VALUE 2. 88 IP-GMC VALUE 3. 88 IP-AMAX VALUE 4.
    02 IP-SCHEDULE PIC XX. 02 IP-SCHEDNO PIC X(5). 02 IP-FUNCTION PIC XX.
    02 IP-DOC-DATE PIC 9(6) COMP-3. 02 IP-DOC-HDATE PIC 9(6) COMP-3 OCCURS 2.
    02 IP-SHD-CUM PIC S9(9) COMP-3. 02 IP-SHD-DATE PIC 9(6) COMP-3 OCCURS 2.
    02 IP-SHP-CUM PIC S9(9) COMP-3. 02 IP-SHP-DATE PIC 9(6) COMP-3 OCCURS 2.
    02 IP-MODYR PIC X. 02 IP-N-SI PIC X(10). 02 IP-N-ST PIC X(10).
    02 IP-PKG-QTY PIC 9(5) COMP-3. 02 IP-PKG-UNIT PIC XXX.
    02 IP-MAXQTY PIC S9(7) COMP-3. 02 IP-KAN PIC X(8). 02 IP-ORD PIC X(9).
    02 IP-DXNO PIC 9(4) COMP-3. 02 IP-LF PIC X(10). 02 IP-DOCK PIC X(8).
    02 IP-TEXT PIC X(70) OCCURS 5. 02 IP-IXT PIC S99 COMP-3.
    02 IP-INFO. 03 IP-IFLINE PIC X(40) OCCURS 16.
    02 IP-IXI PIC S99 COMP-3. 02 IP-IXI-SEQ PIC S99 COMP-3. 02 IP-IXF PIC S99 COMP-3.
    02 IP-FST. 03 IP-FSTX OCCURS 30.
      04 IP-FQTY PIC S9(7) COMP-3. 04 IP-FDATE PIC 9(6) COMP-3.
      04 IP-FQUAL PIC XXX. 04 IP-FTIME PIC 9(4) COMP-3. 04 IP-FRD PIC 9 COMP-3.
    02 IP-ATOTALS. 03 IP-ATOT PIC S9(5) COMP-3 OCCURS 3.
01  UB-FIELDS.
    02 UB-OP PIC 99 COMP-3.
01  AB-FIELDS.
    02 AB-OP PIC 99 COMP-3. 02 AB-KFIN PIC 9 COMP-3. 02 AB-STEP PIC 9 COMP-3.
    02 AB-SOURCE PIC X(10). 02 AB-B-ST PIC X(10). 02 AB-L-ST PIC X(10).
    02 AB-KDY PIC 9 COMP-3. 02 AB-KAS PIC 9 COMP-3. 02 AB-CUSORD PIC X(9).
    02 AB-STAT PIC XX. 02 AB-DOCK PIC X(8). 02 AB-ZONE PIC X(6).
    02 AB-BFR-TYPE PIC XX. 02 AB-BFR-NUM PIC X(10). 02 AB-BFR-SCHED PIC XX.
    02 AB-BFR-FDATE PIC 9(6) COMP-3. 02 AB-BFR-TDATE PIC 9(6) COMP-3.
    02 AB-BFR-DATE PIC 9(6) COMP-3. 02 AB-CUM PIC S9(9) COMP-3.
    02 AB-IXL PIC S99 COMP-3. 02 AB-IXI PIC S99 COMP-3. 02 AB-IXF PIC S99 COMP-3.
    02 AB-LIN. 03 OCCURS 5. 04 AB-LCODE PIC XX. 04 AB-LVAL PIC X(10).
    02 AB-INFO. 03 AB-IFLINE PIC X(40) OCCURS 12.
    02 AB-FST. 03 OCCURS 30.
      04 AB-FQTY PIC S9(7) COMP-3. 04 AB-FPERIOD PIC X.
      04 AB-FDATE PIC 9(6) COMP-3. 04 AB-FRD PIC 9 COMP-3.
01  IQ-FIELDS.
    02 IQ-OP PIC 99 COMP-3. 02 IQ-STEP PIC 9 COMP-3. 02 IQ-FIN PIC 9 COMP-3.
    02 IQ-QUAL PIC XX. 02 IQ-PERIOD PIC X. 02 IQ-STATUS PIC X.
    02 IQ-WEEK PIC X(20). 02 IQ-FUNCTION PIC XX. 02 IQ-SOURCE PIC X(10).
    02 IQ-DOC-DATE PIC 9(6) COMP-3. 02 IQ-DOC-HDATE PIC 9(6) COMP-3 OCCURS 2.
    02 IQ-SHD-CUM PIC S9(9) COMP-3. 02 IQ-SHD-DATE PIC 9(6) COMP-3 OCCURS 2.
    02 IQ-SHP-CUM PIC S9(9) COMP-3. 02 IQ-SHP-DATE PIC 9(6) COMP-3 OCCURS 2.
    02 IQ-FAB-CUM PIC S9(9) COMP-3. 02 IQ-FAB-DATE PIC 9(6) COMP-3 OCCURS 2.
    02 IQ-MAT-CUM PIC S9(9) COMP-3. 02 IQ-MAT-DATE PIC 9(6) COMP-3 OCCURS 2.
    02 IQ-MODYR PIC X. 02 IQ-LF PIC X(10). 02 IQ-DOCK PIC X(8).
    02 IQ-CUSORD PIC X(12). 02 IQ-CUM PIC S9(9) COMP-3.
    02 IQ-PKG-ID PIC X(6). 02 IQ-PKG-QTY PIC 9(5) COMP-3. 02 IQ-PKG-UNIT PIC XXX.
    02 IQ-TEXT PIC X(70) OCCURS 5. 02 IQ-IXT PIC S99 COMP-3.
    02 IQ-INFO. 03 IQ-IFLINE PIC X(40) OCCURS 6. 02 IQ-IXI PIC S99 COMP-3.
    02 IQ-FST. 03 OCCURS 30.
      04 IQ-FQTY PIC S9(7) COMP-3. 04 IQ-FPERIOD PIC X.
      04 IQ-FDATE PIC 9(6) COMP-3. 04 IQ-FRD PIC 9 COMP-3.
    02 IQ-IXF PIC S99 COMP-3.
01  AK-FIELDS.
    02 AK-OP PIC 99 COMP-3. 02 AK-KFIN PIC 9 COMP-3. 02 AK-STEP PIC 9 COMP-3.
    02 AK-PO PIC X(12). 02 AK-PURPOSE PIC XX. 02 AK-TYPE PIC XX.
    02 AK-PO-DATE PIC 9(6) COMP-3. 02 AK-B-ST PIC X(10). 02 AK-LN PIC XXX.
    02 AK-GS-SENDER PIC X(15). 02 AK-OQTY PIC S9(7) COMP-3.
    02 AK-UNIT PIC XX. 02 AK-PRICE PIC 9(5)V999 COMP-3. 02 AK-MODE PIC XX.
    02 AK-RQTY PIC S9(7) COMP-3. 02 AK-RUNIT PIC XX. 02 AK-RDATE PIC 9(6) COMP-3.
01  BK-FIELDS.
    02 BK-KST PIC 9 COMP-3.
01  UF-FIELDS.
    02 UF-OP PIC 99 COMP-3.
01  AD-FIELDS.
    02 AD-OP PIC 99 COMP-3. 02 AD-KFIN PIC 9 COMP-3. 02 AD-PR PIC XX.
    02 AD-TEXT PIC X(132).
01  WI-FIELDS.
    02 WI-OP PIC 99 COMP-3. 02 WI-KFIN PIC 9 COMP-3.
    02 WI-DATE PIC 9(6) COMP-3. 02 WI-TEXT PIC X(400).
    02 WI-INFO PIC X(22) OCCURS 5. 02 WI-IXI PIC S99 COMP-3.
01  AF-FIELDS.
    02 AF-OP PIC 99 COMP-3. 02 AF-KFIN PIC 9 COMP-3. 02 AF-KREF PIC 9 COMP-3.
    02 AF-DATE PIC 9(6) COMP-3. 02 AF-TRACE PIC X(16). 02 AF-PAY-SRC PIC X(12).
    02 AF-INV-NO PIC X(12). 02 AF-BL-NO PIC X(10).
    02 AF-CHQ-AMT PIC S9(7)V99 COMP-3. 02 AF-CHQ-DATE PIC 9(6) COMP-3.
    02 AF-INV-AMT PIC S9(7)V99 COMP-3. 02 AF-PAY-AMT PIC S9(7)V99 COMP-3.
    02 AF-INV-DATE PIC 9(6) COMP-3.
    02 AF-STOTALS. 03 AF-STOT PIC S9(7)V99 COMP-3 OCCURS 3.
    02 AF-GTOTALS. 03 AF-GTOT PIC S9(7)V99 COMP-3 OCCURS 3.
01  AE-FIELDS.
    02 AE-OP PIC 99 COMP-3.
01  UG-FIELDS.
    02 UG-OP PIC 99 COMP-3.
01  GA-FIELDS.
    02 GA-OP PIC 99 COMP-3. 02 GA-KFIN PIC 9 COMP-3.
    02 GA-TEXT PIC X(50) OCCURS 3. 02 GA-IXN PIC S99 COMP-3.
    02 GA-HFIELDS. 03 GA-REF PIC X(12). 03 GA-SREF PIC X(12).
      03 GA-DATE PIC 9(6) COMP-3. 03 GA-DATE-RCV PIC 9(6). 03 GA-PKCODE PIC X(6).
      03 GA-PKNUM PIC 999 COMP-3. 03 GA-PKWEIGHT PIC 9(5) COMP-3.
      03 GA-PKGN PIC X. 03 GA-PKUNIT PIC XX. 03 GA-SCAC PIC X(4).
    02 GA-DFIELDS. 03 GA-PROD PIC X(12). 03 GA-CREF PIC X(12).
      03 GA-QTY-REC PIC S9(7) COMP-3. 03 GA-QTY-SHP PIC S9(7) COMP-3.
      03 GA-UNIT-REC PIC XXX. 03 GA-UNIT-SHP PIC XXX.
01  GJ-FIELDS.
    02 GJ-OP PIC 99 COMP-3. 02 GJ-FIN PIC 9 COMP-3. 02 GJ-QUAL PIC XX.
    02 GJ-TEXT PIC X(30) OCCURS 10. 02 GJ-IXN PIC S99 COMP-3.
    02 GJ-HFIELDS. 03 GJ-REF PIC X(12). 03 GJ-SREF PIC X(12).
      03 GJ-N-MI PIC X(10). 03 GJ-N-ST PIC X(10).
      03 GJ-DATE-DOC PIC 9(6) COMP-3. 03 GJ-DATE PIC 9(6).
    02 GJ-DFIELDS. 03 GJ-PROD PIC X(12). 03 GJ-CREF PIC X(12).
      03 GJ-QTY-REC PIC S9(7) COMP-3. 03 GJ-QTY-SHP PIC S9(7) COMP-3.
      03 GJ-UNIT-REC PIC XXX. 03 GJ-UNIT-SHP PIC XXX.
01  AJ-FIELDS.
    02 AJ-OP PIC 99 COMP-3. 02 AJ-LVL PIC XX.
    02 AJ-KFIN PIC 9 COMP-3. 02 AJ-KFIR PIC 9 COMP-3.
    02 AJ-SQTY PIC 999 COMP-3. 02 AJ-SCOUNT PIC 999 COMP-3. 02 AJ-IXS PIC S99 COMP-3.
    02 AJ-HFIELDS. 03 AJ-DATE-TRANS PIC 9(6) COMP-3. 03 AJ-DATE-SHIP PIC 9(6) COMP-3.
    02 AJ-DFIELDS. 03 AJ-PACKING PIC X(7). 03 AJ-QTY PIC 999 COMP-3.
      03 AJ-WEIGHT PIC 9(6) COMP-3. 03 AJ-WUNIT PIC XX. 03 AJ-WQUAL PIC XXX.
      03 AJ-CARRIER PIC X(20). 03 AJ-METHOD PIC X(5). 03 AJ-EQ-TYPE PIC X(16).
      03 AJ-VEN-BL PIC X(10). 03 AJ-VEN-ORD PIC X(10). 03 AJ-VEN-LINE PIC X(10).
      03 AJ-PO PIC X(10). 03 AJ-DIM PIC X(10). 03 AJ-DTYPE PIC X(10). 03 AJ-HEAT PIC X(10).
      03 AJ-SO-NAME PIC X(30). 03 AJ-SO-ID PIC X(9).
      03 AJ-ST-NAME PIC X(30). 03 AJ-ST-ID PIC X(9).
      03 AJ-SE-NAME PIC X(30). 03 AJ-SE-ID PIC X(9).
      03 AJ-SWEIGHT PIC 9(5) COMP-3. 03 AJ-SUNIT PIC XX. 03 AJ-SNUM PIC X(15).
      03 AJ-IXP PIC S99 COMP-3. 03 AJ-IXC PIC S99 COMP-3.
      03 OCCURS 5. 04 AJ-PCODE PIC X(5). 04 AJ-PDESC PIC X(12).
      03 OCCURS 20. 04 AJ-CHEM PIC XX. 04 AJ-CVAL PIC X(5). 04 AJ-CUNIT PIC X.
01  UJ-FIELDS.
    02 UJ-OP PIC 99 COMP-3.
01  HF-FIELDS.
    02 HF-FIN PIC 9 COMP-3. 02 HF-IO PIC 9 COMP-3. 02 HF-RFFQ PIC XX.
    02 HF-HFIELDS. 03 HF-DATE PIC 9(6) COMP-3. 03 HF-TIME PIC 9(4) COMP-3.
      03 HF-MI PIC X(10).
    02 HF-DFIELDS. 03 HF-PROD PIC X(8). 03 HF-PLANT PIC X(10).
      03 HF-DOCK PIC X(5). 03 HF-BAL-QTY PIC S9(7) COMP-3.
      03 HF-IN-QTY PIC S9(7) COMP-3. 03 HF-IN-DATE PIC 9(6) COMP-3. 03 HF-IN-ADV PIC X(12).
      03 HF-OUT-QTY PIC S9(7) COMP-3. 03 HF-OUT-DATE PIC 9(6) COMP-3. 03 HF-OUT-ADV PIC X(12).
      03 HF-DEL-DATE PIC 9(6) COMP-3. 03 HF-DEL-NOTE PIC X(12).
01  AW-FIELDS.
    02 AW-OP PIC 99 COMP-3. 02 AW-NUM PIC 999 COMP-3. 02 AW-MSAV PIC X(80).
    02 AW-UNB-REF PIC X(14). 02 AW-UNH-REF PIC X(14). 02 AW-FLD PIC X(30).
    02 AW-ID1 PIC X(20). 02 AW-ID2 PIC X(20).
01  RM-FIELDS.
    02 RM-OP PIC 99 COMP-3. 02 RM-STEP PIC 9 COMP-3.
    02 RM-KTOT PIC 9 COMP-3. 02 RM-KSA PIC 9 COMP-3.
    02 RM-PROD PIC X(12). 02 RM-ORD PIC 9(6) COMP-3.
    02 RM-OCAT PIC 99 COMP-3. 02 RM-OREP PIC XX.
    02 RM-SDT PIC 9(4) COMP-3. 02 RM-SQTY PIC S9(7) COMP-3.
01  MH-FIELDS.
    02 MH-OP PIC 99 COMP-3. 02 MH-PROD PIC X(12).
01  MA-FIELDS.
    02 MA-OP PIC 9 COMP-3. 02 MA-KFIN PIC 9 COMP-3.
    02 MA-PLANT PIC X(10). 02 MA-PROD PIC X(12).
    02 MA-DEMAND PIC S9(9) COMP-3. 02 MA-FDEMAND PIC S9(9) COMP-3.
01  MG-FIELDS.
    02 MG-OP PIC 99 COMP-3. 02 MG-LF PIC X(10).
    02 MG-PTOT PIC S9(5) COMP-3. 02 MG-DTOT PIC S9(5) COMP-3.
    02 MG-LTOT PIC S9(5) COMP-3.
    02 MG-OPLANT PIC X(10). 02 MG-ODATE PIC 9(6). 02 MG-OLF PIC X(10).
01  RO-FIELDS.
    02 RO-TYPE PIC 99 COMP-3.
01  EN-FIELDS.
    02 EN-SEL PIC 99 COMP-3. 02 EN-OP PIC 9 COMP-3. 02 EN-KFIN PIC 9 COMP-3.
    02 EN-PLANT PIC X(10). 02 EN-PROD PIC X(12). 02 EN-SEQ PIC 99.
    02 EN-DATE PIC 9(6) COMP-3. 02 EN-TYPE PIC 99 COMP-3. 02 EN-NUM PIC 9(4).
    02 EN-IXD PIC S999 COMP-3.

* C: PRODUCT COSTING FUNCTIONS

01  JM-FIELDS.
    02 JM-CUS PIC X(6). 02 JM-PROD PIC X(12). 02 JM-MAC PIC 99.
    02 JM-PRICE PIC 9(4)V999 COMP-3. 02 JM-U PIC X.
01  GF-FIELDS.
    02 OCCURS 10. 03 GF-CNO PIC X(6). 03 GF-CINC PIC 99V99 COMP-3.
    02 GF-KC PIC 9 COMP-3. 02 GF-NUM PIC 99 COMP-3. 02 GF-IXC PIC 99 COMP-3.
01  HK-FIELDS.
    02 HK-OP PIC 9 COMP-3. 02 HK-KFIN PIC 9 COMP-3. 02 HK-KH PIC 9 COMP-3.
    02 HK-PRICE PIC 9(4)V999 COMP-3. 02 HK-SUR PIC 9 COMP-3. 02 HK-SURCH PIC 99V999 COMP-3.
    02 HK-NOTE PIC X(50). 02 HK-AUTH PIC XXX. 02 HK-DATE PIC 9(6) COMP-3.
01  HZ-FIELDS.
    02 HZ-HEADLN PIC X(39) VALUE "customer no.`product no.`price`eff date".
01  AM-FIELDS.
    02 AM-PREV-NO PIC 9(6). 02 AM-LINE PIC 99 COMP-3. 02 AM-IXL PIC S999 COMP-3.
    02 AM-SAVNO PIC 9(6). 02 AM-SAVPROD PIC X(12). 02 AM-OPDESC PIC X(10).

* F: FINANCIALS FUNCTIONS

01  CS-FIELDS.
    02 CS-KNEW PIC 9 COMP-3. 02 CS-AMT PIC S9(7)V99 COMP-3.
    02 CS-DF1 PIC Z9.99-. 02 CS-DF2 PIC Z(4),ZZ9.99-.
01  LI-FIELDS.
    02 LI-BLNO PIC 9(7). 02 LI-BL PIC 9(7). 02 LI-TOT PIC S9(7)V99 COMP-3 OCCURS 2.
01  JF-FIELDS.
    02 JF-KFIN PIC 9 COMP-3. 02 JF-KREF PIC 9 COMP-3. 02 JF-KSAT PIC 9 COMP-3.
    02 JF-INUM PIC 9(5) COMP-3. 02 JF-RSEQ PIC 9(5) COMP-3.
    02 JF-INV-DATE PIC 9(6) COMP-3. 02 JF-EFF-DATE PIC 9(6) COMP-3.
    02 JF-PE PIC XX. 02 JF-BL PIC 9(7). 02 JF-BL-NO PIC X(12).
    02 JF-CHQ-AMT PIC S9(7)V99 COMP-3. 02 JF-CHQ-DATE PIC 9(6) COMP-3.
    02 JF-CHQ-CUR PIC XXX. 02 JF-ROUND PIC S9(5)V99 COMP-3.
    02 JF-RMAX PIC S9V99 COMP-3 VALUE 5.00. 02 JF-RSMAX PIC S9V99 COMP-3 VALUE 1.00.
    02 JF-TOT PIC S9(7)V99 COMP-3. 02 JF-NUM-INV PIC 999 COMP-3.
    02 JF-INVNO PIC 9(6) COMP-3. 02 JF-PAY-AMT PIC S9(7)V99 COMP-3.
    02 JF-IX1 PIC S999 COMP-3. 02 JF-SNUM PIC S999 COMP-3. 02 JF-D1 PIC S9(7)V99 COMP-3.
    02 JF-EXC PIC 9 COMP-3. 02 JF-EXLIT PIC X(5) VALUE "10*RS".
    02 JF-TOTALS. 03 JF-TTOT PIC S9(7)V99 COMP-3. 03 JF-FTOT PIC S9(7)V99 COMP-3.
    02 JF-SLINES. 03 OCCURS 5. 04 JF-SPROD PIC X(8). 04 JF-SAMT PIC S9(5)V99 COMP-3.
01  JG-FIELDS.
    02 JG-KFIN PIC 9 COMP-3. 02 JG-KREF PIC 9 COMP-3.
    02 JG-PID PIC XX. 02 JG-STEP PIC 9 COMP-3.
    02 JG-CHQ-AMT PIC S9(7)V99 COMP-3. 02 JG-CHQ-CUR PIC XXX.
    02 JG-INV-DATE PIC 9(6) COMP-3. 02 JG-CHQ-DATE PIC 9(6) COMP-3.
    02 JG-PAY-AMT PIC S9(7)V99 COMP-3. 02 JG-BL-NO PIC X(12).
    02 JG-PO PIC X(12). 02 JG-LN PIC 999 COMP-3. 02 JG-QTY PIC S9(7) COMP-3.
    02 JG-MODE PIC XX. 02 JG-PRICE PIC S9(5)V9(5) COMP-3. 02 JG-DESC PIC X(15).
    02 JG-TOTAL PIC S9(5)V9(5) COMP-3.
01  CM-FIELDS.
    02 CM-CHQ-DATE PIC 9(6) COMP-3. 02 CM-TOT-AMT PIC S9(7)V99 COMP-3.
    02 CM-IDATE PIC 9(6) COMP-3. 02 CM-BL PIC 9(7) COMP-3. 02 CM-PO PIC X(12).
    02 CM-QTY PIC S9(7) COMP-3. 02 CM-AMT PIC S9(7)V99 COMP-3.
    02 CM-VENDOR PIC X(20). 02 CM-PROD. 03 CM-NPROD PIC 9(8).
01  OU-FIELDS.
    02 OU-HEADLN PIC X(38) VALUE "customer`customer name`sur cd`surch/lb".
01  JS-FIELDS.
    02 JS-KFIN PIC 9 COMP-3. 02 JS-EFF-DATE PIC 9(6) COMP-3.
    02 JS-INUM PIC 9(5) COMP-3. 02 JS-RSEQ PIC 9(5) COMP-3. 02 JS-ITEM PIC 999 COMP-3.
    02 JS-KB PIC 9 COMP-3. 02 JS-TOTNUM PIC 999 COMP-3. 02 JS-TOTAMT PIC S9(9)V99 COMP-3.
    02 JS-DATE PIC 9(6) COMP-3. 02 JS-PAYEE PIC X(10). 02 JS-PAYER PIC X(20).
    02 JS-CHQNO PIC 9(7) COMP-3. 02 JS-CHQAMT PIC S9(9)V99 COMP-3.
    02 JS-INVNO PIC 9(6) COMP-3. 02 JS-INVAMT PIC S9(9)V99 COMP-3.
    02 JS-RMAX PIC S99V99 COMP-3 VALUE 5.00. 02 JS-ROUND PIC S9(5)V99 COMP-3.
    02 JS-TOT PIC S9(7)V99 COMP-3. 02 JS-NUM-INV PIC 999 COMP-3.
    02 JS-INV PIC 9(7). 02 JS-BL PIC 9(7). 02 JS-PAY-AMT PIC S9(7)V99 COMP-3.
    02 JS-D1 PIC S9(7)V99 COMP-3. 02 JS-D2 PIC S9(7)V99 COMP-3.
    02 JS-EXC PIC 9 COMP-3. 02 JS-EXLIT PIC X(4) VALUE "10*R".
    02 JS-TOTALS. 03 JS-ATOT PIC S9(7)V99 COMP-3. 03 JS-RTOT PIC S9(7)V99 COMP-3.
01  JQ-FIELDS.
    02 JQ-KFIN PIC 9 COMP-3. 02 JQ-KFIR PIC 9 COMP-3. 02 JQ-KBAT PIC 9 COMP-3.
    02 JQ-TOTNUM PIC 999 COMP-3. 02 JQ-TOTAMT PIC S9(9)V99 COMP-3.
    02 JQ-DATE PIC 9(6) COMP-3. 02 JQ-PAYEE PIC X(10). 02 JQ-PAYER PIC X(20).
    02 JQ-CHQNO PIC 9(7) COMP-3. 02 JQ-CHQAMT PIC S9(9)V99 COMP-3.
    02 JQ-INVNO PIC 9(7) COMP-3. 02 JQ-INVAMT PIC S9(9)V99 COMP-3.
    02 JQ-ITEM PIC 999 COMP-3.

* A: PREVENTIVE MAINTENANCE FUNCTIONS

01  KA-FIELDS.
    02 KA-OP PIC XXX. 02 KA-KFIN PIC 9 COMP-3.
01  KC-FIELDS.
    02 KC-OP PIC XXX. 02 KC-OQ PIC XXX. 02 KC-TYPE PIC 9. 02 KC-ONO PIC 9(6) COMP-3.
    02 KC-KFIN PIC 9 COMP-3. 02 KC-KADD PIC 9 COMP-3. 02 KC-HOURS PIC 999V9 COMP-3.
01  KF-FIELDS.
    02 KF-ME PIC X.
01  KJ-FIELDS.
    02 KJ-SEL PIC 9 COMP-3. 02 KJ-CN PIC X. 02 KJ-PE PIC X. 02 KJ-IMAC PIC X(4).
    02 KJ-USER PIC X(12). 02 KJ-NUM PIC S9(5) COMP-3.
    02 KJ-DF1. 03 KJ-DF1A PIC X(40). 03 KJ-DF1B PIC Z(5)9. 03 KJ-DF1C PIC ZZZ99/99/99.
01  FM-FIELDS.
    02 FM-YY PIC 99. 02 FM-MM PIC 99.
    02 FM-MTOTALS. 03 FM-MHOURS PIC S9(5)V9 COMP-3. 03 FM-MDIST PIC S9(5)V9 COMP-3 OCCURS 6.
    02 FM-TTOTALS. 03 FM-THOURS PIC S9(5)V9 COMP-3. 03 FM-TDIST PIC S9(5)V9 COMP-3 OCCURS 6.
    02 FM-GTOTALS. 03 FM-GHOURS PIC S9(5)V9 COMP-3. 03 FM-GDIST PIC S9(5)V9 COMP-3 OCCURS 6.
01  WB-FIELDS.
    02 WB-IMAC PIC X(4). 02 WB-MDESC PIC X(30). 02 WB-GHOURS PIC S9(6)V9 COMP-3.
01  WM-FIELDS.
    02 WM-PE PIC X.
01  FX-FIELDS.
    02 FX-OP PIC 9 COMP-3. 02 FX-KFIN PIC 9 COMP-3.
01  NS-FIELDS.
    02 NS-HOURS PIC 9(5) COMP-3.
    02 NS-DF1. 03 NS-DF1A PIC ZZZ9. 03 NS-DF1B PIC Z(5)99/99/99.
      03 NS-DF1C PIC Z(8),ZZ9. 03 NS-DF1D PIC Z(8),ZZ9. 03 NS-DF1E PIC B(6)X.

* Z: BATCH AND OTHER FUNCTIONS

01  BB-FIELDS.
    02 BB-PNO PIC X(12). 02 BB-PROD PIC X(12). 02 BB-NUM PIC 99 COMP-3.
    02 BB-MTH PIC S9(4) COMP-3. 02 BB-CURMTH PIC S9(4) COMP-3.
    02 BB-PTOTALS. 03 BB-PQTY PIC S9(9) COMP-3 OCCURS 3.
    02 BB-STOTALS. 03 BB-SQTY PIC S9(9) COMP-3 OCCURS 3.
    02 BB-GTOTALS. 03 BB-GQTY PIC S9(9) COMP-3 OCCURS 3.
    02 BB-CTOTALS. 03 BB-CQTY PIC S9(9) COMP-3. 03 BB-CVAL PIC S9(7)V99 COMP-3.
    02 BB-FTOTALS. 03 BB-FQTY PIC S9(9) COMP-3. 03 BB-FVAL PIC S9(7)V99 COMP-3.
    02 BB-YTOTALS. 03 BB-YQTY PIC S9(9) COMP-3 OCCURS 5.
    02 BB-TTOTALS. 03 BB-TQTY PIC S9(9) COMP-3 OCCURS 5.
    02 BB-IXR PIC S99 COMP-3. 02 BB-IXO PIC S99 COMP-3. 02 BB-IXL PIC S99 COMP-3.
    02 BB-KMO PIC 9 COMP-3. 02 BB-NEXT PIC 999 COMP-3. 02 BB-QHAND PIC S9(9) COMP-3.
    02 BB-OPX. 03 BB-OMO PIC 9(6) COMP-3. 03 BB-OUT PIC S9(7) COMP-3.
      03 BB-OORD PIC S9(7) COMP-3. 03 BB-OPROD PIC S9(7) COMP-3.
      03 OCCURS 31. 04 BB-OPER PIC 999 COMP-3. 04 BB-ODATE PIC 9(6) COMP-3.
        04 BB-OQTY PIC S9(7) COMP-3.
    02 BB-RQX. 03 OCCURS 21.
      04 BB-RD PIC X. 04 BB-RDATE PIC 9(6) COMP-3. 04 BB-RQTY PIC S9(7) COMP-3.
    02 BB-HEADLN.
      03 PIC X(107) VALUE "order no.`part`blanket`date reqd`qty reqd`qty on hand`qty Q bins`m.o. no.`qty ordered`qty produced`qty out`".
      03 PIC X(58) VALUE "op`op date`op qty`last op`last op date`last op qty`next op".
01  JJ-FIELDS.
    02 JJ-KM PIC 9 COMP-3. 02 JJ-KW PIC 9 COMP-3. 02 JJ-KP PIC 9 COMP-3.
    02 JJ-KN PIC 9 COMP-3. 02 JJ-KL PIC 9 COMP-3.
    02 JJ-KBL PIC 9 COMP-3. 02 JJ-KEXP PIC 9 COMP-3. 02 JJ-KSUM PIC 9 COMP-3.
    02 JJ-DATE PIC 9(6) COMP-3. 02 JJ-AMT PIC S9(9)V99 COMP-3.
    02 JJ-QTY PIC S9(9) COMP-3. 02 JJ-WEIGHT PIC S9(9) COMP-3.
    02 JJ-DTBL. 03 OCCURS 5. 04 JJ-FROM PIC 9(6) COMP-3. 04 JJ-TO PIC 9(6) COMP-3.
    02 JJ-STBL. 03 OCCURS 12.
      04 JJ-SMM PIC 99 COMP-3. 04 JJ-SYY PIC 99 COMP-3. 04 JJ-SDAYS PIC 99 COMP-3.
      04 JJ-SW PIC S9(9) COMP-3. 04 JJ-SA PIC S9(7)V99 COMP-3.
    02 JJ-YY PIC 99 COMP-3. 02 JJ-MM PIC 99 COMP-3. 02 JJ-DD PIC 99 COMP-3.
    02 JJ-CTOTALS. 03 JJ-CT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 JJ-STOTALS. 03 JJ-ST PIC S9(9)V99 COMP-3 OCCURS 6.
    02 JJ-GTOTALS. 03 JJ-GT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 JJ-HEADLN1.
      03 PIC X(94) VALUE "customer`customer name`order no.`customer order`part`part description`customer part`date reqd`".
      03 PIC X(99) VALUE "regular/blanket`qty`weight`value (mixed)`value (cdn equiv)`qty on hand`qty in process`qty exception".
    02 JJ-HEADLN2 PIC X(54) VALUE "year`month`days`tons/day`value/day (mixed)`month total".
01  SO-FIELDS.
    02 SO-STOTALS. 03 SO-SN PIC S9(9) COMP-3 OCCURS 4.
    02 SO-GTOTALS. 03 SO-GN PIC S9(9) COMP-3 OCCURS 4.
      03 SO-GW PIC S9(9) COMP-3. 03 SO-GR PIC S9(9) COMP-3.
01  HR-FIELDS.
    02 HR-KS PIC 9 COMP-3. 02 HR-KD PIC 9 COMP-3.
    02 HR-SHIPTO PIC 99 COMP-3. 02 HR-CUSORD PIC X(9). 02 HR-LTH PIC 99 COMP-3.
    02 HR-AMT PIC S9(7)V99 COMP-3. 02 HR-PROD PIC X(12). 02 HR-DT PIC 9(6) COMP-3.
    02 HR-HQTY PIC S9(9) COMP-3. 02 HR-HWEIGHT PIC S9(9) COMP-3.
    02 HR-MECOST PIC 9(4)V99 COMP-3. 02 HR-OVERHEAD PIC S9(9)V99 COMP-3.
    02 HR-CONTRIB PIC S9(9)V99 COMP-3. 02 HR-MARGIN PIC S9(9)V99 COMP-3.
    02 HR-NTOTALS. 03 HR-NQ PIC S9(11) COMP-3.
      03 HR-NA PIC S9(9)V99 COMP-3. 03 HR-NW PIC S9(9) COMP-3.
    02 HR-CTOTALS. 03 HR-CQ PIC S9(11) COMP-3.
      03 HR-CA PIC S9(9)V99 COMP-3. 03 HR-CW PIC S9(9) COMP-3.
      03 HR-CL PIC S9(11) COMP-3. 03 HR-CS PIC S9(11) COMP-3.
    02 HR-PTOTALS. 03 HR-PQ PIC S9(11) COMP-3.
      03 HR-PA PIC S9(9)V99 COMP-3. 03 HR-PW PIC S9(9) COMP-3.
      03 HR-PL PIC S9(11) COMP-3. 03 HR-PS PIC S9(11) COMP-3.
    02 HR-GTOTALS. 03 HR-GQ PIC S9(11) COMP-3.
      03 HR-GA PIC S9(9)V99 COMP-3. 03 HR-GW PIC S9(9) COMP-3.
      03 HR-GL PIC S9(11) COMP-3. 03 HR-GS PIC S9(11) COMP-3.
    02 HR-HEADLN1 PIC X(104) VALUE "cust no.`cust name`province`generic part`alternate part`description`quantity`amount`weight`currency`date".
    02 HR-HEADLN2 PIC X(90) VALUE "generic part`alternate part`description`cust no.`cust name`quantity`amount`weight`currency".
    02 HR-HEADLN3.
      03 PIC X(100) VALUE "part`description`qty sold`weight sold`total dollars`category`material`proc code`clean code`mac`rate`".
      03 PIC X(108) VALUE "op 1`op 2`op 3`op 4`op 5`op 6`op 7`op 8`op 9`op 10`op 11`op 12`cust 1`cust 2`cust 3`cust 4`cust 5`purch cost".
    02 HR-HEADLN4.
      03 PIC X(81) VALUE "cust`part`cat`description`on hand`date received`price 1`price 2`weight`quote no.`".
      03 PIC X(115) VALUE "12-mth hist qty`12-mth hist weight`EA qty`EA weight`EA value`future reqd date`future qty`future weight`future value".
    02 HR-HEADLN5 PIC X(35) VALUE "invoice`date`amount`quantity`weight".
    02 HR-HEADLN6 PIC X(126) VALUE "inv date`inv number`P.O. number`B/L number`date shipped`part`description`quantity`price`unit`tot amount`currency`customer`name".
01  BR-FIELDS.
    02 BR-LCUS PIC X(6). 02 BR-LDATE PIC 9(6) COMP-3. 02 BR-LQTY PIC S9(9) COMP-3.
    02 BR-YLOT1 PIC 9(11) COMP-3. 02 BR-YLOT2 PIC 9(11) COMP-3.
    02 BR-YEAR PIC 9(4) COMP-3. 02 BR-KG PIC 9 COMP-3. 02 BR-CONT PIC X.
    02 BR-STOTALS. 03 BR-SQ PIC S9(9) COMP-3. 03 BR-SR PIC S9(9) COMP-3.
      03 BR-SW PIC S9(9) COMP-3. 03 BR-ST PIC S9(9) COMP-3 OCCURS 6.
    02 BR-GTOTALS. 03 BR-GQ PIC S9(9) COMP-3. 03 BR-GR PIC S9(9) COMP-3.
      03 BR-GW PIC S9(9) COMP-3. 03 BR-GT PIC S9(9) COMP-3 OCCURS 6.
    02 BR-SFIELDS. 03 BR-SPROD PIC X(12). 03 BR-SDESC PIC X(32).
      03 BR-SCAT PIC 99 COMP-3. 03 BR-SPRINT PIC X(6).
    02 BR-HEADLN PIC X(51) VALUE "part`part description`category`print no.`qty`weight".
01  AR-FIELDS.
    02 AR-DAYS PIC 9(5) COMP-3. 02 AR-KZ PIC 9 COMP-3. 02 AR-KF PIC 9 COMP-3.
    02 AR-KP PIC 9 COMP-3. 02 AR-PAY-DAYS PIC 999 COMP-3. 02 AR-PTOT PIC S9(7)V99 COMP-3.
    02 AR-WPD PIC 9(5) COMP-3 OCCURS 3. 02 AR-TITLE PIC X(14).
    02 AR-WD1 PIC S9(9)V99 COMP-3. 02 AR-WN1 PIC S9(9) COMP-3.
    02 AR-STOTALS. 03 OCCURS 2. 04 OCCURS 2. 05 AR-STOT PIC S9(7)V99 COMP-3 OCCURS 6.
    02 AR-ATOTALS. 03 AR-ASTOT PIC S9(9)V99 COMP-3. 03 AR-ATOT PIC S9(9) COMP-3 OCCURS 4.
    02 AR-BTOTALS. 03 AR-BSTOT PIC S9(9)V99 COMP-3. 03 AR-BTOT PIC S9(9) COMP-3 OCCURS 4.
    02 AR-CTOTALS. 03 AR-CTOT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 AR-FTOTALS. 03 AR-FTOT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 AR-GTOTALS. 03 AR-GTOT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 AR-ITOTALS. 03 AR-ITOT PIC S9(7)V99 COMP-3 OCCURS 2.
    02 AR-JTOTALS. 03 AR-JTOT PIC S9(7)V99 COMP-3 OCCURS 4.
    02 AR-KTOTALS. 03 AR-KTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 AR-HEADLN.
      03 PIC X(100) VALUE "cust no.`name`address line 1`address line 2`postal code`currency`total bal`credit lim`D&B`insurance`".
      03 PIC X(97) VALUE "current`30 days`60 days`90 days`120 days`pay in days`contact info 1`contact info 2`contact info 3".
01  DS-FIELDS.
    02 DS-STEP PIC 9 COMP-3. 02 DS-EX PIC 9 COMP-3. 02 DS-AF PIC 9 COMP-3.
    02 DS-OP PIC 9 COMP-3. 02 DS-OQ PIC 9 COMP-3.
    02 DS-KM PIC 9 COMP-3. 02 DS-KR PIC 9 COMP-3. 02 DS-DATE PIC 9(6) COMP-3.
    02 DS-MM PIC 99. 02 DS-DD PIC 99. 02 DS-YY PIC 99.
    02 DS-AMT PIC S9(9)V99 COMP-3. 02 DS-XAMT PIC S9(9)V99 COMP-3.
    02 DS-XTER. 03 DS-TER PIC 99 OCCURS 4.
    02 DS-IXT PIC 99 COMP-3. 02 DS-IXC PIC 99 COMP-3. 02 DS-IX1 PIC 99 COMP-3.
    02 DS-MDAYS PIC 99 COMP-3. 02 DS-YDAYS PIC 999 COMP-3. 02 DS-RNUM PIC 9(6) COMP-3.
    02 DS-FORECAST. 03 DS-IM PIC 99 COMP-3.
      03 DS-IA PIC S9(9)V99 COMP-3. 03 DS-YA PIC S9(9)V99 COMP-3.
      03 DS-IW PIC S9(9) COMP-3. 03 DS-YW PIC S9(9) COMP-3.
      03 DS-IC PIC S999V99 COMP-3. 03 DS-YC PIC S999V99 COMP-3.
      03 DS-IT PIC S999V9 COMP-3. 03 DS-YT PIC S999V9 COMP-3.
    02 DS-VFIELDS. 03 DS-VTER PIC 99 COMP-3. 03 DS-VCAT PIC 99 COMP-3.
      03 DS-VPROD PIC X(12). 03 DS-VAMT PIC S9(9)V99 COMP-3.
      03 DS-VQTY PIC S9(9) COMP-3. 03 DS-VWEIGHT PIC S9(5) COMP-3.
    02 DS-HTOTALS. 03 DS-HA PIC S9(9)V99 COMP-3. 03 DS-HB PIC S9(9)V99 COMP-3.
      03 DS-HW PIC S9(9) COMP-3. 03 DS-HR PIC S9(9) COMP-3.
    02 DS-TTOTALS. 03 DS-TAMT PIC S9(7)V99 COMP-3. 03 DS-TWEIGHT PIC S9(9) COMP-3.
    02 DS-CTOTALS. 03 DS-CAMT PIC S9(7)V99 COMP-3. 03 DS-CWEIGHT PIC S9(9) COMP-3.
    02 DS-PTOTALS. 03 DS-PAMT PIC S9(7)V99 COMP-3. 03 DS-PWEIGHT PIC S9(9) COMP-3.
      03 DS-PQTY PIC S9(9) COMP-3.
    02 DS-XTOTALS. 03 OCCURS 3.
      04 DS-XA PIC S9(9)V99 COMP-3. 04 DS-XW PIC S9(9) COMP-3. 04 DS-XQ PIC S9(9) COMP-3.
    02 DS-DTOTALS. 03 OCCURS 3.
      04 DS-DA PIC S9(9)V99 COMP-3. 04 DS-DW PIC S9(9) COMP-3. 04 DS-DQ PIC S9(9) COMP-3.
    02 DS-STOTALS. 03 OCCURS 3.
      04 DS-SA PIC S9(9)V99 COMP-3. 04 DS-SW PIC S9(9) COMP-3. 04 DS-SQ PIC S9(9) COMP-3.
    02 DS-GTOTALS. 03 OCCURS 3.
      04 DS-GA PIC S9(9)V99 COMP-3. 04 DS-GW PIC S9(9) COMP-3. 04 DS-GQ PIC S9(9) COMP-3.
    02 DS-S1TOTALS. 03 OCCURS 3.
      04 DS-S1A PIC S9(9)V99 COMP-3. 04 DS-S1W PIC S9(9) COMP-3. 04 DS-S1Q PIC S9(9) COMP-3.
    02 DS-S2TOTALS. 03 OCCURS 3.
      04 DS-S2A PIC S9(9)V99 COMP-3. 04 DS-S2W PIC S9(9) COMP-3. 04 DS-S2Q PIC S9(9) COMP-3.
    02 DS-S3TOTALS. 03 OCCURS 3.
      04 DS-S3A PIC S9(9)V99 COMP-3. 04 DS-S3W PIC S9(9) COMP-3. 04 DS-S3Q PIC S9(9) COMP-3.
    02 DS-S4TOTALS. 03 OCCURS 3.
      04 DS-S4A PIC S9(9)V99 COMP-3. 04 DS-S4W PIC S9(9) COMP-3. 04 DS-S4Q PIC S9(9) COMP-3.
    02 DS-NTOTALS. 03 OCCURS 5. 04 OCCURS 6. 05 OCCURS 3. 06 DS-NA PIC S9(9)V99 COMP-3.
    02 DS-BTOTALS. 03 OCCURS 3. 04 OCCURS 3. 05 OCCURS 2. 06 OCCURS 2.
      07 DS-BW PIC S9(9) COMP-3. 07 DS-BA PIC S9(9)V9 COMP-3.
    02 DS-BGTOTALS. 03 OCCURS 2. 04 OCCURS 2.
      05 DS-BGW PIC S9(9) COMP-3. 05 DS-BGA PIC S9(9)V9 COMP-3.
    02 DS-RSTOTALS. 03 DS-RSA PIC S9(9)V99 COMP-3 OCCURS 2.
    02 DS-RGTOTALS. 03 DS-RGA PIC S9(9)V99 COMP-3 OCCURS 2.
    02 DS-RNTOTALS. 03 OCCURS 2. 04 OCCURS 4. 05 OCCURS 6. 06 DS-RNA PIC S9(9)V99 COMP-3.
01  SE-FIELDS.
    02 SE-STEP PIC 9 COMP-3. 02 SE-KPLT PIC 9 COMP-3. 02 SE-KSAN PIC 9 COMP-3.
    02 SE-TBL PIC 99 COMP-3. 02 SE-TNO PIC 999 COMP-3. 02 SE-IXN PIC 99 COMP-3.
    02 SE-STOTALS. 03 SE-STOT PIC S9(11) COMP-3 OCCURS 5.
    02 SE-GTOTALS. 03 SE-GTOT PIC S9(11) COMP-3 OCCURS 5.
    02 SE-PTOTALS. 03 SE-PTOT PIC S9(11) COMP-3 OCCURS 5.
    02 SE-RTOTALS. 03 SE-RTOT PIC S9(11) COMP-3 OCCURS 5.
    02 SE-XTOTALS. 03 SE-XTOT PIC S9(11) COMP-3 OCCURS 5.
    02 SE-YTOTALS. 03 SE-YTOT PIC S9(11) COMP-3 OCCURS 5.
01  DD-FIELDS.
    02 DD-MTOTALS. 03 DD-MA PIC S9(9)V99 COMP-3 OCCURS 8. 03 DD-MA-IG PIC S9(9)V99 COMP-3.
    02 DD-UMTOTALS. 03 DD-UMA PIC S9(7)V99 COMP-3 OCCURS 5.
01  SD-FIELDS.
    02 SD-OQTY PIC S9(9) COMP-3. 02 SD-OWEIGHT PIC S9(9) COMP-3.
    02 SD-ORDER PIC S9(9) COMP-3.
    02 SD-STOTALS. 03 SD-SQ PIC S9(9) COMP-3. 03 SD-SW PIC S9(9) COMP-3.
      03 SD-SN PIC S9(9) COMP-3.
    02 SD-GTOTALS. 03 SD-GQ PIC S9(9) COMP-3. 03 SD-GW PIC S9(9) COMP-3.
      03 SD-GN PIC S9(9) COMP-3.
01  SS-FIELDS.
    02 SS-STEP PIC 9 COMP-3. 02 SS-TITLE PIC X(52). 02 SS-KSAN PIC 9 COMP-3.
    02 SS-KR PIC 9 COMP-3. 02 SS-KC PIC 9 COMP-3. 02 SS-KI PIC 9 COMP-3.
    02 SS-KA PIC 9 COMP-3. 02 SS-KN PIC 9 COMP-3.
    02 SS-KS PIC 9 COMP-3. 02 SS-KS1 PIC 9 COMP-3. 02 SS-KS2 PIC 9 COMP-3.
    02 SS-PWEIGHT PIC S9(9) COMP-3.
    02 SS-STOTALS. 03 SS-SQ PIC S9(9) COMP-3. 03 SS-SW PIC S9(9) COMP-3.
      03 SS-SR PIC S9(9) COMP-3. 03 SS-SN PIC S9(9) COMP-3 OCCURS 2.
    02 SS-GTOTALS. 03 SS-GQ PIC S9(9) COMP-3. 03 SS-GW PIC S9(9) COMP-3.
      03 SS-GR PIC S9(9) COMP-3. 03 SS-GN PIC S9(9) COMP-3 OCCURS 2.
    02 SS-XTOTALS. 03 SS-XQ PIC S9(9) COMP-3. 03 SS-XW PIC S9(9) COMP-3.
      03 SS-XR PIC S9(9) COMP-3. 03 SS-XN PIC S9(9) COMP-3 OCCURS 2.
    02 SS-CTOTALS. 03 SS-CN PIC S9(9) COMP-3 OCCURS 2.
    02 SS-HEADLN.
      03 PIC X(95) VALUE "cat`generic part`alternate part`description`on hand`on order`in process`total demand`ROP`lvl 3`".
      03 PIC X(95) VALUE "weight/c`weight on hand`lead days`below safety`last rcvd`last sale price (Can$)`last sale date`".
      03 PIC X(115) VALUE "diameter`grade`anneal/clean`tot man cost (mode 1)`tot man cost (mode 3)`mat cost (laid down)`mat cost (purch hist)`".
      03 PIC X(97) VALUE "tools cost/1000 (mode 1)`tools cost/1000 (mode 3)`tools cost/ton (mode 1)`tools cost/ton (mode 3)".
01  RS-FIELDS.
    02 RS-KR PIC 9 COMP-3. 02 RS-LEFT PIC S9(9) COMP-3.
    02 RS-HOURS PIC S9(5) COMP-3. 02 RS-WEIGHT PIC S9(9) COMP-3.
    02 RS-LIM-DATE PIC 9(6) COMP-3. 02 RS-IXL PIC S99 COMP-3.
    02 RS-MTOTALS. 03 RS-MTOT PIC S9(7) COMP-3 OCCURS 4.
      03 RS-MHOURS PIC S9(7) COMP-3 OCCURS 3.
      03 RS-MSHOURS PIC S9(7) COMP-3. 03 RS-MLHOURS PIC S9(7) COMP-3.
    02 RS-GTOTALS. 03 RS-GTOT PIC S9(7) COMP-3 OCCURS 4.
      03 RS-GHOURS PIC S9(7) COMP-3 OCCURS 3.
    02 RS-HEADLN.
      03 PIC X(59) VALUE "mac`cat`product`description`m.o.`s/s`to build`started`date`".
      03 PIC X(73) VALUE "hrs curr`wt curr`hrs fut 1`wt fut 1`hrs fut 2`wt fut 2`hrs fut 3`wt fut 3".
01  TU-FIELDS.
    02 TU-IXP PIC 99 COMP-3. 02 TU-TITLE PIC X(15).
01  SQ-FIELDS.
    02 SQ-KP PIC 9 COMP-3. 02 SQ-KT PIC 9 COMP-3. 02 SQ-KM PIC 9 COMP-3.
    02 SQ-CLASS PIC X. 02 SQ-STEP PIC 9 COMP-3.
    02 SQ-OCUS PIC X(6). 02 SQ-OPROD PIC X(12).
    02 SQ-MM PIC 99 COMP-3. 02 SQ-YY PIC 99 COMP-3. 02 SQ-NUM PIC 9(4) COMP-3.
    02 SQ-YCUR PIC 9(4). 02 SQ-YPREV PIC 9(4).
    02 SQ-MM1 PIC 99 COMP-3. 02 SQ-MM2 PIC 99 COMP-3.
    02 SQ-KS PIC 9 COMP-3. 02 SQ-IXY PIC S999 COMP-3.
    02 SQ-PTBL. 03 OCCURS 3. 04 SQ-PCODE PIC 999 COMP-3. 04 SQ-PCOST PIC 9(4)V999 COMP-3.
    02 OCCURS 2. 03 SQ-PNET PIC S9(7)V99 COMP-3.
      03 OCCURS 3. 04 SQ-PPLAT PIC S9(7)V99 COMP-3.
    02 SQ-LTOTALS. 03 OCCURS 2. 04 SQ-LTOT PIC S9(9) COMP-3 OCCURS 5.
    02 SQ-ATOTALS. 03 OCCURS 2. 04 SQ-ATOT PIC S9(9) COMP-3 OCCURS 5.
    02 SQ-CTOTALS. 03 SQ-CTOT PIC S9(9) COMP-3 OCCURS 3.
    02 SQ-RTOTALS. 03 SQ-RTOT PIC S9(9) COMP-3 OCCURS 3.
    02 SQ-GTOTALS. 03 SQ-GTOT PIC S9(9) COMP-3 OCCURS 3.
    02 SQ-STOTALS. 03 SQ-STOT PIC S9(9) COMP-3 OCCURS 3.
    02 SQ-PTOTALS. 03 OCCURS 2.
      04 SQ-PWTOT PIC S9(9) COMP-3. 04 SQ-PATOT PIC S9(9)V99 COMP-3.
      04 SQ-PPTOT PIC S9(9)V99 COMP-3. 04 SQ-PNTOT PIC S9(9)V99 COMP-3.
    02 SQ-ZTOTALS. 03 OCCURS 2.
      04 SQ-ZWTOT PIC S9(9) COMP-3. 04 SQ-ZATOT PIC S9(9)V99 COMP-3.
      04 SQ-ZPTOT PIC S9(9)V99 COMP-3. 04 SQ-ZNTOT PIC S9(9)V99 COMP-3.
01  RL-FIELDS.
    02 RL-MM PIC 99 COMP-3. 02 RL-YY PIC 99 COMP-3. 02 RL-DATE PIC 9(6) COMP-3.
    02 RL-STEP PIC 9 COMP-3. 02 RL-KD PIC 9 COMP-3. 02 RL-NUM PIC S9(7) COMP-3.
    02 RL-MTHS PIC S9(5) COMP-3. 02 RL-IXD PIC S9(5) COMP-3. 02 RL-IXE PIC S9(5) COMP-3.
    02 RL-IXC PIC S9(5) COMP-3 OCCURS 3. 02 RL-OA PIC X(50). 02 RL-OB PIC X(50).
01  QA-FIELDS.
    02 QA-CTOTALS. 03 QA-CT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 QA-STOTALS. 03 OCCURS 2. 04 QA-SA PIC S9(9)V99 COMP-3. 04 QA-SD PIC S999V99 COMP-3.
    02 QA-GTOTALS. 03 OCCURS 2. 04 QA-GA PIC S9(9)V99 COMP-3. 04 QA-GD PIC S999V99 COMP-3.
01  TB-FIELDS.
    02 TB-SEL PIC 99 COMP-3. 02 TB-OP PIC 9 COMP-3. 02 TB-TNO PIC 99 COMP-3.
    02 TB-KFIN PIC 9 COMP-3.
01  SY-FIELDS.
    02 SY-TTBL PIC X(104) VALUE
      "1. INV VALUE 2. GST       3. HST       4. PST       5. QST       6. NON SALES 7. NET SALES 8. SURCHARGE ".
    02 REDEFINES SY-TTBL. 03 SY-TDESC PIC X(13) OCCURS 8.
    02 SY-SEL PIC 99 COMP-3. 02 SY-IX1 PIC 9(6) COMP-3.
    02 SY-YY1 PIC 99. 02 SY-YY2 PIC 99.
01  TK-FIELDS.
    02 TK-MO PIC 9(6) COMP-3. 02 TK-RN PIC 99 COMP-3. 02 TK-IXN PIC 9(4) COMP-3.
    02 TK-KODD PIC 9 COMP-3. 02 TK-MAC PIC 99 COMP-3.
    02 TK-OPL. 03 OCCURS 12.
      04 TK-DF1 PIC ZZ9. 04 TK-DF2 PIC X. 04 TK-DF3 PIC X(10). 04 PIC X(4).
    02 REDEFINES TK-OPL. 03 TK-OPLINE PIC X(72) OCCURS 3.
01  WP-FIELDS.
    02 WP-TITLE PIC X(50). 02 WP-KP PIC 9 COMP-3.
    02 WP-RQTY PIC S9(9) COMP-3. 02 WP-RWEIGHT PIC S9(9) COMP-3.
    02 WP-STOTALS. 03 WP-SQTY PIC S9(9) COMP-3. 03 WP-SWEIGHT PIC S9(9) COMP-3.
      03 WP-SQ PIC S9(9) COMP-3. 03 WP-SW PIC S9(9) COMP-3. 03 WP-SR PIC S9(9) COMP-3.
      03 WP-SN PIC S9(9) COMP-3 OCCURS 2.
    02 WP-GTOTALS. 03 WP-GQTY PIC S9(9) COMP-3. 03 WP-GWEIGHT PIC S9(9) COMP-3.
      03 WP-GQ PIC S9(9) COMP-3. 03 WP-GW PIC S9(9) COMP-3. 03 WP-GR PIC S9(9) COMP-3.
      03 WP-GN PIC S9(9) COMP-3 OCCURS 2.
    02 WP-XTOTALS. 03 WP-XQTY PIC S9(9) COMP-3. 03 WP-XWEIGHT PIC S9(9) COMP-3.
      03 WP-XQ PIC S9(9) COMP-3. 03 WP-XW PIC S9(9) COMP-3. 03 WP-XR PIC S9(9) COMP-3.
      03 WP-XN PIC S9(9) COMP-3 OCCURS 2.
01  BN-FIELDS.
    02 BN-OPROD PIC X(12). 02 BN-QTY PIC S9(9) COMP-3. 02 BN-WEIGHT PIC S9(9) COMP-3.
    02 BN-AMT PIC S9(9)V99 COMP-3. 02 BN-STEP PIC 9 COMP-3. 02 BN-IXD PIC 9(6) COMP-3.
    02 BN-DATE PIC 9(6) COMP-3. 02 BN-RN1 PIC S9(9) COMP-3. 02 BN-Q1 PIC S9(9) COMP-3.
    02 BN-WN1 PIC S9(9) COMP-3. 02 BN-WN2 PIC S9(9) COMP-3. 02 BN-WN3 PIC S9(9) COMP-3.
    02 BN-WN4 PIC S9(9) COMP-3. 02 BN-WN5 PIC S9(9) COMP-3. 02 BN-WN6 PIC S9(9) COMP-3.
    02 BN-WNP PIC S9(9) COMP-3 OCCURS 9. 02 BN-WT1 PIC S9(9)V999 COMP-3.
01  JT-FIELDS.
    02 JT-DIAM PIC X(6) OCCURS 5. 02 JT-GRADE PIC X(8) OCCURS 5.
    02 JT-WTOT PIC S9(9) COMP-3.
01  FP-FIELDS.
    02 FP-STEP PIC 9 COMP-3.
    02 FP-CTOTALS. 03 FP-CAMT PIC S9(7)V99 COMP-3. 03 FP-CTOT PIC S9(7)V99 COMP-3.
    02 FP-RTOTALS. 03 FP-RAMT PIC S9(7)V99 COMP-3. 03 FP-RTOT PIC S9(7)V99 COMP-3.
    02 FP-STOTALS. 03 FP-SAMT PIC S9(7)V99 COMP-3. 03 FP-STOT PIC S9(7)V99 COMP-3.
    02 FP-GTOTALS. 03 FP-GAMT PIC S9(7)V99 COMP-3. 03 FP-GTOT PIC S9(7)V99 COMP-3.
01  FT-FIELDS.
    02 FT-SAL PIC 99 COMP-3. 02 FT-STEP PIC 9 COMP-3.
    02 FT-CTOTALS. 03 FT-CQ PIC S9(9) COMP-3. 03 FT-CW PIC S9(9) COMP-3.
      03 FT-CA PIC S9(9)V99 COMP-3.
    02 FT-STOTALS. 03 FT-SQ PIC S9(9) COMP-3. 03 FT-SW PIC S9(9) COMP-3.
      03 FT-SA PIC S9(9)V99 COMP-3.
01  DP-FIELDS.
    02 DP-TARGET PIC S9(9) COMP-3.
    02 DP-GTOTALS. 03 DP-GTOT PIC 9(9)V99 COMP-3 OCCURS 5.
    02 DP-TTOTALS. 03 DP-TTOT PIC 9(9)V99 COMP-3 OCCURS 5.
    02 DP-MTOTALS. 03 DP-MTOT PIC 9(9)V99 COMP-3 OCCURS 5.
01  PO-FIELDS.
    02 PO-CTOTALS. 03 PO-CQTY PIC S9(9) COMP-3.
    02 PO-PTOTALS. 03 PO-PQTY PIC S9(9) COMP-3.
    02 PO-GTOTALS. 03 PO-GQTY PIC S9(9) COMP-3.
01  UP-FIELDS.
    02 UP-TYPE PIC 999. 02 UP-TCATX. 03 UP-TCAT PIC 99 COMP-3 OCCURS 6.
    02 UP-TOTALS. 03 UP-TOT PIC S9(11) COMP-3 OCCURS 3.
01  KS-FIELDS.
    02 KS-R PIC XXX OCCURS 3. 02 KS-KS PIC X. 02 KS-KC PIC X.
    02 KS-STOTALS. 03 KS-SQ PIC S9(9) COMP-3. 03 KS-SW PIC S9(9) COMP-3.
    02 KS-GTOTALS. 03 KS-GQ PIC S9(9) COMP-3. 03 KS-GW PIC S9(9) COMP-3.
01  KL-FIELDS.
    02 KL-PNO PIC X(12). 02 KL-PROD PIC X(12). 02 KL-CAT PIC 99 COMP-3.
    02 KL-QTY PIC S9(9) COMP-3. 02 KL-NUM PIC 99 COMP-3. 02 KL-ROP PIC S9(9) COMP-3.
    02 KL-PSEQ PIC 9(6). 02 KL-STEP PIC 9 COMP-3.
    02 KL-KFIR PIC 9 COMP-3. 02 KL-KDEM PIC 9 COMP-3.
    02 KL-PDATE PIC 9(6) COMP-3. 02 KL-RDATE PIC 9(6) COMP-3.
    02 KL-QMIN PIC S9(9) COMP-3. 02 KL-QMAX PIC S9(9) COMP-3.
    02 KL-TQTY PIC S9(9) COMP-3. 02 KL-PQTY PIC S9(9) COMP-3.
    02 KL-BQTY PIC S9(9) COMP-3. 02 KL-HQTY PIC S9(9) COMP-3.
    02 KL-SQTY PIC S9(9) COMP-3. 02 KL-OQTY PIC S9(9) COMP-3.
    02 KL-FQTY PIC S9(9) COMP-3. 02 KL-CQTY PIC S9(9) COMP-3.
01  KM-FIELDS.
    02 KM-PSEQ PIC 9(6). 02 KM-LNO PIC 9(6). 02 KM-RX PIC 99 COMP-3.
    02 KM-RNO PIC 9(6) OCCURS 10.
    02 KM-RMINTBL PIC X(60) VALUE
      "10001.20001.30001.49001.50001.60001.70001.80001.00000.00000.".
    02 REDEFINES KM-RMINTBL. 03 OCCURS 10. 04 KM-RMIN PIC 9(5). 04 PIC X.
    02 KM-RMAXTBL PIC X(60) VALUE
      "19999.27999.37999.49499.54499.64499.79999.89999.00000.00000.".
    02 REDEFINES KM-RMAXTBL. 03 OCCURS 10. 04 KM-RMAX PIC 9(5). 04 PIC X.
    02 KM-FDATE PIC 9(6) COMP-3. 02 KM-SDATE PIC 9(6) COMP-3.
    02 KM-MTOT PIC S9(5) COMP-3. 02 KM-TNUM PIC 9 COMP-3.
01  KR-FIELDS.
    02 KR-KSEP PIC 9 COMP-3. 02 KR-KSORT PIC 9 COMP-3.
    02 KR-NM PIC 99 COMP-3. 02 KR-MAC PIC 99 COMP-3. 02 KR-HOURS PIC S9(5) COMP-3.
    02 KR-MTOTALS. 03 KR-MQTY PIC S9(9) COMP-3. 03 KR-MHOURS PIC S9(7) COMP-3.
      03 KR-MLATE PIC S9(7) COMP-3 OCCURS 3.

* Z-16: FINANCIAL FUNCTIONS

01  FE-FIELDS.
    02 FE-PWEIGHT PIC S9(9) COMP-3.
    02 FE-STOTALS. 03 FE-SH PIC S9(9) COMP-3. 03 FE-SW PIC S9(9) COMP-3.
      03 FE-SV PIC S9(9)V99 COMP-3.
    02 FE-GTOTALS. 03 FE-GH PIC S9(9) COMP-3. 03 FE-GW PIC S9(9) COMP-3.
      03 FE-GV PIC S9(9)V99 COMP-3.
01  FI-FIELDS.
    02 FI-PTOTALS. 03 FI-PW PIC S9(9)V99 COMP-3. 03 FI-PV PIC S9(9)V99 COMP-3.
    02 FI-GTOTALS. 03 FI-GW PIC S9(9)V99 COMP-3. 03 FI-GV PIC S9(9)V99 COMP-3.
01  HA-FIELDS.
    02 HA-TOTALS. 03 HA-TOT PIC S9(7)V99 COMP-3. 03 HA-CUR PIC S9(7)V99 COMP-3.
      03 HA-30 PIC S9(7)V99 COMP-3. 03 HA-60 PIC S9(7)V99 COMP-3.
      03 HA-90 PIC S9(7)V99 COMP-3. 03 HA-120 PIC S9(7)V99 COMP-3.
01  AI-FIELDS.
    02 AI-KUP PIC 9 COMP-3. 02 AI-PERIOD PIC X(10).
01  AS-FIELDS.
    02 AS-HSEL PIC 9 COMP-3. 02 AS-KSUM PIC 9 COMP-3.
    02 AS-KLST PIC 9 COMP-3. 02 AS-IXP PIC 99 COMP-3. 02 AS-SIND PIC 9 COMP-3.
    02 AS-KRAN PIC 9 COMP-3. 02 AS-VAL PIC S9(7)V99 COMP-3.
    02 AS-QTY PIC S9(9) COMP-3. 02 AS-WEIGHT PIC S9(9) COMP-3.
    02 AS-PERIOD PIC X(10). 02 AS-YEAR PIC 9(4) COMP-3. 02 AS-NUM PIC 99 COMP-3.
    02 AS-MECOST PIC 9(4)V99 COMP-3. 02 AS-HVAL PIC S9(9)V99 COMP-3 OCCURS 3.
    02 AS-CONTRIB PIC S9(9)V99 COMP-3. 02 AS-MARGIN PIC S9(9)V99 COMP-3.
    02 AS-OVERHEAD PIC S9(9)V99 COMP-3. 02 AS-VCT PIC S9(7)V99 COMP-3.
    02 AS-VCD PIC S9(9) COMP-3. 02 AS-VCP PIC S999V9 COMP-3.
    02 AS-VMD PIC S9(9) COMP-3. 02 AS-VMP PIC S999V9 COMP-3.
    02 AS-DCOST PIC S9(9) COMP-3. 02 AS-MCOST PIC S9(9) COMP-3.
    02 AS-RNUM PIC 9(6) COMP-3. 02 AS-PRICE PIC S9(5)V99 COMP-3.
    02 AS-STOTALS. 03 AS-SH PIC S9(9)V99 COMP-3 OCCURS 3.
      03 AS-SA PIC S9(9)V99 COMP-3. 03 AS-SW PIC S9(9) COMP-3.
      03 AS-SC PIC S9(9)V99 COMP-3. 03 AS-SM PIC S9(9)V99 COMP-3.
    02 AS-GTOTALS. 03 AS-GH PIC S9(9)V99 COMP-3 OCCURS 3.
      03 AS-GA PIC S9(9)V99 COMP-3. 03 AS-GW PIC S9(9) COMP-3.
      03 AS-GC PIC S9(9)V99 COMP-3. 03 AS-GM PIC S9(9)V99 COMP-3.
    02 AS-XTOTALS. 03 AS-XH PIC S9(9)V99 COMP-3 OCCURS 3.
      03 AS-XA PIC S9(9)V99 COMP-3. 03 AS-XW PIC S9(9) COMP-3.
      03 AS-XC PIC S9(9)V99 COMP-3. 03 AS-XM PIC S9(9)V99 COMP-3.
    02 AS-HEADLN1.
      03 PIC X(101) VALUE "costing period`year`from mth`to mth`customer`customer name`part`part description`machine`qty on hand`".
      03 PIC X(94) VALUE "last sale date`last sale price`last sale surch`qty`value`tons`contrib/ton`contrib $`contrib %`".
      03 PIC X(94) VALUE "gross mrg $`gross mrg %`direct cost/m`mfg cost/m`lbs`material type`material cost/ton (mode 1)`".
      03 PIC X(97) VALUE "tools cost/1000 (mode 1)`tools cost/1000 (mode 3)`tools cost/ton (mode 1)`tools cost/ton (mode 3)".
    02 AS-HEADLN2 PIC X(63) VALUE "order`part`date reqd`date shipped`days late`contrib $`contrib %".
01  BF-FIELDS.
    02 BF-STEP PIC 9 COMP-3. 02 BF-IX1 PIC S999 COMP-3. 02 BF-KOP PIC 9 COMP-3.
    02 BF-QTY PIC S9(9) COMP-3. 02 BF-VAL PIC S9(7)V999 COMP-3.
    02 BF-PTOTALS. 03 BF-PQ PIC S9(9) COMP-3. 03 BF-PV PIC S9(9)V99 COMP-3.
    02 BF-DTOTALS. 03 BF-DQ PIC S9(9) COMP-3. 03 BF-DV PIC S9(9)V99 COMP-3.
    02 BF-GTOTALS. 03 BF-GQ PIC S9(9) COMP-3. 03 BF-GV PIC S9(9)V99 COMP-3.
01  BJ-FIELDS.
    02 BJ-PROD PIC X(12). 02 BJ-SPRICE PIC 9(4)V999 COMP-3. 02 BJ-KC PIC 9 COMP-3.
    02 OCCURS 6. 03 BJ-XC.
      04 BJ-CUS PIC X(6). 04 BJ-DATE PIC 9(6) COMP-3.
      04 BJ-PRICE PIC 9(4)V999 COMP-3. 04 BJ-US PIC 9 COMP-3.
    02 BJ-HEADLN.
      03 PIC X(110) VALUE "category`product`description`machine`gross wt`net wt`mat grade`material cost`third party cost`conversion cost`".
      03 PIC X(122) VALUE "op 1`cost 1`op 2`cost 2`op 3`cost 3`op 4`cost 4`op 5`cost 5`op 6`cost 6`op 7`cost 7`op 8`cost 8`op 9`cost 9`op 10`cost 10`".
      03 PIC X(92) VALUE "tools cost`cartons cost`direct cost`overhead`total manufacturing cost`suggested price`errors".
01  ER-FIELDS.
    02 ER-STEP PIC 9 COMP-3. 02 ER-WAMT PIC S9(7)V999 COMP-3.
    02 ER-WEIGHT PIC S9(9) COMP-3. 02 ER-COST PIC S9(7)V99 COMP-3.
    02 ER-SKEY PIC X(48). 02 ER-SKL PIC X(48). 02 ER-SF PIC S9(8) COMP-3.
    02 ER-SW PIC 9 COMP-3.
    02 ER-MTOTALS. 03 ER-MQ PIC S9(9) COMP-3. 03 ER-MW PIC S9(9) COMP-3.
      03 ER-MA PIC S9(9)V99 COMP-3.
    02 ER-DTOTALS. 03 ER-DQ PIC S9(9) COMP-3. 03 ER-DW PIC S9(9) COMP-3.
      03 ER-DA PIC S9(9)V99 COMP-3.
    02 ER-GTOTALS. 03 ER-GQ PIC S9(9) COMP-3. 03 ER-GW PIC S9(9) COMP-3.
      03 ER-GA PIC S9(9)V99 COMP-3.
01  FY-FIELDS.
    02 FY-STEP PIC 9 COMP-3.
    02 FY-STOT PIC S9(9)V99 COMP-3. 02 FY-GTOT PIC S9(9)V99 COMP-3.
    02 FY-PART PIC X(12). 02 FY-DESC1 PIC X(32). 02 FY-MODE PIC X(4).
    02 FY-LDCOST PIC 9(6)V999 COMP-3. 02 FY-QTY PIC S9(9) COMP-3.
01  WU-FIELDS.
    02 WU-HEADLN.
      03 PIC X(102) VALUE "account`name`address line 1`address line 2`postal code`prov code`province`mother co cust no.`currency`".
      03 PIC X(108) VALUE "contact line 1`contact line 2`contact line 3`insurance`pay terms code`pay terms days`pay terms`credit limit`".
      03 PIC X(89) VALUE "D&B credit code`GST license`PST license`balance`current`30 days`60 days`90 days`120+ days".
01  QY-FIELDS.
    02 QY-PERC PIC 999 COMP-3. 02 QY-VAR PIC S9(4) COMP-3.
    02 QY-COST1 PIC S9(5)V999 COMP-3. 02 QY-COST2 PIC S9(5)V999 COMP-3.
    02 QY-DIFF PIC S9(5)V999 COMP-3. 02 QY-AMO PIC 9(6) COMP-3.
    02 QY-HEADLN1 PIC X(85) VALUE "product`description`normalized cost`actual cost`difference`variance %`m.o. no.`errors".
    02 QY-HEADLN2 PIC X(82) VALUE "product`description`regular cost`actual cost`difference`variance %`m.o. no.`errors".
01  VQ-FIELDS.
    02 VQ-EDIV PIC 99 COMP-3. 02 VQ-DIV PIC 99 COMP-3. 02 VQ-CUR PIC XXX.
01  OA-FIELDS.
    02 OA-ORD PIC 9(6) COMP-3.
    02 OA-DF1. 03 PIC X VALUE "(". 03 OA-DF1A PIC 99. 03 PIC X VALUE ")".
01  QT-FIELDS.
    02 QT-YY PIC 99. 02 QT-MM PIC 99. 02 QT-KD PIC 9 COMP-3. 02 QT-KS PIC 9 COMP-3.
01  QV-FIELDS.
    02 QV-YY PIC 99. 02 QV-MM PIC 99.

* Z-17: TOOLS FUNCTIONS

01  NL-FIELDS.
    02 NL-KMAC PIC 9 COMP-3. 02 NL-TOTAL PIC S9(7)V99 COMP-3.
01  NQ-FIELDS.
    02 NQ-STEP PIC 9 COMP-3. 02 NQ-ASM PIC 9 COMP-3. 02 NQ-LF PIC 9 COMP-3.
    02 NQ-RQTY PIC S9(9) COMP-3.
01  NR-FIELDS.
    02 NR-ASM PIC 9 COMP-3. 02 NR-STEP PIC 9 COMP-3. 02 NR-LSTEP PIC 9 COMP-3.
    02 NR-KMIN PIC 9 COMP-3. 02 NR-KERR PIC 9 COMP-3. 02 NR-MINROP PIC 9(4) COMP-3.
    02 NR-TOT PIC S9(7)V999 COMP-3. 02 NR-QTY PIC S9(7)V999 COMP-3.
    02 NR-KFIR PIC 9 COMP-3. 02 NR-KPUR PIC 9 COMP-3. 02 NR-IXP PIC S99 COMP-3.
    02 NR-RDATE PIC 9(6) COMP-3. 02 NR-MDATE PIC 9(6) COMP-3.
    02 NR-KSV PIC 9 COMP-3. 02 NR-SVLN PIC 999 COMP-3. 02 NR-STOT PIC S9(7) COMP-3.
    02 OCCURS 10. 03 NR-PDATE PIC 9(6) COMP-3. 03 NR-PQTY PIC S9(9) COMP-3.
    02 NR-QNUM PIC 999 COMP-3. 02 NR-QDT1 PIC 9(6) COMP-3. 02 NR-QDT2 PIC 9(6) COMP-3.
    02 NR-TNUM PIC 999 COMP-3. 02 NR-TQTY PIC S9(9) COMP-3. 02 NR-TMIN PIC S99 COMP-3.
01  NA-FIELDS.
    02 NA-SEL PIC 99 COMP-3.
    02 NA-STBL PIC X(24) VALUE "372.472.366.364.462.363.".
    02 REDEFINES NA-STBL. 03 OCCURS 6.
      04 NA-STN PIC 9. 04 NA-CAT PIC 9. 04 NA-LOC PIC 9. 04 PIC X.
01  NE-FIELDS.
    02 NE-STEP PIC 9 COMP-3.
    02 NE-TTBL PIC X(49) VALUE "DIE   .PCH   .PIN   .      .      .DIE TL.PCH TL.".
    02 REDEFINES NE-TTBL. 03 OCCURS 7. 04 NE-TDESC PIC X(6). 04 PIC X.
01  NF-FIELDS.
    02 NF-KR PIC 9 COMP-3. 02 NF-KL PIC 9 COMP-3. 02 NF-XL PIC S99 COMP-3.
    02 NF-ICOST PIC S9(9)V99 COMP-3.
    02 NF-PTOTALS. 03 NF-PQ PIC S9(9) COMP-3.
      03 OCCURS 4. 04 NF-PC PIC S9(9)V99 COMP-3. 04 NF-PI PIC S9(9)V99 COMP-3.
    02 NF-MTOTALS. 03 NF-MQ PIC S9(9) COMP-3.
      03 OCCURS 4. 04 NF-MC PIC S9(9)V99 COMP-3. 04 NF-MI PIC S9(9)V99 COMP-3.
    02 NF-TTOTALS. 03 NF-TQ PIC S9(9) COMP-3.
      03 OCCURS 4. 04 NF-TC PIC S9(9)V99 COMP-3. 04 NF-TI PIC S9(9)V99 COMP-3.
    02 NF-GTOTALS. 03 NF-GQ PIC S9(9) COMP-3.
      03 OCCURS 4. 04 NF-GC PIC S9(9)V99 COMP-3. 04 NF-GI PIC S9(9)V99 COMP-3.
    02 NF-HEADLN.
      03 PIC X(42) VALUE "dept`sect`machine`product`description`qty`".
      03 PIC X(100) VALUE "(life 1) cost`(life 1) cost/M`(life 1) issue cost`(life 2) cost`(life 2) cost/M`(life 2) issue cost`".
      03 PIC X(111) VALUE "(life 3) cost`(life 3) cost/M`(life 3) issue cost`(life total) cost`(life total) cost/M`(life total) issue cost".
01  NC-FIELDS.
    02 NC-KUP PIC 9 COMP-3.
01  TV-FIELDS.
    02 TV-ODRAW PIC X(14). 02 TV-PART PIC X(12).
01  BV-FIELDS.
    02 BV-ODRAW PIC X(14). 02 BV-PART PIC X(12).
01  TC-FIELDS.
    02 TC-OP PIC 99 COMP-3. 02 TC-PROD PIC X(12). 02 TC-MAC PIC 99 COMP-3.
    02 TC-NF PIC 999 COMP-3.
01  FU-FIELDS.
    02 FU-LASDT PIC 9(6) COMP-3. 02 FU-CURDT PIC 9(6) COMP-3.
    02 FU-HEADLN PIC X(123) VALUE "tool part no.`expected life (000)`actual life (000)`production part no.`qty produced last year (000)`qty produced YTD (000)".

* Z-18: MACHINE AND WORKSHEET FUNCTIONS

01  EA-FIELDS.
    02 EA-DATE PIC 9(6) COMP-3 OCCURS 7.
    02 EA-DAY PIC 99 COMP-3. 02 EA-SHIFT PIC 9 COMP-3.
    02 EA-MFLD. 03 OCCURS 3. 04 OCCURS 7.
      05 EA-HOURS PIC 99V99 COMP-3. 05 EA-RHOURS PIC 99V99 COMP-3.
01  EB-FIELDS.
    02 EB-RN PIC 99 COMP-3. 02 EB-STEP PIC 9 COMP-3. 02 EB-KSAN PIC 9 COMP-3.
    02 EB-WEIGHT PIC S9(9) COMP-3. 02 EB-COST PIC S9(7)V99 COMP-3.
    02 EB-DF1 PIC 999. 02 EB-DF2 PIC 9(4). 02 EB-DF3 PIC 9(4).
    02 EB-NX1 PIC 9 COMP-3. 02 EB-NX2 PIC 9 COMP-3. 02 EB-NX3 PIC 9 COMP-3.
    02 EB-XTOTALS. 03 EB-XN PIC S9(9) COMP-3 OCCURS 3.
      03 EB-XH PIC S9(7)V99 COMP-3. 03 EB-XK PIC S9(7)V99 COMP-3.
    02 EB-MTOTALS. 03 EB-MN PIC S9(9) COMP-3 OCCURS 3.
      03 EB-MH PIC S9(7)V99 COMP-3. 03 EB-MK PIC S9(7)V99 COMP-3.
    02 EB-PTOTALS. 03 EB-PN PIC S9(9) COMP-3 OCCURS 3.
      03 EB-PH PIC S9(7)V99 COMP-3. 03 EB-PK PIC S9(7)V99 COMP-3.
      03 EB-PR PIC S9(5) COMP-3.
    02 EB-ATOTALS. 03 EB-AN PIC S9(9) COMP-3 OCCURS 3.
      03 EB-AH PIC S9(7)V99 COMP-3. 03 EB-AK PIC S9(7)V99 COMP-3.
      03 EB-AR PIC S9(5) COMP-3. 03 EB-AP PIC S9(5) COMP-3.
    02 EB-GTOTALS. 03 EB-GN PIC S9(9) COMP-3 OCCURS 3.
      03 EB-GH PIC S9(7)V99 COMP-3. 03 EB-GK PIC S9(7)V99 COMP-3.
      03 EB-GR PIC S9(5) COMP-3. 03 EB-GP PIC S9(5) COMP-3.
    02 EB-DTOTALS. 03 EB-DQ PIC S9(9) COMP-3. 03 EB-DW PIC S9(9) COMP-3.
      03 EB-DH PIC S9(7)V99 COMP-3. 03 EB-DC PIC S9(9)V99 COMP-3.
    02 EB-STOTALS. 03 EB-SQ PIC S9(9) COMP-3. 03 EB-SW PIC S9(9) COMP-3.
      03 EB-SH PIC S9(7)V99 COMP-3. 03 EB-SC PIC S9(9)V99 COMP-3.
01  EC-FIELDS.
    02 EC-STOTALS. 03 EC-SN PIC S9(9) COMP-3 OCCURS 5.
    02 EC-GTOTALS. 03 EC-GN PIC S9(9) COMP-3 OCCURS 5.
01  EM-FIELDS.
    02 EM-HEADLN.
      03 PIC X(98) VALUE "mac/proc`description 1`description 2`operation`target prod`target weight`hours/day`cost`cost mode`".
      03 PIC X(66) VALUE "lead days`lot chg`batch chg`surchg %`freight/ton`group`type`sector".
01  JR-FIELDS.
    02 JR-FDATE PIC 9(6) COMP-3.
    02 JR-HEADLN.
      03 PIC X(103) VALUE "machine`M.O. no.`close date`product no.`1:run time`2:training run time`3:setup time`4:downtime tooling`".
      03 PIC X(115) VALUE "5:downtime material`6:downtime maint`7:rework`8:machine verify`9:operator not avail`pieces produced`weight produced".
01  EF-FIELDS.
    02 EF-PERIOD PIC X(20). 02 EF-DESC PIC X(40). 02 EF-TARGET PIC S9(9) COMP-3.
    02 EF-MACHINE PIC 99 COMP-3.
    02 EF-IX1 PIC 99 COMP-3. 02 EF-IX2 PIC 99 COMP-3. 02 EF-IX3 PIC 99 COMP-3.
    02 EF-TOTALS. 03 OCCURS 20.
      04 EF-CAT PIC 99 COMP-3. 04 EF-ROP PIC 9(9) COMP-3.
      04 EF-NUM PIC 9(4) COMP-3. 04 EF-ZNUM PIC 9(4) COMP-3.
    02 EF-CTOTALS. 03 OCCURS 4.
      04 EF-CROP PIC 9(9) COMP-3. 04 EF-CNUM PIC 9(4) COMP-3.
      04 EF-CZNUM PIC 9(4) COMP-3.
    02 EF-GTOTALS. 03 EF-GROP PIC 9(9) COMP-3. 03 EF-GNUM PIC 9(4) COMP-3.
      03 EF-GZNUM PIC 9(4) COMP-3.
01  NM-FIELDS.
    02 NM-YY PIC 99 COMP-3. 02 NM-MM PIC 99 COMP-3. 02 NM-KYTD PIC 9 COMP-3.
    02 NM-GROUP PIC 99. 02 NM-PDAYS PIC 99 COMP-3.
    02 NM-DT. 03 NM-DTM PIC X(4). 03 NM-DTY PIC 9(4). 03 NM-DTL PIC X(4).
    02 NM-STOTALS. 03 NM-ST PIC S9(7) COMP-3. 03 NM-SQ PIC S9(7) COMP-3.
      03 NM-SW PIC S9(7) COMP-3.
    02 NM-GTOTALS. 03 NM-GT PIC S9(7) COMP-3. 03 NM-GQ PIC S9(7) COMP-3.
      03 NM-GW PIC S9(7) COMP-3.
    02 NM-XTOTALS. 03 NM-XT PIC S9(7) COMP-3. 03 NM-XQ PIC S9(7) COMP-3.
      03 NM-XW PIC S9(7) COMP-3.
01  EG-FIELDS.
    02 EG-STEP PIC 9 COMP-3. 02 EG-RSEQ PIC 9(5) COMP-3.
    02 EG-TTOT PIC S9(5)V99 COMP-3. 02 EG-ETOT PIC S9(5)V99 COMP-3.
01  JB-FIELDS.
    02 JB-LEFT PIC S9(9) COMP-3. 02 JB-NUM PIC S9(5) COMP-3.
    02 JB-MTOTALS. 03 JB-MTOT PIC S9(7) COMP-3 OCCURS 4.
    02 JB-TTOTALS. 03 JB-TTOT PIC S9(7) COMP-3 OCCURS 4.
01  JL-FIELDS.
    02 JL-EDATE PIC X(10). 02 JL-LAST PIC X(17). 02 JL-FIRST PIC X(17).
    02 JL-DF1 PIC 9(4). 02 JL-DF2 PIC 99. 02 JL-DF3 PIC 99.
    02 JL-DN1 PIC 9 COMP-3. 02 JL-DN2 PIC 9 COMP-3. 02 JL-DN3 PIC 9 COMP-3.
01  EQ-FIELDS.
    02 EQ-STEP PIC 9 COMP-3. 02 EQ-WEIGHT PIC S9(9) COMP-3.
    02 EQ-PTOTALS. 03 EQ-PQ PIC S9(9) COMP-3. 03 EQ-PW PIC S9(9) COMP-3.
      03 EQ-PR PIC S9(5) COMP-3.
    02 EQ-ATOTALS. 03 EQ-AQ PIC S9(9) COMP-3. 03 EQ-AW PIC S9(9) COMP-3.
      03 EQ-AR PIC S9(5) COMP-3. 03 EQ-AP PIC S9(5) COMP-3.
    02 EQ-GTOTALS. 03 EQ-GQ PIC S9(9) COMP-3. 03 EQ-GW PIC S9(9) COMP-3.
      03 EQ-GR PIC S9(5) COMP-3. 03 EQ-GP PIC S9(5) COMP-3.
    02 EQ-STOTALS. 03 OCCURS 4. 04 EQ-SQ PIC S9(9) COMP-3. 04 EQ-SW PIC S9(9) COMP-3.
    02 EQ-STABLE PIC X(36) VALUE "BOLTS   .STUDS   .MAN NUTS.PUR NUTS.".
    02 REDEFINES EQ-STABLE. 03 OCCURS 4. 04 EQ-SDESC PIC X(8). 04 PIC X.
01  KQ-FIELDS.
    02 KQ-PMAC PIC 999 COMP-3. 02 KQ-SMAC PIC 999 COMP-3.
01  EH-FIELDS.
    02 EH-STEP PIC 9 COMP-3.
01  EY-FIELDS.
    02 EY-DAYS PIC 999 COMP-3. 02 EY-PERC PIC 999 COMP-3.
01  NY-FIELDS.
    02 NY-OP PIC 9 COMP-3. 02 NY-SHIFT PIC 9 COMP-3. 02 NY-EFF PIC 999 COMP-3.
    02 NY-DATE PIC 9(6) COMP-3. 02 NY-YY PIC 99 COMP-3. 02 NY-MM PIC 99 COMP-3.
    02 NY-KP PIC 9 COMP-3. 02 NY-YSZ PIC 9(4).
    02 NY-TOTALS. 03 NY-TT PIC S9(9) COMP-3. 03 NY-TQ PIC S9(9) COMP-3.
      03 NY-TW PIC S9(5)V9 COMP-3.
01  EK-FIELDS.
    02 EK-OP PIC 9 COMP-3. 02 EK-KFIN PIC 9 COMP-3.
01  GE-FIELDS.
    02 GE-IXT PIC 99 COMP-3. 02 GE-OP PIC 9 COMP-3. 02 GE-KFIN PIC 9 COMP-3.
    02 GE-IXL PIC 99 COMP-3. 02 GE-MAT PIC X(12). 02 GE-CLEAN PIC 9 COMP-3.
    02 GE-MAC PIC 99 COMP-3. 02 GE-MDESC PIC X(30).
    02 GE-PROD PIC X(12). 02 GE-DESC PIC X(32). 02 GE-ALERT PIC 999 COMP-3.
    02 GE-QTY PIC S9(9) COMP-3. 02 GE-COILS PIC 999V9 COMP-3.
    02 GE-LND. 03 GE-LD1 PIC X(12). 03 GE-LD2 PIC BBX(32). 03 GE-LD3 PIC ZZZ,ZZZ,ZZ9.
      03 GE-LD4 PIC BBX(12). 03 GE-LD5 PIC ZZ9. 03 GE-LD6 PIC Z(6)9.9.
      03 PIC X(32). 03 GE-LD7 PIC Z(4).
    02 GE-PDT. 03 GE-DT PIC 99/99/99.
      03 GE-TH PIC ZZ99. 03 PIC X VALUE ":". 03 GE-TM PIC 99.
    02 GE-LNP1. 03 GE-LX1 PIC X(13). 03 GE-LP1 PIC Z9. 03 GE-LP2 PIC X.
      03 GE-LP3 PIC Z(6)9. 03 GE-LP4 PIC BBX(12). 03 GE-LP5 PIC BBX(32).
      03 GE-LX2 PIC X(13). 03 GE-LP6 PIC Z(6).
    02 GE-LNP2. 03 GE-LX3 PIC X(13). 03 PIC X(11). 03 GE-LP7 PIC ZZZ,ZZZ,ZZ9BB.
      03 GE-LX4 PIC X(13). 03 GE-LP8 PIC X(12). 03 GE-LX5 PIC X(13).
      03 GE-LP9 PIC ZZ9. 03 GE-LP10 PIC Z(4)9.9. 03 GE-LP11 PIC B(4)X(30).
01  EW-FIELDS.
    02 EW-NO PIC 9(4). 02 EW-OP PIC 9. 02 EW-FLD PIC 99. 02 EW-ONO PIC 9(4).

* Z-19: RAW MATERIALS FUNCTIONS

01  RA-FIELDS.
    02 RA-WEIGHT PIC S9(9) COMP-3. 02 RA-DIAM PIC X(6). 02 RA-GRADE PIC X(6).
    02 RA-MAT PIC X(12). 02 RA-IXP PIC S99 COMP-3.
    02 RA-TOT PIC S9(9) COMP-3. 02 RA-TOTP PIC S9(9) COMP-3.
    02 RA-LSTEP PIC 9 COMP-3. 02 RA-KFIR PIC 9 COMP-3. 02 RA-KPUR PIC 9 COMP-3.
    02 RA-RDATE PIC 9(6) COMP-3. 02 RA-MDATE PIC 9(6) COMP-3.
    02 RA-MILL-CYCLE PIC X(4). 02 RA-MILL-DATE PIC 9(6) COMP-3.
    02 OCCURS 10. 03 RA-PDATE PIC 9(6) COMP-3. 03 RA-PQTY PIC S9(9) COMP-3.
    02 RA-STOTALS. 03 RA-STOT PIC S9(9) COMP-3 OCCURS 2.
    02 RA-GTOTALS. 03 RA-GTOT PIC S9(9) COMP-3 OCCURS 2.
    02 RA-QNUM PIC 999 COMP-3. 02 RA-QDT1 PIC 9(6) COMP-3. 02 RA-QDT2 PIC 9(6) COMP-3.
01  RH-FIELDS.
    02 RH-KBIN PIC 9 COMP-3.
01  RQ-FIELDS.
    02 RQ-LN PIC 99 COMP-3. 02 RQ-KPR PIC 9 COMP-3. 02 RQ-KSP PIC 9 COMP-3.
    02 RQ-WWEIGHT PIC S9(9) COMP-3. 02 RQ-PWEIGHT PIC S9(9) COMP-3.
    02 RQ-MWEIGHT PIC S9(9) COMP-3. 02 RQ-GWEIGHT PIC S9(9) COMP-3.
01  RT-FIELDS.
    02 RT-LN PIC 99 COMP-3. 02 RT-LEFT PIC S9(9) COMP-3.
    02 RT-WTOTALS. 03 RT-WTOT PIC S9(11) COMP-3 OCCURS 4.
    02 RT-PTOTALS. 03 RT-PTOT PIC S9(11) COMP-3 OCCURS 4.
    02 RT-MTOTALS. 03 RT-MTOT PIC S9(11) COMP-3 OCCURS 4.
    02 RT-GTOTALS. 03 RT-GTOT PIC S9(11) COMP-3 OCCURS 4.
01  RC-FIELDS.
    02 RC-DIAM PIC X(6). 02 RC-GRADE PIC X(5).
    02 RC-MDATE PIC 9(6) COMP-3. 02 RC-MWEI PIC S9(7) COMP-3.
    02 RC-PWEI PIC S9(7) COMP-3. 02 RC-LWEI PIC S9(7) COMP-3.
01  RF-FIELDS.
    02 RF-HTOTALS. 03 RF-HW PIC S9(7) COMP-3. 03 RF-HV PIC S9(7)V99 COMP-3.
    02 RF-GTOTALS. 03 RF-GW PIC S9(7) COMP-3. 03 RF-GV PIC S9(7)V99 COMP-3.
01  RY-FIELDS.
    02 RY-YEAR PIC 9(4) COMP-3.
    02 RY-PTOTALS. 03 RY-PTOT PIC S9(9) COMP-3 OCCURS 6.
    02 RY-GTOTALS. 03 RY-GTOT PIC S9(9) COMP-3 OCCURS 6.
01  RJ-FIELDS.
    02 RJ-STEP PIC 9 COMP-3. 02 RJ-KUP PIC 9 COMP-3.
    02 RJ-KP PIC 9 COMP-3. 02 RJ-KM PIC 9 COMP-3. 02 RJ-KB PIC 9 COMP-3.
    02 RJ-BIN PIC X(8). 02 REDEFINES RJ-BIN. 03 PIC X(4). 03 RJ-BN1 PIC 9.
    02 REDEFINES RJ-BIN. 03 PIC X(4). 03 RJ-BN2 PIC 99.
    02 RJ-PART PIC X(12). 02 RJ-HEAT PIC X(10). 02 RJ-PCODE PIC 9 COMP-3.
    02 RJ-COILS PIC 999 COMP-3. 02 RJ-AVG PIC 9(5) COMP-3.
    02 RJ-QTY PIC 9(7) COMP-3. 02 RJ-DATE PIC 9(6) COMP-3.
01  IK-FIELDS.
    02 IK-DN PIC S9(7) COMP-3 OCCURS 5. 02 IK-IXN PIC S99 COMP-3.
    02 IK-PQTY PIC S9(7) COMP-3. 02 IK-MQTY PIC S9(7) COMP-3.
    02 IK-DATE PIC 9(6) COMP-3.
01  RK-FIELDS.
    02 RK-DT PIC 9(6) COMP-3 OCCURS 9.
    02 RK-XTOTALS. 03 RK-XTOT PIC S9(9) COMP-3 OCCURS 9.
    02 RK-PTOTALS. 03 RK-PTOT PIC S9(9) COMP-3 OCCURS 9.
    02 RK-MTOTALS. 03 RK-MTOT PIC S9(9) COMP-3 OCCURS 9.
    02 RK-GTOTALS. 03 RK-GTOT PIC S9(9) COMP-3 OCCURS 9.
    02 RK-HEADLN. 03 RK-HD1 PIC X(16).
      03 OCCURS 7. 04 RK-HD2 PIC X(6). 04 RK-HD3 PIC 99/99/99.
      03 RK-HD4 PIC X. 03 RK-HD5 PIC 99/99/99. 03 RK-HD6 PIC XXX. 03 RK-HD7 PIC 99/99/99.
      03 RK-HD8 PIC X. 03 RK-HD9 PIC 99/99/99. 03 RK-HD10 PIC X(10).

* Z-20: PURCHASING AND A/P FUNCTIONS

01  II-FIELDS.
    02 II-KSHORT PIC 9 COMP-3. 02 II-KFULL PIC 9 COMP-3. 02 II-KTRAN PIC 9 COMP-3.
    02 II-KPR PIC 9 COMP-3. 02 II-NP2 PIC 99 COMP-3. 02 II-NP3 PIC 99 COMP-3.
    02 II-MIN PIC S9(7) COMP-3. 02 II-VAL PIC S9(9)V99 COMP-3.
    02 II-SUR PIC S9(7) COMP-3. 02 II-GROUP PIC 9(4) COMP-3. 02 II-OGROUP PIC 999 COMP-3.
    02 II-XTOTALS. 03 II-XPRICE PIC 9(6)V999 COMP-3 OCCURS 9.
      03 II-XPTOT. 04 OCCURS 9. 05 II-XPH PIC S9(9) COMP-3. 05 II-XPV PIC S9(9)V99 COMP-3.
    02 II-MTOTALS. 03 II-MH PIC S9(9) COMP-3. 03 II-MV PIC S9(9)V99 COMP-3.
      03 II-MPTOT. 04 OCCURS 9. 05 II-MPH PIC S9(9) COMP-3. 05 II-MPV PIC S9(9)V99 COMP-3.
    02 II-CTOTALS. 03 II-CH PIC S9(9) COMP-3. 03 II-CV PIC S9(9)V99 COMP-3.
      03 II-CPTOT. 04 OCCURS 9. 05 II-CPH PIC S9(9) COMP-3. 05 II-CPV PIC S9(9)V99 COMP-3.
    02 II-RTOTALS. 03 II-RH PIC S9(9) COMP-3. 03 II-RV PIC S9(9)V99 COMP-3.
      03 II-RPTOT. 04 OCCURS 9. 05 II-RPH PIC S9(9) COMP-3. 05 II-RPV PIC S9(9)V99 COMP-3.
    02 II-GTOTALS. 03 II-GH PIC S9(9) COMP-3. 03 II-GV PIC S9(9)V99 COMP-3.
      03 II-GPTOT. 04 OCCURS 9. 05 II-GPH PIC S9(9) COMP-3. 05 II-GPV PIC S9(9)V99 COMP-3.
    02 II-ATOTALS. 03 II-AS PIC S9(9) COMP-3. 03 II-AV PIC S9(9)V99 COMP-3.
    02 II-STOTALS. 03 II-SS PIC S9(9) COMP-3. 03 II-SV PIC S9(9)V99 COMP-3.
    02 II-TRTBL. 03 II-TRX OCCURS 5.
      04 II-TRANS PIC XXX. 04 II-TDATE PIC 9(6) COMP-3. 04 II-TQTY PIC S9(9) COMP-3.
    02 II-HEADLN1.
      03 II-HEADLN2.
        04 PIC X(83) VALUE "part`cat`drawing`part description`on hand`on order`blanket`demand`life`ROP`level 3`".
        04 PIC X(63) VALUE "laid-down cost`last pur price`last pur date`value on hand`DM`BL".
      03 PIC X(105) VALUE "`trans 1`date 1`qty 1`trans 2`date 2`qty 2`trans 3`date 3`qty 3`trans 4`date 4`qty 4`trans 5`date 5`qty 5".
01  BD-FIELDS.
    02 BD-KBIN PIC 9 COMP-3. 02 BD-KMAT PIC 9 COMP-3.
    02 BD-GTOTALS. 03 BD-GQ PIC S9(9) COMP-3. 03 BD-GC PIC S9(5) COMP-3.
01  PN-FIELDS.
    02 PN-KFIN PIC 9 COMP-3.
01  DV-FIELDS.
    02 DV-ORD PIC X(8). 02 DV-IXD PIC 999 COMP-3.
01  PD-FIELDS.
    02 PD-VAMT PIC S9(9)V99 COMP-3. 02 PD-GAMT PIC S9(9)V99 COMP-3.
01  PA-FIELDS.
    02 PA-STEP PIC 9 COMP-3. 02 PA-KEF PIC 9 COMP-3. 02 PA-KFIN PIC 9 COMP-3.
    02 PA-KRAN PIC 9 COMP-3. 02 PA-TITLE PIC X(52).
    02 PA-PART PIC X(12). 02 PA-GRADE PIC X(8). 02 PA-WEIGHT PIC S9(9) COMP-3.
    02 PA-CAT PIC 99 COMP-3. 02 PA-NGL PIC 99 COMP-3. 02 PA-LDA PIC S9(9)V99 COMP-3.
    02 PA-VTOTALS. 03 PA-VQTY PIC S9(9) COMP-3. 03 PA-VWEIGHT PIC S9(9) COMP-3.
      03 PA-VAMT PIC S9(9)V99 COMP-3. 03 PA-VLDA PIC S9(9)V99 COMP-3.
      03 PA-VLQTY PIC S9(9) COMP-3.
    02 PA-CTOTALS. 03 PA-CQTY PIC S9(9) COMP-3. 03 PA-CWEIGHT PIC S9(9) COMP-3.
      03 PA-CAMT PIC S9(9)V99 COMP-3. 03 PA-CLDA PIC S9(9)V99 COMP-3.
      03 PA-CLQTY PIC S9(9) COMP-3.
    02 PA-GTOTALS. 03 PA-GQTY PIC S9(9) COMP-3. 03 PA-GWEIGHT PIC S9(9) COMP-3.
      03 PA-GAMT PIC S9(9)V99 COMP-3. 03 PA-GLDA PIC S9(9)V99 COMP-3.
      03 PA-GLQTY PIC S9(9) COMP-3.
01  GD-FIELDS.
    02 GD-GL1 PIC 9(6) OCCURS 10. 02 GD-OA PIC S9(18). 02 GD-KFUL PIC 9 COMP-3.
    02 GD-YY PIC 99. 02 GD-MM PIC 99. 02 GD-GAMT PIC S9(9)V99 COMP-3.
    02 GD-SQTY PIC S9(9) COMP-3. 02 GD-SAMT PIC S9(9)V99 COMP-3.
01  JA-FIELDS.
    02 JA-OGROUP PIC 999 COMP-3. 02 JA-GROUP PIC 9(4) COMP-3.
    02 JA-COST PIC S9(7)V99 COMP-3. 02 JA-BAMT PIC S9(7)V99 COMP-3.
    02 JA-CTOTALS. 03 JA-CA PIC S9(9) COMP-3. 03 JA-CB PIC S9(9)V99 COMP-3.
    02 JA-RTOTALS. 03 JA-RA PIC S9(9) COMP-3. 03 JA-RB PIC S9(9)V99 COMP-3.
    02 JA-GTOTALS. 03 JA-GA PIC S9(9) COMP-3. 03 JA-GB PIC S9(9)V99 COMP-3.
01  JI-FIELDS.
    02 JI-NO PIC 9(6). 02 JI-PROD PIC X(12).
    02 JI-IXC PIC S99 COMP-3. 02 JI-CNUM PIC S99 COMP-3.
    02 OCCURS 3. 03 JI-CMAC PIC 999 COMP-3. 03 JI-CDAYS PIC 999 COMP-3.
      03 JI-CCON PIC X(10).
    02 JI-OMAC PIC 999 COMP-3. 02 JI-IMAC PIC 999 COMP-3.
    02 JI-ODATE PIC 9(6) COMP-3. 02 JI-IDATE PIC 9(6) COMP-3.
    02 JI-OWEIGHT PIC S9(9) COMP-3. 02 JI-IWEIGHT PIC S9(9) COMP-3.
    02 JI-VTOTALS. 03 JI-VW PIC S9(9) COMP-3. 03 JI-VL PIC S9(9) COMP-3.
    02 JI-GTOTALS. 03 JI-GW PIC S9(9) COMP-3. 03 JI-GL PIC S9(9) COMP-3.
01  FN-FIELDS.
    02 FN-PTOTALS. 03 FN-PV PIC S9(9)V99 COMP-3.
    02 FN-GTOTALS. 03 FN-GV PIC S9(9)V99 COMP-3.
01  QP-FIELDS.
    02 QP-STEP PIC 9 COMP-3. 02 QP-BMO PIC 9(6) COMP-3.
    02 QP-IXM PIC S999 COMP-3. 02 QP-IXL PIC S999 COMP-3.
    02 QP-MO PIC 9(6) COMP-3 OCCURS 10.
    02 QP-OPX. 03 OCCURS 13. 04 QP-OP PIC 999 COMP-3. 04 QP-QTY PIC S9(5) COMP-3.
01  QD-FIELDS.
    02 QD-KERR PIC 9 COMP-3. 02 QD-LN PIC 99 COMP-3. 02 QD-DESC PIC X(32).
01  AP-FIELDS.
    02 AP-KEF PIC 9 COMP-3. 02 AP-KVEN PIC 9 COMP-3.
    02 AP-TOT1 PIC S9(9)V99 COMP-3. 02 AP-TOT2 PIC S9(9)V99 COMP-3.
    02 AP-TOT3 PIC S9(9)V99 COMP-3.
01  AV-FIELDS.
    02 AV-KADD PIC 9 COMP-3. 02 AV-KCOM PIC 9 COMP-3. 02 AV-KBAL PIC 9 COMP-3.
    02 AV-GROSS PIC S9(9)V99 COMP-3 OCCURS 2. 02 AV-NET PIC S9(9)V99 COMP-3 OCCURS 2.
    02 AV-CTOTALS. 03 OCCURS 2. 04 AV-CTOT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 AV-STOTALS. 03 OCCURS 2. 04 AV-STOT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 AV-GTOTALS. 03 OCCURS 2. 04 AV-GTOT PIC S9(9)V99 COMP-3 OCCURS 6.
01  CR-FIELDS.
    02 CR-KOUT PIC 9 COMP-3.
    02 CR-WTOTALS. 03 OCCURS 2. 04 CR-WTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 CR-GTOTALS. 03 OCCURS 3. 04 CR-GTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 CR-HEADLN PIC X(58) VALUE "vendor name`vendor no.`vendor class`cheque amount`currency".
01  PC-FIELDS.
    02 PC-PR1 PIC 99 COMP-3. 02 PC-PR2 PIC 99 COMP-3. 02 PC-PRA PIC X(40).
    02 PC-LN PIC 999 COMP-3. 02 PC-LNUM PIC 999 COMP-3. 02 PC-KOLD PIC 9 COMP-3.
    02 PC-KSP PIC 9 COMP-3. 02 PC-KFIR PIC 9 COMP-3. 02 PC-KAL PIC 9 COMP-3.
    02 PC-RHEAD PIC X(80). 02 PC-NAD PIC X(36) OCCURS 4.
* note 152
    02 PC-ATOTALS. 03 PC-NET PIC S9(9)V99 COMP-3. 03 PC-GROSS PIC S9(9)V99 COMP-3.
      03 OCCURS 2. 04 PC-VNET PIC S9(9)V99 COMP-3. 04 PC-VGROSS PIC S9(9)V99 COMP-3.
    02 PC-GTOTALS. 03 PC-GTOT PIC S9(9)V99 COMP-3 OCCURS 3.
    02 PC-HEADLN PIC X(49) VALUE "vendor name`vendor no.`vendor class`cheque amount".
01  QC-FIELDS.
    02 QC-STEP PIC 9 COMP-3.
    02 QC-CTOTALS. 03 OCCURS 2. 04 QC-CTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 QC-GTOTALS. 03 QC-GTOT PIC S9(9)V99 COMP-3 OCCURS 2.
01  GL-FIELDS.
    02 GL-OA PIC S9(18). 02 GL-OB PIC S9(18). 02 GL-OC PIC S9(18). 02 GL-OX PIC 9(9).
    02 GL-MTH PIC 9(6) COMP-3. 02 GL-MTH1 PIC 9(6) COMP-3. 02 GL-MTH2 PIC 9(6) COMP-3.
    02 GL-ATOTALS. 03 GL-ATOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 GL-BTOTALS. 03 GL-BTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 GL-CTOTALS. 03 GL-CTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 GL-GTOTALS. 03 GL-GTOT PIC S9(9)V99 COMP-3 OCCURS 2.
01  PY-FIELDS.
    02 PY-STEP PIC 9 COMP-3. 02 PY-MTHS PIC 9(6) COMP-3.
    02 PY-VTOTALS. 03 PY-VTOT PIC S9(9)V99 COMP-3 OCCURS 6.
    02 PY-STOTALS. 03 OCCURS 3. 04 OCCURS 3. 05 PY-STOT PIC S9(9)V99 COMP-3 OCCURS 6.
01  IH-FIELDS.
    02 IH-OLDNO PIC X(8). 02 IH-FOB PIC X(15). 02 IH-DISC PIC 99V99 COMP-3.
    02 IH-LOT-CHARGE PIC 999V99 COMP-3. 02 IH-BATCH-CHARGE PIC 999V99 COMP-3.
    02 IH-SURCHARGE PIC 99V99 COMP-3. 02 IH-FRPAY PIC 9 COMP-3.
    02 IH-FSTD PIC 999V99 COMP-3. 02 IH-FRATE PIC 99V99 COMP-3.
    02 IH-TWEIGHT PIC S9(7) COMP-3. 02 IH-PFREIGHT PIC S9(5)V99 COMP-3.
    02 IH-PSTPAY PIC 9 COMP-3. 02 IH-US PIC 9 COMP-3. 02 IH-IXR PIC 99 COMP-3.
    02 IH-ORD PIC X(8) OCCURS 30. 02 IH-NORD PIC 99 COMP-3. 02 IH-ERR PIC 9 COMP-3.
    02 IH-QTY PIC S9(9) COMP-3. 02 IH-AMT PIC S9(9)V99 COMP-3.
    02 IH-LDAMT PIC S9(9)V99 COMP-3. 02 IH-LDCOST PIC 9(6)V999 COMP-3.
    02 IH-COST PIC 9(4)V999 COMP-3. 02 IH-CMODE PIC X. 02 IH-IXE PIC 99 COMP-3.
01  VE-FIELDS.
    02 VE-HEADLN.
      03 PIC X(82) VALUE "vendor no.`name`address line 1`address line 2`postal code`currency`GST`comm class`".
      03 PIC X(95) VALUE "purch YTD (mx$)`purch last yr (mx$)`contact info 1`contact info 2`contact info 3`contact info 4".
01  SP-FIELDS.
    02 SP-OP PIC 99 COMP-3. 02 SP-US PIC 9 COMP-3.
    02 SP-JDESC PIC X(25). 02 SP-SMTHS PIC 9(6) COMP-3.
    02 SP-MTHS PIC 9(6) COMP-3. 02 SP-YY PIC 99. 02 SP-PERIOD PIC 99.
    02 SP-ENTRY-DATE PIC 9(6). 02 SP-EFFECTIVE-DATE PIC 9(6).
    02 SP-LEDGER PIC X(4). 02 SP-ENTITY PIC X(4). 02 SP-JOURNAL PIC X(4).
    02 SP-BATCH PIC 9(4) COMP-3. 02 SP-LNUM PIC 9(6) COMP-3.
    02 SP-DEBIT PIC S9(9)V99 COMP-3. 02 SP-CREDIT PIC S9(9)V99 COMP-3.
    02 SP-OGL PIC 9(18). 02 SP-ONGL PIC 9(18). 02 SP-ODESC PIC X(25).
    02 SP-AMT PIC S9(9)V99 COMP-3. 02 SP-TOT PIC S9(9)V99 COMP-3.
    02 SP-CTOT PIC S9(9)V99 COMP-3. 02 SP-PTOT PIC S9(9)V99 COMP-3.
    02 SP-PROOF PIC S9(9)V99 COMP-3. 02 SP-IXF PIC 99 COMP-3. 02 SP-IXG PIC 99 COMP-3.
    02 SP-STABLE.
      03 PIC X(95) VALUE "345621000000000000.345622000000000000.722301000000000000.721601000000000000.754801000000000114.".
      03 PIC X(95) VALUE "754801000000000117.720701000000000000.562135071010000000.562115071010000000.346841000000000000.".
      03 PIC X(95) VALUE "722321000000000000.347409000000000000.235859029020000000.236403099030000000.721601000000000000.".
      03 PIC X(95) VALUE "720701000000000000.722301000000000000.236403099030000000.342233200000000000.344441000000000000.".
      03 PIC X(95) VALUE "342233200000000000.341921000000000114.341921000000000117.341921000000000104.754821000000000104.".
      03 PIC X(38) VALUE "341922000000000114.753501000000000114.".
    02 REDEFINES SP-STABLE. 03 OCCURS 27. 04 SP-SGL PIC 9(18). 04 PIC X.
    02 SP-FTABLE PIC X(81) VALUE "22.23.24.01.02.03.04.05.06.25.07.08.09.10.11.12.13.14.15.16.17.18.19.20.21.26.27.".
    02 REDEFINES SP-FTABLE. 03 OCCURS 27. 04 SP-FPOS PIC 99. 04 PIC X.
01  DI-FIELDS.
    02 DI-OINV PIC X(15). 02 DI-OORD PIC X(8).
    02 DI-ITOTALS. 03 DI-US PIC 9 COMP-3. 03 DI-TOTAL PIC S9(9)V99 COMP-3.
      03 DI-DISC PIC S9(7)V99 COMP-3. 03 DI-FREIGHT PIC S9(7)V99 COMP-3.
      03 DI-FRPAY PIC 9 COMP-3. 03 DI-GST PIC S9(7)V99 COMP-3.
      03 DI-PST PIC S9(7)V99 COMP-3.
01  UR-FIELDS.
    02 UR-STEP PIC 9 COMP-3. 02 UR-KW1 PIC 9 COMP-3.
    02 UR-IXW PIC 99 COMP-3. 02 UR-IXL PIC 99 COMP-3. 02 UR-IXE PIC 99 COMP-3.
    02 UR-WEEKS. 03 OCCURS 20.
      04 UR-DATE PIC 9(6) COMP-3.
      04 UR-WTOTALS. 05 UR-WTOT PIC S9(9)V99 COMP-3 OCCURS 2.
    02 UR-TOTALS. 03 UR-TOT PIC S9(9) COMP-3 OCCURS 2.

PROCEDURE DIVISION.
DECLARATIVES.
SEC-001 SECTION 0.
    USE AFTER ERROR PROCEDURE INPUT.
USE-1. MOVE "INPUT" TO DCL-F1 PERFORM USE-DIS.
SEC-002 SECTION 0.
    USE AFTER ERROR PROCEDURE OUTPUT.
USE-2. MOVE "OUTPUT" TO DCL-F1 PERFORM USE-DIS.
SEC-003 SECTION 0.
    USE AFTER ERROR PROCEDURE I-O.
USE-3. IF NOT(DSTAT="02" OR "90" OR "92") MOVE "I-O" TO DCL-F1 PERFORM USE-DIS.
SEC-004 SECTION 0.
    USE AFTER ERROR PROCEDURE EXTEND.
USE-4. MOVE "EXTEND" TO DCL-F1 PERFORM USE-DIS.
USE-DIS. ADD 1 TO DCL-ERRNO MOVE "DISK ERROR" TO DCL-F2 MOVE DSTAT TO DCL-F3.
    MOVE RMS-CURRENT-FILENAME TO DCL-F4 MOVE DCL-ERRNO TO DCL-F5.
    DISPLAY DCL-LINE LINE 24 REVERSED ERASE LINE.
END DECLARATIVES.

SEC-0 SECTION 0.
MN0. PERFORM WRT80 MOVE 1 TO TSTART MOVE 0 TO DCL-ERRNO D-PF.
    MOVE "SET TERMINAL/NOWRAP" TO A-A1 CALL "LIB$SPAWN" USING DESCRIPTOR A-A1.
* note 49
    MOVE 21 TO WS-DIV MOVE "(IRVINE FASTENERS)" TO WA1.
    IF SW-1 MOVE 31 TO WS-DIV MOVE "(IRVINE TOOLS)" TO WA1.
    IF SW-2 MOVE 41 TO WS-DIV MOVE "(IRVINE NUTS)" TO WA1.
    IF SW-3 DISPLAY "IRVINE FASTENERS" LINE 1
      ELSE DISPLAY "IFOP" LINE 1 BOLD WA1(1:18) COLUMN 7 BOLD.
    OPEN I-O USERS ALLOWING ALL CLOSE USERS MOVE RMS-CURRENT-FILENAME TO WA1.
    MOVE 0 TO IX1 INSPECT WA1 TALLYING IX1 FOR CHARACTERS BEFORE ":[".
    MOVE IX1 TO IX2 INSPECT WA1(IX2 + 1:) TALLYING IX2 FOR CHARACTERS BEFORE "]".
    MOVE WA1(IX1 + 3:IX2 - IX1 - 2) TO WA2.
    IF NOT((IFAST AND WA2="IFMAIN" OR "IFTEST") OR (ITOOL AND WA2="ITMAIN" OR "ITTEST")
        OR (INUT AND WA2="INMAIN" OR "INTEST"))
      DISPLAY "WRONG DIRECTORY" LINE 5
      IF SW-3 PERFORM DSQ-CONT ELSE PERFORM DSP-CONT END-IF STOP RUN.
    PERFORM PUR-SETNM PERFORM GET-USER.
    MOVE 0 TO S-IX USN-KSYS USN-KPRT MOVE "G" TO MN-OSEL.
    OPEN I-O USERS ALLOWING ALL MOVE 1 TO USN-OP PERFORM SET-USER.
    IF A-S1=1 CLOSE USERS STOP RUN.
    MOVE "SPRINGHILL" TO WS-FOB MOVE 417680 TO WS-HBOX MOVE "158177035" TO ED-DUNS.
    MOVE "162844750" TO ED-DUNS2 MOVE "252866912" TO ED-DUNS3.
    IF INUT MOVE 417258 TO WS-HBOX MOVE "374908722" TO ED-DUNS
      MOVE "361098432" TO ED-DUNS2 MOVE "226429845" TO ED-DUNS3.
    MOVE USN-NUM TO MFA-NUM MFB-NUM MFC-NUM REP-NUM SORT-NUM SORC-NUM.
    ACCEPT SYS-TIME FROM TIME.
    MOVE SYS-TIME TO MFA-TIM MFB-TIM MFC-TIM REP-TIM SORT-TIM SORC-TIM.
    PERFORM OPEN-FL PERFORM RDR-INFO PERFORM RDR-EDINFO.
    IF SW-3 GO MW1. GO MN1.

RD8.
    MOVE "^L: LICENSE                                                                    ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "IFOP  (C) Copyright 1979-2015 Andrei Sorin "                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "This program comes with ABSOLUTELY NO WARRANTY. "                                  TO TLN(5).
    MOVE "This is free software. You may also redistribute it, under certain conditions. "   TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "For details see the GNU General Public License ver. 3 in a file included with "    TO TLN(8).
    MOVE "  this software, or see http://www.gnu.org/licenses/ "                             TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD9.
    MOVE "^IRVINE FASTENERS SYSTEM                                                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] ___ "                                                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "G  GENERAL "                                                                       TO TLN(5).
    MOVE "S  SHIPPING "                                                                      TO TLN(6).
    MOVE "I  PHYSICAL INVENTORY "                                                            TO TLN(7).
    MOVE "B  Q BINS "                                                                        TO TLN(8).
    MOVE "P  PURCHASING, A/P "                                                               TO TLN(9).
    MOVE "T  TOOLS "                                                                         TO TLN(10).
    MOVE "M  MTR, QA, LABELS "                                                               TO TLN(11).
    MOVE "E  EDI "                                                                           TO TLN(12).
    MOVE "C  COSTING "                                                                       TO TLN(13).
    MOVE "F  FINANCIALS "                                                                    TO TLN(14).
    MOVE "A  MAINTENANCE "                                                                   TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "Z  BATCH AND OTHER "                                                               TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "X/PF4  EXIT "                                                                      TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "L  LICENSE "                                                                       TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD9G.
    MOVE "^G: GENERAL FUNCTIONS                                                          ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. CUSTOMER INFORMATION                  21. CUSTOMER FILE MAINTENANCE "          TO TLN(5).
    MOVE " 2. PRODUCT INFORMATION                   22. PRODUCT FILE MAINTENANCE "           TO TLN(6).
    MOVE " 3. SHOW OPERATIONS LIST                  23. BIN FILE MAINTENANCE "               TO TLN(7).
    MOVE " 4. INVENTORY UPDATE                      24. SHIP-TO FILE MAINTENANCE "           TO TLN(8).
    MOVE " 5. ORDER ENTRY                           25. MACHINE FILE MAINTENANCE "           TO TLN(9).
    MOVE " 6. PRINT A FILE                          26. OPERATIONS FILE MAINTENANCE "        TO TLN(10).
    MOVE " 7. PRODUCTION ORDER ENTRY                27. SHOW CUSTOMER NAMES "                TO TLN(11).
    MOVE " 8. PRODUCTION ORDER INFORMATION          28. UPDATE BUCKETS "                     TO TLN(12).
    MOVE " 9. SHOW PRODUCTION ORDERS BY PRODUCT     29. CREATE MISCELLANEOUS LABELS "        TO TLN(13).
    MOVE "10. SHOW BIN CONTENTS                     30. SHOW SALES SUMMARY "                 TO TLN(14).
    MOVE "11. SHOW PRODUCT LOCATION                 31. SHOW ALTERNATE PRODUCTS "            TO TLN(15).
    MOVE "12. ORDER INFORMATION                     32. SHOW PRODUCT DRAWING "               TO TLN(16).
    MOVE "13. SHOW TRANSACTIONS BY CUSTOMER         33. DELETE PRODUCT DRAWING "             TO TLN(17).
    MOVE "14. SHOW ORDERS BY CUSTOMER               34. SHOW PRODUCT TRANSACTIONS "          TO TLN(18).
    MOVE "15. SHOW OPEN LINES IN ORDER              35. MODIFY USER DATA "                   TO TLN(19).
    MOVE "16. SHOW BACKORDERS BY PRODUCT            36. FREIGHT BILL-TO FILE MAINTENANCE "   TO TLN(20).
    MOVE "17. SHOW SALES HISTORY                    37. SOLD-TO FILE MAINTENANCE "           TO TLN(21).
    MOVE "18. WORKSHEET ENTRY                       38. SHOW PRODUCTION SHORT SCHEDULE "     TO TLN(22).
    MOVE "19. SHOW WORKSHEETS BY PRODUCTION ORDER "                                          TO TLN(23).
    MOVE "20. MACHINE/PROCESS INFORMATION                     99/PF4  RETURN TO MAIN MENU "  TO TLN(24).
    MOVE "?? "                                                                               TO TLN(25).

RD9S.
    MOVE "^S: SHIPPING FUNCTIONS                                                         ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE "                                          !THESE OPERATIONS CHANGE STATUS TO: ] "  TO TLN(4).
    MOVE " 1. ADD BLANKET ORDERS TO SHIP             20. CREATE SHIPPING FILE         0 "    TO TLN(5).
    MOVE " 2. PREVENT SELECTIVELY BIN ALLOCATION     21. ALLOCATE BINS                1 "    TO TLN(6).
    MOVE " 3. MODIFY ORDER STATUS IN SHIPPING FILE   22  SELECT ORDERS TO SHIP        2 "    TO TLN(7).
    MOVE " 4. LIST ORDERS TO SHIP                    23. PRINT PICKING TICKETS        3 "    TO TLN(8).
    MOVE " 5. SHOW ORDERS TO SHIP BY VIA CODE        24. PREPARE BILLS OF LADING      4 "    TO TLN(9).
    MOVE " 6. SHOW OPEN LINES IN ORDER               25. MARK COMPLETED SHIPMENTS     5 "    TO TLN(10).
    MOVE " 7. GENERATE BILLS OF LADING               26. INVOICE SHIPPED ORDERS       6 "    TO TLN(11).
    MOVE " 8. DESTINATION PLANT FILE MAINTENANCE     27. PRINT INVOICES               7 "    TO TLN(12).
    MOVE " 9. DESTINATION PLANT LISTING "                                                    TO TLN(13).
    MOVE "10. GENERATE BLANKET ORDER EXTENSIONS "                                            TO TLN(14).
    MOVE "11. MISCELLANEOUS MODIFICATIONS           !SUBCONTRACTOR FUNCTIONS ] "             TO TLN(15).
    MOVE "12. CREATE SINGLE GM SHIPPING LABELS       31. SPECIFY SHIPMENTS "                 TO TLN(16).
    MOVE "13. SHOW SHIP-TO ADDRESSES                 32. SHOW SHIPMENTS "                    TO TLN(17).
    MOVE "14. FILE LISTINGS                          33. SHIPMENTS REPORT "                  TO TLN(18).
    MOVE "15. EDI BATCH                              34. GENERATE BILLS OF LADING "          TO TLN(19).
    MOVE "16. MODIFY PLANT ISSUER IDENTIFIERS        35. SPECIFY RETURNS "                   TO TLN(20).
    MOVE "17. CREATE SHIPPING LABELS                 36. MODIFY SUBCONTRACTOR RECORD "       TO TLN(21).
    MOVE "18. PRINT SHIPPING LABELS "                                                        TO TLN(22).
    MOVE "19. PRINT SHIPPING MASTER LABELS "                                                 TO TLN(23).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(24).
    MOVE "?? "                                                                               TO TLN(25).

RD9I.
    MOVE "^I: PHYSICAL INVENTORY FUNCTIONS                                               ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. TICKET ENTRY "                                                                 TO TLN(5).
    MOVE " 2. MISSING TICKETS REPORT "                                                       TO TLN(6).
    MOVE " 3. TICKET LISTING "                                                               TO TLN(7).
    MOVE " 4. M.O. ADJUSTMENT AND REPORT "                                                   TO TLN(8).
    MOVE " 5. SAVE CURRENT QUANTITY LEFT AND PRODUCED "                                      TO TLN(9).
    MOVE " 6. PHYSICAL INVENTORY PRODUCT LISTING "                                           TO TLN(10).
    MOVE " 7. RE-CREATE PHYSICAL INVENTORY FILE "                                            TO TLN(11).
    MOVE " 8. BIN REPORT (PRODUCT BINS) "                                                    TO TLN(12).
    MOVE " 9. BIN REPORT (PART BINS) "                                                       TO TLN(13).
    MOVE "10. UPDATE PRODUCT RECORDS FROM BINS "                                             TO TLN(14).
    MOVE "11. UPDATE PART RECORDS FROM BINS "                                                TO TLN(15).
    MOVE "12. MODIFY SAVED QUANTITY LEFT AND PRODUCED "                                      TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD9B.
    MOVE "^B: Q BINS FUNCTIONS                                                           ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. Q BINS FILE MAINTENANCE "                                                      TO TLN(5).
    MOVE " 2. Q BINS LISTING "                                                               TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD9P.
    MOVE "^P: PURCHASING AND ACCOUNTS PAYABLE FUNCTIONS                                  ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. PART FILE MAINTENANCE                21. VENDOR FILE MAINTENANCE "             TO TLN(5).
    MOVE " 2. PART INFORMATION                     22. GENERATE INVOICES DIRECTLY "          TO TLN(6).
    MOVE " 3. BIN FILE MAINTENANCE                 23. GENERATE INVOICES FROM ORDERS "       TO TLN(7).
    MOVE " 4. SHOW BIN CONTENTS                    24. DELETE CHEQUES "                      TO TLN(8).
    MOVE " 5. SHOW PART LOCATION                   25. G/L CHART OF ACCOUNTS MAINTENANCE "   TO TLN(9).
    MOVE " 6. STOCK UPDATE                         26. CHANGE DUE DATE "                     TO TLN(10).
    MOVE " 7. PURCHASE ORDER ENTRY                 27. SHOW PURCHASE ORDERS BY VENDOR "      TO TLN(11).
    MOVE " 8. PURCHASE ORDER INFORMATION           28. VENDOR INFORMATION "                  TO TLN(12).
    MOVE " 9. SHOW PURCHASE ORDERS BY PART         29. SHOW TRANSACTIONS BY VENDOR "         TO TLN(13).
    MOVE "10. PRINT PURCHASE ORDERS                30. SHOW PART PURCHASE HISTORY "          TO TLN(14).
    MOVE "11. SHOW VENDORS AND PART NUMBERS        31. INVOICE FILE MAINTENANCE "            TO TLN(15).
    MOVE "12. MAT. CLEANING REQUIREMENTS REPORT    32. SHOW VENDOR NAMES "                   TO TLN(16).
    MOVE "13. PRINT MATERIAL CLEANING SLIP         33. SHOW VENDOR PURCHASE HISTORY "        TO TLN(17).
    MOVE "14. SHOW CLEANED COIL BINS               34. MARK MAILED CHEQUES "                 TO TLN(18).
    MOVE "15. COUNT PURCHASE ORDERS                35. CANCEL CHEQUES "                      TO TLN(19).
    MOVE "16. PRINT TOOL DRAWINGS                  36. SCRAP ENTRY "                         TO TLN(20).
    MOVE "17. ISSUE BLANKET PURCHASE ORDER         37. ROLLING MILL FILE MAINTENANCE "       TO TLN(21).
    MOVE "18. MODIFY M.O. MAT. ALLOC. INDICATOR    38. SHOW STOCK TRANSACTIONS "             TO TLN(22).
    MOVE " "                                                                                 TO TLN(23).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(24).
    MOVE "?? "                                                                               TO TLN(25).

RD9T.
    MOVE "^T: TOOLS FUNCTIONS                                                            ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. ARCHIVE TOOL LIST MAINTENANCE "                                                TO TLN(5).
    MOVE " 2. SHOW ARCHIVE TOOL LISTS "                                                      TO TLN(6).
    MOVE " 3. PRINT TOOL DRAWINGS "                                                          TO TLN(7).
    MOVE " 4. SHOW MAINTENANCE BINS "                                                        TO TLN(8).
    MOVE " 5. WRITE TOOL LIST NOTES "                                                        TO TLN(9).
    MOVE " 6. READ DRAWINGS INPUT FILE "                                                     TO TLN(10).
    MOVE " 7. WRITE ASSEMBLY NOTES "                                                         TO TLN(11).
    MOVE " 8. SHOW TOOLS IN ASSEMBLIES "                                                     TO TLN(12).
    MOVE " 9. SHOW TOOL DRAWING "                                                            TO TLN(13).
    MOVE "10. PRINT PCC & DRAWING "                                                          TO TLN(14).
    MOVE "11. MISCELLANEOUS MODIFICATIONS "                                                  TO TLN(15).
    MOVE "12. SHOW TOOL APPLICATIONS "                                                       TO TLN(16).
    MOVE "13. SHOW TOOL LISTS DIFFERENCE "                                                   TO TLN(17).
    MOVE "14. SHOW ALTERNATE TOOLS "                                                         TO TLN(18).
    MOVE "15. TOOL FILE MAINTENANCE "                                                        TO TLN(19).
    MOVE "16. SHOW TOOL LIST "                                                               TO TLN(20).
    MOVE "17. ASSEMBLY INFORMATION "                                                         TO TLN(21).
    MOVE "18. SHOW TOOL SHORTAGE "                                                           TO TLN(22).
    MOVE "19. SHOW TOOLS BY DRAWING NUMBER "                                                 TO TLN(23).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(24).
    MOVE "?? "                                                                               TO TLN(25).

RD9M.
    MOVE "^M: METALLURGICAL TEST, QA, AND PACKING LABELS FUNCTIONS                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. HEAT FILE MAINTENANCE              21. HEAT FILE LISTING "                     TO TLN(5).
    MOVE " 2. HEAT INFORMATION                   22. LOT METALLURGICAL TEST REPORT "         TO TLN(6).
    MOVE " 3. LOT FILE MAINTENANCE               23. METALLURGICAL TEST REPORT "             TO TLN(7).
    MOVE " 4. LOT INFORMATION                    24. LOT REPORTS "                           TO TLN(8).
    MOVE " 5. SHIPPING LABEL ENTRY               25. PRODUCT REPORTS "                       TO TLN(9).
    MOVE " 6. SHOW LABELS BY LOT                 26. LIST PRODUCTS WITH NO SPECS "           TO TLN(10).
    MOVE " 7. CREATE LABELS PRINT FILE           27. LIST PRODUCTS NOT MADE RECENTLY "       TO TLN(11).
    MOVE " 8. MISCELLANEOUS MODIFICATIONS        28. LIST SIMILAR HEAT TREAT PRODUCTS "      TO TLN(12).
    MOVE " 9. CHANGE THE GRADE IN LOT            29. AUTHORIZE SHIPPING LABELS "             TO TLN(13).
    MOVE "10. QUARANTINE/RELEASE LOTS            30. PRODUCT DATA LISTING "                  TO TLN(14).
    MOVE "11. SHOW LOT SALE HISTORY              31. PRODUCT DESCRIPTIONS LISTING "          TO TLN(15).
    MOVE "12. SHOW PRODUCTS BY PRINT NUMBER      32. SHOW LOTS BY PRODUCT "                  TO TLN(16).
    MOVE "13. PRINT INSPECTION PCC & DRAWING     33. PRINT PRODUCT DRAWINGS "                TO TLN(17).
    MOVE "14. PHYSICAL SPECS MAINTENANCE "                                                   TO TLN(18).
    MOVE "15. CHARACTERISTICS LISTING "                                                      TO TLN(19).
    MOVE "16. SHOW HEAT TREATMENT SPECS "                                                    TO TLN(20).
    MOVE "17. HEAT TREATMENT SPECS MAINTENANCE "                                             TO TLN(21).
    MOVE "18. MISCELLANEOUS INQUIRIES "                                                      TO TLN(22).
    MOVE "19. QUARANTINE/RELEASE BINS "                                                      TO TLN(23).
    MOVE "20. MECHANICAL SPECS MAINTENANCE                    99/PF4  RETURN TO MAIN MENU "  TO TLN(24).
    MOVE "?? "                                                                               TO TLN(25).

RD9E.
    MOVE "^E: EDI FUNCTIONS                                                              ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. PRINT NAFTA FORM                       21. MODIFY B/L INDICATORS "             TO TLN(5).
    MOVE " 2. CREATE TOWER GROUP INVOICE 810         22. MATERIAL RELEASE REPORT "           TO TLN(6).
    MOVE " 3. PRINT COMBINATION CUSTOMS FORMS        23. DELETE RELEASE FILE RECORDS "       TO TLN(7).
    MOVE " 4. CREATE ASN 856, DESADV                 24. MATERIAL RELEASE FILE MAINTENANCE"  TO TLN(8).
    MOVE " 5. PROCESS DAILY SHIP 862, DELJIT         25. LINE FEED SUMMARY REPORT "          TO TLN(9).
    MOVE " 6. PROCESS MATERIAL RELEASE 830, DELFOR   26. DAILY RELEASE REPORT "              TO TLN(10).
    MOVE " 7. PROCESS TEXT MESSAGE 864, GENRAL       27. PRODUCT LISTING BY HARMONY CODE "   TO TLN(11).
    MOVE " 8. PROCESS REMITTANCE ADVICE 820          28. DAILY RELEASE FILE MAINTENANCE "    TO TLN(12).
    MOVE " 9. PROCESS PURCHASE ORDER CHANGE 860 "                                            TO TLN(13).
    MOVE "10. PROCESS RECEIVING ADVICE 861, RECADV "                                         TO TLN(14).
    MOVE "11. PROCESS ADVANCE SHIP NOTICE 856 "                                              TO TLN(15).
    MOVE "12. PROCESS INVENTORY REPORT INVRPT "                                              TO TLN(16).
    MOVE "13. CREATE EDIFACT ACKNOWLEDGEMENT CONTRL "                                        TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(19).
    MOVE "?? "                                                                               TO TLN(20).

RD9C.
    MOVE "^C: PRODUCT COSTING FUNCTIONS                                                  ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. CALCULATE INDIVIDUAL PRODUCT COST "                                            TO TLN(5).
    MOVE " 2. UPDATE COST OF NUTS SHIPPED WITH BOLTS "                                       TO TLN(6).
    MOVE " 3. INCREASE PRODUCT PRICE IN OUTSTANDING ORDERS "                                 TO TLN(7).
    MOVE " 4. PRODUCT PRICE FILE MAINTENANCE "                                               TO TLN(8).
    MOVE " 5. SHOW PRODUCT PRICES BY CUSTOMER OR PRODUCT "                                   TO TLN(9).
    MOVE " 6. SHOW PRODUCT PRICE HISTORY "                                                   TO TLN(10).
    MOVE " 7. PRODUCT PRICE LISTING "                                                        TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!QUOTATION FUNCTIONS ] "                                                           TO TLN(14).
    MOVE "11. QUOTATION ENTRY "                                                              TO TLN(15).
    MOVE "12. CALCULATE AND PRINT QUOTATIONS "                                               TO TLN(16).
    MOVE "13. CALCULATE INDIVIDUAL LINE COST "                                               TO TLN(17).
    MOVE "14. UPDATE QUOTATION COSTING FILE "                                                TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD9F.
    MOVE "^F: FINANCIALS FUNCTIONS                                                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. PROCESS CASH RECEIPTS "                                                        TO TLN(5).
    MOVE " 2. SHOW INVOICES BY B/L NUMBER "                                                  TO TLN(6).
    MOVE " 3. INVOICE INFORMATION "                                                          TO TLN(7).
    MOVE " 4. TRANSACTION FILE MAINTENANCE "                                                 TO TLN(8).
    MOVE " 5. PROCESS GM EDI REMITTANCE ADVICE 820 "                                         TO TLN(9).
    MOVE " 6. LIST GM EDI REMITTANCE ADVICE 820 "                                            TO TLN(10).
    MOVE " 7. LIST AMERICAN AXLE REMITTANCE FILE "                                           TO TLN(11).
    MOVE " 8. SURCHARGE LISTING BY CUSTOMER "                                                TO TLN(12).
    MOVE " 9. BROKER LISTING BY CUSTOMER "                                                   TO TLN(13).
    MOVE "10. BANK CLEARING REPORT "                                                         TO TLN(14).
    MOVE "11. PROCESS BANK EDI LOCKBOX DEPOSIT 823 "                                         TO TLN(15).
    MOVE "12. LIST BANK EDI LOCKBOX DEPOSIT 823 "                                            TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD9A.
    MOVE "^A: PREVENTIVE MAINTENANCE FUNCTIONS                                           ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. MODIFY MASTER ORDER "                                                          TO TLN(5).
    MOVE " 2. MODIFY MAINTENANCE ORDER "                                                     TO TLN(6).
    MOVE " 3. SHOW MAINTENANCE ORDER "                                                       TO TLN(7).
    MOVE " 4. GENERATE EMERGENCY ORDER "                                                     TO TLN(8).
    MOVE " 5. PRINT MAINTENANCE ORDER "                                                      TO TLN(9).
    MOVE " 6. SHOW ORDERS BY MACHINE OR ISSUER "                                             TO TLN(10).
    MOVE " 7. SUMMARY HOURS REPORT "                                                         TO TLN(11).
    MOVE " 8. WRITE ORDER COMMENTS "                                                         TO TLN(12).
    MOVE " 9. WORK-IN-PROCESS LISTING "                                                      TO TLN(13).
    MOVE "10. OPEN/WIP ORDERS REPORT "                                                       TO TLN(14).
    MOVE "11. DETAILED HISTORY REPORT "                                                      TO TLN(15).
    MOVE "12. HISTORY REPORT "                                                               TO TLN(16).
    MOVE "13. NON-PRODUCTION MACHINES FILE MAINTENANCE "                                     TO TLN(17).
    MOVE "14. MODIFY MACHINE CLEANOUT SETTINGS "                                             TO TLN(18).
    MOVE "15. MACHINE CLEANOUT INFORMATION "                                                 TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD10.
    MOVE "^Z: BATCH AND OTHER FUNCTIONS                                                  ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] ____     BATCH: _ "                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. BACKORDER REPORTS                 21. MONTH-END FILE UPDATE "                  TO TLN(5).
    MOVE " 2. ORDER REPORTS                     22. AUDIT LISTING "                          TO TLN(6).
    MOVE " 3. PRODUCTION ORDERS REPORTS         23. TABLES MAINTENANCE AND LISTING "         TO TLN(7).
    MOVE " 4. SALES HISTORY REPORTS             24. SYSTEM FUNCTIONS "                       TO TLN(8).
    MOVE " 5. BIN REPORTS                       25. PRINT PRODUCTION TICKETS "               TO TLN(9).
    MOVE " 6. ACCOUNTS RECEIVABLE REPORTS       26. WORK IN PROGRESS REPORT "                TO TLN(10).
    MOVE " 7. DAILY SALES ANALYSIS REPORT       27. DAILY FILE UPDATE "                      TO TLN(11).
    MOVE " 8. SALES ANALYSIS REPORTS            28. HEAT TREATING DRAWBACK REPORT "          TO TLN(12).
    MOVE " 9. SALES JOURNAL                     29. SALESMAN COMMISSION REPORT "             TO TLN(13).
    MOVE "10. PRODUCT DEMAND REPORT             30. DAILY PRODUCTION REPORT "                TO TLN(14).
    MOVE "11. INVENTORY REPORT                  31. PRODUCTS ON ORDER REPORT "               TO TLN(15).
    MOVE "12. PRODUCTION HOURS REPORT           32. SALES BY PRODUCT TYPE REPORT "           TO TLN(16).
    MOVE "13. PRINT USER TABLES                 33. SURPLUS INVENTORY REPORT "               TO TLN(17).
    MOVE "14. SALES SUMMARY REPORTS             34. GENERATE PRODUCTION ORDERS "             TO TLN(18).
    MOVE "15. PRODUCT ALTERNATES REPORT         35. PRODUCTION SHORT SCHEDULE REPORT "       TO TLN(19).
    MOVE "16. FINANCIALS MENU "                                                              TO TLN(20).
    MOVE "17. TOOLS MENU "                                                                   TO TLN(21).
    MOVE "18. MACHINE AND WORKSHEET MENU "                                                   TO TLN(22).
    MOVE "19. RAW MATERIALS MENU                                  77  START BATCH RUN "      TO TLN(23).
    MOVE "20. PURCHASING AND A/P MENU                         99/PF4  RETURN TO MAIN MENU "  TO TLN(24).
    MOVE "?? "                                                                               TO TLN(25).

RD1016.
    MOVE "^FINANCIALS FUNCTIONS                                                          ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. SUBCONTRACTOR INVENTORY VALUE REPORT "                                         TO TLN(5).
    MOVE " 2. SUBCONTRACTOR WORK-IN-PROCESS VALUE REPORT "                                   TO TLN(6).
    MOVE " 3. CREATE A/R EXPORT FILE "                                                       TO TLN(7).
    MOVE " 4. PRODUCT COST UPDATE "                                                          TO TLN(8).
    MOVE " 5. PRODUCT CONTRIBUTION REPORTS "                                                 TO TLN(9).
    MOVE " 6. THIRD PARTY OPERATIONS VALUATION REPORT "                                      TO TLN(10).
    MOVE " 7. PRODUCT COST REPORT "                                                          TO TLN(11).
    MOVE " 8. PRODUCT COST ANALYSIS "                                                        TO TLN(12).
    MOVE " 9. MAINTENANCE PARTS COST REPORT "                                                TO TLN(13).
    MOVE "10. CREATE A/R AUDIT FILE "                                                        TO TLN(14).
    MOVE "11. CUSTOMER LISTING "                                                             TO TLN(15).
    MOVE "12. PRODUCT COST VARIANCE REPORTS "                                                TO TLN(16).
    MOVE "13. CREATE INVOICE EXPORT FILES "                                                  TO TLN(17).
    MOVE "14. PRINT ORDER ACKNOWLEDGEMENTS "                                                 TO TLN(18).
    MOVE "15. PRINT STATEMENTS "                                                             TO TLN(19).
    MOVE "16. STATEMENT HISTORY REPORT "                                                     TO TLN(20).
    MOVE " "                                                                                 TO TLN(21).
    MOVE "                                                       99/PF4  RETURN TO Z MENU "  TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD1017.
    MOVE "^TOOLS FUNCTIONS                                                               ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. LIST M.O.'S WITH INCOMPLETE TOOL LIST "                                        TO TLN(5).
    MOVE " 2. LIST BINS WITH TOOLS NOT USED IN ANY TOOL LIST "                               TO TLN(6).
    MOVE " 3. LIST BACK INSERTS WITH NO ALTERNATES "                                         TO TLN(7).
    MOVE " 4. TOOL REQUISITION REPORT "                                                      TO TLN(8).
    MOVE " 5. TOOL RUN-OUT REPORT "                                                          TO TLN(9).
    MOVE " 6. TOOL IDENTIFICATION REPORT "                                                   TO TLN(10).
    MOVE " 7. ALTERNATE TOOL REPORT "                                                        TO TLN(11).
    MOVE " 8. TOOL TABLES LISTING "                                                          TO TLN(12).
    MOVE " 9. TOOL COSTING REPORT "                                                          TO TLN(13).
    MOVE "10. TOOL LIFE REPORT AND UPDATE "                                                  TO TLN(14).
    MOVE "11. TOOL USAGE EXCEPTION REPORT "                                                  TO TLN(15).
    MOVE "12. TOOL LIST VALIDATION REPORT "                                                  TO TLN(16).
    MOVE "13. TOOL BIN VALIDATION REPORT "                                                   TO TLN(17).
    MOVE "14. PRINT TOOL LIST FORMS "                                                        TO TLN(18).
    MOVE "15. TOOL USAGE HISTORY REPORT "                                                    TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "                                                       99/PF4  RETURN TO Z MENU "  TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD1018.
    MOVE "^MACHINE AND WORKSHEET FUNCTIONS                                               ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. MAINTENANCE DOWNTIME REPORT       21. MODIFY M.O. COMPLETION INDICATOR "       TO TLN(5).
    MOVE " 2. MACHINE ACTIVITY REPORT           22. MACHINE TYPE FILE MAINTENANCE "          TO TLN(6).
    MOVE " 3. MACHINE UTILIZATION REPORT        23. PRODUCTION SHORT SCHEDULE MAINTENANCE "  TO TLN(7).
    MOVE " 4. MACHINE/PROCESS LISTING           24. EMPLOYEE FILE MAINTENANCE "              TO TLN(8).
    MOVE " 5. MACHINE TIME ANALYSIS "                                                        TO TLN(9).
    MOVE " 6. MACHINE UTILIZATION ANALYSIS "                                                 TO TLN(10).
    MOVE " 7. OLD INCOMPLETE PRODUCTION ORDERS REPORT "                                      TO TLN(11).
    MOVE " 8. MACHINE PERFORMANCE ANALYSIS "                                                 TO TLN(12).
    MOVE " 9. PAYROLL WEEKLY SUMMARY REPORT "                                                TO TLN(13).
    MOVE "10. FORWARD LOADING REPORT (SECONDARY OPERATIONS) "                                TO TLN(14).
    MOVE "11. CREATE EMPLOYEE TIME LABELS "                                                  TO TLN(15).
    MOVE "12. CREATE EMPLOYEE ADDRESS LABELS "                                               TO TLN(16).
    MOVE "13. EMPTY BUCKETS REPORT "                                                         TO TLN(17).
    MOVE "14. SCRAP ANALYSIS (SECONDARY OPERATIONS) "                                        TO TLN(18).
    MOVE "15. SCRAP REPORT "                                                                 TO TLN(19).
    MOVE "16. MACHINE/PROCESS TYPES AND GROUPS LISTING "                                     TO TLN(20).
    MOVE "17. IN-PROCESS PRODUCTION ORDERS REPORT "                                          TO TLN(21).
    MOVE "18. PRODUCTION REPORTS "                                                           TO TLN(22).
    MOVE "                                                       99/PF4  RETURN TO Z MENU "  TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD1019.
    MOVE "^RAW MATERIALS FUNCTIONS                                                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. MATERIAL RUN-OUT REPORT "                                                      TO TLN(5).
    MOVE " 2. STOCK TRANSACTIONS REPORT "                                                    TO TLN(6).
    MOVE " 3. MATERIAL DEMAND REPORT "                                                       TO TLN(7).
    MOVE " 4. MATERIAL REQUIREMENTS REPORT "                                                 TO TLN(8).
    MOVE " 5. CALCULATE ROLLING MILL ORDERS "                                                TO TLN(9).
    MOVE " 6. ROLLING MILL TABLE LISTING "                                                   TO TLN(10).
    MOVE " 7. PRODUCT LISTING BY CLEANING CODE "                                             TO TLN(11).
    MOVE " 8. HEAT LOCATION REPORT "                                                         TO TLN(12).
    MOVE " 9. MATERIAL AGING REPORT "                                                        TO TLN(13).
    MOVE "10. READ CLEANED COILS BIN FILE "                                                  TO TLN(14).
    MOVE "11. DAILY MATERIAL REQUIREMENTS REPORT "                                           TO TLN(15).
    MOVE "12. WEEKLY MATERIAL REQUIREMENTS REPORT "                                          TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "                                                       99/PF4  RETURN TO Z MENU "  TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD1020.
    MOVE "^PURCHASING AND A/P FUNCTIONS                                                  ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. INVENTORY REPORTS                 21. A/P JOURNAL "                            TO TLN(5).
    MOVE " 2. EMPTY BINS REPORT                 22. A/P TRIAL BALANCE "                      TO TLN(6).
    MOVE " 3. BIN CONTENTS REPORT               23. OUTSTANDING INVOICES REPORTS "           TO TLN(7).
    MOVE " 4. BIN INVALID CONTENTS REPORT       24. GENERATE CHEQUES "                       TO TLN(8).
    MOVE " 5. PART LOCATION REPORT              25. OUTSTANDING CHEQUES REPORT "             TO TLN(9).
    MOVE " 6. DELETE OLD ORDERS                 26. PRINT G/L CHART OF ACCOUNTS "            TO TLN(10).
    MOVE " 7. PURCHASE ORDERS DUE REPORT        27. A/P DISTRIBUTION AND ACCRUAL REPORTS "   TO TLN(11).
    MOVE " 8. PURCHASE HISTORY REPORTS          28. A/P AGE ANALYSIS "                       TO TLN(12).
    MOVE " 9. PURCHASING DISTRIBUTION REPORT    29. GENERATE SUBCONTRACTOR INVOICES "        TO TLN(13).
    MOVE "10. PURCHASING PERFORMANCE REPORT     30. VENDOR LISTING "                         TO TLN(14).
    MOVE "11. CONTRACTOR PERFORMANCE REPORT     31. CREATE G/L EXPORT FILE "                 TO TLN(15).
    MOVE "                                      32. GENERATE DUMMY INVOICES "                TO TLN(16).
    MOVE "                                      33. CASH REQUIREMENTS SUMMARY REPORT "       TO TLN(17).
    MOVE "!IRVINE TOOLS FUNCTIONS ] "                                                        TO TLN(18).
    MOVE "18. WORK IN PROGRESS REPORT "                                                      TO TLN(19).
    MOVE "19. OPERATIONS REPORT "                                                            TO TLN(20).
    MOVE "20. GENERATE SALES ORDERS "                                                        TO TLN(21).
    MOVE "                                                       99/PF4  RETURN TO Z MENU "  TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD11.
    MOVE "^CUSTOMER RECORD ]          ^CUSTOMER        ]!                                ]"  TO TLN(1).
    MOVE "                            !                ] "                                   TO TLN(2).
    MOVE "^TERRITORY  ] "                                                                    TO TLN(3).
    MOVE "^PROVINCE   ]      ^SURCH CODE ] "                                                 TO TLN(4).
    MOVE "^SALESMAN   ]      ^BACKORDERS ] "                                                 TO TLN(5).
    MOVE "^VIA        ]      ^EDI CUSTOMS]     ^CONTACT] "                                   TO TLN(6).
    MOVE "^STATEMENTS ]      ^BROKER     ] "                                                 TO TLN(7).
    MOVE "^CREDIT HOLD]      ^MILL TEST  ] "                                                 TO TLN(8).
    MOVE "^US$ INVOICE]      ^INACTIVE   ] "                                                 TO TLN(9).
    MOVE "                              ^BALANCE  ] "                                        TO TLN(10).
    MOVE "^CREDIT LIM.]                 ^CURRENT  ] "                                        TO TLN(11).
    MOVE "^D & B      ]                 ^30 DAYS  ] "                                        TO TLN(12).
    MOVE "^G/L CONTRA ]                 ^60 DAYS  ] "                                        TO TLN(13).
    MOVE "^INSURANCE  ]                 ^90 DAYS  ] "                                        TO TLN(14).
    MOVE "^GST LICENCE]                 ^120 DAYS ] "                                        TO TLN(15).
    MOVE "^PST LICENCE] "                                                                    TO TLN(16).
    MOVE "                              ^SALES MTD]                   ^PAY IN AVG] "         TO TLN(17).
    MOVE "^CUST. TYPE ]                 ^      YTD]                   ^   LAST YR] "         TO TLN(18).
    MOVE "^AUTO. TYPE ]                 ^  LAST YR]                   ^ 2 YRS AGO] "         TO TLN(19).
    MOVE "^SHIP LABEL ]                 ^2 YRS AGO]                   ^TERMS] "              TO TLN(20).
    MOVE "^CUST. CLASS]                 ^ON ORDER ] "                                        TO TLN(21).
    MOVE "^IRS NO.    ] "                                                                    TO TLN(22).
    MOVE "^SUPPLR NO. ]                                             NEXT CUSTOMER  ______ "  TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD12.
    MOVE "^PRODUCT RECORD ]           ^PRODUCT NO.] "                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ALTERNATES] "                                                                     TO TLN(3).
    MOVE "^GENERIC PRODUCT] "                                                                TO TLN(4).
    MOVE "^QUOTE REF] "                                                                      TO TLN(5).
    MOVE "^INACTV, CUST, ORDER] "                                                            TO TLN(6).
    MOVE "^OPER.] "                                                                          TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "^PLTG, SPEC]                           ^CATEGORY, FAMILY, MARKET] "                TO TLN(9).
    MOVE "^DIAMETER,GRADE]                       ^WEIGHT NET,GRS,P] "                        TO TLN(10).
    MOVE "^WIRE,PROCESS,CLEANING]                ^PRICE 1,2, MODE ] "                        TO TLN(11).
    MOVE "^MACHINE,RATE,ALT MAC]                 ^COST, CHG PRICE ] "                        TO TLN(12).
    MOVE "^PACKING,QTY,CONTAINER] "                                                          TO TLN(13).
    MOVE "^TICKET COLOUR, PPAP]                  ^ON HAND, Q BINS ] "                        TO TLN(14).
    MOVE "^HARMONY]                              ^DEMAND          ] "                        TO TLN(15).
    MOVE "^QTY LST YR, 2 YRS AGO]                ^FUTURE DEMAND   ] "                        TO TLN(16).
    MOVE "                                       ^ORDER, TMP ORDER] "                        TO TLN(17).
    MOVE "         ^   MTD  ]   ^   YTD  ]       ^IN PROCESS, DM  ] "                        TO TLN(18).
    MOVE "^QTY   ]                               ^R.O.P.          ] "                        TO TLN(19).
    MOVE "^WEIGHT]                               ^R.O.P. EST, LVL ] "                        TO TLN(20).
    MOVE "^AMOUNT]                               ^BANK,LEAD W.DAYS] "                        TO TLN(21).
    MOVE "                                       ^LAST NET, GROSS ] "                        TO TLN(22).
    MOVE "NEXT PRODUCT ____________              ^LAST RCVD, NEW  ] "                        TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD13.
    MOVE "^CASH RECEIPTS ] "                                                                 TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD13A. MOVE 3 TO TSTART.
    MOVE "!CUSTOMER NO.] ______ "                                                            TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD13B. MOVE 6 TO TSTART.
    MOVE "!INVOICE NO. ] ______                  !NEW TRANSACTION ?] ___ "                   TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!AMOUNT PAID ] __________ "                                                        TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD13C. MOVE 10 TO TSTART.
    MOVE "                                       !BILL OF LADING NO.] _______ "              TO TLN(10).
    MOVE "                                       !ORDER NO.] ______ "                        TO TLN(11).
    MOVE "                                       !CUST ORDER NO.] _________ "                TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD14.
    MOVE "^INVENTORY UPDATE ] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!TRANSACTION] ___ "                                                                TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD15.
    MOVE "^SALES HISTORY ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CUSTOMER / PRODUCT "                                           TO TLN(3).
    MOVE "              2. BY PRODUCT / CUSTOMER "                                           TO TLN(4).
    MOVE "              3. BY CUSTOMER / INVOICE "                                           TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD15A.
    MOVE "^SALES HISTORY FOR CUSTOMER NO.                                                                                                    ]"  TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^CAT PRODUCT     SHIPTO    QTY      AMOUNT  US   PRICE/M   CD-SURCHARGE   WEIGHT     DATE   INVOICE     B/L   ORDER  CUST ORD ] "      TO TLNW(3).
*          ..  ............  ..   ...,...-  ..,...:..-.. ..,...:..-  .:...,...:..-  ..,...-  ../../..  ......  .......  .....  .........
    MOVE " "                                                                                                                                     TO TLNW(4).

RD15B.
    MOVE "^SALES HISTORY FOR PRODUCT NO.                                                                                                     ]"  TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^CUST  SHIPTO    QTY      AMOUNT  US   PRICE/M   CD-SURCHARGE   WEIGHT     DATE   INVOICE     B/L   ORDER  CUST ORD ] "                TO TLNW(3).
*          ......  ..   ...,...-  ..,...:..-.. ..,...:..-  .:...,...:..-  ..,...-  ../../..  ......  .......  .....  .........
    MOVE " "                                                                                                                                     TO TLNW(4).

RD16.
    MOVE "^ORDER ENTRY ]           !ORDER NO.] ______        !DATE] ______ "                 TO TLN(1).
    MOVE "!SPECIAL ORDER] _        !CUSTOMER NO.] ______     !SALSMN] __     !COMM] _____ "  TO TLN(2).
    MOVE "!BLANKET ORDER] _        !SHIP-TO CODE] __ "                                       TO TLN(3).
    MOVE "                                        ________________________________ "         TO TLN(4).
    MOVE "                                        ________________________ "                 TO TLN(5).
    MOVE "                                        ________________________ "                 TO TLN(6).
    MOVE "                                        __________ "                               TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!CUSTOMER ORDER NO.] _________    !DATE REQ'D] ______    !TERMS] ______ "          TO TLN(9).
    MOVE "!FOB] _______________    !VIA CODE] __    !PPD/COL] _    !EXP/BUYER] _ "           TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!SPECIAL INSTRUCTION CODES] __  __  __  __     !SALES CONTACT] _______________ "   TO TLN(12).
    MOVE "!PICKING TICKET NOTES] _____________________________________________ "             TO TLN(13).
    MOVE "                       _____________________________________________ "             TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!FREIGHT RATE] _______  !OR LOT CHARGE] _________ "                                TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD17.
    MOVE "^ORDER NO.]        ^LINE]       !CUST.] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT NO.     QTY       PRICE   MODE  DISC.  PLATING   AMOUNT  ] "              TO TLN(3).
*         ............  .........-  ....:...  ..    ..      ..    .......:..-
    MOVE "?? "                                                                               TO TLN(4).

RD18.
    MOVE "^MODIFY ORDER NO.]        ^LINE]       !CUST.] "                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT NO.     QTY       PRICE   MODE  DISC.  PLATING   AMOUNT  ] "              TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD19.
    MOVE "^PREPARE BILLS OF LADING ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!NEXT B/L NO.] "                                                                   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD19A.
    MOVE "^BILL OF LADING - ORDER DATA ]                                 !B/L NO.] "         TO TLN(1).
    MOVE "                                                               !INV NO.] "         TO TLN(2).
    MOVE "^ORDER NO.] ______                     !SHIP VIA] __ "                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PALLETS] ___ "                                                                    TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "^PACKING TYPE:] "                                                                  TO TLN(7).
    MOVE "!................] ____          !................] ____ "                         TO TLN(8).
    MOVE "!................] ____          !................] ____ "                         TO TLN(9).
    MOVE "!................] ____          !................] ____ "                         TO TLN(10).
    MOVE "!................] ____          !................] ____ "                         TO TLN(11).
    MOVE "!................] ____ "                                                          TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "^CUSTOMS DATA:] "                                                                  TO TLN(15).
    MOVE "!STATE] __     !PORT OF ENTRY] ________     !BORDER POINT] ________ "              TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD19B.
    MOVE "^BILL OF LADING - LINE DATA ]      !ORDER NO.]                 !B/L NO.] "         TO TLN(1).
    MOVE "                                                               !INV NO.] "         TO TLN(2).
    MOVE "^EXCEPTIONS ] "                                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT NO.  BIN     LOT       QTY       ACTUAL] "                                TO TLN(5).
    MOVE "____________  _____  _______             ________ "                                TO TLN(6).
    MOVE "                                                         !TOTAL QTY     ACTUAL] "  TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD20.
    MOVE "^CREATE A/R AUDIT FILE ] "                                                         TO TLN(1).
    MOVE "                                                                       !OK] __ "   TO TLN(2).
    MOVE "?? "                                                                               TO TLN(3).

RD21.
    MOVE "^PRODUCTION ORDER RECORD ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ORDER NO.]           !STATUS:]         !START DATE:] "                            TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TICKETS STATUS:]      !SALES ORDER:]              !MATERIAL ALLOCATED:] "         TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRODUCT NO.] "                                                                    TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!QTY ORDERED ]                    ^LATE DATES:]!MACHINE ] "                        TO TLN(9).
    MOVE "    !PRODUCED]                                 !MATERIAL] "                        TO TLN(10).
    MOVE "    !RECEIVED]                                 !TOOLS   ] "                        TO TLN(11).
    MOVE "    !LEFT    ] "                                                                   TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "NEXT ORDER NO. ______ "                                                            TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD22.
    MOVE "^PRODUCTION ORDERS FOR PRODUCT:]!                                              ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ORDER S/S  QTY ORDERED   QTY PRODUCED   QTY LEFT   REQD START  ACTUAL START   ]"  TO TLN(3).
*         ......  .  ..,...,...-    ..,...,...-  ..,...,...-   ../../..     ../../..
    MOVE " "                                                                                 TO TLN(4).

RD23.
    MOVE "^BIN RECORD ] "                                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.     ] "                                                                   TO TLN(3).
    MOVE "^PRODUCT NO. ] "                                                                   TO TLN(4).
    MOVE "^LOT         ] "                                                                   TO TLN(5).
    MOVE "^CONTAINER   ] "                                                                   TO TLN(6).
    MOVE "^DATE        ] "                                                                   TO TLN(7).
    MOVE "^QTY         ] "                                                                   TO TLN(8).
    MOVE "^QTY ALLOC.  ] "                                                                   TO TLN(9).
    MOVE "^PACKING QTY ] "                                                                   TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "NEXT BIN NO. _____ "                                                               TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD24.
    MOVE "^BINS CONTAINING PRODUCT NO.]!                                                 ]"  TO TLN(1).
    MOVE "                                             !TOTAL QTY:                       ]"  TO TLN(2).
    MOVE "^BIN NO.  LOT  CONTAINER    QTY       DATE     ALLOCATED   PACKING ] "             TO TLN(3).
*          .....  .......   .  ...,...,...-   ../../.. ..,...,...-   ..,...
    MOVE " "                                                                                 TO TLN(4).

RD25.
    MOVE "^ORDER NO.             INVOICE NO.          CUSTOMER NO.                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^SOLD TO ]                                        !CUST ORD NO.] "                 TO TLN(3).
    MOVE "                                                  !ORDER DATE  ] "                 TO TLN(4).
    MOVE "                                                  !REQ'D DATE  ] "                 TO TLN(5).
    MOVE "                                                  !INVOICE DATE] "                 TO TLN(6).
    MOVE "                                                  !PPD,EXP     ] "                 TO TLN(7).
    MOVE "^SHIP TO ]                                        !TERMS       ] "                 TO TLN(8).
    MOVE "                                                  !B/L NO.     ] "                 TO TLN(9).
    MOVE "                                                  !PALLETS     ] "                 TO TLN(10).
    MOVE "                                                  !CTNS,TRIWLS ] "                 TO TLN(11).
    MOVE "                                                  !BUCKETS,BINS] "                 TO TLN(12).
    MOVE "^VIA     ]                                        !TOTAL LINES ] "                 TO TLN(13).
    MOVE "^FOB     ]                                        !GST         ] "                 TO TLN(14).
    MOVE "                                                  !HST         ] "                 TO TLN(15).
    MOVE "^STD TEXT]                                        !PST         ] "                 TO TLN(16).
    MOVE "                                                  !QST         ] "                 TO TLN(17).
    MOVE "                                                  !NON-SALES   ] "                 TO TLN(18).
    MOVE "                                                  !NET AMOUNT  ] "                 TO TLN(19).
    MOVE "                                                  !NET WEIGHT  ] "                 TO TLN(20).
    MOVE "                                                  !GROSS WEIGHT] "                 TO TLN(21).
    MOVE " "                                                                                 TO TLN(22).
    MOVE "LINE NO. __     OR PRODUCT NO. ____________      OR NEXT ORDER NO. ______ "        TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD26.
    MOVE "^ORDER NO.             INVOICE NO.          CUSTOMER NO.                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^LINE     ] "                                                                      TO TLN(3).
    MOVE "^PRODUCT  ] "                                                                      TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "^CONTAINER IND.] "                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "^PRICE    ] "                                                                      TO TLN(8).
    MOVE "^MODE     ] "                                                                      TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "^QTY ORDERED  ] "                                                                  TO TLN(11).
    MOVE "^QTY LAST SHP.] "                                                                  TO TLN(12).
    MOVE "^QTY LEFT     ] "                                                                  TO TLN(13).
    MOVE "^QTY CUM. YTD ] "                                                                  TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "^DISCOUNT ] "                                                                      TO TLN(16).
    MOVE "^PLATING  ] "                                                                      TO TLN(17).
    MOVE "^SURCHARGE] "                                                                      TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "                                                 ^EXTENSION    ] "                 TO TLN(20).
    MOVE " "                                                                                 TO TLN(21).
    MOVE " "                                                                                 TO TLN(22).
    MOVE "LINE NO. __     OR PRODUCT NO. ____________      OR NEXT ORDER NO. ______ "        TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD27.
    MOVE "^TRANSACTIONS FOR CUSTOMER:                                                    ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^      BALANCE      CURRENT      30 DAYS      60 DAYS      90 DAYS     120 DAYS]"  TO TLN(3).
    MOVE "! "                                                                                TO TLN(4).
*             ...,...:..-  ...,...:..-  ...,...:..-  ...,...:..-  ...,...:..-  ...,...:..-
    MOVE "^ DATE   REFERENCE  CUST ORDER        CHARGES       CREDITS ] "                    TO TLN(5).
*         ../../..  ......    .........  ...,...,...:..- .,...,...:..-
    MOVE " "                                                                                 TO TLN(6).

RD28.
    MOVE "^ORDERS FOR CUSTOMER:                                                          ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ORDER NO.  BLKT   DATE     DATE REQ   LINES   P/O      ] "                        TO TLN(3).
*           ......     .   ../../..   ../../..     ..    .........
    MOVE " "                                                                                 TO TLN(4).

RD29.
    MOVE "^OPEN LINES FOR ORDER NO.           CUST.                                      ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^LINE  PRODUCT         QTY ORD'D      QTY LEFT    QTY YTD (BLANKET)] "             TO TLN(3).
*           ..   ............  ...,...,...-  ...,...,...-  ...,...,...-
    MOVE " "                                                                                 TO TLN(4).

RD30.
    MOVE "^CUSTOMER FILE MAINTENANCE ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUSTOMER NO.] ______           ^FUNCTION] _       ^FUNCTIONS               ] "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                   1. ADD RECORD "                 TO TLN(5).
    MOVE "                                                   2. DISPLAY / CHANGE RECORD "    TO TLN(6).
    MOVE "                                                   3. DELETE RECORD "              TO TLN(7).
    MOVE "                                                   9. END "                        TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD31.
    MOVE "^ADD CUSTOMER RECORD ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUSTOMER NO.] "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!US$ INDICATOR] _ (0,1)          !CUSTOMER CLASS] _ "                              TO TLN(5).
    MOVE "!CUSTOMER TYPE] _ (blank,X,Y,U)  !AUTOMOTIVE TYPE] __ "                            TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!TERRITORY] __    !PROVINCE] __    !SALESMAN] __    !VIA] __    !TERMS] __ "       TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!NAME     ] ________________________________ "                                     TO TLN(10).
    MOVE "!ADDRESS 1] ________________________ "                                             TO TLN(11).
    MOVE "!ADDRESS 2] ________________________ "                                             TO TLN(12).
    MOVE "!POST CODE] __________ "                                                           TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!STATEMENT IND.] _   !BACKORDER IND.] _   !MILL TEST IND.] _ "                     TO TLN(15).
    MOVE "!EDI CUSTOMS IND.] _    !BROKER] __ "                                              TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!INSURANCE] _______      !CREDIT LIMIT] ________    !D & B RATING] ___ "           TO TLN(18).
    MOVE "!GST LICENSE] ________   !PST LICENSE] ________   !IRS NO.] _______________ "      TO TLN(19).
    MOVE "!SUPPLIER CODE] _______________ "                                                  TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD32.
    MOVE "^CUSTOMER RECORD ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUSTOMER NO.] "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. TERRITORY        2. PROVINCE         3. SALESMAN         4. NAME "             TO TLN(5).
    MOVE " 5. ADDRESS LINE 1   6. ADDRESS LINE 2   7. POSTAL CODE      8. STATEMENT IND. "   TO TLN(6).
    MOVE " 9. BACKORDER IND.  10. INSURANCE       11. CREDIT LIMIT    12. D & B RATING "     TO TLN(7).
    MOVE "13. GST LICENSE     14. PST LICENSE     15. TOTAL BAL       16. CURRENT BAL "      TO TLN(8).
    MOVE "17. 30 DAY BAL      18. 60 DAY BAL      19. 90 DAY BAL      20. 120 DAY BAL "      TO TLN(9).
    MOVE "21. SALES MTD       22. SALES YTD       23. OUTST ORDERS    24. CUSTOMER TYPE "    TO TLN(10).
    MOVE "25. IRS NO.         26. VIA CODE        27. CRED HOLD IND.  28. SALES LAST YR "    TO TLN(11).
    MOVE "29. SALES 2 YRS AGO 30. CONTACT LINE 1  31. CONTACT LINE 2  32. CONTACT LINE 3 "   TO TLN(12).
    MOVE "33. AUTOMOTIVE TYPE 34. G/L CONTRA      35. MILL TEST IND.  36. US$ IND. "         TO TLN(13).
    MOVE "37. EDI CUSTOMS IND.38. INACTIVE IND.   39. CUSTOMER CLASS  40. SHIP LABEL TYPE "  TO TLN(14).
    MOVE "41. CUSTOMS BROKER  42. TERMS CODE      43. SURCH PRNT IND. 44. CORP CUST NO. "    TO TLN(15).
    MOVE "45. SUPPLIER CODE   46. SURCHARGE CODE "                                           TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD33.
    MOVE "^PRODUCT FILE MAINTENANCE ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PRODUCT NO.] ____________      ^FUNCTION] _       ^FUNCTIONS               ] "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                   1. ADD RECORD "                 TO TLN(5).
    MOVE "                                                   2. DISPLAY / CHANGE RECORD "    TO TLN(6).
    MOVE "                                                   3. DELETE RECORD "              TO TLN(7).
    MOVE "                                                   9. END "                        TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD34.
    MOVE "^ADD PRODUCT RECORD ] "                                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PRODUCT NO.]                      !CATEGORY] __    !FAMILY] __    !MARKET] __ "   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                             !PRICE MODE] __    !GENERIC PROD NO.] ____________ "  TO TLN(5).
    MOVE "!DESCRIPTION ] ________________|________________ "                                 TO TLN(6).
    MOVE "!EXTD DESCR 1] ________________________________ "                                  TO TLN(7).
    MOVE "!EXTD DESCR 2] ________________________________ "                                  TO TLN(8).
    MOVE "!FINISH DESCR] ________________________________ "                                  TO TLN(9).
    MOVE "!PRINT DESCR ] __________________ "                                                TO TLN(10).
    MOVE "!PRINT NO] ______    !PRINT REV.] __ "                                             TO TLN(11).
    MOVE "!CUST NO] ______    !MAT SPEC] ____________________    !TAX CODE] __ "             TO TLN(12).
    MOVE "!PRICE 1] ________   !PRICE 2] ________   !CHG PRICE IND.] _    !COST] ________ "  TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!REORDER LEVEL] __________    !ESTIMATED QTY] __________    !ESTIMATED LEVEL] _ "  TO TLN(15).
    MOVE "!BANK QTY ] __________   !LEAD W.DAYS] __ "                                        TO TLN(16).
    MOVE "!MACHINE NO] __   !HOURLY RATE] ______     !WEIGHT] ______   !GROSS WT.] ______ "  TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "!HARMONY CODE] __   !TICKET COLOUR] __   !PLATING SPEC CODE] ___ "                 TO TLN(19).
    MOVE "!DIAMETER] ______   !GRADE] ________     !WIRE SIZE] ______ "                      TO TLN(20).
    MOVE "!PROCESS CODE] _    !CLEANING CODE] _ "                                            TO TLN(21).
    MOVE "!PACKING CODE] __   !PACKING QTY] _____   !CONTAINER CODE] _ "                     TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD35.
    MOVE "^PRODUCT RECORD ]    !                                                        ] "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE " 1. CATEGORY         2. PRICE MODE       3. DESCRIPTION      4. VENDOR NO. "       TO TLN(3).
    MOVE " 5. TAX CODE         6. GEN PROD NO.     7. ALT VENDOR NO.   8. PRICE 1 "          TO TLN(4).
    MOVE " 9. PRICE 2         10. WEIGHT          11. DATE LAST ORD   12. QTY ON HAND "      TO TLN(5).
    MOVE "13. QTY ON ORDER    14. QTY ON DEMAND   15. QTY MTD         16. QTY YTD "          TO TLN(6).
    MOVE "17. QTY LAST YEAR   18. WEIGHT MTD      19. WEIGHT YTD      20. REORDER QTY "      TO TLN(7).
    MOVE "21. QTY 2 YRS AGO   22. MACHINE NO.     23. HOURLY RATE     24. COST "             TO TLN(8).
    MOVE "25. AMT MTD         26. AMT YTD         27. ESTIMATED QTY   28. ESTIMATED LEVEL "  TO TLN(9).
    MOVE "29. LEAD W.DAYS     30. CUSTOMER NO.    31. TICKET COLOUR   32. PURCHSD PART NO."  TO TLN(10).
    MOVE "33. HARMONY CODE    34. FINISH DESCR.   35. PRINT DESCR.    36. DIAMETER "         TO TLN(11).
    MOVE "37. GRADE           38. WIRE SIZE       39. PROCESS CODE    40. CLEANING CODE "    TO TLN(12).
    MOVE "41. EXTD DESCR 1    42. EXTD DESCR 2    43. CUST. PART NO.  44. MARKET "           TO TLN(13).
    MOVE "45. PRINT NO.       46. PRINT REVISION  47. CHG PRICE IND   48. PLTG SPEC CODE "   TO TLN(14).
    MOVE "49. FAMILY          50. INACTIVE IND.   51. ALT MACHINE NO. 52. UPC "              TO TLN(15).
    MOVE "53. QUOTE REFERENCE 54. EST TOOLS COST  55. PPAP INDICATOR  56. NUT INCL IND. "    TO TLN(16).
    MOVE "57. NO LABELS IND.  58. PACKING CODE    59. PACKING QTY     60. GROSS WEIGHT "     TO TLN(17).
    MOVE "61. MATERIAL SPEC   62. BANK QTY        63. CONTAINER CODE  64. QTY IN PROCESS "   TO TLN(18).
    MOVE "65. MATCHING NUT    66. NUT(S) WEIGHT   67. BLANKET ORDER   68. PRIMARY WEIGHT "   TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE " "                                                                                 TO TLN(21).
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(22).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD36.
    MOVE "^BIN FILE MAINTENANCE ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.] _____                 ^FUNCTION] _       ^FUNCTIONS               ] "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                   1. ADD RECORD "                 TO TLN(5).
    MOVE "                                                   2. DISPLAY / CHANGE RECORD "    TO TLN(6).
    MOVE "                                                   3. DELETE RECORD "              TO TLN(7).
    MOVE "                                                   9. END "                        TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "^ADD RANGE OF BINS ] "                                                             TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!PREFIX] __      !FROM] ___     !TO] ___                 !'OK' TO ADD BINS] __ "   TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD37.
    MOVE "^ADD BIN RECORD ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.] "                                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT NO.] ____________ "                                                       TO TLN(5).
    MOVE "!DATE LAST CHG.] ______ "                                                          TO TLN(6).
    MOVE "!QTY] __________     !QTY ALLOCATED] __________     !PACKING QTY] _____ "          TO TLN(7).
    MOVE "!LOT NO.] _______    !CONTAINER CODE] _ "                                          TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD38.
    MOVE "^BIN RECORD ] "                                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.] "                                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. PRODUCT NO.      2. DATE LAST CHG.   3. QTY              4. QTY ALLOCATED "    TO TLN(5).
    MOVE " 5. LOT NO.          6. CONTAINER CODE   7. PACKING QTY "                          TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD38A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD39.
    MOVE "^SHIP-TO FILE MAINTENANCE ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUST NO.] ______    ^SHIP-TO CODE] __             ^FUNCTIONS               ] "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^FUNCTION] _                                       1. ADD RECORD "                 TO TLN(5).
    MOVE "                                                   2. DISPLAY / CHANGE RECORD "    TO TLN(6).
    MOVE "                                                   3. DELETE RECORD "              TO TLN(7).
    MOVE "                                                   9. END "                        TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD40.
    MOVE "^ADD SHIP-TO RECORD ] "                                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUST NO. / SHIP-TO CODE] "                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!NAME      ] ________________________________ "                                    TO TLN(5).
    MOVE "!ADDRESS 1 ] ________________________________ "                                    TO TLN(6).
    MOVE "!ADDRESS 2 ] ________________________________ "                                    TO TLN(7).
    MOVE "!POST CODE ] __________ "                                                          TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD41.
    MOVE "^SHIP-TO RECORD ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUST NO. / SHIP-TO] "                                                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. NAME             2. ADDRESS 1        3. ADDRESS 2        4. POSTAL CODE "      TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD41A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD42.
    MOVE "^MACHINE/PROCESS FILE MAINTENANCE ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^MACH/PROC NO.] ____        ^FUNCTION] _        ^FUNCTIONS               ] "       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                1. ADD RECORD "                    TO TLN(5).
    MOVE "                                                2. DISPLAY / CHANGE RECORD "       TO TLN(6).
    MOVE "                                                3. DELETE RECORD "                 TO TLN(7).
    MOVE "                                                9. END "                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD43.
    MOVE "^ADD MACHINE/PROCESS RECORD ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^MACH/PROC NO.] "                                                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!GROUP] __ "                                                                       TO TLN(5).
    MOVE "!TYPE ] __ "                                                                       TO TLN(6).
    MOVE "!SECTOR] __ "                                                                      TO TLN(7).
    MOVE "!TARGET PRODUCTION] _________     !SPEED] ___     !EFFICIENCY %] __ "              TO TLN(8).
    MOVE "!TARGET WEIGHT/M] _______ "                                                        TO TLN(9).
    MOVE "!HOURS/DAY] __ "                                                                   TO TLN(10).
    MOVE "!DESCRIPTION LINE 1] ______________________________ "                              TO TLN(11).
    MOVE "            !LINE 2] ______________________________ "                              TO TLN(12).
    MOVE "!OPERATION DESCRIPTION] __________ "                                               TO TLN(13).
    MOVE "!COST] ________     !COST MODE] _  (G/N/M/H) "                                     TO TLN(14).
    MOVE "!ALTERNATE COST (PER HOUR)] ________ "                                             TO TLN(15).
    MOVE "!LEAD DAYS] ___ "                                                                  TO TLN(16).
    MOVE "!PLATING PROCESS INDICATOR] _     !VENDOR] ____       !FREIGHT/TON] ______ "       TO TLN(17).
    MOVE "!LOT CHARGE] ______       !BATCH CHARGE] ______       !SURCHARGE %] _____ "        TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD44.
    MOVE "^MACHINE/PROCESS RECORD ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^MACH/PROC NO.] "                                                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. GROUP            2. TYPE             3. SECTOR           4. TARGET PROD. "     TO TLN(5).
    MOVE " 5. HOURS/DAY        6. CURRENT M.O.     7. DESCR. LINE 1    8. DESCR. LINE 2 "    TO TLN(6).
    MOVE " 9. COST            10. COST MODE       11. TARGET WEIGHT/M 12. LEAD DAYS "        TO TLN(7).
    MOVE "13. OPER. DESCR.    14. PLATING IND.    15. LOT CHARGE      16. BATCH CHARGE "     TO TLN(8).
    MOVE "17. SURCHARGE %     18. VENDOR NO.      19. TARGET COST     20. SPEED "            TO TLN(9).
    MOVE "21. EFFICIENCY %    22. FREIGHT/TON     23. ALT COST (/HR)  24. INACTIVE IND "     TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD44A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD45.
    MOVE "^OPERATIONS LIST ] "                                                               TO TLN(1).
    MOVE "               !MACHINES USED:] "                                                  TO TLN(2).
    MOVE "!PRODUCT] ____________   !MAC.]__ "                                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!MACHINE SPEED]          !EFFICIENCY %] "                                          TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "^OPER  DESCRIPTION LINE 1             LINE 2                         OPERATION] "  TO TLN(8).
*          ...   .............................. .............................. ..........
    MOVE "?? "                                                                               TO TLN(9).

RD46.
    MOVE "^CREATE LABELS PRINT FILE ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] _      1. AUTOMATIC LABELS   ('LAB01.PRN') "                           TO TLN(3).
    MOVE "                   2. MANUAL LABELS      ('LAB02.PRN') "                           TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "                                                                       !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD47.
    MOVE "^MACHINE/PROCESS LISTING ] (ALSO EXPORT FILE) "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACH/PROC] ____      !TO MACH/PROC] ____ "                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD48.
    MOVE "^MACHINE/PROCESS TYPES AND GROUPS LISTING ] "                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD49.
    MOVE "^DAILY PRODUCTION REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DATE] ______ "                                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM GROUP NO.] __      !TO GROUP NO.] __ "                                       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD50.
    MOVE "^SHIP-VIA TABLE MAINTENANCE ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VIA CODE] __ "                                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CARRIER DESCRIPTION] ________________________________________  !SORT ORDER] __ "  TO TLN(5).
    MOVE "!SCAC CODE] ____      !METHOD CODE] __     !POOL CODE] _______ "                   TO TLN(6).
    MOVE "!CARRIER EQUIPMENT:] !TRAILER PREFIX] ____   !TRAILER NUMBER] __________ "         TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD51.
    MOVE "^INVOICE INFORMATION ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INVOICE NO.] ______ "                                                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CUSTOMER   ] "                                                                    TO TLN(5).
    MOVE "!INVOICE    ] "                                                                    TO TLN(6).
    MOVE "!AMT LEFT   ] "                                                                    TO TLN(7).
    MOVE "!AMT ORIG.  ] "                                                                    TO TLN(8).
    MOVE "!DATE       ] "                                                                    TO TLN(9).
    MOVE "!DATE PAID  ] "                                                                    TO TLN(10).
    MOVE "!ORDER NO.  ] "                                                                    TO TLN(11).
    MOVE "!B/L NO.    ] "                                                                    TO TLN(12).
    MOVE "!CUST ORDER ] "                                                                    TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD52.
    MOVE "^ORDERS TO SHIP VIA                                                            ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUSTOMER                    CUST ORD   ORDER    DATE REQ %COM   WEIGHT  LNS ST]"  TO TLN(3).
*         ...... ....................  ......... ......-.. ../../..  ...  ...,...  ..  .-.
*                                                           !.... ......  ...,... ..]
    MOVE " "                                                                                 TO TLN(4).

RD53.
    MOVE "^MARK COMPLETED SHIPMENTS ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^B/L NO.] _______     !SHIPPED] ___ "                                              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^CARRIER EQUIPMENT:]  !TRAILER PREFIX] ____   !TRAILER NUMBER] __________ "        TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "^EXCESS TRANSPORTATION CHARGES:]  !RESPONSIBILITY] _   !AETC NO.] ________ "       TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!SLI NO. (GM)] ___________ "                                                       TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD54.
    MOVE "^OPEN LINES ]     !ORDER]           !CUST.] "                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!STATUS]    !DATE REQD]                        !VIA] "                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^LN PRODUCT       DESCRIPTION                          QTY        1ST ALLOC 2ND]"  TO TLN(5).
*         ..  ............  ................................  ...,...   ...,...   ...,...
    MOVE " "                                                                                 TO TLN(6).

RD55.
    MOVE "^PURCHASE ORDERS   VENDOR:]!                                                  ] "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ORDER      DATE    DATE REQ  INV DATE  DUE DATE  INVOICE          BLANKET ] "     TO TLN(3).
*         ........  ../../..  ../../..  ../../..  ../../..  ...............  ........
    MOVE " "                                                                                 TO TLN(4).

RD56.
    MOVE "^ADD PHYSICAL INVENTORY TICKET ]       !DATE] ______ "                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O. NO.] ______ "                                                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TICKET NO.] ______ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!WEIGHT] _________      !CARTONS] _____               !QTY] "                      TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!COMPLETION CODE] __      !LOCATION CODE] __ "                                     TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " 1. BULK - BARE            1. PLANT #1 "                                           TO TLN(11).
    MOVE " 2. BULK - PLATED          2. HEAT TREAT "                                         TO TLN(12).
    MOVE " 3. PACKAGED & LABELED     3. INSPECTION "                                         TO TLN(13).
    MOVE "                           4. SAKI BAY "                                           TO TLN(14).
    MOVE "                           5. PLANT #3 "                                           TO TLN(15).
    MOVE "                           6. SHIPPING "                                           TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD57.
    MOVE "^ALLOCATE BINS ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "BLANKET ORDERS WITH REQUIRED DATE UP TO AND INCLUDING THIS DATE "                  TO TLN(3).
    MOVE "  WILL BE AUTOMATICALLY SELECTED FOR SHIPPING IF ALLOCATED 100% AND OVER "         TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "       !GM ORDERS] ______ "                                                        TO TLN(6).
    MOVE "   !NON-GM ORDERS] ______ "                                                        TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "EXCEPTION REPORT SHOWS LINES THAT WERE NOT ALLOCATED 100% "                        TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD58.
    MOVE "^DESTINATION PLANT FILE MAINTENANCE ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PLANT CODE] __________    !PRODUCT] ____________ "                                TO TLN(3).
    MOVE "!NAME] ______________________________                           !SALES REP] __ "   TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!BLANKET ORDER NO.] ______       !GM RECEIVER ID] ___       !GM DOCK CODE] ___ "   TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!EDIFACT INDICATOR] _ "                                                            TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD59.
    MOVE "^INVOICES FOR B/L NO.:]          !CUST:] "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^INV NO.  ORDER  CUST ORDER     DATE       AMOUNT       INV AMT ] "                TO TLN(3).
*          ......  ......  .........    ../../.. ...,...:..-   ...,...:..-
    MOVE "?? "                                                                               TO TLN(4).

RD60.
    MOVE "^PRODUCTS BY 'IF' PRINT NUMBER ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!'IF' PRINT NO.] ______ "                                                          TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD61.
    MOVE "^PHYSICAL INVENTORY MISSING TICKETS REPORT ] "                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST MISSING TICKET NUMBERS IN THE RANGE:] "                                      TO TLN(3).
    MOVE "       !FROM TICKET NO.] ______      !TO TICKET NO.] ______ "                      TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD62.
    MOVE "^PACKING TABLE MAINTENANCE ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PACKING CODE] ___                        ^FUNCTION] _    1. ADD RECORD "          TO TLN(3).
    MOVE "                                                          2. CHANGE RECORD "       TO TLN(4).
    MOVE "                                                          3. DELETE RECORD "       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PART NO.] ____________ "                                                          TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!PACKING DESCRIPTION] ________________________________________ "                   TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!PALLET PACKING CODE] ___        !MAX. CARTONS/PALLET] __ "                        TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD63.
    MOVE "^OLD INCOMPLETE PRODUCTION ORDERS REPORT ] "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST WORKSHEETS OLDER THAN] __ !DAYS] "                                           TO TLN(3).
    MOVE "   !FOR WHICH THE M.O. COMPLETION INDICATOR IS NOT SET] "                          TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD64.
    MOVE "^MODIFY M.O. COMPLETION INDICATOR ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O. NO.] ______       !COMPLETED] _          0 = INCOMPLETE "                    TO TLN(3).
    MOVE "                                               1 = COMPLETE "                      TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD65.
    MOVE "^ALTERNATE PRODUCTS FOR:                                                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PRODUCT       DESCRIPTION                   ] "                                   TO TLN(3).
*         ............  ................................
    MOVE " "                                                                                 TO TLN(4).

RD66.
    MOVE "^HEAT TREATING DRAWBACK REPORT ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!DIAMETERS]  ______  ______  ______  ______  ______ "                              TO TLN(5).
    MOVE "!GRADES]  ________  ________  ________  ________  ________ "                       TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD67.
    MOVE "^PHYSICAL INVENTORY BIN REPORT (PRODUCT BINS) ] "                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM BIN] _____    !TO BIN] _____ "                                               TO TLN(3).
    MOVE "           _____             _____ "                                               TO TLN(4).
    MOVE "           _____             _____ "                                               TO TLN(5).
    MOVE "           _____             _____ "                                               TO TLN(6).
    MOVE "           _____             _____ "                                               TO TLN(7).
    MOVE "           _____             _____ "                                               TO TLN(8).
    MOVE "           _____             _____ "                                               TO TLN(9).
    MOVE "           _____             _____ "                                               TO TLN(10).
    MOVE "           _____             _____ "                                               TO TLN(11).
    MOVE "           _____             _____ "                                               TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(14).
    MOVE "?? "                                                                               TO TLN(15).

RD68.
    MOVE "^PHYSICAL INVENTORY BIN REPORT (PART BINS) ] "                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM BIN] ______   !TO BIN] ______ "                                              TO TLN(3).
    MOVE "           ______            ______ "                                              TO TLN(4).
    MOVE "           ______            ______ "                                              TO TLN(5).
    MOVE "           ______            ______ "                                              TO TLN(6).
    MOVE "           ______            ______ "                                              TO TLN(7).
    MOVE "           ______            ______ "                                              TO TLN(8).
    MOVE "           ______            ______ "                                              TO TLN(9).
    MOVE "           ______            ______ "                                              TO TLN(10).
    MOVE "           ______            ______ "                                              TO TLN(11).
    MOVE "           ______            ______ "                                              TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(14).
    MOVE "?? "                                                                               TO TLN(15).

RD69.
    MOVE "^LIST BINS WITH TOOLS NOT USED IN ANY TOOL LIST ] "                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM BIN] ______       !TO BIN] ______ "                                          TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "ONLY BINS WITH TOOLS NOT USED IN ANY TOOL LIST ARE NORMALLY SHOWN. "               TO TLN(5).
    MOVE "SHOW INSTEAD BINS WITH TOOLS NOT USED IN TOOL LISTS "                              TO TLN(6).
    MOVE "  OF DEFAULT OR ALTERNATE MACHINES ? ___ "                                         TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD70.
    MOVE "^TOOL RUN-OUT REPORT ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SHOW SHORTAGE ONLY FOR TOOLS WITH MINIMUM R.O.P. OF] ____ "                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD71.
    MOVE "^SELECT ORDERS TO SHIP ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ORDER NO.] ______ "                                                               TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD72.
    MOVE "^AUTOMATIC ORDER SELECTION ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SHIP-VIA CODE] ___       !CUSTOMER] ______          !MAX WEIGHT] ______ "         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^ORDERS:WEIGHT SELECTED:] "                                                        TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD73.
    MOVE "^ROLLING MILL FILE MAINTENANCE ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CYCLE NO.] ____    ^DIAMETER] ______     ^FUNCTION] _    1. ADD RECORD "          TO TLN(3).
    MOVE "                                                          2. CHANGE RECORD "       TO TLN(4).
    MOVE "                                                          3. DELETE RECORD "       TO TLN(5).
    MOVE "                                                          4. GLOBAL DATE CHANGE "  TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!STATUS] _ "                                                                       TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!DATE] ______      !QTY AVAILABLE] _______    !QTY REQUIRED] _______ "             TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "^CALCULATED ORDERS (GRADE:QUANTITY)                                            ]"  TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD74.
    MOVE "^CALCULATE ROLLING MILL ORDERS ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "                                                         !'OK' TO CONTINUE] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD75.
    MOVE "^ROLLING MILL TABLE LISTING ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD76.
    MOVE "^MATERIAL RUN-OUT REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD77.
    MOVE "^STOCK TRANSACTIONS ] !PART NO.] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ DATE  TRANS FROM   TO           QTY] "                                           TO TLN(3).
*         ../../.. ...  ...... ...... .,...,...-
    MOVE " "                                                                                 TO TLN(4).

RD77A.
    MOVE "^STOCK TRANSACTIONS ] !PART NO.] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ DATE  TRANS FROM     TO             QTY  PRO  COILS  WEIGHT  HEAT     ] "        TO TLN(3).
*         ../../.. ...  ........ ........ .,...,...-  .   ...-   .,...   ..........
    MOVE " "                                                                                 TO TLN(4).

RD77B.
    MOVE "^STOCK TRANSACTIONS ] !PART NO.] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ DATE   TIME  TRANS FROM   TO       QTY   OPERATOR   ] "                          TO TLN(3).
*         ../../.. ..:..  ...  ...... ......  ....-  ............
    MOVE " "                                                                                 TO TLN(4).

RD78.
    MOVE "^STOCK TRANSACTIONS REPORT ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST BY BIN ?] ___  (OTHERWISE LISTED BY PART) "                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM PART] ____________       !TO PART] ____________ "                            TO TLN(5).
    MOVE "!FROM BIN ] ______             !TO BIN ] ______ "                                  TO TLN(6).
    MOVE "!FROM DATE] ______             !TO DATE] ______ "                                  TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD79.
    MOVE "^TOOL REQUISITION REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD80.
    MOVE "^TOOL IDENTIFICATION REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECTION CODES:] "                                                               TO TLN(3).
    MOVE "!   MACHINES OF TYPE 7, 8, 9, 10, 11      MACHINES OF TYPE 12 ] "                  TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "1.  3RD PUNCH INSERT 1                    3RD PUNCH FRONT INS "                    TO TLN(6).
    MOVE "2.  4TH PUNCH INSERT 1                    4TH PUNCH FRONT INS "                    TO TLN(7).
    MOVE "3.  3RD MIDDLE INSERT 2                   3RD MIDDLE INSERT 2, INSERT 3 "          TO TLN(8).
    MOVE "4.  3RD BACK INSERT, INSERT 1             3RD BACK INSERT 1 "                      TO TLN(9).
    MOVE "5.  4TH FRONT INSERT                      4TH FRONT INSERT 1 "                     TO TLN(10).
    MOVE "6.  3RD MIDDLE INSERT, INSERT 1           3RD FRONT INSERT 2 "                     TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!CODE] __ "                                                                        TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD81.
    MOVE "^LOTS FOR PRODUCT:] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ LOT      DATE      M.O.        QTY      WEIGHT   FINISH        ] "               TO TLN(3).
*         .......  ../../..  ......-. .,...,...- .,...,...-  ...............
    MOVE " "                                                                                 TO TLN(4).

RD82.
    MOVE "^Q BINS FILE MAINTENANCE ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^Q BIN NO.] _____                         ^FUNCTION] _    1. ADD BIN RECORD "      TO TLN(3).
    MOVE "                                                          2. MODIFY FIELDS "       TO TLN(4).
    MOVE "                                                          3. DELETE BIN RECORD "   TO TLN(5).
    MOVE "                                                          4. EMPTY BIN "           TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!DM NO.] ______      !DATE] ______ "                                               TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!PRODUCT] ____________      !QTY] __________      !LOT] _______ "                  TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!NOTES] __________________________________________________ "                       TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD83.
    MOVE "^PRINT A FILE ] "                                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^FILE:]  !NAME]      !NO.]   !EXTENSION] "                                         TO TLN(3).
    MOVE "          ________    __      ___ "                                                TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!QUEUE] __________ "                                                               TO TLN(6).
    MOVE "                                                                       !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD84.
    MOVE "^MACHINE ACTIVITY REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______     !TO DATE] ______ "                                          TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM MACHINE] ____   !TO MACHINE] ____ "                                          TO TLN(5).
    MOVE "               ____                ____ "                                          TO TLN(6).
    MOVE "               ____                ____ "                                          TO TLN(7).
    MOVE "               ____                ____ "                                          TO TLN(8).
    MOVE "               ____                ____ "                                          TO TLN(9).
    MOVE "               ____                ____ "                                          TO TLN(10).
    MOVE "               ____                ____ "                                          TO TLN(11).
    MOVE "               ____                ____ "                                          TO TLN(12).
    MOVE "               ____                ____ "                                          TO TLN(13).
    MOVE "               ____                ____ "                                          TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!GRAND TOTALS ONLY ?] ___      !SUB-TOTALS ONLY ?] ___ "                           TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!INCLUDE PRODUCTION SUMMARY ANALYSIS ?] ___ "                                      TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD85.
    MOVE "^SALES SUMMARY ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CUSTOMER "                                                     TO TLN(3).
    MOVE "              2. BY PRODUCT "                                                      TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD85A.
    MOVE "^SALES SUMMARY FOR CUSTOMER NO.                                                                                                    ]"  TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^PRODUCT       QTY -      - AMT         QTY -      - AMT         QTY -      - AMT         QTY -      - AMT         QTY -      - AMT]"  TO TLNW(3).
*         !............  ................................]
*                    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...
    MOVE " "                                                                                                                                     TO TLNW(4).

RD85B.
    MOVE "^SALES SUMMARY FOR PRODUCT NO.                                                                                                     ]"  TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^CUSTOMER      QTY -      - AMT         QTY -      - AMT         QTY -      - AMT         QTY -      - AMT         QTY -      - AMT]"  TO TLNW(3).
*         !......  ................................]
*                    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...
    MOVE " "                                                                                                                                     TO TLNW(4).

RD86.
    MOVE "^BACKORDERS FOR PRODUCT NO.                                                                                                        ]"  TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^CUST  NAME                          LOCATION                CUS ORD     ORD   PRODUCT      DATE REQ    QUANTITY   QTY SHIPPED  ADJ]"  TO TLNW(3).
*         ...... ............................  ......................  ......... ......  ............ ../../.. ...,...,...-               ...
*         PLANT ..........  ..............................                       ......  ............    ../.. ...,...,...- ...,...,...-
    MOVE " "                                                                                                                                     TO TLNW(4).

RD87.
    MOVE "^CUSTOMER NAMES ] "                                                                                                                    TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!CUSTOMER NAME] _________________________ "                                                                                            TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
*         ......  ................................      ......  ................................      ......  ................................
    MOVE "?? "                                                                                                                                   TO TLNW(5).

RD88.
    MOVE "^OPERATIONS FILE MAINTENANCE ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. DISPLAY/ADD/CHANGE/DELETE OPERATION LISTS "                                     TO TLN(5).
    MOVE "2. CHANGE AN OPERATION IN ALL OPERATION LISTS "                                    TO TLN(6).
    MOVE "3. SHOW OPERATION APPLICATIONS "                                                   TO TLN(7).
    MOVE "4. ADD/DELETE OPERATION IN AN OPERATION LIST "                                     TO TLN(8).
    MOVE "5. CHANGE AN OPERATION COST IN ALL OPERATION LISTS "                               TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD88A.
    MOVE "^OPERATIONS FILE MAINTENANCE ] "                                                   TO TLN(1).
    MOVE "               !MACHINES USED:]                 ^FUNCTION] _  1. ADD LIST "        TO TLN(2).
    MOVE "!PRODUCT] ____________   !MAC.]__                             2. CHANGE LIST "     TO TLN(3).
    MOVE "                                                              3. DELETE LIST "     TO TLN(4).
    MOVE "                                                              4. COPY LIST "       TO TLN(5).
    MOVE "!MACHINE SPEED] ___      !EFFICIENCY %] __ "                                       TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "^OPERATION  COST   MODE   DESCRIPTION                      ABBREVIATION ] "        TO TLN(8).
*             ...                   ..............................   ..........
    MOVE " "                                                                                 TO TLN(9).
    MOVE " 1. ___   ________  _ "                                                            TO TLN(10).
    MOVE " 2. ___   ________  _ "                                                            TO TLN(11).
    MOVE " 3. ___   ________  _ "                                                            TO TLN(12).
    MOVE " 4. ___   ________  _ "                                                            TO TLN(13).
    MOVE " 5. ___   ________  _ "                                                            TO TLN(14).
    MOVE " 6. ___   ________  _ "                                                            TO TLN(15).
    MOVE " 7. ___   ________  _ "                                                            TO TLN(16).
    MOVE " 8. ___   ________  _ "                                                            TO TLN(17).
    MOVE " 9. ___   ________  _ "                                                            TO TLN(18).
    MOVE "10. ___   ________  _ "                                                            TO TLN(19).
    MOVE "11. ___   ________  _ "                                                            TO TLN(20).
    MOVE "12. ___   ________  _ "                                                            TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD88B.
    MOVE "^CHANGE AN OPERATION IN ALL OPERATION LISTS ] "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "  !CHANGE OPERATION] ___ "                                                         TO TLN(3).
    MOVE "      !TO OPERATION] ___ "                                                         TO TLN(4).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD88C.
    MOVE "^OPERATION LISTS CONTAINING OPERATION:                                        ] "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PRODUCT-MACHINE                                                          ] "      TO TLN(3).
*         ............ ..     ............ ..     ............ ..     ............ ..
    MOVE " "                                                                                 TO TLN(4).

RD88D.
    MOVE "^ADD/DELETE OPERATION ] "                                                          TO TLN(1).
    MOVE "               !MACHINES USED:]               ^FUNCTION] _  1. ADD OPERATION "     TO TLN(2).
    MOVE "!PRODUCT] ____________   !MAC.]__                           2. DELETE OPERATION "  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "^OPERATION                DESCRIPTION                      ABBREVIATION ] "        TO TLN(7).
*             ...                   ..............................   ..........
    MOVE "?? "                                                                               TO TLN(8).

RD88E. MOVE 9 TO TSTART.
    MOVE " 1. ___ "                                                                          TO TLN(9).
    MOVE " 2. ___ "                                                                          TO TLN(10).
    MOVE " 3. ___ "                                                                          TO TLN(11).
    MOVE " 4. ___ "                                                                          TO TLN(12).
    MOVE " 5. ___ "                                                                          TO TLN(13).
    MOVE " 6. ___ "                                                                          TO TLN(14).
    MOVE " 7. ___ "                                                                          TO TLN(15).
    MOVE " 8. ___ "                                                                          TO TLN(16).
    MOVE " 9. ___ "                                                                          TO TLN(17).
    MOVE "10. ___ "                                                                          TO TLN(18).
    MOVE "11. ___ "                                                                          TO TLN(19).
    MOVE "12. ___ "                                                                          TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD88F.
    MOVE "^CHANGE AN OPERATION COST IN ALL OPERATION LISTS ] "                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "  !OPERATION] ___ "                                                                TO TLN(3).
    MOVE "  !NEW COST ] ________  !MODE] _ "                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "THIS FUNCTION SETS THE NEW COST IN ALL LISTS WHERE THIS OPERATION "                TO TLN(6).
    MOVE "  IS FOUND AND HAS A COST. "                                                       TO TLN(7).
    MOVE "USE FUNCTION 3 'SHOW OPERATION APPLICATIONS' TO SEE WHICH LISTS "                  TO TLN(8).
    MOVE "  INCLUDE THIS OPERATION. "                                                        TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD89.
    MOVE "^MACHINE TYPE FILE MAINTENANCE ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^TYPE] __                                 ^FUNCTION] _    1. ADD RECORD "          TO TLN(3).
    MOVE "                                                          2. CHANGE RECORD "       TO TLN(4).
    MOVE "                                                          3. DELETE RECORD "       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!DESCRIPTION] ____________________________________ "                               TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!COST] ________    !COST MODE] _        !TOOL EST. COST (N)] ________ "            TO TLN(10).
    MOVE "!CONTRIBUTION] ____ "                                                              TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD90.
    MOVE "^RE-CREATE DAILY SHIPPING/SALES FILES ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "NORMALLY THE DAILY SHIPPING/SALES FILES ARE RE-CREATED AUTOMATICALLY IN S-20. "    TO TLN(3).
    MOVE "THIS MUST BE DONE HERE ONLY WHEN THERE WERE SYSTEM PROBLEMS. "                     TO TLN(4).
    MOVE "NO SHIPPING, EDI, OR METALLURGICAL TEST FUNCTIONS SHOULD BE RUNNING "              TO TLN(5).
    MOVE "  WHILE RE-CREATING THESE FILES. "                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!RE-CREATE BINALLOC FILE ?] ___ "                                                  TO TLN(9).
    MOVE "!RE-CREATE SHIPORD/SHIPLIN FILES ?] ___ "                                          TO TLN(10).
    MOVE "!RE-CREATE CFORD/CFLIN FILES ?] ___ "                                              TO TLN(11).
    MOVE "!RE-CREATE HTRANS FILE ?] ___ "                                                    TO TLN(12).
    MOVE "!RE-CREATE TMPORD/TMPLIN FILES ?] ___ "                                            TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD91.
    MOVE "^CALCULATE PRODUCT COST ]           !PRODUCT] ____________                                !MACHINE] __     !TOOL LISTS:] "             TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!CUSTOMERS IN PRICE TABLE:] "                                                                                                          TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE " "                                                                                                                                     TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "   !CUSTOMER] ______                      !PRICE] ________     !US$] _ "                                                               TO TLNW(10).
    MOVE "   (IF A CUSTOMER'S PRICE IS NEEDED)      (IF DIFFERENT FROM STANDARD PRICE) "                                                         TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE " "                                                                                                                                     TO TLNW(13).
    MOVE "   !LAST OPERATION] ___                                                   !CALCULATION MODE] _ "                                       TO TLNW(14).
    MOVE " "                                                                                                                                     TO TLNW(15).
    MOVE "                                                                          1. VALUES/1000 PCS (ACCOUNTING USE) "                        TO TLNW(16).
    MOVE "                                                                          2. VALUES/TON "                                              TO TLNW(17).
    MOVE "                                                                          3. VALUES BASED ON ORDERS/PURCHASES (SALES & QUOTING USE) "  TO TLNW(18).
    MOVE "                                                                          4. VALUES BASED ON ORDERS/PURCHASES AND ACTUAL HOURS "       TO TLNW(19).
    MOVE "                                                                          5. VARIANCE (MODE 3 - 4) "                                   TO TLNW(20).
    MOVE "?? "                                                                                                                                   TO TLNW(21).

RD92.
    MOVE "....................                  !PRODUCT:]                                            !MACHINE:] "                               TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "                                                                                            !SUGGESTED SELLING PRICE (CDN):] "         TO TLNW(4).
    MOVE "!PRICE (CDN):] "                                                                                                                       TO TLNW(5).
    MOVE "!WEIGHT GROSS,NET:] "                                                                                                                  TO TLNW(6).
    MOVE "!OPERATIONS:] "                                                                                                                        TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^MATERIAL COST                  ]   ^THIRD PARTY COST                   ]   ^CONVERSION COST                    ] "                    TO TLNW(9).
    MOVE " "                                                                                                                                     TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE " "                                                                                                                                     TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE " "                                                                                                                                     TO TLNW(15).
    MOVE " "                                                                                                                                     TO TLNW(16).
    MOVE "!DIRECT COST SUB-TOTAL:] "                                                                                                             TO TLNW(17).
    MOVE "!GENERAL OVERHEAD:     ] "                                                                                                             TO TLNW(18).
    MOVE "!TOTAL MFG COST:                  ] "                                                                                                  TO TLNW(19).
    MOVE "?? "                                                                                                                                   TO TLNW(20).

RD93.
    MOVE "^UPDATE COST OF NUTS SHIPPED WITH BOLTS ] "                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!NUT RECORDS UPDATED:]                                      !'OK' TO START] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD94.
    MOVE "^MISCELLANEOUS MODIFICATIONS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHANGE THE PRODUCT PRINT REVISION "                                             TO TLN(5).
    MOVE "2. CHANGE THE PRODUCT SPEC "                                                       TO TLN(6).
    MOVE "3. CHANGE THE PPAP INDICATOR "                                                     TO TLN(7).
    MOVE "4. CHANGE THE PRODUCT FINISH DESCRIPTION "                                         TO TLN(8).
    MOVE "5. CHANGE THE QUALITY ALERT NO. "                                                  TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD94A.
    MOVE "^CHANGE THE PRODUCT PRINT REVISION ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION CHANGES THE PRINT REVISION FOR ALL PRODUCTS "                        TO TLN(3).
    MOVE "  WITH THE SPECIFIED PRINT NUMBER. "                                               TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT NO.] ______       !NEW REVISION] __ "                                       TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD94B.
    MOVE "^CHANGE THE PRODUCT SPEC ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION PLACES THE 'NEW SPEC' IN ALL PRODUCTS "                              TO TLN(3).
    MOVE "  WITH THE SPECIFIED 'CURRENT SPEC'. "                                             TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!CURRENT SPEC] ____________________     !NEW SPEC] ____________________ "          TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD94C.
    MOVE "^CHANGE THE PPAP INDICATOR ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION MODIFIES THE PPAP INDICATOR IN THE PRODUCT SPECIFIED. "              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!CURRENT PPAP] _        ( 0=NO  1=YES ) "                                          TO TLN(7).
    MOVE "    !NEW PPAP] _ "                                                                 TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD94D.
    MOVE "^CHANGE THE PRODUCT FINISH DESCRIPTION ] "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION PLACES THE 'NEW FINISH DESCRIPTION' IN ALL PRODUCTS "                TO TLN(3).
    MOVE "  WITH THE SPECIFIED 'CURRENT FINISH DESCRIPTION'. "                               TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!CURRENT FINISH DESCRIPTION] ________________________________ "                    TO TLN(6).
    MOVE "    !NEW FINISH DESCRIPTION] ________________________________ "                    TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD94E.
    MOVE "^CHANGE THE QUALITY ALERT NO. ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION MODIFIES THE QUALITY ALERT NO. IN THE PRODUCT SPECIFIED. "           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!CURRENT QA NO.] ___      (0 = NO ALERT) "                                         TO TLN(7).
    MOVE "    !NEW QA NO.] ___ "                                                             TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD95.
    MOVE "^TABLES MAINTENANCE AND LISTING ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "GENERAL TABLES  1. MAINTENANCE "                                                   TO TLN(6).
    MOVE "                2. LISTING "                                                       TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "SHIP-VIA TABLE  3. MAINTENANCE "                                                   TO TLN(9).
    MOVE "                4. LISTING "                                                       TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "PACKING TABLE   5. MAINTENANCE "                                                   TO TLN(12).
    MOVE "                6. LISTING "                                                       TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "SALESMAN TABLE  7. MAINTENANCE "                                                   TO TLN(15).
    MOVE "                8. LISTING "                                                       TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD96.
    MOVE "^SYSTEM FUNCTIONS ] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. SET S-20 VERIFICATION DATE "                                                   TO TLN(5).
    MOVE " 2. MODIFY SYSTEM-GENERATED NUMBERS "                                              TO TLN(6).
    MOVE " 3. MODIFY SALES MTD TOTALS "                                                      TO TLN(7).
    MOVE " 4. MODIFY M.O. AUTOMATIC SEQUENCE NUMBERS "                                       TO TLN(8).
    MOVE " 5. MODIFY RAW MATERIAL ADDED VALUES AND FREIGHT RATE "                            TO TLN(9).
    MOVE " 6. RE-CREATE DAILY SHIPPING/SALES FILES "                                         TO TLN(10).
    MOVE " 7. MODIFY GST, HST, PST, QST RATES "                                              TO TLN(11).
    MOVE " 8. MODIFY PRODUCTION OFF DATES "                                                  TO TLN(12).
    MOVE " 9. MODIFY STEEL SURCHARGE VALUES "                                                TO TLN(13).
    MOVE "10. MODIFY US$ EXCHANGE RATES "                                                    TO TLN(14).
    MOVE "11. SET MAIN/EPSON PRINTER INDICATOR "                                             TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(17).
    MOVE "?? "                                                                               TO TLN(18).

RD97.
    MOVE "^BACKORDER REPORTS ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CATEGORY/PRODUCT "                                             TO TLN(3).
    MOVE "              2. BY CUSTOMER "                                                     TO TLN(4).
    MOVE "              3. PRODUCT DEMAND OVER TIME "                                        TO TLN(5).
    MOVE "              4. PRODUCT AVAILABILITY (ONLY EXPORT FILE) "                         TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD98.
    MOVE "^ORDER REPORTS ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. REGULAR ORDER BOOK "                                              TO TLN(3).
    MOVE "              2. REGULAR ORDERS PAST DUE "                                         TO TLN(4).
    MOVE "              3. REGULAR ORDERS NOT YET DUE "                                      TO TLN(5).
    MOVE "             11. BLANKET ORDER BOOK "                                              TO TLN(6).
    MOVE "             12. BLANKET ORDERS PAST DUE "                                         TO TLN(7).
    MOVE "             13. BLANKET ORDERS NOT YET DUE "                                      TO TLN(8).
    MOVE "             21. FULL ORDER BOOK (ONLY EXPORT FILE) "                              TO TLN(9).
    MOVE "             22. ORDER BOOK MONTHLY SUMMARY (ONLY EXPORT FILE) "                   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD99.
    MOVE "^TOOL TABLES LISTING ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD100.
    MOVE "^DAILY SALES ANALYSIS REPORT ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^DATA FOR DAILY SHIPMENTS SUMMARY:]       !SHIPPING DAYS:] !MTD] __  !YTD] ___ "   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "   ^CURRENT MONTH FORECAST:                 ] "                                    TO TLN(5).
    MOVE "   !MONTH] __   !MTD]           !YTD] "                                            TO TLN(6).
    MOVE "      !AMOUNT]   ____________    ____________ "                                    TO TLN(7).
    MOVE "      !WEIGHT]   __________      __________ "                                      TO TLN(8).
    MOVE "      !AMT/CWT]  _______         _______ "                                         TO TLN(9).
    MOVE "      !TONS/DAY] ______          ______ "                                          TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!PRINT ONLY THE DAILY SHIPMENTS SUMMARY ?] ___   !REPORT DATE] ______ "            TO TLN(12).
    MOVE "                                                 !UPDATE G/L MTD TOTALS ?] ___ "   TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!TERRITORY TOTALS ONLY ?] ___     !TOTALS ONLY ?] ___ "                            TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(17).
    MOVE "?? "                                                                               TO TLN(18).

RD101.
    MOVE "^FORWARD LOADING REPORT (SECONDARY OPERATIONS) ] "                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM PROCESS] ____       !TO PROCESS] ____ "                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD102.
    MOVE "^CREATE MISCELLANEOUS LABELS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __  (CREATE 'LAB09.PRN') "                                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. SHIPPING ADDRESS LABELS "                                                      TO TLN(5).
    MOVE " 2. INSPECTION LABELS "                                                            TO TLN(6).
    MOVE " 3. BILLING ADDRESS LABELS "                                                       TO TLN(7).
    MOVE " 4. GENERAL TEXT LABELS "                                                          TO TLN(8).
    MOVE " 5. BIN LABELS "                                                                   TO TLN(9).
    MOVE " 6. BIN LEVEL LABELS "                                                             TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD102A.
    MOVE "^CREATE SHIPPING ADDRESS LABELS ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "   !CUSTOMER NO.] ______   !SHIP-TO CODE] __     !NUM. LABELS] ___ "               TO TLN(3).
    MOVE "                  ______                  __                   ___ "               TO TLN(4).
    MOVE "                  ______                  __                   ___ "               TO TLN(5).
    MOVE "                  ______                  __                   ___ "               TO TLN(6).
    MOVE "                  ______                  __                   ___ "               TO TLN(7).
    MOVE "                  ______                  __                   ___ "               TO TLN(8).
    MOVE "                  ______                  __                   ___ "               TO TLN(9).
    MOVE "                  ______                  __                   ___ "               TO TLN(10).
    MOVE "                  ______                  __                   ___ "               TO TLN(11).
    MOVE "                  ______                  __                   ___ "               TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "    ^OR SPECIFY ] !NAME          ] ________________________________ "              TO TLN(14).
    MOVE "                  !ADDRESS LINE 1] ________________________________ "              TO TLN(15).
    MOVE "                  !ADDRESS LINE 2] ________________________________ "              TO TLN(16).
    MOVE "                  !POSTAL CODE   ] __________ "                                    TO TLN(17).
    MOVE "                  !NUM. LABELS   ] ___ "                                           TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "                                                                       !OK] __ "   TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD102B.
    MOVE "^CREATE INSPECTION LABELS ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "   !INSPECTOR] __       !NUM. LABELS] ___ "                                        TO TLN(3).
    MOVE "                                                                       !OK] __ "   TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD102C.
    MOVE "^CREATE BILLING ADDRESS LABELS ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CUSTOMER] ______       !TO CUSTOMER] ______ "                                TO TLN(3).
    MOVE "                                                                       !OK] __ "   TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD102D.
    MOVE "^CREATE GENERAL TEXT LABELS ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!TEXT 1]   ___________________________________ "                                   TO TLN(3).
    MOVE "           ___________________________________ "                                   TO TLN(4).
    MOVE "           ___________________________________ "                                   TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!TEXT 2]   ___________________________________ "                                   TO TLN(7).
    MOVE "           ___________________________________ "                                   TO TLN(8).
    MOVE "           ___________________________________ "                                   TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!NUM LABELS] ___                                                       !OK] __ "   TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD102E.
    MOVE "^CREATE BIN LABELS ]                                             'PF4' TO END _ "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "       !FROM  TO] "                                                                TO TLN(3).
    MOVE "!ROW   ] __   __    (1 - 30) "                                                     TO TLN(4).
    MOVE "!COLUMN] __   __    (1 - 70) "                                                     TO TLN(5).
    MOVE "!LEVEL ] _    _     (A - H  OR BLANK) "                                            TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!TOTAL LABELS:]                                                        !OK] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD102F.
    MOVE "^CREATE BIN LEVEL LABELS ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION CREATES 2 LABELS, FOR LEVELS A - H "                                 TO TLN(3).
    MOVE "                                                                       !OK] __ "   TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD103.
    MOVE "^WORKSHEET ENTRY ]                    !PRODUCT] "                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O.](OR LOT) _______   !MACH/PROC] ____ "                                        TO TLN(3).
    MOVE "!DATE](MMDDYY) ______    !SHIFT](D/A/N) _ "                                        TO TLN(4).
    MOVE "!CLOCK NO.] ____    !NAME] ____________________ "                                  TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD103A. MOVE 7 TO TSTART.
    MOVE "!CODE] _     ! 1      2      3      4      5      6      7      8      9 ] "       TO TLN(7).
    MOVE "!HRS:MINS]    _:__   _:__   _:__   _:__   _:__   _:__   _:__   _:__   _:__ "       TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!QTY] __________     !WEIGHT] __________                    !TOTAL TIME]   : "     TO TLN(10).
    MOVE "!NOTES] ______________________________________________________________________ "   TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD103B. MOVE 13 TO TSTART.
    MOVE "!BUCKET NOS.] ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ "   TO TLN(13).
    MOVE "              ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ "   TO TLN(14).
    MOVE "              ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ ____ "   TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD103C. MOVE 13 TO TSTART.
    MOVE "!TIME CODES] "                                                                     TO TLN(13).
    MOVE " 1. RUN "                                                                          TO TLN(14).
    MOVE " 2. TRAINING RUN "                                                                 TO TLN(15).
    MOVE " 3. SETUP "                                                                        TO TLN(16).
    MOVE " 4. DOWNTIME TOOLING "                                                             TO TLN(17).
    MOVE " 5. DOWNTIME MATERIAL "                                                            TO TLN(18).
    MOVE " 6. DOWNTIME MAINTENANCE "                                                         TO TLN(19).
    MOVE " 7. REWORK "                                                                       TO TLN(20).
    MOVE " 8. VERIFY "                                                                       TO TLN(21).
    MOVE " 9. OPERATOR NOT AVAILABLE "                                                       TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD104.
    MOVE "^WORKSHEETS FOR M.O.                                                           ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^MACH  DATE  SH NAME                HOURS    PIECES   WEIGHT---ACTUAL    TARGET]"  TO TLN(3).
*         .... ../../.. . .................... .:.. .,...,...- ...,...- ...,...-.  ...,...
*               BUCKETS:! ....:....] (x5)
    MOVE " "                                                                                 TO TLN(4).

RD105.
    MOVE "^MACHINE/PROCESS RECORD ]     !MACH/PROC NO.     ] "                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!GROUP ] "                                                                         TO TLN(3).
    MOVE "!TYPE  ] "                                                                         TO TLN(4).
    MOVE "!SECTOR] "                                                                         TO TLN(5).
    MOVE "!TARGET PRODUCTION]               !SPEED]         !EFFICIENCY %] "                 TO TLN(6).
    MOVE "!TARGET WEIGHT/M] "                                                                TO TLN(7).
    MOVE "!HOURS/DAY] "                                                                      TO TLN(8).
    MOVE "!DESCRIPTION LINE 1] "                                                             TO TLN(9).
    MOVE "            !LINE 2] "                                                             TO TLN(10).
    MOVE "!OPERATION DESCRIPTION]                   !PLATING PROCESS] "                      TO TLN(11).
    MOVE "!COST]               !TARGET COST] "                                               TO TLN(12).
    MOVE "!ALTERNATE COST (PER HOUR)] "                                                      TO TLN(13).
    MOVE "!LOT CHARGE]           !BATCH CHARGE]           !SURCHARGE %] "                    TO TLN(14).
    MOVE "!CURRENT M.O.]         !FREIGHT/TON] "                                             TO TLN(15).
    MOVE "!VENDOR NO.] "                                                                     TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "                                                NEXT MACH/PROC NO. ____ "          TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD106.
    MOVE "^PRODUCTION ORDER ENTRY ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ORDER NO.  ] ______        !CORRECTION ?] ___ "                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT NO.] ____________ "                                                       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "         !QTY ORDERED] __________  (+/-  ADD/SUBTRACT) "                           TO TLN(7).
    MOVE "         !START DATE ] ______ "                                                    TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "^SPECIAL ORDERS ONLY] !SALES ORDER NO.] ______  !LINE NO.] __ "                    TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "^ADJ ONLY] !QTY ORD] __________   !QTY PROD] __________   !QTY RCVD] __________ "  TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD107.
    MOVE "^EDI BATCH ] "                                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!THIS FUNCTION PERFORMS THE FOLLOWING OPERATIONS:] "                               TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "- READ GM EDI FILE (LEAVE FILE BLANK IF NO GM FILE) "                              TO TLN(5).
    MOVE "- READ ADVANTIS EDI FILE (LEAVE FILE BLANK IF NO ADVANTIS FILE) "                  TO TLN(6).
    MOVE "- S-10. GENERATE BLANKET ORDER EXTENSIONS "                                        TO TLN(7).
    MOVE "- S-21. ALLOCATE BINS "                                                            TO TLN(8).
    MOVE "- S-23. PRINT PICKING TICKETS "                                                    TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "      !GM EDI FILE] ________         ^PRINT FILE NO.] !FOR REPORTS] __ "           TO TLN(11).
    MOVE "!ADVANTIS EDI FILE] ________                          !FOR REPORT DETAILS] __ "    TO TLN(12).
    MOVE "                                                      !FOR PICKING TICKETS] __ "   TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!FOR BIN ALLOCATION:] "                                                            TO TLN(15).
    MOVE " BLANKET ORDERS WITH REQUIRED DATE UP TO AND INCLUDING THIS DATE "                 TO TLN(16).
    MOVE "   WILL BE AUTOMATICALLY SELECTED FOR SHIPPING IF ALLOCATED 100% AND OVER "        TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "       !GM ORDERS] ______ "                                                        TO TLN(19).
    MOVE "   !NON-GM ORDERS] ______ "                                                        TO TLN(20).
    MOVE "                                                                       !OK] __ "   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD108.
    MOVE "^MATERIAL RELEASE FILE 'MATREL' MAINTENANCE ]                ^FUNCTION] _ "        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PLANT] __________     !PRODUCT] ____________                1. ADD RECORD "       TO TLN(3).
    MOVE "                                                             2. CHANGE RECORD "    TO TLN(4).
    MOVE "!SALES REP] __     !CREATION DATE] ______                    3. DELETE RECORD "    TO TLN(5).
    MOVE "!RELEASE STATUS] __    !DOCK] ________   !LINE FEED] ______  4. DELETE FIRST "     TO TLN(6).
    MOVE "                                                                   QTY/DATE PAIR"  TO TLN(7).
    MOVE "!SOURCE] __________       !RELEASE NUM.] __________ "                              TO TLN(8).
    MOVE "!TYPE] __       !SCHEDULE] __                          !QTY SHIPPED] __________ "  TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "^WEEKLY SCHEDULE ]       !FROM] ______     !TO] ______      !ISSUE DATE] ______ "  TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!  QTY     DATE         QTY     DATE         QTY     DATE         QTY     DATE ]"  TO TLN(13).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(14).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(15).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(16).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "^INFORMATION ]   !1] ________________________________________ "                    TO TLN(19).
    MOVE "                 !2] ________________________________________ "                    TO TLN(20).
    MOVE "                 !3] ________________________________________ "                    TO TLN(21).
    MOVE "                 !4] ________________________________________ "                    TO TLN(22).
    MOVE "                 !5] ________________________________________ "                    TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD109.
    MOVE "^DAILY RELEASE FILE 'DAYREL' MAINTENANCE ] "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. ADD/CHANGE/DELETE 'DAYREL' RECORDS "                                            TO TLN(5).
    MOVE "2. DELETE OLD 'DAYREL' RECORDS "                                                   TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD110.
    MOVE "^'DAYREL' FILE MAINTENANCE ]                                 ^FUNCTION] _ "        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PLANT] __________     !PRODUCT] ____________     !NO.] __   1. ADD RECORD "       TO TLN(3).
    MOVE "                                                             2. CHANGE RECORD "    TO TLN(4).
    MOVE "!AUTO CODE] __     !ORDER NO.] ______     !SCHEDULE] __      3. DELETE RECORD "    TO TLN(5).
    MOVE "!CREATION DATE] ______    !CUST ORDER] _________ "                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!LINE FEED, GRP/DEPT] __________     !PLANT/DOCK] ________ "                       TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!  QTY     DATE         QTY     DATE         QTY     DATE         QTY     DATE ]"  TO TLN(10).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(11).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(12).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(13).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(14).
    MOVE "________  ______     ________  ______     ________  ______     ________  ______ "  TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD111.
    MOVE "^DELETE OLD 'DAYREL' RECORDS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION DELETES ALL 'DAYREL' RECORDS "                                       TO TLN(3).
    MOVE "  WITH A CREATION DATE EARLIER THAN THE DATE ENTERED. "                            TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!AUTO CODE] __     !OLDEST DATE TO KEEP] ______                        !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD112.
    MOVE "^PART FILE MAINTENANCE ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PART NO.] ____________       ^FUNCTION] _      ^FUNCTIONS                 ] "     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                1. ADD RECORD "                    TO TLN(5).
    MOVE "                                                2. DISPLAY / CHANGE RECORD "       TO TLN(6).
    MOVE "                                                3. DELETE RECORD "                 TO TLN(7).
    MOVE "                                                4. ADD RECORDS FROM TEMPLATE "     TO TLN(8).
    MOVE "                                                5. CHANGE ALTERNATE PART NO. "     TO TLN(9).
    MOVE "                                                6. CHANGE VENDOR PART NO. "        TO TLN(10).
    MOVE "                                                9. END "                           TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD113.
    MOVE "^ADD PART RECORD ]      ^PART NO.] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ASSY DIE INDICATOR] _            !PRICE MODE] ____    !UNIT OF MEASURE] ____ "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!DRAWING] ____________    !REVISION] _    !LIFE EXPECT.] ______ "                  TO TLN(5).
    MOVE "!CATEGORY] ___  !MATERIAL] ____________________ "                                  TO TLN(6).
    MOVE "!DESCRIPTION] ________________________________ "                                   TO TLN(7).
    MOVE "              ________________________________ "                                   TO TLN(8).
    MOVE "!VENDOR 1] ____      !VENDOR 2] ____      !VENDOR 3] ____ "                        TO TLN(9).
    MOVE "!PRICE 1] _________  !PRICE 2] _________  !PRICE 3] _________ "                    TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!REORDER QTY] _______     !ECONOMIC ORDER QTY] _____     !REORDER LEVEL] _ "       TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!QTY ON HAND] _______    !QTY ON ORDER] _______    !QTY ON DEMAND] _______ "       TO TLN(14).
    MOVE "!QTY MTD] _______      !QTY YTD] _______      !QTY LAST YR] _______ "              TO TLN(15).
    MOVE "!VALUE MTD] _________  !VALUE YTD] _________  !VALUE LAST YR] _________ "          TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!MACHINE TYPE] __    !TAX CODE] __    !HARMONY CODE] __ "                          TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD114.
    MOVE "^PART RECORD ] "                                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PART NO.] "                                                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. DRAWING          2. CATEGORY         3. PRICE MODE       4. UNIT OF MEASURE "  TO TLN(5).
    MOVE " 5. DESCRIPT 1       6. DESCRIPT 2       7. MATERIAL         8. VENDOR 1 "         TO TLN(6).
    MOVE " 9. VENDOR 2        10. VENDOR 3        11. PRICE 1         12. PRICE 2 "          TO TLN(7).
    MOVE "13. PRICE 3         14. ACTUAL LIFE     15. QTY ON HAND     16. QTY ON ORDER "     TO TLN(8).
    MOVE "17. QTY ON DEMAND   18. REORDER QTY     19. QTY MTD         20. QTY YTD "          TO TLN(9).
    MOVE "21. QTY LAST YR     22. VALUE MTD       23. VALUE YTD       24. VALUE LAST YR "    TO TLN(10).
    MOVE "25. DATE LAST CHG   26. MACHINE TYPE    27. TAX CODE        28. HARMONY CODE "     TO TLN(11).
    MOVE "29. LIFE            30. DRWG REVISION   31. ECON ORDER QTY  32. REORDER LEVEL "    TO TLN(12).
    MOVE "33. ASSY DIE IND.   34. TARGET COST     35. LAID DOWN COST "                       TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD114A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD115.
    MOVE "^BIN FILE MAINTENANCE ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.] ______              ^FUNCTION] _      ^FUNCTIONS               ] "       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                1. ADD RECORD "                    TO TLN(5).
    MOVE "                                                2. DISPLAY / CHANGE RECORD "       TO TLN(6).
    MOVE "                                                3. DELETE RECORD "                 TO TLN(7).
    MOVE "                                                9. END "                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD116.
    MOVE "^ADD BIN RECORD ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.] "                                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PART NO.] ____________     !QUANTITY] _________ "                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!P.O.] __________ "                                                                TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PROCESS CODE] _    !NUM. COILS] ___    !HEAT NO.] __________ "                    TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD117.
    MOVE "^BIN RECORD ] "                                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN NO.] "                                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. PART NO.         2. LAST CHG DATE    3. QUANTITY         4. PROCESS CODE "     TO TLN(5).
    MOVE " 5. QTY ALLOCATED    6. HEAT NO.         7. NUM COILS        8. P.O. NO. "         TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD117A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD118.
    MOVE "^PART RECORD] !PART NO.             ]  !DRAWING]                        !ASSY] "   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE " "                                                                                 TO TLN(3).
    MOVE "!CATEGORY]        !MODE]         !UNIT]           !ALT PART NO.] "                 TO TLN(4).
    MOVE "!MATERIAL]                            !VENDOR PART NO.] "                          TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!LDN COST]             ^VENDOR:] !1:]            !2:]            !3:] "            TO TLN(7).
    MOVE "!TRG COST]             ^ PRICE:] "                                                 TO TLN(8).
    MOVE "^ROP, EOQ, LEVEL] "                                                                TO TLN(9).
    MOVE "                                       !LIFE]             !ACTUAL LIFE] "          TO TLN(10).
    MOVE "!ON HAND] "                                                                        TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!ON DEMAND] "                                                                      TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!ON ORDER]              !BLANKET LINES] "                                          TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "^PURCHASED     QTY:]  !MTD]              !YTD]              !LAST YR] "            TO TLN(17).
    MOVE "            ^VALUE:] "                                                             TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "!MAC TYPE]      !TAX CODE]       !HARMONY CODE]        !DATE LAST CHG] "           TO TLN(20).
    MOVE "!ON HAND JAN 1, LAST YR, 2 YRS AGO] "                                              TO TLN(21).
    MOVE "^REQUISITION:] !CREATED]             !QTY] "                                       TO TLN(22).
    MOVE "                                                 NEXT PART NO. ____________ "      TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD119.
    MOVE "^BIN RECORD ]      !BIN NO.                                                    ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PART NO.]                !QTY]                    !LAST CHANGE DATE] "            TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!P.O. NO.] "                                                                       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PROCESS]        !NUM COILS]         !AVG. WEIGHT]             !HEAT] "            TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "                                                          NEXT BIN NO. ______ "    TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD120.
    MOVE "^BINS CONTAINING PART NO.] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "                                                 !TOTAL QTY ON HAND:] "            TO TLN(3).
    MOVE "^BIN            QTY     DATE    P.O. NO.   PROC  COILS   AV.WT.  HEAT     ] "      TO TLN(4).
*         ........ ..,...,...-  ../../..  ..........   .    ...    .,...   ..........
    MOVE " "                                                                                 TO TLN(5).

RD121.
    MOVE "^STOCK UPDATE ]      !TRANSACTION TYPE] ___       !TRANSACTION DATE] ______ "      TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD122.
    MOVE "^PURCHASE ORDER ENTRY ]            !P.O. NO.] ________ "                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VENDOR] ____                !DATE] ______    !DATE REQD] ______       !HOLD] _ "  TO TLN(3).
    MOVE "                                                                    !BLANKET] _ "  TO TLN(4).
    MOVE "!NAME     ] "                                                                      TO TLN(5).
    MOVE "!ADDR LN 1] "                                                                      TO TLN(6).
    MOVE "!ADDR LN 2] "                                                                      TO TLN(7).
    MOVE "!POST CODE] "                                                                      TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!SHIP TO] ____________________ "                                                   TO TLN(10).
    MOVE "!VIA    ] _______________ "                                                        TO TLN(11).
    MOVE "!F.O.B. ] _______________ "                                                        TO TLN(12).
    MOVE "!TERMS  ] ____________      !US$] _   !PST] _     !STD TEXT] __  __  __  __  __ "  TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD122A.
    MOVE "^PURCHASE ORDER          ]    !VENDOR]         !ORDER TOTAL] "                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!  QTY   UNIT  PART NO.        PRICE    MODE  DISC     VALUE     CAT ] "           TO TLN(3).
*         .......- ....  ............  ......:... ....   ..   .......:..-  ...
    MOVE "?? "                                                                               TO TLN(4).

RD122B.
    MOVE "^MODIFY PURCHASE ORDER          ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!  QTY   UNIT  PART NO.        PRICE    MODE  DISC     VALUE         QTY RCVD ] "  TO TLN(3).
*         .......- ....  ............  ......:... ....   ..   .......:..-    .........-
    MOVE "?? "                                                                               TO TLN(4).

RD123.
    MOVE "^MODIFY PLANT EDIFACT INDICATOR ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PLANT CODE] __________      !EDIFACT IND.] _   ( 0: EDI    1: EDIFACT ) "         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!ALL PLANT-PRODUCT RECORDS FOR THIS PLANT WILL BE MODIFIED AS INDICATED ] "        TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                                       !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD124.
    MOVE "^PURCHASE ORDERS ] !PART NO.] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ORDER    VENDOR                                        QTY ORD      QTY REC ] "   TO TLN(3).
*         ........  ....  .................................... ..,...,...-  ..,...,...-
    MOVE " "                                                                                 TO TLN(4).

RD125.
    MOVE "^PRINT PURCHASE ORDERS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM ORDER] ________       !TO ORDER] ________ "                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!INCLUDE PURCHASE ORDERS ALREADY PRINTED ON DATE] ______ "                         TO TLN(5).
    MOVE "!IRVINE TOOLS ORDERS ?] ___  (OTHERWISE ALL OTHER VENDORS) "                       TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD126.
    MOVE "^TOOL LIST NOTES ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________      !MACHINE] __ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PL NO.] ________ "                                                                TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "  !NOTES] "                                                                        TO TLN(7).
    MOVE "   ____________________________________________________________ "                  TO TLN(8).
    MOVE "   ____________________________________________________________ "                  TO TLN(9).
    MOVE "   ____________________________________________________________ "                  TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD127.
    MOVE "^TOOL APPLICATIONS ]   !TOOL M#:] "                                                TO TLN(1).
    MOVE "                          !DWG#:] "                                                TO TLN(2).
    MOVE "^PRODUCT      DESCRIPTION                       CAT  MACHINE    ON ORDER] "        TO TLN(3).
*         ............  ................................  ..      ..   ...,...,...
    MOVE " "                                                                                 TO TLN(4).

RD128.
    MOVE "^CLEANED COIL BINS ]                                    !TOTAL QTY:] "             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN       PART NO.           QTY     DATE    PROC  COILS   AV.WT.  HEAT     ] "   TO TLN(3).
*         ........  ............ ..,...,...-  ../../..    .    ...    .,...   ..........
    MOVE " "                                                                                 TO TLN(4).

RD129.
    MOVE "^ISSUE BLANKET PURCHASE ORDER ]     !BLANKET P.O. NO.] ________ "                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VENDOR]                                                          !DATE] "         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!NEW P.O. NO.] ________         !DATE] ______      !DATE REQD] ______ "            TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!  QTY   UNIT  PART NO.        PRICE    MODE  DISC     VALUE ] "                   TO TLN(10).
*         .......  ....  ............  ......:... ....   ..   .......:..
    MOVE "?? "                                                                               TO TLN(11).

RD130.
    MOVE "^PURCHASE HISTORY]   !PART NO.] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ DATE    ORDER    VENDOR                                      QTY      LD COST]"  TO TLN(3).
*         ../../..  ........  ....  ................................. ...,...- ...,...:...
    MOVE " "                                                                                 TO TLN(4).

RD131.
    MOVE "^MISCELLANEOUS MODIFICATIONS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHANGE A TOOL IN ALL TOOL LISTS "                                               TO TLN(5).
    MOVE "2. ADD RANGE OF BINS (TWO-CHARACTER PREFIX) "                                      TO TLN(6).
    MOVE "3. CHANGE A FIELD IN A RANGE OF TOOLS "                                            TO TLN(7).
    MOVE "4. CHANGE A TOOL DEPENDING ON ANOTHER TOOL IN ALL TOOL LISTS "                     TO TLN(8).
    MOVE "5. DELETE ALL TOOL LISTS FOR PRODUCT CATEGORIES 61 - 98 "                          TO TLN(9).
    MOVE "6. DELETE ALL TOOL LISTS FOR A CERTAIN MACHINE "                                   TO TLN(10).
    MOVE "7. ADD RANGE OF BINS (ONE-CHARACTER AND MACHINE PREFIX) "                          TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD131A.
    MOVE "^CHANGE A TOOL IN ALL TOOL LISTS ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!NO ONE ELSE SHOULD BE RUNNING A GLOBAL TOOL FILE MODIFICATION ] "                 TO TLN(3).
    MOVE "  !OR 'TOOL FILE MAINTENANCE' WHILE THIS OPERATION IS TAKING PLACE ] "             TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "  !CHANGE TOOL] ____________      !TO TOOL] ___________ "                          TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD131B.
    MOVE "^ADD RANGE OF BINS (TWO-CHARACTER PREFIX) ] "                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "  !BIN PREFIX] __                    !NUMERIC SUFFIX:]  !FROM] ___   !TO] ___ "    TO TLN(3).
    MOVE "                       !OPTIONAL FINAL LETTER SUFFIX:]  !FROM] _     !TO] _ "      TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "THIS FUNCTION CREATES ALL THE BINS IN THE RANGE: PREFIX-FROM - PREFIX-TO "         TO TLN(6).
    MOVE "  (ANY EXISTING BINS IN THIS RANGE ARE NOT AFFECTED) "                             TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD131C.
    MOVE "^CHANGE A FIELD IN A RANGE OF TOOLS ] "                                                                                                TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "THE NEW FIELD VALUE WILL BE PLACED INTO ALL THE TOOLS STARTING WITH THIS PREFIX "                                                      TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "!PART PREFIX] __________     !FIELD NO. TO MODIFY] __    !NEW FIELD VALUE] _                                    !'OK' TO START] __ "   TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^FIELDS:]    1. DRAWING         2. DRAWING REV.    3. DESCRIPTION LINE 1      4. CATEGORY       5. LIFE EXPECT.       6. E.O.Q. "      TO TLNW(7).
    MOVE "             7. MACHINE TYPE    8. VENDOR 1        9. PRICE 1                10. ROP           11. LEVEL "                             TO TLNW(8).
    MOVE "?? "                                                                                                                                   TO TLNW(9).

RD131D.
    MOVE "^CHANGE A TOOL DEPENDING ON ANOTHER TOOL IN ALL TOOL LISTS ] "                                                                         TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!NO ONE ELSE SHOULD BE RUNNING A GLOBAL TOOL FILE MODIFICATION OR 'TOOL FILE MAINTENANCE' WHILE THIS OPERATION IS TAKING PLACE ] "     TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "  !MACHINE] __      !CHANGE TOOL NO.] ___                          !TO] ____________ "                                                 TO TLNW(5).
    MOVE "                        !IF TOOL NO.] ___                          !IS] ____________                            !'OK' TO START] __ "   TO TLNW(6).
    MOVE "?? "                                                                                                                                   TO TLNW(7).

RD131E.
    MOVE "^DELETE TOOL LISTS ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!THIS FUNCTION DELETES ALL EXISTING TOOL LISTS ] "                                 TO TLN(3).
    MOVE "  !FOR PRODUCTS IN CATEGORIES 61 - 98 ] "                                          TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD131F.
    MOVE "^DELETE TOOL LISTS ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!THIS FUNCTION DELETES ALL TOOL LISTS FOR THE MACHINE GIVEN. ] "                   TO TLN(3).
    MOVE "!IT ALSO CLEARS THE ALTERNATE MACHINE FIELD FOR ALL PRODUCTS ] "                   TO TLN(4).
    MOVE "  !THAT USE IT AS ALTERNATE. ] "                                                   TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "  !MACHINE] __ "                                                                   TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "                                          !'OK' TO DELETE THESE TOOL LISTS] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD131G.
    MOVE "^ADD RANGE OF BINS (ONE-CHARACTER AND MACHINE PREFIX) ] "                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "  !BIN PREFIX] _     !MACHINE] __      !NUMERIC SUFFIX:]  !FROM] ___   !TO] ___ "  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "THIS FUNCTION CREATES ALL THE BINS IN THE RANGE: "                                 TO TLN(5).
    MOVE "          PREFIX-MAC-FROM - PREFIX-MAC-TO "                                        TO TLN(6).
    MOVE "  (ANY EXISTING BINS IN THIS RANGE ARE NOT AFFECTED) "                             TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "                                                            !'OK' TO START] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD132.
    MOVE "^VENDOR FILE MAINTENANCE ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^VENDOR NO.] ____           ^FUNCTION] _        ^FUNCTIONS               ] "       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                1. ADD RECORD "                    TO TLN(5).
    MOVE "                                                2. DISPLAY / CHANGE RECORD "       TO TLN(6).
    MOVE "                                                3. DELETE RECORD "                 TO TLN(7).
    MOVE "                                                9. END "                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD133.
    MOVE "^ADD VENDOR RECORD ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^VENDOR NO.] "                                                                     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!NAME      ] ____________________________________ "                                TO TLN(5).
    MOVE "!ADDRESS 1 ] ____________________________________ "                                TO TLN(6).
    MOVE "!ADDRESS 2 ] ________________________ "                                            TO TLN(7).
    MOVE "!POST CODE ] _______ "                                                             TO TLN(8).
    MOVE "!DISCOUNT  ] _____ "                                                               TO TLN(9).
    MOVE "!G/L CONTRA] _______ "                                                             TO TLN(10).
    MOVE "!PAY CODE  ] _ "                                                                   TO TLN(11).
    MOVE "!COMMODITY CLASS] ___ "                                                            TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD134.
    MOVE "^VENDOR RECORD ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^VENDOR NO.] "                                                                     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. NAME             2. ADDRESS LINE 1   3. ADDRESS LINE 2   4. POSTAL CODE "      TO TLN(5).
    MOVE " 5. DISCOUNT %       6. GROSS BAL CN$    7. GROSS BAL US$    8. NET BAL CN$ "      TO TLN(6).
    MOVE " 9. NET BAL US$     10. PURCH YTD CN$   11. PURCH YTD US$   12. PRCH LST YR CN$ "  TO TLN(7).
    MOVE "13. PRCH LST YR US$ 14. PRCH 2 YR CN$   15. PRCH 2 YR US$   16. DISC YTD CN$ "     TO TLN(8).
    MOVE "17. DISC YTD US$    18. LAST INV DATE   19. G/L CONTRA      20. PAY CODE "         TO TLN(9).
    MOVE "21. COMMODITY CLASS 22. GST INDICATOR   23. FREIGHT STD     24. FREIGHT RATE "     TO TLN(10).
    MOVE "25. FRT PAID TO VEN 26. SHPTO USE IND   27. SHPTO NAME      28. SHPTO ADDR LN 1 "  TO TLN(11).
    MOVE "29. SHPTO ADDR LN 2 30. SHPTO POST CD "                                            TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD134A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD135.
    MOVE "^G/L CHART OF ACCOUNTS MAINTENANCE ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!G/L ACCOUNT              DESCRIPTION                  NEW G/L ACCOUNT     ] "     TO TLN(3).
    MOVE " ______ ___ __ _______    _________________________    ______ ______ ____ __ "     TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD136.
    MOVE "^VENDOR RECORD ]       ^VENDOR      ]!                                    ] "      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE " "                                                                                 TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                            ^CONTACT] "                                            TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!CONTRA]           !GST IND.]     !FREIGHT STD]        !FREIGHT RATE/CWT] "        TO TLN(9).
    MOVE "                                  !FREIGHT PAID TO VENDOR] "                       TO TLN(10).
    MOVE "!DISCOUNT]         !PAY CODE]     !COMMODITY CLASS]       !LAST INVOICE] "         TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "                 ^      CN$  ]  ^      US$  ] "                                    TO TLN(13).
    MOVE "!GROSS        ] "                                                                  TO TLN(14).
    MOVE "!NET          ] "                                                                  TO TLN(15).
    MOVE "!DISCOUNT YTD ] "                                                                  TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!PURCHASES YTD] "                                                                  TO TLN(18).
    MOVE "    !LAST YEAR] "                                                                  TO TLN(19).
    MOVE "  !2 YEARS AGO] "                                                                  TO TLN(20).
    MOVE " "                                                                                 TO TLN(21).
    MOVE " "                                                                                 TO TLN(22).
    MOVE "                                                         NEXT VENDOR NO. ____ "    TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD137.
    MOVE "^TRANSACTIONS BY VENDOR ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. OPEN TRANSACTIONS "                                               TO TLN(3).
    MOVE "              2. PAID TRANSACTIONS "                                               TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD137A.
    MOVE "^OPEN TRANSACTIONS FOR VENDOR:]!                                              ] "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^INVOICE        ORDER      EFF-DATE INV-DATE DUE-DATE      GROSS        NET   ] "  TO TLN(3).
*         ............... ........   ../../.. ../../.. ../../..  ..,...:..-  ..,...:..-US
*                                                  !** TOTAL     ..,...:..-  ..,...:..-US]
    MOVE " "                                                                                 TO TLN(4).

RD137B.
    MOVE "^PAID TRANSACTIONS FOR VENDOR:]!                                              ] "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^INVOICE        CHEQUE  CHQ DATE                       INV GROSS     INV NET  ] "  TO TLN(3).
*         ............... ......  ..........                     ..,...:..-  ..,...:..-US
*                                                  !** TOTAL     ..,...:..-  ..,...:..-US]
    MOVE " "                                                                                 TO TLN(4).

RD138.
    MOVE "^INVOICE FILE MAINTENANCE ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VENDOR] ____   !INVOICE NO.] _______________       !DIRECT PAY ?] _ "             TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD139.
    MOVE "^READ DRAWINGS INPUT FILE ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DRAWINGS INPUT FILE (FOR DISPLAY) ] __________ "                                  TO TLN(3).
    MOVE "                    !(FOR PRINTING)] __________ "                                  TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PASSWORD:] "                                                                      TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD140.
    MOVE "^MAINTENANCE BINS ]                          !TOTAL QTY IN MAINTENANCE]: "         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^BIN     PART NO.       QTY     DATE ] "                                           TO TLN(3).
*         ......  ............ ..,...-  ../../..
    MOVE " "                                                                                 TO TLN(4).

RD141.
    MOVE "^VENDOR NAMES ] "                                                                                                                      TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!VENDOR NAME] _________________________ "                                                                                              TO TLNW(3).
*         ......  ................................      ......  ................................      ......  ................................
    MOVE "?? "                                                                                                                                   TO TLNW(4).

RD142.
    MOVE "^PURCHASE ORDER NO.]                !HOLD]      !STATUS]      !ORDER DATE]             !DATE REQD]              !TOTAL] "              TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!VENDOR]                                                !SHIP TO]                          !VIA] "                                     TO TLNW(3).
    MOVE "!F.O.B.]                     !TERMS]                  !US$]      !PST]       !STD TEXT] "                                              TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE "^   QTY ORD          QTY REC    RCVD    PART NO.      DESCRIPTION                           PRICE       DISCOUNT      VALUE ] "        TO TLNW(6).
*         ...,...,...-....  ..,...,...- ../../..  ............  ................................ ...,...:... .... ........ ....,...:..
    MOVE " "                                                                                                                                     TO TLNW(7).

RD143.
    MOVE "^TOOL LIST  ]       !PRODUCT:             ]   !MACHINE:                                   ] NEXT PRODUCT: ____________  MACHINE: __ "  TO TLNW(1).
    MOVE "!PAGE   OF  ]                !                                ]       !M.O.:      ]         OR NEXT M.O.: ______ "                     TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^TOOLS REQUIRED       TOOL M #     TOOL DWG #     LOCTN  IN STK]     ^TOOLS REQUIRED       TOOL M #     TOOL DWG #     LOCTN  IN STK"  TO TLNW(4).
*         ....................  ............ .............. ...... .... .      ....................  ............ .............. ...... .... .
    MOVE "?? "                                                                                                                                   TO TLNW(5).

RD144.
    MOVE "^TOOLS SHORT ]      !PRODUCT:             ]   !MACHINE:                                   ] NEXT PRODUCT: ____________  MACHINE: __ "  TO TLNW(1).
    MOVE "!PAGE   OF  ]                !                                ]       !M.O.:      ]         OR NEXT M.O.: ______ "                     TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^TOOLS REQUIRED       TOOL M #     TOOL DWG #       ON HAND DEM/ROP  ORDER    QTY  REQUIRED  VENDOR                                ]"  TO TLNW(4).
*         ....................  ............ ..............  .......-.......-  ........ ...  ../../..  .... ..................................
*                                            ........................
    MOVE "?? "                                                                                                                                   TO TLNW(5).

RD145.
    MOVE "^TOOLS FOR DRAWING:] "                                                                                                                 TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^TOOL         ALTERNATE       DRAWING               DESCRIPTION                       ON HAND  ON ORDER   DEMAND  LIFE   ROP   EOQ ]"  TO TLNW(3).
*         ............  ..............  ....................  ................................ ...,...-  ...,...-  ..,...-  ....  ....  ....
    MOVE " "                                                                                                                                     TO TLNW(4).

RD146.
    MOVE "^TOOL LISTS DIFFERENCE ]  !FIRST M.O.] ______    !SECOND M.O.] ______     !PRODUCTS:                                               ]"  TO TLNW(1).
    MOVE "!PAGE   OF  ]       !MACHINE   ]                                          !                                                        ]"  TO TLNW(2).
    MOVE "                    !          ] "                                                                                                     TO TLNW(3).
    MOVE "^TOOLS REQUIRED       TOOL M #     TOOL DWG #     LOCTN  IN STK]     ^TOOLS REQUIRED       TOOL M #     TOOL DWG #     LOCTN  IN STK"  TO TLNW(4).
*         ....................  ............ .............. ...... .... .      ....................  ............ .............. ...... .... .
    MOVE "?? "                                                                                                                                   TO TLNW(5).

RD147.
    MOVE "^INVENTORY REPORT ] (ALSO EXPORT FILE) "                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE ONLY DEAD STOCK ?] ___  ^OR]  !INCLUDE ONLY R.O.P. EXCEPTIONS ?] ___ "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!SORT BY R.O.P. ?] ___  ^OR]  !SORT BY CUSTOMER ?] ___ "                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!INCLUDE ONLY PARTS BELOW SAFETY LEVEL ?] ___ "                                    TO TLN(7).
    MOVE "!INCLUDE ONLY NEW PARTS ?] ___ "                                                   TO TLN(8).
    MOVE "!INCLUDE INACTIVE PARTS ?] ___ "                                                   TO TLN(9).
    MOVE "!EXCLUDE ALTERNATES ?] ___ "                                                       TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!FROM CATEGORY] __       !TO CATEGORY] __ "                                        TO TLN(12).
    MOVE "!FROM CUSTOMER] ______   !TO CUSTOMER] ______ "                                    TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!INCLUDE INVENTORY SUMMARY ANALYSIS ?] ___ "                                       TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(17).
    MOVE "?? "                                                                               TO TLN(18).

RD148.
    MOVE "^QUARANTINE/RELEASE BINS ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________      !LOT] _______       !QUARANTINE OR RELEASE] _ "        TO TLN(3).
    MOVE "                                                               !REASON] __ "       TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD149.
    MOVE "^PRODUCT TRANSACTIONS ] !PROD NO.] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ DATE  TRANS FROM  TO          QTY    LOT     M.O.  CTNS  PACKING CONTAINER ] "   TO TLN(3).
*         ../../.. ...  ..... ..... .,...,...- ....... ......  ...-  ..,...   .
    MOVE " "                                                                                 TO TLN(4).

RD150.
    MOVE "^UPDATE BUCKETS ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. UPDATE BUCKETS WITH ZERO WEIGHT "                                               TO TLN(5).
    MOVE "2. UPDATE BUCKETS WITH WEIGHT "                                                    TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD150A.
    MOVE ".................... "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!BUCKET NO.] ____            !M.O.:   ] "                                          TO TLN(3).
    MOVE "!WEIGHT    ] ____            !MACHINE:] "                                          TO TLN(4).
    MOVE "                             !DATE:   ] "                                          TO TLN(5).
    MOVE "                             !SHIFT:  ] "                                          TO TLN(6).
    MOVE "                             !CLOCK:  ] "                                          TO TLN(7).
    MOVE "                             !PRODUCT:] "                                          TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD151.
    MOVE "^EMPTY BUCKETS REPORT ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD152.
    MOVE "^BIN REPORTS ] "                                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. CONTENTS "                                                        TO TLN(3).
    MOVE "              2. PRODUCT LOCATION "                                                TO TLN(4).
    MOVE "              3. SLOW MOVING STOCK (ALSO EXPORT FILE) "                            TO TLN(5).
    MOVE "              4. EMPTY BINS "                                                      TO TLN(6).
    MOVE "              5. PART CARTONS "                                                    TO TLN(7).
    MOVE "              6. BOLTS WITH NUTS "                                                 TO TLN(8).
    MOVE "              7. SPECIAL PACKING "                                                 TO TLN(9).
    MOVE "              8. INVENTORY AGING "                                                 TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD153.
    MOVE "^ACCOUNTS RECEIVABLE REPORTS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. AGE ANALYSIS (ALSO EXPORT FILE) "                                 TO TLN(3).
    MOVE "              2. TRIAL BALANCE "                                                   TO TLN(4).
    MOVE "              3. CREDIT REPORT - SLOW PAYING "                                     TO TLN(5).
    MOVE "              4. CREDIT REPORT - HIGH EXPOSURE "                                   TO TLN(6).
    MOVE "              5. CREDIT REPORT - HIGH 'PAY IN' DAYS "                              TO TLN(7).
    MOVE "              6. CREDIT REPORT - OVER CREDIT LIMIT "                               TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD154.
    MOVE "^INVENTORY REPORTS ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CATEGORY (ALSO EXPORT FILE) "                                  TO TLN(3).
    MOVE "              2. BY MACHINE TYPE "                                                 TO TLN(4).
    MOVE "              3. TOOL SURPLUS "                                                    TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD154A.
    MOVE "^INVENTORY REPORT - BY CATEGORY ]  (ALSO EXPORT FILE) "                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CATEGORY] ___     !TO CATEGORY] ___ "                                        TO TLN(3).
    MOVE "!FULL REPORT (INCLUDING PARTS WITH NO QTY ON HAND) ?] ___ "                        TO TLN(4).
    MOVE "!SHORTAGE REPORT ?] ___ "                                                          TO TLN(5).
    MOVE "    !INCLUDE ONLY PARTS WITH MINIMUM REORDER QTY] ________ "                       TO TLN(6).
    MOVE "!INCLUDE STOCK TRANSACTIONS IN EXPORT FILE ?] ___ "                                TO TLN(7).
    MOVE "!SUMMARY ONLY ?] ___ "                                                             TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD154B.
    MOVE "^INVENTORY REPORT - BY MACHINE TYPE ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACHINE] ____     !TO MACHINE] ____ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!SUMMARY ONLY ?] ___ "                                                             TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD154C.
    MOVE "^INVENTORY REPORT - TOOL SURPLUS ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CATEGORY] ___     !TO CATEGORY] ___ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD155.
    MOVE "^EMPTY BINS REPORT ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM BIN] ______       !TO BIN] ______ "                                          TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD156.
    MOVE "^BIN CONTENTS REPORT ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST BY PART NO.] _      !FROM CATEGORY] ___      !TO CATEGORY] ___     "         TO TLN(3).
    MOVE "!  OR BY BIN NO. ] _      !FROM BIN] ______        !TO BIN] ______ "               TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD157.
    MOVE "^BIN INVALID CONTENTS REPORT ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS REPORT SHOWS THE BIN RECORDS THAT HAVE A QUANTITY BUT NO PART. "              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM BIN] ______       !TO BIN] ______ "                                          TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD159.
    MOVE "^PURCHASE ORDERS DUE REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM VENDOR] ____      !TO VENDOR] ____ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!INCLUDE ORDERS DUE DURING PERIOD:]   !FROM DATE] ______   !TO DATE] ______ "      TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD160.
    MOVE "^PART LOCATION REPORT ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM PART] ____________       !TO PART] ____________ "                            TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!INCLUDE PARTS NOT FOUND IN ANY BIN] ___ "                                         TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD161.
    MOVE "^DELETE OLD ORDERS ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!OLDEST DATE TO KEEP] ______ "                                                     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!ALL ORDERS OLDER THAN THIS DATE AND WITH NO OUTSTANDING LINES WILL BE DELETED] "  TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                                                       !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD162.
    MOVE "^SUBCONTRACTOR PRODUCT RETURNS ] "                                                 TO TLN(1).
    MOVE "                                               !PRODUCT] "                         TO TLN(2).
    MOVE "!SUBCONTRACTOR] ____ "                                                             TO TLN(3).
    MOVE "!LOT](OR M.O.) _______     !M.O. SUFFIX] _ "                                       TO TLN(4).
    MOVE "                           !B/L] _______ "                                         TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PACKING SLIP] __________ "                                                        TO TLN(7).
    MOVE "!WORKSHEET PROCESS] ____ "                                                         TO TLN(8).
    MOVE "!DATE RECEIVED] ______ "                                                           TO TLN(9).
    MOVE "!FINAL RETURN ?] ___ "                                                             TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!BUCKETS AND WEIGHT:] "                                                            TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "^ON HAND ]   ^ORIGINAL]   ^  OUT   ]   ^   IN   ]    ^RETURNED                 ]"  TO TLN(14).
*         ..-..,...-   ..-..,...-   ..-..,...-   ..-..,...-
    MOVE "                                                     !BKTS   WEIGHT    QTY     ]"  TO TLN(15).
    MOVE "                                                       ___   ______   ________ "   TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE " "                                                                                 TO TLN(21).
    MOVE "                                              !'CAN' TO CANCEL TRANSACTION] ___ "  TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD163.
    MOVE "^SHIPMENTS FOR SUBCONTRACTOR                                                  ] "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ M.O.   LOT      PRODUCT    ]  ^ON HAND ]  ^ORIGINAL]  ^  OUT   ]  ^   IN    ] "  TO TLN(3).
*         ......-. .......  ............  ..-..,...-  ..-..,...-  ..-..,...-  ..-..,...-
    MOVE " "                                                                                 TO TLN(4).

RD164.
    MOVE "^SUBCONTRACTOR SHIPMENTS REPORT ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM VENDOR] ____      !TO VENDOR] ____ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD165.
    MOVE "^SUBCONTRACTOR PRODUCT SHIPMENTS ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!NEXT B/L NO.]          !VENDOR NO.] ____ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                        !SHIP VIA] __ "                                            TO TLN(7).
    MOVE "                                               !PRODUCT] "                         TO TLN(8).
    MOVE "!SUBCONTRACTOR] ____ "                                                             TO TLN(9).
    MOVE "!LOT](OR M.O.) _______     !M.O. SUFFIX] _ "                                       TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "^ACCOUNTING:]!OUTBOUND PROCESS] ___ "                                              TO TLN(13).
    MOVE "             !COST] ________   !MODE] _ "                                          TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!B/L NOTE] __________________________________________________ "                    TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!BUCKETS AND WEIGHT:] "                                                            TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "^ON HAND ]   ^ORIGINAL]   ^  OUT   ]   ^   IN   ]       !SHIPPED] "                TO TLN(20).
*         ..-..,...-   ..-..,...-   ..-..,...-   ..-..,...-              ..,...-
    MOVE "                                                         ___ "                     TO TLN(21).
    MOVE " "                                                                                 TO TLN(22).
    MOVE "                                                                       !OK] __ "   TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD166.
    MOVE "^GENERATE SUBCONTRACTOR BILLS OF LADING AND EXPORT DOCUMENTS ] "                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] !FOR BILLS OF LADING ] __ "                                       TO TLN(3).
    MOVE "                 !FOR EXPORT DOCUMENTS] __ "                                       TO TLN(4).
    MOVE "                 !FOR DUMMY PURCHASE ORDERS] __ "                                  TO TLN(5).
    MOVE "                                                                       !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD167.
    MOVE "^SUBCONTRACTOR RECORD ] "                                                          TO TLN(1).
    MOVE "                                               !PRODUCT] ____________ "            TO TLN(2).
    MOVE "!SUBCONTRACTOR] ____ "                                                             TO TLN(3).
    MOVE "!LOT](OR M.O.) _______     !M.O. SUFFIX] _ "                                       TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "           ^BUCKETS   WEIGHT ] "                                                   TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!ORIGINAL]    ____    ________ "                                                   TO TLN(9).
    MOVE "!IN      ]    ____    ________ "                                                   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD168.
    MOVE "^CREATE SHIPPING LABELS ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. AMERICAN AXLE  ('LAB05.PRN') "                                                  TO TLN(5).
    MOVE "2. ALL OTHERS     ('LAB04.PRN') "                                                  TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD169.
    MOVE "^CREATE G/L EXPORT FILE ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __      !US$ RUN] _ "                                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. ACCOUNTS PAYABLE "                                                              TO TLN(5).
    MOVE "2. ACCOUNTS PAYABLE ACCRUAL "                                                      TO TLN(6).
    MOVE "3. PAYROLL 30 (IRVINE FASTENERS HRLY) "                                            TO TLN(7).
    MOVE "4. PAYROLL 35 (IRVINE FASTENERS SAL) "                                             TO TLN(8).
    MOVE "5. PAYROLL 40 (IRVINE NUTS HRLY) "                                                 TO TLN(9).
    MOVE "6. PAYROLL 45 (IRVINE NUTS SAL) "                                                  TO TLN(10).
    MOVE "7. PAYROLL 50 (IRVINE TOOLS) "                                                     TO TLN(11).
    MOVE "8. ACCOUNTS RECEIVABLE "                                                           TO TLN(12).
    MOVE "9. TOOL COST "                                                                     TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD169A.
    MOVE "^CREATE G/L EXPORT FILE ]         ......................... "                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!G/L ENTRY DATE] ______ "                                                          TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!EFFECTIVE DATE] ______      !BATCH NO.] ____ "                                    TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!YEAR:]      !PERIOD:]      !ENTITY:]        !JOURNAL:]        !LEDGER:] "         TO TLN(7).
    MOVE "!OUTPUT FILE:] "                                                                   TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD170.
    MOVE "^GENERATE DUMMY INVOICES ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. MANUAL INVOICES "                                                 TO TLN(3).
    MOVE "              2. AUTOMATIC SUBCONTRACTOR INVOICES "                                TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD171.
    MOVE "^PRINT TOOL LIST FORMS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT TYPE OF FORM] __ "                                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "   1. TOOL LIST FOR ONE PRODUCT-MACHINE COMBINATION "                              TO TLN(5).
    MOVE "   2. TOOL LISTS FOR ALL THE PRODUCTS FOR ONE MACHINE "                            TO TLN(6).
    MOVE "   3. TOOL LISTS FOR PRODUCTS FROM CURRENT PRODUCTION ORDERS "                     TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " BLANK FORMS: "                                                                    TO TLN(9).
    MOVE "   4. MACHINE TYPE 0 "                                                             TO TLN(10).
    MOVE "   5. MACHINE TYPE 7                    6. MACHINE TYPE 8 "                        TO TLN(11).
    MOVE "   7. MACHINE TYPE 9 (MAC. 17,20)       8. MACHINE TYPE 9 (MAC. 18,19) "           TO TLN(12).
    MOVE "   9. MACHINE TYPE 10                  10. MACHINE TYPE 11 "                       TO TLN(13).
    MOVE "  11. MACHINE TYPE 12 (MAC. 24)        12. MACHINE TYPE 12 (MAC. 36,38) "          TO TLN(14).
    MOVE "  13. MACHINE TYPE 12 (MAC. 32,33,34)  14. MACHINE TYPE 12 (MAC. 37) "             TO TLN(15).
    MOVE "  15. MACHINE TYPE 12 (MAC. 39)        16. MACHINE TYPE 18 (MAC. 29,30,31) "       TO TLN(16).
    MOVE "  17. MAC. 54                          18. MAC. 99 "                               TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD172.
    MOVE "^PURCHASE HISTORY REPORTS ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. FOR ONE PART                !PART NO.] ____________ "             TO TLN(3).
    MOVE "              2. FOR RANGE OF VENDORS        !FROM/TO VENDOR NO.] ____ / ____ "    TO TLN(4).
    MOVE "                                             !SUMMARY ONLY ?] ___ "                TO TLN(5).
    MOVE "                                             !INCLUDE VENDOR RANKING ?] ___ "      TO TLN(6).
    MOVE "              3. FOR SELECTED G/L ACCOUNTS   !G/L ACCS.] _____________________ "   TO TLN(7).
    MOVE "                                                         _____________________ "   TO TLN(8).
    MOVE "                                                         _____________________ "   TO TLN(9).
    MOVE "                                                         _____________________ "   TO TLN(10).
    MOVE "                                                         _____________________ "   TO TLN(11).
    MOVE "              4. FOR RAW MATERIALS "                                               TO TLN(12).
    MOVE "              5. FOR PURCHASED FINISHED GOODS - BY VENDOR "                        TO TLN(13).
    MOVE "              6. FOR PURCHASED FINISHED GOODS - BY INVOICE "                       TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "!SELECT RANGE:] !EFFECTIVE DATE]   !FROM DATE] ______    !TO DATE] ______ "        TO TLN(17).
    MOVE "                OR!INVOICE DATE]               ______              ______ "        TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD173.
    MOVE "^PURCHASING DISTRIBUTION REPORT ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!A/P EFFECTIVE DATE] ______ "                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!SELECT G/L ACCOUNTS STARTING WITH:]  (OR NONE FOR FULL REPORT) "                  TO TLN(5).
    MOVE "      ______ ______ ______ ______ ______ ______ ______ ______ ______ ______ "      TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD174.
    MOVE "^A/P JOURNAL ] "                                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^SELECT INVOICES BY:] "                                                            TO TLN(3).
    MOVE "   !A/P EFFECTIVE DATE] ______   ^OR]  !CREATION DATE] ______ "                    TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD175.
    MOVE "^CASH REQUIREMENTS SUMMARY REPORT ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD176.
    MOVE "^PRODUCT LISTING BY PACKING CODE ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD177.
    MOVE "^PRODUCTION ORDERS REPORTS ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY ORDERS "                                                       TO TLN(3).
    MOVE "              2. BY PRODUCT "                                                      TO TLN(4).
    MOVE "              3. BY START DATE "                                                   TO TLN(5).
    MOVE "              4. PAST DUE "                                                        TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD178.
    MOVE "^SALES HISTORY REPORTS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CUSTOMER / PRODUCT (ALSO EXPORT FILE) "                        TO TLN(3).
    MOVE "              2. BY PRODUCT / CUSTOMER (ALSO EXPORT FILE) "                        TO TLN(4).
    MOVE "              3. BY CUSTOMER / INVOICE "                                           TO TLN(5).
    MOVE "              4. PRODUCT RANKING BY WEIGHT "                                       TO TLN(6).
    MOVE "              5. PRODUCT COSTING DATA (ONLY EXPORT FILE) "                         TO TLN(7).
    MOVE "              6. NEW PRODUCT TRACKING (ONLY EXPORT FILE) "                         TO TLN(8).
    MOVE "              7. BY INVOICE (ALSO EXPORT FILE) "                                   TO TLN(9).
    MOVE "              8. BY DATE (ONLY EXPORT FILE) "                                      TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD179.
    MOVE "^TRANSACTION FILE MAINTENANCE ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUSTOMER NO.] ______ "                                                            TO TLN(3).
    MOVE "!INVOICE NO. ] ______ "                                                            TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD179A. MOVE 6 TO TSTART.
    MOVE "!DATE] ______ "                                                                    TO TLN(6).
    MOVE "!AMOUNT] ___________ "                                                             TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!BILL OF LADING NO.] _______ "                                                     TO TLN(9).
    MOVE "!ORDER NO.] ______ "                                                               TO TLN(10).
    MOVE "!CUST ORDER NO.] _________ "                                                       TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD180.
    MOVE "^PRODUCT DESCRIPTIONS LISTING ] (ONLY EXPORT FILE) "                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE ONLY PRODUCTS MADE SINCE] ______ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD181.
    MOVE "^MAINTENANCE MASTER ]    !MACHINE-SECTION-LEVEL] ___ __ __       ^FUNCTION] ___ "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!EST DOWNTIME HRS] ___                                      A: ADD  C: CHANGE "    TO TLN(3).
    MOVE "                                                            DEL: DELETE "          TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!NOTES] ______________________________________________________________________ "   TO TLN(6).
    MOVE "        ______________________________________________________________________ "   TO TLN(7).
    MOVE "        ______________________________________________________________________ "   TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "^LABOUR ]   !PROCESS-HOURS] "                                                      TO TLN(10).
    MOVE "___ _____     ___ _____     ___ _____     ___ _____     ___ _____     ___ _____ "  TO TLN(11).
    MOVE "___ _____     ___ _____     ___ _____     ___ _____     ___ _____     ___ _____ "  TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "^PARTS  ]   !PART-QTY] "                                                           TO TLN(14).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(15).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(16).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(17).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(18).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(19).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(20).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(21).
    MOVE "____________ ____         ____________ ____         ____________ ____ "            TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD182.
    MOVE "^MAINTENANCE ORDER ]    !ORDER NO.] ______                       ^FUNCTION] ___ "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!TYPE P/E] _     !DATE] ______       !PRIORITY] _           A: ADD  C: CHANGE "    TO TLN(3).
    MOVE "!MACHINE-SECTION-LEVEL] ___  __ __   !DEPT-SECT] __ __      DEL: DELETE "          TO TLN(4).
    MOVE "          !DESCRIPTION] ______________________________      L: LABOUR  P: PARTS "  TO TLN(5).
    MOVE "                        ______________________________ "                           TO TLN(6).
    MOVE "!STATUS] _                             !DOWN DATE/TIME] ______  __:__ "            TO TLN(7).
    MOVE "!NOTES] ______________________________________________________________________ "   TO TLN(8).
    MOVE "        ______________________________________________________________________ "   TO TLN(9).
    MOVE "        ______________________________________________________________________ "   TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "^LABOUR  ]!PROCESS] ___                                          ^FUNCTION] ___ "  TO TLN(13).
    MOVE "         |!DATE] ______   !SHIFT](D/A/N) _                          (A, DEL) "     TO TLN(14).
    MOVE "         |!CLOCK] ____ "                                                           TO TLN(15).
    MOVE "          !HOURS] _____ "                                                          TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "^PARTS   ]!PART] ____________                                    ^FUNCTION] ___ "  TO TLN(19).
    MOVE "         |!DATE] ______                                             (A, C, DEL) "  TO TLN(20).
    MOVE "         |!CLOCK] ____ "                                                           TO TLN(21).
    MOVE "          !QTY] ____ "                                                             TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD183.
    MOVE "^MAINTENANCE ORDER]              !MACHINE]                 !PRTY] "                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!STATUS] "                                                                         TO TLN(3).
    MOVE "!DOWN] "                                                                           TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).

RD184.
    MOVE "^EMERGENCY MAINTENANCE ORDER ]    !ORDER NO.] "                                    TO TLN(1).
    MOVE "                                         !MECHANICAL/ELECTRICAL (M/E)] _ "         TO TLN(2).
    MOVE "!DATE] ______     !PRIORITY] _ "                                                   TO TLN(3).
    MOVE "!MACHINE-SECTION-LEVEL] ____ __ __ "                                               TO TLN(4).
    MOVE "          !DESCRIPTION] ______________________________ "                           TO TLN(5).
    MOVE "                        ______________________________ "                           TO TLN(6).
    MOVE "                                       !DOWN DATE/TIME] ______  __:__ "            TO TLN(7).
    MOVE "!NOTES] ______________________________________________________________________ "   TO TLN(8).
    MOVE "        ______________________________________________________________________ "   TO TLN(9).
    MOVE "        ______________________________________________________________________ "   TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "                                                           !'OK' TO ACCEPT] __ "   TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD185.
    MOVE "^PRINT MAINTENANCE ORDER ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ORDER NO.] ______ "                                                               TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD186.
    MOVE "^ALTERNATE TOOLS ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ALTERNATE TOOL NO.] ____ ____ ____ "                                              TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD187.
    MOVE "^ASSEMBLY INFORMATION ]  !ASSY:             ]           NEXT ASSY: ____________ "  TO TLN(1).
    MOVE "                               !                                ] "                TO TLN(2).
    MOVE "!NOTES:] "                                                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "^TOOL                 TOOL M #     TOOL DWG #     LOCTN  IN STK  ON ORD  P.O.  ]"  TO TLN(6).
*         ....................  ............ .............. ...... .... .   ....  ........
    MOVE "?? "                                                                               TO TLN(7).

RD188.
    MOVE "^ASSEMBLY NOTES ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ASSY] ____________ "                                                              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "  !NOTES] "                                                                        TO TLN(6).
    MOVE "   ______________________________________________________________________ "        TO TLN(7).
    MOVE "   ______________________________________________________________________ "        TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD189.
    MOVE "^NON-PRODUCTION MACHINES FILE MAINTENANCE ]                  ^FUNCTION] _ "        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!MACHINE NO.] M___      !DEPT-SECT] __ __                    1. ADD RECORD "       TO TLN(3).
    MOVE "                                                             2. CHANGE RECORD "    TO TLN(4).
    MOVE "                                                             3. DELETE RECORD "    TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!DESCRIPTION] ______________________________ "                                     TO TLN(7).
    MOVE "              ______________________________ "                                     TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD190.
    MOVE "^PRODUCT DATA LISTING ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM PRODUCT] ____________     !TO PRODUCT] ____________ "                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD191.
    MOVE "^MAINTENANCE ORDERS ] "                                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ORDER TYPE STATUS  MACHINE     ISSUER         DATE   TIME   PRIORITY       ] "    TO TLN(3).
*         ......  .   ......  .... .. ..  ............ ../../.. .....  .............
*                ......................................................................
    MOVE " "                                                                                 TO TLN(4).

RD192.
    MOVE "^COUNT PURCHASE ORDERS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SHOW NUMBER OF PURCHASE ORDERS:]       !FROM DATE] ______    !TO DATE] ______ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD193.
    MOVE "^PRODUCT COST VARIANCE REPORTS ] (ALSO EXPORT FILE) "                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THESE REPORTS LIST PRODUCTS WITH VARIANCE BETWEEN TWO COSTING MODES "              TO TLN(3).
    MOVE "  GREATER THAN THE SPECIFIED PERCENTAGE "                                          TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!REPORTS] "                                                                        TO TLN(6).
    MOVE " 1. MFG COST: ACTUAL - NORMALIZED (MODE 4 - 3) "                                   TO TLN(7).
    MOVE " 2. TOOLING COST: ACTUAL - REGULAR (MODE 4 - 1) "                                  TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!REPORT] _     !MINIMUM VARIANCE %] ___ "                                          TO TLN(11).
    MOVE "               !FROM PRODUCT] ____________     !TO PRODUCT] ____________ "         TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(14).
    MOVE "?? "                                                                               TO TLN(15).

RD194.
    MOVE "^MAINTENANCE SUMMARY HOURS REPORT ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!YEAR](0-99) __    !MONTH](1-12) __ "                                              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD195.
    MOVE "^MAINTENANCE ORDER COMMENTS]     !ORDER NO.] ______             !DATE] "           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!MACHINE] "                                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!NOTES] ______________________________________________________________________ "   TO TLN(7).
    MOVE "        ______________________________________________________________________ "   TO TLN(8).
    MOVE "        ______________________________________________________________________ "   TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!COMMENTS] "                                                                       TO TLN(11).
    MOVE "        ______________________________________________________________________ "   TO TLN(12).
    MOVE "        ______________________________________________________________________ "   TO TLN(13).
    MOVE "        ______________________________________________________________________ "   TO TLN(14).
    MOVE "        ______________________________________________________________________ "   TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD196.
    MOVE "^MAINTENANCE DETAILED HISTORY REPORT ] "                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!MACHINE] ____ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD197.
    MOVE "^SALESMAN TABLE MAINTENANCE ]                                ^FUNCTION] _ "        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SALESMAN NO.] __                                            1. ADD RECORD "       TO TLN(3).
    MOVE "                                                             2. CHANGE RECORD "    TO TLN(4).
    MOVE "!NAME] ______________________________                        3. DELETE RECORD "    TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!COMMISSION RATE] _____ "                                                          TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD198.
    MOVE "^PHYSICAL SPECS MAINTENANCE ] "                                                                                                        TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!PRODUCT] ____________ "                                                                                                               TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^CHARACTERISTIC                       MIN       MAX      UNIT]        ^CHARACTERISTIC                       MIN       MAX      UNIT]"  TO TLNW(5).
*         ... ...............................  ..:....   ..:....   .....        ... ...............................  ..:....   ..:....   .....
    MOVE "?? "                                                                                                                                   TO TLNW(6).

RD198A. MOVE 21 TO TSTART.
    MOVE "^CHARACTERISTIC                       MIN       MAX      UNIT]     !FUNCTION] _  1. ADD CHARACTERISTIC       4. COPY CHARACTERISTICS"  TO TLNW(21).
    MOVE "___                                  _______   _______                           2. CHANGE MIN/MAX VALUES "                            TO TLNW(22).
    MOVE "                                                                                 3. DELETE CHARACTERISTIC "                            TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD199.
    MOVE "^CHARACTERISTICS LISTING ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION LISTS THE FOLLOWING TABLES: "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "- PHYSICAL CHARACTERISTICS "                                                       TO TLN(5).
    MOVE "- HEAT TREATMENT CHARACTERISTICS "                                                 TO TLN(6).
    MOVE "- MECHANICAL CHARACTERISTICS "                                                     TO TLN(7).
    MOVE "- INSTRUMENT CODES "                                                               TO TLN(8).
    MOVE "- UNITS OF MEASURE "                                                               TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD200.
    MOVE "^SUBCONTRACTOR PRODUCT RETURNS ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VENDOR NO.] ____ "                                                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!SUBCONTRACTOR] ____                  !PRODUCT] ____________ "                     TO TLN(5).
    MOVE "!PACKING SLIP] __________ "                                                        TO TLN(6).
    MOVE "!INVOICE DATE] ______ "                                                            TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "    !WEIGHT] ______   OR   !QTY] ________ "                                        TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "                                              !'CAN' TO CANCEL TRANSACTION] ___ "  TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD201.
    MOVE "^MACHINE TIME ANALYSIS ] (ALSO EXPORT FILE) "                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACHINE] ____    !TO MACHINE] ____ "                                         TO TLN(3).
    MOVE "!FROM M.O.] ______     !TO M.O.] ______ "                                          TO TLN(4).
    MOVE "!FROM DATE] ______     !TO DATE] ______ "                                          TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD202.
    MOVE "^MAINTENANCE OPEN/WIP ORDERS REPORT ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACHINE] ____     !TO MACHINE] ____ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD203.
    MOVE "^MAINTENANCE HISTORY REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!ORDER TYPE] _     P: PREVENTIVE ORDERS ONLY "                                     TO TLN(5).
    MOVE "                   E: EMERGENCY ORDERS ONLY "                                      TO TLN(6).
    MOVE "                   A: ALL ORDERS "                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD204.
    MOVE "^HEAT TREATMENT SPECS MAINTENANCE ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^CHARACTERISTIC                    MIN     MAX   UNIT        INSTRUMENT        ]"  TO TLN(5).
*         .. ............................ ....... .......  ..........  ...................
    MOVE "?? "                                                                               TO TLN(6).

RD205.
    MOVE "^HEAT TREATMENT SPECS ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^CHARACTERISTIC                    MIN     MAX   UNIT        INSTRUMENT        ]"  TO TLN(5).
*         .. ............................ ....... .......  ..........  ...................
    MOVE "?? "                                                                               TO TLN(6).

RD206.
    MOVE "^CREATE SHIPPING LABELS ]  ('LAB04.PRN') "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUSTOMER] ______ "                                                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT] ____________      !PACKING QTY] _____      !LOT NO.] _______ "           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!NUMBER OF LABELS] ____     !SHIPMENT DATE] ______ "                               TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "^GM LABEL DATA:        ]                               !KANBAN NOS.] __________ "  TO TLN(9).
    MOVE "                                                                     __________ "  TO TLN(10).
    MOVE "  !PKG 11Z (DLOC)]      ________                                     __________ "  TO TLN(11).
    MOVE "  !PKG 12Z (PLANT/DOCK)]________                                     __________ "  TO TLN(12).
    MOVE "  !PKG 13Z]             _________________________                    __________ "  TO TLN(13).
    MOVE "  !PKG 14Z]             ____________________ "                                     TO TLN(14).
    MOVE "  !PKG 15Z]             ____________________ "                                     TO TLN(15).
    MOVE "  !PKG 16Z]             ________________________ "                                 TO TLN(16).
    MOVE "  !PKG 17Z]             __________ "                                               TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "!BLANKET ORDER NO.] ______ "                                                       TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "!CUSTOMER ORDER] _________ "                                                       TO TLN(21).
    MOVE "                                                                       !OK] __ "   TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD207.
    MOVE "^AMERICAN AXLE SHIPPING LABELS ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ORDER NO.] ______ "                                                               TO TLN(3).
    MOVE "                          !PROD] "                                                 TO TLN(4).
    MOVE "!PLANT/DOCK] ________     !GROUP/DEPT] ________ "                                  TO TLN(5).
    MOVE "!PULL SIGNALS:] "                                                                  TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD207A. MOVE 12 TO TSTART.
    MOVE "^PALLET LABELS] "                                                                  TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "!PULL SIGNAL] ________   !CARTONS] "                                               TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!CUST ORDER ID.] _________          !SERIAL NOS.:] !MASTER ] "                     TO TLN(16).
    MOVE "                                                   !CARTONS] "                     TO TLN(17).
    MOVE "!LOT] _______  !CTNS] __ "                                                         TO TLN(18).
    MOVE "      _______         __ "                                                         TO TLN(19).
    MOVE "      _______         __           !CREATE LABELS FOR THIS PULL ?] ___ "           TO TLN(20).
    MOVE "      _______         __                             ('LAB05.PRN') "               TO TLN(21).
    MOVE "      _______         __           !LABEL SERIAL NO.] ________ "                   TO TLN(22).
    MOVE "?? "                                                                               TO TLN(23).

RD208.
    MOVE "^PRINT PCC & DRAWING ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O. NO.] ______ "                                                                TO TLN(3).
    MOVE "           ______ "                                                                TO TLN(4).
    MOVE "           ______ "                                                                TO TLN(5).
    MOVE "           ______ "                                                                TO TLN(6).
    MOVE "           ______ "                                                                TO TLN(7).
    MOVE "           ______ "                                                                TO TLN(8).
    MOVE "           ______ "                                                                TO TLN(9).
    MOVE "           ______ "                                                                TO TLN(10).
    MOVE "           ______ "                                                                TO TLN(11).
    MOVE "           ______ "                                                                TO TLN(12).
    MOVE "                                                                       !OK] __ "   TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD209.
    MOVE "^PRINT INSPECTION PCC & DRAWING ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O. NO.] ______ "                                                                TO TLN(3).
    MOVE "           ______ "                                                                TO TLN(4).
    MOVE "           ______ "                                                                TO TLN(5).
    MOVE "           ______ "                                                                TO TLN(6).
    MOVE "           ______ "                                                                TO TLN(7).
    MOVE "           ______ "                                                                TO TLN(8).
    MOVE "           ______ "                                                                TO TLN(9).
    MOVE "           ______ "                                                                TO TLN(10).
    MOVE "           ______ "                                                                TO TLN(11).
    MOVE "           ______ "                                                                TO TLN(12).
    MOVE "                                                                       !OK] __ "   TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD210.
    MOVE "^MODIFY SAVED QUANTITY LEFT AND PRODUCED ] "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O. NO] ______       !SAVED QTY LEFT    ] __________ "                           TO TLN(3).
    MOVE "                       !SAVED QTY PRODUCED] __________ "                           TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD211.
    MOVE "^PRODUCT LISTING BY PLATING SPEC ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM PLATING SPEC] ___        !TO PLATING SPEC] ___ "                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD212.
    MOVE "^HEAT FILE MAINTENANCE ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^HEAT NO.] __________       ^FUNCTION] _        ^FUNCTIONS               ] "       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                1. ADD RECORD "                    TO TLN(5).
    MOVE "                                                2. DISPLAY / CHANGE RECORD "       TO TLN(6).
    MOVE "                                                3. DELETE RECORD "                 TO TLN(7).
    MOVE "                                                9. END "                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD213.
    MOVE "^ADD HEAT RECORD ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^HEAT NO.] "                                                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!GRADE] ________     !DI VALUE] ____ "                                             TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!.............] ____ "                                                             TO TLN(7).
    MOVE "!.............] ____ "                                                             TO TLN(8).
    MOVE "!.............] ____ "                                                             TO TLN(9).
    MOVE "!.............] ____ "                                                             TO TLN(10).
    MOVE "!.............] ____ "                                                             TO TLN(11).
    MOVE "!.............] ____ "                                                             TO TLN(12).
    MOVE "!.............] ____ "                                                             TO TLN(13).
    MOVE "!.............] ____ "                                                             TO TLN(14).
    MOVE "!.............] ____ "                                                             TO TLN(15).
    MOVE "!.............] ____ "                                                             TO TLN(16).
    MOVE "!.............] ____ "                                                             TO TLN(17).
    MOVE "!.............] _____ "                                                            TO TLN(18).
    MOVE "!.............] ____ "                                                             TO TLN(19).
    MOVE "!.............] ____ "                                                             TO TLN(20).
    MOVE "!.............] _____ "                                                            TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD214.
    MOVE "^HEAT RECORD ] "                                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^HEAT NO.] "                                                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. C  CARBON        2. MN MANGANESE     3. P  PHOSPHORUS    4. S  SULPHUR "       TO TLN(5).
    MOVE " 5. SI SILICON       6. CU COPPER        7. NI NICKEL        8. CR CHROMIUM "      TO TLN(6).
    MOVE " 9. MO MOLYBDENUM   10. SN TIN          11. AL ALUMINUM     12. B  BORON "         TO TLN(7).
    MOVE "13. V  VANADIUM     14. CO COBALT       15. N  NITROGEN     16. (NOT USED) "       TO TLN(8).
    MOVE "17. GRADE           18. DI VALUE "                                                 TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD214A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD215.
    MOVE "^HEAT RECORD ]     !HEAT NO.           ]     !DATE] "                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^GRADE]            ^DI VALUE] "                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^.............] "                                                                  TO TLN(5).
    MOVE "^.............] "                                                                  TO TLN(6).
    MOVE "^.............] "                                                                  TO TLN(7).
    MOVE "^.............] "                                                                  TO TLN(8).
    MOVE "^.............] "                                                                  TO TLN(9).
    MOVE "^.............] "                                                                  TO TLN(10).
    MOVE "^.............] "                                                                  TO TLN(11).
    MOVE "^.............] "                                                                  TO TLN(12).
    MOVE "^.............] "                                                                  TO TLN(13).
    MOVE "^.............] "                                                                  TO TLN(14).
    MOVE "^.............] "                                                                  TO TLN(15).
    MOVE "^.............] "                                                                  TO TLN(16).
    MOVE "^.............] "                                                                  TO TLN(17).
    MOVE "^.............] "                                                                  TO TLN(18).
    MOVE "^.............] "                                                                  TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "                                        NEXT HEAT NO. __________ "                 TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD216.
    MOVE "^LOT FILE MAINTENANCE ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^LOT NO.] _______           ^FUNCTION] _        ^FUNCTIONS               ] "       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                1. ADD RECORD "                    TO TLN(5).
    MOVE "                                                2. DISPLAY / CHANGE RECORD "       TO TLN(6).
    MOVE "                                                3. DELETE RECORD "                 TO TLN(7).
    MOVE "                                                9. END "                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD217.
    MOVE "^ADD LOT RECORD ]      !LOT NO.        ]          !SAME AS LOT NO.] _______ "      TO TLN(1).
    MOVE "                                                  !REWORKED/RESORTED LOT ?] ___ "  TO TLN(2).
    MOVE "!CLOCK] ____                         !PROD NO.] ____________ "                     TO TLN(3).
    MOVE "!M.O.] ______-_    !SPEC] ____________________ "                                   TO TLN(4).
    MOVE "!HEAT] __________    !CTRY ORIG] __ "                                              TO TLN(5).
    MOVE "!FINISH] _______________    !BUCKETS] ____ "                                       TO TLN(6).
    MOVE "!QTY] __________    !WEIGHT] __________ "                                          TO TLN(7).
    MOVE "!NOTES] __________________________________________________ "                       TO TLN(8).
    MOVE "                                                      !EXTERNAL LOT] __________ "  TO TLN(9).
    MOVE "!......................] ____________________ _____ "                              TO TLN(10).
    MOVE "!......................] __________ _____ "                                        TO TLN(11).
    MOVE "!......................] __________ _____ "                                        TO TLN(12).
    MOVE "!......................] __________ _____ "                                        TO TLN(13).
    MOVE "!......................] ____________________ _____ "                              TO TLN(14).
    MOVE "!......................] ___________________________________ _____ "               TO TLN(15).
    MOVE "!......................] __________ _____ "                                        TO TLN(16).
    MOVE "!......................] __________ _____ "                                        TO TLN(17).
    MOVE "!......................] __________ _____ "                                        TO TLN(18).
    MOVE "!......................] __________ _____ "                                        TO TLN(19).
    MOVE "!......................] __________ _____ "                                        TO TLN(20).
    MOVE "!......................] __________ _____ "                                        TO TLN(21).
    MOVE "!......................] __________ _____ "                                        TO TLN(22).
    MOVE "!......................] __________ _____ "                                        TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD218.
    MOVE "^LOT RECORD ] "                                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^LOT NO.] "                                                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. EMPL CLOCK       2. PRODUCT NO.      3. M.O. NO.         4. M.O. SUFFIX "      TO TLN(5).
    MOVE " 5. HEAT             6. FINISH           7. QUANTITY         8. WEIGHT "           TO TLN(6).
    MOVE " 9. HARDNESS        10. HARDN AFTER 24H 11. SURF HARDNESS   12. PROOF LOAD "       TO TLN(7).
    MOVE "13. WEDGE TENS STR  14. ULTIM TENS STR  15. YIELD STRENGTH  16. ELONGATION "       TO TLN(8).
    MOVE "17. REDUCTN OF AREA 18. DECARB CLASS    19. CASE DEPTH      20. PLATING THKNS "    TO TLN(9).
    MOVE "21. SALT SPRAY HRS  22. TEMPERING TEMP  23. NOTES           24. SPECIFICATION "    TO TLN(10).
    MOVE "25. CNTRY OF ORIGIN 26. NUM OF BUCKETS  27. EXTERNAL LOT "                         TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD218A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD219.
    MOVE "^LOT RECORD ]     !LOT NO.        ]  ^PROD NO.] "                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CLOCK] "                                                                          TO TLN(3).
    MOVE "^M.O.]            ^SPEC] "                                                         TO TLN(4).
    MOVE "^HEAT]               ^GRADE] "                                                     TO TLN(5).
    MOVE "^FINISH]                     ^CTRY ORIG] "                                         TO TLN(6).
    MOVE "^QTY]              ^WEIGHT]             ^BUCKETS] "                                TO TLN(7).
    MOVE "^NOTES] "                                                                          TO TLN(8).
    MOVE "                                                ^EXTERNAL LOT] "                   TO TLN(9).
    MOVE "^......................] "                                                         TO TLN(10).
    MOVE "^......................] "                                                         TO TLN(11).
    MOVE "^......................] "                                                         TO TLN(12).
    MOVE "^......................] "                                                         TO TLN(13).
    MOVE "^......................] "                                                         TO TLN(14).
    MOVE "^......................] "                                                         TO TLN(15).
    MOVE "^......................] "                                                         TO TLN(16).
    MOVE "^......................] "                                                         TO TLN(17).
    MOVE "^......................] "                                                         TO TLN(18).
    MOVE "^......................] "                                                         TO TLN(19).
    MOVE "^......................] "                                                         TO TLN(20).
    MOVE "^......................] "                                                         TO TLN(21).
    MOVE "^......................] "                                                         TO TLN(22).
    MOVE "^......................]                                NEXT LOT NO. _______ "     TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD220.
    MOVE "^SHIPPING LABEL ENTRY ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LOT NO.] _______      !PRODUCT] ____________      !PACKING QTY] _____ "           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!NUMBER OF LABELS] ___ "                                                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!MFG DATE] ______      !CUST. ORDER] _________ "                                   TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "^ DATE     TIME   TYPE  QTY  PRODUCT     PACK QTY   OPERATOR     PR ] "            TO TLN(10).
*         ../../.. ..:..:..  .    ...  ............ .....     ............ .
    MOVE "?? "                                                                               TO TLN(11).

RD221.
    MOVE "^LABELS INFORMATION ] "                                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ LOT      DATE     TIME   TYPE  QTY  PRODUCT     PK QTY  OPERATOR      PR ] "     TO TLN(3).
*         .......  ../../.. ..:..:..  .    ...  ............ .....  ............  .
    MOVE " "                                                                                 TO TLN(4).

RD222.
    MOVE "^PRODUCT LISTING FOR A WIRE SIZE ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST PRODUCTS WITH WIRE SIZE IN RANGE:]      !FROM] ______      !TO] ______ "     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!LIST PRODUCTS WITH R.O.P. GREATER THAN] _________ "                               TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD223.
    MOVE "^PRODUCT LISTING BY FAMILY ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM FAMILY] __        !TO FAMILY] __ "                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD224.
    MOVE "^SHOW TOOL DRAWING ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DRAWING] ____________ "                                                           TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD225.
    MOVE "^SHOW PRODUCT DRAWING ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

* note 165
RD226. MOVE 6 TO TSTART.
    MOVE "TO VIEW DRAWING: "                                                                 TO TLN(6).
    MOVE "    'UP'/'DOWN' ARROW KEYS TO SCROLL, 'SELECT' TO CHANGE PAGE, 'PF4' TO END. "     TO TLN(7).
    MOVE "    '.' FOLLOWED BY 'UP'/'DOWN' ARROW KEYS TO GO TO TOP/BOTTOM OF DRAWING. "       TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "NOTE: IF USING PC AS TERMINAL, "                                                   TO TLN(14).
    MOVE "      TO ENABLE 'SELECT', THE 'PC' INDICATOR MUST BE SET FOR THIS USER. "          TO TLN(15).
    MOVE "      (SEE G-35 'MODIFY USER DATA') "                                              TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD227.
    MOVE "^THIRD PARTY OPERATIONS VALUATION REPORT ] "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD228.
    MOVE "^PRODUCT MECHANICAL SPECS MAINTENANCE ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^CHARACTERISTIC                  MIN        MAX     UNIT   INSTRUMENT          ]"  TO TLN(5).
*         .. .........................  ....:....  ....:....  .....  .....................
    MOVE "?? "                                                                               TO TLN(6).

RD229.
    MOVE "^PRINT TOOL DRAWINGS ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DRAWINGS] ____________ "                                                          TO TLN(3).
    MOVE "           ____________ "                                                          TO TLN(4).
    MOVE "           ____________ "                                                          TO TLN(5).
    MOVE "           ____________ "                                                          TO TLN(6).
    MOVE "           ____________ "                                                          TO TLN(7).
    MOVE "                                                            !'OK' TO PRINT] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD230.
    MOVE "^PRINT PRODUCT DRAWINGS ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCTS] ____________ "                                                          TO TLN(3).
    MOVE "           ____________ "                                                          TO TLN(4).
    MOVE "           ____________ "                                                          TO TLN(5).
    MOVE "           ____________ "                                                          TO TLN(6).
    MOVE "           ____________ "                                                          TO TLN(7).
    MOVE "                                                            !'OK' TO PRINT] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD231.
    MOVE "^LIST PRODUCTS WITH NO SPECS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECTION CODES:] "                                                               TO TLN(3).
    MOVE "  1. EXCLUDE PRODUCTS WITH NO PRODUCTION OR SALES IN THE LAST 2 YEARS "            TO TLN(4).
    MOVE "  2. EXCLUDE PRODUCTS WITH NO QTY ON HAND, ON ORDER, ON DEMAND, IN PROCESS "       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!CODE] _ "                                                                         TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD232.
    MOVE "^FREIGHT BILL-TO FILE MAINTENANCE ]                          ^FUNCTION] _ "        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUSTOMER] ______    !SHIP-TO] __                            1. ADD RECORD "       TO TLN(3).
    MOVE "                                                             2. CHANGE RECORD "    TO TLN(4).
    MOVE "                                                             3. DELETE RECORD "    TO TLN(5).
    MOVE "!SEND FREIGHT BILL TO:] "                                                          TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " __________________________________________________ "                              TO TLN(8).
    MOVE " __________________________________________________ "                              TO TLN(9).
    MOVE " __________________________________________________ "                              TO TLN(10).
    MOVE " __________________________________________________ "                              TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD233.
    MOVE "^FILE LISTINGS ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. SHIP-TO FILE LISTING "                                            TO TLN(3).
    MOVE "              2. FREIGHT BILL-TO FILE LISTING "                                    TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD234.
    MOVE "^ARCHIVE TOOL LIST MAINTENANCE ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTIONS:]  1. SAVE IN ARCHIVE "                                                 TO TLN(3).
    MOVE "              2. RESTORE FROM ARCHIVE "                                            TO TLN(4).
    MOVE "              3. DELETE IN ARCHIVE "                                               TO TLN(5).
    MOVE "              9. END "                                                             TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!FUNCTION] _     !PRODUCT] ____________     !MACHINE] __     !ARCHIVE ID] _ "      TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!DATE] ______    !NOTES] __________________________________________________ "      TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD235.
    MOVE "^ARCHIVE TOOL LISTS ] "                                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PRODUCT     MAC ID   DATE    NOTES                                            ]"  TO TLN(3).
*         ............ ..  .  ../../..  ..................................................
    MOVE "?? "                                                                               TO TLN(4).

RD236.
    MOVE "^CALCULATE QUOTATION LINE COST ] "                                                                                                     TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "!QUOTATION NO.] ______    !LINE] __ "                                                                                                  TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "                                                                                                             !'OK' TO CONTINUE] __ "   TO TLNW(5).
    MOVE "?? "                                                                                                                                   TO TLNW(6).

RD237.
    MOVE "^QUOTATION ENTRY ]         !QUOTATION NO.] ______    !DATE] ______ "               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUST] ______                          !CONTACT] ______________________________ "  TO TLN(3).
    MOVE "!NAME] ________________________________          ______________________________ "  TO TLN(4).
    MOVE "!ADD1] ________________________________          ______________________________ "  TO TLN(5).
    MOVE "!ADD2] ________________________________ "                                          TO TLN(6).
    MOVE "!POST] __________ "                                                                TO TLN(7).
    MOVE "      !US$] _  !EXCHG] ______ "                                                    TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "^NOTES ] "                                                                         TO TLN(11).
    MOVE " 1. ___________________________________________________________________________ "  TO TLN(12).
    MOVE " 2. ___________________________________________________________________________ "  TO TLN(13).
    MOVE " 3. ___________________________________________________________________________ "  TO TLN(14).
    MOVE " 4. ___________________________________________________________________________ "  TO TLN(15).
    MOVE " 5. ___________________________________________________________________________ "  TO TLN(16).
    MOVE " 6. ___________________________________________________________________________ "  TO TLN(17).
    MOVE " 7. ___________________________________________________________________________ "  TO TLN(18).
    MOVE " 8. ___________________________________________________________________________ "  TO TLN(19).
    MOVE " 9. ___________________________________________________________________________ "  TO TLN(20).
    MOVE "10. ___________________________________________________________________________ "  TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

RD238.
    MOVE "^QUOTATION NO.]         ^LINE] "                                                   TO TLN(1).
    MOVE "                                     !SAME AS: ACTIVE PRODUCT NO.] ____________ "  TO TLN(2).
    MOVE "                                              !OR QUOTATION/LINE ] ______/__ "     TO TLN(3).
    MOVE "!PRODUCT NO. ] ____________ "                                                      TO TLN(4).
    MOVE "!DESCRIPTION ] ________________________________ ^  OPER    COST  MODE  ABBREV  ]"  TO TLN(5).
    MOVE "!EXTD DESCR 1] ________________________________  1. ___  ________  _ "             TO TLN(6).
    MOVE "!EXTD DESCR 2] ________________________________  2. ___  ________  _ "             TO TLN(7).
    MOVE "!FINISH DESCR] ________________________________  3. ___  ________  _ "             TO TLN(8).
    MOVE "!PRINT DESCR ] __________________                4. ___  ________  _ "             TO TLN(9).
    MOVE "                                                 5. ___  ________  _ "             TO TLN(10).
    MOVE "!CATEGORY] __    !FAMILY] __    !PRICE MODE] __  6. ___  ________  _ "             TO TLN(11).
    MOVE "!PRICE 1] ________  !PRICE 2] ________           7. ___  ________  _ "             TO TLN(12).
    MOVE "!COST] ______                                    8. ___  ________  _ "             TO TLN(13).
    MOVE "!MACHINE] __        !HOURLY RATE] ______         9. ___  ________  _ "             TO TLN(14).
    MOVE "!WEIGHT] _______    !GROSS WEIGHT] _______      10. ___  ________  _ "             TO TLN(15).
    MOVE "!DIAMETER] ______   !GRADE] ________            11. ___  ________  _ "             TO TLN(16).
    MOVE "!PROCESS CODE] _    !CLEANING CODE] _           12. ___  ________  _ "             TO TLN(17).
    MOVE "!PACKING CODE] __   !PACKING QTY] _____ "                                          TO TLN(18).
    MOVE "!EST ANNUAL QTY] __________ "                                                      TO TLN(19).
    MOVE "!EST DELIVERY (WEEKS)] __ "                                                        TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD239.
    MOVE "^DAILY MATERIAL REQUIREMENTS REPORT ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD240.
    MOVE "^WEEKLY MATERIAL REQUIREMENTS REPORT ]  (ALSO EXPORT FILE) "                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD241.
    MOVE "^PRODUCT LISTING BY MATERIAL SPEC ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD242.
    MOVE "^DELETE PRODUCT DRAWING ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DRAWING] ________                            !'OK' TO DELETE THIS DRAWING] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD243.
    MOVE "^CALCULATE AND PRINT QUOTATIONS ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM QUOTATION] ______      !TO QUOTATION] ______ "                               TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD244.
    MOVE "^PRINT PRODUCTION TICKETS ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O. NO.] ______       M.O. NO'S REQUIRED ONLY TO PRINT SPECIFIC M.O.'S "         TO TLN(3).
    MOVE "           ______ "                                                                TO TLN(4).
    MOVE "           ______ "                                                                TO TLN(5).
    MOVE "           ______ "                                                                TO TLN(6).
    MOVE "           ______ "                                                                TO TLN(7).
    MOVE "           ______ "                                                                TO TLN(8).
    MOVE "           ______ "                                                                TO TLN(9).
    MOVE "           ______ "                                                                TO TLN(10).
    MOVE "           ______ "                                                                TO TLN(11).
    MOVE "           ______ "                                                                TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "                                                                       !OK] __ "   TO TLN(14).
    MOVE "?? "                                                                               TO TLN(15).

RD245.
    MOVE "^SOLD-TO FILE MAINTENANCE ]                                  ^FUNCTION] _ "        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUSTOMER] ______                                            1. ADD RECORD "       TO TLN(3).
    MOVE "                                                             2. CHANGE RECORD "    TO TLN(4).
    MOVE "                                                             3. DELETE RECORD "    TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!SOLD-TO NAME & ADDRESS] "                                                         TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " ________________________________________ "                                        TO TLN(11).
    MOVE " ________________________________________ "                                        TO TLN(12).
    MOVE " ________________________________________ "                                        TO TLN(13).
    MOVE " ________________________________________ "                                        TO TLN(14).
    MOVE " ________________________________________ "                                        TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD246.
    MOVE "^PURCHASE HISTORY]   !VENDOR NO.] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ DATE    INVOICE          ORDER     PART NO.          QTY       AMOUNT ] "        TO TLN(3).
*         ../../..  ...............  ........  ............  ...,...-  ...,...:..-
    MOVE " "                                                                                 TO TLN(4).

RD247.
    MOVE "^PRODUCTION SHORT SCHEDULE MAINTENANCE ]    !MACHINE] __                                                     ^FUNCTION] _ "            TO TLNW(1).
    MOVE "                                                                                                             1. ADD SCHEDULE "         TO TLNW(2).
    MOVE "                                                                                                             2. CHANGE SCHEDULE "      TO TLNW(3).
    MOVE "                                                                                                             3. DELETE SCHEDULE "      TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^     M.O.  PROD NO.      DESCRIPTION                           QTY    MATERIAL    CLEAN  COILS  COMMENTS                        QA]"  TO TLNW(7).
*             ......  ............  ................................ ..,...,...  ............  .    ...:.  .............................. ...
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE " 1. ______ "                                                                                                                           TO TLNW(9).
    MOVE " 2. ______ "                                                                                                                           TO TLNW(10).
    MOVE " 3. ______ "                                                                                                                           TO TLNW(11).
    MOVE " 4. ______ "                                                                                                                           TO TLNW(12).
    MOVE " 5. ______ "                                                                                                                           TO TLNW(13).
    MOVE " 6. ______ "                                                                                                                           TO TLNW(14).
    MOVE " 7. ______ "                                                                                                                           TO TLNW(15).
    MOVE " 8. ______ "                                                                                                                           TO TLNW(16).
    MOVE " 9. ______ "                                                                                                                           TO TLNW(17).
    MOVE "10. ______ "                                                                                                                           TO TLNW(18).
    MOVE "11. ______ "                                                                                                                           TO TLNW(19).
    MOVE "12. ______ "                                                                                                                           TO TLNW(20).
    MOVE "13. ______ "                                                                                                                           TO TLNW(21).
    MOVE "14. ______ "                                                                                                                           TO TLNW(22).
    MOVE "15. ______ "                                                                                                                           TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD248.
    MOVE "^PRODUCTION SHORT SCHEDULE ]    !MACHINE] __                                                              !PRINTED:] "                 TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^     M.O. COMPL  PROD NO.     DESCRIPTION                           QTY    MATERIAL     COILS  COMMENTS                        QA] "  TO TLNW(3).
*         ... ......   .   ............  ................................ ..,...,...  ............ ...:.  .............................. ...
    MOVE "?? "                                                                                                                                   TO TLNW(4).

RD249.
    MOVE "^AUDIT LISTING ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BUCKET UPDATE "                                                   TO TLN(3).
    MOVE "              2. Q BINS MAINTENANCE "                                              TO TLN(4).
    MOVE "              3. CASH RECEIPTS "                                                   TO TLN(5).
    MOVE "              4. INVENTORY UPDATE "                                                TO TLN(6).
    MOVE "              5. STOCK UPDATE (PURCHASING) "                                       TO TLN(7).
    MOVE "              6. BILLS OF LADING "                                                 TO TLN(8).
    MOVE "              7. PRODUCTION ORDERS "                                               TO TLN(9).
    MOVE "              8. WORKSHEET QTY/WEIGHT ERROR OVERRIDE "                             TO TLN(10).
    MOVE "              9. DELETE CHEQUES "                                                  TO TLN(11).
    MOVE "             10. CANCEL CHEQUES "                                                  TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!DATE RANGE FOR SPECIFIC DAYS:]   !FROM DATE] ______   !TO DATE] ______ "          TO TLN(15).
    MOVE " "                                                                                 TO TLN(16).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(17).
    MOVE "?? "                                                                               TO TLN(18).

RD250.
    MOVE "^PRODUCT LISTING BY DESCRIPTION ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DESCRIPTION CODES:]  1. FINISH DESCRIPTION "                                      TO TLN(3).
    MOVE "                      2. PRINT DESCRIPTION "                                       TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!CODE] _        !FROM DESCRIPTION] ____________________ "                          TO TLN(7).
    MOVE "                  !TO DESCRIPTION] ____________________ "                          TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD251.
    MOVE "^HEAT FILE LISTING ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM HEAT] __________       !TO HEAT] __________ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD252.
    MOVE "^LOT METALLURGICAL TEST REPORT ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM LOT] _______    !TO LOT] _______ "                                           TO TLN(3).
    MOVE "           _______             _______ "                                           TO TLN(4).
    MOVE "           _______             _______ "                                           TO TLN(5).
    MOVE "           _______             _______ "                                           TO TLN(6).
    MOVE "           _______             _______ "                                           TO TLN(7).
    MOVE "           _______             _______ "                                           TO TLN(8).
    MOVE "           _______             _______ "                                           TO TLN(9).
    MOVE "           _______             _______ "                                           TO TLN(10).
    MOVE "           _______             _______ "                                           TO TLN(11).
    MOVE "           _______             _______ "                                           TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!INCLUDE BARE LOTS ?]   ___ "                                                      TO TLN(15).
    MOVE "!INCLUDE PLATED LOTS ?] ___ "                                                      TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(18).
    MOVE "?? "                                                                               TO TLN(19).

RD253.
    MOVE "^METALLURGICAL TEST REPORT ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD254.
    MOVE "^SALES ANALYSIS REPORTS ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY TERRITORY "                                                    TO TLN(3).
    MOVE "              2. BY PROVINCE "                                                     TO TLN(4).
    MOVE "              3. BY SALESMAN "                                                     TO TLN(5).
    MOVE "              4. BY CATEGORY "                                                     TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD255.
    MOVE "^SALES SUMMARY REPORTS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. 5 YEAR COMPARISON "                                               TO TLN(3).
    MOVE "              2. 5 YEAR CUSTOMER SUMMARY "                                         TO TLN(4).
    MOVE "              3. CUSTOMER RANKING "                                                TO TLN(5).
    MOVE "              4. SALES ANALYSIS BY PLATING PROCESS "                               TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD256.
    MOVE "^PRODUCT LISTING FOR A PRINT NO. ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST PRODUCTS WITH PRINT NO.] IF-____ "                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD257.
    MOVE "^MISCELLANEOUS MODIFICATIONS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CLEAR AUTOMOTIVE QTY CUM. YTD "                                                 TO TLN(5).
    MOVE "2. CLEAR NON-AUTOMOTIVE QTY CUM. YTD "                                             TO TLN(6).
    MOVE "3. CHANGE AUTOMOTIVE MODEL YEAR "                                                  TO TLN(7).
    MOVE "4. MODIFY PLANT EDIFACT INDICATOR "                                                TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD258.
    MOVE "^PRINT SHIPPING LABELS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT LABELS CREATED WITH PICKING TICKETS ] "                                     TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " 1. GM (PRINT 'LAB07') "                                                           TO TLN(7).
    MOVE " 2. AMERICAN AXLE (PRINT 'LAB08') "                                                TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " (CREATE AND PRINT 'LAB03') "                                                      TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE " 3. FLEXALLOY    4. FASTENAL    5. SATURN    6. DELPHI    7. TRW    8. DANA "      TO TLN(12).
    MOVE " 9. BENTELER    10. VENEST     11. MGM "                                           TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!PRINT LABELS FOR SPECIFIC ORDERS ] "                                              TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "20. ALL (EXCEPT AMERICAN AXLE) "                                                   TO TLN(18).
    MOVE "                                                                       !OK] __ "   TO TLN(19).
    MOVE "?? "                                                                               TO TLN(20).

RD259.
    MOVE "^PRINT SHIPPING MASTER LABELS ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. GM "                                                                           TO TLN(5).
    MOVE " 2. GM MIXED LOAD "                                                                TO TLN(6).
    MOVE " 3. QSS "                                                                          TO TLN(7).
    MOVE " 4. MODATEK "                                                                      TO TLN(8).
    MOVE " 5. SATURN "                                                                       TO TLN(9).
    MOVE " 6. TRW "                                                                          TO TLN(10).
    MOVE " 7. INMET "                                                                        TO TLN(11).
    MOVE " 8. BENTELER "                                                                     TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE "11. STOCK "                                                                        TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD260.
    MOVE "^PRINT STOCK MASTER LABEL ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________ "                                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CARTONS/PALLET] __     !QTY/PALLET] ______ "                                      TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!LOT] _______      !DATE MFG] ______      !NUM LABELS] __ "                        TO TLN(7).
    MOVE "                                                                       !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD261.
    MOVE "^INCREASE PRODUCT PRICE IN OUTSTANDING ORDERS ] "                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CORRECTION RUN ?] ___ "                                                           TO TLN(3).
    MOVE "    TO RESTORE ORIGINAL PRICES ENTER 'YES' AND SPECIFY ORIGINAL % INCREASE "       TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!CUST NO.   % INCREASE ] "                                                         TO TLN(7).
    MOVE " ______       _____ "                                                              TO TLN(8).
    MOVE " ______       _____ "                                                              TO TLN(9).
    MOVE " ______       _____ "                                                              TO TLN(10).
    MOVE " ______       _____ "                                                              TO TLN(11).
    MOVE " ______       _____ "                                                              TO TLN(12).
    MOVE " ______       _____ "                                                              TO TLN(13).
    MOVE " ______       _____ "                                                              TO TLN(14).
    MOVE " ______       _____ "                                                              TO TLN(15).
    MOVE " ______       _____ "                                                              TO TLN(16).
    MOVE " ______       _____ "                                                              TO TLN(17).
    MOVE " "                                                                                 TO TLN(18).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(19).
    MOVE "?? "                                                                               TO TLN(20).

RD262.
    MOVE "^SET S-20 (CREATE SHIPPING FILE) VERIFICATION DATE ] "                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CURRENT S-20 DATE:] "                                                             TO TLN(3).
    MOVE "!CURRENT S-20 COMPLETION INDICATOR:] "                                             TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "THIS FUNCTION SETS THE S-20 DATE AS TODAY'S DATE "                                 TO TLN(7).
    MOVE "  TO INDICATE THAT S-20 WAS PERFORMED TODAY. "                                     TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "NORMALLY THIS IS DONE AUTOMATICALLY IN S-20, WHEN THE SYSTEM SETS THE "            TO TLN(10).
    MOVE "COMPLETION INDICATOR TO 'COMPLETED OK'. IT MUST BE DONE HERE ONLY WHEN IT IS "     TO TLN(11).
    MOVE "NECESSARY TO PERFORM S-15, S-21 - S-27 WITHOUT HAVING PERFORMED S-20 FIRST, "      TO TLN(12).
    MOVE "OR WHEN S-20 WAS PERFORMED BUT THE DATE WAS NOT SET PROPERLY BY THE SYSTEM. "      TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!ARE YOU SURE ?] ___ "                                                             TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD263.
    MOVE "^SET MAIN/EPSON PRINTER INDICATOR ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS SETTING AFFECTS THE PRINT FILES PRODUCED FOR: "                               TO TLN(3).
    MOVE "  PICKING TICKETS, INVOICES, A/P CHEQUES "                                         TO TLN(4).

     IF IFAST
    MOVE "       !(IN IRVINE FASTENERS ONLY)] "                                              TO TLN(5)
    MOVE "   PLUS PAYROLL CHEQUES IN!ALL]DIVISIONS "                                         TO TLN(6).
     IF ITOOL
    MOVE "         !(IN IRVINE TOOLS ONLY)] "                                                TO TLN(5)
    MOVE " "                                                                                 TO TLN(6).
     IF INUT
    MOVE "         !(IN IRVINE NUTS ONLY)] "                                                 TO TLN(5)
    MOVE " "                                                                                 TO TLN(6).

    MOVE " "                                                                                 TO TLN(7).
    MOVE "SET TO !0] FOR MAIN PRINTER "                                                      TO TLN(8).
    MOVE "SET TO !1] FOR EPSON-TYPE PRINTER "                                                TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!CURRENT SETTING] "                                                                TO TLN(11).
    MOVE "    !NEW SETTING] _ "                                                              TO TLN(12).
    MOVE " "                                                                                 TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!ARE YOU SURE ?] ___ "                                                             TO TLN(15).
    MOVE "?? "                                                                               TO TLN(16).

RD264.
    MOVE "^SUBCONTRACTOR PRODUCT SHIPMENTS ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "  !CARTONS] _____          !SKIDS] ___           !CARDBOARD PADS] ___ "            TO TLN(3).
    MOVE "  !CARTON BUNDLES] __      !SKID STACKS] __      !CARDBOARD BUNDLES] __ "          TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "SORTING SUBCONTRACTOR: ENTER TOTAL CARTONS AND SKIDS SHIPPED WITH THIS B/L "       TO TLN(7).
    MOVE "PLATING SUBCONTRACTOR: ENTER TOTAL CARDBOARDS SHIPPED WITH THIS B/L "              TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "                                                                       !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD265.
    MOVE "^PRINT NAFTA FORM ] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUST NO.] ______ "                                                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!BLANKET DATE RANGE:]   !FROM] ______     !TO] ______ "                            TO TLN(5).
    MOVE "!HISTORY DATE RANGE:]   !FROM] ______     !TO] ______ "                            TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!ADDITIONAL PRODUCTS:] ____________  ____________  ____________ "                  TO TLN(8).
    MOVE "                       ____________  ____________  ____________ "                  TO TLN(9).
    MOVE "                       ____________  ____________  ____________ "                  TO TLN(10).
    MOVE "                       ____________  ____________  ____________ "                  TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "                                                                       !OK] __ "   TO TLN(13).
    MOVE "?? "                                                                               TO TLN(14).

RD266.
    MOVE "^PRINT LABELS FOR SPECIFIC ORDERS ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!ORDER NO.] ______ "                                                               TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRODUCT] ____________  (LEAVE BLANK TO SELECT ALL THE PRODUCTS IN THIS ORDER) "   TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                                                       !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD267.
    MOVE "^GENERATE BLANKET ORDER EXTENSIONS ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE ONLY NON-EDI (MATREL) ORDERS ?] ___ "                                     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "^DAYREL ORDERS] "                                                                  TO TLN(5).
    MOVE "!INCLUDE AMERICAN AXLE ORDERS ?] ___ "                                             TO TLN(6).
    MOVE "!INCLUDE GM ORDERS ?] ___ "                                                        TO TLN(7).
    MOVE "!INCLUDE OTHER ORDERS ?] ___ "                                                     TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "^PRINT FILE NO.] !FOR REPORT] __ "                                                 TO TLN(10).
    MOVE "                 !FOR REPORT DETAILS] __ "                                         TO TLN(11).
    MOVE "                                                                       !OK] __ "   TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD268.
    MOVE "^BANK CLEARING REPORT ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!BANK INPUT FILE] _______.DAT "                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD269.
    MOVE "^LIST PRODUCTS WITH SIMILAR HEAT TREATMENT CHARACTERISTICS ] "                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT] ____________      (PRODUCT WITH COMMON CHARACTERISTICS) "                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!GRADE:]            !WIRE:]          !SPEC:] "                                     TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!ASSIGN THE COMMON CHARACTERISTICS TO THE PRODUCTS LISTED ?] ___ "                 TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!CHARACTERISTIC                        MIN       MAX] "                            TO TLN(11).
*         .. ...............................  .......   .......
    MOVE "?? "                                                                               TO TLN(12).

RD270.
    MOVE "^CHANGE THE GRADE IN LOT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION MODIFIES THE GRADE AND AUTHORIZATION IN THE LOT SPECIFIED. "         TO TLN(3).
    MOVE "  (IF LOT GRADE IS BLANK, THE MTR GRADE WILL BE TAKEN FROM THE HEAT) "             TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "                                 !CURRENT]    !NEW] "                              TO TLN(6).
    MOVE "!LOT] _______             !GRADE] ________    ________ "                           TO TLN(7).
    MOVE "                  !AUTHORIZATION] ____        ____ "                               TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD271.
    MOVE "^LIST PRODUCTS NOT MADE RECENTLY ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE PRODUCTS NOT MADE SINCE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD272.
    MOVE "^MACHINE CLEANOUT SETTINGS ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!MACHINE] ___ "                                                                    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                  !FREQUENCY    LAST CLEANOUT DATE] "                              TO TLN(5).
    MOVE "                  ! (HOURS)          (MMDDYY)     ] "                              TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!CURRENT SETTINGS] "                                                               TO TLN(8).
    MOVE "    !NEW SETTINGS]   _____            ______ "                                     TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "                                                    !'OK' TO APPLY CHANGES] __ "   TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD273.
    MOVE "^MACHINE CLEANOUT INFORMATION ]         !FROM MACHINE] ____   !TO MACHINE] ____ "  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^MAC  LAST CLEANOUT   RUN HOURS   FREQUENCY   DUE ] "                              TO TLN(3).
*          ...     ../../..      ..,...      ..,...      .
    MOVE "?? "                                                                               TO TLN(4).

RD274.
    MOVE "^UPDATE QUOTATION COSTING FILE ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM QUOTATION] ______      !TO QUOTATION] ______ "                               TO TLN(3).
    MOVE "                                                                       !OK] __ "   TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD275.
    MOVE "^QUARANTINE/RELEASE LOTS ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LOT] _______   !STATUS] _          'Y' = QUARANTINED "                            TO TLN(3).
    MOVE "                                    'N' = RELEASED "                               TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD276.
    MOVE "^LOT SALE HISTORY ] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY LOT "                                                          TO TLN(3).
    MOVE "              2. BY INVOICE "                                                      TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD276A.
    MOVE "^LOT HISTORY FOR LOT]!       ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUST  NAME                               DATE    INV NO. CUST ORD    QTY  CTNS]"  TO TLN(3).
*         ...... ................................ ../../..  ......  ......... ...,... ...
    MOVE " "                                                                                 TO TLN(4).

RD276B.
    MOVE "^LOT HISTORY FOR INVOICE]!      ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUST  NAME                               DATE   LOT NO.  CUST ORD    QTY  CTNS]"  TO TLN(3).
*         ...... ................................ ../../.. .......  ......... ...,... ...
    MOVE " "                                                                                 TO TLN(4).

RD277.
    MOVE "^VENDORS AND PART NUMBERS ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VENDOR PART NO.] ________________________ "                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
*         ............  ........................    ............  ........................
    MOVE "?? "                                                                               TO TLN(5).

RD278.
    MOVE "^MISCELLANEOUS INQUIRIES ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. M.O.'S WITH REJECT/SCRAP WORKSHEETS "                                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD278A.
    MOVE "^M.O.'S WITH REJECT/SCRAP WORKSHEETS ] "                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION CALCULATES THE TOTAL QTY & WEIGHT OF THE REJECT/SCRAP "              TO TLN(3).
    MOVE "  WORKSHEET ENTRIES IN M.O.'S THAT HAVE WORKSHEET ENTRIES WITH ONE "               TO TLN(4).
    MOVE "  OF THE SPECIFIED PROCESSES, IN THE PERIOD SPECIFIED. "                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PROCESSES]  ____  ____  ____  ____  ____  ____  ____  ____  ____  ____ "          TO TLN(7).
    MOVE "             ____  ____  ____  ____  ____  ____  ____  ____  ____  ____ "          TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!FROM DATE] ______     !TO DATE] ______                     !'OK' TO START] __ "   TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "  !NUM M.O.'S:]        !TOTAL QTY:]               !TOTAL WEIGHT:] "                TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD279.
    MOVE "^TOOLS IN ASSEMBLIES ]   !TOOL:] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^ASSEMBLY     DESCRIPTION                      LOCTN  IN STK ] "                   TO TLN(3).
*         ............  ................................ ...... ...  .
    MOVE " "                                                                                 TO TLN(4).

RD280.
    MOVE "^WORK IN PROGRESS REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. USING M.O. 'QUANTITY LEFT' "                                      TO TLN(3).
    MOVE "              2. USING 'PROCESS 940' "                                             TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD281.
    MOVE "^AUTHORIZE SHIPPING LABELS ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LOT NO.] _______     !CURRENT AUTHORIZATION] _    ('Y' TO AUTHORIZE, ELSE 'N') "  TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD282.
    MOVE "^PRODUCT PRICE FILE MAINTENANCE ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "                                          ^FUNCTION] _    1. ADD RECORD "          TO TLN(3).
    MOVE "                                                          2. CHANGE RECORD "       TO TLN(4).
    MOVE "                                                          3. DELETE RECORD "       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "^CUSTOMER] ______ "                                                                TO TLN(7).
    MOVE "^PRODUCT ] ____________ "                                                          TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!EFFECTIVE DATE] "                                                                 TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!PRICE] ________     !SURCH CODE OVERRIDE] _     !SURCH/M PCS OVERRIDE] ______ "   TO TLN(13).
    MOVE " "                                                                                 TO TLN(14).
    MOVE "!AUTHORIZATION] ___ "                                                              TO TLN(15).
    MOVE "!NOTE] __________________________________________________ "                        TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD283.
    MOVE "^PRODUCT PRICES ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CUSTOMER / PRODUCT "                                           TO TLN(3).
    MOVE "              2. BY PRODUCT / CUSTOMER "                                           TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD283A.
    MOVE "^PRICES FOR CUSTOMER NO.                                                       ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^PRODUCT     DESCRIPTION                   PRICE  US SUR SURCH/M  AUTH EFF DATE]"  TO TLN(3).
*         ............ ............................ ...:... ..  .   ..:...   ...  ../../..
*                      ..................................................
    MOVE " "                                                                                 TO TLN(4).

RD283B.
    MOVE "^PRICES FOR PRODUCT NO.                                                        ]"  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^CUST        NAME                          PRICE  US SUR SURCH/M  AUTH EFF DATE]"  TO TLN(3).
*         ......       ............................ ...:... ..  .   ..:...   ...  ../../..
*                      ..................................................
    MOVE " "                                                                                 TO TLN(4).

RD284.
    MOVE "^PRODUCT PRICE HISTORY ]  !CUST:                                               ]"  TO TLN(1).
    MOVE "                          !PROD:                                               ]"  TO TLN(2).
    MOVE " "                                                                                 TO TLN(3).
    MOVE "^DATE ARCHIVED   PRICE  US SUR SURCH/M  AUTH  EFF DATE          ] "                TO TLN(4).
*            ../../..    ....:... ..  .   ..:...  ...   ../../..
*                        ..................................................
    MOVE " "                                                                                 TO TLN(5).

RD285.
    MOVE "^LIST M.O.'S WITH INCOMPLETE TOOL LIST ] "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION LISTS THE PRODUCTS (IN CURRENT M.O.'S) "                             TO TLN(3).
    MOVE "  THAT HAVE AN INCOMPLETE TOOL LIST "                                              TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD286.
    MOVE "^SHIP-TO ADDRESSES ]  !CUST:       ] "                                                                                                 TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^SHIP-TO   NAME                              ADDRESS LINE 1                    ADDRESS LINE 2                    POST/ZIP ] "          TO TLNW(3).
*          ..        ................................  ................................  ................................  ..........
    MOVE " "                                                                                                                                     TO TLNW(4).

RD287.
    MOVE "^CUSTOMER CONTACTS ]    ^CUST:] "                                                                                                      TO TLNW(1).
    MOVE " "                                                                                                                                     TO TLNW(2).
    MOVE "^FIRST     LAST       POSITION   PHONE         EXT  FAX           EMAIL                          CITY            ST  CTRY] "           TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(5).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(6).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(7).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(8).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(9).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(10).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(11).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(12).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(13).
    MOVE "__________ __________ __________ _____________ ____ _____________ ______________________________ _______________ ___ _____ "           TO TLNW(14).
    MOVE "?? "                                                                                                                                   TO TLNW(15).

RD288.
    MOVE "^SCRAP ENTRY ] "                                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O.   ] ______ "                                                                 TO TLN(3).
    MOVE "!MACHINE] ___ "                                                                    TO TLN(4).
    MOVE "!WEIGHT ] _______ "                                                                TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD289.
    MOVE "^SCRAP REPORT ] "                                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACHINE] ____         !TO MACHINE] ____ "                                    TO TLN(3).
    MOVE "   !FROM PART] ____________    !TO PART] ____________ "                            TO TLN(4).
    MOVE "   !FROM DATE] ______          !TO DATE] ______ "                                  TO TLN(5).
    MOVE "   !FROM M.O.] ______          !TO M.O.] ______ "                                  TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD290.
    MOVE "^IN-PROCESS PRODUCTION ORDERS REPORT ] "                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD291.
    MOVE "^PRODUCTION REPORTS ] "                                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACHINE] ____     !TO MACHINE] ____ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!REPORT TYPE] _ "                                                                  TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "   1. ONE SHIFT:   !DATE] ______     !SHIFT](D/A/N) _ "                            TO TLN(7).
    MOVE "   2. ONE WEEK:    !DATE] ______     (ENTER ANY DATE WITHIN THE REQUIRED WEEK) "   TO TLN(8).
    MOVE "   3. ONE MONTH:   !YEAR](0-99) __   !MONTH](1-12) __ "                            TO TLN(9).
    MOVE "                                                                       !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD292.
    MOVE "^PRODUCTION HOURS REPORT ] (ALSO EXPORT FILE) "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUTURE HOURS CALCULATION NORMALLY USES LATE M.O. START DATES. ] "                 TO TLN(3).
    MOVE "!USE INSTEAD REQUIRED START DATES ?] ___ "                                         TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!FROM MACHINE] ____    !TO MACHINE] ____ "                                         TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD293.
    MOVE "^TOOL COSTING REPORT ] (ALSO EXPORT FILE) "                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!UPDATE G/L MTD TOTALS ?] ___ "                                                    TO TLN(5).
    MOVE "!INCLUDE TOOL LIFE BREAKDOWN IN PRINTED REPORT ?] ___ "                            TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD294.
    MOVE "^TOOL LIFE REPORT AND UPDATE ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "'ACTUAL' LIFE IS BASED ON LAST YEAR + YTD TOOL USAGE. "                            TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!UPDATE THE 'ACTUAL' LIFE FIELD ?] ___  (OTHERWISE ONLY REPORT) "                  TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD295.
    MOVE "^PROCESS TEXT MESSAGE 864, GENRAL FILES ] "                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHRYSLER 864 FILE "                                                             TO TLN(5).
    MOVE "2. GM 864 FILE "                                                                   TO TLN(6).
    MOVE "3. GM GENRAL FILE "                                                                TO TLN(7).
    MOVE "4. ADVANTIS GENRAL FILE "                                                          TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD296.
    MOVE "^MATERIAL RELEASE REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHRYSLER "                                                                      TO TLN(5).
    MOVE "2. GM "                                                                            TO TLN(6).
    MOVE "3. NON-GM EDI "                                                                    TO TLN(7).
    MOVE "4. NON-EDI "                                                                       TO TLN(8).
    MOVE "5. ALL "                                                                           TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD296A.
    MOVE "^MATERIAL RELEASE REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM PLANT]   __________       !TO PLANT]   __________ "                          TO TLN(3).
    MOVE "!FROM PRODUCT] ____________     !TO PRODUCT] ____________ "                        TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD296B.
    MOVE "^MATERIAL RELEASE REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM SALES REP] __      !TO SALES REP] __ "                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD296C.
    MOVE "^MATERIAL RELEASE REPORT ] "                                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CATEGORY] __      !TO CATEGORY] __ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD297.
    MOVE "^PROCESS REMITTANCE ADVICE 820 FILES ] "                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHRYSLER 820 FILE "                                                             TO TLN(5).
    MOVE "2. GM 820 FILE "                                                                   TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD298.
    MOVE "^PROCESS PURCHASE ORDER CHANGE 860 FILES ] "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHRYSLER 860 FILE "                                                             TO TLN(5).
    MOVE "2. GM 860 FILE "                                                                   TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD299.
    MOVE "^DELETE RELEASE FILE RECORDS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION DELETES PLANT-PRODUCT COMBINATIONS IN THE RELEASE FILES. "           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!SELECT:] __  1. MATERIAL RELEASES FILE 'MATREL' "                                 TO TLN(5).
    MOVE "              2. DAILY    RELEASES FILE 'DAYREL' "                                 TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!PRODUCT] ____________      !PLANT] "                                              TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD300.
    MOVE "^MODIFY B/L INDICATORS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^B/L NO.] _______                 0 = NOT DONE "                                   TO TLN(3).
    MOVE "                                  1 = DONE "                                       TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!SHIPPED        ] _ "                                                              TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!CUSTOMS FORMS  ] _ "                                                              TO TLN(8).
    MOVE "!BILLS OF LADING] _ "                                                              TO TLN(9).
    MOVE "!TOWER EDI FILE ] _ "                                                              TO TLN(10).
    MOVE "!EDI 856/DESADV ] _ "                                                              TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD301.
    MOVE "^LINE FEED SUMMARY REPORT ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. GM "                                                              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

* note 73.2
RD302.
    MOVE "^DAILY RELEASE REPORT ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUSTOMER AUTOMOTIVE/EDI CODES:] "                                                 TO TLN(3).
    MOVE " 1:TOWER   2:CHRYSLER   3:GM   4:TRW   5:UTA   6:FLEXALLOY   7:SKF   8:RBW "       TO TLN(4).
    MOVE " 9:AMERICAN AXLE   10:KSR   11:FABCO   12:GRAHAM   13:DELPHI   14:MGM "            TO TLN(5).
    MOVE " 15:WOODBRIDGE   16:QSS   17:INMET   18:DANA   19:DRIVESOL   20: MODATEK "         TO TLN(6).
    MOVE " 21:BENTELER   22:VENEST "                                                         TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!CUSTOMER CODE] __ "                                                               TO TLN(11).
    MOVE " "                                                                                 TO TLN(12).
    MOVE "!FROM PLANT]   __________       !TO PLANT]   __________ "                          TO TLN(13).
    MOVE "!FROM PRODUCT] ____________     !TO PRODUCT] ____________ "                        TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(16).
    MOVE "?? "                                                                               TO TLN(17).

RD303.
    MOVE "^PROCESS RECEIVING ADVICE 861, RECADV FILES ] "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. ADVANTIS 861 FILE "                                                             TO TLN(5).
    MOVE "2. GM & ADVANTIS RECADV FILE "                                                     TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD304.
    MOVE "^PRODUCT LISTING BY HARMONY CODE ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD305.
    MOVE "^PROCESS ADVANCE SHIP NOTICE 856 FILES ] "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. SIDBEC FILE "                                                                   TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD306.
    MOVE "^CREATE EDIFACT ACKNOWLEDGEMENT CONTRL FILE ] "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. READ ADVANTIS FILE "                                                            TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD307.
    MOVE "^CREATE ASN 856, DESADV FILES ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. TOWER 856 FILE "                                                               TO TLN(5).
    MOVE " 2. CHRYSLER 856 FILE "                                                            TO TLN(6).
    MOVE " 3. GM 856 FILE "                                                                  TO TLN(7).
    MOVE " 4. TRW DESADV FILE "                                                              TO TLN(8).
    MOVE " 5. TRW 856 FILE "                                                                 TO TLN(9).
    MOVE " 6. UTA 856 FILE "                                                                 TO TLN(10).
    MOVE " 7. GM DESADV FILE "                                                               TO TLN(11).
    MOVE " 8. GM FUNCTIONS 3+7 IN ONE FILE "                                                 TO TLN(12).
    MOVE " 9. SEVERAL (SEE *) IN ONE FILE "                                                  TO TLN(13).
    MOVE "10. MGM 856 FILE "                                                                 TO TLN(14).
    MOVE "11. WOODBRIDGE 856 FILE "                                                          TO TLN(15).
    MOVE "12. DANA 856 FILE "                                                                TO TLN(16).
    MOVE "13. MODATEK 856 FILE "                                                             TO TLN(17).
    MOVE "14. BENTELER 856 FILE "                                                            TO TLN(18).
    MOVE "15. VENEST 856 FILE "                                                              TO TLN(19).
    MOVE " "                                                                                 TO TLN(20).
    MOVE "* TOWER,TRW,DELPHI,AMERICAN AXLE,MGM,WOODBRIDGE,DANA,MODATEK,BENTELER,VENEST "     TO TLN(21).
    MOVE " "                                                                                 TO TLN(22).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(23).
    MOVE "?? "                                                                               TO TLN(24).

RD308.
    MOVE "^PROCESS DAILY SHIP 862, DELJIT FILES ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHRYSLER 862 FILE "                                                             TO TLN(5).
    MOVE "2. GM 862 FILE "                                                                   TO TLN(6).
    MOVE "3. GM DELJIT FILE "                                                                TO TLN(7).
    MOVE "4. ADVANTIS 862 FILE "                                                             TO TLN(8).
    MOVE "5. ADVANTIS DELJIT FILE "                                                          TO TLN(9).
    MOVE "6. REPORT ONLY: ADVANTIS DELJIT FILE "                                             TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(12).
    MOVE "?? "                                                                               TO TLN(13).

RD309.
    MOVE "^PROCESS MATERIAL RELEASE 830, DELFOR FILES ] "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. CHRYSLER 830 FILE "                                                             TO TLN(5).
    MOVE "2. GM 830 FILE "                                                                   TO TLN(6).
    MOVE "3. ADVANTIS 830 FILE + PROCESS 850 FILE + CREATE 855 FILE "                        TO TLN(7).
    MOVE "4. GM DELFOR FILE "                                                                TO TLN(8).
    MOVE "5. ADVANTIS DELFOR FILE "                                                          TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD310.
    MOVE "^PROCESS INVENTORY REPORT INVRPT FILE ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FUNCTION:] __ "                                                                   TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "1. GM INVRPT FILE "                                                                TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                                    99/PF4  RETURN TO MAIN MENU "  TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD311.
    MOVE "^MODIFY PRODUCTION OFF DATES ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "- ENTER PAIRS OF 'FROM' - 'TO' DATES, IN ANY SEQUENCE. "                           TO TLN(3).
    MOVE "- ANY PAIR CAN BE '000000 - 000000' (UNUSED). "                                    TO TLN(4).
    MOVE "- SATURDAYS AND SUNDAYS ARE OFF DAYS WHETHER OR NOT INCLUDED IN A RANGE. "         TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                         !LIMIT DATE FOR CURRENT DEMAND] ______ "  TO TLN(7).
    MOVE "!FROM DATE] ______    !TO DATE] ______ "                                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD312.
    MOVE "^A/P TRIAL BALANCE ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIST BY COMMODITY CLASS ?] ___ "                                                  TO TLN(3).
    MOVE "!LIST IN DECREASING BALANCE ORDER ?] ___ "                                         TO TLN(4).
    MOVE "!SHOW FULL ADDRESS ?] ___ "                                                        TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD313.
    MOVE "^ALTERNATE TOOL REPORT ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY OUTSIDE DIAMETER "                                             TO TLN(3).
    MOVE "              2. BY HOLE SIZE "                                                    TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD314.
    MOVE "^PRODUCT CONTRIBUTION REPORTS ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY CATEGORY                           !YEAR] _  1. THIS YEAR "    TO TLN(3).
    MOVE "              2. BY MACHINE                                      2. LAST YEAR "    TO TLN(4).
    MOVE "              3. BY CUSTOMER (ALSO EXPORT FILE)                  3. 2 YEARS AGO "  TO TLN(5).
    MOVE "              4. BY CUSTOMER - SUMMARY (ONLY EXPORT FILE) "                        TO TLN(6).
    MOVE "              5. BY ORDER (ONLY EXPORT FILE)              !MONTH RANGE] __ - __ "  TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!COST HISTORY PERIOD] __________ "                                                 TO TLN(10).
    MOVE " "                                                                                 TO TLN(11).
    MOVE "!FROM CATEGORY] __          !TO CATEGORY] __ "                                     TO TLN(12).
    MOVE "!FROM MACHINE]  ____        !TO MACHINE]  ____ "                                   TO TLN(13).
    MOVE "!FROM CUSTOMER] ______      !TO CUSTOMER] ______ "                                 TO TLN(14).
    MOVE " "                                                                                 TO TLN(15).
    MOVE "!FROM DATE] ______          !TO DATE] ______ "                                     TO TLN(16).
    MOVE " "                                                                                 TO TLN(17).
    MOVE "!APPLY MOST RECENT SALE PRICE TO THE SALES IN THE RANGE ?] ___ "                   TO TLN(18).
    MOVE " "                                                                                 TO TLN(19).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(20).
    MOVE "?? "                                                                               TO TLN(21).

RD315.
    MOVE "^TOOL LIST VALIDATION REPORT ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD316.
    MOVE "^TOOL BIN VALIDATION REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD317.
    MOVE "^CONTRACTOR PERFORMANCE REPORT ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD318.
    MOVE "^PURCHASING PERFORMANCE REPORT ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CATEGORY] ___     !TO CATEGORY] ___ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD319.
    MOVE "^LOT REPORTS ] "                                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY LOT "                                                          TO TLN(3).
    MOVE "              2. BY PRODUCT "                                                      TO TLN(4).
    MOVE "              3. BY HEAT "                                                         TO TLN(5).
    MOVE "              4. BY M.O. "                                                         TO TLN(6).
    MOVE "              5. LOTS WITH INVALID LOT NUMBER "                                    TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!FROM] ______          !TO] ______ "                                               TO TLN(9).
    MOVE " "                                                                                 TO TLN(10).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(11).
    MOVE "?? "                                                                               TO TLN(12).

RD320.
    MOVE "^PRODUCT REPORTS ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. BY DESCRIPTION "                                                  TO TLN(3).
    MOVE "              2. FOR A PRINT NO. "                                                 TO TLN(4).
    MOVE "              3. BY PLATING SPEC "                                                 TO TLN(5).
    MOVE "              4. BY PACKING CODE "                                                 TO TLN(6).
    MOVE "              5. FOR A WIRE SIZE "                                                 TO TLN(7).
    MOVE "              6. BY FAMILY "                                                       TO TLN(8).
    MOVE "              7. BY MATERIAL SPEC "                                                TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD321.
    MOVE "^HEAT LOCATION REPORT ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM HEAT] __________       !TO HEAT] __________ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!INCLUDE ONLY HEATS OLDER THAN] ______ "                                           TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD322.
    MOVE "^CREATE INVOICE EXPORT FILES ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. A/R FILE "                                                        TO TLN(3).
    MOVE "              2. A/P FILE "                                                        TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).

     IF IFAST
    MOVE " "                                                                                 TO TLN(6)
    MOVE "ONE FILE IS CREATED WITH DATA FROM BOTH IRVINE FASTENERS AND IRVINE NUTS. "        TO TLN(7).
     IF NOT IFAST
    MOVE "THIS FUNCTION CAN BE RUN ONLY FOR IRVINE FASTENERS "                               TO TLN(6)
    MOVE "  AND CREATES ONE FILE WITH DATA FROM BOTH IRVINE FASTENERS AND IRVINE NUTS. "     TO TLN(7).

    MOVE "?? "                                                                               TO TLN(8).

RD323.
    MOVE "^A/P DISTRIBUTION AND ACCRUAL REPORTS ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!SELECT:] __  1. DISTRIBUTION REPORT "                                             TO TLN(3).
    MOVE "              2. ACCRUAL REPORT "                                                  TO TLN(4).
    MOVE "              3. DISTRIBUTION REPORT BY INVOICE "                                  TO TLN(5).
    MOVE "              4. DISTRIBUTION REPORT BY AMOUNT "                                   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD324.
    MOVE "^SURPLUS INVENTORY REPORT ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE OEM ?] ___ "                                                              TO TLN(3).
    MOVE "!INCLUDE STANDARD ?] ___ "                                                         TO TLN(4).
    MOVE "!INCLUDE SPECIAL ?] ___ "                                                          TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!SORT BY CATEGORY ?] ___  (OTHERWISE SORTED BY MACHINE) "                          TO TLN(7).
    MOVE "!SORT BY SURPLUS LBS WITHIN CATEGORY/MACHINE ?] ___ "                              TO TLN(8).
    MOVE " "                                                                                 TO TLN(9).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD325.
    MOVE "^PRINT STATEMENTS ] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CUSTOMER] ______       !TO CUSTOMER] ______ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!STATEMENT DATE] ______ "                                                          TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD326.
    MOVE "^STATEMENT HISTORY REPORT ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CUSTOMER] ______       !TO CUSTOMER] ______ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!YEAR](0-99) __    !MONTH](1-12) __ "                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD327.
    MOVE "^SUBCONTRACTOR INVENTORY VALUE REPORT ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CATEGORY] __       !TO CATEGORY] __ "                                        TO TLN(3).
    MOVE "!FROM PROCESS]  ____     !TO PROCESS]  ____ "                                      TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD328.
    MOVE "^SUBCONTRACTOR WORK-IN-PROCESS VALUE REPORT ] "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM PROCESS] ____     !TO PROCESS] ____ "                                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!LIMIT DATE] ______ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD329.
    MOVE "^CREATE A/R EXPORT FILE ] "                                                        TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD330.
    MOVE "^PRODUCT COST UPDATE ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PERIOD DESCRIPTION] __________ "                                                  TO TLN(3).
    MOVE "!UPDATE THE COST HISTORY FILE ?] ___ "                                             TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD331.
    MOVE "^PRODUCT COST REPORT ]  (ALSO EXPORT FILE) "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE CUSTOMER PRICE HISTORY ?] ___ "                                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM CATEGORY] __       !TO CATEGORY] __ "                                        TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD332.
    MOVE "^PRODUCT COST ANALYSIS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!SUMMARY ONLY ?] ___ "                                                             TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD333.
    MOVE "^MAINTENANCE PARTS COST REPORT ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD334.
    MOVE "^LIST ORDERS TO SHIP ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD335.
    MOVE "^GENERATE BILLS OF LADING ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD336.
    MOVE "^CREATE SHIPPING FILE ] "                                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!NO ONE ELSE MUST USE 'S' MENU FUNCTIONS WHILE CREATING THE SHIPPING FILE ] "      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                                       !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD337.
    MOVE "^PRINT PICKING TICKETS ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE GM ?] ___ "                                                               TO TLN(3).
    MOVE "!PRINT ON EPSON-TYPE PRINTER ?] ___ "                                              TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD338.
    MOVE "^INVOICE SHIPPED ORDERS ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD339.
    MOVE "^PRINT INVOICES ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD340.
    MOVE "^ADD BLANKET ORDERS TO SHIP ] "                                                    TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD341.
    MOVE "^PREVENT SELECTIVELY BIN ALLOCATION ] "                                            TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD342.
    MOVE "^MODIFY ORDER STATUS IN SHIPPING FILE ] "                                          TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD343.
    MOVE "^DESTINATION PLANT LISTING ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM RECEIVER] ___      !TO RECEIVER] ___ "                                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD344.
    MOVE "^CREATE SINGLE GM SHIPPING LABELS ] "                                              TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD345.
    MOVE "^MODIFY PLANT ISSUER IDENTIFIERS ] "                                               TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD346.
    MOVE "^PROCESS GM EDI REMITTANCE ADVICE 820 ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PROCESSED LAST TIME ON] "                                                         TO TLN(3).
    MOVE "!ARE YOU SURE YOU WANT TO PROCESS THE FILE ?] ___ "                                TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!EDI FILE] _________          !A/R EFFECTIVE DATE] ______ "                        TO TLN(6).
    MOVE " "                                                                                 TO TLN(7).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD347.
    MOVE "^LIST GM EDI REMITTANCE ADVICE 820 ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!EDI FILE] _________          !PLANT ID] __ "                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD348.
    MOVE "^LIST AMERICAN AXLE REMITTANCE FILE ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION READS REMITTANCE FILE IN CSV FORMAT (COMMA-SEPARATED FIELDS), "      TO TLN(3).
    MOVE "  LISTS THE DATA, AND CONVERTS IT TO A DUMMY EDI 820 FILE TO BE PROCESSED "        TO TLN(4).
    MOVE "  THROUGH F-6 'PROCESS GM EDI REMITTANCE ADVICE 820 FILE'. "                       TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!EDI FILE] _________ "                                                             TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD349.
    MOVE "^SURCHARGE LISTING BY CUSTOMER ]  (ALSO EXPORT FILE) "                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CUSTOMER] ______       !TO CUSTOMER] ______ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD350.
    MOVE "^BROKER LISTING BY CUSTOMER ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CUSTOMER] ______       !TO CUSTOMER] ______ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD351.
    MOVE "^LIST BANK EDI LOCKBOX DEPOSIT 823 ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!EDI FILE] _________ "                                                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD352.
    MOVE "^PROCESS BANK EDI LOCKBOX DEPOSIT 823 ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!EDI FILE] _________          !A/R EFFECTIVE DATE] ______ "                        TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD353.
    MOVE "^GENERATE INVOICES DIRECTLY ] "                                                    TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD354.
    MOVE "^GENERATE INVOICES FROM ORDERS ] "                                                 TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD355.
    MOVE "^DELETE CHEQUES ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!US$ ?] ___ "                                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CHQ NO.   AMOUNT ] "                                                              TO TLN(5).
*          ______    ___________
    MOVE "?? "                                                                               TO TLN(6).

RD356.
    MOVE "^CHANGE DUE DATE ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!VENDOR  INVOICE            DUE DATE    NEW DATE ] "                               TO TLN(3).
    MOVE " ____    _______________                 ______ "                                  TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD357.
    MOVE "^MARK MAILED CHEQUES ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!US$ ?] ___ "                                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CHQ NO.   AMOUNT ] "                                                              TO TLN(5).
*          ______    ___________
    MOVE "?? "                                                                               TO TLN(6).

RD358.
    MOVE "^CANCEL CHEQUES ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!US$ ?] ___ "                                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CHQ NO.   AMOUNT ] "                                                              TO TLN(5).
*          ______    ___________
    MOVE "?? "                                                                               TO TLN(6).

RD359.
    MOVE "^MACHINE UTILIZATION REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MACHINE]  ____     !TO MACHINE]  ____ "                                      TO TLN(3).
    MOVE "!FROM CATEGORY] __       !TO CATEGORY] __ "                                        TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD360.
    MOVE "^MACHINE UTILIZATION ANALYSIS ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!REPORT PERIOD] ____________________ "                                             TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM MACHINE] ____     !TO MACHINE] ____ "                                        TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD361.
    MOVE "^CREATE EMPLOYEE TIME LABELS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PAYROLL DIVISION] __      !WEEK ENDING DATE] __________ "                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM EMPLOYEE] ____      !TO EMPLOYEE] ____ "                                     TO TLN(5).
    MOVE "                                                                       !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD362.
    MOVE "^CREATE EMPLOYEE ADDRESS LABELS ] "                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PAYROLL DIVISION] __ "                                                            TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!FROM EMPLOYEE] ____      !TO EMPLOYEE] ____"                                      TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!LABELS FILE NO.] __                                                   !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD363.
    MOVE "^SCRAP ANALYSIS (SECONDARY OPERATIONS) ] "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______      !TO DATE] ______ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD364.
    MOVE "^PRINT G/L CHART OF ACCOUNTS ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD365.
    MOVE "^MAINTENANCE DOWNTIME REPORT ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM DATE] ______ "                                                               TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD366.
    MOVE "^MACHINE PERFORMANCE ANALYSIS ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!YEAR](0-99) __    !MONTH](1-12) __ "                                              TO TLN(3).
    MOVE "!GENERATE YTD REPORT ?] ___  (OTHERWISE MONTHLY REPORT) "                          TO TLN(4).
    MOVE "                                                                       !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD367.
    MOVE "^PAYROLL WEEKLY SUMMARY REPORT ] "                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!WEEK START DATE (SUNDAY)] ______ "                                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD368.
    MOVE "^PRODUCT DEMAND REPORT ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CATEGORY] __      !TO CATEGORY] __ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD369.
    MOVE "^MONTH-END FILE UPDATE ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MONTH (1 - 12)] __         !FROM YEAR] __ "                                  TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO. FOR EXCEPTION REPORTS] __                              !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD370.
    MOVE "^SALESMAN COMMISSION REPORT ] "                                                    TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD371.
    MOVE "^PRODUCTS ON ORDER REPORT ] "                                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM CUSTOMER] ______       !TO CUSTOMER] ______ "                                TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!LIMIT DATE] ______ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD372.
    MOVE "^SALES BY PRODUCT TYPE REPORT ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRODUCT TYPE] ___      !CATEGORIES] __  __  __  __  __  __ "                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD373.
    MOVE "^PRODUCTION SHORT SCHEDULE REPORT ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!MACHINES] __ __ __ __ __ __ __ __ __ __ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!CONSIDER EACH MACHINE SEPARATELY ?] ___ "                                         TO TLN(5).
    MOVE "!'LH' OR 'HL' TO ORDER WIRE SIZE 'LOW TO HIGH' OR 'HIGH TO LOW'] __ "              TO TLN(6).
    MOVE "!LIMIT DATE] ______ "                                                              TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD374.
    MOVE "^OUTSTANDING INVOICES / CASH REQUIREMENTS ] "                                      TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!OUTSTANDING INVOICES REPORT ?] ___ "                                              TO TLN(3).
    MOVE "    OTHERWISE CASH REQUIREMENTS REPORT (ALSO EXPORT FILE) "                        TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD375.
    MOVE "^GENERATE CHEQUES ]  (ALSO EXPORT FILE) "                                          TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD376.
    MOVE "^OUTSTANDING CHEQUES REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!US$ ?] ___ "                                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD377.
    MOVE "^A/P AGE ANALYSIS ] "                                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!AGING DATE] ______ "                                                              TO TLN(3).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD378.
    MOVE "^GENERATE SUBCONTRACTOR INVOICES ] "                                               TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD379.
    MOVE "^VENDOR LISTING ]  (ALSO EXPORT FILE) "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM VENDOR] ____      !TO VENDOR] ____ "                                         TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD380.
    MOVE "^OPERATIONS REPORT (IRVINE TOOLS) ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD381.
    MOVE "^GENERATE SALES ORDERS (IRVINE TOOLS) ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION GENERATES TOOL SALES ORDERS TO IRVINE FASTENERS "                    TO TLN(3).
    MOVE "  BY READING THE PURCHASE ORDERS TO IRVINE TOOLS CREATED IN IRVINE FASTENERS. "    TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD382.
    MOVE "^PRODUCT PRICE LISTING ]  (ONLY EXPORT FILE) "                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!CUSTOMER NO.] ______ "                                                            TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD383.
    MOVE "^MAINTENANCE WORK-IN-PROCESS LISTING ] "                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD384.
    MOVE "^CREATE TOWER GROUP INTERNATIONAL INVOICE 810 FILE ] "                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION CREATES AN EDI 810 FILE FOR THIS CUSTOMS BROKER "                    TO TLN(3).
    MOVE "  REFLECTING THE INVOICES FOR SHIPMENTS TO CUSTOMERS THAT HAVE "                   TO TLN(4).
    MOVE "  THE EDI CUSTOMS FORM INDICATOR SET. "                                            TO TLN(5).
    MOVE "                                                                       !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD385.
    MOVE "^PRINT COMBINATION CUSTOMS FORMS ] "                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD386.
    MOVE "^MATERIAL DEMAND REPORT ] "                                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!INCLUDE SPECIALS ?] ___ "                                                         TO TLN(3).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD387.
    MOVE "^MATERIAL REQUIREMENTS REPORT ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!FROM MATERIAL] ____________     !TO MATERIAL] ____________ "                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD388.
    MOVE "^MATERIAL AGING REPORT ] "                                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!AGING DATE] ______ "                                                              TO TLN(3).
    MOVE "!TOTALS ONLY ?] ___ "                                                              TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD389.
    MOVE "^READ CLEANED COILS BIN FILE ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!EDI FILE] _________ "                                                             TO TLN(3).
    MOVE "!UPDATE FILES ?] ___  (OTHERWISE ONLY REPORT) "                                    TO TLN(4).
    MOVE "                                                                       !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD390.
    MOVE "^PHYSICAL INVENTORY TICKET LISTING ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD391.
    MOVE "^M.O. ADJUSTMENT AND REPORT ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!MODIFY FILES ?] ___  (OTHERWISE ONLY REPORT, NO ACTUAL ADJUSTMENT) "              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD392.
    MOVE "^SAVE CURRENT QUANTITY LEFT AND PRODUCED ] "                                       TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "THIS FUNCTION STORES IN SPECIAL FIELDS THE CURRENT QTY LEFT AND QTY PRODUCED "     TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                                       !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD393.
    MOVE "^PHYSICAL INVENTORY PRODUCT LISTING ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD394.
    MOVE "^RE-CREATE PHYSICAL INVENTORY FILE ] "                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!THE CURRENT PHYSICAL INVENTORY FILE WILL BE DELETED ] "                           TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!NO OTHER PHYSICAL INVENTORY FUNCTIONS SHOULD BE RUNNING AT THIS TIME ] "          TO TLN(5).
    MOVE " "                                                                                 TO TLN(6).
    MOVE "                                                                       !OK] __ "   TO TLN(7).
    MOVE "?? "                                                                               TO TLN(8).

RD395.
    MOVE "^UPDATE PRODUCT RECORDS FROM BINS ] "                                              TO TLN(1).
    MOVE "                                                                       !OK] __ "   TO TLN(2).
    MOVE "?? "                                                                               TO TLN(3).

RD396.
    MOVE "^UPDATE PART RECORDS FROM BINS ] "                                                 TO TLN(1).
    MOVE "                                                                       !OK] __ "   TO TLN(2).
    MOVE "?? "                                                                               TO TLN(3).

RD397.
    MOVE "^Q BINS LISTING ] "                                                                TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD398.
    MOVE "^LIST BACK INSERTS WITH NO ALTERNATES ] "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD399.
    MOVE "^TOOL USAGE EXCEPTION REPORT ] "                                                   TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD400.
    MOVE "^TOOL USAGE HISTORY REPORT ]  (ONLY EXPORT FILE) "                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD401.
    MOVE "^MATERIAL CLEANING REQUIREMENTS REPORT ] "                                         TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!REQUIREMENT DAYS] _ "                                                             TO TLN(3).
    MOVE "                                                                       !OK] __ "   TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD402.
    MOVE "^PRINT DAILY MATERIAL CLEANING SLIP ] "                                            TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!DATE] ______ "                                                                    TO TLN(3).
    MOVE "                                                                       !OK] __ "   TO TLN(4).
    MOVE "?? "                                                                               TO TLN(5).

RD403.
    MOVE "^MODIFY M.O. 'MATERIAL ALLOCATED' INDICATOR ] "                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!M.O.] ______     !MATERIAL ALLOCATED] _   (0:NO   1:YES   2:FINAL) "              TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD404.
    MOVE "^SALES JOURNAL ] "                                                                 TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD405.
    MOVE "^PRINT USER TABLES ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD406.
    MOVE "^DAILY FILE UPDATE ] "                                                             TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO. FOR UPDATE REPORT] __                                  !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD407.
    MOVE "^GENERATE PRODUCTION ORDERS ] "                                                    TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO. FOR EXCEPTIONS REPORT] __                              !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD408.
    MOVE "^PRODUCT ALTERNATES REPORT ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD409.
    MOVE "^PRINT ORDER ACKNOWLEDGEMENTS ] "                                                  TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!TO PRINT ONLY ONE SPECIFIC ORDER, ENTER ORDER NO.] ______ "                       TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD410.
    MOVE "^CUSTOMER LISTING ]  (ONLY EXPORT FILE) "                                          TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD411.
    MOVE "^PRODUCT LISTING BY CLEANING CODE ] "                                              TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(3).
    MOVE "?? "                                                                               TO TLN(4).

RD412.
    MOVE "^WORK IN PROGRESS REPORT (IRVINE TOOLS) ] "                                        TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!LIMIT DATE] ______ "                                                              TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!PRINT FILE NO.] __                                                    !OK] __ "   TO TLN(5).
    MOVE "?? "                                                                               TO TLN(6).

RD413.
    MOVE "^USER AUTHORIZATION TABLES ] "                                                     TO TLN(1).
    MOVE "?? "                                                                               TO TLN(2).

RD413A. MOVE 3 TO TSTART.
    MOVE "!USER] ____________      !FUNCTION] _    1. ADD USER TABLES "                      TO TLN(3).
    MOVE "                                         2. MODIFY USER TABLES "                   TO TLN(4).
    MOVE "                                         3. DELETE USER TABLES "                   TO TLN(5).
    MOVE "                                         4. MODIFY USER NAME "                     TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD414.
    MOVE "^USER DATA ] "                                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "!USER] ____________        !PC] _   '0' IF VT TERMINAL, '1' IF PC "                TO TLN(3).
    MOVE "                        !PRINT] __  'PR', 'PA', 'PB'  (PRINT FILE PREFIX) "        TO TLN(4).
    MOVE " "                                                                                 TO TLN(5).
    MOVE "!FIELDS PERMITTED IN FILE MAINTENANCE] "                                           TO TLN(6).
    MOVE "(IF NO FIELDS ARE SPECIFIED, ALL ARE PERMITTED) "                                  TO TLN(7).
    MOVE " "                                                                                 TO TLN(8).
    MOVE "  !CUSTOMER FILE]  __ __ __ __ __ __ __ __ __ __ "                                 TO TLN(9).
    MOVE "  !PRODUCT FILE ]  __ __ __ __ __ __ __ __ __ __ "                                 TO TLN(10).
    MOVE "?? "                                                                               TO TLN(11).

RD415.
    MOVE "^EMPLOYEE FILE MAINTENANCE ] "                                                     TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^EMPL. NO.] ____                ^FUNCTION] _       ^FUNCTIONS               ] "    TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "                                                   1. ADD RECORD "                 TO TLN(5).
    MOVE "                                                   2. DISPLAY / CHANGE RECORD "    TO TLN(6).
    MOVE "                                                   3. DELETE RECORD "              TO TLN(7).
    MOVE "                                                   7. CHANGE EMPLOYEE NO. "        TO TLN(8).
    MOVE "                                                   9. END "                        TO TLN(9).
    MOVE "?? "                                                                               TO TLN(10).

RD416.
    MOVE "^ADD EMPLOYEE RECORD ] "                                                           TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^EMPL. NO.] "                                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE "!NAME        ] ______________________________ "                                    TO TLN(5).
    MOVE "!ADDRESS 1   ] ______________________________ "                                    TO TLN(6).
    MOVE "!ADDRESS 2   ] ________________________ "                                          TO TLN(7).
    MOVE "!POSTAL CODE ] _______ "                                                           TO TLN(8).
    MOVE "?? "                                                                               TO TLN(9).

RD417.
    MOVE "^EMPLOYEE RECORD ] "                                                               TO TLN(1).
    MOVE " "                                                                                 TO TLN(2).
    MOVE "^EMPL. NO.] "                                                                      TO TLN(3).
    MOVE " "                                                                                 TO TLN(4).
    MOVE " 1. NAME             2. ADDRESS LINE 1   3. ADDRESS LINE 2   4. POSTAL CODE "      TO TLN(5).
    MOVE " 5. DEPARTMENT       6. SECTOR           7. DELETE IND "                           TO TLN(6).
    MOVE "?? "                                                                               TO TLN(7).

RD417A. MOVE 20 TO TSTART.
    MOVE "^CHANGE FIELD NO. ] __       _ "                                                   TO TLN(20).
    MOVE "^NEW VALUE        ]          _ "                                                   TO TLN(21).
    MOVE "?? "                                                                               TO TLN(22).

* ...

* note 107.1
RD801X.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:] "                                       TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "?? "                                                                                                                                   TO TLNW(3).

RD801A1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!DRAW DIE:]____________    !FEEDROLLS:]____________!/]____________    !QUILL:]____________ "                                           TO TLNW(4).
    MOVE "!CUTTER:]____________    !CUTTER HOLDER:]____________ "                                                                                TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________ "                                                                               TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^1ST DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(9).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(10).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(11).
    MOVE "?? "                                                                                                                                   TO TLNW(12).

RD801A2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(4).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^2ND PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(7).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^THREADER TOOLS:]   !INNER GUIDE TIP:]____________ "                                                                                   TO TLNW(10).
    MOVE "                    !THREAD DIES:]____________!/]____________    !KNURL DIES:]____________!/]____________ "                            TO TLNW(11).
    MOVE "?? "                                                                                                                                   TO TLNW(12).

RD801B1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!DRAW DIE:]____________    !FEEDROLLS:]____________!/]____________    !QUILL:]____________ "                                           TO TLNW(4).
    MOVE "!CUTTER:]____________    !CUTTER HOLDER:]____________ "                                                                                TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________    !2ND:]____________!/]____________ "                                          TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^1ST DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(9).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(10).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________!/]____________     !SLEEVE:]____________ "                                TO TLNW(11).
    MOVE "           !INTERMEDIATE ROD:]____________    !ASSEMBLED PIN:]____________     !ASSEMBLED DIE:]____________ "                          TO TLNW(12).
    MOVE " "                                                                                                                                     TO TLNW(13).
    MOVE "^2ND DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(14).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________     !NUT:]____________    !BACKPLATE:]____________ "  TO TLNW(15).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________!/]____________     !SLEEVE:]____________ "                                TO TLNW(16).
    MOVE "           !INTERMEDIATE ROD:]____________    !ASSEMBLED PIN:]____________     !ASSEMBLED DIE:]____________ "                          TO TLNW(17).
    MOVE "?? "                                                                                                                                   TO TLNW(18).

RD801B2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(4).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^2ND PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(7).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^3RD PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(10).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "!TRIM DIE:]____________    !FILLER:]____________    !CASE:]____________ "                                                              TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^THREADER TOOLS:]   !INNER GUIDE TIP:]____________ "                                                                                   TO TLNW(15).
    MOVE "                    !THREAD DIES:]____________!/]____________    !KNURL DIES:]____________!/]____________ "                            TO TLNW(16).
    MOVE "?? "                                                                                                                                   TO TLNW(17).

RD801C1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!DRAW DIE:]____________    !FEEDROLLS:]____________!/]____________    !QUILL:]____________    !CUTTER:]____________ "                  TO TLNW(4).
    MOVE "                                                                            !POINTER DIES:]____________    !GRIP JAWS:]____________ "  TO TLNW(5).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________    !2ND:]____________!/]____________ "                                          TO TLNW(6).
    MOVE "                     !3RD:]____________!/]____________    !4TH:]____________!/]____________ "                                          TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^1ST DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(9).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(10).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(11).
    MOVE "^2ND DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(12).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________     !NUT:]____________    !BACKPLATE:]____________ "  TO TLNW(13).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(14).
    MOVE "^3RD DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(15).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(16).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________    !NUT:]____________      !ASSEMBLED DIE:]____________ "                 TO TLNW(17).
    MOVE "^4TH DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(18).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(19).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(20).
    MOVE " "                                                                                                                                     TO TLNW(21).
    MOVE "!TRIM PUNCH:]____________    !MIDDLE:]____________    !CASE:]____________ "                                                            TO TLNW(22).
    MOVE "!BACKPLATE:]____________     !K.O. PIN:]____________    !BUTTONS:]____________ "                                                       TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD801C2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(4).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^2ND PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(7).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^3RD PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(10).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "^4TH PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(13).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(14).
    MOVE " "                                                                                                                                     TO TLNW(15).
    MOVE "!TRIM DIE:]____________    !FILLER:]____________    !CASE:]____________ "                                                              TO TLNW(16).
    MOVE " "                                                                                                                                     TO TLNW(17).
    MOVE "^THREADER TOOLS:]   !INNER GUIDE TIP:]____________ "                                                                                   TO TLNW(18).
    MOVE "                    !THREAD DIES:]____________!/]____________    !KNURL DIES:]____________!/]____________ "                            TO TLNW(19).
    MOVE "?? "                                                                                                                                   TO TLNW(20).

RD801D1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!DRAW DIE:]____________    !FEEDROLLS:]____________!/]____________    !QUILL:]____________    !CUTTER:]____________ "                  TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________    !2ND:]____________!/]____________ "                                          TO TLNW(6).
    MOVE "                     !3RD:]____________!/]____________ "                                                                               TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^1ST DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(9).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________ "                                                     TO TLNW(10).
    MOVE "           !K.O. PIN:]____________     !ASSEMBLED DIE:]____________ "                                                                  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "^2ND DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(13).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________ "                                                     TO TLNW(14).
    MOVE "           !K.O. PIN:]____________     !ASSEMBLED DIE:]____________ "                                                                  TO TLNW(15).
    MOVE " "                                                                                                                                     TO TLNW(16).
    MOVE "^3RD DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(17).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________ "                                                     TO TLNW(18).
    MOVE "           !K.O. PIN:]____________    !NUT:]____________      !ASSEMBLED DIE:]____________ "                                           TO TLNW(19).
    MOVE " "                                                                                                                                     TO TLNW(20).
    MOVE "!TRIM PUNCH:]____________    !MIDDLE:]____________    !CASE:]____________    !NUT:]____________ "                                      TO TLNW(21).
    MOVE "!BACKPLATE:]____________     !K.O. PIN:]____________ "                                                                                 TO TLNW(22).
    MOVE "?? "                                                                                                                                   TO TLNW(23).

RD801D2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(4).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^2ND PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(7).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^3RD PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(10).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "!TRIM DIE:]____________    !FILLER:]____________    !CASE:]____________ "                                                              TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^THREADER TOOLS:]   !INNER GUIDE TIP:]____________ "                                                                                   TO TLNW(15).
    MOVE "                    !THREAD DIES:]____________!/]____________    !KNURL DIES:]____________!/]____________ "                            TO TLNW(16).
    MOVE "?? "                                                                                                                                   TO TLNW(17).

RD801E1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!DRAW DIE:]____________    !FEEDROLLS:]____________!/]____________    !QUILL:]____________    !CUTTER:]____________ "                  TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________    !2ND:]____________!/]____________ "                                          TO TLNW(6).
    MOVE "                     !3RD:]____________!/]____________    !4TH:]____________!/]____________ "                                          TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^1ST DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(9).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(10).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(11).
    MOVE "^2ND DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(12).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________     !NUT:]____________    !BACKPLATE:]____________ "  TO TLNW(13).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(14).
    MOVE "^3RD DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(15).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(16).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________    !NUT:]____________      !ASSEMBLED DIE:]____________ "                 TO TLNW(17).
    MOVE "^4TH DIE:] !FRONT INSERT:]____________    !MIDDLE INSERTS:]____________!/]____________    !POINTER:]____________ "                     TO TLNW(18).
    MOVE "           !BACK INSERTS:]____________!/]____________    !DIE CASE:]____________    !BACKPLATE:]____________ "                         TO TLNW(19).
    MOVE "           !K.O. PIN:]____________    !BUTTONS:]____________     !ASSEMBLED DIE:]____________ "                                        TO TLNW(20).
    MOVE " "                                                                                                                                     TO TLNW(21).
    MOVE "!TRIM PUNCH:]____________    !MIDDLE:]____________    !CASE:]____________    !NUT:]____________ "                                      TO TLNW(22).
    MOVE "!BACKPLATE:]____________     !K.O. PIN:]____________    !BUTTONS:]____________ "                                                       TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD801E2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(4).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^2ND PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(7).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^3RD PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________ "                                                           TO TLNW(10).
    MOVE "               !PIN:]____________    !PLUG:]____________    !ASSEMBLY:]____________ "                                                  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "!TRIM DIE:]____________    !FILLER:]____________    !CASE:]____________ "                                                              TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^POINTER TOOLS:]    !PLATE:]____________    !GUIDE TIP:]____________    !SPECIAL CUTTER HOLDER:]____________ "                         TO TLNW(15).
    MOVE "^GRIP JAWS:]   !STATIONARY:]____________    !MOVABLE:]____________    !BLOCK:]____________ "                                           TO TLNW(16).
    MOVE " "                                                                                                                                     TO TLNW(17).
    MOVE "^THREADER TOOLS:]   !INNER GUIDE TIP:]____________    !OUTER GUIDE TIP:]____________ "                                                 TO TLNW(18).
    MOVE "                    !THREAD DIES:]____________!/]____________    !KNURL DIES:]____________!/]____________ "                            TO TLNW(19).
    MOVE "?? "                                                                                                                                   TO TLNW(20).

RD802.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:] "                                       TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST STATION:]  !DIE:]____________     !PUNCH:]____________     !EJECTOR:]____________ "                                               TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE "^2ND STATION:]  !DIE:]____________     !PUNCH PIN:]____________     !BACKING PUNCH:]____________     !CROWNER:]____________ "          TO TLNW(6).
    MOVE "                !EJECTOR SLEEVE:]____________     !WASHER FACE INSERT:]____________     !SLOTTED KEY:]____________ "                   TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^3RD STATION:]  !PIERCING DIE:]____________     !PIERCING PUNCH:]____________ "                                                        TO TLNW(9).
    MOVE " "                                                                                                                                     TO TLNW(10).
    MOVE "!NIB TAP:]____________    !TAP SHANK:]____________     !COUPLER:]____________ "                                                        TO TLNW(11).
    MOVE "?? "                                                                                                                                   TO TLNW(12).

RD803A1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "!DRAW DIE:]____________     !QUILL:]____________     !CUTTER:]____________     !UPPER/LOWER FEEDBLOCK:]____________!/]____________ "   TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^1ST DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(5).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(6).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !BUTTON DISC:]____________ "            TO TLNW(7).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !K.O. BUTTON:]____________        !FILLER DISC:]____________ "            TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^2ND DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(10).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(11).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !BUTTON DISC:]____________ "            TO TLNW(12).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !K.O. BUTTON:]____________        !FILLER DISC:]____________ "            TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^3RD DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(15).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(16).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !BUTTON DISC:]____________ "            TO TLNW(17).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !K.O. BUTTON:]____________        !FILLER DISC:]____________ "            TO TLNW(18).
    MOVE " "                                                                                                                                     TO TLNW(19).
    MOVE "^4TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(20).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________        !BUTTON DISC:]____________ "            TO TLNW(21).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !EJECTOR PIN:]____________ "            TO TLNW(22).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !K.O. BUTTON:]____________        !FILLER DISC:]____________ "            TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD803A2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(4).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(5).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(6).
    MOVE " "                                                                                                                                     TO TLNW(7).
    MOVE "^2ND PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(8).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(9).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^3RD PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(12).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(13).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(14).
    MOVE " "                                                                                                                                     TO TLNW(15).
    MOVE "^4TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(16).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(17).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(18).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(19).
    MOVE " "                                                                                                                                     TO TLNW(20).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________   !2ND:]____________!/]____________ "                                           TO TLNW(21).
    MOVE "                     !3RD:]____________!/]____________   !4TH:]____________!/]____________ "                                           TO TLNW(22).
    MOVE "?? "                                                                                                                                   TO TLNW(23).

RD803A3.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 3]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^POINTER TOOLS:]  !UPPER GUIDE:]____________   !REAR UPPER GUIDE:]____________   !PLATE:]____________   !FILLER BLOCK:]____________ "  TO TLNW(4).
    MOVE "                  !STATIONARY JAW:]____________    !MOVABLE JAW:]____________ "                                                        TO TLNW(5).
    MOVE "                  !POINTER INJ. FINGER:]____________    !HOOK FINGER:]____________ "                                                   TO TLNW(6).
    MOVE "                  !SEPARATOR PIN:]____________    !PRESS PIN:]____________    !PRESS PIN HOLDER:]____________ "                        TO TLNW(7).
    MOVE "                  !PUSHER GUIDE:]____________    !SEPARATOR GUIDE:]____________ "                                                      TO TLNW(8).
    MOVE "                  !INSIDE DISCHARGE RAIL:]____________    !OUTSIDE DISCHARGE RAIL:]____________ "                                      TO TLNW(9).
    MOVE "                  !CUTTER HOLDER:]____________!/]____________    !CUTTER INSERT]____________!/]____________ "                          TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^THREADER TOOLS:] !INNER GUIDE TIP:]____________    !OUTER GUIDE TIP:]____________    !THREADER INJECTOR:]____________ "               TO TLNW(12).
    MOVE "                  !THREAD DIES:]____________!/]____________ "                                                                          TO TLNW(13).
    MOVE "                  !KNURL DIES:]____________!/]____________!/]____________!/]____________ "                                             TO TLNW(14).
    MOVE "                  !THREAD DIE SPACERS:]____________!/]____________    !KNURL DIE SPACERS:]____________!/]____________ "                TO TLNW(15).
    MOVE "?? "                                                                                                                                   TO TLNW(16).

RD803B1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "!DRAW DIE:]____________     !QUILL:]____________     !CUTTER:]____________     !FEEDROLLS:]____________ "                              TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^1ST DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(5).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(6).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(7).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^2ND DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(10).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(11).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(12).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^3RD DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(15).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(16).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(17).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(18).
    MOVE " "                                                                                                                                     TO TLNW(19).
    MOVE "^4TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(20).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(21).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !EJECTOR PIN:]____________ "            TO TLNW(22).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD803B2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(4).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(5).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(6).
    MOVE " "                                                                                                                                     TO TLNW(7).
    MOVE "^2ND PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(8).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(9).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^3RD PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(12).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(13).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(14).
    MOVE " "                                                                                                                                     TO TLNW(15).
    MOVE "^4TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(16).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(17).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(18).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(19).
    MOVE " "                                                                                                                                     TO TLNW(20).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________   !2ND:]____________!/]____________ "                                           TO TLNW(21).
    MOVE "                     !3RD:]____________!/]____________   !4TH:]____________!/]____________ "                                           TO TLNW(22).
    MOVE "?? "                                                                                                                                   TO TLNW(23).

RD803B3.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 3]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^POINTER TOOLS:]  !UPPER GUIDE:]____________   !REAR UPPER GUIDE:]____________   !PLATE:]____________   !FILLER BLOCK:]____________ "  TO TLNW(4).
    MOVE "                  !STATIONARY JAW:]____________    !MOVABLE JAW:]____________ "                                                        TO TLNW(5).
    MOVE "                  !POINTER INJ. FINGER:]____________    !HOOK FINGER:]____________ "                                                   TO TLNW(6).
    MOVE "                  !SEPARATOR PIN:]____________    !PRESS PIN:]____________    !PRESS PIN HOLDER:]____________ "                        TO TLNW(7).
    MOVE "                  !PUSHER GUIDE:]____________    !SEPARATOR GUIDE:]____________ "                                                      TO TLNW(8).
    MOVE "                  !INSIDE DISCHARGE RAIL:]____________    !OUTSIDE DISCHARGE RAIL:]____________ "                                      TO TLNW(9).
    MOVE "                  !CUTTER HOLDER:]____________!/]____________    !CUTTER INSERT]____________!/]____________ "                          TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^THREADER TOOLS:] !INNER GUIDE TOP:]____________    !INNER GUIDE BOTTOM:]____________    !OUTER GUIDE TIP:]____________ "              TO TLNW(12).
    MOVE "                  !THREADER SEPARATOR:]____________    !CARRIER FINGER:]____________    !STARTER PUSHER:]____________ "                TO TLNW(13).
    MOVE "                  !THREAD DIES:]____________!/]____________ "                                                                          TO TLNW(14).
    MOVE "                  !KNURL DIES:]____________!/]____________!/]____________!/]____________ "                                             TO TLNW(15).
    MOVE "                  !THREAD DIE SPACERS:]____________!/]____________    !KNURL DIE SPACERS:]____________!/]____________ "                TO TLNW(16).
    MOVE "?? "                                                                                                                                   TO TLNW(17).

RD803C1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "!DRAW DIE:]____________     !QUILL:]____________     !CUTTER:]____________     !UPPER/LOWER FEEDBLOCK:]____________!/]____________ "   TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^1ST DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(5).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(6).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(7).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^2ND DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(10).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(11).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(12).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^3RD DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(15).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(16).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(17).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(18).
    MOVE " "                                                                                                                                     TO TLNW(19).
    MOVE "^4TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(20).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________       !DIE CASE:]____________ "                                              TO TLNW(21).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !EJECTOR PIN:]____________ "            TO TLNW(22).
    MOVE "            !BACK    INSERTS:]____________!/]____________    !FILLER DISC:]____________ "                                              TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD803C2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^1ST PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(4).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(5).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(6).
    MOVE " "                                                                                                                                     TO TLNW(7).
    MOVE "^2ND PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(8).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(9).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^3RD PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(12).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(13).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(14).
    MOVE " "                                                                                                                                     TO TLNW(15).
    MOVE "^4TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(16).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(17).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(18).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(19).
    MOVE " "                                                                                                                                     TO TLNW(20).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________   !2ND:]____________!/]____________ "                                           TO TLNW(21).
    MOVE "                     !3RD:]____________!/]____________   !4TH:]____________!/]____________ "                                           TO TLNW(22).
    MOVE "?? "                                                                                                                                   TO TLNW(23).

RD803C3.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 3]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^POINTER TOOLS:]  !UPPER GUIDE:]____________   !REAR UPPER GUIDE:]____________   !PLATE:]____________   !FILLER BLOCK:]____________ "  TO TLNW(4).
    MOVE "                  !STATIONARY JAW:]____________    !MOVABLE JAW:]____________ "                                                        TO TLNW(5).
    MOVE "                  !POINTER INJ. FINGER:]____________    !HOOK FINGER:]____________ "                                                   TO TLNW(6).
    MOVE "                  !SEPARATOR PIN:]____________    !PRESS PIN:]____________    !PRESS PIN HOLDER:]____________ "                        TO TLNW(7).
    MOVE "                  !PUSHER GUIDE:]____________    !SEPARATOR GUIDE:]____________ "                                                      TO TLNW(8).
    MOVE "                  !INSIDE DISCHARGE RAIL:]____________    !OUTSIDE DISCHARGE RAIL:]____________ "                                      TO TLNW(9).
    MOVE "                  !CUTTER HOLDER:]____________!/]____________    !CUTTER INSERT]____________!/]____________ "                          TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^THREADER TOOLS:] !INNER GUIDE TIP:]____________    !OUTER GUIDE TIP:]____________    !THREADER INJECTOR:]____________ "               TO TLNW(12).
    MOVE "                  !THREAD DIES:]____________!/]____________ "                                                                          TO TLNW(13).
    MOVE "                  !KNURL DIES:]____________!/]____________!/]____________!/]____________ "                                             TO TLNW(14).
    MOVE "                  !THREAD DIE SPACERS:]____________!/]____________    !KNURL DIE SPACERS:]____________!/]____________ "                TO TLNW(15).
    MOVE "?? "                                                                                                                                   TO TLNW(16).

RD803D1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "!DRAW DIE:]____________     !QUILL:]____________     !CUTTER:]____________     !UPPER/LOWER FEEDBLOCK:]____________!/]____________ "   TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^1ST DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(5).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(6).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(7).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^2ND DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(10).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(11).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(12).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^3RD DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(15).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(16).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(17).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(18).
    MOVE " "                                                                                                                                     TO TLNW(19).
    MOVE "^4TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(20).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(21).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(22).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD803D2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^5TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(4).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(5).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !EJECTOR PIN:]____________ "            TO TLNW(6).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^1ST PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(9).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(10).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "^2ND PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(13).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(14).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(15).
    MOVE " "                                                                                                                                     TO TLNW(16).
    MOVE "^3RD PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(17).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(18).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(19).
    MOVE "?? "                                                                                                                                   TO TLNW(20).

RD803D3.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 3]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^4TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(4).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(5).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(6).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^5TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(9).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(10).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(11).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(12).
    MOVE " "                                                                                                                                     TO TLNW(13).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________   !2ND:]____________!/]____________ "                                           TO TLNW(14).
    MOVE "                     !3RD:]____________!/]____________   !4TH:]____________!/]____________   !5TH:]____________!/]____________ "       TO TLNW(15).
    MOVE "?? "                                                                                                                                   TO TLNW(16).

RD803D4.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 4]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^POINTER TOOLS:]  !UPPER GUIDE:]____________   !REAR UPPER GUIDE:]____________   !PLATE:]____________   !FILLER BLOCK:]____________ "  TO TLNW(4).
    MOVE "                  !STATIONARY JAW:]____________    !MOVABLE JAW:]____________ "                                                        TO TLNW(5).
    MOVE "                  !POINTER INJ. FINGER:]____________    !HOOK FINGER:]____________ "                                                   TO TLNW(6).
    MOVE "                  !SEPARATOR PIN:]____________    !PRESS PIN:]____________    !PRESS PIN HOLDER:]____________ "                        TO TLNW(7).
    MOVE "                  !PUSHER GUIDE:]____________    !SEPARATOR GUIDE:]____________ "                                                      TO TLNW(8).
    MOVE "                  !INSIDE DISCHARGE RAIL:]____________    !OUTSIDE DISCHARGE RAIL:]____________ "                                      TO TLNW(9).
    MOVE "                  !CUTTER HOLDER:]____________!/]____________    !CUTTER INSERT]____________!/]____________ "                          TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^THREADER TOOLS:] !INNER GUIDE TOP:]____________    !INNER GUIDE BOTTOM:]____________    !OUTER GUIDE TIP:]____________ "              TO TLNW(12).
    MOVE "                  !THREADER SEPARATOR:]____________    !CARRIER FINGER:]____________    !STARTER PUSHER:]____________ "                TO TLNW(13).
    MOVE "                  !THREAD DIE WEAR PLATE:]____________    !THREAD DIES:]____________!/]____________ "                                  TO TLNW(14).
    MOVE "                  !TOP DIE SPACERS:]____________!/]____________    !BOTTOM DIE SPACERS:]____________!/]____________ "                  TO TLNW(15).
    MOVE "                  !KNURL DIES:]____________!/]____________!/]____________!/]____________ "                                             TO TLNW(16).
    MOVE "                  !TOP KNURL DIE SPACERS:]____________!/]____________ "                                                                TO TLNW(17).
    MOVE "?? "                                                                                                                                   TO TLNW(18).

RD803E1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "!DRAW DIE:]____________     !QUILL:]____________     !CUTTER:]____________     !UPPER/LOWER FEEDBLOCK:]____________!/]____________ "   TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^1ST DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(5).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(6).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(7).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^2ND DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(10).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(11).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(12).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^3RD DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(15).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(16).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(17).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(18).
    MOVE " "                                                                                                                                     TO TLNW(19).
    MOVE "^4TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(20).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(21).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(22).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD803E2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^5TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(4).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(5).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________ "                                              TO TLNW(6).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(7).
    MOVE " "                                                                                                                                     TO TLNW(8).
    MOVE "^6TH DIE:]  !FRONT   INSERTS:]____________!/]____________     !DIE SLEEVE:]____________      !ASSEMBLED DIE:]____________ "            TO TLNW(9).
    MOVE "            !MIDDLE  INSERTS:]____________!/]____________!/]____________                          !DIE CASE:]____________ "            TO TLNW(10).
    MOVE "            !POINTER INSERTS:]____________!/]____________       !K.O. PIN:]____________        !EJECTOR PIN:]____________ "            TO TLNW(11).
    MOVE "            !BACK    INSERTS:]____________!/]____________!/]____________                       !FILLER DISC:]____________ "            TO TLNW(12).
    MOVE " "                                                                                                                                     TO TLNW(13).
    MOVE "^1ST PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(14).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(15).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(16).
    MOVE " "                                                                                                                                     TO TLNW(17).
    MOVE "^2ND PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(18).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(19).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(20).
    MOVE "?? "                                                                                                                                   TO TLNW(21).

RD803E3.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 3]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^3RD PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(4).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(5).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(6).
    MOVE " "                                                                                                                                     TO TLNW(7).
    MOVE "^4TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(8).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(9).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________    !ASSEMBLY:]____________ "  TO TLNW(10).
    MOVE " "                                                                                                                                     TO TLNW(11).
    MOVE "^5TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(12).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(13).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(14).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(15).
    MOVE " "                                                                                                                                     TO TLNW(16).
    MOVE "^6TH PUNCH:]  !FRONT INSERT:]____________        !FILLER:]____________         !PUNCH CASE:]____________ "                             TO TLNW(17).
    MOVE "               !BACK INSERT:]____________     !BACKPLATE:]____________     !FILLER BUSHING:]____________ "                             TO TLNW(18).
    MOVE "                 !PUNCH PIN:]____________    !P.K.O. PIN:]____________       !FILLER BLOCK:]____________ "                             TO TLNW(19).
    MOVE "       !PUNCH INSERT SLEEVE:]____________    !FILLER PIN:]____________             !SPRING:]____________    !ASSEMBLY:]____________ "  TO TLNW(20).
    MOVE "?? "                                                                                                                                   TO TLNW(21).

RD803E4.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 4]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________   !2ND:]____________!/]____________   !3RD:]____________!/]____________ "       TO TLNW(4).
    MOVE "                     !4TH:]____________!/]____________   !5TH:]____________!/]____________   !6TH:]____________!/]____________ "       TO TLNW(5).
    MOVE " "                                                                                                                                     TO TLNW(6).
    MOVE "^POINTER TOOLS:]  !UPPER GUIDE:]____________   !REAR UPPER GUIDE:]____________   !PLATE:]____________   !FILLER BLOCK:]____________ "  TO TLNW(7).
    MOVE "                  !STATIONARY JAW:]____________    !MOVABLE JAW:]____________ "                                                        TO TLNW(8).
    MOVE "                  !POINTER INJ. FINGER:]____________    !HOOK FINGER:]____________ "                                                   TO TLNW(9).
    MOVE "                  !SEPARATOR PIN:]____________    !PRESS PIN:]____________    !PRESS PIN HOLDER:]____________ "                        TO TLNW(10).
    MOVE "                  !PUSHER GUIDE:]____________    !SEPARATOR GUIDE:]____________ "                                                      TO TLNW(11).
    MOVE "                  !INSIDE DISCHARGE RAIL:]____________    !OUTSIDE DISCHARGE RAIL:]____________ "                                      TO TLNW(12).
    MOVE "                  !CUTTER HOLDER:]____________!/]____________    !CUTTER INSERT]____________!/]____________ "                          TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^THREADER TOOLS:] !INNER GUIDE TOP:]____________    !INNER GUIDE BOTTOM:]____________    !OUTER GUIDE TIP:]____________ "              TO TLNW(15).
    MOVE "                  !THREADER SEPARATOR:]____________    !CARRIER FINGER:]____________    !STARTER PUSHER:]____________ "                TO TLNW(16).
    MOVE "                  !THREAD DIE WEAR PLATE:]____________    !THREAD DIES:]____________!/]____________ "                                  TO TLNW(17).
    MOVE "                  !TOP DIE SPACERS:]____________!/]____________    !BOTTOM DIE SPACERS:]____________!/]____________ "                  TO TLNW(18).
    MOVE "                  !KNURL DIES:]____________!/]____________!/]____________!/]____________ "                                             TO TLNW(19).
    MOVE "                  !TOP KNURL DIE SPACERS:]____________!/]____________ "                                                                TO TLNW(20).
    MOVE "?? "                                                                                                                                   TO TLNW(21).

RD804.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!THREAD DIES:]____________!/]____________ "                                                                                            TO TLNW(4).
    MOVE "?? "                                                                                                                                   TO TLNW(5).

RD805.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "!THREAD DIES:]____________!/]____________ "                                                                                            TO TLNW(4).
    MOVE " "                                                                                                                                     TO TLNW(5).
    MOVE "!NIB TAP:]____________    !TAP SHANK:]____________     !COUPLER:]____________ "                                                        TO TLNW(6).
    MOVE "?? "                                                                                                                                   TO TLNW(7).

RD806A1.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 1]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE "!DRAW DIE:]____________    !FEEDROLLS:]____________    !QUILL:]____________    !CUTTER:]____________ "                                 TO TLNW(3).
    MOVE " "                                                                                                                                     TO TLNW(4).
    MOVE "^1ST DIE:] !FRONT INSERT:]____________    !MIDDLE INSERT:]____________    !BACK INSERT:]____________ "                                 TO TLNW(5).
    MOVE "           !IDLE:]____________!/]____________    !MIDDLE:]____________    !BACK:]____________!/]____________ "                         TO TLNW(6).
    MOVE "           !SLEEVE:]____________     !NUT:]____________    !FILLER:]____________    !DIE CASE:]____________ "                          TO TLNW(7).
    MOVE "           !K.O. PIN:]____________    !SEGMENTS:]____________    !CROSS PIN:]____________    !ASSEMBLED DIE:]____________ "            TO TLNW(8).
    MOVE " "                                                                                                                                     TO TLNW(9).
    MOVE "^2ND DIE:] !FRONT INSERT:]____________    !MIDDLE INSERT:]____________    !BACK INSERT:]____________ "                                 TO TLNW(10).
    MOVE "           !IDLE:]____________!/]____________    !POINTER:]____________   !BACK:]____________!/]____________ "                         TO TLNW(11).
    MOVE "           !SLEEVE:]____________     !NUT:]____________    !FILLER:]____________    !DIE CASE:]____________ "                          TO TLNW(12).
    MOVE "           !K.O. PIN:]____________    !SEGMENTS:]____________    !CROSS PIN:]____________    !ASSEMBLED DIE:]____________ "            TO TLNW(13).
    MOVE " "                                                                                                                                     TO TLNW(14).
    MOVE "^3RD DIE:] !FRONT INSERT:]____________    !MIDDLE INSERT:]____________    !BACK INSERT:]____________ "                                 TO TLNW(15).
    MOVE "           !IDLE:]____________!/]____________    !MIDDLE:]____________    !BACK:]____________!/]____________ "                         TO TLNW(16).
    MOVE "           !SLEEVE:]____________     !NUT:]____________    !FILLER:]____________    !DIE CASE:]____________ "                          TO TLNW(17).
    MOVE "           !K.O. PIN:]____________    !SEGMENTS:]____________    !CROSS PIN:]____________    !ASSEMBLED DIE:]____________ "            TO TLNW(18).
    MOVE " "                                                                                                                                     TO TLNW(19).
    MOVE "^4TH DIE:] !FRONT INSERT:]____________    !MIDDLE INSERT:]____________    !BACK INSERT:]____________ "                                 TO TLNW(20).
    MOVE "           !IDLE:]____________!/]____________    !MIDDLE:]____________    !BACK:]____________!/]____________ "                         TO TLNW(21).
    MOVE "           !SLEEVE:]____________     !NUT:]____________    !FILLER:]____________    !DIE CASE:]____________ "                          TO TLNW(22).
    MOVE "           !K.O. PIN:]____________    !SEGMENTS:]____________    !CROSS PIN:]____________    !ASSEMBLED DIE:]____________ "            TO TLNW(23).
    MOVE "?? "                                                                                                                                   TO TLNW(24).

RD806A2.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 2]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^4TH STATION:] !TRIM PUNCH:]____________    !FILLER:]____________!/]____________ "                                                     TO TLNW(4).
    MOVE "               !SLEEVE:]____________    !NUT:]____________    !FILLER:]____________ "                                                  TO TLNW(5).
    MOVE "               !K.O. PIN:]____________    !SEGMENTS:]____________    !CROSS PIN:]____________ "                                        TO TLNW(6).
    MOVE " "                                                                                                                                     TO TLNW(7).
    MOVE "^1ST PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________    !PIN:]____________ "                                     TO TLNW(8).
    MOVE "              !PLUG:]____________    !BACKPLATE:]____________    !ASSEMBLY:]____________ "                                             TO TLNW(9).
    MOVE " "                                                                                                                                     TO TLNW(10).
    MOVE "^2ND PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________    !PIN:]____________ "                                     TO TLNW(11).
    MOVE "              !PLUG:]____________    !BACKPLATE:]____________    !ASSEMBLY:]____________ "                                             TO TLNW(12).
    MOVE " "                                                                                                                                     TO TLNW(13).
    MOVE "^3RD PUNCH:]  !CASE:]____________    !INSERTS:]____________!/]____________    !PIN:]____________ "                                     TO TLNW(14).
    MOVE "              !PLUG:]____________    !BACKPLATE:]____________    !ASSEMBLY:]____________ "                                             TO TLNW(15).
    MOVE " "                                                                                                                                     TO TLNW(16).
    MOVE "^TRIM STATION:]    !TRIM DIE:]____________    !CASE:]____________    !PIN:]____________    !PLUG:]____________ "                       TO TLNW(17).
    MOVE " "                                                                                                                                     TO TLNW(18).
    MOVE "^TRANSFER FINGERS:]  !1ST:]____________!/]____________    !2ND:]____________!/]____________ "                                          TO TLNW(19).
    MOVE "                     !3RD:]____________!/]____________    !4TH:]____________!/]____________ "                                          TO TLNW(20).
    MOVE "?? "                                                                                                                                   TO TLNW(21).

RD806A3.
    MOVE "^PRODUCT:]____________                                    ^MACHINE:]__        !MACHINES USED:]                              ^PAGE 3]"  TO TLNW(1).
    MOVE "                                                                                     ^FUNCTION:]_  (1:ADD 2:CHANGE 3:DELETE 4:COPY) "  TO TLNW(2).
    MOVE " "                                                                                                                                     TO TLNW(3).
    MOVE "^POINTER TOOLS:]  !UPPER GUIDE:]____________   !REAR UPPER GUIDE:]____________ "                                                       TO TLNW(4).
    MOVE "                  !PUSHER GUIDE:]____________    !SEPARATOR GUIDE:]____________    !FILLER PLATE:]____________ "                       TO TLNW(5).
    MOVE "                  !STATIONARY JAW:]____________    !MOVABLE JAW:]____________    !PLATE:]____________ "                                TO TLNW(6).
    MOVE "                  !HOOK FINGER:]____________    !INJECTOR FINGER:]____________    !SEPARATOR PIN:]____________ "                       TO TLNW(7).
    MOVE "                  !PRESS PIN:]____________    !PRESS PIN HOLDER:]____________ "                                                        TO TLNW(8).
    MOVE "                  !INSIDE DISCHARGE RAIL:]____________    !OUTSIDE DISCHARGE RAIL:]____________ "                                      TO TLNW(9).
    MOVE "                  !CUTTER HOLDER:]____________!/]____________    !CUTTER INSERT:]____________!/]____________ "                         TO TLNW(10).
    MOVE "                  !L.H. GUIDE BLOCK:]____________    !R.H. GUIDE BLOCK:]____________    !SPRING PLATE:]____________ "                  TO TLNW(11).
    MOVE " "                                                                                                                                     TO TLNW(12).
    MOVE "^THREADER TOOLS:]  !GUIDE TIP:]____________    !STOPPER:]____________    !INJECTOR:]____________ "                                     TO TLNW(13).
    MOVE "                   !THREAD DIES:]____________!/]____________ "                                                                         TO TLNW(14).
    MOVE "?? "                                                                                                                                   TO TLNW(15).
* note 107.2

* note 1
WRT. PERFORM WRT-T1 THRU WRT-T9.
WRT-T1. MOVE 1 TO TXS.
    MOVE TSTART TO TROW MOVE 1 TO TCOL MOVE TPOS TO TFLD MOVE 9 TO TLTH PERFORM WRT-F.
    MOVE TCLSF TO TFLD MOVE 4 TO TLTH PERFORM WRT-F.
    MOVE TSTART TO TXW MOVE 1 TO TSTART.
WRT-T3. IF TWIDTH=80 IF TLN(TXW)(1:2)="??" GO WRT-T8 END-IF IF TLN(TXW)=" " GO WRT-T78 END-IF
      ELSE IF TLNW(TXW)(1:2)="??" GO WRT-T8 END-IF IF TLNW(TXW)=" " GO WRT-T78 END-IF.
    MOVE 1 TO TXC.
WRT-T5. IF TXC>TWIDTH GO WRT-T78. PERFORM WRT-C IF TCH=" " ADD 1 TO TXC GO WRT-T5.
    MOVE TXW TO TROW MOVE TXC TO TCOL MOVE TPOS TO TFLD MOVE 9 TO TLTH PERFORM WRT-F.
    MOVE 0 TO TSA.
    IF TCH="^" MOVE 1 TO TSA MOVE " " TO TCH MOVE TREV TO TFLD MOVE 4 TO TLTH PERFORM WRT-F.
    IF TCH="!" MOVE 1 TO TSA MOVE " " TO TCH MOVE TBOLD TO TFLD MOVE 4 TO TLTH PERFORM WRT-F.
    IF TCH="|" MOVE 1 TO TSA MOVE TREV TO TFLD MOVE 4 TO TLTH PERFORM WRT-F
      MOVE " " TO TFC(1) MOVE 1 TO TLTH ADD 1 TO TXC GO WRT-T6.
    MOVE TCH TO TFC(1) MOVE 1 TO TXF TLTH.
WRT-T55. ADD 1 TO TXC TXF IF TXC>TWIDTH GO WRT-T6. PERFORM WRT-C.
    IF TCH="^" OR "!" OR "|" GO WRT-T6.
    IF TCH="]" MOVE " " TO TFC(TXF) MOVE TXF TO TLTH ADD 1 TO TXC GO WRT-T6.
    MOVE TCH TO TFC(TXF) IF TCH>" " MOVE TXF TO TLTH. GO WRT-T55.
WRT-T6. PERFORM WRT-F IF TSA=1 MOVE TNORM TO TFLD MOVE 4 TO TLTH PERFORM WRT-F.
    GO WRT-T5.
WRT-T78. IF TXS>1500 DISPLAY TSTR(1:TXS - 1) MOVE 1 TO TXS.
    ADD 1 TO TXW IF TXW<=24 GO WRT-T3.
WRT-T8. IF TXS>1 DISPLAY TSTR(1:TXS - 1). MOVE TXW TO IXT IXTSV.
    IF ITOOL DISPLAY " I R V I N E  T O O L S *** " LINE 24 REVERSED.
    IF INUT DISPLAY " I R V I N E  N U T S *** " LINE 24 REVERSED.
WRT-T9. EXIT.
WRT-C. IF TWIDTH=80 MOVE TLN(TXW)(TXC:1) TO TCH ELSE MOVE TLNW(TXW)(TXC:1) TO TCH.
WRT-F. IF TXS + TLTH<=2000 MOVE TFLD(1:TLTH) TO TSTR(TXS:TLTH) ADD TLTH TO TXS.

WRT80. MOVE 1 TO TROW TCOL MOVE TPOS TO TSTR(1:9) MOVE TCLS TO TSTR(10:4).
    MOVE TW80 TO TSTR(14:5) DISPLAY TSTR(1:18) MOVE 80 TO TWIDTH.
WRT132. MOVE 1 TO TROW TCOL MOVE TPOS TO TSTR(1:9) MOVE TCLS TO TSTR(10:4).
    MOVE TW132 TO TSTR(14:5) DISPLAY TSTR(1:18) MOVE 132 TO TWIDTH.
CLR-LN. IF TWIDTH=80 MOVE " " TO TLN(IXT) ELSE MOVE " " TO TLNW(IXT).

DSP-ERR0. MOVE "FUNCTION NOT AUTHORIZED" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR1. MOVE "INVALID FUNCTION" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR2. MOVE "INVALID VALUE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR3. MOVE "INVALID PART NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR4. MOVE "INVALID SHIP-TO CODE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR5. MOVE "INVALID CUSTOMER NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR6. MOVE "INVALID PRODUCT NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR7. MOVE "INVALID BIN NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR8. MOVE "INVALID ORDER NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR9. MOVE "INVALID CODE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR10. MOVE "INVALID DATE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR11. MOVE "INVALID M.O. NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR12. MOVE "INVALID MACHINE/PROCESS NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR13. MOVE "INVALID B/L NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR14. MOVE "INVALID RESPONSE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR15. MOVE "INVALID LOT NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR16. MOVE "INVALID G/L A/C" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR17. MOVE "INVALID VENDOR NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR18. MOVE "INVALID HEAT NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR19. MOVE "INVALID TRANSACTION" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR20. MOVE "INVALID EMPLOYEE NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR21. MOVE "INVALID PASSWORD" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR22. MOVE "INVALID CHEQUE NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR23. MOVE "INVALID SUBCONTRACTOR NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR24. MOVE "INVALID SHIFT" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR25. MOVE "INVALID MAINTENANCE ORDER NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR26. MOVE "NO TOOL LIST FOUND FOR THIS PRODUCT-MACHINE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR27. MOVE "NO OPERATIONS LIST FOUND FOR THIS PRODUCT-MACHINE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR28. MOVE "INVALID NON-PRODUCTION MACHINE NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR29. MOVE "PRODUCT MUST BE THE GENERIC PRODUCT NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR30. MOVE "RECORD NOT FOUND" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR31. MOVE "DUPLICATE ORDER NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR32. MOVE "INVALID USER" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR33. MOVE "DUPLICATE USER" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR34. MOVE "MUST BE LABOUR MAINTENANCE PROCESS" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR35. MOVE "INVALID QUOTATION NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR36. MOVE "INVALID QUOTATION LINE NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR37. MOVE "SUBCONTRACTOR RECORD NOT FOUND" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR38. MOVE "DUPLICATE G/L TRANSACTION" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR39. MOVE "THIS RECORD ALREADY EXISTS" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR40. MOVE "WRONG AMOUNT" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR41. MOVE "DRAWING NOT FOUND" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR42. MOVE "DUPLICATE A/P TRANSACTION" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR43. MOVE "INVALID ALTERNATE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR44. MOVE "THIS LOT IS QUARANTINED - CONTACT QA DEPARTMENT" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR45. MOVE "PRICE NOT DEFINED FOR THIS CUSTOMER-PRODUCT" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR46. MOVE "NOT AUTHORIZED TO MODIFY THIS FIELD" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR47. MOVE "B/L NOT FOUND IN INVOICE TRANSACTION FILE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR48. MOVE "'TO' MUST NOT BE LESS THAN 'FROM'" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR49. MOVE "FIRST LINE MUST BE BLANK" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR50. MOVE "ORDER MUST BE A BLANKET ORDER" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR51. MOVE "INVALID VENDOR NO. IN THIS ORDER" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR52. MOVE "CANNOT CREATE SHIPPING LABELS FOR THIS CUSTOMER" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR53. MOVE "PART MUST BE AN ASSEMBLY" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR54. MOVE "PART MUST BE A TOOL" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR55. MOVE "UNDEFINED CHARACTERISTIC" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR56. MOVE "DUPLICATE PLANT-PRODUCT" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR57. MOVE "CANNOT OPEN INPUT FILE" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR58. MOVE "DUPLICATE EMPLOYEE NO." TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR59. MOVE "NAME FIELD MUST BE BLANK" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR60. MOVE "DESCRIPTION FIELD MUST BE BLANK" TO ERR-MESG PERFORM DSP-ERR.
DSP-ERR. DISPLAY ERR-LINE LINE 24 BLINKING ERASE LINE.
    ACCEPT XA1 COLUMN 80 PROTECTED AUTOTERMINATE PERFORM DSP-ERS.
DSP-OK. DISPLAY ERR-LINE LINE 24 BLINKING ERASE LINE.
    DISPLAY "'OK' TO ACCEPT: __" COLUMN 62.
    ACCEPT XA2 COLUMN 78 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
DSP-SURE. DISPLAY "'YES' IF YOU ARE SURE: ___" LINE 24 COLUMN 54 BOLD.
    ACCEPT XA3 COLUMN 77 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
DSP-ACC. DISPLAY "'OK' TO ACCEPT: __" LINE 24 COLUMN 61 BOLD.
    ACCEPT XA2 COLUMN 77 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
DSP-CONT. DISPLAY "PRESS ANY KEY TO CONTINUE" LINE 24 BOLD ERASE LINE.
    ACCEPT XA1 COLUMN 27 PROTECTED AUTOTERMINATE PERFORM DSP-ERS.
DSP-MSG. DISPLAY TMSG(1:78) LINE 24 BOLD ERASE LINE.
    ACCEPT XA1 COLUMN 80 PROTECTED AUTOTERMINATE PERFORM DSP-ERS.
DSP-MSGCONT. DISPLAY TMSG(1:49) LINE 24 BOLD ERASE LINE.
    DISPLAY " - PRESS ANY KEY TO CONTINUE" COLUMN 50.
    ACCEPT XA1 COLUMN 80 PROTECTED AUTOTERMINATE PERFORM DSP-ERS.
DSP-PROMPT. MOVE 0 TO TX1 INSPECT TMSG TALLYING TX1 FOR CHARACTERS BEFORE "_".
    DISPLAY TMSG LINE 24 BOLD ERASE LINE.
    ACCEPT XA3 COLUMN TX1 PLUS 1 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
DSP-NEXT. DISPLAY "TO END, LEAVE FUNCTION BLANK" LINE 24 BOLD ERASE LINE.
DSP-PF1. DISPLAY "- PF1 TO GO BACK" LINE 24 COLUMN 64 BOLD.
DSP-PF3. DISPLAY "- PF3 TO END" LINE 24 COLUMN 68 BOLD.
DSP-PF13. DISPLAY "- PF1 TO GO BACK, PF3 TO END" LINE 24 COLUMN 52 BOLD.
DSP-ERS. DISPLAY " " LINE 24 ERASE LINE.

DSP-CLS. DISPLAY " " LINE 1 ERASE SCREEN MOVE 2 TO IXT IXTSV.
* note 282
DSP-WAIT. IF IXTSV>IXT MOVE IXTSV TO IXT.
    ADD 2 TO IXT DISPLAY "PLEASE WAIT ..." LINE IXT ERASE LINE.
DSP-QWAIT. DISPLAY "PLEASE WAIT ..." LINE 24 COLUMN 33 BLINKING ERASE LINE.

* note 22.1
DSQ-ERR0. MOVE "NOT AUTHORIZED" TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR6. MOVE "INVALID PRODUCT NO." TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR7. MOVE "INVALID BIN NO." TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR11. MOVE "INVALID M.O. NO." TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR12. MOVE "INVALID MAC/PROC NO." TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR15. MOVE "INVALID LOT NO." TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR19. MOVE "INVALID TRANSACTION" TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR44. MOVE "LOT IS QUARANTINED  CONTACT QA DEPT." TO ERR-MESG PERFORM DSQ-ERR.
DSQ-ERR. DISPLAY ERR-MESG(1:20) LINE 15 BLINKING ERASE END SCREEN ERR-MESG(21:20) LINE 16 BLINKING.
    ACCEPT XA1 LINE 16 COLUMN 19 PROTECTED AUTOTERMINATE PERFORM DSQ-ERS.
DSQ-OK. DISPLAY ERR-MESG(1:20) LINE 14 BLINKING ERASE END SCREEN ERR-MESG(21:20) LINE 15 BLINKING.
    DISPLAY "'OK' TO ACCEPT: __" LINE 16.
    ACCEPT XA2 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED PERFORM DSQ-ERS.
DSQ-ERS. DISPLAY " " LINE 13 ERASE END SCREEN.
DSQ-CONT. DISPLAY "PRESS ANY KEY" LINE 15 ERASE END SCREEN "   TO CONTINUE" LINE 16.
    ACCEPT XA1 LINE 16 COLUMN 19 PROTECTED AUTOTERMINATE PERFORM DSQ-ERS.
DSQ-CLS. DISPLAY " " LINE 1 ERASE SCREEN MOVE 2 TO IXT.

* note 84
AX-SYS-DATE. ACCEPT D-DT FROM DATE PERFORM D-YN MOVE D-DATE TO SYS-DATE.
    ACCEPT D-DT FROM DATE PERFORM D-SHDT MOVE D-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO SYS-YEAR.
    ACCEPT SYS-WDAY FROM DAY-OF-WEEK ACCEPT SYS-JDATE FROM DAY ACCEPT SYS-TIME FROM TIME.
D-SHDT. MOVE D-MM TO D-T1 MOVE D-DD TO D-MM MOVE D-YY TO D-DD MOVE D-T1 TO D-YY.
D-SHDT2. PERFORM D-SHDT 2 TIMES.
D-CHKDT. MOVE 0 TO D-ERR PERFORM D-LEAP.
    IF D-MM=0 OR>12 OR D-DD=0 MOVE 1 TO D-ERR
      ELSE IF D-DD>D-MNUM(D-XL1,D-MM + 1) - D-MNUM(D-XL1,D-MM) MOVE 1 TO D-ERR.
D-CHKDTR. MOVE 0 TO D-ERR.
    IF D-DATE<SYS-DATE - D-N1 OR>SYS-DATE + D-N2 MOVE "INVALID DATE RANGE"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" MOVE 1 TO D-ERR.
D-CHKWIN. IF D-DATE>=36525 AND<=73049 MOVE 0 TO D-S1 ELSE MOVE 1 TO D-S1.
D-LEAP. DIVIDE D-YY BY 4 GIVING D-XL2 REMAINDER D-XL1.
    IF D-XL1=0 MOVE 2 TO D-XL1 ELSE MOVE 1 TO D-XL1.
D-NY. PERFORM D-NM PERFORM D-SHDT2.
D-YN. IF D-DT NOT NUMERIC MOVE 0 TO D-DT. PERFORM D-SHDT PERFORM D-MN.
D-MN. IF D-DT NOT NUMERIC MOVE 0 TO D-DT.
    MOVE D-YY TO D-T1 IF D-YY<70 ADD 100 TO D-T1.
    PERFORM D-CHKDT IF D-ERR=1 MOVE 0 TO D-DATE
      ELSE PERFORM D-LEAP COMPUTE D-DATE=
       36524 + (D-T1 - 70) * 365 + (D-T1 - 69) / 4 + D-MNUM(D-XL1,D-MM) + D-DD.
D-NM. PERFORM D-NM1 THRU D-NM9.
D-NM1. IF D-DATE=0 MOVE 0 TO D-DT D-YEAR GO D-NM9.
    COMPUTE D-T1=D-DATE - 36524.
    IF D-T1<=0 MOVE 010170 TO D-DT MOVE 1970 TO D-YEAR GO D-NM9.
    IF D-T1>36525 MOVE 123169 TO D-DT MOVE 2069 TO D-YEAR GO D-NM9.
    PERFORM VARYING D-X1 FROM 5 BY -1 UNTIL D-T1>D-LNUM(D-X1) CONTINUE END-PERFORM.
    COMPUTE D-T1=D-T1 - D-LNUM(D-X1).
    PERFORM VARYING D-X2 FROM 20 BY -1 UNTIL D-T1>D-YNUM(D-X2) CONTINUE END-PERFORM.
    COMPUTE D-T1=D-T1 - D-YNUM(D-X2) MOVE D-T1 TO D-JDAY.
    COMPUTE D-T2=70 + 20 * (D-X1 - 1) + (D-X2 - 1) COMPUTE D-YEAR=1900 + D-T2.
    IF D-T2>=100 SUBTRACT 100 FROM D-T2. MOVE D-T2 TO D-YY PERFORM D-LEAP.
    PERFORM VARYING D-MM FROM 12 BY -1 UNTIL D-T1>D-MNUM(D-XL1,D-MM) CONTINUE END-PERFORM.
    COMPUTE D-DD=D-T1 - D-MNUM(D-XL1,D-MM).
D-NM9. EXIT.
D-NC. PERFORM D-NM COMPUTE D-N1=D-YEAR * 10000 + D-MM * 100 + D-DD.
D-YCONV. IF D-Y1<70 ADD 2000 TO D-Y1 ELSE ADD 1900 TO D-Y1.
* note 141
D-LOTDATE. MOVE 0 TO D-ERR MOVE SYS-YEAR TO D-YEAR1.
    COMPUTE D-YEAR=D-YEAR1 / 10 COMPUTE D-YEAR=D-YEAR * 10 + D-LOTY.
    IF D-YEAR>D-YEAR1 SUBTRACT 10 FROM D-YEAR.
    DIVIDE D-YEAR BY 100 GIVING D-T1 REMAINDER D-YY PERFORM D-LEAP.
    IF D-LOTD=0 OR>D-MNUM(D-XL1,13) MOVE 0 TO D-DT MOVE 1 TO D-ERR
      ELSE PERFORM VARYING D-MM FROM 12 BY -1 UNTIL D-LOTD>D-MNUM(D-XL1,D-MM) CONTINUE END-PERFORM
        COMPUTE D-DD=D-LOTD - D-MNUM(D-XL1,D-MM).
    PERFORM D-MN.
* note 83
D-WKDAY. COMPUTE D-M1=D-DATE + 5 DIVIDE D-M1 BY 7 GIVING D-M1 REMAINDER D-N1.
    IF D-N1=0 MOVE 7 TO D-N1.
D-OFFDAY. PERFORM D-OF1 THRU D-OF9.
D-OF1. PERFORM D-WKDAY IF D-N1>5 MOVE 1 TO D-N1 GO D-OF9.
    PERFORM VARYING D-X1 FROM 1 BY 1 UNTIL D-X1>15
      IF IF-OFF-DATE1(D-X1)>0 AND D-DATE>=IF-OFF-DATE1(D-X1) AND<=IF-OFF-DATE2(D-X1)
        MOVE 2 TO D-N1 GO D-OF9 END-IF END-PERFORM.
    MOVE 0 TO D-N1.
D-OF9. EXIT.
D-PDAYS. MOVE 0 TO D-N2.
    PERFORM VARYING D-DD FROM 1 BY 1 UNTIL D-DD>31 PERFORM D-CHKDT
      IF D-ERR=0 PERFORM D-MN PERFORM D-OFFDAY IF D-N1=0 ADD 1 TO D-N2 END-IF
        END-IF END-PERFORM.
    MOVE D-N2 TO D-N1.
* note 182
D-DTADD. PERFORM D-CHKWIN IF D-S1=1 MOVE SYS-DATE TO D-DATE.
    ADD D-DAYS TO D-DATE PERFORM D-PREVIOUS.
D-CDTADD. PERFORM D-CHKWIN IF D-S1=1 MOVE SYS-DATE TO D-DATE.
    ADD D-DAYS TO D-DATE PERFORM D-CPREVIOUS.
D-NEXT. MOVE D-N1 TO D-P1.
    PERFORM TEST AFTER UNTIL D-N1=D-P1 ADD 1 TO D-DATE PERFORM D-WKDAY END-PERFORM.
D-PREVIOUS. MOVE D-N1 TO D-P1.
    PERFORM TEST AFTER UNTIL D-N1=D-P1 SUBTRACT 1 FROM D-DATE PERFORM D-WKDAY END-PERFORM.
D-CNEXT. MOVE D-N1 TO D-P1 PERFORM D-WKDAY.
    PERFORM UNTIL D-N1=D-P1 ADD 1 TO D-DATE PERFORM D-WKDAY END-PERFORM.
D-CPREVIOUS. MOVE D-N1 TO D-P1 PERFORM D-WKDAY.
    PERFORM UNTIL D-N1=D-P1 SUBTRACT 1 FROM D-DATE PERFORM D-WKDAY END-PERFORM.
D-NEXT-DAY. PERFORM TEST AFTER UNTIL D-N1<=5 ADD 1 TO D-DATE PERFORM D-WKDAY END-PERFORM.
D-PREV-DAY. PERFORM TEST AFTER UNTIL D-N1<=5 SUBTRACT 1 FROM D-DATE PERFORM D-WKDAY END-PERFORM.
D-MTHS. COMPUTE D-N1=(D-YEAR - 1869) * 12 + (D-MM - 1).
D-MTHSR. DIVIDE D-N1 BY 12 GIVING D-YEAR REMAINDER D-MM.
    ADD 1869 TO D-YEAR ADD 1 TO D-MM MOVE D-YEAR TO D-YY.
D-CURR. PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO D-W1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS COMPUTE D-N1=D-W1 - D-N1.
D-INCMTH. PERFORM D-NM ADD 1 TO D-MM IF D-MM>12 MOVE 1 TO D-MM ADD 1 TO D-YY.
    PERFORM D-MN.
* note 11
D-WDIFF. PERFORM D-WD1 THRU D-WD9.
D-WD1. PERFORM D-CHKWIN IF D-S1=1 GO D-WD9. PERFORM RDR-INFO MOVE 1 TO D-R3.
    MOVE D-DAYS TO D-R2 IF D-R2<0 MULTIPLY -1 BY D-R2 D-R3. MOVE -1 TO D-R1.
D-WD3. PERFORM D-OFFDAY IF D-N1=0 ADD 1 TO D-R1.
    IF D-R1 NOT=D-R2 ADD D-R3 TO D-DATE GO D-WD3.
D-WD9. EXIT.
D-PR-TIME. MOVE D-TIME(1:2) TO D-PRTIME(1:2) MOVE D-TIME(3:2) TO D-PRTIME(4:2).
    MOVE ":" TO D-PRTIME(3:1).
D-PR-STIME. MOVE D-STIME(1:2) TO D-PRSTIME(1:2) MOVE D-STIME(3:2) TO D-PRSTIME(4:2).
    MOVE D-STIME(5:2) TO D-PRSTIME(7:2) MOVE ":" TO D-PRSTIME(3:1) D-PRSTIME(6:1).

EXCHG-CONV. PERFORM D-NM MOVE D-YEAR TO D-YEAR2.
    MOVE IF-EXCH-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR1.
    IF (D-YEAR2>=D-YEAR1 AND<=D-YEAR1 + 4) AND (D-MM>=1 AND<=12)
      MULTIPLY IF-EXCH(D-YEAR2 - D-YEAR1 + 1,D-MM) BY A-T1 ROUNDED.
    COMPUTE A-D1 ROUNDED=A-T1.
EXCHG-RD. MOVE 0 TO A-V1 PERFORM D-NM MOVE D-YEAR TO D-YEAR2.
    MOVE IF-EXCH-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR1.
    IF (D-YEAR2>=D-YEAR1 AND<=D-YEAR1 + 4) AND (D-MM>=1 AND<=12)
      MOVE IF-EXCH(D-YEAR2 - D-YEAR1 + 1,D-MM) TO A-V1.

* note 262
STR-CONVAN. MOVE A-A1 TO STR-BL MOVE X"00" TO STR-BH MOVE STR-NUM TO A-N1.
STR-CONVNA. MOVE A-N1 TO STR-NUM MOVE STR-BL TO A-A1.
STR-BINREV. PERFORM VARYING STR-IX1 FROM 1 BY 1 UNTIL STR-IX1>A-N1
      MOVE A-A1(STR-IX1:1) TO STR-BL MOVE X"00" TO STR-BH
      COMPUTE STR-NUM=255 - STR-NUM MOVE STR-BL TO A-A1(STR-IX1:1) END-PERFORM.
STR-LTH. CALL "STR$TRIM" USING DESCRIPTOR LIB-S1 A-A1 REFERENCE LIB-W1.
    MOVE LIB-W1 TO A-N1.

* note 172
CHK-ZERO. IF A-N1=0 MOVE 0 TO A-N1.
CHK-DZERO. IF A-D1=0 MOVE 0 TO A-D1.
COUNT-ZERO. MOVE 0 TO A-N2 INSPECT A-U1(19 - A-N1:) TALLYING A-N2 FOR LEADING "0".
    ADD 1 TO A-N2 IF A-N2<A-N1 MOVE A-N2 TO A-N1.
LEAD-ZERO. MOVE 0 TO A-N1 INSPECT A-U1 TALLYING A-N1 FOR LEADING "0".
    IF A-N1<18 ADD 1 TO A-N1.

UPDATE-PROD-ORD. PERFORM UPD-P1 THRU UPD-P9.
UPD-P1. IF A-S1=0 GO UPD-P4.
* note 215
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO UPD-P4.
UPD-P3. READ PRODUCT NEXT REGARDLESS END GO UPD-P4.
    MOVE 0 TO P-ORDER P-TORDER P-PROCESS.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT GO UPD-P3.
UPD-P4. MOVE " " TO UPD-PROD MOVE 0 TO UPD-Q1 UPD-Q2 UPD-Q3.
    MOVE " " TO R-KP START PRODORD KEY>R-KP REGARDLESS INVALID GO UPD-P6.
UPD-P5. READ PRODORD NEXT REGARDLESS END PERFORM UPD-PQ GO UPD-P6.
    IF R-QTY-LEFT<=0 GO UPD-P5.
    IF R-PROD NOT=UPD-PROD IF UPD-PROD>" " PERFORM UPD-PQ END-IF
      MOVE R-PROD TO UPD-PROD MOVE 0 TO UPD-Q1 UPD-Q2 UPD-Q3.
    IF R-FIN=1 ADD R-QTY-LEFT TO UPD-Q1
      ELSE IF R-NO>9999 ADD R-QTY-LEFT TO UPD-Q2 ELSE ADD R-QTY-LEFT TO UPD-Q3.
    GO UPD-P5.
UPD-P6.
UPD-P9. EXIT.
UPD-PQ. PERFORM UPD-PQ1 THRU UPD-PQ9.
UPD-PQ1. MOVE UPD-PROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO UPD-PQ9.
    ADD UPD-Q1 TO P-PROCESS ADD UPD-Q2 TO P-ORDER ADD UPD-Q3 TO P-TORDER.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
UPD-PQ9. EXIT.

UPDATE-PART-DEM. PERFORM UPD-H1 THRU UPD-H9.
UPD-H1. MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO UPD-H19.
UPD-H13. READ PART NEXT REGARDLESS END GO UPD-H19.
    IF NOT(PH-DEMAND=0 AND PH-QTY-TMP=0 AND PH-ASM-HAND=0 AND PH-ASM-DEMAND=0) GO UPD-H14.
    PERFORM VARYING UPD-IX1 FROM 1 BY 1 UNTIL UPD-IX1>9
      IF PH-PROC-DEMAND(UPD-IX1) NOT=0 GO UPD-H14 END-IF END-PERFORM.
    GO UPD-H13.
UPD-H14. MOVE 0 TO PH-DEMAND PH-QTY-TMP PH-ASM-HAND PH-ASM-DEMAND.
    PERFORM VARYING UPD-IX1 FROM 1 BY 1 UNTIL UPD-IX1>9
      MOVE 0 TO PH-PROC-DEMAND(UPD-IX1) END-PERFORM.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO UPD-H13.
UPD-H19.

    MOVE " " TO UPD-PROD MOVE 0 TO UPD-Q1 UPD-Q2 UPD-Q3.
    MOVE " " TO R-KP START PRODORD KEY>R-KP REGARDLESS INVALID GO UPD-H39.
UPD-H33. READ PRODORD NEXT REGARDLESS END PERFORM UPD-HQ GO UPD-H39.
    IF R-PROD NOT=UPD-PROD IF UPD-PROD>" " PERFORM UPD-HQ END-IF
      MOVE R-PROD TO UPD-PROD MOVE 0 TO UPD-Q1 UPD-Q2 UPD-Q3.
    IF R-FIN=0 COMPUTE UPD-WN1=R-QTY-ORD - R-QTY-PROD
      ADD UPD-WN1 TO UPD-Q1 IF R-ALLOC=0 ADD UPD-WN1 TO UPD-Q2.
    IF R-QTY-LEFT>0 AND R-FIN=1 ADD R-QTY-LEFT TO UPD-Q3. GO UPD-H33.
UPD-H39.

    MOVE " " TO UPD-TOOL.
UPD-H43. MOVE UPD-TOOL TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO UPD-H49.
    READ PART NEXT REGARDLESS END GO UPD-H49. MOVE PH-NO TO UPD-TOOL.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=1) GO UPD-H43.
    MOVE PH-HAND TO UPD-Q1 PERFORM CALC-PART-REQ MOVE A-N1 TO UPD-Q2.
    IF UPD-Q1=0 AND UPD-Q2=0 GO UPD-H43.
    MOVE UPD-TOOL TO A-A1 PERFORM TL-SET-ASM IF A-S1=1 GO UPD-H48.
    MOVE 1 TO TL-IXF.
UPD-H457. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO UPD-H458.
    IF NOT(TL-PAGE>0 AND TL-STN=TL-ASTN AND TL-CAT=TL-ACAT) GO UPD-H458.
    MOVE TS-TOOL(TL-FLD) TO PH-NO READ PART REGARDLESS INVALID GO UPD-H458.
    ADD UPD-Q1 TO PH-ASM-HAND ADD UPD-Q2 TO PH-ASM-DEMAND.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
UPD-H458. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO UPD-H457.
UPD-H48. GO UPD-H43.
UPD-H49.

    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO UPD-H79.
UPD-H73. READ PART NEXT REGARDLESS END GO UPD-H79. IF PH-QTY-TMP=0 GO UPD-H73.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=0) GO UPD-H73.
    IF PH-LIFE=0 MOVE 9999999 TO PH-DEMAND
      ELSE COMPUTE UPD-WD1 ROUNDED=PH-QTY-TMP / PH-LIFE / 1000
       IF UPD-WD1<2 MOVE 2 TO PH-DEMAND ELSE COMPUTE PH-DEMAND ROUNDED=UPD-WD1.
    MOVE 0 TO PH-QTY-TMP REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO UPD-H73.
UPD-H79.
UPD-H9. EXIT.

UPD-HQ. PERFORM UPD-HQ1 THRU UPD-HQ9.
UPD-HQ1. MOVE UPD-PROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO UPD-HQ9.
    IF P-CAT=99 GO UPD-HQ9. IF UPD-Q1=0 OR P-MAC=0 GO UPD-HQ4.
    PERFORM GET-TS IF A-S1=1 GO UPD-HQ4. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXA.
UPD-HQ3. IF TS-TOOL(TL-IXA)=" " OR "N/R" GO UPD-HQ38.
    MOVE TS-TOOL(TL-IXA) TO PH-NO READ PART REGARDLESS INVALID GO UPD-HQ38.
    MOVE UPD-Q1 TO A-T1 PERFORM ADJ-PLIFE ADD A-T1 TO PH-QTY-TMP ROUNDED.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
UPD-HQ38. ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO UPD-HQ3.
UPD-HQ4. IF UPD-Q2=0 GO UPD-HQ6. PERFORM SET-PART MOVE PART-NO TO PH-NO.
    READ PART REGARDLESS INVALID GO UPD-HQ6.
    MOVE UPD-Q2 TO A-N1 PERFORM CALC-GWEIGHT ADD A-N1 TO PH-DEMAND.
    IF P-PROC<=8 ADD A-N1 TO PH-PROC-DEMAND(P-PROC + 1).
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
UPD-HQ6. IF UPD-Q3=0 OR P-PACKING=0 OR P-QTY-PACK=0 GO UPD-HQ8.
    DIVIDE P-QTY-PACK INTO UPD-Q3 ROUNDED.
    MOVE P-PACKING TO PK-NO READ PACKING REGARDLESS INVALID GO UPD-HQ8.
    MOVE PK-PART TO PH-NO READ PART REGARDLESS INVALID GO UPD-HQ8.
    ADD UPD-Q3 TO PH-DEMAND REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    IF PK-PALLET=0 OR PK-MAX=0 GO UPD-HQ8. DIVIDE PK-MAX INTO UPD-Q3 ROUNDED.
    MOVE PK-PALLET TO PK-NO READ PACKING REGARDLESS INVALID GO UPD-HQ8.
    MOVE PK-PART TO PH-NO READ PART REGARDLESS INVALID GO UPD-HQ8.
    ADD UPD-Q3 TO PH-DEMAND REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
UPD-HQ8.
UPD-HQ9. EXIT.

* note 284
UPDATE-TOOL-LIFE. PERFORM UPD-T1 THRU UPD-T9.
UPD-T1. PERFORM OPEN-SORT.
    SUBTRACT 1 FROM D-YY MOVE 1 TO D-MM D-DD PERFORM D-MN MOVE D-DATE TO A-N1.
    INITIALIZE J-KM START WORKSHEET KEY>J-KM REGARDLESS INVALID GO UPD-T24.
UPD-T23. READ WORKSHEET NEXT REGARDLESS END GO UPD-T24. IF J-MAC>88 GO UPD-T24.
    IF J-DATE<A-N1 GO UPD-T23.
    MOVE J-PROD TO SR-F176 MOVE J-MAC TO SR-F177 MOVE J-QTY TO SR-F178.
    MOVE J-AWEIGHT TO A-N2 IF A-N2=0 MOVE J-WEIGHT TO A-N2. MOVE A-N2 TO SR-F179.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD J-QTY TO SR-F178 ADD A-N2 TO SR-F179 REWRITE SR-RECORD.
    GO UPD-T23.
UPD-T24. MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO UPD-T28.
UPD-T25. READ PART NEXT REGARDLESS END GO UPD-T28. PERFORM PART-TYPE.
    IF PART-TOOL AND NOT(PH-QTYA-TMP=0 AND PH-QTYB-TMP=0)
      MOVE 0 TO PH-QTYA-TMP PH-QTYB-TMP REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    GO UPD-T25.
UPD-T28. MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO UPD-T4.
UPD-T3. READ SORTFL NEXT END GO UPD-T4.
    MOVE SR-F176 TO TS-PROD MOVE SR-F177 TO TS-MAC.
    READ TOOLS REGARDLESS INVALID GO UPD-T38. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
UPD-T35. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO UPD-T36.
    IF TL-PAGE=0 OR (TL-CAT=1 OR 2 OR 3) GO UPD-T36.
    MOVE TS-TOOL(TL-FLD) TO PH-NO READ PART REGARDLESS INVALID GO UPD-T36.
    ADD SR-F178 TO PH-QTYA-TMP ADD SR-F179 TO PH-QTYB-TMP.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
UPD-T36. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO UPD-T35.
UPD-T38. GO UPD-T3.
UPD-T4. MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO UPD-T6.
UPD-T5. READ PART NEXT REGARDLESS END GO UPD-T6.
    PERFORM PART-TYPE IF NOT PART-TOOL GO UPD-T5. MOVE 0 TO PH-ALIFE.
    PERFORM CHK-ROLL IF A-S1=0 MOVE PH-QTYA-TMP TO A-N1 ELSE MOVE PH-QTYB-TMP TO A-N1.
    COMPUTE A-N2=PH-BEG-HAND(2) + PH-LAST + PH-YTD - PH-HAND - PH-ASM-HAND.
    IF A-N2>0 COMPUTE PH-ALIFE ROUNDED=A-N1 / A-N2 / 1000.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO UPD-T5.
UPD-T6. PERFORM CLOSE-SORT.
UPD-T9. EXIT.

GET-OP. PERFORM INIT-OP MOVE P-NO TO OP-PROD MOVE P-MAC TO OP-MAC.
    MOVE 0 TO A-S1 READ OPERATIONS REGARDLESS INVALID MOVE 1 TO A-S1.
* note 260
SET-OPLIST. PERFORM SET-OP1 THRU SET-OP9.
SET-OP1. MOVE " " TO PRO-OPDESC MOVE 0 TO PRO-SPN.
    PERFORM GET-OP IF A-S1=1 GO SET-OP8.
    MOVE OP-SPEED TO PRO-SPN MOVE 0 TO A-X1 MOVE 1 TO A-X2 A-X3.
SET-OP3. IF A-X1=0 IF ITOOL GO SET-OP4 END-IF MOVE OP-MAC TO M-NO
      ELSE IF OP-OPER(A-X1)=0 GO SET-OP4 END-IF MOVE OP-OPER(A-X1) TO M-NO.
    READ MACHINE REGARDLESS INVALID MOVE "--ERROR--" TO M-OPDESC.
    MOVE M-OPDESC TO PRO-OPDESC(A-X2:10) A-A1.
    PERFORM STR-LTH IF A-N1>10 MOVE 10 TO A-N1.
    ADD A-N1 TO A-X2 MOVE "," TO PRO-OPDESC(A-X2:1).
    MOVE A-X2 TO A-X3 ADD 2 TO A-X2.
    IF ITOOL AND A-X1=6 OR NOT ITOOL AND A-X1=5 MOVE 73 TO A-X2.
SET-OP4. ADD 1 TO A-X1 IF A-X1<=12 GO SET-OP3.
    MOVE "." TO PRO-OPDESC(A-X3:1).
SET-OP8. MOVE PRO-SPDESC TO PRO-OPLINE(2)(59:).
SET-OP9. EXIT.

SET-QUOTPROD. PERFORM INIT-P MOVE QL-PROD TO P-NO.
    MOVE QL-DESC TO P-DESC MOVE QL-EDESC1 TO P-EDESC1.
    MOVE QL-EDESC2 TO P-EDESC2 MOVE QL-FINDESC TO P-FINDESC.
    MOVE QL-PRDESC TO P-PRDESC MOVE QL-CAT TO P-CAT MOVE QL-FAMILY TO P-FAMILY.
    MOVE QL-MODE TO P-MODE MOVE QL-PRICE1 TO P-PRICE1 MOVE QL-PRICE2 TO P-PRICE2.
    MOVE QL-COST TO P-COST MOVE QL-RATE TO P-RATE MOVE QL-EST TO P-EST.
    MOVE QL-MAC TO P-MAC MOVE QL-WEIGHT TO P-WEIGHT MOVE QL-GROSS TO P-GROSS.
    MOVE QL-DIAM TO P-DIAM MOVE QL-GRADE TO P-GRADE.
    MOVE QL-PROC TO P-PROC MOVE QL-CLEAN TO P-CLEAN.
    MOVE QL-PACKING TO P-PACKING MOVE QL-QTY-PACK TO P-QTY-PACK.
    PERFORM PROD-DESC.
    PERFORM INIT-OP MOVE QL-PROD TO OP-PROD MOVE QL-MAC TO OP-MAC.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>12
      MOVE QL-OPER(A-X1) TO OP-OPER(A-X1) MOVE QL-OPCOST(A-X1) TO OP-COST(A-X1)
      MOVE QL-CMODE(A-X1) TO OP-CMODE(A-X1) END-PERFORM.

OPEN-MACSCHED. OPEN I-O MACSCHED ALLOWING ALL.
* note 76
SET-SHORT-SCHED. PERFORM SET-SS1 THRU SET-SS9.
SET-SS1. PERFORM OPEN-MACSCHED MOVE 0 TO A-N1.
    MOVE " " TO MQ-KEY START MACSCHED KEY>MQ-KEY REGARDLESS INVALID GO SET-SS4.
SET-SS3. READ MACSCHED NEXT REGARDLESS END GO SET-SS4.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>15
      IF MQ-MO(A-X1) NOT=0 ADD 1 TO A-N1 MOVE MQ-MAC TO XM-F6(A-N1)
        MOVE A-X1 TO XM-F7(A-N1) MOVE MQ-MO(A-X1) TO XM-F8(A-N1)
        IF A-N1=999 GO SET-SS4 END-IF END-IF END-PERFORM.
    GO SET-SS3.
SET-SS4. ADD 1 TO A-N1 MOVE 0 TO XM-F6(A-N1) CLOSE MACSCHED.
SET-SS9. EXIT.

CHK-ALTS. PERFORM CHK-ALT1 THRU CHK-ALT9.
CHK-ALT1. MOVE 0 TO A-S1 MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>AL-KEY REGARDLESS INVALID GO CHK-ALT9.
    READ ALTERNATES NEXT REGARDLESS END GO CHK-ALT9. IF AL-PROD=P-NO MOVE 1 TO A-S1.
CHK-ALT9. EXIT.
RD-GEN. PERFORM RD-GEN1 THRU RD-GEN9.
RD-GEN1. MOVE " " TO GEN-NUT MOVE 0 TO GEN-WEIGHT-NUT.
    IF P-GEN>" " MOVE P-NUT TO GEN-NUT MOVE P-WEIGHT-NUT TO GEN-WEIGHT-NUT.
    MOVE 0 TO GEN-IND IF P-GEN=" " GO RD-GEN9.
    MOVE P-NO TO GEN-ALT MOVE P-GEN TO P-NO.
    READ PRODUCT REGARDLESS INVALID MOVE GEN-ALT TO P-NO GO RD-GEN9.
    MOVE 1 TO GEN-IND.
RD-GEN9. EXIT.
PROD-GEN. PERFORM PROD-RT PERFORM RD-GEN.
PROD-RGD. PERFORM PROD-RT PERFORM RD-GEN PERFORM PROD-DESC.
PROD-RDG. PERFORM PROD-RT PERFORM PROD-DESC PERFORM RD-GEN.
PROD-RD. PERFORM PROD-RT PERFORM PROD-DESC.
PROD-RT. INITIALIZE P-REC MOVE A-A1 TO P-NO READ PRODUCT REGARDLESS INVALID CONTINUE.
PROD-DESC. IF IFAST OR INUT PERFORM DESC-MAIN MOVE 0 TO PRO-SIND PERFORM DESC-SEC
      ELSE PERFORM DESC-IMAIN.
DESC-MAIN. MOVE " " TO PRO-DESC-TBL MOVE 1 TO PRO-IX1.
    MOVE P-NO TO PRO-NO PERFORM SET-PRO-LTH PERFORM CHK-STANDARD.
    IF PRO-KS=1 AND PRO-LTH=6 MOVE P-DESC TO PRO-DESC(PRO-IX1)(1:16)
      IF PRO-PR(1) NUMERIC AND PRO-PR(1) NOT=0
        MOVE 8 TO T-TBL MOVE PRO-PR(1) TO T-NO PERFORM RD-TBL
        MOVE T-LINE TO PRO-DESC(PRO-IX1)(17:) END-IF
     ELSE MOVE P-DESC TO PRO-DESC(PRO-IX1)
      IF P-EDESC1>" " ADD 1 TO PRO-IX1 MOVE P-EDESC1 TO PRO-DESC(PRO-IX1) END-IF
      IF P-EDESC2>" " ADD 1 TO PRO-IX1 MOVE P-EDESC2 TO PRO-DESC(PRO-IX1) END-IF.
DESC-SEC. IF PRO-SIND=0 AND P-FINDESC>" " ADD 1 TO PRO-IX1 MOVE P-FINDESC TO PRO-DESC(PRO-IX1).
    ADD 1 TO PRO-IX1 PERFORM DESC-PRINT.
    IF P-PRDESC>" " MOVE P-PRDESC TO PRO-DESC(PRO-IX1)
      MOVE PRO-PRINT TO PRO-DESC(PRO-IX1)(20:)
     ELSE MOVE PRO-PRINT TO PRO-DESC(PRO-IX1).
DESC-IMAIN. MOVE " " TO PRO-DESC-TBL MOVE 1 TO PRO-IX1.
    MOVE P-DESC TO PRO-DESC(PRO-IX1).
    IF P-EDESC1>" " ADD 1 TO PRO-IX1 MOVE P-EDESC1 TO PRO-DESC(PRO-IX1).
    IF P-EDESC2>" " ADD 1 TO PRO-IX1 MOVE P-EDESC2 TO PRO-DESC(PRO-IX1).
DESC-PRINT. MOVE " " TO PRO-PRINT.
    IF P-PRINT>0 MOVE "IF" TO PRO-PRT1 MOVE P-PRINT TO PRO-PRT2
      IF P-PRINT-REV>" " MOVE "REV" TO PRO-PRT3 MOVE P-PRINT-REV TO PRO-PRT4.
DESC-ENG. MOVE " " TO PRO-ENG.
    MOVE 0 TO PRO-IX1 INSPECT P-PRDESC TALLYING PRO-IX1 FOR CHARACTERS BEFORE "'".
    IF PRO-IX1<=17 MOVE P-PRDESC(PRO-IX1 + 2:3) TO PRO-ENG
      IF PRO-ENG(2:1)="'" MOVE " " TO PRO-ENG(2:)
        ELSE IF PRO-ENG(3:1)="'" MOVE " " TO PRO-ENG(3:).
DESC-QUAL. MOVE " " TO PRO-QUAL.
    IF A-N1=1 MOVE 0 TO PRO-IX1 INSPECT P-PRDESC TALLYING PRO-IX1 FOR CHARACTERS BEFORE "PF SAFETY"
      IF PRO-IX1<=9 MOVE "PF SAFETY" TO PRO-QUAL.
    IF A-N1=2 MOVE 0 TO PRO-IX1 INSPECT P-PRDESC TALLYING PRO-IX1 FOR CHARACTERS BEFORE "GM 9050P"
      IF PRO-IX1<=10 MOVE "GM9050P" TO PRO-QUAL.
DESC-HARM. MOVE " " TO PRO-HARM IF A-N1 NOT=0 MOVE 15 TO T-TBL MOVE A-N1 TO T-NO
      PERFORM RD-TBL MOVE T-LINE TO PRO-HARM.
DESC-CAT. MOVE " " TO T-LINE.
    IF PRO-CAT NOT=0 MOVE 2 TO T-TBL MOVE PRO-CAT TO T-NO PERFORM RD-TBL.

CALC-GWEIGHT. PERFORM GROSS-WEIGHT COMPUTE A-N1 ROUNDED=A-N1 * PRO-GROSS / 100.
CALC-TWEIGHT. MOVE P-WEIGHT TO A-D1 IF P-INC-NUT=1 ADD P-WEIGHT-NUT TO A-D1.
GROSS-WEIGHT. IF P-GROSS NOT=0 MOVE P-GROSS TO PRO-GROSS
       ELSE COMPUTE PRO-GROSS ROUNDED=P-WEIGHT / 0.9.
CALC-NCOILS. PERFORM GROSS-WEIGHT.
    COMPUTE A-L1 ROUNDED=R-QTY-ORD * PRO-GROSS / 100 / WEI-COIL.
CALC-PRATE. IF P-RATE>0 MOVE P-RATE TO A-N1 ELSE COMPUTE A-N1 ROUNDED=M-TQTY / 8.
NUM-NUTS. MOVE 1 TO PRO-NNUT IF P-PACKING=9 MOVE 2 TO PRO-NNUT.
CHK-STANDARD. IF P-CAT>=12 AND<=21 OR=22 OR 34 OR 52 OR 55 OR 58
      MOVE 1 TO PRO-KS ELSE MOVE 0 TO PRO-KS.
CHK-NEW. IF SYS-DATE - P-CRDATE<=365 MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
SET-PRO-LTH. MOVE P-NO TO A-A1 PERFORM STR-LTH MOVE A-N1 TO PRO-LTH.
CHK-WIRE. IF PRO-AWIRE(6:1)="0" MOVE " " TO PRO-AWIRE(6:1).
CHK-PUR. IF (IFAST OR ITOOL) AND A-N1=99 OR INUT AND (A-N1=99 OR 98 OR 97)
      MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.

CHK-QBIN. PERFORM CHK-QB1 THRU CHK-QB9.
CHK-QB1. MOVE 0 TO A-N1 INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>B-KP REGARDLESS INVALID GO CHK-QB4.
CHK-QB3. READ BIN NEXT REGARDLESS END GO CHK-QB4. IF B-PROD>P-NO GO CHK-QB4.
    IF B-CONT="Q" ADD B-QTY TO A-N1. GO CHK-QB3.
CHK-QB4.
CHK-QB9. EXIT.
CHK-BIN-EMPTY. IF B-QTY<=0 INITIALIZE B-QTY B-QTY-AL B-QTY-PACK
      B-DATE B-LYEAR B-LOT B-PROD B-CONT B-QREASON.
SET-B-LYEAR. MOVE B-LOT TO D-LOT PERFORM D-LOTDATE MOVE D-YEAR TO B-LYEAR.

LPRICE-CALC. MOVE L-PRICE TO CL-PRICE MOVE L-MODE TO CL-MODE.
    MOVE L-DISC TO CL-DISC PERFORM PRICE-CALC.
KPRICE-CALC. MOVE LK-PRICE TO CL-PRICE MOVE LK-MODE TO CL-MODE.
    MOVE LK-DISC TO CL-DISC PERFORM PRICE-CALC.
* note 88
PRICE-CALC. PERFORM PRI-C1 THRU PRI-C9.
PRI-C1. COMPUTE CL-T1 ROUNDED=CL-QTY * CL-PRICE.
    IF CL-MODE="C" DIVIDE 100 INTO CL-T1 ROUNDED.
    IF CL-MODE="M" DIVIDE 1000 INTO CL-T1 ROUNDED.
    IF CL-DISC=0 MOVE "NET" TO CL-DTXT GO PRI-C8.
    MOVE 6 TO T-TBL MOVE CL-DISC TO T-NO PERFORM RD-TBL.
    MOVE " " TO CL-DTXT MOVE 1 TO CL-IXD CL-IXP.
PRI-C3. MOVE T-DIS(CL-IXD) TO CL-NDIS.
    IF CL-ADIS(1:1) NOT="0" MOVE CL-ADIS(1:1) TO CL-C PERFORM PRI-P.
    MOVE CL-ADIS(2:1) TO CL-C PERFORM PRI-P.
    IF CL-ADIS(3:1) NOT="0"
      MOVE "." TO CL-C PERFORM PRI-P MOVE CL-ADIS(3:1) TO CL-C PERFORM PRI-P.
    MOVE "/" TO CL-C PERFORM PRI-P.
    IF CL-NDIS NOT=0 COMPUTE CL-T1 ROUNDED=CL-T1 * (1 - CL-TDIS).
    ADD 1 TO CL-IXD IF CL-IXD<=4 GO PRI-C3.
PRI-C8. COMPUTE CL-AMT ROUNDED=CL-T1.
PRI-C9. EXIT.
PRI-P. MOVE CL-C TO CL-DTXT(CL-IXP:1) ADD 1 TO CL-IXP.
PLATING-READ. MOVE " " TO T-PLS MOVE 0 TO T-PLR.
    IF L-PLATING NOT=0 MOVE 11 TO T-TBL MOVE L-PLATING TO T-NO PERFORM RD-TBL.
    IF T-PLR NOT NUMERIC MOVE 0 TO T-PLR.
PLATING-CALC. IF L-PLATING NOT=0 PERFORM PLATING-READ
      COMPUTE CL-D1 ROUNDED=CL-WEIGHT * T-PLR / 100 ADD CL-D1 TO CL-AMT.
SURCH-CALC. MOVE 0 TO CL-SURCH CL-D1 CL-KSM.
    MOVE C-SUR TO CL-SUR IF L-SPECIAL=1 MOVE L-SUR TO CL-SUR.
    INITIALIZE IO-REC MOVE L-CUS TO IO-CUS MOVE L-PROD TO IO-PROD.
    READ PRICE REGARDLESS INVALID CONTINUE. IF IO-SUR>0 MOVE IO-SUR TO CL-SUR.
    IF IO-SURCH>0 MOVE 1 TO CL-KSM MOVE IO-SURCH TO CL-SURCH
      COMPUTE CL-D1 ROUNDED=CL-QTY * CL-SURCH / 1000
     ELSE IF CL-SUR>0 MOVE IF-SURCH(CL-SUR) TO CL-SURCH
      COMPUTE CL-D1 ROUNDED=CL-WEIGHT * CL-SURCH.
    ADD CL-D1 TO CL-AMT.
WEIGHT-CALC. COMPUTE CL-WEIGHT ROUNDED CL-WEIGHT-I ROUNDED=CL-QTY * P-WEIGHT / 100.
RD-MODE. MOVE 1 TO A-N1.
    IF A-A1="C" MOVE 100 TO A-N1. IF A-A1="M" MOVE 1000 TO A-N1.

PRI-CHKVEN. PERFORM VARYING A-X1 FROM 1 BY 1
      UNTIL A-X1>3 OR PH-VENDOR(A-X1)=OK-VENDOR CONTINUE END-PERFORM.
PRI-SET-PRICE. PERFORM PRI-SP1 THRU PRI-SP9.
PRI-SP1. PERFORM PRI-CHKVEN IF A-X1<=3 GO PRI-SP8.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3 OR PH-VENDOR(A-X1)=0 CONTINUE END-PERFORM.
    IF A-X1>3 MOVE 3 TO A-X1. MOVE OK-VENDOR TO PH-VENDOR(A-X1).
PRI-SP8. MOVE LK-PRICE TO PH-PRICE(A-X1).
PRI-SP9. EXIT.

* note 16.1
SET-DEM-DATE. COMPUTE PRO-DEM-DATE=SYS-DATE + 91.
    IF IF-DEM-DATE>PRO-DEM-DATE MOVE IF-DEM-DATE TO PRO-DEM-DATE.
ADD-DEM. IF L-QTY NOT=LIT-Q9 PERFORM SET-DEM-DATE
      IF L-DATE-REQ<=PRO-DEM-DATE ADD L-QTY-LEFT TO P-DEMAND
        ELSE ADD L-QTY-LEFT TO P-FDEMAND.
SUB-DEM. IF L-QTY NOT=LIT-Q9 PERFORM SET-DEM-DATE
      IF L-DATE-REQ<=PRO-DEM-DATE SUBTRACT L-QTY-LEFT FROM P-DEMAND
        ELSE SUBTRACT L-QTY-LEFT FROM P-FDEMAND.
DEL-ORDER. PERFORM DEL-O1 THRU DEL-O9.
DEL-O1. DELETE SAORD COMPUTE L-NO=100 * O-NO.
DEL-O3. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO DEL-O9.
    MOVE L-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO DEL-O4.
    PERFORM RD-GEN PERFORM SUB-DEM REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
DEL-O4. DELETE SALIN GO DEL-O3.
DEL-O9. EXIT.

SET-TRDATE. MOVE TR-DATE-PREV(1) TO TR-DATE-PREV(2) MOVE TR-DATE-PAY TO TR-DATE-PREV(1).
UPDATE-CUST-BAL. ADD A-D1 TO C-TOT.
    MOVE TR-DATE TO D-DATE PERFORM D-CURR COMPUTE D-N1=-D-N1.
    EVALUATE TRUE
      WHEN D-N1<1 ADD A-D1 TO C-CUR
      WHEN D-N1=1 ADD A-D1 TO C-30
      WHEN D-N1=2 ADD A-D1 TO C-60
      WHEN D-N1=3 ADD A-D1 TO C-90
      WHEN D-N1>3 ADD A-D1 TO C-120
      END-EVALUATE.
UPDATE-CUST-PAY. COMPUTE A-N1=SYS-DATE - TR-DATE.
    IF A-N1>0 ADD A-N1 TO C-PAY-DAYS(1) ADD 1 TO C-PAY-NUM(1).
* note 69
CHK-OVERSEAS. IF L-CUS="06233" OR "06509"
      COMPUTE A-D1 ROUNDED=A-D1 - 5.25 * (L-WEIGHT + L-WEIGHT-NUT) / 100.
CHK-CUSFORM. IF A-A1<="07999" OR="08012" OR "15150" OR "15175"
      MOVE 1 TO CFO-IND ELSE MOVE 0 TO CFO-IND.
CHK-CUSTYPE. IF C-TYPE="X" OR "Y" MOVE 1 TO CAU-IND ELSE MOVE 0 TO CAU-IND.
SET-BROKER. IF C-BROKER=0 MOVE MSG-M2 TO A-A1
      ELSE MOVE " " TO A-A1 MOVE 4 TO T-TBL MOVE C-BROKER TO T-NO PERFORM RD-TBL
        STRING "CUSTOMS CLEARANCE BY " T-LINE DELIMITED SIZE INTO A-A1.
CALC-PACKS. MOVE 0 TO A-N1 A-N2.
    PERFORM VARYING A-X1 FROM 3 BY 1 UNTIL A-X1>5 ADD FO-PACKS(A-X1) TO A-N1 END-PERFORM.
    PERFORM VARYING A-X1 FROM 6 BY 1 UNTIL A-X1>9 ADD FO-PACKS(A-X1) TO A-N2 END-PERFORM.

CHK-SHIFT. PERFORM VARYING A-N1 FROM 1 BY 1 UNTIL A-N1>4 OR LIT-XDAN(A-N1:1)=XA1 CONTINUE END-PERFORM.
    SUBTRACT 1 FROM A-N1.
* note 27.2
CALC-QTY-WEIGHT. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-PRIMARY OR J-BKTOT=0 MOVE J-WEIGHT TO J-AWEIGHT
      ELSE IF J-BKEMPTY=0 MOVE 0 TO J-WEIGHT
        COMPUTE J-QTY ROUNDED=J-AWEIGHT * 100 / P-WEIGHT SIZE ERROR CONTINUE END-COMPUTE
        IF J-MAC>=29 AND<=31 MULTIPLY 0.95 BY J-QTY ROUNDED END-IF
       ELSE MOVE 0 TO J-WEIGHT COMPUTE J-AWEIGHT ROUNDED=J-QTY * P-WEIGHT / 100.
BUCKET-CALC. PERFORM BUCK-C1 THRU BUCK-C9.
BUCK-C1. MOVE J-KEY TO BU-JKEY MOVE 0 TO BU-NUM J-BKEMPTY J-BKTOT J-AWEIGHT.
    START BUCKET KEY>BU-KEY REGARDLESS INVALID GO BUCK-C8.
BUCK-C3. READ BUCKET NEXT REGARDLESS END GO BUCK-C8. IF BU-JKEY NOT=J-KEY GO BUCK-C8.
    IF BU-WEIGHT=0 MOVE 1 TO J-BKEMPTY.
    ADD 1 TO J-BKTOT ADD BU-WEIGHT TO J-AWEIGHT GO BUCK-C3.
BUCK-C8. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY MOVE J-WEIGHT TO J-AWEIGHT.
BUCK-C9. EXIT.
CHK-BUCKET-WEIGHT. MOVE 0 TO A-S1.
    IF BU-WEIGHT>1599 MOVE "WEIGHT CANNOT BE OVER 1599" TO ERR-MESG
      PERFORM DSP-ERR MOVE 1 TO A-S1.
CHK-SUBCON. IF A-N1>=400 AND<=598 OR=634 OR 639 OR 790 OR 792
      MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
CALC-OUTCON. MOVE 0 TO A-N2.
    IF A-X1=1 MOVE 158 TO A-N2. IF A-X1=2 MOVE 168 TO A-N2. IF A-X1=3 MOVE 169 TO A-N2.
    IF A-N1>=530 AND<=549 MOVE 166 TO A-N2. MOVE A-N2 TO A-N1.
GET-PWEIGHT. MOVE P-WEIGHT TO A-D1 IF SJ-MAC=541 AND P-PWEIGHT>0 MOVE P-PWEIGHT TO A-D1.
* note 174
CALC-QLEFT. IF R-PUR=0
     IF R-FIN=0 COMPUTE R-QTY-LEFT=R-QTY-ORD
       ELSE COMPUTE R-QTY-LEFT=R-QTY-PROD - R-QTY-REC
      ELSE IF R-QTY-PROD>R-QTY-ORD COMPUTE R-QTY-LEFT=R-QTY-PROD - R-QTY-REC
       ELSE COMPUTE R-QTY-LEFT=R-QTY-ORD - R-QTY-REC.
FIND-RLDATE. MOVE 0 TO A-N1.
    PERFORM VARYING A-X2 FROM 1 BY 1 UNTIL A-X2>3
      IF R-LDATE(A-X2) NOT=0 MOVE R-LDATE(A-X2) TO D-DATE
        ELSE MOVE R-DATE TO D-DATE END-IF
      IF D-DATE>A-N1 MOVE D-DATE TO A-N1 MOVE A-X2 TO A-X1 END-IF END-PERFORM.
    MOVE A-N1 TO D-DATE.
* note 159
CALC-TARGET. IF PROC-PRIMARY AND P-RATE>0 COMPUTE A-N1 ROUNDED=A-D1 * P-RATE
      ELSE COMPUTE A-N1 ROUNDED=A-D1 * M-TQTY / 8.
PROC-TYPE. EVALUATE TRUE
      WHEN A-N1>=1 AND<=88 SET PROC-PRIMARY TO TRUE
      WHEN A-N1=89 SET PROC-SCRAP TO TRUE
      WHEN A-N1>=90 AND<=93 SET PROC-REJECT TO TRUE
      WHEN A-N1>=94 AND<=95 SET PROC-DEFECT TO TRUE
      WHEN A-N1>=132 AND<=153 SET PROC-TAP TO TRUE
      WHEN A-N1>=154 AND<=157 OR=159 OR 164 OR 165 OR>=170 AND<=179 SET PROC-THREAD TO TRUE
      WHEN A-N1=158 OR 166 OR 168 OR 169 SET PROC-OUTCON TO TRUE
      WHEN A-N1>=279 AND<=286 SET PROC-HEAT TO TRUE
      WHEN A-N1>=400 AND<=598 SET PROC-INCON TO TRUE
      WHEN A-N1=599 SET PROC-RETURN TO TRUE
      WHEN A-N1=624 SET PROC-INSPECT TO TRUE
      WHEN A-N1=625 SET PROC-MANUSORT TO TRUE
      WHEN A-N1>=626 AND<=634 OR=638 SET PROC-AUTOSORT TO TRUE
      WHEN A-N1>=635 AND<=637 SET PROC-LOTINSP TO TRUE
      WHEN A-N1>=780 AND<=799 SET PROC-PACK TO TRUE
      WHEN A-N1=845 OR 850 SET PROC-RECEIVE TO TRUE
      WHEN A-N1=846 SET PROC-BOLTNUT TO TRUE
      WHEN A-N1=940 SET PROC-PHYSINV TO TRUE
      WHEN A-N1=955 OR 956 SET PROC-ADJUST TO TRUE
      WHEN A-N1>=975 AND<=999 SET PROC-MAINT TO TRUE
      WHEN OTHER MOVE 0 TO PROC-CODE.
PROC-XTYPE. PERFORM PROC-TYPE.
    IF PROC-INSPECT OR PROC-MANUSORT OR PROC-AUTOSORT OR PROC-LOTINSP SET PROC-XINSPECT TO TRUE.
    IF PROC-RECEIVE OR PROC-BOLTNUT SET PROC-XRECEIVE TO TRUE.

SET-PART. MOVE " " TO PART-NO STRING P-DIAM "-" P-GRADE DELIMITED " " INTO PART-NO.
SET-ANNEAL. MOVE P-PROC TO PART-PA MOVE P-CLEAN TO PART-PC.
PART-TYPE. EVALUATE TRUE
      WHEN PH-CAT>=100 AND<=199 SET PART-MAT TO TRUE
      WHEN PH-CAT>=200 AND<=499 SET PART-TOOL TO TRUE
      WHEN PH-CAT>=500 AND<=599 OR=701 SET PART-MAINT TO TRUE
      WHEN OTHER MOVE 0 TO PART-CODE.
* note 243
DIV-PAMT. IF PART-MAT DIVIDE 2000 INTO A-T1 ROUNDED
      ELSE IF PH-MODE="C" DIVIDE 100 INTO A-T1 ROUNDED
      ELSE IF PH-MODE="M" DIVIDE 1000 INTO A-T1 ROUNDED.
MUL-PAMT. IF PART-MAT MULTIPLY 2000 BY A-T1
      ELSE IF PH-MODE="C" MULTIPLY 100 BY A-T1
      ELSE IF PH-MODE="M" MULTIPLY 1000 BY A-T1.
DIV-SAMT. IF A-A1="C" DIVIDE 100 INTO A-T1 ROUNDED
      ELSE IF A-A1="M" DIVIDE 1000 INTO A-T1 ROUNDED.
MUL-SAMT. IF A-A1="C" MULTIPLY 100 BY A-T1
      ELSE IF A-A1="M" MULTIPLY 1000 BY A-T1.
DIV-MQTY. IF PART-MAT DIVIDE 2000 INTO A-T1 ROUNDED.
MUL-MQTY. IF PART-MAT MULTIPLY 2000 BY A-T1.
* note 235
CHK-ROLL. IF PH-CAT=243 MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
ADJ-PLIFE. PERFORM CHK-ROLL IF A-S1=1 COMPUTE A-T1 ROUNDED=A-T1 * P-WEIGHT / 100.
CHK-TLIFE. MOVE 1 TO A-N1.
    IF PH-LIFE>=100 MOVE 2 TO A-N1. IF PH-LIFE>=1000 MOVE 3 TO A-N1.
CALC-PART-REQ. PERFORM CAP-R1 THRU CAP-R9.
CAP-R1. IF PH-ASM=1 COMPUTE A-N1=PH-ROP - PH-HAND - PH-ORDER
      IF A-N1<0 MOVE 0 TO A-N1 END-IF GO CAP-R9.
    MOVE PH-ASM-HAND TO A-N2 IF PH-ROP>3 OR PH-LIFE<50 MOVE 0 TO A-N2.
    COMPUTE A-N1=(PH-HAND + A-N2) + PH-ORDER - (PH-DEMAND + PH-ASM-DEMAND).
    IF A-N1>=PH-ROP / 2 MOVE 0 TO A-N1 GO CAP-R9. COMPUTE A-N1=PH-ROP - A-N1.
    IF PH-EOQ>0 IF PH-EOQ>A-N1 MOVE PH-EOQ TO A-N1 END-IF
      ELSE IF PH-ROP>A-N1 MOVE PH-ROP TO A-N1.
CAP-R9. EXIT.
CALC-LKQTY. COMPUTE A-T1=LK-QTY - LK-QTY-REC PERFORM MUL-MQTY.

    REPLACE ==CLOSED== BY ==LK-BLANKET=1 OR LK-QTY<=LK-QTY-REC==.
* note 64
FIND-PO-LATE. PERFORM FPO-L1 THRU FPO-L9.
FPO-L1. MOVE A-N1 TO A-N2.
    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO FPO-L19.
FPO-L13. READ PURLIN NEXT REGARDLESS END GO FPO-L19. IF LK-PART NOT=PH-NO GO FPO-L19.
    IF CLOSED GO FPO-L13. MOVE 0 TO LK-DATE-TMP.
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN GO FPO-L13.
FPO-L19. MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO FPO-L8.
FPO-L3. READ PURLIN NEXT REGARDLESS END GO FPO-L8. IF LK-PART NOT=PH-NO GO FPO-L8.
    IF CLOSED GO FPO-L3.
    MOVE LK-DATE-REQ TO LK-DATE-TMP IF LK-DATE-REQ>SYS-DATE GO FPO-L78.
    MOVE LK-KP TO A-A1.
    COMPUTE A-N1=SYS-DATE + 70 IF A-N2>0 AND<A-N1 MOVE A-N2 TO A-N1.
FPO-L5. READ PURLIN NEXT REGARDLESS END GO FPO-L6. IF LK-PART NOT=PH-NO GO FPO-L6.
    IF CLOSED OR LK-DATE-REQ<=SYS-DATE GO FPO-L5. MOVE LK-DATE-REQ TO A-N1.
FPO-L6. MOVE A-A1 TO LK-KP START PURLIN KEY=LK-KP REGARDLESS.
FPO-L7. READ PURLIN NEXT REGARDLESS.
    IF CLOSED OR LK-DATE-TMP NOT=0 GO FPO-L7. MOVE A-N1 TO LK-DATE-TMP.
FPO-L78. REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN GO FPO-L3.
FPO-L8.
FPO-L9. EXIT.
    REPLACE OFF.

COU-LINES. PERFORM COU-L1 THRU COU-L9.
COU-L1. MOVE FL-PROD TO A-A1 PERFORM PROD-RGD INITIALIZE COU-CTBL.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
      MOVE FL-COUNTRY(1,A-X1) TO COU-COUNTRY(1,A-X1)
      MOVE FL-CQTY(1,A-X1) TO COU-QTY(1,A-X1) MOVE FL-PROD TO COU-PROD(1,A-X1)
      MOVE PRO-DESC(1) TO COU-DESC(1,A-X1) MOVE P-HCODE TO COU-HCODE(1,A-X1)
      MOVE FL-PRICE TO COU-PRICE(1,A-X1) MOVE FL-MODE TO COU-MODE(1,A-X1)
      COMPUTE COU-EXT(1,A-X1) ROUNDED=FL-EXT * COU-QTY(1,A-X1) / FL-QTY
      COMPUTE COU-WEIGHT(1,A-X1) ROUNDED=COU-QTY(1,A-X1) * P-WEIGHT * WEI-LB / 100
      END-PERFORM.
    MOVE P-NUT TO PRO-NUT IF GEN-NUT>" " MOVE GEN-NUT TO PRO-NUT.
    IF PRO-NUT=" " GO COU-L9.
    IF GEN-NUT=" " MOVE P-WEIGHT-NUT TO A-D1 ELSE MOVE GEN-WEIGHT-NUT TO A-D1.
    MOVE PRO-NUT TO P-NO READ PRODUCT REGARDLESS INVALID MOVE " " TO PRO-NUT GO COU-L9.
    PERFORM PROD-DESC MOVE P-MODE TO A-A1 PERFORM RD-MODE.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
      MOVE FL-COUNTRY(2,A-X1) TO COU-COUNTRY(2,A-X1)
      MOVE FL-CQTY(2,A-X1) TO COU-QTY(2,A-X1) MOVE P-NO TO COU-PROD(2,A-X1)
      MOVE PRO-DESC(1) TO COU-DESC(2,A-X1) MOVE P-HCODE TO COU-HCODE(2,A-X1)
      MOVE P-PRICE1 TO COU-PRICE(2,A-X1) MOVE P-MODE TO COU-MODE(2,A-X1)
      COMPUTE COU-EXT(2,A-X1) ROUNDED=P-PRICE1 * COU-QTY(2,A-X1) / A-N1
      COMPUTE COU-WEIGHT(2,A-X1) ROUNDED=COU-QTY(2,A-X1) * A-D1 * WEI-LB / 100
      END-PERFORM.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
      SUBTRACT P-PRICE1 FROM COU-PRICE(1,A-X1)
      COMPUTE COU-EXT(1,A-X1) ROUNDED=
        COU-EXT(1,A-X1) - P-PRICE1 * COU-QTY(1,A-X1) / A-N1
      END-PERFORM.
COU-L9. EXIT.

INIT-B. MOVE LOW-VALUES TO B-RECORD INITIALIZE B-REC B-KP.
INIT-R. MOVE LOW-VALUES TO R-RECORD INITIALIZE R-REC R-KP.
INIT-O. MOVE LOW-VALUES TO O-RECORD INITIALIZE O-REC O-KC.
INIT-L. MOVE LOW-VALUES TO L-RECORD INITIALIZE L-REC L-KP.
INIT-TS. MOVE LOW-VALUES TO TS-RECORD INITIALIZE TS-REC.
INIT-OP. MOVE LOW-VALUES TO OP-RECORD INITIALIZE OP-REC.
INIT-QB. MOVE LOW-VALUES TO QB-RECORD INITIALIZE QB-REC QB-KP.
INIT-BH. MOVE LOW-VALUES TO BH-RECORD INITIALIZE BH-REC BH-KP.
INIT-AT. MOVE LOW-VALUES TO AT-RECORD INITIALIZE AT-REC AT-KEY AT-KD.
INIT-DY. MOVE LOW-VALUES TO DY-RECORD INITIALIZE DY-REC DY-KEY.
INIT-MT. MOVE LOW-VALUES TO MT-RECORD INITIALIZE MT-REC MT-KEY.
INIT-PL. MOVE LOW-VALUES TO PL-RECORD INITIALIZE PL-REC PL-KO.
INIT-PH. MOVE LOW-VALUES TO PH-RECORD INITIALIZE PH-REC PH-KA.
INIT-TR. MOVE LOW-VALUES TO TR-RECORD INITIALIZE TR-REC TR-KI TR-KB.
INIT-OK. MOVE LOW-VALUES TO OK-RECORD INITIALIZE OK-REC OK-KV.
INIT-LK. MOVE LOW-VALUES TO LK-RECORD INITIALIZE LK-REC LK-KEY LK-KP LK-SUB.
INIT-LA. MOVE LOW-VALUES TO LA-RECORD INITIALIZE LA-REC.
INIT-SJ. MOVE LOW-VALUES TO SJ-RECORD INITIALIZE SJ-REC SJ-KEY.
INIT-P. MOVE LOW-VALUES TO P-RECORD INITIALIZE P-REC.
    MOVE SYS-DATE TO P-CRDATE P-GDATE P-NDATE.
INIT-J. MOVE LOW-VALUES TO J-RECORD INITIALIZE J-REC J-KEY J-KM J-KN J-KD.
    MOVE SYS-DATE TO J-DATE MOVE ALL "0" TO J-NOTE.
INIT-BU. MOVE LOW-VALUES TO BU-RECORD INITIALIZE BU-REC MOVE J-KEY TO BU-JKEY.
    COMPUTE BU-ZDATE=999999 - BU-DATE.
INIT-HO. MOVE LOW-VALUES TO HO-RECORD INITIALIZE HO-REC HO-KEY HO-KB HO-KV.
    MOVE O-NO TO HO-ORD MOVE O-CUS TO HO-CUS.
    IF O-VIA=0 MOVE 99 TO HO-VIA ELSE MOVE O-VIA TO HO-VIA.
INIT-HL. MOVE LOW-VALUES TO HL-RECORD INITIALIZE HL-REC MOVE HO-ORDSEQ TO HL-ORDSEQ.
    MOVE L-LINE TO HL-LINE MOVE L-PROD TO HL-PROD MOVE HO-DATE-REQ TO HL-DATE-REQ.
    MOVE L-CONT TO HL-CONT.
INIT-BA. MOVE LOW-VALUES TO BA-RECORD INITIALIZE BA-REC MOVE HL-NO TO BA-NO.
INIT-VO. MOVE LOW-VALUES TO VO-RECORD INITIALIZE VO-REC.
INIT-VL. MOVE LOW-VALUES TO VL-RECORD INITIALIZE VL-REC.
    MOVE VO-NO TO VL-NO MOVE A-N1 TO VL-TYPE MOVE VO-DATE TO VL-DATE.
    IF VL-TYPE=0 MOVE 0 TO VL-PROC MOVE 1 TO VL-SHIFT ELSE MOVE 0 TO VL-SHIFT.
    MOVE 0 TO VL-EMP.
INIT-PU. MOVE LOW-VALUES TO PU-RECORD INITIALIZE PU-REC.
    MOVE WS-DIV TO PU-DIV MOVE LK-PART TO PU-PART MOVE OK-VENDOR TO PU-VENDOR.
    COMPUTE PU-ZDATE=999999 - SYS-DATE.
    ACCEPT SYS-TIME FROM TIME COMPUTE PU-ZTIME=99999999 - SYS-TIME.
    MOVE PU-DIV TO PU-VDIV MOVE PU-ZDATE TO PU-ZVDATE MOVE PU-ZTIME TO PU-ZVTIME.
    MOVE OK-INV TO PU-INV MOVE OK-DATE-REQ TO PU-DATE-REQ MOVE LK-ORD TO PU-ORD.
    MOVE LK-CAT TO PU-CAT MOVE LK-MODE TO PU-MODE MOVE LK-GL TO PU-GL.
INIT-UN. MOVE LOW-VALUES TO US-RECORD INITIALIZE US-REC.
    MOVE 1 TO US-PC MOVE "PR" TO US-PRNM.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>24 MOVE ALL "0" TO US-TDX(A-X1) END-PERFORM.

SET-OKV. MOVE OK-NO TO A-A1 MOVE 8 TO A-N1 PERFORM STR-BINREV MOVE A-A1 TO OK-ZNO.
SET-JKD. MOVE J-NO TO J-KNO MOVE J-DATE TO J-KDATE MOVE J-SHIFT TO J-KSHIFT.
    MOVE J-MAC TO J-KMAC.
SET-ATKD. MOVE AT-DIV TO AT-KDIV MOVE AT-VEN TO AT-KVEN.
    COMPUTE AT-ZDATE=999999 - AT-INV-DATE.
    MOVE AT-TYPE TO AT-KTYPE MOVE AT-INV TO AT-KINV.

* note 26.1
GET-CUSORD. IF HO-CUSORD>" " MOVE HO-CUSORD TO A-A1 ELSE MOVE O-CUSORD TO A-A1.
GET-HLCUSORD. IF HL-CUSORD>" " MOVE HL-CUSORD TO A-A1 ELSE PERFORM GET-CUSORD.
RD-EXT. PERFORM RD-EXT1 THRU RD-EXT9.
RD-EXT1. MOVE 0 TO HO-SEQ START SHIPORD KEY>=HO-KEY REGARDLESS INVALID GO RD-EXT8.
    READ SHIPORD NEXT REGARDLESS END GO RD-EXT8. IF HO-ORD NOT=A-N1 GO RD-EXT8.
    IF HO-SEQ=0 GO RD-EXT9. DISPLAY "EXT. (1-19): __" LINE IXT COLUMN IXU BOLD.
    ADD 13 TO IXU ACCEPT HO-SEQ COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ SHIPORD REGARDLESS INVALID GO RD-EXT8. GO RD-EXT9.
RD-EXT8. MOVE "ORDER NOT FOUND IN SHIPPING FILE" TO ERR-MESG PERFORM DSP-ERR.
    MOVE 0 TO A-N1.
RD-EXT9. EXIT.
DSP-EXT. MOVE " " TO EXT-D.
    IF EXT-S>0 MOVE "-" TO EXT-DA
      IF EXT-S<10 MOVE EXT-S TO EXT-DN1 ELSE MOVE EXT-S TO EXT-DN2.

OPEN-CUSCONT. OPEN I-O CUSCONT ALLOWING ALL.
GET-CUSPHONE. PERFORM GET-CP1 THRU GET-CP9.
GET-CP1. MOVE " " TO A-A1.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3 MOVE C-INFO(A-X1) TO A-A2
      MOVE 0 TO A-X2 INSPECT A-A2 TALLYING A-X2 FOR CHARACTERS BEFORE "PHONE:"
      IF A-X2<20 MOVE A-A2(A-X2 + 1:) TO A-A1 GO GET-CP9 END-IF
      MOVE 0 TO A-X2 INSPECT A-A2 TALLYING A-X2 FOR CHARACTERS BEFORE "TEL:"
      IF A-X2<20 MOVE A-A2(A-X2 + 1:) TO A-A1 GO GET-CP9 END-IF END-PERFORM.
GET-CP9. EXIT.
GET-CUSADD. PERFORM GET-CS1 THRU GET-CS9.
GET-CS1. MOVE C-NAME TO CUS-LINE(1) MOVE C-ADD1 TO CUS-LINE(2).
    MOVE C-ADD2 TO CUS-LINE(3) MOVE C-POST TO CUS-LINE(4) MOVE " " TO CUS-LINE(5).
    MOVE C-NO TO UH-NO READ SOLDTO REGARDLESS INVALID GO GET-CS9.
    IF UH-LINE(1)>" " PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>5
      MOVE UH-LINE(A-X1) TO CUS-LINE(A-X1) END-PERFORM.
GET-CS9. EXIT.
GET-O-CUSADD. MOVE SA-NAME TO O-NAME.
    MOVE SA-ADD1 TO O-ADD1 MOVE SA-ADD2 TO O-ADD2 MOVE SA-POST TO O-POST.
GET-FO-CUSADD. MOVE SA-NAME TO FO-NAME.
    MOVE SA-ADD1 TO FO-ADD1 MOVE SA-ADD2 TO FO-ADD2 MOVE SA-POST TO FO-POST.

CAN-ALLOC. PERFORM CAN-L1 THRU CAN-L9.
CAN-L1. IF HL-QTY-AL=0 AND HL-QTY-NAL=0 GO CAN-L9.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO CAN-L4.
CAN-L3. READ BINALLOC NEXT REGARDLESS END GO CAN-L4. IF BA-NO NOT=HL-NO GO CAN-L4.
    DELETE BINALLOC GO CAN-L3.
CAN-L4. MOVE 0 TO HL-QTY-AL HL-WEIGHT-AL.
CAN-L9. EXIT.
CAN-SHORDER. PERFORM CAN-S1 THRU CAN-S9.
CAN-S1. MOVE 9 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO CAN-S4.
CAN-S3. READ SHIPLIN NEXT REGARDLESS END GO CAN-S4. IF HL-ORDSEQ NOT=HO-ORDSEQ GO CAN-S4.
    PERFORM CAN-ALLOC REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO CAN-S3.
CAN-S4.
CAN-S9. EXIT.

DRAW-EXP-PH. MOVE PH-DRAW TO A-A1 MOVE PH-REV TO A-A2 PERFORM DRAW-EXP.
DRAW-EXP-LK. MOVE LK-DRAW TO A-A1 MOVE LK-REV TO A-A2 PERFORM DRAW-EXP.
* note 51
DRAW-EXP. PERFORM DRW-E1 THRU DRW-E9.
DRW-E1. IF A-A1=" " MOVE " " TO A-A2 GO DRW-E9.
    MOVE " " TO A-A3 MOVE 1 TO A-X1 A-X2.
DRW-E3. MOVE A-A1(A-X1:1) TO A-A3(A-X2:1).
    IF A-X1=4 OR 6 ADD 1 TO A-X2 MOVE "-" TO A-A3(A-X2:1).
    ADD 1 TO A-X1 A-X2 IF A-X1<=12 GO DRW-E3.
    MOVE A-A3 TO A-A1 MOVE A-A2 TO A-A3 MOVE A-A1 TO A-A2.
    IF A-A3>" " MOVE "REV" TO A-A2(A-X2 + 1:3) MOVE A-A3(1:1) TO A-A2(A-X2 + 5:1).
DRW-E9. EXIT.

MNT-GET-NAME. IF VL-VEN=1 MOVE VL-EMP TO A-N1 PERFORM RD-VEN MOVE V-NAME TO A-A1
      ELSE MOVE VL-EMP TO A-N1 PERFORM RD-EMPL MOVE E-NAME TO A-A1.
MNT-PRIOR. EVALUATE TRUE
      WHEN VO-PRIOR=1 MOVE "UNSAFE" TO A-A1
      WHEN VO-PRIOR=2 MOVE "MACHINE DOWN" TO A-A1
      WHEN VO-PRIOR=3 MOVE "PREV MAINT" TO A-A1
      WHEN VO-PRIOR=4 MOVE "ASAP" TO A-A1
      WHEN VO-PRIOR=5 MOVE "ENVIRONMENTAL" TO A-A1
      WHEN OTHER MOVE " " TO A-A1.
MNT-STATUS. EVALUATE TRUE
      WHEN VO-STATUS=0 MOVE "OPEN" TO A-A1
      WHEN VO-STATUS=1 MOVE "WIP" TO A-A1
      WHEN VO-STATUS=2 MOVE "CLOSED" TO A-A1
      WHEN OTHER MOVE " " TO A-A1.
MNT-DESC. IF VO-MAC=0 MOVE VO-MDESC1 TO MNT-DESC1 MOVE VO-MDESC2 TO MNT-DESC2
      ELSE IF VO-MAC-IND=0 MOVE VO-MAC TO A-N1 PERFORM RD-MAC
        MOVE M-DESC1 TO MNT-DESC1 MOVE M-DESC2 TO MNT-DESC2
      ELSE MOVE VO-MAC TO A-N1 PERFORM RD-MNTMAC
        MOVE MK-DESC1 TO MNT-DESC1 MOVE MK-DESC2 TO MNT-DESC2.
MNT-GETMAC. PERFORM MNT-GM1 THRU MNT-GM9.
MNT-GM1. MOVE 0 TO MNT-MAC MNT-KM MNT-KERR.
    MOVE MNT-IMAC TO A-A1 PERFORM STR-LTH MOVE A-N1 TO MNT-LTH.
    IF MNT-IMAC(1:1)="M" IF MNT-IMAC(2:MNT-LTH - 1) NOT NUMERIC GO MNT-GM6 END-IF
      MOVE 1 TO MNT-KM MOVE 2 TO MNT-IX1 GO MNT-GM8.
    IF MNT-LTH>3 OR MNT-IMAC(1:MNT-LTH) NOT NUMERIC GO MNT-GM6.
    MOVE 0 TO MNT-KM MOVE 1 TO MNT-IX1 GO MNT-GM8.
MNT-GM6. MOVE "INCORRECT MACHINE SPECIFICATION" TO ERR-MESG PERFORM DSP-ERR.
    MOVE 1 TO MNT-KERR GO MNT-GM9.
MNT-GM8. PERFORM UNTIL MNT-IX1>MNT-LTH
      COMPUTE MNT-MAC=MNT-MAC * 10 + MNT-IN(MNT-IX1) ADD 1 TO MNT-IX1 END-PERFORM.
MNT-GM9. EXIT.
MNT-SETMAC. MOVE " " TO MNT-IMAC MOVE VO-MAC TO MNT-MAC.
    MOVE 1 TO MNT-IX2 IF VO-MAC-IND=1 MOVE "M" TO MNT-IMAC(1:1) MOVE 2 TO MNT-IX2.
    IF MNT-MAC>99 MOVE 1 TO MNT-IX1 ELSE IF MNT-MAC>9 MOVE 2 TO MNT-IX1
      ELSE MOVE 3 TO MNT-IX1.
    PERFORM UNTIL MNT-IX1>3 MOVE MNT-MAC(MNT-IX1:1) TO MNT-IN(MNT-IX2)
      ADD 1 TO MNT-IX1 MNT-IX2 END-PERFORM.
MNT-RDMAC. MOVE 0 TO A-S1.
    IF VO-MAC-IND=0 MOVE VO-MAC TO M-NO READ MACHINE REGARDLESS
       INVALID PERFORM DSP-ERR12 MOVE 1 TO A-S1
      ELSE MOVE VO-MAC TO MK-NO READ MNTMAC REGARDLESS
       INVALID PERFORM DSP-ERR28 MOVE 1 TO A-S1.
MNT-SET-VO. COMPUTE VO-ZNO=999999 - VO-NO MOVE USN-USER TO VO-USER.
    ACCEPT SYS-TIME FROM TIME MOVE SYS-TIME(1:2) TO A-N1 MOVE SYS-TIME(3:2) TO A-N2.
    COMPUTE VO-TIME=100 * A-N1 + A-N2.

AX-CHQDATE. DISPLAY "CHEQUE DATE: ______" LINE IXT COLUMN IXU BOLD.
    ADD 13 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO WS-CHNDATE D-DATE.
    PERFORM D-NC MOVE D-N1 TO WS-CHLDATE.
    STRING D-YY " " D-MTHNM(D-MM)(1:3) " " D-DD " " DELIMITED SIZE INTO WS-CHQDATE.
CHK-GL. PERFORM CHK-GL1 THRU CHK-GL9.
CHK-GL1. MOVE 1 TO A-S1 MOVE WS-DIV TO G-DIV MOVE WS-GL TO G-GL.
    READ GLDIST REGARDLESS INVALID PERFORM DSP-ERR16 GO CHK-GL9.
    IF G-NGL=0 MOVE "THIS G/L HAS NO 'NEW G/L' A/C" TO ERR-MESG
      PERFORM DSP-ERR GO CHK-GL9.
    MOVE 0 TO A-S1.
CHK-GL9. EXIT.
* note 112
RD-CATGL. PERFORM RD-CG1 THRU RD-CG9.
RD-CG1. MOVE 0 TO WS-GL IF A-N1=0 GO RD-CG9.
    MOVE 7 TO T-TBL MOVE A-N1 TO T-NO PERFORM RD-TBL.
    IF NOT(T-GH1=0 AND T-GH2=0 AND T-GH3=0)
      MOVE T-GH1 TO WS-GL1 MOVE T-GH2 TO WS-GL2 MOVE T-GH3 TO WS-GL3.
    IF NOT PART-MAT
      IF A-N2 NOT=0 MOVE 22 TO T-TBL MOVE A-N2 TO T-NO PERFORM RD-TBL
        IF T-GP1 NOT=0 MOVE T-GP1 TO WS-GL3.
    IF A-N3 NOT=0 MOVE A-N3 TO WS-GL4.
RD-CG9. EXIT.
DSP-GL. DISPLAY WS-GL1 LINE IXT COLUMN IXU WS-GL2 COLUMN IXU PLUS 7
         WS-GL3 COLUMN IXU PLUS 11 WS-GL4 COLUMN IXU PLUS 14.
DSP-NGL. DISPLAY WS-NGL1 LINE IXT COLUMN IXU WS-NGL2 COLUMN IXU PLUS 7
          WS-NGL3 COLUMN IXU PLUS 14 WS-NGL4 COLUMN IXU PLUS 19.
    REPLACE ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION==.
AX-GL. PERFORM AX-GL1 THRU AX-GL9.
AX-GL1. PERFORM DSP-GL.
    ACCEPT WS-GL1 LINE IXT COLUMN IXU ACC-NUM KEY CKEY.
    DISPLAY WS-GL1 LINE IXT COLUMN IXU IF KPF4 GO AX-GL9.
    ACCEPT WS-GL2 LINE IXT COLUMN IXU PLUS 7 ACC-NUM.
    DISPLAY WS-GL2 LINE IXT COLUMN IXU PLUS 7.
    ACCEPT WS-GL3 LINE IXT COLUMN IXU PLUS 11 ACC-NUM.
    DISPLAY WS-GL3 LINE IXT COLUMN IXU PLUS 11.
    ACCEPT WS-GL4 LINE IXT COLUMN IXU PLUS 14 ACC-NUM.
    DISPLAY WS-GL4 LINE IXT COLUMN IXU PLUS 14.
AX-GL9. EXIT.
AX-NGL. PERFORM DSP-NGL.
    ACCEPT WS-NGL1 LINE IXT COLUMN IXU ACC-NUM.
    DISPLAY WS-NGL1 LINE IXT COLUMN IXU.
    ACCEPT WS-NGL2 LINE IXT COLUMN IXU PLUS 7 ACC-NUM.
    DISPLAY WS-NGL2 LINE IXT COLUMN IXU PLUS 7.
    ACCEPT WS-NGL3 LINE IXT COLUMN IXU PLUS 14 ACC-NUM.
    DISPLAY WS-NGL3 LINE IXT COLUMN IXU PLUS 14.
    ACCEPT WS-NGL4 LINE IXT COLUMN IXU PLUS 19 ACC-NUM.
    DISPLAY WS-NGL4 LINE IXT COLUMN IXU PLUS 19.
    REPLACE OFF.

CALC-DUE-DATE. PERFORM CDD-T1 THRU CDD-T9.
CDD-T1. IF V-PAY=3 MOVE 5 TO D-N1 PERFORM D-NEXT GO CDD-T9. PERFORM D-NM.
    EVALUATE TRUE
      WHEN V-PAY=1 OR 9 MOVE 1 TO A-N1 MOVE 15 TO A-N2
      WHEN V-PAY=2 MOVE 2 TO A-N1 MOVE 15 TO A-N2
      WHEN V-PAY=4 IF D-DD<=15 MOVE 1 TO A-N1 MOVE 20 TO A-N2 ELSE MOVE 2 TO A-N1 MOVE 10 TO A-N2 END-IF
      WHEN V-PAY=5 MOVE 2 TO A-N1 IF D-DD<=15 MOVE 10 TO A-N2 ELSE MOVE 20 TO A-N2 END-IF
      WHEN OTHER MOVE 2 TO A-N1 MOVE 15 TO A-N2.
    ADD A-N1 TO D-MM IF D-MM>12 ADD 1 TO D-YY SUBTRACT 12 FROM D-MM.
    MOVE A-N2 TO D-DD PERFORM D-MN.
CDD-T9. EXIT.
CHK-VENUS. IF A-N1>=4000 AND<=4999 OR>=9500 AND<=9999 MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
CHK-VENSP. IF A-N1=3001 OR 4001 MOVE 1 TO A-N1
       ELSE IF A-N1=3025 OR 4025 MOVE 2 TO A-N1 ELSE MOVE 0 TO A-N1.
DSP-PALT. PERFORM SET-PALT DISPLAY PART-PRINT LINE IXT COLUMN IXU.
AX-PALT. PERFORM DSP-PALT MOVE IXU TO A-N1.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
      ACCEPT PART-ALT1(A-X1) LINE IXT COLUMN A-N1 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY PART-ALT1(A-X1) LINE IXT COLUMN A-N1 ADD 5 TO A-N1 END-PERFORM.
SET-PALT. MOVE PART-ALT1(1) TO PART-PRT1 MOVE PART-ALT1(2) TO PART-PRT2.
    MOVE PART-ALT1(3) TO PART-PRT3 MOVE "-" TO PART-PRT1A PART-PRT2A.

GRT-CHKDUP. PERFORM GRT-CD1 THRU GRT-CD9.
GRT-CD1. MOVE WS-DIV TO GT-DIV MOVE AT-VEN TO GT-VEN MOVE AT-INV TO GT-INV.
    MOVE 0 TO GT-TYPE GT-SYS GT-GL.
    MOVE 0 TO A-S1 START GLTR KEY>=GT-KEY REGARDLESS INVALID GO GRT-CD9.
    READ GLTR NEXT REGARDLESS END GO GRT-CD9.
    IF NOT(GT-DIV=WS-DIV AND GT-VEN=AT-VEN AND GT-INV=AT-INV) GO GRT-CD9.
    MOVE 1 TO A-S1.
GRT-CD9. EXIT.
* note 114
GRT-PROC. PERFORM GRT-P1 THRU GRT-P9.
GRT-P1. MOVE 0 TO GRT-EXCHANGE.
    MOVE 1 TO GRT-SYS MOVE 0 TO GRT-QTY MOVE AT-INV-DATE TO GRT-INV-DATE.
    IF AT-TYPE=0 MOVE AT-INV TO GRT-INV
      ELSE MOVE AH-NO TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO GRT-INV.
    IF AT-TYPE=0 IF AT-EXCH=0 MOVE GRT-PGL(3) TO GRT-GL ELSE MOVE GRT-PGL(4) TO GRT-GL END-IF
      PERFORM GRT-ADJ
     ELSE IF AT-EXCH=0 MOVE GRT-PGL(1) TO GRT-GL ELSE MOVE GRT-PGL(2) TO GRT-GL.
    IF AT-TYPE=0 COMPUTE GRT-AMT=-AT-GROSS PERFORM GRT-PA
      ELSE COMPUTE GRT-AMT=-AT-NET PERFORM GRT-PA
       MOVE GRT-PGL(7) TO GRT-GL COMPUTE GRT-AMT=-AT-DISC PERFORM GRT-PA.
    MOVE GRT-PGL(10) TO GRT-GL MOVE AT-PST TO GRT-AMT PERFORM GRT-PA.
    IF AT-EXCH NOT=0 COMPUTE GRT-AMT ROUNDED=AT-PST * (AT-EXCH - 1)
      MOVE 7 TO GRT-TYPE PERFORM GRT-TRANS ADD GRT-AMT TO GRT-EXCHANGE.
    MOVE GRT-PGL(5) TO GRT-GL MOVE AT-GST TO GRT-AMT PERFORM GRT-PA.
    IF AT-EXCH NOT=0 COMPUTE GRT-AMT ROUNDED=AT-GST * (AT-EXCH - 1)
      MOVE 7 TO GRT-TYPE PERFORM GRT-TRANS ADD GRT-AMT TO GRT-EXCHANGE.
* note 216
    IF AT-FRPAY=0 MOVE GRT-PGL(8) TO GRT-GL COMPUTE GRT-AMT=-AT-FREIGHT PERFORM GRT-PA
      IF AT-EXCH NOT=0 COMPUTE GRT-AMT ROUNDED=-AT-FREIGHT * (AT-EXCH - 1)
        MOVE 7 TO GRT-TYPE PERFORM GRT-TRANS
        MOVE 0 TO GRT-SYS COMPUTE GRT-AMT=-GRT-AMT PERFORM GRT-TRANS.
    IF AT-FGL NOT=0 MOVE 0 TO GRT-SYS MOVE AT-FGL TO GRT-GL MOVE 0 TO GRT-QTY
      MOVE AT-FREIGHT TO GRT-AMT MOVE 6 TO GRT-TYPE PERFORM GRT-TRANS
      IF AT-EXCH NOT=0 COMPUTE GRT-AMT ROUNDED=AT-FREIGHT * (AT-EXCH - 1)
        MOVE 7 TO GRT-TYPE PERFORM GRT-TRANS ADD GRT-AMT TO GRT-EXCHANGE.
    MOVE 0 TO GRT-FREIGHT GRT-IX1.
GRT-P3. ADD 1 TO GRT-IX1 IF GRT-IX1>10 OR AT-GL(GRT-IX1)=0 GO GRT-P4.
    COMPUTE GRT-FAMT(GRT-IX1) ROUNDED=AT-FREIGHT * AT-AMT(GRT-IX1) / AT-TOTAL
      SIZE ERROR MOVE 0 TO GRT-FAMT(GRT-IX1).
    ADD GRT-FAMT(GRT-IX1) TO GRT-FREIGHT GO GRT-P3.
GRT-P4. COMPUTE GRT-FAMT(1)=GRT-FAMT(1) + AT-FREIGHT - GRT-FREIGHT.
* note 102
    MOVE 0 TO GRT-IX1.
GRT-P5. ADD 1 TO GRT-IX1 IF GRT-IX1>10 OR AT-GL(GRT-IX1)=0 GO GRT-P6.
    MOVE 0 TO GRT-SYS MOVE AT-GL(GRT-IX1) TO GRT-GL.
    MOVE AT-AMT(GRT-IX1) TO GRT-AMT MOVE AT-QTY(GRT-IX1) TO GRT-QTY PERFORM GRT-PA.
    MOVE GRT-FAMT(GRT-IX1) TO GRT-AMT MOVE 6 TO GRT-TYPE PERFORM GRT-TRANS.
    IF AT-EXCH NOT=0 COMPUTE GRT-AMT ROUNDED=
       (AT-AMT(GRT-IX1) + GRT-FAMT(GRT-IX1)) * (AT-EXCH - 1)
      MOVE 7 TO GRT-TYPE PERFORM GRT-TRANS ADD GRT-AMT TO GRT-EXCHANGE.
    GO GRT-P5.
GRT-P6. MOVE 1 TO GRT-SYS MOVE 0 TO GRT-QTY.
    MOVE GRT-PGL(9) TO GRT-GL COMPUTE GRT-AMT=-GRT-EXCHANGE PERFORM GRT-PA.
GRT-P9. EXIT.
GRT-PA. MOVE AT-TYPE TO GRT-TYPE PERFORM GRT-TRANS.
GRT-CHQ. MOVE 0 TO GRT-QTY MOVE 1 TO GRT-SYS.
    MOVE V-NO TO GRT-VEN MOVE SYS-DATE TO GRT-INV-DATE.
    IF GRT-KCAN=0 MOVE 1 TO GRT-TYPE ELSE MOVE 3 TO GRT-TYPE.
    MOVE AH-NO TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO GRT-INV.
    IF USD-IND=0 MOVE GRT-PGL(3) TO GRT-GL ELSE MOVE GRT-PGL(4) TO GRT-GL.
    PERFORM GRT-ADJ MOVE AH-GROSS TO GRT-AMT PERFORM GRT-CR.
    IF USD-IND=0 MOVE GRT-PGL(1) TO GRT-GL ELSE MOVE GRT-PGL(2) TO GRT-GL.
    COMPUTE GRT-AMT=-AH-NET PERFORM GRT-CR.
    MOVE GRT-PGL(7) TO GRT-GL COMPUTE GRT-AMT=-(AH-GROSS - AH-NET) PERFORM GRT-CR.
GRT-CR. IF GRT-KCAN=1 COMPUTE GRT-AMT=-GRT-AMT. PERFORM GRT-TRANS.
GRT-TRANS. PERFORM GRT-T1 THRU GRT-T9.
GRT-T1. IF GRT-AMT=0 GO GRT-T9. MOVE LOW-VALUES TO GT-RECORD.
    MOVE WS-DIV TO GT-DIV MOVE GRT-VEN TO GT-VEN MOVE GRT-INV TO GT-INV.
    MOVE GRT-TYPE TO GT-TYPE MOVE GRT-SYS TO GT-SYS MOVE GRT-GL TO GT-GL.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-YY TO GT-YY MOVE D-MM TO GT-MM.
    MOVE GRT-AMT TO GT-AMT MOVE GRT-QTY TO GT-QTY MOVE GRT-INV-DATE TO GT-INV-DATE.
    WRITE GT-RECORD ALLOWING NO UNLOCK GLTR.
GRT-T9. EXIT.
GRT-ADJ. IF V-NO>=9000 SUBTRACT 028000 FROM GRT-GL1 MOVE V-CONTRA TO GRT-GL4.
* note 197

APS-AXSEL. PERFORM APS-P1 THRU APS-P9.
APS-P1. ADD 1 TO IXT MOVE IXT TO APS-IXT.
    ADD 1 TO IXT DISPLAY
         "FROM-TO        INV OR DUE       FROM-TO        INV OR DUE" LINE IXT BOLD.
    ADD 1 TO IXT DISPLAY
         "VENDOR   PAYCD    DATE          VENDOR   PAYCD    DATE " LINE IXT BOLD.
*         .... ....  .  ...... ......     .... ....  .  ...... ......
    PERFORM VARYING APS-IX1 FROM 1 BY 1 UNTIL APS-IX1>12 ADD 1 TO IXT
      MOVE 1 TO APS-COL PERFORM APS-D MOVE 33 TO APS-COL PERFORM APS-D END-PERFORM.
    ADD 2 TO IXT DISPLAY "ENTER 1 TO 24 VENDOR RANGES AND SPECIFICATIONS" LINE IXT.
    ADD 1 TO IXT DISPLAY "LEAVE PAY CODE BLANK TO INCLUDE ALL VENDORS IN THAT RANGE" LINE IXT.

    MOVE 0 TO APS-SN COMPUTE IXT=APS-IXT + 2 MOVE 1 TO APS-COL.
APS-P3. ADD 1 TO APS-SN IXT.
APS-P33. PERFORM DSP-PF3 COMPUTE IXU=APS-COL.
    ACCEPT APS-VEN1(APS-SN) LINE IXT COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF3 SUBTRACT 1 FROM APS-SN GO APS-P4.
    COMPUTE IXU=APS-COL + 5 MOVE APS-VEN1(APS-SN) TO APS-VEN2(APS-SN).
    DISPLAY APS-VEN2(APS-SN) LINE IXT COLUMN IXU CONVERSION.
    ACCEPT APS-VEN2(APS-SN) LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY APS-VEN2(APS-SN) LINE IXT COLUMN IXU CONVERSION.
    COMPUTE IXU=APS-COL + 11.
    ACCEPT APS-PAY(APS-SN) LINE IXT COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 0 TO APS-KDUE(APS-SN) COMPUTE IXU=APS-COL + 14 PERFORM AX-DT-INV.
    IF DATE0=0 MOVE 1 TO APS-KDUE(APS-SN) COMPUTE IXU=APS-COL + 21 PERFORM AX-DT-INV.
    IF DATE0=0 PERFORM DSP-ERR14 PERFORM APS-D GO APS-P33.
    MOVE DATE0 TO APS-DATE(APS-SN).
    IF APS-SN=12 COMPUTE IXT=APS-IXT + 2 MOVE 33 TO APS-COL.
    IF APS-SN<24 GO APS-P3.
APS-P4. PERFORM DSP-CONT.
    COMPUTE IXT=APS-IXT + 1 DISPLAY " " LINE IXT ERASE END SCREEN.
APS-P9. EXIT.
APS-D. DISPLAY "____ ____  _  ______ ______" LINE IXT COLUMN APS-COL.
APS-CHKVEN. PERFORM APS-S1 THRU APS-S9.
APS-S1. MOVE 0 TO A-S1.
    PERFORM VARYING APS-IX1 FROM 1 BY 1 UNTIL APS-IX1>APS-SN
      IF APS-VEN>=APS-VEN1(APS-IX1) AND<=APS-VEN2(APS-IX1)
        MOVE 1 TO A-S1 GO APS-S9 END-IF END-PERFORM.
APS-S9. EXIT.
APS-CHKTR. PERFORM APS-T1 THRU APS-T9.
APS-T1. MOVE 0 TO A-S1 IF AT-IND=1 GO APS-T9.
    PERFORM VARYING APS-IX1 FROM 1 BY 1 UNTIL APS-IX1>APS-SN
     IF AT-VEN>=APS-VEN1(APS-IX1) AND<=APS-VEN2(APS-IX1)
      IF APS-KDUE(APS-IX1)=1 MOVE AT-DUE-DATE TO A-N1 ELSE MOVE AT-INV-DATE TO A-N1 END-IF
      IF (APS-PAY(APS-IX1)=0 OR V-PAY) AND A-N1<=APS-DATE(APS-IX1)
        MOVE 1 TO A-S1 GO APS-T9 END-IF END-IF END-PERFORM.
APS-T9. EXIT.

    REPLACE ==INTO-LN== BY ==DELIMITED SIZE INTO DSA-LN POINTER DSA-IXL==
            ==INTO-LNA== BY ==DELIMITED SIZE INTO DSA-LNA POINTER DSA-IXA==.
* note 146
DESC-AMT. MOVE " " TO DSA-LN MOVE 1 TO DSA-IXL.
    IF DSA-VAL<1 STRING "NO " INTO-LN
     ELSE PERFORM VARYING DSA-IX1 FROM 1 BY 1 UNTIL DSA-IX1>3
      IF DSA-VALD(DSA-IX1)>0 MOVE DSA-VALD(DSA-IX1) TO DSA-AMT PERFORM DESC-AMT-A
        STRING DSA-LNA(1:DSA-IXA - 1) INTO-LN
        IF DSA-IX1<=2 STRING DSA-DES4(DSA-IX1) DELIMITED " " " " INTO-LN END-IF
        END-IF END-PERFORM.
    IF DSA-VAL>=1 AND<=1.99 STRING "DOLLAR AND " INTO-LN ELSE STRING "DOLLARS AND " INTO-LN.
    IF DSA-VALC=0 STRING "NO " INTO-LN
      ELSE MOVE DSA-VALC TO DSA-AMT PERFORM DESC-AMT-A STRING DSA-LNA(1:DSA-IXA - 1) INTO-LN.
    IF DSA-VALC=1 STRING "CENT ONLY" INTO-LN ELSE STRING "CENTS ONLY" INTO-LN.
    PERFORM VARYING DSA-IX1 FROM 1 BY 1 UNTIL DSA-IX1>3 OR DSA-LINE(DSA-IX1 + 1)=" "
     COMPUTE DSA-IXT=DSA-LTH * DSA-IX1
     IF DSA-LN(DSA-IXT:1)>" "
      IF DSA-LN(DSA-IXT + 1:1)=" " MOVE DSA-LN(DSA-IXT + 2:) TO DSA-LN(DSA-IXT + 1:)
        ELSE PERFORM VARYING DSA-IXL FROM DSA-IXT BY -1 UNTIL DSA-LN(DSA-IXL:1)=" " CONTINUE END-PERFORM
         MOVE DSA-LN(DSA-IXL + 1:) TO DSA-LN(DSA-IXT + 1:)
         MOVE " " TO DSA-LN(DSA-IXL + 1:DSA-IXT - DSA-IXL) END-IF END-IF END-PERFORM.
DESC-AMT-A. MOVE " " TO DSA-LNA MOVE 1 TO DSA-IXA.
    IF DSA-AMA(1)>0 STRING DSA-DES1(DSA-AMA(1)) DELIMITED " " " HUNDRED " INTO-LNA.
    IF DSA-AMA(2)>=2 STRING DSA-DES3(DSA-AMA(2)) DELIMITED " " " " INTO-LNA
      IF DSA-AMA(3)>0 STRING DSA-DES1(DSA-AMA(3)) DELIMITED " " " " INTO-LNA END-IF
     ELSE IF DSA-AMA(2)=1 STRING DSA-DES2(DSA-AMA(3) + 1) DELIMITED " " " " INTO-LNA
       ELSE IF DSA-AMA(3)>0 STRING DSA-DES1(DSA-AMA(3)) DELIMITED " " " " INTO-LNA.
    REPLACE OFF.

* note 158
SCAN-BIN. PERFORM SCN-B1 THRU SCN-B9.
SCN-B1. MOVE 0 TO A-S1.
    ACCEPT SCN-BIN LINE IXT COLUMN 6 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SCN-BIN(1:5)=ALL "9" MOVE 1 TO A-S1 GO SCN-B9.
    IF SCN-BIN(1:1) NOT="B" MOVE SCN-BIN(1:5) TO A-A1 GO SCN-B9.
    MOVE SCN-BIN(2:) TO A-A1 DISPLAY A-A1(1:6) LINE IXT COLUMN 6.
    ACCEPT SCN-LVL LINE IXT COLUMN 19 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF SCN-LVL(1:1)="L" MOVE SCN-LVL(2:1) TO SCN-LVL(1:1)
      DISPLAY SCN-LVL(1:1) LINE IXT COLUMN 19 " ".
    MOVE SCN-LVL(1:1) TO A-A1(3:1).
SCN-B9. EXIT.
SCAN-LOT. PERFORM SCN-L1 THRU SCN-L9.
SCN-L1. MOVE 0 TO A-S1.
    ACCEPT SCN-ALOT LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SCN-ALOT(1:7)=ALL "9" MOVE 1 TO A-S1 GO SCN-L9.
    IF SCN-ALOT(1:1) NOT="L" MOVE SCN-ALOT(1:7) TO SCN-ALOT(2:).
    IF SCN-LOT NOT NUMERIC MOVE 0 TO SCN-LOT.
SCN-L9. EXIT.
SCAN-PROD. PERFORM SCN-P1 THRU SCN-P9.
SCN-P1. MOVE 0 TO A-S1.
    ACCEPT SCN-APROD LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SCN-APROD(1:8)=ALL "9" MOVE 1 TO A-S1 GO SCN-P9.
    IF SCN-APROD(1:1) NOT="P" MOVE SCN-APROD(1:12) TO SCN-APROD(2:).
SCN-P9. EXIT.

ADD-PBIN. MOVE "BIN DOES NOT EXIST - 'ADD' TO ADD IT NOW: ___" TO TMSG.
    PERFORM DSP-PROMPT MOVE 0 TO A-S1.
    IF XA3="ADD" MOVE 1 TO A-S1 MOVE BH-NO TO A-A1 PERFORM INIT-BH
      MOVE A-A1 TO BH-NO BH-KNO WRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
CHK-PBIN-EMPTY. IF PART-MAT IF BH-COILS<=0
        INITIALIZE BH-PCODE BH-COILS BH-QTY BH-DATE BH-PART BH-HEAT BH-PO END-IF
      ELSE IF BH-QTY<=0 INITIALIZE BH-QTY BH-DATE BH-PO.
SHOW-PBINS. PERFORM SHB-B1 THRU SHB-B9.
SHB-B1. DISPLAY "'Y' TO SHOW BINS: _" LINE IXT BOLD ERASE END SCREEN.
    ACCEPT XA1 COLUMN 19 DEFAULT " " UNDERLINED PROTECTED.
    IF XA1 NOT="Y" DISPLAY " " LINE IXT ERASE LINE GO SHB-B9.
    DISPLAY "BINS CONTAINING PART NO." LINE IXT BOLD SHB-PART COLUMN 26 BOLD.
    IF PART-MAT DISPLAY "(BIN : PROCESS - COILS - HEAT)" COLUMN 40 MOVE 2 TO SHB-COL
      ELSE DISPLAY "(BIN : QUANTITY)" COLUMN 40 MOVE 3 TO SHB-COL.
    ADD 1 TO IXT MOVE 1 TO SHB-IX1 MOVE " " TO SHB-TDS1.
    INITIALIZE BH-KP MOVE SHB-PART TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO SHB-B8.
SHB-B3. READ PURBIN NEXT REGARDLESS END GO SHB-B8. IF BH-PART NOT=SHB-PART GO SHB-B8.
    IF PART-MAT MOVE BH-NO TO SHB-TS5(SHB-IX1) MOVE ":" TO SHB-TS6(SHB-IX1)
      MOVE BH-PCODE TO SHB-TS7(SHB-IX1) MOVE "-" TO SHB-TS8(SHB-IX1) SHB-TS10(SHB-IX1)
      MOVE BH-COILS TO SHB-TS9(SHB-IX1) MOVE BH-HEAT TO SHB-TS11(SHB-IX1)
     ELSE MOVE BH-NO TO SHB-TS1(SHB-IX1) MOVE ":" TO SHB-TS2(SHB-IX1)
      MOVE BH-QTY TO SHB-TS3(SHB-IX1).
    ADD 1 TO SHB-IX1 IF SHB-IX1<=SHB-COL GO SHB-B3.
    DISPLAY SHB-TDS1 LINE IXT MOVE " " TO SHB-TDS1.
    MOVE 1 TO SHB-IX1 ADD 1 TO IXT IF IXT<=23 GO SHB-B3.
SHB-B8. IF SHB-IX1>1 DISPLAY SHB-TDS1 LINE IXT.
SHB-B9. EXIT.
CHK-COIL-WEIGHT. MOVE 0 TO A-S1 IF NOT(A-N1>=800 AND<=4000)
      MOVE "AVERAGE COIL WEIGHT MUST BE 800 - 4000" TO ERR-MESG PERFORM DSP-OK
      IF XA2 NOT="OK" MOVE 1 TO A-S1.

CTA-ANALYSIS. PERFORM CTA-N1 THRU CTA-N9.
CTA-N1. OPEN INPUT MAINTA PERFORM OPEN-REP PERFORM CTA-HEAD.
    IF CTA-OP=1 MOVE 4 TO CTA-N ELSE MOVE 1 TO CTA-N.
CTA-N23. READ MAINTA END GO CTA-N29. IF MFA-F33=0 OR>89 GO CTA-N23. PERFORM INIT-RP.
    EVALUATE TRUE
      WHEN MFA-F33=21 OR 22 MOVE 1 TO RP-F282
      WHEN MFA-F33=14 OR 32 OR 33 OR 69 MOVE 3 TO RP-F282
      WHEN MFA-F33=60 MOVE 4 TO RP-F282
      WHEN OTHER MOVE 2 TO RP-F282.
    MOVE MFA-F33 TO RP-F283 READ REPFL INVALID WRITE RP-RECORD.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CTA-N
      ADD MFA-F34(IX1) TO RP-F284(IX1) END-PERFORM.
    REWRITE RP-RECORD GO CTA-N23.
CTA-N29. MOVE 0 TO OLD-N MOVE LOW-VALUES TO CTA-STOTALS CTA-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO CTA-N8.
CTA-N3. READ REPFL NEXT END GO CTA-N8.
    IF RP-F282 NOT=OLD-N IF OLD-N NOT=0 PERFORM CTA-NS END-IF MOVE RP-F282 TO OLD-N.
    MOVE "CAT" TO FF485 MOVE RP-F283 TO FF486 PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF487.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CTA-N
      MOVE RP-F284(IX1) TO FF488(IX1) ADD RP-F284(IX1) TO CTA-STOT(IX1) CTA-GTOT(IX1) END-PERFORM.
    PERFORM PR-LINE GO CTA-N3.
CTA-N8. PERFORM CTA-NS MOVE "*** GRAND TOTAL" TO FF487.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CTA-N
      MOVE CTA-GTOT(IX1) TO FF488(IX1) END-PERFORM.
    MOVE "**" TO FF489 PERFORM PR-LINE.
    PERFORM CLOSE-REP CLOSE MAINTA PERFORM DELETE-MAINT.
CTA-N9. EXIT.
CTA-NS. EVALUATE TRUE
      WHEN OLD-N=1 MOVE "**  TOTAL STUDS" TO FF487
      WHEN OLD-N=2 MOVE "**  TOTAL BOLTS" TO FF487
      WHEN OLD-N=3 MOVE "**  TOTAL NUTS" TO FF487
      WHEN OLD-N=4 MOVE "**  TOTAL WASHERS" TO FF487
      WHEN OTHER CONTINUE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CTA-N
      MOVE CTA-STOT(IX1) TO FF488(IX1) END-PERFORM.
    MOVE "**" TO FF489 PERFORM PR-LINE-2 MOVE LOW-VALUES TO CTA-STOTALS.
CTA-HEAD. IF CTA-OP=1 MOVE "SALES SUMMARY ANALYSIS" TO PREC PERFORM PR-LINE-2
      MOVE
         "                                             SALES MTD     SALES YTD    WEIGHT MTD    WEIGHT YTD" TO PREC PERFORM PR-LINE-3.
    IF CTA-OP=2 MOVE "INVENTORY SUMMARY ANALYSIS" TO PREC PERFORM PR-LINE-2
      MOVE
         "                                         WEIGHT ON HAND" TO PREC PERFORM PR-LINE-3.
    IF CTA-OP=3 MOVE "PRODUCTION SUMMARY ANALYSIS" TO PREC PERFORM PR-LINE-2
      MOVE
         "                                        WEIGHT PRODUCED" TO PREC PERFORM PR-LINE-3.
    IF CTA-OP=4 MOVE "PHYSICAL INVENTORY SUMMARY ANALYSIS" TO PREC PERFORM PR-LINE-2
      MOVE
         "                                         WEIGHT ON HAND" TO PREC PERFORM PR-LINE-3.
*         ... ..  ................................   ..,...,...-   ..,...,...-   ..,...,...-   ..,...,...-  ..

* note 91
COST-CALC. PERFORM CST-CL1 THRU CST-CL9.
CST-CL1. PERFORM RDR-INFO MOVE 0 TO CST-KTOOL CST-KPUR.
    MOVE CST-MAC TO A-N1 PERFORM CHK-PUR IF A-S1=1 MOVE 1 TO CST-KPUR.

    IF CST-KPRI=0 IF P-LUS=1 MOVE P-LDATE TO D-DATE MOVE CST-PRICE TO A-T1
      PERFORM EXCHG-CONV MOVE A-T1 TO CST-PRICE.

    IF NOT(CST-KQ=1 OR CST-KPUR=1 OR P-CAT=80 OR INUT)
      MOVE 1 TO CST-KTOOL MOVE P-NO TO TS-PROD MOVE CST-MAC TO TS-MAC
      READ TOOLS REGARDLESS INVALID MOVE 0 TO CST-KTOOL END-READ
      IF CST-KTOOL=1 PERFORM TL-SET-TYPE.
* note 78

    MOVE 0 TO CST-N-TOT IF CST-NUT=" " OR CST-KQ=1 GO CST-CL2.
    PERFORM NUM-NUTS MOVE P-KEY TO CST-PNO MOVE CST-NUT TO P-NO.
    READ PRODUCT REGARDLESS INVALID
      MOVE "NN" TO A-A1 PERFORM COST-E GO CST-CL18.
    IF NOT(P-MAC>=29 AND<=31 OR>=97 AND<=99) MOVE "NM" TO A-A1 PERFORM COST-E GO CST-CL18.
    COMPUTE CST-N-TOT=P-COST * PRO-NNUT.
CST-CL18. MOVE CST-PNO TO P-KEY START PRODUCT KEY=P-KEY REGARDLESS.
    READ PRODUCT NEXT REGARDLESS.
* note 60
CST-CL2. PERFORM COST-MULT-INIT.

    IF CST-KPUR=1 MOVE "PURCHASED" TO CST-MAT PERFORM COST-PART
      READ PART REGARDLESS INVALID MOVE "MP" TO A-A1 PERFORM COST-E END-READ
      MOVE PH-LDCOST TO CST-M-MAT GO CST-CL24.

    IF IFAST OR INUT PERFORM SET-PART MOVE PART-NO TO CST-MAT GO CST-CL22.
    MOVE " " TO CST-MAT STRING P-DIAM P-GRADE DELIMITED " " INTO CST-MAT.
    IF CST-MAT=" " OPEN I-O IFPART ALLOWING ALL MOVE P-NO TO IFPH-NO
      READ IFPART INTO PH-RECORD REGARDLESS INVALID MOVE " " TO PH-MATERIAL END-READ
      MOVE PH-MATERIAL TO CST-MAT CLOSE IFPART.
CST-CL22. INITIALIZE PH-REC MOVE CST-MAT TO PH-NO READ PART REGARDLESS INVALID
      MOVE "MP" TO A-A1 PERFORM COST-E.
    IF NOT(CST-MODE=3 OR 4) GO CST-CL226.
    MOVE 0 TO A-T1 MOVE PH-NO TO LK-PART MOVE SYS-DATE TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO CST-CL224.
CST-CL223. READ PURLIN NEXT REGARDLESS END GO CST-CL224. IF LK-PART NOT=PH-NO GO CST-CL224.
    IF LK-BLANKET=0 AND LK-QTY-REC=0 MOVE LK-PRICE TO A-T1. GO CST-CL223.
CST-CL224. IF A-T1>0 GO CST-CL228.
CST-CL226. MOVE PH-NO TO A-A1 PERFORM COST-LDCOST PERFORM COST-LDADJ.
CST-CL228. COMPUTE CST-M-MAT ROUNDED=A-T1 * CST-GMULT.
    IF ITOOL MOVE PH-LDCOST TO CST-M-MAT
      IF PH-UNIT="LB" COMPUTE CST-M-MAT ROUNDED=CST-M-MAT * CST-GROSS / 100.

* note 266
CST-CL24. PERFORM SET-ANNEAL.
    MOVE PART-PROCESS TO CST-PROCESS A-A1 PERFORM RD-PART PERFORM COST-LDCOST.
    COMPUTE CST-M-PROC ROUNDED=A-T1 * 2000 * CST-GMULT.
    COMPUTE CST-M-TOT=CST-M-MAT + CST-M-PROC.

    MOVE 0 TO CST-T-FREIGHT CST-IXT IF CST-LOP=CST-MAC GO CST-CL28.
    MOVE 1 TO CST-IXO.
CST-CL25. MOVE OP-OPER(CST-IXO) TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO CST-CL26.
    MOVE OP-OPER(CST-IXO) TO M-NO READ MACHINE REGARDLESS INVALID
      MOVE "TM" TO A-A1 PERFORM COST-E GO CST-CL26.
    IF CST-IXT=5 MOVE "TX" TO A-A1 PERFORM COST-E GO CST-CL26.
    ADD 1 TO CST-IXT MOVE OP-OPER(CST-IXO) TO CST-T-CODE(CST-IXT).
    IF CST-KQ=1 AND M-TCOST>0 MOVE M-TCOST TO CST-WAMT MOVE M-CMODE TO A-A1
     ELSE IF OP-COST(CST-IXO)>0
       MOVE OP-COST(CST-IXO) TO CST-WAMT MOVE OP-CMODE(CST-IXO) TO A-A1
       IF M-VENDOR>=4000 MULTIPLY IF-EXCH-AP BY CST-WAMT ROUNDED END-IF
      ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    IF IFAST OR INUT PERFORM COST-M COMPUTE CST-T-AMT(CST-IXT) ROUNDED=CST-WAMT * CST-MULT
      COMPUTE CST-T-FREIGHT ROUNDED=CST-T-FREIGHT + M-FREIGHT * CST-NMULT
     ELSE COMPUTE CST-T-AMT(CST-IXT) ROUNDED=CST-WAMT * CST-NET / 100.
CST-CL26. IF OP-OPER(CST-IXO) NOT=CST-LOP ADD 1 TO CST-IXO IF CST-IXO<=12 GO CST-CL25.
CST-CL28. IF ITOOL COMPUTE CST-T-FREIGHT ROUNDED=CST-IXT * IF-CST-FREIGHT * CST-NET / 100.
    MOVE CST-T-FREIGHT TO CST-T-TOT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CST-IXT
      ADD CST-T-AMT(IX1) TO CST-T-TOT END-PERFORM.

    INITIALIZE CST-AMO CST-ACTBL IF CST-MODE NOT=4 GO CST-CL30.
    MOVE P-NO TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO CST-CL284.
CST-CL283. READ PRODORD NEXT REGARDLESS END GO CST-CL284. IF R-PROD NOT=P-NO GO CST-CL284.
    IF R-NO>9999 AND R-QTY-LEFT<=0 MOVE R-NO TO CST-AMO. GO CST-CL283.
CST-CL284. IF CST-AMO=0 GO CST-CL288. INITIALIZE J-KEY MOVE CST-AMO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO CST-CL288.
CST-CL285. READ WORKSHEET NEXT REGARDLESS END GO CST-CL288.
    IF J-NO NOT=CST-AMO GO CST-CL288.
    MOVE J-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=1 GO CST-CL285.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 OR (CST-ACODE(IX1)=0 OR J-MAC)
      CONTINUE END-PERFORM.
    IF IX1<=12 MOVE J-MAC TO CST-ACODE(IX1)
      ADD J-HOURS TO CST-AHOURS(IX1) ADD J-QTY TO CST-AQTY(IX1).
    GO CST-CL285.
CST-CL288.

CST-CL30. IF ITOOL MOVE 0 TO CST-ITHOURS. MOVE 0 TO CST-IXP CST-IXO.
CST-CL31. IF CST-IXO=0 IF ITOOL OR CST-KPUR=1 GO CST-CL34 END-IF MOVE CST-MAC TO M-NO
      ELSE MOVE OP-OPER(CST-IXO) TO M-NO IF M-NO=0 GO CST-CL34 END-IF
        MOVE M-NO TO A-N1 PERFORM CHK-SUBCON IF A-S1=1 GO CST-CL34 END-IF
        MOVE M-NO TO A-N1 PERFORM PROC-TYPE IF PROC-INSPECT GO CST-CL34 END-IF.
    READ MACHINE REGARDLESS INVALID MOVE "PM" TO A-A1 PERFORM COST-E GO CST-CL34.
    IF CST-IXP=10 MOVE "PX" TO A-A1 PERFORM COST-E GO CST-CL34.
    ADD 1 TO CST-IXP MOVE M-NO TO CST-C-CODE(CST-IXP).
    IF ITOOL MOVE 0 TO CST-C-LABOUR(CST-IXP) GO CST-CL32.
    IF CST-IXO=0
      MOVE M-COST TO WT1 IF CST-KQ=1 AND M-TCOST>0 MOVE M-TCOST TO WT1 END-IF
      IF M-CMODE="H" PERFORM CALC-PRATE
        COMPUTE CST-C-LABOUR(CST-IXP) ROUNDED=WT1 * 1000 / A-N1 SIZE ERROR CONTINUE END-COMPUTE
       ELSE MOVE WT1 TO CST-WAMT MOVE M-CMODE TO A-A1 PERFORM COST-M
        COMPUTE CST-C-LABOUR(CST-IXP) ROUNDED=CST-WAMT * CST-MULT END-IF
      GO CST-CL314.
    IF CST-KQ=1 AND M-TCOST>0 MOVE M-TCOST TO CST-WAMT MOVE M-CMODE TO A-A1
     ELSE IF OP-COST(CST-IXO)>0
       MOVE OP-COST(CST-IXO) TO CST-WAMT MOVE OP-CMODE(CST-IXO) TO A-A1
      ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    PERFORM COST-M COMPUTE CST-C-LABOUR(CST-IXP) ROUNDED=CST-WAMT * CST-MULT.
CST-CL314. IF CST-AMO=0 OR M-HCOST=0 GO CST-CL32.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      OR (CST-ACODE(IX1)=0 OR M-NO) CONTINUE END-PERFORM.
    IF IX1<=12 AND CST-ACODE(IX1)>0 AND CST-AHOURS(IX1)>0 AND CST-AQTY(IX1)>0
      COMPUTE CST-C-LABOUR(CST-IXP) ROUNDED=
        M-HCOST * CST-AHOURS(IX1) * 1000 / CST-AQTY(IX1).
CST-CL32. IF M-TYPE=0 MOVE 0 TO CST-C-OVERHEAD(CST-IXP)
      MOVE "PO" TO A-A1 PERFORM COST-E GO CST-CL34.
    MOVE M-TYPE TO A-N1 PERFORM RD-MACTYPE MOVE ME-CMODE TO A-A1 PERFORM COST-M.
    IF IFAST OR INUT COMPUTE CST-C-OVERHEAD(CST-IXP) ROUNDED=ME-COST * CST-MULT
      ELSE IF M-TQTY NOT=0 COMPUTE CST-C-OVERHEAD(CST-IXP) ROUNDED=ME-COST * M-HOURS / M-TQTY
       COMPUTE CST-ITHOURS ROUNDED=CST-ITHOURS + M-HOURS / M-TQTY.
CST-CL34. IF NOT(CST-IXO=0 AND CST-MAC=CST-LOP OR CST-IXO>0 AND OP-OPER(CST-IXO)=CST-LOP)
      ADD 1 TO CST-IXO IF CST-IXO<=12 GO CST-CL31.

    MOVE 0 TO CST-C-TOOLS.
    IF INUT MOVE P-TCOST TO CST-C-TOOLS GO CST-CL38.
    IF CST-KTOOL=0
      MOVE CST-MAC TO M-NO READ MACHINE REGARDLESS INVALID GO CST-CL38 END-READ
      MOVE M-TYPE TO ME-NO READ MACTYPE REGARDLESS INVALID GO CST-CL38 END-READ
      COMPUTE CST-C-TOOLS ROUNDED=ME-TOOLCOST * CST-NMULT GO CST-CL38.
    MOVE 1 TO TL-IXA.
CST-CL35. IF TS-TOOL(TL-IXA)=" " OR "N/R" GO CST-CL36.
    MOVE TS-TOOL(TL-IXA) TO PH-NO READ PART REGARDLESS INVALID
      MOVE "PT" TO A-A1 PERFORM COST-E GO CST-CL36.
    MOVE PH-NO TO A-A1 PERFORM COST-LDCOST PERFORM COST-LDADJ PERFORM ADJ-PLIFE.
    MOVE PH-LIFE TO A-N1 IF CST-MODE=4 AND PH-ALIFE>0 MOVE PH-ALIFE TO A-N1.
    COMPUTE CST-WAMT ROUNDED=A-T1 / A-N1 SIZE ERROR MOVE 0 TO CST-WAMT.
    IF CST-MODE=3 MULTIPLY 0.8 BY CST-WAMT ROUNDED.
    ADD CST-WAMT TO CST-C-TOOLS.
* note 93
CST-CL36. ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO CST-CL35.
CST-CL38.

* note 200
    MOVE 0 TO CST-C-CARTONS CST-KPACK CST-KL.
    PERFORM COST-CHKPAK IF A-S1=1 GO CST-CL48.
    IF CST-LOP=CST-MAC MOVE 1 TO CST-KL GO CST-CL42.
    PERFORM VARYING CST-IXO FROM 1 BY 1 UNTIL CST-IXO>12
      MOVE OP-OPER(CST-IXO) TO A-N1 PERFORM PROC-TYPE
      IF PROC-PACK MOVE 1 TO CST-KPACK END-IF
      IF OP-OPER(CST-IXO)=CST-LOP MOVE 1 TO CST-KL GO CST-CL42 END-IF END-PERFORM.
CST-CL42. IF CST-KL=1 AND CST-KPACK=0
      OR CST-KPUR=1 AND CST-IXP=0 AND CST-KPACK=0 GO CST-CL48.
    MOVE CST-PACKING TO PK-NO READ PACKING REGARDLESS INVALID
      MOVE "PK" TO A-A1 PERFORM COST-E GO CST-CL48.
    MOVE PK-PART TO PH-NO READ PART REGARDLESS INVALID
      MOVE "PP" TO A-A1 PERFORM COST-E GO CST-CL48.
    MOVE PH-NO TO A-A1 PERFORM COST-LDCOST PERFORM COST-LDADJ.
    COMPUTE CST-C-CARTONS ROUNDED=A-T1 * 1000 / P-QTY-PACK SIZE ERROR CONTINUE.

CST-CL48. MOVE 0 TO CST-C-TOT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CST-IXP
      COMPUTE CST-C-AMT(IX1)=CST-C-LABOUR(IX1) + CST-C-OVERHEAD(IX1)
      ADD CST-C-AMT(IX1) TO CST-C-TOT END-PERFORM.
    ADD CST-C-TOOLS CST-C-CARTONS TO CST-C-TOT.

    MOVE 99 TO A-N1 PERFORM RD-MACTYPE MOVE 0 TO CST-OVERHEAD.
    IF (IFAST AND CST-KPUR=0) OR INUT COMPUTE CST-OVERHEAD ROUNDED=ME-COST * CST-NMULT.
    IF ITOOL COMPUTE CST-OVERHEAD ROUNDED=ME-COST * CST-ITHOURS.
    COMPUTE CST-DIRECT=CST-N-TOT + CST-M-TOT + CST-T-TOT + CST-C-TOT.
    COMPUTE CST-MFG=CST-DIRECT + CST-OVERHEAD.
    COMPUTE CST-PRICE-SUG ROUNDED=CST-MFG * 1.18.
CST-CL9. EXIT.

* note 265
COST-LDCOST. PERFORM CST-LD1 THRU CST-LD9.
CST-LD1. MOVE 0 TO A-T1.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE A-A1 TO PU-PART.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO CST-LD6.
    READ PURHIST NEXT REGARDLESS END GO CST-LD6.
    IF NOT(PU-DIV=WS-DIV AND PU-PART=A-A1) GO CST-LD6.
    MOVE PU-ALDCOST TO A-T1 IF CST-MODE=3 OR 4 MOVE PU-LDCOST TO A-T1.
    MOVE PU-MODE TO A-A1 GO CST-LD8.
CST-LD6. MOVE PH-LDCOST TO A-T1 MOVE PH-MODE TO A-A1.
CST-LD8. PERFORM DIV-SAMT.
CST-LD9. EXIT.
COST-LDADJ. IF CST-KQ=1 AND PH-TCOST>0 MOVE PH-TCOST TO A-T1.

* note 90
COST-E. IF CST-IXE<10 ADD 1 TO CST-IXE MOVE A-A1 TO CST-ERR(CST-IXE).
COST-MULT-INIT. MOVE P-WEIGHT TO CST-NET MOVE P-GROSS TO CST-GROSS.
    IF CST-GROSS=0
     IF IFAST OR INUT
       IF CST-MAC>=29 AND<=31 COMPUTE CST-GROSS ROUNDED=CST-NET / 0.785
         ELSE COMPUTE CST-GROSS ROUNDED=CST-NET / 0.95 END-IF
      ELSE COMPUTE CST-GROSS ROUNDED=CST-NET / 0.85.
    COMPUTE CST-GMULT ROUNDED=CST-GROSS / 200.
    COMPUTE CST-NMULT ROUNDED=CST-NET / 200.
* note 94
COST-M. MOVE 0 TO CST-MULT IF A-A1="M" MOVE 1 TO CST-MULT.
    IF A-A1="G" MOVE CST-GMULT TO CST-MULT.
    IF A-A1="N" MOVE CST-NMULT TO CST-MULT.
COST-CHKPAK. IF CST-PACKING=0 OR 7 OR 14 MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
COST-PART. PERFORM INIT-PH.
    IF INUT AND P-PUR-PART=" " MOVE P-NO TO A-A1 MOVE CST-MAC TO A-N1
      PERFORM COST-PART-N MOVE A-A1 TO P-PUR-PART.
    IF P-PUR-PART>" " MOVE P-PUR-PART TO PH-NO ELSE MOVE P-NO TO PH-NO.
COST-PART-N. EVALUATE TRUE
      WHEN A-N1=99 MOVE "-T" TO A-A2
      WHEN A-N1=98 MOVE "-L" TO A-A2
      WHEN A-N1=97 MOVE "-A" TO A-A2
      WHEN OTHER MOVE " " TO A-A2.
    PERFORM STR-LTH MOVE A-A2 TO A-A1(A-N1 + 1:).

COST-NUT. PERFORM CST-NT1 THRU CST-NT9.
CST-NT1. PERFORM OPEN-SORT.
* note 66
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO CST-NT2.
CST-NT13. READ PRODUCT NEXT REGARDLESS END GO CST-NT2.
    IF P-NUT>" " MOVE P-NUT TO SR-F3 WRITE SR-RECORD INVALID CONTINUE. GO CST-NT13.
CST-NT2. IF CST-KN=1 MOVE 4 TO IXT MOVE 1 TO IXU CST-IXL.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO CST-NT8.
CST-NT3. READ SORTFL NEXT END GO CST-NT8. MOVE SR-F3 TO P-NO.
    READ PRODUCT REGARDLESS INVALID GO CST-NT6.
    IF NOT(P-MAC>=29 AND<=31 OR>=97 AND<=99) GO CST-NT6. MOVE 0 TO P-COST CST-IXE.
    IF P-MAC NOT=99 PERFORM GET-TS IF A-S1=1 GO CST-NT4.
    PERFORM GET-OP IF A-S1=1 GO CST-NT4.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE P-MAC TO CST-MAC MOVE " " TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI CST-KQ MOVE 1 TO CST-MODE PERFORM COST-CALC.
    MOVE CST-MFG TO P-COST.
CST-NT4. REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT. IF CST-KN=0 GO CST-NT6.
    IF IXT<=23 DISPLAY P-NO LINE IXT COLUMN IXU ":" P-COST CONVERSION.
    ADD 28 TO IXU ADD 1 TO CST-IXL IF CST-IXL=4 ADD 1 TO IXT MOVE 1 TO IXU CST-IXL.
CST-NT6. GO CST-NT3.
CST-NT8. PERFORM CLOSE-SORT.
CST-NT9. EXIT.

* note 9
COST-DISP. PERFORM CST-DS1 THRU CST-DS9.
CST-DS1. PERFORM RD92.
    IF CST-KQ=0 MOVE "^PRODUCT COST CALCULATION ]" TO TH105(1)
      ELSE MOVE "^QUOTATION COST CALCULATION ]" TO TH105(1).
    EVALUATE TRUE
      WHEN CST-MODE=1 MOVE "1. VALUES PER 1000 PCS" TO TH105(2)
                      MOVE "    (ACCOUNTING USE)" TO TH105(3)
      WHEN CST-MODE=2 MOVE "2. VALUES PER NET TON" TO TH105(2) PERFORM COST-DISP-C
      WHEN CST-MODE=3 MOVE "3. VALUES BASED ON ORDERS/PURCHASES" TO TH105(2)
                      MOVE "     (SALES & QUOTING USE)" TO TH105(3)
      WHEN CST-MODE=4 MOVE "4. VALUES BASED ON ORDERS/PURCHASES" TO TH105(2)
                      MOVE "     AND ACTUAL HOURS" TO TH105(3)
      WHEN CST-MODE=5 MOVE "5. VARIANCE (MODE 3 - 4)" TO TH105(2)
      WHEN OTHER CONTINUE.
    IF CST-ALT=" " MOVE P-NO TO TH106(1)
      ELSE MOVE CST-ALT TO TH106(1) STRING "!GENERIC:]" P-NO DELIMITED SIZE INTO TH107(1).
    MOVE 1 TO IX1 MOVE 2 TO IXT PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO TH109(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    IF IFAST OR INUT MOVE CST-MAC TO TH108(1) A-N1 PERFORM RD-MAC MOVE M-DESC1 TO TH110(2).
    MOVE CST-PRICE TO TH111(5) MOVE "/1000 PCS" TO TH112(5).
    MOVE CST-GROSS TO TH113(6) MOVE CST-NET TO TH114(6) MOVE "/100 PCS" TO TH115(6).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)>0 MOVE OP-OPER(IX1) TO TH116(7,IX1) END-IF END-PERFORM.

    MOVE 9 TO IXT.
    ADD 1 TO IXT MOVE CST-MAT TO TH117(IXT) MOVE CST-M-MAT TO TH120(IXT).
    ADD 1 TO IXT MOVE "PROCESS" TO TH118(IXT).
    MOVE CST-PROCESS TO TH119(IXT) MOVE CST-M-PROC TO TH120(IXT).
    ADD 1 TO IXT MOVE "!" TO TH131(IXT) MOVE "MATERIAL SUB-TOTAL" TO TH132(IXT).
    MOVE CST-M-TOT TO TH120(IXT) MOVE "]" TO TH133(IXT).

    MOVE 9 TO IXT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CST-IXT
      ADD 1 TO IXT MOVE CST-T-CODE(IX1) TO TH122(IXT) A-N1 PERFORM RD-MAC
      MOVE M-OPDESC TO TH123(IXT) MOVE CST-T-AMT(IX1) TO TH124(IXT) END-PERFORM.
    IF CST-T-FREIGHT NOT=0 OR CST-MODE=5
      ADD 1 TO IXT MOVE "FREIGHT & HANDLING" TO TH123(IXT) MOVE CST-T-FREIGHT TO TH124(IXT).
    ADD 1 TO IXT MOVE "!" TO TH134(IXT) MOVE "THIRD PARTY SUB-TOTAL" TO TH135(IXT).
    MOVE CST-T-TOT TO TH124(IXT) MOVE "]" TO TH136(IXT).

    MOVE 9 TO IXT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CST-IXP
      ADD 1 TO IXT MOVE CST-C-CODE(IX1) TO TH125(IXT) A-N1 PERFORM RD-MAC
      MOVE M-OPDESC TO TH126(IXT) MOVE CST-C-AMT(IX1) TO TH127(IXT) END-PERFORM.
    ADD 1 TO IXT MOVE "TOOLS" TO TH126(IXT) MOVE CST-C-TOOLS TO TH127(IXT).
    ADD 1 TO IXT MOVE "SHIPPING CARTONS" TO TH126(IXT) MOVE CST-C-CARTONS TO TH127(IXT).
    ADD 1 TO IXT MOVE "!" TO TH137(IXT) MOVE "CONVERSION SUB-TOTAL" TO TH138(IXT).
    MOVE CST-C-TOT TO TH127(IXT) MOVE "]" TO TH139(IXT).
    IF CST-MODE=4 MOVE "(M.O.:" TO TH140(IXT) MOVE CST-AMO TO TH141(IXT) MOVE ")" TO TH142(IXT).

    IF CST-NUT>" " MOVE "!NUT:] " TO TH128(15) MOVE CST-NUT TO TH129(15)
      MOVE CST-N-TOT TO TH143(15).
    MOVE CST-DIRECT TO TH143(17) MOVE CST-OVERHEAD TO TH143(18).
    MOVE CST-MFG TO TH143(19).
    IF CST-KPRI=1
      MOVE "CONT:" TO A-A1 MOVE CST-DIRECT TO A-T1 MOVE 18 TO A-X1 PERFORM COST-DISP-A
      MOVE "G.M.:" TO A-A1 MOVE CST-MFG TO A-T1 MOVE 19 TO A-X1 PERFORM COST-DISP-A.
    MOVE CST-PRICE-SUG TO TH146(4).

    IF CST-IXE=0 GO CST-DS68. MOVE 9 TO IXT.
    MOVE "^ERRORS:      ]" TO TH144(IXT) ADD 1 TO IXT MOVE 1 TO IX1 IX2.
CST-DS67. MOVE CST-ERR(IX1) TO TH145(IXT,IX2).
    ADD 1 TO IX1 IX2 IF IX2>5 ADD 1 TO IXT MOVE 1 TO IX2. IF IX1<=CST-IXE GO CST-DS67.
CST-DS68.

    IF CST-KQ=1 GO CST-DS8.
    MOVE "^HISTORY    MAC   MATERIAL   THIRD PARTY   CONVERSION ]" TO TLNW(21) TLNW(21)(60:).
*          .......... ..    ....:...     ....:...     ....:...
    MOVE " " TO TLNW(22) TLNW(23) MOVE "??" TO TLNW(24).
    PERFORM RDR-INFO.
    MOVE P-NO TO CU-PROD READ COSTHIST REGARDLESS INVALID GO CST-DS78.
    MOVE 1 TO CST-IXL MOVE 22 TO IXT.
CST-DS73. IF CU-NUM(CST-IXL)=0 GO CST-DS78. MOVE " " TO CST-DF1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8 IF CU-NUM(CST-IXL)=IF-CST-NUM(IX1)
      MOVE IF-CST-PERIOD(IX1) TO CST-DF11 GO CST-DS76 END-IF END-PERFORM.
CST-DS76. MOVE CU-MAC(CST-IXL) TO CST-DF12.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      IF CST-MODE=3 OR 4 MOVE CU-NTOT(CST-IXL,IX1) TO CST-CUTOT(IX1)
        ELSE MOVE CU-TOT(CST-IXL,IX1) TO CST-CUTOT(IX1) END-IF END-PERFORM.
    IF CST-MODE=2 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      DIVIDE CST-NMULT INTO CST-CUTOT(IX1) ROUNDED END-PERFORM.
    MOVE CST-CUTOT(1) TO CST-DF13 MOVE CST-CUTOT(2) TO CST-DF14 MOVE CST-CUTOT(3) TO CST-DF15.
    IF CST-IXL<=2 MOVE CST-DF1 TO TH147(IXT) ELSE MOVE CST-DF1 TO TH148(IXT).
    ADD 1 TO CST-IXL IXT IF CST-IXL=3 MOVE 22 TO IXT. IF CST-IXL<=4 GO CST-DS73.
CST-DS78.
CST-DS8. IF CST-KDSP=1 PERFORM WRT.
CST-DS9. EXIT.
COST-DISP-A. MOVE " " TO CST-DF2 MOVE "!" TO CST-DF21 MOVE "%] (" TO CST-DF24.
    MOVE "/" TO CST-DF26 MOVE ")" TO CST-DF28.
    MOVE CST-PRICE TO A-T2 IF CST-MODE=2 DIVIDE CST-NMULT INTO A-T2 ROUNDED.
    MOVE A-A1 TO CST-DF22 COMPUTE A-T1=A-T2 - A-T1.
    COMPUTE CST-DF23 ROUNDED=100 * A-T1 / A-T2 SIZE ERROR MOVE 0 TO CST-DF23.
    MOVE A-T1 TO CST-DF25 MOVE A-T2 TO CST-DF27 MOVE CST-DF2 TO TH130(A-X1).
COST-DISP-C. DIVIDE CST-NMULT INTO CST-N-TOT ROUNDED CST-M-MAT ROUNDED
      CST-M-PROC ROUNDED CST-M-TOT ROUNDED CST-T-FREIGHT ROUNDED CST-T-TOT ROUNDED
      CST-C-TOOLS ROUNDED CST-C-CARTONS ROUNDED CST-C-TOT ROUNDED CST-DIRECT ROUNDED
      CST-OVERHEAD ROUNDED CST-MFG ROUNDED.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>5
      DIVIDE CST-NMULT INTO CST-T-AMT(A-X1) ROUNDED END-PERFORM.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>10
      DIVIDE CST-NMULT INTO CST-C-AMT(A-X1) ROUNDED END-PERFORM.

COST-PROCESS. PERFORM CST-PC1 THRU CST-PC9.
CST-PC1. PERFORM GET-OP MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT.
    IF M-NO=P-MAC MOVE 0 TO A-X1 GO CST-PC4.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>12
      IF OP-OPER(A-X1)=M-NO GO CST-PC4 END-IF END-PERFORM.
CST-PC4. IF A-X1>=1 AND<=12 AND OP-COST(A-X1)>0
      MOVE OP-COST(A-X1) TO CST-WAMT MOVE OP-CMODE(A-X1) TO A-A1
        ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    IF A-X1=0 AND A-A1="H" PERFORM CALC-PRATE
      COMPUTE CST-WAMT ROUNDED=M-COST * 1000 / A-N1
     ELSE PERFORM COST-M COMPUTE CST-WAMT ROUNDED=CST-WAMT * CST-MULT.
    IF M-TYPE NOT=0 MOVE M-TYPE TO A-N1 PERFORM RD-MACTYPE
      MOVE ME-CMODE TO A-A1 PERFORM COST-M
      COMPUTE CST-WAMT ROUNDED=CST-WAMT + ME-COST * CST-MULT.
CST-PC9. EXIT.

AX-CMODE. PERFORM AX-CM1 THRU AX-CM9.
AX-CM1. DISPLAY "ENTER COST MODE ('M' OR 'N' OR 'G')" LINE 24 BOLD.
    ACCEPT XA1 LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF NOT(XA1="M" OR "N" OR "G") PERFORM DSP-ERR2 GO AX-CM1.
AX-CM9. EXIT.
AX-BCMODE. PERFORM AX-BM1 THRU AX-BM9.
AX-BM1. DISPLAY "ENTER COST MODE ('M' OR 'N' OR 'G' OR BLANK)" LINE 24 BOLD.
    ACCEPT XA1 LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF NOT(XA1="M" OR "N" OR "G" OR " ") PERFORM DSP-ERR2 GO AX-BM1.
AX-BM9. EXIT.

* note 225
GET-GRADE. IF LT-GRADE>" " MOVE LT-GRADE TO A-A1 ELSE MOVE HE-GRADE TO A-A1.
CHK-GRADE-OVR. IF LT-GRADE-OVR=1326 OR 2741 OR 3057 OR 4810 OR 5238
      MOVE 0 TO A-S1 ELSE PERFORM DSP-ERR2 MOVE 1 TO A-S1.
* note 259
MECH-GET. IF CAR-CH=1 MOVE LT-MECH-1 TO MEC-VAL
       ELSE IF CAR-CH=5 MOVE LT-MECH-5 TO MEC-VAL
        ELSE IF CAR-CH=6 MOVE LT-MECH-6 TO MEC-VAL
         ELSE MOVE LT-MECH(CAR-CH) TO MEC-VAL.
    MOVE LT-UNIT(CAR-CH) TO MEC-UNIT.
MECH-PUT. IF CAR-CH=1 MOVE MEC-VAL TO LT-MECH-1
       ELSE IF CAR-CH=5 MOVE MEC-VAL TO LT-MECH-5
        ELSE IF CAR-CH=6 MOVE MEC-VAL TO LT-MECH-6
         ELSE MOVE MEC-VAL TO LT-MECH(CAR-CH).
    MOVE MEC-UNIT TO LT-UNIT(CAR-CH).
* note 286
MECH-CONV. PERFORM MECH-C1 THRU MECH-C9.
MECH-C1. MOVE MEC-VAL TO A-A1 PERFORM STR-LTH MOVE A-N1 TO MEC-VLTH.
    MOVE 0 TO MEC-IX1 INSPECT MEC-VAL TALLYING MEC-IX1 FOR LEADING " ".
    MOVE 0 TO MEC-NUM MEC-DEC.
MECH-C3. ADD 1 TO MEC-IX1 MOVE MEC-VAL(MEC-IX1:1) TO MEC-CA.
    IF MEC-CA=" " GO MECH-C4. IF MEC-CA="." MOVE 1 TO MEC-DEC GO MECH-C3.
    IF MEC-CN NOT NUMERIC GO MECH-C9.
    COMPUTE MEC-NUM=MEC-NUM * 10 + MEC-CN MULTIPLY 10 BY MEC-DEC GO MECH-C3.
MECH-C4. IF MEC-NUM=0 GO MECH-C9. COMPUTE A-T1 ROUNDED=MEC-NUM * 6.895.
    IF MEC-DEC>0 COMPUTE A-T1 ROUNDED=A-T1 / MEC-DEC.
    COMPUTE MEC-VN ROUNDED=A-T1.
    MOVE 0 TO MEC-IX1 INSPECT MEC-VN TALLYING MEC-IX1 FOR LEADING "0".
    MOVE "-" TO MEC-VAL(MEC-VLTH + 2:1).
    MOVE MEC-VN(MEC-IX1 + 1:) TO MEC-VAL(MEC-VLTH + 4:5 - MEC-IX1).
    MOVE "MPA" TO MEC-VAL(MEC-VLTH + 10 - MEC-IX1:3).
MECH-C9. EXIT.
MECH-DESC. MOVE MEC-VAL TO A-A1 PERFORM STR-LTH.
    IF A-N1>0 MOVE MEC-UNIT TO MEC-VAL(A-N1 + 2:).
DESC-INSTR. MOVE " " TO CAR-INSTRUMENT CAR-INSTR-A(1) CAR-INSTR-A(2).
    IF CAR-IN>=1 AND<=CAR-INSTR-NUM
      MOVE CAR-INSTR-DESC(CAR-IN,1) TO CAR-INSTR-A(1)
      MOVE CAR-INSTR-DESC(CAR-IN,2) TO CAR-INSTR-A(2)
      STRING CAR-INSTR-A(1) " " CAR-INSTR-A(2) DELIMITED "  " INTO CAR-INSTRUMENT.
DESC-UNIT. MOVE " " TO CAR-UNIT CAR-UNIT-A.
    IF CAR-UN>=1 AND<=CAR-UNIT-NUM
      MOVE CAR-UNIT-DESC(CAR-UN) TO CAR-UNIT
      MOVE CAR-UNITA-DESC(CAR-UN) TO CAR-UNIT-A.
RD-CHAR. MOVE 24 TO T-TBL PERFORM RD-TBL MOVE T-LINE TO CAR-DATA.
    IF T-LINE=ALL "0" MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
DSP-HVAL. IF CAR-CH=11 DISPLAY CAR-TVAL LINE IXT COLUMN IXU CONVERSION
      ELSE DISPLAY CAR-VAL LINE IXT COLUMN IXU PLUS 1 CONVERSION.

    REPLACE ==AA== BY ==ALLOWING ALL==.
OPEN-FL. OPEN I-O INFOFL AA EDINFO AA LABELS AA TABLES AA SHIPVIA AA PACKING AA
      SALHIST AA SALSUM AA TRANS AA CUSTOMER AA PRODUCT AA ALTERNATES AA
      NUTBOLT AA OPERATIONS AA PRICE AA BIN AA PART AA PURBIN AA TOOLS AA
      TOOLPROD AA HEAT AA LOT AA SHIPTO AA SAORD AA SALIN AA PURORD AA PURLIN AA
      PARTRANS AA PRODTRANS AA PLANT AA MATREL AA DAYREL AA MACHINE AA
      MACTYPE AA PRODORD AA WORKSHEET AA BUCKET AA MILL AA VENDOR AA APTR AA
      APCHQ AA GLDIST AA GLTR AA PURHIST AA COSTHIST AA.
    REPLACE OFF.
CLOSE-FL. CLOSE INFOFL EDINFO LABELS TABLES SHIPVIA PACKING SALHIST SALSUM
      TRANS CUSTOMER PRODUCT ALTERNATES NUTBOLT OPERATIONS PRICE BIN PART
      PURBIN TOOLS TOOLPROD HEAT LOT SHIPTO SAORD SALIN PURORD PURLIN PARTRANS
      PRODTRANS PLANT MATREL DAYREL MACHINE MACTYPE PRODORD WORKSHEET BUCKET
      MILL VENDOR APTR APCHQ GLDIST GLTR PURHIST COSTHIST.
OPEN-EMPL. MOVE 30 TO WS-PDIV EMPL-DIV.
    IF INUT MOVE 40 TO WS-PDIV EMPL-DIV.
    IF ITOOL MOVE 50 TO WS-PDIV EMPL-DIV.
    OPEN I-O EMPL ALLOWING ALL.
PUR-SETNM. MOVE "IRVINE FASTENERS" TO WS-DIV-NAME.
    IF INUT MOVE "IRVINE NUTS" TO WS-DIV-NAME.
    IF ITOOL MOVE "IRVINE TOOLS" TO WS-DIV-NAME.
INIT-RP. MOVE LOW-VALUES TO RP-RECORD MOVE " " TO RP-KEY.
INIT-SR. MOVE LOW-VALUES TO SR-RECORD MOVE " " TO SR-KEY.
INIT-SC. MOVE LOW-VALUES TO SC-RECORD MOVE " " TO SC-KEY.
OPEN-REP. OPEN OUTPUT REPFL CLOSE REPFL OPEN I-O REPFL PERFORM INIT-RP.
CLOSE-REP. CLOSE REPFL MOVE " " TO A-A1.
    STRING REP-ID ".DAT.1" DELIMITED " " INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.
OPEN-SORT. OPEN OUTPUT SORTFL CLOSE SORTFL OPEN I-O SORTFL PERFORM INIT-SR.
CLOSE-SORT. CLOSE SORTFL MOVE " " TO A-A1.
    STRING SORT-ID ".DAT.1" DELIMITED " " INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.
OPEN-SORC. OPEN OUTPUT SORCFL CLOSE SORCFL OPEN I-O SORCFL PERFORM INIT-SC.
CLOSE-SORC. CLOSE SORCFL MOVE " " TO A-A1.
    STRING SORC-ID ".DAT.1" DELIMITED " " INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.
DELETE-MAINT. MOVE " " TO A-A1.
    STRING MFA-ID ".DAT.*" DELIMITED " " INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.
    STRING MFB-ID ".DAT.*" DELIMITED " " INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.
    STRING MFC-ID ".DAT.*" DELIMITED " " INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.
OPEN-MAINTA. OPEN OUTPUT MAINTA MOVE LOW-VALUES TO MFA-RECORD.
OPEN-MAINTB. OPEN OUTPUT MAINTB MOVE LOW-VALUES TO MFB-RECORD.
OPEN-MAINTC. OPEN OUTPUT MAINTC MOVE LOW-VALUES TO MFC-RECORD.
* note 15
LKWAIT. MOVE 0.01 TO LIB-F1 CALL "LIB$WAIT" USING LIB-F1.
* note 98.1
VMS-CMND. MOVE LIT-LOGFL TO A-A2.
    CALL "LIB$SPAWN" USING DESCRIPTOR A-A1 OMITTED DESCRIPTOR A-A2.

PRINT-PR. MOVE " " TO A-A1 STRING "PRINT " PR-ID " /QUEUE=" PR-QUEUE DELIMITED SIZE INTO A-A1.
    PERFORM AUTO-PRINT.
PRINT-DOC. MOVE " " TO A-A1 STRING "PRINT " DOC-ID " /DELETE/QUEUE=" DOC-QUEUE DELIMITED SIZE INTO A-A1.
    PERFORM DSP-QWAIT PERFORM AUTO-PRINT PERFORM DSP-ERS.
PRINT-LAB. MOVE " " TO A-A1 STRING "PRINT " LAB-ID " /DELETE/QUEUE=" LAB-QUEUE DELIMITED SIZE INTO A-A1.
    PERFORM DSP-QWAIT PERFORM AUTO-PRINT PERFORM DSP-ERS.
PRINTKEEP-LAB. MOVE " " TO A-A1 STRING "PRINT " LAB-ID " /QUEUE=" LAB-QUEUE DELIMITED SIZE INTO A-A1.
    PERFORM DSP-QWAIT PERFORM AUTO-PRINT PERFORM DSP-ERS.
PRINT-LAS. MOVE " " TO A-A1 STRING "PRINT " LAS-ID " /PASSALL/QUEUE=" LAS-QUEUE DELIMITED SIZE INTO A-A1.
    PERFORM AUTO-PRINT.
* note 277
AUTO-PRINT. IF NOT(USN-USER="SYSTEM" AND USN-KPRT=0) PERFORM VMS-CMND.

INIT-PR. MOVE 0 TO WS-PAGE MOVE 1 TO WS-PR WS-LINES MOVE " " TO PREC.
OPEN-PR. MOVE USN-PRNM TO PR-NAME MOVE PR-NUM TO PR-FLN OPEN OUTPUT PRINTFL.
    PERFORM INIT-PR.
OPEN-EXT-PR. MOVE USN-PRNM TO PR-NAME MOVE PR-NUM TO PR-FLN OPEN EXTEND PRINTFL.
    PERFORM INIT-PR.
* note 140
EXTEND-PR. PERFORM OPEN-EXT-PR WRITE PREC AFTER PAGE.
CLOSE-PR. CLOSE PRINTFL.
PR-RESET. WRITE PREC AFTER PAGE MOVE 0 TO WS-PAGE.
PR-LINE. WRITE PREC AFTER WS-PR.
    MOVE " " TO PREC ADD WS-PR TO WS-LINES MOVE 1 TO WS-PR.
PR-LINE-2. PERFORM PR-LINE 2 TIMES.
PR-LINE-3. PERFORM PR-LINE 3 TIMES.
PR-LINE-4. PERFORM PR-LINE 4 TIMES.
PR-LASTLN. IF PR-IXP>1 PERFORM PR-LINE.
PR-IPAGE. MOVE 1 TO WS-KHD PERFORM PR-PAGE MOVE 0 TO WS-KHD.
PR-PAGE. MOVE "DATE" TO FF1 MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF2.
    ADD 1 TO WS-PAGE MOVE "PAGE" TO FF8 MOVE WS-PAGE TO FF9.
    PERFORM PR-PAGE-P.
PR-PAGE-80. MOVE "DATE" TO FF1Y MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF2Y.
    ADD 1 TO WS-PAGE MOVE "PAGE" TO FF8Y MOVE WS-PAGE TO FF9Y.
    PERFORM PR-PAGE-P.
PR-PAGE-P. IF WS-PAGE=1 WRITE PREC AFTER 0 ELSE WRITE PREC AFTER PAGE.
    MOVE " " TO PREC MOVE 1 TO WS-LINES.
    IF NOT IFAST OR WS-KHD=1 MOVE 1 TO WS-PR MOVE WS-DIV-NAME TO PREC PERFORM PR-LINE.
    MOVE 3 TO WS-PR.

OPEN-EXP. OPEN OUTPUT EXPFL PERFORM EXP-CLR MOVE " " TO EXP-FLD.
CLOSE-EXP. CLOSE EXPFL.
EXP-CLR. MOVE " " TO EXP-RECORD MOVE 0 TO EXP-SZ.
* note 244.1
EXP-LINE. IF EXP-SZ>0 SUBTRACT 1 FROM EXP-SZ PERFORM EXP-WRITE.
EXP-HEADLN. PERFORM VARYING EXP-SZ FROM EXP-MAX BY -1
      UNTIL EXP-SZ=0 OR EXP-RECORD(EXP-SZ:1)>" " CONTINUE END-PERFORM.
    INSPECT EXP-RECORD(1:EXP-SZ) REPLACING ALL "`" BY LIT-TAB PERFORM EXP-WRITE.
EXP-WRITE. WRITE EXP-RECORD PERFORM EXP-CLR.
EXPF. MOVE 0 TO EXP-IX1 INSPECT EXP-FLD TALLYING EXP-IX1 FOR LEADING " ".
    MOVE EXP-FLD TO A-A1 PERFORM STR-LTH.
    IF A-N1=0 MOVE 0 TO EXP-IXL ELSE COMPUTE EXP-IXL=A-N1 - EXP-IX1.
    IF EXP-SZ + EXP-IXL + 1<=EXP-MAX
      MOVE EXP-FLD(EXP-IX1 + 1:EXP-IXL) TO EXP-RECORD(EXP-SZ + 1:EXP-IXL)
      COMPUTE EXP-SZ=EXP-SZ + EXP-IXL + 1 MOVE LIT-TAB TO EXP-RECORD(EXP-SZ:1).
    MOVE " " TO EXP-FLD.
EXPFN. PERFORM EXPF A-N1 TIMES.

OPEN-DOC. MOVE USN-PRNM TO DOC-NAME MOVE PR-NUM TO DOC-FLN PERFORM OPEN-DOCFL.
OPEN-PDOC. PERFORM RD-INFO ADD 1 TO IF-PRNSEQ PERFORM WR-INFO.
    MOVE "PP" TO DOC-NAME MOVE IF-PRNSEQ TO DOC-FLN PERFORM OPEN-DOCFL.
OPEN-DOCFL. OPEN OUTPUT DOCFL.
    MOVE 0 TO DOC-PAGE MOVE 1 TO DOC-LINES MOVE " " TO PREC.
CLOSE-DOC. CLOSE DOCFL.
* note 62
DOC-LINE. MOVE PREC TO DOC-RECORD A-A1 PERFORM STR-LTH MOVE A-N1 TO DOC-SZ.
    WRITE DOC-RECORD MOVE " " TO PREC ADD 1 TO DOC-LINES.

OPEN-LAB. MOVE "LAB" TO LAB-NAME PERFORM OPEN-LABFL.
OPEN-PLAB. PERFORM RD-INFO ADD 1 TO IF-PRNSEQ PERFORM WR-INFO.
    MOVE "LLL" TO LAB-NAME MOVE IF-PRNSEQ TO LAB-FLN PERFORM OPEN-LABFL.
OPEN-LABFL. OPEN OUTPUT LABFL MOVE 1 TO LAB-PTR.
CLOSE-LAB. CLOSE LABFL.
LAB-LINE. COMPUTE LAB-SZ=LAB-PTR - 1 WRITE LAB-RECORD MOVE 1 TO LAB-PTR.

OPEN-LAS. OPEN OUTPUT LASFL.
CLOSE-LAS. CLOSE LASFL.
LAS-LINE. PERFORM LASF ADD 1 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
LAS-DOCLINE. MOVE LAS-RECORD(1:LAS-PTR) TO PREC PERFORM DOC-LINE MOVE 0 TO LAS-PTR.
* note 281
LASF. PERFORM LSF-F1 THRU LSF-F9.
LSF-F1. CALL "STR$TRIM" USING DESCRIPTOR LIB-S1 LAS-FLD REFERENCE LIB-W1.
    MOVE LIB-W1 TO LAS-FL1 IF LAS-FL1=0 GO LSF-F9.
    INSPECT LAS-FLD(1:LAS-FL1) REPLACING ALL "`" BY X"1B".
    COMPUTE LAS-FL2=512 - LAS-PTR.
    IF LAS-FL1<=LAS-FL2 MOVE 0 TO LAS-FL2
      ELSE MOVE LAS-FLD(1:LAS-FL2) TO LAS-RECORD(LAS-PTR + 1:)
        WRITE LAS-RECORD MOVE 0 TO LAS-PTR.
    MOVE LAS-FLD(1 + LAS-FL2:) TO LAS-RECORD(LAS-PTR + 1:LAS-FL1 - LAS-FL2).
    COMPUTE LAS-PTR=LAS-PTR + LAS-FL1 - LAS-FL2 MOVE " " TO LAS-FLD.
LSF-F9. EXIT.
* note 288
LAS-BAR. PERFORM STR-LTH MOVE A-N1 TO LAS-BARN.
    PERFORM PCL-PUSH MOVE "*" TO LAS-BARCH PERFORM LAS-BAR-C.
    PERFORM VARYING LAS-IXN FROM 1 BY 1 UNTIL LAS-IXN>LAS-BARN
      MOVE A-A1(LAS-IXN:1) TO LAS-BARCH PERFORM LAS-BAR-C END-PERFORM.
    MOVE "*" TO LAS-BARCH PERFORM LAS-BAR-C PERFORM PCL-POP.
LAS-BAR-C. MOVE 0 TO LAS-IX1.
    INSPECT LAS-BAR39 TALLYING LAS-IX1 FOR CHARACTERS BEFORE LAS-BARCH.
    ADD 1 TO LAS-IX1 IF LAS-IX1>44 MOVE 39 TO LAS-IX1.
    MOVE ALL "1" TO LAS-BARCHAR.
    PERFORM VARYING LAS-IX2 FROM 1 BY 1 UNTIL LAS-IX2>3
      MOVE 3 TO LAS-BARC(LAS-BARL(LAS-IX1,LAS-IX2)) END-PERFORM.
    PERFORM VARYING LAS-IX1 FROM 1 BY 1 UNTIL LAS-IX1>10
      DIVIDE LAS-IX1 BY 2 GIVING A-N1 REMAINDER A-N2
      COMPUTE A-N1=LAS-BARX * LAS-BARC(LAS-IX1)
      IF A-N2=1 IF LAS-BARV=0 MOVE A-N1 TO LAS-AREX MOVE LAS-BARH TO LAS-AREY
                  ELSE MOVE LAS-BARH TO LAS-AREX MOVE A-N1 TO LAS-AREY END-IF
        MOVE 0 TO LAS-AREF MOVE LAS-AREA TO LAS-FLD PERFORM LASF END-IF
      IF LAS-BARV=0 MOVE A-N1 TO LAS-RMX MOVE LAS-RMOVE TO LAS-FLD
        ELSE MOVE A-N1 TO LAS-DMY MOVE LAS-DMOVE TO LAS-FLD END-IF
      PERFORM LASF END-PERFORM.
LAS-SET-FDATE. MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO LAS-FD1.
    ACCEPT SYS-TIME FROM TIME.
    MOVE SYS-TIME(1:2) TO LAS-FD2 MOVE SYS-TIME(3:2) TO LAS-FD3.
LAS-SET-SDATE. PERFORM D-NM MOVE " " TO LAS-SDATE.
    MOVE D-DD TO LAS-SD1 MOVE D-MTHNM(D-MM)(1:3) TO LAS-SD2 MOVE D-YEAR TO LAS-SD3.

PCL-INIT. MOVE 0 TO LAS-PTR MOVE " " TO LAS-FLD.
PCL-START. MOVE "`%-12345X`E`&u300D`&l2A`&k0G`&l8C`(8U" TO LAS-FLD PERFORM LASF.
PCL-END. MOVE "`E`%-12345X" TO LAS-FLD PERFORM LASF.
PCL-ENDFL. PERFORM PCL-END PERFORM PCL-FLUSH.
PCL-FLUSH. IF LAS-PTR>0 MOVE LOW-VALUES TO LAS-RECORD(LAS-PTR + 1:) WRITE LAS-RECORD.
PCL-FF. MOVE X"0C" TO LAS-FLD PERFORM LASF.
PCL-UNDY. MOVE "`&d0D" TO LAS-FLD PERFORM LASF.
PCL-UNDN. MOVE "`&d@" TO LAS-FLD PERFORM LASF.
PCL-PUSH. MOVE "`&f0S" TO LAS-FLD PERFORM LASF.
PCL-POP. MOVE "`&f1S" TO LAS-FLD PERFORM LASF.
PCL-PCR. MOVE LAS-COL TO LAS-PCRX MOVE LAS-ROW TO LAS-PCRY MOVE LAS-PCR TO LAS-FLD PERFORM LASF.
PCL-NORM1. MOVE 10 TO LAS-STYP MOVE 0 TO LAS-STYI MOVE 0 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-BOLD1. MOVE 10 TO LAS-STYP MOVE 0 TO LAS-STYI MOVE 3 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-ITAL1. MOVE 10 TO LAS-STYP MOVE 1 TO LAS-STYI MOVE 0 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-IBOLD1. MOVE 10 TO LAS-STYP MOVE 1 TO LAS-STYI MOVE 3 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-NORM2. MOVE 12 TO LAS-STYP MOVE 0 TO LAS-STYI MOVE 0 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-BOLD2. MOVE 12 TO LAS-STYP MOVE 0 TO LAS-STYI MOVE 3 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-ITAL2. MOVE 12 TO LAS-STYP MOVE 1 TO LAS-STYI MOVE 0 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-IBOLD2. MOVE 12 TO LAS-STYP MOVE 1 TO LAS-STYI MOVE 3 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-NORM3. MOVE 16.66 TO LAS-STYP MOVE 0 TO LAS-STYI MOVE 0 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-BOLD3. MOVE 16.66 TO LAS-STYP MOVE 0 TO LAS-STYI MOVE 3 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-ITAL3. MOVE 16.66 TO LAS-STYP MOVE 1 TO LAS-STYI MOVE 0 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.
PCL-IBOLD3. MOVE 16.66 TO LAS-STYP MOVE 1 TO LAS-STYI MOVE 3 TO LAS-STYB MOVE LAS-STYLE TO LAS-FLD PERFORM LASF.

DAT-LINE. MOVE DAT-RECORD TO A-A1 PERFORM STR-LTH MOVE A-N1 TO DAT-SZ.
    WRITE DAT-RECORD MOVE " " TO DAT-RECORD.

SHOW-DRAWING. PERFORM SDR-S1 THRU SDR-S9.
SDR-S1. PERFORM SDR-OPEN IF SDR-KER=1 GO SDR-S9.
SDR-S3. IF SDR-NPG=1 GO SDR-S32.
    MOVE 2 TO SDR-PG PERFORM SIXPG2 PERFORM SIXCLS PERFORM SIXD.
    MOVE SDR-LINE(SDR-PG) TO SDR-FIRST MOVE 76 TO SDR-NUM.
    MOVE 0 TO SDR-OP PERFORM SDR-DSP.
    MOVE 1 TO SDR-PG PERFORM SIXPG1 PERFORM SIXD.
SDR-S32. PERFORM SIXCLS PERFORM SIXD.
    MOVE SDR-LINE(SDR-PG) TO SDR-FIRST MOVE 76 TO SDR-NUM.
    MOVE 0 TO SDR-OP PERFORM SDR-DSP.
SDR-S33. IF SDR-TP=1 MOVE "TOOL:" TO SDR-MESG MOVE SDR-DRAW(SDR-PG) TO SDR-MESG(7:6)
       MOVE "NEXT TOOL:" TO SDR-MESG(57:)
     ELSE MOVE "PRODUCT:" TO SDR-MESG MOVE SDR-PROD(SDR-PG) TO SDR-MESG(10:12)
       MOVE "NEXT PRODUCT:" TO SDR-MESG(54:).
    MOVE "PAGE" TO SDR-MESG(23:4) MOVE SDR-PG TO SDR-MESG(28:1).
    IF SDR-NPG=2 MOVE "(2 PAGES)" TO SDR-MESG(31:9).
    DISPLAY SDR-MESG LINE 24 REVERSED.
SDR-S5. ACCEPT SDR-INP LINE 24 COLUMN 68 DEFAULT " " REVERSED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SDR-INP=ALL "9" GO SDR-S9. IF SDR-INP>" " AND KP-RETURN GO SDR-S8.
    IF KP-SELECT GO SDR-S6. IF SDR-DRAW(SDR-PG)=" " GO SDR-S5.
    IF KP-DOWN IF SDR-INP="." GO SDR-S66 ELSE GO SDR-S62.
    IF KP-UP IF SDR-INP="." GO SDR-S68 ELSE GO SDR-S64.
    GO SDR-S5.
SDR-S6. COMPUTE SDR-PG=3 - SDR-PG.
    MOVE SDR-PG TO A-N1 PERFORM SIXPGN PERFORM SIXD.
* note 178
    IF USN-KPC=1 PERFORM SIXCLS PERFORM SIXD
      MOVE SDR-LINE(SDR-PG) TO SDR-FIRST MOVE 76 TO SDR-NUM
      MOVE 0 TO SDR-OP PERFORM SDR-DSP.
    GO SDR-S33.
SDR-S62. IF SDR-LINE(SDR-PG) + 76<=SDR-MAX(SDR-PG)
      COMPUTE SDR-FIRST=SDR-LINE(SDR-PG) + 76 MOVE 10 TO SDR-NUM
      MOVE 1 TO SDR-OP PERFORM SDR-DSP ADD 10 TO SDR-LINE(SDR-PG).
    GO SDR-S5.
SDR-S64. IF SDR-LINE(SDR-PG) - 10>=1
      COMPUTE SDR-FIRST=SDR-LINE(SDR-PG) - 10 MOVE 10 TO SDR-NUM
      MOVE 2 TO SDR-OP PERFORM SDR-DSP SUBTRACT 10 FROM SDR-LINE(SDR-PG).
    GO SDR-S5.
SDR-S66. PERFORM VARYING WN1 FROM 1 BY 10 UNTIL WN1 + 76>SDR-MAX(SDR-PG) CONTINUE END-PERFORM.
    IF SDR-LINE(SDR-PG) NOT=WN1 MOVE WN1 TO SDR-FIRST MOVE 76 TO SDR-NUM
      MOVE 3 TO SDR-OP PERFORM SDR-DSP MOVE SDR-FIRST TO SDR-LINE(SDR-PG).
    GO SDR-S5.
SDR-S68. IF SDR-LINE(SDR-PG) NOT=1 MOVE 1 TO SDR-FIRST MOVE 76 TO SDR-NUM
      MOVE 4 TO SDR-OP PERFORM SDR-DSP MOVE SDR-FIRST TO SDR-LINE(SDR-PG).
    GO SDR-S5.
SDR-S8. PERFORM SDR-OPEN IF SDR-KER=1 GO SDR-S33. GO SDR-S3.
SDR-S9. EXIT.

* note 2
SDR-DSP. PERFORM SDR-D1 THRU SDR-D9.
SDR-D1. MOVE 1 TO TX-CUR-R TX-CUR-C MOVE TX-CUR TO SIX-FLD PERFORM SIXF.
    IF SDR-OP>=1 AND<=4
      MOVE 1 TO TX-SCR-T MOVE 23 TO TX-SCR-B MOVE TX-SCR TO SIX-FLD PERFORM SIXF
      IF SDR-OP=1 OR 2 MOVE 3 TO A-N1 END-IF
      IF SDR-OP=3 OR 4 MOVE 23 TO A-N1 END-IF
      IF SDR-OP=1 OR 3 MOVE A-N1 TO TX-DEL-N MOVE TX-DEL TO SIX-FLD PERFORM SIXF END-IF
      IF SDR-OP=2 OR 4 MOVE A-N1 TO TX-INS-N MOVE TX-INS TO SIX-FLD PERFORM SIXF END-IF
      MOVE 1 TO TX-SCR-T MOVE 24 TO TX-SCR-B MOVE TX-SCR TO SIX-FLD PERFORM SIXF.
    MOVE TX-SIXSCR TO SIX-FLD PERFORM SIXF MOVE TX-SIXY TO SIX-FLD PERFORM SIXF.
    IF SDR-OP=1 PERFORM 6 TIMES
      MOVE "?$-?$-?$-?$-?$-?$-?$-?$-?$-?$-?$-" TO SIX-FLD PERFORM SIXF END-PERFORM.
    PERFORM SIXD.
    MOVE SDR-DRAW(SDR-PG) TO DR-DRAW MOVE SDR-PAGE(SDR-PG) TO DR-PAGE MOVE SDR-FIRST TO DR-LINE.
    START DRAWINGS KEY>=DR-KEY REGARDLESS INVALID GO SDR-D6.
SDR-D3. READ DRAWINGS NEXT REGARDLESS END GO SDR-D6.
    IF NOT(DR-DRAW=SDR-DRAW(SDR-PG) AND DR-PAGE=SDR-PAGE(SDR-PG)) GO SDR-D6.
    IF DR-LINE>=SDR-FIRST + SDR-NUM GO SDR-D6. COMPUTE A-N1=SIX-SZ - 13.
    IF SIX-IXW + A-N1<=1000
      MOVE DR-DATA(1:A-N1) TO SIX-DISP(SIX-IXW:A-N1) ADD A-N1 TO SIX-IXW.
    IF DR-LINE NOT=SDR-FIRST + SDR-NUM - 1 MOVE "$-" TO SIX-FLD PERFORM SIXF.
    PERFORM SIXD GO SDR-D3.
SDR-D6. MOVE TX-SIXN TO SIX-FLD PERFORM SIXF PERFORM SIXD.
SDR-D9. EXIT.
SDR-OPEN. PERFORM SDR-O1 THRU SDR-O9.
SDR-O1. MOVE 0 TO SDR-KER IF SDR-TP=1 GO SDR-O2.
    MOVE SDR-INP TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6
      MOVE 1 TO SDR-KER GO SDR-O9.
    PERFORM DESC-PRINT MOVE PRO-PRINT(1:6) TO SDR-INP.
SDR-O2. MOVE SDR-INP TO DR-DRAW MOVE 1 TO DR-PAGE MOVE 0 TO DR-LINE.
    READ DRAWINGS REGARDLESS INVALID PERFORM DSP-ERR41 MOVE 1 TO SDR-KER GO SDR-O9.
    MOVE SDR-INP TO SDR-DRAW(SDR-PG) IF SDR-TP=2 MOVE P-NO TO SDR-PROD(SDR-PG).
    MOVE 1 TO SDR-NPG MOVE 1 TO SDR-PAGE(SDR-PG).
    MOVE DR-NLINES TO SDR-MAX(SDR-PG) MOVE SDR-START TO SDR-LINE(SDR-PG).
    MOVE SDR-INP TO DR-DRAW MOVE 2 TO DR-PAGE MOVE 0 TO DR-LINE.
    READ DRAWINGS REGARDLESS INVALID GO SDR-O9.
    MOVE 2 TO SDR-NPG MOVE SDR-INP TO SDR-DRAW(1) SDR-DRAW(2).
    IF SDR-TP=2 MOVE P-NO TO SDR-PROD(1) SDR-PROD(2).
    MOVE 2 TO SDR-PAGE(2) MOVE DR-NLINES TO SDR-MAX(2) MOVE SDR-START TO SDR-LINE(2).
    MOVE SDR-INP TO DR-DRAW MOVE 1 TO DR-PAGE MOVE 0 TO DR-LINE.
    READ DRAWINGS REGARDLESS.
    MOVE 1 TO SDR-PAGE(1) MOVE DR-NLINES TO SDR-MAX(1) MOVE SDR-START TO SDR-LINE(1).
SDR-O9. EXIT.

SIXF. MOVE SIX-FLD TO A-A1 PERFORM STR-LTH.
    IF SIX-IXW + A-N1<=1000
      MOVE SIX-FLD(1:A-N1) TO SIX-DISP(SIX-IXW:A-N1) ADD A-N1 TO SIX-IXW.
SIXINIT. MOVE 1 TO SIX-IXW.
SIXD. DISPLAY SIX-DISP(1:SIX-IXW - 1) PERFORM SIXINIT.
SIXCLS. MOVE TX-CLS TO SIX-FLD PERFORM SIXF.
SIXPGN. MOVE A-N1 TO TX-PG-N MOVE TX-PG TO SIX-FLD PERFORM SIXF.
SIXPG1. MOVE 1 TO A-N1 PERFORM SIXPGN.
SIXPG2. MOVE 2 TO A-N1 PERFORM SIXPGN.

PRINT-DRAWING. PERFORM PDR-L1 THRU PDR-L9.
PDR-L1. IF PDR-TP=1 OR 2 PERFORM RD229 ELSE PERFORM RD230. PERFORM WRT.
    OPEN INPUT PDRAWINGS ALLOWING ALL MOVE 1 TO PDR-NUM MOVE 3 TO IXT.
PDR-L13. ACCEPT PDR-INP LINE IXT COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF PDR-INP=" " GO PDR-L18. IF PDR-TP=1 OR 2 GO PDR-L16.
    MOVE PDR-INP TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO PDR-L13.
    PERFORM DESC-PRINT MOVE PRO-PRINT(1:6) TO PDR-INP.
PDR-L16. MOVE PDR-INP TO PDR-DRAW(PDR-NUM) DG-DRAW MOVE 1 TO DG-PAGE MOVE 0 TO DG-LINE.
    READ PDRAWINGS REGARDLESS INVALID PERFORM DSP-ERR41 GO PDR-L13.
    ADD 1 TO PDR-NUM IXT IF PDR-NUM<=5 GO PDR-L13.
PDR-L18. CLOSE PDRAWINGS SUBTRACT 1 FROM PDR-NUM IF PDR-NUM=0 GO PDR-L9.
    MOVE 8 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO PDR-L9.
    MOVE 1 TO LAS-FLN PERFORM OPEN-LAS OPEN INPUT PDRAWINGS ALLOWING ALL.
    PERFORM DSP-QWAIT MOVE 0 TO PDR-IX1.
PDR-L3. ADD 1 TO PDR-IX1 IF PDR-IX1>PDR-NUM GO PDR-L4.
* note 126
    MOVE PDR-DRAW(PDR-IX1) TO DG-DRAW MOVE 1 TO DG-PAGE DG-LINE.
    START PDRAWINGS KEY>=DG-KEY REGARDLESS INVALID GO PDR-L39.
PDR-L33. READ PDRAWINGS NEXT REGARDLESS END GO PDR-L39.
    IF DG-DRAW NOT=PDR-DRAW(PDR-IX1) GO PDR-L39. IF DG-LINE=0 GO PDR-L33.
    MOVE DG-DATA TO LAS-RECORD WRITE LAS-RECORD GO PDR-L33.
PDR-L39. GO PDR-L3.
PDR-L4. PERFORM CLOSE-LAS CLOSE PDRAWINGS EVALUATE TRUE
      WHEN PDR-TP=1 MOVE "PRINT1" TO LAS-QUEUE
      WHEN PDR-TP=2 MOVE "PRINT2" TO LAS-QUEUE
      WHEN PDR-TP=3 MOVE "CENTRAL" TO LAS-QUEUE
      END-EVALUATE.
    PERFORM PRINT-LAS PERFORM DSP-ERS.
PDR-L9. EXIT.

CREATE-TRAUD. PERFORM CRE-TA1 THRU CRE-TA9.
CRE-TA1. IF NOT(IFAST OR INUT) GO CRE-TA9.
    PERFORM OPEN-TRAUDIT MOVE 0 TO EXP-FLN PERFORM OPEN-EXP.
    MOVE " " TO YT-KEY START TRAUDIT KEY>YT-KEY REGARDLESS INVALID GO CRE-TA4.
CRE-TA3. READ TRAUDIT NEXT REGARDLESS END GO CRE-TA4.
    MOVE YT-CUS TO TR-CUS MOVE YT-INV TO TR-INV.
    READ TRANS REGARDLESS INVALID GO CRE-TA3. IF TR-AMT=0 GO CRE-TA3.
    MOVE YT-INV TO EXP-N PERFORM EXPF MOVE YT-IDATE TO D-DATE PERFORM CRE-D.
    MOVE YT-CUS TO EXP-A PERFORM EXPF MOVE YT-TERMS TO EXP-A PERFORM EXPF.
    MOVE YT-AMT TO EXP-D PERFORM EXPF MOVE YT-TDATE TO D-DATE PERFORM CRE-D.
    MOVE YT-DATE TO D-DATE PERFORM CRE-D MOVE WS-DIV-NAME TO EXP-A PERFORM EXPF.
    EVALUATE TRUE
      WHEN YT-TYPE=0 MOVE "A/R TRADE" TO EXP-A
      WHEN YT-TYPE=1 MOVE "CASH" TO EXP-A
      WHEN YT-TYPE=2 MOVE "ADJUSTMENT" TO EXP-A
      WHEN YT-TYPE=3 MOVE "CREDIT" TO EXP-A
      WHEN OTHER MOVE " " TO EXP-A.
    PERFORM EXPF.
    MOVE YT-CUS TO A-A1 PERFORM RD-CUS.
    IF C-US=0 MOVE "C" TO EXP-A ELSE MOVE "U" TO EXP-A. PERFORM EXPF.
    PERFORM EXPF PERFORM EXP-LINE GO CRE-TA3.
CRE-TA4. CLOSE TRAUDIT PERFORM CLOSE-EXP.
    IF IFAST MOVE "IFAR" TO A-A1 ELSE MOVE "INAR" TO A-A1. PERFORM CRE-F.

    MOVE 0 TO EXP-FLN PERFORM OPEN-EXP.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO CRE-TA6.
CRE-TA5. READ CUSTOMER NEXT REGARDLESS END GO CRE-TA6.
    MOVE WS-DIV-NAME TO EXP-A PERFORM EXPF MOVE C-NO TO EXP-A PERFORM EXPF.
    MOVE C-NAME TO EXP-A PERFORM EXPF MOVE C-ADD1 TO EXP-A PERFORM EXPF.
    MOVE C-ADD2 TO EXP-A PERFORM EXPF MOVE 4 TO A-N1 PERFORM EXPFN.
    MOVE C-POST TO EXP-A PERFORM EXPF.
    EVALUATE TRUE
      WHEN C-PROV>=1 AND<=54 MOVE "USA" TO EXP-A
      WHEN C-PROV>=60 AND<=71 MOVE "CANADA" TO EXP-A
      WHEN OTHER MOVE "OTHER" TO EXP-A.
    PERFORM EXPF.
    MOVE C-DATE-PAY TO D-DATE PERFORM CRE-D MOVE C-CREDIT TO EXP-N PERFORM EXPF.
    IF C-CLASS="A" MOVE "Y" TO EXP-A ELSE MOVE "N" TO EXP-A. PERFORM EXPF.
    MOVE 0 TO A-N1 A-N2.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
      ADD C-PAY-DAYS(A-X1) TO A-N1 ADD C-PAY-NUM(A-X1) TO A-N2 END-PERFORM.
    COMPUTE EXP-N ROUNDED=A-N1 / A-N2 SIZE ERROR MOVE 0 TO EXP-N. PERFORM EXPF.
    PERFORM EXP-LINE GO CRE-TA5.
CRE-TA6. PERFORM CLOSE-EXP.
    IF IFAST MOVE "IFCM" TO A-A1 ELSE MOVE "INCM" TO A-A1. PERFORM CRE-F.
CRE-TA9. EXIT.
CRE-D. PERFORM D-NC MOVE D-N1 TO EXP-N PERFORM EXPF.
CRE-F. MOVE A-A1 TO A-A2 MOVE " " TO A-A1.
    STRING "COPY FL00.PRN DUA1:[IFMAIN]" DELIMITED SIZE A-A2 DELIMITED " " ".DAT" DELIMITED SIZE INTO A-A1.
    PERFORM VMS-CMND.

* note 247
OPEN-TRAUDIT. OPEN I-O TRAUDIT ALLOWING ALL.
ADD-TRAUD. PERFORM ADD-TRA1 THRU ADD-TRA9.
ADD-TRA1. MOVE LOW-VALUES TO YT-RECORD INITIALIZE YT-REC.
    MOVE TR-CUS TO YT-CUS MOVE TR-INV TO YT-INV MOVE SYS-DATE TO YT-DATE.
    MOVE A-N1 TO YT-TYPE MOVE A-N2 TO YT-TDATE MOVE A-D1 TO YT-AMT.
    MOVE TR-DATE TO YT-IDATE MOVE TR-TERMS TO YT-TERMS.
ADD-TRA3. ACCEPT YT-TIME FROM TIME WRITE YT-RECORD ALLOWING NO INVALID GO ADD-TRA3.
    UNLOCK TRAUDIT.
ADD-TRA9. EXIT.
OPEN-AUDIT. OPEN I-O AUDIT ALLOWING ALL.
ADD-AUD. PERFORM ADD-AU1 THRU ADD-AU9.
ADD-AU1. MOVE SYS-DATE TO AU-DATE IF AU-K=3 MOVE WS-EFF-DATE TO AU-DATE.
* note 150.1
    IF AU-K NOT=6 MOVE 0 TO AU-L. MOVE 0 TO AU-IND.
ADD-AU3. ACCEPT AU-TIME FROM TIME WRITE AU-RECORD ALLOWING NO INVALID GO ADD-AU3.
    UNLOCK AUDIT.
ADD-AU9. EXIT.

OPEN-EDI. OPEN INPUT EDI IF DSTAT NOT="00" MOVE "CANNOT OPEN EDI FILE"
      TO ERR-MESG PERFORM DSP-ERR MOVE " " TO EDI-ID.
SET-ENAME. EVALUATE TRUE
      WHEN A-N1=1 MOVE "TOWER" TO A-A1
      WHEN A-N1=2 MOVE "CHRYSLER" TO A-A1
      WHEN A-N1=3 MOVE "GM" TO A-A1
      WHEN A-N1=4 MOVE "ADVANTIS" TO A-A1
      WHEN OTHER MOVE " " TO A-A1.
EDI-ERR. MOVE "***** ERROR READING EDI FILE" TO PREC.
    MOVE 3 TO WS-PR PERFORM PR-LINE.
CHK-PLORD. IF REL-ORD=0 MOVE REL-PLANT TO SR-F101 MOVE REL-PROD TO SR-F102
      WRITE SR-RECORD INVALID CONTINUE.
* note 147
PRINT-PLORD. PERFORM PPL-S1 THRU PPL-S9.
PPL-S1. MOVE 1 TO PR-IXP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO PPL-S4.
PPL-S3. READ SORTFL NEXT END GO PPL-S4.
    STRING SR-F101 ":" SR-F102 DELIMITED " " INTO FG446(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>5 PERFORM PR-LINE MOVE 1 TO PR-IXP. GO PPL-S3.
PPL-S4. PERFORM PR-LASTLN.
PPL-S9. EXIT.
RD-PLANT. PERFORM INIT-PL MOVE REL-PLANT TO PL-PLANT MOVE REL-PROD TO PL-PROD.
    READ PLANT REGARDLESS INVALID CONTINUE. MOVE PL-ORD TO REL-ORD.
* note 38
RDADJ-PNO. PERFORM RDA-P1 THRU RDA-P9.
RDA-P1. MOVE REL-PROD TO P-NO READ PRODUCT REGARDLESS INVALID
      IF P-NO(1:1)="0" MOVE REL-PROD(2:) TO P-NO READ PRODUCT REGARDLESS INVALID
        IF P-NO(1:1)="0" MOVE REL-PROD(3:) TO P-NO READ PRODUCT REGARDLESS INVALID
          GO RDA-P9 ELSE GO RDA-P9 END-IF ELSE GO RDA-P9 END-IF.
    MOVE P-NO TO REL-PROD.
RDA-P9. EXIT.
EXTEND-PNO. PERFORM STR-LTH IF A-N1>=1 AND<=8 MOVE A-A1 TO A-A2
      MOVE "00000000" TO A-A1 MOVE A-A2 TO A-A1(9 - A-N1:A-N1).
* note 239.2
CHK-RBW. IF DY-PLANT="00087" OR "00088" MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.

* note 87.1
DAY-DELREC. PERFORM DAY-D1 THRU DAY-D9.
DAY-D1. MOVE 0 TO A-S1.
    MOVE REL-PLANT TO DY-PLANT MOVE REL-PROD TO DY-PROD MOVE 0 TO DY-SEQ.
    START DAYREL KEY>=DY-KEY REGARDLESS INVALID GO DAY-D4.
DAY-D3. READ DAYREL NEXT REGARDLESS END GO DAY-D4.
    IF NOT(DY-PLANT=REL-PLANT AND DY-PROD=REL-PROD) GO DAY-D4.
    IF A-N1=0 IF DY-ISA-KEY<=REL-ISA-KEY DELETE DAYREL ELSE MOVE 1 TO A-S1 END-IF
      ELSE IF DY-ISA-KEY<=REL-ISA-KEY IF DY-DATE<=SYS-DATE - A-N1 DELETE DAYREL END-IF
        ELSE MOVE 1 TO A-S1 END-IF.
    GO DAY-D3.
DAY-D4.
DAY-D9. EXIT.
DAY-ADDREC. PERFORM DAY-A1 THRU DAY-A9.
DAY-A1. MOVE 0 TO A-N1.
DAY-A3. WRITE DY-RECORD ALLOWING NO INVALID
      ADD 1 TO A-N1 IF A-N1<99 ADD 1 TO DY-SEQ GO DAY-A3 END-IF. UNLOCK DAYREL.
DAY-A9. EXIT.
* note 87.2
MAT-DELREC. PERFORM MAT-D1 THRU MAT-D9.
MAT-D1. MOVE 0 TO A-S1.
    MOVE REL-PLANT TO MT-PLANT MOVE REL-PROD TO MT-PROD MOVE 0 TO MT-SEQ.
    START MATREL KEY>=MT-KEY REGARDLESS INVALID GO MAT-D4.
MAT-D3. READ MATREL NEXT REGARDLESS END GO MAT-D4.
    IF NOT(MT-PLANT=REL-PLANT AND MT-PROD=REL-PROD) GO MAT-D4.
    IF MT-ISA-KEY<=REL-ISA-KEY DELETE MATREL ELSE MOVE 1 TO A-S1. GO MAT-D3.
MAT-D4.
MAT-D9. EXIT.
MAT-ADDREC. PERFORM MAT-A1 THRU MAT-A9.
MAT-A1. MOVE 0 TO A-N1.
MAT-A3. WRITE MT-RECORD ALLOWING NO INVALID
      ADD 1 TO A-N1 IF A-N1<99 ADD 1 TO MT-SEQ GO MAT-A3 END-IF. UNLOCK MATREL.
MAT-A9. EXIT.

DX-RD-GMC. INITIALIZE ED-GMC-DATA MOVE ED-GMC-DATA TO DX-DATA.
    PERFORM DX-READ MOVE DX-DATA TO ED-GMC-DATA.
DX-RD-AMAX. INITIALIZE ED-AMAX-DATA MOVE ED-AMAX-DATA TO DX-DATA.
    PERFORM DX-READ MOVE DX-DATA TO ED-AMAX-DATA.
DX-RD-DELP. INITIALIZE ED-DELP-DATA MOVE ED-DELP-DATA TO DX-DATA.
    PERFORM DX-READ MOVE DX-DATA TO ED-DELP-DATA.
DX-RD-SAT. INITIALIZE ED-SAT-DATA MOVE ED-SAT-DATA TO DX-DATA.
    PERFORM DX-READ MOVE DX-DATA TO ED-SAT-DATA.
DX-RD-BEN. INITIALIZE ED-BEN-DATA MOVE ED-BEN-DATA TO DX-DATA.
    PERFORM DX-READ MOVE DX-DATA TO ED-BEN-DATA.
DX-READ. MOVE A-N1 TO DX-NO IF DX-NO>0 READ DELJITEX REGARDLESS INVALID CONTINUE.
DX-ADD. PERFORM DX-A1 THRU DX-A9.
DX-A1. PERFORM RD-INFO IF IF-DXNO=9999 MOVE 1 TO IF-DXNO ELSE ADD 1 TO IF-DXNO.
    PERFORM WR-INFO.
    MOVE IF-DXNO TO DX-NO READ DELJITEX REGARDLESS INVALID GO DX-A8. DELETE DELJITEX.
DX-A8. MOVE LOW-VALUES TO DX-RECORD MOVE IF-DXNO TO DX-NO MOVE SYS-DATE TO DX-DATE.
DX-A9. EXIT.
DX-SET-CTNS. MOVE 0 TO DX-CTNS PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>5
      ADD ED-ACARTONS(DX-IXP,A-X1) TO DX-CTNS END-PERFORM.
DX-SET-PULLS. PERFORM VARYING DX-IXP FROM 1 BY 1 UNTIL DX-IXP>30 OR ED-AKAN(DX-IXP)=" " CONTINUE END-PERFORM.
    COMPUTE DX-PULLS=DX-IXP - 1.
DX-SET-CNUM. IF C-NO="06105" OR "06106" MOVE 36 TO DX-CNUM ELSE MOVE 18 TO DX-CNUM.
DX-PSET-CNUM. IF DY-PLANT="400104134" OR "812481521" MOVE 36 TO DX-CNUM ELSE MOVE 18 TO DX-CNUM.
* note 212
DX-LAB-AMAX. PERFORM DX-L1 THRU DX-L9.
DX-L1. MOVE HL-DATE-REQ TO BAR-DATE MOVE HL-PROD TO BAR-PROD MOVE " " TO BAR-DESC.
    MOVE PRO-DESC(1)(1:16) TO BAR-DESC-A MOVE PRO-DESC(1)(17:) TO BAR-DESC-B.
    PERFORM BAR-TXT-INSPECT PERFORM BAR-SHP-NAME.
    MOVE ED-AGROUP TO ED-PKG11 MOVE ED-ADOCK TO ED-PKG12.
    MOVE ED-AORD(DX-IXP) TO BAR-CUSORD MOVE ED-AKAN(DX-IXP) TO BAR-KANBAN.
    PERFORM DX-SET-CTNS.
    MOVE DX-CTNS TO BAR-CARTONS COMPUTE BAR-QTY=DX-CTNS * P-QTY-PACK.
    MOVE ED-ASERIAL(DX-IXP) TO BAR-SERIAL MOVE 2 TO BAR-LABQTY BAR-QSER.
    IF DX-SERIAL=0 OR BAR-SERIAL PERFORM BAR-LAB-AMASTER.
    MOVE P-QTY-PACK TO BAR-QTY COMPUTE BAR-SERIAL=ED-ASERIAL(DX-IXP) + 1.
    IF DX-SERIAL=0 PERFORM VARYING DX-IXL FROM 1 BY 1 UNTIL DX-IXL>5
      MOVE ED-ACARTONS(DX-IXP,DX-IXL) TO BAR-LABQTY MOVE 1 TO BAR-QSER
      MOVE ED-ALOT(DX-IXP,DX-IXL) TO BAR-LOT
      IF BAR-LABQTY>0 PERFORM BAR-LAB-AMAX END-IF END-PERFORM
     ELSE PERFORM VARYING DX-IXL FROM 1 BY 1 UNTIL DX-IXL>5
      IF DX-SERIAL>=BAR-SERIAL AND<BAR-SERIAL + ED-ACARTONS(DX-IXP,DX-IXL)
        MOVE 1 TO BAR-LABQTY BAR-QSER MOVE ED-ALOT(DX-IXP,DX-IXL) TO BAR-LOT
        MOVE DX-SERIAL TO BAR-SERIAL PERFORM BAR-LAB-AMAX GO DX-L8
       ELSE ADD ED-ACARTONS(DX-IXP,DX-IXL) TO BAR-SERIAL END-IF END-PERFORM.
DX-L8. PERFORM BAR-LAB-SPACER.
DX-L9. EXIT.

* note 229
EL-RDNUM. PERFORM EL-RN1 THRU EL-RN9.
EL-RN1. MOVE 0 TO ED-NUM.
    PERFORM VARYING ED-IX1 FROM 1 BY 1 UNTIL ED-IX1>12
      MOVE ED-ANUM(ED-IX1:1) TO ED-VCA IF ED-VCN NOT NUMERIC GO EL-RN9 END-IF
      COMPUTE ED-NUM=ED-NUM * 10 + ED-VCN END-PERFORM.
EL-RN9. EXIT.
EL-RDVAL. PERFORM EL-RV1 THRU EL-RV9.
EL-RV1. MOVE 0 TO ED-T1 ED-T2 ED-KN ED-IX1.
EL-RV3. ADD 1 TO ED-IX1 IF ED-IX1>ED-LTH GO EL-RV8.
    MOVE ED-LINE(ED-IX1:1) TO ED-VCA IF ED-VCA NUMERIC GO EL-RV4.
    IF ED-VCA="-" MOVE 1 TO ED-KN. IF ED-VCA="." MOVE 1 TO ED-T2. GO EL-RV3.
EL-RV4. COMPUTE ED-T1=ED-T1 * 10 + ED-VCN MULTIPLY 10 BY ED-T2 GO EL-RV3.
EL-RV8. IF ED-T2=0 MOVE ED-T1 TO ED-VAL ELSE COMPUTE ED-VAL=ED-T1 / ED-T2.
    IF ED-KN=1 COMPUTE ED-VAL=-ED-VAL.
EL-RV9. EXIT.
EL-RDATE. PERFORM EL-RDVAL MOVE ED-VAL TO ED-DTM MOVE 0 TO D-DATE D-TIME.
    IF ED-DFQUAL="102" OR "203" OR "303"
      IF ED-DTM(1:4)="0000" MOVE ED-DTM(7:6) TO D-DT PERFORM D-YN
        ELSE MOVE ED-DTM(3:6) TO D-DT PERFORM D-YN MOVE ED-DTM(9:4) TO D-TIME.
EL-RADATE. MOVE " " TO ED-A21 ED-A31 ED-A41 MOVE 0 TO D-DT.
    UNSTRING ED-ADATE DELIMITED "/" OR "-" OR " " INTO ED-A21 ED-A31 ED-A41.
    MOVE ED-A21 TO ED-ANUM PERFORM EL-RDNUM MOVE ED-NUM TO D-DD.
    IF ED-A31(1:1) NUMERIC MOVE ED-A31 TO ED-ANUM PERFORM EL-RDNUM MOVE ED-NUM TO D-MM
      ELSE CALL "STR$UPCASE" USING DESCRIPTOR ED-A32 ED-A31
        PERFORM VARYING ED-IX1 FROM 1 BY 1
          UNTIL ED-IX1>12 OR D-MTHNM(ED-IX1)(1:3)=ED-A32 CONTINUE END-PERFORM
       IF ED-IX1<=12 MOVE ED-IX1 TO D-MM.
    MOVE ED-A41 TO ED-ANUM PERFORM EL-RDNUM DIVIDE ED-NUM BY 100 GIVING ED-NUM REMAINDER D-YY.
    PERFORM D-MN.
EL-GET-SEP. MOVE ED-RECORD(4:1) TO ED-SEP MOVE ED-RECORD(106:1) TO ED-NL.
EL-SWRITE. IF ED-SEP NOT="~" INSPECT ED-RECORD REPLACING ALL "~" BY ED-SEP.
    PERFORM EL-WRITE.
EL-WRITE. COMPUTE EDI-SZ=ED-PTR - 1 WRITE ED-RECORD.
    ADD 1 TO ED-ST-TOT MOVE 1 TO ED-PTR.
* note 221
EL-CLR. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>30
      MOVE ED-NL TO ED-RECORD(EDI-SZ + A-X1:1) END-PERFORM.
* note 230
EL-CSV. PERFORM EL-CS1 THRU EL-CS9.
EL-CS1. MOVE 1 TO A-X1 A-X4.
EL-CS3. MOVE 0 TO A-S1.
EL-CS5. MOVE 0 TO A-X2 COMPUTE A-X3=EDI-SZ - A-X1 + 1.
    INSPECT ED-RECORD(A-X1:A-X3) TALLYING A-X2 FOR CHARACTERS BEFORE """".
    IF A-X2=A-X3 GO EL-CS8. IF A-S1=1 MOVE A-X1 TO A-X3. ADD A-X2 TO A-X1.
    MOVE ED-RECORD(A-X1 + 1:) TO ED-RECORD(A-X1:) SUBTRACT 1 FROM EDI-SZ.
    IF A-S1=0 MOVE 1 TO A-S1 GO EL-CS5.
    INSPECT ED-RECORD(A-X3:A-X1 - A-X3) REPLACING ALL "," BY "\".
    ADD 1 TO A-X4 IF A-X4<=20 GO EL-CS3.
EL-CS8. MOVE ED-NL TO ED-RECORD(EDI-SZ + 1:1).
EL-CS9. EXIT.

RD-SALESMAN. OPEN I-O SALESMAN ALLOWING ALL INITIALIZE SN-REC MOVE A-N1 TO SN-NO.
    READ SALESMAN REGARDLESS INVALID CONTINUE. CLOSE SALESMAN.
RD-EMPL. INITIALIZE E-REC MOVE WS-PDIV TO E-DIV MOVE A-N1 TO E-NO.
    READ EMPL REGARDLESS INVALID CONTINUE.
RDF-PRODORD. PERFORM RDF-PR1 THRU RDF-PR9.
RDF-PR1. IF R-NO<=9999 GO RDF-PR8. READ PRODORD REGARDLESS INVALID GO RDF-PR8.
    MOVE 0 TO A-S1 GO RDF-PR9.
RDF-PR8. PERFORM DSP-ERR11 MOVE 1 TO A-S1.
RDF-PR9. EXIT.
RD-PRODORD. INITIALIZE R-REC R-KP MOVE A-N1 TO R-NO READ PRODORD REGARDLESS INVALID CONTINUE.
RD-CUS. INITIALIZE C-REC MOVE A-A1 TO C-NO READ CUSTOMER REGARDLESS INVALID CONTINUE.
RD-VEN. INITIALIZE V-REC MOVE WS-DIV TO V-DIV MOVE A-N1 TO V-NO READ VENDOR REGARDLESS INVALID CONTINUE.
RD-PART. INITIALIZE PH-REC PH-KA MOVE A-A1 TO PH-NO READ PART REGARDLESS INVALID CONTINUE.
RD-PURBIN. INITIALIZE BH-REC BH-KP MOVE A-A1 TO BH-NO READ PURBIN REGARDLESS INVALID CONTINUE.
RD-SAORD. INITIALIZE O-REC O-KC MOVE A-N1 TO O-NO READ SAORD REGARDLESS INVALID CONTINUE.
RD-SALIN. INITIALIZE L-REC L-KP MOVE A-N1 TO L-NO READ SALIN REGARDLESS INVALID CONTINUE.
RD-LOT. INITIALIZE LT-REC MOVE A-N1 TO LT-NO READ LOT REGARDLESS INVALID CONTINUE.
RD-MAC. INITIALIZE M-REC MOVE A-N1 TO M-NO READ MACHINE REGARDLESS INVALID CONTINUE.
RD-MACTYPE. INITIALIZE ME-REC MOVE A-N1 TO ME-NO READ MACTYPE REGARDLESS INVALID CONTINUE.
RD-MNTMAC. INITIALIZE MK-REC MOVE A-N1 TO MK-NO READ MNTMAC REGARDLESS INVALID CONTINUE.
RD-PACKING. INITIALIZE PK-REC MOVE A-N1 TO PK-NO READ PACKING REGARDLESS INVALID CONTINUE.
RD-TBL. READ TABLES REGARDLESS INVALID MOVE ALL "0" TO T-LINE.
RD-VIA. INITIALIZE SV-REC IF SV-KEY NOT=0 READ SHIPVIA REGARDLESS INVALID CONTINUE.

RDR-INFO. MOVE 1 TO IF-KEY READ INFOFL REGARDLESS.
RD-INFO. MOVE 1 TO IF-KEY READ INFOFL ALLOWING NO IF DSTAT NOT="00" PERFORM LKWAIT GO RD-INFO.
WR-INFO. MOVE 1 TO IF-KEY REWRITE IF-RECORD ALLOWING NO UNLOCK INFOFL.
RDR-EDINFO. MOVE 1 TO EI-KEY READ EDINFO REGARDLESS.
RD-EDINFO. MOVE 1 TO EI-KEY READ EDINFO ALLOWING NO IF DSTAT NOT="00" PERFORM LKWAIT GO RD-EDINFO.
WR-EDINFO. MOVE 1 TO EI-KEY REWRITE EI-RECORD ALLOWING NO UNLOCK EDINFO.

RDLK-CUSTOMER. READ CUSTOMER ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-CUSTOMER.
RDLK-VENDOR. READ VENDOR ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-VENDOR.
RDLK-PRODUCT. READ PRODUCT ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-PRODUCT.
RDLK-PART. READ PART ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-PART.
RDLK-BIN. READ BIN ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-BIN.
RDLK-PURBIN. READ PURBIN ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-PURBIN.
RDLK-TOOLS. READ TOOLS ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-TOOLS.
RDLK-MNTORD. READ MNTORD ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-MNTORD.
RDLK-SHIPTO. READ SHIPTO ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-SHIPTO.
RDLK-MACHINE. READ MACHINE ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-MACHINE.
RDLK-LOT. READ LOT ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-LOT.
RDLK-HEAT. READ HEAT ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-HEAT.
RDLK-EMPL. READ EMPL ALLOWING NO IF DSTAT="90" OR "92" PERFORM LKWAIT GO RDLK-EMPL.

* note 52
PRANGE-CUS. STRING "CUSTOMER RANGE SELECTED: " DELIMITED SIZE CUS1 DELIMITED " "
      " - " DELIMITED SIZE CUS2 DELIMITED " " INTO PREC PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-PROD. STRING "PRODUCT RANGE SELECTED: " DELIMITED SIZE PROD1 DELIMITED " "
      " - " DELIMITED SIZE PROD2 DELIMITED " " INTO PREC PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-PART. STRING "PART RANGE SELECTED: " DELIMITED SIZE PART1 DELIMITED " "
      " - " DELIMITED SIZE PART2 DELIMITED " " INTO PREC PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-MAT. STRING "MATERIAL RANGE SELECTED: " DELIMITED SIZE MAT1 DELIMITED " "
      " - " DELIMITED SIZE MAT2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-BIN. STRING "BIN RANGE SELECTED: " DELIMITED SIZE BIN1 DELIMITED " "
      " - " DELIMITED SIZE BIN2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-PBIN. STRING "BIN RANGE SELECTED: " DELIMITED SIZE PBIN1 DELIMITED " "
      " - " DELIMITED SIZE PBIN2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-PLANT. STRING "PLANT RANGE SELECTED: " DELIMITED SIZE PLANT1 DELIMITED " "
      " - " DELIMITED SIZE PLANT2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-HEAT. STRING "HEAT RANGE SELECTED: " DELIMITED SIZE HEAT1 DELIMITED " "
      " - " DELIMITED SIZE HEAT2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-IMAC. STRING "MACHINE RANGE SELECTED: " DELIMITED SIZE IMAC1 DELIMITED " "
      " - " DELIMITED SIZE IMAC2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-RCV. STRING "RECEIVER RANGE SELECTED: " DELIMITED SIZE RCV1 DELIMITED " "
      " - " DELIMITED SIZE RCV2 DELIMITED " " INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-MAC. MOVE MAC1 TO DSP-N31 MOVE MAC2 TO DSP-N32.
    STRING "MACHINE RANGE SELECTED: " DSP-N31 " - " DSP-N32 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-PROC. MOVE MAC1 TO DSP-N31 MOVE MAC2 TO DSP-N32.
    STRING "PROCESS RANGE SELECTED: " DSP-N31 " - " DSP-N32 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-CAT. MOVE CAT1 TO DSP-N21 MOVE CAT2 TO DSP-N22.
    STRING "CATEGORY RANGE SELECTED: " DSP-N21 " - " DSP-N22 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-PCAT. MOVE PCAT1 TO DSP-N31 MOVE PCAT2 TO DSP-N32.
    STRING "CATEGORY RANGE SELECTED: " DSP-N31 " - " DSP-N32 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-GROUP. MOVE GROUP1 TO DSP-N21 MOVE GROUP2 TO DSP-N22.
    STRING "MACHINE GROUP RANGE SELECTED: " DSP-N21 " - " DSP-N22 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-SPEC. MOVE SPEC1 TO DSP-N31 MOVE SPEC2 TO DSP-N32.
    STRING "SPEC RANGE SELECTED: " DSP-N31 " - " DSP-N32 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-FAM. MOVE FAM1 TO DSP-N21 MOVE FAM2 TO DSP-N22.
    STRING "FAMILY RANGE SELECTED: " DSP-N21 " - " DSP-N22 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-VEN. MOVE VEN1 TO DSP-N41 MOVE VEN2 TO DSP-N42.
    STRING "VENDOR RANGE SELECTED: " DSP-N41 " - " DSP-N42 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-LOT. MOVE LOT1 TO DSP-F71 MOVE LOT2 TO DSP-F72.
    STRING "LOT RANGE SELECTED: " DSP-F71 " - " DSP-F72 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-MO. MOVE ORD1 TO DSP-N51 MOVE ORD2 TO DSP-N52.
    STRING "M.O. RANGE SELECTED: " DSP-N51 " - " DSP-N52 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-GL. MOVE GLAC1 TO DSP-GL1 MOVE GLAC2 TO DSP-GL2.
    STRING "A/C RANGE SELECTED: " DSP-GL1 " - " DSP-GL2 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
PRANGE-DATE. MOVE 1 TO WS-PR PERFORM PRANGE-COPY-STR MOVE "-" TO FF5C.
    MOVE DATE1 TO D-DATE PERFORM D-NM MOVE D-DT TO FF5B.
    MOVE DATE2 TO D-DATE PERFORM D-NM MOVE D-DT TO FF5D PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-DT. MOVE 1 TO WS-PR PERFORM PRANGE-COPY-STR.
    MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-DT TO FF5B PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-MONTH. MOVE 1 TO WS-PR PERFORM PRANGE-COPY-STR MOVE "-" TO FF5F.
    MOVE DATE1 TO D-DATE PERFORM D-NM COMPUTE FF5E=100 * D-MM + D-YY.
    MOVE DATE2 TO D-DATE PERFORM D-NM COMPUTE FF5G=100 * D-MM + D-YY PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-MTH. MOVE 1 TO WS-PR PERFORM PRANGE-COPY-STR.
    MOVE DATE0 TO D-DATE PERFORM D-NM COMPUTE FF5E=100 * D-MM + D-YY PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
PRANGE-COPY-STR. PERFORM STR-LTH IF A-N1=0 OR>19 MOVE 19 TO A-N1.
    MOVE A-A1 TO FF5(20 - A-N1:).

AX-SEL. ACCEPT SEL-N LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
AX-PR. ACCEPT PR-NUM LINE IXT COLUMN 18 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
AX-OK. ACCEPT XA2 LINE IXT COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
AX-OKW. ACCEPT XA2 LINE IXT COLUMN 129 DEFAULT " " UNDERLINED PROTECTED.
AX-ACC. ADD 1 TO IXT DISPLAY "'OK' TO CONTINUE: __" LINE IXT BOLD ERASE LINE.
    ACCEPT XA2 LINE IXT COLUMN 19 DEFAULT " " UNDERLINED PROTECTED.
AX-PRNUM. ADD 1 TO IXT DISPLAY "PRINT FILE NO.: __" LINE IXT BOLD ERASE LINE.
    ACCEPT PR-NUM LINE IXT COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
AX-CHQ. ADD 1 TO IXT DISPLAY "FIRST CHEQUE NO.: ______" LINE IXT BOLD ERASE LINE.
    ACCEPT WS-CHQNO LINE IXT COLUMN 19 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
AX-EDI. ADD 1 TO IXT DISPLAY "FILE NAME:" LINE IXT BOLD.
    ACCEPT EDI-ID LINE IXT COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
* note 54
AX-EXCH. PERFORM AX-E1 THRU AX-E9.
AX-E1. ADD 1 TO IXT DISPLAY "US$ EXCH: ______" LINE IXT BOLD.
    MOVE IF-EXCH-AP TO WS-EXCH DISPLAY WS-EXCH LINE IXT COLUMN 11 CONVERSION.
AX-E3. ACCEPT WS-EXCH LINE IXT COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY WS-EXCH LINE IXT COLUMN 11 CONVERSION.
    IF WS-EXCH=0 PERFORM DSP-ERR2 GO AX-E3.
AX-E9. EXIT.

AX-LIM-DATE. ADD 1 TO IXT DISPLAY "LIMIT DATE: ______" LINE IXT BOLD ERASE LINE.
    MOVE 13 TO IXU PERFORM AX-DT-VAL.
AX-EFF-DATE. ADD 1 TO IXT DISPLAY "A/P EFFECTIVE DATE: ______" LINE IXT BOLD ERASE LINE.
    MOVE 21 TO IXU PERFORM AX-DT-VAL.
AX-AP-DATE. ADD 1 TO IXT DISPLAY "A/P EFFECTIVE DATE: ______" LINE IXT BOLD ERASE LINE.
    MOVE 21 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.
AX-AR-DATE. ADD 1 TO IXT DISPLAY "A/R EFFECTIVE DATE: ______" LINE IXT BOLD ERASE LINE.
    MOVE 21 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO WS-EFF-DATE.
AX-AGE-DATE. ADD 1 TO IXT DISPLAY "AGING DATE: ______" LINE IXT BOLD ERASE LINE.
    MOVE 13 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.

* note 275
AX-DT-INV. PERFORM AX-DI1 THRU AX-DI9.
AX-DI1. ACCEPT D-DT LINE IXT COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY D-DT LINE IXT COLUMN IXU IF D-DT=0 MOVE 0 TO DATE0 GO AX-DI9.
    PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO AX-DI1.
    PERFORM D-MN MOVE D-DATE TO DATE0.
AX-DI9. EXIT.
AX-DT-VAL. PERFORM AX-DT1 THRU AX-DT9.
AX-DT1. IF D-PF=0 ACCEPT D-DT LINE IXT COLUMN IXU DEFAULT ZERO
         UNDERLINED PROTECTED CONVERSION
      ELSE ACCEPT D-DT LINE IXT COLUMN IXU DEFAULT ZERO
         UNDERLINED PROTECTED CONVERSION KEY CKEY.
    DISPLAY D-DT LINE IXT COLUMN IXU.
    IF D-PF=1 AND (KPF1 OR KPF3) OR D-PF=3 AND KPF3 OR D-PF=4 AND KPF4 GO AX-DT8.
    PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO AX-DT1.
    PERFORM D-MN MOVE D-DATE TO DATE0.
AX-DT8. MOVE 0 TO D-PF.
AX-DT9. EXIT.
AX-DT-DEF. PERFORM AX-DF1 THRU AX-DF9.
AX-DF1. PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN IXU.
AX-DF3. IF D-PF=0 ACCEPT D-DT LINE IXT COLUMN IXU DEFAULT CURRENT
         UNDERLINED PROTECTED NO BLANK CONVERSION
       ELSE ACCEPT D-DT LINE IXT COLUMN IXU DEFAULT CURRENT
         UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    DISPLAY D-DT LINE IXT COLUMN IXU.
    IF D-PF=1 AND (KPF1 OR KPF3) OR D-PF=3 AND KPF3 OR D-PF=4 AND KPF4 GO AX-DF8.
    PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO AX-DF3.
    PERFORM D-MN MOVE D-DATE TO DATE0.
AX-DF8. MOVE 0 TO D-PF.
AX-DF9. EXIT.

AX-CUS. ADD 1 TO IXT.
    DISPLAY "FROM CUSTOMER: ______           TO CUSTOMER: ______" LINE IXT BOLD ERASE LINE.
    MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-CUS-R.
AX-PROD. ADD 1 TO IXT.
    DISPLAY "FROM PRODUCT: ____________      TO PRODUCT: ____________" LINE IXT BOLD ERASE LINE.
    MOVE 15 TO IXU MOVE 45 TO IXV PERFORM AX-PROD-R.
AX-CAT. ADD 1 TO IXT.
    DISPLAY "FROM CATEGORY: __               TO CATEGORY: __" LINE IXT BOLD ERASE LINE.
    MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-CAT-R.
AX-BIN. ADD 1 TO IXT.
    DISPLAY "FROM BIN: _____                 TO BIN: _____" LINE IXT BOLD ERASE LINE.
    MOVE 11 TO IXU MOVE 41 TO IXV PERFORM AX-BIN-R.
AX-LOT. ADD 1 TO IXT.
    DISPLAY "FROM LOT: _______               TO LOT: _______" LINE IXT BOLD ERASE LINE.
    MOVE 11 TO IXU MOVE 41 TO IXV PERFORM AX-LOT-R.
AX-VEN. ADD 1 TO IXT.
    DISPLAY "FROM VENDOR: ____               TO VENDOR: ____" LINE IXT BOLD ERASE LINE.
    MOVE 14 TO IXU MOVE 44 TO IXV PERFORM AX-VEN-R.
AX-RCV. ADD 1 TO IXT.
    DISPLAY "FROM RECEIVER: ___              TO RECEIVER: ___" LINE IXT BOLD ERASE LINE.
    MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-RCV-R.
AX-DATE. ADD 1 TO IXT.
    DISPLAY "FROM DATE: ______               TO DATE: ______" LINE IXT BOLD ERASE LINE.
    MOVE 12 TO IXU MOVE 42 TO IXV PERFORM AX-DATE-R.
AX-GLAC. ADD 1 TO IXT.
    DISPLAY "FROM G/L A/C: _____________________       TO G/L A/C: _____________________" LINE IXT BOLD ERASE LINE.
    MOVE 15 TO IXU MOVE 55 TO IXV PERFORM AX-GLAC-R.

    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
AX-CUS-R. ACCEPT CUS1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT CUS2 LINE IXT COLUMN IXV ACC-ALP.
AX-PROD-R. ACCEPT PROD1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT PROD2 LINE IXT COLUMN IXV ACC-ALP.
AX-CAT-R. ACCEPT CAT1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT CAT2 LINE IXT COLUMN IXV ACC-NUM.
AX-PCAT-R. ACCEPT PCAT1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT PCAT2 LINE IXT COLUMN IXV ACC-NUM.
AX-MAC-R. ACCEPT MAC1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT MAC2 LINE IXT COLUMN IXV ACC-NUM.
AX-WIRE-R. ACCEPT WIRE1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT WIRE2 LINE IXT COLUMN IXV ACC-NUM.
AX-PART-R. ACCEPT PART1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT PART2 LINE IXT COLUMN IXV ACC-ALP.
AX-BIN-R. ACCEPT BIN1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT BIN2 LINE IXT COLUMN IXV ACC-ALP.
AX-PBIN-R. ACCEPT PBIN1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT PBIN2 LINE IXT COLUMN IXV ACC-ALP.
AX-LOT-R. ACCEPT LOT1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT LOT2 LINE IXT COLUMN IXV ACC-NUM.
AX-MAT-R. ACCEPT MAT1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT MAT2 LINE IXT COLUMN IXV ACC-ALP.
AX-VEN-R. ACCEPT VEN1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT VEN2 LINE IXT COLUMN IXV ACC-NUM.
AX-HEAT-R. ACCEPT HEAT1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT HEAT2 LINE IXT COLUMN IXV ACC-ALP.
AX-PLANT-R. ACCEPT PLANT1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT PLANT2 LINE IXT COLUMN IXV ACC-ALP.
AX-SPEC-R. ACCEPT SPEC1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT SPEC2 LINE IXT COLUMN IXV ACC-NUM.
AX-FAM-R. ACCEPT FAM1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT FAM2 LINE IXT COLUMN IXV ACC-NUM.
AX-ORD-R. ACCEPT ORD1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT ORD2 LINE IXT COLUMN IXV ACC-NUM.
AX-QUOT-R. ACCEPT QUOT1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT QUOT2 LINE IXT COLUMN IXV ACC-NUM.
AX-RCV-R. ACCEPT RCV1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT RCV2 LINE IXT COLUMN IXV ACC-ALP.
AX-REP-R. ACCEPT REP1 LINE IXT COLUMN IXU ACC-ALP.
    ACCEPT REP2 LINE IXT COLUMN IXV ACC-ALP.
AX-GROUP-R. ACCEPT GROUP1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT GROUP2 LINE IXT COLUMN IXV ACC-NUM.
AX-EMP-R. ACCEPT EMP1 LINE IXT COLUMN IXU ACC-NUM.
    ACCEPT EMP2 LINE IXT COLUMN IXV ACC-NUM.
    REPLACE OFF.

AX-DATE-R. PERFORM AX-DAT1 THRU AX-DAT9.
AX-DAT1. ACCEPT D-DT LINE IXT COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO AX-DAT1.
    PERFORM D-MN MOVE D-DATE TO DATE1.
AX-DAT3. ACCEPT D-DT LINE IXT COLUMN IXV DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO AX-DAT3.
    PERFORM D-MN MOVE D-DATE TO DATE2.
AX-DAT9. EXIT.
AX-GLAC-R. MOVE 0 TO WS-GL PERFORM AX-GL MOVE WS-GL TO GLAC1.
    MOVE IXV TO IXU MOVE 0 TO WS-GL PERFORM AX-GL MOVE WS-GL TO GLAC2.
AX-IMAC-R. PERFORM AX-IM1 THRU AX-IM9.
AX-IM1. ACCEPT MNT-IMAC LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM MNT-GETMAC IF MNT-KERR=1 GO AX-IM1. MOVE MNT-IMAC TO IMAC1.
AX-IM3. ACCEPT MNT-IMAC LINE IXT COLUMN IXV DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM MNT-GETMAC IF MNT-KERR=1 GO AX-IM3. MOVE MNT-IMAC TO IMAC2.
AX-IM9. EXIT.

AX-YM. ADD 1 TO IXT.
    DISPLAY "YEAR (0-99) __     MONTH (1-12) __" LINE IXT BOLD ERASE LINE.
    MOVE 13 TO IXU MOVE 33 TO IXV PERFORM AX-YM-S.
AX-YM-S. PERFORM AX-YM1 THRU AX-YM9.
AX-YM1. MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    DISPLAY D-YY LINE IXT COLUMN IXU CONVERSION D-MM COLUMN IXV CONVERSION.
    ACCEPT D-YY LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY D-YY LINE IXT COLUMN IXU CONVERSION.
AX-YM3. ACCEPT D-MM LINE IXT COLUMN IXV DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY D-MM LINE IXT COLUMN IXV CONVERSION.
    IF D-MM=0 OR>12 PERFORM DSP-ERR2 GO AX-YM3.
AX-YM9. EXIT.

AX-TOT. ADD 1 TO IXT DISPLAY "TOTALS ONLY ? ___" LINE IXT BOLD ERASE LINE.
    MOVE 15 TO IXU PERFORM AX-TOT-S.
AX-TOT-S. ACCEPT XA3 LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO TOT-IND ELSE MOVE 0 TO TOT-IND.
AX-SUM. ADD 1 TO IXT DISPLAY "SUMMARY ONLY ? ___" LINE IXT BOLD ERASE LINE.
    MOVE 16 TO IXU PERFORM AX-SUM-S.
AX-SUM-S. ACCEPT XA3 LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SUM-IND ELSE MOVE 0 TO SUM-IND.
AX-US. ADD 1 TO IXT DISPLAY "US$ ? ___" LINE IXT BOLD ERASE LINE.
    MOVE 7 TO IXU PERFORM AX-US-S.
AX-US-S. ACCEPT XA3 LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO USD-IND ELSE MOVE 0 TO USD-IND.

AX-TIME. PERFORM AX-TIM1 THRU AX-TIM9.
AX-TIM1. MOVE D-TIME(1:2) TO D-TT DISPLAY D-TT LINE IXT COLUMN IXU.
AX-TIM3. ACCEPT D-TT LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY D-TT LINE IXT COLUMN IXU IF D-TT>24 PERFORM DSP-ERR2 GO AX-TIM3.
    IF D-TT=24 MOVE 0 TO D-TT. MOVE D-TT TO D-TIME(1:2).
    MOVE D-TIME(3:2) TO D-TT DISPLAY D-TT LINE IXT COLUMN IXU PLUS 3.
AX-TIM5. ACCEPT D-TT LINE IXT COLUMN IXU PLUS 3 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY D-TT LINE IXT COLUMN IXU PLUS 3 IF D-TT>59 PERFORM DSP-ERR2 GO AX-TIM5.
    MOVE D-TT TO D-TIME(3:2).
AX-TIM9. EXIT.
AX-PDIV. ACCEPT WS-PDIV LINE IXT COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(WS-PDIV=30 OR 35 OR 40 OR 45 OR 50) PERFORM DSP-ERR2 GO AX-PDIV.
AX-NY. PERFORM AX-NY1 THRU AX-NY9.
AX-NY1. IF A-S1>1 MOVE 0 TO A-S1. MOVE LIT-NY(A-S1 + 1:1) TO XA1.
    DISPLAY "ENTER 'Y' OR 'N' OR LEAVE UNCHANGED" LINE 24 BOLD.
    ACCEPT XA1 LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED KEY CKEY PERFORM DSP-ERS.
    IF XA1="Y" MOVE 1 TO A-S1 ELSE IF XA1="N" MOVE 0 TO A-S1
      ELSE PERFORM DSP-ERR14 GO AX-NY1.
AX-NY9. EXIT.

GET-TS. PERFORM INIT-TS MOVE P-NO TO TS-PROD MOVE P-MAC TO TS-MAC.
    MOVE 0 TO A-S1 READ TOOLS REGARDLESS INVALID MOVE 1 TO A-S1.
* note 105.2
TL-FIND-TYPE. EVALUATE TRUE
      WHEN TS-MAC=3 OR 7 MOVE 1 TO TL-NTYPE
      WHEN TS-MAC=1 OR 2 OR>=4 AND<=6 MOVE 2 TO TL-NTYPE
      WHEN TS-MAC=17 OR 20 MOVE 3 TO TL-NTYPE
      WHEN TS-MAC=18 OR 19 MOVE 4 TO TL-NTYPE
      WHEN TS-MAC>=9 AND<=12 OR=15 OR 16 OR 22 OR 23 OR>=25 AND<=27 MOVE 5 TO TL-NTYPE
      WHEN TS-MAC>=29 AND<=31 MOVE 8 TO TL-NTYPE
      WHEN TS-MAC=54 MOVE 9 TO TL-NTYPE
      WHEN TS-MAC=99 MOVE 10 TO TL-NTYPE
      WHEN TS-MAC=24 MOVE 11 TO TL-NTYPE
      WHEN TS-MAC=36 OR 38 MOVE 12 TO TL-NTYPE
      WHEN TS-MAC=32 OR 33 OR 34 MOVE 13 TO TL-NTYPE
      WHEN TS-MAC=37 MOVE 14 TO TL-NTYPE
      WHEN TS-MAC=39 MOVE 15 TO TL-NTYPE
      WHEN TS-MAC=21 MOVE 16 TO TL-NTYPE
      WHEN OTHER MOVE 0 TO TL-NTYPE.
TL-SET-TYPE. PERFORM TL-FIND-TYPE MOVE TL-NTYPE TO TL-TYPE.
    EVALUATE TRUE
      WHEN TL-TYPE>=0 AND<=5 MOVE TL-BTOOLS TO TL-NUM
      WHEN TL-TYPE=8 MOVE TL-NTOOLS TO TL-NUM
      WHEN TL-TYPE=9 MOVE TL-STOOLS TO TL-NUM
      WHEN TL-TYPE=10 MOVE TL-PTOOLS TO TL-NUM
      WHEN TL-TYPE>=11 AND<=15 MOVE TL-XTOOLS TO TL-NUM
      WHEN TL-TYPE=16 MOVE TL-YTOOLS TO TL-NUM
      WHEN OTHER CONTINUE.
    PERFORM TL-SET-SCRN.
TL-SET-TBL. EVALUATE TRUE
      WHEN TL-TYPE>=0 AND<=5 MOVE TL-BTBL(TL-IXF) TO TL-DATA
        IF TL-TYPE>0 MOVE TL-TINF(TL-TYPE) TO TL-INF END-IF
      WHEN TL-TYPE=8 MOVE TL-NTBL(TL-IXF) TO TL-DATA
      WHEN TL-TYPE=9 MOVE TL-STBL(TL-IXF) TO TL-DATA
      WHEN TL-TYPE=10 MOVE TL-PTBL(TL-IXF) TO TL-DATA
      WHEN TL-TYPE>=11 AND<=15 MOVE TL-XTBL(TL-IXF) TO TL-DATA
        IF TL-TYPE>11 MOVE TL-TINF(TL-TYPE - 11) TO TL-INF END-IF
      WHEN TL-TYPE=16 MOVE TL-YTBL(TL-IXF) TO TL-DATA
      WHEN OTHER CONTINUE.
TL-SET-SCRN. EVALUATE TRUE
      WHEN TL-TYPE>=1 AND<=5 MOVE 2 TO TL-NS
      WHEN TL-TYPE>=11 AND<=13 OR=16 MOVE 3 TO TL-NS
      WHEN TL-TYPE=14 OR 15 MOVE 4 TO TL-NS
      WHEN OTHER MOVE 1 TO TL-NS.
TL-RD-SCRN. MOVE 4 TO TL-R1.
    EVALUATE TRUE
      WHEN TL-TYPE=0 PERFORM RD801X MOVE 3 TO TL-R1 TL-R2
      WHEN TL-TYPE=1 IF TL-SCRN=1 PERFORM RD801A1 MOVE 11 TO TL-R2
                             ELSE PERFORM RD801A2 MOVE 11 TO TL-R2 END-IF
      WHEN TL-TYPE=2 IF TL-SCRN=1 PERFORM RD801B1 MOVE 17 TO TL-R2
                             ELSE PERFORM RD801B2 MOVE 16 TO TL-R2 END-IF
      WHEN TL-TYPE=3 IF TL-SCRN=1 PERFORM RD801C1 MOVE 23 TO TL-R2
                             ELSE PERFORM RD801C2 MOVE 19 TO TL-R2 END-IF
      WHEN TL-TYPE=4 IF TL-SCRN=1 PERFORM RD801D1 MOVE 22 TO TL-R2
                             ELSE PERFORM RD801D2 MOVE 16 TO TL-R2 END-IF
      WHEN TL-TYPE=5 IF TL-SCRN=1 PERFORM RD801E1 MOVE 23 TO TL-R2
                             ELSE PERFORM RD801E2 MOVE 19 TO TL-R2 END-IF
      WHEN TL-TYPE=8 PERFORM RD802 MOVE 11 TO TL-R2
      WHEN TL-TYPE=9 PERFORM RD804 MOVE 4 TO TL-R2
      WHEN TL-TYPE=10 PERFORM RD805 MOVE 6 TO TL-R2
      WHEN TL-TYPE=11 IF TL-SCRN=1 PERFORM RD803A1 MOVE 3 TO TL-R1 MOVE 23 TO TL-R2
                 ELSE IF TL-SCRN=2 PERFORM RD803A2 MOVE 22 TO TL-R2
                              ELSE PERFORM RD803A3 MOVE 15 TO TL-R2 END-IF END-IF
      WHEN TL-TYPE=12 IF TL-SCRN=1 PERFORM RD803B1 MOVE 3 TO TL-R1 MOVE 23 TO TL-R2
                 ELSE IF TL-SCRN=2 PERFORM RD803B2 MOVE 22 TO TL-R2
                              ELSE PERFORM RD803B3 MOVE 16 TO TL-R2 END-IF END-IF
      WHEN TL-TYPE=13 IF TL-SCRN=1 PERFORM RD803C1 MOVE 3 TO TL-R1 MOVE 23 TO TL-R2
                 ELSE IF TL-SCRN=2 PERFORM RD803C2 MOVE 22 TO TL-R2
                              ELSE PERFORM RD803C3 MOVE 15 TO TL-R2 END-IF END-IF
      WHEN TL-TYPE=14 IF TL-SCRN=1 PERFORM RD803D1 MOVE 3 TO TL-R1 MOVE 23 TO TL-R2
                 ELSE IF TL-SCRN=2 PERFORM RD803D2 MOVE 19 TO TL-R2
                 ELSE IF TL-SCRN=3 PERFORM RD803D3 MOVE 15 TO TL-R2
                              ELSE PERFORM RD803D4 MOVE 17 TO TL-R2 END-IF END-IF END-IF
      WHEN TL-TYPE=15 IF TL-SCRN=1 PERFORM RD803E1 MOVE 3 TO TL-R1 MOVE 23 TO TL-R2
                 ELSE IF TL-SCRN=2 PERFORM RD803E2 MOVE 20 TO TL-R2
                 ELSE IF TL-SCRN=3 PERFORM RD803E3 MOVE 20 TO TL-R2
                              ELSE PERFORM RD803E4 MOVE 20 TO TL-R2 END-IF END-IF END-IF
      WHEN TL-TYPE=16 IF TL-SCRN=1 PERFORM RD806A1 MOVE 3 TO TL-R1 MOVE 23 TO TL-R2
                 ELSE IF TL-SCRN=2 PERFORM RD806A2 MOVE 20 TO TL-R2
                              ELSE PERFORM RD806A3 MOVE 14 TO TL-R2 END-IF END-IF
      WHEN OTHER CONTINUE.
TL-REP-SCRN. INSPECT TD-SCREEN(1:3036) REPLACING ALL "^" BY " " "!" BY " " "]" BY " ".

* note 92
TL-DISP-TOOLS. PERFORM TL-DT1 THRU TL-DT9.
TL-DT1. DISPLAY "ENTER PAGE NUMBER (1 - 4) TO SHOW THE TOOL NUMBERS IN THAT PAGE, OR 'RETURN' TO END: _" LINE 24 BOLD.
    ACCEPT XN1 LINE 24 COLUMN 81 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF XN1=0 GO TL-DT9. IF NOT(XN1>=1 AND<=4) GO TL-DT1.
    MOVE 8 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    MOVE 1 TO IXU TL-IXF.
TL-DT5. PERFORM TL-SET-TBL IF TL-PAGE NOT=XN1 GO TL-DT8.
    MOVE 20 TO WN1 IF IXU=109 MOVE 19 TO WN1.
    IF IXU<=109 DISPLAY TL-IXF LINE IXT COLUMN IXU CONVERSION
      ":" COLUMN IXU PLUS 3 TL-DESC(1:WN1) COLUMN IXU PLUS 5
      ADD 1 TO IXT IF IXT>23 MOVE 8 TO IXT ADD 27 TO IXU.
TL-DT8. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TL-DT5. GO TL-DT1.
TL-DT9. EXIT.
TL-SET-ASM. PERFORM TL-SA1 THRU TL-SA9.
TL-SA1. MOVE 1 TO A-S1.
* note 3
    IF ITOOL GO TL-SA12.
    INITIALIZE TP-KEY MOVE A-A1 TO TP-TOOL.
    START TOOLPROD KEY>TP-KEY REGARDLESS INVALID GO TL-SA9.
    READ TOOLPROD NEXT REGARDLESS END GO TL-SA9. IF TP-TOOL NOT=A-A1 GO TL-SA9.
    MOVE TP-PROD TO TS-PROD MOVE TP-MAC TO TS-MAC.
    READ TOOLS REGARDLESS INVALID GO TL-SA9. GO TL-SA2.
TL-SA12. INITIALIZE IFTP-KEY MOVE A-A1 TO IFTP-TOOL.
    START IFTOOLPROD KEY>IFTP-KEY REGARDLESS INVALID GO TL-SA9.
    READ IFTOOLPROD NEXT REGARDLESS END GO TL-SA9. IF IFTP-TOOL NOT=A-A1 GO TL-SA9.
    MOVE IFTP-PROD TO IFTS-PROD MOVE IFTP-MAC TO IFTS-MAC.
    READ IFTOOLS INTO TS-RECORD REGARDLESS INVALID GO TL-SA9.
TL-SA2. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
TL-SA3. PERFORM TL-SET-TBL IF TL-FLD=TP-FLD
      IF TL-PAGE>0 AND TL-STN>0 AND (TL-CAT=1 OR 2) GO TL-SA4 ELSE GO TL-SA9.
    ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TL-SA3. GO TL-SA9.
TL-SA4. IF TL-CAT=1 MOVE 6 TO TL-ACAT. IF TL-CAT=2 MOVE 7 TO TL-ACAT.
    MOVE TL-STN TO TL-ASTN MOVE 0 TO A-S1.
TL-SA9. EXIT.
* note 109
TL-TP-UPDATE. PERFORM TL-TP1 THRU TL-TP9.
TL-TP1. MOVE LOW-VALUES TO TP-RECORD MOVE 1 TO TL-IXA.
TL-TP3. IF A-N1=1 AND TS-TOOL(TL-IXA) NOT=TL-LTOOL(TL-IXA)
      IF TL-LTOOL(TL-IXA)>" " MOVE TL-LTOOL(TL-IXA) TO TP-TOOL
        MOVE TL-LPROD TO TP-PROD MOVE TL-LMAC TO TP-MAC MOVE TL-IXA TO TP-FLD
        DELETE TOOLPROD INVALID CONTINUE END-DELETE END-IF
      IF TS-TOOL(TL-IXA)>" " AND NOT="N/R" MOVE TS-TOOL(TL-IXA) TO TP-TOOL
        MOVE TS-PROD TO TP-PROD MOVE TS-MAC TO TP-MAC MOVE TL-IXA TO TP-FLD
        WRITE TP-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK TOOLPROD.
    IF A-N1=0 AND TS-TOOL(TL-IXA)>" " MOVE TS-TOOL(TL-IXA) TO TP-TOOL
      MOVE TS-PROD TO TP-PROD MOVE TS-MAC TO TP-MAC MOVE TL-IXA TO TP-FLD
      DELETE TOOLPROD INVALID CONTINUE.
    ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO TL-TP3.
    CLOSE TOOLPROD OPEN I-O TOOLPROD ALLOWING ALL.
TL-TP9. EXIT.

* note 7
SET-LA. IF LA-SRC=0 OR 1 EVALUATE TRUE
      WHEN P-CAT=2 OR 4 MOVE P-CAT TO LA-TYPE
      WHEN LA-CUS="07030" OR "12583" MOVE 2 TO LA-TYPE
      WHEN LA-CUS="06534" MOVE 3 TO LA-TYPE
      WHEN LA-CUS="12310" OR "12311" MOVE 5 TO LA-TYPE
      WHEN LA-CUS="11573" MOVE 6 TO LA-TYPE
      WHEN LA-CUS="06517" OR "06518" MOVE 8 TO LA-TYPE
      WHEN LA-CUS="06515" OR "06516" MOVE 10 TO LA-TYPE
      WHEN LA-CUS="07283" OR "12891" OR "12893" MOVE 13 TO LA-TYPE
      WHEN LA-CUS="06469" OR "06470" MOVE 14 TO LA-TYPE
      WHEN LA-CUS="11317" MOVE 15 TO LA-TYPE
      WHEN LA-CUS="10150" MOVE 16 TO LA-TYPE
      WHEN LA-CUS="06234" MOVE 17 TO LA-TYPE
      WHEN LA-CUS="13006" MOVE 18 TO LA-TYPE
      WHEN LA-CUS="07025" OR "07026" MOVE 19 TO LA-TYPE
      WHEN OTHER MOVE 1 TO LA-TYPE.
    IF LA-SRC=2 EVALUATE TRUE
      WHEN C-LABEL=2 MOVE 3 TO LA-TYPE
      WHEN C-LABEL=3 MOVE 9 TO LA-TYPE
      WHEN C-LABEL=4 MOVE 10 TO LA-TYPE
      WHEN C-LABEL=5 MOVE 11 TO LA-TYPE
      WHEN C-LABEL=6 MOVE 12 TO LA-TYPE
      WHEN C-LABEL=7 MOVE 13 TO LA-TYPE
      WHEN C-LABEL=8 MOVE 14 TO LA-TYPE
      WHEN C-LABEL=9 MOVE 17 TO LA-TYPE
      WHEN C-LABEL=10 MOVE 18 TO LA-TYPE
      WHEN C-LABEL=11 MOVE 19 TO LA-TYPE
      WHEN OTHER CONTINUE.

* note 234.1
    PERFORM RD-INFO ADD 1 TO IF-LABNO MOVE IF-LABNO TO LA-NO.
    IF LA-QTY>0 AND LA-SRC=0 OR 1 COMPUTE IF-LABNO=IF-LABNO - 1 + LA-QTY.
    PERFORM BAR-CHK-SERIAL PERFORM WR-INFO.

    MOVE USN-USER TO LA-USER.
    MOVE LA-LOT TO D-LOT PERFORM D-LOTDATE COMPUTE LA-ZLYEAR=9999 - D-YEAR.
    COMPUTE LA-ZLOT=9999999 - LA-LOT COMPUTE LA-ZDATE=999999 - SYS-DATE.
    ACCEPT SYS-TIME FROM TIME COMPUTE LA-ZTIME=99999999 - SYS-TIME.
SET-LA-KL. MOVE A-N1 TO D-LOT PERFORM D-LOTDATE COMPUTE LA-ZLYEAR=9999 - D-YEAR.
    COMPUTE LA-ZLOT=9999999 - A-N1 MOVE 0 TO LA-ZDATE LA-ZTIME.

* note 234.2
BAR-SET-SERIAL. PERFORM RD-INFO COMPUTE BAR-SERIAL=IF-LABNO + 1.
    ADD A-N1 TO IF-LABNO PERFORM BAR-CHK-SERIAL PERFORM WR-INFO.
BAR-CHK-SERIAL. IF IF-LABNO>9990000 MOVE 1001000 TO IF-LABNO.
BAR-SET-DATE. PERFORM D-NM.
    MOVE D-MM TO BAR-MM MOVE D-DD TO BAR-DD MOVE D-YY TO BAR-YY MOVE D-YEAR TO BAR-YEAR.
    STRING BAR-MM "-" BAR-DD "-" BAR-YY DELIMITED SIZE INTO BAR-NDATE.
    STRING BAR-MM "/" BAR-DD "/" BAR-YY DELIMITED SIZE INTO BAR-LDATE.
    STRING BAR-MM "/" BAR-DD "/" BAR-YEAR DELIMITED SIZE INTO BAR-CDATE.
    STRING BAR-DD " " D-MTHNM(BAR-MM)(1:3) " " BAR-YEAR DELIMITED SIZE INTO BAR-ADATE.
    STRING BAR-DD D-MTHNM(BAR-MM)(1:3) BAR-YEAR DELIMITED SIZE INTO BAR-SDATE.
* note 142
BAR-GET-LDATE. PERFORM BAR-GD1 THRU BAR-GD9.
BAR-GD1. MOVE D-DATE TO A-N1 IF BAR-LOT=0 GO BAR-GD8.
    INITIALIZE LT-REC MOVE BAR-LOT TO LT-NO READ LOT REGARDLESS INVALID GO BAR-GD8.
    MOVE LT-NO TO D-LOT IF LT-BMLOT NOT=0 MOVE LT-BMLOT TO D-LOT.
    PERFORM D-LOTDATE IF D-ERR=0 GO BAR-GD9.
BAR-GD8. MOVE A-N1 TO D-DATE.
BAR-GD9. EXIT.
BAR-SHP-NAME. PERFORM BAR-SH1 THRU BAR-SH9.
BAR-SH1. MOVE " " TO BAR-NAMAD.
    IF O-SHIPTO=0 GO BAR-SH4. MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO BAR-SH4. PERFORM GET-O-CUSADD.
BAR-SH4. MOVE O-NAME TO BAR-NAME.
    MOVE O-ADD1 TO BAR-ADD1 MOVE O-ADD2 TO BAR-ADD2 MOVE O-POST TO BAR-POST.
BAR-SH9. EXIT.
BAR-TXT-INSPECT. PERFORM BAR-TI1 THRU BAR-TI9.
BAR-TI1. MOVE " " TO BAR-INSPTXT PERFORM GET-OP IF A-S1=1 GO BAR-TI9.
    PERFORM VARYING BAR-IX1 FROM 1 BY 1 UNTIL BAR-IX1>12
      IF OP-OPER(BAR-IX1)=627 MOVE "THIS PRODUCT HAS BEEN 100% INSPECTED" TO BAR-INSPTXT
        GO BAR-TI9 END-IF END-PERFORM.
BAR-TI9. EXIT.
BAR-QSS-PROD. IF BAR-PROD(1:4)="QSS-" MOVE BAR-PROD(5:) TO BAR-PROD.
    PERFORM BAR-LTH-PROD.
    IF BAR-PX>6 AND<12 MOVE BAR-PROD(7:) TO BAR-PROD(8:) MOVE "-" TO BAR-PROD(7:1)
      ADD 1 TO BAR-PX.

BAR-LTH-PROD. MOVE BAR-PROD TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-PX.
BAR-LTH-QTY. MOVE BAR-QTY TO A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-QX.
BAR-LTH-WEIGHT. MOVE BAR-WEIGHT TO A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-WX.
BAR-LTH-SERIAL. MOVE BAR-SERIAL TO A-U1 MOVE 8 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-SX.
BAR-LTH-CUSORD. MOVE BAR-CUSORD TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-CX.
BAR-LTH-CUSPART. MOVE BAR-CUSPART TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-FX.
BAR-LTH-CARTONS. MOVE BAR-CARTONS TO A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-RX.
BAR-LTH-SUPPLIER. MOVE BAR-SUPPLIER TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-EX.
BAR-LTH-KANBAN. MOVE BAR-KANBAN TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-AX.
BAR-LTH-PLQTY. MOVE BAR-PLQTY TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-TX.
BAR-LTH-PKQTY. MOVE BAR-PKQTY TO A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-KX.
BAR-LTH-PKSLIP. MOVE BAR-PKSLIP TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-GX.
BAR-LTH-ENG. MOVE PRO-ENG TO BAR-ENG A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-NX.
BAR-LTH-PKG11. MOVE ED-PKG11 TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-P11X.
BAR-LTH-PKG12. MOVE ED-PKG12 TO A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-P12X.
BAR-LTH-LOT. MOVE 1 TO BAR-LX.

* note 245
BAR-SET-SUPPLIER. EVALUATE TRUE
      WHEN BAR-CUS="06234" MOVE "142876" TO BAR-SUPPLIER
      WHEN BAR-CUS="06449" OR>="06469" AND<="06476" OR="06502" MOVE "6843" TO BAR-SUPPLIER
      WHEN BAR-CUS="06515" OR "06516" MOVE "2732" TO BAR-SUPPLIER
      WHEN BAR-CUS="06517" OR "06518" MOVE "IRV000" TO BAR-SUPPLIER
      WHEN BAR-CUS="06534" MOVE "130648" TO BAR-SUPPLIER
      WHEN BAR-CUS="07030" MOVE "63862" TO BAR-SUPPLIER
      WHEN BAR-CUS="07283" MOVE "28431" TO BAR-SUPPLIER
      WHEN BAR-CUS="10150" MOVE "381082" TO BAR-SUPPLIER
      WHEN BAR-CUS="11317" MOVE "20312" TO BAR-SUPPLIER
      WHEN BAR-CUS="11573" MOVE "S-145" TO BAR-SUPPLIER
      WHEN BAR-CUS="12310" OR "12311" MOVE "1634" TO BAR-SUPPLIER
      WHEN BAR-CUS="12583" MOVE "42865" TO BAR-SUPPLIER
      WHEN BAR-CUS="12891" OR "12893" MOVE "273412" TO BAR-SUPPLIER
      WHEN BAR-CUS="13006" MOVE "04143" TO BAR-SUPPLIER
      WHEN OTHER MOVE "42853S1" TO BAR-SUPPLIER.
    PERFORM BAR-LTH-SUPPLIER.
BAR-SET-CUSORD. MOVE A-A1 TO A-A3 MOVE " " TO A-A1.
    IF A-A3="10150"
      IF A-A2="P2950850" MOVE "IRV02141" TO A-A1 END-IF
      IF A-A2="P4821250" MOVE "IRV02142" TO A-A1 END-IF.

* note 127.1
BAR-LAB. PERFORM BAR-LAB1 THRU BAR-LAB9.
BAR-LAB1. MOVE 0 TO BAR-ERR IF LA-QTY=0 GO BAR-LAB9.
    INITIALIZE P-REC MOVE LA-PROD TO BAR-PROD P-NO.
    READ PRODUCT REGARDLESS INVALID MOVE 1 TO BAR-ERR GO BAR-LAB9.
    MOVE P-CUSPART TO BAR-CUSPART PERFORM BAR-LTH-CUSPART.
    MOVE " " TO BAR-DESC MOVE 0 TO BAR-UDX MOVE P-DESC(1:16) TO BAR-DESC-A.
    MOVE P-EDESC1 TO BAR-DESC-EXT MOVE P-FINDESC TO BAR-DESC-FIN.

    MOVE P-NO TO PRO-NO PERFORM SET-PRO-LTH PERFORM CHK-STANDARD.
    IF PRO-KS=1 AND PRO-LTH=6 GO BAR-LAB2. MOVE P-DESC(17:) TO BAR-DESC-B.
* note 65.1
    IF P-NO(1:3)="063" AND P-CAT=33
      MOVE 0 TO BAR-IX1 INSPECT BAR-DESC-B TALLYING BAR-IX1 FOR CHARACTERS BEFORE "2HM"
      IF BAR-IX1<=13 COMPUTE BAR-UDX=BAR-IX1 + 3.
    GO BAR-LAB4.
BAR-LAB2. IF PRO-PR(1) NUMERIC AND PRO-PR(1) NOT=0
      MOVE 8 TO T-TBL MOVE PRO-PR(1) TO T-NO PERFORM RD-TBL
      IF T-LINE NOT=ALL "0" MOVE T-LINE TO BAR-DESC-B END-IF
      IF LA-TYPE=1 MOVE 23 TO T-TBL MOVE PRO-PR(1) TO T-NO PERFORM RD-TBL
        IF T-LINE NOT=ALL "0" MOVE T-LINE TO BAR-DESC-FR.
BAR-LAB4. PERFORM BAR-LTH-PROD.
    MOVE 1 TO BAR-QSER.
    IF P-PACKING=3 OR 4 OR 14 OR 58 MOVE 5 TO BAR-QSER.
    IF P-PACKING=19 MOVE 6 TO BAR-QSER.
    COMPUTE BAR-LABQTY=LA-QTY * BAR-QSER.

* note 179.1
    IF LA-TYPE=11 MOVE 2 TO BAR-LABQTY BAR-QSER.
    IF LA-TYPE=12 MOVE 1 TO BAR-LABQTY BAR-QSER.
    IF LA-TYPE=19 MULTIPLY 2 BY BAR-LABQTY BAR-QSER.

    PERFORM DESC-ENG PERFORM RD-GEN PERFORM BAR-LTH-ENG.

    MOVE LA-LOT TO A-N1 PERFORM RD-LOT.
    MOVE P-QTY-PACK TO BAR-QTY IF LA-QPACK NOT=0 MOVE LA-QPACK TO BAR-QTY.
    PERFORM BAR-LTH-QTY.

    PERFORM CALC-TWEIGHT COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * A-D1 / 100.
    PERFORM BAR-LTH-WEIGHT.

    MOVE LA-NO TO BAR-SERIAL PERFORM BAR-LTH-SERIAL.
    MOVE LA-LOT TO BAR-LOT PERFORM BAR-LTH-LOT.
    MOVE LA-DATE TO BAR-DATE D-DATE PERFORM BAR-GET-LDATE PERFORM BAR-SET-DATE.

    PERFORM BAR-TXT-INSPECT MOVE P-HCODE TO A-N1 PERFORM DESC-HARM.
    IF LA-TYPE=2 MOVE 1 TO A-N1 PERFORM DESC-QUAL.
    IF LA-TYPE=4 MOVE 2 TO A-N1 PERFORM DESC-QUAL.

    MOVE 0 TO BAR-KHT.
    IF (LA-TYPE=1 AND P-CAT=21 OR 22) OR (LA-TYPE=4 AND BAR-PROD="5667628")
      MOVE 1 TO BAR-KHT MOVE LT-HEAT TO BAR-HEAT.

    MOVE 0 TO BAR-UPC IF P-UPC>0 MOVE P-UPC TO BAR-UPC.
    MOVE 0 TO BAR-UPC IF P-UPC>0 PERFORM CHK-STANDARD IF PRO-KS=1 MOVE P-UPC TO BAR-UPC.

    MOVE " " TO BAR-COUNTRY.
    IF LT-COUNTRY>0 MOVE 14 TO T-TBL MOVE LT-COUNTRY TO T-NO PERFORM RD-TBL
      MOVE T-CTN TO BAR-COUNTRY
     ELSE IF LA-PROD="PI1076" MOVE "CANADA" TO BAR-COUNTRY.

    MOVE " " TO BAR-NAMAD MOVE LA-CUSORD TO BAR-CUSORD.
    IF LA-ORD>0 MOVE LA-ORD TO A-N1 PERFORM RD-SAORD PERFORM BAR-SHP-NAME
      IF LA-CUSORD=" " MOVE O-CUSORD TO BAR-CUSORD.
    PERFORM BAR-LTH-CUSORD.

    MOVE LA-LABINF TO ED-LABINF MOVE " " TO BAR-KANBAN.
    IF LA-TYPE=11 OR 12 MOVE LA-KANBAN TO BAR-KANBAN.

    MOVE LA-CUS TO BAR-CUS PERFORM BAR-SET-SUPPLIER.

* note 283
    IF BAR-QSER<4 PERFORM BAR-LAB-P
      ELSE MOVE BAR-QSER TO BAR-LABQTY
       PERFORM VARYING BAR-IXP FROM 1 BY 1 UNTIL BAR-IXP>LA-QTY
         PERFORM BAR-LAB-P IF BAR-IXP<LA-QTY PERFORM BAR-LAB-BLANK END-IF
         ADD 1 TO BAR-SERIAL END-PERFORM.
BAR-LAB9. EXIT.
* note 144
BAR-LAB-P. EVALUATE TRUE
      WHEN LA-TYPE=1 PERFORM BAR-LAB-STOCK
      WHEN LA-TYPE=2 PERFORM BAR-LAB-CHRYSLER
      WHEN LA-TYPE=3 PERFORM BAR-LAB-FLEXALLOY
      WHEN LA-TYPE=4 PERFORM BAR-LAB-GM
      WHEN LA-TYPE=5 PERFORM BAR-LAB-QSS
      WHEN LA-TYPE=6 PERFORM BAR-LAB-CAMI
      WHEN LA-TYPE=7 CONTINUE
      WHEN LA-TYPE=8 PERFORM BAR-LAB-GUNITE
      WHEN LA-TYPE=9 CONTINUE
      WHEN LA-TYPE=10 PERFORM BAR-LAB-FASTENAL
      WHEN LA-TYPE=11 PERFORM BAR-LAB-SATURN
      WHEN LA-TYPE=12 PERFORM BAR-LAB-DELPHI
      WHEN LA-TYPE=13 PERFORM BAR-LAB-TRW
      WHEN LA-TYPE=14 PERFORM BAR-LAB-DANA
      WHEN LA-TYPE=15 PERFORM BAR-LAB-MODATEK
      WHEN LA-TYPE=16 PERFORM BAR-LAB-INMET
      WHEN LA-TYPE=17 PERFORM BAR-LAB-BENTELER
      WHEN LA-TYPE=18 PERFORM BAR-LAB-VENEST
      WHEN LA-TYPE=19 PERFORM BAR-LAB-MGM
      WHEN OTHER MOVE 1 TO BAR-ERR.

* note 101
BAR-LAB-SHIP. MOVE C-NO TO BAR-CUS PERFORM BAR-SET-SUPPLIER.
    PERFORM CALC-TWEIGHT.
    IF C-LABEL=1 COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * A-D1 * WEI-LB / 100
      ELSE COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * A-D1 / 100.
    EVALUATE TRUE
      WHEN C-LABEL=1 PERFORM BAR-LAB-GMSHIP
      WHEN C-LABEL=2 PERFORM BAR-LAB-FLEXALLOY
      WHEN C-LABEL=3 PERFORM BAR-LAB-AMAX
      WHEN C-LABEL=4 PERFORM BAR-LAB-FASTENAL
      WHEN C-LABEL=5 PERFORM BAR-LAB-SATURN
      WHEN C-LABEL=6 PERFORM BAR-LAB-DELPHI
      WHEN C-LABEL=7 PERFORM BAR-LAB-TRW
      WHEN C-LABEL=8 PERFORM BAR-LAB-DANA
      WHEN C-LABEL=9 PERFORM BAR-LAB-BENTELER
      WHEN C-LABEL=10 PERFORM BAR-LAB-VENEST
      WHEN C-LABEL=11 PERFORM BAR-LAB-MGM
      WHEN OTHER CONTINUE.

    REPLACE ==INTO-LAB== BY ==DELIMITED SIZE INTO LAB-RECORD POINTER LAB-PTR PERFORM LAB-LINE==.

* note 168
BAR-STRD. MOVE A-N1 TO A-N6 PERFORM STR-LTH MOVE A-N1 TO A-N5 MOVE A-N6 TO A-N1.
    MOVE A-N1 TO BAR-BX MOVE A-N2 TO BAR-BY STRING BAR-B INTO-LAB.
    MOVE 1 TO A-X1 PERFORM UNTIL A-X1>A-N5
      MOVE 0 TO A-X2 INSPECT A-A1(A-X1:A-N5 - A-X1 + 1) TALLYING A-X2 FOR CHARACTERS BEFORE "-"
      IF A-X2>0 MOVE A-N3 TO BAR-AH MOVE A-N4 TO BAR-AW
        STRING BAR-A A-A1(A-X1:A-X2) "^FS" INTO-LAB END-IF
      IF A-X1 + A-X2 - 1<A-N5 ADD 1 TO A-X2
        MOVE A-N3 TO BAR-AH COMPUTE BAR-AW=A-N4 / 2
        STRING BAR-A "-^FS" INTO-LAB END-IF
      ADD A-X2 TO A-X1 END-PERFORM.
BAR-LAB-SPACER. STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO675,0^GB0,1320,125^FS" INTO-LAB.
    STRING "^FO450,0^GB0,1320,125^FS" INTO-LAB.
    STRING "^FO225,0^GB0,1320,125^FS" INTO-LAB.
    STRING "^FO0,0^GB0,1320,125^FS" INTO-LAB.
    STRING "^PQ0001,0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.
BAR-LAB-BLANK. STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FT0,0^A0,1,1^FD.^FS" INTO-LAB.
    STRING "^PQ0001,0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.
* note 44

BAR-LAB-ORDER. STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO700,0^GB0,1320,100^FS" INTO-LAB.
    STRING "^FT400,150^A0,60,60^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT300,150^A0,30,30^FDORDER: ^FS" INTO-LAB.
    MOVE BAR-ORDSEQ TO A-U1 MOVE 8 TO A-N1 PERFORM COUNT-ZERO.
    STRING "^FT^A0,60,60^FD" BAR-ORDSEQ(A-N1:7 - A-N1) "-" BAR-ORDSEQ(7:2) "^FS" INTO-LAB.
    STRING "^FO0,0^GB0,1320,100^FS" INTO-LAB.
    STRING "^PQ0001,0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-STOCK. PERFORM BAR-LAB-S1 THRU BAR-LAB-S9.
BAR-LAB-S1.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO586,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO330,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO250,1120^GB0,200,4^FS" INTO-LAB.
    STRING "^FO120,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO120,500^GB210,0,4^FS" INTO-LAB.
    STRING "^FO120,1120^GB210,0,4^FS" INTO-LAB.

    IF BAR-UPC>0
      STRING "^FT786,895^AC^FDUPC^FS" INTO-LAB
      STRING "^FT766,895^AC^FD(U)^FS" INTO-LAB
      STRING "^FT696,895^A0,30,30^FD" BAR-UPC "^FS" INTO-LAB
      STRING "^FT596,895^BY3,3,90^B3,,,N,N^FDU" BAR-UPC "^FS" INTO-LAB
     ELSE IF P-CAT=21 OR 22 MOVE 760 TO BAR-NTX MOVE 25 TO BAR-NTD PERFORM BAR-LAB-SN.

    MOVE BAR-PROD TO BAR-PART MOVE BAR-PX TO BAR-HX.
    IF BAR-CUSPART>" " MOVE BAR-CUSPART TO BAR-PART MOVE BAR-FX TO BAR-HX
      MOVE "IF PART #:" TO BAR-DESC-EXT MOVE BAR-PROD TO BAR-DESC-EXT(12:).

    STRING "^FT786,20^AC^FDPART^FS" INTO-LAB.
    STRING "^FT766,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PART TO A-A1 MOVE 696 TO A-N1 MOVE 120 TO A-N2 MOVE 140 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT596,070^BY3,3,90^B3,,,N,N^FDP" BAR-PART(1:BAR-HX) "^FS" INTO-LAB.

* note 155
    MOVE " " TO BAR-LINE(1) BAR-LINE(2).
    IF BAR-DESC-FR>" " MOVE BAR-DESC-FR TO BAR-LINE(2)
      IF BAR-DESC-EXT>" " MOVE BAR-DESC-EXT TO BAR-LINE(1)
        ELSE MOVE BAR-DESC-FIN TO BAR-LINE(1)
     ELSE MOVE BAR-DESC-EXT TO BAR-LINE(1) MOVE BAR-DESC-FIN TO BAR-LINE(2).

    IF BAR-UPC>0 AND (P-CAT=21 OR 22)
      IF BAR-DESC-FR=" " AND BAR-DESC-EXT>" " MOVE BAR-DESC-EXT TO BAR-LINE(2) END-IF
      MOVE 560 TO BAR-NTX MOVE 20 TO BAR-NTD PERFORM BAR-LAB-SN
      PERFORM BAR-LAB-SD
      STRING "^FT435,040^A0,60,55^FD" BAR-DESC-B "^FS" INTO-LAB
      GO BAR-LAB-S4.
* note 65.2
    PERFORM BAR-LAB-SD.
    STRING "^FT^A0,75,60^FD " BAR-DESC-B "^FS" INTO-LAB.
    IF BAR-UDX>0
      PERFORM BAR-LAB-SD
      STRING "^FT^A0,75,60^FD " BAR-DESC-B(1:BAR-UDX) "^FS" INTO-LAB
      STRING "^FT485^GB0,46,6^FS" INTO-LAB.
    IF BAR-LINE(1)>" "
      STRING "^FT435,040^A0,60,55^FD" BAR-LINE(1) "^FS" INTO-LAB.
BAR-LAB-S4. IF BAR-COUNTRY>" "
      STRING "^FT340,040^A0,40,40^FDCONTENTS MADE IN ^FS^FT^A0,40,40^FD" BAR-COUNTRY "^FS" INTO-LAB
     ELSE IF BAR-INSPTXT=" "
      IF BAR-LINE(2)>" " STRING "^FT340,040^A0,60,55^FD" BAR-LINE(2) "^FS" INTO-LAB END-IF
     ELSE
      IF BAR-LINE(2)>" " STRING "^FT375,040^A0,60,55^FD" BAR-LINE(2) "^FS" INTO-LAB END-IF
      STRING "^FT340,040^A0,35,35^FD" BAR-INSPTXT "^FS" INTO-LAB.

    IF BAR-KHT=1
      STRING "^FT390,1070^AC^FDHEAT^FS" INTO-LAB
      STRING "^FT340,1070^A0,50,50^FD" BAR-HEAT "^FS" INTO-LAB
     ELSE IF PRO-ENG>" "
      STRING "^FT390,1070^AC^FDREV^FS" INTO-LAB
      STRING "^FT340,1070^A0,50,50^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.

    STRING "^FT310,20^AC^FDQTY^FS" INTO-LAB.
    STRING "^FT290,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT230,80^A0,130,130^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    IF BAR-QTY<=9999 STRING "^FT^A0,80,80^FD PCS^FS" INTO-LAB
      ELSE STRING "^FT^A0,80,50^FD PCS^FS" INTO-LAB.
    STRING "^FT130,070^BY3,3,90^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT310,520^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT290,520^AC^FD(L)^FS" INTO-LAB.
    STRING "^FT230,580^A0,130,130^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT130,570^BY3,3,90^B3,,,N,N^FDL" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT310,1140^AC^FDDATE MFG^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 260 TO A-N1 MOVE 1140 TO A-N2 MOVE 55 TO A-N3 MOVE 45 TO A-N4 PERFORM BAR-STRD.

    STRING "^FT230,1140^AC^FDWEIGHT^FS" INTO-LAB.
    STRING "^FT180,1140^A0,50,50^FDNET^FS" INTO-LAB.
    STRING "^FT130,1140^A0,55,45^FD" BAR-WEIGHT(BAR-WX:) "^FS" INTO-LAB.
    STRING "^FT^A0,55,45^FD lbs^FS" INTO-LAB.

    STRING "^FT045,125^A0,55,55^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD  " BAR-FROM-LOC3 "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.
BAR-LAB-S9. EXIT.
BAR-LAB-SD. MOVE BAR-DESC-A TO A-A1 MOVE 495 TO A-N1 MOVE 40 TO A-N2.
    MOVE 115 TO A-N3 MOVE 105 TO A-N4 PERFORM BAR-STRD.
BAR-LAB-SN. STRING "^FT" BAR-NTX ",840^A0,30,30^FDADVISORY^FS" INTO-LAB.
    SUBTRACT 5 FROM BAR-NTX.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>6 SUBTRACT BAR-NTD FROM BAR-NTX
      STRING "^FT" BAR-NTX ",840^AC^FD" BAR-MES1(A-X1) "^FS" INTO-LAB END-PERFORM.

BAR-LAB-MASTER. PERFORM BAR-LTH-PROD PERFORM BAR-LTH-PLQTY.
    PERFORM BAR-LTH-CARTONS PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO586,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO330,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO250,1120^GB0,200,4^FS" INTO-LAB.
    STRING "^FO120,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO586,950^GB214,0,4^FS" INTO-LAB.
    IF BAR-PLQTY<=99999 STRING "^FO120,500^GB210,0,4^FS" INTO-LAB.
    STRING "^FO120,1120^GB210,0,4^FS" INTO-LAB.

    STRING "^FT620,970^A0,140,100^FDMASTER^FS" INTO-LAB.

    STRING "^FT786,20^AC^FDPART^FS" INTO-LAB.
    STRING "^FT766,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 696 TO A-N1 MOVE 120 TO A-N2 MOVE 140 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT596,070^BY3,3,90^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    MOVE BAR-DESC-A TO A-A1 MOVE 495 TO A-N1 MOVE 40 TO A-N2 MOVE 115 TO A-N3 MOVE 105 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT^A0,75,60^FD " BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT440,040^A0,60,55^FD" BAR-DESC-EXT "^FS" INTO-LAB.
    STRING "^FT390,040^A0,60,55^FD" BAR-DESC-FIN "^FS" INTO-LAB.

    STRING "^FT310,20^AC^FDQTY^FS" INTO-LAB.
    STRING "^FT290,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT230,80^A0,130,130^FD" BAR-PLQTY(BAR-TX:) "^FS" INTO-LAB.
    IF BAR-PLQTY<=99999 STRING "^FT^A0,80,50^FD PCS^FS" INTO-LAB.
    STRING "^FT130,070^BY3,3,90^B3,,,N,N^FDQ" BAR-PLQTY(BAR-TX:) "^FS" INTO-LAB.

    STRING "^FT310,520^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT290,520^AC^FD(L)^FS" INTO-LAB.
    STRING "^FT230,580^A0,130,130^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT130,570^BY3,3,90^B3,,,N,N^FDL" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT310,1140^AC^FDDATE MFG^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 260 TO A-N1 MOVE 1140 TO A-N2 MOVE 55 TO A-N3 MOVE 45 TO A-N4 PERFORM BAR-STRD.

    STRING "^FT230,1140^AC^FDCARTONS^FS" INTO-LAB.
    STRING "^FT130,1140^A0,120,120^FD" BAR-CARTONS(BAR-RX:) "^FS" INTO-LAB.

    STRING "^FT045,125^A0,55,55^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD  " BAR-FROM-LOC3 "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-CHRYSLER.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO568,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO344,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO184,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO094,808^GB0,512,4^FS" INTO-LAB.

    STRING "^FO344,608^GB224,0,4^FS" INTO-LAB.
    STRING "^FO000,808^GB348,0,4^FS" INTO-LAB.

    STRING "^FT788,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT768,20^AC^FD  (P)   ^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 696 TO A-N1 MOVE 160 TO A-N2 MOVE 140 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT583,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT548,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT528,20^AC^FD  (Q)   ^FS" INTO-LAB.
    STRING "^FT460,160^A0,140,140^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT350,070^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT548,628^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT480,628^A0,55,55^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT430,628^A0,55,55^FD" BAR-DESC-B "^FS" INTO-LAB.
    STRING "^FT380,628^A0,40,40^FD" BAR-DESC-FIN "^FS" INTO-LAB.

    STRING "^FT324,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT304,20^AC^FD  (V)   ^FS" INTO-LAB.
    STRING "^FT300,160^A0,55,55^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT190,070^BY3,3,105^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT324,828^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT208,860^A0,85,85^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT164,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT144,20^AC^FD (S)  ^FS" INTO-LAB.
    STRING "^FT140,160^A0,55,55^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT030,070^BY3,3,105^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT164,828^AC^FDDATE MFG^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 110 TO A-N1 MOVE 860 TO A-N2 MOVE 55 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT074,828^AC^FDENGR CHANGE^FS" INTO-LAB.
    STRING "^FT020,860^A0,55,55^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.

    IF PRO-QUAL>" "
      STRING "^FT074,1080^AC^FDQUAL STD^FS" INTO-LAB
      STRING "^FT020,1020^A0,55,55^FD" PRO-QUAL "^FS" INTO-LAB.

    STRING "^FT010,070^AC^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 127.3
BAR-LAB-FLEXALLOY. MOVE 1 TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-CUSPART PERFORM BAR-LTH-CUSORD.
    PERFORM BAR-LTH-QTY PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO706,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO552,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO398,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO244,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO090,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO706,440^GB084,0,4^FS" INTO-LAB.
    STRING "^FO706,800^GB084,0,4^FS" INTO-LAB.
    STRING "^FO552,600^GB154,0,4^FS" INTO-LAB.
    STRING "^FO244,500^GB154,0,4^FS" INTO-LAB.
    STRING "^FO244,1000^GB154,0,4^FS" INTO-LAB.
    STRING "^FO090,400^GB154,0,4^FS" INTO-LAB.
    STRING "^FO090,700^GB154,0,4^FS" INTO-LAB.
    STRING "^FO010,1200^GB080,0,4^FS" INTO-LAB.

    STRING "^FT770,020^AC^FDFROM: " BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT745,020^AC^FD      " BAR-FROM-LOC2 "^FS" INTO-LAB.
    STRING "^FT720,020^AC^FD      CANADA^FS" INTO-LAB.

    STRING "^FT686,20^AC^FDPO#^FS" INTO-LAB.
    STRING "^FT666,20^AC^FD(K)^FS" INTO-LAB.
    STRING "^FT640,080^A0,80,70^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT558,050^BY2,3,80^B3,,,N,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT686,620^AC^FDPART#   ^FS" INTO-LAB.
    STRING "^FT666,620^AC^FDCUST (P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 640 TO A-N1 MOVE 740 TO A-N2 MOVE 80 TO A-N3 MOVE 70 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT558,650^BY2,3,80^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT532,20^AC^FDREF^FS" INTO-LAB.
    STRING "^FT512,20^AC^FD(Z)^FS" INTO-LAB.
    IF BAR-CUSPART>" "
      MOVE BAR-CUSPART TO A-A1 MOVE 486 TO A-N1 MOVE 80 TO A-N2 MOVE 80 TO A-N3 MOVE 70 TO A-N4 PERFORM BAR-STRD
      STRING "^FT404,050^BY2,3,80^B3,,,N,N^FDZ" BAR-CUSPART(1:BAR-FX) "^FS" INTO-LAB.

    STRING "^FT378,20^AC^FDQUANTITY U/M^FS" INTO-LAB.
    STRING "^FT358,20^AC^FD    (7Q)    ^FS" INTO-LAB.
    STRING "^FT332,190^A0,80,70^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT^A0,40,40^FD PCS^FS" INTO-LAB.
    STRING "^FT250,050^BY2,3,80^B3,,,N,N^FD7Q" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT378,520^AC^FDLOT#     ^FS" INTO-LAB.
    STRING "^FT358,520^AC^FDSPLR (1T)^FS" INTO-LAB.
    STRING "^FT332,660^A0,80,70^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT250,550^BY2,3,80^B3,,,N,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT378,1020^AC^FDEC# ^FS" INTO-LAB.
    STRING "^FT358,1020^AC^FD(2P)^FS" INTO-LAB.

    STRING "^FT224,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT204,20^AC^FD  (V)   ^FS" INTO-LAB.
    STRING "^FT178,140^A0,80,70^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT096,050^BY2,3,80^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT224,420^AC^FDCTRY OF ^FS" INTO-LAB.
    STRING "^FT204,420^AC^FDORG (4L)^FS" INTO-LAB.
    STRING "^FT178,540^A0,80,70^FDCA^FS" INTO-LAB.
    STRING "^FT096,450^BY2,3,80^B3,,,N,N^FD4LCA^FS" INTO-LAB.

    STRING "^FT224,720^AC^FDHARMONIZED^FS" INTO-LAB.
    STRING "^FT204,720^AC^FDCODE (HC) ^FS" INTO-LAB.
    STRING "^FT178,860^A0,80,70^FD" PRO-HARM "^FS" INTO-LAB.
    STRING "^FT096,750^BY2,3,80^B3,,,N,N^FDHC" PRO-HARM "^FS" INTO-LAB.

    STRING "^FT070,20^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT010,050^A0,55,55^FD" BAR-DESC-A BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT070,1220^AC^FDEXP. DATE^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-GM.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO568,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO344,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO184,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO094,728^GB0,592,4^FS" INTO-LAB.

    STRING "^FO344,608^GB224,0,4^FS" INTO-LAB.
    STRING "^FO000,728^GB348,0,4^FS" INTO-LAB.

    STRING "^FT788,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT768,20^AC^FD  (P)   ^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 696 TO A-N1 MOVE 160 TO A-N2 MOVE 140 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT583,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    IF PRO-QUAL>" "
      STRING "^FT736,1000^A0,85,85^FD" PRO-QUAL "^FS" INTO-LAB.

    STRING "^FT548,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT528,20^AC^FD  (Q)   ^FS" INTO-LAB.
    STRING "^FT460,160^A0,140,140^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT350,070^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT548,628^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT480,628^A0,55,55^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT430,628^A0,55,55^FD" BAR-DESC-B "^FS" INTO-LAB.
    STRING "^FT380,628^A0,40,40^FD" BAR-DESC-FIN "^FS" INTO-LAB.

    STRING "^FT324,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT304,20^AC^FD  (V)   ^FS" INTO-LAB.
    STRING "^FT300,160^A0,55,55^FD" ED-DUNS "^FS" INTO-LAB.
    STRING "^FT190,070^BY3,3,105^B3,,,N,N^FDV" ED-DUNS "^FS" INTO-LAB.

    STRING "^FT324,748^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT304,748^AC^FD(L)^FS" INTO-LAB.
    IF BAR-KHT=0
      STRING "^FT300,820^A0,55,55^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB
      STRING "^FT190,780^BY3,3,105^B3,,,N,N^FDL" BAR-LOT(BAR-LX:) "^FS" INTO-LAB
     ELSE
      STRING "^FO256,728^GB0,592,4^FS" INTO-LAB
      STRING "^FT266,800^A0,85,85^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB
      STRING "^FT236,748^AC^FDHEAT^FS" INTO-LAB
      STRING "^FT194,800^A0,50,50^FD" BAR-HEAT "^FS" INTO-LAB.

    STRING "^FT164,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT144,20^AC^FD (S)  ^FS" INTO-LAB.
    STRING "^FT140,160^A0,55,55^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT030,070^BY3,3,105^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT164,748^AC^FDDATE MFG^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 110 TO A-N1 MOVE 780 TO A-N2 MOVE 55 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT074,748^AC^FDENGR CHANGE^FS" INTO-LAB.
    STRING "^FT020,780^A0,55,55^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.

    STRING "^FT010,050^AC^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 127.2
BAR-LAB-GMSHIP. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY PERFORM BAR-LTH-WEIGHT.
    PERFORM BAR-LTH-PKG11 PERFORM BAR-LTH-PKG12 PERFORM BAR-LTH-LOT.
    PERFORM VARYING BAR-IXL FROM 1 BY 1 UNTIL BAR-IXL>BAR-LABQTY
      STRING "^XA^LH0,0^FWR^FS" INTO-LAB
      IF BAR-IXL=1 PERFORM BAR-LAB-GMSHIP-P END-IF PERFORM BAR-LAB-GMSHIP-M
      STRING "^PQ0001,0," BAR-QSER "^FS" INTO-LAB
      IF BAR-IXL=BAR-LABQTY STRING "^FWN^MCY^XZ" INTO-LAB
        ELSE STRING "^FWN^MCN^XZ" INTO-LAB END-IF
      ADD 1 TO BAR-SERIAL END-PERFORM.
BAR-LAB-GMSHIP-P.
    STRING "^FO598,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO494,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO394,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO190,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO598,330^GB202,0,4^FS" INTO-LAB.
    STRING "^FO598,930^GB202,0,4^FS" INTO-LAB.
    STRING "^FO494,270^GB104,0,4^FS" INTO-LAB.
    STRING "^FO494,768^GB104,0,4^FS" INTO-LAB.
    STRING "^FO190,990^GB204,0,4^FS" INTO-LAB.
    STRING "^FO000,832^GB190,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.
    STRING "^FT660,20^A0,30,30^FDMADE IN CANADA^FS" INTO-LAB.

    STRING "^FT780,350^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT745,350^A0,40,35^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT710,350^A0,40,35^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT675,350^A0,40,35^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT655,350^AC^FDPLANT^FS" INTO-LAB.
    STRING "^FT635,350^AC^FDDOCK^FS" INTO-LAB.
    MOVE ED-PKG12 TO A-A1 MOVE 606 TO A-N1 MOVE 410 TO A-N2 MOVE 85 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT578,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT502,40^A0,95,95^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT578,290^AC^FDMATERIAL HANDLING CODE^FS" INTO-LAB.
    MOVE ED-PKG11 TO A-A1 MOVE 502 TO A-N1 MOVE 290 TO A-N2 MOVE 95 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT578,788^AC^FDREFERENCE^FS" INTO-LAB.
    STRING "^FT502,788^A0,95,95^FD" PRO-QUAL "^FS" INTO-LAB.

    STRING "^FT474,20^AC^FDPART^FS" INTO-LAB.
    STRING "^FT454,20^AC^FDNUMBER^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 402 TO A-N1 MOVE 110 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT374,20^AC^FDLICENSE PLATE (1J)^FS" INTO-LAB.

    STRING "^FT374,1010^AC^FDSHIPMENT DATE^FS" INTO-LAB.
    STRING "^FT336,1010^A0,45,45^FD" BAR-ADATE "^FS" INTO-LAB.
    STRING "^FT308,1010^AC^FDCONTAINER TYPE^FS" INTO-LAB.
    STRING "^FT270,1010^A0,45,45^FDPCS71^FS" INTO-LAB.
    STRING "^FT242,1010^AC^FDGROSS WEIGHT^FS" INTO-LAB.
    STRING "^FT204,1010^A0,45,45^FD" BAR-WEIGHT(BAR-WX:) " KG^FS" INTO-LAB.

    STRING "^FT140,40^A0,40,40^FDENG CHG: " PRO-ENG "^FS" INTO-LAB.
    STRING "^FT040,40^A0,40,40^FDLOT NO.: ^FS" INTO-LAB.
    IF BAR-LOT>0 STRING "^FT^A0,85,85^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT155,852^A0,40,40^FD" ED-PKG13 "^FS" INTO-LAB.
    STRING "^FT120,852^A0,40,40^FD" ED-PKG14 "^FS" INTO-LAB.
    STRING "^FT085,852^A0,40,40^FD" ED-PKG15 "^FS" INTO-LAB.
    STRING "^FT050,852^A0,40,40^FD" ED-PKG16 "^FS" INTO-LAB.
    STRING "^FT015,852^A0,40,40^FD" ED-PKG17 "^FS" INTO-LAB.
BAR-LAB-GMSHIP-M.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE BAR-SERIAL TO BAR-LI3.
    STRING "^FT620,960^BY2,3^B7,8,5,0,22,N^FH^FV" "[)>_1E06" INTO-LAB.
    STRING "_1DP" BAR-PROD(1:BAR-PX) "_1DQ" BAR-QTY(BAR-QX:) "_1D1J" BAR-LICENSE
      "_1D20L" ED-PKG11(1:BAR-P11X) "_1D21L" ED-PKG12(1:BAR-P12X)
      "_1D7Q" BAR-WEIGHT(BAR-WX:) "GT" INTO-LAB.
    STRING "_1E_04" "^FS" INTO-LAB.
    STRING "^FT260,40^BY3,3,104^BC,,N^FV1J" BAR-LICENSE "^FS" INTO-LAB.
    STRING "^FT198,40^A0,70,70^FV" BAR-LI1 " " BAR-LI2 " " BAR-LI3 "^FS" INTO-LAB.

* note 127.6
BAR-LAB-GMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-PKQTY PERFORM BAR-LTH-CARTONS PERFORM BAR-LTH-WEIGHT.
    PERFORM BAR-LTH-PKG11 PERFORM BAR-LTH-PKG12.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE BAR-SERIAL TO BAR-LI3.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO598,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO496,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO394,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO190,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO598,330^GB202,0,4^FS" INTO-LAB.
    STRING "^FO598,990^GB202,0,4^FS" INTO-LAB.
    STRING "^FO494,380^GB104,0,4^FS" INTO-LAB.
    STRING "^FO494,880^GB104,0,4^FS" INTO-LAB.
    STRING "^FO190,910^GB204,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.

    STRING "^FT780,350^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT745,350^A0,40,35^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT710,350^A0,40,35^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT675,350^A0,40,35^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT655,350^AC^FDPLANT^FS" INTO-LAB.
    STRING "^FT635,350^AC^FDDOCK^FS" INTO-LAB.
    MOVE ED-PKG12 TO A-A1 MOVE 606 TO A-N1 MOVE 410 TO A-N2 MOVE 85 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT700,1010^A0,90,90^FDMASTER^FS" INTO-LAB.
    STRING "^FT610,1045^A0,90,90^FDLABEL^FS" INTO-LAB.

    STRING "^FT578,400^AC^FDMATERIAL HANDLING CODE^FS" INTO-LAB.
    MOVE ED-PKG11 TO A-A1 MOVE 504 TO A-N1 MOVE 400 TO A-N2 MOVE 95 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT474,20^AC^FDPART^FS" INTO-LAB.
    STRING "^FT454,20^AC^FDNUMBER^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 402 TO A-N1 MOVE 110 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT374,20^AC^FDLICENSE PLATE (6J)^FS" INTO-LAB.
    STRING "^FT260,40^BY3,3,104^BC,,N^FD6J" BAR-LICENSE "^FS" INTO-LAB.
    STRING "^FT198,40^A0,70,70^FD" BAR-LI1 " " BAR-LI2 " " BAR-LI3 "^FS" INTO-LAB.

    STRING "^FT374,930^AC^FDGROSS WEIGHT KG:^FS" INTO-LAB.
    STRING "^FT326,930^AC^FDTOTAL QTY:^FS" INTO-LAB.
    STRING "^FT278,930^AC^FDNUM PACKS:^FS" INTO-LAB.
    STRING "^FT230,930^AC^FDQTY/PACK:^FS" INTO-LAB.

    STRING "^FT354,1135^A0,45,45^FD" BAR-WEIGHT(BAR-WX:) "^FS" INTO-LAB.
    STRING "^FT306,1135^A0,45,45^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT258,1135^A0,45,45^FD" BAR-CARTONS(BAR-RX:) "^FS" INTO-LAB.
    STRING "^FT210,1135^A0,45,45^FD" BAR-PKQTY(BAR-KX:) "^FS" INTO-LAB.

    STRING "^FT170,20^AC^FDMASTER^FS" INTO-LAB.
    STRING "^FT150,20^AC^FDDATA^FS" INTO-LAB.

    STRING "^FT030,120^BY2,3^B7,8,5,0,18,N^FH^FD" "[)>_1E06" INTO-LAB.
    STRING "_1DP" BAR-PROD(1:BAR-PX) "_1DQ" BAR-PKQTY(BAR-KX:)
      "_1D7Q" BAR-QTY(BAR-QX:) "PL" "_1D7Q" BAR-CARTONS(BAR-RX:) "PK"
      "_1D7Q" BAR-WEIGHT(BAR-WX:) "GT" "_1D6J" BAR-LICENSE
      "_1D20L" ED-PKG11(1:BAR-P11X) "_1D21L" ED-PKG12(1:BAR-P12X) INTO-LAB.
    STRING "_1E_04" "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 127.7
BAR-LAB-GMIXED. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-WEIGHT.
    PERFORM BAR-LTH-PKG11 PERFORM BAR-LTH-PKG12.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE BAR-SERIAL TO BAR-LI3.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO598,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO496,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO394,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO190,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO598,330^GB202,0,4^FS" INTO-LAB.
    STRING "^FO598,990^GB202,0,4^FS" INTO-LAB.
    STRING "^FO496,330^GB102,0,4^FS" INTO-LAB.
    STRING "^FO496,660^GB102,0,4^FS" INTO-LAB.
    STRING "^FO496,990^GB102,0,4^FS" INTO-LAB.
    STRING "^FO394,330^GB102,0,4^FS" INTO-LAB.
    STRING "^FO394,660^GB102,0,4^FS" INTO-LAB.
    STRING "^FO394,990^GB102,0,4^FS" INTO-LAB.
    STRING "^FO190,910^GB204,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.
    STRING "^FT660,20^A0,30,30^FDMADE IN CANADA^FS" INTO-LAB.

    STRING "^FT780,350^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT745,350^A0,40,35^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT710,350^A0,40,35^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT675,350^A0,40,35^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT655,350^AC^FDPLANT^FS" INTO-LAB.
    STRING "^FT635,350^AC^FDDOCK^FS" INTO-LAB.
    MOVE ED-PKG12 TO A-A1 MOVE 606 TO A-N1 MOVE 410 TO A-N2 MOVE 85 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT700,1040^A0,90,90^FDMIXED^FS" INTO-LAB.
    STRING "^FT610,1060^A0,90,90^FDLOAD^FS" INTO-LAB.

    MOVE BAR-MX-LITX TO BAR-MX-TBLX MOVE BAR-MX-LITY TO BAR-MX-TBLY.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>BAR-MXL
      MOVE BAR-MXPN(A-X1) TO BAR-PROD A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-PX
      MOVE BAR-MXTQ(A-X1) TO BAR-QTY A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-QX
      MOVE BAR-MXNC(A-X1) TO BAR-CARTONS A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-RX
      MOVE BAR-MXPQ(A-X1) TO BAR-PKQTY A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-KX

      STRING "^FT" BAR-MXX(1) "," BAR-MXY(1) "^AC^FDPART NUMBER^FS" INTO-LAB
      STRING "^FT" BAR-MXX(2) "," BAR-MXY(2) "^A0,40,40^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB
      STRING "^FT" BAR-MXX(3) "," BAR-MXY(3) "^AC^FDTOTAL QTY^FS" INTO-LAB
      STRING "^FT" BAR-MXX(4) "," BAR-MXY(4) "^A0,40,40^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB
      STRING "^FT" BAR-MXX(5) "," BAR-MXY(5) "^AC^FDNUM PACKS^FS" INTO-LAB
      STRING "^FT" BAR-MXX(6) "," BAR-MXY(6) "^A0,40,40^FD" BAR-CARTONS(BAR-RX:) "^FS" INTO-LAB
      STRING "^FT" BAR-MXX(7) "," BAR-MXY(7) "^AC^FDQTY PER PACK^FS" INTO-LAB
      STRING "^FT" BAR-MXX(8) "," BAR-MXY(8) "^A0,40,40^FD" BAR-PKQTY(BAR-KX:) "^FS" INTO-LAB
      STRING "^FT" BAR-MXX(9) "," BAR-MXY(9) "^A0,40,40^FD@^FS" INTO-LAB

      IF A-X1=4 MOVE BAR-MX-LITY TO BAR-MX-TBLY
        PERFORM VARYING A-X2 FROM 1 BY 1 UNTIL A-X2>9 SUBTRACT 102 FROM BAR-MXX(A-X2) END-PERFORM
       ELSE PERFORM VARYING A-X2 FROM 1 BY 1 UNTIL A-X2>9 ADD 330 TO BAR-MXY(A-X2) END-PERFORM END-IF
      END-PERFORM.

    STRING "^FT374,20^AC^FDLICENSE PLATE (5J)^FS" INTO-LAB.
    STRING "^FT260,40^BY3,3,104^BC,,N^FD5J" BAR-LICENSE "^FS" INTO-LAB.
    STRING "^FT198,40^A0,70,70^FD" BAR-LI1 " " BAR-LI2 " " BAR-LI3 "^FS" INTO-LAB.

    STRING "^FT374,930^AC^FDGROSS WEIGHT:^FS" INTO-LAB.
    STRING "^FT210,930^A0,100,100^FD" BAR-WEIGHT(BAR-WX:) " KG^FS" INTO-LAB.

    STRING "^FT030,040^BY2,3^B7,8,5,0,18,N^FH^FD" "[)>_1E06" INTO-LAB.
    STRING "_1D5J" BAR-LICENSE "_1D7Q" BAR-WEIGHT(BAR-WX:) "GT"
      "_1D20L" ED-PKG11(1:BAR-P11X) "_1D21L" ED-PKG12(1:BAR-P12X) INTO-LAB.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>BAR-MXL
      MOVE BAR-MXPN(A-X1) TO BAR-PROD A-A1 PERFORM STR-LTH MOVE A-N1 TO BAR-PX
      MOVE BAR-MXTQ(A-X1) TO BAR-QTY A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-QX
      MOVE BAR-MXNC(A-X1) TO BAR-CARTONS A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-RX
      MOVE BAR-MXPQ(A-X1) TO BAR-PKQTY A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO BAR-KX
      STRING "_1E06_1DP" BAR-PROD(1:BAR-PX) "_1D7Q" BAR-QTY(BAR-QX:) "PL"
        "_1D7Q" BAR-CARTONS(BAR-RX:) "PK" "_1DQ" BAR-PKQTY(BAR-KX:) INTO-LAB
      END-PERFORM.
    STRING "_1E_04" "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 127.9
BAR-LAB-QSS. PERFORM BAR-QSS-PROD MOVE "WH2" TO BAR-A31.
    PERFORM VARYING BAR-IXL FROM 1 BY 1 UNTIL BAR-IXL>BAR-LABQTY
      STRING "^XA^LH0,0^FWR^FS" INTO-LAB
      IF BAR-IXL=1 PERFORM BAR-LAB-QSS-P END-IF PERFORM BAR-LAB-QSS-M
      STRING "^PQ0001,0," BAR-QSER "^FS" INTO-LAB
      IF BAR-IXL=BAR-LABQTY STRING "^FWN^MCY^XZ" INTO-LAB
        ELSE STRING "^FWN^MCN^XZ" INTO-LAB END-IF
      ADD 1 TO BAR-SERIAL END-PERFORM.
BAR-LAB-QSS-P.
    STRING "^FO610,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO380,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO190,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO270,710^GB0,0610,4^FS" INTO-LAB.
    STRING "^FO610,340^GB190,0,4^FS" INTO-LAB.
    STRING "^FO000,710^GB380,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.
    STRING "^FT630,20^A0,30,30^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT780,360^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT765,440^A0,35,35^FDQSS - BASELINE^FS" INTO-LAB.
    STRING "^FT730,440^A0,35,35^FD417 JUTRAS^FS" INTO-LAB.
    STRING "^FT695,440^A0,35,35^FDTECUMSEH, ON  N8N 2L9^FS" INTO-LAB.

    STRING "^FT650,360^AC^FDPLANT^FS" INTO-LAB.
    STRING "^FT630,360^AC^FDDOCK^FS" INTO-LAB.
    STRING "^FT620,440^A0,80,80^FD" BAR-A31 "^FS" INTO-LAB.

    STRING "^FT590,20^AC^FDPART#^FS" INTO-LAB.
    STRING "^FT570,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 500 TO A-N1 MOVE 80 TO A-N2 MOVE 80 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT390,80^BY3,3,100^BC,,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT360,20^AC^FDQTY^FS" INTO-LAB.
    STRING "^FT340,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT310,80^A0,80,80^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT200,80^BY3,3,100^BC,,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT360,730^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT320,750^A0,40,40^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT280,750^A0,40,40^FD" BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT250,730^AC^FDDATE (MM/DD/YY)^FS" INTO-LAB.
    STRING "^FT200,750^A0,40,40^FD" BAR-LDATE "^FS" INTO-LAB.

    STRING "^FT170,20^AC^FDLOT#^FS" INTO-LAB.
    STRING "^FT150,20^AC^FD(1T)^FS" INTO-LAB.
    STRING "^FT120,80^A0,80,80^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT010,80^BY3,3,100^BC,,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT170,730^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT150,730^AC^FD(S)^FS" INTO-LAB.
BAR-LAB-QSS-M.
    MOVE BAR-SUPPLIER TO BAR-VE1 MOVE BAR-SERIAL TO BAR-VE2.
    STRING "^FT410,880^BY2,3^B7,8,5,0,24,N^FH^FV" "[)>_1E06" INTO-LAB.
    STRING "_1DP" BAR-PROD(1:BAR-PX) "_1DQ" BAR-QTY(BAR-QX:) "_1D21L" BAR-A31
      "_1D2D" BAR-LDATE "_1DS" BAR-VENSER "_1D1T" BAR-LOT(BAR-LX:) INTO-LAB.
    STRING "_1E_04^FS" INTO-LAB.
    STRING "^FT120,810^A0,80,80^FV" BAR-VENSER "^FS" INTO-LAB.
    STRING "^FT010,810^BY3,3,100^BC,,N^FVS" BAR-VENSER "^FS" INTO-LAB.

BAR-LAB-QMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-QSS-PROD MOVE "WH2" TO BAR-A31.
    MOVE SYS-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-QTY PERFORM BAR-LTH-LOT.
    MOVE BAR-SUPPLIER TO BAR-VE1 MOVE BAR-SERIAL TO BAR-VE2.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO610,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO380,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO190,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO270,710^GB0,0610,4^FS" INTO-LAB.
    STRING "^FO610,340^GB190,0,4^FS" INTO-LAB.
    STRING "^FO000,710^GB380,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.
    STRING "^FT630,20^A0,30,30^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT780,360^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT765,440^A0,35,35^FDQSS - BASELINE^FS" INTO-LAB.
    STRING "^FT730,440^A0,35,35^FD417 JUTRAS^FS" INTO-LAB.
    STRING "^FT695,440^A0,35,35^FDTECUMSEH, ON  N8N 2L9^FS" INTO-LAB.

    STRING "^FT650,360^AC^FDPLANT^FS" INTO-LAB.
    STRING "^FT630,360^AC^FDDOCK^FS" INTO-LAB.
    STRING "^FT620,440^A0,80,80^FD" BAR-A31 "^FS" INTO-LAB.

    STRING "^FT700,930^A0,110,110^FDMASTER^FS" INTO-LAB.

    STRING "^FT590,20^AC^FDPART#^FS" INTO-LAB.
    STRING "^FT570,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 500 TO A-N1 MOVE 80 TO A-N2 MOVE 80 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT390,80^BY3,3,100^BC,,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT410,880^BY2,3^B7,8,5,0,24,N^FH^FD" "[)>_1E06" INTO-LAB.
    STRING "_1DP" BAR-PROD(1:BAR-PX) "_1DQ" BAR-QTY(BAR-QX:) "_1D21L" BAR-A31
      "_1D2D" BAR-LDATE "_1D4S" BAR-VENSER "_1D1T" BAR-LOT(BAR-LX:) INTO-LAB.
    STRING "_1E_04^FS" INTO-LAB.

    STRING "^FT360,20^AC^FDQTY^FS" INTO-LAB.
    STRING "^FT340,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT310,80^A0,80,80^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT200,80^BY3,3,100^BC,,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT360,730^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT320,750^A0,40,40^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT280,750^A0,40,40^FD" BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT250,730^AC^FDDATE (MM/DD/YY)^FS" INTO-LAB.
    STRING "^FT200,750^A0,40,40^FD" BAR-LDATE "^FS" INTO-LAB.

    STRING "^FT170,20^AC^FDLOT#^FS" INTO-LAB.
    STRING "^FT150,20^AC^FD(1T)^FS" INTO-LAB.
    STRING "^FT120,80^A0,80,80^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT010,80^BY3,3,100^BC,,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT170,730^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT150,730^AC^FD(4S)^FS" INTO-LAB.
    STRING "^FT120,810^A0,80,80^FD" BAR-VENSER "^FS" INTO-LAB.
    STRING "^FT010,810^BY3,3,100^BC,,N^FD4S" BAR-VENSER "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-CAMI.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO650,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO530,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO410,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO290,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO170,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO650,968^GB160,0,4^FS" INTO-LAB.
    STRING "^FO530,360^GB120,0,4^FS" INTO-LAB.
    STRING "^FO530,880^GB120,0,4^FS" INTO-LAB.
    STRING "^FO290,860^GB120,0,4^FS" INTO-LAB.
    STRING "^FO170,400^GB120,0,4^FS" INTO-LAB.
    STRING "^FO170,800^GB120,0,4^FS" INTO-LAB.

    STRING "^FT785,20^AC^FDCAMI PART NO.^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 670 TO A-N1 MOVE 50 TO A-N2 MOVE 140 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT670,1000^A0,140,140^FDCAMI^FS" INTO-LAB.

    STRING "^FT630,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT550,50^A0,80,80^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT^A0,60,60^FD PCS^FS" INTO-LAB.

    STRING "^FT630,380^AC^FDSUZUKI PART NO.^FS" INTO-LAB.
    MOVE BAR-CUSPART TO A-A1 MOVE 550 TO A-N1 MOVE 410 TO A-N2 MOVE 80 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT510,20^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT430,50^A0,90,90^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT^A0,70,70^FD " BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT390,20^AC^FDDUNS^FS" INTO-LAB.
    STRING "^FT310,50^A0,80,80^FD24^FS" INTO-LAB.
    STRING "^FT^A0,80,40^FD-^FS" INTO-LAB.
    STRING "^FT^A0,80,80^FD793^FS" INTO-LAB.
    STRING "^FT^A0,80,40^FD-^FS" INTO-LAB.
    STRING "^FT^A0,80,80^FD2874   NIFAST^FS" INTO-LAB.

    STRING "^FT390,880^AC^FDNIFAST VENDOR NO.^FS" INTO-LAB.
    MOVE BAR-SUPPLIER TO A-A1 MOVE 310 TO A-N1 MOVE 910 TO A-N2 MOVE 80 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT270,20^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT190,50^A0,80,80^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT270,420^AC^FDDATE MFG.^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 190 TO A-N1 MOVE 450 TO A-N2 MOVE 80 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT130,40^A0,30,30^FDMADE IN CANADA^FS" INTO-LAB.
    STRING "^FT045,125^A0,55,55^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD  " BAR-FROM-LOC3 "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-GUNITE.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO568,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO344,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO184,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO094,608^GB0,712,4^FS" INTO-LAB.

    STRING "^FO344,508^GB224,0,4^FS" INTO-LAB.
    STRING "^FO094,608^GB250,0,4^FS" INTO-LAB.
    STRING "^FO000,920^GB184,0,4^FS" INTO-LAB.

    STRING "^FT788,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT768,20^AC^FD  (P)   ^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 696 TO A-N1 MOVE 160 TO A-N2 MOVE 140 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT583,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT548,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT528,20^AC^FD  (Q)   ^FS" INTO-LAB.
    STRING "^FT460,160^A0,140,140^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT350,070^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT548,528^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT488,528^A0,55,55^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT436,528^A0,55,55^FD" BAR-DESC-B "^FS" INTO-LAB.
    STRING "^FT396,528^A0,40,40^FD" BAR-DESC-EXT "^FS" INTO-LAB.
    STRING "^FT356,528^A0,40,40^FD" BAR-DESC-FIN "^FS" INTO-LAB.

    STRING "^FT324,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT304,20^AC^FD  (V)   ^FS" INTO-LAB.
    STRING "^FT300,160^A0,55,55^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT190,070^BY3,3,105^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT324,628^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT304,628^AC^FD(T)^FS" INTO-LAB.
    STRING "^FT300,728^A0,55,55^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT190,678^BY3,3,105^B3,,,N,N^FDT" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT164,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT144,20^AC^FD (S)  ^FS" INTO-LAB.
    STRING "^FT140,160^A0,55,55^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT030,070^BY3,3,105^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT164,628^AC^FDDATE MFG^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 110 TO A-N1 MOVE 660 TO A-N2 MOVE 55 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT164,940^AC^FDWEIGHT^FS" INTO-LAB.
    STRING "^FT110,970^A0,55,45^FDNET ^FS" INTO-LAB.
    STRING "^FT^A0,55,55^FD" BAR-WEIGHT(BAR-WX:) "^FS" INTO-LAB.
    STRING "^FT^A0,55,45^FD lbs^FS" INTO-LAB.

    STRING "^FT074,940^AC^FDENGR CHANGE^FS" INTO-LAB.
    STRING "^FT020,980^A0,55,55^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.

    STRING "^FT010,070^AC^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 127.4
BAR-LAB-AMAX. MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY PERFORM BAR-LTH-CUSORD.
    PERFORM BAR-LTH-PKG11 PERFORM BAR-LTH-PKG12 PERFORM BAR-LTH-KANBAN.
    PERFORM BAR-LTH-LOT.
    PERFORM VARYING BAR-IXL FROM 1 BY 1 UNTIL BAR-IXL>BAR-LABQTY
    PERFORM VARYING BAR-IX1 FROM 1 BY 1 UNTIL BAR-IX1>2
      STRING "^XA^LH0,0^FWR^FS" INTO-LAB
      IF BAR-IXL=1 AND BAR-IX1=1 PERFORM BAR-LAB-AMAX-P END-IF
      PERFORM BAR-LAB-AMAX-M
      STRING "^PQ0001,0," BAR-QSER "^FS" INTO-LAB
      IF BAR-IXL=BAR-LABQTY AND BAR-IX1=2 STRING "^FWN^MCY^XZ" INTO-LAB
        ELSE STRING "^FWN^MCN^XZ" INTO-LAB END-IF
      END-PERFORM ADD 1 TO BAR-SERIAL END-PERFORM.
BAR-LAB-AMAX-P.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO440,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO340,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO140,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO600,330^GB202,0,4^FS" INTO-LAB.
    STRING "^FO340,1120^GB100,0,4^FS" INTO-LAB.
    STRING "^FO140,920^GB200,0,4^FS" INTO-LAB.
    STRING "^FO000,820^GB140,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.
    STRING "^FT660,20^A0,30,30^FDMADE IN CANADA^FS" INTO-LAB.

    STRING "^FT780,350^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT750,350^A0,30,30^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT720,350^A0,30,30^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT690,350^A0,30,30^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT635,350^AC^FDPLANT/DOCK:^FS" INTO-LAB.
    MOVE ED-PKG12 TO A-A1 MOVE 610 TO A-N1 MOVE 490 TO A-N2 MOVE 60 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT540,20^A0,35,35^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT510,20^A0,35,35^FD" BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT478,390^BY6,3,118^BC,,N^FD9K" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT448,390^AC^FDORDER ID (9K)^FS" INTO-LAB.
    STRING "^FT448,560^A0,35,35^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT420,20^AC^FDPART^FS" INTO-LAB.
    STRING "^FT400,20^AC^FDNUMBER^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 348 TO A-N1 MOVE 110 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT420,1140^A0,25,25^FDREV#^FS" INTO-LAB.
    STRING "^FT420,1200^A0,25,25^FD" PRO-ENG "^FS" INTO-LAB.
    STRING "^FT390,1140^A0,25,25^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT370,1140^A0,25,25^FDMATERIAL^FS" INTO-LAB.
    STRING "^FT348,1140^A0,25,25^FD    OK^FS" INTO-LAB.

    STRING "^FT320,20^AC^FDLICENSE PLATE (1J)^FS" INTO-LAB.

    STRING "^FT320,940^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT275,940^A0,50,50^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT250,940^AC^FDPULL SIGNAL^FS" INTO-LAB.
    STRING "^FT205,940^A0,50,50^FD" BAR-KANBAN(1:BAR-AX) "^FS" INTO-LAB.
    STRING "^FT175,940^AC^FDLOT #^FS" INTO-LAB.
    STRING "^FT150,940^A0,30,30^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    IF BAR-INSPTXT>" " STRING "^FT110,020^A0,30,30^FD" BAR-INSPTXT "^FS" INTO-LAB.

    STRING "^FT120,840^AC^FDGROUP/DEPT^FS" INTO-LAB.
    MOVE ED-PKG11 TO A-A1 MOVE 40 TO A-N1 MOVE 840 TO A-N2 MOVE 100 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT010,840^AC^FDDATE:^FS" INTO-LAB.
    STRING "^FT010,910^A0,24,24^FD" BAR-ADATE "^FS" INTO-LAB.
BAR-LAB-AMAX-M.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE BAR-SERIAL TO BAR-LI3.
    STRING "^FT620,880^BY2,3^B7,8,5,0,22,N^FH^FV" "[)>_1E06" INTO-LAB.
    STRING "_1DP" BAR-PROD(1:BAR-PX) "_1DQ" BAR-QTY(BAR-QX:) "_1D1J" BAR-LICENSE
      "_1D9K" BAR-CUSORD(1:BAR-CX) "_1D15K" BAR-KANBAN(1:BAR-AX)
      "_1D20L" ED-PKG12(1:BAR-P12X) "_1D21L" ED-PKG11(1:BAR-P11X)
      "_1D9D" BAR-SDATE INTO-LAB.
    STRING "_1E_04" "^FS" INTO-LAB.
    STRING "^FT210,60^BY3,3,100^BC,,N^FV1J" BAR-LICENSE "^FS" INTO-LAB.
    STRING "^FT150,60^A0,65,65^FV" BAR-LI1 " " BAR-LI2 " " BAR-LI3 "^FS" INTO-LAB.

* note 127.5
BAR-LAB-AMASTER. PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-CARTONS PERFORM BAR-LTH-CUSORD PERFORM BAR-LTH-KANBAN.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE BAR-SERIAL TO BAR-LI3.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO440,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO340,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO140,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO600,330^GB202,0,4^FS" INTO-LAB.
    STRING "^FO340,1120^GB100,0,4^FS" INTO-LAB.
    STRING "^FO140,920^GB200,0,4^FS" INTO-LAB.
    STRING "^FO000,820^GB140,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT750,20^A0,30,30^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT720,20^A0,30,30^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT690,20^A0,30,30^FDCDA^FS" INTO-LAB.
    STRING "^FT660,20^A0,30,30^FDMADE IN CANADA^FS" INTO-LAB.

    STRING "^FT780,350^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT750,350^A0,30,30^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT720,350^A0,30,30^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT690,350^A0,30,30^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT635,350^AC^FDPLANT/DOCK:^FS" INTO-LAB.
    MOVE ED-PKG12 TO A-A1 MOVE 610 TO A-N1 MOVE 490 TO A-N2 MOVE 60 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT620,880^BY2,3^B7,8,5,0,22,N^FH^FD" "[)>_1E06" INTO-LAB.
    STRING "_1DP" BAR-PROD(1:BAR-PX) "_1D2Q" BAR-QTY(BAR-QX:)
      "_1D7Q" BAR-CARTONS(BAR-RX:) "_1D6J" BAR-LICENSE
      "_1D9K" BAR-CUSORD(1:BAR-CX) INTO-LAB.
    STRING "_1E_04" "^FS" INTO-LAB.

    STRING "^FT540,20^A0,35,35^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT510,20^A0,35,35^FD" BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT478,390^BY6,3,118^BC,,N^FD9K" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT448,390^AC^FDORDER ID (9K)^FS" INTO-LAB.
    STRING "^FT448,560^A0,35,35^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT420,20^AC^FDPART^FS" INTO-LAB.
    STRING "^FT400,20^AC^FDNUMBER^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 348 TO A-N1 MOVE 110 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT420,1140^A0,25,25^FDREV#^FS" INTO-LAB.
    STRING "^FT420,1200^A0,25,25^FD" PRO-ENG "^FS" INTO-LAB.

    STRING "^FT320,20^AC^FDLICENSE PLATE (6J)^FS" INTO-LAB.
    STRING "^FT210,60^BY3,3,100^BC,,N^FD6J" BAR-LICENSE "^FS" INTO-LAB.
    STRING "^FT150,60^A0,65,65^FD" BAR-LI1 " " BAR-LI2 " " BAR-LI3 "^FS" INTO-LAB.

    STRING "^FT320,940^AC^FDTOTAL QUANTITY^FS" INTO-LAB.
    STRING "^FT275,940^A0,50,50^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT250,940^AC^FD# OF PACKS^FS" INTO-LAB.
    STRING "^FT205,940^A0,50,50^FD" BAR-CARTONS(BAR-RX:) "^FS" INTO-LAB.

    IF BAR-INSPTXT>" " STRING "^FT110,020^A0,30,30^FD" BAR-INSPTXT "^FS" INTO-LAB.

    STRING "^FT074,900^A0,85,85^FDMASTER^FS" INTO-LAB.
    STRING "^FT006,935^A0,85,85^FDLABEL^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 127.8
BAR-LAB-FASTENAL. MOVE 1 TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-CUSPART PERFORM BAR-LTH-CUSORD.
    PERFORM BAR-LTH-QTY PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO706,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO552,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO398,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO244,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO090,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO706,440^GB084,0,4^FS" INTO-LAB.
    STRING "^FO706,800^GB084,0,4^FS" INTO-LAB.
    STRING "^FO552,600^GB154,0,4^FS" INTO-LAB.
    STRING "^FO244,500^GB154,0,4^FS" INTO-LAB.
    STRING "^FO244,1000^GB154,0,4^FS" INTO-LAB.
    STRING "^FO090,400^GB154,0,4^FS" INTO-LAB.
    STRING "^FO090,700^GB154,0,4^FS" INTO-LAB.
    STRING "^FO010,1200^GB080,0,4^FS" INTO-LAB.

    STRING "^FT770,020^AC^FDFROM: " BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT745,020^AC^FD      " BAR-FROM-LOC2 "^FS" INTO-LAB.
    STRING "^FT720,020^AC^FD      CANADA^FS" INTO-LAB.

    STRING "^FT686,20^AC^FDP.O.#^FS" INTO-LAB.
    STRING "^FT640,105^A0,80,70^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT558,050^BY2,3,80^B3,,,N,N^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT686,620^AC^FDPART#^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 640 TO A-N1 MOVE 705 TO A-N2 MOVE 80 TO A-N3 MOVE 70 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT558,650^BY2,3,80^B3,,,N,N^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT532,20^AC^FDREF^FS" INTO-LAB.
    IF BAR-CUSPART>" "
      MOVE BAR-CUSPART TO A-A1 MOVE 486 TO A-N1 MOVE 80 TO A-N2 MOVE 80 TO A-N3 MOVE 70 TO A-N4 PERFORM BAR-STRD
      STRING "^FT404,050^BY2,3,80^B3,,,N,N^FD" BAR-CUSPART(1:BAR-FX) "^FS" INTO-LAB.

    STRING "^FT378,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT332,140^A0,80,70^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT^A0,40,40^FD PCS^FS" INTO-LAB.
    STRING "^FT250,050^BY2,3,80^B3,,,N,N^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT378,520^AC^FDLOT#^FS" INTO-LAB.
    STRING "^FT332,600^A0,80,70^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT250,550^BY2,3,80^B3,,,N,N^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT224,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT178,140^A0,80,70^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT096,050^BY2,3,80^B3,,,N,N^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT224,420^AC^FDCTRY OF^FS" INTO-LAB.
    STRING "^FT204,420^AC^FDORIGIN^FS" INTO-LAB.
    STRING "^FT178,530^A0,80,70^FDCA^FS" INTO-LAB.
    STRING "^FT096,450^BY2,3,80^B3,,,N,N^FDCA^FS" INTO-LAB.

    STRING "^FT224,720^AC^FDHARMONIZED^FS" INTO-LAB.
    STRING "^FT204,720^AC^FDCODE^FS" INTO-LAB.
    STRING "^FT178,860^A0,80,70^FD" PRO-HARM "^FS" INTO-LAB.
    STRING "^FT096,750^BY2,3,80^B3,,,N,N^FD" PRO-HARM "^FS" INTO-LAB.

    STRING "^FT070,20^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT010,050^A0,55,55^FD" BAR-DESC-A BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT070,1220^AC^FDEXP. DATE^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-SATURN. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-KANBAN PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO400,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO200,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO600,700^GB200,0,4^FS" INTO-LAB.
    STRING "^FO400,700^GB200,0,4^FS" INTO-LAB.
    STRING "^FO200,700^GB200,0,4^FS" INTO-LAB.
    STRING "^FO000,700^GB200,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT760,20^AC^FDCUST(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 704 TO A-N1 MOVE 140 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT610,070^BY3,3,90^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT780,720^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT760,720^AC^FD  (Q)   ^FS" INTO-LAB.
    STRING "^FT704,840^A0,120,120^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT610,770^BY3,3,90^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT580,20^AC^FDPULL^FS" INTO-LAB.
    STRING "^FT560,20^AC^FD(15K)^FS" INTO-LAB.
    STRING "^FT504,140^A0,120,120^SN" BAR-KANBAN(1:BAR-AX) ",,Y^FS" INTO-LAB.
    STRING "^FT410,070^BY3,3,90^B3,,,N,N^SN15K" BAR-KANBAN(1:BAR-AX) ",,Y^FS" INTO-LAB.

    STRING "^FT580,720^AC^FDDLOC^FS" INTO-LAB.
    MOVE ED-PKG11 TO A-A1 MOVE 504 TO A-N1 MOVE 800 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT380,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT360,20^AC^FD (3S)^FS" INTO-LAB.
    STRING "^FT304,140^A0,120,120^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT210,070^BY3,3,90^B3,,,N,N^SN3S" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT380,720^AC^FDPLANT^FS" INTO-LAB.
    STRING "^FT360,720^AC^FDDOCK^FS" INTO-LAB.
    MOVE ED-PKG12 TO A-A1 MOVE 304 TO A-N1 MOVE 800 TO A-N2 MOVE 120 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT270,740^A0,35,35^FD" ED-PKG13 "^FS" INTO-LAB.
    STRING "^FT240,740^A0,35,35^FD" ED-PKG14 "^FS" INTO-LAB.
    STRING "^FT210,740^A0,35,35^FD" ED-PKG15 "^FS" INTO-LAB.

    STRING "^FT160,40^A0,45,45^FDENG CHG: " PRO-ENG "^FS" INTO-LAB.
    STRING "^FT120,40^A0,45,45^FDMFG SHIP DATE: " BAR-ADATE "^FS" INTO-LAB.
    STRING "^FT080,40^A0,45,45^FDLOT NO.: " BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT170,740^A0,35,35^FD" ED-PKG16 "^FS" INTO-LAB.
    STRING "^FT140,740^A0,35,35^FD" ED-PKG17 "^FS" INTO-LAB.
    STRING "^FT100,740^A0,35,35^FDSUPPLIER (V): " ED-DUNS "^FS" INTO-LAB.
    STRING "^FT040,740^A0,55,55^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT010,740^A0,35,35^FD" BAR-FROM-LOC3 "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-SMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-PLQTY.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.

    STRING "^FT600,240^A0,60,60^FD" BAR-PLQTY(BAR-TX:) "^FS" INTO-LAB.
    STRING "^FT520,240^A0,70,70^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    STRING "^FT440,240^A0,60,60^FD" BAR-DESC-A "^FS" INTO-LAB.

    STRING "^FT360,240^A0,30,30^FDMADE IN CANADA^FS" INTO-LAB.
    STRING "^FT360,820^A0,30,30^FD" BAR-ADATE "^FS" INTO-LAB.
    STRING "^FT300,240^A0,40,40^FD" BAR-NAME "^FS" INTO-LAB.

    STRING "^FT150,240^A0,70,70^FDGENUINE SATURN PARTS^FS" INTO-LAB.
    STRING "^FO080,240^GB0,730,60^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-DELPHI. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-KANBAN PERFORM BAR-LTH-CUSORD PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO400,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO200,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO600,700^GB200,0,4^FS" INTO-LAB.
    STRING "^FO400,600^GB200,0,4^FS" INTO-LAB.
    STRING "^FO200,600^GB200,0,4^FS" INTO-LAB.
    STRING "^FO000,600^GB200,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDPART #^FS" INTO-LAB.
    STRING "^FT760,20^AC^FDCUST(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 704 TO A-N1 MOVE 120 TO A-N2 MOVE 120 TO A-N3 MOVE 100 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT610,070^BY2,3,90^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT680,720^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT660,720^AC^FD  (Q)   ^FS" INTO-LAB.
    STRING "^FT704,770^BY2,3,90^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT610,840^A0,120,100^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    IF BAR-AX>0
      STRING "^FT580,20^AC^FDKANBAN^FS" INTO-LAB
      STRING "^FT560,20^AC^FD(15K)^FS" INTO-LAB
      STRING "^FT504,100^A0,120,100^FD" BAR-KANBAN(1:BAR-AX) "^FS" INTO-LAB
      STRING "^FT410,070^BY2,3,90^B3,,,N,N^FD15K" BAR-KANBAN(1:BAR-AX) "^FS" INTO-LAB
     ELSE
      STRING "^FT580,20^AC^FDP.O.^FS" INTO-LAB
      STRING "^FT560,20^AC^FD(K)^FS" INTO-LAB
      STRING "^FT504,100^A0,120,100^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB
      STRING "^FT410,070^BY2,3,90^B3,,,N,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT580,620^AC^FDREV LVL^FS" INTO-LAB.
    STRING "^FT560,620^AC^FD (2P)^FS" INTO-LAB.
    STRING "^FT530,720^A0,60,50^FD" PRO-ENG "^FS" INTO-LAB.
    STRING "^FT504,830^BY2,3,90^B3,,,N,N^FD2P" PRO-ENG "^FS" INTO-LAB.
    STRING "^FT480,620^AC^FDDLOC^FS" INTO-LAB.
    MOVE ED-PKG11 TO A-A1 MOVE 410 TO A-N1 MOVE 700 TO A-N2 MOVE 120 TO A-N3 MOVE 100 TO A-N4 PERFORM BAR-STRD.

    STRING "^FT380,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT360,20^AC^FD (3S)^FS" INTO-LAB.
    STRING "^FT304,100^A0,120,100^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT210,070^BY2,3,90^B3,,,N,N^SN3S" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT385,620^AC^FDPLT/DOCK^FS" INTO-LAB.
    MOVE ED-PKG12(1:7) TO A-A1 MOVE 292 TO A-N1 MOVE 620 TO A-N2 MOVE 120 TO A-N3 MOVE 90 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT265,620^A0,30,25^FDSTORAGE BIN:^FS" INTO-LAB.
    STRING "^FT265,780^A0,35,30^FD" ED-PKG13 "^FS" INTO-LAB.
    STRING "^FT235,620^A0,30,25^FDPLANT NAME:^FS" INTO-LAB.
    STRING "^FT235,780^A0,35,30^FD" ED-PKG14 "^FS" INTO-LAB.
    STRING "^FT205,620^A0,30,25^FDPLANT CITY:^FS" INTO-LAB.
    STRING "^FT205,780^A0,35,30^FD" ED-PKG15 "^FS" INTO-LAB.

    STRING "^FT345,1020^BY2,3,50^BC,,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT328,1020^AC^FDLOT NO.^FS" INTO-LAB.
    STRING "^FT308,1020^AC^FD (1T)^FS" INTO-LAB.
    STRING "^FT308,1120^A0,45,40^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT110,620^AC^FDSUPPLIER (V)^FS" INTO-LAB.
    STRING "^FT130,670^BY2,3,60^B3,,,N,N^FDV" ED-DUNS "^FS" INTO-LAB.
    STRING "^FT080,800^A0,60,50^FD" ED-DUNS "^FS" INTO-LAB.

    STRING "^FT050,620^A0,35,30^FDDESC: " BAR-DESC-A BAR-DESC-B "^FS" INTO-LAB.
    STRING "^FT025,620^A0,20,20^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT005,620^A0,20,20^FD" BAR-FROM-LOC3 "^FS" INTO-LAB.
    STRING "^FT025,1100^A0,20,20^FDMFG. DATE: " BAR-CDATE "^FS" INTO-LAB.
    STRING "^FT005,1100^A0,20,20^FDMADE IN: CANADA^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-TRW. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-CUSORD PERFORM BAR-LTH-ENG PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO660,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO460,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO390,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO260,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO130,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO660,800^GB130,0,4^FS" INTO-LAB.
    STRING "^FO390,900^GB070,0,4^FS" INTO-LAB.
    STRING "^FO260,580^GB130,0,4^FS" INTO-LAB.
    STRING "^FO130,700^GB130,0,4^FS" INTO-LAB.
    STRING "^FO000,580^GB130,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT730,20^A0,35,35^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT700,20^A0,35,35^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT670,20^A0,35,35^FDCDA^FS" INTO-LAB.

    STRING "^FT780,820^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT730,820^A0,35,35^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT700,820^A0,35,35^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT670,820^A0,35,35^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT640,20^AC^FDPART NUMBER (P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 550 TO A-N1 MOVE 200 TO A-N2 MOVE 100 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT470,80^BY3,3,70^BC,,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT440,20^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT396,20^A0,50,40^FD" BAR-DESC-A BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT440,920^AC^FDDATE^FS" INTO-LAB.
    STRING "^FT420,920^AC^FD(MM-DD-YY)^FS" INTO-LAB.
    MOVE BAR-NDATE TO A-A1 MOVE 396 TO A-N1 MOVE 1080 TO A-N2 MOVE 50 TO A-N3 A-N4 PERFORM BAR-STRD.

    STRING "^FT370,20^AC^FDQUANTITY (Q)^FS" INTO-LAB.
    STRING "^FT346,200^A0,50,50^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT270,80^BY3,3,70^BC,,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT370,600^AC^FDPO NUMBER (K)^FS" INTO-LAB.
    STRING "^FT346,780^A0,50,50^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT270,640^BY3,3,70^BC,,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT240,20^AC^FDSUPPLIER NUMBER (V)^FS" INTO-LAB.
    STRING "^FT216,270^A0,50,50^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT140,80^BY3,3,70^BC,,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT240,520^AC^FDCERTIFICATION^FS" INTO-LAB.
    STRING "^FT220,520^AC^FDSTATUS^FS" INTO-LAB.
    STRING "^FT140,600^A0,100,100^FDC^FS" INTO-LAB.

    STRING "^FT240,720^AC^FDREV LEVEL (2P)^FS" INTO-LAB.
    STRING "^FT216,910^A0,50,50^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.
    STRING "^FT140,760^BY3,3,70^BC,,N^FD2P" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.

    STRING "^FT110,20^AC^FDSERIAL NUMBER (S)^FS" INTO-LAB.
    STRING "^FT086,250^A0,50,50^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT010,80^BY3,3,70^BC,,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT110,600^AC^FDLOT NUMBER (1T)^FS" INTO-LAB.
    STRING "^FT086,800^A0,50,50^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT010,640^BY3,3,70^BC,,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-TMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-PLQTY.
    PERFORM BAR-LTH-PKSLIP PERFORM BAR-LTH-CUSORD PERFORM BAR-LTH-ENG.
    PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO650,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO520,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO390,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO260,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO130,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO520,800^GB130,0,4^FS" INTO-LAB.
    STRING "^FO390,900^GB130,0,4^FS" INTO-LAB.
    STRING "^FO000,580^GB390,0,4^FS" INTO-LAB.

    STRING "^FT670,220^A0,140,140^FDMASTER LABEL^FS" INTO-LAB.

    STRING "^FT630,20^AC^FDFROM:^FS" INTO-LAB.
    STRING "^FT590,20^A0,35,35^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT560,20^A0,35,35^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT530,20^A0,35,35^FDCDA^FS" INTO-LAB.

    STRING "^FT630,820^AC^FDTO:^FS" INTO-LAB.
    STRING "^FT590,820^A0,35,35^FD" BAR-NAME "^FS" INTO-LAB.
    STRING "^FT560,820^A0,35,35^FD" BAR-ADD1 "^FS" INTO-LAB.
    MOVE BAR-ADD2 TO A-A1 PERFORM STR-LTH.
    STRING "^FT530,820^A0,35,35^FD" BAR-ADD2(1:A-N1) " " BAR-POST "^FS" INTO-LAB.

    STRING "^FT500,20^AC^FDPART NUMBER (P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 476 TO A-N1 MOVE 270 TO A-N2 MOVE 50 TO A-N3 A-N4 PERFORM BAR-STRD.
    STRING "^FT400,80^BY3,3,70^BC,,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT500,920^AC^FDREV LEVEL (2P)^FS" INTO-LAB.
    STRING "^FT476,1100^A0,50,50^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.
    STRING "^FT400,960^BY3,3,70^BC,,N^FD2P" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.

    STRING "^FT370,20^AC^FDQUANTITY (Q)^FS" INTO-LAB.
    STRING "^FT346,270^A0,50,50^FD" BAR-PLQTY(BAR-TX:) "^FS" INTO-LAB.
    STRING "^FT270,80^BY3,3,70^BC,,N^FDQ" BAR-PLQTY(BAR-TX:) "^FS" INTO-LAB.

    STRING "^FT370,600^AC^FDPO NUMBER (K)^FS" INTO-LAB.
    STRING "^FT346,830^A0,50,50^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT270,640^BY3,3,70^BC,,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT240,20^AC^FDSUPPLIER NUMBER (V)^FS" INTO-LAB.
    STRING "^FT216,270^A0,50,50^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT140,80^BY3,3,70^BC,,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT240,600^AC^FDPACKING SLIP (11K)^FS" INTO-LAB.
    STRING "^FT216,830^A0,50,50^FD" BAR-PKSLIP(BAR-GX:) "^FS" INTO-LAB.
    STRING "^FT140,640^BY3,3,70^BC,,N^FD11K" BAR-PKSLIP(BAR-GX:) "^FS" INTO-LAB.

    STRING "^FT110,20^AC^FDPKG ID-MASTER (4S)^FS" INTO-LAB.
    STRING "^FT086,270^A0,50,50^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT010,80^BY3,3,70^BC,,N^SN4S" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT110,600^AC^FDLOT NUMBER (1T)^FS" INTO-LAB.
    STRING "^FT086,830^A0,50,50^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT010,640^BY3,3,70^BC,,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-DANA. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
* note 241
    INSPECT BAR-PROD REPLACING ALL "-" BY " " PERFORM BAR-LTH-PROD.
    PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO568,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO344,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO184,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO094,808^GB0,512,4^FS" INTO-LAB.

    STRING "^FO184,608^GB384,0,4^FS" INTO-LAB.
    STRING "^FO000,808^GB184,0,4^FS" INTO-LAB.

    STRING "^FT788,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT768,20^AC^FD(P)^FS" INTO-LAB.
    STRING "^FT696,160^A0,140,140^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    STRING "^FT583,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT548,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT528,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT460,160^A0,140,140^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT350,070^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT548,628^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT480,628^A0,55,55^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT430,628^A0,55,55^FD" BAR-DESC-B "^FS" INTO-LAB.
    STRING "^FT380,628^A0,40,40^FD" BAR-DESC-FIN "^FS" INTO-LAB.

    STRING "^FT324,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT304,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT300,160^A0,55,55^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT190,070^BY3,3,105^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT324,628^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT304,628^AC^FD(L)^FS" INTO-LAB.
    STRING "^FT300,768^A0,55,55^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT190,678^BY3,3,105^B3,,,N,N^FDL" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT164,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT144,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT140,160^A0,55,55^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT030,070^BY3,3,105^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT164,828^AC^FDDATE MFG^FS" INTO-LAB.
    STRING "^FT110,860^A0,40,40^FD" BAR-ADATE "^FS" INTO-LAB.

    STRING "^FT010,070^AC^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-MODATEK.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO610,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO450,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO280,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO120,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO450,900^GB350,0,4^FS" INTO-LAB.
    STRING "^FO000,900^GB280,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT760,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 730 TO A-N1 MOVE 160 TO A-N2 MOVE 75 TO A-N3 MOVE 85 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT622,080^BY4,3,100^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT780,920^AC^FDFROM^FS" INTO-LAB.
    STRING "^FT710,920^A0,35,35^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT670,920^A0,35,35^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT630,920^A0,35,35^FDCDA^FS" INTO-LAB.

    STRING "^FT590,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT570,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT570,160^A0,50,60^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT462,080^BY4,3,100^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT590,920^AC^FDSTORAGE LOCATION^FS" INTO-LAB.
    STRING "^FT470,920^A0,110,110^FD0010^FS" INTO-LAB.

    STRING "^FT430,20^AC^FDSERIAL NO.^FS" INTO-LAB.
    STRING "^FT410,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT400,160^A0,50,60^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT292,080^BY4,3,100^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT260,20^AC^FDVENDOR^FS" INTO-LAB.
    STRING "^FT240,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT240,160^A0,50,60^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT132,080^BY4,3,100^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT260,920^AC^FDPRODUCTION DATE^FS" INTO-LAB.
    STRING "^FT160,920^A0,60,60^FD" BAR-CDATE "^FS" INTO-LAB.

    STRING "^FT100,20^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT062,180^A0,70,70^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT004,180^A0,70,70^FD" BAR-DESC-B "^FS" INTO-LAB.

    STRING "^FT100,920^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT030,920^A0,60,60^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-MMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE SYS-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY PERFORM BAR-LTH-SERIAL.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO680,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO490,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO330,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO160,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO330,900^GB350,0,4^FS" INTO-LAB.
    STRING "^FO000,900^GB160,0,4^FS" INTO-LAB.

    STRING "^FT700,200^A0,100,170^FDMaster Label^FS" INTO-LAB.

    STRING "^FT660,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT640,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 610 TO A-N1 MOVE 160 TO A-N2 MOVE 75 TO A-N3 MOVE 85 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT502,080^BY4,3,100^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT660,920^AC^FDFROM^FS" INTO-LAB.
    STRING "^FT590,920^A0,35,35^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT550,920^A0,35,35^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT510,920^A0,35,35^FDCDA^FS" INTO-LAB.

    STRING "^FT470,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT450,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT450,160^A0,50,60^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT342,080^BY4,3,100^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT470,920^AC^FDSTORAGE LOCATION^FS" INTO-LAB.
    STRING "^FT350,920^A0,110,110^FD0010^FS" INTO-LAB.

    STRING "^FT310,20^AC^FDSERIAL NO.^FS" INTO-LAB.
    STRING "^FT290,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT280,160^A0,50,60^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT172,080^BY4,3,100^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT140,20^AC^FDVENDOR^FS" INTO-LAB.
    STRING "^FT120,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT120,160^A0,50,60^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT012,080^BY4,3,100^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT140,920^AC^FDPRODUCTION DATE^FS" INTO-LAB.
    STRING "^FT040,920^A0,60,60^FD" BAR-CDATE "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-INMET.
    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO610,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO450,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO280,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO120,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO610,900^GB190,0,4^FS" INTO-LAB.
    STRING "^FO280,600^GB330,0,4^FS" INTO-LAB.
    STRING "^FO120,900^GB160,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT760,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 730 TO A-N1 MOVE 160 TO A-N2 MOVE 75 TO A-N3 MOVE 85 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT622,080^BY3,3,100^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT780,920^AC^FDFROM^FS" INTO-LAB.
    STRING "^FT710,920^A0,35,35^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT670,920^A0,35,35^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT630,920^A0,35,35^FDCDA^FS" INTO-LAB.

    STRING "^FT590,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT570,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT570,160^A0,50,60^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT462,080^BY3,3,100^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT590,620^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT570,620^AC^FD(1T)^FS" INTO-LAB.
    STRING "^FT570,760^A0,50,60^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT462,680^BY3,3,100^B3,,,N,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT430,20^AC^FDSERIAL NO.^FS" INTO-LAB.
    STRING "^FT410,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT400,160^A0,50,60^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT292,080^BY3,3,100^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT430,620^AC^FDP.O. NO.^FS" INTO-LAB.
    STRING "^FT410,620^AC^FD(K)^FS" INTO-LAB.
    STRING "^FT400,760^A0,50,60^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT292,680^BY3,3,100^B3,,,N,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT260,20^AC^FDVENDOR^FS" INTO-LAB.
    STRING "^FT240,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT240,160^A0,50,60^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT132,080^BY3,3,100^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT260,920^AC^FDPRODUCTION DATE^FS" INTO-LAB.
    STRING "^FT160,920^A0,60,60^FD" BAR-CDATE "^FS" INTO-LAB.

    STRING "^FT100,20^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT062,180^A0,70,70^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT004,180^A0,70,70^FD" BAR-DESC-B "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-IMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE SYS-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY PERFORM BAR-LTH-SERIAL.
    PERFORM BAR-LTH-CUSORD PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO680,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO490,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO330,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO160,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO490,900^GB190,0,4^FS" INTO-LAB.
    STRING "^FO160,600^GB330,0,4^FS" INTO-LAB.
    STRING "^FO000,900^GB160,0,4^FS" INTO-LAB.

    STRING "^FT700,300^A0,100,120^FDMASTER LABEL^FS" INTO-LAB.

    STRING "^FT660,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT640,20^AC^FD(P)^FS" INTO-LAB.
    MOVE BAR-PROD TO A-A1 MOVE 610 TO A-N1 MOVE 160 TO A-N2 MOVE 75 TO A-N3 MOVE 85 TO A-N4 PERFORM BAR-STRD.
    STRING "^FT502,080^BY3,3,100^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT660,920^AC^FDFROM^FS" INTO-LAB.
    STRING "^FT590,920^A0,35,35^FD" BAR-FROM-NAME "^FS" INTO-LAB.
    STRING "^FT550,920^A0,35,35^FD" BAR-FROM-LOC1 "^FS" INTO-LAB.
    STRING "^FT510,920^A0,35,35^FDCDA^FS" INTO-LAB.

    STRING "^FT470,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT450,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT450,160^A0,50,60^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT342,080^BY3,3,100^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT470,620^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT450,620^AC^FD(1T)^FS" INTO-LAB.
    STRING "^FT450,760^A0,50,60^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT342,680^BY3,3,100^B3,,,N,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT310,20^AC^FDSERIAL NO.^FS" INTO-LAB.
    STRING "^FT290,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT280,160^A0,50,60^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT172,080^BY3,3,100^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT310,620^AC^FDP.O. NO.^FS" INTO-LAB.
    STRING "^FT290,620^AC^FD(K)^FS" INTO-LAB.
    STRING "^FT280,760^A0,50,60^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT172,680^BY3,3,100^B3,,,N,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT140,20^AC^FDVENDOR^FS" INTO-LAB.
    STRING "^FT120,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT120,160^A0,50,60^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT012,080^BY3,3,100^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT140,920^AC^FDPRODUCTION DATE^FS" INTO-LAB.
    STRING "^FT040,920^A0,60,60^FD" BAR-CDATE "^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-BENTELER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO400,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO210,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO030,000^GB0,720,2^FS" INTO-LAB.
    STRING "^FO500,610^GB0,710,4^FS" INTO-LAB.

    STRING "^FO600,900^GB200,0,4^FS" INTO-LAB.
    STRING "^FO400,610^GB200,0,4^FS" INTO-LAB.
    STRING "^FO030,660^GB370,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT760,20^AC^FD(P)^FS" INTO-LAB.
    STRING "^FT715,150^A0,100,100^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    STRING "^FT606,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT780,920^AC^FDLOT^FS" INTO-LAB.
    STRING "^FT620,920^A0,65,65^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT580,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT560,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT515,150^A0,75,75^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT^A0,75,75^FD  EA^FS" INTO-LAB.
    STRING "^FT406,070^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT580,630^AC^FDDATE^FS" INTO-LAB.
    STRING "^FT510,660^A0,65,65^FD" BAR-LDATE "^FS" INTO-LAB.

    STRING "^FT480,630^AC^FDENG CHANGE^FS" INTO-LAB.
    STRING "^FT410,660^A0,65,65^FDAB^FS" INTO-LAB.

    STRING "^FT380,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT360,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT325,150^A0,75,75^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT216,070^BY3,3,105^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT380,680^AC^FDDESCRIPTION^FS" INTO-LAB.
    STRING "^FT230,680^A0,65,65^FD" BAR-DESC-A "^FS" INTO-LAB.

    STRING "^FT190,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT170,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT142,150^A0,75,75^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT034,070^BY3,3,105^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT190,680^AC^FDSHIP TO^FS" INTO-LAB.
    STRING "^FT170,680^AC^FD(D)^FS" INTO-LAB.
    STRING "^FT190,1220^AC^FDDOCK ID^FS" INTO-LAB.
    STRING "^FT170,800^A0,45,45^FD45^FS" INTO-LAB.
    STRING "^FT050,680^A0,95,75^FDKZOO^FS" INTO-LAB.
    STRING "^FT050,900^BY3,3,105^B3,,,N,N^FDD45^FS" INTO-LAB.
    STRING "^FT030,925^AC^FD9000 E MICHIGAN^FS" INTO-LAB.
    STRING "^FT010,925^AC^FD GALESBURG, MI^FS" INTO-LAB.

    STRING "^FT010,050^AC^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-BMASTER. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY PERFORM BAR-LTH-SERIAL.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO400,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO210,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO030,000^GB0,720,2^FS" INTO-LAB.
    STRING "^FO030,660^GB370,0,4^FS" INTO-LAB.

    STRING "^FT610,050^A0,250,200^FDMASTER LABEL^FS" INTO-LAB.

    STRING "^FT580,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT560,20^AC^FD(P)^FS" INTO-LAB.
    STRING "^FT515,150^A0,100,100^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    STRING "^FT406,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT380,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT360,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT325,150^A0,75,75^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT216,070^BY3,3,105^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT380,680^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT360,680^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT325,810^A0,75,75^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT^A0,75,75^FD  EA^FS" INTO-LAB.
    STRING "^FT216,790^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT190,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT170,20^AC^FD(M)^FS" INTO-LAB.
    STRING "^FT142,150^A0,75,75^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT034,070^BY3,3,105^B3,,,N,N^SNM" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT190,680^AC^FDSHIP TO^FS" INTO-LAB.
    STRING "^FT170,680^AC^FD(D)^FS" INTO-LAB.
    STRING "^FT190,1220^AC^FDDOCK ID^FS" INTO-LAB.
    STRING "^FT170,800^A0,45,45^FD45^FS" INTO-LAB.
    STRING "^FT050,680^A0,95,75^FDKZOO^FS" INTO-LAB.
    STRING "^FT050,900^BY3,3,105^B3,,,N,N^FDD45^FS" INTO-LAB.
    STRING "^FT030,925^AC^FD9000 E MICHIGAN^FS" INTO-LAB.
    STRING "^FT010,925^AC^FD GALESBURG, MI^FS" INTO-LAB.

    STRING "^FT010,050^AC^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

BAR-LAB-VENEST. MOVE BAR-LABQTY TO A-N1 PERFORM BAR-SET-SERIAL.
    MOVE BAR-DATE TO D-DATE PERFORM BAR-SET-DATE.
    PERFORM BAR-LTH-PROD PERFORM BAR-LTH-SERIAL PERFORM BAR-LTH-QTY.
    PERFORM BAR-LTH-CUSORD PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO600,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO400,000^GB0,1320,4^FS" INTO-LAB.
    STRING "^FO200,000^GB0,1320,4^FS" INTO-LAB.

    STRING "^FO600,700^GB200,0,4^FS" INTO-LAB.
    STRING "^FO000,620^GB600,0,4^FS" INTO-LAB.

    STRING "^FT780,20^AC^FDPART NO.^FS" INTO-LAB.
    STRING "^FT760,20^AC^FD(P)^FS" INTO-LAB.
    STRING "^FT715,150^A0,100,100^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    STRING "^FT606,070^BY3,3,105^B3,,,N,N^FDP" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.

    STRING "^FT780,720^AC^FDLOT#^FS" INTO-LAB.
    STRING "^FT760,720^AC^FD(1T)^FS" INTO-LAB.
    STRING "^FT715,830^A0,100,100^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT606,760^BY3,3,105^B3,,,N,N^FD1T" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.

    STRING "^FT580,20^AC^FDQUANTITY^FS" INTO-LAB.
    STRING "^FT560,20^AC^FD(Q)^FS" INTO-LAB.
    STRING "^FT525,150^A0,75,75^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT416,070^BY3,3,105^B3,,,N,N^FDQ" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.

    STRING "^FT580,640^AC^FDSHIP TO:^FS" INTO-LAB.
    STRING "^FT480,640^A0,30,30^FDVENEST INDUSTRIES^FS" INTO-LAB.
    STRING "^FT450,640^A0,30,30^FD2032 FIRST STREET SOUTH^FS" INTO-LAB.
    STRING "^FT420,640^A0,30,30^FDST. CATHARINES, ON L2R 6P9^FS" INTO-LAB.

    STRING "^FT380,20^AC^FDSUPPLIER^FS" INTO-LAB.
    STRING "^FT360,20^AC^FD(V)^FS" INTO-LAB.
    STRING "^FT325,150^A0,75,75^FD" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.
    STRING "^FT216,070^BY3,3,105^B3,,,N,N^FDV" BAR-SUPPLIER(1:BAR-EX) "^FS" INTO-LAB.

    STRING "^FT380,640^AC^FDPO#^FS" INTO-LAB.
    STRING "^FT360,640^AC^FD(K)^FS" INTO-LAB.
    STRING "^FT325,770^A0,75,75^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT216,690^BY3,3,105^B3,,,N,N^FDK" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.

    STRING "^FT180,20^AC^FDSERIAL^FS" INTO-LAB.
    STRING "^FT160,20^AC^FD(S)^FS" INTO-LAB.
    STRING "^FT125,150^A0,75,75^SN" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.
    STRING "^FT016,070^BY3,3,105^B3,,,N,N^SNS" BAR-SERIAL(BAR-SX:) "^FS" INTO-LAB.

    STRING "^FT160,640^AC^FDDATE:    ^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD" BAR-LDATE "^FS" INTO-LAB.
    STRING "^FT120,640^AC^FDDESCR:   ^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD" BAR-DESC-A "^FS" INTO-LAB.
    STRING "^FT080,640^AC^FDENG CHG: ^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD" PRO-ENG "^FS" INTO-LAB.
    STRING "^FT040,640^AC^FDPART#:   ^FS" INTO-LAB.
    STRING "^FT^A0,35,35^FD ^FS" INTO-LAB.

    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

* note 278
BAR-LAB-MGM. PERFORM BAR-LTH-PROD PERFORM BAR-LTH-QTY PERFORM BAR-LTH-CUSORD.
    PERFORM BAR-LTH-ENG PERFORM BAR-LTH-LOT.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.

    STRING "^FT720,0^A0,35,35^FB250,1,,R^FDPart Number:^FS" INTO-LAB.
    STRING "^FT650,0^A0,35,35^FB250,1,,R^FDQuantity:^FS" INTO-LAB.
    STRING "^FT580,0^A0,35,35^FB250,1,,R^FDPO Number:^FS" INTO-LAB.
    STRING "^FT510,0^A0,35,35^FB250,1,,R^FDRev:^FS" INTO-LAB.
    STRING "^FT440,0^A0,35,35^FB250,1,,R^FDLot Number:^FS" INTO-LAB.
    STRING "^FT370,0^A0,35,35^FB250,1,,R^FDDev Number:^FS" INTO-LAB.
    STRING "^FT300,0^A0,35,35^FB250,1,,R^FDTool Number:^FS" INTO-LAB.

    STRING "^FT720,280^A0,60,60^FD" BAR-PROD(1:BAR-PX) "^FS" INTO-LAB.
    STRING "^FT650,280^A0,60,60^FD" BAR-QTY(BAR-QX:) "^FS" INTO-LAB.
    STRING "^FT580,280^A0,60,60^FD" BAR-CUSORD(1:BAR-CX) "^FS" INTO-LAB.
    STRING "^FT510,280^A0,60,60^FD" BAR-ENG(1:BAR-NX) "^FS" INTO-LAB.
    STRING "^FT440,280^A0,60,60^FD" BAR-LOT(BAR-LX:) "^FS" INTO-LAB.
    STRING "^FT370,280^A0,60,60^FDNA^FS" INTO-LAB.
    STRING "^FT300,280^A0,60,60^FDNA^FS" INTO-LAB.

    STRING "^FT400,700^BY4,3^B7,8,5,0,40,N^FH^FD" "[)>_1E06" INTO-LAB.
    STRING "@P" BAR-PROD(1:BAR-PX) "@Q" BAR-QTY(BAR-QX:)
      "@K" BAR-CUSORD(1:BAR-CX) "@2P" BAR-ENG(1:BAR-NX)
      "@1T" BAR-LOT(BAR-LX:) "@ZNA" "@10SNA" INTO-LAB.
    STRING "_1E_04" "^FS" INTO-LAB.

    STRING "^FT040,050^A0,30,30^FD" BAR-FROM "^FS" INTO-LAB.
    STRING "^PQ" BAR-LABQTY ",0," BAR-QSER "^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    REPLACE OFF.

BATCH-READ. PERFORM BAT-RD1 THRU BAT-RD9.
BAT-RD1. ADD 1 TO S-IX IF S-IX>30 OR S-SCD(S-IX)=0
      MOVE 0 TO S-BAT-CODE S-IX MOVE 99 TO S-CD GO BAT-RD9.
    MOVE S-SCD(S-IX) TO S-CD.
    MOVE S-PR-NUM(S-IX) TO PR-NUM MOVE S-SEL-N(S-IX) TO SEL-N.
    MOVE S-TOT-IND(S-IX) TO TOT-IND MOVE S-SUM-IND(S-IX) TO SUM-IND.
    MOVE S-RANGE-FIELDS(S-IX) TO RANGE-FIELDS.
    MOVE S-PARAM-FIELDS(S-IX) TO PARAM-FIELDS.
BAT-RD9. EXIT.
BATCH-WRITE. PERFORM BAT-WR1 THRU BAT-WR9.
BAT-WR1. MOVE 0 TO S-DEF-CODE ADD 1 TO S-IX IF S-IX>30 GO BAT-WR9.
    IF S-IX<30 MOVE 0 TO S-SCD(S-IX + 1).
    MOVE S-CD TO S-SCD(S-IX).
    MOVE PR-NUM TO S-PR-NUM(S-IX) MOVE SEL-N TO S-SEL-N(S-IX).
    MOVE TOT-IND TO S-TOT-IND(S-IX) MOVE SUM-IND TO S-SUM-IND(S-IX).
    MOVE RANGE-FIELDS TO S-RANGE-FIELDS(S-IX).
    MOVE PARAM-FIELDS TO S-PARAM-FIELDS(S-IX).
BAT-WR9. EXIT.

GET-USER. SET JPI-CUR TO TRUE CALL "SYS$GETJPIW"
      USING OMITTED JPI-PIDADR OMITTED JPI-LIST OMITTED OMITTED OMITTED
      GIVING LIB-RET IF NOT LIB-RET-NORMAL STOP RUN.
    MOVE JPI-USERNAME TO USN-USER.
SET-USER. PERFORM SET-US1 THRU SET-US9.
SET-US1. MOVE 0 TO A-S1 MOVE USN-USER TO US-USER.
    READ USERS REGARDLESS INVALID MOVE 1 TO A-S1 GO SET-US9.
    MOVE US-NUM TO USN-NUM MOVE US-TDX(USN-OP) TO USN-TDX.
    MOVE US-PC TO USN-KPC MOVE US-PRNM TO USN-PRNM.
SET-US9. EXIT.

MN-AXFUNC. PERFORM MN-AXF1 THRU MN-AXF9.
MN-AXF1. ACCEPT MN-S LINE 3 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO MN-AXF9.
    IF MN-S="KZX" MOVE 1 TO USN-KSYS GO MN-AXF1.
    IF MN-S="KP1" MOVE 1 TO USN-KPRT GO MN-AXF1.
    IF MN-S="KP0" MOVE 0 TO USN-KPRT GO MN-AXF1.
    IF MN-S1 ALPHABETIC AND NOT=" "
      PERFORM 2 TIMES IF MN-S(3:1)=" "
        MOVE MN-S(2:1) TO MN-S(3:1) MOVE "0" TO MN-S(2:1) END-IF END-PERFORM
      IF MN-S2 NOT NUMERIC PERFORM DSP-ERR2 GO MN-AXF1 END-IF
      MOVE MN-S1 TO A-A1 CALL "STR$UPCASE" USING DESCRIPTOR A-A2 A-A1
      MOVE A-A2 TO MN-SEL GO MN-AXF4.
    PERFORM 3 TIMES IF MN-S(3:1)=" "
      MOVE MN-S(2:1) TO MN-S(3:1) MOVE MN-S(1:1) TO MN-S(2:1)
      MOVE "0" TO MN-S(1:1) END-IF END-PERFORM.
    IF MN-N NOT NUMERIC PERFORM DSP-ERR2 GO MN-AXF1.
    MOVE MN-OSEL TO MN-SEL MOVE MN-N TO MN-S2.
MN-AXF4. IF MN-SEL="X" OR "L" GO MN-AXF9.
    PERFORM MN-GETOP IF MN-OP=0 PERFORM DSP-ERR2 GO MN-AXF1.
    IF MN-S2>40 AND NOT=99 MOVE 0 TO MN-S2. MOVE MN-S2 TO MN-FUNC.
    IF USN-USER="SYSTEM" AND USN-KSYS=0 GO MN-AXF6.
    MOVE MN-OP TO USN-OP PERFORM SET-USER IF A-S1=1 GO MN-AXF6.
    IF MN-OP=24 PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>40
      IF USN-TD(A-X1)="1" GO MN-AXF8 END-IF END-PERFORM GO MN-AXF6.
    IF (MN-FUNC=0 OR 99) OR USN-TD(MN-FUNC)="1" GO MN-AXF8.
MN-AXF6. PERFORM DSP-ERR0 GO MN-AXF1.
MN-AXF8. MOVE MN-SEL TO MN-OSEL.
MN-AXF9. EXIT.
MN-GETOP. PERFORM MN-GOP1 THRU MN-GOP9.
MN-GOP1. PERFORM VARYING MN-OP FROM 1 BY 1 UNTIL MN-OP>24
      IF MN-MTBL(MN-OP:1)=MN-SEL GO MN-GOP9 END-IF END-PERFORM.
    MOVE 0 TO MN-OP.
MN-GOP9. EXIT.
MN-CLR. PERFORM DSP-CLS MOVE 0 TO DCL-ERRNO.

MW1.
MW3. PERFORM AX-SYS-DATE.
    DISPLAY "SCANNER FUNCTIONS   " LINE 1 REVERSED ERASE SCREEN.
    DISPLAY "FUNCTION: _" LINE 3.
    DISPLAY "1. INVENTORY UPDATE" LINE 5.
    DISPLAY "2. SCRAP ENTRY" LINE 6.
    DISPLAY "9. LOG OUT" LINE 7.
    ACCEPT XN1 LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR XN1=9 CLOSE USERS PERFORM CLOSE-FL PERFORM DSQ-CLS STOP RUN.
    IF XN1=0 OR>2 GO MW3.
* note 271
    IF XN1=1 MOVE "G" TO MN-SEL MOVE 4 TO MN-FUNC.
    IF XN1=2 MOVE "P" TO MN-SEL MOVE 36 TO MN-FUNC.
    PERFORM MN-GETOP MOVE MN-OP TO USN-OP PERFORM SET-USER.
    IF A-S1=1 OR USN-TD(MN-FUNC)="0" PERFORM DSQ-ERR0 GO MW3.
    GO IW1 LW1  DEPENDING XN1.
MW9. GO MW3.

MN1. PERFORM RD9 IF NOT IFAST MOVE WS-DIV-NAME TO TF12(1).
    PERFORM AX-SYS-DATE MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE D-DAYNM(SYS-WDAY) TO A-A1 PERFORM STR-LTH.
    MOVE D-DAYNM(SYS-WDAY) TO TF13(1)(10 - A-N1:) MOVE D-MTHNM(D-MM)(1:3) TO TF14(1).
    MOVE D-DD TO TF15(1) MOVE D-YEAR TO TF16(1) PERFORM WRT.
    PERFORM MN-AXFUNC.
MN3. PERFORM DSP-CLS IF KPF4 OR MN-SEL="X" GO MN8.
    IF MN-SEL="L" PERFORM RD8 PERFORM WRT PERFORM DSP-CONT GO MN1.
    PERFORM MN-GETOP IF MN-OP=0 GO MN1.
    GO GG1 LL1 QQ1 HH1 KK1 OO1 NN1 TT1 MM1 UU1
       WW1 MN1 MN1 MN1 MN1 MN1 MN1 MN1 MN1 MN1
       MN1 MN1 MN1 MX1
      DEPENDING MN-OP. GO MN1.
MN8. CLOSE USERS PERFORM CLOSE-FL STOP RUN.
MN9. GO GG9 LL9 QQ9 HH9 KK9 OO9 NN9 TT9 MM9 UU9
        WW9 MN1 MN1 MN1 MN1 MN1 MN1 MN1 MN1 MN1
        MN1 MN1 MN1 MN1
       DEPENDING MN-OP. GO MN1.

MX1. PERFORM RD10 PERFORM WRT PERFORM AX-SYS-DATE.
    ACCEPT S-CD LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR S-CD=99 GO MN1.
    IF S-CD=77 MOVE 1 TO S-BAT-CODE MOVE 0 TO S-DEF-CODE S-IX MOVE " " TO S-DF GO MX9.
    IF NOT(S-CD>=1 AND<=40) GO MX1.
    MOVE 24 TO USN-OP PERFORM SET-USER.
    IF A-S1=1 OR USN-TD(S-CD)="0" PERFORM DSP-ERR0 GO MX1.
    MOVE 0 TO S-BAT-CODE.
    ACCEPT S-DF LINE 3 COLUMN 29 DEFAULT " " UNDERLINED PROTECTED.
MX3. IF S-CD=99 GO MN1. IF S-DF>" " MOVE 1 TO S-DEF-CODE.
    IF S-BAT COMPUTE S-CDB=S-CD / 100 MULTIPLY 100 BY S-CDB
      ELSE COMPUTE S-CDB=100 * S-CD.
    IF NOT(S-CD>=16 AND<=20 OR>1000) GO MX4.
    IF S-BAT COMPUTE S-CDL=S-CD - S-CDB
      ELSE EVALUATE TRUE
        WHEN S-CDB=1600 PERFORM RD1016
        WHEN S-CDB=1700 PERFORM RD1017
        WHEN S-CDB=1800 PERFORM RD1018
        WHEN S-CDB=1900 PERFORM RD1019
        WHEN S-CDB=2000 PERFORM RD1020
        END-EVALUATE PERFORM WRT
       ACCEPT S-CDL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY
       IF KPF4 OR S-CDL=99 GO MX1 END-IF COMPUTE S-CD=S-CDB + S-CDL.
    PERFORM MN-CLR.
    IF S-CDB=1600
      GO FE1 FI1 HA1 AI1 AS1 BF1 BJ1 ER1 FY1 FZ1
         WU1 QY1 VQ1 OA1 QT1 QV1
        DEPENDING S-CDL.
    IF S-CDB=1700
      GO NB1 NL1 NH1 NQ1 NR1 NA1 ND1 NE1 NF1 NC1
         NI1 TV1 BV1 TC1 FU1
        DEPENDING S-CDL.
    IF S-CDB=1800
      GO EA1 EB1 EC1 EM1 JR1 EF1 EJ1 NM1 EG1 JB1
         JL1 JK1 JW1 EQ1 KQ1 EH1 EY1 NY1 MX1 MX1
         EE1 EK1 GE1 EW1
        DEPENDING S-CDL.
    IF S-CDB=1900
      GO RA1 RH1 RQ1 RT1 RC1 RB1 RW1 RF1 RY1 RJ1
         IK1 RK1
        DEPENDING S-CDL.
    IF S-CDB=2000
      GO II1 EV1 BD1 IB1 PN1 DV1 PD1 PA1 GD1 JA1
         JI1 MX1 MX1 MX1 MX1 MX1 MX1 FN1 QP1 QD1
         AP1 AV1 CR1 PC1 QC1 CA1 GL1 PY1 IH1 VE1
         SP1 DI1 UR1
        DEPENDING S-CDL.
    GO MX1.
MX4. PERFORM MN-CLR.
    GO BB1 JJ1 SO1 HR1 BR1 AR1 DS1 SE1 DD1 SD1
       SS1 RS1 TU1 SQ1 QG1 MX1 MX1 MX1 MX1 MX1
       RL1 QA1 TB1 SY1 TK1 WP1 BN1 JT1 FP1 DP1
       PO1 UP1 KS1 KL1 KR1
      DEPENDING S-CD. GO MX1.
MX9. IF S-DEF PERFORM BATCH-WRITE GO MX1.
    IF S-BAT PERFORM BATCH-READ GO MX3. GO MX1.

GG1. IF MN-FUNC>0 GO GG4.
GG3. PERFORM RD9G PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="G" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO GG3.
GG4. PERFORM MN-CLR.
    GO CI1 TI1 QN1 IV1 OR1 WF1 TO1 RI1 ON1 BC1
       QF1 OI1 CT1 CO1 OL1 BI1 SF1 DE1 QS1 MI1
       MC1 MP1 MB1 MS1 MJ1 MO1 CN1 DH1 JC1 SG1
       AQ1 FK1 UE1 RG1 WR1 MU1 MV1 JP1
      DEPENDING MN-FUNC.
GG9. GO GG3.

LL1. IF MN-FUNC>0 GO LL4.
LL3. PERFORM RD9S PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="S" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO LL3.
LL4. PERFORM MN-CLR.
    IF MN-FUNC=15 OR>=21 AND<=27 PERFORM RDR-INFO IF IF-SHP-DATE NOT=SYS-DATE
      DISPLAY "S-20 'CREATE SHIPPING FILE' WAS NOT PERFORMED TODAY." LINE 8 BOLD
      DISPLAY "YOU MUST PERFORM S-20 BEFORE S-15, S-21 - S-27." LINE 12
      DISPLAY "(NO ONE ELSE MUST USE 'S' MENU FUNCTIONS WHILE PERFORMING S-20.)" LINE 14
      PERFORM DSP-CONT GO LL3.
    IF MN-FUNC<=30 OPEN I-O SHIPORD ALLOWING ALL SHIPLIN ALLOWING ALL BINALLOC ALLOWING ALL.
    IF MN-FUNC>=31 AND<=40 OPEN I-O SUBCON ALLOWING ALL SUBINV ALLOWING ALL.
    GO LJ1 LP1 LD1 LR1 LQ1 LO1 LF1 PG1 PV1 KG1
       LH1 CD1 HX1 JD1 GB1 NG1 FC1 FH1 FQ1 KW1
       KB1 LS1 KD1 IN1 LM1 LV1 IR1 LL9 LL9 LL9
       GS1 GN1 GQ1 GR1 GC1 GW1
      DEPENDING MN-FUNC.
LL9. IF MN-FUNC<=30 CLOSE SHIPORD SHIPLIN BINALLOC.
    IF MN-FUNC>=31 AND<=40 CLOSE SUBCON SUBINV. GO LL3.

HH1. IF MN-FUNC>0 GO HH4.
HH3. PERFORM RD9I PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="I" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO HH3.
HH4. PERFORM MN-CLR.
    OPEN I-O PHYSINV ALLOWING ALL.
    GO DB1 HI1 HU1 HS1 HW1 HV1 HN1 HB1 HD1 WC1
       WH1 WZ1
      DEPENDING MN-FUNC.
HH9. CLOSE PHYSINV GO HH3.

QQ1. IF MN-FUNC>0 GO QQ4.
QQ3. PERFORM RD9B PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="B" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO QQ3.
QQ4. PERFORM MN-CLR.
    OPEN I-O QBIN ALLOWING ALL.
    GO QM1 QR1
      DEPENDING MN-FUNC.
QQ9. CLOSE QBIN GO QQ3.

WW1. IF MN-FUNC>0 GO WW4.
WW3. PERFORM RD9P PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="P" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO WW3.
WW4. PERFORM MN-CLR.
    GO PM1 PJ1 BM1 BE1 PB1 SU1 OM1 OQ1 OS1 PP1
       CV1 OB1 OC1 SI1 WX1 SZ1 BP1 WY1 WW9 WW9
       VM1 AG1 IG1 DC1 GM1 CG1 OV1 VI1 VT1 PQ1
       IM1 VN1 PZ1 WG1 DN1 LZ1 RE1 RN1
      DEPENDING MN-FUNC.
WW9. GO WW3.

UU1. IF MN-FUNC>0 GO UU4.
UU3. PERFORM RD9T PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="T" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO UU3.
UU4. PERFORM MN-CLR.
    GO EP1 EO1 MZ1 BQ1 TW1 UD1 FW1 GH1 VX1 QH1
       TE1 TA1 TN1 FB1 TM1 TQ1 FS1 TJ1 DQ1
      DEPENDING MN-FUNC.
UU9. GO UU3.

KK1. IF MN-FUNC>0 GO KK4.
KK3. PERFORM RD9M PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="M" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO KK3.
KK4. PERFORM MN-CLR.
    GO HM1 HQ1 IS1 IL1 CE1 CQ1 UL1 JE1 BW1 QJ1
       QK1 BG1 SB1 VA1 VW1 VJ1 VC1 OT1 VD1 VF1
       HP1 IT1 MR1 PS1 DA1 VG1 VK1 VS1 UQ1 KV1
       VY1 GK1 DZ1
      DEPENDING MN-FUNC.
KK9. GO KK3.

OO1. IF MN-FUNC>0 GO OO4.
OO3. PERFORM RD9E PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="E" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO OO3.
OO4. PERFORM MN-CLR.
    GO CW1 CJ1 CB1 UC1 UA1 UB1 UF1 AF1 AE1 UG1
       AJ1 UJ1 AW1 OO9 OO9 OO9 OO9 OO9 OO9 OO9
       MD1 RM1 MH1 MA1 MG1 RO1 QW1 EN1
      DEPENDING MN-FUNC.
OO9. GO OO3.

NN1. IF MN-FUNC>0 GO NN4.
NN3. PERFORM RD9C PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="C" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO NN3.
NN4. PERFORM MN-CLR.
    IF MN-FUNC>=11 AND<=20 OPEN I-O QUOTORD ALLOWING ALL QUOTLIN ALLOWING ALL.
    GO JM1 AO1 GF1 HK1 HG1 HY1 HZ1 NN9 NN9 NN9
       AM1 BS1 JN1 BL1
      DEPENDING MN-FUNC.
NN9. IF MN-FUNC>=11 AND<=20 CLOSE QUOTORD QUOTLIN. GO NN3.

TT1. IF MN-FUNC>0 GO TT4.
TT3. PERFORM RD9F PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="F" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO TT3.
TT4. PERFORM MN-CLR.
    GO CS1 LI1 JH1 UT1 JF1 JG1 CM1 OU1 OW1 KN1
       JS1 JQ1
      DEPENDING MN-FUNC.
TT9. GO TT3.

MM1. IF MN-FUNC>0 GO MM4.
MM3. PERFORM RD9A PERFORM WRT PERFORM AX-SYS-DATE PERFORM MN-AXFUNC.
    IF MN-SEL NOT="A" GO MN3. IF KPF4 OR MN-FUNC=99 GO MN1. IF MN-FUNC=0 GO MM3.
MM4. PERFORM MN-CLR.
    PERFORM OPEN-EMPL OPEN I-O MNTMAST ALLOWING ALL MNTORD ALLOWING ALL
      MNTLIN ALLOWING ALL MNTMAC ALLOWING ALL.
    GO KA1 KC1 KE1 KF1 KH1 KJ1 FM1 UW1 WJ1 WK1
       WB1 WM1 FX1 NP1 NS1
      DEPENDING MN-FUNC.
MM9. CLOSE EMPL MNTMAST MNTORD MNTLIN MNTMAC GO MM3.

* G: GENERAL FUNCTIONS

* G-1 CUSTOMER INFORMATION
CI1. PERFORM RD11 PERFORM WRT MOVE " " TO C-NO.
CI3. DISPLAY "PF2 FOR CUSTOMER CONTACTS" LINE 24 BOLD.
    ACCEPT IA7 LINE 23 COLUMN 74 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR IA7=ALL "9" GO CI9.
    IF KPF2 AND IA7=" " PERFORM CI-CONT IF A-S1=1 GO CI3 ELSE MOVE C-NO TO IA7 GO CI4.
    IF KPF3 AND IA7=" " GO CI32. GO CI4.
CI32. READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO CI3.
    MOVE 1 TO IX1 MOVE 6 TO IXT.
CI33. ACCEPT C-INFO(IX1) LINE IXT COLUMN 48 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE C-INFO(IX1) TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-INFO(IX1).
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER.
    ADD 1 TO IX1 IXT IF IX1<=3 GO CI33. GO CI3.
CI4. MOVE C-NO TO CI-NO MOVE IA7 TO C-NO.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 MOVE CI-NO TO C-NO GO CI3.
    PERFORM RDR-INFO PERFORM RD11 MOVE C-NO TO TF44(1) MOVE C-NAME TO TF45(1).
    IF INUT MOVE "CORP CUS" TO TLN(2)(30:8) MOVE C-MCUS TO TF44(2).
    MOVE C-ADD1 TO TF45(2) MOVE C-ADD2 TO TF45(3) MOVE C-POST TO TF45(4).
    MOVE 1 TO IX1 MOVE 6 TO IXT PERFORM UNTIL IX1>3
      MOVE C-INFO(IX1) TO TF45(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    MOVE C-TER TO TF41(3) MOVE C-PROV TO TF41(4).
    MOVE C-SUR TO TF42(4) IF C-SUR>0 MOVE IF-SURCH(C-SUR) TO TF43(4).
    MOVE C-SAL TO TF41(5) IF C-BACK<=1 MOVE LIT-YN(C-BACK + 1:1) TO TF39(5).
    MOVE C-VIA TO TF41(6) IF C-EDICF<=1 MOVE LIT-NY(C-EDICF + 1:1) TO TF39(6).
    IF C-STAT<=1 MOVE LIT-YN(C-STAT + 1:1) TO TF38(7). MOVE C-BROKER TO TF40(7).
    IF C-HOLD<=1 MOVE LIT-NY(C-HOLD + 1:1) TO TF38(8).
    IF C-MTEST<=1 MOVE LIT-YN(C-MTEST + 1:1) TO TF39(8).
    IF C-US<=1 MOVE LIT-NY(C-US + 1:1) TO TF38(9).
    IF C-INACTIVE<=1 MOVE LIT-NY(C-INACTIVE + 1:1) TO TF39(9).
    MOVE C-CREDIT TO TF47(11) MOVE C-DB TO TF46(12) MOVE C-CONTRA TO TF48(13).
    MOVE C-INS TO TF47(14) MOVE C-GST TO TF46(15) MOVE C-PST TO TF46(16).
    MOVE C-TYPE TO TF46(18) MOVE C-AUTO TO TF41(19) MOVE C-LABEL TO TF41(20).
    MOVE C-CLASS TO TF46(21) MOVE C-IRS TO TF46(22) MOVE C-SUPPLIER TO TF46(23).
    MOVE C-TOT TO TF49(10) MOVE C-CUR TO TF49(11) MOVE C-30 TO TF49(12).
    MOVE C-60 TO TF49(13) MOVE C-90 TO TF49(14) MOVE C-120 TO TF49(15).
    MOVE C-MTD TO TF49(17) MOVE C-YTD TO TF49(18).
    MOVE C-LAST TO TF49(19) MOVE C-BLAST TO TF49(20) MOVE C-ORD TO TF49(21).
    MOVE 1 TO IX1 MOVE 17 TO IXT PERFORM UNTIL IX1>3
      IF C-PAY-NUM(IX1) NOT=0 COMPUTE TF37(IXT) ROUNDED=C-PAY-DAYS(IX1) / C-PAY-NUM(IX1) END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
    MOVE C-TERMS TO TF51(20).
    IF C-TERMS>0 MOVE 16 TO T-TBL MOVE C-TERMS TO T-NO PERFORM RD-TBL
      MOVE T-TE1 TO TF52(20) MOVE "DAYS" TO TF53(20)
      MOVE T-TE2 TO A-A1 PERFORM STR-LTH
      IF A-N1<=19 MOVE T-TE2 TO TF50(21)(7:) ELSE MOVE T-TE2 TO TF50(21)(26 - A-N1:).
    PERFORM WRT GO CI3.
CI9. GO MN9.

CI-CONT. PERFORM CI-C1 THRU CI-C9.
CI-C1. MOVE 0 TO A-S1.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 MOVE 1 TO A-S1 GO CI-C9.
    PERFORM WRT132 PERFORM RD287 PERFORM WRT PERFORM OPEN-CUSCONT.
    DISPLAY C-NO LINE 1 COLUMN 33 BOLD "  " C-NAME BOLD.
    DISPLAY "EDIT FIELDS OR: 'RETURN', 'UP', 'DOWN', PF4 TO END" LINE 23 BOLD.
    MOVE LOW-VALUES TO CY-RECORD INITIALIZE CY-REC MOVE C-NO TO CY-NO.
    READ CUSCONT REGARDLESS INVALID WRITE CY-RECORD ALLOWING NO UNLOCK CUSCONT.

    MOVE 1 TO CI-IXL MOVE 5 TO IXT.
CI-C3. IF CY-FIRST(CI-IXL)>" " DISPLAY CY-FIRST(CI-IXL) LINE IXT COLUMN 1.
    IF CY-LAST(CI-IXL)>" " DISPLAY CY-LAST(CI-IXL) LINE IXT COLUMN 12.
    IF CY-POSITION(CI-IXL)>" " DISPLAY CY-POSITION(CI-IXL) LINE IXT COLUMN 23.
    IF CY-PHONE(CI-IXL)>" " DISPLAY CY-PHONE(CI-IXL) LINE IXT COLUMN 34.
    IF CY-EXT(CI-IXL)>" " DISPLAY CY-EXT(CI-IXL) LINE IXT COLUMN 48.
    IF CY-FAX(CI-IXL)>" " DISPLAY CY-FAX(CI-IXL) LINE IXT COLUMN 53.
    IF CY-EMAIL(CI-IXL)>" " DISPLAY CY-EMAIL(CI-IXL) LINE IXT COLUMN 67.
    IF CY-CITY(CI-IXL)>" " DISPLAY CY-CITY(CI-IXL) LINE IXT COLUMN 98.
    IF CY-STATE(CI-IXL)>" " DISPLAY CY-STATE(CI-IXL) LINE IXT COLUMN 114.
    IF CY-COUNTRY(CI-IXL)>" " DISPLAY CY-COUNTRY(CI-IXL) LINE IXT COLUMN 118.
    ADD 1 TO CI-IXL IXT IF CI-IXL<=10 GO CI-C3.

    REPLACE ==CHK-KPF== BY ==IF KPF4 GO CI-C8 ELSE IF KP-UP OR KP-DOWN PERFORM CI-K GO CI-C5==
            ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY==.
    MOVE 1 TO CI-IXL MOVE 5 TO IXT.
CI-C5. ACCEPT CY-FIRST(CI-IXL) LINE IXT COLUMN 1 ACC-ALP CHK-KPF.
    ACCEPT CY-LAST(CI-IXL) LINE IXT COLUMN 12 ACC-ALP CHK-KPF.
    ACCEPT CY-POSITION(CI-IXL) LINE IXT COLUMN 23 ACC-ALP CHK-KPF.
    ACCEPT CY-PHONE(CI-IXL) LINE IXT COLUMN 34 ACC-ALP CHK-KPF.
    ACCEPT CY-EXT(CI-IXL) LINE IXT COLUMN 48 ACC-ALP CHK-KPF.
    ACCEPT CY-FAX(CI-IXL) LINE IXT COLUMN 53 ACC-ALP CHK-KPF.
    ACCEPT CY-EMAIL(CI-IXL) LINE IXT COLUMN 67 ACC-ALP CHK-KPF.
    ACCEPT CY-CITY(CI-IXL) LINE IXT COLUMN 98 ACC-ALP CHK-KPF.
    ACCEPT CY-STATE(CI-IXL) LINE IXT COLUMN 114 ACC-ALP CHK-KPF.
    ACCEPT CY-COUNTRY(CI-IXL) LINE IXT COLUMN 118 ACC-ALP CHK-KPF.
    ADD 1 TO CI-IXL IXT IF CI-IXL<=10 GO CI-C5.
    REPLACE OFF.

CI-C8. REWRITE CY-RECORD ALLOWING NO UNLOCK CUSCONT.
    PERFORM WRT80 CLOSE CUSCONT.
CI-C9. EXIT.

CI-K. IF KP-UP IF CI-IXL>1 SUBTRACT 1 FROM CI-IXL IXT.
    IF KP-DOWN IF CI-IXL<10 ADD 1 TO CI-IXL IXT.

* G-2 PRODUCT INFORMATION
TI1. PERFORM RD12 PERFORM WRT.
* note 63
TI3. ACCEPT P-NO LINE 23 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR P-NO=ALL "9" GO TI9.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TI3.
    PERFORM RD12 MOVE P-NO TO TF576(1) IF P-NUT>" " MOVE "(NUT:" TO TF577(1)
      MOVE P-NUT TO TF578(1) MOVE ")" TO TF579(1).
    PERFORM PROD-DESC.
    MOVE 1 TO IX1 MOVE 2 TO IXT PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO TF580(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    IF IX1<=5 AND P-CUSPART>" "
      STRING "CUSTOMER PART: " P-CUSPART DELIMITED SIZE INTO TF580(IXT).
    IF P-GEN=" " PERFORM CHK-ALTS
      IF A-S1=0 MOVE "NO" TO TF581(3) ELSE MOVE "YES" TO TF581(3).
    MOVE P-GEN TO TF582(4) MOVE P-QUOTNO TO TF586(5).
    IF P-INACTIVE<=1 MOVE LIT-NY(P-INACTIVE + 1:1) TO TF583(6).
    MOVE P-CUS TO TF584(6) MOVE P-ORD TO TF585(6).
    PERFORM SET-OPLIST MOVE PRO-OPLINE(1) TO TF628(7) MOVE PRO-OPLINE(2) TO TF628(8).
    MOVE P-PLSPEC TO TF606(9) MOVE P-SPEC TO TF607(9).
    MOVE P-DIAM TO TF615(10) MOVE P-GRADE TO TF616(10).
    MOVE P-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO TF611(11).
    MOVE P-PROC TO TF612(11) MOVE P-CLEAN TO TF613(11).
    MOVE P-MAC TO TF608(12) MOVE P-RATE TO TF609(12) MOVE P-ALT-MAC TO TF610(12).
    MOVE P-PACKING TO TF617(13) MOVE P-QTY-PACK TO TF618(13) MOVE P-CONT TO TF619(13).
    MOVE P-TCOLOR TO TF620(14) IF P-PPAP<=1 MOVE LIT-NY(P-PPAP + 1:1) TO TF621(14).
    MOVE P-HCODE TO TF622(15).
    MOVE P-LAST TO TF627(16) MOVE P-PREV TO TF627(17).

    MOVE P-MTD TO TF623(19) MOVE P-YTD TO TF625(19).
    MOVE P-W-MTD TO TF623(20) MOVE P-W-YTD TO TF625(20).
    MOVE P-A-MTD TO TF624(21) MOVE P-A-YTD TO TF626(21).

    MOVE P-CAT TO TF595(9) MOVE P-FAMILY TO TF596(9) MOVE P-MARKET TO TF597(9).
    MOVE P-WEIGHT TO TF592(10) MOVE P-GROSS TO TF593(10) MOVE P-PWEIGHT TO TF594(10).
    MOVE P-PRICE1 TO TF587(11) MOVE P-PRICE2 TO TF588(11) MOVE P-MODE TO TF589(11).
    MOVE P-COST TO TF590(12) IF P-CHGPR<=1 MOVE LIT-NY(P-CHGPR + 1:1) TO TF591(12).

    MOVE P-HAND TO TF600(14) PERFORM CHK-QBIN MOVE A-N1 TO TF601(14).
    MOVE P-DEMAND TO TF598(15) MOVE P-FDEMAND TO TF598(16).
    MOVE P-ORDER TO TF600(17) MOVE P-TORDER TO TF601(17).

    MOVE P-PROCESS TO TF600(18) MOVE 0 TO WN1 WN2.
    MOVE P-NO TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO TI58.
TI51. READ PRODORD NEXT REGARDLESS END GO TI58. IF R-PROD NOT=P-NO GO TI58.
    IF R-QTY-LEFT<=0 GO TI51.
* note 250
    INITIALIZE J-KEY MOVE R-NO TO J-NO MOVE 90 TO J-MAC.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO TI54.
TI53. READ WORKSHEET NEXT REGARDLESS END GO TI54.
    IF J-NO NOT=R-NO OR J-MAC>95 GO TI54. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-DEFECT ADD J-QTY TO WN1. IF PROC-REJECT ADD J-QTY TO WN2. GO TI53.
TI54. INITIALIZE J-KEY MOVE R-NO TO J-NO MOVE 845 TO J-MAC.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO TI56.
TI55. READ WORKSHEET NEXT REGARDLESS END GO TI56.
    IF J-NO NOT=R-NO OR J-MAC>850 GO TI56. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-RECEIVE ADD J-QTY TO WN2. GO TI55.
TI56. GO TI51.
TI58. IF WN1>0 SUBTRACT WN2 FROM WN1 IF WN1<0 MOVE 0 TO WN1.
    MOVE WN1 TO TF601(18).

    MOVE P-ROP TO TF598(19) MOVE P-EST TO TF598(20) MOVE P-LEVEL TO TF599(20).
    MOVE P-BANK TO TF598(21) MOVE P-LEAD TO TF599(21).
    MOVE P-NDATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF603(22).
    MOVE P-GDATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF604(22).
    MOVE P-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF603(23).
    MOVE P-CRDATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF604(23).
    PERFORM CHK-NEW IF A-S1=1 MOVE "N" TO TF605(23).
    PERFORM WRT GO TI3.
TI9. GO MN9.

* G-3 SHOW OPERATIONS LIST
QN1. PERFORM RD45 PERFORM WRT MOVE " " TO P-NO.
QN3. ACCEPT P-NO LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR P-NO=ALL "9" GO QN9.
    PERFORM RD45 PERFORM WRT DISPLAY P-NO LINE 3 COLUMN 11.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO QN3.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 4 COLUMN 11.
    MOVE 0 TO IX1 MOVE 32 TO IXU MOVE P-NO TO OP-PROD MOVE 0 TO OP-MAC.
    START OPERATIONS KEY>OP-KEY REGARDLESS INVALID GO QN36.
QN35. READ OPERATIONS NEXT REGARDLESS END GO QN36. IF OP-PROD NOT=P-NO GO QN36.
    DISPLAY OP-MAC LINE 2 COLUMN IXU CONVERSION.
    ADD 1 TO IX1 IF IX1<5 ADD 3 TO IXU GO QN35.
QN36. MOVE P-MAC TO OP-MAC DISPLAY OP-MAC LINE 3 COLUMN 32 CONVERSION.
    MOVE P-NO TO OP-PROD.
    ACCEPT OP-MAC LINE 3 COLUMN 32 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 GO QN9. DISPLAY OP-MAC LINE 3 COLUMN 32 CONVERSION.
    READ OPERATIONS REGARDLESS INVALID PERFORM DSP-ERR27 GO QN3.
    DISPLAY OP-SPEED LINE 6 COLUMN 17 CONVERSION OP-EFF COLUMN 41 CONVERSION.
    MOVE 0 TO IX1 MOVE 9 TO IXT.
QN53. IF IX1=0 IF ITOOL GO QN58 END-IF MOVE OP-MAC TO M-NO
        ELSE IF OP-OPER(IX1)=0 GO QN58 END-IF MOVE OP-OPER(IX1) TO M-NO.
    DISPLAY M-NO LINE IXT COLUMN 2 CONVERSION.
    READ MACHINE REGARDLESS INVALID MOVE "--ERROR--" TO M-DESC1 M-DESC2 M-OPDESC.
    DISPLAY M-DESC1 LINE IXT COLUMN 8 M-DESC2 COLUMN 39 M-OPDESC COLUMN 70.
QN58. ADD 1 TO IX1 IXT IF IX1<=12 GO QN53. GO QN3.
QN9. GO MN9.

* G-4 INVENTORY UPDATE
IV1. PERFORM OPEN-AUDIT MOVE 0 TO IV-KQ.
IV3. PERFORM RD14 PERFORM WRT.
    INITIALIZE IV-PROD IV-FBIN IV-TBIN IV-NO IV-LOT IV-QTY IV-CARTONS IV-QTY-PACK IV-CONT.
    DISPLAY "VALID TRANSACTIONS: 'REC', 'ADJ', 'TRF'" LINE 24 BOLD.
    ACCEPT IV-TRANS LINE 3 COLUMN 15 DEFAULT "REC"
      UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR IV-TRANS="999" GO IV9.
    IF IV-TRANS="REC" GO IV4. IF IV-TRANS="ADJ" GO IV6. IF IV-TRANS="TRF" GO IV8.
    PERFORM DSP-ERR19 GO IV3.

IV4. DISPLAY " M.O.    LOT       BIN   CARTONS           QUANTITY" LINE 5 BOLD.
*             ......   _______   _____   ______x_____ = __________
IV43. DISPLAY " " LINE 6 ERASE LINE " " LINE 9 ERASE LINE.
    ACCEPT IV-LOT LINE 6 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IV-LOT=9999999 GO IV89. IF IV-LOT=0 PERFORM DSP-ERR15 GO IV43.
    MOVE IV-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO IV43.
    IF LT-QUAR=1 PERFORM DSP-ERR44 GO IV43.
    MOVE LT-MO TO IV-NO R-NO DISPLAY IV-NO LINE 6 COLUMN 1 CONVERSION.
    READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO IV43.
    MOVE 0 TO IV-KRP IF R-QTY-LEFT>0 GO IV46.
    MOVE "NO FURTHER RECEIPTS PERMITTED FOR THIS M.O. - IS THIS A REPACK OPERATION ? ___" TO TMSG.
    PERFORM DSP-PROMPT IF XA3 NOT="YES" GO IV43. MOVE 1 TO IV-KRP.
IV46. MOVE R-PROD TO IV-PROD P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO IV43.
    PERFORM IV-DSP-PROD.
    IF IV-PROD NOT=LT-PROD MOVE "PRODUCT NOT AS IN LOT RECORD" TO ERR-MESG
      PERFORM DSP-ERR GO IV43.

IV5. DISPLAY " " LINE 7 ERASE LINE.
    ACCEPT IV-TBIN LINE 6 COLUMN 20 DEFAULT " "
      UNDERLINED PROTECTED EDITING ERASE END LINE KEY CKEY.
    IF KPF4 OR IV-TBIN=ALL "9" GO IV43. IF IV-TBIN=LIT-PICK GO IV54.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO IV5.
    IF B-QTY NOT=0 AND B-PROD NOT=P-NO
      MOVE "PRODUCT NOT AS IN BIN RECORD" TO ERR-MESG PERFORM DSP-ERR GO IV5.
    IF IV-LOT NOT=0 IF B-LOT NOT=0 AND NOT=IV-LOT
      MOVE "LOT NOT AS IN BIN RECORD" TO ERR-MESG PERFORM DSP-ERR GO IV5.
    DISPLAY "CONTAINER CODE: _" LINE 7 BOLD.
    DISPLAY "ENTER 'P', 'T', ETC. IF RECEIVED IN SPECIAL CONTAINERS, ELSE BLANK" LINE 24 BOLD.
    ACCEPT IV-CONT LINE 7 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF B-QTY NOT=0 AND B-CONT NOT=IV-CONT
      MOVE "CONTAINER CODE NOT AS IN BIN RECORD" TO ERR-MESG PERFORM DSP-ERR GO IV5.
IV54. PERFORM IV-CALC-SQTY.

IV55. DISPLAY " " LINE 6 COLUMN 28 ERASE END LINE.
IV553. ACCEPT IV-CARTONS LINE 6 COLUMN 28 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF IV-CARTONS>36 MOVE "CARTONS CANNOT BE OVER 36"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO IV553.
    DISPLAY "x" LINE 6 COLUMN 34.
    IF IV-CARTONS=0 DISPLAY "BUCKET WEIGHT: ______" LINE 6 COLUMN 59 BOLD
      ACCEPT IV-WEIGHT LINE 6 COLUMN 74 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      MOVE 1 TO IV-CARTONS IF IV-WEIGHT<0 MULTIPLY -1 BY IV-WEIGHT IV-CARTONS END-IF
      DISPLAY IV-CARTONS LINE 6 COLUMN 28 CONVERSION
      PERFORM CALC-TWEIGHT
      COMPUTE IV-QTY-PACK ROUNDED=IV-WEIGHT * 100 / A-D1 SIZE ERROR MOVE 0 TO IV-QTY-PACK END-COMPUTE
      DISPLAY IV-QTY-PACK LINE 6 COLUMN 35 CONVERSION
     ELSE MOVE P-QTY-PACK TO IV-QTY-PACK
      DISPLAY IV-QTY-PACK LINE 6 COLUMN 35 CONVERSION
      ACCEPT IV-QTY-PACK LINE 6 COLUMN 35 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY IV-QTY-PACK LINE 6 COLUMN 35 CONVERSION.
    DISPLAY "=" COLUMN 41.
    COMPUTE IV-QTY=IV-CARTONS * IV-QTY-PACK.
    DISPLAY "TO CANCEL TRANSACTION ENTER 0" LINE 24 BOLD.
    DISPLAY IV-QTY LINE 6 COLUMN 43 CONVERSION.
    ACCEPT IV-QTY LINE 6 COLUMN 43 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSP-ERS.
    DISPLAY IV-QTY LINE 6 COLUMN 43 CONVERSION.
    IF IV-QTY=0 GO IV5.
    IF IV-KRP=0 AND IV-QTY>IV-SQTY MOVE " " TO ERR-MESG MOVE IV-SQTY TO DSP-C81
      STRING "QTY EXCEEDS PRIMARY MACHINE" DSP-C81 DELIMITED SIZE INTO ERR-MESG
      PERFORM DSP-OK IF XA2 NOT="OK" GO IV55 END-IF
      PERFORM DSP-SURE IF XA3 NOT="YES" GO IV55.
    PERFORM IV-UPDT-REC GO IV5.

IV6. DISPLAY "BIN      QUANTITY" LINE 5 BOLD.
*             _____   __________
IV63. DISPLAY " " LINE 9 ERASE LINE.
    ACCEPT IV-TBIN LINE 6 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING ERASE END LINE KEY CKEY.
    IF KPF4 OR IV-TBIN=ALL "9" GO IV89.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO IV63.
    MOVE B-PROD TO IV-PROD P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO IV63.
    PERFORM IV-DSP-PROD.
    MOVE B-QTY TO IV-QTY DISPLAY IV-QTY LINE 6 COLUMN 9 CONVERSION.
IV65. DISPLAY "ENTER ADJUSTMENT QUANTITY ('-' TO REDUCE, TO CANCEL TRANSACTION ENTER 0)" LINE 24 BOLD.
    ACCEPT IV-QTY LINE 6 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSP-ERS.
    IF IV-QTY=0 GO IV63.
    IF B-QTY + IV-QTY<B-QTY-AL MOVE "CANNOT ADJUST BELOW ALLOCATED QUANTITY"
      TO ERR-MESG PERFORM DSP-ERR GO IV65.
    PERFORM IV-UPDT-ADJ GO IV63.

IV8. DISPLAY "FROM BIN   TO BIN    QUANTITY" LINE 5 BOLD.
*               _____    _____    __________
IV83. DISPLAY " " LINE 9 ERASE LINE.
    ACCEPT IV-FBIN LINE 6 COLUMN 3 DEFAULT " " UNDERLINED PROTECTED EDITING ERASE END LINE KEY CKEY.
    IF KPF4 OR IV-FBIN=ALL "9" GO IV89.
    MOVE IV-FBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO IV83.
    MOVE B-PROD TO IV-PROD P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO IV83.
    PERFORM IV-DSP-PROD.
    IF B-QTY-AL NOT=0 MOVE "BIN HAS ALLOCATED QUANTITY" TO ERR-MESG
      PERFORM DSP-OK IF XA2 NOT="OK" GO IV83.
    MOVE B-DATE TO IV-DATE MOVE B-LOT TO IV-LOT MOVE B-QTY TO IV-FQTY.
    MOVE B-CONT TO IV-CONT MOVE B-QTY-PACK TO IV-QTY-PACK.
IV85. ACCEPT IV-TBIN LINE 6 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO IV85.
    IF B-QTY=0 GO IV86.
    IF B-PROD NOT=IV-PROD MOVE "PRODUCT NOT AS IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSP-ERR GO IV83.
    IF B-LOT NOT=0 AND IV-LOT NOT=0
      IF B-LOT NOT=IV-LOT MOVE "LOT NOT AS IN 'FROM' BIN"
        TO ERR-MESG PERFORM DSP-ERR GO IV83.
    IF B-CONT NOT=IV-CONT MOVE "CONTAINER CODE NOT AS IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSP-ERR GO IV83.
    IF B-QTY-PACK NOT=IV-QTY-PACK MOVE "PACKING QTY NOT AS IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSP-ERR GO IV83.
IV86. MOVE IV-FQTY TO IV-QTY DISPLAY IV-QTY LINE 6 COLUMN 21 CONVERSION.
IV87. DISPLAY "ENTER QUANTITY TRANSFERRED (TO CANCEL TRANSACTION ENTER 0)" LINE 24 BOLD.
    ACCEPT IV-QTY LINE 6 COLUMN 21 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSP-ERS.
    DISPLAY IV-QTY LINE 6 COLUMN 21 CONVERSION.
    IF IV-QTY=0 GO IV83.
    IF IV-QTY>IV-FQTY MOVE "QUANTITY IS GREATER THAN QUANTITY IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO IV87.
    PERFORM IV-UPDT-TRF GO IV83.

IV89. GO IV3.
IV9. CLOSE AUDIT GO MN9.

IV-DSP-PROD. PERFORM PROD-DESC.
    DISPLAY "PRODUCT:" LINE 9 BOLD IV-PROD COLUMN 11 PRO-DESC(1) COLUMN 25.
* note 205.2
IV-CALC-SQTY. PERFORM IV-CS1 THRU IV-CS9.
IV-CS1. IF IV-TBIN=LIT-PICK MOVE 850 TO IV-MAC ELSE MOVE 845 TO IV-MAC.
* note 30.2
    MOVE 0 TO IV-SQTY INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO IV-CS4.
IV-CS3. READ WORKSHEET NEXT REGARDLESS END GO IV-CS4. IF J-NO NOT=R-NO GO IV-CS4.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY ADD J-QTY TO IV-SQTY
      ELSE IF (IFAST OR INUT) AND PROC-REJECT OR J-MAC=IV-MAC SUBTRACT J-QTY FROM IV-SQTY.
    GO IV-CS3.
IV-CS4.
IV-CS9. EXIT.
IV-UPDT-REC. PERFORM IV-UR1 THRU IV-UR9.
IV-UR1. MOVE SYS-DATE TO IV-DATE.
    IF IV-TBIN=LIT-PICK GO IV-UR2. MOVE IV-TBIN TO B-NO READ BIN REGARDLESS.
    MOVE IV-PROD TO B-PROD ADD IV-QTY TO B-QTY MOVE IV-DATE TO B-DATE.
    IF B-LOT=0 MOVE IV-LOT TO B-LOT PERFORM SET-B-LYEAR.
    MOVE IV-CONT TO B-CONT IF P-CAT=21 OR 22 MOVE "Q" TO B-CONT.
    MOVE IV-QTY-PACK TO B-QTY-PACK REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
IV-UR2. IF IV-KRP=1 GO IV-UR4.
    MOVE IV-PROD TO P-NO READ PRODUCT REGARDLESS.
    MOVE SYS-DATE TO P-DATE SUBTRACT IV-QTY FROM P-PROCESS ADD IV-QTY TO P-HAND.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    MOVE IV-NO TO A-N1 PERFORM RD-PRODORD.
    ADD IV-QTY TO R-QTY-REC PERFORM CALC-QLEFT.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    PERFORM INIT-J MOVE IV-NO TO J-NO MOVE IV-MAC TO J-MAC MOVE IV-DATE TO J-DATE.
    MOVE IV-LOT TO J-LOT(1) MOVE IV-PROD TO J-PROD.
    MOVE IV-QTY TO A-N1 COMPUTE A-N2 ROUNDED=IV-QTY * P-WEIGHT / 100.
    MOVE A-N1 TO J-QTY MOVE A-N2 TO J-WEIGHT PERFORM SET-JKD.
    READ WORKSHEET REGARDLESS INVALID
      WRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET GO IV-UR4.
    ADD A-N1 TO J-QTY ADD A-N2 TO J-WEIGHT MOVE 1 TO IX1.
IV-UR3. IF J-LOT(IX1) NUMERIC
       IF J-LOT(IX1)=0 MOVE IV-LOT TO J-LOT(IX1)
         ELSE IF J-LOT(IX1) NOT=IV-LOT ADD 1 TO IX1 IF IX1<=10 GO IV-UR3.
    REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
IV-UR4. IF P-NUT=" " GO IV-UR8.
    MOVE 0 TO IV-NUM MOVE P-NUT TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO IV-UR44.
IV-UR43. READ PRODORD NEXT REGARDLESS END GO IV-UR44. IF R-PROD NOT=P-NUT GO IV-UR44.
    IF R-NO>9999 ADD 1 TO IV-NUM. GO IV-UR43.
IV-UR44. MOVE IV-QTY TO IV-Q1 MOVE P-NUT TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO IV-UR6.
IV-UR5. READ PRODORD NEXT REGARDLESS END GO IV-UR6. IF R-PROD NOT=P-NUT GO IV-UR6.
    IF R-NO<=9999 GO IV-UR5. SUBTRACT 1 FROM IV-NUM PERFORM CALC-QLEFT.
    IF IV-NUM=0 OR IV-Q1<=R-QTY-LEFT MOVE IV-Q1 TO IV-Q2 ELSE MOVE R-QTY-LEFT TO IV-Q2.
    SUBTRACT IV-Q2 FROM IV-Q1 ADD IV-Q2 TO R-QTY-REC PERFORM CALC-QLEFT.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    PERFORM INIT-J MOVE R-NO TO J-NO MOVE IV-MAC TO J-MAC MOVE IV-DATE TO J-DATE.
    MOVE P-NUT TO J-PROD.
    MOVE IV-Q2 TO A-N1 COMPUTE A-N2 ROUNDED=IV-Q2 * P-WEIGHT-NUT / 100.
    MOVE A-N1 TO J-QTY MOVE A-N2 TO J-WEIGHT PERFORM SET-JKD.
    WRITE J-RECORD ALLOWING NO INVALID READ WORKSHEET REGARDLESS
      ADD A-N1 TO J-QTY ADD A-N2 TO J-WEIGHT REWRITE J-RECORD ALLOWING NO.
    UNLOCK WORKSHEET IF IV-Q1>0 GO IV-UR5.
IV-UR6.
IV-UR8. PERFORM IV-AUDIT PERFORM IV-TR.
IV-UR9. EXIT.
IV-UPDT-ADJ. MOVE IV-TBIN TO B-NO READ BIN REGARDLESS ADD IV-QTY TO B-QTY.
    PERFORM CHK-BIN-EMPTY REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    MOVE IV-PROD TO P-NO READ PRODUCT REGARDLESS.
    ADD IV-QTY TO P-HAND REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    PERFORM IV-AUDIT PERFORM IV-TR.
IV-UPDT-TRF. MOVE IV-FBIN TO B-NO READ BIN REGARDLESS SUBTRACT IV-QTY FROM B-QTY.
    PERFORM CHK-BIN-EMPTY REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS ADD IV-QTY TO B-QTY.
    MOVE IV-PROD TO B-PROD MOVE SYS-DATE TO B-DATE.
    IF B-LOT=0 MOVE IV-LOT TO B-LOT PERFORM SET-B-LYEAR.
    MOVE IV-CONT TO B-CONT MOVE IV-QTY-PACK TO B-QTY-PACK.
    REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    PERFORM IV-AUDIT PERFORM IV-TR.
IV-AUDIT. MOVE IV-TRANS TO IE41 MOVE IV-NO TO IE42 MOVE IV-PROD TO IE43.
    MOVE IV-LOT TO IE44 MOVE IV-FBIN TO IE45 MOVE IV-TBIN TO IE46.
    MOVE IV-CARTONS TO IE47 MOVE IV-QTY TO IE48 MOVE IV-QTY-PACK TO IE49.
    IF IV-KQ=1 MOVE "SCN" TO IE49A.
    MOVE TD-INP-R4 TO AU-DATA MOVE 4 TO AU-K PERFORM ADD-AUD.
IV-TR. MOVE LOW-VALUES TO PE-RECORD INITIALIZE PE-REC MOVE IV-TRANS TO PE-TRANS.
    MOVE IV-PROD TO PE-PROD MOVE SYS-DATE TO PE-DATE ACCEPT PE-TIME FROM TIME.
    MOVE IV-FBIN TO PE-FBIN MOVE IV-TBIN TO PE-TBIN MOVE IV-LOT TO PE-LOT.
    MOVE IV-NO TO PE-NO MOVE IV-QTY TO PE-QTY MOVE IV-QTY-PACK TO PE-QTY-PACK.
    MOVE IV-CARTONS TO PE-CARTONS MOVE IV-CONT TO PE-CONT.
    WRITE PE-RECORD ALLOWING NO UNLOCK PRODTRANS.

* INVENTORY UPDATE (scanner function)
IW1. PERFORM OPEN-AUDIT MOVE 1 TO IV-KQ.
* note 22.2
IW3. DISPLAY "INVENTORY UPDATE    " LINE 1 REVERSED ERASE SCREEN.
    DISPLAY "TRANSACTION: _" LINE 3.
    DISPLAY "1. RECEIVE" LINE 6.
    DISPLAY "2. ADJUST" LINE 7.
    DISPLAY "3. TRANSFER" LINE 8.
    DISPLAY "9. END" LINE 9.
    INITIALIZE IV-PROD IV-FBIN IV-TBIN IV-NO IV-LOT IV-QTY IV-CARTONS IV-QTY-PACK IV-CONT.
    ACCEPT XN1 LINE 3 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR XN1=9 GO IW9.
    IF XN1=1 MOVE "REC" TO IV-TRANS GO IW4.
    IF XN1=2 MOVE "ADJ" TO IV-TRANS GO IW6.
    IF XN1=3 MOVE "TRF" TO IV-TRANS GO IW8.
    PERFORM DSQ-ERR19 GO IW3.

IW4. DISPLAY "INVNTRY UPDATE " LINE 1 REVERSED "  REC".
IW43. DISPLAY " " LINE 2 ERASE END SCREEN.
    DISPLAY "M.O.:" LINE 3 REVERSED.
    DISPLAY "LOT:" LINE 4 REVERSED " ________".
    DISPLAY "BIN:" LINE 5 REVERSED " _____" "LVL:" COLUMN 14 REVERSED " _".

    DISPLAY "CARTONS:" LINE 7 REVERSED.
    DISPLAY "QTY/CTN:" LINE 8 REVERSED.
    DISPLAY "QTY:" LINE 9 REVERSED.
    PERFORM IW-CLA.

    MOVE 4 TO IXT MOVE 6 TO IXU PERFORM SCAN-LOT IF A-S1=1 GO IW89.
    MOVE SCN-LOT TO IV-LOT IF IV-LOT=0 PERFORM DSQ-ERR15 GO IW43.
    MOVE IV-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSQ-ERR15 GO IW43.
    IF LT-QUAR=1 PERFORM DSQ-ERR44 GO IW43.
    MOVE LT-MO TO IV-NO R-NO DISPLAY IV-NO LINE 3 COLUMN 7 CONVERSION.
    READ PRODORD REGARDLESS INVALID PERFORM DSQ-ERR11 GO IW43.
    MOVE 0 TO IV-KRP IF R-QTY-LEFT>0 GO IW46.
    DISPLAY "NO FURTHER RECEIPTS" LINE 14 "  FOR THIS M.O." LINE 15
      "IS THIS REPACK? ___" LINE 16.
    ACCEPT XA3 LINE 16 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED PERFORM DSQ-ERS.
    IF XA3 NOT="YES" GO IW43. MOVE 1 TO IV-KRP.
IW46. MOVE R-PROD TO IV-PROD P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSQ-ERR6 GO IW43.
    MOVE 11 TO IXT PERFORM IW-DSP-PROD.
    IF IV-PROD NOT=LT-PROD MOVE "PRODUCT NOT AS IN     LOT RECORD" TO ERR-MESG
      PERFORM DSQ-ERR GO IW43.

IW5. PERFORM IW-CLA DISPLAY " " LINE 6 ERASE LINE " " LINE 10 ERASE LINE.
    MOVE 5 TO IXT PERFORM SCAN-BIN IF A-S1=1 GO IW43. MOVE A-A1 TO IV-TBIN.
    IF IV-TBIN=LIT-PICK GO IW54.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSQ-ERR7 GO IW5.
    IF B-QTY NOT=0 AND B-PROD NOT=P-NO
      MOVE "PRODUCT NOT AS IN     BIN RECORD" TO ERR-MESG PERFORM DSQ-ERR GO IW5.
    IF IV-LOT NOT=0 IF B-LOT NOT=0 AND NOT=IV-LOT
      MOVE "LOT NOT AS IN         BIN RECORD" TO ERR-MESG PERFORM DSQ-ERR GO IW5.
    DISPLAY "CONTAINER CODE:" LINE 6 REVERSED " _".
    DISPLAY "ENTER 'P', 'T', ETC." LINE 14 "  IF SPECIAL CONTNRS" LINE 15
      "  ELSE BLANK" LINE 16.
    ACCEPT IV-CONT LINE 6 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSQ-ERS.
    IF B-QTY NOT=0 AND B-CONT NOT=IV-CONT
      MOVE "CONTAINER CODE NOT    AS IN BIN RECORD" TO ERR-MESG PERFORM DSQ-ERR GO IW5.
IW54. PERFORM IV-CALC-SQTY.

IW55. PERFORM IW-CLA DISPLAY " " LINE 10 ERASE LINE.
    ACCEPT IV-CARTONS LINE 7 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF IV-CARTONS=0 DISPLAY "BKT WEIGHT:" LINE 10 REVERSED " ______"
      ACCEPT IV-WEIGHT LINE 10 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      MOVE 1 TO IV-CARTONS IF IV-WEIGHT<0 MULTIPLY -1 BY IV-WEIGHT IV-CARTONS END-IF
      DISPLAY IV-CARTONS LINE 7 COLUMN 10 CONVERSION
      PERFORM CALC-TWEIGHT
      COMPUTE IV-QTY-PACK ROUNDED=IV-WEIGHT * 100 / A-D1 SIZE ERROR MOVE 0 TO IV-QTY-PACK END-COMPUTE
      DISPLAY IV-QTY-PACK LINE 8 COLUMN 10 CONVERSION
     ELSE MOVE P-QTY-PACK TO IV-QTY-PACK
      DISPLAY IV-QTY-PACK LINE 8 COLUMN 10 CONVERSION
      ACCEPT IV-QTY-PACK LINE 8 COLUMN 10 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY IV-QTY-PACK LINE 8 COLUMN 10 CONVERSION.
    COMPUTE IV-QTY=IV-CARTONS * IV-QTY-PACK.
    DISPLAY "TO CANCEL TRANSCTN" LINE 15 "  ENTER 0" LINE 16.
    DISPLAY IV-QTY LINE 9 COLUMN 6 CONVERSION.
    ACCEPT IV-QTY LINE 9 COLUMN 6 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSQ-ERS.
    DISPLAY IV-QTY LINE 9 COLUMN 6 CONVERSION.
    IF IV-QTY=0 GO IW5.
    IF IV-KRP=0 AND IV-QTY>IV-SQTY MOVE " " TO ERR-MESG MOVE IV-SQTY TO DSP-C81
      STRING "QTY EXCEEDS PRIMARY  MACHINE" DSP-C81 DELIMITED SIZE INTO ERR-MESG
      PERFORM DSQ-ERR GO IW55.
    PERFORM IV-UPDT-REC GO IW5.

IW6. DISPLAY "INVNTRY UPDATE " LINE 1 REVERSED "  ADJ".
IW63. DISPLAY " " LINE 2 ERASE END SCREEN.
    DISPLAY "BIN:" LINE 3 REVERSED " _____" "LVL:" COLUMN 14 REVERSED " _".
    DISPLAY "QTY:" LINE 4 REVERSED " __________".
    MOVE 3 TO IXT PERFORM SCAN-BIN IF A-S1=1 GO IW89. MOVE A-A1 TO IV-TBIN.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSQ-ERR7 GO IW63.
    MOVE B-PROD TO IV-PROD P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSQ-ERR6 GO IW63.
    MOVE 10 TO IXT PERFORM IW-DSP-PROD.
    MOVE B-QTY TO IV-QTY DISPLAY IV-QTY LINE 4 COLUMN 6 CONVERSION.
IW65. DISPLAY "ENTER ADJUSTMENT QTY" LINE 13 "  ('-' TO REDUCE)" LINE 14
        "TO CANCEL TRANSCTN" LINE 15 "  ENTER 0" LINE 16.
    ACCEPT IV-QTY LINE 4 COLUMN 6 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSQ-ERS.
    IF IV-QTY=0 GO IW63.
    IF B-QTY + IV-QTY<B-QTY-AL MOVE "CANNOT ADJUST BELOW   ALLOCATED QTY"
      TO ERR-MESG PERFORM DSQ-ERR GO IW65.
    PERFORM IV-UPDT-ADJ GO IW63.

IW8. DISPLAY "INVNTRY UPDATE " LINE 1 REVERSED "  TRF".
IW83. DISPLAY " " LINE 2 ERASE END SCREEN.
    DISPLAY "FROM" LINE 3 REVERSED.
    DISPLAY "BIN:" LINE 4 REVERSED " _____" "LVL:" COLUMN 14 REVERSED " _".
    DISPLAY "TO  " LINE 5 REVERSED.
    DISPLAY "BIN:" LINE 6 REVERSED " _____" "LVL:" COLUMN 14 REVERSED " _".
    DISPLAY "QTY:" LINE 8 REVERSED " __________".
    MOVE 4 TO IXT PERFORM SCAN-BIN IF A-S1=1 GO IW89. MOVE A-A1 TO IV-FBIN.
    MOVE IV-FBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSQ-ERR7 GO IW83.
    MOVE B-PROD TO IV-PROD P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSQ-ERR6 GO IW83.
    MOVE 11 TO IXT PERFORM IW-DSP-PROD.
    IF B-QTY-AL NOT=0 MOVE "BIN HAS ALLOCATED     QTY" TO ERR-MESG
      PERFORM DSQ-OK IF XA2 NOT="OK" GO IW83.
    MOVE B-DATE TO IV-DATE MOVE B-LOT TO IV-LOT MOVE B-QTY TO IV-FQTY.
    MOVE B-CONT TO IV-CONT MOVE B-QTY-PACK TO IV-QTY-PACK.
IW85. MOVE 6 TO IXT PERFORM SCAN-BIN MOVE A-A1 TO IV-TBIN.
    MOVE IV-TBIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSQ-ERR7 GO IW85.
    IF B-QTY=0 GO IW86.
    IF B-PROD NOT=IV-PROD MOVE "PRODUCT NOT           AS IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSQ-ERR GO IW83.
    IF B-LOT NOT=0 AND IV-LOT NOT=0
      IF B-LOT NOT=IV-LOT MOVE "LOT NOT               AS IN 'FROM' BIN"
        TO ERR-MESG PERFORM DSQ-ERR GO IW83.
    IF B-CONT NOT=IV-CONT MOVE "CONTNR INDICATOR NOT  AS IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSQ-ERR GO IW83.
    IF B-QTY-PACK NOT=IV-QTY-PACK MOVE "PACKING QTY NOT       AS IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSQ-ERR GO IW83.
IW86. MOVE IV-FQTY TO IV-QTY DISPLAY IV-QTY LINE 8 COLUMN 6 CONVERSION.
IW87. DISPLAY "ENTER QTY TRANSFRD" LINE 14
        "TO CANCEL TRANSCTN" LINE 15 "  ENTER 0" LINE 16.
    ACCEPT IV-QTY LINE 8 COLUMN 6 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSQ-ERS.
    DISPLAY IV-QTY LINE 8 COLUMN 6 CONVERSION.
    IF IV-QTY=0 GO IW83.
    IF IV-QTY>IV-FQTY MOVE "QTY IS GREATER THAN   QTY IN 'FROM' BIN"
      TO ERR-MESG PERFORM DSQ-OK IF XA2 NOT="OK" GO IW87.
    PERFORM IV-UPDT-TRF GO IW83.

IW89. GO IW3.
IW9. CLOSE AUDIT GO MW9.

IW-CLA. DISPLAY "______" LINE 7 COLUMN 10.
    DISPLAY "_____" LINE 8 COLUMN 10.
    DISPLAY "__________" LINE 9 COLUMN 6.
IW-DSP-PROD. PERFORM PROD-DESC.
    DISPLAY IV-PROD LINE IXT PRO-DESC(1)(1:16) LINE IXT PLUS 1.

* G-5 ORDER ENTRY
OR1. OPEN I-O ACKORD ALLOWING ALL ACKLIN ALLOWING ALL.
    MOVE 0 TO OR-PREV-NO.
OR3. PERFORM RD16 PERFORM WRT.
    DISPLAY "'RETURN' TO START NEW ORDER" LINE 21 BOLD.
    DISPLAY "  OR 'PF1' TO START NEW ORDER AND COPY THE PREVIOUS ORDER" LINE 22 BOLD.
    DISPLAY "  OR ENTER AN ORDER NO. TO MODIFY OR CANCEL EXISTING ORDER" LINE 23 BOLD.
    DISPLAY "WHEN ENTERING/MODIFYING FIELDS: 'PF1' TO RETURN TO TOP, 'PF3' TO END" LINE 24 BOLD.
    ACCEPT O-NO LINE 1 COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    DISPLAY " " LINE 21 ERASE END SCREEN.
    IF KPF4 OR O-NO=999999 GO OR9. IF O-NO=0 GO OR4.
    READ SAORD REGARDLESS INVALID PERFORM DSP-ERR8 GO OR39. PERFORM OR-DSP-ORD.
    MOVE 0 TO OR-KSHP IF O-SPECIAL=1 GO OR38.
    OPEN I-O SHIPORD ALLOWING ALL.
    MOVE 0 TO WN1 MOVE O-NO TO HO-ORD MOVE 0 TO HO-SEQ.
    START SHIPORD KEY>=HO-KEY REGARDLESS INVALID GO OR34.
OR33. READ SHIPORD NEXT REGARDLESS END GO OR34. IF HO-ORD NOT=O-NO GO OR34.
    IF HO-IND=9 GO OR33. MOVE 1 TO WN2 IF HO-IND>3 MOVE 2 TO WN2.
    IF WN2>WN1 MOVE WN2 TO WN1. GO OR33.
OR34. CLOSE SHIPORD IF WN1=0 GO OR38.
    IF WN1=2 MOVE "THIS ORDER IS BEING SHIPPED: IT CAN NO LONGER BE MODIFIED"
      TO ERR-MESG PERFORM DSP-ERR GO OR39.
    DISPLAY "THIS ORDER IS BEING SHIPPED:" LINE 21 BOLD.
    DISPLAY "  YOU CAN NO LONGER MODIFY THE PRODUCT NO. OR QUANTITY, OR ADD LINES" LINE 22 BOLD.
    MOVE "'RETURN' TO CANCEL THIS REQUEST, OR 'MOD' TO MODIFY THE ORDER: ___" TO TMSG.
    PERFORM DSP-PROMPT DISPLAY " " LINE 21 ERASE END SCREEN.
    IF XA3=" " GO OR39. IF XA3 NOT="MOD" PERFORM DSP-ERR14 GO OR39.
    MOVE 1 TO OR-KSHP GO OR6.
OR38. MOVE "'A' TO ADD LINE, 'M' TO MODIFY ORDER, 'CAN' TO CANCEL ORDER: ___" TO TMSG.
    PERFORM DSP-PROMPT.
    IF XA3="A" MOVE O-LINES TO OR-LINE GO OR49. IF XA3="M" GO OR6.
    IF XA3="CAN" MOVE 3 TO O-ACK PERFORM OR-ADDACK PERFORM DEL-ORDER.
OR39. GO OR3.

    REPLACE ==CHK-KPF== BY ==IF KPF1 GO OR43 ELSE IF KPF3 GO OR48 END-IF END-IF==
            ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY==.
OR4.
OR41. PERFORM RD-INFO ADD 1 TO IF-ORDNO PERFORM WR-INFO.
    PERFORM INIT-O MOVE IF-ORDNO TO O-NO MOVE "NET 30" TO O-TERMS.
    MOVE WS-FOB TO O-FOB MOVE "C" TO O-PPD MOVE "B" TO O-PAYER.
    READ SAORD REGARDLESS INVALID GO OR42. GO OR41.
OR42. DISPLAY O-NO LINE 1 COLUMN 38 CONVERSION.
    IF NOT KPF1 OR OR-PREV-NO=0 GO OR428.
    MOVE OR-PREV-NO TO O-NO READ SAORD REGARDLESS INVALID GO OR428.
    MOVE IF-ORDNO TO O-NO.
OR428. PERFORM OR-DSP-ORD.
OR43. MOVE SYS-DATE TO D-DATE MOVE 1 TO IXT MOVE 59 TO IXU.
    MOVE 1 TO D-PF PERFORM AX-DT-DEF CHK-KPF MOVE DATE0 TO O-DATE.
    MOVE 2 TO IXT MOVE 17 TO IXU MOVE O-SPECIAL TO A-S1.
    PERFORM AX-NY CHK-KPF MOVE A-S1 TO O-SPECIAL.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE O-BLANKET TO A-S1.
    PERFORM AX-NY CHK-KPF MOVE A-S1 TO O-BLANKET.
    MOVE O-CUS TO OR-OCUS.
OR431. ACCEPT O-CUS LINE 2 COLUMN 41 ACC-ALP CHK-KPF.
    MOVE O-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO OR431.
    DISPLAY C-NAME LINE 4 C-ADD1 LINE 5 C-ADD2 LINE 6 C-POST LINE 7.
    IF C-INACTIVE=0 GO OR432. MOVE "THIS CUSTOMER IS INACTIVE" TO ERR-MESG PERFORM DSP-ERR.
* note 97.2
    PERFORM RD-INFO IF IF-ORDNO=O-NO SUBTRACT 1 FROM IF-ORDNO. PERFORM WR-INFO.
    GO OR3.
OR432. MOVE C-TER TO O-TER MOVE C-US TO O-US.
    IF O-CUS NOT=OR-OCUS
      MOVE C-SAL TO O-SAL A-N1 PERFORM RD-SALESMAN MOVE SN-SALCOM TO O-SALCOM
      DISPLAY O-SAL LINE 2 COLUMN 61 CONVERSION O-SALCOM COLUMN 75 CONVERSION.
    PERFORM OR-AX-SAL CHK-KPF PERFORM CHK-CUSTYPE.
OR433. DISPLAY "ENTER EITHER SHIP-TO CODE OR FULL SHIP-TO ADDRESS" LINE 24 BOLD.
    ACCEPT O-SHIPTO LINE 3 COLUMN 41 ACC-NUM.
    PERFORM DSP-ERS DISPLAY O-SHIPTO LINE 3 COLUMN 41 CONVERSION CHK-KPF.
    IF O-SHIPTO=0
      ACCEPT O-NAME LINE 4 COLUMN 41 ACC-ALP CHK-KPF
      ACCEPT O-ADD1 LINE 5 COLUMN 41 ACC-ALP CHK-KPF
      ACCEPT O-ADD2 LINE 6 COLUMN 41 ACC-ALP CHK-KPF
      ACCEPT O-POST LINE 7 COLUMN 41 ACC-ALP CHK-KPF
     ELSE PERFORM OR-RD-SHIPTO IF A-S1=1 GO OR433.
    ACCEPT O-CUSORD LINE 9 COLUMN 22 ACC-ALP CHK-KPF.
    MOVE O-DATE-REQ TO D-DATE MOVE 9 TO IXT MOVE 48 TO IXU.
    MOVE 1 TO D-PF PERFORM AX-DT-DEF CHK-KPF MOVE DATE0 TO O-DATE-REQ.
    ACCEPT O-TERMS LINE 9 COLUMN 66 ACC-ALP CHK-KPF.
    ACCEPT O-FOB LINE 10 COLUMN 7 ACC-ALP CHK-KPF.
    MOVE C-VIA TO O-VIA DISPLAY O-VIA LINE 10 COLUMN 37 CONVERSION.
    ACCEPT O-VIA LINE 10 COLUMN 37 ACC-NUM.
    DISPLAY O-VIA LINE 10 COLUMN 37 CONVERSION CHK-KPF.
OR461. DISPLAY "SHIPPING CHARGES: 'P' OR '*' FOR PREPAID, 'C' OR BLANK FOR COLLECT" LINE 24 BOLD.
    ACCEPT O-PPD LINE 10 COLUMN 53 ACC-ALP.
    PERFORM DSP-ERS CHK-KPF PERFORM OR-CHK-PPD IF A-S1=1 GO OR461.
OR463. DISPLAY "DUTY & BROKERAGE CHARGES: 'E' FOR EXPORTER, 'B' FOR BUYER" LINE 24 BOLD.
    ACCEPT O-PAYER LINE 10 COLUMN 70 ACC-ALP.
    PERFORM DSP-ERS CHK-KPF PERFORM OR-CHK-PAYER IF A-S1=1 GO OR463.
    MOVE 29 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      ACCEPT O-TEXT(IX1) LINE 12 COLUMN IXU ACC-NUM
      DISPLAY O-TEXT(IX1) LINE 12 COLUMN IXU CONVERSION CHK-KPF
      ADD 4 TO IXU END-PERFORM.
    ACCEPT O-SALCONT LINE 12 COLUMN 64 ACC-ALP CHK-KPF.
    MOVE 1 TO IX1 MOVE 13 TO IXT PERFORM UNTIL IX1>2
      ACCEPT O-PLINE(IX1) LINE IXT COLUMN 24 ACC-ALP CHK-KPF
      ADD 1 TO IX1 IXT END-PERFORM.
    ACCEPT O-FRATE LINE 16 COLUMN 16 ACC-NUM.
    DISPLAY O-FRATE LINE 16 COLUMN 16 CONVERSION CHK-KPF.
    ACCEPT O-FLOT LINE 16 COLUMN 41 ACC-NUM.
    DISPLAY O-FLOT LINE 16 COLUMN 41 CONVERSION CHK-KPF.
OR48. WRITE O-RECORD ALLOWING NO UNLOCK SAORD MOVE 0 TO OR-LINE.
OR49.
    REPLACE OFF.

OR5. PERFORM RD17 PERFORM WRT COMPUTE OR-NL=OR-LINE + 1.
    DISPLAY O-NO LINE 1 COLUMN 12 CONVERSION OR-NL COLUMN 26 CONVERSION.
    MOVE O-CUS TO A-A1 PERFORM RD-CUS.
    DISPLAY C-NO LINE 1 COLUMN 40 C-NAME COLUMN 48.
OR51. PERFORM INIT-L DISPLAY "PF4 TO END THIS ORDER" LINE 24 BOLD.
    ACCEPT L-PROD LINE 4 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR L-PROD=ALL "9" GO OR59.
    IF OR-LINE=98 MOVE "ORDERS CANNOT HAVE MORE THAN 98 LINES"
      TO ERR-MESG PERFORM DSP-ERR GO OR51.
    MOVE L-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO OR51.
    IF P-INACTIVE=1 MOVE "THIS PRODUCT IS INACTIVE" TO ERR-MESG PERFORM DSP-ERR GO OR51.
    ADD 1 TO OR-LINE MOVE O-NO TO L-ORD MOVE OR-LINE TO L-LINE.
    MOVE P-PRICE1 TO OR-PRICE1 MOVE P-PRICE2 TO OR-PRICE2.
    PERFORM RD-GEN PERFORM PROD-DESC PERFORM OR-DESC.
    IF O-BLANKET=0 ACCEPT L-QTY LINE 4 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      MOVE L-QTY TO L-QTY-LEFT
     ELSE MOVE LIT-Q9 TO L-QTY DISPLAY LIT-BL LINE 4 COLUMN 16.
OR53. IF ITOOL OR INUT PERFORM OR-MSG1
       ACCEPT L-PRICE LINE 4 COLUMN 27 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS
       IF KPF1 MOVE OR-PRICE1 TO L-PRICE END-IF IF KPF2 MOVE OR-PRICE2 TO L-PRICE END-IF
     ELSE MOVE 0 TO OR-KMOD PERFORM OR-RD-PRICE IF A-S1=1 GO OR588 END-IF
       DISPLAY L-PRICE LINE 4 COLUMN 27 CONVERSION
       ACCEPT L-PRICE LINE 4 COLUMN 27 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY L-PRICE LINE 4 COLUMN 27 CONVERSION.
OR55. DISPLAY "PRICE MODE - 'C', 'M', 'EA', 'FT'" LINE 24 BOLD.
    ACCEPT L-MODE LINE 4 COLUMN 37 DEFAULT "M" UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    PERFORM OR-CHK-MODE IF A-S1=1 GO OR55.
    PERFORM OR-CHK-PRICE IF A-S1=1 DISPLAY "  " LINE 4 COLUMN 37 GO OR53.
    ACCEPT L-DISC LINE 4 COLUMN 43 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT L-PLATING LINE 4 COLUMN 51 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY "AMOUNT REQUIRED ONLY FOR 'ADJUSTMENT' LINE" LINE 24 BOLD.
    ACCEPT L-EXTA LINE 4 COLUMN 57 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF L-EXTA NOT=0 MOVE 1 TO L-ADJ.
    DISPLAY "CUSTOMER PART NO.: _________________________" LINE 7 COLUMN 36 BOLD.
    ACCEPT L-CUSPART LINE 7 COLUMN 55 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF CAU-IND=1 DISPLAY "MODEL YEAR: __" LINE 8 COLUMN 53 BOLD
      ACCEPT L-MODYR LINE 8 COLUMN 65 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY "CONTAINER CODE: _" LINE 9 COLUMN 45 BOLD.
    DISPLAY "'P', 'T', ETC. IF SHIPPED IN SPECIAL CONTAINERS, ELSE BLANK" LINE 24 BOLD.
    ACCEPT L-CONT LINE 9 COLUMN 61 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF O-SPECIAL=1 MOVE C-SUR TO L-SUR
      DISPLAY "SURCHARGE CODE:" LINE 10 COLUMN 50 BOLD L-SUR COLUMN 66 CONVERSION
      DISPLAY "ENTER SURCHARGE CODE (0 - 9) USED IN ORIGINAL ORDER" LINE 24 BOLD
      ACCEPT L-SUR LINE 10 COLUMN 66 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSP-ERS
      DISPLAY L-SUR LINE 10 COLUMN 66 CONVERSION PERFORM OR-DSP-SUR.
    MOVE "'CAN' TO CANCEL THIS LINE: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" GO OR588.
    MOVE O-DATE-REQ TO L-DATE-REQ MOVE O-TER TO L-TER MOVE O-CUS TO L-CUS.
    MOVE O-SPECIAL TO L-SPECIAL MOVE P-CAT TO L-CAT.
    MOVE P-NUT TO L-NUT IF GEN-NUT>" " MOVE GEN-NUT TO L-NUT.
    WRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    MOVE OR-LINE TO O-LINES REWRITE O-RECORD ALLOWING NO UNLOCK SAORD.
    PERFORM ADD-DEM REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    IF L-NUT>" " DISPLAY "DO NOT ADD A LINE FOR THE NUT - NUT DATA WAS ADDED AUTOMATICALLY" LINE 24 BOLD
      ACCEPT XA1 COLUMN 66 PROTECTED AUTOTERMINATE PERFORM DSP-ERS.
    GO OR5.
OR588. SUBTRACT 1 FROM OR-LINE GO OR5.
OR59. MOVE "'CAN' TO CANCEL ENTIRE ORDER: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" PERFORM DEL-ORDER
      ELSE MOVE 1 TO O-ACK REWRITE O-RECORD ALLOWING NO UNLOCK SAORD
        PERFORM OR-ADDACK MOVE O-NO TO OR-PREV-NO.
    GO OR3.

    REPLACE ==CHK-KPF== BY ==IF KPF1 GO OR63 ELSE IF KPF3 GO OR66 END-IF END-IF==
            ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY==.
OR6. DISPLAY "MODIFY" LINE 1 COLUMN 20 BOLD.
    MOVE "'L' TO MODIFY LINES ONLY: _" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="L" GO OR68.
OR63. MOVE O-DATE TO D-DATE MOVE 1 TO IXT MOVE 59 TO IXU.
    MOVE 1 TO D-PF PERFORM AX-DT-DEF CHK-KPF MOVE DATE0 TO O-DATE.
    PERFORM OR-AX-SAL CHK-KPF.
OR643. ACCEPT O-SHIPTO LINE 3 COLUMN 41 ACC-NUM.
    DISPLAY O-SHIPTO LINE 3 COLUMN 41 CONVERSION CHK-KPF.
    IF O-SHIPTO=0
      ACCEPT O-NAME LINE 4 COLUMN 41 ACC-ALP CHK-KPF
      ACCEPT O-ADD1 LINE 5 COLUMN 41 ACC-ALP CHK-KPF
      ACCEPT O-ADD2 LINE 6 COLUMN 41 ACC-ALP CHK-KPF
      ACCEPT O-POST LINE 7 COLUMN 41 ACC-ALP CHK-KPF
     ELSE PERFORM OR-RD-SHIPTO IF A-S1=1 GO OR643.
    ACCEPT O-CUSORD LINE 9 COLUMN 22 ACC-ALP CHK-KPF.
    MOVE O-DATE-REQ TO OR-ODATE-REQ D-DATE MOVE 9 TO IXT MOVE 48 TO IXU.
    MOVE 1 TO D-PF PERFORM AX-DT-DEF CHK-KPF MOVE DATE0 TO O-DATE-REQ.
    ACCEPT O-TERMS LINE 9 COLUMN 66 ACC-ALP CHK-KPF.
    ACCEPT O-FOB LINE 10 COLUMN 7 ACC-ALP CHK-KPF.
    MOVE O-VIA TO OR-OVIA.
    ACCEPT O-VIA LINE 10 COLUMN 37 ACC-NUM.
    DISPLAY O-VIA LINE 10 COLUMN 37 CONVERSION CHK-KPF.
OR651. ACCEPT O-PPD LINE 10 COLUMN 53 ACC-ALP CHK-KPF.
    PERFORM OR-CHK-PPD IF A-S1=1 GO OR651.
OR653. ACCEPT O-PAYER LINE 10 COLUMN 70 ACC-ALP CHK-KPF.
    PERFORM OR-CHK-PAYER IF A-S1=1 GO OR653.
    MOVE 29 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      ACCEPT O-TEXT(IX1) LINE 12 COLUMN IXU ACC-NUM
      DISPLAY O-TEXT(IX1) LINE 12 COLUMN IXU CONVERSION CHK-KPF
      ADD 4 TO IXU END-PERFORM.
    ACCEPT O-SALCONT LINE 12 COLUMN 64 ACC-ALP CHK-KPF.
    MOVE 1 TO IX1 MOVE 13 TO IXT PERFORM UNTIL IX1>2
      ACCEPT O-PLINE(IX1) LINE IXT COLUMN 24 ACC-ALP CHK-KPF
      ADD 1 TO IX1 IXT END-PERFORM.
    ACCEPT O-FRATE LINE 16 COLUMN 16 ACC-NUM.
    DISPLAY O-FRATE LINE 16 COLUMN 16 CONVERSION CHK-KPF.
    ACCEPT O-FLOT LINE 16 COLUMN 41 ACC-NUM.
    DISPLAY O-FLOT LINE 16 COLUMN 41 CONVERSION CHK-KPF.
    REPLACE OFF.

OR66. IF OR-KSHP=0 GO OR670.
    IF NOT(O-VIA NOT=OR-OVIA OR O-BLANKET=0 AND O-DATE-REQ NOT=OR-ODATE-REQ) GO OR666.
    OPEN I-O SHIPORD ALLOWING ALL MOVE O-NO TO HO-ORD MOVE 0 TO HO-SEQ.
    START SHIPORD KEY>=HO-KEY REGARDLESS INVALID GO OR664.
OR663. READ SHIPORD NEXT REGARDLESS END GO OR664. IF HO-ORD NOT=O-NO GO OR664.
    IF O-VIA NOT=OR-OVIA MOVE O-VIA TO HO-VIA.
    IF O-BLANKET=0 AND O-DATE-REQ NOT=OR-ODATE-REQ MOVE O-DATE-REQ TO HO-DATE-REQ.
    REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD GO OR663.
OR664. CLOSE SHIPORD.
OR666. IF NOT(O-BLANKET=0 AND O-DATE-REQ NOT=OR-ODATE-REQ) GO OR669.
    OPEN I-O SHIPLIN ALLOWING ALL MOVE O-NO TO HO-ORD MOVE 0 TO HO-SEQ.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO OR668.
OR667. READ SHIPLIN NEXT REGARDLESS END GO OR668. IF HL-ORDSEQ NOT=HO-ORDSEQ GO OR668.
    MOVE O-DATE-REQ TO HL-DATE-REQ.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO OR667.
OR668. CLOSE SHIPLIN.
OR669.

OR670. IF O-DATE-REQ=OR-ODATE-REQ GO OR674. COMPUTE L-NO=100 * O-NO.
OR673. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO OR674.
    MOVE O-DATE-REQ TO L-DATE-REQ.
    REWRITE L-RECORD ALLOWING NO UNLOCK SALIN GO OR673.
OR674.

OR68. DISPLAY "'Y' TO PRINT A MODIFIED ORDER ACKNOWLEDGEMENT: _" LINE 24 BOLD.
    ACCEPT XA1 LINE 24 COLUMN 48 DEFAULT "Y" UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA1="Y" MOVE 2 TO O-ACK. REWRITE O-RECORD ALLOWING NO UNLOCK SAORD.
    COMPUTE L-NO=100 * O-NO.
OR7. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO OR79.
    PERFORM RD18 PERFORM WRT.
    DISPLAY O-NO LINE 1 COLUMN 19 CONVERSION L-LINE COLUMN 33 CONVERSION C-NAME COLUMN 47.
    DISPLAY L-PROD LINE 4 MOVE L-PROD TO A-A1 PERFORM PROD-RGD PERFORM OR-DESC.
    IF O-BLANKET=1 DISPLAY LIT-BL LINE 4 COLUMN 16
      ELSE DISPLAY L-QTY LINE 4 COLUMN 15 CONVERSION.
    DISPLAY L-PRICE LINE 4 COLUMN 27 CONVERSION L-MODE COLUMN 37
      L-DISC COLUMN 43 CONVERSION L-PLATING COLUMN 51 CONVERSION L-EXTA COLUMN 57 CONVERSION.
    DISPLAY "CUSTOMER PART NO.: " LINE 7 COLUMN 36 BOLD L-CUSPART COLUMN 55.
    IF O-BLANKET=1
      DISPLAY "QTY CUM. YTD:" LINE 8 COLUMN 51 BOLD L-QTY-LEFT COLUMN 65 CONVERSION.
    IF CAU-IND=1
      DISPLAY "RETURNABLE CONTAINER ID:" LINE 9 COLUMN 40 BOLD L-RC COLUMN 65
      DISPLAY "MODEL YEAR:" LINE 10 COLUMN 53 BOLD L-MODYR COLUMN 65 CONVERSION.
    DISPLAY "CONTAINER CODE:" LINE 11 COLUMN 45 BOLD L-CONT COLUMN 61.
    IF O-SPECIAL=1
      DISPLAY "SURCHARGE CODE:" LINE 12 COLUMN 50 BOLD L-SUR COLUMN 66 CONVERSION
      PERFORM OR-DSP-SUR.
OR73. DISPLAY "'RETURN' FOR NEXT LINE, 'E' TO END ORDER," LINE 23 BOLD.
    IF OR-KSHP=0 MOVE "  OR 'M' TO MODIFY LINE, 'CAN' TO CANCEL LINE: ___" TO TMSG
      ELSE MOVE "  OR 'M' TO MODIFY LINE: _" TO TMSG.
    PERFORM DSP-PROMPT DISPLAY " " LINE 23 ERASE LINE.
    IF XA3="M" AND O-BLANKET=0 AND L-QTY-LEFT=0
      MOVE "THIS LINE WAS SHIPPED OR CANCELED" TO ERR-MESG PERFORM DSP-ERR GO OR73.
    IF XA3="E" GO OR79. IF XA3="M" GO OR74.
    IF XA3="CAN" PERFORM SUB-DEM REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT
      MOVE 0 TO L-QTY L-QTY-THIS L-QTY-LEFT GO OR78.
    GO OR7.

    REPLACE ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION==.
OR74.
OR743. IF OR-KSHP=0 ACCEPT L-PROD LINE 4 COLUMN 1 ACC-ALP.
    MOVE L-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO OR743.
    MOVE P-PRICE1 TO OR-PRICE1 MOVE P-PRICE2 TO OR-PRICE2.
    PERFORM RD-GEN PERFORM PROD-DESC PERFORM OR-DESC PERFORM SUB-DEM.
    IF NOT(OR-KSHP=0 AND O-BLANKET=0) GO OR76. MOVE L-QTY TO OR-QTY.
OR75. ACCEPT OR-QTY LINE 4 COLUMN 15 ACC-NUM.
    DISPLAY OR-QTY LINE 4 COLUMN 15 CONVERSION IF OR-QTY=L-QTY GO OR76.
    COMPUTE WN1=L-QTY-LEFT - L-QTY + OR-QTY.
    IF WN1<0 MOVE "CANNOT REDUCE QUANTITY BELOW QUANTITY ALREADY SHIPPED"
      TO ERR-MESG PERFORM DSP-ERR GO OR75.
    MOVE OR-QTY TO L-QTY MOVE WN1 TO L-QTY-LEFT.
OR76. PERFORM ADD-DEM REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
OR77. IF ITOOL OR INUT PERFORM OR-MSG1 ACCEPT L-PRICE LINE 4 COLUMN 27 ACC-NUM KEY CKEY PERFORM DSP-ERS
       IF KPF1 MOVE OR-PRICE1 TO L-PRICE END-IF IF KPF2 MOVE OR-PRICE2 TO L-PRICE END-IF
     ELSE MOVE 1 TO OR-KMOD PERFORM OR-RD-PRICE IF A-S1=1 GO OR73 END-IF
       PERFORM OR-MSG2 ACCEPT L-PRICE LINE 4 COLUMN 27 ACC-NUM KEY CKEY PERFORM DSP-ERS
       IF KPF1 MOVE IO-PRICE TO L-PRICE.
    DISPLAY L-PRICE LINE 4 COLUMN 27 CONVERSION.
OR775. ACCEPT L-MODE LINE 4 COLUMN 37 ACC-ALP.
    PERFORM OR-CHK-MODE IF A-S1=1 PERFORM DSP-ERR2 GO OR775.
    PERFORM OR-CHK-PRICE IF A-S1=1 GO OR77.
    ACCEPT L-DISC LINE 4 COLUMN 43 ACC-NUM.
    DISPLAY L-DISC LINE 4 COLUMN 43 CONVERSION.
    ACCEPT L-PLATING LINE 4 COLUMN 51 ACC-NUM.
    DISPLAY L-PLATING LINE 4 COLUMN 51 CONVERSION.
    ACCEPT L-EXTA LINE 4 COLUMN 57 ACC-NUM.
    DISPLAY L-EXTA LINE 4 COLUMN 57 CONVERSION.
    IF L-EXTA=0 MOVE 0 TO L-ADJ ELSE MOVE 1 TO L-ADJ.
    ACCEPT L-CUSPART LINE 7 COLUMN 55 ACC-ALP.
    IF O-BLANKET=1 ACCEPT L-QTY-LEFT LINE 8 COLUMN 65 ACC-NUM
      DISPLAY L-QTY-LEFT LINE 8 COLUMN 65 CONVERSION.
    IF CAU-IND=1 ACCEPT L-RC LINE 9 COLUMN 65 ACC-ALP
      ACCEPT L-MODYR LINE 10 COLUMN 65 ACC-NUM
      DISPLAY L-MODYR LINE 10 COLUMN 65 CONVERSION.
    ACCEPT L-CONT LINE 11 COLUMN 61 ACC-ALP.
    IF O-SPECIAL=1 ACCEPT L-SUR LINE 12 COLUMN 66 ACC-NUM
      DISPLAY L-SUR LINE 12 COLUMN 66 CONVERSION PERFORM OR-DSP-SUR.
    MOVE P-NUT TO L-NUT IF GEN-NUT>" " MOVE GEN-NUT TO L-NUT.
    MOVE 0 TO L-WEIGHT-NUT.
    REPLACE OFF.
OR78. REWRITE L-RECORD ALLOWING NO UNLOCK SALIN GO OR7.
OR79. IF O-ACK=2 PERFORM OR-ADDACK. MOVE O-NO TO OR-PREV-NO GO OR3.
OR9. CLOSE ACKORD ACKLIN GO MN9.

OR-MSG1. DISPLAY "PF1,PF2 FOR PRICE 1,2 - OR ENTER PRICE" LINE 24 BOLD.
OR-MSG2. DISPLAY "PF1 FOR THE PRICE IN PRICE TABLE" LINE 24 BOLD.
OR-CHK-PPD. IF O-PPD="P" OR "*" OR "C" OR " " MOVE 0 TO A-S1
      ELSE PERFORM DSP-ERR2 MOVE 1 TO A-S1.
OR-CHK-PAYER. IF O-PAYER="E" OR "B" MOVE 0 TO A-S1 ELSE PERFORM DSP-ERR2 MOVE 1 TO A-S1.
OR-CHK-MODE. IF L-MODE="C" OR "M" OR "EA" OR "FT" MOVE 0 TO A-S1 ELSE MOVE 1 TO A-S1.
OR-CHK-PRICE. MOVE 0 TO A-S1 MOVE L-QTY TO CL-QTY PERFORM LPRICE-CALC.
    IF CL-AMT>2.00 * CL-QTY * P-WEIGHT / 100
      MOVE "EXCESSIVE REVENUE PER POUND - CHECK SELLING PRICE"
        TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" MOVE 1 TO A-S1.
OR-RD-PRICE. PERFORM OR-RP1 THRU OR-RP9.
OR-RP1. IF P-CHGPR=1 MOVE 0 TO L-PRICE GO OR-RP8.
    MOVE 1 TO A-S1 MOVE O-CUS TO IO-CUS MOVE L-PROD TO IO-PROD.
    READ PRICE REGARDLESS INVALID PERFORM DSP-ERR45 GO OR-RP9.
    IF IO-PRICE=0 PERFORM DSP-ERR45 GO OR-RP9.
    IF OR-KMOD=0 MOVE IO-PRICE TO L-PRICE.
OR-RP8. MOVE 0 TO A-S1.
OR-RP9. EXIT.
OR-RD-SHIPTO. PERFORM OR-RS1 THRU OR-RS9.
OR-RS1. MOVE 0 TO A-S1 MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID PERFORM DSP-ERR4 MOVE 1 TO A-S1 GO OR-RS9.
    PERFORM GET-O-CUSADD DISPLAY O-NAME LINE 4 COLUMN 41
      O-ADD1 LINE 5 COLUMN 41 O-ADD2 LINE 6 COLUMN 41 O-POST LINE 7 COLUMN 41.
OR-RS9. EXIT.
OR-AX-SAL. PERFORM OR-AS1 THRU OR-AS9.
OR-AS1. ACCEPT O-SAL LINE 2 COLUMN 61 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    DISPLAY O-SAL LINE 2 COLUMN 61 CONVERSION IF KPF1 OR KPF3 GO OR-AS9.
    ACCEPT O-SALCOM LINE 2 COLUMN 75 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    DISPLAY O-SALCOM LINE 2 COLUMN 75 CONVERSION.
OR-AS9. EXIT.
OR-DESC. MOVE 1 TO OR-IX1 MOVE 6 TO IXT.
    PERFORM UNTIL OR-IX1>5 OR PRO-DESC(OR-IX1)=" "
      DISPLAY PRO-DESC(OR-IX1) LINE IXT ADD 1 TO OR-IX1 IXT END-PERFORM.
OR-DSP-SUR. IF L-SUR>0 DISPLAY IF-SURCH(L-SUR) COLUMN 69 CONVERSION.
OR-DSP-ORD. PERFORM OR-DS1 THRU OR-DS9.
OR-DS1. MOVE O-CUS TO A-A1 PERFORM RD-CUS PERFORM CHK-CUSTYPE.
    MOVE O-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 1 COLUMN 59.
    DISPLAY O-CUS LINE 2 COLUMN 41 O-SAL COLUMN 61 CONVERSION O-SALCOM COLUMN 75 CONVERSION.
    DISPLAY LIT-NY(O-SPECIAL + 1:1) LINE 2 COLUMN 17.
    DISPLAY LIT-NY(O-BLANKET + 1:1) LINE 3 COLUMN 17.
    DISPLAY C-NAME LINE 4 C-ADD1 LINE 5 C-ADD2 LINE 6 C-POST LINE 7.
    DISPLAY O-SHIPTO LINE 3 COLUMN 41 CONVERSION.
    IF O-SHIPTO=0 GO OR-DS4. MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO OR-DS4. PERFORM GET-O-CUSADD.
OR-DS4. DISPLAY O-NAME LINE 4 COLUMN 41 O-ADD1 LINE 5 COLUMN 41
      O-ADD2 LINE 6 COLUMN 41 O-POST LINE 7 COLUMN 41.
    DISPLAY O-CUSORD LINE 9 COLUMN 22.
    MOVE O-DATE-REQ TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 9 COLUMN 48.
    DISPLAY O-TERMS LINE 9 COLUMN 66 O-FOB LINE 10 COLUMN 7.
    DISPLAY O-VIA LINE 10 COLUMN 37 CONVERSION O-PPD COLUMN 53 O-PAYER COLUMN 70.
    MOVE 29 TO IXU PERFORM VARYING OR-IX1 FROM 1 BY 1 UNTIL OR-IX1>4
      DISPLAY O-TEXT(OR-IX1) LINE 12 COLUMN IXU CONVERSION
      ADD 4 TO IXU END-PERFORM.
    DISPLAY O-SALCONT LINE 12 COLUMN 64.
    MOVE 1 TO OR-IX1 MOVE 13 TO IXT PERFORM UNTIL OR-IX1>2
      DISPLAY O-PLINE(OR-IX1) LINE IXT COLUMN 24
      ADD 1 TO OR-IX1 IXT END-PERFORM.
    DISPLAY O-FRATE LINE 16 COLUMN 16 CONVERSION O-FLOT COLUMN 41 CONVERSION.
OR-DS9. EXIT.
OR-ADDACK. PERFORM OR-A1 THRU OR-A9.
OR-A1. MOVE O-NO TO AKO-NO READ ACKORD REGARDLESS INVALID GO OR-A4.
    DELETE ACKORD COMPUTE AKL-NO=100 * AKO-NO.
OR-A3. ADD 1 TO AKL-LINE READ ACKLIN REGARDLESS INVALID GO OR-A4.
    DELETE ACKLIN GO OR-A3.
OR-A4. WRITE AKO-RECORD FROM O-RECORD ALLOWING NO UNLOCK ACKORD.
    COMPUTE L-NO=100 * O-NO.
OR-A5. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO OR-A6.
    WRITE AKL-RECORD FROM L-RECORD ALLOWING NO UNLOCK ACKLIN GO OR-A5.
OR-A6.
OR-A9. EXIT.

* G-6 PRINT A FILE
WF1. PERFORM RD83 PERFORM WRT.
    MOVE USN-USER TO US-USER READ USERS REGARDLESS INVALID GO WF9.
    MOVE US-PR-FILE TO WF-FILE MOVE US-PR-NO TO WF-NO MOVE US-PR-EXT TO WF-EXT.
    MOVE US-PR-QUEUE TO WF-QUEUE.

    DISPLAY WF-FILE LINE 4 COLUMN 11 WF-NO COLUMN 23 CONVERSION WF-EXT COLUMN 31.
    DISPLAY WF-QUEUE LINE 6 COLUMN 9.
    ACCEPT WF-FILE LINE 4 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT WF-NO LINE 4 COLUMN 23 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY WF-NO LINE 4 COLUMN 23 CONVERSION.
    ACCEPT WF-EXT LINE 4 COLUMN 31 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT WF-QUEUE LINE 6 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.

    MOVE " " TO WA1 WA2 WA3.
    IF WF-NO>0 MOVE WF-NO TO WA2(1:2).
    IF WF-QUEUE>" " STRING " /QUEUE=" DELIMITED SIZE WF-QUEUE DELIMITED " " INTO WA3.
    STRING "PRINT " DELIMITED SIZE WF-FILE WA2 "." WF-EXT DELIMITED " "
      WA3 DELIMITED SIZE INTO WA1.
    MOVE 7 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE WA1 TO A-A1 PERFORM AUTO-PRINT.

    MOVE USN-USER TO US-USER READ USERS REGARDLESS INVALID GO WF9.
    MOVE WF-FILE TO US-PR-FILE MOVE WF-NO TO US-PR-NO MOVE WF-EXT TO US-PR-EXT.
    MOVE WF-QUEUE TO US-PR-QUEUE.
    REWRITE US-RECORD ALLOWING NO UNLOCK USERS.
WF9. GO MN9.

* G-7 PRODUCTION ORDER ENTRY
TO1. PERFORM OPEN-AUDIT.
TO3. PERFORM RD106 PERFORM WRT INITIALIZE TD-INP-R7 PERFORM INIT-R.
    ACCEPT R-NO LINE 3 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO TO9. IF R-NO<=9999 PERFORM DSP-ERR11 GO TO3.
    MOVE R-NO TO IE71.
    ACCEPT IE72 LINE 3 COLUMN 44 DEFAULT " " UNDERLINED PROTECTED.
    READ PRODORD REGARDLESS INVALID
      IF IE72="YES" PERFORM DSP-ERR11 GO TO3 ELSE GO TO4 END-IF.
    IF IE72 NOT="YES" PERFORM DSP-ERR31 GO TO3.
    MOVE R-QTY-ORD TO TO-QTY-ORD.
TO4. ACCEPT P-NO LINE 5 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED.
    IF P-NO=" " AND IE72="YES" GO TO6. MOVE P-NO TO R-PROD IE73.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TO3.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 5 COLUMN 31.
TO6. ACCEPT IE74 LINE 7 COLUMN 24 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ADD IE74 TO R-QTY-ORD PERFORM CALC-QLEFT.
    MOVE R-DATE TO D-DATE MOVE 8 TO IXT MOVE 24 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO R-DATE IE76.
    REPLACE ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
    ACCEPT R-SPORD LINE 10 COLUMN 41 ACC-NUM.
    ACCEPT R-SPLINE LINE 10 COLUMN 60 ACC-NUM.
    ACCEPT R-QTY-ORD LINE 12 COLUMN 22 ACC-NUM.
    ACCEPT R-QTY-PROD LINE 12 COLUMN 46 ACC-NUM.
    ACCEPT R-QTY-REC LINE 12 COLUMN 70 ACC-NUM.
    REPLACE OFF.
    MOVE R-SPORD TO IE77 MOVE R-SPLINE TO IE78.
    MOVE R-QTY-ORD TO IE79(1) MOVE R-QTY-PROD TO IE79(2) MOVE R-QTY-REC TO IE79(3).
    PERFORM CALC-QLEFT MOVE R-QTY-ORD TO R-ORIG-ORD MOVE SYS-DATE TO R-LAST-DATE.
    IF IE72="YES" IF R-QTY-ORD NOT=TO-QTY-ORD MOVE 2 TO R-TICKET END-IF
      REWRITE R-RECORD ALLOWING NO
     ELSE MOVE 1 TO R-TICKET WRITE R-RECORD ALLOWING NO. UNLOCK PRODORD.
    MOVE TD-INP-R7 TO AU-DATA MOVE 7 TO AU-K PERFORM ADD-AUD GO TO3.
TO9. CLOSE AUDIT GO MN9.

* G-8 PRODUCTION ORDER INFORMATION
RI1. PERFORM RD21 PERFORM WRT.
RI3. ACCEPT R-NO LINE 15 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO RI9.
    READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO RI3.
    PERFORM RD21 MOVE R-NO TO TF301(3).
    MOVE R-FIN TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO TF302(3).
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF303(3).
    MOVE R-TICKET TO TF296(5).
    IF R-SPORD NOT=0 MOVE R-SPORD TO TF297(5) MOVE "-" TO TF298(5) MOVE R-SPLINE TO TF299(5).
    IF R-ALLOC=0 MOVE "NO" TO TF300(5). IF R-ALLOC=1 MOVE "YES" TO TF300(5).
    IF R-ALLOC=2 MOVE "FINAL" TO TF300(5).
    MOVE R-PROD TO TF292(7) A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO TF293(7).
    MOVE R-QTY-ORD TO TF294(9) MOVE R-QTY-PROD TO TF294(10).
    MOVE R-QTY-REC TO TF294(11) MOVE R-QTY-LEFT TO TF294(12).
    MOVE 1 TO IX1 MOVE 9 TO IXT PERFORM UNTIL IX1>3
      MOVE R-LDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO TF295(IXT)
      ADD 1 TO IX1 IXT END-PERFORM.
    PERFORM WRT GO RI3.
RI9. GO MN9.

* G-9 SHOW PRODUCTION ORDERS BY PRODUCT
ON1. PERFORM RD22 MOVE " " TO P-NO MOVE 1 TO ON-KALL MOVE 3 TO IXT.
ON3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
ON33. DISPLAY "NEXT PRODUCT NO. ____________         INCLUDE ORDERS WITH NO QTY LEFT ? _" LINE IXT.
    ACCEPT IA13 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA13=ALL "9" GO ON9.
    MOVE 73 TO IXU MOVE ON-KALL TO A-S1 PERFORM AX-NY MOVE A-S1 TO ON-KALL.
    IF IA13=" " IF P-NO=" " GO ON33 ELSE GO ON4. MOVE IA13 TO P-NO.
    PERFORM SET-SHORT-SCHED.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO ON33.
    READ PRODUCT NEXT REGARDLESS PERFORM RD-GEN PERFORM PROD-DESC.
    MOVE P-NO TO R-PROD MOVE 0 TO R-DATE INQ-IND.
ON4. PERFORM RD22 MOVE P-NO TO TF61(1) MOVE PRO-DESC(1) TO TF62(1).
    MOVE 4 TO IXT IF INQ-IND=0 START PRODORD KEY>R-KP REGARDLESS INVALID GO ON8.
ON5. READ PRODORD NEXT REGARDLESS END GO ON8. IF R-PROD NOT=P-NO GO ON8.
    IF ON-KALL=0 AND R-QTY-LEFT<=0 GO ON5.
    PERFORM CLR-LN MOVE R-NO TO TF56(IXT).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL XM-F6(IX1)=0
      IF R-NO=XM-F8(IX1) MOVE "*" TO TF56A(IXT) GO ON54 END-IF END-PERFORM.
ON54. MOVE R-QTY-ORD TO TF57(IXT) MOVE R-QTY-PROD TO TF57A(IXT).
    MOVE R-QTY-LEFT TO TF58(IXT).
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF59(IXT).
    IF R-LDATE(1)>0 MOVE R-LDATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO TF60(IXT).
    ADD 1 TO IXT IF IXT<22 GO ON5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO ON89.
ON8. MOVE "*** END ***" TO TLN(IXT).
    IF GEN-IND=1 MOVE GEN-ALT TO P-NO READ PRODUCT REGARDLESS.
    READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO ON89.
    PERFORM RD-GEN PERFORM PROD-DESC.
    MOVE P-NO TO R-PROD MOVE 0 TO R-DATE INQ-IND.
ON89. GO ON3.
ON9. GO MN9.

* G-10 SHOW BIN CONTENTS
BC1. PERFORM RD23 PERFORM WRT.
BC3. ACCEPT B-NO LINE 13 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR B-NO=ALL "9" GO BC9.
    READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO BC3.
    PERFORM RD23 MOVE B-NO TO TF371(3).
    MOVE B-PROD TO TF371(4) A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO TF375(4).
    MOVE B-LOT TO TF372(5) MOVE B-CONT TO TF371A(6).
    IF B-CONT="Q" MOVE B-QREASON TO TF371B(6).
    MOVE B-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF374(7).
    MOVE B-QTY TO TF373(8) MOVE B-QTY-AL TO TF373(9) MOVE B-QTY-PACK TO TF373(10).
    PERFORM WRT GO BC3.
BC9. GO MN9.

* G-11 SHOW PRODUCT LOCATION
QF1. PERFORM RD24 MOVE " " TO P-NO MOVE 3 TO IXT.
QF3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
QF33. DISPLAY "NEXT PRODUCT NO. ____________" LINE IXT.
    ACCEPT IA14 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA14=ALL "9" GO QF9.
    IF IA14=" " IF P-NO=" " GO QF33 ELSE GO QF4. MOVE IA14 TO P-NO.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO QF33.
    READ PRODUCT NEXT REGARDLESS PERFORM RD-GEN PERFORM PROD-DESC.
    INITIALIZE B-KP MOVE P-NO TO B-PROD MOVE 0 TO WD1 INQ-IND.
QF4. PERFORM RD24 MOVE P-NO TO TF63(1) MOVE PRO-DESC(1) TO TF63A(1).
    MOVE 4 TO IXT IF INQ-IND=0 START BIN KEY>=B-KP REGARDLESS INVALID GO QF8.
QF5. READ BIN NEXT REGARDLESS END GO QF8. IF B-PROD NOT=P-NO GO QF8.
    PERFORM CLR-LN MOVE B-NO TO TF64(IXT) MOVE B-LOT TO TF64A(IXT).
    MOVE B-CONT TO TF64B(IXT) MOVE B-QTY TO TF65(IXT) ADD B-QTY TO WD1.
    MOVE B-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF66(IXT).
    MOVE B-QTY-AL TO TF67(IXT) MOVE B-QTY-PACK TO TF68(IXT).
    ADD 1 TO IXT IF IXT<22 GO QF5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO QF89.
QF8. MOVE "*** END ***" TO TLN(IXT) MOVE WD1 TO TF63B(2).
    IF GEN-IND=1 MOVE GEN-ALT TO P-NO READ PRODUCT REGARDLESS.
    READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO QF89.
    PERFORM RD-GEN PERFORM PROD-DESC.
    INITIALIZE B-KP MOVE P-NO TO B-PROD MOVE 0 TO WD1 INQ-IND.
QF89. GO QF3.
QF9. GO MN9.

* G-12 ORDER INFORMATION
OI1. PERFORM RD25 PERFORM WRT MOVE 0 TO O-NO.
OI3. ACCEPT IA8 LINE 23 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA8=99 GO OI9.
    ACCEPT IA9 LINE 23 COLUMN 32 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT IA10 LINE 23 COLUMN 68 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF IA10=0 GO OI4. MOVE IA10 TO O-NO.
    PERFORM RD25 READ SAORD REGARDLESS INVALID PERFORM DSP-ERR8 GO OI3.
    MOVE O-NO TO TF77(1) MOVE O-INVNO TO TF78(1) MOVE O-CUS TO C-NO TF79(1).
    READ CUSTOMER REGARDLESS INVALID GO OI36. MOVE C-NAME TO TF81(3).
    MOVE C-ADD1 TO TF81(4) MOVE C-ADD2 TO TF81(5) MOVE C-POST TO TF81(6).
OI36. MOVE O-NAME TO TF81(8) MOVE O-ADD1 TO TF81(9) MOVE O-ADD2 TO TF81(10).
    MOVE O-POST TO TF81(11) MOVE O-CUSORD TO TF82(3).
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF83(4).
    MOVE O-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TF83(5).
    MOVE O-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF83(6).
    IF O-PPD="P" OR "*" MOVE "PPD" TO TF87C(7) ELSE MOVE "COL" TO TF87C(7).
    IF O-PAYER="E" MOVE "EXPORTER" TO TF87D(7) ELSE MOVE "BUYER" TO TF87D(7).
    MOVE O-TERMS TO TF82(8) MOVE O-BL TO TF84(9) MOVE O-PALLETS TO TF87A(10).
    MOVE O-PACKS(1) TO TF87A(11) MOVE O-PACKS(2) TO TF87B(11).
    COMPUTE TF87A(12)=O-PACKS(3) + O-PACKS(4) + O-PACKS(5).
    COMPUTE TF87B(12)=O-PACKS(6) + O-PACKS(7) + O-PACKS(8) + O-PACKS(9).
    MOVE O-LINES TO TF84(13) MOVE O-FOB TO TF81(14) MOVE O-GST TO TF86(14).
    MOVE O-HST TO TF86(15) MOVE O-PST TO TF86(16) MOVE O-QST TO TF86(17).
    MOVE O-NON-SAL TO TF86(18) MOVE O-TOTAL TO TF86(19).
    MOVE O-NET TO TF87(20) MOVE O-GROSS TO TF87(21).
    MOVE O-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO TF81(13).
    MOVE 1 TO IX1 MOVE 16 TO IXT PERFORM UNTIL IX1>4
      IF O-TEXT(IX1) NOT=0 MOVE 3 TO T-TBL MOVE O-TEXT(IX1) TO T-NO
        PERFORM RD-TBL MOVE T-LINE TO TF81(IXT) END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
    PERFORM WRT GO OI3.
OI4. COMPUTE L-NO=100 * O-NO IF IA9>" " GO OI48.
    IF IA8 NOT=0 MOVE IA8 TO L-LINE ELSE MOVE 1 TO L-LINE.
    READ SALIN REGARDLESS INVALID MOVE "INVALID LINE NO."
      TO ERR-MESG PERFORM DSP-ERR GO OI3. GO OI6.
OI48.
OI53. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID MOVE "NO LINE FOR THIS PRODUCT"
       TO ERR-MESG PERFORM DSP-ERR GO OI3.
    IF L-PROD NOT=IA9 GO OI53.
OI6. PERFORM RD26 MOVE O-NO TO TF77(1) MOVE O-INVNO TO TF78(1) MOVE O-CUS TO TF79(1).
    MOVE L-LINE TO TF89(3) MOVE L-PROD TO TF88(4) A-A1 PERFORM PROD-RGD.
    MOVE 1 TO IX1 MOVE 4 TO IXT PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO TF91(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    MOVE L-CONT TO TF98(6) MOVE L-QTY-THIS TO CL-QTY PERFORM LPRICE-CALC.
    MOVE L-PRICE TO TF90(8) MOVE L-MODE TO TF88(9).
    IF L-QTY=LIT-Q9 MOVE LIT-BL TO TF92A(11) MOVE L-QTY-THIS TO TF92(12)
      MOVE L-QTY-LEFT TO TF92(14)
     ELSE MOVE L-QTY TO TF92(11) MOVE L-QTY-THIS TO TF92(12)
      MOVE L-QTY-LEFT TO TF92(13).
    MOVE L-DISC TO TF93(16) MOVE CL-DTXT TO TF94(16).
    PERFORM WEIGHT-CALC MOVE L-PLATING TO TF93(17).
    IF L-PLATING NOT=0 PERFORM PLATING-CALC
      MOVE T-PLS TO TF94(17) MOVE T-PLR TO TF95(17)
      MOVE CL-WEIGHT TO TF96(17) MOVE CL-D1 TO TF97(17).
    PERFORM SURCH-CALC.
    IF CL-D1 NOT=0 MOVE "STEEL SURCHARGE" TO TF94(18) MOVE CL-SURCH TO TF95(18)
      IF CL-KSM=0 MOVE CL-WEIGHT TO TF96(18) END-IF MOVE CL-D1 TO TF97(18).
    IF L-ADJ=1 MOVE L-EXTA TO CL-AMT. MOVE CL-AMT TO TF97(20).
    IF L-QTY=0 MOVE "^** LINE CANCELED **]" TO TF99(19).
    IF L-ADJ=1 MOVE "*** ADJUSTMENT ***" TO TF99(20).
    IF L-REORDER=1 MOVE "*** REORDER ***" TO TF99(21).
    PERFORM WRT GO OI3.
OI9. GO MN9.

* G-13 SHOW TRANSACTIONS BY CUSTOMER
CT1. PERFORM RD27 MOVE " " TO C-NO MOVE 5 TO IXT.
CT3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
CT33. DISPLAY "NEXT CUSTOMER NO. / INVOICE DATE: ______ / ______" LINE IXT.
    ACCEPT IA15 COLUMN 35 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA15=ALL "9" GO CT9.
    IF IA15=" " IF C-NO=" " GO CT33 ELSE GO CT4. MOVE IA15 TO C-NO.
    MOVE 44 TO IXU PERFORM AX-DT-INV.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5
      MOVE " " TO C-NO GO CT33.
    READ CUSTOMER NEXT REGARDLESS MOVE 0 TO INQ-IND.
CT4. PERFORM RD27 MOVE C-NO TO TF70(1) MOVE C-NAME TO TF71(1).
    MOVE C-TOT TO TF73(4,1) MOVE C-CUR TO TF73(4,2).
    MOVE C-30 TO TF73(4,3) MOVE C-60 TO TF73(4,4).
    MOVE C-90 TO TF73(4,5) MOVE C-120 TO TF73(4,6).
    MOVE 6 TO IXT.
    IF INQ-IND=0 MOVE C-NO TO TR-CUS MOVE 0 TO TR-INV
      START TRANS KEY>TR-KEY REGARDLESS INVALID GO CT8.
CT5. READ TRANS NEXT REGARDLESS END GO CT8. IF TR-CUS NOT=C-NO GO CT8.
    IF DATE0>0 IF TR-DATE<DATE0 GO CT5. IF TR-AMT=0 GO CT5. PERFORM CLR-LN.
    MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF73A(IXT).
    MOVE TR-INV TO TF74(IXT) MOVE TR-CUSORD TO TF74A(IXT).
    IF TR-AMT>0 MOVE TR-AMT TO TF75(IXT) ELSE COMPUTE TF76(IXT)=-TR-AMT.
    ADD 1 TO IXT IF IXT<22 GO CT5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO CT89.
CT8. MOVE "*** END ***" TO TLN(IXT).
    READ CUSTOMER NEXT REGARDLESS END MOVE " " TO C-NO GO CT89. MOVE 0 TO INQ-IND.
CT89. GO CT3.
CT9. GO MN9.

* G-14 SHOW ORDERS BY CUSTOMER
CO1. PERFORM RD28 MOVE " " TO C-NO MOVE 3 TO IXT.
CO3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
CO33. DISPLAY "NEXT CUSTOMER NO. ______" LINE IXT.
    ACCEPT IA16 COLUMN 19 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA16=ALL "9" GO CO9.
    IF IA16=" " IF C-NO=" " GO CO33 ELSE GO CO4. MOVE IA16 TO C-NO.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5
      MOVE " " TO C-NO GO CO33.
    READ CUSTOMER NEXT REGARDLESS MOVE 0 TO INQ-IND.
CO4. PERFORM RD28 MOVE C-NO TO TF102(1) MOVE C-NAME TO TF103(1).
    MOVE 4 TO IXT.
    IF INQ-IND=0 MOVE C-NO TO O-CUS MOVE 0 TO O-DATE
      START SAORD KEY>O-KC REGARDLESS INVALID GO CO8.
CO5. READ SAORD NEXT REGARDLESS END GO CO8. IF O-CUS NOT=C-NO GO CO8.
    PERFORM CLR-LN MOVE O-NO TO TF104(IXT) IF O-BLANKET=1 MOVE "B" TO TF104A(IXT).
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF105(IXT).
    MOVE O-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TF106(IXT).
    MOVE O-LINES TO TF107(IXT) MOVE O-CUSORD TO TF108(IXT).
    ADD 1 TO IXT IF IXT<22 GO CO5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO CO89.
CO8. MOVE "*** END ***" TO TLN(IXT).
    READ CUSTOMER NEXT REGARDLESS END MOVE " " TO C-NO GO CO89. MOVE 0 TO INQ-IND.
CO89. GO CO3.
CO9. GO MN9.

* G-15 SHOW OPEN LINES IN ORDER
OL1. PERFORM RD29 MOVE 0 TO O-NO MOVE 3 TO IXT.
OL3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
OL33. DISPLAY "NEXT ORDER NO. ______" LINE IXT.
    ACCEPT IA17 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA17=999999 GO OL9.
    IF IA17=0 IF O-NO=0 GO OL33 ELSE GO OL4. MOVE IA17 TO O-NO.
    START SAORD KEY>=O-KEY REGARDLESS INVALID PERFORM DSP-ERR8
      MOVE 0 TO O-NO GO OL33.
    READ SAORD NEXT REGARDLESS MOVE 0 TO INQ-IND.
OL4. PERFORM RD29 MOVE O-NO TO TF109(1).
    MOVE O-CUS TO TF110(1) A-A1 PERFORM RD-CUS MOVE C-NAME TO TF110A(1).
    MOVE 4 TO IXT.
    IF INQ-IND=0 COMPUTE L-NO=100 * O-NO
      START SALIN KEY>L-KEY REGARDLESS INVALID GO OL8.
OL5. READ SALIN NEXT REGARDLESS END GO OL8. IF L-ORD NOT=O-NO GO OL8.
    IF L-QTY-LEFT=0 GO OL5. PERFORM CLR-LN.
    MOVE L-LINE TO TF111(IXT) MOVE L-PROD TO TF112(IXT).
    IF L-QTY=LIT-Q9 MOVE LIT-BL TO TF114(IXT,1) MOVE L-QTY-LEFT TO TF113(IXT,3)
      ELSE MOVE L-QTY TO TF113(IXT,1) MOVE L-QTY-LEFT TO TF113(IXT,2).
    ADD 1 TO IXT IF IXT<22 GO OL5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO OL89.
OL8. MOVE "*** END ***" TO TLN(IXT).
    READ SAORD NEXT REGARDLESS END MOVE 0 TO O-NO GO OL89. MOVE 0 TO INQ-IND.
OL89. GO OL3.
OL9. GO MN9.

* G-16 SHOW BACKORDERS BY PRODUCT
BI1. PERFORM WRT132 PERFORM RD86.
    MOVE 0 TO BI-KOPN MOVE " " TO P-NO MOVE 3 TO IXT.
BI3. MOVE "??" TO TLNW(IXT + 1) PERFORM WRT.
BI33. DISPLAY "NEXT PRODUCT NO. ____________" LINE IXT.
    ACCEPT IA40 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA40=ALL "9" GO BI9.
    IF IA40=" " IF P-NO=" " GO BI33 ELSE GO BI4. MOVE IA40 TO P-NO.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 MOVE " " TO P-NO GO BI33.
    READ PRODUCT NEXT REGARDLESS IF P-GEN>" " PERFORM DSP-ERR29 MOVE " " TO P-NO GO BI33.
    PERFORM PROD-DESC MOVE 0 TO INQ-IND.
BI4. PERFORM RD86 MOVE P-NO TO TH94(1) MOVE PRO-DESC(1) TO TH95(1).
    MOVE 4 TO IXT IF INQ-IND=1 GO BI48. PERFORM DSP-QWAIT.
    IF BI-KOPN=1 PERFORM CLOSE-SORT. PERFORM OPEN-SORT MOVE 1 TO BI-KOPN.
    MOVE P-NO TO BI-PNO MOVE 1 TO BI-NUM PERFORM BI-A.
* note 14.2
    IF NOT(P-MAC>=29 AND<=31 OR=28 OR 99) GO BI44.
    MOVE P-NO TO NU-NUT MOVE " " TO NU-BOLT.
    START NUTBOLT KEY>NU-KEY REGARDLESS INVALID GO BI44.
BI43. READ NUTBOLT NEXT REGARDLESS END GO BI44. IF NU-NUT NOT=P-NO GO BI44.
    MOVE NU-BOLT TO BI-PROD MOVE NU-NUM TO BI-NUM PERFORM BI-M GO BI43.
BI44. PERFORM DSP-ERS.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO BI8.
BI48.
BI5. READ SORTFL NEXT END GO BI8. PERFORM CLR-LN IF SR-F27=1 GO BI6.
    MOVE SR-F30A TO TH85(IXT) A-N1 PERFORM RD-SAORD MOVE O-CUSORD TO TH84A(IXT).
    MOVE SR-F34 TO TH82(IXT) A-A1 PERFORM RD-CUS MOVE C-NAME TO TH83(IXT).
    MOVE C-ADD2 TO TH84(IXT) IF O-ADD2>" " MOVE O-ADD2 TO TH84(IXT).
    MOVE SR-F28 TO TH85A(IXT).
    MOVE SR-F30 TO D-DATE PERFORM D-NM MOVE D-DT TO TH86(IXT).
    MOVE SR-F33 TO TH87(IXT) IF SR-F34A=1 MOVE "ADJ" TO TH88A(IXT).
    GO BI68.
BI6. IF SR-F32 NOT=0 GO BI64. PERFORM INIT-PL.
    MOVE SR-F31 TO PL-PLANT MOVE SR-F28 TO PL-PROD READ PLANT REGARDLESS INVALID CONTINUE.
    MOVE "PLANT" TO TH89(IXT) MOVE PL-PLANT TO TH90(IXT) MOVE PL-NAME TO TH91(IXT).
    MOVE PL-ORD TO TH85(IXT) MOVE PL-PROD TO TH85A(IXT) MOVE SR-F33 TO TH88(IXT).
    READ SORTFL NEXT END GO BI8.
BI64. MOVE SR-F32 TO D-N1 PERFORM D-MTHSR.
    COMPUTE TH86A(IXT)=D-MM * 100 + D-YY MOVE SR-F33 TO TH87(IXT).
BI68. ADD 1 TO IXT IF IXT<22 GO BI5.
    MOVE "*** MORE ***" TO TLNW(IXT) MOVE 1 TO INQ-IND GO BI89.
BI8. MOVE "*** END ***" TO TLNW(IXT).
BI83. READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO BI89.
    IF P-GEN>" " GO BI83. PERFORM PROD-DESC MOVE 0 TO INQ-IND.
BI89. GO BI3.
BI9. IF BI-KOPN=1 PERFORM CLOSE-SORT. PERFORM WRT80 GO MN9.

BI-A. PERFORM BI-A1 THRU BI-A9.
BI-A1. MOVE BI-PNO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>=AL-KEY REGARDLESS INVALID GO BI-A4.
BI-A3. READ ALTERNATES NEXT REGARDLESS END GO BI-A4. IF AL-PROD NOT=BI-PNO GO BI-A4.
    MOVE AL-PROD TO BI-PROD IF AL-ALT>" " MOVE AL-ALT TO BI-PROD.
    PERFORM BI-M GO BI-A3.
BI-A4.
BI-A9. EXIT.

BI-M. PERFORM BI-M1 THRU BI-M9.
BI-M1. PERFORM INIT-SR MOVE 0 TO SR-F27.
    MOVE BI-PROD TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO BI-M46.
BI-M43. READ SALIN NEXT REGARDLESS END GO BI-M46. IF L-PROD NOT=BI-PROD GO BI-M46.
    IF L-SPECIAL=1 OR L-QTY-LEFT=0 OR L-QTY=LIT-Q9 GO BI-M43.
    MOVE BI-PROD TO SR-F28 MOVE L-DATE-REQ TO SR-F30 MOVE L-ORD TO SR-F30A.
    COMPUTE A-N1=BI-NUM * L-QTY-LEFT MOVE A-N1 TO SR-F33.
    MOVE L-CUS TO SR-F34 MOVE L-ADJ TO SR-F34A.
    WRITE SR-RECORD INVALID READ SORTFL ADD A-N1 TO SR-F33
      IF L-ADJ=1 MOVE L-ADJ TO SR-F34A END-IF REWRITE SR-RECORD.
    GO BI-M43.
BI-M46.

* note 56
    PERFORM INIT-SR MOVE 1 TO SR-F27.
    MOVE ALL "-" TO BI-OPLANT MOVE BI-PROD TO MT-KPROD MOVE " " TO MT-KPLANT.
    START MATREL KEY>=MT-KP REGARDLESS INVALID GO BI-M59.
BI-M53. READ MATREL NEXT REGARDLESS END GO BI-M59. IF MT-KPROD NOT=BI-PROD GO BI-M59.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>MT-IXF
      IF MT-FQTY(A-X1) NOT=0 GO BI-M54 END-IF END-PERFORM.
    GO BI-M53.
BI-M54. IF MT-KPLANT=BI-OPLANT GO BI-M56.
    MOVE MT-KPLANT TO BI-OPLANT SR-F31 MOVE 0 TO SR-F32 MOVE BI-PROD TO SR-F28.
    COMPUTE SR-F33=BI-NUM * MT-QTY-SHIP WRITE SR-RECORD INVALID CONTINUE.
BI-M56. MOVE 1 TO A-X1.
BI-M57. IF A-X1>MT-IXF GO BI-M58.
    MOVE MT-FQTY(A-X1) TO REL-FQTY MOVE MT-FDATE(A-X1) TO REL-FDATE.
    IF NOT(REL-FQTY=0 AND REL-FDATE=0)
      MOVE BI-PROD TO SR-F28 MOVE MT-PLANT TO SR-F31 PERFORM BI-W.
    ADD 1 TO A-X1 GO BI-M57.
BI-M58. GO BI-M53.
BI-M59.

    PERFORM INIT-SR MOVE 1 TO SR-F27.
    MOVE BI-PROD TO DY-KPROD MOVE " " TO DY-KPLANT.
    START DAYREL KEY>=DY-KP REGARDLESS INVALID GO BI-M69.
BI-M63. READ DAYREL NEXT REGARDLESS END GO BI-M69. IF DY-KPROD NOT=BI-PROD GO BI-M69.
    PERFORM CHK-RBW IF A-S1=0 GO BI-M63.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>DY-IXF
      IF DY-FQTY(A-X1) NOT=0 GO BI-M66 END-IF END-PERFORM.
    GO BI-M63.
BI-M66. MOVE 1 TO A-X1.
BI-M67. IF A-X1>DY-IXF GO BI-M68.
    MOVE DY-FQTY(A-X1) TO REL-FQTY MOVE DY-FDATE(A-X1) TO REL-FDATE.
    IF NOT(REL-FQTY=0 AND REL-FDATE=0)
      MOVE BI-PROD TO SR-F28 MOVE DY-PLANT TO SR-F31 PERFORM BI-W.
    ADD 1 TO A-X1 GO BI-M67.
BI-M68. GO BI-M63.
BI-M69.
BI-M9. EXIT.

BI-W. IF REL-FDATE=0 MOVE 9999 TO SR-F32
       ELSE MOVE REL-FDATE TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO SR-F32.
    MULTIPLY BI-NUM BY REL-FQTY MOVE REL-FQTY TO SR-F33.
    WRITE SR-RECORD INVALID READ SORTFL ADD REL-FQTY TO SR-F33 REWRITE SR-RECORD.

* G-17 SHOW SALES HISTORY
SF1. PERFORM RD15 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>3 GO MN9. PERFORM WRT132.
    IF Y1 OR Y3 PERFORM RD15A MOVE " " TO C-NO ELSE PERFORM RD15B MOVE " " TO P-NO.
    MOVE 3 TO IXT MOVE 0 TO INQ-IND.
SF3. MOVE "??" TO TLNW(IXT + 1) PERFORM WRT.
SF33. IF Y2 GO SF36. IF Y3 GO SF34.
    DISPLAY "NEXT CUSTOMER/PRODUCT/DATE ______/____________/______" LINE IXT.
    ACCEPT IA41 COLUMN 28 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA41=ALL "9" GO SF9.
    IF IA41>" " ACCEPT IA42 LINE IXT COLUMN 35 DEFAULT " " UNDERLINED PROTECTED EDITING
      ACCEPT IA43 LINE IXT COLUMN 48 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
     ELSE IF INQ-IND=0 MOVE " " TO IA42 MOVE 0 TO IA43.
    IF IA41=" " IF C-NO=" " GO SF33 ELSE GO SF4. MOVE IA41 TO C-NO.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5 GO SF33.
    READ CUSTOMER NEXT REGARDLESS.
    MOVE C-NO TO SH-CUS MOVE IA42 TO SH-PROD MOVE 0 TO SH-CDATE SH-CTIME.
    IF IA42>" " MOVE IA43 TO D-DT PERFORM D-MN MOVE D-DATE TO SH-CDATE.
    GO SF4.
SF34. DISPLAY "NEXT CUSTOMER/INVOICE ______/______" LINE IXT.
    ACCEPT IA41 COLUMN 23 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA41=ALL "9" GO SF9.
    IF IA41>" " ACCEPT IA44 LINE IXT COLUMN 30 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      ELSE IF INQ-IND=0 MOVE 0 TO IA44.
    IF IA41=" " IF C-NO=" " GO SF33 ELSE GO SF4. MOVE IA41 TO C-NO.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5 GO SF33.
    READ CUSTOMER NEXT REGARDLESS.
    MOVE C-NO TO SH-CUS MOVE " " TO SH-PROD MOVE 0 TO SH-CDATE SH-CTIME.
    GO SF4.
SF36. DISPLAY "NEXT PRODUCT/CUSTOMER/DATE ____________/______/______" LINE IXT.
    ACCEPT IA42 COLUMN 28 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA42=ALL "9" GO SF9.
    IF IA42>" " ACCEPT IA41 LINE IXT COLUMN 41 DEFAULT " " UNDERLINED PROTECTED EDITING
      ACCEPT IA43 LINE IXT COLUMN 48 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
     ELSE IF INQ-IND=0 MOVE " " TO IA41 MOVE 0 TO IA43.
    IF IA42=" " IF P-NO=" " GO SF33 ELSE GO SF4. MOVE IA42 TO P-NO.
    IF INUT INITIALIZE P-REC MOVE IA42 TO P-NO PERFORM PROD-DESC GO SF38.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO SF33.
    READ PRODUCT NEXT REGARDLESS PERFORM PROD-DESC.
SF38. MOVE P-NO TO SH-KPROD MOVE IA41 TO SH-KCUS MOVE 0 TO SH-KDATE SH-KTIME.
    IF IA41>" " MOVE IA43 TO D-DT PERFORM D-MN MOVE D-DATE TO SH-KDATE.

SF4. MOVE 0 TO INQ-IND IF Y2 GO SF42.
    PERFORM RD15A MOVE C-NO TO TH155(1) MOVE C-NAME TO TH156(1).
    MOVE 4 TO IXT IF INQ-IND=0 START SALHIST KEY>=SH-KEY REGARDLESS INVALID GO SF8.
    GO SF44.
SF42. PERFORM RD15B MOVE P-NO TO TH157(1) MOVE PRO-DESC(1) TO TH158(1).
    MOVE 4 TO IXT IF INQ-IND=0 START SALHIST KEY>=SH-KP REGARDLESS INVALID GO SF8.
SF44. IF ((Y1 OR Y2) AND IA43 NOT=0) OR Y3 PERFORM DSP-QWAIT.
* note 258.1
SF5. READ SALHIST NEXT REGARDLESS END GO SF8. IF Y2 GO SF52.
    IF SH-CUS NOT=C-NO GO SF8.
    IF Y1 IF NOT(IA42=" " OR SH-PROD) GO SF8 END-IF
      MOVE IA43 TO D-DT PERFORM D-MN IF SH-CDATE<D-DATE GO SF5.
    IF Y3 IF SH-INVNO NOT=IA44 GO SF5. GO SF6.
SF52. IF SH-PROD NOT=P-NO GO SF8. IF NOT(IA41=" " OR SH-CUS) GO SF8.
    MOVE IA43 TO D-DT PERFORM D-MN IF SH-KDATE<D-DATE GO SF5.

SF6. MOVE SH-SHIPTO TO SF-DF1 MOVE SH-QTY TO SF-DF2 MOVE SH-AMT TO SF-DF3.
    IF SH-US=1 MOVE "US" TO SF-DF4.
    COMPUTE SF-DF5 ROUNDED=SH-AMT * 1000 / SH-QTY SIZE ERROR CONTINUE.
    IF SH-SUR>0 MOVE SH-SUR TO SF-DF7 MOVE ":" TO SF-DF8 MOVE SH-SURCHARGE TO SF-DF9.
    MOVE SH-WEIGHT TO SF-DF10 MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO SF-DF11.
    MOVE SH-INVNO TO SF-DF12 MOVE SH-BL TO SF-DF13 MOVE SH-ORD TO SF-DF14.
    MOVE SH-CUSORD TO SF-DF15 PERFORM CLR-LN.
    IF Y2 MOVE SH-CUS TO TH153(IXT) MOVE SF-DF TO TH154(IXT)
      ELSE MOVE SH-CAT TO TH149(IXT) MOVE SH-PROD TO TH150(IXT) MOVE SF-DF TO TH151(IXT).
    ADD 1 TO IXT IF IXT<22 GO SF5.
    MOVE "*** MORE ***" TO TLNW(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO SF89.
SF8. MOVE "*** END ***" TO TLNW(IXT) PERFORM DSP-ERS MOVE 0 TO INQ-IND.
    IF Y2 GO SF82. IF Y3 MOVE " " TO C-NO GO SF89.
    READ CUSTOMER NEXT REGARDLESS END MOVE " " TO C-NO GO SF89.
    INITIALIZE SH-KEY MOVE C-NO TO SH-CUS GO SF89.
SF82. IF INUT MOVE " " TO P-NO GO SF89.
    READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO SF89. PERFORM PROD-DESC.
    INITIALIZE SH-KP MOVE P-NO TO SH-KPROD.
SF89. GO SF3.
SF9. PERFORM WRT80 GO MN9.

* G-18 WORKSHEET ENTRY
DE1. PERFORM OPEN-AUDIT PERFORM OPEN-MACSCHED PERFORM OPEN-EMPL.
    MOVE " " TO DE-JKEY MOVE 0 TO DE-PDATE.
DE13. PERFORM RD103 PERFORM WRT MOVE 0 TO DE-KMOP.
    MOVE LOW-VALUES TO J-RECORD INITIALIZE J-REC.
    DISPLAY "- PF1 TO READ PREVIOUS WORKSHEET" LINE 24 COLUMN 48 BOLD.
    ACCEPT LT-KEY LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    PERFORM DSP-ERS IF NOT KPF1 GO DE2. IF DE-JKEY=" " GO DE13.
    MOVE DE-JKEY TO J-KEY READ WORKSHEET REGARDLESS INVALID GO DE13.
    MOVE J-NO TO R-NO READ PRODORD REGARDLESS INVALID GO DE13.
    MOVE J-MAC TO M-NO READ MACHINE REGARDLESS INVALID GO DE13.
    DISPLAY J-NO LINE 3 COLUMN 16 CONVERSION J-MAC COLUMN 38 CONVERSION.
    MOVE J-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 4 COLUMN 16.
    DISPLAY LIT-XDAN(J-SHIFT + 1:1) LINE 4 COLUMN 41.
    DISPLAY J-EMP LINE 5 COLUMN 13 CONVERSION.
    MOVE J-PROD TO A-A1 PERFORM PROD-RD PERFORM DE-PDSP GO DE36.

DE2. IF KPF4 OR LT-KEY=" " OR ALL "9" GO DE9. MOVE LT-KEY TO A-A1 PERFORM STR-LTH.
    IF LT-KEY(1:A-N1) NOT NUMERIC PERFORM DSP-ERR2 GO DE13.
    IF A-N1<7 MOVE 0 TO J-NO MOVE LT-NO(1:A-N1) TO J-NO(7 - A-N1:) GO DE22.
    READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO DE13.
    MOVE LT-MO TO J-NO DISPLAY LIT-SP(1:7) LINE 3 COLUMN 16 J-NO COLUMN 16 CONVERSION.
DE22. MOVE J-NO TO R-NO PERFORM RDF-PRODORD IF A-S1=1 GO DE13.
    MOVE R-PROD TO J-PROD A-A1 PERFORM PROD-RD PERFORM DE-PDSP.
DE25. PERFORM DSP-PF1 ACCEPT J-MAC LINE 3 COLUMN 38 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS IF KPF1 GO DE13.
    MOVE J-MAC TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO DE25.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO DE256.
    IF DE-PDATE=0 MOVE SYS-DATE TO DE-PDATE.
    MOVE J-MAC TO MQ-MAC READ MACSCHED REGARDLESS INVALID GO DE254.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>15
      IF MQ-MO(IX1)=J-NO GO DE256 END-IF END-PERFORM.
DE254. MOVE "THIS M.O. IS NOT SCHEDULED FOR THIS MACHINE" TO ERR-MESG.
    PERFORM DSP-OK IF XA2 NOT="OK" GO DE25.
DE256. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY OR PROC-OUTCON GO DE28.
    PERFORM GET-OP IF A-S1=1 GO DE28.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF J-MAC=OP-OPER(IX1) GO DE28 END-IF END-PERFORM.
    MOVE "THIS PROCESS IS NOT IN THE OPERATIONS LIST" TO ERR-MESG.
    PERFORM DSP-OK IF XA2 NOT="OK" GO DE25.
DE28. MOVE DE-PDATE TO D-DATE PERFORM D-NM IF D-DT>0 DISPLAY D-DT LINE 4 COLUMN 16.
DE31. PERFORM DSP-PF1 MOVE 4 TO IXT MOVE 16 TO IXU PERFORM AX-DT-DEF.
    PERFORM DSP-ERS IF KPF1 GO DE13.
    MOVE DATE0 TO DE-PDATE J-DATE D-DATE MOVE 20 TO D-N1 MOVE 0 TO D-N2.
    PERFORM D-CHKDTR IF D-ERR=1 GO DE31.
DE33. PERFORM DSP-PF1 ACCEPT XA1 LINE 4 COLUMN 41 DEFAULT "D"
       UNDERLINED PROTECTED KEY CKEY PERFORM DSP-ERS IF KPF1 GO DE13.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE PERFORM CHK-SHIFT.
    IF A-N1>3 OR A-N1=0 AND NOT(PROC-INCON OR PROC-RETURN OR PROC-OUTCON
      OR PROC-LOTINSP OR PROC-RECEIVE OR PROC-HEAT OR PROC-ADJUST OR PROC-PHYSINV)
      PERFORM DSP-ERR24 GO DE33.
    MOVE A-N1 TO J-SHIFT.
DE35. PERFORM DSP-PF1 ACCEPT J-EMP LINE 5 COLUMN 13 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS IF KPF1 GO DE13.
    IF J-EMP NOT=0 MOVE WS-PDIV TO E-DIV MOVE J-EMP TO E-NO
      READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO DE35 END-READ
      MOVE E-NAME TO J-NAME DISPLAY J-NAME LINE 5 COLUMN 28.

DE36. IF ITOOL PERFORM GET-OP.
    IF IFAST OR INUT MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY GO DE38.
    PERFORM DE-LPUT.
* note 30.1
    MOVE 0 TO DE-SQTY INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO DE364.
DE363. READ WORKSHEET NEXT REGARDLESS END GO DE364. IF J-NO NOT=R-NO GO DE364.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF (IFAST OR INUT) AND PROC-PRIMARY OR ITOOL AND J-MAC=OP-OPER(1) ADD J-QTY TO DE-SQTY.
    IF (J-MAC=DE-LMAC OR (IFAST OR INUT) AND PROC-REJECT)
      AND NOT(J-MAC=DE-LMAC AND J-DATE=DE-LDATE AND J-SHIFT=DE-LSHIFT AND J-EMP=DE-LEMP)
        SUBTRACT J-QTY FROM DE-SQTY.
    GO DE363.
DE364. COMPUTE DE-SWEIGHT ROUNDED=DE-SQTY * P-WEIGHT / 100.
    PERFORM DE-LGET.

DE38. READ WORKSHEET REGARDLESS INVALID GO DE6. MOVE J-KEY TO DE-JKEY.
    DISPLAY "THIS WORKSHEET ENTRY EXISTS" LINE 23 BOLD.
    MOVE " -- 'B' FOR BUCKETS, 'C' TO CHANGE, 'DEL' TO DELETE: ___" TO TMSG.
    PERFORM DSP-PROMPT DISPLAY " " LINE 23 ERASE LINE.
    IF XA3="B" GO DE4. IF XA3="C" GO DE50.
    IF XA3="DEL" DELETE WORKSHEET PERFORM DE-DELBK.
    GO DE13.

DE4. DISPLAY "UPDATE BUCKETS" LINE 1 COLUMN 21 REVERSED.
    DISPLAY "CURRENT BUCKETS:" LINE 12 BOLD ERASE END SCREEN.
    MOVE 13 TO IXT MOVE 1 TO IXCOL MOVE J-KEY TO BU-JKEY MOVE 0 TO BU-NUM.
    START BUCKET KEY>BU-KEY REGARDLESS INVALID GO DE44.
DE43. READ BUCKET NEXT REGARDLESS END GO DE44. IF BU-JKEY NOT=J-KEY GO DE44.
    MOVE BU-NUM TO DE-DF1A MOVE ":" TO DE-DF1B MOVE BU-WEIGHT TO DE-DF1C.
    COMPUTE IXU=(IXCOL - 1) * 13 + 1 DISPLAY DE-DF1 LINE IXT COLUMN IXU.
    ADD 1 TO IXCOL IF IXCOL>6 ADD 1 TO IXT MOVE 1 TO IXCOL. GO DE43.
DE44. DISPLAY "'C' TO CHANGE WEIGHT, 'A' TO ADD BUCKET, 'D' TO DELETE BUCKET: _" LINE 21 BOLD.
    ACCEPT DE-OPT COLUMN 64 DEFAULT " " UNDERLINED PROTECTED.
    IF NOT(DE-OPT="C" OR "A" OR "D") GO DE13.
DE45. DISPLAY "BUCKET NO. ____" LINE 23 BOLD ERASE LINE.
    ACCEPT DE-BNUM COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DE-BNUM=0 GO DE49. IF DE-OPT="C" OR "D" GO DE46.
    MOVE J-KEY TO BU-JKEY MOVE 0 TO BU-NUM DE-BSEQ.
    START BUCKET KEY>BU-KEY REGARDLESS INVALID GO DE454.
DE453. READ BUCKET NEXT REGARDLESS END GO DE454. IF BU-JKEY NOT=J-KEY GO DE454.
    IF BU-SEQ>DE-BSEQ MOVE BU-SEQ TO DE-BSEQ. GO DE453.
DE454. IF DE-BSEQ<99 ADD 1 TO DE-BSEQ ELSE MOVE 1 TO DE-BSEQ.
    PERFORM INIT-BU MOVE DE-BNUM TO BU-NUM BU-KNUM MOVE DE-BSEQ TO BU-SEQ.
    WRITE BU-RECORD ALLOWING NO INVALID PERFORM DE-E1 GO DE488. UNLOCK BUCKET.
    GO DE48.
DE46. MOVE J-KEY TO BU-JKEY MOVE DE-BNUM TO BU-NUM.
    READ BUCKET REGARDLESS INVALID MOVE "INVALID BUCKET NO." TO ERR-MESG
      PERFORM DSP-ERR GO DE488.
    IF DE-OPT="D" DELETE BUCKET GO DE488.
DE48. DISPLAY "WEIGHT: ____" LINE 23 COLUMN 25 BOLD.
DE483. ACCEPT BU-WEIGHT LINE 23 COLUMN 33 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM CHK-BUCKET-WEIGHT IF A-S1=1 GO DE483.
    REWRITE BU-RECORD ALLOWING NO UNLOCK BUCKET.
DE488. GO DE45.
DE49. PERFORM BUCKET-CALC REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET GO DE13.

DE50. DISPLAY "CHANGE WORKSHEET" LINE 1 COLUMN 21 REVERSED.
    PERFORM RD103A PERFORM WRT PERFORM RD103C PERFORM WRT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      MOVE J-DHOURS(IX1) TO A-D1 PERFORM DE-HCONV
      MOVE DE-DH TO DE-HH(IX1) MOVE DE-DM TO DE-MM(IX1) END-PERFORM.
    DISPLAY J-NAME LINE 5 COLUMN 28.
    PERFORM DE-TDSP.
    DISPLAY J-QTY LINE 10 COLUMN 7 CONVERSION J-WEIGHT COLUMN 31 CONVERSION.
    MOVE J-HOURS TO A-D1 PERFORM DE-HCONV PERFORM DE-HDSP.
    DISPLAY J-NOTE LINE 11 COLUMN 9.

    ACCEPT J-NAME LINE 5 COLUMN 28 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM DE-TX IF NOT ITOOL GO DE52.
    ACCEPT DE-DH LINE 10 COLUMN 74 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY DE-DH LINE 10 COLUMN 74 CONVERSION.
    ACCEPT DE-DM LINE 10 COLUMN 77 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE DE-DM TO DSP-F21 DISPLAY DSP-F21 LINE 10 COLUMN 77.
    COMPUTE J-HOURS ROUNDED=(DE-DH * 60 + DE-DM) / 60.
DE52.
DE535. ACCEPT J-QTY LINE 10 COLUMN 7 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY J-QTY LINE 10 COLUMN 7 CONVERSION.
    PERFORM DE-CHK-QTY IF A-S1=1 GO DE535.
DE537. ACCEPT J-WEIGHT LINE 10 COLUMN 31 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY J-WEIGHT LINE 10 COLUMN 31 CONVERSION.
    PERFORM DE-CHK-WEIGHT IF A-S1=1 GO DE537.
    PERFORM DE-CHK-QW IF A-S1=1 GO DE535.
    PERFORM DE-CHK-PKWEIGHT IF A-S1=1 GO DE54.
    ACCEPT J-NOTE LINE 11 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
DE54. MOVE "'CAN' TO CANCEL THESE CHANGES: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="CAN" REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
    GO DE13.

DE6. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF NOT((IFAST OR INUT) AND PROC-PRIMARY OR ITOOL AND J-MAC=OP-OPER(1)) GO DE62.
    IF M-RNO=R-NO GO DE62. MOVE J-NO TO DE-LNO.
    MOVE M-RNO TO A-N1 PERFORM RD-PRODORD.
    MOVE R-QTY-ORD TO DSP-C81 DISPLAY "ORDERED:" LINE 20 BOLD DSP-C81 COLUMN 10.
    MOVE R-QTY-PROD TO DSP-C81 DISPLAY "PRODUCED:" LINE 21 BOLD DSP-C81 COLUMN 10.
    MOVE R-QTY-LEFT TO DSP-C81 DISPLAY "LEFT:" LINE 22 BOLD DSP-C81 COLUMN 10.
    MOVE DE-LNO TO A-N1 PERFORM RD-PRODORD.
    MOVE " " TO WA1 MOVE J-MAC TO DSP-N31 MOVE M-RNO TO DSP-N61.
    STRING "NEW M.O. FOR MACHINE " DSP-N31 " - IS M.O. " DSP-N61 " COMPLETE ? ___"
      DELIMITED SIZE INTO WA1 DISPLAY WA1(1:57) LINE 24 BOLD.
    ACCEPT XA3 COLUMN 54 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    DISPLAY " " LINE 20 ERASE END SCREEN.
    IF XA3 NOT="YES" GO DE62. PERFORM DE-LPUT.
    INITIALIZE R-REC P-REC MOVE M-RNO TO R-NO READ PRODORD REGARDLESS INVALID GO DE612.
    MOVE 1 TO R-FIN REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT.
DE612. INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO DE616.
DE613. READ WORKSHEET NEXT REGARDLESS END GO DE616. IF J-NO NOT=R-NO GO DE616.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-PRIMARY PERFORM CALC-QTY-WEIGHT REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
    GO DE613.
DE616. MOVE DE-LNO TO A-N1 PERFORM RD-PRODORD.
    MOVE DE-LPROD TO A-A1 PERFORM PROD-RT PERFORM DE-LGET.
    MOVE J-NO TO M-RNO REWRITE M-RECORD ALLOWING NO UNLOCK MACHINE.
DE62. IF J-EMP=0 ACCEPT J-NAME LINE 5 COLUMN 28 DEFAULT " " UNDERLINED PROTECTED EDITING.

    REPLACE ==CHK-KPF== BY ==PERFORM DSP-ERS IF KPF1 GO DE63 ELSE IF KPF3 GO DE8==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION==
            ==ACC-ZNUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
DE63. PERFORM RD103A PERFORM WRT INITIALIZE J-HOURS J-QTY J-WEIGHT J-NOTE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 MOVE 0 TO J-DHOURS(IX1) END-PERFORM.
    IF NOT ITOOL GO DE64.
DE633. DISPLAY "FROM: HOUR __  MIN __     TO: HOUR __  MIN __" LINE 16 BOLD "    (HOUR 1-12, MIN 0-59)".
    ACCEPT DE-H1 LINE 16 COLUMN 12 ACC-ZNUM.
    ACCEPT DE-M1 LINE 16 COLUMN 20 ACC-ZNUM.
    ACCEPT DE-H2 LINE 16 COLUMN 36 ACC-ZNUM.
    ACCEPT DE-M2 LINE 16 COLUMN 44 ACC-ZNUM.
    IF NOT((DE-H1>=1 AND<=12) AND (DE-H2>=1 AND<=12) AND (DE-M1>=0 AND<=59)
      AND (DE-M2>=0 AND<=59)) PERFORM DSP-ERR2 GO DE633.
    COMPUTE WN1=60 * (DE-H2 - DE-H1) + DE-M2 - DE-M1 IF WN1<0 ADD 720 TO WN1.
    COMPUTE J-HOURS ROUNDED=WN1 / 60.
    DIVIDE WN1 BY 60 GIVING DE-DH REMAINDER DE-DM PERFORM DE-HDSP.
    DISPLAY " " LINE 16 ERASE LINE.

DE64. PERFORM RD103C PERFORM WRT.
    INITIALIZE DE-HTBL PERFORM DE-TDSP PERFORM DE-TX.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF IFAST OR INUT IF PROC-TAP OR PROC-THREAD GO DE70.
    IF PROC-AUTOSORT OR PROC-PACK OR PROC-RECEIVE OR PROC-BOLTNUT GO DE68.
DE645. PERFORM DSP-PF13 ACCEPT J-QTY LINE 10 COLUMN 7 ACC-ZNUM KEY CKEY CHK-KPF.
    PERFORM DE-CHK-QTY IF A-S1=1 GO DE645.
DE647. PERFORM DSP-PF13 ACCEPT J-WEIGHT LINE 10 COLUMN 31 ACC-ZNUM KEY CKEY CHK-KPF.
    PERFORM DE-CHK-WEIGHT IF A-S1=1 GO DE647.
    PERFORM DE-CHK-QW IF A-S1=1 GO DE8. GO DE70.

DE68. DISPLAY "QTY/CTN    CARTON WEIGHT    NUM CARTONS" LINE 16 BOLD.
    DISPLAY   " _____         _____           ______ " LINE 17.
    MOVE P-QTY-PACK TO DE-QTY-PACK COMPUTE DE-WEIGHT-PACK ROUNDED=P-QTY-PACK * P-WEIGHT / 100.
    DISPLAY DE-QTY-PACK LINE 17 COLUMN 2 CONVERSION.
    DISPLAY DE-WEIGHT-PACK LINE 17 COLUMN 16 CONVERSION.
    PERFORM DSP-PF13 ACCEPT DE-QTY-PACK LINE 17 COLUMN 2 ACC-NUM KEY CKEY CHK-KPF.
    DISPLAY DE-QTY-PACK LINE 17 COLUMN 2 CONVERSION.
    COMPUTE DE-WEIGHT-PACK ROUNDED=DE-QTY-PACK * P-WEIGHT / 100.
    DISPLAY DE-WEIGHT-PACK LINE 17 COLUMN 16 CONVERSION.
    PERFORM DSP-PF13 ACCEPT DE-WEIGHT-PACK LINE 17 COLUMN 16 ACC-NUM KEY CKEY CHK-KPF.
    DISPLAY DE-WEIGHT-PACK LINE 17 COLUMN 16 CONVERSION.
DE683. PERFORM DSP-PF13 ACCEPT DE-CARTONS LINE 17 COLUMN 32 ACC-ZNUM KEY CKEY CHK-KPF.
    IF DE-CARTONS=0 MOVE "INVALID VALUE" TO ERR-MESG PERFORM DSP-OK
      IF XA2 NOT="OK" GO DE683.
    COMPUTE J-QTY=DE-QTY-PACK * DE-CARTONS DISPLAY J-QTY LINE 10 COLUMN 7 CONVERSION.
    COMPUTE J-WEIGHT=DE-WEIGHT-PACK * DE-CARTONS DISPLAY J-WEIGHT LINE 10 COLUMN 31 CONVERSION.
    IF PROC-AUTOSORT GO DE688.
DE685. PERFORM DSP-PF13 ACCEPT J-QTY LINE 10 COLUMN 7 ACC-NUM KEY CKEY CHK-KPF.
    DISPLAY J-QTY LINE 10 COLUMN 7 CONVERSION.
    PERFORM DE-CHK-QTY IF A-S1=1 GO DE685.
DE687. PERFORM DSP-PF13 ACCEPT J-WEIGHT LINE 10 COLUMN 31 ACC-NUM KEY CKEY CHK-KPF.
    DISPLAY J-WEIGHT LINE 10 COLUMN 31 CONVERSION.
    PERFORM DE-CHK-WEIGHT IF A-S1=1 GO DE687.
DE688. PERFORM DE-CHK-QW IF A-S1=1 GO DE8. PERFORM DE-CHK-PKWEIGHT IF A-S1=1 GO DE8.
    DISPLAY " " LINE 16 ERASE END SCREEN.
    REPLACE OFF.

DE70. PERFORM DSP-PF13 ACCEPT J-NOTE LINE 11 COLUMN 9 DEFAULT " "
       UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF1 GO DE63 ELSE IF KPF3 GO DE8.

    PERFORM RD103B PERFORM WRT PERFORM OPEN-MAINTA MOVE 1 TO DE-KMOP.
    MOVE SYS-DATE TO D-DATE MOVE -3 TO D-DAYS PERFORM D-WDIFF.
    MOVE D-DATE TO DE-BDATE MOVE 0 TO DE-BSEQ.
    MOVE 13 TO DE-IXT MOVE 15 TO DE-IXU.
DE73. ACCEPT DE-BNUM LINE DE-IXT COLUMN DE-IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF DE-BNUM=0 GO DE8.
* note 28
DE75. MOVE DE-BNUM TO BU-KNUM MOVE 0 TO BU-ZDATE.
    START BUCKET KEY>BU-KN REGARDLESS INVALID GO DE76.
DE753. READ BUCKET NEXT REGARDLESS END GO DE76.
    IF BU-NUM NOT=DE-BNUM OR BU-DATE<DE-BDATE GO DE76.
    IF NOT(BU-NO=J-NO AND BU-MAC=J-MAC) OR BU-JKEY=J-KEY GO DE753.
    DISPLAY "BUCKET:  " LINE 17 BOLD BU-NUM CONVERSION.
    DISPLAY "WEIGHT:  " LINE 18 BOLD BU-WEIGHT CONVERSION.
    DISPLAY "M.O.:    " LINE 19 BOLD BU-NO CONVERSION.
    DISPLAY "MACHINE: " LINE 20 BOLD BU-MAC CONVERSION.
    MOVE BU-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO DSP-DT1.
    DISPLAY "DATE:    " LINE 21 BOLD DSP-DT1.
    DISPLAY "SHIFT:   " LINE 22 BOLD LIT-XDAN(BU-SHIFT + 1:1).
    DISPLAY "CLOCK:   " LINE 23 BOLD BU-EMP CONVERSION.
    MOVE "BUCKET IS USED IN ANOTHER WORKSHEET - 'DEL' TO DELETE THAT BUCKET: ___" TO TMSG.
    PERFORM DSP-PROMPT DISPLAY " " LINE 17 ERASE END SCREEN.
    IF XA3="DEL" DELETE BUCKET WRITE MFA-RECORD FROM BU-JKEY GO DE75.
DE76. PERFORM INIT-BU MOVE DE-BNUM TO BU-NUM BU-KNUM.
    ADD 1 TO DE-BSEQ MOVE DE-BSEQ TO BU-SEQ.
    WRITE BU-RECORD ALLOWING NO INVALID PERFORM DE-E1 GO DE73. UNLOCK BUCKET.
    ADD 1 TO J-BKTOT MOVE 1 TO J-BKEMPTY.
    ADD 5 TO DE-IXU IF DE-IXU>75 ADD 1 TO DE-IXT MOVE 15 TO DE-IXU.
    IF DE-IXT<=15 GO DE73.

DE8. IF DE-KMOP=0 PERFORM OPEN-MAINTA.
    MOVE "'CAN' TO CANCEL THIS WORKSHEET ENTRY: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" PERFORM DE-DELBK GO DE84.
    IF J-MAC=8 OR 54 MOVE "IS THIS M.O. COMPLETE ? ___" TO TMSG PERFORM DSP-PROMPT
      IF XA3="YES" PERFORM CALC-QTY-WEIGHT MOVE 1 TO R-FIN
        REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    PERFORM SET-JKD WRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
    MOVE J-KEY TO DE-JKEY.
DE84. CLOSE MAINTA OPEN INPUT MAINTA.
DE85. READ MAINTA INTO J-KEY END GO DE88. READ WORKSHEET REGARDLESS INVALID GO DE85.
    PERFORM BUCKET-CALC REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET GO DE85.
DE88. CLOSE MAINTA PERFORM DELETE-MAINT GO DE13.
DE9. CLOSE AUDIT MACSCHED EMPL GO MN9.

DE-PDSP. DISPLAY P-NO LINE 1 COLUMN 49 PERFORM PROD-DESC.
    MOVE 1 TO IX1 MOVE 2 TO IXT PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      DISPLAY PRO-DESC(IX1) LINE IXT COLUMN 49 ADD 1 TO IX1 IXT END-PERFORM.
DE-HCONV. MOVE A-D1 TO DE-DH COMPUTE DE-DM ROUNDED=60 * (A-D1 - DE-DH).
DE-HDSP. DISPLAY DE-DH LINE 10 COLUMN 74 CONVERSION.
    MOVE DE-DM TO DSP-F21 DISPLAY DSP-F21 COLUMN 77.
DE-TDSP. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 COMPUTE IXU=8 + IX1 * 7
      DISPLAY DE-HH(IX1) LINE 8 COLUMN IXU CONVERSION
      MOVE DE-MM(IX1) TO DSP-F21 DISPLAY DSP-F21 COLUMN IXU PLUS 2 END-PERFORM.
DE-TX. PERFORM DE-TX1 THRU DE-TX9.
DE-TX1. DISPLAY "CODE 1 - 9, OR 'RETURN' TO END" LINE 24 BOLD.
    ACCEPT XN1 LINE 7 COLUMN 8 DEFAULT ZERO
      UNDERLINED PROTECTED AUTOTERMINATE CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF XN1=0 GO DE-TX4. MOVE XN1 TO IX1 COMPUTE IXU=8 + IX1 * 7.
    ACCEPT DE-HH(IX1) LINE 8 COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY DE-HH(IX1) LINE 8 COLUMN IXU CONVERSION.
    ACCEPT DE-MM(IX1) LINE 8 COLUMN IXU PLUS 2 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE DE-MM(IX1) TO DSP-F21 DISPLAY DSP-F21 LINE 8 COLUMN IXU PLUS 2.
    GO DE-TX1.
DE-TX4. DISPLAY " " LINE 13 ERASE END SCREEN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      COMPUTE J-DHOURS(IX1) ROUNDED=(DE-HH(IX1) * 60 + DE-MM(IX1)) / 60 END-PERFORM.
    IF NOT ITOOL MOVE 0 TO J-HOURS
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 ADD J-DHOURS(IX1) TO J-HOURS END-PERFORM
      MOVE J-HOURS TO A-D1 PERFORM DE-HCONV PERFORM DE-HDSP.
DE-TX9. EXIT.
DE-AUDIT. MOVE J-NO TO IE81 MOVE J-MAC TO IE82 MOVE USN-USER TO IE83 MOVE A-S2 TO IE84.
    IF A-S2=0 MOVE J-QTY TO IE85 MOVE DE-SQTY TO IE86
      ELSE MOVE J-WEIGHT TO IE85 MOVE DE-SWEIGHT TO IE86.
    MOVE TD-INP-R8 TO AU-DATA MOVE 8 TO AU-K PERFORM ADD-AUD.
DE-CHK-QTY. PERFORM DE-CQ1 THRU DE-CQ9.
DE-CQ1. MOVE 0 TO A-S1 MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF (IFAST OR INUT) AND (PROC-PRIMARY OR PROC-PACK) OR ITOOL AND J-MAC=OP-OPER(1)
      OR J-QTY<=DE-SQTY GO DE-CQ9.
    MOVE 1 TO A-S1 MOVE " " TO ERR-MESG MOVE DE-SQTY TO DSP-C81.
    STRING "QTY CANNOT EXCEED PRIMARY MACHINE" DSP-C81 DELIMITED SIZE INTO ERR-MESG.
    IF ITOOL PERFORM DSP-OK IF XA2="OK" MOVE 0 TO A-S1 END-IF
     ELSE IF PROC-LOTINSP OR PROC-RECEIVE OR PROC-BOLTNUT PERFORM DSP-OK
       IF XA2="OK" MOVE 0 TO A-S1 MOVE 0 TO A-S2 PERFORM DE-AUDIT END-IF
      ELSE PERFORM DSP-ERR.
DE-CQ9. EXIT.
DE-CHK-WEIGHT. PERFORM DE-CW1 THRU DE-CW9.
DE-CW1. MOVE 0 TO A-S1 IF ITOOL GO DE-CW9. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-PRIMARY OR PROC-PACK OR J-WEIGHT<=DE-SWEIGHT GO DE-CW9.
    MOVE 1 TO A-S1 MOVE " " TO ERR-MESG MOVE DE-SWEIGHT TO DSP-C81.
    STRING "WEIGHT CANNOT EXCEED PRIMARY MACHINE" DSP-C81 DELIMITED SIZE INTO ERR-MESG.
    IF PROC-LOTINSP OR PROC-RECEIVE OR PROC-BOLTNUT OR PROC-HEAT PERFORM DSP-OK
      IF XA2="OK" MOVE 0 TO A-S1 MOVE 1 TO A-S2 PERFORM DE-AUDIT END-IF
     ELSE PERFORM DSP-ERR.
DE-CW9. EXIT.
DE-CHK-QW. MOVE 0 TO A-S1 MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    MOVE P-WEIGHT TO A-D1 IF PROC-PRIMARY AND P-PWEIGHT>0 MOVE P-PWEIGHT TO A-D1.
    IF J-WEIGHT=0 COMPUTE J-WEIGHT ROUNDED=J-QTY * A-D1 / 100
      ELSE IF J-QTY=0 COMPUTE J-QTY ROUNDED=J-WEIGHT * 100 / A-D1 SIZE ERROR CONTINUE.
    IF J-QTY=0 AND J-WEIGHT=0 MOVE "BOTH QTY AND WEIGHT CANNOT BE 0"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" MOVE 1 TO A-S1.
DE-CHK-PKWEIGHT. PERFORM DE-CP1 THRU DE-CP9.
DE-CP1. MOVE 0 TO A-S1 IF ITOOL GO DE-CP9.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PACK GO DE-CP9.
    IF J-QTY<=0 OR J-WEIGHT<=0 GO DE-CP9.
    COMPUTE A-D1 ROUNDED=(J-WEIGHT * 100 / J-QTY - P-WEIGHT) * 100 / P-WEIGHT
      SIZE ERROR MOVE 99.99 TO A-D1.
    IF NOT(A-D1>=-5 AND<=5) MOVE 1 TO A-S1
      MOVE "OVER 5% WEIGHT DISCREPANCY" TO ERR-MESG PERFORM DSP-ERR.
DE-CP9. EXIT.
DE-LPUT. MOVE J-KEY TO DE-LKEY MOVE J-NAME TO DE-LNAME MOVE J-PROD TO DE-LPROD.
DE-LGET. MOVE LOW-VALUES TO J-RECORD INITIALIZE J-REC.
    MOVE DE-LKEY TO J-KEY MOVE DE-LNAME TO J-NAME MOVE DE-LPROD TO J-PROD.
DE-E1. MOVE "THIS BUCKET WAS ALREADY USED IN THIS WORKSHEET" TO ERR-MESG PERFORM DSP-ERR.
DE-DELBK. PERFORM DE-DB1 THRU DE-DB9.
DE-DB1. MOVE J-KEY TO BU-JKEY MOVE 0 TO BU-NUM.
    START BUCKET KEY>BU-KEY REGARDLESS INVALID GO DE-DB4.
DE-DB3. READ BUCKET NEXT REGARDLESS END GO DE-DB4. IF BU-JKEY NOT=J-KEY GO DE-DB4.
    DELETE BUCKET GO DE-DB3.
DE-DB4.
DE-DB9. EXIT.

* G-19 SHOW WORKSHEETS BY PRODUCTION ORDER
QS1. PERFORM RD104 MOVE 0 TO R-NO MOVE "N" TO QS-DTL MOVE 3 TO IXT.
QS3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
QS33. DISPLAY "NEXT M.O. NO. ______       DETAIL _" LINE IXT.
    ACCEPT IA38 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA38=999999 GO QS9.
    DISPLAY "'D': DETAIL BY DATE  'M': DETAIL BY MACHINE  'N': NO DETAILS" LINE 24 BOLD.
    ACCEPT QS-DTL LINE IXT COLUMN 35 DEFAULT CURRENT UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF NOT(QS-DTL="D" OR "M" OR "N") MOVE "N" TO QS-DTL.
    IF IA38=0 IF R-NO=0 GO QS33 ELSE GO QS4.
    MOVE IA38 TO R-NO IF R-NO<10000 MOVE 10000 TO R-NO.
    START PRODORD KEY>=R-KEY REGARDLESS INVALID PERFORM DSP-ERR11 GO QS33.
    READ PRODORD NEXT REGARDLESS MOVE R-PROD TO A-A1 PERFORM PROD-RD.
    INITIALIZE J-KEY MOVE R-NO TO J-NO PERFORM SET-JKD MOVE 0 TO INQ-IND.
QS4. PERFORM RD104 MOVE R-NO TO TF350(1) MOVE "(" TO TF350A(1) MOVE ")" TO TF350C(1).
    MOVE R-FIN TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO TF350B(1).
    MOVE P-NO TO TF351(1) MOVE PRO-DESC(1) TO TF352(1).
    MOVE 4 TO IXT IF QS-DTL NOT="N" GO QS6.

    IF INQ-IND=0 MOVE 0 TO OLD-M MOVE LOW-VALUES TO QS-MTOTALS
      START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO QS59.
QS53. READ WORKSHEET NEXT REGARDLESS END GO QS59. IF J-NO NOT=R-NO GO QS59.
    IF J-MAC=OLD-M GO QS54.
    IF OLD-M NOT=0 PERFORM QS-MTOT IF IXT>=21 GO QS58. MOVE J-MAC TO OLD-M.
QS54. ADD J-HOURS TO QS-MHOURS ADD J-QTY TO QS-MQTY ADD J-WEIGHT TO QS-MWEIGHT.
    ADD J-AWEIGHT TO QS-MAWEIGHT GO QS53.
QS58. MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO QS89.
QS59. PERFORM QS-MTOT GO QS8.

QS6. IF INQ-IND=0
      IF QS-DTL="M" START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO QS8 END-START
        ELSE START WORKSHEET KEY>J-KN REGARDLESS INVALID GO QS8.
QS63. READ WORKSHEET NEXT REGARDLESS END GO QS8. IF J-NO NOT=R-NO GO QS8.
    PERFORM CLR-LN MOVE 0 TO IX1 MOVE 20 TO IX2.
QS65. IF J-BKTOT>IX1 AND IXT>IX2
       IF QS-DTL="M" START WORKSHEET KEY=J-KEY REGARDLESS END-START
         ELSE START WORKSHEET KEY=J-KN REGARDLESS END-START END-IF GO QS76.
    ADD 5 TO IX1 SUBTRACT 1 FROM IX2 IF IX1<40 GO QS65.
    MOVE J-MAC TO TF354(IXT) A-N1 PERFORM RD-MAC MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    MOVE J-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF355(IXT).
    MOVE LIT-XDAN(J-SHIFT + 1:1) TO TF356(IXT).
    IF PROC-LOTINSP OR PROC-RECEIVE OR PROC-ADJUST OR PROC-PHYSINV
      MOVE M-DESC1 TO TF357(IXT)
     ELSE MOVE J-NAME TO TF357A(IXT) MOVE J-HOURS TO TF357B(IXT).
    MOVE J-QTY TO TF358(IXT).
    IF R-FIN=0 MOVE J-WEIGHT TO TF360(IXT)
     ELSE IF NOT PROC-PRIMARY AND J-BKEMPTY=1 MOVE "  ------" TO TF360X(IXT)
      ELSE IF J-WEIGHT NOT=0 MOVE J-WEIGHT TO TF360(IXT).
    MOVE J-AWEIGHT TO TF361(IXT) IF J-BKWRONG=1 MOVE "M" TO TF361A(IXT).
    MOVE J-HOURS TO A-D1 PERFORM CALC-TARGET MOVE A-N1 TO TF362(IXT).
    IF J-NOTE=" " OR ALL "0" GO QS70.
    ADD 1 TO IXT PERFORM CLR-LN MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-OUTCON OR PROC-LOTINSP OR PROC-RECEIVE OR PROC-ADJUST
      MOVE "FINAL:" TO TF363(IXT)
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 OR J-LOT(IX1) NOT NUMERIC OR J-LOT(IX1)=0
        MOVE J-LOT(IX1) TO TF363A(IXT,IX1) END-PERFORM
     ELSE MOVE J-NOTE TO TF364(IXT).

QS70. IF J-BKTOT=0 GO QS76.
    INITIALIZE QS-BTBL MOVE J-KEY TO BU-JKEY MOVE 0 TO BU-NUM.
    START BUCKET KEY>BU-KEY REGARDLESS INVALID GO QS74.
QS73. READ BUCKET NEXT REGARDLESS END GO QS74. IF BU-JKEY NOT=J-KEY GO QS74.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>40 OR QS-BS(IX1)=0 OR>BU-SEQ CONTINUE END-PERFORM.
    IF IX1>40 GO QS74.
    IF QS-BS(IX1) NOT=0 PERFORM VARYING IX2 FROM 40 BY -1 UNTIL IX2<IX1
      MOVE QS-BKT(IX2) TO QS-BKT(IX2 + 1) END-PERFORM.
    MOVE BU-SEQ TO QS-BS(IX1) MOVE BU-NUM TO QS-BN(IX1) MOVE BU-WEIGHT TO QS-BW(IX1).
    GO QS73.
QS74. ADD 1 TO IXT PERFORM CLR-LN MOVE "BUCKETS:" TO TF365(IXT) MOVE 0 TO IX2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL QS-BS(IX1)=0
      ADD 1 TO IX2 IF IX2=6 MOVE 1 TO IX2 ADD 1 TO IXT PERFORM CLR-LN END-IF
      MOVE QS-BN(IX1) TO TF367(IXT,IX2) MOVE ":" TO TF368(IXT,IX2)
      MOVE QS-BW(IX1) TO TF369(IXT,IX2)
      IF QS-BW(IX1)=0 MOVE "!" TO TF366(IXT,IX2) MOVE "]" TO TF370(IXT,IX2) END-IF END-PERFORM.
QS76. ADD 1 TO IXT IF IXT<21 GO QS63.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO QS89.
QS8. MOVE "*** END ***" TO TLN(IXT).
    READ PRODORD NEXT REGARDLESS END MOVE 0 TO R-NO GO QS89.
    MOVE R-PROD TO A-A1 PERFORM PROD-RD.
    INITIALIZE J-KEY MOVE R-NO TO J-NO PERFORM SET-JKD MOVE 0 TO INQ-IND.
QS89. GO QS3.
QS9. GO MN9.

QS-MTOT. PERFORM CLR-LN MOVE OLD-M TO TF354(IXT) A-N1 PERFORM RD-MAC.
    MOVE OLD-M TO A-N1 PERFORM PROC-TYPE.
    MOVE QS-MHOURS TO TF357C(IXT) MOVE QS-MQTY TO TF358(IXT).
    MOVE QS-MWEIGHT TO TF360(IXT) MOVE QS-MAWEIGHT TO TF361(IXT).
    MOVE QS-MHOURS TO A-D1 PERFORM CALC-TARGET MOVE A-N1 TO TF362(IXT).
    ADD 1 TO IXT MOVE LOW-VALUES TO QS-MTOTALS.

* G-20 MACHINE/PROCESS INFORMATION
MI1. PERFORM RD105 PERFORM WRT.
MI3. ACCEPT M-NO LINE 18 COLUMN 68 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR M-NO=9999 GO MI9.
    READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO MI3.
    PERFORM RD105 MOVE M-NO TO TF563(1).
    MOVE M-GROUP TO TF561(3) T-NO MOVE 19 TO T-TBL PERFORM RD-TBL MOVE T-LINE TO TF562(3).
    MOVE M-TYPE TO TF561(4) A-N1 PERFORM RD-MACTYPE MOVE ME-DESC TO TF562(4).
    MOVE M-SECT TO TF561(5) MOVE M-TQTY TO TF564(6) MOVE M-SPEED TO TF565(6).
    MOVE M-EFF TO TF566(6) MOVE M-TWEIGHT TO TF569(7) MOVE M-HOURS TO TF567(8).
    MOVE M-DESC1 TO TF568(9) MOVE M-DESC2 TO TF568(10) MOVE M-OPDESC TO TF559(11).
    IF M-PLT-IND<=1 MOVE LIT-NY(M-PLT-IND + 1:1) TO TF560(11).
    MOVE M-COST TO TF556(12) MOVE M-CMODE TO TF557(12) MOVE M-TCOST TO TF558(12).
    MOVE M-HCOST TO TF555(13) MOVE M-LOT-CHARGE TO TF571(14).
    MOVE M-BATCH-CHARGE TO TF572(14) MOVE M-SURCHARGE TO TF573(14).
    MOVE M-RNO TO TF570(15) MOVE M-FREIGHT TO TF570A(15) MOVE M-VENDOR TO TF574(16).
    PERFORM WRT GO MI3.
MI9. GO MN9.

* G-21 CUSTOMER FILE MAINTENANCE
MC1.
MC3. PERFORM RD30 PERFORM WRT.
    ACCEPT MC-NO LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MC-NO=ALL "9" GO MC9. IF MC-NO=" " PERFORM DSP-ERR5 GO MC3.
    ACCEPT MC-OP LINE 3 COLUMN 44 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MC-OP=9 GO MC9.
    GO MC40 MC50 MC60  DEPENDING MC-OP. PERFORM DSP-ERR1 GO MC3.
MC40. MOVE LOW-VALUES TO C-RECORD INITIALIZE C-REC MOVE MC-NO TO C-NO.
    MOVE SYS-DATE TO C-CRDATE START CUSTOMER REGARDLESS INVALID GO MC42.
    MOVE "DUPLICATE CUSTOMER NO." TO ERR-MESG PERFORM DSP-ERR GO MC3.
    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
MC42. PERFORM RD31 MOVE C-NO TO TF23(3) PERFORM WRT.
    ACCEPT C-US LINE 5 COLUMN 17 ACC-NUM.
    ACCEPT C-CLASS LINE 5 COLUMN 51 ACC-ALP.
    ACCEPT C-TYPE LINE 6 COLUMN 17 ACC-ALP.
    ACCEPT C-AUTO LINE 6 COLUMN 52 ACC-NUM.
    ACCEPT C-TER LINE 8 COLUMN 13 ACC-NUM.
    ACCEPT C-PROV LINE 8 COLUMN 30 ACC-NUM.
    ACCEPT C-SAL LINE 8 COLUMN 47 ACC-NUM.
    ACCEPT C-VIA LINE 8 COLUMN 59 ACC-NUM.
    ACCEPT C-TERMS LINE 8 COLUMN 73 ACC-NUM.
    ACCEPT C-NAME LINE 10 COLUMN 13 ACC-ALP.
    ACCEPT C-ADD1 LINE 11 COLUMN 13 ACC-ALP.
    ACCEPT C-ADD2 LINE 12 COLUMN 13 ACC-ALP.
    ACCEPT C-POST LINE 13 COLUMN 13 ACC-ALP.
    ACCEPT C-STAT LINE 15 COLUMN 18 ACC-NUM.
    ACCEPT C-BACK LINE 15 COLUMN 39 ACC-NUM.
    ACCEPT C-MTEST LINE 15 COLUMN 60 ACC-NUM.
    ACCEPT C-EDICF LINE 16 COLUMN 20 ACC-NUM.
    ACCEPT C-BROKER LINE 16 COLUMN 34 ACC-NUM.
    ACCEPT C-INS LINE 18 COLUMN 13 ACC-NUM.
    ACCEPT C-CREDIT LINE 18 COLUMN 41 ACC-NUM.
    ACCEPT C-DB LINE 18 COLUMN 68 ACC-ALP.
    ACCEPT C-GST LINE 19 COLUMN 15 ACC-ALP.
    ACCEPT C-PST LINE 19 COLUMN 40 ACC-ALP.
    ACCEPT C-IRS LINE 19 COLUMN 61 ACC-ALP.
    ACCEPT C-SUPPLIER LINE 20 COLUMN 17 ACC-ALP.
    WRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER GO MC3.
    REPLACE OFF.
MC50. MOVE MC-NO TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO MC3.
    PERFORM RD32 MOVE C-NO TO TF24(3) MOVE C-NAME TO TF25(3) PERFORM WRT.
    MOVE USN-USER TO US-USER READ USERS REGARDLESS INVALID GO MC3.
MC53. ACCEPT MC-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      IF MC-FLD=US-CFLD(IX1) GO MC54 END-IF IF US-CFLD(IX1)>0 MOVE 1 TO WS1 END-IF END-PERFORM.
    IF WS1=1 PERFORM DSP-ERR46 GO MC53.
* note 269.1
MC54. GO MC551 MC552 MC553 MC554 MC555 MC556 MC557 MC558 MC559 MC5510
       MC5511 MC5512 MC5513 MC5514 MC5515 MC5516 MC5517 MC5518 MC5519 MC5520
       MC5521 MC5522 MC5523 MC5524 MC5525 MC5526 MC5527 MC5528 MC5529 MC5530
       MC5531 MC5532 MC5533 MC5534 MC5535 MC5536 MC5537 MC5538 MC5539 MC5540
       MC5541 MC5542 MC5543 MC5544 MC5545 MC5546
      DEPENDING MC-FLD. GO MC3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
MC551. DISPLAY C-TER COLUMN 30 CONVERSION BOLD ACCEPT C-TER ACC-NUM.
    MOVE C-TER TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-TER GO MC58.
MC552. DISPLAY C-PROV COLUMN 30 CONVERSION BOLD ACCEPT C-PROV ACC-NUM.
    MOVE C-PROV TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-PROV GO MC58.
MC553. DISPLAY C-SAL COLUMN 30 CONVERSION BOLD ACCEPT C-SAL ACC-NUM.
    MOVE C-SAL TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-SAL GO MC58.
MC554. DISPLAY C-NAME COLUMN 30 BOLD ACCEPT C-NAME ACC-ALP.
    MOVE C-NAME TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-NAME GO MC58.
MC555. DISPLAY C-ADD1 COLUMN 30 BOLD ACCEPT C-ADD1 ACC-ALP.
    MOVE C-ADD1 TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-ADD1 GO MC58.
MC556. DISPLAY C-ADD2 COLUMN 30 BOLD ACCEPT C-ADD2 ACC-ALP.
    MOVE C-ADD2 TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-ADD2 GO MC58.
MC557. DISPLAY C-POST COLUMN 30 BOLD ACCEPT C-POST ACC-ALP.
    MOVE C-POST TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-POST GO MC58.
MC558. DISPLAY C-STAT COLUMN 30 CONVERSION BOLD ACCEPT C-STAT ACC-NUM.
    MOVE C-STAT TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-STAT GO MC58.
MC559. DISPLAY C-BACK COLUMN 30 CONVERSION BOLD ACCEPT C-BACK ACC-NUM.
    MOVE C-BACK TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-BACK GO MC58.
MC5510. DISPLAY C-INS COLUMN 30 CONVERSION BOLD ACCEPT C-INS ACC-NUM.
    MOVE C-INS TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-INS GO MC58.
MC5511. DISPLAY C-CREDIT COLUMN 30 CONVERSION BOLD ACCEPT C-CREDIT ACC-NUM.
    MOVE C-CREDIT TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-CREDIT GO MC58.
MC5512. DISPLAY C-DB COLUMN 30 BOLD ACCEPT C-DB ACC-ALP.
    MOVE C-DB TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-DB GO MC58.
MC5513. DISPLAY C-GST COLUMN 30 BOLD ACCEPT C-GST ACC-ALP.
    MOVE C-GST TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-GST GO MC58.
MC5514. DISPLAY C-PST COLUMN 30 BOLD ACCEPT C-PST ACC-ALP.
    MOVE C-PST TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-PST GO MC58.
MC5515. DISPLAY C-TOT COLUMN 30 CONVERSION BOLD ACCEPT C-TOT ACC-NUM.
    MOVE C-TOT TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-TOT GO MC58.
MC5516. DISPLAY C-CUR COLUMN 30 CONVERSION BOLD ACCEPT C-CUR ACC-NUM.
    MOVE C-CUR TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-CUR GO MC58.
MC5517. DISPLAY C-30 COLUMN 30 CONVERSION BOLD ACCEPT C-30 ACC-NUM.
    MOVE C-30 TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-30 GO MC58.
MC5518. DISPLAY C-60 COLUMN 30 CONVERSION BOLD ACCEPT C-60 ACC-NUM.
    MOVE C-60 TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-60 GO MC58.
MC5519. DISPLAY C-90 COLUMN 30 CONVERSION BOLD ACCEPT C-90 ACC-NUM.
    MOVE C-90 TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-90 GO MC58.
MC5520. DISPLAY C-120 COLUMN 30 CONVERSION BOLD ACCEPT C-120 ACC-NUM.
    MOVE C-120 TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-120 GO MC58.
MC5521. DISPLAY C-MTD COLUMN 30 CONVERSION BOLD ACCEPT C-MTD ACC-NUM.
    MOVE C-MTD TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-MTD GO MC58.
MC5522. DISPLAY C-YTD COLUMN 30 CONVERSION BOLD ACCEPT C-YTD ACC-NUM.
    MOVE C-YTD TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-YTD GO MC58.
MC5523. DISPLAY C-ORD COLUMN 30 CONVERSION BOLD ACCEPT C-ORD ACC-NUM.
    MOVE C-ORD TO WD1 PERFORM RDLK-CUSTOMER MOVE WD1 TO C-ORD GO MC58.
MC5524. DISPLAY C-TYPE COLUMN 30 BOLD ACCEPT C-TYPE ACC-ALP.
    MOVE C-TYPE TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-TYPE GO MC58.
MC5525. DISPLAY C-IRS COLUMN 30 BOLD ACCEPT C-IRS ACC-ALP.
    MOVE C-IRS TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-IRS GO MC58.
MC5526. DISPLAY C-VIA COLUMN 30 CONVERSION BOLD ACCEPT C-VIA ACC-NUM.
    MOVE C-VIA TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-VIA GO MC58.
MC5527. DISPLAY C-HOLD COLUMN 30 CONVERSION BOLD ACCEPT C-HOLD ACC-NUM.
    MOVE C-HOLD TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-HOLD GO MC58.
MC5528. DISPLAY C-LAST COLUMN 30 CONVERSION BOLD ACCEPT C-LAST ACC-NUM.
    MOVE C-LAST TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-LAST GO MC58.
MC5529. DISPLAY C-BLAST COLUMN 30 CONVERSION BOLD ACCEPT C-BLAST ACC-NUM.
    MOVE C-BLAST TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-BLAST GO MC58.
MC5530. DISPLAY C-INFO(1) COLUMN 30 BOLD ACCEPT C-INFO(1) ACC-ALP.
    MOVE C-INFO(1) TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-INFO(1) GO MC58.
MC5531. DISPLAY C-INFO(2) COLUMN 30 BOLD ACCEPT C-INFO(2) ACC-ALP.
    MOVE C-INFO(2) TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-INFO(2) GO MC58.
MC5532. DISPLAY C-INFO(3) COLUMN 30 BOLD ACCEPT C-INFO(3) ACC-ALP.
    MOVE C-INFO(3) TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-INFO(3) GO MC58.
MC5533. DISPLAY C-AUTO COLUMN 30 CONVERSION BOLD ACCEPT C-AUTO ACC-NUM.
    MOVE C-AUTO TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-AUTO GO MC58.
MC5534. DISPLAY C-CONTRA COLUMN 30 CONVERSION BOLD ACCEPT C-CONTRA ACC-NUM.
    MOVE C-CONTRA TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-CONTRA GO MC58.
MC5535. DISPLAY C-MTEST COLUMN 30 CONVERSION BOLD ACCEPT C-MTEST ACC-NUM.
    MOVE C-MTEST TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-MTEST GO MC58.
MC5536. DISPLAY C-US COLUMN 30 CONVERSION BOLD ACCEPT C-US ACC-NUM.
    MOVE C-US TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-US GO MC58.
MC5537. DISPLAY C-EDICF COLUMN 30 CONVERSION BOLD ACCEPT C-EDICF ACC-NUM.
    MOVE C-EDICF TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-EDICF GO MC58.
MC5538. DISPLAY C-INACTIVE COLUMN 30 CONVERSION BOLD ACCEPT C-INACTIVE ACC-NUM.
    MOVE C-INACTIVE TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-INACTIVE GO MC58.
MC5539. DISPLAY C-CLASS COLUMN 30 BOLD ACCEPT C-CLASS ACC-ALP.
    MOVE C-CLASS TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-CLASS GO MC58.
MC5540. DISPLAY C-LABEL COLUMN 30 CONVERSION BOLD ACCEPT C-LABEL ACC-NUM.
    MOVE C-LABEL TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-LABEL GO MC58.
MC5541. DISPLAY C-BROKER COLUMN 30 CONVERSION BOLD ACCEPT C-BROKER ACC-NUM.
    MOVE C-BROKER TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-BROKER GO MC58.
MC5542. DISPLAY C-TERMS COLUMN 30 CONVERSION BOLD ACCEPT C-TERMS ACC-NUM.
    MOVE C-TERMS TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-TERMS GO MC58.
MC5543. DISPLAY C-SURLN COLUMN 30 CONVERSION BOLD ACCEPT C-SURLN ACC-NUM.
    MOVE C-SURLN TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-SURLN GO MC58.
MC5544. DISPLAY C-MCUS COLUMN 30 BOLD ACCEPT C-MCUS ACC-ALP.
    MOVE C-MCUS TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-MCUS GO MC58.
MC5545. DISPLAY C-SUPPLIER COLUMN 30 BOLD ACCEPT C-SUPPLIER ACC-ALP.
    MOVE C-SUPPLIER TO WA1 PERFORM RDLK-CUSTOMER MOVE WA1 TO C-SUPPLIER GO MC58.
MC5546. DISPLAY C-SUR COLUMN 30 CONVERSION BOLD ACCEPT C-SUR ACC-NUM.
    MOVE C-SUR TO WN1 PERFORM RDLK-CUSTOMER MOVE WN1 TO C-SUR GO MC58.
MC58. REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER GO MC53.
    REPLACE OFF.
MC60. MOVE MC-NO TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO MC3.
    IF C-NAME=" " DELETE CUSTOMER ELSE PERFORM DSP-ERR59. GO MC3.
MC9. GO MN9.

* G-22 PRODUCT FILE MAINTENANCE
MP1.
MP3. PERFORM RD33 PERFORM WRT.
    ACCEPT MP-NO LINE 3 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MP-NO=ALL "9" GO MP9. IF MP-NO=" " PERFORM DSP-ERR6 GO MP3.
    ACCEPT MP-OP LINE 3 COLUMN 44 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MP-OP=9 GO MP9.
    GO MP40 MP50 MP60  DEPENDING MP-OP. PERFORM DSP-ERR1 GO MP3.
MP40. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 OR MP-NO(IX1:1)=" "
       IF MP-NO(IX1:1) ALPHABETIC-LOWER
         MOVE "NO LOWER-CASE LETTERS ALLOWED IN PRODUCT NUMBER" TO ERR-MESG
         PERFORM DSP-ERR GO MP3 END-IF END-PERFORM.
    PERFORM INIT-P MOVE MP-NO TO P-NO START PRODUCT REGARDLESS INVALID GO MP42.
    MOVE "DUPLICATE PRODUCT NO." TO ERR-MESG PERFORM DSP-ERR GO MP3.
    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
MP42. PERFORM RD34 MOVE P-NO TO TF22(3) PERFORM WRT.
    ACCEPT P-CAT LINE 3 COLUMN 47 ACC-NUM.
    ACCEPT P-FAMILY LINE 3 COLUMN 62 ACC-NUM.
    ACCEPT P-MARKET LINE 3 COLUMN 77 ACC-NUM.
    ACCEPT P-MODE LINE 5 COLUMN 43 ACC-ALP.
    ACCEPT P-GEN LINE 5 COLUMN 68 ACC-ALP.
    ACCEPT P-DESC(1:16) LINE 6 COLUMN 16 ACC-ALP.
    ACCEPT P-DESC(17:) LINE 6 COLUMN 33 ACC-ALP.
    ACCEPT P-EDESC1 LINE 7 COLUMN 16 ACC-ALP.
    ACCEPT P-EDESC2 LINE 8 COLUMN 16 ACC-ALP.
    ACCEPT P-FINDESC LINE 9 COLUMN 16 ACC-ALP.
    ACCEPT P-PRDESC LINE 10 COLUMN 16 ACC-ALP.
    ACCEPT P-PRINT LINE 11 COLUMN 12 ACC-NUM.
    ACCEPT P-PRINT-REV LINE 11 COLUMN 35 ACC-ALP.
    ACCEPT P-CUS LINE 12 COLUMN 11 ACC-ALP.
    ACCEPT P-SPEC LINE 12 COLUMN 32 ACC-ALP.
    ACCEPT P-TAX LINE 12 COLUMN 67 ACC-NUM.
    ACCEPT P-PRICE1 LINE 13 COLUMN 11 ACC-NUM.
    ACCEPT P-PRICE2 LINE 13 COLUMN 32 ACC-NUM.
    ACCEPT P-CHGPR LINE 13 COLUMN 60 ACC-NUM.
    ACCEPT P-COST LINE 13 COLUMN 72 ACC-NUM.
    ACCEPT P-ROP LINE 15 COLUMN 17 ACC-NUM.
    ACCEPT P-EST LINE 15 COLUMN 47 ACC-NUM.
    ACCEPT P-LEVEL LINE 15 COLUMN 79 ACC-NUM.
    ACCEPT P-BANK LINE 16 COLUMN 13 ACC-NUM.
    ACCEPT P-LEAD LINE 16 COLUMN 40 ACC-NUM.
    ACCEPT P-MAC LINE 17 COLUMN 14 ACC-NUM.
    ACCEPT P-RATE LINE 17 COLUMN 33 ACC-NUM.
    ACCEPT P-WEIGHT LINE 17 COLUMN 53 ACC-NUM.
    ACCEPT P-GROSS LINE 17 COLUMN 74 ACC-NUM.
    ACCEPT P-HCODE LINE 19 COLUMN 16 ACC-NUM.
    ACCEPT P-TCOLOR LINE 19 COLUMN 37 ACC-NUM.
    ACCEPT P-PLSPEC LINE 19 COLUMN 62 ACC-NUM.
    ACCEPT P-DIAM LINE 20 COLUMN 12 ACC-ALP.
    ACCEPT P-GRADE LINE 20 COLUMN 29 ACC-ALP.
    ACCEPT P-WIRE LINE 20 COLUMN 54 ACC-NUM.
    ACCEPT P-PROC LINE 21 COLUMN 16 ACC-NUM.
    ACCEPT P-CLEAN LINE 21 COLUMN 37 ACC-NUM.
    ACCEPT P-PACKING LINE 22 COLUMN 16 ACC-NUM.
    ACCEPT P-QTY-PACK LINE 22 COLUMN 35 ACC-NUM.
    ACCEPT P-CONT LINE 22 COLUMN 60 ACC-ALP.
    WRITE P-RECORD ALLOWING NO UNLOCK PRODUCT PERFORM MP-A GO MP3.
    REPLACE OFF.
MP50. MOVE MP-NO TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO MP3.
    PERFORM PROD-DESC.
    PERFORM RD35 MOVE P-NO TO TF20(1) MOVE PRO-DESC(1) TO TF21(1) PERFORM WRT.
    MOVE USN-USER TO US-USER READ USERS REGARDLESS INVALID GO MP3.
MP53. ACCEPT MP-FLD LINE 22 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 23 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 22 COLUMN 30 ERASE END LINE.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      IF MP-FLD=US-PFLD(IX1) GO MP54 END-IF IF US-PFLD(IX1)>0 MOVE 1 TO WS1 END-IF END-PERFORM.
    IF WS1=1 PERFORM DSP-ERR46 GO MP53.
* note 269.2
MP54. GO MP551 MP552 MP553 MP554 MP555 MP556 MP557 MP558 MP559 MP5510
       MP5511 MP5512 MP5513 MP5514 MP5515 MP5516 MP5517 MP5518 MP5519 MP5520
       MP5521 MP5522 MP5523 MP5524 MP5525 MP5526 MP5527 MP5528 MP5529 MP5530
       MP5531 MP5532 MP5533 MP5534 MP5535 MP5536 MP5537 MP5538 MP5539 MP5540
       MP5541 MP5542 MP5543 MP5544 MP5545 MP5546 MP5547 MP5548 MP5549 MP5550
       MP5551 MP5552 MP5553 MP5554 MP5555 MP5556 MP5557 MP5558 MP5559 MP5560
       MP5561 MP5562 MP5563 MP5564 MP5565 MP5566 MP5567 MP5568
      DEPENDING MP-FLD. GO MP3.
    REPLACE ==ACC-ALP== BY ==LINE 23 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 23 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
MP551. DISPLAY P-CAT COLUMN 30 CONVERSION BOLD ACCEPT P-CAT ACC-NUM.
    MOVE P-CAT TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-CAT GO MP58.
MP552. DISPLAY P-MODE COLUMN 30 BOLD ACCEPT P-MODE ACC-ALP.
    MOVE P-MODE TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-MODE GO MP58.
MP553. DISPLAY P-DESC(1:16) COLUMN 30 BOLD " " COLUMN 46 REVERSED P-DESC(17:) COLUMN 47 BOLD.
    DISPLAY " " LINE 23 COLUMN 46 REVERSED.
    ACCEPT P-DESC(1:16) ACC-ALP.
    ACCEPT P-DESC(17:) LINE 23 COLUMN 47 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE P-DESC TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-DESC GO MP58.
MP554. DISPLAY P-VENDOR COLUMN 30 CONVERSION BOLD ACCEPT P-VENDOR ACC-NUM.
    MOVE P-VENDOR TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-VENDOR GO MP58.
MP555. DISPLAY P-TAX COLUMN 30 CONVERSION BOLD ACCEPT P-TAX ACC-NUM.
    MOVE P-TAX TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-TAX GO MP58.
MP556. MOVE P-GEN TO MP-GEN DISPLAY P-GEN COLUMN 30 BOLD ACCEPT P-GEN ACC-ALP.
    MOVE P-GEN TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-GEN PERFORM MP-A GO MP58.
MP557. DISPLAY P-ALT-V COLUMN 30 CONVERSION BOLD ACCEPT P-ALT-V ACC-NUM.
    MOVE P-ALT-V TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-ALT-V GO MP58.
MP558. DISPLAY P-PRICE1 COLUMN 30 CONVERSION BOLD ACCEPT P-PRICE1 ACC-NUM.
    MOVE P-PRICE1 TO WT1 PERFORM RDLK-PRODUCT MOVE WT1 TO P-PRICE1 GO MP58.
MP559. DISPLAY P-PRICE2 COLUMN 30 CONVERSION BOLD ACCEPT P-PRICE2 ACC-NUM.
    MOVE P-PRICE2 TO WT1 PERFORM RDLK-PRODUCT MOVE WT1 TO P-PRICE2 GO MP58.
MP5510. DISPLAY P-WEIGHT COLUMN 30 CONVERSION BOLD ACCEPT P-WEIGHT ACC-NUM.
    MOVE P-WEIGHT TO WD1 PERFORM RDLK-PRODUCT MOVE WD1 TO P-WEIGHT.
    MOVE SYS-DATE TO P-NDATE GO MP58.
MP5511. MOVE P-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT COLUMN 30 BOLD.
    MOVE P-DATE TO D-DATE MOVE 23 TO IXT MOVE 30 TO IXU.
    PERFORM AX-DT-DEF MOVE DATE0 TO P-DATE.
    MOVE P-DATE TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-DATE GO MP58.
MP5512. DISPLAY P-HAND COLUMN 30 CONVERSION BOLD ACCEPT P-HAND ACC-NUM.
    MOVE P-HAND TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-HAND GO MP58.
MP5513. DISPLAY P-ORDER COLUMN 30 CONVERSION BOLD ACCEPT P-ORDER ACC-NUM.
    MOVE P-ORDER TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-ORDER GO MP58.
MP5514. DISPLAY P-DEMAND COLUMN 30 CONVERSION BOLD ACCEPT P-DEMAND ACC-NUM.
    MOVE P-DEMAND TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-DEMAND GO MP58.
MP5515. DISPLAY P-MTD COLUMN 30 CONVERSION BOLD ACCEPT P-MTD ACC-NUM.
    MOVE P-MTD TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-MTD GO MP58.
MP5516. DISPLAY P-YTD COLUMN 30 CONVERSION BOLD ACCEPT P-YTD ACC-NUM.
    MOVE P-YTD TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-YTD GO MP58.
MP5517. DISPLAY P-LAST COLUMN 30 CONVERSION BOLD ACCEPT P-LAST ACC-NUM.
    MOVE P-LAST TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-LAST GO MP58.
MP5518. DISPLAY P-W-MTD COLUMN 30 CONVERSION BOLD ACCEPT P-W-MTD ACC-NUM.
    MOVE P-W-MTD TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-W-MTD GO MP58.
MP5519. DISPLAY P-W-YTD COLUMN 30 CONVERSION BOLD ACCEPT P-W-YTD ACC-NUM.
    MOVE P-W-YTD TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-W-YTD GO MP58.
MP5520. DISPLAY P-ROP COLUMN 30 CONVERSION BOLD ACCEPT P-ROP ACC-NUM.
    MOVE P-ROP TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-ROP GO MP58.
MP5521. DISPLAY P-PREV COLUMN 30 CONVERSION BOLD ACCEPT P-PREV ACC-NUM.
    MOVE P-PREV TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PREV GO MP58.
MP5522. DISPLAY P-MAC COLUMN 30 CONVERSION BOLD ACCEPT P-MAC ACC-NUM.
    MOVE P-MAC TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-MAC GO MP58.
MP5523. DISPLAY P-RATE COLUMN 30 CONVERSION BOLD ACCEPT P-RATE ACC-NUM.
    MOVE P-RATE TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-RATE GO MP58.
MP5524. DISPLAY P-COST COLUMN 30 CONVERSION BOLD ACCEPT P-COST ACC-NUM.
    MOVE P-COST TO WT1 PERFORM RDLK-PRODUCT MOVE WT1 TO P-COST GO MP58.
MP5525. DISPLAY P-A-MTD COLUMN 30 CONVERSION BOLD ACCEPT P-A-MTD ACC-NUM.
    MOVE P-A-MTD TO WD1 PERFORM RDLK-PRODUCT MOVE WD1 TO P-A-MTD GO MP58.
MP5526. DISPLAY P-A-YTD COLUMN 30 CONVERSION BOLD ACCEPT P-A-YTD ACC-NUM.
    MOVE P-A-YTD TO WD1 PERFORM RDLK-PRODUCT MOVE WD1 TO P-A-YTD GO MP58.
MP5527. DISPLAY P-EST COLUMN 30 CONVERSION BOLD ACCEPT P-EST ACC-NUM.
    MOVE P-EST TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-EST GO MP58.
MP5528. DISPLAY P-LEVEL COLUMN 30 CONVERSION BOLD ACCEPT P-LEVEL ACC-NUM.
    MOVE P-LEVEL TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-LEVEL GO MP58.
MP5529. DISPLAY P-LEAD COLUMN 30 CONVERSION BOLD ACCEPT P-LEAD ACC-NUM.
    MOVE P-LEAD TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-LEAD GO MP58.
MP5530. DISPLAY P-CUS COLUMN 30 BOLD ACCEPT P-CUS ACC-ALP.
    MOVE P-CUS TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-CUS GO MP58.
MP5531. DISPLAY P-TCOLOR COLUMN 30 CONVERSION BOLD ACCEPT P-TCOLOR ACC-NUM.
    MOVE P-TCOLOR TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-TCOLOR GO MP58.
MP5532. DISPLAY P-PUR-PART COLUMN 30 BOLD ACCEPT P-PUR-PART ACC-ALP.
    MOVE P-PUR-PART TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-PUR-PART GO MP58.
MP5533. DISPLAY P-HCODE COLUMN 30 CONVERSION BOLD ACCEPT P-HCODE ACC-NUM.
    MOVE P-HCODE TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-HCODE GO MP58.
MP5534. DISPLAY P-FINDESC COLUMN 30 BOLD ACCEPT P-FINDESC ACC-ALP.
    MOVE P-FINDESC TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-FINDESC GO MP58.
MP5535. DISPLAY P-PRDESC COLUMN 30 BOLD ACCEPT P-PRDESC ACC-ALP.
    MOVE P-PRDESC TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-PRDESC GO MP58.
MP5536. DISPLAY P-DIAM COLUMN 30 BOLD ACCEPT P-DIAM ACC-ALP.
    MOVE P-DIAM TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-DIAM GO MP58.
MP5537. DISPLAY P-GRADE COLUMN 30 BOLD ACCEPT P-GRADE ACC-ALP.
    MOVE P-GRADE TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-GRADE GO MP58.
MP5538. DISPLAY P-WIRE COLUMN 30 CONVERSION BOLD ACCEPT P-WIRE ACC-NUM.
    MOVE P-WIRE TO WV1 PERFORM RDLK-PRODUCT MOVE WV1 TO P-WIRE GO MP58.
MP5539. DISPLAY P-PROC COLUMN 30 CONVERSION BOLD ACCEPT P-PROC ACC-NUM.
    MOVE P-PROC TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PROC GO MP58.
MP5540. DISPLAY P-CLEAN COLUMN 30 CONVERSION BOLD ACCEPT P-CLEAN ACC-NUM.
    MOVE P-CLEAN TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-CLEAN GO MP58.
MP5541. DISPLAY P-EDESC1 COLUMN 30 BOLD ACCEPT P-EDESC1 ACC-ALP.
    MOVE P-EDESC1 TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-EDESC1 GO MP58.
MP5542. DISPLAY P-EDESC2 COLUMN 30 BOLD ACCEPT P-EDESC2 ACC-ALP.
    MOVE P-EDESC2 TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-EDESC2 GO MP58.
MP5543. DISPLAY P-CUSPART COLUMN 30 BOLD ACCEPT P-CUSPART ACC-ALP.
    MOVE P-CUSPART TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-CUSPART GO MP58.
MP5544. DISPLAY P-MARKET COLUMN 30 CONVERSION BOLD ACCEPT P-MARKET ACC-NUM.
    MOVE P-MARKET TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-MARKET GO MP58.
MP5545. DISPLAY P-PRINT COLUMN 30 CONVERSION BOLD ACCEPT P-PRINT ACC-NUM.
    MOVE P-PRINT TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PRINT GO MP58.
MP5546. DISPLAY P-PRINT-REV COLUMN 30 BOLD ACCEPT P-PRINT-REV ACC-ALP.
    MOVE P-PRINT-REV TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-PRINT-REV GO MP58.
MP5547. DISPLAY P-CHGPR COLUMN 30 CONVERSION BOLD ACCEPT P-CHGPR ACC-NUM.
    MOVE P-CHGPR TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-CHGPR GO MP58.
MP5548. DISPLAY P-PLSPEC COLUMN 30 CONVERSION BOLD ACCEPT P-PLSPEC ACC-NUM.
    MOVE P-PLSPEC TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PLSPEC GO MP58.
MP5549. DISPLAY P-FAMILY COLUMN 30 CONVERSION BOLD ACCEPT P-FAMILY ACC-NUM.
    MOVE P-FAMILY TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-FAMILY GO MP58.
MP5550. DISPLAY P-INACTIVE COLUMN 30 CONVERSION BOLD ACCEPT P-INACTIVE ACC-NUM.
    MOVE P-INACTIVE TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-INACTIVE GO MP58.
MP5551. DISPLAY P-ALT-MAC COLUMN 30 CONVERSION BOLD ACCEPT P-ALT-MAC ACC-NUM.
    MOVE P-ALT-MAC TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-ALT-MAC GO MP58.
MP5552. DISPLAY P-UPC COLUMN 30 CONVERSION BOLD ACCEPT P-UPC ACC-NUM.
    MOVE P-UPC TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-UPC GO MP58.
MP5553. DISPLAY P-QUOTNO COLUMN 30 CONVERSION BOLD ACCEPT P-QUOTNO ACC-NUM.
    MOVE P-QUOTNO TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-QUOTNO GO MP58.
MP5554. DISPLAY P-TCOST COLUMN 30 CONVERSION BOLD ACCEPT P-TCOST ACC-NUM.
    MOVE P-TCOST TO WT1 PERFORM RDLK-PRODUCT MOVE WT1 TO P-TCOST GO MP58.
MP5555. DISPLAY P-PPAP COLUMN 30 CONVERSION BOLD ACCEPT P-PPAP ACC-NUM.
    MOVE P-PPAP TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PPAP GO MP58.
MP5556. DISPLAY P-INC-NUT COLUMN 30 CONVERSION BOLD ACCEPT P-INC-NUT ACC-NUM.
    MOVE P-INC-NUT TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-INC-NUT GO MP58.
MP5557. DISPLAY P-LABELS COLUMN 30 CONVERSION BOLD ACCEPT P-LABELS ACC-NUM.
    MOVE P-LABELS TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-LABELS GO MP58.
MP5558. DISPLAY P-PACKING COLUMN 30 CONVERSION BOLD ACCEPT P-PACKING ACC-NUM.
    MOVE P-PACKING TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PACKING GO MP58.
MP5559. DISPLAY P-QTY-PACK COLUMN 30 CONVERSION BOLD ACCEPT P-QTY-PACK ACC-NUM.
    MOVE P-QTY-PACK TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-QTY-PACK GO MP58.
MP5560. DISPLAY P-GROSS COLUMN 30 CONVERSION BOLD ACCEPT P-GROSS ACC-NUM.
    MOVE P-GROSS TO WD1 PERFORM RDLK-PRODUCT MOVE WD1 TO P-GROSS.
    MOVE SYS-DATE TO P-GDATE GO MP58.
MP5561. DISPLAY P-SPEC COLUMN 30 BOLD ACCEPT P-SPEC ACC-ALP.
    MOVE P-SPEC TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-SPEC GO MP58.
MP5562. DISPLAY P-BANK COLUMN 30 CONVERSION BOLD ACCEPT P-BANK ACC-NUM.
    MOVE P-BANK TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-BANK GO MP58.
MP5563. DISPLAY P-CONT COLUMN 30 BOLD ACCEPT P-CONT ACC-ALP.
    MOVE P-CONT TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-CONT GO MP58.
MP5564. DISPLAY P-PROCESS COLUMN 30 CONVERSION BOLD ACCEPT P-PROCESS ACC-NUM.
    MOVE P-PROCESS TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PROCESS GO MP58.
MP5565. DISPLAY P-NUT COLUMN 30 BOLD ACCEPT P-NUT ACC-ALP.
    MOVE P-NUT TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-NUT GO MP58.
MP5566. DISPLAY P-WEIGHT-NUT COLUMN 30 CONVERSION BOLD ACCEPT P-WEIGHT-NUT ACC-NUM.
    MOVE P-WEIGHT-NUT TO WD1 PERFORM RDLK-PRODUCT MOVE WD1 TO P-WEIGHT-NUT GO MP58.
MP5567. DISPLAY P-ORD COLUMN 30 CONVERSION BOLD ACCEPT P-ORD ACC-NUM.
    MOVE P-ORD TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-ORD GO MP58.
MP5568. DISPLAY P-PWEIGHT COLUMN 30 CONVERSION BOLD ACCEPT P-PWEIGHT ACC-NUM.
    MOVE P-PWEIGHT TO WD1 PERFORM RDLK-PRODUCT MOVE WD1 TO P-PWEIGHT GO MP58.
MP58. REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT GO MP53.
    REPLACE OFF.
MP60. MOVE MP-NO TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO MP3.
    INITIALIZE SH-KP MOVE P-NO TO SH-KPROD.
    START SALHIST KEY>SH-KP REGARDLESS INVALID GO MP62.
    READ SALHIST NEXT REGARDLESS END GO MP62. IF SH-KPROD NOT=P-NO GO MP62.
    MOVE "CANNOT DELETE - THIS PRODUCT HAS HISTORY RECORDS" TO ERR-MESG.
    PERFORM DSP-ERR GO MP3.
MP62. MOVE P-NO TO TS-PROD MOVE 0 TO TS-MAC.
    START TOOLS KEY>TS-KEY REGARDLESS INVALID GO MP64.
    READ TOOLS NEXT REGARDLESS END GO MP64. IF TS-PROD NOT=P-NO GO MP64.
    MOVE "CANNOT DELETE - THIS PRODUCT HAS TOOL LISTS" TO ERR-MESG.
    PERFORM DSP-ERR GO MP3.
MP64. MOVE P-NO TO OP-PROD MOVE 0 TO OP-MAC.
    START OPERATIONS KEY>OP-KEY REGARDLESS INVALID GO MP66.
    READ OPERATIONS NEXT REGARDLESS END GO MP66. IF OP-PROD NOT=P-NO GO MP66.
    MOVE "CANNOT DELETE - THIS PRODUCT HAS OPERATIONS LISTS" TO ERR-MESG.
    PERFORM DSP-ERR GO MP3.
MP66. IF P-DESC=" " DELETE PRODUCT PERFORM MP-A ELSE PERFORM DSP-ERR60. GO MP3.
MP9. GO MN9.

MP-A. MOVE LOW-VALUES TO AL-RECORD.
    IF MP-OP=1 MOVE P-GEN TO MP-GEN PERFORM MP-P WRITE AL-RECORD ALLOWING NO UNLOCK ALTERNATES.
    IF MP-OP=2 AND MP-GEN NOT=P-GEN PERFORM MP-P DELETE ALTERNATES
      MOVE P-GEN TO MP-GEN PERFORM MP-P WRITE AL-RECORD ALLOWING NO UNLOCK ALTERNATES.
    IF MP-OP=3 MOVE P-GEN TO MP-GEN PERFORM MP-P DELETE ALTERNATES.
MP-P. IF MP-GEN=" " MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT
       ELSE MOVE MP-GEN TO AL-PROD MOVE P-NO TO AL-ALT.

* G-23 BIN FILE MAINTENANCE
MB1.
MB3. PERFORM RD36 PERFORM WRT.
    DISPLAY "TO ADD A RANGE OF BINS LEAVE BIN NO. BLANK" LINE 24 BOLD.
    ACCEPT MB-NO LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR MB-NO=ALL "9" GO MB9. IF MB-NO=" " GO MB70.
    IF MB-NO(1:1)="Q" MOVE "FOR 'Q' BINS USE Q BINS MAINTENANCE FUNCTIONS"
      TO ERR-MESG PERFORM DSP-ERR GO MB3.
    ACCEPT MB-OP LINE 3 COLUMN 44 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MB-OP=9 GO MB9.
    GO MB40 MB50 MB60  DEPENDING MB-OP. PERFORM DSP-ERR1 GO MB3.
MB40. MOVE LOW-VALUES TO B-RECORD INITIALIZE B-REC MOVE MB-NO TO B-NO.
    START BIN REGARDLESS INVALID GO MB42.
    MOVE "DUPLICATE BIN NO." TO ERR-MESG PERFORM DSP-ERR GO MB3.
MB42. PERFORM RD37 MOVE B-NO TO TF26(3) PERFORM WRT.
MB421. ACCEPT B-PROD LINE 5 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM MB-CHKP IF A-S1=1 GO MB421.
    MOVE 6 TO IXT MOVE 18 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO B-DATE.
    ACCEPT B-QTY LINE 7 COLUMN 7 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT B-QTY-AL LINE 7 COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT B-QTY-PACK LINE 7 COLUMN 67 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
MB425. ACCEPT B-LOT LINE 8 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM MB-CHKL IF A-S1=1 GO MB425. PERFORM SET-B-LYEAR.
    ACCEPT B-CONT LINE 8 COLUMN 39 DEFAULT " " UNDERLINED PROTECTED EDITING.
    WRITE B-RECORD ALLOWING NO UNLOCK BIN GO MB3.
MB50. MOVE MB-NO TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO MB3.
    PERFORM RD38 MOVE B-NO TO TF27(3) PERFORM WRT PERFORM RD38A PERFORM WRT.
MB53. ACCEPT MB-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
MB533. DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO MB551 MB552 MB553 MB554 MB555 MB556 MB557
      DEPENDING MB-FLD. GO MB3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
MB551. DISPLAY B-PROD COLUMN 30 BOLD ACCEPT B-PROD ACC-ALP.
    PERFORM MB-CHKP IF A-S1=1 GO MB533.
    MOVE B-PROD TO WA1 PERFORM RDLK-BIN MOVE WA1 TO B-PROD GO MB58.
MB552. MOVE B-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT COLUMN 30 BOLD.
    MOVE B-DATE TO D-DATE MOVE 21 TO IXT MOVE 30 TO IXU.
    PERFORM AX-DT-DEF MOVE DATE0 TO B-DATE.
    MOVE B-DATE TO WN1 PERFORM RDLK-BIN MOVE WN1 TO B-DATE GO MB58.
MB553. DISPLAY B-QTY COLUMN 30 CONVERSION BOLD ACCEPT B-QTY ACC-NUM.
    MOVE B-QTY TO WN1 PERFORM RDLK-BIN MOVE WN1 TO B-QTY GO MB58.
MB554. DISPLAY B-QTY-AL COLUMN 30 CONVERSION BOLD ACCEPT B-QTY-AL ACC-NUM.
    MOVE B-QTY-AL TO WN1 PERFORM RDLK-BIN MOVE WN1 TO B-QTY-AL GO MB58.
MB555. DISPLAY B-LOT COLUMN 30 CONVERSION BOLD ACCEPT B-LOT ACC-NUM.
    PERFORM MB-CHKL IF A-S1=1 GO MB533. PERFORM SET-B-LYEAR.
    MOVE B-LOT TO WN1 PERFORM RDLK-BIN MOVE WN1 TO B-LOT.
    PERFORM SET-B-LYEAR GO MB58.
MB556. DISPLAY B-CONT COLUMN 30 BOLD ACCEPT B-CONT ACC-ALP.
    MOVE B-CONT TO WA1 PERFORM RDLK-BIN MOVE WA1 TO B-CONT GO MB58.
MB557. DISPLAY B-QTY-PACK COLUMN 30 CONVERSION BOLD ACCEPT B-QTY-PACK ACC-NUM.
    MOVE B-QTY-PACK TO WN1 PERFORM RDLK-BIN MOVE WN1 TO B-QTY-PACK GO MB58.
MB58. REWRITE B-RECORD ALLOWING NO UNLOCK BIN GO MB53.
    REPLACE OFF.
MB60. MOVE MB-NO TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO MB3.
    IF B-PROD=" " DELETE BIN
      ELSE MOVE "PRODUCT FIELD MUST BE BLANK" TO ERR-MESG PERFORM DSP-ERR.
    GO MB3.

MB70.
MB71. ACCEPT MB-FP LINE 13 COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE MB-FP TO A-A1 PERFORM STR-LTH.
    IF A-N1 NOT=2 MOVE "PREFIX MUST BE 2 CHARACTERS"
      TO ERR-MESG PERFORM DSP-ERR GO MB71.
    IF MB-FP(1:1)="Q" MOVE "ONLY QUARANTINE BINS CAN START WITH 'Q'"
      TO ERR-MESG PERFORM DSP-ERR GO MB71.
    MOVE MB-FP TO MB-TP.
MB73. ACCEPT MB-FN LINE 13 COLUMN 25 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT MB-TN LINE 13 COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MB-TN<MB-FN PERFORM DSP-ERR48 GO MB73.
    MOVE " " TO WA1 STRING "ALL BINS IN THE RANGE  " MB-FBIN " - " MB-TBIN
      "  (INCLUSIVE) WILL BE ADDED" DELIMITED SIZE INTO WA1 DISPLAY WA1 LINE 15.
    MOVE 0 TO WN1 MOVE 13 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MB78.
    PERFORM DSP-QWAIT PERFORM INIT-B.
MB75. MOVE MB-FBIN TO B-NO WRITE B-RECORD ALLOWING NO INVALID GO MB76.
    UNLOCK BIN ADD 1 TO WN1.
MB76. IF MB-FN<999 ADD 1 TO MB-FN IF MB-FN<=MB-TN GO MB75. PERFORM DSP-ERS.
MB78. MOVE " " TO WA1 MOVE WN1 TO DSP-N31 STRING DSP-N31 " BINS WERE ADDED"
       DELIMITED SIZE INTO WA1 DISPLAY WA1 LINE 16 BOLD.
    PERFORM DSP-CONT GO MB3.
MB9. GO MN9.

MB-CHKP. PERFORM MB-CP1 THRU MB-CP9.
MB-CP1. IF B-PROD=" " GO MB-CP8. MOVE 1 TO A-S1.
    MOVE B-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO MB-CP9.
MB-CP8. MOVE 0 TO A-S1.
MB-CP9. EXIT.
MB-CHKL. PERFORM MB-CL1 THRU MB-CL9.
MB-CL1. IF B-LOT=0 GO MB-CL8. MOVE 1 TO A-S1.
    MOVE B-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO MB-CL9.
    IF LT-PROD NOT=B-PROD MOVE "LOT PRODUCT IS DIFFERENT FROM BIN PRODUCT"
      TO ERR-MESG PERFORM DSP-ERR GO MB-CL9.
    IF LT-QUAR=1 PERFORM DSP-ERR44 GO MB-CL9.
MB-CL8. MOVE 0 TO A-S1.
MB-CL9. EXIT.

* G-24 SHIP-TO FILE MAINTENANCE
MS1.
MS3. PERFORM RD39 PERFORM WRT.
    ACCEPT MS-CUS LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MS-CUS=ALL "9" GO MS9. IF MS-CUS=" " PERFORM DSP-ERR5 GO MS3.
    ACCEPT MS-TO LINE 3 COLUMN 37 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MS-TO=0 PERFORM DSP-ERR4 GO MS3.
    ACCEPT MS-OP LINE 5 COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MS-OP=9 GO MS9.
    GO MS40 MS50 MS60  DEPENDING MS-OP. PERFORM DSP-ERR1 GO MS3.
MS40. MOVE LOW-VALUES TO SA-RECORD INITIALIZE SA-REC MOVE MS-NO TO SA-NO.
    START SHIPTO REGARDLESS INVALID GO MS42.
    MOVE "DUPLICATE SHIP-TO NO." TO ERR-MESG PERFORM DSP-ERR GO MS3.
MS42. PERFORM RD40 MOVE SA-NO TO TF28(3) PERFORM WRT.
    ACCEPT SA-NAME LINE 5 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT SA-ADD1 LINE 6 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT SA-ADD2 LINE 7 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT SA-POST LINE 8 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING.
    WRITE SA-RECORD ALLOWING NO UNLOCK SHIPTO GO MS3.
MS50. MOVE MS-NO TO SA-NO READ SHIPTO REGARDLESS INVALID PERFORM DSP-ERR4 GO MS3.
    PERFORM RD41 MOVE SA-NO TO TF29(3) MOVE SA-NAME TO TF30(3) PERFORM WRT.
    PERFORM RD41A PERFORM WRT.
MS53. ACCEPT MS-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO MS551 MS552 MS553 MS554  DEPENDING MS-FLD. GO MS3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==.
MS551. DISPLAY SA-NAME COLUMN 30 BOLD ACCEPT SA-NAME ACC-ALP.
    MOVE SA-NAME TO WA1 PERFORM RDLK-SHIPTO MOVE WA1 TO SA-NAME GO MS58.
MS552. DISPLAY SA-ADD1 COLUMN 30 BOLD ACCEPT SA-ADD1 ACC-ALP.
    MOVE SA-ADD1 TO WA1 PERFORM RDLK-SHIPTO MOVE WA1 TO SA-ADD1 GO MS58.
MS553. DISPLAY SA-ADD2 COLUMN 30 BOLD ACCEPT SA-ADD2 ACC-ALP.
    MOVE SA-ADD2 TO WA1 PERFORM RDLK-SHIPTO MOVE WA1 TO SA-ADD2 GO MS58.
MS554. DISPLAY SA-POST COLUMN 30 BOLD ACCEPT SA-POST ACC-ALP.
    MOVE SA-POST TO WA1 PERFORM RDLK-SHIPTO MOVE WA1 TO SA-POST GO MS58.
MS58. REWRITE SA-RECORD ALLOWING NO UNLOCK SHIPTO GO MS53.
    REPLACE OFF.
MS60. MOVE MS-NO TO SA-NO READ SHIPTO REGARDLESS INVALID PERFORM DSP-ERR4 GO MS3.
    DELETE SHIPTO GO MS3.
MS9. GO MN9.

* G-25 MACHINE FILE MAINTENANCE
MJ1.
MJ3. PERFORM RD42 PERFORM WRT.
    ACCEPT MJ-NO LINE 3 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR MJ-NO=9999 GO MJ9. IF MJ-NO=0 PERFORM DSP-ERR12 GO MJ3.
    ACCEPT MJ-OP LINE 3 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MJ-OP=9 GO MJ9.
    GO MJ40 MJ50 MJ60  DEPENDING MJ-OP. PERFORM DSP-ERR1 GO MJ3.
MJ40. MOVE LOW-VALUES TO M-RECORD INITIALIZE M-REC MOVE MJ-NO TO M-NO.
    START MACHINE REGARDLESS INVALID GO MJ42.
    MOVE "DUPLICATE MACHINE NO." TO ERR-MESG PERFORM DSP-ERR GO MJ3.
    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
MJ42. PERFORM RD43 MOVE M-NO TO TF340(3) PERFORM WRT.
    ACCEPT M-GROUP LINE 5 COLUMN 9 ACC-NUM.
    MOVE 19 TO T-TBL MOVE M-GROUP TO T-NO PERFORM RD-TBL MOVE T-LINE TO TF342(5).
    ACCEPT M-TYPE LINE 6 COLUMN 9 ACC-NUM.
    MOVE M-TYPE TO A-N1 PERFORM RD-MACTYPE MOVE ME-DESC TO TF342(6).
    ACCEPT M-SECT LINE 7 COLUMN 10 ACC-NUM.
    ACCEPT M-TQTY LINE 8 COLUMN 21 ACC-NUM.
    ACCEPT M-SPEED LINE 8 COLUMN 43 ACC-NUM.
    ACCEPT M-EFF LINE 8 COLUMN 66 ACC-NUM.
    ACCEPT M-TWEIGHT LINE 9 COLUMN 19 ACC-NUM.
    ACCEPT M-HOURS LINE 10 COLUMN 13 ACC-NUM.
    ACCEPT M-DESC1 LINE 11 COLUMN 22 ACC-ALP.
    ACCEPT M-DESC2 LINE 12 COLUMN 22 ACC-ALP.
    ACCEPT M-OPDESC LINE 13 COLUMN 25 ACC-ALP.
    ACCEPT M-COST LINE 14 COLUMN 8 ACC-NUM.
    ACCEPT M-CMODE LINE 14 COLUMN 33 ACC-ALP.
    ACCEPT M-HCOST LINE 15 COLUMN 29 ACC-NUM.
    ACCEPT M-LDAYS LINE 16 COLUMN 13 ACC-NUM.
    ACCEPT M-PLT-IND LINE 17 COLUMN 29 ACC-NUM.
    ACCEPT M-VENDOR LINE 17 COLUMN 44 ACC-NUM.
    ACCEPT M-FREIGHT LINE 17 COLUMN 69 ACC-NUM.
    ACCEPT M-LOT-CHARGE LINE 18 COLUMN 14 ACC-NUM.
    ACCEPT M-BATCH-CHARGE LINE 18 COLUMN 42 ACC-NUM.
    ACCEPT M-SURCHARGE LINE 18 COLUMN 69 ACC-NUM.
    WRITE M-RECORD ALLOWING NO UNLOCK MACHINE GO MJ3.
    REPLACE OFF.
MJ50. MOVE MJ-NO TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO MJ3.
    PERFORM RD44 MOVE M-NO TO TF341(3) PERFORM WRT PERFORM RD44A PERFORM WRT.
MJ53. ACCEPT MJ-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO MJ551 MJ552 MJ553 MJ554 MJ555 MJ556 MJ557 MJ558 MJ559 MJ5510
       MJ5511 MJ5512 MJ5513 MJ5514 MJ5515 MJ5516 MJ5517 MJ5518 MJ5519 MJ5520
       MJ5521 MJ5522 MJ5523 MJ5524
      DEPENDING MJ-FLD. GO MJ3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
MJ551. DISPLAY M-GROUP COLUMN 30 CONVERSION BOLD ACCEPT M-GROUP ACC-NUM.
    MOVE M-GROUP TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-GROUP GO MJ58.
MJ552. DISPLAY M-TYPE COLUMN 30 CONVERSION BOLD ACCEPT M-TYPE ACC-NUM.
    MOVE M-TYPE TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-TYPE GO MJ58.
MJ553. DISPLAY M-SECT COLUMN 30 CONVERSION BOLD ACCEPT M-SECT ACC-NUM.
    MOVE M-SECT TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-SECT GO MJ58.
MJ554. DISPLAY M-TQTY COLUMN 30 CONVERSION BOLD ACCEPT M-TQTY ACC-NUM.
    MOVE M-TQTY TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-TQTY GO MJ58.
MJ555. DISPLAY M-HOURS COLUMN 30 CONVERSION BOLD ACCEPT M-HOURS ACC-NUM.
    MOVE M-HOURS TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-HOURS GO MJ58.
MJ556. DISPLAY M-RNO COLUMN 30 CONVERSION BOLD ACCEPT M-RNO ACC-NUM.
    MOVE M-RNO TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-RNO GO MJ58.
MJ557. DISPLAY M-DESC1 COLUMN 30 BOLD ACCEPT M-DESC1 ACC-ALP.
    MOVE M-DESC1 TO WA1 PERFORM RDLK-MACHINE MOVE WA1 TO M-DESC1 GO MJ58.
MJ558. DISPLAY M-DESC2 COLUMN 30 BOLD ACCEPT M-DESC2 ACC-ALP.
    MOVE M-DESC2 TO WA1 PERFORM RDLK-MACHINE MOVE WA1 TO M-DESC2 GO MJ58.
MJ559. DISPLAY M-COST COLUMN 30 CONVERSION BOLD ACCEPT M-COST ACC-NUM.
    MOVE M-COST TO WT1 PERFORM RDLK-MACHINE MOVE WT1 TO M-COST GO MJ58.
MJ5510. DISPLAY M-CMODE COLUMN 30 BOLD ACCEPT M-CMODE ACC-ALP.
    MOVE M-CMODE TO WA1 PERFORM RDLK-MACHINE MOVE WA1 TO M-CMODE GO MJ58.
MJ5511. DISPLAY M-TWEIGHT COLUMN 30 CONVERSION BOLD ACCEPT M-TWEIGHT ACC-NUM.
    MOVE M-TWEIGHT TO WD1 PERFORM RDLK-MACHINE MOVE WD1 TO M-TWEIGHT GO MJ58.
MJ5512. DISPLAY M-LDAYS COLUMN 30 CONVERSION BOLD ACCEPT M-LDAYS ACC-NUM.
    MOVE M-LDAYS TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-LDAYS GO MJ58.
MJ5513. DISPLAY M-OPDESC COLUMN 30 BOLD ACCEPT M-OPDESC ACC-ALP.
    MOVE M-OPDESC TO WA1 PERFORM RDLK-MACHINE MOVE WA1 TO M-OPDESC GO MJ58.
MJ5514. DISPLAY M-PLT-IND COLUMN 30 CONVERSION BOLD ACCEPT M-PLT-IND ACC-NUM.
    MOVE M-PLT-IND TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-PLT-IND GO MJ58.
MJ5515. DISPLAY M-LOT-CHARGE COLUMN 30 CONVERSION BOLD ACCEPT M-LOT-CHARGE ACC-NUM.
    MOVE M-LOT-CHARGE TO WD1 PERFORM RDLK-MACHINE MOVE WD1 TO M-LOT-CHARGE GO MJ58.
MJ5516. DISPLAY M-BATCH-CHARGE COLUMN 30 CONVERSION BOLD ACCEPT M-BATCH-CHARGE ACC-NUM.
    MOVE M-BATCH-CHARGE TO WD1 PERFORM RDLK-MACHINE MOVE WD1 TO M-BATCH-CHARGE GO MJ58.
MJ5517. DISPLAY M-SURCHARGE COLUMN 30 CONVERSION BOLD ACCEPT M-SURCHARGE ACC-NUM.
    MOVE M-SURCHARGE TO WD1 PERFORM RDLK-MACHINE MOVE WD1 TO M-SURCHARGE GO MJ58.
MJ5518. DISPLAY M-VENDOR COLUMN 30 CONVERSION BOLD ACCEPT M-VENDOR ACC-NUM.
    MOVE M-VENDOR TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-VENDOR GO MJ58.
MJ5519. DISPLAY M-TCOST COLUMN 30 CONVERSION BOLD ACCEPT M-TCOST ACC-NUM.
    MOVE M-TCOST TO WT1 PERFORM RDLK-MACHINE MOVE WT1 TO M-TCOST GO MJ58.
MJ5520. DISPLAY M-SPEED COLUMN 30 CONVERSION BOLD ACCEPT M-SPEED ACC-NUM.
    MOVE M-SPEED TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-SPEED GO MJ58.
MJ5521. DISPLAY M-EFF COLUMN 30 CONVERSION BOLD ACCEPT M-EFF ACC-NUM.
    MOVE M-EFF TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-EFF GO MJ58.
MJ5522. DISPLAY M-FREIGHT COLUMN 30 CONVERSION BOLD ACCEPT M-FREIGHT ACC-NUM.
    MOVE M-FREIGHT TO WT1 PERFORM RDLK-MACHINE MOVE WT1 TO M-FREIGHT GO MJ58.
MJ5523. DISPLAY M-HCOST COLUMN 30 CONVERSION BOLD ACCEPT M-HCOST ACC-NUM.
    MOVE M-HCOST TO WT1 PERFORM RDLK-MACHINE MOVE WT1 TO M-HCOST GO MJ58.
MJ5524. DISPLAY M-INACTIVE COLUMN 30 CONVERSION BOLD ACCEPT M-INACTIVE ACC-NUM.
    MOVE M-INACTIVE TO WN1 PERFORM RDLK-MACHINE MOVE WN1 TO M-INACTIVE GO MJ58.
MJ58. REWRITE M-RECORD ALLOWING NO UNLOCK MACHINE GO MJ53.
    REPLACE OFF.
MJ60. MOVE MJ-NO TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO MJ3.
    DELETE MACHINE GO MJ3.
MJ9. GO MN9.

* G-26 OPERATIONS FILE MAINTENANCE
MO1. PERFORM RD88 PERFORM WRT.
    ACCEPT MO-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR MO-SEL=99 GO MO9. IF MO-SEL=0 GO MO1. PERFORM DSP-CLS.
    GO MO10 MO20 MO30 MO40 MO50  DEPENDING MO-SEL. GO MO1.

MO10. MOVE " " TO MO-PROD.
MO13. PERFORM RD88A PERFORM WRT.
MO133. ACCEPT MO-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MO-PROD=ALL "9" GO MO19.
    MOVE MO-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO MO133.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 4 COLUMN 11 PERFORM MO-D.
    PERFORM INIT-OP MOVE MO-PROD TO OP-PROD.
    MOVE P-MAC TO OP-MAC DISPLAY OP-MAC LINE 3 COLUMN 32 CONVERSION.
    ACCEPT OP-MAC LINE 3 COLUMN 32 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 GO MO19. DISPLAY OP-MAC LINE 3 COLUMN 32 CONVERSION.
    READ OPERATIONS REGARDLESS INVALID MOVE 0 TO MO-KFIN GO MO14. MOVE 1 TO MO-KFIN.

MO135. DISPLAY OP-SPEED LINE 6 COLUMN 17 CONVERSION OP-EFF COLUMN 41 CONVERSION.
    MOVE 1 TO IX1 MOVE 10 TO IXT PERFORM UNTIL IX1>12
      DISPLAY OP-OPER(IX1) LINE IXT COLUMN 5 CONVERSION
      DISPLAY OP-COST(IX1) LINE IXT COLUMN 11 CONVERSION OP-CMODE(IX1) COLUMN 21
      PERFORM MO-M ADD 1 TO IX1 IXT END-PERFORM.

MO14.
MO15. PERFORM DSP-NEXT ACCEPT MO-OP LINE 2 COLUMN 60 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF MO-OP=0 GO MO13. IF MO-OP>4 PERFORM DSP-ERR1 GO MO15.
    IF MO-OP=1 AND MO-KFIN=1 MOVE "DUPLICATE OPERATIONS LIST FOR THIS PRODUCT-MACHINE"
      TO ERR-MESG PERFORM DSP-ERR GO MO13.
    IF (MO-OP=2 OR 3 OR 4) AND MO-KFIN=0 MOVE "OPERATIONS LIST NOT FOUND"
      TO ERR-MESG PERFORM DSP-ERR GO MO13.
    IF MO-OP=1 OR 2 GO MO170. IF MO-OP=3 DELETE OPERATIONS GO MO13.

* op=4
    MOVE OP-PROD TO MO-SPROD MOVE OP-MAC TO MO-SMAC.
    DISPLAY "ENTER PRODUCT-MACHINE COMBINATION TO COPY: ____________ - __" LINE 24 BOLD.
    ACCEPT OP-PROD LINE 24 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE OP-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO MO13.
    ACCEPT OP-MAC LINE 24 COLUMN 59 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    READ OPERATIONS REGARDLESS INVALID PERFORM DSP-ERR27 GO MO13.
    MOVE MO-SPROD TO OP-PROD MOVE MO-SMAC TO OP-MAC.
    REWRITE OP-RECORD ALLOWING NO UNLOCK OPERATIONS GO MO135.

MO170. ACCEPT OP-SPEED LINE 6 COLUMN 17 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY OP-SPEED LINE 6 COLUMN 17 CONVERSION.
    ACCEPT OP-EFF LINE 6 COLUMN 41 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY OP-EFF LINE 6 COLUMN 41 CONVERSION.
    MOVE 1 TO IX1 MOVE 10 TO IXT.
MO173. PERFORM DSP-PF3 ACCEPT OP-OPER(IX1) LINE IXT COLUMN 5 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    DISPLAY OP-OPER(IX1) LINE IXT COLUMN 5 CONVERSION PERFORM MO-M IF KPF3 GO MO18.
    ACCEPT OP-COST(IX1) LINE IXT COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY OP-COST(IX1) LINE IXT COLUMN 11 CONVERSION.
    MOVE 21 TO IXU MOVE OP-CMODE(IX1) TO XA1 PERFORM AX-BCMODE MOVE XA1 TO OP-CMODE(IX1).
    ADD 1 TO IX1 IXT IF IX1<=12 GO MO173.
MO18. IF MO-OP=1 WRITE OP-RECORD ALLOWING NO ELSE REWRITE OP-RECORD ALLOWING NO.
    UNLOCK OPERATIONS PERFORM DSP-CONT GO MO13.
MO19. GO MO9.

MO20.
MO23. PERFORM RD88B PERFORM WRT.
MO233. ACCEPT MO-OPER1 LINE 3 COLUMN 22 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO MO29. IF MO-OPER1=0 PERFORM DSP-ERR2 GO MO233.
    MOVE MO-OPER1 TO M-NO PERFORM MO-R DISPLAY A-A1(1:30) LINE 3 COLUMN 27.
MO235. ACCEPT MO-OPER2 LINE 4 COLUMN 22 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MO-OPER2=0 PERFORM DSP-ERR2 GO MO235.
    MOVE MO-OPER2 TO M-NO PERFORM MO-R DISPLAY A-A1(1:30) LINE 4 COLUMN 27.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MO23.
    PERFORM DSP-QWAIT MOVE 0 TO WN1.
    MOVE " " TO OP-KEY START OPERATIONS KEY>OP-KEY REGARDLESS INVALID GO MO26.
MO25. READ OPERATIONS NEXT REGARDLESS END GO MO26. MOVE 0 TO WS1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)=MO-OPER1 MOVE MO-OPER2 TO OP-OPER(IX1) MOVE 1 TO WS1 END-IF END-PERFORM.
    IF WS1=1 ADD 1 TO WN1 REWRITE OP-RECORD ALLOWING NO UNLOCK OPERATIONS.
    GO MO25.
MO26. PERFORM DSP-ERS DISPLAY WN1 LINE 6 CONVERSION "  OPERATION LISTS WERE MODIFIED".
    PERFORM DSP-CONT GO MO23.
MO29. GO MO9.

MO30. PERFORM RD88C MOVE 0 TO M-NO MOVE 4 TO IXT.
MO33. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
MO333. DISPLAY "NEXT OPERATION: ___" LINE IXT.
    ACCEPT IA6 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA6=999 GO MO39.
    IF IA6=0 IF M-NO=0 GO MO333 ELSE GO MO34. MOVE IA6 TO M-NO.
    START MACHINE KEY>=M-KEY REGARDLESS INVALID PERFORM DSP-ERR12 GO MO333.
    READ MACHINE NEXT REGARDLESS MOVE 1 TO MO-KFIN.
* note 122.4
    IF M-NO NOT=IA6 MOVE 0 TO MO-KFIN MOVE IA6 TO M-NO
      START MACHINE KEY>=M-KEY REGARDLESS.
    MOVE " " TO OP-KEY MOVE 0 TO INQ-IND.
MO34. PERFORM RD88C MOVE M-NO TO TF31(1).
    IF MO-KFIN=1 MOVE M-DESC1 TO TF32(1) ELSE MOVE MO-MSG1 TO TF32(1).
    PERFORM DSP-QWAIT MOVE 5 TO IXT MOVE 1 TO MO-IX1.
    IF INQ-IND=0 START OPERATIONS KEY>=OP-KEY REGARDLESS INVALID GO MO38.
MO35. READ OPERATIONS NEXT REGARDLESS END GO MO38.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)=M-NO GO MO36 END-IF END-PERFORM. GO MO35.
MO36. IF MO-IX1=1 PERFORM CLR-LN.
    MOVE OP-PROD TO TF33(IXT,MO-IX1) MOVE OP-MAC TO TF34(IXT,MO-IX1).
    ADD 1 TO MO-IX1 IF MO-IX1<=4 GO MO35. MOVE 1 TO MO-IX1.
    ADD 1 TO IXT IF IXT<22 GO MO35.
    MOVE "*** MORE ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO MO389.
MO38. IF MO-IX1>1 ADD 1 TO IXT. MOVE "*** END ***" TO TLN(IXT) PERFORM DSP-ERS.
    READ MACHINE NEXT REGARDLESS END MOVE 0 TO M-NO GO MO389. MOVE 1 TO MO-KFIN.
    MOVE " " TO OP-KEY MOVE 0 TO INQ-IND.
MO389. GO MO33.
MO39. GO MO9.

MO40. MOVE " " TO MO-PROD.
MO43. PERFORM RD88D PERFORM WRT PERFORM RD88E PERFORM WRT.
MO433. ACCEPT MO-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MO-PROD=ALL "9" GO MO49.
    MOVE MO-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO MO433.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 4 COLUMN 11 PERFORM MO-D.
    PERFORM INIT-OP MOVE MO-PROD TO OP-PROD.
    MOVE P-MAC TO OP-MAC DISPLAY OP-MAC LINE 3 COLUMN 32 CONVERSION.
    ACCEPT OP-MAC LINE 3 COLUMN 32 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 GO MO49. DISPLAY OP-MAC LINE 3 COLUMN 32 CONVERSION.
    READ OPERATIONS REGARDLESS INVALID PERFORM DSP-ERR27 GO MO43.
    MOVE 1 TO IX1 MOVE 9 TO IXT PERFORM UNTIL IX1>12
      DISPLAY OP-OPER(IX1) LINE IXT COLUMN 5 CONVERSION
      PERFORM MO-M ADD 1 TO IX1 IXT END-PERFORM.
MO45. PERFORM DSP-NEXT ACCEPT MO-OP LINE 2 COLUMN 58 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF MO-OP=0 GO MO43. IF MO-OP=1 GO MO46. IF MO-OP=2 GO MO470.
    PERFORM DSP-ERR1 GO MO45.

MO46.
MO461. DISPLAY "ADD OPERATION ___  BEFORE LINE NO. __ (1 - 12)" LINE 24 BOLD.
    ACCEPT MO-OPER1 LINE 24 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT MO-LINE LINE 24 COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(MO-LINE>=1 AND<=12) PERFORM DSP-ERR2 GO MO461. PERFORM DSP-ERS.
    PERFORM VARYING IX1 FROM 11 BY -1 UNTIL IX1<MO-LINE
      MOVE OP-OP(IX1) TO OP-OP(IX1 + 1) END-PERFORM.
    INITIALIZE OP-OP(MO-LINE) MOVE MO-OPER1 TO OP-OPER(MO-LINE) GO MO48.

MO470.
MO471. DISPLAY "DELETE LINE NO. __ (1 - 12)" LINE 24 BOLD.
    ACCEPT MO-LINE LINE 24 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(MO-LINE>=1 AND<=12) PERFORM DSP-ERR2 GO MO471. PERFORM DSP-ERS.
    PERFORM VARYING IX1 FROM MO-LINE BY 1 UNTIL IX1=12
      MOVE OP-OP(IX1 + 1) TO OP-OP(IX1) END-PERFORM.
    INITIALIZE OP-OP(12) GO MO48.

MO48. REWRITE OP-RECORD ALLOWING NO UNLOCK OPERATIONS.
    PERFORM RD88E PERFORM WRT MOVE 1 TO IX1 MOVE 9 TO IXT.
    PERFORM UNTIL IX1>12 DISPLAY OP-OPER(IX1) LINE IXT COLUMN 5 CONVERSION
      PERFORM MO-M ADD 1 TO IX1 IXT END-PERFORM.
    PERFORM DSP-CONT GO MO43.
MO49. GO MO9.

MO50.
MO53. PERFORM RD88F PERFORM WRT.
MO533. ACCEPT MO-OPER1 LINE 3 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO MO59. IF MO-OPER1=0 PERFORM DSP-ERR2 GO MO533.
    MOVE MO-OPER1 TO M-NO PERFORM MO-R DISPLAY A-A1(1:30) LINE 3 COLUMN 21.
    ACCEPT MO-COST LINE 4 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 4 TO IXT MOVE 32 TO IXU MOVE MO-CMODE TO XA1 PERFORM AX-BCMODE MOVE XA1 TO MO-CMODE.
    MOVE 11 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MO53.
    PERFORM DSP-QWAIT MOVE 0 TO WN1 WN2.
    MOVE " " TO OP-KEY START OPERATIONS KEY>OP-KEY REGARDLESS INVALID GO MO56.
MO55. READ OPERATIONS NEXT REGARDLESS END GO MO56. MOVE 0 TO WS1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)=MO-OPER1 ADD 1 TO WN1
        IF OP-COST(IX1)>0 MOVE MO-COST TO OP-COST(IX1) MOVE MO-CMODE TO OP-CMODE(IX1)
          MOVE 1 TO WS1 END-IF END-IF END-PERFORM.
    IF WS1=1 ADD 1 TO WN2 REWRITE OP-RECORD ALLOWING NO UNLOCK OPERATIONS.
    GO MO55.
MO56. PERFORM DSP-ERS.
    DISPLAY WN1 LINE 12 CONVERSION "  OPERATION LISTS WERE FOUND".
    DISPLAY WN2 LINE 13 CONVERSION "  OPERATION LISTS WERE MODIFIED".
    PERFORM DSP-CONT GO MO53.
MO59. GO MO9.

MO9. GO MN9.

MO-D. PERFORM MO-D1 THRU MO-D9.
MO-D1. MOVE MO-PROD TO OP-PROD MOVE 0 TO OP-MAC MOVE 0 TO IX1 MOVE 32 TO IXU.
    START OPERATIONS KEY>OP-KEY REGARDLESS INVALID GO MO-D4.
MO-D3. READ OPERATIONS NEXT REGARDLESS END GO MO-D4. IF OP-PROD NOT=MO-PROD GO MO-D4.
    DISPLAY OP-MAC LINE 2 COLUMN IXU CONVERSION.
    ADD 1 TO IX1 IF IX1<5 ADD 3 TO IXU GO MO-D3.
MO-D4.
MO-D9. EXIT.
MO-M. PERFORM MO-M1 THRU MO-M9.
MO-M1. IF OP-OPER(IX1)=0 GO MO-M9.
    MOVE OP-OPER(IX1) TO M-NO READ MACHINE REGARDLESS INVALID
      DISPLAY MO-MSG1 LINE IXT COLUMN 27 BOLD GO MO-M9.
    DISPLAY M-DESC1 LINE IXT COLUMN 27 M-OPDESC COLUMN 60.
MO-M9. EXIT.
MO-R. PERFORM MO-R1 THRU MO-R9.
MO-R1. READ MACHINE REGARDLESS INVALID MOVE MO-MSG1 TO A-A1 GO MO-R9.
    MOVE M-DESC1 TO A-A1.
MO-R9. EXIT.

* G-27 SHOW CUSTOMER NAMES
CN1. PERFORM WRT132 PERFORM RD87 PERFORM WRT MOVE " " TO CN-NAME.
CN3. DISPLAY "ENTER THE BEGINNING OF THE CUSTOMER NAME" LINE 24 BOLD.
    ACCEPT CN-NAME LINE 3 COLUMN 17 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR CN-NAME(1:10)=ALL "9" GO CN9.
    MOVE 5 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    MOVE CN-NAME TO A-A1 PERFORM STR-LTH MOVE A-N1 TO CN-LTH.
    MOVE 1 TO IXCOL MOVE 0 TO CN-KFIN.
    MOVE CN-NAME TO C-KN START CUSTOMER KEY>=C-KN REGARDLESS INVALID GO CN8.
CN5. READ CUSTOMER NEXT REGARDLESS END GO CN8. IF C-NAME(1:CN-LTH) NOT=CN-NAME GO CN8.
    COMPUTE IXU=(IXCOL - 1) * 46 + 1 MOVE 1 TO CN-KFIN.
    DISPLAY C-NO LINE IXT COLUMN IXU C-NAME COLUMN IXU PLUS 8.
    ADD 1 TO IXT IF IXT=24 MOVE 5 TO IXT ADD 1 TO IXCOL IF IXCOL>3 GO CN8. GO CN5.
CN8. IF CN-KFIN=0 DISPLAY "*** NO CUSTOMERS FOUND" LINE IXT. GO CN3.
CN9. PERFORM WRT80 GO MN9.

* G-28 UPDATE BUCKETS
DH1. PERFORM RD150 PERFORM WRT PERFORM OPEN-AUDIT.
    ACCEPT DH-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR DH-SEL=0 OR>2 GO DH9. IF DH-SEL=1 GO DH2. IF DH-SEL=2 GO DH6.

DH2. COMPUTE DH-DATE=SYS-DATE - 90.
DH3. PERFORM RD150A PERFORM WRT.
    DISPLAY " UPDATE BUCKETS WITH ZERO WEIGHT " LINE 1 REVERSED.
    ACCEPT DH-NUM LINE 3 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR DH-NUM=9999 GO DH49. PERFORM DH-DSP.
    IF DH-N=0 MOVE "NO BUCKETS FOUND WITH ZERO WEIGHT"
      TO ERR-MESG PERFORM DSP-ERR GO DH48.
    IF DH-N=1 MOVE 1 TO IX1 GO DH4.
    DISPLAY "SELECT MACHINE: ___" LINE 6 BOLD.
DH35. ACCEPT DH-MAC LINE 6 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>DH-N
      MOVE DH-KEY(IX1) TO BU-KEY IF DH-MAC=BU-MAC GO DH4 END-IF END-PERFORM.
    MOVE "NO BUCKET FOUND WITH THIS MACHINE" TO ERR-MESG PERFORM DSP-ERR GO DH35.
DH4. MOVE DH-KEY(IX1) TO BU-KEY READ BUCKET REGARDLESS INVALID GO DH48.
DH43. ACCEPT BU-WEIGHT LINE 4 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF BU-WEIGHT=0 GO DH48. PERFORM CHK-BUCKET-WEIGHT IF A-S1=1 GO DH43.
    REWRITE BU-RECORD ALLOWING NO UNLOCK BUCKET.
    MOVE BU-NUM TO IE11 MOVE BU-WEIGHT TO IE12 MOVE BU-NO TO IE13 MOVE " " TO IE14.
    MOVE TD-INP-R1 TO AU-DATA MOVE 1 TO AU-K PERFORM ADD-AUD.
    MOVE BU-JKEY TO J-KEY READ WORKSHEET REGARDLESS INVALID GO DH48.
    PERFORM BUCKET-CALC REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
DH48. GO DH3.
DH49. GO DH9.

DH6. COMPUTE DH-DATE=SYS-DATE - 30.
DH7. PERFORM RD150A PERFORM WRT.
    DISPLAY " UPDATE BUCKETS WITH WEIGHT " LINE 1 REVERSED.
    ACCEPT DH-NUM LINE 3 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR DH-NUM=9999 GO DH89.
DH73. ACCEPT DH-WEIGHT LINE 4 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DH-WEIGHT=0 PERFORM DSP-ERR2 GO DH73. PERFORM DH-DSP.
    IF DH-N=0 MOVE "NO BUCKETS FOUND WITH THIS WEIGHT"
      TO ERR-MESG PERFORM DSP-ERR GO DH88.
    MOVE DH-KEY(1) TO BU-KEY READ BUCKET REGARDLESS INVALID GO DH88.
DH83. DISPLAY BU-WEIGHT LINE 4 COLUMN 14 CONVERSION.
    ACCEPT BU-WEIGHT LINE 4 COLUMN 14 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY BU-WEIGHT LINE 4 COLUMN 14 CONVERSION.
    IF BU-WEIGHT=DH-WEIGHT GO DH88. PERFORM CHK-BUCKET-WEIGHT IF A-S1=1 GO DH83.
    REWRITE BU-RECORD ALLOWING NO UNLOCK BUCKET.
    MOVE BU-NUM TO IE11 MOVE BU-WEIGHT TO IE12 MOVE BU-NO TO IE13 MOVE "MOD" TO IE14.
    MOVE TD-INP-R1 TO AU-DATA MOVE 1 TO AU-K PERFORM ADD-AUD.
    MOVE BU-JKEY TO J-KEY READ WORKSHEET REGARDLESS INVALID GO DH88.
    PERFORM BUCKET-CALC REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
DH88. GO DH7.
DH89. GO DH9.

DH9. CLOSE AUDIT GO MN9.

DH-DSP. PERFORM DH-D1 THRU DH-D9.
DH-D1. MOVE 0 TO DH-N MOVE 40 TO IXU.
    MOVE DH-NUM TO BU-KNUM MOVE 0 TO BU-ZDATE.
    START BUCKET KEY>BU-KN REGARDLESS INVALID GO DH-D4.
DH-D3. READ BUCKET NEXT REGARDLESS END GO DH-D4.
    IF BU-NUM>DH-NUM OR BU-DATE<DH-DATE GO DH-D4.
    IF DH-SEL=1 AND BU-WEIGHT NOT=0 OR DH-SEL=2 AND BU-WEIGHT NOT=DH-WEIGHT GO DH-D3.
    ADD 1 TO DH-N IF DH-N>1 ADD 14 TO IXU. MOVE BU-KEY TO DH-KEY(DH-N).
    INITIALIZE J-REC MOVE BU-JKEY TO J-KEY READ WORKSHEET REGARDLESS INVALID CONTINUE.
    DISPLAY BU-NO LINE 3 COLUMN IXU CONVERSION.
    DISPLAY BU-MAC LINE 4 COLUMN IXU CONVERSION.
    MOVE BU-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO DSP-DT1.
    DISPLAY DSP-DT1 LINE 5 COLUMN IXU.
    DISPLAY LIT-XDAN(BU-SHIFT + 1:1) LINE 6 COLUMN IXU.
    DISPLAY BU-EMP LINE 7 COLUMN IXU CONVERSION.
    DISPLAY J-PROD LINE 8 COLUMN IXU.
    IF DH-N<3 GO DH-D3.
DH-D4.
DH-D9. EXIT.

    REPLACE ==INTO-LAB== BY ==DELIMITED SIZE INTO LAB-RECORD POINTER LAB-PTR PERFORM LAB-LINE==.
* G-29 CREATE MISCELLANEOUS LABELS
JC1. PERFORM RD102 PERFORM WRT.
    ACCEPT JC-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR JC-SEL=99 GO JC9.
    GO JC10 JC20 JC30 JC40 JC50 JC60  DEPENDING JC-SEL. GO JC1.

JC10. PERFORM RD102A PERFORM WRT.
    MOVE 0 TO JC-KMAN JC-NUM MOVE 2 TO IXT.
JC103. PERFORM VARYING JC-IXT FROM 14 BY 1 UNTIL JC-IXT>17
        DISPLAY " " LINE JC-IXT COLUMN 36 ERASE END LINE END-PERFORM.
    ADD 1 TO JC-NUM IXT.
    ACCEPT JC-CNO(JC-NUM) LINE IXT COLUMN 19 DEFAULT " " UNDERLINED PROTECTED.
    IF JC-CNO(JC-NUM)=" " SUBTRACT 1 FROM JC-NUM GO JC109.
    MOVE JC-CNO(JC-NUM) TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5
      SUBTRACT 1 FROM JC-NUM IXT GO JC103.
    DISPLAY C-NAME LINE 14 COLUMN 36.
JC105. ACCEPT JC-CSHIP(JC-NUM) LINE IXT COLUMN 43 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF JC-CSHIP(JC-NUM)=0 MOVE C-NAME TO SA-NAME MOVE C-ADD1 TO SA-ADD1
      MOVE C-ADD2 TO SA-ADD2 MOVE C-POST TO SA-POST GO JC106.
    MOVE C-NO TO SA-CUS MOVE JC-CSHIP(JC-NUM) TO SA-TO.
    READ SHIPTO REGARDLESS INVALID PERFORM DSP-ERR4 GO JC105.
JC106. DISPLAY SA-NAME LINE 14 COLUMN 36 SA-ADD1 LINE 15 COLUMN 36
        SA-ADD2 LINE 16 COLUMN 36 SA-POST LINE 17 COLUMN 36.
    ACCEPT JC-CQTY(JC-NUM) LINE IXT COLUMN 64 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF JC-CQTY(JC-NUM)=0 SUBTRACT 1 FROM JC-NUM IXT. IF JC-NUM<10 GO JC103.
JC109. IF JC-NUM>0 GO JC12. MOVE 1 TO JC-KMAN.
    ACCEPT JC-NAME LINE 14 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT JC-ADD1 LINE 15 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT JC-ADD2 LINE 16 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT JC-POST LINE 17 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT JC-QTY LINE 18 COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
JC12. MOVE 20 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JC9.
    PERFORM DSP-WAIT MOVE 9 TO LAB-FLN PERFORM OPEN-LAB MOVE 0 TO JC-IXC.

JC13. ADD 1 TO JC-IXC.
    IF JC-KMAN=0 AND JC-IXC>JC-NUM OR JC-KMAN=1 AND JC-IXC>1 GO JC19.
    IF JC-KMAN=1 MOVE JC-NAME TO SA-NAME MOVE JC-ADD1 TO SA-ADD1
      MOVE JC-ADD2 TO SA-ADD2 MOVE JC-POST TO SA-POST GO JC14.
    MOVE JC-CQTY(JC-IXC) TO JC-QTY.
    MOVE JC-CNO(JC-IXC) TO C-NO READ CUSTOMER REGARDLESS INVALID GO JC13.
    IF JC-CSHIP(JC-IXC)=0 MOVE C-NAME TO SA-NAME MOVE C-ADD1 TO SA-ADD1
      MOVE C-ADD2 TO SA-ADD2 MOVE C-POST TO SA-POST GO JC14.
    MOVE C-NO TO SA-CUS MOVE JC-CSHIP(JC-IXC) TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO JC13.

JC14. STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FO710,40^GB80,1250,80^FS" INTO-LAB.
    STRING "^FT725,60^A0,60,60^FR^FDSHIP TO:^FS" INTO-LAB.
    STRING "^FT480,40^A0,110,75^FD" SA-NAME "^FS" INTO-LAB.
    STRING "^FT360,40^A0,110,75^FD" SA-ADD1 "^FS" INTO-LAB.
    STRING "^FT240,40^A0,110,75^FD" SA-ADD2 "^FS" INTO-LAB.
    STRING "^FT120,40^A0,110,75^FD" SA-POST "^FS" INTO-LAB.
    STRING "^PQ" JC-QTY ",0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    GO JC13.
JC19. PERFORM CLOSE-LAB GO JC9.

JC20. PERFORM RD102B PERFORM WRT.
    ACCEPT JC-INSP LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT JC-QTY LINE 3 COLUMN 39 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 4 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JC9.
    PERFORM DSP-WAIT MOVE 9 TO LAB-FLN PERFORM OPEN-LAB.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FT700,480^A0,80,80^FDVERIFIED BY^FS" INTO-LAB.
    STRING "^FT620,290^A0,80,80^FDIRVINE FASTENERS^FS" INTO-LAB.
    STRING "^FT540,190^A0,80,80^FDINSPECTION SORT MACHINES^FS" INTO-LAB.
    STRING "^FT460,620^A0,80,80^FD(" JC-INSP ")^FS" INTO-LAB.
    STRING "^FT300,480^A0,80,80^FDVERIFIED BY^FS" INTO-LAB.
    STRING "^FT220,290^A0,80,80^FDIRVINE FASTENERS^FS" INTO-LAB.
    STRING "^FT140,190^A0,80,80^FDINSPECTION SORT MACHINES^FS" INTO-LAB.
    STRING "^FT060,620^A0,80,80^FD(" JC-INSP ")^FS" INTO-LAB.
    STRING "^PQ" JC-QTY ",0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    PERFORM CLOSE-LAB GO JC9.

JC30. PERFORM RD102C PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 44 TO IXV PERFORM AX-CUS-R.
    MOVE 4 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JC9.
    PERFORM DSP-WAIT MOVE 9 TO LAB-FLN PERFORM OPEN-LAB.

    MOVE CUS1 TO C-NO START CUSTOMER KEY>=C-KEY REGARDLESS INVALID GO JC39.
JC33. READ CUSTOMER NEXT REGARDLESS END GO JC39. IF C-NO>CUS2 GO JC39.

    STRING "^XA^LH0,0^FWN^FS" INTO-LAB.
    STRING "^FT20,50^A0,30,30^FD" C-NAME "^FS" INTO-LAB.
    STRING "^FT20,90^A0,30,30^FD" C-ADD1 "^FS" INTO-LAB.
    STRING "^FT20,130^A0,30,30^FD" C-ADD2 "^FS" INTO-LAB.
    STRING "^FT20,170^A0,30,30^FD" C-POST "^FS" INTO-LAB.
    STRING "^PQ0001,0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    GO JC33.
JC39. PERFORM CLOSE-LAB GO JC9.

JC40. PERFORM RD102D PERFORM WRT.
    MOVE 1 TO IX1 MOVE 3 TO IXT PERFORM UNTIL IX1>3
      ACCEPT JC-TLINE1(IX1) LINE IXT COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING
      ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 1 TO IX1 MOVE 7 TO IXT PERFORM UNTIL IX1>3
      ACCEPT JC-TLINE2(IX1) LINE IXT COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING
      ADD 1 TO IX1 IXT END-PERFORM.
    ACCEPT JC-QTY LINE 12 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 12 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JC9.
    PERFORM DSP-WAIT MOVE 9 TO LAB-FLN PERFORM OPEN-LAB.

    STRING "^XA^LH0,0^FWR^FS" INTO-LAB.
    STRING "^FT670,40^A0,120,80^FD" JC-TLINE1(1) "^FS" INTO-LAB.
    STRING "^FT550,40^A0,120,80^FD" JC-TLINE1(2) "^FS" INTO-LAB.
    STRING "^FT430,40^A0,120,80^FD" JC-TLINE1(3) "^FS" INTO-LAB.
    STRING "^FT270,40^A0,120,80^FD" JC-TLINE2(1) "^FS" INTO-LAB.
    STRING "^FT150,40^A0,120,80^FD" JC-TLINE2(2) "^FS" INTO-LAB.
    STRING "^FT030,40^A0,120,80^FD" JC-TLINE2(3) "^FS" INTO-LAB.
    STRING "^PQ" JC-QTY ",0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    PERFORM CLOSE-LAB GO JC9.

JC50. MOVE 9 TO LAB-FLN PERFORM OPEN-LAB.
JC53. PERFORM RD102E PERFORM WRT.
    ACCEPT XA1 LINE 1 COLUMN 79 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 GO JC59.
JC531. ACCEPT JC-BR1 LINE 4 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(JC-BR1>=1 AND<=30) PERFORM DSP-ERR2 GO JC531.
JC533. ACCEPT JC-BR2 LINE 4 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(JC-BR2>=1 AND<=30) PERFORM DSP-ERR2 GO JC533.
    IF JC-BR1>JC-BR2 MOVE JC-BR1 TO WN1 MOVE JC-BR2 TO JC-BR1 MOVE WN1 TO JC-BR2.

JC535. ACCEPT JC-BC1 LINE 5 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(JC-BC1>=1 AND<=70) PERFORM DSP-ERR2 GO JC535.
JC537. ACCEPT JC-BC2 LINE 5 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(JC-BC2>=1 AND<=70) PERFORM DSP-ERR2 GO JC537.
    IF JC-BC1>JC-BC2 MOVE JC-BC1 TO WN1 MOVE JC-BC2 TO JC-BC1 MOVE WN1 TO JC-BC2.

JC541. ACCEPT JC-BL1 LINE 6 COLUMN 10 DEFAULT " " UNDERLINED PROTECTED.
    IF NOT(JC-BL1=" " OR>="A" AND<="H") PERFORM DSP-ERR2 GO JC541.
    IF JC-BL1=" " MOVE " " TO JC-BL2 GO JC544.
JC543. ACCEPT JC-BL2 LINE 6 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED.
    IF NOT(JC-BL2>="A" AND<="H") PERFORM DSP-ERR2 GO JC543.
    IF JC-BL1>JC-BL2 MOVE JC-BL1 TO WA1 MOVE JC-BL2 TO JC-BL1 MOVE WA1 TO JC-BL2.
JC544. IF JC-BL1=" " MOVE 0 TO JC-BN1 JC-BN2
      ELSE MOVE JC-BL1 TO A-A1 PERFORM STR-CONVAN COMPUTE JC-BN1=A-N1 - 64
           MOVE JC-BL2 TO A-A1 PERFORM STR-CONVAN COMPUTE JC-BN2=A-N1 - 64.

    COMPUTE WN1=(JC-BR2 - JC-BR1 + 1) * (JC-BC2 - JC-BC1 + 1) * (JC-BN2 - JC-BN1 + 1).
    MOVE WN1 TO DSP-N51 DISPLAY DSP-N51 LINE 9 COLUMN 16 BOLD.
    MOVE 9 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JC9.
    IF WN1>1000 MOVE "YOU MAY NOT CREATE MORE THAN 1000 LABELS AT A TIME"
      TO ERR-MESG PERFORM DSP-ERR GO JC58.

    PERFORM DSP-WAIT.
    PERFORM VARYING IX1 FROM JC-BR1 BY 1 UNTIL IX1>JC-BR2
    PERFORM VARYING IX2 FROM JC-BC1 BY 1 UNTIL IX2>JC-BC2
    PERFORM VARYING IX3 FROM JC-BN1 BY 1 UNTIL IX3>JC-BN2
      MOVE IX1 TO JC-BR MOVE IX2 TO JC-BC
      IF JC-BL1=" " MOVE " " TO JC-BL MOVE JC-LSZ(9) TO WN1
        ELSE MOVE LIT-ALPHA(IX3:1) TO JC-BL MOVE JC-LSZ(IX3) TO WN1 END-IF
      COMPUTE DSP-F31 ROUNDED=(165 - WN1) * 8 / 2
* note 70
      STRING "^XA^LH0,0^FWR^FS" INTO-LAB
      STRING "^FT600," DSP-F31 "^A0,240,300^FD" JC-BIN "^FS" INTO-LAB
      STRING "^FT420,170^BY8,3,170^B3,,,N,N^FDB" JC-BIN "^FS" INTO-LAB
      STRING "^PQ0001,0,1^FS" INTO-LAB
      STRING "^FWN^XZ" INTO-LAB

      END-PERFORM END-PERFORM END-PERFORM.
JC58. GO JC53.
JC59. PERFORM CLOSE-LAB GO JC9.

JC60. PERFORM RD102F PERFORM WRT.
    MOVE 4 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JC9.
    PERFORM DSP-WAIT MOVE 9 TO LAB-FLN PERFORM OPEN-LAB.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      STRING "^XA^LH0,0^FWN^FS" INTO-LAB
      PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>4
        STRING "^FT100," JC-PY(IX2) "^A0,300,300^FD" JC-PLVL(IX2,IX1) "^FS" INTO-LAB
        STRING "^FT370," JC-PY(IX2) "^BY5,3,220^B3,,,N,N^FDL" JC-PLVL(IX2,IX1) "^FS" INTO-LAB
        END-PERFORM
      STRING "^PQ0001,0,1^FS" INTO-LAB
      STRING "^FWN^XZ" INTO-LAB
      END-PERFORM.
    PERFORM CLOSE-LAB GO JC9.

JC9. GO MN9.
    REPLACE OFF.

* G-30 SHOW SALES SUMMARY
SG1. PERFORM RD85 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MN9. PERFORM WRT132.
    IF Y2 GO SG4.
* Y1
    PERFORM RD85A MOVE " " TO C-NO MOVE 3 TO IXT.
SG33. MOVE "??" TO TLNW(IXT + 1) PERFORM SG-Y PERFORM WRT.
SG333. DISPLAY "NEXT CUSTOMER ______" LINE IXT.
    ACCEPT IA18 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA18=ALL "9" GO SG39.
    IF IA18=" " IF C-NO=" " GO SG333 ELSE GO SG34. MOVE IA18 TO C-NO.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5 GO SG333.
    READ CUSTOMER NEXT REGARDLESS.
    DISPLAY "NEXT PRODUCT ____________" LINE IXT COLUMN 30.
    DISPLAY "LEAVE BLANK TO INCLUDE ALL PRODUCTS" LINE 24 BOLD.
    ACCEPT IA19 LINE IXT COLUMN 43 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    MOVE C-NO TO SM-CUS MOVE IA19 TO SM-PROD MOVE 0 TO INQ-IND.
SG34. PERFORM RD85A MOVE C-NO TO TH67(1) MOVE C-NAME TO TH67A(1).
    MOVE 4 TO IXT IF INQ-IND=0 START SALSUM KEY>=SM-KEY REGARDLESS INVALID GO SG38.
SG35. READ SALSUM NEXT REGARDLESS END GO SG38. IF SM-CUS NOT=C-NO GO SG38.
    PERFORM CLR-LN MOVE "!" TO TH68(IXT) MOVE SM-PROD TO TH69(IXT) A-A1.
    PERFORM PROD-RD MOVE PRO-DESC(1) TO TH70(IXT) MOVE "]" TO TH71(IXT).
    PERFORM SG-D ADD 1 TO IXT IF IXT<22 GO SG35.
    MOVE "*** MORE ***" TO TLNW(IXT) MOVE 1 TO INQ-IND GO SG389.
SG38. MOVE "*** END ***" TO TLNW(IXT).
    READ CUSTOMER NEXT REGARDLESS END MOVE " " TO C-NO GO SG389.
    MOVE C-NO TO SM-CUS MOVE " " TO SM-PROD MOVE 0 TO INQ-IND.
SG389. GO SG33.
SG39. GO SG9.

SG4. PERFORM RD85B MOVE " " TO P-NO MOVE 3 TO IXT.
SG43. MOVE "??" TO TLNW(IXT + 1) PERFORM SG-Y PERFORM WRT.
SG433. DISPLAY "NEXT PRODUCT ____________" LINE IXT.
    ACCEPT IA20 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA20=ALL "9" GO SG49.
    IF IA20=" " IF P-NO=" " GO SG433 ELSE GO SG44. MOVE IA20 TO P-NO.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO SG433.
    READ PRODUCT NEXT REGARDLESS PERFORM PROD-DESC.
    DISPLAY "NEXT CUSTOMER ______" LINE IXT COLUMN 35.
    DISPLAY "LEAVE BLANK TO INCLUDE ALL CUSTOMERS" LINE 24 BOLD.
    ACCEPT IA21 LINE IXT COLUMN 49 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    MOVE P-NO TO SM-KPROD MOVE IA21 TO SM-KCUS MOVE 0 TO INQ-IND.
SG44. PERFORM RD85B MOVE P-NO TO TH74(1) MOVE PRO-DESC(1) TO TH75(1).
    MOVE 4 TO IXT IF INQ-IND=0 START SALSUM KEY>=SM-KP REGARDLESS INVALID GO SG48.
SG45. READ SALSUM NEXT REGARDLESS END GO SG48. IF SM-KPROD NOT=P-NO GO SG48.
    PERFORM CLR-LN MOVE "!" TO TH76(IXT).
    MOVE SM-CUS TO TH77(IXT) A-A1 PERFORM RD-CUS.
    MOVE C-NAME TO TH78(IXT) MOVE "]" TO TH79(IXT).
    PERFORM SG-D ADD 1 TO IXT IF IXT<22 GO SG45.
    MOVE "*** MORE ***" TO TLNW(IXT) MOVE 1 TO INQ-IND GO SG489.
SG48. MOVE "*** END ***" TO TLNW(IXT).
    READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO SG489. PERFORM PROD-DESC.
    MOVE P-NO TO SM-KPROD MOVE " " TO SM-KCUS MOVE 0 TO INQ-IND.
SG489. GO SG43.
SG49. GO SG9.

SG9. PERFORM WRT80 GO MN9.

SG-D. ADD 1 TO IXT PERFORM CLR-LN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE SM-QTY(IX1) TO TH72(IXT,IX1) MOVE SM-AMT(IX1) TO TH73(IXT,IX1) END-PERFORM.
SG-Y. MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE D-YEAR TO TH80(3,IX1) SUBTRACT 1 FROM D-YEAR END-PERFORM.

* G-31 SHOW ALTERNATE PRODUCTS
AQ1. PERFORM RD65 MOVE " " TO P-NO MOVE 3 TO IXT.
AQ3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
AQ33. DISPLAY "NEXT PRODUCT NO. ____________" LINE IXT.
    ACCEPT IA22 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA22=ALL "9" GO AQ9.
    IF IA22=" " IF P-NO=" " GO AQ33 ELSE GO AQ4. MOVE IA22 TO P-NO.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO AQ33.
AQ35. READ PRODUCT NEXT REGARDLESS END PERFORM DSP-ERR6 GO AQ33.
    IF P-GEN>" " GO AQ35. PERFORM PROD-DESC.
    MOVE P-NO TO AQ-PROD AL-PROD MOVE " " TO AL-ALT MOVE 0 TO INQ-IND.
AQ4. PERFORM RD65 MOVE P-NO TO TF417(1) MOVE PRO-DESC(1) TO TF418(1).
    MOVE 4 TO IXT IF INQ-IND=0 START ALTERNATES KEY>AL-KEY REGARDLESS INVALID GO AQ8.
AQ5. READ ALTERNATES NEXT REGARDLESS END GO AQ8. IF AL-PROD NOT=AQ-PROD GO AQ8.
    PERFORM CLR-LN MOVE AL-ALT TO TF419(IXT) A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO TF420(IXT).
    ADD 1 TO IXT IF IXT<22 GO AQ5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO AQ89.
AQ8. MOVE "*** END ***" TO TLN(IXT).
    MOVE AQ-PROD TO P-NO READ PRODUCT REGARDLESS.
AQ83. READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO AQ89.
    IF P-GEN>" " GO AQ83. PERFORM PROD-DESC.
    MOVE P-NO TO AQ-PROD AL-PROD MOVE " " TO AL-ALT MOVE 0 TO INQ-IND.
AQ89. GO AQ3.
AQ9. GO MN9.

* G-32 SHOW PRODUCT DRAWING
FK1. OPEN INPUT DRAWINGS ALLOWING ALL PERFORM SIXINIT.
FK3. MOVE 1 TO SDR-PG MOVE " " TO SDR-DRAW(1) SDR-DRAW(2) SDR-PROD(1) SDR-PROD(2).
    PERFORM SIXPG2 PERFORM SIXCLS PERFORM SIXPG1 PERFORM SIXCLS PERFORM SIXD.
    PERFORM RD225 PERFORM WRT PERFORM RD226 PERFORM WRT.
FK5. ACCEPT SDR-INP LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SDR-INP=ALL "9" GO FK9.
    MOVE 2 TO SDR-TP PERFORM SHOW-DRAWING IF SDR-KER=1 GO FK5. GO FK3.
FK9. PERFORM SIXPG2 PERFORM SIXCLS PERFORM SIXPG1 PERFORM SIXCLS PERFORM SIXD.
    CLOSE DRAWINGS GO MN9.

* G-33 DELETE PRODUCT DRAWING
UE1. OPEN I-O DRAWINGS ALLOWING ALL PDRAWINGS ALLOWING ALL.
UE3. PERFORM RD242 PERFORM WRT.
    ACCEPT UE-DRAW LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR UE-DRAW=ALL "9" GO UE9.
    MOVE UE-DRAW TO DR-DRAW MOVE 1 TO DR-PAGE MOVE 0 TO DR-LINE.
    READ DRAWINGS REGARDLESS INVALID PERFORM DSP-ERR41 GO UE3.
    MOVE 3 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO UE3.

    MOVE UE-DRAW TO DR-DRAW MOVE 1 TO DR-PAGE MOVE 0 TO DR-LINE.
    MOVE DR-KEY TO WA1.
UE33. MOVE WA1 TO DR-KEY MOVE 0 TO IX1.
    START DRAWINGS KEY>=DR-KEY REGARDLESS INVALID GO UE39.
UE35. READ DRAWINGS NEXT REGARDLESS END GO UE39. MOVE DR-KEY TO WA1.
    IF DR-DRAW NOT=UE-DRAW GO UE39. DELETE DRAWINGS.
    ADD 1 TO IX1 IF IX1=100 CLOSE DRAWINGS OPEN I-O DRAWINGS ALLOWING ALL GO UE33.
    GO UE35.
UE39. MOVE UE-DRAW TO DG-DRAW MOVE 1 TO DG-PAGE MOVE 0 TO DG-LINE.
    MOVE DG-KEY TO WA1.
UE43. MOVE WA1 TO DG-KEY MOVE 0 TO IX1.
    START PDRAWINGS KEY>=DG-KEY REGARDLESS INVALID GO UE49.
UE45. READ PDRAWINGS NEXT REGARDLESS END GO UE49. MOVE DG-KEY TO WA1.
    IF DG-DRAW NOT=UE-DRAW GO UE49. DELETE PDRAWINGS.
    ADD 1 TO IX1 IF IX1=100 CLOSE PDRAWINGS OPEN I-O PDRAWINGS ALLOWING ALL GO UE43.
    GO UE45.
UE49. GO UE3.
UE9. CLOSE DRAWINGS PDRAWINGS GO MN9.

* G-34 SHOW PRODUCT TRANSACTIONS
RG1. PERFORM RD149 MOVE " " TO P-NO MOVE 3 TO IXT.
RG3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
RG33. DISPLAY "NEXT PRODUCT NO. ____________      DATE ______" LINE IXT.
    ACCEPT IA34 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA34=ALL "9" GO RG9.
    IF IA34=" " IF P-NO=" " GO RG33 ELSE GO RG4. MOVE IA34 TO P-NO.
    MOVE 41 TO IXU PERFORM AX-DT-INV.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO RG33.
    READ PRODUCT NEXT REGARDLESS PERFORM RD-GEN PERFORM PROD-DESC.
    MOVE P-NO TO PE-PROD MOVE DATE0 TO PE-DATE MOVE 0 TO PE-TIME INQ-IND.
RG4. PERFORM RD149 MOVE P-NO TO TF148(1) MOVE PRO-DESC(1) TO TF149(1).
    MOVE 4 TO IXT IF INQ-IND=0 START PRODTRANS KEY>=PE-KEY REGARDLESS INVALID GO RG8.
RG5. READ PRODTRANS NEXT REGARDLESS END GO RG8. IF PE-PROD NOT=P-NO GO RG8.
    PERFORM CLR-LN MOVE PE-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF150(IXT).
    MOVE PE-TRANS TO TF151(IXT) MOVE PE-FBIN TO TF152(IXT) MOVE PE-TBIN TO TF153(IXT).
    MOVE PE-QTY TO TF154(IXT) MOVE PE-LOT TO TF155(IXT) MOVE PE-NO TO TF156(IXT).
    MOVE PE-CARTONS TO TF157(IXT) MOVE PE-QTY-PACK TO TF158(IXT) MOVE PE-CONT TO TF159(IXT).
    ADD 1 TO IXT IF IXT<22 GO RG5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO RG89.
RG8. MOVE "*** END ***" TO TLN(IXT).
    IF GEN-IND=1 MOVE GEN-ALT TO P-NO READ PRODUCT REGARDLESS.
    READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO RG89.
    PERFORM RD-GEN PERFORM PROD-DESC.
    MOVE P-NO TO PE-PROD MOVE DATE0 TO PE-DATE MOVE 0 TO PE-TIME INQ-IND.
RG89. GO RG3.
RG9. GO MN9.

* G-35 MODIFY USER DATA
WR1.
WR3. PERFORM RD414 PERFORM WRT.
    ACCEPT US-USER LINE 3 COLUMN 8 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR US-USER=" " OR ALL "9" GO WR9.
    READ USERS REGARDLESS INVALID PERFORM DSP-ERR32 GO WR3.
    DISPLAY US-PC LINE 3 COLUMN 33 CONVERSION.
    DISPLAY US-PRNM LINE 4 COLUMN 33.
    MOVE 9 TO IXT MOVE 20 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      DISPLAY US-CFLD(IX1) LINE IXT COLUMN IXU CONVERSION ADD 3 TO IXU END-PERFORM.
    MOVE 10 TO IXT MOVE 20 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      DISPLAY US-PFLD(IX1) LINE IXT COLUMN IXU CONVERSION ADD 3 TO IXU END-PERFORM.

WR33. ACCEPT US-PC LINE 3 COLUMN 33 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY US-PC LINE 3 COLUMN 33 CONVERSION.
    IF US-PC>1 PERFORM DSP-ERR2 GO WR33. MOVE US-PC TO USN-KPC.
WR35. ACCEPT US-PRNM LINE 4 COLUMN 33 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF NOT(US-PRNM="PR" OR "PA" OR "PB") PERFORM DSP-ERR2 GO WR35. MOVE US-PRNM TO USN-PRNM.

    PERFORM DSP-PF3 MOVE 9 TO IXT MOVE 20 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      ACCEPT US-CFLD(IX1) LINE IXT COLUMN IXU DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY
      DISPLAY US-CFLD(IX1) COLUMN IXU CONVERSION IF KPF3 GO WR42 END-IF
      ADD 3 TO IXU END-PERFORM.
WR42. MOVE 10 TO IXT MOVE 20 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      ACCEPT US-PFLD(IX1) LINE IXT COLUMN IXU DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY
      DISPLAY US-PFLD(IX1) COLUMN IXU CONVERSION IF KPF3 GO WR44 END-IF
      ADD 3 TO IXU END-PERFORM.
WR44. PERFORM DSP-ERS.
    REWRITE US-RECORD ALLOWING NO UNLOCK USERS PERFORM DSP-CONT GO WR3.
WR9. GO MN9.

* G-36 FREIGHT BILL-TO FILE MAINTENANCE
MU1. OPEN I-O BILLTO ALLOWING ALL.
MU3. PERFORM RD232 PERFORM WRT MOVE LOW-VALUES TO BT-RECORD INITIALIZE BT-REC.
MU33. ACCEPT BT-CUS LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR BT-CUS=ALL "9" GO MU9.
    MOVE BT-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO MU33.
    DISPLAY C-NAME LINE 4 COLUMN 12.
    ACCEPT BT-TO LINE 3 COLUMN 32 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ BILLTO REGARDLESS INVALID MOVE 0 TO MU-KFIN GO MU4. MOVE 1 TO MU-KFIN.
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>4
      DISPLAY BT-LINE(IX1) LINE IXT COLUMN 2 ADD 1 TO IX1 IXT END-PERFORM.
MU4.
MU5. PERFORM DSP-NEXT ACCEPT MU-OP LINE 1 COLUMN 73 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF MU-OP=0 GO MU3. IF MU-OP>3 PERFORM DSP-ERR1 GO MU5.
    IF MU-OP=1 AND MU-KFIN=1 MOVE "THIS CUSTOMER & SHIP-TO COMBINATION ALREADY EXISTS"
      TO ERR-MESG PERFORM DSP-ERR GO MU3.
    IF (MU-OP=2 OR 3) AND MU-KFIN=0 PERFORM DSP-ERR30 GO MU3.
    IF MU-OP=3 IF BT-LINE(1)>" " PERFORM DSP-ERR49
                 ELSE DELETE BILLTO END-DELETE END-IF GO MU3.

* op=1,2
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>4
      ACCEPT BT-LINE(IX1) LINE IXT COLUMN 2 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      ADD 1 TO IX1 IXT END-PERFORM.
    IF MU-OP=1 WRITE BT-RECORD ALLOWING NO ELSE REWRITE BT-RECORD ALLOWING NO.
    UNLOCK BILLTO PERFORM DSP-CONT GO MU3.
MU9. CLOSE BILLTO GO MN9.

* G-37 SOLD-TO FILE MAINTENANCE
MV1. OPEN I-O SOLDTO ALLOWING ALL.
MV3. PERFORM RD245 PERFORM WRT MOVE LOW-VALUES TO UH-RECORD INITIALIZE UH-REC.
MV33. ACCEPT UH-NO LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR UH-NO=ALL "9" GO MV9.
    MOVE UH-NO TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO MV33.
    DISPLAY C-NAME LINE 4 COLUMN 12 C-ADD1 LINE 5 COLUMN 12
      C-ADD2 LINE 6 COLUMN 12 C-POST LINE 7 COLUMN 12.
    READ SOLDTO REGARDLESS INVALID MOVE 0 TO MV-KFIN GO MV4. MOVE 1 TO MV-KFIN.
    MOVE 1 TO IX1 MOVE 11 TO IXT PERFORM UNTIL IX1>5
      DISPLAY UH-LINE(IX1) LINE IXT COLUMN 2 ADD 1 TO IX1 IXT END-PERFORM.
MV4.
MV5. PERFORM DSP-NEXT ACCEPT MV-OP LINE 1 COLUMN 73 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF MV-OP=0 GO MV3. IF MV-OP>3 PERFORM DSP-ERR1 GO MV5.
    IF MV-OP=1 AND MV-KFIN=1 PERFORM DSP-ERR39 GO MV3.
    IF (MV-OP=2 OR 3) AND MV-KFIN=0 PERFORM DSP-ERR30 GO MV3.
    IF MV-OP=3 IF UH-LINE(1)>" " PERFORM DSP-ERR49
                 ELSE DELETE SOLDTO END-DELETE END-IF GO MV3.

* op=1,2
    MOVE 1 TO IX1 MOVE 11 TO IXT PERFORM UNTIL IX1>5
      ACCEPT UH-LINE(IX1) LINE IXT COLUMN 2 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      ADD 1 TO IX1 IXT END-PERFORM.
    IF MV-OP=1 WRITE UH-RECORD ALLOWING NO ELSE REWRITE UH-RECORD ALLOWING NO.
    UNLOCK SOLDTO PERFORM DSP-CONT GO MV3.
MV9. CLOSE SOLDTO GO MN9.

* G-38 SHOW PRODUCTION SHORT SCHEDULE
JP1. PERFORM WRT132 PERFORM OPEN-MACSCHED.
JP3. PERFORM RD248 PERFORM WRT.
    ACCEPT JP-MAC LINE 1 COLUMN 43 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR JP-MAC=99 GO JP9. IF JP-MAC=0 GO JP3.
    MOVE JP-MAC TO A-N1 PERFORM RD-MAC DISPLAY M-DESC1 LINE 1 COLUMN 47.
    MOVE JP-MAC TO MQ-MAC READ MACSCHED REGARDLESS INVALID
      MOVE "NO SCHEDULE FOR THIS MACHINE" TO ERR-MESG PERFORM DSP-ERR GO JP3.
    DISPLAY MQ-PDT LINE 1 COLUMN 118.

    MOVE 1 TO JP-IXL MOVE 5 TO IXT.
JP5. MOVE " " TO JP-LND MOVE JP-IXL TO JP-LD1 MOVE "." TO JP-LD2.
    IF MQ-MO(JP-IXL)=0 GO JP58.
    MOVE MQ-MO(JP-IXL) TO JP-LD3 R-NO READ PRODORD REGARDLESS INVALID GO JP58.
    IF R-FIN=1 MOVE "*" TO JP-LD3A.
    MOVE R-PROD TO JP-LD4 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO JP-LD5.
    MOVE R-QTY-ORD TO JP-LD6 PERFORM SET-PART MOVE PART-NO TO JP-LD7.
    IF R-COILS=0 PERFORM CALC-NCOILS ELSE MOVE R-COILS TO A-L1.
    MOVE A-L1 TO JP-LD8 MOVE MQ-COM(JP-IXL) TO JP-LD9 MOVE P-ALERT TO JP-LD10.
    DISPLAY JP-LND LINE IXT.
JP58. ADD 1 TO JP-IXL IXT IF JP-IXL<=15 GO JP5.
    PERFORM DSP-CONT GO JP3.
JP9. CLOSE MACSCHED PERFORM WRT80 GO MN9.

* S: SHIPPING FUNCTIONS

* S-1 ADD BLANKET ORDERS TO SHIP
LJ1. PERFORM RD340 PERFORM WRT.
LJ3. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT O-NO LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR O-NO=999999 GO LJ9. IF O-NO=0 GO LJ3.
    READ SAORD REGARDLESS INVALID PERFORM DSP-ERR8 GO LJ3.
    IF O-BLANKET=0 PERFORM DSP-ERR50 GO LJ3.
    MOVE O-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID
      MOVE "INVALID CUSTOMER NO. IN THIS ORDER" TO ERR-MESG PERFORM DSP-ERR GO LJ3.
    DISPLAY C-NAME LINE 3 COLUMN 48 PERFORM LJ-A IF XA3="NO" GO LJ3.
    MOVE C-AUTO TO AUTO-CODE PERFORM INIT-HO.
    DISPLAY "DATE REQUIRED: ______" LINE 4 BOLD.
    MOVE O-DATE-REQ TO D-DATE MOVE 4 TO IXT MOVE 16 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO HO-DATE-REQ.
    DISPLAY "CUSTOMER ORDER NO.: _________" LINE 4 COLUMN 35 BOLD.
    ACCEPT HO-CUSORD LINE 4 COLUMN 55 DEFAULT O-CUSORD UNDERLINED PROTECTED EDITING.
LJ43. IF HO-SEQ=19 MOVE "TOO MANY ORDERS WITH THIS ORDER NO. IN THE SHIPPING FILE"
       TO ERR-MESG PERFORM DSP-ERR GO LJ3.
    ADD 1 TO HO-SEQ WRITE HO-RECORD ALLOWING NO INVALID GO LJ43. UNLOCK SHIPORD.

    MOVE 7 TO IXT DISPLAY "LINE  PRODUCT                        QTY SHIPPED" LINE IXT BOLD.
*                           ..   ............                     .......-
    COMPUTE L-NO=100 * O-NO START SALIN KEY>L-KEY REGARDLESS INVALID GO LJ8.
LJ5. READ SALIN NEXT REGARDLESS END GO LJ8. IF L-ORD NOT=O-NO GO LJ8.
    IF L-QTY=0 GO LJ5. IF AUTO-GMC MOVE 15 TO WN1 ELSE MOVE 23 TO WN1.
    ADD 1 TO IXT IF IXT>WN1 MOVE 8 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    DISPLAY L-LINE LINE IXT COLUMN 2 CONVERSION L-PROD COLUMN 7.
    PERFORM INIT-HL DISPLAY HL-QTY LINE IXT COLUMN 40 CONVERSION.
    ACCEPT HL-QTY LINE IXT COLUMN 40 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY HL-QTY LINE IXT COLUMN 40 CONVERSION.

    IF NOT AUTO-GMC GO LJ78.
    DISPLAY "SHIP LABEL DATA:" LINE 16 REVERSED.
    DISPLAY "PKG 11Z (DLOC):" LINE 17 COLUMN 5 BOLD.
    DISPLAY "PKG 12Z (PLT.DOCK):" LINE 18 COLUMN 5 BOLD.
    DISPLAY "PKG 13Z:" LINE 19 COLUMN 5 BOLD.
    DISPLAY "PKG 14Z:" LINE 20 COLUMN 5 BOLD.
    DISPLAY "PKG 15Z:" LINE 21 COLUMN 5 BOLD.
    DISPLAY "PKG 16Z:" LINE 22 COLUMN 5 BOLD.
    DISPLAY "PKG 17Z:" LINE 23 COLUMN 5 BOLD.
    REPLACE ==ACC-ALP== BY ==COLUMN 25 DEFAULT " " UNDERLINED PROTECTED EDITING==.
    ACCEPT ED-PKG11 LINE 17 ACC-ALP.
    ACCEPT ED-PKG12 LINE 18 ACC-ALP.
    ACCEPT ED-PKG13 LINE 19 ACC-ALP.
    ACCEPT ED-PKG14 LINE 20 ACC-ALP.
    ACCEPT ED-PKG15 LINE 21 ACC-ALP.
    ACCEPT ED-PKG16 LINE 22 ACC-ALP.
    ACCEPT ED-PKG17 LINE 23 ACC-ALP.
    REPLACE OFF.
    MOVE ED-LABINF TO HL-LABINF DISPLAY " " LINE 16 ERASE END SCREEN.
LJ78. WRITE HL-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK SHIPLIN GO LJ5.

LJ8. PERFORM LJ-A IF XA3 NOT="NO" GO LJ88. DELETE SHIPORD.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LJ84.
LJ83. READ SHIPLIN NEXT REGARDLESS END GO LJ84. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LJ84.
    DELETE SHIPLIN GO LJ83.
LJ84.
LJ88. GO LJ3.
LJ9. GO MN9.

LJ-A. MOVE "'NO' IF YOU DO NOT WANT TO ADD THIS ORDER: __" TO TMSG PERFORM DSP-PROMPT.

* S-2 PREVENT SELECTIVELY BIN ALLOCATION
LP1. PERFORM RD341 PERFORM WRT.
LP3. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT HO-ORD LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO LP9. IF HO-ORD=0 GO LP3.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO LP3.
    IF HO-IND NOT=0 MOVE "ORDER STATUS IS NOT 0" TO ERR-MESG PERFORM DSP-ERR GO LP3.
    MOVE HO-CUS TO A-A1 PERFORM RD-CUS DISPLAY C-NAME LINE 3 COLUMN 48.
    DISPLAY "ALLOW BIN ALLOCATION: _" LINE 5 BOLD.
LP5. IF HO-BIND=0 MOVE "Y" TO XA1 ELSE MOVE "N" TO XA1.
    DISPLAY "'Y' TO ALLOW BIN ALLOCATION, OR 'N' TO PREVENT IT" LINE 24 BOLD.
    ACCEPT XA1 LINE 5 COLUMN 23 DEFAULT CURRENT UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA1="Y" MOVE 0 TO HO-BIND ELSE IF XA1="N" MOVE 1 TO HO-BIND
      ELSE PERFORM DSP-ERR14 GO LP5.
    REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD GO LP3.
LP9. GO MN9.

* S-3 MODIFY ORDER STATUS IN SHIPPING FILE
LD1. PERFORM RD342 PERFORM WRT.
LD3. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT HO-ORD COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO LD9. IF HO-ORD=0 GO LD3.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO LD3.
    MOVE HO-CUS TO A-A1 PERFORM RD-CUS DISPLAY C-NAME LINE 3 COLUMN 48.
    DISPLAY "CURRENT STATUS:" LINE 5 BOLD HO-IND COLUMN 17 CONVERSION.
    DISPLAY "    NEW STATUS: _" LINE 6 BOLD "   (0 - 7, OR 9 TO DELETE THE ORDER)".
LD33. ACCEPT XN1 LINE 6 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(XN1>=0 AND<=7 OR=9) PERFORM DSP-ERR2 GO LD33.
    PERFORM DSP-SURE IF XA3 NOT="YES" GO LD8.
    IF XN1=9 PERFORM CAN-SHORDER
      ELSE MOVE XN1 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
LD8. GO LD3.
LD9. GO MN9.

* S-4 LIST ORDERS TO SHIP
LR1. PERFORM RD334 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LR29.
LR23. READ SHIPORD NEXT REGARDLESS END GO LR29. IF HO-IND NOT=2 GO LR23.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LR28.
LR25. READ SHIPLIN NEXT REGARDLESS END GO LR28. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LR28.
    IF HL-QTY-AL=0 GO LR25. INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO LR278.
LR273. READ BINALLOC NEXT REGARDLESS END GO LR278. IF BA-NO NOT=HL-NO GO LR278.
    PERFORM INIT-RP MOVE BA-BIN TO RP-F293 MOVE BA-KEY TO RP-F294.
    WRITE RP-RECORD GO LR273.
LR278. GO LR25.
LR28. GO LR23.
LR29. PERFORM OPEN-PR PERFORM LR-PAGE MOVE " " TO OLD-A MOVE 0 TO LR-R LR-Q.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO LR9.
LR3. READ REPFL NEXT END GO LR9. IF RP-F293=OLD-A GO LR4.
    IF OLD-A>" " PERFORM LR-B. MOVE RP-F293 TO OLD-A FD276 B-NO.
    READ BIN REGARDLESS INVALID GO LR4.
    MOVE B-PROD TO FD277 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FD278.
LR4. MOVE RP-F294 TO BA-KEY READ BINALLOC REGARDLESS MOVE BA-ORD TO FD279.
    MOVE BA-SEQ TO EXT-S PERFORM DSP-EXT MOVE EXT-D TO FD280.
    MOVE "(" TO FD281 MOVE BA-LOT TO FD282 MOVE ")" TO FD283.
    MOVE BA-CARTONS TO FD284 MOVE "x" TO FD285 MOVE BA-QTY-PACK TO FD286.
    MOVE BA-QTY TO FD287 IF BA-PARTIAL=1 MOVE "P" TO FD288.
    PERFORM LR-LINE ADD BA-CARTONS TO LR-R ADD BA-QTY TO LR-Q GO LR3.
LR9. PERFORM LR-B.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

LR-B. MOVE LR-R TO FD289 MOVE LR-Q TO FD290 PERFORM LR-LINE 2 TIMES.
    MOVE 0 TO LR-R LR-Q.
LR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM LR-PAGE.
LR-PAGE. MOVE "ORDERS TO SHIP" TO FF3 MOVE "** BY BIN **" TO FF4 PERFORM PR-PAGE.
    MOVE "BIN    PRODUCT       DESCRIPTION                        ORDER     LOT NO.     CARTONS   QUANTITY    TOTAL: CTNS      QTY" TO PREC PERFORM PR-LINE-3.
*         .....  ............  ................................  ......-.. (.......)  ... x ....  ...,... .          ...  .....,...

* S-5 SHOW ORDERS TO SHIP BY VIA CODE
LQ1. PERFORM RD52 MOVE 0 TO LQ-S1 LQ-S2 LQ-KF PERFORM LQ-CLR MOVE 3 TO IXT.
    PERFORM LQ-V.
LQ3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
    IF LQ-KE=1 MOVE "NO ORDERS IN SHIPPING FILE" TO ERR-MESG
      PERFORM DSP-ERR GO LQ9.
    DISPLAY "NEXT SHIP-VIA CODE: ___        SELECT STATUS: _ _  ('0 0' FOR ALL)" LINE IXT.
    MOVE LQ-S1 TO DSP-N21 MOVE LQ-S2 TO DSP-N22.
    DISPLAY DSP-N21 LINE IXT COLUMN 47 DSP-N22 COLUMN 49.
    ACCEPT LQ-VIA LINE IXT COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR LQ-VIA=999 PERFORM LQ-F GO LQ9.
* note 42.1
    ACCEPT LQ-S1 LINE IXT COLUMN 48 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE LQ-S1 TO DSP-N21 DISPLAY DSP-N21 LINE IXT COLUMN 47.
    ACCEPT LQ-S2 LINE IXT COLUMN 50 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE LQ-S2 TO DSP-N21 DISPLAY DSP-N21 LINE IXT COLUMN 49.

LQ33. IF LQ-VIA NOT=0 PERFORM LQ-CLR PERFORM LQ-F
       INITIALIZE HO-KV MOVE LQ-VIA TO HO-VIA
       START SHIPORD KEY>HO-KV REGARDLESS INVALID MOVE 1 TO LQ-VIA GO LQ33.
    PERFORM RD52 MOVE HO-VIA TO LQ-VIA TF376(1) SV-KEY PERFORM RD-VIA.
    MOVE SV-CARRIER TO TF377(1).
    PERFORM DSP-QWAIT MOVE 4 TO IXT.
* note 220
    IF NOT(LQ-VIA=46 AND LQ-KF=0) GO LQ48.
    MOVE 1 TO LQ-KF PERFORM OPEN-SORT.
LQ43. READ SHIPORD NEXT REGARDLESS END GO LQ46. IF HO-VIA NOT=LQ-VIA GO LQ46.
    IF HO-CUSORD>" " MOVE HO-CUSORD(1:2) TO SR-F134 GO LQ44.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO LQ43.
    MOVE O-CUSORD(1:2) TO SR-F134.
LQ44. MOVE HO-DATE-REQ TO SR-F135 MOVE HO-NO TO SR-F136.
    WRITE SR-RECORD INVALID CONTINUE. GO LQ43.
LQ46. MOVE HO-NO TO LQ-SAVNO.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID CONTINUE.
LQ48.

LQ5. IF LQ-KF=0 READ SHIPORD NEXT REGARDLESS END PERFORM LQ-V GO LQ8
       ELSE READ SORTFL NEXT END GO LQ8 END-READ
         MOVE SR-F136 TO HO-NO READ SHIPORD REGARDLESS.
    IF HO-VIA NOT=LQ-VIA GO LQ8.
    IF NOT(LQ-S1=0 AND LQ-S2=0 OR HO-IND=LQ-S1 OR LQ-S2) GO LQ5.

    IF LQ-KF=0 IF HO-CUS=OLD-C GO LQ62 END-IF IF OLD-C>" " PERFORM LQ-C.
    MOVE HO-CUS TO OLD-C.
LQ62. IF LQ-KF=0 OR SR-F134=OLD-A GO LQ64. IF OLD-A>" " PERFORM LQ-P.
    MOVE SR-F134 TO OLD-A.
LQ64. PERFORM CLR-LN MOVE HO-CUS TO TF378(IXT) A-A1 PERFORM RD-CUS.
    MOVE C-NAME TO TF379(IXT) MOVE HO-CUSORD TO TF379A(IXT).
    IF HO-CUSORD=" " MOVE HO-ORD TO A-N1 PERFORM RD-SAORD MOVE O-CUSORD TO TF379A(IXT).
    MOVE HO-ORD TO TF380(IXT) MOVE HO-SEQ TO EXT-S PERFORM DSP-EXT MOVE EXT-D TO TF380A(IXT).
    MOVE HO-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TF381(IXT).
    MOVE 0 TO WN1 WN2 WN3 WN4.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LQ74.
LQ73. READ SHIPLIN NEXT REGARDLESS END GO LQ74. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LQ74.
    IF HL-QTY-AL NOT=0 ADD HL-QTY-AL TO WN3 ADD HL-WEIGHT-AL TO WN2 LQ-PWT LQ-CWT
      ELSE ADD HL-QTY-ALPREV TO WN3 ADD HL-WEIGHT-ALPREV TO WN2 LQ-PWT LQ-CWT.
    IF HL-QTY-NAL NOT=0 ADD HL-WEIGHT-NAL TO WN2 LQ-PWT LQ-CWT
      ELSE ADD HL-WEIGHT-NALPREV TO WN2 LQ-PWT LQ-CWT.
    ADD 1 TO WN1 ADD HL-QTY TO WN4 GO LQ73.
LQ74. COMPUTE TF382(IXT) ROUNDED=100 * WN3 / WN4 SIZE ERROR CONTINUE.
    MOVE WN2 TO TF383(IXT) MOVE WN1 TO TF384(IXT) MOVE HO-IND TO TF385(IXT).
    IF C-HOLD=1 MOVE "-H" TO TF386(IXT).
    ADD 1 TO IXT IF LQ-VIA NOT=46 AND IXT<22 OR LQ-VIA=46 AND IXT<21 GO LQ5.
    MOVE "*** MORE ***" TO TLN(IXT) PERFORM DSP-ERS GO LQ89.
LQ8. IF LQ-KF=1 PERFORM LQ-P. PERFORM LQ-C PERFORM LQ-CLR PERFORM LQ-F.
    START SHIPORD KEY=HO-KV REGARDLESS.
    MOVE "*** END ***" TO TLN(IXT) PERFORM DSP-ERS.
LQ89. GO LQ3.
LQ9. GO MN9.

LQ-CLR. MOVE 0 TO LQ-PWT LQ-CWT MOVE " " TO OLD-A OLD-C.
LQ-F. IF LQ-KF=1 MOVE 0 TO LQ-KF PERFORM CLOSE-SORT
       MOVE LQ-SAVNO TO HO-NO READ SHIPORD REGARDLESS.
LQ-P. PERFORM LQ-P1 THRU LQ-P9.
LQ-P1. IF OLD-A=" " GO LQ-P9. PERFORM CLR-LN MOVE "!" TO TF387(IXT).
    MOVE OLD-A TO TF388(IXT) MOVE "TOTAL:" TO TF389(IXT).
    MOVE LQ-PWT TO TF390(IXT) MOVE "*" TO TF391(IXT) MOVE "]" TO TF392(IXT).
    MOVE 0 TO LQ-PWT ADD 1 TO IXT.
LQ-P9. EXIT.
LQ-C. PERFORM LQ-C1 THRU LQ-C9.
LQ-C1. IF OLD-C=" " GO LQ-C9. PERFORM CLR-LN MOVE "!" TO TF387(IXT).
    MOVE "CUST" TO TF388(IXT) MOVE "TOTAL:" TO TF389(IXT).
    MOVE LQ-CWT TO TF390(IXT) MOVE "**" TO TF391(IXT) MOVE "]" TO TF392(IXT).
    MOVE 0 TO LQ-CWT ADD 1 TO IXT.
LQ-C9. EXIT.
LQ-V. PERFORM LQ-V1 THRU LQ-V9.
LQ-V1. MOVE 0 TO LQ-KE INITIALIZE HO-KV.
    START SHIPORD KEY>HO-KV REGARDLESS INVALID MOVE 1 TO LQ-KE GO LQ-V9.
    READ SHIPORD NEXT REGARDLESS START SHIPORD KEY=HO-KV REGARDLESS.
LQ-V9. EXIT.

* S-6 SHOW OPEN LINES IN ORDER
LO1. PERFORM RD54 MOVE 0 TO HO-NO MOVE 5 TO IXT.
LO3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
LO33. DISPLAY "NEXT ORDER NO. ______" LINE IXT ERASE LINE.
    ACCEPT IA39 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA39=999999 GO LO9.
    IF IA39=0 IF HO-ORD=0 GO LO33 ELSE GO LO4. MOVE IA39 TO HO-ORD.
    MOVE HO-ORD TO A-N1 MOVE 25 TO IXU PERFORM RD-EXT IF A-N1=0 GO LO33.
    COMPUTE HL-NO=100 * HO-NO MOVE 0 TO INQ-IND.
LO4. PERFORM RD54 MOVE HO-ORD TO TF304(1).
    MOVE HO-SEQ TO EXT-S PERFORM DSP-EXT MOVE EXT-D TO TF305(1).
    MOVE HO-CUS TO TF306(1) A-A1 PERFORM RD-CUS MOVE C-NAME TO TF307(1).
    MOVE HO-IND TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO TF393(3).
    IF C-HOLD=1 MOVE "-H" TO TF394(3).
    MOVE HO-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TF395(3).
    MOVE HO-VIA TO TF396(3) SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO TF397(3).
    MOVE 6 TO IXT IF INQ-IND=0 START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LO8.
LO5. READ SHIPLIN NEXT REGARDLESS END GO LO8. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LO8.
    PERFORM CLR-LN MOVE HL-LINE TO TF400(IXT).
    MOVE HL-PROD TO TF401(IXT) A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO TF402(IXT).
    MOVE HL-QTY TO TF403(IXT) MOVE HL-QTY-ALPREV TO TF404(IXT).
    MOVE HL-QTY-AL TO TF404A(IXT) ADD 1 TO IXT IF IXT<22 GO LO5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO LO89.
LO8. MOVE "*** END ***" TO TLN(IXT).
    READ SHIPORD NEXT REGARDLESS END MOVE 0 TO HO-NO GO LO89.
    COMPUTE HL-NO=100 * HO-NO MOVE 0 TO INQ-IND.
LO89. GO LO3.
LO9. GO MN9.

* S-7 GENERATE BILLS OF LADING
LF1. PERFORM RD335 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    OPEN I-O CFORD ALLOWING ALL CFLIN ALLOWING ALL BILLTO ALLOWING ALL.
    PERFORM DSP-WAIT IF ITOOL GO LF6.

    PERFORM OPEN-PR WRITE PREC AFTER PAGE.
    MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO LF59.
LF3. READ CFORD NEXT REGARDLESS END GO LF59. IF FO-PIND(2)=1 GO LF3.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    PERFORM GET-CUSPHONE MOVE A-A1 TO LF-PHONE.
    MOVE " " TO LF-FDOCK IF FO-DOCK>" " STRING "DOCK " FO-DOCK DELIMITED SIZE INTO LF-FDOCK.
    IF FO-SHIPTO=0 GO LF34. MOVE FO-CUS TO SA-CUS MOVE FO-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO LF34. PERFORM GET-FO-CUSADD.
LF34. MOVE 1 TO WS-LINES MOVE 12 TO WS-PR.
    MOVE FO-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO FD260.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE D-MM TO FD261 MOVE D-DD TO FD262 MOVE D-YY TO FD263 PERFORM PR-LINE-2.
    MOVE C-NAME TO FD264 PERFORM PR-LINE-2.
    IF FO-SHIPTO=0 AND FO-ADD1=" " AND FO-ADD2=" " MOVE LF-PHONE TO FD265
      PERFORM PR-LINE-2 MOVE C-ADD1 TO FD266 MOVE C-ADD2 TO FD267 MOVE C-POST TO FD268
     ELSE MOVE FO-NAME TO FD264 MOVE LF-FDOCK TO FD264A MOVE LF-PHONE TO FD265
      PERFORM PR-LINE-2 MOVE FO-ADD1 TO FD266 MOVE FO-ADD2 TO FD267 MOVE FO-POST TO FD268.
    PERFORM PR-LINE MOVE 5 TO WS-PR.
    IF FO-PACKS(1)>0 MOVE FO-PACKS(1) TO FD269
      IF FO-PACKS(1)=1 MOVE "CARTON OF BOLTS" TO FD270 ELSE MOVE "CARTONS OF BOLTS" TO FD270 END-IF
      IF FO-PALLETS>0 MOVE "ON" TO FD271 MOVE FO-PALLETS TO FD271A
        IF FO-PALLETS=1 MOVE "PALLET" TO FD272 ELSE MOVE "PALLETS" TO FD272.
    COMPUTE FD273 ROUNDED=FO-GROSS / WEI-LB.
    IF FO-PAYER="E" MOVE "PREPAID" TO FD273A ELSE MOVE "COLLECT" TO FD273A.
    PERFORM PR-LINE.
    IF FO-PACKS(2)>0 MOVE FO-PACKS(2) TO FD269
      IF FO-PACKS(2)=1 MOVE "TRIWALL OF BOLTS" TO FD270 ELSE MOVE "TRIWALLS OF BOLTS" TO FD270 END-IF
      PERFORM PR-LINE.
    PERFORM CALC-PACKS.
    IF A-N1>0 MOVE A-N1 TO FD269
      IF A-N1=1 MOVE "BUCKET OF BOLTS" TO FD270 ELSE MOVE "BUCKETS OF BOLTS" TO FD270 END-IF
      PERFORM PR-LINE.
    IF A-N2>0 MOVE A-N2 TO FD269
      IF A-N2=1 MOVE "BIN OF BOLTS" TO FD270 ELSE MOVE "BINS OF BOLTS" TO FD270 END-IF
      PERFORM PR-LINE.
    IF C-TYPE="U" OR "Y" MOVE 3 TO WS-PR
      MOVE "NUTS OR BOLTS" TO FD274 PERFORM PR-LINE
      MOVE "ITEM #104520 SUB 2, NOI I/S RATE OR CLASS 50" TO FD274 PERFORM PR-LINE.
    IF AUTO-GMC AND C-TYPE="Y" MOVE 3 TO WS-PR
      MOVE "PRO FORMA INVOICE DATA:" TO FD274 PERFORM PR-LINE-2
      MOVE MSG-M2 TO FD274 PERFORM PR-LINE
      MOVE "COUNTRY OF ORIGIN: CANADA" TO FD274 PERFORM PR-LINE
      MOVE "ESTIMATED VALUE:" TO FD306 MOVE FO-TOTAL TO FD307 PERFORM PR-LINE.

    MOVE FO-CUS TO BT-CUS MOVE FO-SHIPTO TO BT-TO.
    READ BILLTO REGARDLESS INVALID GO LF42. GO LF44.
LF42. IF FO-SHIPTO=0 GO LF50.
    MOVE 0 TO BT-TO READ BILLTO REGARDLESS INVALID GO LF50.
LF44. MOVE 2 TO WS-PR MOVE "SEND FREIGHT BILL TO:" TO FD308 PERFORM PR-LINE-2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE BT-LINE(IX1) TO FD308 PERFORM PR-LINE END-PERFORM.

LF50. PERFORM PR-LINE.
    IF C-EDICF=1 MOVE MSG-M1 TO FD308 PERFORM PR-LINE.
    IF NOT(AUTO-GMC AND C-TYPE="Y") MOVE C-NO TO A-A1 PERFORM CHK-CUSFORM
      IF CFO-IND=1 PERFORM SET-BROKER MOVE A-A1 TO FD308 PERFORM PR-LINE.
    IF NOT(FO-CUS="06105" OR "06106") GO LF54.
    COMPUTE WS-PR=39 - WS-LINES IF WS-PR<1 GO LF54.
    MOVE MSG-M5A TO FD308 PERFORM PR-LINE MOVE MSG-M5B TO FD308 PERFORM PR-LINE.
    MOVE MSG-M5C TO FD308 PERFORM PR-LINE MOVE MSG-M5D TO FD308 PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
    MOVE MSG-M6A TO FD308 PERFORM PR-LINE MOVE MSG-M6B TO FD308 PERFORM PR-LINE.
    MOVE MSG-M6C TO FD308 PERFORM PR-LINE MOVE MSG-M6D TO FD308 PERFORM PR-LINE.
LF54. COMPUTE WS-PR=58 - WS-LINES MOVE FO-BL TO FD275 PERFORM PR-LINE.
    WRITE PREC AFTER PAGE.
    MOVE 1 TO FO-PIND(2) REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD GO LF3.
LF59. PERFORM CLOSE-PR GO LF9.

LF6. PERFORM OPEN-DOC STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM DOC-LINE.
    MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO LF79.
LF7. READ CFORD NEXT REGARDLESS END GO LF79. IF FO-PIND(2)=1 GO LF7.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    IF FO-SHIPTO=0 GO LF74. MOVE FO-CUS TO SA-CUS MOVE FO-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO LF74. PERFORM GET-FO-CUSADD.
LF74. MOVE 1 TO DOC-LINES PERFORM DOC-LINE 2 TIMES.
    MOVE "B I L L   O F   L A D I N G" TO FD300.
    MOVE "SHIPPER: IRVINE TOOLS" TO FD301 PERFORM DOC-LINE.
    MOVE "DATE:" TO FD302 MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD303.
    PERFORM DOC-LINE MOVE "B/L NO." TO FD304 MOVE FO-BL TO FD305 PERFORM DOC-LINE.
    MOVE C-NAME TO FD264 PERFORM DOC-LINE.
    IF FO-SHIPTO=0 AND FO-ADD1=" " AND FO-ADD2=" " PERFORM DOC-LINE
      MOVE C-ADD1 TO FD266 MOVE C-ADD2 TO FD267 MOVE C-POST TO FD268
     ELSE MOVE FO-NAME TO FD264 PERFORM DOC-LINE
      MOVE FO-ADD1 TO FD266 MOVE FO-ADD2 TO FD267 MOVE FO-POST TO FD268.
    PERFORM DOC-LINE 2 TIMES.
    MOVE " QTY  DESCRIPTION" TO PREC PERFORM DOC-LINE.
    MOVE ALL "-" TO PREC(1:70) PERFORM DOC-LINE 2 TIMES.
    MOVE FO-PACKS(1) TO FD293 MOVE " " TO WA1.
    IF FO-PACKS(1)=1 MOVE "CARTON" TO WA2 ELSE MOVE "CARTONS" TO WA2.
    STRING WA2 DELIMITED " " " OF TOOLS CONTAINING:" DELIMITED SIZE INTO WA1.
    MOVE WA1 TO FD294 PERFORM DOC-LINE MOVE FO-BL TO FL-BL MOVE 0 TO FL-SEQ.
LF77. ADD 1 TO FL-SEQ READ CFLIN REGARDLESS INVALID GO LF78.
    IF DOC-LINES>55 MOVE "*** ADDITIONAL TOOLS NOT LISTED ***" TO FD299
      PERFORM DOC-LINE GO LF78.
    MOVE FL-PROD TO A-A1 PERFORM PROD-RGD.
    MOVE FL-QTY TO FD295 MOVE FL-PROD TO FD296 MOVE "ORD:" TO FD297 MOVE FL-CUSORD TO FD298.
    PERFORM DOC-LINE MOVE 1 TO IX1.
    PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" " MOVE PRO-DESC(IX1) TO FD299
      PERFORM DOC-LINE ADD 1 TO IX1 END-PERFORM.
    GO LF77.
LF78. STRING EPS-FF DELIMITED SIZE INTO PREC PERFORM DOC-LINE.
    MOVE 1 TO FO-PIND(2) REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD GO LF7.
LF79. STRING EPS-FF EPS-INIT DELIMITED SIZE INTO PREC PERFORM DOC-LINE.
    PERFORM CLOSE-DOC GO LF9.

LF9. CLOSE CFORD CFLIN BILLTO GO MN9.

* S-8 DESTINATION PLANT FILE MAINTENANCE
PG1.
PG3. PERFORM RD58 PERFORM WRT PERFORM INIT-PL MOVE "BFT" TO PL-RECEIVER.
PG31. ACCEPT PL-PLANT LINE 3 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR PL-PLANT=ALL "9" GO PG9. IF PL-PLANT=" " GO PG31.
PG33. ACCEPT PL-PROD LINE 3 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR PL-PROD=ALL "9" GO PG9. IF PL-PROD=" " GO PG33.
    MOVE PL-PROD TO P-NO READ PRODUCT REGARDLESS INVALID MOVE "INVALID PRODUCT NO."
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO PG33 END-IF.
    READ PLANT REGARDLESS INVALID WRITE PL-RECORD ALLOWING NO UNLOCK PLANT.
    DISPLAY PL-NAME LINE 4 COLUMN 8 PL-REP COLUMN 77.
    DISPLAY PL-ORD LINE 6 COLUMN 21 CONVERSION PL-RECEIVER COLUMN 51
      PL-DOCK COLUMN 76.
    DISPLAY PL-EDIFACT LINE 8 COLUMN 21 CONVERSION.
    MOVE "'DEL' TO DELETE THIS RECORD: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="DEL" DELETE PLANT GO PG3.
PG35. ACCEPT PL-NAME LINE 4 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT PL-REP LINE 4 COLUMN 77 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    ACCEPT PL-ORD LINE 6 COLUMN 21 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY PL-ORD LINE 6 COLUMN 21 CONVERSION.
    IF PL-ORD=0 PERFORM DSP-ERR8 GO PG35.
    ACCEPT PL-RECEIVER LINE 6 COLUMN 51 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT PL-DOCK LINE 6 COLUMN 76 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF PL-RECEIVER=" " MOVE "BFT" TO PL-RECEIVER.
PG37. DISPLAY "ENTER 0 FOR EDI, OR 1 FOR EDIFACT" LINE 24 BOLD.
    ACCEPT PL-EDIFACT LINE 8 COLUMN 21 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION PERFORM DSP-ERS.
    DISPLAY PL-EDIFACT LINE 8 COLUMN 21 CONVERSION.
    IF PL-EDIFACT>1 PERFORM DSP-ERR2 GO PG37.
    REWRITE PL-RECORD ALLOWING NO UNLOCK PLANT GO PG3.
PG9. GO MN9.

* S-9 DESTINATION PLANT LISTING
PV1. PERFORM RD343 PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-RCV-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO PL-KEY START PLANT KEY>PL-KEY REGARDLESS INVALID GO PV29.
PV23. READ PLANT NEXT REGARDLESS END GO PV29.
    IF NOT(PL-RECEIVER>=RCV1 AND<=RCV2) GO PV23. PERFORM INIT-RP.
    MOVE PL-RECEIVER TO RP-F285 MOVE PL-KEY TO RP-F286 WRITE RP-RECORD GO PV23.
PV29. PERFORM OPEN-PR PERFORM PV-PAGE MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PV9.
PV3. READ REPFL NEXT END GO PV9. MOVE RP-F286 TO PL-KEY READ PLANT REGARDLESS.
    IF RP-F285 NOT=OLD-A IF OLD-A>" " PERFORM PV-LINE END-IF MOVE RP-F285 TO OLD-A.
    MOVE PL-RECEIVER TO FD74 MOVE PL-ISSUER TO FD75 MOVE PL-DOCK TO FD76.
    MOVE PL-PLANT TO FD77 MOVE PL-NAME TO FD78 MOVE PL-PROD TO FD79.
    MOVE PL-ORD TO FD80 MOVE PL-EDIFACT TO FD80A MOVE PL-REP TO FD80B.
    PERFORM PV-LINE GO PV3.
PV9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

PV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PV-PAGE.
PV-PAGE. MOVE "DESTINATION PLANT LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-RCV.
    MOVE "RECEIVER ID   ISSUER ID   DOCK  PLANT      NAME                            PRODUCT        SALES ORDER  EDIFACT  REP" TO PREC PERFORM PR-LINE-3.
*             ...       .........   ...   .......... ..............................  ............      ......       .     ..

* S-10 GENERATE BLANKET ORDER EXTENSIONS
KG1. PERFORM RD267 PERFORM WRT MOVE 0 TO LG-KMAT LG-KGM LG-KAM LG-KOT.
    ACCEPT XA3 LINE 3 COLUMN 42 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO LG-KMAT GO KG2.
    ACCEPT XA3 LINE 6 COLUMN 34 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO LG-KAM.
    ACCEPT XA3 LINE 7 COLUMN 23 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO LG-KGM.
    ACCEPT XA3 LINE 8 COLUMN 26 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO LG-KOT.
KG2. ACCEPT LG-PR1 LINE 10 COLUMN 31 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT LG-PR2 LINE 11 COLUMN 39 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 12 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
* note 143
    PERFORM DSP-WAIT MOVE LG-PR1 TO PR-NUM PERFORM OPEN-PR PERFORM CLOSE-PR.
    PERFORM LG-GEN-EXTEN.
KG9. GO MN9.

LG-GEN-EXTEN. PERFORM LG1 THRU LG9.
LG1. MOVE SYS-DATE TO LG-DATE-MIN D-DATE MOVE 10 TO D-DAYS PERFORM D-WDIFF.
    MOVE D-DATE TO LG-DATE-MAX MOVE 10 TO LG-PNUM.
    MOVE SYS-DATE TO D-DATE MOVE 1 TO D-DAYS PERFORM D-WDIFF.
    MOVE D-DATE TO LG-DATE-CHK.

* note 99
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LG22.
LG21. READ SHIPORD NEXT REGARDLESS END GO LG22.
    IF HO-TPLANT>" " MOVE " " TO HO-TPLANT REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LG21.
LG22. MOVE " " TO HL-KEY START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LG24.
LG23. READ SHIPLIN NEXT REGARDLESS END GO LG24.
    IF NOT(HL-USE=0 AND HL-QTY-DIFF=0)
      MOVE 0 TO HL-USE HL-QTY-DIFF REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    GO LG23.
LG24.

    MOVE LG-PR2 TO PR-NUM PERFORM OPEN-PR MOVE 1 TO LG-STEP PERFORM LG-PAGE.
    PERFORM OPEN-SORT.
    IF LG-KMAT=0 MOVE " " TO DY-KEY START DAYREL KEY>DY-KEY REGARDLESS INVALID GO LG8 END-START
      ELSE MOVE " " TO MT-KEY START MATREL KEY>MT-KEY REGARDLESS INVALID GO LG8 END-START.
LG3. IF LG-KMAT=0 READ DAYREL NEXT REGARDLESS END GO LG8 END-READ GO LG32.
    READ MATREL NEXT REGARDLESS END GO LG8. IF MT-TYPE NOT=0 GO LG3.
    INITIALIZE DY-REC MOVE 0 TO DY-SEQ MOVE "SH" TO DY-SCHEDULE.
    MOVE MT-PLANT TO DY-PLANT PL-PLANT MOVE MT-PROD TO DY-PROD PL-PROD.
    READ PLANT REGARDLESS INVALID GO LG3. MOVE PL-ORD TO DY-ORD.
    MOVE MT-DATE TO DY-DATE.
    MOVE MT-IXF TO DY-IXF PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>MT-IXF
      MOVE MT-FQTY(IX1) TO DY-FQTY(IX1) MOVE MT-FDATE(IX1) TO DY-FDATE(IX1)
      MOVE " " TO DY-FQUAL(IX1) MOVE 0 TO DY-FTIME(IX1)
      MOVE MT-FRD(IX1) TO DY-FRD(IX1) END-PERFORM.
LG32. IF NOT(DY-SCHEDULE="SH" OR "DL" OR "KB") GO LG3. MOVE DY-TYPE TO AUTO-CODE.
    IF AUTO-GMC IF LG-KGM=0 GO LG3.
    IF AUTO-AMAX MOVE SYS-DATE TO D-DATE PERFORM D-NEXT-DAY
      IF LG-KAM=0 OR NOT(DY-DATE>=SYS-DATE AND<=D-DATE) GO LG3.
    IF NOT(AUTO-GMC OR AUTO-AMAX) IF LG-KOT=0 GO LG3.

    MOVE DY-ORD TO HO-ORD MOVE 0 TO HO-SEQ.
    START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LG34.
LG33. READ SHIPORD NEXT REGARDLESS END GO LG34. IF HO-ORD NOT=DY-ORD GO LG34.
    MOVE DY-PLANT TO HO-TPLANT REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LG33.
LG34.

    MOVE 0 TO LG-TQTY MOVE DY-PROD TO HL-PROD MOVE 0 TO HL-DATE-REQ.
    START SHIPLIN KEY>HL-KP REGARDLESS INVALID GO LG36.
LG35. READ SHIPLIN NEXT REGARDLESS END GO LG36.
    IF HL-PROD NOT=DY-PROD OR HL-DATE-REQ>=LG-DATE-MIN GO LG36.
    IF HL-ORD NOT=DY-ORD GO LG35. ADD HL-QTY TO LG-TQTY.
    MOVE 1 TO HL-USE REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO LG35.
LG36.

    MOVE 1 TO LG-IXE PERFORM LG-P MOVE LG-IXM TO LG-ONUM.
    MOVE 0 TO LG-IX1 LG-IXP.
LG5. ADD 1 TO LG-IX1 IF LG-IX1>DY-IXF GO LG59.
    IF AUTO-AMAX MOVE DY-FQTY(LG-IX1) TO LG-AQTY MOVE 0 TO LG-NQTY GO LG56.
    IF DY-FDATE(LG-IX1)>=LG-DATE-MIN GO LG52. IF DY-FRD(LG-IX1)=1 GO LG5.
    MOVE DY-FDATE(LG-IX1) TO D-DATE PERFORM D-WKDAY.
    IF D-N1 NOT=7 GO LG512. COMPUTE LG-QTY=DY-FQTY(LG-IX1) - LG-TQTY.
    IF LG-QTY>=0 MOVE 0 TO LG-TQTY ELSE COMPUTE LG-TQTY=-LG-QTY MOVE 0 TO LG-QTY.
    IF LG-QTY=0 GO LG586.
    MOVE "C" TO A-A1 MOVE DY-FDATE(LG-IX1) TO A-N1.
    MOVE LG-QTY TO LG-AQTY LG-NQTY A-N2 PERFORM LG-E GO LG56.
LG512. MOVE "B" TO A-A1 MOVE DY-FDATE(LG-IX1) TO A-N1 MOVE DY-FQTY(LG-IX1) TO A-N2.
    PERFORM LG-E GO LG586.
LG52. IF DY-FDATE(LG-IX1)>LG-DATE-MAX GO LG59.
    ADD 1 TO LG-IXP IF LG-IXP>LG-PNUM GO LG59.

* note 139.1
    MOVE DY-PROD TO HL-PROD MOVE DY-FDATE(LG-IX1) TO HL-DATE-REQ.
    START SHIPLIN KEY=HL-KP REGARDLESS INVALID GO LG54.
LG53. READ SHIPLIN NEXT REGARDLESS END GO LG54.
    IF NOT(HL-PROD=DY-PROD AND HL-DATE-REQ=DY-FDATE(LG-IX1)) GO LG54.
    IF HL-ORD NOT=DY-ORD GO LG53.
    IF DY-DATE<SYS-DATE AND HL-QTY-NEW>0
      MOVE 1 TO HL-USE REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO LG53.
    IF LG-IX1>1 AND DY-FDATE(LG-IX1)=DY-FDATE(LG-IX1 - 1)
      MOVE DY-FQTY(LG-IX1) TO LG-AQTY MOVE 0 TO LG-NQTY GO LG56.
    MOVE DY-LABINF TO HL-LABINF MOVE DY-CUSORD TO HL-CUSORD.
    MOVE 1 TO HL-USE REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    MOVE HL-ORDSEQ TO HO-ORDSEQ READ SHIPORD REGARDLESS INVALID GO LG588.
    IF HO-IND=9 GO LG53.
    IF DY-DATE<SYS-DATE COMPUTE LG-QTY=DY-FQTY(LG-IX1) - (HL-QTY - HL-QTY-NEW)
      ELSE COMPUTE LG-QTY=DY-FQTY(LG-IX1) - HL-QTY - LG-TQTY MOVE 0 TO LG-TQTY.
    IF LG-QTY=0 GO LG58.
    IF HO-IND>=3
      MOVE "S" TO A-A1 MOVE HL-DATE-REQ TO A-N1 MOVE LG-QTY TO A-N2 PERFORM LG-E
      IF LG-QTY>0 MOVE LG-QTY TO LG-AQTY LG-NQTY GO LG56
        ELSE COMPUTE HL-QTY-DIFF=-LG-QTY
          REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO LG58.
    MOVE DY-FQTY(LG-IX1) TO HL-QTY.
* note 50
    MOVE HL-QTY TO HL-QTY-ALPREV MOVE HL-PROD TO A-A1 PERFORM PROD-GEN.
    COMPUTE HL-WEIGHT-ALPREV ROUNDED=HL-QTY-ALPREV * (P-WEIGHT + P-WEIGHT-NUT) / 100.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    GO LG58.
LG54. COMPUTE LG-QTY=DY-FQTY(LG-IX1) - LG-TQTY.
    IF LG-QTY>=0 MOVE 0 TO LG-TQTY ELSE COMPUTE LG-TQTY=-LG-QTY MOVE 0 TO LG-QTY.
    IF LG-QTY=0 GO LG586.
    MOVE "A" TO A-A1 MOVE DY-FDATE(LG-IX1) TO A-N1 MOVE LG-QTY TO A-N2 PERFORM LG-E.
    MOVE LG-QTY TO LG-AQTY MOVE 0 TO LG-NQTY GO LG56.

LG56. PERFORM LG-ADD IF A-S1=1 GO LG586.
* note 13
LG58. MOVE DY-FQUAL(LG-IX1) TO HO-SHQUAL MOVE DY-FTIME(LG-IX1) TO HO-SHTIME.
    MOVE DY-DOCK TO HO-DOCK MOVE DY-DXNO TO HO-DXNO.
    IF DY-CUSORD>" " MOVE DY-CUSORD TO HO-CUSORD.
    REWRITE HO-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK SHIPORD.
LG586. MOVE 1 TO DY-FRD(LG-IX1).
LG588. GO LG5.
LG59. IF LG-KMAT=0 REWRITE DY-RECORD ALLOWING NO UNLOCK DAYREL
       ELSE PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>DY-IXF
             MOVE DY-FRD(IX1) TO MT-FRD(IX1) END-PERFORM
         REWRITE MT-RECORD ALLOWING NO UNLOCK MATREL.

* note 82
    MOVE LG-DATE-CHK TO LG-DATE-MOD.
    IF AUTO-AMAX GO LG70.
    MOVE DY-PROD TO HL-PROD MOVE 0 TO HL-DATE-REQ MOVE HL-KP TO OLD-A.
LG61. MOVE OLD-A TO HL-KP START SHIPLIN KEY>HL-KP REGARDLESS INVALID GO LG66.
LG63. READ SHIPLIN NEXT REGARDLESS END GO LG66. IF HL-PROD NOT=DY-PROD GO LG66.
    IF HL-ORD NOT=DY-ORD OR HL-DATE-REQ<LG-DATE-MIN GO LG63. MOVE HL-KP TO OLD-A.
    MOVE HL-ORDSEQ TO HO-ORDSEQ READ SHIPORD REGARDLESS INVALID GO LG63.
    IF HL-QTY-DIFF>0 MOVE HL-QTY-DIFF TO LG-QTY GO LG64.
    IF HL-USE=0 AND HL-QTY NOT=0 AND HO-IND>=3 MOVE HL-QTY TO LG-QTY GO LG64.
    GO LG63.
LG64.
LG643. READ SHIPLIN NEXT REGARDLESS END GO LG646. IF HL-PROD NOT=DY-PROD GO LG646.
    IF HL-ORD NOT=DY-ORD GO LG643.
    MOVE HL-ORDSEQ TO HO-ORDSEQ READ SHIPORD REGARDLESS INVALID GO LG643.
    IF HO-IND>=3 GO LG643.
    SUBTRACT LG-QTY FROM HL-QTY HL-QTY-NEW MOVE 0 TO LG-QTY.
    IF HL-QTY<0 COMPUTE LG-QTY=-HL-QTY ADD LG-QTY TO HL-QTY-NEW MOVE 0 TO HL-QTY.
    IF HL-DATE-REQ>LG-DATE-MOD MOVE HL-DATE-REQ TO LG-DATE-MOD.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    IF LG-QTY>0 GO LG643.
LG646. GO LG61.
LG66.

    MOVE DY-ORD TO HO-ORD MOVE 0 TO HO-SEQ.
    START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LG678.
LG673. READ SHIPORD NEXT REGARDLESS END GO LG678. IF HO-ORD NOT=DY-ORD GO LG678.
    IF HO-TPLANT=" " OR HO-IND=9 GO LG673. MOVE 0 TO WS1.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LG676.
LG675. READ SHIPLIN NEXT REGARDLESS END GO LG676. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LG676.
    IF HL-USE=1 AND HL-QTY NOT=0 MOVE 1 TO WS1
      ELSE MOVE HL-DATE-REQ TO A-N1 MOVE HL-QTY TO A-N2 PERFORM LG-CHK-PL
       IF A-S1=1 AND HL-DATE-REQ=SYS-DATE MOVE 1 TO WS1 MOVE "G" TO A-A1
         ELSE IF HO-IND>=3 MOVE 1 TO WS1 MOVE "F" TO A-A1
           ELSE DELETE SHIPLIN MOVE "D" TO A-A1 END-IF END-IF
       PERFORM LG-E.
    GO LG675.
LG676. IF WS1=0 DELETE SHIPORD. GO LG673.
LG678.

* note 167
LG70. MOVE 2 TO LG-IXE PERFORM LG-P MOVE LG-IXM TO LG-NNUM.
    IF LG-ONUM<LG-NNUM GO LG72. IF LG-ONUM>LG-NNUM MOVE LG-NNUM TO LG-ONUM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>LG-ONUM
      IF LG-EFLD(1,IX1) NOT=LG-EFLD(2,IX1) GO LG72 END-IF END-PERFORM.
    IF NOT(AUTO-GMC OR AUTO-AMAX) GO LG79.
LG72. MOVE 2 TO WS-PR.
    MOVE DY-PLANT TO FD88 MOVE DY-PROD TO FD89 MOVE DY-ORD TO FD90.
    MOVE 1 TO IX1 PR-IXP.
    PERFORM UNTIL IX1>DY-IXF OR DY-FDATE(IX1)>LG-DATE-MAX
      MOVE DY-FQTY(IX1) TO FD91(PR-IXP)
      MOVE DY-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FD92(PR-IXP)
      ADD 1 TO IX1 PR-IXP IF PR-IXP>5 PERFORM LG-LINE MOVE 1 TO PR-IXP END-IF END-PERFORM.
    IF IX1=1 OR PR-IXP>1 PERFORM LG-LINE.
    MOVE 2 TO WS-PR MOVE "OLD:" TO FD93 MOVE 1 TO IX1 PR-IXP.
    PERFORM UNTIL IX1>LG-ONUM MOVE LG-EFLD(1,IX1) TO FD94(PR-IXP)
      ADD 1 TO IX1 PR-IXP IF PR-IXP>3 PERFORM LG-LINE MOVE 1 TO PR-IXP END-IF END-PERFORM.
    IF IX1=1 OR PR-IXP>1 PERFORM LG-LINE.
    MOVE "NEW:" TO FD93 MOVE 1 TO IX1 PR-IXP.
    PERFORM UNTIL IX1>LG-NNUM MOVE LG-EFLD(2,IX1) TO FD94(PR-IXP)
      ADD 1 TO IX1 PR-IXP IF PR-IXP>3 PERFORM LG-LINE MOVE 1 TO PR-IXP END-IF END-PERFORM.
    IF IX1=1 OR PR-IXP>1 PERFORM LG-LINE.
LG79. GO LG3.
LG8. PERFORM CLOSE-PR.

    MOVE LG-PR1 TO PR-NUM PERFORM EXTEND-PR MOVE 2 TO LG-STEP PERFORM LG-PAGE.
    MOVE " " TO LG-SKEY MOVE 1 TO PR-IXP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO LG89.
LG83. READ SORTFL NEXT END GO LG89. IF SR-F45=LG-SKEY GO LG84.
    IF LG-SKEY>" "
      IF PR-IXP>1 PERFORM LG-LINE MOVE 1 TO PR-IXP END-IF PERFORM LG-LINE.
    MOVE SR-F45A TO FA69 LG-SPLANT MOVE SR-F45B TO FA70 LG-SPROD.
    MOVE SR-F49 TO FA71.
LG84. MOVE SR-F50 TO FA72(PR-IXP) MOVE SR-F48 TO FA73(PR-IXP).
    MOVE SR-F46 TO D-DATE PERFORM D-NM MOVE D-DT TO FA74(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>4 PERFORM LG-LINE MOVE 1 TO PR-IXP. GO LG83.
LG89. PERFORM PR-LASTLN.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR.
LG9. EXIT.

LG-ADD. PERFORM LG-A1 THRU LG-A9.
LG-A1. MOVE 0 TO A-S1.
    MOVE DY-ORD TO O-NO READ SAORD REGARDLESS INVALID MOVE 1 TO A-S1 GO LG-A9.
    IF LG-IX1>1 AND DY-FDATE(LG-IX1)=DY-FDATE(LG-IX1 - 1) GO LG-A2.
* note 139.2
    MOVE DY-ORD TO HO-ORD MOVE 0 TO HO-SEQ.
    START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LG-A14.
LG-A13. READ SHIPORD NEXT REGARDLESS END GO LG-A14. IF HO-ORD NOT=DY-ORD GO LG-A14.
    IF NOT(HO-DATE-REQ=DY-FDATE(LG-IX1) AND HO-IND<=2) GO LG-A13.
    IF HO-TPLANT=" " MOVE DY-PLANT TO HO-TPLANT REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LG-A4.
LG-A14.
LG-A2. PERFORM INIT-HO MOVE DY-PLANT TO HO-TPLANT MOVE DY-FDATE(LG-IX1) TO HO-DATE-REQ.
LG-A3. ADD 1 TO HO-SEQ WRITE HO-RECORD ALLOWING NO
        INVALID IF HO-SEQ=19 GO LG-A9 END-IF GO LG-A3. UNLOCK SHIPORD.
LG-A4. COMPUTE L-NO=100 * O-NO START SALIN KEY>L-KEY REGARDLESS INVALID GO LG-A6.
LG-A5. READ SALIN NEXT REGARDLESS END GO LG-A6. IF L-ORD NOT=O-NO GO LG-A6.
    IF L-PROD NOT=DY-PROD GO LG-A5. PERFORM INIT-HL MOVE 1 TO HL-USE.
    MOVE LG-AQTY TO HL-QTY MOVE LG-NQTY TO HL-QTY-NEW.
    MOVE DY-LABINF TO HL-LABINF MOVE DY-CUSORD TO HL-CUSORD.
    WRITE HL-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK SHIPLIN.
LG-A6.
LG-A9. EXIT.
LG-E. PERFORM LG-E1 THRU LG-E9.
LG-E1. IF NOT(AUTO-GMC AND A-N1<=LG-DATE-CHK) GO LG-E9.
    MOVE DY-PLANT TO SR-F45A MOVE DY-PROD TO SR-F45B MOVE A-N1 TO SR-F46.
    MOVE 0 TO SR-F47 MOVE A-A1 TO SR-F48 MOVE DY-ORD TO SR-F49 MOVE A-N2 TO SR-F50.
LG-E3. WRITE SR-RECORD INVALID IF SR-F47<9 ADD 1 TO SR-F47 GO LG-E3 END-IF.
LG-E9. EXIT.
LG-P. PERFORM LG-P1 THRU LG-P9.
LG-P1. MOVE 0 TO LG-IXM MOVE DY-PROD TO HL-PROD MOVE 0 TO HL-DATE-REQ.
    START SHIPLIN KEY>HL-KP REGARDLESS INVALID GO LG-P4.
LG-P3. READ SHIPLIN NEXT REGARDLESS END GO LG-P4. IF HL-PROD NOT=DY-PROD GO LG-P4.
    IF LG-IXE=2 AND HL-DATE-REQ>LG-DATE-MOD GO LG-P4. IF HL-ORD NOT=DY-ORD GO LG-P3.
    MOVE HL-ORDSEQ TO HO-ORDSEQ READ SHIPORD REGARDLESS INVALID GO LG-P3.
    IF HO-IND=9 GO LG-P3.
    MOVE HL-SEQ TO EXT-S PERFORM DSP-EXT MOVE EXT-D TO LG-DF1A.
    MOVE "(" TO LG-DF1B MOVE HO-IND TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO LG-DF1C.
    MOVE ")" TO LG-DF1D MOVE HL-QTY TO LG-DF1E.
    MOVE HL-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO LG-DF1F.
    IF LG-IXM<10 ADD 1 TO LG-IXM MOVE LG-DF1 TO LG-EFLD(LG-IXE,LG-IXM). GO LG-P3.
LG-P4.
LG-P9. EXIT.
LG-CHK-PL. IF DY-PLANT="932731029" OR "974287542" MOVE 1 TO A-S1 ELSE MOVE 0 TO A-S1.
LG-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM LG-PAGE.
LG-PAGE. IF LG-STEP=1 MOVE "BLANKET ORDER EXTENSIONS GENERATION" TO FF3.
    IF LG-STEP=2 MOVE "BLANKET ORDER EXCEPTIONS SUMMARY (GM)" TO FF3.
    IF LG-KMAT=1 MOVE "** NON-EDI **" TO FF4. PERFORM PR-PAGE.
    IF LG-STEP=1 MOVE
         "PLANT       PRODUCT        ORDER" TO PREC PERFORM PR-LINE-3.
*         ..........  ............  ......        ...,... ../../.. (x5)
*                                           ...:      -..(.)....,...  ../../..  (x3)
    IF LG-STEP=2 MOVE
         "PLANT       PRODUCT        ORDER     EXCEPTIONS" TO PREC PERFORM PR-LINE-3.
*         ..........  ............  ......     ....,...+ . ../../.. (x4)

* S-11 MISCELLANEOUS MODIFICATIONS
LH1. PERFORM RD257 PERFORM WRT.
    ACCEPT LH-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR LH-SEL=99 GO LH9. PERFORM DSP-CLS.
    GO LH10 LH20 LH30 LH40  DEPENDING LH-SEL. GO LH1.

LH10. DISPLAY " CLEAR AUTOMOTIVE QTY CUM. YTD " LINE 1 REVERSED.
    PERFORM AX-RCV PERFORM AX-ACC IF XA2 NOT="OK" GO LH9.
    PERFORM DSP-WAIT.
    MOVE RCV1 TO PL-RECEIVER START PLANT KEY>=PL-KR REGARDLESS INVALID GO LH19.
LH13. READ PLANT NEXT REGARDLESS END GO LH19. IF PL-RECEIVER>RCV2 GO LH19.
    COMPUTE L-NO=100 * PL-ORD.
LH15. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO LH16. IF L-ORD NOT=PL-ORD GO LH16.
    IF L-QTY=LIT-Q9 MOVE 0 TO L-QTY-LEFT REWRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    GO LH15.
LH16. GO LH13.
LH19. GO LH9.

LH20. DISPLAY " CLEAR NON-AUTOMOTIVE QTY CUM. YTD " LINE 1 REVERSED.
    PERFORM AX-ACC IF XA2 NOT="OK" GO LH9.
    PERFORM DSP-WAIT.
    MOVE 0 TO O-NO START SAORD KEY>=O-KEY REGARDLESS INVALID GO LH29.
LH23. READ SAORD NEXT REGARDLESS END GO LH29. IF O-BLANKET=0 GO LH23.
    MOVE O-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO LH23.
    IF C-TYPE="X" OR "Y" GO LH23. COMPUTE L-NO=100 * O-NO.
LH25. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO LH26. IF L-ORD NOT=O-NO GO LH26.
    IF L-QTY=LIT-Q9 MOVE 0 TO L-QTY-LEFT REWRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    GO LH25.
LH26. GO LH23.
LH29. GO LH9.

LH30. DISPLAY " CHANGE AUTOMOTIVE MODEL YEAR " LINE 1 REVERSED.
    PERFORM AX-RCV ADD 1 TO IXT DISPLAY "NEW MODEL YEAR: __" LINE IXT BOLD.
    ACCEPT LH-MODYR LINE IXT COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM AX-ACC IF XA2 NOT="OK" GO LH9.
    PERFORM DSP-WAIT.
    MOVE RCV1 TO PL-RECEIVER START PLANT KEY>=PL-KR REGARDLESS INVALID GO LH39.
LH33. READ PLANT NEXT REGARDLESS END GO LH39. IF PL-RECEIVER>RCV2 GO LH39.
    COMPUTE L-NO=100 * PL-ORD.
LH35. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO LH36. IF L-ORD NOT=PL-ORD GO LH36.
    IF L-QTY=LIT-Q9 MOVE LH-MODYR TO L-MODYR REWRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    GO LH35.
LH36. GO LH33.
LH39. GO LH9.

LH40.
LH43. PERFORM RD123 PERFORM WRT.
LH431. ACCEPT LH-PLANT LINE 3 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR LH-PLANT=ALL "9" GO LH49. IF LH-PLANT=" " GO LH431.
    MOVE LH-PLANT TO PL-PLANT MOVE " " TO PL-PROD.
    START PLANT KEY>PL-KEY REGARDLESS INVALID GO LH434.
    READ PLANT NEXT REGARDLESS END GO LH434. IF PL-PLANT=LH-PLANT GO LH436.
LH434. MOVE "NO PRODUCTS FOUND FOR THIS PLANT" TO ERR-MESG PERFORM DSP-ERR GO LH431.
LH436.
LH437. ACCEPT LH-IND LINE 3 COLUMN 45 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF LH-IND>1 PERFORM DSP-ERR2 GO LH437.
    MOVE 8 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO LH43.
    PERFORM DSP-QWAIT MOVE 0 TO LH-NUM.
    MOVE LH-PLANT TO PL-PLANT MOVE " " TO PL-PROD.
    START PLANT KEY>PL-KEY REGARDLESS INVALID GO LH46.
LH45. READ PLANT NEXT REGARDLESS END GO LH46. IF PL-PLANT NOT=LH-PLANT GO LH46.
    MOVE LH-IND TO PL-EDIFACT ADD 1 TO LH-NUM.
    REWRITE PL-RECORD ALLOWING NO UNLOCK PLANT GO LH45.
LH46. DISPLAY LH-NUM LINE 10 CONVERSION " PLANT-PRODUCT RECORDS WERE MODIFIED".
    PERFORM DSP-CONT GO LH43.
LH49. GO LH9.

LH9. GO MN9.

* S-12 CREATE SINGLE GM SHIPPING LABELS
CD1. PERFORM RD344 PERFORM WRT.
CD3. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT HO-ORD LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO CD9. IF HO-ORD=0 GO CD3.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO CD3.
    MOVE HO-ORD TO A-N1 PERFORM RD-SAORD DISPLAY O-NAME LINE 3 COLUMN 40.

* note 233
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO CD44.
CD43. READ SHIPLIN NEXT REGARDLESS END GO CD44. IF HL-ORDSEQ NOT=HO-ORDSEQ GO CD44.
    IF HL-ERR=0 GO CD43. MOVE HL-PROD TO A-A1 PERFORM PROD-GEN.
    COMPUTE WN1=HL-QTY - HL-QTY-AL.
    IF WN1>0 AND P-QTY-PACK>0
      DIVIDE WN1 BY P-QTY-PACK GIVING WN1 REMAINDER WN2 IF WN2>0 ADD 1 TO WN1 END-IF
      MOVE WN1 TO HL-ACARTONS REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    GO CD43.
CD44.

CD5. DISPLAY "LOT NO. ________" LINE 5 BOLD ERASE END SCREEN.
    MOVE 5 TO IXT MOVE 9 TO IXU PERFORM SCAN-LOT IF A-S1=1 GO CD8.
    IF SCN-LOT=0 PERFORM DSP-ERR15 GO CD5.
    MOVE SCN-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO CD5.

    MOVE 0 TO CD-KFIN.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO CD58.
CD53. READ SHIPLIN NEXT REGARDLESS END GO CD58. IF HL-ORDSEQ NOT=HO-ORDSEQ GO CD58.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO CD56.
CD55. READ BINALLOC NEXT REGARDLESS END GO CD56. IF BA-NO NOT=HL-NO GO CD56.
    IF BA-LOT NOT=LT-NO GO CD55.
    IF BA-LABELS=BA-CARTONS MOVE 1 TO CD-KFIN GO CD55.
    PERFORM CD-H PERFORM CD-B PERFORM CD-L.
    ADD 1 TO BA-LABELS REWRITE BA-RECORD ALLOWING NO UNLOCK BINALLOC.
    GO CD79.
CD56. GO CD53.
CD58. IF CD-KFIN=0 MOVE "LOT NUMBER NOT FOUND IN THIS ORDER" TO ERR-MESG
       PERFORM DSP-OK IF XA2 NOT="OK" GO CD79.

    MOVE 0 TO CD-KFIN.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO CD64.
CD63. READ SHIPLIN NEXT REGARDLESS END GO CD64. IF HL-ORDSEQ NOT=HO-ORDSEQ GO CD64.
    IF HL-PROD NOT=LT-PROD GO CD63. MOVE 1 TO CD-KFIN.
    IF HL-ERR=0 OR HL-ALABELS=HL-ACARTONS GO CD63.
    PERFORM CD-H PERFORM CD-P PERFORM CD-L.
    ADD 1 TO HL-ALABELS REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    GO CD79.
CD64. IF CD-KFIN=1 MOVE "TOO MANY CARTONS FOR THIS PRODUCT" TO ERR-MESG
        ELSE MOVE "PRODUCT NOT FOUND IN THIS ORDER" TO ERR-MESG.
    PERFORM DSP-ERR.
CD79. GO CD5.

CD8. MOVE 0 TO WN1.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO CD88.
CD83. READ SHIPLIN NEXT REGARDLESS END GO CD88. IF HL-ORDSEQ NOT=HO-ORDSEQ GO CD88.
    COMPUTE WN1=WN1 + HL-ACARTONS - HL-ALABELS.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO CD86.
CD85. READ BINALLOC NEXT REGARDLESS END GO CD86. IF BA-NO NOT=HL-NO GO CD86.
    COMPUTE WN1=WN1 + BA-CARTONS - BA-LABELS GO CD85.
CD86. GO CD83.
CD88. IF WN1>0 MOVE " " TO ERR-MESG MOVE WN1 TO DSP-N31
       STRING "ORDER NOT FULFILLED:" DSP-N31 " CARTONS MISSING"
       DELIMITED SIZE INTO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO CD5.
    GO CD3.
CD9. GO MN9.

CD-H. MOVE HL-LABINF TO ED-LABINF MOVE HL-PROD TO BAR-PROD A-A1 PERFORM PROD-RT.
    PERFORM DESC-ENG PERFORM RD-GEN MOVE 2 TO A-N1 PERFORM DESC-QUAL.
    MOVE " " TO BAR-DESC MOVE 1 TO BAR-QSER MOVE HL-DATE-REQ TO BAR-DATE.
    PERFORM BAR-SHP-NAME.
CD-B. MOVE BA-LOT TO BAR-LOT MOVE BA-QTY-PACK TO BAR-QTY.
    COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * P-WEIGHT * WEI-LB / 100.
    MOVE 1 TO BAR-LABQTY.
CD-P. MOVE LT-NO TO BAR-LOT MOVE P-QTY-PACK TO BAR-QTY.
    COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * P-WEIGHT * WEI-LB / 100.
    MOVE 1 TO BAR-LABQTY.
CD-L. PERFORM OPEN-PLAB PERFORM BAR-LAB-GMSHIP PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.

* S-13 SHOW SHIP-TO ADDRESSES
HX1. PERFORM WRT132 PERFORM RD286 MOVE " " TO C-NO MOVE 3 TO IXT.
HX3. MOVE "??" TO TLNW(IXT + 1) PERFORM WRT.
HX33. DISPLAY "NEXT CUSTOMER/SHIP-TO ______/__" LINE IXT.
    ACCEPT IA1 LINE IXT COLUMN 23 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 OR IA1=ALL "9" GO HX9.
    IF IA1=" " IF C-NO=" " GO HX33 ELSE GO HX4. MOVE IA1 TO C-NO.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5
      MOVE " " TO C-NO GO HX33.
    READ CUSTOMER NEXT REGARDLESS.
    ACCEPT IA2 LINE IXT COLUMN 30 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA2=99 GO HX9.
    MOVE C-NO TO SA-CUS MOVE IA2 TO SA-TO MOVE 0 TO INQ-IND.
HX4. PERFORM RD286 MOVE C-NO TO TH165(1) MOVE C-NAME TO TH166(1).
    MOVE 4 TO IXT IF INQ-IND=0 START SHIPTO KEY>=SA-KEY REGARDLESS INVALID GO HX8.
HX5. READ SHIPTO NEXT REGARDLESS END GO HX8. IF SA-CUS NOT=C-NO GO HX8.
    PERFORM CLR-LN MOVE SA-TO TO TH167(IXT) MOVE SA-NAME TO TH168(IXT).
    MOVE SA-ADD1 TO TH169(IXT) MOVE SA-ADD2 TO TH170(IXT) MOVE SA-POST TO TH171(IXT).
    ADD 1 TO IXT IF IXT<22 GO HX5.
    MOVE "*** MORE ***" TO TLNW(IXT) MOVE 1 TO INQ-IND GO HX89.
HX8. MOVE "*** END ***" TO TLNW(IXT).
    READ CUSTOMER NEXT REGARDLESS END MOVE " " TO C-NO GO HX89. MOVE 0 TO INQ-IND.
HX89. GO HX3.
HX9. PERFORM WRT80 GO MN9.

* S-14 FILE LISTINGS
JD1. PERFORM RD233 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MN9.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM JD-PAGE.
    GO JD2 JD4  DEPENDING SEL-N.

JD2. MOVE " " TO SA-KEY START SHIPTO KEY>SA-KEY REGARDLESS INVALID GO JD29.
JD23. READ SHIPTO NEXT REGARDLESS END GO JD29.
    MOVE SA-CUS TO FF346 MOVE SA-TO TO FF347 MOVE SA-NAME TO FF348.
    MOVE SA-ADD1 TO FF349 MOVE SA-ADD2 TO FF350 MOVE SA-POST TO FF350A.
    PERFORM JD-LINE GO JD23.
JD29. GO JD9.

JD4. OPEN I-O BILLTO ALLOWING ALL.
    MOVE " " TO BT-KEY START BILLTO KEY>BT-KEY REGARDLESS INVALID GO JD49.
JD43. READ BILLTO NEXT REGARDLESS END GO JD49.
    MOVE BT-CUS TO FA147 MOVE BT-TO TO FA148.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE BT-LINE(IX1) TO FA149 PERFORM PR-LINE END-PERFORM.
    PERFORM JD-LINE 2 TIMES GO JD43.
JD49. CLOSE BILLTO GO JD9.

JD9. PERFORM CLOSE-PR GO MN9.

JD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JD-PAGE.
JD-PAGE. IF Y1 MOVE "SHIP-TO FILE LISTING" TO FF3.
    IF Y2 MOVE "FREIGHT BILL-TO FILE LISTING" TO FF3. PERFORM PR-PAGE.
    IF Y1 MOVE
         "CUST  SHIP-TO  ------------- NAME -------------  -------- ADDRESS LINE 1 --------  -------- ADDRESS LINE 2 --------  POST/ZIP" TO PREC PERFORM PR-LINE-3.
*         ......  ..     ................................  ................................  ................................  ..........
    IF Y2 MOVE
         "CUST  SHIP-TO  SEND FREIGHT BILL TO:" TO PREC PERFORM PR-LINE-3.
*         ......  ..     ........................................

* S-15 EDI BATCH
GB1. PERFORM RD107 PERFORM WRT MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE " " TO EDI-ID STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID.
    ACCEPT EDI-ID LINE 11 COLUMN 21 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF EDI-ID>" " PERFORM OPEN-EDI IF EDI-ID=" " GO MN9 END-IF CLOSE EDI.
    MOVE EDI-ID TO GB-GMFL.
    MOVE " " TO EDI-ID STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID.
    ACCEPT EDI-ID LINE 12 COLUMN 21 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF EDI-ID>" " PERFORM OPEN-EDI IF EDI-ID=" " GO MN9 END-IF CLOSE EDI.
    MOVE EDI-ID TO GB-ADFL.
    ACCEPT GB-PR1 LINE 11 COLUMN 69 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT GB-PR2 LINE 12 COLUMN 76 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT GB-PR3 LINE 13 COLUMN 77 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE SYS-DATE TO D-DATE.
    MOVE 19 TO IXT MOVE 20 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO GB-GDATE.
    MOVE SYS-DATE TO D-DATE MOVE 2 TO D-DAYS PERFORM D-WDIFF.
    MOVE 20 TO IXT MOVE 20 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO GB-NDATE.
    MOVE 21 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE GB-PR1 TO PR-NUM PERFORM OPEN-PR PERFORM CLOSE-PR.

    MOVE GB-GMFL TO EDI-ID IF EDI-ID=" " GO GB4. SET ED-GMC TO TRUE.
    MOVE GB-PR1 TO PR-NUM.
    PERFORM EXTEND-PR MOVE 3 TO IP-OP PERFORM IP-DELJIT PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 4 TO IQ-OP PERFORM IQ-DELFOR PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 2 TO AC-OP PERFORM AC-E862 PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 2 TO AB-OP PERFORM AB-E830 PERFORM CLOSE-PR.
    PERFORM EXTEND-PR PERFORM HF-INVRPT PERFORM CLOSE-PR.

GB4. MOVE GB-ADFL TO EDI-ID IF EDI-ID=" " GO GB6. MOVE 0 TO ED-TYPE.
    MOVE GB-PR1 TO PR-NUM.
    PERFORM EXTEND-PR MOVE 5 TO IP-OP PERFORM IP-DELJIT PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 5 TO IQ-OP PERFORM IQ-DELFOR PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 4 TO AC-OP PERFORM AC-E862 PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 3 TO AB-OP PERFORM AB-E830 PERFORM CLOSE-PR.
    PERFORM EXTEND-PR MOVE 3 TO AK-OP PERFORM AK-E850 PERFORM BK-E855 PERFORM CLOSE-PR.

GB6. MOVE GB-PR1 TO LG-PR1 MOVE GB-PR2 TO LG-PR2.
    MOVE 0 TO LG-KMAT LG-KAM MOVE 1 TO LG-KGM LG-KOT PERFORM LG-GEN-EXTEN.
    MOVE GB-PR1 TO PR-NUM PERFORM EXTEND-PR.
    MOVE GB-GDATE TO LB-GDATE MOVE GB-NDATE TO LB-NDATE PERFORM LB-BIN-ALLOC PERFORM CLOSE-PR.
    MOVE GB-PR3 TO PR-NUM PERFORM OPEN-PR.
    MOVE 0 TO ID-KEPS MOVE 1 TO ID-KGM PERFORM ID-PICK-TICKETS PERFORM CLOSE-PR.
GB9. GO MN9.

* S-16 MODIFY PLANT ISSUER IDENTIFIERS
NG1. PERFORM RD345 PERFORM WRT.
* note 186
    DISPLAY "CURRENT RECEIVER/ISSUER IDENTIFIERS:" LINE 6 BOLD.
    PERFORM DSP-QWAIT MOVE 8 TO IXT MOVE 1 TO IX1 MOVE " " TO OLD-A.
    MOVE " " TO PL-RECEIVER START PLANT KEY>PL-KR REGARDLESS INVALID GO NG39.
NG33. READ PLANT NEXT REGARDLESS END GO NG39. IF PL-ISSUER=" " GO NG33.
    IF PL-RECEIVER=OLD-A GO NG34. MOVE PL-RECEIVER TO OLD-A.
    COMPUTE IXU=1 + 20 * (IX1 - 1).
    DISPLAY PL-RECEIVER LINE IXT COLUMN IXU PL-ISSUER COLUMN IXU PLUS 4.
    ADD 1 TO IXT IF IXT>23 MOVE 8 TO IXT ADD 1 TO IX1 IF IX1>4 MOVE 1 TO IX1.
NG34. GO NG33.
NG39. PERFORM DSP-ERS.
NG5. DISPLAY "RECEIVER ID: ___    ISSUER ID: _________" LINE 3 BOLD ERASE LINE.
    DISPLAY " " LINE 4 ERASE LINE.
    ACCEPT NG-RECEIVER LINE 3 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR NG-RECEIVER="999" GO NG9. IF NG-RECEIVER=" " GO NG5.
    PERFORM DSP-QWAIT MOVE NG-RECEIVER TO PL-RECEIVER MOVE 0 TO NG-NUM.
    START PLANT KEY>=PL-KR REGARDLESS INVALID GO NG54.
NG53. READ PLANT NEXT REGARDLESS END GO NG54. IF PL-RECEIVER>NG-RECEIVER GO NG54.
    IF NG-NUM=0 MOVE PL-ISSUER TO NG-ISSUER. ADD 1 TO NG-NUM GO NG53.
NG54. PERFORM DSP-ERS.
    IF NG-NUM=0 MOVE "THERE ARE NO PLANT RECORDS WITH THIS RECEIVER ID"
      TO ERR-MESG PERFORM DSP-ERR GO NG5.
    DISPLAY NG-NUM LINE 3 COLUMN 44 CONVERSION BOLD " RECORDS WERE FOUND" BOLD.
    ACCEPT NG-ISSUER LINE 3 COLUMN 32 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    DISPLAY "RECORDS WILL BE MODIFIED" LINE 3 COLUMN 48 BOLD ERASE END LINE.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO NG5.
    MOVE NG-RECEIVER TO PL-RECEIVER PERFORM DSP-QWAIT.
    START PLANT KEY>=PL-KR REGARDLESS INVALID GO NG64.
NG63. READ PLANT NEXT REGARDLESS END GO NG64. IF PL-RECEIVER>NG-RECEIVER GO NG64.
    MOVE NG-ISSUER TO PL-ISSUER REWRITE PL-RECORD ALLOWING NO UNLOCK PLANT GO NG63.
NG64. PERFORM DSP-ERS GO NG5.
NG9. GO MN9.

* S-17 CREATE SHIPPING LABELS
FC1. PERFORM RD168 PERFORM WRT.
* note 231
    ACCEPT FC-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR FC-OP=99 GO FC9. IF NOT(FC-OP=1 OR 2) GO FC1.
    IF FC-OP=1 PERFORM FV-AMAX-LABELS GO FC9.

* op=2
    MOVE 4 TO LAB-FLN PERFORM OPEN-LAB.
FC3. PERFORM RD206 PERFORM WRT.
FC33. ACCEPT C-NO LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING ERASE END LINE KEY CKEY.
    IF KPF4 OR C-NO=ALL "9" GO FC8.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO FC33.
    DISPLAY C-NAME LINE 3 COLUMN 22.
    IF C-LABEL=0 PERFORM DSP-ERR52 GO FC33. MOVE " " TO FC-KANBANX.
    ACCEPT FC-PROD LINE 5 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    MOVE FC-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FC33.
    PERFORM PROD-DESC MOVE " " TO BAR-DESC.
    MOVE PRO-DESC(1)(1:16) TO BAR-DESC-A MOVE PRO-DESC(1)(17:) TO BAR-DESC-B.
    MOVE P-EDESC1 TO BAR-DESC-EXT MOVE P-FINDESC TO BAR-DESC-FIN.
    MOVE P-CUSPART TO BAR-CUSPART.
    PERFORM DESC-ENG PERFORM RD-GEN MOVE P-HCODE TO A-N1 PERFORM DESC-HARM.
    IF C-LABEL=1 MOVE 2 TO A-N1 PERFORM DESC-QUAL.
    IF C-LABEL=3 PERFORM BAR-TXT-INSPECT.
    MOVE P-QTY-PACK TO FC-QPACK DISPLAY FC-QPACK LINE 5 COLUMN 43 CONVERSION.
    ACCEPT FC-QPACK LINE 5 COLUMN 43 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FC-QPACK LINE 5 COLUMN 43 CONVERSION.
    ACCEPT FC-LOT LINE 5 COLUMN 64 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
* note 179.2
FC35. IF C-LABEL=5 DISPLAY "2 LABELS WILL BE PRINTED FOR EACH KANBAN NUMBER" LINE 24 BOLD.
    IF C-LABEL=11 DISPLAY "ENTER NUMBER OF CARTONS - 2 LABELS WILL BE PRINTED FOR EACH CARTON" LINE 24 BOLD.
    ACCEPT FC-LABQTY LINE 7 COLUMN 20 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF FC-LABQTY=0 PERFORM DSP-ERR2 GO FC35.
    MOVE 1 TO FC-QSER IF C-LABEL=5 OR 11 MULTIPLY 2 BY FC-LABQTY FC-QSER.
    MOVE SYS-DATE TO D-DATE MOVE 7 TO IXT MOVE 45 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO FC-DATE.
    REPLACE ==ACC-ALP== BY ==COLUMN 25 DEFAULT " " UNDERLINED PROTECTED EDITING==.
    IF C-LABEL=1 OR 5 OR 6
      ACCEPT ED-PKG11 LINE 11 ACC-ALP
      ACCEPT ED-PKG12 LINE 12 ACC-ALP
      ACCEPT ED-PKG13 LINE 13 ACC-ALP
      ACCEPT ED-PKG14 LINE 14 ACC-ALP
      ACCEPT ED-PKG15 LINE 15 ACC-ALP
      ACCEPT ED-PKG16 LINE 16 ACC-ALP
      ACCEPT ED-PKG17 LINE 17 ACC-ALP.
    REPLACE OFF.
    IF NOT(C-LABEL=1 OR 3 OR 7) GO FC44.
FC43. ACCEPT O-NO LINE 19 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ SAORD REGARDLESS INVALID PERFORM DSP-ERR8 GO FC43.
    IF O-CUS NOT=C-NO MOVE "THIS ORDER BELONGS TO ANOTHER CUSTOMER"
      TO ERR-MESG PERFORM DSP-ERR GO FC43.
    PERFORM BAR-SHP-NAME.
FC44. IF NOT(C-LABEL=5 OR 6) GO FC48. MOVE 1 TO IX1 MOVE 9 TO IXT.
FC45. IF C-LABEL=5 DISPLAY "ENTER JUST THE FIRST ONE IN THE SERIES OF KANBAN NUMBERS" LINE 24 BOLD.
    ACCEPT FC-KANBAN(IX1) LINE IXT COLUMN 70 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF C-LABEL=5 OR FC-KANBAN(IX1)=" " GO FC46.
    ADD 1 TO IX1 IXT IF IX1<=5 GO FC45.
FC46.
FC48. IF (C-LABEL=2 OR 3 OR 4 OR 7 OR 10 OR 11) OR (C-LABEL=6 AND FC-KANBAN(1)=" ")
       ACCEPT FC-CUSORD LINE 21 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING.

    MOVE 22 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO FC6.
    MOVE FC-PROD TO BAR-PROD MOVE FC-QPACK TO BAR-QTY MOVE FC-LOT TO BAR-LOT.
    MOVE FC-DATE TO BAR-DATE MOVE FC-CUSORD TO BAR-CUSORD.
    MOVE FC-LABQTY TO BAR-LABQTY MOVE FC-QSER TO BAR-QSER.
    MOVE FC-KANBAN(1) TO BAR-KANBAN.
    PERFORM BAR-LAB-SHIP.
    IF C-LABEL=6 PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5 OR FC-KANBAN(IX1)=" "
      MOVE FC-KANBAN(IX1) TO BAR-KANBAN PERFORM BAR-LAB-SHIP END-PERFORM.
FC6. GO FC3.
FC8. PERFORM BAR-LAB-SPACER PERFORM CLOSE-LAB.
FC9. GO MN9.

FV-AMAX-LABELS. PERFORM FV1 THRU FV9.
FV1. OPEN I-O DELJITEX ALLOWING ALL MOVE 5 TO LAB-FLN PERFORM OPEN-LAB.
FV3. PERFORM RD207 PERFORM WRT.
FV33. DISPLAY " " LINE 3 COLUMN 20 ERASE END LINE " " LINE 4 COLUMN 34 ERASE END LINE.
    ACCEPT HO-ORD LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO FV88. IF HO-ORD=0 GO FV33.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO FV33.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO FV82.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO FV82.
    DISPLAY C-NAME LINE 3 COLUMN 48.
    MOVE C-AUTO TO AUTO-CODE IF NOT AUTO-AMAX
      MOVE "THIS ORDER IS NOT FOR AMERICAN AXLE" TO ERR-MESG PERFORM DSP-ERR GO FV33.
    IF HO-DXNO=0 PERFORM DX-ADD SET ED-AMAX TO TRUE MOVE ED-TYPE TO DX-TYPE
      INITIALIZE ED-AMAX-DATA MOVE SYS-DATE TO ED-AFDATE
      MOVE ED-AMAX-DATA TO DX-DATA WRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX
      MOVE DX-NO TO HO-DXNO REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    MOVE HO-DXNO TO A-N1 PERFORM DX-RD-AMAX PERFORM DX-SET-CNUM.

    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO FV82.
    READ SHIPLIN NEXT REGARDLESS END GO FV82. IF HL-ORDSEQ NOT=HO-ORDSEQ GO FV82.
    MOVE HL-PROD TO A-A1 PERFORM PROD-RD PERFORM DESC-ENG PERFORM RD-GEN.
    DISPLAY HL-PROD LINE 4 COLUMN 34 PRO-DESC(1) COLUMN 48.
    DISPLAY ED-ADOCK LINE 5 COLUMN 14 ED-AGROUP COLUMN 40 PERFORM FV-DP.
    ACCEPT ED-ADOCK LINE 5 COLUMN 14 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT ED-AGROUP LINE 5 COLUMN 40 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.

FV5. PERFORM RD207A PERFORM WRT.
    ACCEPT FV-KAN LINE 14 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR FV-KAN=" " GO FV8.
    PERFORM VARYING DX-IXP FROM 1 BY 1 UNTIL DX-IXP>30 OR ED-AKAN(DX-IXP)=" "
      IF FV-KAN=ED-AKAN(DX-IXP) GO FV52 END-IF END-PERFORM.
    MOVE "PULL NOT FOUND - ADD IT TO THIS ORDER ? ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="YES" GO FV5.
    IF DX-IXP>30 MOVE "CANNOT CREATE MORE THAN 30 PULLS/ORDER"
      TO ERR-MESG PERFORM DSP-ERR GO FV5.
    INITIALIZE ED-APDATA(DX-IXP) MOVE FV-KAN TO ED-AKAN(DX-IXP).
    COMPUTE A-N1=DX-CNUM + 1 PERFORM BAR-SET-SERIAL MOVE BAR-SERIAL TO ED-ASERIAL(DX-IXP).
    PERFORM FV-DP.
FV52. PERFORM DX-SET-CTNS DISPLAY DX-CTNS LINE 14 COLUMN 36 CONVERSION.
    DISPLAY ED-AORD(DX-IXP) LINE 16 COLUMN 18.
    MOVE 1 TO DX-IXL MOVE 18 TO IXT PERFORM UNTIL DX-IXL>5
      DISPLAY ED-ALOT(DX-IXP,DX-IXL) LINE IXT COLUMN 7 CONVERSION
      DISPLAY ED-ACARTONS(DX-IXP,DX-IXL) LINE IXT COLUMN 23 CONVERSION
      ADD 1 TO DX-IXL IXT END-PERFORM.
    PERFORM FV-DS.
    MOVE "'MOD' TO MODIFY, 'DEL' TO DELETE, THIS PULL: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="DEL" GO FV66. IF XA3 NOT="MOD" GO FV64.
* note 219
    IF ED-ASERIAL(DX-IXP)=0 COMPUTE A-N1=DX-CNUM + 1 PERFORM BAR-SET-SERIAL
      MOVE BAR-SERIAL TO ED-ASERIAL(DX-IXP) PERFORM FV-DS.
    ACCEPT ED-AORD(DX-IXP) LINE 16 COLUMN 18 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
FV61. MOVE 1 TO DX-IXL MOVE 18 TO IXT.
FV63. ACCEPT ED-ALOT(DX-IXP,DX-IXL) LINE IXT COLUMN 7 DEFAULT CURRENT
       UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY ED-ALOT(DX-IXP,DX-IXL) LINE IXT COLUMN 7 CONVERSION.
    ACCEPT ED-ACARTONS(DX-IXP,DX-IXL) LINE IXT COLUMN 23 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY ED-ACARTONS(DX-IXP,DX-IXL) LINE IXT COLUMN 23 CONVERSION.
    PERFORM DX-SET-CTNS DISPLAY DX-CTNS LINE 14 COLUMN 36 CONVERSION.
    ADD 1 TO DX-IXL IXT IF DX-IXL<=5 GO FV63.
    IF DX-CTNS>DX-CNUM MOVE "TOO MANY CARTONS" TO ERR-MESG PERFORM DSP-ERR GO FV61.
FV64. ACCEPT XA3 LINE 20 COLUMN 68 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3 NOT="YES" GO FV648.
FV643. DISPLAY "TO PRINT ONE LABEL ENTER ITS SERIAL NO.; TO PRINT ENTIRE PULL LEAVE BLANK" LINE 24 BOLD.
    ACCEPT DX-SERIAL LINE 22 COLUMN 55 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF DX-SERIAL>0 IF NOT(DX-SERIAL>=ED-ASERIAL(DX-IXP) AND<=ED-ASERIAL(DX-IXP) + DX-CNUM)
      MOVE "NO SUCH SERIAL NO. IN THIS PULL" TO ERR-MESG PERFORM DSP-ERR GO FV643.
    PERFORM DX-LAB-AMAX.
FV648. GO FV5.
FV66. PERFORM VARYING IX1 FROM DX-IXP BY 1 UNTIL IX1=30 OR ED-AKAN(IX1)=" "
       MOVE ED-APDATA(IX1 + 1) TO ED-APDATA(IX1) END-PERFORM.
    INITIALIZE ED-APDATA(30).
    PERFORM VARYING IXT FROM 7 BY 1 UNTIL IXT>10 DISPLAY " " LINE IXT ERASE LINE END-PERFORM.
    PERFORM FV-DP GO FV5.

FV8. MOVE ED-AMAX-DATA TO DX-DATA REWRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX.
    GO FV3.
FV82. MOVE "LABELS INFORMATION NOT FOUND" TO ERR-MESG PERFORM DSP-ERR GO FV33.
FV88. CLOSE DELJITEX PERFORM CLOSE-LAB.
FV9. EXIT.

FV-DP. MOVE 7 TO IXT MOVE 1 TO IXCOL.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>30 OR ED-AKAN(A-X1)=" "
      COMPUTE IXU=4 + 9 * (IXCOL - 1) DISPLAY ED-AKAN(A-X1) LINE IXT COLUMN IXU
      ADD 1 TO IXCOL IF IXCOL>8 ADD 1 TO IXT MOVE 1 TO IXCOL END-IF END-PERFORM.
FV-DS. MOVE ED-ASERIAL(DX-IXP) TO DSP-F81 DISPLAY DSP-F81 LINE 16 COLUMN 62.
    COMPUTE A-N1=ED-ASERIAL(DX-IXP) + 1 COMPUTE A-N2=A-N1 + DX-CNUM - 1.
    MOVE A-N1 TO DSP-F81 MOVE A-N2 TO DSP-F82.
    DISPLAY DSP-F81 LINE 17 COLUMN 62 " - " DSP-F82.

* S-18 PRINT SHIPPING LABELS
FH1. PERFORM RD258 PERFORM WRT.
    ACCEPT FH-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR FH-OP=99 GO FH9.
    IF FH-OP=20 GO FH6. IF NOT(FH-OP>=1 AND<=11) GO FH1.
    MOVE 19 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    IF FH-OP=1 MOVE "LAB" TO LAB-NAME MOVE 7 TO LAB-FLN MOVE "LABEL2" TO LAB-QUEUE
      PERFORM PRINTKEEP-LAB GO FH9.
    IF FH-OP=2 MOVE "LAB" TO LAB-NAME MOVE 8 TO LAB-FLN MOVE "LABEL2" TO LAB-QUEUE
      PERFORM PRINTKEEP-LAB GO FH9.

* op=3-11
    PERFORM DSP-QWAIT MOVE 3 TO LAB-FLN PERFORM OPEN-LAB.
    MOVE 0 TO LA-NO START LABELS KEY>=LA-KEY REGARDLESS INVALID GO FH29.
FH23. READ LABELS NEXT REGARDLESS END GO FH29.
    IF NOT(LA-PR=0 AND LA-SRC=2) GO FH23.
    EVALUATE TRUE
      WHEN FH-OP=3 IF LA-TYPE NOT=3 GO FH23 END-IF
      WHEN FH-OP=4 IF LA-TYPE NOT=10 GO FH23 END-IF
      WHEN FH-OP=5 IF LA-TYPE NOT=11 GO FH23 END-IF
      WHEN FH-OP=6 IF LA-TYPE NOT=12 GO FH23 END-IF
      WHEN FH-OP=7 IF LA-TYPE NOT=13 GO FH23 END-IF
      WHEN FH-OP=8 IF LA-TYPE NOT=14 GO FH23 END-IF
      WHEN FH-OP=9 IF LA-TYPE NOT=17 GO FH23 END-IF
      WHEN FH-OP=10 IF LA-TYPE NOT=18 GO FH23 END-IF
      WHEN FH-OP=11 IF LA-TYPE NOT=19 GO FH23 END-IF
      WHEN OTHER GO FH23.
    PERFORM BAR-LAB IF BAR-ERR=0 MOVE 1 TO LA-PR REWRITE LA-RECORD ALLOWING NO UNLOCK LABELS.
    GO FH23.
FH29. PERFORM BAR-LAB-SPACER PERFORM CLOSE-LAB PERFORM DSP-ERS.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB GO FH9.

FH6. OPEN I-O DELJITEX ALLOWING ALL.
FH63. PERFORM RD266 PERFORM WRT.
    ACCEPT HO-ORD LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO FH69. IF HO-ORD=0 GO FH63.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO FH63.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO FH63.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO FH63.
    MOVE C-AUTO TO AUTO-CODE DISPLAY C-NAME LINE 3 COLUMN 48.
    IF C-LABEL=0 PERFORM DSP-ERR52 GO FH63.
    IF C-LABEL=3 MOVE "THIS FUNCTION CANNOT CREATE AMERICAN AXLE LABELS"
      TO ERR-MESG PERFORM DSP-ERR GO FH63.
    ACCEPT FH-PROD LINE 5 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 7 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO FH63.
    PERFORM DSP-QWAIT PERFORM OPEN-PLAB.
    MOVE HO-ORDSEQ TO BAR-ORDSEQ MOVE O-NAME TO BAR-NAME PERFORM BAR-LAB-ORDER.
    PERFORM BAR-SHP-NAME.

    IF C-LABEL=5 MOVE HO-DXNO TO A-N1 PERFORM DX-RD-SAT MOVE ED-SKAN-N(1) TO FH-KAN-N.
    IF C-LABEL=6 MOVE HO-DXNO TO A-N1 PERFORM DX-RD-DELP.

    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO FH68.
FH65. READ SHIPLIN NEXT REGARDLESS END GO FH68. IF HL-ORDSEQ NOT=HO-ORDSEQ GO FH68.
    IF FH-PROD>" " AND NOT=HL-PROD GO FH65. MOVE HL-LABINF TO ED-LABINF.
    MOVE HL-DATE-REQ TO BAR-DATE.
    MOVE HL-PROD TO BAR-PROD A-A1 PERFORM PROD-RD MOVE P-CUSPART TO BAR-CUSPART.
    PERFORM DESC-ENG PERFORM RD-GEN MOVE P-HCODE TO A-N1 PERFORM DESC-HARM.
    MOVE " " TO BAR-DESC.
    MOVE PRO-DESC(1)(1:16) TO BAR-DESC-A MOVE PRO-DESC(1)(17:) TO BAR-DESC-B.
    PERFORM GET-HLCUSORD MOVE A-A1 TO BAR-CUSORD.
    IF C-LABEL=1 MOVE 2 TO A-N1 PERFORM DESC-QUAL.
* note 179.3
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO FH658.
FH653. READ BINALLOC NEXT REGARDLESS END GO FH658. IF BA-NO NOT=HL-NO GO FH658.
    MOVE BA-LOT TO BAR-LOT MOVE BA-QTY-PACK TO BAR-QTY.
    IF C-LABEL=5 MOVE 2 TO BAR-LABQTY BAR-QSER
      PERFORM BA-CARTONS TIMES
        MOVE FH-KAN-N TO ED-N61 COMPUTE WN1=6 - ED-SKAN-ND + 1
        MOVE " " TO BAR-KANBAN STRING ED-SKAN-A ED-N61(WN1:) DELIMITED SIZE INTO BAR-KANBAN
        PERFORM BAR-LAB-SHIP ADD 1 TO FH-KAN-N END-PERFORM GO FH656.
    IF C-LABEL=6 MOVE 1 TO BAR-LABQTY BAR-QSER
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>BA-CARTONS OR ED-DKNUM
        MOVE ED-DKVAL(IX1) TO BAR-KANBAN
        PERFORM BAR-LAB-SHIP END-PERFORM GO FH656.
    MOVE BA-CARTONS TO BAR-LABQTY MOVE 1 TO BAR-QSER.
    IF C-LABEL=11 MULTIPLY 2 BY BAR-LABQTY BAR-QSER.
    PERFORM BAR-LAB-SHIP.
FH656. GO FH653.
FH658. IF HL-ERR=1 AND NOT(C-LABEL=5 OR 6) COMPUTE WN1=HL-QTY - HL-QTY-AL
        IF WN1>0 AND P-QTY-PACK>0 DIVIDE P-QTY-PACK INTO WN1 ROUNDED ADD 1 TO WN1
          MOVE 0 TO BAR-LOT MOVE P-QTY-PACK TO BAR-QTY
          MOVE WN1 TO BAR-LABQTY MOVE 1 TO BAR-QSER PERFORM BAR-LAB-SHIP.
    GO FH65.
FH68. PERFORM BAR-LAB-SPACER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB PERFORM DSP-ERS GO FH63.
FH69. CLOSE DELJITEX GO FH9.

FH9. GO MN9.

* S-19 PRINT SHIPPING MASTER LABELS
FQ1. PERFORM RD259 PERFORM WRT.
    ACCEPT XN2 LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR XN2=99 GO MN9. IF NOT(XN2>=1 AND<=8 OR=11) GO FQ1.
    PERFORM DSP-CLS IF XN2=11 PERFORM FQ-S GO FQ9.
    GO FQ10 FQ20 FQ30 FQ40 FQ50 FQ60 FQ70 FQ80  DEPENDING XN2.

FQ10. DISPLAY " PRINT GM MASTER LABELS " LINE 1 REVERSED.
FQ13. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT HO-ORD LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO FQ19. IF HO-ORD=0 GO FQ13.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO FQ13.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO FQ13.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO FQ13.
    MOVE C-AUTO TO AUTO-CODE DISPLAY O-NAME LINE 1 COLUMN 48.
    IF NOT(AUTO-GMC OR AUTO-WOOD) PERFORM FQ-E1 GO FQ13.

    MOVE 0 TO FQ-KFIR FQ-TCARTONS.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO FQ16.
FQ15. READ SHIPLIN NEXT REGARDLESS END GO FQ16. IF HL-ORDSEQ NOT=HO-ORDSEQ GO FQ16.
    IF FQ-KFIR=0 MOVE 1 TO FQ-KFIR MOVE HL-LABINF TO ED-LABINF
      MOVE HL-PROD TO FQ-PROD A-A1 PERFORM PROD-RDG
      MOVE P-QTY-PACK TO FQ-PKQTY MOVE P-WEIGHT TO FQ-WEIGHT.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO FQ154.
FQ153. READ BINALLOC NEXT REGARDLESS END GO FQ154. IF BA-NO NOT=HL-NO GO FQ154.
    ADD BA-CARTONS TO FQ-TCARTONS GO FQ153.
FQ154. GO FQ15.
FQ16. DISPLAY "CONFIRM LABEL DATA " LINE 5 REVERSED.
    DISPLAY "PRODUCT  TOTAL CARTONS   QTY/CARTON   TOTAL QTY   GROSS WEIGHT (KG)" LINE 7 BOLD.
*            ........      ..           .....        .....         .....
    PERFORM FQ-A.
    DISPLAY FQ-PROD(1:8) LINE 8 FQ-TCARTONS COLUMN 15 CONVERSION FQ-PKQTY COLUMN 28 CONVERSION
      FQ-TQTY COLUMN 41 CONVERSION FQ-TGROSS COLUMN 55 CONVERSION.
    MOVE FQ-TCARTONS TO WN1 MOVE FQ-PKQTY TO WN2.
    ACCEPT FQ-TCARTONS LINE 8 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-TCARTONS LINE 8 COLUMN 15 CONVERSION.
    ACCEPT FQ-PKQTY LINE 8 COLUMN 28 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-PKQTY LINE 8 COLUMN 28 CONVERSION.
    IF NOT(FQ-TCARTONS=WN1 AND FQ-PKQTY=WN2) PERFORM FQ-A
      DISPLAY FQ-TQTY LINE 8 COLUMN 41 CONVERSION FQ-TGROSS COLUMN 55 CONVERSION.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ18.

    PERFORM BAR-SHP-NAME MOVE FQ-PROD TO BAR-PROD MOVE FQ-TGROSS TO BAR-WEIGHT.
    MOVE FQ-PKQTY TO BAR-PKQTY MOVE FQ-TQTY TO BAR-QTY MOVE FQ-TCARTONS TO BAR-CARTONS.
    MOVE 1 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-GMASTER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ18. GO FQ13.
FQ19. GO FQ9.

FQ20. DISPLAY " PRINT GM MIXED LOAD LABELS " LINE 1 REVERSED.
FQ23. DISPLAY " " LINE 3 BOLD ERASE END SCREEN.
    DISPLAY "'RETURN' TO START A NEW LABEL, OR PF4 TO END _" LINE 24 BOLD.
    ACCEPT XA1 COLUMN 46 PROTECTED AUTOTERMINATE KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO FQ29.
    DISPLAY "    PRODUCT   CARTONS   QTY/CARTON   TOTAL QTY" LINE 9 BOLD.
*            ..  ........    ..         .....       .....

    MOVE " " TO ED-LABINF MOVE 0 TO FQ-TGROSS FQ-KDK.
    MOVE 1 TO FQ-IXL MOVE 10 TO IXT.
FQ25. MOVE FQ-IXL TO DSP-N11 DISPLAY DSP-N11 LINE IXT BOLD "." BOLD.
    MOVE IXT TO FQ-IXT.
FQ253. DISPLAY "ENTER NEXT ORDER NO., OR PF4 TO END THIS LABEL" LINE 24 BOLD.
    DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE LINE.
    ACCEPT HO-ORD LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 SUBTRACT 1 FROM FQ-IXL GO FQ26.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO FQ253.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO FQ253.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO FQ253.
    MOVE C-AUTO TO AUTO-CODE DISPLAY O-NAME LINE 3 COLUMN 40.
    IF NOT(AUTO-GMC OR AUTO-WOOD) PERFORM FQ-E1 GO FQ253.

    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO FQ254.
    READ SHIPLIN NEXT REGARDLESS END GO FQ254.
FQ254. IF HL-ORDSEQ NOT=HO-ORDSEQ OR HL-LINE=0 MOVE "NO LINES IN THIS ORDER"
         TO ERR-MESG PERFORM DSP-ERR GO FQ253.
    MOVE HL-LABINF TO ED-LABINF.
    IF FQ-IXL=1 MOVE ED-PKG12 TO FQ-DOCK WA1
      DISPLAY "PLANT/DOCK: ________" LINE 5 BOLD
      ACCEPT FQ-DOCK LINE 5 COLUMN 13 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      IF FQ-DOCK NOT=WA1 MOVE 1 TO FQ-KDK END-IF
     ELSE IF FQ-KDK=0
      IF ED-PKG12 NOT=FQ-DOCK MOVE "DIFFERENT PLANT/DOCK IN THIS ORDER"
        TO ERR-MESG PERFORM DSP-ERR GO FQ253 END-IF
       ELSE MOVE FQ-DOCK TO ED-PKG12.
    MOVE HL-PROD TO FQ-PN(FQ-IXL) P-NO.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FQ253.
    PERFORM RD-GEN MOVE P-QTY-PACK TO FQ-PQ(FQ-IXL).
    MOVE HL-QTY-AL TO FQ-TQ(FQ-IXL) COMPUTE FQ-NC(FQ-IXL)=FQ-TQ(FQ-IXL) / FQ-PQ(FQ-IXL).
    MOVE FQ-IXT TO IXT.
    DISPLAY FQ-PN(FQ-IXL) LINE IXT COLUMN 5 FQ-NC(FQ-IXL) COLUMN 17 CONVERSION
      FQ-PQ(FQ-IXL) COLUMN 28 CONVERSION FQ-TQ(FQ-IXL) COLUMN 40 CONVERSION.

    ACCEPT FQ-NC(FQ-IXL) LINE IXT COLUMN 17 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-NC(FQ-IXL) LINE IXT COLUMN 17 CONVERSION.
FQ255. ACCEPT FQ-PQ(FQ-IXL) LINE IXT COLUMN 28 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-PQ(FQ-IXL) LINE IXT COLUMN 28 CONVERSION.
    IF FQ-PQ(FQ-IXL) NOT=P-QTY-PACK MOVE "QTY DIFFERENT FROM DEFAULT CARTON QTY"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO FQ255.
    COMPUTE FQ-TQ(FQ-IXL)=FQ-NC(FQ-IXL) * FQ-PQ(FQ-IXL).
    DISPLAY FQ-TQ(FQ-IXL) COLUMN 40 CONVERSION.

    COMPUTE FQ-TGROSS ROUNDED=FQ-TGROSS
      + FQ-TQ(FQ-IXL) * P-WEIGHT / 100 + FQ-NC(FQ-IXL) * WEI-WT(1).
    IF FQ-IXL<8 ADD 1 TO FQ-IXL IXT GO FQ25.
FQ26. COMPUTE FQ-TGROSS ROUNDED=(FQ-TGROSS + WEI-PALLET) * WEI-LB.
    ADD 2 TO IXT DISPLAY "GROSS WEIGHT:" LINE IXT BOLD FQ-TGROSS CONVERSION " KG".
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ28.

* note 195
    PERFORM BAR-SHP-NAME MOVE FQ-TGROSS TO BAR-WEIGHT MOVE FQ-IXL TO BAR-MXL.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>FQ-IXL
      MOVE FQ-PN(IX1) TO BAR-MXPN(IX1) MOVE FQ-NC(IX1) TO BAR-MXNC(IX1)
      MOVE FQ-TQ(IX1) TO BAR-MXTQ(IX1) MOVE FQ-PQ(IX1) TO BAR-MXPQ(IX1) END-PERFORM.
    MOVE 1 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-GMIXED PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ28. GO FQ23.
FQ29. GO FQ9.

FQ30. DISPLAY " PRINT QSS MASTER LABELS " LINE 1 REVERSED.
FQ33. DISPLAY " " LINE 3 ERASE END SCREEN.
    DISPLAY "PRODUCT: ____________" LINE 3 BOLD.
    DISPLAY "LOT: _______" LINE 4 BOLD.
    DISPLAY "QTY/PALLET: _____" LINE 5 BOLD.
FQ333. ACCEPT FQ-PROD LINE 3 COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO FQ39.
    MOVE FQ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FQ333.
FQ335. ACCEPT FQ-LOT LINE 4 COLUMN 6 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE FQ-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO FQ335.
    ACCEPT FQ-TQTY LINE 5 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ38.

    MOVE FQ-PROD TO BAR-PROD MOVE " " TO BAR-DESC PERFORM PROD-DESC.
    MOVE PRO-DESC(1)(1:16) TO BAR-DESC-A MOVE PRO-DESC(1)(17:) TO BAR-DESC-B.
    MOVE FQ-TQTY TO BAR-QTY MOVE FQ-LOT TO BAR-LOT.
    MOVE "12310" TO BAR-CUS PERFORM BAR-SET-SUPPLIER.
    MOVE 1 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-QMASTER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ38. GO FQ33.
FQ39. GO FQ9.

FQ40. DISPLAY " PRINT MODATEK MASTER LABELS " LINE 1 REVERSED.
FQ43. DISPLAY " " LINE 3 ERASE END SCREEN.
    DISPLAY "PRODUCT: ____________" LINE 3 BOLD.
    DISPLAY "QTY/PALLET: _____" LINE 4 BOLD.
    DISPLAY "2 IDENTICAL LABELS WILL BE PRINTED" LINE 6.
FQ433. ACCEPT FQ-PROD LINE 3 COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO FQ49.
    MOVE FQ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FQ433.
    ACCEPT FQ-TQTY LINE 4 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ48.

    MOVE FQ-PROD TO BAR-PROD MOVE FQ-TQTY TO BAR-QTY.
    MOVE "11317" TO BAR-CUS PERFORM BAR-SET-SUPPLIER.
    MOVE 2 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-MMASTER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ48. GO FQ43.
FQ49. GO FQ9.

FQ50. DISPLAY " PRINT SATURN MASTER LABELS " LINE 1 REVERSED.
FQ53. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT HO-ORD LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO FQ59. IF HO-ORD=0 GO FQ53.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO FQ53.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO FQ53.

    MOVE 0 TO FQ-KFIR FQ-PCARTONS.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO FQ56.
FQ55. READ SHIPLIN NEXT REGARDLESS END GO FQ56. IF HL-ORDSEQ NOT=HO-ORDSEQ GO FQ56.
    IF FQ-KFIR=0 MOVE 1 TO FQ-KFIR MOVE HL-PROD TO FQ-PROD A-A1 PERFORM PROD-RDG
      MOVE P-QTY-PACK TO FQ-PKQTY.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO FQ554.
FQ553. READ BINALLOC NEXT REGARDLESS END GO FQ554. IF BA-NO NOT=HL-NO GO FQ554.
    ADD BA-CARTONS TO FQ-PCARTONS GO FQ553.
FQ554. GO FQ55.

FQ56. DISPLAY "CONFIRM LABEL DATA " LINE 5 REVERSED.
    DISPLAY "PRODUCT  TOTAL CARTONS   QTY/CARTON   TOTAL QTY" LINE 7 BOLD.
*            ........      ..           .....        ......
    PERFORM FQ-B.
    DISPLAY FQ-PROD(1:8) LINE 8 FQ-PCARTONS COLUMN 15 CONVERSION FQ-PKQTY COLUMN 28 CONVERSION
      FQ-PLQTY COLUMN 41 CONVERSION.
    MOVE FQ-PCARTONS TO WN1.
    ACCEPT FQ-PCARTONS LINE 8 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-PCARTONS LINE 8 COLUMN 15 CONVERSION.
    IF FQ-PCARTONS NOT=WN1 PERFORM FQ-B DISPLAY FQ-PLQTY LINE 8 COLUMN 41 CONVERSION.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ58.

    PERFORM BAR-SHP-NAME MOVE FQ-PLQTY TO BAR-PLQTY MOVE SYS-DATE TO BAR-DATE.
    MOVE FQ-PROD TO BAR-PROD MOVE PRO-DESC(1)(1:16) TO BAR-DESC-A.
    MOVE 1 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-SMASTER PERFORM CLOSE-LAB.
    MOVE "LABEL3" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ58. GO FQ53.
FQ59. GO FQ9.

FQ60. DISPLAY " PRINT TRW MASTER LABELS " LINE 1 REVERSED.
FQ63. DISPLAY "ORDER NO. ______" LINE 3 BOLD ERASE END SCREEN.
    ACCEPT HO-ORD LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR HO-ORD=999999 GO FQ69. IF HO-ORD=0 GO FQ63.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 20 TO IXU PERFORM RD-EXT IF A-N1=0 GO FQ63.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO FQ63.
    MOVE HO-INVNO TO FQ-PKSLIP DISPLAY "PACKING SLIP:" LINE 5 BOLD.
    DISPLAY FQ-PKSLIP LINE 5 COLUMN 15 CONVERSION.
    ACCEPT FQ-PKSLIP LINE 5 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-PKSLIP LINE 5 COLUMN 15 CONVERSION.
    MOVE HO-CUS TO FQ-CUS.

* note 198
    PERFORM VARYING FQ-IXP FROM 1 BY 1 UNTIL FQ-IXP>10
      INITIALIZE FQ-WTBL(FQ-IXP) END-PERFORM.
    MOVE 0 TO FQ-IXL FQ-KFIR.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO FQ66.
FQ65. READ SHIPLIN NEXT REGARDLESS END GO FQ66. IF HL-ORDSEQ NOT=HO-ORDSEQ GO FQ66.
    MOVE HL-PROD TO A-A1 PERFORM PROD-RT PERFORM DESC-ENG.
    IF FQ-KFIR=0 MOVE 1 TO FQ-KFIR PERFORM GET-HLCUSORD MOVE A-A1 TO FQ-CUSORD
      MOVE HL-PROD TO FQ-PROD MOVE PRO-ENG TO FQ-ENG MOVE P-QTY-PACK TO FQ-PKQTY.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO FQ654.
FQ653. READ BINALLOC NEXT REGARDLESS END GO FQ654. IF BA-NO NOT=HL-NO GO FQ654.
    PERFORM VARYING FQ-IXP FROM 1 BY 1 UNTIL FQ-IXP>FQ-IXL
      IF HL-PROD=FQ-WPROD(FQ-IXP) AND BA-LOT=FQ-WLOT(FQ-IXP)
        ADD BA-CARTONS TO FQ-WC(FQ-IXP) ADD BA-QTY TO FQ-WQTY(FQ-IXP)
        GO FQ6538 END-IF END-PERFORM.
    IF FQ-IXL<10 ADD 1 TO FQ-IXL
      MOVE HL-PROD TO FQ-WPROD(FQ-IXL) MOVE BA-LOT TO FQ-WLOT(FQ-IXL)
      MOVE PRO-ENG TO FQ-WENG(FQ-IXL) MOVE P-QTY-PACK TO FQ-WQPK(FQ-IXL)
      MOVE BA-CARTONS TO FQ-WC(FQ-IXL) MOVE BA-QTY TO FQ-WQTY(FQ-IXL).
FQ6538. GO FQ653.
FQ654. GO FQ65.
FQ66. IF FQ-CUSORD=" " MOVE O-CUSORD TO FQ-CUSORD.
    COMPUTE FQ-IXP=FQ-IXL + 1.
    PERFORM VARYING FQ-IXP FROM FQ-IXP BY 1 UNTIL FQ-IXP>10
      MOVE FQ-PROD TO FQ-WPROD(FQ-IXP) MOVE FQ-ENG TO FQ-WENG(FQ-IXP)
      MOVE FQ-PKQTY TO FQ-WQPK(FQ-IXP) END-PERFORM.

    DISPLAY "CONFIRM LABEL DATA " LINE 7 REVERSED.
    MOVE 9 TO IXT.
    DISPLAY "PRODUCT         LOT   CARTONS   QTY/CARTON   TOTAL QTY" LINE IXT BOLD.
*            ............  .......   ...        .....       ......
    PERFORM VARYING FQ-IXP FROM 1 BY 1 UNTIL FQ-IXP>10 ADD 1 TO IXT
      DISPLAY FQ-WPROD(FQ-IXP) LINE IXT FQ-WLOT(FQ-IXP) COLUMN 15 CONVERSION
      FQ-WC(FQ-IXP) COLUMN 25 CONVERSION FQ-WQPK(FQ-IXP) COLUMN 36 CONVERSION
      FQ-WQTY(FQ-IXP) COLUMN 48 CONVERSION END-PERFORM.

    MOVE 9 TO IXT MOVE 0 TO FQ-IXP.
FQ663. ADD 1 TO IXT FQ-IXP IF FQ-IXP>10 GO FQ664. PERFORM DSP-PF3.
    ACCEPT FQ-WLOT(FQ-IXP) LINE IXT COLUMN 15 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    DISPLAY FQ-WLOT(FQ-IXP) LINE IXT COLUMN 15 CONVERSION IF KPF3 GO FQ664.
    MOVE FQ-WC(FQ-IXP) TO WN1.
    ACCEPT FQ-WC(FQ-IXP) LINE IXT COLUMN 25 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-WC(FQ-IXP) LINE IXT COLUMN 25 CONVERSION.
    IF FQ-WC(FQ-IXP) NOT=WN1 COMPUTE FQ-WQTY(FQ-IXP)=FQ-WC(FQ-IXP) * FQ-WQPK(FQ-IXP)
      DISPLAY FQ-WQTY(FQ-IXP) LINE IXT COLUMN 48 CONVERSION.
    GO FQ663.
FQ664. PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ68.

    PERFORM BAR-SHP-NAME MOVE 1 TO BAR-LABQTY BAR-QSER.
    MOVE FQ-CUSORD TO BAR-CUSORD MOVE FQ-PKSLIP TO BAR-PKSLIP.
    MOVE FQ-CUS TO BAR-CUS PERFORM BAR-SET-SUPPLIER.
    PERFORM OPEN-PLAB.
    PERFORM VARYING FQ-IXP FROM 1 BY 1 UNTIL FQ-IXP>10 IF FQ-WQTY(FQ-IXP)>0
      MOVE FQ-WPROD(FQ-IXP) TO BAR-PROD MOVE FQ-WLOT(FQ-IXP) TO BAR-LOT
      MOVE FQ-WQTY(FQ-IXP) TO BAR-PLQTY MOVE FQ-WENG(FQ-IXP) TO PRO-ENG
      PERFORM BAR-LAB-TMASTER END-IF END-PERFORM.
    PERFORM CLOSE-LAB MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ68. GO FQ63.
FQ69. GO FQ9.

FQ70. DISPLAY " PRINT INMET MASTER LABELS " LINE 1 REVERSED.
FQ73. DISPLAY " " LINE 3 ERASE END SCREEN.
    DISPLAY "PRODUCT: ____________" LINE 3 BOLD.
    DISPLAY "LOT: _______" LINE 4 BOLD.
    DISPLAY "QTY/PALLET: _____" LINE 5 BOLD.
    DISPLAY "P.O. NO.: _________" LINE 6 BOLD.
    DISPLAY "2 IDENTICAL LABELS WILL BE PRINTED FOR THIS LOT" LINE 8.
    DISPLAY "SEPARATE MASTER LABELS REQUIRED FOR EACH LOT ON A PALLET" LINE 9.
FQ733. ACCEPT FQ-PROD LINE 3 COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO FQ79.
    MOVE FQ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FQ733.
FQ735. ACCEPT FQ-LOT LINE 4 COLUMN 6 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE FQ-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO FQ735.
    ACCEPT FQ-TQTY LINE 5 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE "10150" TO FQ-CUS.
FQ737. MOVE FQ-CUS TO A-A1 MOVE FQ-PROD TO A-A2 PERFORM BAR-SET-CUSORD MOVE A-A1 TO FQ-CUSORD.
    ACCEPT FQ-CUSORD LINE 6 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF FQ-CUSORD=" " PERFORM DSP-ERR2 GO FQ737.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ78.

    MOVE FQ-PROD TO BAR-PROD MOVE FQ-TQTY TO BAR-QTY MOVE FQ-LOT TO BAR-LOT.
    MOVE FQ-CUSORD TO BAR-CUSORD MOVE FQ-CUS TO BAR-CUS PERFORM BAR-SET-SUPPLIER.
    MOVE 2 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-IMASTER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ78. GO FQ73.
FQ79. GO FQ9.

FQ80. DISPLAY " PRINT BENTELER MASTER LABELS " LINE 1 REVERSED.
FQ83. DISPLAY " " LINE 3 ERASE END SCREEN.
    DISPLAY "PRODUCT: ____________" LINE 3 BOLD.
    DISPLAY "QTY/PALLET: _____" LINE 4 BOLD.
FQ833. ACCEPT FQ-PROD LINE 3 COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO FQ89.
    MOVE FQ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FQ833.
    ACCEPT FQ-TQTY LINE 4 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM DSP-ACC IF XA2 NOT="OK" GO FQ88.

    MOVE FQ-PROD TO BAR-PROD MOVE FQ-TQTY TO BAR-QTY.
    MOVE "06234" TO BAR-CUS PERFORM BAR-SET-SUPPLIER.
    MOVE 1 TO BAR-LABQTY BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-BMASTER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ88. GO FQ83.
FQ89. GO FQ9.

FQ9. GO MN9.

FQ-E1. MOVE "THIS IS NOT A GM OR WOODBRIDGE ORDER" TO ERR-MESG PERFORM DSP-ERR.
FQ-A. COMPUTE FQ-TQTY=FQ-TCARTONS * FQ-PKQTY.
    COMPUTE FQ-TGROSS ROUNDED=
      (FQ-TQTY * FQ-WEIGHT / 100 + FQ-TCARTONS * WEI-WT(1) + WEI-PALLET) * WEI-LB.
FQ-B. COMPUTE FQ-PLQTY=FQ-PCARTONS * FQ-PKQTY.
FQ-S. PERFORM FQ-S1 THRU FQ-S9.
FQ-S1. PERFORM RD260 PERFORM WRT.
FQ-S3. ACCEPT FQ-PROD LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO FQ-S9.
    MOVE FQ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO FQ-S3.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 3 COLUMN 25.
    MOVE P-QTY-PACK TO FQ-PKQTY.
FQ-S5. MOVE P-PACKING TO A-N1 PERFORM RD-PACKING MOVE PK-MAX TO FQ-PCARTONS.
    DISPLAY FQ-PCARTONS LINE 5 COLUMN 18 CONVERSION.
    ACCEPT FQ-PCARTONS LINE 5 COLUMN 18 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-PCARTONS LINE 5 COLUMN 18 CONVERSION.
    IF FQ-PCARTONS=0 PERFORM DSP-ERR2 GO FQ-S5.

    PERFORM FQ-B DISPLAY FQ-PLQTY LINE 5 COLUMN 38 CONVERSION.
    ACCEPT FQ-PLQTY LINE 5 COLUMN 38 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-PLQTY LINE 5 COLUMN 38 CONVERSION.
FQ-S7. ACCEPT FQ-LOT LINE 7 COLUMN 7 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE FQ-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO FQ-S7.
    MOVE SYS-DATE TO D-DATE MOVE 7 TO IXT MOVE 31 TO IXU PERFORM AX-DT-DEF.
    MOVE 1 TO FQ-NUMLAB.
    DISPLAY FQ-NUMLAB LINE 7 COLUMN 56 CONVERSION.
    ACCEPT FQ-NUMLAB LINE 7 COLUMN 56 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FQ-NUMLAB LINE 7 COLUMN 56 CONVERSION.
    MOVE 8 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO FQ-S8.

    MOVE FQ-PROD TO BAR-PROD MOVE " " TO BAR-DESC.
    MOVE PRO-DESC(1)(1:16) TO BAR-DESC-A MOVE PRO-DESC(1)(17:) TO BAR-DESC-B.
    MOVE P-EDESC1 TO BAR-DESC-EXT MOVE P-FINDESC TO BAR-DESC-FIN.
    MOVE FQ-PLQTY TO BAR-PLQTY MOVE FQ-PCARTONS TO BAR-CARTONS MOVE FQ-LOT TO BAR-LOT.
    MOVE DATE0 TO D-DATE PERFORM BAR-SET-DATE.
    MOVE FQ-NUMLAB TO BAR-LABQTY MOVE 1 TO BAR-QSER.
    PERFORM OPEN-PLAB PERFORM BAR-LAB-MASTER PERFORM CLOSE-LAB.
    MOVE "LABEL2" TO LAB-QUEUE PERFORM PRINT-LAB.
FQ-S8. GO FQ-S1.
FQ-S9. EXIT.

* S-20 CREATE SHIPPING FILE
KW1. PERFORM RD336 PERFORM WRT.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM LC-CREATE-FILES.
KW9. GO MN9.

LC-CREATE-FILES. PERFORM LC1 THRU LC9.
LC1. MOVE "[IFSHPSAV]" TO LC-DIR.
    IF ITOOL MOVE "[ITSHPSAV]" TO LC-DIR. IF INUT MOVE "[INSHPSAV]" TO LC-DIR.
    PERFORM RDR-INFO IF IF-SHP-IND=1
      CLOSE SHIPORD SHIPLIN BINALLOC
      MOVE " " TO A-A1 STRING "PURGE " DELIMITED SIZE LC-DIR DELIMITED " " "*.DAT" DELIMITED SIZE INTO A-A1
      PERFORM VMS-CMND
      MOVE " " TO A-A1 STRING "COPY " DELIMITED SIZE LC-DIR DELIMITED " " "*.DAT *.DAT" DELIMITED SIZE INTO A-A1
      PERFORM VMS-CMND
      OPEN I-O SHIPORD ALLOWING ALL SHIPLIN ALLOWING ALL BINALLOC ALLOWING ALL
      PERFORM RD-INFO MOVE IF-SHP-SAVNO TO IF-SPINVNO PERFORM WR-INFO GO LC12.
    IF IF-SHP-DATE=SYS-DATE
      DISPLAY "S-20 WAS ALREADY RUN TODAY - YOU CANNOT RUN IT AGAIN" LINE 11 BOLD BLINKING
      MOVE "PRESS ANY KEY TO RETURN TO THE 'S' MENU" TO TMSG PERFORM DSP-MSG GO LC9.
LC12. CLOSE SHIPORD SHIPLIN BINALLOC.
    MOVE " " TO A-A1 STRING "COPY SHIPORD.DAT,SHIPLIN.DAT,BINALLOC.DAT,CFORD.DAT,CFLIN.DAT,HTRANS.DAT "
      DELIMITED SIZE LC-DIR DELIMITED " " INTO A-A1.
    PERFORM VMS-CMND.
    OPEN I-O SHIPORD ALLOWING ALL SHIPLIN ALLOWING ALL BINALLOC ALLOWING ALL.
    PERFORM RD-INFO MOVE 1 TO IF-SHP-IND MOVE IF-SPINVNO TO IF-SHP-SAVNO PERFORM WR-INFO.
* note 98.3

    OPEN OUTPUT TMPORD ALLOWING NO TMPLIN ALLOWING NO CLOSE TMPORD TMPLIN.

    PERFORM OPEN-MAINTA PERFORM OPEN-MAINTB PERFORM OPEN-MAINTC.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LC18.
LC13. READ SHIPORD NEXT REGARDLESS END GO LC18. IF HO-IND>=7 GO LC13.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO LC13.
    WRITE MFA-RECORD FROM HO-RECORD.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LC16.
LC15. READ SHIPLIN NEXT REGARDLESS END GO LC16. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LC16.
    WRITE MFB-RECORD FROM HL-RECORD IF HO-IND NOT=3 GO LC158.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO LC158.
LC153. READ BINALLOC NEXT REGARDLESS END GO LC158. IF BA-NO NOT=HL-NO GO LC158.
    IF BA-QTY>0 WRITE MFC-RECORD FROM BA-RECORD. GO LC153.
LC158. GO LC15.
LC16. GO LC13.
LC18. CLOSE MAINTA MAINTB MAINTC SHIPORD SHIPLIN BINALLOC.
    OPEN INPUT MAINTA MAINTB MAINTC
      OUTPUT SHIPORD ALLOWING NO SHIPLIN ALLOWING NO BINALLOC ALLOWING NO.
LC23. READ MAINTA INTO HO-RECORD END GO LC24.
    WRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD GO LC23.
LC24.
LC25. READ MAINTB INTO HL-RECORD END GO LC26.
    WRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO LC25.
LC26.
LC27. READ MAINTC INTO BA-RECORD END GO LC28.
    WRITE BA-RECORD ALLOWING NO UNLOCK BINALLOC GO LC27.
LC28. CLOSE MAINTA MAINTB MAINTC SHIPORD SHIPLIN BINALLOC.
    OPEN I-O SHIPORD ALLOWING ALL SHIPLIN ALLOWING ALL BINALLOC ALLOWING ALL.

    PERFORM OPEN-MAINTA PERFORM OPEN-MAINTB.
    OPEN I-O CFORD ALLOWING ALL CFLIN ALLOWING ALL.
    MOVE " " TO FO-KEY START CFORD KEY>FO-KEY REGARDLESS INVALID GO LC34.
LC33. READ CFORD NEXT REGARDLESS END GO LC34.
    MOVE FO-BL TO HO-BL READ SHIPORD REGARDLESS KEY HO-KB INVALID GO LC33.
    WRITE MFA-RECORD FROM FO-RECORD MOVE FO-BL TO FL-BL MOVE 0 TO FL-SEQ.
LC335. ADD 1 TO FL-SEQ READ CFLIN REGARDLESS INVALID GO LC338.
    WRITE MFB-RECORD FROM FL-RECORD GO LC335.
LC338. GO LC33.
LC34. CLOSE MAINTA MAINTB CFORD CFLIN.
    OPEN INPUT MAINTA MAINTB OUTPUT CFORD ALLOWING NO CFLIN ALLOWING NO.
LC35. READ MAINTA INTO FO-RECORD END GO LC36.
    WRITE FO-RECORD ALLOWING NO UNLOCK CFORD GO LC35.
LC36.
LC37. READ MAINTB INTO FL-RECORD END GO LC38.
    WRITE FL-RECORD ALLOWING NO UNLOCK CFLIN GO LC37.
LC38. CLOSE MAINTA MAINTB CFORD CFLIN.

    MOVE SYS-DATE TO D-DATE MOVE 10 TO D-DAYS PERFORM D-WDIFF.
    MOVE D-DATE TO LC-DATE-MAX.
    MOVE 0 TO O-NO START SAORD KEY>O-KEY REGARDLESS INVALID GO LC49.
LC43. READ SAORD NEXT REGARDLESS END GO LC49. IF O-BLANKET=1 GO LC43.
    IF O-DATE-REQ>LC-DATE-MAX AND O-CUS<="15000" GO LC43.
    PERFORM INIT-HO MOVE O-DATE-REQ TO HO-DATE-REQ.
    IF ITOOL MOVE 3 TO HO-IND. IF O-SPECIAL=0 GO LC44. MOVE 5 TO HO-IND.
LC435. PERFORM RD-INFO ADD 1 TO IF-SPINVNO PERFORM WR-INFO.
    MOVE IF-SPINVNO TO HO-INVNO TR-INV.
    START TRANS KEY=TR-KI REGARDLESS INVALID GO LC44. GO LC435.
LC44. MOVE 0 TO WS1.
    COMPUTE L-NO=100 * O-NO START SALIN KEY>L-KEY REGARDLESS INVALID GO LC48.
LC45. READ SALIN NEXT REGARDLESS END GO LC48. IF L-ORD NOT=O-NO GO LC48.
    IF O-SPECIAL=0 AND L-QTY-LEFT=0 GO LC45. PERFORM INIT-HL.
    MOVE L-QTY-LEFT TO HL-QTY IF O-SPECIAL=1 MOVE L-QTY TO HL-QTY-AL.
    WRITE HL-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK SHIPLIN.
    MOVE 1 TO WS1 GO LC45.
LC48. IF WS1=1 WRITE HO-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK SHIPORD.
    GO LC43.
LC49.

    PERFORM OPEN-MAINTA OPEN I-O HTRANS ALLOWING ALL.
    MOVE " " TO HT-KEY START HTRANS KEY>HT-KEY REGARDLESS INVALID GO LC54.
LC53. READ HTRANS NEXT REGARDLESS END GO LC54. IF HT-IND=1 GO LC53.
    WRITE MFA-RECORD FROM HT-RECORD GO LC53.
LC54. CLOSE MAINTA HTRANS.
    OPEN INPUT MAINTA OUTPUT HTRANS ALLOWING NO.
LC55. READ MAINTA INTO HT-RECORD END GO LC56.
    WRITE HT-RECORD ALLOWING NO UNLOCK HTRANS GO LC55.
LC56. CLOSE HTRANS MAINTA PERFORM DELETE-MAINT.

    PERFORM RD-INFO MOVE 0 TO IF-SHP-IND MOVE SYS-DATE TO IF-SHP-DATE PERFORM WR-INFO.
LC9. EXIT.

* S-21 ALLOCATE BINS
KB1. PERFORM RD57 PERFORM WRT MOVE SYS-DATE TO D-DATE.
    MOVE 6 TO IXT MOVE 20 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO KB-GDATE.
    MOVE SYS-DATE TO D-DATE MOVE 2 TO D-DAYS PERFORM D-WDIFF.
    MOVE 7 TO IXT MOVE 20 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO KB-NDATE.
    MOVE 12 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    MOVE KB-GDATE TO LB-GDATE MOVE KB-NDATE TO LB-NDATE PERFORM LB-BIN-ALLOC.
    PERFORM CLOSE-PR.
KB9. GO MN9.

LB-BIN-ALLOC. PERFORM LB1 THRU LB9.
LB1. PERFORM LB-ALLOC.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LB4.
LB3. READ SHIPORD NEXT REGARDLESS END GO LB4. IF HO-SEQ=0 GO LB3.
    MOVE HO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    IF AUTO-GMC IF NOT(HO-IND=0 OR 1) OR HO-DATE-REQ>LB-GDATE GO LB3 END-IF
      ELSE IF HO-IND NOT=1 OR HO-DATE-REQ>LB-NDATE GO LB3.
    MOVE 1 TO WS1 IF AUTO-GMC GO LB34.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LB34.
LB33. READ SHIPLIN NEXT REGARDLESS END GO LB34. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LB34.
    MOVE HL-PROD TO A-A1 PERFORM PROD-GEN.
    IF HL-QTY-ALPREV<HL-QTY OR GEN-NUT>" " AND HL-QTY-NALPREV<HL-QTY
      MOVE 0 TO WS1 GO LB34. GO LB33.
LB34. IF WS1=1 AND C-HOLD=0 MOVE 2 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LB3.

LB4. MOVE SYS-DATE TO D-DATE MOVE 1 TO D-DAYS PERFORM D-WDIFF MOVE D-DATE TO LB-ADATE.
    MOVE SYS-DATE TO D-DATE MOVE 2 TO D-DAYS PERFORM D-WDIFF MOVE D-DATE TO LB-BDATE.
    MOVE SYS-DATE TO D-DATE MOVE 5 TO D-DAYS PERFORM D-WDIFF MOVE D-DATE TO LB-LDATE.
    PERFORM OPEN-SORT.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LB49.
LB43. READ SHIPORD NEXT REGARDLESS END GO LB49.
    IF NOT(HO-IND>=0 AND<=2) OR HO-DATE-REQ>LB-LDATE GO LB43.
    MOVE HO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    IF NOT AUTO-GMC GO LB43.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO LB43.
    IF O-SHIPTO=0 GO LB44. MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO LB44. MOVE SA-NAME TO O-NAME.
LB44. COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LB48.
LB45. READ SHIPLIN NEXT REGARDLESS END GO LB48. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LB48.
    MOVE HL-PROD TO A-A1 PERFORM PROD-GEN.
    IF HL-QTY-ALPREV<HL-QTY OR GEN-NUT>" " AND HL-QTY-NALPREV<HL-QTY
      IF HL-DATE-REQ<=LB-ADATE MOVE 0 TO SR-F66 ELSE MOVE 1 TO SR-F66 END-IF
      MOVE P-CAT TO SR-F67 MOVE HL-PROD TO SR-F68 MOVE HL-DATE-REQ TO SR-F69
      MOVE HL-ORD TO SR-F70 MOVE HL-SEQ TO SR-F70A
      COMPUTE SR-F71=HL-QTY - HL-QTY-ALPREV
      IF GEN-NUT>" " COMPUTE SR-F71A=HL-QTY - HL-QTY-NALPREV END-IF
      MOVE O-NAME TO SR-F71B WRITE SR-RECORD INVALID CONTINUE.
    GO LB45.
LB48. GO LB43.
LB49.

    MOVE 1 TO LB-STEP.
LB5. PERFORM LB-PAGE MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY COMPUTE SR-F66=LB-STEP - 1.
    START SORTFL KEY>SR-KEY INVALID GO LB59.
LB53. READ SORTFL NEXT END GO LB59. IF SR-F66>LB-STEP - 1 GO LB59.
    IF SR-F67 NOT=OLD-N PERFORM LB-LINE MOVE "CAT" TO FF351 MOVE SR-F67 TO FF351A OLD-N.
    MOVE SR-F68 TO FF352 MOVE SR-F69 TO D-DATE PERFORM D-NM MOVE D-DT TO FF353.
    MOVE SR-F71 TO FF354 MOVE SR-F71A TO FF354A.
    MOVE SR-F70 TO FF355 IF SR-F70A>0 MOVE "-" TO FF355A MOVE SR-F70A TO FF355B.
    MOVE SR-F71B TO FF356 PERFORM LB-LINE GO LB53.
LB59. IF LB-STEP=1 MOVE 2 TO LB-STEP GO LB5.
    PERFORM CLOSE-SORT.
LB9. EXIT.

LB-ALLOC. PERFORM LB-A1 THRU LB-A9.
LB-A1. PERFORM OPEN-SORT.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LB-A19.
LB-A13. READ SHIPORD NEXT REGARDLESS END GO LB-A19. IF NOT(HO-IND>=0 AND<=2) GO LB-A13.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LB-A18.
LB-A15. READ SHIPLIN NEXT REGARDLESS END GO LB-A18. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LB-A18.
    IF HO-BIND=1 GO LB-A16.
    MOVE HL-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO LB-A15. PERFORM RD-GEN.
    MOVE P-NO TO SR-F73 MOVE HL-CONT TO SR-F74 MOVE HL-DATE-REQ TO SR-F75.
    MOVE HL-KEY TO SR-F75A MOVE 0 TO SR-F76 WRITE SR-RECORD.
    IF GEN-NUT>" "
      MOVE GEN-NUT TO SR-F73 MOVE HL-CONT TO SR-F74 MOVE HL-DATE-REQ TO SR-F75
      MOVE HL-KEY TO SR-F75A MOVE 1 TO SR-F76 WRITE SR-RECORD.
LB-A16. MOVE 0 TO HL-QTY-AL HL-QTY-ALPREV HL-WEIGHT-AL HL-WEIGHT-ALPREV
          HL-QTY-NAL HL-QTY-NALPREV HL-WEIGHT-NAL HL-WEIGHT-NALPREV.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO LB-A15.
LB-A18. IF HO-IND=1 MOVE 0 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LB-A13.
LB-A19.

    MOVE " " TO OLD-A MOVE 0 TO LB-TQTY.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO LB-A6.
LB-A3. READ SORTFL NEXT END GO LB-A6. IF SR-F72=OLD-A GO LB-A4.
    MOVE SR-F73 TO P-NO READ PRODUCT REGARDLESS INVALID GO LB-A3.
    MOVE 0 TO LB-TQTY INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO LB-A34.
LB-A33. READ BIN NEXT REGARDLESS END GO LB-A34. IF B-PROD NOT=P-NO GO LB-A34.
    IF B-CONT=SR-F74 COMPUTE LB-TQTY=LB-TQTY + B-QTY - B-QTY-AL. GO LB-A33.
LB-A34. MOVE SR-F72 TO OLD-A.
LB-A4. MOVE SR-F75A TO HL-KEY READ SHIPLIN REGARDLESS.
    IF HL-QTY<=LB-TQTY MOVE HL-QTY TO LB-AQTY SUBTRACT HL-QTY FROM LB-TQTY
      ELSE MOVE LB-TQTY TO LB-AQTY MOVE 0 TO LB-TQTY.
    IF LB-AQTY=0 GO LB-A58.
    IF SR-F76=0 MOVE LB-AQTY TO HL-QTY-AL
      COMPUTE HL-WEIGHT-AL ROUNDED=HL-QTY-AL * (P-WEIGHT + P-WEIGHT-NUT) / 100
      MOVE HL-QTY-AL TO HL-QTY-ALPREV MOVE HL-WEIGHT-AL TO HL-WEIGHT-ALPREV
     ELSE MOVE LB-AQTY TO HL-QTY-NAL
      COMPUTE HL-WEIGHT-NAL ROUNDED=HL-QTY-NAL * P-WEIGHT / 100
      MOVE HL-QTY-NAL TO HL-QTY-NALPREV MOVE HL-WEIGHT-NAL TO HL-WEIGHT-NALPREV.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    MOVE HL-ORDSEQ TO HO-ORDSEQ READ SHIPORD REGARDLESS INVALID GO LB-A58.
    IF HO-IND=0 MOVE 1 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
* note 24
LB-A58. GO LB-A3.
LB-A6. PERFORM CLOSE-SORT.
LB-A9. EXIT.
LB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM LB-PAGE.
LB-PAGE. MOVE "BIN ALLOCATION EXCEPTION REPORT" TO FF3.
    MOVE "** PRODUCTS NOT FULLY ALLOCATED (GM) **" TO FF4 PERFORM PR-PAGE.
    IF LB-STEP=1 MOVE SYS-DATE TO DATE1 MOVE LB-ADATE TO DATE2
      ELSE MOVE LB-BDATE TO DATE1 MOVE LB-LDATE TO DATE2.
    MOVE "DATE REQUIRED:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR MOVE "ALLOCATED UP TO:" TO FF545 MOVE LB-GDATE TO D-DATE.
    PERFORM D-NM MOVE D-DT TO FF546 PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "   CAT  PRODUCT         DATE    QTY SHORT      NUTS    ORDER     SHIP TO" TO PREC PERFORM PR-LINE-3.
*         ... ..  ............  ../../.. ..,...,...-..,...,...- ......-..  ................................

* S-22 SELECT ORDERS TO SHIP
LS1.
LS3. PERFORM RD71 PERFORM WRT.
    DISPLAY "FOR AUTOMATIC SELECTION, LEAVE 'ORDER NO.' BLANK" LINE 24 BOLD.
    ACCEPT HO-ORD LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR HO-ORD=999999 GO LS9. IF HO-ORD=0 GO LS6.
    MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 22 TO IXU PERFORM RD-EXT IF A-N1=0 GO LS3.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO LS3.
    DISPLAY C-NAME LINE 3 COLUMN 48.
    IF C-HOLD=1 MOVE "CANNOT SHIP FOR THIS CUSTOMER - CREDIT HOLD" TO ERR-MESG
      PERFORM DSP-ERR GO LS3.
    IF HO-IND>2 MOVE "ORDER STATUS IS GREATER THAN 2" TO ERR-MESG
      PERFORM DSP-ERR GO LS3.
    DISPLAY "ORDER SELECTED TO SHIP: _" LINE 5 BOLD.
LS33. IF HO-IND<=1 MOVE "N" TO XA1 ELSE MOVE "Y" TO XA1.
    DISPLAY "'Y' TO SHIP THIS ORDER, OR 'N' NOT TO SHIP IT" LINE 24 BOLD.
    ACCEPT XA1 LINE 5 COLUMN 25 DEFAULT CURRENT UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF NOT(XA1="Y" OR "N") PERFORM DSP-ERR14 GO LS33.
    IF XA1="N" IF HO-IND=2 MOVE 1 TO HO-IND END-IF GO LS38.
    IF HO-IND=0 MOVE "ORDER STATUS IS 0, NOT 1" TO ERR-MESG
      PERFORM DSP-OK IF XA2="OK" MOVE 1 TO HO-NOALLOC ELSE GO LS3.
    MOVE 2 TO HO-IND.
LS38. REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD IF HO-IND NOT=2 GO LS49.

    MOVE 8 TO LS-IXT.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LS48.
LS43. READ SHIPLIN NEXT REGARDLESS END GO LS48. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LS48.
    MOVE HL-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO LS43. PERFORM RD-GEN.
    IF P-CAT<=21 GO LS43. DISPLAY "SPECIAL PRODUCT: " LINE LS-IXT BOLD P-NO.
    MOVE P-HAND TO LS-DF1 DISPLAY "QTY ON HAND:" LINE LS-IXT COLUMN 35 BOLD LS-DF1.
    DISPLAY "QTY TO SHIP: ________" LINE LS-IXT COLUMN 59 BOLD.
    MOVE HL-QTY-AL TO LS-AQTY DISPLAY LS-AQTY LINE LS-IXT COLUMN 72 CONVERSION.

    MOVE 12 TO IXT MOVE 0 TO LS-KOT.
    MOVE P-NO TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO LS46.
LS45. READ SALIN NEXT REGARDLESS END GO LS46. IF L-PROD NOT=P-NO GO LS46.
    IF L-ORD=HO-ORD OR L-QTY-LEFT=0 OR L-ADJ=1 GO LS45.
    IF LS-KOT=0 MOVE 1 TO LS-KOT
      DISPLAY "OTHER ORDERS WITH THIS PRODUCT: " LINE IXT REVERSED ADD 1 TO IXT
      DISPLAY " ORDER  CUST    NAME                              REQUIRED     QTY"
*              ......  ......  ................................  ../../..  ...,...-
        LINE IXT BOLD ADD 1 TO IXT.
    MOVE L-ORD TO LS-DS3A MOVE L-CUS TO LS-DS3B A-A1 PERFORM RD-CUS MOVE C-NAME TO LS-DS3C.
    MOVE L-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO LS-DS3D.
    IF L-QTY=LIT-Q9 MOVE LIT-BL TO LS-DS3F ELSE MOVE L-QTY-LEFT TO LS-DS3E.
    DISPLAY LS-DS3 LINE IXT ADD 1 TO IXT IF IXT<22 GO LS45.
LS46. IF LS-KOT=0 DISPLAY "THERE ARE NO OTHER ORDERS WITH THIS PRODUCT" LINE IXT BOLD.

    ACCEPT LS-AQTY LINE LS-IXT COLUMN 72 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LS-AQTY LINE LS-IXT COLUMN 72 CONVERSION.
* note 18.1
    IF LS-AQTY=HL-QTY-AL GO LS478.
    MOVE LS-AQTY TO HL-QTY-AL.
    COMPUTE HL-WEIGHT-AL ROUNDED=HL-QTY-AL * (P-WEIGHT + P-WEIGHT-NUT) / 100.
    MOVE HL-QTY-AL TO HL-QTY-ALPREV MOVE HL-WEIGHT-AL TO HL-WEIGHT-ALPREV.
    IF GEN-NUT>" " MOVE LS-AQTY TO HL-QTY-NAL
      COMPUTE HL-WEIGHT-NAL ROUNDED=HL-QTY-NAL * GEN-WEIGHT-NUT / 100
      MOVE HL-QTY-NAL TO HL-QTY-NALPREV MOVE HL-WEIGHT-NAL TO HL-WEIGHT-NALPREV.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
LS478. DISPLAY " " LINE LS-IXT ERASE END SCREEN.
    GO LS43.
LS48.
LS49. GO LS3.

LS6.
LS61. PERFORM RD72 PERFORM WRT.
LS63. ACCEPT LS-VIA LINE 3 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR LS-VIA=999 GO LS9. IF LS-VIA=0 GO LS63.
* note 42.2
LS65. DISPLAY "TO INCLUDE ALL CUSTOMERS, LEAVE 'CUSTOMER' BLANK" LINE 24 BOLD.
    ACCEPT LS-CUS LINE 3 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF LS-CUS>" " MOVE LS-CUS TO C-NO
      READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO LS65.
LS67. ACCEPT LS-MAXW LINE 3 COLUMN 67 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF LS-MAXW=0 GO LS67.
    MOVE 0 TO LS-EX PERFORM LS-SELECT.
    MOVE "'OK' TO SELECT THESE ORDERS: __" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="OK" GO LS61. DISPLAY " " LINE 6 ERASE END SCREEN.
    MOVE 1 TO LS-EX PERFORM LS-SELECT PERFORM DSP-CONT GO LS9.

LS9. GO MN9.

LS-SELECT. PERFORM LS-S1 THRU LS-S9.
LS-S1. MOVE 0 TO LS-TOTW LS-TOTN LS-PORD LS-KEND.
    MOVE 6 TO IXT MOVE 1 TO IXU MOVE 1 TO LS-IX1.
    MOVE LS-VIA TO HO-VIA MOVE LS-CUS TO HO-CUS MOVE 0 TO HO-DATE-REQ.
    START SHIPORD KEY>HO-KV REGARDLESS INVALID GO LS-S8.
LS-S3. READ SHIPORD NEXT REGARDLESS END GO LS-S8. IF HO-VIA NOT=LS-VIA GO LS-S8.
    IF LS-CUS>" " AND NOT=HO-CUS GO LS-S8. IF HO-IND NOT=1 GO LS-S3.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO LS-S3. IF C-HOLD=1 GO LS-S3.
    MOVE 0 TO LS-ORDW.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LS-S6.
LS-S5. READ SHIPLIN NEXT REGARDLESS END GO LS-S6. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LS-S6.
    MOVE HL-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO LS-S6. PERFORM RD-GEN.
    IF HL-QTY-AL NOT=0 MOVE HL-QTY-AL TO WN1 MOVE HL-WEIGHT-AL TO LS-AWEIGHT
      ELSE MOVE HL-QTY-ALPREV TO WN1 MOVE HL-WEIGHT-ALPREV TO LS-AWEIGHT.
    IF GEN-NUT>" " COMPUTE LS-AWEIGHT ROUNDED=
      LS-AWEIGHT + GEN-WEIGHT-NUT * HL-QTY * WN1 / HL-QTY / 100.
* note 163
    IF LS-TOTW + LS-AWEIGHT<=LS-MAXW ADD LS-AWEIGHT TO LS-ORDW LS-TOTW GO LS-S5.
    MOVE 1 TO LS-KEND.
    IF GEN-NUT>" " MOVE 0 TO LS-QTY LS-WEIGHT GO LS-S52.
    COMPUTE LS-QTY ROUNDED=(LS-MAXW - LS-TOTW) * 100 / (P-WEIGHT + P-WEIGHT-NUT) SIZE ERROR GO LS-S6.
    IF P-QTY-PACK>0 DIVIDE P-QTY-PACK INTO LS-QTY MULTIPLY P-QTY-PACK BY LS-QTY.
    COMPUTE LS-WEIGHT ROUNDED=LS-QTY * (P-WEIGHT + P-WEIGHT-NUT) / 100.
    ADD LS-WEIGHT TO LS-ORDW LS-TOTW.
LS-S52. IF LS-EX=0 GO LS-S6.
* note 18.2
    MOVE LS-QTY TO HL-QTY-AL HL-QTY-ALPREV.
    MOVE LS-WEIGHT TO HL-WEIGHT-AL HL-WEIGHT-ALPREV.
    IF GEN-NUT>" " MOVE 0 TO HL-QTY-NAL HL-QTY-NALPREV HL-WEIGHT-NAL HL-WEIGHT-NALPREV.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
LS-S53. READ SHIPLIN NEXT REGARDLESS END GO LS-S6. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LS-S6.
    MOVE 0 TO HL-QTY-AL HL-QTY-ALPREV HL-WEIGHT-AL HL-WEIGHT-ALPREV
      HL-QTY-NAL HL-QTY-NALPREV HL-WEIGHT-NAL HL-WEIGHT-NALPREV.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO LS-S53.
LS-S6. IF LS-KEND=1 IF LS-ORDW=0 GO LS-S8 END-IF
         MOVE HO-ORD TO LS-PORD MOVE HO-SEQ TO LS-PSEQ.
* note 19
    DISPLAY HO-ORD LINE IXT COLUMN IXU CONVERSION.
    MOVE HO-SEQ TO EXT-S PERFORM DSP-EXT DISPLAY EXT-D COLUMN IXU PLUS 6.
    DISPLAY ":" COLUMN IXU PLUS 9 MOVE LS-ORDW TO LS-DF1 DISPLAY LS-DF1 COLUMN IXU PLUS 10.
    ADD 20 TO IXU ADD 1 TO LS-IX1.
    IF LS-IX1>4 ADD 1 TO IXT MOVE 1 TO IXU MOVE 1 TO LS-IX1
      IF IXT>21 MOVE 6 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    IF LS-EX=1 MOVE 2 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    ADD 1 TO LS-TOTN IF LS-KEND=0 GO LS-S3.
LS-S8. MOVE " " TO LS-DS1 MOVE LS-TOTN TO LS-DS1A MOVE "ORDERS" TO LS-DS1B.
    IF LS-EX=0 MOVE "WILL BE SELECTED" TO LS-DS1C ELSE MOVE "WERE SELECTED" TO LS-DS1C.
    MOVE "-- TOTAL WEIGHT:" TO LS-DS1D MOVE LS-TOTW TO LS-DS1E.
    DISPLAY LS-DS1 LINE 22 BOLD.
    IF LS-PORD NOT=0 MOVE " " TO LS-DS2
      MOVE "(ORDER" TO LS-DS2A MOVE LS-PORD TO LS-DS2B
      IF LS-PSEQ>0 MOVE "-" TO LS-DS2C MOVE LS-PSEQ TO LS-DS2D END-IF
      MOVE "IS PARTIALLY SELECTED)" TO LS-DS2E DISPLAY LS-DS2 LINE 23.
LS-S9. EXIT.

* S-23 PRINT PICKING TICKETS
KD1. PERFORM RD337 PERFORM WRT.
    ACCEPT XA3 LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO ID-KGM ELSE MOVE 0 TO ID-KGM.
    ACCEPT XA3 LINE 4 COLUMN 33 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO ID-KEPS ELSE MOVE 0 TO ID-KEPS.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM ID-PICK-TICKETS PERFORM CLOSE-PR.
KD9. GO MN9.

ID-PICK-TICKETS. PERFORM ID1 THRU ID9.
ID1. OPEN I-O SOLDTO ALLOWING ALL DELJITEX ALLOWING ALL.
    PERFORM ID-ALLOC PERFORM OPEN-REP.
    INITIALIZE HO-KV START SHIPORD KEY>HO-KV REGARDLESS INVALID GO ID29.
ID23. READ SHIPORD NEXT REGARDLESS END GO ID29. IF HO-IND NOT=2 GO ID23.
    MOVE HO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    IF AUTO-GMC AND ID-KGM=0 GO ID23.
    MOVE HO-VIA TO SV-KEY PERFORM RD-VIA PERFORM INIT-RP.
    MOVE SV-SORT TO RP-F218 MOVE HO-VIA TO RP-F219 MOVE HO-KEY TO RP-F220.
    WRITE RP-RECORD GO ID23.
ID29. PERFORM RDR-INFO.
    IF IF-PRINTER=1 OR ID-KEPS=1 MOVE X"33" TO EPS-PGL
      STRING EPS-INIT EPS-SKIPN EPS-PGLIN DELIMITED SIZE INTO PREC
      WRITE PREC AFTER 0 MOVE " " TO PREC
     ELSE WRITE PREC AFTER PAGE.
    PERFORM OPEN-SORT.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO ID8.
ID3. READ REPFL NEXT END GO ID8.
    MOVE RP-F220 TO HO-KEY READ SHIPORD REGARDLESS INVALID GO ID3.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO ID3.
    MOVE O-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    IF AUTO-AMAX MOVE HO-DXNO TO A-N1 PERFORM DX-RD-AMAX PERFORM DX-SET-PULLS.
    IF O-SHIPTO=0 GO ID32. MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO ID32. PERFORM GET-O-CUSADD.
ID32. MOVE 1 TO ID-PGTOT MOVE 21 TO ID-LNUM MOVE 1 TO ID-KFIR.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO ID4.
ID35. READ SHIPLIN NEXT REGARDLESS END GO ID4. IF HL-ORDSEQ NOT=HO-ORDSEQ GO ID4.
    IF NOT(O-BLANKET=1 OR HO-NOALLOC=1 OR HL-QTY-AL NOT=0) GO ID35.
    MOVE HL-ORD TO L-ORD MOVE HL-LINE TO L-LINE READ SALIN REGARDLESS INVALID GO ID35.
    MOVE HL-LABINF TO ED-LABINF MOVE L-PROD TO A-A1 PERFORM PROD-RDG.
    MOVE 0 TO ID-LIN IF GEN-IND=1 ADD 1 TO ID-LIN.
    MOVE 2 TO IX1 ADD 1 TO ID-LIN PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      ADD 1 TO IX1 ID-LIN END-PERFORM.
    IF L-CUSPART>" " ADD 1 TO ID-LIN. IF L-PLATING NOT=0 ADD 1 TO ID-LIN.
    IF HL-OLD=1 ADD 1 TO ID-LIN. IF HL-ERR=1 ADD 1 TO ID-LIN.
    IF GEN-NUT>" " ADD 4 TO ID-LIN.
* note 156
    MOVE 0 TO WN1 INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID38.
ID37. READ BINALLOC NEXT REGARDLESS END GO ID38. IF BA-NO NOT=HL-NO GO ID38.
    ADD 1 TO WN1 GO ID37.
ID38. IF ED-PKG11>" " ADD 1 TO WN1. IF WN1>ID-LIN MOVE WN1 TO ID-LIN.
    ADD 2 TO ID-LIN IF GEN-NUT>" " ADD 2 TO ID-LIN.
    IF AUTO-AMAX COMPUTE WN1=(DX-PULLS + 5) / 6 ADD WN1 TO ID-LIN.
    IF ID-LNUM + ID-LIN<=ID-MAXLN ADD ID-LIN TO ID-LNUM MOVE 0 TO HL-PAGE
      ELSE IF ID-KFIR=0 ADD 1 TO ID-PGTOT MOVE 1 TO HL-PAGE END-IF
        COMPUTE ID-LNUM=21 + ID-LIN
        IF ID-LNUM>ID-MAXLN ADD 1 TO ID-PGTOT SUBTRACT 28 FROM ID-LNUM.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN MOVE 0 TO ID-KFIR.
    GO ID35.
ID4. MOVE 0 TO WN1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      IF O-TEXT(IX1) NOT=0 ADD 1 TO WN1 END-IF END-PERFORM.
    MOVE 0 TO ID-KT IF ID-LNUM + WN1>ID-MAXLN ADD 1 TO ID-PGTOT MOVE 1 TO ID-KT.

    IF C-LABEL=5 MOVE HO-DXNO TO A-N1 PERFORM DX-RD-SAT MOVE ED-SKAN-N(1) TO ID-KAN-N.
    IF C-LABEL=6 MOVE HO-DXNO TO A-N1 PERFORM DX-RD-DELP.

    MOVE 0 TO WS-PAGE PERFORM ID-PAGE.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO ID70.
ID5. READ SHIPLIN NEXT REGARDLESS END GO ID70. IF HL-ORDSEQ NOT=HO-ORDSEQ GO ID70.
    IF NOT(O-BLANKET=1 OR HO-NOALLOC=1 OR HL-QTY-AL NOT=0) GO ID5.
    MOVE HL-ORD TO L-ORD MOVE HL-LINE TO L-LINE READ SALIN REGARDLESS INVALID GO ID5.
    MOVE HL-LABINF TO ED-LABINF MOVE L-PROD TO A-A1 PERFORM PROD-RDG.
* note 8.1
    IF ED-PKG11>" " PERFORM INIT-BA MOVE "zzzzz" TO BA-BIN MOVE P-NO TO BA-PROD
      WRITE BA-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK BINALLOC.
    MOVE 0 TO ID-KL ID-KB INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID MOVE 1 TO ID-KB.
    IF HL-PAGE=1 WRITE PREC AFTER PAGE PERFORM ID-PAGE.
    MOVE L-PROD TO FA431 IF GEN-IND=1 PERFORM ID-BLINE MOVE P-NO TO FA431.
    MOVE PRO-DESC(1) TO FA432 MOVE HL-QTY-AL TO FA433.
    COMPUTE FA434=P-WEIGHT + P-WEIGHT-NUT PERFORM ID-BLINE.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO FA432 PERFORM ID-BLINE END-PERFORM.
    IF L-CUSPART>" " STRING "CUSTOMER PART: " L-CUSPART DELIMITED SIZE
      INTO FA435 PERFORM ID-BLINE.
    IF L-PLATING NOT=0 PERFORM PLATING-READ MOVE T-PLS TO FA432 PERFORM ID-BLINE.
    IF HL-OLD=1 MOVE ID-MSG1 TO FA430 PERFORM ID-BLINE.
    IF HL-ERR=1 IF HL-QTY-AL=0 MOVE ID-MSG2 TO FA428 ELSE MOVE ID-MSG3 TO FA428 END-IF
      MOVE HL-QTY TO FA429 PERFORM ID-BLINE.
    IF NOT AUTO-AMAX GO ID56.
    MOVE "PULL SIGNALS:" TO FA426 MOVE 0 TO DX-IXP MOVE 1 TO PR-IXP.
ID53. ADD 1 TO DX-IXP IF DX-IXP>DX-PULLS GO ID54.
    MOVE ED-AKAN(DX-IXP) TO FA427(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>6 PERFORM ID-BLINE MOVE 1 TO PR-IXP. GO ID53.
ID54. IF PR-IXP>1 PERFORM ID-BLINE.
ID56. MOVE 1 TO ID-KL PERFORM ID-BLINE UNTIL ID-KB=1 PERFORM PR-LINE-2.
    IF ED-PKG11>" " MOVE HL-NO TO BA-NO MOVE "zzzzz" TO BA-BIN DELETE BINALLOC INVALID CONTINUE.

    IF GEN-NUT=" " GO ID6.
    IF WS-LINES>ID-MAXLN - 3 WRITE PREC AFTER PAGE PERFORM ID-PAGE.
    MOVE GEN-NUT TO A-A1 PERFORM PROD-RD.
    MOVE 0 TO ID-KL ID-KB INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID MOVE 1 TO ID-KB.
    MOVE P-NO TO FA431 MOVE PRO-DESC(1) TO FA432 MOVE HL-QTY-NAL TO FA433.
    MOVE P-WEIGHT TO FA434 PERFORM ID-BLINE.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO FA432 PERFORM ID-BLINE END-PERFORM.
    IF L-PLATING NOT=0 PERFORM PLATING-READ MOVE T-PLS TO FA432 PERFORM ID-BLINE.
    IF HL-NOLD=1 MOVE ID-MSG1 TO FA430 PERFORM ID-BLINE.
    IF HL-NERR=1 IF HL-QTY-NAL=0 MOVE ID-MSG2 TO FA428 ELSE MOVE ID-MSG3 TO FA428 END-IF
      MOVE HL-QTY TO FA429 PERFORM ID-BLINE.
    MOVE 1 TO ID-KL PERFORM ID-BLINE UNTIL ID-KB=1 PERFORM PR-LINE-2.

ID6. IF C-LABEL=1 PERFORM INIT-SR MOVE 1 TO SR-F51 MOVE RP-F218 TO SR-F51A
      MOVE HL-ORDSEQ TO SR-F52 MOVE HL-PROD TO SR-F53 MOVE O-NAME TO SR-F54
      MOVE HL-LINE TO SR-F55 MOVE O-NO TO SR-F56
      WRITE SR-RECORD INVALID CONTINUE END-WRITE GO ID69.
    IF C-LABEL=3 PERFORM INIT-SR MOVE 3 TO SR-F51 MOVE 0 TO SR-F51A
      MOVE HL-ORDSEQ TO SR-F52 MOVE " " TO SR-F53 MOVE HL-LINE TO SR-F55
      WRITE SR-RECORD INVALID CONTINUE END-WRITE GO ID69.
    IF NOT(C-LABEL=2 OR>=4 AND<=11) GO ID69.
    PERFORM INIT-LA MOVE 2 TO LA-SRC.
    MOVE HL-PROD TO LA-PROD MOVE HL-DATE-REQ TO LA-DATE MOVE O-CUS TO LA-CUS.
    PERFORM GET-HLCUSORD MOVE A-A1 TO LA-CUSORD.
    MOVE O-NO TO LA-ORD MOVE ED-LABINF TO LA-LABINF.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID68.
ID63. READ BINALLOC NEXT REGARDLESS END GO ID68. IF BA-NO NOT=HL-NO GO ID68.
    MOVE BA-LOT TO LA-LOT MOVE BA-QTY-PACK TO LA-QPACK.
    IF C-LABEL=5 MOVE 1 TO LA-QTY
      PERFORM BA-CARTONS TIMES
        MOVE ID-KAN-N TO ED-N61 COMPUTE WN1=6 - ED-SKAN-ND + 1
        STRING ED-SKAN-A ED-N61(WN1:) DELIMITED SIZE INTO LA-KANBAN
        PERFORM SET-LA WRITE LA-RECORD ALLOWING NO UNLOCK LABELS
        ADD 1 TO ID-KAN-N END-PERFORM GO ID66.
    IF C-LABEL=6 MOVE 1 TO LA-QTY
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>BA-CARTONS OR ED-DKNUM
        MOVE ED-DKVAL(IX1) TO LA-KANBAN
        PERFORM SET-LA WRITE LA-RECORD ALLOWING NO UNLOCK LABELS
        END-PERFORM GO ID66.
    COMPUTE LA-QTY=BA-CARTONS + 1.
    PERFORM SET-LA WRITE LA-RECORD ALLOWING NO UNLOCK LABELS.
ID66. GO ID63.
ID68.
ID69. GO ID5.

ID70. MOVE 3 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    IF ID-KT=1 WRITE PREC AFTER PAGE PERFORM ID-PAGE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      IF O-TEXT(IX1) NOT=0 MOVE 3 TO T-TBL MOVE O-TEXT(IX1) TO T-NO
        PERFORM RD-TBL MOVE T-LINE TO FA430 PERFORM PR-LINE END-IF END-PERFORM.
    WRITE PREC AFTER PAGE GO ID3.

ID8. PERFORM RDR-INFO IF IF-PRINTER=1 OR ID-KEPS=1
       STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM PR-LINE.

    MOVE 7 TO LAB-FLN PERFORM OPEN-LAB MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO ID829.
ID823. READ SORTFL NEXT END GO ID829. IF SR-F51 NOT=1 GO ID823.
    IF SR-F52 NOT=OLD-N MOVE SR-F52 TO OLD-N BAR-ORDSEQ
      MOVE SR-F54 TO BAR-NAME PERFORM BAR-LAB-ORDER.
    INITIALIZE HL-REC MOVE SR-F52 TO HL-ORDSEQ MOVE SR-F55 TO HL-LINE.
    READ SHIPLIN REGARDLESS INVALID CONTINUE. MOVE HL-LABINF TO ED-LABINF.
    MOVE HL-PROD TO BAR-PROD A-A1 PERFORM PROD-RT.
    PERFORM DESC-ENG PERFORM RD-GEN MOVE 2 TO A-N1 PERFORM DESC-QUAL.
    MOVE " " TO BAR-DESC MOVE 1 TO BAR-QSER MOVE HL-DATE-REQ TO BAR-DATE.
    MOVE SR-F56 TO A-N1 PERFORM RD-SAORD PERFORM BAR-SHP-NAME.
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID826.
ID825. READ BINALLOC NEXT REGARDLESS END GO ID826. IF BA-NO NOT=HL-NO GO ID826.
    MOVE BA-LOT TO BAR-LOT MOVE BA-QTY-PACK TO BAR-QTY.
    PERFORM CALC-TWEIGHT COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * A-D1 * WEI-LB / 100.
    MOVE BA-CARTONS TO BAR-LABQTY PERFORM BAR-LAB-GMSHIP GO ID825.
ID826. IF HL-ERR=1 COMPUTE WN1=HL-QTY - HL-QTY-AL
      IF WN1>0 AND P-QTY-PACK>0 DIVIDE P-QTY-PACK INTO WN1 ROUNDED ADD 1 TO WN1
        MOVE 0 TO BAR-LOT MOVE P-QTY-PACK TO BAR-QTY
        PERFORM CALC-TWEIGHT COMPUTE BAR-WEIGHT ROUNDED=BAR-QTY * A-D1 * WEI-LB / 100
        MOVE WN1 TO BAR-LABQTY PERFORM BAR-LAB-GMSHIP.
    GO ID823.
ID829. PERFORM BAR-LAB-SPACER PERFORM CLOSE-LAB.

    MOVE 8 TO LAB-FLN PERFORM OPEN-LAB.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO ID839.
ID833. READ SORTFL NEXT END GO ID839. IF SR-F51 NOT=3 GO ID833.
    MOVE SR-F52 TO HO-ORDSEQ READ SHIPORD REGARDLESS INVALID GO ID833.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO ID833.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO ID833.
    MOVE SR-F52 TO HL-ORDSEQ MOVE SR-F55 TO HL-LINE.
    READ SHIPLIN REGARDLESS INVALID GO ID833.
    MOVE HL-PROD TO A-A1 PERFORM PROD-RD PERFORM DESC-ENG PERFORM RD-GEN.
    MOVE HO-DXNO TO A-N1 PERFORM DX-RD-AMAX PERFORM DX-SET-CNUM.
    PERFORM VARYING DX-IXP FROM 1 BY 1 UNTIL DX-IXP>30 OR ED-AKAN(DX-IXP)=" "
      MOVE 0 TO ED-ASERIAL(DX-IXP)
      PERFORM VARYING DX-IXL FROM 1 BY 1 UNTIL DX-IXL>5
      MOVE 0 TO ED-ACARTONS(DX-IXP,DX-IXL) ED-ALOT(DX-IXP,DX-IXL) END-PERFORM END-PERFORM.

* note 213
    PERFORM OPEN-SORC INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID8348.
ID8343. READ BINALLOC NEXT REGARDLESS END GO ID8348. IF BA-NO NOT=HL-NO GO ID8348.
    MOVE 0 TO WN1 MOVE " " TO SC-KEY START SORCFL KEY>SC-KEY INVALID GO ID8346.
ID8345. READ SORCFL NEXT END GO ID8346.
    IF SC-F2=BA-LOT COMPUTE WN1=9999 - SC-F1 DELETE SORCFL GO ID8346. GO ID8345.
ID8346. ADD BA-CARTONS TO WN1 COMPUTE SC-F1=9999 - WN1 MOVE BA-LOT TO SC-F2.
    WRITE SC-RECORD GO ID8343.
ID8348.

    MOVE 0 TO DX-IXP.
    MOVE " " TO SC-KEY START SORCFL KEY>SC-KEY INVALID GO ID8358.
ID8351. READ SORCFL NEXT END GO ID8358. COMPUTE WN1=9999 - SC-F1.
ID8353. ADD 1 TO DX-IXP IF DX-IXP>30 OR ED-AKAN(DX-IXP)=" " GO ID8358.
    COMPUTE A-N1=DX-CNUM + 1 PERFORM BAR-SET-SERIAL MOVE BAR-SERIAL TO ED-ASERIAL(DX-IXP).
    MOVE 1 TO DX-IXL MOVE DX-CNUM TO WN2.
ID8355. IF WN2<=WN1 MOVE WN2 TO ED-ACARTONS(DX-IXP,DX-IXL)
      MOVE SC-F2 TO ED-ALOT(DX-IXP,DX-IXL)
      SUBTRACT WN2 FROM WN1 IF WN1=0 GO ID8351 ELSE GO ID8353.
    MOVE WN1 TO ED-ACARTONS(DX-IXP,DX-IXL) MOVE SC-F2 TO ED-ALOT(DX-IXP,DX-IXL).
    SUBTRACT WN1 FROM WN2 ADD 1 TO DX-IXL IF DX-IXL>5 GO ID8353.
    READ SORCFL NEXT END GO ID8358. COMPUTE WN1=9999 - SC-F1 GO ID8355.
ID8358. PERFORM CLOSE-SORC.
    IF DX-NO>0 MOVE ED-AMAX-DATA TO DX-DATA REWRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX.
    PERFORM VARYING DX-IXP FROM 1 BY 1 UNTIL DX-IXP>30 OR ED-AKAN(DX-IXP)=" "
      MOVE 0 TO DX-SERIAL PERFORM DX-LAB-AMAX END-PERFORM.
    GO ID833.
ID839. PERFORM CLOSE-LAB.
    CLOSE SOLDTO DELJITEX PERFORM CLOSE-REP PERFORM CLOSE-SORT.
ID9. EXIT.

ID-ALLOC. PERFORM ID-A1 THRU ID-A9.
ID-A1. MOVE " " TO B-KEY START BIN KEY>B-KEY REGARDLESS INVALID GO ID-A14.
ID-A13. READ BIN NEXT REGARDLESS END GO ID-A14.
    IF B-QTY-AL NOT=0 MOVE 0 TO B-QTY-AL REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    GO ID-A13.
ID-A14. MOVE " " TO BA-KEY START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID-A16.
ID-A15. READ BINALLOC NEXT REGARDLESS END GO ID-A16.
    IF BA-IND NOT=0 MOVE 0 TO BA-IND REWRITE BA-RECORD ALLOWING NO UNLOCK BINALLOC.
    GO ID-A15.
ID-A16.

* note 21
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO ID-A29.
ID-A23. READ SHIPORD NEXT REGARDLESS END GO ID-A29. IF NOT(HO-IND>=1 AND<=3) GO ID-A23.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO ID-A28.
ID-A25. READ SHIPLIN NEXT REGARDLESS END GO ID-A28. IF HL-ORDSEQ NOT=HO-ORDSEQ GO ID-A28.
    IF HO-IND=1 OR 2 MOVE 0 TO HL-QTY-AL HL-WEIGHT-AL HL-QTY-NAL HL-WEIGHT-NAL
      REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO ID-A278.
* ho-ind=3
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID-A278.
ID-A273. READ BINALLOC NEXT REGARDLESS END GO ID-A278. IF BA-NO NOT=HL-NO GO ID-A278.
    IF BA-QTY=0 GO ID-A273.
    MOVE BA-BIN TO B-NO READ BIN REGARDLESS INVALID GO ID-A274.
    ADD BA-QTY TO B-QTY-AL REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
ID-A274. MOVE 1 TO BA-IND REWRITE BA-RECORD ALLOWING NO UNLOCK BINALLOC GO ID-A273.
ID-A278. GO ID-A25.
ID-A28. GO ID-A23.
ID-A29.

    MOVE " " TO WA1.
ID-A43. MOVE WA1 TO BA-KEY MOVE 0 TO IX1.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO ID-A49.
ID-A45. READ BINALLOC NEXT REGARDLESS END GO ID-A49. MOVE BA-KEY TO WA1.
    IF BA-IND=1 GO ID-A45. DELETE BINALLOC ADD 1 TO IX1 IF IX1<100 GO ID-A45.
    CLOSE BINALLOC OPEN I-O BINALLOC ALLOWING ALL GO ID-A43.
ID-A49.

    MOVE " " TO HO-KV START SHIPORD KEY>HO-KV REGARDLESS INVALID GO ID-A58.
ID-A5. READ SHIPORD NEXT REGARDLESS END GO ID-A58.
    IF HO-BIND=1 OR HO-IND NOT=2 GO ID-A5.
    MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO ID-A5.
    MOVE C-AUTO TO AUTO-CODE IF AUTO-GMC AND ID-KGM=0 GO ID-A5.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO ID-A56.
ID-A53. READ SHIPLIN NEXT REGARDLESS END GO ID-A56. IF HL-ORDSEQ NOT=HO-ORDSEQ GO ID-A56.
    MOVE HL-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO ID-A53. PERFORM RD-GEN.
    MOVE HL-QTY-ALPREV TO ID-TQTY MOVE 0 TO PRO-NIND PERFORM ID-ALLOC-LINE.
    IF GEN-NUT>" "
      MOVE GEN-NUT TO P-NO READ PRODUCT REGARDLESS INVALID GO ID-A54 END-READ
      MOVE HL-QTY-NALPREV TO ID-TQTY MOVE 1 TO PRO-NIND PERFORM ID-ALLOC-LINE.
ID-A54. REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN GO ID-A53.
ID-A56. GO ID-A5.
ID-A58.
ID-A9. EXIT.

ID-ALLOC-LINE. PERFORM ID-L1 THRU ID-L9.
ID-L1. MOVE 0 TO ID-AQTY ID-OLD ID-ERR.
    IF ID-TQTY=0 MOVE 1 TO ID-ERR GO ID-L8.

    IF NOT((P-CAT=21 OR 22) AND (P-PACKING=1 OR 2 OR 13)) GO ID-L4.
    IF P-PACKING=1 MOVE 27 TO ID-CARTONS. IF P-PACKING=2 MOVE 36 TO ID-CARTONS.
    IF P-PACKING=13 MOVE 24 TO ID-CARTONS.
    DIVIDE ID-TQTY BY P-QTY-PACK GIVING A-N1 REMAINDER A-N2 SIZE ERROR GO ID-L4.
    IF A-N2 NOT=0 GO ID-L4.
    DIVIDE A-N1 BY ID-CARTONS GIVING ID-PALLETS REMAINDER A-N2.
    IF A-N2 NOT=0 GO ID-L4.

    INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO ID-L32.
ID-L31. READ BIN NEXT REGARDLESS END GO ID-L32. IF B-PROD NOT=P-NO GO ID-L32.
    IF B-IND NOT=0 MOVE 0 TO B-IND REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    GO ID-L31.
ID-L32. MOVE ID-PALLETS TO ID-BINS INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO ID-L34.
ID-L33. READ BIN NEXT REGARDLESS END GO ID-L34. IF B-PROD NOT=P-NO GO ID-L34.
    IF NOT(B-QTY-AL=0 AND B-QTY=ID-CARTONS * B-QTY-PACK
      AND B-QTY-PACK=P-QTY-PACK AND B-CONT=HL-CONT) GO ID-L33.
    MOVE 1 TO B-IND REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    SUBTRACT 1 FROM ID-BINS IF ID-BINS>0 GO ID-L33.
ID-L34. IF ID-BINS>0 GO ID-L4.
    MOVE ID-PALLETS TO ID-BINS INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO ID-L38.
ID-L35. READ BIN NEXT REGARDLESS END GO ID-L38. IF B-PROD NOT=P-NO GO ID-L38.
    IF B-IND=0 GO ID-L35. PERFORM INIT-BA MOVE B-NO TO BA-BIN.
    MOVE P-NO TO BA-PROD MOVE B-LOT TO BA-LOT MOVE B-QTY-PACK TO BA-QTY-PACK.
    MOVE B-QTY TO BA-QTY MOVE ID-CARTONS TO BA-CARTONS.
    PERFORM ID-LWR SUBTRACT 1 FROM ID-BINS IF ID-BINS>0 GO ID-L35.
ID-L38. GO ID-L8.

ID-L4. MOVE 0 TO ID-PQTY INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO ID-L6.
ID-L5. COMPUTE ID-QTY=ID-TQTY - ID-AQTY IF ID-QTY<=0 GO ID-L62.
    READ BIN NEXT REGARDLESS END GO ID-L6. IF B-PROD NOT=P-NO GO ID-L6.
    IF B-CONT NOT=HL-CONT GO ID-L5. PERFORM INIT-BA MOVE B-NO TO BA-BIN.
    MOVE P-NO TO BA-PROD MOVE B-LOT TO BA-LOT MOVE B-QTY-PACK TO BA-QTY-PACK.
    COMPUTE ID-BQTY=B-QTY - B-QTY-AL IF ID-BQTY<=0 GO ID-L5.
* note 157
    IF GEN-NUT>" " COMPUTE BA-BN=PRO-NIND + 1
     IF PRO-NIND=0
      IF ID-QTY<ID-BQTY MOVE ID-QTY TO BA-QTY MOVE 1 TO BA-PARTIAL
        ELSE MOVE ID-BQTY TO BA-QTY END-IF
      MOVE 1 TO BA-CARTONS MOVE BA-QTY TO BA-QTY-PACK GO ID-L58.
* note 25
    IF BA-QTY-PACK=0
      IF ID-QTY<ID-BQTY MOVE ID-QTY TO BA-QTY ELSE MOVE ID-BQTY TO BA-QTY END-IF
      GO ID-L58.
    MOVE 0 TO BA-QTY.
ID-L53. IF BA-QTY + BA-QTY-PACK<=ID-BQTY
      ADD BA-QTY-PACK TO BA-QTY ADD 1 TO BA-CARTONS IF BA-QTY<ID-QTY GO ID-L53.
ID-L58. IF BA-QTY NOT=0 PERFORM ID-LWR. GO ID-L5.
ID-L6. MOVE 1 TO ID-ERR.
ID-L62. IF AUTO-GMC IF ID-AQTY<HL-QTY MOVE 1 TO ID-ERR.

ID-L8. IF PRO-NIND=0 MOVE ID-OLD TO HL-OLD MOVE ID-ERR TO HL-ERR
      MOVE ID-AQTY TO HL-QTY-AL
      COMPUTE HL-WEIGHT-AL ROUNDED=HL-QTY-AL * (P-WEIGHT + P-WEIGHT-NUT) / 100
     ELSE MOVE ID-OLD TO HL-NOLD MOVE ID-ERR TO HL-NERR
      MOVE ID-AQTY TO HL-QTY-NAL
      COMPUTE HL-WEIGHT-NAL ROUNDED=HL-QTY-NAL * P-WEIGHT / 100.
ID-L9. EXIT.
* note 207

ID-LWR. WRITE BA-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK BINALLOC.
    MOVE BA-LOT TO D-LOT PERFORM D-LOTDATE IF D-YEAR<=SYS-YEAR - 2 MOVE 1 TO ID-OLD.
    ADD BA-QTY TO ID-AQTY B-QTY-AL REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
ID-BLINE. PERFORM ID-BL1 THRU ID-BL9.
ID-BL1. IF ID-KB=1 PERFORM PR-LINE GO ID-BL9.
ID-BL3. READ BINALLOC NEXT REGARDLESS END GO ID-BL8.
    IF BA-NO NOT=HL-NO GO ID-BL8. IF BA-PROD NOT=P-NO GO ID-BL3.
* note 31
    IF WS-LINES>=ID-MAXLN MOVE PREC TO ID-PREC-SV MOVE " " TO PREC
      WRITE PREC AFTER PAGE PERFORM ID-PAGE MOVE ID-PREC-SV TO PREC.
* note 8.2
    IF BA-BIN="zzzzz" MOVE "DLOC, PLT.DOCK:" TO FA423
      MOVE ED-PKG11 TO FA424 MOVE ED-PKG12 TO FA425 GO ID-BL6.
    MOVE BA-BIN TO FA436 MOVE "(" TO FA437 MOVE BA-LOT TO FA438 MOVE ")" TO FA439.
    IF BA-BN=0 OR 2 MOVE BA-CARTONS TO FA440 MOVE "x" TO FA441 MOVE BA-QTY-PACK TO FA442.
    MOVE BA-QTY TO FA443 IF BA-PARTIAL=1 MOVE "P" TO FA444.
ID-BL6. PERFORM PR-LINE GO ID-BL9.
ID-BL8. MOVE 1 TO ID-KB IF ID-KL=0 PERFORM PR-LINE.
ID-BL9. EXIT.
ID-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 2 TO WS-PR PERFORM GET-CUSADD.
    MOVE CUS-LINE(1) TO FA401 PERFORM PR-LINE MOVE CUS-LINE(2) TO FA401 PERFORM PR-LINE.
    MOVE CUS-LINE(3) TO FA401 PERFORM PR-LINE MOVE CUS-LINE(4) TO FA401 PERFORM PR-LINE.
    MOVE CUS-LINE(5) TO FA401 PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE O-NAME TO FA401 PERFORM PR-LINE.
    MOVE O-ADD1 TO FA401 MOVE HO-CUSID TO FA416 PERFORM PR-LINE.
    MOVE O-ADD2 TO FA401 PERFORM PR-LINE MOVE O-POST TO FA398.
* note 26.2
    IF HO-DOCK>" " MOVE "DOCK" TO FA399 MOVE HO-DOCK TO FA400.
    IF HO-SHQUAL>" " MOVE HO-SHQUAL TO FA414
      MOVE HO-SHTIME TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO FA415.
    PERFORM PR-LINE MOVE O-PLINE(1) TO FA406 PERFORM PR-LINE.
    MOVE "PAGE" TO FA402 MOVE WS-PAGE TO FA403 MOVE "OF" TO FA404 MOVE ID-PGTOT TO FA405.
    MOVE O-PLINE(2) TO FA406 PERFORM PR-LINE MOVE 3 TO WS-PR.
    PERFORM GET-CUSORD MOVE A-A1 TO FA408.
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA409 MOVE HO-ORD TO FA410.
    MOVE HO-SEQ TO EXT-S PERFORM DSP-EXT MOVE EXT-D TO FA410A.
    MOVE O-TERMS TO FA411 MOVE O-CUS TO FA412.
    MOVE HO-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO FA413.
    PERFORM PR-LINE MOVE 3 TO WS-PR.
    MOVE C-GST TO FA417 MOVE C-PST TO FA418 MOVE O-FOB TO FA419.
    MOVE HO-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA420.
    IF O-PPD="P" OR "*" MOVE "*" TO FA421 ELSE MOVE "*" TO FA422.
    PERFORM PR-LINE-3.

* S-24 PREPARE BILLS OF LADING
IN1. PERFORM OPEN-AUDIT OPEN I-O CFORD ALLOWING ALL CFLIN ALLOWING ALL
       HTRANS ALLOWING ALL LOTHIST ALLOWING ALL.
    MOVE SYS-DATE TO IN-DATE.
IN13. PERFORM RD19 PERFORM WRT.
    PERFORM RD-INFO ADD 1 TO IF-BLNO PERFORM WR-INFO MOVE IF-BLNO TO IN-BL.
    MOVE IN-BL TO IN-DF4 DISPLAY IN-DF4 LINE 3 COLUMN 16.
    MOVE "'YES' TO START A NEW B/L: ___" TO TMSG PERFORM DSP-PROMPT.
* note 97.1
    IF XA3 NOT="YES" PERFORM RD-INFO
      IF IF-BLNO=IN-BL SUBTRACT 1 FROM IF-BLNO END-IF PERFORM WR-INFO GO IN9.
    MOVE LOW-VALUES TO FO-RECORD INITIALIZE FO-REC MOVE IN-BL TO FO-BL.
    MOVE " " TO IN-CUS MOVE 0 TO IN-TOT-NET IN-TOT-GROSS.
IN3. PERFORM RD19A PERFORM WRT MOVE 1 TO IX1.
    PERFORM VARYING IXT FROM 8 BY 1 UNTIL IXT>12
      DISPLAY WEI-PK(IX1) LINE IXT COLUMN 2 ADD 1 TO IX1 END-PERFORM.
    PERFORM VARYING IXT FROM 8 BY 1 UNTIL IXT>11
      DISPLAY WEI-PK(IX1) LINE IXT COLUMN 35 ADD 1 TO IX1 END-PERFORM.
    INITIALIZE TD-INP-R6 MOVE 0 TO IN-NET IN-GROSS IN-CTYPE.
    MOVE IN-BL TO IN-DF4 DISPLAY IN-DF4 LINE 1 COLUMN 74.
    ACCEPT HO-ORD LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF NOT(KPF4 OR HO-ORD=999999) GO IN32.
    MOVE "'YES' TO CONFIRM THE END OF THIS B/L: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="YES" IF FO-LINES=0 GO IN13 ELSE GO IN88. GO IN3.
IN32. MOVE HO-ORD TO A-N1 MOVE 3 TO IXT MOVE 22 TO IXU PERFORM RD-EXT IF A-N1=0 GO IN3.
* note 37
    IF FO-LINES=0 MOVE HO-CUS TO IN-CUS
      ELSE IF HO-CUS NOT=IN-CUS MOVE "THIS ORDER BELONGS TO A DIFFERENT CUSTOMER" TO ERR-MESG
             PERFORM DSP-OK IF XA2="OK" MOVE HO-CUS TO IN-CUS ELSE GO IN3.
    IF HO-IND NOT=3 MOVE "ORDER STATUS IS NOT 3" TO ERR-MESG PERFORM DSP-ERR GO IN3.
    MOVE IN-BL TO IE601 MOVE HO-ORD TO IE602 O-NO READ SAORD REGARDLESS INVALID GO IN3.
    MOVE HO-CUS TO A-A1 PERFORM RD-CUS.
    IF FO-LINES=0 AND C-AUTO>0
      MOVE O-NO TO PL-ORD FO-ORD READ PLANT REGARDLESS KEY PL-KO INVALID
        MOVE "THERE IS NO PLANT RECORD WITH THIS ORDER NO." TO ERR-MESG
        PERFORM DSP-ERR GO IN3.
IN33. PERFORM RD-INFO ADD 1 TO IF-INVNO PERFORM WR-INFO.
    MOVE IF-INVNO TO IN-INVNO TR-INV.
    START TRANS KEY=TR-KI REGARDLESS INVALID GO IN34. GO IN33.
IN34. MOVE IN-INVNO TO IN-DF4 DISPLAY IN-DF4 LINE 2 COLUMN 74.
    PERFORM CHK-CUSTYPE MOVE C-NO TO A-A1 PERFORM CHK-CUSFORM.
    IF FO-LINES>0 DISPLAY LIT-SP(1:13) LINE 5 COLUMN 1.
    IF FO-LINES>0 OR CFO-IND=0 DISPLAY " " LINE 15 ERASE LINE " " LINE 16 ERASE LINE.

IN35. IF FO-LINES=0 MOVE HO-VIA TO IE603 ELSE MOVE FO-VIA TO IE603.
    DISPLAY IE603 LINE 3 COLUMN 51.
    MOVE IE603 TO SV-KEY PERFORM RD-VIA DISPLAY SV-CARRIER(1:30) LINE 4 COLUMN 51.
    IF FO-LINES=0 MOVE 0 TO IE607 DISPLAY "___" LINE 5 COLUMN 11.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 MOVE 0 TO IE605(IX1) END-PERFORM.
    PERFORM VARYING IXT FROM 8 BY 1 UNTIL IXT>12 DISPLAY "____" LINE IXT COLUMN 20 END-PERFORM.
    PERFORM VARYING IXT FROM 8 BY 1 UNTIL IXT>11 DISPLAY "____" LINE IXT COLUMN 53 END-PERFORM.
    IF FO-LINES=0 AND CFO-IND=1
      MOVE "MI" TO IE608 DISPLAY IE608 LINE 16 COLUMN 9
      MOVE "DETROIT" TO IE610 DISPLAY IE610 LINE 16 COLUMN 32
      MOVE "WINDSOR" TO IE612 DISPLAY IE612 LINE 16 COLUMN 60.

    IF FO-LINES=0 ACCEPT IE603 LINE 3 COLUMN 51 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY IE603 LINE 3 COLUMN 51
      MOVE IE603 TO SV-KEY PERFORM RD-VIA DISPLAY SV-CARRIER(1:30) LINE 4 COLUMN 51.
    IF FO-LINES=0 ACCEPT IE607 LINE 5 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 1 TO IX1 DISPLAY "- PF3 TO END PACKING DATA" LINE 24 COLUMN 55 BOLD.
    PERFORM VARYING IXT FROM 8 BY 1 UNTIL IXT>12
      ACCEPT IE605(IX1) LINE IXT COLUMN 20 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY
      IF KPF3 GO IN36 END-IF ADD 1 TO IX1 END-PERFORM.
    PERFORM VARYING IXT FROM 8 BY 1 UNTIL IXT>11
      ACCEPT IE605(IX1) LINE IXT COLUMN 53 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY
      IF KPF3 GO IN36 END-IF ADD 1 TO IX1 END-PERFORM.
IN36. PERFORM DSP-ERS.
    IF FO-LINES=0 AND CFO-IND=1
      ACCEPT IE608 LINE 16 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      ACCEPT IE610 LINE 16 COLUMN 32 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      ACCEPT IE612 LINE 16 COLUMN 60 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE "'CAN' TO CANCEL AND REENTER THESE FIELDS: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" GO IN35.

    MOVE IN-BL TO HO-BL HO-SID MOVE IN-INVNO TO HO-INVNO MOVE IE603 TO HO-VIA.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 MOVE IE605(IX1) TO HO-PACKS(IX1) END-PERFORM.
    MOVE IE607 TO HO-PALLETS.
    MOVE TD-INP-R6 TO AU-DATA MOVE 6 TO AU-K MOVE 0 TO AU-L PERFORM ADD-AUD.

    IF FO-LINES>0 GO IN38.
    MOVE HO-SID TO FO-SID MOVE HO-INVNO TO FO-INVNO.
    MOVE O-CUS TO FO-CUS MOVE O-SHIPTO TO FO-SHIPTO MOVE O-NAME TO FO-NAME.
    MOVE O-ADD1 TO FO-ADD1 MOVE O-ADD2 TO FO-ADD2 MOVE O-POST TO FO-POST.
    MOVE O-DATE TO FO-DATE MOVE IN-DATE TO FO-INV-DATE MOVE O-FOB TO FO-FOB.
    MOVE O-PAYER TO FO-PAYER.
    MOVE "TL" TO FO-EQCODE MOVE " " TO FO-EQNUM FO-EQINIT.
    MOVE HO-VIA TO FO-VIA SV-KEY PERFORM RD-VIA.
    MOVE SV-EQNUM TO FO-EQNUM MOVE SV-EQINIT TO FO-EQINIT.
    IF FO-EQINIT=" " MOVE SV-SCAC TO FO-EQINIT.
    MOVE 8.50 TO FO-FRATE MOVE "S" TO FO-ETRESP MOVE " " TO FO-ETNUM FO-CARRID.
    MOVE IE608 TO FO-STATE MOVE IE610 TO FO-ENTRY MOVE IE612 TO FO-BORDER.
    MOVE HO-PALLETS TO FO-PALLETS.
IN38. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 ADD HO-PACKS(IX1) TO FO-PACKS(IX1) END-PERFORM.
    MOVE HO-DOCK TO FO-DOCK MOVE HO-DXNO TO FO-DXNO.

IN5. PERFORM RD19B PERFORM WRT INITIALIZE TD-INP-R6A.
    MOVE HO-ORD TO IN-DF1 DISPLAY IN-DF1 LINE 1 COLUMN 48.
    MOVE IN-BL TO IN-DF4 DISPLAY IN-DF4 LINE 1 COLUMN 74.
    MOVE IN-INVNO TO IN-DF4 DISPLAY IN-DF4 LINE 2 COLUMN 74.
    ACCEPT IN-PROD LINE 6 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 OR IN-PROD=ALL "9" GO IN6. IF IN-PROD=" " GO IN5.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO IN516.
IN513. READ SHIPLIN NEXT REGARDLESS END GO IN516. IF HL-ORDSEQ NOT=HO-ORDSEQ GO IN516.
    MOVE HL-PROD TO A-A1 PERFORM PROD-RT.
    IF P-GEN>" " AND P-NUT>" "
      IF P-GEN=IN-PROD MOVE 0 TO PRO-NIND GO IN518
        ELSE IF P-NUT=IN-PROD MOVE 1 TO PRO-NIND GO IN518 END-IF
     ELSE IF HL-PROD=IN-PROD MOVE 0 TO PRO-NIND GO IN518.
    GO IN513.
IN516. MOVE "THERE IS NO LINE WITH THIS PRODUCT" TO ERR-MESG PERFORM DSP-ERR.
    GO IN5.
* note 267
IN518. IF NOT(ITOOL OR HL-QTY-AL>0 OR HL-PROD="H")
      MOVE "THIS PRODUCT WAS NOT ALLOCATED" TO ERR-MESG
      PERFORM DSP-OK IF XA2 NOT="OK" GO IN5.
    MOVE P-GEN TO IN-GEN MOVE IN-PROD TO IE621.

    IF PRO-NIND=0 MOVE HL-QTY-AL TO IN-QTY-AL ELSE MOVE HL-QTY-NAL TO IN-QTY-AL.
    MOVE IN-QTY-AL TO IN-DF3 DISPLAY IN-DF3 LINE 8 COLUMN 58.
    IF HL-PROD="H" GO IN56. DISPLAY IN-DF3 COLUMN 70 MOVE 0 TO IN-IXA.
IN53. ACCEPT IN-BIN LINE 6 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED ERASE END LINE KEY CKEY.
    IF KPF4 OR IN-BIN=ALL "9" GO IN56. IF IN-BIN=" " GO IN53.
    MOVE IN-BIN TO B-NO READ BIN REGARDLESS INVALID PERFORM DSP-ERR7 GO IN53.
    MOVE B-LOT TO IN-LOT IN-DF5 DISPLAY IN-DF5 LINE 6 COLUMN 22.
    MOVE 0 TO WS2 IF ITOOL GO IN54.
    IF NOT(B-PROD=IN-PROD OR IN-GEN) MOVE 1 TO WS2
      MOVE "THIS BIN CONTAINS A DIFFERENT PRODUCT" TO ERR-MESG
      PERFORM DSP-OK IF XA2 NOT="OK" GO IN53.
* note 227
IN535. ACCEPT IN-LOT LINE 6 COLUMN 22 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE IN-LOT TO IN-DF5 DISPLAY IN-DF5 LINE 6 COLUMN 22.
    MOVE IN-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO IN535.
    IF LT-QUAR=1 PERFORM DSP-ERR44 GO IN535.
    IF NOT(LT-PROD=IN-PROD OR IN-GEN) MOVE "THIS LOT IS FOR A DIFFERENT PRODUCT"
      TO ERR-MESG PERFORM DSP-ERR GO IN535.
IN54. PERFORM INIT-BA MOVE IN-BIN TO BA-BIN.
    READ BINALLOC REGARDLESS INVALID MOVE 0 TO WS1
      MOVE IN-PROD TO BA-PROD MOVE IN-LOT TO BA-LOT MOVE 0 TO IN-QTY
      COMPUTE BA-BN=PRO-NIND + 1 GO IN542.
    MOVE BA-QTY TO IN-QTY MOVE 1 TO WS1.
IN542. MOVE IN-QTY TO IN-DF2 DISPLAY IN-DF2 LINE 6 COLUMN 31.
    ACCEPT IN-QTY-NEW LINE 6 COLUMN 42 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    SUBTRACT IN-QTY FROM B-QTY-AL IN-QTY-AL IF B-QTY-AL<0 MOVE 0 TO B-QTY-AL.
    ADD IN-QTY-NEW TO B-QTY-AL IN-QTY-AL MOVE IN-QTY-NEW TO BA-QTY.
    MOVE IN-QTY-AL TO IN-DF3 DISPLAY IN-DF3 LINE 8 COLUMN 70.
    IF WS2=0 REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    IF WS1=1 REWRITE BA-RECORD ALLOWING NO ELSE WRITE BA-RECORD ALLOWING NO. UNLOCK BINALLOC.
    IF BA-QTY=0 DELETE BINALLOC.
    ADD 1 TO IN-IXA IF IN-IXA<=23 MOVE IN-BIN TO IE623(IN-IXA)
      MOVE IN-QTY TO IE624(IN-IXA) MOVE IN-QTY-NEW TO IE625(IN-IXA)
      MOVE IN-LOT TO IE626(IN-IXA).
    GO IN53.
IN56. IF PRO-NIND=0 MOVE IN-QTY-AL TO HL-QTY-AL ELSE MOVE IN-QTY-AL TO HL-QTY-NAL.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    MOVE TD-INP-R6A TO AU-DATA MOVE 6 TO AU-K MOVE HL-LINE TO AU-L PERFORM ADD-AUD.
    IF ITOOL PERFORM IN-ITJADD.
    GO IN5.

IN6. IF O-CUS="15300" MOVE 1 TO IN-CTYPE
      ELSE IF O-CUS="07251" MOVE 2 TO IN-CTYPE ELSE GO IN62.
    IF IN-CTYPE=1 MOVE "BUCKETS" TO IN-CDESC MOVE "B" TO IN-CPROD
      MOVE 35 TO IN-CPRICE MOVE 0 TO IN-CWEIGHT.
    IF IN-CTYPE=2 MOVE "CRATES" TO IN-CDESC MOVE "C" TO IN-CPROD
      MOVE 55 TO IN-CPRICE MOVE 70 TO IN-CWEIGHT.
    MOVE " " TO WA1 STRING "NUMBER OF " IN-CDESC " SHIPPED: ____"
      DELIMITED SIZE INTO WA1 DISPLAY WA1 LINE 10 BOLD.
    MOVE " " TO WA1 STRING "(" IN-CDESC " LINE WILL BE ADDED TO THE ORDER AUTOMATICALLY)"
      DELIMITED SIZE INTO WA1 DISPLAY WA1 LINE 11.
    ACCEPT IN-CNUM LINE 10 COLUMN 28 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF IN-CNUM=0 MOVE 0 TO IN-CTYPE GO IN62. COMPUTE L-NO=100 * O-NO.
IN613. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO IN614.
    IF L-PROD NOT=IN-CPROD GO IN613.
    MOVE 94 TO L-CAT MOVE IN-CPRICE TO L-PRICE MOVE "EA" TO L-MODE.
    MOVE IN-CNUM TO L-QTY L-QTY-LEFT REWRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    PERFORM INIT-HL MOVE IN-CNUM TO HL-QTY HL-QTY-AL.
    WRITE HL-RECORD ALLOWING NO INVALID REWRITE HL-RECORD ALLOWING NO. UNLOCK SHIPLIN.
    GO IN62.
IN614. IF L-LINE>98 MOVE " " TO ERR-MESG
      STRING IN-CDESC " LINE NOT ADDED - TOO MANY LINES IN ORDER"
        DELIMITED SIZE INTO ERR-MESG PERFORM DSP-ERR MOVE 0 TO IN-CTYPE GO IN62.
    MOVE L-LINE TO WN1 PERFORM INIT-L MOVE O-NO TO L-ORD MOVE WN1 TO L-LINE.
    MOVE O-DATE-REQ TO L-DATE-REQ MOVE O-TER TO L-TER MOVE O-CUS TO L-CUS.
    MOVE O-SPECIAL TO L-SPECIAL MOVE IN-CPROD TO L-PROD MOVE 94 TO L-CAT.
    MOVE IN-CPRICE TO L-PRICE MOVE "EA" TO L-MODE MOVE IN-CNUM TO L-QTY L-QTY-LEFT.
    WRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    PERFORM INIT-HL MOVE IN-CNUM TO HL-QTY HL-QTY-AL.
    WRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
IN62.

    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO IN8.
IN63. READ SHIPLIN NEXT REGARDLESS END GO IN8. IF HL-ORDSEQ NOT=HO-ORDSEQ GO IN8.
    IF HL-QTY-AL=0 AND HL-PROD NOT="H" GO IN63.
    MOVE HL-ORD TO L-ORD MOVE HL-LINE TO L-LINE READ SALIN REGARDLESS INVALID GO IN63.
* note 45
    MOVE HL-QTY-AL TO L-QTY-THIS MOVE L-PROD TO A-A1 PERFORM PROD-GEN.
    IF L-QTY=LIT-Q9 ADD L-QTY-THIS TO L-QTY-LEFT
      ELSE SUBTRACT L-QTY-THIS FROM L-QTY-LEFT IF L-QTY-LEFT<0 MOVE 0 TO L-QTY-LEFT.
    MOVE L-QTY-THIS TO CL-QTY PERFORM WEIGHT-CALC MOVE CL-WEIGHT-I TO L-WEIGHT.
    IF L-NUT>" "
      IF GEN-NUT=" " MOVE P-WEIGHT-NUT TO WD1 ELSE MOVE GEN-WEIGHT-NUT TO WD1 END-IF
      COMPUTE L-WEIGHT-NUT ROUNDED=CL-QTY * WD1 / 100.
    PERFORM LPRICE-CALC PERFORM PLATING-CALC PERFORM SURCH-CALC.
    IF L-ADJ=1 MOVE L-EXTA TO CL-AMT. MOVE CL-AMT TO L-EXTA.
    ADD L-WEIGHT L-WEIGHT-NUT TO IN-NET IN-GROSS.

* note 208
    MOVE LOW-VALUES TO FL-RECORD INITIALIZE FL-REC MOVE IN-BL TO FL-BL MOVE 1 TO FL-SEQ.
    MOVE IN-INVNO TO FL-PKSLIP MOVE L-PROD TO FL-PROD MOVE L-QTY-THIS TO FL-QTY.
    MOVE L-QTY-LEFT TO FL-QTY-CUM MOVE L-RC TO FL-RC MOVE L-MODYR TO FL-MODYR.
    MOVE L-EXTA TO FL-EXT MOVE L-MODE TO FL-MODE A-A1 PERFORM RD-MODE.
    COMPUTE FL-PRICE ROUNDED=L-EXTA * A-N1 / L-QTY-THIS.
    PERFORM GET-CUSORD MOVE A-A1 TO FL-CUSORD MOVE HO-DXNO TO FL-DXNO.

* note 206
    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO IN66.
IN65. READ BINALLOC NEXT REGARDLESS END GO IN66. IF BA-NO NOT=HL-NO GO IN66.
    MOVE BA-LOT TO A-N1 PERFORM RD-LOT.
    IF BA-BN=0 OR 1 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1.
    PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>3
     IF FL-COUNTRY(IX1,IX2)=LT-COUNTRY OR FL-CQTY(IX1,IX2)=0
       MOVE LT-COUNTRY TO FL-COUNTRY(IX1,IX2)
       ADD BA-QTY TO FL-CQTY(IX1,IX2) GO IN658 END-IF END-PERFORM.
IN658. GO IN65.
IN66.
IN67. WRITE FL-RECORD ALLOWING NO INVALID ADD 1 TO FL-SEQ GO IN67. UNLOCK CFLIN.
    ADD 1 TO FO-LINES ADD FL-EXT TO FO-TOTAL ADD FL-QTY TO FO-TQTY.

    INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO IN78.
IN73. READ BINALLOC NEXT REGARDLESS END GO IN78. IF BA-NO NOT=HL-NO GO IN78.
    MOVE BA-BIN TO B-NO READ BIN REGARDLESS INVALID GO IN74. IF B-PROD=" " GO IN74.
* note 138
    MOVE LOW-VALUES TO PE-RECORD INITIALIZE PE-REC MOVE "SHP" TO PE-TRANS.
    MOVE B-PROD TO PE-PROD MOVE SYS-DATE TO PE-DATE ACCEPT PE-TIME FROM TIME.
    MOVE BA-BIN TO PE-FBIN MOVE BA-LOT TO PE-LOT.
    MOVE BA-QTY TO PE-QTY MOVE BA-QTY-PACK TO PE-QTY-PACK.
    MOVE BA-CARTONS TO PE-CARTONS MOVE B-CONT TO PE-CONT.
    WRITE PE-RECORD ALLOWING NO UNLOCK PRODTRANS.
    SUBTRACT BA-QTY FROM B-QTY B-QTY-AL IF B-QTY-AL<0 MOVE 0 TO B-QTY-AL.
    PERFORM CHK-BIN-EMPTY REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
IN74.

    IF ITOOL OR NOT(C-MTEST=0 AND CAU-IND=0 AND P-CAT<90 AND (BA-BN=0 OR 1)) GO IN76.
    MOVE LOW-VALUES TO HT-RECORD INITIALIZE HT-REC.
    MOVE IN-INVNO TO HT-INV MOVE HL-LINE TO HT-LN.
    MOVE BA-LOT TO HT-LOT D-LOT PERFORM D-LOTDATE MOVE D-YEAR TO HT-LYEAR.
    PERFORM GET-CUSORD MOVE A-A1 TO HT-CUSORD MOVE IN-BL TO HT-BL.
    MOVE O-CUS TO HT-CUS MOVE O-SHIPTO TO HT-SHIPTO MOVE O-NAME TO HT-NAME.
    MOVE O-ADD1 TO HT-ADD1 MOVE O-ADD2 TO HT-ADD2 MOVE O-POST TO HT-POST.
    MOVE L-PROD TO HT-PROD MOVE BA-QTY TO HT-QTY MOVE L-CUSPART TO HT-CUSPART.
    WRITE HT-RECORD ALLOWING NO INVALID READ HTRANS REGARDLESS
      ADD BA-QTY TO HT-QTY REWRITE HT-RECORD ALLOWING NO. UNLOCK HTRANS.
IN76.

    MOVE LOW-VALUES TO LN-RECORD INITIALIZE LN-REC.
    MOVE O-CUS TO LN-CUS MOVE SYS-DATE TO LN-DATE ACCEPT LN-TIME FROM TIME.
    MOVE BA-LOT TO LN-LOT MOVE IN-INVNO TO LN-INV.
    MOVE BA-PROD TO LN-PROD MOVE BA-QTY TO LN-QTY MOVE BA-QTY-PACK TO LN-QTY-PACK.
    MOVE BA-CARTONS TO LN-CARTONS MOVE BA-PARTIAL TO LN-PARTIAL MOVE BA-ORD TO LN-ORD.
    MOVE IN-BL TO LN-BL PERFORM GET-CUSORD MOVE A-A1 TO LN-CUSORD.
    MOVE O-SHIPTO TO LN-SHIPTO WRITE LN-RECORD ALLOWING NO UNLOCK LOTHIST.
    GO IN73.
IN78.

    MOVE 0 TO WN1 INITIALIZE BA-KEY MOVE HL-NO TO BA-NO.
    START BINALLOC KEY>BA-KEY REGARDLESS INVALID GO IN784.
IN783. READ BINALLOC NEXT REGARDLESS END GO IN784. IF BA-NO NOT=HL-NO GO IN784.
    ADD BA-QTY TO WN1 GO IN783.
IN784. PERFORM RDLK-PRODUCT SUBTRACT WN1 FROM P-HAND.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    GO IN63.

IN8. COMPUTE IN-GROSS=IN-GROSS + HO-PALLETS * WEI-PALLET.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      COMPUTE IN-GROSS=IN-GROSS + HO-PACKS(IX1) * WEI-WT(IX1) END-PERFORM.
    IF IN-CTYPE>0 COMPUTE IN-GROSS=IN-GROSS + IN-CNUM * IN-CWEIGHT.
    ADD IN-NET TO IN-TOT-NET ADD IN-GROSS TO IN-TOT-GROSS.
    MOVE IN-NET TO HO-NET MOVE IN-GROSS TO HO-GROSS.
    IF C-AUTO>0 MOVE 4 TO HO-IND ELSE MOVE 5 TO HO-IND.
    REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    IF IN-CTYPE>0 MOVE HO-ORD TO O-NO READ SAORD REGARDLESS
      ADD 1 TO O-LINES REWRITE O-RECORD ALLOWING NO UNLOCK SAORD.
    GO IN3.
IN88. COMPUTE FO-NET ROUNDED=IN-TOT-NET * WEI-LB.
    COMPUTE FO-GROSS ROUNDED=IN-TOT-GROSS * WEI-LB.
    WRITE FO-RECORD ALLOWING NO UNLOCK CFORD.
    GO IN13.
IN9. CLOSE AUDIT CFORD CFLIN HTRANS LOTHIST GO MN9.

IN-ITJADD. PERFORM IN-IT1 THRU IN-IT9.
IN-IT1. MOVE HL-ORD TO R-NO READ PRODORD REGARDLESS INVALID GO IN-IT4.
    PERFORM IN-ITJAR GO IN-IT9.
IN-IT4. IF HL-ORD>99999 GO IN-IT9.
    COMPUTE R-NO=10 * HL-ORD START PRODORD REGARDLESS INVALID GO IN-IT6.
IN-IT5. READ PRODORD NEXT REGARDLESS END GO IN-IT6. IF R-NO(1:5)>HL-ORD(1:5) GO IN-IT6.
    PERFORM IN-ITJAR GO IN-IT5.
IN-IT6.
IN-IT9. EXIT.
IN-ITJAR. PERFORM INIT-J MOVE R-NO TO J-NO MOVE 850 TO J-MAC.
    MOVE R-PROD TO J-PROD MOVE HL-QTY-AL TO J-QTY.
    PERFORM SET-JKD WRITE J-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK WORKSHEET.

* S-25 MARK COMPLETED SHIPMENTS
LM1. OPEN I-O CFORD ALLOWING ALL.
LM3. PERFORM RD53 PERFORM WRT.
LM31. ACCEPT FO-BL LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR FO-BL=9999999 GO LM9. IF FO-BL=0 GO LM31.
    READ CFORD REGARDLESS INVALID PERFORM DSP-ERR13 GO LM31.
    DISPLAY "'YES' TO CONFIRM SHIPMENT" LINE 24 BOLD.
LM33. ACCEPT XA3 LINE 3 COLUMN 33 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF NOT(XA3=" " OR "YES" OR "NO") PERFORM DSP-ERR14 GO LM33.
    IF XA3 NOT="YES" GO LM3. MOVE 1 TO FO-IND.
    DISPLAY FO-EQINIT LINE 5 COLUMN 40 FO-EQNUM COLUMN 64.
    DISPLAY FO-ETRESP LINE 7 COLUMN 52.
    ACCEPT FO-EQINIT LINE 5 COLUMN 40 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT FO-EQNUM LINE 5 COLUMN 64 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT FO-ETRESP LINE 7 COLUMN 52 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT FO-ETNUM LINE 7 COLUMN 67 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT FO-CARRID LINE 9 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE FO-BL TO HO-BL START SHIPORD KEY=HO-KB REGARDLESS INVALID GO LM46.
LM43. READ SHIPORD NEXT REGARDLESS END GO LM46. IF HO-BL NOT=FO-BL GO LM46.
    IF HO-IND=4 MOVE 5 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LM43.
LM46. REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD GO LM3.
LM9. CLOSE CFORD GO MN9.

* S-26 INVOICE SHIPPED ORDERS
LV1. PERFORM RD338 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM LV-PAGE.
    OPEN I-O SALTOT ALLOWING ALL TMPORD ALLOWING ALL TMPLIN ALLOWING ALL.
    PERFORM OPEN-TRAUDIT PERFORM RDR-INFO MOVE SYS-DATE TO LV-DATE.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO LV9.
LV3. READ SHIPORD NEXT REGARDLESS END GO LV9. IF HO-IND NOT=5 GO LV3.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO LV3.
    MOVE LV-DATE TO O-INV-DATE.
    MOVE HO-BL TO O-BL MOVE HO-SID TO O-SID MOVE HO-INVNO TO O-INVNO.
    MOVE HO-PALLETS TO O-PALLETS MOVE HO-NET TO O-NET MOVE HO-GROSS TO O-GROSS.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 MOVE HO-PACKS(IX1) TO O-PACKS(IX1) END-PERFORM.
    INITIALIZE C-REC MOVE HO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO LV3.
    PERFORM CHK-CUSTYPE MOVE C-TER TO O-TER MOVE C-US TO O-US.
    MOVE 0 TO LV-MTD LV-YTD LV-TOTAL LV-FREIGHT LV-FREIGHT-OVS LV-GST LV-HST
      LV-PST LV-QST LV-NONS LV-SURTOT.
    COMPUTE L-NO=100 * O-NO.
LV33. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO LV34. IF L-ORD NOT=O-NO GO LV34.
    MOVE 0 TO L-QTY-THIS REWRITE L-RECORD ALLOWING NO UNLOCK SALIN GO LV33.
LV34. COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO LV8.
LV5. READ SHIPLIN NEXT REGARDLESS END GO LV8. IF HL-ORDSEQ NOT=HO-ORDSEQ GO LV8.
    IF HL-QTY-AL=0 AND HL-PROD NOT="H" GO LV5.
    MOVE HL-ORD TO L-ORD MOVE HL-LINE TO L-LINE READ SALIN REGARDLESS INVALID GO LV5.
    MOVE HL-QTY-AL TO L-QTY-THIS MOVE L-PROD TO A-A1 PERFORM PROD-GEN PERFORM SUB-DEM.
    IF L-QTY=LIT-Q9 ADD L-QTY-THIS TO L-QTY-LEFT
      ELSE SUBTRACT L-QTY-THIS FROM L-QTY-LEFT IF L-QTY-LEFT<0 MOVE 0 TO L-QTY-LEFT.
    IF CAU-IND=1 OR C-BACK=0 OR L-QTY-LEFT=L-QTY PERFORM ADD-DEM
      ELSE MOVE 0 TO L-QTY-LEFT MOVE 1 TO L-REORDER.
    SUBTRACT L-QTY-THIS FROM P-HAND ADD L-QTY-THIS TO P-MTD P-YTD.
    MOVE L-QTY-THIS TO CL-QTY PERFORM WEIGHT-CALC MOVE CL-WEIGHT-I TO L-WEIGHT.
    ADD L-WEIGHT TO P-W-MTD P-W-YTD.
    IF L-NUT>" "
      IF GEN-NUT=" " MOVE P-WEIGHT-NUT TO WD1 ELSE MOVE GEN-WEIGHT-NUT TO WD1 END-IF
      COMPUTE L-WEIGHT-NUT ROUNDED=CL-QTY * WD1 / 100.
    PERFORM LPRICE-CALC PERFORM PLATING-CALC PERFORM SURCH-CALC.
    MOVE CL-SUR TO LV-SUR MOVE CL-D1 TO LV-SURCHARGE ADD CL-D1 TO LV-SURTOT.
    IF L-ADJ=1 MOVE L-EXTA TO CL-AMT.
    IF P-CAT>=90 ADD CL-AMT TO LV-NONS ELSE ADD CL-AMT TO LV-MTD ROUNDED LV-YTD ROUNDED.
    MOVE CL-AMT TO L-EXTA ADD CL-AMT TO P-A-MTD P-A-YTD LV-TOTAL.
    REWRITE P-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK PRODUCT.
    MOVE L-EXTA TO A-D1 PERFORM CHK-OVERSEAS.
    COMPUTE LV-FREIGHT-OVS=LV-FREIGHT-OVS + L-EXTA - A-D1.
    MOVE P-CAT TO L-CAT MOVE C-TER TO L-TER REWRITE L-RECORD ALLOWING NO UNLOCK SALIN.

* note 29.1
    IF O-BLANKET=0 GO LV52.
    MOVE O-NO TO PL-ORD READ PLANT REGARDLESS KEY PL-KO INVALID GO LV52.
    MOVE PL-PLANT TO MT-PLANT MOVE L-PROD TO MT-PROD MOVE 0 TO MT-SEQ.
    READ MATREL REGARDLESS INVALID GO LV52.
    ADD L-QTY-THIS TO MT-QTY-SHIP REWRITE MT-RECORD ALLOWING NO UNLOCK MATREL.
LV52.

    MOVE 0 TO LV-KN IF L-NUT=" " GO LV56.
    PERFORM NUM-NUTS COMPUTE CL-QTY=PRO-NNUT * L-QTY-THIS.
    MOVE P-KEY TO PRO-NSV MOVE L-NUT TO P-NO.
    READ PRODUCT REGARDLESS INVALID GO LV54. MOVE 1 TO LV-KN.
    ADD CL-QTY TO P-MTD P-YTD ADD L-WEIGHT-NUT TO P-W-MTD P-W-YTD.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    MOVE CL-QTY TO LV-QTY-NUT MOVE P-CAT TO LV-CAT-NUT MOVE 0 TO LV-AMT-NUT.
    IF P-MAC>=29 AND<=31 OR=99 COMPUTE LV-AMT-NUT ROUNDED=P-COST / 0.9 * CL-QTY / 1000.
LV54. MOVE PRO-NSV TO P-KEY READ PRODUCT REGARDLESS.
LV56.

    MOVE LOW-VALUES TO SH-RECORD.
    MOVE L-CUS TO SH-CUS SH-KCUS MOVE L-PROD TO SH-PROD SH-KPROD.
    MOVE LV-DATE TO SH-CDATE SH-KDATE ACCEPT SH-CTIME FROM TIME MOVE SH-CTIME TO SH-KTIME.
    MOVE O-NO TO SH-ORD MOVE O-INVNO TO SH-INVNO MOVE O-BL TO SH-BL.
    MOVE O-SHIPTO TO SH-SHIPTO MOVE O-SAL TO SH-SAL MOVE O-SALCOM TO SH-SALCOM.
    PERFORM GET-CUSORD MOVE A-A1 TO SH-CUSORD.
    MOVE LV-DATE TO SH-DATE MOVE C-US TO SH-US MOVE HO-DATE-REQ TO SH-DATE-REQ.
    MOVE L-QTY-THIS TO SH-QTY MOVE L-WEIGHT TO SH-WEIGHT MOVE P-CAT TO SH-CAT.
    MOVE L-EXTA TO A-D1 PERFORM CHK-OVERSEAS MOVE A-D1 TO SH-AMT.
    MOVE LV-SUR TO SH-SUR MOVE LV-SURCHARGE TO SH-SURCHARGE.
    IF LV-KN=1 SUBTRACT LV-AMT-NUT FROM SH-AMT. PERFORM LV-ADDHIST.
    PERFORM LV-INITSALT MOVE SH-CAT TO ST-CAT.
    MOVE SH-AMT TO ST-AMT MOVE SH-WEIGHT TO ST-WEIGHT MOVE SH-QTY TO ST-QTY.
    MOVE LV-SURCHARGE TO ST-SURCHARGE PERFORM LV-ADDSALT.
    IF LV-KN=1 MOVE L-NUT TO SH-PROD SH-KPROD MOVE LV-AMT-NUT TO SH-AMT
      MOVE LV-QTY-NUT TO SH-QTY MOVE L-WEIGHT-NUT TO SH-WEIGHT
      MOVE LV-CAT-NUT TO SH-CAT PERFORM LV-ADDHIST
      PERFORM LV-INITSALT MOVE SH-CAT TO ST-CAT
      MOVE SH-AMT TO ST-AMT MOVE SH-WEIGHT TO ST-WEIGHT MOVE SH-QTY TO ST-QTY
      MOVE 0 TO ST-SURCHARGE PERFORM LV-ADDSALT.

    MOVE L-KEY TO YL-K MOVE 0 TO YL-SEQ MOVE L-RECORD TO YL-DATA.
LV63. WRITE YL-RECORD ALLOWING NO INVALID ADD 1 TO YL-SEQ GO LV63. UNLOCK TMPLIN.
    MOVE L-QTY-THIS TO HL-QTY-THIS MOVE L-QTY-LEFT TO HL-QTY-LEFT.
    REWRITE HL-RECORD ALLOWING NO UNLOCK SHIPLIN.
    GO LV5.

LV8. IF O-FLOT NOT=0 MOVE O-FLOT TO LV-FREIGHT
      ELSE IF O-FRATE NOT=0 COMPUTE LV-FREIGHT ROUNDED=O-FRATE * O-GROSS / 100.
    ADD LV-FREIGHT TO LV-TOTAL.
    IF C-PROV=69
      IF C-GST=" " COMPUTE LV-GST ROUNDED=LV-TOTAL * IF-GST / 100 END-IF
      IF C-PST=" " COMPUTE LV-QST ROUNDED=(LV-TOTAL + LV-GST) * IF-QST / 100 END-IF
     ELSE IF C-PROV=63 OR 64 OR 66
      IF C-GST=" " COMPUTE LV-HST ROUNDED=LV-TOTAL * IF-HST / 100 END-IF
     ELSE IF NOT(C-TYPE="U" OR "Y")
      IF C-GST=" " COMPUTE LV-GST ROUNDED=LV-TOTAL * IF-GST / 100 END-IF
      IF C-PST=" " COMPUTE LV-PST ROUNDED=LV-TOTAL * IF-PST / 100 END-IF.
    ADD LV-GST LV-HST LV-PST LV-QST TO LV-TOTAL.
    ADD LV-FREIGHT LV-FREIGHT-OVS TO LV-NONS.
    MOVE LV-GST TO O-GST HO-GST MOVE LV-HST TO O-HST HO-HST.
    MOVE LV-PST TO O-PST HO-PST MOVE LV-QST TO O-QST HO-QST.
    MOVE LV-FREIGHT TO O-FREIGHT HO-FREIGHT MOVE LV-FREIGHT-OVS TO O-FREIGHT-OVS.
    MOVE LV-TOTAL TO O-TOTAL HO-TOTAL MOVE LV-NONS TO O-NON-SAL.
    MOVE LV-SURTOT TO O-SURTOT.
    REWRITE O-RECORD ALLOWING NO UNLOCK SAORD.

    PERFORM LV-INITSALT MOVE 90 TO ST-CAT.
    MOVE LV-FREIGHT TO ST-AMT MOVE O-GROSS TO ST-WEIGHT PERFORM LV-ADDSALT.
    PERFORM LV-INITSALT MOVE 90 TO ST-CAT.
    MOVE LV-FREIGHT-OVS TO ST-AMT PERFORM LV-ADDSALT.

    MOVE O-KEY TO YO-K MOVE 0 TO YO-SEQ MOVE O-RECORD TO YO-DATA.
LV83. WRITE YO-RECORD ALLOWING NO INVALID ADD 1 TO YO-SEQ GO LV83. UNLOCK TMPORD.
* note 46
    PERFORM RDLK-CUSTOMER.
    ADD LV-MTD TO C-MTD ADD LV-YTD TO C-YTD ADD LV-TOTAL TO C-CUR C-TOT.
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER.
    PERFORM INIT-TR.
    MOVE C-NO TO TR-CUS FF605 MOVE C-NAME TO FF606 MOVE O-BL TO TR-BL FF607.
    MOVE O-INVNO TO TR-INV TR-BINV FF608 MOVE O-NO TO TR-ORD FF609.
    MOVE LV-DATE TO TR-DATE D-DATE PERFORM D-NM MOVE D-DT TO FF610.
    PERFORM GET-CUSORD MOVE A-A1 TO TR-CUSORD FF611.
    MOVE LV-TOTAL TO TR-AMT TR-AMT-ORIG FF612 MOVE O-TERMS TO TR-TERMS.
    PERFORM LV-LINE.
* note 47
    WRITE TR-RECORD ALLOWING NO INVALID MOVE "*** INVOICE NOT CREATED, ALREADY EXISTS"
      TO PREC PERFORM LV-LINE. UNLOCK TRANS.
    MOVE 0 TO A-N1 IF TR-AMT<0 MOVE 3 TO A-N1.
    MOVE SYS-DATE TO A-N2 MOVE TR-AMT TO A-D1 PERFORM ADD-TRAUD.
    MOVE 6 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    GO LV3.
LV9. CLOSE SALTOT TMPORD TMPLIN TRAUDIT PERFORM CLOSE-PR GO MN9.

LV-ADDHIST. WRITE SH-RECORD ALLOWING NO UNLOCK SALHIST.
    MOVE LOW-VALUES TO SM-RECORD.
    MOVE SH-CUS TO SM-CUS SM-KCUS MOVE SH-PROD TO SM-PROD SM-KPROD.
    MOVE SH-QTY TO SM-QTY(1) COMPUTE SM-AMT(1) ROUNDED=SH-AMT.
    WRITE SM-RECORD ALLOWING NO INVALID READ SALSUM REGARDLESS
      ADD SH-QTY TO SM-QTY(1) ADD SH-AMT TO SM-AMT(1) ROUNDED REWRITE SM-RECORD ALLOWING NO.
    UNLOCK SALSUM.
LV-INITSALT. MOVE LOW-VALUES TO ST-RECORD INITIALIZE ST-REC.
    MOVE C-TER TO ST-TER MOVE LV-DATE TO D-DATE PERFORM D-NM.
    MOVE D-YY TO ST-YY MOVE D-MM TO ST-MM MOVE D-DD TO ST-DD.
    MOVE C-US TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO ST-US.
LV-ADDSALT. PERFORM LV-AS1 THRU LV-AS9.
LV-AS1. IF ST-AMT=0 AND ST-WEIGHT=0 GO LV-AS9.
    MOVE ST-AMT TO A-D1 MOVE ST-WEIGHT TO A-N1 MOVE ST-QTY TO A-N2 MOVE ST-SURCHARGE TO A-D2.
    WRITE ST-RECORD ALLOWING NO INVALID READ SALTOT REGARDLESS
      ADD A-D1 TO ST-AMT ADD A-N1 TO ST-WEIGHT ADD A-N2 TO ST-QTY ADD A-D2 TO ST-SURCHARGE
      REWRITE ST-RECORD ALLOWING NO.
    UNLOCK SALTOT.
LV-AS9. EXIT.
LV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM LV-PAGE.
LV-PAGE. MOVE "INVOICE JOURNAL" TO FF3 PERFORM PR-PAGE.
    MOVE "CUST    NAME                              B/L NO   INV NO  ORD NO  INV DATE  CUST ORD      INV AMT" TO PREC PERFORM PR-LINE-3.
*         ......  ................................  .......  ......  ......  ../../..  .........  ...,...:..-

* S-27 PRINT INVOICES
IR1. PERFORM RD339 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT OPEN I-O SOLDTO ALLOWING ALL PERFORM OPEN-REP.
    MOVE " " TO HO-KEY START SHIPORD KEY>HO-KEY REGARDLESS INVALID GO IR29.
IR23. READ SHIPORD NEXT REGARDLESS END GO IR29. IF HO-IND NOT=6 GO IR23.
    PERFORM INIT-RP MOVE HO-INVNO TO RP-F179 MOVE HO-KEY TO RP-F180.
    WRITE RP-RECORD GO IR23.
IR29. PERFORM OPEN-PR MOVE 47 TO IR-LN2.
    IF ITOOL STRING EPS-INIT EPS-CONDY DELIMITED SIZE INTO PREC PERFORM PR-LINE.
    IF IFAST OR INUT PERFORM RDR-INFO IF IF-PRINTER=1 MOVE X"33" TO EPS-PGL
      STRING EPS-INIT EPS-SKIPN EPS-PGLIN DELIMITED SIZE INTO PREC PERFORM PR-LINE.
    WRITE PREC AFTER PAGE.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO IR9.
IR3. READ REPFL NEXT END GO IR9. MOVE RP-F180 TO HO-KEY READ SHIPORD REGARDLESS.
    MOVE HO-ORD TO O-NO READ SAORD REGARDLESS INVALID GO IR3.
    MOVE O-CUS TO A-A1 PERFORM RD-CUS PERFORM CHK-CUSTYPE.
    IF O-SHIPTO=0 GO IR4. MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO IR4. PERFORM GET-O-CUSADD.
IR4. MOVE 0 TO WS-PAGE PERFORM IR-PAGE.
    COMPUTE HL-NO=100 * HO-NO START SHIPLIN KEY>HL-KEY REGARDLESS INVALID GO IR6.
IR5. READ SHIPLIN NEXT REGARDLESS END GO IR6. IF HL-ORDSEQ NOT=HO-ORDSEQ GO IR6.
    MOVE HL-ORD TO L-ORD MOVE HL-LINE TO L-LINE READ SALIN REGARDLESS INVALID GO IR5.
    IF HL-QTY-THIS=0 AND HL-PROD NOT="H" GO IR58.
    PERFORM IR-LINE MOVE L-PROD TO FA471 A-A1 PERFORM PROD-RDG.
    IF GEN-IND=1 PERFORM IR-LINE MOVE P-NO TO FA471. MOVE PRO-DESC(1) TO FA472.
    MOVE HL-QTY-LEFT TO FA473 IF L-QTY=LIT-Q9 MOVE LIT-BL TO FA473A.
    IF L-ADJ=1 MOVE "ADJUSTMENT" TO FA477 MOVE L-EXTA TO FA478
      PERFORM IR-LINE GO IR58.
    MOVE HL-QTY-THIS TO FA474.
    IF L-PRICE=0 MOVE "    N/C" TO FA475X
      ELSE IF C-NO="06469" OR "06470" MOVE L-PRICE TO FA475A
        ELSE MOVE L-PRICE TO FA475.
    MOVE L-MODE TO FA476 MOVE HL-QTY-THIS TO CL-QTY PERFORM LPRICE-CALC.
    MOVE CL-DTXT TO FA477 MOVE CL-AMT TO FA478 PERFORM IR-LINE.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO FA472 PERFORM IR-LINE END-PERFORM.
    IF L-CUSPART>" " STRING "CUSTOMER PART: " L-CUSPART DELIMITED SIZE
      INTO FA470 PERFORM IR-LINE.
    PERFORM WEIGHT-CALC.
    IF L-PLATING NOT=0 PERFORM PLATING-CALC
      MOVE T-PLS TO FA472 MOVE CL-WEIGHT TO FA474A MOVE T-PLR TO FA475
      MOVE CL-D1 TO FA478 PERFORM IR-LINE.
    PERFORM SURCH-CALC.
    IF CL-D1 NOT=0 MOVE "STEEL SURCHARGE" TO FA472
      IF CL-KSM=0 MOVE CL-WEIGHT TO FA474A MOVE "LBS" TO FA474B MOVE "/LB" TO FA476 END-IF
      MOVE CL-SURCH TO FA475 MOVE CL-D1 TO FA478 PERFORM IR-LINE
      IF C-SURLN=0 MOVE "REVISED PRICE INCL. SURCHARGE" TO FA472
        MOVE CL-MODE TO A-A1 PERFORM RD-MODE
        COMPUTE FA475 ROUNDED=CL-AMT * A-N1 / CL-QTY PERFORM IR-LINE.
    IF L-REORDER=1 MOVE "*** REORDER" TO FA472 PERFORM IR-LINE.
IR58. IF O-BLANKET=1 OR L-QTY-LEFT NOT=0
       MOVE 0 TO L-EXTA L-ADJ REWRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    GO IR5.
IR6. MOVE 7 TO HO-IND REWRITE HO-RECORD ALLOWING NO UNLOCK SHIPORD.
    PERFORM IR-LINE MOVE 0 TO IR-IXN.
    COMPUTE FA478=HO-TOTAL - HO-FREIGHT - HO-GST - HO-HST - HO-PST - HO-QST PERFORM IR-LINE.
    IF HO-FREIGHT NOT=0 MOVE "    FREIGHT" TO FA472 MOVE HO-FREIGHT TO FA478
      IF O-FRATE NOT=0 MOVE O-FRATE TO FA475 MOVE "C" TO FA476 END-IF
      IF O-FLOT NOT=0 MOVE O-FLOT TO FA475 MOVE "LOT" TO FA476 END-IF
      PERFORM IR-LINE.
    IF HO-PST NOT=0 MOVE "PST" TO FA477 MOVE HO-PST TO FA478
      PERFORM IR-NOTE PERFORM IR-LINE.
    IF HO-QST NOT=0 MOVE "QST" TO FA477 MOVE HO-QST TO FA478
      PERFORM IR-NOTE PERFORM IR-LINE.
    IF HO-GST NOT=0 MOVE "GST" TO FA477 MOVE HO-GST TO FA478
      PERFORM IR-NOTE PERFORM IR-LINE.
    IF HO-HST NOT=0 MOVE "HST" TO FA477 MOVE HO-HST TO FA478
      PERFORM IR-NOTE PERFORM IR-LINE.
    MOVE "*** TOTAL" TO FA477 MOVE HO-TOTAL TO FA478 PERFORM IR-NOTE PERFORM IR-LINE.
    PERFORM UNTIL IR-IXN>4 PERFORM IR-NOTE IF A-S1=1 PERFORM IR-LINE END-IF END-PERFORM.
    IF HO-CUS="06105"
      PERFORM IR-LINE IF WS-LINES>IR-LN2 - 4 PERFORM IR-PG END-IF
      MOVE MSG-M7A TO FA470 PERFORM PR-LINE MOVE MSG-M7B TO FA470 PERFORM PR-LINE
      MOVE MSG-M7C TO FA470 PERFORM PR-LINE MOVE MSG-M7D TO FA470 PERFORM PR-LINE.
    IF IFAST AND C-TER=3 OR 13
      PERFORM IR-LINE IF WS-LINES>IR-LN2 - 2 PERFORM IR-PG END-IF
      MOVE MSG-M10A TO FA470 PERFORM PR-LINE MOVE MSG-M10B TO FA470 PERFORM PR-LINE.
    WRITE PREC AFTER PAGE.
    IF O-SPECIAL=1 GO IR84. IF O-BLANKET=1 GO IR88.
    COMPUTE L-NO=100 * O-NO.
IR83. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO IR84.
    IF L-QTY-LEFT NOT=0 GO IR88. GO IR83.
IR84. DELETE SAORD COMPUTE L-NO=100 * O-NO.
IR85. ADD 1 TO L-LINE DELETE SALIN INVALID GO IR88. GO IR85.
IR88. GO IR3.
IR9. IF ITOOL STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM PR-LINE.
    IF IFAST OR INUT PERFORM RDR-INFO IF IF-PRINTER=1
      STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM PR-LINE.
    CLOSE SOLDTO PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

IR-NOTE. PERFORM IR-N1 THRU IR-N9.
IR-N1. MOVE 0 TO A-S1.
IR-N3. ADD 1 TO IR-IXN IF IR-IXN>4 GO IR-N9. IF O-TEXT(IR-IXN)=0 GO IR-N3.
    MOVE 3 TO T-TBL MOVE O-TEXT(IR-IXN) TO T-NO PERFORM RD-TBL.
    MOVE T-LINE TO FA470 MOVE 1 TO A-S1.
IR-N9. EXIT.
IR-PG. WRITE PREC AFTER PAGE PERFORM IR-PAGE PERFORM PR-LINE.
IR-LINE. PERFORM PR-LINE IF WS-LINES>IR-LN2 PERFORM IR-PG.
IR-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 2 TO WS-PR.
    IF ITOOL MOVE 1 TO WS-PR
      MOVE "I R V I N E  T O O L S                     INVOICE" TO PREC(55:) PERFORM PR-LINE.
    PERFORM GET-CUSADD.
    MOVE CUS-LINE(1) TO FA445 PERFORM PR-LINE MOVE CUS-LINE(2) TO FA445 PERFORM PR-LINE.
    MOVE CUS-LINE(3) TO FA445 PERFORM PR-LINE MOVE CUS-LINE(4) TO FA445 PERFORM PR-LINE.
    MOVE CUS-LINE(5) TO FA445 PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE O-NAME TO FA445 PERFORM PR-LINE MOVE O-ADD1 TO FA445 PERFORM PR-LINE.
    MOVE O-ADD2 TO FA445 PERFORM PR-LINE MOVE O-POST TO FA445 PERFORM PR-LINE.
    IF O-CUS="06105" OR "06106" MOVE "160 RICHMOND STREET" TO PREC(54:30).
    MOVE "PAGE" TO FA446 MOVE WS-PAGE TO FA447 PERFORM PR-LINE.
    IF O-CUS="06105" OR "06106" MOVE "SPRINGHILL, ONTARIO N1K 5R6" TO PREC(54:30).
    PERFORM PR-LINE-2.
* note 26.3
    PERFORM GET-CUSORD MOVE A-A1 TO FA448.
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA449.
    MOVE O-NO TO FA450 MOVE O-TERMS TO FA451.
    MOVE HO-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO FA453.
    MOVE HO-BL TO FA454 MOVE HO-SID TO FA455 PERFORM PR-LINE MOVE 3 TO WS-PR.
    MOVE C-GST TO FA457 MOVE C-PST TO FA458 MOVE O-FOB TO FA459.
    IF O-PPD="P" OR "*" MOVE "*" TO FA460 ELSE MOVE "*" TO FA461.
    MOVE O-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA462.
    MOVE HO-INVNO TO FA463 MOVE O-CUS TO FA464.
    MOVE HO-PACKS(1) TO FA465 MOVE HO-GROSS TO FA466 MOVE HO-NET TO FA467.
    PERFORM PR-LINE-2.

* S-31 SPECIFY SHIPMENTS (subcontractor function)
GS1.
GS13. PERFORM RD165 PERFORM WRT.
    PERFORM RD-INFO ADD 1 TO IF-BLNO PERFORM WR-INFO MOVE IF-BLNO TO GS-BL.
    MOVE GS-BL TO DSP-N71 DISPLAY DSP-N71 LINE 3 COLUMN 15.
    MOVE "'YES' TO START A NEW B/L: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="YES" PERFORM GS-BLCHK GO GS9.
GS23. ACCEPT GS-VEN LINE 3 COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR GS-VEN=9999 PERFORM GS-BLCHK GO GS9.
    INITIALIZE V-REC MOVE WS-DIV TO V-DIV MOVE GS-VEN TO V-NO.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO GS23.
    MOVE V-NAME TO GS-NAME MOVE V-ADD1 TO GS-ADD1 MOVE V-ADD2 TO GS-ADD2 MOVE V-POST TO GS-POST.
    IF V-SIND=1 MOVE V-SNAME TO GS-NAME MOVE V-SADD1 TO GS-ADD1
      MOVE V-SADD2 TO GS-ADD2 MOVE V-SPOST TO GS-POST.
    DISPLAY GS-NAME LINE 3 COLUMN 44 GS-ADD1 LINE 4 COLUMN 44
      GS-ADD2 LINE 5 COLUMN 44 GS-POST LINE 6 COLUMN 44.
    MOVE "MODIFY SHIPPING ADDRESS ? ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="YES" GO GS26.
    ACCEPT GS-NAME LINE 3 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT GS-ADD1 LINE 4 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT GS-ADD2 LINE 5 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT GS-POST LINE 6 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
GS26. ACCEPT GS-VIA LINE 7 COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE GS-VIA TO SV-KEY PERFORM RD-VIA.
    MOVE SV-CARRIER TO GS-CARRIER DISPLAY GS-CARRIER(1:36) LINE 7 COLUMN 40.
    MOVE " " TO GS-SJKEY.

GS3. PERFORM RD165 PERFORM WRT.
    MOVE GS-BL TO DSP-N71 DISPLAY DSP-N71 LINE 3 COLUMN 15.
    MOVE GS-VEN TO DSP-N41 DISPLAY DSP-N41 LINE 3 COLUMN 38.
    DISPLAY GS-NAME LINE 3 COLUMN 44 GS-ADD1 LINE 4 COLUMN 44
      GS-ADD2 LINE 5 COLUMN 44 GS-POST LINE 6 COLUMN 44.
    MOVE GS-VIA TO DSP-N21 DISPLAY DSP-N21 LINE 7 COLUMN 36.
    DISPLAY GS-CARRIER(1:36) LINE 7 COLUMN 40.

    MOVE LOW-VALUES TO SJ-RECORD INITIALIZE SJ-REC.
GS31. DISPLAY LIT-SP(1:10) LINE 9 COLUMN 23.
    ACCEPT SJ-MAC LINE 9 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF NOT(KPF4 OR SJ-MAC=9999) GO GS32.
    MOVE "'YES' TO CONFIRM THE END OF THIS B/L: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="YES" GO GS8. GO GS3.
GS32. MOVE SJ-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 PERFORM DSP-ERR23 GO GS3.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC DISPLAY M-OPDESC LINE 9 COLUMN 23.
    IF M-VENDOR=0 MOVE "NO VENDOR DEFINED FOR THIS PROCESS" TO ERR-MESG
      PERFORM DSP-OK IF XA2="OK" GO GS326 ELSE GO GS31.
    IF M-VENDOR NOT=GS-VEN MOVE "VENDOR/PROCESS MISMATCH" TO ERR-MESG
      PERFORM DSP-ERR GO GS31.
GS326.
GS33. ACCEPT LT-KEY LINE 10 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR LT-KEY=ALL "9" GO GS3. MOVE LT-KEY TO A-A1 PERFORM STR-LTH.
    IF LT-KEY(1:A-N1) NOT NUMERIC PERFORM DSP-ERR2 GO GS33.
    IF A-N1<7 MOVE 0 TO SJ-MO MOVE LT-NO(1:A-N1) TO SJ-MO(7 - A-N1:)
      INITIALIZE SJ-SUFFIX SJ-LOT GO GS34.
    READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO GS33.
    MOVE LT-NO TO SJ-LOT MOVE LT-MO TO SJ-MO MOVE LT-SUFFIX TO SJ-SUFFIX.
    MOVE LT-BUCKETS TO SJ-BUCKETS MOVE LT-WEIGHT TO SJ-WEIGHT.
    DISPLAY LIT-SP(1:7) LINE 10 COLUMN 16 SJ-MO COLUMN 16 CONVERSION SJ-SUFFIX COLUMN 42.
    DISPLAY SJ-LOT LINE 11 COLUMN 17.
GS34. MOVE SJ-MO TO R-NO PERFORM RDF-PRODORD IF A-S1=1 GO GS33.
    IF SJ-LOT=0 ACCEPT SJ-SUFFIX LINE 10 COLUMN 42 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE R-PROD TO SJ-PROD A-A1 PERFORM PROD-RD PERFORM GS-PDSP.

    MOVE 0 TO GS-KALT IF SJ-MAC NOT=790 GO GS36.
    PERFORM CHK-ALTS IF A-S1=0 GO GS36.
GS35. DISPLAY "ENTER ALTERNATE PRODUCT OR ACCEPT THE GENERIC" LINE 24 BOLD.
    ACCEPT P-NO LINE 9 COLUMN 49 DEFAULT CURRENT UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF P-NO=SJ-PROD GO GS36.
    MOVE P-NO TO A-A1 PERFORM PROD-RD IF P-GEN NOT=SJ-PROD PERFORM DSP-ERR43
      MOVE SJ-PROD TO A-A1 PERFORM PROD-RD GO GS35.
    MOVE 1 TO GS-KALT PERFORM GS-PDSP MOVE P-NO TO SJ-PROD PERFORM RD-GEN.
GS36. IF GS-VEN=3098 DISPLAY "C OF C" LINE 8 COLUMN 28 BOLD
       ACCEPT GS-COFC LINE 8 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.

    MOVE 0 TO GS-KADD.
    READ SUBCON REGARDLESS INVALID MOVE 1 TO GS-KADD MOVE SYS-DATE TO SJ-DATE.
    MOVE 0 TO SJ-OUTCON SJ-WEX.
    IF GS-KALT=1 GO GS366. PERFORM GET-OP IF A-S1=1 GO GS366.
    MOVE 1 TO IX1 MOVE 0 TO IX2.
GS363. MOVE OP-OPER(IX1) TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO GS364.
    ADD 1 TO IX2 IF OP-OPER(IX1) NOT=SJ-MAC GO GS364.
    MOVE SJ-MAC TO A-N1 MOVE IX2 TO A-X1 PERFORM CALC-OUTCON MOVE A-N1 TO SJ-OUTCON.
    IF OP-COST(IX1)>0 MOVE OP-COST(IX1) TO SJ-COST MOVE OP-CMODE(IX1) TO SJ-CMODE
      ELSE MOVE M-COST TO SJ-COST MOVE M-CMODE TO SJ-CMODE.
    GO GS366.
GS364. ADD 1 TO IX1 IF IX1<=12 GO GS363.
GS366. PERFORM GS-CDSP IF SJ-OUTCON>0 AND SJ-COST>0 AND SJ-CMODE>" " GO GS38.
    MOVE "MODIFY ACCOUNTING DATA ? ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="YES" GO GS3.
    MOVE SJ-MAC TO A-N1 MOVE 1 TO A-X1 PERFORM CALC-OUTCON MOVE A-N1 TO SJ-OUTCON.
    DISPLAY SJ-OUTCON LINE 13 COLUMN 33 CONVERSION.
GS367. ACCEPT SJ-OUTCON LINE 13 COLUMN 33 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY SJ-OUTCON LINE 13 COLUMN 33 CONVERSION.
    MOVE SJ-OUTCON TO A-N1 PERFORM PROC-TYPE.
    IF NOT PROC-OUTCON MOVE "WRONG VALUE FOR THIS PROCESS TYPE"
      TO ERR-MESG PERFORM DSP-ERR GO GS367.
    ACCEPT SJ-COST LINE 14 COLUMN 21 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY SJ-COST LINE 14 COLUMN 21 CONVERSION.
    MOVE 14 TO IXT MOVE 39 TO IXU MOVE SJ-CMODE TO XA1 PERFORM AX-CMODE MOVE XA1 TO SJ-CMODE.
GS38. PERFORM GS-DSP.

    ACCEPT SJ-NOTE LINE 16 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING.
GS43. DISPLAY "ENTER NUMBER OF BUCKETS SHIPPED" LINE 24 BOLD.
    ACCEPT GS-OBUCKETS LINE 21 COLUMN 58 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF GS-OBUCKETS=0 PERFORM DSP-ERR2 GO GS43. IF SJ-LOT=0 GO GS48.
    IF SJ-OBUCKETS + GS-OBUCKETS>SJ-BUCKETS
      MOVE "'OUT' BUCKETS EXCEED TOTAL ORIGINAL BUCKETS" TO ERR-MESG
      PERFORM DSP-ERR GO GS43.
    COMPUTE GS-DF2 ROUNDED=SJ-WEIGHT * GS-OBUCKETS / SJ-BUCKETS SIZE ERROR MOVE 0 TO GS-DF2.
    DISPLAY GS-DF2 LINE 21 COLUMN 64 CONVERSION.
    GO GS6.
GS48.

GS53. DISPLAY "ENTER WEIGHT SHIPPED" LINE 24 BOLD.
    ACCEPT GS-OWEIGHT LINE 21 COLUMN 64 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF GS-OWEIGHT=0 PERFORM DSP-ERR2 GO GS53.
    MOVE GS-OWEIGHT TO GS-DF2 DISPLAY GS-DF2 LINE 21 COLUMN 64 CONVERSION.
    ADD GS-OBUCKETS TO SJ-BUCKETS ADD GS-OWEIGHT TO SJ-WEIGHT.

    MOVE 0 TO GS-QTY INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO GS56.
GS55. READ WORKSHEET NEXT REGARDLESS END GO GS56. IF J-NO NOT=R-NO GO GS56.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY ADD J-QTY TO GS-QTY
      ELSE IF (IFAST OR INUT) AND PROC-REJECT SUBTRACT J-QTY FROM GS-QTY.
    GO GS55.
GS56. PERFORM GET-PWEIGHT COMPUTE WN1 ROUNDED=GS-QTY * A-D1 / 100.
    IF SJ-WEIGHT + GS-OWEIGHT>WN1 MOVE " " TO ERR-MESG MOVE WN1 TO GS-DF3
      STRING "WEIGHT EXCEEDS PRIMARY MACHINE" GS-DF3 DELIMITED SIZE
        INTO ERR-MESG PERFORM DSP-OK IF XA2="OK" MOVE 1 TO SJ-WEX ELSE GO GS43.

GS6. PERFORM GS-DSP MOVE 23 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO GS78.
    ADD GS-OBUCKETS TO SJ-OBUCKETS SJ-SBUCKETS.
    COMPUTE SJ-OWEIGHT ROUNDED=SJ-WEIGHT * SJ-OBUCKETS / SJ-BUCKETS SIZE ERROR MOVE 0 TO SJ-OWEIGHT.
    COMPUTE SJ-SWEIGHT ROUNDED=SJ-WEIGHT * SJ-SBUCKETS / SJ-BUCKETS SIZE ERROR MOVE 0 TO SJ-SWEIGHT.
    IF GS-KADD=0 PERFORM VARYING IX1 FROM 15 BY -1 UNTIL IX1=1
      MOVE SJ-BL(IX1 - 1) TO SJ-BL(IX1) END-PERFORM.
    MOVE GS-BL TO SJ-BL(1) MOVE GS-VEN TO SJ-VEN MOVE GS-VIA TO SJ-VIA.
    MOVE GS-COFC TO SJ-COFC MOVE GS-NAME TO SJ-NAME.
    MOVE GS-ADD1 TO SJ-ADD1 MOVE GS-ADD2 TO SJ-ADD2 MOVE GS-POST TO SJ-POST.
    MOVE USN-USER TO SJ-USER.

    IF SJ-OUTCON=0 GO GS76.
    PERFORM INIT-J MOVE SJ-MO TO J-NO MOVE SJ-OUTCON TO J-MAC MOVE SJ-PROD TO J-PROD.
    MOVE GS-BL TO A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO.
    STRING "B/L " GS-BL(A-N1:) DELIMITED SIZE INTO J-NAME.
    COMPUTE J-WEIGHT ROUNDED=SJ-WEIGHT * GS-OBUCKETS / SJ-BUCKETS SIZE ERROR CONTINUE.
    PERFORM GET-PWEIGHT COMPUTE J-QTY ROUNDED=J-WEIGHT * 100 / A-D1 SIZE ERROR CONTINUE.
    MOVE J-QTY TO WN1 MOVE J-WEIGHT TO WN2 PERFORM SET-JKD.
    WRITE J-RECORD ALLOWING NO INVALID READ WORKSHEET REGARDLESS
      ADD WN1 TO J-QTY ADD WN2 TO J-WEIGHT REWRITE J-RECORD ALLOWING NO.
    UNLOCK WORKSHEET.
GS76. IF GS-KADD=0 REWRITE SJ-RECORD ALLOWING NO ELSE WRITE SJ-RECORD ALLOWING NO.
    UNLOCK SUBCON.
* note 176.1
    IF GS-SJKEY=" " MOVE SJ-MAC TO A-N1 PERFORM PROC-TYPE
      IF PROC-MANUSORT OR PROC-AUTOSORT OR PROC-LOTINSP OR PROC-PACK
        OR SJ-MAC=458 MOVE SJ-KEY TO GS-SJKEY.
GS78. GO GS3.
GS8. IF GS-SJKEY=" " GO GS88.
GS83. PERFORM RD264 PERFORM WRT.
    REPLACE ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
    ACCEPT GS-NCARTONS LINE 3 COLUMN 13 ACC-NUM.
    ACCEPT GS-BCARTONS LINE 4 COLUMN 20 ACC-NUM.
    ACCEPT GS-NSKIDS LINE 3 COLUMN 36 ACC-NUM.
    ACCEPT GS-BSKIDS LINE 4 COLUMN 42 ACC-NUM.
    ACCEPT GS-NPADS LINE 3 COLUMN 67 ACC-NUM.
    ACCEPT GS-BPADS LINE 4 COLUMN 70 ACC-NUM.
    REPLACE OFF.
    MOVE 10 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO GS83.
    MOVE GS-SJKEY TO SJ-KEY READ SUBCON REGARDLESS INVALID GO GS88.
    MOVE GS-NCARTONS TO SJ-NCARTONS MOVE GS-BCARTONS TO SJ-BCARTONS.
    MOVE GS-NSKIDS TO SJ-NSKIDS MOVE GS-BSKIDS TO SJ-BSKIDS.
    MOVE GS-NPADS TO SJ-NPADS MOVE GS-BPADS TO SJ-BPADS.
    REWRITE SJ-RECORD ALLOWING NO UNLOCK SUBCON.
GS88. GO GS13.
GS9. GO MN9.

* note 97.3
GS-BLCHK. PERFORM RD-INFO IF IF-BLNO=GS-BL SUBTRACT 1 FROM IF-BLNO. PERFORM WR-INFO.
GS-PDSP. DISPLAY P-NO LINE 9 COLUMN 49.
    MOVE 1 TO A-X1 MOVE 10 TO IXT PERFORM UNTIL A-X1>5 OR PRO-DESC(A-X1)=" "
      DISPLAY PRO-DESC(A-X1) LINE IXT COLUMN 49 ADD 1 TO A-X1 IXT END-PERFORM.
GS-CDSP. DISPLAY SJ-OUTCON LINE 13 COLUMN 32 CONVERSION.
    DISPLAY SJ-COST LINE 14 COLUMN 20 CONVERSION SJ-CMODE COLUMN 37.
GS-DSP. COMPUTE GS-DF1=SJ-BUCKETS - SJ-OBUCKETS + SJ-IBUCKETS DISPLAY GS-DF1 LINE 21 COLUMN 1 CONVERSION BOLD.
    COMPUTE GS-DF2=SJ-WEIGHT - SJ-OWEIGHT + SJ-IWEIGHT DISPLAY GS-DF2 LINE 21 COLUMN 4 CONVERSION BOLD.
    MOVE SJ-BUCKETS TO GS-DF1 DISPLAY GS-DF1 LINE 21 COLUMN 14 CONVERSION BOLD.
    MOVE SJ-WEIGHT TO GS-DF2 DISPLAY GS-DF2 LINE 21 COLUMN 17 CONVERSION BOLD.
    MOVE SJ-OBUCKETS TO GS-DF1 DISPLAY GS-DF1 LINE 21 COLUMN 27 CONVERSION.
    MOVE SJ-OWEIGHT TO GS-DF2 DISPLAY GS-DF2 LINE 21 COLUMN 30 CONVERSION.
    MOVE SJ-IBUCKETS TO GS-DF1 DISPLAY GS-DF1 LINE 21 COLUMN 40 CONVERSION.
    MOVE SJ-IWEIGHT TO GS-DF2 DISPLAY GS-DF2 LINE 21 COLUMN 43 CONVERSION.

* S-32 SHOW SHIPMENTS (subcontractor function)
GN1. PERFORM RD163 MOVE 0 TO M-NO MOVE 3 TO IXT.
GN3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
GN33. DISPLAY "NEXT SUBCONTRACTOR NO. ___" LINE IXT.
    ACCEPT IA12 COLUMN 24 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA12=999 GO GN9.
    IF IA12=0 IF M-NO=0 GO GN33 ELSE GO GN4. MOVE IA12 TO M-NO.
    START MACHINE KEY>=M-KEY REGARDLESS INVALID PERFORM DSP-ERR23 GO GN33.
    READ MACHINE NEXT REGARDLESS.
    MOVE M-NO TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 PERFORM DSP-ERR23 GO GN33.
    INITIALIZE SJ-KEY MOVE M-NO TO SJ-MAC MOVE 0 TO INQ-IND.
GN4. PERFORM RD163 MOVE M-NO TO TF116(1) MOVE M-OPDESC TO TF117(1).
    MOVE 4 TO IXT IF INQ-IND=0 START SUBCON KEY>=SJ-KEY REGARDLESS INVALID GO GN8.
GN5. READ SUBCON NEXT REGARDLESS END GO GN8. IF SJ-MAC NOT=M-NO GO GN8.
    PERFORM CLR-LN MOVE SJ-MO TO TF118(IXT).
    IF SJ-SUFFIX>" " MOVE "-" TO TF118A(IXT) MOVE SJ-SUFFIX TO TF118B(IXT).
    IF SJ-LOT>0 MOVE SJ-LOT TO TF118C(IXT). MOVE SJ-PROD TO TF119(IXT).
    COMPUTE TF120(IXT,1)=SJ-BUCKETS - SJ-OBUCKETS + SJ-IBUCKETS.
    COMPUTE TF121(IXT,1)=SJ-WEIGHT - SJ-OWEIGHT + SJ-IWEIGHT.
    MOVE SJ-BUCKETS TO TF120(IXT,2) MOVE SJ-WEIGHT TO TF121(IXT,2).
    MOVE SJ-OBUCKETS TO TF120(IXT,3) MOVE SJ-OWEIGHT TO TF121(IXT,3).
    MOVE SJ-IBUCKETS TO TF120(IXT,4) MOVE SJ-IWEIGHT TO TF121(IXT,4).
    ADD 1 TO IXT IF IXT<22 GO GN5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO GN89.
GN8. MOVE "*** END ***" TO TLN(IXT).
    READ MACHINE NEXT REGARDLESS END MOVE 0 TO M-NO GO GN89.
    MOVE M-NO TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 MOVE 0 TO M-NO GO GN89.
    INITIALIZE SJ-KEY MOVE M-NO TO SJ-MAC MOVE 0 TO INQ-IND.
GN89. GO GN3.
GN9. GO MN9.

* S-33 SHIPMENTS REPORT (subcontractor function)
GQ1. PERFORM RD164 PERFORM WRT.
    MOVE 3 TO IXT MOVE 15 TO IXU MOVE 37 TO IXV PERFORM AX-VEN-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO SJ-KEY START SUBCON KEY>SJ-KEY REGARDLESS INVALID GO GQ29.
GQ23. READ SUBCON NEXT REGARDLESS END GO GQ29. IF SJ-IBUCKETS=SJ-BUCKETS GO GQ23.
    IF NOT(SJ-VEN>=VEN1 AND<=VEN2) GO GQ23.
    PERFORM INIT-RP MOVE SJ-VEN TO RP-F225 MOVE SJ-MAC TO RP-F226.
    MOVE SJ-PROD TO RP-F227 MOVE SJ-MO TO RP-F228 MOVE SJ-SUFFIX TO RP-F228A.
    MOVE SJ-LOT TO RP-F228B WRITE RP-RECORD GO GQ23.
GQ29. PERFORM OPEN-PR PERFORM GQ-PAGE.
    MOVE LOW-VALUES TO GQ-WTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO GQ9.
GQ3. READ REPFL NEXT END GO GQ9. IF RP-F225=OLD-N GO GQ4.
    IF OLD-N>0 PERFORM GQ-LINE. MOVE RP-F225 TO OLD-N FA349 A-N1.
    PERFORM RD-VEN MOVE V-NAME TO FA349A.
GQ4. MOVE RP-F226 TO SJ-MAC MOVE RP-F228 TO SJ-MO MOVE RP-F228A TO SJ-SUFFIX.
    MOVE RP-F228B TO SJ-LOT MOVE RP-F227 TO SJ-PROD READ SUBCON REGARDLESS.
    MOVE SJ-MAC TO FA350 MOVE SJ-PROD TO FA351 MOVE SJ-MO TO FA352.
    IF SJ-SUFFIX>" " MOVE "-" TO FA353 MOVE SJ-SUFFIX TO FA354.
    IF SJ-LOT>0 MOVE SJ-LOT TO FA355.
    MOVE SJ-BUCKETS TO FA356A(1) MOVE SJ-WEIGHT TO FA356B(1).
    MOVE SJ-OBUCKETS TO FA356A(2) MOVE SJ-OWEIGHT TO FA356B(2).
    MOVE SJ-IBUCKETS TO FA356A(3) MOVE SJ-IWEIGHT TO FA356B(3).
    ADD SJ-WEIGHT TO GQ-WTOT(1) ADD SJ-OWEIGHT TO GQ-WTOT(2) ADD SJ-IWEIGHT TO GQ-WTOT(3).
    MOVE 1 TO IX1.
GQ43. IF SJ-BL(IX1)=0 GO GQ46.
    MOVE SJ-BL(IX1) TO FA357 A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO OK-NO.
    READ PURORD REGARDLESS INVALID GO GQ44.
    MOVE OK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA357A.
GQ44. PERFORM GQ-LINE ADD 1 TO IX1 IF IX1<=15 GO GQ43.
GQ46. GO GQ3.
GQ9. MOVE 3 TO WS-PR MOVE "*** WEIGHT TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE GQ-WTOT(IX1) TO FA356C(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

GQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GQ-PAGE.
GQ-PAGE. MOVE "SUBCONTRACTOR SHIPMENTS REPORT" TO FF3.
    MOVE "** OPEN ITEMS **" TO FF4 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-VEN.
    MOVE "                                                                       ORIGINAL         OUT            IN" TO PREC PERFORM PR-LINE.
    MOVE "VENDOR                       PROCESS  PRODUCT        M.O.     LOT     BKTS WEIGHT    BKTS WEIGHT    BKTS WEIGHT      P.O.     DATE" TO PREC PERFORM PR-LINE-3.
*         .... ........................  ...    ............ ......-. .......    ..- ..,...-    ..- ..,...-    ..- ..,...-   .......  ../../..

* S-34 GENERATE BILLS OF LADING (subcontractor function)
GR1. PERFORM RD166 PERFORM WRT.
    ACCEPT GR-BPR LINE 3 COLUMN 41 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT GR-CPR LINE 4 COLUMN 41 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT GR-PPR LINE 5 COLUMN 46 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 6 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    PERFORM INIT-UN MOVE USN-USER TO US-USER READ USERS REGARDLESS INVALID CONTINUE.
    MOVE US-NAME TO GR-UNAME.

    MOVE " " TO SJ-KEY START SUBCON KEY>SJ-KEY REGARDLESS INVALID GO GR29.
GR23. READ SUBCON NEXT REGARDLESS END GO GR29.
    IF SJ-SBUCKETS=0 OR NOT(SJ-USER=USN-USER OR " ") GO GR23. PERFORM INIT-RP.
    MOVE SJ-BL(1) TO RP-F229 MOVE SJ-KEY TO RP-F230 WRITE RP-RECORD GO GR23.
GR29.

    MOVE GR-BPR TO PR-NUM PERFORM OPEN-PR WRITE PREC AFTER PAGE MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO GR39.
GR3. READ REPFL NEXT END GO GR39. MOVE RP-F230 TO SJ-KEY READ SUBCON REGARDLESS.
    IF SJ-BL(1)=OLD-N GO GR34. IF OLD-N NOT=0 PERFORM GR-BTOT. MOVE SJ-BL(1) TO OLD-N.
    MOVE SJ-NAME TO GR-NAME MOVE SJ-ADD1 TO GR-ADD1 MOVE SJ-ADD2 TO GR-ADD2 MOVE SJ-POST TO GR-POST.
    MOVE SJ-VIA TO SV-KEY PERFORM RD-VIA.
    MOVE 0 TO GR-TBUCKETS GR-TWEIGHT GR-TOTAL
      GR-NCARTONS GR-BCARTONS GR-NSKIDS GR-BSKIDS GR-NPADS GR-BPADS.
    MOVE 0 TO WS-PAGE PERFORM GR-BPAGE.
GR34. PERFORM GR-BLINE MOVE SJ-PROD TO A-A1 PERFORM PROD-RT.
    MOVE SJ-SBUCKETS TO FA367 IF SJ-SBUCKETS=1 MOVE "BKT" TO FA368 ELSE MOVE "BKTS" TO FA368.
    MOVE SJ-PROD TO FA369A.
    IF SJ-CMODE="M" PERFORM GET-PWEIGHT
      COMPUTE FA369B ROUNDED=SJ-SWEIGHT * 100 / A-D1 SIZE ERROR CONTINUE END-COMPUTE
      MOVE "PCS" TO FA369C.
    MOVE SJ-SWEIGHT TO FA370 MOVE "LBS" TO FA371 PERFORM PR-LINE.
    MOVE "LOT" TO FA372 IF SJ-LOT>0 MOVE SJ-LOT TO FA372A.
    MOVE "FROM M.O." TO FA373 MOVE SJ-MO TO FA374.
    IF SJ-SUFFIX>" " MOVE "-" TO FA374A MOVE SJ-SUFFIX TO FA374B.
    PERFORM PR-LINE.
    MOVE "FOR PROCESS" TO FA375 MOVE SJ-MAC TO FA376.
    IF SJ-COFC>" " MOVE "C OF C" TO FA376A MOVE SJ-COFC TO FA376B.
    PERFORM PR-LINE.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FA369 PERFORM PR-LINE.
    IF M-DESC2>" " MOVE M-DESC2 TO FA369 PERFORM PR-LINE.
    IF M-PLT-IND=1
      IF P-PLSPEC>0 MOVE 20 TO T-TBL MOVE P-PLSPEC TO T-NO PERFORM RD-TBL
        MOVE T-LINE TO FA369 PERFORM PR-LINE.
    IF SJ-NOTE>" " MOVE SJ-NOTE TO FA377 PERFORM PR-LINE.
    IF SJ-WEX=1 MOVE "(WEIGHT EXCEEDS PRIMARY MACHINE WEIGHT)" TO FA377 PERFORM PR-LINE.
    PERFORM GR-TADD GO GR3.
GR39. PERFORM GR-BTOT PERFORM CLOSE-PR.

    MOVE GR-CPR TO PR-NUM PERFORM OPEN-PR.
    MOVE EPS-ALIGN TO PREC WRITE PREC MOVE " " TO PREC.
* note 204.1
    MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO GR59.
GR5. READ REPFL NEXT END GO GR59. MOVE RP-F230 TO SJ-KEY READ SUBCON REGARDLESS.
    MOVE SJ-VEN TO A-N1 PERFORM CHK-VENUS IF A-S1=0 GO GR5.
    IF SJ-BL(1)=OLD-N GO GR56. IF OLD-N NOT=0 PERFORM GR-CTOT. MOVE SJ-BL(1) TO OLD-N.

    MOVE 0 TO GR-NUMLIN GR-TBUCKETS GR-TWEIGHT GR-TOTAL
      GR-NCARTONS GR-BCARTONS GR-PCARTONS GR-NSKIDS GR-BSKIDS GR-PSKIDS
      GR-NPADS GR-BPADS GR-PPADS.
    MOVE RP-KEY TO GR-RPSAV START REPFL.
GR53. READ REPFL NEXT END GO GR54. MOVE RP-F230 TO SJ-KEY READ SUBCON REGARDLESS.
    IF SJ-BL(1) NOT=OLD-N GO GR54. MOVE SJ-VEN TO A-N1 PERFORM CHK-VENUS IF A-S1=0 GO GR53.
    ADD 1 TO GR-NUMLIN PERFORM GR-TADD MOVE SJ-PROD TO GR-PROD GO GR53.
GR54. PERFORM GR-TCALC.

    INITIALIZE PK-REC IF GR-NCARTONS=0 GO GR542.
    MOVE GR-PROD TO A-A1 PERFORM PROD-RT.
    MOVE P-PACKING TO PK-NO READ PACKING REGARDLESS INVALID GO GR542.
    MOVE PK-PART TO PH-NO READ PART REGARDLESS INVALID GO GR542.
    PERFORM PART-TYPE MOVE PH-LDCOST TO A-T1 PERFORM DIV-PAMT.
    MOVE A-T1 TO GR-PCARTONS.
GR542. IF GR-NSKIDS=0 GO GR546. MOVE "99261" TO PH-NO IF PK-PALLET=0 GO GR544.
    MOVE PK-PALLET TO PK-NO READ PACKING REGARDLESS INVALID GO GR544.
    MOVE PK-PART TO PH-NO.
GR544. READ PART REGARDLESS INVALID GO GR546.
    PERFORM PART-TYPE MOVE PH-LDCOST TO A-T1 PERFORM DIV-PAMT.
    MOVE A-T1 TO GR-PSKIDS.
GR546. IF GR-NPADS=0 GO GR548.
    MOVE "99518" TO PH-NO READ PART REGARDLESS INVALID GO GR548.
    PERFORM PART-TYPE MOVE PH-LDCOST TO A-T1 PERFORM DIV-PAMT.
    MOVE A-T1 TO GR-PPADS.
GR548.

    MOVE GR-RPSAV TO RP-KEY START REPFL READ REPFL NEXT.
    MOVE RP-F230 TO SJ-KEY READ SUBCON REGARDLESS.
    MOVE SJ-VEN TO A-N1 PERFORM RD-VEN MOVE SJ-VIA TO SV-KEY PERFORM RD-VIA.
* note 81.2
    MOVE 2 TO GR-LNP MOVE 31 TO GR-LN1 MOVE 45 TO GR-LN2 GR-LNN.
    SUBTRACT 1 FROM GR-LNN SUBTRACT 2 FROM GR-LNN.
    IF GR-NSKIDS>0 SUBTRACT 2 FROM GR-LNN.
    IF GR-NCARTONS>0 OR GR-NSKIDS>0 OR GR-NPADS>0 ADD 1 TO GR-NUMLIN.
    COMPUTE WN1=(GR-LN2 - GR-LN1 + 1) / GR-LNP.
    COMPUTE WN2=(GR-LNN - GR-LN1 + 1) / GR-LNP COMPUTE WN2=GR-NUMLIN - WN2.
    IF WN2<=0 MOVE 1 TO GR-NPG
      ELSE DIVIDE WN2 BY WN1 GIVING GR-NPG REMAINDER WN3
        ADD 1 TO GR-NPG IF WN3>0 ADD 1 TO GR-NPG.
    MOVE 0 TO WS-PAGE PERFORM GR-CPAGE.

GR56. MOVE SJ-PROD TO A-A1 PERFORM PROD-RT PERFORM GET-PWEIGHT.
    COMPUTE GR-SQTY ROUNDED=SJ-SWEIGHT * 100 / A-D1 SIZE ERROR MOVE 0 TO GR-SQTY.
    MOVE "CDA" TO FF387 MOVE "XO" TO FF388 MOVE "C" TO FF389.
    MOVE SJ-SBUCKETS TO FF390A MOVE "BUCKETS OF BOLTS CONTAINING:" TO FF390B.
    MOVE "YES" TO FF391 MOVE "NO" TO FF391A.
* note 129
    COMPUTE WT1 ROUNDED=SJ-SWEIGHT * 1000 / GR-SQTY SIZE ERROR MOVE 0 TO WT1.
    COMPUTE WD1 ROUNDED=GR-SQTY * WT1 / 1000 ADD WD1 TO GR-TOTAL.
    MOVE GR-SQTY TO FF391B MOVE WT1 TO FF392 MOVE "M" TO FF393 MOVE WD1 TO FF394.
    PERFORM PR-LINE.
    MOVE "PROD NO." TO FF397 MOVE SJ-PROD TO FF398.
    IF P-HCODE NOT=0 MOVE 15 TO T-TBL MOVE P-HCODE TO T-NO PERFORM RD-TBL
      MOVE T-LINE(1:15) TO FF399.
    PERFORM GR-CLINE GO GR5.
GR59. PERFORM GR-CTOT PERFORM CLOSE-PR.

    MOVE GR-PPR TO PR-NUM PERFORM OPEN-PR MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO GR69.
GR63. READ REPFL NEXT END GO GR69. MOVE RP-F230 TO SJ-KEY READ SUBCON REGARDLESS.
    IF SJ-BL(1)=OLD-N GO GR64. PERFORM GR-PAGE.
    MOVE SJ-VEN TO A-N1 PERFORM RD-VEN PERFORM INIT-OK MOVE 1 TO OK-SUBCON.
    MOVE SJ-BL(1) TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO OK-NO.
    MOVE SJ-VEN TO OK-VENDOR A-N1 PERFORM CHK-VENUS MOVE A-S1 TO OK-US.
    MOVE SJ-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO OK-CARRIER.
    MOVE SYS-DATE TO OK-DATE D-DATE MOVE 30 TO D-DAYS MOVE 5 TO D-N1.
    PERFORM D-DTADD MOVE D-DATE TO OK-DATE-REQ.
    MOVE WS-FOB TO OK-FOB MOVE "NET 60 DAYS" TO OK-TERMS.
    MOVE "MAIN PLANT" TO OK-SHIPTO MOVE "MORRIS" TO OK-USER MOVE 0 TO GR-KDUP.
    PERFORM SET-OKV WRITE OK-RECORD ALLOWING NO INVALID MOVE 1 TO GR-KDUP. UNLOCK PURORD.
    MOVE OK-NO TO FA746 MOVE OK-VENDOR TO FA747 MOVE V-NAME TO FA748.
    MOVE OK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA749.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA750.
    MOVE LIT-NY(OK-US + 1:1) TO FA751 MOVE LIT-NY(OK-PSTPAY + 1:1) TO FA752.
    PERFORM GR-LINE.
    MOVE OK-CARRIER TO FA753 MOVE OK-FOB TO FA754 MOVE OK-TERMS TO FA755.
    IF GR-KDUP=1 MOVE "DUPL. P.O. NO." TO FA756.
    PERFORM GR-LINE.
    MOVE SJ-BL(1) TO OLD-N MOVE 0 TO GR-LN.

GR64. PERFORM INIT-LK MOVE OK-NO TO LK-ORD ADD 1 TO GR-LN MOVE GR-LN TO LK-LINE.
    MOVE SJ-MAC TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO LK-PART.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO LK-DESC1.
    MOVE SJ-MAC TO LK-SUB-MAC MOVE SJ-LOT TO LK-SUB-LOT.
    MOVE SJ-MO TO LK-SUB-MO MOVE SJ-SUFFIX TO LK-SUB-SUFFIX.
    MOVE SJ-PROD TO LK-SUB-PROD MOVE OK-DATE-REQ TO LK-DATE-REQ.
    MOVE 235859 TO WS-GL1 IF M-PLT-IND=1 MOVE 235852 TO WS-GL1.
    MOVE M-GROUP TO WS-GL2 MOVE M-SECT TO WS-GL3 MOVE 0 TO WS-GL4.
    MOVE WS-GL TO LK-GL.
    MOVE SJ-PROD TO A-A1 PERFORM PROD-RT.
    IF SJ-CMODE="G" OR "N" MOVE "C" TO LK-MODE MOVE "LBS" TO LK-UNIT
      COMPUTE LK-PRICE ROUNDED=SJ-COST * 100 / 2000 MOVE SJ-SWEIGHT TO LK-QTY
     ELSE MOVE "M" TO LK-MODE MOVE "PCS" TO LK-UNIT
      MOVE SJ-COST TO LK-PRICE
      COMPUTE LK-QTY ROUNDED=SJ-SWEIGHT * 100 / P-WEIGHT SIZE ERROR CONTINUE.
    MOVE LK-QTY TO CL-QTY PERFORM KPRICE-CALC MOVE CL-AMT TO LK-TOTAL.
    IF GR-KDUP=0 WRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    MOVE LK-LINE TO FA760 MOVE LK-PART TO FA761 MOVE LK-SUB-MO TO FA762.
    IF LK-SUB-SUFFIX>" " MOVE "-" TO FA763 MOVE LK-SUB-SUFFIX TO FA764.
    MOVE LK-SUB-LOT TO FA765 MOVE SJ-COFC TO FA765A MOVE LK-SUB-PROD TO FA766.
    MOVE LK-QTY TO FA767 MOVE LK-UNIT TO FA768 MOVE LK-PRICE TO FA769.
    MOVE LK-MODE TO FA770 MOVE LK-TOTAL TO FA771 PERFORM GR-LINE.
    MOVE "DISTR A/C" TO FA772 MOVE LK-GL TO FA773.
    MOVE WS-DIV TO G-DIV MOVE LK-GL TO G-GL.
    READ GLDIST REGARDLESS INVALID MOVE "INVALID G/L A/C ***" TO FA773A.
    IF G-NGL=0 MOVE "MISSING 'NEW G/L' A/C ***" TO FA773A.
    PERFORM GR-LINE GO GR63.
GR69. PERFORM CLOSE-REP PERFORM CLOSE-PR.

    MOVE " " TO SJ-KEY START SUBCON KEY>SJ-KEY REGARDLESS INVALID GO GR84.
GR83. READ SUBCON NEXT REGARDLESS END GO GR84.
    IF SJ-SBUCKETS=0 OR NOT(SJ-USER=USN-USER OR " ") GO GR83.
    MOVE 0 TO SJ-SBUCKETS SJ-SWEIGHT
      SJ-NCARTONS SJ-BCARTONS SJ-NSKIDS SJ-BSKIDS SJ-NPADS SJ-BPADS.
    REWRITE SJ-RECORD ALLOWING NO UNLOCK SUBCON GO GR83.
GR84.

GR9. GO MN9.

GR-TCALC. COMPUTE GR-TARE=GR-TBUCKETS * WEI-WT(3).
    COMPUTE GR-TWEIGHT ROUNDED=GR-TWEIGHT + GR-NCARTONS * WEI-WT(1)
      + GR-NSKIDS * WEI-PALLET + GR-NPADS * WEI-PAD.
GR-TADD. ADD SJ-SBUCKETS TO GR-TBUCKETS ADD SJ-SWEIGHT TO GR-TWEIGHT.
    ADD SJ-NCARTONS TO GR-NCARTONS ADD SJ-BCARTONS TO GR-BCARTONS.
    ADD SJ-NSKIDS TO GR-NSKIDS ADD SJ-BSKIDS TO GR-BSKIDS.
    ADD SJ-NPADS TO GR-NPADS ADD SJ-BPADS TO GR-BPADS.
* note 176.2

GR-BTOT. PERFORM GR-TCALC.
    IF GR-NCARTONS>0 OR GR-NSKIDS>0 OR GR-NPADS>0 PERFORM GR-BLINE.
    IF GR-NCARTONS>0 COMPUTE WN1=GR-NCARTONS * WEI-WT(1)
      MOVE GR-BCARTONS TO FA367 MOVE "BUNDLES OF CARTONS" TO FA369
      MOVE WN1 TO FA370 MOVE "LBS" TO FA371 PERFORM GR-BLINE.
    IF GR-NSKIDS>0 COMPUTE WN1=GR-NSKIDS * WEI-PALLET
      MOVE GR-BSKIDS TO FA367 MOVE "STACKS OF SKIDS" TO FA369
      MOVE WN1 TO FA370 MOVE "LBS" TO FA371 PERFORM GR-BLINE.
    IF GR-NPADS>0 COMPUTE WN1 ROUNDED=GR-NPADS * WEI-PAD
      MOVE GR-BPADS TO FA367 MOVE "BUNDLES OF CARDBOARD PADS" TO FA369
      MOVE WN1 TO FA370 MOVE "LBS" TO FA371 PERFORM GR-BLINE.
    PERFORM GR-BLINE.
    MOVE GR-TBUCKETS TO FA367 MOVE "BKTS" TO FA368.
    MOVE "          TOTAL NET" TO FA369 MOVE GR-TWEIGHT TO FA370 MOVE "LBS" TO FA371 PERFORM PR-LINE.
    MOVE "               TARE" TO FA369 MOVE GR-TARE TO FA370 MOVE "LBS" TO FA371 PERFORM PR-LINE.
    MOVE "        TOTAL GROSS" TO FA369 COMPUTE FA370=GR-TWEIGHT + GR-TARE MOVE "LBS" TO FA371 PERFORM PR-LINE.
    PERFORM GR-BEND.
GR-BEND. COMPUTE WS-PR=58 - WS-LINES MOVE OLD-N TO FA366 PERFORM PR-LINE.
    WRITE PREC AFTER PAGE.
GR-BLINE. PERFORM PR-LINE IF WS-LINES>41 PERFORM GR-BEND PERFORM GR-BPAGE PERFORM PR-LINE.
GR-BPAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 12 TO WS-PR.
    MOVE SV-CARRIER TO FA358 MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE D-MM TO FA359 MOVE D-DD TO FA360 MOVE D-YY TO FA361 PERFORM PR-LINE-2.
    MOVE GR-NAME TO FA362 MOVE "PAGE" TO FA362A MOVE WS-PAGE TO FA362B PERFORM PR-LINE-2.
    MOVE GR-ADD1 TO FA362 PERFORM PR-LINE-2.
    MOVE GR-ADD2 TO FA363 MOVE GR-POST TO FA364 PERFORM PR-LINE-4.

GR-CTOT. IF GR-NCARTONS>0
      COMPUTE WD1 ROUNDED=GR-NCARTONS * GR-PCARTONS ADD WD1 TO GR-TOTAL
      MOVE "CDA" TO FF387 MOVE "XO" TO FF388 MOVE "C" TO FF389
      MOVE GR-BCARTONS TO FF390C MOVE "BUNDLES OF CARTONS" TO FF390D MOVE "4819.20" TO FF390E
      MOVE "NO" TO FF391 FF391A MOVE GR-NCARTONS TO FF391B MOVE GR-PCARTONS TO FF392
      MOVE "EA" TO FF393 MOVE WD1 TO FF394 PERFORM GR-CLINE.
    IF GR-NSKIDS>0
      COMPUTE WD1 ROUNDED=GR-NSKIDS * GR-PSKIDS ADD WD1 TO GR-TOTAL
      MOVE "CDA" TO FF387 MOVE "XO" TO FF388 MOVE "C" TO FF389
      MOVE GR-BSKIDS TO FF390C MOVE "STACKS OF SKIDS" TO FF390D MOVE "4415.20" TO FF390E
      MOVE "NO" TO FF391 FF391A MOVE GR-NSKIDS TO FF391B MOVE GR-PSKIDS TO FF392
      MOVE "EA" TO FF393 MOVE WD1 TO FF394 PERFORM GR-CLINE.
    IF GR-NPADS>0
      COMPUTE WD1 ROUNDED=GR-NPADS * GR-PPADS ADD WD1 TO GR-TOTAL
      MOVE "CDA" TO FF387 MOVE "XO" TO FF388 MOVE "C" TO FF389
      MOVE GR-BPADS TO FF390C MOVE "BUNDLES OF CRDBRD PADS" TO FF390D MOVE "4819.10" TO FF390E
      MOVE "NO" TO FF391 FF391A MOVE GR-NPADS TO FF391B MOVE GR-PPADS TO FF392
      MOVE "EA" TO FF393 MOVE WD1 TO FF394 PERFORM GR-CLINE.
    IF WS-LINES>GR-LNN PERFORM GR-CEND PERFORM GR-CPAGE.
    IF WS-LINES<GR-LNN COMPUTE WS-PR=GR-LNN - WS-LINES PERFORM PR-LINE.
    PERFORM PR-LINE.
    MOVE MSG-M9A TO FF404 PERFORM PR-LINE MOVE MSG-M9B TO FF404 PERFORM PR-LINE.
    IF GR-NSKIDS>0 MOVE MSG-M4A TO FF404 PERFORM PR-LINE MOVE MSG-M4B TO FF404 PERFORM PR-LINE.
    COMPUTE WS-PR=48 - WS-LINES.
    MOVE GR-TOTAL TO FF394 PERFORM PR-LINE PERFORM GR-CEND.
GR-CEND. COMPUTE WS-PR=56 - WS-LINES MOVE GR-NPG TO FF395 PERFORM PR-LINE.
    MOVE 5 TO WS-PR MOVE GR-UNAME TO FF396 PERFORM PR-LINE.
    MOVE "IRVINE FASTENERS" TO FF376.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF377 PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE "SHIPPING CLERK" TO FF400 MOVE "519-324-6448" TO FF401.
    MOVE "519-324-2731" TO FF402 PERFORM PR-LINE WRITE PREC AFTER PAGE.
GR-CLINE. PERFORM PR-LINE IF WS-LINES>GR-LN2 - 1 PERFORM GR-CEND PERFORM GR-CPAGE.
GR-CPAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES.
    MOVE 4 TO T-TBL MOVE 4 TO T-NO PERFORM RD-TBL MOVE T-LINE TO A-A1.
    MOVE "XXXXXXXXXXXXXXX" TO A-A2.
    MOVE A-A2 TO PREC(17:) PERFORM PR-LINE.
    MOVE A-A2 TO PREC(17:) PERFORM PR-LINE.
    MOVE A-A1 TO PREC(3:) PERFORM PR-LINE MOVE 5 TO WS-PR.
    MOVE WS-NAME TO FF367 MOVE "SAME AS EXPORTER" TO FF368 PERFORM PR-LINE.
    MOVE WS-ADD1 TO FF367 PERFORM PR-LINE.
    MOVE WS-ADD2 TO FF367 PERFORM PR-LINE.
    MOVE WS-POST TO FF367 PERFORM PR-LINE.
    MOVE WS-TAXID TO FF367(3:16) PERFORM PR-LINE MOVE 3 TO WS-PR.
    MOVE V-NAME TO FF367 MOVE SJ-NAME TO FF368 PERFORM PR-LINE.
    MOVE V-ADD1 TO FF367 MOVE SJ-ADD1 TO FF368 PERFORM PR-LINE.
    MOVE V-ADD2 TO FF367 MOVE SJ-ADD2 TO FF368 PERFORM PR-LINE.
    MOVE V-POST TO FF367 MOVE SJ-POST TO FF368 PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE SJ-BL(1) TO FF365 PERFORM PR-LINE.
    MOVE "X" TO FF371 MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF372.
    MOVE SJ-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO FF373 PERFORM PR-LINE.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF372 PERFORM PR-LINE.
    MOVE "X" TO FF366 MOVE "PAGE" TO FF361 MOVE WS-PAGE TO FF362.
    MOVE "OF" TO FF363 MOVE GR-NPG TO FF364 PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "X" TO FF374 PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE GR-TBUCKETS TO FF378.
    IF GR-TBUCKETS=1 MOVE "BUCKET" TO FF379 ELSE MOVE "BUCKETS" TO FF379.
    MOVE "GR:" TO FF383 COMPUTE FF384 ROUNDED=(GR-TWEIGHT + GR-TARE) * WEI-LB.
    MOVE "KG" TO FF385 PERFORM PR-LINE.
    PERFORM PR-LINE COMPUTE WS-PR=GR-LN1 - WS-LINES - 1 PERFORM PR-LINE.

GR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GR-PAGE.
GR-PAGE. MOVE "SUBCONTRACTOR DUMMY PURCHASE ORDERS" TO FF3Y PERFORM PR-PAGE-80.
    MOVE "P.O. NO.  VEN  NAME                             DATE   DATE REQD US$ PST" TO PREC PERFORM PR-LINE.
*         ........  .... .............................. ../../.. ../../..   .   .
    MOVE "               VIA             F.O.B.          TERMS        ERROR" TO PREC PERFORM PR-LINE.
*                        ............... ............... ............ ..............
    MOVE "  LN PART M.O.     LOT     C OF C  PRODUCT           QTY  UNIT    PRICE MODE      TOTAL" TO PREC PERFORM PR-LINE-3.
*           .. .... ......-. ....... ......  ............ .,...,...-.... ....:... .... ...,...:..-
*                                              DISTR A/C ...... ... .. .......                         ..............................

* S-35 SPECIFY RETURNS (subcontractor function)
GC1. IF INUT GO GC6.
GC3. PERFORM RD162 PERFORM WRT.
    ACCEPT SJ-MAC LINE 3 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR SJ-MAC=999 GO GC59.
    MOVE SJ-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 PERFORM DSP-ERR23 GO GC3.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC DISPLAY M-OPDESC LINE 3 COLUMN 23.
GC33. ACCEPT LT-KEY LINE 4 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR LT-KEY=ALL "9" GO GC59. MOVE LT-KEY TO A-A1 PERFORM STR-LTH.
    IF LT-KEY(1:A-N1) NOT NUMERIC PERFORM DSP-ERR2 GO GC33.
    IF A-N1<7 MOVE 0 TO SJ-MO MOVE LT-NO(1:A-N1) TO SJ-MO(7 - A-N1:)
      INITIALIZE SJ-SUFFIX SJ-LOT GO GC34.
    READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO GC33.
    MOVE LT-NO TO SJ-LOT MOVE LT-MO TO SJ-MO MOVE LT-SUFFIX TO SJ-SUFFIX.
    DISPLAY LIT-SP(1:7) LINE 4 COLUMN 16 SJ-MO COLUMN 16 CONVERSION SJ-SUFFIX COLUMN 42.
    DISPLAY SJ-LOT LINE 5 COLUMN 17.
GC34. MOVE SJ-MO TO R-NO PERFORM RDF-PRODORD IF A-S1=1 GO GC33.
    ACCEPT SJ-SUFFIX LINE 4 COLUMN 42 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE R-PROD TO SJ-PROD A-A1 PERFORM PROD-RD.
    PERFORM GC-PDSP MOVE P-QTY-PACK TO GC-QTY-PACK.

    IF SJ-MAC NOT=790 GO GC346.
    PERFORM CHK-ALTS IF A-S1=0 GO GC346.
GC345. DISPLAY "ENTER ALTERNATE PRODUCT OR ACCEPT THE GENERIC" LINE 24 BOLD.
    ACCEPT P-NO LINE 3 COLUMN 49 DEFAULT CURRENT UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF P-NO=SJ-PROD GO GC346.
    MOVE P-NO TO A-A1 PERFORM PROD-RD IF P-GEN NOT=SJ-PROD PERFORM DSP-ERR43
      MOVE SJ-PROD TO A-A1 PERFORM PROD-RD GO GC345.
    PERFORM GC-PDSP MOVE P-QTY-PACK TO GC-QTY-PACK.
    MOVE P-NO TO SJ-PROD PERFORM RD-GEN.
GC346. READ SUBCON REGARDLESS INVALID PERFORM DSP-ERR37 GO GC3.
    IF SJ-BL(2)=0 MOVE SJ-BL(1) TO GC-BL GO GC40.

    MOVE 0 TO GC-NBL MOVE 1 TO IX1.
GC353. IF SJ-BL(IX1)=0 GO GC358.
    MOVE SJ-BL(IX1) TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO OK-NO.
    READ PURORD REGARDLESS INVALID GO GC356.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO GC356.
GC355. READ PURLIN NEXT REGARDLESS END GO GC356. IF LK-ORD NOT=OK-NO GO GC356.
    IF NOT(LK-SUB-MAC=SJ-MAC AND LK-SUB-MO=SJ-MO
      AND LK-SUB-SUFFIX=SJ-SUFFIX AND LK-SUB-LOT=SJ-LOT) GO GC355.
    ADD 1 TO GC-NBL MOVE SJ-BL(IX1) TO GC-OBL(GC-NBL).
    IF LK-QTY-REC>=LK-QTY MOVE 1 TO GC-OCL(GC-NBL).
GC356. IF IX1<15 ADD 1 TO IX1 GO GC353.
GC358. MOVE 7 TO IXT MOVE 34 TO IXU IF GC-NBL>6 MOVE 31 TO IXU.
    MOVE 1 TO IX1 PERFORM UNTIL IX1>6 OR GC-NBL
      PERFORM GC-DB ADD 1 TO IX1 IXT END-PERFORM.
    IF GC-NBL>6 MOVE 7 TO IXT MOVE 40 TO IXU
      MOVE 7 TO IX1 PERFORM UNTIL IX1>12 OR GC-NBL
        PERFORM GC-DB ADD 1 TO IX1 IXT END-PERFORM.
    DISPLAY "THERE ARE SEVERAL SHIPMENTS - ENTER B/L NO. (ORDERS MARKED ARE CLOSED)" LINE 24 BOLD.
    ACCEPT GC-BL LINE 5 COLUMN 34 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>15 OR GC-NBL
      IF GC-BL=GC-OBL(IX1) GO GC40 END-IF END-PERFORM.
    PERFORM DSP-ERR13 GO GC3.

GC40. DISPLAY GC-BL LINE 5 COLUMN 34 CONVERSION.
    PERFORM GC-DSP.
    ACCEPT GC-SLIP LINE 7 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM GC-DUP IF A-S1=1 GO GC3.
GC41. MOVE SJ-MAC TO GC-MAC.
    DISPLAY GC-MAC LINE 8 COLUMN 21 CONVERSION.
    ACCEPT GC-MAC LINE 8 COLUMN 21 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY GC-MAC LINE 8 COLUMN 21 CONVERSION.
    MOVE GC-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 PERFORM DSP-ERR23 GO GC41.
GC423. MOVE 9 TO IXT MOVE 17 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.
    MOVE DATE0 TO GC-DATE D-DATE MOVE 20 TO D-N1 MOVE 0 TO D-N2.
    PERFORM D-CHKDTR IF D-ERR=1 GO GC423.
    DISPLAY "IF 'YES', PROCESS 599 WORKSHEET ENTRY WILL ALSO BE ADDED" LINE 24 BOLD.
    ACCEPT XA3 LINE 10 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA3="YES" MOVE 1 TO GC-KR ELSE MOVE 0 TO GC-KR.

GC43. DISPLAY "ENTER NUMBER OF BUCKETS RETURNED" LINE 24 BOLD.
    ACCEPT GC-IBUCKETS LINE 16 COLUMN 56 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF GC-IBUCKETS=0 GO GC44.
    IF SJ-IBUCKETS + GC-IBUCKETS>SJ-OBUCKETS
      MOVE "'IN' BUCKETS EXCEED 'OUT' BUCKETS" TO ERR-MESG PERFORM DSP-ERR GO GC43.
    IF SJ-IBUCKETS + GC-IBUCKETS>SJ-BUCKETS
      MOVE "'IN' BUCKETS EXCEED TOTAL ORIGINAL BUCKETS" TO ERR-MESG PERFORM DSP-ERR GO GC43.
GC44.
GC45. IF SJ-VEN=3049
      DISPLAY "CARTONS: _____" LINE 17 COLUMN 62 BOLD
      DISPLAY "ENTER CARTONS RETURNED" LINE 24 BOLD
      ACCEPT GC-ICARTONS LINE 17 COLUMN 71 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS
      COMPUTE GC-IQTY=GC-ICARTONS * GC-QTY-PACK
      GO GC458.
    DISPLAY "ENTER WEIGHT RETURNED" LINE 24 BOLD.
    ACCEPT GC-IWEIGHT LINE 16 COLUMN 62 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    MOVE GC-IWEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 16 COLUMN 62 CONVERSION.
    COMPUTE GC-IQTY ROUNDED=GC-IWEIGHT * 100 / P-WEIGHT SIZE ERROR MOVE 0 TO GC-IQTY.
    MOVE GC-IQTY TO GC-DF3 DISPLAY GC-DF3 LINE 16 COLUMN 71 CONVERSION.
    IF GC-IWEIGHT NOT=0 GO GC46.
    DISPLAY "ENTER QTY RETURNED" LINE 24 BOLD.
    ACCEPT GC-IQTY LINE 16 COLUMN 71 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
GC458. MOVE GC-IQTY TO GC-DF3 DISPLAY GC-DF3 LINE 16 COLUMN 71 CONVERSION.
    COMPUTE GC-IWEIGHT ROUNDED=GC-IQTY * P-WEIGHT / 100.
    MOVE GC-IWEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 16 COLUMN 62 CONVERSION.
GC46. IF GC-IWEIGHT NOT=0 AND SJ-IWEIGHT + GC-IWEIGHT>SJ-OWEIGHT
       MOVE "'IN' WEIGHT EXCEEDS 'OUT' WEIGHT" TO ERR-MESG PERFORM DSP-OK
       IF XA2 NOT="OK" GO GC45.
    IF GC-IBUCKETS=0 PERFORM GET-PWEIGHT
      COMPUTE GC-IBUCKETS ROUNDED=SJ-BUCKETS * GC-IWEIGHT * A-D1 / P-WEIGHT / SJ-WEIGHT SIZE ERROR CONTINUE END-COMPUTE
      IF SJ-IBUCKETS + GC-IBUCKETS>SJ-BUCKETS COMPUTE GC-IBUCKETS=SJ-BUCKETS - SJ-IBUCKETS END-IF
      MOVE GC-IBUCKETS TO GC-DF1 DISPLAY GC-DF1 LINE 16 COLUMN 56 CONVERSION.

    MOVE 0 TO GC-IPALLETS GC-IRBUCKETS GC-ITRUCK GC-ILTLOAD GC-IMETRO.
    IF SJ-VEN=3268 AND SJ-MAC=526
      DISPLAY "PALLETS: ___" LINE 18 COLUMN 47 BOLD
      DISPLAY "ENTER PALLETS (FOR $3.00/PALLET CHARGE)" LINE 24 BOLD
      ACCEPT GC-IPALLETS LINE 18 COLUMN 56 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF SJ-VEN=3049
      DISPLAY "BUCKETS: ___" LINE 18 COLUMN 47 BOLD
      DISPLAY "ENTER RETURNED BUCKETS (FOR $0.75/BUCKET CHARGE)" LINE 24 BOLD
      ACCEPT GC-IRBUCKETS LINE 18 COLUMN 56 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF SJ-VEN=3058
      DISPLAY "TRUCK CHARGE ? ___" LINE 18 COLUMN 47 BOLD
      DISPLAY "LESS THAN TRUCK LOAD PREMIUM ? ___" LINE 18 COLUMN 47 BOLD
      DISPLAY "METRO DELIVERY ? ___" LINE 20 COLUMN 47 BOLD
      DISPLAY "'YES' FOR $100 TRUCK CHARGE" LINE 24 BOLD
      ACCEPT XA3 LINE 18 COLUMN 62 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS
      IF XA3="YES" MOVE 1 TO GC-ITRUCK END-IF
      DISPLAY "'YES' FOR $50 LTL PREMIUM" LINE 24 BOLD
      ACCEPT XA3 LINE 19 COLUMN 78 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS
      IF XA3="YES" MOVE 1 TO GC-ILTLOAD END-IF
      DISPLAY "'YES' FOR $50 METRO CHARGE" LINE 24 BOLD
      ACCEPT XA3 LINE 20 COLUMN 64 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS
      IF XA3="YES" MOVE 1 TO GC-IMETRO END-IF.

    ACCEPT XA3 LINE 22 COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="CAN" MOVE "TRANSACTION CANCELED" TO TMSG PERFORM DSP-MSGCONT GO GC58.
    IF GC-IBUCKETS=0 AND GC-IWEIGHT=0 GO GC58.

    ADD GC-IBUCKETS TO SJ-IBUCKETS.
    IF SJ-IWEIGHT + GC-IWEIGHT>SJ-OWEIGHT MOVE SJ-OWEIGHT TO SJ-IWEIGHT
      ELSE ADD GC-IWEIGHT TO SJ-IWEIGHT.
    REWRITE SJ-RECORD ALLOWING NO UNLOCK SUBCON.
    MOVE LOW-VALUES TO SL-RECORD.
    MOVE SJ-MAC TO SL-MAC MOVE SJ-MO TO SL-MO MOVE SJ-SUFFIX TO SL-SUFFIX.
    MOVE SJ-LOT TO SL-LOT MOVE SJ-PROD TO SL-PROD.
    MOVE GC-SLIP TO SL-KSLIP SL-SLIP MOVE 0 TO SL-SEQ.
    MOVE GC-BL TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO SL-ORD.
    MOVE GC-IQTY TO SL-QTY MOVE GC-IWEIGHT TO SL-WEIGHT.
    MOVE GC-IPALLETS TO SL-PALLETS MOVE GC-IRBUCKETS TO SL-RBUCKETS.
    MOVE GC-ITRUCK TO SL-TRUCK MOVE GC-ILTLOAD TO SL-LTLOAD MOVE GC-IMETRO TO SL-METRO.
    MOVE GC-MAC TO SL-JMAC MOVE GC-DATE TO SL-JDATE MOVE GC-KR TO SL-JRET.
GC53. WRITE SL-RECORD ALLOWING NO INVALID IF SL-SEQ<99 ADD 1 TO SL-SEQ GO GC53 END-IF.
    UNLOCK SUBINV.
* note 169
GC58. GO GC3.
GC59. GO GC9.

GC6. MOVE SYS-DATE TO GC-DATE.
GC63. PERFORM RD200 PERFORM WRT PERFORM INIT-SJ.
GC65. ACCEPT SJ-VEN LINE 3 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR SJ-VEN=9999 GO GC89.
    INITIALIZE V-REC MOVE WS-DIV TO V-DIV MOVE SJ-VEN TO V-NO.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO GC65.
    DISPLAY V-NAME LINE 3 COLUMN 20.
GC67. ACCEPT SJ-MAC LINE 5 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE SJ-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 PERFORM DSP-ERR23 GO GC67.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC DISPLAY M-OPDESC LINE 5 COLUMN 23.

    MOVE SJ-VEN TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO GC-ORD.
    MOVE SJ-MAC TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO GC-PART.
    PERFORM GC-FL IF A-S1=0 MOVE "NO P.O. FOUND FOR THIS SUBCONTRACTOR"
      TO ERR-MESG PERFORM DSP-ERR GO GC63.

GC71. ACCEPT SJ-PROD LINE 5 COLUMN 49 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE SJ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO GC71.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 6 COLUMN 49.

    MOVE 0 TO WS1 PERFORM GET-OP IF A-S1=1 GO GC724.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)=SJ-MAC MOVE 1 TO WS1 GO GC724 END-IF END-PERFORM.
GC724. IF WS1=0 MOVE "SUBCONTRACTOR NOT FOUND IN THE OPERATIONS LIST"
        TO ERR-MESG PERFORM DSP-ERR GO GC63.

    ACCEPT GC-SLIP LINE 6 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN MOVE 0 TO AT-TYPE MOVE GC-SLIP TO AT-INV.
    READ APTR REGARDLESS INVALID GO GC726. PERFORM DSP-ERR42 GO GC63.
GC726. PERFORM GC-DUP IF A-S1=1 GO GC63.
    MOVE GC-DATE TO D-DATE MOVE 7 TO IXT MOVE 16 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO GC-DATE.
GC75. DISPLAY "ENTER WEIGHT OR QTY RETURNED" LINE 24 BOLD.
    ACCEPT GC-IWEIGHT LINE 9 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF GC-IWEIGHT NOT=0
      MOVE GC-IWEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 9 COLUMN 14 CONVERSION
      COMPUTE GC-IQTY ROUNDED=GC-IWEIGHT * 100 / P-WEIGHT SIZE ERROR MOVE 0 TO GC-IQTY END-COMPUTE
      MOVE GC-IQTY TO GC-DF3 DISPLAY GC-DF3 LINE 9 COLUMN 34 CONVERSION
      GO GC76.
    DISPLAY "ENTER QTY RETURNED" LINE 24 BOLD.
    ACCEPT GC-IQTY LINE 9 COLUMN 34 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    MOVE GC-IQTY TO GC-DF3 DISPLAY GC-DF3 LINE 9 COLUMN 34 CONVERSION.
    COMPUTE GC-IWEIGHT ROUNDED=GC-IQTY * P-WEIGHT / 100.
    MOVE GC-IWEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 9 COLUMN 14 CONVERSION.
GC76. IF GC-IWEIGHT=0 AND GC-IQTY=0 PERFORM DSP-ERR2 GO GC75.
    ACCEPT XA3 LINE 12 COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="CAN" MOVE "TRANSACTION CANCELED" TO TMSG PERFORM DSP-MSGCONT GO GC63.

* note 189
    MOVE SYS-DATE TO SJ-DATE.
    MOVE GC-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO SJ-MO.
GC83. WRITE SJ-RECORD ALLOWING NO INVALID IF SJ-LOT<99 ADD 1 TO SJ-LOT GO GC83 END-IF.
    UNLOCK SUBCON.
    MOVE LOW-VALUES TO SL-RECORD INITIALIZE SL-REC.
    MOVE SJ-MAC TO SL-MAC MOVE SJ-MO TO SL-MO MOVE SJ-SUFFIX TO SL-SUFFIX.
    MOVE SJ-LOT TO SL-LOT MOVE SJ-PROD TO SL-PROD.
    MOVE GC-SLIP TO SL-KSLIP SL-SLIP MOVE GC-ORD TO SL-ORD MOVE 0 TO SL-SEQ.
    MOVE GC-IQTY TO SL-QTY MOVE GC-IWEIGHT TO SL-WEIGHT MOVE GC-DATE TO SL-INV-DATE.
GC85. WRITE SL-RECORD ALLOWING NO INVALID IF SL-SEQ<99 ADD 1 TO SL-SEQ GO GC85 END-IF.
    UNLOCK SUBINV.
    GO GC63.
GC89. GO GC9.

GC9. GO MN9.

GC-PDSP. DISPLAY P-NO LINE 3 COLUMN 49.
    MOVE 1 TO A-X1 MOVE 4 TO IXT PERFORM UNTIL A-X1>5 OR PRO-DESC(A-X1)=" "
      DISPLAY PRO-DESC(A-X1) LINE IXT COLUMN 49 ADD 1 TO A-X1 IXT END-PERFORM.
GC-DSP. COMPUTE GC-DF1=SJ-BUCKETS - SJ-OBUCKETS + SJ-IBUCKETS DISPLAY GC-DF1 LINE 15 COLUMN 1 CONVERSION BOLD.
    COMPUTE GC-DF2=SJ-WEIGHT - SJ-OWEIGHT + SJ-IWEIGHT DISPLAY GC-DF2 LINE 15 COLUMN 4 CONVERSION BOLD.
    MOVE SJ-BUCKETS TO GC-DF1 DISPLAY GC-DF1 LINE 15 COLUMN 14 CONVERSION BOLD.
    MOVE SJ-WEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 15 COLUMN 17 CONVERSION BOLD.
    MOVE SJ-OBUCKETS TO GC-DF1 DISPLAY GC-DF1 LINE 15 COLUMN 27 CONVERSION.
    MOVE SJ-OWEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 15 COLUMN 30 CONVERSION.
    MOVE SJ-IBUCKETS TO GC-DF1 DISPLAY GC-DF1 LINE 15 COLUMN 40 CONVERSION.
    MOVE SJ-IWEIGHT TO GC-DF2 DISPLAY GC-DF2 LINE 15 COLUMN 43 CONVERSION.
GC-DB. MOVE GC-OBL(IX1) TO DSP-N71 DISPLAY DSP-N71 LINE IXT COLUMN IXU.
    IF GC-OCL(IX1)=1 DISPLAY "*" COLUMN IXU PLUS 7.
GC-FL. PERFORM GC-FL1 THRU GC-FL9.
GC-FL1. MOVE GC-ORD TO LK-ORD MOVE 0 TO LK-LINE A-S1.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO GC-FL4.
GC-FL3. READ PURLIN NEXT REGARDLESS END GO GC-FL4. IF LK-ORD NOT=GC-ORD GO GC-FL4.
    IF LK-PART NOT=GC-PART GO GC-FL3. MOVE 1 TO A-S1.
GC-FL4.
GC-FL9. EXIT.
GC-DUP. PERFORM GC-DP1 THRU GC-DP9.
GC-DP1. MOVE 0 TO A-S1 INITIALIZE SL-KS MOVE GC-SLIP TO SL-SLIP.
    START SUBINV KEY>SL-KS REGARDLESS INVALID GO GC-DP6.
GC-DP3. READ SUBINV NEXT REGARDLESS END GO GC-DP6. IF SL-SLIP>GC-SLIP GO GC-DP6.
    MOVE SL-ORD TO OK-NO READ PURORD REGARDLESS INVALID GO GC-DP4.
    IF OK-VENDOR NOT=SJ-VEN MOVE "THIS SLIP WAS USED BEFORE WITH ANOTHER VENDOR"
      TO ERR-MESG PERFORM DSP-ERR MOVE 1 TO A-S1 GO GC-DP9.
GC-DP4. GO GC-DP3.
GC-DP6.
GC-DP9. EXIT.

* S-36 MODIFY SUBCONTRACTOR RECORD (subcontractor function)
GW1.
GW3. PERFORM RD167 PERFORM WRT.
    ACCEPT SJ-MAC LINE 3 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR SJ-MAC=999 GO GW9.
    MOVE SJ-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 PERFORM DSP-ERR23 GO GW3.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC DISPLAY M-OPDESC LINE 3 COLUMN 23.
GW33. ACCEPT LT-KEY LINE 4 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR LT-KEY=ALL "9" GO GW9. MOVE LT-KEY TO A-A1 PERFORM STR-LTH.
    IF LT-KEY(1:A-N1) NOT NUMERIC PERFORM DSP-ERR2 GO GW33.
    IF A-N1<7 MOVE 0 TO SJ-MO MOVE LT-NO(1:A-N1) TO SJ-MO(7 - A-N1:)
      INITIALIZE SJ-SUFFIX SJ-LOT GO GW34.
    READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO GW33.
    MOVE LT-NO TO SJ-LOT MOVE LT-MO TO SJ-MO MOVE LT-SUFFIX TO SJ-SUFFIX.
    DISPLAY LIT-SP(1:7) LINE 4 COLUMN 16 SJ-MO COLUMN 16 CONVERSION SJ-SUFFIX COLUMN 42.
    DISPLAY SJ-LOT LINE 5 COLUMN 17.
GW34. MOVE SJ-MO TO R-NO IF R-NO<=9999 PERFORM DSP-ERR11 GO GW33.
    READ PRODORD REGARDLESS INVALID MOVE " " TO R-PROD
      MOVE "INVALID M.O. NO." TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO GW33 END-IF.
    MOVE R-PROD TO SJ-PROD.
    ACCEPT SJ-PROD LINE 2 COLUMN 58 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT SJ-SUFFIX LINE 4 COLUMN 42 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF SJ-LOT=0 READ SUBCON REGARDLESS INVALID PERFORM DSP-ERR37 GO GW3 END-READ
       GO GW38.
GW35. READ SUBCON REGARDLESS INVALID GO GW36. GO GW38.
GW36. MOVE "SUBCONTRACTOR RECORD NOT FOUND - 'OK' TO ENTER A DIFFERENT M.O.: __" TO TMSG.
    PERFORM DSP-PROMPT IF XA3 NOT="OK" GO GW3.
    DISPLAY "ENTER M.O., OR LEAVE BLANK TO CANCEL: ______" LINE 24 BOLD.
    ACCEPT SJ-MO COLUMN 39 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF SJ-MO=0 GO GW3.
    DISPLAY LIT-SP(1:7) LINE 4 COLUMN 16 SJ-MO COLUMN 16 CONVERSION.
    GO GW35.
GW38. DISPLAY SJ-BUCKETS LINE 9 COLUMN 15 CONVERSION.
    MOVE SJ-WEIGHT TO DSP-C61 DISPLAY DSP-C61 LINE 9 COLUMN 23 CONVERSION.
    DISPLAY SJ-IBUCKETS LINE 10 COLUMN 15 CONVERSION.
    MOVE SJ-IWEIGHT TO DSP-C61 DISPLAY DSP-C61 LINE 10 COLUMN 23 CONVERSION.
    DISPLAY "TO DELETE THIS RECORD SET THE ORIGINAL BUCKETS AND WEIGHT TO 0" LINE 24 BOLD.

    ACCEPT SJ-BUCKETS LINE 9 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY SJ-BUCKETS LINE 9 COLUMN 15 CONVERSION.
    ACCEPT SJ-WEIGHT LINE 9 COLUMN 23 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE SJ-WEIGHT TO DSP-C61 DISPLAY DSP-C61 LINE 9 COLUMN 23 CONVERSION.

    PERFORM DSP-ERS IF NOT(SJ-BUCKETS=0 AND SJ-WEIGHT=0) GO GW4.
    MOVE "'DEL' TO CONFIRM DELETION: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="DEL" DELETE SUBCON MOVE "RECORD DELETED" TO TMSG PERFORM DSP-MSGCONT
      ELSE PERFORM DSP-CONT.
    GO GW8.
GW4. ACCEPT SJ-IBUCKETS LINE 10 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY SJ-IBUCKETS LINE 10 COLUMN 15 CONVERSION.
    ACCEPT SJ-IWEIGHT LINE 10 COLUMN 23 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE SJ-IWEIGHT TO DSP-C61 DISPLAY DSP-C61 LINE 10 COLUMN 23 CONVERSION.
    REWRITE SJ-RECORD ALLOWING NO UNLOCK SUBCON PERFORM DSP-CONT.
GW8. GO GW3.
GW9. GO MN9.

* I: PHYSICAL INVENTORY FUNCTIONS

* I-1 TICKET ENTRY
DB1.
DB13. MOVE 0 TO DB-NO DB-DATE.
DB3. PERFORM RD56 PERFORM WRT MOVE LOW-VALUES TO PI-RECORD INITIALIZE PI-REC.
    IF DB-DATE=0 MOVE 1 TO IXT MOVE 47 TO IXU PERFORM AX-DT-VAL
      MOVE DATE0 TO DB-DATE D-DATE MOVE 30 TO D-N1 D-N2
      PERFORM D-CHKDTR IF D-ERR=1 GO DB13 END-IF
     ELSE MOVE DB-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 1 COLUMN 47.
    MOVE DB-NO TO R-NO DISPLAY R-NO LINE 3 COLUMN 12 CONVERSION.
DB35. ACCEPT R-NO LINE 3 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO DB9. DISPLAY R-NO LINE 3 COLUMN 12 CONVERSION.
    PERFORM RDF-PRODORD IF A-S1=1 GO DB35. MOVE R-NO TO DB-NO.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO DB35.
    PERFORM PROD-DESC DISPLAY P-NO LINE 3 COLUMN 35 PRO-DESC(1) COLUMN 49.
DB37. ACCEPT PI-NO LINE 5 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF PI-NO=0 PERFORM DSP-ERR2 GO DB37. READ PHYSINV REGARDLESS INVALID GO DB4.
    MOVE "DUPLICATE TICKET NO. - 'DEL' TO DELETE THE OLD ONE: ___" TO TMSG.
    PERFORM DSP-PROMPT IF XA3="DEL" DELETE PHYSINV GO DB3. GO DB37.
DB4.
DB43. ACCEPT DB-WEIGHT LINE 7 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DB-WEIGHT>1500 MOVE "WEIGHT EXCEEDS 1500 LBS" TO ERR-MESG PERFORM DSP-OK
      IF XA2 NOT="OK" GO DB43.
    IF DB-WEIGHT NOT=0
      COMPUTE DB-QTY ROUNDED=DB-WEIGHT * 100 / P-WEIGHT SIZE ERROR MOVE 0 TO DB-QTY END-COMPUTE
      DISPLAY DB-QTY LINE 7 COLUMN 60 CONVERSION
      GO DB48.
DB45. ACCEPT DB-CARTONS LINE 7 COLUMN 35 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DB-CARTONS=0 MOVE "THIS VALUE CANNOT BE 0" TO ERR-MESG PERFORM DSP-ERR GO DB45.
    DISPLAY "x" LINE 7 COLUMN 42 MOVE P-QTY-PACK TO DB-QTY-PACK.
    DISPLAY DB-QTY-PACK LINE 7 COLUMN 44 CONVERSION.
    ACCEPT DB-QTY-PACK LINE 7 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY DB-QTY-PACK LINE 7 COLUMN 44 CONVERSION.
    DISPLAY "=" LINE 7 COLUMN 51 COMPUTE DB-QTY=DB-CARTONS * DB-QTY-PACK.
    DISPLAY DB-QTY LINE 7 COLUMN 60 CONVERSION.
    COMPUTE DB-WEIGHT ROUNDED=DB-QTY * P-WEIGHT / 100.
DB48.
DB483. ACCEPT DB-CODE LINE 9 COLUMN 19 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(DB-CODE>=1 AND<=3) MOVE "INVALID CODE" TO ERR-MESG PERFORM DSP-OK
      IF XA2 NOT="OK" GO DB483.
DB485. ACCEPT DB-LOCATION LINE 9 COLUMN 43 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(DB-LOCATION>=1 AND<=6) MOVE "INVALID CODE" TO ERR-MESG PERFORM DSP-OK
      IF XA2 NOT="OK" GO DB485.
    MOVE "'CAN' TO CANCEL THIS TICKET: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="CAN" MOVE DB-DATE TO PI-DATE MOVE DB-NO TO PI-MO
      MOVE DB-QTY TO PI-QTY MOVE DB-WEIGHT TO PI-WEIGHT
      MOVE DB-CODE TO PI-CODE MOVE DB-LOCATION TO PI-LOCATION
      WRITE PI-RECORD ALLOWING NO UNLOCK PHYSINV.
    GO DB3.
DB9. GO MN9.

* I-2 MISSING TICKETS REPORT
HI1. PERFORM RD61 PERFORM WRT.
    ACCEPT HI-T1 LINE 4 COLUMN 26 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT HI-T2 LINE 4 COLUMN 54 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM HI-PAGE.
    MOVE HI-T1 TO PI-NO MOVE 1 TO PR-IXP.
HI3. IF PI-NO>HI-T2 GO HI9.
    READ PHYSINV REGARDLESS INVALID MOVE PI-NO TO FF136(PR-IXP)
      ADD 1 TO PR-IXP IF PR-IXP>16 PERFORM HI-LINE MOVE 1 TO PR-IXP END-IF.
    ADD 1 TO PI-NO GO HI3.
HI9. PERFORM PR-LINE PERFORM CLOSE-PR GO MN9.

HI-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HI-PAGE.
HI-PAGE. MOVE "PHYSICAL INVENTORY MISSING TICKETS REPORT" TO FF3.
    PERFORM PR-PAGE MOVE 2 TO WS-PR MOVE HI-T1 TO DSP-N61 MOVE HI-T2 TO DSP-N62.
    STRING "MISSING TICKET NUMBERS IN THE RANGE: " DSP-N61 " - " DSP-N62 DELIMITED SIZE
      INTO PREC PERFORM PR-LINE-3.

* I-3 TICKET LISTING
HU1. PERFORM RD390 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-SORT PERFORM OPEN-SORC PERFORM OPEN-PR.
    MOVE 1 TO HU-STEP PERFORM HU-PAGE.
    MOVE " " TO PI-KEY START PHYSINV KEY>PI-KEY REGARDLESS INVALID GO HU4.
HU3. READ PHYSINV NEXT REGARDLESS END GO HU4.
    MOVE PI-NO TO FF170 MOVE PI-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF171.
    MOVE PI-MO TO FF172 MOVE PI-CODE TO FF173 MOVE PI-LOCATION TO FF173A.
    MOVE PI-QTY TO FF174 MOVE PI-WEIGHT TO FF175 PERFORM HU-LINE.

    MOVE PI-CODE TO SR-F154 MOVE PI-QTY TO SR-F155 MOVE PI-WEIGHT TO SR-F156.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD PI-QTY TO SR-F155 ADD PI-WEIGHT TO SR-F156 REWRITE SR-RECORD.
    MOVE PI-LOCATION TO SC-F3 MOVE PI-QTY TO SC-F4 MOVE PI-WEIGHT TO SC-F5.
    WRITE SC-RECORD INVALID READ SORCFL
      ADD PI-QTY TO SC-F4 ADD PI-WEIGHT TO SC-F5 REWRITE SC-RECORD.
    GO HU3.

HU4. MOVE 2 TO HU-STEP PERFORM HU-PAGE.
    MOVE "SUMMARY BY COMPLETION CODE" TO PREC PERFORM HU-LINE 2 TIMES.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO HU6.
HU5. READ SORTFL NEXT END GO HU6.
    MOVE SR-F154 TO FF168 MOVE SR-F155 TO FF169 MOVE SR-F156 TO FF169A.
    PERFORM HU-LINE GO HU5.
HU6. MOVE 5 TO WS-PR MOVE "SUMMARY BY LOCATION CODE" TO PREC PERFORM HU-LINE 2 TIMES.
    MOVE " " TO SC-KEY START SORCFL KEY>SC-KEY INVALID GO HU9.
HU7. READ SORCFL NEXT END GO HU9.
    MOVE SC-F3 TO FF168 MOVE SC-F4 TO FF169 MOVE SC-F5 TO FF169A.
    PERFORM HU-LINE GO HU7.
HU9. PERFORM CLOSE-SORT PERFORM CLOSE-SORC PERFORM CLOSE-PR GO MN9.

HU-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HU-PAGE.
HU-PAGE. MOVE "PHYSICAL INVENTORY TICKET LISTING" TO FF3.
    IF HU-STEP=1 MOVE "** BY TICKET NUMBER **" TO FF4.
    IF HU-STEP=2 MOVE "** TICKET SUMMARY **" TO FF4. PERFORM PR-PAGE.
    IF HU-STEP=1 MOVE
         "TICKET    DATE      M.O.   COMPLETION  LOCATION      QTY          WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ......  ../../..  ......      ..         ..    ...,...,...-  ...,...,...-
    IF HU-STEP=2 MOVE
         "CODE      QTY          WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ..  ...,...,...-  ...,...,...-

* I-4 M.O. ADJUSTMENT AND REPORT
HS1. PERFORM RD391 PERFORM WRT.
    ACCEPT XA3 LINE 3 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO HS-KUP ELSE MOVE 0 TO HS-KUP.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-SORT.
    MOVE 0 TO PI-MO START PHYSINV KEY>PI-KM REGARDLESS INVALID GO HS24.
HS23. READ PHYSINV NEXT REGARDLESS END GO HS24.
    MOVE PI-MO TO SR-F100 WRITE SR-RECORD INVALID CONTINUE. GO HS23.
HS24.

    PERFORM OPEN-PR PERFORM HS-PAGE MOVE LOW-VALUES TO HS-GTOTALS.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO HS8.
HS3. READ SORTFL NEXT END GO HS8.
    MOVE SR-F100 TO R-NO READ PRODORD REGARDLESS INVALID GO HS3.
    MOVE LOW-VALUES TO HS-MTOTALS.
    MOVE R-NO TO FF176 PI-MO START PHYSINV KEY>=PI-KM REGARDLESS INVALID GO HS6.
HS5. READ PHYSINV NEXT REGARDLESS END GO HS6. IF PI-MO NOT=R-NO GO HS6.
    MOVE PI-NO TO FF177 MOVE PI-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF178.
    MOVE PI-CODE TO FF179 MOVE PI-WEIGHT TO FF180 MOVE PI-QTY TO FF181 PERFORM HS-LINE.
    ADD PI-QTY TO HS-MQ ADD PI-WEIGHT TO HS-MW.
    IF HS-KUP=0 GO HS58.
    PERFORM INIT-J MOVE R-NO TO J-NO MOVE 940 TO J-MAC.
    MOVE PI-DATE TO J-DATE MOVE R-PROD TO J-PROD.
    READ WORKSHEET REGARDLESS INVALID
      PERFORM SET-JKD WRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
    ADD PI-QTY TO J-QTY ADD PI-WEIGHT TO J-WEIGHT J-AWEIGHT.
    REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
HS58. GO HS5.
HS6. MOVE R-PROD TO A-A1 PERFORM PROD-GEN.
    MOVE R-OLD-LEFT TO HS-MLQ COMPUTE HS-MDQ=HS-MQ - HS-MLQ.
    COMPUTE HS-MDW ROUNDED=HS-MDQ * P-WEIGHT / 100.
    MOVE HS-MW TO FF180 MOVE HS-MQ TO FF181 MOVE HS-MLQ TO FF182.
    MOVE HS-MDW TO FF183 MOVE HS-MDQ TO FF184.
    MOVE HS-MDQ TO WN1 IF WN1<0 COMPUTE WN1=-WN1.
    IF WN1<R-OLD-PROD * 0.05 MOVE "***" TO FF185
      MOVE HS-MDW TO HS-MSW MOVE HS-MDQ TO HS-MSQ.
    PERFORM HS-LINE 2 TIMES.
    ADD HS-MW TO HS-GW ADD HS-MQ TO HS-GQ ADD HS-MLQ TO HS-GLQ.
    ADD HS-MDW TO HS-GDW ADD HS-MDQ TO HS-GDQ.
    ADD HS-MSW TO HS-GSW ADD HS-MSQ TO HS-GSQ.
    IF HS-KUP=1 PERFORM HS-W.
    GO HS3.
HS8. MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    MOVE HS-GW TO FF180 MOVE HS-GQ TO FF181 MOVE HS-GLQ TO FF182.
    MOVE HS-GDW TO FF183 MOVE HS-GDQ TO FF184 PERFORM PR-LINE-2.
    MOVE "** TOTAL WITH DIFFERENCE < 5% OF PRODUCED:" TO PREC(31:).
    MOVE HS-GSW TO FF183 MOVE HS-GSQ TO FF184 PERFORM PR-LINE.
    PERFORM HS-PAGE.

    MOVE "PRODUCTION ORDERS WITH QUANTITY LEFT AND NO INVENTORY TICKETS" TO PREC PERFORM HS-LINE 3 TIMES.
    MOVE LOW-VALUES TO HS-GTOTALS.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO HS88.
HS83. READ PRODORD NEXT REGARDLESS END GO HS88. IF R-OLD-LEFT=0 GO HS83.
    MOVE R-NO TO PI-MO READ PHYSINV REGARDLESS KEY PI-KM INVALID GO HS84. GO HS83.
HS84. MOVE R-NO TO FF176 MOVE LOW-VALUES TO HS-MTOTALS.
    MOVE R-PROD TO A-A1 PERFORM PROD-GEN.
    MOVE R-OLD-LEFT TO HS-MLQ COMPUTE HS-MDQ=HS-MQ - HS-MLQ.
    COMPUTE HS-MDW ROUNDED=HS-MDQ * P-WEIGHT / 100.
    MOVE HS-MW TO FF180 MOVE HS-MQ TO FF181 MOVE HS-MLQ TO FF182.
    MOVE HS-MDW TO FF183 MOVE HS-MDQ TO FF184 PERFORM HS-LINE.
    ADD HS-MW TO HS-GW ADD HS-MQ TO HS-GQ ADD HS-MLQ TO HS-GLQ.
    ADD HS-MDW TO HS-GDW ADD HS-MDQ TO HS-GDQ.
    IF HS-KUP=1 PERFORM HS-W. GO HS83.
HS88. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO PREC.
    MOVE HS-GW TO FF180 MOVE HS-GQ TO FF181 MOVE HS-GLQ TO FF182.
    MOVE HS-GDW TO FF183 MOVE HS-GDQ TO FF184 PERFORM PR-LINE.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR.
HS9. GO MN9.

HS-W. PERFORM INIT-J MOVE R-NO TO J-NO MOVE 956 TO J-MAC MOVE R-PROD TO J-PROD.
    COMPUTE J-WEIGHT=-HS-MDW COMPUTE J-QTY=-HS-MDQ.
    PERFORM SET-JKD WRITE J-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK WORKSHEET.
    ADD J-QTY TO R-QTY-REC PERFORM CALC-QLEFT REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
HS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HS-PAGE.
HS-PAGE. MOVE "PHYSICAL INVENTORY M.O. ADJUSTMENT" TO FF3.
    IF HS-KUP=0 MOVE "(REPORT ONLY - FILES NOT UPDATED)" TO FF4. PERFORM PR-PAGE.
    MOVE "  M.O.  TICKET    DATE   COMPL     WEIGHT - M.O. - QTY    PREV QTY LEFT       WEIGHT - DIFF - QTY     DIFF < 5% OF PRODUCED" TO PREC PERFORM PR-LINE-3.
*         ......  ......  ../../..  ..   ...,...,...- ...,...,...-    ...,...,...-   ...,...,...- ...,...,...-      ...

* I-5 SAVE CURRENT QUANTITY LEFT AND PRODUCED
HW1. PERFORM RD392 PERFORM WRT.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO HW4.
HW3. READ PRODORD NEXT REGARDLESS END GO HW4. MOVE 0 TO R-OLD-PROD R-OLD-LEFT.
    IF R-QTY-PROD>0 AND R-QTY-LEFT>0
      MOVE R-QTY-PROD TO R-OLD-PROD MOVE R-QTY-LEFT TO R-OLD-LEFT.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD GO HW3.
HW4.
HW9. GO MN9.

* I-6 PHYSICAL INVENTORY PRODUCT LISTING
HV1. PERFORM RD393 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO PI-KEY START PHYSINV KEY>PI-KEY REGARDLESS INVALID GO HV29.
HV23. READ PHYSINV NEXT REGARDLESS END GO HV29.
    MOVE PI-MO TO R-NO READ PRODORD REGARDLESS INVALID GO HV23.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO HV23.
    PERFORM INIT-RP MOVE P-CAT TO RP-F86 MOVE P-NO TO RP-F87.
    MOVE PI-KEY TO RP-F88 WRITE RP-RECORD GO HV23.
HV29. PERFORM OPEN-MAINTA PERFORM OPEN-PR MOVE 1 TO HV-STEP PERFORM HV-PAGE.
    MOVE LOW-VALUES TO HV-STOTALS HV-GTOTALS MOVE " " TO OLD-A MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO HV9.
HV3. READ REPFL NEXT END GO HV9. MOVE RP-F88 TO PI-KEY READ PHYSINV REGARDLESS.
    IF RP-F86=OLD-N GO HV34. IF OLD-N NOT=0 PERFORM HV-C.
    MOVE "CAT" TO FF204 MOVE RP-F86 TO FF205 PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF206.
    PERFORM HV-LINE 2 TIMES MOVE RP-F86 TO OLD-N MOVE " " TO OLD-A.
HV34. IF RP-F87=OLD-A GO HV4. MOVE RP-F87 TO OLD-A A-A1 PERFORM PROD-RD.
    MOVE P-NO TO FF208 MOVE PRO-DESC(1) TO FF209.
HV4. MOVE PI-QTY TO FF210 MOVE PI-WEIGHT TO FF211 PERFORM HV-LINE.
    ADD PI-QTY TO HV-SQ HV-GQ ADD PI-WEIGHT TO HV-SW HV-GW.
    IF P-MAC=99 ADD PI-QTY TO HV-SR HV-GR ADD PI-WEIGHT TO HV-SD HV-GD.
    MOVE P-CAT TO MFA-F33 MOVE PI-WEIGHT TO MFA-F34(1) WRITE MFA-RECORD GO HV3.
HV9. PERFORM HV-C MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO A-A1.
    MOVE HV-GTOTALS TO HV-XTOTALS PERFORM HV-P PERFORM PR-LINE.
    PERFORM CLOSE-REP CLOSE MAINTA.
    MOVE 2 TO HV-STEP PERFORM HV-PAGE MOVE 4 TO CTA-OP PERFORM CTA-ANALYSIS.
    PERFORM CLOSE-PR GO MN9.

HV-C. MOVE 2 TO WS-PR MOVE OLD-N TO DSP-N21.
    MOVE " " TO A-A1 STRING "**  CATEGORY " DSP-N21 " TOTALS" DELIMITED SIZE INTO A-A1.
    MOVE HV-STOTALS TO HV-XTOTALS PERFORM HV-P PERFORM HV-LINE 3 TIMES.
    MOVE LOW-VALUES TO HV-STOTALS.
HV-P. MOVE A-A1 TO FF209.
    MOVE HV-XQ TO FF210 MOVE HV-XW TO FF211 PERFORM PR-LINE.
    MOVE "          PURCHASED PARTS" TO FF209.
    MOVE HV-XR TO FF210 MOVE HV-XD TO FF211 PERFORM PR-LINE.
    MOVE "          NET" TO FF209.
    COMPUTE FF210=HV-XQ - HV-XR COMPUTE FF211=HV-XW - HV-XD.
HV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HV-PAGE.
HV-PAGE. MOVE "PHYSICAL INVENTORY PRODUCT LISTING" TO FF3.
    MOVE "** BY CATEGORY **" TO FF4 PERFORM PR-PAGE.
    IF HV-STEP=1 MOVE
         "PRODUCT       DESCRIPTION                           QTY        WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ..,...,...- ..,...,...-
    IF HV-STEP=2 MOVE 2 TO WS-PR PERFORM PR-LINE.

* I-7 RE-CREATE PHYSICAL INVENTORY FILE
HN1. PERFORM RD394 PERFORM WRT.
    MOVE 7 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    CLOSE PHYSINV OPEN OUTPUT PHYSINV ALLOWING NO CLOSE PHYSINV.
    OPEN I-O PHYSINV ALLOWING ALL.
HN9. GO MN9.

* I-8 BIN REPORT (PRODUCT BINS)
HB1. PERFORM RD67 PERFORM WRT MOVE 0 TO HB-RN MOVE 2 TO IXT.
HB13. ADD 1 TO HB-RN IXT.
    ACCEPT HB-BIN LINE IXT COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF HB-BIN=" " SUBTRACT 1 FROM HB-RN GO HB14. MOVE HB-BIN TO RALP1(HB-RN).
    ACCEPT HB-BIN LINE IXT COLUMN 30 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE HB-BIN TO RALP2(HB-RN) IF HB-RN<10 GO HB13.
HB14. MOVE 14 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 0 TO HB-IX1.
HB23. ADD 1 TO HB-IX1 IF HB-IX1>HB-RN GO HB9.
    MOVE RALP1(HB-IX1) TO BIN1 MOVE RALP2(HB-IX1) TO BIN2 PERFORM HB-PAGE.
    MOVE BIN1 TO B-KEY START BIN KEY>=B-KEY REGARDLESS INVALID GO HB8.
HB3. READ BIN NEXT REGARDLESS END GO HB8. IF B-NO>BIN2 GO HB8.
    MOVE B-NO TO FA237 MOVE B-QTY TO FA243 MOVE B-CONT TO FA244A.
    IF B-PROD=" " GO HB6.
    MOVE B-PROD TO FA238 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FA239.
    IF B-CONT="B" MOVE "BUCKETS" TO PREC(56:7) GO HB4.
    DIVIDE B-QTY BY B-QTY-PACK GIVING WN1 REMAINDER WN2 SIZE ERROR MOVE 0 TO WN1 WN2.
    IF WN1>0 MOVE WN1 TO FA240. IF B-QTY-PACK>0 MOVE B-QTY-PACK TO FA241.
    IF WN2>0 MOVE WN2 TO FA242.
HB4. IF B-QTY>0 PERFORM NUM-NUTS MOVE PRO-NNUT TO WN1
      IF B-CONT="N" MOVE 0 TO WN1 END-IF
      COMPUTE FA244 ROUNDED=B-QTY * (P-WEIGHT + WN1 * P-WEIGHT-NUT) / 100.
HB6. PERFORM HB-LINE GO HB3.
HB8. GO HB23.
HB9. PERFORM CLOSE-PR GO MN9.

HB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HB-PAGE.
HB-PAGE. MOVE "PHYSICAL INVENTORY BIN REPORT" TO FF3.
    MOVE "(PRODUCT BINS)" TO FF4 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-BIN.
    MOVE "BIN    PRODUCT       DESCRIPTION                       CTNS X QTY + PART CTN =  PIECES    WEIGHT   CONTNR" TO PREC PERFORM PR-LINE-3.
*         .....  ............  ................................  ... ..,...    ..,... ..,...,...   ...,...     .

* I-9 BIN REPORT (PART BINS)
HD1. PERFORM RD68 PERFORM WRT MOVE 0 TO HD-RN MOVE 2 TO IXT.
HD13. ADD 1 TO HD-RN IXT.
    ACCEPT HD-BIN LINE IXT COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF HD-BIN=" " SUBTRACT 1 FROM HD-RN GO HD14. MOVE HD-BIN TO RALP1(HD-RN).
    ACCEPT HD-BIN LINE IXT COLUMN 30 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE HD-BIN TO RALP2(HD-RN) IF HD-RN<10 GO HD13.
HD14. MOVE 14 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 0 TO HD-IX1.
HD23. ADD 1 TO HD-IX1 IF HD-IX1>HD-RN GO HD9.
    MOVE RALP1(HD-IX1) TO PBIN1 MOVE RALP2(HD-IX1) TO PBIN2 PERFORM HD-PAGE.
    MOVE PBIN1 TO BH-KEY START PURBIN KEY>=BH-KEY REGARDLESS INVALID GO HD8.
HD3. READ PURBIN NEXT REGARDLESS END GO HD8. IF BH-NO>PBIN2 GO HD8.
    MOVE BH-NO TO FA245 MOVE BH-QTY TO FA248 IF BH-PART=" " GO HD6.
    MOVE BH-PART TO FA246 PH-NO READ PART REGARDLESS INVALID
      MOVE "*** NO PART RECORD ***" TO FA247 GO HD6.
    MOVE PH-DESC1 TO FA247 PERFORM PART-TYPE.
    IF PART-MAT MOVE BH-PCODE TO FA249 MOVE BH-COILS TO FA250 MOVE BH-HEAT TO FA250A.
HD6. PERFORM HD-LINE GO HD3.
HD8. GO HD23.
HD9. PERFORM CLOSE-PR GO MN9.

HD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HD-PAGE.
HD-PAGE. MOVE "PHYSICAL INVENTORY BIN REPORT" TO FF3 MOVE "(PART BINS)" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR PERFORM PRANGE-PBIN.
    MOVE "BIN       PART NO.      DESCRIPTION                          QTY   PROC  COILS  HEAT" TO PREC PERFORM PR-LINE-3.
*         ........  ............  ................................ ...,...-    .    ...-  ..........

* I-10 UPDATE PRODUCT RECORDS FROM BINS
WC1. PERFORM RD395 PERFORM WRT.
    MOVE 2 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO WC14.
WC13. READ PRODUCT NEXT REGARDLESS END GO WC14.
    IF P-HAND NOT=0 MOVE 0 TO P-HAND REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    GO WC13.
WC14. MOVE " " TO WC-OPROD MOVE 0 TO WC-QTY INITIALIZE B-KP.
    START BIN KEY>B-KP REGARDLESS INVALID GO WC9.
WC3. READ BIN NEXT REGARDLESS END PERFORM WC-P GO WC9.
    IF B-PROD NOT=WC-OPROD IF WC-OPROD>" " PERFORM WC-P END-IF
      MOVE B-PROD TO WC-OPROD MOVE 0 TO WC-QTY.
    ADD B-QTY TO WC-QTY GO WC3.
WC9. GO MN9.

WC-P. PERFORM WC-P1 THRU WC-P9.
WC-P1. MOVE WC-OPROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO WC-P9.
    ADD WC-QTY TO P-HAND REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
WC-P9. EXIT.

* I-11 UPDATE PART RECORDS FROM BINS
WH1. PERFORM RD396 PERFORM WRT.
    MOVE 2 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO WH9.
WH3. READ PART NEXT REGARDLESS END GO WH9. PERFORM PART-TYPE.
    MOVE 0 TO PH-HAND.
    IF PART-MAT PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      MOVE 0 TO PH-PROC-HAND(IX1) END-PERFORM.
    INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO WH6.
WH5. READ PURBIN NEXT REGARDLESS END GO WH6. IF BH-PART NOT=PH-NO GO WH6.
* note 223
    IF BH-NO(1:2)="SQ" GO WH5. ADD BH-QTY TO PH-HAND.
    IF PART-MAT IF BH-PCODE<=8 ADD BH-QTY TO PH-PROC-HAND(BH-PCODE + 1).
    GO WH5.
WH6. REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO WH3.
WH9. GO MN9.

* I-12 MODIFY SAVED QUANTITY LEFT AND PRODUCED
WZ1.
WZ3. PERFORM RD210 PERFORM WRT.
    ACCEPT R-NO LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO WZ9.
    READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO WZ3.
    DISPLAY R-OLD-LEFT LINE 3 COLUMN 45 CONVERSION.
    DISPLAY R-OLD-PROD LINE 4 COLUMN 45 CONVERSION.
    ACCEPT R-OLD-LEFT LINE 3 COLUMN 45 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY R-OLD-LEFT LINE 3 COLUMN 45 CONVERSION.
    ACCEPT R-OLD-PROD LINE 4 COLUMN 45 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY R-OLD-PROD LINE 4 COLUMN 45 CONVERSION.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD GO WZ3.
WZ9. GO MN9.

* B: Q BINS FUNCTIONS

* B-1 Q BINS FILE MAINTENANCE
QM1. PERFORM OPEN-AUDIT.
QM3. PERFORM RD82 PERFORM WRT PERFORM INIT-QB.
QM33. ACCEPT QB-NO LINE 3 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR QB-NO=ALL "9" GO QM9.
    IF QB-NO(1:1) NOT="Q" MOVE "MUST BE A 'Q' BIN" TO ERR-MESG PERFORM DSP-ERR GO QM33.
    READ QBIN REGARDLESS INVALID MOVE 0 TO QM-KFIN GO QM4. MOVE 1 TO QM-KFIN.
    DISPLAY QB-DM LINE 11 COLUMN 10 CONVERSION.
    MOVE QB-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 11 COLUMN 29.
    DISPLAY QB-PROD LINE 13 COLUMN 11.
    DISPLAY QB-QTY LINE 13 COLUMN 35 CONVERSION.
    DISPLAY QB-LOT LINE 13 COLUMN 57.
    DISPLAY QB-NOTE LINE 15 COLUMN 9.
QM4.
QM5. PERFORM DSP-NEXT ACCEPT QM-OP LINE 3 COLUMN 54 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF QM-OP=0 GO QM3. IF QM-OP>4 PERFORM DSP-ERR1 GO QM5.
    IF QM-OP=1 AND QM-KFIN=1 MOVE "DUPLICATE Q BIN NO." TO ERR-MESG
      PERFORM DSP-ERR GO QM3.
    IF (QM-OP=2 OR 3 OR 4) AND QM-KFIN=0 PERFORM DSP-ERR30 GO QM3.
    IF QM-OP=1 OR 2 GO QM6. IF QM-OP=3 PERFORM QM-AUDIT DELETE QBIN GO QM3.

* op=4
    PERFORM QM-AUDIT.
    MOVE " " TO QB-PROD QB-NOTE MOVE 0 TO QB-LYEAR QB-LOT QB-DATE QB-DM QB-QTY.
    REWRITE QB-RECORD ALLOWING NO UNLOCK QBIN GO QM3.

QM6. ACCEPT QB-DM LINE 11 COLUMN 10 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO QM8.
    DISPLAY QB-DM LINE 11 COLUMN 10 CONVERSION.
    MOVE QB-DATE TO D-DATE MOVE 11 TO IXT MOVE 29 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO QM8. MOVE DATE0 TO QB-DATE.
    ACCEPT QB-PROD LINE 13 COLUMN 11 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO QM8.
    ACCEPT QB-QTY LINE 13 COLUMN 35 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO QM8.
    DISPLAY QB-QTY LINE 13 COLUMN 35 CONVERSION.
    ACCEPT QB-LOT LINE 13 COLUMN 57 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO QM8.
    DISPLAY QB-LOT LINE 13 COLUMN 57.
    ACCEPT QB-NOTE LINE 15 COLUMN 9 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO QM8.
QM8. MOVE QB-LOT TO D-LOT PERFORM D-LOTDATE MOVE D-YEAR TO QB-LYEAR.
    IF QM-OP=1 WRITE QB-RECORD ALLOWING NO ELSE REWRITE QB-RECORD ALLOWING NO.
    UNLOCK QBIN PERFORM QM-AUDIT PERFORM DSP-CONT GO QM3.
QM9. CLOSE AUDIT GO MN9.

QM-AUDIT. MOVE QM-DES(QM-OP) TO IE21 MOVE QB-NO TO IE22 MOVE QB-DM TO IE23.
    MOVE QB-DATE TO IE24 MOVE QB-PROD TO IE25 MOVE QB-QTY TO IE26.
    MOVE QB-LOT TO IE27 MOVE QB-NOTE TO IE28.
    MOVE TD-INP-R2 TO AU-DATA MOVE 2 TO AU-K PERFORM ADD-AUD.

* B-2 Q BINS LISTING
QR1. PERFORM RD397 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM QR-PAGE.
    MOVE " " TO QB-KEY START QBIN KEY>QB-KEY REGARDLESS INVALID GO QR9.
QR3. READ QBIN NEXT REGARDLESS END GO QR9.
    IF QB-PROD=" " AND QB-DATE=0 AND QB-DM=0 AND QB-QTY=0 GO QR3.
    MOVE QB-NO TO FF327 MOVE QB-PROD TO FF328 A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO FF329 MOVE QB-QTY TO FF330 MOVE QB-LOT TO FF331.
    MOVE QB-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF332.
    MOVE QB-DM TO FF333 PERFORM PR-LINE.
    MOVE QB-NOTE TO FF335 PERFORM QR-LINE GO QR3.
QR9. PERFORM CLOSE-PR GO MN9.

QR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QR-PAGE.
QR-PAGE. MOVE "Q BINS LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE "BIN    PRODUCT       DESCRIPTION                           QTY       LOT    SINCE     DM #   NOTES" TO PREC PERFORM PR-LINE-3.
*         .....  ............  ................................ ..,...,...- .......  ../../.. ......
*                                                                                    ..................................................

* P: PURCHASING AND ACCOUNTS PAYABLE FUNCTIONS

* P-1 PART FILE MAINTENANCE
PM1.
PM3. PERFORM RD112 PERFORM WRT.
    ACCEPT PM-NO LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO PM9. IF PM-NO=" " PERFORM DSP-ERR3 GO PM3.
    ACCEPT PM-OP LINE 3 COLUMN 42 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF PM-OP=9 GO PM9.
    GO PM40 PM50 PM60 PM70 PM80 PM82  DEPENDING PM-OP. PERFORM DSP-ERR1 GO PM3.
PM40. PERFORM INIT-PH MOVE PM-NO TO PH-NO.
    MOVE SYS-DATE TO PH-CRDATE START PART REGARDLESS INVALID GO PM42.
    MOVE "DUPLICATE PART NO." TO ERR-MESG PERFORM DSP-ERR GO PM3.
    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
PM42. PERFORM RD113 MOVE PH-NO TO TF270(1) PERFORM WRT.
    MOVE 3 TO IXT MOVE 22 TO IXU MOVE 0 TO A-S1 PERFORM AX-NY MOVE A-S1 TO PH-ASM.
    ACCEPT PH-MODE LINE 3 COLUMN 48 ACC-ALP.
    ACCEPT PH-UNIT LINE 3 COLUMN 74 ACC-ALP.
    ACCEPT PH-DRAW LINE 5 COLUMN 11 ACC-ALP.
    ACCEPT PH-REV LINE 5 COLUMN 38 ACC-ALP.
    ACCEPT PH-LIFE LINE 5 COLUMN 58 ACC-NUM.
    ACCEPT PH-CAT LINE 6 COLUMN 12 ACC-NUM.
    ACCEPT PH-MATERIAL LINE 6 COLUMN 28 ACC-ALP.
    ACCEPT PH-DESC1 LINE 7 COLUMN 15 ACC-ALP.
    ACCEPT PH-DESC2 LINE 8 COLUMN 15 ACC-ALP.
    ACCEPT PH-VENDOR(1) LINE 9 COLUMN 12 ACC-NUM.
    ACCEPT PH-VENDOR(2) LINE 9 COLUMN 33 ACC-NUM.
    ACCEPT PH-VENDOR(3) LINE 9 COLUMN 54 ACC-NUM.
    ACCEPT PH-PRICE(1) LINE 10 COLUMN 11 ACC-NUM.
    ACCEPT PH-PRICE(2) LINE 10 COLUMN 32 ACC-NUM.
    ACCEPT PH-PRICE(3) LINE 10 COLUMN 53 ACC-NUM.
    ACCEPT PH-ROP LINE 12 COLUMN 15 ACC-NUM.
    ACCEPT PH-EOQ LINE 12 COLUMN 48 ACC-NUM.
    ACCEPT PH-LEVEL LINE 12 COLUMN 74 ACC-NUM.
    ACCEPT PH-HAND LINE 14 COLUMN 15 ACC-NUM.
    ACCEPT PH-ORDER LINE 14 COLUMN 41 ACC-NUM.
    ACCEPT PH-DEMAND LINE 14 COLUMN 68 ACC-NUM.
    ACCEPT PH-MTD LINE 15 COLUMN 11 ACC-NUM.
    ACCEPT PH-YTD LINE 15 COLUMN 34 ACC-NUM.
    ACCEPT PH-LAST LINE 15 COLUMN 61 ACC-NUM.
    ACCEPT PH-AMTD LINE 16 COLUMN 13 ACC-NUM.
    ACCEPT PH-AYTD LINE 16 COLUMN 36 ACC-NUM.
    ACCEPT PH-ALAST LINE 16 COLUMN 63 ACC-NUM.
    ACCEPT PH-MTYPE LINE 18 COLUMN 16 ACC-NUM.
    ACCEPT PH-TAX LINE 18 COLUMN 33 ACC-NUM.
    ACCEPT PH-HCODE LINE 18 COLUMN 54 ACC-NUM.
    MOVE PH-NO TO PH-KANO PH-KVNO WRITE PH-RECORD ALLOWING NO UNLOCK PART GO PM3.
    REPLACE OFF.
PM50. MOVE PM-NO TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO PM3.
    PERFORM RD114 MOVE PH-NO TO TF210(3) PERFORM WRT PERFORM RD114A PERFORM WRT.
PM53. ACCEPT PM-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO PM551 PM552 PM553 PM554 PM555 PM556 PM557 PM558 PM559 PM5510
       PM5511 PM5512 PM5513 PM5514 PM5515 PM5516 PM5517 PM5518 PM5519 PM5520
       PM5521 PM5522 PM5523 PM5524 PM5525 PM5526 PM5527 PM5528 PM5529 PM5530
       PM5531 PM5532 PM5533 PM5534 PM5535
      DEPENDING PM-FLD. GO PM3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
PM551. DISPLAY PH-DRAW COLUMN 30 BOLD ACCEPT PH-DRAW ACC-ALP.
    MOVE PH-DRAW TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-DRAW GO PM58.
PM552. DISPLAY PH-CAT COLUMN 30 CONVERSION BOLD ACCEPT PH-CAT ACC-NUM.
    MOVE PH-CAT TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-CAT GO PM58.
PM553. DISPLAY PH-MODE COLUMN 30 BOLD ACCEPT PH-MODE ACC-ALP.
    MOVE PH-MODE TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-MODE GO PM58.
PM554. DISPLAY PH-UNIT COLUMN 30 BOLD ACCEPT PH-UNIT ACC-ALP.
    MOVE PH-UNIT TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-UNIT GO PM58.
PM555. DISPLAY PH-DESC1 COLUMN 30 BOLD ACCEPT PH-DESC1 ACC-ALP.
    MOVE PH-DESC1 TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-DESC1 GO PM58.
PM556. DISPLAY PH-DESC2 COLUMN 30 BOLD ACCEPT PH-DESC2 ACC-ALP.
    MOVE PH-DESC2 TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-DESC2 GO PM58.
PM557. DISPLAY PH-MATERIAL COLUMN 30 BOLD ACCEPT PH-MATERIAL ACC-ALP.
    MOVE PH-MATERIAL TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-MATERIAL GO PM58.
PM558. DISPLAY PH-VENDOR(1) COLUMN 30 CONVERSION BOLD ACCEPT PH-VENDOR(1) ACC-NUM.
    MOVE PH-VENDOR(1) TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-VENDOR(1) GO PM58.
PM559. DISPLAY PH-VENDOR(2) COLUMN 30 CONVERSION BOLD ACCEPT PH-VENDOR(2) ACC-NUM.
    MOVE PH-VENDOR(2) TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-VENDOR(2) GO PM58.
PM5510. DISPLAY PH-VENDOR(3) COLUMN 30 CONVERSION BOLD ACCEPT PH-VENDOR(3) ACC-NUM.
    MOVE PH-VENDOR(3) TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-VENDOR(3) GO PM58.
PM5511. DISPLAY PH-PRICE(1) COLUMN 30 CONVERSION BOLD ACCEPT PH-PRICE(1) ACC-NUM.
    MOVE PH-PRICE(1) TO WT1 PERFORM RDLK-PART MOVE WT1 TO PH-PRICE(1) GO PM58.
PM5512. DISPLAY PH-PRICE(2) COLUMN 30 CONVERSION BOLD ACCEPT PH-PRICE(2) ACC-NUM.
    MOVE PH-PRICE(2) TO WT1 PERFORM RDLK-PART MOVE WT1 TO PH-PRICE(2) GO PM58.
PM5513. DISPLAY PH-PRICE(3) COLUMN 30 CONVERSION BOLD ACCEPT PH-PRICE(3) ACC-NUM.
    MOVE PH-PRICE(3) TO WT1 PERFORM RDLK-PART MOVE WT1 TO PH-PRICE(3) GO PM58.
PM5514. DISPLAY PH-ALIFE COLUMN 30 CONVERSION BOLD ACCEPT PH-ALIFE ACC-NUM.
    MOVE PH-ALIFE TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-ALIFE GO PM58.
PM5515. DISPLAY PH-HAND COLUMN 30 CONVERSION BOLD ACCEPT PH-HAND ACC-NUM.
    MOVE PH-HAND TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-HAND GO PM58.
PM5516. DISPLAY PH-ORDER COLUMN 30 CONVERSION BOLD ACCEPT PH-ORDER ACC-NUM.
    MOVE PH-ORDER TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-ORDER GO PM58.
PM5517. DISPLAY PH-DEMAND COLUMN 30 CONVERSION BOLD ACCEPT PH-DEMAND ACC-NUM.
    MOVE PH-DEMAND TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-DEMAND GO PM58.
PM5518. DISPLAY PH-ROP COLUMN 30 CONVERSION BOLD ACCEPT PH-ROP ACC-NUM.
    MOVE PH-ROP TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-ROP GO PM58.
PM5519. DISPLAY PH-MTD COLUMN 30 CONVERSION BOLD ACCEPT PH-MTD ACC-NUM.
    MOVE PH-MTD TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-MTD GO PM58.
PM5520. DISPLAY PH-YTD COLUMN 30 CONVERSION BOLD ACCEPT PH-YTD ACC-NUM.
    MOVE PH-YTD TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-YTD GO PM58.
PM5521. DISPLAY PH-LAST COLUMN 30 CONVERSION BOLD ACCEPT PH-LAST ACC-NUM.
    MOVE PH-LAST TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-LAST GO PM58.
PM5522. DISPLAY PH-AMTD COLUMN 30 CONVERSION BOLD ACCEPT PH-AMTD ACC-NUM.
    MOVE PH-AMTD TO WD1 PERFORM RDLK-PART MOVE WD1 TO PH-AMTD GO PM58.
PM5523. DISPLAY PH-AYTD COLUMN 30 CONVERSION BOLD ACCEPT PH-AYTD ACC-NUM.
    MOVE PH-AYTD TO WD1 PERFORM RDLK-PART MOVE WD1 TO PH-AYTD GO PM58.
PM5524. DISPLAY PH-ALAST COLUMN 30 CONVERSION BOLD ACCEPT PH-ALAST ACC-NUM.
    MOVE PH-ALAST TO WD1 PERFORM RDLK-PART MOVE WD1 TO PH-ALAST GO PM58.
PM5525. MOVE PH-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT COLUMN 30 BOLD.
    MOVE PH-DATE TO D-DATE MOVE 21 TO IXT MOVE 30 TO IXU.
    PERFORM AX-DT-DEF MOVE DATE0 TO PH-DATE.
    MOVE PH-DATE TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-DATE GO PM58.
PM5526. DISPLAY PH-MTYPE COLUMN 30 CONVERSION BOLD ACCEPT PH-MTYPE ACC-NUM.
    MOVE PH-MTYPE TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-MTYPE GO PM58.
PM5527. DISPLAY PH-TAX COLUMN 30 CONVERSION BOLD ACCEPT PH-TAX ACC-NUM.
    MOVE PH-TAX TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-TAX GO PM58.
PM5528. DISPLAY PH-HCODE COLUMN 30 CONVERSION BOLD ACCEPT PH-HCODE ACC-NUM.
    MOVE PH-HCODE TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-HCODE GO PM58.
PM5529. DISPLAY PH-LIFE COLUMN 30 CONVERSION BOLD ACCEPT PH-LIFE ACC-NUM.
    MOVE PH-LIFE TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-LIFE GO PM58.
PM5530. DISPLAY PH-REV COLUMN 30 BOLD ACCEPT PH-REV ACC-ALP.
    MOVE PH-REV TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-REV GO PM58.
PM5531. DISPLAY PH-EOQ COLUMN 30 CONVERSION BOLD ACCEPT PH-EOQ ACC-NUM.
    MOVE PH-EOQ TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-EOQ GO PM58.
PM5532. DISPLAY PH-LEVEL COLUMN 30 CONVERSION BOLD ACCEPT PH-LEVEL ACC-NUM.
    MOVE PH-LEVEL TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-LEVEL GO PM58.
PM5533. IF PH-ASM<=1 DISPLAY LIT-NY(PH-ASM + 1:1) COLUMN 30 BOLD.
    MOVE 21 TO IXT MOVE 30 TO IXU MOVE PH-ASM TO A-S1 PERFORM AX-NY MOVE A-S1 TO PH-ASM.
    MOVE PH-ASM TO WN1 PERFORM RDLK-PART MOVE WN1 TO PH-ASM GO PM58.
PM5534. DISPLAY PH-TCOST COLUMN 30 CONVERSION BOLD ACCEPT PH-TCOST ACC-NUM.
    MOVE PH-TCOST TO WT1 PERFORM RDLK-PART MOVE WT1 TO PH-TCOST GO PM58.
PM5535. DISPLAY PH-LDCOST COLUMN 30 CONVERSION BOLD ACCEPT PH-LDCOST ACC-NUM.
    MOVE PH-LDCOST TO WT1 PERFORM RDLK-PART MOVE WT1 TO PH-LDCOST GO PM58.
PM58. REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO PM53.
    REPLACE OFF.
PM60. MOVE PM-NO TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO PM3.
    IF PH-DESC1=" " DELETE PART ELSE PERFORM DSP-ERR60. GO PM3.

PM70. MOVE PM-NO TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO PM3.
    MOVE PM-NO TO A-A1 PERFORM STR-LTH MOVE A-N1 TO PM-LTH.
    IF PM-LTH>9 MOVE "PART NO. IS TOO LONG TO USE AS TEMPLATE"
      TO ERR-MESG PERFORM DSP-ERR GO PM3.
    MOVE " " TO WA1 STRING PM-NO DELIMITED " " "-1, " DELIMITED SIZE
      PM-NO DELIMITED " " "-2, ..." DELIMITED SIZE INTO WA1.
    MOVE WA1 TO A-A1 PERFORM STR-LTH.
    DISPLAY "THIS FUNCTION WILL CREATE PART RECORDS " LINE 15 WA1(1:A-N1).
    MOVE PM-NO TO A-A1 PERFORM STR-LTH.
    DISPLAY "  UP TO THE SUFFIX SPECIFIED, ALL IDENTICAL TO PART " LINE 16 PM-NO(1:A-N1) ".".
    DISPLAY "PARTS THAT ALREADY EXIST IN THIS RANGE WILL BE LEFT UNCHANGED." LINE 17.
    DISPLAY "YOU CAN THEN DELETE THE TEMPLATE RECORD. TO CANCEL, LEAVE SUFFIX BLANK." LINE 18.

    DISPLAY "HIGHEST SUFFIX TO CREATE: __" LINE 21 BOLD.
    ACCEPT PM-SMAX COLUMN 27 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF PM-SMAX=0 GO PM3. IF PM-SMAX=99 MOVE 98 TO PM-SMAX. PERFORM DSP-QWAIT.
    MOVE 1 TO PM-S.
PM73. MOVE "-" TO PH-NO(PM-LTH + 1:1).
    IF PM-S<10 MOVE PM-S(2:1) TO PH-NO(PM-LTH + 2:1)
      ELSE MOVE PM-S TO PH-NO(PM-LTH + 2:2).
    MOVE PH-NO TO PH-KANO PH-KVNO WRITE PH-RECORD ALLOWING NO INVALID CONTINUE.
    UNLOCK PART ADD 1 TO PM-S IF PM-S<=PM-SMAX GO PM73. GO PM3.

PM80. MOVE PM-NO TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO PM3.
    MOVE 15 TO IXT DISPLAY "ALTERNATE PART:" LINE IXT BOLD.
    MOVE PH-ALT TO PART-ALT MOVE 17 TO IXU PERFORM AX-PALT.
    PERFORM RDLK-PART MOVE PART-ALT TO PH-ALT.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO PM3.
PM82. MOVE PM-NO TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO PM3.
    MOVE 15 TO IXT DISPLAY "VENDOR PART NO.: ________________________" LINE IXT BOLD.
    ACCEPT PH-VNUM LINE IXT COLUMN 18 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE PH-VNUM TO WA1 PERFORM RDLK-PART MOVE WA1 TO PH-VNUM.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO PM3.
PM9. GO MN9.

* P-2 PART INFORMATION
PJ1. PERFORM RD118 PERFORM WRT.
PJ3. ACCEPT PH-NO LINE 23 COLUMN 64 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR PH-NO=ALL "9" GO PJ9.
    READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO PJ3. PERFORM PART-TYPE.
    PERFORM RD118 MOVE PH-NO TO TF214(1) PERFORM DRAW-EXP-PH MOVE A-A2 TO TF215(1).
    IF PH-ASM<=1 MOVE LIT-NY(PH-ASM + 1:1) TO TF216(1).
    MOVE PH-DESC1 TO TF217(2) MOVE PH-DESC2 TO TF217(3).
    MOVE PH-CAT TO TF218(4) MOVE PH-MODE TO TF219(4) MOVE PH-UNIT TO TF220(4).
    MOVE PH-ALT TO PART-ALT PERFORM SET-PALT MOVE PART-PRINT TO TF221(4).
    MOVE PH-MATERIAL TO TF225(5) MOVE PH-VNUM TO TF226(5).
    MOVE PH-LDCOST TO TF227(7) MOVE PH-TCOST TO TF227(8).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE PH-VENDOR(IX1) TO TF228(7,IX1) MOVE PH-PRICE(IX1) TO TF229(8,IX1) END-PERFORM.
    MOVE PH-ROP TO TF230(9) MOVE PH-EOQ TO TF231(9).
    MOVE PH-LEVEL TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO TF232(9).
    MOVE PH-LIFE TO TF222(10) MOVE PH-ALIFE TO TF223(10).
    MOVE PH-HAND TO TF247(11).
    IF PART-TOOL AND PH-ASM=0
      MOVE " !IN ASSEMBLIES]" TO TF248(11) MOVE PH-ASM-HAND TO TF249(11).
    IF PART-MAT
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
        COMPUTE TF250(11,IX1)=IX1 - 1 MOVE ":" TO TF251(11,IX1)
        MOVE PH-PROC-HAND(IX1) TO TF252(11,IX1) END-PERFORM
      PERFORM VARYING IX1 FROM 6 BY 1 UNTIL IX1>9
        COMPUTE TF250(12,IX1 - 4)=IX1 - 1 MOVE ":" TO TF251(12,IX1 - 4)
        MOVE PH-PROC-HAND(IX1) TO TF252(12,IX1 - 4) END-PERFORM.
    MOVE PH-DEMAND TO TF247(13).
    IF PART-TOOL AND PH-ASM=0
      MOVE "!FOR ASSEMBLIES]" TO TF248(13) MOVE PH-ASM-DEMAND TO TF249(13).
    IF PART-MAT
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
        COMPUTE TF250(13,IX1)=IX1 - 1 MOVE ":" TO TF251(13,IX1)
        MOVE PH-PROC-DEMAND(IX1) TO TF252(13,IX1) END-PERFORM
      PERFORM VARYING IX1 FROM 6 BY 1 UNTIL IX1>9
        COMPUTE TF250(14,IX1 - 4)=IX1 - 1 MOVE ":" TO TF251(14,IX1 - 4)
        MOVE PH-PROC-DEMAND(IX1) TO TF252(14,IX1 - 4) END-PERFORM.
    MOVE PH-ORDER TO TF233(15) MOVE PH-BLINES TO TF234(15).
    MOVE PH-MTD TO TF235(17) MOVE PH-YTD TO TF236(17) MOVE PH-LAST TO TF237(17).
    MOVE PH-AMTD TO TF238(18) MOVE PH-AYTD TO TF239(18) MOVE PH-ALAST TO TF240(18).
    MOVE PH-MTYPE TO TF241(20) MOVE PH-TAX TO TF242(20) MOVE PH-HCODE TO TF243(20).
    MOVE PH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF244(20).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE PH-BEG-HAND(IX1) TO TF224(21,IX1) END-PERFORM.
    IF PART-TOOL AND PH-DATE-REQ(1) NOT=0
      MOVE PH-DATE-REQ(1) TO D-DATE PERFORM D-NM MOVE D-DT TO TF245(22)
      MOVE PH-QTY-REQ TO TF246(22).
    PERFORM WRT GO PJ3.
PJ9. GO MN9.

* P-3 BIN FILE MAINTENANCE
BM1.
BM3. PERFORM RD115 PERFORM WRT.
    ACCEPT BM-NO LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO BM9. IF BM-NO=" " PERFORM DSP-ERR7 GO BM3.
    ACCEPT BM-OP LINE 3 COLUMN 42 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF BM-OP=9 GO BM9.
    GO BM40 BM50 BM60  DEPENDING BM-OP. PERFORM DSP-ERR1 GO BM3.
BM40. PERFORM INIT-BH MOVE BM-NO TO BH-NO.
    START PURBIN REGARDLESS INVALID GO BM42.
    MOVE "DUPLICATE BIN NO." TO ERR-MESG PERFORM DSP-ERR GO BM3.
BM42. PERFORM RD116 MOVE BH-NO TO TF268(3) PERFORM WRT.
    ACCEPT BH-PART LINE 5 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT BH-QTY LINE 5 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT BH-PO LINE 7 COLUMN 8 DEFAULT " " UNDERLINED PROTECTED EDITING.
BM45. ACCEPT BH-PCODE LINE 9 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF BH-PCODE>8 PERFORM DSP-ERR2 GO BM45.
    ACCEPT BH-COILS LINE 9 COLUMN 34 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT BH-HEAT LINE 9 COLUMN 52 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF BH-QTY NOT=0 MOVE SYS-DATE TO BH-DATE. MOVE BH-NO TO BH-KNO.
    WRITE BH-RECORD ALLOWING NO UNLOCK PURBIN GO BM3.
BM50. MOVE BM-NO TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM DSP-ERR7 GO BM3.
    PERFORM RD117 MOVE BH-NO TO TF269(3) PERFORM WRT PERFORM RD117A PERFORM WRT.
BM53. ACCEPT BM-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO BM551 BM552 BM553 BM554 BM555 BM556 BM557 BM558
      DEPENDING BM-FLD. GO BM3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
BM551. DISPLAY BH-PART COLUMN 30 BOLD ACCEPT BH-PART ACC-ALP.
    MOVE BH-PART TO WA1 PERFORM RDLK-PURBIN MOVE WA1 TO BH-PART GO BM58.
BM552. MOVE BH-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT COLUMN 30 BOLD.
    MOVE BH-DATE TO D-DATE MOVE 21 TO IXT MOVE 30 TO IXU.
    PERFORM AX-DT-DEF MOVE DATE0 TO BH-DATE.
    MOVE BH-DATE TO WN1 PERFORM RDLK-PURBIN MOVE WN1 TO BH-DATE GO BM58.
BM553. DISPLAY BH-QTY COLUMN 30 CONVERSION BOLD ACCEPT BH-QTY ACC-NUM.
    MOVE BH-QTY TO WN1 PERFORM RDLK-PURBIN MOVE WN1 TO BH-QTY GO BM58.
BM554. DISPLAY BH-PCODE COLUMN 30 CONVERSION BOLD.
BM5543. ACCEPT BH-PCODE ACC-NUM IF BH-PCODE>8 PERFORM DSP-ERR2 GO BM5543.
    MOVE BH-PCODE TO WN1 PERFORM RDLK-PURBIN MOVE WN1 TO BH-PCODE GO BM58.
BM555. DISPLAY BH-QTY-AL COLUMN 30 CONVERSION BOLD ACCEPT BH-QTY-AL ACC-NUM.
    MOVE BH-QTY-AL TO WN1 PERFORM RDLK-PURBIN MOVE WN1 TO BH-QTY-AL GO BM58.
BM556. DISPLAY BH-HEAT COLUMN 30 BOLD ACCEPT BH-HEAT ACC-ALP.
    MOVE BH-HEAT TO WA1 PERFORM RDLK-PURBIN MOVE WA1 TO BH-HEAT GO BM58.
BM557. DISPLAY BH-COILS COLUMN 30 CONVERSION BOLD ACCEPT BH-COILS ACC-NUM.
    MOVE BH-COILS TO WN1 PERFORM RDLK-PURBIN MOVE WN1 TO BH-COILS GO BM58.
BM558. DISPLAY BH-PO COLUMN 30 BOLD ACCEPT BH-PO ACC-ALP.
    MOVE BH-PO TO WA1 PERFORM RDLK-PURBIN MOVE WA1 TO BH-PO GO BM58.
BM58. REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN GO BM53.
    REPLACE OFF.
BM60. MOVE BM-NO TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM DSP-ERR7 GO BM3.
    IF BH-PART=" " DELETE PURBIN
      ELSE MOVE "PART NO. FIELD MUST BE BLANK" TO ERR-MESG PERFORM DSP-ERR.
    GO BM3.
BM9. GO MN9.

* P-4 SHOW BIN CONTENTS
BE1. PERFORM RD119 PERFORM WRT.
BE3. ACCEPT BH-NO LINE 9 COLUMN 72 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR BH-NO=ALL "9" GO BE9.
    READ PURBIN REGARDLESS INVALID PERFORM DSP-ERR7 GO BE3.
    PERFORM RD119 MOVE BH-NO TO TF253(1) MOVE BH-PART TO TF254(3) PH-NO.
    MOVE 0 TO PART-CODE PH-CAT WS1.
    IF PH-NO>" " READ PART REGARDLESS INVALID MOVE 1 TO WS1. PERFORM PART-TYPE.
    MOVE BH-QTY TO TF255(3) MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF256(3).
    MOVE BH-PO TO TF257(5).
    IF PART-MAT MOVE BH-PCODE TO TF257A(7) MOVE BH-COILS TO TF257B(7)
      COMPUTE TF257C(7) ROUNDED=BH-QTY / BH-COILS SIZE ERROR CONTINUE END-COMPUTE
      MOVE BH-HEAT TO TF257D(7).
    PERFORM WRT IF WS1=1 MOVE "INVALID PART NO. IN THIS BIN RECORD"
      TO ERR-MESG PERFORM DSP-ERR.
    GO BE3.
BE9. GO MN9.

* P-5 SHOW PART LOCATION
PB1. PERFORM RD120 MOVE " " TO PH-NO MOVE 4 TO IXT.
PB3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
PB33. DISPLAY "NEXT PART NO. ____________" LINE IXT.
    ACCEPT IA29 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA29=ALL "9" GO PB9.
    IF IA29=" " IF PH-NO=" " GO PB33 ELSE GO PB4. MOVE IA29 TO PH-NO.
    START PART KEY>=PH-KEY REGARDLESS INVALID PERFORM DSP-ERR3 GO PB33.
    READ PART NEXT REGARDLESS MOVE 1 TO PB-KFIN.
* note 122.3
    IF PH-NO NOT=IA29 MOVE 0 TO PB-KFIN PH-CAT MOVE IA29 TO PH-NO
      START PART KEY>=PH-KEY REGARDLESS.
    PERFORM PART-TYPE.
    INITIALIZE BH-KP MOVE PH-NO TO BH-PART MOVE 0 TO WD1 PB-KQ INQ-IND.
PB4. PERFORM RD120 MOVE PH-NO TO TF258(1).
    IF PB-KFIN=1 MOVE PH-DESC1 TO TF259(1) MOVE PH-DESC2 TO TF259(2)
      ELSE MOVE "*** NO RECORD FOR THIS PART ***" TO TF259(1).
    MOVE 5 TO IXT IF INQ-IND=0 START PURBIN KEY>=BH-KP REGARDLESS INVALID GO PB8.
PB5. READ PURBIN NEXT REGARDLESS END GO PB8. IF BH-PART NOT=PH-NO GO PB8.
    IF PART-MAT IF PB-KQ=0 AND BH-NO(1:2)="SQ" OR PB-KQ=1 AND BH-NO(1:2) NOT="SQ" GO PB5.
    PERFORM CLR-LN MOVE BH-NO TO TF261(IXT).
    MOVE BH-QTY TO TF262(IXT) ADD BH-QTY TO WD1.
    MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF262A(IXT).
    MOVE BH-PO TO TF263(IXT).
    IF PB-KFIN=1 AND PART-MAT
      MOVE BH-PCODE TO TF264(IXT) MOVE BH-COILS TO TF265(IXT)
      COMPUTE TF266(IXT) ROUNDED=BH-QTY / BH-COILS SIZE ERROR CONTINUE END-COMPUTE
      MOVE BH-HEAT TO TF267(IXT).
    ADD 1 TO IXT IF IXT<22 GO PB5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO PB89.
PB8. IF PART-MAT IF PB-KQ=0 MOVE 1 TO PB-KQ INITIALIZE BH-KP MOVE PH-NO TO BH-PART
      START PURBIN KEY>=BH-KP REGARDLESS INVALID GO PB82 END-START GO PB5.
PB82. MOVE "*** END ***" TO TLN(IXT) MOVE WD1 TO TF260(3).
    READ PART NEXT REGARDLESS END MOVE " " TO PH-NO GO PB89. MOVE 1 TO PB-KFIN.
    PERFORM PART-TYPE.
    INITIALIZE BH-KP MOVE PH-NO TO BH-PART MOVE 0 TO WD1 PB-KQ INQ-IND.
PB89. GO PB3.
PB9. GO MN9.

* P-6 STOCK UPDATE
SU1. PERFORM OPEN-AUDIT PERFORM OPEN-EMPL OPEN I-O MNTORD ALLOWING ALL MNTLIN ALLOWING ALL.
    MOVE SYS-DATE TO SU-DATE.
SU3. PERFORM RD121 PERFORM WRT.
SU31. DISPLAY "VALID TRANSACTIONS: 'REC', 'ISS', 'OUT', 'TRF', 'PRO', 'MNT', 'ADJ'" LINE 24 BOLD.
    ACCEPT SU-TRANS LINE 1 COLUMN 41 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR SU-TRANS="999" GO SU9.
    IF NOT(SU-TRANS="REC" OR "ISS" OR "OUT" OR "TRF" OR "PRO" OR "MNT" OR "ADJ")
      PERFORM DSP-ERR19 GO SU31.
    MOVE SU-DATE TO D-DATE MOVE 1 TO IXT MOVE 70 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO SU3. MOVE DATE0 TO SU-DATE.
    INITIALIZE SU-MO SU-QTY SU-PCODE SU-COILS SU-CWEIGHT SU-PO SU-FBIN SU-TBIN SU-HEAT.
    IF SU-TRANS="REC" GO SU4. IF SU-TRANS="ISS" OR "OUT" GO SU6.
    IF SU-TRANS="ADJ" GO SU70. IF SU-TRANS="TRF" OR "PRO" OR "MNT" GO SU8.

SU4.
SU41. DISPLAY "PART NO.        TO BIN    P.O. NO." LINE 3 BOLD.
    DISPLAY   "____________    ________  __________" LINE 4 ERASE LINE PERFORM SU-CLRS.
SU413. ACCEPT SU-PART LINE 4 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF3 OR KPF4 OR SU-PART=ALL "9" GO SU89.
    MOVE SU-PART TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO SU413.
    PERFORM PART-TYPE PERFORM SU-US-PCHK IF A-S1=1 GO SU413.
    MOVE SU-PART TO SHB-PART MOVE 9 TO IXT PERFORM SHOW-PBINS.
SU43. DISPLAY " " LINE 4 COLUMN 17 ERASE END LINE PERFORM SU-CLRS.
    ACCEPT SU-TBIN LINE 4 COLUMN 17 DEFAULT " "
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO SU41.
    MOVE SU-TBIN TO BH-NO.
    IF INUT READ PURBIN REGARDLESS INVALID PERFORM ADD-PBIN IF A-S1=0 GO SU43 END-IF
      ELSE READ PURBIN REGARDLESS INVALID PERFORM SU-E2 GO SU43.
    PERFORM SU-US-BCHK IF A-S1=1 GO SU43.
    IF BH-PART>" " AND NOT=SU-PART PERFORM SU-E4 IF XA2 NOT="OK" GO SU43.
SU433. ACCEPT SU-PO LINE 4 COLUMN 27 DEFAULT " "
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO SU41.
    IF SU-PO>" " MOVE SU-PO TO OK-NO READ PURORD REGARDLESS INVALID
      MOVE "INVALID P.O. NO." TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO SU433 END-IF.
    IF NOT PART-MAT PERFORM SU-AQ IF A-S1=1 GO SU41 END-IF GO SU46.
    DISPLAY "PROCESS CODE   COILS   TOTAL WEIGHT   HEAT"       LINE 6 BOLD.
    DISPLAY "    _           ____    __________    __________" LINE 7.
SU45. ACCEPT SU-PCODE LINE 7 COLUMN 5 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU41.
    IF SU-PCODE>8 PERFORM SU-E8 GO SU45.
    IF BH-PART>" " AND BH-PCODE NOT=SU-PCODE PERFORM SU-E9 IF XA2 NOT="OK" GO SU43.
SU453. ACCEPT SU-COILS LINE 7 COLUMN 17 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU41.
    IF SU-COILS=0 PERFORM DSP-ERR2 GO SU453.
SU455. ACCEPT SU-QTY LINE 7 COLUMN 25 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU41.
    IF SU-QTY=0 PERFORM DSP-ERR2 GO SU455. COMPUTE SU-CWEIGHT ROUNDED=SU-QTY / SU-COILS.
    MOVE SU-CWEIGHT TO A-N1 PERFORM CHK-COIL-WEIGHT IF A-S1=1 GO SU455.
    ACCEPT SU-HEAT LINE 7 COLUMN 39 DEFAULT " "
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO SU41.
    IF SU-HEAT>" " AND BH-HEAT>" " AND NOT=SU-HEAT
      PERFORM SU-E7 IF XA2 NOT="OK" GO SU43.
SU46. PERFORM SU-CAN IF XA3="CAN" GO SU41. MOVE SU-DATE TO BH-DATE.
    MOVE SU-PART TO BH-PART MOVE SU-PO TO BH-PO ADD SU-QTY TO BH-QTY.
    IF PART-MAT MOVE SU-PCODE TO BH-PCODE ADD SU-COILS TO BH-COILS
      IF SU-HEAT>" " MOVE SU-HEAT TO BH-HEAT.
    REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    PERFORM SU-AUDIT PERFORM SU-TR.

    IF NOT(SU-PO>" " AND PART-TOOL) GO SU48.
    MOVE SU-PO TO OK-NO READ PURORD REGARDLESS INVALID GO SU48.
    IF OK-VENDOR NOT=9250 GO SU48.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO SU464.
SU463. READ PURLIN NEXT REGARDLESS END GO SU464. IF LK-ORD NOT=OK-NO GO SU464.
    IF LK-PART NOT=SU-PART GO SU463.
    ADD SU-QTY TO PH-HAND PH-MTD PH-YTD SUBTRACT LK-QTY FROM PH-ORDER.
    MOVE SYS-DATE TO PH-DATE REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    PERFORM INIT-PU MOVE SYS-DATE TO PU-INV-DATE MOVE SU-QTY TO PU-QTY.
    WRITE PU-RECORD ALLOWING NO UNLOCK PURHIST.
SU464. DELETE PURORD MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO SU466.
SU465. READ PURLIN NEXT REGARDLESS END GO SU466. IF LK-ORD NOT=OK-NO GO SU466.
    DELETE PURLIN GO SU465.
SU466.
SU48. GO SU41.

SU6. MOVE 0 TO SU-OMO.
SU61. IF SU-TRANS="OUT" GO SU62.
* trans="ISS"
    DISPLAY "PART NO.        FROM BIN" LINE 3 BOLD.
    DISPLAY "____________    ________" LINE 4 ERASE LINE PERFORM SU-CLRS.
SU613. ACCEPT SU-PART LINE 4 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF3 OR KPF4 OR SU-PART=ALL "9" GO SU89.
    MOVE SU-PART TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO SU613.
    IF PH-ASM=1 PERFORM SU-E14 GO SU613.
    PERFORM PART-TYPE PERFORM SU-US-PCHK IF A-S1=1 GO SU613.
    MOVE SU-PART TO SHB-PART MOVE 9 TO IXT PERFORM SHOW-PBINS.
SU615. ACCEPT SU-FBIN LINE 4 COLUMN 17 DEFAULT " "
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO SU61.
    MOVE SU-FBIN TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM SU-E3 GO SU615.
    PERFORM SU-US-BCHK IF A-S1=1 GO SU615.
    IF BH-PART NOT=SU-PART PERFORM SU-E5 IF XA2 NOT="OK" GO SU615.
    GO SU64.

SU62. DISPLAY "FROM BIN    PART" LINE 3 BOLD.
*              ________    ............
    DISPLAY " " LINE 4 ERASE LINE PERFORM SU-CLRS.
    ACCEPT SU-FBIN LINE 4 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF3 OR KPF4 OR SU-FBIN=ALL "9" GO SU89.
    MOVE SU-FBIN TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM SU-E3 GO SU61.
    PERFORM SU-US-BCHK IF A-S1=1 GO SU61.
    MOVE BH-PART TO SU-PART PH-NO DISPLAY SU-PART LINE 4 COLUMN 13.
    READ PART REGARDLESS INVALID PERFORM SU-E10 GO SU61.
    IF PH-ASM=1 PERFORM SU-E14 GO SU61. PERFORM PART-TYPE.

SU64. IF PART-TOOL GO SU642. IF PART-MAT GO SU650. IF PART-MAINT GO SU66.

    DISPLAY "QUANTITY" LINE 3 COLUMN 30 BOLD ERASE END LINE.
*          ..........
    DISPLAY BH-QTY LINE 4 COLUMN 28 CONVERSION.
    PERFORM SU-AQ IF A-S1=1 GO SU61.
    IF SU-QTY>BH-QTY PERFORM SU-E6 IF XA2 NOT="OK" GO SU61.
    GO SU68.

SU642. DISPLAY "QUANTITY" LINE 3 COLUMN 30 BOLD ERASE END LINE.
*             ..........
    DISPLAY BH-QTY LINE 4 COLUMN 28 CONVERSION.
    DISPLAY "QUANTITY      M.O." LINE 6 BOLD.
    DISPLAY "__________   ______" LINE 7.
SU643. ACCEPT SU-QTY LINE 7 COLUMN 1 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU61.
    IF SU-QTY=0 PERFORM DSP-ERR2 GO SU643.
    IF SU-QTY>BH-QTY PERFORM SU-E6 IF XA2 NOT="OK" GO SU61.
SU645. MOVE SU-OMO TO R-NO DISPLAY R-NO LINE 7 COLUMN 14 CONVERSION.
    ACCEPT R-NO LINE 7 COLUMN 14 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO SU61.
    DISPLAY R-NO LINE 7 COLUMN 14 CONVERSION.
    PERFORM RDF-PRODORD IF A-S1=1 GO SU645. MOVE R-NO TO SU-MO SU-OMO.
    GO SU68.

SU650. DISPLAY "PROCESS   COILS" LINE 3 COLUMN 30 BOLD ERASE END LINE.
*                  .      ....
    DISPLAY BH-PCODE LINE 4 COLUMN 33 CONVERSION BH-COILS COLUMN 40 CONVERSION.
    DISPLAY "COILS  TOTAL WEIGHT   M.O."  LINE 6 BOLD.
    DISPLAY " ____   __________   ______" LINE 7.
SU653. ACCEPT SU-COILS LINE 7 COLUMN 2 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU61.
    IF SU-COILS=0 PERFORM DSP-ERR2 GO SU653.
    IF SU-COILS>BH-COILS PERFORM SU-E1 IF XA2 NOT="OK" GO SU653.
SU655. COMPUTE SU-QTY ROUNDED=BH-QTY * SU-COILS / BH-COILS SIZE ERROR MOVE 0 TO SU-QTY.
    DISPLAY SU-QTY LINE 7 COLUMN 9 CONVERSION.
    ACCEPT SU-QTY LINE 7 COLUMN 9 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO SU61.
    DISPLAY SU-QTY LINE 7 COLUMN 9 CONVERSION.
    COMPUTE SU-CWEIGHT ROUNDED=SU-QTY / SU-COILS.
    MOVE SU-CWEIGHT TO A-N1 PERFORM CHK-COIL-WEIGHT IF A-S1=1 GO SU655.
    IF SU-QTY>BH-QTY PERFORM SU-E6 IF XA2 NOT="OK" GO SU61.
SU657. ACCEPT R-NO LINE 7 COLUMN 22 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU61.
    PERFORM RDF-PRODORD IF A-S1=1 GO SU657.
    MOVE R-NO TO SU-MO MOVE BH-HEAT TO SU-HEAT.
    MOVE BH-PCODE TO SU-PCODE IF SU-PCODE>8 MOVE 0 TO SU-PCODE.
    GO SU68.

SU66. DISPLAY "QUANTITY" LINE 3 COLUMN 30 BOLD ERASE END LINE.
*            ..........
    DISPLAY BH-QTY LINE 4 COLUMN 28 CONVERSION.
    DISPLAY "QUANTITY    MAINT. ORDER   CLOCK NO." LINE 6 BOLD.
    DISPLAY "__________     ______        ____" LINE 7.
SU663. ACCEPT SU-QTY LINE 7 COLUMN 1 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU61.
    IF SU-QTY=0 PERFORM DSP-ERR2 GO SU663.
    IF SU-QTY>BH-QTY PERFORM SU-E6 IF XA2 NOT="OK" GO SU61.
SU665. ACCEPT VO-NO LINE 7 COLUMN 16 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU61.
    IF VO-NO=0 GO SU668.
    READ MNTORD REGARDLESS INVALID PERFORM DSP-ERR25 GO SU665.
SU667. ACCEPT E-NO LINE 7 COLUMN 30 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU61.
    IF E-NO=0 GO SU668.
    MOVE WS-PDIV TO E-DIV READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO SU667.
    MOVE 1 TO A-N1 PERFORM INIT-VL MOVE SU-PART TO VL-PART MOVE SU-DATE TO VL-DATE.
    MOVE E-NO TO VL-EMP MOVE SU-QTY TO VL-QTY.
    COMPUTE A-T1=VL-QTY * PH-LDCOST PERFORM DIV-PAMT COMPUTE VL-AMT ROUNDED=A-T1.
    WRITE VL-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK MNTLIN.
SU668. GO SU68.

SU68. PERFORM SU-CAN IF XA3="CAN" GO SU61. SUBTRACT SU-QTY FROM BH-QTY.
    IF PART-MAT SUBTRACT SU-COILS FROM BH-COILS
      MOVE 1 TO R-ALLOC REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    PERFORM CHK-PBIN-EMPTY REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    SUBTRACT SU-QTY FROM PH-HAND.
    IF PART-MAT SUBTRACT SU-QTY FROM PH-PROC-HAND(SU-PCODE + 1).
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    PERFORM SU-AUDIT PERFORM SU-TR GO SU61.

SU70.
SU71. DISPLAY "BIN         PART" LINE 3 BOLD.
*              ________    ............
    DISPLAY " " LINE 4 ERASE LINE PERFORM SU-CLRS.
    ACCEPT SU-FBIN LINE 4 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF3 OR KPF4 OR SU-FBIN=ALL "9" GO SU89.
    MOVE SU-FBIN TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM DSP-ERR7 GO SU71.
    PERFORM SU-US-BCHK IF A-S1=1 GO SU71.
    MOVE BH-PART TO SU-PART PH-NO DISPLAY SU-PART LINE 4 COLUMN 13.
    READ PART REGARDLESS INVALID PERFORM SU-E13 GO SU71. PERFORM PART-TYPE.
    IF PART-MAT DISPLAY "COILS" LINE 3 COLUMN 30 BOLD ERASE END LINE
*                        ....
      DISPLAY BH-COILS LINE 4 COLUMN 30 CONVERSION
     ELSE DISPLAY "QUANTITY" LINE 3 COLUMN 30 BOLD ERASE END LINE
*                ..........
      DISPLAY BH-QTY LINE 4 COLUMN 28 CONVERSION.
    IF NOT PART-MAT PERFORM SU-AQ IF A-S1=1 GO SU71 END-IF
      IF BH-QTY + SU-QTY<0 PERFORM SU-E12 GO SU71 END-IF GO SU78.
    DISPLAY "COILS  TOTAL WEIGHT"  LINE 6 BOLD.
*             ____   __________
SU75. ACCEPT SU-COILS LINE 7 COLUMN 2 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU71.
    IF SU-COILS=0 PERFORM DSP-ERR2 GO SU75.
    IF BH-COILS + SU-COILS<0 PERFORM SU-E12 GO SU71.
SU753. COMPUTE SU-QTY ROUNDED=BH-QTY * SU-COILS / BH-COILS SIZE ERROR MOVE 0 TO SU-QTY.
    DISPLAY SU-QTY LINE 7 COLUMN 9 CONVERSION.
    ACCEPT SU-QTY LINE 7 COLUMN 9 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO SU71.
    DISPLAY SU-QTY LINE 7 COLUMN 9 CONVERSION.
    COMPUTE SU-CWEIGHT ROUNDED=SU-QTY / SU-COILS.
    MOVE SU-CWEIGHT TO A-N1 PERFORM CHK-COIL-WEIGHT IF A-S1=1 GO SU753.
    IF BH-QTY + SU-QTY<0 PERFORM SU-E6 IF XA2 NOT="OK" GO SU71.
    MOVE BH-PCODE TO SU-PCODE IF SU-PCODE>8 MOVE 0 TO SU-PCODE.
SU78. PERFORM SU-CAN IF XA3="CAN" GO SU71. ADD SU-QTY TO BH-QTY.
    IF PART-MAT ADD SU-COILS TO BH-COILS.
    PERFORM CHK-PBIN-EMPTY REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    ADD SU-QTY TO PH-HAND IF PART-MAT ADD SU-QTY TO PH-PROC-HAND(SU-PCODE + 1).
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    PERFORM SU-AUDIT PERFORM SU-TR GO SU71.

SU8.
SU81. DISPLAY "PART NO.        FROM BIN   TO BIN" LINE 3 BOLD.
    DISPLAY   "____________    ________   ________" LINE 4 ERASE LINE PERFORM SU-CLRS.
SU813. ACCEPT SU-PART LINE 4 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF3 OR KPF4 OR SU-PART=ALL "9" GO SU89.
    MOVE SU-PART TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO SU813.
    PERFORM PART-TYPE PERFORM SU-US-PCHK IF A-S1=1 GO SU813.
    IF SU-TRANS="PRO" AND NOT PART-MAT
      MOVE "'PRO' CAN BE USED WITH MATERIALS ONLY" TO ERR-MESG PERFORM DSP-ERR GO SU813.
    IF SU-TRANS="MNT" AND NOT PART-TOOL
      MOVE "'MNT' CAN BE USED WITH TOOLS ONLY" TO ERR-MESG PERFORM DSP-ERR GO SU813.
    MOVE SU-PART TO SHB-PART MOVE 9 TO IXT PERFORM SHOW-PBINS.
SU831. ACCEPT SU-FBIN LINE 4 COLUMN 17 DEFAULT " "
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO SU81.
    IF SU-FBIN(1:2)="SI" PERFORM SU-SICHK IF XA2 NOT="OK" GO SU831.
    IF SU-FBIN(1:1)="X" PERFORM SU-XCHK IF XA2 NOT="OK" GO SU831.
    MOVE SU-FBIN TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM SU-E3 GO SU831.
    PERFORM SU-US-BCHK IF A-S1=1 GO SU831.
    IF BH-PART NOT=SU-PART PERFORM SU-E5 IF XA2 NOT="OK" GO SU831.
    MOVE BH-DATE TO SU-BDATE.
    IF NOT PART-MAT PERFORM SU-AQ IF A-S1=1 GO SU81 END-IF
      IF SU-QTY>BH-QTY PERFORM SU-E6 IF XA2 NOT="OK" GO SU81 END-IF END-IF
      GO SU84.
* note 120
    IF SU-TRANS="TRF" DISPLAY "COILS  TOTAL WEIGHT" LINE 6 BOLD.
*                               ____   __________
    IF SU-TRANS="PRO" DISPLAY "COILS  TOTAL WEIGHT   NEW PROCESS CODE" LINE 6 BOLD
                      DISPLAY " ____   __________           _" LINE 7.
SU833. MOVE BH-COILS TO SU-COILS DISPLAY SU-COILS LINE 7 COLUMN 2 CONVERSION.
    ACCEPT SU-COILS LINE 7 COLUMN 2 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO SU81.
    DISPLAY SU-COILS LINE 7 COLUMN 2 CONVERSION.
    IF SU-COILS=0 PERFORM DSP-ERR2 GO SU833.
    IF SU-COILS>BH-COILS PERFORM SU-E1 IF XA2 NOT="OK" GO SU833.
SU835. COMPUTE SU-QTY ROUNDED=BH-QTY * SU-COILS / BH-COILS SIZE ERROR MOVE 0 TO SU-QTY.
    DISPLAY SU-QTY LINE 7 COLUMN 9 CONVERSION.
    ACCEPT SU-QTY LINE 7 COLUMN 9 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO SU81.
    DISPLAY SU-QTY LINE 7 COLUMN 9 CONVERSION.
    COMPUTE SU-CWEIGHT ROUNDED=SU-QTY / SU-COILS.
    MOVE SU-CWEIGHT TO A-N1 PERFORM CHK-COIL-WEIGHT IF A-S1=1 GO SU835.
    IF SU-QTY>BH-QTY PERFORM SU-E6 IF XA2 NOT="OK" GO SU81.
    IF SU-TRANS="TRF" MOVE BH-PCODE TO SU-PCODE IF SU-PCODE>8 MOVE 0 TO SU-PCODE.
    IF NOT(SU-TRANS="PRO") GO SU838.
SU837. ACCEPT SU-PCODE LINE 7 COLUMN 30 DEFAULT ZERO
        UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO SU81.
    IF SU-PCODE>8 PERFORM SU-E8 GO SU837.
SU838. MOVE BH-PO TO SU-PO MOVE BH-HEAT TO SU-HEAT.
SU84.
SU85. MOVE 0 TO SU-KADD.
    ACCEPT SU-TBIN LINE 4 COLUMN 28 DEFAULT " "
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO SU81.
    IF SU-TBIN(1:2)="SI" PERFORM SU-SICHK IF XA2 NOT="OK" GO SU85 END-IF
      PERFORM SU-ADD-BIN.
    IF SU-TBIN(1:1)="X" PERFORM SU-XCHK IF XA2 NOT="OK" GO SU85 END-IF
      PERFORM SU-ADD-BIN.
    MOVE SU-TBIN TO BH-NO.
    IF INUT AND SU-TRANS="PRO"
      READ PURBIN REGARDLESS INVALID PERFORM ADD-PBIN IF A-S1=0 GO SU85 END-IF
     ELSE READ PURBIN REGARDLESS INVALID PERFORM SU-E2 GO SU85.
    PERFORM SU-US-BCHK IF A-S1=1 PERFORM SU-DEL-BIN GO SU85.
    IF BH-PART>" " AND NOT=SU-PART PERFORM SU-E4 IF XA2 NOT="OK" PERFORM SU-DEL-BIN GO SU85.
    IF BH-QTY NOT=0 PERFORM SU-E11 IF XA2 NOT="OK" PERFORM SU-DEL-BIN GO SU85.
    IF NOT PART-MAT GO SU86.
    IF SU-HEAT>" " AND BH-HEAT>" " AND NOT=SU-HEAT PERFORM SU-E7 IF XA2 NOT="OK" PERFORM SU-DEL-BIN GO SU85.
    IF BH-PART>" " AND BH-PCODE NOT=SU-PCODE PERFORM SU-E9 IF XA2 NOT="OK" PERFORM SU-DEL-BIN GO SU85.
SU86. PERFORM SU-CAN IF XA3="CAN" PERFORM SU-DEL-BIN GO SU81.
    MOVE SU-PART TO BH-PART ADD SU-QTY TO BH-QTY.
    IF PART-MAT MOVE SU-PCODE TO BH-PCODE ADD SU-COILS TO BH-COILS
      IF SU-HEAT>" " MOVE SU-HEAT TO BH-HEAT.
    MOVE SU-BDATE TO BH-DATE MOVE SU-PO TO BH-PO.
    REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    MOVE SU-FBIN TO A-A1 PERFORM RD-PURBIN SUBTRACT SU-QTY FROM BH-QTY.
    IF PART-MAT SUBTRACT SU-COILS FROM BH-COILS.
    PERFORM CHK-PBIN-EMPTY REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    IF (SU-FBIN(1:2)="SI" OR SU-FBIN(1:1)="X") AND BH-QTY=0 DELETE PURBIN.
    PERFORM SU-AUDIT PERFORM SU-TR GO SU81.

SU89. GO SU3.
SU9. CLOSE AUDIT EMPL MNTORD MNTLIN GO MN9.

SU-CLRS. DISPLAY " " LINE 6 ERASE LINE " " LINE 7 ERASE LINE.
SU-ADD-BIN. MOVE 1 TO SU-KADD PERFORM INIT-BH MOVE SU-TBIN TO BH-NO BH-KNO.
    WRITE BH-RECORD ALLOWING NO INVALID MOVE 0 TO SU-KADD. UNLOCK PURBIN.
SU-DEL-BIN. IF SU-KADD=1 DELETE PURBIN.
SU-SICHK. IF SU-TRANS="PRO" MOVE "OK" TO XA2
        ELSE MOVE "CLEANED COIL BINS MUST USE 'PRO' TRANSACTION" TO ERR-MESG PERFORM DSP-OK.
SU-XCHK. IF SU-TRANS="MNT" MOVE "OK" TO XA2
        ELSE MOVE "MAINTENANCE BINS MUST USE 'MNT' TRANSACTION" TO ERR-MESG PERFORM DSP-OK.
SU-US-PCHK. MOVE 0 TO A-S1.
    IF NOT ITOOL AND USN-USER="IRVTOOLS" AND NOT PART-TOOL
      MOVE "'IRVTOOLS' CAN ACCESS ONLY TOOLS" TO ERR-MESG
      PERFORM DSP-ERR MOVE 1 TO A-S1.
SU-US-BCHK. MOVE 0 TO A-S1.
    IF NOT ITOOL AND USN-USER="IRVTOOLS" AND BH-NO(1:2) NOT="TZ"
      MOVE "'IRVTOOLS' CAN ACCESS ONLY BINS TZ--" TO ERR-MESG
      PERFORM DSP-ERR MOVE 1 TO A-S1.
SU-AQ. PERFORM SU-AQ1 THRU SU-AQ9.
SU-AQ1. DISPLAY "QUANTITY"  LINE 6 COLUMN 1 BOLD MOVE 0 TO A-S1.
*                __________
SU-AQ3. ACCEPT SU-QTY LINE 7 COLUMN 1 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF3 MOVE 1 TO A-S1 GO SU-AQ9. IF SU-QTY=0 PERFORM DSP-ERR2 GO SU-AQ3.
SU-AQ9. EXIT.
SU-CAN. MOVE "'CAN' TO CANCEL THIS LINE: ___" TO TMSG PERFORM DSP-PROMPT.
SU-E1. MOVE "INSUFFICIENT COILS IN 'FROM BIN'" TO ERR-MESG PERFORM DSP-OK.
SU-E2. MOVE "INVALID 'TO BIN'" TO ERR-MESG PERFORM DSP-ERR.
SU-E3. MOVE "INVALID 'FROM BIN'" TO ERR-MESG PERFORM DSP-ERR.
SU-E4. MOVE "'TO BIN' PART MISMATCH" TO ERR-MESG PERFORM DSP-OK.
SU-E5. MOVE "'FROM BIN' PART MISMATCH" TO ERR-MESG PERFORM DSP-OK.
SU-E6. MOVE "INSUFFICIENT QUANTITY IN 'FROM BIN'" TO ERR-MESG PERFORM DSP-OK.
SU-E7. MOVE "'TO BIN' HEAT NO. MISMATCH" TO ERR-MESG PERFORM DSP-OK.
SU-E8. MOVE "INVALID PROCESS CODE" TO ERR-MESG PERFORM DSP-ERR.
SU-E9. MOVE "'TO BIN' PROCESS CODE MISMATCH" TO ERR-MESG PERFORM DSP-OK.
SU-E10. MOVE "INVALID PART IN 'FROM BIN'" TO ERR-MESG PERFORM DSP-ERR.
SU-E11. MOVE "'TO BIN' IS NOT EMPTY" TO ERR-MESG PERFORM DSP-OK.
SU-E12. MOVE "INVALID ADJUSTMENT QUANTITY" TO ERR-MESG PERFORM DSP-ERR.
SU-E13. MOVE "INVALID PART IN THIS BIN" TO ERR-MESG PERFORM DSP-ERR.
SU-E14. MOVE "THIS ITEM IS AN ASSEMBLY AND SHOULD NOT BE ISSUED" TO ERR-MESG PERFORM DSP-ERR.
* note 185.1
SU-AUDIT. MOVE SU-TRANS TO IE51 MOVE SU-PART TO IE52 MOVE SU-FBIN TO IE53.
    MOVE SU-TBIN TO IE54 MOVE SU-QTY TO IE55 MOVE SU-PO TO IE55A.
    MOVE 0 TO IE52A IF PART-MAT MOVE 1 TO IE52A MOVE SU-PCODE TO IE56
      MOVE SU-COILS TO IE57 MOVE SU-CWEIGHT TO IE58 MOVE SU-HEAT TO IE59.
    MOVE TD-INP-R5 TO AU-DATA MOVE 5 TO AU-K PERFORM ADD-AUD.
SU-TR. MOVE LOW-VALUES TO PT-RECORD INITIALIZE PT-REC MOVE SU-TRANS TO PT-TRANS.
    MOVE SU-PART TO PT-PART MOVE SU-DATE TO PT-DATE ACCEPT PT-TIME FROM TIME.
    MOVE USN-USER TO PT-USER.
    MOVE SU-FBIN TO PT-FBIN MOVE SU-TBIN TO PT-TBIN MOVE SU-QTY TO PT-QTY.
    MOVE SU-PO TO PT-PO MOVE SU-MO TO PT-MO MOVE SU-PCODE TO PT-PCODE.
    MOVE SU-COILS TO PT-COILS MOVE SU-CWEIGHT TO PT-CWEIGHT MOVE SU-HEAT TO PT-HEAT.
    WRITE PT-RECORD ALLOWING NO UNLOCK PARTRANS.

* P-7 PURCHASE ORDER ENTRY
OM1.
OM13. PERFORM RD122 PERFORM WRT PERFORM INIT-OK.
    ACCEPT OK-NO LINE 1 COLUMN 47 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR OK-NO=ALL "9" GO OM9. IF OK-NO=" " GO OM13. MOVE 0 TO OM-KMOD.
    READ PURORD REGARDLESS INVALID GO OM2.
    MOVE 1 TO OM-KMOD DISPLAY OK-NO LINE 1 COLUMN 47.
    DISPLAY OK-VENDOR LINE 3 COLUMN 10 CONVERSION.
    MOVE OK-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 3 COLUMN 37.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 3 COLUMN 59.
    DISPLAY LIT-NY(OK-HOLD + 1:1) LINE 3 COLUMN 79.
    DISPLAY LIT-NY(OK-BLANKET + 1:1) LINE 4 COLUMN 79.
    MOVE OK-VENDOR TO A-N1 PERFORM RD-VEN.
    DISPLAY V-NAME LINE 5 COLUMN 13 V-ADD1 LINE 6 COLUMN 13
      V-ADD2 LINE 7 COLUMN 13 V-POST LINE 8 COLUMN 13.
    DISPLAY OK-SHIPTO LINE 10 COLUMN 11 OK-CARRIER LINE 11 COLUMN 11
      OK-FOB LINE 12 COLUMN 11 OK-TERMS LINE 13 COLUMN 11.
    DISPLAY LIT-NY(OK-US + 1:1) LINE 13 COLUMN 35.
    DISPLAY LIT-NY(OK-PSTPAY + 1:1) LINE 13 COLUMN 45.
    MOVE 62 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      DISPLAY OK-TEXT(IX1) LINE 13 COLUMN IXU CONVERSION ADD 4 TO IXU END-PERFORM.
    DISPLAY "THIS ORDER NO. EXISTS" LINE 23 BOLD.
    MOVE "  'A' TO ADD LINE, 'M' TO MODIFY ORDER, 'DEL' TO DELETE ORDER: ___" TO TMSG.
    PERFORM DSP-PROMPT DISPLAY " " LINE 23 ERASE LINE.
    IF XA3="A" GO OM14. IF XA3="M" GO OM70. IF XA3="DEL" GO OM16. GO OM13.
OM14. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE OM-LINE OM-TOTAL.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO OM144.
OM143. READ PURLIN NEXT REGARDLESS END GO OM144. IF LK-ORD NOT=OK-NO GO OM144.
    MOVE LK-LINE TO OM-LINE ADD LK-TOTAL TO OM-TOTAL GO OM143.
OM144. GO OM4.

OM16. IF OK-SUBCON=1 MOVE "SYSTEM-GENERATED ORDER - ENTER AUTHORIZATION CODE TO DELETE IT: ___" TO TMSG
       PERFORM DSP-PROMPT IF XA3 NOT="473" GO OM168.
    DELETE PURORD MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO OM168.
OM163. READ PURLIN NEXT REGARDLESS END GO OM168. IF LK-ORD NOT=OK-NO GO OM168.
    DELETE PURLIN IF LK-BLANKET=1 GO OM166.
    MOVE LK-PART TO PH-NO READ PART REGARDLESS INVALID GO OM166.
    PERFORM PART-TYPE MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY.
    SUBTRACT A-T1 FROM PH-ORDER ROUNDED.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
OM166. GO OM163.
OM168. GO OM13.

OM2.
OM23. ACCEPT OK-VENDOR LINE 3 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF OK-VENDOR=0 PERFORM DSP-ERR17 GO OM23.
    MOVE LOW-VALUES TO V-RECORD INITIALIZE V-REC MOVE WS-DIV TO V-DIV MOVE OK-VENDOR TO V-NO.
    READ VENDOR REGARDLESS INVALID GO OM24.
    DISPLAY V-NAME LINE 5 COLUMN 13 V-ADD1 LINE 6 COLUMN 13
      V-ADD2 LINE 7 COLUMN 13 V-POST LINE 8 COLUMN 13.
    PERFORM OM-ACC IF XA3="N" GO OM13. GO OM26.
OM24. MOVE "VENDOR NOT FOUND - CANCEL OR 'ADD': ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="ADD" GO OM13.
    ACCEPT V-NAME LINE 5 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT V-ADD1 LINE 6 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT V-ADD2 LINE 7 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT V-POST LINE 8 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM OM-ACC IF XA3="N" GO OM13. WRITE V-RECORD ALLOWING NO UNLOCK VENDOR.
OM26. MOVE SYS-DATE TO D-DATE MOVE 3 TO IXT MOVE 37 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO OK-DATE.
    MOVE 3 TO IXT MOVE 59 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO OK-DATE-REQ.
    MOVE 3 TO IXT MOVE 79 TO IXU MOVE OK-HOLD TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-HOLD.
    MOVE 4 TO IXT MOVE 79 TO IXU MOVE OK-BLANKET TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-BLANKET.
    ACCEPT OK-SHIPTO LINE 10 COLUMN 11 DEFAULT "MAIN PLANT" UNDERLINED PROTECTED EDITING.
    ACCEPT OK-CARRIER LINE 11 COLUMN 11 DEFAULT "TRUCK-PPD" UNDERLINED PROTECTED EDITING.
    ACCEPT OK-FOB LINE 12 COLUMN 11 DEFAULT WS-FOB UNDERLINED PROTECTED EDITING.
    ACCEPT OK-TERMS LINE 13 COLUMN 11 DEFAULT "NET 60 DAYS" UNDERLINED PROTECTED EDITING.
    MOVE OK-VENDOR TO A-N1 PERFORM CHK-VENUS MOVE A-S1 TO OK-US.
    MOVE 13 TO IXT MOVE 35 TO IXU MOVE OK-US TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-US.
    MOVE 13 TO IXT MOVE 45 TO IXU MOVE OK-PSTPAY TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-PSTPAY.
    MOVE 62 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      ACCEPT OK-TEXT(IX1) LINE 13 COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      IF OK-TEXT(IX1)=0 GO OM28 END-IF ADD 4 TO IXU END-PERFORM.
OM28. MOVE USN-USER TO OK-USER PERFORM OM-ACC IF XA3="N" GO OM13.
    PERFORM SET-OKV WRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    MOVE 0 TO OM-LINE OM-TOTAL.

OM4.
OM5. PERFORM RD122A MOVE OK-NO TO TF285(1) MOVE V-NO TO TF286(1).
    MOVE OM-TOTAL TO TF287(1) MOVE V-NAME TO TF288(2).
    PERFORM WRT ADD 1 TO OM-LINE IF OM-LINE=99 GO OM69.
OM51. MOVE 0 TO OM-PF PERFORM INIT-LK MOVE OK-BLANKET TO LK-BLANKET.
    DISPLAY
         "________ ____  ____________  __________ ____   __   ___________  ___" LINE 4 ERASE END SCREEN.
    IF LK-BLANKET=0 ACCEPT OM-AF1 LINE 4 COLUMN 1 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY
      IF KPF4 OR OM-AF1=9999999 GO OM69 END-IF MOVE OM-AF1 TO LK-QTY
     ELSE DISPLAY LIT-BL LINE 4 COLUMN 1
      ACCEPT XA1 COLUMN 8 PROTECTED AUTOTERMINATE KEY CKEY IF KPF4 GO OM69.
    PERFORM INIT-PH.
    ACCEPT PH-NO LINE 4 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE OK-NO TO LK-ORD MOVE OM-LINE TO LK-LINE MOVE PH-NO TO LK-PART.
    READ PART REGARDLESS INVALID GO OM54. PERFORM PART-TYPE.
    PERFORM PRI-CHKVEN IF A-X1<=3 MOVE PH-PRICE(A-X1) TO LK-PRICE.
    DISPLAY PH-UNIT LINE 4 COLUMN 10 LK-PRICE COLUMN 30 CONVERSION
      PH-MODE COLUMN 41 LK-DISC COLUMN 48 CONVERSION PH-CAT COLUMN 66 CONVERSION.
    DISPLAY PH-DESC1 LINE 5 COLUMN 16 PH-DESC2 LINE 6 COLUMN 16.
    DISPLAY PH-DRAW LINE 7 COLUMN 16 "REV:" COLUMN 31 BOLD PH-REV COLUMN 36.
    MOVE PH-DESC1 TO LK-DESC1 MOVE PH-DESC2 TO LK-DESC2.
    MOVE PH-DRAW TO LK-DRAW MOVE PH-REV TO LK-REV MOVE PH-UNIT TO LK-UNIT.
    MOVE PH-MODE TO LK-MODE MOVE PH-MTYPE TO LK-MTYPE MOVE PH-CAT TO LK-CAT.
    PERFORM OM-ACC IF XA3="N" GO OM52.
    MOVE PH-CAT TO A-N1 MOVE PH-MTYPE TO A-N2 MOVE V-CONTRA TO A-N3.
    PERFORM RD-CATGL MOVE WS-DIV TO G-DIV MOVE WS-GL TO G-GL.
    READ GLDIST REGARDLESS INVALID MOVE "THE CALCULATED G/L A/C IS INVALID"
      TO ERR-MESG PERFORM DSP-ERR GO OM51.
    PERFORM CHK-GL IF A-S1=1 GO OM51. MOVE WS-GL TO LK-GL.
    GO OM6.
OM52. MOVE 1 TO OM-PF MOVE "'YES' TO OVERRIDE VALUES, ELSE CANCEL: ___" TO TMSG.
    PERFORM DSP-PROMPT IF XA3 NOT="YES" GO OM51. GO OM56.
OM54. MOVE 2 TO OM-PF MOVE "PART NOT FOUND - CANCEL OR 'OK': __" TO TMSG.
    PERFORM DSP-PROMPT IF XA3 NOT="OK" GO OM51.
    DISPLAY LK-PRICE LINE 4 COLUMN 30 CONVERSION LK-CAT COLUMN 66 CONVERSION.

OM56. ACCEPT LK-UNIT LINE 4 COLUMN 10 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-PRICE LINE 4 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LK-PRICE LINE 4 COLUMN 30 CONVERSION.
    ACCEPT LK-MODE LINE 4 COLUMN 41 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-DISC LINE 4 COLUMN 48 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
OM57. IF OM-PF=2 MOVE 6 TO IXT DISPLAY "G/L:" LINE IXT COLUMN 52 BOLD
       MOVE 57 TO IXU MOVE 0 TO WS-GL PERFORM AX-GL
       PERFORM CHK-GL IF A-S1=1 GO OM57 END-IF MOVE WS-GL TO LK-GL.
    ACCEPT LK-DESC1 LINE 5 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-DESC2 LINE 6 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-DRAW LINE 7 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-REV COLUMN 36 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM OM-ACC IF XA3="N" GO OM51.

OM6. MOVE LK-QTY TO CL-QTY PERFORM KPRICE-CALC.
    MOVE CL-AMT TO LK-TOTAL ADD CL-AMT TO OM-TOTAL.
    MOVE LK-TOTAL TO OM-AF3 DISPLAY OM-AF3 LINE 4 COLUMN 53 CONVERSION.
    MOVE OK-DATE-REQ TO LK-DATE-REQ.
    IF OM-PF NOT=2 MOVE LK-REV TO PH-REV
      MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY ADD A-T1 TO PH-ORDER ROUNDED
      PERFORM PRI-SET-PRICE REWRITE PH-RECORD ALLOWING NO UNLOCK PART.

    DISPLAY "NOTES:" LINE 8 BOLD MOVE 0 TO IX1 MOVE 7 TO IXT.
OM67. ADD 1 TO IX1 IXT IF IX1>15 GO OM68. PERFORM DSP-PF3.
    ACCEPT LK-NOTE(IX1) LINE IXT COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF3 OR KPF4 GO OM68. GO OM67.
OM68. WRITE LK-RECORD ALLOWING NO UNLOCK PURLIN GO OM5.
OM69. IF OM-KMOD=1 GO OM79. GO OM13.

OM70. MOVE OK-DATE TO D-DATE MOVE 3 TO IXT MOVE 37 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO OK-DATE.
    MOVE OK-DATE-REQ TO OM-ODATE-REQ D-DATE MOVE 3 TO IXT MOVE 59 TO IXU.
    PERFORM AX-DT-DEF MOVE DATE0 TO OK-DATE-REQ.
    MOVE 3 TO IXT MOVE 79 TO IXU MOVE OK-HOLD TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-HOLD.
    ACCEPT OK-SHIPTO LINE 10 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT OK-CARRIER LINE 11 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT OK-FOB LINE 12 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT OK-TERMS LINE 13 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 13 TO IXT MOVE 35 TO IXU MOVE OK-US TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-US.
    MOVE 13 TO IXT MOVE 45 TO IXU MOVE OK-PSTPAY TO A-S1 PERFORM AX-NY MOVE A-S1 TO OK-PSTPAY.
    MOVE 62 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      ACCEPT OK-TEXT(IX1) LINE 13 COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY OK-TEXT(IX1) LINE 13 COLUMN IXU CONVERSION ADD 4 TO IXU END-PERFORM.
    REWRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    IF OK-DATE-REQ=OM-ODATE-REQ GO OM728. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO OM728.
OM727. READ PURLIN NEXT REGARDLESS END GO OM728. IF LK-ORD NOT=OK-NO GO OM728.
    MOVE OK-DATE-REQ TO LK-DATE-REQ.
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN GO OM727.

OM728. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO OM79.
OM73. READ PURLIN NEXT REGARDLESS END GO OM79. IF LK-ORD NOT=OK-NO GO OM79.
    PERFORM RD122B MOVE OK-NO TO TF283(1) PERFORM WRT.
    IF LK-BLANKET=0 MOVE LK-QTY TO OM-AF1 DISPLAY OM-AF1 LINE 5 COLUMN 1 CONVERSION BOLD
      ELSE DISPLAY LIT-BL LINE 5 COLUMN 1 BOLD.
    DISPLAY LK-UNIT LINE 5 COLUMN 10 BOLD LK-PART COLUMN 16 BOLD
      LK-PRICE COLUMN 30 CONVERSION BOLD LK-MODE COLUMN 41 BOLD
      LK-DISC COLUMN 48 CONVERSION BOLD.
    IF LK-BLANKET=0 MOVE LK-TOTAL TO OM-AF3 DISPLAY OM-AF3 COLUMN 53 CONVERSION BOLD.
    MOVE LK-QTY-REC TO OM-AF2 DISPLAY OM-AF2 COLUMN 68 CONVERSION BOLD.
    DISPLAY LK-DESC1 LINE 7 COLUMN 16 LK-DESC2 LINE 8 COLUMN 16.
    IF LK-DRAW>" " MOVE " " TO WA1 STRING "DRAWING: " DELIMITED SIZE
      LK-DRAW DELIMITED " " "  REV " LK-REV DELIMITED SIZE INTO WA1
      DISPLAY WA1 LINE 9 COLUMN 16.
    MOVE 10 TO IXT DISPLAY "NOTES:" LINE IXT BOLD MOVE 1 TO IX1.
OM733. IF LK-NOTE(IX1)>" " DISPLAY LK-NOTE(IX1) LINE IXT COLUMN 16.
    ADD 1 TO IX1 IXT IF IX1<=15 AND IXT<=22 GO OM733.

    MOVE "'E' TO END, 'M' TO MODIFY LINE, 'DEL' TO DELETE LINE: ___" TO TMSG.
    PERFORM DSP-PROMPT.
    IF XA3="E" GO OM79. IF XA3="M" GO OM76. IF XA3="DEL" GO OM78. GO OM73.
OM76. PERFORM INIT-PH MOVE LK-PART TO PH-NO MOVE 0 TO OM-KNF.
    READ PART REGARDLESS INVALID MOVE 1 TO OM-KNF. PERFORM PART-TYPE.
* note 103
    IF LK-BLANKET=0
      MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY COMPUTE OM-PQTY ROUNDED=-A-T1
      MOVE LK-QTY TO OM-AF1 DISPLAY OM-AF1 LINE 6 COLUMN 1 CONVERSION
      ACCEPT OM-AF1 LINE 6 COLUMN 1 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      MOVE OM-AF1 TO LK-QTY DISPLAY OM-AF1 LINE 6 COLUMN 1 CONVERSION
      MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY ADD A-T1 TO OM-PQTY ROUNDED
     ELSE MOVE 0 TO OM-PQTY.
    ACCEPT LK-UNIT LINE 6 COLUMN 10 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    DISPLAY LK-PRICE LINE 6 COLUMN 30 CONVERSION.
    ACCEPT LK-PRICE LINE 6 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LK-PRICE LINE 6 COLUMN 30 CONVERSION.
    ACCEPT LK-MODE LINE 6 COLUMN 41 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-DISC LINE 6 COLUMN 48 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    IF LK-BLANKET=0 MOVE LK-QTY TO CL-QTY PERFORM KPRICE-CALC
      MOVE CL-AMT TO LK-TOTAL OM-AF3 DISPLAY OM-AF3 LINE 6 COLUMN 53 CONVERSION.
    MOVE LK-QTY-REC TO OM-AF2 DISPLAY OM-AF2 LINE 6 COLUMN 68 CONVERSION.
    ACCEPT OM-AF2 LINE 6 COLUMN 68 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE OM-AF2 TO LK-QTY-REC DISPLAY OM-AF2 LINE 6 COLUMN 68 CONVERSION.
    IF LK-BLANKET=1
      ACCEPT LK-DESC1 LINE 7 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      ACCEPT LK-DESC2 LINE 8 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
OM763. IF LK-CAT=0 MOVE 8 TO IXT DISPLAY "G/L:" LINE IXT COLUMN 52 BOLD
      MOVE 57 TO IXU MOVE LK-GL TO WS-GL PERFORM AX-GL
      PERFORM CHK-GL IF A-S1=1 GO OM763 END-IF MOVE WS-GL TO LK-GL.
    MOVE 0 TO IX1 MOVE 9 TO IXT.
OM767. ADD 1 TO IX1 IXT IF IX1>15 OR IXT>22 GO OM768.
    PERFORM DSP-PF3 ACCEPT LK-NOTE(IX1) LINE IXT COLUMN 16 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS IF NOT KPF3 GO OM767.
OM768. REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    IF OM-KNF=0 ADD OM-PQTY TO PH-ORDER PERFORM PRI-SET-PRICE
      REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    GO OM73.
OM78. DELETE PURLIN IF LK-BLANKET=1 GO OM782.
    MOVE LK-PART TO PH-NO READ PART REGARDLESS INVALID GO OM782.
    PERFORM PART-TYPE MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY.
    SUBTRACT A-T1 FROM PH-ORDER ROUNDED REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
OM782. GO OM73.
OM79. DISPLAY "'Y' TO PRINT THIS MODIFIED PURCHASE ORDER: _" LINE 24 BOLD.
    ACCEPT XA1 COLUMN 44 DEFAULT "N" UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA1="Y" READ PURORD REGARDLESS MOVE USN-USER TO OK-USER
      MOVE 2 TO OK-STATUS REWRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    GO OM13.
OM9. GO MN9.

OM-ACC. MOVE "ACCEPT OR 'N': _" TO TMSG PERFORM DSP-PROMPT.

* P-8 PURCHASE ORDER INFORMATION
OQ1. PERFORM WRT132 PERFORM RD142 MOVE " " TO OK-NO MOVE 6 TO IXT.
OQ3. MOVE "??" TO TLNW(IXT + 1) PERFORM WRT.
OQ33. DISPLAY "NEXT ORDER NO. ________" LINE IXT.
    ACCEPT IA24 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA24=ALL "9" GO OQ9.
    IF IA24=" " IF OK-NO=" " GO OQ33 ELSE GO OQ4. MOVE IA24 TO OK-NO.
    START PURORD KEY>=OK-KEY REGARDLESS INVALID PERFORM DSP-ERR8 GO OQ33.
    READ PURORD NEXT REGARDLESS.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE WD1 INQ-IND.
OQ4. PERFORM RD142 MOVE OK-NO TO TH30(1) MOVE LIT-NY(OK-HOLD + 1:1) TO TH31(1).
    MOVE OK-STATUS TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO TH32(1).
    MOVE OK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TH33(1).
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TH34(1).
    MOVE OK-VENDOR TO TH36(3) A-N1 PERFORM RD-VEN MOVE V-NAME TO TH37(3).
    MOVE OK-SHIPTO TO TH38(3) MOVE OK-CARRIER TO TH39(3).
    MOVE OK-FOB TO TH40(4) MOVE OK-TERMS TO TH41(4).
    MOVE LIT-NY(OK-US + 1:1) TO TH42(4) MOVE LIT-NY(OK-PSTPAY + 1:1) TO TH43(4).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      IF OK-TEXT(IX1) NOT=0 MOVE OK-TEXT(IX1) TO TH44(4,IX1) END-IF END-PERFORM.
    MOVE 7 TO IXT IF INQ-IND=0 START PURLIN KEY>LK-KEY REGARDLESS INVALID GO OQ8.
OQ5. READ PURLIN NEXT REGARDLESS END GO OQ8. IF LK-ORD NOT=OK-NO GO OQ8.
    PERFORM CLR-LN.
    IF LK-BLANKET=0 MOVE LK-QTY TO TH45(IXT) ELSE MOVE LIT-BL TO TH45A(IXT).
    MOVE LK-UNIT TO TH46(IXT) MOVE LK-QTY-REC TO TH47(IXT).
    IF LK-DATE-LAST>0 MOVE LK-DATE-LAST TO D-DATE PERFORM D-NM MOVE D-DT TO TH48(IXT).
    MOVE LK-PART TO TH49(IXT) MOVE LK-DESC1 TO TH51(IXT).
    MOVE LK-PRICE TO TH52(IXT) MOVE LK-MODE TO TH53(IXT).
    MOVE LK-QTY TO CL-QTY PERFORM KPRICE-CALC MOVE CL-DTXT TO TH54(IXT).
    MOVE CL-AMT TO TH55(IXT) ADD CL-AMT TO WD1.
    IF LK-SUB-MAC>0 ADD 1 TO IXT PERFORM CLR-LN
      MOVE "PROD:" TO TH160(IXT) MOVE LK-SUB-PROD TO TH161(IXT)
      MOVE "LOT:" TO TH162(IXT) MOVE LK-SUB-LOT TO TH163(IXT).
* note 74
    ADD 1 TO IXT IF IXT<21 GO OQ5.
    MOVE "*** MORE ***" TO TLNW(IXT) MOVE 1 TO INQ-IND GO OQ89.
OQ8. MOVE "*** END ***" TO TLNW(IXT) MOVE WD1 TO TH35(1).
    READ PURORD NEXT REGARDLESS END MOVE " " TO OK-NO GO OQ89.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE WD1 INQ-IND.
OQ89. GO OQ3.
OQ9. PERFORM WRT80 GO MN9.

* P-9 SHOW PURCHASE ORDERS BY PART
OS1. PERFORM RD124 MOVE " " TO PH-NO MOVE 1 TO OS-KALL MOVE 3 TO IXT.
OS3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
OS33. DISPLAY "NEXT PART NO. ____________        INCLUDE CLOSED ORDERS ? _" LINE IXT.
    ACCEPT IA23 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA23=ALL "9" GO OS9.
    MOVE 59 TO IXU MOVE OS-KALL TO A-S1 PERFORM AX-NY MOVE A-S1 TO OS-KALL.
    IF IA23=" " IF PH-NO=" " GO OS33 ELSE GO OS4. MOVE IA23 TO PH-NO.
    START PART KEY>=PH-KEY REGARDLESS INVALID PERFORM DSP-ERR3 GO OS33.
    READ PART NEXT REGARDLESS MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ INQ-IND.
OS4. PERFORM RD124 MOVE PH-NO TO TF289(1).
    MOVE PH-DESC1 TO TF290(1) MOVE PH-DESC2 TO TF290(2).
    MOVE 4 TO IXT IF INQ-IND=0 START PURLIN KEY>=LK-KP REGARDLESS INVALID GO OS8.
OS5. READ PURLIN NEXT REGARDLESS END GO OS8. IF LK-PART NOT=PH-NO GO OS8.
    IF OS-KALL=0 AND LK-BLANKET=0 AND (LK-QTY>0 AND<=LK-QTY-REC) GO OS5.
    PERFORM CLR-LN MOVE LK-ORD TO TF278(IXT) OK-NO.
    READ PURORD REGARDLESS INVALID GO OS54.
    MOVE OK-VENDOR TO TF279(IXT) A-N1 PERFORM RD-VEN MOVE V-NAME TO TF280(IXT).
OS54. IF LK-BLANKET=0 MOVE LK-QTY TO TF281(IXT) ELSE MOVE LIT-BL TO TF281A(IXT).
    MOVE LK-QTY-REC TO TF282(IXT).
    ADD 1 TO IXT IF IXT<22 GO OS5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO OS89.
OS8. MOVE "*** END ***" TO TLN(IXT).
    READ PART NEXT REGARDLESS END MOVE " " TO PH-NO GO OS89.
    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ INQ-IND.
OS89. GO OS3.
OS9. GO MN9.

* P-10 PRINT PURCHASE ORDERS
PP1. PERFORM RD125 PERFORM WRT.
    ACCEPT PP-ORD1 LINE 3 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED.
    ACCEPT PP-ORD2 LINE 3 COLUMN 40 DEFAULT " " UNDERLINED PROTECTED.
    MOVE 5 TO IXT MOVE 51 TO IXU PERFORM AX-DT-INV.
    ACCEPT XA3 LINE 6 COLUMN 25 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO PP-KIT ELSE MOVE 0 TO PP-KIT.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    IF PP-KIT=1 OPEN I-O ITPRODUCT ALLOWING ALL ITOPERATIONS ALLOWING ALL ITMACHINE ALLOWING ALL.
    PERFORM DSP-WAIT PERFORM OPEN-PR WRITE PREC AFTER PAGE.
    MOVE PP-ORD1 TO OK-NO START PURORD KEY>=OK-KEY REGARDLESS INVALID GO PP9.
PP3. READ PURORD NEXT REGARDLESS END GO PP9. IF OK-NO>PP-ORD2 GO PP9.
* note 48
    IF OK-HOLD=1 OR NOT((OK-USER=USN-USER OR " ")
      AND ((OK-STATUS=0 OR 2) OR DATE0=OK-DATE)) GO PP3.
    IF PP-KIT=1 IF OK-VENDOR=9250 GO PP6 ELSE GO PP3
      ELSE IF OK-VENDOR NOT=9250 GO PP4 ELSE GO PP3.

PP4. MOVE 0 TO WS-PAGE PERFORM PP-PAGE MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO PP58.
PP5. READ PURLIN NEXT REGARDLESS END GO PP58. IF LK-ORD NOT=OK-NO GO PP58.
    IF LK-BLANKET=0 MOVE LK-QTY TO FA43 ELSE MOVE LIT-BL TO FA43A.
    MOVE LK-UNIT TO FA44 MOVE LK-PART TO FA45.
    MOVE LK-DESC1 TO FA46 MOVE LK-PRICE TO FA47 MOVE LK-MODE TO FA48.
    PERFORM PP-LINE IF LK-DESC2>" " MOVE LK-DESC2 TO FA46 PERFORM PP-LINE.
    IF LK-DRAW>" " PERFORM DRAW-EXP-LK
      MOVE "DRAWING:" TO FA46 MOVE A-A2 TO FA46(10:) PERFORM PP-LINE.
    PERFORM VARYING IX2 FROM 15 BY -1 UNTIL IX2=0 OR LK-NOTE(IX2)>" " CONTINUE END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IX2
      MOVE LK-NOTE(IX1) TO FA40 PERFORM PP-LINE END-PERFORM.
    PERFORM PP-LINE GO PP5.
PP58. PERFORM PP-LINE 2 TIMES MOVE 0 TO WS1.
    MOVE "100% ON TIME DELIVERY IN HOUSE BY REQUIRED DATE" TO FA40 PERFORM PP-LINE.
    IF OK-US=1 MOVE "PAYABLE IN US$" TO FA40 PERFORM PP-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 IF OK-TEXT(IX1) NOT=0
      IF OK-TEXT(IX1)=99 MOVE 1 TO WS1
        ELSE MOVE 3 TO T-TBL MOVE OK-TEXT(IX1) TO T-NO PERFORM RD-TBL
          MOVE T-LINE TO FA40 PERFORM PP-LINE END-IF END-IF END-PERFORM.
    IF WS1=1
      MOVE "INSPECTION: SELLER AGREES THAT BUYER SHALL HAVE THE RIGHT TO ENTER SELLER'S" TO FA41 PERFORM PP-LINE
      MOVE "FACILITY AT REASONABLE TIMES TO INSPECT THE FACILITY, GOODS, MATERIALS AND" TO FA41 PERFORM PP-LINE
      MOVE "ANY PROPERTY OF BUYER COVERED BY THIS ORDER. BUYER'S INSPECTION OF THE GOODS," TO FA41 PERFORM PP-LINE
      MOVE "WHETHER DURING MANUFACTURE, PRIOR TO DELIVERY OR WITHIN A REASONABLE TIME" TO FA41 PERFORM PP-LINE
      MOVE "AFTER DELIVERY, SHALL NOT CONSTITUTE ACCEPTANCE OF ANY WORK-IN-PROCESS OR" TO FA41 PERFORM PP-LINE
      MOVE "FINISHED GOODS." TO FA41 PERFORM PP-LINE.
    IF OK-STATUS=2 MOVE 2 TO WS-PR MOVE "*** ORDER MODIFIED" TO FA40 PERFORM PP-LINE.
    WRITE PREC AFTER PAGE GO PP8.

PP6. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO PP68.
PP63. READ PURLIN NEXT REGARDLESS END GO PP68. IF LK-ORD NOT=OK-NO GO PP68.
    INITIALIZE P-REC OP-REC MOVE LK-PART TO A-A1 PERFORM RD-PART.
    MOVE LK-PART TO ITP-NO READ ITPRODUCT INTO P-RECORD REGARDLESS INVALID CONTINUE.
    MOVE P-NO TO ITOP-PROD MOVE P-MAC TO ITOP-MAC.
    READ ITOPERATIONS INTO OP-RECORD REGARDLESS INVALID CONTINUE.

    MOVE 2 TO WS-PR MOVE "DATE:" TO FA267.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA268 PERFORM PR-LINE.
    MOVE 3 TO WS-PR MOVE OK-NO TO FA269 MOVE "IRVINE FASTENERS" TO FA270.
    MOVE LK-PRICE TO FA270A PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE LK-PART TO FA273 PERFORM PR-LINE.
    MOVE LK-DESC1 TO FA273 PERFORM PR-LINE MOVE LK-DESC2 TO FA273 PERFORM PR-LINE.
    MOVE PH-MATERIAL TO FA271.
    IF LK-BLANKET=0 MOVE LK-QTY TO FA272 ELSE MOVE LIT-BL TO FA272A.
    IF LK-DRAW>" " PERFORM DRAW-EXP-LK
      MOVE "DRAWING:" TO FA273 MOVE A-A2 TO FA273(10:).
    PERFORM PR-LINE MOVE 4 TO WS-PR MOVE "DATE REQUIRED:" TO FA274.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA275 PERFORM PR-LINE.
    MOVE 7 TO WS-PR PERFORM PR-LINE MOVE 1 TO IX1.
PP65. IF OP-OPER(IX1)=0 GO PP66. MOVE OP-OPER(IX1) TO FA265 ITM-NO.
    READ ITMACHINE INTO M-RECORD REGARDLESS
      INVALID MOVE "*** ERROR ***" TO M-DESC1 MOVE " " TO M-DESC2.
    MOVE M-DESC1 TO FA266 PERFORM PR-LINE MOVE M-DESC2 TO FA266 PERFORM PR-LINE-3.
PP66. ADD 1 TO IX1 IF IX1<=10 GO PP65.
    WRITE PREC AFTER PAGE GO PP63.
PP68. GO PP8.

PP8. MOVE 1 TO OK-STATUS REWRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    GO PP3.
PP9. IF PP-KIT=1 CLOSE ITPRODUCT ITOPERATIONS ITMACHINE.
    PERFORM CLOSE-PR GO MN9.

PP-LINE. PERFORM PR-LINE.
    IF WS-LINES>54 MOVE 2 TO WS-PR MOVE "---- CONTINUED ----" TO FA46 PERFORM PR-LINE
      WRITE PREC AFTER PAGE PERFORM PP-PAGE PERFORM PR-LINE.
PP-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 10 TO WS-PR.
    MOVE WS-DIV TO FA31 MOVE OK-VENDOR TO FA32 A-N1 PERFORM RD-VEN PERFORM PR-LINE-3.
    MOVE V-NAME TO FA33 MOVE OK-NO TO FA37 PERFORM PR-LINE.
    MOVE V-ADD1 TO FA33 PERFORM PR-LINE.
    MOVE V-ADD2 TO FA33 MOVE OK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA36 PERFORM PR-LINE.
    MOVE V-POST TO FA33 PERFORM PR-LINE.
    MOVE "REQUIRED IN HOUSE BY" TO FA34.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA36 PERFORM PR-LINE-2.
    MOVE "PAGE" TO FA37A MOVE WS-PAGE TO FA37B PERFORM PR-LINE-2.
    MOVE OK-SHIPTO TO FA38 MOVE OK-CARRIER TO FA39 PERFORM PR-LINE-2.
    MOVE OK-FOB TO FA38 MOVE OK-TERMS TO FA39 PERFORM PR-LINE-3.

* P-11 SHOW VENDORS AND PART NUMBERS
CV1. PERFORM RD277 PERFORM WRT MOVE " " TO CV-NUM.
CV3. DISPLAY "ENTER THE BEGINNING OF THE VENDOR PART NUMBER" LINE 24 BOLD.
    ACCEPT CV-NUM LINE 3 COLUMN 19 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR CV-NUM(1:10)=ALL "9" GO CV9.
    MOVE 5 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    MOVE CV-NUM TO A-A1 PERFORM STR-LTH MOVE A-N1 TO CV-LTH.
    MOVE 1 TO IXCOL MOVE 0 TO CV-KFIN MOVE CV-NUM TO PH-VNUM MOVE " " TO PH-KVNO.
    START PART KEY>=PH-KV REGARDLESS INVALID GO CV8.
CV5. READ PART NEXT REGARDLESS END GO CV8. IF PH-VNUM(1:CV-LTH) NOT=CV-NUM GO CV8.
    COMPUTE IXU=(IXCOL - 1) * 42 + 1 MOVE 1 TO CV-KFIN.
    DISPLAY PH-NO LINE IXT COLUMN IXU PH-VNUM COLUMN IXU PLUS 14.
    ADD 1 TO IXT IF IXT=24 MOVE 5 TO IXT ADD 1 TO IXCOL IF IXCOL>2 GO CV8. GO CV5.
CV8. IF CV-KFIN=0 DISPLAY "*** NO PARTS FOUND" LINE IXT. GO CV3.
CV9. GO MN9.

* P-12 MAT. CLEANING REQUIREMENTS REPORT
OB1. PERFORM RD401 PERFORM WRT.
    MOVE 2 TO OB-DAYS DISPLAY OB-DAYS LINE 3 COLUMN 20 CONVERSION.
    ACCEPT OB-DAYS LINE 3 COLUMN 20 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY OB-DAYS LINE 3 COLUMN 20 CONVERSION.
    MOVE 4 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-MACSCHED PERFORM OPEN-REP.

* note 248
    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO OB14.
OB13. READ PRODORD NEXT REGARDLESS END GO OB14.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
     IF R-TMP(IX1) NOT=0
       PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE 0 TO R-TMP(IX1) END-PERFORM
       REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD GO OB138 END-IF END-PERFORM.
OB138. GO OB13.
OB14.

    MOVE " " TO MQ-KEY START MACSCHED KEY>MQ-KEY REGARDLESS INVALID GO OB4.
OB3. READ MACSCHED NEXT REGARDLESS END GO OB4.
    MOVE MQ-MAC TO A-N1 PERFORM RD-MAC.
    MOVE M-HOURS TO WN1 IF WN1=0 MOVE 15 TO WN1.
    COMPUTE OB-MAC-HOURS=OB-DAYS * WN1 MOVE 0 TO OB-IXN.
OB31. ADD 1 TO OB-IXN IF OB-IXN>15 OR OB-MAC-HOURS=0 GO OB39.
    IF MQ-MO(OB-IXN)=0 GO OB31.
    MOVE MQ-MO(OB-IXN) TO R-NO READ PRODORD REGARDLESS INVALID GO OB31.
    IF R-ALLOC=2 GO OB31.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT PERFORM GROSS-WEIGHT.
    IF R-COILS=0 PERFORM CALC-NCOILS ELSE MOVE R-COILS TO A-L1.
    MOVE A-L1 TO OB-CL-TOT.

    MOVE 0 TO OB-QTY-PROD INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO OB34.
OB33. READ WORKSHEET NEXT REGARDLESS END GO OB34. IF J-NO NOT=R-NO GO OB34.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-PRIMARY ADD J-QTY TO OB-QTY-PROD.
    IF PROC-REJECT SUBTRACT J-QTY FROM OB-QTY-PROD.
    GO OB33.
OB34. COMPUTE OB-CL-USED ROUNDED=OB-QTY-PROD * PRO-GROSS / 100 / WEI-COIL.

    MOVE 0 TO OB-CL-ISS PERFORM SET-PART.
    INITIALIZE PT-KEY MOVE PART-NO TO PT-PART.
    START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO OB36.
OB35. READ PARTRANS NEXT REGARDLESS END GO OB36. IF PT-PART NOT=PART-NO GO OB36.
    IF PT-TRANS="ISS" AND PT-MO=R-NO ADD PT-COILS TO OB-CL-ISS. GO OB35.
OB36.

    PERFORM CALC-PRATE MOVE A-N1 TO OB-RATE.
    COMPUTE OB-HOURS ROUNDED=(R-QTY-ORD - OB-QTY-PROD) / OB-RATE SIZE ERROR MOVE 0 TO OB-HOURS.
    IF OB-HOURS<=0 GO OB389.
    IF OB-HOURS<OB-MAC-HOURS SUBTRACT OB-HOURS FROM OB-MAC-HOURS
      ELSE MOVE OB-MAC-HOURS TO OB-HOURS MOVE 0 TO OB-MAC-HOURS.
    COMPUTE OB-CL-REQ ROUNDED=OB-HOURS * OB-RATE * PRO-GROSS / 100 / WEI-COIL.

    COMPUTE WD1=OB-CL-ISS - OB-CL-USED IF WD1<0 MOVE 0 TO WD1.
    COMPUTE WD1=OB-CL-REQ - WD1 IF WD1<0 MOVE 0 TO WD1.
    COMPUTE WD2=OB-CL-TOT - OB-CL-ISS IF WD2<0 MOVE 0 TO WD2.
    IF WD1>WD2 MOVE WD2 TO WD1.
    MOVE WD1 TO R-TMP(1) MOVE OB-CL-TOT TO R-TMP(2).
    MOVE OB-CL-USED TO R-TMP(3) MOVE OB-CL-ISS TO R-TMP(4).
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    IF R-TMP(1)=0 GO OB389.

    PERFORM SET-PART INITIALIZE BH-KP MOVE PART-NO TO BH-PART.
    START PURBIN KEY>BH-KP REGARDLESS INVALID GO OB38.
OB37. READ PURBIN NEXT REGARDLESS END GO OB38. IF BH-PART NOT=PART-NO GO OB38.
    MOVE BH-COILS TO BH-TMP-COILS IF BH-TMP-COILS<0 MOVE 0 TO BH-TMP-COILS.
    REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN GO OB37.
OB38.

    PERFORM INIT-RP MOVE P-CLEAN TO RP-F2 MOVE MQ-MAC TO RP-F3.
    MOVE OB-IXN TO RP-F4 MOVE MQ-MO(OB-IXN) TO RP-F5 WRITE RP-RECORD.
OB389. GO OB31.
OB39. GO OB3.
OB4.

    MOVE 0 TO PR-NUM PERFORM OPEN-PR PERFORM OB-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO OB6.
OB5. READ REPFL NEXT END GO OB6. MOVE RP-F5 TO R-NO READ PRODORD REGARDLESS.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT PERFORM SET-PART.
    MOVE P-CLEAN TO FG12 MOVE P-NO TO FG13 MOVE P-PROC TO FG14.
    MOVE PART-NO TO FG15 MOVE R-NO TO FG16 MOVE RP-F3 TO FG17.
    MOVE R-TMP(2) TO FG17A COMPUTE FG17B ROUNDED=R-TMP(3) MOVE R-TMP(4) TO FG17C.
    COMPUTE WD1=R-TMP(1) + 0.99 MOVE WD1 TO OB-CL-IREQ.

    MOVE 0 TO OB-KFIN INITIALIZE BH-KP MOVE PART-NO TO BH-PART.
    START PURBIN KEY>BH-KP REGARDLESS INVALID GO OB56.
OB55. READ PURBIN NEXT REGARDLESS END GO OB56. IF BH-PART NOT=PART-NO GO OB56.
    IF BH-NO(1:2)="SQ" OR BH-TMP-COILS=0 OR BH-PCODE NOT=P-PROC GO OB55.
    MOVE 1 TO OB-KFIN MOVE BH-NO TO FG18 COMPUTE WN1=BH-TMP-COILS - OB-CL-IREQ.
    IF WN1>=0 MOVE OB-CL-IREQ TO FG19 MOVE WN1 TO BH-TMP-COILS MOVE 0 TO OB-CL-IREQ
      ELSE MOVE BH-TMP-COILS TO FG19 MOVE 0 TO BH-TMP-COILS COMPUTE OB-CL-IREQ=-WN1.
    REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    PERFORM OB-LINE IF OB-CL-IREQ>0 GO OB55.
OB56. IF OB-KFIN=0 PERFORM OB-LINE. PERFORM OB-LINE GO OB5.

OB6. CLOSE MACSCHED PERFORM CLOSE-REP PERFORM CLOSE-PR.
    MOVE "PRINT2" TO PR-QUEUE PERFORM PRINT-PR.
OB9. GO MN9.

OB-LINE. PERFORM PR-LINE IF WS-LINES>58 PERFORM OB-PAGE.
OB-PAGE. MOVE OB-DAYS TO DSP-N11 MOVE " DAYS)" TO A-A1 IF OB-DAYS=1 MOVE " DAY)" TO A-A1.
    STRING "MATERIAL CLEANING REQUIREMENTS (FOR " DSP-N11 DELIMITED SIZE A-A1 DELIMITED "  "
      INTO FF3Y PERFORM PR-PAGE-80.
    MOVE "CLN  PRODUCT     PROC  MATERIAL        M.O.  MAC  ORIG  USED  ISS  BIN      REQD" TO PREC PERFORM PR-LINE-3.
*          .   ............  .   ............  ......  ..   ..:.  ..:.  ..   ........  ..

* P-13 PRINT MATERIAL CLEANING SLIP
OC1. PERFORM RD402 PERFORM WRT.
    MOVE SYS-DATE TO D-DATE MOVE 3 TO IXT MOVE 8 TO IXU PERFORM AX-DT-DEF.
    MOVE 4 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM SET-SHORT-SCHED PERFORM OPEN-SORT.

* note 226
    MOVE " " TO PT-KEY START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO OC19.
OC13. READ PARTRANS NEXT REGARDLESS END GO OC19. IF PT-DATE NOT=DATE0 GO OC13.
    IF PT-TRANS NOT="ISS" GO OC13.
    MOVE PT-PART TO PH-NO READ PART REGARDLESS INVALID GO OC13.
    PERFORM PART-TYPE IF NOT PART-MAT GO OC13.
    PERFORM INIT-SR MOVE PT-FBIN TO SR-F140 MOVE PT-PART TO SR-F141.
    MOVE PT-MO TO SR-F142.
    MOVE PT-COILS TO SR-F143 MOVE PT-QTY TO SR-F144 MOVE PT-KEY TO SR-F145.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD PT-COILS TO SR-F143 ADD PT-QTY TO SR-F144 REWRITE SR-RECORD.
    GO OC13.
OC19. INITIALIZE OC-KM OC-ROWS OC-PROWS OC-TCOILS OC-CTOT OC-WTOT.
    MOVE 1 TO OC-TPAGE.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO OC29.
OC23. READ SORTFL NEXT END GO OC29. MOVE SR-KEY TO OC-KEY.
    IF OC-KM=" " MOVE OC-KEY TO OC-KM OC-KP GO OC24.
    IF SR-KEY(1:18)=OC-KM(1:18) GO OC24. PERFORM OC-M.
    IF OC-PROWS + OC-ROWS<=24 ADD OC-ROWS TO OC-PROWS
      ELSE PERFORM OC-P MOVE OC-ROWS TO OC-PROWS ADD 1 TO OC-TPAGE
        MOVE OC-KM TO OC-KP.
    MOVE OC-KEY TO OC-KM SR-KEY START SORTFL KEY=SR-KEY READ SORTFL NEXT.
    MOVE 0 TO OC-ROWS OC-CTOT OC-WTOT.
OC24. ADD SR-F143 TO OC-CTOT OC-TCOILS ADD SR-F144 TO OC-WTOT ADD 1 TO OC-ROWS.
    GO OC23.
OC29. IF OC-KM>" " PERFORM OC-M ADD OC-ROWS TO OC-PROWS PERFORM OC-P.

    MOVE 5 TO LAS-FLN PERFORM OPEN-LAS PERFORM PCL-INIT PERFORM PCL-START.
    MOVE LAS-PO90 TO LAS-FLD PERFORM LASF MOVE 0 TO OC-PAGE.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO OC8.
OC3. READ SORTFL NEXT END GO OC8. MOVE SR-F145 TO PT-KEY READ PARTRANS REGARDLESS.
    IF SR-F148=0 GO OC4.
    IF OC-PAGE>0 MOVE 100 TO LAS-POSX MOVE OC-YLINE TO LAS-POSY MOVE LAS-POS TO LAS-FLD PERFORM LASF
      MOVE "`*c3100a4b0P" TO LAS-FLD PERFORM LASF PERFORM PCL-FF.
    ADD 1 TO OC-PAGE.

    MOVE "`(s10h0s3B`*p100x030YDAILY RAW MATERIAL CLEANING SLIP" TO LAS-FLD PERFORM LASF.
    MOVE "`(s10h0s3B`*p2690x030YIRVINE FASTENERS" TO LAS-FLD PERFORM LASF.
    MOVE "`(s16.66h0s0B`*p2800x080YIF-79 REV 2 08/09/05" TO LAS-FLD PERFORM LASF.

    MOVE DATE0 TO D-DATE PERFORM D-NM.
    MOVE "IF" TO WA1 MOVE D-DT TO WA1(3:6).
    MOVE "`(s10h0s3B`*p1500x030Y" TO LAS-FLD PERFORM LASF.
    MOVE WA1 TO LAS-FLD PERFORM LASF.
    MOVE "`(s10h0s0B`*p100x130YDate:" TO LAS-FLD PERFORM LASF.
    MOVE D-DT TO OC-DF6 MOVE OC-DF6 TO LAS-FLD PERFORM LASF.
    MOVE "`*p720XPage" TO LAS-FLD PERFORM LASF.
    MOVE OC-PAGE TO OC-DF1A MOVE "of" TO OC-DF1B MOVE OC-TPAGE TO OC-DF1C.
    MOVE OC-DF1 TO LAS-FLD PERFORM LASF.

    MOVE "`*p770x2140Y`*c1710a90b0P`*p772x2142Y`*c1706a86b1P`*c1706a86b15g2P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s10h0s3B`*p800x2200YPINLOADERS: PLEASE IDENTIFY CLEANING CODE ON METAL TAGS" TO LAS-FLD PERFORM LASF.

    MOVE "`(s10h0s0B`*p100x2380YTotal coils:" TO LAS-FLD PERFORM LASF.
    MOVE OC-TCOILS TO FJ-N3 PERFORM LASF.
    MOVE "`(s10h0s0B`*p1800x2380YYARDMAN: CHECK, INITIAL ________ RETURN TO PM" TO LAS-FLD PERFORM LASF.

    MOVE "`*p100x230Y`*c3100a4b0P`*p100x300Y`*c3100a4b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s16.66h0s3B`*p130x288YLOCATION`*p430XSIZE`*p590XGRADE" TO LAS-FLD PERFORM LASF.
    MOVE "`*p810XCONDITION`*p1010XHEAT NO.`*p1365x263YNUM.`*p1352x288YCOILS" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1485XTOTAL WEIGHT`*p1744x263YCLEANING`*p1780x288YCODE" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1940XCLEANING PROCESS`*p2590XJ#`*p2735x263YNUM.`*p2722x288YCOILS" TO LAS-FLD PERFORM LASF.
    MOVE "`*p2855XMAC.`*p3040XM.O." TO LAS-FLD PERFORM LASF.

    COMPUTE LAS-AREY=70 + 6 + 70 * SR-F148 MOVE 0 TO LAS-AREF.
    MOVE "`*p100x230Y" TO LAS-FLD PERFORM OC-L2.
    MOVE "`*p380X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p560X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p800X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p980X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p1340X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p1460X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p1730X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p1910X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p2510X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p2710X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p2830X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p2950X" TO LAS-FLD PERFORM OC-L1.
    MOVE "`*p3200x230Y" TO LAS-FLD PERFORM OC-L2.
    MOVE 284 TO OC-YTEXT MOVE 302 TO OC-YLINE MOVE 0 TO OC-KFIR.

OC4. IF SR-F149=1
      IF OC-KFIR=0 MOVE 1 TO OC-KFIR
        ELSE MOVE 100 TO LAS-POSX MOVE OC-YLINE TO LAS-POSY
         MOVE LAS-POS TO LAS-FLD PERFORM LASF MOVE "`*c3100a2b0P" TO LAS-FLD PERFORM LASF.
    ADD 70 TO OC-YTEXT OC-YLINE PERFORM PCL-NORM1.
    MOVE 100 TO LAS-POSX MOVE OC-YTEXT TO LAS-POSY MOVE LAS-POS TO LAS-FLD PERFORM LASF.
    MOVE PT-MO TO A-N1 PERFORM RD-PRODORD MOVE R-PROD TO A-A1 PERFORM PROD-RT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL XM-F6(IX1)=0
      IF PT-MO=XM-F8(IX1) MOVE XM-F6(IX1) TO OC-MAC GO OC44 END-IF END-PERFORM.
    MOVE P-MAC TO OC-MAC.
OC44. IF SR-F149=0 GO OC6.
    MOVE PT-FBIN TO OC-DF2 MOVE OC-DF2 TO LAS-FLD PERFORM LASF.
    MOVE "`*p380X" TO LAS-FLD PERFORM LASF.
    MOVE PT-PART(2:3) TO OC-DF3 MOVE OC-DF3A TO FJ-D31 PERFORM LASF.
    MOVE "`*p560X" TO LAS-FLD PERFORM LASF.
    MOVE PT-PART(6:) TO OC-DF2 MOVE OC-DF2 TO LAS-FLD PERFORM LASF.
    MOVE "`*p800X" TO LAS-FLD PERFORM LASF.
    MOVE "A" TO OC-DF4A MOVE PT-PCODE TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO OC-DF4B.
    MOVE OC-DF4 TO LAS-FLD PERFORM LASF.
    MOVE "`*p980X" TO LAS-FLD PERFORM LASF.
    MOVE PT-HEAT TO OC-DF2 MOVE OC-DF2 TO LAS-FLD PERFORM LASF.
    MOVE "`*p1340X" TO LAS-FLD PERFORM LASF.
    MOVE SR-F146 TO FJ-N3 PERFORM LASF.
    MOVE "`*p1460X" TO LAS-FLD PERFORM LASF.
    MOVE SR-F147 TO OC-DF5 MOVE OC-DF5 TO LAS-FLD PERFORM LASF.
    MOVE "`*p1730X" TO LAS-FLD PERFORM LASF.
    MOVE P-CLEAN TO FJ-N3 PERFORM LASF.
    MOVE "`*p1910X" TO LAS-FLD PERFORM LASF.
    IF P-CLEAN>=1 AND<=8 MOVE CLN-DESC(P-CLEAN) TO OC-DF2
      MOVE OC-DF2 TO LAS-FLD PERFORM LASF.
OC6. MOVE "`*p2710X" TO LAS-FLD PERFORM LASF.
    MOVE SR-F143 TO FJ-N3 PERFORM LASF.
    MOVE "`*p2830X" TO LAS-FLD PERFORM LASF.
    MOVE OC-MAC TO FJ-N3 PERFORM LASF.
    MOVE "`*p2950X" TO LAS-FLD PERFORM LASF.
    MOVE PT-MO TO FJ-N7 PERFORM LASF.
    GO OC3.
OC8. IF OC-PAGE>0 MOVE 100 TO LAS-POSX MOVE OC-YLINE TO LAS-POSY
      MOVE LAS-POS TO LAS-FLD PERFORM LASF MOVE "`*c3100a4b0P" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-ENDFL PERFORM CLOSE-LAS PERFORM CLOSE-SORT.
    MOVE "PRINT2" TO LAS-QUEUE PERFORM PRINT-LAS.
OC9. GO MN9.

OC-M. MOVE OC-KM TO SR-KEY READ SORTFL.
    MOVE OC-CTOT TO SR-F146 MOVE OC-WTOT TO SR-F147 MOVE 1 TO SR-F149 REWRITE SR-RECORD.
OC-P. MOVE OC-KP TO SR-KEY READ SORTFL MOVE OC-PROWS TO SR-F148 REWRITE SR-RECORD.
OC-L1. PERFORM LASF MOVE 2 TO LAS-AREX MOVE LAS-AREA TO LAS-FLD PERFORM LASF.
OC-L2. PERFORM LASF MOVE 4 TO LAS-AREX MOVE LAS-AREA TO LAS-FLD PERFORM LASF.

* P-14 SHOW CLEANED COIL BINS
SI1. PERFORM RD128 MOVE 0 TO SI-TOT INQ-IND MOVE 3 TO IXT.
SI3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
    DISPLAY "SELECT 'SI' 'PAD' 'PAD1' 'PAD2': ____" LINE IXT.
SI33. ACCEPT IA45 LINE IXT COLUMN 34 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA45="9999" GO SI9. IF IA45=" " AND INQ-IND=1 GO SI4.
    IF NOT(IA45="SI" OR "PAD" OR "PAD1" OR "PAD2") PERFORM DSP-ERR2 GO SI33.
    MOVE 0 TO INQ-IND MOVE IA45 TO SI-PREFIX A-A1 PERFORM STR-LTH.
    MOVE A-N1 TO SI-PLTH IF SI-PREFIX(1:3)="PAD" ADD 1 TO SI-PLTH MOVE "-" TO SI-PREFIX(SI-PLTH:1).
SI4. PERFORM RD128 MOVE 4 TO IXT.
    IF INQ-IND=0 MOVE SI-PREFIX TO BH-NO
      START PURBIN KEY>=BH-KEY REGARDLESS INVALID GO SI8.
SI5. READ PURBIN NEXT REGARDLESS END GO SI8. IF BH-NO(1:SI-PLTH)>SI-PREFIX GO SI8.
    PERFORM CLR-LN MOVE BH-NO TO TF428(IXT) MOVE BH-PART TO TF428A(IXT).
    MOVE BH-QTY TO TF429(IXT) ADD BH-QTY TO SI-TOT.
    MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF430(IXT).
    MOVE BH-PCODE TO TF431(IXT) MOVE BH-COILS TO TF432(IXT).
    COMPUTE TF433(IXT) ROUNDED=BH-QTY / BH-COILS SIZE ERROR CONTINUE.
    MOVE BH-HEAT TO TF434(IXT).
    ADD 1 TO IXT IF IXT<22 GO SI5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO SI89.
SI8. MOVE "*** END ***" TO TLN(IXT) MOVE SI-TOT TO TF427(1).
    MOVE 0 TO SI-TOT INQ-IND.
SI89. GO SI3.
SI9. GO MN9.

* P-15 COUNT PURCHASE ORDERS
WX1. PERFORM RD192 PERFORM WRT.
    MOVE 3 TO IXT MOVE 53 TO IXU MOVE 73 TO IXV PERFORM AX-DATE-R.
    PERFORM DSP-QWAIT MOVE 0 TO WN1 MOVE " " TO OK-KEY.
    START PURORD KEY>OK-KEY REGARDLESS INVALID GO WX4.
WX3. READ PURORD NEXT REGARDLESS END GO WX4.
    IF OK-DATE>=DATE1 AND<=DATE2 ADD 1 TO WN1. GO WX3.
WX4. PERFORM DSP-ERS MOVE WN1 TO DSP-N51.
    DISPLAY "TOTAL NUMBER OF P.O.'S: " LINE 5 DSP-N51 BOLD.
    PERFORM DSP-CONT.
WX9. GO MN9.

* P-16 PRINT TOOL DRAWINGS
SZ1. MOVE 2 TO PDR-TP PERFORM PRINT-DRAWING.
SZ9. GO MN9.

* P-17 ISSUE BLANKET PURCHASE ORDER
BP1.
BP3. PERFORM RD129 PERFORM WRT.
    ACCEPT OK-NO LINE 1 COLUMN 56 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR OK-NO=ALL "9" GO BP9.
    READ PURORD REGARDLESS INVALID PERFORM DSP-ERR8 GO BP3.
    DISPLAY OK-VENDOR LINE 3 COLUMN 9 CONVERSION.
    MOVE WS-DIV TO V-DIV MOVE OK-VENDOR TO V-NO.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR51 GO BP3.
    DISPLAY V-NAME LINE 3 COLUMN 17 V-ADD1 LINE 4 COLUMN 17
      V-ADD2 LINE 5 COLUMN 17 V-POST LINE 6 COLUMN 17.
    MOVE OK-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 3 COLUMN 74.
    IF OK-BLANKET=0 PERFORM DSP-ERR50 GO BP3. MOVE OK-NO TO BP-NO.
BP35. ACCEPT OK-NO LINE 8 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    READ PURORD REGARDLESS INVALID GO BP36. PERFORM DSP-ERR31 GO BP35.
BP36. MOVE 0 TO OK-BLANKET OK-HOLD OK-STATUS MOVE BP-NO TO OK-BLANKET-ORD.
    MOVE SYS-DATE TO D-DATE MOVE 8 TO IXT MOVE 40 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO OK-DATE.
    MOVE 8 TO IXT MOVE 64 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO OK-DATE-REQ.
    MOVE USN-USER TO OK-USER PERFORM SET-OKV WRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    MOVE 0 TO BP-LINE BP-NLINE.

BP5. DISPLAY " " LINE 11 ERASE END SCREEN.
    MOVE BP-NO TO LK-ORD MOVE BP-LINE TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO BP58.
    READ PURLIN NEXT REGARDLESS END GO BP58. IF LK-ORD NOT=BP-NO GO BP58.
    MOVE LK-LINE TO BP-LINE.
    MOVE OK-NO TO LK-ORD ADD 1 TO BP-NLINE MOVE BP-NLINE TO LK-LINE.
    MOVE OK-DATE-REQ TO LK-DATE-REQ MOVE 0 TO LK-BLANKET LK-QTY-REC LK-TOTAL-REC.

    DISPLAY LK-UNIT LINE 11 COLUMN 10 LK-PART COLUMN 16
      LK-PRICE COLUMN 30 CONVERSION LK-MODE COLUMN 41 LK-DISC COLUMN 48 CONVERSION.
    MOVE 12 TO IXT DISPLAY LK-DESC1 LINE IXT COLUMN 16 ADD 1 TO IXT.
    IF LK-DESC2>" " DISPLAY LK-DESC2 LINE IXT COLUMN 16 ADD 1 TO IXT.
    IF LK-DRAW>" " MOVE " " TO WA1 STRING "DRAWING: " DELIMITED SIZE
      LK-DRAW DELIMITED " " "  REV " LK-REV DELIMITED SIZE INTO WA1
      DISPLAY WA1 LINE IXT COLUMN 16 ADD 1 TO IXT.
    DISPLAY "NOTES:" LINE IXT BOLD MOVE 1 TO IX1.
BP53. IF LK-NOTE(IX1)>" " DISPLAY LK-NOTE(IX1) LINE IXT COLUMN 16.
    ADD 1 TO IX1 IXT IF IX1<=15 AND IXT<=22 GO BP53.
    PERFORM INIT-PH MOVE LK-PART TO PH-NO MOVE 0 TO BP-KNF.
    READ PART REGARDLESS INVALID MOVE 1 TO BP-KNF. PERFORM PART-TYPE.

    DISPLAY "PRESS 'RETURN' TO IGNORE THIS LINE" LINE 24 BOLD.
    ACCEPT BP-AF1 LINE 11 COLUMN 1 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF BP-AF1=0 SUBTRACT 1 FROM BP-NLINE GO BP5. MOVE BP-AF1 TO LK-QTY.
    ACCEPT LK-UNIT LINE 11 COLUMN 10 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    DISPLAY LK-PRICE LINE 11 COLUMN 30 CONVERSION.
    ACCEPT LK-PRICE LINE 11 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LK-PRICE LINE 11 COLUMN 30 CONVERSION.
    ACCEPT LK-MODE LINE 11 COLUMN 41 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LK-DISC LINE 11 COLUMN 48 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    MOVE LK-QTY TO CL-QTY PERFORM KPRICE-CALC.
    MOVE CL-AMT TO LK-TOTAL BP-AF2 DISPLAY BP-AF2 LINE 11 COLUMN 53 CONVERSION.
BP57. IF LK-CAT=0 MOVE 13 TO IXT DISPLAY "G/L:" LINE IXT COLUMN 52 BOLD
       MOVE 57 TO IXU MOVE LK-GL TO WS-GL PERFORM AX-GL
       PERFORM CHK-GL IF A-S1=1 GO BP57 END-IF MOVE WS-GL TO LK-GL.
    WRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    IF BP-KNF=0 MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY
      ADD A-T1 TO PH-ORDER ROUNDED PERFORM PRI-SET-PRICE
      REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    GO BP5.
BP58. MOVE "'CAN' TO CANCEL THIS NEW ORDER: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="CAN" GO BP59.
    DELETE PURORD MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO BP588.
BP583. READ PURLIN NEXT REGARDLESS END GO BP588. IF LK-ORD NOT=OK-NO GO BP588.
    DELETE PURLIN MOVE LK-PART TO PH-NO READ PART REGARDLESS INVALID GO BP583.
    PERFORM PART-TYPE MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY.
    SUBTRACT A-T1 FROM PH-ORDER ROUNDED.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO BP583.
BP588.
BP59. GO BP3.
BP9. GO MN9.

* P-18 MODIFY M.O. MAT. ALLOC. INDICATOR
WY1. PERFORM RD403 PERFORM WRT.
WY3. ACCEPT R-NO LINE 3 COLUMN 8 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO WY9. PERFORM RDF-PRODORD IF A-S1=1 GO WY3.
    DISPLAY R-ALLOC LINE 3 COLUMN 40 CONVERSION.
WY7. ACCEPT R-ALLOC LINE 3 COLUMN 40 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY R-ALLOC LINE 3 COLUMN 40 CONVERSION.
    IF R-ALLOC>2 PERFORM DSP-ERR2 GO WY7.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD GO WY3.
WY9. GO MN9.

* P-21 VENDOR FILE MAINTENANCE
VM1.
VM3. PERFORM RD132 PERFORM WRT.
    ACCEPT VM-NO LINE 3 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR VM-NO=9999 GO VM9. IF VM-NO=0 PERFORM DSP-ERR17 GO VM3.
    ACCEPT VM-OP LINE 3 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF VM-OP=9 GO VM9.
    GO VM40 VM50 VM60  DEPENDING VM-OP. PERFORM DSP-ERR1 GO VM3.
VM40. MOVE LOW-VALUES TO V-RECORD INITIALIZE V-REC.
    MOVE WS-DIV TO V-DIV MOVE VM-NO TO V-NO.
    MOVE SYS-DATE TO V-CRDATE START VENDOR REGARDLESS INVALID GO VM42.
    MOVE "DUPLICATE VENDOR NO." TO ERR-MESG PERFORM DSP-ERR GO VM3.
    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
VM42. PERFORM RD133 MOVE V-NO TO TF192(3) PERFORM WRT.
    ACCEPT V-NAME LINE 5 COLUMN 14 ACC-ALP.
    ACCEPT V-ADD1 LINE 6 COLUMN 14 ACC-ALP.
    ACCEPT V-ADD2 LINE 7 COLUMN 14 ACC-ALP.
    ACCEPT V-POST LINE 8 COLUMN 14 ACC-ALP.
    ACCEPT V-DISC LINE 9 COLUMN 14 ACC-NUM.
    ACCEPT V-CONTRA LINE 10 COLUMN 14 ACC-NUM.
    ACCEPT V-PAY LINE 11 COLUMN 14 ACC-NUM.
    ACCEPT V-CLASS LINE 12 COLUMN 19 ACC-NUM.
    WRITE V-RECORD ALLOWING NO UNLOCK VENDOR GO VM3.
    REPLACE OFF.
VM50. MOVE WS-DIV TO V-DIV MOVE VM-NO TO V-NO.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO VM3.
    PERFORM RD134 MOVE V-NO TO TF212(3) MOVE V-NAME TO TF213(3) PERFORM WRT.
    PERFORM RD134A PERFORM WRT.
VM53. ACCEPT VM-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO VM551 VM552 VM553 VM554 VM555 VM556 VM557 VM558 VM559 VM5510
       VM5511 VM5512 VM5513 VM5514 VM5515 VM5516 VM5517 VM5518 VM5519 VM5520
       VM5521 VM5522 VM5523 VM5524 VM5525 VM5526 VM5527 VM5528 VM5529 VM5530
      DEPENDING VM-FLD. GO VM3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
VM551. DISPLAY V-NAME COLUMN 30 BOLD ACCEPT V-NAME ACC-ALP.
    MOVE V-NAME TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-NAME GO VM58.
VM552. DISPLAY V-ADD1 COLUMN 30 BOLD ACCEPT V-ADD1 ACC-ALP.
    MOVE V-ADD1 TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-ADD1 GO VM58.
VM553. DISPLAY V-ADD2 COLUMN 30 BOLD ACCEPT V-ADD2 ACC-ALP.
    MOVE V-ADD2 TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-ADD2 GO VM58.
VM554. DISPLAY V-POST COLUMN 30 BOLD ACCEPT V-POST ACC-ALP.
    MOVE V-POST TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-POST GO VM58.
VM555. DISPLAY V-DISC COLUMN 30 CONVERSION BOLD ACCEPT V-DISC ACC-NUM.
    MOVE V-DISC TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-DISC GO VM58.
VM556. DISPLAY V-GROSS(1) COLUMN 30 CONVERSION BOLD ACCEPT V-GROSS(1) ACC-NUM.
    MOVE V-GROSS(1) TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-GROSS(1) GO VM58.
VM557. DISPLAY V-GROSS(2) COLUMN 30 CONVERSION BOLD ACCEPT V-GROSS(2) ACC-NUM.
    MOVE V-GROSS(2) TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-GROSS(2) GO VM58.
VM558. DISPLAY V-NET(1) COLUMN 30 CONVERSION BOLD ACCEPT V-NET(1) ACC-NUM.
    MOVE V-NET(1) TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-NET(1) GO VM58.
VM559. DISPLAY V-NET(2) COLUMN 30 CONVERSION BOLD ACCEPT V-NET(2) ACC-NUM.
    MOVE V-NET(2) TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-NET(2) GO VM58.
VM5510. DISPLAY V-PUR-YTD(1) COLUMN 30 CONVERSION BOLD ACCEPT V-PUR-YTD(1) ACC-NUM.
    MOVE V-PUR-YTD(1) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PUR-YTD(1) GO VM58.
VM5511. DISPLAY V-PUR-YTD(2) COLUMN 30 CONVERSION BOLD ACCEPT V-PUR-YTD(2) ACC-NUM.
    MOVE V-PUR-YTD(2) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PUR-YTD(2) GO VM58.
VM5512. DISPLAY V-PUR-LAST(1) COLUMN 30 CONVERSION BOLD ACCEPT V-PUR-LAST(1) ACC-NUM.
    MOVE V-PUR-LAST(1) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PUR-LAST(1) GO VM58.
VM5513. DISPLAY V-PUR-LAST(2) COLUMN 30 CONVERSION BOLD ACCEPT V-PUR-LAST(2) ACC-NUM.
    MOVE V-PUR-LAST(2) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PUR-LAST(2) GO VM58.
VM5514. DISPLAY V-PUR-2(1) COLUMN 30 CONVERSION BOLD ACCEPT V-PUR-2(1) ACC-NUM.
    MOVE V-PUR-2(1) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PUR-2(1) GO VM58.
VM5515. DISPLAY V-PUR-2(2) COLUMN 30 CONVERSION BOLD ACCEPT V-PUR-2(2) ACC-NUM.
    MOVE V-PUR-2(2) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PUR-2(2) GO VM58.
VM5516. DISPLAY V-DISC-YTD(1) COLUMN 30 CONVERSION BOLD ACCEPT V-DISC-YTD(1) ACC-NUM.
    MOVE V-DISC-YTD(1) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-DISC-YTD(1) GO VM58.
VM5517. DISPLAY V-DISC-YTD(2) COLUMN 30 CONVERSION BOLD ACCEPT V-DISC-YTD(2) ACC-NUM.
    MOVE V-DISC-YTD(2) TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-DISC-YTD(2) GO VM58.
VM5518. MOVE V-INV-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT COLUMN 30 BOLD.
    MOVE V-INV-DATE TO D-DATE MOVE 21 TO IXT MOVE 30 TO IXU.
    PERFORM AX-DT-DEF MOVE DATE0 TO V-INV-DATE.
    MOVE V-INV-DATE TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-INV-DATE GO VM58.
VM5519. DISPLAY V-CONTRA COLUMN 30 CONVERSION BOLD ACCEPT V-CONTRA ACC-NUM.
    MOVE V-CONTRA TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-CONTRA GO VM58.
VM5520. DISPLAY V-PAY COLUMN 30 CONVERSION BOLD ACCEPT V-PAY ACC-NUM.
    MOVE V-PAY TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-PAY GO VM58.
VM5521. DISPLAY V-CLASS COLUMN 30 CONVERSION BOLD ACCEPT V-CLASS ACC-NUM.
    MOVE V-CLASS TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-CLASS GO VM58.
VM5522. DISPLAY V-GST-IND COLUMN 30 CONVERSION BOLD ACCEPT V-GST-IND ACC-NUM.
    MOVE V-GST-IND TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-GST-IND GO VM58.
VM5523. DISPLAY V-FREIGHT-STD COLUMN 30 CONVERSION BOLD ACCEPT V-FREIGHT-STD ACC-NUM.
    MOVE V-FREIGHT-STD TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-FREIGHT-STD GO VM58.
VM5524. DISPLAY V-FREIGHT-RATE COLUMN 30 CONVERSION BOLD ACCEPT V-FREIGHT-RATE ACC-NUM.
    MOVE V-FREIGHT-RATE TO WD1 PERFORM RDLK-VENDOR MOVE WD1 TO V-FREIGHT-RATE GO VM58.
VM5525. DISPLAY V-FRPAY COLUMN 30 CONVERSION BOLD ACCEPT V-FRPAY ACC-NUM.
    MOVE V-FRPAY TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-FRPAY GO VM58.
VM5526. DISPLAY V-SIND COLUMN 30 CONVERSION BOLD ACCEPT V-SIND ACC-NUM.
    MOVE V-SIND TO WN1 PERFORM RDLK-VENDOR MOVE WN1 TO V-SIND GO VM58.
VM5527. DISPLAY V-SNAME COLUMN 30 BOLD ACCEPT V-SNAME ACC-ALP.
    MOVE V-SNAME TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-SNAME GO VM58.
VM5528. DISPLAY V-SADD1 COLUMN 30 BOLD ACCEPT V-SADD1 ACC-ALP.
    MOVE V-SADD1 TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-SADD1 GO VM58.
VM5529. DISPLAY V-SADD2 COLUMN 30 BOLD ACCEPT V-SADD2 ACC-ALP.
    MOVE V-SADD2 TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-SADD2 GO VM58.
VM5530. DISPLAY V-SPOST COLUMN 30 BOLD ACCEPT V-SPOST ACC-ALP.
    MOVE V-SPOST TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-SPOST GO VM58.
VM58. REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR GO VM53.
    REPLACE OFF.
VM60. MOVE WS-DIV TO V-DIV MOVE VM-NO TO V-NO.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO VM3.
    IF V-NAME=" " DELETE VENDOR ELSE PERFORM DSP-ERR59. GO VM3.
VM9. GO MN9.

* P-22 GENERATE INVOICES DIRECTLY
AG1. PERFORM RD353 PERFORM WRT.
    PERFORM RDR-INFO MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    ADD 1 TO IXT DISPLAY "A/P EFFECTIVE DATE: " LINE IXT BOLD D-DT.
    PERFORM AX-EXCH PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    OPEN I-O MNTORD ALLOWING ALL MNTLIN ALLOWING ALL.
AG3. DISPLAY " " LINE 2 ERASE END SCREEN.
    MOVE 3 TO IXT DISPLAY "VENDOR: ____" LINE IXT BOLD ERASE END SCREEN.
    ACCEPT V-NO LINE IXT COLUMN 9 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR V-NO=9999 GO AG9. MOVE WS-DIV TO V-DIV.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO AG3.
    DISPLAY V-NAME LINE IXT COLUMN 15.
AG33. MOVE 4 TO IXT DISPLAY " " LINE 3 COLUMN 50 ERASE END LINE.
    PERFORM INIT-AT MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    DISPLAY "INVOICE NO.: _______________   DIRECT PAY ? ___" LINE IXT BOLD ERASE END SCREEN.
    DISPLAY "PRESS PF4 TO START ANOTHER VENDOR" LINE 24 BOLD.
    ACCEPT AT-INV LINE IXT COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR AT-INV=ALL "9" GO AG3. IF AT-INV=" " PERFORM DSP-ERR2 GO AG33.
    ACCEPT XA3 LINE IXT COLUMN 45 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" GO AG50.

    MOVE V-NO TO A-N1 PERFORM CHK-VENSP IF A-N1=0 GO AG4.
    IF A-N1=1
      DISPLAY "______________________________" LINE 3 COLUMN 50
      DISPLAY "______________________________" LINE 4 COLUMN 50
      DISPLAY "________________________" LINE 5 COLUMN 50
      DISPLAY "_______" LINE 6 COLUMN 50
      GO AG36.
    DISPLAY "P/R DIV. __    EMPL NO. ____" LINE 2 COLUMN 50 BOLD ERASE END LINE.
    MOVE 2 TO IXT MOVE 59 TO IXU PERFORM AX-PDIV.
    MOVE WS-PDIV TO EMPL-DIV OPEN I-O EMPL ALLOWING ALL.
AG345. ACCEPT E-NO LINE 2 COLUMN 74 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE WS-PDIV TO E-DIV READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO AG345.
    CLOSE EMPL.
    MOVE E-NAME TO AT-NAME MOVE E-ADD1 TO AT-ADD1 MOVE E-ADD2 TO AT-ADD2 MOVE E-POST TO AT-POST.
    DISPLAY AT-NAME LINE 3 COLUMN 50 AT-ADD1 LINE 4 COLUMN 50
      AT-ADD2 LINE 5 COLUMN 50 AT-POST LINE 6 COLUMN 50.
AG36. DISPLAY "PAYEE NAME" LINE 2 COLUMN 50 BOLD ERASE END LINE.
AG37. DISPLAY "ENTER PAYEE NAME AND ADDRESS" LINE 24 BOLD.
    ACCEPT AT-NAME LINE 3 COLUMN 50 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT AT-ADD1 LINE 4 COLUMN 50 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT AT-ADD2 LINE 5 COLUMN 50 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT AT-POST LINE 6 COLUMN 50 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM DSP-ERS PERFORM DSP-ACC IF XA2 NOT="OK" GO AG37.
    DISPLAY " " LINE 2 COLUMN 50 ERASE END LINE " " LINE 4 COLUMN 50 ERASE END SCREEN.

AG4. MOVE 4 TO IXT.
    READ APTR REGARDLESS INVALID GO AG42. PERFORM DSP-ERR42 GO AG88.
AG42. MOVE V-NO TO GRT-VEN PERFORM GRT-CHKDUP IF A-S1=1 PERFORM DSP-ERR38 GO AG88.
    DISPLAY "MEMO: __________________" LINE IXT COLUMN 56 BOLD.
    ACCEPT AT-MEMO LINE IXT COLUMN 62 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 5 TO IXT DISPLAY "INV DATE: ______    DUE DATE: ______    PROJECT: ______" LINE IXT BOLD.
AG43. MOVE 11 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO AT-INV-DATE D-DATE.
    MOVE 20 TO D-N1 MOVE 0 TO D-N2 PERFORM D-CHKDTR IF D-ERR=1 GO AG43.
    PERFORM CALC-DUE-DATE MOVE 31 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO AT-DUE-DATE.
    ACCEPT AT-PROJECT LINE IXT COLUMN 50 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    GO AG6.

AG50. MOVE 1 TO AT-TYPE MOVE LOW-VALUES TO AH-RECORD INITIALIZE AH-REC.
    MOVE AT-INV TO A-A1 PERFORM STR-LTH.
    IF A-N1>6 OR AT-INV(1:A-N1) NOT NUMERIC PERFORM DSP-ERR22 GO AG88.
    MOVE 0 TO AH-NO MOVE AT-INV TO AG-IFA MOVE AG-IFN(1:A-N1) TO AH-NO(7 - A-N1:).
    MOVE WS-DIV TO AH-DIV MOVE V-NO TO AH-VEN.
    READ APTR REGARDLESS INVALID GO AG52. PERFORM DSP-ERR42 GO AG88.
AG52. PERFORM GRT-CHKDUP IF A-S1=1 PERFORM DSP-ERR38 GO AG88.
    MOVE 56 TO IXU PERFORM AX-CHQDATE.
    MOVE "** DIRECT PAY" TO AT-MEMO MOVE 1 TO AT-IND.

AG6. MOVE 6 TO IXT DISPLAY "US$ ? ___" LINE IXT BOLD.
    MOVE V-NO TO A-N1 PERFORM CHK-VENUS IF A-S1=1 MOVE "YES" TO XA3 ELSE MOVE " " TO XA3.
    ACCEPT XA3 LINE IXT COLUMN 7 DEFAULT CURRENT UNDERLINED PROTECTED.
    IF XA3="YES" MOVE WS-EXCH TO AT-EXCH.
    MOVE 8 TO IXT DISPLAY "          DISTRIBUTION ACCOUNT          AMOUNT" LINE IXT BOLD ERASE LINE.
*                                    ...... ... .. .......    -.......:..
    MOVE 0 TO IX1.
AG73. ADD 1 TO IX1 IXT IF IX1>10 GO AG76.
AG75. MOVE 11 TO IXU MOVE 0 TO WS-GL PERFORM AX-GL.
    IF KPF4 OR WS-GL=0 DISPLAY LIT-SP(1:21) COLUMN 11 GO AG76.
    MOVE WS-DIV TO G-DIV MOVE WS-GL TO G-GL.
    READ GLDIST REGARDLESS INVALID PERFORM DSP-ERR16 GO AG75.
    PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2=IX1
      IF WS-GL=AT-GL(IX2) MOVE "DUPLICATE DISTRIBUTION ACCOUNT" TO ERR-MESG
        PERFORM DSP-ERR GO AG75 END-IF END-PERFORM.
    ACCEPT AT-AMT(IX1) LINE IXT COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY AT-AMT(IX1) LINE IXT COLUMN 36 CONVERSION.
    MOVE WS-GL TO AT-GL(IX1) ADD AT-AMT(IX1) TO AT-GROSS AT-TOTAL.
    MOVE 0 TO AG-MNTORD(IX1) IF NOT(WS-GL1=212707 OR 212708) GO AG758.
    DISPLAY "MAINT. ORDER:" LINE IXT COLUMN 55 BOLD.
AG753. ACCEPT VO-NO LINE IXT COLUMN 69 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF VO-NO=0 GO AG758. READ MNTORD REGARDLESS INVALID PERFORM DSP-ERR25 GO AG753.
    MOVE VO-NO TO AG-MNTORD(IX1).
AG758. GO AG73.
AG76. IF V-GST-IND=1 GO AG78.
    MOVE V-NO TO A-N1 PERFORM CHK-VENUS IF A-S1=1 GO AG78.
    COMPUTE AT-GST ROUNDED=AT-TOTAL * IF-GST / 100.
    ADD 1 TO IXT DISPLAY "     GST:" LINE IXT.
    DISPLAY AT-GST LINE IXT COLUMN 36 CONVERSION.
    ACCEPT AT-GST LINE IXT COLUMN 36 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY AT-GST LINE IXT COLUMN 36 CONVERSION.
    ADD AT-GST TO AT-GROSS.
AG78. ADD 1 TO IXT DISPLAY "** TOTAL:" LINE IXT BOLD.
    DISPLAY AT-GROSS LINE IXT COLUMN 36 CONVERSION BOLD "*" BOLD.
    IF V-DISC=0 MOVE AT-GROSS TO AT-NET GO AG8.
    COMPUTE AT-DISC ROUNDED=AT-TOTAL * V-DISC / 100.
    ADD 1 TO IXT DISPLAY "DISCOUNT:" LINE IXT.
    DISPLAY AT-DISC LINE IXT COLUMN 36 CONVERSION.
    DISPLAY V-DISC COLUMN 50 CONVERSION "%".
    ACCEPT AT-DISC LINE IXT COLUMN 36 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY AT-DISC LINE IXT COLUMN 36 CONVERSION ERASE END LINE.
    COMPUTE AT-NET=AT-GROSS - AT-DISC.
    ADD 1 TO IXT DISPLAY "     NET:" LINE IXT BOLD.
    DISPLAY AT-NET LINE IXT COLUMN 36 CONVERSION BOLD.
AG8. MOVE SYS-DATE TO AT-DATE AT-EFF-DATE MOVE 1 TO AT-MANUAL.
    MOVE "'CAN' TO CANCEL THIS INVOICE: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" ADD 1 TO IXT DISPLAY "** CANCELED **" LINE IXT REVERSED GO AG88.

    PERFORM RDLK-VENDOR IF AT-EXCH=0 MOVE 1 TO AG-IXE ELSE MOVE 2 TO AG-IXE.
    ADD AT-TOTAL TO V-PUR-YTD(AG-IXE) ROUNDED.
    IF AT-TYPE=0 MOVE AT-INV-DATE TO V-INV-DATE
      ADD AT-GROSS TO V-GROSS(AG-IXE) ADD AT-NET TO V-NET(AG-IXE)
      ADD AT-DISC TO V-DISC-YTD(AG-IXE) ROUNDED.
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR.

    IF AT-TYPE=0 GO AG84. IF AT-EXCH=0 MOVE 0 TO AH-US ELSE MOVE 1 TO AH-US.
    MOVE AT-GROSS TO AH-GROSS MOVE AT-NET TO AH-NET.
    MOVE WS-CHQDATE TO AH-CHQDATE MOVE WS-CHNDATE TO AH-CHNDATE.
    WRITE AH-RECORD ALLOWING NO INVALID MOVE "DUPLICATE CHEQUE NO."
      TO ERR-MESG PERFORM DSP-ERR GO AG88. UNLOCK APCHQ.
    MOVE AH-NO TO AT-CHQNO MOVE WS-CHQDATE TO AT-CHQDATE.

AG84. PERFORM SET-ATKD WRITE AT-RECORD ALLOWING NO UNLOCK APTR.
    MOVE V-NO TO GRT-VEN PERFORM GRT-PROC.

    MOVE 0 TO IX1.
AG85. ADD 1 TO IX1 IF IX1>10 OR AT-GL(IX1)=0 GO AG86. IF AG-MNTORD(IX1)=0 GO AG85.
    MOVE AG-MNTORD(IX1) TO VO-NO READ MNTORD REGARDLESS INVALID GO AG85.
    MOVE 1 TO A-N1 PERFORM INIT-VL MOVE " " TO VL-PART MOVE AT-INV-DATE TO VL-DATE.
    MOVE V-NO TO VL-EMP MOVE 1 TO VL-VEN MOVE AT-AMT(IX1) TO VL-AMT.
    WRITE VL-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK MNTLIN GO AG85.
AG86.
AG88. PERFORM DSP-CONT GO AG33.
AG9. CLOSE MNTORD MNTLIN GO MN9.

* P-23 GENERATE INVOICES FROM ORDERS
IG1. PERFORM RD354 PERFORM WRT.
    PERFORM RDR-INFO MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    ADD 1 TO IXT DISPLAY "A/P EFFECTIVE DATE: " LINE IXT BOLD D-DT.
    PERFORM AX-EXCH PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-AUDIT OPEN I-O TMPURORD ALLOWING ALL TMPURLIN ALLOWING ALL
      MNTORD ALLOWING ALL MNTLIN ALLOWING ALL.
    DISPLAY " " LINE 2 ERASE END SCREEN.
IG3. PERFORM INIT-AT MOVE 0 TO IG-VEN IG-IXR IG-NORD.
    MOVE 3 TO IXT DISPLAY "INVOICE NO.: _______________ " LINE IXT BOLD ERASE END SCREEN.
IG31. ACCEPT AT-INV LINE IXT COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR AT-INV=ALL "9" GO IG9. IF AT-INV=" " PERFORM DSP-ERR2 GO IG31.
    DISPLAY "ORDER NO.:" LINE 4 BOLD.
IG33. DISPLAY " " LINE 8 ERASE END SCREEN ADD 1 TO IG-IXR IF IG-IXR>23 GO IG6.
IG35. MOVE 4 TO IXT MOVE 0 TO WN1.
    IF IG-IXR>7 ADD 1 TO IXT ADD 8 TO WN1. IF IG-IXR>15 ADD 1 TO IXT ADD 8 TO WN1.
    COMPUTE IXU=2 + 10 * (IG-IXR - WN1).
    DISPLAY "PRESS PF4 AFTER THE LAST ORDER FOR THIS INVOICE" LINE 24 BOLD.
    ACCEPT OK-NO LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR OK-NO=ALL "9" GO IG6. IF OK-NO=" " PERFORM DSP-ERR8 GO IG35.
    READ PURORD REGARDLESS INVALID PERFORM DSP-ERR8 GO IG35.
    IF IG-VEN=0 GO IG4. IF OK-VENDOR=IG-VEN GO IG50.
    MOVE "THIS ORDER HAS A DIFFERENT VENDOR" TO ERR-MESG PERFORM DSP-ERR GO IG35.

IG4. MOVE WS-DIV TO V-DIV MOVE OK-VENDOR TO V-NO IG-VEN.
    MOVE OK-FOB TO IG-FOB MOVE OK-US TO IG-US MOVE OK-PSTPAY TO IG-PSTPAY.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR51 GO IG35.
    DISPLAY V-NAME LINE 3 COLUMN 45.
    MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN MOVE 0 TO AT-TYPE.
    READ APTR REGARDLESS INVALID GO IG42. PERFORM DSP-ERR42 GO IG88.
IG42. PERFORM GRT-CHKDUP IF A-S1=1 PERFORM DSP-ERR38 GO IG88.
    MOVE 7 TO IXT DISPLAY "INV DATE: ______    DUE DATE: ______" LINE IXT BOLD.
IG43. MOVE 11 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO AT-INV-DATE D-DATE.
    MOVE 20 TO D-N1 MOVE 0 TO D-N2 PERFORM D-CHKDTR IF D-ERR=1 GO IG43.
    PERFORM CALC-DUE-DATE MOVE 31 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO AT-DUE-DATE.
    IF IG-US=1 MOVE WS-EXCH TO AT-EXCH. MOVE OK-NO TO AT-ORD.

IG50. MOVE OK-NO TO IG-ORD(IG-IXR) MOVE IG-IXR TO IG-NORD.
    MOVE 10 TO IXT DISPLAY "EXCEPTION LINES: " LINE IXT REVERSED.
    MOVE 12 TO IXT.
    DISPLAY "                ----- ORDERED -----        ----- RECEIVED -----" LINE IXT BOLD.
    MOVE 13 TO IXT.
    DISPLAY "PART NO.           QTY       AMOUNT          QTY         AMOUNT" LINE IXT BOLD.
*            ............ .......... ........:..    ..........   ........:..   DIS: .........
    MOVE 10 TO IXT DISPLAY "CORRECTION ? ___" LINE IXT COLUMN 64 BOLD.
    ACCEPT XA3 LINE IXT COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO IG-COR ELSE MOVE 0 TO IG-COR.

    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IG504.
IG503. READ PURLIN NEXT REGARDLESS END GO IG504. IF LK-ORD NOT=OK-NO GO IG504.
    IF NOT(LK-QTY-LAST=0 AND LK-TOTAL-LAST=0 AND LK-CHARGE-LAST=" ")
      INITIALIZE LK-QTY-LAST LK-TOTAL-LAST LK-CHARGE-LAST
      REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    GO IG503.
IG504.

IG51. IF IG-COR NOT=1 GO IG52. PERFORM IG-ERS MOVE 15 TO IXT.
    IF INUT OR OK-SUBCON=1 DISPLAY "ENTER LINE NUMBER TO BE CORRECTED   (PF4 TO END)" LINE 24 BOLD
      ACCEPT IG-LK-LINE LINE IXT COLUMN 1 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY
     ELSE DISPLAY "ENTER PART NO. OF LINE TO BE CORRECTED   (PF4 TO END)" LINE 24 BOLD
      ACCEPT IG-LK-PART LINE IXT COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    PERFORM DSP-ERS IF KPF4 GO IG59.
IG52. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE IG-LNO.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IG58.
IG53. READ PURLIN NEXT REGARDLESS END GO IG58. IF LK-ORD NOT=OK-NO GO IG58.
    ADD 1 TO IG-LNO IF IG-COR=0 GO IG532.
    IF INUT OR OK-SUBCON=1 IF IG-LNO=IG-LK-LINE GO IG532 ELSE GO IG53
      ELSE IF LK-PART=IG-LK-PART GO IG532 ELSE GO IG53.
IG532. IF IG-COR=0 AND LK-BLANKET=0
      IF (LK-QTY>=0 AND<=LK-QTY-REC) OR (LK-QTY<0 AND>=LK-QTY-REC) GO IG53.
* note 106.1
    MOVE LK-CAT TO PH-CAT PERFORM PART-TYPE.
    IF LK-CAT NOT=0 MOVE LK-CAT TO A-N1 MOVE LK-MTYPE TO A-N2 MOVE V-CONTRA TO A-N3
      PERFORM RD-CATGL MOVE WS-GL TO LK-GL.
    MOVE 0 TO LK-QTY-LAST LK-TOTAL-LAST.
    PERFORM IG-ERS MOVE 15 TO IXT DISPLAY LK-PART LINE IXT.
    IF LK-BLANKET=0 MOVE LK-QTY TO A-T1 PERFORM MUL-MQTY MOVE A-T1 TO IG-WQTY
      DISPLAY IG-WQTY LINE IXT COLUMN 14 CONVERSION
      DISPLAY LK-TOTAL LINE IXT COLUMN 25 CONVERSION
      COMPUTE A-T1=LK-QTY - LK-QTY-REC PERFORM MUL-MQTY MOVE A-T1 TO IG-QTY
      COMPUTE LK-TOTAL-LAST=LK-TOTAL - LK-TOTAL-REC
     ELSE MOVE 0 TO IG-QTY DISPLAY LIT-BL LINE IXT COLUMN 15.
    DISPLAY IG-QTY LINE IXT COLUMN 40 CONVERSION.
    DISPLAY LK-TOTAL-LAST LINE IXT COLUMN 53 CONVERSION.
    MOVE 18 TO IXT DISPLAY "CAT.        G/L:" LINE IXT COLUMN 43 BOLD.
    DISPLAY LK-CAT COLUMN 48 CONVERSION MOVE LK-GL TO WS-GL MOVE 60 TO IXU PERFORM DSP-GL.
    MOVE IG-QTY TO IG-QTY-SV.
IG535. MOVE 15 TO IXT.
    ACCEPT IG-QTY LINE IXT COLUMN 40 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 GO IG58.
    DISPLAY IG-QTY LINE IXT COLUMN 40 CONVERSION.
    MOVE IG-QTY TO A-T1 PERFORM DIV-MQTY MOVE A-T1 TO LK-QTY-LAST.
    MOVE LK-QTY-LAST TO CL-QTY PERFORM KPRICE-CALC MOVE CL-AMT TO LK-TOTAL-LAST.
    DISPLAY LK-TOTAL-LAST LINE IXT COLUMN 53 CONVERSION.
    IF LK-DISC NOT=0 DISPLAY "DIS:" COLUMN 67 BOLD CL-DTXT(1:9) COLUMN 72.
    IF LK-TOTAL-LAST=0
      ACCEPT LK-TOTAL-LAST LINE IXT COLUMN 53 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY LK-TOTAL-LAST LINE IXT COLUMN 53 CONVERSION.
    IF IG-QTY-SV>0 AND IG-QTY>IG-QTY-SV * 2 MOVE "QTY RECEIVED IS TOO LARGE"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO IG535.
    IF LK-TOTAL-LAST>1000000 MOVE "AMOUNT FOR QTY RECEIVED IS TOO LARGE"
      TO ERR-MESG PERFORM DSP-ERR GO IG535.
    IF LK-CAT=0 OR LK-GL=0 GO IG54.
    MOVE WS-DIV TO G-DIV MOVE LK-GL TO G-GL.
    READ GLDIST REGARDLESS INVALID GO IG538. IF G-NGL=0 GO IG538. GO IG56.
IG538. MOVE "G/L OR 'NEW G/L' A/C INVALID - CORRECT IT" TO ERR-MESG PERFORM DSP-ERR.
IG54.
IG55. MOVE 18 TO IXT MOVE 60 TO IXU MOVE LK-GL TO WS-GL PERFORM AX-GL.
    PERFORM CHK-GL IF A-S1=1 GO IG55. MOVE WS-GL TO LK-GL.
IG56. PERFORM DSP-CONT REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    GO IG53.

IG58. IF IG-COR=1 GO IG51. MOVE 0 TO IG-COR PERFORM IG-ERS.
    MOVE "DO YOU WANT TO CORRECT A LINE ? ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="YES" GO IG59.
    IF INUT OR OK-SUBCON=1 DISPLAY "ENTER LINE NUMBER TO BE CORRECTED: __" LINE 24 BOLD
      ACCEPT IG-LK-LINE COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS
      IF IG-LK-LINE>0 GO IG588 ELSE GO IG59 END-IF
     ELSE DISPLAY "ENTER PART NO. OF LINE TO BE CORRECTED: ____________" LINE 24 BOLD
      ACCEPT IG-LK-PART COLUMN 41 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS
      IF IG-LK-PART>" " GO IG588 ELSE GO IG59.
IG588. MOVE 2 TO IG-COR GO IG51.
IG59. GO IG33.

IG6. MOVE 10 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    MOVE 0 TO IG-IXR IX1.
IG61. ADD 1 TO IG-IXR IF IG-IXR>IG-NORD GO IG66.
    MOVE IG-ORD(IG-IXR) TO OK-NO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IG64.
IG63. READ PURLIN NEXT REGARDLESS END GO IG64. IF LK-ORD NOT=OK-NO GO IG64.
    IF LK-QTY-LAST=0 OR LK-GL=0 GO IG63.
* note 106.2
    IF LK-CAT=801 MOVE LK-PART TO A-A1 PERFORM PROD-RD
      COMPUTE IG-QTY ROUNDED=LK-QTY-LAST * P-WEIGHT / 100
     ELSE MOVE LK-CAT TO PH-CAT PERFORM PART-TYPE
      MOVE LK-QTY-LAST TO A-T1 PERFORM MUL-MQTY COMPUTE IG-QTY ROUNDED=A-T1.
    MOVE 0 TO IX2.
IG633. ADD 1 TO IX2 IF IX2>IX1 GO IG634.
    IF LK-GL=AT-GL(IX2)
      ADD LK-TOTAL-LAST TO AT-AMT(IX2) ADD IG-QTY TO AT-QTY(IX2) GO IG636.
    GO IG633.
IG634. IF IX1<10 ADD 1 TO IX1 MOVE LK-GL TO AT-GL(IX1)
         MOVE LK-TOTAL-LAST TO AT-AMT(IX1) MOVE IG-QTY TO AT-QTY(IX1).
IG636. GO IG63.
IG64. GO IG61.
IG66.

    DISPLAY "               AMOUNT    DISTRIBUTION ACCOUNT" LINE IXT BOLD.
*                      -.......:..    ...... ... .. .......
    MOVE 0 TO IX1 IG-NUMLN.
IG67. ADD 1 TO IX1 IXT IF IX1>10 OR AT-GL(IX1)=0 GO IG68.
    ADD 1 TO IG-NUMLN ADD AT-AMT(IX1) TO AT-GROSS AT-TOTAL.
    DISPLAY AT-AMT(IX1) LINE IXT COLUMN 11 CONVERSION.
    MOVE AT-GL(IX1) TO WS-GL MOVE 26 TO IXU PERFORM DSP-GL GO IG67.
IG68. IF IXT>15 MOVE 11 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN
       ADD 1 TO IXT DISPLAY "**" LINE IXT AT-GROSS COLUMN 11 CONVERSION.
    IF IG-FOB=WS-FOB GO IG70.
    ADD 1 TO IXT DISPLAY " FREIGHT:" LINE IXT.
    ACCEPT AT-FREIGHT LINE IXT COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY AT-FREIGHT LINE IXT COLUMN 11 CONVERSION.
    DISPLAY "FREIGHT PAID TO VENDOR ? ___" LINE IXT COLUMN 50.
    ACCEPT XA3 LINE IXT COLUMN 75 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO AT-FRPAY ADD AT-FREIGHT TO AT-GROSS.
    IF IG-NUMLN>0 GO IG70.
    DISPLAY "THIS INVOICE HAS NO LINES: ENTER FREIGHT G/L ACCOUNT" LINE 24 BOLD.
IG683. MOVE 26 TO IXU MOVE 0 TO WS-GL PERFORM AX-GL.
    MOVE WS-DIV TO G-DIV MOVE WS-GL TO G-GL.
    READ GLDIST REGARDLESS INVALID PERFORM DSP-ERR16 GO IG683.
    MOVE WS-GL TO AT-FGL PERFORM DSP-ERS.
IG70. IF V-GST-IND=1 GO IG72.
    MOVE V-NO TO A-N1 PERFORM CHK-VENUS IF A-S1=1 AND IG-US=1 GO IG72.
    IF IG-US=0 MOVE AT-TOTAL TO WD1 IF AT-FRPAY=1 ADD AT-FREIGHT TO WD1 END-IF
      COMPUTE AT-GST ROUNDED=WD1 * IF-GST / 100.
    ADD 1 TO IXT DISPLAY "     GST:" LINE IXT AT-GST COLUMN 11 CONVERSION.
    ACCEPT AT-GST LINE IXT COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY AT-GST LINE IXT COLUMN 11 CONVERSION.
    ADD AT-GST TO AT-GROSS.
IG72. IF IG-PSTPAY=0 GO IG74. COMPUTE AT-PST ROUNDED=AT-TOTAL * IF-PST / 100.
    ADD 1 TO IXT DISPLAY "     PST:" LINE IXT AT-PST COLUMN 11 CONVERSION.
    ACCEPT AT-PST LINE IXT COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY AT-PST LINE IXT COLUMN 11 CONVERSION.
    ADD AT-PST TO AT-GROSS.
IG74. ADD 1 TO IXT DISPLAY "** TOTAL:" LINE IXT BOLD
       AT-GROSS COLUMN 11 CONVERSION BOLD "*" BOLD.
    IF V-DISC=0 MOVE AT-GROSS TO AT-NET GO IG8.
    COMPUTE AT-DISC ROUNDED=AT-TOTAL * V-DISC / 100.
    ADD 1 TO IXT DISPLAY "DISCOUNT:" LINE IXT AT-DISC COLUMN 11 CONVERSION
      V-DISC COLUMN 25 CONVERSION "%".
    ACCEPT AT-DISC LINE IXT COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY AT-DISC LINE IXT COLUMN 11 CONVERSION ERASE END LINE.
    COMPUTE AT-NET=AT-GROSS - AT-DISC.
    ADD 1 TO IXT DISPLAY "     NET:" LINE IXT BOLD.
    DISPLAY AT-NET LINE IXT COLUMN 11 CONVERSION BOLD.
IG8. MOVE SYS-DATE TO AT-DATE AT-EFF-DATE.
    MOVE "'CAN' TO CANCEL THIS INVOICE: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" ADD 1 TO IXT DISPLAY "** CANCELED **" LINE IXT REVERSED GO IG88.

    PERFORM RDLK-VENDOR IF AT-EXCH=0 MOVE 1 TO IG-IXE ELSE MOVE 2 TO IG-IXE.
    ADD AT-TOTAL TO V-PUR-YTD(IG-IXE) ROUNDED MOVE AT-INV-DATE TO V-INV-DATE.
    ADD AT-GROSS TO V-GROSS(IG-IXE) ADD AT-NET TO V-NET(IG-IXE).
    ADD AT-DISC TO V-DISC-YTD(IG-IXE) ROUNDED.
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR.

    MOVE 0 TO IG-IXR.
IG81. ADD 1 TO IG-IXR IF IG-IXR>IG-NORD GO IG86.
    MOVE IG-ORD(IG-IXR) TO OK-NO READ PURORD REGARDLESS. MOVE AT-INV TO OK-INV.
    IF IG-IXR=1 MOVE AT-DISC TO OK-DISC MOVE AT-FREIGHT TO OK-FREIGHT
      MOVE AT-FRPAY TO OK-FRPAY MOVE AT-GST TO OK-GST MOVE AT-PST TO OK-PST
     ELSE MOVE 0 TO OK-DISC OK-FREIGHT OK-FRPAY OK-GST OK-PST.
    MOVE AT-INV-DATE TO OK-INV-DATE-LAST MOVE AT-DUE-DATE TO OK-DUE-DATE-LAST.
    MOVE AT-EFF-DATE TO OK-EFF-DATE-LAST.
    REWRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    MOVE LOW-VALUES TO YOK-RECORD MOVE OK-NO TO YOK-ORD MOVE 0 TO YOK-SEQ.
    MOVE 0 TO YOK-PR MOVE USN-USER TO YOK-USER MOVE OK-RECORD TO YOK-DATA.
IG813. WRITE YOK-RECORD ALLOWING NO INVALID ADD 1 TO YOK-SEQ GO IG813. UNLOCK TMPURORD.
* note 100

    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IG84.
IG83. READ PURLIN NEXT REGARDLESS END GO IG84. IF LK-ORD NOT=OK-NO GO IG84.
    IF LK-QTY-LAST=0 GO IG83. MOVE SYS-DATE TO LK-DATE-LAST.
    ADD LK-QTY-LAST TO LK-QTY-REC ROUNDED ADD LK-TOTAL-LAST TO LK-TOTAL-REC.
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    MOVE LK-ORD TO YLK-ORD MOVE YOK-SEQ TO YLK-SEQ MOVE LK-LINE TO YLK-LINE.
    MOVE LK-RECORD TO YLK-DATA WRITE YLK-RECORD ALLOWING NO UNLOCK TMPURLIN.

    IF OK-BLANKET-ORD=" " GO IG836.
    MOVE LK-KEY TO IG-LK-KEY MOVE LK-PART TO IG-LK-PART.
    MOVE LK-QTY-LAST TO IG-LK-QTY-LAST MOVE LK-TOTAL-LAST TO IG-LK-TOTAL-LAST.
    MOVE OK-BLANKET-ORD TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IG834.
IG833. READ PURLIN NEXT REGARDLESS END GO IG834. IF LK-ORD NOT=OK-BLANKET-ORD GO IG834.
    IF LK-PART NOT=IG-LK-PART GO IG833.
    ADD IG-LK-QTY-LAST TO LK-QTY-REC ROUNDED ADD IG-LK-TOTAL-LAST TO LK-TOTAL-REC.
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
IG834. MOVE IG-LK-KEY TO LK-KEY START PURLIN REGARDLESS READ PURLIN NEXT REGARDLESS.

IG836. MOVE LK-CAT TO PH-CAT PERFORM PART-TYPE MOVE LK-MODE TO PH-MODE.
* note 106.3
    MOVE LK-QTY-LAST TO A-T1 PERFORM MUL-MQTY COMPUTE IG-QTY ROUNDED=A-T1.
    MOVE 0 TO WD1 IF AT-EXCH NOT=0 COMPUTE WD1 ROUNDED=AT-TOTAL * (AT-EXCH - 1).
    COMPUTE IG-AMT ROUNDED=LK-TOTAL-LAST + (AT-FREIGHT + WD1) * LK-TOTAL-LAST / AT-TOTAL
      SIZE ERROR MOVE 0 TO IG-AMT.
    MOVE IG-AMT TO A-T1 PERFORM MUL-PAMT COMPUTE IG-LDAMT ROUNDED=A-T1.
    COMPUTE IG-LDCOST ROUNDED=IG-LDAMT / IG-QTY SIZE ERROR MOVE 0 TO IG-LDCOST.

    INITIALIZE PH-REC MOVE LK-PART TO PH-NO READ PART REGARDLESS INVALID GO IG838.
    IF LK-BLANKET=0 SUBTRACT IG-QTY FROM PH-ORDER.
    ADD IG-QTY TO PH-HAND IF PART-MAT ADD IG-QTY TO PH-PROC-HAND(1).
    ADD IG-QTY TO PH-MTD PH-YTD ADD IG-AMT TO PH-AMTD PH-AYTD.
    IF IG-QTY>0 COMPUTE PH-LDCOST ROUNDED=
      (PH-LDCOST * (PH-HAND - IG-QTY) + IG-LDAMT) / PH-HAND SIZE ERROR CONTINUE.
    MOVE SYS-DATE TO PH-DATE REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
IG838. PERFORM INIT-PU MOVE AT-INV-DATE TO PU-INV-DATE.
    MOVE LK-TOTAL-LAST TO PU-AMT MOVE IG-QTY TO PU-QTY.
    MOVE IG-LDCOST TO PU-LDCOST PU-ALDCOST.
    IF PH-LDCOST NOT=0 MOVE PH-LDCOST TO PU-ALDCOST.
    WRITE PU-RECORD ALLOWING NO UNLOCK PURHIST GO IG83.
IG84. GO IG81.

IG86. PERFORM SET-ATKD WRITE AT-RECORD ALLOWING NO UNLOCK APTR.
    MOVE V-NO TO GRT-VEN PERFORM GRT-PROC.

    DISPLAY " " LINE 4 ERASE END SCREEN "BIN UPDATE " LINE 5 REVERSED.
    IF INUT AND V-NO=9400 DISPLAY "(ISS) " COLUMN 12 REVERSED PERFORM IG-ISS
      ELSE DISPLAY "(REC) " COLUMN 12 REVERSED PERFORM IG-REC.
    GO IG3.
IG88. PERFORM DSP-CONT GO IG3.
IG9. CLOSE AUDIT TMPURORD TMPURLIN MNTORD MNTLIN GO MN9.

IG-REC. PERFORM IG-R1 THRU IG-R9.
IG-R1. DISPLAY "PART NO."     LINE 6 BOLD ERASE END SCREEN.
    DISPLAY    "____________" LINE 7.
    DISPLAY "PRESS PF4 TO END THIS INVOICE" LINE 24 BOLD.
    ACCEPT IG-PART LINE 7 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO IG-R9.
    MOVE IG-PART TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO IG-R1.
    PERFORM PART-TYPE.
    IF PART-MAT
      DISPLAY "TO BIN    P.O. NO.    COILS   COIL WEIGHT   HEAT"       LINE 6 COLUMN 15 BOLD
      DISPLAY "______    __________   ___       _____      __________" LINE 7 COLUMN 15
       ELSE
      DISPLAY "TO BIN    P.O. NO.      QUANTITY" LINE 6 COLUMN 15 BOLD
      DISPLAY "______    __________   _________" LINE 7 COLUMN 15.
    MOVE IG-PART TO SHB-PART MOVE 9 TO IXT PERFORM SHOW-PBINS.
    INITIALIZE IG-PCODE IG-BQTY IG-COILS IG-CWEIGHT IG-PO IG-FBIN IG-TBIN IG-HEAT.
IG-R41. ACCEPT IG-TBIN LINE 7 COLUMN 15 DEFAULT " "
         UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO IG-R1.
    MOVE IG-TBIN TO BH-NO.
    IF INUT READ PURBIN REGARDLESS INVALID PERFORM ADD-PBIN IF A-S1=0 GO IG-R41 END-IF
      ELSE READ PURBIN REGARDLESS INVALID PERFORM IG-E2 GO IG-R41.
    IF BH-PART>" " AND NOT=IG-PART PERFORM IG-E4 IF XA2 NOT="OK" GO IG-R41.
    ACCEPT IG-PO LINE 7 COLUMN 25 DEFAULT " "
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO IG-R1.
    IF PART-MAT GO IG-R44.
IG-R43. ACCEPT IG-BQTY LINE 7 COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF IG-BQTY=0 PERFORM DSP-ERR2 GO IG-R43. GO IG-R48.
IG-R44. IF BH-PART>" " AND BH-PCODE NOT=0 PERFORM IG-E8 IF XA2 NOT="OK" GO IG-R41.
IG-R45. ACCEPT IG-COILS LINE 7 COLUMN 38 DEFAULT ZERO
         UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO IG-R1.
    IF IG-COILS=0 PERFORM DSP-ERR2 GO IG-R45.
IG-R47. ACCEPT IG-CWEIGHT LINE 7 COLUMN 48 DEFAULT ZERO
         UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO IG-R1.
    IF IG-CWEIGHT=0 PERFORM DSP-ERR2 GO IG-R47. COMPUTE IG-BQTY=IG-COILS * IG-CWEIGHT.
    ACCEPT IG-HEAT LINE 7 COLUMN 59 DEFAULT " "
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO IG-R1.
    IF IG-HEAT>" " AND BH-HEAT>" " AND NOT=IG-HEAT
      PERFORM IG-E7 IF XA2 NOT="OK" GO IG-R41.
IG-R48. PERFORM IG-CAN IF XA3="CAN" GO IG-R6. PERFORM RDLK-PURBIN.
    MOVE SYS-DATE TO BH-DATE MOVE IG-PART TO BH-PART MOVE IG-PO TO BH-PO.
    ADD IG-BQTY TO BH-QTY.
    IF PART-MAT MOVE 0 TO BH-PCODE ADD IG-COILS TO BH-COILS
      IF IG-HEAT>" " MOVE IG-HEAT TO BH-HEAT.
    REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    MOVE "REC" TO IG-TRANS PERFORM IG-AUDIT PERFORM IG-TR.
IG-R6. GO IG-R1.
IG-R9. EXIT.

IG-ISS. PERFORM IG-I1 THRU IG-I9.
IG-I1. DISPLAY "PART NO.        FROM BIN" LINE 6 BOLD ERASE END SCREEN.
    DISPLAY    "____________    ______" LINE 7.
    DISPLAY "PRESS PF4 TO END THIS INVOICE" LINE 24 BOLD.
    ACCEPT IG-PART LINE 7 COLUMN 1 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO IG-I9.
    MOVE IG-PART TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO IG-I1.
    PERFORM PART-TYPE IF NOT PART-MAT PERFORM IG-E9 GO IG-I1.
    MOVE IG-PART TO SHB-PART MOVE 9 TO IXT PERFORM SHOW-PBINS.
    INITIALIZE IG-PCODE IG-BQTY IG-COILS IG-CWEIGHT IG-PO IG-FBIN IG-TBIN IG-HEAT.
IG-I41. ACCEPT IG-FBIN LINE 7 COLUMN 17 DEFAULT " "
         UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO IG-I1.
    MOVE IG-FBIN TO BH-NO READ PURBIN REGARDLESS INVALID PERFORM IG-E3 GO IG-I41.
    IF BH-PART NOT=IG-PART PERFORM IG-E5 IF XA2 NOT="OK" GO IG-I41.

    DISPLAY "PROCESS   COILS" LINE 6 COLUMN 30 BOLD ERASE END LINE.
*               .      ....
    DISPLAY BH-PCODE LINE 7 COLUMN 33 CONVERSION BH-COILS COLUMN 40 CONVERSION.
    DISPLAY "COILS  TOTAL WEIGHT   M.O."  LINE 6 COLUMN 51 BOLD.
    DISPLAY " ____   __________   ______" LINE 7 COLUMN 51.
IG-I43. ACCEPT IG-COILS LINE 7 COLUMN 52 DEFAULT ZERO
         UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO IG-I1.
    IF IG-COILS=0 PERFORM DSP-ERR2 GO IG-I43.
    IF IG-COILS>BH-COILS PERFORM IG-E1 IF XA2 NOT="OK" GO IG-I43.
IG-I45. COMPUTE IG-BQTY ROUNDED=BH-QTY * IG-COILS / BH-COILS SIZE ERROR MOVE 0 TO IG-BQTY.
    DISPLAY IG-BQTY LINE 7 COLUMN 59 CONVERSION.
    ACCEPT IG-BQTY LINE 7 COLUMN 59 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO IG-I1.
    DISPLAY IG-BQTY LINE 7 COLUMN 59 CONVERSION.
    COMPUTE IG-CWEIGHT ROUNDED=IG-BQTY / IG-COILS.
    MOVE IG-CWEIGHT TO A-N1 PERFORM CHK-COIL-WEIGHT IF A-S1=1 GO IG-I45.
    IF IG-BQTY>BH-QTY PERFORM IG-E6 IF XA2 NOT="OK" GO IG-I1.
IG-I47. ACCEPT R-NO LINE 7 COLUMN 72 DEFAULT ZERO
         UNDERLINED PROTECTED CONVERSION KEY CKEY IF KPF3 GO IG-I1.
    PERFORM RDF-PRODORD IF A-S1=1 GO IG-I47.
    MOVE BH-PCODE TO IG-PCODE IF IG-PCODE>8 MOVE 0 TO IG-PCODE.

    PERFORM IG-CAN IF XA3="CAN" GO IG-I6.
    SUBTRACT IG-BQTY FROM BH-QTY SUBTRACT IG-COILS FROM BH-COILS.
    MOVE 1 TO R-ALLOC REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    PERFORM CHK-PBIN-EMPTY REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    SUBTRACT IG-BQTY FROM PH-HAND PH-PROC-HAND(IG-PCODE + 1).
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    MOVE "ISS" TO IG-TRANS PERFORM IG-AUDIT PERFORM IG-TR.
IG-I6. GO IG-I1.
IG-I9. EXIT.

IG-ERS. DISPLAY " " LINE 15 ERASE LINE " " LINE 18 ERASE LINE.
IG-CAN. MOVE "'CAN' TO CANCEL THIS LINE: ___" TO TMSG PERFORM DSP-PROMPT.
IG-E1. MOVE "INSUFFICIENT COILS IN 'FROM BIN'" TO ERR-MESG PERFORM DSP-OK.
IG-E2. MOVE "INVALID 'TO BIN'" TO ERR-MESG PERFORM DSP-ERR.
IG-E3. MOVE "INVALID 'FROM BIN'" TO ERR-MESG PERFORM DSP-ERR.
IG-E4. MOVE "'TO BIN' PART MISMATCH" TO ERR-MESG PERFORM DSP-OK.
IG-E5. MOVE "'FROM BIN' PART MISMATCH" TO ERR-MESG PERFORM DSP-OK.
IG-E6. MOVE "INSUFFICIENT QUANTITY IN 'FROM BIN'" TO ERR-MESG PERFORM DSP-OK.
IG-E7. MOVE "'TO BIN' HEAT NO. MISMATCH" TO ERR-MESG PERFORM DSP-OK.
IG-E8. MOVE "'TO BIN' PROCESS CODE IS NOT 0" TO ERR-MESG PERFORM DSP-OK.
IG-E9. MOVE "PART MUST BE MATERIAL" TO ERR-MESG PERFORM DSP-OK.
* note 185.2
IG-AUDIT. MOVE IG-TRANS TO IE51 MOVE IG-PART TO IE52 MOVE IG-FBIN TO IE53.
    MOVE IG-TBIN TO IE54 MOVE IG-BQTY TO IE55 MOVE IG-PO TO IE55A.
    MOVE 0 TO IE52A IF PART-MAT MOVE 1 TO IE52A MOVE IG-PCODE TO IE56
      MOVE IG-COILS TO IE57 MOVE IG-CWEIGHT TO IE58 MOVE IG-HEAT TO IE59.
    MOVE TD-INP-R5 TO AU-DATA MOVE 5 TO AU-K PERFORM ADD-AUD.
IG-TR. MOVE LOW-VALUES TO PT-RECORD INITIALIZE PT-REC MOVE IG-TRANS TO PT-TRANS.
    MOVE IG-PART TO PT-PART MOVE SYS-DATE TO PT-DATE ACCEPT PT-TIME FROM TIME.
    MOVE USN-USER TO PT-USER.
    MOVE IG-FBIN TO PT-FBIN MOVE IG-TBIN TO PT-TBIN MOVE IG-BQTY TO PT-QTY.
    MOVE IG-PO TO PT-PO MOVE IG-PCODE TO PT-PCODE MOVE IG-COILS TO PT-COILS.
    MOVE IG-CWEIGHT TO PT-CWEIGHT MOVE IG-HEAT TO PT-HEAT.
    WRITE PT-RECORD ALLOWING NO UNLOCK PARTRANS.

* P-24 DELETE CHEQUES
DC1. PERFORM RD355 PERFORM WRT PERFORM OPEN-AUDIT.
    MOVE 3 TO IXT MOVE 9 TO IXU PERFORM AX-US-S.
DC3. DISPLAY " ______    ___________" LINE 6.
    ACCEPT AH-NO LINE 6 COLUMN 2 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AH-NO=999999 GO DC9.
    MOVE WS-DIV TO AH-DIV MOVE USD-IND TO AH-US.
    READ APCHQ REGARDLESS INVALID PERFORM DSP-ERR22 GO DC8.
    ACCEPT DC-AMT LINE 6 COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DC-AMT NOT=AH-NET PERFORM DSP-ERR40 GO DC8.
    DELETE APCHQ MOVE AH-VEN TO A-N1 PERFORM RD-VEN.
    MOVE AH-NO TO IE91 MOVE AH-NET TO IE92 MOVE AH-US TO IE93.
    MOVE AH-CHQDATE TO IE94 MOVE V-NAME TO IE95.
    MOVE TD-INP-R9 TO AU-DATA MOVE 9 TO AU-K PERFORM ADD-AUD.
DC8. GO DC3.
DC9. CLOSE AUDIT GO MN9.

* P-25 G/L CHART OF ACCOUNTS MAINTENANCE
GM1.
GM3. PERFORM RD135 PERFORM WRT MOVE "TYPE 'E' TO END: _" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="E" GO GM9. MOVE LOW-VALUES TO G-RECORD INITIALIZE G-REC.
    MOVE 4 TO IXT MOVE 2 TO IXU MOVE 0 TO WS-GL PERFORM AX-GL.
    IF WS-GL=0 PERFORM DSP-ERR16 GO GM3.
    MOVE WS-DIV TO G-DIV MOVE WS-GL TO G-GL MOVE 0 TO WS1.
    READ GLDIST REGARDLESS INVALID MOVE 1 TO WS1 WRITE G-RECORD ALLOWING NO UNLOCK GLDIST.
    IF WS1=0 DISPLAY "ACCOUNT FOUND IN CHART OF ACCOUNTS" LINE 24 BOLD
      ELSE DISPLAY "ACCOUNT ADDED TO CHART OF ACCOUNTS" LINE 24 BOLD.
    DISPLAY G-DESC LINE IXT COLUMN 27.
    MOVE 56 TO IXU MOVE G-NGL TO WS-NGL PERFORM DSP-NGL.
    ACCEPT G-DESC LINE IXT COLUMN 27 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 56 TO IXU MOVE G-NGL TO WS-NGL PERFORM AX-NGL MOVE WS-NGL TO G-NGL.
    MOVE "'DEL' TO DELETE THIS G/L ACCOUNT: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="DEL" DELETE GLDIST ELSE REWRITE G-RECORD ALLOWING NO UNLOCK GLDIST.
    GO GM3.
GM9. GO MN9.

* P-26 CHANGE DUE DATE
CG1.
CG3. PERFORM RD356 PERFORM WRT MOVE 4 TO IXT.
    ACCEPT AT-VEN LINE IXT COLUMN 2 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AT-VEN=9999 GO CG9. MOVE WS-DIV TO AT-DIV MOVE 0 TO AT-TYPE.
    ACCEPT AT-INV LINE IXT COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING.
    READ APTR REGARDLESS INVALID MOVE "TRANSACTION NOT FOUND"
      TO ERR-MESG PERFORM DSP-ERR GO CG3.
    MOVE AT-DUE-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN 30.
    MOVE 42 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO AT-DUE-DATE.
    REWRITE AT-RECORD ALLOWING NO UNLOCK APTR GO CG3.
CG9. GO MN9.

* P-27 SHOW PURCHASE ORDERS BY VENDOR
OV1. PERFORM RD55 MOVE 0 TO V-NO MOVE 1 TO OV-KALL MOVE 3 TO IXT.
OV3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
OV33. DISPLAY "NEXT VENDOR NO. ____         INCLUDE CLOSED ORDERS ? _" LINE IXT.
    ACCEPT IA30 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA30=9999 GO OV9.
    MOVE 54 TO IXU MOVE OV-KALL TO A-S1 PERFORM AX-NY MOVE A-S1 TO OV-KALL.
    IF IA30=0 IF V-NO=0 GO OV33 ELSE GO OV4. MOVE WS-DIV TO V-DIV MOVE IA30 TO V-NO.
    START VENDOR KEY>=V-KEY REGARDLESS INVALID PERFORM DSP-ERR17 GO OV33.
    READ VENDOR NEXT REGARDLESS MOVE V-NO TO OK-VENDOR MOVE " " TO OK-ZNO MOVE 0 TO INQ-IND.
OV4. PERFORM RD55 MOVE V-NO TO TF524(1) MOVE V-NAME TO TF525(1).
    PERFORM DSP-QWAIT.
    MOVE 4 TO IXT IF INQ-IND=0 START PURORD KEY>=OK-KV REGARDLESS INVALID GO OV8.
OV5. READ PURORD NEXT REGARDLESS END GO OV8. IF OK-VENDOR NOT=V-NO GO OV8.
    IF OV-KALL=1 OR OK-BLANKET=1 GO OV6. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO OV54.
OV53. READ PURLIN NEXT REGARDLESS END GO OV54. IF LK-ORD NOT=OK-NO GO OV54.
    IF LK-QTY>0 AND>LK-QTY-REC GO OV6. GO OV53.
OV54. GO OV5.
OV6. PERFORM CLR-LN MOVE OK-NO TO TF526(IXT).
    MOVE OK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF527(IXT).
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TF528(IXT).
    IF OK-INV-DATE-LAST>0
      MOVE OK-INV-DATE-LAST TO D-DATE PERFORM D-NM MOVE D-DT TO TF529(IXT).
    IF OK-DUE-DATE-LAST>0
      MOVE OK-DUE-DATE-LAST TO D-DATE PERFORM D-NM MOVE D-DT TO TF530(IXT).
    MOVE OK-INV TO TF531(IXT) MOVE OK-BLANKET-ORD TO TF532(IXT).
    ADD 1 TO IXT IF IXT<22 GO OV5.
    MOVE "*** MORE ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO OV89.
OV8. MOVE "*** END ***" TO TLN(IXT) PERFORM DSP-ERS.
    READ VENDOR NEXT REGARDLESS END MOVE 0 TO V-NO GO OV89.
    MOVE V-NO TO OK-VENDOR MOVE " " TO OK-ZNO MOVE 0 TO INQ-IND.
OV89. GO OV3.
OV9. GO MN9.

* P-28 VENDOR INFORMATION
VI1. PERFORM RD136 PERFORM WRT.
VI3. ACCEPT IA11 LINE 23 COLUMN 74 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA11=9999 GO VI9. IF NOT KPF3 GO VI4.
    MOVE WS-DIV TO V-DIV READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO VI3.
    MOVE 1 TO IX1 MOVE 5 TO IXT.
VI33. ACCEPT V-CONTACT(IX1) LINE IXT COLUMN 39 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE V-CONTACT(IX1) TO WA1 PERFORM RDLK-VENDOR MOVE WA1 TO V-CONTACT(IX1).
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR.
    ADD 1 TO IX1 IXT IF IX1<=4 GO VI33. GO VI3.
VI4. MOVE WS-DIV TO V-DIV MOVE IA11 TO V-NO.
    READ VENDOR REGARDLESS INVALID PERFORM DSP-ERR17 GO VI3.
    PERFORM RD136 MOVE V-NO TO TF436(1) MOVE V-NAME TO TF437(1).
    MOVE V-ADD1 TO TF437(2) MOVE V-ADD2 TO TF438(3) MOVE V-POST TO TF439(3).
    MOVE 1 TO IX1 MOVE 5 TO IXT PERFORM UNTIL IX1>4
      MOVE V-CONTACT(IX1) TO TF435(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    MOVE V-CONTRA TO TF440(9) IF V-GST-IND<=1 MOVE LIT-YN(V-GST-IND + 1:1) TO TF441(9).
    MOVE V-FREIGHT-STD TO TF450(9) MOVE V-FREIGHT-RATE TO TF451(9).
    IF V-FRPAY<=1 MOVE LIT-NY(V-FRPAY + 1:1) TO TF452(10).
    MOVE V-DISC TO TF442(11) MOVE V-PAY TO TF443(11) MOVE V-CLASS TO TF444(11).
    MOVE V-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF445(11).
    MOVE V-GROSS(1) TO TF446(14) MOVE V-GROSS(2) TO TF448(14).
    MOVE V-NET(1) TO TF446(15) MOVE V-NET(2) TO TF448(15).
    MOVE V-DISC-YTD(1) TO TF447(16) MOVE V-DISC-YTD(2) TO TF449(16).
    MOVE V-PUR-YTD(1) TO TF447(18) MOVE V-PUR-YTD(2) TO TF449(18).
    MOVE V-PUR-LAST(1) TO TF447(19) MOVE V-PUR-LAST(2) TO TF449(19).
    MOVE V-PUR-2(1) TO TF447(20) MOVE V-PUR-2(2) TO TF449(20).
    PERFORM WRT GO VI3.
VI9. GO MN9.

* P-29 SHOW TRANSACTIONS BY VENDOR
VT1. PERFORM RD137 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MN9.
    IF Y1 PERFORM RD137A ELSE PERFORM RD137B. MOVE 0 TO V-NO MOVE 3 TO IXT.
VT3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
VT33. DISPLAY "NEXT VENDOR NO. ____" LINE IXT.
    ACCEPT IA26 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA26=9999 GO VT9.
    IF IA26=0 IF V-NO=0 GO VT33 ELSE GO VT4. MOVE WS-DIV TO V-DIV MOVE IA26 TO V-NO.
    START VENDOR KEY>=V-KEY REGARDLESS INVALID PERFORM DSP-ERR17 GO VT33.
    READ VENDOR NEXT REGARDLESS MOVE LOW-VALUES TO VT-TOTALS.
    INITIALIZE AT-KD MOVE WS-DIV TO AT-KDIV MOVE V-NO TO AT-KVEN MOVE 0 TO INQ-IND.
VT4. IF Y1 PERFORM RD137A MOVE V-NO TO TF462(1) MOVE V-NAME TO TF463(1)
      ELSE PERFORM RD137B MOVE V-NO TO TF487(1) MOVE V-NAME TO TF488(1).
    PERFORM DSP-QWAIT.
    MOVE 4 TO IXT IF INQ-IND=0 START APTR KEY>=AT-KD REGARDLESS INVALID GO VT8.
VT5. READ APTR NEXT REGARDLESS END GO VT8. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO VT8.
    IF Y1 AND AT-IND=1 OR Y2 AND AT-IND=0 GO VT5. PERFORM CLR-LN.
    IF Y1 MOVE AT-INV TO TF453(IXT) MOVE AT-ORD TO TF454(IXT)
      MOVE AT-EFF-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF455(IXT)
      MOVE AT-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF456(IXT)
      MOVE AT-DUE-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF457(IXT)
      MOVE AT-GROSS TO TF458(IXT) MOVE AT-NET TO TF459(IXT)
      IF AT-EXCH NOT=0 MOVE "US" TO TF460(IXT) END-IF
     ELSE MOVE AT-INV TO TF489(IXT) MOVE AT-CHQNO TO TF490(IXT)
      MOVE AT-CHQDATE TO TF491(IXT) MOVE AT-GROSS TO TF494(IXT)
      MOVE AT-NET TO TF495(IXT) IF AT-EXCH NOT=0 MOVE "US" TO TF496(IXT).
    IF AT-EXCH=0 ADD AT-GROSS TO VT-TOT(1,1) ADD AT-NET TO VT-TOT(1,2)
      ELSE ADD AT-GROSS TO VT-TOT(2,1) ADD AT-NET TO VT-TOT(2,2).
    ADD 1 TO IXT IF IXT<21 GO VT5.
    MOVE "*** MORE ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO VT89.
VT8. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      PERFORM CLR-LN MOVE "!" TO TF464(IXT)
      IF IX1=1 MOVE "** TOTAL" TO TF465(IXT) END-IF
      MOVE VT-TOT(IX1,1) TO TF466(IXT) MOVE VT-TOT(IX1,2) TO TF467(IXT)
      IF IX1=2 MOVE "US" TO TF468(IXT) END-IF
      MOVE "]" TO TF469(IXT) ADD 1 TO IXT END-PERFORM.
    MOVE "*** END ***" TO TLN(IXT) PERFORM DSP-ERS.
    READ VENDOR NEXT REGARDLESS END MOVE 0 TO V-NO GO VT89.
    MOVE LOW-VALUES TO VT-TOTALS.
    INITIALIZE AT-KD MOVE WS-DIV TO AT-KDIV MOVE V-NO TO AT-KVEN MOVE 0 TO INQ-IND.
VT89. GO VT3.
VT9. GO MN9.

* P-30 SHOW PART PURCHASE HISTORY
PQ1. PERFORM RD130 MOVE " " TO PH-NO MOVE 3 TO IXT.
PQ3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
PQ33. DISPLAY "NEXT PART NO. ____________" LINE IXT.
    ACCEPT IA27 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA27=ALL "9" GO PQ9.
    IF IA27=" " IF PH-NO=" " GO PQ33 ELSE GO PQ4. MOVE IA27 TO PH-NO.
    START PART KEY>=PH-KEY REGARDLESS INVALID PERFORM DSP-ERR3 GO PQ33.
    READ PART NEXT REGARDLESS MOVE 1 TO PQ-KFIN.
* note 122.2
    IF PH-NO NOT=IA27 MOVE 0 TO PQ-KFIN MOVE IA27 TO PH-NO
      START PART KEY>=PH-KEY REGARDLESS.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PH-NO TO PU-PART MOVE 0 TO INQ-IND.
PQ4. PERFORM RD130 MOVE PH-NO TO TF470(1).
    IF PQ-KFIN=1 MOVE PH-DESC1 TO TF471(1) MOVE PH-DESC2 TO TF471(2)
      ELSE MOVE "*** NO RECORD FOR THIS PART ***" TO TF471(1).
    MOVE 4 TO IXT IF INQ-IND=0 START PURHIST KEY>=PU-KEY REGARDLESS INVALID GO PQ8.
PQ5. READ PURHIST NEXT REGARDLESS END GO PQ8.
    IF NOT(PU-DIV=WS-DIV AND PU-PART=PH-NO) GO PQ8. PERFORM CLR-LN.
    COMPUTE D-DATE=999999 - PU-ZDATE PERFORM D-NM MOVE D-DT TO TF472(IXT).
    MOVE PU-ORD TO TF473(IXT).
    MOVE PU-VENDOR TO TF474(IXT) A-N1 PERFORM RD-VEN MOVE V-NAME TO TF475(IXT).
    MOVE PU-QTY TO TF476(IXT) MOVE PU-LDCOST TO TF477(IXT).
    ADD 1 TO IXT IF IXT<22 GO PQ5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO PQ89.
PQ8. MOVE "*** END ***" TO TLN(IXT).
    READ PART NEXT REGARDLESS END MOVE " " TO PH-NO GO PQ89. MOVE 1 TO PQ-KFIN.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PH-NO TO PU-PART MOVE 0 TO INQ-IND.
PQ89. GO PQ3.
PQ9. GO MN9.

* P-31 INVOICE FILE MAINTENANCE
IM1.
IM3. PERFORM RD138 PERFORM WRT MOVE WS-DIV TO AT-DIV.
    ACCEPT AT-VEN LINE 3 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AT-VEN=9999 GO IM9.
    MOVE WS-DIV TO V-DIV MOVE AT-VEN TO V-NO.
    READ VENDOR REGARDLESS INVALID MOVE "*** NO VENDOR RECORD ***" TO V-NAME.
    DISPLAY "VENDOR: " LINE 5 COLUMN 10 V-NAME.
    DISPLAY "FOR DIRECT PAY INVOICE, ENTER CHEQUE NO." LINE 24 BOLD.
    ACCEPT AT-INV LINE 3 COLUMN 31 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    MOVE 3 TO IXT MOVE 68 TO IXU MOVE 0 TO A-S1 PERFORM AX-NY MOVE A-S1 TO AT-TYPE.
    READ APTR REGARDLESS INVALID MOVE "INVOICE NOT FOUND" TO ERR-MESG
      PERFORM DSP-ERR GO IM3.
    DISPLAY "NET INVOICE AMOUNT:" LINE 6 COLUMN 10 AT-NET CONVERSION.
    IF AT-IND=0 MOVE "'PAY' TO MARK THIS INVOICE AS 'PAID': ___" TO TMSG
      ELSE DISPLAY "THIS INVOICE IS MARKED AS 'PAID'" LINE 7 COLUMN 10 BOLD
        MOVE "'RES' TO RESTORE THIS INVOICE AS 'NOT PAID': ___" TO TMSG.
    PERFORM DSP-PROMPT.
    IF AT-IND=0 AND XA3="PAY" MOVE 1 TO AT-IND REWRITE AT-RECORD ALLOWING NO UNLOCK APTR.
    IF AT-IND=1 AND XA3="RES" MOVE 0 TO AT-IND REWRITE AT-RECORD ALLOWING NO UNLOCK APTR.
    GO IM3.
IM9. GO MN9.

* P-32 SHOW VENDOR NAMES
VN1. PERFORM WRT132 PERFORM RD141 PERFORM WRT MOVE " " TO VN-NAME.
VN3. DISPLAY "ENTER THE BEGINNING OF THE VENDOR NAME" LINE 24 BOLD.
    ACCEPT VN-NAME LINE 3 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR VN-NAME(1:10)=ALL "9" GO VN9.
    MOVE 5 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    MOVE VN-NAME TO A-A1 PERFORM STR-LTH MOVE A-N1 TO VN-LTH.
    MOVE 1 TO IXCOL MOVE 0 TO VN-KFIN.
    MOVE VN-NAME TO V-KN START VENDOR KEY>=V-KN REGARDLESS INVALID GO VN8.
VN5. READ VENDOR NEXT REGARDLESS END GO VN8. IF V-NAME(1:VN-LTH) NOT=VN-NAME GO VN8.
    IF V-DIV NOT=WS-DIV GO VN5. COMPUTE IXU=(IXCOL - 1) * 46 + 1.
    MOVE 1 TO VN-KFIN DISPLAY V-NO LINE IXT COLUMN IXU V-NAME(1:32) COLUMN IXU PLUS 8.
    ADD 1 TO IXT IF IXT=24 MOVE 5 TO IXT ADD 1 TO IXCOL IF IXCOL>3 GO VN8. GO VN5.
VN8. IF VN-KFIN=0 DISPLAY "*** NO VENDORS FOUND" LINE IXT. GO VN3.
VN9. PERFORM WRT80 GO MN9.

* P-33 SHOW VENDOR PURCHASE HISTORY
PZ1. PERFORM RD246 MOVE 0 TO V-NO MOVE 3 TO IXT.
PZ3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
PZ33. DISPLAY "NEXT VENDOR NO. ____" LINE IXT.
    ACCEPT IA37 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA37=9999 GO PZ9.
    IF IA37=0 IF V-NO=0 GO PZ33 ELSE GO PZ4. MOVE WS-DIV TO V-DIV MOVE IA37 TO V-NO.
    START VENDOR KEY>=V-KEY REGARDLESS INVALID PERFORM DSP-ERR17
      MOVE 0 TO V-NO GO PZ33.
    READ VENDOR NEXT REGARDLESS MOVE 0 TO INQ-IND.
PZ4. PERFORM RD246 MOVE V-NO TO TF165(1) MOVE V-NAME TO TF166(1).
    MOVE 4 TO IXT.
    IF INQ-IND=0 INITIALIZE PU-KV MOVE WS-DIV TO PU-VDIV MOVE V-NO TO PU-VENDOR
      START PURHIST KEY>=PU-KV REGARDLESS INVALID GO PZ8.
PZ5. READ PURHIST NEXT REGARDLESS END GO PZ8.
    IF NOT(PU-VDIV=WS-DIV AND PU-VENDOR=V-NO) GO PZ8. PERFORM CLR-LN.
    COMPUTE D-DATE=999999 - PU-ZVDATE PERFORM D-NM MOVE D-DT TO TF167(IXT).
    MOVE PU-INV TO TF168(IXT) MOVE PU-ORD TO TF169(IXT) MOVE PU-PART TO TF170(IXT).
    MOVE PU-QTY TO TF171(IXT) MOVE PU-AMT TO TF172(IXT).
    ADD 1 TO IXT IF IXT<22 GO PZ5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO PZ89.
PZ8. MOVE "*** END ***" TO TLN(IXT).
    READ VENDOR NEXT REGARDLESS END MOVE 0 TO V-NO GO PZ89. MOVE 0 TO INQ-IND.
PZ89. GO PZ3.
PZ9. GO MN9.

* P-34 MARK MAILED CHEQUES
WG1. PERFORM RD357 PERFORM WRT MOVE 3 TO IXT MOVE 9 TO IXU PERFORM AX-US-S.
    MOVE 0 TO WG-KBM IF USD-IND=1 GO WG2. MOVE 1 TO WG-KBM.
    DISPLAY "START A NEW FILE ONLY IF THE PREVIOUS ONE WAS TRANSMITTED" LINE 24 BOLD.
    DISPLAY "START A NEW CHEQUE TRANSFER FILE ? ___" LINE 3 COLUMN 20 BOLD.
    ACCEPT XA3 COLUMN 55 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA3 NOT="YES" GO WG9.
    IF INUT MOVE "BNCHQIN" TO BNCHQ-NAME MOVE "INCHP" TO WG-NAM MOVE 6206268429321 TO WG-ACC
      ELSE MOVE "BNCHQIF" TO BNCHQ-NAME MOVE "IFCHP" TO WG-NAM MOVE 6206433908132 TO WG-ACC.
    OPEN OUTPUT BNCHQ MOVE 0 TO WG-CNUM WG-CTOT MOVE " " TO CZ-RECORD.
    MOVE "CMRA" TO CZ-H1 MOVE "ISS" TO CZ-H2.
    MOVE WG-NAM TO CZ-H3 MOVE WG-ACC TO CZ-H4.
    MOVE SYS-DATE TO D-DATE PERFORM D-NY MOVE D-DT TO CZ-H5 WRITE CZ-RECORD.
WG2.
WG3. DISPLAY " ______    ___________" LINE 6.
    ACCEPT AH-NO LINE 6 COLUMN 2 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AH-NO=999999 GO WG8.
    MOVE WS-DIV TO AH-DIV MOVE USD-IND TO AH-US.
    READ APCHQ REGARDLESS INVALID PERFORM DSP-ERR22 GO WG6.
    ACCEPT WG-AMT LINE 6 COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF WG-AMT NOT=AH-NET PERFORM DSP-ERR40 GO WG6.
    MOVE SYS-DATE TO AH-MDATE REWRITE AH-RECORD ALLOWING NO UNLOCK APCHQ.
    IF WG-KBM=0 GO WG6. MOVE AH-VEN TO A-N1 PERFORM RD-VEN.
    MOVE " " TO CZ-RECORD ADD 1 TO WG-CNUM ADD AH-NET TO WG-CTOT.
    MOVE WG-ACC TO CZ-D1 MOVE AH-NO TO CZ-D2 MOVE AH-NET TO CZ-D3.
    MOVE AH-CHNDATE TO D-DATE PERFORM D-NY MOVE D-DT TO CZ-D4.
    MOVE "I" TO CZ-D6 MOVE V-NAME TO CZ-D7(1) MOVE V-ADD1 TO CZ-D7(2).
    MOVE V-ADD2 TO CZ-D7(3) WRITE CZ-RECORD.
WG6. GO WG3.
WG8. IF WG-KBM=1 MOVE " " TO CZ-RECORD
      MOVE "CMTA" TO CZ-T1 MOVE WG-CNUM TO CZ-T2 MOVE WG-CTOT TO CZ-T3
      WRITE CZ-RECORD CLOSE BNCHQ.
WG9. GO MN9.

* P-35 CANCEL CHEQUES
DN1. PERFORM RD358 PERFORM WRT PERFORM OPEN-AUDIT.
    MOVE 3 TO IXT MOVE 9 TO IXU PERFORM AX-US-S.
DN3. DISPLAY " ______    ___________" LINE 6 ERASE END LINE.
    ACCEPT AH-NO LINE 6 COLUMN 2 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AH-NO=999999 GO DN9. MOVE 0 TO DN-KFIN.
    MOVE WS-DIV TO AH-DIV MOVE USD-IND TO AH-US.
    READ APCHQ REGARDLESS INVALID MOVE 1 TO DN-KFIN
      MOVE "INVALID CHEQUE NO." TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO DN8 END-IF.
    ACCEPT DN-NET LINE 6 COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DN-KFIN=1 MOVE DN-NET TO AH-NET AH-GROSS
      DISPLAY "VENDOR: ____" LINE 6 COLUMN 30 BOLD
      ACCEPT AH-VEN LINE 6 COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DN-NET NOT=AH-NET MOVE "WRONG AMOUNT" TO ERR-MESG PERFORM DSP-OK
      IF XA2="OK" MOVE DN-NET TO AH-NET AH-GROSS ELSE GO DN8.
    MOVE WS-DIV TO V-DIV MOVE AH-VEN TO V-NO READ VENDOR REGARDLESS
      INVALID PERFORM DSP-ERR17 GO DN8.
    MOVE 0 TO WD1 INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO DN44.
DN43. READ APTR NEXT REGARDLESS END GO DN44. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO DN44.
    IF AT-IND=1 AND AT-CHQNO=AH-NO ADD AT-NET TO WD1. GO DN43.
DN44. IF WD1 NOT=AH-NET MOVE "CHEQUE/TRANSACTIONS AMOUNT MISMATCH"
       TO ERR-MESG PERFORM DSP-ERR GO DN8.
    MOVE 1 TO GRT-KCAN PERFORM GRT-CHQ.
    PERFORM RDLK-VENDOR COMPUTE IX1=AH-US + 1.
    ADD AH-NET TO V-NET(IX1) ADD AH-GROSS TO V-GROSS(IX1).
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR.

    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO DN54.
DN53. READ APTR NEXT REGARDLESS END GO DN54. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO DN54.
    IF AT-IND=1 AND AT-CHQNO=AH-NO
      MOVE 0 TO AT-IND AT-CHQNO MOVE " " TO AT-CHQDATE
      REWRITE AT-RECORD ALLOWING NO UNLOCK APTR.
    GO DN53.
DN54. IF DN-KFIN=0 DELETE APCHQ.
    MOVE AH-NO TO IE101 MOVE AH-NET TO IE102 MOVE AH-US TO IE103.
    MOVE TD-INP-R10 TO AU-DATA MOVE 10 TO AU-K PERFORM ADD-AUD.
DN8. GO DN3.
DN9. CLOSE AUDIT GO MN9.

* P-36 SCRAP ENTRY
LZ1.
LZ3. PERFORM RD288 PERFORM WRT.
LZ33. ACCEPT R-NO LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO LZ9. PERFORM RDF-PRODORD IF A-S1=1 GO LZ33.
LZ35. ACCEPT M-NO LINE 4 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO LZ35.
    ACCEPT LZ-WEIGHT LINE 5 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE "'CAN' TO CANCEL THIS ENTRY: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="CAN" PERFORM LZ-A. GO LZ3.
LZ9. GO MN9.

* note 272.2
LZ-A. PERFORM LZ-A1 THRU LZ-A9.
LZ-A1. PERFORM INIT-J MOVE R-NO TO J-NO MOVE 89 TO J-MAC MOVE 2000 TO J-EMP.
    MOVE M-NO TO DSP-N31 STRING "MAC " DSP-N31 DELIMITED SIZE INTO J-NAME.
    MOVE R-PROD TO J-PROD MOVE LZ-WEIGHT TO J-WEIGHT J-AWEIGHT PERFORM SET-JKD.
LZ-A3. WRITE J-RECORD ALLOWING NO INVALID ADD 1 TO J-EMP GO LZ-A3. UNLOCK WORKSHEET.
LZ-A9. EXIT.

* SCRAP ENTRY (scanner function)
LW1. DISPLAY "SCRAP ENTRY         " LINE 1 REVERSED.
* note 22.3
LW3. DISPLAY " " LINE 2 ERASE END SCREEN.
    DISPLAY "M.O.:   " LINE 3 REVERSED " ______".
    DISPLAY "MACHINE:" LINE 4 REVERSED " ___".
    DISPLAY "WEIGHT: " LINE 5 REVERSED " ________".
LW33. ACCEPT R-NO LINE 3 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO LW9. IF R-NO<=9999 PERFORM DSQ-ERR11 GO LW33.
    READ PRODORD REGARDLESS INVALID PERFORM DSQ-ERR11 GO LW33.
LW35. ACCEPT M-NO LINE 4 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ MACHINE REGARDLESS INVALID PERFORM DSQ-ERR12 GO LW35.
    ACCEPT LZ-WEIGHT LINE 5 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY "'CAN' TO CANCEL:" LINE 14 " ___" LINE 15.
    ACCEPT XA3 LINE 15 COLUMN 2 DEFAULT " " UNDERLINED PROTECTED PERFORM DSQ-ERS.
    IF XA3 NOT="CAN" PERFORM LZ-A. GO LW3.
LW9. GO MW9.

* P-37 ROLLING MILL FILE MAINTENANCE
RE1.
RE3. PERFORM RD73 PERFORM WRT.
    MOVE LOW-VALUES TO ML-RECORD INITIALIZE ML-REC.
    ACCEPT ML-CYCLE LINE 3 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR ML-CYCLE="9999" GO RE9.
    ACCEPT ML-DIAM LINE 3 COLUMN 32 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF3 GO RE3. IF KPF4 GO RE9.
    READ MILL REGARDLESS INVALID MOVE 0 TO RE-KFIN GO RE4. MOVE 1 TO RE-KFIN.
    DISPLAY ML-STATUS LINE 11 COLUMN 10 CONVERSION.
    MOVE ML-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 13 COLUMN 8.
    DISPLAY ML-WEI-MAX LINE 13 COLUMN 36 CONVERSION.
    DISPLAY ML-WEI-REQ LINE 13 COLUMN 62 CONVERSION.
    MOVE 17 TO IXT MOVE 0 TO IX2 MOVE " " TO RE-LN1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>ML-GNUM
      ADD 1 TO IX2 IF IX2>5 ADD 1 TO IXT DISPLAY RE-LN1 LINE IXT
        MOVE " " TO RE-LN1 MOVE 1 TO IX2 END-IF
      MOVE ML-GRADE(IX1) TO RE-DF1(IX2) MOVE ":" TO RE-DF2(IX2)
      MOVE ML-WEI(IX1) TO RE-DF3(IX2) END-PERFORM.
    IF IX2>0 ADD 1 TO IXT DISPLAY RE-LN1 LINE IXT.
RE4.
RE5. PERFORM DSP-NEXT ACCEPT RE-OP LINE 3 COLUMN 54 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF RE-OP=0 GO RE3. IF RE-OP>4 PERFORM DSP-ERR1 GO RE5.
    IF RE-OP=1 AND RE-KFIN=1 MOVE "DUPLICATE CYCLE-DIAMETER" TO ERR-MESG
      PERFORM DSP-ERR GO RE3.
    IF (RE-OP=2 OR 3 OR 4) AND RE-KFIN=0 PERFORM DSP-ERR30 GO RE3.
    IF RE-OP=1 OR 2 GO RE6. IF RE-OP=3 DELETE MILL GO RE3.

* op=4
    DISPLAY "DAYS TO ADD: ___ " LINE 7 BOLD " (NEGATIVE TO SUBTRACT)".
    ACCEPT RE-DAYS LINE 7 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    DISPLAY RE-DAYS LINE 23 CONVERSION BOLD
      " DAYS WILL BE ADDED TO ALL CYCLE/DIAMETER COMBINATIONS" BOLD.
    DISPLAY "     FOLLOWING THE ONE DISPLAYED - 'OK' TO ACCEPT: __ " LINE 24 BOLD.
    ACCEPT XA2 COLUMN 52 DEFAULT " " UNDERLINED PROTECTED.
    DISPLAY " " LINE 23 ERASE END SCREEN.
    IF XA2 NOT="OK" OR RE-DAYS=0 GO RE3.
    START MILL KEY=ML-KEY REGARDLESS INVALID GO RE54.
RE53. READ MILL NEXT REGARDLESS END GO RE54.
    ADD RE-DAYS TO ML-DATE COMPUTE ML-ZDATE=999999 - ML-DATE.
    REWRITE ML-RECORD ALLOWING NO UNLOCK MILL GO RE53.
RE54. GO RE3.

RE6. ACCEPT ML-STATUS LINE 11 COLUMN 10 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO RE8.
    DISPLAY ML-STATUS LINE 11 COLUMN 10 CONVERSION.
    MOVE ML-DATE TO D-DATE MOVE 13 TO IXT MOVE 8 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO RE8. MOVE DATE0 TO ML-DATE.
    ACCEPT ML-WEI-MAX LINE 13 COLUMN 36 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO RE8.
    DISPLAY ML-WEI-MAX LINE 13 COLUMN 36 CONVERSION.
    ACCEPT ML-WEI-REQ LINE 13 COLUMN 62 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO RE8.
    DISPLAY ML-WEI-REQ LINE 13 COLUMN 62 CONVERSION.
RE8. MOVE ML-DIAM TO ML-KDIAM COMPUTE ML-ZDATE=999999 - ML-DATE.
    IF RE-OP=1 WRITE ML-RECORD ALLOWING NO ELSE REWRITE ML-RECORD ALLOWING NO.
    UNLOCK MILL PERFORM DSP-CONT GO RE3.
RE9. GO MN9.

* P-38 SHOW STOCK TRANSACTIONS
RN1. PERFORM RD77 MOVE " " TO PH-NO MOVE 3 TO IXT.
RN3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
RN33. DISPLAY "NEXT PART NO. ____________      DATE ______" LINE IXT.
    ACCEPT IA33 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA33=ALL "9" GO RN9.
    IF IA33=" " IF PH-NO=" " GO RN33 ELSE GO RN4. MOVE IA33 TO PH-NO.
    MOVE 38 TO IXU PERFORM AX-DT-INV.
    START PART KEY>=PH-KEY REGARDLESS INVALID PERFORM DSP-ERR3 GO RN33.
    READ PART NEXT REGARDLESS.
    MOVE PH-NO TO PT-PART MOVE DATE0 TO PT-DATE MOVE 0 TO PT-TIME INQ-IND.
RN4. PERFORM PART-TYPE.
    IF PART-MAT PERFORM RD77A ELSE IF PART-TOOL PERFORM RD77B ELSE PERFORM RD77.
    MOVE PH-NO TO TF173(1) MOVE PH-DESC1 TO TF174(1) MOVE PH-DESC2 TO TF174(2).
    MOVE 4 TO IXT IF INQ-IND=0 START PARTRANS KEY>=PT-KEY REGARDLESS INVALID GO RN8.
RN5. READ PARTRANS NEXT REGARDLESS END GO RN8. IF PT-PART NOT=PH-NO GO RN8.
    PERFORM CLR-LN.
    IF PART-MAT MOVE PT-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF175(IXT)
      MOVE PT-TRANS TO TF176(IXT) MOVE PT-FBIN TO TF177(IXT) MOVE PT-TBIN TO TF178(IXT)
      MOVE PT-QTY TO TF179(IXT) MOVE PT-PCODE TO TF180(IXT) MOVE PT-COILS TO TF181(IXT)
      MOVE PT-CWEIGHT TO TF182(IXT) MOVE PT-HEAT TO TF183(IXT) GO RN6.
    IF PART-TOOL MOVE PT-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF185(IXT)
      MOVE PT-TIME(1:4) TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO TF186(IXT)
      MOVE PT-TRANS TO TF187(IXT) MOVE PT-FBIN TO TF188(IXT) MOVE PT-TBIN TO TF189(IXT)
      MOVE PT-QTY TO TF190(IXT) MOVE PT-USER TO TF191(IXT) GO RN6.
    MOVE PT-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF193(IXT).
    MOVE PT-TRANS TO TF194(IXT) MOVE PT-FBIN TO TF195(IXT) MOVE PT-TBIN TO TF196(IXT).
    MOVE PT-QTY TO TF197(IXT).
RN6. ADD 1 TO IXT IF IXT<22 GO RN5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO RN89.
RN8. MOVE "*** END ***" TO TLN(IXT).
    READ PART NEXT REGARDLESS END MOVE " " TO PH-NO GO RN89.
    MOVE PH-NO TO PT-PART MOVE DATE0 TO PT-DATE MOVE 0 TO PT-TIME INQ-IND.
RN89. GO RN3.
RN9. GO MN9.

* T: TOOLS FUNCTIONS

* T-1 ARCHIVE TOOL LIST MAINTENANCE
EP1. OPEN I-O ARCTOOLS ALLOWING ALL.
EP3. PERFORM RD234 PERFORM WRT.
    ACCEPT EP-OP LINE 9 COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR EP-OP=9 GO EP9. IF EP-OP=0 OR>3 PERFORM DSP-ERR1 GO EP3.
    ACCEPT EP-PROD LINE 9 COLUMN 28 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE EP-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO EP3.
    IF P-GEN>" " PERFORM DSP-ERR29 GO EP3.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 10 COLUMN 28.
    ACCEPT EP-MAC LINE 9 COLUMN 55 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT EP-ID LINE 9 COLUMN 75 DEFAULT " " UNDERLINED PROTECTED EDITING.

    MOVE LOW-VALUES TO TS-RECORD TY-RECORD INITIALIZE TS-REC TY-REC.
    MOVE EP-PROD TO TS-PROD TY-PROD MOVE EP-MAC TO TS-MAC TY-MAC MOVE EP-ID TO TY-ID.
    MOVE SYS-DATE TO TY-DATE.
    MOVE 0 TO EP-KTS READ TOOLS REGARDLESS INVALID MOVE 1 TO EP-KTS.
    MOVE 0 TO EP-KTY READ ARCTOOLS REGARDLESS INVALID MOVE 1 TO EP-KTY.
    MOVE TY-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 12 COLUMN 8.
    DISPLAY TY-NOTE LINE 12 COLUMN 26.
    IF EP-OP=1 AND EP-KTS=1 MOVE "THERE IS NO CURRENT TOOL LIST FOR THIS PRODUCT-MACHINE"
      TO ERR-MESG PERFORM DSP-ERR GO EP3.
    IF EP-OP=1 AND EP-KTY=0 MOVE "THIS ARCHIVE TOOL LIST ALREADY EXISTS"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO EP3.
    IF EP-OP=2 AND EP-KTS=1 MOVE "THERE IS NO CURRENT TOOL LIST FOR THIS PRODUCT-MACHINE"
      TO ERR-MESG PERFORM DSP-OK IF XA2 NOT="OK" GO EP3.
    IF (EP-OP=2 OR 3) AND EP-KTY=1 MOVE "THERE IS NO ARCHIVE TOOL LIST FOR THIS PRODUCT-MACHINE-ID"
      TO ERR-MESG PERFORM DSP-ERR GO EP3.
    MOVE 15 TO EP-IXT GO EP4 EP6 EP8  DEPENDING EP-OP.

EP4. MOVE 12 TO IXT MOVE 8 TO IXU PERFORM AX-DT-DEF MOVE DATE0 TO TY-DATE.
    ACCEPT TY-NOTE LINE 12 COLUMN 26 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE TS-RECORD TO TY-TSREC.
    IF EP-KTY=1 DISPLAY "A NEW ARCHIVE TOOL LIST WILL BE CREATED" LINE EP-IXT BOLD
      ELSE DISPLAY "THE PREVIOUS ARCHIVE TOOL LIST WILL BE OVERWRITTEN" LINE EP-IXT BOLD.
    PERFORM EP-OK IF XA2 NOT="OK" GO EP48.
    IF EP-KTY=1 WRITE TY-RECORD ALLOWING NO ELSE REWRITE TY-RECORD ALLOWING NO.
    UNLOCK ARCTOOLS.
EP48. GO EP89.

EP6. MOVE TS-RECORD TO TL-LREC MOVE TY-TSREC TO TS-RECORD.
    IF EP-KTS=1 DISPLAY "A NEW TOOL LIST WILL BE CREATED FROM THE ARCHIVE ONE" LINE EP-IXT BOLD
      ELSE DISPLAY "THE CURRENT TOOL LIST WILL BE REPLACED WITH THE ARCHIVE ONE" LINE EP-IXT BOLD.
    PERFORM EP-OK IF XA2 NOT="OK" GO EP68.
    IF EP-KTS=1 WRITE TS-RECORD ALLOWING NO ELSE REWRITE TS-RECORD ALLOWING NO.
    UNLOCK TOOLS.
    PERFORM TL-SET-TYPE MOVE 1 TO A-N1 PERFORM TL-TP-UPDATE.
EP68. GO EP89.

EP8. DISPLAY "THE ARCHIVE TOOL LIST WILL BE DELETED" LINE EP-IXT BOLD.
    PERFORM EP-OK IF XA2="OK" DELETE ARCTOOLS. GO EP89.

EP89. DISPLAY EP-MESG LINE EP-IXT PLUS 2 BOLD PERFORM DSP-CONT GO EP3.
EP9. CLOSE ARCTOOLS GO MN9.

EP-OK. DISPLAY "'OK' TO PERFORM OPERATION: __" LINE EP-IXT PLUS 2 COLUMN 50 BOLD.
    ACCEPT XA2 LINE EP-IXT PLUS 2 COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
    IF XA2="OK" MOVE "OPERATION COMPLETED" TO EP-MESG
      ELSE MOVE "OPERATION CANCELED" TO EP-MESG.

* T-2 SHOW ARCHIVE TOOL LISTS
EO1. OPEN I-O ARCTOOLS ALLOWING ALL.
    PERFORM RD235 MOVE " " TO EO-PROD MOVE 0 TO INQ-IND MOVE 3 TO IXT.
EO3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
    DISPLAY "NEXT PRODUCT NO. ____________" LINE IXT.
    DISPLAY "PRODUCT NO., OR BEGINNING OF PRODUCT NO., OR LEAVE BLANK TO SEE ALL PRODUCTS" LINE 24 BOLD.
    ACCEPT IA35 LINE IXT COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR IA35=ALL "9" GO EO9. IF IA35=" " AND INQ-IND=1 GO EO4.
    MOVE IA35 TO EO-PROD A-A1 PERFORM STR-LTH MOVE A-N1 TO EO-LTH.
    INITIALIZE TY-KEY MOVE EO-PROD TO TY-PROD MOVE 0 TO INQ-IND.
EO4. PERFORM RD235.
    MOVE 4 TO IXT IF INQ-IND=0 START ARCTOOLS KEY>=TY-KEY REGARDLESS INVALID GO EO8.
EO5. READ ARCTOOLS NEXT REGARDLESS END GO EO8. IF TY-PROD(1:EO-LTH) NOT=EO-PROD GO EO8.
    PERFORM CLR-LN MOVE TY-PROD TO TF160(IXT) MOVE TY-MAC TO TF161(IXT).
    MOVE TY-ID TO TF162(IXT) MOVE TY-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF163(IXT).
    MOVE TY-NOTE TO TF164(IXT).
    ADD 1 TO IXT IF IXT<22 GO EO5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO EO89.
EO8. MOVE "*** END ***" TO TLN(IXT).
    MOVE " " TO EO-PROD MOVE 0 TO INQ-IND.
EO89. GO EO3.
EO9. CLOSE ARCTOOLS GO MN9.

* T-3 PRINT TOOL DRAWINGS
MZ1. MOVE 1 TO PDR-TP PERFORM PRINT-DRAWING.
MZ9. GO MN9.

* T-4 SHOW MAINTENANCE BINS
BQ1. MOVE "X" TO BH-NO MOVE 0 TO WD1 INQ-IND.
BQ3. PERFORM RD140 MOVE 4 TO IXT.
    IF INQ-IND=0 START PURBIN KEY>=BH-KEY REGARDLESS INVALID GO BQ8.
BQ5. READ PURBIN NEXT REGARDLESS END GO BQ8. IF BH-NO(1:1)>"X" GO BQ8.
    PERFORM CLR-LN MOVE BH-NO TO TF271(IXT) MOVE BH-PART TO TF272(IXT).
    MOVE BH-QTY TO TF273(IXT) ADD BH-QTY TO WD1.
    MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF274(IXT).
    ADD 1 TO IXT IF IXT<22 GO BQ5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO BQ82.
BQ8. MOVE "*** END ***" TO TLN(IXT) MOVE WD1 TO TF277(1).
    MOVE "X" TO BH-NO MOVE 0 TO WD1 INQ-IND.
BQ82. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
    DISPLAY "PF4 TO END: _" LINE IXT.
    ACCEPT XA1 COLUMN 13 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF NOT KPF4 GO BQ3.
BQ9. GO MN9.

* T-5 WRITE TOOL LIST NOTES
TW1.
TW3. PERFORM RD126 PERFORM WRT.
TW33. ACCEPT TS-PROD LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR TS-PROD=ALL "9" GO TW9.
    MOVE TS-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TW33.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 4 COLUMN 11.
    MOVE P-MAC TO TS-MAC DISPLAY TS-MAC LINE 3 COLUMN 39 CONVERSION.
    ACCEPT TS-MAC LINE 3 COLUMN 39 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 GO TW9. DISPLAY TS-MAC LINE 3 COLUMN 39 CONVERSION.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TW33.
    MOVE TS-PLNUM TO TW-PLNUM DISPLAY TW-PLNUM LINE 5 COLUMN 10.
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>3
      MOVE TS-NOTE(IX1) TO TW-NOTE(IX1) DISPLAY TW-NOTE(IX1) LINE IXT COLUMN 4
      ADD 1 TO IX1 IXT END-PERFORM.
    ACCEPT TW-PLNUM LINE 5 COLUMN 10 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>3
      ACCEPT TW-NOTE(IX1) LINE IXT COLUMN 4 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      ADD 1 TO IX1 IXT END-PERFORM.
    PERFORM RDLK-TOOLS MOVE TW-PLNUM TO TS-PLNUM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE TW-NOTE(IX1) TO TS-NOTE(IX1) END-PERFORM.
    REWRITE TS-RECORD ALLOWING NO UNLOCK TOOLS GO TW3.
TW9. GO MN9.

* T-6 READ DRAWINGS INPUT FILE
UD1. PERFORM RD139 PERFORM WRT.
    ACCEPT SIX-ID LINE 3 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SIX-ID=ALL "9" GO UD9.
    IF SIX-ID>" " OPEN INPUT SIXIN
      MOVE SIX-ID TO A-A1 PERFORM UD-OPEN IF A-S1=1 GO UD1 END-IF CLOSE SIXIN.
    ACCEPT PIN-ID LINE 4 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR PIN-ID=ALL "9" GO UD9.
    IF PIN-ID>" " OPEN INPUT PCLIN
      MOVE PIN-ID TO A-A1 PERFORM UD-OPEN IF A-S1=1 GO UD1 END-IF CLOSE PCLIN.
    IF SIX-ID=" " AND PIN-ID=" " GO UD9.
    ACCEPT XA5 LINE 6 COLUMN 12 DEFAULT " " PROTECTED NO ECHO.
    IF XA5 NOT="21476" PERFORM DSP-ERR21 GO UD1.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO UD9.
    PERFORM DSP-WAIT PERFORM OPEN-PR.

    IF SIX-ID=" " GO UD6. MOVE 1 TO UD-STEP.
    OPEN INPUT SIXIN I-O DRAWINGS ALLOWING ALL PERFORM UD-PAGE MOVE 0 TO PR-IXP.
UD3. READ SIXIN END GO UD48. PERFORM UD-C IF UD-KH=0 GO UD3.
UD31. MOVE SIN-DRAW TO UD-DRAW MOVE SIN-PAGE TO UD-PG MOVE SIN-NLINES TO UD-NLINES.
    IF UD-PG=2 MOVE UD-DRAW TO A-A1 PERFORM STR-LTH MOVE " " TO UD-DRAW(A-N1:1).
* note 119.1
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM UD-LINE MOVE 1 TO PR-IXP.
    MOVE UD-DRAW TO FA98(PR-IXP) MOVE UD-PG TO FA99(PR-IXP).
    IF UD-PG=2 MOVE UD-DRAW TO DR-DRAW MOVE 1 TO DR-PAGE MOVE 0 TO DR-LINE
      READ DRAWINGS REGARDLESS INVALID MOVE "*" TO FA97(PR-IXP) GO UD3.
    MOVE UD-DRAW TO DR-DRAW MOVE UD-PG TO DR-PAGE MOVE 0 TO DR-LINE.
    MOVE DR-KEY TO WA1.
UD33. MOVE WA1 TO DR-KEY MOVE 0 TO IX1.
    START DRAWINGS KEY>=DR-KEY REGARDLESS INVALID GO UD39.
UD35. READ DRAWINGS NEXT REGARDLESS END GO UD39. MOVE DR-KEY TO WA1.
    IF DR-DRAW NOT=UD-DRAW GO UD39.
    DELETE DRAWINGS IF DR-LINE=0 MOVE "-" TO FA97(PR-IXP).
    ADD 1 TO IX1 IF IX1=100 CLOSE DRAWINGS OPEN I-O DRAWINGS ALLOWING ALL GO UD33.
    GO UD35.
UD39.

    MOVE UD-DRAW TO DR-DRAW MOVE UD-PG TO DR-PAGE MOVE 0 TO DR-LINE.
    MOVE UD-NLINES TO DR-NLINES.
    MOVE SYS-DATE TO DR-DATE ACCEPT DR-TIME FROM TIME.
* note 252.1
    MOVE 31 TO SIX-SZ WRITE DR-RECORD ALLOWING NO UNLOCK DRAWINGS.
UD43. READ SIXIN END MOVE "*" TO FA97(PR-IXP) GO UD48.
    PERFORM UD-C IF UD-KH=1 MOVE "*" TO FA97(PR-IXP) GO UD46.
    ADD 1 TO DR-LINE MOVE SIN-RECORD(1:SIX-SZ) TO DR-DATA(1:SIX-SZ).
    ADD 13 TO SIX-SZ WRITE DR-RECORD ALLOWING NO UNLOCK DRAWINGS.
    IF DR-LINE<UD-NLINES GO UD43.
UD45. READ SIXIN END GO UD48. PERFORM UD-C IF UD-KH=1 GO UD46.
    MOVE "*" TO FA97(PR-IXP) GO UD45.
UD46. GO UD31.
UD48. PERFORM UD-LINE CLOSE SIXIN DRAWINGS.

UD6. IF PIN-ID=" " GO UD89. MOVE 2 TO UD-STEP.
    OPEN INPUT PCLIN I-O PDRAWINGS ALLOWING ALL PERFORM UD-PAGE MOVE 0 TO PR-IXP.
UD7. READ PCLIN END GO UD88. PERFORM UD-PC IF UD-KH=0 GO UD7.
UD71. MOVE PIN-DRAW TO UD-DRAW MOVE PIN-PAGE TO UD-PG MOVE PIN-NLINES TO UD-NLINES.
    IF UD-PG=2 MOVE UD-DRAW TO A-A1 PERFORM STR-LTH MOVE " " TO UD-DRAW(A-N1:1).
* note 119.2
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM UD-LINE MOVE 1 TO PR-IXP.
    MOVE UD-DRAW TO FA98(PR-IXP) MOVE UD-PG TO FA99(PR-IXP).
    IF UD-PG=2 MOVE UD-DRAW TO DG-DRAW MOVE 1 TO DG-PAGE MOVE 0 TO DG-LINE
      READ PDRAWINGS REGARDLESS INVALID MOVE "*" TO FA97(PR-IXP) GO UD7.
    MOVE UD-DRAW TO DG-DRAW MOVE UD-PG TO DG-PAGE MOVE 0 TO DG-LINE.
    MOVE DG-KEY TO WA1.
UD73. MOVE WA1 TO DG-KEY MOVE 0 TO IX1.
    START PDRAWINGS KEY>=DG-KEY REGARDLESS INVALID GO UD79.
UD75. READ PDRAWINGS NEXT REGARDLESS END GO UD79. MOVE DG-KEY TO WA1.
    IF DG-DRAW NOT=UD-DRAW GO UD79.
    DELETE PDRAWINGS IF DG-LINE=0 MOVE "-" TO FA97(PR-IXP).
    ADD 1 TO IX1 IF IX1=100 CLOSE PDRAWINGS OPEN I-O PDRAWINGS ALLOWING ALL GO UD73.
    GO UD75.
UD79.

    MOVE UD-DRAW TO DG-DRAW MOVE UD-PG TO DG-PAGE MOVE 0 TO DG-LINE.
    MOVE " " TO DG-DATA MOVE UD-NLINES TO DG-NLINES.
    MOVE SYS-DATE TO DG-DATE ACCEPT DG-TIME FROM TIME.
* note 252.2
    WRITE DG-RECORD ALLOWING NO UNLOCK PDRAWINGS.
UD83. READ PCLIN END GO UD88. PERFORM UD-PC IF UD-KH=1 GO UD86.
    ADD 1 TO DG-LINE MOVE PIN-RECORD TO DG-DATA.
    WRITE DG-RECORD ALLOWING NO UNLOCK PDRAWINGS GO UD83.
UD86. GO UD71.
UD88. PERFORM UD-LINE CLOSE PCLIN PDRAWINGS.

UD89. PERFORM CLOSE-PR.
UD9. GO MN9.

UD-OPEN. IF DSTAT="00" MOVE 0 TO A-S1
      ELSE MOVE 1 TO A-S1 MOVE " " TO ERR-MESG
        STRING A-A1 DELIMITED " " " - FILE NOT FOUND" DELIMITED SIZE
        INTO ERR-MESG PERFORM DSP-ERR.
UD-C. MOVE 0 TO UD-KH IF SIX-SZ=13 AND SIN-PAGE NUMERIC AND (SIN-PAGE=1 OR 2)
        AND SIN-NLINES NUMERIC MOVE 1 TO UD-KH.
UD-PC. MOVE 0 TO UD-KH IF PIN-RECORD(14:10)="**********" AND PIN-PAGE NUMERIC
        AND (PIN-PAGE=1 OR 2) AND PIN-NLINES NUMERIC MOVE 1 TO UD-KH.
UD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM UD-PAGE.
UD-PAGE. MOVE "DRAWINGS FILE UPDATE" TO FF3.
    IF UD-STEP=1 MOVE "(FOR DISPLAY)" TO FF4.
    IF UD-STEP=2 MOVE "(FOR PRINTING)" TO FF4. PERFORM PR-PAGE.
    MOVE 2 TO WS-PR MOVE "'*' ERROR     '-' REPLACEMENT" TO PREC PERFORM PR-LINE-3.

* T-7 WRITE ASSEMBLY NOTES
FW1.
FW3. PERFORM RD188 PERFORM WRT.
FW33. ACCEPT PH-NO LINE 3 COLUMN 8 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR PH-NO=ALL "9" GO FW9.
    READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO FW33.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=1) PERFORM DSP-ERR53 GO FW33.
    DISPLAY PH-DESC1 LINE 3 COLUMN 22 PH-DESC2 LINE 4 COLUMN 22.
    DISPLAY PH-NOTE(1) LINE 7 COLUMN 4 PH-NOTE(2) LINE 8 COLUMN 4.
    MOVE PH-NOTE(1) TO FW-NOTE(1) MOVE PH-NOTE(2) TO FW-NOTE(2).
    ACCEPT FW-NOTE(1) LINE 7 COLUMN 4 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT FW-NOTE(2) LINE 8 COLUMN 4 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM RDLK-PART MOVE FW-NOTE(1) TO PH-NOTE(1) MOVE FW-NOTE(2) TO PH-NOTE(2).
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO FW3.
FW9. GO MN9.

* T-8 SHOW TOOLS IN ASSEMBLIES
GH1. PERFORM RD279 MOVE " " TO PH-NO MOVE 3 TO IXT MOVE 0 TO GH-KSRT.
GH3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
GH33. DISPLAY "NEXT PART NO. ____________" LINE IXT.
GH35. ACCEPT IA3 LINE IXT COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA3=ALL "9" GO GH9.
    IF IA3=" " IF PH-NO=" " GO GH33 ELSE GO GH6. MOVE IA3 TO PH-NO.
    READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO GH33.
    MOVE PH-NO TO GH-PART MOVE PH-DESC1 TO GH-DESC1 MOVE PH-DESC2 TO GH-DESC2.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=0) PERFORM DSP-ERR54 GO GH35.
    PERFORM DSP-QWAIT.
    IF GH-KSRT=1 PERFORM CLOSE-SORT. PERFORM OPEN-SORT MOVE 1 TO GH-KSRT.
    INITIALIZE TP-KEY MOVE GH-PART TO TP-TOOL.
    START TOOLPROD KEY>TP-KEY REGARDLESS INVALID GO GH59.
GH5. READ TOOLPROD NEXT REGARDLESS END GO GH59. IF TP-TOOL NOT=GH-PART GO GH59.
    MOVE TP-PROD TO TS-PROD MOVE TP-MAC TO TS-MAC READ TOOLS REGARDLESS INVALID GO GH588.
    PERFORM TL-SET-TYPE.
    PERFORM VARYING TL-IXF FROM 1 BY 1 UNTIL TL-IXF>TL-NUM PERFORM TL-SET-TBL
      IF TP-FLD=TL-FLD GO GH52 END-IF END-PERFORM.
    GO GH588.
GH52. IF TL-CAT=6 MOVE 1 TO GH-CAT ELSE IF TL-CAT=7 MOVE 2 TO GH-CAT ELSE GO GH588.
    MOVE TL-STN TO GH-STN MOVE TL-IXF TO GH-IXF.
    PERFORM VARYING TL-IXF FROM GH-IXF BY 1 UNTIL TL-IXF>TL-NUM PERFORM TL-SET-TBL
       IF TL-STN NOT=GH-STN GO GH54 END-IF IF TL-CAT=GH-CAT GO GH58 END-IF END-PERFORM.
GH54. PERFORM VARYING TL-IXF FROM GH-IXF BY -1 UNTIL TL-IXF=0 PERFORM TL-SET-TBL
       IF TL-STN NOT=GH-STN GO GH56 END-IF IF TL-CAT=GH-CAT GO GH58 END-IF END-PERFORM.
GH56. GO GH588.
GH58. MOVE TS-TOOL(TL-FLD) TO SR-F172 WRITE SR-RECORD INVALID CONTINUE.
GH588. GO GH5.
GH59. PERFORM DSP-ERS MOVE 0 TO INQ-IND MOVE " " TO SR-KEY.

GH6. PERFORM RD279 MOVE GH-PART TO TF343(1) MOVE PH-DESC1 TO TF344(1) MOVE PH-DESC2 TO TF344(2).
    MOVE 4 TO IXT IF INQ-IND=0 START SORTFL KEY>SR-KEY INVALID GO GH8.
GH7. READ SORTFL NEXT END GO GH8. PERFORM CLR-LN MOVE SR-F172 TO TF345(IXT) PH-NO.
    READ PART REGARDLESS INVALID MOVE "** NO PART RECORD **" TO TF346(IXT) GO GH78.
    MOVE PH-DESC1 TO TF346(IXT).
    MOVE 0 TO GH-BTOT GH-KFIR INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO GH74.
GH73. READ PURBIN NEXT REGARDLESS END GO GH74. IF BH-PART NOT=PH-NO GO GH74.
    IF GH-KFIR=0 AND BH-QTY>0 MOVE BH-NO TO TF347(IXT) MOVE 1 TO GH-KFIR.
    ADD 1 TO GH-BTOT GO GH73.
GH74. MOVE PH-HAND TO TF348(IXT) IF GH-BTOT>1 MOVE GH-BTOT TO TF349(IXT).
GH78. ADD 1 TO IXT IF IXT<22 GO GH7.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE GH-PART TO PH-NO MOVE 1 TO INQ-IND GO GH89.
GH8. MOVE "*** END ***" TO TLN(IXT) MOVE " " TO PH-NO.
GH89. GO GH3.
GH9. IF GH-KSRT=1 PERFORM CLOSE-SORT. GO MN9.

* T-9 SHOW TOOL DRAWING
VX1. OPEN INPUT DRAWINGS ALLOWING ALL PERFORM SIXINIT.
VX3. MOVE 1 TO SDR-PG MOVE " " TO SDR-DRAW(1) SDR-DRAW(2).
    PERFORM SIXPG2 PERFORM SIXCLS PERFORM SIXPG1 PERFORM SIXCLS PERFORM SIXD.
    PERFORM RD224 PERFORM WRT PERFORM RD226 PERFORM WRT.
VX5. ACCEPT SDR-INP LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR SDR-INP=ALL "9" GO VX9.
    MOVE 1 TO SDR-TP PERFORM SHOW-DRAWING IF SDR-KER=1 GO VX5. GO VX3.
VX9. PERFORM SIXPG2 PERFORM SIXCLS PERFORM SIXPG1 PERFORM SIXCLS PERFORM SIXD.
    CLOSE DRAWINGS GO MN9.

* T-10 PRINT PCC & DRAWING
QH1. PERFORM RD208 PERFORM WRT MOVE 0 TO QH-RN MOVE 2 TO IXT.
QH13. ADD 1 TO QH-RN IXT.
QH15. ACCEPT R-NO LINE IXT COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF R-NO=0 SUBTRACT 1 FROM QH-RN GO QH16.
    READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO QH15.
    MOVE R-NO TO RNUM1(QH-RN) IF QH-RN<10 GO QH13.
QH16. MOVE 13 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE 3 TO LAS-FLN PERFORM OPEN-LAS.
    OPEN INPUT PDRAWINGS ALLOWING ALL.

    MOVE 0 TO QH-IXN.
QH3. ADD 1 TO QH-IXN IF QH-IXN>QH-RN GO QH8.
    MOVE RNUM1(QH-IXN) TO A-N1 PERFORM RD-PRODORD MOVE R-PROD TO A-A1 PERFORM PROD-RT.
    MOVE P-MAC TO QH-MAC MOVE " " TO QH-DRAW PERFORM SET-PART MOVE PART-NO TO QH-MAT.
    IF P-PRINT>0 PERFORM DESC-PRINT MOVE PRO-PRINT(1:6) TO QH-DRAW.

    PERFORM PCL-INIT PERFORM PCL-START.
    PERFORM PCL-BOLD1 MOVE 0 TO LAS-ROW LAS-COL PERFORM PCL-PCR.
    MOVE QH-DRAW TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM2 ADD 2 TO LAS-ROW PERFORM PCL-PCR.
    PERFORM PCL-UNDY MOVE "M.O." TO LAS-FLD PERFORM LASF PERFORM PCL-UNDN.
    PERFORM PCL-BOLD1 ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE R-NO TO FJ-N5 PERFORM LASF.

    MOVE QH-DRAW TO DG-DRAW MOVE 1 TO DG-PAGE MOVE 0 TO DG-LINE.
    READ PDRAWINGS REGARDLESS INVALID PERFORM PCL-ENDFL GO QH66.
    PERFORM PCL-FLUSH.
* note 75.1
    MOVE QH-DRAW TO DG-DRAW MOVE 1 TO DG-PAGE DG-LINE.
    START PDRAWINGS KEY>=DG-KEY REGARDLESS INVALID GO QH66.
QH65. READ PDRAWINGS NEXT REGARDLESS END GO QH66.
    IF DG-DRAW NOT=QH-DRAW GO QH66. IF DG-LINE=0 GO QH65.
    IF DG-PAGE=1 AND DG-LINE=1 MOVE LOW-VALUES TO DG-DATA(1:11).
    MOVE DG-DATA TO LAS-RECORD WRITE LAS-RECORD GO QH65.
QH66. PERFORM PCL-INIT PERFORM PCL-START MOVE LAS-PO90 TO LAS-FLD PERFORM LASF.

    MOVE "`*p100x000Y`*c650a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p+50Y`*c650a2b0P`*p+50Y`*c650a2b0P`*p+50Y`*c650a2b0P`*p+50Y`*c650a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p100x000Y`*c2a202b0P`*p+650X`*c2a202b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s12h0s0B`*p110x042YM.O.`*p110x+50YPART NO.`*p110x+50YDWG. NO.`*p110x+50YDATE" TO LAS-FLD PERFORM LASF.

    MOVE "`*p800x000Y`*c730a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p+50Y`*c730a2b0P`*p+50Y`*c730a2b0P`*p+50Y`*c730a2b0P`*p+50Y`*c730a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p800x000Y`*c2a202b0P`*p+730X`*c2a202b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s12h0s0B`*p810x042YMATERIAL`*p810x+50YHEAT NO.`*p810x+50YMACHINE" TO LAS-FLD PERFORM LASF.
    MOVE "`*p810x+50YOPERATOR CLOCK" TO LAS-FLD PERFORM LASF.

    MOVE "`*p1580x000Y`*c720a2b0P`*p+180Y`*c720a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1580x000Y`*c2a182b0P`*p+720X`*c2a182b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s16.66h0s0B`*p1590x076YPART SPECIFIC CONCERNS REVIEWED `*c120a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1590x+80YERROR PROOFING DEVICES VERIFIED `*c120a2b0P" TO LAS-FLD PERFORM LASF.

    MOVE "`(s10h0s3B`*p2690x030YIRVINE FASTENERS" TO LAS-FLD PERFORM LASF.
    MOVE "`(s16.66h0s0B`*p2780x080YIF-438 REV 0 02/21/05" TO LAS-FLD PERFORM LASF.
    MOVE "`(s12h1s3B`*p2010x253YTHE ACCEPTANCE CRITERION IS ZERO DISCREPANCIES" TO LAS-FLD PERFORM LASF.

    MOVE "`*p100x261Y`*c3100a4b0P`*p100x311Y`*c3100a4b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p100x313Y" TO LAS-FLD PERFORM LASF.
    PERFORM 26 TIMES MOVE "`*p+77Y`*c3100a2b0P" TO LAS-FLD PERFORM LASF END-PERFORM.
    MOVE "`*p+77Y`*c3100a4b0P" TO LAS-FLD PERFORM LASF.

    MOVE "`*p100x261Y`*c4a2135b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p+780X`*c2a2135b0P`*p+210X`*c2a2135b0P`*p+210X`*c2a2135b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p+250X`*c2a2135b0P`*p+188X`*c4a2135b0P" TO LAS-FLD PERFORM LASF.
    PERFORM 7 TIMES MOVE "`*p+183X`*c2a2135b0P" TO LAS-FLD PERFORM LASF END-PERFORM.
    MOVE "`*p3200x261Y`*c4a2135b0P" TO LAS-FLD PERFORM LASF.

    STRING "`(s16.66h0s3B`*p112x303YCHARACTERISTIC`*p892XSPEC'S`*p1102XUNIT"
      "`*p1312XCHECKED WITH`*p1562XSET-UP"
      "`*p1750X1`*p1933X2`*p2116X3`*p2299X4`*p2482X5`*p2665X6`*p2848X7`*p3031X8"
      DELIMITED SIZE INTO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD1.
    MOVE "`*p360x042Y" TO LAS-FLD PERFORM LASF MOVE R-NO TO FJ-N6 PERFORM LASF.
    MOVE "`*p360x+50Y" TO LAS-FLD PERFORM LASF MOVE P-NO TO LAS-FLD PERFORM LASF.
    MOVE "`*p360x+50Y" TO LAS-FLD PERFORM LASF MOVE QH-DRAW TO LAS-FLD PERFORM LASF.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE "`*p360x+50Y" TO LAS-FLD PERFORM LASF MOVE D-DT TO FJ-NDT PERFORM LASF.

    MOVE "`*p1060x042Y" TO LAS-FLD PERFORM LASF MOVE QH-MAT TO LAS-FLD PERFORM LASF.
    MOVE "`*p1060x+100Y" TO LAS-FLD PERFORM LASF.
    IF QH-MAC<10 MOVE QH-MAC TO FJ-N1 ELSE MOVE QH-MAC TO FJ-N2. PERFORM LASF.

    MOVE 305 TO QH-YPOS MOVE 1 TO CAR-CH MOVE 0 TO QH-CNUM.
QH73. IF P-PCHAR(CAR-CH)=0 GO QH78. ADD 1 TO QH-CNUM ADD 77 TO QH-YPOS.
    MOVE P-PCHAR(CAR-CH) TO T-NO PERFORM RD-CHAR IF A-S1=1 MOVE "*** UNDEFINED ***" TO CAR-DESC.
    PERFORM PCL-NORM2.
    MOVE 112 TO LAS-POSX MOVE QH-YPOS TO LAS-POSY MOVE LAS-POS TO LAS-FLD PERFORM LASF.
    MOVE CAR-DESC TO LAS-FLD PERFORM LASF.
    IF P-PCHAR(CAR-CH)=25
      MOVE "`*p892X" TO LAS-FLD PERFORM LASF MOVE P-PID TO LAS-FLD PERFORM LASF
     ELSE
      MOVE "`*p892x-35Y" TO LAS-FLD PERFORM LASF
      IF P-PMIN(CAR-CH)>0 MOVE P-PMIN(CAR-CH) TO FJ-D24 PERFORM LASF END-IF
      MOVE "`*p892x+35Y" TO LAS-FLD PERFORM LASF
      IF P-PMAX(CAR-CH)>0 MOVE P-PMAX(CAR-CH) TO FJ-D24 PERFORM LASF END-IF.
    PERFORM PCL-NORM3 PERFORM DESC-UNIT PERFORM DESC-INSTR.
    MOVE "`*p1102X" TO LAS-FLD PERFORM LASF MOVE CAR-UNIT TO LAS-FLD PERFORM LASF.
    IF CAR-INSTR-A(2)=" "
      MOVE "`*p1312X" TO LAS-FLD PERFORM LASF MOVE CAR-INSTR-A(1) TO LAS-FLD PERFORM LASF
     ELSE
      MOVE "`*p1312x-35Y" TO LAS-FLD PERFORM LASF MOVE CAR-INSTR-A(1) TO LAS-FLD PERFORM LASF
      MOVE "`*p1312x+35Y" TO LAS-FLD PERFORM LASF MOVE CAR-INSTR-A(2) TO LAS-FLD PERFORM LASF.
QH78. ADD 1 TO CAR-CH IF CAR-CH<=CAR-PHYS-NUM AND QH-CNUM<27 GO QH73.
    PERFORM PCL-ENDFL GO QH3.
QH8. PERFORM CLOSE-LAS CLOSE PDRAWINGS.
    MOVE "PRINT1" TO LAS-QUEUE PERFORM PRINT-LAS.
QH9. GO MN9.

* T-11 MISCELLANEOUS MODIFICATIONS
TE1. PERFORM RD131 PERFORM WRT.
    ACCEPT TE-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR TE-SEL=99 GO TE9. PERFORM DSP-CLS.
    GO TE10 TE20 TE30 TE40 TE50 TE60 TE70  DEPENDING TE-SEL. GO TE1.

TE10.
TE11. PERFORM RD131A PERFORM WRT.
TE123. ACCEPT TE-PART1 LINE 6 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO TE89. IF TE-PART1=" " PERFORM DSP-ERR2 GO TE123.
    ACCEPT TE-PART2 LINE 6 COLUMN 45 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 8 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO TE89.
    PERFORM DSP-QWAIT MOVE 0 TO TE-NUM.

    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TE18.
TE13. READ TOOLS NEXT REGARDLESS END GO TE18. MOVE 0 TO TE-KMOD.
    PERFORM TL-SET-TYPE MOVE 1 TO TL-IXA.
TE15. IF TS-TOOL(TL-IXA) NOT=TE-PART1 GO TE16. MOVE 1 TO TE-KMOD.
    MOVE TE-PART2 TO TS-TOOL(TL-IXA).
    MOVE TE-PART1 TO TP-TOOL MOVE TS-PROD TO TP-PROD.
    MOVE TS-MAC TO TP-MAC MOVE TL-IXA TO TP-FLD.
    DELETE TOOLPROD INVALID CONTINUE.
    IF TE-PART2>" " AND NOT="N/R" MOVE TE-PART2 TO TP-TOOL
      WRITE TP-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK TOOLPROD.
TE16. ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO TE15.
    IF TE-KMOD=1 ADD 1 TO TE-NUM REWRITE TS-RECORD ALLOWING NO UNLOCK TOOLS.
    GO TE13.
TE18. PERFORM DSP-ERS DISPLAY TE-NUM LINE 10 CONVERSION "  TOOL LISTS WERE MODIFIED".
    PERFORM DSP-CONT GO TE11.

TE20.
TE21. PERFORM RD131B PERFORM WRT.
TE23. ACCEPT TE-PREFIX LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO TE89. IF TE-PREFIX(1:1)=" " OR TE-PREFIX(2:1)=" " PERFORM DSP-ERR2 GO TE23.
TE231. ACCEPT TE-N1 LINE 3 COLUMN 64 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT TE-N2 LINE 3 COLUMN 75 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF TE-N2<TE-N1 PERFORM DSP-ERR48 GO TE231.
TE233. ACCEPT XA1 LINE 4 COLUMN 64 DEFAULT " " UNDERLINED PROTECTED.
    IF XA1=" " MOVE 0 TO TE-L1 TE-L2 GO TE24.
    PERFORM VARYING TE-L1 FROM 1 BY 1 UNTIL TE-L1>26 OR XA1=LIT-ALPHA(TE-L1:1) CONTINUE END-PERFORM.
    IF TE-L1>26 PERFORM DSP-ERR2 GO TE233.
    ACCEPT XA1 LINE 4 COLUMN 75 DEFAULT " " UNDERLINED PROTECTED.
    PERFORM VARYING TE-L2 FROM 1 BY 1 UNTIL TE-L2>26 OR XA1=LIT-ALPHA(TE-L2:1) CONTINUE END-PERFORM.
    IF TE-L2>26 PERFORM DSP-ERR2 GO TE233. IF TE-L2<TE-L1 PERFORM DSP-ERR48 GO TE233.
TE24. MOVE " " TO WA1 MOVE TE-PREFIX TO WA1(1:2) WA1(10:2) MOVE "-" TO WA1(8:1).
    MOVE TE-N1 TO WA1(3:3) MOVE TE-N2 TO WA1(12:3).
    IF TE-L1 NOT=0 MOVE LIT-ALPHA(TE-L1:1) TO WA1(6:1) MOVE LIT-ALPHA(TE-L2:1) TO WA1(15:1).
    DISPLAY WA1(1:15) LINE 6 COLUMN 54 BOLD ERASE END LINE.
    MOVE 9 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO TE89.
    PERFORM DSP-QWAIT MOVE 0 TO TE-NUM.

    PERFORM INIT-BH MOVE TE-PREFIX TO BH-NO.
    MOVE TE-N1 TO TE-NSUFFIX MOVE TE-L1 TO TE-LSUFFIX.
TE25. MOVE TE-NSUFFIX TO BH-NO(3:3).
    IF TE-LSUFFIX NOT=0 MOVE LIT-ALPHA(TE-LSUFFIX:1) TO BH-NO(6:1).
    MOVE BH-NO TO BH-KNO.
    WRITE BH-RECORD ALLOWING NO INVALID GO TE26. UNLOCK PURBIN ADD 1 TO TE-NUM.
TE26. IF TE-LSUFFIX NOT=0 IF TE-LSUFFIX<TE-L2 ADD 1 TO TE-LSUFFIX GO TE25.
    IF TE-NSUFFIX<TE-N2 ADD 1 TO TE-NSUFFIX MOVE TE-L1 TO TE-LSUFFIX GO TE25.
    PERFORM DSP-ERS DISPLAY TE-NUM LINE 11 CONVERSION "  BINS WERE ADDED".
    PERFORM DSP-CONT GO TE21.

TE30. PERFORM WRT132.
TE31. PERFORM RD131C PERFORM WRT.
TE313. ACCEPT TE-PARTX LINE 5 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO TE89. IF TE-PARTX=" " PERFORM DSP-ERR2 GO TE313.
    MOVE TE-PARTX TO A-A1 PERFORM STR-LTH MOVE A-N1 TO TE-LTH.
* note 108
    MOVE TE-PARTX TO PH-NO MOVE 10 TO IXT MOVE 1 TO IXCOL MOVE 0 TO TE-NUM.
    START PART KEY>=PH-KEY REGARDLESS INVALID GO TE324.
TE323. READ PART NEXT REGARDLESS END GO TE324. IF PH-NO(1:TE-LTH) NOT=TE-PARTX GO TE324.
    ADD 1 TO TE-NUM.
    COMPUTE IXU=(IXCOL - 1) * 9 + 1 DISPLAY PH-NO(TE-LTH + 1:) LINE IXT COLUMN IXU.
    ADD 1 TO IXCOL IF IXCOL>14 ADD 1 TO IXT MOVE 1 TO IXCOL.
    IF IXT>22 DISPLAY " " LINE 22 ERASE LINE MOVE 22 TO IXT. GO TE323.
TE324. ADD 1 TO IXT DISPLAY TE-NUM LINE IXT CONVERSION BOLD "  PARTS WILL BE MODIFIED" BOLD.
    IF TE-NUM>182 DISPLAY "(NOT ALL PARTS ARE SHOWN)" LINE IXT COLUMN 55 BOLD
      SUBTRACT 1 FROM IXT DISPLAY "....." LINE IXT ERASE LINE.

TE33. ACCEPT TE-FLD LINE 5 COLUMN 52 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    GO TE3301 TE3302 TE3303 TE3304 TE3305 TE3306 TE3307 TE3308 TE3309 TE3310
       TE3311
      DEPENDING TE-FLD. PERFORM DSP-ERR2 GO TE33.
    REPLACE ==ACC-ALP== BY ==LINE 5 COLUMN 76 DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 5 COLUMN 76 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
TE3301. ACCEPT TE-DRAW ACC-ALP GO TE34.
TE3302. ACCEPT TE-REV ACC-ALP GO TE34.
TE3303. ACCEPT TE-DESC1 ACC-ALP GO TE34.
TE3304. ACCEPT TE-CAT ACC-NUM GO TE34.
TE3305. ACCEPT TE-LIFE ACC-NUM GO TE34.
TE3306. ACCEPT TE-EOQ ACC-NUM GO TE34.
TE3307. ACCEPT TE-MTYPE ACC-NUM GO TE34.
TE3308. ACCEPT TE-VENDOR-1 ACC-NUM GO TE34.
TE3309. ACCEPT TE-PRICE-1 ACC-NUM GO TE34.
TE3310. ACCEPT TE-ROP ACC-NUM GO TE34.
TE3311. ACCEPT TE-LEVEL ACC-NUM GO TE34.
    REPLACE OFF.
TE34. MOVE 5 TO IXT PERFORM AX-OKW IF XA2 NOT="OK" GO TE89. PERFORM DSP-QWAIT.
    MOVE TE-PARTX TO PH-NO START PART KEY>=PH-KEY REGARDLESS INVALID GO TE38.
TE35. READ PART NEXT REGARDLESS END GO TE38. IF PH-NO(1:TE-LTH) NOT=TE-PARTX GO TE38.
    GO TE3501 TE3502 TE3503 TE3504 TE3505 TE3506 TE3507 TE3508 TE3509 TE3510
       TE3511
      DEPENDING TE-FLD. GO TE35.
TE3501. MOVE TE-DRAW TO PH-DRAW GO TE36.
TE3502. MOVE TE-REV TO PH-REV GO TE36.
TE3503. MOVE TE-DESC1 TO PH-DESC1 GO TE36.
TE3504. MOVE TE-CAT TO PH-CAT GO TE36.
TE3505. MOVE TE-LIFE TO PH-LIFE GO TE36.
TE3506. MOVE TE-EOQ TO PH-EOQ GO TE36.
TE3507. MOVE TE-MTYPE TO PH-MTYPE GO TE36.
TE3508. MOVE TE-VENDOR-1 TO PH-VENDOR(1) GO TE36.
TE3509. MOVE TE-PRICE-1 TO PH-PRICE(1) GO TE36.
TE3510. MOVE TE-ROP TO PH-ROP GO TE36.
TE3511. MOVE TE-LEVEL TO PH-LEVEL GO TE36.

TE36. REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO TE35.
TE38. PERFORM DSP-ERS PERFORM DSP-CONT GO TE31.

TE40. PERFORM WRT132.
TE41. PERFORM RD131D PERFORM WRT.
TE413. ACCEPT TE-MAC LINE 5 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO TE89. IF TE-MAC=0 PERFORM DSP-ERR2 GO TE413.
    MOVE TE-MAC TO TS-MAC PERFORM TL-SET-TYPE PERFORM TL-DISP-TOOLS.
TE421. ACCEPT XN3 LINE 5 COLUMN 39 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF XN3>0 AND<=TL-NUM MOVE XN3 TO TL-IXF PERFORM TL-SET-TBL
      IF TL-PAGE>0 MOVE TL-FLD TO TE-T1 DISPLAY TL-DESC LINE 5 COLUMN 44 GO TE422.
    PERFORM DSP-ERR2 GO TE421.
TE422. ACCEPT TE-PART1 LINE 5 COLUMN 73 DEFAULT " " UNDERLINED PROTECTED EDITING.
TE423. ACCEPT XN3 LINE 6 COLUMN 39 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF XN3>0 AND<=TL-NUM MOVE XN3 TO TL-IXF PERFORM TL-SET-TBL
      IF TL-PAGE>0 MOVE TL-FLD TO TE-T2 DISPLAY TL-DESC LINE 6 COLUMN 44 GO TE424.
    PERFORM DSP-ERR2 GO TE423.
TE424.
TE427. ACCEPT TE-PART2 LINE 6 COLUMN 73 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF TE-PART2=" " MOVE "THIS TOOL CANNOT BE BLANK" TO ERR-MESG PERFORM DSP-ERR GO TE427.

    DISPLAY "'Y' TO SHOW EXAMPLES OF TOOLS THAT WILL BE CHANGED: _ " LINE 24 BOLD.
    ACCEPT XA1 COLUMN 53 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA1 NOT="Y" GO TE44. DISPLAY " " LINE 8 ERASE END SCREEN.
    PERFORM DSP-QWAIT MOVE 8 TO IXT MOVE 1 TO IXCOL MOVE 0 TO TE-NUM.
    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TE438.
TE43. READ TOOLS NEXT REGARDLESS END GO TE438.
    IF NOT(TS-MAC=TE-MAC AND TS-TOOL(TE-T2)=TE-PART2) GO TE43. ADD 1 TO TE-NUM.
    IF TS-TOOL(TE-T1)>" " AND IXT<=22
      COMPUTE IXU=(IXCOL - 1) * 14 + 1 DISPLAY TS-TOOL(TE-T1) LINE IXT COLUMN IXU
      ADD 1 TO IXCOL IF IXCOL>9 ADD 1 TO IXT MOVE 1 TO IXCOL.
    GO TE43.
TE438. PERFORM DSP-ERS ADD 1 TO IXT IF IXT>23 MOVE 23 TO IXT.
    DISPLAY TE-NUM LINE IXT CONVERSION BOLD "  TOOL LISTS WILL BE MODIFIED" BOLD.

TE44. MOVE 6 TO IXT PERFORM AX-OKW IF XA2 NOT="OK" GO TE89.
    DISPLAY " " LINE 8 ERASE END SCREEN PERFORM DSP-QWAIT.
    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TE48.
TE45. READ TOOLS NEXT REGARDLESS END GO TE48.
    IF NOT(TS-MAC=TE-MAC AND TS-TOOL(TE-T2)=TE-PART2) GO TE45.
    MOVE TS-TOOL(TE-T1) TO TP-TOOL MOVE TS-PROD TO TP-PROD.
    MOVE TS-MAC TO TP-MAC MOVE TE-T1 TO TP-FLD DELETE TOOLPROD INVALID CONTINUE.
    MOVE TE-PART1 TO TS-TOOL(TE-T1).
    IF TE-PART1>" " AND NOT="N/R" MOVE TE-PART1 TO TP-TOOL
      WRITE TP-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK TOOLPROD.
    REWRITE TS-RECORD ALLOWING NO UNLOCK TOOLS GO TE45.
TE48. PERFORM DSP-ERS PERFORM DSP-CONT GO TE41.

TE50. PERFORM RD131E PERFORM WRT.
    MOVE 6 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO TE89.
    PERFORM DSP-QWAIT MOVE 0 TO TE-NUM TE-IXD.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO TE59.
TE53. READ PRODUCT NEXT REGARDLESS END GO TE59. IF NOT(P-CAT>=61 AND<=98) GO TE53.
    MOVE P-NO TO TS-PROD MOVE 0 TO TS-MAC.
    START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TE56.
TE55. READ TOOLS NEXT REGARDLESS END GO TE56. IF TS-PROD NOT=P-NO GO TE56.
    PERFORM TL-SET-TYPE DELETE TOOLS ADD 1 TO TE-NUM MOVE 1 TO TL-IXA.
TE553. IF TS-TOOL(TL-IXA)>" " MOVE TS-TOOL(TL-IXA) TO TP-TOOL
      MOVE TS-PROD TO TP-PROD MOVE TS-MAC TO TP-MAC MOVE TL-IXA TO TP-FLD
      ADD 1 TO TE-IXD DELETE TOOLPROD INVALID CONTINUE.
    ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO TE553. GO TE55.
TE56. IF TE-IXD>50 MOVE 0 TO TE-IXD
       CLOSE TOOLS TOOLPROD OPEN I-O TOOLS ALLOWING ALL TOOLPROD ALLOWING ALL.
    GO TE53.
TE59. PERFORM DSP-ERS DISPLAY TE-NUM LINE 8 CONVERSION "  TOOL LISTS WERE DELETED".
    PERFORM DSP-CONT GO TE89.

TE60. PERFORM RD131F PERFORM WRT.
TE61. ACCEPT TE-MAC LINE 7 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO TE89. IF TE-MAC=0 PERFORM DSP-ERR2 GO TE61.
    DISPLAY "CHECKING THE TOOLS FILE ..." LINE 9.
    PERFORM DSP-QWAIT MOVE 0 TO TE-NUM MOVE " " TO TS-KEY.
    START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TE64.
TE63. READ TOOLS NEXT REGARDLESS END GO TE64. IF TS-MAC=TE-MAC ADD 1 TO TE-NUM.
    GO TE63.
TE64. PERFORM DSP-ERS DISPLAY TE-NUM LINE 9 CONVERSION "  TOOL LISTS WILL BE DELETED".
    MOVE 10 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO TE89.

    DISPLAY "TOOL LISTS DELETED:" LINE 11 BOLD.
    MOVE 13 TO IXT MOVE 1 TO IXU IX1.
    PERFORM DSP-QWAIT MOVE 0 TO TE-NUM TE-IXD MOVE " " TO TS-KEY.
    START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TE66.
TE65. READ TOOLS NEXT REGARDLESS END GO TE66. IF TS-MAC NOT=TE-MAC GO TE65.
    PERFORM TL-SET-TYPE DELETE TOOLS ADD 1 TO TE-NUM.
    IF IXT=22 MOVE 13 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    DISPLAY TS-PROD LINE IXT COLUMN IXU ADD 16 TO IXU ADD 1 TO IX1.
    IF IX1>5 MOVE 1 TO IXU IX1 ADD 1 TO IXT. MOVE 1 TO TL-IXA.
TE653. IF TS-TOOL(TL-IXA)>" " MOVE TS-TOOL(TL-IXA) TO TP-TOOL
      MOVE TS-PROD TO TP-PROD MOVE TS-MAC TO TP-MAC MOVE TL-IXA TO TP-FLD
      ADD 1 TO TE-IXD DELETE TOOLPROD INVALID CONTINUE.
    ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO TE653.
    IF TE-IXD>50 MOVE 0 TO TE-IXD
      CLOSE TOOLS TOOLPROD OPEN I-O TOOLS ALLOWING ALL TOOLPROD ALLOWING ALL.
    GO TE65.
TE66. MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO TE68.
TE67. READ PRODUCT NEXT REGARDLESS END GO TE68.
    IF P-ALT-MAC=TE-MAC MOVE 0 TO P-ALT-MAC REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    GO TE67.
TE68. PERFORM DSP-ERS DISPLAY TE-NUM LINE 23 CONVERSION "  TOOL LISTS WERE DELETED".
    PERFORM DSP-CONT GO TE89.

TE70.
TE71. PERFORM RD131G PERFORM WRT.
TE723. ACCEPT TE-CHAR LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO TE89. IF TE-CHAR=" " PERFORM DSP-ERR2 GO TE723.
TE725. ACCEPT TE-MAC LINE 3 COLUMN 32 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF TE-MAC=0 PERFORM DSP-ERR2 GO TE725.
TE75. ACCEPT TE-N1 LINE 3 COLUMN 66 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ACCEPT TE-N2 LINE 3 COLUMN 77 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF TE-N2<TE-N1 PERFORM DSP-ERR48 GO TE75.
    MOVE " " TO WA1 MOVE TE-CHAR TO WA1(1:1) WA1(10:1) MOVE TE-MAC TO WA1(2:2) WA1(11:2).
    MOVE "-" TO WA1(8:1) MOVE TE-N1 TO WA1(4:3) MOVE TE-N2 TO WA1(13:3).
    DISPLAY WA1(1:15) LINE 6 COLUMN 54 BOLD ERASE END LINE.
    DISPLAY " " LINE 7 COLUMN 48 ERASE END LINE.
    MOVE 9 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO TE89.
    PERFORM DSP-QWAIT MOVE 0 TO TE-NUM.

    PERFORM INIT-BH MOVE TE-CHAR TO BH-NO MOVE TE-MAC TO BH-NO(2:2).
    MOVE TE-N1 TO TE-NSUFFIX.
TE77. MOVE TE-NSUFFIX TO BH-NO(4:3) MOVE BH-NO TO BH-KNO.
    WRITE BH-RECORD ALLOWING NO INVALID GO TE78. UNLOCK PURBIN ADD 1 TO TE-NUM.
TE78. IF TE-NSUFFIX<TE-N2 ADD 1 TO TE-NSUFFIX GO TE77.
    PERFORM DSP-ERS DISPLAY TE-NUM LINE 11 CONVERSION "  BINS WERE ADDED".
    PERFORM DSP-CONT GO TE71.

TE89. PERFORM WRT80 GO TE1.
TE9. GO MN9.

* T-12 SHOW TOOL APPLICATIONS
TA1. PERFORM RD127 MOVE " " TO PH-NO MOVE 3 TO IXT.
TA3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
TA33. DISPLAY "NEXT TOOL NO. ____________" LINE IXT.
    ACCEPT IA25 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA25=ALL "9" GO TA9.
    IF IA25=" " IF PH-NO=" " GO TA33 ELSE GO TA4. MOVE IA25 TO PH-NO.
    START PART KEY>=PH-KEY REGARDLESS INVALID PERFORM DSP-ERR3 GO TA33.
    READ PART NEXT REGARDLESS MOVE 1 TO TA-KFIN.
* note 122.1
    IF PH-NO NOT=IA25 MOVE 0 TO TA-KFIN MOVE IA25 TO PH-NO
      START PART KEY>=PH-KEY REGARDLESS.
    IF TA-KFIN=1 PERFORM PART-TYPE IF NOT PART-TOOL PERFORM DSP-ERR54 GO TA33.
    INITIALIZE TP-KEY MOVE PH-NO TO TP-TOOL MOVE 0 TO INQ-IND.
    MOVE " " TO TA-PROD MOVE 0 TO TA-MAC.
TA4. PERFORM RD127 MOVE PH-NO TO TF480(1).
    IF TA-KFIN=1 PERFORM DRAW-EXP-PH MOVE A-A1 TO TF480(2)
      MOVE PH-DESC1 TO TF481(1) MOVE PH-DESC2 TO TF481(2)
     ELSE MOVE "*** NO RECORD FOR THIS TOOL ***" TO TF481(1).
    MOVE 4 TO IXT IF INQ-IND=0 START TOOLPROD KEY>TP-KEY REGARDLESS INVALID GO TA8.
TA5. READ TOOLPROD NEXT REGARDLESS END GO TA8. IF TP-TOOL NOT=PH-NO GO TA8.
    IF TP-PROD=TA-PROD AND TP-MAC=TA-MAC GO TA5.
    MOVE TP-PROD TO TA-PROD MOVE TP-MAC TO TA-MAC.
    MOVE TP-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO TA5. PERFORM PROD-DESC.
    PERFORM CLR-LN MOVE P-NO TO TF482(IXT) MOVE PRO-DESC(1) TO TF483(IXT).
    MOVE P-CAT TO TF484(IXT) MOVE TP-MAC TO TF485(IXT).
    IF TP-MAC=P-MAC COMPUTE TF486(IXT)=P-ORDER + P-TORDER.
    ADD 1 TO IXT IF IXT<22 GO TA5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO TA89.
TA8. MOVE "*** END ***" TO TLN(IXT).
    READ PART NEXT REGARDLESS END MOVE " " TO PH-NO GO TA89. MOVE 1 TO TA-KFIN.
    MOVE PH-NO TO TP-TOOL MOVE " " TO TP-PROD MOVE 0 TO TP-MAC TP-FLD INQ-IND.
    MOVE " " TO TA-PROD MOVE 0 TO TA-MAC.
TA89. GO TA3.
TA9. GO MN9.

* T-13 SHOW TOOL LISTS DIFFERENCE
TN1. PERFORM WRT132 PERFORM RD146 PERFORM WRT MOVE 0 TO TN-NPAGE TN-MO1 TN-MO2.
TN3. IF TN-NPAGE>0 DISPLAY TN-MO1 LINE 1 COLUMN 40 CONVERSION
       DISPLAY TN-MO2 LINE 1 COLUMN 64 CONVERSION.
TN33. MOVE TN-MO1 TO TN-IMO PERFORM TN-P.
    ACCEPT TN-IMO LINE 1 COLUMN 40 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    DISPLAY TN-IMO LINE 1 COLUMN 40 CONVERSION.
    IF KPF4 OR TN-IMO=999999 GO TN9. IF TN-IMO=0 GO TN33.
    IF TN-NPAGE>0
      IF TN-IMO=9 PERFORM TN-PR GO TN3 END-IF
      IF KPF2 PERFORM TN-N GO TN6 END-IF
      IF TN-IMO>=1 AND<=8 COMPUTE TN-PAGE=TN-IMO - 1 PERFORM TN-N GO TN6.
    MOVE TN-IMO TO TN-MO1 R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO TN33.
    MOVE R-PROD TO TN-PROD1 P-NO DISPLAY P-NO LINE 1 COLUMN 86 BOLD.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TN33.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO TN-PDESC1 DISPLAY TN-PDESC1 LINE 1 COLUMN 100 BOLD.
    MOVE P-MAC TO TN-MAC1 DISPLAY TN-MAC1 LINE 2 COLUMN 30 CONVERSION BOLD.
    MOVE TN-MAC1 TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO TN-MDESC1.
    DISPLAY TN-MDESC1 LINE 2 COLUMN 34.
    MOVE TN-PROD1 TO TS-PROD MOVE TN-MAC1 TO TS-MAC.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TN33.
    PERFORM TL-FIND-TYPE MOVE TL-NTYPE TO TN-MTYPE MOVE TS-RECORD TO TL-LREC.

    PERFORM DSP-ERS.
    DISPLAY LIT-SP(1:12) LINE 2 COLUMN 86 LIT-SP(1:32) COLUMN 100.
    DISPLAY LIT-SP(1:2) LINE 3 COLUMN 30 LIT-SP(1:30) COLUMN 34.
TN43. ACCEPT TN-MO2 LINE 1 COLUMN 64 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    DISPLAY TN-MO2 LINE 1 COLUMN 64 CONVERSION.
    IF KPF4 OR TN-MO2=999999 GO TN9. IF TN-MO2=0 GO TN43.
    MOVE TN-MO2 TO R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO TN43.
    MOVE R-PROD TO TN-PROD2 P-NO DISPLAY P-NO LINE 2 COLUMN 86 BOLD.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TN43.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO TN-PDESC2 DISPLAY TN-PDESC2 LINE 2 COLUMN 100 BOLD.
    MOVE P-MAC TO TN-MAC2 IF TN-MAC2=TN-MAC1 GO TN46.
    DISPLAY TN-MAC2 LINE 3 COLUMN 30 CONVERSION BOLD.
    MOVE TN-MAC2 TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO TN-MDESC2.
    DISPLAY TN-MDESC2 LINE 3 COLUMN 34.
TN46. MOVE TN-PROD2 TO TS-PROD MOVE TN-MAC2 TO TS-MAC.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TN43.
    PERFORM TL-FIND-TYPE.
    IF TL-NTYPE NOT=TN-MTYPE MOVE "THE TWO M.O.'S MUST USE THE SAME MACHINE TYPE"
      TO ERR-MESG PERFORM DSP-ERR GO TN43.

    PERFORM DSP-QWAIT PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF MOVE 0 TO TN-NFLD.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      IF TS-NOTE(IX1)>" " ADD 1 TO TN-NFLD MOVE " " TO XM-F5(TN-NFLD)
        MOVE TS-NOTE(IX1) TO XM-F5(TN-NFLD)(4:) END-IF END-PERFORM.
    MOVE TN-NFLD TO TN-ALINES.
TN5. PERFORM TL-SET-TBL IF TL-SETUP=0 GO TN58.
    IF TS-TOOL(TL-FLD)=" " OR TL-LTOOL(TL-FLD) GO TN58.
    MOVE " " TO TN-DF MOVE TL-DESC TO TN-DF1 MOVE TS-TOOL(TL-FLD) TO TN-DF2 PH-NO.
    IF PH-NO="N/R" GO TN56. READ PART REGARDLESS INVALID GO TN56.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO TN-DF3.
    MOVE 0 TO TN-BTOT TN-KFIR INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO TN54.
TN53. READ PURBIN NEXT REGARDLESS END GO TN54. IF BH-PART NOT=PH-NO GO TN54.
    IF TN-KFIR=0 AND BH-QTY>0 MOVE BH-NO TO TN-DF4 MOVE 1 TO TN-KFIR.
    ADD 1 TO TN-BTOT GO TN53.
TN54. MOVE PH-HAND TO TN-DF5 IF TN-BTOT>1 MOVE TN-BTOT TO TN-DF6.
TN56. IF TN-NFLD<228 ADD 1 TO TN-NFLD MOVE TN-DF TO XM-F5(TN-NFLD).
TN58. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TN5.
    MOVE 1 TO TN-NPAGE IF TN-NFLD>0 COMPUTE TN-NPAGE=(TN-NFLD - 1) / 38 + 1.
    MOVE 1 TO TN-PAGE.

TN6. PERFORM RD146 MOVE TN-PROD1 TO TH96(1) MOVE TN-PDESC1 TO TH97(1).
    MOVE TN-PROD2 TO TH96(2) MOVE TN-PDESC2 TO TH97(2).
    IF TN-NFLD>0 COMPUTE TN-LAST=TN-PAGE * 38 COMPUTE TN-IXP=TN-LAST - 37
      IF TN-LAST>TN-NFLD MOVE TN-NFLD TO TN-LAST.
    MOVE TN-PAGE TO TH98(2) MOVE TN-NPAGE TO TH99(2).
    MOVE TN-MAC1 TO TH100(2) MOVE TN-MDESC1 TO TH101(2).
    IF TN-MAC2 NOT=TN-MAC1 MOVE TN-MAC2 TO TH100(3) MOVE TN-MDESC2 TO TH101(3).
    MOVE 1 TO TN-COL TN-ROW MOVE 5 TO IXT.
    IF TN-NFLD=TN-ALINES MOVE "*** NO TOOL DIFFERENCE ***" TO TH103(IXT)
      ADD 1 TO IXT GO TN64.
TN63. IF TN-COL=1 PERFORM CLR-LN MOVE XM-F5(TN-IXP) TO TH103(IXT)
       ELSE MOVE XM-F5(TN-IXP) TO TH104(IXT).
    ADD 1 TO TN-IXP IXT TN-ROW IF TN-IXP<=TN-LAST
      IF TN-ROW>19 MOVE 2 TO TN-COL MOVE 1 TO TN-ROW MOVE 5 TO IXT END-IF GO TN63.
TN64. IF TN-COL=2 MOVE 24 TO IXT. MOVE "??" TO TLNW(IXT) PERFORM WRT GO TN3.
TN9. PERFORM WRT80 GO MN9.

TN-P. IF TN-NPAGE>1 DISPLAY "- PF2 FOR NEXT PAGE, OR ENTER PAGE NO., OR ENTER '9' TO PRINT" LINE 24 COLUMN 71 BOLD
        ELSE IF TN-NPAGE>0 DISPLAY "- ENTER '9' TO PRINT" LINE 24 COLUMN 112 BOLD.
TN-N. ADD 1 TO TN-PAGE IF TN-PAGE>TN-NPAGE MOVE 1 TO TN-PAGE.

TN-PR. PERFORM TN-PR1 THRU TN-PR9.
TN-PR1. PERFORM DSP-QWAIT PERFORM LAS-SET-FDATE.
    MOVE 2 TO LAS-FLN PERFORM OPEN-LAS PERFORM PCL-INIT PERFORM PCL-START.
    MOVE 1 TO LAS-NPAGE IF TN-NFLD>0 COMPUTE LAS-NPAGE=(TN-NFLD - 1) / 102 + 1.
    MOVE 1 TO LAS-PAGE.
TN-PR3. PERFORM TN-PR-PG.
    IF TN-NFLD>0 COMPUTE TN-LAST=LAS-PAGE * 102 COMPUTE TN-IXP=TN-LAST - 101
      IF TN-LAST>TN-NFLD MOVE TN-NFLD TO TN-LAST.
    PERFORM PCL-NORM3 MOVE 1 TO TN-ROW MOVE 0 TO LAS-COL MOVE 8 TO LAS-ROW.
    IF TN-NFLD=TN-ALINES PERFORM PCL-PCR MOVE "*** NO TOOL DIFFERENCE ***"
      TO LAS-FLD PERFORM LASF GO TN-PR6.
TN-PR5. PERFORM PCL-PCR MOVE XM-F5(TN-IXP) TO LAS-FLD PERFORM LASF.
    ADD 1 TO TN-IXP LAS-ROW TN-ROW IF TN-IXP<=TN-LAST
      IF TN-ROW>51 MOVE 1 TO TN-ROW MOVE 70 TO LAS-COL MOVE 8 TO LAS-ROW END-IF GO TN-PR5.
TN-PR6. ADD 1 TO LAS-PAGE IF LAS-PAGE<=LAS-NPAGE PERFORM PCL-FF GO TN-PR3.
    PERFORM PCL-ENDFL PERFORM CLOSE-LAS.
    MOVE "PRINT1" TO LAS-QUEUE PERFORM PRINT-LAS PERFORM DSP-ERS.
TN-PR9. EXIT.
TN-PR-PG. PERFORM PCL-BOLD1 MOVE 0 TO LAS-ROW LAS-COL PERFORM PCL-PCR.
    MOVE "TOOL LIST DIFFERENCE" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 60 TO LAS-COL PERFORM PCL-PCR.
    MOVE LAS-FDATE TO LAS-FLD PERFORM LASF.
    MOVE LAS-PAGE TO LAS-FPAGE1 MOVE LAS-NPAGE TO LAS-FPAGE2.
    PERFORM PCL-BOLD3 MOVE 122 TO LAS-COL PERFORM PCL-PCR.
    MOVE LAS-FPAGE TO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 3 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    MOVE "FIRST M.O.:" TO LAS-FLD PERFORM LASF.
    ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE "SECOND M.O.:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 3 TO LAS-ROW MOVE 12 TO LAS-COL PERFORM PCL-PCR.
    MOVE TN-MO1 TO FJ-N6 PERFORM LASF.
    ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE TN-MO2 TO FJ-N6 PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 3 TO LAS-ROW MOVE 25 TO LAS-COL PERFORM PCL-PCR.
    MOVE "MACHINE:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 34 TO LAS-COL PERFORM PCL-PCR.
    MOVE TN-MAC1 TO FJ-N2 PERFORM LASF.
    IF TN-MAC2 NOT=TN-MAC1 ADD 1 TO LAS-ROW PERFORM PCL-PCR
      MOVE TN-MAC2 TO FJ-N2 PERFORM LASF.
    PERFORM PCL-ITAL3 MOVE 3 TO LAS-ROW MOVE 38 TO LAS-COL PERFORM PCL-PCR.
    MOVE TN-MDESC1 TO LAS-FLD PERFORM LASF.
    IF TN-MAC2 NOT=TN-MAC1 ADD 1 TO LAS-ROW PERFORM PCL-PCR
      MOVE TN-MDESC2 TO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 3 TO LAS-ROW MOVE 76 TO LAS-COL PERFORM PCL-PCR.
    MOVE "PRODUCTS:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 86 TO LAS-COL PERFORM PCL-PCR.
    MOVE TN-PROD1 TO LAS-FLD PERFORM LASF.
    ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE TN-PROD2 TO LAS-FLD PERFORM LASF.
    PERFORM PCL-ITAL3 MOVE 3 TO LAS-ROW MOVE 100 TO LAS-COL PERFORM PCL-PCR.
    MOVE TN-PDESC1 TO LAS-FLD PERFORM LASF.
    ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE TN-PDESC2 TO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 6 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    PERFORM PCL-UNDY MOVE TN-HD TO LAS-FLD PERFORM LASF PERFORM PCL-UNDN.
    MOVE 70 TO LAS-COL PERFORM PCL-PCR.
    PERFORM PCL-UNDY MOVE TN-HD TO LAS-FLD PERFORM LASF PERFORM PCL-UNDN.

* T-14 SHOW ALTERNATE TOOLS
FB1.
FB3. PERFORM RD186 PERFORM WRT MOVE 22 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      ACCEPT PART-ALT1(IX1) LINE 3 COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY
      IF KPF4 GO FB9 END-IF ADD 5 TO IXU END-PERFORM.
    IF PART-ALT=0 PERFORM DSP-ERR2 GO FB3.
    MOVE 5 TO IXT MOVE 1 TO IXCOL MOVE 0 TO WN1.
    MOVE PART-ALT TO PH-ALT MOVE " " TO PH-KANO.
    START PART KEY>PH-KA REGARDLESS INVALID GO FB6.
FB5. READ PART NEXT REGARDLESS END GO FB6. IF PH-ALT>PART-ALT GO FB6. ADD 1 TO WN1.
    IF IXT<=22 COMPUTE IXU=(IXCOL - 1) * 16 + 1 DISPLAY PH-NO LINE IXT COLUMN IXU.
    ADD 1 TO IXCOL IF IXCOL>5 MOVE 1 TO IXCOL IF IXT<=22 ADD 1 TO IXT. GO FB5.
FB6. IF WN1=0 DISPLAY "NO PARTS FOUND" LINE IXT BOLD.
    PERFORM DSP-CONT GO FB3.
FB9. GO MN9.

* T-15 TOOL FILE MAINTENANCE
TM1. PERFORM WRT132 MOVE " " TO TM-PROD MOVE 0 TO TL-TYPE.
TM3. PERFORM TM-RD.
    ACCEPT TM-PROD LINE 1 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR TM-PROD=ALL "9" GO TM9.
    MOVE TM-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TM3.
    IF P-GEN>" " PERFORM DSP-ERR29 GO TM3.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO TM-DESC MOVE " " TO TM-MSTR.
    MOVE TM-PROD TO TS-PROD MOVE 0 TO TS-MAC MOVE 0 TO TM-IXM.
    START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TM34.
TM33. READ TOOLS NEXT REGARDLESS END GO TM34. IF TS-PROD NOT=TM-PROD GO TM34.
    IF TM-IXM<5 ADD 1 TO TM-IXM MOVE TS-MAC TO TM-MNO(TM-IXM) GO TM33.
TM34. PERFORM INIT-TS MOVE TM-PROD TO TS-PROD MOVE P-MAC TO TS-MAC PERFORM TM-D.
    PERFORM TM-S PERFORM TL-SET-TYPE.
    ACCEPT TS-MAC LINE 1 COLUMN 69 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    IF KPF4 GO TM9. DISPLAY TS-MAC LINE 1 COLUMN 69 CONVERSION.
    PERFORM TM-S PERFORM TL-SET-TYPE MOVE 1 TO TL-SCRN.
* note 111
    READ TOOLS REGARDLESS INVALID MOVE 0 TO TM-KFIN GO TM6. MOVE 1 TO TM-KFIN.

TM5. MOVE 1 TO TXS TL-IXF.
TM53. PERFORM TL-SET-TBL IF TL-PAGE NOT=TL-SCRN GO TM54.
    IF TS-TOOL(TL-FLD)>" " MOVE TL-ROW TO TROW MOVE TL-COL TO TCOL
      MOVE TPOS TO TFLD MOVE 9 TO TLTH PERFORM WRT-F
      MOVE TS-TOOL(TL-FLD) TO TFLD MOVE 12 TO TLTH PERFORM WRT-F.
TM54. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TM53. DISPLAY TSTR(1:TXS - 1).

TM6.
TM63. PERFORM DSP-NEXT PERFORM TM-DP ACCEPT TM-OP LINE 2 COLUMN 97 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO TM9. IF KPF2 PERFORM TM-P GO TM5.
    IF TM-OP=0 GO TM3. IF TM-OP>4 PERFORM DSP-ERR1 GO TM63.
    MOVE TS-RECORD TO TL-LREC.
* note 116
    IF TM-OP=1
      IF TM-KFIN=0 WRITE TS-RECORD ALLOWING NO UNLOCK TOOLS
        IF TM-IXM<5 ADD 1 TO TM-IXM MOVE TS-MAC TO TM-MNO(TM-IXM) END-IF
        MOVE 2 TO TM-OP MOVE 1 TO TM-KFIN GO TM8
       ELSE MOVE "DUPLICATE TOOL LIST FOR THIS PRODUCT-MACHINE" TO ERR-MESG
        PERFORM DSP-ERR GO TM3.
    IF (TM-OP=2 OR 3 OR 4) AND TM-KFIN=0 MOVE "TOOL LIST NOT FOUND" TO ERR-MESG
      PERFORM DSP-ERR GO TM3.
    IF TM-OP=2 GO TM8.
    IF TM-OP=3 PERFORM DSP-SURE
      IF XA3="YES" DELETE TOOLS PERFORM TM-A
        ELSE MOVE "** NOT DELETED **" TO TMSG PERFORM DSP-MSGCONT END-IF GO TM3.
* op=4
    MOVE TS-PROD TO TM-SPROD MOVE TS-MAC TO TM-SMAC.
    DISPLAY "ENTER PRODUCT-MACHINE COMBINATION TO COPY: ____________ - __" LINE 24 BOLD.
    ACCEPT TS-PROD LINE 24 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE TS-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TM3.
    ACCEPT TS-MAC LINE 24 COLUMN 59 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    PERFORM TL-FIND-TYPE IF TL-NTYPE NOT=TL-TYPE
      MOVE "MACHINE MUST BE THE SAME TYPE" TO ERR-MESG PERFORM DSP-ERR GO TM3.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TM3.
    MOVE TM-SPROD TO TS-PROD MOVE TM-SMAC TO TS-MAC.
    REWRITE TS-RECORD ALLOWING NO UNLOCK TOOLS PERFORM TM-A GO TM5.

TM8.
TM81. MOVE 1 TO TL-IXF.
TM83. PERFORM TL-SET-TBL IF TL-PAGE NOT=TL-SCRN GO TM84.
    DISPLAY "- PF3 TO END" LINE 24 COLUMN 92 BOLD PERFORM TM-DP.
    ACCEPT TS-TOOL(TL-FLD) LINE TL-ROW COLUMN TL-COL DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF2 OR KPF3 GO TM88. IF KP-UP GO TM842. IF KP-DOWN GO TM844.
TM84. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TM83. GO TM81.
TM842. MOVE TL-ROW TO TM-ROW MOVE 0 TO TM-KR.
TM8423. SUBTRACT 1 FROM TL-IXF IF TL-IXF=0 GO TM81.
    PERFORM TL-SET-TBL IF TL-PAGE NOT=TL-SCRN GO TM8423.
    IF TL-ROW=TM-ROW GO TM8423.
    IF TM-KR=0 MOVE TL-ROW TO TM-ROW MOVE 1 TO TM-KR GO TM8423.
    ADD 1 TO TL-IXF GO TM83.
TM844. MOVE TL-ROW TO TM-ROW.
TM8443. ADD 1 TO TL-IXF IF TL-IXF>TL-NUM GO TM81.
    PERFORM TL-SET-TBL IF TL-PAGE NOT=TL-SCRN GO TM8443.
    IF TL-ROW=TM-ROW GO TM8443. GO TM83.
TM88. REWRITE TS-RECORD ALLOWING NO UNLOCK TOOLS PERFORM TM-A.
    IF KPF2 PERFORM TM-P GO TM5. GO TM3.
TM9. PERFORM WRT80 GO MN9.

TM-A. IF TM-OP=3 MOVE 0 TO A-N1 ELSE MOVE 1 TO A-N1. PERFORM TL-TP-UPDATE.
* op can be 2,3,4
TM-RD. MOVE 1 TO TL-SCRN PERFORM TL-RD-SCRN PERFORM WRT.
TM-S. PERFORM TL-FIND-TYPE.
    IF TL-NTYPE NOT=TL-TYPE MOVE TL-NTYPE TO TL-TYPE PERFORM TM-RD PERFORM TM-D.
TM-DP. IF TL-NS>1 DISPLAY "- PF2 FOR NEXT PAGE" LINE 24 COLUMN 113 BOLD.
TM-P. ADD 1 TO TL-SCRN IF TL-SCRN>TL-NS MOVE 1 TO TL-SCRN.
    PERFORM TL-RD-SCRN PERFORM WRT PERFORM TM-D.
TM-D. DISPLAY TS-PROD LINE 1 COLUMN 11 TM-DESC COLUMN 25
       TS-MAC COLUMN 69 CONVERSION TM-MSTR COLUMN 95.

* T-16 SHOW TOOL LIST
TQ1. PERFORM WRT132 PERFORM RD143 PERFORM WRT MOVE 0 TO TQ-NPAGE TQ-MO.
TQ3. MOVE 0 TO TQ-IMO.
    DISPLAY "TO INQUIRE BY M.O., LEAVE PRODUCT BLANK" LINE 24 BOLD.
    IF TQ-NPAGE>1 DISPLAY "- PF2 FOR NEXT PAGE, OR ENTER PAGE NO., OR ENTER '9' TO PRINT OR 'E' TO EXPORT" LINE 24 COLUMN 54 BOLD
      ELSE IF TQ-NPAGE>0 DISPLAY "- ENTER '9' TO PRINT OR 'E' TO EXPORT" LINE 24 COLUMN 95 BOLD.
    ACCEPT TQ-IPROD LINE 1 COLUMN 107 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR TQ-IPROD=ALL "9" GO TQ9.
    IF TQ-NPAGE>0
      IF KPF2 PERFORM TQ-N GO TQ6 END-IF
      IF TQ-IPROD(2:)=" " MOVE TQ-IPROD TO TQ-PA
        IF TQ-PA="E" PERFORM TQ-EXP GO TQ3 END-IF
        IF TQ-PN NUMERIC IF TQ-PN=9 PERFORM TQ-PR GO TQ3 END-IF
          IF TQ-PN>=1 AND<=8 COMPUTE TQ-PAGE=TQ-PN - 1 PERFORM TQ-N GO TQ6.
    IF TQ-IPROD>" " MOVE TQ-IPROD TO TQ-PROD GO TQ46.

TQ43. DISPLAY "TO INQUIRE BY PRODUCT, LEAVE M.O. BLANK" LINE 24 BOLD.
    IF TQ-NPAGE>1 DISPLAY "- PF2 FOR NEXT PAGE, OR ENTER PAGE NO., OR ENTER '9' TO PRINT" LINE 24 COLUMN 71 BOLD
      ELSE IF TQ-NPAGE>0 DISPLAY "- ENTER '9' TO PRINT" LINE 24 COLUMN 112 BOLD.
    ACCEPT TQ-IMO LINE 2 COLUMN 107 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR TQ-IMO=999999 GO TQ9.
    IF TQ-NPAGE>0
      IF KPF2 PERFORM TQ-N GO TQ6 END-IF
      IF TQ-IMO=9 PERFORM TQ-PR GO TQ3 END-IF
      IF TQ-IMO>=1 AND<=8 COMPUTE TQ-PAGE=TQ-IMO - 1 PERFORM TQ-N GO TQ6.
    IF TQ-IMO=0 GO TQ3.
    MOVE TQ-IMO TO R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO TQ43.
    DISPLAY TQ-IMO LINE 2 COLUMN 77 CONVERSION.
    MOVE R-PROD TO TQ-PROD DISPLAY TQ-PROD LINE 1 COLUMN 107.

TQ46. MOVE TQ-IMO TO TQ-MO.
    MOVE TQ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TQ3.
    MOVE P-MAC TO TQ-MAC DISPLAY TQ-MAC LINE 1 COLUMN 130 CONVERSION.
    IF TQ-MO=0 ACCEPT TQ-MAC LINE 1 COLUMN 130 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY TQ-MAC LINE 1 COLUMN 130 CONVERSION.
    MOVE TQ-PROD TO TS-PROD MOVE TQ-MAC TO TS-MAC.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TQ3.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO TQ-PDESC.
    MOVE TQ-MAC TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO TQ-MDESC.

    PERFORM DSP-QWAIT PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF MOVE 0 TO TQ-NFLD.
    IF TS-PLNUM>" " ADD 1 TO TQ-NFLD MOVE "PL NO.:" TO XM-F1(TQ-NFLD)
      MOVE TS-PLNUM TO XM-F1(TQ-NFLD)(9:).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      IF TS-NOTE(IX1)>" " ADD 1 TO TQ-NFLD MOVE " " TO XM-F1(TQ-NFLD)
        MOVE TS-NOTE(IX1) TO XM-F1(TQ-NFLD)(4:) END-IF END-PERFORM.
    MOVE TQ-NFLD TO TQ-ALINES.
TQ5. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " AND TL-MAND=0 GO TQ58.
    MOVE " " TO TQ-DF MOVE TL-DESC TO TQ-DF1 MOVE TS-TOOL(TL-FLD) TO TQ-DF2 PH-NO.
    IF PH-NO=" " MOVE "** NOT SPECIFIED **" TO TQ-DF11 GO TQ56.
    IF PH-NO="N/R" GO TQ56. READ PART REGARDLESS INVALID GO TQ56.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO TQ-DF3.
    MOVE 0 TO TQ-BTOT TQ-KFIR INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO TQ54.
TQ53. READ PURBIN NEXT REGARDLESS END GO TQ54. IF BH-PART NOT=PH-NO GO TQ54.
    IF TQ-KFIR=0 AND BH-QTY>0 MOVE BH-NO TO TQ-DF4 MOVE 1 TO TQ-KFIR.
    ADD 1 TO TQ-BTOT GO TQ53.
TQ54. MOVE PH-HAND TO TQ-DF5 IF TQ-BTOT>1 MOVE TQ-BTOT TO TQ-DF6.
TQ56. IF TQ-NFLD<228 ADD 1 TO TQ-NFLD MOVE TQ-DF TO XM-F1(TQ-NFLD).
TQ58. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TQ5.
    MOVE 1 TO TQ-NPAGE IF TQ-NFLD>0 COMPUTE TQ-NPAGE=(TQ-NFLD - 1) / 38 + 1.
    MOVE 1 TO TQ-PAGE.

TQ6. PERFORM RD143 MOVE TQ-PROD TO TH11(1) MOVE TQ-PDESC TO TH17(2).
    MOVE TQ-MAC TO TH12(1) MOVE TQ-MDESC TO TH13(1).
    IF TQ-MO>0 MOVE TQ-MO TO TH18(2).
    IF TQ-NFLD>0 COMPUTE TQ-LAST=TQ-PAGE * 38 COMPUTE TQ-IXP=TQ-LAST - 37
      IF TQ-LAST>TQ-NFLD MOVE TQ-NFLD TO TQ-LAST.
    MOVE TQ-PAGE TO TH14(2) MOVE TQ-NPAGE TO TH15(2).
    MOVE 1 TO TQ-COL TQ-ROW MOVE 5 TO IXT IF TQ-NFLD=0 GO TQ64.
TQ63. IF TQ-COL=1 PERFORM CLR-LN MOVE XM-F1(TQ-IXP) TO TH19(IXT)
       ELSE MOVE XM-F1(TQ-IXP) TO TH20(IXT).
    ADD 1 TO TQ-IXP IXT TQ-ROW IF TQ-IXP<=TQ-LAST
      IF TQ-ROW>19 MOVE 2 TO TQ-COL MOVE 1 TO TQ-ROW MOVE 5 TO IXT END-IF GO TQ63.
TQ64. IF TQ-COL=2 MOVE 24 TO IXT. MOVE "??" TO TLNW(IXT) PERFORM WRT GO TQ3.
TQ9. PERFORM WRT80 GO MN9.

TQ-N. ADD 1 TO TQ-PAGE IF TQ-PAGE>TQ-NPAGE MOVE 1 TO TQ-PAGE.
TQ-EXP. PERFORM TQ-E1 THRU TQ-E9.
TQ-E1. DISPLAY "ENTER EXPORT FILE NO. __" LINE 24 BOLD.
    ACCEPT PR-NUM COLUMN 23 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM DSP-QWAIT MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE TQ-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN MOVE 1 TO TQ-IXP.
TQ-E3. MOVE TQ-PROD TO EXP-A PERFORM EXPF MOVE TQ-MAC TO EXP-N PERFORM EXPF.
    MOVE XM-F1(TQ-IXP) TO TQ-DF.
    IF TQ-IXP<=TQ-ALINES
      MOVE TQ-DF TO EXP-A PERFORM EXPF MOVE 5 TO A-N1 PERFORM EXPFN GO TQ-E4.
    MOVE TQ-DF(1:20) TO EXP-A PERFORM EXPF MOVE TQ-DF(23:12) TO EXP-A PERFORM EXPF.
    IF TQ-DF11="** NOT SPECIFIED **"
      MOVE TQ-DF11 TO EXP-A PERFORM EXPF MOVE 3 TO A-N1 PERFORM EXPFN GO TQ-E4.
    MOVE TQ-DF(36:14) TO EXP-A PERFORM EXPF MOVE TQ-DF(51:6) TO EXP-A PERFORM EXPF.
    MOVE TQ-DF(58:4) TO EXP-A PERFORM EXPF MOVE TQ-DF(63:1) TO EXP-A PERFORM EXPF.
TQ-E4. PERFORM EXP-LINE ADD 1 TO TQ-IXP IF TQ-IXP<=TQ-NFLD GO TQ-E3.
    PERFORM CLOSE-EXP PERFORM DSP-ERS.
TQ-E9. EXIT.

TQ-PR. PERFORM TQ-PR1 THRU TQ-PR9.
TQ-PR1. PERFORM DSP-QWAIT PERFORM LAS-SET-FDATE.
    MOVE 2 TO LAS-FLN PERFORM OPEN-LAS PERFORM PCL-INIT PERFORM PCL-START.
    MOVE 1 TO LAS-NPAGE IF TQ-NFLD>0 COMPUTE LAS-NPAGE=(TQ-NFLD - 1) / 102 + 1.
    MOVE 1 TO LAS-PAGE.
TQ-PR3. PERFORM TQ-PR-PG.
    IF TQ-NFLD>0 COMPUTE TQ-LAST=LAS-PAGE * 102 COMPUTE TQ-IXP=TQ-LAST - 101
      IF TQ-LAST>TQ-NFLD MOVE TQ-NFLD TO TQ-LAST.
    PERFORM PCL-NORM3 MOVE 1 TO TQ-ROW MOVE 0 TO LAS-COL MOVE 8 TO LAS-ROW.
TQ-PR5. PERFORM PCL-PCR MOVE XM-F1(TQ-IXP) TO LAS-FLD PERFORM LASF.
    ADD 1 TO TQ-IXP LAS-ROW TQ-ROW IF TQ-IXP<=TQ-LAST
      IF TQ-ROW>51 MOVE 1 TO TQ-ROW MOVE 70 TO LAS-COL MOVE 8 TO LAS-ROW END-IF GO TQ-PR5.
    ADD 1 TO LAS-PAGE IF LAS-PAGE<=LAS-NPAGE PERFORM PCL-FF GO TQ-PR3.
    PERFORM PCL-ENDFL PERFORM CLOSE-LAS.
    MOVE "PRINT1" TO LAS-QUEUE PERFORM PRINT-LAS PERFORM DSP-ERS.
TQ-PR9. EXIT.
TQ-PR-PG. PERFORM PCL-BOLD1 MOVE 0 TO LAS-ROW LAS-COL PERFORM PCL-PCR.
    MOVE "TOOL LIST" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 60 TO LAS-COL PERFORM PCL-PCR.
    MOVE LAS-FDATE TO LAS-FLD PERFORM LASF.
    MOVE LAS-PAGE TO LAS-FPAGE1 MOVE LAS-NPAGE TO LAS-FPAGE2.
    PERFORM PCL-BOLD3 MOVE 122 TO LAS-COL PERFORM PCL-PCR.
    MOVE LAS-FPAGE TO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 3 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    MOVE "PRODUCT:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 9 TO LAS-COL PERFORM PCL-PCR.
    MOVE TQ-PROD TO LAS-FLD PERFORM LASF.
    PERFORM PCL-ITAL3 MOVE 23 TO LAS-COL PERFORM PCL-PCR.
    MOVE TQ-PDESC TO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 3 TO LAS-ROW MOVE 65 TO LAS-COL PERFORM PCL-PCR.
    MOVE "MACHINE:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 74 TO LAS-COL PERFORM PCL-PCR.
    MOVE TQ-MAC TO FJ-N2 PERFORM LASF.
    PERFORM PCL-ITAL3 MOVE 78 TO LAS-COL PERFORM PCL-PCR.
    MOVE TQ-MDESC TO LAS-FLD PERFORM LASF.

    IF TQ-MO>0 PERFORM PCL-BOLD3 MOVE 3 TO LAS-ROW MOVE 120 TO LAS-COL PERFORM PCL-PCR
      MOVE "M.O.:" TO LAS-FLD PERFORM LASF
      PERFORM PCL-NORM3 MOVE 125 TO LAS-COL PERFORM PCL-PCR
      MOVE TQ-MO TO FJ-N6 PERFORM LASF.

    PERFORM PCL-BOLD3 MOVE 6 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    PERFORM PCL-UNDY MOVE TQ-HD TO LAS-FLD PERFORM LASF PERFORM PCL-UNDN.
    MOVE 70 TO LAS-COL PERFORM PCL-PCR.
    PERFORM PCL-UNDY MOVE TQ-HD TO LAS-FLD PERFORM LASF PERFORM PCL-UNDN.

* T-17 ASSEMBLY INFORMATION
FS1. PERFORM RD187 PERFORM WRT.
FS3. ACCEPT PH-NO LINE 1 COLUMN 68 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR PH-NO=ALL "9" GO FS9.
    READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO FS3.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=1) PERFORM DSP-ERR53 GO FS3.
    PERFORM DSP-QWAIT.
    PERFORM RD187 MOVE PH-NO TO TF499(1) MOVE PH-DESC1 TO TF500(2).
    MOVE PH-NOTE(1) TO TF498(4) MOVE PH-NOTE(2) TO TF498(5).
    MOVE 0 TO FS-NUM MOVE 6 TO IXT.
    MOVE PH-NO TO A-A1 PERFORM TL-SET-ASM IF A-S1=1 GO FS58. MOVE 1 TO TL-IXF.
FS5. IF FS-NUM=15 GO FS58. PERFORM TL-SET-TBL.
    IF NOT(TL-PAGE>0 AND TL-STN=TL-ASTN AND TL-CAT=TL-ACAT) GO FS56.
    MOVE " " TO FS-DF MOVE TL-DESC TO FS-DF1 MOVE TS-TOOL(TL-FLD) TO FS-DF2 PH-NO.
    IF PH-NO=" " OR "N/R" GO FS56. READ PART REGARDLESS INVALID GO FS56.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO FS-DF3.
    MOVE 0 TO FS-BTOT FS-KFIR INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO FS54.
FS53. READ PURBIN NEXT REGARDLESS END GO FS54. IF BH-PART NOT=PH-NO GO FS54.
    IF FS-KFIR=0 AND BH-QTY>0 MOVE BH-NO TO FS-DF4 MOVE 1 TO FS-KFIR.
    ADD 1 TO FS-BTOT GO FS53.
FS54. MOVE PH-HAND TO FS-DF5 IF FS-BTOT>1 MOVE FS-BTOT TO FS-DF6.
    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO FS544.
FS543. READ PURLIN NEXT REGARDLESS END GO FS544. IF LK-PART NOT=PH-NO GO FS544.
    COMPUTE WN1=LK-QTY - LK-QTY-REC IF LK-QTY<0 OR WN1<=0 GO FS543.
    MOVE WN1 TO FS-DF7 MOVE LK-ORD TO FS-DF8.
FS544. ADD 1 TO FS-NUM IXT MOVE FS-DF TO TLN(IXT).
FS56. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO FS5.
FS58. IF FS-NUM=0 ADD 1 TO IXT MOVE "** NO TOOLS **" TO TLN(IXT).
    PERFORM DSP-ERS MOVE "??" TO TLN(IXT + 1) PERFORM WRT GO FS3.
FS9. GO MN9.

* T-18 SHOW TOOL SHORTAGE
TJ1. PERFORM WRT132 PERFORM RD144 PERFORM WRT MOVE 0 TO TJ-NPAGE.
TJ3. MOVE 0 TO TJ-MO DISPLAY LIT-SP(1:6) LINE 2 COLUMN 77.
    DISPLAY "TO INQUIRE BY M.O., LEAVE PRODUCT BLANK" LINE 24 BOLD.
    PERFORM TJ-P.
    ACCEPT TJ-IPROD LINE 1 COLUMN 107 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR TJ-IPROD=ALL "9" GO TJ9.
    IF TJ-NPAGE>0
      IF KPF2 PERFORM TJ-N GO TJ6 END-IF
      IF TJ-IPROD(2:)=" " MOVE TJ-IPROD TO TJ-PA
        IF TJ-PN NUMERIC AND TJ-PN>=1 AND<=9 COMPUTE TJ-PAGE=TJ-PN - 1 PERFORM TJ-N GO TJ6.
    IF TJ-IPROD>" " MOVE TJ-IPROD TO TJ-PROD GO TJ46.

TJ43. DISPLAY "TO INQUIRE BY PRODUCT, LEAVE M.O. BLANK" LINE 24 BOLD.
    PERFORM TJ-P.
    ACCEPT TJ-IMO LINE 2 COLUMN 107 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR TJ-IMO=999999 GO TJ9.
    IF TJ-NPAGE>0
      IF KPF2 PERFORM TJ-N GO TJ6 END-IF
      IF TJ-IMO>=1 AND<=9 AND TJ-NPAGE>0 COMPUTE TJ-PAGE=TJ-IMO - 1 PERFORM TJ-N GO TJ6.
    IF TJ-IMO=0 GO TJ3.
    MOVE TJ-IMO TO TJ-MO R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO TJ43.
    DISPLAY TJ-MO LINE 2 COLUMN 77 CONVERSION.
    MOVE R-PROD TO TJ-PROD DISPLAY TJ-PROD LINE 1 COLUMN 107.

TJ46. MOVE TJ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO TJ3.
    MOVE P-MAC TO TJ-MAC DISPLAY TJ-MAC LINE 1 COLUMN 130 CONVERSION.
    IF TJ-MO=0 ACCEPT TJ-MAC LINE 1 COLUMN 130 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY TJ-MAC LINE 1 COLUMN 130 CONVERSION.
    MOVE TJ-PROD TO TS-PROD MOVE TJ-MAC TO TS-MAC.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TJ3.
    PERFORM TL-SET-TYPE PERFORM VARYING TL-IXA FROM 1 BY 1 UNTIL TL-IXA>TL-NUM
      IF TS-TOOL(TL-IXA)>" " AND NOT="N/R" GO TJ48 END-IF END-PERFORM.
    MOVE "THERE ARE NO TOOLS IN THIS TOOL LIST" TO ERR-MESG PERFORM DSP-ERR GO TJ3.
TJ48. PERFORM PROD-DESC MOVE PRO-DESC(1) TO TJ-PDESC.
    MOVE TJ-MAC TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO TJ-MDESC.

    PERFORM DSP-QWAIT PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF MOVE 0 TO TJ-NLINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      IF TS-NOTE(IX1)>" " ADD 1 TO TJ-NLINE MOVE " " TO XM-F2(TJ-NLINE)
        MOVE TS-NOTE(IX1) TO XM-F2(TJ-NLINE)(4:) END-IF END-PERFORM.
TJ5. PERFORM TL-SET-TBL.
    IF TS-TOOL(TL-FLD)="N/R" OR TS-TOOL(TL-FLD)=" " AND TL-SETUP=0 GO TJ58.
    MOVE " " TO TJ-DF MOVE TL-DESC TO TJ-DF1 MOVE TS-TOOL(TL-FLD) TO TJ-DF2 PH-NO.
    IF PH-NO=" " MOVE "** NOT SPECIFIED **" TO TJ-DF11 GO TJ56.
    READ PART REGARDLESS INVALID MOVE "** NO TOOL RECORD **" TO TJ-DF11 GO TJ56.
    MOVE 0 TO WN1 INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO TJ52.
TJ51. READ PURBIN NEXT REGARDLESS END GO TJ52. IF BH-PART NOT=PH-NO GO TJ52.
    IF BH-NO(1:1)="X" ADD BH-QTY TO WN1. GO TJ51.
TJ52. MOVE PH-DEMAND TO TJ-MIN IF PH-ASM=1 MOVE PH-ROP TO TJ-MIN.
    IF NOT(PH-HAND - WN1<TJ-MIN) GO TJ58.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO TJ-DF3.
    MOVE PH-HAND TO TJ-DF4 MOVE TJ-MIN TO TJ-DF5.
    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO TJ56.
TJ53. READ PURLIN NEXT REGARDLESS END GO TJ56. IF LK-PART NOT=PH-NO GO TJ56.
    COMPUTE WN1=LK-QTY - LK-QTY-REC IF LK-QTY<0 OR WN1<=0 GO TJ53. MOVE WN1 TO TJ-DF7.
    MOVE LK-ORD TO OK-NO TJ-DF6 READ PURORD REGARDLESS INVALID GO TJ56.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO TJ-DF8.
    MOVE OK-VENDOR TO TJ-DF9 A-N1 PERFORM RD-VEN MOVE V-NAME TO TJ-DF10.
TJ56. IF TJ-NLINE<171 ADD 1 TO TJ-NLINE MOVE TJ-DF TO XM-F2(TJ-NLINE).
TJ58. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TJ5.
    IF TJ-NLINE=0 MOVE 1 TO TJ-NLINE MOVE "** NO TOOLS ARE SHORT **" TO XM-F2(TJ-NLINE).
    COMPUTE TJ-NPAGE=(TJ-NLINE - 1) / 19 + 1 MOVE 1 TO TJ-PAGE.

TJ6. PERFORM RD144 MOVE TJ-PAGE TO TH24(2) MOVE TJ-NPAGE TO TH25(2).
    MOVE TJ-PROD TO TH21(1) MOVE TJ-PDESC TO TH27(2).
    MOVE TJ-MAC TO TH22(1) MOVE TJ-MDESC TO TH23(1).
    IF TJ-MO>0 MOVE TJ-MO TO TH28(2).
    COMPUTE TJ-LAST=TJ-PAGE * 19 COMPUTE TJ-IXP=TJ-LAST - 18.
    IF TJ-LAST>TJ-NLINE MOVE TJ-NLINE TO TJ-LAST. MOVE 5 TO IXT.
TJ63. MOVE XM-F2(TJ-IXP) TO TLNW(IXT) ADD 1 TO TJ-IXP IXT IF TJ-IXP<=TJ-LAST GO TJ63.
    MOVE "??" TO TLNW(IXT) PERFORM WRT GO TJ3.
TJ9. PERFORM WRT80 GO MN9.

TJ-P. IF TJ-NPAGE>1 DISPLAY "- TO SEE ANOTHER PAGE: ENTER PAGE NO. OR PRESS PF2 FOR NEXT PAGE" LINE 24 COLUMN 68 BOLD.
TJ-N. ADD 1 TO TJ-PAGE IF TJ-PAGE>TJ-NPAGE MOVE 1 TO TJ-PAGE.

* T-19 SHOW TOOLS BY DRAWING NUMBER
DQ1. PERFORM WRT132 PERFORM RD145 MOVE " " TO DQ-DRAW MOVE 3 TO IXT.
DQ3. MOVE "??" TO TLNW(IXT + 1) PERFORM WRT.
DQ33. DISPLAY "NEXT DRAWING: ____________" LINE IXT.
    DISPLAY "ENTER A DRAWING NO. OR THE BEGINNING OF A DRAWING NO." LINE 24 BOLD.
    ACCEPT IA28 LINE IXT COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR IA28=ALL "9" GO DQ9.
    IF IA28=" " IF DQ-DRAW=" " GO DQ33 ELSE GO DQ4. MOVE IA28 TO DQ-DRAW A-A1.
    PERFORM STR-LTH MOVE A-N1 TO DQ-LTH.
    MOVE DQ-DRAW TO PH-DRAW MOVE 0 TO INQ-IND.
DQ4. PERFORM RD145 MOVE DQ-DRAW TO TH57(1).
    MOVE 4 TO IXT IF INQ-IND=0 START PART KEY>=PH-KD REGARDLESS INVALID GO DQ8.
DQ5. READ PART NEXT REGARDLESS END GO DQ8. IF PH-DRAW(1:DQ-LTH) NOT=DQ-DRAW GO DQ8.
    PERFORM CLR-LN MOVE PH-NO TO TH58(IXT).
    MOVE PH-ALT TO PART-ALT PERFORM SET-PALT MOVE PART-PRINT TO TH58A(IXT).
    PERFORM DRAW-EXP-PH MOVE A-A2 TO TH59(IXT).
    MOVE PH-DESC1 TO TH60(IXT) MOVE PH-HAND TO TH61(IXT).
    MOVE PH-ORDER TO TH62(IXT) MOVE PH-DEMAND TO TH63(IXT).
    MOVE PH-LIFE TO TH64(IXT) MOVE PH-ROP TO TH65(IXT) MOVE PH-EOQ TO TH66(IXT).
    ADD 1 TO IXT IF IXT<22 GO DQ5.
    MOVE "*** MORE ***" TO TLNW(IXT) MOVE 1 TO INQ-IND GO DQ89.
DQ8. MOVE "*** END ***" TO TLNW(IXT).
    MOVE " " TO DQ-DRAW MOVE 0 TO INQ-IND.
DQ89. GO DQ3.
DQ9. PERFORM WRT80 GO MN9.

* M: METALLURGICAL TEST, QA, AND PACKING LABELS FUNCTIONS

* M-1 HEAT FILE MAINTENANCE
HM1.
HM3. PERFORM RD212 PERFORM WRT.
    ACCEPT HM-HEAT LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR HM-HEAT=ALL "9" GO HM9. IF HM-HEAT=" " PERFORM DSP-ERR18 GO HM3.
    ACCEPT HM-OP LINE 3 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF HM-OP=9 GO HM9.
    GO HM40 HM50 HM60  DEPENDING HM-OP. PERFORM DSP-ERR1 GO HM3.
HM40. MOVE LOW-VALUES TO HE-RECORD INITIALIZE HE-REC MOVE HM-HEAT TO HE-NO.
    START HEAT REGARDLESS INVALID GO HM42.
    MOVE "DUPLICATE HEAT NO." TO ERR-MESG PERFORM DSP-ERR GO HM3.
    REPLACE ==ACC-ALP== BY ==DEFAULT " " UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
HM42. PERFORM RD213 MOVE HE-NO TO TF518(3).
    MOVE 1 TO IX1 MOVE 7 TO IXT PERFORM UNTIL IX1>15
      MOVE CHM-DESC(IX1) TO TF519(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    PERFORM WRT.
    ACCEPT HE-GRADE LINE 5 COLUMN 9 ACC-ALP.
    ACCEPT HE-DIVAL LINE 5 COLUMN 33 ACC-NUM.
    ACCEPT HE-C LINE 7 COLUMN 17 ACC-NUM.
    ACCEPT HE-MN LINE 8 COLUMN 17 ACC-NUM.
    ACCEPT HE-P LINE 9 COLUMN 17 ACC-NUM.
    ACCEPT HE-S LINE 10 COLUMN 17 ACC-NUM.
    ACCEPT HE-SI LINE 11 COLUMN 17 ACC-NUM.
    ACCEPT HE-CU LINE 12 COLUMN 17 ACC-NUM.
    ACCEPT HE-NI LINE 13 COLUMN 17 ACC-NUM.
    ACCEPT HE-CR LINE 14 COLUMN 17 ACC-NUM.
    ACCEPT HE-MO LINE 15 COLUMN 17 ACC-NUM.
    ACCEPT HE-SN LINE 16 COLUMN 17 ACC-NUM.
    ACCEPT HE-AL LINE 17 COLUMN 17 ACC-NUM.
    ACCEPT HE-B LINE 18 COLUMN 17 ACC-NUM.
    ACCEPT HE-V LINE 19 COLUMN 17 ACC-NUM.
    ACCEPT HE-CO LINE 20 COLUMN 17 ACC-NUM.
    ACCEPT HE-N LINE 21 COLUMN 17 ACC-NUM.
    MOVE SYS-DATE TO HE-DATE.
    WRITE HE-RECORD ALLOWING NO UNLOCK HEAT GO HM3.
    REPLACE OFF.
HM50. MOVE HM-HEAT TO HE-NO READ HEAT REGARDLESS INVALID PERFORM DSP-ERR18 GO HM3.
    PERFORM RD214 MOVE HE-NO TO TF510(3) PERFORM WRT PERFORM RD214A PERFORM WRT.
HM53. ACCEPT HM-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO HM551 HM552 HM553 HM554 HM555 HM556 HM557 HM558 HM559 HM5510
       HM5511 HM5512 HM5513 HM5514 HM5515 HM5516 HM5517 HM5518
      DEPENDING HM-FLD. GO HM3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
HM551. DISPLAY HE-C COLUMN 30 CONVERSION BOLD ACCEPT HE-C ACC-NUM.
    MOVE HE-C TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-C GO HM58.
HM552. DISPLAY HE-MN COLUMN 30 CONVERSION BOLD ACCEPT HE-MN ACC-NUM.
    MOVE HE-MN TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-MN GO HM58.
HM553. DISPLAY HE-P COLUMN 30 CONVERSION BOLD ACCEPT HE-P ACC-NUM.
    MOVE HE-P TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-P GO HM58.
HM554. DISPLAY HE-S COLUMN 30 CONVERSION BOLD ACCEPT HE-S ACC-NUM.
    MOVE HE-S TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-S GO HM58.
HM555. DISPLAY HE-SI COLUMN 30 CONVERSION BOLD ACCEPT HE-SI ACC-NUM.
    MOVE HE-SI TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-SI GO HM58.
HM556. DISPLAY HE-CU COLUMN 30 CONVERSION BOLD ACCEPT HE-CU ACC-NUM.
    MOVE HE-CU TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-CU GO HM58.
HM557. DISPLAY HE-NI COLUMN 30 CONVERSION BOLD ACCEPT HE-NI ACC-NUM.
    MOVE HE-NI TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-NI GO HM58.
HM558. DISPLAY HE-CR COLUMN 30 CONVERSION BOLD ACCEPT HE-CR ACC-NUM.
    MOVE HE-CR TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-CR GO HM58.
HM559. DISPLAY HE-MO COLUMN 30 CONVERSION BOLD ACCEPT HE-MO ACC-NUM.
    MOVE HE-MO TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-MO GO HM58.
HM5510. DISPLAY HE-SN COLUMN 30 CONVERSION BOLD ACCEPT HE-SN ACC-NUM.
    MOVE HE-SN TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-SN GO HM58.
HM5511. DISPLAY HE-AL COLUMN 30 CONVERSION BOLD ACCEPT HE-AL ACC-NUM.
    MOVE HE-AL TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-AL GO HM58.
HM5512. DISPLAY HE-B COLUMN 30 CONVERSION BOLD ACCEPT HE-B ACC-NUM.
    MOVE HE-B TO WV1 PERFORM RDLK-HEAT MOVE WV1 TO HE-B GO HM58.
HM5513. DISPLAY HE-V COLUMN 30 CONVERSION BOLD ACCEPT HE-V ACC-NUM.
    MOVE HE-V TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-V GO HM58.
HM5514. DISPLAY HE-CO COLUMN 30 CONVERSION BOLD ACCEPT HE-CO ACC-NUM.
    MOVE HE-CO TO WT1 PERFORM RDLK-HEAT MOVE WT1 TO HE-CO GO HM58.
HM5515. DISPLAY HE-N COLUMN 30 CONVERSION BOLD ACCEPT HE-N ACC-NUM.
    MOVE HE-N TO WV1 PERFORM RDLK-HEAT MOVE WV1 TO HE-N GO HM58.
HM5516. GO HM53.
HM5517. DISPLAY HE-GRADE COLUMN 30 BOLD ACCEPT HE-GRADE ACC-ALP.
    MOVE HE-GRADE TO WA1 PERFORM RDLK-HEAT MOVE WA1 TO HE-GRADE GO HM58.
HM5518. DISPLAY HE-DIVAL COLUMN 30 CONVERSION BOLD ACCEPT HE-DIVAL ACC-NUM.
    MOVE HE-DIVAL TO WD1 PERFORM RDLK-HEAT MOVE WD1 TO HE-DIVAL GO HM58.
HM58. REWRITE HE-RECORD ALLOWING NO UNLOCK HEAT GO HM53.
    REPLACE OFF.
HM60. MOVE HM-HEAT TO HE-NO READ HEAT REGARDLESS INVALID PERFORM DSP-ERR18 GO HM3.
    DELETE HEAT GO HM3.
HM9. GO MN9.

* M-2 HEAT INFORMATION
HQ1. PERFORM RD215 PERFORM WRT.
HQ3. ACCEPT HQ-HEAT LINE 21 COLUMN 55 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR HQ-HEAT=ALL "9" GO HQ9.
    MOVE HQ-HEAT TO HE-NO READ HEAT REGARDLESS INVALID PERFORM DSP-ERR18 GO HQ3.
    PERFORM RD215 MOVE HE-NO TO TF512(1).
    MOVE 1 TO IX1 MOVE 5 TO IXT PERFORM UNTIL IX1>15
      MOVE CHM-DESC(IX1) TO TF533(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    MOVE HE-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF513(1).
    MOVE HE-GRADE TO TF520(3) MOVE HE-DIVAL TO TF521(3).
    MOVE HE-C TO TF516(5) MOVE HE-MN TO TF516(6) MOVE HE-P TO TF517(7).
    MOVE HE-S TO TF517(8) MOVE HE-SI TO TF516(9) MOVE HE-CU TO TF516(10).
    MOVE HE-NI TO TF516(11) MOVE HE-CR TO TF516(12) MOVE HE-MO TO TF517(13).
    MOVE HE-SN TO TF517(14) MOVE HE-AL TO TF517(15) MOVE HE-B TO TF515(16).
    MOVE HE-V TO TF517(17) MOVE HE-CO TO TF517(18) MOVE HE-N TO TF515(19).
    PERFORM WRT GO HQ3.
HQ9. GO MN9.

* M-3 LOT FILE MAINTENANCE
IS1. PERFORM OPEN-EMPL.
IS3. PERFORM RD216 PERFORM WRT.
    ACCEPT IS-LOT LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IS-LOT=9999999 GO IS9.
    ACCEPT IS-OP LINE 3 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF IS-OP=9 GO IS9.
    GO IS40 IS50 IS60  DEPENDING IS-OP. PERFORM DSP-ERR1 GO IS3.

IS40. MOVE IS-LOT TO LT-NO READ LOT REGARDLESS INVALID GO IS408.
    MOVE "DUPLICATE LOT NO." TO ERR-MESG PERFORM DSP-ERR GO IS3.
IS408.
IS41. PERFORM RD217 MOVE LT-NO TO TF522(1).
    MOVE 1 TO CAR-CH MOVE 10 TO IXT PERFORM UNTIL CAR-CH>14
      MOVE CAR-MECH(CAR-CH) TO CAR-DATA MOVE CAR-DESC TO TF523(IXT)
      PERFORM DESC-UNIT MOVE CAR-UNIT TO A-A1 PERFORM STR-LTH
      COMPUTE IXU=34 + IS-MSZ(CAR-CH)
      MOVE " " TO WA1 STRING "(" CAR-UNIT(1:A-N1) ")" DELIMITED SIZE INTO WA1
      MOVE WA1 TO TLN(IXT)(IXU:A-N1 + 2) ADD 1 TO CAR-CH IXT END-PERFORM.
    PERFORM WRT.
IS43. ACCEPT IS-SLOT LINE 1 COLUMN 69 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IS-SLOT=9999999 GO IS9. MOVE 0 TO IS-KREW.
* note 261
    IF IS-SLOT=0 MOVE LOW-VALUES TO LT-RECORD INITIALIZE LT-REC
      MOVE IS-LOT TO LT-NO MOVE LIT-BARE TO LT-FINISH
      PERFORM VARYING CAR-CH FROM 1 BY 1 UNTIL CAR-CH>14
        MOVE CAR-MECH(CAR-CH) TO CAR-DATA PERFORM DESC-UNIT
        MOVE CAR-UNIT-A TO LT-UNIT(CAR-CH) END-PERFORM
      GO IS44.
    MOVE IS-SLOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO IS43.
    MOVE IS-LOT TO LT-NO IF LT-FINISH=LIT-BARE MOVE IS-SLOT TO LT-BMLOT.
    INITIALIZE LT-QTY LT-WEIGHT LT-BUCKETS LT-FINISH LT-GRADE LT-GRADE-OVR LT-QUAR.
    ACCEPT XA3 LINE 2 COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO IS-KREW.
IS44. DISPLAY LT-EMP LINE 3 COLUMN 9 CONVERSION.
    DISPLAY LT-MO LINE 4 COLUMN 8 CONVERSION LT-SUFFIX COLUMN 15.
    IF LT-PROD=" " GO IS442. DISPLAY LT-PROD LINE 3 COLUMN 49.
    MOVE LT-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO IS442.
    PERFORM RD-GEN PERFORM IS-DESC.
IS442. DISPLAY LT-SPEC LINE 4 COLUMN 27.
    DISPLAY LT-HEAT LINE 5 COLUMN 8 LT-COUNTRY COLUMN 34 CONVERSION.
    DISPLAY LT-FINISH LINE 6 COLUMN 10 LT-BUCKETS COLUMN 39 CONVERSION.
    DISPLAY LT-QTY LINE 7 COLUMN 7 CONVERSION LT-WEIGHT COLUMN 30 CONVERSION.
    DISPLAY LT-NOTE LINE 8 COLUMN 9 LT-ALOT LINE 9 COLUMN 70.
    MOVE 1 TO CAR-CH MOVE 10 TO IXT PERFORM UNTIL CAR-CH>14
      PERFORM MECH-GET DISPLAY MEC-VAL(1:IS-MSZ(CAR-CH)) LINE IXT COLUMN 26
      COMPUTE IXU=27 + IS-MSZ(CAR-CH) DISPLAY MEC-UNIT COLUMN IXU
      ADD 1 TO CAR-CH IXT END-PERFORM.

IS447. ACCEPT LT-EMP LINE 3 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LT-EMP LINE 3 COLUMN 9 CONVERSION.
    MOVE WS-PDIV TO E-DIV MOVE LT-EMP TO E-NO.
    READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO IS447.
    DISPLAY E-NAME(1:20) LINE 3 COLUMN 15.
IS45. ACCEPT LT-MO LINE 4 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LT-MO LINE 4 COLUMN 8 CONVERSION.
    MOVE LT-MO TO R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO IS45.
    ACCEPT LT-SUFFIX LINE 4 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE R-PROD TO LT-PROD P-NO READ PRODUCT REGARDLESS INVALID GO IS452.
    DISPLAY LT-PROD LINE 3 COLUMN 49 PERFORM RD-GEN PERFORM IS-DESC.
    MOVE P-SPEC TO LT-SPEC DISPLAY LT-SPEC LINE 4 COLUMN 27.
IS452. ACCEPT LT-PROD LINE 3 COLUMN 49 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE LT-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO IS45.
    PERFORM RD-GEN PERFORM IS-DESC.
    ACCEPT LT-SPEC LINE 4 COLUMN 27 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LT-HEAT LINE 5 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE LT-HEAT TO HE-NO READ HEAT REGARDLESS INVALID PERFORM DSP-ERR18 GO IS41.
    MOVE HE-GRADE TO LT-GRADE IF HE-GRADE(1:4)=P-GRADE(1:4) GO IS4526.
    IF LT-FINISH=LIT-BARE
      DISPLAY "GRADE MISMATCH - ENTER AUTHORIZATION CODE TO ACCEPT THIS HEAT: ____" LINE 24 BOLD ERASE LINE
      ACCEPT LT-GRADE-OVR LINE 24 COLUMN 64 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS
      PERFORM CHK-GRADE-OVR IF A-S1=1 GO IS41.
    MOVE P-GRADE TO LT-GRADE.
IS4526. ACCEPT LT-COUNTRY LINE 5 COLUMN 34 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LT-COUNTRY LINE 5 COLUMN 34 CONVERSION.
    ACCEPT LT-FINISH LINE 6 COLUMN 10 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF LT-FINISH=LIT-BARE MOVE 635 TO IS-MAC
      ELSE IF IS-KREW=0 MOVE 636 TO IS-MAC ELSE MOVE 637 TO IS-MAC.
    MOVE 0 TO WS1.
IS4527. ACCEPT LT-BUCKETS LINE 6 COLUMN 39 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LT-BUCKETS LINE 6 COLUMN 39 CONVERSION.
    IF IS-MAC=635 AND LT-BUCKETS=0 MOVE "BUCKETS CANNOT BE 0 FOR BARE METAL LOTS"
      TO ERR-MESG PERFORM DSP-ERR IF WS1=0 MOVE 1 TO WS1 GO IS4527 ELSE GO IS41.
* note 30.3
    MOVE 0 TO IS-SQTY INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO IS454.
IS453. READ WORKSHEET NEXT REGARDLESS END GO IS454. IF J-NO NOT=R-NO GO IS454.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY ADD J-QTY TO IS-SQTY
      ELSE IF (IFAST OR INUT) AND PROC-REJECT OR J-MAC=IS-MAC SUBTRACT J-QTY FROM IS-SQTY.
    GO IS453.
IS454. COMPUTE IS-SWEIGHT ROUNDED=IS-SQTY * P-WEIGHT / 100.

IS461. ACCEPT LT-QTY LINE 7 COLUMN 7 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LT-QTY LINE 7 COLUMN 7 CONVERSION.
    PERFORM IS-CHK-QTY IF A-S1=1 GO IS461. MOVE 0 TO WS1.
IS463. ACCEPT LT-WEIGHT LINE 7 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LT-WEIGHT LINE 7 COLUMN 30 CONVERSION.
    PERFORM IS-CHK-WEIGHT IF A-S1=1 GO IS463.
    IF LT-WEIGHT=0 COMPUTE LT-WEIGHT ROUNDED=LT-QTY * P-WEIGHT / 100
      ELSE IF LT-QTY=0 COMPUTE LT-QTY ROUNDED=LT-WEIGHT * 100 / P-WEIGHT SIZE ERROR CONTINUE.
    IF IS-MAC=635 AND LT-WEIGHT=0 MOVE "WEIGHT CANNOT BE 0 FOR BARE METAL LOTS"
      TO ERR-MESG PERFORM DSP-ERR IF WS1=0 MOVE 1 TO WS1 GO IS463 ELSE GO IS41.
    ACCEPT LT-NOTE LINE 8 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT LT-ALOT LINE 9 COLUMN 70 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.

IS465. DISPLAY "'Y' TO AUTHORIZE LABELS, ELSE 'N': _" LINE 24 BOLD.
    ACCEPT XA1 COLUMN 36 DEFAULT "N" UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA1="Y" MOVE 1 TO LT-LAB ELSE IF XA1="N" MOVE 0 TO LT-LAB
      ELSE PERFORM DSP-ERR14 GO IS465.

    MOVE 1 TO CAR-CH MOVE 10 TO IXT PERFORM UNTIL CAR-CH>14 PERFORM MECH-GET
      ACCEPT MEC-VAL(1:IS-MSZ(CAR-CH)) LINE IXT COLUMN 26 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      COMPUTE IXU=27 + IS-MSZ(CAR-CH)
      ACCEPT MEC-UNIT LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED EDITING
      PERFORM MECH-PUT ADD 1 TO CAR-CH IXT END-PERFORM.
    MOVE LT-NO TO LT-LOT D-LOT PERFORM D-LOTDATE MOVE D-YEAR TO LT-LYEAR.
    WRITE LT-RECORD ALLOWING NO UNLOCK LOT.

    PERFORM INIT-J MOVE LT-MO TO J-NO MOVE IS-MAC TO J-MAC MOVE LT-PROD TO J-PROD.
    MOVE LT-NO TO J-LOT(1) MOVE LT-QTY TO J-QTY MOVE LT-WEIGHT TO J-WEIGHT.
    READ WORKSHEET REGARDLESS INVALID
      PERFORM SET-JKD WRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET GO IS48.
    ADD LT-QTY TO J-QTY ADD LT-WEIGHT TO J-WEIGHT MOVE 1 TO IX1.
IS47. IF J-LOT(IX1) NUMERIC
       IF J-LOT(IX1)=0 MOVE LT-NO TO J-LOT(IX1)
         ELSE IF J-LOT(IX1) NOT=LT-NO ADD 1 TO IX1 IF IX1<=10 GO IS47.
    REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
IS48. GO IS3.

IS50. MOVE IS-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO IS3.
    PERFORM RD218 MOVE LT-NO TO TF511(3) PERFORM WRT PERFORM RD218A PERFORM WRT.
IS53. ACCEPT IS-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO IS551 IS552 IS553 IS554 IS555 IS556 IS557 IS558 IS559 IS559
       IS559 IS559 IS559 IS559 IS559 IS559 IS559 IS559 IS559 IS559
       IS559 IS559 IS5523 IS5524 IS5525 IS5526 IS5527
      DEPENDING IS-FLD. GO IS3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
IS551. DISPLAY LT-EMP COLUMN 30 CONVERSION BOLD ACCEPT LT-EMP ACC-NUM.
    MOVE LT-EMP TO WN1 PERFORM RDLK-LOT MOVE WN1 TO LT-EMP GO IS58.
IS552. DISPLAY LT-PROD COLUMN 30 BOLD ACCEPT LT-PROD ACC-ALP.
    MOVE LT-PROD TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-PROD GO IS58.
IS553. DISPLAY LT-MO COLUMN 30 CONVERSION BOLD ACCEPT LT-MO ACC-NUM.
    MOVE LT-MO TO WN1 PERFORM RDLK-LOT MOVE WN1 TO LT-MO GO IS58.
IS554. DISPLAY LT-SUFFIX COLUMN 30 BOLD ACCEPT LT-SUFFIX ACC-ALP.
    MOVE LT-SUFFIX TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-SUFFIX GO IS58.
IS555. DISPLAY LT-HEAT COLUMN 30 BOLD ACCEPT LT-HEAT ACC-ALP.
    MOVE LT-HEAT TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-HEAT GO IS58.
IS556. DISPLAY LT-FINISH COLUMN 30 BOLD ACCEPT LT-FINISH ACC-ALP.
    MOVE LT-FINISH TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-FINISH GO IS58.
IS557. DISPLAY LT-QTY COLUMN 30 CONVERSION BOLD ACCEPT LT-QTY ACC-NUM.
    MOVE LT-QTY TO WN1 PERFORM RDLK-LOT MOVE WN1 TO LT-QTY GO IS58.
IS558. DISPLAY LT-WEIGHT COLUMN 30 CONVERSION BOLD ACCEPT LT-WEIGHT ACC-NUM.
    MOVE LT-WEIGHT TO WN1 PERFORM RDLK-LOT MOVE WN1 TO LT-WEIGHT GO IS58.
IS559. COMPUTE CAR-CH=IS-FLD - 8 PERFORM MECH-GET.
    DISPLAY MEC-VAL(1:IS-MSZ(CAR-CH)) COLUMN 30 BOLD.
    COMPUTE IXU=32 + IS-MSZ(CAR-CH) DISPLAY MEC-UNIT COLUMN IXU BOLD.
    ACCEPT MEC-VAL(1:IS-MSZ(CAR-CH)) ACC-ALP.
    ACCEPT MEC-UNIT LINE 21 COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM RDLK-LOT PERFORM MECH-PUT GO IS58.
IS5523. DISPLAY LT-NOTE COLUMN 30 BOLD ACCEPT LT-NOTE ACC-ALP.
    MOVE LT-NOTE TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-NOTE GO IS58.
IS5524. DISPLAY LT-SPEC COLUMN 30 BOLD ACCEPT LT-SPEC ACC-ALP.
    MOVE LT-SPEC TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-SPEC GO IS58.
IS5525. DISPLAY LT-COUNTRY COLUMN 30 CONVERSION BOLD ACCEPT LT-COUNTRY ACC-NUM.
    MOVE LT-COUNTRY TO WN1 PERFORM RDLK-LOT MOVE WN1 TO LT-COUNTRY GO IS58.
IS5526. DISPLAY LT-BUCKETS COLUMN 30 CONVERSION BOLD ACCEPT LT-BUCKETS ACC-NUM.
    MOVE LT-BUCKETS TO WN1 PERFORM RDLK-LOT MOVE WN1 TO LT-BUCKETS GO IS58.
IS5527. DISPLAY LT-ALOT COLUMN 30 BOLD ACCEPT LT-ALOT ACC-ALP.
    MOVE LT-ALOT TO WA1 PERFORM RDLK-LOT MOVE WA1 TO LT-ALOT GO IS58.
IS58. REWRITE LT-RECORD ALLOWING NO UNLOCK LOT GO IS53.
    REPLACE OFF.
IS60. MOVE IS-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO IS3.
    DELETE LOT GO IS3.
IS9. CLOSE EMPL GO MN9.

IS-DESC. PERFORM PROD-DESC.
    MOVE 1 TO IX1 MOVE 4 TO IXT PERFORM UNTIL IX1>4 OR PRO-DESC(IX1)=" "
      DISPLAY PRO-DESC(IX1) LINE IXT COLUMN 49 ADD 1 TO IX1 IXT END-PERFORM.
IS-CHK-QTY. MOVE 0 TO A-S1.
    IF LT-QTY NOT=0 AND>IS-SQTY MOVE " " TO XA2 ERR-MESG MOVE IS-SQTY TO DSP-C81
      STRING "QTY EXCEEDS PRIMARY MACHINE" DSP-C81 DELIMITED SIZE INTO ERR-MESG
      IF IS-MAC=635 PERFORM DSP-OK ELSE PERFORM DSP-ERR END-IF
      IF XA2 NOT="OK" MOVE 1 TO A-S1.
IS-CHK-WEIGHT. MOVE 0 TO A-S1.
    IF LT-WEIGHT NOT=0 AND>IS-SWEIGHT MOVE " " TO XA2 ERR-MESG MOVE IS-SWEIGHT TO DSP-C81
      STRING "WEIGHT EXCEEDS PRIMARY MACHINE" DSP-C81 DELIMITED SIZE INTO ERR-MESG
      IF IS-MAC=635 PERFORM DSP-OK ELSE PERFORM DSP-ERR END-IF
      IF XA2 NOT="OK" MOVE 1 TO A-S1.

* M-4 LOT INFORMATION
IL1. PERFORM OPEN-EMPL PERFORM RD219 PERFORM IL-T PERFORM WRT.
IL3. ACCEPT IL-LOT LINE 23 COLUMN 70 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IL-LOT=9999999 GO IL9.
    MOVE IL-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO IL3.
    PERFORM RD219 PERFORM IL-T MOVE LT-NO TO TF328(1).
    MOVE LT-PROD TO TF329(1) A-A1 PERFORM PROD-RD.
    MOVE 1 TO IX1 MOVE 2 TO IXT PERFORM UNTIL IX1>4 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO TF329(IXT) ADD 1 TO IX1 IXT END-PERFORM.
    MOVE LT-EMP TO TF308(3) A-N1 PERFORM RD-EMPL MOVE E-NAME TO TF309(3).
    MOVE LT-MO TO TF312(4).
    IF LT-SUFFIX>" " MOVE "-" TO TF313(4) MOVE LT-SUFFIX TO TF314(4).
    MOVE LT-SPEC TO TF315(4) MOVE LT-HEAT TO TF316(5).
    INITIALIZE HE-REC MOVE LT-HEAT TO HE-NO READ HEAT REGARDLESS INVALID CONTINUE.
    PERFORM GET-GRADE MOVE A-A1 TO TF317(5).
    IF LT-GRADE-OVR>0 MOVE "(" TO TF318(5) MOVE LT-GRADE-OVR TO TF319(5) MOVE ")" TO TF320(5).
    MOVE LT-FINISH TO TF321(6) MOVE LT-COUNTRY TO TF322(6).
    MOVE LT-QTY TO TF324(7) MOVE LT-WEIGHT TO TF325(7) MOVE LT-BUCKETS TO TF326(7).
    MOVE LT-NOTE TO TF327(8) MOVE LT-ALOT TO TF323(9).
    MOVE 1 TO CAR-CH MOVE 10 TO IXT PERFORM UNTIL CAR-CH>14
      PERFORM MECH-GET PERFORM MECH-DESC MOVE MEC-VAL TO A-A1 PERFORM STR-LTH
      MOVE MEC-VAL TO TF311(IXT)(1:A-N1) ADD 1 TO CAR-CH IXT END-PERFORM.
    PERFORM WRT GO IL3.
IL9. CLOSE EMPL GO MN9.

IL-T. MOVE 1 TO CAR-CH MOVE 10 TO IXT.
    PERFORM UNTIL CAR-CH>14 MOVE CAR-MECH(CAR-CH) TO CAR-DATA
      MOVE CAR-DESC TO TF310(IXT) ADD 1 TO CAR-CH IXT END-PERFORM.

* M-5 SHIPPING LABEL ENTRY
CE1.
CE3. PERFORM RD220 PERFORM WRT.
CE33. ACCEPT CE-LOT LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR CE-LOT=9999999 GO CE9. IF CE-LOT=0 PERFORM DSP-ERR2 GO CE33.
    MOVE CE-LOT TO LT-NO READ LOT REGARDLESS INVALID
      MOVE "THIS LOT DOES NOT EXIST" TO ERR-MESG PERFORM DSP-ERR GO CE33.
    IF LT-LAB=0 MOVE "LABELS WERE NOT AUTHORIZED FOR THIS LOT"
      TO ERR-MESG PERFORM DSP-ERR GO CE33.
    MOVE LT-PROD TO P-NO.
    ACCEPT P-NO LINE 3 COLUMN 34 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO CE3.
    MOVE P-NO TO CE-PROD MOVE 0 TO CE-TQTY MOVE 11 TO IXT.
    MOVE CE-LOT TO A-N1 PERFORM SET-LA-KL.
    START LABELS KEY>=LA-KL REGARDLESS INVALID GO CE44.
CE43. READ LABELS NEXT REGARDLESS END GO CE44. IF LA-LOT NOT=CE-LOT GO CE44.
    MOVE " " TO CE-TDS.
    COMPUTE D-DATE=999999 - LA-ZDATE PERFORM D-NM MOVE D-DT TO CE-TS1.
    COMPUTE D-STIME=99999999 - LA-ZTIME PERFORM D-PR-STIME MOVE D-PRSTIME TO CE-TS2.
    MOVE LIT-AMS(LA-SRC + 1:1) TO CE-TS3.
    MOVE LA-QTY TO CE-TS4 MOVE LA-PROD TO CE-TS5 A-A1 PERFORM PROD-GEN.
    MOVE P-QTY-PACK TO WN1 IF LA-QPACK NOT=0 MOVE LA-QPACK TO WN1.
    MOVE WN1 TO CE-TS6 MOVE LA-USER TO CE-TS7.
    IF LA-PR=1 MOVE "Y" TO CE-TS8. IF LA-PR=2 MOVE "C" TO CE-TS8.
    DISPLAY CE-TDS LINE IXT ADD LA-QTY TO CE-TQTY.
    ADD 1 TO IXT IF IXT<=23 GO CE43.
CE44. IF IXT<=23 DISPLAY "TOTAL CARTONS/CONTAINERS LABELED:" LINE IXT BOLD CE-TQTY CONVERSION BOLD.
    MOVE CE-PROD TO P-NO READ PRODUCT REGARDLESS.
    PERFORM INIT-LA MOVE 1 TO LA-SRC MOVE CE-LOT TO LA-LOT.
    MOVE P-NO TO LA-PROD MOVE P-CUS TO LA-CUS MOVE P-ORD TO LA-ORD.
    MOVE P-QTY-PACK TO LA-QPACK DISPLAY LA-QPACK LINE 3 COLUMN 66 CONVERSION.
    ACCEPT LA-QPACK LINE 3 COLUMN 66 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY LA-QPACK LINE 3 COLUMN 66 CONVERSION.
CE73. DISPLAY "ENTER NUMBER OF CARTONS OR CONTAINERS TO BE LABELED (1000 MAXIMUM)" LINE 24 BOLD.
    ACCEPT LA-QTY LINE 5 COLUMN 20 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF LA-QTY=0 OR>1000 PERFORM DSP-ERR2 GO CE73.
    MOVE SYS-DATE TO D-DATE MOVE 7 TO IXT MOVE 12 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO LA-DATE.
CE75. MOVE LA-CUS TO A-A1 MOVE LA-PROD TO A-A2 PERFORM BAR-SET-CUSORD MOVE A-A1 TO LA-CUSORD.
    ACCEPT LA-CUSORD LINE 7 COLUMN 38 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF LA-CUS="10150" IF LA-CUSORD=" " PERFORM DSP-ERR2 GO CE75.
    MOVE "'CAN' TO CANCEL THIS ENTRY: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="CAN" PERFORM SET-LA WRITE LA-RECORD ALLOWING NO UNLOCK LABELS.
    GO CE3.
CE9. GO MN9.

* M-6 SHOW LABELS BY LOT
CQ1. PERFORM RD221 MOVE 0 TO CQ-LOT INQ-IND MOVE 3 TO IXT.
CQ3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
    DISPLAY "NEXT LOT NO. _______" LINE IXT.
    DISPLAY "TO SEE ALL LOTS, LEAVE LOT NO. BLANK" LINE 24 BOLD.
    ACCEPT IA36 LINE IXT COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR IA36=9999999 GO CQ9. IF IA36=0 AND INQ-IND=1 GO CQ4.
    MOVE IA36 TO CQ-LOT MOVE 0 TO INQ-IND.
    IF CQ-LOT=0 INITIALIZE LA-KL ELSE MOVE CQ-LOT TO A-N1 PERFORM SET-LA-KL.
CQ4. PERFORM RD221.
    MOVE 4 TO IXT IF INQ-IND=0 START LABELS KEY>=LA-KL REGARDLESS INVALID GO CQ8.
CQ5. READ LABELS NEXT REGARDLESS END GO CQ8. IF NOT(CQ-LOT=0 OR LA-LOT) GO CQ8.
    PERFORM CLR-LN MOVE LA-LOT TO TF331(IXT).
    COMPUTE D-DATE=999999 - LA-ZDATE PERFORM D-NM MOVE D-DT TO TF332(IXT).
    COMPUTE D-STIME=99999999 - LA-ZTIME PERFORM D-PR-STIME MOVE D-PRSTIME TO TF333(IXT).
    MOVE LIT-AMS(LA-SRC + 1:1) TO TF334(IXT).
    MOVE LA-QTY TO TF335(IXT) MOVE LA-PROD TO TF336(IXT) A-A1 PERFORM PROD-GEN.
    MOVE P-QTY-PACK TO WN1 IF LA-QPACK NOT=0 MOVE LA-QPACK TO WN1.
    MOVE WN1 TO TF337(IXT) MOVE LA-USER TO TF338(IXT).
    IF LA-PR=1 MOVE "Y" TO TF339(IXT). IF LA-PR=2 MOVE "C" TO TF339(IXT).
    ADD 1 TO IXT IF IXT<22 GO CQ5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO CQ89.
CQ8. MOVE "*** END ***" TO TLN(IXT) MOVE 0 TO INQ-IND.
CQ89. GO CQ3.
CQ9. GO MN9.

* M-7 CREATE LABELS PRINT FILE
UL1. PERFORM RD46 PERFORM WRT.
    MOVE 2 TO UL-OP DISPLAY UL-OP LINE 3 COLUMN 13 CONVERSION.
* note 145
UL13. ACCEPT UL-OP LINE 3 COLUMN 13 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY UL-OP LINE 3 COLUMN 13 CONVERSION.
    IF NOT(UL-OP=1 OR 2) PERFORM DSP-ERR1 GO UL13.
    MOVE 6 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE UL-OP TO LAB-FLN PERFORM OPEN-LAB.

    MOVE 0 TO LA-NO START LABELS KEY>=LA-KEY REGARDLESS INVALID GO UL9.
UL3. READ LABELS NEXT REGARDLESS END GO UL9. IF NOT(LA-PR=0 AND LA-SRC=UL-OP - 1) GO UL3.
    PERFORM BAR-LAB IF BAR-ERR=0 MOVE 1 TO LA-PR REWRITE LA-RECORD ALLOWING NO UNLOCK LABELS.
    PERFORM BAR-LAB-SPACER GO UL3.
UL9. PERFORM CLOSE-LAB GO MN9.

* M-8 MISCELLANEOUS MODIFICATIONS
JE1. PERFORM RD94 PERFORM WRT.
    ACCEPT JE-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR JE-SEL=99 GO JE9. PERFORM DSP-CLS.
    GO JE10 JE20 JE30 JE40 JE50  DEPENDING JE-SEL. GO JE1.

JE10. PERFORM RD94A PERFORM WRT.
JE11. ACCEPT JE-PRINT LINE 6 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO JE9. IF JE-PRINT=0 PERFORM DSP-ERR2 GO JE11.
    ACCEPT JE-PRINT-REV LINE 6 COLUMN 41 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 8 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JE9.
    MOVE 10 TO JE-FROW PERFORM JE-PI.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO JE18.
JE13. READ PRODUCT NEXT REGARDLESS END GO JE18. IF P-PRINT NOT=JE-PRINT GO JE13.
    PERFORM RDLK-PRODUCT MOVE JE-PRINT-REV TO P-PRINT-REV.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT PERFORM JE-PD GO JE13.
JE18. PERFORM JE-PN PERFORM DSP-CONT GO JE9.

JE20. PERFORM RD94B PERFORM WRT.
JE21. ACCEPT JE-OSPEC LINE 6 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO JE9. IF JE-OSPEC=" " PERFORM DSP-ERR2 GO JE21.
    ACCEPT JE-NSPEC LINE 6 COLUMN 52 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 8 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JE9.
    MOVE 10 TO JE-FROW PERFORM JE-PI.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO JE28.
JE23. READ PRODUCT NEXT REGARDLESS END GO JE28. IF P-SPEC NOT=JE-OSPEC GO JE23.
    PERFORM RDLK-PRODUCT MOVE JE-NSPEC TO P-SPEC.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT PERFORM JE-PD GO JE23.
JE28. PERFORM JE-PN PERFORM DSP-CONT GO JE9.

JE30. PERFORM RD94C PERFORM WRT.
JE31. ACCEPT P-NO LINE 5 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO JE9. READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO JE31.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 5 COLUMN 25 P-PPAP LINE 7 COLUMN 16 CONVERSION.
    DISPLAY P-PPAP LINE 8 COLUMN 16 CONVERSION.
JE33. ACCEPT P-PPAP LINE 8 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY P-PPAP LINE 8 COLUMN 16 CONVERSION.
    IF P-PPAP>1 PERFORM DSP-ERR2 GO JE33.
    MOVE P-PPAP TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-PPAP.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    PERFORM DSP-CONT GO JE9.

JE40. PERFORM RD94D PERFORM WRT.
    ACCEPT JE-ODESC LINE 6 COLUMN 30 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO JE9.
    ACCEPT JE-NDESC LINE 7 COLUMN 30 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 9 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO JE9.
    MOVE 11 TO JE-FROW PERFORM JE-PI.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO JE48.
JE43. READ PRODUCT NEXT REGARDLESS END GO JE48. IF P-FINDESC NOT=JE-ODESC GO JE43.
    PERFORM RDLK-PRODUCT MOVE JE-NDESC TO P-FINDESC.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT PERFORM JE-PD GO JE43.
JE48. PERFORM JE-PN PERFORM DSP-CONT GO JE9.

JE50. PERFORM RD94E PERFORM WRT.
JE51. ACCEPT P-NO LINE 5 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO JE9. READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO JE51.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 5 COLUMN 25 P-ALERT LINE 7 COLUMN 18 CONVERSION.
    DISPLAY P-ALERT LINE 8 COLUMN 18 CONVERSION.
    ACCEPT P-ALERT LINE 8 COLUMN 18 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY P-ALERT LINE 8 COLUMN 18 CONVERSION.
    MOVE P-ALERT TO WN1 PERFORM RDLK-PRODUCT MOVE WN1 TO P-ALERT.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    PERFORM DSP-CONT GO JE9.

JE9. GO MN9.

JE-PI. PERFORM DSP-QWAIT.
    MOVE 0 TO JE-NUM COMPUTE IXT=JE-FROW - 1 MOVE 5 TO JE-IXC.
JE-PD. ADD 1 TO JE-IXC IF JE-IXC>5 MOVE 1 TO JE-IXC ADD 1 TO IXT IF IXT>21
      PERFORM VARYING IXT FROM JE-FROW BY 1 UNTIL IXT>21 DISPLAY " " LINE IXT ERASE LINE END-PERFORM
      MOVE JE-FROW TO IXT.
    COMPUTE IXU=(JE-IXC - 1) * 16 + 1.
    DISPLAY P-NO LINE IXT COLUMN IXU ADD 1 TO JE-NUM.
JE-PN. PERFORM DSP-ERS.
    DISPLAY JE-NUM LINE 23 CONVERSION BOLD " PRODUCTS WERE MODIFIED" BOLD.

* M-9 CHANGE THE GRADE IN LOT
BW1.
BW3. PERFORM RD270 PERFORM WRT.
    ACCEPT LT-NO LINE 7 COLUMN 7 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR LT-NO=9999999 GO BW9.
    READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO BW3.
    DISPLAY LT-GRADE LINE 7 COLUMN 35 LT-GRADE-OVR LINE 8 COLUMN 35 CONVERSION.
    ACCEPT LT-GRADE LINE 7 COLUMN 47 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT LT-GRADE-OVR LINE 8 COLUMN 47 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM CHK-GRADE-OVR IF A-S1=1 GO BW3.
    REWRITE LT-RECORD ALLOWING NO UNLOCK LOT PERFORM DSP-CONT GO BW3.
BW9. GO MN9.

* M-10 QUARANTINE/RELEASE LOTS
QJ1.
QJ3. PERFORM RD275 PERFORM WRT.
QJ33. ACCEPT LT-NO LINE 3 COLUMN 7 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR LT-NO=9999999 GO QJ9.
    READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO QJ33.
    DISPLAY LT-PROD LINE 5.
    MOVE LT-PROD TO A-A1 PERFORM PROD-RD.
    MOVE 1 TO IX1 MOVE 6 TO IXT PERFORM UNTIL IX1>4 OR PRO-DESC(IX1)=" "
      DISPLAY PRO-DESC(IX1) LINE IXT ADD 1 TO IX1 IXT END-PERFORM.
    MOVE LT-QUAR TO A-S1 MOVE 3 TO IXT MOVE 26 TO IXU PERFORM AX-NY.
    MOVE A-S1 TO LT-QUAR REWRITE LT-RECORD ALLOWING NO UNLOCK LOT GO QJ3.
QJ9. GO MN9.

* M-11 SHOW LOT SALE HISTORY
QK1. PERFORM RD276 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MN9. OPEN I-O LOTHIST ALLOWING ALL.
    GO QK2 QK4  DEPENDING SEL-N.

QK2. PERFORM RD276A MOVE 0 TO LT-NO MOVE 3 TO IXT.
QK3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
QK33. DISPLAY "NEXT LOT NO. _______" LINE IXT.
    ACCEPT IA46 COLUMN 14 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA46=9999999 GO QK39.
    IF IA46=0 IF LT-NO=0 GO QK33 ELSE GO QK34. MOVE IA46 TO LT-NO.
    START LOT KEY>=LT-KEY REGARDLESS INVALID PERFORM DSP-ERR15 GO QK33.
    READ LOT NEXT REGARDLESS MOVE LT-PROD TO A-A1 PERFORM PROD-RD.
    MOVE LT-NO TO LN-LOT MOVE 0 TO INQ-IND.
QK34. PERFORM RD276A MOVE LT-NO TO TF198(1).
    MOVE P-NO TO TF200(1) MOVE PRO-DESC(1) TO TF201(1).
    MOVE 4 TO IXT IF INQ-IND=0 START LOTHIST KEY>=LN-KL REGARDLESS INVALID GO QK38.
QK35. READ LOTHIST NEXT REGARDLESS END GO QK38. IF LN-LOT NOT=LT-NO GO QK38.
    PERFORM QK-DSP ADD 1 TO IXT IF IXT<22 GO QK35.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO QK389.
QK38. MOVE "*** END ***" TO TLN(IXT).
    READ LOT NEXT REGARDLESS END MOVE 0 TO LT-NO GO QK389.
    MOVE LT-PROD TO A-A1 PERFORM PROD-RD MOVE LT-NO TO LN-LOT MOVE 0 TO INQ-IND.
QK389. GO QK3.
QK39. GO QK9.

QK4. PERFORM RD276B MOVE 0 TO QK-INV MOVE 3 TO IXT.
QK5. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
QK53. DISPLAY "NEXT INVOICE NO. ______" LINE IXT.
    ACCEPT IA47 COLUMN 18 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA47=999999 GO QK59.
    IF IA47=0 IF QK-INV=0 GO QK53 ELSE GO QK54. MOVE IA47 TO QK-INV.
    MOVE QK-INV TO LN-INV MOVE 0 TO INQ-IND.
QK54. PERFORM RD276B MOVE QK-INV TO TF199(1) MOVE 0 TO QK-KFIR.
    MOVE 4 TO IXT IF INQ-IND=0 START LOTHIST KEY>=LN-KI REGARDLESS INVALID GO QK58.
QK55. READ LOTHIST NEXT REGARDLESS END GO QK58. IF LN-INV NOT=QK-INV GO QK58.
    IF QK-KFIR=0 MOVE 1 TO QK-KFIR MOVE LN-PROD TO A-A1 PERFORM PROD-RD
      MOVE P-NO TO TF200(1) MOVE PRO-DESC(1) TO TF201(1).
    PERFORM QK-DSP ADD 1 TO IXT IF IXT<22 GO QK55.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO QK589.
QK58. MOVE "*** END ***" TO TLN(IXT).
    ADD 1 TO QK-INV IF QK-INV=0 GO QK589. MOVE QK-INV TO LN-INV MOVE 0 TO INQ-IND.
QK589. GO QK5.
QK59. GO QK9.

QK9. CLOSE LOTHIST GO MN9.

QK-DSP. PERFORM CLR-LN.
    MOVE LN-CUS TO TF202(IXT) A-A1 PERFORM RD-CUS MOVE C-NAME TO TF203(IXT).
    MOVE LN-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF204(IXT).
    IF Y1 MOVE LN-INV TO TF205(IXT) ELSE MOVE LN-LOT TO TF206(IXT).
    MOVE LN-CUSORD TO TF207(IXT). MOVE LN-QTY TO TF208(IXT).
    MOVE LN-CARTONS TO TF209(IXT).

* M-12 SHOW PRODUCTS BY PRINT NUMBER
BG1.
BG3. PERFORM RD60 PERFORM WRT.
    ACCEPT BG-PRINT LINE 3 COLUMN 18 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR BG-PRINT=999999 GO BG9. IF BG-PRINT=0 PERFORM DSP-ERR2 GO BG3.
    PERFORM DSP-QWAIT MOVE 0 TO BG-KFIN MOVE 5 TO IXT MOVE 1 TO IXCOL.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO BG8.
BG5. READ PRODUCT NEXT REGARDLESS END GO BG8. IF P-PRINT NOT=BG-PRINT GO BG5.
    MOVE 1 TO BG-KFIN MOVE " " TO WA1 WA2.
    IF P-PRINT-REV>" " STRING "(" DELIMITED SIZE P-PRINT-REV DELIMITED " "
      ")" DELIMITED SIZE INTO WA2.
    STRING P-NO DELIMITED " " " " DELIMITED SIZE WA2 DELIMITED " " INTO WA1.
    COMPUTE IXU=(IXCOL - 1) * 20 + 1 DISPLAY WA1(1:18) LINE IXT COLUMN IXU.
    ADD 1 TO IXCOL IF IXCOL>4 MOVE 1 TO IXCOL ADD 1 TO IXT. IF IXT<=23 GO BG5.
    MOVE "'Y' TO CONTINUE SEARCH: _" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="Y" MOVE 5 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN
      PERFORM DSP-QWAIT GO BG5.
    GO BG3.
BG8. PERFORM DSP-ERS IF BG-KFIN=0 DISPLAY "*** NO PRODUCTS FOUND" LINE IXT.
    PERFORM DSP-CONT GO BG3.
BG9. GO MN9.

* M-13 PRINT INSPECTION PCC & DRAWING
SB1. PERFORM RD209 PERFORM WRT MOVE 0 TO SB-RN MOVE 2 TO IXT.
SB13. ADD 1 TO SB-RN IXT.
SB15. ACCEPT R-NO LINE IXT COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF R-NO=0 SUBTRACT 1 FROM SB-RN GO SB16.
    READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO SB15.
    MOVE R-NO TO RNUM1(SB-RN) IF SB-RN<10 GO SB13.
SB16. MOVE 13 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE 3 TO LAS-FLN PERFORM OPEN-LAS.
    OPEN INPUT PDRAWINGS ALLOWING ALL.

    MOVE 0 TO SB-IXN.
SB3. ADD 1 TO SB-IXN IF SB-IXN>SB-RN GO SB8.
    MOVE RNUM1(SB-IXN) TO A-N1 PERFORM RD-PRODORD MOVE R-PROD TO A-A1 PERFORM PROD-RT.
    MOVE " " TO SB-DRAW PERFORM SET-PART MOVE PART-NO TO SB-MAT.
    IF P-PRINT>0 PERFORM DESC-PRINT MOVE PRO-PRINT(1:6) TO SB-DRAW.

    PERFORM PCL-INIT PERFORM PCL-START.
    PERFORM PCL-BOLD1 MOVE 0 TO LAS-ROW LAS-COL PERFORM PCL-PCR.
    MOVE SB-DRAW TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM2 ADD 2 TO LAS-ROW PERFORM PCL-PCR.
    PERFORM PCL-UNDY MOVE "M.O." TO LAS-FLD PERFORM LASF PERFORM PCL-UNDN.
    PERFORM PCL-BOLD1 ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE R-NO TO FJ-N5 PERFORM LASF.

    MOVE SB-DRAW TO DG-DRAW MOVE 1 TO DG-PAGE MOVE 0 TO DG-LINE.
    READ PDRAWINGS REGARDLESS INVALID PERFORM PCL-ENDFL GO SB66.
    PERFORM PCL-FLUSH.
* note 75.2
    MOVE SB-DRAW TO DG-DRAW MOVE 1 TO DG-PAGE DG-LINE.
    START PDRAWINGS KEY>=DG-KEY REGARDLESS INVALID GO SB66.
SB65. READ PDRAWINGS NEXT REGARDLESS END GO SB66.
    IF DG-DRAW NOT=SB-DRAW GO SB66. IF DG-LINE=0 GO SB65.
    IF DG-PAGE=1 AND DG-LINE=1 MOVE LOW-VALUES TO DG-DATA(1:11).
    MOVE DG-DATA TO LAS-RECORD WRITE LAS-RECORD GO SB65.
SB66. PERFORM PCL-INIT PERFORM PCL-START.

    MOVE "`*p000x000Y`*c650a2b0P`*p+50Y`*c650a2b0P`*p+50Y`*c650a2b0P`*p+50Y`*c650a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p000x000Y`*c2a152b0P`*p+650X`*c2a152b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s12h0s0B`*p010x042YM.O.`*p010x+50YPART NO.`*p010x+50YDWG. NO." TO LAS-FLD PERFORM LASF.

    MOVE "`*p700x000Y`*c730a2b0P`*p+50Y`*c730a2b0P`*p+50Y`*c730a2b0P`*p+50Y`*c730a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p700x000Y`*c2a152b0P`*p+730X`*c2a152b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`(s12h0s0B`*p710x042YMATERIAL`*p710x+50YHEAT NO.`*p710x+50YDATE" TO LAS-FLD PERFORM LASF.

    MOVE "`(s10h0s3B`*p1910x030YIRVINE FASTENERS" TO LAS-FLD PERFORM LASF.
    MOVE "`(s16.66h0s0B`*p2000x080YIF-439 REV 0 03/14/05" TO LAS-FLD PERFORM LASF.
    MOVE "`(s12h1s3B`*p1230x226YTHE ACCEPTANCE CRITERION IS ZERO DISCREPANCIES" TO LAS-FLD PERFORM LASF.

    MOVE "`*p000x234Y`*c2400a4b0P`*p000x284Y`*c2400a4b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p000x286Y" TO LAS-FLD PERFORM LASF.
    PERFORM 28 TIMES MOVE "`*p+77Y`*c2400a2b0P" TO LAS-FLD PERFORM LASF END-PERFORM.
    MOVE "`*c2400a4b0P" TO LAS-FLD PERFORM LASF.

    MOVE "`*p000x234Y`*c4a2212b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p+780X`*c2a2212b0P`*p+210X`*c2a2212b0P`*p+210X`*c2a2212b0P`*p+210X`*c2a2212b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p+250X`*c4a2212b0P`*p+100X`*c2a2212b0P`*p+550X`*c2a2212b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p2396x234Y`*c4a2212b0P" TO LAS-FLD PERFORM LASF.

    STRING "`(s16.66h0s3B`*p012x276YCHARACTERISTIC`*p792XSPEC'S`*p1002XUNIT"
      "`*p1212XSET-UP`*p1422XCHECKED WITH`*p1672XS.P.`*p1772XRESULTS`*p2322XV/X"
      DELIMITED SIZE INTO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD3.
    MOVE "`*p000x2520Y`*c700a170b0P`*p002x2522Y`*c696a166b1P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p014x2590YLOT SIZE `*c508a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p014x2660YSAMPLE SIZE `*c454a2b0P" TO LAS-FLD PERFORM LASF.

    MOVE "`*p000x2760YINCREASED SAMPLE OF `*c258a2b0P`*p600X PCS" TO LAS-FLD PERFORM LASF.
    MOVE "`*p000x2830YFOR `*c598a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p000x2900YRESULTS `*c526a2b0P" TO LAS-FLD PERFORM LASF.

    MOVE "`*p860x2530Y`*c100a80b0P`*p862x2532Y`*c96a76b1P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1000x2540YACCEPT LOT NUMBER `*c676a2b0P`*p1000x2610YWEIGHT `*c874a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p860x2700Y`*c100a80b0P`*p862x2702Y`*c96a76b1P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1000x2710YREJECT D.M. NUMBER `*c658a2b0P`*p1000x2780YWEIGHT `*c874a2b0P" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1000x2900YINSPECTOR SIGNATURE `*c640a2b0P" TO LAS-FLD PERFORM LASF.

    PERFORM PCL-BOLD1.
    MOVE "`*p260x042Y" TO LAS-FLD PERFORM LASF MOVE R-NO TO FJ-N6 PERFORM LASF.
    MOVE "`*p260x+50Y" TO LAS-FLD PERFORM LASF MOVE P-NO TO LAS-FLD PERFORM LASF.
    MOVE "`*p260x+50Y" TO LAS-FLD PERFORM LASF MOVE SB-DRAW TO LAS-FLD PERFORM LASF.

    MOVE "`*p960x042Y" TO LAS-FLD PERFORM LASF MOVE SB-MAT TO LAS-FLD PERFORM LASF.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE "`*p960x+100Y" TO LAS-FLD PERFORM LASF MOVE D-DT TO FJ-NDT PERFORM LASF.

    MOVE 278 TO SB-YPOS MOVE 1 TO CAR-CH.
SB73. IF P-PCHAR(CAR-CH)=0 GO SB78. ADD 77 TO SB-YPOS.
    MOVE P-PCHAR(CAR-CH) TO T-NO PERFORM RD-CHAR IF A-S1=1 MOVE "*** UNDEFINED ***" TO CAR-DESC.
    PERFORM PCL-NORM2.
    MOVE 12 TO LAS-POSX MOVE SB-YPOS TO LAS-POSY MOVE LAS-POS TO LAS-FLD PERFORM LASF.
    MOVE CAR-DESC TO LAS-FLD PERFORM LASF.
    IF P-PCHAR(CAR-CH)=25
      MOVE "`*p792X" TO LAS-FLD PERFORM LASF MOVE P-PID TO LAS-FLD PERFORM LASF
     ELSE
      MOVE "`*p792x-35Y" TO LAS-FLD PERFORM LASF
      IF P-PMIN(CAR-CH)>0 MOVE P-PMIN(CAR-CH) TO FJ-D24 PERFORM LASF END-IF
      MOVE "`*p792x+35Y" TO LAS-FLD PERFORM LASF
      IF P-PMAX(CAR-CH)>0 MOVE P-PMAX(CAR-CH) TO FJ-D24 PERFORM LASF END-IF.
    PERFORM PCL-NORM3 PERFORM DESC-UNIT PERFORM DESC-INSTR.
    MOVE "`*p1002X" TO LAS-FLD PERFORM LASF MOVE CAR-UNIT TO LAS-FLD PERFORM LASF.
    IF CAR-INSTR-A(2)=" "
      MOVE "`*p1422X" TO LAS-FLD PERFORM LASF MOVE CAR-INSTR-A(1) TO LAS-FLD PERFORM LASF
     ELSE
      MOVE "`*p1422x-35Y" TO LAS-FLD PERFORM LASF MOVE CAR-INSTR-A(1) TO LAS-FLD PERFORM LASF
      MOVE "`*p1422x+35Y" TO LAS-FLD PERFORM LASF MOVE CAR-INSTR-A(2) TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM2.
    MOVE "`*p1672X" TO LAS-FLD PERFORM LASF.
    IF CAR-SAMPLE>0 MOVE CAR-SAMPLE TO FJ-N3 PERFORM LASF.
SB78. ADD 1 TO CAR-CH IF CAR-CH<=CAR-PHYS-NUM GO SB73.
    PERFORM PCL-ENDFL GO SB3.
SB8. PERFORM CLOSE-LAS CLOSE PDRAWINGS.
    MOVE "CENTRAL" TO LAS-QUEUE PERFORM PRINT-LAS.
SB9. GO MN9.

* M-14 PHYSICAL SPECS MAINTENANCE
VA1. PERFORM WRT132 MOVE " " TO VA-PROD.
VA3. PERFORM RD198 PERFORM WRT PERFORM RD198A PERFORM WRT.
VA33. ACCEPT VA-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR VA-PROD=ALL "9" GO VA9.
    MOVE VA-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VA33.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 3 COLUMN 25.
    PERFORM VA-D.
VA5. ACCEPT VA-FUNC LINE 21 COLUMN 79 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF VA-FUNC=0 GO VA3.
    GO VA52 VA54 VA54 VA56  DEPENDING VA-FUNC. PERFORM DSP-ERR1 GO VA5.

VA52.
VA523. PERFORM VA-E.
    DISPLAY "ADD CHARACTERISTIC" LINE 24 BOLD "   - TO END, LEAVE CHARACTERISTIC BLANK".
    ACCEPT VA-PCHAR LINE IXT COLUMN 1 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF VA-PCHAR=0 GO VA529.
    MOVE VA-PCHAR TO T-NO PERFORM RD-CHAR IF A-S1=1 PERFORM DSP-ERR55 GO VA523.
    DISPLAY CAR-DESC LINE IXT COLUMN 5.
    PERFORM DESC-UNIT DISPLAY CAR-UNIT-A LINE IXT COLUMN 58.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-PHYS-NUM OR P-PCHAR(IX1)=0
      IF P-PCHAR(IX1)=VA-PCHAR MOVE "THIS CHARACTERISTIC IS ALREADY IN THE LIST"
        TO ERR-MESG PERFORM DSP-ERR GO VA523 END-IF END-PERFORM.
    IF IX1>CAR-PHYS-NUM MOVE "TOO MANY CHARACTERISTICS" TO ERR-MESG PERFORM DSP-ERR GO VA523.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL P-PCHAR(IX1)=0 OR>VA-PCHAR CONTINUE END-PERFORM.
    IF P-PCHAR(IX1) NOT=0 PERFORM VARYING IX2 FROM 27 BY -1 UNTIL IX2<IX1
      MOVE P-PVAL(IX2) TO P-PVAL(IX2 + 1) END-PERFORM.
    MOVE VA-PCHAR TO P-PCHAR(IX1).
    IF VA-PCHAR=25
      ACCEPT P-PID LINE IXT COLUMN 38 DEFAULT " " UNDERLINED PROTECTED EDITING
     ELSE
      ACCEPT P-PMIN(IX1) LINE IXT COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      ACCEPT P-PMAX(IX1) LINE IXT COLUMN 48 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM VA-D PERFORM VA-PMOD GO VA523.
VA529. GO VA5.

VA54.
VA543. PERFORM VA-E.
    IF VA-FUNC=2 DISPLAY "CHANGE MIN/MAX VALUES" LINE 24 BOLD "   - TO END, LEAVE CHARACTERISTIC BLANK"
      ELSE DISPLAY "DELETE CHARACTERISTIC" LINE 24 BOLD "   - TO END, LEAVE CHARACTERISTIC BLANK".
    ACCEPT VA-PCHAR LINE IXT COLUMN 1 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF VA-PCHAR=0 GO VA549.
    MOVE VA-PCHAR TO T-NO PERFORM RD-CHAR IF A-S1=1 PERFORM DSP-ERR55 GO VA543.
    DISPLAY CAR-DESC LINE IXT COLUMN 5.
    IF VA-FUNC=2 PERFORM DESC-UNIT DISPLAY CAR-UNIT-A LINE IXT COLUMN 58.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-PHYS-NUM OR P-PCHAR(IX1)=0
      IF P-PCHAR(IX1)=VA-PCHAR GO VA544 END-IF END-PERFORM.
    MOVE "THIS CHARACTERISTIC IS NOT IN THE LIST"
      TO ERR-MESG PERFORM DSP-ERR GO VA543.
VA544. IF VA-FUNC=3 PERFORM VARYING IX2 FROM IX1 BY 1 UNTIL IX2=CAR-PHYS-NUM
        MOVE P-PVAL(IX2 + 1) TO P-PVAL(IX2) END-PERFORM
      INITIALIZE P-PVAL(IX2) GO VA548.
    IF CAR-NUM=25
      ACCEPT P-PID LINE IXT COLUMN 38 DEFAULT CURRENT UNDERLINED PROTECTED EDITING
     ELSE
      DISPLAY P-PMIN(IX1) LINE IXT COLUMN 38 CONVERSION
      DISPLAY P-PMAX(IX1) LINE IXT COLUMN 48 CONVERSION
      ACCEPT P-PMIN(IX1) LINE IXT COLUMN 38 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY P-PMIN(IX1) LINE IXT COLUMN 38 CONVERSION
      ACCEPT P-PMAX(IX1) LINE IXT COLUMN 48 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY P-PMAX(IX1) LINE IXT COLUMN 48 CONVERSION.
VA548. PERFORM VA-D PERFORM VA-PMOD GO VA543.
VA549. GO VA5.

VA56.
VA563. DISPLAY "COPY ALL CHARACTERISTICS FROM PRODUCT NO. ____________" LINE 24 BOLD
         "   - TO CANCEL REQUEST, LEAVE PRODUCT BLANK".
    ACCEPT P-NO LINE 24 COLUMN 43 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF P-NO=" " MOVE VA-PROD TO P-NO READ PRODUCT REGARDLESS GO VA569.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VA563.
    PERFORM VA-PTOF MOVE VA-PROD TO P-NO PERFORM RDLK-PRODUCT PERFORM VA-FTOP.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    PERFORM VA-D.
VA569. GO VA5.

VA9. PERFORM WRT80 GO MN9.

VA-E. MOVE 22 TO IXT DISPLAY TLNW(IXT)(1:62) LINE IXT.
VA-D. PERFORM VA-D1 THRU VA-D9.
VA-D1. MOVE 1 TO A-X1 MOVE 6 TO IXT.
VA-D3. DISPLAY " " LINE IXT ERASE LINE.
    IF P-PCHAR(A-X1)>0 MOVE A-X1 TO A-X2 MOVE 1 TO IXU PERFORM VA-DC.
    COMPUTE A-X2=A-X1 + 14 IF P-PCHAR(A-X2)>0 MOVE 71 TO IXU PERFORM VA-DC.
    ADD 1 TO A-X1 IXT IF A-X1<=14 GO VA-D3.
VA-D9. EXIT.
VA-DC. MOVE P-PCHAR(A-X2) TO T-NO PERFORM RD-CHAR.
    DISPLAY CAR-NUM LINE IXT COLUMN IXU CONVERSION CAR-DESC COLUMN IXU PLUS 4.
    IF CAR-NUM=25 DISPLAY P-PID LINE IXT COLUMN IXU PLUS 37
      ELSE DISPLAY P-PMIN(A-X2) LINE IXT COLUMN IXU PLUS 37 CONVERSION
           DISPLAY P-PMAX(A-X2) LINE IXT COLUMN IXU PLUS 47 CONVERSION.
    PERFORM DESC-UNIT DISPLAY CAR-UNIT-A LINE IXT COLUMN IXU PLUS 57.
VA-PMOD. PERFORM VA-PTOF PERFORM RDLK-PRODUCT PERFORM VA-FTOP.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
VA-PTOF. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>CAR-PHYS-NUM
      MOVE P-PVAL(A-X1) TO VA-PVAL(A-X1) END-PERFORM.
    MOVE P-PID TO VA-PID.
VA-FTOP. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>CAR-PHYS-NUM
      MOVE VA-PVAL(A-X1) TO P-PVAL(A-X1) END-PERFORM.
    MOVE VA-PID TO P-PID.

* M-15 CHARACTERISTICS LISTING
VW1. PERFORM RD199 PERFORM WRT.
    MOVE 11 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 1 TO VW-STEP PERFORM VW-PAGE.

    MOVE "PHYSICAL CHARACTERISTICS" TO PREC PERFORM VW-LINE 2 TIMES.
    MOVE 24 TO T-TBL MOVE 0 TO T-NO.
    START TABLES KEY>T-KEY REGARDLESS INVALID GO VW4.
VW3. READ TABLES NEXT REGARDLESS END GO VW4. IF T-TBL>24 GO VW4.
    MOVE T-LINE TO CAR-DATA MOVE CAR-NUM TO FA697 MOVE CAR-DESC TO FA698.
    PERFORM DESC-INSTR MOVE CAR-INSTRUMENT TO FA699.
    PERFORM DESC-UNIT MOVE CAR-UNIT TO FA700.
    MOVE CAR-SAMPLE TO FA701 PERFORM VW-LINE GO VW3.
VW4. PERFORM VW-PAGE.
    MOVE "HEAT TREATMENT CHARACTERISTICS" TO PREC PERFORM VW-LINE 2 TIMES.
    PERFORM VARYING CAR-CH FROM 1 BY 1 UNTIL CAR-CH>CAR-HEAT-NUM
      MOVE CAR-HEAT(CAR-CH) TO CAR-DATA PERFORM VW-P END-PERFORM.
    PERFORM VW-LINE 3 TIMES.
    MOVE "MECHANICAL CHARACTERISTICS" TO PREC PERFORM VW-LINE 2 TIMES.
    PERFORM VARYING CAR-CH FROM 1 BY 1 UNTIL CAR-CH>CAR-MECH-NUM
      MOVE CAR-MECH(CAR-CH) TO CAR-DATA PERFORM VW-P END-PERFORM.

    MOVE 2 TO VW-STEP PERFORM VW-PAGE.
    MOVE CAR-INSTR-NUM TO WN1 IF CAR-UNIT-NUM>CAR-INSTR-NUM MOVE CAR-UNIT-NUM TO WN1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>WN1
      IF IX1<=CAR-INSTR-NUM MOVE IX1 TO FA693
        STRING CAR-INSTR-DESC(IX1,1) " " CAR-INSTR-DESC(IX1,2) DELIMITED "  " INTO FA694 END-IF
      IF IX1<=CAR-UNIT-NUM MOVE IX1 TO FA695 MOVE CAR-UNIT-DESC(IX1) TO FA696 END-IF
      PERFORM VW-LINE END-PERFORM.
    PERFORM CLOSE-PR.
VW9. GO MN9.

VW-P. MOVE CAR-NUM TO FA697 MOVE CAR-DESC TO FA698.
    PERFORM DESC-INSTR MOVE CAR-INSTRUMENT TO FA699.
    PERFORM DESC-UNIT MOVE CAR-UNIT TO FA700 PERFORM VW-LINE.
VW-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM VW-PAGE.
VW-PAGE. MOVE "CHARACTERISTICS LISTING" TO FF3 PERFORM PR-PAGE.
    IF VW-STEP=1 MOVE
         "CHARACTERISTIC                         INSTRUMENT               UNIT       SAMPLES" TO PREC PERFORM PR-LINE-3.
*         ...  ...............................   ......................   ..........   ...
    IF VW-STEP=2 MOVE
         "INSTRUMENT CODES                 UNIT OF MEASURE CODES" TO PREC PERFORM PR-LINE-3.
*         ..  ......................       ..  ..........

* M-16 SHOW HEAT TREATMENT SPECS
VJ1. PERFORM RD205 PERFORM WRT MOVE " " TO VJ-PROD.
VJ3. ACCEPT VJ-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR VJ-PROD=ALL "9" GO VJ9.
    MOVE VJ-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VJ3.
    PERFORM PROD-DESC MOVE 1 TO IX1 IXT.
    PERFORM UNTIL IX1>3 DISPLAY PRO-DESC(IX1) LINE IXT COLUMN 49 ADD 1 TO IX1 IXT END-PERFORM.
    DISPLAY " " LINE 6 ERASE END SCREEN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-HEAT-NUM
      IF P-HMIN(IX1)>0 OR P-HMAX(IX1)>0 GO VJ4 END-IF END-PERFORM.
    DISPLAY "** NO HEAT CHARACTERISTICS DEFINED **" LINE 6 GO VJ8.
VJ4. MOVE 1 TO CAR-CH MOVE 5 TO IXT.
VJ5. IF CAR-CH>CAR-HEAT-NUM GO VJ8. MOVE CAR-HEAT(CAR-CH) TO CAR-DATA.
    IF CAR-DESC=" " OR (P-HMIN(CAR-CH)=0 AND P-HMAX(CAR-CH)=0) GO VJ6.
    ADD 1 TO IXT IF IXT>23 GO VJ8.
    DISPLAY CAR-CH LINE IXT COLUMN 1 CONVERSION CAR-DESC(1:28) COLUMN 4.
    MOVE 33 TO IXU MOVE P-HMIN(CAR-CH) TO CAR-VAL PERFORM DSP-HVAL.
    MOVE 41 TO IXU MOVE P-HMAX(CAR-CH) TO CAR-VAL PERFORM DSP-HVAL.
    PERFORM DESC-UNIT DISPLAY CAR-UNIT LINE IXT COLUMN 50.
    PERFORM DESC-INSTR DISPLAY CAR-INSTRUMENT(1:19) LINE IXT COLUMN 62.
VJ6. ADD 1 TO CAR-CH GO VJ5.
VJ8. GO VJ3.
VJ9. GO MN9.

* M-17 HEAT TREATMENT SPECS MAINTENANCE
VC1. MOVE " " TO VC-PROD.
VC3. PERFORM RD204 PERFORM WRT.
VC33. ACCEPT VC-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR VC-PROD=ALL "9" GO VC9.
    MOVE VC-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VC33.
    PERFORM PROD-DESC MOVE 1 TO IX1 IXT.
    PERFORM UNTIL IX1>3 DISPLAY PRO-DESC(IX1) LINE IXT COLUMN 49 ADD 1 TO IX1 IXT END-PERFORM.

    MOVE 1 TO CAR-CH MOVE 6 TO IXT.
VC37. IF CAR-CH>CAR-HEAT-NUM OR IXT>23 GO VC4. MOVE CAR-HEAT(CAR-CH) TO CAR-DATA.
    IF CAR-DESC=" " GO VC38.
    DISPLAY CAR-CH LINE IXT COLUMN 1 CONVERSION CAR-DESC(1:28) COLUMN 4.
    MOVE 33 TO IXU MOVE P-HMIN(CAR-CH) TO CAR-VAL PERFORM DSP-HVAL.
    MOVE 41 TO IXU MOVE P-HMAX(CAR-CH) TO CAR-VAL PERFORM DSP-HVAL.
    PERFORM DESC-UNIT DISPLAY CAR-UNIT LINE IXT COLUMN 50.
    PERFORM DESC-INSTR DISPLAY CAR-INSTRUMENT(1:19) LINE IXT COLUMN 62.
VC38. ADD 1 TO CAR-CH IXT GO VC37.

VC4. MOVE 1 TO CAR-CH MOVE 6 TO IXT.
VC43. IF CAR-CH>CAR-HEAT-NUM OR IXT>23 GO VC8. MOVE CAR-HEAT(CAR-CH) TO CAR-DATA.
    IF CAR-DESC=" " GO VC48. PERFORM DSP-PF3.
    MOVE 33 TO IXU MOVE P-HMIN(CAR-CH) TO CAR-VAL.
    IF CAR-CH=11 ACCEPT CAR-TVAL LINE IXT COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY
     ELSE ACCEPT CAR-VAL LINE IXT COLUMN IXU PLUS 1 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    PERFORM DSP-HVAL MOVE CAR-VAL TO VC-HMIN.
    PERFORM DSP-ERS IF KPF3 GO VC8.
    MOVE 41 TO IXU MOVE P-HMAX(CAR-CH) TO CAR-VAL.
    IF CAR-CH=11 ACCEPT CAR-TVAL LINE IXT COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION
     ELSE ACCEPT CAR-VAL LINE IXT COLUMN IXU PLUS 1 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION.
    PERFORM DSP-HVAL MOVE CAR-VAL TO VC-HMAX.
    PERFORM RDLK-PRODUCT MOVE VC-HMIN TO P-HMIN(CAR-CH) MOVE VC-HMAX TO P-HMAX(CAR-CH).
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
VC48. ADD 1 TO CAR-CH IXT GO VC43.
VC8. PERFORM DSP-CONT GO VC3.
VC9. GO MN9.

* M-18 MISCELLANEOUS INQUIRIES
OT1. PERFORM RD278 PERFORM WRT.
    ACCEPT OT-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR OT-SEL=99 GO OT9. PERFORM DSP-CLS.
    GO OT10  DEPENDING OT-SEL. GO OT1.

OT10. PERFORM RD278A PERFORM WRT.
    MOVE 0 TO OT-NM MOVE 7 TO IXT MOVE 8 TO IXU.
OT11. IF OT-NM=10 ADD 1 TO IXT MOVE 8 TO IXU. ADD 1 TO OT-NM ADD 6 TO IXU.
OT113. ACCEPT XN4 LINE IXT COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF XN4=0 SUBTRACT 1 FROM OT-NM GO OT118.
    MOVE XN4 TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO OT113.
    MOVE XN4 TO OT-MO(OT-NM) IF OT-NM<20 GO OT11.
OT118.

OT13. MOVE 10 TO IXT MOVE 13 TO IXU MOVE 34 TO IXV PERFORM AX-DATE-R.
    MOVE SYS-DATE TO WN2 D-DATE PERFORM D-NM MOVE D-DT TO DSP-DT2.
    SUBTRACT 1 FROM D-YY MOVE 1 TO D-MM D-DD MOVE D-DT TO DSP-DT1.
    PERFORM D-MN MOVE D-DATE TO WN1.
    IF DATE1<WN1 OR DATE2>WN2 MOVE " " TO ERR-MESG
      STRING "'FROM'-'TO' DATES CANNOT BE OUTSIDE RANGE " DSP-DT1 " - " DSP-DT2
      DELIMITED SIZE INTO ERR-MESG PERFORM DSP-ERR GO OT13.
    MOVE 10 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO OT9. PERFORM DSP-QWAIT.

* note 236
    MOVE 0 TO OT-TNUM OT-TQTY OT-TWEIGHT MOVE -1 TO OLD-N.
    INITIALIZE J-KEY START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO OT18.
OT15. READ WORKSHEET NEXT REGARDLESS END GO OT18.
    IF J-NO NOT=OLD-N IF OLD-N NOT=-1 PERFORM OT-M END-IF
      MOVE J-NO TO OLD-N MOVE 0 TO OT-QTY OT-WEIGHT OT-KAS.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF NOT(J-DATE>=DATE1 AND<=DATE2) GO OT16.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>OT-NM
      IF J-MAC=OT-MO(IX1) MOVE 1 TO OT-KAS GO OT16 END-IF END-PERFORM.
OT16. IF PROC-REJECT ADD J-QTY TO OT-QTY MOVE J-AWEIGHT TO WN1
        IF WN1=0 MOVE J-WEIGHT TO WN1 END-IF ADD WN1 TO OT-WEIGHT.
    GO OT15.
OT18. PERFORM OT-M PERFORM DSP-ERS.
    MOVE OT-TNUM TO DSP-N31 MOVE OT-TQTY TO DSP-C81 MOVE OT-TWEIGHT TO DSP-C82.
    DISPLAY DSP-N31 LINE 12 COLUMN 16 DSP-C81 COLUMN 36 DSP-C82 COLUMN 66.
    PERFORM DSP-CONT GO OT9.

OT9. GO MN9.

OT-M. IF OT-KAS=1 AND NOT(OT-QTY=0 AND OT-WEIGHT=0)
       ADD 1 TO OT-TNUM ADD OT-QTY TO OT-TQTY ADD OT-WEIGHT TO OT-TWEIGHT.

* M-19 QUARANTINE/RELEASE BINS
VD1.
VD3. PERFORM RD148 PERFORM WRT.
VD33. ACCEPT P-NO LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR P-NO=ALL "9" GO VD9.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VD33.
    PERFORM RD-GEN PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 4 COLUMN 11.
    ACCEPT VD-LOT LINE 3 COLUMN 35 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
VD35. DISPLAY "'Q' TO QUARANTINE BINS, OR BLANK TO RELEASE BINS" LINE 24 BOLD.
    ACCEPT VD-Q LINE 3 COLUMN 73 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF NOT(VD-Q="Q" OR " ") PERFORM DSP-ERR2 GO VD35.
    MOVE " " TO VD-QR IF VD-Q=" " GO VD4.
VD37. ACCEPT VD-QR LINE 4 COLUMN 73 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF VD-QR=" " PERFORM DSP-ERR2 GO VD37.
VD4. IF VD-Q="Q" DISPLAY "THESE BINS WILL BE QUARANTINED:" LINE 5 BOLD
      ELSE DISPLAY "THESE BINS WILL BE RELEASED:" LINE 5 BOLD.
    MOVE 6 TO IXT MOVE 1 TO IXCOL MOVE 0 TO VD-CODE.

    INITIALIZE B-KP MOVE P-NO TO B-PROD MOVE VD-LOT TO B-LOT PERFORM SET-B-LYEAR.
    START BIN KEY>=B-KP REGARDLESS INVALID GO VD6.
VD5. READ BIN NEXT REGARDLESS END GO VD6. IF NOT(B-PROD=P-NO AND B-LOT=VD-LOT) GO VD6.
    COMPUTE IXU=(IXCOL - 1) * 8 + 1 DISPLAY B-NO LINE IXT COLUMN IXU.
    IF VD-CODE=0 MOVE 1 TO VD-CODE.
    IF VD-Q="Q" AND B-QTY-AL NOT=0 MOVE 2 TO VD-CODE
      DISPLAY B-NO LINE IXT COLUMN IXU BLINKING.
    ADD 1 TO IXCOL IF IXCOL>10 MOVE 1 TO IXCOL ADD 1 TO IXT
      IF IXT>23 MOVE 6 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    GO VD5.
VD6. IF VD-CODE=0 MOVE "NO BINS FOUND" TO ERR-MESG PERFORM DSP-ERR GO VD3.
    IF VD-CODE=2 MOVE "WARNING - THE HIGHLIGHTED BINS ARE ALLOCATED AND WILL NOT BE QUARANTINED"
      TO ERR-MESG PERFORM DSP-ERR.
    DISPLAY "'OK' TO MODIFY BINS: __" LINE 5 COLUMN 56 BOLD.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO VD8.

    INITIALIZE B-KP MOVE P-NO TO B-PROD MOVE VD-LOT TO B-LOT PERFORM SET-B-LYEAR.
    START BIN KEY>=B-KP REGARDLESS INVALID GO VD8.
VD7. READ BIN NEXT REGARDLESS END GO VD8. IF NOT(B-PROD=P-NO AND B-LOT=VD-LOT) GO VD8.
    IF NOT(VD-Q="Q" AND B-QTY-AL NOT=0) MOVE VD-Q TO B-CONT MOVE VD-QR TO B-QREASON
      REWRITE B-RECORD ALLOWING NO UNLOCK BIN.
    GO VD7.
VD8. GO VD3.
VD9. GO MN9.

* M-20 MECHANICAL SPECS MAINTENANCE
VF1. MOVE " " TO VF-PROD.
VF3. PERFORM RD228 PERFORM WRT.
VF33. ACCEPT VF-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR VF-PROD=ALL "9" GO VF9.
    MOVE VF-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VF33.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 4 COLUMN 11.
    PERFORM VARYING CAR-CH FROM 1 BY 1 UNTIL CAR-CH>CAR-MECH-NUM
      IF P-SUNIT(CAR-CH)>" " GO VF36 END-IF END-PERFORM.
    PERFORM RDLK-PRODUCT.
    PERFORM VARYING CAR-CH FROM 1 BY 1 UNTIL CAR-CH>CAR-MECH-NUM
      MOVE CAR-MECH(CAR-CH) TO CAR-DATA
      PERFORM DESC-UNIT MOVE CAR-UNIT-A TO P-SUNIT(CAR-CH) END-PERFORM.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.

VF36. READ PRODUCT REGARDLESS MOVE 1 TO CAR-CH MOVE 6 TO IXT.
VF37. IF CAR-CH>CAR-MECH-NUM GO VF4. MOVE CAR-MECH(CAR-CH) TO CAR-DATA.
    IF CAR-DESC=" " GO VF38.
    DISPLAY CAR-CH LINE IXT COLUMN 1 CONVERSION CAR-DESC(1:25) COLUMN 4.
    IF CAR-CH=10 DISPLAY P-SDECARB LINE IXT COLUMN 30
      ELSE MOVE P-SMIN(CAR-CH) TO CAR-FLD MOVE 30 TO IXU PERFORM VF-D
           MOVE P-SMAX(CAR-CH) TO CAR-FLD MOVE 41 TO IXU PERFORM VF-D.
    DISPLAY P-SUNIT(CAR-CH) LINE IXT COLUMN 53.
    PERFORM DESC-INSTR DISPLAY CAR-INSTRUMENT(1:21) LINE IXT COLUMN 60.
VF38. ADD 1 TO CAR-CH IXT GO VF37.

VF4. MOVE 1 TO CAR-CH MOVE 6 TO IXT.
VF43. IF CAR-CH>CAR-MECH-NUM GO VF8. MOVE CAR-MECH(CAR-CH) TO CAR-DATA.
    IF CAR-DESC=" " GO VF68. PERFORM DSP-PF3.
    IF CAR-CH=10 ACCEPT P-SDECARB LINE IXT COLUMN 30 DEFAULT CURRENT
       UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS IF KPF3 GO VF8 END-IF
      MOVE P-SDECARB TO WA1 PERFORM RDLK-PRODUCT MOVE WA1 TO P-SDECARB GO VF6.
    MOVE P-SMIN(CAR-CH) TO CAR-FLD MOVE 30 TO IXU PERFORM VF-A PERFORM VF-D PERFORM DSP-ERS.
    MOVE CAR-FLD TO P-SMIN(CAR-CH) IF KPF3 GO VF8.
    MOVE P-SMAX(CAR-CH) TO CAR-FLD MOVE 41 TO IXU PERFORM VF-A PERFORM VF-D.
    MOVE CAR-FLD TO P-SMAX(CAR-CH).
    ACCEPT P-SUNIT(CAR-CH) LINE IXT COLUMN 53 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE P-SMIN(CAR-CH) TO WV1 MOVE P-SMAX(CAR-CH) TO WV2 MOVE P-SUNIT(CAR-CH) TO WA1.
    PERFORM RDLK-PRODUCT.
    MOVE WV1 TO P-SMIN(CAR-CH) MOVE WV2 TO P-SMAX(CAR-CH) MOVE WA1 TO P-SUNIT(CAR-CH).
VF6. REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
VF68. ADD 1 TO CAR-CH IXT GO VF43.
VF8. PERFORM DSP-CONT GO VF3.
VF9. GO MN9.

VF-D. IF CAR-CH=13 OR 14 MOVE CAR-FLD TO CAR-N0 DISPLAY CAR-N0 LINE IXT COLUMN IXU CONVERSION.
    IF CAR-CH<=9 MOVE CAR-FLD TO CAR-N1 DISPLAY CAR-N1 LINE IXT COLUMN IXU CONVERSION.
    IF CAR-CH=11 MOVE CAR-FLD TO CAR-N3 DISPLAY CAR-N3 LINE IXT COLUMN IXU CONVERSION.
    IF CAR-CH=12 MOVE CAR-FLD TO CAR-N4 DISPLAY CAR-N4 LINE IXT COLUMN IXU CONVERSION.
    REPLACE ==ACC-NUM== BY ==LINE IXT COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY==.
VF-A. IF CAR-CH=13 OR 14 MOVE CAR-FLD TO CAR-N0 ACCEPT CAR-N0 ACC-NUM MOVE CAR-N0 TO CAR-FLD.
    IF CAR-CH<=9 MOVE CAR-FLD TO CAR-N1 ACCEPT CAR-N1 ACC-NUM MOVE CAR-N1 TO CAR-FLD.
    IF CAR-CH=11 MOVE CAR-FLD TO CAR-N3 ACCEPT CAR-N3 ACC-NUM MOVE CAR-N3 TO CAR-FLD.
    IF CAR-CH=12 MOVE CAR-FLD TO CAR-N4 ACCEPT CAR-N4 ACC-NUM MOVE CAR-N4 TO CAR-FLD.
    REPLACE OFF.

* M-21 HEAT FILE LISTING
HP1. PERFORM RD251 PERFORM WRT.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 40 TO IXV PERFORM AX-HEAT-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM HP-PAGE.
    MOVE HEAT1 TO HE-NO START HEAT KEY>=HE-KEY REGARDLESS INVALID GO HP9.
HP3. READ HEAT NEXT REGARDLESS END GO HP9. IF HE-NO>HEAT2 GO HP9.
    MOVE HE-NO TO FG211 MOVE HE-GRADE TO FG211A MOVE HE-DIVAL TO FG211B.
    MOVE HE-C TO FG214(1) MOVE HE-MN TO FG214(2) MOVE HE-P TO FG215(3).
    MOVE HE-S TO FG215(4) MOVE HE-SI TO FG214(5) MOVE HE-CU TO FG214(6).
    MOVE HE-NI TO FG214(7) MOVE HE-CR TO FG214(8) MOVE HE-MO TO FG215(9).
    MOVE HE-SN TO FG215(10) MOVE HE-AL TO FG215(11) MOVE HE-B TO FG213(12).
    MOVE HE-V TO FG215(13) MOVE HE-CO TO FG215(14) MOVE HE-N TO FG213(15).
    PERFORM HP-LINE GO HP3.
HP9. PERFORM CLOSE-PR GO MN9.

HP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HP-PAGE.
HP-PAGE. MOVE "HEAT FILE LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-HEAT.
    MOVE "HEAT NO.    GRADE     DI      C      MN     P      S      SI     CU     NI     CR     MO     SN     AL     B      V      CO     N" TO PREC PERFORM PR-LINE-3.
*         ..........  ........ .:..   .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:.... .:....

* M-22 LOT METALLURGICAL TEST REPORT
IT1. PERFORM RD252 PERFORM WRT MOVE 0 TO IT-RN MOVE 2 TO IXT.
IT13. ADD 1 TO IT-RN IXT.
    ACCEPT LOT1 LINE IXT COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF LOT1=0 SUBTRACT 1 FROM IT-RN GO IT14.
    ACCEPT LOT2 LINE IXT COLUMN 32 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE LOT1 TO RNUM1(IT-RN) MOVE LOT2 TO RNUM2(IT-RN) IF IT-RN<10 GO IT13.
IT14. ACCEPT XA3 LINE 15 COLUMN 25 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO IT-KB ELSE MOVE 0 TO IT-KB.
    ACCEPT XA3 LINE 16 COLUMN 25 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO IT-KP ELSE MOVE 0 TO IT-KP.
    MOVE 18 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-DOC.
    PERFORM PCL-INIT PERFORM PCL-START PERFORM PCL-BOLD3 PERFORM LAS-DOCLINE.

    MOVE 0 TO IT-IX1.
IT3. ADD 1 TO IT-IX1 IF IT-IX1>IT-RN GO IT9.
    MOVE RNUM1(IT-IX1) TO LT-NO START LOT KEY>=LT-KEY REGARDLESS INVALID GO IT8.
IT5. READ LOT NEXT REGARDLESS END GO IT8. IF LT-NO>RNUM2(IT-IX1) GO IT8.
    IF NOT(IT-KB=1 AND LT-FINISH=LIT-BARE OR IT-KP=1 AND LT-FINISH NOT=LIT-BARE) GO IT5.
    PERFORM MR-PAGE.
    MOVE "      PART NO.      DESCRIPTION" TO PREC PERFORM MR-LINE 2 TIMES.
    MOVE LT-PROD TO FG244 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FG245.
    PERFORM MR-LINE.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO FG245 PERFORM MR-LINE END-PERFORM.
    PERFORM MR-LINE 2 TIMES.
    MOVE "--- STEEL CHEMISTRY ---" TO PREC(21:) PERFORM MR-LINE 2 TIMES.
    MOVE CHM-HTITLE TO PREC(7:) PERFORM MR-LINE 2 TIMES.
    MOVE LT-HEAT TO FG246 HE-NO.
    READ HEAT REGARDLESS INVALID MOVE "NOT ON FILE" TO FG247 GO IT56.
    PERFORM MR-HEAT.
IT56. MOVE " " TO MEC-MFLDS PERFORM MR-LINE 3 TIMES.
    MOVE "--- MECHANICAL PROPERTIES ---" TO PREC(21:) PERFORM MR-LINE 2 TIMES.
    MOVE "       LOT           SPECIFICATION" TO MEC-TL0.
*              .......         ....................
    MOVE LT-NO TO MEC-FL03 IF LT-ALOT>" " MOVE LT-ALOT TO MEC-FL03X.
    MOVE LT-SPEC TO MEC-FL05 PERFORM MR-LOT.
    MOVE " " TO C-NO PERFORM MR-NOTE GO IT5.
IT8. GO IT3.
IT9. PERFORM PCL-END PERFORM LAS-DOCLINE.
    PERFORM CLOSE-DOC GO MN9.

* M-23 METALLURGICAL TEST REPORT
MR1. PERFORM RD253 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT OPEN I-O HTRANS ALLOWING ALL PERFORM OPEN-DOC.
    PERFORM PCL-INIT PERFORM PCL-START PERFORM PCL-BOLD3 PERFORM LAS-DOCLINE.

    MOVE 0 TO OLD-INVLN.
MR3. MOVE OLD-INVLN TO HT-INVLN MOVE 9999 TO HT-LYEAR MOVE 9999999 TO HT-LOT.
    START HTRANS KEY>HT-KEY REGARDLESS INVALID GO MR9.
MR33. READ HTRANS NEXT REGARDLESS END GO MR9. IF HT-IND=1 GO MR33.
    MOVE HT-INVLN TO OLD-INVLN MOVE 0 TO MR-QTY.
    INITIALIZE HT-KEY MOVE OLD-INVLN TO HT-INVLN.
    START HTRANS KEY>=HT-KEY REGARDLESS INVALID GO MR36.
MR35. READ HTRANS NEXT REGARDLESS END GO MR36. IF HT-INVLN NOT=OLD-INVLN GO MR36.
    ADD HT-QTY TO MR-QTY GO MR35.
MR36.

    MOVE 0 TO MR-LN INITIALIZE HT-KEY MOVE OLD-INVLN TO HT-INVLN.
    START HTRANS KEY>=HT-KEY REGARDLESS INVALID GO MR6.
MR5. READ HTRANS NEXT REGARDLESS END GO MR6. IF HT-INVLN NOT=OLD-INVLN GO MR6.
    ADD 1 TO MR-LN PERFORM MR-PAGE MOVE HT-CUS TO A-A1 PERFORM RD-CUS.
    IF HT-SHIPTO=0 GO MR52. MOVE HT-CUS TO SA-CUS MOVE HT-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO MR52. MOVE SA-NAME TO HT-NAME.
    MOVE SA-ADD1 TO HT-ADD1 MOVE SA-ADD2 TO HT-ADD2 MOVE SA-POST TO HT-POST.
MR52. MOVE "SOLD TO:" TO FG219 MOVE C-NAME TO FG220 MOVE "SHIP TO:" TO FG221.
    IF HT-SHIPTO=0 AND HT-NAME=" " MOVE "S A M E" TO FG222 ELSE MOVE HT-NAME TO FG222.
    MOVE "ORDER NO." TO FG223 MOVE HT-CUSORD TO FG224 PERFORM MR-LINE.
    MOVE C-ADD1 TO FG220 MOVE HT-ADD1 TO FG222.
    MOVE "INVOICE NO." TO FG223 MOVE HT-INV TO FG225 PERFORM MR-LINE.
    MOVE C-ADD2 TO FG220 A-A1 PERFORM STR-LTH MOVE C-POST TO FG220(A-N1 + 3:).
    MOVE HT-ADD2 TO FG222 A-A1 PERFORM STR-LTH MOVE HT-POST TO FG222(A-N1 + 3:).
    MOVE "B/L NO." TO FG223 MOVE HT-BL TO FG225 PERFORM MR-LINE 3 TIMES.
    MOVE "LINE  PART NO.      DESCRIPTION                         LINE QTY     LOT QTY"
*          ..   ............  ................................ ..,...,...- ..,...,...-
      TO PREC PERFORM MR-LINE 2 TIMES.
    MOVE OLD-LN TO FG226 MOVE HT-PROD TO FG227 A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO FG228 MOVE MR-QTY TO FG229 MOVE HT-QTY TO FG229A.
    PERFORM MR-LINE.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO FG228 PERFORM MR-LINE END-PERFORM.
    IF HT-CUSPART>" " STRING "CUSTOMER PART: " HT-CUSPART DELIMITED SIZE
      INTO FG228 PERFORM MR-LINE.
    PERFORM MR-LINE 2 TIMES.
    MOVE "--- STEEL CHEMISTRY ---" TO PREC(21:) PERFORM MR-LINE 2 TIMES.
    MOVE "ITEM" TO FG238 MOVE CHM-HTITLE TO PREC(7:) PERFORM MR-LINE 2 TIMES.
    MOVE MR-LN TO FG230 MOVE HT-LOT TO A-N1 PERFORM RD-LOT.
    INITIALIZE HE-REC MOVE LT-HEAT TO FG231 HE-NO.
    READ HEAT REGARDLESS INVALID MOVE "NOT ON FILE" TO FG235A GO MR54.
    PERFORM MR-HEAT.
MR54. PERFORM MR-LINE 3 TIMES.
    MOVE "--- MECHANICAL PROPERTIES ---" TO PREC(21:) PERFORM MR-LINE 2 TIMES.
    MOVE " " TO MEC-MFLDS.
    MOVE "ITEM   LOT     QTY   SPECIFICATION" TO MEC-TL0 MOVE MR-LN TO MEC-FL01.
*         ..   .......  .....  ....................
    MOVE LOW-VALUES TO LT-RECORD MOVE HT-LOT TO LT-NO MEC-FL03.
    READ LOT REGARDLESS INVALID MOVE HT-QTY TO MEC-FL04 MOVE "NOT ON FILE" TO MEC-FL05
      MOVE MEC-TL0 TO FG236 PERFORM MR-LINE MOVE MEC-FL0 TO FG236 PERFORM MR-LINE
      GO MR56.
    IF LT-ALOT>" " MOVE LT-ALOT TO MEC-FL03X.
    MOVE HT-QTY TO MEC-FL04 MOVE LT-SPEC TO MEC-FL05 PERFORM MR-LOT.
MR56. PERFORM MR-NOTE GO MR5.
MR6.

    INITIALIZE HT-KEY MOVE OLD-INVLN TO HT-INVLN.
    START HTRANS KEY>=HT-KEY REGARDLESS INVALID GO MR84.
MR83. READ HTRANS NEXT REGARDLESS END GO MR84. IF HT-INVLN NOT=OLD-INVLN GO MR84.
    MOVE 1 TO HT-IND REWRITE HT-RECORD ALLOWING NO UNLOCK HTRANS GO MR83.
MR84. GO MR3.
MR9. PERFORM PCL-END PERFORM LAS-DOCLINE.
    CLOSE HTRANS PERFORM CLOSE-DOC GO MN9.

* note 61
MR-HEAT. PERFORM GET-GRADE MOVE A-A1 TO FG232.
    MOVE HE-C TO FG234(1) MOVE HE-MN TO FG234(2) MOVE HE-P TO FG235(3).
    MOVE HE-S TO FG235(4) MOVE HE-SI TO FG234(5) MOVE HE-CU TO FG234(6).
    MOVE HE-NI TO FG234(7) MOVE HE-CR TO FG234(8) MOVE HE-MO TO FG235(9).
    MOVE HE-SN TO FG235(10) MOVE HE-AL TO FG235(11) MOVE HE-B TO FG233(12).
    MOVE HE-V TO FG235(13) MOVE HE-CO TO FG235(14) MOVE HE-N TO FG233(15).
MR-LOT. PERFORM MR-LT1 THRU MR-LT9.
* note 228
MR-LT1. MOVE 0 TO A-X1 MOVE 1 TO CAR-CH.
MR-LT3. PERFORM MECH-GET IF MEC-VAL=" " GO MR-LT4. ADD 1 TO A-X1.
    PERFORM MECH-DESC.
    IF (P-CAT=21 OR 22) AND (CAR-CH=6 OR 7) AND MEC-UNIT="KSI" PERFORM MECH-CONV.
    MOVE MEC-VAL TO A-A1 PERFORM STR-LTH.
    IF A-N1>26 AND (A-X1=3 OR 6 OR 9 OR 12) ADD 1 TO A-X1.
    MOVE CAR-MECH(CAR-CH) TO CAR-DATA MOVE CAR-DESC TO MEC-TA(A-X1).
    IF A-N1>26 MOVE MEC-VAL(1:28) TO MEC-FA(A-X1)
      MOVE MEC-VAL(29:) TO MEC-FA(A-X1 + 1) ADD 1 TO A-X1
     ELSE MOVE MEC-VAL TO MEC-FA(A-X1).
MR-LT4. ADD 1 TO CAR-CH IF CAR-CH<=14 GO MR-LT3.
    IF LT-BMLOT NOT=0 MOVE LT-BMLOT TO MEC-LD11 MOVE "BARE LOT" TO MEC-LD12.

    MOVE MEC-TL0 TO FG236 MOVE MEC-TL1(1) TO FG237 PERFORM MR-LINE.
    MOVE MEC-FL0 TO FG236 MOVE MEC-FL1(1) TO FG237 PERFORM MR-LINE.
    PERFORM VARYING A-X1 FROM 2 BY 1 UNTIL A-X1>5 IF MEC-FL1(A-X1)>" "
      IF A-X1=2 AND MEC-LD1>" " MOVE MEC-LD1 TO FG236 MOVE " " TO MEC-LD1 END-IF
      MOVE MEC-TL1(A-X1) TO FG237 PERFORM MR-LINE
      MOVE MEC-FL1(A-X1) TO FG237 PERFORM MR-LINE END-IF END-PERFORM.
    IF MEC-LD1>" " MOVE MEC-LD1 TO FG236 PERFORM MR-LINE.
MR-LT9. EXIT.
    REPLACE ==STD6== BY ==PRO-KS=1 AND PRO-LTH=6 AND PRO-PR(1) NUMERIC==.
MR-NOTE. PERFORM MR-LINE 2 TIMES IF DOC-LINES>47 PERFORM MR-END PERFORM MR-PAGE.
    MOVE P-NO TO PRO-NO PERFORM SET-PRO-LTH PERFORM CHK-STANDARD.
    MOVE "NOTES:" TO PREC PERFORM MR-LINE.
    MOVE "THIS REPORT CONTAINS DATA THAT ARE NOT COVERED BY THE NVLAP ACCREDITATION." TO PREC PERFORM MR-LINE.
    MOVE "STEEL CHEMISTRY IS CERTIFIED BY THE SUPPLYING STEEL MILL. THE SAMPLES TESTED CONFORM TO THE STANDARD AND SPECIFICATION LISTED." TO PREC PERFORM MR-LINE.
    MOVE "THIS DOCUMENT MAY ONLY BE REPRODUCED IN ITS ENTIRETY. RESULTS SHOWN ON TEST REPORT RELATE ONLY TO THE ITEMS TESTED." TO PREC PERFORM MR-LINE.
    IF LT-ALOT=" "
      MOVE "IRVINE FASTENERS IS ACCREDITED BY THE NATIONAL VOLUNTARY LABORATORY ACCREDITATION PROGRAM FOR THE SPECIFIC SCOPE OF ACCREDITATION" TO PREC PERFORM DOC-LINE
      MOVE "UNDER LABORATORY CODE 200208. THIS DOCUMENT DOES NOT CLAIM PRODUCT ENDORSEMENT BY NVLAP OR ANY AGENCY OF THE U.S. GOVERNMENT." TO PREC PERFORM MR-LINE.
    MOVE "THE TEST METHODS UTILIZED CONFORM TO ASTM F606 AND F606M." TO PREC PERFORM MR-LINE.
    IF P-CAT NOT=21
      MOVE "THE SAMPLE PLAN FOR MECHANICAL PROPERTIES EXCEEDS ASME B18.18.2M." TO PREC PERFORM MR-LINE.
    IF LT-ALOT>" "
      MOVE "THE MECHANICAL PROPERTIES WERE TESTED BY AN ACCREDITED LABORATORY. ORIGINAL REPORTS ARE ON FILE." TO PREC PERFORM MR-LINE.
    IF STD6 AND PRO-PR(1)=21
      MOVE "- PARTS SUPPLIED UNDER THIS CERTIFICATION ALSO MEET THE REQUIREMENTS OF ASME SA193-04." TO PREC PERFORM MR-LINE.
    IF P-CAT=10
      MOVE "MECHANICAL PROPERTIES ARE TESTED ON FULL SIZE PRODUCT." TO PREC PERFORM MR-LINE.
    IF P-CAT=21 OR 22 OR 25
      MOVE "- MATERIAL SOUNDNESS HAS BEEN TESTED BY THE SUPPLYING STEEL MILL AND MEETS THE REQUIREMENTS SPECIFIED" TO PREC PERFORM DOC-LINE
      MOVE "  IN PARAGRAPH 4.2 OF ASTM A193." TO PREC PERFORM MR-LINE.
    IF P-CAT=21 OR 22 OR 25
      MOVE "- PARTS WERE AUSTENITIZED AT 1550 DEG. F. FOR 45 MINUTES MINIMUM, OIL QUENCHED," TO PREC PERFORM DOC-LINE
      MOVE "  AND TEMPERED TO SPECIFICATION AT 1100 DEG. F. MINIMUM FOR 60 MINUTES MINIMUM." TO PREC PERFORM MR-LINE.
    IF P-CAT=21 OR 22 OR 25
      MOVE "- ONE TENSION TEST IS MADE FOR EVERY 1500 LBS OF PRODUCT PRODUCED IN A LOT. THE LOT SIZE MAY EXCEED THE SPECIFICATION." TO PREC PERFORM MR-LINE.
    IF (STD6 AND PRO-PR(1)=23 AND P-CAT=33) OR P-CAT=32
      MOVE "- MINIMUM TEMPERING TEMPERATURE FOR GRADE 2H NUTS IS 850 DEG. F." TO PREC PERFORM MR-LINE.
    IF P-NO(1:3)="063" AND PRO-LTH=7
      MOVE "- GRADE 2HM NUTS ARE QUENCHED AND TEMPERED WITH A MINIMUM TEMPERING TEMPERATURE OF 1150 DEG. F." TO PREC PERFORM DOC-LINE
      MOVE "- THE HARDNESS READINGS REPORTED ARE TAKEN FROM IN-PROCESS SAMPLING." TO PREC PERFORM DOC-LINE
      MOVE "  THE 100% HARDNESS VERIFICATION IS COMPLETED BY A SUBCONTRACTOR OF IRVINE FASTENERS." TO PREC PERFORM MR-LINE.
    IF C-NO="06190"
      MOVE "- THE PRODUCT HAS NOT COME INTO CONTACT WITH MERCURY OR ANY OF ITS COMPOUNDS DURING PROCESSING AT IRVINE FASTENERS." TO PREC PERFORM MR-LINE.
    IF C-NO="06490" AND (P-CAT=21 OR 22)
      MOVE "- IRVINE FASTENERS QA PROGRAM MEETS THE REQUIREMENTS OF EN 10204 FOR INSPECTION CERTIFICATE TYPE 3.1." TO PREC PERFORM MR-LINE.
    IF (STD6 AND PRO-PR(1)=21) OR P-CAT=25
      MOVE "- ADVISORY:" TO PREC PERFORM DOC-LINE
      MOVE "  ELECTROPLATED B7 BOLT/STUD AND 2H NUT ASSEMBLIES SHOULD NOT BE USED IN APPLICATIONS WHERE THEY ARE EXPOSED TO" TO PREC PERFORM DOC-LINE
      MOVE "  TEMPERATURES IN EXCESS OF 300 DEG. F. SUCH USAGE MAY SUBJECT THE STUDS AND NUTS TO LIQUID METAL EMBRITTLEMENT." TO PREC PERFORM MR-LINE.
    IF P-NO="43RU1538"
      MOVE "- THIS LOT HAS BEEN AUDITED FOR ANNULAR THREADS WITH ZERO NON-CONFORMING PARTS FOUND." TO PREC PERFORM MR-LINE.
    IF C-NO="07290" AND P-NO="2422041"
      MOVE "- SAMPLES FROM THE ABOVE LOT HAVE BEEN TESTED PER SPECIFICATION ES 1096, PARAGRAPH 3.1," TO PREC PERFORM DOC-LINE
      MOVE "  AND FOUND TO BE LESS THAN 5 GAUSS RESIDUAL MAGNETISM." TO PREC PERFORM MR-LINE.
    MOVE "MATERIAL USED TO MANUFACTURE THIS PRODUCT IS ASBESTOS, MERCURY, AND RADIOACTIVITY FREE." TO PREC PERFORM MR-LINE.
    PERFORM DOC-LINE.
    MOVE "DATE:" TO FG240 MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG241.
    MOVE "ISSUED BY: JOHN HAMDEN, QUALITY ASSURANCE MANAGER" TO FG242.
    MOVE "METALLURGICAL AND QUALITY CONTROL DEPARTMENT" TO FG243 PERFORM DOC-LINE.
    REPLACE OFF.
MR-END. COMPUTE DOC-PR=58 - DOC-LINES IF DOC-PR>0 PERFORM DOC-LINE DOC-PR TIMES.
    MOVE "CONTINUED ..." TO PREC(120:) PERFORM DOC-LINE.
MR-LINE. PERFORM DOC-LINE IF DOC-LINES>57 PERFORM MR-END PERFORM MR-PAGE.
MR-PAGE. ADD 1 TO DOC-PAGE IF DOC-PAGE>1 PERFORM PCL-FF.
    PERFORM LAS-DOCLINE MOVE 1 TO DOC-LINES.
    MOVE "    M E T A L L U R G I C A L   T E S T   R E P O R T" TO FG218 PERFORM DOC-LINE 2 TIMES.
    MOVE "                    IRVINE FASTENERS" TO FG218 PERFORM DOC-LINE.
    MOVE "160 RICHMOND STREET, SPRINGHILL, ONTARIO, CANADA  N1K 5R6" TO FG218 PERFORM DOC-LINE 3 TIMES.

* M-24 LOT REPORTS
PS1. PERFORM RD319 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>5 GO MN9.
    MOVE 9 TO IXT MOVE 8 TO IXU MOVE 29 TO IXV.
    IF Y1 PERFORM AX-LOT-R
      MOVE LOT1 TO D-LOT PERFORM D-LOTDATE COMPUTE PS-YLOT1=D-YEAR * 10000000 + LOT1
      MOVE LOT2 TO D-LOT PERFORM D-LOTDATE COMPUTE PS-YLOT2=D-YEAR * 10000000 + LOT2.
    IF Y2 PERFORM AX-PROD-R. IF Y3 PERFORM AX-HEAT-R. IF Y4 PERFORM AX-ORD-R.
    MOVE 11 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 0 TO LT-NO START LOT KEY>LT-KEY REGARDLESS INVALID GO PS29.
PS23. READ LOT NEXT REGARDLESS END GO PS29. PERFORM INIT-RP.
    MOVE LT-NO TO D-LOT PERFORM D-LOTDATE COMPUTE PS-YLOT=D-YEAR * 10000000 + LT-NO.
    EVALUATE TRUE
      WHEN Y1 IF PS-YLOT>=PS-YLOT1 AND<=PS-YLOT2 MOVE PS-YLOT TO RP-F151A ELSE GO PS23 END-IF
      WHEN Y2 IF LT-PROD>=PROD1 AND<=PROD2 MOVE LT-PROD TO RP-F151 ELSE GO PS23 END-IF
      WHEN Y3 IF LT-HEAT>=HEAT1 AND<=HEAT2 MOVE LT-HEAT TO RP-F151 ELSE GO PS23 END-IF
      WHEN Y4 IF LT-MO>=ORD1 AND<=ORD2 MOVE LT-MO TO RP-F151A ELSE GO PS23 END-IF
      WHEN Y5 MOVE LT-NO TO D-LOT PERFORM D-LOTDATE
        IF D-ERR=1 MOVE 0 TO RP-F151A ELSE GO PS23 END-IF
      END-EVALUATE.
    MOVE PS-YLOT TO RP-F152 WRITE RP-RECORD GO PS23.
PS29. PERFORM OPEN-PR PERFORM PS-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PS9.
PS3. READ REPFL NEXT END GO PS9. MOVE RP-F152 TO A-N1 PERFORM RD-LOT.
    MOVE LT-NO TO FG250 MOVE LT-PROD TO FG251 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FG252.
    MOVE LT-MO TO FG253 IF LT-SUFFIX>" " MOVE "-" TO FG253A MOVE LT-SUFFIX TO FG253B.
    MOVE LT-HEAT TO FG254 MOVE LT-QTY TO FG255 MOVE LT-WEIGHT TO FG256.
    MOVE LT-FINISH TO FG257 PERFORM PS-LINE GO PS3.
PS9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

PS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PS-PAGE.
PS-PAGE. MOVE "LOT LISTING" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** BY LOT **" TO FF4
      WHEN Y2 MOVE "** BY PRODUCT **" TO FF4
      WHEN Y3 MOVE "** BY HEAT **" TO FF4
      WHEN Y4 MOVE "** BY M.O. **" TO FF4
      WHEN Y5 MOVE "** LOTS WITH INVALID LOT NUMBER **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    IF NOT Y5 MOVE 2 TO WS-PR EVALUATE TRUE
      WHEN Y1 PERFORM PRANGE-LOT
      WHEN Y2 PERFORM PRANGE-PROD
      WHEN Y3 PERFORM PRANGE-HEAT
      WHEN Y4 PERFORM PRANGE-MO
      END-EVALUATE.
    MOVE "LOT NO. PRODUCT      DESCRIPTION                        M.O.   HEAT            QTY      WEIGHT  FINISH" TO PREC PERFORM PR-LINE-3.
*         ....... ............ ................................ ......-. .......... .,...,...- .,...,...- ...............

* M-25 PRODUCT REPORTS
DA1. PERFORM RD320 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>7 GO MN9.
    GO DA10 DA20 DA30 DA40 DA50 DA60 DA70  DEPENDING SEL-N.

DA10. PERFORM RD250 PERFORM WRT.
DA113. ACCEPT DA-CODE LINE 7 COLUMN 8 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(DA-CODE=1 OR 2) PERFORM DSP-ERR9 GO DA113.
    ACCEPT DA-DESC1 LINE 7 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT DA-DESC2 LINE 8 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE DA-DESC1 TO A-A1 PERFORM STR-LTH MOVE A-N1 TO DA-LTH1.
    MOVE DA-DESC2 TO A-A1 PERFORM STR-LTH MOVE A-N1 TO DA-LTH2.
    IF DA-LTH2=0 MOVE 1 TO DA-LTH2.
    MOVE 10 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA129.
DA123. READ PRODUCT NEXT REGARDLESS END GO DA129.
    IF DA-CODE=1 MOVE P-FINDESC TO DA-DESC ELSE MOVE P-PRDESC TO DA-DESC.
    IF NOT(DA-DESC>=DA-DESC1 AND DA-DESC(1:DA-LTH2)<=DA-DESC2) GO DA123.
* note 237
    PERFORM INIT-RP MOVE DA-DESC TO RP-F155 MOVE P-KEY TO RP-F155A.
    WRITE RP-RECORD GO DA123.
DA129. PERFORM OPEN-PR PERFORM DA-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DA19.
DA13. READ REPFL NEXT END GO DA19. MOVE RP-F155 TO FA94.
    MOVE RP-F155A TO A-A1 PERFORM PROD-RGD.
    MOVE P-NO TO FA95 MOVE PRO-DESC(1) TO FA96 PERFORM DA-LINE GO DA13.
DA19. PERFORM CLOSE-REP PERFORM CLOSE-PR GO DA9.

DA20. PERFORM RD256 PERFORM WRT.
DA213. ACCEPT DA-PRINT LINE 3 COLUMN 35 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF DA-PRINT=0 PERFORM DSP-ERR2 GO DA213.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM DA-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA29.
DA23. READ PRODUCT NEXT REGARDLESS END GO DA29. IF P-PRINT NOT=DA-PRINT GO DA23.
    MOVE P-NO TO FA569(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM DA-LINE MOVE 1 TO PR-IXP. GO DA23.
DA29. PERFORM PR-LASTLN PERFORM CLOSE-PR GO DA9.

DA30. PERFORM RD211 PERFORM WRT.
    MOVE 3 TO IXT MOVE 21 TO IXU MOVE 50 TO IXV PERFORM AX-SPEC-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA329.
DA323. READ PRODUCT NEXT REGARDLESS END GO DA329.
    IF NOT(P-PLSPEC>=SPEC1 AND<=SPEC2) GO DA323. PERFORM INIT-RP.
    MOVE P-PLSPEC TO RP-F75 MOVE P-KEY TO RP-F76 WRITE RP-RECORD GO DA323.
DA329. PERFORM OPEN-PR PERFORM DA-PAGE MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DA39.
DA33. READ REPFL NEXT END GO DA39. IF RP-F75=OLD-N GO DA34.
    IF OLD-N NOT=-1 PERFORM DA-LINE 3 TIMES. MOVE RP-F75 TO OLD-N FG318.
    IF OLD-N NOT=0 MOVE 20 TO T-TBL MOVE OLD-N TO T-NO PERFORM RD-TBL MOVE T-LINE TO FG319.
    PERFORM DA-LINE 2 TIMES.
DA34. MOVE RP-F76 TO A-A1 PERFORM PROD-RGD MOVE P-NO TO FG320 MOVE PRO-DESC(1) TO FG321.
    PERFORM DA-LINE GO DA33.
DA39. PERFORM CLOSE-REP PERFORM CLOSE-PR GO DA9.

DA40. PERFORM RD176 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA429.
DA423. READ PRODUCT NEXT REGARDLESS END GO DA429. IF P-PACKING=0 GO DA423.
    PERFORM INIT-RP MOVE P-PACKING TO RP-F248 MOVE P-CAT TO RP-F249.
    MOVE P-KEY TO RP-F250 WRITE RP-RECORD GO DA423.
DA429. PERFORM OPEN-PR PERFORM DA-PAGE MOVE 0 TO OLD-T OLD-N MOVE 1 TO PR-IXP.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DA49.
DA43. READ REPFL NEXT END GO DA49. IF RP-F248=OLD-T GO DA434.
    IF OLD-T NOT=0 PERFORM PR-LASTLN PERFORM DA-LINE 3 TIMES.
    MOVE RP-F248 TO OLD-T FA605 A-N1 PERFORM RD-PACKING.
    MOVE PK-DESC TO FA606 PERFORM DA-LINE 2 TIMES MOVE 0 TO OLD-N MOVE 1 TO PR-IXP.
DA434. IF RP-F249=OLD-N GO DA44. IF OLD-N NOT=0 PERFORM PR-LASTLN.
    MOVE "CAT" TO FA607 MOVE RP-F249 TO OLD-N FA608 MOVE 1 TO PR-IXP.
DA44. MOVE RP-F250 TO FA609(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM DA-LINE MOVE 1 TO PR-IXP. GO DA43.
DA49. PERFORM PR-LASTLN.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO DA9.

DA50. PERFORM RD222 PERFORM WRT.
    MOVE 3 TO IXT MOVE 54 TO IXU MOVE 71 TO IXV PERFORM AX-WIRE-R.
    ACCEPT DA-ROP LINE 5 COLUMN 42 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE WIRE1 TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO DA-AWIRE1.
    MOVE WIRE2 TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO DA-AWIRE2.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA529.
DA523. READ PRODUCT NEXT REGARDLESS END GO DA529.
    IF NOT(P-WIRE>=WIRE1 AND<=WIRE2 AND P-ROP>DA-ROP) GO DA523.
    PERFORM INIT-RP COMPUTE RP-F257=999999999 - P-ROP.
    MOVE P-KEY TO RP-F258 WRITE RP-RECORD GO DA523.
DA529. PERFORM OPEN-PR PERFORM DA-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DA59.
DA53. READ REPFL NEXT END GO DA59. MOVE RP-F258 TO A-A1 PERFORM PROD-RGD.
    MOVE P-NO TO FA620 MOVE PRO-DESC(1) TO FA621.
    PERFORM DESC-PRINT MOVE PRO-PRINT TO FA622 MOVE P-MAC TO FA623.
    MOVE P-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FA624.
    MOVE P-ROP TO FA625 PERFORM DA-LINE GO DA53.
DA59. PERFORM CLOSE-REP PERFORM CLOSE-PR GO DA9.

DA60. PERFORM RD223 PERFORM WRT.
    MOVE 3 TO IXT MOVE 15 TO IXU MOVE 37 TO IXV PERFORM AX-FAM-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA629.
DA623. READ PRODUCT NEXT REGARDLESS END GO DA629.
    IF NOT(P-GEN=" " AND (P-FAMILY>=FAM1 AND<=FAM2)) GO DA623.
    PERFORM INIT-RP MOVE P-FAMILY TO RP-F295 MOVE P-PRINT TO RP-F296.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO RP-F297 MOVE P-NO TO RP-F297A.
    WRITE RP-RECORD GO DA623.
DA629. PERFORM OPEN-PR PERFORM DA-PAGE MOVE -1 TO OLD-M OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DA69.
DA63. READ REPFL NEXT END GO DA69. IF RP-F295=OLD-M GO DA634.
    IF OLD-M NOT=-1 PERFORM DA-LINE 3 TIMES.
    MOVE RP-F295 TO OLD-M FA704 MOVE -1 TO OLD-N.
    IF OLD-M NOT=0 MOVE 18 TO T-TBL MOVE OLD-M TO T-NO PERFORM RD-TBL MOVE T-LINE TO FA705.
    PERFORM DA-LINE 2 TIMES.
DA634. IF RP-F296 NOT=OLD-N IF OLD-N NOT=-1 PERFORM DA-LINE END-IF MOVE RP-F296 TO OLD-N.
    MOVE RP-F296 TO FA706 MOVE RP-F297A TO FA707 A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO FA708 PERFORM DA-LINE GO DA63.
DA69. PERFORM CLOSE-REP PERFORM CLOSE-PR GO DA9.

DA70. PERFORM RD241 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO DA729.
DA723. READ PRODUCT NEXT REGARDLESS END GO DA729. PERFORM INIT-RP.
    MOVE P-SPEC TO RP-F339 MOVE P-KEY TO RP-F340 WRITE RP-RECORD GO DA723.
DA729. PERFORM OPEN-PR PERFORM DA-PAGE MOVE ALL "-" TO OLD-A MOVE 1 TO PR-IXP.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DA79.
DA73. READ REPFL NEXT END GO DA79. IF RP-F339=OLD-A GO DA74.
    IF OLD-A NOT=ALL "-" PERFORM PR-LASTLN PERFORM DA-LINE 2 TIMES.
    MOVE RP-F339 TO OLD-A PREC PERFORM DA-LINE MOVE 1 TO PR-IXP.
DA74. MOVE RP-F340 TO FF55(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM DA-LINE MOVE 1 TO PR-IXP. GO DA73.
DA79. PERFORM PR-LASTLN.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO DA9.

DA9. GO MN9.

DA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM DA-PAGE.
DA-PAGE. PERFORM DA-P1 THRU DA-P9.
DA-P1. GO DA-P10 DA-P20 DA-P30 DA-P40 DA-P50 DA-P60 DA-P70  DEPENDING SEL-N.
DA-P10. MOVE "PRODUCT LISTING" TO FF3.
    IF DA-CODE=1 MOVE "** BY FINISH DESCRIPTION **" TO FF4
      ELSE MOVE "** BY PRINT DESCRIPTION **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    STRING "DESCRIPTION RANGE SELECTED: " DA-DESC1(1:DA-LTH1) " - " DA-DESC2(1:DA-LTH2)
      DELIMITED SIZE INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "DESCRIPTION                       PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*         ................................  ............  ................................
    GO DA-P9.
DA-P20. MOVE "PRODUCT LISTING FOR A PRINT NO." TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR STRING "PRODUCTS WITH PRINT NO. IF-" DA-PRINT
      DELIMITED SIZE INTO PREC PERFORM PR-LINE-3 GO DA-P9.
DA-P30. MOVE "PRODUCT LISTING BY PLATING SPEC" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-SPEC.
    MOVE "     PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*              ............  ................................
    GO DA-P9.
DA-P40. MOVE "PRODUCT LISTING BY PACKING CODE" TO FF3.
    PERFORM PR-PAGE PERFORM PR-LINE GO DA-P9.
DA-P50. MOVE "PRODUCT LISTING FOR A WIRE SIZE" TO FF3 PERFORM PR-PAGE.
    MOVE DA-ROP TO DSP-C81 MOVE 2 TO WS-PR.
    STRING "PRODUCTS WITH WIRE SIZE " DELIMITED SIZE
      DA-AWIRE1 DELIMITED " " " - " DELIMITED SIZE DA-AWIRE2 DELIMITED " "
      " AND R.O.P. GREATER THAN" DSP-C81 DELIMITED SIZE
         INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "PRODUCT       DESCRIPTION                       PRINT NO.     MAC  WIRE        R.O.P." TO PREC PERFORM PR-LINE-3.
*         ............  ................................  .............  ..  ......  ..,...,...
    GO DA-P9.
DA-P60. MOVE "PRODUCT LISTING BY FAMILY" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-FAM.
    MOVE "    PRINT NO.  PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*              ......    ............  ................................
    GO DA-P9.
DA-P70. MOVE "PRODUCT LISTING BY MATERIAL SPEC" TO FF3.
    PERFORM PR-PAGE PERFORM PR-LINE GO DA-P9.
DA-P9. EXIT.

* M-26 LIST PRODUCTS WITH NO SPECS
VG1. PERFORM RD231 PERFORM WRT.
VG13. ACCEPT VG-SEL LINE 8 COLUMN 8 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(VG-SEL=1 OR 2) PERFORM DSP-ERR9 GO VG13.
    MOVE 10 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM VG-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO VG9.
VG3. READ PRODUCT NEXT REGARDLESS END GO VG9.
    IF P-GEN>" " OR NOT(P-CAT>=1 AND<=64) GO VG3.
    MOVE P-CRDATE TO D-DATE PERFORM D-NM MOVE D-YEAR TO D-YEAR1.
    MOVE P-DATE TO D-DATE PERFORM D-NM MOVE D-YEAR TO D-YEAR2.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    IF VG-SEL=1 IF P-YTD=0 AND P-LAST=0 AND P-PREV=0
      AND D-YEAR2<D-YEAR - 2 AND D-YEAR1 NOT=D-YEAR GO VG3.
    IF VG-SEL=2 IF P-HAND=0 AND P-ORDER=0 AND P-PROCESS=0 AND P-DEMAND=0
      AND D-YEAR1 NOT=D-YEAR GO VG3.

    MOVE "PHM" TO VG-PM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-PHYS-NUM OR P-PCHAR(IX1)=0
      IF P-PMIN(IX1)>0 OR P-PMAX(IX1)>0 MOVE " " TO VG-PM(1:1) GO VG44 END-IF END-PERFORM.
VG44. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-HEAT-NUM
       IF P-HMIN(IX1)>0 OR P-HMAX(IX1)>0 MOVE " " TO VG-PM(2:1) GO VG46 END-IF END-PERFORM.
VG46. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-MECH-NUM
       IF P-SMIN(IX1)>0 OR P-SMAX(IX1)>0 MOVE " " TO VG-PM(3:1) GO VG48 END-IF END-PERFORM.
VG48. IF VG-PM>" " MOVE P-NO TO FG464(PR-IXP) MOVE VG-PM TO FG465(PR-IXP)
       PERFORM DESC-PRINT MOVE PRO-PRINT TO FG466(PR-IXP)
       ADD 1 TO PR-IXP IF PR-IXP>3 PERFORM VG-LINE MOVE 1 TO PR-IXP.
    GO VG3.
VG9. PERFORM PR-LASTLN PERFORM CLOSE-PR GO MN9.

VG-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM VG-PAGE.
VG-PAGE. MOVE "PRODUCTS WITH NO SPECS" TO FF3 PERFORM PR-PAGE MOVE 2 TO WS-PR.
    MOVE "P: MISSING PHYSICAL    H: MISSING HEAT TREATMENT    M: MISSING MECHANICAL" TO PREC PERFORM PR-LINE-3.

* M-27 LIST PRODUCTS NOT MADE RECENTLY
VK1. PERFORM RD271 PERFORM WRT.
    MOVE 3 TO IXT MOVE 35 TO IXU PERFORM AX-DT-VAL.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM VK-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO VK9.
VK3. READ PRODUCT NEXT REGARDLESS END GO VK9.
    IF P-GEN>" " OR P-DATE=0 OR>DATE0 GO VK3. MOVE P-NO TO FF94(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM VK-LINE MOVE 1 TO PR-IXP. GO VK3.
VK9. PERFORM PR-LASTLN PERFORM CLOSE-PR GO MN9.

VK-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM VK-PAGE.
VK-PAGE. MOVE "PRODUCTS NOT MADE RECENTLY" TO FF3 PERFORM PR-PAGE.
    MOVE "SINCE" TO A-A1 PERFORM PRANGE-DT PERFORM PR-LINE-2.

* M-28 LIST SIMILAR HEAT TREAT PRODUCTS
VS1. MOVE " " TO VS-PROD.
VS13. PERFORM RD269 PERFORM WRT.
VS15. ACCEPT VS-PROD LINE 3 COLUMN 11 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR VS-PROD=ALL "9" GO VS9.
    MOVE VS-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO VS15.
    IF P-GEN>" " PERFORM DSP-ERR29 GO VS15.
    MOVE P-GRADE TO VS-GRADE MOVE P-WIRE TO VS-WIRE MOVE P-SPEC TO VS-SPEC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-HEAT-NUM
      MOVE P-HMIN(IX1) TO VS-HMIN(IX1) MOVE P-HMAX(IX1) TO VS-HMAX(IX1) END-PERFORM.
    DISPLAY VS-GRADE LINE 5 COLUMN 9.
    MOVE VS-WIRE TO PRO-WIRE PERFORM CHK-WIRE DISPLAY PRO-AWIRE LINE 5 COLUMN 28.
    DISPLAY VS-SPEC LINE 5 COLUMN 45.
    MOVE 1 TO CAR-CH MOVE 11 TO IXT.
VS17. IF CAR-CH>CAR-HEAT-NUM GO VS2. MOVE CAR-HEAT(CAR-CH) TO CAR-DATA.
    IF CAR-DESC=" " OR (VS-HMIN(CAR-CH)=0 AND VS-HMAX(CAR-CH)=0) GO VS18.
    ADD 1 TO IXT IF IXT>23 GO VS2.
    DISPLAY CAR-CH LINE IXT COLUMN 1 CONVERSION CAR-DESC COLUMN 4.
    MOVE 37 TO IXU MOVE VS-HMIN(CAR-CH) TO CAR-VAL PERFORM DSP-HVAL.
    MOVE 47 TO IXU MOVE VS-HMAX(CAR-CH) TO CAR-VAL PERFORM DSP-HVAL.
VS18. ADD 1 TO CAR-CH GO VS17.
VS2. ACCEPT XA3 LINE 7 COLUMN 62 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO VS-KMOD ELSE MOVE 0 TO VS-KMOD.
    MOVE 9 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO VS13.

    PERFORM OPEN-PR PERFORM VS-PAGE.
    MOVE "PRODUCTS WITH THE SAME GRADE, WIRE, SPEC AS PRODUCT:" TO FD360.
    MOVE VS-PROD TO FD361 MOVE "(" TO FD362 MOVE VS-GRADE TO FD364.
    MOVE VS-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FD365.
    MOVE VS-SPEC TO FD366 MOVE ")" TO FD367 PERFORM PR-LINE-3.
    MOVE 1 TO PR-IXP.

    DISPLAY "PRODUCTS WITH THE SAME GRADE, WIRE, SPEC:" LINE 11 BOLD ERASE END SCREEN.
    MOVE 12 TO IXT MOVE 1 TO IXCOL MOVE 0 TO VS-NUM PERFORM DSP-QWAIT.

    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO VS8.
VS3. READ PRODUCT NEXT REGARDLESS END GO VS8. IF P-GEN>" " OR P-NO=VS-PROD GO VS3.
    IF NOT(P-GRADE=VS-GRADE AND P-WIRE=VS-WIRE AND P-SPEC=VS-SPEC) GO VS3.
    MOVE P-NO TO FD368(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM VS-LINE MOVE 1 TO PR-IXP.
    COMPUTE IXU=(IXCOL - 1) * 15 + 1 DISPLAY P-NO LINE IXT COLUMN IXU.
    ADD 1 TO IXCOL IF IXCOL>5 MOVE 1 TO IXCOL ADD 1 TO IXT
      IF IXT>22 MOVE 12 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN.
    IF VS-KMOD=1 PERFORM RDLK-PRODUCT
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CAR-HEAT-NUM
        MOVE VS-HMIN(IX1) TO P-HMIN(IX1) MOVE VS-HMAX(IX1) TO P-HMAX(IX1) END-PERFORM
      REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    ADD 1 TO VS-NUM GO VS3.
VS8. PERFORM PR-LASTLN PERFORM CLOSE-PR.
    PERFORM DSP-ERS DISPLAY VS-NUM LINE 23 CONVERSION BOLD " PRODUCTS FOUND" BOLD.
    PERFORM DSP-CONT GO VS13.
VS9. GO MN9.

VS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM VS-PAGE.
VS-PAGE. MOVE "PRODUCTS WITH SIMILAR HEAT TREATMENT CHARACTERISTICS" TO FF3X PERFORM PR-PAGE.
    PERFORM PR-LINE.
*         .................................................... ............  (........   ......   ....................)

* M-29 AUTHORIZE SHIPPING LABELS
UQ1.
UQ3. PERFORM RD281 PERFORM WRT.
UQ33. ACCEPT UQ-LOT LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UQ-LOT=9999999 GO UQ9. IF UQ-LOT=0 PERFORM DSP-ERR2 GO UQ33.
    MOVE UQ-LOT TO LT-NO READ LOT REGARDLESS INVALID PERFORM DSP-ERR15 GO UQ33.
    MOVE 3 TO IXT MOVE 47 TO IXU MOVE LT-LAB TO A-S1 PERFORM AX-NY MOVE A-S1 TO LT-LAB.
    REWRITE LT-RECORD ALLOWING NO UNLOCK LOT GO UQ3.
UQ9. GO MN9.

* M-30 PRODUCT DATA LISTING
KV1. PERFORM RD190 PERFORM WRT.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-PROD-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM KV-PAGE.
    MOVE PROD1 TO P-NO START PRODUCT KEY>=P-KEY REGARDLESS INVALID GO KV9.
KV3. READ PRODUCT NEXT REGARDLESS END GO KV9. IF P-NO>PROD2 GO KV9.
    IF P-GEN>" " GO KV3. PERFORM PROD-DESC.
    MOVE P-NO TO FD573 MOVE PRO-DESC(1) TO FD574.
    MOVE P-MAC TO FD575 MOVE P-ALT-MAC TO FD576 MOVE P-RATE TO FD577.
    MOVE P-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FD578.
    MOVE P-DIAM TO FD579 MOVE P-GRADE TO FD580.
    PERFORM DESC-PRINT MOVE PRO-PRINT TO FD581.
    IF P-PPAP<=1 MOVE LIT-NY(P-PPAP + 1:1) TO FD582.
    MOVE P-WEIGHT TO FD583 MOVE P-GROSS TO FD584 PERFORM KV-LINE GO KV3.
KV9. PERFORM CLOSE-PR GO MN9.

KV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KV-PAGE.
KV-PAGE. MOVE "PRODUCT DATA LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PROD.
    MOVE "                                                MACHINE        WIRE                                          WEIGHT" TO PREC PERFORM PR-LINE.
    MOVE "PRODUCT       DESCRIPTION                       PRI ALT  RATE  SIZE   DIAM   GRADE    PRINT NO.    PPAP    NET   GROSS" TO PREC PERFORM PR-LINE-3.
*         ............  ................................  ..  ..  .....  ...... ...... ........ .............  .   ...:.. ...:..

* M-31 PRODUCT DESCRIPTIONS LISTING
VY1. PERFORM RD180 PERFORM WRT.
    MOVE 3 TO IXT MOVE 36 TO IXU PERFORM AX-DT-VAL.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE VY-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO VY9.
VY3. READ PRODUCT NEXT REGARDLESS END GO VY9.
    IF P-GEN>" " OR P-DATE<DATE0 GO VY3. PERFORM PROD-DESC.
    MOVE P-NO TO EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE P-EDESC1 TO EXP-A PERFORM EXPF MOVE P-EDESC2 TO EXP-A PERFORM EXPF.
    MOVE P-FINDESC TO EXP-A PERFORM EXPF MOVE P-PRDESC TO EXP-A PERFORM EXPF.
    PERFORM DESC-PRINT MOVE PRO-PRINT TO EXP-A PERFORM EXPF.
    MOVE P-PLSPEC TO EXP-N PERFORM EXPF.
    IF P-PLSPEC>0 MOVE 20 TO T-TBL MOVE P-PLSPEC TO T-NO PERFORM RD-TBL MOVE T-LINE TO EXP-A.
    PERFORM EXPF PERFORM EXP-LINE GO VY3.
VY9. PERFORM CLOSE-EXP GO MN9.

* M-32 SHOW LOTS BY PRODUCT
GK1. PERFORM RD81 MOVE 0 TO INQ-IND MOVE 3 TO IXT.
GK3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
GK33. DISPLAY "NEXT PRODUCT NO. ____________     START YEAR (4 DIGITS) ____" LINE IXT.
    ACCEPT IA4 LINE IXT COLUMN 18 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA4=ALL "9" GO GK9.
    IF IA4=" " IF INQ-IND=0 GO GK33 ELSE GO GK4.
    MOVE IA4 TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO GK33.
    PERFORM RD-GEN PERFORM PROD-DESC.
    DISPLAY "LEAVE YEAR BLANK TO START FROM OLDEST LOTS" LINE 24 BOLD.
    ACCEPT IA5 LINE IXT COLUMN 57 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    INITIALIZE LT-KP MOVE P-NO TO LT-PROD MOVE IA5 TO LT-LYEAR MOVE 0 TO INQ-IND.
GK4. PERFORM RD81 MOVE P-NO TO TF629(1) MOVE PRO-DESC(1) TO TF630(1).
    MOVE 4 TO IXT IF INQ-IND=0 START LOT KEY>LT-KP REGARDLESS INVALID GO GK8.
GK5. READ LOT NEXT REGARDLESS END GO GK8. IF LT-PROD>P-NO GO GK8.
    PERFORM CLR-LN MOVE LT-NO TO TF631(IXT).
    MOVE LT-NO TO D-LOT PERFORM D-LOTDATE PERFORM D-NM MOVE D-DT TO TF632(IXT).
    MOVE LT-MO TO TF633(IXT) IF LT-SUFFIX>" " MOVE "-" TO TF633A(IXT) MOVE LT-SUFFIX TO TF633B(IXT).
    MOVE LT-QTY TO TF634(IXT) MOVE LT-WEIGHT TO TF635(IXT).
    MOVE LT-FINISH TO TF636(IXT) ADD 1 TO IXT IF IXT<22 GO GK5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO GK89.
GK8. MOVE "*** END ***" TO TLN(IXT) MOVE 0 TO INQ-IND.
GK89. GO GK3.
GK9. GO MN9.

* M-33 PRINT PRODUCT DRAWINGS
DZ1. MOVE 3 TO PDR-TP PERFORM PRINT-DRAWING.
DZ9. GO MN9.

* E: EDI FUNCTIONS

* E-1 PRINT NAFTA FORM
CW1. PERFORM RD265 PERFORM WRT.
CW13. ACCEPT C-NO LINE 3 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO CW9. READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO CW13.
    MOVE 5 TO IXT MOVE 32 TO IXU MOVE 48 TO IXV PERFORM AX-DATE-R.
    MOVE DATE1 TO CW-DT1 MOVE DATE2 TO CW-DT2.
    MOVE 6 TO IXT MOVE 32 TO IXU MOVE 48 TO IXV PERFORM AX-DATE-R.
    PERFORM OPEN-SORT PERFORM DSP-QWAIT.

    MOVE 0 TO CW-N INITIALIZE SH-KEY MOVE C-NO TO SH-CUS.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO CW24.
CW23. READ SALHIST NEXT REGARDLESS END GO CW24. IF SH-CUS>C-NO GO CW24.
    IF (SH-PROD="F" OR "S" OR "ADM") OR NOT(SH-DATE>=DATE1 AND<=DATE2) GO CW23.
    MOVE SH-PROD TO SR-F13 WRITE SR-RECORD INVALID GO CW238. ADD 1 TO CW-N.
CW238. GO CW23.
CW24. PERFORM DSP-ERS MOVE 8 TO IXT MOVE 1 TO IXCOL.
CW25. COMPUTE IXU=(IXCOL - 1) * 14 + 24.
    ACCEPT P-NO LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED.
    IF P-NO=" " GO CW26. READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO CW25.
    MOVE P-NO TO SR-F13 WRITE SR-RECORD INVALID GO CW258. ADD 1 TO CW-N.
CW258. ADD 1 TO IXCOL IF IXCOL>3 ADD 1 TO IXT MOVE 1 TO IXCOL. IF IXT<=11 GO CW25.
CW26. DIVIDE CW-N BY 20 GIVING CW-NP REMAINDER CW-NR IF CW-NR>0 ADD 1 TO CW-NP.
    MOVE 13 TO IXT PERFORM AX-OK IF XA2 NOT="OK" PERFORM CLOSE-SORT GO MN9.
    PERFORM DSP-WAIT MOVE 6 TO LAS-FLN PERFORM OPEN-LAS MOVE 0 TO CW-IXN.

CW3. ADD 1 TO CW-IXN IF CW-IXN>CW-NP GO CW8.
    PERFORM PCL-INIT PERFORM PCL-START.
    MOVE "`(s12h0s0B`*p130x395YIRVINE FASTENERS" TO LAS-FLD PERFORM LASF.
    MOVE "`*p130x+46Y160 RICHMOND STREET" TO LAS-FLD PERFORM LASF.
    MOVE "`*p130x+46YSPRINGHILL, ONTARIO" TO LAS-FLD PERFORM LASF.
    MOVE "`*p130x+46YCANADA N1K 5R6" TO LAS-FLD PERFORM LASF.
    MOVE "`*p540x570Y472389022 RM0001" TO LAS-FLD PERFORM LASF.
    MOVE "`*p130x700Y(SAME AS ABOVE)" TO LAS-FLD PERFORM LASF.
    MOVE CW-DT1 TO D-DATE PERFORM D-NM.
    MOVE "`*p1260x490Y" TO LAS-FLD PERFORM LASF MOVE D-DT TO FJ-NDT PERFORM LASF.
    MOVE CW-DT2 TO D-DATE PERFORM D-NM.
    MOVE "`*p1260x+80Y" TO LAS-FLD PERFORM LASF MOVE D-DT TO FJ-NDT PERFORM LASF.
    MOVE "`*p1200x700YVARIOUS" TO LAS-FLD PERFORM LASF.

    COMPUTE CW-L1=(CW-IXN - 1) * 20.
    IF CW-IXN=CW-NP AND CW-NR>0 COMPUTE CW-L2=CW-L1 + CW-NR
      ELSE COMPUTE CW-L2=CW-L1 + 20.
    MOVE 0 TO CW-N MOVE 1030 TO CW-YPOS.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO CW6.
CW5. READ SORTFL NEXT END GO CW6. ADD 1 TO CW-N.
    IF CW-N>CW-L2 GO CW6. IF CW-N<=CW-L1 GO CW5.
    ADD 50 TO CW-YPOS PERFORM PCL-NORM2.
    MOVE 120 TO LAS-POSX MOVE CW-YPOS TO LAS-POSY MOVE LAS-POS TO LAS-FLD PERFORM LASF.
    MOVE SR-F13 TO A-A1 PERFORM PROD-RGD.
    STRING SR-F13 DELIMITED " " " " PRO-DESC(1) DELIMITED SIZE INTO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE "`*p1330X" TO LAS-FLD PERFORM LASF.
    MOVE P-HCODE TO A-N1 PERFORM DESC-HARM MOVE PRO-HARM TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM2 MOVE "`*p1640XC`*p1785XYES`*p2010XNO`*p2200XCA" TO LAS-FLD PERFORM LASF.
    GO CW5.

CW6. MOVE "`*p750x2565Y1`*p210x2760YJANE JONES" TO LAS-FLD PERFORM LASF.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE "`*p210x2880Y" TO LAS-FLD PERFORM LASF MOVE D-DT TO FJ-NDT PERFORM LASF.
    MOVE "`*p1230x2660YIRVINE FASTENERS`*p1230x2760YCONTROLLER" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1230x2880Y(519)324-6448`*p1770x2880Y(519)324-2731" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-ENDFL.
    GO CW3.
CW8. PERFORM CLOSE-LAS PERFORM CLOSE-SORT.
    MOVE "PRINT3" TO LAS-QUEUE PERFORM PRINT-LAS.
CW9. GO MN9.

    REPLACE ==INTO-RECORD== BY ==ED-NL DELIMITED SIZE INTO ED-RECORD POINTER ED-PTR PERFORM EL-SWRITE==.
* note 285.1
* E-2 CREATE TOWER GROUP INVOICE 810
CJ1. PERFORM RD384 PERFORM WRT.
    MOVE 6 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE "EDITOW" TO EDI-ID OPEN OUTPUT EDI.
    MOVE X"1C" TO ED-NL MOVE "~" TO ED-SEP MOVE "<" TO ED-SUBSEP.
    OPEN I-O CFORD ALLOWING ALL CFLIN ALLOWING ALL.
    ACCEPT ED-YYMMDD FROM DATE ACCEPT ED-TIME FROM TIME.
    MOVE 1 TO ED-PTR.

    PERFORM RD-EDINFO ADD 1 TO EI-TOW-ISA PERFORM WR-EDINFO.
    MOVE EI-TOW-ISA TO ED-ISA-NUM MOVE 0 TO ED-ISA-TOT ED-GS-NUM.
    MOVE ED-DUNS TO ED-SENDER-ID MOVE "TGIEDIPROD" TO ED-RECEIVER-ID.
    MOVE "ZZ" TO ED-SENDER-QUAL MOVE "ZZ" TO ED-RECEIVER-QUAL.
    STRING "ISA~00~          ~00~          ~"
      ED-SENDER-QUAL "~" ED-SENDER-ID "~" ED-RECEIVER-QUAL "~" ED-RECEIVER-ID "~"
      ED-YYMMDD "~" ED-HHMM "~U~00000~" ED-ISA-NUM "~0~P~" ED-SUBSEP INTO-RECORD.

    ADD 1 TO ED-ISA-TOT.
    ADD 1 TO ED-GS-NUM MOVE 0 TO ED-GS-TOT ED-ST-NUM.
    STRING "GS~IN~" ED-SENDER-ID "~" ED-RECEIVER-ID "~" DELIMITED " "
      ED-YYMMDD "~" ED-HHMM "~" ED-GS-NUM "~X~002003" INTO-RECORD.

    MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO CJ9.
CJ3. READ CFORD NEXT REGARDLESS END GO CJ9.
    IF FO-IND=0 OR FO-PIND(3)=1 GO CJ3.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS IF C-EDICF=0 GO CJ3.
    MOVE C-AUTO TO AUTO-CODE.

    ADD 1 TO ED-GS-TOT ADD 1 TO ED-ST-NUM MOVE 1 TO ED-ST-TOT.
    STRING "ST~810~" ED-ST-NUM INTO-RECORD.

    IF FO-SHIPTO=0 GO CJ32. MOVE FO-CUS TO SA-CUS MOVE FO-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO CJ32. PERFORM GET-FO-CUSADD.
CJ32. MOVE FO-INV-DATE TO D-DATE PERFORM D-NY MOVE D-DT TO ED-N61.
    MOVE FO-DATE TO D-DATE PERFORM D-NY MOVE D-DT TO ED-N62.
    STRING "BIG~" ED-N61 "~" FO-BL "~" ED-N62 INTO-RECORD.
    STRING "NTE~ZZZ~" MSG-M8 INTO-RECORD.

    IF C-US=1 MOVE "USD" TO ED-A31 ELSE MOVE "CAD" TO ED-A31.
    STRING "CUR~ZZ~" ED-A31 INTO-RECORD.
    MOVE "N" TO ED-A11 IF C-NO>"15000" MOVE "Y" TO ED-A11.
    STRING "REF~ZZ~REL~" ED-A11 INTO-RECORD.
    STRING "REF~ZZ~POE~" FO-ENTRY DELIMITED "  " INTO-RECORD.
    STRING "REF~ZZ~IRS#~" C-IRS DELIMITED "  " INTO-RECORD.
    IF FO-STATE="MX" MOVE "MEXICO" TO ED-A61
      ELSE STRING "USA/" FO-STATE DELIMITED SIZE INTO ED-A61.
    STRING "REF~ZZ~DEST~" ED-A61 INTO-RECORD.
    MOVE "CONSIGNEE" TO ED-A101.
    IF FO-PAYER="B" MOVE "BUYER" TO ED-A101 ELSE MOVE "EXPORTER" TO ED-A101.
    STRING "REF~ZZ~BILL~" ED-A101 DELIMITED " " INTO-RECORD.

    MOVE "Y" TO ED-A11 IF FO-FOB=WS-FOB MOVE "N" TO ED-A11.
    STRING "REF~ZZ~DUT~" ED-A11 INTO-RECORD.
    STRING "REF~ZZ~BRO~" ED-A11 INTO-RECORD.
    STRING "REF~ZZ~FRE~" ED-A11 INTO-RECORD.
    STRING "REF~ZZ~ADD~" ED-A11 INTO-RECORD.

    STRING "REF~ZZ~SOL~Y" INTO-RECORD.

    STRING "N1~EX~IRVINE FASTENERS" INTO-RECORD.
    STRING "N2~" WS-TAXID INTO-RECORD.
    STRING "N3~160 RICHMOND STREET" INTO-RECORD.
    STRING "N4~SPRINGHILL~ON~N1K 5R6~CA" INTO-RECORD.

    STRING "N1~ST~" FO-NAME DELIMITED "  " INTO-RECORD.
    STRING "N3~" FO-ADD1 "~" FO-ADD2 DELIMITED "  " INTO-RECORD.
    STRING "N4~~" FO-STATE "~" FO-POST DELIMITED "  " INTO-RECORD.

    STRING "N1~SO~" C-NAME DELIMITED "  " INTO-RECORD.
    STRING "N3~" C-ADD1 "~" C-ADD2 DELIMITED "  " INTO-RECORD.
    STRING "N4~~~" C-POST DELIMITED "  " INTO-RECORD.

    IF FO-FOB=WS-FOB MOVE "OA" TO ED-A21 ELSE MOVE "DE" TO ED-A21.
    STRING "FOB~~OP~CANADA/ON~~~" ED-A21 "~" FO-FOB DELIMITED "  " INTO-RECORD.
    STRING "PID~F~~~~FASTENERS" INTO-RECORD.
    MOVE FO-PACKS(1) TO ED-N61 MOVE "CT" TO ED-A21.
    STRING "MEA~~~" ED-N61 "~" ED-A21 INTO-RECORD.

    MOVE FO-BL TO FL-BL MOVE 0 TO FL-SEQ.
CJ5. ADD 1 TO FL-SEQ READ CFLIN REGARDLESS INVALID GO CJ6.
    IF FL-PROD="C" GO CJ5. PERFORM COU-LINES.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
    PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>3
     IF COU-QTY(IX1,IX2) NOT=0
       MOVE COU-QTY(IX1,IX2) TO ED-N91 MOVE COU-PRICE(IX1,IX2) TO ED-T41
       IF COU-COUNTRY(IX1,IX2)=0 MOVE "~CH~CA~ZZ~ON" TO ED-A201
         ELSE MOVE "~CH~~ZZ~" TO ED-A201 END-IF
       STRING "IT1~~" ED-N91 "~EA~" ED-T41 "~~~~~~~~~~~~~~~~~" ED-A201 DELIMITED " " INTO-RECORD
       STRING "PID~F~~ZZ~" COU-PROD(IX1,IX2) "~" COU-DESC(IX1,IX2)(1:16) DELIMITED "  "
         "  " DELIMITED SIZE COU-DESC(IX1,IX2)(17:) DELIMITED "  " INTO-RECORD
       MOVE COU-WEIGHT(IX1,IX2) TO ED-N61
       STRING "MEA~~~" ED-N61 "~KG" INTO-RECORD
       MOVE COU-EXT(IX1,IX2) TO ED-D71
       STRING "ITA~C~~~ZZ~~~" ED-D71 INTO-RECORD
       MOVE COU-HCODE(IX1,IX2) TO A-N1 PERFORM DESC-HARM
       STRING "REF~ZZ~HS~" PRO-HARM DELIMITED "  " INTO-RECORD
       END-IF END-PERFORM END-PERFORM.
    GO CJ5.
CJ6. MOVE FO-TOTAL TO ED-D71.
    STRING "TDS~" ED-D71 INTO-RECORD.
    MOVE FO-VIA TO SV-KEY PERFORM RD-VIA.
    STRING "CAD~J~~~~" SV-CARRIER DELIMITED "  " INTO-RECORD.

    COMPUTE ED-D71 ROUNDED=FO-GROSS * FO-FRATE / 100.
    IF FO-FOB=WS-FOB MOVE "FCD" TO ED-A31 ELSE MOVE "FFC" TO ED-A31.
    STRING "ITA~C~~~06~~~" ED-D71 "~~~~~~" FO-BORDER "~" ED-A31 DELIMITED " " INTO-RECORD.

    COMPUTE ED-N31=FL-SEQ - 1.
    MOVE FO-GROSS TO ED-N61 MOVE FO-NET TO ED-N62.
    STRING "CTT~" ED-N31 "~~" ED-N61 "~KG~" ED-N62 "~KG" INTO-RECORD.
    STRING "SE~" ED-ST-TOT "~" ED-ST-NUM INTO-RECORD.
    MOVE 1 TO FO-PIND(3) REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD GO CJ3.
CJ9. STRING "GE~" ED-GS-TOT "~" ED-GS-NUM INTO-RECORD.
    STRING "IEA~" ED-ISA-TOT "~" ED-ISA-NUM INTO-RECORD.
    CLOSE CFORD CFLIN EDI GO MN9.
    REPLACE OFF.

* E-3 PRINT COMBINATION CUSTOMS FORMS
CB1. PERFORM RD385 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    MOVE EPS-ALIGN TO PREC WRITE PREC MOVE " " TO PREC.
* note 204.2
    OPEN I-O CFORD ALLOWING ALL CFLIN ALLOWING ALL.
    PERFORM INIT-UN MOVE USN-USER TO US-USER READ USERS REGARDLESS INVALID CONTINUE.
    MOVE US-NAME TO CB-UNAME.

    MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO CB9.
CB3. READ CFORD NEXT REGARDLESS END GO CB9. IF FO-PIND(1)=1 GO CB3.
    MOVE FO-CUS TO A-A1 PERFORM CHK-CUSFORM IF CFO-IND=0 GO CB3.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS.
* note 81.1
    MOVE 2 TO CB-LNP IF FO-STATE="MX" MOVE 3 TO CB-LNP.
    MOVE 31 TO CB-LN1 MOVE 45 TO CB-LN2 CB-LNN.
    SUBTRACT 3 FROM CB-LNN IF C-EDICF=1 SUBTRACT 1 FROM CB-LNN.
    IF FO-CUS="06105" OR "06106" SUBTRACT 1 FROM CB-LNN.
    IF FO-PALLETS>0 SUBTRACT 2 FROM CB-LNN.
    COMPUTE WN1=(CB-LN2 - CB-LN1 + 1) / CB-LNP.
    COMPUTE WN2=(CB-LNN - CB-LN1 + 1) / CB-LNP COMPUTE WN2=FO-LINES - WN2.
    IF WN2<=0 MOVE 1 TO CB-NPG
      ELSE DIVIDE WN2 BY WN1 GIVING CB-NPG REMAINDER WN3
        ADD 1 TO CB-NPG IF WN3>0 ADD 1 TO CB-NPG.

    IF FO-SHIPTO=0 GO CB4. MOVE FO-CUS TO SA-CUS MOVE FO-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO CB4. PERFORM GET-FO-CUSADD.
CB4. MOVE 0 TO WS-PAGE PERFORM CB-PAGE.

    MOVE FO-BL TO FL-BL MOVE 0 TO FL-SEQ.
CB5. ADD 1 TO FL-SEQ READ CFLIN REGARDLESS INVALID GO CB6.
    IF FL-PROD="C" GO CB5. PERFORM COU-LINES.
    PERFORM VARYING CB-IX1 FROM 1 BY 1 UNTIL CB-IX1>2
    PERFORM VARYING CB-IX2 FROM 1 BY 1 UNTIL CB-IX2>3
      IF COU-QTY(CB-IX1,CB-IX2) NOT=0 PERFORM CB-PR END-IF END-PERFORM END-PERFORM.
    IF FO-STATE="MX" PERFORM CB-LINE. GO CB5.
CB6. IF WS-LINES>CB-LNN PERFORM CB-END PERFORM CB-PAGE.
    IF WS-LINES<CB-LNN COMPUTE WS-PR=CB-LNN - WS-LINES PERFORM PR-LINE.
    PERFORM PR-LINE MOVE MSG-M8 TO FF404 PERFORM PR-LINE.
    PERFORM SET-BROKER MOVE A-A1 TO FF404 PERFORM PR-LINE.
    IF C-EDICF=1 MOVE MSG-M1 TO FF404 PERFORM PR-LINE.
    IF FO-CUS="06105" OR "06106" MOVE MSG-M3 TO FF404 PERFORM PR-LINE.
    IF FO-PALLETS>0 MOVE MSG-M4A TO FF404 PERFORM PR-LINE MOVE MSG-M4B TO FF404 PERFORM PR-LINE.
    COMPUTE WS-PR=48 - WS-LINES MOVE FO-TOTAL TO FF394 PERFORM PR-LINE.
    PERFORM CB-END MOVE 1 TO FO-PIND(1) REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD.
    GO CB3.
CB9. CLOSE CFORD CFLIN PERFORM CLOSE-PR GO MN9.

CB-PR. IF COU-COUNTRY(CB-IX1,CB-IX2)=0 MOVE "CDA" TO FF387
      ELSE MOVE 14 TO T-TBL MOVE COU-COUNTRY(CB-IX1,CB-IX2) TO T-NO PERFORM RD-TBL
        MOVE T-CTA TO FF387.
    IF COU-COUNTRY(CB-IX1,CB-IX2)=0 MOVE "XO" TO FF388.
    IF COU-COUNTRY(CB-IX1,CB-IX2)=0 OR 1 OR 2 MOVE "C" TO FF389.
    MOVE COU-DESC(CB-IX1,CB-IX2) TO FF390.
    IF COU-COUNTRY(CB-IX1,CB-IX2)=0 MOVE "YES" TO FF391 ELSE MOVE "NO" TO FF391.
    MOVE "NO" TO FF391A MOVE COU-QTY(CB-IX1,CB-IX2) TO FF391B.
    MOVE COU-PRICE(CB-IX1,CB-IX2) TO FF392 MOVE COU-MODE(CB-IX1,CB-IX2) TO FF393.
    MOVE COU-EXT(CB-IX1,CB-IX2) TO FF394 PERFORM PR-LINE.
    MOVE "PROD NO." TO FF397 MOVE COU-PROD(CB-IX1,CB-IX2) TO FF398.
    MOVE COU-HCODE(CB-IX1,CB-IX2) TO A-N1 PERFORM DESC-HARM MOVE PRO-HARM TO FF399.
    PERFORM CB-LINE.
CB-END. COMPUTE WS-PR=56 - WS-LINES MOVE CB-NPG TO FF395 PERFORM PR-LINE.
    MOVE 5 TO WS-PR MOVE CB-UNAME TO FF396 PERFORM PR-LINE.
    MOVE "IRVINE FASTENERS" TO FF376.
    MOVE FO-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF377 PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE "SHIPPING CLERK" TO FF400 MOVE "519-324-6448" TO FF401.
    MOVE "519-324-2731" TO FF402 PERFORM PR-LINE WRITE PREC AFTER PAGE.
CB-LINE. PERFORM PR-LINE IF WS-LINES>CB-LN2 - 1 PERFORM CB-END PERFORM CB-PAGE.
CB-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES.
    IF C-BROKER=0 MOVE " " TO A-A1 A-A2
      ELSE MOVE 4 TO T-TBL MOVE C-BROKER TO T-NO PERFORM RD-TBL
        MOVE T-LINE TO A-A1 MOVE "XXXXXXXXXXXXXXX" TO A-A2.
    MOVE A-A2 TO PREC(17:) PERFORM PR-LINE.
    MOVE A-A2 TO PREC(17:) PERFORM PR-LINE.
    MOVE A-A1 TO PREC(3:) PERFORM PR-LINE MOVE 5 TO WS-PR.
    MOVE WS-NAME TO FF367 MOVE "SAME AS EXPORTER" TO FF368 PERFORM PR-LINE.
    MOVE WS-ADD1 TO FF367 PERFORM PR-LINE.
    MOVE WS-ADD2 TO FF367 PERFORM PR-LINE.
    MOVE WS-POST TO FF367 PERFORM PR-LINE.
    MOVE WS-TAXID TO FF367(3:16) PERFORM PR-LINE MOVE 3 TO WS-PR.
    MOVE C-NAME TO FF367 MOVE FO-NAME TO FF368 PERFORM PR-LINE.
    MOVE C-ADD1 TO FF367 MOVE FO-ADD1 TO FF368 PERFORM PR-LINE.
    MOVE C-ADD2 TO FF367 MOVE FO-ADD2 TO FF368 PERFORM PR-LINE.
    MOVE C-POST TO FF367 MOVE FO-POST TO FF368 PERFORM PR-LINE.
    MOVE C-IRS TO FF367(3:15) PERFORM PR-LINE.
    MOVE FO-BL TO FF365 PERFORM PR-LINE.
    IF C-NO>"15000" MOVE "X" TO FF370 ELSE MOVE "X" TO FF371.
    MOVE FO-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF372.
    MOVE FO-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO FF373 PERFORM PR-LINE.
    MOVE FO-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF372 PERFORM PR-LINE.
    IF FO-PAYER="E" MOVE "X" TO FF366 ELSE MOVE "X" TO FF366A.
    MOVE "PAGE" TO FF361 MOVE WS-PAGE TO FF362 MOVE "OF" TO FF363.
    MOVE CB-NPG TO FF364 PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF C-US=1 MOVE "X" TO FF374 ELSE MOVE "X" TO FF375. PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF FO-PACKS(1)>0 MOVE FO-PACKS(1) TO FF378
      IF FO-PACKS(1)=1 MOVE "CARTON" TO FF379 ELSE MOVE "CARTONS" TO FF379 END-IF
      IF FO-PALLETS>0 MOVE "ON" TO FF380 MOVE FO-PALLETS TO FF381
        IF FO-PALLETS=1 MOVE "PALLET" TO FF382 ELSE MOVE "PALLETS" TO FF382.
    IF FO-PACKS(2)>0 AND FO-PACKS(1)=0 MOVE FO-PACKS(2) TO FF378
      IF FO-PACKS(2)=1 MOVE "TRIWALL" TO FF379 ELSE MOVE "TRIWALLS" TO FF379.
    PERFORM CALC-PACKS.
    IF A-N1>0 AND FO-PACKS(1)=0 MOVE A-N1 TO FF378
      IF A-N1=1 MOVE "BUCKET" TO FF379 ELSE MOVE "BUCKETS" TO FF379.
    IF A-N2>0 AND FO-PACKS(1)=0 MOVE A-N2 TO FF378
      IF A-N2=1 MOVE "BIN" TO FF379 ELSE MOVE "BINS" TO FF379.
    MOVE "GR:" TO FF383 MOVE FO-GROSS TO FF384 MOVE "KG" TO FF385.
    COMPUTE FF386 ROUNDED=FO-GROSS * FO-FRATE / 100.
    PERFORM PR-LINE COMPUTE WS-PR=CB-LN1 - WS-LINES - 1 PERFORM PR-LINE.

* E-4 CREATE ASN 856, DESADV
UC1. PERFORM RD307 PERFORM WRT.
    ACCEPT UC-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UC-OP=99 GO MN9. IF UC-OP=0 OR>15 GO UC1.

    EVALUATE TRUE
      WHEN UC-OP=1 SET ED-AOS TO TRUE MOVE "EDIAOS" TO EDI-ID
        MOVE " CREATE TOWER 856 FILE " TO WA1
      WHEN UC-OP=2 SET ED-CHRY TO TRUE MOVE "EDICHRY" TO EDI-ID
        MOVE " CREATE CHRYSLER 856 FILE " TO WA1
      WHEN UC-OP=3 SET ED-GMC TO TRUE MOVE "EDIGMC" TO EDI-ID
        MOVE " CREATE GM 856 FILE " TO WA1
      WHEN UC-OP=4 SET ED-TRW TO TRUE MOVE "EDITRW" TO EDI-ID
        MOVE " CREATE TRW EDIFACT DESADV FILE " TO WA1
      WHEN UC-OP=5 SET ED-TRW TO TRUE MOVE "EDITRW" TO EDI-ID
        MOVE " CREATE TRW 856 FILE " TO WA1
      WHEN UC-OP=6 SET ED-UTA TO TRUE MOVE "EDIUTA" TO EDI-ID
        MOVE " CREATE UTA 856 FILE " TO WA1
      WHEN UC-OP=7 SET ED-GMC TO TRUE MOVE "EDIGMC" TO EDI-ID
        MOVE " CREATE GM EDIFACT DESADV FILE (DESPATCH ADVICE) " TO WA1
      WHEN UC-OP=8 SET ED-GMC TO TRUE MOVE "EDIGMC" TO EDI-ID
        MOVE " CREATE GM 856 + DESADV (IN ONE FILE) " TO WA1
      WHEN UC-OP=9 MOVE "EDIADV" TO EDI-ID
        MOVE " CREATE ADVANTIS FILE " TO WA1
      WHEN UC-OP=10 SET ED-MGM TO TRUE MOVE "EDIMGM" TO EDI-ID
        MOVE " CREATE MGM 856 FILE " TO WA1
      WHEN UC-OP=11 SET ED-WOOD TO TRUE MOVE "EDIWOOD" TO EDI-ID
        MOVE " CREATE WOODBRIDGE 856 FILE " TO WA1
      WHEN UC-OP=12 SET ED-DANA TO TRUE MOVE "EDIDANA" TO EDI-ID
        MOVE " CREATE DANA 856 FILE " TO WA1
      WHEN UC-OP=13 SET ED-MOD TO TRUE MOVE "EDIMOD" TO EDI-ID
        MOVE " CREATE MODATEK 856 FILE " TO WA1
      WHEN UC-OP=14 SET ED-BEN TO TRUE MOVE "EDIBEN" TO EDI-ID
        MOVE " CREATE BENTELER 856 FILE " TO WA1
      WHEN UC-OP=15 SET ED-VEN TO TRUE MOVE "EDIVEN" TO EDI-ID
        MOVE " CREATE VENEST 856 FILE " TO WA1
      END-EVALUATE.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT OPEN OUTPUT EDI I-O CFORD ALLOWING ALL CFLIN ALLOWING ALL.

* note 151
    INITIALIZE UC-XIND.
    IF UC-OP=4 OR 5 OR 6 OR 10 OR 11 OR 12 OR 13 OR 14 OR 15 PERFORM UC-CHK.
    IF UC-OP=9
      SET ED-TRW TO TRUE PERFORM UC-CHK
      SET ED-MGM TO TRUE PERFORM UC-CHK
      SET ED-WOOD TO TRUE PERFORM UC-CHK
      SET ED-DANA TO TRUE PERFORM UC-CHK
      SET ED-MOD TO TRUE PERFORM UC-CHK
      SET ED-BEN TO TRUE PERFORM UC-CHK
      SET ED-VEN TO TRUE PERFORM UC-CHK.

    IF UC-OP=4 OR 7 PERFORM IC-DESADV
      ELSE IF UC-OP=8 PERFORM CC-E856 PERFORM IC-DESADV
      ELSE IF UC-OP=9
        SET ED-AOS TO TRUE PERFORM CC-E856
        SET ED-TRW TO TRUE PERFORM CC-E856 PERFORM IC-DESADV
        SET ED-DELP TO TRUE PERFORM IC-DESADV
        SET ED-AMAX TO TRUE PERFORM IC-DESADV
        SET ED-MGM TO TRUE PERFORM CC-E856
        SET ED-WOOD TO TRUE PERFORM CC-E856
        SET ED-DANA TO TRUE PERFORM CC-E856
        SET ED-MOD TO TRUE PERFORM CC-E856
        SET ED-BEN TO TRUE PERFORM CC-E856
        SET ED-VEN TO TRUE PERFORM CC-E856
      ELSE PERFORM CC-E856.
    CLOSE EDI CFORD CFLIN.
    OPEN INPUT EDI MOVE 0 TO WS1 READ EDI END GO UC4. MOVE 1 TO WS1.
UC4. CLOSE EDI.
    IF WS1=0 ADD 2 TO IXT DISPLAY "NO SHIPMENTS - EDI FILE IS EMPTY" LINE IXT
      PERFORM DSP-CONT.
UC9. GO MN9.

UC-CHK. PERFORM UC-C1 THRU UC-C9.
UC-C1. MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO UC-C9.
UC-C3. READ CFORD NEXT REGARDLESS END GO UC-C9. IF FO-IND=0 OR FO-PIND(4)=1 GO UC-C3.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    PERFORM INIT-PL MOVE FO-ORD TO PL-ORD READ PLANT REGARDLESS KEY PL-KO INVALID CONTINUE.
    EVALUATE TRUE
      WHEN ED-TRW IF AUTO-TRW AND PL-EDIFACT=0 MOVE 1 TO UC-IND(5) ELSE GO UC-C3 END-IF
      WHEN ED-MGM IF AUTO-MGM MOVE 1 TO UC-IND(10) ELSE GO UC-C3 END-IF
      WHEN ED-WOOD IF AUTO-WOOD MOVE 1 TO UC-IND(11) ELSE GO UC-C3 END-IF
      WHEN ED-DANA IF AUTO-DANA MOVE 1 TO UC-IND(12) ELSE GO UC-C3 END-IF
      WHEN ED-MOD IF AUTO-MOD MOVE 1 TO UC-IND(13) ELSE GO UC-C3 END-IF
      WHEN ED-BEN IF AUTO-BEN MOVE 1 TO UC-IND(14) ELSE GO UC-C3 END-IF
      WHEN ED-VEN IF AUTO-VEN MOVE 1 TO UC-IND(15) ELSE GO UC-C3 END-IF
      WHEN OTHER GO UC-C9.
UC-C9. EXIT.

    REPLACE ==INTO-RECORD== BY ==ED-NL DELIMITED SIZE INTO ED-RECORD POINTER ED-PTR PERFORM EL-SWRITE==.
* note 285.2
CC-E856. PERFORM CC1 THRU CC9.
CC1. IF ED-TRW AND UC-IND(5)=0 OR ED-MGM AND UC-IND(10)=0
       OR ED-WOOD AND UC-IND(11)=0 OR ED-DANA AND UC-IND(12)=0
       OR ED-MOD AND UC-IND(13)=0 OR ED-BEN AND UC-IND(14)=0
       OR ED-VEN AND UC-IND(15)=0 GO CC9.
    OPEN I-O DELJITEX ALLOWING ALL.
    MOVE X"1C" TO ED-NL MOVE "~" TO ED-SEP MOVE "<" TO ED-SUBSEP.
    IF ED-TRW MOVE X"15" TO ED-NL MOVE "*" TO ED-SEP ED-SUBSEP.
    ACCEPT ED-YYMMDD FROM DATE ACCEPT ED-TIME FROM TIME MOVE 1 TO ED-PTR.
    MOVE 20 TO ED-CC MOVE 3 TO ED-DX1 MOVE 6 TO ED-DX2.
    IF ED-MGM OR ED-WOOD OR ED-BEN OR ED-VEN MOVE 1 TO ED-DX1 MOVE 8 TO ED-DX2.

    IF NOT(ED-AOS OR ED-GMC) EVALUATE TRUE
      WHEN ED-CHRY MOVE "ZZ" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-CHRY-CL TO ED-SENDER-ID MOVE "04000" TO ED-RECEIVER-ID
      WHEN ED-TRW MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE "201479482" TO ED-RECEIVER-ID
      WHEN ED-UTA MOVE "01" TO ED-SENDER-QUAL MOVE "ZZ" TO ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE "UTA01" TO ED-RECEIVER-ID
      WHEN ED-MGM MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE "131906851" TO ED-RECEIVER-ID
      WHEN ED-WOOD MOVE "ZZ" TO ED-SENDER-QUAL MOVE "01" TO ED-RECEIVER-QUAL
        MOVE ED-WOOD-CL TO ED-SENDER-ID MOVE "000160077" TO ED-RECEIVER-ID
      WHEN ED-DANA MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE "005470885" TO ED-RECEIVER-ID
      WHEN ED-MOD MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE "200198765" TO ED-RECEIVER-ID
      WHEN ED-BEN MOVE "ZZ" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-BEN-CL TO ED-SENDER-ID MOVE "BENTUSA" TO ED-RECEIVER-ID
      WHEN ED-VEN MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE "244247250" TO ED-RECEIVER-ID
      END-EVALUATE PERFORM CC-ISA-GS.

    MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO CC8.
CC3. READ CFORD NEXT REGARDLESS END GO CC8. IF FO-IND=0 OR FO-PIND(4)=1 GO CC3.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    EVALUATE TRUE
      WHEN ED-AOS IF NOT AUTO-AOS GO CC3 END-IF
      WHEN ED-CHRY IF NOT AUTO-CHRY GO CC3 END-IF
      WHEN ED-GMC IF NOT AUTO-GMC GO CC3 END-IF
      WHEN ED-TRW IF NOT AUTO-TRW GO CC3 END-IF
      WHEN ED-UTA IF NOT AUTO-UTA GO CC3 END-IF
      WHEN ED-MGM IF NOT AUTO-MGM GO CC3 END-IF
      WHEN ED-WOOD IF NOT AUTO-WOOD GO CC3 END-IF
      WHEN ED-DANA IF NOT AUTO-DANA GO CC3 END-IF
      WHEN ED-MOD IF NOT AUTO-MOD GO CC3 END-IF
      WHEN ED-BEN IF NOT AUTO-BEN GO CC3 END-IF
      WHEN ED-VEN IF NOT AUTO-VEN GO CC3 END-IF
      WHEN OTHER GO CC3.

    PERFORM INIT-PL MOVE FO-ORD TO PL-ORD READ PLANT REGARDLESS KEY PL-KO INVALID CONTINUE.
    IF PL-EDIFACT=1 OR PL-RECEIVER=" " GO CC3.
    IF ED-BEN MOVE FO-DXNO TO A-N1 PERFORM DX-RD-BEN.

    IF ED-AOS MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
      MOVE ED-DUNS TO ED-SENDER-ID MOVE PL-PLANT TO ED-RECEIVER-ID
      PERFORM CC-ISA-GS.
    IF ED-GMC MOVE "ZZ" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
      MOVE ED-GMC-CL TO ED-SENDER-ID MOVE PL-RECEIVER TO ED-RECEIVER-ID
      IF PL-RECEIVER="AYG"
        MOVE "01" TO ED-SENDER-QUAL MOVE ED-DUNS TO ED-SENDER-ID END-IF
      IF PL-RECEIVER="SSG"
        MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
        MOVE ED-DUNS TO ED-SENDER-ID MOVE PL-ISSUER TO ED-RECEIVER-ID END-IF
      PERFORM CC-ISA-GS.

    ADD 1 TO ED-GS-TOT ADD 1 TO ED-ST-NUM MOVE 1 TO ED-ST-TOT.
    STRING "ST~856~" ED-ST-NUM INTO-RECORD.

    MOVE FO-BL TO A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO.
    STRING "BSN~00~" FO-BL(A-N1:) "~" ED-CCYYMMDD(ED-DX1:ED-DX2) "~" ED-HHMM INTO-RECORD.
    DIVIDE ED-HHMM BY 100 GIVING WN1 REMAINDER WN2 SUBTRACT 5 FROM WN2.
    IF WN2<0 ADD 60 TO WN2 SUBTRACT 1 FROM WN1 IF WN1<0 MOVE 0 TO WN1 WN2.
    COMPUTE ED-N41=100 * WN1 + WN2.
    STRING "DTM~011~" ED-CCYYMMDD(ED-DX1:ED-DX2) "~" ED-N41 INTO-RECORD.

    STRING "HL~1~~S" INTO-RECORD.
    COMPUTE ED-N61 ROUNDED=FO-GROSS / WEI-LB.
    MOVE ED-N61 TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    IF NOT ED-BEN STRING "MEA~PD~G~" ED-N61(A-N1:) "~LB" INTO-RECORD.
    IF ED-AOS OR ED-CHRY OR ED-TRW OR ED-UTA OR ED-DANA
      COMPUTE ED-N61 ROUNDED=FO-NET / WEI-LB
      MOVE ED-N61 TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO
      STRING "MEA~PD~N~" ED-N61(A-N1:) "~LB" INTO-RECORD.
    IF NOT ED-TRW PERFORM CC-TD1.
    IF ED-TRW MOVE FO-LINES TO ED-N21 A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO
      STRING "TD1~~" ED-N21(A-N1:) INTO-RECORD.
    MOVE FO-VIA TO SV-KEY PERFORM RD-VIA.
    MOVE " " TO WA1 IF SV-POOL>" " STRING "~~~PP~" SV-POOL DELIMITED " " INTO WA1.
    STRING "TD5~B~2~" SV-SCAC "~" SV-METHOD WA1 DELIMITED " " INTO-RECORD.
    IF NOT ED-TRW
      STRING "TD3~" FO-EQCODE "~" FO-EQINIT "~" FO-EQNUM DELIMITED " " INTO-RECORD.

    MOVE FO-BL TO A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO.
    IF ED-TRW OR ED-UTA OR ED-MGM OR ED-WOOD OR ED-DANA OR ED-MOD OR ED-VEN
      STRING "REF~PK~" FO-BL(A-N1:) INTO-RECORD.
    IF NOT(ED-GMC OR ED-DANA OR ED-MOD OR ED-BEN OR ED-VEN)
      STRING "REF~BM~" FO-BL(A-N1:) INTO-RECORD.
    IF ED-CHRY
      IF FO-CARRID>" " STRING "REF~FR~" FO-CARRID DELIMITED " " INTO-RECORD.
    IF ED-GMC
      IF FO-DOCK>" " STRING "REF~DK~" FO-DOCK DELIMITED " " INTO-RECORD
        ELSE IF PL-DOCK>" " STRING "REF~DK~" PL-DOCK DELIMITED " " INTO-RECORD.

    EVALUATE TRUE
      WHEN ED-AOS
        STRING "N1~SU~~1~" ED-DUNS INTO-RECORD
        STRING "N1~SF~~1~" ED-DUNS INTO-RECORD
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~MA~~92~" PL-PLANT DELIMITED " " INTO-RECORD
      WHEN ED-CHRY
        STRING "N1~SU~~92~" ED-CHRY-CL INTO-RECORD
        STRING "N1~SF~~92~" ED-CHRY-CL INTO-RECORD
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~MA~~92~" PL-PLANT DELIMITED " " INTO-RECORD
      WHEN ED-GMC
        IF PL-RECEIVER="PUO" STRING "N1~SF~~1~" ED-DUNS INTO-RECORD
          ELSE STRING "N1~SU~~1~" ED-DUNS INTO-RECORD END-IF
        MOVE PL-PLANT TO A-A1 PERFORM CC-N1-QUALIFIER
        STRING "N1~ST~~" CC-QUAL "~" PL-PLANT DELIMITED " " INTO-RECORD
        MOVE PL-ISSUER TO A-A1 PERFORM CC-N1-QUALIFIER
        STRING "N1~MI~~" CC-QUAL "~" PL-ISSUER DELIMITED " " INTO-RECORD
      WHEN ED-TRW
        STRING "N1~SF~~1~" ED-DUNS INTO-RECORD
        STRING "N1~ST~~1~" PL-PLANT DELIMITED " " INTO-RECORD
      WHEN ED-UTA
        STRING "N1~SF~~1~" ED-DUNS INTO-RECORD
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
      WHEN ED-MGM
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~SU~~92~" ED-MGM-CL INTO-RECORD
      WHEN ED-WOOD
        IF FO-FOB=WS-FOB MOVE "CC" TO ED-A21 ELSE MOVE "PP" TO ED-A21 END-IF
        STRING "FOB~" ED-A21 DELIMITED " " INTO-RECORD
        MOVE PL-ISSUER TO A-A1 PERFORM CC-N1-QUALIFIER
        STRING "N1~MI~~" CC-QUAL "~" PL-ISSUER DELIMITED " " INTO-RECORD
        STRING "N1~ST~~1~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~SU~~92~" ED-WOOD-CL INTO-RECORD
        STRING "N1~SF~~92~" ED-WOOD-CL INTO-RECORD
      WHEN ED-DANA
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~SU~~92~" ED-DANA-CL INTO-RECORD
      WHEN ED-MOD
        STRING "N1~MI~~92~" ED-MOD-REL DELIMITED " " INTO-RECORD
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~SU~~92~" ED-MOD-CL INTO-RECORD
      WHEN ED-BEN
        MOVE " " TO ED-PLNAME
        IF PL-PLANT="0445" MOVE "KALAMAZOO PLANT" TO ED-PLNAME END-IF
        STRING "N1~ST~" ED-PLNAME DELIMITED "  " "~98~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~SU~~16~" ED-DUNS INTO-RECORD
      WHEN ED-VEN
        STRING "N1~ST~~92~" PL-PLANT DELIMITED " " INTO-RECORD
        STRING "N1~SU~~1~" ED-DUNS INTO-RECORD
        STRING "N1~SF~~1~" ED-DUNS INTO-RECORD
      WHEN OTHER CONTINUE.

    IF ED-AOS OR ED-CHRY
      IF FO-ETNUM>" " STRING "ETD~ZZ~" FO-ETRESP "~AE~" FO-ETNUM DELIMITED " " INTO-RECORD.
    IF ED-DANA
      INITIALIZE FL-REC MOVE FO-BL TO FL-BL MOVE 1 TO FL-SEQ
      READ CFLIN REGARDLESS INVALID CONTINUE END-READ
      STRING "PRF~" FL-CUSORD DELIMITED " " INTO-RECORD.

    MOVE 1 TO CC-LNUM MOVE 0 TO CC-RCQTY CC-RCQTY-CUM.
    MOVE FO-BL TO FL-BL MOVE 0 TO FL-SEQ.
CC5. ADD 1 TO FL-SEQ READ CFLIN REGARDLESS INVALID GO CC6.
    IF FL-PROD="C" GO CC5.
    IF FL-PROD="0000CC30" MOVE FL-PROD TO CC-RC
      ADD FL-QTY TO CC-RCQTY ADD FL-QTY-CUM TO CC-RCQTY-CUM GO CC5.
    ADD 1 TO CC-LNUM PERFORM CC-NUM.
    IF ED-MGM MOVE "~~I" TO ED-A41
      ELSE IF ED-BEN MOVE "~1~I" TO ED-A41 ELSE MOVE "~1~O" TO ED-A41.
    STRING "HL~" CC-LNUM(A-N1:) DELIMITED SIZE ED-A41 DELIMITED " " INTO-RECORD.
    MOVE FL-PROD TO CC-PROD A-A1 PERFORM PROD-RGD.
    IF ED-TRW
      IF FL-PROD(1:3)="10-" MOVE FL-PROD(4:) TO CC-PROD.
    IF ED-AOS OR ED-CHRY OR ED-GMC
      MOVE FL-PROD TO A-A1 PERFORM EXTEND-PNO MOVE A-A1 TO CC-PROD.
    MOVE " " TO ED-A101.
    IF ED-GMC
      MOVE FL-MODYR TO ED-N21 STRING "~RY~" ED-N21 DELIMITED " " INTO ED-A101.
    IF NOT(ED-GMC OR ED-WOOD) MOVE "~EC~REL" TO ED-A101.
    MOVE " " TO ED-A201 IF FL-RC>" " STRING "~RC~" FL-RC DELIMITED " " INTO ED-A201.
    IF NOT(ED-MGM OR ED-DANA OR ED-MOD OR ED-BEN)
      STRING "LIN~~BP~" CC-PROD ED-A101 ED-A201 DELIMITED " " INTO-RECORD.
    MOVE " " TO ED-A101 IF PRO-ENG>" " STRING "~EC~" PRO-ENG DELIMITED " " INTO ED-A101.
    IF ED-MGM
      MOVE FL-SEQ TO ED-N21 A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO
      STRING "LIN~" ED-N21(A-N1:) "~BP~" CC-PROD "~VP~" P-NO ED-A101 DELIMITED " " INTO-RECORD.
    IF ED-DANA OR ED-MOD
      STRING "LIN~~BP~" CC-PROD ED-A101 DELIMITED " " INTO-RECORD.
    IF ED-BEN MOVE " " TO WA1 MOVE 1 TO IX2
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>ED-BXL
        STRING "~" ED-BLCODE(IX1) "~" ED-BLVAL(IX1) DELIMITED " "
          INTO WA1 POINTER IX2 END-PERFORM
      STRING "LIN~~BP~" CC-PROD WA1 DELIMITED " " INTO-RECORD.
    MOVE FL-QTY TO ED-N91 MOVE FL-QTY-CUM TO ED-N92 PERFORM CC-SN1.
    MOVE " " TO ED-A31 IF PL-RECEIVER="SSG" MOVE "SAG" TO ED-A31.
    IF NOT(ED-DANA OR ED-BEN)
      STRING "PRF~" ED-A31 FL-CUSORD DELIMITED " " INTO-RECORD.
    IF ED-MOD MOVE CC-LNUM TO CC-PNUM ADD 1 TO CC-LNUM PERFORM CC-NUM
      STRING "HL~" CC-LNUM(A-N1:) "~" CC-PNUM(A-N2:) "~I" INTO-RECORD
      STRING "REF~LF~0010" INTO-RECORD.
    IF ED-TRW PERFORM CC-TD1.
    IF ED-MGM OR ED-WOOD OR ED-DANA OR ED-MOD
      MOVE FO-PACKS(1) TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1
      MOVE P-QTY-PACK TO ED-N62 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2
      PERFORM CC-PKT
      STRING "CLD~" ED-N61(WN1:) "~" ED-N62(WN2:) "~" ED-A51 INTO-RECORD.
    IF ED-AOS OR ED-CHRY OR ED-MGM
      MOVE FL-PKSLIP TO ED-N71 STRING "REF~PK~" ED-N71 INTO-RECORD.
    GO CC5.
CC6. IF CC-RCQTY>0 ADD 1 TO CC-LNUM PERFORM CC-NUM
      STRING "HL~" CC-LNUM(A-N1:) "~1~O" INTO-RECORD
      STRING "LIN~~RC~" CC-RC INTO-RECORD
      MOVE CC-RCQTY TO ED-N91 MOVE CC-RCQTY-CUM TO ED-N92 PERFORM CC-SN1.
    STRING "CTT~" CC-LNUM INTO-RECORD.
    STRING "SE~" ED-ST-TOT "~" ED-ST-NUM INTO-RECORD.

    MOVE 1 TO FO-PIND(4) REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD.
    IF ED-AOS OR ED-GMC PERFORM CC-GE-IEA.
    GO CC3.
CC8. IF NOT(ED-AOS OR ED-GMC) PERFORM CC-GE-IEA.
    CLOSE DELJITEX.
CC9. EXIT.

CC-NUM. MOVE 1 TO A-N1 IF CC-LNUM<=9 MOVE 2 TO A-N1.
    MOVE 1 TO A-N2 IF CC-PNUM<=9 MOVE 2 TO A-N2.
CC-TD1. MOVE FO-PACKS(1) TO ED-N61.
    IF ED-GMC MOVE "PCS71" TO ED-A51 ELSE PERFORM CC-PKT ADD A-N1 TO ED-N61.
    MOVE ED-N61 TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "TD1~" ED-A51 "~" ED-N61(A-N1:) INTO-RECORD.
CC-PKT. MOVE 0 TO A-N1 PERFORM VARYING A-X1 FROM 2 BY 1 UNTIL A-X1>9
      ADD FO-PACKS(A-X1) TO A-N1 END-PERFORM.
    IF FO-PACKS(1)>0 AND A-N1>0 MOVE "MIX90" TO ED-A51
      ELSE IF A-N1>0 MOVE "BIN79" TO ED-A51 ELSE MOVE "CTN25" TO ED-A51.
CC-SN1. MOVE ED-N91 TO A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO A-X1.
    MOVE ED-N92 TO A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO A-X2.
    IF ED-BEN MOVE "~PC" TO ED-A31
      STRING "SN1~~" ED-N91(A-X1:) ED-A31 INTO-RECORD
     ELSE MOVE "~EA~" TO ED-A41
      STRING "SN1~~" ED-N91(A-X1:) ED-A41 ED-N92(A-X2:) INTO-RECORD.
CC-N1-QUALIFIER. PERFORM STR-LTH.
    IF A-N1=9 MOVE "1" TO CC-QUAL ELSE MOVE "92" TO CC-QUAL.
CC-ISA-GS. PERFORM RD-EDINFO.
    EVALUATE TRUE
      WHEN ED-AOS ADD 1 TO EI-AOS-ISA MOVE EI-AOS-ISA TO ED-ISA-NUM
        MOVE "00204" TO ED-ISA-VERSION MOVE "002040" TO ED-GS-VERSION
      WHEN ED-CHRY ADD 1 TO EI-CHRY-ISA MOVE EI-CHRY-ISA TO ED-ISA-NUM
        MOVE "00204" TO ED-ISA-VERSION MOVE "002040CHRY" TO ED-GS-VERSION
      WHEN ED-GMC ADD 1 TO EI-GMC-ISA MOVE EI-GMC-ISA TO ED-ISA-NUM
        MOVE "00301" TO ED-ISA-VERSION MOVE "002040GM" TO ED-GS-VERSION
      WHEN ED-TRW ADD 1 TO EI-TRW-ISA MOVE EI-TRW-ISA TO ED-ISA-NUM
        MOVE "00204" TO ED-ISA-VERSION MOVE "002040" TO ED-GS-VERSION
      WHEN ED-UTA ADD 1 TO EI-UTA-ISA MOVE EI-UTA-ISA TO ED-ISA-NUM
        MOVE "00200" TO ED-ISA-VERSION MOVE "002040" TO ED-GS-VERSION
      WHEN ED-MGM ADD 1 TO EI-MGM-ISA MOVE EI-MGM-ISA TO ED-ISA-NUM
        MOVE "00401" TO ED-ISA-VERSION MOVE "004010" TO ED-GS-VERSION
      WHEN ED-WOOD ADD 1 TO EI-WOOD-ISA MOVE EI-WOOD-ISA TO ED-ISA-NUM
        MOVE "00401" TO ED-ISA-VERSION MOVE "004010" TO ED-GS-VERSION
      WHEN ED-DANA ADD 1 TO EI-DANA-ISA MOVE EI-DANA-ISA TO ED-ISA-NUM
        MOVE "00401" TO ED-ISA-VERSION MOVE "002003" TO ED-GS-VERSION
      WHEN ED-MOD ADD 1 TO EI-MOD-ISA MOVE EI-MOD-ISA TO ED-ISA-NUM
        MOVE "00306" TO ED-ISA-VERSION MOVE "003060" TO ED-GS-VERSION
      WHEN ED-BEN ADD 1 TO EI-BEN-ISA MOVE EI-BEN-ISA TO ED-ISA-NUM
        MOVE "00401" TO ED-ISA-VERSION MOVE "004010" TO ED-GS-VERSION
      WHEN ED-VEN ADD 1 TO EI-VEN-ISA MOVE EI-VEN-ISA TO ED-ISA-NUM
        MOVE "00401" TO ED-ISA-VERSION MOVE "004010" TO ED-GS-VERSION
      WHEN OTHER
        MOVE "00204" TO ED-ISA-VERSION MOVE "002040" TO ED-GS-VERSION
      END-EVALUATE.
    PERFORM WR-EDINFO.

    MOVE 0 TO ED-ISA-TOT ED-GS-NUM.
    STRING "ISA~00~          ~00~          ~"
      ED-SENDER-QUAL "~" ED-SENDER-ID "~" ED-RECEIVER-QUAL "~" ED-RECEIVER-ID "~"
      ED-YYMMDD "~" ED-HHMM "~U~" ED-ISA-VERSION "~" ED-ISA-NUM "~0~P~" ED-SUBSEP INTO-RECORD.
    ADD 1 TO ED-ISA-TOT.
    ADD 1 TO ED-GS-NUM MOVE 0 TO ED-GS-TOT ED-ST-NUM.
    STRING "GS~SH~" ED-SENDER-ID "~" ED-RECEIVER-ID DELIMITED " "
      "~" ED-CCYYMMDD(ED-DX1:ED-DX2) "~" ED-HHMM "~" ED-GS-NUM "~X~" DELIMITED SIZE
      ED-GS-VERSION DELIMITED " " INTO-RECORD.
CC-GE-IEA. STRING "GE~" ED-GS-TOT "~" ED-GS-NUM INTO-RECORD.
    STRING "IEA~" ED-ISA-TOT "~" ED-ISA-NUM INTO-RECORD.
    REPLACE OFF.

    REPLACE ==INTO-RECORD== BY ==ED-NL DELIMITED SIZE INTO ED-RECORD POINTER ED-PTR PERFORM EL-WRITE==.
IC-DESADV. PERFORM IC1 THRU IC9.
IC1. OPEN I-O DELJITEX ALLOWING ALL.
    ACCEPT D-DT FROM DATE MOVE D-DT TO ED-YYMMDD PERFORM D-YN PERFORM D-NM.
    COMPUTE ED-CC=D-YEAR / 100 ACCEPT ED-TIME FROM TIME.
    MOVE 1 TO ED-PTR MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.

    MOVE 0 TO FO-BL START CFORD KEY>FO-KEY REGARDLESS INVALID GO IC8.
IC3. READ CFORD NEXT REGARDLESS END GO IC8. IF FO-IND=0 OR FO-PIND(4)=1 GO IC3.
    MOVE FO-CUS TO A-A1 PERFORM RD-CUS MOVE C-AUTO TO AUTO-CODE.
    EVALUATE TRUE
      WHEN ED-GMC IF NOT AUTO-GMC GO IC3 END-IF
      WHEN ED-AMAX IF NOT AUTO-AMAX GO IC3 END-IF
      WHEN ED-DELP IF NOT AUTO-DELP GO IC3 END-IF
      WHEN ED-TRW IF NOT AUTO-TRW GO IC3 END-IF
      WHEN OTHER GO IC3.

    PERFORM INIT-PL MOVE FO-ORD TO PL-ORD READ PLANT REGARDLESS KEY PL-KO INVALID CONTINUE.
    IF PL-EDIFACT=0 OR PL-RECEIVER=" " GO IC3.

* note 188
    MOVE 0 TO IC-KSPO IC-KSAT IC-KSATSRV IC-KSHAN.
    IF PL-ISSUER="17501" MOVE 1 TO IC-KSPO.
    IF PL-RECEIVER="A2Y" MOVE 1 TO IC-KSAT MOVE FO-DXNO TO A-N1 PERFORM DX-RD-SAT
      IF PL-PLANT="603289984" MOVE 1 TO IC-KSATSRV.
    IF PL-PLANT="72872" MOVE 1 TO IC-KSHAN.

    IF ED-GMC MOVE FO-DXNO TO A-N1 PERFORM DX-RD-GMC.
    IF ED-DELP MOVE FO-DXNO TO A-N1 PERFORM DX-RD-DELP.
    IF ED-AMAX MOVE FO-DXNO TO A-N1 PERFORM DX-RD-AMAX
      MOVE 0 TO IC-KMEX IF FO-CUS="06105" MOVE 1 TO IC-KMEX.

    MOVE "ZZ" TO ED-SENDER-QUAL ED-RECEIVER-QUAL.
    MOVE ED-GMC-CL TO ED-SENDER-ID MOVE PL-RECEIVER TO ED-RECEIVER-ID.
    IF ED-AMAX MOVE "01" TO ED-SENDER-QUAL MOVE ED-DUNS TO ED-SENDER-ID.
    IF ED-DELP MOVE "IFLS" TO ED-SENDER-ID.
    IF ED-TRW MOVE "01" TO ED-SENDER-QUAL MOVE ED-DUNS TO ED-SENDER-ID
      MOVE "TRWGDC" TO ED-RECEIVER-ID.
    IF IC-KSHAN=1 MOVE " " TO ED-RECEIVER-QUAL MOVE "654651652" TO ED-RECEIVER-ID.
    IF PL-RECEIVER="SSG" OR "UCC"
      MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL
      MOVE ED-DUNS TO ED-SENDER-ID MOVE PL-ISSUER TO ED-RECEIVER-ID.

    PERFORM RD-EDINFO ADD 1 TO EI-GMC-ISA MOVE EI-GMC-ISA TO ED-ISA-NUM PERFORM WR-EDINFO.
    MOVE 1 TO ED-ISA-TOT.
    MOVE ED-ISA-NUM TO A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    MOVE "GMDESADV" TO ED-A101.
    IF ED-AMAX MOVE "AAMDESADV" TO ED-A101.
    IF ED-DELP MOVE "DESADV" TO ED-A101.
    MOVE " " TO ED-A31 IF ED-TRW MOVE "++1" TO ED-A31.
    STRING "UNB+UNOA:2+" ED-SENDER-ID ":" ED-SENDER-QUAL "+"
      ED-RECEIVER-ID ":" ED-RECEIVER-QUAL "+" DELIMITED " "
      ED-YYMMDD ":" ED-HHMM "+" ED-ISA-NUM(A-N1:) "++" DELIMITED SIZE
      ED-A101 ED-A31 DELIMITED " " INTO-RECORD.
    MOVE 1 TO ED-ST-NUM ED-ST-TOT.
    MOVE ED-ST-NUM TO A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO.
    STRING "UNH+" ED-ST-NUM(A-N1:) "+DESADV:D:97A:UN" INTO-RECORD.

    MOVE " " TO ED-A201 ED-A51.
    IF IC-KSPO=1 OR IC-KSAT=1 MOVE "351" TO ED-A201.
    IF ED-TRW MOVE "350:::DESADV" TO ED-A201 MOVE "+NA" TO ED-A51.
    MOVE FO-BL TO A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO.
    STRING "BGM+" ED-A201 "+" DELIMITED " " FO-BL(A-N1:) DELIMITED SIZE
      "+9" ED-A51 DELIMITED " " INTO-RECORD.

    IF NOT ED-TRW GO IC34.
    STRING "DTM+10:" ED-CCYYMMDD ":102" INTO-RECORD.
    STRING "DTM+97:" ED-CCYYMMDD ":102" INTO-RECORD.
    MOVE FO-GROSS TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "MEA+EGW++KG:" ED-N61(A-N1:) INTO-RECORD.
    COMPUTE ED-N61 ROUNDED=(FO-PACKS(1) * WEI-WT(1) + FO-PALLETS * WEI-PALLET) * WEI-LB.
    MOVE ED-N61 TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "MEA+WT++KG:" ED-N61(A-N1:) INTO-RECORD.
    MOVE FO-PACKS(1) TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "MEA+AAU++EA:" ED-N61(A-N1:) INTO-RECORD.
    MOVE FO-BL TO A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO.
    STRING "RFF+BM:" FO-BL(A-N1:) INTO-RECORD.
    STRING "RFF+PK:" FO-BL(A-N1:) INTO-RECORD.
    STRING "NAD+SF+" ED-DUNS INTO-RECORD.
    MOVE PL-PLANT TO A-A1.
    STRING "NAD+ST+" A-A1 DELIMITED " " INTO-RECORD.
    MOVE FO-VIA TO SV-KEY PERFORM RD-VIA.
    MOVE SV-CARRIER TO A-A1 PERFORM STR-LTH.
    STRING "TDT+20++" SV-METHOD "++" SV-SCAC DELIMITED " " INTO-RECORD.
    STRING "CPS+1" INTO-RECORD.
    GO IC4.
IC34. STRING "DTM+137:" ED-CCYYMMDD ED-HHMM ":203" INTO-RECORD.
    DIVIDE ED-HHMM BY 100 GIVING WN1 REMAINDER WN2 SUBTRACT 5 FROM WN2.
    IF WN2<0 ADD 60 TO WN2 SUBTRACT 1 FROM WN1 IF WN1<0 MOVE 0 TO WN1 WN2.
    COMPUTE ED-N41=100 * WN1 + WN2.
    STRING "DTM+11:" ED-CCYYMMDD ED-N41 ":203" INTO-RECORD.

    COMPUTE ED-N61 ROUNDED=FO-GROSS / WEI-LB.
    MOVE ED-N61 TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "MEA+AAX+G+LBR:" ED-N61(A-N1:) INTO-RECORD.
    COMPUTE ED-N61 ROUNDED=FO-NET / WEI-LB.
    MOVE ED-N61 TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    IF IC-KSPO=0 AND IC-KSAT=0
      STRING "MEA+AAX+N+LBR:" ED-N61(A-N1:) INTO-RECORD.
    IF ED-DELP OR ED-AMAX OR IC-KSPO=1 OR IC-KSAT=1 MOVE "C62" TO ED-A31
      ELSE MOVE "EA" TO ED-A31.
    IF IC-KSAT=0 MOVE FO-TQTY TO WN1 ELSE COMPUTE WN1=ED-SKAN-N(2) - ED-SKAN-N(1) + 1.
    MOVE WN1 TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "MEA+AAX+SQ+" DELIMITED SIZE ED-A31 DELIMITED " " ":" ED-N61(A-N1:) INTO-RECORD.
    IF ED-AMAX
      MOVE FO-BL TO ED-N71 A-U1 IF IC-KMEX=1 MOVE FO-INVNO TO ED-N71 A-U1 END-IF
      MOVE 7 TO A-N1 PERFORM COUNT-ZERO
      STRING "RFF+MB:" ED-N71(A-N1:) INTO-RECORD
      MOVE FO-INVNO TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO
      STRING "RFF+IV:" ED-N61(A-N1:) INTO-RECORD
      MOVE 0 TO ED-N91 A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO
      STRING "RFF+CN:" ED-N91(A-N1:) INTO-RECORD.
    IF IC-KSAT=1 MOVE FO-BL TO A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO
      STRING "RFF+PK:" FO-BL(A-N1:) INTO-RECORD.
    IF ED-GMC
      MOVE FO-CARRID TO ED-A201 IF IC-KSAT=1 AND ED-A201=" " MOVE "123456" TO ED-A201 END-IF
      IF ED-A201>" " STRING "RFF+CN:" DELIMITED SIZE ED-A201 DELIMITED " " INTO-RECORD.
    MOVE PL-ISSUER TO A-A1 IF IC-KSHAN=1 MOVE PL-PLANT TO A-A1. PERFORM IC-NAD-QUAL.
    STRING "NAD+MI+" A-A1 DELIMITED " " "::" IC-QUAL INTO-RECORD.
    MOVE ED-DUNS TO A-A1 PERFORM IC-NAD-QUAL.
    IF IC-KSAT=0 STRING "NAD+SU+" A-A1 DELIMITED " " "::" IC-QUAL INTO-RECORD
      ELSE STRING "NAD+SU+" A-A1 DELIMITED " " "::" IC-QUAL "++IRVINE FASTENERS" INTO-RECORD
           STRING "NAD+SF+" A-A1 DELIMITED " " "::" IC-QUAL INTO-RECORD.
    IF ED-GMC AND ED-GNAD>" " MOVE ED-GNAD TO A-A1 PERFORM STR-LTH
      STRING "NAD+OB+" ED-GNAD(1:A-N1 - 1) INTO-RECORD.
    MOVE PL-PLANT TO A-A1 IF IC-KSAT=1 MOVE "603289984" TO A-A1. PERFORM IC-NAD-QUAL.
    STRING "NAD+ST+" A-A1 DELIMITED " " "::" IC-QUAL INTO-RECORD.
* note 133
    IF ED-AMAX MOVE ED-ADOCK TO A-A1 ELSE MOVE FO-DOCK TO A-A1.
    IF A-A1=" " MOVE PL-DOCK TO A-A1.
    IF IC-KSAT=0 STRING "LOC+11+" A-A1 DELIMITED " " INTO-RECORD.
    MOVE FO-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO A-A1 PERFORM STR-LTH.
    IF IC-KSAT=0 STRING "TDT+12++" SV-METHOD "++" SV-SCAC DELIMITED " " "::182" INTO-RECORD
      ELSE STRING "TDT+12++" SV-METHOD "++" SV-SCAC DELIMITED " " "::182:" SV-CARRIER(1:A-N1) INTO-RECORD.
    MOVE FO-EQCODE TO ED-A21 IF FO-EQCODE="TL" MOVE "TE" TO ED-A21.
    IF IC-KSAT=0 STRING "EQD+" ED-A21 "+" FO-EQINIT FO-EQNUM DELIMITED " " INTO-RECORD.

IC4. MOVE 0 TO IC-LNUM MOVE FO-BL TO FL-BL MOVE 0 TO FL-SEQ.
IC5. ADD 1 TO FL-SEQ READ CFLIN REGARDLESS INVALID GO IC6.
    IF FL-PROD="C" GO IC5.
    MOVE FL-PROD TO A-A1 PERFORM EXTEND-PNO MOVE A-A1 TO IC-PROD.
    MOVE FL-PROD TO A-A1 PERFORM PROD-GEN.

    IF NOT ED-TRW GO IC54.
    ADD 1 TO IC-LNUM MOVE IC-LNUM TO ED-N31 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO.
    STRING "LIN+" ED-N31(A-N1:) "++" IC-PROD DELIMITED " " INTO-RECORD.
    STRING "PIA+1+" FL-CUSORD ":PO" DELIMITED " " INTO-RECORD.
    MOVE FL-QTY TO ED-N91 A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    STRING "QTY+1:" ED-N91(A-N1:) ":EA" INTO-RECORD.
    MOVE FL-QTY-CUM TO ED-N91 A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    STRING "QTY+3:" ED-N91(A-N1:) ":EA" INTO-RECORD.
    GO IC58.

IC54. IF NOT ED-AMAX GO IC56.
    MOVE FL-DXNO TO A-N1 PERFORM DX-RD-AMAX.
    MOVE 0 TO DX-IXP.
IC543. ADD 1 TO DX-IXP IF DX-IXP>30 OR ED-AKAN(DX-IXP)=" " GO IC548.
    PERFORM DX-SET-CTNS MOVE 0 TO IC-IXC MOVE ED-ASERIAL(DX-IXP) TO IC-SERIAL.
IC545. ADD 1 TO IC-IXC IC-SERIAL IF IC-IXC>DX-CTNS GO IC546.
    ADD 1 TO IC-LNUM MOVE IC-LNUM TO ED-N31 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO.
    STRING "CPS+" ED-N31(A-N1:) "++4" INTO-RECORD.
    MOVE DX-CTNS TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "PAC+" ED-N61(A-N1:) "++00004848" INTO-RECORD.
    STRING "PCI+16" INTO-RECORD.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE ED-ASERIAL(DX-IXP) TO BAR-LI3.
    STRING "GIR+3+" BAR-LICENSE ":AW+" ED-AKAN(DX-IXP) ":AL+"
      ED-AORD(DX-IXP) ":AM" DELIMITED " " INTO-RECORD.
    STRING "LIN+++" IC-PROD ":IN" DELIMITED " " INTO-RECORD.
    DIVIDE FL-MODYR BY 10 GIVING WN1 REMAINDER ED-N11.
    STRING "PIA+1+" ED-N11 ":RY" DELIMITED " " INTO-RECORD.
    MOVE FL-QTY-CUM TO ED-N91 A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    STRING "QTY+3:" ED-N91(A-N1:) ":EA" INTO-RECORD.
    MOVE P-QTY-PACK TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    STRING "QTY+12:" ED-N61(A-N1:) ":EA" INTO-RECORD.
    MOVE "UN" TO BAR-LI1 MOVE ED-DUNS TO BAR-LI2 MOVE IC-SERIAL TO BAR-LI3.
    STRING "GIR+3+" BAR-LICENSE ":AW+" ED-AKAN(DX-IXP) ":AL+"
      ED-AORD(DX-IXP) ":AM" DELIMITED " " INTO-RECORD.
    STRING "RFF+ON:" FL-CUSORD DELIMITED " " INTO-RECORD.
    GO IC545.
IC546. GO IC543.
IC548. GO IC58.

IC56. ADD 1 TO IC-LNUM MOVE IC-LNUM TO ED-N31 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO.
    STRING "CPS+" ED-N31(A-N1:) "++4" INTO-RECORD.
    COMPUTE IC-CARTONS=FL-QTY / P-QTY-PACK SIZE ERROR MOVE 0 TO IC-CARTONS.
    MOVE IC-CARTONS TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO.
    IF IC-KSAT=0 AND (NOT ED-DELP) STRING "PAC+" ED-N61(A-N1:) "++PCS71" INTO-RECORD.
    IF IC-KSAT=1 STRING "PAC+" ED-N61(A-N1:) INTO-RECORD
      MOVE P-QTY-PACK TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO
      STRING "QTY+52:" ED-N61(A-N1:) INTO-RECORD
      STRING "PCI+16" INTO-RECORD
      PERFORM VARYING IX1 FROM ED-SKAN-N(1) BY 1 UNTIL IX1>ED-SKAN-N(2)
        MOVE IX1 TO ED-N61 COMPUTE WN1=6 - ED-SKAN-ND + 1
        STRING "GIR+3+" ED-SKAN-A ED-N61(WN1:) ":AL" INTO-RECORD
        END-PERFORM.
    IF ED-DELP STRING "PAC+" ED-N61(A-N1:) "++PCS71" INTO-RECORD
      MOVE P-QTY-PACK TO ED-N61 A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO
      STRING "QTY+52:" ED-N61(A-N1:) ":C62" INTO-RECORD
      STRING "PCI+16+" ED-DSTOR DELIMITED " " INTO-RECORD
      IF ED-DKNUM>0 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>ED-DKNUM
        STRING "GIR+3+" ED-DKVAL(IX1) DELIMITED " " ":AL" INTO-RECORD
        END-PERFORM.
    STRING "LIN+++" IC-PROD ":IN" DELIMITED " " INTO-RECORD.
    IF IC-KSPO=0 AND IC-KSAT=0
      DIVIDE FL-MODYR BY 10 GIVING WN1 REMAINDER ED-N11
      STRING "PIA+1+" ED-N11 ":RY" DELIMITED " " INTO-RECORD.
    IF IC-KSPO=1 OR ED-DELP MOVE "C62" TO ED-A31 ELSE MOVE "EA" TO ED-A31.
    MOVE FL-QTY-CUM TO ED-N91 A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    IF IC-KSAT=0 STRING "QTY+3:" ED-N91(A-N1:) ":" DELIMITED SIZE ED-A31 DELIMITED " " INTO-RECORD.
    MOVE FL-QTY TO ED-N91 A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    IF IC-KSAT=0 STRING "QTY+12:" ED-N91(A-N1:) ":" DELIMITED SIZE ED-A31 DELIMITED " " INTO-RECORD
      ELSE STRING "QTY+12:" ED-N91(A-N1:) INTO-RECORD.
    IF ED-DELP MOVE ED-DSCHEDNO TO ED-A201 ELSE MOVE FL-CUSORD TO ED-A201.
    STRING "RFF+ON:" ED-A201 DELIMITED " " INTO-RECORD.

IC58. GO IC5.
IC6. IF ED-TRW MOVE IC-LNUM TO ED-N31 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO
       STRING "CNT+2:" ED-N31(A-N1:) INTO-RECORD.
    MOVE ED-ST-TOT TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1.
    MOVE ED-ST-NUM TO A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2.
    STRING "UNT+" ED-ST-TOT(WN1:) "+" ED-ST-NUM(WN2:) INTO-RECORD.
    MOVE ED-ISA-TOT TO A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1.
    MOVE ED-ISA-NUM TO A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2.
    STRING "UNZ+" ED-ISA-TOT(WN1:) "+" ED-ISA-NUM(WN2:) INTO-RECORD.
    MOVE 1 TO FO-PIND(4) REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD.
    GO IC3.
IC8. CLOSE DELJITEX.
IC9. EXIT.

IC-NAD-QUAL. PERFORM STR-LTH.
    IF A-N1=9 MOVE "16" TO IC-QUAL ELSE MOVE "92" TO IC-QUAL.
    REPLACE OFF.

* E-5 PROCESS DAILY SHIP 862, DELJIT
UA1. PERFORM RD308 PERFORM WRT.
    ACCEPT UA-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UA-OP=99 GO MN9. IF UA-OP=0 OR>6 GO UA1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    EVALUATE TRUE
      WHEN UA-OP=1 SET ED-CHRY TO TRUE STRING "CHREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS CHRYSLER DAILY SHIP SCHEDULE (862) FILE " TO WA1
      WHEN UA-OP=2 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS GM DAILY SHIP SCHEDULE (862) FILE " TO WA1
      WHEN UA-OP=3 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS GM EDIFACT DAILY SHIP SCHEDULE (DELJIT) FILE " TO WA1
      WHEN UA-OP=4 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS ADVANTIS DAILY SHIP SCHEDULE (862) FILE " TO WA1
      WHEN UA-OP=5 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS ADVANTIS EDIFACT DAILY SHIP SCHEDULE (DELJIT) FILE " TO WA1
      WHEN UA-OP=6 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " REPORT ONLY: ADVANTIS EDIFACT DELJIT FILE " TO WA1
      END-EVALUATE.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9. CLOSE EDI.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    IF UA-OP=3 OR 5 OR 6 MOVE UA-OP TO IP-OP PERFORM IP-DELJIT
      ELSE MOVE UA-OP TO AC-OP PERFORM AC-E862.
    PERFORM CLOSE-PR.
UA9. GO MN9.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
AC-E862. PERFORM AC1 THRU AC9.
AC1. OPEN I-O DELJITEX ALLOWING ALL INPUT EDI PERFORM OPEN-SORT.
    MOVE 1 TO AC-STEP PERFORM AC-PAGE MOVE " " TO REL-OPLANT.
AC3. READ EDI END GO AC8.
    IF ED-RECORD(1:3) NOT="ISA" GO AC3. PERFORM EL-GET-SEP.
    MOVE ED-RECORD(36:15) TO ED-SENDER-ID.
* note 240.3
    IF AC-OP=4 EVALUATE TRUE
      WHEN ED-SENDER-ID="603992546" SET ED-SKF TO TRUE
      WHEN ED-SENDER-ID="BENTUSA" SET ED-BEN TO TRUE
      WHEN OTHER CONTINUE.
    MOVE ED-RECORD(71:6) TO REL-ISA-KEY(1:6).
    IF REL-IDATE NUMERIC MOVE REL-IDATE TO D-DT PERFORM D-YN MOVE D-DATE TO REL-IDATE.
    MOVE ED-RECORD(78:4) TO REL-ISA-KEY(7:4).
    MOVE ED-RECORD(91:9) TO REL-ISA-KEY(11:9).
AC33. READ EDI END PERFORM EDI-ERR GO AC8.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AC3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AC33.
AC35. READ EDI END PERFORM EDI-ERR GO AC8.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AC33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AC35.
    IF ED-RECORD(4:3)="862" GO AC4.
AC37. READ EDI END PERFORM EDI-ERR GO AC8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AC35. GO AC37.

AC4. PERFORM AC-LINE 2 TIMES MOVE 0 TO AC-IXN.
AC43. READ EDI END PERFORM EDI-ERR GO AC8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AC35.
    IF ED-RECORD(1:3)="LIN" AND ED-RECORD(4:1)=ED-SEP GO AC44.
    IF ED-RECORD(1:3)="BSS" AND ED-RECORD(4:1)=ED-SEP
      MOVE " " TO AC-N-SI AC-N-ST
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE AC-SCHEDULE
      MOVE ED-RECORD(1:EDI-SZ - 1) TO AC-BSS GO AC438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE
      IF ED-RECORD(4:2)="SI" MOVE ED-LINE TO AC-N-SI END-IF
      IF ED-RECORD(4:2)="ST" MOVE ED-LINE TO AC-N-ST END-IF
      GO AC438.
    IF ED-RECORD(1:3)="NTE" AND ED-RECORD(4:1)=ED-SEP
      IF AC-IXN<3 ADD 1 TO AC-IXN MOVE ED-RECORD(1:EDI-SZ - 1) TO AC-TEXT(AC-IXN) END-IF
      GO AC438.
AC438. GO AC43.
AC44. IF AC-N-ST>" " MOVE AC-N-ST TO REL-PLANT ELSE MOVE AC-N-SI TO REL-PLANT.
    IF ED-SKF MOVE "07252" TO REL-PLANT.
    IF REL-PLANT NOT=REL-OPLANT
      IF REL-OPLANT>" " PERFORM AC-PAGE END-IF MOVE REL-PLANT TO REL-OPLANT.
    MOVE "PLANT:" TO FG130 MOVE REL-PLANT TO FG131.
    IF NOT(AC-SCHEDULE="SH" OR "DL") MOVE "** NOT 'SHIP' QTY **" TO FG132.
    MOVE AC-BSS TO FG133 INSPECT FG133 REPLACING ALL ED-SEP BY ":" PERFORM AC-LINE.
    IF AC-IXN>0 MOVE 2 TO WS-PR
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AC-IXN
        MOVE AC-TEXT(IX1) TO PREC INSPECT PREC REPLACING ALL ED-SEP BY ":"
        PERFORM AC-LINE END-PERFORM.

* LIN records
    MOVE 0 TO AC-KFIN.
AC45. INITIALIZE REL-PROD AC-LIN AC-IXL ED-BEN-DATA.
    MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE POINTER ED-PTR.
AC453. UNSTR-RECORD INTO WA1 WA2 DELIMITER WA3 POINTER ED-PTR.
    IF WA1="BP" MOVE WA2 TO REL-PROD
      ELSE IF AC-IXL<5 ADD 1 TO AC-IXL MOVE WA1 TO AC-LCODE(AC-IXL) MOVE WA2 TO AC-LVAL(AC-IXL).
    IF NOT(WA3=ED-NL OR " ") GO AC453.
    IF ED-SKF IF REL-PROD="VB-BTF1034" MOVE "VB-BTF-1034" TO REL-PROD.
    IF ED-BEN MOVE AC-IXL TO ED-BXL MOVE AC-LIN TO ED-BLIN.
    PERFORM RDADJ-PNO PERFORM RD-PLANT PERFORM CHK-PLORD.

    INITIALIZE ED-LABINF AC-IXI AC-CUM AC-CUM-ATH AC-LF AC-DOCK AC-NOTE
      AC-IXF AC-FST AC-INFO.
AC47. READ EDI END PERFORM EDI-ERR GO AC8. PERFORM EL-CLR.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO AC-KFIN GO AC48.
    IF ED-RECORD(1:3)="LIN" AND ED-RECORD(4:1)=ED-SEP GO AC48.
    IF ED-RECORD(1:3)="NTE" AND ED-RECORD(4:1)=ED-SEP
      MOVE ED-RECORD(1:EDI-SZ - 1) TO AC-NOTE GO AC478.
    IF ED-RECORD(1:3)="ATH" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AC-AINF UNSTR-RECORD INTO ED-LINE WA1 ED-LINE ED-LINE COUNT ED-LTH
      IF WA1="PQ" PERFORM EL-RDVAL MOVE ED-VAL TO AC-CUM-ATH END-IF
      GO AC478.
    IF ED-RECORD(1:3)="SHP" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AC-AINF UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="02" PERFORM EL-RDVAL MOVE ED-VAL TO AC-CUM END-IF
      GO AC478.
    IF ED-RECORD(1:3)="PKG" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AC-AINF UNSTR-RECORD INTO ED-LINE WA1 WA2 WA3 WA4 ED-LINE
      IF WA1="X" AND WA2="67" AND WA3="AI" EVALUATE TRUE
        WHEN WA4="11Z" MOVE ED-LINE(1:8) TO ED-PKG11
        WHEN WA4="12Z" MOVE ED-LINE(1:8) TO ED-PKG12
        WHEN WA4="13Z" MOVE ED-LINE(1:25) TO ED-PKG13
        WHEN WA4="14Z" MOVE ED-LINE(1:20) TO ED-PKG14
        WHEN WA4="15Z" MOVE ED-LINE(1:20) TO ED-PKG15
        WHEN WA4="16Z" MOVE ED-LINE(1:24) TO ED-PKG16
        WHEN WA4="17Z" MOVE ED-LINE(1:10) TO ED-PKG17
        END-EVALUATE END-IF
      GO AC478.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF (WA1="LF" OR "DK") AND AC-IXI<16 ADD 1 TO AC-IXI
        MOVE ED-RECORD(1:EDI-SZ - 1) TO AC-IFLINE(AC-IXI) END-IF
      IF WA1="LF" MOVE WA2 TO AC-LF END-IF
      IF WA1="DK" MOVE WA2 TO AC-DOCK END-IF
      GO AC478.
    IF NOT(ED-RECORD(1:3)="FST" AND ED-RECORD(4:1)=ED-SEP) GO AC478.
    IF AC-IXF=30 GO AC478. ADD 1 TO AC-IXF.
    MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL IF ED-VAL=0 SUBTRACT 1 FROM AC-IXF GO AC478.
    MOVE ED-VAL TO AC-FQTY(AC-IXF).
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AC-FDATE(AC-IXF).
    UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH POINTER ED-PTR.
    IF WA1>" " MOVE WA1 TO AC-FQUAL(AC-IXF)
      PERFORM EL-RDVAL MOVE ED-VAL TO AC-FTIME(AC-IXF).
AC478. GO AC47.
AC48. IF NOT(AC-SCHEDULE="SH" OR "DL") PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AC-IXF
       IF IX1=1 ADD AC-CUM-ATH TO AC-FQTY(IX1)
         ELSE ADD AC-FQTY(IX1 - 1) TO AC-FQTY(IX1) END-IF END-PERFORM.
    MOVE 0 TO A-N1 PERFORM DAY-DELREC IF A-S1=1 GO AC78.

    MOVE 2 TO WS-PR MOVE REL-PROD TO FG144 MOVE REL-ORD TO FG145.
    IF REL-ORD=0 MOVE "***" TO FG146. MOVE 1 TO IX1 PR-IXP.
AC53. IF IX1>AC-IXF GO AC54. IF PR-IXP>5 PERFORM AC-LINE MOVE 1 TO PR-IXP.
    MOVE AC-FQTY(IX1) TO FG147(PR-IXP).
    MOVE AC-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG148(PR-IXP).
    ADD 1 TO IX1 PR-IXP GO AC53.
AC54. PERFORM AC-LINE.
    MOVE 2 TO WS-PR MOVE AC-NOTE TO FG154 INSPECT FG154 REPLACING ALL ED-SEP BY ":".
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AC-IXL
      MOVE AC-LCODE(IX1) TO FG155(IX1) MOVE ":" TO FG156(IX1)
      MOVE AC-LVAL(IX1) TO FG157(IX1) END-PERFORM.
    PERFORM AC-LINE MOVE 1 TO IX1 PR-IXP.
AC55. IF IX1>AC-IXI GO AC56. IF PR-IXP>3 PERFORM AC-LINE MOVE 1 TO PR-IXP.
    MOVE AC-IFLINE(IX1) TO FG152(PR-IXP) INSPECT FG152(PR-IXP) REPLACING ALL ED-SEP BY ":".
    ADD 1 TO IX1 PR-IXP GO AC55.
AC56. PERFORM AC-LINE.

* note 77
    IF ED-CHRY AND AC-SCHEDULE="SH"
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AC-IXF IF AC-FDATE(IX1)>=SYS-DATE
        COMPUTE AC-FQTY(IX1)=AC-FQTY(IX1) + AC-CUM-ATH - AC-CUM
        IF AC-FQTY(IX1)<0 MOVE 0 TO AC-FQTY(IX1) END-IF GO AC62 END-IF END-PERFORM.
AC62.

    MOVE 0 TO AC-DXNO.
    IF ED-BEN PERFORM DX-ADD MOVE DX-NO TO AC-DXNO
      MOVE ED-BEN-DATA TO DX-DATA WRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX.

    IF ED-SKF GO AC76.
    PERFORM INIT-DY.
    MOVE REL-PLANT TO DY-PLANT DY-KPLANT MOVE REL-PROD TO DY-PROD DY-KPROD.
    MOVE ED-TYPE TO DY-TYPE MOVE ED-SEP TO DY-SEP.
    MOVE SYS-DATE TO DY-DATE MOVE REL-ISA-KEY TO DY-ISA-KEY.
    MOVE AC-LIN TO DY-LIN MOVE AC-IXL TO DY-IXL.
    MOVE AC-INFO TO DY-INFO MOVE AC-IXI TO DY-IXI.
    MOVE AC-FST TO DY-FST MOVE AC-IXF TO DY-IXF.
    MOVE AC-BSS TO DY-BSS MOVE REL-ORD TO DY-ORD MOVE AC-SCHEDULE TO DY-SCHEDULE.
    MOVE AC-LF TO DY-LF MOVE AC-DOCK TO DY-DOCK MOVE ED-LABINF TO DY-LABINF.
    MOVE AC-DXNO TO DY-DXNO PERFORM DAY-ADDREC.
AC76.
AC78. IF AC-KFIN=0 GO AC45. GO AC35.
AC8. CLOSE EDI DELJITEX.
    MOVE 2 TO AC-STEP PERFORM AC-PAGE PERFORM PRINT-PLORD PERFORM CLOSE-SORT.
AC9. EXIT.

AC-AINF. IF AC-IXI<16 ADD 1 TO AC-IXI MOVE ED-RECORD(1:EDI-SZ - 1) TO AC-IFLINE(AC-IXI).
AC-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AC-PAGE.
AC-PAGE. IF AC-OP=1 MOVE 2 TO A-N1. IF AC-OP=2 MOVE 3 TO A-N1.
    IF AC-OP=4 MOVE 4 TO A-N1. PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " DAILY SHIP SCHEDULE (862) REPORT" DELIMITED SIZE INTO FF3.
    MOVE "(DAYREL FILE UPDATE)" TO FF4 PERFORM PR-PAGE.
    IF AC-STEP=1 MOVE
         "PRODUCT    ORDER   ERR" TO PREC PERFORM PR-LINE-3.
*         ........  ......   ...   ...,... ../../..   ...,... ../../.. (x5)
    IF AC-STEP=2 MOVE ED-HEAD1 TO PREC PERFORM PR-LINE-3.
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==MOVE ALL ":" TO ED-FIELD UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==UNSTR-FIELD== BY ==UNSTRING ED-FIELD DELIMITED ED-DEL==.
IP-DELJIT. PERFORM IP1 THRU IP9.
IP1. OPEN I-O DELJITEX ALLOWING ALL INPUT EDI PERFORM OPEN-SORT.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.
    MOVE LOW-VALUES TO IP-ATOTALS.
    MOVE 1 TO IP-STEP PERFORM IP-PAGE MOVE " " TO REL-OPLANT.
IP3. READ EDI END GO IP8. IF ED-RECORD(1:4) NOT="UNB+" GO IP3.
    UNSTR-RECORD INTO ED-A ED-A ED-FIELD UNSTR-FIELD INTO WA1.
    MOVE 0 TO IP-MI IP-KSHAN.
    IF WA1="654651652" MOVE 1 TO IP-KSHAN.
    IF WA1="160943056" SET IP-SAT TO TRUE.
    IF WA1="DPH" SET IP-DELP TO TRUE.
    IF WA1="XLP" SET IP-AMAX TO TRUE.
    IF ED-GMC SET IP-GMC TO TRUE.
    UNSTR-RECORD INTO ED-A ED-A ED-A ED-A ED-FIELD.
    MOVE 1 TO ED-PTR UNSTR-FIELD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO REL-IDATE.
    UNSTR-FIELD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO REL-ITIME.
IP33. READ EDI END PERFORM EDI-ERR GO IP8. IF ED-RECORD(1:4)="UNZ+" GO IP3.
    IF ED-RECORD(1:4) NOT="UNH+" GO IP33.
    UNSTR-RECORD INTO ED-A ED-LINE COUNT ED-LTH ED-FIELD.
    PERFORM EL-RDVAL MOVE ED-VAL TO REL-INUM.
    UNSTR-FIELD INTO WA1 IF WA1="DELJIT" GO IP4.
IP35. READ EDI END PERFORM EDI-ERR GO IP8. IF ED-RECORD(1:4)="UNT+" GO IP33.
    GO IP35.
IP4. PERFORM IP-LINE 2 TIMES.
    INITIALIZE IP-IXT IP-SCHEDULE IP-SCHEDNO IP-RELNO IP-FUNCTION IP-N-SI IP-N-ST
      IP-DOC-DATE IP-DOC-HDATE(1) IP-DOC-HDATE(2) ED-GMC-DATA.
IP43. READ EDI END PERFORM EDI-ERR GO IP8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" GO IP33. IF ED-RECORD(1:4)="SEQ+" GO IP44.
    IF ED-RECORD(1:4)="BGM+"
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-A ED-FIELD POINTER ED-PTR
      UNSTR-FIELD INTO ED-A ED-A ED-A IP-SCHEDULE
      UNSTR-RECORD INTO ED-FIELD IP-FUNCTION POINTER ED-PTR
      UNSTR-FIELD INTO IP-RELNO GO IP438.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF ED-DQUAL="137" MOVE D-DATE TO IP-DOC-DATE END-IF
      IF ED-DQUAL="158" OR IP-KSHAN=1 AND ED-DQUAL="234"
        MOVE D-DATE TO IP-DOC-HDATE(1) END-IF
      IF ED-DQUAL="159" OR IP-KSHAN=1 AND ED-DQUAL="117"
        MOVE D-DATE TO IP-DOC-HDATE(2) END-IF
      GO IP438.
    IF ED-RECORD(1:4)="FTX+"
      UNSTR-RECORD INTO ED-A ED-A ED-A ED-A WA1
      IF IP-IXT<5 ADD 1 TO IP-IXT MOVE WA1 TO IP-TEXT(IP-IXT) END-IF
      GO IP438.
    IF ED-RECORD(1:4)="RFF+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO WA1 WA2
      IF WA1="AAN" MOVE WA2 TO IP-SCHEDNO END-IF
      IF IP-DELP
        IF WA1="AAN" AND IP-SCHEDULE="SH" OR WA1="ON" AND IP-SCHEDULE="KB"
          MOVE WA2 TO ED-DSCHEDNO END-IF END-IF
      GO IP438.
    IF ED-RECORD(1:4)="NAD+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="SI" MOVE WA2 TO IP-N-SI END-IF
      IF WA1="ST" MOVE WA2 TO IP-N-ST END-IF
      IF WA1="OB" AND IP-GMC MOVE ED-RECORD(8:EDI-SZ - 7) TO ED-GNAD END-IF
* note 211
      GO IP438.
IP438. GO IP43.
IP44. IF IP-N-ST>" " MOVE IP-N-ST TO REL-PLANT ELSE MOVE IP-N-SI TO REL-PLANT.
    IF REL-PLANT NOT=REL-OPLANT
      IF REL-OPLANT>" " PERFORM IP-PAGE END-IF MOVE REL-PLANT TO REL-OPLANT.

    MOVE "PLANT:" TO FG366 MOVE REL-PLANT TO FG367 MOVE "DATES:" TO FG368.
    MOVE IP-DOC-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG369.
    MOVE IP-DOC-HDATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG370 MOVE "-" TO FG371.
    MOVE IP-DOC-HDATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG372.
    MOVE "SCHED:" TO FG373 MOVE IP-SCHEDULE TO FG373A.
    MOVE "SCHED NO.:" TO FG374 MOVE IP-SCHEDNO TO FG374A.
    MOVE "REL:" TO FG375 MOVE IP-RELNO TO FG375A.
    MOVE "FUNC:" TO FG376 MOVE IP-FUNCTION TO FG376A.
    PERFORM IP-LINE.
    IF IP-IXT>0 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IP-IXT
      MOVE IP-TEXT(IX1) TO FG378 PERFORM IP-LINE END-PERFORM.

* SEQ records
IP51. INITIALIZE ED-LABINF IP-IXI IP-INFO
        ED-SAT-DATA ED-DELP-DATA.
IP53. READ EDI END PERFORM EDI-ERR GO IP8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="LIN+" GO IP54.
    IF ED-RECORD(1:4)="PCI+"
      PERFORM IP-AINF MOVE 1 TO ED-PTR
      UNSTR-RECORD INTO ED-A ED-A ED-FIELD POINTER ED-PTR UNSTR-FIELD INTO WA1
      UNSTR-RECORD INTO ED-A ED-FIELD POINTER ED-PTR UNSTR-FIELD INTO WA2
      EVALUATE TRUE
        WHEN WA2="11Z" MOVE WA1(1:8) TO ED-PKG11
          IF IP-DELP MOVE WA1(1:8) TO ED-DSTOR END-IF
        WHEN WA2="12Z" MOVE WA1(1:8) TO ED-PKG12
        WHEN WA2="13Z" MOVE WA1(1:25) TO ED-PKG13
        WHEN WA2="14Z" MOVE WA1(1:20) TO ED-PKG14
        WHEN WA2="15Z" MOVE WA1(1:20) TO ED-PKG15
        WHEN WA2="16Z" MOVE WA1(1:24) TO ED-PKG16
        WHEN WA2="17Z" MOVE WA1(1:10) TO ED-PKG17
        END-EVALUATE
      GO IP538.

    IF NOT(ED-RECORD(1:4)="GIN+" AND IP-SAT) GO IP5348.
    PERFORM IP-AINF UNSTR-RECORD INTO ED-A WA1 ED-FIELD.
    IF WA1 NOT="AL" GO IP5346. INITIALIZE ED-SAT-DATA.
    MOVE 1 TO ED-PTR UNSTR-FIELD INTO WA2 COUNT ED-LTH POINTER ED-PTR.
    MOVE WA2(1:1) TO ED-SKAN-A.
    MOVE WA2(2:) TO ED-LINE SUBTRACT 1 FROM ED-LTH MOVE ED-LTH TO ED-SKAN-ND.
    PERFORM EL-RDVAL MOVE ED-VAL TO ED-SKAN-N(1).
    UNSTR-FIELD INTO WA2 COUNT ED-LTH POINTER ED-PTR.
    MOVE WA2(2:) TO ED-LINE SUBTRACT 1 FROM ED-LTH.
    PERFORM EL-RDVAL MOVE ED-VAL TO ED-SKAN-N(2).
IP5346. GO IP538.
IP5348.

    IF NOT(ED-RECORD(1:4)="GIR+" AND IP-DELP) GO IP5358.
    PERFORM IP-AINF MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-A WA1 POINTER ED-PTR.
    IF NOT(WA1="3" AND IP-SCHEDULE="KB") GO IP5356.
IP5353. UNSTR-RECORD INTO ED-FIELD DELIMITER WA3 POINTER ED-PTR.
    MOVE " " TO WA1 WA2 UNSTR-FIELD INTO WA1 WA2.
    IF WA2="AL" AND ED-DKNUM<30 ADD 1 TO ED-DKNUM MOVE WA1 TO ED-DKVAL(ED-DKNUM).
    IF WA3=ED-SEP GO IP5353.
IP5356. GO IP538.
IP5358.

IP538. GO IP53.

* LIN records
IP54. MOVE 0 TO IP-FIN MOVE IP-IXI TO IP-IXI-SEQ.
IP55. UNSTR-RECORD INTO ED-A ED-A ED-A ED-FIELD UNSTR-FIELD INTO REL-PROD.
    PERFORM RDADJ-PNO PERFORM RD-PLANT PERFORM CHK-PLORD.
    INITIALIZE IP-IXF IP-FST IP-SHD-CUM IP-SHP-CUM IP-QUAL IP-MODYR
      IP-LF IP-DOCK IP-KAN IP-ORD IP-PKG-QTY IP-PKG-UNIT
      IP-SHD-DATE(1) IP-SHD-DATE(2) IP-SHP-DATE(1) IP-SHP-DATE(2).
    MOVE IP-IXI-SEQ TO IP-IXI COMPUTE IX1=IP-IXI + 1.
    PERFORM UNTIL IX1>16 MOVE " " TO IP-IFLINE(IX1) ADD 1 TO IX1 END-PERFORM.

IP57. READ EDI END PERFORM EDI-ERR GO IP8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" MOVE 2 TO IP-FIN GO IP58.
    IF ED-RECORD(1:4)="SEQ+" MOVE 1 TO IP-FIN GO IP58.
    IF ED-RECORD(1:4)="LIN+" GO IP58.

    IF ED-RECORD(1:4)="PIA+"
      UNSTR-RECORD INTO ED-A ED-A ED-FIELD UNSTR-FIELD INTO WA1 WA2
      IF WA2="RY" MOVE WA1 TO A-A1 PERFORM STR-LTH MOVE WA1(A-N1:1) TO IP-MODYR END-IF
      GO IP578.
    IF ED-RECORD(1:4)="LOC+"
      PERFORM IP-AINF UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="11" MOVE WA2 TO IP-DOCK END-IF
      IF WA1="159" MOVE WA2 TO IP-LF END-IF
      GO IP578.
    IF ED-RECORD(1:4)="CTA+" PERFORM IP-AINF GO IP578.
    IF ED-RECORD(1:4)="COM+" PERFORM IP-AINF GO IP578.
    IF ED-RECORD(1:4)="GIR+" AND IP-AMAX
      PERFORM IP-AINF MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-A A-A1 POINTER ED-PTR
      IF A-A1="1" PERFORM TEST AFTER UNTIL A-A3 NOT=ED-SEP
        UNSTR-RECORD INTO ED-FIELD DELIMITER A-A3 POINTER ED-PTR
        MOVE " " TO A-A1 A-A2 UNSTR-FIELD INTO A-A1 A-A2
        IF A-A2="AL" MOVE A-A1 TO IP-KAN END-IF
        IF A-A2="AM" MOVE A-A1 TO IP-ORD END-IF
        END-PERFORM END-IF
      GO IP578.
    IF ED-RECORD(1:4)="QTY+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO IP-QUAL ED-LINE COUNT ED-LTH WA1
      PERFORM EL-RDVAL
      IF IP-QUAL="79" MOVE ED-VAL TO IP-SHD-CUM GO IP578 END-IF
      IF IP-QUAL="3" MOVE ED-VAL TO IP-SHP-CUM GO IP578 END-IF
      IF IP-QUAL="52"
        MOVE ED-VAL TO IP-PKG-QTY MOVE WA1 TO IP-PKG-UNIT GO IP578 END-IF
      MOVE "1" TO ED-QQUAL IF IP-AMAX MOVE "12" TO ED-QQUAL END-IF
      IF IP-QUAL=ED-QQUAL AND IP-IXF<30
        IF ED-VAL>0 ADD 1 TO IP-IXF MOVE ED-VAL TO IP-FQTY(IP-IXF)
          IF IP-PKG-UNIT=" " MOVE WA1 TO IP-PKG-UNIT END-IF
         ELSE MOVE " " TO IP-QUAL END-IF
        GO IP578 END-IF
      GO IP578.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF IP-QUAL="79"
        IF ED-DQUAL="51" MOVE D-DATE TO IP-SHD-DATE(1) END-IF
        IF ED-DQUAL="52" MOVE D-DATE TO IP-SHD-DATE(2) END-IF GO IP578 END-IF
      IF IP-QUAL="3"
        IF ED-DQUAL="51" MOVE D-DATE TO IP-SHP-DATE(1) END-IF
        IF ED-DQUAL="11" MOVE D-DATE TO IP-SHP-DATE(2) END-IF GO IP578 END-IF
      MOVE "1" TO ED-QQUAL IF IP-AMAX MOVE "12" TO ED-QQUAL END-IF
      IF IP-QUAL=ED-QQUAL AND ED-DQUAL="10" AND (IP-IXF>=1 AND<=30)
        MOVE D-DATE TO IP-FDATE(IP-IXF) MOVE D-TIME TO IP-FTIME(IP-IXF)
        MOVE " " TO IP-FQUAL(IP-IXF) GO IP578 END-IF
      GO IP578.
IP578. GO IP57.
IP58. IF IP-SCHEDULE NOT="SH" PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IP-IXF
       IF IX1=1 ADD IP-SHD-CUM TO IP-FQTY(IX1)
         ELSE ADD IP-FQTY(IX1 - 1) TO IP-FQTY(IX1) END-IF END-PERFORM.
    IF IP-KSHAN=1 PERFORM IP-IXF TIMES
      IF IP-FDATE(IP-IXF)=0 MOVE IP-DOC-HDATE(1) TO IP-FDATE(IP-IXF) END-IF END-PERFORM.

    MOVE 0 TO A-N1.
    IF IP-AMAX MOVE 1 TO A-N1. IF IP-SAT OR IP-DELP MOVE 30 TO A-N1.
    IF IP-OP NOT=6 PERFORM DAY-DELREC IF A-S1=1 GO IP78.

* note 130
    IF NOT IP-AMAX GO IP62.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IP-IXF
      IF IP-FDATE(IX1)<SYS-DATE MOVE 1 TO IX2
        ELSE IF IP-FDATE(IX1)=SYS-DATE MOVE 2 TO IX2 ELSE MOVE 3 TO IX2 END-IF END-IF
      ADD 1 TO IP-ATOT(IX2) END-PERFORM.
    IF IP-OP=6 GO IP62.

    IF IP-KAN=" " GO IP78. MOVE 1 TO IX1.
IP613. IF IX1>IP-IXF GO IP618. IF IP-FDATE(IX1)>=SYS-DATE GO IP614.
    MOVE SYS-DATE TO D-DATE PERFORM D-PREV-DAY IF IP-FDATE(IX1)<D-DATE GO IP616.
    PERFORM RDR-INFO MOVE IF-DXNO TO DX-NO.
IP6133. READ DELJITEX REGARDLESS INVALID GO IP6136.
    MOVE DX-TYPE TO ED-TYPE IF NOT ED-AMAX GO IP6136. MOVE DX-DATA TO ED-AMAX-DATA.
    IF ED-APLANT NOT=REL-PLANT GO IP6136. IF ED-AFDATE<D-DATE GO IP6138.
    PERFORM VARYING DX-IXP FROM 1 BY 1 UNTIL DX-IXP>30 OR ED-AKAN(DX-IXP)=" "
      IF IP-KAN=ED-AKAN(DX-IXP) GO IP616 END-IF END-PERFORM.
IP6136. SUBTRACT 1 FROM DX-NO IF DX-NO>0 GO IP6133.
IP6138. MOVE SYS-DATE TO IP-FDATE(IX1).
IP614. ADD 1 TO IX1 GO IP613.
IP616. PERFORM VARYING IX2 FROM IX1 BY 1 UNTIL IX2>IP-IXF - 1
        MOVE IP-FSTX(IX2 + 1) TO IP-FSTX(IX2) END-PERFORM.
    INITIALIZE IP-FSTX(IP-IXF) SUBTRACT 1 FROM IP-IXF GO IP613.
IP618. IF IP-IXF=0 GO IP78.

IP62. MOVE 2 TO WS-PR MOVE REL-PROD TO FG382 MOVE REL-ORD TO FG383.
    MOVE IP-MODYR TO FG384 MOVE IP-PKG-QTY TO FG385 MOVE IP-PKG-UNIT TO FG386.
    MOVE "SHED CUM." TO FG389(1) MOVE IP-SHD-CUM TO FG390(1).
    MOVE IP-SHD-DATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG391(1) MOVE "-" TO FG392(1).
    MOVE IP-SHD-DATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG393(1).
    MOVE "SHIP CUM." TO FG389(2) MOVE IP-SHP-CUM TO FG390(2).
    MOVE IP-SHP-DATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG391(2) MOVE "-" TO FG392(2).
    MOVE IP-SHP-DATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG393(2).
    PERFORM IP-LINE.
    IF REL-ORD=0 MOVE "*** ERROR - NO SALES ORDER FOR THIS PLANT-PRODUCT ***"
      TO PREC PERFORM IP-LINE.
    PERFORM IP-LINE MOVE 1 TO IX1 PR-IXP.
IP63. IF IX1>IP-IXF GO IP64. IF PR-IXP>4 PERFORM IP-LINE MOVE 1 TO PR-IXP.
    MOVE IP-FQTY(IX1) TO FG379(PR-IXP).
    MOVE IP-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG380(PR-IXP).
    IF IP-FTIME(IX1)=0 MOVE "*" TO FG380A(PR-IXP)
      ELSE MOVE IP-FTIME(IX1) TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO FG380A(PR-IXP).
    ADD 1 TO IX1 PR-IXP GO IP63.
IP64. PERFORM IP-LINE 2 TIMES MOVE 1 TO IX1 PR-IXP.
    PERFORM UNTIL IX1>IP-IXI IF PR-IXP>3 PERFORM IP-LINE MOVE 1 TO PR-IXP END-IF
      MOVE IP-IFLINE(IX1) TO FG381(PR-IXP) ADD 1 TO IX1 PR-IXP END-PERFORM.
    PERFORM IP-LINE.
    IF IP-OP=6 GO IP78.

    IF NOT IP-AMAX GO IP76.
* note 131
    PERFORM INIT-DY.
    MOVE REL-PLANT TO DY-PLANT DY-KPLANT MOVE REL-PROD TO DY-PROD DY-KPROD.
    READ DAYREL REGARDLESS INVALID GO IP74.

    IF IP-FDATE(1) NOT=DY-FDATE(1) GO IP758.
    MOVE DY-DXNO TO A-N1 PERFORM DX-RD-AMAX.
    PERFORM VARYING DX-IXP FROM 1 BY 1 UNTIL DX-IXP>30 OR ED-AKAN(DX-IXP)=" "
      IF IP-KAN=ED-AKAN(DX-IXP) GO IP722 END-IF END-PERFORM.
    IF DX-IXP<=30 MOVE IP-KAN TO ED-AKAN(DX-IXP) MOVE IP-ORD TO ED-AORD(DX-IXP).
    MOVE ED-AMAX-DATA TO DX-DATA REWRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX.
IP722. MOVE DY-PROD TO A-A1 PERFORM PROD-GEN.
    PERFORM DX-PSET-CNUM PERFORM DX-SET-PULLS.
    COMPUTE IP-MAXQTY=P-QTY-PACK * DX-CNUM * DX-PULLS.

    MOVE 1 TO IX1.
IP723. PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>DY-IXF
        IF IP-FDATE(IX1)=DY-FDATE(IX2) ADD IP-FQTY(IX1) TO DY-FQTY(IX2)
          IF DY-FQTY(IX2)>IP-MAXQTY MOVE IP-MAXQTY TO DY-FQTY(IX2) END-IF
          GO IP724 END-IF END-PERFORM.
    IF DY-IXF<30 ADD 1 TO DY-IXF
      MOVE IP-FQTY(IX1) TO DY-FQTY(DY-IXF) MOVE IP-FDATE(IX1) TO DY-FDATE(DY-IXF)
      MOVE IP-FQUAL(IX1) TO DY-FQUAL(DY-IXF) MOVE IP-FTIME(IX1) TO DY-FTIME(DY-IXF).
IP724. ADD 1 TO IX1 IF IX1<=IP-IXF GO IP723.
    REWRITE DY-RECORD ALLOWING NO UNLOCK DAYREL.
    GO IP758.

IP74. SET ED-AMAX TO TRUE.
    PERFORM DX-ADD MOVE DX-NO TO IP-DXNO.
    INITIALIZE ED-AMAX-DATA MOVE IP-DOCK TO ED-ADOCK MOVE IP-LF TO ED-AGROUP.
    MOVE REL-PLANT TO ED-APLANT MOVE REL-PROD TO ED-APROD MOVE IP-FDATE(1) TO ED-AFDATE.
    MOVE IP-KAN TO ED-AKAN(1) MOVE IP-ORD TO ED-AORD(1).
    MOVE ED-AMAX-DATA TO DX-DATA MOVE ED-TYPE TO DX-TYPE.
    WRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX.

    MOVE ED-TYPE TO DY-TYPE MOVE ED-SEP TO DY-SEP.
    MOVE SYS-DATE TO DY-DATE MOVE REL-ISA-KEY TO DY-ISA-KEY.
    MOVE REL-ORD TO DY-ORD MOVE IP-SCHEDULE TO DY-SCHEDULE.
    MOVE IP-INFO TO DY-INFO MOVE IP-IXI TO DY-IXI.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IP-IXF
      MOVE IP-FQTY(IX1) TO DY-FQTY(IX1) MOVE IP-FDATE(IX1) TO DY-FDATE(IX1)
      MOVE IP-FQUAL(IX1) TO DY-FQUAL(IX1) MOVE IP-FTIME(IX1) TO DY-FTIME(IX1)
      ADD 1 TO DY-IXF END-PERFORM.
    MOVE IP-DXNO TO DY-DXNO PERFORM DAY-ADDREC.
IP758. GO IP78.

* non-AmAx
IP76. MOVE 0 TO IP-DXNO.
    IF NOT(IP-DELP OR IP-SAT OR (IP-GMC AND ED-GNAD>" ")) GO IP764.
    PERFORM DX-ADD MOVE DX-NO TO IP-DXNO.
    IF IP-DELP MOVE ED-DELP-DATA TO DX-DATA.
    IF IP-SAT MOVE ED-SAT-DATA TO DX-DATA.
    IF IP-GMC MOVE ED-GMC-DATA TO DX-DATA.
    WRITE DX-RECORD ALLOWING NO UNLOCK DELJITEX.
IP764. PERFORM INIT-DY.
    MOVE REL-PLANT TO DY-PLANT DY-KPLANT MOVE REL-PROD TO DY-PROD DY-KPROD.
    MOVE ED-TYPE TO DY-TYPE MOVE ED-SEP TO DY-SEP.
    MOVE SYS-DATE TO DY-DATE MOVE REL-ISA-KEY TO DY-ISA-KEY.
    MOVE IP-INFO TO DY-INFO MOVE IP-IXI TO DY-IXI.
    MOVE REL-ORD TO DY-ORD MOVE IP-SCHEDULE TO DY-SCHEDULE.
    MOVE IP-LF TO DY-LF MOVE IP-DOCK TO DY-DOCK.
    IF ED-PKG11=" " MOVE IP-LF TO ED-PKG11.
    IF ED-PKG12=" " MOVE IP-DOCK TO ED-PKG12.
    MOVE ED-LABINF TO DY-LABINF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IP-IXF
      MOVE IP-FQTY(IX1) TO DY-FQTY(IX1) MOVE IP-FDATE(IX1) TO DY-FDATE(IX1)
      MOVE IP-FQUAL(IX1) TO DY-FQUAL(IX1) MOVE IP-FTIME(IX1) TO DY-FTIME(IX1)
      ADD 1 TO DY-IXF END-PERFORM.
    MOVE IP-DXNO TO DY-DXNO PERFORM DAY-ADDREC.

IP78. IF IP-FIN=0 GO IP55. IF IP-FIN=1 GO IP51. GO IP33.
IP8. COMPUTE WN1=IP-ATOT(1) + IP-ATOT(2) + IP-ATOT(3) IF WN1=0 GO IP82.
    MOVE 3 TO WS-PR MOVE "AMERICAN AXLE STATISTICS (PAST, TODAY, FUTURE):" TO FD468.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      COMPUTE FD469(IX1) ROUNDED=IP-ATOT(IX1) * 100 / WN1 MOVE "%" TO FD470(IX1) END-PERFORM.
    PERFORM PR-LINE.
IP82. CLOSE EDI DELJITEX.
    MOVE 2 TO IP-STEP PERFORM IP-PAGE PERFORM PRINT-PLORD PERFORM CLOSE-SORT.
IP9. EXIT.

IP-AINF. IF IP-IXI<16 ADD 1 TO IP-IXI MOVE ED-RECORD(1:EDI-SZ - 1) TO IP-IFLINE(IP-IXI).
IP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM IP-PAGE.
IP-PAGE. IF IP-OP=3 MOVE 3 TO A-N1. IF IP-OP=5 OR 6 MOVE 4 TO A-N1. PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " EDIFACT DELJIT REPORT" DELIMITED SIZE INTO FF3.
    IF IP-OP=6 MOVE "(REPORT ONLY)" TO FF4
      ELSE MOVE "(DAYREL FILE UPDATE)" TO FF4.
    PERFORM PR-PAGE.
    IF IP-STEP=1 MOVE
         "PRODUCT     ORDER  YR  PACKING" TO PREC PERFORM PR-LINE-3.
*         ........   ......  .  ..,... ...                  ......... ..,...,... ../../..-../../..      ......... ..,...,... ../../..-../../..
*                              ...,... ../../.. ..:..     ...,... ../../.. ..:.. (x4)
*         PLANT: ..........   DATES: ../../..  ../../..-../../..   SCHED: .....  SCHED NO.: .....   REL: ....................  FUNC: ..
    IF IP-STEP=2 MOVE ED-HEAD1 TO PREC PERFORM PR-LINE-3.
    REPLACE OFF.

* E-6 PROCESS MATERIAL RELEASE 830, DELFOR
UB1. PERFORM RD309 PERFORM WRT.
    ACCEPT UB-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UB-OP=99 GO MN9. IF UB-OP=0 OR>5 GO UB1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    EVALUATE TRUE
      WHEN UB-OP=1 SET ED-CHRY TO TRUE STRING "CHREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS CHRYSLER MATERIAL RELEASE (830) FILE " TO WA1
      WHEN UB-OP=2 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS GM MATERIAL RELEASE (830) FILE " TO WA1
      WHEN UB-OP=3 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS ADVANTIS MATERIAL RELEASE (830) FILE " TO WA1
      WHEN UB-OP=4 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS GM EDIFACT DELIVERY FORECAST (DELFOR) FILE " TO WA1
      WHEN UB-OP=5 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
        MOVE " PROCESS ADVANTIS EDIFACT DELIVERY FORECAST (DELFOR) FILE " TO WA1
      END-EVALUATE.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9. CLOSE EDI.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    IF UB-OP=4 OR 5 MOVE UB-OP TO IQ-OP PERFORM IQ-DELFOR
      ELSE MOVE UB-OP TO AB-OP PERFORM AB-E830
       IF UB-OP=3 PERFORM CLOSE-PR PERFORM EXTEND-PR
         MOVE UB-OP TO AK-OP PERFORM AK-E850 PERFORM BK-E855.
    PERFORM CLOSE-PR.
UB9. GO MN9.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
AB-E830. PERFORM AB1 THRU AB9.
AB1. OPEN INPUT EDI PERFORM OPEN-SORT MOVE 1 TO AB-STEP PERFORM AB-PAGE.
AB3. READ EDI END GO AB8.
    IF ED-RECORD(1:3) NOT="ISA" GO AB3. PERFORM EL-GET-SEP.
    MOVE ED-RECORD(36:15) TO ED-SENDER-ID.
* note 240.1
    IF AB-OP=3 EVALUATE TRUE
      WHEN ED-SENDER-ID="252371174" SET ED-AOS TO TRUE
      WHEN ED-SENDER-ID="201479482" SET ED-TRW TO TRUE
      WHEN ED-SENDER-ID="UTA01" SET ED-UTA TO TRUE
      WHEN ED-SENDER-ID(1:9)="085761492" SET ED-FLEX TO TRUE
      WHEN ED-SENDER-ID="603992546" SET ED-SKF TO TRUE
      WHEN ED-SENDER-ID="195204458" SET ED-RBW TO TRUE
      WHEN ED-SENDER-ID(1:10)="5192843330" OR "5196745413" SET ED-KSR TO TRUE
      WHEN ED-SENDER-ID(1:9)="249780669" SET ED-FAB TO TRUE
      WHEN ED-SENDER-ID="006403273" SET ED-GRAH TO TRUE
      WHEN ED-SENDER-ID="131906851" SET ED-MGM TO TRUE
      WHEN ED-SENDER-ID="000160077" SET ED-WOOD TO TRUE
      WHEN ED-SENDER-ID="GI15043" SET ED-INM TO TRUE
      WHEN ED-SENDER-ID="005470885" SET ED-DANA TO TRUE
      WHEN ED-SENDER-ID="200198765" SET ED-MOD TO TRUE
      WHEN ED-SENDER-ID="BENTUSA" SET ED-BEN TO TRUE
      WHEN ED-SENDER-ID="244247250" SET ED-VEN TO TRUE
      WHEN OTHER CONTINUE.
    MOVE 0 TO AB-KDY.
    IF ED-AOS OR ED-TRW OR ED-UTA OR ED-SKF OR ED-WOOD OR ED-INM OR ED-DANA OR ED-VEN
      MOVE 1 TO AB-KDY.
* note 239.1

    MOVE ED-RECORD(71:6) TO REL-ISA-KEY(1:6).
    IF REL-IDATE NUMERIC MOVE REL-IDATE TO D-DT PERFORM D-YN MOVE D-DATE TO REL-IDATE.
    MOVE ED-RECORD(78:4) TO REL-ISA-KEY(7:4).
    MOVE ED-RECORD(91:9) TO REL-ISA-KEY(11:9).
AB33. READ EDI END PERFORM EDI-ERR GO AB8.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AB3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AB33.
AB35. READ EDI END PERFORM EDI-ERR GO AB8.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AB33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AB35.
    IF ED-RECORD(4:3)="830" GO AB4.
AB37. READ EDI END PERFORM EDI-ERR GO AB8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AB35. GO AB37.

AB4. PERFORM AB-LINE 2 TIMES.
    MOVE SYS-DATE TO REL-RDATE ACCEPT REL-RTIME FROM TIME.
AB43. READ EDI END PERFORM EDI-ERR GO AB8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AB35.
    IF ED-RECORD(1:3)="LIN" AND ED-RECORD(4:1)=ED-SEP GO AB44.
    IF ED-RECORD(1:3)="BFR" AND ED-RECORD(4:1)=ED-SEP
      MOVE " " TO AB-SOURCE REL-PLANT AB-B-ST
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE AB-BFR-TYPE ED-LINE
        AB-BFR-NUM AB-BFR-SCHED ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AB-BFR-FDATE
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AB-BFR-TDATE
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AB-BFR-DATE
      GO AB438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE ED-LINE WA2
      IF WA1="MI" MOVE WA2 TO AB-SOURCE END-IF
      IF WA1="ST" MOVE WA2 TO AB-B-ST END-IF
      GO AB438.
    IF ED-RECORD(1:3)="NTE" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE PREC PERFORM AB-LINE GO AB438.
AB438. GO AB43.
AB44. MOVE AB-SOURCE TO FG134 MOVE AB-BFR-NUM TO FG134A MOVE AB-BFR-TYPE TO FG134B.
    MOVE AB-BFR-SCHED TO FG135.
    MOVE AB-BFR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG136.
    MOVE AB-BFR-FDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG136A.
    MOVE AB-BFR-TDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG136B PERFORM AB-LINE.

* LIN records
    MOVE 0 TO AB-KFIN.
AB45. MOVE " " TO REL-PROD AB-CUSORD AB-LIN MOVE 0 TO AB-IXL.
    MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE POINTER ED-PTR.
AB453. UNSTR-RECORD INTO WA1 WA2 DELIMITER WA3 POINTER ED-PTR.
    IF WA1="BP" MOVE WA2 TO REL-PROD
      IF ED-UTA MOVE 0 TO IX1 INSPECT WA2 TALLYING IX1 FOR LEADING " "
        MOVE WA2(IX1 + 1:) TO REL-PROD END-IF
     ELSE
      IF WA1="PO" MOVE WA2 TO AB-CUSORD END-IF
      IF AB-IXL<5 ADD 1 TO AB-IXL
        MOVE WA1 TO AB-LCODE(AB-IXL) MOVE WA2 TO AB-LVAL(AB-IXL).
    IF NOT(WA3=ED-NL OR " ") GO AB453.
    IF ED-TRW AND AB-B-ST="201479482"
      MOVE REL-PROD TO WA1 MOVE "10-" TO REL-PROD MOVE WA1 TO REL-PROD(4:).
    IF ED-UTA MOVE REL-PROD TO A-A1 PERFORM EXTEND-PNO MOVE A-A1 TO REL-PROD.
    IF ED-SKF IF REL-PROD="VB-BTF1034" MOVE "VB-BTF-1034" TO REL-PROD.
    IF ED-KSR MOVE REL-PROD TO WA1 MOVE "0" TO REL-PROD MOVE WA1 TO REL-PROD(2:).
    IF ED-FAB
      IF REL-PROD="M10-1.5X73-H" MOVE "M10-1.5X73" TO REL-PROD END-IF
      IF REL-PROD="N601317-M10X" MOVE "N601317-M1" TO REL-PROD END-IF
      IF REL-PROD="S6143-3/8X1" MOVE "S6143-S100" TO REL-PROD END-IF
      END-IF.
    IF ED-GRAH
      IF REL-PROD="X02160C-BOL" MOVE "2160" TO REL-PROD END-IF
      IF REL-PROD="X02166A-BOL" MOVE "2166" TO REL-PROD END-IF
      IF REL-PROD="2300/2301-BO" MOVE "2300/2301" TO REL-PROD END-IF
      END-IF.

    INITIALIZE REL-PLANT AB-IXI AB-IXF AB-FST AB-L-ST AB-INFO AB-DOCK AB-ZONE AB-STAT.
    IF ED-UTA MOVE 0 TO AB-CUM.
AB47. READ EDI END PERFORM EDI-ERR GO AB8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO AB-KFIN GO AB48.
    IF ED-RECORD(1:3)="LIN" AND ED-RECORD(4:1)=ED-SEP GO AB48.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE ED-LINE WA2
      IF WA1="ST" MOVE WA2 TO AB-L-ST END-IF
      GO AB478.
    IF ED-RECORD(1:3)="SHP" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AB-AINF
      IF ED-UTA UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
        IF WA1="02" PERFORM EL-RDVAL MOVE ED-VAL TO AB-CUM END-IF END-IF
      GO AB478.
    IF ED-RECORD(1:3)="ATH" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AB-AINF GO AB478.
    IF ED-RECORD(1:3)="PER" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AB-AINF GO AB478.
    IF ED-RECORD(1:3)="SDP" AND ED-RECORD(4:1)=ED-SEP
      PERFORM AB-AINF GO AB478.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="DK" MOVE WA2 TO AB-DOCK END-IF
      IF WA1="RL" MOVE WA2 TO AB-ZONE END-IF
      GO AB478.
    IF ED-RECORD(1:3)="PRS" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE AB-STAT GO AB478.
    IF NOT(ED-RECORD(1:3)="FST" AND ED-RECORD(4:1)=ED-SEP) GO AB478.
    IF AB-IXF=30 GO AB478. ADD 1 TO AB-IXF.
    MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO AB-FQTY(AB-IXF).
    UNSTR-RECORD INTO ED-LINE AB-FPERIOD(AB-IXF) ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AB-FDATE(AB-IXF).
AB478. GO AB47.
AB48. IF ED-UTA PERFORM VARYING IX1 FROM AB-IXF BY -1 UNTIL IX1=1
        SUBTRACT AB-FQTY(IX1 - 1) FROM AB-FQTY(IX1)
        IF AB-FQTY(IX1)<0 MOVE 0 TO AB-FQTY(IX1) END-IF END-PERFORM
       SUBTRACT AB-CUM FROM AB-FQTY(1) IF AB-FQTY(1)<0 MOVE 0 TO AB-FQTY(1).
    MOVE AB-B-ST TO REL-PLANT IF AB-L-ST>" " MOVE AB-L-ST TO REL-PLANT.
    IF ED-SKF MOVE "07252" TO REL-PLANT.
    IF ED-GRAH MOVE "06708" TO REL-PLANT.
    PERFORM RDADJ-PNO PERFORM RD-PLANT PERFORM CHK-PLORD.
* note 87.3
    IF NOT ED-KSR GO AB486. MOVE 0 TO AB-KAS.
    MOVE REL-PLANT TO MT-PLANT MOVE REL-PROD TO MT-PROD MOVE 0 TO MT-SEQ.
    READ MATREL REGARDLESS INVALID GO AB486.
    IF MT-RUN-KEY=REL-RUN-KEY MOVE 1 TO AB-KAS GO AB488.
AB486. PERFORM MAT-DELREC IF A-S1=1 GO AB78.
AB488. IF AB-KDY=1 MOVE 0 TO A-N1 PERFORM DAY-DELREC.

    MOVE 2 TO WS-PR MOVE REL-PROD TO FG137 MOVE REL-PLANT TO FG137A.
    MOVE REL-ORD TO FG137B IF REL-ORD=0 MOVE "***" TO FG137C.
    MOVE AB-DOCK TO FG138 MOVE AB-ZONE TO FG138A MOVE AB-STAT TO FG139.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AB-IXL
      MOVE AB-LCODE(IX1) TO FG140(IX1) MOVE ":" TO FG140A(IX1)
      MOVE AB-LVAL(IX1) TO FG140B(IX1) END-PERFORM.
    PERFORM AB-LINE MOVE 1 TO IX1 PR-IXP.
AB53. IF IX1>AB-IXF GO AB54. IF PR-IXP>6 PERFORM AB-LINE MOVE 1 TO PR-IXP.
    MOVE AB-FQTY(IX1) TO FG141(PR-IXP).
    MOVE AB-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG142(PR-IXP).
    IF AB-FPERIOD(IX1) NOT="W" MOVE AB-FPERIOD(IX1) TO FG143(PR-IXP).
    ADD 1 TO IX1 PR-IXP GO AB53.
AB54. PERFORM AB-LINE MOVE 1 TO IX1 PR-IXP.
AB55. IF IX1>AB-IXI GO AB56. IF PR-IXP>3 PERFORM PR-LINE MOVE 1 TO PR-IXP.
    MOVE AB-IFLINE(IX1) TO FG153(PR-IXP) INSPECT FG153(PR-IXP) REPLACING ALL ED-SEP BY ":".
    ADD 1 TO IX1 PR-IXP GO AB55.
AB56. PERFORM AB-LINE.

    IF NOT(ED-KSR AND AB-KAS=1) GO AB72.
    MOVE REL-PLANT TO MT-PLANT MOVE REL-PROD TO MT-PROD MOVE 0 TO MT-SEQ.
    READ MATREL REGARDLESS INVALID GO AB718.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AB-IXF OR MT-IXF=30 ADD 1 TO MT-IXF
      MOVE AB-FQTY(IX1) TO MT-FQTY(MT-IXF) MOVE AB-FPERIOD(IX1) TO MT-FPERIOD(MT-IXF)
      MOVE AB-FDATE(IX1) TO MT-FDATE(MT-IXF) MOVE AB-FRD(IX1) TO MT-FRD(MT-IXF) END-PERFORM.
    REWRITE MT-RECORD ALLOWING NO UNLOCK MATREL.
AB718. GO AB74.

AB72. PERFORM INIT-MT.
    MOVE REL-PLANT TO MT-PLANT MT-KPLANT MOVE REL-PROD TO MT-PROD MT-KPROD.
    MOVE ED-TYPE TO MT-TYPE MOVE ED-SEP TO MT-SEP MOVE SYS-DATE TO MT-DATE.
    MOVE REL-ISA-KEY TO MT-ISA-KEY MOVE REL-RUN-KEY TO MT-RUN-KEY.
    MOVE AB-LIN TO MT-LIN MOVE AB-IXL TO MT-IXL.
    MOVE AB-INFO TO MT-INFO MOVE AB-IXI TO MT-IXI IF MT-IXI>6 MOVE 6 TO MT-IXI.
    MOVE AB-FST TO MT-FST MOVE AB-IXF TO MT-IXF.
    MOVE AB-SOURCE TO MT-SOURCE.
    MOVE AB-BFR-TYPE TO MT-BFR-TYPE MOVE AB-BFR-NUM TO MT-BFR-NUM.
    MOVE AB-BFR-SCHED TO MT-BFR-SCHED MOVE AB-BFR-FDATE TO MT-BFR-FDATE.
    MOVE AB-BFR-TDATE TO MT-BFR-TDATE MOVE AB-BFR-DATE TO MT-BFR-DATE.
    MOVE AB-DOCK TO MT-DOCK MOVE AB-ZONE TO MT-LF MOVE AB-STAT TO MT-STATUS.
    MOVE PL-REP TO MT-REP PERFORM MAT-ADDREC.
AB74. IF AB-KDY=0 GO AB76. PERFORM INIT-DY.
    MOVE REL-PLANT TO DY-PLANT DY-KPLANT MOVE REL-PROD TO DY-PROD DY-KPROD.
    MOVE ED-TYPE TO DY-TYPE MOVE ED-SEP TO DY-SEP.
    MOVE SYS-DATE TO DY-DATE MOVE REL-ISA-KEY TO DY-ISA-KEY.
    MOVE REL-ORD TO DY-ORD MOVE AB-CUSORD TO DY-CUSORD MOVE "SH" TO DY-SCHEDULE.
    MOVE AB-LIN TO DY-LIN MOVE AB-IXL TO DY-IXL.
    MOVE AB-INFO TO DY-INFO MOVE AB-IXI TO DY-IXI.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AB-IXF
      MOVE AB-FQTY(IX1) TO DY-FQTY(IX1) MOVE AB-FDATE(IX1) TO DY-FDATE(IX1) END-PERFORM.
    MOVE AB-IXF TO DY-IXF PERFORM DAY-ADDREC.
AB76.
AB78. IF AB-KFIN=0 GO AB45. GO AB35.
AB8. CLOSE EDI.
    MOVE 2 TO AB-STEP PERFORM AB-PAGE PERFORM PRINT-PLORD PERFORM CLOSE-SORT.
AB9. EXIT.

AB-AINF. IF AB-IXI<12 ADD 1 TO AB-IXI MOVE ED-RECORD(1:EDI-SZ - 1) TO AB-IFLINE(AB-IXI).
AB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AB-PAGE.
AB-PAGE. IF AB-OP=1 MOVE 2 TO A-N1. IF AB-OP=2 MOVE 3 TO A-N1.
    IF AB-OP=3 MOVE 4 TO A-N1. PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " MATERIAL RELEASE (830) REPORT" DELIMITED SIZE INTO FF3.
    MOVE "(MATREL FILE UPDATE)" TO FF4 PERFORM PR-PAGE.
    IF AB-STEP=1 MOVE
         "SOURCE      REL NUM   TYPE  SCHED   DATE       FROM  --  TO" TO PREC PERFORM PR-LINE
      MOVE
         "   PRODUCT      PLANT       ORDER  ERR  DOCK    ZONE  RELEASE" TO PREC PERFORM PR-LINE-3.
*         ..........  .......... ..    ..   ../../..   ../../.. ../../..
*            ............ .......... ......  ...  ......  ......  ..     ..:.......... ..:.......... (x5)
*                  ...,... ../../.. .   ...,... ../../.. .  (x6)
    IF AB-STEP=2 MOVE ED-HEAD1 TO PREC PERFORM PR-LINE-3.
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==MOVE ALL ":" TO ED-FIELD UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==UNSTR-FIELD== BY ==UNSTRING ED-FIELD DELIMITED ED-DEL==.
IQ-DELFOR. PERFORM IQ1 THRU IQ9.
IQ1. OPEN INPUT EDI PERFORM OPEN-SORT.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.
    MOVE 1 TO IQ-STEP PERFORM IQ-PAGE.
IQ3. READ EDI END GO IQ8. IF ED-RECORD(1:4) NOT="UNB+" GO IQ3.
    UNSTR-RECORD INTO ED-A ED-A ED-FIELD UNSTR-FIELD INTO WA1.
* note 240.2
    IF IQ-OP=5 EVALUATE TRUE
      WHEN WA1="XLP" SET ED-AMAX TO TRUE
      WHEN WA1="603813507" SET ED-DRI TO TRUE
      WHEN OTHER CONTINUE.
    UNSTR-RECORD INTO ED-A ED-A ED-A ED-A ED-FIELD.
    MOVE 1 TO ED-PTR UNSTR-FIELD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO REL-IDATE.
    UNSTR-FIELD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO REL-ITIME.
IQ33. READ EDI END PERFORM EDI-ERR GO IQ8. IF ED-RECORD(1:4)="UNZ+" GO IQ3.
    IF ED-RECORD(1:4) NOT="UNH+" GO IQ33.
    UNSTR-RECORD INTO ED-A ED-LINE COUNT ED-LTH ED-FIELD.
    PERFORM EL-RDVAL MOVE ED-VAL TO REL-INUM.
    UNSTR-FIELD INTO WA1 IF WA1="DELFOR" GO IQ4.
IQ35. READ EDI END PERFORM EDI-ERR GO IQ8. IF ED-RECORD(1:4)="UNT+" GO IQ33.
    GO IQ35.
IQ4. PERFORM IQ-LINE 2 TIMES.
    INITIALIZE IQ-IXT IQ-WEEK IQ-FUNCTION IQ-SOURCE IQ-DOC-DATE IQ-DOC-HDATE(1) IQ-DOC-HDATE(2).
IQ43. READ EDI END PERFORM EDI-ERR GO IQ8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" GO IQ33. IF ED-RECORD(1:4)="GIS+" GO IQ44.
    IF ED-RECORD(1:4)="BGM+"
      UNSTR-RECORD INTO ED-A ED-A IQ-WEEK IQ-FUNCTION GO IQ438.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF ED-DQUAL="137" MOVE D-DATE TO IQ-DOC-DATE END-IF
      IF ED-DQUAL="158" MOVE D-DATE TO IQ-DOC-HDATE(1) END-IF
      IF ED-DQUAL="159" MOVE D-DATE TO IQ-DOC-HDATE(2) END-IF
      GO IQ438.
    IF ED-RECORD(1:4)="FTX+"
      UNSTR-RECORD INTO ED-A ED-A ED-A ED-A WA1
      IF IQ-IXT<5 ADD 1 TO IQ-IXT MOVE WA1 TO IQ-TEXT(IQ-IXT) END-IF
      GO IQ438.
    IF ED-RECORD(1:4)="NAD+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="MI" MOVE WA2 TO IQ-SOURCE END-IF
      GO IQ438.
IQ438. GO IQ43.
IQ44. MOVE "SOURCE:" TO FG394 MOVE IQ-SOURCE TO FG395 MOVE "DATES:" TO FG396.
    MOVE IQ-DOC-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG397.
    MOVE IQ-DOC-HDATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG398 MOVE "-" TO FG399.
    MOVE IQ-DOC-HDATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG400.
    MOVE "WEEK:" TO FG401 MOVE IQ-WEEK TO FG402.
    MOVE "FUNCTION:" TO FG403 MOVE IQ-FUNCTION TO FG404.
    PERFORM IQ-LINE.
    IF IQ-IXT>0 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IQ-IXT
      MOVE IQ-TEXT(IX1) TO FG424 PERFORM IQ-LINE END-PERFORM.

* GIS records
IQ51. MOVE " " TO REL-PLANT.
IQ53. READ EDI END PERFORM EDI-ERR GO IQ8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="LIN+" GO IQ54.
    IF ED-RECORD(1:4)="NAD+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="ST" MOVE WA2 TO REL-PLANT END-IF
      GO IQ538.
IQ538. GO IQ53.

* LIN records
IQ54. MOVE 0 TO IQ-FIN.
IQ55. UNSTR-RECORD INTO ED-A ED-A ED-A ED-FIELD UNSTR-FIELD INTO REL-PROD.
    PERFORM RDADJ-PNO PERFORM RD-PLANT PERFORM CHK-PLORD.
    MOVE 0 TO IQ-IXI IQ-IXT IQ-IXF IQ-SHD-CUM IQ-SHP-CUM IQ-CUM IQ-FAB-CUM IQ-MAT-CUM
      IQ-SHD-DATE(1) IQ-SHD-DATE(2) IQ-SHP-DATE(1) IQ-SHP-DATE(2)
      IQ-FAB-DATE(1) IQ-FAB-DATE(2) IQ-MAT-DATE(1) IQ-MAT-DATE(2).
    INITIALIZE IQ-QUAL IQ-STATUS IQ-PERIOD IQ-MODYR IQ-LF IQ-DOCK IQ-CUSORD
      IQ-PKG-ID IQ-PKG-QTY IQ-PKG-UNIT IQ-INFO IQ-FST.

IQ57. READ EDI END PERFORM EDI-ERR GO IQ8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" MOVE 2 TO IQ-FIN GO IQ58.
    IF ED-RECORD(1:4)="GIS+" MOVE 1 TO IQ-FIN GO IQ58.
    IF ED-RECORD(1:4)="LIN+" GO IQ58.

    IF ED-RECORD(1:4)="PIA+"
      UNSTR-RECORD INTO ED-A ED-A ED-FIELD UNSTR-FIELD INTO WA1 WA2
      IF WA2="RY" MOVE WA1 TO A-A1 PERFORM STR-LTH MOVE WA1(A-N1:1) TO IQ-MODYR END-IF
      GO IQ578.
    IF ED-RECORD(1:4)="IMD+" PERFORM IQ-AINF GO IQ578.
    IF ED-RECORD(1:4)="LOC+"
      PERFORM IQ-AINF UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="11" MOVE WA2 TO IQ-DOCK END-IF
      IF WA1="159" MOVE WA2 TO IQ-LF END-IF
      GO IQ578.
    IF ED-RECORD(1:4)="FTX+"
      UNSTR-RECORD INTO ED-A ED-A ED-A ED-A WA1
      IF IQ-IXT<5 ADD 1 TO IQ-IXT MOVE WA1 TO IQ-TEXT(IQ-IXT) END-IF
      GO IQ578.
    IF ED-RECORD(1:4)="RFF+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO WA1 WA2
      IF WA1="ON" MOVE WA2 TO IQ-CUSORD END-IF
      GO IQ578.
    IF ED-RECORD(1:4)="QTY+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO IQ-QUAL ED-LINE COUNT ED-LTH WA1
      PERFORM EL-RDVAL
      IF IQ-STATUS=" " AND IQ-QUAL="79" MOVE ED-VAL TO IQ-SHD-CUM GO IQ578 END-IF
      IF IQ-STATUS=" " AND IQ-QUAL="3" MOVE ED-VAL TO IQ-SHP-CUM IQ-CUM GO IQ578 END-IF
      IF IQ-STATUS="2" AND IQ-QUAL="3" MOVE ED-VAL TO IQ-FAB-CUM GO IQ578 END-IF
      IF IQ-STATUS="3" AND IQ-QUAL="3" MOVE ED-VAL TO IQ-MAT-CUM GO IQ578 END-IF
      IF (IQ-STATUS="1" OR "4") AND (IQ-QUAL="1" OR "3") AND IQ-IXF<30
        IF IQ-QUAL="1" MOVE ED-VAL TO WN1
          ELSE COMPUTE WN1=ED-VAL - IQ-CUM MOVE ED-VAL TO IQ-CUM END-IF
        IF WN1>0 ADD 1 TO IQ-IXF MOVE WN1 TO IQ-FQTY(IQ-IXF)
          MOVE IQ-PERIOD TO IQ-FPERIOD(IQ-IXF)
         ELSE MOVE " " TO IQ-QUAL END-IF GO IQ578 END-IF
      IF IQ-STATUS="P" AND IQ-QUAL="52"
        MOVE ED-VAL TO IQ-PKG-QTY MOVE WA1 TO IQ-PKG-UNIT GO IQ578 END-IF
      GO IQ578.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF IQ-STATUS=" " AND IQ-QUAL="79"
        IF ED-DQUAL="51" MOVE D-DATE TO IQ-SHD-DATE(1) END-IF
        IF ED-DQUAL="52" MOVE D-DATE TO IQ-SHD-DATE(2) END-IF GO IQ578 END-IF
      IF IQ-STATUS=" " AND IQ-QUAL="3"
        IF ED-DQUAL="51" MOVE D-DATE TO IQ-SHP-DATE(1) END-IF
        IF ED-DQUAL="11" MOVE D-DATE TO IQ-SHP-DATE(2) END-IF GO IQ578 END-IF
      IF IQ-STATUS="2" AND IQ-QUAL="3"
        IF ED-DQUAL="51" MOVE D-DATE TO IQ-FAB-DATE(1) END-IF
        IF ED-DQUAL="52" MOVE D-DATE TO IQ-FAB-DATE(2) END-IF GO IQ578 END-IF
      IF IQ-STATUS="3" AND IQ-QUAL="3"
        IF ED-DQUAL="51" MOVE D-DATE TO IQ-MAT-DATE(1) END-IF
        IF ED-DQUAL="52" MOVE D-DATE TO IQ-MAT-DATE(2) END-IF GO IQ578 END-IF
      IF (IQ-STATUS="1" OR "4") AND (IQ-QUAL="1" OR "3") AND (IQ-IXF>=1 AND<=30)
        MOVE D-DATE TO IQ-FDATE(IQ-IXF) GO IQ578 END-IF
      GO IQ578.
    IF ED-RECORD(1:4)="SCC+"
      UNSTR-RECORD INTO ED-A IQ-STATUS ED-A ED-FIELD
      UNSTR-FIELD INTO IQ-PERIOD GO IQ578.
    IF ED-RECORD(1:4)="PAC+"
      UNSTR-RECORD INTO ED-A ED-A ED-A IQ-PKG-ID
      MOVE "P" TO IQ-STATUS GO IQ578.
IQ578. GO IQ57.
IQ58. PERFORM MAT-DELREC IF A-S1=1 GO IQ78.
    MOVE 2 TO WS-PR MOVE REL-PROD TO FG408 MOVE REL-PLANT TO FG409.
    MOVE REL-ORD TO FG410 MOVE IQ-CUSORD TO FG411 MOVE IQ-MODYR TO FG412.
    MOVE IQ-PKG-ID TO FG413 MOVE IQ-PKG-QTY TO FG414 MOVE IQ-PKG-UNIT TO FG415.
    PERFORM IQ-LINE.
    MOVE "SHED CUM." TO FG418(1) MOVE IQ-SHD-CUM TO FG419(1).
    MOVE IQ-SHD-DATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG420(1) MOVE "-" TO FG421(1).
    MOVE IQ-SHD-DATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG422(1).
    MOVE "FAB AUTH." TO FG418(2) MOVE IQ-FAB-CUM TO FG419(2).
    MOVE IQ-FAB-DATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG420(2) MOVE "-" TO FG421(2).
    MOVE IQ-FAB-DATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG422(2).
    PERFORM IQ-LINE.
    MOVE "SHIP CUM." TO FG418(1) MOVE IQ-SHP-CUM TO FG419(1).
    MOVE IQ-SHP-DATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG420(1) MOVE "-" TO FG421(1).
    MOVE IQ-SHP-DATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG422(1).
    MOVE "MAT AUTH." TO FG418(2) MOVE IQ-MAT-CUM TO FG419(2).
    MOVE IQ-MAT-DATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG420(2) MOVE "-" TO FG421(2).
    MOVE IQ-MAT-DATE(2) TO D-DATE PERFORM D-NM MOVE D-DT TO FG422(2).
    PERFORM IQ-LINE 2 TIMES MOVE 1 TO IX1 PR-IXP.
    PERFORM UNTIL IX1>IQ-IXF IF PR-IXP>6 PERFORM IQ-LINE MOVE 1 TO PR-IXP END-IF
      MOVE IQ-FQTY(IX1) TO FG425(PR-IXP)
      MOVE IQ-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG426(PR-IXP)
      IF IQ-FPERIOD(IX1) NOT="W" MOVE IQ-FPERIOD(IX1) TO FG427(PR-IXP) END-IF
      ADD 1 TO IX1 PR-IXP END-PERFORM.
    PERFORM IQ-LINE 2 TIMES MOVE 1 TO IX1 PR-IXP.
    PERFORM UNTIL IX1>IQ-IXI IF PR-IXP>3 PERFORM IQ-LINE MOVE 1 TO PR-IXP END-IF
      MOVE IQ-IFLINE(IX1) TO FG430(PR-IXP) ADD 1 TO IX1 PR-IXP END-PERFORM.
    PERFORM IQ-LINE.
    IF IQ-IXT>0 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IQ-IXT
      MOVE IQ-TEXT(IX1) TO FG424 PERFORM IQ-LINE END-PERFORM.

    PERFORM INIT-MT.
    MOVE REL-PLANT TO MT-PLANT MT-KPLANT MOVE REL-PROD TO MT-PROD MT-KPROD.
    MOVE ED-TYPE TO MT-TYPE MOVE ED-SEP TO MT-SEP MOVE SYS-DATE TO MT-DATE.
    MOVE REL-ISA-KEY TO MT-ISA-KEY MOVE ALL "0" TO MT-RUN-KEY.
    MOVE IQ-INFO TO MT-INFO MOVE IQ-IXI TO MT-IXI.
    MOVE IQ-FST TO MT-FST MOVE IQ-IXF TO MT-IXF.
    MOVE IQ-SOURCE TO MT-SOURCE MOVE IQ-DOC-DATE TO MT-BFR-DATE.
    MOVE IQ-DOC-HDATE(1) TO MT-BFR-FDATE MOVE IQ-DOC-HDATE(2) TO MT-BFR-TDATE.
    MOVE IQ-DOCK TO MT-DOCK MOVE IQ-LF TO MT-LF MOVE IQ-STATUS TO MT-STATUS.
    MOVE PL-REP TO MT-REP PERFORM MAT-ADDREC.
IQ78. IF IQ-FIN=0 GO IQ55. IF IQ-FIN=1 GO IQ51. GO IQ33.
IQ8. CLOSE EDI.
    MOVE 2 TO IQ-STEP PERFORM IQ-PAGE PERFORM PRINT-PLORD PERFORM CLOSE-SORT.
IQ9. EXIT.

IQ-AINF. IF IQ-IXI<6 ADD 1 TO IQ-IXI MOVE ED-RECORD(1:EDI-SZ - 1) TO IQ-IFLINE(IQ-IXI).
IQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM IQ-PAGE.
IQ-PAGE. IF IQ-OP=4 MOVE 3 TO A-N1. IF IQ-OP=5 MOVE 4 TO A-N1. PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " EDIFACT DELFOR REPORT" DELIMITED SIZE INTO FF3.
    MOVE "(MATREL FILE UPDATE)" TO FF4 PERFORM PR-PAGE.
    IF IQ-STEP=1 MOVE
         "PRODUCT    PLANT       ORDER  CUST ORD     YR  PACKING INFO" TO PREC PERFORM PR-LINE-3.
*         .........  .......... ......  ............ .   ......  ... ...
*                                                           ......... ..,...,... ../../..-../../..      ......... ..,...,... ../../..-../../..
*                 ...,... ../../..-..  ...,... ../../..-.. (x6)
*         SOURCE: ..........   DATES: ../../..  ../../..-../../..   WEEK: ....................   FUNCTION: ..
    IF IQ-STEP=2 MOVE ED-HEAD1 TO PREC PERFORM PR-LINE-3.
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
AK-E850. PERFORM AK1 THRU AK9.
AK1. OPEN INPUT EDI PERFORM OPEN-SORT PERFORM OPEN-MAINTA.
    MOVE 1 TO AK-STEP PERFORM AK-PAGE.
AK3. READ EDI END GO AK8.
    IF ED-RECORD(1:3) NOT="ISA" GO AK3. PERFORM EL-GET-SEP.
    MOVE ED-RECORD(36:15) TO ED-SENDER-ID.
    IF AK-OP=3 MOVE 0 TO ED-TYPE
      IF ED-SENDER-ID="195204458" SET ED-RBW TO TRUE END-IF
      END-IF.
    MOVE ED-RECORD(71:6) TO REL-ISA-KEY(1:6).
    IF REL-IDATE NUMERIC MOVE REL-IDATE TO D-DT PERFORM D-YN MOVE D-DATE TO REL-IDATE.
    MOVE ED-RECORD(78:4) TO REL-ISA-KEY(7:4).
    MOVE ED-RECORD(91:9) TO REL-ISA-KEY(11:9).
AK33. READ EDI END PERFORM EDI-ERR GO AK8.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AK3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AK33.
    UNSTR-RECORD INTO ED-LINE ED-LINE AK-GS-SENDER.
AK35. READ EDI END PERFORM EDI-ERR GO AK8.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AK33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AK35.
    IF ED-RECORD(4:3)="850" GO AK4.
AK37. READ EDI END PERFORM EDI-ERR GO AK8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AK35. GO AK37.

AK4. PERFORM AK-LINE 2 TIMES.
AK43. READ EDI END PERFORM EDI-ERR GO AK8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AK35.
    IF ED-RECORD(1:3)="PO1" AND ED-RECORD(4:1)=ED-SEP GO AK44.
    IF ED-RECORD(1:3)="BEG" AND ED-RECORD(4:1)=ED-SEP
      MOVE " " TO AK-B-ST
      UNSTR-RECORD INTO ED-LINE AK-PURPOSE AK-TYPE AK-PO ED-LINE ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AK-PO-DATE
      MOVE "BEG" TO MFA-F2 MOVE AK-GS-SENDER TO MFA-F3 MOVE AK-PO TO MFA-F4
      MOVE AK-PO-DATE TO MFA-F5 WRITE MFA-RECORD GO AK438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE ED-LINE WA2
      IF WA1="ST" MOVE WA2 TO AK-B-ST
        MOVE "N1" TO MFA-F2 MOVE AK-B-ST TO MFA-F6 WRITE MFA-RECORD END-IF
      GO AK438.
AK438. GO AK43.
AK44. MOVE AK-PO TO FG447 MOVE AK-PURPOSE TO FG448 MOVE AK-TYPE TO FG449.
    MOVE AK-PO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG450.
    PERFORM AK-LINE.

* PO1 records
    MOVE 0 TO AK-KFIN.
AK45. MOVE " " TO REL-PROD.
    MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE AK-LN ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO AK-OQTY.
    UNSTR-RECORD INTO AK-UNIT ED-LINE COUNT ED-LTH AK-MODE POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO AK-PRICE.
AK453. UNSTR-RECORD INTO WA1 WA2 DELIMITER WA3 POINTER ED-PTR.
    IF WA1="BP" MOVE WA2 TO REL-PROD.
    IF NOT(WA3=ED-NL OR " ") GO AK453.
    MOVE "PO1" TO MFA-F2 MOVE AK-LN TO MFA-F8 MOVE AK-OQTY TO MFA-F9.
    MOVE AK-UNIT TO MFA-F10 MOVE AK-PRICE TO MFA-F11 MOVE AK-MODE TO MFA-F12.
    MOVE REL-PROD TO MFA-F13 WRITE MFA-RECORD.

    MOVE " " TO REL-PLANT.
AK47. READ EDI END PERFORM EDI-ERR GO AK8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO AK-KFIN GO AK6.
    IF ED-RECORD(1:3)="PO1" AND ED-RECORD(4:1)=ED-SEP GO AK6.
    IF ED-RECORD(1:3)="SCH" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO AK-RQTY
      UNSTR-RECORD INTO AK-RUNIT ED-LINE ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AK-RDATE
      MOVE "SCH" TO MFA-F2 MOVE AK-RQTY TO MFA-F15 MOVE AK-RUNIT TO MFA-F16
      MOVE AK-RDATE TO MFA-F17 WRITE MFA-RECORD GO AK478.
    IF ED-RECORD(1:3)="CTT" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO WN1
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO WN2
      MOVE "CTT" TO MFA-F2 MOVE WN1 TO MFA-F19 MOVE WN2 TO MFA-F20
      WRITE MFA-RECORD GO AK478.
AK478. GO AK47.
AK6. MOVE AK-B-ST TO REL-PLANT.
    PERFORM RDADJ-PNO PERFORM RD-PLANT PERFORM CHK-PLORD.
    MOVE 0 TO A-N1 PERFORM DAY-DELREC IF A-S1=1 GO AK78.

    MOVE 2 TO WS-PR MOVE AK-LN TO FG452.
    MOVE REL-PROD TO FG453 MOVE REL-PLANT TO FG454.
    MOVE REL-ORD TO FG455 IF REL-ORD=0 MOVE "***" TO FG456.
    MOVE AK-OQTY TO FG457 MOVE AK-UNIT TO FG458 MOVE AK-PRICE TO FG459.
    MOVE AK-MODE TO FG460 MOVE AK-RQTY TO FG461.
    MOVE AK-RDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG462.
    PERFORM AK-LINE.

* note 149
    PERFORM INIT-DY.
    MOVE REL-PLANT TO DY-PLANT DY-KPLANT MOVE REL-PROD TO DY-PROD DY-KPROD.
    MOVE ED-TYPE TO DY-TYPE MOVE ED-SEP TO DY-SEP.
    MOVE SYS-DATE TO DY-DATE MOVE REL-ISA-KEY TO DY-ISA-KEY.
    MOVE REL-ORD TO DY-ORD MOVE AK-PO TO DY-CUSORD MOVE "SH" TO DY-SCHEDULE.
    MOVE 1 TO DY-IXF MOVE AK-RQTY TO DY-FQTY(1) MOVE AK-RDATE TO DY-FDATE(1).
    PERFORM DAY-ADDREC.
AK78. IF AK-KFIN=0 GO AK45. GO AK35.
AK8. CLOSE EDI MAINTA.
    MOVE 2 TO AK-STEP PERFORM AK-PAGE PERFORM PRINT-PLORD PERFORM CLOSE-SORT.
AK9. EXIT.

AK-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AK-PAGE.
AK-PAGE. MOVE 4 TO A-N1 PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " P.O. RELEASE (850) REPORT" DELIMITED SIZE INTO FF3.
    PERFORM PR-PAGE.
    IF AK-STEP=1 MOVE
         "P.O. NO.    PURPOSE  TYPE   DATE" TO PREC PERFORM PR-LINE
      MOVE
         "  LINE  PRODUCT      PLANT       ORDER  ERR    ORD QTY     PRICE  MODE   REL QTY  REL DATE" TO PREC PERFORM PR-LINE-3.
*         ............  ..      ..  ../../..
*            ...  ............ .......... ......  ...  .,...,...-.. ....:... ..  .,...,...- ../../..
    IF AK-STEP=2 MOVE ED-HEAD1 TO PREC PERFORM PR-LINE-3.
    REPLACE OFF.

    REPLACE ==INTO-RECORD== BY ==ED-NL DELIMITED SIZE INTO ED-RECORD POINTER ED-PTR PERFORM EL-SWRITE==.
* note 285.3
BK-E855. PERFORM BK1 THRU BK9.
BK1. MOVE "EDI855" TO EDI-ID OPEN OUTPUT EDI INPUT MAINTA.
    READ MAINTA END GO BK89. CLOSE MAINTA OPEN INPUT MAINTA.
* note 148
    MOVE X"15" TO ED-NL MOVE "*" TO ED-SEP ED-SUBSEP.
    ACCEPT ED-YYMMDD FROM DATE ACCEPT ED-TIME FROM TIME MOVE 1 TO ED-PTR.
    MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL.
    MOVE ED-DUNS TO ED-SENDER-ID MOVE "195204458" TO ED-RECEIVER-ID.
    MOVE "00401" TO ED-ISA-VERSION MOVE "004010" TO ED-GS-VERSION.
    PERFORM RD-EDINFO ADD 1 TO EI-RBW-ISA MOVE EI-RBW-ISA TO ED-ISA-NUM PERFORM WR-EDINFO.
    MOVE 0 TO ED-ISA-TOT ED-GS-NUM.
    STRING "ISA~00~          ~00~          ~"
      ED-SENDER-QUAL "~" ED-SENDER-ID "~" ED-RECEIVER-QUAL "~" ED-RECEIVER-ID "~"
      ED-YYMMDD "~" ED-HHMM "~U~" ED-ISA-VERSION "~" ED-ISA-NUM "~0~P~" ED-SUBSEP INTO-RECORD.
    MOVE 0 TO BK-KST.
BK3. READ MAINTA END GO BK8.
    IF MFA-F2 NOT="BEG" GO BK34. PERFORM BK-SGE MOVE 1 TO BK-KST.
    ADD 1 TO ED-ISA-TOT ED-GS-NUM MOVE 0 TO ED-GS-TOT ED-ST-NUM.
    STRING "GS~SH~" ED-SENDER-ID "~" MFA-F3 DELIMITED " "
      "~" ED-YYMMDD "~" ED-HHMM "~" ED-GS-NUM "~X~" DELIMITED SIZE
      ED-GS-VERSION DELIMITED " " INTO-RECORD.
    ADD 1 TO ED-GS-TOT ADD 1 TO ED-ST-NUM MOVE 1 TO ED-ST-TOT.
    STRING "ST~855~" ED-ST-NUM INTO-RECORD.
    MOVE MFA-F4 TO A-A1 PERFORM STR-LTH MOVE A-N1 TO WN1.
    MOVE MFA-F5 TO D-DATE PERFORM D-NY MOVE D-DT TO ED-N61.
    STRING "BAK~00~AT~" MFA-F4(1:WN1) "~" ED-N61 "~~~~~" ED-YYMMDD INTO-RECORD.
    GO BK38.
BK34.

    IF MFA-F2="N1"
      STRING "N1~SF~IRVINE FASTENERS~01~" ED-DUNS INTO-RECORD
      STRING "N1~ST~RB&W~92~" DELIMITED SIZE MFA-F6 DELIMITED " " INTO-RECORD GO BK38.
    IF MFA-F2="PO1"
      MOVE MFA-F9 TO ED-N71 A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1
      MOVE MFA-F11 TO ED-T41 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2
      STRING "PO1~" DELIMITED SIZE MFA-F8 DELIMITED " " "~" ED-N71(WN1:) "~" DELIMITED SIZE
        MFA-F10 DELIMITED " " "~" ED-T41(WN2:) "~" DELIMITED SIZE MFA-F12 DELIMITED " "
        "~BP~" DELIMITED SIZE MFA-F13 DELIMITED " " INTO-RECORD GO BK38.
    IF MFA-F2="SCH"
      MOVE MFA-F15 TO ED-N71 A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1
      MOVE MFA-F17 TO D-DATE PERFORM D-NY MOVE D-DT TO ED-N61
      STRING "SCH~" ED-N71(WN1:) "~" DELIMITED SIZE MFA-F16 DELIMITED " "
        "~~~002~" ED-N61 INTO-RECORD GO BK38.
    IF MFA-F2="CTT"
      MOVE MFA-F19 TO ED-N31 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1
      MOVE MFA-F20 TO ED-N71 A-U1 MOVE 7 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2
      STRING "CTT~" ED-N31(WN1:) "~" ED-N71(WN2:) INTO-RECORD GO BK38.
BK38. GO BK3.
BK8. PERFORM BK-SGE.
    STRING "IEA~" ED-ISA-TOT "~" ED-ISA-NUM INTO-RECORD.
BK89. CLOSE EDI MAINTA PERFORM DELETE-MAINT.
BK9. EXIT.

BK-SGE. IF BK-KST=1 STRING "SE~" ED-ST-TOT "~" ED-ST-NUM INTO-RECORD
          STRING "GE~" ED-GS-TOT "~" ED-GS-NUM INTO-RECORD.
    REPLACE OFF.

* E-7 PROCESS TEXT MESSAGE 864, GENRAL
UF1. PERFORM RD295 PERFORM WRT.
    ACCEPT UF-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UF-OP=99 GO MN9. IF UF-OP=0 OR>4 GO UF1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF UF-OP=1 SET ED-CHRY TO TRUE STRING "CHREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS CHRYSLER TEXT MESSAGE (864) FILE " TO WA1.
    IF UF-OP=2 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS GM TEXT MESSAGE (864) FILE " TO WA1.
    IF UF-OP=3 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS GM EDIFACT TEXT MESSAGE (GENRAL) FILE " TO WA1.
    IF UF-OP=4 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS ADVANTIS EDIFACT TEXT MESSAGE (GENRAL) FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9. CLOSE EDI.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    IF UF-OP=1 OR 2 MOVE UF-OP TO AD-OP PERFORM AD-E864
      ELSE MOVE UF-OP TO WI-OP PERFORM WI-GENRAL.
    PERFORM CLOSE-PR.
UF9. GO MN9.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
AD-E864. PERFORM AD1 THRU AD9.
AD1. OPEN INPUT EDI.
AD3. READ EDI END GO AD8.
    IF ED-RECORD(1:3) NOT="ISA" GO AD3. PERFORM EL-GET-SEP.
AD33. READ EDI END PERFORM EDI-ERR GO AD8.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AD3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AD33.
AD35. READ EDI END PERFORM EDI-ERR GO AD8.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AD33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AD35.
    IF ED-RECORD(4:3)="864" GO AD4.
AD37. READ EDI END PERFORM EDI-ERR GO AD8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AD35. GO AD37.

AD4. PERFORM AD-PAGE.
AD43. READ EDI END PERFORM EDI-ERR GO AD8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AD35.
    IF ED-RECORD(1:3)="MIT" AND ED-RECORD(4:1)=ED-SEP GO AD44.
    GO AD43.
AD44. MOVE ED-RECORD(1:EDI-SZ - 1) TO PREC INSPECT PREC REPLACING ALL ED-SEP BY ":".
    PERFORM AD-LINE.

* MIT records
    MOVE 0 TO AD-KFIN.
AD45. MOVE 2 TO WS-PR MOVE ED-RECORD(1:EDI-SZ - 1) TO PREC.
    INSPECT PREC REPLACING ALL ED-SEP BY ":" PERFORM AD-LINE.
AD47. READ EDI END PERFORM EDI-ERR GO AD8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO AD-KFIN GO AD48.
    IF ED-RECORD(1:3)="MIT" AND ED-RECORD(4:1)=ED-SEP GO AD48.
    IF NOT(ED-RECORD(1:3)="MSG" AND ED-RECORD(4:1)=ED-SEP)
      MOVE ED-RECORD(1:EDI-SZ - 1) TO PREC INSPECT PREC REPLACING ALL ED-SEP BY ":"
      PERFORM AD-LINE GO AD478.
    UNSTR-RECORD INTO ED-LINE AD-TEXT AD-PR.
    IF AD-PR="NP" PERFORM AD-PAGE.
    IF AD-PR="NS" MOVE 0 TO WS-PR. IF AD-PR="DS" MOVE 2 TO WS-PR.
    MOVE AD-TEXT TO PREC PERFORM AD-LINE GO AD478.
AD478. GO AD47.
AD48. IF AD-KFIN=0 GO AD45. GO AD35.
AD8. CLOSE EDI.
AD9. EXIT.

AD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AD-PAGE.
AD-PAGE. IF AD-OP=1 MOVE 2 TO A-N1. IF AD-OP=2 MOVE 3 TO A-N1.
    PERFORM SET-ENAME STRING A-A1 DELIMITED " " " EDI (864) TEXT MESSAGE"
      DELIMITED SIZE INTO FF3.
    PERFORM PR-PAGE PERFORM PR-LINE.
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==MOVE ALL ":" TO ED-FIELD UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==UNSTR-FIELD== BY ==UNSTRING ED-FIELD DELIMITED ED-DEL==.
WI-GENRAL. PERFORM WI1 THRU WI9.
WI1. OPEN INPUT EDI PERFORM OPEN-SORT.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.
WI3. READ EDI END GO WI8. IF ED-RECORD(1:4) NOT="UNB+" GO WI3.
    UNSTR-RECORD INTO ED-A ED-A ED-A ED-A ED-FIELD.
    MOVE 1 TO ED-PTR UNSTR-FIELD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO REL-IDATE.
    UNSTR-FIELD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO REL-ITIME.
WI33. READ EDI END PERFORM EDI-ERR GO WI8. IF ED-RECORD(1:4)="UNZ+" GO WI3.
    IF ED-RECORD(1:4) NOT="UNH+" GO WI33.
    UNSTR-RECORD INTO ED-A ED-LINE COUNT ED-LTH ED-FIELD.
    PERFORM EL-RDVAL MOVE ED-VAL TO REL-INUM.
    UNSTR-FIELD INTO WA1 IF WA1="GENRAL" GO WI4.
WI35. READ EDI END PERFORM EDI-ERR GO WI8. IF ED-RECORD(1:4)="UNT+" GO WI33.
    GO WI35.
WI4. PERFORM WI-PAGE MOVE 0 TO WI-IXI.
WI43. READ EDI END PERFORM EDI-ERR GO WI8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" GO WI33. IF ED-RECORD(1:4)="FTX+" GO WI44.
    IF ED-RECORD(1:4)="BGM+" OR "NAD+" OR "CTA+"
      IF WI-IXI<5 ADD 1 TO WI-IXI MOVE ED-RECORD(1:EDI-SZ - 1) TO WI-INFO(WI-IXI) END-IF
      GO WI438.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE MOVE D-DATE TO WI-DATE GO WI438.
WI438. GO WI43.
WI44. MOVE "DATE" TO FA800 MOVE WI-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA801.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1> WI-IXI
      MOVE WI-INFO(IX1) TO FA802(IX1) INSPECT FA802(IX1) REPLACING ALL ED-SEP BY ":" END-PERFORM.
    PERFORM WI-LINE 2 TIMES.

* FTX records
    MOVE 0 TO WI-KFIN.
WI55. UNSTR-RECORD INTO ED-A ED-A ED-A ED-A WI-TEXT MOVE 1 TO ED-PTR.
    PERFORM TEST AFTER UNTIL WA1=ED-NL OR ED-SEP OR " "
      UNSTRING WI-TEXT DELIMITED ED-SEP OR ED-NL OR ED-DEL INTO ED-LINE DELIMITER WA1 POINTER ED-PTR
      IF ED-LINE NOT="." MOVE ED-LINE TO PREC END-IF
      PERFORM WI-LINE END-PERFORM.
WI57. READ EDI END PERFORM EDI-ERR GO WI8.
    IF ED-RECORD(1:4)="UNT+" MOVE 1 TO WI-KFIN GO WI58.
    IF ED-RECORD(1:4)="FTX+" GO WI58.
    GO WI57.
WI58. IF WI-KFIN=0 GO WI55. GO WI33.
WI8. CLOSE EDI.
WI9. EXIT.

WI-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM WI-PAGE.
WI-PAGE. IF AD-OP=3 MOVE 3 TO A-N1. IF WI-OP=4 MOVE 4 TO A-N1.
    PERFORM SET-ENAME STRING A-A1 DELIMITED " " " EDIFACT GENRAL REPORT"
      DELIMITED SIZE INTO FF3.
    MOVE "(TEXT MESSAGE)" TO FF4 PERFORM PR-PAGE PERFORM PR-LINE.
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* E-8 PROCESS REMITTANCE ADVICE 820
AF1. PERFORM RD297 PERFORM WRT.
    ACCEPT AF-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AF-OP=99 GO MN9. IF AF-OP=0 OR>2 GO AF1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF AF-OP=1 SET ED-CHRY TO TRUE STRING "CHREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS CHRYSLER REMITTANCE ADVICE (820) FILE " TO WA1.
    IF AF-OP=2 SET ED-GMC TO TRUE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS GM REMITTANCE ADVICE (820) FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM AF-PAGE.

AF3. READ EDI END GO AF9.
    IF ED-RECORD(1:3) NOT="ISA" GO AF3. PERFORM EL-GET-SEP.
    IF NOT(ED-RECORD(55:9)=ED-DUNS OR ED-DUNS2 OR ED-DUNS3 OR ED-REMIT-CL) GO AF3.
AF33. READ EDI END PERFORM EDI-ERR GO AF9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AF3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AF33.
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE COUNT ED-LTH.
    PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AF-DATE.
AF35. READ EDI END PERFORM EDI-ERR GO AF9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AF33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AF35.
    IF ED-RECORD(4:3)="820" GO AF4.
AF37. READ EDI END PERFORM EDI-ERR GO AF9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AF35. GO AF37.

AF4. INITIALIZE AF-TRACE AF-PAY-SRC AF-CHQ-AMT AF-CHQ-DATE AF-KREF.
AF43. READ EDI END PERFORM EDI-ERR GO AF9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AF35.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP
      IF AF-KREF=1 GO AF44 ELSE GO AF37.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="IT" OR "AD" MOVE WA2 TO A-A1 PERFORM STR-LTH
        IF A-N1>=9 AND (WA2(A-N1 - 8:)=ED-DUNS OR ED-DUNS2 OR ED-DUNS3)
          MOVE 1 TO AF-KREF END-IF END-IF
      GO AF438.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO AF-CHQ-AMT
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE
        ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AF-CHQ-DATE
      GO AF438.
    IF ED-RECORD(1:3)="TRN" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE AF-TRACE GO AF438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="PR" MOVE WA2 TO AF-PAY-SRC END-IF GO AF438.
AF438. GO AF43.
AF44. MOVE AF-PAY-SRC TO FG111.
    MOVE AF-CHQ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG112.
    MOVE AF-CHQ-AMT TO FG113 MOVE AF-TRACE TO FG114.
    MOVE LOW-VALUES TO AF-STOTALS AF-GTOTALS MOVE " " TO REL-OPLANT.

* RMR records
    MOVE 0 TO AF-KFIN.
AF45. MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE AF-BL-NO ED-LINE ED-LINE
       COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO AF-PAY-AMT.
    UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO AF-INV-AMT.

    MOVE " " TO AF-INV-NO REL-PLANT.
AF47. READ EDI END PERFORM EDI-ERR GO AF9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO AF-KFIN GO AF48.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP GO AF48.
    IF ED-RECORD(1:3)="DTM" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AF-INV-DATE
      GO AF478.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="OI" MOVE WA2 TO AF-INV-NO END-IF
      IF WA1="PE" MOVE WA2 TO REL-PLANT END-IF
      GO AF478.
AF478. GO AF47.
AF48. IF REL-PLANT=REL-OPLANT GO AF484. IF REL-OPLANT>" " PERFORM AF-ST.
    MOVE REL-PLANT TO REL-OPLANT.
AF484. MOVE REL-PLANT TO FG115 MOVE AF-INV-NO TO FG116 MOVE AF-BL-NO TO FG117.
    MOVE AF-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG118.
    COMPUTE WD1=AF-INV-AMT - AF-PAY-AMT.
    MOVE AF-INV-AMT TO FG119(1) MOVE AF-PAY-AMT TO FG119(2) MOVE WD1 TO FG119(3).
    ADD AF-INV-AMT TO AF-STOT(1) AF-GTOT(1) ADD AF-PAY-AMT TO AF-STOT(2) AF-GTOT(2).
    ADD WD1 TO AF-STOT(3) AF-GTOT(3) PERFORM AF-LINE.
    IF AF-KFIN=0 GO AF45.

    PERFORM AF-ST MOVE "*** PAYMENT TOTALS" TO FG120 MOVE "(RCVD ON" TO FG121.
    MOVE AF-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG122 MOVE ")" TO FG123.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE AF-GTOT(IX1) TO FG119(IX1) END-PERFORM.
    MOVE 2 TO WS-PR PERFORM AF-LINE 4 TIMES.
    GO AF35.
AF9. CLOSE EDI PERFORM CLOSE-PR GO MN9.

AF-ST. MOVE "*** PLANT TOTALS" TO FG120.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE AF-STOT(IX1) TO FG119(IX1) END-PERFORM.
    MOVE 2 TO WS-PR PERFORM AF-LINE 3 TIMES MOVE LOW-VALUES TO AF-STOTALS.
AF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AF-PAGE.
AF-PAGE. IF AF-OP=1 MOVE 2 TO A-N1. IF AF-OP=2 MOVE 3 TO A-N1.
    PERFORM SET-ENAME STRING A-A1 DELIMITED " " " EDI REMITTANCE ADVICE (820) REPORT"
      DELIMITED SIZE INTO FF3 PERFORM PR-PAGE.
    MOVE "RECVD FROM     DATE        AMOUNT  TRACE NO         PLANT    INV NO       B/L NO       DATE       INV AMT     PAID AMT         DIFF" TO PREC PERFORM PR-LINE-3.
*         ..........   ../../..  ...,...:..  ................ ........ ............ .......... ../../..  ...,...:..-  ...,...:..-  ...,...:..-
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* E-9 PROCESS PURCHASE ORDER CHANGE 860
AE1. PERFORM RD298 PERFORM WRT.
    ACCEPT AE-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AE-OP=99 GO MN9. IF AE-OP=0 OR>2 GO AE1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF AE-OP=1 SET ED-CHRY TO TRUE STRING "CHREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS CHRYSLER PURCHASE ORDER CHANGE (860) FILE " TO WA1.
    IF AE-OP=2 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS GM PURCHASE ORDER CHANGE (860) FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM AE-PAGE.

AE3. READ EDI END GO AE9.
    IF ED-RECORD(1:3) NOT="ISA" GO AE3. PERFORM EL-GET-SEP.
AE33. READ EDI END PERFORM EDI-ERR GO AE9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AE3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AD33.
AE35. READ EDI END PERFORM EDI-ERR GO AE9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AE33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AE35.
    IF ED-RECORD(4:3)="860" GO AE4.
AE37. READ EDI END PERFORM EDI-ERR GO AE9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AE35. GO AE37.
AE4.

AE5. READ EDI END PERFORM EDI-ERR GO AE9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AE6.
    UNSTR-RECORD INTO WA1.
    IF WA1="BCH" MOVE 3 TO WS-PR. IF WA1="POC" OR "CTT" MOVE 2 TO WS-PR.
    MOVE ED-RECORD(1:EDI-SZ - 1) TO PREC INSPECT PREC REPLACING ALL ED-SEP BY ":".
    PERFORM AE-LINE GO AE5.
AE6. GO AE35.
AE9. CLOSE EDI PERFORM CLOSE-PR GO MN9.

AE-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AE-PAGE.
AE-PAGE. IF AE-OP=1 MOVE 2 TO A-N1. IF AE-OP=2 MOVE 3 TO A-N1.
    PERFORM SET-ENAME STRING A-A1 DELIMITED " "
      " EDI PURCHASE ORDER CHANGE (860) REPORT" DELIMITED SIZE INTO FF3.
    PERFORM PR-PAGE PERFORM PR-LINE.
    REPLACE OFF.

* E-10 PROCESS RECEIVING ADVICE 861, RECADV
UG1. PERFORM RD303 PERFORM WRT.
    ACCEPT UG-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UG-OP=99 GO MN9. IF UG-OP=0 OR>2 GO UG1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF UG-OP=1 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS ADVANTIS RECEIVING ADVICE (861) FILE " TO WA1.
    IF UG-OP=2 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS GM & ADVANTIS EDIFACT RECEIVING ADVICE (RECADV) FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9. CLOSE EDI.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    IF UG-OP=1 MOVE UG-OP TO GA-OP PERFORM GA-E861
      ELSE MOVE UG-OP TO GJ-OP PERFORM GJ-RECADV.
    PERFORM CLOSE-PR.
UG9. GO MN9.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
GA-E861. PERFORM GA1 THRU GA9.
GA1. OPEN INPUT EDI PERFORM GA-PAGE.
GA3. READ EDI END GO GA8.
    IF ED-RECORD(1:3) NOT="ISA" GO GA3. PERFORM EL-GET-SEP.
GA33. READ EDI END PERFORM EDI-ERR GO GA8.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO GA3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO GA33.
GA35. READ EDI END PERFORM EDI-ERR GO GA8.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO GA33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO GA35.
    IF ED-RECORD(4:3)="861" GO GA4.
GA37. READ EDI END PERFORM EDI-ERR GO GA8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO GA35. GO GA37.

GA4. INITIALIZE GA-HFIELDS MOVE 0 TO GA-IXN.
GA43. READ EDI END PERFORM EDI-ERR GO GA8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO GA35.
    IF ED-RECORD(1:3)="RCD" AND ED-RECORD(4:1)=ED-SEP GO GA44.
    IF ED-RECORD(1:3)="BRA" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE GA-REF ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO GA-DATE
      GO GA438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      IF GA-IXN<3 ADD 1 TO GA-IXN MOVE ED-RECORD(1:EDI-SZ - 1) TO GA-TEXT(GA-IXN) END-IF
      GO GA438.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="SI" MOVE WA2 TO GA-SREF END-IF
      GO GA438.
    IF ED-RECORD(1:3)="DTM" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="050" PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO GA-DATE-RCV END-IF
      GO GA438.
    IF ED-RECORD(1:3)="TD1" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE GA-PKCODE WA1 COUNT WN1 ED-LINE ED-LINE ED-LINE
        GA-PKGN WA2 COUNT WN2 GA-PKUNIT
      MOVE WA1 TO ED-LINE MOVE WN1 TO ED-LTH PERFORM EL-RDVAL MOVE ED-VAL TO GA-PKNUM
      MOVE WA2 TO ED-LINE MOVE WN2 TO ED-LTH PERFORM EL-RDVAL MOVE ED-VAL TO GA-PKWEIGHT
      GO GA438.
    IF ED-RECORD(1:3)="TD5" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE GA-SCAC GO GA438.
GA438. GO GA43.
GA44. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>GA-IXN
       INSPECT GA-TEXT(IX1) REPLACING ALL ED-SEP BY ":" END-PERFORM.
    PERFORM GA-LINE 2 TIMES.
    MOVE GA-REF TO FG100 MOVE GA-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG101.
    MOVE GA-SREF TO FG102 MOVE GA-DATE-RCV TO D-DATE PERFORM D-NM MOVE D-DT TO FG103.
    MOVE GA-PKCODE TO FG104 MOVE GA-PKNUM TO FG104A MOVE GA-PKWEIGHT TO FG104B.
    MOVE GA-PKUNIT TO FG104C MOVE GA-PKGN TO FG104D MOVE GA-SCAC TO FG105.
    IF GA-IXN>0 MOVE GA-TEXT(1) TO FG106. PERFORM GA-LINE.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>GA-IXN
      MOVE GA-TEXT(IX1) TO FG106 PERFORM GA-LINE END-PERFORM.

* RCD records
    MOVE 0 TO GA-KFIN.
GA45. INITIALIZE GA-DFIELDS.
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH GA-UNIT-REC.
    PERFORM EL-RDVAL MOVE ED-VAL TO GA-QTY-REC.

GA47. READ EDI END PERFORM EDI-ERR GO GA8.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO GA-KFIN GO GA48.
    IF ED-RECORD(1:3)="RCD" AND ED-RECORD(4:1)=ED-SEP GO GA48.
    IF ED-RECORD(1:3)="SN1" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH GA-UNIT-SHP
      PERFORM EL-RDVAL MOVE ED-VAL TO GA-QTY-SHP GO GA478.
    IF ED-RECORD(1:3)="LIN" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE WA1 WA2
      IF WA1="BP" MOVE WA2 TO GA-PROD END-IF
      GO GA478.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="CR" MOVE WA2 TO GA-CREF END-IF
      GO GA478.
GA478. GO GA47.
GA48. MOVE GA-PROD TO FG107 MOVE GA-QTY-SHP TO FG108 MOVE GA-UNIT-SHP TO FG108A.
    MOVE GA-QTY-REC TO FG109 MOVE GA-UNIT-REC TO FG109A MOVE GA-CREF TO FG110.
    PERFORM GA-LINE.
    IF GA-KFIN=0 GO GA45. GO GA35.
GA8. CLOSE EDI.
GA9. EXIT.

GA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GA-PAGE.
GA-PAGE. IF GA-OP=1 MOVE 4 TO A-N1. PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " RECEIVING ADVICE (861) REPORT"
      DELIMITED SIZE INTO FF3 PERFORM PR-PAGE.
    MOVE "REF            DATE    SID          DATE RCVD   PCKG  NUM WEIGHT       CARRIER   MISCELLANEOUS" TO PREC PERFORM PR-LINE.
*         ............ ../../..  ............ ../../..    ..... ... ..,... .. .   ....     ..................................................
    MOVE "     PRODUCT        QTY SHPD     QTY RCVD     CUST REF" TO PREC PERFORM PR-LINE-3.
*              ............  ...,... ...  ...,... ...   ............
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==MOVE ALL ":" TO ED-FIELD UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==UNSTR-FIELD== BY ==UNSTRING ED-FIELD DELIMITED ED-DEL==.
GJ-RECADV. PERFORM GJ1 THRU GJ9.
GJ1. OPEN INPUT EDI PERFORM GJ-PAGE.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.
GJ3. READ EDI END GO GJ8. IF ED-RECORD(1:4) NOT="UNB+" GO GJ3.
GJ33. READ EDI END PERFORM EDI-ERR GO GJ8. IF ED-RECORD(1:4)="UNZ+" GO GJ3.
    IF ED-RECORD(1:4) NOT="UNH+" GO GJ33.
    UNSTR-RECORD INTO ED-A ED-A ED-FIELD.
    UNSTR-FIELD INTO WA1 IF WA1="RECADV" GO GJ4.
GJ35. READ EDI END PERFORM EDI-ERR GO GJ8. IF ED-RECORD(1:4)="UNT+" GO GJ33.
    GO GJ35.
GJ4. INITIALIZE GJ-HFIELDS MOVE 0 TO GJ-IXN.
GJ43. READ EDI END PERFORM EDI-ERR GO GJ8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" GO GJ33. IF ED-RECORD(1:4)="CPS+" GO GJ44.
    IF ED-RECORD(1:4)="BGM+"
      UNSTR-RECORD INTO ED-A ED-A GJ-REF GO GJ438.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF ED-DQUAL="137" MOVE D-DATE TO GJ-DATE-DOC END-IF
      IF ED-DQUAL="11" MOVE D-DATE TO GJ-DATE END-IF
      GO GJ438.
    IF ED-RECORD(1:4)="RFF+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO WA1 WA2
      IF WA1="SI" MOVE WA2 TO GJ-SREF END-IF
      GO GJ438.
    IF ED-RECORD(1:4)="DOC+" OR "CDI+"
      IF GJ-IXN<10 ADD 1 TO GJ-IXN MOVE ED-RECORD(1:EDI-SZ - 1) TO GJ-TEXT(GJ-IXN) END-IF
      GO GJ438.
    IF ED-RECORD(1:4)="NAD+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="MI" MOVE WA2 TO GJ-N-MI END-IF
      IF WA1="ST" MOVE WA2 TO GJ-N-ST END-IF
      GO GJ438.
GJ438. GO GJ43.
GJ44. PERFORM GJ-LINE.
    MOVE GJ-REF TO FG467 MOVE GJ-DATE-DOC TO D-DATE PERFORM D-NM MOVE D-DT TO FG468.
    MOVE GJ-SREF TO FG469 MOVE GJ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG470.
    MOVE GJ-N-MI TO FG471 MOVE GJ-N-ST TO FG472.
    MOVE 0 TO WS1 MOVE 1 TO PR-IXP.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>GJ-IXN
      MOVE GJ-TEXT(IX1) TO FG473(PR-IXP) MOVE 1 TO WS1
      ADD 1 TO PR-IXP IF PR-IXP>2 PERFORM GJ-LINE MOVE 1 TO PR-IXP END-IF END-PERFORM.
    IF WS1=0 OR PR-IXP>1 PERFORM GJ-LINE.

* CPS records
GJ51.
GJ53. READ EDI END PERFORM EDI-ERR GO GJ8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="LIN+" GO GJ54. GO GJ53.

* LIN records
GJ54. MOVE 0 TO GJ-FIN.
GJ55. INITIALIZE GJ-DFIELDS.
    UNSTR-RECORD INTO ED-A ED-A ED-A ED-FIELD UNSTR-FIELD INTO GJ-PROD.
GJ57. READ EDI END PERFORM EDI-ERR GO GJ8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" MOVE 2 TO GJ-FIN GO GJ58.
    IF ED-RECORD(1:4)="CPS+" MOVE 1 TO GJ-FIN GO GJ58.
    IF ED-RECORD(1:4)="LIN+" GO GJ58.
    IF ED-RECORD(1:4)="QTY+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO GJ-QUAL ED-LINE COUNT ED-LTH WA1
      PERFORM EL-RDVAL
      IF GJ-QUAL="12" MOVE ED-VAL TO GJ-QTY-SHP MOVE WA1 TO GJ-UNIT-SHP END-IF
      IF GJ-QUAL="48" MOVE ED-VAL TO GJ-QTY-REC MOVE WA1 TO GJ-UNIT-REC END-IF
      GO GJ578.
    IF ED-RECORD(1:4)="RFF+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO WA1 WA2
      IF WA1="CR" MOVE WA2 TO GJ-CREF END-IF
      GO GJ578.
GJ578. GO GJ57.
GJ58. MOVE GJ-PROD TO FG474 MOVE GJ-QTY-SHP TO FG475 MOVE GJ-UNIT-SHP TO FG475A.
    MOVE GJ-QTY-REC TO FG476 MOVE GJ-UNIT-REC TO FG476A MOVE GJ-CREF TO FG477.
    PERFORM GJ-LINE.
    IF GJ-FIN=0 GO GJ55. IF GJ-FIN=1 GO GJ51. GO GJ33.
GJ8. CLOSE EDI.
GJ9. EXIT.

GJ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GJ-PAGE.
GJ-PAGE. IF GJ-OP=2 MOVE 3 TO A-N1. PERFORM SET-ENAME.
    STRING A-A1 DELIMITED " " " RECADV REPORT" DELIMITED SIZE INTO FF3.
    MOVE "(RECEIVING ADVICE)" TO FF4 PERFORM PR-PAGE.
    MOVE "DOC/MSG NO.  DOC DATE  SID            DATE    ISSUER     SHIP TO     MISCELLANEOUS ------------------------------------------------" TO PREC PERFORM PR-LINE.
*         ............ ../../..  ............ ../../..  .......... ..........  ..............................  ..............................
    MOVE "     PRODUCT        QTY SHPD     QTY RCVD     CUST REF" TO PREC PERFORM PR-LINE-3.
*              ............  ...,... ...  ...,... ...   ............
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* E-11 PROCESS ADVANCE SHIP NOTICE 856
AJ1. PERFORM RD305 PERFORM WRT.
    ACCEPT AJ-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AJ-OP=99 GO MN9. IF AJ-OP=0 OR>1 GO AJ1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF AJ-OP=1 STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS SIDBEC-DOSCO ADVANCE SHIP NOTICE (856) FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM AJ-PAGE MOVE 0 TO AJ-KFIR.

AJ3. READ EDI END GO AJ9.
    IF ED-RECORD(1:3) NOT="ISA" GO AJ3. PERFORM EL-GET-SEP.
AJ33. READ EDI END PERFORM EDI-ERR GO AJ9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO AJ3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO AJ33.
AJ35. READ EDI END PERFORM EDI-ERR GO AJ9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO AJ33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO AJ35.
    IF ED-RECORD(4:3)="856" GO AJ4.
AJ37. READ EDI END PERFORM EDI-ERR GO AJ9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AJ35. GO AJ37.

AJ4. INITIALIZE AJ-HFIELDS.
AJ43. READ EDI END PERFORM EDI-ERR GO AJ9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO AJ35.
    IF ED-RECORD(1:2)="HL" AND ED-RECORD(3:1)=ED-SEP GO AJ44.
    IF ED-RECORD(1:3)="BSN" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AJ-DATE-TRANS
      GO AJ438.
    IF ED-RECORD(1:3)="DTM" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="011" PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO AJ-DATE-SHIP END-IF
      GO AJ438.
AJ438. GO AJ43.
AJ44. IF AJ-KFIR=0 MOVE 1 TO AJ-KFIR ELSE PERFORM AJ-PAGE.
    MOVE "*** SHIPPING NOTICE" TO FA626.
    MOVE "DATE SHIPPED:" TO FA627 MOVE AJ-DATE-SHIP TO D-DATE PERFORM D-NM MOVE D-DT TO FA628.
    MOVE "EDI DATE:" TO FA629 MOVE AJ-DATE-TRANS TO D-DATE PERFORM D-NM MOVE D-DT TO FA630.
    PERFORM AJ-LINE.

* HL records
    MOVE 0 TO AJ-KFIN.
AJ45. INITIALIZE AJ-DFIELDS.
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE AJ-LVL.

AJ47. READ EDI END PERFORM EDI-ERR GO AJ9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO AJ-KFIN GO AJ48.
    IF ED-RECORD(1:2)="HL" AND ED-RECORD(3:1)=ED-SEP GO AJ48.

    IF AJ-LVL="S"
      IF ED-RECORD(1:3)="TD1" AND ED-RECORD(4:1)=ED-SEP
        PERFORM AJ-R1
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="TD5" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE AJ-CARRIER WA1
        IF WA1="M" MOVE "MOTOR" TO AJ-METHOD END-IF
        IF WA1="R" MOVE "RAIL" TO AJ-METHOD END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="TD3" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1
        IF WA1="FT" MOVE "FLAT BED TRAILER" TO AJ-EQ-TYPE END-IF
        IF WA1="RO" MOVE "OPEN GONDOLA" TO AJ-EQ-TYPE END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1 WA2
        IF WA1="BM" MOVE WA2 TO AJ-VEN-BL END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1 WA2 ED-LINE WA3
        IF WA1="SO" MOVE WA2 TO AJ-SO-NAME MOVE WA3 TO AJ-SO-ID END-IF
        IF WA1="ST" MOVE WA2 TO AJ-ST-NAME MOVE WA3 TO AJ-ST-ID END-IF
        IF WA1="SE" OR "SU" MOVE WA2 TO AJ-SE-NAME MOVE WA3 TO AJ-SE-ID END-IF
        GO AJ478 END-IF
      END-IF.

    IF AJ-LVL="O"
      IF ED-RECORD(1:3)="PRF" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE AJ-PO
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="TD1" AND ED-RECORD(4:1)=ED-SEP
        PERFORM AJ-R1
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1 WA2
        IF WA1="IL" MOVE WA2 TO AJ-VEN-ORD END-IF
        GO AJ478 END-IF
      END-IF.

    IF AJ-LVL="I"
      IF ED-RECORD(1:3)="LIN" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE ED-LINE WA1 WA2
        IF WA1="VN" MOVE WA2 TO AJ-VEN-LINE END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="PID" AND ED-RECORD(4:1)=ED-SEP
        MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE WA1 ED-LINE ED-LINE WA2 POINTER ED-PTR
        IF AJ-IXP<5 ADD 1 TO AJ-IXP MOVE WA2 TO AJ-PCODE(AJ-IXP)
          IF WA1="F" UNSTR-RECORD INTO AJ-PDESC(AJ-IXP) POINTER ED-PTR END-IF END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="MEA" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE ED-LINE WA1 WA2 WA3
        IF WA1="DI" MOVE "DIAMETER" TO AJ-DTYPE END-IF
        STRING WA2 DELIMITED " " " " DELIMITED SIZE WA3 DELIMITED " " INTO AJ-DIM
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="TD1" AND ED-RECORD(4:1)=ED-SEP
        PERFORM AJ-R1
        GO AJ478 END-IF
      END-IF.

    IF AJ-LVL="T"
      IF ED-RECORD(1:3)="MEA" AND ED-RECORD(4:1)=ED-SEP
        MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE WA1 POINTER ED-PTR
        IF WA1="CT"
          UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH WA1 POINTER ED-PTR
          IF WA1="CX" MOVE "COIL" TO AJ-PACKING END-IF
          IF WA1="BD" MOVE "BUNDLE" TO AJ-PACKING END-IF
          PERFORM EL-RDVAL MOVE ED-VAL TO AJ-QTY PERFORM AJ-Q
          MOVE AJ-QTY TO AJ-SQTY MOVE 0 TO AJ-SCOUNT MOVE 1 TO AJ-IXS END-IF
        IF WA1="WT"
          UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH AJ-WUNIT POINTER ED-PTR
          PERFORM EL-RDVAL MOVE ED-VAL TO AJ-WEIGHT END-IF
        IF WA1="CH"
          UNSTR-RECORD INTO WA1 WA2 WA3 POINTER ED-PTR
          IF AJ-IXC<20 ADD 1 TO AJ-IXC MOVE WA1(2:) TO AJ-CHEM(AJ-IXC)
            MOVE WA2 TO AJ-CVAL(AJ-IXC)
            IF WA3="P1" MOVE "%" TO AJ-CUNIT(AJ-IXC) END-IF END-IF END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1 WA2
        IF WA1="HC" MOVE WA2 TO AJ-HEAT END-IF
        GO AJ478 END-IF
      END-IF.

    IF AJ-LVL="R"
      IF ED-RECORD(1:3)="MEA" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1 ED-LINE ED-LINE COUNT ED-LTH WA2
        IF WA1="WT" PERFORM EL-RDVAL MOVE ED-VAL TO AJ-SWEIGHT
          MOVE WA2 TO AJ-SUNIT END-IF
        GO AJ478 END-IF
      IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
        UNSTR-RECORD INTO ED-LINE WA1 WA2
        IF WA1="CV" MOVE WA2 TO AJ-SNUM END-IF
        GO AJ478 END-IF
      END-IF.
AJ478. GO AJ47.
AJ48. IF AJ-LVL="S" MOVE 2 TO WS-PR
      MOVE "FROM:" TO FA634 MOVE AJ-SE-NAME TO FA635 MOVE AJ-SE-ID TO FA636
      MOVE "CARRIER:" TO FA637 MOVE AJ-CARRIER TO A-A1 PERFORM STR-LTH
      STRING AJ-CARRIER(1:A-N1) ", " AJ-METHOD ", " DELIMITED SIZE AJ-EQ-TYPE DELIMITED "  "
        INTO FA638 PERFORM AJ-LINE
      MOVE "SOLD TO:" TO FA634 MOVE AJ-SO-NAME TO FA635 MOVE AJ-SO-ID TO FA636 PERFORM AJ-LINE
      MOVE "SHIP TO:" TO FA634 MOVE AJ-ST-NAME TO FA635 MOVE AJ-ST-ID TO FA636 PERFORM AJ-LINE
      PERFORM AJ-P1 MOVE "B/L:" TO FA646 MOVE AJ-VEN-BL TO FA647 PERFORM AJ-LINE.
    IF AJ-LVL="O" MOVE 2 TO WS-PR
      PERFORM AJ-P1 MOVE "P.O.:" TO FA648 MOVE AJ-PO TO FA649
      MOVE "VENDOR ORDER:" TO FA650 MOVE AJ-VEN-ORD TO FA651 PERFORM AJ-LINE.
    IF AJ-LVL="I" MOVE 2 TO WS-PR
      PERFORM AJ-P1 MOVE "VENDOR LINE ITEM:" TO FA653 MOVE AJ-VEN-LINE TO FA654
      STRING AJ-DTYPE DELIMITED " " ": " AJ-DIM DELIMITED SIZE INTO FA655 PERFORM AJ-LINE
      MOVE "PRODUCT CODES:" TO FA657
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AJ-IXP
        STRING AJ-PCODE(IX1) DELIMITED " " "/" AJ-PDESC(IX1) DELIMITED SIZE
          INTO FA658(IX1) END-PERFORM
      PERFORM AJ-LINE.
    IF AJ-LVL="T" MOVE 2 TO WS-PR
      PERFORM AJ-P1 MOVE "HEAT:" TO FA665 MOVE AJ-HEAT TO FA666 PERFORM AJ-LINE
      IF AJ-IXC>0 MOVE "CHEMISTRY:" TO FA660 MOVE 1 TO PR-IXP
        PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>AJ-IXC
          MOVE AJ-CHEM(IX1) TO FA661(PR-IXP)
          STRING AJ-CVAL(IX1) AJ-CUNIT(IX1) DELIMITED " " INTO FA662(PR-IXP)
          ADD 1 TO PR-IXP IF PR-IXP>10 PERFORM AJ-LINE MOVE 1 TO PR-IXP END-IF END-PERFORM
        IF PR-IXP>1 PERFORM AJ-LINE END-IF END-IF.
    IF AJ-LVL="R" ADD 1 TO AJ-SCOUNT
      MOVE AJ-SWEIGHT TO FA668(AJ-IXS) MOVE AJ-SUNIT TO FA669(AJ-IXS)
      MOVE AJ-SNUM TO FA670(AJ-IXS)
      ADD 1 TO AJ-IXS IF AJ-IXS>4 IF AJ-SCOUNT=4 MOVE 2 TO WS-PR END-IF
        PERFORM AJ-LINE MOVE 1 TO AJ-IXS END-IF
      IF AJ-SCOUNT=AJ-SQTY AND AJ-IXS>1 PERFORM AJ-LINE.
    IF AJ-KFIN=0 GO AJ45. GO AJ35.
AJ9. CLOSE EDI PERFORM CLOSE-PR GO MN9.

AJ-R1. MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH POINTER ED-PTR.
    IF WA1="COL52" MOVE "COIL" TO AJ-PACKING.
    IF WA1="BDL52" MOVE "BUNDLE" TO AJ-PACKING.
    PERFORM EL-RDVAL MOVE ED-VAL TO AJ-QTY PERFORM AJ-Q.
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE WA1 ED-LINE COUNT ED-LTH AJ-WUNIT POINTER ED-PTR.
    IF WA1="N" MOVE "NET" TO AJ-WQUAL.
    PERFORM EL-RDVAL MOVE ED-VAL TO AJ-WEIGHT.
AJ-Q. MOVE AJ-PACKING TO A-A1 PERFORM STR-LTH.
    IF AJ-QTY>1 AND A-N1>0 MOVE "S" TO AJ-PACKING(A-N1 + 1:1).
AJ-P1. MOVE "QTY:" TO FA640 MOVE AJ-QTY TO FA641 MOVE AJ-PACKING TO FA642.
    MOVE AJ-WQUAL TO FA643 MOVE AJ-WEIGHT TO FA644 MOVE AJ-WUNIT TO FA645.
AJ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AJ-PAGE.
AJ-PAGE. IF AJ-OP=1 MOVE "SIDBEC-DOSCO" TO A-A1.
    STRING A-A1 DELIMITED " " " ADVANCE SHIP NOTICE 856 REPORT" DELIMITED SIZE INTO FF3.
    PERFORM PR-PAGE PERFORM PR-LINE.
    REPLACE OFF.

* E-12 PROCESS INVENTORY REPORT INVRPT
UJ1. PERFORM RD310 PERFORM WRT.
    ACCEPT UJ-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR UJ-OP=99 GO MN9. IF UJ-OP=0 OR>1 GO UJ1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF UJ-OP=1 SET ED-GMC TO TRUE STRING "GMREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS GM EDIFACT INVENTORY REPORT (INVRPT) FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9. CLOSE EDI.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM HF-INVRPT PERFORM CLOSE-PR.
UJ9. GO MN9.

    REPLACE ==UNSTR-RECORD== BY ==MOVE ALL ":" TO ED-FIELD UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==UNSTR-FIELD== BY ==UNSTRING ED-FIELD DELIMITED ED-DEL==.
HF-INVRPT. PERFORM HF1 THRU HF9.
HF1. OPEN INPUT EDI PERFORM HF-PAGE.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.
HF3. READ EDI END GO HF8. IF ED-RECORD(1:4) NOT="UNB+" GO HF3.
HF33. READ EDI END PERFORM EDI-ERR GO HF8. IF ED-RECORD(1:4)="UNZ+" GO HF3.
    IF ED-RECORD(1:4) NOT="UNH+" GO HF33.
    UNSTR-RECORD INTO ED-A ED-A ED-FIELD.
    UNSTR-FIELD INTO WA1 IF WA1="INVRPT" GO HF4.
HF35. READ EDI END PERFORM EDI-ERR GO HF8. IF ED-RECORD(1:4)="UNT+" GO HF33.
    GO HF35.
HF4. INITIALIZE HF-HFIELDS.
HF43. READ EDI END PERFORM EDI-ERR GO HF8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" GO HF33. IF ED-RECORD(1:4)="LIN+" GO HF44.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF ED-DQUAL="137" MOVE D-DATE TO HF-DATE MOVE D-TIME TO HF-TIME END-IF
      GO HF438.
    IF ED-RECORD(1:4)="NAD+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="MI" MOVE WA2 TO HF-MI END-IF
      GO HF438.
HF438. GO HF43.
HF44. PERFORM HF-LINE 2 TIMES.
    MOVE "DATE:" TO FF556 MOVE HF-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF557.
    MOVE "TIME:" TO FF558 MOVE HF-TIME TO FF559.
    MOVE "ISSUER:" TO FF560 MOVE HF-MI TO FF561 PERFORM HF-LINE 2 TIMES.

* LIN records
    MOVE 0 TO HF-FIN.
HF55. INITIALIZE HF-DFIELDS.
    UNSTR-RECORD INTO ED-A ED-A ED-A ED-FIELD UNSTR-FIELD INTO HF-PROD.
HF57. READ EDI END PERFORM EDI-ERR GO HF8. MOVE " " TO WA1 WA2.
    IF ED-RECORD(1:4)="UNT+" MOVE 1 TO HF-FIN GO HF58.
    IF ED-RECORD(1:4)="LIN+" GO HF58.
    IF ED-RECORD(1:4)="INV+"
      UNSTR-RECORD INTO ED-A WA1 MOVE 0 TO HF-IO
      IF WA1="1" MOVE 1 TO HF-IO END-IF
      IF WA1="2" MOVE 2 TO HF-IO END-IF
      IF WA1=" " MOVE 3 TO HF-IO END-IF
      GO HF578.
    IF ED-RECORD(1:4)="NAD+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="ST" MOVE WA2 TO HF-PLANT END-IF
      GO HF578.
    IF ED-RECORD(1:4)="LOC+"
      UNSTR-RECORD INTO ED-A WA1 ED-FIELD UNSTR-FIELD INTO WA2
      IF WA1="159" MOVE WA2 TO HF-DOCK END-IF
      GO HF578.
    IF ED-RECORD(1:4)="QTY+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO WA1 ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE 0 TO WN1 IF WA1="1" MOVE ED-VAL TO WN1 END-IF
      IF HF-IO=1 MOVE WN1 TO HF-OUT-QTY END-IF
      IF HF-IO=2 MOVE WN1 TO HF-IN-QTY END-IF
      IF HF-IO=3 MOVE WN1 TO HF-BAL-QTY END-IF
      GO HF578.
    IF ED-RECORD(1:4)="RFF+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO HF-RFFQ WA1
      IF HF-RFFQ="SI"
        IF HF-IO=1 MOVE WA1 TO HF-OUT-ADV END-IF
        IF HF-IO=2 MOVE WA1 TO HF-IN-ADV END-IF
        END-IF
      IF HF-RFFQ="DQ" MOVE WA1 TO HF-DEL-NOTE END-IF
      GO HF578.
    IF ED-RECORD(1:4)="DTM+"
      UNSTR-RECORD INTO ED-A ED-FIELD UNSTR-FIELD INTO ED-DQUAL ED-LINE COUNT ED-LTH ED-DFQUAL
      PERFORM EL-RDATE
      IF ED-DQUAL="137"
        IF HF-RFFQ="SI"
          IF HF-IO=1 MOVE D-DATE TO HF-OUT-DATE END-IF
          IF HF-IO=2 MOVE D-DATE TO HF-IN-DATE END-IF
          END-IF
        IF HF-RFFQ="DQ" MOVE D-DATE TO HF-DEL-DATE END-IF END-IF
      GO HF578.
HF578. GO HF57.
HF58. MOVE HF-PROD TO FF562 MOVE HF-PLANT TO FF563 MOVE HF-DOCK TO FF564.
    MOVE HF-BAL-QTY TO FF565 MOVE HF-IN-QTY TO FF566.
    MOVE HF-IN-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF567.
    MOVE HF-IN-ADV TO FF568 MOVE HF-OUT-QTY TO FF569.
    MOVE HF-OUT-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF570.
    MOVE HF-OUT-ADV TO FF571.
    MOVE HF-DEL-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF572.
    MOVE HF-DEL-NOTE TO FF573 PERFORM HF-LINE.
    IF HF-FIN=0 GO HF55. GO HF33.
HF8. CLOSE EDI.
HF9. EXIT.

HF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HF-PAGE.
HF-PAGE. MOVE "GM INVRPT REPORT" TO FF3 MOVE "(INVENTORY)" TO FF4 PERFORM PR-PAGE.
    MOVE "PROD NO.  PLANT    DOCK   BALANCE    --------- MOVE IN ----------     --------- MOVE OUT ---------     -- DELIVERY NOTE --" TO PREC PERFORM PR-LINE.
    MOVE "                            QTY          QTY   DATE   DESP ADVICE         QTY   DATE   DESP ADVICE       DATE   NOTE NO." TO PREC PERFORM PR-LINE-3.
*         ........  ........ .....  ...,...    ...,... ../../.. ............    ...,... ../../.. ............    ../../.. ............
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==MOVE ALL ":" TO ED-FIELD UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==UNSTR-FIELD== BY ==UNSTRING ED-FIELD DELIMITED ED-DEL==
            ==INTO-RECORD== BY ==ED-NL DELIMITED SIZE INTO ED-RECORD POINTER ED-PTR PERFORM EL-WRITE==.
* E-13 CREATE EDIFACT ACKNOWLEDGEMENT CONTRL
AW1. PERFORM RD306 PERFORM WRT.
    ACCEPT AW-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR AW-OP=99 GO MN9. IF AW-OP=0 OR>1 GO AW1.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.

    IF AW-OP=1 MOVE 0 TO ED-TYPE STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID
      MOVE " PROCESS ADVANTIS DELJIT/DELFOR/RECADV FILE " TO WA1.

    PERFORM DSP-CLS DISPLAY WA1 LINE 1 REVERSED.
    PERFORM AX-EDI PERFORM AX-ACC IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-MAINTA.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.

AW3. READ EDI END GO AW6. IF ED-RECORD(1:4) NOT="UNB+" GO AW3.
    UNSTR-RECORD INTO ED-A ED-A WA1 WA2 ED-A AW-UNB-REF.
    MOVE " " TO AW-ID1 MOVE 1 TO IX2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>20
      IF WA1(IX1:1)>" " MOVE WA1(IX1:1) TO AW-ID1(IX2:1) ADD 1 TO IX2 END-IF END-PERFORM.
    MOVE " " TO AW-ID2 MOVE 1 TO IX2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>20
      IF WA2(IX1:1)>" " MOVE WA2(IX1:1) TO AW-ID2(IX2:1) ADD 1 TO IX2 END-IF END-PERFORM.
* note 166
    IF AW-ID1(1:9)="002493039" GO AW3.
    MOVE "UNB" TO MFA-F26 MOVE AW-UNB-REF TO MFA-F27.
    MOVE AW-ID1 TO MFA-F28 MOVE AW-ID2 TO MFA-F29 MOVE MFA-RECORD TO AW-MSAV.
AW33. READ EDI END GO AW6. IF ED-RECORD(1:4)="UNZ+" GO AW3.
    IF ED-RECORD(1:4) NOT="UNH+" GO AW33.
    UNSTR-RECORD INTO ED-A AW-UNH-REF ED-FIELD MOVE ED-FIELD TO AW-FLD.
    UNSTR-FIELD INTO WA1 IF WA1="DELJIT" OR "DELFOR" OR "RECADV" GO AW4.
AW35. READ EDI END GO AW6. IF ED-RECORD(1:4)="UNT+" GO AW33.
    GO AW35.
AW4. MOVE AW-MSAV TO MFA-RECORD WRITE MFA-RECORD.
    MOVE "UNH" TO MFA-F26 MOVE AW-UNH-REF TO MFA-F30 MOVE AW-FLD TO MFA-F31.
    WRITE MFA-RECORD GO AW35.
AW6. CLOSE EDI MAINTA.

    MOVE "EDICON" TO EDI-ID OPEN OUTPUT EDI INPUT MAINTA.
    ACCEPT D-DT FROM DATE MOVE D-DT TO ED-YYMMDD PERFORM D-YN PERFORM D-NM.
    COMPUTE ED-CC=D-YEAR / 100 ACCEPT ED-TIME FROM TIME MOVE 1 TO ED-PTR.
    MOVE "'" TO ED-NL MOVE "+" TO ED-SEP MOVE ":" TO ED-DEL.

    MOVE 0 TO AW-NUM.
AW7. READ MAINTA END GO AW8.
    IF MFA-F26 NOT="UNB" GO AW72.
    MOVE MFA-F27 TO AW-UNB-REF MOVE MFA-F28 TO AW-ID1 MOVE MFA-F29 TO AW-ID2.
    IF AW-NUM>0 PERFORM AW-T. ADD 1 TO AW-NUM.
    PERFORM RD-EDINFO ADD 1 TO EI-CONTRL-ISA MOVE EI-CONTRL-ISA TO ED-ISA-NUM PERFORM WR-EDINFO.
    MOVE 1 TO ED-ISA-TOT.
    MOVE ED-DUNS TO ED-SENDER-ID MOVE "01" TO ED-SENDER-QUAL.
    MOVE ED-ISA-NUM TO A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO.
    STRING "UNB+UNOA:2+" ED-SENDER-ID ":" ED-SENDER-QUAL "+" AW-ID1 "+" DELIMITED " "
      ED-YYMMDD ":" ED-HHMM "+" ED-ISA-NUM(A-N1:) INTO-RECORD.
    MOVE 1 TO ED-ST-NUM ED-ST-TOT.
    MOVE ED-ST-NUM TO A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO.
    STRING "UNH+" ED-ST-NUM(A-N1:) "+CONTRL:2:2:UN" INTO-RECORD.
    STRING "UCI+" AW-UNB-REF "+" AW-ID1 "+" AW-ID2 "+7" DELIMITED " " INTO-RECORD.
AW72. IF MFA-F26 NOT="UNH" GO AW78.
    MOVE MFA-F30 TO AW-UNH-REF MOVE MFA-F31 TO AW-FLD.
    STRING "UCM+" AW-UNH-REF "+" AW-FLD "+7" DELIMITED " " INTO-RECORD.
AW78. GO AW7.
AW8. IF AW-NUM>0 PERFORM AW-T.
    IF AW-NUM=0 ADD 2 TO IXT
      DISPLAY "NO DELJIT/DELFOR/RECADV FOUND - EDICON FILE IS EMPTY" LINE IXT
      PERFORM DSP-CONT.
    CLOSE EDI MAINTA PERFORM DELETE-MAINT.
AW9. GO MN9.

AW-T. MOVE ED-ST-TOT TO A-U1 MOVE 6 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1.
    MOVE ED-ST-NUM TO A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2.
    STRING "UNT+" ED-ST-TOT(WN1:) "+" ED-ST-NUM(WN2:) INTO-RECORD.
    MOVE ED-ISA-TOT TO A-U1 MOVE 5 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1.
    MOVE ED-ISA-NUM TO A-U1 MOVE 9 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2.
    STRING "UNZ+" ED-ISA-TOT(WN1:) "+" ED-ISA-NUM(WN2:) INTO-RECORD.
    REPLACE OFF.

* E-21 MODIFY B/L INDICATORS
MD1. OPEN I-O CFORD ALLOWING ALL.
MD3. PERFORM RD300 PERFORM WRT.
MD31. ACCEPT FO-BL LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR FO-BL=9999999 GO MD9. IF FO-BL=0 GO MD31.
    READ CFORD REGARDLESS INVALID PERFORM DSP-ERR13 GO MD31.
    DISPLAY FO-IND LINE 6 COLUMN 19 CONVERSION.
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>4
      DISPLAY FO-PIND(IX1) LINE IXT COLUMN 19 CONVERSION
      ADD 1 TO IX1 IXT END-PERFORM.
    ACCEPT FO-IND LINE 6 COLUMN 19 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY FO-IND LINE 6 COLUMN 19 CONVERSION.
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>4
      ACCEPT FO-PIND(IX1) LINE IXT COLUMN 19 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY FO-PIND(IX1) LINE IXT COLUMN 19 CONVERSION
      ADD 1 TO IX1 IXT END-PERFORM.
    REWRITE FO-RECORD ALLOWING NO UNLOCK CFORD GO MD3.
MD9. CLOSE CFORD GO MN9.

* E-22 MATERIAL RELEASE REPORT
RM1. PERFORM RD296 PERFORM WRT.
    ACCEPT RM-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR RM-OP=99 GO MN9. IF RM-OP=0 OR>5 GO RM1.
    IF RM-OP=1 SET ED-CHRY TO TRUE. IF RM-OP=2 SET ED-GMC TO TRUE.
    IF RM-OP=3 OR 4 GO RM4. IF RM-OP=5 GO RM6.

* op=1,2
    PERFORM RD296A PERFORM WRT.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-PLANT-R.
    MOVE 4 TO IXT MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-PROD-R.
    MOVE 6 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-SORT PERFORM OPEN-PR.

    MOVE 1 TO RM-STEP PERFORM RM-PAGE MOVE " " TO REL-OPLANT.
    MOVE " " TO MT-KEY START MATREL KEY>MT-KEY REGARDLESS INVALID GO RM39.
RM33. READ MATREL NEXT REGARDLESS END GO RM39. MOVE MT-TYPE TO ED-TYPE.
    IF NOT(RM-OP=1 AND ED-CHRY OR RM-OP=2 AND ED-GMC) GO RM33.
    IF NOT((MT-PLANT>=PLANT1 AND<=PLANT2) AND (MT-PROD>=PROD1 AND<=PROD2)) GO RM33.
    IF MT-PLANT=REL-OPLANT GO RM34.
    IF TOT-IND=0 IF REL-OPLANT>" " PERFORM RM-PAGE. MOVE MT-PLANT TO REL-OPLANT.
RM34. MOVE MT-PLANT TO REL-PLANT MOVE MT-PROD TO REL-PROD.
    PERFORM RDADJ-PNO PERFORM RD-PLANT.
    MOVE PL-PROD TO RM-PROD MOVE PL-ORD TO RM-ORD PERFORM RM-P GO RM33.
RM39. PERFORM RM-T.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR GO RM9.

RM4. PERFORM RD296B PERFORM WRT.
    MOVE 3 TO IXT MOVE 18 TO IXU MOVE 41 TO IXV PERFORM AX-REP-R.
    MOVE 5 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S MOVE TOT-IND TO RM-KTOT.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO MT-KEY START MATREL KEY>MT-KEY REGARDLESS INVALID GO RM429.
RM423. READ MATREL NEXT REGARDLESS END GO RM429. MOVE MT-TYPE TO ED-TYPE.
    IF NOT(RM-OP=3 AND NOT(ED-GMC OR ED-CHRY OR ED-NONEDI) OR RM-OP=4 AND ED-NONEDI) GO RM423.
    IF NOT(MT-REP>=REP1 AND<=REP2) GO RM423. PERFORM INIT-RP.
    MOVE MT-REP TO RP-F6 MOVE MT-KEY TO RP-F7 WRITE RP-RECORD GO RM423.
RM429. PERFORM OPEN-PR PERFORM OPEN-SORT.
    MOVE "??" TO RM-OREP MOVE RM-KTOT TO TOT-IND.
* note 71
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RM48.
RM43. READ REPFL NEXT END GO RM48. IF RP-F6=RM-OREP GO RM44.
    IF RM-OREP NOT="??" PERFORM RM-T
      PERFORM CLOSE-SORT PERFORM OPEN-SORT PERFORM PR-RESET.
    MOVE RM-KTOT TO TOT-IND MOVE RP-F6 TO RM-OREP.
    MOVE 1 TO RM-STEP PERFORM RM-PAGE.
RM44. MOVE RP-F7 TO MT-KEY READ MATREL REGARDLESS.
    MOVE MT-PLANT TO REL-PLANT MOVE MT-PROD TO REL-PROD.
    PERFORM RDADJ-PNO PERFORM RD-PLANT.
    MOVE PL-PROD TO RM-PROD MOVE PL-ORD TO RM-ORD PERFORM RM-P GO RM43.
RM48. PERFORM RM-T.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR GO RM9.

RM6. PERFORM RD296C PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 39 TO IXV PERFORM AX-CAT-R.
    MOVE 5 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO MT-KEY START MATREL KEY>MT-KEY REGARDLESS INVALID GO RM629.
RM623. READ MATREL NEXT REGARDLESS END GO RM629.
    MOVE MT-PROD TO A-A1 PERFORM PROD-RT IF NOT(P-CAT>=CAT1 AND<=CAT2) GO RM623.
    PERFORM INIT-RP MOVE P-CAT TO RP-F153 MOVE MT-KEY TO RP-F154.
    WRITE RP-RECORD GO RM623.
RM629. PERFORM OPEN-SORT PERFORM OPEN-PR.
    MOVE 1 TO RM-STEP PERFORM RM-PAGE MOVE 0 TO RM-OCAT.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RM68.
RM63. READ REPFL NEXT END GO RM68. IF RP-F153=RM-OCAT GO RM64.
    IF TOT-IND=0 IF RM-OCAT NOT=0 PERFORM RM-PAGE END-IF
      MOVE RP-F153 TO DSP-N21 STRING "CATEGORY " DSP-N21 DELIMITED SIZE INTO PREC
      PERFORM RM-PLINE 3 TIMES.
    MOVE RP-F153 TO RM-OCAT.
RM64. MOVE RP-F154 TO MT-KEY READ MATREL REGARDLESS.
    MOVE MT-PLANT TO REL-PLANT MOVE MT-PROD TO REL-PROD.
    PERFORM RDADJ-PNO PERFORM RD-PLANT.
    MOVE PL-PROD TO RM-PROD MOVE PL-ORD TO RM-ORD PERFORM RM-P GO RM63.
RM68. PERFORM RM-T.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR GO RM9.

RM9. GO MN9.

RM-P. PERFORM RM-P1 THRU RM-P9.
RM-P1. MOVE MT-PLANT TO FG36 MOVE RM-PROD TO FG37 MOVE RM-ORD TO FG38.
    MOVE MT-DOCK TO FG39 MOVE MT-LF TO FG39A MOVE MT-STATUS TO FG40.
    MOVE MT-BFR-NUM TO FG41 MOVE MT-BFR-TYPE TO FG42 MOVE MT-BFR-SCHED TO FG43.
    MOVE MT-BFR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG44.
    MOVE MT-BFR-FDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG44A.
    MOVE MT-BFR-TDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG44B.
    IF RM-OP=3 OR 4 MOVE MT-QTY-SHIP TO FG44C. PERFORM RM-TLINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>MT-IXL
      MOVE MT-LCODE(IX1) TO FG45(IX1) MOVE ":" TO FG45A(IX1)
      MOVE MT-LVAL(IX1) TO FG45B(IX1) END-PERFORM.
    PERFORM RM-TLINE MOVE 1 TO IX1 PR-IXP.
RM-P3. IF IX1>MT-IXF GO RM-P4. IF PR-IXP>6 PERFORM RM-TLINE MOVE 1 TO PR-IXP.
    MOVE MT-FQTY(IX1) TO FG48(PR-IXP).
    MOVE MT-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG49(PR-IXP).
    IF MT-FPERIOD(IX1) NOT="W" MOVE MT-FPERIOD(IX1) TO FG50(PR-IXP).
    MOVE MT-FDATE(IX1) TO D-DATE PERFORM D-NM COMPUTE RM-SDT=D-YY * 100 + D-MM.
    MOVE MT-FQTY(IX1) TO RM-SQTY MOVE 0 TO RM-KSA.
    IF RM-OP=3 OR 4 IF MT-FDATE(IX1)>SYS-DATE + 90 MOVE 1 TO RM-KSA.
    PERFORM RM-S ADD 1 TO IX1 PR-IXP GO RM-P3.
RM-P4. PERFORM RM-TLINE.
    IF RM-OP=3 OR 4 COMPUTE RM-SQTY=-MT-QTY-SHIP MOVE 0 TO RM-SDT PERFORM RM-S.
    MOVE 1 TO IX1 PR-IXP.
RM-P5. IF IX1>MT-IXI GO RM-P8. IF PR-IXP>3 PERFORM RM-TLINE MOVE 1 TO PR-IXP.
    MOVE MT-IFLINE(IX1) TO FG52(PR-IXP) INSPECT FG52(PR-IXP) REPLACING ALL MT-SEP BY ":".
    ADD 1 TO IX1 PR-IXP GO RM-P5.
RM-P8. PERFORM RM-TLINE 2 TIMES.
RM-P9. EXIT.
RM-S. PERFORM RM-S1 THRU RM-S9.
RM-S1. IF RM-SQTY=0 GO RM-S9. PERFORM INIT-SR.
    MOVE RM-PROD TO SR-F21 MOVE 1 TO SR-F22 MOVE RM-SDT TO SR-F23 MOVE RM-SQTY TO SR-F24.
    WRITE SR-RECORD INVALID READ SORTFL ADD RM-SQTY TO SR-F24 REWRITE SR-RECORD.
    IF RM-KSA=1 GO RM-S9.
    MOVE 0 TO SR-F22 SR-F23 MOVE RM-SQTY TO SR-F24.
    WRITE SR-RECORD INVALID READ SORTFL ADD RM-SQTY TO SR-F24 REWRITE SR-RECORD.
RM-S9. EXIT.
RM-T. PERFORM RM-T1 THRU RM-T9.
RM-T1. MOVE 0 TO TOT-IND MOVE 2 TO RM-STEP PERFORM RM-PAGE.
    MOVE " " TO OLD-A MOVE 1 TO PR-IXP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO RM-T8.
RM-T3. READ SORTFL NEXT END GO RM-T8. IF SR-F21=OLD-A GO RM-T4.
* note 72
    PERFORM RM-TLINE 2 TIMES MOVE SR-F21 TO FG53 OLD-A MOVE SR-F24 TO FG53A.
    IF RM-OP=3 OR 4 MOVE SR-F21 TO A-A1 PERFORM PROD-GEN
      IF GEN-IND=1 MOVE "        ALT" TO FG54X ELSE MOVE P-ROP TO FG54.
    MOVE 1 TO PR-IXP GO RM-T3.
RM-T4. IF PR-IXP>5 PERFORM RM-TLINE MOVE 1 TO PR-IXP. MOVE SR-F24 TO FG55(PR-IXP).
    IF SR-F24>=0 MOVE SR-F23 TO FG56(PR-IXP) ELSE MOVE " SHPD" TO FG56X(PR-IXP).
    ADD 1 TO PR-IXP GO RM-T3.
RM-T8. IF PR-IXP>1 PERFORM RM-TLINE.
RM-T9. EXIT.
RM-TLINE. IF TOT-IND=1 MOVE " " TO PREC
      ELSE PERFORM PR-LINE IF WS-LINES>60 PERFORM RM-PAGE.
RM-PLINE. IF TOT-IND=1 MOVE " " TO PREC ELSE PERFORM PR-LINE.
RM-PAGE. EVALUATE TRUE
      WHEN RM-OP=1 MOVE 2 TO A-N1 PERFORM SET-ENAME
      WHEN RM-OP=2 MOVE 3 TO A-N1 PERFORM SET-ENAME
      WHEN RM-OP=3 MOVE "NON-GM EDI" TO A-A1
      WHEN RM-OP=4 MOVE "NON-EDI" TO A-A1
      WHEN RM-OP=5 MOVE "FULL" TO A-A1
      END-EVALUATE.
    STRING A-A1 DELIMITED "  " " MATERIAL RELEASE REPORT" DELIMITED SIZE INTO FF3.
    IF RM-OP=1 OR 2 MOVE "** BY PLANT **" TO FF4.
    IF RM-OP=3 OR 4 STRING "FOR SALES REP: " RM-OREP DELIMITED SIZE INTO FF4.
    IF RM-OP=5 MOVE "** BY CATEGORY **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF RM-OP=1 OR 2 PERFORM PRANGE-PLANT MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    IF RM-OP=5 PERFORM PRANGE-CAT.
    IF RM-STEP=1 MOVE
         "PLANT       PRODUCT        ORDER  DOCK    ZONE  RELEASE  REL.NUM   TYPE  SCHED   DATE       FROM  --  TO    QTY SHIPPED" TO PREC PERFORM PR-LINE-3.
*         ..........  ............  ......  ......  ......  ..     .......... ..    ..   ../../..   ../../.. ../../..   ...,...
*                  ..:.......... ..:.......... (x5)
*                  ...,... ../../..   ...,... ../../..  (x6)
    IF RM-STEP=2 MOVE "MONTHLY PRODUCT TOTALS" TO PREC PERFORM PR-LINE-2
      IF RM-OP=3 OR 4 MOVE
         "PRODUCT       90-DAY QTY    R.O.P." TO PREC PERFORM PR-LINE-3
       ELSE MOVE
         "PRODUCT          QTY" TO PREC PERFORM PR-LINE-3.
*         ............ .,...,...-  .,...,...      .,...,...-../..  .,...,...-../..  (x5)

* E-23 DELETE RELEASE FILE RECORDS
MH1. PERFORM RD299 PERFORM WRT.
MH11. ACCEPT MH-OP LINE 5 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR MH-OP=99 GO MN9. IF MH-OP=0 OR>2 PERFORM DSP-ERR2 GO MH11.
MH3. ACCEPT MH-PROD LINE 11 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MH-PROD=ALL "9" GO MH9. IF MH-PROD=" " GO MH3.
    GO MH4 MH6  DEPENDING MH-OP.

MH4. MOVE MH-PROD TO MT-KPROD MOVE " " TO MT-KPLANT.
    START MATREL KEY>=MT-KP REGARDLESS INVALID GO MH58.
MH5. READ MATREL NEXT REGARDLESS END GO MH58. IF MT-KPROD NOT=MH-PROD GO MH58.
    DISPLAY MT-PLANT LINE 11 COLUMN 37.
    PERFORM MH-D IF XA3="DEL" DELETE MATREL.
    DISPLAY " " LINE 11 COLUMN 37 ERASE END LINE GO MH5.
MH58. GO MH3.

MH6. MOVE " " TO DY-KEY START DAYREL KEY>DY-KEY REGARDLESS INVALID GO MH78.
MH7. PERFORM DSP-QWAIT.
MH73. READ DAYREL NEXT REGARDLESS END GO MH78. IF DY-PROD NOT=MH-PROD GO MH73.
    PERFORM DSP-ERS DISPLAY DY-PLANT LINE 11 COLUMN 37.
    DISPLAY "ORDER NO." LINE 11 COLUMN 55 BOLD DY-ORD COLUMN 65 CONVERSION.
    PERFORM MH-D IF XA3="DEL" DELETE DAYREL.
    DISPLAY " " LINE 11 COLUMN 37 ERASE END LINE GO MH7.
MH78. PERFORM DSP-ERS GO MH3.

MH9. GO MN9.

MH-D. MOVE "'DEL' TO DELETE THIS PLANT-PRODUCT RECORD: ___" TO TMSG PERFORM DSP-PROMPT.

* E-24 MATERIAL RELEASE FILE MAINTENANCE
MA1. INITIALIZE MA-PLANT MA-PROD.
MA3. PERFORM RD108 PERFORM WRT.
    PERFORM INIT-MT MOVE "~" TO MT-SEP MOVE ALL "0" TO MT-ISA-KEY MT-RUN-KEY.
    DISPLAY MA-PLANT LINE 3 COLUMN 9 MA-PROD COLUMN 34.
    ACCEPT MA-PLANT LINE 3 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR MA-PLANT=ALL "9" GO MA9.
    ACCEPT MA-PROD LINE 3 COLUMN 34 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO MA9.
    MOVE MA-PLANT TO MT-PLANT MT-KPLANT MOVE MA-PROD TO MT-PROD MT-KPROD.
    PERFORM RDR-INFO PERFORM SET-DEM-DATE.
    MOVE 1 TO MA-KFIN READ MATREL REGARDLESS INVALID MOVE 0 TO MA-KFIN.
    PERFORM MA-SDEM IF MA-KFIN=0 GO MA4.

MA33. DISPLAY MT-REP LINE 5 COLUMN 13.
    MOVE MT-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 5 COLUMN 36.
    DISPLAY MT-STATUS LINE 6 COLUMN 18 MT-DOCK COLUMN 31 MT-LF COLUMN 54.
    DISPLAY MT-SOURCE LINE 8 COLUMN 10 MT-BFR-NUM COLUMN 42.
    DISPLAY MT-BFR-TYPE LINE 9 COLUMN 8 MT-BFR-SCHED COLUMN 28
      MT-QTY-SHIP COLUMN 70 CONVERSION.
    MOVE MT-BFR-FDATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 11 COLUMN 33.
    MOVE MT-BFR-TDATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 11 COLUMN 49.
    MOVE MT-BFR-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 11 COLUMN 74.
    MOVE 14 TO IXT MOVE 1 TO IXCOL.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>MT-IXF OR 16
      COMPUTE IXU=(IXCOL - 1) * 21 + 1 DISPLAY MT-FQTY(IX1) LINE IXT COLUMN IXU CONVERSION
      MOVE MT-FDATE(IX1) TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN IXU PLUS 10
      ADD 1 TO IXCOL IF IXCOL>4 ADD 1 TO IXT MOVE 1 TO IXCOL END-IF END-PERFORM.
    MOVE 1 TO IX1 MOVE 19 TO IXT PERFORM UNTIL IX1>MT-IXI OR 5
      DISPLAY MT-IFLINE(IX1) LINE IXT COLUMN 22 ADD 1 TO IX1 IXT END-PERFORM.
MA4.
MA5. PERFORM DSP-NEXT ACCEPT MA-OP LINE 1 COLUMN 73 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF MA-OP=0 GO MA3. IF MA-OP>4 PERFORM DSP-ERR1 GO MA5.
    IF MA-OP=1 AND MA-KFIN=1 PERFORM DSP-ERR56 GO MA3.
    IF (MA-OP=2 OR 3 OR 4) AND MA-KFIN=0 PERFORM DSP-ERR30 GO MA3.
    IF MA-OP=3 DELETE MATREL MOVE 0 TO MT-IXF GO MA8.
    IF MA-OP=4
      IF MT-IXF>0
        PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1=MT-IXF
          MOVE MT-FQTY(IX1 + 1) TO MT-FQTY(IX1) MOVE MT-FDATE(IX1 + 1) TO MT-FDATE(IX1)
          MOVE MT-FPERIOD(IX1 + 1) TO MT-FPERIOD(IX1) END-PERFORM
        MOVE 0 TO MT-FQTY(MT-IXF) MT-FDATE(MT-IXF) MOVE " " TO MT-FPERIOD(MT-IXF)
        SUBTRACT 1 FROM MT-IXF REWRITE MT-RECORD ALLOWING NO UNLOCK MATREL
        PERFORM MA-ADEM PERFORM MA-SDEM END-IF
      PERFORM RD108 PERFORM WRT DISPLAY MT-PLANT LINE 3 COLUMN 9 MT-PROD COLUMN 34
      GO MA33.

* op=1,2
    DISPLAY "- PF3 TO END" LINE 23 COLUMN 68 BOLD.
    IF MA-OP=1 MOVE SYS-DATE TO MT-DATE D-DATE PERFORM D-NM DISPLAY D-DT LINE 5 COLUMN 36.
    ACCEPT MT-REP LINE 5 COLUMN 13 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO MA70.
    MOVE MT-DATE TO D-DATE MOVE 5 TO IXT MOVE 36 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO MA70. MOVE DATE0 TO MT-DATE.
    REPLACE ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO MA70==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO MA70==.
    ACCEPT MT-STATUS LINE 6 COLUMN 18 ACC-ALP.
    ACCEPT MT-DOCK LINE 6 COLUMN 31 ACC-ALP.
    ACCEPT MT-LF LINE 6 COLUMN 54 ACC-ALP.
    ACCEPT MT-SOURCE LINE 8 COLUMN 10 ACC-ALP.
    ACCEPT MT-BFR-NUM LINE 8 COLUMN 42 ACC-ALP.
    ACCEPT MT-BFR-TYPE LINE 9 COLUMN 8 ACC-ALP.
    ACCEPT MT-BFR-SCHED LINE 9 COLUMN 28 ACC-ALP.
    ACCEPT MT-QTY-SHIP LINE 9 COLUMN 70 ACC-NUM.
    DISPLAY MT-QTY-SHIP LINE 9 COLUMN 70 CONVERSION.
    REPLACE OFF.

    MOVE MT-BFR-FDATE TO D-DATE MOVE 11 TO IXT MOVE 33 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO MA70. MOVE DATE0 TO MT-BFR-FDATE.
    MOVE MT-BFR-TDATE TO D-DATE MOVE 11 TO IXT MOVE 49 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO MA70. MOVE DATE0 TO MT-BFR-TDATE.
    MOVE MT-BFR-DATE TO D-DATE MOVE 11 TO IXT MOVE 74 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO MA70. MOVE DATE0 TO MT-BFR-DATE.
MA70. MOVE 14 TO IXT MOVE 1 TO IXCOL IX1.
MA73. COMPUTE IXU=(IXCOL - 1) * 21 + 1.
    ACCEPT MT-FQTY(IX1) LINE IXT COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO MA74.
    DISPLAY MT-FQTY(IX1) LINE IXT COLUMN IXU CONVERSION.
    MOVE MT-FDATE(IX1) TO D-DATE ADD 10 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO MA74. MOVE DATE0 TO MT-FDATE(IX1).
    ADD 1 TO IXCOL IF IXCOL>4 ADD 1 TO IXT MOVE 1 TO IXCOL.
    ADD 1 TO IX1 IF IX1<=16 GO MA73.
MA74. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>30
       IF MT-FDATE(IX1) NOT=0 MOVE "W" TO MT-FPERIOD(IX1) MOVE IX1 TO MT-IXF END-IF END-PERFORM.
    MOVE 1 TO IX1 MOVE 19 TO IXT PERFORM UNTIL IX1>5
      ACCEPT MT-IFLINE(IX1) LINE IXT COLUMN 22 DEFAULT CURRENT
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO MA76 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
MA76. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
       IF MT-IFLINE(IX1)>" " MOVE IX1 TO MT-IXI END-IF END-PERFORM.
    DISPLAY " " LINE 23 COLUMN 68 ERASE END LINE.
    IF MA-OP=1 WRITE MT-RECORD ALLOWING NO ELSE REWRITE MT-RECORD ALLOWING NO.
    UNLOCK MATREL PERFORM DSP-CONT.
MA8. PERFORM MA-ADEM GO MA3.
MA9. GO MN9.

* note 16.2
MA-SDEM. MOVE 0 TO MA-DEMAND MA-FDEMAND.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>MT-IXF
      IF MT-FDATE(A-X1)<=PRO-DEM-DATE SUBTRACT MT-FQTY(A-X1) FROM MA-DEMAND
        ELSE SUBTRACT MT-FQTY(A-X1) FROM MA-FDEMAND END-IF END-PERFORM.
MA-ADEM. PERFORM MA-AD1 THRU MA-AD9.
MA-AD1. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>MT-IXF
      IF MT-FDATE(A-X1)<=PRO-DEM-DATE ADD MT-FQTY(A-X1) TO MA-DEMAND
        ELSE ADD MT-FQTY(A-X1) TO MA-FDEMAND END-IF END-PERFORM.
    MOVE MT-PROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO MA-AD9.
    PERFORM RD-GEN PERFORM RDLK-PRODUCT ADD MA-DEMAND TO P-DEMAND ADD MA-FDEMAND TO P-FDEMAND.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
MA-AD9. EXIT.

* E-25 LINE FEED SUMMARY REPORT
MG1. PERFORM RD301 PERFORM WRT.
    ACCEPT MG-OP LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MG-OP=0 OR>1 GO MG1.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO DY-KEY START DAYREL KEY>DY-KEY REGARDLESS INVALID GO MG4.
MG3. READ DAYREL NEXT REGARDLESS END GO MG4. MOVE DY-TYPE TO ED-TYPE.
    IF NOT(MG-OP=1 AND ED-GMC) GO MG3.
    MOVE DY-PROD TO A-A1 PERFORM PROD-RT.
    IF DY-LF>" " MOVE DY-LF TO MG-LF ELSE MOVE "--------" TO MG-LF.
    PERFORM INIT-RP MOVE DY-PLANT TO RP-F167.
    MOVE MG-LF TO RP-F169 MOVE DY-PROD TO RP-F170 MOVE 1 TO IX1.
MG33. IF IX1>DY-IXF GO MG38. MOVE DY-FDATE(IX1) TO RP-F168.
    COMPUTE WN1=(DY-FQTY(IX1) + P-QTY-PACK - 1) / P-QTY-PACK SIZE ERROR MOVE 0 TO WN1.
    IF WN1=0 GO MG34. MOVE WN1 TO RP-F171.
    WRITE RP-RECORD INVALID READ REPFL ADD WN1 TO RP-F171 REWRITE RP-RECORD.
MG34. ADD 1 TO IX1 GO MG33.
MG38. GO MG3.

MG4. PERFORM OPEN-PR PERFORM MG-PAGE MOVE 0 TO MG-PTOT MG-DTOT MG-LTOT.
    MOVE " " TO MG-OPLANT MG-OLF MOVE 0 TO MG-ODATE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO MG9.
MG5. READ REPFL NEXT END GO MG9.
    IF RP-F167 NOT=MG-OPLANT
      IF MG-OPLANT>" " PERFORM MG-LT PERFORM MG-DT PERFORM MG-PT END-IF
      MOVE RP-F167 TO MG-OPLANT MOVE 0 TO MG-ODATE MOVE " " TO MG-OLF.
    IF RP-F168 NOT=MG-ODATE
      IF MG-ODATE NOT=0 PERFORM MG-LT PERFORM MG-DT END-IF
      MOVE RP-F168 TO MG-ODATE MOVE " " TO MG-OLF.
    IF RP-F169 NOT=MG-OLF
      IF MG-OLF>" " PERFORM MG-LT END-IF MOVE RP-F169 TO MG-OLF.
    ADD RP-F171 TO MG-PTOT MG-DTOT MG-LTOT.
    MOVE RP-F167 TO FF234 MOVE RP-F168 TO D-DATE PERFORM D-NM MOVE D-DT TO FF235.
    MOVE RP-F169 TO FF236 MOVE RP-F170 TO FF237 MOVE RP-F171 TO FF238.
    PERFORM MG-LINE GO MG5.
MG9. PERFORM MG-LT PERFORM MG-DT PERFORM MG-PT.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

MG-PT. MOVE "** PLANT TOTAL" TO PREC MOVE MG-PTOT TO FF239 MOVE "**" TO FF239A.
    PERFORM MG-LINE 5 TIMES MOVE 0 TO MG-PTOT.
MG-DT. MOVE "** DATE TOTAL" TO PREC(13:) MOVE MG-DTOT TO FF239 MOVE "*" TO FF239A.
    PERFORM MG-LINE 2 TIMES MOVE 0 TO MG-DTOT.
MG-LT. MOVE "** LF TOTAL" TO PREC(23:) MOVE MG-LTOT TO FF239.
    PERFORM MG-LINE 2 TIMES MOVE 0 TO MG-LTOT.
MG-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM MG-PAGE.
MG-PAGE. IF MG-OP=1 MOVE 3 TO A-N1.
    PERFORM SET-ENAME STRING A-A1 DELIMITED " "
      " LINE FEED SUMMARY REPORT" DELIMITED SIZE INTO FF3 PERFORM PR-PAGE.
    MOVE "PLANT         DATE    LF          PRODUCT      CARTONS    TOTAL" TO PREC PERFORM PR-LINE-3.
*         ..........  ../../..  ..........  ............   ...       ... ..

* E-26 DAILY RELEASE REPORT
RO1. PERFORM RD302 PERFORM WRT.
    ACCEPT RO-TYPE LINE 11 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF RO-TYPE=0 PERFORM DSP-ERR9 GO RO1.
    MOVE 13 TO IXT MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-PLANT-R.
    MOVE 14 TO IXT MOVE 16 TO IXU MOVE 46 TO IXV PERFORM AX-PROD-R.
    MOVE 16 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM RO-PAGE MOVE " " TO REL-OPLANT.

    MOVE " " TO DY-KEY START DAYREL KEY>DY-KEY REGARDLESS INVALID GO RO9.
RO3. READ DAYREL NEXT REGARDLESS END GO RO9.
    IF NOT(DY-TYPE=RO-TYPE AND (DY-PLANT>=PLANT1 AND<=PLANT2)
      AND (DY-PROD>=PROD1 AND<=PROD2)) GO RO3.
    IF DY-PLANT NOT=REL-OPLANT
      IF REL-OPLANT>" " PERFORM RO-PAGE END-IF MOVE DY-PLANT TO REL-OPLANT.
    MOVE DY-PLANT TO FG57 MOVE DY-PROD TO FG58 MOVE DY-ORD TO FG59.
    MOVE DY-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG60.
    MOVE DY-SCHEDULE TO FG61 MOVE DY-LF TO FG62.
    MOVE DY-BSS TO FG63 INSPECT FG63 REPLACING ALL DY-SEP BY ":" PERFORM RO-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>DY-IXL
      MOVE DY-LCODE(IX1) TO FG67(IX1) MOVE ":" TO FG68(IX1)
      MOVE DY-LVAL(IX1) TO FG69(IX1) END-PERFORM.
    PERFORM RO-LINE MOVE 1 TO IX1 PR-IXP.
RO33. IF IX1>DY-IXF GO RO34. MOVE DY-FQTY(IX1) TO FG65(PR-IXP).
    MOVE DY-FDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FG66(PR-IXP).
    ADD 1 TO IX1 PR-IXP IF PR-IXP>6 PERFORM RO-LINE MOVE 1 TO PR-IXP. GO RO33.
RO34. IF PR-IXP>1 PERFORM RO-LINE. MOVE 1 TO IX1 PR-IXP.
RO35. IF IX1>DY-IXI GO RO36.
    MOVE DY-IFLINE(IX1) TO FG70(PR-IXP) INSPECT FG70(PR-IXP) REPLACING ALL DY-SEP BY ":".
    ADD 1 TO IX1 PR-IXP IF PR-IXP>3 PERFORM RO-LINE MOVE 1 TO PR-IXP. GO RO35.
RO36. IF PR-IXP>1 PERFORM RO-LINE.
    PERFORM RO-LINE GO RO3.
RO9. PERFORM CLOSE-PR GO MN9.

RO-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RO-PAGE.
RO-PAGE. MOVE "DAILY RELEASE REPORT" TO FF3 MOVE RO-TYPE TO DSP-N21.
    STRING "(CUSTOMER AUTOMOTIVE CODE " DSP-N21 ")" DELIMITED SIZE INTO FF4.
    PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PLANT MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    MOVE "PLANT       PRODUCT    ORDER    DATE  SCHEDULE  LINE FEED   BSS" TO PREC PERFORM PR-LINE-3.
*         ..........  ........  ......  ../../..   ..     ..........  ............................................................
*              ..:..........  ..:.......... (x5)
*              ...,... ../../..   ...,... ../../.. (x6)

* E-27 PRODUCT LISTING BY HARMONY CODE
QW1. PERFORM RD304 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO QW29.
QW23. READ PRODUCT NEXT REGARDLESS END GO QW29.
    IF P-GEN=" " MOVE P-HCODE TO WN1 GO QW24. MOVE P-KEY TO PRO-NSV.
    MOVE P-GEN TO A-A1 PERFORM PROD-RT MOVE P-HCODE TO WN1.
    MOVE PRO-NSV TO P-KEY START PRODUCT REGARDLESS READ PRODUCT NEXT REGARDLESS.
QW24. PERFORM INIT-RP MOVE WN1 TO RP-F251 MOVE P-NO TO RP-F252.
    WRITE RP-RECORD GO QW23.
QW29. PERFORM OPEN-PR PERFORM QW-PAGE MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO QW9.
QW3. READ REPFL NEXT END GO QW9. IF RP-F251=OLD-N GO QW4.
    IF OLD-N NOT=-1 PERFORM QW-LINE 3 TIMES.
    MOVE "H.C." TO FA610 MOVE RP-F251 TO FA611 OLD-N A-N1.
    PERFORM DESC-HARM MOVE PRO-HARM TO FA612 PERFORM QW-LINE 2 TIMES.
QW4. MOVE RP-F252 TO FA613 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FA614(1).
    MOVE P-EDESC1 TO FA614(2) MOVE P-EDESC2 TO FA614(3) PERFORM QW-LINE GO QW3.
QW9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

QW-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QW-PAGE.
QW-PAGE. MOVE "PRODUCT LISTING BY HARMONY CODE" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PROD.
    MOVE "PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*         ............  ................................  ................................  ................................

* E-28 DAILY RELEASE FILE MAINTENANCE
EN1. PERFORM RD109 PERFORM WRT.
    ACCEPT EN-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR EN-SEL=99 GO EN9.
    GO EN2 EN6  DEPENDING EN-SEL. GO EN1.

EN2. INITIALIZE EN-PLANT EN-PROD EN-SEQ.
EN3. PERFORM RD110 PERFORM WRT.
    PERFORM INIT-DY MOVE "~" TO DY-SEP MOVE ALL "0" TO DY-ISA-KEY.
    DISPLAY EN-PLANT LINE 3 COLUMN 9 EN-PROD COLUMN 34 EN-SEQ COLUMN 57 CONVERSION.
    ACCEPT EN-PLANT LINE 3 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR EN-PLANT=ALL "9" GO EN59.
    ACCEPT EN-PROD LINE 3 COLUMN 34 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 GO EN59.
    ACCEPT EN-SEQ LINE 3 COLUMN 57 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    DISPLAY EN-SEQ LINE 3 COLUMN 57 CONVERSION.
    IF KPF4 GO EN59.
    MOVE EN-PLANT TO DY-PLANT DY-KPLANT MOVE EN-PROD TO DY-PROD DY-KPROD.
    MOVE EN-SEQ TO DY-SEQ.
    READ DAYREL REGARDLESS INVALID MOVE 0 TO EN-KFIN GO EN4. MOVE 1 TO EN-KFIN.

    DISPLAY DY-TYPE LINE 5 COLUMN 13 CONVERSION DY-ORD COLUMN 32 CONVERSION
      DY-SCHEDULE COLUMN 54.
    MOVE DY-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 6 COLUMN 17.
    DISPLAY DY-CUSORD LINE 6 COLUMN 40.
    DISPLAY DY-LF LINE 8 COLUMN 23 DY-DOCK COLUMN 51.
    MOVE 11 TO IXT MOVE 1 TO IXCOL.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>DY-IXF OR 20
      COMPUTE IXU=(IXCOL - 1) * 21 + 1 DISPLAY DY-FQTY(IX1) LINE IXT COLUMN IXU CONVERSION
      MOVE DY-FDATE(IX1) TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN IXU PLUS 10
      ADD 1 TO IXCOL IF IXCOL>4 ADD 1 TO IXT MOVE 1 TO IXCOL END-IF END-PERFORM.
EN4.
EN41. PERFORM DSP-NEXT ACCEPT EN-OP LINE 1 COLUMN 73 DEFAULT ZERO
       UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF EN-OP=0 GO EN3. IF EN-OP>3 PERFORM DSP-ERR1 GO EN41.
    IF EN-OP=1 AND EN-KFIN=1 PERFORM DSP-ERR56 GO EN3.
    IF (EN-OP=2 OR 3) AND EN-KFIN=0 PERFORM DSP-ERR30 GO EN3.
    IF EN-OP=3 DELETE DAYREL GO EN3.

* op=1,2
    DISPLAY "- PF3 TO END" LINE 17 COLUMN 68 BOLD.
    IF EN-OP=1 MOVE SYS-DATE TO DY-DATE D-DATE PERFORM D-NM DISPLAY D-DT LINE 6 COLUMN 17.
    ACCEPT DY-TYPE LINE 5 COLUMN 13 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO EN50.
    DISPLAY DY-TYPE LINE 5 COLUMN 13 CONVERSION.
    ACCEPT DY-ORD LINE 5 COLUMN 32 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO EN50.
    DISPLAY DY-ORD LINE 5 COLUMN 32 CONVERSION.
    ACCEPT DY-SCHEDULE LINE 5 COLUMN 54 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO EN50.
    MOVE DY-DATE TO D-DATE MOVE 6 TO IXT MOVE 17 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO EN50. MOVE DATE0 TO DY-DATE.
    ACCEPT DY-CUSORD LINE 6 COLUMN 40 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO EN50.
    ACCEPT DY-LF LINE 8 COLUMN 23 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO EN50.
    ACCEPT DY-DOCK LINE 8 COLUMN 51 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO EN50.
    MOVE DY-LABINF TO ED-LABINF.
    MOVE DY-LF TO ED-PKG11 MOVE DY-DOCK TO ED-PKG12.
    MOVE ED-LABINF TO DY-LABINF.
EN50. MOVE 11 TO IXT MOVE 1 TO IXCOL IX1.
EN53. COMPUTE IXU=(IXCOL - 1) * 21 + 1.
    ACCEPT DY-FQTY(IX1) LINE IXT COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO EN56.
    DISPLAY DY-FQTY(IX1) LINE IXT COLUMN IXU CONVERSION.
    MOVE DY-FDATE(IX1) TO D-DATE ADD 10 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO EN56. MOVE DATE0 TO DY-FDATE(IX1).
    ADD 1 TO IXCOL IF IXCOL>4 ADD 1 TO IXT MOVE 1 TO IXCOL.
    ADD 1 TO IX1 IF IX1<=20 GO EN53.
EN56. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>30
       IF DY-FDATE(IX1) NOT=0 MOVE IX1 TO DY-IXF END-IF END-PERFORM.
    IF EN-OP=1 WRITE DY-RECORD ALLOWING NO ELSE REWRITE DY-RECORD ALLOWING NO.
    UNLOCK DAYREL.
    DISPLAY " " LINE 17 COLUMN 68 ERASE END LINE.
    PERFORM DSP-CONT GO EN3.
EN59. GO EN9.

EN6.
EN61. PERFORM RD111 PERFORM WRT.
    DISPLAY "(RECORDS TO BE DELETED WILL BE FIRST DISPLAYED FOR CONFIRMATION)" LINE 7.
    ACCEPT EN-TYPE LINE 6 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO EN89.
    MOVE 6 TO IXT MOVE 42 TO IXU MOVE 4 TO D-PF PERFORM AX-DT-VAL IF KPF4 GO EN89.
    MOVE DATE0 TO EN-DATE.
    MOVE 6 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO EN89.
    DISPLAY "READING 'DAYREL' FILE ..." LINE 7 ERASE LINE.
    MOVE 8 TO IXT MOVE 1 TO IXCOL MOVE 0 TO EN-NUM PERFORM DSP-QWAIT.
    MOVE " " TO DY-KEY START DAYREL KEY>DY-KEY REGARDLESS INVALID GO EN64.
EN63. READ DAYREL NEXT REGARDLESS END GO EN64.
    IF NOT(DY-TYPE=EN-TYPE AND DY-DATE<EN-DATE) GO EN63.
    MOVE " " TO WA1 STRING DY-PLANT ":" DY-PROD DELIMITED " " INTO WA1.
    COMPUTE IXU=(IXCOL - 1) * 28 + 1 DISPLAY WA1(1:23) LINE IXT COLUMN IXU.
    ADD 1 TO IXCOL IF IXCOL>3 ADD 1 TO IXT IF IXT>23 MOVE 8 TO IXT END-IF MOVE 1 TO IXCOL.
    ADD 1 TO EN-NUM GO EN63.
EN64. PERFORM DSP-ERS.
    DISPLAY " " LINE 7 ERASE LINE " " LINE 22 ERASE END SCREEN.
    DISPLAY EN-NUM LINE 23 CONVERSION BOLD " RECORDS WILL BE DELETED" BOLD.
    DISPLAY "DELETE THESE RECORDS ? ___" LINE 23 COLUMN 45 BOLD.
    ACCEPT XA3 LINE 23 COLUMN 68 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3 NOT="YES" MOVE 0 TO EN-NUM GO EN88.

    MOVE 0 TO EN-NUM MOVE " " TO WA1 PERFORM DSP-QWAIT.
EN81. MOVE WA1 TO DY-KEY MOVE 0 TO EN-IXD.
    START DAYREL KEY>DY-KEY REGARDLESS INVALID GO EN84.
EN83. READ DAYREL NEXT REGARDLESS END GO EN84. MOVE DY-KEY TO WA1.
    IF NOT(DY-TYPE=EN-TYPE AND DY-DATE<EN-DATE) GO EN83.
    DELETE DAYREL ADD 1 TO EN-NUM.
    ADD 1 TO EN-IXD IF EN-IXD=100 CLOSE DAYREL OPEN I-O DAYREL ALLOWING ALL GO EN81.
    GO EN83.
EN84. PERFORM DSP-ERS.

EN88. DISPLAY EN-NUM LINE 23 CONVERSION BOLD " RECORDS WERE DELETED" BOLD ERASE LINE.
    PERFORM DSP-CONT GO EN61.
EN89. GO EN9.

EN9. GO MN9.

* C: PRODUCT COSTING FUNCTIONS

* C-1 CALCULATE INDIVIDUAL PRODUCT COST
JM1. PERFORM RDR-INFO PERFORM WRT132 MOVE " " TO JM-PROD.
JM3. PERFORM RD91 PERFORM WRT.
    ACCEPT JM-PROD LINE 1 COLUMN 47 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR JM-PROD=ALL "9" GO JM9.
    MOVE JM-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO JM3.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    PERFORM PROD-DESC PERFORM RD-GEN MOVE P-NO TO JM-PROD MOVE " " TO CST-ALT.
    IF GEN-IND=1 MOVE GEN-ALT TO CST-ALT
      DISPLAY "GENERIC:" LINE 1 COLUMN 65 BOLD JM-PROD COLUMN 74.
    MOVE 1 TO IX1 MOVE 2 TO IXT PERFORM UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      DISPLAY PRO-DESC(IX1) LINE IXT COLUMN 47 ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 121 TO IXU MOVE JM-PROD TO TS-PROD MOVE 0 TO TS-MAC.
    START TOOLS KEY>TS-KEY REGARDLESS INVALID GO JM34.
JM33. READ TOOLS NEXT REGARDLESS END GO JM34. IF TS-PROD NOT=JM-PROD GO JM34.
    DISPLAY TS-MAC LINE 1 COLUMN IXU CONVERSION ADD 3 TO IXU IF IXU<=130 GO JM33.
JM34. MOVE P-MAC TO JM-MAC DISPLAY JM-MAC LINE 1 COLUMN 101 CONVERSION.
    IF ITOOL GO JM36.
    ACCEPT JM-MAC LINE 1 COLUMN 101 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
    DISPLAY JM-MAC LINE 1 COLUMN 101 CONVERSION.
    MOVE JM-MAC TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO JM3.
    DISPLAY M-DESC1 LINE 2 COLUMN 101.

JM36. IF NOT(IFAST AND (JM-MAC=99 OR P-CAT=80) OR ITOOL OR INUT)
       MOVE JM-PROD TO TS-PROD MOVE JM-MAC TO TS-MAC
       READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO JM3.
    MOVE JM-PROD TO OP-PROD MOVE JM-MAC TO OP-MAC.
    READ OPERATIONS REGARDLESS INVALID PERFORM DSP-ERR27 GO JM3.
    IF ITOOL OR INUT GO JM38.

    MOVE 4 TO IXT MOVE 3 TO IXU MOVE 1 TO IX1.
    MOVE JM-PROD TO IO-KPROD MOVE " " TO IO-KCUS.
    START PRICE KEY>=IO-KP REGARDLESS INVALID GO JM364.
JM363. READ PRICE NEXT REGARDLESS END GO JM364. IF IO-KPROD NOT=JM-PROD GO JM364.
    DISPLAY IO-KCUS LINE IXT COLUMN IXU ADD 8 TO IXU ADD 1 TO IX1.
    IF IX1>4 MOVE 1 TO IX1 MOVE 3 TO IXU ADD 1 TO IXT IF IXT>9 GO JM364. GO JM363.
JM364.
JM37. ACCEPT JM-CUS LINE 10 COLUMN 15 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF JM-CUS=" " GO JM38.
    MOVE JM-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO JM37.
    MOVE JM-CUS TO IO-CUS MOVE JM-PROD TO IO-PROD.
    READ PRICE REGARDLESS INVALID PERFORM DSP-ERR45 GO JM37.
    IF IO-PRICE=0 PERFORM DSP-ERR45 GO JM37.
    MOVE IO-PRICE TO JM-PRICE DISPLAY JM-PRICE LINE 10 COLUMN 51 CONVERSION.
    MOVE " " TO JM-U IF C-US=1 MOVE "Y" TO JM-U DISPLAY JM-U LINE 10 COLUMN 70.
    MOVE 1 TO CST-KPRI PERFORM JM-P GO JM4.
JM38. ACCEPT JM-PRICE LINE 10 COLUMN 51 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF JM-PRICE=0 MOVE 0 TO CST-KPRI GO JM4. MOVE 1 TO CST-KPRI.
    DISPLAY "'Y' IF PRICE IS IN US$" LINE 24 BOLD.
    ACCEPT JM-U LINE 10 COLUMN 70 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    PERFORM JM-P.

JM4. MOVE 14 TO IXT MOVE 30 TO IXU DISPLAY JM-MAC LINE IXT COLUMN IXU CONVERSION.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)>0 ADD 4 TO IXU
        DISPLAY OP-OPER(IX1) LINE IXT COLUMN IXU CONVERSION END-IF END-PERFORM.
JM43. DISPLAY "LAST OPERATION TO INCLUDE IN COSTING (LEAVE BLANK TO INCLUDE ALL OPERATIONS)" LINE 24 BOLD.
    ACCEPT CST-LOP LINE 14 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF CST-LOP=0 MOVE -1 TO CST-LOP GO JM48.
    IF CST-LOP=JM-MAC MOVE JM-MAC TO CST-LOP GO JM48.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF CST-LOP=OP-OPER(IX1) GO JM48 END-IF END-PERFORM.
    MOVE "NOT FOUND IN OPERATIONS LIST" TO ERR-MESG PERFORM DSP-ERR GO JM43.
JM48.
JM53. MOVE 1 TO CST-MODE DISPLAY CST-MODE LINE 14 COLUMN 94 CONVERSION.
    ACCEPT CST-MODE LINE 14 COLUMN 94 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY CST-MODE LINE 14 COLUMN 94 CONVERSION.
    IF NOT(CST-MODE>=1 AND<=5) PERFORM DSP-ERR2 GO JM53.

    MOVE P-NUT TO CST-NUT IF GEN-NUT>" " MOVE GEN-NUT TO CST-NUT.
    MOVE JM-MAC TO CST-MAC MOVE 0 TO CST-KQ.
JM7. PERFORM DSP-QWAIT.
    IF CST-MODE=5 MOVE 0 TO CST-IXE MOVE 4 TO CST-MODE PERFORM COST-CALC
      MOVE CST-DFLDS TO CSV-DFLDS
      MOVE 0 TO CST-IXE MOVE 3 TO CST-MODE PERFORM COST-CALC
      PERFORM JM-SUB MOVE 5 TO CST-MODE
     ELSE MOVE 0 TO CST-IXE PERFORM COST-CALC.
    PERFORM DSP-ERS MOVE 1 TO CST-KDSP PERFORM COST-DISP.
    DISPLAY "PRESS ANY KEY TO CONTINUE, OR 1 - 5 FOR DIFFERENT CALCULATION MODE: _" LINE 24 BOLD ERASE LINE.
    ACCEPT CST-MODE LINE 24 COLUMN 69 DEFAULT ZERO
      UNDERLINED PROTECTED AUTOTERMINATE CONVERSION PERFORM DSP-ERS.
    IF NOT(CST-MODE>=1 AND<=5) GO JM3. GO JM7.
JM9. PERFORM WRT80 GO MN9.

JM-P. MOVE SYS-DATE TO D-DATE.
    IF JM-U="Y" MOVE JM-PRICE TO A-T1 PERFORM EXCHG-CONV MOVE A-T1 TO CST-PRICE
      ELSE MOVE JM-PRICE TO CST-PRICE.
JM-SUB. SUBTRACT CSV-M-TOT FROM CST-M-TOT SUBTRACT CSV-M-MAT FROM CST-M-MAT.
    SUBTRACT CSV-M-PROC FROM CST-M-PROC.
    SUBTRACT CSV-T-TOT FROM CST-T-TOT SUBTRACT CSV-T-FREIGHT FROM CST-T-FREIGHT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      SUBTRACT CSV-T-AMT(IX1) FROM CST-T-AMT(IX1) END-PERFORM
    SUBTRACT CSV-C-TOT FROM CST-C-TOT SUBTRACT CSV-C-TOOLS FROM CST-C-TOOLS.
    SUBTRACT CSV-C-CARTONS FROM CST-C-CARTONS.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      SUBTRACT CSV-C-AMT(IX1) FROM CST-C-AMT(IX1) END-PERFORM.
    SUBTRACT CSV-N-TOT FROM CST-N-TOT SUBTRACT CSV-OVERHEAD FROM CST-OVERHEAD.
    SUBTRACT CSV-DIRECT FROM CST-DIRECT SUBTRACT CSV-MFG FROM CST-MFG.

* C-2 UPDATE COST OF NUTS SHIPPED WITH BOLTS
AO1. PERFORM RD93 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9. PERFORM DSP-QWAIT.
    MOVE 1 TO CST-KN PERFORM COST-NUT PERFORM DSP-ERS PERFORM DSP-CONT.
AO9. GO MN9.

* C-3 INCREASE PRODUCT PRICE IN OUTSTANDING ORDERS
GF1. PERFORM RD261 PERFORM WRT.
    ACCEPT XA3 LINE 3 COLUMN 20 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO GF-KC ELSE MOVE 0 TO GF-KC.
    MOVE 0 TO GF-NUM MOVE 7 TO IXT.
GF13. ADD 1 TO GF-NUM IXT.
GF15. ACCEPT C-NO LINE IXT COLUMN 2 DEFAULT " " UNDERLINED PROTECTED.
    IF C-NO=" " SUBTRACT 1 FROM GF-NUM GO GF16. MOVE C-NO TO GF-CNO(GF-NUM).
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO GF15.
    DISPLAY C-NAME LINE IXT COLUMN 28.
    ACCEPT GF-CINC(GF-NUM) LINE IXT COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF GF-NUM<10 GO GF13.
GF16. MOVE 19 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM GF-PAGE MOVE " " TO OLD-C.

    INITIALIZE O-KC START SAORD KEY>O-KC REGARDLESS INVALID GO GF9.
GF3. READ SAORD NEXT REGARDLESS END GO GF9.
    PERFORM VARYING GF-IXC FROM 1 BY 1 UNTIL GF-IXC>GF-NUM
      IF O-CUS=GF-CNO(GF-IXC) GO GF32 END-IF END-PERFORM.
    GO GF3.
GF32. IF O-CUS=OLD-C GO GF4. IF OLD-C>" " PERFORM GF-PAGE.
    MOVE O-CUS TO OLD-C FD446 C-NO READ CUSTOMER REGARDLESS MOVE C-NAME TO FD447.
    PERFORM PR-LINE-2.
GF4. MOVE O-NO TO FD448.
    COMPUTE L-NO=100 * O-NO START SALIN KEY>L-KEY REGARDLESS INVALID GO GF6.
GF5. READ SALIN NEXT REGARDLESS END GO GF6. IF L-ORD NOT=O-NO GO GF6.
    MOVE L-LINE TO FD449.
    MOVE L-PROD TO FD450 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FD451.
    COMPUTE WV1 ROUNDED=1 + GF-CINC(GF-IXC) / 100.
    IF GF-KC=0 COMPUTE WD1 ROUNDED=L-PRICE * WV1
      ELSE COMPUTE WD1 ROUNDED=L-PRICE / WV1.
    MOVE L-PRICE TO FD452 MOVE WD1 TO L-PRICE FD453.
    IF L-QTY=LIT-Q9 MOVE LIT-BL TO FD454A ELSE MOVE L-QTY-LEFT TO FD454.
    PERFORM GF-LINE REWRITE L-RECORD ALLOWING NO UNLOCK SALIN GO GF5.
GF6. GO GF3.
GF9. PERFORM CLOSE-PR GO MN9.

GF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GF-PAGE.
GF-PAGE. MOVE "PRODUCT PRICE INCREASE IN OUTSTANDING ORDERS" TO FF3.
    IF GF-KC=1 MOVE "** CORRECTION RUN **" TO FF4. PERFORM PR-PAGE.
    MOVE " ORDER LINE  PRODUCT       DESCRIPTION                       OLD PRICE   NEW PRICE     QTY LEFT" TO PREC PERFORM PR-LINE-3.
*         ......  ..   ............  ................................   ....:...    ....:...  ...,...,...-

* C-4 PRODUCT PRICE FILE MAINTENANCE
HK1. OPEN I-O PRICEHIST ALLOWING ALL.
HK3. PERFORM RD282 PERFORM WRT.
    MOVE LOW-VALUES TO IO-RECORD INITIALIZE IO-REC MOVE SYS-DATE TO IO-DATE.
HK33. ACCEPT IO-CUS LINE 7 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 OR IO-CUS=ALL "9" GO HK9.
    MOVE IO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO HK33.
    IF C-US=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1.
    DISPLAY C-NAME LINE 7 COLUMN 26 LIT-CUR(IX1) COLUMN 60.
HK35. ACCEPT IO-PROD LINE 8 COLUMN 12 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 OR IO-PROD=ALL "9" GO HK9.
    MOVE IO-PROD TO P-NO READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO HK35.
    PERFORM PROD-DESC DISPLAY PRO-DESC(1) LINE 8 COLUMN 26.
    READ PRICE REGARDLESS INVALID MOVE 0 TO HK-KFIN GO HK4. MOVE 1 TO HK-KFIN.
    DISPLAY IO-PRICE LINE 13 COLUMN 9 CONVERSION IO-SUR COLUMN 44 CONVERSION
      IO-SURCH COLUMN 73 CONVERSION.
    DISPLAY IO-AUTH LINE 15 COLUMN 17.
    DISPLAY IO-NOTE LINE 16 COLUMN 8.
HK4. MOVE IO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO DSP-DT1 DISPLAY DSP-DT1 LINE 11 COLUMN 18.
HK5. PERFORM DSP-NEXT ACCEPT HK-OP LINE 3 COLUMN 54 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF HK-OP=0 GO HK3. IF HK-OP>3 PERFORM DSP-ERR1 GO HK5.
    IF HK-OP=1 AND HK-KFIN=1 MOVE "THIS CUSTOMER-PRODUCT ALREADY EXISTS"
      TO ERR-MESG PERFORM DSP-ERR GO HK3.
    IF (HK-OP=2 OR 3) AND HK-KFIN=0 PERFORM DSP-ERR30 GO HK3.
    MOVE IO-PRICE TO HK-PRICE MOVE IO-SUR TO HK-SUR MOVE IO-SURCH TO HK-SURCH.
    MOVE IO-NOTE TO HK-NOTE MOVE IO-AUTH TO HK-AUTH MOVE IO-DATE TO HK-DATE.
    IF HK-OP=3 PERFORM HK-HIS DELETE PRICE GO HK3.

* op=1,2
    ACCEPT IO-PRICE LINE 13 COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY IO-PRICE LINE 13 COLUMN 9 CONVERSION.
    ACCEPT IO-SUR LINE 13 COLUMN 44 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY IO-SUR LINE 13 COLUMN 44 CONVERSION.
    ACCEPT IO-SURCH LINE 13 COLUMN 73 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY IO-SURCH LINE 13 COLUMN 73 CONVERSION.
    ACCEPT IO-AUTH LINE 15 COLUMN 17 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT IO-NOTE LINE 16 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF HK-OP=1 MOVE IO-CUS TO IO-KCUS MOVE IO-PROD TO IO-KPROD.
    MOVE 0 TO HK-KH.
    IF HK-OP=2 AND NOT(IO-PRICE=HK-PRICE AND IO-SUR=HK-SUR AND IO-SURCH=HK-SURCH)
      MOVE SYS-DATE TO IO-DATE MOVE 1 TO HK-KH.
    IF HK-OP=1 WRITE IO-RECORD ALLOWING NO ELSE REWRITE IO-RECORD ALLOWING NO.
    UNLOCK PRICE IF HK-KH=1 PERFORM HK-HIS.
    PERFORM DSP-CONT GO HK3.
HK9. CLOSE PRICEHIST GO MN9.

* note 257
HK-HIS. MOVE LOW-VALUES TO NJ-RECORD INITIALIZE NJ-REC.
    MOVE IO-CUS TO NJ-CUS MOVE IO-PROD TO NJ-PROD MOVE SYS-DATE TO NJ-CDATE.
    MOVE HK-PRICE TO NJ-PRICE MOVE HK-SUR TO NJ-SUR MOVE HK-SURCH TO NJ-SURCH.
    MOVE HK-NOTE TO NJ-NOTE MOVE HK-AUTH TO NJ-AUTH MOVE HK-DATE TO NJ-DATE.
    WRITE NJ-RECORD ALLOWING NO INVALID REWRITE NJ-RECORD ALLOWING NO. UNLOCK PRICEHIST.

* C-5 SHOW PRODUCT PRICES BY CUSTOMER OR PRODUCT
HG1. PERFORM RD283 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MN9.
    IF Y1 PERFORM RD283A MOVE " " TO C-NO ELSE PERFORM RD283B MOVE " " TO P-NO.
    MOVE 3 TO IXT MOVE 0 TO INQ-IND.
HG3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
HG33. IF Y2 GO HG36.
    DISPLAY "NEXT CUSTOMER/PRODUCT ______/____________" LINE IXT.
    ACCEPT IA48 COLUMN 23 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA48=ALL "9" GO HG9.
    IF IA48>" " ACCEPT IA49 LINE IXT COLUMN 30 DEFAULT " " UNDERLINED PROTECTED EDITING
      ELSE IF INQ-IND=0 MOVE " " TO IA49.
    IF IA48=" " IF C-NO=" " GO HG33 ELSE GO HG4. MOVE IA48 TO C-NO.
    START CUSTOMER KEY>=C-KEY REGARDLESS INVALID PERFORM DSP-ERR5 GO HG33.
    READ CUSTOMER NEXT REGARDLESS.
    MOVE C-NO TO IO-CUS MOVE IA49 TO IO-PROD GO HG38.
HG36. DISPLAY "NEXT PRODUCT/CUSTOMER ____________/______" LINE IXT.
    ACCEPT IA49 COLUMN 23 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA49=ALL "9" GO HG9.
    IF IA49>" " ACCEPT IA48 LINE IXT COLUMN 36 DEFAULT " " UNDERLINED PROTECTED EDITING
      ELSE IF INQ-IND=0 MOVE " " TO IA48.
    IF IA49=" " IF P-NO=" " GO HG33 ELSE GO HG4. MOVE IA49 TO P-NO.
    START PRODUCT KEY>=P-KEY REGARDLESS INVALID PERFORM DSP-ERR6 GO HG33.
    READ PRODUCT NEXT REGARDLESS PERFORM PROD-DESC.
    MOVE P-NO TO IO-KPROD MOVE IA48 TO IO-KCUS.
HG38. MOVE 0 TO INQ-IND.

HG4. MOVE 4 TO IXT.
    IF Y1 PERFORM RD283A MOVE C-NO TO TF534(1) MOVE C-NAME TO TF535(1)
      IF INQ-IND=0 START PRICE KEY>=IO-KEY REGARDLESS INVALID GO HG8 END-START END-IF
     ELSE PERFORM RD283B MOVE P-NO TO TF536(1) MOVE PRO-DESC(1) TO TF537(1)
      IF INQ-IND=0 START PRICE KEY>=IO-KP REGARDLESS INVALID GO HG8 END-START.
* note 258.2
HG5. READ PRICE NEXT REGARDLESS END GO HG8. PERFORM CLR-LN.
    IF Y1 IF IO-CUS NOT=C-NO OR NOT(IA49=" " OR IO-PROD) GO HG8 END-IF
      MOVE IO-PROD TO TF538(IXT) A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO TF539(IXT)
     ELSE IF IO-PROD NOT=P-NO OR NOT(IA48=" " OR IO-CUS) GO HG8 END-IF
      MOVE IO-CUS TO TF538(IXT) A-A1 PERFORM RD-CUS MOVE C-NAME TO TF539(IXT).
    MOVE IO-PRICE TO TF540(IXT) IF C-US=1 MOVE "US" TO TF541(IXT).
    IF IO-SUR>0 MOVE IO-SUR TO TF541A(IXT). IF IO-SURCH>0 MOVE IO-SURCH TO TF541B(IXT).
    MOVE IO-AUTH TO TF542(IXT).
    MOVE IO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF543(IXT).
    ADD 1 TO IXT PERFORM CLR-LN MOVE IO-NOTE TO TF545(IXT).
    ADD 1 TO IXT IF IXT<22 GO HG5.
    MOVE "*** MORE ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO HG89.
HG8. MOVE "*** END ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 0 TO INQ-IND.
    IF Y2 GO HG82.
    READ CUSTOMER NEXT REGARDLESS END MOVE " " TO C-NO GO HG89.
    MOVE C-NO TO IO-CUS MOVE " " TO IO-PROD GO HG89.
HG82. READ PRODUCT NEXT REGARDLESS END MOVE " " TO P-NO GO HG89. PERFORM PROD-DESC.
    MOVE P-NO TO IO-KPROD MOVE " " TO IO-KCUS.
HG89. GO HG3.
HG9. GO MN9.

* C-6 SHOW PRODUCT PRICE HISTORY
HY1. OPEN I-O PRICEHIST ALLOWING ALL.
    PERFORM RD284 MOVE " " TO C-NO MOVE 4 TO IXT.
HY3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
HY33. DISPLAY "NEXT CUSTOMER/PRODUCT ______/____________" LINE IXT.
HY35. ACCEPT IA50 LINE IXT COLUMN 23 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 OR IA50=ALL "9" GO HY9.
    IF IA50=" " IF C-NO=" " GO HY33 ELSE GO HY4. MOVE IA50 TO C-NO.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO HY35.
HY37. ACCEPT P-NO LINE IXT COLUMN 30 DEFAULT " " UNDERLINED PROTECTED KEY CKEY.
    IF KPF4 OR P-NO=ALL "9" GO HY9.
    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6 GO HY37. PERFORM PROD-DESC.
    MOVE C-NO TO NJ-CUS MOVE P-NO TO NJ-PROD MOVE 0 TO NJ-CDATE INQ-IND.
HY4. PERFORM RD284 MOVE C-NO TO TF546(1) MOVE C-NAME TO TF547(1).
    MOVE P-NO TO TF546(2) MOVE PRO-DESC(1) TO TF547(2).
    MOVE 5 TO IXT IF INQ-IND=0 START PRICEHIST KEY>=NJ-KEY REGARDLESS INVALID GO HY8.
HY5. READ PRICEHIST NEXT REGARDLESS END GO HY8.
    IF NOT(NJ-CUS=C-NO AND NJ-PROD=P-NO) GO HY8.
    PERFORM CLR-LN MOVE NJ-CDATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF548(IXT).
    MOVE NJ-PRICE TO TF549(IXT) IF C-US=1 MOVE "US" TO TF550(IXT).
    IF NJ-SUR>0 MOVE NJ-SUR TO TF550A(IXT). IF NJ-SURCH>0 MOVE NJ-SURCH TO TF550B(IXT).
    MOVE NJ-AUTH TO TF551(IXT).
    MOVE NJ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF552(IXT).
    ADD 1 TO IXT PERFORM CLR-LN MOVE NJ-NOTE TO TF554(IXT).
    ADD 1 TO IXT IF IXT<21 GO HY5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO HY89.
HY8. MOVE "*** END ***" TO TLN(IXT) MOVE " " TO C-NO MOVE 0 TO INQ-IND.
HY89. GO HY3.
HY9. CLOSE PRICEHIST GO MN9.

* C-7 PRODUCT PRICE LISTING
HZ1. PERFORM RD382 PERFORM WRT.
HZ13. ACCEPT C-NO LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR C-NO=ALL "9" GO MN9.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO HZ13.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HZ-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE C-NO TO IO-CUS MOVE " " TO IO-PROD.
    START PRICE KEY>=IO-KEY REGARDLESS INVALID GO HZ9.
HZ3. READ PRICE NEXT REGARDLESS END GO HZ9. IF IO-CUS NOT=C-NO GO HZ9.
    MOVE IO-CUS TO EXP-A PERFORM EXPF MOVE IO-PROD TO EXP-A PERFORM EXPF.
    MOVE IO-PRICE TO EXP-T PERFORM EXPF.
    MOVE IO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    PERFORM EXP-LINE GO HZ3.
HZ9. PERFORM CLOSE-EXP GO MN9.

* C-11 QUOTATION ENTRY
AM1. MOVE 0 TO AM-PREV-NO.
AM3. PERFORM RD237 PERFORM WRT.
    DISPLAY "QUOTATION NO. REQUIRED ONLY TO MODIFY OR CANCEL AN EXISTING QUOTATION" LINE 24 BOLD.
    ACCEPT QO-NO LINE 1 COLUMN 44 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR QO-NO=999999 GO AM9.
    IF KPF1 IF AM-PREV-NO=0 GO AM4 ELSE MOVE AM-PREV-NO TO QO-NO GO AM32.
    IF QO-NO=0 GO AM4.
AM32. READ QUOTORD REGARDLESS INVALID PERFORM DSP-ERR35 GO AM3.
    MOVE QO-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 1 COLUMN 61.
    DISPLAY QO-CUS LINE 3 COLUMN 8 QO-NAME LINE 4 COLUMN 8
      QO-ADD1 LINE 5 COLUMN 8 QO-ADD2 LINE 6 COLUMN 8 QO-POST LINE 7 COLUMN 8.
    MOVE 1 TO IX1 MOVE 3 TO IXT PERFORM UNTIL IX1>3
      DISPLAY QO-INFO(IX1) LINE IXT COLUMN 50 ADD 1 TO IX1 IXT END-PERFORM.
    DISPLAY LIT-NY(QO-US + 1:1) LINE 8 COLUMN 13.
    DISPLAY QO-EXCH LINE 8 COLUMN 24 CONVERSION.
    MOVE 1 TO A-X1 MOVE 12 TO IXT PERFORM UNTIL A-X1>10
      DISPLAY QO-NOTE(A-X1) LINE IXT COLUMN 5 ADD 1 TO A-X1 IXT END-PERFORM.
    MOVE "'A' TO ADD LINE, 'MOD' TO MODIFY QUOTATION, 'CAN' TO CANCEL QUOTATION: ___" TO TMSG.
    PERFORM DSP-PROMPT IF XA3="A" MOVE QO-LINES TO AM-LINE GO AM48.
    IF XA3="MOD" GO AM6. IF XA3="CAN" PERFORM AM-DEL.
    GO AM3.

AM4.
AM41. PERFORM RD-INFO ADD 1 TO IF-QUOTNO PERFORM WR-INFO.
    MOVE LOW-VALUES TO QO-RECORD INITIALIZE QO-REC MOVE IF-QUOTNO TO QO-NO.
    READ QUOTORD REGARDLESS INVALID GO AM42. GO AM41.
AM42. MOVE QO-NO TO DSP-N61 DISPLAY DSP-N61 LINE 1 COLUMN 44.
    MOVE SYS-DATE TO D-DATE MOVE 1 TO IXT MOVE 61 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO QO-DATE.
    ACCEPT QO-CUS LINE 3 COLUMN 8 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF QO-CUS=" " GO AM44.
    MOVE QO-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO AM44.
    MOVE C-NAME TO QO-NAME MOVE C-ADD1 TO QO-ADD1 MOVE C-ADD2 TO QO-ADD2 MOVE C-POST TO QO-POST.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE C-INFO(IX1) TO QO-INFO(IX1) END-PERFORM.
    DISPLAY QO-NAME LINE 4 COLUMN 8 QO-ADD1 LINE 5 COLUMN 8
      QO-ADD2 LINE 6 COLUMN 8 QO-POST LINE 7 COLUMN 8.
    MOVE 1 TO IX1 MOVE 3 TO IXT PERFORM UNTIL IX1>3
      DISPLAY QO-INFO(IX1) LINE IXT COLUMN 50 ADD 1 TO IX1 IXT END-PERFORM.
AM44. DISPLAY LIT-NY(QO-US + 1:1) LINE 8 COLUMN 13.
    DISPLAY QO-EXCH LINE 8 COLUMN 24 CONVERSION.
    PERFORM AM-MOD-O WRITE QO-RECORD ALLOWING NO UNLOCK QUOTORD.
    MOVE 0 TO AM-LINE.
AM48.

AM5. PERFORM RD238 PERFORM WRT.
    MOVE QO-NO TO DSP-N61 COMPUTE DSP-N21=AM-LINE + 1.
    DISPLAY DSP-N61 LINE 1 COLUMN 16 DSP-N21 COLUMN 31.
AM51. MOVE LOW-VALUES TO QL-RECORD INITIALIZE QL-REC.
AM513. DISPLAY "PF4 TO END THIS QUOTATION" LINE 24 BOLD.
    ACCEPT QL-PROD LINE 4 COLUMN 16 DEFAULT " "
      UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO AM59. IF QL-PROD=" " PERFORM DSP-ERR2 GO AM513.
    IF AM-LINE=98 MOVE "QUOTATIONS CANNOT HAVE MORE THAN 98 LINES"
      TO ERR-MESG PERFORM DSP-ERR GO AM51.
    ACCEPT P-NO LINE 2 COLUMN 68 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF P-NO=" " GO AM52.

    READ PRODUCT REGARDLESS INVALID PERFORM DSP-ERR6
      DISPLAY "____________" LINE 2 COLUMN 68 GO AM51.
    PERFORM RD-GEN PERFORM PROD-DESC.
    MOVE P-DESC TO QL-DESC MOVE P-EDESC1 TO QL-EDESC1 MOVE P-EDESC2 TO QL-EDESC2.
    MOVE P-FINDESC TO QL-FINDESC MOVE P-PRDESC TO QL-PRDESC.
    MOVE P-CAT TO QL-CAT MOVE P-FAMILY TO QL-FAMILY MOVE P-MODE TO QL-MODE.
    MOVE P-PRICE1 TO QL-PRICE1 MOVE P-PRICE2 TO QL-PRICE2 MOVE P-COST TO QL-COST.
    MOVE P-MAC TO QL-MAC MOVE P-RATE TO QL-RATE MOVE P-WEIGHT TO QL-WEIGHT.
    MOVE P-GROSS TO QL-GROSS MOVE P-DIAM TO QL-DIAM MOVE P-GRADE TO QL-GRADE.
    MOVE P-PROC TO QL-PROC MOVE P-CLEAN TO QL-CLEAN MOVE P-PACKING TO QL-PACKING.
    MOVE P-QTY-PACK TO QL-QTY-PACK MOVE P-EST TO QL-EST.

    PERFORM GET-OP IF A-S1=1 GO AM518.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      MOVE OP-OPER(IX1) TO QL-OPER(IX1) MOVE OP-COST(IX1) TO QL-OPCOST(IX1)
      MOVE OP-CMODE(IX1) TO QL-CMODE(IX1) END-PERFORM.
AM518. GO AM54.

AM52. MOVE QO-NO TO AM-SAVNO MOVE QL-PROD TO AM-SAVPROD.
AM523. ACCEPT QO-NO LINE 3 COLUMN 68 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF QO-NO=0 DISPLAY "______" LINE 3 COLUMN 68
      MOVE AM-SAVNO TO QO-NO READ QUOTORD REGARDLESS GO AM54.
    READ QUOTORD REGARDLESS INVALID PERFORM DSP-ERR35 GO AM523.
    MOVE QO-NO TO QL-NO.
    ACCEPT QL-LINE LINE 3 COLUMN 75 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ QUOTLIN REGARDLESS INVALID PERFORM DSP-ERR36
      DISPLAY "__" LINE 3 COLUMN 75 GO AM523.
    MOVE AM-SAVPROD TO QL-PROD MOVE AM-SAVNO TO QO-NO READ QUOTORD REGARDLESS.

AM54. PERFORM AM-DSP-L PERFORM AM-MOD-L.
    MOVE "'CAN' TO CANCEL THIS LINE: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3 NOT="CAN" ADD 1 TO AM-LINE
      MOVE QO-NO TO QL-NO MOVE AM-LINE TO QL-LINE
      WRITE QL-RECORD ALLOWING NO UNLOCK QUOTLIN.
    GO AM5.

AM59. MOVE "'CAN' TO CANCEL ENTIRE QUOTATION: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="CAN" PERFORM AM-DEL
      ELSE MOVE QO-NO TO AM-PREV-NO MOVE AM-LINE TO QO-LINES
        REWRITE QO-RECORD ALLOWING NO UNLOCK QUOTORD.
    GO AM3.

AM6. MOVE "'L' TO MODIFY LINES ONLY: _" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="L" GO AM68.
    MOVE QO-DATE TO D-DATE MOVE 1 TO IXT MOVE 61 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO QO-DATE.
    ACCEPT QO-CUS LINE 3 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM AM-MOD-O.
AM68. REWRITE QO-RECORD ALLOWING NO UNLOCK QUOTORD.
    MOVE QO-NO TO QL-NO MOVE 0 TO QL-LINE.
AM7. ADD 1 TO QL-LINE READ QUOTLIN REGARDLESS INVALID GO AM79.
    IF QL-DEL=1 GO AM7.
    PERFORM RD238 PERFORM WRT.
    DISPLAY " " LINE 2 COLUMN 38 ERASE END LINE.
    DISPLAY " " LINE 3 COLUMN 38 ERASE END LINE.
    MOVE QL-NO TO DSP-N61 MOVE QL-LINE TO DSP-N21.
    DISPLAY DSP-N61 LINE 1 COLUMN 16 DSP-N21 COLUMN 31.
    DISPLAY QL-PROD LINE 4 COLUMN 16 PERFORM AM-DSP-L.
    DISPLAY "'RETURN' FOR NEXT LINE, 'E' TO END ORDER," LINE 23 BOLD.
    MOVE "  OR 'M' TO MODIFY LINE, 'CAN' TO CANCEL LINE: ___" TO TMSG.
    PERFORM DSP-PROMPT DISPLAY " " LINE 23 ERASE LINE.
    IF XA3="E" GO AM79. IF XA3="M" GO AM74. IF XA3="CAN" MOVE 1 TO QL-DEL GO AM78.
    GO AM7.
AM74. ACCEPT QL-PROD LINE 4 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM AM-MOD-L.
AM78. REWRITE QL-RECORD ALLOWING NO UNLOCK QUOTLIN GO AM7.
AM79. MOVE QO-NO TO AM-PREV-NO GO AM3.
AM9. GO MN9.

AM-MOD-O. PERFORM AM-MO1 THRU AM-MO9.
AM-MO1. ACCEPT QO-NAME LINE 4 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT QO-ADD1 LINE 5 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT QO-ADD2 LINE 6 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT QO-POST LINE 7 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 1 TO IX1 MOVE 3 TO IXT PERFORM UNTIL IX1>3
      ACCEPT QO-INFO(IX1) LINE IXT COLUMN 50 DEFAULT CURRENT
        UNDERLINED PROTECTED EDITING ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 8 TO IXT MOVE 13 TO IXU MOVE QO-US TO A-S1 PERFORM AX-NY MOVE A-S1 TO QO-US.
    IF QO-US=0 MOVE 0 TO QO-EXCH ELSE PERFORM RDR-INFO
      MOVE SYS-DATE TO D-DATE PERFORM EXCHG-RD MOVE A-V1 TO QO-EXCH.
    DISPLAY QO-EXCH LINE 8 COLUMN 24 CONVERSION.
    ACCEPT QO-EXCH LINE 8 COLUMN 24 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY QO-EXCH LINE 8 COLUMN 24 CONVERSION.
AM-MO3. MOVE 1 TO IX1 MOVE 12 TO IXT.
AM-MO5. PERFORM DSP-PF13.
    ACCEPT QO-NOTE(IX1) LINE IXT COLUMN 5 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    PERFORM DSP-ERS IF KPF1 GO AM-MO3 ELSE IF KPF3 GO AM-MO4.
    ADD 1 TO IX1 IXT IF IX1<=10 GO AM-MO5.
AM-MO4.
AM-MO9. EXIT.
AM-DSP-L. PERFORM AM-DL1 THRU AM-DL9.
AM-DL1. DISPLAY QL-DESC LINE 5 COLUMN 16 QL-EDESC1 LINE 6 COLUMN 16
      QL-EDESC2 LINE 7 COLUMN 16 QL-FINDESC LINE 8 COLUMN 16 QL-PRDESC LINE 9 COLUMN 16.
    DISPLAY QL-CAT LINE 11 COLUMN 12 CONVERSION QL-FAMILY COLUMN 27 CONVERSION
      QL-MODE COLUMN 46.
    DISPLAY QL-PRICE1 LINE 12 COLUMN 11 CONVERSION QL-PRICE2 COLUMN 31 CONVERSION
      QL-COST LINE 13 COLUMN 8 CONVERSION.
    DISPLAY QL-MAC LINE 14 COLUMN 11 CONVERSION QL-RATE COLUMN 35 CONVERSION.
    DISPLAY QL-WEIGHT LINE 15 COLUMN 10 CONVERSION QL-GROSS COLUMN 36 CONVERSION.
    DISPLAY QL-DIAM LINE 16 COLUMN 12 QL-GRADE COLUMN 29.
    DISPLAY QL-PROC LINE 17 COLUMN 16 CONVERSION QL-CLEAN COLUMN 37 CONVERSION.
    DISPLAY QL-PACKING LINE 18 COLUMN 16 CONVERSION QL-QTY-PACK COLUMN 35 CONVERSION.
    DISPLAY QL-EST LINE 19 COLUMN 18 CONVERSION QL-DELIVERY LINE 20 COLUMN 24 CONVERSION.
    MOVE 1 TO AM-IXL MOVE 6 TO IXT.
AM-DL7. DISPLAY QL-OPER(AM-IXL) LINE IXT COLUMN 53 CONVERSION.
    DISPLAY QL-OPCOST(AM-IXL) LINE IXT COLUMN 58 CONVERSION.
    DISPLAY QL-CMODE(AM-IXL) LINE IXT COLUMN 68.
    PERFORM AM-DSP-M ADD 1 TO AM-IXL IXT IF AM-IXL<=12 GO AM-DL7.
AM-DL9. EXIT.
AM-MOD-L. PERFORM AM-ML1 THRU AM-ML9.
AM-ML1.
    REPLACE ==CHK-KPF== BY ==IF KPF1 GO AM-ML3 ELSE IF KPF3 GO AM-ML4==
            ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY==.
AM-ML3. PERFORM DSP-PF13.
    ACCEPT QL-DESC LINE 5 COLUMN 16 ACC-ALP CHK-KPF.
    ACCEPT QL-EDESC1 LINE 6 COLUMN 16 ACC-ALP CHK-KPF.
    ACCEPT QL-EDESC2 LINE 7 COLUMN 16 ACC-ALP CHK-KPF.
    ACCEPT QL-FINDESC LINE 8 COLUMN 16 ACC-ALP CHK-KPF.
    ACCEPT QL-PRDESC LINE 9 COLUMN 16 ACC-ALP CHK-KPF.
    ACCEPT QL-CAT LINE 11 COLUMN 12 ACC-NUM.
    DISPLAY QL-CAT LINE 11 COLUMN 12 CONVERSION CHK-KPF.
    ACCEPT QL-FAMILY LINE 11 COLUMN 27 ACC-NUM.
    DISPLAY QL-FAMILY LINE 11 COLUMN 27 CONVERSION CHK-KPF.
    ACCEPT QL-MODE LINE 11 COLUMN 46 ACC-ALP CHK-KPF.
    ACCEPT QL-PRICE1 LINE 12 COLUMN 11 ACC-NUM.
    DISPLAY QL-PRICE1 LINE 12 COLUMN 11 CONVERSION CHK-KPF.
    ACCEPT QL-PRICE2 LINE 12 COLUMN 31 ACC-NUM.
    DISPLAY QL-PRICE2 LINE 12 COLUMN 31 CONVERSION CHK-KPF.
    ACCEPT QL-COST LINE 13 COLUMN 8 ACC-NUM.
    DISPLAY QL-COST LINE 13 COLUMN 8 CONVERSION CHK-KPF.
    ACCEPT QL-MAC LINE 14 COLUMN 11 ACC-NUM.
    DISPLAY QL-MAC LINE 14 COLUMN 11 CONVERSION CHK-KPF.
    ACCEPT QL-RATE LINE 14 COLUMN 35 ACC-NUM.
    DISPLAY QL-RATE LINE 14 COLUMN 35 CONVERSION CHK-KPF.
    ACCEPT QL-WEIGHT LINE 15 COLUMN 10 ACC-NUM.
    DISPLAY QL-WEIGHT LINE 15 COLUMN 10 CONVERSION CHK-KPF.
    ACCEPT QL-GROSS LINE 15 COLUMN 36 ACC-NUM.
    DISPLAY QL-GROSS LINE 15 COLUMN 36 CONVERSION CHK-KPF.
    ACCEPT QL-DIAM LINE 16 COLUMN 12 ACC-ALP CHK-KPF.
    ACCEPT QL-GRADE LINE 16 COLUMN 29 ACC-ALP CHK-KPF.
    ACCEPT QL-PROC LINE 17 COLUMN 16 ACC-NUM.
    DISPLAY QL-PROC LINE 17 COLUMN 16 CONVERSION CHK-KPF.
    ACCEPT QL-CLEAN LINE 17 COLUMN 37 ACC-NUM.
    DISPLAY QL-CLEAN LINE 17 COLUMN 37 CONVERSION CHK-KPF.
    ACCEPT QL-PACKING LINE 18 COLUMN 16 ACC-NUM.
    DISPLAY QL-PACKING LINE 18 COLUMN 16 CONVERSION CHK-KPF.
    ACCEPT QL-QTY-PACK LINE 18 COLUMN 35 ACC-NUM.
    DISPLAY QL-QTY-PACK LINE 18 COLUMN 35 CONVERSION CHK-KPF.
    ACCEPT QL-EST LINE 19 COLUMN 18 ACC-NUM.
    DISPLAY QL-EST LINE 19 COLUMN 18 CONVERSION CHK-KPF.
    ACCEPT QL-DELIVERY LINE 20 COLUMN 24 ACC-NUM.
    DISPLAY QL-DELIVERY LINE 20 COLUMN 24 CONVERSION CHK-KPF.
AM-ML4. PERFORM DSP-ERS.
    REPLACE OFF.
AM-ML5. MOVE 1 TO AM-IXL MOVE 6 TO IXT.
AM-ML7. PERFORM DSP-PF13.
    ACCEPT QL-OPER(AM-IXL) LINE IXT COLUMN 53 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY.
    PERFORM DSP-ERS DISPLAY QL-OPER(AM-IXL) LINE IXT COLUMN 53 CONVERSION.
    PERFORM AM-DSP-M IF KPF1 GO AM-ML5 ELSE IF KPF3 GO AM-ML8.
    ACCEPT QL-OPCOST(AM-IXL) LINE IXT COLUMN 58 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY QL-OPCOST(AM-IXL) LINE IXT COLUMN 58 CONVERSION.
    ACCEPT QL-CMODE(AM-IXL) LINE IXT COLUMN 68 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ADD 1 TO AM-IXL IXT IF AM-IXL<=12 GO AM-ML7.
AM-ML8.
AM-ML9. EXIT.
AM-DSP-M. PERFORM AM-DM1 THRU AM-DM9.
AM-DM1. IF QL-OPER(AM-IXL)=0 MOVE " " TO AM-OPDESC GO AM-DM8.
    MOVE QL-OPER(AM-IXL) TO M-NO READ MACHINE REGARDLESS INVALID
      MOVE "*** ERROR" TO AM-OPDESC GO AM-DM8.
    MOVE M-OPDESC TO AM-OPDESC.
AM-DM8. DISPLAY AM-OPDESC LINE IXT COLUMN 71.
AM-DM9. EXIT.
AM-DEL. PERFORM AM-DEL1 THRU AM-DEL9.
AM-DEL1. DELETE QUOTORD MOVE QO-NO TO QL-NO MOVE 0 TO QL-LINE.
AM-DEL3. ADD 1 TO QL-LINE READ QUOTLIN REGARDLESS INVALID GO AM-DEL4.
    DELETE QUOTLIN GO AM-DEL3.
AM-DEL4.
AM-DEL9. EXIT.

* C-12 CALCULATE AND PRINT QUOTATIONS
BS1. PERFORM RD243 PERFORM WRT.
    MOVE 3 TO IXT MOVE 18 TO IXU MOVE 45 TO IXV PERFORM AX-QUOT-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR WRITE PREC AFTER PAGE.

    MOVE QUOT1 TO QO-NO START QUOTORD KEY>=QO-KEY REGARDLESS INVALID GO BS9.
BS3. READ QUOTORD NEXT REGARDLESS END GO BS9. IF QO-NO>QUOT2 GO BS9.
    PERFORM BS-PAGE MOVE QO-NO TO QL-NO MOVE 0 TO QL-LINE.
BS5. ADD 1 TO QL-LINE READ QUOTLIN REGARDLESS INVALID GO BS6. IF QL-DEL=1 GO BS5.
    PERFORM SET-QUOTPROD.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE 0 TO CST-IXE MOVE QL-MAC TO CST-MAC MOVE " " TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI MOVE 1 TO CST-KQ CST-MODE PERFORM COST-CALC.
    MOVE CST-MFG TO QL-COST REWRITE QL-RECORD ALLOWING NO UNLOCK QUOTLIN.
    MOVE QL-LINE TO FA774 MOVE QL-PROD TO FA775 MOVE QL-DESC TO FA776.
    MOVE QL-GRADE TO FA777 MOVE QL-FINDESC TO FA778 MOVE QL-EST TO FA779.
    MOVE QL-COST TO FA780 COMPUTE FA781 ROUNDED=QL-WEIGHT * 10.
    MOVE QL-DELIVERY TO FA782 IF CST-IXE>0 MOVE "*" TO FA783.
    PERFORM BS-LINE GO BS5.
BS6. PERFORM BS-LINE 3 TIMES.
    MOVE "NOTES:" TO PREC PERFORM BS-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      IF QO-NOTE(IX1)>" " MOVE "-" TO FA796 MOVE QO-NOTE(IX1) TO FA797
        PERFORM BS-LINE END-IF END-PERFORM.
    WRITE PREC AFTER PAGE.

    MOVE QO-NO TO QL-NO MOVE 0 TO QL-LINE.
BS7. ADD 1 TO QL-LINE READ QUOTLIN REGARDLESS INVALID GO BS8. IF QL-DEL=1 GO BS7.
    PERFORM SET-QUOTPROD.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE 0 TO CST-IXE MOVE QL-MAC TO CST-MAC MOVE " " TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI MOVE 1 TO CST-KQ CST-MODE PERFORM COST-CALC.
    MOVE 0 TO CST-KDSP PERFORM COST-DISP PERFORM TL-REP-SCRN.
    PERFORM VARYING IXT FROM 1 BY 1 UNTIL IXT>19
      MOVE TLNW(IXT) TO PREC PERFORM PR-LINE END-PERFORM.
    WRITE PREC AFTER PAGE GO BS7.
BS8. GO BS3.
BS9. PERFORM CLOSE-PR GO MN9.

BS-LINE. PERFORM PR-LINE IF WS-LINES>58
      MOVE 2 TO WS-PR MOVE "CONTINUED ..." TO PREC PERFORM PR-LINE
      WRITE PREC AFTER PAGE PERFORM BS-PAGE PERFORM PR-LINE.
BS-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 1 TO WS-PR.
    MOVE WS-DIV-NAME TO PREC PERFORM PR-LINE-2.
    MOVE "Q U O T A T I O N" TO PREC PERFORM PR-LINE-3.
    MOVE QO-CUS TO FA787 PERFORM PR-LINE.
    MOVE QO-NAME TO FA787 MOVE QO-INFO(1) TO FA788.
    MOVE "QUOTATION NO.:" TO FA790 MOVE QO-NO TO FA791.
    MOVE "   DATE:" TO FA792 MOVE QO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA793.
    PERFORM PR-LINE.
    MOVE QO-ADD1 TO FA787 MOVE QO-INFO(2) TO FA788.
    MOVE "PRINTED:" TO FA792 MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA793.
    PERFORM PR-LINE.
    MOVE QO-ADD2 TO FA787 MOVE QO-INFO(3) TO FA788 PERFORM PR-LINE.
    MOVE QO-POST TO FA787 PERFORM PR-LINE-3.
    MOVE "    PRODUCT       DESCRIPTION                       GRADE     FINISH                       EST QTY  PRICE/M    WT/M  DELIV       ERR" TO PREC PERFORM PR-LINE.
    MOVE "------------------------------------------------------------------------------------------------------------------------------------" TO PREC PERFORM PR-LINE.
*         ..  ............  ................................  ........  ......................... ..,...,... ....:...  ....:..  ..          .
*         ................................     ..............................     ..............  .....     ........ ../../..

* C-13 CALCULATE INDIVIDUAL LINE COST
JN1. PERFORM WRT132.
JN3. PERFORM RD236 PERFORM WRT.
JN33. ACCEPT QO-NO LINE 3 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR QO-NO=999999 GO JN9.
    READ QUOTORD REGARDLESS INVALID PERFORM DSP-ERR35 GO JN33.
    DISPLAY QO-NAME LINE 5.
    MOVE QO-NO TO QL-NO.
    ACCEPT QL-LINE LINE 3 COLUMN 34 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    READ QUOTLIN REGARDLESS INVALID PERFORM DSP-ERR36
      DISPLAY "__" LINE 3 COLUMN 34 GO JN33.
    DISPLAY QL-PROD LINE 3 COLUMN 41 QL-DESC LINE 4 COLUMN 41.
    MOVE 5 TO IXT PERFORM AX-OKW IF XA2 NOT="OK" GO JN3.
    PERFORM DSP-QWAIT PERFORM SET-QUOTPROD MOVE " " TO CST-ALT.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE 0 TO CST-IXE MOVE QL-MAC TO CST-MAC MOVE " " TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI MOVE 1 TO CST-KQ CST-MODE PERFORM COST-CALC PERFORM DSP-ERS.
    MOVE 1 TO CST-KDSP PERFORM COST-DISP PERFORM DSP-CONT GO JN3.
JN9. PERFORM WRT80 GO MN9.

* C-14 UPDATE QUOTATION COSTING FILE
BL1. PERFORM RD274 PERFORM WRT.
    MOVE 3 TO IXT MOVE 18 TO IXU MOVE 45 TO IXV PERFORM AX-QUOT-R.
    MOVE 4 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT.
    MOVE QUOT1 TO QO-NO START QUOTORD KEY>=QO-KEY REGARDLESS INVALID GO BL9.
BL3. READ QUOTORD NEXT REGARDLESS END GO BL9. IF QO-NO>QUOT2 GO BL9.
    MOVE QO-NO TO QL-NO MOVE 0 TO QL-LINE.
BL5. ADD 1 TO QL-LINE READ QUOTLIN REGARDLESS INVALID GO BL8. IF QL-DEL=1 GO BL5.
    PERFORM SET-QUOTPROD.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE 0 TO CST-IXE MOVE QL-MAC TO CST-MAC MOVE " " TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI MOVE 1 TO CST-KQ CST-MODE PERFORM COST-CALC GO BL5.
BL8. GO BL3.
BL9. GO MN9.

* F: FINANCIALS FUNCTIONS

* F-1 PROCESS CASH RECEIPTS
CS1. PERFORM RD13 PERFORM WRT PERFORM OPEN-AUDIT PERFORM OPEN-TRAUDIT.
    PERFORM AX-AR-DATE PERFORM AX-US.
    DISPLAY LIT-CUR(USD-IND + 1) LINE 1 COLUMN 19 REVERSED.
CS3. PERFORM RD13A PERFORM WRT.
CS33. ACCEPT C-NO LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR C-NO=ALL "9" GO CS9.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO CS33.
    IF C-US NOT=USD-IND MOVE "CURRENCY MISMATCH" TO ERR-MESG
      PERFORM DSP-OK IF XA2 NOT="OK" GO CS3.
    DISPLAY C-NAME LINE 3 COLUMN 25 LIT-CUR(C-US + 1) COLUMN 60 BOLD.
CS35. PERFORM RD13B PERFORM WRT INITIALIZE TD-INP-R3.
    MOVE C-NO TO IE31 MOVE C-US TO IE37.
CS37. ACCEPT IE32 LINE 6 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO CS8. IF IE32=0 PERFORM DSP-ERR2 GO CS37.
    PERFORM INIT-TR MOVE IE31 TO TR-CUS MOVE IE32 TO TR-INV.
    ACCEPT IE35 LINE 6 COLUMN 60 DEFAULT " " UNDERLINED PROTECTED.
    IF IE35="YES" MOVE 1 TO CS-KNEW ELSE MOVE 0 TO CS-KNEW.
    IF CS-KNEW=1 READ TRANS REGARDLESS KEY TR-KI INVALID GO CS4 END-READ
      MOVE "THIS INVOICE NUMBER ALREADY EXISTS" TO ERR-MESG PERFORM DSP-ERR GO CS37.
    READ TRANS REGARDLESS KEY TR-KI INVALID PERFORM DSP-ERR19 GO CS37.
    IF TR-CUS NOT=C-NO PERFORM DSP-ERR19 GO CS37. MOVE TR-AMT TO CS-DF2.
    DISPLAY "INVOICE BALANCE:" LINE 8 COLUMN 41 BOLD CS-DF2 CONVERSION BOLD.
CS4. ACCEPT IE33 LINE 8 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    COMPUTE CS-AMT=-IE33 IF CS-KNEW=0 GO CS48.
    MOVE IE32 TO TR-BINV MOVE WS-EFF-DATE TO TR-DATE.
    PERFORM RD13C PERFORM WRT.
    IF NOT INUT
      ACCEPT TR-BL LINE 10 COLUMN 61 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      ACCEPT TR-ORD LINE 11 COLUMN 52 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      GO CS46.
    MOVE TR-INV TO TR-BL DISPLAY TR-BL LINE 10 COLUMN 61 CONVERSION.
CS45. ACCEPT TR-BL LINE 10 COLUMN 61 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY TR-BL LINE 10 COLUMN 61 CONVERSION.
    IF TR-BL=0 PERFORM DSP-ERR2 GO CS45.
    MOVE TR-INV TO TR-ORD DISPLAY TR-ORD LINE 11 COLUMN 52 CONVERSION.
    ACCEPT TR-ORD LINE 11 COLUMN 52 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY TR-ORD LINE 11 COLUMN 52 CONVERSION.
CS46. ACCEPT TR-CUSORD LINE 12 COLUMN 57 DEFAULT " " UNDERLINED PROTECTED.
    GO CS6.
CS48. COMPUTE WD1=TR-AMT + CS-AMT IF NOT(WD1 NOT=0 AND>-1 AND<1) GO CS6. MOVE WD1 TO CS-DF1.
    DISPLAY "WRITE OFF DIFFERENCE OF " LINE 14 COLUMN 41 BOLD CS-DF1 BOLD " ? ___" BOLD.
    ACCEPT XA3 LINE 14 COLUMN 74 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE WD1 TO IE34 COMPUTE IE33=TR-AMT COMPUTE CS-AMT=-IE33.
CS6. ADD CS-AMT TO TR-AMT PERFORM SET-TRDATE MOVE WS-EFF-DATE TO TR-DATE-PAY IE36.
    PERFORM RDLK-CUSTOMER MOVE CS-AMT TO A-D1 PERFORM UPDATE-CUST-BAL.
    IF CS-KNEW=0 PERFORM UPDATE-CUST-PAY.
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER.
    IF CS-KNEW=1 WRITE TR-RECORD ALLOWING NO ELSE REWRITE TR-RECORD ALLOWING NO.
    UNLOCK TRANS.
    MOVE 1 TO A-N1 IF CS-AMT>0 OR CS-KNEW=1 MOVE 2 TO A-N1.
    MOVE TR-DATE-PAY TO A-N2 MOVE CS-AMT TO A-D1 PERFORM ADD-TRAUD.
* note 150.2
    MOVE TD-INP-R3 TO AU-DATA MOVE 3 TO AU-K PERFORM ADD-AUD GO CS35.
CS8. GO CS3.
CS9. CLOSE AUDIT TRAUDIT GO MN9.

* F-2 SHOW INVOICES BY B/L NUMBER
LI1. PERFORM RD59 MOVE 0 TO LI-BLNO MOVE 3 TO IXT.
LI3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
LI33. DISPLAY "NEXT B/L NO.: _______" LINE IXT BOLD.
    ACCEPT LI-BL COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR LI-BL=9999999 GO LI9.
    IF LI-BL=0 IF LI-BLNO=0 GO LI33 ELSE GO LI4. MOVE LI-BL TO LI-BLNO.
    MOVE LI-BLNO TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID PERFORM DSP-ERR47 GO LI33.
    READ TRANS NEXT REGARDLESS IF TR-BL NOT=LI-BLNO PERFORM DSP-ERR47 GO LI33.
    MOVE 0 TO TR-BINV INQ-IND LI-TOT(1) LI-TOT(2).
LI4. PERFORM RD59 MOVE LI-BLNO TO TF405(1).
    MOVE 4 TO IXT IF INQ-IND=0 START TRANS KEY>TR-KB REGARDLESS INVALID GO LI8.
LI5. READ TRANS NEXT REGARDLESS END GO LI8. IF TR-BL NOT=LI-BLNO GO LI8.
    IF IXT>4 GO LI6. MOVE TR-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO LI6.
    MOVE C-NO TO TF406(1) MOVE C-NAME TO TF407(1).
LI6. PERFORM CLR-LN MOVE TR-INV TO TF408(IXT) MOVE TR-ORD TO TF409(IXT).
    MOVE TR-CUSORD TO TF410(IXT).
    MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF411(IXT).
    MOVE TR-AMT TO TF412(IXT) MOVE TR-AMT-ORIG TO TF413(IXT).
    ADD TR-AMT TO LI-TOT(1) ADD TR-AMT-ORIG TO LI-TOT(2).
    ADD 1 TO IXT IF IXT<22 GO LI5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO LI89.
LI8. PERFORM CLR-LN MOVE "!** TOTALS:" TO TF414(IXT).
    MOVE LI-TOT(1) TO TF412(IXT) MOVE LI-TOT(2) TO TF413(IXT).
    MOVE "]" TO TF415(IXT) ADD 1 TO IXT.
    MOVE "*** END ***" TO TLN(IXT) MOVE 0 TO LI-BLNO.
LI89. GO LI3.
LI9. GO MN9.

* F-3 INVOICE INFORMATION
JH1. PERFORM RD51 PERFORM WRT.
JH3. ACCEPT TR-INV LINE 3 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR TR-INV=999999 GO JH9.
    READ TRANS REGARDLESS KEY TR-KI INVALID MOVE "INVALID INVOICE"
      TO ERR-MESG PERFORM DSP-ERR GO JH3.
    PERFORM RD51.
    MOVE TR-CUS TO TF421(5) A-A1 PERFORM RD-CUS MOVE C-NAME TO TF421A(5).
    MOVE TR-INV TO TF425(6) MOVE TR-AMT TO TF423(7) MOVE TR-AMT-ORIG TO TF423(8).
    MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF424(9).
    IF TR-DATE-PAY>0 MOVE TR-DATE-PAY TO D-DATE PERFORM D-NM MOVE D-DT TO TF424(10).
    IF TR-DATE-PREV(1)>0 MOVE TR-DATE-PREV(1) TO D-DATE PERFORM D-NM MOVE D-DT TO TF424A(10).
    IF TR-DATE-PREV(2)>0 MOVE TR-DATE-PREV(2) TO D-DATE PERFORM D-NM MOVE D-DT TO TF424B(10).
    MOVE TR-ORD TO TF425(11) MOVE TR-BL TO TF425(12) MOVE TR-CUSORD TO TF422(13).
    PERFORM WRT GO JH3.
JH9. GO MN9.

* F-4 TRANSACTION FILE MAINTENANCE
UT1. PERFORM OPEN-TRAUDIT.
UT3. PERFORM RD179 PERFORM WRT PERFORM INIT-TR.
    ACCEPT C-NO LINE 3 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR C-NO=ALL "9" GO UT9.
    READ CUSTOMER REGARDLESS INVALID PERFORM DSP-ERR5 GO UT3.
    MOVE C-NO TO TR-CUS DISPLAY C-NAME LINE 3 COLUMN 25.
    ACCEPT TR-INV LINE 4 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF TR-INV=0 PERFORM DSP-ERR2 GO UT3.
    READ TRANS REGARDLESS KEY TR-KI INVALID GO UT4.
    IF TR-CUS NOT=C-NO MOVE "THIS TRANSACTION HAS A DIFFERENT CUSTOMER NO."
      TO ERR-MESG PERFORM DSP-ERR GO UT3.
    MOVE "THIS TRANSACTION EXISTS - 'DEL' TO DELETE IT: ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="DEL" DELETE TRANS
      MOVE 2 TO A-N1 MOVE SYS-DATE TO A-N2 COMPUTE A-D1=-TR-AMT PERFORM ADD-TRAUD.
    GO UT3.
UT4. MOVE TR-INV TO TR-BINV PERFORM RD179A PERFORM WRT.
    MOVE 6 TO IXT MOVE 8 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO TR-DATE.
    ACCEPT TR-AMT LINE 7 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT INUT
      ACCEPT TR-BL LINE 9 COLUMN 22 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      ACCEPT TR-ORD LINE 10 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION
      GO UT46.
    MOVE TR-INV TO TR-BL DISPLAY TR-BL LINE 9 COLUMN 22 CONVERSION.
UT45. ACCEPT TR-BL LINE 9 COLUMN 22 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY TR-BL LINE 9 COLUMN 22 CONVERSION.
    IF TR-BL=0 PERFORM DSP-ERR2 GO UT45.
    MOVE TR-INV TO TR-ORD DISPLAY TR-ORD LINE 10 COLUMN 13 CONVERSION.
    ACCEPT TR-ORD LINE 10 COLUMN 13 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY TR-ORD LINE 10 COLUMN 13 CONVERSION.
UT46. ACCEPT TR-CUSORD LINE 11 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED.
    MOVE TR-AMT TO TR-AMT-ORIG WRITE TR-RECORD ALLOWING NO UNLOCK TRANS.
    MOVE 0 TO A-N1 IF TR-AMT<0 MOVE 3 TO A-N1.
    MOVE SYS-DATE TO A-N2 MOVE TR-AMT TO A-D1 PERFORM ADD-TRAUD.
    GO UT3.
UT9. CLOSE TRAUDIT GO MN9.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* F-5 PROCESS GM EDI REMITTANCE ADVICE 820
JF1. PERFORM RD346 PERFORM WRT.
    PERFORM RDR-INFO MOVE IF-GMR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO DSP-DT1.
    DISPLAY DSP-DT1 LINE 3 COLUMN 26 BOLD.
    ACCEPT XA3 LINE 4 COLUMN 47 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3 NOT="YES" GO MN9.
    MOVE SYS-DATE TO JF-EFF-DATE D-DATE PERFORM D-NM.
    MOVE " " TO EDI-ID STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID.
    ACCEPT EDI-ID LINE 6 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 6 TO IXT MOVE 52 TO IXU.
    IF INUT PERFORM AX-DT-VAL MOVE DATE0 TO JF-EFF-DATE
      ELSE DISPLAY D-DT LINE IXT COLUMN IXU.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-TRAUDIT PERFORM OPEN-PR PERFORM JF-PAGE.
    PERFORM RD-INFO MOVE SYS-DATE TO IF-GMR-DATE PERFORM WR-INFO.
    MOVE 0 TO JF-INUM.

JF3. READ EDI END GO JF9.
    IF ED-RECORD(1:3) NOT="ISA" GO JF3. PERFORM EL-GET-SEP.
    IF NOT(ED-RECORD(55:9)=ED-DUNS OR ED-DUNS2 OR ED-DUNS3 OR ED-REMIT-CL) GO JF3.
JF33. READ EDI END PERFORM EDI-ERR GO JF9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO JF3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO JF33.
JF35. READ EDI END PERFORM EDI-ERR GO JF9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO JF33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO JF35.
    IF ED-RECORD(4:3)="820" GO JF4.
JF37. READ EDI END PERFORM EDI-ERR GO JF9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JF35. GO JF37.

JF4. PERFORM OPEN-SORT.
    INITIALIZE JF-RSEQ JF-CHQ-AMT JF-CHQ-DATE JF-CHQ-CUR JF-KREF.
JF43. READ EDI END PERFORM EDI-ERR GO JF9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP PERFORM CLOSE-SORT GO JF35.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP
      IF JF-KREF=1 GO JF44 ELSE PERFORM CLOSE-SORT GO JF37.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="IT" OR "AD" MOVE WA2 TO A-A1 PERFORM STR-LTH
        IF A-N1>=9 AND (WA2(A-N1 - 8:)=ED-DUNS OR ED-DUNS2 OR ED-DUNS3)
          MOVE 1 TO JF-KREF END-IF END-IF
      GO JF438.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JF-CHQ-AMT
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE
        ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO JF-CHQ-DATE
      GO JF438.
    IF ED-RECORD(1:3)="CUR" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE JF-CHQ-CUR
      GO JF438.
JF438. GO JF43.
JF44.

* RMR records
* note 6.1
    MOVE 0 TO JF-KFIN.
JF45. INITIALIZE JF-INV-DATE JF-PE JF-KSAT JF-SNUM.
    UNSTR-RECORD INTO ED-LINE ED-LINE JF-BL-NO ED-LINE ED-LINE COUNT ED-LTH.
    PERFORM EL-RDVAL MOVE ED-VAL TO JF-PAY-AMT.
    MOVE JF-BL-NO TO ED-ANUM PERFORM EL-RDNUM.
    MOVE ED-NUM TO JF-BL TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF46.
    READ TRANS NEXT REGARDLESS END GO JF46.
    IF TR-BL=JF-BL AND TR-CUS="06620" MOVE 1 TO JF-KSAT.
JF46.

JF47. READ EDI END PERFORM EDI-ERR GO JF9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO JF-KFIN GO JF48.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP GO JF48.
    IF ED-RECORD(1:3)="DTM" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO JF-INV-DATE
      GO JF478.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2 IF WA1="PE" MOVE WA2 TO JF-PE END-IF
      GO JF478.
    IF JF-KSAT=0 GO JF478.
    IF ED-RECORD(1:3)="IT1" AND ED-RECORD(4:1)=ED-SEP
      IF JF-SNUM=5 GO JF478 END-IF ADD 1 TO JF-SNUM
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO WN1
      UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL COMPUTE JF-SAMT(JF-SNUM) ROUNDED=ED-VAL * WN1
      UNSTR-RECORD INTO ED-LINE ED-LINE A-A1 POINTER ED-PTR
      PERFORM STR-LTH MOVE A-A1(A-N1 - 7:) TO JF-SPROD(JF-SNUM)
      GO JF478.
JF478. GO JF47.
JF48. PERFORM INIT-SR MOVE JF-BL-NO TO SR-F60 ADD 1 TO JF-RSEQ MOVE JF-RSEQ TO SR-F61.
    MOVE JF-INV-DATE TO SR-F62 MOVE JF-PAY-AMT TO SR-F63 MOVE JF-PE TO SR-F64.
    IF JF-SNUM>0 MOVE JF-SNUM TO SR-F65 MOVE JF-SLINES TO SR-F65A.
    WRITE SR-RECORD INVALID CONTINUE.
    IF JF-KFIN=0 GO JF45.

    PERFORM OPEN-REP MOVE 0 TO JF-ROUND.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO JF8.
JF5. READ SORTFL NEXT END GO JF8. MOVE SR-F63 TO JF-PAY-AMT.
    MOVE SR-F60 TO ED-ANUM PERFORM EL-RDNUM MOVE ED-NUM TO JF-BL.
    IF INUT MOVE 0 TO JF-BL(1:1).
* note 164.1
    IF JF-BL=0 MOVE 2 TO JF-EXC GO JF78.
    IF SR-F65=0 GO JF6. MOVE SR-F65 TO JF-SNUM MOVE SR-F65A TO JF-SLINES.

    MOVE 0 TO JF-TOT MOVE 1 TO JF-IX1.
JF541. MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF549.
JF543. READ TRANS NEXT REGARDLESS END GO JF549. IF TR-BL NOT=JF-BL GO JF549.
    COMPUTE L-NO=100 * TR-ORD START SALIN KEY>L-KEY REGARDLESS INVALID GO JF546.
JF545. READ SALIN NEXT REGARDLESS END GO JF546. IF L-ORD NOT=TR-ORD GO JF546.
    IF L-PROD=JF-SPROD(JF-IX1) GO JF548. GO JF545.
JF546. GO JF543.
JF548. IF TR-AMT - JF-SAMT(JF-IX1)>=-JF-RSMAX AND<=JF-RSMAX
      COMPUTE JF-ROUND=JF-ROUND + TR-AMT - JF-SAMT(JF-IX1)
      MOVE TR-AMT TO JF-SAMT(JF-IX1).
    ADD JF-SAMT(JF-IX1) TO JF-TOT.
    COMPUTE JF-D1=-JF-SAMT(JF-IX1) ADD JF-D1 TO TR-AMT.
    PERFORM JF-T MOVE 5 TO JF-EXC PERFORM JF-W.
JF549. ADD 1 TO JF-IX1 IF JF-IX1<=JF-SNUM GO JF541.
    COMPUTE JF-D1=JF-TOT - JF-PAY-AMT MOVE 5 TO JF-EXC PERFORM JF-A GO JF79.

JF6. IF JF-PAY-AMT>=-JF-RMAX AND<=JF-RMAX
       SUBTRACT JF-PAY-AMT FROM JF-ROUND GO JF79.

    MOVE 0 TO JF-NUM-INV JF-TOT MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF644.
JF643. READ TRANS NEXT REGARDLESS END GO JF644. IF TR-BL NOT=JF-BL GO JF644.
    ADD 1 TO JF-NUM-INV ADD TR-AMT TO JF-TOT GO JF643.
JF644. IF JF-NUM-INV=0 MOVE 2 TO JF-EXC GO JF78.
    IF NOT(JF-TOT - JF-PAY-AMT>=-JF-RMAX AND<=JF-RMAX) GO JF66.

    COMPUTE JF-ROUND=JF-ROUND + JF-TOT - JF-PAY-AMT.
    MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF646.
JF645. READ TRANS NEXT REGARDLESS END GO JF646. IF TR-BL NOT=JF-BL GO JF646.
    COMPUTE JF-D1=-TR-AMT MOVE 0 TO TR-AMT.
    PERFORM JF-T MOVE 0 TO JF-EXC PERFORM JF-W GO JF645.
JF646. GO JF79.

JF66. IF JF-NUM-INV>1 GO JF670. MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS READ TRANS NEXT REGARDLESS.
    COMPUTE JF-D1=-JF-PAY-AMT ADD JF-D1 TO TR-AMT.
    PERFORM JF-T MOVE 1 TO JF-EXC PERFORM JF-W GO JF79.

JF670. MOVE 0 TO JF-INVNO MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF674.
JF673. READ TRANS NEXT REGARDLESS END GO JF674. IF TR-BL NOT=JF-BL GO JF674.
    IF JF-TOT - TR-AMT - JF-PAY-AMT>=-JF-RMAX AND<=JF-RMAX
      MOVE TR-INV TO JF-INVNO SUBTRACT TR-AMT FROM JF-TOT GO JF674.
    GO JF673.
JF674. IF JF-INVNO=0 GO JF68.

    COMPUTE JF-ROUND=JF-ROUND + JF-TOT - JF-PAY-AMT.
    MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF676.
JF675. READ TRANS NEXT REGARDLESS END GO JF676. IF TR-BL NOT=JF-BL GO JF676.
    IF TR-INV=JF-INVNO GO JF675. COMPUTE JF-D1=-TR-AMT MOVE 0 TO TR-AMT.
    PERFORM JF-T MOVE 0 TO JF-EXC PERFORM JF-W GO JF675.
JF676. GO JF79.

JF68. MOVE JF-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JF684.
JF683. READ TRANS NEXT REGARDLESS END GO JF684. IF TR-BL NOT=JF-BL GO JF684.
    MOVE TR-AMT TO JF-TOT.
    IF NOT(JF-TOT - JF-PAY-AMT>=-JF-RMAX AND<=JF-RMAX) GO JF683.
    COMPUTE JF-ROUND=JF-ROUND + JF-TOT - JF-PAY-AMT.
    COMPUTE JF-D1=-TR-AMT MOVE 0 TO TR-AMT.
    PERFORM JF-T MOVE 0 TO JF-EXC PERFORM JF-W GO JF79.
JF684. MOVE 3 TO JF-EXC GO JF78.

JF78. COMPUTE JF-D1=-JF-PAY-AMT PERFORM JF-A.
JF79. GO JF5.
JF8. IF JF-ROUND NOT=0 MOVE JF-ROUND TO JF-D1 MOVE 4 TO JF-EXC PERFORM JF-A.

    MOVE LOW-VALUES TO JF-TOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JF88.
JF83. READ REPFL NEXT END GO JF88. MOVE RP-F201 TO TR-KEY READ TRANS REGARDLESS.
    PERFORM INIT-SR MOVE RP-F202 TO SR-F60 JF-BL-NO MOVE RP-F203 TO SR-F61.
    READ SORTFL MOVE SR-F62 TO JF-INV-DATE MOVE SR-F64 TO JF-PE.

    MOVE TR-CUS TO FG261 MOVE TR-INV TO FG262.
    MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG263.
    MOVE TR-AMT-ORIG TO FG264 MOVE RP-F205A TO FG265 MOVE RP-F205 TO FG266.
    IF TR-AMT NOT=0 MOVE TR-AMT TO FG267. IF TR-BL NOT=0 MOVE TR-BL TO FG268.
    IF RP-F204>0 MOVE JF-EXLIT(RP-F204:1) TO FG269 MOVE JF-PE TO FG269A.
    IF RP-F204=1 OR 2 MOVE JF-BL-NO TO FG270.
    MOVE JF-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG270A.
    ADD RP-F205A TO JF-FTOT ADD RP-F205 TO JF-TTOT.
    PERFORM JF-LINE GO JF83.
JF88. MOVE 2 TO WS-PR MOVE "*** PAYMENT TOTALS" TO PREC.
    MOVE JF-FTOT TO FG265 MOVE JF-TTOT TO FG266 PERFORM PR-LINE-2.
    MOVE "     GM CHEQUE" TO FG295.
    MOVE JF-CHQ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG296.
    MOVE JF-CHQ-AMT TO FG297 MOVE JF-CHQ-CUR TO FG298 PERFORM PR-LINE.
    PERFORM JF-PAGE.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT.
    GO JF35.
JF9. CLOSE EDI CLOSE TRAUDIT PERFORM CLOSE-PR GO MN9.

JF-W. PERFORM JF-W1 THRU JF-W9.
JF-W1. IF JF-D1=0 GO JF-W9. MOVE TR-CUS TO C-NO.
    READ CUSTOMER ALLOWING NO INVALID GO JF-W4. PERFORM RDLK-CUSTOMER.
    MOVE JF-D1 TO A-D1 PERFORM UPDATE-CUST-BAL PERFORM UPDATE-CUST-PAY.
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER.
JF-W4. PERFORM INIT-RP MOVE TR-KEY TO RP-F201.
    MOVE SR-F60 TO RP-F202 MOVE SR-F61 TO RP-F203 MOVE JF-EXC TO RP-F204.
    MOVE JF-D1 TO RP-F205 COMPUTE RP-F205A=-JF-D1 WRITE RP-RECORD.
JF-W9. EXIT.
JF-A. PERFORM JF-A1 THRU JF-A9.
JF-A1. IF JF-D1=0 GO JF-A9.
    PERFORM INIT-TR MOVE "06662" TO TR-CUS ADD 1 TO JF-INUM.
    IF INUT COMPUTE TR-INV=900000 + SYS-DDD * 100 + JF-INUM
      ELSE COMPUTE TR-INV=SYS-DDD * 1000 + JF-INUM.
* note 59.1
    MOVE TR-INV TO TR-BINV MOVE JF-EFF-DATE TO TR-DATE MOVE JF-D1 TO TR-AMT TR-AMT-ORIG.
JF-A3. WRITE TR-RECORD ALLOWING NO INVALID ADD 1 TO TR-INV TR-BINV GO JF-A3. UNLOCK TRANS.
    MOVE 2 TO A-N1 MOVE TR-DATE TO A-N2 MOVE TR-AMT TO A-D1 PERFORM ADD-TRAUD.
    PERFORM JF-W.
JF-A9. EXIT.
JF-T. PERFORM SET-TRDATE MOVE JF-EFF-DATE TO TR-DATE-PAY.
    REWRITE TR-RECORD ALLOWING NO UNLOCK TRANS.
    MOVE 1 TO A-N1 MOVE TR-DATE-PAY TO A-N2 MOVE JF-D1 TO A-D1 PERFORM ADD-TRAUD.
JF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JF-PAGE.
JF-PAGE. MOVE "GM EDI REMITTANCE ADVICE (820) REPORT" TO FF3 PERFORM PR-PAGE.
    IF INUT MOVE "EFFECTIVE DATE:" TO A-A1 MOVE JF-EFF-DATE TO DATE0 PERFORM PRANGE-DT.
    MOVE "CUST      INV   INV DATE    ORIG AMT      FROM GM      APPLIED      BALANCE    B/L NO.   EXC PLNT  GM B/L NO.   GM INV DATE" TO PREC PERFORM PR-LINE-3.
*         ......  ......  ../../..  ...,...:..-  ...,...:..-  ...,...:..-  ...,...:..-   .......    .   ..   ............  ../../..
*         ..............  ../../..  ...,...:..- ...
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* F-6 LIST GM EDI REMITTANCE ADVICE 820
JG1. PERFORM RD347 PERFORM WRT MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE " " TO EDI-ID STRING "ADREL" D-DD DELIMITED SIZE INTO EDI-ID.
    ACCEPT EDI-ID LINE 3 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT JG-PID LINE 3 COLUMN 42 DEFAULT " " UNDERLINED PROTECTED.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM JG-PAGE.

JG3. READ EDI END GO JG9.
    IF ED-RECORD(1:3) NOT="ISA" GO JG3. PERFORM EL-GET-SEP.
    IF NOT(ED-RECORD(55:9)=ED-DUNS OR ED-DUNS2 OR ED-DUNS3 OR ED-REMIT-CL) GO JG3.
JG33. READ EDI END PERFORM EDI-ERR GO JG9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO JG3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO JG33.
JG35. READ EDI END PERFORM EDI-ERR GO JG9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO JG33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO JG35.
    IF ED-RECORD(4:3)="820" GO JG4.
JG37. READ EDI END PERFORM EDI-ERR GO JG9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JG35. GO JG37.

JG4. INITIALIZE JG-CHQ-AMT JG-CHQ-DATE JG-CHQ-CUR JG-KREF.
JG43. READ EDI END PERFORM EDI-ERR GO JG9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JG35.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP
      IF JG-KREF=1 GO JG44 ELSE GO JG37.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="IT" OR "AD" MOVE WA2 TO A-A1 PERFORM STR-LTH
        IF A-N1>=9 AND (WA2(A-N1 - 8:)=ED-DUNS OR ED-DUNS2 OR ED-DUNS3)
          MOVE 1 TO JG-KREF END-IF END-IF
      GO JG438.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JG-CHQ-AMT
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE
        ED-LINE ED-LINE ED-LINE ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO JG-CHQ-DATE
      GO JG438.
    IF ED-RECORD(1:3)="CUR" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE JG-CHQ-CUR
      GO JG438.
JG438. GO JG43.
JG44.

* RMR records
    MOVE 3 TO WS-PR MOVE JG-CHQ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA710.
    MOVE JG-CHQ-AMT TO FA711 MOVE JG-CHQ-CUR TO FA712 PERFORM JG-LINE 2 TIMES.
    MOVE 0 TO JG-KFIN.
JG45. MOVE 0 TO JG-STEP INITIALIZE JG-PAY-AMT JG-BL-NO JG-PO JG-INV-DATE JG-TOTAL.
    UNSTR-RECORD INTO ED-LINE ED-LINE JG-BL-NO ED-LINE ED-LINE COUNT ED-LTH.
    PERFORM EL-RDVAL MOVE ED-VAL TO JG-PAY-AMT.

JG47. READ EDI END PERFORM EDI-ERR GO JG9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO JG-KFIN GO JG48.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP GO JG48.
    IF ED-RECORD(1:3)="DTM" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH
      PERFORM EL-RDVAL MOVE ED-VAL TO D-DT PERFORM D-YN MOVE D-DATE TO JG-INV-DATE
      GO JG478.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="PE" AND WA2(1:2)=JG-PID MOVE 1 TO JG-STEP END-IF
      IF WA1="PO" MOVE WA2 TO JG-PO END-IF
      GO JG478.
    IF ED-RECORD(1:3)="IT1" AND ED-RECORD(4:1)=ED-SEP
      IF JG-STEP=0 GO JG478 END-IF
      IF JG-STEP=1 MOVE 2 TO JG-STEP
        MOVE JG-BL-NO TO FA713 MOVE JG-PAY-AMT TO FA714 MOVE JG-PO TO FA715
        MOVE JG-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA716
        INITIALIZE JG-LN JG-QTY JG-MODE JG-PRICE JG-DESC END-IF
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JG-LN
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JG-QTY
      UNSTR-RECORD INTO JG-MODE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JG-PRICE
      UNSTR-RECORD INTO ED-LINE ED-LINE JG-DESC POINTER ED-PTR
      MOVE JG-LN TO FA717 MOVE JG-QTY TO FA718 MOVE JG-MODE TO FA719
      MOVE JG-PRICE TO FA720 MOVE JG-DESC TO FA721
      COMPUTE WD1 ROUNDED=JG-QTY * JG-PRICE MOVE WD1 TO FA722 ADD WD1 TO JG-TOTAL
      PERFORM JG-LINE GO JG478.
JG478. GO JG47.
JG48. IF JG-STEP=2 MOVE JG-TOTAL TO FA722 MOVE "*" TO FA722A PERFORM JG-LINE.
    IF JG-KFIN=0 GO JG45. GO JG35.
JG9. CLOSE EDI PERFORM CLOSE-PR GO MN9.

JG-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JG-PAGE.
JG-PAGE. MOVE "GM EDI REMITTANCE ADVICE (820) LISTING" TO FF3.
    STRING "(PLANT ID: " JG-PID ")" DELIMITED SIZE INTO FF4 PERFORM PR-PAGE.
    MOVE "CHQ DATE     CHQ AMT CUR" TO PREC PERFORM PR-LINE.
*         ../../..  ...,...:..-...
    MOVE "          B/L NO.         B/L AMT  P.O.         INV DATE  LINE    QTY    UNIT PRICE  DESCRIPTION          VALUE" TO PREC PERFORM PR-LINE-3.
*                   ............ ...,...:..- ............ ../../..  ..  ...,...-..  ...:.....- ............... ...,...:..-..
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==
            ==INTO-RECORD== BY ==ED-NL DELIMITED SIZE INTO ED-RECORD POINTER ED-PTR PERFORM EL-WRITE==.
* F-7 LIST AMERICAN AXLE REMITTANCE FILE
CM1. PERFORM RD348 PERFORM WRT MOVE "AAREMIT" TO EDI-ID.
    ACCEPT EDI-ID LINE 7 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 9 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-SORT.
    MOVE X"1C" TO ED-NL MOVE "," TO ED-SEP.
    MOVE 0 TO CM-TOT-AMT CM-CHQ-DATE.

* note 254
CM3. READ EDI END GO CM4. PERFORM EL-CSV IF ED-RECORD(1:3) NOT NUMERIC GO CM3.
    MOVE 1 TO ED-PTR.
    UNSTR-RECORD INTO ED-LINE ED-ADATE POINTER ED-PTR.
    PERFORM EL-RADATE IF CM-CHQ-DATE=0 MOVE D-DATE TO CM-CHQ-DATE.
    UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO CM-AMT.
    UNSTR-RECORD INTO CM-VENDOR ED-ANUM POINTER ED-PTR.
    PERFORM EL-RDNUM MOVE ED-NUM TO CM-BL.
    UNSTR-RECORD INTO ED-ADATE POINTER ED-PTR.
    PERFORM EL-RADATE MOVE D-DATE TO CM-IDATE.
    UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO CM-QTY.
    UNSTR-RECORD INTO ED-LINE ED-ANUM POINTER ED-PTR.
    PERFORM EL-RDNUM MOVE ED-NUM TO CM-NPROD.
    UNSTR-RECORD INTO CM-PO POINTER ED-PTR.

    MOVE CM-BL TO SR-F157 MOVE CM-PROD TO SR-F158.
    MOVE CM-QTY TO SR-F159 MOVE CM-AMT TO SR-F160.
    MOVE CM-IDATE TO SR-F161 MOVE CM-PO TO SR-F162 MOVE CM-VENDOR TO SR-F163.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD CM-QTY TO SR-F159 ADD CM-AMT TO SR-F160 REWRITE SR-RECORD.
    ADD CM-AMT TO CM-TOT-AMT GO CM3.
CM4. CLOSE EDI.

    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.
    STRING "AAREL" D-DD DELIMITED SIZE INTO EDI-ID OPEN OUTPUT EDI.
    MOVE X"1C" TO ED-NL MOVE "~" TO ED-SEP MOVE "<" TO ED-SUBSEP.
    ACCEPT ED-YYMMDD FROM DATE ACCEPT ED-TIME FROM TIME MOVE 1 TO ED-PTR.
    MOVE 20 TO ED-CC MOVE 3 TO ED-DX1 MOVE 6 TO ED-DX2.

    MOVE "00204" TO ED-ISA-VERSION MOVE "002040" TO ED-GS-VERSION.
    MOVE "01" TO ED-SENDER-QUAL ED-RECEIVER-QUAL.
    MOVE ED-DUNS TO ED-SENDER-ID ED-RECEIVER-ID.
    MOVE 1 TO ED-ISA-NUM MOVE 0 TO ED-ISA-TOT ED-GS-NUM.
    STRING "ISA~00~          ~00~          ~"
      ED-SENDER-QUAL "~" ED-SENDER-ID "~" ED-RECEIVER-QUAL "~" ED-RECEIVER-ID "~"
      ED-YYMMDD "~" ED-HHMM "~U~" ED-ISA-VERSION "~" ED-ISA-NUM "~0~P~" ED-SUBSEP INTO-RECORD.
    ADD 1 TO ED-ISA-TOT.
    ADD 1 TO ED-GS-NUM MOVE 0 TO ED-GS-TOT ED-ST-NUM.
    STRING "GS~SH~" ED-SENDER-ID "~" ED-RECEIVER-ID DELIMITED " "
      "~" ED-CCYYMMDD(ED-DX1:ED-DX2) "~" ED-HHMM "~" ED-GS-NUM "~X~" DELIMITED SIZE
      ED-GS-VERSION DELIMITED " " INTO-RECORD.
    ADD 1 TO ED-GS-TOT ADD 1 TO ED-ST-NUM MOVE 1 TO ED-ST-TOT.
    STRING "ST~820~" ED-ST-NUM INTO-RECORD.
    MOVE CM-TOT-AMT TO ED-D71.
    MOVE CM-CHQ-DATE TO D-DATE PERFORM D-NY MOVE D-DT TO ED-N61.
    STRING "BPR~~" ED-D71 "~~~~~~~~~~~~~~" ED-N61 INTO-RECORD.
    STRING "REF~IT~" ED-DUNS INTO-RECORD.

    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO CM6.
CM5. READ SORTFL NEXT END GO CM6.
    MOVE SR-F160 TO ED-D71.
    STRING "RMR~BM~" SR-F157 "~" ED-D71 "~" ED-D71 INTO-RECORD.
    MOVE SR-F162 TO A-A1 PERFORM STR-LTH.
    STRING "REF~PO~" SR-F162(1:A-N1) INTO-RECORD.
    STRING "REF~PE~AA~AMERICAN AXLE" INTO-RECORD.
    MOVE SR-F161 TO D-DATE PERFORM D-NY MOVE D-DT TO ED-N61.
    STRING "DTM~003~" ED-N61 INTO-RECORD.
    MOVE 1 TO ED-N31 MOVE SR-F159 TO ED-N71 COMPUTE ED-P51 ROUNDED=SR-F160 / SR-F159.
    STRING "IT1~" ED-N31 "~" ED-N71 "~EA~" ED-P51 "~~~" SR-F158 INTO-RECORD.
    GO CM5.
CM6. STRING "SE~" ED-ST-TOT "~" ED-ST-NUM INTO-RECORD.
    STRING "GE~" ED-GS-TOT "~" ED-GS-NUM INTO-RECORD.
    STRING "IEA~" ED-ISA-TOT "~" ED-ISA-NUM INTO-RECORD.
    CLOSE EDI.

    PERFORM OPEN-PR PERFORM CM-PAGE.
    MOVE "CHEQUE DATE:" TO FF590.
    MOVE CM-CHQ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF591 PERFORM PR-LINE.
    MOVE "TOTAL PAID:" TO FF592 MOVE CM-TOT-AMT TO FF593 PERFORM CM-LINE.
    MOVE "DUMMY EDI FILE CREATED:" TO FF594 MOVE EDI-ID TO FF595.
    PERFORM CM-LINE 3 TIMES.
    MOVE 0 TO OLD-N MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO CM8.
CM7. READ SORTFL NEXT END GO CM8.
    IF SR-F157 NOT=OLD-N MOVE SR-F157 TO FF597 OLD-N MOVE SR-F163 TO FF603.
    MOVE SR-F158 TO FF598 MOVE SR-F159 TO FF599 MOVE SR-F160 TO FF600.
    MOVE SR-F161 TO D-DATE PERFORM D-NM MOVE D-DT TO FF601.
    MOVE SR-F162 TO FF602 PERFORM CM-LINE GO CM7.
CM8. PERFORM CLOSE-SORT PERFORM CLOSE-PR.
CM9. GO MN9.

CM-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM CM-PAGE.
CM-PAGE. MOVE "AMERICAN AXLE REMITTANCE LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE "B/L NO.  PRODUCT      QTY       AMT     INV DATE  P.O.          VENDOR" TO PREC PERFORM PR-LINE-3.
*         .......  ........  ...,...- ...,...:..- ../../..  ............  ....................
    REPLACE OFF.

* F-8 SURCHARGE LISTING BY CUSTOMER
OU1. PERFORM RD349 PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 44 TO IXV PERFORM AX-CUS-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM OU-PAGE.
    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE OU-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE CUS1 TO C-NO START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO OU9.
OU3. READ CUSTOMER NEXT REGARDLESS END GO OU9. IF C-NO>CUS2 GO OU9.
    MOVE C-NO TO FF446 EXP-A PERFORM EXPF MOVE C-NAME TO FF446A EXP-A PERFORM EXPF.
    MOVE C-SUR TO FF447 EXP-N PERFORM EXPF MOVE ":" TO FF447A.
    IF C-SUR>0 MOVE IF-SURCH(C-SUR) TO FF448 EXP-Q. PERFORM EXPF.
    PERFORM OU-LINE PERFORM EXP-LINE GO OU3.
OU9. PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MN9.

OU-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM OU-PAGE.
OU-PAGE. MOVE "SURCHARGE LISTING BY CUSTOMER" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-CUS.
    MOVE "CUS     NAME                                SURCHARGE" TO PREC PERFORM PR-LINE-3.
*         ......  ................................    .: :...

* F-9 BROKER LISTING BY CUSTOMER
OW1. PERFORM RD350 PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 44 TO IXV PERFORM AX-CUS-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM OW-PAGE.
    MOVE CUS1 TO C-NO START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO OW9.
OW3. READ CUSTOMER NEXT REGARDLESS END GO OW9. IF C-NO>CUS2 GO OW9.
    MOVE C-NO TO FF512 MOVE C-NAME TO FF513 MOVE C-BROKER TO FF514.
    IF C-BROKER NOT=0 MOVE 4 TO T-TBL MOVE C-BROKER TO T-NO PERFORM RD-TBL
      MOVE T-LINE TO FF515.
    PERFORM OW-LINE GO OW3.
OW9. PERFORM CLOSE-PR GO MN9.

OW-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM OW-PAGE.
OW-PAGE. MOVE "BROKER LISTING BY CUSTOMER" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-CUS.
    MOVE "CUS     NAME                              BROKER" TO PREC PERFORM PR-LINE-3.
*         ......  ................................    ..  .............................................

* F-10 BANK CLEARING REPORT
KN1. PERFORM RD268 PERFORM WRT.
    IF INUT MOVE "BNCLRIN" TO BNCLR-NAME ELSE MOVE "BNCLRIF" TO BNCLR-NAME.
KN13. ACCEPT BNCLR-NAME LINE 3 COLUMN 19 DEFAULT CURRENT UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR BNCLR-NAME=ALL "9" GO MN9.
    OPEN INPUT BNCLR IF DSTAT NOT="00" PERFORM DSP-ERR57 GO KN13.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM KN-PAGE.

KN3. READ BNCLR END GO KN8.
    IF BZ-A1="A"
      MOVE BZ-A3 TO FD466 MOVE BZ-A4 TO FD456 MOVE BZ-A5 TO FD457
      MOVE BZ-A6 TO FD467 GO KN6.
    IF BZ-A1="B"
      MOVE BZ-B3 TO FD459 MOVE BZ-B4 TO FD461 MOVE BZ-B5 TO FD462
      MOVE BZ-B6 TO FD463 MOVE BZ-B7 TO FD464 MOVE BZ-B8 TO FD458
      MOVE BZ-B9 TO FD465 MOVE BZ-B10 TO FD466 GO KN6.
    IF BZ-A1="T" GO KN6.
    IF BZ-A1="Z"
      MOVE BZ-Z3 TO FD466 MOVE BZ-Z4 TO FD456 MOVE BZ-Z5 TO FD459
      MOVE BZ-Z6 TO FD460 GO KN6.
    MOVE "** UNIDENTIFIED RECORD **" TO PREC.
KN6. MOVE BZ-A2 TO FD455 MOVE BZ-A1 TO FD455A PERFORM KN-LINE.
    IF BZ-A1 NOT="B" GO KN78.
* note 222
    MOVE WS-DIV TO AH-DIV MOVE 0 TO AH-US COMPUTE AH-NO=BZ-B8 / 10.
    READ APCHQ REGARDLESS INVALID MOVE "      ** ERROR: INVALID CHEQUE NO." TO PREC
      PERFORM KN-LINE GO KN78.
    IF BZ-B3 NOT=AH-NET MOVE "      ** ERROR: WRONG AMOUNT" TO PREC
      PERFORM KN-LINE GO KN78.
    DELETE APCHQ.
KN78. GO KN3.
KN8. CLOSE BNCLR PERFORM CLOSE-PR.
KN9. GO MN9.

KN-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KN-PAGE.
KN-PAGE. MOVE "BANK CLEARING REPORT" TO FF3 PERFORM PR-IPAGE.
    MOVE "REC   FILE NO  FILE DATE  SER NUMBER        AMOUNT  TOT ITEMS  TRANSACTION  A/C      INSTITUTION  TRANSIT  TRACE      ORIGIN  DESTIN" TO PREC PERFORM PR-LINE-3.
*         ... .  ....     .. ...    ........   ...,...,...:..    ....        ....   .............  ...       .....   .........  ... ..  ... ..

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* F-11 PROCESS BANK EDI LOCKBOX DEPOSIT 823
JS1. PERFORM RD352 PERFORM WRT.
    MOVE SYS-DATE TO JS-EFF-DATE D-DATE PERFORM D-NM MOVE " " TO EDI-ID.
    IF INUT STRING "LOCKIN" D-DD DELIMITED SIZE INTO EDI-ID
      ELSE STRING "LOCKIF" D-DD DELIMITED SIZE INTO EDI-ID.
    ACCEPT EDI-ID LINE 3 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 3 TO IXT MOVE 52 TO IXU.
    IF INUT PERFORM AX-DT-VAL MOVE DATE0 TO JS-EFF-DATE
      ELSE DISPLAY D-DT LINE IXT COLUMN IXU.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-TRAUDIT PERFORM OPEN-PR PERFORM JS-PAGE.
    MOVE 0 TO JS-INUM.

JS3. READ EDI END GO JS9.
    IF ED-RECORD(1:3) NOT="ISA" GO JS3. PERFORM EL-GET-SEP.
JS33. READ EDI END PERFORM EDI-ERR GO JS9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO JS3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO JS33.
JS35. READ EDI END PERFORM EDI-ERR GO JS9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO JS33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO JS35.
    IF ED-RECORD(4:3)="823" GO JS4.
JS37. READ EDI END PERFORM EDI-ERR GO JS9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JS35. GO JS37.

JS4. INITIALIZE JS-KB JS-DATE JS-PAYEE JS-TOTNUM JS-TOTAMT.
JS43. READ EDI END PERFORM EDI-ERR GO JS9. PERFORM EL-CLR.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JS35.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP GO JS44.
    IF ED-RECORD(1:3)="BAT" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO JS-KB
      GO JS438.
    IF ED-RECORD(1:3)="DEP" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL IF ED-VAL NOT=WS-HBOX GO JS37 END-IF
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      MOVE "102" TO ED-DFQUAL PERFORM EL-RDATE MOVE D-DATE TO JS-DATE
      GO JS438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="PE" MOVE WA2 TO JS-PAYEE END-IF
      GO JS438.
    IF ED-RECORD(1:3)="QTY" AND ED-RECORD(4:1)=ED-SEP
      IF JS-KB=1 GO JS438 END-IF
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="42" PERFORM EL-RDVAL MOVE ED-VAL TO JS-TOTNUM END-IF
      GO JS438.
    IF ED-RECORD(1:3)="AMT" AND ED-RECORD(4:1)=ED-SEP
      IF JS-KB=1 GO JS438 END-IF
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="3" PERFORM EL-RDVAL MOVE ED-VAL TO JS-TOTAMT END-IF
      GO JS438.
JS438. GO JS43.
JS44. MOVE 3 TO WS-PR MOVE "PAYEE:" TO FD131 MOVE JS-PAYEE TO FD132 PERFORM JS-LINE.
    MOVE "DATE:" TO FD131 MOVE JS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD135 PERFORM JS-LINE.
    MOVE "NUM CHQS:" TO FD131 MOVE JS-TOTNUM TO FD134 PERFORM JS-LINE.
    MOVE "TOTAL:" TO FD131 MOVE JS-TOTAMT TO FD133 PERFORM JS-LINE 2 TIMES.

* BPR records
JS45. INITIALIZE JS-ITEM JS-PAYER JS-CHQNO JS-CHQAMT.
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH.
    PERFORM EL-RDVAL MOVE ED-VAL TO JS-CHQAMT.

JS47. READ EDI END PERFORM EDI-ERR GO JS9.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH PERFORM EL-RDVAL
      IF WA1="CK" MOVE ED-VAL TO JS-CHQNO END-IF
      IF WA1="ZZ" MOVE ED-VAL TO JS-ITEM END-IF
      GO JS478.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="PR" MOVE WA2 TO JS-PAYER END-IF
      GO JS478.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP GO JS48.
JS478. GO JS47.
JS48. PERFORM JS-LINE 3 TIMES.
    MOVE JS-ITEM TO FD136 MOVE JS-PAYER TO FD137 MOVE JS-CHQNO TO FD138.
    MOVE JS-CHQAMT TO FD139 PERFORM JS-LINE.

* RMR records
* note 6.2
    PERFORM OPEN-SORT MOVE 0 TO JS-KFIN.
JS53. INITIALIZE JS-INV JS-INVAMT.
    MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE WA1 POINTER ED-PTR.
    IF WA1="IV"
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JS-INV
      UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL MOVE ED-VAL TO JS-INVAMT.
JS55. READ EDI END PERFORM EDI-ERR GO JS9. PERFORM EL-CLR.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO JS-KFIN GO JS58.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP MOVE 2 TO JS-KFIN GO JS58.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP GO JS58.
    GO JS55.
JS58. MOVE JS-INV TO SR-F137 ADD 1 TO JS-RSEQ MOVE JS-RSEQ TO SR-F138.
    MOVE JS-INVAMT TO SR-F139 WRITE SR-RECORD INVALID CONTINUE.
    IF JS-KFIN=0 GO JS53.

    PERFORM OPEN-REP MOVE 0 TO JS-ROUND.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO JS8.
JS63. READ SORTFL NEXT END GO JS8.
    MOVE SR-F139 TO JS-PAY-AMT MOVE SR-F137 TO JS-INV JS-BL.
    IF INUT MOVE 0 TO JS-INV(1:1) JS-BL(1:1).
* note 164.2
    IF JS-INV=0 MOVE 2 TO JS-EXC GO JS78.
    IF JS-PAY-AMT>=-JS-RMAX AND<=JS-RMAX
      SUBTRACT JS-PAY-AMT FROM JS-ROUND GO JS79.

    MOVE JS-INV TO TR-INV READ TRANS REGARDLESS KEY TR-KI INVALID GO JS64.
    MOVE TR-AMT TO A-D1 PERFORM JS-C.
    IF A-S1=1 COMPUTE JS-D1=-JS-PAY-AMT MOVE 0 TO JS-D2 MOVE 1 TO JS-EXC GO JS634.
    COMPUTE JS-D2=TR-AMT - JS-PAY-AMT ADD JS-D2 TO JS-ROUND.
    COMPUTE JS-D1=-TR-AMT MOVE 0 TO JS-EXC.
JS634. ADD JS-D1 TO TR-AMT.
    PERFORM JS-T PERFORM JS-W GO JS79.

JS64. MOVE 0 TO JS-NUM-INV JS-TOT MOVE JS-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JS644.
JS643. READ TRANS NEXT REGARDLESS END GO JS644. IF TR-BL NOT=JS-BL GO JS644.
    ADD 1 TO JS-NUM-INV ADD TR-AMT TO JS-TOT GO JS643.
JS644. IF JS-NUM-INV=0 MOVE 2 TO JS-EXC GO JS78.
    MOVE JS-TOT TO A-D1 PERFORM JS-C IF A-S1=1 GO JS66.
    COMPUTE JS-D2=JS-TOT - JS-PAY-AMT ADD JS-D2 TO JS-ROUND.
    MOVE JS-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JS646.
JS645. READ TRANS NEXT REGARDLESS END GO JS646. IF TR-BL NOT=JS-BL GO JS646.
    COMPUTE JS-D1=-TR-AMT MOVE 0 TO TR-AMT.
    PERFORM JS-T MOVE 0 TO JS-EXC PERFORM JS-W MOVE 0 TO JS-D2 GO JS645.
JS646. GO JS79.

JS66. IF JS-NUM-INV>1 GO JS670. MOVE JS-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS READ TRANS NEXT REGARDLESS.
    MOVE 0 TO JS-D2 COMPUTE JS-D1=-JS-PAY-AMT ADD JS-D1 TO TR-AMT.
    PERFORM JS-T MOVE 1 TO JS-EXC PERFORM JS-W GO JS79.

JS670. MOVE 0 TO JS-INVNO MOVE JS-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JS674.
JS673. READ TRANS NEXT REGARDLESS END GO JS674. IF TR-BL NOT=JS-BL GO JS674.
    COMPUTE A-D1=JS-TOT - TR-AMT PERFORM JS-C.
    IF A-S1=0 MOVE TR-INV TO JS-INVNO SUBTRACT TR-AMT FROM JS-TOT GO JS674.
    GO JS673.
JS674. IF JS-INVNO=0 GO JS68.

    COMPUTE JS-D2=JS-TOT - JS-PAY-AMT ADD JS-D2 TO JS-ROUND.
    MOVE JS-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JS676.
JS675. READ TRANS NEXT REGARDLESS END GO JS676. IF TR-BL NOT=JS-BL GO JS676.
    IF TR-INV=JS-INVNO GO JS675. COMPUTE JS-D1=-TR-AMT MOVE 0 TO TR-AMT.
    PERFORM JS-T MOVE 0 TO JS-EXC PERFORM JS-W MOVE 0 TO JS-D2 GO JS675.
JS676. GO JS79.

JS68. MOVE JS-BL TO TR-BL MOVE 0 TO TR-BINV.
    START TRANS KEY>TR-KB REGARDLESS INVALID GO JS684.
JS683. READ TRANS NEXT REGARDLESS END GO JS684. IF TR-BL NOT=JS-BL GO JS684.
    MOVE TR-AMT TO JS-TOT A-D1 PERFORM JS-C IF A-S1=1 GO JS683.
    COMPUTE JS-D2=JS-TOT - JS-PAY-AMT ADD JS-D2 TO JS-ROUND.
    COMPUTE JS-D1=-TR-AMT MOVE 0 TO TR-AMT.
    PERFORM JS-T MOVE 0 TO JS-EXC PERFORM JS-W GO JS79.
JS684. MOVE 3 TO JS-EXC GO JS78.

JS78. COMPUTE JS-D1=-JS-PAY-AMT PERFORM JS-A.
JS79. GO JS63.
JS8. IF JS-ROUND NOT=0 MOVE JS-ROUND TO JS-D1 MOVE 4 TO JS-EXC PERFORM JS-A.

    MOVE LOW-VALUES TO JS-TOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JS88.
JS83. READ REPFL NEXT END GO JS88. MOVE RP-F375 TO TR-KEY READ TRANS REGARDLESS.
    MOVE TR-CUS TO FD140 MOVE TR-INV TO FD141.
    MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD142.
    MOVE TR-AMT-ORIG TO FD143 MOVE RP-F379 TO FD144.
    IF RP-F380 NOT=0 MOVE RP-F380 TO FD145. IF TR-AMT NOT=0 MOVE TR-AMT TO FD146.
    IF TR-BL NOT=0 MOVE TR-BL TO FD147.
    IF RP-F378>0 MOVE JS-EXLIT(RP-F378:1) TO FD148.
    ADD RP-F379 TO JS-ATOT ADD RP-F380 TO JS-RTOT.
    PERFORM JS-LINE GO JS83.
JS88. MOVE "      *** PAYMENT TOTALS" TO PREC.
    MOVE JS-ATOT TO FD144 MOVE JS-RTOT TO FD145.
    IF -JS-ATOT NOT=JS-CHQAMT MOVE "** NOT EQUAL TO CHEQUE AMT **" TO FD149.
    PERFORM JS-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT.
    IF JS-KFIN=2 GO JS45. GO JS35.
JS9. CLOSE EDI CLOSE TRAUDIT PERFORM CLOSE-PR GO MN9.

JS-C. MOVE 1 TO A-S1.
    COMPUTE A-D2 ROUNDED=A-D1 * 0.98 COMPUTE A-D3 ROUNDED=A-D1 * 1.02.
    IF A-D1>=0 AND (JS-PAY-AMT>=A-D2 AND<=A-D3)
      OR A-D1<0 AND (JS-PAY-AMT<=A-D2 AND>=A-D3) MOVE 0 TO A-S1.
JS-W. PERFORM JS-W1 THRU JS-W9.
JS-W1. IF JS-D1=0 GO JS-W9. MOVE TR-CUS TO C-NO.
    READ CUSTOMER ALLOWING NO INVALID GO JS-W4. PERFORM RDLK-CUSTOMER.
    MOVE JS-D1 TO A-D1 PERFORM UPDATE-CUST-BAL PERFORM UPDATE-CUST-PAY.
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER.
JS-W4. PERFORM INIT-RP MOVE TR-KEY TO RP-F375 MOVE SR-F138 TO RP-F376.
    MOVE JS-EXC TO RP-F378 MOVE JS-D1 TO RP-F379 MOVE JS-D2 TO RP-F380.
    WRITE RP-RECORD.
JS-W9. EXIT.
JS-A. PERFORM JS-A1 THRU JS-A9.
JS-A1. PERFORM INIT-TR MOVE "06662" TO TR-CUS ADD 1 TO JS-INUM.
    IF INUT COMPUTE TR-INV=900000 + SYS-DDD * 100 + JS-INUM
      ELSE COMPUTE TR-INV=SYS-DDD * 1000 + JS-INUM.
* note 59.2
    MOVE TR-INV TO TR-BINV MOVE JS-EFF-DATE TO TR-DATE MOVE JS-D1 TO TR-AMT TR-AMT-ORIG.
JS-A3. WRITE TR-RECORD ALLOWING NO INVALID ADD 1 TO TR-INV TR-BINV GO JS-A3. UNLOCK TRANS.
    MOVE 2 TO A-N1 MOVE TR-DATE TO A-N2 MOVE TR-AMT TO A-D1 PERFORM ADD-TRAUD.
    MOVE 0 TO JS-D2 PERFORM JS-W.
JS-A9. EXIT.
JS-T. PERFORM SET-TRDATE MOVE JS-EFF-DATE TO TR-DATE-PAY.
    REWRITE TR-RECORD ALLOWING NO UNLOCK TRANS.
    MOVE 1 TO A-N1 MOVE TR-DATE-PAY TO A-N2 MOVE JS-D1 TO A-D1 PERFORM ADD-TRAUD.
JS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JS-PAGE.
JS-PAGE. MOVE "BANK EDI LOCKBOX DEPOSIT (823) REPORT" TO FF3 PERFORM PR-IPAGE.
    IF INUT MOVE "EFFECTIVE DATE:" TO A-A1 MOVE JS-EFF-DATE TO DATE0 PERFORM PRANGE-DT.
    MOVE "ITEM  PAYER                  CHQ NO       CHQ AMT" TO PREC PERFORM PR-LINE.
    MOVE "      CUST      INV   INV DATE     ORIG AMT      APPLIED     ROUNDING      BALANCE    B/L    EXC" TO PREC PERFORM PR-LINE-3.
*         ...   ....................  .......  .,...,...:..-
*               ......  ......  ../../..  ...,...:..-  ...,...:..-  ...,...:..-  ...,...:..-  .......   .
    REPLACE OFF.

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* F-12 LIST BANK EDI LOCKBOX DEPOSIT 823
JQ1. PERFORM RD351 PERFORM WRT.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE " " TO EDI-ID.
    IF INUT STRING "LOCKIN" D-DD DELIMITED SIZE INTO EDI-ID
      ELSE STRING "LOCKIF" D-DD DELIMITED SIZE INTO EDI-ID.
    ACCEPT EDI-ID LINE 3 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM JQ-PAGE.

JQ3. READ EDI END GO JQ9.
    IF ED-RECORD(1:3) NOT="ISA" GO JQ3. PERFORM EL-GET-SEP.
JQ33. READ EDI END PERFORM EDI-ERR GO JQ9.
    IF ED-RECORD(1:3)="IEA" AND ED-RECORD(4:1)=ED-SEP GO JQ3.
    IF NOT(ED-RECORD(1:2)="GS" AND ED-RECORD(3:1)=ED-SEP) GO JQ33.
JQ35. READ EDI END PERFORM EDI-ERR GO JQ9.
    IF ED-RECORD(1:2)="GE" AND ED-RECORD(3:1)=ED-SEP GO JQ33.
    IF NOT(ED-RECORD(1:2)="ST" AND ED-RECORD(3:1)=ED-SEP) GO JQ35.
    IF ED-RECORD(4:3)="823" GO JQ4.
JQ37. READ EDI END PERFORM EDI-ERR GO JQ9.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JQ35. GO JQ37.

JQ4. INITIALIZE JQ-KBAT JQ-DATE JQ-PAYEE JQ-TOTNUM JQ-TOTAMT.
JQ43. READ EDI END PERFORM EDI-ERR GO JQ9. PERFORM EL-CLR.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP GO JQ35.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP GO JQ44.
    IF ED-RECORD(1:3)="BAT" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO JQ-KBAT
      GO JQ438.
    IF ED-RECORD(1:3)="DEP" AND ED-RECORD(4:1)=ED-SEP
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
      PERFORM EL-RDVAL IF ED-VAL NOT=WS-HBOX GO JQ37 END-IF
      UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
      MOVE "102" TO ED-DFQUAL PERFORM EL-RDATE MOVE D-DATE TO JQ-DATE
      GO JQ438.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="PE" MOVE WA2 TO JQ-PAYEE END-IF
      GO JQ438.
    IF ED-RECORD(1:3)="QTY" AND ED-RECORD(4:1)=ED-SEP
      IF JQ-KBAT=1 GO JQ438 END-IF
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="42" PERFORM EL-RDVAL MOVE ED-VAL TO JQ-TOTNUM END-IF
      GO JQ438.
    IF ED-RECORD(1:3)="AMT" AND ED-RECORD(4:1)=ED-SEP
      IF JQ-KBAT=1 GO JQ438 END-IF
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH
      IF WA1="3" PERFORM EL-RDVAL MOVE ED-VAL TO JQ-TOTAMT END-IF
      GO JQ438.
JQ438. GO JQ43.
JQ44. MOVE 3 TO WS-PR MOVE "PAYEE:" TO FD497 MOVE JQ-PAYEE TO FD498 PERFORM JQ-LINE.
    MOVE "DATE:" TO FD497 MOVE JQ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD498C PERFORM JQ-LINE.
    MOVE "NUM CHQS:" TO FD497 MOVE JQ-TOTNUM TO FD498B PERFORM JQ-LINE.
    MOVE "TOTAL:" TO FD497 MOVE JQ-TOTAMT TO FD498A PERFORM JQ-LINE 3 TIMES.

* BPR records
    MOVE 0 TO JQ-KFIN.
JQ45. INITIALIZE JQ-KFIR JQ-ITEM JQ-PAYER JQ-CHQNO JQ-CHQAMT.
    UNSTR-RECORD INTO ED-LINE ED-LINE ED-LINE COUNT ED-LTH.
    PERFORM EL-RDVAL MOVE ED-VAL TO JQ-CHQAMT.

JQ47. READ EDI END PERFORM EDI-ERR GO JQ9. PERFORM EL-CLR.
    IF ED-RECORD(1:2)="SE" AND ED-RECORD(3:1)=ED-SEP MOVE 1 TO JQ-KFIN GO JQ48.
    IF ED-RECORD(1:3)="BPR" AND ED-RECORD(4:1)=ED-SEP GO JQ48.
    IF ED-RECORD(1:3)="REF" AND ED-RECORD(4:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 ED-LINE COUNT ED-LTH PERFORM EL-RDVAL
      IF WA1="CK" MOVE ED-VAL TO JQ-CHQNO END-IF
      IF WA1="ZZ" MOVE ED-VAL TO JQ-ITEM END-IF
      GO JQ478.
    IF ED-RECORD(1:2)="N1" AND ED-RECORD(3:1)=ED-SEP
      UNSTR-RECORD INTO ED-LINE WA1 WA2
      IF WA1="PR" MOVE WA2 TO JQ-PAYER END-IF
      GO JQ478.
    IF ED-RECORD(1:3)="RMR" AND ED-RECORD(4:1)=ED-SEP
      IF JQ-KFIR=0 MOVE JQ-ITEM TO FD490 MOVE JQ-PAYER TO FD491
        MOVE JQ-CHQNO TO FD492 MOVE JQ-CHQAMT TO FD493 MOVE 1 TO JQ-KFIR END-IF
      MOVE 1 TO ED-PTR UNSTR-RECORD INTO ED-LINE WA1 POINTER ED-PTR
      IF WA1="IV"
        UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR
        PERFORM EL-RDVAL MOVE ED-VAL TO JQ-INVNO
        UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR
        PERFORM EL-RDVAL MOVE ED-VAL TO JQ-INVAMT
        MOVE JQ-INVNO TO FD494 MOVE JQ-INVAMT TO FD495 PERFORM JQ-LINE END-IF
      GO JQ478.
JQ478. GO JQ47.
JQ48. PERFORM JQ-LINE.
    IF JQ-KFIN=0 GO JQ45. GO JQ35.
JQ9. CLOSE EDI PERFORM CLOSE-PR GO MN9.

JQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JQ-PAGE.
JQ-PAGE. MOVE "BANK EDI LOCKBOX DEPOSIT (823) LISTING" TO FF3 PERFORM PR-IPAGE.
    MOVE "ITEM  PAYER                  CHQ NO       CHQ AMT     INV NO         AMT" TO PREC PERFORM PR-LINE-3.
*         ...   ....................  .......  .,...,...:..-   ....... .,...,...:..-
    REPLACE OFF.

* A: PREVENTIVE MAINTENANCE FUNCTIONS

* A-1 MODIFY MASTER ORDER
KA1.
KA3. PERFORM RD181 PERFORM WRT.
    MOVE LOW-VALUES TO MF-RECORD INITIALIZE MF-REC.
KA33. ACCEPT MF-MAC LINE 1 COLUMN 50 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR MF-MAC=999 GO KA9.
    MOVE MF-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY
      MOVE "MUST BE A PRIMARY MACHINE" TO ERR-MESG PERFORM DSP-ERR GO KA33.
    MOVE MF-MAC TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO KA33.
    DISPLAY M-DESC1 LINE 2 COLUMN 50.
    ACCEPT MF-SEC LINE 1 COLUMN 54 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO KA9.
    ACCEPT MF-LEVEL LINE 1 COLUMN 57 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO KA9.
    READ MNTMAST REGARDLESS INVALID MOVE 0 TO KA-KFIN GO KA4. MOVE 1 TO KA-KFIN.

    DISPLAY MF-EST-HOURS LINE 3 COLUMN 20 CONVERSION.
    MOVE 1 TO IX1 MOVE 6 TO IXT PERFORM UNTIL IX1>3
      IF MF-NOTE(IX1)>" " DISPLAY MF-NOTE(IX1) LINE IXT COLUMN 9 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 11 TO IXT MOVE 1 TO IXCOL MOVE 1 TO IX1.
KA35. COMPUTE IXU=(IXCOL - 1) * 14 + 1.
    IF MF-PROC(IX1) NOT=0 DISPLAY MF-PROC(IX1) LINE IXT COLUMN IXU CONVERSION.
    IF MF-HOURS(IX1) NOT=0 DISPLAY MF-HOURS(IX1) LINE IXT COLUMN IXU PLUS 4 CONVERSION.
    ADD 1 TO IXCOL IF IXCOL>6 ADD 1 TO IXT MOVE 1 TO IXCOL.
    ADD 1 TO IX1 IF IX1<=12 GO KA35.
    MOVE 15 TO IXT MOVE 1 TO IXCOL MOVE 1 TO IX1.
KA37. COMPUTE IXU=(IXCOL - 1) * 26 + 1.
    IF MF-PART(IX1)>" " DISPLAY MF-PART(IX1) LINE IXT COLUMN IXU.
    IF MF-QTY(IX1) NOT=0 DISPLAY MF-QTY(IX1) LINE IXT COLUMN IXU PLUS 13 CONVERSION.
    ADD 1 TO IXCOL IF IXCOL>3 ADD 1 TO IXT MOVE 1 TO IXCOL.
    ADD 1 TO IX1 IF IX1<=24 GO KA37.
KA4.
KA43. PERFORM DSP-NEXT ACCEPT KA-OP LINE 1 COLUMN 77 DEFAULT " "
       UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KA9. IF KA-OP=" " GO KA3.
    IF NOT(KA-OP="A" OR "C" OR "DEL") PERFORM DSP-ERR1 GO KA43.
    IF KA-OP="A" AND KA-KFIN=1 MOVE "DUPLICATE MASTER RECORD"
      TO ERR-MESG PERFORM DSP-ERR GO KA3.
    IF (KA-OP="C" OR "DEL") AND KA-KFIN=0 MOVE "MASTER RECORD NOT FOUND"
      TO ERR-MESG PERFORM DSP-ERR GO KA3.
    IF KA-OP="DEL" DELETE MNTMAST GO KA3.

* op="A", "C"
    ACCEPT MF-EST-HOURS LINE 3 COLUMN 20 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KA54.
    DISPLAY MF-EST-HOURS LINE 3 COLUMN 20 CONVERSION.
    MOVE 1 TO IX1 MOVE 6 TO IXT PERFORM UNTIL IX1>3
      ACCEPT MF-NOTE(IX1) LINE IXT COLUMN 9 DEFAULT CURRENT
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO KA54 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
KA54. MOVE 11 TO IXT MOVE 1 TO IXCOL MOVE 1 TO IX1.
KA55. COMPUTE IXU=(IXCOL - 1) * 14 + 1.
    ACCEPT MF-PROC(IX1) LINE IXT COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KA56.
    IF MF-PROC(IX1)=0 MOVE 0 TO MF-HOURS(IX1) GO KA556.
    MOVE MF-PROC(IX1) TO A-N1 PERFORM PROC-TYPE.
    IF NOT PROC-MAINT PERFORM DSP-ERR34 GO KA55.
    MOVE MF-PROC(IX1) TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO KA55.
    DISPLAY MF-PROC(IX1) LINE IXT COLUMN IXU CONVERSION.
    ACCEPT MF-HOURS(IX1) LINE IXT COLUMN IXU PLUS 4 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KA56.
KA556. DISPLAY MF-HOURS(IX1) LINE IXT COLUMN IXU PLUS 4 CONVERSION.
    ADD 1 TO IXCOL IF IXCOL>6 ADD 1 TO IXT MOVE 1 TO IXCOL.
    ADD 1 TO IX1 IF IX1<=12 GO KA55.
KA56. MOVE 15 TO IXT MOVE 1 TO IXCOL MOVE 1 TO IX1.
KA57. COMPUTE IXU=(IXCOL - 1) * 26 + 1.
    ACCEPT MF-PART(IX1) LINE IXT COLUMN IXU DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO KA58.
    IF MF-PART(IX1)=" " MOVE 0 TO MF-QTY(IX1) GO KA576.
    MOVE MF-PART(IX1) TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO KA57.
    ACCEPT MF-QTY(IX1) LINE IXT COLUMN IXU PLUS 13 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KA58.
KA576. DISPLAY MF-QTY(IX1) LINE IXT COLUMN IXU PLUS 13 CONVERSION.
    ADD 1 TO IXCOL IF IXCOL>3 ADD 1 TO IXT MOVE 1 TO IXCOL.
    ADD 1 TO IX1 IF IX1<=24 GO KA57.
KA58. IF KA-OP="A" WRITE MF-RECORD ALLOWING NO ELSE REWRITE MF-RECORD ALLOWING NO.
    UNLOCK MNTMAST PERFORM DSP-CONT GO KA3.
KA9. GO MN9.

* A-2 MODIFY MAINTENANCE ORDER
KC1. MOVE 0 TO KC-ONO.
KC3. PERFORM RD182 PERFORM WRT PERFORM INIT-VO.
    DISPLAY "'PF1' TO SHOW PREVIOUS ORDER NO." LINE 24 BOLD.
    ACCEPT VO-NO LINE 1 COLUMN 37 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 OR VO-NO=999999 GO KC9.
    IF KPF1 MOVE KC-ONO TO VO-NO DISPLAY VO-NO LINE 1 COLUMN 37 CONVERSION.
    READ MNTORD REGARDLESS INVALID MOVE 0 TO KC-KFIN GO KC4.
    MOVE 1 TO KC-KFIN MOVE VO-NO TO KC-ONO.
    DISPLAY LIT-PE(VO-TYPE + 1:1) LINE 3 COLUMN 12.
    MOVE VO-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 3 COLUMN 25.
    DISPLAY VO-PRIOR LINE 3 COLUMN 49 CONVERSION.
    PERFORM MNT-SETMAC DISPLAY MNT-IMAC LINE 4 COLUMN 25 CONVERSION.
    DISPLAY VO-SEC LINE 4 COLUMN 30 CONVERSION VO-LEVEL COLUMN 33 CONVERSION
      VO-DEPT COLUMN 50 CONVERSION VO-SECT COLUMN 53 CONVERSION.
    PERFORM MNT-DESC DISPLAY MNT-DESC1 LINE 5 COLUMN 25 MNT-DESC2 LINE 6 COLUMN 25.
    DISPLAY VO-STATUS LINE 7 COLUMN 10 CONVERSION.
    MOVE VO-DN-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 7 COLUMN 57.
    MOVE VO-DN-TIME TO D-TIME PERFORM D-PR-TIME DISPLAY D-PRTIME LINE 7 COLUMN 65.
    MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>3
      IF VO-NOTE(IX1)>" " DISPLAY VO-NOTE(IX1) LINE IXT COLUMN 9 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
KC4.
KC43. PERFORM DSP-NEXT ACCEPT KC-OP LINE 1 COLUMN 77 DEFAULT "L"
       UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC9. IF KC-OP=" " GO KC3.
    IF NOT(KC-OP="A" OR "C" OR "DEL" OR "L" OR "P") PERFORM DSP-ERR1 GO KC43.
    IF KC-OP="A" IF VO-NO NOT=0 MOVE "MUST LEAVE ORDER NO. BLANK FOR NEW ORDER"
       TO ERR-MESG PERFORM DSP-ERR GO KC3 END-IF
      PERFORM RD-INFO ADD 1 TO IF-MAINTNO PERFORM WR-INFO
      MOVE IF-MAINTNO TO VO-NO DISPLAY VO-NO LINE 1 COLUMN 37 CONVERSION
      READ MNTORD REGARDLESS INVALID MOVE VO-NO TO KC-ONO GO KC50 END-READ
      PERFORM DSP-ERR31 GO KC3.
* op="C", "DEL", "L", "P"
    IF KC-KFIN=0 MOVE "ORDER NOT FOUND" TO ERR-MESG PERFORM DSP-ERR GO KC3.
    IF KC-OP="C" GO KC50. IF KC-OP="L" GO KC6. IF KC-OP="P" GO KC8.

* op="DEL"
KC45. MOVE 0 TO IX1 INITIALIZE VL-KEY MOVE VO-NO TO VL-NO.
    START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO KC48.
KC47. READ MNTLIN NEXT REGARDLESS END GO KC48. IF VL-NO NOT=VO-NO GO KC48.
    DELETE MNTLIN ADD 1 TO IX1.
    IF IX1=100 CLOSE MNTLIN OPEN I-O MNTLIN ALLOWING ALL GO KC45. GO KC47.
KC48. DELETE MNTORD GO KC3.

KC50. DISPLAY "- PF3 TO END" LINE 23 COLUMN 68 BOLD.
    MOVE LIT-PE(VO-TYPE + 1:1) TO XA1.
KC53. ACCEPT XA1 LINE 3 COLUMN 12 DEFAULT CURRENT
       UNDERLINED PROTECTED KEY CKEY IF KPF3 GO KC58.
    IF XA1="P" MOVE 0 TO VO-TYPE ELSE IF XA1="E" MOVE 1 TO VO-TYPE
      ELSE PERFORM DSP-ERR2 GO KC53.
    IF KC-OP="A" MOVE SYS-DATE TO VO-DATE VO-DN-DATE.
    MOVE VO-DATE TO D-DATE MOVE 3 TO IXT MOVE 25 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO KC58. MOVE DATE0 TO VO-DATE.
KC553. ACCEPT VO-PRIOR LINE 3 COLUMN 49 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KC58.
    DISPLAY VO-PRIOR LINE 3 COLUMN 49 CONVERSION.
    IF NOT(VO-PRIOR>=1 AND<=5) PERFORM DSP-ERR2 GO KC553.
KC57. DISPLAY "IF NEITHER PRODUCTION NOR NON-PRODUCTION MACHINE, LEAVE MACHINE FIELD BLANK" LINE 24 BOLD.
    PERFORM MNT-SETMAC ACCEPT MNT-IMAC LINE 4 COLUMN 25 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS IF KPF3 GO KC58.
    PERFORM MNT-GETMAC IF MNT-KERR=1 GO KC57. MOVE MNT-MAC TO VO-MAC MOVE MNT-KM TO VO-MAC-IND.
    IF VO-MAC=0
      ACCEPT VO-MDESC1 LINE 5 COLUMN 25 DEFAULT CURRENT
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO KC58 END-IF
      ACCEPT VO-MDESC2 LINE 6 COLUMN 25 DEFAULT CURRENT
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO KC58 END-IF
      GO KC574.
    PERFORM MNT-RDMAC IF A-S1=1 GO KC57.
    IF VO-MAC-IND=0 DISPLAY M-DESC1 LINE 5 COLUMN 25 M-DESC2 LINE 6 COLUMN 25
      ELSE DISPLAY MK-DESC1 LINE 5 COLUMN 25 MK-DESC2 LINE 6 COLUMN 25.
    ACCEPT VO-SEC LINE 4 COLUMN 30 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KC58.
    DISPLAY VO-SEC LINE 4 COLUMN 30 CONVERSION.
    ACCEPT VO-LEVEL LINE 4 COLUMN 33 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KC58.
    DISPLAY VO-LEVEL LINE 4 COLUMN 33 CONVERSION.
    IF KC-OP="A" IF VO-MAC-IND=0 MOVE M-GROUP TO VO-DEPT MOVE M-SECT TO VO-SECT
                   ELSE MOVE MK-DEPT TO VO-DEPT MOVE MK-SECT TO VO-SECT.
KC574. ACCEPT VO-DEPT LINE 4 COLUMN 50 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KC58.
    DISPLAY VO-DEPT LINE 4 COLUMN 50 CONVERSION.
    ACCEPT VO-SECT LINE 4 COLUMN 53 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KC58.
    DISPLAY VO-SECT LINE 4 COLUMN 53 CONVERSION.
KC575. ACCEPT VO-STATUS LINE 7 COLUMN 10 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO KC58.
    DISPLAY VO-STATUS LINE 7 COLUMN 10 CONVERSION.
    IF NOT(VO-STATUS>=0 AND<=2) PERFORM DSP-ERR2 GO KC575.
    IF VO-MAC=0 GO KC578.
    MOVE VO-DN-DATE TO D-DATE MOVE 7 TO IXT MOVE 57 TO IXU.
    MOVE 3 TO D-PF PERFORM AX-DT-DEF IF KPF3 GO KC58. MOVE DATE0 TO VO-DN-DATE.
    MOVE VO-DN-TIME TO D-TIME MOVE 7 TO IXT MOVE 65 TO IXU.
    PERFORM AX-TIME MOVE D-TIME TO VO-DN-TIME.
KC578. MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>3
      ACCEPT VO-NOTE(IX1) LINE IXT COLUMN 9 DEFAULT CURRENT
        UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO KC58 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
KC58. DISPLAY " " LINE 23 COLUMN 68 ERASE END LINE.
    IF KC-OP="A" PERFORM MNT-SET-VO WRITE VO-RECORD ALLOWING NO
      ELSE REWRITE VO-RECORD ALLOWING NO.
    UNLOCK MNTORD PERFORM DSP-CONT GO KC3.

KC6. MOVE 0 TO KC-TYPE.
KC63. PERFORM KC-INIT.
KC631. IF VL-PROC=0 MOVE 975 TO VL-PROC. PERFORM KC-DL.
    DISPLAY "LABOUR MAINT. PROCESSES" LINE 17 COLUMN 35 BOLD
      "975: MECHANICAL MAINT" LINE PLUS COLUMN 35
      "976: ELECTRICAL MAINT" LINE PLUS COLUMN 35
      "985: MECHANICAL MAINT-2" LINE PLUS COLUMN 35
      "977-984: OTHERS" LINE PLUS COLUMN 35.
    PERFORM KC-MD ACCEPT VL-PROC LINE 13 COLUMN 21 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    DISPLAY LIT-SP(1:30) LINE 13 COLUMN 26.
    PERFORM VARYING IXT FROM 17 BY 1 UNTIL IXT>21
      DISPLAY LIT-SP(1:25) LINE IXT COLUMN 35 END-PERFORM.
    IF KPF4 GO KC69. IF KP-DOWN PERFORM KC-NEXT GO KC631.
    DISPLAY VL-PROC LINE 13 COLUMN 21 CONVERSION.
    MOVE VL-PROC TO A-N1 PERFORM PROC-TYPE.
    IF NOT PROC-MAINT PERFORM DSP-ERR34 GO KC631.
    MOVE VL-PROC TO M-NO READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO KC631.
    DISPLAY M-DESC1 LINE 13 COLUMN 26.
    MOVE VL-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 14 COLUMN 18.
KC633. PERFORM KC-MD ACCEPT D-DT LINE 14 COLUMN 18 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC69. IF KP-DOWN PERFORM KC-NEXT GO KC631.
    DISPLAY D-DT LINE 14 COLUMN 18 PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO KC633.
    PERFORM D-MN MOVE D-DATE TO VL-DATE.
    MOVE LIT-XDAN(VL-SHIFT + 1:1) TO XA1.
KC635. PERFORM KC-MD ACCEPT XA1 LINE 14 COLUMN 42 DEFAULT CURRENT
        UNDERLINED PROTECTED KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC69. IF KP-DOWN PERFORM KC-NEXT GO KC631.
    PERFORM CHK-SHIFT IF A-N1=0 OR>3 PERFORM DSP-ERR24 GO KC635.
    MOVE A-N1 TO VL-SHIFT.
KC637. PERFORM KC-MD ACCEPT VL-EMP LINE 15 COLUMN 19 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC69. IF KP-DOWN PERFORM KC-NEXT GO KC631.
    DISPLAY VL-EMP LINE 15 COLUMN 19 CONVERSION.
    MOVE WS-PDIV TO E-DIV MOVE VL-EMP TO E-NO.
    READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO KC637.
    DISPLAY E-NAME LINE 15 COLUMN 25.
    READ MNTLIN REGARDLESS INVALID MOVE 0 TO KC-KFIN GO KC66. MOVE 1 TO KC-KFIN.
    DISPLAY VL-HOURS LINE 16 COLUMN 19 CONVERSION.
KC66.
KC663. PERFORM DSP-NEXT ACCEPT KC-OQ LINE 13 COLUMN 77 DEFAULT "A"
        UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC69. IF KC-OQ=" " GO KC63.
    IF NOT(KC-OQ="A" OR "DEL") PERFORM DSP-ERR1 GO KC663.
    IF KC-OQ="DEL"
      IF KC-KFIN=0 MOVE "LABOUR ENTRY NOT FOUND" TO ERR-MESG PERFORM DSP-ERR
        ELSE DELETE MNTLIN END-IF GO KC63.
* oq="A"
    MOVE 0 TO KC-KADD.
    IF KC-KFIN=1 MOVE "THIS ENTRY EXISTS - 'A' TO ADD TO PREVIOUS HOURS: _" TO TMSG
      PERFORM DSP-PROMPT IF XA3="A" MOVE 1 TO KC-KADD.
    IF KC-KADD=0 MOVE VL-HOURS TO KC-HOURS MOVE 19 TO IXU
      ELSE DISPLAY "HOURS TO ADD  _____" LINE 16 COLUMN 30 BOLD
        MOVE 0 TO KC-HOURS MOVE 44 TO IXU.
    DISPLAY KC-HOURS LINE 16 COLUMN IXU CONVERSION.
    ACCEPT KC-HOURS LINE 16 COLUMN IXU DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY KC-HOURS LINE 16 COLUMN IXU CONVERSION.
    IF KC-KADD=0 MOVE KC-HOURS TO VL-HOURS
      ELSE ADD KC-HOURS TO VL-HOURS DISPLAY LIT-SP(1:19) LINE 16 COLUMN 30.

    IF KC-KFIN=0 WRITE VL-RECORD ALLOWING NO ELSE REWRITE VL-RECORD ALLOWING NO.
    UNLOCK MNTLIN.
    MOVE VL-NO TO VO-NO READ MNTORD REGARDLESS MOVE 1 TO VO-STATUS.
    REWRITE VO-RECORD ALLOWING NO UNLOCK MNTORD GO KC63.
KC69. MOVE "IS THIS ORDER CLOSED ? ___" TO TMSG PERFORM DSP-PROMPT.
    IF XA3="YES" MOVE VL-NO TO VO-NO READ MNTORD REGARDLESS MOVE 2 TO VO-STATUS
      REWRITE VO-RECORD ALLOWING NO UNLOCK MNTORD.
    GO KC3.

KC8. MOVE 1 TO KC-TYPE.
KC83. PERFORM KC-INIT.
KC831. PERFORM KC-DP.
    PERFORM KC-MD ACCEPT VL-PART LINE 19 COLUMN 18 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC89. IF KP-DOWN PERFORM KC-NEXT GO KC831.
    MOVE VL-PART TO PH-NO READ PART REGARDLESS INVALID PERFORM DSP-ERR3 GO KC831.
    DISPLAY PH-DESC1 LINE 19 COLUMN 32.
    MOVE VL-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 20 COLUMN 18.
KC833. PERFORM KC-MD ACCEPT D-DT LINE 20 COLUMN 18 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC89. IF KP-DOWN PERFORM KC-NEXT GO KC831.
    DISPLAY D-DT LINE 20 COLUMN 18 PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO KC833.
    PERFORM D-MN MOVE D-DATE TO VL-DATE.
KC837. PERFORM KC-MD ACCEPT VL-EMP LINE 21 COLUMN 19 DEFAULT CURRENT
        UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC89. IF KP-DOWN PERFORM KC-NEXT GO KC831.
    DISPLAY VL-EMP LINE 21 COLUMN 19 CONVERSION.
    MOVE WS-PDIV TO E-DIV MOVE VL-EMP TO E-NO.
    READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO KC837.
    DISPLAY E-NAME LINE 21 COLUMN 25.
    READ MNTLIN REGARDLESS INVALID MOVE 0 TO KC-KFIN GO KC86. MOVE 1 TO KC-KFIN.
    DISPLAY VL-QTY LINE 22 COLUMN 17 CONVERSION.
KC86.
KC863. PERFORM DSP-NEXT ACCEPT KC-OQ LINE 19 COLUMN 77 DEFAULT "A"
        UNDERLINED PROTECTED EDITING KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KC89. IF KC-OQ=" " GO KC83.
    IF NOT(KC-OQ="A" OR "C" OR "DEL") PERFORM DSP-ERR1 GO KC863.
    IF KC-OQ="A" AND KC-KFIN=1 MOVE "DUPLICATE PART ENTRY"
      TO ERR-MESG PERFORM DSP-ERR GO KC83.
    IF (KC-OQ="C" OR "DEL") AND KC-KFIN=0 MOVE "PART ENTRY NOT FOUND"
      TO ERR-MESG PERFORM DSP-ERR GO KC83.
    IF KC-OQ="DEL" DELETE MNTLIN GO KC83.

* oq="A" or "C"
    ACCEPT VL-QTY LINE 22 COLUMN 17 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY VL-QTY LINE 22 COLUMN 17 CONVERSION.
    IF KC-OQ="A" WRITE VL-RECORD ALLOWING NO ELSE REWRITE VL-RECORD ALLOWING NO.
    UNLOCK MNTLIN GO KC83.
KC89. GO KC3.
KC9. GO MN9.

KC-DL. DISPLAY VL-PROC LINE 13 COLUMN 21 CONVERSION.
    MOVE VL-PROC TO A-N1 PERFORM RD-MAC DISPLAY M-DESC1 LINE 13 COLUMN 26.
    MOVE VL-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 14 COLUMN 18.
    DISPLAY LIT-XDAN(VL-SHIFT + 1:1) LINE 14 COLUMN 42.
    DISPLAY VL-EMP LINE 15 COLUMN 19 CONVERSION.
    PERFORM MNT-GET-NAME DISPLAY A-A1(1:30) LINE 15 COLUMN 25.
    DISPLAY VL-HOURS LINE 16 COLUMN 19 CONVERSION.
KC-DP. DISPLAY VL-PART LINE 19 COLUMN 18.
    MOVE VL-PART TO A-A1 PERFORM RD-PART DISPLAY PH-DESC1 LINE 19 COLUMN 32.
    MOVE VL-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 20 COLUMN 18.
    DISPLAY VL-EMP LINE 21 COLUMN 19 CONVERSION.
    PERFORM MNT-GET-NAME DISPLAY A-A1(1:30) LINE 21 COLUMN 25.
    DISPLAY VL-QTY LINE 22 COLUMN 17 CONVERSION.
KC-NEXT. PERFORM KC-N1 THRU KC-N9.
KC-N1. START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO KC-N4.
KC-N3. READ MNTLIN NEXT REGARDLESS END GO KC-N4. IF VL-NO NOT=VO-NO GO KC-N4.
    IF VL-TYPE NOT=KC-TYPE GO KC-N3. GO KC-N9.
KC-N4. PERFORM KC-INIT.
KC-N9. EXIT.
KC-MD. DISPLAY "- 'DOWN' ARROW FOR NEXT ENTRY" LINE 24 COLUMN 51 BOLD.
KC-INIT. MOVE KC-TYPE TO A-N1 PERFORM INIT-VL.

* A-3 SHOW MAINTENANCE ORDER
KE1. PERFORM RD183 MOVE 0 TO VO-NO MOVE 5 TO IXT.
KE3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
KE33. DISPLAY "NEXT ORDER NO.: ______       (LAST ORDER CREATED:      )" LINE IXT.
    PERFORM RDR-INFO DISPLAY IF-MAINTNO COLUMN 50 CONVERSION.
    ACCEPT IA31 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR IA31=999999 GO KE9.
    IF IA31=0 IF VO-NO=0 GO KE33 ELSE GO KE4. MOVE IA31 TO VO-NO.
    START MNTORD KEY>=VO-KEY REGARDLESS INVALID PERFORM DSP-ERR8
      MOVE 0 TO VO-NO GO KE33.
    READ MNTORD NEXT REGARDLESS MOVE 0 TO INQ-IND.
KE4. PERFORM RD183 MOVE VO-NO TO TF122(1) MOVE LIT-PE(VO-TYPE + 1:1) TO TF123(1).
    PERFORM MNT-SETMAC MOVE MNT-IMAC TO TF125(1).
    MOVE VO-SEC TO TF126(1) MOVE VO-LEVEL TO TF127(1).
    MOVE VO-PRIOR TO TF128(1) PERFORM MNT-PRIOR MOVE A-A1 TO TF128A(1).
    MOVE VO-USER TO TF144(2).
    MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF145(2).
    MOVE VO-TIME TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO TF146(2).
    PERFORM MNT-STATUS MOVE A-A1 TO TF139(3).
    IF VO-MAC>0 MOVE VO-DN-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF142(4)
      MOVE VO-DN-TIME TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO TF143(4).
    PERFORM MNT-DESC MOVE MNT-DESC1 TO TF147(2) MOVE MNT-DESC2 TO TF147(3).
    MOVE 0 TO WS1 MOVE 5 TO IXT PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      IF VO-NOTE(IX1)>" " PERFORM CLR-LN
        IF WS1=0 MOVE "!NOTES]" TO TF129(IXT) MOVE 1 TO WS1 END-IF
        MOVE VO-NOTE(IX1) TO TF129A(IXT) ADD 1 TO IXT END-IF END-PERFORM.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      IF VO-COMMENT(IX1)>" " PERFORM CLR-LN
        IF WS1=0 MOVE "!COMMENTS]" TO TF129(IXT) MOVE 1 TO WS1 END-IF
        MOVE VO-COMMENT(IX1) TO TF129A(IXT) ADD 1 TO IXT END-IF END-PERFORM.
    MOVE "^PROC/PART   DESCRIPTION                 DATE     EMPLOYEE              HRS/QTY]" TO TLN(IXT).
*         ............ ......................... ../../.. . ... .................... ...:.
    ADD 1 TO IXT.
    IF INQ-IND=0 INITIALIZE VL-KEY MOVE VO-NO TO VL-NO
      START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO KE8.
KE5. READ MNTLIN NEXT REGARDLESS END GO KE8. IF VL-NO NOT=VO-NO GO KE8.
    PERFORM CLR-LN.
    IF VL-TYPE=0 MOVE VL-PROC TO TF131(IXT) A-N1 PERFORM RD-MAC
      MOVE M-DESC1(1:25) TO TF132(IXT)
     ELSE MOVE VL-PART TO TF130(IXT) A-A1 PERFORM RD-PART
      MOVE PH-DESC1(1:25) TO TF132(IXT).
    MOVE VL-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF133(IXT).
    IF VL-TYPE=0 MOVE LIT-XDAN(VL-SHIFT + 1:1) TO TF134(IXT).
    MOVE VL-EMP TO TF135(IXT) PERFORM MNT-GET-NAME MOVE A-A1(1:20) TO TF136(IXT).
    IF VL-TYPE=0 MOVE VL-HOURS TO TF138(IXT) ELSE MOVE VL-QTY TO TF137(IXT).
    ADD 1 TO IXT IF IXT<22 GO KE5.
    MOVE "*** MORE ***" TO TLN(IXT) MOVE 1 TO INQ-IND GO KE89.
KE8. MOVE "*** END ***" TO TLN(IXT).
    READ MNTORD NEXT REGARDLESS END MOVE 0 TO VO-NO GO KE89. MOVE 0 TO INQ-IND.
KE89. GO KE3.
KE9. GO MN9.

* A-4 GENERATE EMERGENCY ORDER
KF1.
KF3. PERFORM RD184 PERFORM WRT.
    DISPLAY "PRESS 'RETURN' TO START A NEW ORDER, OR PF4 TO END" LINE 24 BOLD.
    ACCEPT XA1 COLUMN 80 PROTECTED AUTOTERMINATE KEY CKEY PERFORM DSP-ERS.
    IF KPF4 GO KF9.
    PERFORM INIT-VO PERFORM RD-INFO ADD 1 TO IF-MAINTNO PERFORM WR-INFO.
    MOVE IF-MAINTNO TO VO-NO DISPLAY VO-NO LINE 1 COLUMN 46 CONVERSION.
    READ MNTORD REGARDLESS INVALID GO KF4. PERFORM DSP-ERR31 GO KF3.
KF4. MOVE "M" TO KF-ME.
KF41. ACCEPT KF-ME LINE 2 COLUMN 72 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF NOT(KF-ME="M" OR "E") PERFORM DSP-ERR2 GO KF41.
    MOVE 1 TO VO-TYPE MOVE SYS-DATE TO VO-DATE VO-DN-DATE.
    MOVE VO-DATE TO D-DATE MOVE 3 TO IXT MOVE 8 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO VO-DATE.
KF45. ACCEPT VO-PRIOR LINE 3 COLUMN 30 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(VO-PRIOR>=1 AND<=5) PERFORM DSP-ERR2 GO KF45.
    PERFORM MNT-PRIOR DISPLAY A-A1(1:13) LINE 3 COLUMN 32.
KF47. DISPLAY "IF NEITHER PRODUCTION NOR NON-PRODUCTION MACHINE, LEAVE MACHINE FIELD BLANK" LINE 24 BOLD.
    PERFORM MNT-SETMAC ACCEPT MNT-IMAC LINE 4 COLUMN 25 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    PERFORM MNT-GETMAC IF MNT-KERR=1 GO KF47. MOVE MNT-MAC TO VO-MAC MOVE MNT-KM TO VO-MAC-IND.
    IF VO-MAC=0
      ACCEPT VO-MDESC1 LINE 5 COLUMN 25 DEFAULT " " UNDERLINED PROTECTED EDITING
      ACCEPT VO-MDESC2 LINE 6 COLUMN 25 DEFAULT " " UNDERLINED PROTECTED EDITING
      GO KF48.
    PERFORM MNT-RDMAC IF A-S1=1 GO KF47.
    IF VO-MAC-IND=0 DISPLAY M-DESC1 LINE 5 COLUMN 25 M-DESC2 LINE 6 COLUMN 25
      ELSE DISPLAY MK-DESC1 LINE 5 COLUMN 25 MK-DESC2 LINE 6 COLUMN 25.
    ACCEPT VO-SEC LINE 4 COLUMN 30 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY VO-SEC LINE 4 COLUMN 30 CONVERSION.
    ACCEPT VO-LEVEL LINE 4 COLUMN 33 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY VO-LEVEL LINE 4 COLUMN 33 CONVERSION.
    IF VO-MAC-IND=0 MOVE M-GROUP TO VO-DEPT MOVE M-SECT TO VO-SECT
      ELSE MOVE MK-DEPT TO VO-DEPT MOVE MK-SECT TO VO-SECT.
KF48. IF VO-MAC=0 GO KF54.
    MOVE VO-DN-DATE TO D-DATE MOVE 7 TO IXT MOVE 57 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO VO-DN-DATE.
    MOVE VO-DN-TIME TO D-TIME MOVE 7 TO IXT MOVE 65 TO IXU PERFORM AX-TIME.
    MOVE D-TIME TO VO-DN-TIME.
KF54. MOVE 1 TO IX1 MOVE 8 TO IXT PERFORM UNTIL IX1>3
       ACCEPT VO-NOTE(IX1) LINE IXT COLUMN 9 DEFAULT " " UNDERLINED PROTECTED EDITING
       ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 13 TO IXT PERFORM AX-OK.
    IF XA2 NOT="OK" PERFORM RD-INFO IF IF-MAINTNO=VO-NO SUBTRACT 1 FROM IF-MAINTNO END-IF
      PERFORM WR-INFO GO KF6.
    PERFORM MNT-SET-VO WRITE VO-RECORD ALLOWING NO UNLOCK MNTORD.

    PERFORM OPEN-PDOC STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM DOC-LINE.
    PERFORM KH-PAGE MOVE ALL "-" TO PREC(1:80) PERFORM DOC-LINE.
    STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM DOC-LINE.
    PERFORM CLOSE-DOC.
    IF KF-ME="M" MOVE "MAINT" TO DOC-QUEUE ELSE MOVE "ELEC" TO DOC-QUEUE.
    PERFORM PRINT-DOC.
KF6. GO KF3.
KF9. GO MN9.

* A-5 PRINT MAINTENANCE ORDER
KH1. PERFORM RD185 PERFORM WRT.
KH13. ACCEPT VO-NO LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
* note 256.2
    IF KPF4 OR VO-NO=0 GO KH9.
    READ MNTORD REGARDLESS INVALID PERFORM DSP-ERR25 GO KH13.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-DOC.
    STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM DOC-LINE.

    PERFORM KH-PAGE PERFORM KH-HEAD INITIALIZE VL-KEY MOVE VO-NO TO VL-NO.
    START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO KH8.
KH3. READ MNTLIN NEXT REGARDLESS END GO KH8. IF VL-NO NOT=VO-NO GO KH8.
    IF VL-TYPE=0 MOVE VL-PROC TO FD351 A-N1 PERFORM RD-MAC MOVE M-DESC1(1:25) TO FD352
      ELSE MOVE VL-PART TO FD350 A-A1 PERFORM RD-PART MOVE PH-DESC1(1:25) TO FD352.
    MOVE VL-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD353.
    IF VL-TYPE=0 MOVE LIT-XDAN(VL-SHIFT + 1:1) TO FD354.
    MOVE VL-EMP TO FD355 PERFORM MNT-GET-NAME MOVE A-A1(1:20) TO FD356.
    IF VL-TYPE=0 MOVE VL-HOURS TO FD358 ELSE MOVE VL-QTY TO FD357.
    PERFORM DOC-LINE IF DOC-LINES>60 STRING EPS-FF DELIMITED SIZE INTO PREC PERFORM DOC-LINE
      MOVE 1 TO DOC-LINES ADD 1 TO DOC-PAGE MOVE "PAGE" TO FD347 MOVE DOC-PAGE TO FD348
      PERFORM DOC-LINE 2 TIMES PERFORM KH-HEAD.
    GO KH3.
KH8. STRING EPS-FF EPS-INIT DELIMITED SIZE INTO PREC PERFORM DOC-LINE.
    PERFORM CLOSE-DOC.
KH9. GO MN9.

KH-HEAD.
    MOVE "PROC/PART    DESCRIPTION                 DATE     EMPLOYEE               HRS/QTY" TO PREC PERFORM DOC-LINE.
*         ............ ......................... ../../.. . ... .................... ...:.
    MOVE ALL "-" TO PREC(1:80) PERFORM DOC-LINE.
* note 128
KH-PAGE. ADD 1 TO DOC-PAGE IF DOC-PAGE>1 MOVE EPS-FF TO PREC.
    PERFORM DOC-LINE MOVE 1 TO DOC-LINES PERFORM DOC-LINE.
    MOVE "M A I N T E N A N C E    W O R K    O R D E R" TO PREC(17:) PERFORM DOC-LINE 3 TIMES.
    MOVE "ORDER:" TO FD326 MOVE VO-NO TO FD327 MOVE LIT-PE(VO-TYPE + 1:1) TO FD328.
    MOVE "DATE:" TO FD331 MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD332.
    MOVE VO-TIME TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO FD333.
    PERFORM DOC-LINE 2 TIMES.
    MOVE "PRIORITY:" TO FD329 MOVE VO-PRIOR TO FD330 PERFORM MNT-PRIOR MOVE A-A1 TO FD330A.
    MOVE "CREATED BY:" TO FD338 MOVE VO-USER TO FD339 PERFORM DOC-LINE 2 TIMES.
    MOVE "MACHINE:" TO FD340 PERFORM MNT-SETMAC MOVE MNT-IMAC TO FD341.
    MOVE VO-SEC TO FD342 MOVE VO-LEVEL TO FD343.
    PERFORM MNT-DESC MOVE MNT-DESC1 TO FD344.
    MOVE "STATUS:" TO FD336 PERFORM MNT-STATUS MOVE A-A1 TO FD337 PERFORM DOC-LINE.
    MOVE MNT-DESC2 TO FD344 PERFORM DOC-LINE.
    IF VO-MAC>0 MOVE "DOWN:" TO FD331
      MOVE VO-DN-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD332
      MOVE VO-DN-TIME TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO FD333.
    PERFORM DOC-LINE 2 TIMES.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
     IF VO-NOTE(IX1)>" " IF WS1=0 MOVE "NOTES:" TO FD345 MOVE 1 TO WS1 END-IF
       MOVE VO-NOTE(IX1) TO FD346 PERFORM DOC-LINE END-IF END-PERFORM.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
     IF VO-COMMENT(IX1)>" " IF WS1=0 MOVE "COMMENTS:" TO FD345 MOVE 1 TO WS1 END-IF
       MOVE VO-COMMENT(IX1) TO FD346 PERFORM DOC-LINE END-IF END-PERFORM.
    PERFORM DOC-LINE.

* A-6 SHOW ORDERS BY MACHINE OR ISSUER
KJ1. PERFORM RD191 MOVE "A" TO KJ-CN KJ-PE MOVE 0 TO INQ-IND MOVE 3 TO IXT.
KJ3. MOVE "??" TO TLN(IXT + 1) PERFORM WRT.
    DISPLAY "NEXT MACHINE OR ISSUER: ____________    CLOSED/NOT CLOSED: _    PREVEN/EMERG: _" LINE IXT.
KJ33. ACCEPT IA32 LINE IXT COLUMN 25 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR IA32=ALL "9" GO KJ9.
    IF IA32=" " IF INQ-IND=0 GO KJ33 ELSE GO KJ4. MOVE 0 TO VO-ZNO INQ-IND.
    IF IA32 ALPHABETIC MOVE IA32 TO KJ-USER MOVE 2 TO KJ-SEL
      ELSE MOVE IA32 TO MNT-IMAC PERFORM MNT-GETMAC IF MNT-KERR=1 GO KJ33 END-IF
        MOVE MNT-IMAC TO KJ-IMAC MOVE 1 TO KJ-SEL.
    DISPLAY "'C': ONLY CLOSED ORDERS   'N': ONLY NOT CLOSED   'A': ALL ORDERS" LINE 24 BOLD.
    ACCEPT KJ-CN LINE IXT COLUMN 60 DEFAULT CURRENT UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF NOT(KJ-CN="C" OR "N" OR "A") MOVE "A" TO KJ-CN.
    DISPLAY "'P': ONLY PREVENTIVE ORDERS   'E': ONLY EMERGENCY ORDERS   'A': ALL ORDERS" LINE 24 BOLD.
    ACCEPT KJ-PE LINE IXT COLUMN 79 DEFAULT CURRENT UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    IF NOT(KJ-PE="P" OR "E" OR "A") MOVE "A" TO KJ-PE.
KJ4. PERFORM RD191 PERFORM DSP-QWAIT MOVE 0 TO KJ-NUM.
    MOVE 4 TO IXT IF INQ-IND=0 START MNTORD KEY>=VO-KN REGARDLESS INVALID GO KJ8.
KJ5. READ MNTORD NEXT REGARDLESS END GO KJ8.
    PERFORM MNT-SETMAC IF NOT(KJ-SEL=1 AND MNT-IMAC=KJ-IMAC OR KJ-SEL=2 AND VO-USER=KJ-USER) GO KJ6.
    IF NOT(KJ-CN="A" OR KJ-CN="C" AND VO-STATUS=2 OR KJ-CN="N" AND (VO-STATUS=0 OR 1)) GO KJ6.
    IF NOT(KJ-PE="A" OR KJ-PE="P" AND VO-TYPE=0 OR KJ-PE="E" AND VO-TYPE=1) GO KJ6.
    PERFORM CLR-LN MOVE VO-NO TO TF501(IXT) MOVE LIT-PE(VO-TYPE + 1:1) TO TF501A(IXT).
    PERFORM MNT-STATUS MOVE A-A1 TO TF502(IXT).
    IF VO-MAC>0 PERFORM MNT-SETMAC MOVE MNT-IMAC TO TF503(IXT)
      MOVE VO-SEC TO TF504(IXT) MOVE VO-LEVEL TO TF505(IXT).
    MOVE VO-USER TO TF506(IXT).
    MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO TF507(IXT).
    MOVE VO-TIME TO D-TIME PERFORM D-PR-TIME MOVE D-PRTIME TO TF508(IXT).
    PERFORM MNT-PRIOR MOVE A-A1 TO TF508A(IXT).
    ADD 1 TO IXT PERFORM CLR-LN.
    PERFORM MNT-DESC MOVE MNT-DESC1 TO TF509(IXT)(1:30) MOVE MNT-DESC2 TO TF509(IXT)(33:30).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 IF VO-NOTE(IX1)>" "
      ADD 1 TO IXT PERFORM CLR-LN MOVE VO-NOTE(IX1) TO TF509(IXT) END-IF END-PERFORM.
    ADD 1 TO IXT IF IXT<18 GO KJ5.
    MOVE "*** MORE ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO KJ89.
KJ6. ADD 1 TO KJ-NUM IF KJ-NUM<1000 GO KJ5.
    MOVE "*** MORE - OLDEST ORDER CHECKED SO FAR:" TO KJ-DF1A MOVE VO-NO TO KJ-DF1B.
    MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO KJ-DF1C.
    MOVE KJ-DF1 TO TLN(IXT) PERFORM DSP-ERS MOVE 1 TO INQ-IND GO KJ89.
KJ8. MOVE "*** END ***" TO TLN(IXT) PERFORM DSP-ERS MOVE 0 TO INQ-IND.
KJ89. GO KJ3.
KJ9. GO MN9.

* A-7 SUMMARY HOURS REPORT
FM1. PERFORM RD194 PERFORM WRT.
    MOVE 3 TO IXT MOVE 14 TO IXU MOVE 34 TO IXV PERFORM AX-YM-S.
    MOVE D-YY TO FM-YY MOVE D-MM TO FM-MM.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO VL-KEY START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO FM29.
FM23. READ MNTLIN NEXT REGARDLESS END GO FM29.
    MOVE VL-DATE TO D-DATE PERFORM D-NM IF NOT(D-MM=FM-MM AND D-YY=FM-YY) GO FM23.
    MOVE VL-NO TO VO-NO READ MNTORD REGARDLESS INVALID GO FM23.
    IF VL-VEN=1 MOVE 0 TO WN1
      ELSE MOVE VL-EMP TO A-N1 PERFORM RD-EMPL COMPUTE WN1=100 * E-DEPT + E-SECT.
    IF WN1=4901 MOVE 1 TO IX1 ELSE IF WN1=5901 MOVE 2 TO IX1 ELSE IF WN1=5902 MOVE 3 TO IX1
      ELSE IF WN1=5904 MOVE 4 TO IX1 ELSE IF WN1=5906 MOVE 5 TO IX1 ELSE MOVE 6 TO IX1.
    PERFORM INIT-RP MOVE VO-DEPT TO RP-F259 MOVE VO-SECT TO RP-F260.
    PERFORM MNT-SETMAC MOVE MNT-IMAC TO RP-F261 MOVE VL-NO TO RP-F261A.
    MOVE VL-HOURS TO RP-F262 RP-F263(IX1).
    WRITE RP-RECORD INVALID READ REPFL ADD VL-HOURS TO RP-F262 RP-F263(IX1) REWRITE RP-RECORD.
    GO FM23.
FM29. PERFORM OPEN-PR PERFORM FM-PAGE.
    MOVE LOW-VALUES TO FM-MTOTALS FM-TTOTALS FM-GTOTALS.
    MOVE -1 TO OLD-T MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FM9.
FM3. READ REPFL NEXT END GO FM9.
    COMPUTE WN1=100 * RP-F259 + RP-F260 IF WN1=OLD-T GO FM34.
    IF OLD-T NOT=-1 PERFORM FM-M PERFORM FM-T. MOVE WN1 TO OLD-T MOVE " " TO OLD-A.
    MOVE RP-F259 TO FG357 MOVE RP-F260 TO FG358.
FM34. IF RP-F261=OLD-A GO FM4. IF OLD-A>" " PERFORM FM-M.
    MOVE RP-F261 TO OLD-A FG359.
FM4. MOVE RP-F261A TO FG360 MOVE RP-F262 TO FG361.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE RP-F263(IX1) TO FG363(IX1) END-PERFORM.
    ADD RP-F262 TO FM-MHOURS FM-THOURS FM-GHOURS.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      ADD RP-F263(IX1) TO FM-MDIST(IX1) FM-TDIST(IX1) FM-GDIST(IX1) END-PERFORM.
    PERFORM FM-LINE GO FM3.
FM9. PERFORM FM-M PERFORM FM-T.
    MOVE "*** GRAND TOTALS" TO PREC MOVE FM-GHOURS TO FG361 MOVE "***" TO FG362.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE FM-GDIST(IX1) TO FG363(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

FM-M. MOVE "* MACHINE TOTALS" TO PREC MOVE FM-MHOURS TO FG361 MOVE "*" TO FG362.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE FM-MDIST(IX1) TO FG363(IX1) END-PERFORM.
    PERFORM FM-LINE 2 TIMES MOVE LOW-VALUES TO FM-MTOTALS.
FM-T. MOVE "** DEPT/SECT TOTALS" TO PREC MOVE FM-THOURS TO FG361 MOVE "**" TO FG362.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE FM-TDIST(IX1) TO FG363(IX1) END-PERFORM.
    PERFORM FM-LINE 2 TIMES MOVE LOW-VALUES TO FM-TTOTALS.
FM-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FM-PAGE.
FM-PAGE. MOVE "MAINTENANCE SUMMARY HOURS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "FOR MONTH:" TO A-A1 MOVE FM-MM TO D-MM MOVE FM-YY TO D-YY MOVE 1 TO D-DD.
    PERFORM D-MN MOVE D-DATE TO DATE0 PERFORM PRANGE-MTH.
    MOVE "DEP/SEC  MAC    ORDER       HOURS            49/01     59/01     59/02     59/04     59/06     OTHER" TO PREC PERFORM PR-LINE-3.
*         ..  ..   ....  ......    ..,...:. ...     ..,...:.  ..,...:.  ..,...:.  ..,...:.  ..,...:.  ..,...:.

* A-8 WRITE ORDER COMMENTS
UW1.
UW3. PERFORM RD195 PERFORM WRT.
    ACCEPT VO-NO LINE 1 COLUMN 46 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR VO-NO=999999 GO UW9.
    READ MNTORD REGARDLESS INVALID PERFORM DSP-ERR25 GO UW3.
    MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO D-PRDATE DISPLAY D-PRDATE LINE 1 COLUMN 72.
    PERFORM MNT-SETMAC DISPLAY MNT-IMAC LINE 3 COLUMN 11 CONVERSION
      VO-SEC COLUMN 15 CONVERSION VO-LEVEL COLUMN 18 CONVERSION.
    PERFORM MNT-DESC DISPLAY MNT-DESC1 LINE 4 COLUMN 25 MNT-DESC2 LINE 5 COLUMN 25.
    MOVE 1 TO IX1 MOVE 7 TO IXT PERFORM UNTIL IX1>3
      IF VO-NOTE(IX1)>" " DISPLAY VO-NOTE(IX1) LINE IXT COLUMN 9 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 1 TO IX1 MOVE 12 TO IXT PERFORM UNTIL IX1>4
      IF VO-COMMENT(IX1)>" " DISPLAY VO-COMMENT(IX1) LINE IXT COLUMN 9 END-IF
      ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 1 TO IX1 MOVE 12 TO IXT.
UW43. ACCEPT VO-COMMENT(IX1) LINE IXT COLUMN 9 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    MOVE VO-COMMENT(IX1) TO WA1 PERFORM RDLK-MNTORD MOVE WA1 TO VO-COMMENT(IX1).
    REWRITE VO-RECORD ALLOWING NO UNLOCK MNTORD.
    ADD 1 TO IX1 IXT IF IX1<=4 GO UW43.
    PERFORM DSP-CONT GO UW3.
UW9. GO MN9.

* A-9 WORK-IN-PROCESS LISTING
WJ1. PERFORM RD383 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM WJ-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO VO-KEY START MNTORD KEY>VO-KEY REGARDLESS INVALID GO WJ9.
WJ3. READ MNTORD NEXT REGARDLESS END GO WJ9. IF VO-STATUS NOT=1 GO WJ3.
    MOVE VO-NO TO FA671(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>12 PERFORM WJ-LINE 2 TIMES MOVE 1 TO PR-IXP.
    GO WJ3.
WJ9. PERFORM PR-LASTLN PERFORM CLOSE-PR GO MN9.

WJ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM WJ-PAGE.
WJ-PAGE. MOVE "MAINTENANCE WORK-IN-PROCESS LISTING" TO FF3 PERFORM PR-PAGE.
    PERFORM PR-LINE.

* A-10 OPEN/WIP ORDERS REPORT
WK1. PERFORM RD202 PERFORM WRT.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 38 TO IXV PERFORM AX-IMAC-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO VO-KEY START MNTORD KEY>VO-KEY REGARDLESS INVALID GO WK29.
WK23. READ MNTORD NEXT REGARDLESS END GO WK29. IF NOT(VO-STATUS=0 OR 1) GO WK23.
    MOVE IMAC1 TO MNT-IMAC PERFORM MNT-GETMAC IF NOT(VO-MAC-IND=MNT-KM AND VO-MAC>=MNT-MAC) GO WK23.
    MOVE IMAC2 TO MNT-IMAC PERFORM MNT-GETMAC IF NOT(VO-MAC-IND=MNT-KM AND VO-MAC<=MNT-MAC) GO WK23.
    PERFORM INIT-RP MOVE VO-MAC-IND TO RP-F313 MOVE VO-MAC TO RP-F313A.
    MOVE VO-PRIOR TO RP-F314 MOVE VO-NO TO RP-F315 WRITE RP-RECORD GO WK23.
WK29. PERFORM OPEN-PR PERFORM WK-PAGE MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO WK9.
WK3. READ REPFL NEXT END GO WK9. MOVE RP-F315 TO VO-NO READ MNTORD REGARDLESS.
    PERFORM MNT-SETMAC.
    IF MNT-IMAC NOT=OLD-A IF OLD-A>" " PERFORM WK-LINE END-IF MOVE MNT-IMAC TO OLD-A.
    MOVE MNT-IMAC TO FG168 PERFORM MNT-DESC MOVE MNT-DESC1 TO FG169.
    PERFORM MNT-PRIOR MOVE A-A1 TO FG170 MOVE VO-NO TO FG171.
    MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG172.
    MOVE LIT-PE(VO-TYPE + 1:1) TO FG173 PERFORM MNT-STATUS MOVE A-A1 TO FG174.
    MOVE VO-NOTE(1) TO FG175 PERFORM WK-LINE GO WK3.
WK9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

WK-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM WK-PAGE.
WK-PAGE. MOVE "MAINTENANCE OPEN/WIP ORDERS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-IMAC.
    MOVE "MACHINE                             PRIORITY       ORDER   DATE  TYPE  STATUS  NOTE" TO PREC PERFORM PR-LINE-3.
*         .... .............................. ............. ...... ../../..  .   ......  .....................................................

* A-11 DETAILED HISTORY REPORT
WB1. PERFORM RD196 PERFORM WRT.
WB13. ACCEPT MNT-IMAC LINE 3 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM MNT-GETMAC IF MNT-KERR=1 GO WB13. MOVE MNT-IMAC TO WB-IMAC.
    IF MNT-MAC=0 MOVE " " TO WB-MDESC
      ELSE MOVE MNT-MAC TO VO-MAC MOVE MNT-KM TO VO-MAC-IND PERFORM MNT-DESC
        MOVE MNT-DESC1 TO WB-MDESC.
    MOVE 5 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO VL-KEY START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO WB29.
WB23. READ MNTLIN NEXT REGARDLESS END GO WB29.
    IF NOT(VL-TYPE=0 AND VL-DATE>=DATE1 AND<=DATE2) GO WB23.
    MOVE VL-NO TO VO-NO READ MNTORD REGARDLESS INVALID GO WB23.
    PERFORM MNT-SETMAC IF MNT-IMAC NOT=WB-IMAC GO WB23.
    PERFORM INIT-RP MOVE VL-KEY TO RP-F287 WRITE RP-RECORD GO WB23.
WB29. PERFORM OPEN-PR PERFORM WB-PAGE MOVE 0 TO WB-GHOURS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO WB9.
WB3. READ REPFL NEXT END GO WB9. MOVE RP-F287 TO VL-KEY READ MNTLIN REGARDLESS.
    IF VL-NO=OLD-N GO WB4.
    MOVE VL-NO TO FA672 OLD-N VO-NO READ MNTORD REGARDLESS INVALID CONTINUE.
    MOVE LIT-PE(VO-TYPE + 1:1) TO FA674 MOVE VO-NOTE(1) TO FA675.
    MOVE VO-MDESC1 TO FA676 PERFORM WB-LINE.
WB4. MOVE VL-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA678.
    MOVE VL-PROC TO FA679 MOVE VL-EMP TO FA680.
    PERFORM MNT-GET-NAME MOVE A-A1(1:25) TO FA681.
    MOVE VL-HOURS TO FA682 ADD VL-HOURS TO WB-GHOURS PERFORM WB-LINE GO WB3.
WB9. MOVE 3 TO WS-PR MOVE "** TOTAL HOURS" TO FA686 MOVE WB-GHOURS TO FA687 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

WB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM WB-PAGE.
WB-PAGE. MOVE "MAINTENANCE DETAILED HISTORY REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR STRING "MACHINE SELECTED: " WB-IMAC "  " WB-MDESC
      DELIMITED SIZE INTO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE " ORDER TYPE  NOTE                                                                    MACHINE DESCRIPTION" TO PREC PERFORM PR-LINE.
*         ......  .    ......................................................................  ..............................
    MOVE "          DATE    PROC EMPL                             HOURS" TO PREC PERFORM PR-LINE-3.
*                 ../../..  ...  ...  .........................   ...:.

* A-12 HISTORY REPORT
WM1. PERFORM RD203 PERFORM WRT.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
WM13. ACCEPT WM-PE LINE 5 COLUMN 14 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF NOT(WM-PE="P" OR "E" OR "A") PERFORM DSP-ERR2 GO WM13.
    MOVE 9 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MN9.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

    MOVE " " TO VO-KEY START MNTORD KEY>VO-KEY REGARDLESS INVALID GO WM29.
WM23. READ MNTORD NEXT REGARDLESS END GO WM29. IF NOT(VO-DATE>=DATE1 AND<=DATE2) GO WM23.
    IF NOT(WM-PE="A" OR WM-PE="P" AND VO-TYPE=0 OR WM-PE="E" AND VO-TYPE=1) GO WM23.
    PERFORM INIT-RP MOVE VO-MAC-IND TO RP-F316 MOVE VO-MAC TO RP-F316A.
    MOVE VO-PRIOR TO RP-F317 MOVE VO-NO TO RP-F318 WRITE RP-RECORD GO WM23.
WM29. PERFORM OPEN-PR PERFORM WM-PAGE MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO WM9.
WM3. READ REPFL NEXT END GO WM9. MOVE RP-F318 TO VO-NO READ MNTORD REGARDLESS.
    PERFORM MNT-SETMAC.
    IF MNT-IMAC NOT=OLD-A IF OLD-A>" " PERFORM WM-LINE END-IF MOVE MNT-IMAC TO OLD-A.
    MOVE MNT-IMAC TO FG177 PERFORM MNT-DESC MOVE MNT-DESC1 TO FG178.
    PERFORM MNT-PRIOR MOVE A-A1 TO FG179 MOVE VO-NO TO FG180.
    MOVE VO-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG181.
    MOVE LIT-PE(VO-TYPE + 1:1) TO FG182 PERFORM MNT-STATUS MOVE A-A1 TO FG183.
    MOVE VO-NOTE(1) TO FG184 PERFORM WM-LINE GO WM3.
WM9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MN9.

WM-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM WM-PAGE.
WM-PAGE. MOVE "MAINTENANCE HISTORY REPORT" TO FF3.
    IF WM-PE="P" MOVE "** PREVENTIVE ORDERS **" TO FF4.
    IF WM-PE="E" MOVE "** EMERGENCY ORDERS **" TO FF4. PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE "MACHINE                             PRIORITY       ORDER   DATE  TYPE  STATUS  NOTE" TO PREC PERFORM PR-LINE-3.
*         .... .............................. ............. ...... ../../..  .   ......  .....................................................

* A-13 NON-PRODUCTION MACHINES FILE MAINTENANCE
FX1.
FX3. PERFORM RD189 PERFORM WRT MOVE LOW-VALUES TO MK-RECORD INITIALIZE MK-REC.
    ACCEPT MK-NO LINE 3 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR MK-NO=999 GO FX9. IF MK-NO=0 PERFORM DSP-ERR2 GO FX3.
    READ MNTMAC REGARDLESS INVALID MOVE 0 TO FX-KFIN GO FX4. MOVE 1 TO FX-KFIN.
    DISPLAY MK-DEPT LINE 3 COLUMN 37 CONVERSION MK-SECT COLUMN 40 CONVERSION.
    DISPLAY MK-DESC1 LINE 7 COLUMN 15 MK-DESC2 LINE 8 COLUMN 15.
FX4.
FX5. PERFORM DSP-NEXT ACCEPT FX-OP LINE 1 COLUMN 73 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF FX-OP=0 GO FX3. IF FX-OP>3 PERFORM DSP-ERR1 GO FX5.
    IF FX-OP=1 AND FX-KFIN=1 MOVE "DUPLICATE MACHINE NO." TO ERR-MESG
      PERFORM DSP-ERR GO FX3.
    IF (FX-OP=2 OR 3) AND FX-KFIN=0 PERFORM DSP-ERR30 GO FX3.
    IF FX-OP=3 DELETE MNTMAC GO FX3.

* op=1,2
    ACCEPT MK-DEPT LINE 3 COLUMN 37 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO FX8.
    DISPLAY MK-DEPT LINE 3 COLUMN 37 CONVERSION.
    ACCEPT MK-SECT LINE 3 COLUMN 40 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY IF KPF3 GO FX8.
    DISPLAY MK-SECT LINE 3 COLUMN 40 CONVERSION.
    ACCEPT MK-DESC1 LINE 7 COLUMN 15 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO FX8.
    ACCEPT MK-DESC2 LINE 8 COLUMN 15 DEFAULT CURRENT
      UNDERLINED PROTECTED EDITING KEY CKEY IF KPF3 GO FX8.
FX8. IF FX-OP=1 WRITE MK-RECORD ALLOWING NO ELSE REWRITE MK-RECORD ALLOWING NO.
    UNLOCK MNTMAC PERFORM DSP-CONT GO FX3.
FX9. GO MN9.

* A-14 MODIFY MACHINE CLEANOUT SETTINGS
NP1.
NP3. PERFORM RD272 PERFORM WRT.
    ACCEPT M-NO LINE 3 COLUMN 11 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR M-NO=9999 GO NP9.
    READ MACHINE REGARDLESS INVALID PERFORM DSP-ERR12 GO NP3.
    DISPLAY M-DESC1 LINE 3 COLUMN 16.
    DISPLAY M-CLFREQ LINE 8 COLUMN 22 CONVERSION.
    MOVE M-CLDATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 8 COLUMN 39.
    DISPLAY M-CLFREQ LINE 9 COLUMN 22 CONVERSION.
    ACCEPT M-CLFREQ LINE 9 COLUMN 22 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY M-CLFREQ LINE 9 COLUMN 22 CONVERSION.
    MOVE M-CLDATE TO D-DATE MOVE 9 TO IXT MOVE 39 TO IXU PERFORM AX-DT-DEF.
    MOVE DATE0 TO M-CLDATE.
    MOVE 11 TO IXT PERFORM AX-OK.
    IF XA2="OK" REWRITE M-RECORD ALLOWING NO UNLOCK MACHINE
      ELSE MOVE "** NOT MODIFIED **" TO TMSG PERFORM DSP-MSGCONT.
    GO NP3.
NP9. GO MN9.

* A-15 MACHINE CLEANOUT INFORMATION
NS1. PERFORM RD273 PERFORM WRT.
NS3. DISPLAY "____" LINE 1 COLUMN 76.
    ACCEPT MAC1 LINE 1 COLUMN 56 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR MAC1=9999 GO NS9.
    ACCEPT MAC2 LINE 1 COLUMN 76 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE MAC1 TO M-NO START MACHINE KEY>=M-KEY REGARDLESS INVALID GO NS6.
NS5. MOVE 4 TO IXT DISPLAY " " LINE IXT ERASE END SCREEN PERFORM DSP-QWAIT.
NS51. READ MACHINE NEXT REGARDLESS END GO NS6. IF M-NO>MAC2 GO NS6.
    MOVE 0 TO NS-HOURS INITIALIZE J-KM MOVE M-NO TO J-MAC MOVE M-CLDATE TO J-DATE.
    START WORKSHEET KEY>J-KM REGARDLESS INVALID GO NS54.
NS53. READ WORKSHEET NEXT REGARDLESS END GO NS54. IF J-MAC>M-NO GO NS54.
    ADD J-DHOURS(1) J-DHOURS(2) TO NS-HOURS GO NS53.
NS54. MOVE " " TO NS-DF1 MOVE M-NO TO NS-DF1A.
    MOVE M-CLDATE TO D-DATE PERFORM D-NM MOVE D-DT TO NS-DF1B.
    MOVE NS-HOURS TO NS-DF1C MOVE M-CLFREQ TO NS-DF1D.
    IF NS-HOURS>=M-CLFREQ MOVE "*" TO NS-DF1E.
    DISPLAY NS-DF1 LINE IXT ADD 1 TO IXT IF IXT<23 GO NS51. PERFORM DSP-ERS.
    DISPLAY "*** MORE - PRESS ANY KEY TO CONTINUE, PF4 TO END" LINE 23 BOLD.
    ACCEPT XA1 COLUMN 80 PROTECTED AUTOTERMINATE KEY CKEY PERFORM DSP-ERS.
    IF KPF4 DISPLAY " " LINE 23 ERASE LINE GO NS3. GO NS5.
NS6. PERFORM DSP-ERS DISPLAY "*** END" LINE IXT GO NS3.
NS9. GO MN9.

* Z: BATCH AND OTHER FUNCTIONS

* Z-1 BACKORDER REPORTS
BB1. PERFORM RD97 PERFORM WRT IF S-BAT GO BB2.
    PERFORM AX-SEL IF SEL-N=0 OR>4 GO MX1.
    IF Y1 PERFORM AX-CAT PERFORM AX-PROD PERFORM AX-TOT PERFORM AX-LIM-DATE.
    IF Y2 PERFORM AX-CUS PERFORM AX-LIM-DATE.
    IF Y3 PERFORM AX-CAT PERFORM AX-PROD.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
BB2. PERFORM DSP-WAIT.
    IF Y2 GO BB40. IF Y3 GO BB50. IF Y4 GO BB60.

* Y1
    PERFORM OPEN-REP.
    MOVE " " TO L-KEY START SALIN KEY>L-KEY REGARDLESS INVALID GO BB29.
BB23. READ SALIN NEXT REGARDLESS END GO BB29.
    IF NOT((L-CAT>=CAT1 AND<=CAT2) AND (L-PROD>=PROD1 AND<=PROD2)) GO BB23.
    IF L-SPECIAL=1 OR L-QTY-LEFT=0 OR L-DATE-REQ>DATE0 GO BB23.
    PERFORM INIT-RP MOVE L-CAT TO RP-F77 MOVE L-PROD TO RP-F78.
    MOVE L-DATE-REQ TO RP-F79 MOVE L-KEY TO RP-F80 WRITE RP-RECORD GO BB23.
BB29. PERFORM OPEN-PR PERFORM BB-PAGE.
    MOVE LOW-VALUES TO BB-PTOTALS BB-STOTALS BB-GTOTALS.
    MOVE 0 TO OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BB39.
BB3. READ REPFL NEXT END GO BB39. MOVE RP-F80 TO L-KEY READ SALIN REGARDLESS.
    IF L-CAT=OLD-N GO BB34. IF OLD-N NOT=0 PERFORM BB-P PERFORM BB-S.
    MOVE L-CAT TO OLD-N MOVE " " TO OLD-A.
    MOVE "CATEGORY" TO FF48 MOVE L-CAT TO FF49 PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF50.
    PERFORM BB-LINE 2 TIMES.
BB34. IF L-PROD=OLD-A GO BB36. IF OLD-A>" " PERFORM BB-P.
    MOVE L-PROD TO OLD-A FF40 A-A1 PERFORM PROD-RGD MOVE PRO-DESC(1) TO FF40A OLD-DESC.
    MOVE P-HAND TO BB-PQTY(2) MOVE P-PROCESS TO BB-PQTY(3).
    ADD P-HAND TO BB-SQTY(2) BB-GQTY(2) ADD P-PROCESS TO BB-SQTY(3) BB-GQTY(3).
BB36. PERFORM BB-R MOVE C-NO TO FF40A MOVE C-NAME TO FF41.
    MOVE C-ADD2 TO FF42 IF O-ADD2>" " MOVE O-ADD2 TO FF42.
    MOVE L-ORD TO FF43 MOVE L-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FF44.
    IF L-QTY=LIT-Q9 MOVE LIT-BL TO FF45A
      ELSE MOVE L-QTY-LEFT TO FF45 ADD L-QTY-LEFT TO BB-PQTY(1) BB-SQTY(1) BB-GQTY(1).
    IF TOT-IND=0 PERFORM BB-LINE ELSE MOVE " " TO PREC. GO BB3.
BB39. PERFORM BB-P PERFORM BB-S MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FF40A.
    MOVE BB-GQTY(1) TO FF45 MOVE BB-GQTY(2) TO FF46 MOVE BB-GQTY(3) TO FF47 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO BB9.

BB40. PERFORM OPEN-REP.
    MOVE " " TO L-KEY START SALIN KEY>L-KEY REGARDLESS INVALID GO BB44.
BB43. READ SALIN NEXT REGARDLESS END GO BB44. IF NOT(L-CUS>=CUS1 AND<=CUS2) GO BB43.
    IF L-QTY=LIT-Q9 OR L-SPECIAL=1 OR L-QTY-LEFT=0 OR L-DATE-REQ>DATE0 GO BB43.
    PERFORM INIT-RP MOVE L-CUS TO RP-F221 MOVE L-PROD TO RP-F222.
    MOVE L-DATE-REQ TO RP-F223 MOVE L-KEY TO RP-F224 WRITE RP-RECORD GO BB43.
BB44. PERFORM OPEN-PR PERFORM BB-PAGE.
    MOVE LOW-VALUES TO BB-CTOTALS BB-FTOTALS MOVE " " TO OLD-C OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BB49.
BB45. READ REPFL NEXT END GO BB49. MOVE RP-F224 TO L-KEY READ SALIN REGARDLESS.
    PERFORM BB-R IF L-CUS=OLD-C GO BB454. IF OLD-C>" " PERFORM BB-C.
    MOVE L-CUS TO OLD-C MOVE " " TO OLD-A.
    MOVE C-NO TO FA498 MOVE C-NAME TO FA499 MOVE C-ADD2 TO FA500.
    IF O-ADD2>" " MOVE O-ADD2 TO FA500. PERFORM BB-LINE.
BB454. IF L-PROD=OLD-A GO BB456. MOVE L-PROD TO OLD-A FA501 A-A1 PERFORM PROD-RGD.
    MOVE PRO-DESC(1) TO FA502 MOVE P-HAND TO FA506 MOVE P-PROCESS TO FA507.
BB456. MOVE L-ORD TO FA503 MOVE O-CUSORD TO FA503A.
    MOVE L-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA504.
    MOVE L-QTY-LEFT TO CL-QTY PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    MOVE L-QTY-LEFT TO FA505 MOVE CL-AMT TO FA508.
    ADD L-QTY-LEFT TO BB-CQTY BB-FQTY ADD CL-AMT TO BB-CVAL BB-FVAL.
    PERFORM BB-LINE GO BB45.
BB49. PERFORM BB-C MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FA499.
    MOVE BB-FQTY TO FA505 MOVE BB-FVAL TO FA508 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO BB9.

BB50. PERFORM OPEN-SORT.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO BB-CURMTH.
    MOVE PROD1 TO P-NO START PRODUCT KEY>=P-KEY REGARDLESS INVALID GO BB58.
BB53. READ PRODUCT NEXT REGARDLESS END GO BB58. IF P-NO>PROD2 GO BB58.
    IF P-GEN>" " OR NOT(P-CAT>=CAT1 AND<=CAT2) GO BB53.
    MOVE P-NO TO BB-PNO MOVE 1 TO BB-NUM PERFORM BB-A.
* note 14.4
    IF NOT(P-MAC>=29 AND<=31 OR=28 OR 99) GO BB56.
    MOVE P-NO TO NU-NUT MOVE " " TO NU-BOLT.
    START NUTBOLT KEY>NU-KEY REGARDLESS INVALID GO BB56.
BB55. READ NUTBOLT NEXT REGARDLESS END GO BB56. IF NU-NUT NOT=P-NO GO BB56.
    MOVE P-KEY TO PRO-NSV.
    MOVE NU-BOLT TO BB-PNO A-A1 PERFORM PROD-RT IF P-GEN>" " MOVE P-GEN TO BB-PNO.
    MOVE PRO-NSV TO P-KEY START PRODUCT KEY=P-KEY REGARDLESS INVALID GO BB58.
    READ PRODUCT NEXT REGARDLESS END GO BB58.
    MOVE NU-BOLT TO BB-PROD MOVE NU-NUM TO BB-NUM PERFORM BB-M GO BB55.
BB56. GO BB53.
BB58. PERFORM OPEN-PR PERFORM BB-PAGE.
    MOVE LOW-VALUES TO BB-YTOTALS BB-TTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO BB59.
BB583. READ SORTFL NEXT END GO BB59.
    IF SR-F131=OLD-N GO BB584. IF OLD-N NOT=0 PERFORM BB-Y.
    MOVE "CATEGORY" TO FF550 MOVE SR-F131 TO FF551 OLD-N PRO-CAT.
    PERFORM DESC-CAT MOVE T-LINE TO FF552 PERFORM BB-LINE 2 TIMES.
BB584. MOVE SR-F132 TO FF553 A-A1 PERFORM PROD-RGD MOVE PRO-DESC(1) TO FF554.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE SR-F133(IX1) TO A-N1 PERFORM BB-Z
      ADD SR-F133(IX1) TO BB-YQTY(IX1) BB-TQTY(IX1) END-PERFORM.
    PERFORM BB-LINE GO BB583.
BB59. PERFORM BB-Y MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FF554.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE BB-TQTY(IX1) TO A-N1 PERFORM BB-Z END-PERFORM.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR GO BB9.

BB60. PERFORM OPEN-SORT OPEN I-O SUBCON ALLOWING ALL.
    MOVE " " TO SJ-KEY START SUBCON KEY>SJ-KEY REGARDLESS INVALID GO BB624.
BB623. READ SUBCON NEXT REGARDLESS END GO BB624. IF SJ-IBUCKETS=SJ-BUCKETS GO BB623.
    COMPUTE WN1=SJ-OWEIGHT - SJ-IWEIGHT MOVE SJ-MO TO SR-F173 MOVE WN1 TO SR-F174.
    WRITE SR-RECORD INVALID READ SORTFL ADD WN1 TO SR-F174 REWRITE SR-RECORD.
    GO BB623.
BB624. MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE BB-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE " " TO OLD-A L-KP START SALIN KEY>L-KP REGARDLESS INVALID GO BB79.
BB63. READ SALIN NEXT REGARDLESS END GO BB79. IF L-PROD=OLD-A GO BB70.
    MOVE L-PROD TO OLD-A A-A1 PERFORM PROD-GEN PERFORM CHK-QBIN MOVE A-N1 TO BB-QHAND.
    PERFORM GET-OP.

    PERFORM OPEN-MAINTA MOVE 0 TO BB-KMO MOVE P-NO TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO BB68.
BB65. READ PRODORD NEXT REGARDLESS END GO BB68. IF R-PROD>P-NO GO BB68.
    IF R-NO<=9999 OR R-QTY-REC=R-QTY-PROD GO BB65.
    MOVE 1 TO BB-KMO INITIALIZE BB-OPX MOVE R-NO TO BB-OMO.
    MOVE R-QTY-ORD TO BB-OORD MOVE R-QTY-PROD TO BB-OPROD.
    PERFORM INIT-SR MOVE R-NO TO SR-F173 READ SORTFL INVALID GO BB652.
    COMPUTE BB-OUT ROUNDED=SR-F174 * 100 / P-WEIGHT SIZE ERROR CONTINUE.
BB652.

* note 251
    INITIALIZE J-KN MOVE R-NO TO J-KNO.
    START WORKSHEET KEY>J-KN REGARDLESS INVALID GO BB658.
BB653. READ WORKSHEET NEXT REGARDLESS END GO BB658. IF J-KNO NOT=R-NO GO BB658.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12 IF J-MAC=OP-OPER(IX1) GO BB654 END-IF END-PERFORM.
    GO BB653.
BB654. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>30 OR BB-OPER(IX1)=0 OR J-MAC CONTINUE END-PERFORM.
    IF IX1<=30 MOVE J-MAC TO BB-OPER(IX1) ADD J-QTY TO BB-OQTY(IX1)
      IF J-DATE>BB-ODATE(IX1) MOVE J-DATE TO BB-ODATE(IX1).
    GO BB653.
BB658. WRITE MFA-RECORD FROM BB-OPX GO BB65.
BB68. IF BB-KMO=0 INITIALIZE BB-OPX WRITE MFA-RECORD FROM BB-OPX.
    CLOSE MAINTA.

BB70. INITIALIZE BB-RQX MOVE 0 TO BB-IXR.
    IF L-QTY NOT=LIT-Q9
      IF L-QTY-LEFT>0 ADD 1 TO BB-IXR
        MOVE L-DATE-REQ TO BB-RDATE(BB-IXR) MOVE L-QTY-LEFT TO BB-RQTY(BB-IXR) END-IF
      GO BB72.
* note 29.2
    MOVE L-ORD TO PL-ORD READ PLANT REGARDLESS KEY PL-KO INVALID GO BB72.
    MOVE PL-PLANT TO MT-PLANT MOVE L-PROD TO MT-PROD MOVE 0 TO MT-SEQ.
    READ MATREL REGARDLESS INVALID GO BB712.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>MT-IXF
      OR MT-FDATE(IX1)>SYS-DATE + 30 OR BB-IXR=20 ADD 1 TO BB-IXR
        MOVE "F" TO BB-RD(BB-IXR) MOVE MT-FDATE(IX1) TO BB-RDATE(BB-IXR)
        MOVE MT-FQTY(IX1) TO BB-RQTY(BB-IXR) END-PERFORM.
    IF MT-QTY-SHIP>0 AND BB-IXR<20 ADD 1 TO BB-IXR
      MOVE "S" TO BB-RD(BB-IXR) MOVE SYS-DATE TO BB-RDATE(BB-IXR)
      COMPUTE BB-RQTY(BB-IXR)=-MT-QTY-SHIP.
BB712. MOVE PL-PLANT TO DY-PLANT MOVE PL-PROD TO DY-PROD MOVE 0 TO DY-SEQ.
    READ DAYREL REGARDLESS INVALID GO BB714. IF NOT(DY-TYPE=3 OR 8 OR 9) GO BB714.
* note 239.3
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>DY-IXF
      OR DY-FDATE(IX1)>SYS-DATE + 30 OR BB-IXR=20 ADD 1 TO BB-IXR
        MOVE "D" TO BB-RD(BB-IXR) MOVE DY-FDATE(IX1) TO BB-RDATE(BB-IXR)
        MOVE DY-FQTY(IX1) TO BB-RQTY(BB-IXR) END-PERFORM.
BB714.
BB72. IF BB-IXR=0 GO BB78.

    MOVE 0 TO BB-IXR.
BB73. ADD 1 TO BB-IXR IF BB-RDATE(BB-IXR)=0 GO BB78. OPEN INPUT MAINTA.
BB75. READ MAINTA INTO BB-OPX END GO BB76.
    PERFORM VARYING IX1 FROM 30 BY -1 UNTIL IX1=0 OR BB-OPER(IX1)>0 CONTINUE END-PERFORM.
    MOVE IX1 TO BB-IXL MOVE 0 TO BB-NEXT IF IX1=0 GO BB752.
    MOVE BB-OPER(BB-IXL) TO A-N1 PERFORM PROC-XTYPE MOVE PROC-CODE TO WN1.
    IF PROC-PRIMARY MOVE OP-OPER(1) TO BB-NEXT GO BB752.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>11
      MOVE OP-OPER(IX1) TO A-N1 PERFORM PROC-XTYPE
      IF PROC-CODE=WN1 MOVE OP-OPER(IX1 + 1) TO BB-NEXT GO BB752 END-IF END-PERFORM.
BB752. MOVE 0 TO BB-IXO.
BB753. ADD 1 TO BB-IXO IF BB-IXO>1 AND BB-OPER(BB-IXO)=0 GO BB758.
    MOVE L-ORD TO EXP-N PERFORM EXPF MOVE P-NO TO EXP-A PERFORM EXPF.
    MOVE BB-RD(BB-IXR) TO EXP-A PERFORM EXPF.
    MOVE BB-RDATE(BB-IXR) TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    MOVE BB-RQTY(BB-IXR) TO EXP-N PERFORM EXPF MOVE P-HAND TO EXP-N PERFORM EXPF.
    MOVE BB-QHAND TO EXP-N PERFORM EXPF MOVE BB-OMO TO EXP-N PERFORM EXPF.
    MOVE BB-OORD TO EXP-N PERFORM EXPF MOVE BB-OPROD TO EXP-N PERFORM EXPF.
    MOVE BB-OUT TO EXP-N PERFORM EXPF MOVE BB-OPER(BB-IXO) TO EXP-N PERFORM EXPF.
    MOVE BB-ODATE(BB-IXO) TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    MOVE BB-OQTY(BB-IXO) TO EXP-N PERFORM EXPF.
    IF BB-IXL>0 MOVE BB-OPER(BB-IXL) TO EXP-N PERFORM EXPF
      MOVE BB-ODATE(BB-IXL) TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF
      MOVE BB-OQTY(BB-IXL) TO EXP-N PERFORM EXPF MOVE BB-NEXT TO EXP-N PERFORM EXPF
     ELSE MOVE 4 TO A-N1 PERFORM EXPFN.
    PERFORM EXP-LINE GO BB753.
BB758. GO BB75.
BB76. CLOSE MAINTA GO BB73.
BB78. GO BB63.
BB79. CLOSE SUBCON PERFORM CLOSE-SORT PERFORM CLOSE-EXP PERFORM DELETE-MAINT.
    GO BB9.

BB9. GO MX9.

BB-R. MOVE L-ORD TO A-N1 PERFORM RD-SAORD MOVE L-CUS TO A-A1 PERFORM RD-CUS.
BB-S. MOVE 2 TO WS-PR MOVE "** CATEGORY TOTALS" TO FF40A.
    MOVE BB-SQTY(1) TO FF45 MOVE BB-SQTY(2) TO FF46 MOVE BB-SQTY(3) TO FF47.
    MOVE LOW-VALUES TO BB-STOTALS PERFORM BB-LINE 4 TIMES.
BB-P. IF TOT-IND=0 MOVE 2 TO WS-PR MOVE "** PRODUCT TOTALS" TO FF40A
       ELSE MOVE OLD-A TO FF40 MOVE OLD-DESC TO FF40A.
    MOVE BB-PQTY(1) TO FF45 MOVE BB-PQTY(2) TO FF46 MOVE BB-PQTY(3) TO FF47.
    MOVE LOW-VALUES TO BB-PTOTALS.
    IF TOT-IND=0 PERFORM BB-LINE 2 TIMES ELSE PERFORM BB-LINE.
BB-C. MOVE 2 TO WS-PR MOVE "** CUSTOMER TOTALS" TO FA499.
    MOVE BB-CQTY TO FA505 MOVE BB-CVAL TO FA508.
    PERFORM BB-LINE 2 TIMES MOVE LOW-VALUES TO BB-CTOTALS.
BB-Y. MOVE 2 TO WS-PR MOVE "** CATEGORY TOTALS" TO FF554.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE BB-YQTY(IX1) TO A-N1 PERFORM BB-Z END-PERFORM.
    MOVE LOW-VALUES TO BB-YTOTALS PERFORM BB-LINE 2 TIMES.
BB-Z. IF NOT(IX1=1 AND A-N1=0) MOVE A-N1 TO FF555(IX1).

BB-A. PERFORM BB-A1 THRU BB-A9.
BB-A1. MOVE BB-PNO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>=AL-KEY REGARDLESS INVALID GO BB-A4.
BB-A3. READ ALTERNATES NEXT REGARDLESS END GO BB-A4. IF AL-PROD NOT=BB-PNO GO BB-A4.
    MOVE AL-PROD TO BB-PROD IF AL-ALT>" " MOVE AL-ALT TO BB-PROD.
    PERFORM BB-M GO BB-A3.
BB-A4.
BB-A9. EXIT.

BB-M. PERFORM BB-M1 THRU BB-M9.
BB-M1. PERFORM INIT-SR MOVE P-CAT TO SR-F131 MOVE BB-PNO TO SR-F132.
    MOVE BB-PROD TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO BB-M46.
BB-M43. READ SALIN NEXT REGARDLESS END GO BB-M46. IF L-PROD NOT=BB-PROD GO BB-M46.
    IF L-SPECIAL=1 OR L-QTY-LEFT=0 OR L-QTY=LIT-Q9 GO BB-M43.
    MOVE LOW-VALUES TO SR-F133X MOVE L-DATE-REQ TO D-DATE PERFORM BB-D.
    COMPUTE A-N1=BB-NUM * L-QTY-LEFT MOVE A-N1 TO SR-F133(BB-MTH).
    WRITE SR-RECORD INVALID READ SORTFL ADD A-N1 TO SR-F133(BB-MTH) REWRITE SR-RECORD.
    GO BB-M43.
BB-M46.

    MOVE BB-PROD TO MT-KPROD MOVE " " TO MT-KPLANT.
    START MATREL KEY>=MT-KP REGARDLESS INVALID GO BB-M59.
BB-M53. READ MATREL NEXT REGARDLESS END GO BB-M59. IF MT-KPROD NOT=BB-PROD GO BB-M59.
    IF MT-QTY-SHIP NOT=0 MOVE LOW-VALUES TO SR-F133X
      COMPUTE A-N1=BB-NUM * MT-QTY-SHIP MOVE A-N1 TO SR-F133(1)
      WRITE SR-RECORD INVALID READ SORTFL ADD A-N1 TO SR-F133(1) REWRITE SR-RECORD.
    MOVE 1 TO A-X1.
BB-M55. IF A-X1>MT-IXF GO BB-M58.
    MOVE MT-FQTY(A-X1) TO REL-FQTY MOVE MT-FDATE(A-X1) TO REL-FDATE.
    IF NOT(REL-FDATE=0 OR REL-FQTY=0) PERFORM BB-W. ADD 1 TO A-X1 GO BB-M55.
BB-M58. GO BB-M53.
BB-M59.

    MOVE BB-PROD TO DY-KPROD MOVE " " TO DY-KPLANT.
    START DAYREL KEY>=DY-KP REGARDLESS INVALID GO BB-M69.
BB-M63. READ DAYREL NEXT REGARDLESS END GO BB-M69. IF DY-KPROD NOT=BB-PROD GO BB-M69.
    PERFORM CHK-RBW IF A-S1=0 GO BB-M63. MOVE 1 TO A-X1.
BB-M65. IF A-X1>DY-IXF GO BB-M68.
    MOVE DY-FQTY(A-X1) TO REL-FQTY MOVE DY-FDATE(A-X1) TO REL-FDATE.
    IF NOT(REL-FDATE=0 OR REL-FQTY=0) PERFORM BB-W. ADD 1 TO A-X1 GO BB-M65.
BB-M68. GO BB-M63.
BB-M69.
BB-M9. EXIT.

BB-W. MOVE LOW-VALUES TO SR-F133X MOVE REL-FDATE TO D-DATE PERFORM BB-D.
    MULTIPLY BB-NUM BY REL-FQTY MOVE REL-FQTY TO SR-F133(BB-MTH).
    WRITE SR-RECORD INVALID READ SORTFL ADD REL-FQTY TO SR-F133(BB-MTH) REWRITE SR-RECORD.
BB-D. PERFORM D-NM PERFORM D-MTHS COMPUTE BB-MTH=D-N1 - BB-CURMTH.
    IF BB-MTH<0 MOVE 0 TO BB-MTH. IF BB-MTH>3 MOVE 3 TO BB-MTH. ADD 2 TO BB-MTH.
BB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BB-PAGE.
BB-PAGE. MOVE "BACKORDER REPORT" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** BY CATEGORY / BY PRODUCT **" TO FF4
      WHEN Y2 MOVE "** BY CUSTOMER **" TO FF4
      WHEN Y3 MOVE "** PRODUCT DEMAND **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    IF Y1 OR Y2 MOVE "DUE BY:" TO A-A1 PERFORM PRANGE-DT.
    IF Y1 MOVE 1 TO WS-PR PERFORM PRANGE-CAT MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    IF Y2 MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    IF Y3 MOVE 2 TO WS-PR PERFORM PRANGE-CAT MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    IF Y1 MOVE
         "PRODUCT      DESCRIPTION                       CUSTOMER                    LOC     ORD  DATE REQ       QTY      ON HAND   IN PROCESS" TO PREC PERFORM PR-LINE-3.
*         ............ ................................  ..........................  ..... ...... ../../.. ..,...,...- ..,...,...- ..,...,...-
    IF Y2 MOVE
         "CUST    NAME                              LOCATION" TO PREC PERFORM PR-LINE
*         ......  ................................  ........................
      MOVE
         "        PRODUCT       DESCRIPTION                        ORD   CUST ORD   DATE REQ      QTY      ON HAND   IN PROCESS       VALUE" TO PREC PERFORM PR-LINE-3.
*                 ............  ................................ ......  ......... ../../.. ..,...,...- ..,...,...- ..,...,...- ..,...,...:..-
    IF Y3 MOVE
         "PRODUCT      DESCRIPTION                          SHIPPED      CURRENT      1 MONTH     2 MONTHS    3+ MONTHS" TO PREC PERFORM PR-LINE-3.
*         ............ ................................  ..,...,...-  ..,...,...-  ..,...,...-  ..,...,...-  ..,...,...-

* Z-2 ORDER REPORTS
JJ1. PERFORM RD98 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO JJ-KM MOVE S-S2 TO JJ-KW MOVE S-S3 TO JJ-KBL
      MOVE S-S4 TO JJ-KEXP MOVE S-S5 TO JJ-KN MOVE S-S6 TO JJ-KSUM GO JJ2.
    PERFORM AX-SEL MOVE 0 TO JJ-KEXP JJ-KSUM JJ-KBL.
    IF SEL-N=22 MOVE 1 TO JJ-KSUM.
    IF SEL-N=21 OR 22 MOVE 1 TO SEL-N MOVE 1 TO JJ-KEXP.
    IF SEL-N>=11 AND<=13 SUBTRACT 10 FROM SEL-N MOVE 1 TO JJ-KBL.
    IF SEL-N=0 OR>3 GO MX1.

    IF JJ-KEXP=1 MOVE 0 TO JJ-KW JJ-KM DATE0 GO JJ16.
    IF Y2 OR Y3 PERFORM AX-CUS PERFORM AX-LIM-DATE GO JJ16.
* Y1
    ADD 1 TO IXT DISPLAY "SHOW ORDER WEIGHT ? ___" LINE IXT BOLD "  (OTHERWISE ORDER VALUE IS SHOWN)".
    ACCEPT XA3 LINE IXT COLUMN 21 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO JJ-KW ELSE MOVE 0 TO JJ-KW.
    ADD 1 TO IXT DISPLAY "USE MONTHLY AGING ? ___" LINE IXT BOLD "  (OTHERWISE 4-WEEK AGING IS USED)".
    ACCEPT XA3 LINE IXT COLUMN 21 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO JJ-KM ELSE MOVE 0 TO JJ-KM.
    IF JJ-KM=0 MOVE SYS-DATE TO D-DATE PERFORM D-WKDAY
      MOVE 1 TO WN1 IF D-N1>=5 ADD 7 TO WN1 END-IF
      COMPUTE DATE0=D-DATE + WN1 - D-N1 GO JJ16.
* note 232
    ADD 1 TO IXT.
JJ13. MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    DISPLAY "CURRENT MONTH/YEAR FOR AGING: __/__" LINE IXT BOLD.
    DISPLAY D-MM LINE IXT COLUMN 31 D-YY COLUMN 34.
    ACCEPT D-MM LINE IXT COLUMN 31 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY D-MM LINE IXT COLUMN 31.
    ACCEPT D-YY LINE IXT COLUMN 34 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY D-YY LINE IXT COLUMN 34.
    MOVE 1 TO D-DD PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO JJ13.
    PERFORM D-MN MOVE D-DATE TO DATE0.
JJ16. ADD 1 TO IXT DISPLAY "INCLUDE ONLY NEW PARTS ? ___" LINE IXT BOLD.
    ACCEPT XA3 LINE IXT COLUMN 26 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO JJ-KN ELSE MOVE 0 TO JJ-KN.
    IF JJ-KEXP=1 MOVE 0 TO TOT-IND ELSE PERFORM AX-TOT.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE JJ-KM TO S-S1 MOVE JJ-KW TO S-S2 MOVE JJ-KBL TO S-S3
      MOVE JJ-KEXP TO S-S4 MOVE JJ-KN TO S-S5 MOVE JJ-KSUM TO S-S6 GO MX9.
JJ2. PERFORM DSP-WAIT PERFORM OPEN-REP PERFORM RDR-INFO.
    IF Y1 AND JJ-KEXP=0
      MOVE DATE0 TO JJ-FROM(2) MOVE 0 TO JJ-FROM(1) JJ-TO(5)
      PERFORM VARYING IX1 FROM 3 BY 1 UNTIL IX1>5
        IF JJ-KM=1 MOVE JJ-FROM(IX1 - 1) TO D-DATE PERFORM D-INCMTH
          MOVE D-DATE TO JJ-FROM(IX1)
         ELSE COMPUTE JJ-FROM(IX1)=JJ-FROM(IX1 - 1) + 28 END-IF END-PERFORM
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
        COMPUTE JJ-TO(IX1)=JJ-FROM(IX1 + 1) - 1 END-PERFORM.
    IF JJ-KBL=1 AND JJ-KEXP=0 GO JJ6.
* note 161

    MOVE 0 TO O-NO START SAORD KEY>O-KEY REGARDLESS INVALID GO JJ29.
JJ23. READ SAORD NEXT REGARDLESS END GO JJ29. IF O-BLANKET=1 GO JJ23.
    IF Y2 OR Y3 IF NOT(O-CUS>=CUS1 AND<=CUS2) GO JJ23.
    IF NOT(Y1 OR Y2 AND O-DATE-REQ<=DATE0 OR Y3 AND O-DATE-REQ>DATE0) GO JJ23.
    IF JJ-KN=0 GO JJ28.
    COMPUTE L-NO=100 * O-NO START SALIN KEY>L-KEY REGARDLESS INVALID GO JJ26.
JJ25. READ SALIN NEXT REGARDLESS END GO JJ26. IF L-ORD NOT=O-NO GO JJ26.
    MOVE L-PROD TO A-A1 PERFORM PROD-RT PERFORM CHK-NEW IF A-S1=1 GO JJ28.
    GO JJ25.
JJ26. GO JJ23.
JJ28. MOVE O-CUS TO A-A1 PERFORM RD-CUS PERFORM INIT-RP.
    IF JJ-KEXP=1 MOVE O-DATE-REQ TO RP-F156 ELSE MOVE 0 TO RP-F156.
    IF Y1 AND JJ-KEXP=0 MOVE C-SAL TO RP-F157 ELSE MOVE 0 TO RP-F157.
    MOVE O-CUS TO RP-F158 MOVE O-KEY TO RP-F159 MOVE " " TO RP-F160.
    MOVE O-DATE-REQ TO RP-F161 WRITE RP-RECORD GO JJ23.
JJ29. IF JJ-KEXP=1 GO JJ6.

    PERFORM OPEN-PR.
    MOVE LOW-VALUES TO JJ-CTOTALS JJ-STOTALS JJ-GTOTALS.
    MOVE " " TO OLD-C IF Y1 MOVE 0 TO JJ-KP MOVE -1 TO OLD-N.
    IF Y2 OR Y3 PERFORM JJ-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JJ39.
JJ33. READ REPFL NEXT END GO JJ39. MOVE RP-F159 TO O-KEY READ SAORD REGARDLESS.
    IF NOT Y1 IF O-CUS NOT=OLD-C
      IF OLD-C>" " PERFORM JJ-CR END-IF PERFORM JJ-CUS END-IF GO JJ34.
    IF RP-F157=OLD-N GO JJ332. IF OLD-N NOT=-1 PERFORM JJ-CL PERFORM JJ-S.
    MOVE RP-F157 TO OLD-N MOVE " " TO OLD-C PERFORM JJ-PAGE.
JJ332. IF O-CUS=OLD-C GO JJ34. IF OLD-C>" " PERFORM JJ-CL.
    MOVE 2 TO WS-PR PERFORM JJ-CUS.
JJ34. MOVE 0 TO JJ-AMT JJ-WEIGHT JJ-KL COMPUTE L-NO=100 * O-NO.
JJ35. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO JJ36.
    MOVE 1 TO JJ-KL MOVE L-PROD TO A-A1 PERFORM PROD-RT.
    IF JJ-KN=1 PERFORM CHK-NEW IF A-S1=0 GO JJ35. PERFORM RD-GEN.
    MOVE L-QTY-LEFT TO CL-QTY PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    ADD CL-AMT TO JJ-AMT ADD CL-WEIGHT-I TO JJ-WEIGHT GO JJ35.
JJ36. IF JJ-AMT=0 AND JJ-WEIGHT=0 AND JJ-KL=1 GO JJ38.
    MOVE O-NO TO FF33 MOVE O-CUSORD TO FF34.
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF35.
    MOVE O-DATE-REQ TO JJ-DATE D-DATE PERFORM D-NM MOVE D-DT TO FF36.
    IF JJ-KW=0 MOVE JJ-AMT TO FF37 ELSE MOVE JJ-WEIGHT TO FF37A.
    IF C-US=1 MOVE JJ-AMT TO A-T1 MOVE JJ-DATE TO D-DATE PERFORM EXCHG-CONV
      MOVE A-D1 TO JJ-AMT IF JJ-KW=0 MOVE JJ-AMT TO FF38.
    PERFORM JJ-AT IF Y1 MOVE O-DATE-REQ TO D-DATE PERFORM JJ-A.
    IF TOT-IND=0 PERFORM JJ-LINE ELSE MOVE " " TO PREC.
JJ38. GO JJ33.
JJ39. GO JJ8.

JJ6. MOVE " " TO MT-KP START MATREL KEY>MT-KP REGARDLESS INVALID GO JJ64.
JJ63. READ MATREL NEXT REGARDLESS END GO JJ64.
    IF JJ-KN=1 MOVE MT-PROD TO A-A1 PERFORM PROD-RT PERFORM CHK-NEW IF A-S1=0 GO JJ63.
    MOVE MT-PLANT TO PL-PLANT MOVE MT-PROD TO PL-PROD.
    READ PLANT REGARDLESS INVALID GO JJ63.
    MOVE PL-ORD TO O-NO READ SAORD REGARDLESS INVALID GO JJ63.
    MOVE O-CUS TO A-A1 PERFORM RD-CUS.
    IF Y2 OR Y3 IF NOT(O-CUS>=CUS1 AND<=CUS2) GO JJ63.
    COMPUTE JJ-QTY=-MT-QTY-SHIP MOVE 1 TO IX1.
JJ633. MOVE MT-FQTY(IX1) TO REL-FQTY MOVE MT-FDATE(IX1) TO REL-FDATE.
    IF Y1 OR Y2 AND REL-FDATE<=DATE0 OR Y3 AND REL-FDATE>DATE0
      ADD REL-FQTY TO JJ-QTY.
    ADD 1 TO IX1 IF IX1<=MT-IXF GO JJ633. IF JJ-QTY<=0 GO JJ638.
    IF (Y1 OR Y2) AND MT-QTY-SHIP NOT=0
      MOVE 999999 TO A-N1 COMPUTE A-N2=-MT-QTY-SHIP
      MOVE MT-PROD TO A-A1 PERFORM JJ-WREP.
    MOVE 1 TO IX1.
JJ635. MOVE MT-FQTY(IX1) TO REL-FQTY MOVE MT-FDATE(IX1) TO REL-FDATE.
    IF REL-FQTY NOT=0
      IF Y1 OR Y2 AND REL-FDATE<=DATE0 OR Y3 AND REL-FDATE>DATE0
        MOVE REL-FDATE TO A-N1 MOVE REL-FQTY TO A-N2
        MOVE MT-PROD TO A-A1 PERFORM JJ-WREP.
    ADD 1 TO IX1 IF IX1<=MT-IXF GO JJ635.
JJ638. GO JJ63.
JJ64.

    MOVE " " TO DY-KP START DAYREL KEY>DY-KP REGARDLESS INVALID GO JJ68.
JJ65. READ DAYREL NEXT REGARDLESS END GO JJ68.
    IF JJ-KN=1 MOVE DY-PROD TO A-A1 PERFORM PROD-RT PERFORM CHK-NEW IF A-S1=0 GO JJ65.
    PERFORM CHK-RBW IF A-S1=0 GO JJ65.
    MOVE DY-PLANT TO PL-PLANT MOVE DY-PROD TO PL-PROD.
    READ PLANT REGARDLESS INVALID GO JJ65.
    MOVE PL-ORD TO O-NO READ SAORD REGARDLESS INVALID GO JJ65.
    MOVE O-CUS TO A-A1 PERFORM RD-CUS.
    IF Y2 OR Y3 IF NOT(O-CUS>=CUS1 AND<=CUS2) GO JJ65. MOVE 1 TO IX1.
JJ67. IF DY-FQTY(IX1) NOT=0
       IF Y1 OR Y2 AND DY-FDATE(IX1)<=DATE0 OR Y3 AND DY-FDATE(IX1)>DATE0
         MOVE DY-FDATE(IX1) TO A-N1 MOVE DY-FQTY(IX1) TO A-N2
         MOVE DY-PROD TO A-A1 PERFORM JJ-WREP.
    ADD 1 TO IX1 IF IX1<=DY-IXF GO JJ67. GO JJ65.
JJ68. IF JJ-KEXP=1 GO JJ8.

    PERFORM OPEN-PR.
    MOVE LOW-VALUES TO JJ-CTOTALS JJ-STOTALS JJ-GTOTALS.
    MOVE " " TO OLD-C IF Y1 MOVE 0 TO JJ-KP MOVE -1 TO OLD-N.
    IF Y2 OR Y3 PERFORM JJ-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JJ79.
JJ73. READ REPFL NEXT END GO JJ79. MOVE RP-F159 TO O-KEY READ SAORD REGARDLESS.
    IF NOT Y1 IF O-CUS NOT=OLD-C
      IF OLD-C>" " PERFORM JJ-CR END-IF PERFORM JJ-CUS END-IF GO JJ74.
    IF RP-F157=OLD-N GO JJ732. IF OLD-N NOT=-1 PERFORM JJ-CL PERFORM JJ-S.
    MOVE RP-F157 TO OLD-N MOVE " " TO OLD-C PERFORM JJ-PAGE.
JJ732. IF O-CUS=OLD-C GO JJ74. IF OLD-C>" " PERFORM JJ-CL.
    MOVE 2 TO WS-PR PERFORM JJ-CUS.
JJ74. COMPUTE L-NO=100 * O-NO.
JJ75. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO JJ78.
    IF L-QTY=0 OR L-PROD NOT=RP-F160 GO JJ75.
    MOVE L-PROD TO A-A1 PERFORM PROD-GEN.
    MOVE RP-F162 TO CL-QTY PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    MOVE O-NO TO FF33 MOVE O-CUSORD TO FF34.
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF35.
    IF RP-F161=999999 MOVE SYS-DATE TO JJ-DATE MOVE "SHIPPED" TO FF36A
      ELSE MOVE RP-F161 TO JJ-DATE D-DATE PERFORM D-NM MOVE D-DT TO FF36.
    MOVE CL-AMT TO JJ-AMT MOVE CL-WEIGHT-I TO JJ-WEIGHT.
    IF JJ-KW=0 MOVE JJ-AMT TO FF37 ELSE MOVE JJ-WEIGHT TO FF37A.
    IF C-US=1 MOVE JJ-AMT TO A-T1 MOVE JJ-DATE TO D-DATE PERFORM EXCHG-CONV
      MOVE A-D1 TO JJ-AMT IF JJ-KW=0 MOVE JJ-AMT TO FF38.
    PERFORM JJ-AT IF Y1 AND RP-F161 NOT=999999 MOVE RP-F161 TO D-DATE PERFORM JJ-A.
    IF TOT-IND=0 PERFORM JJ-LINE ELSE MOVE " " TO PREC. GO JJ75.
JJ78. GO JJ73.
JJ79. GO JJ8.

JJ8. IF JJ-KEXP=1 PERFORM JJ-EXP GO JJ9.
    IF Y1 PERFORM JJ-CL PERFORM JJ-S MOVE 1 TO JJ-KP PERFORM JJ-PAGE
      MOVE "*** GRAND TOTALS" TO FF32
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
        IF JJ-KW=1 MOVE JJ-GT(IX1) TO FF54(IX1)
          ELSE MOVE JJ-GT(IX1) TO FF53(IX1) END-IF END-PERFORM
     ELSE PERFORM JJ-CR MOVE 3 TO WS-PR
      MOVE "*** GRAND TOTAL" TO FF32 MOVE JJ-GT(6) TO FF39.
    PERFORM PR-LINE.
    PERFORM CLOSE-PR.
JJ9. PERFORM CLOSE-REP GO MX9.

JJ-A. PERFORM JJ-A1 THRU JJ-A9.
JJ-A1. IF JJ-KM=1 PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO A-N1
      MOVE DATE0 TO D-DATE PERFORM D-NM PERFORM D-MTHS
      COMPUTE A-X1=A-N1 - D-N1 + 2
      IF A-X1<1 MOVE 1 TO A-X1 END-IF IF A-X1>5 MOVE 5 TO A-X1 END-IF
        ELSE PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>4
         IF D-DATE<DATE0 + 28 * (A-X1 - 1) GO JJ-A4 END-IF END-PERFORM.
JJ-A4. IF JJ-KW=1 ADD JJ-WEIGHT TO JJ-CT(A-X1) JJ-ST(A-X1) JJ-GT(A-X1)
         ELSE ADD JJ-AMT TO JJ-CT(A-X1) JJ-ST(A-X1) JJ-GT(A-X1).
JJ-A9. EXIT.
JJ-WREP. PERFORM INIT-RP MOVE 0 TO RP-F156 IF JJ-KEXP=1 MOVE A-N1 TO RP-F156.
    IF Y1 AND JJ-KEXP=0 MOVE C-SAL TO RP-F157 ELSE MOVE 0 TO RP-F157.
    MOVE O-CUS TO RP-F158 MOVE O-KEY TO RP-F159 MOVE A-A1 TO RP-F160.
    MOVE A-N1 TO RP-F161 MOVE A-N2 TO RP-F162.
    WRITE RP-RECORD INVALID READ REPFL ADD A-N2 TO RP-F162 REWRITE RP-RECORD.
JJ-S. MOVE 2 TO WS-PR MOVE " " TO PREC MOVE " ** SUB-TOTALS" TO FF32.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      IF Y1 AND JJ-KW=1 MOVE JJ-ST(IX1) TO FF54(IX1) ELSE MOVE JJ-ST(IX1) TO FF53(IX1) END-IF END-PERFORM.
    PERFORM PR-LINE-2 MOVE LOW-VALUES TO JJ-STOTALS.
* note 68
JJ-CL. PERFORM JJ-CK.
    IF TOT-IND=0 AND JJ-CT(6) NOT=0 MOVE 2 TO WS-PR
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
        IF Y1 AND JJ-KW=1 MOVE JJ-CT(IX1) TO FF54(IX1)
          ELSE MOVE JJ-CT(IX1) TO FF53(IX1) END-IF END-PERFORM
      PERFORM PR-LINE ELSE MOVE " " TO PREC.
    MOVE LOW-VALUES TO JJ-CTOTALS.
JJ-CR. PERFORM JJ-CK.
    IF JJ-CT(6) NOT=0 MOVE 2 TO WS-PR MOVE " ** SUB-TOTAL" TO FF32
      IF TOT-IND=1 MOVE OLD-C TO FF31 MOVE OLD-NAME TO FF32 END-IF
      MOVE JJ-CT(6) TO FF39 PERFORM JJ-LINE 3 TIMES
     ELSE MOVE " " TO PREC.
    MOVE LOW-VALUES TO JJ-CTOTALS.
JJ-CK. IF JJ-KBL=1 AND JJ-CT(6)<0 SUBTRACT JJ-CT(6) FROM JJ-ST(6) JJ-GT(6)
         MOVE LOW-VALUES TO JJ-CTOTALS.
JJ-AT. IF Y1 AND JJ-KW=1 ADD JJ-WEIGHT TO JJ-CT(6) JJ-ST(6) JJ-GT(6)
         ELSE ADD JJ-AMT TO JJ-CT(6) JJ-ST(6) JJ-GT(6).
JJ-CUS. MOVE O-CUS TO OLD-C FF31 A-A1 PERFORM RD-CUS MOVE C-NAME TO OLD-NAME FF32.

JJ-EXP. PERFORM JJ-E1 THRU JJ-E9.
JJ-E1. IF JJ-KSUM=1 GO JJ-E8.
    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE JJ-HEADLN1 TO EXP-RECORD PERFORM EXP-HEADLN MOVE " " TO OLD-C.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JJ-E6.
JJ-E3. READ REPFL NEXT END GO JJ-E6. MOVE RP-F159 TO O-KEY READ SAORD REGARDLESS.
    IF O-CUS NOT=OLD-C MOVE O-CUS TO OLD-C A-A1 PERFORM RD-CUS.
    COMPUTE L-NO=100 * O-NO.
JJ-E5. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO JJ-E58.
    IF RP-F160=" " AND L-QTY-LEFT=0
      OR RP-F160>" " AND (L-QTY=0 OR L-PROD NOT=RP-F160) GO JJ-E5.
    MOVE L-PROD TO A-A1 PERFORM PROD-RT.
    IF JJ-KN=1 AND RP-F160=" " PERFORM CHK-NEW IF A-S1=0 GO JJ-E5.
    PERFORM RD-GEN PERFORM PROD-DESC.
    IF RP-F160=" " MOVE L-QTY-LEFT TO CL-QTY ELSE MOVE RP-F162 TO CL-QTY.
    PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    MOVE C-NO TO EXP-A PERFORM EXPF MOVE C-NAME TO EXP-A PERFORM EXPF.
    MOVE O-NO TO EXP-N PERFORM EXPF MOVE O-CUSORD TO EXP-A PERFORM EXPF.
    MOVE P-NO TO EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE L-CUSPART TO EXP-A PERFORM EXPF.
    IF RP-F161=999999 MOVE SYS-DATE TO JJ-DATE ELSE MOVE RP-F161 TO JJ-DATE.
    MOVE JJ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    IF RP-F160=" " MOVE " " TO EXP-A ELSE MOVE "BL" TO EXP-A. PERFORM EXPF.
    MOVE CL-QTY TO EXP-N PERFORM EXPF MOVE CL-WEIGHT-I TO EXP-N PERFORM EXPF.
    MOVE CL-AMT TO EXP-D PERFORM EXPF MOVE CL-AMT TO A-D1.
    IF C-US=1 MOVE CL-AMT TO A-T1 MOVE JJ-DATE TO D-DATE PERFORM EXCHG-CONV.
    MOVE A-D1 TO EXP-D PERFORM EXPF.
    MOVE P-HAND TO EXP-N PERFORM EXPF MOVE P-PROCESS TO EXP-N PERFORM EXPF.
    COMPUTE WN1=P-HAND + P-PROCESS - CL-QTY IF WN1<0 MOVE WN1 TO EXP-N. PERFORM EXPF.
    PERFORM EXP-LINE GO JJ-E5.
JJ-E58. GO JJ-E3.
JJ-E6. PERFORM CLOSE-EXP GO JJ-E9.

JJ-E8. MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    MOVE D-YY TO JJ-YY MOVE D-MM TO JJ-MM MOVE D-DD TO JJ-DD.
    INITIALIZE JJ-STBL.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      MOVE JJ-YY TO WN1 COMPUTE WN2=JJ-MM + IX1 - 1
      IF WN2>12 SUBTRACT 12 FROM WN2 ADD 1 TO WN1 END-IF
      MOVE WN1 TO JJ-SYY(IX1) MOVE WN2 TO JJ-SMM(IX1)
      IF WN2=JJ-MM MOVE JJ-DD TO WN4 ELSE MOVE 1 TO WN4 END-IF
      PERFORM VARYING WN3 FROM WN4 BY 1 UNTIL WN3>31
        MOVE WN1 TO D-YY MOVE WN2 TO D-MM MOVE WN3 TO D-DD PERFORM D-MN
        IF D-DATE>0 PERFORM D-OFFDAY IF D-N1=0 ADD 1 TO JJ-SDAYS(IX1) END-IF END-IF
        END-PERFORM END-PERFORM.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JJ-E88.
JJ-E83. READ REPFL NEXT END GO JJ-E88.
    MOVE RP-F159 TO O-KEY COMPUTE L-NO=100 * O-NO.
JJ-E85. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO JJ-E86.
    IF RP-F160=" " AND L-QTY-LEFT=0
      OR RP-F160>" " AND (L-QTY=0 OR L-PROD NOT=RP-F160) GO JJ-E85.
    MOVE L-PROD TO A-A1 PERFORM PROD-RT.
    IF JJ-KN=1 AND RP-F160=" " PERFORM CHK-NEW IF A-S1=0 GO JJ-E85.
    PERFORM RD-GEN.
    IF RP-F160=" " MOVE L-QTY-LEFT TO CL-QTY ELSE MOVE RP-F162 TO CL-QTY.
    PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    IF RP-F161=999999 MOVE SYS-DATE TO D-DATE ELSE MOVE RP-F161 TO D-DATE.
    PERFORM D-CURR COMPUTE IX1=D-N1 + 1.
    IF IX1<1 MOVE 1 TO IX1. IF IX1>12 MOVE 12 TO IX1.
    ADD CL-AMT TO JJ-SA(IX1) ADD CL-WEIGHT-I TO JJ-SW(IX1) GO JJ-E85.
JJ-E86. GO JJ-E83.
JJ-E88. MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE JJ-HEADLN2 TO EXP-RECORD PERFORM EXP-HEADLN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      MOVE JJ-SYY(IX1) TO EXP-N PERFORM EXPF MOVE JJ-SMM(IX1) TO EXP-N PERFORM EXPF
      MOVE JJ-SDAYS(IX1) TO EXP-N PERFORM EXPF
      COMPUTE EXP-N ROUNDED=JJ-SW(IX1) / JJ-SDAYS(IX1) / 2000 PERFORM EXPF
      COMPUTE EXP-N ROUNDED=JJ-SA(IX1) / JJ-SDAYS(IX1) PERFORM EXPF
      COMPUTE EXP-N ROUNDED=JJ-SA(IX1) PERFORM EXPF
      PERFORM EXP-LINE END-PERFORM.
    PERFORM CLOSE-EXP.
JJ-E9. EXIT.

JJ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JJ-PAGE.
JJ-PAGE. IF JJ-KBL=0 MOVE "REGULAR" TO WA1 ELSE MOVE "BLANKET" TO WA1.
    MOVE " " TO WA2 WA3.
    IF Y1 STRING WA1 DELIMITED " " " OUTSTANDING ORDERS" DELIMITED SIZE INTO WA2
      IF JJ-KW=1 MOVE "** ORDER BOOK - SHOWING ORDER WEIGHT **" TO FF4
        ELSE MOVE "** ORDER BOOK - SHOWING ORDER VALUE **" TO FF4.
    IF Y2 OR Y3 STRING WA1 DELIMITED " " " BACKORDER REPORT" DELIMITED SIZE INTO WA2
      IF Y2 MOVE "** ORDERS PAST DUE **" TO FF4
        ELSE MOVE "** ORDERS NOT YET DUE **" TO FF4.
    IF JJ-KN=1 MOVE " (NEW PARTS)" TO WA3.
    STRING WA2 WA3 DELIMITED "  " INTO FF3 PERFORM PR-PAGE.
    IF Y1 IF JJ-KM=0 MOVE "4-WEEK AGING:" TO A-A1 PERFORM PRANGE-DT
            ELSE MOVE "MONTHLY AGING:" TO A-A1 PERFORM PRANGE-MTH END-IF
      IF JJ-KP=0 MOVE "SALESMAN" TO FD221 MOVE OLD-N TO FD222 A-N1
        PERFORM RD-SALESMAN MOVE SN-NAME TO FD223 PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF Y2 OR Y3 MOVE "AS OF:" TO A-A1 PERFORM PRANGE-DT
      MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    IF Y1 IF JJ-KW=1 MOVE
         "CUST    NAME                               ORDER   CUST ORDER    DATE    DATE REQD     WEIGHT" TO PREC PERFORM PR-LINE
           ELSE MOVE
         "CUST    NAME                               ORDER   CUST ORDER    DATE    DATE REQD       VALUE       CDN EQUIV" TO PREC PERFORM PR-LINE END-IF
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
        IF JJ-FROM(IX1)>0 MOVE JJ-FROM(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FF51(IX1) END-IF END-PERFORM PERFORM PR-LINE
      MOVE
         "                                            UP TO           TO             TO             TO          AND AFTER         TOTAL" TO PREC PERFORM PR-LINE
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
        IF JJ-TO(IX1)>0 MOVE JJ-TO(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FF51(IX1) END-IF END-PERFORM PERFORM PR-LINE-3.
    IF Y2 OR Y3 MOVE
         "CUST    NAME                               ORDER   CUST ORDER    DATE    DATE REQD       VALUE       CDN EQUIV     CUST TOTAL" TO PREC PERFORM PR-LINE-3.
*                                                   ../../..       ../../..       ../../..       ../../..       ../../..
*         ......  ................................  ......   .........   ../../..  ../../.. ..,...,...:..- ..,...,...:..- ..,...,...:..-
*                                              ..,...,...:..- ..,...,...:..- ..,...,...:..- ..,...,...:..- ..,...,...:..- ..,...,...:..-

* Z-3 PRODUCTION ORDERS REPORTS
SO1. PERFORM RD177 PERFORM WRT IF S-BAT GO SO2.
    PERFORM AX-SEL IF SEL-N=0 OR>4 GO MX1.
    IF Y2 PERFORM AX-PROD. IF Y3 PERFORM AX-LIM-DATE.
    IF Y4 MOVE " " TO PROD1 MOVE ALL "Z" TO PROD2.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
SO2. PERFORM DSP-WAIT.
    IF NOT Y3 GO SO28. PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO SO24.
SO23. READ PRODORD NEXT REGARDLESS END GO SO24. IF R-QTY-LEFT<=0 GO SO23.
    IF R-DATE>DATE0 GO SO23. PERFORM INIT-RP.
    MOVE R-DATE TO RP-F84 MOVE R-KEY TO RP-F85 WRITE RP-RECORD GO SO23.
SO24.
SO28. PERFORM OPEN-PR PERFORM SO-PAGE.
    MOVE LOW-VALUES TO SO-STOTALS SO-GTOTALS MOVE " " TO OLD-A.
    IF Y1 MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO SO8.
    IF Y2 OR Y4 MOVE PROD1 TO R-PROD MOVE 0 TO R-DATE
      START PRODORD KEY>R-KP REGARDLESS INVALID GO SO8.
    IF Y3 MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SO8.
SO3. IF Y3 READ REPFL NEXT END GO SO8 END-READ
      MOVE RP-F85 TO R-KEY READ PRODORD REGARDLESS GO SO4.
    READ PRODORD NEXT REGARDLESS END GO SO8. IF R-QTY-LEFT<=0 GO SO3.
    IF Y2 OR Y4 IF R-PROD>PROD2 GO SO8.
    IF NOT Y4 GO SO36. IF R-QTY-PROD=0 OR R-QTY-LEFT=0 GO SO3.
    MOVE R-NO TO J-KNO COMPUTE J-KDATE=SYS-DATE - 60 MOVE 0 TO J-KSHIFT J-KMAC.
    START WORKSHEET KEY>J-KN REGARDLESS INVALID GO SO36.
    READ WORKSHEET NEXT REGARDLESS END GO SO36. IF J-KNO NOT=R-NO GO SO36.
    GO SO3.
SO36. IF NOT(Y2 OR Y4) GO SO4. IF R-PROD=OLD-A GO SO4.
    IF OLD-A>" " PERFORM SO-SUB. MOVE R-PROD TO OLD-A IF Y4 ADD 1 TO SO-GW.
SO4. MOVE R-NO TO FD311 IF R-SPORD NOT=0
      MOVE R-SPORD TO FD311A MOVE "-" TO FD311B MOVE R-SPLINE TO FD311C.
    MOVE R-PROD TO FD312 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FD313.
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD314.
    MOVE R-QTY-ORD TO FD315(1) MOVE R-QTY-PROD TO FD315(2).
    MOVE R-QTY-REC TO FD315(3) MOVE R-QTY-LEFT TO FD315(4).
    ADD R-QTY-ORD TO SO-SN(1) ADD R-QTY-PROD TO SO-SN(2).
    ADD R-QTY-REC TO SO-SN(3) ADD R-QTY-LEFT TO SO-SN(4).
    IF Y4 ADD 1 TO SO-GR ADD R-QTY-ORD TO SO-GN(1) ADD R-QTY-PROD TO SO-GN(2)
      ADD R-QTY-REC TO SO-GN(3) ADD R-QTY-LEFT TO SO-GN(4).
    PERFORM SO-LINE GO SO3.
SO8. IF Y2 OR Y4 PERFORM SO-SUB. IF NOT Y4 GO SO9.
    MOVE 3 TO WS-PR PERFORM SO-LINE IF WS-LINES>52 PERFORM SO-PAGE.
    MOVE "SUMMARY" TO PREC PERFORM SO-LINE.
    MOVE 2 TO WS-PR MOVE SO-GR TO FD316 MOVE "ORDERS AFFECTING" TO FD317.
    MOVE SO-GW TO FD318 MOVE "PRODUCTS" TO FD319 PERFORM SO-LINE MOVE 2 TO WS-PR.
    MOVE "ORDERED" TO FD320 MOVE SO-GN(1) TO FD321 MOVE "PCS" TO FD322.
    PERFORM SO-LINE.
    MOVE "PRODUCED" TO FD320 MOVE SO-GN(2) TO FD321 MOVE "PCS" TO FD322.
    COMPUTE FD323 ROUNDED=100 * SO-GN(2) / SO-GN(1) SIZE ERROR CONTINUE.
    MOVE "% OF QTY ORDERED" TO FD324 PERFORM SO-LINE.
    MOVE "RECEIVED" TO FD320 MOVE SO-GN(3) TO FD321 MOVE "PCS" TO FD322.
    COMPUTE FD323 ROUNDED=100 * SO-GN(3) / SO-GN(2) SIZE ERROR CONTINUE.
    MOVE "% OF QTY PRODUCED" TO FD324 PERFORM SO-LINE.
    MOVE "LEFT" TO FD320 MOVE SO-GN(4) TO FD321 MOVE "PCS" TO FD322.
    COMPUTE FD323 ROUNDED=100 * SO-GN(4) / SO-GN(1) SIZE ERROR CONTINUE.
    MOVE "% OF QTY ORDERED" TO FD324 PERFORM SO-LINE.
SO9. IF Y3 PERFORM CLOSE-REP. PERFORM CLOSE-PR GO MX9.

SO-SUB. MOVE 2 TO WS-PR MOVE "** TOTAL PIECES" TO FD313.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE SO-SN(IX1) TO FD315(IX1) END-PERFORM.
    PERFORM SO-LINE MOVE 2 TO WS-PR MOVE LOW-VALUES TO SO-STOTALS.
SO-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM SO-PAGE.
SO-PAGE. MOVE "PRODUCTION ORDERS REPORT" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** BY ORDERS **"  TO FF4
      WHEN Y2 MOVE "** BY PRODUCT **" TO FF4
      WHEN Y3 MOVE "** BY START DATE **" TO FF4
      WHEN Y4 MOVE "** PAST DUE BY PRODUCT **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    IF Y2 MOVE 2 TO WS-PR PERFORM PRANGE-PROD.
    IF Y3 MOVE "REQD. BY:" TO A-A1 PERFORM PRANGE-DT.
    MOVE " M.O.   SALES ORD  PRODUCT       DESCRIPTION                      START DATE     ORDERED     PRODUCED     RECEIVED         LEFT" TO PREC PERFORM PR-LINE-3.
*         ......  ......-..  ............  ................................  ../../..  ...,...,...- ...,...,...- ...,...,...- ...,...,...-

* Z-4 SALES HISTORY REPORTS
HR1. PERFORM RD178 PERFORM WRT.
    IF S-BAT MOVE S-A1 TO HR-CUSORD MOVE S-N1 TO HR-LTH MOVE S-N2 TO HR-SHIPTO
      MOVE S-S1 TO HR-KS MOVE S-S2 TO HR-KD GO HR2.
    PERFORM AX-SEL IF SEL-N=0 OR>8 GO MX1.
    IF Y2 PERFORM AX-CAT PERFORM AX-PROD PERFORM AX-CUS PERFORM AX-DATE GO HR14.
    IF Y3 PERFORM AX-CUS PERFORM AX-DATE GO HR16.
    IF Y4 OR Y5 PERFORM AX-DATE GO HR16. IF Y6 GO HR16.
    IF Y7 PERFORM AX-DATE GO HR16. IF Y8 PERFORM AX-DATE PERFORM AX-CUS GO HR18.
* Y1
    PERFORM AX-CUS PERFORM AX-PROD PERFORM AX-DATE.
    ADD 1 TO IXT DISPLAY "EXCLUDE STANDARD PRODUCTS ? ___ " LINE IXT BOLD.
    ACCEPT XA3 LINE IXT COLUMN 29 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO HR-KS ELSE MOVE 0 TO HR-KS.
    ADD 1 TO IXT DISPLAY "SELECT ONLY CUSTOMER ORDERS STARTING WITH: ____" LINE IXT BOLD.
    ACCEPT HR-CUSORD COLUMN 44 DEFAULT " " UNDERLINED PROTECTED.
    MOVE HR-CUSORD TO A-A1 PERFORM STR-LTH MOVE A-N1 TO HR-LTH.
    ADD 1 TO IXT DISPLAY "SELECT ONLY CUSTOMER ORDERS WITH SHIP-TO CODE: __" LINE IXT BOLD.
    ACCEPT HR-SHIPTO COLUMN 48 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
HR14. PERFORM AX-SUM IF SUM-IND=1 MOVE 1 TO TOT-IND ELSE PERFORM AX-TOT.
HR16. ADD 1 TO IXT DISPLAY "REPORT IN CAN$ ? ___" LINE IXT BOLD "  (OTHERWISE REPORTED IN MIXED $)".
    ACCEPT XA3 LINE IXT COLUMN 18 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO HR-KD ELSE MOVE 0 TO HR-KD.
HR18. PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE HR-CUSORD TO S-A1 MOVE HR-LTH TO S-N1 MOVE HR-SHIPTO TO S-N2
      MOVE HR-KS TO S-S1 MOVE HR-KD TO S-S2 GO MX9.
HR2. PERFORM DSP-WAIT PERFORM RDR-INFO.
    GO HR30 HR40 HR50 HR60 HR70 HR810 HR820 HR830  DEPENDING SEL-N.

HR30. PERFORM OPEN-PR PERFORM HR-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HR-HEADLN1 TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE LOW-VALUES TO HR-CTOTALS HR-PTOTALS HR-GTOTALS MOVE " " TO OLD-C OLD-A.
    INITIALIZE SH-KEY MOVE CUS1 TO SH-CUS.
    START SALHIST KEY>=SH-KEY REGARDLESS INVALID GO HR39.
HR33. READ SALHIST NEXT REGARDLESS END GO HR39. IF SH-CUS>CUS2 GO HR39.
    IF NOT(SH-CAT<90 AND (SH-PROD>=PROD1 AND<=PROD2) AND (SH-DATE>=DATE1 AND<=DATE2)) GO HR33.
    IF HR-KS=1 MOVE SH-CAT TO P-CAT PERFORM CHK-STANDARD IF PRO-KS=1 GO HR33.
    IF HR-LTH>0 IF SH-CUSORD(1:HR-LTH) NOT=HR-CUSORD GO HR33.
    IF HR-SHIPTO>0 IF SH-SHIPTO NOT=HR-SHIPTO GO HR33.
    IF SH-CUS=OLD-C GO HR334. IF OLD-C>" " PERFORM HR-C-P PERFORM HR-C-C.
    MOVE SH-CUS TO OLD-C MOVE " " TO OLD-A MOVE 2 TO WS-PR.
    MOVE SH-CUS TO FG282 A-A1 PERFORM RD-CUS MOVE C-NAME TO FG283 OLD-NAME.
    MOVE C-PROV TO OLD-N PERFORM HR-PRV.
    IF C-US=0 MOVE "CAN" TO OLD-B ELSE MOVE "USD" TO OLD-B.
    IF SUM-IND=0 PERFORM HR-LINE 2 TIMES ELSE MOVE " " TO PREC.
HR334. IF SH-PROD=OLD-A GO HR336. IF OLD-A>" " PERFORM HR-C-P. MOVE SH-PROD TO OLD-A.
    MOVE SH-CAT TO FG271 MOVE SH-PROD TO FG272 A-A1 PERFORM PROD-RGD.
    MOVE PRO-DESC(1) TO OLD-DESC FG273.
HR336. MOVE SH-CUS TO EXP-A PERFORM EXPF MOVE OLD-NAME TO EXP-A PERFORM EXPF.
    MOVE OLD-N TO EXP-N PERFORM EXPF MOVE P-NO TO EXP-A PERFORM EXPF.
    IF GEN-IND=1 MOVE GEN-ALT TO EXP-A. PERFORM EXPF.
    MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE SH-INVNO TO FG274 MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG275.
    MOVE SH-AMT TO HR-AMT.
    IF HR-KD=1 AND SH-US=1 MOVE SH-DATE TO D-DATE MOVE HR-AMT TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO HR-AMT.
    MOVE SH-QTY TO FG276 EXP-N PERFORM EXPF MOVE HR-AMT TO FG277 EXP-D PERFORM EXPF.
    MOVE SH-WEIGHT TO FG278 EXP-N PERFORM EXPF MOVE OLD-B TO FG277A EXP-A PERFORM EXPF.
    MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    ADD SH-QTY TO HR-PQ HR-CQ HR-GQ ADD HR-AMT TO HR-PA HR-CA HR-GA.
    ADD SH-WEIGHT TO HR-PW HR-CW HR-GW.
    IF SH-INVNO>500000 ADD SH-QTY TO HR-PS HR-CS HR-GS
      MOVE SH-DATE-REQ TO D-DATE MOVE 2 TO D-DAYS PERFORM D-WDIFF
      IF SH-DATE>D-DATE MOVE "*" TO FG279 ADD SH-QTY TO HR-PL HR-CL HR-GL.
    IF TOT-IND=0 PERFORM HR-LINE PERFORM EXP-LINE ELSE MOVE " " TO PREC PERFORM EXP-CLR.
    GO HR33.
* note 264.3
HR39. PERFORM HR-C-P PERFORM HR-C-C.
    MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    MOVE HR-GQ TO FG276 MOVE HR-GA TO FG277 MOVE HR-GW TO FG278.
    COMPUTE FG280 ROUNDED=HR-GL * 100 / HR-GS SIZE ERROR CONTINUE. MOVE "%" TO FG281.
    PERFORM PR-LINE.
    IF TOT-IND=1 MOVE 5 TO A-N1 PERFORM EXPFN MOVE "*** GRAND TOTALS" TO EXP-A PERFORM EXPF
      MOVE HR-GQ TO EXP-N PERFORM EXPF MOVE HR-GA TO EXP-D PERFORM EXPF
      MOVE HR-GW TO EXP-N PERFORM EXPF MOVE 2 TO A-N1 PERFORM EXPFN PERFORM EXP-LINE.
    PERFORM CLOSE-PR PERFORM CLOSE-EXP GO HR9.

HR40. PERFORM OPEN-REP MOVE " " TO OLD-A.
    INITIALIZE SH-KP MOVE PROD1 TO SH-KPROD.
    START SALHIST KEY>=SH-KP REGARDLESS INVALID GO HR429.
HR423. READ SALHIST NEXT REGARDLESS END GO HR429. IF SH-KPROD>PROD2 GO HR429.
    IF NOT(SH-CAT<90 AND (SH-KCUS>=CUS1 AND<=CUS2) AND (SH-DATE>=DATE1 AND<=DATE2)) GO HR423.
* note 180
    IF SH-KPROD NOT=OLD-A MOVE SH-KPROD TO OLD-A A-A1 PERFORM PROD-RT.
    IF NOT(P-CAT>=CAT1 AND<=CAT2) GO HR423. PERFORM INIT-RP.
    MOVE P-CAT TO RP-F355 MOVE SH-KPROD TO RP-F356 MOVE SH-KCUS TO RP-F357.
    MOVE SH-KDATE TO RP-F358 MOVE SH-KTIME TO RP-F359 WRITE RP-RECORD GO HR423.
HR429. PERFORM OPEN-PR PERFORM HR-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HR-HEADLN2 TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE LOW-VALUES TO HR-NTOTALS HR-PTOTALS HR-CTOTALS HR-GTOTALS.
    MOVE 0 TO OLD-N MOVE " " TO OLD-A OLD-C.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO HR49.
HR43. READ REPFL NEXT END GO HR49. MOVE RP-F356 TO SH-PROD MOVE RP-F357 TO SH-CUS.
    MOVE RP-F358 TO SH-CDATE MOVE RP-F359 TO SH-CTIME READ SALHIST REGARDLESS.
    IF RP-F355=OLD-N GO HR432.
    IF OLD-N>0 PERFORM HR-P-C PERFORM HR-P-P PERFORM HR-P-N.
    MOVE RP-F355 TO OLD-N MOVE " " TO OLD-A OLD-C MOVE 2 TO WS-PR.
    MOVE "CAT" TO FG294 MOVE OLD-N TO FG294A PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FG294B.
    IF SUM-IND=0 PERFORM HR-LINE 2 TIMES ELSE MOVE " " TO PREC.
HR432. IF SH-KPROD=OLD-A GO HR434. IF OLD-A>" " PERFORM HR-P-C PERFORM HR-P-P.
    MOVE SH-KPROD TO OLD-A MOVE " " TO OLD-C MOVE 2 TO WS-PR.
    MOVE SH-KPROD TO FG285 A-A1 PERFORM PROD-RGD MOVE PRO-DESC(1) TO OLD-DESC FG286.
    IF SUM-IND=0 PERFORM HR-LINE 2 TIMES ELSE MOVE " " TO PREC.
HR434. IF SH-KCUS=OLD-C GO HR436. IF OLD-C>" " PERFORM HR-P-C. MOVE SH-KCUS TO OLD-C.
    MOVE SH-KCUS TO FG287 A-A1 PERFORM RD-CUS MOVE C-NAME TO OLD-NAME FG288.
    IF C-US=0 MOVE "CAN" TO OLD-B ELSE MOVE "USD" TO OLD-B.
HR436. MOVE P-NO TO EXP-A PERFORM EXPF.
    IF GEN-IND=1 MOVE GEN-ALT TO EXP-A. PERFORM EXPF.
    MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE SH-KCUS TO EXP-A PERFORM EXPF MOVE OLD-NAME TO EXP-A PERFORM EXPF.
    MOVE SH-INVNO TO FG289 MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG290.
    MOVE SH-AMT TO HR-AMT.
    IF HR-KD=1 AND SH-US=1 MOVE SH-DATE TO D-DATE MOVE HR-AMT TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO HR-AMT.
    MOVE SH-QTY TO FG291 EXP-N PERFORM EXPF MOVE HR-AMT TO FG292 EXP-D PERFORM EXPF.
    MOVE SH-WEIGHT TO FG293 EXP-N PERFORM EXPF MOVE OLD-B TO FG292A EXP-A PERFORM EXPF.
    ADD SH-QTY TO HR-NQ HR-PQ HR-CQ HR-GQ ADD HR-AMT TO HR-NA HR-PA HR-CA HR-GA.
    ADD SH-WEIGHT TO HR-NW HR-PW HR-CW HR-GW.
    IF TOT-IND=0 PERFORM HR-LINE PERFORM EXP-LINE ELSE MOVE " " TO PREC PERFORM EXP-CLR.
    GO HR43.
HR49. PERFORM HR-P-C PERFORM HR-P-P PERFORM HR-P-N.
    MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    MOVE HR-GQ TO FG291 MOVE HR-GA TO FG292 MOVE HR-GW TO FG293 PERFORM PR-LINE.
    IF TOT-IND=1 MOVE 2 TO A-N1 PERFORM EXPFN MOVE "*** GRAND TOTALS" TO EXP-A PERFORM EXPF
      MOVE 2 TO A-N1 PERFORM EXPFN MOVE HR-GQ TO EXP-N PERFORM EXPF
      MOVE HR-GA TO EXP-D PERFORM EXPF MOVE HR-GW TO EXP-N PERFORM EXPF
      PERFORM EXPF PERFORM EXP-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO HR9.

HR50. PERFORM OPEN-REP INITIALIZE SH-KEY MOVE CUS1 TO SH-CUS.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO HR529.
HR523. READ SALHIST NEXT REGARDLESS END GO HR529. IF SH-CUS>CUS2 GO HR529.
    IF NOT(SH-CAT<90 AND (SH-DATE>=DATE1 AND<=DATE2)) GO HR523.
    PERFORM INIT-RP MOVE SH-CUS TO RP-F363 MOVE SH-INVNO TO RP-F364.
    MOVE SH-DATE TO RP-F365 MOVE SH-AMT TO RP-F366 MOVE SH-US TO RP-F367.
    WRITE RP-RECORD INVALID READ REPFL ADD SH-AMT TO RP-F366 REWRITE RP-RECORD.
    GO HR523.
HR529. PERFORM OPEN-PR PERFORM HR-PAGE.

    MOVE 0 TO HR-CA HR-GA MOVE " " TO OLD-C.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO HR59.
HR53. READ REPFL NEXT END GO HR59. IF RP-F363=OLD-C GO HR534.
    IF OLD-C NOT=" " PERFORM HR-C-T.
    MOVE RP-F363 TO OLD-C FA803 A-A1 PERFORM RD-CUS MOVE C-NAME TO FA804.
HR534. MOVE RP-F364 TO FA805 MOVE RP-F365 TO D-DATE PERFORM D-NM MOVE D-DT TO FA806.
    MOVE RP-F366 TO HR-AMT.
    IF HR-KD=1 AND RP-F367=1 MOVE RP-F365 TO D-DATE MOVE HR-AMT TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO HR-AMT.
    MOVE HR-AMT TO FA807 ADD HR-AMT TO HR-CA HR-GA.
    PERFORM HR-LINE GO HR53.
HR59. PERFORM HR-C-T.
    MOVE 3 TO WS-PR MOVE "*** GRAND-TOTAL" TO PREC MOVE HR-GA TO FA807.
    MOVE "***" TO FA808 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO HR9.

HR60. PERFORM OPEN-SORT PERFORM OPEN-REP.
    INITIALIZE SH-KEY START SALHIST KEY>SH-KEY REGARDLESS INVALID GO HR626.
HR623. READ SALHIST NEXT REGARDLESS END GO HR626.
    IF NOT(SH-DATE>=DATE1 AND<=DATE2) GO HR623. MOVE SH-AMT TO HR-AMT.
    IF HR-KD=1 AND SH-US=1 MOVE SH-DATE TO D-DATE MOVE HR-AMT TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO HR-AMT.
    MOVE SH-PROD TO A-A1 PERFORM PROD-GEN.
    PERFORM INIT-SR MOVE P-NO TO SR-F150 PERFORM HR-AQ.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM HR-AQ REWRITE SR-RECORD.
    GO HR623.
HR626. MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO HR629.
HR627. READ SORTFL NEXT END GO HR629. PERFORM INIT-RP.
    IF SR-F152>0 MOVE 0 TO RP-F381 COMPUTE RP-F382=999999999 - SR-F152
      ELSE MOVE 1 TO RP-F381 COMPUTE RP-F382=-SR-F152.
    MOVE SR-F150 TO RP-F383 MOVE SR-F151 TO RP-F384 MOVE SR-F152 TO RP-F385.
    MOVE SR-F153 TO RP-F386 WRITE RP-RECORD GO HR627.
HR629. PERFORM OPEN-PR PERFORM HR-PAGE.
    MOVE 99 TO A-N1 PERFORM RD-MACTYPE COMPUTE HR-MECOST=ME-COST.

    MOVE 0 TO WN1 MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO HR69.
HR63. READ REPFL NEXT END GO HR69. ADD 1 TO WN1 MOVE WN1 TO FA843.
    MOVE RP-F383 TO FA844 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FA845.
    MOVE P-CAT TO FA846 MOVE RP-F384 TO FA847 MOVE RP-F385 TO FA848.
    COMPUTE FA849 ROUNDED=RP-F386.
* note 238
    MOVE P-NO TO CU-PROD READ COSTHIST REGARDLESS INVALID GO HR66.
    COMPUTE HR-CONTRIB ROUNDED=
      RP-F386 - (CU-TOT(1,1) + CU-TOT(1,2) + CU-TOT(1,3)) * RP-F384 / 1000.
    COMPUTE FA850 ROUNDED=HR-CONTRIB.
    COMPUTE FA851 ROUNDED=HR-CONTRIB * 100 / RP-F386 SIZE ERROR CONTINUE.
    IF P-MAC=99 MOVE 0 TO HR-OVERHEAD
      ELSE COMPUTE HR-OVERHEAD ROUNDED=HR-MECOST * RP-F385 / 2000 SIZE ERROR MOVE 0 TO HR-OVERHEAD.
    COMPUTE HR-MARGIN=HR-CONTRIB - HR-OVERHEAD COMPUTE FA852 ROUNDED=HR-MARGIN.
    COMPUTE FA853 ROUNDED=HR-MARGIN * 100 / RP-F386 SIZE ERROR CONTINUE.
HR66. PERFORM HR-LINE GO HR63.
HR69. PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR GO HR9.

HR70. PERFORM OPEN-SORT.
    INITIALIZE SH-KEY START SALHIST KEY>SH-KEY REGARDLESS INVALID GO HR729.
HR723. READ SALHIST NEXT REGARDLESS END GO HR729. IF NOT(SH-DATE>=DATE1 AND<=DATE2) GO HR723.
    MOVE SH-AMT TO HR-AMT.
    IF HR-KD=1 AND SH-US=1 MOVE SH-DATE TO D-DATE MOVE HR-AMT TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO HR-AMT.
    MOVE SH-PROD TO A-A1 PERFORM PROD-GEN.
    PERFORM INIT-SR MOVE P-NO TO SR-F164 PERFORM HR-AS.
    MOVE " " TO SR-F168X MOVE SH-CUS TO SR-F168(1).
    WRITE SR-RECORD INVALID READ SORTFL PERFORM HR-AS
      PERFORM VARYING IX1 FROM 1 BY 1
        UNTIL IX1>5 OR (SR-F168(IX1)=" " OR SH-CUS) CONTINUE END-PERFORM
      IF IX1<=5 MOVE SH-CUS TO SR-F168(IX1) END-IF REWRITE SR-RECORD.
    GO HR723.
HR729. MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HR-HEADLN3 TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO HR79.
HR73. READ SORTFL NEXT END GO HR79. MOVE SR-F164 TO A-A1 PERFORM PROD-RD.
    MOVE P-NO TO EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE SR-F165 TO EXP-N PERFORM EXPF MOVE SR-F166 TO EXP-N PERFORM EXPF.
    MOVE SR-F167 TO EXP-D PERFORM EXPF MOVE P-CAT TO EXP-N PERFORM EXPF.
    PERFORM SET-PART MOVE PART-NO TO EXP-A PERFORM EXPF.
    MOVE P-PROC TO EXP-N PERFORM EXPF MOVE P-CLEAN TO EXP-N PERFORM EXPF.
    MOVE P-MAC TO EXP-N PERFORM EXPF MOVE P-RATE TO EXP-N PERFORM EXPF.
    PERFORM GET-OP IF A-S1=1 MOVE 12 TO A-N1 PERFORM EXPFN GO HR78.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      MOVE OP-OPER(IX1) TO EXP-N PERFORM EXPF END-PERFORM.
HR78. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
       MOVE SR-F168(IX1) TO EXP-A PERFORM EXPF END-PERFORM.
    MOVE P-MAC TO A-N1 PERFORM CHK-PUR.
    IF A-S1=1 MOVE P-MAC TO CST-MAC PERFORM COST-PART
      READ PART REGARDLESS INVALID CONTINUE END-READ MOVE PH-LDCOST TO EXP-T.
    PERFORM EXPF PERFORM EXP-LINE GO HR73.
HR79. PERFORM CLOSE-SORT PERFORM CLOSE-EXP GO HR9.

HR810. PERFORM OPEN-SORT.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO HR812.
HR811. READ PRODUCT NEXT REGARDLESS END GO HR812.
    PERFORM CHK-NEW IF A-S1=1 MOVE P-NO TO SR-F175 WRITE SR-RECORD. GO HR811.
HR812. MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HR-HEADLN4 TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO HR819.
HR813. READ CUSTOMER NEXT REGARDLESS END GO HR819.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO HR818.
HR815. READ SORTFL NEXT END GO HR818.
    MOVE SR-F175 TO HR-PROD A-A1 PERFORM PROD-RGD.
    MOVE 0 TO HR-HQTY HR-HWEIGHT INITIALIZE SH-KEY.
    MOVE C-NO TO SH-CUS MOVE HR-PROD TO SH-PROD COMPUTE SH-CDATE=SYS-DATE - 365.
    START SALHIST KEY>=SH-KEY REGARDLESS INVALID GO HR8154.
HR8153. READ SALHIST NEXT REGARDLESS END GO HR8154.
    IF NOT(SH-CUS=C-NO AND SH-PROD=HR-PROD) GO HR8154.
    ADD SH-QTY TO HR-HQTY ADD SH-WEIGHT TO HR-HWEIGHT GO HR8153.
HR8154. MOVE 0 TO WS1 MOVE HR-PROD TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO HR8156. READ SALIN NEXT REGARDLESS.
    IF L-PROD=HR-PROD AND L-CUS=C-NO MOVE 1 TO WS1.
HR8156. IF HR-HQTY=0 AND HR-HWEIGHT=0 AND WS1=0 GO HR8178.
    IF P-CAT<=21 OR WS1=0
      PERFORM HR-EXPC MOVE 4 TO A-N1 PERFORM EXPFN PERFORM EXP-LINE GO HR8178.

    MOVE HR-PROD TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO HR8164.
HR8163. READ SALIN NEXT REGARDLESS END GO HR8164. IF L-PROD NOT=HR-PROD GO HR8164.
    IF L-CUS NOT=C-NO OR L-QTY-LEFT=0 GO HR8163.
    PERFORM HR-EXPC.
    MOVE L-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    MOVE L-QTY-LEFT TO CL-QTY PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    MOVE CL-QTY TO EXP-N PERFORM EXPF MOVE CL-WEIGHT-I TO EXP-N PERFORM EXPF.
    MOVE CL-AMT TO A-D1.
    IF HR-KD=1 AND C-US=1 MOVE CL-AMT TO A-T1 MOVE SYS-DATE TO D-DATE PERFORM EXCHG-CONV.
    MOVE A-D1 TO EXP-D PERFORM EXPF PERFORM EXP-LINE GO HR8163.
HR8164.
HR8178. GO HR815.
HR818. GO HR813.
HR819. PERFORM CLOSE-SORT PERFORM CLOSE-EXP GO HR9.

HR820. PERFORM OPEN-REP INITIALIZE SH-KEY.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO HR824.
HR823. READ SALHIST NEXT REGARDLESS END GO HR824.
    IF NOT(SH-CAT<90 AND (SH-DATE>=DATE1 AND<=DATE2)) GO HR823.
    PERFORM INIT-RP MOVE SH-INVNO TO RP-F424.
    MOVE SH-DATE TO RP-F425 MOVE SH-US TO RP-F426 PERFORM HR-AT.
    WRITE RP-RECORD INVALID READ REPFL PERFORM HR-AT REWRITE RP-RECORD.
    GO HR823.
HR824. PERFORM OPEN-PR PERFORM HR-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HR-HEADLN5 TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE LOW-VALUES TO HR-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO HR826.
HR825. READ REPFL NEXT END GO HR826. MOVE RP-F424 TO FA176 EXP-N PERFORM EXPF.
    MOVE RP-F425 TO D-DATE PERFORM D-NM MOVE D-DT TO FA177 EXP-DT PERFORM EXPF.
    IF HR-KD=1 AND RP-F426=1 MOVE RP-F425 TO D-DATE MOVE RP-F427 TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO RP-F427.
    MOVE RP-F427 TO FA178 EXP-D PERFORM EXPF MOVE RP-F428 TO FA179 EXP-N PERFORM EXPF.
    MOVE RP-F429 TO FA180 EXP-N PERFORM EXPF PERFORM EXP-LINE.
    ADD RP-F427 TO HR-GA ADD RP-F428 TO HR-GQ ADD RP-F429 TO HR-GW.
    PERFORM HR-LINE GO HR825.
HR826. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO PREC.
    MOVE HR-GA TO FA178 MOVE HR-GQ TO FA179 MOVE HR-GW TO FA180 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO HR9.

HR830. PERFORM OPEN-REP INITIALIZE SH-KEY MOVE CUS1 TO SH-CUS.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO HR8329.
HR8323. READ SALHIST NEXT REGARDLESS END GO HR8329. IF SH-CUS>CUS2 GO HR8329.
    IF NOT(SH-DATE>=DATE1 AND<=DATE2) GO HR8323.
    PERFORM INIT-RP MOVE SH-DATE TO RP-F475 MOVE SH-INVNO TO RP-F476.
    MOVE SH-KEY TO RP-F477 WRITE RP-RECORD GO HR8323.
HR8329. MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE HR-HEADLN6 TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO HR839.
HR833. READ REPFL NEXT END GO HR839. MOVE RP-F477 TO SH-KEY READ SALHIST REGARDLESS.
    MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO HR-DT EXP-DT PERFORM EXPF.
    MOVE SH-INVNO TO EXP-N PERFORM EXPF MOVE SH-CUSORD TO EXP-A PERFORM EXPF.
    MOVE SH-BL TO EXP-N PERFORM EXPF MOVE HR-DT TO EXP-DT PERFORM EXPF.
    MOVE SH-PROD TO EXP-A A-A1 PERFORM PROD-RD PERFORM EXPF.
    MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF MOVE SH-QTY TO EXP-N PERFORM EXPF.
    COMPUTE EXP-T ROUNDED=SH-AMT * 1000 / SH-QTY SIZE ERROR CONTINUE. PERFORM EXPF.
    MOVE "M" TO EXP-A PERFORM EXPF MOVE SH-AMT TO EXP-D PERFORM EXPF.
    IF SH-US=0 MOVE "CAN" TO EXP-A ELSE MOVE "USD" TO EXP-A. PERFORM EXPF.
    MOVE SH-CUS TO EXP-A A-A1 PERFORM RD-CUS PERFORM EXPF.
    MOVE C-NAME TO EXP-A PERFORM EXPF.
    PERFORM EXP-LINE GO HR833.
HR839. PERFORM CLOSE-REP PERFORM CLOSE-EXP GO HR9.

HR9. GO MX9.

HR-AQ. ADD SH-QTY TO SR-F151 ADD SH-WEIGHT TO SR-F152 ADD HR-AMT TO SR-F153.
HR-AS. ADD SH-QTY TO SR-F165 ADD SH-WEIGHT TO SR-F166 ADD HR-AMT TO SR-F167.
HR-AT. ADD SH-AMT TO RP-F427 ADD SH-QTY TO RP-F428 ADD SH-WEIGHT TO RP-F429.
HR-EXPC. MOVE C-NO TO EXP-A PERFORM EXPF MOVE HR-PROD TO EXP-A PERFORM EXPF.
    MOVE P-CAT TO EXP-N PERFORM EXPF MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE P-HAND TO EXP-N PERFORM EXPF.
    MOVE P-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    MOVE P-PRICE1 TO EXP-T PERFORM EXPF MOVE P-PRICE2 TO EXP-T PERFORM EXPF.
    MOVE P-WEIGHT TO EXP-D PERFORM EXPF MOVE P-QUOTNO TO EXP-N PERFORM EXPF.
    MOVE HR-HQTY TO EXP-N PERFORM EXPF MOVE HR-HWEIGHT TO EXP-N PERFORM EXPF.
    MOVE P-EST TO EXP-N PERFORM EXPF.
    COMPUTE EXP-N ROUNDED=P-EST * P-WEIGHT / 100 PERFORM EXPF.
    MOVE P-MODE TO A-A1 PERFORM RD-MODE.
    COMPUTE EXP-N ROUNDED=P-EST * P-PRICE1 / A-N1 PERFORM EXPF.
HR-PRV. MOVE OLD-N TO DSP-N21 STRING "(PROV " DSP-N21 ")" DELIMITED SIZE INTO FG284.
* note 181
HR-C-C. IF SUM-IND=0 MOVE 2 TO WS-PR MOVE " ** CUSTOMER TOTALS" TO PREC
      ELSE MOVE OLD-C TO FG282 MOVE OLD-NAME TO FG283 PERFORM HR-PRV.
    MOVE HR-CQ TO FG276 MOVE HR-CA TO FG277 MOVE OLD-B TO FG277A MOVE HR-CW TO FG278.
    COMPUTE FG280 ROUNDED=HR-CL * 100 / HR-CS SIZE ERROR CONTINUE. MOVE "%" TO FG281.
    IF SUM-IND=0 PERFORM HR-LINE 2 TIMES ELSE PERFORM HR-LINE.
    IF TOT-IND=1 MOVE OLD-C TO EXP-A PERFORM EXPF MOVE OLD-NAME TO EXP-A PERFORM EXPF
      MOVE OLD-N TO EXP-N PERFORM EXPF MOVE 3 TO A-N1 PERFORM EXPFN
      MOVE HR-CQ TO EXP-N PERFORM EXPF MOVE HR-CA TO EXP-D PERFORM EXPF
      MOVE HR-CW TO EXP-N PERFORM EXPF MOVE OLD-B TO EXP-A PERFORM EXPF
      PERFORM EXPF PERFORM EXP-LINE.
    MOVE LOW-VALUES TO HR-CTOTALS.
HR-C-P. PERFORM HR-CP1 THRU HR-CP9.
HR-CP1. IF SUM-IND=1 GO HR-CP8.
    IF TOT-IND=0 MOVE 2 TO WS-PR MOVE " ** PRODUCT TOTALS" TO PREC
      ELSE MOVE OLD-A TO FG272 MOVE OLD-DESC TO FG273.
    MOVE HR-PQ TO FG276 MOVE HR-PA TO FG277 MOVE HR-PW TO FG278.
    COMPUTE FG280 ROUNDED=HR-PL * 100 / HR-PS SIZE ERROR CONTINUE. MOVE "%" TO FG281.
    IF TOT-IND=0 PERFORM HR-LINE 2 TIMES ELSE PERFORM HR-LINE.
    IF TOT-IND=1 MOVE 3 TO A-N1 PERFORM EXPFN MOVE OLD-A TO EXP-A PERFORM EXPF
      IF GEN-IND=1 MOVE GEN-ALT TO EXP-A END-IF PERFORM EXPF
      MOVE OLD-DESC TO EXP-A PERFORM EXPF
      MOVE HR-PQ TO EXP-N PERFORM EXPF MOVE HR-PA TO EXP-D PERFORM EXPF
      MOVE HR-PW TO EXP-N PERFORM EXPF MOVE 2 TO A-N1 PERFORM EXPFN PERFORM EXP-LINE.
HR-CP8. MOVE LOW-VALUES TO HR-PTOTALS.
HR-CP9. EXIT.
HR-P-N. MOVE 2 TO WS-PR.
    IF SUM-IND=0 MOVE " ** CATEGORY TOTALS" TO PREC
      ELSE MOVE "CAT" TO FG294 MOVE OLD-N TO FG294A PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FG294B.
    MOVE HR-NQ TO FG291 MOVE HR-NA TO FG292 MOVE HR-NW TO FG293.
    PERFORM HR-LINE 2 TIMES MOVE LOW-VALUES TO HR-NTOTALS.
HR-P-P. IF SUM-IND=0 MOVE 2 TO WS-PR MOVE " ** PRODUCT TOTALS" TO PREC
      ELSE MOVE OLD-A TO FG285 MOVE OLD-DESC TO FG286.
    MOVE HR-PQ TO FG291 MOVE HR-PA TO FG292 MOVE HR-PW TO FG293.
    IF SUM-IND=0 PERFORM HR-LINE 2 TIMES ELSE PERFORM HR-LINE.
    IF TOT-IND=1 MOVE OLD-A TO EXP-A PERFORM EXPF
      IF GEN-IND=1 MOVE GEN-ALT TO EXP-A END-IF PERFORM EXPF
      MOVE OLD-DESC TO EXP-A PERFORM EXPF MOVE 2 TO A-N1 PERFORM EXPFN
      MOVE HR-PQ TO EXP-N PERFORM EXPF MOVE HR-PA TO EXP-D PERFORM EXPF
      MOVE HR-PW TO EXP-N PERFORM EXPF PERFORM EXPF PERFORM EXP-LINE.
    MOVE LOW-VALUES TO HR-PTOTALS.
HR-P-C. PERFORM HR-PC1 THRU HR-PC9.
HR-PC1. IF SUM-IND=1 GO HR-PC8.
    IF TOT-IND=0 MOVE 2 TO WS-PR MOVE " ** CUSTOMER TOTALS" TO PREC
      ELSE MOVE OLD-C TO FG287 MOVE OLD-NAME TO FG288.
    MOVE HR-CQ TO FG291 MOVE HR-CA TO FG292 MOVE OLD-B TO FG292A MOVE HR-CW TO FG293.
    IF TOT-IND=0 PERFORM HR-LINE 2 TIMES ELSE PERFORM HR-LINE.
    IF TOT-IND=1 MOVE 3 TO A-N1 PERFORM EXPFN
      MOVE OLD-C TO EXP-A PERFORM EXPF MOVE OLD-NAME TO EXP-A PERFORM EXPF
      MOVE HR-CQ TO EXP-N PERFORM EXPF MOVE HR-CA TO EXP-D PERFORM EXPF
      MOVE HR-CW TO EXP-N PERFORM EXPF MOVE OLD-B TO EXP-A PERFORM EXPF PERFORM EXP-LINE.
HR-PC8. MOVE LOW-VALUES TO HR-CTOTALS.
HR-PC9. EXIT.
HR-C-T. MOVE HR-CA TO FA807 MOVE "**" TO FA808 PERFORM HR-LINE 2 TIMES MOVE 0 TO HR-CA.
HR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM HR-PAGE.
HR-PAGE. MOVE "SALES HISTORY REPORT" TO FF3 EVALUATE TRUE
      WHEN Y1 IF HR-KS=0 MOVE "** BY CUSTOMER - INCL STD PRODUCTS" TO A-A1
        ELSE MOVE "** BY CUSTOMER - EXCL STD PRODUCTS" TO A-A1 END-IF
      WHEN Y2 MOVE "** BY PRODUCT" TO A-A1
      WHEN Y3 MOVE "** INVOICES BY CUSTOMER" TO A-A1
      WHEN Y4 MOVE "** PRODUCT RANKING BY WEIGHT" TO A-A1
      WHEN Y7 MOVE "** BY INVOICE" TO A-A1
      END-EVALUATE.
    IF HR-KD=0 MOVE "(MIXED $) **" TO A-A2 ELSE MOVE "(CAN$) **" TO A-A2.
    STRING A-A1 DELIMITED "  " "  " DELIMITED SIZE A-A2 DELIMITED "  " INTO FF4.
    PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE MOVE 1 TO WS-PR.
    IF Y1 MOVE " " TO A-A1
      IF HR-SHIPTO>0 MOVE HR-SHIPTO TO DSP-N21
        STRING "    SHIP-TO CODE: " DSP-N21 DELIMITED SIZE INTO A-A1 END-IF
      STRING "CUSTOMER RANGE SELECTED: " DELIMITED SIZE CUS1 DELIMITED " "
        " - " DELIMITED SIZE CUS2 DELIMITED " " A-A1(1:20) DELIMITED SIZE
          INTO PREC PERFORM PR-LINE
      IF HR-LTH>0 STRING "CUSTOMER ORDERS SELECTED: " DELIMITED SIZE
        HR-CUSORD "---" DELIMITED " " INTO PREC PERFORM PR-LINE END-IF
      PERFORM PRANGE-PROD.
    IF Y2 PERFORM PRANGE-CAT MOVE 1 TO WS-PR PERFORM PRANGE-PROD
      MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    IF Y3 PERFORM PRANGE-CUS.
    IF Y4 MOVE "COSTING CALCULATIONS ARE BASED ON MOST RECENT COST HISTORY DATA"
      TO PREC PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
    IF Y1 MOVE
         "CAT  PRODUCT       DESCRIPTION                       INVOICE   DATE        QUANTITY         AMOUNT   CURR     WEIGHT    LATE SHP" TO PREC.
*          ..  ............  ................................  ......  ../../..  ....,...,...-  ..,...,...:..- ...  ..,...,...-      .
*                                                                                                                                   ...%
    IF Y2 MOVE
         "CUST    NAME                              INVOICE   DATE        QUANTITY         AMOUNT   CURR     WEIGHT" TO PREC.
*         ......  ................................  ......  ../../..  ....,...,...-  ..,...,...:..- ...  ..,...,...-
    IF Y3 MOVE
         "CUST    NAME                              INVOICE   DATE          AMOUNT" TO PREC.
*         ......  ................................  ......  ../../..  ...,...,...:..- ...
    IF Y4 MOVE
         "      PRODUCT      DESCRIPTION                      CAT        QTY       WEIGHT      AMOUNT     CONTR$   CONTR%   GRS MRG$  GRS MRG%" TO PREC.
*         ....  ............ ................................ ..  ...,...,...- ..,...,...- ..,...,...- .,...,...-  ...:.-  .,...,...-  ...:.-
    IF Y7 MOVE
         "INVOICE   DATE          AMOUNT      QUANTITY       WEIGHT" TO PREC.
*         ......  ../../..  ..,...,...:..-  ..,...,...-  ..,...,...-
    PERFORM PR-LINE-3.

* Z-5 BIN REPORTS
BR1. PERFORM RD152 PERFORM WRT.
    IF S-BAT MOVE S-A1 TO BR-CONT MOVE S-S1 TO BR-KG GO BR2.
    PERFORM AX-SEL IF SEL-N=0 OR>8 GO MX1.
    IF Y3 PERFORM AX-LOT. MOVE " " TO BR-CONT.
    IF Y1 OR Y7 ADD 1 TO IXT DISPLAY "PACKING INDICATOR: _" LINE IXT BOLD
      ACCEPT BR-CONT LINE IXT COLUMN 20 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF Y1 OR Y4 PERFORM AX-BIN. IF Y2 OR Y3 OR Y5 OR Y7 PERFORM AX-PROD.
    IF Y4 ADD 1 TO IXT
      DISPLAY "INCLUDE LEVEL 'G' BINS ? ___" LINE IXT BOLD "  (OTHERWISE 'G' IS EXCLUDED)"
      ACCEPT XA3 LINE IXT COLUMN 26 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO BR-KG ELSE MOVE 0 TO BR-KG.
    IF Y8 PERFORM AX-AGE-DATE PERFORM AX-PROD. IF Y7 OR Y8 PERFORM AX-TOT.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE BR-CONT TO S-A1 MOVE BR-KG TO S-S1 GO MX9.
BR2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM BR-PAGE.
    IF Y6 GO BR4. IF Y8 GO BR6.

* Y1 Y2 Y3 Y4 Y5 Y7
    IF Y3 MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP
      MOVE BR-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN
      MOVE LOT1 TO D-LOT PERFORM D-LOTDATE COMPUTE BR-YLOT1=D-YEAR * 10000000 + LOT1
      MOVE LOT2 TO D-LOT PERFORM D-LOTDATE COMPUTE BR-YLOT2=D-YEAR * 10000000 + LOT2.
    MOVE LOW-VALUES TO BR-STOTALS BR-GTOTALS MOVE " " TO OLD-A.
    IF Y4 MOVE 1 TO PR-IXP.
    IF Y1 OR Y4 MOVE BIN1 TO B-KEY
      START BIN KEY>=B-KEY REGARDLESS INVALID GO BR39 END-START
     ELSE INITIALIZE B-KP MOVE PROD1 TO B-PROD
      START BIN KEY>=B-KP REGARDLESS INVALID GO BR39 END-START.
BR3. READ BIN NEXT REGARDLESS END GO BR39.
    IF Y1 OR Y4 IF B-NO>BIN2 GO BR39 END-IF ELSE IF B-PROD>PROD2 GO BR39.
    IF Y1 OR Y2 IF B-QTY=0 GO BR3.
* note 210
    IF Y3 IF B-QTY=0 GO BR3 END-IF MOVE B-LOT TO D-LOT PERFORM D-LOTDATE
      IF NOT(D-YEAR * 10000000 + B-LOT>=BR-YLOT1 AND<=BR-YLOT2) GO BR3.
    IF Y4 IF B-QTY NOT=0 OR BR-KG=0 AND B-NO(3:1)="G" GO BR3.
    IF Y5 IF B-QTY-PACK=0 OR<=B-QTY GO BR3.
    IF Y1 AND BR-CONT>" " OR Y7 IF B-CONT NOT=BR-CONT GO BR3.
    IF Y3 OR Y5 OR Y7
      IF B-PROD NOT=OLD-A IF OLD-A>" " PERFORM BR-S END-IF MOVE B-PROD TO OLD-A.
    IF Y4 MOVE B-NO TO FF78(PR-IXP)
      ADD 1 TO PR-IXP IF PR-IXP>12 PERFORM BR-LINE 2 TIMES MOVE 1 TO PR-IXP END-IF
      GO BR3.
    MOVE B-PROD TO A-A1 PERFORM PROD-RD MOVE B-NO TO FF73 MOVE P-CAT TO FF73A.
    MOVE P-NO TO FF74 MOVE PRO-DESC(1) TO FF75 MOVE B-QTY TO FF76.
    PERFORM NUM-NUTS MOVE PRO-NNUT TO WN1 IF B-CONT="N" MOVE 0 TO WN1.
    COMPUTE WN1 ROUNDED=B-QTY * (P-WEIGHT + WN1 * P-WEIGHT-NUT) / 100.
    MOVE WN1 TO FF76A MOVE B-LOT TO FF77.
    IF Y7 AND BR-CONT="Q" MOVE B-QREASON TO FF77A.
    IF Y7 IF TOT-IND=0 PERFORM BR-LINE ELSE MOVE " " TO PREC ELSE PERFORM BR-LINE.
    IF Y3 MOVE P-NO TO BR-SPROD MOVE PRO-DESC(1) TO BR-SDESC MOVE P-CAT TO BR-SCAT
      PERFORM DESC-PRINT MOVE PRO-PRINT(1:6) TO BR-SPRINT.
    ADD B-QTY TO BR-SQ BR-GQ ADD WN1 TO BR-SW BR-GW GO BR3.
BR39. IF Y3 OR Y5 OR Y7 PERFORM BR-S. IF Y4 PERFORM PR-LASTLN.
    IF NOT Y4 MOVE 2 TO WS-PR MOVE "GRAND TOTALS ***" TO FF75
      MOVE BR-GQ TO FF76 MOVE BR-GW TO FF76A PERFORM PR-LINE.
    IF Y3 PERFORM CLOSE-EXP.
    GO BR9.

BR4. MOVE LOW-VALUES TO BR-GTOTALS.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO BR49.
BR43. READ PRODUCT NEXT REGARDLESS END GO BR49.
    IF NOT(P-NUT>" " AND P-GEN=" " AND P-HAND NOT=0) GO BR43. PERFORM PROD-DESC.
    MOVE P-NO TO FF186 MOVE PRO-DESC(1) TO FF187.
    PERFORM NUM-NUTS MOVE PRO-NNUT TO FF188 MOVE "X" TO FF188A.
    MOVE P-NUT TO FF189 MOVE LOW-VALUES TO BR-STOTALS.
    INITIALIZE B-KP MOVE P-NO TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO BR46.
BR45. READ BIN NEXT REGARDLESS END GO BR46. IF B-PROD NOT=P-NO GO BR46.
    MOVE B-NO TO FF190 IF B-CONT="N" MOVE "*" TO FF191. MOVE B-QTY TO FF192.
    COMPUTE FF193 ROUNDED=B-QTY * (P-WEIGHT + P-WEIGHT-NUT) / 100.
    COMPUTE FF194 ROUNDED=B-QTY * P-WEIGHT-NUT / 100.
    COMPUTE WN1=PRO-NNUT * B-QTY IF B-CONT="N" MOVE 0 TO WN1.
    COMPUTE WN2 ROUNDED=(B-QTY * P-WEIGHT + WN1 * P-WEIGHT-NUT) / 100.
    COMPUTE WN3 ROUNDED=WN1 * P-WEIGHT-NUT / 100.
    ADD WN1 TO BR-SQ BR-GQ ADD WN2 TO BR-SW BR-GW ADD WN3 TO BR-SR BR-GR.
    MOVE B-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF195.
    PERFORM BR-LINE GO BR45.
BR46. MOVE 2 TO WS-PR MOVE "**  TOTAL (ACTUAL NUTS)" TO FF187.
    MOVE BR-SQ TO FF192 MOVE BR-SW TO FF193 MOVE BR-SR TO FF194.
    PERFORM BR-LINE 2 TIMES GO BR43.
BR49. MOVE 2 TO WS-PR MOVE "*** GRAND TOTAL (ACTUAL NUTS)" TO FF187.
    MOVE BR-GQ TO FF192 MOVE BR-GW TO FF193 MOVE BR-GR TO FF194.
    PERFORM PR-LINE GO BR9.

BR6. MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-YEAR TO BR-YEAR.
    MOVE LOW-VALUES TO BR-STOTALS BR-GTOTALS MOVE " " TO OLD-A.
    INITIALIZE B-KP MOVE PROD1 TO B-PROD.
    START BIN KEY>=B-KP REGARDLESS INVALID GO BR69.
BR63. READ BIN NEXT REGARDLESS END GO BR69. IF B-PROD>PROD2 GO BR69.
    IF B-PROD=" " GO BR63. IF B-PROD=OLD-A GO BR64. IF OLD-A>" " PERFORM BR-P.
    MOVE B-PROD TO OLD-A FD390 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FD391.
    PERFORM BR-LINE.
BR64. MOVE B-NO TO FD393 MOVE B-LOT TO FD394 D-LOT PERFORM D-LOTDATE.
    IF D-ERR=0 MOVE D-DT TO FD395. COMPUTE IX1=BR-YEAR - B-LYEAR.
    IF IX1<0 MOVE 0 TO IX1. IF IX1>4 MOVE 4 TO IX1. ADD 2 TO IX1.
    COMPUTE WN1 ROUNDED=B-QTY * P-WEIGHT / 100 MOVE WN1 TO FD396(IX1).
    ADD WN1 TO BR-ST(IX1) BR-ST(1) BR-GT(IX1) BR-GT(1).
    IF TOT-IND=0 PERFORM BR-LINE ELSE MOVE " " TO PREC. GO BR63.
BR69. PERFORM BR-P MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE BR-GT(IX1) TO FD396(IX1) END-PERFORM.
    PERFORM PR-LINE GO BR9.
BR9. PERFORM CLOSE-PR GO MX9.

BR-S. PERFORM BR-S1 THRU BR-S9.
BR-S1. IF BR-SQ=0 GO BR-S9. MOVE 2 TO WS-PR MOVE OLD-A TO FF74.
    MOVE "TOTALS **" TO FF75 MOVE BR-SQ TO FF76 MOVE BR-SW TO FF76A.
    IF NOT Y3 GO BR-S8.
    MOVE 0 TO BR-LDATE INITIALIZE SH-KP MOVE OLD-A TO SH-KPROD.
    START SALHIST KEY>SH-KP REGARDLESS INVALID GO BR-S4.
BR-S3. READ SALHIST NEXT REGARDLESS END GO BR-S4. IF SH-PROD NOT=OLD-A GO BR-S4.
    IF SH-CDATE>BR-LDATE
      MOVE SH-CDATE TO BR-LDATE MOVE SH-QTY TO BR-LQTY MOVE SH-CUS TO BR-LCUS.
    GO BR-S3.
BR-S4. IF BR-LDATE NOT=0 MOVE BR-LDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF77B
         MOVE BR-LQTY TO FF77C MOVE BR-LCUS TO FF77D.
    MOVE BR-SPROD TO EXP-A PERFORM EXPF MOVE BR-SDESC TO EXP-A PERFORM EXPF.
    MOVE BR-SCAT TO EXP-N PERFORM EXPF MOVE BR-SPRINT TO EXP-A PERFORM EXPF.
    MOVE BR-SQ TO EXP-N PERFORM EXPF MOVE BR-SW TO EXP-N PERFORM EXPF.
    PERFORM EXP-LINE.
BR-S8. PERFORM BR-LINE 2 TIMES MOVE LOW-VALUES TO BR-STOTALS.
BR-S9. EXIT.
BR-P. MOVE "** TOTALS" TO FD391.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE BR-ST(IX1) TO FD396(IX1) END-PERFORM.
    PERFORM BR-LINE MOVE LOW-VALUES TO BR-STOTALS.
BR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BR-PAGE.
BR-PAGE. MOVE "BIN REPORT" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** CONTENTS **" TO FF4
      WHEN Y2 MOVE "** PRODUCT LOCATION **" TO FF4
      WHEN Y3 MOVE "** SLOW MOVING STOCK **" TO FF4
      WHEN Y4 IF BR-KG=1 MOVE "** EMPTY BINS **" TO FF4
        ELSE MOVE "** EMPTY BINS (EXCLUDING LEVEL 'G') **" TO FF4 END-IF
      WHEN Y5 MOVE "** PART CARTONS **" TO FF4
      WHEN Y6 MOVE "** BOLTS WITH NUTS **" TO FF4
      WHEN Y7 MOVE "** SPECIAL PACKING **" TO FF4
      WHEN Y8 MOVE "** INVENTORY AGING **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    IF Y1 OR Y4 MOVE 2 TO WS-PR PERFORM PRANGE-BIN.
    IF Y2 OR Y5 OR Y7 MOVE 2 TO WS-PR PERFORM PRANGE-PROD.
    IF Y3 MOVE 2 TO WS-PR PERFORM PRANGE-PROD MOVE 1 TO WS-PR PERFORM PRANGE-LOT.
    IF Y1 AND BR-CONT>" " OR Y7
      MOVE 1 TO WS-PR MOVE "PACKING INDICATOR:" TO FF336 MOVE BR-CONT TO FF337
      PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF Y8 MOVE "AGING DATE:" TO A-A1 PERFORM PRANGE-DT
      MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    IF Y1 OR Y2 OR Y5 OR Y7 MOVE
         "BIN    CAT  PRODUCT       DESCRIPTION                            PIECES        WEIGHT       LOT" TO PREC PERFORM PR-LINE-3.
*         .....  ..   ............  ................................  ...,...,...-  ...,...,...-    .......  ..
    IF Y3 MOVE
         "BIN    CAT  PRODUCT       DESCRIPTION                            PIECES        WEIGHT       LOT       ---- LAST SALE ----- CUS NO." TO PREC PERFORM PR-LINE-3.
*         .....  ..   ............  ................................  ...,...,...-  ...,...,...-    .......  .. ../../.. ..,...,...- ......
    IF Y6 MOVE
         "PRODUCT       DESCRIPTION                          NUT           BIN     NUTS       PIECES       WEIGHT    NUT WEIGHT   SINCE" TO PREC PERFORM PR-LINE-3.
*         ............  ................................  .. ............  ......   .    ...,...,...- ...,...,...- ...,...,...-  ../../..
    IF Y8 MOVE
         "PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE
*         ............  ................................
      MOVE
         "              BIN    LOT      LOT DATE       TOTAL     CURRENT      1 YEAR     2 YEARS     3 YEARS     4 YEARS" TO PREC PERFORM PR-LINE-3.
*                       .....  .......  ../../..  ..,...,...- ..,...,...- ..,...,...- ..,...,...- ..,...,...- ..,...,...-

* Z-6 ACCOUNTS RECEIVABLE REPORTS
AR1. PERFORM RD153 PERFORM WRT.
    IF S-BAT MOVE S-N1 TO AR-PAY-DAYS MOVE S-S1 TO AR-KZ MOVE S-S2 TO AR-KF GO AR2.
    PERFORM AX-SEL IF SEL-N=0 OR>6 GO MX1.
    IF Y1 ADD 1 TO IXT DISPLAY "INCLUDE CUSTOMERS WITH ZERO BALANCES ? ___" LINE IXT BOLD
      ACCEPT XA3 LINE IXT COLUMN 40 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO AR-KZ ELSE MOVE 0 TO AR-KZ.
    IF Y2 ADD 1 TO IXT DISPLAY "FULL REPORT ? ___" LINE IXT BOLD
      ACCEPT XA3 LINE IXT COLUMN 15 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO AR-KF ELSE MOVE 0 TO AR-KF.
    IF Y5 ADD 1 TO IXT DISPLAY "MINIMUM 'PAY IN' DAYS: ___" LINE IXT BOLD
      ACCEPT AR-PAY-DAYS LINE IXT COLUMN 24 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF Y3 OR Y5 PERFORM AX-CUS.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE AR-PAY-DAYS TO S-N1 MOVE AR-KZ TO S-S1 MOVE AR-KF TO S-S2 GO MX9.
AR2. PERFORM DSP-WAIT.
    GO AR30 AR40 AR50 AR60 AR70 AR80  DEPENDING SEL-N.

AR30. PERFORM OPEN-REP.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO AR32.
AR31. READ CUSTOMER NEXT REGARDLESS END GO AR32.
    IF AR-KZ=0 AND C-CUR=0 AND C-30=0 AND C-60=0 AND C-90=0 AND C-120=0 GO AR31.
    PERFORM INIT-RP MOVE 1 TO RP-F183 IF C-TER=3 OR 13 MOVE 2 TO RP-F183.
    MOVE 1 TO RP-F183A IF C-US=1 MOVE 2 TO RP-F183A.
    MOVE C-NAME TO RP-F184 MOVE C-KEY TO RP-F185 WRITE RP-RECORD GO AR31.
AR32. PERFORM OPEN-PR MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE AR-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
* note 134

    MOVE LOW-VALUES TO AR-STOTALS MOVE 0 TO OLD-M OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO AR39.
AR33. READ REPFL NEXT END GO AR39. MOVE RP-F185 TO C-KEY READ CUSTOMER REGARDLESS.
    IF RP-F183=OLD-M AND RP-F183A=OLD-N GO AR34.
    IF NOT(OLD-M=0 AND OLD-N=0) PERFORM AR-S.
    MOVE RP-F183 TO OLD-M MOVE RP-F183A TO OLD-N.
    IF OLD-M=1 IF OLD-N=1 MOVE "TRADE CN$" TO AR-TITLE ELSE MOVE "TRADE US$" TO AR-TITLE
      ELSE IF OLD-N=1 MOVE "AFFILIATE CN$" TO AR-TITLE ELSE MOVE "AFFILIATE US$" TO AR-TITLE.
    PERFORM AR-PAGE.
AR34. MOVE C-NO TO FF25 EXP-A PERFORM EXPF MOVE C-NAME TO FF26 EXP-A PERFORM EXPF.
    MOVE C-ADD1 TO EXP-A PERFORM EXPF MOVE C-ADD2 TO EXP-A PERFORM EXPF.
    MOVE C-POST TO EXP-A PERFORM EXPF.
    IF C-US=1 MOVE "USD" TO EXP-A ELSE MOVE "CAN" TO EXP-A. PERFORM EXPF.
    MOVE C-TOT TO FF27(1) EXP-D PERFORM EXPF.
    PERFORM PR-LINE MOVE C-ADD2 TO FF26 PERFORM PR-LINE.
    MOVE C-CREDIT TO FF28 EXP-N PERFORM EXPF MOVE C-DB TO FF29 EXP-A PERFORM EXPF.
    MOVE C-INS TO FF30 EXP-N PERFORM EXPF MOVE C-CUR TO FF27(2) EXP-D PERFORM EXPF.
    MOVE C-30 TO FF27(3) EXP-D PERFORM EXPF MOVE C-60 TO FF27(4) EXP-D PERFORM EXPF.
    MOVE C-90 TO FF27(5) EXP-D PERFORM EXPF MOVE C-120 TO FF27(6) EXP-D PERFORM EXPF.
    COMPUTE WN1 ROUNDED=C-PAY-DAYS(1) / C-PAY-NUM(1) SIZE ERROR CONTINUE.
    MOVE WN1 TO FF27A EXP-N PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE C-INFO(IX1) TO EXP-A PERFORM EXPF END-PERFORM.
    PERFORM PR-LINE PERFORM AR-LINE PERFORM EXP-LINE.
    ADD C-TOT TO AR-STOT(OLD-M,OLD-N,1) ADD C-CUR TO AR-STOT(OLD-M,OLD-N,2).
    ADD C-30 TO AR-STOT(OLD-M,OLD-N,3) ADD C-60 TO AR-STOT(OLD-M,OLD-N,4).
    ADD C-90 TO AR-STOT(OLD-M,OLD-N,5) ADD C-120 TO AR-STOT(OLD-M,OLD-N,6).
    GO AR33.
AR39. PERFORM AR-S MOVE " " TO AR-TITLE PERFORM AR-PAGE.
    MOVE " ** TOTALS TRADE MXD$" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      COMPUTE FF27(IX1)=AR-STOT(1,1,IX1) + AR-STOT(1,2,IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    MOVE " ** TOTALS AFFILIATE MXD$" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      COMPUTE FF27(IX1)=AR-STOT(2,1,IX1) + AR-STOT(2,2,IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    MOVE " ** GRAND TOTALS MXD$" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      COMPUTE FF27(IX1)=AR-STOT(1,1,IX1) + AR-STOT(1,2,IX1)
        + AR-STOT(2,1,IX1) + AR-STOT(2,2,IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO AR9.

AR40. IF AR-KF=1 GO AR46. PERFORM OPEN-PR PERFORM AR-PAGE.
    MOVE LOW-VALUES TO AR-ATOTALS AR-BTOTALS MOVE 1 TO OLD-N.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO AR44.
AR43. READ CUSTOMER NEXT REGARDLESS END GO AR44.
    IF C-NO>"07500" AND OLD-N<2 PERFORM AR-T PERFORM AR-PAGE MOVE 2 TO OLD-N.
    IF C-NO>"15000" AND OLD-N<3 PERFORM AR-T PERFORM AR-PAGE MOVE 3 TO OLD-N.
    MOVE C-NO TO FF341 MOVE C-NAME TO FF342 MOVE C-TOT TO FF343.
    MOVE C-MTD TO FF344(1) MOVE C-YTD TO FF344(2).
    IF C-30 NOT=0 MOVE "*" TO FF345. IF C-60 NOT=0 MOVE "**" TO FF345.
    IF C-90 NOT=0 MOVE "***" TO FF345. IF C-120 NOT=0 MOVE "****" TO FF345.
    PERFORM AR-LINE ADD C-TOT TO AR-ASTOT AR-BSTOT.
    ADD C-MTD TO AR-ATOT(1) AR-BTOT(1) ADD C-YTD TO AR-ATOT(2) AR-BTOT(2).
    GO AR43.
AR44. PERFORM AR-T PERFORM AR-LINE 2 TIMES MOVE "*** GRAND TOTALS" TO PREC.
    MOVE AR-BSTOT TO FF343 MOVE AR-BTOT(1) TO FF344(1) MOVE AR-BTOT(2) TO FF344(2).
    PERFORM PR-LINE.
    PERFORM CLOSE-PR GO AR9.

AR46. PERFORM OPEN-PR PERFORM AR-PAGE.
    MOVE LOW-VALUES TO AR-FTOTALS AR-GTOTALS AR-ATOTALS AR-BTOTALS MOVE 1 TO OLD-N.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO AR48.
AR47. READ CUSTOMER NEXT REGARDLESS END GO AR48.
    IF C-NO>"07500" AND OLD-N<2 PERFORM AR-F PERFORM AR-PAGE MOVE 2 TO OLD-N.
    IF C-NO>"15000" AND OLD-N<3 PERFORM AR-F PERFORM AR-PAGE MOVE 3 TO OLD-N.
    MOVE C-NO TO FG186 MOVE C-NAME TO FG187 MOVE C-INFO(1) TO FG188.
    MOVE C-MTD TO FG189(1) MOVE C-YTD TO FG189(2).
    MOVE C-LAST TO FG189(3) MOVE C-BLAST TO FG189(4) PERFORM PR-LINE.
    MOVE C-ADD1 TO FG187 MOVE C-INFO(2) TO FG188 PERFORM PR-LINE.
    MOVE C-ADD2 TO FG187 MOVE C-POST TO FG187(23:) MOVE C-INFO(3) TO FG188.
    PERFORM AR-LINE.
    ADD C-MTD TO AR-ATOT(1) AR-BTOT(1) ADD C-YTD TO AR-ATOT(2) AR-BTOT(2).
    ADD C-LAST TO AR-ATOT(3) AR-BTOT(3) ADD C-BLAST TO AR-ATOT(4) AR-BTOT(4).
    MOVE LOW-VALUES TO AR-CTOTALS MOVE C-NO TO TR-CUS MOVE 0 TO TR-INV.
    START TRANS KEY>TR-KEY REGARDLESS INVALID GO AR474.
AR473. READ TRANS NEXT REGARDLESS END GO AR474. IF TR-CUS>C-NO GO AR474.
    IF TR-AMT=0 GO AR473. MOVE TR-INV TO FG195.
    MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG196.
    MOVE TR-DATE TO D-DATE PERFORM D-CURR COMPUTE IX1=-D-N1.
    IF IX1<0 MOVE 0 TO IX1. IF IX1>4 MOVE 4 TO IX1. ADD 2 TO IX1.
    MOVE TR-AMT TO FG197(IX1) ADD TR-AMT TO AR-CTOT(1) AR-CTOT(IX1).
    PERFORM AR-LINE GO AR473.
AR474. MOVE "** TOTALS" TO FG187.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE AR-CTOT(IX1) TO FG197(IX1)
      ADD AR-CTOT(IX1) TO AR-FTOT(IX1) AR-GTOT(IX1) END-PERFORM.
    PERFORM AR-LINE 2 TIMES GO AR47.
AR48. PERFORM AR-F PERFORM AR-LINE 2 TIMES MOVE "*** GRAND TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE AR-BTOT(IX1) TO FG189(IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE AR-GTOT(IX1) TO FG197(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-PR GO AR9.

AR50. PERFORM OPEN-PR PERFORM AR-PAGE MOVE LOW-VALUES TO AR-ITOTALS.
    MOVE CUS1 TO C-NO START CUSTOMER KEY>=C-KEY REGARDLESS INVALID GO AR59.
AR53. READ CUSTOMER NEXT REGARDLESS END GO AR59. IF C-NO>CUS2 GO AR59.
    MOVE C-NO TO FD631 MOVE C-NAME TO FD632 MOVE C-TOT TO FD633.
    MOVE 1 TO A-S1 PERFORM AR-P.
    IF AR-KP=1 MOVE A-D1 TO FD635 MOVE "*" TO FD636
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 IF C-PAY-NUM(IX1) NOT=0
        COMPUTE FD638(IX1) ROUNDED=C-PAY-DAYS(IX1) / C-PAY-NUM(IX1) END-IF END-PERFORM
      PERFORM AR-LINE 2 TIMES ADD C-TOT TO AR-ITOT(1) ADD A-D1 TO AR-ITOT(2)
     ELSE MOVE " " TO PREC.
    GO AR53.
AR59. MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FD632.
    MOVE AR-ITOT(1) TO FD633 MOVE AR-ITOT(2) TO FD635 PERFORM PR-LINE.
    PERFORM CLOSE-PR GO AR9.

AR60. PERFORM OPEN-PR PERFORM AR-PAGE MOVE LOW-VALUES TO AR-JTOTALS.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO AR69.
AR63. READ CUSTOMER NEXT REGARDLESS END GO AR69. IF C-NO>"15000" GO AR69.
    IF C-CREDIT=1 GO AR63. COMPUTE AR-WD1=C-TOT + C-ORD.
    COMPUTE AR-WN1 ROUNDED=AR-WD1 - C-CREDIT IF AR-WN1<=0 GO AR63.
    MOVE C-NO TO FA590 MOVE C-NAME TO FA591 MOVE C-TOT TO FA592 MOVE C-ORD TO FA593.
    MOVE AR-WD1 TO FA594 MOVE C-CREDIT TO FA595 MOVE AR-WN1 TO FA596.
    MOVE 0 TO A-S1 PERFORM AR-P IF AR-KP=1 MOVE "*" TO FA597.
    ADD C-TOT TO AR-JTOT(1) ADD C-ORD TO AR-JTOT(2) ADD AR-WD1 TO AR-JTOT(3).
    ADD AR-WN1 TO AR-JTOT(4) PERFORM AR-LINE GO AR63.
AR69. MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FA591.
    MOVE AR-JTOT(1) TO FA592 MOVE AR-JTOT(2) TO FA593 MOVE AR-JTOT(3) TO FA594.
    MOVE AR-JTOT(4) TO FA596 PERFORM PR-LINE.
    PERFORM CLOSE-PR GO AR9.

AR70. PERFORM OPEN-PR PERFORM AR-PAGE MOVE 0 TO AR-PTOT.
    MOVE CUS1 TO C-NO START CUSTOMER KEY>=C-KEY REGARDLESS INVALID GO AR79.
AR73. READ CUSTOMER NEXT REGARDLESS END GO AR79. IF C-NO>CUS2 GO AR79.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      COMPUTE AR-WPD(IX1) ROUNDED=C-PAY-DAYS(IX1) / C-PAY-NUM(IX1)
        SIZE ERROR MOVE 0 TO AR-WPD(IX1) END-COMPUTE END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      IF AR-WPD(IX1)>AR-PAY-DAYS GO AR74 END-IF END-PERFORM.
    GO AR73.
AR74. MOVE C-NO TO FG332 MOVE C-NAME TO FG333 MOVE C-TOT TO FG334.
    IF AR-WPD(1)>0 MOVE AR-WPD(1) TO FG335.
    IF AR-WPD(2)>0 MOVE AR-WPD(2) TO FG336.
    IF AR-WPD(3)>0 MOVE AR-WPD(3) TO FG337.
    PERFORM AR-LINE GO AR73.
AR79. MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FG333.
    MOVE AR-PTOT TO FG334 PERFORM PR-LINE.
    PERFORM CLOSE-PR GO AR9.

AR80. PERFORM OPEN-PR PERFORM AR-PAGE MOVE LOW-VALUES TO AR-KTOTALS.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO AR89.
AR83. READ CUSTOMER NEXT REGARDLESS END GO AR89. IF C-NO>"15000" GO AR89.
    IF C-CREDIT=1 GO AR83.
    COMPUTE AR-WN1 ROUNDED=C-TOT - C-CREDIT IF AR-WN1<=0 GO AR83.
    MOVE C-NO TO FF131 MOVE C-NAME TO FF132 MOVE C-TOT TO FF133.
    MOVE C-CREDIT TO FF134 MOVE AR-WN1 TO FF135.
    ADD C-TOT TO AR-KTOT(1) ADD AR-WN1 TO AR-KTOT(2) PERFORM AR-LINE GO AR83.
AR89. MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FF132.
    MOVE AR-KTOT(1) TO FF133 MOVE AR-KTOT(2) TO FF135 PERFORM PR-LINE.
    PERFORM CLOSE-PR GO AR9.

AR9. GO MX9.

AR-S. MOVE 3 TO WS-PR STRING " ** SUB-TOTALS " AR-TITLE DELIMITED SIZE INTO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE AR-STOT(OLD-M,OLD-N,IX1) TO FF27(IX1) END-PERFORM.
    PERFORM PR-LINE.
AR-T. MOVE 3 TO WS-PR MOVE " ** SUB-TOTALS" TO PREC.
    MOVE AR-ASTOT TO FF343 MOVE AR-ATOT(1) TO FF344(1) MOVE AR-ATOT(2) TO FF344(2).
    PERFORM PR-LINE MOVE LOW-VALUES TO AR-ATOTALS.
AR-F. PERFORM AR-LINE MOVE 2 TO WS-PR MOVE "** SUB-TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE AR-ATOT(IX1) TO FG189(IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE AR-FTOT(IX1) TO FG197(IX1) END-PERFORM.
    PERFORM PR-LINE MOVE LOW-VALUES TO AR-ATOTALS AR-FTOTALS.
AR-P. PERFORM AR-P1 THRU AR-P9.
AR-P1. MOVE C-NO TO TR-CUS MOVE 0 TO TR-INV AR-KP A-D1.
    START TRANS KEY>TR-KEY REGARDLESS INVALID GO AR-P9.
AR-P3. READ TRANS NEXT REGARDLESS END GO AR-P9. IF TR-CUS NOT=C-NO GO AR-P9.
    IF TR-AMT<=0 GO AR-P3. COMPUTE AR-DAYS=SYS-DATE - TR-DATE.
    IF AR-DAYS<75 GO AR-P3. MOVE 1 TO AR-KP.
    IF A-S1=1 MOVE TR-INV TO FD634 MOVE TR-AMT TO FD635
      MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD637
      ADD TR-AMT TO A-D1 PERFORM AR-LINE GO AR-P3.
AR-P9. EXIT.
AR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AR-PAGE.
AR-PAGE. IF Y1 MOVE "AGE ANALYSIS" TO FF3 IF AR-KZ=0 MOVE "(EXCLUDING ZERO BALANCES)" TO FF4.
    IF Y2 MOVE "TRIAL BALANCE" TO FF3 IF AR-KF=0 MOVE "(SHORT FORM)" TO FF4.
    IF Y3 OR Y4 OR Y5 OR Y6 MOVE "ACCOUNTS RECEIVABLE CREDIT REPORT" TO FF3 EVALUATE TRUE
      WHEN Y3 MOVE "** SLOW PAYING (75+ DAYS) **" TO FF4
      WHEN Y4 MOVE "** HIGH EXPOSURE **" TO FF4
      WHEN Y5 MOVE "** HIGH 'PAY IN' DAYS **" TO FF4
      WHEN Y6 MOVE "** OVER CREDIT LIMIT **" TO FF4
      END-EVALUATE.
    IF Y1 PERFORM PR-IPAGE ELSE PERFORM PR-PAGE.
    IF Y1 MOVE 2 TO WS-PR MOVE AR-TITLE TO PREC PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF Y3 OR Y5 MOVE 2 TO WS-PR PERFORM PRANGE-CUS.
    IF Y5 MOVE 1 TO WS-PR MOVE "AVERAGE 'PAY IN' DAYS OVER:" TO FG330
      MOVE AR-PAY-DAYS TO FG331 PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF Y1 MOVE
         "CUST    NAME                                   TOTAL" TO PREC PERFORM PR-LINE
*         ......  ................................   ...,...:..-
      MOVE
         "      CREDIT LIM   D&B   INSUR                              CURRENT       30 DAYS       60 DAYS       90 DAYS      120 DAYS   PAY IN" TO PREC PERFORM PR-LINE-3.
*              ..,...,...    ... .,...,...           ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-    ...
    IF Y2 AND AR-KF=0 MOVE
         "CUST    NAME                                     TOTAL         MTD          YTD     ARREARS" TO PREC PERFORM PR-LINE-3.
*         ......  ................................   .,...,...:..- ...,...,...- ...,...,...-    .....
    IF Y2 AND AR-KF=1 MOVE
         "CUST    NAME                                CONTACT                              MTD          YTD        LAST YR    2 YRS AGO" TO PREC PERFORM PR-LINE
      MOVE
         "        INVOICE   DATE          TOTAL       CURRENT       30 DAYS       60 DAYS       90 DAYS      120 DAYS" TO PREC PERFORM PR-LINE-3.
*         ......  ................................    .............................. ...,...,...- ...,...,...- ...,...,...- ...,...,...-
*                 ......  ../../.. .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..-
    IF Y3 MOVE
         "CUST    NAME                                  BALANCE   INVOICE       AMOUNT      DATE    PAY IN AVG" TO PREC PERFORM PR-LINE-3.
*         ......  ................................ .,...,...:..-   ......   ...,...:..-.  ../../..  ... ... ...
    IF Y4 MOVE
         "CUST    NAME                                  A/R TOTAL       ON ORDER    POTENTIAL A/R   CREDIT LIM    EXCESS    ALSO SLOW" TO PREC PERFORM PR-LINE-3.
*         ......  ................................ ...,...,...:..-    ...,...:..-    ...,...:..-   ..,...,...  .,...,...-       .
    IF Y5 MOVE
         "CUST    NAME                                   TOTAL     PAY IN   LAST YR   2 YRS AGO" TO PREC PERFORM PR-LINE-3.
*         ......  ................................ .,...,...:..-     ...      ...        ...
    IF Y6 MOVE
         "CUST    NAME                                    BALANCE    CREDIT LIM     EXCESS" TO PREC PERFORM PR-LINE-3.
*         ......  ................................ ...,...,...:..-   ..,...,...  .,...,...-

* Z-7 DAILY SALES ANALYSIS REPORT
DS1. PERFORM RD100 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO DS-KM MOVE S-S2 TO DS-KR MOVE S-N1 TO DS-MDAYS
      MOVE S-N2 TO DS-YDAYS MOVE S-A1 TO DS-FORECAST GO DS2.
    REPLACE ==ACC-NUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
DS11. ACCEPT DS-MDAYS LINE 3 COLUMN 66 ACC-NUM.
    IF DS-MDAYS=0 OR>31 PERFORM DSP-ERR2 GO DS11.
DS13. ACCEPT DS-YDAYS LINE 3 COLUMN 76 ACC-NUM.
    IF DS-YDAYS=0 OR>365 PERFORM DSP-ERR2 GO DS13.
DS15. ACCEPT DS-IM LINE 6 COLUMN 12 ACC-NUM.
    IF DS-IM=0 OR>12 PERFORM DSP-ERR2 GO DS15.
    ACCEPT DS-IA LINE 7 COLUMN 18 ACC-NUM.
    ACCEPT DS-YA LINE 7 COLUMN 34 ACC-NUM.
    ACCEPT DS-IW LINE 8 COLUMN 18 ACC-NUM.
    ACCEPT DS-YW LINE 8 COLUMN 34 ACC-NUM.
    ACCEPT DS-IC LINE 9 COLUMN 18 ACC-NUM.
    ACCEPT DS-YC LINE 9 COLUMN 34 ACC-NUM.
    ACCEPT DS-IT LINE 10 COLUMN 18 ACC-NUM.
    ACCEPT DS-YT LINE 10 COLUMN 34 ACC-NUM.
    REPLACE OFF.
    MOVE 0 TO DS-KM DS-KR.
    ACCEPT XA3 LINE 12 COLUMN 44 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO DS-KM
      MOVE 12 TO IXT MOVE 64 TO IXU PERFORM AX-DT-VAL
      ACCEPT XA3 LINE 13 COLUMN 76 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO DS-KR END-IF GO DS18.
    MOVE SYS-DATE TO DATE0.
    MOVE 15 TO IXT MOVE 27 TO IXU PERFORM AX-SUM-S MOVE 1 TO TOT-IND.
    IF SUM-IND=0 MOVE 15 TO IXT MOVE 51 TO IXU PERFORM AX-TOT-S.
DS18. MOVE 17 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE DS-KM TO S-S1 MOVE DS-KR TO S-S2 MOVE DS-MDAYS TO S-N1
      MOVE DS-YDAYS TO S-N2 MOVE DS-FORECAST TO S-A1 GO MX9.
DS2. PERFORM DSP-WAIT IF DS-KM=1 PERFORM OPEN-PR GO DS4.

    MOVE 1 TO DS-STEP PERFORM OPEN-REP MOVE 0 TO DS-RNUM.
    OPEN I-O TMPORD ALLOWING ALL TMPLIN ALLOWING ALL.
    MOVE " " TO YL-KEY START TMPLIN KEY>YL-KEY REGARDLESS INVALID GO DS24.
DS23. READ TMPLIN NEXT REGARDLESS END GO DS24. MOVE YL-DATA TO L-RECORD.
    MOVE L-EXTA TO A-D1 PERFORM CHK-OVERSEAS.
    PERFORM INIT-RP MOVE L-TER TO RP-F13 MOVE L-CAT TO RP-F14.
    MOVE L-PROD TO RP-F15 ADD 1 TO DS-RNUM MOVE DS-RNUM TO RP-F15A.
    MOVE A-D1 TO RP-F16 MOVE L-QTY-THIS TO RP-F16A.
    COMPUTE RP-F16B=L-WEIGHT + L-WEIGHT-NUT WRITE RP-RECORD.
    IF A-D1<L-EXTA PERFORM INIT-RP MOVE L-TER TO RP-F13 MOVE 90 TO RP-F14
      MOVE "F" TO RP-F15 ADD 1 TO DS-RNUM MOVE DS-RNUM TO RP-F15A
      COMPUTE RP-F16=L-EXTA - A-D1 WRITE RP-RECORD.
    GO DS23.
* note 40
DS24. MOVE " " TO YO-KEY START TMPORD KEY>YO-KEY REGARDLESS INVALID GO DS29.
DS25. READ TMPORD NEXT REGARDLESS END GO DS29. MOVE YO-DATA TO O-RECORD.
    IF O-FREIGHT=0 GO DS25.
    PERFORM INIT-RP MOVE O-TER TO RP-F13 MOVE 90 TO RP-F14 MOVE "F" TO RP-F15.
    ADD 1 TO DS-RNUM MOVE DS-RNUM TO RP-F15A.
    MOVE O-FREIGHT TO RP-F16 WRITE RP-RECORD GO DS25.
DS29. PERFORM OPEN-PR PERFORM DS-PAGE.
    MOVE LOW-VALUES TO DS-PTOTALS DS-CTOTALS DS-TTOTALS DS-HTOTALS.
    MOVE 0 TO OLD-T OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DS39.
DS3. READ REPFL NEXT END GO DS39.
    MOVE RP-F13 TO DS-VTER MOVE RP-F14 TO DS-VCAT MOVE RP-F15 TO DS-VPROD.
    MOVE RP-F16 TO DS-VAMT MOVE RP-F16A TO DS-VQTY MOVE RP-F16B TO DS-VWEIGHT.
    IF DS-VTER=OLD-T GO DS32. IF OLD-T NOT=0 PERFORM DS-PP PERFORM DS-CC PERFORM DS-TT.
    MOVE DS-VTER TO OLD-T MOVE 0 TO OLD-N.
DS32. IF DS-VCAT=OLD-N GO DS34. IF OLD-N NOT=0 PERFORM DS-PP PERFORM DS-CC.
    MOVE DS-VCAT TO OLD-N MOVE " " TO OLD-A. IF TOT-IND=1 GO DS34.
    MOVE "CATEGORY" TO FF57 MOVE DS-VCAT TO FF58 PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF59.
    PERFORM DS-LINE MOVE 2 TO WS-PR.
DS34. IF DS-VPROD=OLD-A GO DS36. IF OLD-A>" " PERFORM DS-PP.
    MOVE DS-VPROD TO OLD-A A-A1 PERFORM PROD-GEN.
DS36. ADD DS-VAMT TO DS-PAMT DS-CAMT ADD DS-VQTY TO DS-PQTY.
    ADD DS-VWEIGHT TO DS-PWEIGHT DS-CWEIGHT.
    IF DS-VCAT<90 ADD DS-VAMT TO DS-TAMT DS-HA ADD DS-VWEIGHT TO DS-TWEIGHT DS-HW
      ELSE ADD DS-VAMT TO DS-HB ADD DS-VWEIGHT TO DS-HR.
    GO DS3.
DS39. PERFORM DS-PP PERFORM DS-CC PERFORM DS-TT MOVE 4 TO WS-PR.
    MOVE "TOTALS SALES:" TO FF59 MOVE DS-HW TO FF60(2) MOVE DS-HA TO FF61(1).
    COMPUTE WD1 ROUNDED=DS-HA * 100 / DS-HW SIZE ERROR MOVE 0 TO WD1.
    MOVE WD1 TO FF61(2) PERFORM PR-LINE-2.
    MOVE "   NON SALES:" TO FF59 MOVE DS-HR TO FF60(2) MOVE DS-HB TO FF61(1).
    COMPUTE WD1 ROUNDED=DS-HB * 100 / DS-HR SIZE ERROR MOVE 0 TO WD1.
    MOVE WD1 TO FF61(2) PERFORM PR-LINE.
    CLOSE TMPORD TMPLIN PERFORM CLOSE-REP PERFORM PR-RESET.

DS4. OPEN I-O SALTOT ALLOWING ALL PERFORM RDR-INFO.
    IF DS-KR=1 PERFORM RD-INFO
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>25
        MOVE 0 TO IF-SALVAL(IX1,IX2) END-PERFORM END-PERFORM
      MOVE 1 TO A-X1 MOVE 10 TO A-X2 PERFORM DS-JSUB
      MOVE 2 TO A-X1 MOVE 20 TO A-X2 PERFORM DS-JSUB
      MOVE 3 TO A-X1 MOVE 19 TO A-X2 PERFORM DS-JSUB
      MOVE 4 TO A-X1 MOVE 21 TO A-X2 PERFORM DS-JSUB
      IF INUT MOVE 5 TO A-X1 MOVE 12 TO A-X2 PERFORM DS-JSUB END-IF
      SUBTRACT IF-SAV-SAL-IG FROM IF-SALVAL(1,1) ADD IF-SAV-SAL-IG TO IF-SALVAL(1,24)
      PERFORM WR-INFO.

    MOVE 2 TO DS-STEP MOVE DATE0 TO D-DATE PERFORM D-NM.
    MOVE D-MM TO DS-MM MOVE D-DD TO DS-DD MOVE D-YY TO DS-YY.
    MOVE 1 TO DS-EX MOVE 0 TO DS-AF.
DS41. PERFORM DS-PAGE.
    MOVE LOW-VALUES TO DS-GTOTALS DS-RGTOTALS DS-S1TOTALS DS-S2TOTALS DS-S3TOTALS DS-S4TOTALS.
    MOVE 1 TO DS-OP.
DS43. MOVE LOW-VALUES TO DS-STOTALS DS-RSTOTALS.
    IF INUT GO DS44.

    EVALUATE TRUE
      WHEN DS-OP=1 MOVE "DOMESTIC" TO FA287 MOVE "05110000" TO DS-XTER
      WHEN DS-OP=2 MOVE "EXPORT"   TO FA287 MOVE "06090000" TO DS-XTER
      WHEN DS-OP=3 MOVE "OFFSHORE" TO FA287 MOVE "00000000" TO DS-XTER
      WHEN DS-OP=4 MOVE "AFFIL 1" TO FA287
      WHEN DS-OP=5 MOVE "AFFIL 2" TO FA287
      WHEN DS-OP=6 MOVE "AFFIL 3" TO FA287
      END-EVALUATE.
    IF DS-OP<=3 MOVE "- AUTO" TO FA288 MOVE 1 TO DS-OQ PERFORM DS-RD.
    EVALUATE TRUE
      WHEN DS-OP=1 MOVE "01100000" TO DS-XTER
      WHEN DS-OP=2 MOVE "02080000" TO DS-XTER
      WHEN DS-OP=3 MOVE "04000000" TO DS-XTER
      WHEN DS-OP=4 MOVE "03000000" TO DS-XTER
      WHEN DS-OP=5 MOVE "13000000" TO DS-XTER
      WHEN DS-OP=6 MOVE "12000000" TO DS-XTER
      END-EVALUATE.
    MOVE "- OTHER" TO FA288 MOVE 2 TO DS-OQ PERFORM DS-RD.
    MOVE "- STUDS" TO FA288 MOVE 3 TO DS-OQ PERFORM DS-RD.
    IF DS-OP<=3
      MOVE "- NUTS(MAN)" TO FA288 MOVE 4 TO DS-OQ PERFORM DS-RD
      MOVE "- NUTS(PUR)" TO FA288 MOVE 5 TO DS-OQ PERFORM DS-RD
     ELSE MOVE "- NUTS" TO FA288 MOVE 4 TO DS-OQ PERFORM DS-RD.
    GO DS46.

DS44. EVALUATE TRUE
      WHEN DS-OP=1 MOVE "DOMESTIC" TO FA287 MOVE "05110110" TO DS-XTER
      WHEN DS-OP=2 MOVE "EXPORT"   TO FA287 MOVE "06090208" TO DS-XTER
      WHEN DS-OP=3 MOVE "OFFSHORE" TO FA287 MOVE "04000000" TO DS-XTER
      WHEN DS-OP=4 MOVE "AFFIL 1" TO FA287 MOVE "03000000" TO DS-XTER
      WHEN DS-OP=5 MOVE "AFFIL 2" TO FA287 MOVE "13000000" TO DS-XTER
      WHEN DS-OP=6 MOVE "AFFIL 3" TO FA287 MOVE "12000000" TO DS-XTER
      END-EVALUATE.
    MOVE "- NUTS" TO FA288 MOVE 1 TO DS-OQ PERFORM DS-RD.
    IF DS-OP<=3
      MOVE "- KEPS" TO FA288 MOVE 2 TO DS-OQ PERFORM DS-RD
      MOVE "- NUTS/RTNR" TO FA288 MOVE 3 TO DS-OQ PERFORM DS-RD.
    MOVE "- OTHER" TO FA288 MOVE 4 TO DS-OQ PERFORM DS-RD.

DS46. MOVE 2 TO WS-PR MOVE "   ** SUB-TOTALS" TO FA302.
    MOVE DS-STOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE 2 TIMES.

    IF DS-KR=1 PERFORM RD-INFO
      IF DS-EX=1 EVALUATE TRUE
        WHEN DS-OP=1 MOVE 17 TO A-X1 PERFORM DS-RSUB
        WHEN DS-OP=2 MOVE 15 TO A-X1 PERFORM DS-RSUB
        WHEN DS-OP=3 MOVE 16 TO A-X1 PERFORM DS-RSUB
        END-EVALUATE END-IF
      IF DS-EX=2 EVALUATE TRUE
        WHEN DS-OP=1 MOVE 17 TO A-X1 PERFORM DS-RADD
          MOVE 3 TO A-X1 PERFORM DS-RSUB
        WHEN DS-OP=2 MOVE 15 TO A-X1 PERFORM DS-RADD
          MOVE 4 TO A-X1 PERFORM DS-RSUB
        WHEN DS-OP=3 MOVE 16 TO A-X1 PERFORM DS-RADD
          MOVE 7 TO A-X1 PERFORM DS-RSUB
        WHEN DS-OP=4 ADD DS-RSA(1) TO IF-SALVAL(1,22)
          SUBTRACT DS-RSA(1) FROM IF-SALVAL(1,5)
          ADD DS-RSA(2) TO IF-SALVAL(1,26)
          SUBTRACT DS-RSA(2) FROM IF-SALVAL(1,27)
        WHEN DS-OP=5 ADD DS-RSA(1) TO IF-SALVAL(1,23)
          SUBTRACT DS-RSA(1) FROM IF-SALVAL(1,6)
        WHEN DS-OP=6 ADD DS-RSA(1) TO IF-SALVAL(1,24)
          SUBTRACT DS-RSA(1) FROM IF-SALVAL(1,3)
        END-EVALUATE END-IF
      PERFORM WR-INFO.

    ADD 1 TO DS-OP IF DS-OP<=6 GO DS43.
    MOVE "*** GRAND TOTALS" TO FA302.
    MOVE DS-GTOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE.

    IF DS-KR=1 PERFORM RD-INFO
      IF DS-EX=1 ADD DS-RGA(1) TO IF-SALVAL(1,14)
        ADD DS-RGA(2) TO IF-SALVAL(2,14) END-IF
      IF DS-EX=2 SUBTRACT DS-RGA(1) FROM IF-SALVAL(1,14)
        SUBTRACT DS-RGA(2) FROM IF-SALVAL(2,14) END-IF
      PERFORM WR-INFO.

    MOVE 3 TO WS-PR MOVE "SUMMARY OF ALL AREAS" TO PREC PERFORM DS-LINE.
    IF NOT INUT
      MOVE "- BOLTS" TO FA288
      MOVE DS-S1TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE
      MOVE "- STUDS" TO FA288
      MOVE DS-S2TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE
      MOVE "- NUTS(MAN)" TO FA288
      MOVE DS-S3TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE
      MOVE "- NUTS(PUR)" TO FA288
      MOVE DS-S4TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE
     ELSE
      MOVE "- NUTS" TO FA288
      MOVE DS-S1TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE
      MOVE "- KEPS" TO FA288
      MOVE DS-S2TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE
      MOVE "- NUTS/RTNR" TO FA288
      MOVE DS-S3TOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE.
    MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO FA302.
    MOVE DS-GTOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM PR-LINE.
* note 214

    IF DS-EX=1 MOVE 2 TO WS-PR MOVE "CURRENT MONTH FORECAST" TO FA303
      MOVE D-MTHNM(DS-IM)(1:3) TO FA304
      MOVE DS-IA TO FA291 MOVE DS-IW TO FA292A MOVE DS-IC TO FA292B MOVE DS-IT TO FA293
      MOVE DS-YA TO FA294 MOVE DS-YW TO FA295A MOVE DS-YC TO FA295B MOVE DS-YT TO FA296
      PERFORM PR-LINE.
    PERFORM PR-RESET ADD 1 TO DS-EX.
    IF DS-AF=0 AND DS-EX<=5 OR DS-AF=1 AND DS-EX<=4 GO DS41.
    IF IFAST IF DS-AF=0 MOVE 1 TO DS-AF MOVE 1 TO DS-EX GO DS41.

    MOVE 3 TO DS-STEP MOVE DATE0 TO D-DATE PERFORM D-NM.
    MOVE D-MM TO DS-MM MOVE D-DD TO DS-DD MOVE D-YY TO DS-YY.
    MOVE LOW-VALUES TO DS-NTOTALS DS-RNTOTALS.
    MOVE " " TO ST-KEY START SALTOT KEY>ST-KEY REGARDLESS INVALID GO DS54.
DS53. READ SALTOT NEXT REGARDLESS END GO DS54. IF ST-CAT<90 GO DS53.
    IF ST-YY NOT=DS-YY GO DS53.
    IF ST-MM>DS-MM OR ST-MM=DS-MM AND ST-DD>DS-DD GO DS53.
    MOVE ST-AMT TO DS-AMT MOVE 0 TO DS-XAMT.
    IF ST-US=1
      MOVE ST-YY TO D-YY MOVE ST-MM TO D-MM MOVE 1 TO D-DD PERFORM D-MN
      MOVE DS-AMT TO A-T1 PERFORM EXCHG-CONV
      COMPUTE DS-XAMT=DS-AMT - A-D1 MOVE A-D1 TO DS-AMT.

    EVALUATE TRUE
      WHEN ST-CAT=90 MOVE 1 TO IX1
      WHEN ST-CAT=92 MOVE 2 TO IX1
      WHEN ST-CAT=94 MOVE 3 TO IX1
      WHEN ST-CAT=96 MOVE 4 TO IX1
      WHEN OTHER GO DS53.
    EVALUATE TRUE
      WHEN ST-TER=1 OR 5 OR 9 OR 10 OR 11 MOVE 1 TO IX2
      WHEN ST-TER=2 OR 6 OR 7 OR 8 MOVE 2 TO IX2
      WHEN ST-TER=4 MOVE 3 TO IX2
      WHEN ST-TER=3 MOVE 4 TO IX2
      WHEN ST-TER=13 MOVE 5 TO IX2
      WHEN ST-TER=12 MOVE 6 TO IX2
      WHEN OTHER GO DS53.

    IF ST-MM=DS-MM AND ST-DD=DS-DD
      ADD DS-AMT TO DS-NA(IX1,IX2,1) ADD DS-XAMT TO DS-NA(5,IX2,1).
    IF ST-MM=DS-MM ADD DS-AMT TO DS-NA(IX1,IX2,2) ADD DS-XAMT TO DS-NA(5,IX2,2)
      IF IX1<=4 IF ST-US<=1 ADD ST-AMT TO DS-RNA(ST-US + 1,IX1,IX2).
    ADD DS-AMT TO DS-NA(IX1,IX2,3) ADD DS-XAMT TO DS-NA(5,IX2,3).
    GO DS53.
DS54. PERFORM DS-PAGE MOVE 1 TO IX1.
DS55. MOVE 2 TO WS-PR EVALUATE TRUE
       WHEN IX1=1 MOVE "FREIGHT" TO FF357
       WHEN IX1=2 MOVE "SCRAP" TO FF357
       WHEN IX1=3 MOVE "RETURNABLE CONTAINERS" TO FF357
       WHEN IX1=4 MOVE "INSPECTION/SORTING" TO FF357
       WHEN IX1=5 MOVE "FOREIGN EXCHANGE" TO FF357
       END-EVALUATE.
    MOVE 1 TO IX2.
DS57. MOVE "-" TO FF358 EVALUATE TRUE
       WHEN IX2=1 MOVE "CDN" TO FF359
       WHEN IX2=2 MOVE "U.S." TO FF359
       WHEN IX2=3 MOVE "OFFSHORE" TO FF359
       WHEN IX2=4 MOVE "AFFIL 1" TO FF359
       WHEN IX2=5 MOVE "AFFIL 2" TO FF359
       WHEN IX2=6 MOVE "AFFIL 3" TO FF359
       END-EVALUATE.
    PERFORM VARYING IX3 FROM 1 BY 1 UNTIL IX3>3
      MOVE DS-NA(IX1,IX2,IX3) TO FF360(IX3) END-PERFORM.
    PERFORM DS-LINE ADD 1 TO IX2 IF IX2<=6 GO DS57.
    ADD 1 TO IX1 IF IX1<=5 GO DS55.

    IF DS-KR=1 PERFORM RD-INFO
      PERFORM VARYING DS-IXC FROM 1 BY 1 UNTIL DS-IXC>2
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 EVALUATE TRUE
        WHEN IX1=1 MOVE 8 TO IX4 IF DS-IXC=2 MOVE 9 TO IX4 END-IF
        WHEN IX1=2 MOVE 11 TO IX4
        WHEN IX1=3 MOVE 12 TO IX4
        WHEN IX1=4 MOVE 13 TO IX4
        END-EVALUATE
        PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>6
          IF IX2 NOT=3 MOVE DS-IXC TO IX3
            IF IFAST AND DS-IXC=1 EVALUATE TRUE
              WHEN IX2=4 MOVE 22 TO IX3
              WHEN IX2=5 MOVE 23 TO IX3
              WHEN IX2=6 MOVE 24 TO IX3 IF IX1=2 MOVE 25 TO IX4 END-IF
              END-EVALUATE END-IF
            ADD DS-RNA(DS-IXC,IX1,IX2) TO IF-SALVAL(DS-IXC,IX3)
            SUBTRACT DS-RNA(DS-IXC,IX1,IX2) FROM IF-SALVAL(DS-IXC,IX4) END-IF
        END-PERFORM END-PERFORM END-PERFORM
      PERFORM WR-INFO.

    MOVE 2 TO WS-PR MOVE "*** TOTALS" TO FF357.
    PERFORM VARYING IX3 FROM 1 BY 1 UNTIL IX3>3 MOVE 0 TO WD1
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>6
        ADD DS-NA(IX1,IX2,IX3) TO WD1 END-PERFORM END-PERFORM
      MOVE WD1 TO FF360(IX3) END-PERFORM.
    PERFORM PR-LINE PERFORM PR-RESET.

    MOVE 4 TO DS-STEP MOVE DATE0 TO D-DATE PERFORM D-NM.
    MOVE D-MM TO DS-MM MOVE D-DD TO DS-DD MOVE D-YY TO DS-YY.
    MOVE LOW-VALUES TO DS-BTOTALS.
    MOVE " " TO ST-KEY START SALTOT KEY>ST-KEY REGARDLESS INVALID GO DS64.
DS63. READ SALTOT NEXT REGARDLESS END GO DS64. IF ST-CAT>=90 GO DS63.
    IF ST-YY NOT=DS-YY GO DS63.
    IF ST-MM>DS-MM OR ST-MM=DS-MM AND ST-DD>DS-DD GO DS63.
    MOVE ST-AMT TO DS-AMT MOVE 0 TO DS-XAMT.
    IF ST-US=1
      MOVE ST-YY TO D-YY MOVE ST-MM TO D-MM MOVE 1 TO D-DD PERFORM D-MN
      MOVE DS-AMT TO A-T1 PERFORM EXCHG-CONV COMPUTE DS-XAMT=A-D1 - DS-AMT.
    IF NOT(ST-TER>=1 AND<=13) GO DS63.
    EVALUATE TRUE
      WHEN ST-TER=5 OR 11       MOVE 1 TO IX1 MOVE 1 TO IX2 MOVE 1 TO IX4
      WHEN ST-TER=1 OR 10       MOVE 1 TO IX1 MOVE 2 TO IX2 MOVE 1 TO IX4
      WHEN ST-TER=3 OR 12 OR 13 MOVE 1 TO IX1 MOVE 2 TO IX2 MOVE 2 TO IX4
      WHEN ST-TER=6 OR 9        MOVE 2 TO IX1 MOVE 1 TO IX2 MOVE 1 TO IX4
      WHEN ST-TER=2 OR 8        MOVE 2 TO IX1 MOVE 2 TO IX2 MOVE 1 TO IX4
      WHEN ST-TER=7             MOVE 2 TO IX1 MOVE 2 TO IX2 MOVE 2 TO IX4
      WHEN ST-TER=4             MOVE 3 TO IX1 MOVE 2 TO IX2 MOVE 1 TO IX4
      WHEN OTHER CONTINUE.

    IF ST-MM=DS-MM ADD ST-WEIGHT TO DS-BW(IX1,IX2,1,IX4)
      ADD DS-AMT TO DS-BA(IX1,IX2,1,IX4) ROUNDED ADD DS-XAMT TO DS-BA(IX1,3,1,IX4) ROUNDED.
    ADD ST-WEIGHT TO DS-BW(IX1,IX2,2,IX4).
    ADD DS-AMT TO DS-BA(IX1,IX2,2,IX4) ROUNDED ADD DS-XAMT TO DS-BA(IX1,3,2,IX4) ROUNDED.
    GO DS63.
DS64. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>3
      PERFORM VARYING IX3 FROM 1 BY 1 UNTIL IX3>2
      PERFORM VARYING IX4 FROM 1 BY 1 UNTIL IX4>2
        DIVIDE 100 INTO DS-BW(IX1,IX2,IX3,IX4) ROUNDED
        DIVIDE 1000 INTO DS-BA(IX1,IX2,IX3,IX4) ROUNDED
        END-PERFORM END-PERFORM END-PERFORM END-PERFORM.

    PERFORM DS-PAGE MOVE LOW-VALUES TO DS-BGTOTALS MOVE 1 TO IX1.
DS65. MOVE 2 TO WS-PR EVALUATE TRUE
       WHEN IX1=1 MOVE "CANADIAN" TO FF419
       WHEN IX1=2 MOVE "EXPORT" TO FF419
       WHEN IX1=3 MOVE "OFFSHORE" TO FF419
       END-EVALUATE.
    MOVE 1 TO IX2.
DS67. MOVE "-" TO FF420 EVALUATE TRUE
       WHEN IX2=1 MOVE "AUTOMOTIVE" TO FF421
       WHEN IX2=2 MOVE "OTHER" TO FF421
       WHEN IX2=3 MOVE "EXCHANGE" TO FF421
       END-EVALUATE.
    PERFORM VARYING IX3 FROM 1 BY 1 UNTIL IX3>2
    PERFORM VARYING IX4 FROM 1 BY 1 UNTIL IX4>2
      IF IX2=1 OR 2 MOVE DS-BW(IX1,IX2,IX3,IX4) TO FF422(IX3,IX4)
        COMPUTE FF423(IX3,IX4) ROUNDED=
          DS-BA(IX1,IX2,IX3,IX4) * 1000 / DS-BW(IX1,IX2,IX3,IX4) SIZE ERROR CONTINUE END-COMPUTE END-IF
      MOVE DS-BA(IX1,IX2,IX3,IX4) TO FF424(IX3,IX4) END-PERFORM END-PERFORM.
    PERFORM DS-LINE ADD 1 TO IX2 IF IX2<=3 GO DS67.

    MOVE "** TOTALS" TO FF421.
    PERFORM VARYING IX3 FROM 1 BY 1 UNTIL IX3>2
    PERFORM VARYING IX4 FROM 1 BY 1 UNTIL IX4>2
      MOVE 0 TO WN1 WD1
      PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>3
        ADD DS-BW(IX1,IX2,IX3,IX4) TO WN1 DS-BGW(IX3,IX4)
        ADD DS-BA(IX1,IX2,IX3,IX4) TO WD1 DS-BGA(IX3,IX4) END-PERFORM
      MOVE WN1 TO FF422(IX3,IX4) MOVE WD1 TO FF424(IX3,IX4)
      COMPUTE FF423(IX3,IX4) ROUNDED=WD1 * 1000 / WN1 SIZE ERROR CONTINUE END-COMPUTE
      END-PERFORM END-PERFORM.
    PERFORM DS-LINE ADD 1 TO IX1 IF IX1<=3 GO DS65.

    MOVE 3 TO WS-PR MOVE "*** TOTAL SALES" TO PREC.
    PERFORM VARYING IX3 FROM 1 BY 1 UNTIL IX3>2
    PERFORM VARYING IX4 FROM 1 BY 1 UNTIL IX4>2
      MOVE DS-BGW(IX3,IX4) TO FF422(IX3,IX4) MOVE DS-BGA(IX3,IX4) TO FF424(IX3,IX4)
      COMPUTE FF423(IX3,IX4) ROUNDED=
        DS-BGA(IX3,IX4) * 1000 / DS-BGW(IX3,IX4) SIZE ERROR CONTINUE END-COMPUTE
      END-PERFORM END-PERFORM.
    PERFORM DS-LINE.
    CLOSE SALTOT PERFORM CLOSE-PR.
DS9. GO MX9.

DS-RADD. ADD DS-RSA(1) TO IF-SALVAL(1,1) IF-SALVAL(1,A-X1).
    ADD DS-RSA(2) TO IF-SALVAL(2,2) IF-SALVAL(2,A-X1).
DS-RSUB. SUBTRACT DS-RSA(1) FROM IF-SALVAL(1,A-X1).
    SUBTRACT DS-RSA(2) FROM IF-SALVAL(2,A-X1).
DS-JSUB. ADD IF-SAV-SAL(A-X1) TO IF-SALVAL(1,1).
    SUBTRACT IF-SAV-SAL(A-X1) FROM IF-SALVAL(1,A-X2).
    ADD IF-SAV-USAL(A-X1) TO IF-SALVAL(2,2).
    SUBTRACT IF-SAV-USAL(A-X1) FROM IF-SALVAL(2,A-X2).
DS-PP. MOVE P-NO TO FF56 PERFORM PROD-DESC MOVE PRO-DESC(1) TO FF59.
    MOVE DS-PQTY TO FF60(1) MOVE DS-PWEIGHT TO FF60(2) MOVE DS-PAMT TO FF61(1).
    IF TOT-IND=0 PERFORM DS-LINE. MOVE LOW-VALUES TO DS-PTOTALS.
DS-CC. MOVE 2 TO WS-PR MOVE " " TO PREC.
    IF TOT-IND=1 MOVE "CATEGORY" TO FF57 MOVE OLD-N TO FF58.
    MOVE "SUB-TOTALS:" TO FF59 MOVE DS-CWEIGHT TO FF60(2) MOVE DS-CAMT TO FF61(1).
    COMPUTE WD1 ROUNDED=DS-CAMT * 100 / DS-CWEIGHT SIZE ERROR MOVE 0 TO WD1.
    MOVE WD1 TO FF61(2) IF SUM-IND=0 PERFORM DS-LINE.
    MOVE LOW-VALUES TO DS-CTOTALS MOVE 3 TO WS-PR.
DS-TT. MOVE 4 TO WS-PR MOVE " " TO PREC.
    MOVE "TERRITORY" TO FF57 MOVE OLD-T TO FF58.
    MOVE "TOTALS:" TO FF59 MOVE DS-TWEIGHT TO FF60(2) MOVE DS-TAMT TO FF61(1).
    COMPUTE WD1 ROUNDED=DS-TAMT * 100 / DS-TWEIGHT SIZE ERROR MOVE 0 TO WD1.
    MOVE WD1 TO FF61(2) PERFORM PR-LINE.
    MOVE LOW-VALUES TO DS-TTOTALS PERFORM DS-PAGE.

DS-RD. PERFORM DS-RD1 THRU DS-RD9.
DS-RD1. MOVE LOW-VALUES TO DS-DTOTALS MOVE 0 TO DS-IXT.
DS-RD13. ADD 1 TO DS-IXT IF DS-IXT>4 OR DS-TER(DS-IXT)=0 GO DS-RD6.
    INITIALIZE ST-KEY MOVE DS-TER(DS-IXT) TO ST-TER.
    START SALTOT KEY>ST-KEY REGARDLESS INVALID GO DS-RD4.
DS-RD3. READ SALTOT NEXT REGARDLESS END GO DS-RD4.
    IF ST-TER NOT=DS-TER(DS-IXT) GO DS-RD4. IF ST-CAT>=90 GO DS-RD3.
    IF ST-YY NOT=DS-YY GO DS-RD3.
    IF ST-MM>DS-MM OR ST-MM=DS-MM AND ST-DD>DS-DD GO DS-RD3.
    IF DS-EX=3 AND ST-US=0 OR DS-EX=4 AND ST-US=1 GO DS-RD3.
    IF INUT GO DS-RD32.

    MOVE ST-YY TO D-YY MOVE ST-MM TO D-MM MOVE ST-DD TO D-DD.
    PERFORM D-MN MOVE D-DATE TO DS-DATE MOVE 062409 TO D-DT PERFORM D-MN.
    IF NOT(DS-AF=0 AND (DS-DATE<D-DATE OR DS-DATE>=D-DATE AND NOT(ST-TER=3 OR 13))
      OR DS-AF=1 AND DS-DATE>=D-DATE AND (ST-TER=3 OR 13)) GO DS-RD3.

    REPLACE ==STUDS== BY ==21 OR 22 OR 23==
            ==MNUTS== BY ==11 OR 14 OR 33 OR 69==
            ==PNUTS== BY ==8 OR 31 OR 32==.
    IF DS-OQ=1 GO DS-RD34.
    IF DS-OQ=2 IF NOT(ST-CAT= STUDS OR MNUTS OR PNUTS) GO DS-RD34 ELSE GO DS-RD3.
    IF DS-OQ=3 IF ST-CAT= STUDS GO DS-RD34 ELSE GO DS-RD3.
    IF DS-OQ=4 IF DS-OP<=3 IF ST-CAT= MNUTS GO DS-RD34 ELSE GO DS-RD3
                 ELSE IF ST-CAT= MNUTS OR PNUTS GO DS-RD34 ELSE GO DS-RD3.
    IF DS-OQ=5 IF ST-CAT= PNUTS GO DS-RD34 ELSE GO DS-RD3.
    REPLACE OFF.

DS-RD32.
    REPLACE ==NUTS== BY ==2 OR 8 OR 11==
            ==KEPS== BY ==31 OR 33==
            ==RNUTS== BY ==32==
            ==ANUTS== BY ==14==.
    IF DS-OQ=1 IF DS-OP<=3 IF ST-CAT= NUTS GO DS-RD34 ELSE GO DS-RD3
                 ELSE IF ST-CAT= ANUTS GO DS-RD34 ELSE GO DS-RD3.
    IF DS-OQ=2 IF ST-CAT= KEPS GO DS-RD34 ELSE GO DS-RD3.
    IF DS-OQ=3 IF ST-CAT= RNUTS GO DS-RD34 ELSE GO DS-RD3.
    IF DS-OQ=4 IF DS-OP<=3 IF NOT(ST-CAT= NUTS OR KEPS OR RNUTS) GO DS-RD34 ELSE GO DS-RD3
                 ELSE IF NOT(ST-CAT= ANUTS) GO DS-RD34 ELSE GO DS-RD3.
    REPLACE OFF.

DS-RD34. MOVE ST-AMT TO DS-AMT.
    IF DS-EX=1 AND ST-US=1
      MOVE ST-YY TO D-YY MOVE ST-MM TO D-MM MOVE 1 TO D-DD PERFORM D-MN
      MOVE DS-AMT TO A-T1 PERFORM EXCHG-CONV MOVE A-D1 TO DS-AMT.
    IF ST-MM=DS-MM AND ST-DD=DS-DD
      ADD DS-AMT TO DS-DA(1) DS-SA(1) DS-GA(1)
      ADD ST-WEIGHT TO DS-DW(1) DS-SW(1) DS-GW(1) ADD ST-QTY TO DS-DQ(1) DS-SQ(1) DS-GQ(1).
    IF ST-MM=DS-MM
      ADD DS-AMT TO DS-DA(2) DS-SA(2) DS-GA(2)
      ADD ST-WEIGHT TO DS-DW(2) DS-SW(2) DS-GW(2) ADD ST-QTY TO DS-DQ(2) DS-SQ(2) DS-GQ(2)
      IF ST-US<=1 ADD ST-AMT TO DS-RSA(ST-US + 1) DS-RGA(ST-US + 1).
    ADD DS-AMT TO DS-DA(3) DS-SA(3) DS-GA(3).
    ADD ST-WEIGHT TO DS-DW(3) DS-SW(3) DS-GW(3) ADD ST-QTY TO DS-DQ(3) DS-SQ(3) DS-GQ(3).
    GO DS-RD3.
DS-RD4. GO DS-RD13.
DS-RD6. MOVE DS-DTOTALS TO DS-XTOTALS PERFORM DS-PRT PERFORM DS-LINE.
    PERFORM VARYING DS-IX1 FROM 1 BY 1 UNTIL DS-IX1>3
     IF NOT INUT AND (DS-OQ=1 OR 2) OR INUT AND (DS-OQ=1 OR 4)
       ADD DS-DA(DS-IX1) TO DS-S1A(DS-IX1)
       ADD DS-DW(DS-IX1) TO DS-S1W(DS-IX1) ADD DS-DQ(DS-IX1) TO DS-S1Q(DS-IX1) END-IF
     IF NOT INUT AND DS-OQ=3 OR INUT AND DS-OQ=2
       ADD DS-DA(DS-IX1) TO DS-S2A(DS-IX1)
       ADD DS-DW(DS-IX1) TO DS-S2W(DS-IX1) ADD DS-DQ(DS-IX1) TO DS-S2Q(DS-IX1) END-IF
     IF NOT INUT AND DS-OQ=4 OR INUT AND DS-OQ=3
       ADD DS-DA(DS-IX1) TO DS-S3A(DS-IX1)
       ADD DS-DW(DS-IX1) TO DS-S3W(DS-IX1) ADD DS-DQ(DS-IX1) TO DS-S3Q(DS-IX1) END-IF
     IF DS-OQ=5
       ADD DS-DA(DS-IX1) TO DS-S4A(DS-IX1)
       ADD DS-DW(DS-IX1) TO DS-S4W(DS-IX1) ADD DS-DQ(DS-IX1) TO DS-S4Q(DS-IX1) END-IF
     END-PERFORM.
DS-RD9. EXIT.
DS-PRT. MOVE DS-XA(1) TO FA289.
    IF DS-EX=5 COMPUTE A-N1 ROUNDED=DS-XQ(1) / 1000
      MOVE A-N1 TO FA290C COMPUTE FA290D ROUNDED=DS-XA(1) / A-N1 SIZE ERROR CONTINUE END-COMPUTE
     ELSE MOVE DS-XW(1) TO FA290A COMPUTE FA290B ROUNDED=DS-XA(1) * 100 / DS-XW(1) SIZE ERROR CONTINUE.
    MOVE DS-XA(2) TO FA291.
    IF DS-EX=5 COMPUTE A-N1 ROUNDED=DS-XQ(2) / 1000
      MOVE A-N1 TO FA292C COMPUTE FA292D ROUNDED=DS-XA(2) / A-N1 SIZE ERROR CONTINUE END-COMPUTE
     ELSE MOVE DS-XW(2) TO FA292A COMPUTE FA292B ROUNDED=DS-XA(2) * 100 / DS-XW(2) SIZE ERROR CONTINUE.
    COMPUTE FA293 ROUNDED=DS-XW(2) / 2000 / DS-MDAYS SIZE ERROR CONTINUE.
    MOVE DS-XA(3) TO FA294.
    IF DS-EX=5 COMPUTE A-N1 ROUNDED=DS-XQ(3) / 1000
      MOVE A-N1 TO FA295C COMPUTE FA295D ROUNDED=DS-XA(3) / A-N1 SIZE ERROR CONTINUE END-COMPUTE
     ELSE MOVE DS-XW(3) TO FA295A COMPUTE FA295B ROUNDED=DS-XA(3) * 100 / DS-XW(3) SIZE ERROR CONTINUE.
    COMPUTE FA296 ROUNDED=DS-XW(3) / 2000 / DS-YDAYS SIZE ERROR CONTINUE.
DS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM DS-PAGE.
DS-PAGE. IF DS-STEP=1 MOVE "DAILY SALES ANALYSIS REPORT" TO FF3
      MOVE "** BY TERRITORY / BY CATEGORY **" TO FF4.
    IF DS-STEP=2
      IF DS-AF=0 MOVE "DAILY SHIPMENTS" TO FF3
        ELSE MOVE "DAILY TRANSFERS TO AFFILIATES" TO FF3 END-IF
      EVALUATE TRUE
        WHEN DS-EX=1 MOVE "(CDN DOLLARS)" TO FF4
        WHEN DS-EX=2 MOVE "(MIXED DOLLARS)" TO FF4
        WHEN DS-EX=3 MOVE "(US DOLLARS ONLY)" TO FF4
        WHEN DS-EX=4 MOVE "(CDN DOLLARS ONLY)" TO FF4
        WHEN DS-EX=5 MOVE "(MIXED DOLLARS - PIECES)" TO FF4
        END-EVALUATE.
    IF DS-STEP=3 MOVE "DAILY SALES ANALYSIS REPORT" TO FF3
      MOVE "** NON-SALES SUMMARY **" TO FF4.
    IF DS-STEP=4 MOVE "MONTHLY SALES SUMMARY" TO FF3.
    PERFORM PR-PAGE.
    IF DS-STEP=2 OR 3 OR 4
      IF DS-STEP=2 MOVE "SHIPPING DAYS:" TO FA297
        MOVE DS-MDAYS TO FA298 MOVE DS-YDAYS TO FA299 END-IF
      MOVE "REPORT DATE:" TO A-A1 PERFORM PRANGE-DT.
    IF DS-STEP=1 MOVE
         "PRODUCT       DESCRIPTION                              QTY        WEIGHT      TODAY'S VALUE        AVGE/CWT" TO PREC PERFORM PR-LINE-3.
*         ............
*         ......... ..  ................................  ..,...,...-  ..,...,...-      ...,...:..-      ...,...:..-
    IF DS-STEP=2 MOVE
         "                      ----------- DAILY ------------  ----------- MONTH TO DATE -----------  ------------ YEAR TO DATE ------------" TO PREC PERFORM PR-LINE
      IF DS-EX=5 MOVE
         "TERRITORY                   AMT     PCS(M)      $/M          AMT    PCS(M)      $/M   TON/D        AMT      PCS(M)      $/M   TON/D" TO PREC PERFORM PR-LINE-3
*         ......... - ......... .,...,...:..- ..,...- .,...:..- .,...,...:..- ..,...- .,...:..- ..:.- ..,...,...:..- ...,...- .,...:..- ..:.-
        ELSE MOVE
         "TERRITORY                   AMT       WEIGHT   $/CWT        AMT       WEIGHT   $/CWT  TON/D        AMT        WEIGHT   $/CWT  TON/D" TO PREC PERFORM PR-LINE-3.
*         ......... - ......... .,...,...:..- .,...,...- ..:..- .,...,...:..- .,...,...- ..:..- ..:.- ..,...,...:..- ..,...,...- ..:..- ..:.-
    IF DS-STEP=3 MOVE
         "CATEGORY                                     DAILY       MONTH TO DATE       YEAR TO DATE" TO PREC PERFORM PR-LINE-3.
*         ..................... - ..........  ...,...,...:..-    ...,...,...:..-    ...,...,...:..-
    IF DS-STEP=4 MOVE
         "                        ---------------------- MONTH -----------------------   ------------------- YEAR TO DATE -------------------" TO PREC PERFORM PR-LINE
      MOVE
         "                        -------- OUTSIDE --------  ------- AFFILIATES ------   -------- OUTSIDE --------  ------- AFFILIATES ------" TO PREC PERFORM PR-LINE
      MOVE
         "                            CWT  $/CWT      AMT        CWT  $/CWT      AMT         CWT  $/CWT      AMT        CWT  $/CWT      AMT" TO PREC PERFORM PR-LINE-3.
*         ........ - ..........   ...,...- ..:..- ..,...:.-  ...,...- ..:..- ..,...:.-   ...,...- ..:..- ..,...:.-  ...,...- ..:..- ..,...:.-

* Z-8 SALES ANALYSIS REPORTS
SE1. PERFORM RD254 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO SE-KPLT MOVE S-S2 TO SE-KSAN GO SE2.
    PERFORM AX-SEL IF SEL-N=0 OR>4 GO MX1.
    MOVE 0 TO SE-KPLT SE-KSAN.
    IF Y4 ADD 1 TO IXT DISPLAY "INCLUDE ONLY PLATED PARTS ? ___" LINE IXT BOLD
      ACCEPT XA3 LINE IXT COLUMN 29 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO SE-KPLT.
    IF Y4 ADD 1 TO IXT DISPLAY "INCLUDE SALES SUMMARY ANALYSIS ? ___" LINE IXT BOLD
      ACCEPT XA3 LINE IXT COLUMN 34 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO SE-KSAN.
    PERFORM AX-SUM PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE SE-KPLT TO S-S1 MOVE SE-KSAN TO S-S2 GO MX9.
SE2. PERFORM DSP-WAIT PERFORM OPEN-REP MOVE " " TO C-NO P-NO.
    IF Y4 START PRODUCT KEY>P-KEY REGARDLESS INVALID GO SE29
      ELSE START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO SE29.
SE23. IF Y4 READ PRODUCT NEXT REGARDLESS END GO SE29 END-READ
        IF P-YTD=0 AND P-MTD=0 OR SE-KPLT=1 AND P-FINDESC=" " GO SE23 END-IF
       ELSE READ CUSTOMER NEXT REGARDLESS END GO SE29 END-READ
        IF C-TOT=0 AND C-YTD=0 AND C-MTD=0 GO SE23 END-IF.
    PERFORM INIT-RP EVALUATE TRUE
      WHEN Y1 MOVE C-TER TO RP-F19 MOVE C-KEY TO RP-F20
      WHEN Y2 MOVE C-PROV TO RP-F19 MOVE C-KEY TO RP-F20
      WHEN Y3 MOVE C-SAL TO RP-F19 MOVE C-KEY TO RP-F20
      WHEN Y4 MOVE P-CAT TO RP-F19 MOVE P-KEY TO RP-F20
      END-EVALUATE.
    WRITE RP-RECORD GO SE23.
SE29. IF SE-KSAN=1 PERFORM OPEN-MAINTA.
    PERFORM OPEN-PR MOVE 1 TO SE-STEP PERFORM SE-PAGE.
    MOVE LOW-VALUES TO SE-STOTALS SE-GTOTALS MOVE 0 TO OLD-N.
    IF Y4 MOVE LOW-VALUES TO SE-PTOTALS SE-RTOTALS.
    IF Y4 MOVE 5 TO SE-IXN ELSE MOVE 4 TO SE-IXN.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SE9.
SE3. READ REPFL NEXT END GO SE9.
    IF Y4 MOVE RP-F20 TO P-KEY READ PRODUCT REGARDLESS
      ELSE MOVE RP-F20 TO C-KEY READ CUSTOMER REGARDLESS.
    EVALUATE TRUE
      WHEN Y1 MOVE 1 TO SE-TBL MOVE C-TER TO SE-TNO
      WHEN Y2 MOVE 12 TO SE-TBL MOVE C-PROV TO SE-TNO
      WHEN Y3 MOVE C-SAL TO SE-TNO
      WHEN Y4 MOVE 2 TO SE-TBL MOVE P-CAT TO SE-TNO
      END-EVALUATE.
    IF SE-TNO=OLD-N GO SE4. IF OLD-N NOT=0 PERFORM SE-T.
    MOVE SE-TNO TO OLD-N FF11.
    IF SE-TNO NOT=0
      IF Y3 MOVE SE-TNO TO A-N1 PERFORM RD-SALESMAN MOVE SN-NAME TO FF12
       ELSE MOVE SE-TBL TO T-TBL MOVE SE-TNO TO T-NO PERFORM RD-TBL MOVE T-LINE TO FF12.
    PERFORM SE-LINE 2 TIMES.
SE4. IF Y4 GO SE6.
    MOVE C-NO TO FF13 MOVE C-NAME TO FF14.
    MOVE C-MTD TO FF15(1) MOVE C-YTD TO FF15(2).
    ADD C-MTD TO SE-STOT(1) SE-GTOT(1) ADD C-YTD TO SE-STOT(2) SE-GTOT(2).
    GO SE8.
SE6. MOVE P-NO TO FF13 PERFORM PROD-DESC MOVE PRO-DESC(1) TO FF14.
    MOVE P-MTD TO FF15(1) MOVE P-YTD TO FF15(2).
    MOVE P-W-MTD TO FF15(3) MOVE P-W-YTD TO FF15(4).
    ADD P-MTD TO SE-STOT(1) SE-GTOT(1) ADD P-YTD TO SE-STOT(2) SE-GTOT(2).
    ADD P-W-MTD TO SE-STOT(3) SE-GTOT(3) ADD P-W-YTD TO SE-STOT(4) SE-GTOT(4).
    IF P-MAC=99
      ADD P-MTD TO SE-PTOT(1) SE-RTOT(1) ADD P-YTD TO SE-PTOT(2) SE-RTOT(2)
      ADD P-W-MTD TO SE-PTOT(3) SE-RTOT(3) ADD P-W-YTD TO SE-PTOT(4) SE-RTOT(4).
    PERFORM GET-OP IF A-S1=1 GO SE68.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)>=626 AND<=629 OR>=631 AND<=634 OR=638
        MOVE P-MTD TO FF15(5) ADD P-MTD TO SE-STOT(5) SE-GTOT(5) GO SE68 END-IF END-PERFORM.
SE68. IF SE-KSAN=1 MOVE P-CAT TO MFA-F33
        MOVE P-MTD TO MFA-F34(1) MOVE P-YTD TO MFA-F34(2)
        MOVE P-W-MTD TO MFA-F34(3) MOVE P-W-YTD TO MFA-F34(4) WRITE MFA-RECORD.
SE8. IF SUM-IND=0 PERFORM SE-LINE ELSE MOVE " " TO PREC. GO SE3.
SE9. PERFORM SE-T MOVE "*** GRAND TOTALS" TO FF14.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>SE-IXN
      MOVE SE-GTOT(IX1) TO FF15(IX1) END-PERFORM PERFORM PR-LINE.
    IF Y4 MOVE SE-GTOTALS TO SE-XTOTALS MOVE SE-RTOTALS TO SE-YTOTALS PERFORM SE-P.
    PERFORM CLOSE-REP.
    IF SE-KSAN=1 CLOSE MAINTA
      MOVE 2 TO SE-STEP PERFORM SE-PAGE MOVE 1 TO CTA-OP PERFORM CTA-ANALYSIS.
    PERFORM CLOSE-PR GO MX9.

SE-T. MOVE 2 TO WS-PR MOVE " ** SUB-TOTALS" TO FF14.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>SE-IXN
      MOVE SE-STOT(IX1) TO FF15(IX1) END-PERFORM PERFORM PR-LINE.
    IF Y4 MOVE SE-STOTALS TO SE-XTOTALS MOVE SE-PTOTALS TO SE-YTOTALS PERFORM SE-P.
    MOVE LOW-VALUES TO SE-STOTALS IF Y4 MOVE LOW-VALUES TO SE-PTOTALS.
    IF SUM-IND=0 PERFORM SE-PAGE ELSE PERFORM SE-LINE.
SE-P. MOVE "    PURCHASED PARTS" TO FF14.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE SE-YTOT(IX1) TO FF15(IX1) END-PERFORM PERFORM PR-LINE.
    MOVE "                NET" TO FF14.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      COMPUTE FF15(IX1)=SE-XTOT(IX1) - SE-YTOT(IX1) END-PERFORM PERFORM PR-LINE.
SE-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM SE-PAGE.
SE-PAGE. MOVE "SALES ANALYSIS" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** BY TERRITORY **" TO FF4
      WHEN Y2 MOVE "** BY PROVINCE **" TO FF4
      WHEN Y3 MOVE "** BY SALESMAN **" TO FF4
      WHEN Y4 MOVE "** BY CATEGORY **" TO FF4
        IF SE-KPLT=1 MOVE "** BY CATEGORY (PLATED PARTS) **" TO FF4 END-IF
      END-EVALUATE.
    IF Y4 PERFORM PR-IPAGE ELSE PERFORM PR-PAGE.
    IF SE-STEP=1
     IF Y4 MOVE
         "PRODUCT       DESCRIPTION                           SALES MTD     SALES YTD      WEIGHT MTD     WEIGHT YTD     SORTED MTD" TO PREC PERFORM PR-LINE-3
*         ............  ................................   ...,...,...-   ...,...,...-   ...,...,...-   ...,...,...-   ...,...,...-
      ELSE MOVE
         "CUSTOMER      NAME                                  SALES MTD     SALES YTD" TO PREC PERFORM PR-LINE-3.
*         ............  ................................   ...,...,...-   ...,...,...-
    IF SE-STEP=2 MOVE 2 TO WS-PR PERFORM PR-LINE.

* Z-9 SALES JOURNAL
DD1. PERFORM RD404 PERFORM WRT IF S-BAT GO DD2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
DD2. PERFORM DSP-WAIT PERFORM OPEN-REP OPEN INPUT TMPORD ALLOWING ALL.
    MOVE " " TO YO-KEY START TMPORD KEY>YO-KEY REGARDLESS INVALID GO DD29.
DD23. READ TMPORD NEXT REGARDLESS END GO DD29. MOVE YO-DATA TO O-RECORD.
    PERFORM INIT-RP MOVE O-INVNO TO RP-F181 MOVE YO-KEY TO RP-F182.
    WRITE RP-RECORD GO DD23.
DD29. PERFORM OPEN-PR PERFORM DD-PAGE MOVE LOW-VALUES TO DD-MTOTALS DD-UMTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DD9.
DD3. READ REPFL NEXT END GO DD9. MOVE RP-F182 TO YO-KEY READ TMPORD REGARDLESS.
    MOVE YO-DATA TO O-RECORD MOVE O-CUS TO A-A1 PERFORM RD-CUS.
    MOVE O-INVNO TO FD197 MOVE C-NO TO FD198 MOVE C-NAME TO FD199.
    IF 1.33 * C-ORD + C-TOT>C-CREDIT MOVE "***" TO FD200. PERFORM PR-LINE.
    MOVE O-TOTAL TO FD202(1) MOVE O-GST TO FD202(2) MOVE O-HST TO FD202(3).
    MOVE O-PST TO FD202(4) MOVE O-QST TO FD202(5) MOVE O-NON-SAL TO FD202(6).
    ADD O-TOTAL TO DD-MA(1) ADD O-GST TO DD-MA(2) ADD O-HST TO DD-MA(3).
    ADD O-PST TO DD-MA(4) ADD O-QST TO DD-MA(5) ADD O-NON-SAL TO DD-MA(6).
    IF C-TER=12 ADD O-GST TO DD-MA-IG.
    IF C-US=1 ADD O-GST TO DD-UMA(1) ADD O-HST TO DD-UMA(2)
      ADD O-PST TO DD-UMA(3) ADD O-QST TO DD-UMA(4) ADD O-NON-SAL TO DD-UMA(5).
    COMPUTE WD1=O-TOTAL - O-GST - O-HST - O-PST - O-QST - O-NON-SAL.
    MOVE WD1 TO FD202(7) ADD WD1 TO DD-MA(7).
    MOVE O-SURTOT TO FD202(8) ADD O-SURTOT TO DD-MA(8).
    PERFORM DD-LINE GO DD3.
DD9. MOVE 3 TO WS-PR PERFORM DD-LINE MOVE "GRAND TOTALS" TO FD201.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8 MOVE DD-MA(IX1) TO FD202(IX1) END-PERFORM.
    PERFORM PR-LINE MOVE "PREVIOUS BALANCE" TO FD201.
    PERFORM RD-INFO PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      MOVE IF-SALMTD(IX1) TO FD202(IX1) ADD DD-MA(IX1) TO IF-SALMTD(IX1) END-PERFORM.
    ADD DD-MA-IG TO IF-SALMTD-IG.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 ADD DD-UMA(IX1) TO IF-USALMTD(IX1) END-PERFORM.
    PERFORM WR-INFO PERFORM PR-LINE MOVE "MTD BALANCE" TO FD201.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8 MOVE IF-SALMTD(IX1) TO FD202(IX1) END-PERFORM.
    PERFORM PR-LINE.
    CLOSE TMPORD PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

DD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM DD-PAGE.
DD-PAGE. MOVE "SALES JOURNAL" TO FF3 PERFORM PR-PAGE.
    MOVE "INV NO  CUST    NAME                            LIM EX" TO PREC PERFORM PR-LINE.
    MOVE "                            TOTAL          GST           HST           PST           QST       NON SALES     NET SALES     SURCHARGE" TO PREC PERFORM PR-LINE-3.
*         ......  ......  ................................  ...
*         ....................   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-   ...,...:..-

* Z-10 PRODUCT DEMAND REPORT
SD1. PERFORM RD368 PERFORM WRT IF S-BAT GO SD2.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 39 TO IXV PERFORM AX-CAT-R.
    MOVE 5 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
SD2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO SD29.
SD23. READ PRODUCT NEXT REGARDLESS END GO SD29.
    IF NOT(P-CAT>=CAT1 AND<=CAT2) GO SD23. PERFORM INIT-RP.
    MOVE P-CAT TO RP-F17 MOVE P-NO TO RP-F18 WRITE RP-RECORD GO SD23.
SD29. PERFORM OPEN-PR PERFORM SD-PAGE.
    MOVE LOW-VALUES TO SD-STOTALS SD-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SD9.
SD3. READ REPFL NEXT END GO SD9. MOVE RP-F18 TO A-A1 PERFORM PROD-GEN.
    IF P-CAT=OLD-N GO SD4. IF OLD-N NOT=0 PERFORM SD-SUB. MOVE P-CAT TO OLD-N.
SD4. MOVE P-NO TO FF62 IF GEN-IND=1 MOVE GEN-ALT TO FF62 MOVE P-NO TO GEN-PN
      MOVE GEN-MSG TO FF65 GO SD8.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO FF65.
    COMPUTE SD-ORDER=P-ORDER + P-PROCESS MOVE SD-ORDER TO FF66.
    MOVE P-WEIGHT TO FF67 COMPUTE SD-OWEIGHT ROUNDED=SD-ORDER * P-WEIGHT / 100.
    IF SD-OWEIGHT>=0 MOVE SD-OWEIGHT TO FF68. MOVE P-RATE TO FF69.
    COMPUTE SD-OQTY ROUNDED=SD-ORDER / P-RATE SIZE ERROR MOVE 0 TO SD-OQTY.
    IF SD-OQTY>=0 MOVE SD-OQTY TO FF70.
    MOVE P-MAC TO FF71 PERFORM SET-PART MOVE PART-NO TO FF72.
    ADD SD-ORDER TO SD-SQ SD-GQ ADD SD-OWEIGHT TO SD-SW SD-GW ADD SD-OQTY TO SD-SN SD-GN.
SD8. IF TOT-IND=0 PERFORM SD-LINE ELSE MOVE " " TO PREC. GO SD3.
SD9. PERFORM SD-SUB MOVE 4 TO WS-PR MOVE "GRAND TOTALS" TO FF65.
    MOVE SD-GQ TO FF66 MOVE SD-GW TO FF68 MOVE SD-GN TO FF70 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

SD-SUB. MOVE 3 TO WS-PR MOVE "CATEGORY" TO FF64.
    MOVE OLD-N TO FF64A PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF65.
    MOVE SD-SQ TO FF66 MOVE SD-SW TO FF68 MOVE SD-SN TO FF70 PERFORM SD-LINE.
    MOVE LOW-VALUES TO SD-STOTALS MOVE 3 TO WS-PR.
SD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM SD-PAGE.
SD-PAGE. MOVE "PRODUCT DEMAND REPORT" TO FF3 MOVE "** BY CATEGORY **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR PERFORM PRANGE-CAT.
    MOVE "PRODUCT       DESCRIPTION                           ORDERS       WT/C       ORDERS     RATE    ORDERS   MACH  MATERIAL" TO PREC PERFORM PR-LINE.
    MOVE "                                                    IN PCS                  IN LBS    PCS/HR   IN HRS" TO PREC PERFORM PR-LINE-3.
*         ............  ................................  ...,...,...-  ..,...:..  ..,...,...-  ..,...   ..,...-   ..   ...............

* Z-11 INVENTORY REPORT
SS1. PERFORM RD147 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO SS-KS MOVE S-S2 TO SS-KI MOVE S-S3 TO SS-KA
      MOVE S-S4 TO SS-KR MOVE S-S5 TO SS-KC MOVE S-S6 TO SS-KN
      MOVE S-N1 TO SS-KSAN MOVE S-A1 TO SS-TITLE GO SS2.
* note 32
    MOVE 0 TO SEL-N SS-KS SS-KI SS-KA SS-KR SS-KC SS-KN SS-KSAN.
    MOVE " " TO WA1 WA2 WA3 WA4 SS-TITLE.
    ACCEPT XA3 LINE 3 COLUMN 29 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SEL-N GO SS14.
    ACCEPT XA3 LINE 3 COLUMN 75 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 2 TO SEL-N.
    ACCEPT XA3 LINE 5 COLUMN 20 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SS-KR GO SS14.
    ACCEPT XA3 LINE 5 COLUMN 52 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SS-KC.
SS14. IF SEL-N>0 GO SS16.
    ACCEPT XA3 LINE 7 COLUMN 43 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SS-KS MOVE "(BELOW SAFETY)" TO WA1.
    ACCEPT XA3 LINE 8 COLUMN 28 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SS-KN MOVE "(NEW)" TO WA2.
    ACCEPT XA3 LINE 9 COLUMN 28 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SS-KI ELSE MOVE "(ACTIVE PARTS)" TO WA3.
    ACCEPT XA3 LINE 10 COLUMN 24 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SS-KA MOVE "(EXCL ALTERNATES)" TO WA4.
    STRING WA1 WA2 WA3 WA4 DELIMITED "  " INTO SS-TITLE.
SS16. IF SS-KC=1 MOVE 13 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-CUS-R
        ELSE MOVE 12 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-CAT-R.
    IF SS-KI=1 ACCEPT XA3 LINE 15 COLUMN 40 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO SS-KSAN.
    MOVE 17 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE SS-KS TO S-S1 MOVE SS-KI TO S-S2 MOVE SS-KA TO S-S3
      MOVE SS-KR TO S-S4 MOVE SS-KC TO S-S5 MOVE SS-KN TO S-S6
      MOVE SS-KSAN TO S-N1 MOVE SS-TITLE TO S-A1 GO MX9.
SS2. PERFORM DSP-WAIT PERFORM RDR-INFO PERFORM OPEN-REP MOVE " " TO PRO-NSV.
SS23. MOVE PRO-NSV TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO SS29.
    READ PRODUCT NEXT REGARDLESS END GO SS29. MOVE P-KEY TO PRO-NSV.
    IF SS-KC=1 IF P-CUS=" " OR NOT(P-CUS>=CUS1 AND<=CUS2) GO SS23.
    IF SS-KN=1 PERFORM CHK-NEW IF A-S1 NOT=1 GO SS23.
    MOVE P-CUS TO PRO-CUSV MOVE P-CAT TO PRO-CATSV PERFORM RD-GEN.
    IF SS-KA=1 IF GEN-IND=1 GO SS23.
    IF SS-KC=0 IF NOT(P-CAT>=CAT1 AND<=CAT2) GO SS23.
    IF Y1 IF NOT(P-HAND NOT=0 AND P-PROCESS<=0 AND P-DEMAND<=0
      AND P-FDEMAND<=0 AND P-YTD<=0 AND P-LAST<=0 AND P-PREV<=0) GO SS23.
    IF Y2 IF GEN-IND=1 OR NOT(P-DEMAND<P-ROP - P-ROP / 3 OR>P-ROP + P-ROP / 3) GO SS23.
    IF SS-KI=0 IF P-HAND=0 AND P-ORDER=0 AND P-PROCESS=0 AND P-DEMAND=0 GO SS23.
    IF SS-KS=1 IF (P-CAT<=21 AND NOT(P-ROP>1 AND P-HAND<P-ROP / 3))
      OR (P-CAT>21 AND NOT(P-HAND + P-ORDER + P-PROCESS<P-DEMAND)) GO SS23.
    PERFORM INIT-RP.
    IF SS-KC=1 MOVE PRO-CUSV TO RP-F21A ELSE MOVE PRO-CATSV TO RP-F21.
    IF SS-KR=1 MOVE P-ROP TO RP-F21B ELSE MOVE 0 TO RP-F21B.
    MOVE PRO-NSV TO RP-F22 WRITE RP-RECORD GO SS23.
SS29. IF SS-KSAN=1 PERFORM OPEN-MAINTA.
    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE SS-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    PERFORM OPEN-PR MOVE 1 TO SS-STEP PERFORM SS-PAGE.
    MOVE LOW-VALUES TO SS-STOTALS SS-GTOTALS SS-CTOTALS.
    MOVE 0 TO OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SS9.
SS3. READ REPFL NEXT END GO SS9. MOVE RP-F22 TO A-A1 PERFORM PROD-GEN.
    IF SS-KC=1 GO SS34.
    IF RP-F21=OLD-N GO SS4. IF OLD-N NOT=0 PERFORM SS-SUB PERFORM SS-PAGE.
    MOVE "CAT" TO FF22 MOVE RP-F21 TO FF23 PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF24.
    PERFORM SS-LINE 2 TIMES MOVE RP-F21 TO OLD-N GO SS4.
SS34. IF RP-F21A=OLD-A GO SS4. IF OLD-A>" " PERFORM SS-CUS PERFORM SS-PAGE.
    MOVE "CUST." TO FF503 MOVE RP-F21A TO FF504.
    MOVE RP-F21A TO A-A1 PERFORM RD-CUS MOVE C-NAME TO FF505.
    PERFORM SS-LINE 2 TIMES MOVE RP-F21A TO OLD-A GO SS4.
SS4. MOVE P-NO TO FF16.
    IF GEN-IND=1 MOVE GEN-ALT TO FF16 MOVE P-NO TO GEN-PN MOVE GEN-MSG TO FF17
      MOVE GEN-ALT TO P-NO READ PRODUCT REGARDLESS
      IF P-HAND>0 MOVE P-HAND TO FF18(1)
        COMPUTE SS-PWEIGHT ROUNDED=P-HAND * P-WEIGHT / 100 MOVE SS-PWEIGHT TO FF20
        ADD P-HAND TO SS-SQ SS-GQ ADD SS-PWEIGHT TO SS-SW SS-GW END-IF GO SS6.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO FF17.
    IF P-HAND>=0 MOVE P-HAND TO FF18(1) ADD P-HAND TO SS-SQ SS-GQ.
    MOVE P-ORDER TO FF18(2) MOVE P-PROCESS TO FF18(3).
    COMPUTE WN1=P-DEMAND + P-FDEMAND IF WN1>=0 MOVE WN1 TO FF18(4).
    MOVE P-ROP TO FF18(5) ADD P-ROP TO SS-SR SS-GR.
    IF P-LEVEL=3 MOVE P-LEVEL TO FF18A.
    MOVE P-WEIGHT TO FF19 COMPUTE SS-PWEIGHT ROUNDED=P-HAND * P-WEIGHT / 100.
    IF SS-PWEIGHT>=0 MOVE SS-PWEIGHT TO FF20 ADD SS-PWEIGHT TO SS-SW SS-GW.
    MOVE P-LEAD TO FF21 PERFORM SS-SFT.
    IF SS-KS1=1 ADD 1 TO SS-SN(1) SS-GN(1) SS-CN(1).
    IF SS-KS2=1 MOVE "**" TO FF21A ADD 1 TO SS-SN(2) SS-GN(2) SS-CN(2).
SS6. PERFORM SS-LINE.

    MOVE RP-F22 TO A-A1 PERFORM PROD-GEN.
    MOVE P-CAT TO EXP-N PERFORM EXPF MOVE P-NO TO EXP-A PERFORM EXPF.
    IF GEN-IND=1 MOVE GEN-ALT TO EXP-A P-NO READ PRODUCT REGARDLESS. PERFORM EXPF.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE P-HAND TO EXP-N PERFORM EXPF.
    IF GEN-IND=0 MOVE P-ORDER TO EXP-N PERFORM EXPF MOVE P-PROCESS TO EXP-N PERFORM EXPF
      COMPUTE EXP-N=P-DEMAND + P-FDEMAND PERFORM EXPF MOVE P-ROP TO EXP-N PERFORM EXPF
      IF P-LEVEL=3 MOVE P-LEVEL TO EXP-N END-IF PERFORM EXPF
     ELSE MOVE 5 TO A-N1 PERFORM EXPFN.
    MOVE P-WEIGHT TO EXP-D PERFORM EXPF.
    COMPUTE SS-PWEIGHT ROUNDED=P-HAND * P-WEIGHT / 100 MOVE SS-PWEIGHT TO EXP-N PERFORM EXPF.
    IF GEN-IND=0 MOVE P-LEAD TO EXP-N PERFORM EXPF
      PERFORM SS-SFT IF SS-KS2=1 MOVE "**" TO EXP-A END-IF PERFORM EXPF
      MOVE P-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF
     ELSE MOVE 3 TO A-N1 PERFORM EXPFN.
    MOVE P-LPRICE TO A-T1 IF P-LUS=1 MOVE P-LDATE TO D-DATE PERFORM EXCHG-CONV.
    MOVE A-T1 TO EXP-T PERFORM EXPF.
    MOVE P-LDATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    IF GEN-IND=1 MOVE RP-F22 TO A-A1 PERFORM PROD-GEN.
    MOVE P-DIAM TO EXP-A PERFORM EXPF MOVE P-GRADE TO EXP-A PERFORM EXPF.
    PERFORM SET-ANNEAL MOVE PART-PROCESS TO EXP-A PERFORM EXPF.
    MOVE P-COST TO WT1 EXP-T PERFORM EXPF.
    INITIALIZE CU-REC MOVE P-NO TO CU-PROD READ COSTHIST REGARDLESS INVALID CONTINUE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      SUBTRACT CU-TOT(1,IX1) FROM WT1 ADD CU-NTOT(1,IX1) TO WT1 END-PERFORM.
    MOVE WT1 TO EXP-T PERFORM EXPF.
    MOVE CU-TOT(1,1) TO EXP-T PERFORM EXPF MOVE CU-NTOT(1,1) TO EXP-T PERFORM EXPF.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT.
    MOVE CU-TOT(1,4) TO EXP-T PERFORM EXPF MOVE CU-NTOT(1,4) TO EXP-T PERFORM EXPF.
    COMPUTE EXP-T ROUNDED=CU-TOT(1,4) / CST-NMULT SIZE ERROR MOVE 0 TO EXP-T. PERFORM EXPF.
    COMPUTE EXP-T ROUNDED=CU-NTOT(1,4) / CST-NMULT SIZE ERROR MOVE 0 TO EXP-T. PERFORM EXPF.
    PERFORM EXP-LINE.
    IF SS-KSAN=1 AND P-HAND>0
      MOVE RP-F21 TO MFA-F33 MOVE SS-PWEIGHT TO MFA-F34(1) WRITE MFA-RECORD.
    GO SS3.
SS9. IF SS-KC=1 PERFORM SS-CUS ELSE PERFORM SS-SUB.
    MOVE 2 TO WS-PR PERFORM SS-LINE MOVE "        *** GRAND" TO FF506.
    MOVE SS-GTOTALS TO SS-XTOTALS PERFORM SS-PT.
    PERFORM CLOSE-REP.
    IF SS-KSAN=1 CLOSE MAINTA
      MOVE 2 TO SS-STEP PERFORM SS-PAGE MOVE 2 TO CTA-OP PERFORM CTA-ANALYSIS.
    PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

SS-SFT. MOVE 0 TO SS-KS1 SS-KS2.
    IF RP-F21<=21 IF P-ROP>1 MOVE 1 TO SS-KS1 IF P-HAND<P-ROP / 3 MOVE 1 TO SS-KS2 END-IF END-IF
      ELSE MOVE 1 TO SS-KS1 IF P-HAND + P-ORDER + P-PROCESS<P-DEMAND MOVE 1 TO SS-KS2.
SS-CUS. MOVE 2 TO WS-PR PERFORM SS-LINE MOVE "CUSTOMER" TO FF507 MOVE OLD-A TO FF508.
    MOVE SS-STOTALS TO SS-XTOTALS PERFORM SS-PT.
    MOVE LOW-VALUES TO SS-STOTALS.
SS-SUB. MOVE 2 TO WS-PR PERFORM SS-LINE MOVE "CATEGORY" TO FF507 MOVE OLD-N TO FF509.
    MOVE SS-STOTALS TO SS-XTOTALS PERFORM SS-PT.
    MOVE LOW-VALUES TO SS-STOTALS IF OLD-N=11 OR 21 PERFORM SS-TOT.
SS-TOT. MOVE 2 TO WS-PR PERFORM SS-LINE.
    IF OLD-N=11 MOVE "CATEGORIES 01-11" TO FF80.
    IF OLD-N=21 MOVE "CATEGORIES 12-21" TO FF80.
    MOVE SS-CN(1) TO A-N1 MOVE SS-CN(2) TO A-N2 PERFORM SS-PF PERFORM SS-LINE.
    MOVE LOW-VALUES TO SS-CTOTALS.
SS-PT. MOVE "TOTAL ON HAND:" TO FF510 MOVE SS-XQ TO FF511 PERFORM PR-LINE.
    MOVE "TOTAL WEIGHT:" TO FF510 MOVE SS-XW TO FF511 PERFORM PR-LINE.
    MOVE "TOTAL REORDER:" TO FF510 MOVE SS-XR TO FF511 PERFORM SS-LINE.
    MOVE SS-XN(1) TO A-N1 MOVE SS-XN(2) TO A-N2 PERFORM SS-PF PERFORM SS-LINE.
SS-PF. MOVE "PARTS BELOW SAFETY:" TO FF81.
    MOVE A-N2 TO FF82 MOVE "OF" TO FF83 MOVE A-N1 TO FF84 MOVE "(" TO FF85.
    COMPUTE FF85A ROUNDED=A-N2 * 100 / A-N1 SIZE ERROR CONTINUE. MOVE "% )" TO FF85B.
SS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM SS-PAGE.
SS-PAGE. MOVE "INVENTORY REPORT" TO FF3.
    IF SS-KR=1 MOVE "INVENTORY REPORT (BY R.O.P.)" TO FF3.
    IF SS-KC=1 MOVE "INVENTORY REPORT (BY CUSTOMER)" TO FF3.
    MOVE SS-TITLE TO FF4.
    IF Y1 MOVE "** DEAD STOCK **" TO FF4.
    IF Y2 MOVE "** R.O.P. EXCEPTIONS **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF SS-KC=1 PERFORM PRANGE-CUS ELSE PERFORM PRANGE-CAT.
    IF SS-STEP=1 MOVE
         "PRODUCT       DESCRIPTION                         ON HAND    ON ORDER  IN PROCESS  TOT DEMAND      R.O.P. L3  WT/C   WT ON HD  LD ST" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ..,...,...- ..,...,...- ..,...,...- ..,...,...- ..,...,...-. ...:.. ..,...,...- .. ..
    IF SS-STEP=2 MOVE 2 TO WS-PR PERFORM PR-LINE.

* Z-12 PRODUCTION HOURS REPORT
RS1. PERFORM RD292 PERFORM WRT IF S-BAT MOVE S-S1 TO RS-KR GO RS2.
    ACCEPT XA3 LINE 4 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO RS-KR ELSE MOVE 0 TO RS-KR.
    MOVE 6 TO IXT MOVE 16 TO IXU MOVE 37 TO IXV PERFORM AX-MAC-R.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE RS-KR TO S-S1 GO MX9.
RS2. PERFORM DSP-WAIT PERFORM SET-SHORT-SCHED PERFORM OPEN-REP.
    COMPUTE D-DATE=SYS-DATE + 91 MOVE 5 TO D-N1.
    PERFORM D-PREVIOUS MOVE D-DATE TO RS-LIM-DATE.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO RS29.
RS23. READ PRODORD NEXT REGARDLESS END GO RS29.
    IF R-FIN=1 OR R-QTY-ORD<=R-QTY-PROD GO RS23.
* note 191.2
    MOVE R-PROD TO A-A1 PERFORM PROD-GEN PERFORM INIT-RP.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL XM-F6(IX1)=0
      IF R-NO=XM-F8(IX1) MOVE XM-F6(IX1) TO RP-F23 MOVE 0 TO RP-F24
        MOVE XM-F7(IX1) TO RP-F25 MOVE 0 TO RP-F26 GO RS26 END-IF END-PERFORM.
    MOVE P-MAC TO RP-F23 MOVE 1 TO RP-F24 MOVE 0 TO RP-F25.
    IF R-LDATE(1) NOT=0 MOVE R-LDATE(1) TO RP-F26 ELSE MOVE R-DATE TO RP-F26.
RS26. MOVE R-PROD TO RP-F27 MOVE R-KEY TO RP-F28.
    IF RP-F23>=MAC1 AND<=MAC2 WRITE RP-RECORD. GO RS23.
RS29. PERFORM OPEN-PR PERFORM RS-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE RS-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE LOW-VALUES TO RS-MTOTALS RS-GTOTALS MOVE 0 TO OLD-M MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RS9.
RS3. READ REPFL NEXT END GO RS9. MOVE RP-F28 TO R-KEY READ PRODORD REGARDLESS.
    IF RP-F23=OLD-M GO RS34. IF OLD-M NOT=0 PERFORM RS-T.
    MOVE RP-F23 TO OLD-M MOVE -1 TO OLD-N PERFORM RS-MC.
RS34. IF RP-F24=OLD-N GO RS4. IF OLD-N NOT=-1 PERFORM RS-LINE. MOVE RP-F24 TO OLD-N.
RS4. MOVE R-PROD TO A-A1 PERFORM PROD-RGD.
    MOVE P-CAT TO FF107 MOVE P-NO TO FF108 MOVE PRO-DESC(1) TO FF109.
    PERFORM DESC-PRINT MOVE PRO-PRINT(1:6) TO FF109A.
    MOVE R-NO TO FF110 IF RP-F24=0 MOVE "*" TO FF110A.
    COMPUTE RS-LEFT=R-QTY-ORD - R-QTY-PROD.
    COMPUTE RS-HOURS ROUNDED=RS-LEFT / P-RATE SIZE ERROR MOVE 0 TO RS-HOURS.
    MOVE RS-LEFT TO FF111 IF R-QTY-PROD>0 MOVE "*" TO FF112.
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF113.
    IF R-LDATE(1) NOT=0 MOVE R-LDATE(1) TO D-DATE PERFORM D-NM MOVE D-DT TO FF114.
    IF R-DATE<SYS-DATE ADD RS-HOURS TO RS-MHOURS(1).
    IF R-LMAT=1 MOVE "R" TO FF115(1:1) ADD RS-HOURS TO RS-MHOURS(2) RS-GHOURS(2).
    IF R-LTOOLS=1 MOVE "T" TO FF115(2:1) ADD RS-HOURS TO RS-MHOURS(3) RS-GHOURS(3).
    IF R-LPROC=1 AND R-LMAT=0 MOVE "A" TO FF116.
    MOVE R-DATE TO D-DATE IF RS-KR=0 AND R-LDATE(1) NOT=0 MOVE R-LDATE(1) TO D-DATE.
    PERFORM D-CURR COMPUTE RS-IXL=D-N1 + 1.
    IF RS-IXL<1 MOVE 1 TO RS-IXL. IF RS-IXL>4 MOVE 4 TO RS-IXL.
    MOVE RS-HOURS TO FF117(RS-IXL) ADD RS-HOURS TO RS-MTOT(RS-IXL) RS-GTOT(RS-IXL).
    IF P-CAT>=22 ADD RS-HOURS TO RS-MSHOURS.
    IF R-DATE<=RS-LIM-DATE ADD RS-HOURS TO RS-MLHOURS.
    PERFORM RS-LINE.

    MOVE M-NO TO EXP-N PERFORM EXPF MOVE P-CAT TO EXP-N PERFORM EXPF.
    MOVE P-NO TO EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF.
    MOVE R-NO TO EXP-N PERFORM EXPF.
    IF RP-F24=0 MOVE "*" TO EXP-A. PERFORM EXPF.
    MOVE RS-LEFT TO EXP-N PERFORM EXPF.
    IF R-QTY-PROD>0 MOVE "*" TO EXP-A. PERFORM EXPF.
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF.
    COMPUTE RS-WEIGHT ROUNDED=RS-LEFT * P-WEIGHT / 100.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      IF IX1=RS-IXL MOVE RS-HOURS TO EXP-N END-IF PERFORM EXPF
      IF IX1=RS-IXL MOVE RS-WEIGHT TO EXP-N END-IF PERFORM EXPF END-PERFORM.
    PERFORM EXP-LINE.
    GO RS3.
RS9. PERFORM RS-T MOVE "*** GRAND TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE RS-GTOT(IX1) TO FF117(IX1) END-PERFORM.
    PERFORM RS-LINE 2 TIMES.
    MOVE "*** TOTAL HOURS LATE:" TO FF101.
    MOVE "MATERIAL" TO FF102 MOVE RS-GHOURS(2) TO FF103 PERFORM PR-LINE.
    MOVE "TOOLS" TO FF102 MOVE RS-GHOURS(3) TO FF103 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

RS-T. IF WS-LINES>52 PERFORM RS-PAGE.
    MOVE 2 TO WS-PR MOVE "*** MACHINE TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE RS-MTOT(IX1) TO FF117(IX1) END-PERFORM.
    PERFORM RS-LINE 2 TIMES.
    MOVE "DAYS BEHIND SCHEDULE" TO FA600.
    COMPUTE FA601 ROUNDED=RS-MHOURS(1) / M-HOURS SIZE ERROR CONTINUE. PERFORM RS-LINE.
    MOVE "HOURS MATERIAL" TO FA600 MOVE RS-MHOURS(2) TO FA601 PERFORM RS-LINE.
    MOVE "HOURS TOOLS" TO FA600 MOVE RS-MHOURS(3) TO FA601 PERFORM RS-LINE.
    MOVE "LOAD THRU" TO FA600A MOVE RS-LIM-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA600B.
    MOVE RS-MLHOURS TO FA601.
    MOVE "HOURS REQUIRED FOR SPECIAL PRODUCTS:" TO FA602 MOVE RS-MSHOURS TO FA603.
    PERFORM RS-LINE PERFORM RS-PAGE MOVE LOW-VALUES TO RS-MTOTALS.
RS-MC. MOVE 3 TO WS-PR MOVE "MACHINE" TO FF104.
    MOVE OLD-M TO FF105 A-N1 PERFORM RD-MAC.
    MOVE M-DESC1 TO A-A1 PERFORM STR-LTH MOVE M-HOURS TO DSP-N21.
    STRING M-DESC1(1:A-N1) " (" DSP-N21 " HOURS/DAY)" DELIMITED SIZE INTO FF106.
    PERFORM RS-LINE 2 TIMES.
RS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RS-PAGE.
RS-PAGE. MOVE "PRODUCTION HOURS REPORT" TO FF3.
    IF RS-KR=1 MOVE "** USING REQUIRED START DATES **" TO FF4
      ELSE MOVE "** USING LATE START DATES **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR PERFORM PRANGE-MAC.
    MOVE "CAT PRODUCT     DESCRIPTION                     IF#      M.O. S/S   TO BUILD      DATE      LATE      AN   CURR  FUT 1  FUT 2  FUT 3" TO PREC PERFORM PR-LINE-3.
*         .. ............ ..............................  ......  .....  .  ..,...,... .  ../../..  ../../.. .. .    ...    ...    ...    ...

* Z-13 PRINT USER TABLES
TU1. PERFORM RD405 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 1 TO TU-IXP.
TU3. IF MN-MTBL(TU-IXP:1)="-" GO TU8.
    MOVE " " TO TU-TITLE STRING "** '" MN-MTBL(TU-IXP:1) "' MENU **"
      DELIMITED SIZE INTO TU-TITLE PERFORM TU-PAGE.
    MOVE " " TO US-KEY START USERS KEY>US-KEY REGARDLESS INVALID GO TU8.
TU5. READ USERS NEXT REGARDLESS END GO TU8.
    MOVE US-USER TO FF229 MOVE 1 TO IX1 IX2.
TU7. IF US-TD(TU-IXP,IX1)="0" MOVE "-" TO FF230(IX2) ELSE MOVE "X" TO FF230(IX2).
    ADD 1 TO IX1 IX2 IF IX1=11 OR 21 OR 31 ADD 1 TO IX2.
    IF IX1<=40 GO TU7. PERFORM TU-LINE GO TU5.
TU8. ADD 1 TO TU-IXP IF TU-IXP<=24 GO TU3.
TU9. PERFORM CLOSE-PR GO MX9.

TU-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM TU-PAGE.
TU-PAGE. MOVE "USER TABLE" TO FF3 MOVE TU-TITLE TO FF4 PERFORM PR-PAGE.
    MOVE "USER                             1   1 1 1 1 1 1 1 1 1 2   2 2 2 2 2 2 2 2 2 3   3 3 3 3 3 3 3 3 3 4" TO PREC PERFORM PR-LINE.
    MOVE "               1 2 3 4 5 6 7 8 9 0   1 2 3 4 5 6 7 8 9 0   1 2 3 4 5 6 7 8 9 0   1 2 3 4 5 6 7 8 9 0" TO PREC PERFORM PR-LINE-3.
*         ............   . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .

* Z-14 SALES SUMMARY REPORTS
SQ1. PERFORM RD255 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO SQ-KP MOVE S-S2 TO SQ-KT MOVE S-S3 TO SQ-KM
      MOVE S-N1 TO SQ-MM MOVE S-N2 TO SQ-YY MOVE S-A1 TO SQ-CLASS GO SQ2.
* note 177
    PERFORM AX-SEL IF SEL-N=0 OR>4 GO MX1.
    GO SQ10 SQ12 SQ14 SQ16  DEPENDING SEL-N.

SQ10. ADD 1 TO IXT DISPLAY "LIST BY PRODUCT ? ___" LINE IXT BOLD "  (OTHERWISE LISTED BY CUSTOMER)".
    ACCEPT XA3 LINE IXT COLUMN 19 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SQ-KP ELSE MOVE 0 TO SQ-KP.
    IF SQ-KP=0 PERFORM AX-CUS PERFORM AX-PROD ELSE PERFORM AX-PROD PERFORM AX-CUS.
    GO SQ18.
SQ12. PERFORM AX-CUS PERFORM AX-PROD GO SQ18.
SQ14. PERFORM AX-YM MOVE D-YY TO SQ-YY MOVE D-MM TO SQ-MM.
    ADD 1 TO IXT DISPLAY "NORMALLY ONLY TOP 10 CUSTOMERS IN EACH CLASS ARE LISTED" LINE IXT BOLD.
    ADD 1 TO IXT DISPLAY "  LIST ALL CUSTOMERS IN EACH CLASS ? ___" LINE IXT BOLD.
    ACCEPT XA3 LINE IXT COLUMN 38 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SQ-KT ELSE MOVE 0 TO SQ-KT MOVE " " TO SQ-CLASS GO SQ146.
    ADD 1 TO IXT DISPLAY "TO LIST ONLY ONE CLASS, SELECT CLASS: _  (W/T/O/D/A)" LINE IXT BOLD.
    ACCEPT SQ-CLASS LINE IXT COLUMN 39 DEFAULT " " UNDERLINED PROTECTED.
SQ146. ADD 1 TO IXT DISPLAY "REPORT IN MIXED $ ? ___" LINE IXT BOLD "  (OTHERWISE REPORTED IN EQUIV CAN$)".
    ACCEPT XA3 LINE IXT COLUMN 21 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO SQ-KM ELSE MOVE 0 TO SQ-KM. GO SQ18.
SQ16. ADD 1 TO IXT DISPLAY "CURRENT YEAR: __      FROM MONTH: __      TO MONTH: __    (INCLUSIVE)" LINE IXT BOLD.
    ACCEPT SQ-YY LINE IXT COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
SQ163. ACCEPT SQ-MM1 LINE IXT COLUMN 35 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(SQ-MM1>=1 AND<=12) PERFORM DSP-ERR2 GO SQ163.
SQ165. ACCEPT SQ-MM2 LINE IXT COLUMN 53 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(SQ-MM2>=1 AND<=12) PERFORM DSP-ERR2 GO SQ165.
    MOVE SQ-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO SQ-YCUR COMPUTE SQ-YPREV=SQ-YCUR - 1.
    GO SQ18.
SQ18. PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE SQ-KP TO S-S1 MOVE SQ-KT TO S-S2 MOVE SQ-KM TO S-S3
      MOVE SQ-MM TO S-N1 MOVE SQ-YY TO S-N2 MOVE SQ-CLASS TO S-A1 GO MX9.
SQ2. PERFORM DSP-WAIT.
    GO SQ30 SQ40 SQ50 SQ60  DEPENDING SEL-N.

SQ30. PERFORM OPEN-PR PERFORM SQ-PAGE IF SQ-KP=1 GO SQ36.
    MOVE " " TO SQ-OCUS MOVE CUS1 TO SM-CUS MOVE " " TO SM-PROD.
    START SALSUM KEY>=SM-KEY REGARDLESS INVALID GO SQ34.
SQ33. READ SALSUM NEXT REGARDLESS END GO SQ34. IF SM-CUS>CUS2 GO SQ34.
    IF NOT(SM-PROD>=PROD1 AND<=PROD2) GO SQ33.
    IF SM-CUS NOT=SQ-OCUS IF SQ-OCUS>" " PERFORM SQ-LINE 3 TIMES END-IF
      MOVE SM-CUS TO SQ-OCUS PERFORM SQ-C PERFORM SQ-LINE.
    MOVE SM-PROD TO SQ-OPROD PERFORM SQ-P PERFORM SQ-D GO SQ33.
SQ34. GO SQ39.

SQ36. MOVE " " TO SQ-OPROD MOVE PROD1 TO SM-KPROD MOVE " " TO SM-KCUS.
    START SALSUM KEY>=SM-KP REGARDLESS INVALID GO SQ38.
SQ37. READ SALSUM NEXT REGARDLESS END GO SQ38. IF SM-PROD>PROD2 GO SQ38.
    IF NOT(SM-CUS>=CUS1 AND<=CUS2) GO SQ37.
    IF SM-PROD NOT=SQ-OPROD IF SQ-OPROD>" " PERFORM SQ-LINE 3 TIMES END-IF
      MOVE SM-PROD TO SQ-OPROD PERFORM SQ-P PERFORM SQ-LINE.
    MOVE SM-CUS TO SQ-OCUS PERFORM SQ-C PERFORM SQ-D GO SQ37.
SQ38.

SQ39. PERFORM CLOSE-PR GO SQ9.

SQ40. PERFORM OPEN-PR PERFORM SQ-PAGE.
    MOVE LOW-VALUES TO SQ-LTOTALS SQ-ATOTALS MOVE " " TO SQ-OCUS.
    MOVE CUS1 TO SM-CUS MOVE " " TO SM-PROD.
    START SALSUM KEY>=SM-KEY REGARDLESS INVALID GO SQ49.
SQ43. READ SALSUM NEXT REGARDLESS END GO SQ49. IF SM-CUS>CUS2 GO SQ49.
    IF NOT(SM-PROD>=PROD1 AND<=PROD2) GO SQ43.
    IF SM-CUS NOT=SQ-OCUS IF SQ-OCUS>" " PERFORM SQ-L END-IF MOVE SM-CUS TO SQ-OCUS.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      ADD SM-QTY(IX1) TO SQ-LTOT(1,IX1) SQ-ATOT(1,IX1)
      ADD SM-AMT(IX1) TO SQ-LTOT(2,IX1) SQ-ATOT(2,IX1) END-PERFORM.
    GO SQ43.
SQ49. PERFORM SQ-L PERFORM SQ-LINE.
    MOVE "*** GRAND TOTALS" TO PREC PERFORM PR-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE SQ-ATOT(1,IX1) TO FF138(IX1) MOVE SQ-ATOT(2,IX1) TO FF139(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-PR GO SQ9.

SQ50. PERFORM RDR-INFO.
    MOVE SQ-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO SQ-YCUR COMPUTE SQ-YPREV=SQ-YCUR - 1.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO SQ514.
SQ513. READ CUSTOMER NEXT REGARDLESS END GO SQ514.
    MOVE 0 TO C-TOT-TMP(1) C-TOT-TMP(2) C-TOT-TMP(3).
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER GO SQ513.
SQ514. MOVE LOW-VALUES TO SQ-CTOTALS SQ-GTOTALS MOVE " " TO SQ-OCUS.
    MOVE " " TO SH-KEY START SALHIST KEY>SH-KEY REGARDLESS INVALID GO SQ518.
SQ515. READ SALHIST NEXT REGARDLESS END GO SQ518. IF SH-CAT>=90 GO SQ515.
    MOVE SH-DATE TO D-DATE PERFORM D-NM IF NOT(D-YEAR=SQ-YCUR OR SQ-YPREV) GO SQ515.
    IF SH-CUS NOT=SQ-OCUS IF SQ-OCUS>" " PERFORM SQ-CT END-IF MOVE SH-CUS TO SQ-OCUS.
    MOVE SH-AMT TO WD1.
    IF SQ-KM=0 AND SH-US=1 MOVE SH-DATE TO D-DATE MOVE WD1 TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO WD1.
    MOVE SH-DATE TO D-DATE.
    IF D-MM=SQ-MM AND D-YY=SQ-YY ADD WD1 TO SQ-CTOT(1) ROUNDED SQ-GTOT(1) ROUNDED.
    IF D-MM<=SQ-MM
      IF D-YY=SQ-YY ADD WD1 TO SQ-CTOT(2) ROUNDED SQ-GTOT(2) ROUNDED
        ELSE ADD WD1 TO SQ-CTOT(3) ROUNDED SQ-GTOT(3) ROUNDED.
    GO SQ515.
SQ518. PERFORM SQ-CT PERFORM OPEN-PR.

    MOVE 1 TO SQ-STEP PERFORM OPEN-SORT.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO SQ522.
SQ521. READ CUSTOMER NEXT REGARDLESS END GO SQ522.
    MOVE C-CLASS TO A-A1 PERFORM SQ-CC IF A-N1=0 GO SQ521.
    PERFORM INIT-SR MOVE A-N1 TO SR-F92 PERFORM SQ-AC.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM SQ-AC REWRITE SR-RECORD.
    GO SQ521.
SQ522. PERFORM SQ-PAGE.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO SQ524.
SQ523. READ SORTFL NEXT END GO SQ524.
    MOVE SR-F92 TO A-N1 PERFORM SQ-CD MOVE A-A1 TO FG341.
    COMPUTE FG342 ROUNDED=100 * SR-F94 / SQ-GTOT(3) SIZE ERROR CONTINUE.
    COMPUTE FG343 ROUNDED=100 * SR-F93 / SQ-GTOT(2) SIZE ERROR CONTINUE.
    MOVE SR-F93 TO FG344.
    COMPUTE FG345 ROUNDED=100 * (SR-F93 - SR-F94) / SR-F94 SIZE ERROR CONTINUE.
    PERFORM SQ-LINE GO SQ523.
SQ524. PERFORM CLOSE-SORT.

    MOVE 2 TO SQ-STEP PERFORM OPEN-SORT.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO SQ532.
SQ531. READ CUSTOMER NEXT REGARDLESS END GO SQ532. IF C-TOT-TMP(2)<=0 GO SQ531.
    PERFORM INIT-SR IF C-IRS>" " MOVE C-IRS TO SR-F97 ELSE MOVE C-NO TO SR-F97.
    MOVE C-NO TO SR-F98 PERFORM SQ-AT.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM SQ-AT REWRITE SR-RECORD.
    GO SQ531.
SQ532. PERFORM OPEN-REP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO SQ534.
SQ533. READ SORTFL NEXT END GO SQ534. PERFORM INIT-RP.
    MOVE SR-F99(2) TO WN1 IF WN1<0 MOVE 0 TO WN1.
    COMPUTE RP-F164=999999999 - WN1 MOVE SR-F98 TO RP-F165.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SR-F99(IX1) TO RP-F166(IX1) END-PERFORM.
    WRITE RP-RECORD GO SQ533.
SQ534. PERFORM SQ-PAGE MOVE LOW-VALUES TO SQ-STOTALS MOVE 0 TO SQ-NUM.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SQ539.
SQ535. READ REPFL NEXT END GO SQ539. MOVE RP-F165 TO C-NO READ CUSTOMER REGARDLESS.
    ADD 1 TO SQ-NUM IF SQ-NUM>25 GO SQ539. MOVE SQ-NUM TO FG347 MOVE C-NAME TO FG348.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE RP-F166(IX1) TO FG349(IX1)
      ADD RP-F166(IX1) TO SQ-STOT(IX1) END-PERFORM.
    COMPUTE FG350 ROUNDED=100 * (RP-F166(2) - RP-F166(3)) / RP-F166(3) SIZE ERROR CONTINUE.
    PERFORM SQ-LINE GO SQ535.
SQ539. MOVE 2 TO WS-PR MOVE "** TOTAL" TO FG348.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SQ-STOT(IX1) TO FG349(IX1) END-PERFORM.
    COMPUTE FG350 ROUNDED=100 * (SQ-STOT(2) - SQ-STOT(3)) / SQ-STOT(3) SIZE ERROR CONTINUE.
    PERFORM SQ-LINE.
    COMPUTE DSP-N21 ROUNDED=100 * SQ-STOT(2) / SQ-GTOT(2) SIZE ERROR MOVE 0 TO DSP-N21.
    MOVE 3 TO WS-PR STRING "THESE 25 CUSTOMERS REPRESENT " DSP-N21
      "% OF THE YTD SALES" DELIMITED SIZE INTO PREC PERFORM SQ-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT.

    MOVE 3 TO SQ-STEP PERFORM OPEN-REP.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO SQ542.
SQ541. READ CUSTOMER NEXT REGARDLESS END GO SQ542.
    IF SQ-CLASS>" " AND NOT=C-CLASS OR C-TOT-TMP(2)<=0 GO SQ541.
    PERFORM INIT-RP MOVE C-CLASS TO A-A1 PERFORM SQ-CC.
    IF C-NO<="07500" MOVE 1 TO WN1 ELSE IF C-NO<="15000" MOVE 2 TO WN1 ELSE MOVE 0 TO WN1.
    COMPUTE RP-F233=A-N1 * 10 + WN1.
    MOVE C-TOT-TMP(2) TO WN1 IF WN1<0 MOVE 0 TO WN1.
    COMPUTE RP-F234=999999999 - WN1 MOVE C-NO TO RP-F235.
    WRITE RP-RECORD GO SQ541.
SQ542. IF SQ-KT=0 PERFORM SQ-PAGE.
    MOVE LOW-VALUES TO SQ-RTOTALS SQ-STOTALS MOVE 0 TO SQ-NUM OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SQ549.
SQ543. READ REPFL NEXT END GO SQ549. MOVE RP-F235 TO C-NO READ CUSTOMER REGARDLESS.
    IF RP-F233=OLD-N GO SQ544. IF OLD-N NOT=0 PERFORM SQ-ST.
    IF SQ-KT=1 OR WS-LINES>43 PERFORM SQ-PAGE.
    MOVE RP-F233 TO OLD-N DIVIDE OLD-N BY 10 GIVING A-N1 REMAINDER WN1.
    PERFORM SQ-CD MOVE " " TO WA1 WA2.
    IF WN1=1 MOVE "US" TO WA1. IF WN1=2 MOVE "CDN" TO WA1. IF WN1=3 MOVE "EXPORT" TO WA1.
    STRING A-A1 DELIMITED "  " " - " DELIMITED SIZE WA1 DELIMITED " " INTO WA2.
    MOVE WA2 TO FG352 PERFORM SQ-LINE 2 TIMES.
SQ544. ADD 1 TO SQ-NUM.
    IF SQ-NUM<=10 OR SQ-KT=1 MOVE C-NAME TO FG352
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE C-TOT-TMP(IX1) TO FG353(IX1) END-PERFORM
      COMPUTE FG354 ROUNDED=100 * (C-TOT-TMP(2) - C-TOT-TMP(3)) / C-TOT-TMP(3) SIZE ERROR CONTINUE END-COMPUTE
      PERFORM SQ-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 ADD C-TOT-TMP(IX1) TO SQ-RTOT(IX1)
      IF SQ-NUM<=10 ADD C-TOT-TMP(IX1) TO SQ-STOT(IX1) END-IF END-PERFORM.
    GO SQ543.
SQ549. PERFORM SQ-ST MOVE 2 TO WS-PR MOVE "*** TOTAL" TO FG352.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SQ-GTOT(IX1) TO FG353(IX1) END-PERFORM.
    COMPUTE FG354 ROUNDED=100 * (SQ-GTOT(2) - SQ-GTOT(3)) / SQ-GTOT(3) SIZE ERROR CONTINUE.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP.

    MOVE 4 TO SQ-STEP PERFORM OPEN-SORT.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO SQ552.
SQ551. READ CUSTOMER NEXT REGARDLESS END GO SQ552. IF C-PROV=0 OR 99 GO SQ551.
    PERFORM INIT-SR.
    IF C-PROV<=59 MOVE 1 TO SR-F121 MOVE 0 TO SR-F122
      ELSE IF C-PROV<=74 MOVE 0 TO SR-F121 MOVE C-PROV TO SR-F122
        ELSE MOVE 2 TO SR-F121 MOVE 0 TO SR-F122.
    PERFORM SQ-AP.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM SQ-AP REWRITE SR-RECORD.
    GO SQ551.
SQ552. PERFORM SQ-PAGE MOVE LOW-VALUES TO SQ-GTOTALS.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO SQ554.
SQ553. READ SORTFL NEXT END GO SQ554.
    IF SR-F121=0 MOVE 12 TO T-TBL MOVE SR-F122 TO T-NO
      PERFORM RD-TBL MOVE T-LINE TO FG355.
    IF SR-F121=1 MOVE 2 TO WS-PR MOVE "UNITED STATES" TO FG355.
    IF SR-F121=2 MOVE 2 TO WS-PR MOVE "OTHER COUNTRIES" TO FG355.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE SR-F123(IX1) TO FG355A(IX1) ADD SR-F123(IX1) TO SQ-GTOT(IX1) END-PERFORM.
    PERFORM SQ-LINE GO SQ553.
SQ554. MOVE 3 TO WS-PR MOVE "GRAND TOTALS" TO FG355.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SQ-GTOT(IX1) TO FG355A(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR GO SQ9.

SQ60. PERFORM OPEN-REP MOVE " " TO SQ-OPROD.
    MOVE " " TO SH-KP START SALHIST KEY>SH-KP REGARDLESS INVALID GO SQ629.
SQ623. READ SALHIST NEXT REGARDLESS END GO SQ629. IF SH-CAT>=90 GO SQ623.
    MOVE SH-DATE TO D-DATE PERFORM D-NM.
    IF D-YEAR=SQ-YPREV MOVE 1 TO SQ-IXY
      ELSE IF D-YEAR=SQ-YCUR MOVE 2 TO SQ-IXY ELSE GO SQ623.
    IF NOT(D-MM>=SQ-MM1 AND<=SQ-MM2) GO SQ623.
    IF SH-KPROD=SQ-OPROD IF SQ-KS=1 GO SQ626 ELSE GO SQ628.
    MOVE SH-KPROD TO SQ-OPROD P-NO READ PRODUCT REGARDLESS INVALID GO SQ628. PERFORM RD-GEN.
    PERFORM GET-OP IF A-S1=1 GO SQ628.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT.
    MOVE LOW-VALUES TO SQ-PTBL MOVE 1 TO IX1 MOVE 0 TO IX2 SQ-KS.
SQ6243. IF OP-OPER(IX1)=0 GO SQ6244.
    MOVE OP-OPER(IX1) TO M-NO READ MACHINE REGARDLESS INVALID GO SQ6244.
    IF M-PLT-IND=0 OR IX2=3 GO SQ6244.
    ADD 1 TO IX2 MOVE OP-OPER(IX1) TO SQ-PCODE(IX2).
    IF OP-COST(IX1)>0 MOVE OP-COST(IX1) TO CST-WAMT MOVE OP-CMODE(IX1) TO A-A1
      ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    PERFORM COST-M COMPUTE SQ-PCOST(IX2) ROUNDED=CST-WAMT * CST-MULT.
SQ6244. ADD 1 TO IX1 IF IX1<=12 GO SQ6243. IF IX2=0 GO SQ628. MOVE 1 TO SQ-KS.
SQ626. PERFORM INIT-RP MOVE SQ-PCODE(1) TO RP-F341 MOVE P-NO TO RP-F342.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE SQ-PCODE(IX1) TO RP-F347(IX1) MOVE SQ-PCOST(IX1) TO RP-F348(IX1) END-PERFORM.
    MOVE SH-AMT TO WD1.
    IF SH-US=1 MOVE SH-DATE TO D-DATE MOVE WD1 TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO WD1.
    PERFORM SQ-AW.
    WRITE RP-RECORD INVALID READ REPFL PERFORM SQ-AW REWRITE RP-RECORD.
SQ628. GO SQ623.
SQ629. PERFORM OPEN-PR PERFORM SQ-PAGE.

    MOVE LOW-VALUES TO SQ-PTOTALS SQ-ZTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SQ69.
SQ63. READ REPFL NEXT END GO SQ69. IF RP-F341=OLD-N GO SQ64.
    IF OLD-N NOT=0 PERFORM SQ-PS.
    MOVE "PROCESS" TO FD420 MOVE RP-F341 TO FD421 OLD-N A-N1 PERFORM RD-MAC.
    MOVE M-OPDESC TO FD422 MOVE M-DESC1 TO FD423 PERFORM SQ-LINE 2 TIMES.
SQ64. MOVE RP-F342 TO FD405.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE RP-F347(IX1) TO SQ-PCODE(IX1) MOVE RP-F348(IX1) TO SQ-PCOST(IX1) END-PERFORM.

    MOVE 1 TO SQ-IXY.
SQ65. MOVE RP-F346(SQ-IXY) TO FD407(SQ-IXY) MOVE RP-F344(SQ-IXY) TO FD408(SQ-IXY).
    MOVE RP-F344(SQ-IXY) TO SQ-PNET(SQ-IXY).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      COMPUTE SQ-PPLAT(SQ-IXY,IX1) ROUNDED=SQ-PCOST(IX1) * RP-F345(SQ-IXY) / 1000
      SUBTRACT SQ-PPLAT(SQ-IXY,IX1) FROM SQ-PNET(SQ-IXY) END-PERFORM.
    MOVE SQ-PCODE(1) TO FD409(SQ-IXY) MOVE SQ-PPLAT(SQ-IXY,1) TO FD410(SQ-IXY).
    MOVE SQ-PNET(SQ-IXY) TO FD411(SQ-IXY).
    ADD RP-F346(SQ-IXY) TO SQ-PWTOT(SQ-IXY) SQ-ZWTOT(SQ-IXY).
    ADD RP-F344(SQ-IXY) TO SQ-PATOT(SQ-IXY) SQ-ZATOT(SQ-IXY).
    ADD SQ-PNET(SQ-IXY) TO SQ-PNTOT(SQ-IXY) SQ-ZNTOT(SQ-IXY).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      ADD SQ-PPLAT(SQ-IXY,IX1) TO SQ-PPTOT(SQ-IXY) SQ-ZPTOT(SQ-IXY) END-PERFORM.
    ADD 1 TO SQ-IXY IF SQ-IXY<=2 GO SQ65. PERFORM SQ-LINE.

    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>3 IF SQ-PCODE(IX1)>0
      PERFORM VARYING SQ-IXY FROM 1 BY 1 UNTIL SQ-IXY>2
        IF SQ-PPLAT(SQ-IXY,IX1) NOT=0 MOVE SQ-PCODE(IX1) TO FD409(SQ-IXY)
          MOVE SQ-PPLAT(SQ-IXY,IX1) TO FD410(SQ-IXY)
          END-IF END-PERFORM PERFORM SQ-LINE END-IF END-PERFORM.
    GO SQ63.
SQ69. PERFORM SQ-PS MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC PERFORM PR-LINE.
    PERFORM VARYING SQ-IXY FROM 1 BY 1 UNTIL SQ-IXY>2
      MOVE SQ-ZWTOT(SQ-IXY) TO FD407(SQ-IXY) MOVE SQ-ZATOT(SQ-IXY) TO FD408(SQ-IXY)
      MOVE SQ-ZPTOT(SQ-IXY) TO FD410(SQ-IXY) MOVE SQ-ZNTOT(SQ-IXY) TO FD411(SQ-IXY)
      END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO SQ9.

SQ9. GO MX9.

SQ-AC. ADD C-TOT-TMP(2) TO SR-F93 ADD C-TOT-TMP(3) TO SR-F94.
SQ-AT. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
        ADD C-TOT-TMP(A-X1) TO SR-F99(A-X1) END-PERFORM.
SQ-AP. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>3
        ADD C-TOT-TMP(A-X1) TO SR-F123(A-X1) END-PERFORM.
SQ-AW. ADD WD1 TO RP-F344(SQ-IXY) ADD SH-QTY TO RP-F345(SQ-IXY).
    ADD SH-WEIGHT TO RP-F346(SQ-IXY).
SQ-C. MOVE SQ-OCUS TO FF140 A-A1 PERFORM RD-CUS.
    MOVE C-NAME TO FF141 PERFORM SQ-LINE.
SQ-P. MOVE SQ-OPROD TO A-A1 PERFORM PROD-RD.
    MOVE P-NO TO FF142 MOVE PRO-DESC(1) TO FF143 PERFORM SQ-LINE.
SQ-D. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
       MOVE SM-QTY(IX1) TO FF138(IX1) MOVE SM-AMT(IX1) TO FF139(IX1) END-PERFORM.
    PERFORM SQ-LINE.
SQ-L. MOVE SQ-OCUS TO FF140 A-A1 PERFORM RD-CUS.
    MOVE C-NAME TO FF141 PERFORM PR-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE SQ-LTOT(1,IX1) TO FF138(IX1) MOVE SQ-LTOT(2,IX1) TO FF139(IX1) END-PERFORM.
    PERFORM SQ-LINE 2 TIMES MOVE LOW-VALUES TO SQ-LTOTALS.
SQ-CT. PERFORM SQ-CT1 THRU SQ-CT9.
SQ-CT1. MOVE SQ-OCUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO SQ-CT9.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SQ-CTOT(IX1) TO C-TOT-TMP(IX1) END-PERFORM.
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER MOVE LOW-VALUES TO SQ-CTOTALS.
SQ-CT9. EXIT.
SQ-ST. MOVE 2 TO WS-PR.
    IF SQ-NUM>10 MOVE "** TOP 10 TOTAL" TO FG352
      PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SQ-STOT(IX1) TO FG353(IX1) END-PERFORM
      COMPUTE FG354 ROUNDED=100 * (SQ-STOT(2) - SQ-STOT(3)) / SQ-STOT(3) SIZE ERROR CONTINUE END-COMPUTE
      PERFORM PR-LINE.
    MOVE "** CATEGORY TOTAL" TO FG352.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE SQ-RTOT(IX1) TO FG353(IX1) END-PERFORM.
    COMPUTE FG354 ROUNDED=100 * (SQ-RTOT(2) - SQ-RTOT(3)) / SQ-RTOT(3) SIZE ERROR CONTINUE.
    PERFORM SQ-LINE 3 TIMES MOVE LOW-VALUES TO SQ-RTOTALS SQ-STOTALS MOVE 0 TO SQ-NUM.
SQ-CC. EVALUATE TRUE
      WHEN A-A1="W" MOVE 1 TO A-N1
      WHEN A-A1="T" MOVE 2 TO A-N1
      WHEN A-A1="O" MOVE 3 TO A-N1
      WHEN A-A1="D" MOVE 4 TO A-N1
      WHEN A-A1="A" MOVE 5 TO A-N1
      WHEN OTHER MOVE 0 TO A-N1.
SQ-CD. EVALUATE TRUE
      WHEN A-N1=1 MOVE "AUTOMOTIVE" TO A-A1
      WHEN A-N1=2 MOVE "TIER 1" TO A-A1
      WHEN A-N1=3 MOVE "OEM" TO A-A1
      WHEN A-N1=4 MOVE "DISTRIBUTOR" TO A-A1
      WHEN A-N1=5 MOVE "AFFILIATES" TO A-A1
      WHEN OTHER MOVE " " TO A-A1.
SQ-PS. MOVE 2 TO WS-PR MOVE "** TOTALS" TO PREC.
    PERFORM VARYING SQ-IXY FROM 1 BY 1 UNTIL SQ-IXY>2
      MOVE SQ-PWTOT(SQ-IXY) TO FD407(SQ-IXY) MOVE SQ-PATOT(SQ-IXY) TO FD408(SQ-IXY)
      MOVE SQ-PPTOT(SQ-IXY) TO FD410(SQ-IXY) MOVE SQ-PNTOT(SQ-IXY) TO FD411(SQ-IXY)
      END-PERFORM.
    PERFORM SQ-LINE 2 TIMES MOVE LOW-VALUES TO SQ-PTOTALS.
SQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM SQ-PAGE.
SQ-PAGE. PERFORM SQ-P1 THRU SQ-P9.
SQ-P1. GO SQ-P2 SQ-P2 SQ-P6 SQ-P8  DEPENDING SEL-N.
SQ-P2. MOVE "SALES SUMMARY REPORT" TO FF3.
    IF Y1 IF SQ-KP=0 MOVE "** BY CUSTOMER **" TO FF4
            ELSE MOVE "** BY PRODUCT **" TO FF4.
    IF Y2 MOVE "** BY CUSTOMER - TOTALS ONLY **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF Y1 IF SQ-KP=0 PERFORM PRANGE-CUS MOVE 1 TO WS-PR PERFORM PRANGE-PROD
            ELSE PERFORM PRANGE-PROD MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    IF Y2 PERFORM PRANGE-CUS MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    MOVE "               QTY - .... - AMT         QTY - .... - AMT         QTY - .... - AMT         QTY - .... - AMT         QTY - .... - AMT" TO PREC.
*         ......  ................................
*         ............  ................................
*                    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...    ..,...,... ..,...,...
    MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>5
      MOVE D-YEAR TO FF137(PR-IX1) SUBTRACT 1 FROM D-YEAR END-PERFORM.
    PERFORM PR-LINE-3 GO SQ-P9.
SQ-P6. STRING "SALES SUMMARY  (" DELIMITED SIZE D-MTHNM(SQ-MM) DELIMITED " "
      " " SQ-YCUR ")" DELIMITED SIZE INTO FF3Y PERFORM PR-PAGE-80 MOVE 1 TO WS-PR.
    IF SQ-KM=0 MOVE "FOREIGN EXCHANGE INCLUDED" TO PREC ELSE MOVE "FOREIGN EXCHANGE NOT INCLUDED" TO PREC.
    PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF SQ-STEP=1 MOVE "SUMMARY BY CATEGORY" TO PREC PERFORM PR-LINE-2
      MOVE
         "CATEGORY      .... % TOTAL    .... % TOTAL    .... SALES   % CHANGE" TO PREC
*         ...........      ...:.           ...:.       ...,...,...      ...-
      MOVE SQ-YPREV TO FG338 MOVE SQ-YCUR TO FG339 FG340 PERFORM PR-LINE-3.
    IF SQ-STEP=2 MOVE "TOP 25 CUSTOMERS YTD" TO PREC PERFORM PR-LINE-2
      MOVE
         "RANK  CUSTOMER                           CURR MTH    CURR YTD   PRIOR YTD   %CHG" TO PREC PERFORM PR-LINE-3.
*         ..   ................................ ...,...,...-...,...,...-...,...,...-  ...-
    IF SQ-STEP=3
      MOVE
         "CATEGORY                            CURR MTH    CURR YTD   PRIOR YTD   %CHG" TO PREC PERFORM PR-LINE-3.
*         ................................ ...,...,...-...,...,...-...,...,...-  ...-
    IF SQ-STEP=4 MOVE "SUMMARY BY PROVINCE" TO PREC PERFORM PR-LINE-2
      MOVE
         "PROVINCE                         CURR MTH    CURR YTD   PRIOR YTD" TO PREC PERFORM PR-LINE-3.
*         .........................     ...,...,...-...,...,...-...,...,...-
    GO SQ-P9.
SQ-P8. MOVE "SALES ANALYSIS BY PLATING PROCESS" TO FF3 PERFORM PR-PAGE.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>2
      MOVE ALL "-" TO FD414(A-X1) FD419(A-X1) MOVE D-MTHNM(SQ-MM1) TO FD415(A-X1)
      MOVE "-" TO FD416(A-X1) MOVE D-MTHNM(SQ-MM2) TO FD417(A-X1) END-PERFORM.
    MOVE SQ-YPREV TO FD418(1) MOVE SQ-YCUR TO FD418(2) PERFORM PR-LINE.
    MOVE "PRODUCT           WEIGHT       AMOUNT   PROC     PLATING       NET REV       WEIGHT       AMOUNT   PROC     PLATING       NET REV" TO PREC PERFORM PR-LINE-3.
*         ............  ..,...,...- .,...,...:..- ... .,...,...:..- .,...,...:..-  ..,...,...- .,...,...:..- ... .,...,...:..- .,...,...:..-
    GO SQ-P9.
SQ-P9. EXIT.

* Z-15 PRODUCT ALTERNATES REPORT
QG1. PERFORM RD408 PERFORM WRT IF S-BAT GO QG2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
QG2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM QG-PAGE.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO QG9.
QG3. READ PRODUCT NEXT REGARDLESS END GO QG9. IF P-GEN>" " GO QG3.
    PERFORM CHK-ALTS IF A-S1=0 GO QG3.
    PERFORM PROD-DESC MOVE P-NO TO FA725 MOVE PRO-DESC(1) TO FA726 MOVE 1 TO PR-IXP.
    MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>AL-KEY REGARDLESS INVALID GO QG6.
QG5. READ ALTERNATES NEXT REGARDLESS END GO QG6. IF AL-PROD NOT=P-NO GO QG6.
    MOVE AL-ALT TO FA727(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>6 PERFORM QG-LINE MOVE 1 TO PR-IXP. GO QG5.
QG6. IF PR-IXP>1 PERFORM QG-LINE. GO QG3.
QG9. PERFORM CLOSE-PR GO MX9.

QG-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QG-PAGE.
QG-PAGE. MOVE "PRODUCT ALTERNATES REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "PRODUCT       DESCRIPTION                         ALTERNATES" TO PREC PERFORM PR-LINE-3.
*         ............  ................................    ............  ............ (x6)

* Z-21 MONTH-END FILE UPDATE
RL1. PERFORM RD369 PERFORM WRT.
    IF S-BAT MOVE S-N1 TO RL-MM MOVE S-N2 TO RL-YY GO RL2.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-MM TO RL-MM MOVE D-YY TO RL-YY.
RL11. DISPLAY RL-MM LINE 3 COLUMN 23 CONVERSION.
    ACCEPT RL-MM LINE 3 COLUMN 23 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY RL-MM LINE 3 COLUMN 23 CONVERSION.
    IF RL-MM=0 OR>12 PERFORM DSP-ERR2 GO RL11. IF RL-MM NOT=12 GO RL14.
RL13. DISPLAY RL-YY LINE 3 COLUMN 46 CONVERSION.
    ACCEPT RL-YY LINE 3 COLUMN 46 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY RL-YY LINE 3 COLUMN 46 CONVERSION.
    MOVE D-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR1.
    MOVE RL-YY TO D-Y1 PERFORM D-YCONV.
    IF NOT(D-Y1=D-YEAR1 OR D-YEAR1 - 1) PERFORM DSP-ERR2 GO RL13.
RL14. MOVE RL-YY TO DSP-F21 DSP-F22 IF RL-MM=12 ADD 1 TO DSP-F22.
    IF RL-MM=12 MOVE 1 TO IX1 ELSE COMPUTE IX1=RL-MM + 1.
    DISPLAY "FROM " LINE 3 COLUMN 58 D-MTHNM(RL-MM)(1:3) BOLD " " DSP-F21 BOLD
      " TO " D-MTHNM(IX1)(1:3) BOLD " " DSP-F22 BOLD.
    ACCEPT PR-NUM LINE 5 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE RL-MM TO S-N1 MOVE RL-YY TO S-N2 GO MX9.
RL2. PERFORM DSP-WAIT PERFORM OPEN-PR.

* note 98.2
    MOVE " " TO A-A1 STRING LIT-LOGFL ".*" DELIMITED SIZE INTO A-A1.
    CALL "LIB$DELETE_FILE" USING DESCRIPTOR A-A1.

* MTD sales totals update
* note 224
    PERFORM RD-INFO.
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>5
      MOVE IF-SALMTD(IX1) TO IF-SAV-SAL(IX1 - 1) END-PERFORM.
    IF INUT MOVE IF-SALMTD(6) TO IF-SAV-SAL(5).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8 MOVE 0 TO IF-SALMTD(IX1) END-PERFORM.
    MOVE IF-SALMTD-IG TO IF-SAV-SAL-IG MOVE 0 TO IF-SALMTD-IG.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE IF-USALMTD(IX1) TO IF-SAV-USAL(IX1) MOVE 0 TO IF-USALMTD(IX1) END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      SUBTRACT IF-SAV-USAL(IX1) FROM IF-SAV-SAL(IX1) END-PERFORM.
    PERFORM WR-INFO.

* customer file update
    MOVE " " TO C-NO START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO RL239.
RL233. READ CUSTOMER NEXT REGARDLESS END GO RL239.
    ADD C-90 TO C-120 MOVE C-60 TO C-90 MOVE C-30 TO C-60 MOVE C-CUR TO C-30.
    MOVE 0 TO C-CUR C-MTD.
    IF RL-MM=12 MOVE C-LAST TO C-BLAST MOVE C-YTD TO C-LAST MOVE 0 TO C-YTD
      PERFORM VARYING IX1 FROM 3 BY -1 UNTIL IX1=1
        MOVE C-PAY-NUM(IX1 - 1) TO C-PAY-NUM(IX1)
        MOVE C-PAY-DAYS(IX1 - 1) TO C-PAY-DAYS(IX1) END-PERFORM
      MOVE 0 TO C-PAY-NUM(1) C-PAY-DAYS(1).
    REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER GO RL233.
RL239.

* product file update
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO RL249.
RL243. READ PRODUCT NEXT REGARDLESS END GO RL249.
    IF P-PREV NOT=0 MOVE P-PREV TO WN1 ELSE MOVE P-LAST TO WN1.
    IF P-LAST NOT=0 MOVE P-LAST TO WN2 ELSE MOVE P-EST TO WN2.
    IF P-YTD NOT=0 COMPUTE WN3 ROUNDED=P-YTD / RL-MM
      ELSE COMPUTE WN3 ROUNDED=P-LAST / 12.
    IF P-LEVEL=0 COMPUTE P-ROP ROUNDED=WN1 / 12 + P-LAST / 12 + WN3.
    IF P-LEVEL=1 COMPUTE P-ROP ROUNDED=P-EST / 12 + WN2 / 12 + WN3
      IF RL-MM=12 MOVE 0 TO P-LEVEL.
    IF P-LEVEL=2 COMPUTE P-ROP ROUNDED=P-EST / 4
      IF RL-MM=12 MOVE 1 TO P-LEVEL.
    IF P-LEVEL=0 MOVE 0 TO P-EST.

    MOVE 0 TO P-MTD P-W-MTD P-A-MTD.
    IF RL-MM=12 MOVE P-LAST TO P-PREV MOVE P-YTD TO P-LAST
      MOVE P-BEG-HAND(2) TO P-BEG-HAND(3) MOVE P-BEG-HAND(1) TO P-BEG-HAND(2)
      MOVE P-HAND TO P-BEG-HAND(1) MOVE 0 TO P-YTD P-W-YTD P-A-YTD.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT GO RL243.
RL249.

* part file update (after p-rop calculation)
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO RL254.
RL253. READ PART NEXT REGARDLESS END GO RL254.
    PERFORM PART-TYPE IF PART-MAT MOVE 0 TO PH-ROP. MOVE 0 TO PH-MTD PH-AMTD.
    IF RL-MM=12 MOVE PH-YTD TO PH-LAST MOVE PH-AYTD TO PH-ALAST
      MOVE PH-BEG-HAND(2) TO PH-BEG-HAND(3) MOVE PH-BEG-HAND(1) TO PH-BEG-HAND(2)
      MOVE 0 TO PH-YTD PH-AYTD COMPUTE PH-BEG-HAND(1)=PH-HAND + PH-ASM-HAND.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO RL253.
RL254. MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO RL259.
RL255. READ PRODUCT NEXT REGARDLESS END GO RL259.
    IF P-MAC=99 OR NOT(P-CAT>=1 AND<=21) GO RL255.
    PERFORM SET-PART MOVE PART-NO TO PH-NO READ PART REGARDLESS INVALID GO RL255.
    MOVE P-ROP TO A-N1 PERFORM CALC-GWEIGHT ADD A-N1 TO PH-ROP.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO RL255.
RL259.

* subcon file reduction
    MOVE 1 TO RL-STEP PERFORM RL-PAGE OPEN I-O SUBCON ALLOWING ALL.
    MOVE RL-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE RL-MM TO D-MM.
    PERFORM D-MTHS COMPUTE RL-MTHS=D-N1 - 1 MOVE 1 TO PR-IXP MOVE " " TO RL-OA.
RL261. MOVE RL-OA TO SJ-KEY MOVE 0 TO RL-IXD.
    START SUBCON KEY>SJ-KEY REGARDLESS INVALID GO RL269.
RL263. READ SUBCON NEXT REGARDLESS END GO RL269. MOVE SJ-KEY TO RL-OA.
    MOVE SJ-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS IF D-N1>=RL-MTHS GO RL263.
    IF SJ-IBUCKETS=SJ-BUCKETS DELETE SUBCON ADD 1 TO RL-IXD
      IF RL-IXD=100 CLOSE SUBCON OPEN I-O SUBCON ALLOWING ALL GO RL261 END-IF GO RL263.
    MOVE SJ-MAC TO FA394(PR-IXP) MOVE SJ-MO TO FA395(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>6 PERFORM RL-LINE 2 TIMES MOVE 1 TO PR-IXP. GO RL263.
RL269. PERFORM PR-LASTLN CLOSE SUBCON PERFORM PR-RESET.

* subinv file reduction
    OPEN I-O SUBINV ALLOWING ALL MOVE " " TO RL-OA.
RL271. MOVE RL-OA TO SL-KEY MOVE 0 TO RL-IXD.
    START SUBINV KEY>SL-KEY REGARDLESS INVALID GO RL279.
RL273. READ SUBINV NEXT REGARDLESS END GO RL279. MOVE SL-KEY TO RL-OA.
    IF SL-IND=0 GO RL273. DELETE SUBINV ADD 1 TO RL-IXD.
    IF RL-IXD=100 CLOSE SUBINV OPEN I-O SUBINV ALLOWING ALL GO RL271. GO RL273.
RL279. CLOSE SUBINV.

* labels file reduction
* note 53
    MOVE RL-YY TO D-YY MOVE RL-MM TO D-MM MOVE 1 TO D-DD.
    PERFORM D-MN MOVE D-DATE TO RL-DATE MOVE " " TO RL-OA MOVE 0 TO WN1 WS1.
RL281. MOVE RL-OA TO LA-KL MOVE 0 TO RL-IXD.
    START LABELS KEY>LA-KL REGARDLESS INVALID GO RL289.
RL283. READ LABELS NEXT REGARDLESS END GO RL289. MOVE LA-KL TO RL-OA.
    IF LA-LOT=WN1 GO RL284. MOVE LA-LOT TO WN1 MOVE 0 TO WS1.
RL284. IF 999999 - LA-ZDATE>RL-DATE MOVE 1 TO WS1. IF WS1=1 GO RL283.
    DELETE LABELS ADD 1 TO RL-IXD.
    IF RL-IXD=100 CLOSE LABELS OPEN I-O LABELS ALLOWING ALL GO RL281. GO RL283.
RL289.

* traudit file reduction
    PERFORM OPEN-TRAUDIT MOVE " " TO RL-OA.
RL621. MOVE RL-OA TO YT-KEY MOVE 0 TO RL-IXD.
    START TRAUDIT KEY>YT-KEY REGARDLESS INVALID GO RL629.
RL623. READ TRAUDIT NEXT REGARDLESS END GO RL629. MOVE YT-KEY TO RL-OA.
    MOVE YT-CUS TO TR-CUS MOVE YT-INV TO TR-INV.
    READ TRANS REGARDLESS INVALID GO RL626. IF TR-AMT=0 GO RL626. GO RL623.
RL626. DELETE TRAUDIT ADD 1 TO RL-IXD.
    IF RL-IXD=100 CLOSE TRAUDIT PERFORM OPEN-TRAUDIT GO RL621. GO RL623.
RL629. CLOSE TRAUDIT.

* audit file reduction
    PERFORM OPEN-AUDIT.
    MOVE RL-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE RL-MM TO D-MM.
    PERFORM D-MTHS MOVE D-N1 TO RL-MTHS MOVE " " TO RL-OA.
RL631. MOVE RL-OA TO AU-KEY MOVE 0 TO RL-IXD.
    START AUDIT KEY>AU-KEY REGARDLESS INVALID GO RL639.
RL633. READ AUDIT NEXT REGARDLESS END GO RL639. MOVE AU-KEY TO RL-OA.
    MOVE AU-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS IF D-N1>=RL-MTHS GO RL633.
    DELETE AUDIT ADD 1 TO RL-IXD.
    IF RL-IXD=100 CLOSE AUDIT PERFORM OPEN-AUDIT GO RL631. GO RL633.
RL639. CLOSE AUDIT.

* partrans file reduction
    MOVE RL-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE RL-MM TO D-MM.
    PERFORM D-MTHS COMPUTE RL-MTHS=D-N1 - 2 MOVE " " TO RL-OA.
RL711. MOVE RL-OA TO PT-KEY MOVE 0 TO RL-IXD.
    START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO RL719.
RL713. READ PARTRANS NEXT REGARDLESS END GO RL719. MOVE PT-KEY TO RL-OA.
    MOVE PT-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS IF D-N1>=RL-MTHS GO RL713.
    DELETE PARTRANS ADD 1 TO RL-IXD.
    IF RL-IXD=100 CLOSE PARTRANS OPEN I-O PARTRANS ALLOWING ALL GO RL711. GO RL713.
RL719.

* prodtrans file reduction
    MOVE RL-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE RL-MM TO D-MM.
    PERFORM D-MTHS COMPUTE RL-MTHS=D-N1 - 2 MOVE " " TO RL-OA.
RL721. MOVE RL-OA TO PE-KEY MOVE 0 TO RL-IXD.
    START PRODTRANS KEY>PE-KEY REGARDLESS INVALID GO RL729.
RL723. READ PRODTRANS NEXT REGARDLESS END GO RL729. MOVE PE-KEY TO RL-OA.
    MOVE PE-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS IF D-N1>=RL-MTHS GO RL723.
    DELETE PRODTRANS ADD 1 TO RL-IXD.
    IF RL-IXD=100 CLOSE PRODTRANS OPEN I-O PRODTRANS ALLOWING ALL GO RL721. GO RL723.
RL729.

* tmpurord/tmpurlin files reduction
    OPEN I-O TMPURORD ALLOWING ALL TMPURLIN ALLOWING ALL MOVE " " TO RL-OA.
RL731. MOVE RL-OA TO YOK-KEY MOVE 0 TO RL-IXD.
    START TMPURORD KEY>YOK-KEY REGARDLESS INVALID GO RL739.
RL733. READ TMPURORD NEXT REGARDLESS END GO RL739. MOVE YOK-KEY TO RL-OA.
    IF YOK-PR NOT=1 GO RL733. DELETE TMPURORD.
    MOVE YOK-ORD TO YLK-ORD MOVE YOK-SEQ TO YLK-SEQ MOVE 0 TO YLK-LINE.
    START TMPURLIN KEY>YLK-KEY REGARDLESS INVALID GO RL736.
RL735. READ TMPURLIN NEXT REGARDLESS END GO RL736.
    IF NOT(YLK-ORD=YOK-ORD AND YLK-SEQ=YOK-SEQ) GO RL736.
    DELETE TMPURLIN ADD 1 TO RL-IXD GO RL735.
RL736. IF RL-IXD>100 CLOSE TMPURORD TMPURLIN
        OPEN I-O TMPURORD ALLOWING ALL TMPURLIN ALLOWING ALL GO RL731.
    GO RL733.
RL739. CLOSE TMPURORD TMPURLIN.

* ackord/acklin files reduction
    COMPUTE RL-DATE=SYS-DATE - 90.
    OPEN I-O ACKORD ALLOWING ALL ACKLIN ALLOWING ALL MOVE " " TO RL-OA.
RL741. MOVE RL-OA TO AKO-KEY MOVE 0 TO RL-IXD.
    START ACKORD KEY>AKO-KEY REGARDLESS INVALID GO RL749.
RL743. READ ACKORD NEXT INTO O-RECORD REGARDLESS END GO RL749. MOVE AKO-KEY TO RL-OA.
    IF O-DATE>=RL-DATE GO RL743. DELETE ACKORD COMPUTE AKL-NO=100 * AKO-NO.
RL745. ADD 1 TO AKL-LINE READ ACKLIN REGARDLESS INVALID GO RL746.
    DELETE ACKLIN ADD 1 TO RL-IXD GO RL745.
RL746. IF RL-IXD>100 CLOSE ACKORD ACKLIN
        OPEN I-O ACKORD ALLOWING ALL ACKLIN ALLOWING ALL GO RL741.
    GO RL743.
RL749. CLOSE ACKORD ACKLIN.

* deljitex file reduction
    COMPUTE RL-DATE=SYS-DATE - 30.
    OPEN I-O DELJITEX ALLOWING ALL MOVE " " TO RL-OA.
RL751. MOVE RL-OA TO DX-KEY MOVE 0 TO RL-IXD.
    START DELJITEX KEY>DX-KEY REGARDLESS INVALID GO RL759.
RL753. READ DELJITEX NEXT REGARDLESS END GO RL759. MOVE DX-KEY TO RL-OA.
    IF DX-DATE>RL-DATE GO RL753. DELETE DELJITEX ADD 1 TO RL-IXD.
    IF RL-IXD>100 CLOSE DELJITEX OPEN I-O DELJITEX ALLOWING ALL GO RL751. GO RL753.
RL759. CLOSE DELJITEX.

* aptr file reduction
    COMPUTE RL-DATE=SYS-DATE - 90.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE AT-KEY TO RL-OA.
RL781. MOVE RL-OA TO AT-KEY MOVE 0 TO RL-IXD.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO RL784.
RL783. READ APTR NEXT REGARDLESS END GO RL784. MOVE AT-KEY TO RL-OA.
    IF AT-DUE-DATE>=RL-DATE OR AT-IND=0 GO RL783. DELETE APTR ADD 1 TO RL-IXD.
    IF RL-IXD>100 CLOSE APTR OPEN I-O APTR ALLOWING ALL GO RL781. GO RL783.
RL784.

* note 162
    IF RL-MM NOT=12 GO RL89.

* exchange rate table shift
    PERFORM RD-INFO.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE IF-EXCHX(IX1 + 1) TO IF-EXCHX(IX1) END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      MOVE 1.3333 TO IF-EXCH(5,IX1) END-PERFORM.
    ADD 1 TO IF-EXCH-YY PERFORM WR-INFO.

* vendor file update
    MOVE WS-DIV TO V-DIV MOVE 0 TO V-NO START VENDOR KEY>V-KEY REGARDLESS INVALID GO RL819.
RL813. READ VENDOR NEXT REGARDLESS END GO RL819. IF V-DIV>WS-DIV GO RL819.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      MOVE V-PUR-LAST(IX1) TO V-PUR-2(IX1) MOVE V-PUR-YTD(IX1) TO V-PUR-LAST(IX1)
      MOVE 0 TO V-PUR-YTD(IX1) V-DISC-YTD(IX1) END-PERFORM.
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR GO RL813.
RL819.

* salsum file update
    MOVE " " TO SM-KEY START SALSUM KEY>SM-KEY REGARDLESS INVALID GO RL829.
RL823. READ SALSUM NEXT REGARDLESS END GO RL829.
    PERFORM VARYING IX1 FROM 4 BY -1 UNTIL IX1=0
      MOVE SM-QTY(IX1) TO SM-QTY(IX1 + 1) MOVE SM-AMT(IX1) TO SM-AMT(IX1 + 1) END-PERFORM.
    MOVE 0 TO SM-QTY(1) SM-AMT(1).
    REWRITE SM-RECORD ALLOWING NO UNLOCK SALSUM GO RL823.
RL829.

* purlin file update
    MOVE " " TO OK-KEY START PURORD KEY>OK-KEY REGARDLESS INVALID GO RL849.
RL843. READ PURORD NEXT REGARDLESS END GO RL849. IF OK-BLANKET=0 GO RL843.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO RL846.
RL845. READ PURLIN NEXT REGARDLESS END GO RL846. IF LK-ORD NOT=OK-NO GO RL846.
    MOVE 0 TO LK-QTY-REC LK-TOTAL-REC.
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN GO RL845.
RL846. GO RL843.
RL849.

* inactive customers deletion
    MOVE 2 TO RL-STEP PERFORM RL-PAGE MOVE 1 TO PR-IXP MOVE " " TO RL-OA.
RL851. MOVE RL-OA TO C-KEY MOVE 0 TO RL-IXD.
    START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO RL859.
RL853. READ CUSTOMER NEXT REGARDLESS END GO RL859. MOVE C-KEY TO RL-OA.
    IF NOT(C-TOT=0 AND C-CUR=0 AND C-30=0 AND C-60=0 AND C-90=0 AND C-120=0
      AND C-MTD=0 AND C-YTD=0 AND C-ORD=0 AND C-LAST=0 AND C-BLAST=0) GO RL853.
    MOVE C-CRDATE TO D-DATE PERFORM D-NM IF D-YY=RL-YY GO RL853.
    INITIALIZE SH-KEY MOVE C-NO TO SH-CUS.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO RL854.
    READ SALHIST NEXT REGARDLESS END GO RL854. IF SH-CUS=C-NO GO RL853.
RL854. DELETE CUSTOMER ADD 1 TO RL-IXD.
    INITIALIZE SM-KEY MOVE C-NO TO SM-CUS MOVE SM-KEY TO RL-OB.
RL8541. MOVE RL-OB TO SM-KEY MOVE 0 TO RL-IXE.
    START SALSUM KEY>SM-KEY REGARDLESS INVALID GO RL8544.
RL8543. READ SALSUM NEXT REGARDLESS END GO RL8544. IF SM-CUS NOT=C-NO GO RL8544.
    MOVE SM-KEY TO RL-OB DELETE SALSUM ADD 1 TO RL-IXE.
    IF RL-IXE>100 CLOSE SALSUM OPEN I-O SALSUM ALLOWING ALL GO RL8541. GO RL8543.
RL8544. MOVE C-NO TO FA396(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>15 PERFORM RL-LINE 2 TIMES MOVE 1 TO PR-IXP.
    IF RL-IXD>100 CLOSE CUSTOMER OPEN I-O CUSTOMER ALLOWING ALL GO RL851. GO RL853.
RL859. PERFORM PR-LASTLN PERFORM PR-RESET.

* unmatched cuscont records deletion
    PERFORM OPEN-CUSCONT.
    MOVE " " TO CY-KEY START CUSCONT KEY>CY-KEY REGARDLESS INVALID GO RL8604.
RL8603. READ CUSCONT NEXT REGARDLESS END GO RL8604.
    MOVE CY-NO TO C-NO READ CUSTOMER REGARDLESS INVALID DELETE CUSCONT.
    GO RL8603.
RL8604. CLOSE CUSCONT.

* inactive vendors deletion
    MOVE 3 TO RL-STEP PERFORM OPEN-SORT.
    PERFORM RL-PAGE MOVE 1 TO PR-IXP MOVE " " TO RL-OA.
RL861. MOVE RL-OA TO V-KEY MOVE 0 TO RL-IXD.
    START VENDOR KEY>V-KEY REGARDLESS INVALID GO RL864.
RL863. READ VENDOR NEXT REGARDLESS END GO RL864. MOVE V-KEY TO RL-OA.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      IF NOT(V-GROSS(IX1)=0 AND V-NET(IX1)=0 AND V-PUR-YTD(IX1)=0 AND V-PUR-LAST(IX1)=0
        AND V-PUR-2(IX1)=0 AND V-DISC-YTD(IX1)=0) GO RL863 END-IF END-PERFORM.
    MOVE V-CRDATE TO D-DATE PERFORM D-NM IF D-YY=RL-YY GO RL863.
    INITIALIZE OK-KV MOVE V-NO TO OK-VENDOR.
    START PURORD KEY>OK-KV REGARDLESS INVALID GO RL8636.
    READ PURORD NEXT REGARDLESS END GO RL8636. IF OK-VENDOR=V-NO GO RL863.
RL8636. MOVE V-NO TO SR-F91 WRITE SR-RECORD INVALID CONTINUE.
    DELETE VENDOR ADD 1 TO RL-IXD MOVE V-NO TO FA397(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>20 PERFORM RL-LINE 2 TIMES MOVE 1 TO PR-IXP.
    IF RL-IXD>100 CLOSE VENDOR OPEN I-O VENDOR ALLOWING ALL GO RL861. GO RL863.
RL864. PERFORM PR-LASTLN PERFORM PR-RESET.
    MOVE " " TO PH-KEY START PART KEY>PH-KEY REGARDLESS INVALID GO RL869.
RL865. READ PART NEXT REGARDLESS END GO RL869. MOVE 1 TO IX1 MOVE 0 TO WS1.
RL867. IF PH-VENDOR(IX1)=0 GO RL868.
    PERFORM INIT-SR MOVE PH-VENDOR(IX1) TO SR-F91 READ SORTFL INVALID GO RL868.
    MOVE 0 TO PH-VENDOR(IX1) PH-PRICE(IX1) MOVE 1 TO WS1.
RL868. ADD 1 TO IX1 IF IX1<=3 GO RL867.
    IF WS1=1 REWRITE PH-RECORD ALLOWING NO UNLOCK PART. GO RL865.
RL869. PERFORM CLOSE-SORT.

* inactive parts deletion
    MOVE 4 TO RL-STEP PERFORM RL-PAGE MOVE 1 TO PR-IXP MOVE " " TO RL-OA.
RL871. MOVE RL-OA TO PH-KEY MOVE 0 TO RL-IXD.
    START PART KEY>PH-KEY REGARDLESS INVALID GO RL878.
RL873. READ PART NEXT REGARDLESS END GO RL878. MOVE PH-KEY TO RL-OA.
    IF PH-CAT=501 GO RL873.
    IF NOT(PH-HAND=0 AND PH-ORDER=0 AND PH-DEMAND=0 AND PH-MTD=0 AND PH-YTD=0
      AND PH-LAST=0 AND PH-AMTD=0 AND PH-AYTD=0 AND PH-ALAST=0) GO RL873.
    MOVE PH-CRDATE TO D-DATE PERFORM D-NM IF D-YY=RL-YY GO RL873.
    PERFORM PART-TYPE IF PART-MAT PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      IF NOT(PH-PROC-HAND(IX1)=0 AND PH-PROC-DEMAND(IX1)=0) GO RL873 END-IF END-PERFORM.
    IF NOT PART-TOOL GO RL874. IF PH-CAT=250 GO RL873.
    INITIALIZE TP-KEY MOVE PH-NO TO TP-TOOL.
    START TOOLPROD KEY>TP-KEY REGARDLESS INVALID GO RL874.
    READ TOOLPROD NEXT REGARDLESS END GO RL874. IF TP-TOOL=PH-NO GO RL873.
RL874. INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PH-NO TO PU-PART.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO RL876.
    READ PURHIST NEXT REGARDLESS END GO RL876.
    IF NOT(PU-DIV=WS-DIV AND PU-PART=PH-NO) GO RL876.
    MOVE RL-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR1.
    COMPUTE D-DATE=999999 - PU-ZDATE PERFORM D-NM IF D-YEAR>=D-YEAR1 - 2 GO RL873.
RL876. DELETE PART ADD 1 TO RL-IXD.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PH-NO TO PU-PART MOVE PU-KEY TO RL-OB.
RL8761. MOVE RL-OB TO PU-KEY MOVE 0 TO RL-IXE.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO RL8764.
RL8763. READ PURHIST NEXT REGARDLESS END GO RL8764.
    IF NOT(PU-DIV=WS-DIV AND PU-PART=PH-NO) GO RL8764. MOVE PU-KEY TO RL-OB.
    DELETE PURHIST ADD 1 TO RL-IXE.
    IF RL-IXE>100 CLOSE PURHIST OPEN I-O PURHIST ALLOWING ALL GO RL8761. GO RL8763.
RL8764. MOVE PH-NO TO FG356(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM RL-LINE 2 TIMES MOVE 1 TO PR-IXP.
    IF RL-IXD>100 CLOSE PART OPEN I-O PART ALLOWING ALL GO RL871. GO RL873.
RL878. PERFORM PR-LASTLN PERFORM PR-RESET.

    MOVE RL-YY TO D-YY PERFORM UPDATE-TOOL-LIFE.

* inactive products deletion
* note 79
    MOVE 5 TO RL-STEP PERFORM OPEN-SORT.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE 0 TO RL-IXC(IX1) END-PERFORM.
    MOVE " " TO PRO-NSV.
RL881. MOVE PRO-NSV TO P-KEY MOVE 0 TO RL-IXD.
    START PRODUCT KEY>P-KEY REGARDLESS INVALID GO RL889.
RL883. READ PRODUCT NEXT REGARDLESS END GO RL889.
    IF P-GEN>" " OR NOT(P-CAT>=1 AND<=89) GO RL883. MOVE P-KEY TO PRO-NSV.
    MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT MOVE 0 TO RL-KD RL-NUM.
    START ALTERNATES KEY>AL-KEY REGARDLESS INVALID GO RL886.
RL885. READ ALTERNATES NEXT REGARDLESS END GO RL886. IF AL-PROD NOT=P-NO GO RL886.
    MOVE AL-ALT TO P-NO READ PRODUCT REGARDLESS INVALID GO RL8858.
    PERFORM RL-CHK IF A-S1=1 ADD 1 TO RL-NUM MOVE "A" TO A-A1 PERFORM RL-DEL
      DELETE PRODUCT DELETE ALTERNATES ADD 1 TO RL-IXD
     ELSE MOVE 1 TO RL-KD.
RL8858. GO RL885.
RL886. MOVE PRO-NSV TO P-KEY START PRODUCT REGARDLESS INVALID GO RL8889.
    READ PRODUCT NEXT REGARDLESS END GO RL8889. IF RL-KD=1 GO RL888.
    PERFORM RL-CHK IF A-S1=1
      IF RL-NUM=0 MOVE " " TO A-A1 ELSE MOVE "G" TO A-A1 END-IF PERFORM RL-DEL
        MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT
        DELETE PRODUCT DELETE ALTERNATES ADD 1 TO RL-IXD.
RL888. IF RL-IXD>100 CLOSE PRODUCT ALTERNATES
        OPEN I-O PRODUCT ALLOWING ALL ALTERNATES ALLOWING ALL GO RL8889.
    GO RL883.
RL8889. GO RL881.
RL889. PERFORM RL-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO RL8894.
RL8893. READ SORTFL NEXT END GO RL8894.
    MOVE SR-F11 TO FA798(PR-IXP) MOVE SR-F10 TO FA799(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>6 PERFORM RL-LINE 2 TIMES MOVE 1 TO PR-IXP.
    GO RL8893.
RL8894. PERFORM PR-LASTLN PERFORM CLOSE-SORT PERFORM PR-RESET.

RL89.
RL9. PERFORM CLOSE-PR GO MX9.

RL-DEL. PERFORM RL-D1 THRU RL-D9.
RL-D1. MOVE P-NO TO SR-F10 MOVE A-A1 TO SR-F11 WRITE SR-RECORD INVALID CONTINUE.

    INITIALIZE SH-KP MOVE P-NO TO SH-KPROD MOVE SH-KP TO RL-OA.
RL-D321. MOVE RL-OA TO SH-KP MOVE 0 TO RL-IXE.
    START SALHIST KEY>SH-KP REGARDLESS INVALID GO RL-D324.
RL-D323. READ SALHIST NEXT REGARDLESS END GO RL-D324. IF SH-KPROD NOT=P-NO GO RL-D324.
    MOVE SH-KP TO RL-OA DELETE SALHIST ADD 1 TO RL-IXE.
    IF RL-IXE>100 CLOSE SALHIST OPEN I-O SALHIST ALLOWING ALL GO RL-D321. GO RL-D323.
RL-D324.

    INITIALIZE SM-KP MOVE P-NO TO SM-KPROD MOVE SM-KP TO RL-OA.
RL-D331. MOVE RL-OA TO SM-KP MOVE 0 TO RL-IXE.
    START SALSUM KEY>SM-KP REGARDLESS INVALID GO RL-D334.
RL-D333. READ SALSUM NEXT REGARDLESS END GO RL-D334. IF SM-KPROD NOT=P-NO GO RL-D334.
    MOVE SM-KP TO RL-OA DELETE SALSUM ADD 1 TO RL-IXE.
    IF RL-IXE>100 CLOSE SALSUM OPEN I-O SALSUM ALLOWING ALL GO RL-D331. GO RL-D333.
RL-D334.

    MOVE P-NO TO OP-PROD MOVE 0 TO OP-MAC.
    START OPERATIONS KEY>=OP-KEY REGARDLESS INVALID GO RL-D42.
RL-D41. READ OPERATIONS NEXT REGARDLESS END GO RL-D42. IF OP-PROD NOT=P-NO GO RL-D42.
    DELETE OPERATIONS ADD 1 TO RL-IXC(1) GO RL-D41.
RL-D42. IF RL-IXC(1)>100
      CLOSE OPERATIONS OPEN I-O OPERATIONS ALLOWING ALL MOVE 0 TO RL-IXC(1).
    MOVE P-NO TO TS-PROD MOVE 0 TO TS-MAC.
    START TOOLS KEY>=TS-KEY REGARDLESS INVALID GO RL-D48.
RL-D45. READ TOOLS NEXT REGARDLESS END GO RL-D48. IF TS-PROD NOT=P-NO GO RL-D48.
    DELETE TOOLS ADD 1 TO RL-IXC(2) PERFORM TL-SET-TYPE MOVE 1 TO TL-IXA.
RL-D47. IF TS-TOOL(TL-IXA)>" " MOVE TS-TOOL(TL-IXA) TO TP-TOOL
      MOVE TS-PROD TO TP-PROD MOVE TS-MAC TO TP-MAC MOVE TL-IXA TO TP-FLD
      DELETE TOOLPROD INVALID CONTINUE.
    ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO RL-D47.
    CLOSE TOOLPROD OPEN I-O TOOLPROD ALLOWING ALL GO RL-D45.
RL-D48. IF RL-IXC(2)>100 CLOSE TOOLS OPEN I-O TOOLS ALLOWING ALL MOVE 0 TO RL-IXC(2).
    MOVE P-NO TO CU-PROD DELETE COSTHIST INVALID CONTINUE. ADD 1 TO RL-IXC(3).
    IF RL-IXC(3)>100 CLOSE COSTHIST OPEN I-O COSTHIST ALLOWING ALL MOVE 0 TO RL-IXC(3).
RL-D9. EXIT.
RL-CHK. PERFORM RL-C1 THRU RL-C9.
RL-C1. MOVE 0 TO A-S1.
    IF NOT(P-HAND=0 AND P-ORDER=0 AND P-TORDER=0 AND P-PROCESS=0 AND P-DEMAND=0
      AND P-FDEMAND=0 AND P-YTD=0 AND P-LAST=0 AND P-PREV=0) GO RL-C9.
    MOVE P-CRDATE TO D-DATE PERFORM D-NM IF D-YY=RL-YY GO RL-C9.
    MOVE P-NO TO SM-KPROD MOVE " " TO SM-KCUS.
    START SALSUM KEY>=SM-KP REGARDLESS INVALID GO RL-C4.
RL-C3. READ SALSUM NEXT REGARDLESS END GO RL-C4. IF SM-KPROD NOT=P-NO GO RL-C4.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>5
      IF NOT(SM-QTY(A-X1)=0 AND SM-AMT(A-X1)=0) GO RL-C9 END-IF END-PERFORM.
    GO RL-C3.
RL-C4. MOVE 1 TO A-S1.
RL-C9. EXIT.
RL-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RL-PAGE.
RL-PAGE. IF RL-MM=12 MOVE "MONTH-END / YEAR-END FILE UPDATE REPORT" TO FF3
      ELSE MOVE "MONTH-END FILE UPDATE REPORT" TO FF3.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    EVALUATE TRUE
      WHEN RL-STEP=1 MOVE "OLD SUBCONTRACTOR RECORDS THAT COULD NOT BE DELETED BY THE SYSTEM (UNEQUAL IN/OUT BUCKETS)" TO PREC
      WHEN RL-STEP=2 MOVE "INACTIVE CUSTOMERS DELETED BY THE SYSTEM" TO PREC
      WHEN RL-STEP=3 MOVE "INACTIVE VENDORS DELETED BY THE SYSTEM" TO PREC
      WHEN RL-STEP=4 MOVE "INACTIVE PARTS DELETED BY THE SYSTEM" TO PREC
      WHEN RL-STEP=5 MOVE "INACTIVE PRODUCTS DELETED BY THE SYSTEM" TO PREC
      WHEN OTHER CONTINUE.
    PERFORM PR-LINE-3.

* Z-22 AUDIT LISTING
QA1. PERFORM RD249 PERFORM WRT IF S-BAT GO QA2.
    PERFORM AX-SEL IF SEL-N=0 OR>10 GO MX1.
    MOVE 15 TO IXT MOVE 47 TO IXU PERFORM AX-DT-INV MOVE DATE0 TO DATE1.
    IF DATE1>0 MOVE 66 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO DATE2.
    MOVE 17 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
QA2. PERFORM DSP-WAIT PERFORM OPEN-AUDIT PERFORM OPEN-PR PERFORM QA-PAGE.
    IF Y3 PERFORM OPEN-REP. MOVE LOW-VALUES TO QA-CTOTALS.

    INITIALIZE AU-KEY MOVE SEL-N TO AU-K.
    START AUDIT KEY>AU-KEY REGARDLESS INVALID GO QA8.
QA3. READ AUDIT NEXT REGARDLESS END GO QA8. IF AU-K>SEL-N GO QA8.
    IF NOT(DATE1=0 AND AU-IND=0 OR (AU-DATE>=DATE1 AND<=DATE2)) GO QA3.
    GO QA310 QA320 QA330 QA340 QA350 QA360 QA370 QA380 QA390 QA400  DEPENDING SEL-N.
    GO QA3.
QA310. MOVE AU-DATA TO TD-INP-R1.
    MOVE "BUCKET:" TO FA383 MOVE IE11 TO FA384 MOVE "WEIGHT:" TO FA385 MOVE IE12 TO FA386.
    MOVE "M.O.:" TO FA387 MOVE IE13 TO FA388 MOVE IE14 TO FA389.
    PERFORM QA-LINE 2 TIMES GO QA6.
QA320. MOVE AU-DATA TO TD-INP-R2.
    MOVE IE21 TO FF318 MOVE IE22 TO FF319 MOVE IE23 TO FF320.
    MOVE IE24 TO D-DATE PERFORM D-NM MOVE D-DT TO FF321.
    MOVE IE25 TO FF322 MOVE IE26 TO FF323 MOVE IE27 TO FF324 MOVE IE28 TO FF325.
    PERFORM QA-LINE 2 TIMES GO QA6.
QA330. MOVE AU-DATA TO TD-INP-R3 PERFORM INIT-RP.
    MOVE IE31 TO RP-F466 MOVE IE32 TO RP-F467 MOVE 0 TO RP-F468.
    MOVE IE33 TO RP-F469 MOVE IE34 TO RP-F470 MOVE IE35 TO RP-F471.
    MOVE IE36 TO RP-F472 MOVE IE37 TO RP-F473.
QA333. WRITE RP-RECORD INVALID ADD 1 TO RP-F468 GO QA333. GO QA6.
QA340. MOVE AU-DATA TO TD-INP-R4.
    MOVE IE41 TO FD109 MOVE "M.O.:" TO FD110 MOVE IE42 TO FD110A.
    MOVE "PROD:" TO FD111 MOVE IE43 TO FD111A MOVE "LOT:" TO FD112 MOVE IE44 TO FD112A.
    MOVE "FROM:" TO FD113 MOVE IE45 TO FD113A MOVE "TO:" TO FD114 MOVE IE46 TO FD114A.
    MOVE "CTNS:" TO FD115 MOVE IE47 TO FD115A MOVE "QTY:" TO FD116 MOVE IE48 TO FD116A.
    MOVE "QTY/CTN:" TO FD117 MOVE IE49 TO FD117A MOVE IE49A TO FD117B.
    PERFORM QA-LINE 2 TIMES GO QA6.
QA350. MOVE AU-DATA TO TD-INP-R5.
    MOVE IE51 TO FF86 MOVE "PROD:" TO FF87 MOVE IE52 TO FF87A.
    MOVE "FROM:" TO FF88 MOVE IE53 TO FF88A MOVE "TO:" TO FF89 MOVE IE54 TO FF89A.
    MOVE "QTY:" TO FF90 MOVE IE55 TO FF90A MOVE "P.O.:" TO FF91 MOVE IE55A TO FF91A.
    IF IE52A=1 PERFORM QA-LINE
      MOVE "PROC:" TO FF96 MOVE IE56 TO FF96A MOVE "COILS:" TO FF97 MOVE IE57 TO FF97A
      MOVE "AVG WEIGHT:" TO FF98 MOVE IE58 TO FF98A MOVE "HEAT:" TO FF99 MOVE IE59 TO FF99A.
    PERFORM QA-LINE 2 TIMES GO QA6.
QA360. IF AU-L NOT=0 GO QA366. MOVE 3 TO WS-PR MOVE AU-DATA TO TD-INP-R6.
    MOVE "B/L." TO FD165 MOVE IE601 TO FD166 MOVE "ORD." TO FD167 MOVE IE602 TO FD168.
    MOVE "VIA" TO FD169 MOVE IE603 TO FD170 MOVE "PACKING" TO FD175.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 MOVE IE605(IX1) TO FD176(IX1) END-PERFORM.
    MOVE "PALLETS" TO FD177 MOVE IE607 TO FD178.
    PERFORM QA-LINE MOVE "STATE" TO FD191 MOVE IE608 TO FD192.
    MOVE "PORT" TO FD193 MOVE IE610 TO FD194 MOVE "BORDER" TO FD195 MOVE IE612 TO FD196.
    PERFORM QA-LINE 2 TIMES GO QA6.
QA366. MOVE AU-DATA TO TD-INP-R6A.
    MOVE "PROD." TO FD181 MOVE IE621 TO FD182 MOVE "EXCEPTIONS:" TO FD183.
    PERFORM QA-LINE MOVE 1 TO IX1 IX2.
QA367. IF IE623(IX1)=" " GO QA368. MOVE IE623(IX1) TO FD187(IX2).
    MOVE IE624(IX1) TO FD188(IX2) MOVE IE625(IX1) TO FD189(IX2).
    MOVE IE626(IX1) TO FD190(IX2).
    ADD 1 TO IX1 IX2 IF IX2=4 PERFORM QA-LINE MOVE 1 TO IX2. IF IX1<=23 GO QA367.
QA368. PERFORM QA-LINE 2 TIMES GO QA6.
QA370. MOVE AU-DATA TO TD-INP-R7.
    IF IE72="YES" MOVE "CORR**" TO FD121.
    MOVE "ORD." TO FD122 MOVE IE71 TO FD123 MOVE "PROD." TO FD124 MOVE IE73 TO FD125.
    MOVE "QTY." TO FD126 MOVE IE74 TO FD127.
    MOVE "DATE" TO FD129 MOVE IE76 TO D-DATE PERFORM D-NM MOVE D-DT TO FD129A.
    MOVE "SPEC. ORDER" TO FD130 MOVE IE77 TO FD130A MOVE "-" TO FD130B.
    MOVE IE78 TO FD130C PERFORM QA-LINE.
    MOVE "ADJ ORD" TO FD118(1) MOVE IE79(1) TO FD119(1).
    MOVE "ADJ PRD" TO FD118(2) MOVE IE79(2) TO FD119(2).
    MOVE "ADJ LFT" TO FD118(3) MOVE IE79(3) TO FD119(3).
    PERFORM QA-LINE 2 TIMES GO QA6.
QA380. MOVE AU-DATA TO TD-INP-R8.
    MOVE "M.O.:" TO FD46 MOVE IE81 TO FD47 MOVE "PROC:" TO FD48 MOVE IE82 TO FD49.
    MOVE "USER:" TO FD50 MOVE IE83 TO FD51.
    IF IE84=0 MOVE "QTY ACCEPTED/PRIMARY:" TO FD52 ELSE MOVE "WEIGHT ACCEPTED/PRIMARY:" TO FD52.
    MOVE IE85 TO FD53 MOVE "/" TO FD54 MOVE IE86 TO FD55.
    PERFORM QA-LINE 2 TIMES GO QA6.
QA390. MOVE AU-DATA TO TD-INP-R9.
    MOVE "CHQ NO.:" TO FD425 MOVE IE91 TO FD426 MOVE IE92 TO FD427.
    IF IE93=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1. MOVE LIT-CUR(IX1) TO FD428.
    MOVE "DATE:" TO FD429 MOVE IE94 TO FD429A MOVE "VENDOR:" TO FD429B MOVE IE95 TO FD429C.
    ADD IE92 TO QA-CT(IX1) PERFORM QA-LINE 2 TIMES GO QA6.
QA400. MOVE AU-DATA TO TD-INP-R10.
    MOVE "CHQ NO.:" TO FD430 MOVE IE101 TO FD431 MOVE IE102 TO FD432.
    IF IE103=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1. MOVE LIT-CUR(IX1) TO FD433.
    ADD IE102 TO QA-CT(IX1) PERFORM QA-LINE 2 TIMES GO QA6.

QA6. MOVE 1 TO AU-IND REWRITE AU-RECORD ALLOWING NO UNLOCK AUDIT GO QA3.

QA8. IF NOT Y3 GO QA88. MOVE LOW-VALUES TO QA-STOTALS QA-GTOTALS MOVE " " TO OLD-C.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO QA84.
QA83. READ REPFL NEXT END GO QA84. IF RP-F466=OLD-C GO QA834.
    IF OLD-C NOT=" " PERFORM QA-T.
    MOVE RP-F466 TO FD100 OLD-C A-A1 PERFORM RD-CUS MOVE C-NAME TO FD101.
QA834. MOVE RP-F467 TO FD102 MOVE RP-F469 TO FD103 MOVE RP-F470 TO FD104.
    IF RP-F471="YES" MOVE "*" TO FD105.
    MOVE RP-F472 TO D-DATE PERFORM D-NM MOVE D-DT TO FD106.
    IF RP-F473=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1 MOVE "*" TO FD107.
    ADD RP-F469 TO QA-SA(IX1) QA-GA(IX1) ADD RP-F470 TO QA-SD(IX1) QA-GD(IX1).
    PERFORM QA-LINE GO QA83.
QA84. PERFORM QA-T MOVE "*** GRAND TOTALS" TO FD101.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2 MOVE LIT-CUR(IX1) TO FD101A
      MOVE QA-GA(IX1) TO FD103 MOVE QA-GD(IX1) TO FD104 PERFORM PR-LINE END-PERFORM.
    PERFORM CLOSE-REP GO QA9.

QA88. IF Y9 OR Y10 MOVE 2 TO WS-PR PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
       MOVE "** TOTAL" TO FD97 MOVE LIT-CUR(IX1) TO FD98 MOVE QA-CT(IX1) TO FD99
       PERFORM PR-LINE END-PERFORM.
QA9. CLOSE AUDIT PERFORM CLOSE-PR GO MX9.

QA-T. MOVE "**  CUST TOTALS" TO FD101 MOVE "**" TO FD108.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      IF QA-SA(IX1) NOT=0 MOVE LIT-CUR(IX1) TO FD101A
        MOVE QA-SA(IX1) TO FD103 MOVE QA-SD(IX1) TO FD104
        PERFORM PR-LINE END-IF END-PERFORM.
    PERFORM QA-LINE MOVE LOW-VALUES TO QA-STOTALS.
QA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QA-PAGE.
QA-PAGE. MOVE "AUDIT FILE LISTING" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** BUCKET UPDATE **" TO FF4
      WHEN Y2 MOVE "** Q BINS MAINTENANCE **" TO FF4
      WHEN Y3 MOVE "** CASH RECEIPTS **" TO FF4
      WHEN Y4 MOVE "** INVENTORY UPDATE **" TO FF4
      WHEN Y5 MOVE "** STOCK UPDATE (PURCHASING) **" TO FF4
      WHEN Y6 MOVE "** BILLS OF LADING **" TO FF4
      WHEN Y7 MOVE "** PRODUCTION ORDERS ENTRY **" TO FF4
      WHEN Y8 MOVE "** WORKSHEET QTY/WEIGHT ERROR OVERRIDE **" TO FF4
      WHEN Y9 MOVE "** CASHED CHEQUES **" TO FF4
      WHEN Y10 MOVE "** CANCELED CHEQUES **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    IF DATE1>0 MOVE "RANGE SELECTED:" TO A-A1 PERFORM PRANGE-DATE.
    IF Y3 MOVE
         "CUST    NAME                             INVOICE       AMOUNT    DIFF  NEW  EFF DATE  US" TO PREC PERFORM PR-LINE-3
*         ......  ................................ ...... ..,...,...:..- ...:..-  .   ../../..  . ..
      ELSE PERFORM PR-LINE.

    REPLACE ==ACC-ALP== BY ==DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION==
            ==ACC-ZNUM== BY ==DEFAULT ZERO UNDERLINED PROTECTED CONVERSION==.
* Z-23 TABLES MAINTENANCE AND LISTING
TB1. PERFORM RD95 PERFORM WRT.
    ACCEPT TB-SEL LINE 3 COLUMN 13 ACC-ZNUM KEY CKEY.
    IF KPF4 OR TB-SEL=99 GO TB9. PERFORM DSP-CLS.
    GO TB10 TB20 TB30 TB40 TB50 TB60 TB70 TB80  DEPENDING TB-SEL. GO TB1.

TB10. DISPLAY " GENERAL TABLES MAINTENANCE " LINE 1 REVERSED.
    PERFORM TB-TDSP.
TB13. DISPLAY "TABLE (1 - 24): __" LINE 13 BOLD ERASE END SCREEN.
    MOVE ALL "0" TO T-RECORD ACCEPT T-TBL LINE 13 COLUMN 17 ACC-ZNUM.
    IF T-TBL=0 OR>24 GO TB19. DISPLAY TBF-DESC(T-TBL) LINE 13 COLUMN 25 BOLD.
TB15. DISPLAY "ENTRY (1 - 999): ___" LINE 15 BOLD ERASE END SCREEN.
    ACCEPT T-NO LINE 15 COLUMN 18 ACC-ZNUM IF T-NO=0 GO TB13.
    MOVE ALL "0" TO T-LINE EVALUATE TRUE
      WHEN T-TBL=5 GO TB1640
      WHEN T-TBL=6 GO TB1660
      WHEN T-TBL=7 GO TB1620
      WHEN T-TBL=11 GO TB1670
      WHEN T-TBL=14 GO TB1680
      WHEN T-TBL=16 GO TB1650
      WHEN T-TBL=22 GO TB1610
      WHEN T-TBL=24 GO TB1630
      WHEN OTHER CONTINUE.
    READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY T-LINE LINE 15 COLUMN 25 BOLD.
    ACCEPT T-LINE LINE 16 COLUMN 25 ACC-ALP.
    IF T-LINE=ALL "0" DELETE TABLES ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1610. READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY T-GP1 LINE 15 COLUMN 25 CONVERSION BOLD.
    DISPLAY T-GP1 LINE 16 COLUMN 25 CONVERSION.
    ACCEPT T-GP1 LINE 16 COLUMN 25 ACC-NUM.
    DISPLAY T-GP1 LINE 16 COLUMN 25 CONVERSION.
    IF T-GP1=0 DELETE TABLES ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1620. READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY T-GH1 LINE 15 COLUMN 25 CONVERSION BOLD T-GH2 COLUMN 33 CONVERSION BOLD
      T-GH3 COLUMN 38 CONVERSION BOLD.
    DISPLAY T-GH1 LINE 16 COLUMN 25 CONVERSION.
    ACCEPT T-GH1 LINE 16 COLUMN 25 ACC-NUM.
    DISPLAY T-GH1 LINE 16 COLUMN 25 CONVERSION.
    DISPLAY T-GH2 LINE 16 COLUMN 33 CONVERSION.
    ACCEPT T-GH2 LINE 16 COLUMN 33 ACC-NUM.
    DISPLAY T-GH2 LINE 16 COLUMN 33 CONVERSION.
    DISPLAY T-GH3 LINE 16 COLUMN 38 CONVERSION.
    ACCEPT T-GH3 LINE 16 COLUMN 38 ACC-NUM.
    DISPLAY T-GH3 LINE 16 COLUMN 38 CONVERSION.
    IF T-GH1=0 AND T-GH2=0 AND T-GH3=0 DELETE TABLES
      ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1630. MOVE T-NO TO T-PCN MOVE " " TO T-PCD MOVE "." TO T-PCX1 T-PCX2 T-PCX3.
* note 202
    READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY "CHARACTERISTIC DESCRIPTION       INSTRUMENT CODE    UNIT CODE   SAMPLE PLAN" LINE 17 BOLD.
*            ...............................         ..              ..          ...
    DISPLAY T-PCD LINE 18 COLUMN 1 BOLD T-PCI COLUMN 41 CONVERSION BOLD
      T-PCU COLUMN 57 CONVERSION BOLD T-PCS COLUMN 69 CONVERSION BOLD.
    ACCEPT T-PCD LINE 19 COLUMN 1 ACC-ALP.
    DISPLAY T-PCI LINE 19 COLUMN 41 CONVERSION.
    ACCEPT T-PCI LINE 19 COLUMN 41 ACC-NUM.
    DISPLAY T-PCI LINE 19 COLUMN 41 CONVERSION.
    DISPLAY T-PCU LINE 19 COLUMN 57 CONVERSION.
    ACCEPT T-PCU LINE 19 COLUMN 57 ACC-NUM.
    DISPLAY T-PCU LINE 19 COLUMN 57 CONVERSION.
    DISPLAY T-PCS LINE 19 COLUMN 69 CONVERSION.
    ACCEPT T-PCS LINE 19 COLUMN 69 ACC-NUM.
    DISPLAY T-PCS LINE 19 COLUMN 69 CONVERSION.
    IF T-PCD=" " AND T-PCI=0 AND T-PCU=0 AND T-PCS=0 DELETE TABLES
      ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1640. READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY T-OPM LINE 15 COLUMN 25 CONVERSION BOLD.
    DISPLAY T-OPM LINE 16 COLUMN 25 CONVERSION.
    ACCEPT T-OPM LINE 16 COLUMN 25 ACC-NUM.
    DISPLAY T-OPM LINE 16 COLUMN 25 CONVERSION.
    IF T-OPM=0 DELETE TABLES ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1650. INITIALIZE T-TE1 T-TE2.
    READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY "DAYS  TERMS" LINE 17 BOLD.
*             ..   .........................
    DISPLAY T-TE1 LINE 18 COLUMN 2 CONVERSION BOLD T-TE2 COLUMN 7 BOLD.
    DISPLAY T-TE1 LINE 19 COLUMN 2 CONVERSION.
    ACCEPT T-TE1 LINE 19 COLUMN 2 ACC-NUM.
    DISPLAY T-TE1 LINE 19 COLUMN 2 CONVERSION.
    ACCEPT T-TE2 LINE 19 COLUMN 7 ACC-ALP.
    IF T-TE1=0 AND T-TE2=" " DELETE TABLES
      ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1660. READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    MOVE 25 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      DISPLAY T-DIS(IX1) LINE 15 COLUMN IXU CONVERSION BOLD
        T-DIS(IX1) LINE 16 COLUMN IXU CONVERSION ADD 5 TO IXU END-PERFORM.
    MOVE 25 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      ACCEPT T-DIS(IX1) LINE 16 COLUMN IXU ACC-NUM
      DISPLAY T-DIS(IX1) LINE 16 COLUMN IXU ADD 5 TO IXU END-PERFORM.
    IF T-DIS(1)=0 AND T-DIS(2)=0 AND T-DIS(3)=0 AND T-DIS(4)=0 DELETE TABLES
      ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1670. INITIALIZE T-PLR T-PLS.
    READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY T-PLR LINE 15 COLUMN 25 CONVERSION BOLD T-PLS COLUMN 34 BOLD.
    DISPLAY T-PLR LINE 16 COLUMN 25 CONVERSION.
    ACCEPT T-PLR LINE 16 COLUMN 25 ACC-NUM.
    DISPLAY T-PLR LINE 16 COLUMN 25 CONVERSION.
    ACCEPT T-PLS LINE 16 COLUMN 34 ACC-ALP.
    IF T-PLR=0 AND T-PLS=" " DELETE TABLES
      ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB1680. INITIALIZE T-CTA T-CTN T-CTX.
    READ TABLES REGARDLESS INVALID WRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    DISPLAY "ABBREV CODE   COUNTRY" LINE 17 BOLD.
*                ...       ....................
    DISPLAY T-CTA LINE 18 COLUMN 5 BOLD T-CTN COLUMN 15 BOLD.
    ACCEPT T-CTA LINE 19 COLUMN 5 ACC-ALP.
    ACCEPT T-CTN LINE 19 COLUMN 15 ACC-ALP.
    IF T-CTA=" " AND T-CTN=" " DELETE TABLES
      ELSE REWRITE T-RECORD ALLOWING NO UNLOCK TABLES.
    GO TB18.
TB18. GO TB15.
TB19. GO TB9.

TB20. DISPLAY " GENERAL TABLES LISTING " LINE 1 REVERSED.
    PERFORM TB-TDSP.
    MOVE 13 TO IXT DISPLAY "TABLE (1 - 24): __" LINE IXT BOLD.
TB21. ACCEPT TB-TNO LINE IXT COLUMN 17 ACC-ZNUM.
    IF TB-TNO=0 OR>24 PERFORM DSP-ERR2 GO TB21.
    ADD 1 TO IXT PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM TB-TPAGE.
    MOVE TB-TNO TO T-TBL MOVE 0 TO T-NO.
    START TABLES KEY>T-KEY REGARDLESS INVALID GO TB29.
TB23. READ TABLES NEXT REGARDLESS END GO TB29. IF T-TBL>TB-TNO GO TB29.
    MOVE T-NO TO FD555 EVALUATE TRUE
      WHEN T-TBL=5 MOVE T-OPM TO FD557
      WHEN T-TBL=6 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
        MOVE T-DIS(IX1) TO FD558(IX1) END-PERFORM
      WHEN T-TBL=7 MOVE T-GH1 TO FD559 MOVE T-GH2 TO FD560 MOVE T-GH3 TO FD561
      WHEN T-TBL=11 MOVE T-PLR TO FD562 MOVE T-PLS TO FD563
      WHEN T-TBL=16 MOVE T-TE1 TO FD564 MOVE T-TE2 TO FD565
      WHEN T-TBL=22 MOVE T-GP1 TO FD566
      WHEN T-TBL=24 MOVE T-PCN TO FD567 MOVE T-PCD TO FD568 MOVE T-PCI TO FD569
        MOVE T-PCU TO FD570 MOVE T-PCS TO FD571
      WHEN OTHER MOVE T-LINE TO FD556.
    PERFORM TB-TLINE GO TB23.
TB29. PERFORM CLOSE-PR GO TB9.

TB30. PERFORM RD50 PERFORM WRT.
TB33. ACCEPT XN2 LINE 3 COLUMN 12 ACC-ZNUM KEY CKEY IF KPF4 OR XN2=0 GO TB39.
* note 256.3
    MOVE XN2 TO SV-KEY PERFORM RD-VIA.
    DISPLAY SV-CARRIER LINE 5 COLUMN 23 SV-SORT COLUMN 78 CONVERSION.
    DISPLAY SV-SCAC LINE 6 COLUMN 13 SV-METHOD COLUMN 37 SV-POOL COLUMN 56.
    DISPLAY SV-EQINIT LINE 7 COLUMN 39 SV-EQNUM COLUMN 63.
    ACCEPT SV-CARRIER LINE 5 COLUMN 23 ACC-ALP.
    ACCEPT SV-SORT LINE 5 COLUMN 78 ACC-NUM.
    DISPLAY SV-SORT LINE 5 COLUMN 78 CONVERSION.
    ACCEPT SV-SCAC LINE 6 COLUMN 13 ACC-ALP.
    ACCEPT SV-METHOD LINE 6 COLUMN 37 ACC-ALP.
    ACCEPT SV-POOL LINE 6 COLUMN 56 ACC-ALP.
    ACCEPT SV-EQINIT LINE 7 COLUMN 39 ACC-ALP.
    ACCEPT SV-EQNUM LINE 7 COLUMN 63 ACC-ALP.
    REWRITE SV-RECORD ALLOWING NO UNLOCK SHIPVIA GO TB33.
TB39. GO TB9.

TB40. DISPLAY " SHIP-VIA TABLE LISTING " LINE 1 REVERSED.
    MOVE 3 TO IXT PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM TB-SPAGE.
    MOVE 1 TO SV-KEY.
TB43. PERFORM RD-VIA MOVE SV-KEY TO FD40 MOVE SV-CARRIER TO FD41.
    MOVE SV-SORT TO FD41A MOVE SV-SCAC TO FD42 MOVE SV-METHOD TO FD43.
    MOVE SV-POOL TO FD44 MOVE SV-EQINIT TO FD45 MOVE SV-EQNUM TO FD45A.
    PERFORM TB-SLINE ADD 1 TO SV-KEY IF SV-KEY<=99 GO TB43.
TB49. PERFORM CLOSE-PR GO TB9.

TB50.
TB53. PERFORM RD62 PERFORM WRT.
    MOVE LOW-VALUES TO PK-RECORD INITIALIZE PK-REC.
    ACCEPT PK-NO LINE 3 COLUMN 16 ACC-ZNUM KEY CKEY IF KPF4 OR PK-NO=0 GO TB59.
* note 256.4
    READ PACKING REGARDLESS INVALID MOVE 0 TO TB-KFIN GO TB54. MOVE 1 TO TB-KFIN.
    DISPLAY PK-PART LINE 8 COLUMN 12.
    DISPLAY PK-DESC LINE 10 COLUMN 23.
    DISPLAY PK-PALLET LINE 12 COLUMN 23 CONVERSION.
    DISPLAY PK-MAX LINE 12 COLUMN 56 CONVERSION.
TB54.
TB55. PERFORM DSP-NEXT ACCEPT TB-OP LINE 3 COLUMN 54 ACC-ZNUM PERFORM DSP-ERS.
    IF TB-OP=0 GO TB53. IF TB-OP>3 PERFORM DSP-ERR1 GO TB55.
    IF TB-OP=1 AND TB-KFIN=1 MOVE "DUPLICATE PACKING CODE" TO ERR-MESG
      PERFORM DSP-ERR GO TB53.
    IF (TB-OP=2 OR 3) AND TB-KFIN=0 PERFORM DSP-ERR30 GO TB53.
    IF TB-OP=3 DELETE PACKING GO TB53.

* op=1,2
    ACCEPT PK-PART LINE 8 COLUMN 12 ACC-ALP.
    ACCEPT PK-DESC LINE 10 COLUMN 23 ACC-ALP.
    ACCEPT PK-PALLET LINE 12 COLUMN 23 ACC-NUM.
    DISPLAY PK-PALLET LINE 12 COLUMN 23 CONVERSION.
    ACCEPT PK-MAX LINE 12 COLUMN 56 ACC-NUM.
    DISPLAY PK-MAX LINE 12 COLUMN 56 CONVERSION.
    IF TB-OP=1 WRITE PK-RECORD ALLOWING NO ELSE REWRITE PK-RECORD ALLOWING NO.
    UNLOCK PACKING PERFORM DSP-CONT GO TB53.
TB59. GO TB9.

TB60. DISPLAY " PACKING TABLE LISTING " LINE 1 REVERSED.
    MOVE 3 TO IXT PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM TB-PPAGE.
    MOVE " " TO PK-KEY START PACKING KEY>PK-KEY REGARDLESS INVALID GO TB69.
TB63. READ PACKING NEXT REGARDLESS END GO TB69.
    MOVE PK-NO TO FF145 MOVE PK-PART TO FF146 MOVE PK-DESC TO FF147.
    MOVE PK-PALLET TO FF148 MOVE PK-MAX TO FF149 PERFORM TB-PLINE GO TB63.
TB69. PERFORM CLOSE-PR GO TB9.

TB70. OPEN I-O SALESMAN ALLOWING ALL.
TB73. PERFORM RD197 PERFORM WRT MOVE LOW-VALUES TO SN-RECORD INITIALIZE SN-REC.
    ACCEPT SN-NO LINE 3 COLUMN 16 ACC-ZNUM KEY CKEY IF KPF4 GO TB79.
    READ SALESMAN REGARDLESS INVALID MOVE 0 TO TB-KFIN GO TB74. MOVE 1 TO TB-KFIN.
    DISPLAY SN-NAME LINE 5 COLUMN 8.
    DISPLAY SN-SALCOM LINE 7 COLUMN 19 CONVERSION.
TB74.
TB75. PERFORM DSP-NEXT ACCEPT TB-OP LINE 1 COLUMN 73 ACC-ZNUM PERFORM DSP-ERS.
    IF TB-OP=0 GO TB73. IF TB-OP>3 PERFORM DSP-ERR1 GO TB75.
    IF TB-OP=1 AND TB-KFIN=1 MOVE "DUPLICATE SALESMAN NO."
      TO ERR-MESG PERFORM DSP-ERR GO TB73.
    IF (TB-OP=2 OR 3) AND TB-KFIN=0 PERFORM DSP-ERR30 GO TB73.
    IF TB-OP=3 DELETE SALESMAN GO TB73.

* op=1,2
    ACCEPT SN-NAME LINE 5 COLUMN 8 ACC-ALP KEY CKEY IF KPF3 GO TB78.
    ACCEPT SN-SALCOM LINE 7 COLUMN 19 ACC-NUM KEY CKEY IF KPF3 GO TB78.
    DISPLAY SN-SALCOM LINE 7 COLUMN 19 CONVERSION.
TB78. IF TB-OP=1 WRITE SN-RECORD ALLOWING NO ELSE REWRITE SN-RECORD ALLOWING NO.
    UNLOCK SALESMAN PERFORM DSP-CONT GO TB73.
TB79. CLOSE SALESMAN GO TB9.

TB80. DISPLAY " SALESMAN TABLE LISTING " LINE 1 REVERSED.
    MOVE 3 TO IXT PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT OPEN I-O SALESMAN ALLOWING ALL.
    PERFORM OPEN-PR PERFORM TB-NPAGE.
    MOVE " " TO SN-KEY START SALESMAN KEY>SN-KEY REGARDLESS INVALID GO TB89.
TB83. READ SALESMAN NEXT REGARDLESS END GO TB89.
    MOVE SN-NO TO FA150 MOVE SN-NAME TO FA151 MOVE SN-SALCOM TO FA151A.
    PERFORM TB-NLINE GO TB83.
TB89. CLOSE SALESMAN PERFORM CLOSE-PR GO TB9.

TB9. GO MX9.
    REPLACE OFF.

TB-TDSP. PERFORM TB-TD1 THRU TB-TD9.
TB-TD1. MOVE 3 TO IXT MOVE 1 TO A-X1 A-X2.
TB-TD3. COMPUTE IXU=1 + 24 * (A-X2 - 1) MOVE A-X1 TO DSP-N21.
    DISPLAY DSP-N21 LINE IXT COLUMN IXU "." COLUMN IXU PLUS 2 TBF-DESC(A-X1) COLUMN IXU PLUS 4.
    ADD 1 TO A-X1 A-X2 IF A-X2=4 ADD 1 TO IXT MOVE 1 TO A-X2. IF A-X1<=24 GO TB-TD3.
TB-TD9. EXIT.

TB-TLINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM TB-TPAGE.
TB-TPAGE. MOVE "GENERAL TABLES LISTING" TO FF3 MOVE TB-TNO TO DSP-N21.
    STRING "TABLE " DSP-N21 ": " TBF-DESC(TB-TNO) DELIMITED "  " INTO FF4 PERFORM PR-PAGE.
    MOVE "ENTRY  CONTENTS" TO PREC PERFORM PR-LINE-3.
*         ...    .............................................
TB-SLINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM TB-SPAGE.
TB-SPAGE. MOVE "SHIP-VIA TABLE LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE "CODE  CARRIER NAME                           SORT ORDER  SCAC CODE   METHOD CODE   POOL CODE   EQUIPMENT PREFIX - NO." TO PREC PERFORM PR-LINE-3.
*         ...   ........................................   ..        ....          ..         .......           ....      ..........
TB-PLINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM TB-PPAGE.
TB-PPAGE. MOVE "PACKING TABLE LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE "CODE  PART NO.      PACKING DESCRIPTION                         PALLET CODE    MAX. CARTONS/PALLET" TO PREC PERFORM PR-LINE-3.
*         ...   ............  ........................................        ...                ..
TB-NLINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM TB-NPAGE.
TB-NPAGE. MOVE "SALESMAN TABLE LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE "NO.  NAME                           COMMISSION" TO PREC PERFORM PR-LINE-3.
*         ..   ..............................   ..:..

* Z-24 SYSTEM FUNCTIONS
SY1. PERFORM RD96 PERFORM WRT.
    ACCEPT SY-SEL LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR SY-SEL=99 GO SY9. PERFORM DSP-CLS.
    IF SY-SEL=80 GO SY80.
    GO SY310 SY320 SY330 SY340 SY350 SY360 SY370 SY380 SY390 SY400
       SY410
      DEPENDING SY-SEL. GO SY1.

    REPLACE ==ACC-NUM== BY ==DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION==.
SY310. PERFORM RD262 PERFORM WRT PERFORM RDR-INFO.
    MOVE IF-SHP-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO DSP-DT1.
    DISPLAY DSP-DT1 LINE 3 COLUMN 21.
    IF IF-SHP-IND=0 DISPLAY "COMPLETED OK" LINE 4 COLUMN 37
      ELSE DISPLAY "NOT COMPLETED OK" LINE 4 COLUMN 37.
    ACCEPT XA3 LINE 16 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" PERFORM RD-INFO MOVE SYS-DATE TO IF-SHP-DATE PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY9.

SY320. DISPLAY " MODIFY SYSTEM-GENERATED NUMBERS " LINE 1 REVERSED.
    PERFORM RDR-INFO.
    DISPLAY "LAST ORDER NO.:" LINE 4 BOLD IF-ORDNO COLUMN 17 CONVERSION.
    DISPLAY "LAST INVOICE NO.:" LINE 6 BOLD IF-INVNO COLUMN 19 CONVERSION.
    DISPLAY "LAST BILL OF LADING NO.:" LINE 8 BOLD IF-BLNO COLUMN 26 CONVERSION.
    DISPLAY "LAST SPECIAL INVOICE NO.:" LINE 10 BOLD IF-SPINVNO COLUMN 27 CONVERSION.
    DISPLAY "LAST LABELS SERIAL NO.:" LINE 12 BOLD IF-LABNO COLUMN 25 CONVERSION.
    DISPLAY "LAST IRVINE TOOLS PURCHASE ORDER NO.:" LINE 14 BOLD IF-ITORDNO COLUMN 39 CONVERSION.
    DISPLAY "LAST MAINTENANCE ORDER NO.:" LINE 16 BOLD IF-MAINTNO COLUMN 29 CONVERSION.
    DISPLAY "LAST QUOTATION NO.:" LINE 18 BOLD IF-QUOTNO COLUMN 21 CONVERSION.

    ACCEPT IF-ORDNO LINE 4 COLUMN 17 ACC-NUM.
    DISPLAY IF-ORDNO LINE 4 COLUMN 17 CONVERSION.
    MOVE IF-ORDNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-ORDNO PERFORM WR-INFO.
    ACCEPT IF-INVNO LINE 6 COLUMN 19 ACC-NUM.
    DISPLAY IF-INVNO LINE 6 COLUMN 19 CONVERSION.
    MOVE IF-INVNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-INVNO PERFORM WR-INFO.
    ACCEPT IF-BLNO LINE 8 COLUMN 26 ACC-NUM.
    DISPLAY IF-BLNO LINE 8 COLUMN 26 CONVERSION.
    MOVE IF-BLNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-BLNO PERFORM WR-INFO.
    ACCEPT IF-SPINVNO LINE 10 COLUMN 27 ACC-NUM.
    DISPLAY IF-SPINVNO LINE 10 COLUMN 27 CONVERSION.
    MOVE IF-SPINVNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-SPINVNO PERFORM WR-INFO.
    ACCEPT IF-LABNO LINE 12 COLUMN 25 ACC-NUM.
    DISPLAY IF-LABNO LINE 12 COLUMN 25 CONVERSION.
    MOVE IF-LABNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-LABNO PERFORM WR-INFO.
    ACCEPT IF-ITORDNO LINE 14 COLUMN 39 ACC-NUM.
    DISPLAY IF-ITORDNO LINE 14 COLUMN 39 CONVERSION.
    MOVE IF-ITORDNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-ITORDNO PERFORM WR-INFO.
    ACCEPT IF-MAINTNO LINE 16 COLUMN 29 ACC-NUM.
    DISPLAY IF-MAINTNO LINE 16 COLUMN 29 CONVERSION.
    MOVE IF-MAINTNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-MAINTNO PERFORM WR-INFO.
    ACCEPT IF-QUOTNO LINE 18 COLUMN 21 ACC-NUM.
    DISPLAY IF-QUOTNO LINE 18 COLUMN 21 CONVERSION.
    MOVE IF-QUOTNO TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-QUOTNO PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY9.

SY330. DISPLAY " MODIFY SALES MTD TOTALS " LINE 1 REVERSED.
    PERFORM RDR-INFO MOVE 1 TO IX1 MOVE 4 TO IXT PERFORM UNTIL IX1>8
      DISPLAY SY-TDESC(IX1) LINE IXT BOLD IF-SALMTD(IX1) COLUMN 16 CONVERSION BOLD
      ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 1 TO IX1 MOVE 4 TO IXT PERFORM UNTIL IX1>8
      DISPLAY IF-SALMTD(IX1) LINE IXT COLUMN 32 CONVERSION
      ACCEPT IF-SALMTD(IX1) LINE IXT COLUMN 32 ACC-NUM
      DISPLAY IF-SALMTD(IX1) LINE IXT COLUMN 32 CONVERSION
      MOVE IF-SALMTD(IX1) TO WD1 PERFORM RD-INFO MOVE WD1 TO IF-SALMTD(IX1) PERFORM WR-INFO
      ADD 1 TO IX1 IXT END-PERFORM.
    PERFORM DSP-CONT GO SY9.

SY340. DISPLAY " MODIFY M.O. AUTOMATIC SEQUENCE NUMBERS " LINE 1 REVERSED.
    PERFORM RDR-INFO MOVE 4 TO IXT DISPLAY "PRODORD NUMBERS:" LINE IXT BOLD.
    ADD 1 TO IXT MOVE 1 TO IX1 IXU PERFORM UNTIL IX1>9
      DISPLAY IF-RNO(IX1) LINE IXT COLUMN IXU CONVERSION
      ADD 1 TO IX1 ADD 8 TO IXU END-PERFORM.
    MOVE 1 TO IX1 IXU PERFORM UNTIL IX1>9
      ACCEPT IF-RNO(IX1) LINE IXT COLUMN IXU ACC-NUM
      DISPLAY IF-RNO(IX1) LINE IXT COLUMN IXU CONVERSION
      MOVE IF-RNO(IX1) TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-RNO(IX1) PERFORM WR-INFO
      ADD 1 TO IX1 ADD 8 TO IXU END-PERFORM.
    PERFORM DSP-CONT GO SY9.

SY350. DISPLAY " MODIFY RAW MATERIAL ADDED VALUES AND FREIGHT RATE " LINE 1 REVERSED.
    MOVE 3 TO IXT DISPLAY
         "TYPE:                      1      2      3      4      5      6      7      8" LINE IXT BOLD.
*                                 ...:.. ...:.. ...:.. ...:.. ...:.. ...:.. ...:.. ...:..
    MOVE 5 TO IXT MOVE 25 TO IXU DISPLAY "PROCESS VALUES:" LINE IXT BOLD.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      DISPLAY IF-RMPROC(IX1) LINE IXT COLUMN IXU CONVERSION ADD 7 TO IXU END-PERFORM.
    MOVE 7 TO IXT MOVE 25 TO IXU DISPLAY "CAT 130 PROCESS VALUES:" LINE IXT BOLD.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      DISPLAY IF-RMPROC-A(IX1) LINE IXT COLUMN IXU CONVERSION ADD 7 TO IXU END-PERFORM.
    MOVE 9 TO IXT MOVE 25 TO IXU DISPLAY "CLEANING VALUES:" LINE IXT BOLD.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      DISPLAY IF-RMCLEAN(IX1) LINE IXT COLUMN IXU CONVERSION ADD 7 TO IXU END-PERFORM.
    MOVE 11 TO IXT MOVE 19 TO IXU.
    DISPLAY "FREIGHT RATE/TON:" LINE IXT BOLD IF-CST-FREIGHT COLUMN IXU CONVERSION.
    MOVE 13 TO IXT MOVE 20 TO IXU.
    DISPLAY "SURCHARGE AMT/TON:" LINE IXT BOLD IF-RMSUR COLUMN IXU CONVERSION.

    PERFORM DSP-PF3 MOVE 5 TO IXT MOVE 25 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      ACCEPT IF-RMPROC(IX1) LINE IXT COLUMN IXU ACC-NUM KEY CKEY
      DISPLAY IF-RMPROC(IX1) LINE IXT COLUMN IXU CONVERSION IF KPF3 GO SY352 END-IF
      MOVE IF-RMPROC(IX1) TO WD1 PERFORM RD-INFO MOVE WD1 TO IF-RMPROC(IX1) PERFORM WR-INFO
      ADD 7 TO IXU END-PERFORM.
SY352. MOVE 7 TO IXT MOVE 25 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      ACCEPT IF-RMPROC-A(IX1) LINE IXT COLUMN IXU ACC-NUM KEY CKEY
      DISPLAY IF-RMPROC-A(IX1) LINE IXT COLUMN IXU CONVERSION IF KPF3 GO SY354 END-IF
      MOVE IF-RMPROC-A(IX1) TO WD1 PERFORM RD-INFO MOVE WD1 TO IF-RMPROC-A(IX1) PERFORM WR-INFO
      ADD 7 TO IXU END-PERFORM.
SY354. MOVE 9 TO IXT MOVE 25 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      ACCEPT IF-RMCLEAN(IX1) LINE IXT COLUMN IXU ACC-NUM KEY CKEY
      DISPLAY IF-RMCLEAN(IX1) LINE IXT COLUMN IXU CONVERSION IF KPF3 GO SY356 END-IF
      MOVE IF-RMCLEAN(IX1) TO WD1 PERFORM RD-INFO MOVE WD1 TO IF-RMCLEAN(IX1) PERFORM WR-INFO
      ADD 7 TO IXU END-PERFORM.
SY356. PERFORM DSP-ERS MOVE 11 TO IXT MOVE 19 TO IXU.
    ACCEPT IF-CST-FREIGHT LINE IXT COLUMN IXU ACC-NUM.
    DISPLAY IF-CST-FREIGHT LINE IXT COLUMN IXU CONVERSION.
    MOVE IF-CST-FREIGHT TO WT1 PERFORM RD-INFO MOVE WT1 TO IF-CST-FREIGHT PERFORM WR-INFO.
    MOVE 13 TO IXT MOVE 20 TO IXU.
    ACCEPT IF-RMSUR LINE IXT COLUMN IXU ACC-NUM.
    DISPLAY IF-RMSUR LINE IXT COLUMN IXU CONVERSION.
    MOVE IF-RMSUR TO WT1 PERFORM RD-INFO MOVE WT1 TO IF-RMSUR PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY9.

SY360. PERFORM RD90 PERFORM WRT.
    ACCEPT XA3 LINE 9 COLUMN 29 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" OPEN OUTPUT BINALLOC ALLOWING NO CLOSE BINALLOC.
    ACCEPT XA3 LINE 10 COLUMN 37 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" OPEN OUTPUT SHIPORD ALLOWING NO SHIPLIN ALLOWING NO CLOSE SHIPORD SHIPLIN.
    ACCEPT XA3 LINE 11 COLUMN 33 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" OPEN OUTPUT CFORD ALLOWING NO CFLIN ALLOWING NO CLOSE CFORD CFLIN.
    ACCEPT XA3 LINE 12 COLUMN 27 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" OPEN OUTPUT HTRANS ALLOWING NO CLOSE HTRANS.
    ACCEPT XA3 LINE 13 COLUMN 35 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" OPEN OUTPUT TMPORD ALLOWING NO TMPLIN ALLOWING NO CLOSE TMPORD TMPLIN.
    PERFORM DSP-CONT GO SY9.

SY370. DISPLAY " MODIFY GST, HST, PST, QST RATES " LINE 1 REVERSED.
    PERFORM RDR-INFO.
    DISPLAY "GST RATE:" LINE 4 BOLD IF-GST COLUMN 11 CONVERSION.
    DISPLAY "HST RATE:" LINE 5 BOLD IF-HST COLUMN 11 CONVERSION.
    DISPLAY "PST RATE:" LINE 6 BOLD IF-PST COLUMN 11 CONVERSION.
    DISPLAY "QST RATE:" LINE 7 BOLD IF-QST COLUMN 11 CONVERSION.
    ACCEPT IF-GST LINE 4 COLUMN 11 ACC-NUM.
    DISPLAY IF-GST LINE 4 COLUMN 11 CONVERSION.
    MOVE IF-GST TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-GST PERFORM WR-INFO.
    ACCEPT IF-HST LINE 5 COLUMN 11 ACC-NUM.
    DISPLAY IF-HST LINE 5 COLUMN 11 CONVERSION.
    MOVE IF-HST TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-HST PERFORM WR-INFO.
    ACCEPT IF-PST LINE 6 COLUMN 11 ACC-NUM.
    DISPLAY IF-PST LINE 6 COLUMN 11 CONVERSION.
    MOVE IF-PST TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-PST PERFORM WR-INFO.
    ACCEPT IF-QST LINE 7 COLUMN 11 ACC-NUM.
    DISPLAY IF-QST LINE 7 COLUMN 11 CONVERSION.
    MOVE IF-QST TO WL1 PERFORM RD-INFO MOVE WL1 TO IF-QST PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY9.

SY380. PERFORM RD311 PERFORM WRT PERFORM RDR-INFO.
    MOVE IF-DEM-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 7 COLUMN 74.
    MOVE 1 TO IX1 MOVE 8 TO IXT.
    PERFORM UNTIL IX1>15 PERFORM SY-D ADD 1 TO IX1 IXT END-PERFORM.
    MOVE 1 TO IX1 MOVE 8 TO IXT.
SY381. PERFORM SY-D.
SY383. MOVE IF-OFF-DATE1(IX1) TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN 13.
    PERFORM DSP-PF3 ACCEPT D-DT LINE IXT COLUMN 13 ACC-NUM KEY CKEY PERFORM DSP-ERS.
    DISPLAY D-DT LINE IXT COLUMN 13 IF KPF3 GO SY386.
    IF D-DT>0 PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO SY383.
    PERFORM RD-INFO PERFORM D-MN MOVE D-DATE TO IF-OFF-DATE1(IX1) PERFORM WR-INFO.
SY385. MOVE IF-OFF-DATE2(IX1) TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN 33.
    ACCEPT D-DT LINE IXT COLUMN 33 ACC-NUM DISPLAY D-DT LINE IXT COLUMN 33.
    IF D-DT>0 PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO SY385.
    PERFORM RD-INFO PERFORM D-MN MOVE D-DATE TO IF-OFF-DATE2(IX1) PERFORM WR-INFO.
    IF IF-OFF-DATE1(IX1)>IF-OFF-DATE2(IX1) OR IF-OFF-DATE1(IX1)=0 AND IF-OFF-DATE2(IX1)>0
      MOVE "INVALID DATE RANGE" TO ERR-MESG PERFORM DSP-ERR PERFORM SY-E GO SY381.
    IF IF-OFF-DATE2(IX1) - IF-OFF-DATE1(IX1)>28 MOVE "DATE RANGE TOO BIG"
      TO ERR-MESG PERFORM DSP-ERR PERFORM SY-E GO SY381.
    ADD 1 TO IX1 IXT IF IX1<=15 GO SY381.
SY386.
SY387. MOVE IF-DEM-DATE TO D-DATE PERFORM D-NM DISPLAY D-DT LINE 7 COLUMN 74.
    ACCEPT D-DT LINE 7 COLUMN 74 ACC-NUM DISPLAY D-DT LINE 7 COLUMN 74.
    IF D-DT>0 PERFORM D-CHKDT IF D-ERR=1 PERFORM DSP-ERR10 GO SY387.
    PERFORM RD-INFO PERFORM D-MN MOVE D-DATE TO IF-DEM-DATE PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY9.

SY390. DISPLAY " MODIFY STEEL SURCHARGE VALUES " LINE 1 REVERSED.
    DISPLAY
         "CODE:          1     2     3     4     5     6     7     8     9" LINE 3 BOLD.
    DISPLAY
         "SURCH/LB:" LINE 4 BOLD.
*                       :...  :...  :...  :...  :...  :...  :...  :...  :...
    MOVE 4 TO IXT MOVE 15 TO IXU PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      DISPLAY IF-SURCH(IX1) LINE IXT COLUMN IXU CONVERSION ADD 6 TO IXU END-PERFORM.
    PERFORM DSP-PF3 MOVE 4 TO IXT MOVE 15 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      ACCEPT IF-SURCH(IX1) LINE IXT COLUMN IXU ACC-NUM KEY CKEY
      DISPLAY IF-SURCH(IX1) LINE IXT COLUMN IXU CONVERSION IF KPF3 GO SY392 END-IF
      MOVE IF-SURCH(IX1) TO WT1 PERFORM RD-INFO MOVE WT1 TO IF-SURCH(IX1) PERFORM WR-INFO
      ADD 6 TO IXU END-PERFORM.
SY392. PERFORM DSP-ERS.
    PERFORM DSP-CONT GO SY9.

SY400. DISPLAY " MODIFY US$ EXCHANGE RATES " LINE 1 REVERSED.
SY401. PERFORM RDR-INFO.
    MOVE IF-EXCH-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR1.
    MOVE IF-EXCH-YY TO SY-YY1 SY-YY2 ADD 4 TO SY-YY2.
    MOVE " " TO WA1 STRING "YEAR (" SY-YY1 " - " SY-YY2 "): __" DELIMITED SIZE INTO WA1.
    DISPLAY WA1(1:18) LINE 3 BOLD ERASE END SCREEN.
    ACCEPT XN2 LINE 3 COLUMN 17 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 GO SY409. MOVE XN2 TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR2.
    IF NOT(D-YEAR2>=D-YEAR1 AND<=D-YEAR1 + 4) PERFORM DSP-ERR2 GO SY401.
    COMPUTE SY-IX1=D-YEAR2 - D-YEAR1 + 1 MOVE 1 TO IX1 MOVE 5 TO IXT.
    PERFORM UNTIL IX1>12
      DISPLAY D-MTHNM(IX1)(1:3) LINE IXT BOLD ":" IF-EXCH(SY-IX1,IX1) COLUMN 8 CONVERSION
      ADD 1 TO IX1 IXT END-PERFORM.
    DISPLAY "A/P CURRENT RATE" LINE 3 COLUMN 35 BOLD.
    DISPLAY IF-EXCH-AP LINE 4 COLUMN 40 CONVERSION.
    PERFORM DSP-PF3 MOVE 1 TO IX1 MOVE 5 TO IXT.
SY403. ACCEPT IF-EXCH(SY-IX1,IX1) LINE IXT COLUMN 8 ACC-NUM KEY CKEY.
    DISPLAY IF-EXCH(SY-IX1,IX1) LINE IXT COLUMN 8 CONVERSION IF KPF3 GO SY404.
    MOVE IF-EXCH(SY-IX1,IX1) TO WV1 PERFORM RD-INFO MOVE WV1 TO IF-EXCH(SY-IX1,IX1) PERFORM WR-INFO.
    ADD 1 TO IX1 IXT IF IX1<=12 GO SY403.
SY404. PERFORM DSP-ERS.
    ACCEPT IF-EXCH-AP LINE 4 COLUMN 40 ACC-NUM.
    DISPLAY IF-EXCH-AP LINE 4 COLUMN 40 CONVERSION.
    MOVE IF-EXCH-AP TO WV1 PERFORM RD-INFO MOVE WV1 TO IF-EXCH-AP PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY401.
SY409. GO SY9.

SY410. PERFORM RD263 PERFORM WRT.
    PERFORM RDR-INFO DISPLAY IF-PRINTER LINE 11 COLUMN 19.
    DISPLAY IF-PRINTER LINE 12 COLUMN 19.
SY413. ACCEPT IF-PRINTER LINE 12 COLUMN 19 ACC-NUM.
    DISPLAY IF-PRINTER LINE 12 COLUMN 19.
    IF NOT(IF-PRINTER=0 OR 1) PERFORM DSP-ERR2 GO SY413.
    ACCEPT XA3 LINE 15 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE IF-PRINTER TO WN1 PERFORM RD-INFO MOVE WN1 TO IF-PRINTER PERFORM WR-INFO.
    PERFORM DSP-CONT GO SY9.
    REPLACE OFF.

SY80. PERFORM RD413 PERFORM WRT.
SY81. PERFORM RD413A PERFORM WRT.
    ACCEPT US-USER LINE 3 COLUMN 8 DEFAULT " " UNDERLINED PROTECTED EDITING KEY CKEY.
    IF KPF4 OR US-USER=" " OR ALL "9" GO SY89.
    ACCEPT XN1 LINE 3 COLUMN 37 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    GO SY810 SY820 SY830 SY840  DEPENDING XN1. GO SY81.

SY810. READ USERS REGARDLESS INVALID GO SY812. PERFORM DSP-ERR33 GO SY819.
* note 41
SY812. MOVE US-USER TO WA1 MOVE 1 TO US-NUM WN1.
    START USERS KEY>=US-KN REGARDLESS INVALID GO SY814.
SY813. READ USERS NEXT REGARDLESS END GO SY814. IF US-NUM NOT=WN1 GO SY814.
    ADD 1 TO WN1 GO SY813.
SY814. PERFORM INIT-UN MOVE WA1 TO US-USER MOVE WN1 TO US-NUM.
    WRITE US-RECORD ALLOWING NO UNLOCK USERS.
SY819. GO SY81.

SY820. READ USERS REGARDLESS INVALID PERFORM DSP-ERR32 GO SY829.
    DISPLAY "NAME:" LINE 8 COLUMN 50 BOLD US-NAME COLUMN 56.
SY823. DISPLAY "LETTER IDENTIFYING THE MAIN MENU SELECTION: _" LINE 10 BOLD ERASE END SCREEN.
    ACCEPT XA1 COLUMN 45 DEFAULT " " UNDERLINED PROTECTED AUTOTERMINATE KEY CKEY.
    IF KPF4 OR XA1=" " REWRITE US-RECORD ALLOWING NO UNLOCK USERS GO SY829.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>24
      IF MN-MTBL(IX1:1)=XA1 GO SY824 END-IF END-PERFORM.
    MOVE "INVALID LETTER" TO ERR-MESG PERFORM DSP-ERR GO SY823.
SY824. DISPLAY " 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20" LINE 12 COLUMN 10 REVERSED.
    DISPLAY    "21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40" LINE 16 COLUMN 10 REVERSED.
    DISPLAY "0=NO   1=YES   9=END   'RETURN'=NO CHANGE" LINE 21.
    MOVE 13 TO IXT MOVE 11 TO IXU MOVE 1 TO IX2.
SY825. DISPLAY US-TD(IX1,IX2) LINE IXT COLUMN IXU BOLD.
    ADD 1 TO IX2 ADD 3 TO IXU IF IX2=21 ADD 4 TO IXT MOVE 11 TO IXU.
    IF IX2<=40 GO SY825.
    MOVE 14 TO IXT MOVE 11 TO IXU MOVE 1 TO IX2.
SY827. ACCEPT XA1 LINE IXT COLUMN IXU DEFAULT " " UNDERLINED PROTECTED AUTOTERMINATE KEY CKEY.
    IF KPF4 OR XA1="9" GO SY828. IF XA1=" " MOVE US-TD(IX1,IX2) TO XA1.
    IF NOT(XA1="0" OR "1") GO SY827. MOVE XA1 TO US-TD(IX1,IX2).
    ADD 1 TO IX2 ADD 3 TO IXU IF IX2=21 ADD 4 TO IXT MOVE 11 TO IXU.
    IF IX2<=40 GO SY827.
SY828. GO SY823.
SY829. GO SY81.

SY830. READ USERS REGARDLESS INVALID PERFORM DSP-ERR32 GO SY839.
    DISPLAY "NAME:" LINE 8 COLUMN 50 BOLD US-NAME COLUMN 56.
    PERFORM DSP-SURE IF XA3="YES" DELETE USERS.
SY839. GO SY81.

SY840. READ USERS REGARDLESS INVALID PERFORM DSP-ERR32 GO SY849.
    DISPLAY "NAME:" LINE 8 COLUMN 50 BOLD.
    ACCEPT US-NAME COLUMN 56 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    REWRITE US-RECORD ALLOWING NO UNLOCK USERS.
SY849. GO SY81.

SY89. GO SY9.

SY9. GO MX9.

SY-D. MOVE IF-OFF-DATE1(IX1) TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN 13.
    MOVE IF-OFF-DATE2(IX1) TO D-DATE PERFORM D-NM DISPLAY D-DT LINE IXT COLUMN 33.
SY-E. PERFORM RD-INFO MOVE 0 TO IF-OFF-DATE1(IX1) IF-OFF-DATE2(IX1) PERFORM WR-INFO.

* Z-25 PRINT PRODUCTION TICKETS
TK1. PERFORM RD244 PERFORM WRT MOVE 0 TO TK-RN MOVE 2 TO IXT.
TK13. ADD 1 TO TK-RN IXT.
TK15. ACCEPT TK-MO LINE IXT COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF TK-MO=0 SUBTRACT 1 FROM TK-RN GO TK16.
    MOVE TK-MO TO R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO TK15.
    MOVE TK-MO TO RNUM1(TK-RN) IF TK-RN<10 GO TK13.
TK16. MOVE 14 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM SET-SHORT-SCHED.

    MOVE 8 TO LAS-FLN PERFORM OPEN-LAS PERFORM PCL-INIT PERFORM PCL-START.
    PERFORM PCL-BOLD1 MOVE 1 TO TK-KODD MOVE 0 TO TK-IXN.
* note 193

TK3. ADD 1 TO TK-IXN INITIALIZE R-REC.
    IF TK-RN=0 IF XM-F6(TK-IXN)=0 GO TK6 END-IF MOVE XM-F8(TK-IXN) TO R-NO
      ELSE IF TK-IXN>TK-RN GO TK6 END-IF MOVE RNUM1(TK-IXN) TO R-NO.
    READ PRODORD REGARDLESS IF TK-RN=0 AND R-TICKET=0 GO TK3.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT.
    PERFORM DESC-MAIN MOVE 1 TO PRO-SIND PERFORM DESC-SEC.
    IF TK-RN=0 MOVE XM-F6(TK-IXN) TO TK-MAC ELSE MOVE P-MAC TO TK-MAC.
    MOVE TK-MAC TO A-N1 PERFORM RD-MAC.

    MOVE 0 TO LAS-ROW IF TK-KODD=0 ADD 33 TO LAS-ROW. MOVE 0 TO LAS-COL.
    ADD 2 TO LAS-ROW MOVE 10 TO LAS-COL PERFORM PCL-PCR.
    MOVE R-NO TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO A-A1.
    MOVE 150 TO LAS-BARH MOVE 8 TO LAS-BARX MOVE 0 TO LAS-BARV PERFORM LAS-BAR.
    ADD 5 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    MOVE R-NO TO FJ12 MOVE R-LAST-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FJ13.
    IF R-TICKET=2 MOVE "REVISION" TO FJ14.
    MOVE "REQD:" TO FJ15 MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FJ16.
    PERFORM LAS-LINE 2 TIMES.
    IF P-CUS>" " MOVE P-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO TK34 END-READ
      MOVE "CUSTOMER" TO FJ17 MOVE C-NO TO FJ18 MOVE C-NAME TO FJ19.
TK34. PERFORM LAS-LINE 2 TIMES MOVE 1 TO PRO-IX1.
    MOVE P-NO TO FJ20 MOVE PRO-DESC(PRO-IX1) TO FJ21 PERFORM LAS-LINE.
    ADD 1 TO PRO-IX1 MOVE PRO-DESC(PRO-IX1) TO FJ21 PERFORM LAS-LINE.
    MOVE "QTY" TO FJ22 MOVE R-QTY-ORD TO FJ23.
    ADD 1 TO PRO-IX1 MOVE PRO-DESC(PRO-IX1) TO FJ21 PERFORM LAS-LINE.
    MOVE "WEIGHT" TO FJ24 MOVE P-WEIGHT TO FJ25 MOVE "C" TO FJ26.
    ADD 1 TO PRO-IX1 MOVE PRO-DESC(PRO-IX1) TO FJ21 PERFORM LAS-LINE.
    MOVE "MAT" TO FJ27 PERFORM SET-PART MOVE PART-NO TO FJ28.
    MOVE "MACH" TO FJ29 MOVE TK-MAC TO FJ30 MOVE M-DESC1 TO FJ31 PERFORM LAS-LINE.
    MOVE "FIN" TO FJ41 MOVE P-FINDESC TO FJ42 PERFORM LAS-LINE.
    IF R-COILS=0 PERFORM CALC-NCOILS ELSE MOVE R-COILS TO A-L1.
    MOVE A-L1 TO FJ32 IF A-L1<=1 MOVE "COIL" TO FJ33 ELSE MOVE "COILS" TO FJ33.
    COMPUTE WN1=(R-QTY-ORD * P-WEIGHT / 100 + 599) / 600 MOVE WN1 TO FJ34.
    IF WN1=1 MOVE "TICKET" TO FJ35 ELSE MOVE "TICKETS" TO FJ35.
    IF P-TCOLOR NOT=0 MOVE 13 TO T-TBL MOVE P-TCOLOR TO T-NO PERFORM RD-TBL MOVE T-LINE TO FJ36.
    IF P-PACKING NOT=0 MOVE P-PACKING TO A-N1 PERFORM RD-PACKING MOVE PK-DESC TO FJ37.
    MOVE P-QTY-PACK TO FJ38 MOVE "/CTN" TO FJ39 PERFORM LAS-LINE 2 TIMES.

    MOVE 0 TO PRO-SPN MOVE P-NO TO OP-PROD MOVE TK-MAC TO OP-MAC.
    READ OPERATIONS REGARDLESS INVALID
      MOVE P-MAC TO OP-MAC READ OPERATIONS REGARDLESS INVALID GO TK46 END-READ.
    IF OP-SPEED>0 MOVE OP-SPEED TO PRO-SPN ELSE MOVE M-SPEED TO PRO-SPN.
    MOVE " " TO TK-OPL MOVE 1 TO IX1.
TK43. IF IX1=1 MOVE TK-MAC TO M-NO
        ELSE IF OP-OPER(IX1 - 1)=0 GO TK44 ELSE MOVE OP-OPER(IX1 - 1) TO M-NO.
    MOVE M-NO TO TK-DF1(IX1) MOVE "/" TO TK-DF2(IX1).
    READ MACHINE REGARDLESS INVALID MOVE "--ERROR--" TO M-OPDESC.
    MOVE M-OPDESC TO TK-DF3(IX1).
TK44. ADD 1 TO IX1 IF IX1<=12 GO TK43. MOVE PRO-SPDESC TO TK-OPLINE(3)(59:).
    MOVE TK-OPLINE(1) TO FJ40 PERFORM LAS-LINE 2 TIMES.
    MOVE TK-OPLINE(2) TO FJ40 PERFORM LAS-LINE 2 TIMES.
    MOVE TK-OPLINE(3) TO FJ40 PERFORM LAS-LINE.
TK46. IF TK-KODD=1 MOVE 0 TO TK-KODD ELSE MOVE 1 TO TK-KODD PERFORM PCL-FF.
    MOVE 0 TO R-TICKET REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    GO TK3.
TK6. IF TK-KODD=0 PERFORM PCL-FF. PERFORM PCL-ENDFL PERFORM CLOSE-LAS.
    MOVE "PRINT2" TO LAS-QUEUE PERFORM PRINT-LAS.
TK9. GO MX9.

* Z-26 WORK IN PROGRESS REPORT
WP1. PERFORM RD280 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO WP-KP MOVE S-A1 TO WP-TITLE GO WP2.
    MOVE 0 TO WP-KP MOVE " " TO WA1 WA2 WP-TITLE.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MX1.
    IF Y1 MOVE "** USING M.O. QTY LEFT **" TO WA1.
    IF Y2 MOVE "** USING PROCESS 940 **" TO WA1.
    PERFORM AX-CAT.
    IF Y1 ADD 1 TO IXT DISPLAY "INCLUDE ONLY PLATED PARTS ? ___" LINE IXT BOLD
      ACCEPT XA3 LINE IXT COLUMN 29 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO WP-KP MOVE "(PLATED PARTS)" TO WA2.
    IF Y2 ADD 1 TO IXT DISPLAY "INVENTORY DATE: ______" LINE IXT BOLD
      MOVE 17 TO IXU PERFORM AX-DT-VAL.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    STRING WA1 DELIMITED "  " " " DELIMITED SIZE WA2 DELIMITED "  " INTO WP-TITLE.
    IF S-DEF MOVE WP-KP TO S-S1 MOVE WP-TITLE TO S-A1 GO MX9.
WP2. PERFORM DSP-WAIT PERFORM OPEN-REP MOVE " " TO PRO-NSV.
WP23. MOVE PRO-NSV TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO WP29.
    READ PRODUCT NEXT REGARDLESS END GO WP29.
    MOVE P-KEY TO PRO-NSV MOVE P-CAT TO PRO-CATSV PERFORM RD-GEN.
    IF NOT(P-CAT>=CAT1 AND<=CAT2) GO WP23. IF WP-KP=1 AND P-PLSPEC=0 GO WP23.
    PERFORM INIT-RP MOVE PRO-CATSV TO RP-F32 MOVE PRO-NSV TO RP-F33.
    WRITE RP-RECORD GO WP23.
WP29. PERFORM OPEN-PR PERFORM WP-PAGE.
    MOVE LOW-VALUES TO WP-STOTALS WP-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO WP9.
WP3. READ REPFL NEXT END GO WP9. MOVE RP-F33 TO A-A1 PERFORM PROD-GEN.
    MOVE RP-F32 TO P-CAT.
    IF OLD-N=P-CAT GO WP4. IF OLD-N NOT=0 PERFORM WP-SUB PERFORM WP-PAGE.
    MOVE "CAT" TO FG322 MOVE P-CAT TO FG323 PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FG324.
    PERFORM WP-LINE 2 TIMES MOVE P-CAT TO OLD-N.
WP4. MOVE P-NO TO FG325 IF GEN-IND=1 MOVE GEN-ALT TO FG325 MOVE P-NO TO GEN-PN
      MOVE GEN-MSG TO FG326 GO WP86.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO FG326.
    MOVE 0 TO WP-RQTY MOVE P-NO TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO WP8.
WP5. READ PRODORD NEXT REGARDLESS END GO WP8. IF R-PROD NOT=P-NO GO WP8.
    IF Y2 GO WP6.
    IF R-NO<=9999 OR R-QTY-LEFT<=0 OR R-QTY-PROD=0 GO WP5. IF WP-KP=0 GO WP56.
    MOVE R-NO TO J-NO MOVE 636 TO J-MAC MOVE 0 TO J-DATE J-SHIFT J-EMP.
    START WORKSHEET KEY>=J-KEY REGARDLESS INVALID GO WP58.
    READ WORKSHEET NEXT REGARDLESS END GO WP58.
    IF NOT(J-NO=R-NO AND J-MAC=636) GO WP58.
WP56. ADD R-QTY-LEFT TO WP-RQTY.
WP58. GO WP78.
WP6. MOVE R-NO TO J-NO MOVE 940 TO J-MAC MOVE DATE0 TO J-DATE MOVE 0 TO J-SHIFT J-EMP.
    START WORKSHEET KEY>=J-KEY REGARDLESS INVALID GO WP68.
WP63. READ WORKSHEET NEXT REGARDLESS END GO WP68.
    IF NOT(J-NO=R-NO AND J-MAC=940 AND J-DATE=DATE0) GO WP68.
    ADD J-QTY TO WP-RQTY GO WP63.
WP68.
WP78. GO WP5.
WP8. IF WP-RQTY=0 MOVE " " TO PREC GO WP88.
    COMPUTE WP-RWEIGHT ROUNDED=WP-RQTY * P-WEIGHT / 100.
    MOVE WP-RQTY TO FG327 MOVE P-WEIGHT TO FG328 MOVE WP-RWEIGHT TO FG329.
    ADD WP-RQTY TO WP-SQTY WP-GQTY ADD WP-RWEIGHT TO WP-SWEIGHT WP-GWEIGHT.
    ADD P-HAND TO WP-SQ WP-GQ ADD P-ROP TO WP-SR WP-GR.
    COMPUTE WN1 ROUNDED=P-HAND * P-WEIGHT / 100 ADD WN1 TO WP-SW WP-GW.
    MOVE 0 TO WS1 WS2.
    IF P-CAT<=21 IF P-ROP>1 MOVE 1 TO WS1 IF P-HAND<P-ROP / 3 MOVE 1 TO WS2.
    IF P-CAT>21 MOVE 1 TO WS1 IF P-HAND + P-ORDER + P-PROCESS<P-DEMAND MOVE 1 TO WS2.
    IF WS1=1 ADD 1 TO WP-SN(1) WP-GN(1). IF WS2=1 ADD 1 TO WP-SN(2) WP-GN(2).
WP86. PERFORM WP-LINE.
WP88. GO WP3.
WP9. PERFORM WP-SUB MOVE 3 TO WS-PR PERFORM WP-LINE MOVE "  *** GRAND" TO FG431.
    MOVE WP-GTOTALS TO WP-XTOTALS PERFORM WP-F PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

WP-SUB. MOVE 2 TO WS-PR PERFORM WP-LINE MOVE "CATEGORY" TO FG432 MOVE OLD-N TO FG433.
    MOVE WP-STOTALS TO WP-XTOTALS PERFORM WP-F PERFORM WP-LINE.
    MOVE LOW-VALUES TO WP-STOTALS.
WP-F. MOVE "TOTALS:" TO FG435 MOVE WP-XQTY TO FG327 MOVE WP-XWEIGHT TO FG329 PERFORM PR-LINE.
    MOVE "TOTAL ON HAND:" TO FG435 MOVE WP-XQ TO FG436 PERFORM PR-LINE.
    MOVE "TOTAL WEIGHT:" TO FG435 MOVE WP-XW TO FG436 PERFORM PR-LINE.
    MOVE "TOTAL REORDER:" TO FG435 MOVE WP-XR TO FG436 PERFORM WP-LINE.
    MOVE "PARTS BELOW SAFETY:" TO FG438 MOVE WP-XN(2) TO FG439.
    MOVE "OF" TO FG440 MOVE WP-XN(1) TO FG441 MOVE "(" TO FG442.
    COMPUTE FG443 ROUNDED=WP-XN(2) * 100 / WP-XN(1) SIZE ERROR CONTINUE.
    MOVE "% )" TO FG444.
WP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM WP-PAGE.
WP-PAGE. MOVE "WORK IN PROGRESS REPORT" TO FF3 MOVE WP-TITLE TO FF4 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-CAT.
    IF Y2 MOVE "INVENTORY DATE:" TO A-A1 PERFORM PRANGE-DT.
    MOVE "PRODUCT       DESCRIPTION                          QUANTITY        WT/C        WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ............  ................................  ...,...,...-  ...,...:..  ...,...,...-
*         ........ .. .............  ...,...,...-

* Z-27 DAILY FILE UPDATE
BN1. PERFORM RD406 PERFORM WRT IF S-BAT GO BN2.
    ACCEPT PR-NUM LINE 3 COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 3 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
BN2. PERFORM DSP-WAIT PERFORM OPEN-PR.
    PERFORM CREATE-TRAUD.

* update customer file
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO BN248.
BN243. READ CUSTOMER NEXT REGARDLESS END GO BN248.
    MOVE 0 TO C-ORD C-TOT C-CUR C-30 C-60 C-90 C-120 C-DATE-PAY.
    MOVE C-NO TO TR-CUS MOVE 0 TO TR-INV.
    START TRANS KEY>TR-KEY REGARDLESS INVALID GO BN246.
BN245. READ TRANS NEXT REGARDLESS END GO BN246. IF TR-CUS>C-NO GO BN246.
    IF TR-DATE-PAY>C-DATE-PAY MOVE TR-DATE-PAY TO C-DATE-PAY.
    IF TR-AMT NOT=0 MOVE TR-AMT TO A-D1 PERFORM UPDATE-CUST-BAL. GO BN245.
BN246. REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER GO BN243.
BN248. MOVE " " TO L-KEY START SALIN KEY>L-KEY REGARDLESS INVALID GO BN258.
BN253. READ SALIN NEXT REGARDLESS END GO BN258.
    IF L-QTY=LIT-Q9 OR L-QTY-LEFT=0 GO BN253.
    MOVE L-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO BN253.
    MOVE L-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO BN253. PERFORM RD-GEN.
    MOVE L-QTY-LEFT TO CL-QTY PERFORM LPRICE-CALC PERFORM WEIGHT-CALC.
    PERFORM PLATING-CALC PERFORM SURCH-CALC.
    ADD CL-AMT TO C-ORD REWRITE C-RECORD ALLOWING NO UNLOCK CUSTOMER GO BN253.
BN258.

* update vendor file
    MOVE WS-DIV TO V-DIV MOVE 0 TO V-NO.
    START VENDOR KEY>V-KEY REGARDLESS INVALID GO BN269.
BN263. READ VENDOR NEXT REGARDLESS END GO BN269.
    MOVE 0 TO V-GROSS(1) V-GROSS(2) V-NET(1) V-NET(2).
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO BN266.
BN265. READ APTR NEXT REGARDLESS END GO BN266.
    IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO BN266. IF AT-IND=1 GO BN265.
    IF AT-EXCH=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1.
    ADD AT-GROSS TO V-GROSS(IX1) ADD AT-NET TO V-NET(IX1) GO BN265.
BN266. REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR GO BN263.
BN269.

* update product file
    PERFORM OPEN-REP MOVE 0 TO BN-RN1.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO BN318.
BN313. READ PRODUCT NEXT REGARDLESS END GO BN318.
    MOVE 0 TO P-HAND P-DEMAND P-FDEMAND P-ORDER P-TORDER P-PROCESS.
    IF P-NUT=" " MOVE 0 TO P-WEIGHT-NUT.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    IF P-NUT=" " GO BN314. MOVE P-KEY TO PRO-NSV PERFORM NUM-NUTS.
    MOVE P-NUT TO A-A1 PERFORM PROD-RT COMPUTE WD1=PRO-NNUT * P-WEIGHT.
    MOVE PRO-NSV TO P-KEY START PRODUCT KEY=P-KEY REGARDLESS INVALID GO BN318.
    READ PRODUCT NEXT REGARDLESS END GO BN318.
    IF WD1 NOT=P-WEIGHT-NUT MOVE WD1 TO P-WEIGHT-NUT
      REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
BN314. IF P-GEN=" " GO BN316.
    IF P-MAC NOT=0 ADD 1 TO BN-RN1
      PERFORM INIT-RP MOVE P-NO TO RP-F212 WRITE RP-RECORD.
    MOVE P-KEY TO PRO-NSV MOVE P-GEN TO A-A1 PERFORM PROD-RT MOVE P-CAT TO WN1.
    MOVE PRO-NSV TO P-KEY START PRODUCT KEY=P-KEY REGARDLESS INVALID GO BN318.
    READ PRODUCT NEXT REGARDLESS END GO BN318.
    IF WN1>0 AND NOT=P-CAT MOVE WN1 TO P-CAT REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
BN316. GO BN313.
BN318. IF BN-RN1=0 GO BN3189.
    MOVE 1 TO BN-STEP PERFORM BN-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BN3184.
BN3183. READ REPFL NEXT END GO BN3184. MOVE RP-F212 TO FA348(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM BN-LINE MOVE 1 TO PR-IXP. GO BN3183.
BN3184. PERFORM PR-LASTLN.
BN3189. PERFORM CLOSE-REP.

* update nutbolt file
    MOVE " " TO WA1.
BN321. MOVE WA1 TO NU-KEY MOVE 0 TO BN-IXD.
    START NUTBOLT KEY>NU-KEY REGARDLESS INVALID GO BN324.
BN323. READ NUTBOLT NEXT REGARDLESS END GO BN324. MOVE NU-KEY TO WA1 DELETE NUTBOLT.
    ADD 1 TO BN-IXD IF BN-IXD=100 CLOSE NUTBOLT OPEN I-O NUTBOLT ALLOWING ALL GO BN321.
    GO BN323.
* note 14.1
BN324. MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO BN326.
BN325. READ PRODUCT NEXT REGARDLESS END GO BN326. IF P-NUT=" " GO BN325.
    MOVE LOW-VALUES TO NU-RECORD MOVE P-NUT TO NU-NUT MOVE P-NO TO NU-BOLT.
    MOVE P-CAT TO NU-CAT PERFORM NUM-NUTS MOVE PRO-NNUT TO NU-NUM.
    WRITE NU-RECORD ALLOWING NO UNLOCK NUTBOLT GO BN325.
BN326.

* update product file
    MOVE " " TO BN-OPROD MOVE 0 TO BN-QTY.
    INITIALIZE B-KP START BIN KEY>B-KP REGARDLESS INVALID GO BN34.
BN33. READ BIN NEXT REGARDLESS END PERFORM BN-P GO BN34.
    IF B-PROD NOT=BN-OPROD IF BN-OPROD>" " PERFORM BN-P END-IF
      MOVE B-PROD TO BN-OPROD MOVE 0 TO BN-QTY.
    ADD B-QTY TO BN-QTY GO BN33.
BN34.

    PERFORM RDR-INFO PERFORM SET-DEM-DATE.
    MOVE " " TO BN-OPROD MOVE 0 TO BN-QTY BN-Q1.
    MOVE " " TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO BN44.
BN43. READ SALIN NEXT REGARDLESS END PERFORM BN-L GO BN44.
    IF L-SPECIAL=1 OR L-QTY=LIT-Q9 GO BN43.
    IF L-PROD NOT=BN-OPROD IF BN-OPROD>" " PERFORM BN-L END-IF
      MOVE L-PROD TO BN-OPROD MOVE 0 TO BN-QTY BN-Q1.
    IF L-DATE-REQ<=PRO-DEM-DATE ADD L-QTY-LEFT TO BN-QTY
      ELSE ADD L-QTY-LEFT TO BN-Q1.
    GO BN43.
BN44.

    MOVE " " TO BN-OPROD MOVE 0 TO BN-QTY BN-Q1.
    MOVE " " TO MT-KP START MATREL KEY>MT-KP REGARDLESS INVALID GO BN46.
BN45. READ MATREL NEXT REGARDLESS END PERFORM BN-L GO BN46.
    IF MT-KPROD NOT=BN-OPROD IF BN-OPROD>" " PERFORM BN-L END-IF
      MOVE MT-KPROD TO BN-OPROD MOVE 0 TO BN-QTY BN-Q1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>MT-IXF
      IF MT-FDATE(IX1)<=PRO-DEM-DATE ADD MT-FQTY(IX1) TO BN-QTY
        ELSE ADD MT-FQTY(IX1) TO BN-Q1 END-IF END-PERFORM.
    SUBTRACT MT-QTY-SHIP FROM BN-QTY GO BN45.
BN46.

    MOVE " " TO BN-OPROD MOVE 0 TO BN-QTY BN-Q1.
    MOVE " " TO DY-KP START DAYREL KEY>DY-KP REGARDLESS INVALID GO BN48.
BN47. READ DAYREL NEXT REGARDLESS END PERFORM BN-L GO BN48.
    PERFORM CHK-RBW IF A-S1=0 GO BN47.
    IF DY-KPROD NOT=BN-OPROD IF BN-OPROD>" " PERFORM BN-L END-IF
      MOVE DY-KPROD TO BN-OPROD MOVE 0 TO BN-QTY BN-Q1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>DY-IXF
      IF DY-FDATE(IX1)<=PRO-DEM-DATE ADD DY-FQTY(IX1) TO BN-QTY
        ELSE ADD DY-FQTY(IX1) TO BN-Q1 END-IF END-PERFORM.
    GO BN47.
BN48.

* update prodord and worksheet files
    MOVE 2 TO BN-STEP PERFORM BN-PAGE MOVE 1 TO PR-IXP.
    MOVE 10000 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO BN59.
BN53. READ PRODORD NEXT REGARDLESS END GO BN59.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO BN53. PERFORM RD-GEN.
    IF ITOOL PERFORM GET-OP.
    MOVE 0 TO R-QTY-REC R-QTY-PROD IF IFAST OR INUT MOVE R-ORIG-ORD TO R-QTY-ORD.
    MOVE 0 TO BN-WEIGHT INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO BN56.
BN55. READ WORKSHEET NEXT REGARDLESS END GO BN56. IF J-NO NOT=R-NO GO BN56.
    IF ITOOL MOVE J-MAC TO A-N1 PERFORM PROC-TYPE
      IF PROC-RECEIVE OR PROC-BOLTNUT OR PROC-ADJUST ADD J-QTY TO R-QTY-REC END-IF
      IF J-MAC=OP-OPER(1) ADD J-QTY TO R-QTY-PROD END-IF GO BN558.
* note 27.1
    IF J-MAC=8 MOVE 1 TO R-PUR.
    MOVE J-WEIGHT TO BN-WN1 MOVE J-AWEIGHT TO BN-WN2 MOVE J-QTY TO BN-WN3.
    MOVE J-BKTOT TO BN-WN4 MOVE J-BKEMPTY TO BN-WN5 MOVE J-BKWRONG TO BN-WN6.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY ADD J-WEIGHT TO BN-WEIGHT.
    IF R-FIN=0 OR R-QTY-LEFT<=0 GO BN556.
    PERFORM BUCKET-CALC MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF NOT PROC-PRIMARY MOVE 0 TO J-BKWRONG
      IF J-AWEIGHT>BN-WEIGHT MOVE BN-WEIGHT TO J-AWEIGHT MOVE 1 TO J-BKWRONG.
    PERFORM CALC-QTY-WEIGHT.
BN556. IF NOT(J-WEIGHT=BN-WN1 AND J-AWEIGHT=BN-WN2 AND J-QTY=BN-WN3
      AND J-BKTOT=BN-WN4 AND J-BKEMPTY=BN-WN5 AND J-BKWRONG=BN-WN6)
        REWRITE J-RECORD ALLOWING NO UNLOCK WORKSHEET.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-RECEIVE OR PROC-BOLTNUT OR PROC-ADJUST ADD J-QTY TO R-QTY-REC.
    IF PROC-PRIMARY ADD J-QTY TO R-QTY-PROD.
    IF (IFAST OR INUT) AND PROC-REJECT SUBTRACT J-QTY FROM R-QTY-PROD R-QTY-ORD.
BN558. GO BN55.
BN56.

    IF R-FIN=0 GO BN568.
    IF R-QTY-ORD=0 GO BN566. IF R-QTY-REC<R-QTY-PROD * 0.90 GO BN568.
* note 132.1
    INITIALIZE J-KEY MOVE R-NO TO J-NO MOVE 845 TO J-MAC.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO BN564.
BN563. READ WORKSHEET NEXT REGARDLESS END GO BN564.
    IF J-NO NOT=R-NO OR J-MAC>850 GO BN564.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT(PROC-RECEIVE OR PROC-BOLTNUT) GO BN563.
    IF J-DATE>SYS-DATE - 21 GO BN568. GO BN563.
BN564.
BN566. IF R-QTY-REC=R-QTY-PROD GO BN568.
    PERFORM INIT-J MOVE R-NO TO J-NO MOVE 955 TO J-MAC MOVE R-PROD TO J-PROD.
    COMPUTE J-QTY=R-QTY-PROD - R-QTY-REC MOVE R-QTY-PROD TO R-QTY-REC.
    COMPUTE J-WEIGHT ROUNDED=J-QTY * P-WEIGHT / 100.
    PERFORM SET-JKD WRITE J-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK WORKSHEET.
    MOVE R-NO TO FD39(PR-IXP).
    IF R-SPORD NOT=0 MOVE R-SPORD TO DSP-N61 MOVE R-SPLINE TO DSP-F21
      STRING " (" DSP-N61 "-" DSP-F21 ")" DELIMITED SIZE INTO FD39A(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>6 PERFORM BN-LINE MOVE 1 TO PR-IXP.
BN568. IF R-QTY-REC>0 MOVE 1 TO R-FIN. PERFORM CALC-QLEFT.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    GO BN53.
BN59. PERFORM PR-LASTLN.

    PERFORM OPEN-REP.
    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO BN596.
BN593. READ PRODORD NEXT REGARDLESS END GO BN596.
    IF R-FIN=0 OR R-SPORD=0 OR R-SPMOD=1 GO BN593.
    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO BN5934.
BN5933. READ WORKSHEET NEXT REGARDLESS END GO BN5934. IF J-NO NOT=R-NO GO BN5934.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO BN5934.
    IF J-BKEMPTY=1 GO BN593. GO BN5933.
BN5934. MOVE 1 TO R-SPMOD REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    MOVE R-SPORD TO L-ORD MOVE R-SPLINE TO L-LINE READ SALIN REGARDLESS INVALID GO BN593.
    COMPUTE WN1=R-QTY-PROD / 1000 MULTIPLY 1000 BY WN1.
    COMPUTE WN1=WN1 - L-QTY IF WN1=0 GO BN593.
    IF L-QTY-LEFT + WN1<0 COMPUTE WN1=-L-QTY-LEFT. ADD WN1 TO L-QTY L-QTY-LEFT.
* note 89
    PERFORM INIT-RP MOVE L-ORD TO RP-F253 MOVE L-LINE TO RP-F254.
    MOVE R-NO TO RP-F255 MOVE R-QTY-PROD TO RP-F256(1).
    COMPUTE RP-F256(2)=L-QTY - WN1 COMPUTE RP-F256(3)=L-QTY-LEFT - WN1.
    MOVE L-QTY TO RP-F256(4) MOVE L-QTY-LEFT TO RP-F256(5).
    WRITE RP-RECORD GO BN593.
BN596. MOVE 3 TO BN-STEP PERFORM BN-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BN599.
BN597. READ REPFL NEXT END GO BN599. MOVE RP-F255 TO FA615.
    MOVE RP-F253 TO FA616 MOVE "-" TO FA617 MOVE RP-F254 TO FA618.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 MOVE RP-F256(IX1) TO FA619(IX1) END-PERFORM.
    PERFORM BN-LINE GO BN597.
BN599. PERFORM CLOSE-REP.

* update product file
    MOVE 0 TO A-S1 PERFORM UPDATE-PROD-ORD.

    MOVE " " TO BN-OPROD MOVE 0 TO BN-DATE BN-AMT BN-QTY BN-WN1.
    MOVE " " TO SH-KP START SALHIST KEY>SH-KP REGARDLESS INVALID GO BN64.
BN63. READ SALHIST NEXT REGARDLESS END PERFORM BN-S GO BN64.
    IF SH-AMT<=0 GO BN63.
    IF SH-KPROD NOT=BN-OPROD IF BN-OPROD>" " PERFORM BN-S END-IF
      MOVE SH-KPROD TO BN-OPROD MOVE 0 TO BN-DATE BN-AMT BN-QTY BN-WN1.
    IF SH-DATE>BN-DATE MOVE SH-DATE TO BN-DATE
      MOVE SH-AMT TO BN-AMT MOVE SH-QTY TO BN-QTY MOVE SH-US TO BN-WN1.
    GO BN63.
BN64.

* update part file
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO BN79.
BN73. READ PART NEXT REGARDLESS END GO BN79. PERFORM PART-TYPE.
    MOVE PH-HAND TO BN-WN1 MOVE PH-ORDER TO BN-WN2 MOVE PH-BLINES TO BN-WN3.
    MOVE 0 TO PH-HAND PH-ORDER PH-BLINES.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      MOVE PH-PROC-HAND(IX1) TO BN-WNP(IX1) MOVE 0 TO PH-PROC-HAND(IX1) END-PERFORM.
    MOVE PH-LDCOST TO BN-WT1.
    IF PH-LDCOST NOT=0 GO BN74. MOVE 0 TO WN1 WT1 BN-QTY.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PH-NO TO PU-PART.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO BN734.
BN733. READ PURHIST NEXT REGARDLESS END GO BN734.
    IF NOT(PU-DIV=WS-DIV AND PU-PART=PH-NO) GO BN734.
    IF PU-QTY<0 OR PU-LDCOST=0 GO BN733. ADD 1 TO WN1 IF WN1>3 GO BN734.
    ADD PU-QTY TO BN-QTY COMPUTE WT1=WT1 + PU-LDCOST * PU-QTY GO BN733.
BN734. IF BN-QTY>0 AND WT1>0 COMPUTE PH-LDCOST ROUNDED=WT1 / BN-QTY
      ELSE PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
        IF PH-PRICE(IX1)>0 MOVE PH-PRICE(IX1) TO PH-LDCOST GO BN738 END-IF END-PERFORM.
BN738.
BN74. INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO BN76.
BN75. READ PURBIN NEXT REGARDLESS END GO BN76. IF BH-PART NOT=PH-NO GO BN76.
    IF BH-NO(1:2)="SQ" GO BN75. ADD BH-QTY TO PH-HAND.
    IF PART-MAT IF BH-PCODE<=8 ADD BH-QTY TO PH-PROC-HAND(BH-PCODE + 1).
    GO BN75.
BN76. MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO BN78.
BN77. READ PURLIN NEXT REGARDLESS END GO BN78. IF LK-PART NOT=PH-NO GO BN78.
    IF LK-BLANKET=1 ADD 1 TO PH-BLINES
      ELSE PERFORM CALC-LKQTY IF A-T1<0 MOVE 0 TO A-T1 END-IF
        ADD A-T1 TO PH-ORDER ROUNDED.
    MOVE 0 TO WS1.
    IF PH-CAT NOT=LK-CAT MOVE PH-CAT TO LK-CAT MOVE 1 TO WS1.
    IF PH-MODE NOT=LK-MODE MOVE PH-MODE TO LK-MODE MOVE 1 TO WS1.
    IF PH-MTYPE NOT=LK-MTYPE MOVE PH-MTYPE TO LK-MTYPE MOVE 1 TO WS1.
    IF PH-DRAW NOT=LK-DRAW MOVE PH-DRAW TO LK-DRAW MOVE 1 TO WS1.
    IF PH-REV NOT=LK-REV MOVE PH-REV TO LK-REV MOVE 1 TO WS1.
    IF WS1=1 REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN. GO BN77.
BN78. IF NOT(PH-HAND=BN-WN1 AND PH-ORDER=BN-WN2 AND PH-BLINES=BN-WN3
       AND PH-LDCOST=BN-WT1) GO BN786.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      IF PH-PROC-HAND(IX1) NOT=BN-WNP(IX1) GO BN786 END-IF END-PERFORM.
    GO BN788.
BN786. REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
BN788. GO BN73.
BN79.

    PERFORM UPDATE-PART-DEM.

    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO BN82.
BN81. READ PART NEXT REGARDLESS END GO BN82. IF PH-LEVEL=3 GO BN81.
    PERFORM PART-TYPE IF NOT PART-TOOL GO BN81.
    IF NOT(PH-ROP=0 AND PH-QTY-TMP=0 AND PH-QTYA-TMP=0 AND PH-ASM-MAC=0)
      MOVE 0 TO PH-ROP PH-QTY-TMP PH-QTYA-TMP PH-ASM-MAC
      REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    GO BN81.
BN82. MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO BN86.
BN83. READ TOOLS NEXT REGARDLESS END GO BN86. PERFORM TL-SET-TYPE.
    MOVE TS-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO BN83.
    IF NOT(TS-MAC=P-MAC OR P-ALT-MAC) GO BN83. MOVE 1 TO TL-IXA.
BN85. IF TS-TOOL(TL-IXA)=" " OR "N/R" GO BN858.
    MOVE TS-TOOL(TL-IXA) TO PH-NO READ PART REGARDLESS INVALID GO BN858.
    IF PH-ASM=1 IF TS-MAC=P-ALT-MAC GO BN858 END-IF
      MOVE TS-MAC TO PH-ASM-MAC IF P-CAT>21 AND P-ORDER>0 MOVE 1 TO PH-QTYA-TMP.
    IF P-CAT<=21 AND P-ROP>=100
      MOVE P-ROP TO A-T1 IF TS-MAC=P-ALT-MAC MULTIPLY 0.25 BY A-T1 ROUNDED END-IF
      PERFORM ADJ-PLIFE ADD A-T1 TO PH-QTY-TMP.
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
BN858. ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO BN85. GO BN83.
BN86. MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO BN88.
BN87. READ PART NEXT REGARDLESS END GO BN88. IF PH-LEVEL=3 GO BN87.
    PERFORM PART-TYPE IF NOT PART-TOOL GO BN87. IF PH-ASM=1 GO BN874.
    IF PH-LIFE=0 MOVE 9999999 TO PH-ROP
      ELSE COMPUTE WD1 ROUNDED=PH-QTY-TMP / PH-LIFE / 1000
       IF WD1=0 MOVE 1 TO PH-ROP ELSE COMPUTE PH-ROP ROUNDED=WD1.
    GO BN876.
BN874. IF PH-QTY-TMP=0 AND PH-QTYA-TMP NOT=0 MOVE 2 TO PH-ROP GO BN876.
    MOVE PH-ASM-MAC TO A-N1 PERFORM RD-MAC.
    IF M-TQTY=0 MOVE 9999999 TO PH-ROP
      ELSE COMPUTE WD1 ROUNDED=PH-QTY-TMP / (M-TQTY * 100 / 8)
       ADD 1 TO WD1 MOVE WD1 TO PH-ROP
       IF PH-ROP<2 MOVE 2 TO PH-ROP ELSE IF PH-ROP>3 MOVE 3 TO PH-ROP.
BN876. MOVE 0 TO PH-QTY-TMP PH-QTYA-TMP REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    GO BN87.
BN88.

* cancel unprinted shipping labels
    MOVE 0 TO LA-NO START LABELS KEY>=LA-KEY REGARDLESS INVALID GO BN894.
BN893. READ LABELS NEXT REGARDLESS END GO BN894.
    IF LA-PR=0 AND LA-SRC=2 MOVE 2 TO LA-PR REWRITE LA-RECORD ALLOWING NO UNLOCK LABELS.
    GO BN893.
BN894.
BN9. PERFORM CLOSE-PR GO MX9.

BN-P. PERFORM BN-P1 THRU BN-P9.
BN-P1. MOVE BN-OPROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO BN-P9.
    ADD BN-QTY TO P-HAND REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
BN-P9. EXIT.
BN-L. PERFORM BN-L1 THRU BN-L9.
BN-L1. MOVE BN-OPROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO BN-L9.
    PERFORM RD-GEN ADD BN-QTY TO P-DEMAND ADD BN-Q1 TO P-FDEMAND.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    MOVE P-NUT TO PRO-NUT IF GEN-NUT>" " MOVE GEN-NUT TO PRO-NUT.
    IF PRO-NUT=" " GO BN-L9. PERFORM NUM-NUTS.
    MOVE PRO-NUT TO P-NO READ PRODUCT REGARDLESS INVALID GO BN-L9.
    COMPUTE P-DEMAND=P-DEMAND + PRO-NNUT * BN-QTY.
    COMPUTE P-FDEMAND=P-FDEMAND + PRO-NNUT * BN-Q1.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
BN-L9. EXIT.
BN-S. PERFORM BN-S1 THRU BN-S9.
BN-S1. MOVE BN-OPROD TO P-KEY READ PRODUCT REGARDLESS INVALID GO BN-S9.
    IF IFAST OR INUT MOVE 1000 TO WN1 ELSE MOVE 1 TO WN1.
    COMPUTE P-LPRICE ROUNDED=WN1 * BN-AMT / BN-QTY SIZE ERROR CONTINUE.
    MOVE BN-DATE TO P-LDATE MOVE BN-WN1 TO P-LUS.
    REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
BN-S9. EXIT.
BN-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BN-PAGE.
BN-PAGE. MOVE "DAILY FILE UPDATE REPORT" TO FF3 PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF BN-STEP=1 MOVE "ALTERNATE PRODUCTS WITH NON-BLANK FIELDS" TO PREC PERFORM PR-LINE-3.
    IF BN-STEP=2 MOVE "PRODUCTION ORDERS CLOSED BY THE SYSTEM - M.O. / SALES ORDER / LINE" TO PREC PERFORM PR-LINE-3.
*            ...... (......-..) x6
    IF BN-STEP=3 MOVE "ORDERS FOR SPECIAL PRODUCTS MODIFIED BY THE SYSTEM WHEN THE M.O. WAS CLOSED" TO PREC PERFORM PR-LINE-2
      MOVE
         "                                     ----------- OLD -----------     ----------- NEW -----------" TO PREC PERFORM PR-LINE
      MOVE
         "  M.O.  ORDER-LINE   QTY PRODUCED     QTY ORDERED       QTY LEFT      QTY ORDERED       QTY LEFT " TO PREC PERFORM PR-LINE-3.
*         ......  ......-..    ...,...,...-    ...,...,...-    ...,...,...-    ...,...,...-    ...,...,...-

* Z-28 HEAT TREATING DRAWBACK REPORT
JT1. PERFORM RD66 PERFORM WRT IF S-BAT GO JT2.
* note 196
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 14 TO IXU MOVE 1 TO IX1.
JT15. ACCEPT JT-DIAM(IX1) LINE 5 COLUMN IXU DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF JT-DIAM(IX1)>" " ADD 8 TO IXU ADD 1 TO IX1 IF IX1<=5 GO JT15.
    MOVE 11 TO IXU MOVE 1 TO IX1.
JT17. ACCEPT JT-GRADE(IX1) LINE 6 COLUMN IXU DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF JT-GRADE(IX1)>" " ADD 10 TO IXU ADD 1 TO IX1 IF IX1<=5 GO JT17.
    MOVE "06000" TO CUS1 MOVE "07500" TO CUS2.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
JT2. PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE SH-KEY MOVE CUS1 TO SH-CUS.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO JT29.
JT23. READ SALHIST NEXT REGARDLESS END GO JT29. IF SH-CUS>CUS2 GO JT29.
    IF NOT(SH-CDATE>=DATE1 AND<=DATE2) GO JT23.
    MOVE SH-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO JT28. PERFORM RD-GEN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 OR JT-DIAM(IX1)=" "
      IF P-DIAM=JT-DIAM(IX1) GO JT24 END-IF END-PERFORM. GO JT28.
JT24. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 OR JT-GRADE(IX1)=" "
       IF P-GRADE=JT-GRADE(IX1) GO JT26 END-IF END-PERFORM. GO JT28.
JT26. PERFORM INIT-RP MOVE P-DIAM TO RP-F81 MOVE P-GRADE TO RP-F82.
    MOVE SH-KEY TO RP-F83 WRITE RP-RECORD.
JT28. GO JT23.
JT29. PERFORM OPEN-PR PERFORM JT-PAGE MOVE 0 TO JT-WTOT.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JT9.
JT3. READ REPFL NEXT END GO JT9. MOVE RP-F83 TO SH-KEY READ SALHIST REGARDLESS.
    MOVE RP-F81 TO FF158 MOVE RP-F82 TO FF159.
    MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF160.
    MOVE SH-INVNO TO FF161 MOVE SH-PROD TO FF162.
    MOVE SH-CUS TO FF163 A-A1 PERFORM RD-CUS MOVE C-NAME TO FF164.
    MOVE SH-WEIGHT TO FF165 PERFORM JT-LINE.
    ADD SH-WEIGHT TO JT-WTOT GO JT3.
JT9. MOVE 3 TO WS-PR MOVE "*** TOTAL" TO FF164 MOVE JT-WTOT TO FF165 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

JT-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JT-PAGE.
JT-PAGE. MOVE "DRAWBACK OF SUPER STEEL HEAT TREATING DUTY" TO FF3X PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    MOVE 1 TO WS-PR MOVE "DIAMETERS SELECTED:" TO FF166.
    PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>5 OR JT-DIAM(PR-IX1)=" "
      MOVE JT-DIAM(PR-IX1) TO FF167(PR-IX1) END-PERFORM.
    PERFORM PR-LINE MOVE "GRADES SELECTED:" TO FF166.
    PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>5 OR JT-GRADE(PR-IX1)=" "
      MOVE JT-GRADE(PR-IX1) TO FF167(PR-IX1) END-PERFORM.
    PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "DIAM   GRADE       DATE    INVOICE  PRODUCT       CUS     NAME                                 WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ...... ........  ../../..  ......   ............  ......  ................................ ...,...,...-

* Z-29 SALESMAN COMMISSION REPORT
FP1. PERFORM RD370 PERFORM WRT.
    IF INUT PERFORM FT-SALREP IF A-S1=0 GO MX1 ELSE GO MX9.
    IF S-BAT GO FP2.
    PERFORM AX-DATE PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
FP2. PERFORM DSP-WAIT PERFORM OPEN-REP OPEN I-O SALESMAN ALLOWING ALL.
    MOVE " " TO SH-KEY START SALHIST KEY>SH-KEY REGARDLESS INVALID GO FP29.
FP23. READ SALHIST NEXT REGARDLESS END GO FP29.
    IF NOT(SH-SAL>0 AND SH-SALCOM>0 AND SH-DATE>=DATE1 AND<=DATE2) GO FP23.
    PERFORM INIT-RP MOVE SH-SAL TO RP-F298.
    MOVE SH-SALCOM TO RP-F299 MOVE SH-CUS TO RP-F300 MOVE SH-DATE TO RP-F301.
    MOVE SH-ORD TO RP-F302 MOVE SH-PROD TO RP-F303 MOVE 0 TO RP-F304.
    MOVE SH-QTY TO RP-F305 MOVE SH-AMT TO RP-F306 MOVE SH-US TO RP-F307.
FP27. WRITE RP-RECORD INVALID IF RP-F304<99 ADD 1 TO RP-F304 GO FP27 END-IF.
    GO FP23.
FP29. PERFORM OPEN-PR MOVE 0 TO SUM-IND.

FP3. MOVE 1 TO FP-STEP.
FP33. PERFORM FP-PAGE.
    MOVE LOW-VALUES TO FP-CTOTALS FP-RTOTALS FP-STOTALS FP-GTOTALS.
    MOVE 0 TO OLD-N OLD-D MOVE " " TO OLD-C.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FP9.
FP5. READ REPFL NEXT END GO FP9.
    IF NOT(FP-STEP=1 AND RP-F307=0 OR FP-STEP=2 AND RP-F307=1) GO FP5.
    IF RP-F298=OLD-N GO FP52. IF OLD-N NOT=0 PERFORM FP-C PERFORM FP-R PERFORM FP-S.
    MOVE RP-F298 TO OLD-N MOVE 0 TO OLD-D MOVE " " TO OLD-C.
    INITIALIZE SN-REC MOVE RP-F298 TO FF501 SN-NO.
    READ SALESMAN REGARDLESS INVALID CONTINUE. MOVE SN-NAME TO FF502.
    PERFORM FP-LINE 2 TIMES.
FP52. IF RP-F299=OLD-D GO FP54. IF OLD-D NOT=0 PERFORM FP-C PERFORM FP-R.
    MOVE RP-F299 TO OLD-D MOVE " " TO OLD-C.
FP54. IF RP-F300=OLD-C GO FP56. IF OLD-C>" " PERFORM FP-C. MOVE RP-F300 TO OLD-C.
    MOVE RP-F300 TO FF491 A-A1 PERFORM RD-CUS MOVE C-NAME TO FF492 OLD-NAME.
FP56. MOVE RP-F302 TO FF493 MOVE RP-F301 TO D-DATE PERFORM D-NM MOVE D-DT TO FF494.
    MOVE RP-F303 TO FF495 MOVE RP-F305 TO FF496 MOVE RP-F306 TO FF497.
    MOVE RP-F299 TO FF498 COMPUTE WD1 ROUNDED=RP-F306 * RP-F299 / 100.
    MOVE WD1 TO FF499 ADD WD1 TO FP-CTOT FP-RTOT FP-STOT FP-GTOT.
    ADD RP-F306 TO FP-CAMT FP-RAMT FP-SAMT FP-GAMT.
    IF SUM-IND=0 PERFORM FP-LINE ELSE MOVE " " TO PREC. GO FP5.
FP9. PERFORM FP-C PERFORM FP-R PERFORM FP-S.
    MOVE "** GRAND TOTAL" TO FF492.
    MOVE FP-GAMT TO FF497 MOVE FP-GTOT TO FF499 PERFORM PR-LINE.
    IF FP-STEP=1 MOVE 2 TO FP-STEP GO FP33.
    IF SUM-IND=0 MOVE 1 TO SUM-IND GO FP3.
    CLOSE SALESMAN PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

FP-S. MOVE "** SALESMAN TOTAL" TO FF492.
    MOVE FP-SAMT TO FF497 MOVE FP-STOT TO FF499 MOVE "***" TO FF500.
    PERFORM PR-LINE PERFORM FP-PAGE MOVE LOW-VALUES TO FP-STOTALS.
FP-R. MOVE "** RATE TOTAL" TO FF492.
    MOVE FP-RAMT TO FF497 MOVE OLD-D TO FF498.
    MOVE FP-RTOT TO FF499 MOVE "**" TO FF500.
    IF SUM-IND=0 MOVE 2 TO A-N1 ELSE MOVE 1 TO A-N1.
    PERFORM FP-LINE A-N1 TIMES MOVE LOW-VALUES TO FP-RTOTALS.
FP-C. IF SUM-IND=0 MOVE 2 TO WS-PR A-N1 MOVE "** CUSTOMER TOTAL" TO FF492
       ELSE MOVE 1 TO A-N1 MOVE OLD-C TO FF491 MOVE OLD-NAME TO FF492.
    MOVE FP-CAMT TO FF497 MOVE OLD-D TO FF498.
    MOVE FP-CTOT TO FF499 IF SUM-IND=0 MOVE "*" TO FF500.
    PERFORM FP-LINE A-N1 TIMES MOVE LOW-VALUES TO FP-CTOTALS.
FP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FP-PAGE.
FP-PAGE. MOVE "SALESMAN COMMISSION REPORT" TO FF3.
    IF FP-STEP=1 MOVE "(CN$ SALES)" TO FF4.
    IF FP-STEP=2 MOVE "(US$ SALES)" TO FF4. PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    IF SUM-IND=0 MOVE
         "CUSTOMER                                  ORDER    DATE    PRODUCT            QTY       AMOUNT   RATE  COMMISSION" TO PREC
      ELSE MOVE
         "CUSTOMER                                                                                AMOUNT   RATE  COMMISSION" TO PREC.
*         ......  ................................ ......  ../../..  ............ ..,...,...- ...,...:..- ..:.. ...,...:..-...
    PERFORM PR-LINE-3.

FT-SALREP. PERFORM FT1 THRU FT9.
FT1. IF S-BAT GO FT2.
    ADD 1 TO IXT DISPLAY "FOR SALESMAN NO. __ " LINE IXT BOLD.
FT13. ACCEPT FT-SAL LINE IXT COLUMN 18 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF FT-SAL=0 PERFORM DSP-ERR2 GO FT13.
    PERFORM AX-DATE PERFORM AX-PRNUM PERFORM AX-ACC.
    IF XA2 NOT="OK" MOVE 0 TO A-S1 GO FT9.
    IF S-DEF GO FT89.
FT2. PERFORM DSP-WAIT PERFORM OPEN-REP PERFORM OPEN-SORT MOVE " " TO OLD-C.
    MOVE " " TO SH-KEY START SALHIST KEY>SH-KEY REGARDLESS INVALID GO FT29.
FT23. READ SALHIST NEXT REGARDLESS END GO FT29.
    IF NOT(SH-DATE>=DATE1 AND<=DATE2) GO FT23. IF SH-CUS=OLD-C GO FT24.
    MOVE SH-CUS TO C-NO READ CUSTOMER REGARDLESS INVALID GO FT23.
    MOVE SH-CUS TO OLD-C.
FT24. IF C-SAL NOT=FT-SAL GO FT23. PERFORM INIT-RP MOVE C-US TO RP-F349.
    MOVE SH-CUS TO RP-F350 MOVE SH-PROD TO RP-F351 PERFORM FT-AR.
    WRITE RP-RECORD INVALID READ REPFL PERFORM FT-AR REWRITE RP-RECORD.
    PERFORM INIT-SR MOVE SH-PROD TO SR-F87 PERFORM FT-AS.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM FT-AS REWRITE SR-RECORD.
    GO FT23.
FT29. PERFORM OPEN-PR PERFORM FT-PAGE MOVE FT-SAL TO A-N1 PERFORM RD-SALESMAN.

    MOVE 1 TO FT-STEP.
FT3. IF FT-STEP=1 MOVE "CANADIAN" TO WA1 ELSE MOVE "U.S." TO WA1.
    MOVE WA1 TO A-A1 PERFORM STR-LTH MOVE A-N1 TO WN1.
    MOVE SN-NAME TO A-A1 PERFORM STR-LTH MOVE A-N1 TO WN2.
    STRING "COMMISSION SALES FOR " SN-NAME(1:WN2) " (" WA1(1:WN1) " DOLLARS)"
      DELIMITED SIZE INTO PREC PERFORM FT-LINE 3 TIMES.
    MOVE " " TO OLD-C MOVE LOW-VALUES TO FT-CTOTALS FT-STOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FT6.
FT5. READ REPFL NEXT END GO FT6.
    IF NOT(FT-STEP=1 AND RP-F349=0 OR FT-STEP=2 AND RP-F349=1) GO FT5.
    IF RP-F350=OLD-C GO FT54. IF OLD-C>" " PERFORM FT-C.
    MOVE RP-F350 TO OLD-C FG478 C-NO READ CUSTOMER REGARDLESS MOVE C-NAME TO FG479.
    PERFORM FT-LINE 2 TIMES.
FT54. MOVE RP-F351 TO FG480 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FG481.
    MOVE RP-F352 TO FG482 MOVE RP-F353 TO FG483 MOVE RP-F354 TO FG484 PERFORM FT-LINE.
    ADD RP-F352 TO FT-CQ FT-SQ ADD RP-F353 TO FT-CW FT-SW ADD RP-F354 TO FT-CA FT-SA.
    GO FT5.
FT6. PERFORM FT-C PERFORM FT-LINE MOVE "GRAND TOTALS" TO FG479.
    MOVE FT-SQ TO FG482 MOVE FT-SW TO FG483 MOVE FT-SA TO FG484 MOVE "**" TO FG485.
    PERFORM PR-LINE-2.
    MOVE "COMMISSION PAYABLE @" TO FG486 MOVE SN-SALCOM TO FG487 MOVE "% OF SALES" TO FG488.
    COMPUTE FG484 ROUNDED=FT-SA * SN-SALCOM / 100 PERFORM PR-LINE.
    IF FT-STEP=1 MOVE 2 TO FT-STEP PERFORM FT-PAGE GO FT3.

    PERFORM FT-PAGE MOVE "SUMMARY BY PART FOR ALL LOCATIONS" TO PREC PERFORM FT-LINE 2 TIMES.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO FT8.
FT7. READ SORTFL NEXT END GO FT8.
    MOVE SR-F87 TO FG480 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FG481.
    MOVE SR-F88 TO FG482 MOVE SR-F89 TO FG483 MOVE SR-F90 TO FG484 PERFORM FT-LINE.
    GO FT7.
FT8. PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR.
FT89. MOVE 1 TO A-S1.
FT9. EXIT.

FT-AR. ADD SH-QTY TO RP-F352 ADD SH-WEIGHT TO RP-F353 ADD SH-AMT TO RP-F354.
FT-AS. ADD SH-QTY TO SR-F88 ADD SH-WEIGHT TO SR-F89 ADD SH-AMT TO SR-F90.
FT-C. MOVE "CUSTOMER TOTALS" TO FG479.
    MOVE FT-CQ TO FG482 MOVE FT-CW TO FG483 MOVE FT-CA TO FG484 MOVE "*" TO FG485.
    PERFORM FT-LINE 2 TIMES MOVE LOW-VALUES TO FT-CTOTALS.
FT-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FT-PAGE.
FT-PAGE. MOVE "SALESMAN COMMISSION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE "        PRODUCT                                               QTY      WEIGHT       AMOUNT" TO PREC PERFORM PR-LINE-3.
*                 ............  ................................ ..,...,...- ..,...,...-.,...,...:..-

* Z-30 DAILY PRODUCTION REPORT
DP1. PERFORM RD49 PERFORM WRT IF S-BAT GO DP2.
    MOVE 3 TO IXT MOVE 8 TO IXU PERFORM AX-DT-VAL.
    MOVE 5 TO IXT MOVE 18 TO IXU MOVE 41 TO IXV PERFORM AX-GROUP-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
DP2. PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE J-KD MOVE DATE0 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO DP29.
DP23. READ WORKSHEET NEXT REGARDLESS END GO DP29. IF J-DATE>DATE0 GO DP29.
    MOVE J-MAC TO A-N1 PERFORM RD-MAC IF NOT(M-GROUP>=GROUP1 AND<=GROUP2) GO DP23.
    PERFORM INIT-RP MOVE M-GROUP TO RP-F34 MOVE M-TYPE TO RP-F35.
    MOVE J-MAC TO RP-F36 MOVE J-NO TO RP-F37 MOVE J-SHIFT TO RP-F38.
    MOVE J-EMP TO RP-F39 WRITE RP-RECORD GO DP23.
DP29. PERFORM OPEN-PR PERFORM DP-PAGE.
    MOVE LOW-VALUES TO DP-GTOTALS DP-TTOTALS DP-MTOTALS MOVE 0 TO OLD-M OLD-T OLD-G.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DP9.
DP3. READ REPFL NEXT END GO DP9. MOVE RP-F37 TO J-NO MOVE RP-F36 TO J-MAC.
    MOVE DATE0 TO J-DATE MOVE RP-F38 TO J-SHIFT MOVE RP-F39 TO J-EMP.
    READ WORKSHEET REGARDLESS MOVE RP-F36 TO A-N1 PERFORM RD-MAC.
    IF M-GROUP=OLD-G GO DP34.
    IF OLD-G NOT=0 PERFORM DP-M PERFORM DP-T PERFORM DP-G PERFORM DP-PAGE
      MOVE 0 TO OLD-M OLD-T.
    MOVE 19 TO T-TBL MOVE M-GROUP TO T-NO PERFORM RD-TBL.
    MOVE "GROUP" TO FA524 MOVE M-GROUP TO FA525 MOVE T-LINE TO FA526.
    PERFORM PR-LINE-3 MOVE M-GROUP TO OLD-G.
DP34. IF M-TYPE=OLD-T GO DP36.
    IF OLD-T NOT=0 PERFORM DP-M PERFORM DP-T MOVE 0 TO OLD-M.
    MOVE 3 TO WS-PR MOVE "TYPE" TO FA524 MOVE M-TYPE TO FA525.
    PERFORM DP-LINE 3 TIMES MOVE M-TYPE TO OLD-T.
DP36. IF J-MAC=OLD-M GO DP4. IF OLD-M NOT=0 PERFORM DP-M.
    MOVE J-MAC TO FA527 OLD-M MOVE M-DESC1 TO FA528.
DP4. MOVE J-NO TO FA530 MOVE J-PROD TO FA531 A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO FA532 MOVE LIT-XDAN(J-SHIFT + 1:1) TO FA533.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    MOVE J-HOURS TO FA534 MOVE J-QTY TO FA535 MOVE J-WEIGHT TO FA536 MOVE J-AWEIGHT TO FA537.
    MOVE J-HOURS TO A-D1 PERFORM CALC-TARGET MOVE A-N1 TO DP-TARGET.
    MOVE DP-TARGET TO FA538.
* note 23.2
    MOVE J-QTY TO WN1 IF PROC-HEAT MOVE J-AWEIGHT TO WN1 IF WN1=0 MOVE J-WEIGHT TO WN1.
    IF WN1<DP-TARGET MOVE "*" TO FA539.
    ADD J-HOURS TO DP-MTOT(1) DP-TTOT(1) DP-GTOT(1).
    ADD J-QTY TO DP-MTOT(2) DP-TTOT(2) DP-GTOT(2).
    ADD J-WEIGHT TO DP-MTOT(3) DP-TTOT(3) DP-GTOT(3).
    ADD J-AWEIGHT TO DP-MTOT(4) DP-TTOT(4) DP-GTOT(4).
    ADD DP-TARGET TO DP-MTOT(5) DP-TTOT(5) DP-GTOT(5).
    PERFORM DP-LINE GO DP3.
DP9. PERFORM DP-M PERFORM DP-T PERFORM DP-G.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

DP-M. MOVE "** MACHINE TOTALS" TO FA528.
    MOVE DP-MTOT(1) TO FA534 MOVE DP-MTOT(2) TO FA535 MOVE DP-MTOT(3) TO FA536.
    MOVE DP-MTOT(4) TO FA537 MOVE DP-MTOT(5) TO FA538.
    IF DP-MTOT(2)<DP-MTOT(5) MOVE "*" TO FA539.
    PERFORM DP-LINE 2 TIMES MOVE LOW-VALUES TO DP-MTOTALS.
DP-T. MOVE 2 TO WS-PR MOVE "** TYPE TOTALS" TO FA528.
    MOVE DP-TTOT(1) TO FA534 MOVE DP-TTOT(2) TO FA535 MOVE DP-TTOT(3) TO FA536.
    MOVE DP-TTOT(4) TO FA537 MOVE DP-TTOT(5) TO FA538.
    IF DP-TTOT(2)<DP-TTOT(5) MOVE "*" TO FA539.
    PERFORM DP-LINE 2 TIMES MOVE LOW-VALUES TO DP-TTOTALS.
DP-G. MOVE 2 TO WS-PR MOVE "*** GROUP TOTALS" TO FA528.
    MOVE DP-GTOT(1) TO FA534 MOVE DP-GTOT(2) TO FA535 MOVE DP-GTOT(3) TO FA536.
    MOVE DP-GTOT(4) TO FA537 MOVE DP-GTOT(5) TO FA538.
    IF DP-GTOT(2)<DP-GTOT(5) MOVE "*" TO FA539.
    PERFORM DP-LINE MOVE LOW-VALUES TO DP-GTOTALS.
DP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM DP-PAGE.
DP-PAGE. MOVE "DAILY PRODUCTION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "FOR:" TO A-A1 PERFORM PRANGE-DT MOVE 1 TO WS-PR PERFORM PRANGE-GROUP.
    MOVE "MACHINE/PROCESS                     M.O.  PRODUCT      DESCRIPTION                  SH HOURS     PIECES  WEIGHT--ACTUAL     TARGET" TO PREC PERFORM PR-LINE-3.
*         ... ............................ .......  ............ ............................  . ..:.. ..,...,... ...,... ...,... ..,...,... .

* Z-31 PRODUCTS ON ORDER REPORT
PO1. PERFORM RD371 PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 44 TO IXV PERFORM AX-CUS-R.
    MOVE 5 TO IXT MOVE 14 TO IXU PERFORM AX-DT-VAL.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-REP MOVE CUS1 TO O-CUS MOVE 0 TO O-DATE.
    START SAORD KEY>O-KC REGARDLESS INVALID GO PO29.
PO23. READ SAORD NEXT REGARDLESS END GO PO29. IF O-CUS>CUS2 GO PO29.
    IF O-BLANKET=1 OR O-DATE-REQ>DATE0 GO PO23. COMPUTE L-NO=100 * O-NO.
PO25. ADD 1 TO L-LINE READ SALIN REGARDLESS INVALID GO PO26.
    IF L-QTY-LEFT=0 GO PO25. PERFORM INIT-RP.
    MOVE O-CUS TO RP-F40 MOVE L-PROD TO RP-F40A MOVE L-DATE-REQ TO RP-F41.
    MOVE L-ORD TO RP-F42 MOVE L-LINE TO RP-F43 MOVE L-QTY-LEFT TO RP-F44.
    WRITE RP-RECORD GO PO25.
PO26. GO PO23.
PO29. PERFORM OPEN-PR PERFORM PO-PAGE.
    MOVE LOW-VALUES TO PO-CTOTALS PO-PTOTALS PO-GTOTALS MOVE " " TO OLD-C OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PO9.
PO3. READ REPFL NEXT END GO PO9. IF RP-F40=OLD-C GO PO34.
    IF OLD-C>" " PERFORM PO-P PERFORM PO-C.
    MOVE RP-F40 TO FA549 A-A1 PERFORM RD-CUS MOVE C-NAME TO FA550.
    PERFORM PO-LINE 2 TIMES MOVE RP-F40 TO OLD-C MOVE " " TO OLD-A.
PO34. IF RP-F40A=OLD-A GO PO4. IF OLD-A>" " PERFORM PO-P.
    MOVE RP-F40A TO OLD-A FA543 A-A1 PERFORM PROD-RGD MOVE PRO-DESC(1) TO FA544.
PO4. MOVE RP-F42 TO FA545 MOVE RP-F41 TO D-DATE PERFORM D-NM MOVE D-DT TO FA546.
    MOVE RP-F44 TO FA547 ADD RP-F44 TO PO-CQTY PO-PQTY PO-GQTY.
    PERFORM PO-LINE GO PO3.
PO9. PERFORM PO-P PERFORM PO-C.
    MOVE 2 TO WS-PR MOVE "*** GRAND TOTAL" TO FA544 MOVE PO-GQTY TO FA547.
    MOVE "***" TO FA548 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

PO-C. MOVE 2 TO WS-PR MOVE "** CUSTOMER TOTAL" TO FA544 MOVE PO-CQTY TO FA547.
    MOVE "**" TO FA548 PERFORM PO-LINE 2 TIMES MOVE LOW-VALUES TO PO-CTOTALS.
PO-P. MOVE "*  PRODUCT TOTAL" TO FA544 MOVE PO-PQTY TO FA547.
    MOVE "*" TO FA548 PERFORM PO-LINE MOVE LOW-VALUES TO PO-PTOTALS.
PO-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PO-PAGE.
PO-PAGE. MOVE "PRODUCTS ON ORDER REPORT" TO FF3.
    MOVE "** BY CUSTOMER / BY PRODUCT **" TO FF4 PERFORM PR-PAGE.
    MOVE "REQUIRED BY:" TO A-A1 PERFORM PRANGE-DT MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    MOVE "    PRODUCT       DESCRIPTION                      ORDER NO  DATE REQ      QUANTITY" TO PREC PERFORM PR-LINE-3.
*             ............  ................................  ......   ../../..   ...,...,...-...

* Z-32 SALES BY PRODUCT TYPE REPORT
UP1. PERFORM RD372 PERFORM WRT.
    ACCEPT UP-TYPE LINE 3 COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE LOW-VALUES TO UP-TCATX MOVE 1 TO IX1 MOVE 38 TO IXU.
UP13. ACCEPT UP-TCAT(IX1) LINE 3 COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF UP-TCAT(IX1)>0 ADD 1 TO IX1 ADD 4 TO IXU IF IX1<=6 GO UP13.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM UP-PAGE MOVE LOW-VALUES TO UP-TOTALS.

    MOVE " " TO PRO-NO IF UP-TYPE<100 MOVE UP-TYPE TO PRO-PR(1).
    MOVE PRO-NO TO PRO-NSV.
UP3. MOVE PRO-NSV TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO UP9.
    READ PRODUCT NEXT REGARDLESS END GO UP9.
    MOVE P-KEY TO PRO-NSV PRO-NO MOVE P-CAT TO PRO-CATSV PERFORM RD-GEN.
    IF UP-TYPE<100 AND PRO-PR(1) NUMERIC AND PRO-PR(1)>UP-TYPE GO UP9.
    IF PRO-CATSV=0 GO UP3.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      IF UP-TCAT(IX1)=PRO-CATSV GO UP4 END-IF END-PERFORM.
    GO UP3.
UP4. MOVE P-NO TO FA551 IF GEN-IND=1 MOVE GEN-ALT TO FA551 MOVE P-NO TO GEN-PN
      MOVE GEN-MSG TO FA552 GO UP8.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO FA552.
    MOVE P-MTD TO FA553(1) MOVE P-YTD TO FA553(2) MOVE P-LAST TO FA553(3).
    ADD P-MTD TO UP-TOT(1) ADD P-YTD TO UP-TOT(2) ADD P-LAST TO UP-TOT(3).
UP8. PERFORM UP-LINE GO UP3.
UP9. MOVE 3 TO WS-PR MOVE "TOTALS ***" TO FA552.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE UP-TOT(IX1) TO FA553(IX1) END-PERFORM.
    PERFORM PR-LINE PERFORM CLOSE-PR GO MX9.

UP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM UP-PAGE.
UP-PAGE. MOVE "SALES BY PRODUCT TYPE" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR MOVE "PRODUCT TYPE:" TO FA554.
    IF UP-TYPE<100 MOVE UP-TYPE TO FA555 ELSE MOVE "ALL" TO FA555X.
    MOVE "CATEGORIES:" TO FA557.
    PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>6
      MOVE UP-TCAT(PR-IX1) TO FA558(PR-IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    MOVE "PRODUCT       DESCRIPTION                               QTY MTD       QTY YTD    QTY LAST YR" TO PREC PERFORM PR-LINE-3.
*         ............  ................................      ...,...,...-  ...,...,...-  ...,...,...-

* Z-33 SURPLUS INVENTORY REPORT
KS1. PERFORM RD324 PERFORM WRT.
    ACCEPT KS-R(1) LINE 3 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED.
    ACCEPT KS-R(2) LINE 4 COLUMN 22 DEFAULT " " UNDERLINED PROTECTED.
    ACCEPT KS-R(3) LINE 5 COLUMN 21 DEFAULT " " UNDERLINED PROTECTED.
    ACCEPT XA3 LINE 7 COLUMN 22 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO KS-KC ELSE MOVE 0 TO KS-KC.
    ACCEPT XA3 LINE 8 COLUMN 49 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO KS-KS ELSE MOVE 0 TO KS-KS.
    MOVE 10 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.

    PERFORM DSP-WAIT PERFORM OPEN-REP MOVE " " TO PRO-NSV.
KS23. MOVE PRO-NSV TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO KS29.
    READ PRODUCT NEXT REGARDLESS END GO KS29.
    MOVE P-KEY TO PRO-NSV MOVE P-CAT TO PRO-CATSV PERFORM RD-GEN.
    IF P-CAT<=11 MOVE 1 TO IX1 ELSE IF P-CAT<=21 MOVE 2 TO IX1
      ELSE IF P-CAT<=79 MOVE 3 TO IX1 ELSE GO KS23.
    IF IX1=1 MOVE 4 TO WN2 ELSE IF IX1=2 MOVE 8 TO WN2 ELSE MOVE 0 TO WN2.
    COMPUTE WN2=P-HAND - P-BANK - P-DEMAND - P-FDEMAND - WN2 * P-ROP.
    IF KS-R(IX1) NOT="YES" OR WN2<=0 GO KS23.
    COMPUTE WN3 ROUNDED=WN2 * P-WEIGHT / 100 PERFORM INIT-RP.
    IF KS-KC=1 MOVE PRO-CATSV TO RP-F45 ELSE MOVE P-MAC TO RP-F45.
    IF KS-KS=1 COMPUTE RP-F47=999999999 - WN3.
    MOVE PRO-NSV TO RP-F48 MOVE WN2 TO RP-F49 MOVE WN3 TO RP-F50.
    WRITE RP-RECORD GO KS23.
KS29. PERFORM OPEN-PR PERFORM KS-PAGE.
    MOVE LOW-VALUES TO KS-STOTALS KS-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO KS9.
KS3. READ REPFL NEXT END GO KS9. MOVE RP-F48 TO A-A1 PERFORM PROD-GEN.
    IF RP-F45=OLD-N GO KS4. IF OLD-N NOT=0 PERFORM KS-SUB. MOVE RP-F45 TO FA567.
    IF RP-F45 NOT=0
      IF KS-KC=1 MOVE "CAT" TO FA566 MOVE RP-F45 TO PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FA568
        ELSE MOVE "MAC" TO FA566 MOVE RP-F45 TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FA568.
    PERFORM KS-LINE 2 TIMES MOVE RP-F45 TO OLD-N.
KS4. MOVE P-NO TO FA561 IF GEN-IND=1 MOVE GEN-ALT TO FA561 MOVE P-NO TO GEN-PN
      MOVE GEN-MSG TO FA562 GO KS8.
    PERFORM PROD-DESC MOVE PRO-DESC(1) TO FA562.
    MOVE RP-F49 TO FA563 MOVE RP-F50 TO FA564.
    ADD RP-F49 TO KS-SQ KS-GQ ADD RP-F50 TO KS-SW KS-GW.
KS8. PERFORM KS-LINE GO KS3.
KS9. PERFORM KS-SUB MOVE 3 TO WS-PR MOVE "GRAND TOTALS ***" TO FA562.
    MOVE KS-GQ TO FA563 MOVE KS-GW TO FA564 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

KS-SUB. MOVE 3 TO WS-PR.
    IF KS-KC=1 MOVE "CATEGORY TOTALS **" TO FA562
      ELSE MOVE "MACHINE TOTALS **" TO FA562.
    MOVE KS-SQ TO FA563 MOVE KS-SW TO FA564 PERFORM KS-LINE 3 TIMES.
    MOVE LOW-VALUES TO KS-STOTALS.
KS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KS-PAGE.
KS-PAGE. MOVE "SURPLUS INVENTORY REPORT" TO FF3.
    IF KS-KC=1 MOVE "** BY CATEGORY **" TO FF4
      ELSE MOVE "** BY MACHINE **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    MOVE "CATEGORIES SELECTED:" TO PREC MOVE 21 TO A-X1.
    IF KS-R(1)="YES" MOVE "OEM" TO PREC(A-X1:) ADD 4 TO A-X1.
    IF KS-R(2)="YES" MOVE "STANDARD" TO PREC(A-X1:) ADD 9 TO A-X1.
    IF KS-R(3)="YES" MOVE "SPECIAL" TO PREC(A-X1:). PERFORM PR-LINE-2.
    MOVE "PRODUCT       DESCRIPTION                             SURPLUS PCS    SURPLUS LBS" TO PREC PERFORM PR-LINE-3.
*         ............  ................................       ...,...,...-   ...,...,...-

* Z-34 GENERATE PRODUCTION ORDERS
KL1. PERFORM RD407 PERFORM WRT IF S-BAT GO KL2.
    ACCEPT PR-NUM LINE 3 COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 3 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
KL2. PERFORM DSP-WAIT PERFORM RDR-INFO PERFORM SET-DEM-DATE.
* note 17
    PERFORM OPEN-PR PERFORM OPEN-MAINTA PERFORM OPEN-MAINTB.
    MOVE 1 TO KL-STEP PERFORM KL-PAGE MOVE 1000 TO KL-PSEQ.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO KL6.
KL3. READ PRODUCT NEXT REGARDLESS END GO KL6. IF P-GEN>" " OR P-CAT>60 GO KL3.
    IF P-CAT<=21 GO KL4.

* cat 22 - 60 (specials)
    MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>=AL-KEY REGARDLESS INVALID GO KL38.
KL33. READ ALTERNATES NEXT REGARDLESS END GO KL38. IF AL-PROD NOT=P-NO GO KL38.
    MOVE AL-PROD TO KL-PROD IF AL-ALT>" " MOVE AL-ALT TO KL-PROD.
    MOVE KL-PROD TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO KL36.
KL35. READ SALIN NEXT REGARDLESS END GO KL36. IF L-PROD NOT=KL-PROD GO KL36.
    IF (L-QTY<=0 OR=LIT-Q9) OR L-QTY-LEFT=0 GO KL35.
    MOVE P-NO TO KL-PNO MOVE L-QTY TO KL-QTY PERFORM KL-S.
    IF P-NUT=" " GO KL358. PERFORM NUM-NUTS MOVE P-KEY TO PRO-NSV.
    MOVE P-NUT TO P-NO READ PRODUCT REGARDLESS INVALID GO KL356.
    MOVE P-NO TO KL-PNO COMPUTE KL-QTY=L-QTY * PRO-NNUT PERFORM KL-S.
KL356. MOVE PRO-NSV TO P-KEY START PRODUCT KEY=P-KEY REGARDLESS INVALID GO KL6.
    READ PRODUCT NEXT REGARDLESS END GO KL6.
KL358. GO KL35.
KL36. GO KL33.
KL38. GO KL3.

* cat 1 - 21
KL4. PERFORM KL-SET-QPROD COMPUTE KL-ROP ROUNDED=P-ROP * 0.75.
    MOVE 0 TO KL-HQTY IF P-CAT=21 MOVE P-ROP TO KL-HQTY.
    COMPUTE KL-TQTY=P-HAND - P-BANK + P-ORDER + P-PROCESS.
    COMPUTE KL-BQTY=KL-TQTY - KL-HQTY - P-DEMAND.
    IF P-CAT<=11 MOVE 2 TO WN1 ELSE MOVE 4 TO WN1.
    IF KL-BQTY>=WN1 * KL-ROP AND NOT(P-ORDER=0 AND P-TORDER=0)
      MOVE P-NO TO MFA-F24 WRITE MFA-RECORD.
    IF P-CAT=14
     IF KL-BQTY<P-ROP PERFORM INIT-R MOVE P-NO TO R-PROD PERFORM KL-PD
       MOVE D-DATE TO R-DATE MOVE SYS-DATE TO R-LAST-DATE MOVE P-ROP TO R-QTY-ORD
       PERFORM KL-WRITE END-IF GO KL3.
    IF KL-BQTY>=0 GO KL3.
    IF P-CAT=21 MOVE P-ROP TO KL-PQTY ELSE MOVE KL-ROP TO KL-PQTY.
    IF P-RATE>0 MOVE P-RATE TO A-N1 ELSE MOVE P-MAC TO A-N1 PERFORM RD-MAC PERFORM CALC-PRATE.
    IF A-N1>0 MULTIPLY 75 BY A-N1 IF KL-PQTY>A-N1 MOVE A-N1 TO KL-PQTY.

    PERFORM OPEN-SORT.
    MOVE P-NO TO KL-PNO MOVE P-CAT TO KL-CAT MOVE 1 TO KL-NUM PERFORM KL-A.
* note 14.3

    IF NOT(P-MAC>=29 AND<=31 OR=99) GO KL44.
    MOVE P-NO TO NU-NUT MOVE " " TO NU-BOLT.
    START NUTBOLT KEY>NU-KEY REGARDLESS INVALID GO KL44.
KL43. READ NUTBOLT NEXT REGARDLESS END GO KL44. IF NU-NUT NOT=P-NO GO KL44.
    MOVE NU-BOLT TO KL-PROD MOVE NU-CAT TO KL-CAT MOVE NU-NUM TO KL-NUM.
    PERFORM KL-M GO KL43.
KL44.

* note 253
    PERFORM KL-PD MOVE D-DATE TO KL-PDATE MOVE 0 TO KL-KDEM KL-KFIR.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO KL48.
KL47. READ SORTFL NEXT END GO KL48. MOVE 1 TO KL-KDEM.
    SUBTRACT SR-F5 FROM KL-TQTY IF KL-TQTY>=KL-HQTY GO KL47.
    MOVE SR-F4 TO D-DATE PERFORM KL-LEAD MOVE D-DATE TO KL-RDATE.
    IF P-CAT=21 AND KL-KFIR=0 AND KL-PDATE>KL-RDATE MOVE KL-PDATE TO KL-RDATE.
    PERFORM KL-ADD ADD KL-SQTY TO KL-TQTY MOVE 1 TO KL-KFIR GO KL47.
KL48. IF KL-KDEM=0 MOVE KL-PDATE TO KL-RDATE PERFORM KL-ADD.
    PERFORM CLOSE-SORT GO KL3.

KL6. MOVE KL-PSEQ TO R-NO.
    START PRODORD KEY>R-KEY REGARDLESS INVALID GO KL64.
KL63. READ PRODORD NEXT REGARDLESS END GO KL64. IF R-NO>9999 GO KL64.
    MOVE 0 TO R-IND REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD GO KL63.
KL64.

    CLOSE MAINTA OPEN INPUT MAINTA.
    MOVE 2 TO KL-STEP PERFORM PR-RESET PERFORM KL-PAGE MOVE 1 TO PR-IXP.
KL65. READ MAINTA END GO KL66. MOVE MFA-F24 TO FF338(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM KL-LINE 2 TIMES MOVE 1 TO PR-IXP. GO KL65.
KL66. PERFORM PR-LASTLN CLOSE MAINTA.

    CLOSE MAINTB OPEN INPUT MAINTB.
    MOVE 3 TO KL-STEP PERFORM PR-RESET PERFORM KL-PAGE.
KL67. READ MAINTB END GO KL68.
    MOVE MFB-F1 TO FA378 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FA379.
    MOVE MFB-F2 TO FA380 MOVE MFB-F3 TO D-DATE PERFORM D-NM MOVE D-DT TO FA381.
    PERFORM KL-LINE GO KL67.
KL68. CLOSE MAINTB PERFORM DELETE-MAINT.

    MOVE 4 TO KL-STEP PERFORM PR-RESET PERFORM KL-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO KL88.
KL83. READ PRODUCT NEXT REGARDLESS END GO KL88. IF P-GEN>" " OR P-MAC=99 GO KL83.
    PERFORM KL-SET-QPROD.
    IF P-CAT>11 OR P-ROP<=2 * KL-QMIN
      IF P-ALT-MAC=0 GO KL83 ELSE MOVE "*" TO FF449(PR-IXP) GO KL86.
    IF NOT(P-ROP>2 * KL-QMIN AND P-ALT-MAC=0) GO KL83.
KL86. MOVE P-NO TO FF450(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM KL-LINE 2 TIMES MOVE 1 TO PR-IXP. GO KL83.
KL88. PERFORM PR-LASTLN.
    PERFORM KM-FIRM PERFORM CLOSE-PR.
KL9. GO MX9.

KL-PD. COMPUTE A-N1=KL-TQTY - P-DEMAND IF A-N1<0 MOVE 0 TO A-N1.
    COMPUTE A-N1 ROUNDED=84 * A-N1 / P-ROP SIZE ERROR MOVE 0 TO A-N1.
    IF A-N1>365 MOVE 365 TO A-N1. COMPUTE D-DATE=SYS-DATE + A-N1 PERFORM KL-LEAD.
KL-LEAD. COMPUTE A-N1 ROUNDED=P-LEAD * 7 / 5 + 7 SUBTRACT A-N1 FROM D-DATE.
    IF D-DATE<SYS-DATE MOVE SYS-DATE TO D-DATE.
KL-WRITE. PERFORM CALC-QLEFT MOVE R-QTY-ORD TO R-ORIG-ORD.
    ADD 1 TO KL-PSEQ MOVE KL-PSEQ TO R-NO MOVE 1 TO R-IND.
    REWRITE R-RECORD ALLOWING NO INVALID WRITE R-RECORD ALLOWING NO. UNLOCK PRODORD.
KL-SET-QPROD. PERFORM KL-SQ1 THRU KL-SQ9.
KL-SQ1. PERFORM VARYING MAC-IX1 FROM 1 BY 1 UNTIL MAC-IX1>MAC-NUM
      IF P-MAC=MAC-MAC(MAC-IX1) MOVE MAC-MIN(MAC-IX1) TO KL-QMIN
        MOVE MAC-MAX(MAC-IX1) TO KL-QMAX GO KL-SQ8 END-IF END-PERFORM.
    MOVE 0 TO KL-QMIN MOVE 200 TO KL-QMAX.
KL-SQ8. MULTIPLY 1000 BY KL-QMIN KL-QMAX.
KL-SQ9. EXIT.

KL-ADD. PERFORM KL-AD1 THRU KL-AD9.
KL-AD1.
KL-AD3. MOVE KL-RDATE TO D-DATE PERFORM D-OFFDAY IF D-N1>0 SUBTRACT 1 FROM KL-RDATE GO KL-AD3.
    IF P-MAC=99 MOVE KL-ROP TO KL-SQTY
      MOVE P-NO TO MFB-F1 MOVE KL-ROP TO MFB-F2 MOVE KL-RDATE TO MFB-F3
      WRITE MFB-RECORD GO KL-AD9.
    PERFORM INIT-R MOVE P-NO TO R-PROD.
    MOVE KL-RDATE TO R-DATE MOVE SYS-DATE TO R-LAST-DATE.
    PERFORM GROSS-WEIGHT COMPUTE KL-CQTY ROUNDED=WEI-COIL * 100 / PRO-GROSS
      SIZE ERROR MOVE KL-PQTY TO KL-CQTY.
    IF KL-PQTY<KL-CQTY / 2 COMPUTE R-QTY-ORD=KL-CQTY / 2
      PERFORM KL-WRITE MOVE R-QTY-ORD TO KL-SQTY GO KL-AD9.
    COMPUTE A-N1=KL-PQTY + KL-CQTY / 2 COMPUTE A-N1=A-N1 / KL-CQTY.
    COMPUTE KL-FQTY=A-N1 * KL-CQTY MOVE 0 TO KL-SQTY.
KL-AD5. MOVE KL-CQTY TO KL-OQTY ADD KL-CQTY TO KL-SQTY.
KL-AD7. IF KL-OQTY + KL-CQTY<KL-QMAX AND KL-SQTY<KL-FQTY
         ADD KL-CQTY TO KL-OQTY KL-SQTY GO KL-AD7.
    MOVE KL-OQTY TO R-QTY-ORD PERFORM KL-WRITE IF KL-SQTY<KL-FQTY GO KL-AD5.
KL-AD9. EXIT.

KL-S. PERFORM KL-S1 THRU KL-S9.
KL-S1. MOVE KL-PNO TO R-PROD MOVE 0 TO R-DATE.
    START PRODORD KEY>R-KP REGARDLESS INVALID GO KL-S4.
KL-S3. READ PRODORD NEXT REGARDLESS END GO KL-S4.
    IF R-PROD NOT=KL-PNO GO KL-S4. IF R-NO<=9999 GO KL-S3.
    IF L-ORD=R-SPORD AND L-LINE=R-SPLINE GO KL-S9. GO KL-S3.
KL-S4. IF P-HAND NOT=0 PERFORM PROD-DESC MOVE L-CUS TO FD81 MOVE L-ORD TO FD82
      MOVE L-LINE TO FD83 MOVE KL-QTY TO FD84 MOVE KL-PNO TO FD85
      MOVE PRO-DESC(1) TO FD86 MOVE P-HAND TO FD87 PERFORM KL-LINE.
    PERFORM INIT-R MOVE KL-PNO TO R-PROD.
    IF P-MAC=99 COMPUTE R-DATE=L-DATE-REQ - 14 MOVE 1 TO WN1 GO KL-S6.
    MOVE L-DATE-REQ TO D-DATE COMPUTE D-DAYS ROUNDED=-(P-LEAD * 7 / 5).
    MOVE 1 TO D-N1 PERFORM D-CDTADD MOVE D-DATE TO R-DATE.
    MOVE SYS-DATE TO D-DATE MOVE 14 TO D-DAYS MOVE 1 TO D-N1 PERFORM D-CDTADD.
    IF R-DATE<D-DATE MOVE D-DATE TO R-DATE. MOVE 7 TO WN1.
KL-S6.
KL-S7. MOVE R-DATE TO D-DATE PERFORM D-OFFDAY IF D-N1>0 SUBTRACT WN1 FROM R-DATE GO KL-S7.
    MOVE SYS-DATE TO R-LAST-DATE MOVE KL-QTY TO R-QTY-ORD.
    MOVE L-ORD TO R-SPORD MOVE L-LINE TO R-SPLINE PERFORM KL-WRITE.
KL-S9. EXIT.

KL-A. PERFORM KL-A1 THRU KL-A9.
KL-A1. MOVE KL-PNO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>=AL-KEY REGARDLESS INVALID GO KL-A4.
KL-A3. READ ALTERNATES NEXT REGARDLESS END GO KL-A4. IF AL-PROD NOT=KL-PNO GO KL-A4.
    MOVE AL-PROD TO KL-PROD IF AL-ALT>" " MOVE AL-ALT TO KL-PROD.
    PERFORM KL-M GO KL-A3.
KL-A4.
KL-A9. EXIT.

KL-M. PERFORM KL-M1 THRU KL-M9.
KL-M1. MOVE KL-PROD TO L-PROD MOVE 0 TO L-DATE-REQ.
    START SALIN KEY>L-KP REGARDLESS INVALID GO KL-M46.
KL-M43. READ SALIN NEXT REGARDLESS END GO KL-M46.
    IF NOT(L-PROD=KL-PROD AND L-DATE-REQ<=PRO-DEM-DATE) GO KL-M46.
    IF L-QTY=LIT-Q9 OR L-QTY-LEFT=0 GO KL-M43. MOVE L-DATE-REQ TO SR-F4.
    COMPUTE A-N1=KL-NUM * L-QTY-LEFT MOVE A-N1 TO SR-F5.
    WRITE SR-RECORD INVALID READ SORTFL ADD A-N1 TO SR-F5 REWRITE SR-RECORD.
    GO KL-M43.
KL-M46. IF KL-CAT>11 GO KL-M9.

    MOVE KL-PROD TO MT-KPROD MOVE " " TO MT-KPLANT.
    START MATREL KEY>=MT-KP REGARDLESS INVALID GO KL-M59.
KL-M53. READ MATREL NEXT REGARDLESS END GO KL-M59. IF MT-KPROD NOT=KL-PROD GO KL-M59.
* note 58
    IF MT-QTY-SHIP NOT=0 MOVE 0 TO SR-F4
      COMPUTE A-N1=-(KL-NUM * MT-QTY-SHIP) MOVE A-N1 TO SR-F5
      WRITE SR-RECORD INVALID READ SORTFL ADD A-N1 TO SR-F5 REWRITE SR-RECORD.
    MOVE 1 TO A-X1.
KL-M55. IF A-X1>MT-IXF OR MT-FDATE(A-X1)>PRO-DEM-DATE GO KL-M58.
    MOVE MT-FQTY(A-X1) TO REL-FQTY MOVE MT-FDATE(A-X1) TO REL-FDATE.
    IF NOT(REL-FDATE=0 OR REL-FQTY=0) PERFORM KL-W. ADD 1 TO A-X1 GO KL-M55.
KL-M58. GO KL-M53.
KL-M59.

    MOVE KL-PROD TO DY-KPROD MOVE " " TO DY-KPLANT.
    START DAYREL KEY>=DY-KP REGARDLESS INVALID GO KL-M69.
KL-M63. READ DAYREL NEXT REGARDLESS END GO KL-M69. IF DY-KPROD NOT=KL-PROD GO KL-M69.
    PERFORM CHK-RBW IF A-S1=0 GO KL-M63. MOVE 1 TO A-X1.
KL-M65. IF A-X1>DY-IXF OR DY-FDATE(A-X1)>PRO-DEM-DATE GO KL-M68.
    MOVE DY-FQTY(A-X1) TO REL-FQTY MOVE DY-FDATE(A-X1) TO REL-FDATE.
    IF NOT(REL-FDATE=0 OR REL-FQTY=0) PERFORM KL-W. ADD 1 TO A-X1 GO KL-M65.
KL-M68. GO KL-M63.
KL-M69.
KL-M9. EXIT.
KL-W. MOVE REL-FDATE TO SR-F4 MULTIPLY KL-NUM BY REL-FQTY MOVE REL-FQTY TO SR-F5.
    WRITE SR-RECORD INVALID READ SORTFL ADD REL-FQTY TO SR-F5 REWRITE SR-RECORD.
KL-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KL-PAGE.
KL-PAGE. MOVE "EXCEPTIONS REPORT" TO FF3.
    MOVE "(FROM PRODUCTION ORDERS GENERATION)" TO FF4 PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF KL-STEP=1 MOVE "PRODUCTION ORDERS (FOR SPECIAL PRODUCTS) CREATED WHILE THERE IS QTY ON-HAND" TO PREC PERFORM PR-LINE-2
      MOVE
         "CUSTOMER    ORDER LN       QTY   PRODUCT      DESCRIPTION                         ON HAND" TO PREC PERFORM PR-LINE-3.
*         ......     ...... .. ..,...,...- ............ ................................ ..,...,...-
    IF KL-STEP=2 MOVE "PRODUCTS IN SURPLUS BUILD CONDITION" TO PREC PERFORM PR-LINE-3.
    IF KL-STEP=3 MOVE "PURCHASED PRODUCTS SUGGESTED REQUISITION" TO PREC PERFORM PR-LINE-2
      MOVE
         "PRODUCT       DESCRIPTION                        REQD QTY    RUN-OUT" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ..,...,...-  ../../..
    IF KL-STEP=4 MOVE "PRODUCTS WITH MISSING ALTERNATE MACHINE ('*' MEANS PRODUCT HAS BUT SHOULD NOT HAVE AN ALTERNATE MACHINE)" TO PREC PERFORM PR-LINE-2.

KM-FIRM. PERFORM KM1 THRU KM9.
KM1. PERFORM PR-RESET PERFORM KM-PAGE.
    IF ITOOL OPEN I-O IFPART ALLOWING ALL IFTOOLS ALLOWING ALL IFTOOLPROD ALLOWING ALL.
    MOVE SYS-DATE TO D-DATE MOVE 28 TO D-DAYS MOVE 1 TO D-N1 PERFORM D-CDTADD.
    MOVE D-DATE TO KM-FDATE.
    PERFORM RDR-INFO.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      MOVE IF-RNO(IX1) TO KM-RNO(IX1)
      IF KM-RNO(IX1)<KM-RMIN(IX1) OR>KM-RMAX(IX1)
        MOVE KM-RMIN(IX1) TO KM-RNO(IX1) END-IF END-PERFORM.
    MOVE 0 TO KM-PSEQ.
KM3. MOVE KM-PSEQ TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO KM6.
    READ PRODORD NEXT REGARDLESS END GO KM6. MOVE R-NO TO KM-PSEQ.
    IF R-NO>9999 GO KM6. IF R-IND=0 GO KM3. MOVE R-PROD TO A-A1 PERFORM PROD-RT.
    IF NOT(P-MAC=99 OR (P-CAT=42 OR 45 OR 48)) IF R-DATE>KM-FDATE GO KM3.
    EVALUATE TRUE
      WHEN P-MAC=99 MOVE 8 TO KM-RX
      WHEN P-CAT>=12 AND<=21 MOVE 1 TO KM-RX
      WHEN P-CAT>=22 AND<=29 MOVE 2 TO KM-RX
      WHEN P-CAT>=30 AND<=39 OR=8 OR 11 MOVE 3 TO KM-RX
      WHEN P-CAT=49 MOVE 4 TO KM-RX
      WHEN P-CAT=52 OR 55 OR 58 MOVE 5 TO KM-RX
      WHEN P-CAT=42 OR 45 OR 48 MOVE 6 TO KM-RX
      WHEN P-CAT>0 AND<=7 OR=10 MOVE 7 TO KM-RX
      WHEN OTHER MOVE 6 TO KM-RX.
    MOVE 1 TO R-TICKET MOVE SYS-DATE TO R-LAST-DATE.
    IF ITOOL PERFORM KM-ITADD IF A-S1=1 GO KM58 ELSE GO KM3.
    MOVE KM-RNO(KM-RX) TO R-NO KM-LNO.
KM5. ADD 1 TO R-NO IF R-NO=KM-LNO GO KM3.
    IF R-NO<KM-RMIN(KM-RX) OR>KM-RMAX(KM-RX) MOVE KM-RMIN(KM-RX) TO R-NO.
    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO KM52.
    READ WORKSHEET NEXT REGARDLESS END GO KM52. IF J-NO=R-NO GO KM5.
KM52. WRITE R-RECORD ALLOWING NO INVALID GO KM5. UNLOCK PRODORD.
    MOVE R-NO TO KM-RNO(KM-RX).

    IF P-MAC NOT=99 GO KM58. MOVE 2 TO WS-PR MOVE R-NO TO FF125.
    MOVE R-PROD TO A-A1 PERFORM RD-PART PERFORM PART-TYPE.
    MOVE PH-VENDOR(1) TO FF126 A-N1 PERFORM RD-VEN MOVE V-NAME TO FF127.
    MOVE R-LAST-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF128.
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF129.
    COMPUTE A-N1=100 * R-SPORD + R-SPLINE PERFORM RD-SALIN.
    IF P-CAT=14 MOVE R-DATE TO D-DATE ELSE MOVE L-DATE-REQ TO D-DATE.
    PERFORM D-NM MOVE D-DT TO FF130 PERFORM KM-LINE.
    MOVE PH-PRICE(1) TO CL-PRICE MOVE PH-MODE TO CL-MODE MOVE 0 TO CL-DISC.
    MOVE R-QTY-ORD TO CL-QTY PERFORM PRICE-CALC.
    MOVE CL-QTY TO FF118 MOVE PH-UNIT TO FF119 MOVE R-PROD TO FF120.
    MOVE PH-DESC1 TO FF121 MOVE PH-PRICE(1) TO FF122 MOVE PH-MODE TO FF123.
    MOVE CL-AMT TO FF124 PERFORM KM-LINE.
    IF PH-DESC2>" " MOVE PH-DESC2 TO FF121 PERFORM KM-LINE.
    IF PH-DRAW>" " PERFORM DRAW-EXP-PH
      MOVE "DRAWING:" TO FF121 MOVE A-A2 TO FF121(10:) PERFORM KM-LINE.

KM58. MOVE KM-PSEQ TO A-N1 PERFORM RD-PRODORD.
    MOVE 0 TO R-IND REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    GO KM3.

KM6. PERFORM RD-INFO.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10 MOVE KM-RNO(IX1) TO IF-RNO(IX1) END-PERFORM.
    PERFORM WR-INFO.

    MOVE " " TO WA1.
KM61. MOVE WA1 TO R-KEY MOVE 0 TO WN1.
    START PRODORD KEY>R-KEY REGARDLESS INVALID GO KM68.
KM63. READ PRODORD NEXT REGARDLESS END GO KM68. IF R-NO>9999 GO KM68.
    MOVE R-KEY TO WA1 IF R-IND=0 GO KM64.
    IF R-LDATE(1) NOT=0 MOVE 0 TO R-LDATE(1) REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    GO KM63.
KM64. DELETE PRODORD ADD 1 TO WN1.
    IF WN1=100 CLOSE PRODORD OPEN I-O PRODORD ALLOWING ALL GO KM61. GO KM63.
KM68.

    MOVE 1 TO A-S1 PERFORM UPDATE-PROD-ORD PERFORM UPDATE-PART-DEM.
    PERFORM SET-SHORT-SCHED PERFORM OPEN-REP.

    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO KM78.
KM73. READ PRODORD NEXT REGARDLESS END GO KM78.
    IF R-FIN=1 OR R-QTY-ORD<=R-QTY-PROD GO KM73.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO KM73. PERFORM RD-GEN.
    IF P-MAC=99 GO KM73. PERFORM INIT-RP.
* note 191.1
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL XM-F6(IX1)=0
      IF R-NO=XM-F8(IX1) MOVE XM-F6(IX1) TO RP-F8 MOVE 0 TO RP-F9
        MOVE XM-F7(IX1) TO RP-F10 MOVE 0 TO RP-F11 GO KM74 END-IF END-PERFORM.
    MOVE P-MAC TO RP-F8 MOVE 1 TO RP-F9 MOVE 0 TO RP-F10 MOVE R-DATE TO RP-F11.
KM74. MOVE R-KEY TO RP-F12 WRITE RP-RECORD GO KM73.
KM78.

* note 20
    PERFORM RDR-INFO MOVE 0 TO OLD-M KM-MTOT COMPUTE KM-SDATE=SYS-DATE + 1.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO KM89.
KM83. READ REPFL NEXT END GO KM89. MOVE RP-F12 TO R-KEY READ PRODORD REGARDLESS.
    IF RP-F8 NOT=OLD-M MOVE RP-F8 TO OLD-M A-N1 PERFORM RD-MAC
      IF M-HOURS=0 MOVE 15 TO M-HOURS END-IF
      MOVE 0 TO KM-MTOT COMPUTE KM-SDATE=SYS-DATE + 1.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT.
KM85. MOVE KM-SDATE TO D-DATE PERFORM D-OFFDAY IF D-N1>0 ADD 1 TO KM-SDATE GO KM85.
    IF KM-MTOT<0 ADD M-HOURS TO KM-MTOT ADD 1 TO KM-SDATE GO KM85.
    IF KM-SDATE NOT=R-DATE MOVE KM-SDATE TO R-LDATE(1)
      REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    COMPUTE WN1 ROUNDED=(R-QTY-ORD - R-QTY-PROD) / P-RATE SIZE ERROR MOVE 0 TO WN1.
    SUBTRACT WN1 FROM KM-MTOT GO KM83.
KM89. IF ITOOL CLOSE IFPART IFTOOLS IFTOOLPROD.
    PERFORM CLOSE-REP.
KM9. EXIT.

KM-ITADD. PERFORM KM-IT1 THRU KM-IT9.
KM-IT1. MOVE 0 TO A-S1 IF R-SPORD=0 GO KM-IT9.
    MOVE R-SPORD TO R-NO WRITE R-RECORD ALLOWING NO INVALID GO KM-IT9. UNLOCK PRODORD.
    MOVE P-NO TO IFPH-NO READ IFPART INTO PH-RECORD REGARDLESS INVALID GO KM-IT8.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=1) GO KM-IT8.
    MOVE P-NO TO A-A1 PERFORM TL-SET-ASM IF A-S1=1 GO KM-IT8.
    MOVE 0 TO KM-TNUM MOVE 1 TO TL-IXF.
KM-IT3. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO KM-IT4.
    IF NOT(TL-PAGE>0 AND TL-STN=TL-ASTN AND TL-CAT=TL-ACAT AND TL-LOC>0) GO KM-IT4.
    IF KM-TNUM<9 ADD 1 TO KM-TNUM COMPUTE R-NO=10 * R-SPORD + KM-TNUM.
    MOVE TS-TOOL(TL-FLD) TO R-PROD.
    WRITE R-RECORD ALLOWING NO INVALID CONTINUE. UNLOCK PRODORD.
KM-IT4. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO KM-IT3.
KM-IT8. MOVE 1 TO A-S1.
KM-IT9. EXIT.
KM-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KM-PAGE.
KM-PAGE. MOVE "PURCHASED FINISHED GOODS REPORT" TO FF3.
    MOVE "(SUGGESTED REQUISITIONS)" TO FF4 PERFORM PR-PAGE.
    MOVE "  M.O.  VEND  NAME                                 ORDER DATE  IN-HOUSE DATE  DUE DATE" TO PREC PERFORM PR-LINE.
    MOVE "       QTY  UNIT  PART NO.      DESCRIPTION                           PRICE  MODE     TOTAL" TO PREC PERFORM PR-LINE-3.
*         ......  ....  ....................................  ../../..      ../../..    ../../..
*            ...,...  ....  ............  ................................ ...,...:... .... ...,...:..

* Z-35 PRODUCTION SHORT SCHEDULE REPORT
KR1. PERFORM RD373 PERFORM WRT.
    IF S-BAT MOVE S-N1 TO KR-NM MOVE S-S1 TO KR-KSEP MOVE S-S2 TO KR-KSORT GO KR2.
    MOVE 0 TO KR-NM MOVE 9 TO IXU.
KR13. ADD 1 TO KR-NM ADD 3 TO IXU.
    ACCEPT KR-MAC LINE 3 COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF KR-MAC=0 SUBTRACT 1 FROM KR-NM GO KR14.
    MOVE KR-MAC TO RNUM1(KR-NM) IF KR-NM<10 GO KR13.
KR14. ACCEPT XA3 LINE 5 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO KR-KSEP ELSE MOVE 0 TO KR-KSEP.
KR15. ACCEPT XA2 LINE 6 COLUMN 66 DEFAULT "LH" UNDERLINED PROTECTED EDITING.
    IF NOT(XA2="LH" OR "HL") PERFORM DSP-ERR2 GO KR15.
    MOVE 0 TO KR-KSORT IF XA2="HL" MOVE 1 TO KR-KSORT.
    MOVE 7 TO IXT MOVE 14 TO IXU PERFORM AX-DT-VAL.
    MOVE 9 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE KR-NM TO S-N1 MOVE KR-KSEP TO S-S1 MOVE KR-KSORT TO S-S2 GO MX9.
KR2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE SYS-DATE TO DATE1 MOVE DATE0 TO DATE2.

    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO KR29.
KR23. READ PRODORD NEXT REGARDLESS END GO KR29.
    IF R-DATE>DATE2 OR R-QTY-LEFT<=0 OR R-QTY-PROD NOT=0 GO KR23.
    MOVE R-PROD TO A-A1 PERFORM PROD-GEN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>KR-NM
      IF P-MAC=RNUM1(IX1) GO KR24 END-IF END-PERFORM. GO KR23.
KR24. PERFORM INIT-RP MOVE 0 TO RP-F51 IF KR-KSEP=1 MOVE P-MAC TO RP-F51.
    IF KR-KSORT=0 MOVE P-WIRE TO RP-F51A ELSE COMPUTE RP-F51A=9.9999 - P-WIRE.
    MOVE P-CAT TO RP-F52 MOVE P-NO TO RP-F53 MOVE P-DIAM TO RP-F54.
    MOVE P-GRADE TO RP-F55 MOVE R-KEY TO RP-F56 WRITE RP-RECORD GO KR23.
KR29. PERFORM OPEN-PR MOVE LOW-VALUES TO KR-MTOTALS.
    IF KR-KSEP=0 PERFORM KR-PAGE ELSE MOVE 0 TO OLD-M.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO KR9.
KR3. READ REPFL NEXT END GO KR9. IF KR-KSEP=0 GO KR4.
    IF RP-F51=OLD-M GO KR4. IF OLD-M NOT=0 PERFORM KR-T PERFORM PR-RESET.
    MOVE RP-F51 TO OLD-M PERFORM KR-PAGE MOVE LOW-VALUES TO KR-MTOTALS.
KR4. MOVE RP-F56 TO R-KEY READ PRODORD REGARDLESS.
    MOVE R-NO TO FA570 MOVE R-PROD TO A-A1 PERFORM PROD-RGD MOVE P-MAC TO FA571.
    MOVE P-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FA572.
    MOVE P-NO TO FA573 MOVE P-CAT TO FA574 MOVE PRO-DESC(1) TO FA575.
    PERFORM SET-PART MOVE PART-NO TO FA576.
    COMPUTE KR-HOURS ROUNDED=R-QTY-ORD / P-RATE SIZE ERROR MOVE 0 TO KR-HOURS.
    MOVE R-QTY-ORD TO FA577 MOVE KR-HOURS TO FA578.
    ADD R-QTY-ORD TO KR-MQTY ADD KR-HOURS TO KR-MHOURS.

    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA579.
    PERFORM FIND-RLDATE COMPUTE WN1=D-DATE - R-DATE.
    IF WN1>0 ADD KR-HOURS TO KR-MLATE(A-X1).
    IF WN1 NOT=0 PERFORM D-NM MOVE D-DT TO FA580
      MOVE LIT-MRT(A-X1:1) TO FA581 MOVE WN1 TO FA582.
    PERFORM KR-LINE GO KR3.
KR9. PERFORM KR-T.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

KR-T. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO PREC.
    MOVE KR-MQTY TO FA577 MOVE KR-MHOURS TO FA578 PERFORM KR-LINE 2 TIMES.
    MOVE "*** TOTAL HOURS LATE:" TO FA587.
    MOVE "MACHINE" TO FA588 MOVE KR-MLATE(1) TO FA589 PERFORM PR-LINE.
    MOVE "MATERIAL" TO FA588 MOVE KR-MLATE(2) TO FA589 PERFORM PR-LINE.
    MOVE "TOOLS" TO FA588 MOVE KR-MLATE(3) TO FA589 PERFORM PR-LINE.
KR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KR-PAGE.
KR-PAGE. MOVE "PRODUCTION SHORT SCHEDULE REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    IF KR-KSORT=0 MOVE "LOW TO HIGH" TO FA583 ELSE MOVE "HIGH TO LOW" TO FA583.
    MOVE " WIRE SIZE. MACHINE" TO FA584.
    IF KR-KSEP=1 MOVE ":" TO FA585 MOVE OLD-M TO FA586(1)
      ELSE MOVE "S:" TO FA585 PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>KR-NM
        MOVE RNUM1(PR-IX1) TO FA586(PR-IX1) END-PERFORM.
    PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "  M.O. MAC WIRE    PRODUCT      CAT  DESCRIPTION                       MATERIAL          QTY     HOURS     DATE      LATE     DAYS" TO PREC PERFORM PR-LINE-3.
*         ...... ..  ......  ............  ..  ................................  ............ ..,...,... ..,...    ../../..  ../../.. . ...-

* Z-16: FINANCIALS FUNCTIONS

* Z-16-1 SUBCONTRACTOR INVENTORY VALUE REPORT
FE1. PERFORM RD327 PERFORM WRT IF S-BAT GO FE2.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-CAT-R.
    MOVE 4 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-MAC-R.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
FE2. PERFORM DSP-WAIT PERFORM RDR-INFO PERFORM OPEN-REP MOVE " " TO PRO-NSV.
FE23. MOVE PRO-NSV TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO FE29.
    READ PRODUCT NEXT REGARDLESS END GO FE29.
    MOVE P-KEY TO PRO-NSV MOVE P-CAT TO PRO-CATSV.
    IF P-HAND<=0 GO FE23. PERFORM RD-GEN IF NOT(P-CAT>=CAT1 AND<=CAT2) GO FE23.
    PERFORM GET-OP IF A-S1=1 GO FE23.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT MOVE 0 TO CST-IXT MOVE 1 TO IX1.
FE25. MOVE OP-OPER(IX1) TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO FE26.
    IF NOT(OP-OPER(IX1)>=MAC1 AND<=MAC2) GO FE26.
    MOVE OP-OPER(IX1) TO M-NO READ MACHINE REGARDLESS INVALID GO FE26.
    IF OP-COST(IX1)>0 MOVE OP-COST(IX1) TO CST-WAMT MOVE OP-CMODE(IX1) TO A-A1
      ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    IF IFAST OR INUT PERFORM COST-M COMPUTE WT1 ROUNDED=CST-WAMT * CST-MULT
      ELSE COMPUTE WT1 ROUNDED=CST-WAMT * CST-NET / 100.
    PERFORM INIT-RP MOVE PRO-CATSV TO RP-F264 MOVE PRO-NSV TO RP-F265.
    ADD 1 TO CST-IXT MOVE OP-OPER(IX1) TO RP-F267 MOVE WT1 TO RP-F268.
    WRITE RP-RECORD INVALID READ REPFL ADD WT1 TO RP-F268 REWRITE RP-RECORD.
FE26. ADD 1 TO IX1 IF IX1<=12 GO FE25.
* note 43.2
    IF IFAST OR INUT COMPUTE WT1 ROUNDED=CST-IXT * IF-CST-FREIGHT * CST-NMULT
      ELSE COMPUTE WT1 ROUNDED=CST-IXT * IF-CST-FREIGHT * CST-NET / 100.
    IF WT1 NOT=0 PERFORM INIT-RP MOVE PRO-CATSV TO RP-F264 MOVE PRO-NSV TO RP-F265
      MOVE 9003 TO RP-F267 MOVE WT1 TO RP-F268 WRITE RP-RECORD.
    GO FE23.
FE29. PERFORM OPEN-PR PERFORM FE-PAGE.
    MOVE LOW-VALUES TO FE-STOTALS FE-GTOTALS MOVE 0 TO OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FE9.
FE3. READ REPFL NEXT END GO FE9. MOVE RP-F265 TO A-A1 PERFORM PROD-RD.
    IF RP-F264=OLD-N GO FE34. IF OLD-N NOT=0 PERFORM FE-S.
    MOVE "CAT" TO FF451 MOVE RP-F264 TO FF452.
    MOVE P-CAT TO PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FF453.
    PERFORM FE-LINE 2 TIMES MOVE P-CAT TO OLD-N MOVE " " TO OLD-A.
FE34. IF P-NO=OLD-A GO FE4. MOVE P-NO TO FF454 MOVE PRO-DESC(1) TO FF455.
    MOVE P-HAND TO FF456 MOVE P-WEIGHT TO FF457.
    COMPUTE FE-PWEIGHT ROUNDED=P-HAND * P-WEIGHT / 100 MOVE FE-PWEIGHT TO FF458.
    ADD P-HAND TO FE-SH FE-GH ADD FE-PWEIGHT TO FE-SW FE-GW MOVE P-NO TO OLD-A.
FE4. IF RP-F267<=999 MOVE RP-F267 TO FF459 A-N1 PERFORM RD-MAC MOVE M-OPDESC TO FF460
       ELSE IF RP-F267=9003 MOVE "FREIGHT" TO FF460.
    MOVE RP-F268 TO FF461.
    IF IFAST OR INUT COMPUTE WD1 ROUNDED=P-HAND * RP-F268 / 1000
      ELSE COMPUTE WD1 ROUNDED=P-HAND * RP-F268.
    MOVE WD1 TO FF462 ADD WD1 TO FE-SV FE-GV PERFORM FE-LINE GO FE3.
FE9. PERFORM FE-S MOVE "*** GRAND TOTALS" TO FF455.
    MOVE FE-GH TO FF456 MOVE FE-GW TO FF458 MOVE FE-GV TO FF462 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

FE-S. MOVE 2 TO WS-PR MOVE " ** CATEGORY TOTALS" TO FF455.
    MOVE FE-SH TO FF456 MOVE FE-SW TO FF458 MOVE FE-SV TO FF462 PERFORM FE-LINE 3 TIMES.
    MOVE LOW-VALUES TO FE-STOTALS.
FE-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FE-PAGE.
FE-PAGE. MOVE "SUBCONTRACTOR INVENTORY VALUE REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-CAT MOVE 1 TO WS-PR PERFORM PRANGE-PROC.
    MOVE "PRODUCT       DESCRIPTION                         ON HAND    WT/C   WT ON HD   PROCESS            COST/M        VALUE" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ..,...,...- ...:.. ..,...,...-  ... ..........  .,...:... ..,...,...:..-

* Z-16-2 SUBCONTRACTOR WORK-IN-PROCESS VALUE REPORT
FI1. PERFORM RD328 PERFORM WRT IF S-BAT GO FI2.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 38 TO IXV PERFORM AX-MAC-R.
    MOVE 5 TO IXT MOVE 14 TO IXU PERFORM AX-DT-VAL.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
FI2. PERFORM DSP-WAIT PERFORM RDR-INFO PERFORM OPEN-REP.
    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO FI29.
FI23. READ PRODORD NEXT REGARDLESS END GO FI29. IF R-FIN=0 OR R-QTY-LEFT<=0 GO FI23.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT PERFORM GET-OP IF A-S1=1 GO FI23.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT.
    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO FI28.
FI25. READ WORKSHEET NEXT REGARDLESS END GO FI28. IF J-NO NOT=R-NO GO FI28.
    IF NOT(J-DATE<=DATE0 AND J-MAC>=MAC1 AND<=MAC2) GO FI25.
    MOVE J-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO FI25.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>12
      IF OP-OPER(IX1)=J-MAC MOVE 1 TO WS1 GO FI254 END-IF END-PERFORM.
FI254. MOVE J-MAC TO A-N1 PERFORM RD-MAC.
    IF WS1=1 AND OP-COST(IX1)>0 MOVE OP-COST(IX1) TO CST-WAMT MOVE OP-CMODE(IX1) TO A-A1
      ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    IF IFAST OR INUT PERFORM COST-M COMPUTE WT1 ROUNDED=CST-WAMT * CST-MULT
      ELSE COMPUTE WT1 ROUNDED=CST-WAMT * CST-NET / 100.
    PERFORM INIT-RP MOVE P-NO TO RP-F269 MOVE R-NO TO RP-F270.
    MOVE 0 TO RP-F270A MOVE J-MAC TO RP-F271 MOVE R-QTY-LEFT TO RP-F272.
    MOVE WT1 TO RP-F273 MOVE J-QTY TO RP-F274.
    WRITE RP-RECORD INVALID READ REPFL ADD J-QTY TO RP-F274 REWRITE RP-RECORD.
    IF IFAST OR INUT COMPUTE WT1 ROUNDED=IF-CST-FREIGHT * CST-NMULT
       ELSE COMPUTE WT1 ROUNDED=IF-CST-FREIGHT * CST-NET / 100.
    PERFORM INIT-RP MOVE P-NO TO RP-F269 MOVE R-NO TO RP-F270.
    MOVE 1 TO RP-F270A MOVE J-MAC TO RP-F271 MOVE R-QTY-LEFT TO RP-F272.
    MOVE WT1 TO RP-F273 MOVE J-QTY TO RP-F274.
    IF WT1 NOT=0 WRITE RP-RECORD INVALID READ REPFL ADD J-QTY TO RP-F274 REWRITE RP-RECORD.
    GO FI25.
FI28. GO FI23.
FI29. PERFORM OPEN-PR PERFORM FI-PAGE.
    MOVE LOW-VALUES TO FI-PTOTALS FI-GTOTALS MOVE " " TO OLD-A MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FI9.
FI3. READ REPFL NEXT END GO FI9. IF RP-F269=OLD-A GO FI34.
    IF OLD-A>" " PERFORM FI-P. MOVE RP-F269 TO FF464 A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO FF465 MOVE RP-F269 TO OLD-A MOVE 0 TO OLD-N.
FI34. IF RP-F270=OLD-N GO FI4. MOVE RP-F270 TO FF466 MOVE RP-F272 TO FF466A.
    MOVE RP-F270 TO OLD-N.
FI4. IF RP-F270A=0 MOVE RP-F271 TO FF467 A-N1 PERFORM RD-MAC MOVE M-OPDESC TO FF468
       ELSE MOVE "FREIGHT" TO FF468.
    MOVE RP-F273 TO FF469.
    MOVE RP-F274 TO WN1 IF RP-F272<WN1 MOVE RP-F272 TO WN1. MOVE WN1 TO FF470.
    IF IFAST OR INUT COMPUTE WD1 ROUNDED=WN1 * RP-F273 / 1000
      ELSE COMPUTE WD1 ROUNDED=WN1 * RP-F273.
    IF RP-F270A=0 COMPUTE WN1 ROUNDED=WN1 * P-WEIGHT / 100
      MOVE WN1 TO FF471 ADD WN1 TO FI-PW FI-GW.
    MOVE WD1 TO FF472 ADD WD1 TO FI-PV FI-GV PERFORM FI-LINE GO FI3.
FI9. PERFORM FI-P MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FF465.
    MOVE FI-GW TO FF471 MOVE FI-GV TO FF472 MOVE "**" TO FF473 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

FI-P. MOVE FI-PW TO FF471 MOVE FI-PV TO FF472 MOVE "*" TO FF473 PERFORM FI-LINE.
    MOVE LOW-VALUES TO FI-PTOTALS.
FI-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FI-PAGE.
FI-PAGE. MOVE "SUBCONTRACTOR WORK-IN-PROCESS VALUE REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "ON:" TO A-A1 PERFORM PRANGE-DT MOVE 1 TO WS-PR PERFORM PRANGE-PROC.
    MOVE "PRODUCT       DESCRIPTION                        M.O.    QTY LEFT   PROCESS            COST/M       QTY     WEIGHT        VALUE" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ...... ..,...,...-   ... ..........  .,...:... .,...,...- .,...,...- ..,...,...:..-..

* Z-16-3 CREATE A/R EXPORT FILE
HA1. PERFORM RD329 PERFORM WRT.
    MOVE "IFE" TO IFG-ID IF INUT MOVE "INE" TO IFG-ID.
    ADD 2 TO IXT DISPLAY "FILE NAME: " LINE IXT BOLD IFG-ID ".DAT".
    PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT OPEN OUTPUT IFGFL MOVE " " TO C-KEY MOVE 0 TO WN1.
    START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO HA9.
HA3. READ CUSTOMER NEXT REGARDLESS END GO HA9. MOVE LOW-VALUES TO HA-TOTALS.
    MOVE C-NO TO TR-CUS MOVE 0 TO TR-INV.
    START TRANS KEY>TR-KEY REGARDLESS INVALID GO HA6.
HA5. READ TRANS NEXT REGARDLESS END GO HA6. IF TR-CUS>C-NO GO HA6.
    IF TR-AMT NOT=0 ADD TR-AMT TO HA-TOT COMPUTE WN1=SYS-DATE - TR-DATE
      IF WN1>=120 ADD TR-AMT TO HA-120 ELSE IF WN1>=90 ADD TR-AMT TO HA-90
        ELSE IF WN1>=60 ADD TR-AMT TO HA-60 ELSE IF WN1>=30 ADD TR-AMT TO HA-30
          ELSE ADD TR-AMT TO HA-CUR.
    GO HA5.
HA6. IF HA-CUR=0 AND HA-30=0 AND HA-60=0 AND HA-90=0 AND HA-120=0 GO HA88.
    ADD 1 TO WN1 MOVE " " TO HC-RECORD MOVE C-NO(1:5) TO HC-NO1.
    MOVE C-NAME TO HC-NAME WRITE HC-RECORD.
    MOVE " " TO HC-RECORD MOVE C-NO(1:5) TO HC-NO2.
    MOVE C-ADD1 TO HC-ADD1 MOVE C-ADD2 TO HC-ADD2.
    MOVE "C" TO HC-PAYCUR IF C-US=1 MOVE "U" TO HC-PAYCUR.
    MOVE "09" TO HC-CODE IF INUT MOVE "12" TO HC-CODE. WRITE HC-RECORD.
    MOVE " " TO HC-RECORD MOVE C-NO(1:5) TO HC-NO3.
    MOVE C-CREDIT TO HC-CREDIT MOVE HA-TOT TO HC-TOT MOVE HA-CUR TO HC-CUR.
    MOVE HA-30 TO HC-30 MOVE HA-60 TO HC-60 MOVE HA-90 TO HC-90.
    MOVE HA-120 TO HC-120 MOVE 0 TO HC-RACKS WRITE HC-RECORD.
HA88. GO HA3.
HA9. MOVE " " TO HC-RECORD MOVE "*****" TO HC-NO1 MOVE "END-OF-FILE" TO HC-NAME WRITE HC-RECORD.
    MOVE " " TO HC-RECORD MOVE "*****" TO HC-NO2 HC-ADD1 MOVE WN1 TO HC-NREC WRITE HC-RECORD.
    MOVE " " TO HC-RECORD MOVE "*****" TO HC-NO3 WRITE HC-RECORD.
    CLOSE IFGFL GO MX9.

* Z-16-4 PRODUCT COST UPDATE
AI1. PERFORM RD330 PERFORM WRT.
    IF S-BAT MOVE S-A1 TO AI-PERIOD MOVE S-S1 TO AI-KUP GO AI2.
AI13. ACCEPT AI-PERIOD LINE 3 COLUMN 22 DEFAULT " " UNDERLINED PROTECTED EDITING.
    IF AI-PERIOD=" " PERFORM DSP-ERR2 GO AI13.
    ACCEPT XA3 LINE 4 COLUMN 34 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO AI-KUP ELSE MOVE 0 TO AI-KUP.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE AI-PERIOD TO S-A1 MOVE AI-KUP TO S-S1 GO MX9.
AI2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM AI-PAGE.
    MOVE 0 TO CST-KN PERFORM COST-NUT.

    IF AI-KUP=0 GO AI28. PERFORM RD-INFO.
    PERFORM VARYING IX1 FROM 7 BY -1 UNTIL IX1=0
      MOVE IF-CST-PERIOD(IX1) TO IF-CST-PERIOD(IX1 + 1)
      MOVE IF-CST-NUM(IX1) TO IF-CST-NUM(IX1 + 1) END-PERFORM.
    MOVE AI-PERIOD TO IF-CST-PERIOD(1).
    IF IF-CST-NUM(1)=99 MOVE 1 TO IF-CST-NUM(1) ELSE ADD 1 TO IF-CST-NUM(1).
    PERFORM WR-INFO.

AI28. MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO AI4.
AI3. READ PRODUCT NEXT REGARDLESS END GO AI4. IF P-GEN>" " OR P-CAT>60 GO AI3.
    MOVE 0 TO CST-IXE CST-M-TOT CST-T-TOT CST-C-TOT.
    IF ITOOL GO AI32. MOVE P-MAC TO M-NO.
    READ MACHINE REGARDLESS INVALID MOVE "MM" TO A-A1 PERFORM COST-E GO AI38.
    IF NOT(IFAST AND P-MAC=99 OR INUT)
      PERFORM GET-TS IF A-S1=1 MOVE "TT" TO A-A1 PERFORM COST-E GO AI38.
AI32. PERFORM GET-OP IF A-S1=1 MOVE "OO" TO A-A1 PERFORM COST-E GO AI38.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE P-MAC TO CST-MAC MOVE " " TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI CST-KQ MOVE 1 TO CST-MODE PERFORM COST-CALC.

    IF AI-KUP=0 GO AI38.
    MOVE CST-MFG TO P-COST REWRITE P-RECORD ALLOWING NO UNLOCK PRODUCT.
    MOVE LOW-VALUES TO CU-RECORD INITIALIZE CU-REC MOVE P-NO TO CU-PROD.
    MOVE 0 TO WS1 READ COSTHIST REGARDLESS INVALID MOVE 1 TO WS1.
    PERFORM VARYING IX1 FROM 7 BY -1 UNTIL IX1=0
      MOVE CU-HIST(IX1) TO CU-HIST(IX1 + 1) END-PERFORM.
    MOVE IF-CST-NUM(1) TO CU-NUM(1) MOVE P-MAC TO CU-MAC(1).
    MOVE CST-M-TOT TO CU-TOT(1,1) MOVE CST-T-TOT TO CU-TOT(1,2).
    MOVE CST-C-TOT TO CU-TOT(1,3) MOVE CST-C-TOOLS TO CU-TOT(1,4).
    MOVE 0 TO CST-IXE MOVE 3 TO CST-MODE PERFORM COST-CALC.
    MOVE CST-M-TOT TO CU-NTOT(1,1) MOVE CST-T-TOT TO CU-NTOT(1,2).
    MOVE CST-C-TOT TO CU-NTOT(1,3) MOVE CST-C-TOOLS TO CU-NTOT(1,4).
    IF WS1=0 REWRITE CU-RECORD ALLOWING NO ELSE WRITE CU-RECORD ALLOWING NO.
    UNLOCK COSTHIST.

AI38. MOVE P-NO TO FA305 MOVE P-MAC TO FA306.
    MOVE CST-M-TOT TO FA307 MOVE CST-T-TOT TO FA308 MOVE CST-C-TOT TO FA309.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>CST-IXE
      MOVE CST-ERR(IX1) TO FA310(IX1) END-PERFORM.
    PERFORM AI-LINE GO AI3.
AI4. PERFORM CLOSE-PR.
AI9. GO MX9.

AI-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AI-PAGE.
AI-PAGE. MOVE "PRODUCT COST UPDATE" TO FF3 MOVE AI-PERIOD TO FF4 PERFORM PR-PAGE.
    MOVE "PRODUCT       MAC  MATERIAL   THIRD PARTY   CONVERSION    ERRORS" TO PREC PERFORM PR-LINE-3.
*         ............  ..   ....:...     ....:...     ....:...     .. .. .. .. .. .. .. .. .. ..

* Z-16-5 PRODUCT CONTRIBUTION REPORTS
AS1. PERFORM RD314 PERFORM WRT.
    IF S-BAT MOVE S-N1 TO AS-NUM MOVE S-N2 TO AS-HSEL MOVE S-A1 TO AS-PERIOD
      MOVE S-S1 TO AS-KLST MOVE S-S2 TO AS-KSUM GO AS2.
    PERFORM AX-SEL IF SEL-N=0 OR>5 GO MX1. PERFORM RDR-INFO.
* note 217
    IF Y4 MOVE 3 TO SEL-N MOVE 1 TO AS-KSUM ELSE MOVE 0 TO AS-KSUM.
    IF Y5 MOVE 0 TO AS-HSEL GO AS14.
AS13. ACCEPT AS-HSEL LINE 3 COLUMN 63 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF AS-HSEL=0 OR>3 PERFORM DSP-ERR2 GO AS13.
    IF AS-HSEL=3 MOVE 1 TO MTH1 MOVE 12 TO MTH2 GO AS14.
AS133. ACCEPT XN2 LINE 7 COLUMN 73 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(XN2>=1 AND<=12) PERFORM DSP-ERR2 GO AS133. MOVE XN2 TO MTH1.
AS135. ACCEPT XN2 LINE 7 COLUMN 78 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(XN2>=1 AND<=12) PERFORM DSP-ERR2 GO AS135. MOVE XN2 TO MTH2.
AS14. DISPLAY "VALID PERIODS:" LINE 22 BOLD MOVE 22 TO IXT MOVE 16 TO IXU.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      IF IX1=5 ADD 1 TO IXT MOVE 16 TO IXU END-IF
      DISPLAY IF-CST-PERIOD(IX1) LINE IXT COLUMN IXU ADD 15 TO IXU END-PERFORM.
AS143. MOVE IF-CST-PERIOD(1) TO AS-PERIOD.
    ACCEPT AS-PERIOD LINE 10 COLUMN 23 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    IF AS-PERIOD=" " PERFORM DSP-ERR2 GO AS143.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      IF IF-CST-PERIOD(IX1)=AS-PERIOD MOVE IF-CST-NUM(IX1) TO AS-NUM GO AS16 END-IF END-PERFORM.
    MOVE "PERIOD NOT FOUND IN COST HISTORY FILE" TO ERR-MESG PERFORM DSP-ERR GO AS143.
AS16. DISPLAY " " LINE 22 ERASE END SCREEN.
    IF Y5 MOVE 16 TO IXT MOVE 13 TO IXU MOVE 39 TO IXV PERFORM AX-DATE-R
      ELSE MOVE 12 TO IXT MOVE 17 TO IXU MOVE 43 TO IXV PERFORM AX-CAT-R
        MOVE 13 TO IXT MOVE 17 TO IXU MOVE 43 TO IXV PERFORM AX-MAC-R
        MOVE 14 TO IXT MOVE 17 TO IXU MOVE 43 TO IXV PERFORM AX-CUS-R.
    MOVE 0 TO AS-KLST.
    IF Y3 ACCEPT XA3 LINE 18 COLUMN 60 DEFAULT " " UNDERLINED PROTECTED
      IF XA3="YES" MOVE 1 TO AS-KLST.
    MOVE 20 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE AS-NUM TO S-N1 MOVE AS-HSEL TO S-N2 MOVE AS-PERIOD TO S-A1
      MOVE AS-KLST TO S-S1 MOVE AS-KSUM TO S-S2 GO MX9.
AS2. PERFORM DSP-WAIT PERFORM OPEN-SORT.
    IF Y3 AND AS-KSUM=1 PERFORM OPEN-SORC.
    MOVE 99 TO A-N1 PERFORM RD-MACTYPE COMPUTE AS-MECOST=ME-COST.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-YEAR TO AS-YEAR.
    IF AS-HSEL=2 SUBTRACT 1 FROM AS-YEAR. IF AS-HSEL=3 SUBTRACT 2 FROM AS-YEAR.

    MOVE 0 TO AS-RNUM INITIALIZE SH-KEY IF NOT Y5 MOVE CUS1 TO SH-CUS.
    START SALHIST KEY>SH-KEY REGARDLESS INVALID GO AS29.
AS23. READ SALHIST NEXT REGARDLESS END GO AS29.
    IF Y5 IF SH-DATE>=DATE1 AND<=DATE2 GO AS24 ELSE GO AS23.
    IF SH-CUS>CUS2 GO AS29. IF NOT(SH-CAT>=CAT1 AND<=CAT2) GO AS23.
    MOVE SH-DATE TO D-DATE PERFORM D-NM MOVE 0 TO AS-KRAN.
    IF D-YEAR<AS-YEAR OR D-YEAR=AS-YEAR AND D-MM<MTH1 GO AS23.
    IF D-YEAR=AS-YEAR AND (D-MM>=MTH1 AND<=MTH2) GO AS24.
    IF AS-KLST=1 MOVE 1 TO AS-KRAN GO AS24. GO AS23.
AS24. MOVE SH-PROD TO A-A1 PERFORM PROD-GEN.
    IF NOT Y5 IF NOT(P-MAC>=MAC1 AND<=MAC2) GO AS23. PERFORM INIT-SR.
    IF Y1 MOVE SH-CAT TO SR-F182. IF Y2 MOVE P-MAC TO SR-F182.
    IF Y3 MOVE SH-CUS TO SR-F181. IF Y5 MOVE SH-ORD TO SR-F182.
    MOVE P-NO TO SR-F183 MOVE P-MAC TO SR-F189 MOVE P-HAND TO SR-F195.
    PERFORM SET-PART MOVE PART-NO TO SR-F196.
    MOVE SH-AMT TO AS-VAL IF SH-US=1 MOVE SH-DATE TO D-DATE MOVE AS-VAL TO A-T1
      PERFORM EXCHG-CONV MOVE A-D1 TO AS-VAL.
    MOVE SH-QTY TO SR-F185 MOVE SH-WEIGHT TO SR-F186 MOVE AS-VAL TO SR-F187.
    IF P-MAC NOT=99 MOVE AS-MECOST TO SR-F188.
    IF Y3 MOVE SH-DATE TO SR-F192
      COMPUTE AS-PRICE ROUNDED=AS-VAL * 1000 / SH-QTY SIZE ERROR MOVE 0 TO AS-PRICE END-COMPUTE
      MOVE AS-PRICE TO SR-F193
      IF SH-SUR>0 MOVE 1 TO AS-SIND ELSE MOVE 0 TO AS-SIND END-IF
      MOVE AS-SIND TO SR-F194.
    IF Y5 MOVE SH-DATE-REQ TO SR-F190 MOVE SH-DATE TO SR-F191
      ADD 1 TO AS-RNUM MOVE AS-RNUM TO SR-F184.
    IF AS-KRAN=1 READ SORTFL INVALID GO AS28 END-READ
      MOVE SH-DATE TO SR-F192 MOVE AS-PRICE TO SR-F193 MOVE AS-SIND TO SR-F194
      REWRITE SR-RECORD GO AS28.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD SH-QTY TO SR-F185 ADD SH-WEIGHT TO SR-F186 ADD AS-VAL TO SR-F187
      IF Y3 MOVE SH-DATE TO SR-F192 MOVE AS-PRICE TO SR-F193
        MOVE AS-SIND TO SR-F194 END-IF REWRITE SR-RECORD.
AS28. GO AS23.
AS29. IF NOT Y5 PERFORM OPEN-PR PERFORM AS-PAGE.
    IF Y3 OR Y5 MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    IF Y3 MOVE AS-HEADLN1 TO EXP-RECORD PERFORM EXP-HEADLN.
    IF Y5 MOVE AS-HEADLN2 TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE LOW-VALUES TO AS-STOTALS AS-GTOTALS MOVE " " TO OLD-C MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>=SR-KEY INVALID GO AS8.
AS3. READ SORTFL NEXT END GO AS8.
    IF Y1 IF SR-F182=OLD-N GO AS34 END-IF IF OLD-N NOT=0 PERFORM AS-T END-IF
      MOVE SR-F182 TO OLD-N DSP-N21 PRO-CAT PERFORM DESC-CAT
      STRING "CATEGORY " DSP-N21 "  " T-LINE DELIMITED SIZE INTO PREC PERFORM AS-LINE 2 TIMES.
    IF Y2 IF SR-F182=OLD-N GO AS34 END-IF IF OLD-N NOT=0 PERFORM AS-T END-IF
      MOVE SR-F182 TO OLD-N DSP-N21 A-N1 PERFORM RD-MAC
      STRING "MACHINE " DSP-N21 "  " M-DESC1 DELIMITED SIZE INTO PREC PERFORM AS-LINE 2 TIMES.
    IF Y3 IF SR-F181=OLD-C GO AS34 END-IF IF OLD-C>" " PERFORM AS-T END-IF
      MOVE SR-F181 TO OLD-C A-A1 PERFORM RD-CUS
      STRING "CUSTOMER " SR-F181 " " C-NAME DELIMITED SIZE INTO PREC PERFORM AS-LINE 2 TIMES.
AS34. MOVE SR-F185 TO AS-QTY MOVE SR-F186 TO AS-WEIGHT MOVE SR-F187 TO AS-VAL.
    IF AS-KLST=1 COMPUTE AS-VAL ROUNDED=SR-F193 * SR-F185 / 1000.
    MOVE SR-F183 TO FG71 MOVE SR-F189 TO FG72.
    COMPUTE FG73 ROUNDED=AS-QTY / 1000.
    COMPUTE FG74 ROUNDED=AS-VAL COMPUTE FG75 ROUNDED=AS-WEIGHT / 2000.
    IF Y3 AND AS-KSUM=0
      MOVE SR-F183 TO A-A1 PERFORM PROD-RD
      MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT
      MOVE AS-PERIOD TO EXP-A PERFORM EXPF MOVE AS-YEAR TO EXP-N PERFORM EXPF
      MOVE MTH1 TO EXP-N PERFORM EXPF MOVE MTH2 TO EXP-N PERFORM EXPF
      MOVE SR-F181 TO EXP-A PERFORM EXPF MOVE C-NAME TO EXP-A PERFORM EXPF
      MOVE SR-F183 TO EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF
      MOVE SR-F189 TO EXP-N PERFORM EXPF MOVE SR-F195 TO EXP-N PERFORM EXPF
      IF AS-KLST=1 MOVE SR-F192 TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF
         MOVE SR-F193 TO EXP-D PERFORM EXPF
         IF SR-F194=1 MOVE "S" TO EXP-A END-IF PERFORM EXPF
        ELSE MOVE 3 TO A-N1 PERFORM EXPFN END-IF
      MOVE AS-QTY TO EXP-N PERFORM EXPF COMPUTE EXP-N ROUNDED=AS-VAL PERFORM EXPF
      COMPUTE EXP-L ROUNDED=AS-WEIGHT / 2000 PERFORM EXPF.
    IF Y5 MOVE SR-F182 TO EXP-N PERFORM EXPF MOVE SR-F183 TO EXP-A PERFORM EXPF
      MOVE SR-F190 TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF
      MOVE SR-F191 TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF
      COMPUTE EXP-N=SR-F191 - SR-F190 PERFORM EXPF.
    MOVE SR-F183 TO CU-PROD MOVE " " TO WA1.
    READ COSTHIST REGARDLESS INVALID MOVE "*" TO WA1 GO AS44.
    PERFORM VARYING AS-IXP FROM 1 BY 1 UNTIL AS-IXP>8
      IF CU-NUM(AS-IXP)=AS-NUM GO AS44 END-IF END-PERFORM.
    MOVE "-" TO WA1.
AS44. IF WA1>" " MOVE WA1 TO FG80
       IF Y3 AND AS-KSUM=0 MOVE 14 TO A-N1 PERFORM EXPFN END-IF
       IF Y5 MOVE 2 TO A-N1 PERFORM EXPFN END-IF
       GO AS6.
    IF CU-MAC(AS-IXP) NOT=SR-F189 MOVE CU-MAC(AS-IXP) TO FG72A.

    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      COMPUTE AS-HVAL(IX1) ROUNDED=CU-TOT(AS-IXP,IX1) * AS-QTY / 1000 END-PERFORM.
    MOVE AS-VAL TO AS-CONTRIB MOVE 0 TO AS-DCOST.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      SUBTRACT AS-HVAL(IX1) FROM AS-CONTRIB
      ADD AS-HVAL(IX1) TO AS-DCOST AS-SH(IX1) AS-GH(IX1) END-PERFORM.
    COMPUTE AS-OVERHEAD ROUNDED=SR-F188 * AS-WEIGHT / 2000.
    PERFORM AS-VCALC.
    MOVE AS-VCT TO FG76 MOVE AS-VCD TO FG77 MOVE AS-VCP TO FG77A.
    MOVE AS-VMD TO FG78 MOVE AS-VMP TO FG79.
    ADD AS-VAL TO AS-SA AS-GA ADD AS-WEIGHT TO AS-SW AS-GW.
    ADD AS-CONTRIB TO AS-SC AS-GC ADD AS-MARGIN TO AS-SM AS-GM.
    IF Y3 AND AS-KSUM=0 PERFORM AS-VEXP
      MOVE AS-WEIGHT TO EXP-N PERFORM EXPF MOVE SR-F196 TO EXP-A PERFORM EXPF
      COMPUTE EXP-T ROUNDED=CU-TOT(AS-IXP,1) / CST-NMULT
        SIZE ERROR MOVE 0 TO EXP-T END-COMPUTE PERFORM EXPF
      MOVE CU-TOT(AS-IXP,4) TO EXP-T PERFORM EXPF
      MOVE CU-NTOT(AS-IXP,4) TO EXP-T PERFORM EXPF
      COMPUTE EXP-T ROUNDED=CU-TOT(AS-IXP,4) / CST-NMULT
        SIZE ERROR MOVE 0 TO EXP-T END-COMPUTE PERFORM EXPF
      COMPUTE EXP-T ROUNDED=CU-NTOT(AS-IXP,4) / CST-NMULT
        SIZE ERROR MOVE 0 TO EXP-T END-COMPUTE PERFORM EXPF.
    IF Y5 MOVE AS-VCD TO EXP-N PERFORM EXPF MOVE AS-VCP TO EXP-L PERFORM EXPF.
* note 264.1
AS6. IF NOT Y5 PERFORM AS-LINE.
    IF Y3 AND AS-KSUM=0 OR Y5 PERFORM EXP-LINE.
    IF Y3 AND AS-KSUM=1 PERFORM INIT-SC MOVE SR-F181 TO SC-F6 PERFORM AS-AC
      WRITE SC-RECORD INVALID READ SORCFL PERFORM AS-AC REWRITE SC-RECORD.
    GO AS3.
AS8. IF NOT Y5 PERFORM AS-T MOVE "** GRAND TOTALS" TO PREC
       MOVE AS-GTOTALS TO AS-XTOTALS PERFORM AS-P PERFORM PR-LINE.

    IF NOT(Y3 AND AS-KSUM=1) GO AS88.
    MOVE " " TO SC-KEY START SORCFL KEY>=SC-KEY INVALID GO AS84.
AS83. READ SORCFL NEXT END GO AS84. MOVE SC-F6 TO A-A1 PERFORM RD-CUS.
    MOVE SC-F7 TO AS-QTY MOVE SC-F8 TO AS-WEIGHT MOVE SC-F9 TO AS-VAL.
    MOVE AS-PERIOD TO EXP-A PERFORM EXPF MOVE AS-YEAR TO EXP-N PERFORM EXPF.
    MOVE MTH1 TO EXP-N PERFORM EXPF MOVE MTH2 TO EXP-N PERFORM EXPF.
    MOVE C-NO TO EXP-A PERFORM EXPF MOVE C-NAME TO EXP-A PERFORM EXPF.
    MOVE 7 TO A-N1 PERFORM EXPFN.
    MOVE AS-QTY TO EXP-N PERFORM EXPF COMPUTE EXP-N ROUNDED=AS-VAL PERFORM EXPF.
    COMPUTE EXP-L ROUNDED=AS-WEIGHT / 2000 PERFORM EXPF.
    MOVE SC-F10 TO AS-CONTRIB MOVE SC-F11 TO AS-OVERHEAD MOVE SC-F12 TO AS-DCOST.
    PERFORM AS-VCALC PERFORM AS-VEXP.
    MOVE 7 TO A-N1 PERFORM EXPFN PERFORM EXP-LINE GO AS83.
* note 264.2
AS84. PERFORM CLOSE-SORC.
AS88. PERFORM CLOSE-SORT.
    IF Y3 OR Y5 PERFORM CLOSE-EXP. IF NOT Y5 PERFORM CLOSE-PR.
AS9. GO MX9.

AS-AC. ADD AS-QTY TO SC-F7 ADD AS-WEIGHT TO SC-F8 ADD AS-VAL TO SC-F9.
    ADD AS-CONTRIB TO SC-F10 ADD AS-OVERHEAD TO SC-F11 ADD AS-DCOST TO SC-F12.
AS-VCALC. COMPUTE AS-MARGIN=AS-CONTRIB - AS-OVERHEAD.
    COMPUTE AS-MCOST=AS-DCOST + AS-OVERHEAD.
    COMPUTE AS-VCT ROUNDED=AS-CONTRIB * 2000 / AS-WEIGHT SIZE ERROR MOVE 0 TO AS-VCT.
    COMPUTE AS-VCD ROUNDED=AS-CONTRIB.
    COMPUTE AS-VCP ROUNDED=AS-CONTRIB * 100 / AS-VAL SIZE ERROR MOVE 0 TO AS-VCP.
    COMPUTE AS-VMD ROUNDED=AS-MARGIN.
    COMPUTE AS-VMP ROUNDED=AS-MARGIN * 100 / AS-VAL SIZE ERROR MOVE 0 TO AS-VMP.
AS-VEXP. MOVE AS-VCT TO EXP-D PERFORM EXPF MOVE AS-VCD TO EXP-N PERFORM EXPF.
    MOVE AS-VCP TO EXP-L PERFORM EXPF MOVE AS-VMD TO EXP-N PERFORM EXPF.
    MOVE AS-VMP TO EXP-L PERFORM EXPF.
    COMPUTE EXP-T ROUNDED=AS-DCOST * 1000 / AS-QTY SIZE ERROR MOVE 0 TO EXP-T. PERFORM EXPF.
    COMPUTE EXP-T ROUNDED=AS-MCOST * 1000 / AS-QTY SIZE ERROR MOVE 0 TO EXP-T. PERFORM EXPF.
AS-T. MOVE "** TOTALS" TO PREC.
    MOVE AS-STOTALS TO AS-XTOTALS PERFORM AS-P PERFORM AS-LINE 4 TIMES.
    MOVE LOW-VALUES TO AS-STOTALS.
AS-P. COMPUTE FG74 ROUNDED=AS-XA COMPUTE FG75 ROUNDED=AS-XW / 2000.
    COMPUTE FG77 ROUNDED=AS-XC.
    COMPUTE FG77A ROUNDED=AS-XC * 100 / AS-XA SIZE ERROR CONTINUE.
    COMPUTE FG78 ROUNDED=AS-XM.
    COMPUTE FG79 ROUNDED=AS-XM * 100 / AS-XA SIZE ERROR CONTINUE.
    PERFORM PR-LINE-2 PERFORM AS-HEAD.
    COMPUTE FG81 ROUNDED=AS-XC COMPUTE FG82 ROUNDED=AS-XA.
    COMPUTE FG83 ROUNDED=AS-XH(1) COMPUTE FG84 ROUNDED=AS-XH(2).
    COMPUTE FG85 ROUNDED=AS-XH(3).
AS-HEAD.
    MOVE "     CONTRIBUTION   =   REVENUE   -   MATERIAL   -   THIRD PARTY   -   CONVERSION" TO PREC PERFORM PR-LINE.
*              ...,...,...-    ...,...,...-   ...,...,...-     ...,...,...-     ...,...,...-
AS-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AS-PAGE.
AS-PAGE. MOVE "PRODUCT CONTRIBUTION REPORT" TO FF3 EVALUATE TRUE
      WHEN Y1 MOVE "** BY CATEGORY **" TO FF4
      WHEN Y2 MOVE "** BY MACHINE **" TO FF4
      WHEN Y3 MOVE "** BY CUSTOMER **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    IF AS-HSEL=1 MOVE "THIS YEAR" TO A-A1 MOVE 10 TO A-X1.
    IF AS-HSEL=2 MOVE "LAST YEAR" TO A-A1 MOVE 10 TO A-X1.
    IF AS-HSEL=3 MOVE "2 YEARS AGO" TO A-A1 MOVE 12 TO A-X1.
    MOVE MTH1 TO DSP-N21 MOVE MTH2 TO DSP-N22.
    STRING " (MONTH " DSP-N21 " - " DSP-N22 ")" DELIMITED SIZE INTO A-A1 POINTER A-X1.
    IF AS-KLST=1 STRING " (USING MOST RECENT SALE PRICE)" DELIMITED SIZE INTO A-A1 POINTER A-X1.
    STRING " (HISTORY: " DELIMITED SIZE AS-PERIOD ")" DELIMITED " " INTO A-A1 POINTER A-X1.
    MOVE 2 TO WS-PR MOVE A-A1 TO PREC PERFORM PR-LINE.
    PERFORM PRANGE-CAT MOVE 1 TO WS-PR PERFORM PRANGE-MAC MOVE 1 TO WS-PR PERFORM PRANGE-CUS.
    MOVE "PRODUCT      MAC      PIECES(M)     VALUE        TONS    CONTR/TON     CONTR $  CONTR %   GRS MRG $  GRS MRG %  NO COST HIST" TO PREC PERFORM PR-LINE-3.
*         ............ .. ..    ...,...- ...,...,...- ...,...:.-  ..,...:..-  .,...,...-  ...:.-   .,...,...-    ...:.-         .

* Z-16-6 THIRD PARTY OPERATIONS VALUATION REPORT
BF1. PERFORM RD227 PERFORM WRT IF S-BAT GO BF2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
BF2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO BF29.
BF23. READ PRODORD NEXT REGARDLESS END GO BF29.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT PERFORM GET-OP IF A-S1=1 GO BF23.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT.
    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO BF28.
BF25. READ WORKSHEET NEXT REGARDLESS END GO BF28. IF J-NO NOT=R-NO GO BF28.
    IF NOT(J-DATE>=DATE1 AND<=DATE2) GO BF25.
    MOVE J-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO BF25.
    MOVE 0 TO BF-KOP PERFORM VARYING BF-IX1 FROM 1 BY 1 UNTIL BF-IX1>12
      IF OP-OPER(BF-IX1)=J-MAC MOVE 1 TO BF-KOP GO BF26 END-IF END-PERFORM.
BF26. MOVE J-QTY TO BF-QTY PERFORM BF-WR GO BF25.
BF28. GO BF23.
BF29.

    PERFORM OPEN-PR PERFORM OPEN-SORT MOVE 1 TO BF-STEP PERFORM BF-PAGE.
    MOVE LOW-VALUES TO BF-PTOTALS BF-GTOTALS MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BF6.
BF3. READ REPFL NEXT END GO BF6.
    IF RP-F325=OLD-A GO BF34. IF OLD-A>" " PERFORM BF-P.
    MOVE RP-F325 TO FD370 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FD371.
    MOVE RP-F325 TO OLD-A.
BF34. MOVE RP-F326 TO FD372 A-N1 PERFORM RD-MAC MOVE M-OPDESC TO FD373.
    MOVE RP-F327 TO FD374 MOVE RP-F328 TO WN1 FD375.
    IF IFAST OR INUT COMPUTE WD1 ROUNDED=WN1 * RP-F327 / 1000
      ELSE COMPUTE WD1 ROUNDED=WN1 * RP-F327.
    MOVE WD1 TO FD376 PERFORM BF-LINE.
    ADD WN1 TO BF-PQ BF-GQ ADD WD1 TO BF-PV BF-GV.
    MOVE M-GROUP TO SR-F107 MOVE M-SECT TO SR-F108 MOVE M-NO TO SR-F109.
    MOVE WN1 TO SR-F110 MOVE WD1 TO SR-F111 MOVE M-OPDESC TO SR-F112.
    WRITE SR-RECORD INVALID READ SORTFL ADD WN1 TO SR-F110 ADD WD1 TO SR-F111 REWRITE SR-RECORD.
    GO BF3.
BF6. PERFORM BF-P MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO FD371.
    MOVE BF-GQ TO FD375 MOVE BF-GV TO FD376 MOVE "***" TO FD377 PERFORM PR-LINE.

    MOVE 2 TO BF-STEP PERFORM BF-PAGE.
    MOVE LOW-VALUES TO BF-DTOTALS BF-GTOTALS MOVE -1 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO BF8.
BF7. READ SORTFL NEXT END GO BF8. COMPUTE WN1=SR-F107 * 100 + SR-F108.
    IF WN1=OLD-N GO BF74. IF OLD-N>-1 PERFORM BF-D.
    MOVE SR-F107 TO FD378 MOVE SR-F108 TO FD379 MOVE WN1 TO OLD-N.
BF74. MOVE SR-F109 TO FD380 MOVE SR-F112 TO FD381.
    MOVE SR-F110 TO FD382 MOVE SR-F111 TO FD383 PERFORM BF-LINE.
    ADD SR-F110 TO BF-DQ BF-GQ ADD SR-F111 TO BF-DV BF-GV GO BF7.
BF8. PERFORM BF-D MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    MOVE BF-GQ TO FD382 MOVE BF-GV TO FD383 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR.
BF9. GO MX9.

BF-WR. PERFORM BF-WR1 THRU BF-WR9.
BF-WR1. MOVE J-MAC TO A-N1 PERFORM RD-MAC.
    IF BF-KOP=1 AND OP-COST(BF-IX1)>0
       MOVE OP-COST(BF-IX1) TO CST-WAMT MOVE OP-CMODE(BF-IX1) TO A-A1
      ELSE MOVE M-COST TO CST-WAMT MOVE M-CMODE TO A-A1.
    IF IFAST OR INUT PERFORM COST-M COMPUTE BF-VAL ROUNDED=CST-WAMT * CST-MULT
      ELSE COMPUTE BF-VAL ROUNDED=CST-WAMT * CST-NET / 100.
    IF BF-VAL=0 GO BF-WR9. PERFORM INIT-RP MOVE P-NO TO RP-F325.
    MOVE J-MAC TO RP-F326 MOVE BF-VAL TO RP-F327 MOVE BF-QTY TO RP-F328.
    WRITE RP-RECORD INVALID READ REPFL ADD BF-QTY TO RP-F328 REWRITE RP-RECORD.
BF-WR9. EXIT.
BF-P. MOVE " ** PRODUCT TOTALS" TO FD371.
    MOVE BF-PQ TO FD375 MOVE BF-PV TO FD376 MOVE "*" TO FD377 PERFORM BF-LINE 2 TIMES.
    MOVE LOW-VALUES TO BF-PTOTALS.
BF-D. MOVE 2 TO WS-PR MOVE "         ** TOTALS" TO PREC.
    MOVE BF-DQ TO FD382 MOVE BF-DV TO FD383 PERFORM BF-LINE 2 TIMES.
    MOVE LOW-VALUES TO BF-DTOTALS.
BF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BF-PAGE.
BF-PAGE. MOVE "THIRD PARTY OPERATIONS VALUATION REPORT" TO FF3.
    IF BF-STEP=2 MOVE "** DEPARTMENT/SECTOR SUMMARY **" TO FF4. PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    IF BF-STEP=1 MOVE
         "PRODUCT       DESCRIPTION                      PROCESS            COST/M        QTY           VALUE" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ... ..........  .,...:... ...,...,...- ...,...,...:..-..
    IF BF-STEP=2 MOVE
         "DEP/SEC  PROCESS                QTY          VALUE" TO PREC PERFORM PR-LINE-3.
*          .. ..   ... ..........  ...,...,...- ...,...,...:..-

* Z-16-7 PRODUCT COST REPORT
BJ1. PERFORM RD331 PERFORM WRT IF S-BAT MOVE S-S1 TO BJ-KC GO BJ2.
    ACCEPT XA3 LINE 3 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO BJ-KC ELSE MOVE 0 TO BJ-KC.
    MOVE 5 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-CAT-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE BJ-KC TO S-S1 GO MX9.
BJ2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-KEY START PRODUCT KEY>P-KEY REGARDLESS INVALID GO BJ29.
BJ23. READ PRODUCT NEXT REGARDLESS END GO BJ29.
    IF P-GEN>" " OR P-CAT>60 OR NOT(P-CAT>=CAT1 AND<=CAT2) GO BJ23.
    PERFORM INIT-RP MOVE P-CAT TO RP-F373 MOVE P-NO TO RP-F374.
    WRITE RP-RECORD GO BJ23.
BJ29. PERFORM OPEN-PR PERFORM BJ-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE BJ-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE 0 TO OLD-N MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BJ9.
BJ3. READ REPFL NEXT END GO BJ9. IF RP-F373=OLD-N GO BJ34.
    IF OLD-N NOT=0 PERFORM BJ-PAGE. MOVE "CAT" TO FD443.
    MOVE RP-F373 TO FD444 OLD-N PRO-CAT PERFORM DESC-CAT MOVE T-LINE TO FD445.
    PERFORM BJ-LINE 2 TIMES.
BJ34. MOVE RP-F374 TO A-A1 PERFORM PROD-RD.
    MOVE 0 TO CST-IXE CST-M-TOT CST-T-TOT CST-C-TOT CST-DIRECT CST-OVERHEAD CST-MFG.
    IF ITOOL GO BJ36. MOVE P-MAC TO M-NO.
    READ MACHINE REGARDLESS INVALID MOVE "MM" TO A-A1 PERFORM COST-E GO BJ38.
    IF NOT(IFAST AND P-MAC=99 OR INUT)
      PERFORM GET-TS IF A-S1=1 MOVE "TT" TO A-A1 PERFORM COST-E GO BJ38.
BJ36. PERFORM GET-OP IF A-S1=1 MOVE "OO" TO A-A1 PERFORM COST-E GO BJ38.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE P-MAC TO CST-MAC MOVE P-NUT TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI CST-KQ MOVE 1 TO CST-MODE PERFORM COST-CALC.
BJ38. MOVE P-CAT TO EXP-N PERFORM EXPF.
    MOVE P-NO TO FD434 EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO FD435 EXP-A PERFORM EXPF.
    MOVE P-MAC TO FD436 EXP-N PERFORM EXPF MOVE P-GROSS TO EXP-D PERFORM EXPF.
    MOVE P-WEIGHT TO EXP-D PERFORM EXPF MOVE P-GRADE TO EXP-A PERFORM EXPF.
    MOVE CST-M-TOT TO FD437(1) EXP-T PERFORM EXPF.
    MOVE CST-T-TOT TO FD437(2) EXP-T PERFORM EXPF.
    MOVE CST-C-TOT TO FD437(3) EXP-T PERFORM EXPF.

    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10
      IF IX1<=CST-IXP MOVE CST-C-CODE(IX1) TO EXP-N PERFORM EXPF
        MOVE CST-C-AMT(IX1) TO EXP-T PERFORM EXPF
       ELSE MOVE 2 TO A-N1 PERFORM EXPFN END-IF END-PERFORM.
    MOVE CST-C-TOOLS TO EXP-T PERFORM EXPF MOVE CST-C-CARTONS TO EXP-T PERFORM EXPF.

    MOVE CST-DIRECT TO FD437(4) EXP-T PERFORM EXPF.
    MOVE CST-OVERHEAD TO FD437(5) EXP-T PERFORM EXPF.
    MOVE CST-MFG TO FD437(6) EXP-T PERFORM EXPF.
    MOVE CST-PRICE-SUG TO EXP-T PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 OR CST-IXE
      MOVE CST-ERR(IX1) TO FD438(IX1) EXP-A(IX1 * 3 - 2:2) END-PERFORM.
    PERFORM EXPF PERFORM PR-LINE PERFORM EXP-LINE.

    IF BJ-KC=0 GO BJ88.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 INITIALIZE BJ-XC(IX1) END-PERFORM.
    MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT.
    START ALTERNATES KEY>=AL-KEY REGARDLESS INVALID GO BJ8.
BJ5. READ ALTERNATES NEXT REGARDLESS END GO BJ8. IF AL-PROD NOT=P-NO GO BJ8.
    MOVE AL-PROD TO BJ-PROD IF AL-ALT>" " MOVE AL-ALT TO BJ-PROD.
    INITIALIZE SH-KP MOVE BJ-PROD TO SH-KPROD.
    START SALHIST KEY>SH-KP REGARDLESS INVALID GO BJ59.
BJ53. READ SALHIST NEXT REGARDLESS END GO BJ59. IF SH-KPROD>BJ-PROD GO BJ59.
    IF SH-KDATE<SYS-DATE - 365 GO BJ53.
    IF IFAST OR INUT MOVE 1000 TO WN1 ELSE MOVE 1 TO WN1.
    COMPUTE BJ-SPRICE ROUNDED=WN1 * SH-AMT / SH-QTY.
* note 203
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 OR BJ-CUS(IX1)=" "
      IF SH-KCUS=BJ-CUS(IX1) AND SH-US=BJ-US(IX1)
        MOVE SH-KDATE TO BJ-DATE(IX1) MOVE BJ-SPRICE TO BJ-PRICE(IX1)
        COMPUTE IX2=IX1 - 1
        PERFORM UNTIL IX2=0 OR BJ-DATE(IX2)>=BJ-DATE(IX2 + 1)
          MOVE BJ-XC(IX2 + 1) TO BJ-XC(6) MOVE BJ-XC(IX2) TO BJ-XC(IX2 + 1)
          MOVE BJ-XC(6) TO BJ-XC(IX2) SUBTRACT 1 FROM IX2 END-PERFORM
        GO BJ58 END-IF END-PERFORM.
    IF IX1>1 PERFORM VARYING IX2 FROM 1 BY 1
        UNTIL IX2=IX1 OR SH-KDATE>BJ-DATE(IX2) CONTINUE END-PERFORM
      MOVE IX2 TO IX1 IF IX1>5 GO BJ58 END-IF
      PERFORM VARYING IX2 FROM 4 BY -1 UNTIL IX2<IX1
        MOVE BJ-XC(IX2) TO BJ-XC(IX2 + 1) END-PERFORM.
    MOVE SH-KCUS TO BJ-CUS(IX1) MOVE SH-KDATE TO BJ-DATE(IX1).
    MOVE BJ-SPRICE TO BJ-PRICE(IX1) MOVE SH-US TO BJ-US(IX1).
BJ58. GO BJ53.
BJ59. GO BJ5.
BJ8. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 OR BJ-CUS(IX1)=" "
      MOVE BJ-CUS(IX1) TO FD440(IX1) MOVE ":" TO FD440A(IX1)
      MOVE BJ-PRICE(IX1) TO FD441(IX1)
      IF BJ-US(IX1)=1 MOVE "U" TO FD442(IX1) END-IF END-PERFORM.
    IF BJ-CUS(1)=" " PERFORM BJ-LINE ELSE PERFORM BJ-LINE 2 TIMES.
BJ88. GO BJ3.
BJ9. PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

BJ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BJ-PAGE.
BJ-PAGE. MOVE "PRODUCT COST REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-CAT.
    MOVE "PRODUCT       DESCRIPTION                       MAC     MAT   THRD PTY     CONV     DIRECT     OVHD      MFG      ERRORS" TO PREC.
*         ............  ................................  ..  ....:...  ....:...  ....:...  ....:...  ....:...  ....:...    .. .. .. .. .. ..
*                       ..... :....:... .     ..... :....:... .  (x5)
    IF WS-PAGE=1 AND BJ-KC=1 PERFORM PR-LINE-2
      MOVE "SHOWING THE 5 MOST RECENT CUSTOMERS AND SALE PRICES IN THE LAST 12 MONTHS" TO PREC.
    PERFORM PR-LINE-3.

* Z-16-8 PRODUCT COST ANALYSIS
ER1. PERFORM RD332 PERFORM WRT IF S-BAT GO ER2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 5 TO IXT MOVE 18 TO IXU PERFORM AX-SUM-S.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
ER2. PERFORM DSP-WAIT MOVE 1 TO ER-STEP PERFORM OPEN-REP MOVE 0 TO OLD-M.
    INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO ER29.
ER23. READ WORKSHEET NEXT REGARDLESS END GO ER29. IF J-DATE>DATE2 GO ER29.
    IF J-MAC NOT=OLD-M MOVE J-MAC TO OLD-M A-N1 PERFORM RD-MAC.
    MOVE J-AWEIGHT TO ER-WEIGHT IF ER-WEIGHT=0 MOVE J-WEIGHT TO ER-WEIGHT.
    MOVE J-PROD TO A-A1 PERFORM PROD-RGD.
    PERFORM INIT-RP MOVE M-GROUP TO RP-F396 MOVE M-SECT TO RP-F397.
    MOVE M-NO TO RP-F398 MOVE P-NO TO RP-F399.
    MOVE J-QTY TO RP-F402 MOVE ER-WEIGHT TO RP-F403 MOVE M-OPDESC TO RP-F404.
    MOVE PRO-DESC(1) TO RP-F405.
    WRITE RP-RECORD INVALID READ REPFL
      ADD J-QTY TO RP-F402 ADD ER-WEIGHT TO RP-F403 REWRITE RP-RECORD.
    GO ER23.
ER29.

* note 137
    MOVE " " TO ER-SKEY MOVE -1 TO ER-SF.
ER3. MOVE ER-SKEY TO RP-KEY START REPFL KEY>RP-KEY INVALID GO ER4.
    READ REPFL NEXT END GO ER4. MOVE RP-KEY TO ER-SKEY.
    COMPUTE WN1=(RP-F396 * 100 + RP-F397) * 10000 + RP-F398.
    IF WN1 NOT=ER-SF PERFORM ER-W
      MOVE WN1 TO ER-SF MOVE 0 TO ER-SW MOVE RP-KEY TO ER-SKL.
    MOVE RP-F398 TO A-N1 PERFORM RD-MAC MOVE RP-F399 TO A-A1 PERFORM PROD-GEN.
    PERFORM COST-PROCESS.
    MOVE M-NO TO A-N1 PERFORM PROC-TYPE IF NOT(PROC-AUTOSORT OR PROC-PACK) GO ER38.
    MOVE P-PACKING TO CST-PACKING PERFORM COST-CHKPAK IF A-S1=1 GO ER38.
    MOVE CST-PACKING TO PK-NO READ PACKING REGARDLESS INVALID GO ER38.
    MOVE PK-PART TO PH-NO READ PART REGARDLESS INVALID GO ER38.
    MOVE PH-LDCOST TO A-T1 PERFORM PART-TYPE PERFORM DIV-PAMT.
    COMPUTE CST-C-CARTONS ROUNDED=A-T1 * 1000 / P-QTY-PACK SIZE ERROR CONTINUE.
    MOVE CST-C-CARTONS TO RP-F406.
ER38. IF CST-WAMT NOT=0 MOVE 1 TO ER-SW.
    MOVE CST-WAMT TO RP-F401 REWRITE RP-RECORD GO ER3.
ER4. MOVE " " TO ER-SKEY PERFORM ER-W.

    PERFORM OPEN-PR PERFORM ER-PAGE.
    MOVE LOW-VALUES TO ER-MTOTALS ER-DTOTALS ER-GTOTALS.
    MOVE 0 TO OLD-M MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO ER48.
ER43. READ REPFL NEXT END GO ER48. IF RP-F400=1 GO ER43.
    COMPUTE WN1=RP-F396 * 100 + RP-F397. IF WN1=OLD-N GO ER44.
    IF OLD-N NOT=-1 PERFORM ER-M PERFORM ER-D. MOVE WN1 TO OLD-N MOVE 0 TO OLD-M.
    MOVE RP-F396 TO FD233 MOVE RP-F397 TO FD234 PERFORM ER-LINE.
ER44. IF RP-F398=OLD-M GO ER46. IF OLD-M NOT=0 PERFORM ER-M.
    MOVE RP-F398 TO FD235 OLD-M MOVE RP-F404 TO FD236 PERFORM ER-LINE.
ER46. MOVE RP-F399 TO FD237 MOVE RP-F405 TO FD238.
    MOVE RP-F402 TO FD239 MOVE RP-F403 TO FD240.
    COMPUTE ER-COST ROUNDED=RP-F401 * RP-F402 / 1000 MOVE ER-COST TO FD241.
    ADD RP-F402 TO ER-MQ ER-DQ ER-GQ ADD RP-F403 TO ER-MW ER-DW ER-GW.
    ADD ER-COST TO ER-MA ER-DA ER-GA.
    IF SUM-IND=0 PERFORM ER-LINE ELSE MOVE " " TO PREC. GO ER43.
ER48. PERFORM ER-M PERFORM ER-D MOVE "GRAND TOTALS" TO FD246.
    MOVE ER-GQ TO FD239 MOVE ER-GW TO FD240 MOVE ER-GA TO FD241 MOVE "***" TO FD242.
    PERFORM PR-LINE-2.

    MOVE LOW-VALUES TO ER-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO ER484.
ER483. READ REPFL NEXT END GO ER484. IF RP-F400=1 GO ER483.
    COMPUTE ER-COST ROUNDED=RP-F406 * RP-F402 / 1000 ADD ER-COST TO ER-GA.
    GO ER483.
ER484. MOVE "CARTONS TOTAL" TO FD246 MOVE ER-GA TO FD241 PERFORM PR-LINE.
    PERFORM CLOSE-REP.

    PERFORM OPEN-REP PERFORM RDR-INFO INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO ER59.
ER53. READ WORKSHEET NEXT REGARDLESS END GO ER59. IF J-DATE>DATE2 GO ER59.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO ER53.
    MOVE J-AWEIGHT TO ER-WEIGHT IF ER-WEIGHT=0 MOVE J-WEIGHT TO ER-WEIGHT.
    MOVE J-PROD TO A-A1 PERFORM PROD-RGD PERFORM SET-PART MOVE PART-NO TO CST-MAT.
    PERFORM INIT-RP MOVE 2 TO RP-F407 MOVE CST-MAT TO RP-F408 PERFORM ER-R.
    PERFORM INIT-RP MOVE 3 TO RP-F407 MOVE P-PROC TO RP-F409.
    MOVE CST-MAT TO RP-F414 PERFORM ER-R.
    PERFORM INIT-RP MOVE 4 TO RP-F407 MOVE P-CLEAN TO RP-F409 PERFORM ER-R.
    GO ER53.
ER59.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO ER69.
ER63. READ REPFL NEXT END GO ER69. MOVE RP-F410 TO A-A1 PERFORM PROD-GEN.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT MOVE 0 TO ER-WAMT.
    IF RP-F407=2 COMPUTE RP-F413 ROUNDED=RP-F413 * CST-GROSS / CST-NET
      INITIALIZE PH-REC MOVE RP-F408 TO PH-NO
      READ PART REGARDLESS INVALID GO ER68 END-READ
      MOVE PH-LDCOST TO WT1 IF IF-RMSUR>0 ADD IF-RMSUR TO WT1 END-IF
      COMPUTE ER-WAMT ROUNDED=WT1 * CST-GMULT.
    IF RP-F407=3 INITIALIZE PH-REC MOVE RP-F414 TO PH-NO
      READ PART REGARDLESS INVALID GO ER68 END-READ
      IF RP-F409>=1 AND<=8 MOVE IF-RMPROC(RP-F409) TO WT1
        IF PH-CAT=130 AND RP-F409<=2 MOVE IF-RMPROC-A(RP-F409) TO WT1 END-IF
        COMPUTE ER-WAMT ROUNDED=WT1 * CST-GMULT.
    IF RP-F407=4
      IF RP-F409>=1 AND<=8 MOVE IF-RMCLEAN(RP-F409) TO WT1
        COMPUTE ER-WAMT ROUNDED=WT1 * CST-GMULT.
ER68. MOVE ER-WAMT TO RP-F411 REWRITE RP-RECORD GO ER63.
ER69.

    MOVE 2 TO ER-STEP.
ER7. PERFORM ER-PAGE MOVE LOW-VALUES TO ER-MTOTALS ER-GTOTALS.
    IF ER-STEP=2 MOVE " " TO OLD-A ELSE MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY MOVE ER-STEP TO RP-F407.
    START REPFL KEY>RP-KEY INVALID GO ER79.
ER73. READ REPFL NEXT END GO ER79. IF RP-F407>ER-STEP GO ER79.
    IF ER-STEP=2 IF RP-F408=OLD-A GO ER74 END-IF IF OLD-A NOT=" " PERFORM ER-T END-IF
      MOVE RP-F408 TO FD247 OLD-A
     ELSE IF RP-F409=OLD-N GO ER74 END-IF IF OLD-N NOT=-1 PERFORM ER-T END-IF
      MOVE RP-F409 TO FD248 OLD-N.
    PERFORM ER-LINE.
ER74. MOVE RP-F410 TO FD249 MOVE RP-F415 TO FD250.
    MOVE RP-F412 TO FD251 MOVE RP-F413 TO FD252.
    COMPUTE ER-COST ROUNDED=RP-F411 * RP-F412 / 1000 MOVE ER-COST TO FD253.
    ADD RP-F412 TO ER-MQ ER-GQ ADD RP-F413 TO ER-MW ER-GW ADD ER-COST TO ER-MA ER-GA.
    IF SUM-IND=0 PERFORM ER-LINE ELSE MOVE " " TO PREC. GO ER73.
ER79. PERFORM ER-T MOVE "GRAND TOTALS" TO FD257.
    MOVE ER-GQ TO FD251 MOVE ER-GW TO FD252 MOVE ER-GA TO FD253 MOVE "***" TO FD254.
    PERFORM ER-LINE IF ER-STEP<4 ADD 1 TO ER-STEP GO ER7.
ER9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

ER-W. PERFORM ER-W1 THRU ER-W9.
ER-W1. IF ER-SF=-1 OR ER-SW=1 GO ER-W9.
    MOVE ER-SKL TO RP-KEY START REPFL KEY=RP-KEY INVALID GO ER-W4.
ER-W3. READ REPFL NEXT END GO ER-W4. IF RP-KEY=ER-SKEY GO ER-W4.
    MOVE 1 TO RP-F400 REWRITE RP-RECORD GO ER-W3.
ER-W4.
ER-W9. EXIT.
ER-R. MOVE P-NO TO RP-F410 MOVE PRO-DESC(1) TO RP-F415.
    MOVE J-QTY TO RP-F412 MOVE ER-WEIGHT TO RP-F413.
    WRITE RP-RECORD INVALID READ REPFL
      ADD J-QTY TO RP-F412 ADD ER-WEIGHT TO RP-F413 REWRITE RP-RECORD.
ER-M. IF SUM-IND=0 MOVE 2 TO WS-PR.
    MOVE OLD-M TO FD243 MOVE "PROCESS TOTALS" TO FD246.
    MOVE ER-MQ TO FD239 MOVE ER-MW TO FD240 MOVE ER-MA TO FD241 MOVE "*" TO FD242.
    PERFORM ER-LINE 2 TIMES MOVE LOW-VALUES TO ER-MTOTALS.
ER-D. DIVIDE OLD-N BY 100 GIVING FD244 REMAINDER FD245 MOVE "DEP/SEC TOTALS" TO FD246.
    MOVE ER-DQ TO FD239 MOVE ER-DW TO FD240 MOVE ER-DA TO FD241 MOVE "**" TO FD242.
    PERFORM ER-LINE 2 TIMES MOVE LOW-VALUES TO ER-DTOTALS.
ER-T. IF SUM-IND=0 MOVE 2 TO WS-PR.
    EVALUATE TRUE
      WHEN ER-STEP=2 MOVE OLD-A TO FD255 MOVE "MATERIAL TOTALS" TO FD257
      WHEN ER-STEP=3 MOVE OLD-N TO FD256 MOVE "PROCESS TOTALS" TO FD257
      WHEN ER-STEP=4 MOVE OLD-N TO FD256 MOVE "CLEANING TOTALS" TO FD257
      END-EVALUATE.
    MOVE ER-MQ TO FD251 MOVE ER-MW TO FD252 MOVE ER-MA TO FD253 MOVE "**" TO FD254.
    PERFORM ER-LINE 2 TIMES MOVE LOW-VALUES TO ER-MTOTALS.
ER-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM ER-PAGE.
ER-PAGE. MOVE "PRODUCT COST ANALYSIS" TO FF3 EVALUATE TRUE
      WHEN ER-STEP=1 MOVE "** CONVERSION **" TO FF4
      WHEN ER-STEP=2 MOVE "** MATERIAL **" TO FF4
      WHEN ER-STEP=3 MOVE "** MATERIAL PROCESS **" TO FF4
      WHEN ER-STEP=4 MOVE "** MATERIAL CLEANING **" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    IF ER-STEP=1 MOVE
         "DEP/SEC  PROCESS         PRODUCT      DESCRIPTION                            QTY        WEIGHT           COST" TO PREC PERFORM PR-LINE-3.
*          .. ..   ... ..........  ............ ................................ ...,...,...- ...,...,...- ..,...,...:..-...
    IF ER-STEP>=2 MOVE
         "MATERIAL      PRODUCT      DESCRIPTION                            QTY        WEIGHT           COST" TO PREC
*         ............  ............ ................................ ...,...,...- ...,...,...- ..,...,...:..-...
      IF ER-STEP=3 MOVE "PROC CODE" TO PREC(1:12) END-IF
      IF ER-STEP=4 MOVE "CLEAN CODE" TO PREC(1:12) END-IF
      PERFORM PR-LINE-3.

* Z-16-9 MAINTENANCE PARTS COST REPORT
FY1. PERFORM RD333 PERFORM WRT IF S-BAT GO FY2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
FY2. PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 1 TO FY-STEP PERFORM FY-PAGE.
    MOVE 0 TO FY-GTOT MOVE " " TO FY-PART.
    MOVE " " TO PT-KEY START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO FY4.
FY3. READ PARTRANS NEXT REGARDLESS END GO FY4.
    IF NOT((PT-TRANS="ISS" OR "OUT") AND PT-DATE>=DATE1 AND<=DATE2) GO FY3.
    MOVE PT-PART TO PH-NO READ PART REGARDLESS INVALID GO FY3.
    PERFORM PART-TYPE IF NOT PART-MAINT GO FY3.
    IF PT-PART=FY-PART GO FY34. IF FY-PART NOT=" " PERFORM FY-P.
    MOVE PH-NO TO FY-PART MOVE PH-DESC1 TO FY-DESC1 MOVE PH-MODE TO FY-MODE.
    MOVE PH-LDCOST TO FY-LDCOST MOVE 0 TO FY-QTY.
FY34. ADD PT-QTY TO FY-QTY GO FY3.
FY4. PERFORM FY-P MOVE 2 TO WS-PR MOVE "*** GRAND TOTAL" TO FG22.
    MOVE FY-GTOT TO FG26 PERFORM PR-LINE.

* note 242
    MOVE 2 TO FY-STEP PERFORM OPEN-REP.
    OPEN I-O MNTORD ALLOWING ALL MNTLIN ALLOWING ALL MNTMAC ALLOWING ALL.
    MOVE " " TO VL-KEY START MNTLIN KEY>VL-KEY REGARDLESS INVALID GO FY69.
FY63. READ MNTLIN NEXT REGARDLESS END GO FY69.
    IF NOT(VL-TYPE=1 AND VL-PART>" " AND VL-AMT NOT=0
      AND VL-DATE>=DATE1 AND<=DATE2) GO FY63.
    MOVE VL-NO TO VO-NO READ MNTORD REGARDLESS INVALID GO FY63.
    IF VO-MAC=0 GO FY63. PERFORM INIT-RP.
    MOVE VO-DEPT TO RP-F416 MOVE VO-SECT TO RP-F417 MOVE VO-MAC-IND TO RP-F418.
    MOVE VO-MAC TO RP-F419 A-N1.
    IF VO-MAC-IND=0 PERFORM RD-MAC MOVE M-DESC1 TO RP-F421 MOVE M-DESC2 TO RP-F422
      ELSE PERFORM RD-MNTMAC MOVE MK-DESC1 TO RP-F421 MOVE MK-DESC2 TO RP-F422.
    MOVE VL-AMT TO RP-F423.
    WRITE RP-RECORD INVALID READ REPFL ADD VL-AMT TO RP-F423 REWRITE RP-RECORD.
    GO FY63.
FY69.

    PERFORM FY-PAGE MOVE 0 TO FY-STOT FY-GTOT MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FY8.
FY7. READ REPFL NEXT END GO FY8.
    COMPUTE WN1=100 * RP-F416 + RP-F417 IF WN1=OLD-N GO FY72.
    IF OLD-N NOT=-1 PERFORM FY-D. MOVE WN1 TO OLD-N.
    MOVE RP-F416 TO FG28 MOVE RP-F417 TO FG29.
FY72. MOVE RP-F419 TO FG30.
    IF RP-F418=0 MOVE " P" TO FG31 ELSE MOVE "N/P" TO FG31.
    MOVE RP-F421 TO FG32 MOVE RP-F423 TO FG33 ADD RP-F423 TO FY-STOT FY-GTOT.
    PERFORM FY-LINE MOVE RP-F422 TO FG32 PERFORM FY-LINE GO FY7.
FY8. PERFORM FY-D MOVE 2 TO WS-PR MOVE "*** GRAND TOTAL" TO FG32.
    MOVE FY-GTOT TO FG33 MOVE "**" TO FG34 PERFORM PR-LINE.
    CLOSE MNTORD MNTLIN MNTMAC PERFORM CLOSE-REP PERFORM CLOSE-PR.
FY9. GO MX9.

FY-P. MOVE FY-PART TO FG21 MOVE FY-DESC1 TO FG22 MOVE FY-LDCOST TO FG23.
    MOVE FY-MODE TO FG24 MOVE FY-QTY TO FG25.
    MOVE FY-LDCOST TO A-T1 MOVE FY-MODE TO A-A1 PERFORM DIV-SAMT.
    COMPUTE WD1 ROUNDED=A-T1 * FY-QTY.
    MOVE WD1 TO FG26 ADD WD1 TO FY-GTOT PERFORM FY-LINE.
FY-D. MOVE 2 TO WS-PR MOVE " ** DEPT/SECT TOTAL" TO FG32.
    MOVE FY-STOT TO FG33 MOVE "*" TO FG34 PERFORM FY-LINE 2 TIMES.
    MOVE 0 TO FY-STOT.
FY-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FY-PAGE.
FY-PAGE. MOVE "MAINTENANCE PARTS COST REPORT" TO FF3.
    IF FY-STEP=1 MOVE "(FROM STOCK TRANSACTIONS)" TO FF4.
    IF FY-STEP=2 MOVE "(FROM MAINTENANCE ORDERS)" TO FF4. PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    IF FY-STEP=1 MOVE
         "PART NO.      DESCRIPTION                         LD COST  MODE      QTY       COST" TO PREC.
*         ............  ................................ ..,...:...  ....  ...,...-  ...,...:..-
    IF FY-STEP=2 MOVE
         "DEP/SEC  MAC  TYPE  DESCRIPTION                          COST" TO PREC.
*          .. ..   ...  ...   ..............................   ...,...:..-..
    PERFORM PR-LINE-3.

* Z-16-10 CREATE A/R AUDIT FILE
FZ1. PERFORM RD20 PERFORM WRT.
    MOVE 2 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM CREATE-TRAUD.
FZ9. GO MX9.

* Z-16-11 CUSTOMER LISTING
WU1. PERFORM RD410 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE WU-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE " " TO C-KEY START CUSTOMER KEY>C-KEY REGARDLESS INVALID GO WU9.
WU3. READ CUSTOMER NEXT REGARDLESS END GO WU9.
    MOVE C-NO TO EXP-A PERFORM EXPF MOVE C-NAME TO EXP-A PERFORM EXPF.
    MOVE C-ADD1 TO EXP-A PERFORM EXPF MOVE C-ADD2 TO EXP-A PERFORM EXPF.
    MOVE C-POST TO EXP-A PERFORM EXPF MOVE C-PROV TO EXP-N PERFORM EXPF.
    IF C-PROV>0 MOVE 12 TO T-TBL MOVE C-PROV TO T-NO PERFORM RD-TBL MOVE T-LINE TO EXP-A.
    PERFORM EXPF MOVE C-MCUS TO EXP-A PERFORM EXPF.
    MOVE "CAN" TO EXP-A IF C-US=1 MOVE "USD" TO EXP-A. PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE C-INFO(IX1) TO EXP-A PERFORM EXPF END-PERFORM.
    MOVE C-INS TO EXP-N PERFORM EXPF MOVE C-TERMS TO EXP-N PERFORM EXPF.
    IF C-TERMS>0 MOVE 16 TO T-TBL MOVE C-TERMS TO T-NO PERFORM RD-TBL
      MOVE T-TE1 TO EXP-N PERFORM EXPF MOVE T-TE2 TO EXP-A PERFORM EXPF
     ELSE MOVE 2 TO A-N1 PERFORM EXPFN.
    MOVE C-CREDIT TO EXP-N PERFORM EXPF MOVE C-DB TO EXP-A PERFORM EXPF.
    MOVE C-GST TO EXP-A PERFORM EXPF MOVE C-PST TO EXP-A PERFORM EXPF.
    MOVE C-TOT TO EXP-D PERFORM EXPF MOVE C-CUR TO EXP-D PERFORM EXPF.
    MOVE C-30 TO EXP-D PERFORM EXPF MOVE C-60 TO EXP-D PERFORM EXPF.
    MOVE C-90 TO EXP-D PERFORM EXPF MOVE C-120 TO EXP-D PERFORM EXPF.
    PERFORM EXP-LINE GO WU3.
WU9. PERFORM CLOSE-EXP GO MX9.

* Z-16-12 PRODUCT COST VARIANCE REPORTS
QY1. PERFORM RD193 PERFORM WRT IF S-BAT MOVE S-N1 TO QY-PERC GO QY2.
QY13. ACCEPT XN1 LINE 11 COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF XN1=0 OR>2 PERFORM DSP-ERR2 GO QY13. MOVE XN1 TO SEL-N.
    ACCEPT QY-PERC LINE 11 COLUMN 37 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 12 TO IXT MOVE 31 TO IXU MOVE 61 TO IXV PERFORM AX-PROD-R.
    MOVE 14 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE QY-PERC TO S-N1 GO MX9.
QY2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM QY-PAGE.
    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    IF Y1 MOVE QY-HEADLN1 TO EXP-RECORD. IF Y2 MOVE QY-HEADLN2 TO EXP-RECORD.
    PERFORM EXP-HEADLN.
    MOVE PROD1 TO P-NO START PRODUCT KEY>=P-KEY REGARDLESS INVALID GO QY9.
QY3. READ PRODUCT NEXT REGARDLESS END GO QY9. IF P-NO>PROD2 GO QY9.
    IF P-GEN>" " OR P-CAT>60 GO QY3. PERFORM PROD-DESC.
    MOVE 0 TO CST-IXE QY-COST1 QY-COST2 QY-DIFF QY-AMO MOVE 9999 TO QY-VAR.
    IF ITOOL GO QY36. MOVE P-MAC TO M-NO.
    READ MACHINE REGARDLESS INVALID MOVE "MM" TO A-A1 PERFORM COST-E GO QY4.
    IF NOT(IFAST AND P-MAC=99 OR INUT)
      PERFORM GET-TS IF A-S1=1 MOVE "TT" TO A-A1 PERFORM COST-E GO QY4.
QY36. PERFORM GET-OP IF A-S1=1 MOVE "OO" TO A-A1 PERFORM COST-E GO QY4.
    MOVE P-LPRICE TO CST-PRICE MOVE P-PACKING TO CST-PACKING.
    MOVE P-MAC TO CST-MAC MOVE P-NUT TO CST-NUT MOVE -1 TO CST-LOP.
    MOVE 0 TO CST-KPRI CST-KQ.
    IF Y1 MOVE 0 TO CST-IXE MOVE 3 TO CST-MODE PERFORM COST-CALC
      MOVE CST-MFG TO QY-COST1
      MOVE 0 TO CST-IXE MOVE 4 TO CST-MODE PERFORM COST-CALC
      MOVE CST-MFG TO QY-COST2 MOVE CST-AMO TO QY-AMO.
    IF Y2 MOVE 0 TO CST-IXE MOVE 1 TO CST-MODE PERFORM COST-CALC
      MOVE CST-C-TOOLS TO QY-COST1
      MOVE 0 TO CST-IXE MOVE 4 TO CST-MODE PERFORM COST-CALC
      MOVE CST-C-TOOLS TO QY-COST2 MOVE CST-AMO TO QY-AMO.
    COMPUTE QY-DIFF=QY-COST1 - QY-COST2.
    COMPUTE QY-VAR ROUNDED=100 * QY-DIFF / QY-COST2 SIZE ERROR CONTINUE.
    IF QY-VAR>-QY-PERC AND<QY-PERC GO QY6.
QY4. MOVE P-NO TO FD471 EXP-A PERFORM EXPF MOVE PRO-DESC(1) TO FD472 EXP-A PERFORM EXPF.
    MOVE QY-COST1 TO FD473 EXP-T PERFORM EXPF MOVE QY-COST2 TO FD474 EXP-T PERFORM EXPF.
    MOVE QY-DIFF TO FD475 EXP-T PERFORM EXPF MOVE QY-VAR TO FD476 EXP-N PERFORM EXPF.
    MOVE QY-AMO TO FD477 EXP-N PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 OR CST-IXE
      MOVE CST-ERR(IX1) TO FD478(IX1) EXP-A(IX1 * 3 - 2:2) END-PERFORM.
    PERFORM EXPF PERFORM QY-LINE PERFORM EXP-LINE.
QY6. GO QY3.
QY9. PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

QY-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QY-PAGE.
QY-PAGE. IF Y1 MOVE "PRODUCT MFG COST VARIANCE REPORT" TO FF3.
    IF Y2 MOVE "PRODUCT TOOLING COST VARIANCE REPORT" TO FF3.
    PERFORM PR-PAGE MOVE 2 TO WS-PR PERFORM PRANGE-PROD.
    MOVE QY-PERC TO DSP-N31 STRING "VARIANCE OVER: " DSP-N31 "%" DELIMITED SIZE INTO PREC.
    MOVE 1 TO WS-PR PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "PRODUCT       DESCRIPTION                        ..........    ACTUAL    DIFFERENCE    VARIANCE %   M.O.   ERRORS" TO PREC.
    IF Y1 MOVE "NORMALIZED" TO PREC(50:10). IF Y2 MOVE "  REGULAR " TO PREC(50:10).
    PERFORM PR-LINE.
    MOVE "                                                    COST        COST     .........." TO PREC.
    IF Y1 MOVE "NORM - ACT" TO PREC(74:10). IF Y2 MOVE "REG - ACT " TO PREC(74:10).
    PERFORM PR-LINE-3.
*         ............  ................................   .,...:...   .,...:...   .,...:...-      ....-     .....   .. .. .. .. .. ..

* Z-16-13 CREATE INVOICE EXPORT FILES
VQ1. PERFORM RD322 PERFORM WRT IF S-BAT GO VQ2.
    IF NOT IFAST PERFORM DSP-CONT GO MX1.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MX1.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
VQ2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM VQ-PAGE.
    IF Y1 GO VQ30. IF Y2 GO VQ40.

VQ30. MOVE "EXARTRAN" TO DAT-ID OPEN OUTPUT DATFL MOVE " " TO DAT-RECORD.
    OPEN INPUT TMPORD ALLOWING ALL.
    MOVE " " TO YO-KEY START TMPORD KEY>YO-KEY REGARDLESS INVALID GO VQ34.
VQ33. READ TMPORD NEXT REGARDLESS END GO VQ34. MOVE YO-DATA TO O-RECORD.
    MOVE 21 TO VQ-EDIV PERFORM VQ-AR GO VQ33.
VQ34. CLOSE TMPORD OPEN INPUT INTMPORD ALLOWING ALL.
    MOVE " " TO INYO-KEY START INTMPORD KEY>INYO-KEY REGARDLESS INVALID GO VQ36.
VQ35. READ INTMPORD NEXT REGARDLESS END GO VQ36. MOVE INYO-DATA TO O-RECORD.
    MOVE 23 TO VQ-EDIV PERFORM VQ-AR GO VQ35.
VQ36. CLOSE INTMPORD DATFL GO VQ9.

VQ40. MOVE "EXAPTRAN" TO DAT-ID OPEN OUTPUT DATFL MOVE " " TO DAT-RECORD.
    INITIALIZE AT-KEY MOVE 21 TO AT-DIV VQ-DIV.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO VQ44.
VQ43. READ APTR NEXT REGARDLESS END GO VQ44. IF AT-DIV>VQ-DIV GO VQ44.
    IF AT-EXP-DATE NOT=0 GO VQ43. MOVE 21 TO VQ-EDIV PERFORM VQ-AP.
    MOVE SYS-DATE TO AT-EXP-DATE.
    REWRITE AT-RECORD ALLOWING NO UNLOCK APTR GO VQ43.
VQ44. PERFORM VQ-LINE OPEN I-O INAPTR ALLOWING ALL.
    INITIALIZE INAT-KEY MOVE 41 TO INAT-DIV VQ-DIV.
    START INAPTR KEY>INAT-KEY REGARDLESS INVALID GO VQ46.
VQ45. READ INAPTR NEXT INTO AT-RECORD REGARDLESS END GO VQ46. IF AT-DIV>VQ-DIV GO VQ46.
    IF AT-EXP-DATE NOT=0 GO VQ45. MOVE 23 TO VQ-EDIV PERFORM VQ-AP.
    MOVE SYS-DATE TO AT-EXP-DATE.
    REWRITE INAT-RECORD FROM AT-RECORD ALLOWING NO UNLOCK INAPTR GO VQ45.
VQ46. CLOSE INAPTR DATFL GO VQ9.

VQ9. PERFORM CLOSE-PR GO MX9.

VQ-AR. IF O-US=0 MOVE "CAN" TO VQ-CUR ELSE MOVE "USD" TO VQ-CUR.
    MOVE VQ-EDIV TO DAT-R1 MOVE O-INVNO TO DAT-R2.
    IF O-TOTAL>0 MOVE "IN" TO DAT-R3 ELSE MOVE "CN" TO DAT-R3.
    MOVE O-BL TO DAT-R4 MOVE O-CUS TO DAT-R5.
    MOVE O-INV-DATE TO D-DATE PERFORM D-NC MOVE D-N1 TO DAT-R6.
    MOVE O-CUSORD TO DAT-R7 MOVE O-NO TO DAT-R8.
    COMPUTE DAT-R9=O-GST + O-HST + O-PST + O-QST MOVE O-TOTAL TO DAT-R10.
    MOVE VQ-CUR TO DAT-R11 MOVE 0 TO WN1 IF O-PST NOT=0 MOVE 2 TO WN1.
    IF O-QST NOT=0 MOVE 3 TO WN1. IF O-HST NOT=0 MOVE 4 TO WN1.
    IF O-GST NOT=0 IF WN1=0 MOVE 1 TO WN1 ELSE IF WN1=2 MOVE 5 TO WN1 ELSE MOVE 4 TO WN1.
    MOVE WN1 TO DAT-R12 PERFORM DAT-LINE.
    MOVE VQ-EDIV TO FD157 MOVE O-CUS TO FD158 MOVE O-INVNO TO FD159 MOVE O-BL TO FD160.
    MOVE O-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD161.
    MOVE O-TOTAL TO FD162 MOVE VQ-CUR TO FD163 PERFORM VQ-LINE.
VQ-AP. IF AT-EXCH=0 MOVE "CAN" TO VQ-CUR ELSE MOVE "USD" TO VQ-CUR.
    MOVE VQ-EDIV TO DAT-P1 MOVE AT-INV TO DAT-P2.
    IF AT-GROSS>0 MOVE "IN" TO DAT-P3 ELSE MOVE "CN" TO DAT-P3.
    MOVE AT-VEN TO DAT-P4.
    MOVE AT-INV-DATE TO D-DATE PERFORM D-NC MOVE D-N1 TO DAT-P5.
    MOVE AT-MEMO TO DAT-P6 MOVE AT-ORD TO DAT-P7.
    MOVE AT-GST TO DAT-P8 MOVE AT-GROSS TO DAT-P9 MOVE VQ-CUR TO DAT-P10.
    IF AT-GST NOT=0 MOVE 1 TO DAT-P11 ELSE MOVE 0 TO DAT-P11.
    PERFORM DAT-LINE.
    MOVE VQ-EDIV TO FD150 MOVE AT-VEN TO FD151 MOVE AT-INV TO FD152.
    MOVE AT-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD153.
    MOVE AT-GROSS TO FD154 MOVE VQ-CUR TO FD155 PERFORM VQ-LINE.
VQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM VQ-PAGE.
VQ-PAGE. MOVE "INVOICE EXPORT LISTING" TO FF3.
    IF Y1 MOVE "(ACCOUNTS RECEIVABLE)" TO FF4.
    IF Y2 MOVE "(ACCOUNTS PAYABLE)" TO FF4. PERFORM PR-PAGE.
    IF Y1 MOVE
         "DIV  CUST    INVOICE    B/L     DATE         AMT   CURR" TO PREC.
*         ..   ......  ......  .......  ../../.. ...,...:..-  ...
    IF Y2 MOVE
         "DIV  VENDOR  INVOICE          INV DATE       AMT   CURR" TO PREC.
*         ..   ....    ...............  ../../.. ...,...:..-  ...
    PERFORM PR-LINE-3.

* Z-16-14 PRINT ORDER ACKNOWLEDGEMENTS
OA1. PERFORM RD409 PERFORM WRT.
    ACCEPT OA-ORD LINE 3 COLUMN 53 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR.
    OPEN I-O ACKORD ALLOWING ALL ACKLIN ALLOWING ALL.
    MOVE OA-ORD TO AKO-NO START ACKORD KEY>=AKO-KEY REGARDLESS INVALID GO OA9.
OA3. READ ACKORD NEXT INTO O-RECORD REGARDLESS END GO OA9.
    IF OA-ORD NOT=0 AND NOT=O-NO GO OA9. IF OA-ORD=0 AND O-ACK=0 GO OA3.
    MOVE O-CUS TO A-A1 PERFORM RD-CUS.
    IF O-SHIPTO=0 GO OA34. MOVE O-CUS TO SA-CUS MOVE O-SHIPTO TO SA-TO.
    READ SHIPTO REGARDLESS INVALID GO OA34. PERFORM GET-O-CUSADD.
OA34. MOVE 0 TO WS-PAGE PERFORM OA-PAGE.
    IF O-ACK=2 OR 3
      IF O-ACK=2 MOVE "*** ORDER MODIFIED" TO FD629
        ELSE MOVE "*** ORDER CANCELED" TO FD629 END-IF
      MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD630 PERFORM PR-LINE.
    COMPUTE AKL-NO=100 * AKO-NO.
OA5. ADD 1 TO AKL-LINE READ ACKLIN INTO L-RECORD REGARDLESS INVALID GO OA6.
    IF L-QTY=0 GO OA5.
    PERFORM OA-LINE MOVE L-PROD TO FD620 A-A1 PERFORM PROD-RGD.
    IF GEN-IND=1 PERFORM PR-LINE MOVE P-NO TO FD620.
    IF L-QTY=LIT-Q9 MOVE LIT-BL TO FD622 ELSE MOVE L-QTY TO FD621.
    MOVE L-PRICE TO FD624 IF L-PRICE=0 MOVE "    N/C" TO FD624X.
    MOVE L-MODE TO FD625 MOVE L-QTY TO CL-QTY.
    IF L-ADJ=1 MOVE "(ADJUSTMENT)" TO FD626 MOVE L-EXTA TO FD627
      ELSE PERFORM LPRICE-CALC MOVE CL-DTXT TO FD626
        IF L-QTY NOT=LIT-Q9 MOVE CL-AMT TO FD627.
    PERFORM OA-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 OR PRO-DESC(IX1)=" "
      MOVE PRO-DESC(IX1) TO PREC PERFORM OA-LINE END-PERFORM.
    IF L-CUSPART>" " STRING "CUSTOMER PART: " L-CUSPART DELIMITED SIZE
      INTO PREC PERFORM OA-LINE.
    PERFORM WEIGHT-CALC.
    IF L-PLATING NOT=0 PERFORM PLATING-CALC
      MOVE "    PLATING:" TO FD620 MOVE CL-WEIGHT TO FD623 MOVE T-PLR TO FD624
      MOVE T-PLS TO FD626 MOVE CL-D1 TO FD627 PERFORM OA-LINE.
    PERFORM SURCH-CALC.
    IF CL-D1 NOT=0 MOVE "  SURCHARGE:" TO FD620
      IF CL-KSM=0 MOVE CL-WEIGHT TO FD623 END-IF MOVE CL-SURCH TO FD624
      MOVE "STEEL SURCHARGE" TO FD626 MOVE CL-D1 TO FD627 PERFORM OA-LINE.
    GO OA5.
OA6. MOVE 0 TO O-ACK REWRITE AKO-RECORD FROM O-RECORD ALLOWING NO UNLOCK ACKORD.
    WRITE PREC AFTER PAGE GO OA3.
OA9. CLOSE ACKORD ACKLIN PERFORM CLOSE-PR GO MX9.

OA-LINE. PERFORM PR-LINE IF WS-LINES>46 WRITE PREC AFTER PAGE PERFORM OA-PAGE PERFORM PR-LINE.
OA-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 2 TO WS-PR.
    MOVE "IRVINE FASTENERS - - - - - - - - - - - - - - - - - - - ORDER ACKNOWLEDGEMENT" TO PREC PERFORM PR-LINE.
    MOVE 3 TO WS-PR MOVE "SOLD TO:" TO FD588 MOVE C-NAME TO FD589.
    MOVE "ORDER NO." TO FD591 MOVE O-NO TO FD592.
    MOVE "PAGE" TO FD593 MOVE WS-PAGE TO FD594 PERFORM PR-LINE.
    MOVE C-ADD1 TO FD589 MOVE "DATE:" TO FD595.
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD596 PERFORM PR-LINE.
    MOVE C-ADD2 TO FD589 MOVE "CUST. NO." TO FD597 MOVE O-CUS TO FD598 PERFORM PR-LINE.
    MOVE C-POST TO FD589 MOVE "SHIP-TO CODE:" TO FD599 MOVE O-SHIPTO TO FD600 PERFORM PR-LINE.
    MOVE "CUST. ORDER NO." TO FD601 MOVE O-CUSORD TO FD602 PERFORM PR-LINE.
    MOVE "SHIP TO:" TO FD588 MOVE O-NAME TO FD589 MOVE "DATE REQUIRED:" TO FD603.
    MOVE O-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FD604 PERFORM PR-LINE.
    MOVE O-ADD1 TO FD589 MOVE "TERMS:" TO FD605 MOVE O-TERMS TO FD606 PERFORM PR-LINE.
    MOVE O-ADD2 TO FD589 MOVE "FOB:" TO FD607 MOVE O-FOB TO FD608 PERFORM PR-LINE.
    MOVE O-POST TO FD589 MOVE "PPD/COL:" TO FD609 MOVE O-PPD TO FD610.
    MOVE "EXP/BUYER:" TO FD611 MOVE O-PAYER TO FD612 PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE "                 VIA:" TO FD585.
    MOVE O-VIA TO OA-DF1A MOVE OA-DF1 TO FD586.
    MOVE O-VIA TO SV-KEY PERFORM RD-VIA MOVE SV-CARRIER TO FD587 PERFORM PR-LINE.
    MOVE "SPECIAL INSTRUCTIONS:" TO FD585.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      IF O-TEXT(IX1) NOT=0 MOVE O-TEXT(IX1) TO OA-DF1A MOVE OA-DF1 TO FD586
        MOVE 3 TO T-TBL MOVE O-TEXT(IX1) TO T-NO PERFORM RD-TBL MOVE T-LINE TO FD587 END-IF
      PERFORM PR-LINE END-PERFORM.
    MOVE "SALES CONTACT:" TO FD615 MOVE O-SALCONT TO FD616.
    IF O-FRATE NOT=0 MOVE "FREIGHT:" TO FD617 MOVE O-FRATE TO FD618 MOVE "C" TO FD619.
    IF O-FLOT NOT=0 MOVE "FREIGHT:" TO FD617 MOVE O-FLOT TO FD618 MOVE "LOT" TO FD619.
    PERFORM PR-LINE MOVE 3 TO WS-PR.
    MOVE "PRODUCT            QTY      PRICE   MODE  DISCOUNT                   AMOUNT" TO PREC PERFORM PR-LINE.
*         ............ ...,...,...-  ...:...   ..  .....................  .,..,...:..-
    MOVE ALL "-" TO PREC(1:78) PERFORM PR-LINE.

* Z-16-15 PRINT STATEMENTS
QT1. PERFORM RD325 PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 44 TO IXV PERFORM AX-CUS-R.
    MOVE 5 TO IXT MOVE 18 TO IXU PERFORM AX-DT-VAL.
    MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-YY TO QT-YY MOVE D-MM TO QT-MM.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.

    PERFORM DSP-WAIT PERFORM OPEN-PR WRITE PREC AFTER PAGE.
    OPEN I-O STATEMENT ALLOWING ALL SOLDTO ALLOWING ALL.
    MOVE " " TO OLD-C MOVE 0 TO QT-KS MOVE CUS1 TO TR-CUS MOVE 0 TO TR-INV.
    START TRANS KEY>TR-KEY REGARDLESS INVALID GO QT9.
QT3. READ TRANS NEXT REGARDLESS END GO QT9. IF TR-CUS>CUS2 GO QT9.
    IF TR-AMT=0 GO QT3. IF TR-CUS=OLD-C GO QT4.
    IF OLD-C>" " AND QT-KS=0 PERFORM QT-END WRITE PREC AFTER PAGE.
    MOVE TR-CUS TO OLD-C A-A1 PERFORM RD-CUS MOVE C-STAT TO QT-KS.
    IF QT-KS=0 MOVE 0 TO WS-PAGE PERFORM QT-PAGE.

    MOVE 0 TO QT-KD MOVE TR-CUS TO SW-CUS MOVE 0 TO SW-DATE SW-LINE.
    START STATEMENT KEY>SW-KEY REGARDLESS INVALID GO QT34.
QT33. READ STATEMENT NEXT REGARDLESS END GO QT34. IF SW-CUS>TR-CUS GO QT34.
    MOVE SW-DATE TO D-DATE PERFORM D-NM.
    IF D-YY=QT-YY AND D-MM=QT-MM MOVE 1 TO QT-KD GO QT34. GO QT33.
QT34. PERFORM QT-I.
    MOVE C-TOT TO SW-BAL(1) MOVE C-CUR TO SW-BAL(2) MOVE C-30 TO SW-BAL(3).
    MOVE C-60 TO SW-BAL(4) MOVE C-90 TO SW-BAL(5) MOVE C-120 TO SW-BAL(6).
    IF QT-KD=0 WRITE SW-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK STATEMENT.
    PERFORM QT-I.

QT4. MOVE TR-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA489.
    MOVE TR-CUSORD TO FA489A MOVE TR-INV TO FA490.
    IF TR-AMT>0 MOVE TR-AMT TO FA491(1) ELSE COMPUTE FA491(2)=-TR-AMT.
    IF QT-KS=0 PERFORM QT-LINE ELSE MOVE " " TO PREC. ADD 1 TO SW-LINE.
    MOVE TR-DATE TO SW-TDATE MOVE TR-INV TO SW-INV MOVE TR-AMT TO SW-AMT.
    MOVE TR-CUSORD TO SW-CUSORD MOVE TR-BL TO SW-BL.
    IF QT-KD=0 WRITE SW-RECORD ALLOWING NO INVALID CONTINUE END-WRITE UNLOCK STATEMENT.
    GO QT3.
QT9. IF OLD-C>" " AND QT-KS=0 PERFORM QT-END.
    CLOSE STATEMENT SOLDTO PERFORM CLOSE-PR GO MX9.

QT-I. MOVE LOW-VALUES TO SW-RECORD INITIALIZE SW-REC.
    MOVE TR-CUS TO SW-CUS MOVE DATE0 TO SW-DATE MOVE 0 TO SW-LINE.
QT-END. PERFORM PR-LINE MOVE C-TOT TO FA491(3) PERFORM PR-LINE.
QT-LINE. PERFORM PR-LINE IF WS-LINES>45 WRITE PREC AFTER PAGE PERFORM QT-PAGE.
QT-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 12 TO WS-PR.
    MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-DT TO FA482 MOVE C-NO TO FA483.
    PERFORM PR-LINE PERFORM GET-CUSADD.
    MOVE CUS-LINE(1) TO FA481 PERFORM PR-LINE.
    MOVE CUS-LINE(2) TO FA481 MOVE "PAGE" TO FA487 MOVE WS-PAGE TO FA488 PERFORM PR-LINE.
    MOVE CUS-LINE(3) TO FA481 PERFORM PR-LINE.
    MOVE CUS-LINE(4) TO FA481 PERFORM PR-LINE.
    MOVE CUS-LINE(5) TO FA481 PERFORM PR-LINE MOVE 6 TO WS-PR.
    MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-DT TO FA484 MOVE C-CUR TO FA485.
    MOVE C-30 TO FA486(1) MOVE C-60 TO FA486(2) MOVE C-90 TO FA486(3).
    MOVE C-120 TO FA486(4) PERFORM PR-LINE-4.

* Z-16-16 STATEMENT HISTORY REPORT
QV1. PERFORM RD326 PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 44 TO IXV PERFORM AX-CUS-R.
    MOVE 5 TO IXT MOVE 14 TO IXU MOVE 34 TO IXV PERFORM AX-YM-S.
    MOVE D-YY TO QV-YY MOVE D-MM TO QV-MM.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM QV-PAGE.
    OPEN I-O STATEMENT ALLOWING ALL.
    MOVE CUS1 TO SW-CUS MOVE 0 TO SW-DATE SW-LINE MOVE " " TO OLD-C.
    START STATEMENT KEY>SW-KEY REGARDLESS INVALID GO QV9.
QV3. READ STATEMENT NEXT REGARDLESS END GO QV9. IF SW-CUS>CUS2 GO QV9.
    MOVE SW-DATE TO D-DATE PERFORM D-NM IF NOT(D-YY=QV-YY AND D-MM=QV-MM) GO QV3.
    IF SW-CUS=OLD-C GO QV34. IF OLD-C>" " PERFORM PR-LINE.
    MOVE SW-CUS TO OLD-C FD224 A-A1 PERFORM RD-CUS MOVE C-NAME TO FD225.
    MOVE SW-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD226.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE SW-BAL(IX1) TO FD227(IX1) END-PERFORM.
    PERFORM QV-LINE GO QV3.
QV34. MOVE SW-TDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD228.
    MOVE SW-INV TO FD229 MOVE SW-CUSORD TO FD230 MOVE SW-BL TO FD231.
    IF SW-AMT>0 MOVE SW-AMT TO FD232(1) ELSE COMPUTE FD232(2)=-SW-AMT.
    PERFORM QV-LINE GO QV3.
QV9. CLOSE STATEMENT PERFORM CLOSE-PR GO MX9.

QV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QV-PAGE.
QV-PAGE. MOVE "STATEMENT HISTORY REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-CUS.
    MOVE "CUS    NAME                            STMT DATE      BALANCE       CURRENT       30 DAYS       60 DAYS       90 DAYS      120 DAYS" TO PREC PERFORM PR-LINE.
    MOVE "         DATE   INVOICE  CUST ORDER  B/L       CHARGES      CREDITS" TO PREC PERFORM PR-LINE-3.
*         ...... ................................ ../../.. .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..-
*                ../../..  ......  ......... ....... .,...,...:.. .,...,...:..

* Z-17: TOOLS FUNCTIONS

* Z-17-1 LIST M.O.'S WITH INCOMPLETE TOOL LIST
NB1. PERFORM RD285 PERFORM WRT IF S-BAT GO NB2.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
NB2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM NB-PAGE.
    MOVE " " TO OLD-A MOVE 1 TO PR-IXP.
    MOVE " " TO R-KP START PRODORD KEY>R-KP REGARDLESS INVALID GO NB9.
NB3. READ PRODORD NEXT REGARDLESS END GO NB9. IF R-FIN=1 OR R-QTY-LEFT<=0 GO NB3.
    IF R-PROD=OLD-A GO NB4. MOVE R-PROD TO OLD-A P-NO.
    READ PRODUCT REGARDLESS INVALID GO NB3. IF P-CAT>60 GO NB3. IF P-MAC=0 GO NB36.
    PERFORM GET-TS IF A-S1=1 GO NB36. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
NB33. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " AND TL-MAND=1 GO NB36.
    ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NB33. GO NB4.
NB36. MOVE TS-PROD TO FD95(PR-IXP) MOVE TS-MAC TO FD96(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>5 PERFORM NB-LINE MOVE 1 TO PR-IXP.
NB4. GO NB3.
NB9. PERFORM PR-LASTLN PERFORM CLOSE-PR GO MX9.

NB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NB-PAGE.
NB-PAGE. MOVE "PRODUCTS (IN CURRENT M.O.'S) WITH AN INCOMPLETE TOOL LIST" TO FF3X.
    PERFORM PR-PAGE PERFORM PR-LINE.

* Z-17-2 LIST BINS WITH TOOLS NOT USED IN ANY TOOL LIST
NL1. PERFORM RD69 PERFORM WRT IF S-BAT MOVE S-S1 TO NL-KMAC GO NL2.
    MOVE 3 TO IXT MOVE 12 TO IXU MOVE 34 TO IXV PERFORM AX-PBIN-R.
    ACCEPT XA3 LINE 7 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO NL-KMAC ELSE MOVE 0 TO NL-KMAC.
    MOVE 9 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE NL-KMAC TO S-S1 GO MX9.
NL2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM NL-PAGE MOVE 0 TO NL-TOTAL.
    MOVE PBIN1 TO BH-NO START PURBIN KEY>BH-KEY REGARDLESS INVALID GO NL9.
NL3. READ PURBIN NEXT REGARDLESS END GO NL9. IF BH-NO>PBIN2 GO NL9.
    IF BH-PART=" " GO NL3.
    MOVE BH-NO TO FF198 MOVE BH-PART TO FF199 MOVE BH-QTY TO FF201.
    MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF202.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID
      MOVE "** NO TOOL RECORD **" TO FF200 PERFORM NL-LINE GO NL8.
    PERFORM PART-TYPE IF NOT PART-TOOL
      MOVE "** PART IS NOT A TOOL **" TO FF200 PERFORM NL-LINE GO NL8.
    INITIALIZE TP-KEY MOVE PH-NO TO TP-TOOL.
    START TOOLPROD KEY>TP-KEY REGARDLESS INVALID GO NL38.
NL33. READ TOOLPROD NEXT REGARDLESS END GO NL38. IF TP-TOOL NOT=PH-NO GO NL38.
    IF NL-KMAC=0 MOVE " " TO PREC GO NL8.
    MOVE TP-PROD TO A-A1 PERFORM PROD-GEN.
    IF TP-MAC=P-MAC OR P-ALT-MAC MOVE " " TO PREC GO NL8. GO NL33.
NL38. MOVE PH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF202A.
    MOVE PH-LDCOST TO A-T1 PERFORM DIV-PAMT.
    COMPUTE WD1 ROUNDED=A-T1 * BH-QTY MOVE WD1 TO FF203 ADD WD1 TO NL-TOTAL.
    COMPUTE WN1=PH-CAT / 100 MULTIPLY 100 BY WN1 IF PH-CAT - WN1=95 GO NL6.
    COMPUTE PH-CAT=WN1 + 95 MOVE 0 TO PH-ROP MOVE 3 TO PH-LEVEL.
    MOVE PH-CAT TO FF203A REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
NL6. MOVE PH-DESC1 TO FF200 PERFORM NL-LINE.
    IF PH-DESC2>" " MOVE PH-DESC2 TO FF200 PERFORM NL-LINE.
NL8. GO NL3.
NL9. MOVE 2 TO WS-PR MOVE "*** TOTAL" TO PREC MOVE NL-TOTAL TO FF203 PERFORM PR-LINE.
    PERFORM CLOSE-PR GO MX9.

NL-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NL-PAGE.
NL-PAGE. IF NL-KMAC=0 MOVE "BINS WITH TOOLS NOT USED IN ANY TOOL LIST" TO FF3X
      ELSE MOVE "BINS WITH TOOLS NOT USED IN TOOL LISTS OF DEFAULT OR ALTERNATE MACHINES" TO FF3X.
    PERFORM PR-PAGE MOVE 2 TO WS-PR PERFORM PRANGE-PBIN.
    MOVE "BIN     PART NO.      DESCRIPTION                         QTY    SINCE    LAST RCVD     VALUE   CAT CHANGED TO X95" TO PREC PERFORM PR-LINE-3.
*         ......  ............  ................................  .,...-  ../../..  ../../.. .,...,...:..         ...

* Z-17-3 LIST BACK INSERTS WITH NO ALTERNATES
NH1. PERFORM RD398 PERFORM WRT IF S-BAT GO NH2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
NH2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO NH29.
NH23. READ TOOLS NEXT REGARDLESS END GO NH29. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
NH25. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO NH28.
    IF NOT(TL-PAGE>0 AND TL-CAT=6 AND (TL-LOC=4 OR 7)) GO NH28.
    MOVE TS-TOOL(TL-FLD) TO PH-NO READ PART REGARDLESS INVALID GO NH28.
    IF PH-ALT=0 PERFORM INIT-RP
      MOVE PH-NO TO RP-F231 WRITE RP-RECORD INVALID CONTINUE.
NH28. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NH25. GO NH23.
NH29. PERFORM OPEN-PR PERFORM NH-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO NH9.
NH3. READ REPFL NEXT END GO NH9. MOVE RP-F231 TO FA598(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM NH-LINE MOVE 1 TO PR-IXP. GO NH3.
NH9. PERFORM PR-LASTLN.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

NH-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NH-PAGE.
NH-PAGE. MOVE "BACK INSERTS WITH NO ALTERNATES" TO FF3 PERFORM PR-PAGE.
    PERFORM PR-LINE.

* Z-17-4 TOOL REQUISITION REPORT
NQ1. PERFORM RD79 PERFORM WRT IF S-BAT GO NQ2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
NQ2. PERFORM DSP-WAIT PERFORM OPEN-REP PERFORM OPEN-SORT.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO NQ29.
NQ23. READ PART NEXT REGARDLESS END GO NQ29. PERFORM PART-TYPE IF NOT PART-TOOL GO NQ23.
    IF NOT(PH-DATE-REQ(1)=0 AND PH-DATE-REQ(2)=0 AND PH-QTY-REQ=0)
      MOVE PH-DATE-REQ(1) TO PH-DATE-REQ(2) MOVE 0 TO PH-DATE-REQ(1) PH-QTY-REQ
      REWRITE PH-RECORD ALLOWING NO UNLOCK PART.

    IF PH-ROP<=2 OR (PH-HAND + PH-ASM-HAND) + PH-ORDER - (PH-DEMAND + PH-ASM-DEMAND)<=2 * PH-ROP GO NQ26.
    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO NQ26.
NQ25. READ PURLIN NEXT REGARDLESS END GO NQ26. IF LK-PART NOT=PH-NO GO NQ26.
    IF LK-QTY>0 AND>LK-QTY-REC
      MOVE LK-PART TO SR-F83 MOVE LK-ORD TO SR-F84 MOVE LK-LINE TO SR-F85
      WRITE SR-RECORD INVALID CONTINUE.
    GO NQ25.
NQ26. PERFORM CALC-PART-REQ IF A-N1=0 GO NQ23. MOVE A-N1 TO NQ-RQTY.
    PERFORM INIT-RP MOVE PH-ASM TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO RP-F103.
    PERFORM CHK-TLIFE MOVE A-N1 TO RP-F103A.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO RP-F104.
    MOVE PH-KEY TO RP-F105 MOVE NQ-RQTY TO RP-F106 WRITE RP-RECORD GO NQ23.

NQ29. PERFORM OPEN-PR MOVE 1 TO NQ-STEP.
    MOVE 0 TO NQ-ASM MOVE 1 TO NQ-LF MOVE " " TO OLD-A PERFORM NQ-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO NQ6.
NQ3. READ REPFL NEXT END GO NQ6. MOVE RP-F105 TO PH-KEY READ PART REGARDLESS.
    IF RP-F103 NOT=NQ-ASM
      MOVE RP-F103 TO NQ-ASM MOVE 1 TO NQ-LF MOVE " " TO OLD-A PERFORM NQ-PAGE.
    IF RP-F103A NOT=NQ-LF
      MOVE RP-F103A TO NQ-LF MOVE " " TO OLD-A PERFORM NQ-PAGE.
    IF RP-F104 NOT=OLD-A PERFORM NQ-LINE MOVE RP-F104 TO OLD-A.
    MOVE RP-F106 TO NQ-RQTY.
    MOVE PH-NO TO FF212 MOVE RP-F104 TO FF213 MOVE PH-DESC1 TO FF214.
    MOVE PH-LIFE TO FF215 MOVE PH-HAND TO FF216 MOVE PH-ORDER TO FF217.
    MOVE PH-DEMAND TO FF218 MOVE PH-ROP TO FF219 MOVE PH-EOQ TO FF220.
    MOVE NQ-RQTY TO FF221 IF PH-VENDOR(1)=9250 MOVE OK-NO TO FF221A.
    PERFORM NQ-LINE.
    MOVE SYS-DATE TO PH-DATE-REQ(1).
    IF PH-DATE-REQ(2) NOT=0 MOVE PH-DATE-REQ(2) TO PH-DATE-REQ(1).
    MOVE NQ-RQTY TO PH-QTY-REQ REWRITE PH-RECORD ALLOWING NO UNLOCK PART GO NQ3.
NQ6. PERFORM CLOSE-REP.

    MOVE 2 TO NQ-STEP PERFORM NQ-PAGE MOVE 1 TO PR-IXP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO NQ9.
NQ7. READ SORTFL NEXT END GO NQ9.
    MOVE SR-F83 TO FF426(PR-IXP) MOVE SR-F84 TO FF427(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>4 PERFORM NQ-LINE MOVE 1 TO PR-IXP. GO NQ7.
NQ9. PERFORM PR-LASTLN.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

NQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NQ-PAGE.
NQ-PAGE. MOVE "TOOL REQUISITION REPORT" TO FF3.
    IF NQ-STEP=1
      IF NQ-ASM=0 MOVE "** SUPPORT TOOLS" TO A-A1 ELSE MOVE "** ASSEMBLED DIES" TO A-A1 END-IF
      IF NQ-LF=1 MOVE " - LIFE UNDER 100M **" TO A-A2 END-IF
      IF NQ-LF=2 MOVE " - LIFE 100M+ UNDER 1000M **" TO A-A2 END-IF
      IF NQ-LF=3 MOVE " - LIFE 1000M+ **" TO A-A2 END-IF
      STRING A-A1 A-A2 DELIMITED "  " INTO FF4.
    IF NQ-STEP=2 MOVE "** EXCESS PARTS ON ORDER **" TO FF4. PERFORM PR-PAGE.
    IF NQ-STEP=1 MOVE
         "PART NO.      DRAWING         DESCRIPTION                        LIFE  ON HAND  ON ORDER  ON DEMAND   ROP   EOQ  REQ QTY  IRV TOOLS" TO PREC PERFORM PR-LINE-3.
*         ............  ..............  ................................  .....  ..,...-   ..,...-  ...,...-  .,... .,...  ..,...   ........
    IF NQ-STEP=2 MOVE
         "PART NO.      ORDER           PART NO.      ORDER           PART NO.      ORDER           PART NO.      ORDER" TO PREC PERFORM PR-LINE-3.
*         ............  ........        ............  ........        ............  ........        ............  ........

* Z-17-5 TOOL RUN-OUT REPORT
NR1. PERFORM RD70 PERFORM WRT IF S-BAT MOVE S-N1 TO NR-MINROP GO NR2.
    MOVE 0 TO NR-MINROP DISPLAY NR-MINROP LINE 3 COLUMN 53 CONVERSION.
    ACCEPT NR-MINROP LINE 3 COLUMN 55 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY NR-MINROP LINE 3 COLUMN 55 CONVERSION.
    MOVE 5 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE NR-MINROP TO S-N1 GO MX9.
NR2. PERFORM DSP-WAIT.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO NR214.
NR213. READ PART NEXT REGARDLESS END GO NR214.
    PERFORM PART-TYPE IF NOT PART-TOOL GO NR213.
    IF PH-QTY-TMP NOT=0 MOVE 0 TO PH-QTY-TMP
      REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
    GO NR213.
NR214.

    MOVE "X" TO BH-NO START PURBIN KEY>BH-KEY REGARDLESS INVALID GO NR218.
NR215. READ PURBIN NEXT REGARDLESS END GO NR218. IF BH-NO(1:1)>"X" GO NR218.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID GO NR216.
    ADD BH-QTY TO PH-QTY-TMP REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
NR216. GO NR215.
NR218.

    PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO NR29.
NR23. READ PRODORD NEXT REGARDLESS END GO NR29.
    IF R-DATE>SYS-DATE + 70 OR R-QTY-ORD=0 OR R-QTY-PROD NOT=0 GO NR28.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO NR28.
    IF P-MAC=0 OR 99 GO NR28. PERFORM INIT-RP.
    IF R-LDATE(1)=0 MOVE R-DATE TO NR-MDATE
      ELSE IF R-LDATE(1)<R-DATE MOVE R-LDATE(1) TO NR-MDATE ELSE MOVE R-DATE TO NR-MDATE.
    MOVE NR-MDATE TO RP-F98 MOVE R-KEY TO RP-F99.
    PERFORM GET-TS IF A-S1=1 GO NR28. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
NR25. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO NR26.
    MOVE TS-TOOL(TL-FLD) TO RP-F97 PH-NO READ PART REGARDLESS INVALID GO NR26.
    IF PH-ASM=0 IF NOT(TL-MAND=1 OR PH-DEMAND>=3) GO NR26.
    IF PH-ASM=1 IF NOT(PH-HAND<PH-DEMAND) GO NR26.
    MOVE PH-ASM TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO RP-F96.
* note 34
    MOVE 1 TO RP-F100.
    WRITE RP-RECORD INVALID READ REPFL ADD 1 TO RP-F100 REWRITE RP-RECORD.
NR26. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NR25.
NR28. MOVE 0 TO R-LTOOLS R-LDATE(3) REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
* note 33.2
    GO NR23.
NR29. PERFORM OPEN-PR PERFORM OPEN-SORT.
    MOVE 0 TO NR-ASM MOVE 1 TO NR-STEP PERFORM NR-PAGE.
    MOVE " " TO OLD-A MOVE 0 TO NR-STOT.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO NR9.
NR3. READ REPFL NEXT END GO NR9. IF RP-F96=NR-ASM GO NR34. PERFORM NR-SUB.
    MOVE RP-F96 TO NR-ASM PERFORM NR-PAGE MOVE " " TO OLD-A MOVE 0 TO NR-STOT.
NR34. IF RP-F97=OLD-A IF NR-KERR=1 OR NR-KMIN=1 GO NR3 ELSE GO NR4.
    IF OLD-A>" " PERFORM NR-SUB.
* note 36.1
    MOVE 2 TO WS-PR.
    MOVE 0 TO NR-LSTEP NR-KMIN NR-KERR NR-RDATE NR-KPUR NR-IXP
      NR-QNUM NR-QDT1 NR-QDT2 NR-KSV NR-SVLN.
    PERFORM INIT-PH MOVE RP-F97 TO PH-NO OLD-A.
    READ PART REGARDLESS INVALID MOVE 1 TO NR-KERR GO NR3. PERFORM PART-TYPE.
    IF PH-ASM=0 AND PH-LIFE=0 MOVE 1 TO NR-KERR GO NR3.
    IF PH-ROP<NR-MINROP MOVE 1 TO NR-KMIN GO NR3.
    MOVE PH-NO TO FF284 MOVE PH-DESC1 TO FF285 MOVE "LIFE:" TO FF286.
    MOVE PH-LIFE TO FF287 MOVE "DATE LAST RCVD:" TO FF287A.
    MOVE PH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF287B.
    COMPUTE NR-TOT=PH-HAND - PH-QTY-TMP.
* note 35
NR4. MOVE RP-F99 TO R-KEY READ PRODORD REGARDLESS MOVE RP-F98 TO NR-MDATE.
    MOVE R-PROD TO A-A1 PERFORM PROD-RGD.
    MOVE RP-F100 TO NR-TNUM COMPUTE NR-TQTY=NR-TNUM * R-QTY-ORD.
    IF NR-ASM=0 MOVE NR-TQTY TO A-T1 PERFORM ADJ-PLIFE MOVE 0 TO NR-TMIN
      COMPUTE NR-QTY ROUNDED=A-T1 / PH-LIFE / 1000 SIZE ERROR MOVE 0 TO NR-QTY END-COMPUTE
     ELSE MOVE 2 TO NR-TMIN MOVE 0 TO NR-QTY.
    SUBTRACT NR-QTY FROM NR-TOT.
    IF NR-LSTEP>0 OR NR-LSTEP=0 AND NR-TOT<NR-TMIN
      MOVE 1 TO R-LTOOLS REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    IF NR-LSTEP<2 AND NR-TOT>=NR-TMIN GO NR3.

    IF NR-LSTEP=0 GO NR50. IF NR-LSTEP=1 GO NR6.
* lstep=2
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>NR-IXP
      IF NR-PDATE(IX1)>0 AND<=NR-MDATE ADD NR-PQTY(IX1) TO NR-TOT
        MOVE 0 TO NR-PDATE(IX1) END-IF END-PERFORM.
    GO NR8.

NR50. MOVE 1 TO NR-LSTEP MOVE 0 TO A-N1 PERFORM FIND-PO-LATE.
    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO NR64.
NR6.
NR63. READ PURLIN NEXT REGARDLESS END GO NR64. IF LK-PART NOT=PH-NO GO NR64.
    IF LK-BLANKET=1 GO NR63. PERFORM CALC-LKQTY IF A-T1<=0 GO NR63.
    IF LK-DATE-TMP>NR-MDATE MOVE 1 TO NR-KPUR GO NR64.
    ADD A-T1 TO NR-TOT ROUNDED IF NR-TOT<NR-TMIN GO NR63.
    GO NR3.
NR64. IF NR-ASM=0
     IF NR-TMIN - NR-TOT<=0.25 * NR-QTY MOVE NR-TMIN TO NR-TOT
       IF NR-KPUR=1 MOVE 0 TO NR-KPUR START PURLIN KEY=LK-KP REGARDLESS END-IF
       GO NR3.
* note 67.2
    MOVE 2 TO NR-LSTEP PERFORM NR-SLINE MOVE "RUN-OUT:" TO FF288.
    MOVE NR-MDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF289.

    IF NR-KPUR=0 COMPUTE NR-RDATE=SYS-DATE + 70 PERFORM NR-SLINE GO NR8.
    MOVE "TOOLS AVL:" TO FF291 MOVE LK-DATE-TMP TO NR-RDATE MOVE 0 TO NR-KFIR.
NR65. MOVE LK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FF292.
    IF NR-KFIR=0 MOVE "P.O.:" TO FF293 MOVE "QTY:" TO FF295.
    PERFORM CALC-LKQTY MOVE LK-ORD TO FF294 COMPUTE FF296 ROUNDED=A-T1.
    IF LK-DATE-TMP NOT=LK-DATE-REQ MOVE "LATE" TO FF297.
    PERFORM NR-SLINE MOVE 1 TO NR-KFIR.
    IF NR-IXP<10 ADD 1 TO NR-IXP MOVE LK-DATE-REQ TO NR-PDATE(NR-IXP)
      COMPUTE NR-PQTY(NR-IXP) ROUNDED=A-T1.
NR67. READ PURLIN NEXT REGARDLESS END GO NR68. IF LK-PART NOT=PH-NO GO NR68.
    IF LK-BLANKET=1 GO NR67. PERFORM CALC-LKQTY IF A-T1<=0 GO NR67. GO NR65.
NR68. PERFORM NR-SLINE.

NR8. IF TOT-IND=1 GO NR84.
    IF NR-TOT>-1 ADD 1 TO NR-QNUM
      IF NR-QDT1=0 MOVE NR-MDATE TO NR-QDT1 END-IF
      IF NR-QDT2=0 MOVE NR-MDATE TO NR-QDT2 END-IF
      IF NR-MDATE<NR-QDT1 MOVE NR-MDATE TO NR-QDT1 END-IF
      IF NR-MDATE>NR-QDT2 MOVE NR-MDATE TO NR-QDT2 END-IF
     ELSE MOVE 1 TO NR-KSV IF NR-QNUM>0 PERFORM NR-Q END-IF
      MOVE R-NO TO FF300 MOVE P-NO TO FF301 MOVE PRO-DESC(1) TO FF302
      MOVE NR-MDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF303
      MOVE R-QTY-ORD TO FF305
      IF NR-TNUM>1 MOVE " x" TO FF305A MOVE NR-TNUM TO FF306 END-IF
      COMPUTE FF307 ROUNDED=-NR-TOT PERFORM NR-SLINE ADD NR-TQTY TO NR-STOT.
NR84. IF NR-TOT<=-1 MOVE NR-RDATE TO R-LDATE(3)
        REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    MOVE R-PROD TO SR-F38 MOVE PH-NO TO SR-F39 MOVE PH-DESC1 TO SR-F40.
    WRITE SR-RECORD INVALID CONTINUE.
    GO NR3.
NR9. PERFORM NR-SUB MOVE 2 TO NR-STEP PERFORM NR-SUM.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

NR-SUB. PERFORM NR-S1 THRU NR-S9.
NR-S1. IF NR-KSV=0 MOVE " " TO PREC GO NR-S9.
* note 55
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>NR-SVLN
      MOVE XM-F4(IX1) TO PREC PERFORM NR-LINE MOVE " " TO PREC END-PERFORM.
    IF TOT-IND=0 AND NR-QNUM>0 PERFORM NR-Q.
    MOVE 2 TO WS-PR MOVE "** TOOL TOTAL" TO FF302.
    MOVE NR-STOT TO FF305 MOVE "**" TO FF305A PERFORM NR-LINE 2 TIMES.
    MOVE 0 TO NR-STOT.
NR-S9. EXIT.
NR-Q. MOVE "NO SHORTAGE FOR" TO FF308 MOVE NR-QNUM TO FF309.
    IF NR-QNUM=1 MOVE " ORDER" TO FF310 ELSE MOVE " ORDERS" TO FF310.
    MOVE NR-QDT1 TO D-DATE PERFORM D-NM MOVE D-DT TO FF311.
    IF NR-QDT2 NOT=NR-QDT1 MOVE "-" TO FF312
      MOVE NR-QDT2 TO D-DATE PERFORM D-NM MOVE D-DT TO FF313.
    PERFORM NR-SLINE MOVE 0 TO NR-QNUM NR-QDT1 NR-QDT2.
NR-SLINE. IF WS-PR>1 PERFORM UNTIL WS-PR=1
      IF NR-SVLN<120 ADD 1 TO NR-SVLN MOVE " " TO XM-F4(NR-SVLN) END-IF
      SUBTRACT 1 FROM WS-PR END-PERFORM.
    IF NR-SVLN<120 ADD 1 TO NR-SVLN MOVE PREC TO XM-F4(NR-SVLN).
    MOVE " " TO PREC MOVE 1 TO WS-PR.
NR-SUM. PERFORM NR-SM1 THRU NR-SM9.
NR-SM1. PERFORM NR-PAGE MOVE " " TO OLD-A MOVE 1 TO PR-IXP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO NR-SM8.
NR-SM3. READ SORTFL NEXT END GO NR-SM8. IF SR-F38=OLD-A GO NR-SM4.
    IF OLD-A>" " IF PR-IXP>1 PERFORM NR-LINE END-IF MOVE 2 TO WS-PR.
    MOVE SR-F38 TO OLD-A FD18 MOVE ":" TO FD18A MOVE 1 TO PR-IXP.
NR-SM4. MOVE SR-F39 TO FD19(PR-IXP) MOVE SR-F40 TO FD19A(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>2 PERFORM NR-LINE MOVE 1 TO PR-IXP. GO NR-SM3.
NR-SM8. PERFORM PR-LASTLN.
NR-SM9. EXIT.
NR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NR-PAGE.
NR-PAGE. MOVE "TOOL RUN-OUT REPORT" TO FF3.
    IF NR-STEP=1 AND NR-ASM=0 MOVE "** SUPPORT TOOLS **" TO FF4.
    IF NR-STEP=1 AND NR-ASM=1 MOVE "** ASSEMBLED DIES **" TO FF4.
    IF NR-STEP=2 MOVE "** TOOL SHORTAGE SUMMARY **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF NR-STEP=1 MOVE NR-MINROP TO DSP-N41
      STRING "INCLUDES ONLY TOOLS WITH MINIMUM R.O.P.:" DSP-N41 DELIMITED SIZE INTO PREC
      MOVE 2 TO WS-PR PERFORM PR-LINE MOVE 2 TO WS-PR MOVE
         "  M.O.  PRODUCT                                        START DATE       QTY         CUM. TOOL SHORTAGE" TO PREC PERFORM PR-LINE-3.
*         ......  ............  ................................  ../../..  ...,...,...-.. ..    ..,...,...-
*         ...........  ................................    LIFE: ..,...    DATE LAST RCVD: ../../..
*                         RUN-OUT: ../../..     TOOLS AVL: ../../..     P.O.: ........   QTY: ...  ....
*                                   NO SHORTAGE FOR ... ORDERS    ../../.. - ../../..
    IF NR-STEP=2 PERFORM PR-LINE.

* Z-17-6 TOOL IDENTIFICATION REPORT
NA1. PERFORM RD80 PERFORM WRT IF S-BAT MOVE S-N1 TO NA-SEL GO NA2.
NA13. ACCEPT NA-SEL LINE 14 COLUMN 8 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(NA-SEL>=1 AND<=6) PERFORM DSP-ERR9 GO NA13.
    MOVE 16 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE NA-SEL TO S-N1 GO MX9.
NA2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO NA29.
NA23. READ TOOLS NEXT REGARDLESS END GO NA29. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
NA25. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO NA28.
    IF NOT(TL-PAGE>0 AND TL-STN=NA-STN(NA-SEL) AND TL-CAT=NA-CAT(NA-SEL)
      AND TL-LOC=NA-LOC(NA-SEL)) GO NA28.
    PERFORM INIT-RP MOVE TS-TOOL(TL-FLD) TO RP-F172 MOVE TS-MAC TO RP-F173.
    MOVE TS-PROD TO RP-F174 WRITE RP-RECORD.
NA28. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NA25. GO NA23.
NA29. PERFORM OPEN-PR PERFORM NA-PAGE MOVE " " TO OLD-A MOVE 0 TO OLD-M.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO NA9.
NA3. READ REPFL NEXT END GO NA9.
    IF NOT(RP-F172=OLD-A AND RP-F173=OLD-M)
      MOVE RP-F172 TO OLD-A FF314 MOVE RP-F173 TO OLD-M FF315.
    MOVE RP-F174 TO FF316 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FF317.
    PERFORM NA-LINE GO NA3.
NA9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

NA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NA-PAGE.
NA-PAGE. MOVE "TOOL IDENTIFICATION REPORT" TO FF3 EVALUATE TRUE
      WHEN NA-SEL=1 MOVE "3RD PUNCH INSERT 1 / 3RD PUNCH FRONT INS" TO FF4
      WHEN NA-SEL=2 MOVE "4TH PUNCH INSERT 1 / 4TH PUNCH FRONT INS" TO FF4
      WHEN NA-SEL=3 MOVE "3RD MIDDLE INSERT 2 / 3RD MIDDLE INSERT 2, INSERT 3" TO FF4
      WHEN NA-SEL=4 MOVE "3RD BACK INSERT, INSERT 1 / 3RD BACK INSERT 1" TO FF4
      WHEN NA-SEL=5 MOVE "4TH FRONT INSERT / 4TH FRONT INSERT 1" TO FF4
      WHEN NA-SEL=6 MOVE "3RD MIDDLE INSERT, INSERT 1 / 3RD FRONT INSERT 2" TO FF4
      END-EVALUATE PERFORM PR-PAGE.
    MOVE "TOOL          MAC   PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*         ............  ..    ............  ................................

* Z-17-7 ALTERNATE TOOL REPORT
ND1. PERFORM RD313 PERFORM WRT IF S-BAT GO ND2.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MX1.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
ND2. PERFORM DSP-WAIT PERFORM OPEN-REP MOVE 0 TO PH-ALT MOVE ALL "z" TO PH-KANO.
    START PART KEY>PH-KA REGARDLESS INVALID GO ND29.
ND23. READ PART NEXT REGARDLESS END GO ND29. PERFORM INIT-RP.
    IF Y1 MOVE PH-ALT(1:4) TO RP-F175. IF Y2 MOVE PH-ALT(9:4) TO RP-F175.
    MOVE PH-ALT TO RP-F175A MOVE PH-NO TO RP-F176 WRITE RP-RECORD GO ND23.
ND29. PERFORM OPEN-PR PERFORM ND-PAGE MOVE 0 TO OLD-N MOVE 1 TO PR-IXP.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO ND9.
ND3. READ REPFL NEXT END GO ND9.
    IF RP-F175A NOT=OLD-N IF PR-IXP>1 PERFORM ND-LINE END-IF
      MOVE RP-F175A TO OLD-N PART-ALT PERFORM SET-PALT MOVE PART-PRINT TO FF339
      MOVE 1 TO PR-IXP.
    MOVE RP-F176 TO FF340(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>7 PERFORM ND-LINE MOVE 1 TO PR-IXP. GO ND3.
ND9. PERFORM PR-LASTLN.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

ND-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM ND-PAGE.
ND-PAGE. MOVE "ALTERNATE TOOL REPORT" TO FF3.
    IF Y1 MOVE "** BY OUTSIDE DIAMETER **" TO FF4.
    IF Y2 MOVE "** BY HOLE SIZE **" TO FF4.
    PERFORM PR-PAGE PERFORM PR-LINE.

* Z-17-8 TOOL TABLES LISTING
NE1. PERFORM RD99 PERFORM WRT IF S-BAT GO NE2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
NE2. PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 1 TO NE-STEP PERFORM NE-PAGE.
    MOVE TL-BTOOLS TO TL-NUM MOVE 1 TO TL-IXF.
NE3. MOVE TL-BTBL(TL-IXF) TO TL-DATA PERFORM NE-P.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE TL-TINF(IX1) TO TL-INF
      IF TL-PAGE>0 MOVE TL-PAGE TO FG203(IX1) END-IF
      IF TL-MAND=1 MOVE "M" TO FG204(IX1) END-IF
      IF TL-SETUP=1 MOVE "S" TO FG205(IX1) END-IF END-PERFORM.
    PERFORM NE-LINE ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NE3.

    MOVE 2 TO NE-STEP PERFORM NE-PAGE.
    MOVE TL-YTOOLS TO TL-NUM MOVE 1 TO TL-IXF.
NE5. MOVE TL-YTBL(TL-IXF) TO TL-DATA PERFORM NE-P MOVE 1 TO IX1.
    IF TL-PAGE>0 MOVE TL-PAGE TO FG203(IX1).
    IF TL-MAND=1 MOVE "M" TO FG204(IX1). IF TL-SETUP=1 MOVE "S" TO FG205(IX1).
    PERFORM NE-LINE ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NE5.

    MOVE 3 TO NE-STEP PERFORM NE-PAGE.
    MOVE TL-XTOOLS TO TL-NUM MOVE 1 TO TL-IXF.
NE7. MOVE TL-XTBL(TL-IXF) TO TL-DATA PERFORM NE-P.
    PERFORM VARYING IX1 FROM 0 BY 1 UNTIL IX1>4
      IF IX1>0 MOVE TL-TINF(IX1) TO TL-INF END-IF
      IF TL-PAGE>0 MOVE TL-PAGE TO FG203(IX1 + 1) END-IF
      IF TL-MAND=1 MOVE "M" TO FG204(IX1 + 1) END-IF
      IF TL-SETUP=1 MOVE "S" TO FG205(IX1 + 1) END-IF END-PERFORM.
    PERFORM NE-LINE ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO NE7.
NE9. PERFORM CLOSE-PR GO MX9.

NE-P. MOVE TL-DESC TO FG200 IF TL-STN>0 MOVE TL-STN TO FG201.
    IF TL-CAT>=1 AND<=7 MOVE NE-TDESC(TL-CAT) TO FG202.
NE-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NE-PAGE.
NE-PAGE. MOVE "TOOL TABLES LISTING" TO FF3.
    IF NE-STEP=1 MOVE "** FOR MACHINES OF TYPE 7, 8, 9, 11 **" TO FF4.
    IF NE-STEP=2 MOVE "** FOR MACHINES OF TYPE 10 **" TO FF4.
    IF NE-STEP=3 MOVE "** FOR MACHINES OF TYPE 12 **" TO FF4. PERFORM PR-PAGE.
    IF NE-STEP=1 MOVE
         "        MACHINE                            TYPE 7             TYPE 8         TYPE 9 (17,20)     TYPE 9 (18,19)        TYPE 11" TO PREC PERFORM PR-LINE
      MOVE
         "TOOL                 STN  ASY            PG MND STP         PG MND STP         PG MND STP         PG MND STP         PG MND STP" TO PREC PERFORM PR-LINE-3.
*         ....................  .  ......          .   .   .          .   .   .          .   .   .          .   .   .          .   .   .
    IF NE-STEP=2 MOVE
         "        MACHINE                           TYPE 10" TO PREC PERFORM PR-LINE
      MOVE
         "TOOL                 STN  ASY            PG MND STP" TO PREC PERFORM PR-LINE-3.
*         ....................  .  ......          .   .   .
    IF NE-STEP=3 MOVE
         "        MACHINE                         TYPE 12 (24)       TYPE 12 (36)      TYPE 12 (32-34)     TYPE 12 (37)       TYPE 12 (39)" TO PREC PERFORM PR-LINE
      MOVE
         "TOOL                 STN  ASY            PG MND STP         PG MND STP         PG MND STP         PG MND STP         PG MND STP" TO PREC PERFORM PR-LINE-3.
*         ....................  .  ......          .   .   .          .   .   .          .   .   .          .   .   .          .   .   .

* Z-17-9 TOOL COSTING REPORT
NF1. PERFORM RD293 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO NF-KR MOVE S-S2 TO NF-KL GO NF2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    ACCEPT XA3 LINE 5 COLUMN 27 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO NF-KR ELSE MOVE 0 TO NF-KR.
    ACCEPT XA3 LINE 6 COLUMN 51 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO NF-KL ELSE MOVE 0 TO NF-KL.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE NF-KR TO S-S1 MOVE NF-KL TO S-S2 GO MX9.
* note 4
NF2. PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO NF24.
NF23. READ WORKSHEET NEXT REGARDLESS END GO NF24. IF J-DATE>DATE2 GO NF24.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO NF23.
    MOVE J-MAC TO A-N1 PERFORM RD-MAC.
    PERFORM INIT-RP MOVE M-GROUP TO RP-F206 MOVE M-SECT TO RP-F207.
    MOVE J-MAC TO RP-F208 MOVE J-PROD TO RP-F209 MOVE J-QTY TO RP-F210.
    WRITE RP-RECORD INVALID READ REPFL ADD J-QTY TO RP-F210 REWRITE RP-RECORD.
    GO NF23.
NF24. MOVE " " TO PT-KEY START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO NF29.
NF25. READ PARTRANS NEXT REGARDLESS END GO NF29.
    IF NOT((PT-TRANS="ISS" OR "OUT") AND PT-DATE>=DATE1 AND<=DATE2) GO NF25.
    MOVE PT-PART TO PH-NO READ PART REGARDLESS INVALID GO NF25.
    PERFORM PART-TYPE IF NOT PART-TOOL GO NF25.
    PERFORM CHK-TLIFE MOVE A-N1 TO NF-XL.
    MOVE PH-LDCOST TO A-T1 PERFORM DIV-PAMT COMPUTE NF-ICOST ROUNDED=A-T1 * PT-QTY.
    MOVE PT-MO TO R-NO READ PRODORD REGARDLESS INVALID
      MOVE " " TO P-NO MOVE 0 TO P-MAC M-GROUP M-SECT GO NF26.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO NF25.
    MOVE P-MAC TO A-N1 PERFORM RD-MAC.
NF26. PERFORM INIT-RP.
    MOVE M-GROUP TO RP-F206 MOVE M-SECT TO RP-F207 MOVE P-MAC TO RP-F208.
    MOVE P-NO TO RP-F209 MOVE NF-ICOST TO RP-F211(NF-XL) RP-F211(4).
    WRITE RP-RECORD INVALID READ REPFL
      ADD NF-ICOST TO RP-F211(NF-XL) RP-F211(4) REWRITE RP-RECORD.
    GO NF25.
NF29.

    IF NF-KR=1 OPEN OUTPUT GLTOOLCOST ALLOWING ALL.
    PERFORM OPEN-PR PERFORM NF-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE NF-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE LOW-VALUES TO NF-MTOTALS NF-TTOTALS NF-GTOTALS MOVE -1 TO OLD-M OLD-T.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO NF8.
NF3. READ REPFL NEXT END GO NF8.
    COMPUTE WN1=100 * RP-F206 + RP-F207 IF WN1=OLD-T GO NF32.
    IF OLD-T NOT=-1 PERFORM NF-M PERFORM NF-T.
    MOVE WN1 TO OLD-T MOVE -1 TO OLD-M.
    MOVE RP-F206 TO FF408 MOVE RP-F207 TO FF409.
NF32. IF RP-F208=OLD-M GO NF34. IF OLD-M NOT=-1 PERFORM NF-M.
    MOVE RP-F208 TO FF410 OLD-M.
NF34. MOVE RP-F209 TO FF411 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FF412.
    MOVE RP-F210 TO NF-PQ.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE 0 TO NF-PC(IX1) MOVE RP-F211(IX1) TO NF-PI(IX1) END-PERFORM.
    MOVE P-NO TO TS-PROD MOVE OLD-M TO TS-MAC READ TOOLS REGARDLESS INVALID GO NF6.
    PERFORM TL-SET-TYPE MOVE 1 TO TL-IXA.
NF5. IF TS-TOOL(TL-IXA)=" " OR "N/R" GO NF58.
    MOVE TS-TOOL(TL-IXA) TO PH-NO READ PART REGARDLESS INVALID GO NF58.
    PERFORM CHK-TLIFE MOVE A-N1 TO NF-XL.
    PERFORM PART-TYPE MOVE PH-LDCOST TO A-T1 PERFORM DIV-PAMT PERFORM ADJ-PLIFE.
    COMPUTE WD1 ROUNDED=A-T1 * NF-PQ / PH-LIFE / 1000 SIZE ERROR MOVE 0 TO WD1.
    ADD WD1 TO NF-PC(NF-XL) NF-PC(4).
NF58. ADD 1 TO TL-IXA IF TL-IXA<=TL-NUM GO NF5.
NF6. ADD NF-PQ TO NF-MQ NF-TQ NF-GQ.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      ADD NF-PC(IX1) TO NF-MC(IX1) NF-TC(IX1) NF-GC(IX1)
      ADD NF-PI(IX1) TO NF-MI(IX1) NF-TI(IX1) NF-GI(IX1) END-PERFORM.
    IF NF-KL=1 MOVE "*" TO FF417. PERFORM NF-P.

    MOVE RP-F206 TO EXP-N PERFORM EXPF MOVE RP-F207 TO EXP-N PERFORM EXPF.
    MOVE RP-F208 TO EXP-N PERFORM EXPF MOVE P-NO TO EXP-A PERFORM EXPF.
    MOVE PRO-DESC(1) TO EXP-A PERFORM EXPF MOVE NF-PQ TO EXP-N PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE NF-PC(IX1) TO EXP-D PERFORM EXPF
      COMPUTE EXP-T ROUNDED=NF-PC(IX1) * 1000 / NF-PQ SIZE ERROR MOVE 0 TO EXP-T END-COMPUTE PERFORM EXPF
      MOVE NF-PI(IX1) TO EXP-D PERFORM EXPF END-PERFORM.
    PERFORM EXP-LINE GO NF3.
NF8. PERFORM NF-M PERFORM NF-T.
    MOVE "*** GRAND TOTALS" TO PREC MOVE NF-GTOTALS TO NF-PTOTALS PERFORM NF-P.
    IF NF-KR=1 MOVE 347251 TO WS-GL1 MOVE 0 TO WS-GL2 WS-GL3 WS-GL4
      MOVE LOW-VALUES TO GTC-RECORD MOVE WS-GL TO GTC-GL COMPUTE GTC-AMT=-NF-GI(4)
      WRITE GTC-RECORD ALLOWING NO UNLOCK GLTOOLCOST
      CLOSE GLTOOLCOST.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP.
NF9. GO MX9.

NF-P. MOVE NF-PQ TO FF413 MOVE NF-PC(4) TO FF414 MOVE NF-PI(4) TO FF416.
    COMPUTE FF415 ROUNDED=NF-PC(4) * 1000 / NF-PQ SIZE ERROR CONTINUE.
    IF NF-KL=1 PERFORM PR-LINE ELSE PERFORM NF-LINE.
    IF NF-KL=1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3
      MOVE NF-PC(IX1) TO FF414 MOVE NF-PI(IX1) TO FF416
      COMPUTE FF415 ROUNDED=NF-PC(IX1) * 1000 / NF-PQ SIZE ERROR CONTINUE END-COMPUTE
      IF IX1=3 PERFORM NF-LINE ELSE PERFORM PR-LINE END-IF END-PERFORM.
NF-M. MOVE 2 TO WS-PR MOVE " ** MACHINE TOTALS" TO PREC.
    MOVE NF-MTOTALS TO NF-PTOTALS MOVE "**" TO FF417 PERFORM NF-P.
    PERFORM NF-LINE MOVE LOW-VALUES TO NF-MTOTALS.
NF-T. MOVE "*** DEPT/SECT TOTALS" TO PREC.
    MOVE NF-TTOTALS TO NF-PTOTALS MOVE "***" TO FF417 PERFORM NF-P.
    PERFORM NF-LINE 2 TIMES.
    IF NF-KR=1 MOVE 247631 TO WS-GL1
      DIVIDE OLD-T BY 100 GIVING WS-GL2 REMAINDER WS-GL3 MOVE 0 TO WS-GL4
      MOVE LOW-VALUES TO GTC-RECORD MOVE WS-GL TO GTC-GL MOVE NF-TI(4) TO GTC-AMT
      WRITE GTC-RECORD ALLOWING NO UNLOCK GLTOOLCOST.
    MOVE LOW-VALUES TO NF-TTOTALS.
NF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NF-PAGE.
NF-PAGE. MOVE "TOOL COSTING REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    IF NF-KL=1 MOVE "TOOL LIFE BREAKDOWN: UNDER 100M / 100M+ UNDER 1000M / 1000M+" TO PREC
      MOVE 1 TO WS-PR PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "DEP/SEC  MAC  PRODUCT       DESCRIPTION                             QTY        COST       COST/M    ISSUE COST" TO PREC PERFORM PR-LINE-3.
*          .. ..   ..   ............  ................................  ...,...,...  ...,...:.. ...,...:...   ...,...:.. ...

* Z-17-10 TOOL LIFE REPORT AND UPDATE
NC1. PERFORM RD294 PERFORM WRT IF S-BAT MOVE S-S1 TO NC-KUP GO NC2.
    ACCEPT XA3 LINE 5 COLUMN 36 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO NC-KUP ELSE MOVE 0 TO NC-KUP.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE NC-KUP TO S-S1 GO MX9.
NC2. PERFORM DSP-WAIT.
    IF NC-KUP=1 MOVE SYS-DATE TO D-DATE PERFORM D-NM PERFORM UPDATE-TOOL-LIFE.
    PERFORM OPEN-PR PERFORM NC-PAGE.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO NC9.
NC3. READ PART NEXT REGARDLESS END GO NC9. IF PH-ALIFE=0 GO NC3.
    MOVE PH-NO TO FA688 PERFORM DRAW-EXP-PH MOVE A-A1 TO FA689.
    MOVE PH-DESC1 TO FA690 MOVE PH-LIFE TO FA691 MOVE PH-ALIFE TO FA692.
    PERFORM NC-LINE GO NC3.
NC9. PERFORM CLOSE-PR GO MX9.

NC-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NC-PAGE.
NC-PAGE. MOVE "TOOL LIFE REPORT" TO FF3.
    MOVE "(TOOLS THAT HAVE AN 'ACTUAL' LIFE)" TO FF4 PERFORM PR-PAGE.
    MOVE "PART NO.      DRAWING         DESCRIPTION                        EXPECTED LIFE      ACTUAL LIFE" TO PREC PERFORM PR-LINE-3.
*         ............  ..............  ................................     ...,...            ...,...

* Z-17-11 TOOL USAGE EXCEPTION REPORT
NI1. PERFORM RD399 PERFORM WRT IF S-BAT GO NI2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
NI2. PERFORM DSP-WAIT PERFORM OPEN-SORT.
    MOVE " " TO PT-KEY START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO NI24.
NI23. READ PARTRANS NEXT REGARDLESS END GO NI24.
    IF NOT(PT-TRANS="ISS" OR "OUT") GO NI23.
    MOVE PT-PART TO PH-NO READ PART REGARDLESS INVALID GO NI23.
    PERFORM PART-TYPE IF NOT PART-TOOL GO NI23. PERFORM CHK-TLIFE.
    IF A-N1=3 OR NOT(PH-CAT>=226 AND<=229 OR>=236 AND<=241 OR=244) GO NI23.
    MOVE PT-MO TO SR-F95 MOVE PT-PART TO SR-F95A MOVE PT-QTY TO SR-F96.
    WRITE SR-RECORD INVALID READ SORTFL ADD PT-QTY TO SR-F96 REWRITE SR-RECORD.
    GO NI23.
NI24. PERFORM OPEN-PR PERFORM NI-PAGE MOVE 0 TO OLD-N.

    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO NI9.
NI3. READ SORTFL NEXT END GO NI9. IF SR-F96<2 GO NI3.
    MOVE SR-F95 TO R-NO IF R-NO=OLD-N GO NI4.
    READ PRODORD REGARDLESS INVALID GO NI3. INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO NI34.
NI33. READ WORKSHEET NEXT REGARDLESS END GO NI34. IF J-NO NOT=R-NO GO NI34.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO NI33. GO NI36.
NI34. GO NI3.
NI36. MOVE R-PROD TO A-A1 PERFORM PROD-RD.
    MOVE R-NO TO FF575 MOVE J-MAC TO FF576 MOVE P-NO TO FF577.
    MOVE PRO-DESC(1) TO FF578 MOVE R-QTY-PROD TO FF579.
    MOVE 2 TO WS-PR PERFORM NI-LINE MOVE R-NO TO OLD-N.
NI4. MOVE SR-F95A TO FF582 A-A1 PERFORM RD-PART PERFORM DRAW-EXP-PH.
    MOVE A-A1 TO FF583 MOVE PH-DESC1 TO FF584 MOVE SR-F96 TO FF585.
    COMPUTE WN1 ROUNDED=R-QTY-PROD / SR-F96 / 1000 MOVE WN1 TO FF586.
    MOVE PH-LIFE TO FF587 COMPUTE WN2 ROUNDED=100 * (WN1 - PH-LIFE) / PH-LIFE SIZE ERROR MOVE 9999 TO WN2.
    MOVE WN2 TO FF588 IF WN2<=-20 OR>=20 PERFORM NI-LINE ELSE MOVE " " TO PREC.
* note 263
    GO NI3.
NI9. PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

NI-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM NI-PAGE.
NI-PAGE. MOVE "TOOL USAGE EXCEPTION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "  M.O.  MAC  PRODUCT       DESCRIPTION                       QTY PRODUCED" TO PREC PERFORM PR-LINE.
    MOVE "             TOOL          DRAWING         DESCRIPTION                       USED  CALC LIFE  CURRENT LIFE  DIFF %" TO PREC PERFORM PR-LINE-3.
*         ......  ..   ............  ................................  ...,...,...-
*                      ............  ..............  ................................  ...    ...,...     ...,...      ...-

* Z-17-12 TOOL LIST VALIDATION REPORT
TV1. PERFORM RD315 PERFORM WRT IF S-BAT GO TV2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
TV2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TV29.
TV23. READ TOOLS NEXT REGARDLESS END GO TV29. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
TV25. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO TV28.
    MOVE TS-TOOL(TL-FLD) TO PH-NO READ PART REGARDLESS INVALID GO TV26. GO TV28.
TV26. PERFORM INIT-RP MOVE " " TO RP-F137 RP-F142.
    MOVE PH-NO TO RP-F138 MOVE TL-IXF TO RP-F139.
    MOVE TS-PROD TO RP-F140 MOVE TS-MAC TO RP-F141.
    MOVE 0 TO IX1 INSPECT PH-NO TALLYING IX1 FOR CHARACTERS BEFORE "-".
    IF IX1>11 GO TV268. MOVE " " TO PH-NO(IX1 + 1:) MOVE PH-NO TO TV-PART.
    START PART KEY>=PH-KEY REGARDLESS INVALID GO TV268. READ PART NEXT REGARDLESS.
    IF PH-NO(1:IX1) NOT=TV-PART GO TV268. MOVE PH-NO TO RP-F142.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO RP-F137.
TV268. WRITE RP-RECORD.
TV28. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TV25. GO TV23.
TV29. PERFORM OPEN-PR PERFORM TV-PAGE MOVE ALL "-" TO TV-ODRAW.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO TV9.
TV3. READ REPFL NEXT END GO TV9.
    IF RP-F137 NOT=TV-ODRAW PERFORM TV-LINE MOVE RP-F137 TO FA281 TV-ODRAW.
    MOVE RP-F138 TO FA282 MOVE RP-F142 TO FA283.
    MOVE RP-F140 TO TS-PROD FA284 MOVE RP-F141 TO TS-MAC FA285 PERFORM TL-SET-TYPE.
    MOVE RP-F139 TO TL-IXF PERFORM TL-SET-TBL MOVE TL-DESC TO FA286.
    PERFORM TV-LINE GO TV3.
TV9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

TV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM TV-PAGE.
TV-PAGE. MOVE "TOOL LIST VALIDATION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "DRAWING         TOOL NOT FOUND    TOOL FOUND      TOOL LIST: PRODUCT    MACHINE   USAGE" TO PREC PERFORM PR-LINE-3.
*         ..............  ............      ............               ............  ..     ....................

* Z-17-13 TOOL BIN VALIDATION REPORT
BV1. PERFORM RD316 PERFORM WRT IF S-BAT GO BV2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
BV2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE "T" TO BH-NO START PURBIN KEY>=BH-KEY REGARDLESS INVALID GO BV29.
BV23. READ PURBIN NEXT REGARDLESS END GO BV29. IF BH-NO(1:1)>"T" GO BV29.
    IF BH-PART=" " GO BV23.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID GO BV26. GO BV23.
BV26. PERFORM INIT-RP MOVE " " TO RP-F145 RP-F147.
    MOVE PH-NO TO RP-F146 MOVE BH-NO TO RP-F148 MOVE BH-QTY TO RP-F149.
    MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO RP-F150.
    MOVE 0 TO IX1 INSPECT PH-NO TALLYING IX1 FOR CHARACTERS BEFORE "-".
    IF IX1>11 GO BV28. MOVE " " TO PH-NO(IX1 + 1:) MOVE PH-NO TO BV-PART.
    START PART KEY>=PH-KEY REGARDLESS INVALID GO BV28. READ PART NEXT REGARDLESS.
    IF PH-NO(1:IX1) NOT=BV-PART GO BV28. MOVE PH-NO TO RP-F147.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO RP-F145.
BV28. WRITE RP-RECORD GO BV23.
BV29. PERFORM OPEN-PR PERFORM BV-PAGE MOVE ALL "-" TO BV-ODRAW.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO BV9.
BV3. READ REPFL NEXT END GO BV9.
    IF RP-F145 NOT=BV-ODRAW PERFORM BV-LINE MOVE RP-F145 TO FA87 BV-ODRAW.
    MOVE RP-F146 TO FA88 MOVE RP-F147 TO FA89.
    MOVE RP-F148 TO FA90 MOVE RP-F149 TO FA91 MOVE RP-F150 TO FA92.
    PERFORM BV-LINE GO BV3.
BV9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

BV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BV-PAGE.
BV-PAGE. MOVE "TOOL BIN VALIDATION REPORT" TO FF3.
    MOVE "(INVALID TOOLS IN BINS T--)" TO FF4 PERFORM PR-PAGE.
    MOVE "DRAWING         TOOL NOT FOUND    TOOL FOUND      BIN      QTY     DATE" TO PREC PERFORM PR-LINE-3.
*         ..............  ............      ............    ......  ....-  ../../..

* Z-17-14 PRINT TOOL LIST FORMS
TC1. PERFORM RD171 PERFORM WRT.
    IF S-BAT MOVE S-N1 TO TC-OP MOVE S-N2 TO TC-NF MOVE S-A1 TO TC-PROD
      MOVE S-N3 TO TC-MAC GO TC2.
TC13. ACCEPT TC-OP LINE 3 COLUMN 23 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF NOT(TC-OP>=1 AND<=18) GO TC13.
    MOVE 19 TO IXT DISPLAY " " LINE IXT ERASE LINE.
    IF TC-OP=1 GO TC14. IF TC-OP=2 GO TC16. IF TC-OP=3 GO TC18.
* op=4-18
    DISPLAY "NUMBER OF FORMS TO PRINT: ___" LINE IXT BOLD.
    ACCEPT TC-NF LINE IXT COLUMN 27 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    GO TC18.
TC14. DISPLAY "PRODUCT: ____________       MACHINE: __ " LINE IXT BOLD.
    ACCEPT TC-PROD LINE IXT COLUMN 10 DEFAULT " " UNDERLINED PROTECTED EDITING.
    ACCEPT TC-MAC LINE IXT COLUMN 38 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE TC-PROD TO TS-PROD MOVE TC-MAC TO TS-MAC.
    READ TOOLS REGARDLESS INVALID PERFORM DSP-ERR26 GO TC13.
    GO TC18.
TC16. DISPLAY "MACHINE: __ " LINE IXT BOLD.
    ACCEPT TC-MAC LINE IXT COLUMN 10 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    GO TC18.
TC18. MOVE 21 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE TC-OP TO S-N1 MOVE TC-NF TO S-N2 MOVE TC-PROD TO S-A1
      MOVE TC-MAC TO S-N3 GO MX9.
TC2. PERFORM DSP-WAIT.
    IF TC-OP=1 GO TC40. IF TC-OP=2 GO TC50. IF TC-OP=3 GO TC22. GO TC60.

TC22. PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO TC29.
TC23. READ PRODORD NEXT REGARDLESS END GO TC29.
    IF R-FIN=1 OR R-QTY-ORD<=R-QTY-PROD GO TC23.
    MOVE R-DATE TO D-DATE PERFORM D-CURR IF D-N1>0 GO TC23.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO TC23. PERFORM RD-GEN.
    IF P-MAC=0 GO TC23.
    PERFORM GET-TS IF A-S1=1 WRITE TS-RECORD ALLOWING NO UNLOCK TOOLS.
    IF TS-IND=0 PERFORM INIT-RP MOVE TS-MAC TO RP-F135 MOVE TS-PROD TO RP-F136
      WRITE RP-RECORD INVALID CONTINUE.
    GO TC23.
TC29. PERFORM OPEN-PR.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO TC39.
TC3. READ REPFL NEXT END GO TC39. MOVE RP-F136 TO TS-PROD MOVE RP-F135 TO TS-MAC.
    READ TOOLS REGARDLESS PERFORM TC-FORM.
    MOVE 1 TO TS-IND REWRITE TS-RECORD ALLOWING NO UNLOCK TOOLS GO TC3.
TC39. PERFORM CLOSE-REP PERFORM CLOSE-PR GO TC9.

TC40. PERFORM OPEN-PR.
    MOVE TC-PROD TO TS-PROD MOVE TC-MAC TO TS-MAC READ TOOLS REGARDLESS INVALID GO TC49.
    PERFORM TC-FORM.
TC49. PERFORM CLOSE-PR GO TC9.

TC50. PERFORM OPEN-PR.
    MOVE " " TO TS-KEY START TOOLS KEY>TS-KEY REGARDLESS INVALID GO TC59.
TC53. READ TOOLS NEXT REGARDLESS END GO TC59. IF TS-MAC NOT=TC-MAC GO TC53.
    PERFORM TC-FORM GO TC53.
TC59. PERFORM CLOSE-PR GO TC9.

TC60. PERFORM OPEN-PR IF TC-NF=0 GO TC69.
    EVALUATE TRUE
      WHEN TC-OP=5 MOVE 1 TO TL-TYPE
      WHEN TC-OP=6 MOVE 2 TO TL-TYPE
      WHEN TC-OP=7 MOVE 3 TO TL-TYPE
      WHEN TC-OP=8 MOVE 4 TO TL-TYPE
      WHEN TC-OP=9 MOVE 16 TO TL-TYPE
      WHEN TC-OP=10 MOVE 5 TO TL-TYPE
      WHEN TC-OP>=11 AND<=15 MOVE TC-OP TO TL-TYPE
      WHEN TC-OP=16 MOVE 8 TO TL-TYPE
      WHEN TC-OP=17 MOVE 9 TO TL-TYPE
      WHEN TC-OP=18 MOVE 10 TO TL-TYPE
      WHEN OTHER MOVE 0 TO TL-TYPE.
    PERFORM TL-SET-SCRN.
    PERFORM TC-NF TIMES
      PERFORM VARYING TL-SCRN FROM 1 BY 1 UNTIL TL-SCRN>TL-NS
        PERFORM TC-DISP PERFORM TC-HEAD
        PERFORM TC-P VARYING IXT FROM TL-R1 BY 1 UNTIL IXT>TL-R2 END-PERFORM END-PERFORM.
TC69. PERFORM CLOSE-PR GO TC9.

TC9. GO MX9.

TC-HEAD. WRITE PREC AFTER PAGE.
    MOVE "MACHINE: __       PRODUCT: ____________" TO FA251.
    EVALUATE TRUE
      WHEN TL-TYPE=0 MOVE "0" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=1 MOVE "7" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=2 MOVE "8" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=3 MOVE "9 - MAC. 17,20" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=4 MOVE "9 - MAC. 18,19" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=5 MOVE "11" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=8 MOVE "NUT TOOL LIST (MACHINE TYPE 18)" TO FA252
      WHEN TL-TYPE=9 MOVE "BOLT TOOL LIST (MACHINE 54)" TO FA252
      WHEN TL-TYPE=10 MOVE "PURCHASED PART TOOL LIST (MACHINE 99)" TO FA252
      WHEN TL-TYPE=11 MOVE "12 - MAC. 24" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=12 MOVE "12 - MAC. 36,38" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=13 MOVE "12 - MAC. 32,33,34" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=14 MOVE "12 - MAC. 37" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=15 MOVE "12 - MAC. 39" TO WA1 PERFORM TC-H
      WHEN TL-TYPE=16 MOVE "10" TO WA1 PERFORM TC-H
      WHEN OTHER CONTINUE.
    PERFORM TC-PGNO MOVE A-A1 TO FA253 PERFORM PR-LINE-4.
TC-H. MOVE " " TO WA2.
    STRING "BOLT TOOL LIST (MACHINE TYPE " DELIMITED SIZE
      WA1 DELIMITED "  " ")" DELIMITED SIZE INTO WA2 MOVE WA2 TO FA252.
TC-DISP. PERFORM TL-RD-SCRN PERFORM TL-REP-SCRN.
TC-P. MOVE TLNW(IXT) TO PREC MOVE 2 TO WS-PR PERFORM PR-LINE.
TC-Q. MOVE TLNW(IXT) TO PREC MOVE 0 TO WS-PR PERFORM PR-LINE.
TC-PGNO. MOVE " " TO A-A1 MOVE TL-SCRN TO DSP-N11 MOVE TL-NS TO DSP-N12.
    STRING "PAGE " DSP-N11 " OF " DSP-N12 DELIMITED SIZE INTO A-A1.
TC-FORM. PERFORM TL-SET-TYPE.
    PERFORM VARYING TL-SCRN FROM 1 BY 1 UNTIL TL-SCRN>TL-NS PERFORM TC-F END-PERFORM.
TC-F. PERFORM TC-F1 THRU TC-F9.
TC-F1. WRITE PREC AFTER PAGE.
    MOVE "MACHINE:" TO FA231 MOVE TS-MAC TO FA232 A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FA233.
    MOVE "PRODUCT:" TO FA234 MOVE TS-PROD TO FA235 A-A1 PERFORM PROD-RGD.
    PERFORM TC-PGNO MOVE A-A1 TO FA236 PERFORM PR-LINE.
* note 115
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5
      MOVE PRO-DESC(IX1) TO FA235 PERFORM PR-LINE END-PERFORM.
    PERFORM PR-LINE-3 PERFORM TC-DISP MOVE TL-R1 TO IXT MOVE 1 TO TL-IXF.
TC-F3. PERFORM TC-P.
TC-F33. PERFORM TL-SET-TBL IF TL-PAGE NOT=TL-SCRN GO TC-F34.
    IF TL-ROW>IXT GO TC-F36. MOVE TS-TOOL(TL-FLD) TO TLNW(IXT)(TL-COL:12).
TC-F34. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO TC-F33.
TC-F36. PERFORM TC-Q ADD 1 TO IXT IF IXT<=TL-R2 GO TC-F3.
TC-F9. EXIT.

* Z-17-15 TOOL USAGE HISTORY REPORT
FU1. PERFORM RD400 PERFORM WRT IF S-BAT GO FU2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
FU2. PERFORM DSP-WAIT.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE 1 TO D-MM D-DD.
    PERFORM D-MN MOVE D-DATE TO FU-CURDT.
    SUBTRACT 1 FROM D-YY PERFORM D-MN MOVE D-DATE TO FU-LASDT.

    PERFORM OPEN-SORT PERFORM OPEN-SORC.
    INITIALIZE J-KM START WORKSHEET KEY>J-KM REGARDLESS INVALID GO FU24.
FU23. READ WORKSHEET NEXT REGARDLESS END GO FU24. IF J-MAC>88 GO FU24.
    IF J-DATE<FU-LASDT GO FU23.
    PERFORM INIT-SR MOVE J-PROD TO SR-F103 MOVE J-MAC TO SR-F104 PERFORM FU-AT.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM FU-AT REWRITE SR-RECORD.
    GO FU23.
FU24.

    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO FU4.
FU3. READ SORTFL NEXT END GO FU4.
    MOVE SR-F103 TO TS-PROD MOVE SR-F104 TO TS-MAC.
    READ TOOLS REGARDLESS INVALID GO FU38. PERFORM TL-SET-TYPE MOVE 1 TO TL-IXF.
FU35. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO FU36.
    IF TL-PAGE=0 OR (TL-CAT=1 OR 2 OR 3) GO FU36.
    PERFORM INIT-SC MOVE TS-TOOL(TL-FLD) TO SC-F13 MOVE SR-F103 TO SC-F14.
    PERFORM FU-AK.
    WRITE SC-RECORD INVALID READ SORCFL PERFORM FU-AK REWRITE SC-RECORD.
FU36. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO FU35.
FU38. GO FU3.
FU4.

    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE FU-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE " " TO SC-KEY START SORCFL KEY>SC-KEY INVALID GO FU6.
FU5. READ SORCFL NEXT END GO FU6.
    MOVE SC-F13 TO A-A1 EXP-A PERFORM RD-PART PERFORM EXPF.
    MOVE PH-LIFE TO EXP-N PERFORM EXPF MOVE PH-ALIFE TO EXP-N PERFORM EXPF.
    MOVE SC-F14 TO EXP-A PERFORM EXPF.
    PERFORM CHK-ROLL IF A-S1=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1.
    COMPUTE EXP-N ROUNDED=SC-F16(IX1) / 1000 PERFORM EXPF.
    COMPUTE EXP-N ROUNDED=SC-F17(IX1) / 1000 PERFORM EXPF.
    PERFORM EXP-LINE GO FU5.
FU6. PERFORM CLOSE-SORT PERFORM CLOSE-SORC PERFORM CLOSE-EXP.
FU9. GO MX9.

FU-AT. MOVE J-AWEIGHT TO A-N1 IF A-N1=0 MOVE J-WEIGHT TO A-N1.
    IF J-DATE<FU-CURDT ADD J-QTY TO SR-F105(1) ADD A-N1 TO SR-F105(2)
      ELSE ADD J-QTY TO SR-F106(1) ADD A-N1 TO SR-F106(2).
FU-AK. PERFORM FU-AK1 THRU FU-AK9.
FU-AK1. PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>4 OR SC-F15(A-X1)=0
      IF TS-MAC=SC-F15(A-X1) GO FU-AK9 END-IF END-PERFORM.
    IF A-X1<=4 MOVE TS-MAC TO SC-F15(A-X1)
      PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>2
        ADD SR-F105(A-X1) TO SC-F16(A-X1) ADD SR-F106(A-X1) TO SC-F17(A-X1) END-PERFORM.
* note 280
FU-AK9. EXIT.

* Z-18: MACHINE AND WORKSHEET FUNCTIONS

* Z-18-1 MAINTENANCE DOWNTIME REPORT
EA1. PERFORM RD365 PERFORM WRT IF S-BAT GO EA2.
    MOVE 3 TO IXT MOVE 13 TO IXU PERFORM AX-DT-VAL.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EA2. PERFORM DSP-WAIT.
    PERFORM VARYING EA-DAY FROM 1 BY 1 UNTIL EA-DAY>7
      COMPUTE EA-DATE(EA-DAY)=DATE0 + EA-DAY - 1 END-PERFORM.
    MOVE EA-DATE(1) TO DATE1 MOVE EA-DATE(7) TO DATE2.
    PERFORM OPEN-REP INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO EA29.
EA23. READ WORKSHEET NEXT REGARDLESS END GO EA29. IF J-DATE>DATE2 GO EA29.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF NOT(PROC-PRIMARY AND J-SHIFT>0) GO EA23. PERFORM INIT-RP.
    MOVE J-MAC TO RP-F61 MOVE J-SHIFT TO RP-F62 MOVE J-EMP TO RP-F62A.
    MOVE J-DATE TO RP-F63 MOVE J-NO TO RP-F64 WRITE RP-RECORD GO EA23.
EA29. PERFORM OPEN-PR PERFORM EA-PAGE MOVE LOW-VALUES TO EA-MFLD MOVE 0 TO OLD-M.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EA9.
EA3. READ REPFL NEXT END GO EA9. MOVE RP-F64 TO J-NO MOVE RP-F61 TO J-MAC.
    MOVE RP-F63 TO J-DATE MOVE RP-F62 TO J-SHIFT MOVE RP-F62A TO J-EMP.
    READ WORKSHEET REGARDLESS INVALID GO EA3.
    IF J-MAC=OLD-M GO EA4. IF OLD-M NOT=0 PERFORM EA-MTOT. MOVE J-MAC TO OLD-M.
EA4. COMPUTE EA-DAY=J-DATE + 1 - DATE1 IF NOT(EA-DAY>=1 AND<=7) GO EA3.
    ADD J-HOURS TO EA-HOURS(J-SHIFT,EA-DAY).
    ADD J-DHOURS(1) J-DHOURS(2) TO EA-RHOURS(J-SHIFT,EA-DAY) GO EA3.
EA9. PERFORM EA-MTOT.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

EA-MTOT. PERFORM EA-M1 THRU EA-M9.
EA-M1. MOVE OLD-M TO FD20 A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FD21.
    MOVE 1 TO EA-SHIFT.
EA-M3. MOVE LIT-XDAN(EA-SHIFT + 1:1) TO FD22 MOVE 0 TO WD1 WD2 MOVE 1 TO EA-DAY.
EA-M5. MOVE EA-HOURS(EA-SHIFT,EA-DAY) TO FD27(EA-DAY) WD3 ADD WD3 TO WD1.
    SUBTRACT EA-RHOURS(EA-SHIFT,EA-DAY) FROM WD3.
    MOVE WD3 TO FD28(EA-DAY) ADD WD3 TO WD2.
    ADD 1 TO EA-DAY IF EA-DAY<=7 GO EA-M5.
    COMPUTE FD31 ROUNDED=100 * WD2 / WD1 SIZE ERROR CONTINUE.
    IF EA-SHIFT=3 PERFORM EA-LINE ELSE PERFORM PR-LINE.
    ADD 1 TO EA-SHIFT IF EA-SHIFT<=3 GO EA-M3. PERFORM EA-LINE.
    MOVE LOW-VALUES TO EA-MFLD.
EA-M9. EXIT.
EA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EA-PAGE.
EA-PAGE. MOVE "MAINTENANCE DOWNTIME REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE "MACHINE                           SHIFT" TO PREC.
    PERFORM VARYING EA-DAY FROM 1 BY 1 UNTIL EA-DAY>7
      MOVE EA-DATE(EA-DAY) TO D-DATE PERFORM D-NM
      COMPUTE FD25(EA-DAY)=D-MM * 100 + D-DD END-PERFORM.
    PERFORM PR-LINE.
    PERFORM VARYING EA-DAY FROM 1 BY 1 UNTIL EA-DAY>7
      MOVE "  TOT  MNT" TO FD24(EA-DAY) END-PERFORM.
    MOVE "    TOT %" TO FD30 PERFORM PR-LINE-3.
*                                                    ../..       ../..       ../..       ../..       ../..       ../..       ../..
*                                                  TOT  MNT    TOT  MNT    TOT  MNT    TOT  MNT    TOT  MNT    TOT  MNT    TOT  MNT      TOT %
*         ... ..............................  .   ..:.. .:..  ..:.. .:..  ..:.. .:..  ..:.. .:..  ..:.. .:..  ..:.. .:..  ..:.. .:..      ...

* Z-18-2 MACHINE ACTIVITY REPORT
EB1. PERFORM RD84 PERFORM WRT.
    IF S-BAT MOVE S-N1 TO EB-RN MOVE S-S1 TO EB-KSAN GO EB2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 34 TO IXV PERFORM AX-DATE-R.
    MOVE 0 TO EB-RN MOVE 4 TO IXT.
EB13. ADD 1 TO EB-RN IXT.
    ACCEPT MAC1 LINE IXT COLUMN 16 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF MAC1=0 SUBTRACT 1 FROM EB-RN GO EB14.
    ACCEPT MAC2 LINE IXT COLUMN 36 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE MAC1 TO RNUM1(EB-RN) MOVE MAC2 TO RNUM2(EB-RN) IF EB-RN<10 GO EB13.
EB14. MOVE 16 TO IXT MOVE 23 TO IXU PERFORM AX-SUM-S MOVE 1 TO TOT-IND.
    IF SUM-IND=0 MOVE 16 TO IXT MOVE 52 TO IXU PERFORM AX-TOT-S.
    ACCEPT XA3 LINE 18 COLUMN 41 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO EB-KSAN ELSE MOVE 0 TO EB-KSAN.
    MOVE 20 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE EB-RN TO S-N1 MOVE EB-KSAN TO S-S1 GO MX9.
EB2. PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO EB29.
EB23. READ WORKSHEET NEXT REGARDLESS END GO EB29. IF J-DATE>DATE2 GO EB29.
    IF J-MAC NOT=8 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>EB-RN
      IF J-MAC>=RNUM1(IX1) AND<=RNUM2(IX1) GO EB24 END-IF END-PERFORM.
    GO EB23.
EB24. PERFORM INIT-RP MOVE J-MAC TO RP-F65 MOVE J-PROD TO RP-F66.
    MOVE J-NO TO RP-F67 MOVE J-KEY TO RP-F68 WRITE RP-RECORD GO EB23.
EB29. IF EB-KSAN=1 PERFORM OPEN-MAINTA.
    PERFORM OPEN-PR MOVE 1 TO EB-STEP PERFORM EB-PAGE PERFORM OPEN-SORT.
    MOVE LOW-VALUES TO EB-MTOTALS EB-PTOTALS EB-ATOTALS EB-GTOTALS.
    MOVE 0 TO OLD-M OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EB6.
EB3. READ REPFL NEXT END GO EB6. MOVE RP-F68 TO J-KEY.
    READ WORKSHEET REGARDLESS INVALID GO EB3. IF J-MAC=OLD-M GO EB34.
    IF OLD-M NOT=0 IF SUM-IND=0 PERFORM EB-MO PERFORM EB-PROD PERFORM EB-MAC.
    MOVE J-MAC TO OLD-M MOVE " " TO OLD-A MOVE 0 TO OLD-N.
    MOVE J-MAC TO EB-DF1 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX1.
    MOVE J-MAC TO A-N1 PERFORM RD-MAC.
    IF TOT-IND=0 STRING "MACHINE " EB-DF1(EB-NX1:) "  " M-DESC1 DELIMITED SIZE
      INTO PREC PERFORM EB-LINE 2 TIMES.
EB34. IF J-PROD=OLD-A GO EB36. IF OLD-A>" " IF SUM-IND=0 PERFORM EB-MO PERFORM EB-PROD.
    MOVE J-PROD TO OLD-A MOVE 0 TO OLD-N ADD 1 TO EB-AP EB-GP.
    MOVE J-PROD TO A-A1 PERFORM PROD-RT.
EB36. IF J-NO=OLD-N GO EB4. IF OLD-N NOT=0 IF SUM-IND=0 PERFORM EB-MO.
    MOVE J-NO TO OLD-N ADD 1 TO EB-PR EB-AR EB-GR.
EB4. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    ADD J-HOURS TO EB-MH EB-PH EB-AH EB-GH.
    ADD J-DHOURS(3) TO EB-MK EB-PK EB-AK EB-GK.
    ADD J-QTY TO EB-MN(1) EB-PN(1) EB-AN(1) EB-GN(1).
    IF J-AWEIGHT NOT=0 MOVE J-AWEIGHT TO EB-WEIGHT ELSE MOVE J-WEIGHT TO EB-WEIGHT.
    ADD EB-WEIGHT TO EB-MN(2) EB-PN(2) EB-AN(2) EB-GN(2).
    MOVE J-HOURS TO A-D1 PERFORM CALC-TARGET.
    ADD A-N1 TO EB-MN(3) EB-PN(3) EB-AN(3) EB-GN(3).
    MOVE P-CAT TO SR-F42 MOVE J-QTY TO SR-F43 MOVE EB-WEIGHT TO SR-F44.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD J-QTY TO SR-F43 ADD EB-WEIGHT TO SR-F44 REWRITE SR-RECORD.
    IF EB-KSAN=1
      IF PROC-PRIMARY MOVE P-CAT TO MFA-F33 MOVE EB-WEIGHT TO MFA-F34(1) WRITE MFA-RECORD.
    GO EB3.
EB6. IF SUM-IND=0 PERFORM EB-MO PERFORM EB-PROD PERFORM EB-MAC MOVE 3 TO WS-PR.
    MOVE EB-GR TO EB-DF2 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX2.
    MOVE EB-GP TO EB-DF3 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX3.
    IF EB-GR=1 MOVE "," TO WA1 ELSE MOVE "S," TO WA1.
    IF EB-GP=1 MOVE ")" TO WA2 ELSE MOVE "S)" TO WA2.
    STRING "*** GRAND TOTALS  (" EB-DF2(EB-NX2:) " ORDER" DELIMITED SIZE
      WA1 DELIMITED " " " " EB-DF3(EB-NX3:) " PRODUCT" DELIMITED SIZE WA2 DELIMITED " " INTO PREC.
    MOVE EB-GH TO EB-XH MOVE EB-GK TO EB-XK.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE EB-GN(IX1) TO EB-XN(IX1) END-PERFORM.
    MOVE 0 TO OLD-M PERFORM EB-P PERFORM PR-LINE.

    MOVE 2 TO EB-STEP PERFORM EB-PAGE.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO EB64.
EB63. READ SORTFL NEXT END GO EB64. MOVE SR-F42 TO FG208.
    MOVE SR-F43 TO FG209 MOVE SR-F44 TO FG210 PERFORM EB-LINE GO EB63.
EB64. PERFORM CLOSE-SORT.

    MOVE 3 TO EB-STEP PERFORM EB-PAGE PERFORM OPEN-SORT MOVE 0 TO OLD-M.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EB8.
EB7. READ REPFL NEXT END GO EB8. MOVE RP-F68 TO J-KEY.
    READ WORKSHEET REGARDLESS INVALID GO EB7.
    IF J-MAC NOT=OLD-M MOVE J-MAC TO OLD-M A-N1 PERFORM RD-MAC.
    MOVE J-AWEIGHT TO EB-WEIGHT IF EB-WEIGHT=0 MOVE J-WEIGHT TO EB-WEIGHT.
    IF ITOOL MOVE 0 TO EB-COST
      ELSE MOVE J-PROD TO A-A1 PERFORM PROD-GEN PERFORM COST-PROCESS
        COMPUTE EB-COST ROUNDED=CST-WAMT * J-QTY / 1000.
    PERFORM INIT-SR MOVE M-GROUP TO SR-F113 MOVE M-SECT TO SR-F114.
    MOVE M-NO TO SR-F115 MOVE M-OPDESC TO SR-F120 PERFORM EB-AT.
    WRITE SR-RECORD INVALID READ SORTFL PERFORM EB-AT REWRITE SR-RECORD.
    GO EB7.

EB8. PERFORM EB-LINE 3 TIMES.
    MOVE LOW-VALUES TO EB-DTOTALS EB-STOTALS MOVE -1 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO EB88.
EB83. READ SORTFL NEXT END GO EB88. COMPUTE WN1=SR-F113 * 100 + SR-F114.
    IF WN1=OLD-N GO EB84. IF OLD-N NOT=-1 PERFORM EB-D.
    MOVE SR-F113 TO FF516 MOVE SR-F114 TO FF517 MOVE WN1 TO OLD-N.
EB84. MOVE SR-F115 TO FF518 MOVE SR-F120 TO FF519.
    MOVE SR-F116 TO FF520 MOVE SR-F117 TO FF521 COMPUTE FF522 ROUNDED=SR-F117 / 2000.
    MOVE SR-F118 TO FF523 MOVE SR-F119 TO FF524 PERFORM EB-LINE.
    ADD SR-F116 TO EB-DQ EB-SQ ADD SR-F117 TO EB-DW EB-SW.
    ADD SR-F118 TO EB-DH EB-SH ADD SR-F119 TO EB-DC EB-SC GO EB83.
EB88. PERFORM EB-D MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    MOVE EB-SQ TO FF520 MOVE EB-SW TO FF521 COMPUTE FF522 ROUNDED=EB-SW / 2000.
    MOVE EB-SH TO FF523 MOVE EB-SC TO FF524 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT.

    IF EB-KSAN=1 CLOSE MAINTA
      MOVE 4 TO EB-STEP PERFORM EB-PAGE MOVE 3 TO CTA-OP PERFORM CTA-ANALYSIS.
    PERFORM CLOSE-PR.
EB9. GO MX9.

EB-AT. ADD J-QTY TO SR-F116 ADD EB-WEIGHT TO SR-F117 ADD J-HOURS TO SR-F118.
    ADD EB-COST TO SR-F119.
EB-MO. MOVE OLD-N TO FD33 A-N1 PERFORM RD-PRODORD MOVE "(" TO FD33A MOVE ")" TO FD33C.
    MOVE R-FIN TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO FD33B MOVE OLD-A TO FD34.
    MOVE EB-MH TO EB-XH MOVE EB-MK TO EB-XK.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE EB-MN(IX1) TO EB-XN(IX1) END-PERFORM.
    PERFORM EB-P IF TOT-IND=0 PERFORM EB-LINE ELSE MOVE " " TO PREC.
    MOVE LOW-VALUES TO EB-MTOTALS.
EB-PROD. IF TOT-IND=0 MOVE 2 TO WS-PR.
    MOVE EB-PR TO EB-DF2 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX2.
    IF EB-PR=1 MOVE ")" TO WA1 ELSE MOVE "S)" TO WA1.
    STRING "** TOTAL PRODUCT " DELIMITED SIZE OLD-A DELIMITED " "
      " (" EB-DF2(EB-NX2:) " ORDER" DELIMITED SIZE WA1 DELIMITED " " INTO PREC.
    MOVE EB-PH TO EB-XH MOVE EB-PK TO EB-XK.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE EB-PN(IX1) TO EB-XN(IX1) END-PERFORM.
    PERFORM EB-P PERFORM EB-LINE IF TOT-IND=0 PERFORM EB-LINE 2 TIMES.
    MOVE LOW-VALUES TO EB-PTOTALS.
EB-MAC. MOVE 3 TO WS-PR.
    MOVE OLD-M TO EB-DF1 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX1.
    MOVE EB-AR TO EB-DF2 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX2.
    MOVE EB-AP TO EB-DF3 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO EB-NX3.
    IF EB-AR=1 MOVE "," TO WA1 ELSE MOVE "S," TO WA1.
    IF EB-AP=1 MOVE ")" TO WA2 ELSE MOVE "S)" TO WA2.
    STRING "*** TOTAL MACHINE " EB-DF1(EB-NX1:) " (" EB-DF2(EB-NX2:) " ORDER" DELIMITED SIZE
      WA1 DELIMITED " " " " EB-DF3(EB-NX3:) " PRODUCT" DELIMITED SIZE WA2 DELIMITED " " INTO PREC.
    MOVE EB-AH TO EB-XH MOVE EB-AK TO EB-XK.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE EB-AN(IX1) TO EB-XN(IX1) END-PERFORM.
    PERFORM EB-P PERFORM PR-LINE IF TOT-IND=0 PERFORM EB-PAGE ELSE PERFORM EB-LINE 2 TIMES.
    MOVE LOW-VALUES TO EB-ATOTALS.
EB-P. MOVE EB-XH TO FD35 MOVE EB-XK TO FD36.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE EB-XN(IX1) TO FD37(IX1) END-PERFORM.
* note 23.1
    MOVE OLD-M TO A-N1 PERFORM PROC-TYPE.
    IF PROC-HEAT MOVE EB-XN(2) TO WN1 ELSE MOVE EB-XN(1) TO WN1.
    COMPUTE FD38 ROUNDED=100 * WN1 / EB-XN(3) SIZE ERROR CONTINUE.
EB-D. MOVE 2 TO WS-PR MOVE "         ** TOTALS" TO PREC.
    MOVE EB-DQ TO FF520 MOVE EB-DW TO FF521 COMPUTE FF522 ROUNDED=EB-DW / 2000.
    MOVE EB-DH TO FF523 MOVE EB-DC TO FF524 PERFORM EB-LINE 2 TIMES.
    MOVE LOW-VALUES TO EB-DTOTALS.
EB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EB-PAGE.
EB-PAGE. MOVE "MACHINE ACTIVITY REPORT" TO FF3.
    IF EB-STEP=2 MOVE "** CATEGORY SUMMARY **" TO FF4.
    IF EB-STEP=3 MOVE "** DEPARTMENT/SECTOR SUMMARY **" TO FF4. PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    IF EB-STEP=1 MOVE
         "  M.O.     PRODUCT                                         HOURS    SETUP      PIECES       WEIGHT       TARGET    % OF TARGET" TO PREC PERFORM PR-LINE
      MOVE
         "                                                                    HOURS     PRODUCED     PRODUCED                  ACHIEVED" TO PREC PERFORM PR-LINE-3.
*         ......(.)  ............                                 ..,...:.. .,...:..  ..,...,...-  ..,...,...-  ..,...,...-      ...-
    IF EB-STEP=2 MOVE
         "CAT        QTY         WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ..  ...,...,...-  ...,...,...-
    IF EB-STEP=3 MOVE
         "DEP/SEC  PROCESS                QTY         WEIGHT    TONS      HOURS          COST" TO PREC PERFORM PR-LINE-3.
*          .. ..   ... ..........  ...,...,...-  ...,...,...- ..,...- ...,...:..- ..,...,...:..-
    IF EB-STEP=4 PERFORM PR-LINE.

* Z-18-3 MACHINE UTILIZATION REPORT
EC1. PERFORM RD359 PERFORM WRT IF S-BAT GO EC2.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-MAC-R.
    MOVE 4 TO IXT MOVE 17 TO IXU MOVE 40 TO IXV PERFORM AX-CAT-R.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EC2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO EC29.
EC23. READ PRODUCT NEXT REGARDLESS END GO EC29.
    IF NOT((P-CAT>=CAT1 AND<=CAT2) AND (P-MAC>=MAC1 AND<=MAC2)) GO EC23.
    PERFORM INIT-RP MOVE P-MAC TO RP-F29 MOVE P-CAT TO RP-F30 MOVE P-NO TO RP-F31.
    WRITE RP-RECORD GO EC23.
EC29. PERFORM OPEN-PR MOVE 0 TO OLD-M PERFORM EC-PAGE.
    MOVE LOW-VALUES TO EC-STOTALS EC-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EC9.
EC3. READ REPFL NEXT END GO EC9. MOVE RP-F31 TO A-A1 PERFORM PROD-GEN.
    IF P-MAC=OLD-M GO EC4.
    IF OLD-M NOT=0 PERFORM EC-SUB PERFORM EC-TOT MOVE 0 TO OLD-N.
    MOVE P-MAC TO OLD-M PERFORM EC-PAGE.
EC4. IF P-CAT=OLD-N GO EC44. IF OLD-N NOT=0 PERFORM EC-SUB. MOVE P-CAT TO OLD-N.
EC44. MOVE P-CAT TO FD217 MOVE P-NO TO FD217A.
    IF GEN-IND=1 MOVE GEN-ALT TO FD217A MOVE P-NO TO GEN-PN MOVE GEN-MSG TO FD218
      ELSE PERFORM PROD-DESC MOVE PRO-DESC(1) TO FD218
        MOVE P-HAND TO FD219(1) MOVE P-ROP TO FD219(2) MOVE P-YTD TO FD219(3)
        MOVE P-LAST TO FD219(4) MOVE P-PREV TO FD219(5)
        ADD P-HAND TO EC-SN(1) EC-GN(1) ADD P-ROP TO EC-SN(2) EC-GN(2)
        ADD P-YTD TO EC-SN(3) EC-GN(3) ADD P-LAST TO EC-SN(4) EC-GN(4)
        ADD P-PREV TO EC-SN(5) EC-GN(5).
    PERFORM EC-LINE GO EC3.
EC9. PERFORM EC-SUB PERFORM EC-TOT.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

EC-SUB. MOVE 3 TO WS-PR MOVE "CATEGORY SUB-TOTALS ***" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 MOVE EC-SN(IX1) TO FD219(IX1) END-PERFORM.
    PERFORM PR-LINE-3 MOVE LOW-VALUES TO EC-STOTALS.
EC-TOT. MOVE 3 TO WS-PR MOVE "MACHINE SUB-TOTALS ***" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 MOVE EC-GN(IX1) TO FD219(IX1) END-PERFORM.
    PERFORM PR-LINE MOVE LOW-VALUES TO EC-GTOTALS.
EC-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EC-PAGE.
EC-PAGE. MOVE "MACHINE UTILIZATION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-MAC MOVE 1 TO WS-PR PERFORM PRANGE-CAT.
    MOVE "MACHINE NO." TO FD214 MOVE OLD-M TO FD215.
    IF OLD-M NOT=0 MOVE OLD-M TO A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FD216.
    MOVE 1 TO WS-PR PERFORM PR-LINE-2.
    MOVE "CAT PRODUCT       DESCRIPTION                           ON HAND       REORDER           YTD       LAST YR      2 YRS AGO" TO PREC PERFORM PR-LINE-3.
*         ..  ............  ................................   ..,...,...-   ..,...,...-   ..,...,...-   ..,...,...-   ..,...,...-

* Z-18-4 MACHINE/PROCESS LISTING
EM1. PERFORM RD47 PERFORM WRT.
    MOVE 3 TO IXT MOVE 18 TO IXU MOVE 43 TO IXV PERFORM AX-MAC-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM EM-PAGE.
    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE EM-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE MAC1 TO M-NO START MACHINE KEY>=M-KEY REGARDLESS INVALID GO EM9.
EM3. READ MACHINE NEXT REGARDLESS END GO EM9. IF M-NO>MAC2 GO EM9.
    MOVE M-NO TO FA510 MOVE M-DESC1 TO FA511 MOVE M-OPDESC TO FA512.
    MOVE M-TQTY TO FA513 MOVE M-HOURS TO FA514 MOVE M-COST TO FA515 MOVE M-CMODE TO FA515A.
    MOVE M-LOT-CHARGE TO FA516 MOVE M-GROUP TO FA517 T-NO MOVE 19 TO T-TBL.
    PERFORM RD-TBL MOVE T-LINE TO FA518 PERFORM PR-LINE.
    MOVE M-DESC2 TO FA511 MOVE M-LDAYS TO FA519 MOVE M-TWEIGHT TO FA520.
    MOVE M-BATCH-CHARGE TO FA516 MOVE M-TYPE TO FA517 A-N1 PERFORM RD-MACTYPE.
    MOVE ME-DESC TO FA518 PERFORM PR-LINE.
    MOVE M-FREIGHT TO FA515 MOVE M-SURCHARGE TO FA516 MOVE M-SECT TO FA517.
    PERFORM EM-LINE.
    MOVE M-NO TO EXP-N PERFORM EXPF MOVE M-DESC1 TO EXP-A PERFORM EXPF.
    MOVE M-DESC2 TO EXP-A PERFORM EXPF MOVE M-OPDESC TO EXP-A PERFORM EXPF.
    MOVE M-TQTY TO EXP-N PERFORM EXPF MOVE M-TWEIGHT TO EXP-D PERFORM EXPF.
    MOVE M-HOURS TO EXP-N PERFORM EXPF MOVE M-COST TO EXP-T PERFORM EXPF.
    MOVE M-CMODE TO EXP-A PERFORM EXPF MOVE M-LDAYS TO EXP-N PERFORM EXPF.
    MOVE M-LOT-CHARGE TO EXP-D PERFORM EXPF MOVE M-BATCH-CHARGE TO EXP-D PERFORM EXPF.
    MOVE M-SURCHARGE TO EXP-D PERFORM EXPF MOVE M-FREIGHT TO EXP-T PERFORM EXPF.
    MOVE M-GROUP TO EXP-N PERFORM EXPF MOVE M-TYPE TO EXP-N PERFORM EXPF.
    MOVE M-SECT TO EXP-N PERFORM EXPF PERFORM EXP-LINE.
    GO EM3.
EM9. PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

EM-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EM-PAGE.
EM-PAGE. MOVE "MACHINE/PROCESS LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-MAC.
    MOVE "MAC/  DESCRIPTION                     OPERATION   TARGET PROD    HOURS   COST    LOT CHG     GROUP" TO PREC PERFORM PR-LINE.
    MOVE "PROC                                  LEAD DAYS   TARGET WEIGHT                  BATCH CHG   TYPE" TO PREC PERFORM PR-LINE.
    MOVE "                                                                       FREIGHT   SURCHG %    SECTOR" TO PREC PERFORM PR-LINE-3.
*         ...   ..............................  ..........  ...,...,...     ..  ....:... .  ...:..     .. ................................
*               ..............................     ...       ...,...:..                     ...:..     .. ................................
*                                                                                 ..:...    ...:..     ..

* Z-18-5 MACHINE TIME ANALYSIS
JR1. PERFORM RD201 PERFORM WRT IF S-BAT GO JR2.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 37 TO IXV PERFORM AX-MAC-R.
    MOVE 4 TO IXT MOVE 13 TO IXU MOVE 34 TO IXV PERFORM AX-ORD-R.
    MOVE 5 TO IXT MOVE 13 TO IXU MOVE 34 TO IXV PERFORM AX-DATE-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
JR2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE ORD1 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO JR29.
JR23. READ PRODORD NEXT REGARDLESS END GO JR29. IF R-NO>ORD2 GO JR29.
    IF R-FIN=0 GO JR23. MOVE R-PROD TO A-A1 PERFORM PROD-RT.
* note 268
    MOVE 0 TO JR-FDATE INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO JR26.
JR25. READ WORKSHEET NEXT REGARDLESS END GO JR26.
    IF J-NO NOT=R-NO OR J-MAC>88 GO JR26. IF NOT(J-MAC>=MAC1 AND<=MAC2) GO JR25.
    MOVE J-DATE TO JR-FDATE GO JR25.
JR26. IF NOT(JR-FDATE>=DATE1 AND<=DATE2) GO JR288.
    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO JR28.
JR27. READ WORKSHEET NEXT REGARDLESS END GO JR28. IF J-NO NOT=R-NO GO JR28.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO JR28.
    IF NOT(J-MAC>=MAC1 AND<=MAC2) GO JR27.
    PERFORM INIT-RP MOVE J-MAC TO RP-F431 MOVE J-NO TO RP-F432.
    MOVE JR-FDATE TO RP-F433 MOVE R-PROD TO RP-F434.
    COMPUTE WN1 ROUNDED=J-QTY * P-WEIGHT / 100 PERFORM JR-AT.
    WRITE RP-RECORD INVALID READ REPFL PERFORM JR-AT REWRITE RP-RECORD.
    GO JR27.
JR28.
JR288. GO JR23.
JR29. PERFORM OPEN-PR PERFORM JR-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE JR-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JR9.
JR3. READ REPFL NEXT END GO JR9.
    MOVE RP-F431 TO FD506 EXP-N PERFORM EXPF MOVE RP-F432 TO FD507 EXP-N PERFORM EXPF.
    MOVE RP-F433 TO D-DATE PERFORM D-NM MOVE D-DT TO FD508 EXP-DT PERFORM EXPF.
    MOVE RP-F434 TO FD509 EXP-A PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 MOVE RP-F437(IX1) TO WD1
      IF WD1>0 MOVE WD1 TO FD510(IX1) ELSE MOVE "-" TO FD510A(IX1) END-IF
      MOVE WD1 TO EXP-D PERFORM EXPF END-PERFORM.
    MOVE RP-F435 TO FD511 EXP-N PERFORM EXPF MOVE RP-F436 TO FD512 EXP-N PERFORM EXPF.
    PERFORM JR-LINE PERFORM EXP-LINE GO JR3.
JR9. PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

JR-AT. ADD J-QTY TO RP-F435 ADD WN1 TO RP-F436.
    PERFORM VARYING A-X1 FROM 1 BY 1 UNTIL A-X1>9
      ADD J-DHOURS(A-X1) TO RP-F437(A-X1) END-PERFORM.
JR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JR-PAGE.
JR-PAGE. MOVE "MACHINE TIME ANALYSIS" TO FF3 PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR PERFORM PRANGE-MAC MOVE 1 TO WS-PR PERFORM PRANGE-MO.
    MOVE "            CLOSE                  1:RUN  2:TRAIN  3:SET   4:DOWN  5:DOWN  6:DOWN   7:RE   8:MAC  9:OPER      PIECES     WEIGHT" TO PREC PERFORM PR-LINE.
    MOVE "MAC  M.O.    DATE    PRODUCT         TIME    RUN     UP      TOOL    MAT     MAINT   WORK    VER    NOT AV   PRODUCED   PRODUCED" TO PREC PERFORM PR-LINE-3.
*         .. ......  ../../..  ............  ...:..  ...:..  ...:..  ...:..  ...:..  ...:..  ...:..  ...:..  ...:..   .,...,...  .,...,...

* Z-18-6 MACHINE UTILIZATION ANALYSIS
EF1. PERFORM RD360 PERFORM WRT IF S-BAT MOVE S-A1 TO EF-PERIOD GO EF2.
    ACCEPT EF-PERIOD LINE 3 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 5 TO IXT MOVE 16 TO IXU MOVE 38 TO IXV PERFORM AX-MAC-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE EF-PERIOD TO S-A1 GO MX9.
EF2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO EF29.
EF23. READ PRODUCT NEXT REGARDLESS END GO EF29.
    IF P-GEN>" " OR NOT(P-MAC>=MAC1 AND<=MAC2) GO EF23.
    PERFORM INIT-RP MOVE P-MAC TO RP-F73 MOVE P-KEY TO RP-F74.
    WRITE RP-RECORD GO EF23.
EF29. PERFORM OPEN-PR.
    MOVE LOW-VALUES TO EF-TOTALS EF-CTOTALS EF-GTOTALS MOVE 0 TO OLD-M.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EF9.
EF3. READ REPFL NEXT END GO EF9. MOVE RP-F74 TO P-KEY.
    READ PRODUCT REGARDLESS INVALID GO EF3. IF P-MAC=OLD-M GO EF4.
    IF OLD-M NOT=0 PERFORM EF-MAC. MOVE P-MAC TO OLD-M EF-MACHINE.
    MOVE " " TO EF-DESC MOVE 0 TO EF-TARGET.
    IF OLD-M NOT=0 MOVE OLD-M TO A-N1 PERFORM RD-MAC
      MOVE M-DESC1 TO EF-DESC COMPUTE EF-TARGET=M-TQTY * 120.
EF4. IF P-CAT=0 OR>60 GO EF8.
    EVALUATE TRUE
      WHEN P-CAT>=1 AND<=11 MOVE P-CAT TO IX1 MOVE 1 TO IX2
      WHEN P-CAT=12 MOVE 12 TO IX1 MOVE 2 TO IX2
      WHEN P-CAT=52 MOVE 13 TO IX1 MOVE 2 TO IX2
      WHEN P-CAT=15 MOVE 14 TO IX1 MOVE 2 TO IX2
      WHEN P-CAT=55 MOVE 15 TO IX1 MOVE 2 TO IX2
      WHEN P-CAT=18 MOVE 16 TO IX1 MOVE 2 TO IX2
      WHEN P-CAT=58 MOVE 17 TO IX1 MOVE 2 TO IX2
      WHEN P-CAT=21 MOVE 18 TO IX1 MOVE 3 TO IX2
      WHEN P-CAT=22 MOVE 19 TO IX1 MOVE 3 TO IX2
      WHEN OTHER MOVE 20 TO IX1 MOVE 4 TO IX2.
    IF IX1=20 MOVE 60 TO EF-CAT(IX1) ELSE MOVE P-CAT TO EF-CAT(IX1).
    IF P-ROP=0 OR 1 ADD 1 TO EF-ZNUM(IX1) EF-CZNUM(IX2) EF-GZNUM
      ELSE ADD 1 TO EF-NUM(IX1) EF-CNUM(IX2) EF-GNUM
        ADD P-ROP TO EF-ROP(IX1) EF-CROP(IX2) EF-GROP.
EF8. GO EF3.
EF9. PERFORM EF-MAC.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

EF-MAC. PERFORM EF-PAGE.
    MOVE 1  TO EF-IX1 MOVE 11 TO EF-IX2 PERFORM EF-C MOVE 1 TO EF-IX3 PERFORM EF-T.
    MOVE 12 TO EF-IX1 MOVE 17 TO EF-IX2 PERFORM EF-C MOVE 2 TO EF-IX3 PERFORM EF-T.
    MOVE 18 TO EF-IX1 MOVE 19 TO EF-IX2 PERFORM EF-C MOVE 3 TO EF-IX3 PERFORM EF-T.
    MOVE 20 TO EF-IX1 MOVE 20 TO EF-IX2 PERFORM EF-C MOVE 4 TO EF-IX3 PERFORM EF-T.
    MOVE 3 TO WS-PR MOVE "GRAND TOTALS:" TO FD63X.
    COMPUTE FD64 ROUNDED=EF-GROP / 1000 MOVE EF-GNUM TO FD65.
    COMPUTE FD66 ROUNDED=EF-GROP / 1000 / EF-GNUM SIZE ERROR CONTINUE.
    MOVE EF-GZNUM TO FD67.
    COMPUTE FD68 ROUNDED=EF-GROP * 100 / EF-TARGET SIZE ERROR CONTINUE.
    PERFORM EF-LINE 2 TIMES MOVE "MONTHLY AVAILABLE MACHINE TIME FOR SPECIALS:" TO FD71.
    COMPUTE WN1 ROUNDED=
      320 * (EF-TARGET - EF-CROP(1) - EF-CROP(2) - EF-CROP(3)) / EF-TARGET SIZE ERROR MOVE 0 TO WN1.
*   320 = 8*2*20 hours/month
    IF WN1<0 MOVE 0 TO WN1. MOVE WN1 TO FD72 MOVE "HOURS" TO FD73.
    PERFORM EF-LINE MOVE LOW-VALUES TO EF-TOTALS EF-CTOTALS EF-GTOTALS.
EF-C. PERFORM EF-C1 THRU EF-C9.
EF-C1.
EF-C3. IF EF-NUM(EF-IX1)=0 AND EF-ZNUM(EF-IX1)=0 GO EF-C4.
    IF EF-IX1=20 MOVE "OTHERS UP TO 60" TO FD63X ELSE MOVE EF-CAT(EF-IX1) TO FD63.
    COMPUTE FD64 ROUNDED=EF-ROP(EF-IX1) / 1000 MOVE EF-NUM(EF-IX1) TO FD65.
    COMPUTE FD66 ROUNDED=EF-ROP(EF-IX1) / 1000 / EF-NUM(EF-IX1) SIZE ERROR CONTINUE.
    MOVE EF-ZNUM(EF-IX1) TO FD67.
    COMPUTE FD68 ROUNDED=EF-ROP(EF-IX1) * 100 / EF-TARGET SIZE ERROR CONTINUE.
    PERFORM EF-LINE.
EF-C4. ADD 1 TO EF-IX1 IF EF-IX1<=EF-IX2 GO EF-C3.
EF-C9. EXIT.
EF-T. MOVE 2 TO WS-PR MOVE "SUB-TOTALS:" TO FD63X.
    COMPUTE FD64 ROUNDED=EF-CROP(EF-IX3) / 1000 MOVE EF-CNUM(EF-IX3) TO FD65.
    COMPUTE FD66 ROUNDED=EF-CROP(EF-IX3) / 1000 / EF-CNUM(EF-IX3) SIZE ERROR CONTINUE.
    MOVE EF-CZNUM(EF-IX3) TO FD67.
    COMPUTE FD68 ROUNDED=EF-CROP(EF-IX3) * 100 / EF-TARGET SIZE ERROR CONTINUE.
    PERFORM EF-LINE 2 TIMES.
EF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EF-PAGE.
EF-PAGE. MOVE "MACHINE UTILIZATION ANALYSIS" TO FF3.
    MOVE EF-PERIOD TO FF4 PERFORM PR-PAGE MOVE 2 TO WS-PR.
    MOVE "MACHINE NO." TO FD56 MOVE EF-MACHINE TO FD57 MOVE EF-DESC TO FD58.
    MOVE "TARGET:" TO FD59 COMPUTE FD60=(EF-TARGET + 999) / 1000.
    MOVE "(M PIECES / 60 DAYS)" TO FD61 PERFORM PR-LINE-2.
    MOVE "CATEGORY        M PIECES   NUMBER OF   AVERAGE    PARTS WITH   % OF 2-SHIFT" TO PREC PERFORM PR-LINE.
    MOVE "                             PARTS      /PART     R.O.P. 0/1     CAPACITY" TO PREC PERFORM PR-LINE-3.
*            ..           ...,...       ...       ...,...       ...           ...

* Z-18-7 OLD INCOMPLETE PRODUCTION ORDERS REPORT
EJ1. PERFORM RD63 PERFORM WRT IF S-BAT GO EJ2.
    ACCEPT XN2 LINE 3 COLUMN 30 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    COMPUTE DATE0=SYS-DATE - XN2.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EJ2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM EJ-PAGE MOVE -1 TO OLD-N.
    INITIALIZE J-KD START WORKSHEET KEY>J-KD REGARDLESS INVALID GO EJ9.
EJ3. READ WORKSHEET NEXT REGARDLESS END GO EJ9. IF J-DATE>=DATE0 GO EJ9.
    IF J-NO=OLD-N GO EJ4. MOVE J-NO TO OLD-N A-N1 PERFORM RD-PRODORD.
    MOVE J-PROD TO A-A1 PERFORM PROD-RD.
EJ4. IF R-FIN=1 GO EJ3. MOVE J-NO TO FF151 MOVE J-MAC TO FF152.
    MOVE J-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF153.
    MOVE LIT-XDAN(J-SHIFT + 1:1) TO FF154.
    MOVE P-NO TO FF155 MOVE PRO-DESC(1) TO FF156 PERFORM EJ-LINE GO EJ3.
EJ9. PERFORM CLOSE-PR GO MX9.

EJ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EJ-PAGE.
EJ-PAGE. MOVE "OLD INCOMPLETE PRODUCTION ORDERS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "WORKSHEETS BEFORE:" TO A-A1 PERFORM PRANGE-DT.
    MOVE " M.O.   MAC    DATE   SH  PRODUCT       DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*         ......  ...  ../../..  .  ............  ................................

* Z-18-8 MACHINE PERFORMANCE ANALYSIS
NM1. PERFORM RD366 PERFORM WRT.
    MOVE 3 TO IXT MOVE 14 TO IXU MOVE 34 TO IXV PERFORM AX-YM-S.
    MOVE D-YY TO NM-YY MOVE D-MM TO NM-MM.
    ACCEPT XA3 LINE 4 COLUMN 25 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO NM-KYTD ELSE MOVE 0 TO NM-KYTD.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT.

    MOVE D-MTHNM(NM-MM)(1:3) TO NM-DTM.
    MOVE NM-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO NM-DTY.
    MOVE " " TO NM-DTL IF NM-KYTD=1 MOVE " YTD" TO NM-DTL.

    MOVE NM-YY TO D-YY MOVE NM-MM TO D-MM MOVE 1 TO D-DD.
    IF NM-KYTD=1 MOVE 1 TO D-MM. PERFORM D-MN MOVE D-DATE TO DATE1.
    MOVE NM-YY TO D-YY MOVE NM-MM TO D-MM MOVE 1 TO D-DD.
    PERFORM D-MN PERFORM D-INCMTH COMPUTE DATE2=D-DATE - 1.
    MOVE NM-YY TO D-YY MOVE NM-MM TO D-MM PERFORM D-PDAYS MOVE D-N1 TO NM-PDAYS.
    MOVE 21 TO NM-GROUP.

    PERFORM OPEN-REP INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO NM29.
NM23. READ WORKSHEET NEXT REGARDLESS END GO NM29. IF J-DATE>DATE2 GO NM29.
    MOVE J-MAC TO A-N1 PERFORM RD-MAC PERFORM PROC-TYPE.
    IF M-GROUP NOT=NM-GROUP GO NM23. MOVE J-PROD TO A-A1 PERFORM PROD-RD.
    PERFORM INIT-RP MOVE M-SECT TO RP-F460 MOVE M-NO TO RP-F461.
    MOVE J-HOURS TO A-D1 PERFORM CALC-TARGET MOVE A-N1 TO WN1 RP-F462.
    MOVE J-QTY TO RP-F463.
    COMPUTE WN2 ROUNDED=J-QTY * P-WEIGHT / 100 MOVE WN2 TO RP-F464.
    WRITE RP-RECORD INVALID READ REPFL ADD WN1 TO RP-F462 ADD J-QTY TO RP-F463
      ADD WN2 TO RP-F464 REWRITE RP-RECORD.
    GO NM23.
NM29. MOVE 0 TO PR-NUM PERFORM OPEN-PR PERFORM NM-PAGE.

    MOVE LOW-VALUES TO NM-STOTALS NM-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO NM8.
NM3. READ REPFL NEXT END GO NM8.
    IF RP-F460=OLD-N GO NM4. IF OLD-N NOT=0 PERFORM NM-S.
    MOVE "SECTOR" TO FD550 MOVE NM-GROUP TO FD551 MOVE RP-F460 TO FD552 OLD-N.
    PERFORM NM-LINE.
NM4. MOVE RP-F461 TO FD542 A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FD543.
    COMPUTE NM-XT ROUNDED=RP-F462 / 1000 COMPUTE NM-XQ ROUNDED=RP-F463 / 1000.
    COMPUTE NM-XW ROUNDED=RP-F464 / 1000 PERFORM NM-P PERFORM NM-LINE.
    ADD NM-XT TO NM-ST NM-GT ADD NM-XQ TO NM-SQ NM-GQ ADD NM-XW TO NM-SW NM-GW.
    GO NM3.
NM8. PERFORM NM-S MOVE "*** GRAND TOTALS" TO PREC.
    MOVE NM-GTOTALS TO NM-XTOTALS PERFORM NM-P PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR.
    MOVE "PRINT2" TO PR-QUEUE PERFORM PRINT-PR.
NM9. GO MX9.

NM-S. MOVE 2 TO WS-PR MOVE " ** SECTOR TOTALS" TO PREC.
    MOVE NM-STOTALS TO NM-XTOTALS PERFORM NM-P PERFORM NM-LINE 3 TIMES.
    MOVE LOW-VALUES TO NM-STOTALS.
NM-P. MOVE NM-XT TO FD544 MOVE NM-XQ TO FD545.
    COMPUTE FD546 ROUNDED=100 * NM-XQ / NM-XT SIZE ERROR CONTINUE. MOVE "%" TO FD546A.
    MOVE NM-XW TO FD547 COMPUTE FD548 ROUNDED=1000 * NM-XW / NM-XQ SIZE ERROR CONTINUE.
NM-LINE. PERFORM PR-LINE IF WS-LINES>58 PERFORM NM-PAGE.
NM-PAGE. STRING "MACHINE PERFORMANCE ANALYSIS (" NM-DT ")" DELIMITED "  " INTO FF3Y.
    PERFORM PR-PAGE-80.
    MOVE 2 TO WS-PR MOVE NM-PDAYS TO FD553 MOVE "PRODUCTION DAYS" TO FD554.
    PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "                                     TARGET   ACTUAL         ACTUAL" TO PREC PERFORM PR-LINE.
    MOVE "MAC DESCRIPTION                        QTY      QTY    EFF   WEIGHT  WEIGHT/M" TO PREC PERFORM PR-LINE-3.
*         ..  ..............................  ...,...  ...,...  ...%  ...,...   ....:.

* Z-18-9 PAYROLL WEEKLY SUMMARY REPORT
EG1. PERFORM RD367 PERFORM WRT IF S-BAT GO EG2.
EG13. MOVE 3 TO IXT MOVE 28 TO IXU PERFORM AX-DT-VAL.
    MOVE DATE0 TO D-DATE PERFORM D-WKDAY IF D-N1 NOT=7 PERFORM DSP-ERR10 GO EG13.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EG2. PERFORM DSP-WAIT PERFORM OPEN-EMPL PERFORM OPEN-REP PERFORM OPEN-SORT.
    MOVE 0 TO EG-RSEQ INITIALIZE J-KD MOVE DATE0 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO EG29.
EG23. READ WORKSHEET NEXT REGARDLESS END GO EG29. IF J-DATE>DATE0 + 6 GO EG29.
    IF J-EMP=0 GO EG23. PERFORM INIT-RP MOVE J-EMP TO RP-F195.
    MOVE J-MAC TO RP-F198 A-N1 PERFORM RD-MAC.
    MOVE M-GROUP TO RP-F196 MOVE M-SECT TO RP-F197.
    MOVE J-HOURS TO RP-F200 MOVE J-NO TO RP-F200A.
    ADD 1 TO EG-RSEQ MOVE EG-RSEQ TO RP-F199 WRITE RP-RECORD.
    MOVE M-GROUP TO SR-F57 MOVE M-SECT TO SR-F58 MOVE J-HOURS TO SR-F59.
    WRITE SR-RECORD INVALID READ SORTFL ADD J-HOURS TO SR-F59 REWRITE SR-RECORD.
    GO EG23.
EG29. PERFORM OPEN-PR MOVE 1 TO EG-STEP PERFORM EG-PAGE.
    MOVE 0 TO EG-ETOT EG-TTOT OLD-N OLD-T.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EG8.
EG3. READ REPFL NEXT END GO EG8. IF RP-F195=OLD-N GO EG34.
    IF OLD-N NOT=0 PERFORM EG-T PERFORM EG-E. MOVE RP-F195 TO OLD-N MOVE 0 TO OLD-T.
    MOVE RP-F195 TO FG124 A-N1 PERFORM RD-EMPL MOVE E-NAME TO FG125.
    MOVE E-DEPT TO FG126 MOVE E-SECT TO FG126A.
EG34. COMPUTE WN1=100 * RP-F196 + RP-F197 IF WN1=OLD-T GO EG4.
    IF OLD-T NOT=0 PERFORM EG-T. MOVE WN1 TO OLD-T.
    MOVE RP-F196 TO FG127 MOVE RP-F197 TO FG127A.
EG4. MOVE RP-F198 TO FG128 MOVE RP-F200 TO FG129 MOVE RP-F200A TO FG129A.
    ADD RP-F200 TO EG-TTOT EG-ETOT PERFORM EG-LINE GO EG3.
EG8. PERFORM EG-T PERFORM EG-E MOVE 2 TO EG-STEP PERFORM EG-PAGE.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO EG9.
EG83. READ SORTFL NEXT END GO EG9. MOVE SR-F57 TO FG258 MOVE SR-F58 TO FG259.
    MOVE SR-F59 TO FG260 PERFORM EG-LINE GO EG83.
EG9. CLOSE EMPL PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

EG-E. MOVE "      ** EMPL TOTAL" TO FG125 MOVE EG-ETOT TO FG129 MOVE "**" TO FG129B.
    PERFORM EG-LINE 2 TIMES MOVE 0 TO EG-ETOT.
EG-T. MOVE "       * DEPT/SECT TOTAL" TO FG125 MOVE EG-TTOT TO FG129 MOVE "*" TO FG129B.
    PERFORM EG-LINE MOVE 0 TO EG-TTOT.
EG-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EG-PAGE.
EG-PAGE. MOVE "PAYROLL WEEKLY SUMMARY REPORT" TO FF3.
    IF EG-STEP=2 MOVE "** DEPARTMENT/SECTOR ANALYSIS **" TO FF4. PERFORM PR-PAGE.
    MOVE "FOR WEEK STARTING:" TO A-A1 PERFORM PRANGE-DT.
    IF EG-STEP=1 MOVE
         " EMPL  NAME                       REG DEP/SEC     DEP/SEC  MAC   HOURS    M.O." TO PREC PERFORM PR-LINE-3.
*         ....   ..............................  .. ..       .. ..   ...   ..:..  ......  ..
    IF EG-STEP=2 MOVE
         "DEPT SECTOR    HOURS" TO PREC PERFORM PR-LINE-3.
*          ..    ..   .,...:..

* Z-18-10 FORWARD LOADING REPORT (SECONDARY OPERATIONS)
JB1. PERFORM RD101 PERFORM WRT IF S-BAT GO JB2.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 40 TO IXV PERFORM AX-MAC-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
JB2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO JB29.
JB23. READ PRODORD NEXT REGARDLESS END GO JB29. IF R-QTY-LEFT<=0 GO JB23.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO JB23.
    PERFORM GET-OP IF A-S1=1 GO JB23. MOVE 1 TO IX1.
JB25. IF NOT(OP-OPER(IX1)>=MAC1 AND<=MAC2) GO JB28.
    MOVE OP-OPER(IX1) TO M-NO READ MACHINE REGARDLESS INVALID GO JB28.
    IF M-COST=0 GO JB28. MOVE R-QTY-LEFT TO JB-LEFT.
    INITIALIZE J-KEY MOVE R-NO TO J-NO MOVE M-NO TO J-MAC.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO JB264.
JB263. READ WORKSHEET NEXT REGARDLESS END GO JB264.
    IF NOT(J-NO=R-NO AND J-MAC=M-NO) GO JB264.
    SUBTRACT J-QTY FROM JB-LEFT GO JB263.
JB264. IF JB-LEFT<=0 GO JB28.
* note 12
    IF M-CMODE="G" OR "N" COMPUTE JB-NUM ROUNDED=JB-LEFT * P-WEIGHT / 100
      ELSE MOVE JB-LEFT TO JB-NUM.
    COMPUTE JB-NUM ROUNDED=JB-NUM * 8 / M-TQTY SIZE ERROR MOVE 0 TO JB-NUM.
    PERFORM INIT-RP MOVE M-TYPE TO RP-F188 MOVE M-NO TO RP-F189.
    IF R-LDATE(1) NOT=0 MOVE R-LDATE(1) TO RP-F190 ELSE MOVE R-DATE TO RP-F190.
    MOVE P-NO TO RP-F191 MOVE R-KEY TO RP-F192.
    MOVE JB-LEFT TO RP-F193 MOVE JB-NUM TO RP-F194 WRITE RP-RECORD.
JB28. ADD 1 TO IX1 IF IX1<=12 GO JB25. GO JB23.
JB29. PERFORM OPEN-PR PERFORM JB-PAGE.

    MOVE LOW-VALUES TO JB-MTOTALS JB-TTOTALS MOVE 0 TO OLD-M OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JB9.
JB3. READ REPFL NEXT END GO JB9. MOVE RP-F192 TO R-KEY READ PRODORD REGARDLESS.
    IF RP-F188=OLD-N GO JB34. IF OLD-N NOT=0 PERFORM JB-M PERFORM JB-T PERFORM JB-PAGE.
    MOVE RP-F188 TO OLD-N MOVE 0 TO OLD-M PERFORM JB-TC.
JB34. IF RP-F189=OLD-M GO JB4. IF OLD-M NOT=0 PERFORM JB-M.
    MOVE RP-F189 TO OLD-M PERFORM JB-MC.
JB4. MOVE RP-F193 TO JB-LEFT MOVE RP-F194 TO JB-NUM.
    MOVE R-PROD TO A-A1 PERFORM PROD-RGD.
    MOVE P-CAT TO FG86 MOVE P-NO TO FG87 MOVE PRO-DESC(1) TO FG88 MOVE R-NO TO FG89.
    MOVE JB-LEFT TO FG90 IF R-QTY-PROD>0 MOVE "*" TO FG91.
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG92.
    PERFORM FIND-RLDATE IF D-DATE NOT=R-DATE PERFORM D-NM MOVE D-DT TO FG93.
    IF R-LDATE(1) NOT=0 MOVE R-LDATE(1) TO D-DATE ELSE MOVE R-DATE TO D-DATE.
    PERFORM D-CURR COMPUTE IX1=D-N1 + 1.
    IF IX1<1 MOVE 1 TO IX1. IF IX1>4 MOVE 4 TO IX1.
    MOVE JB-NUM TO FG94(IX1) ADD JB-NUM TO JB-MTOT(IX1) JB-TTOT(IX1).
    PERFORM JB-LINE GO JB3.
JB9. PERFORM JB-M PERFORM JB-T.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

JB-T. MOVE 2 TO WS-PR MOVE "*** PROCESS TYPE TOTALS" TO FG88.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE JB-TTOT(IX1) TO FG94(IX1) END-PERFORM.
    PERFORM PR-LINE MOVE LOW-VALUES TO JB-TTOTALS.
JB-M. MOVE 2 TO WS-PR MOVE "*** PROCESS TOTALS" TO FG88.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE JB-MTOT(IX1) TO FG94(IX1) END-PERFORM.
    PERFORM JB-LINE 2 TIMES MOVE LOW-VALUES TO JB-MTOTALS.
JB-TC. MOVE "PROCESS TYPE" TO FG97 MOVE OLD-N TO FG98.
    IF OLD-N NOT=0 MOVE OLD-N TO A-N1 PERFORM RD-MACTYPE MOVE ME-DESC TO FG99.
    PERFORM JB-LINE 2 TIMES.
JB-MC. MOVE 2 TO WS-PR MOVE "    PROCESS " TO FG97 MOVE OLD-M TO FG98.
    IF OLD-M NOT=0 MOVE OLD-M TO A-N1 PERFORM RD-MAC
      MOVE M-DESC1 TO A-A1 PERFORM STR-LTH MOVE M-HOURS TO DSP-N21
      STRING M-DESC1(1:A-N1) " (" DSP-N21 " HOURS/DAY)" DELIMITED SIZE INTO FG99.
    PERFORM JB-LINE 2 TIMES.
JB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JB-PAGE.
JB-PAGE. MOVE "FORWARD LOADING REPORT (SECONDARY OPERATIONS)" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PROC.
    MOVE "CAT PRODUCT                                         M.O.    TO BUILD     DATE      LATE      CURR  FUT 1  FUT 2  FUT 3" TO PREC PERFORM PR-LINE-3.
*         .. ............ ................................  ...... ..,...,... .  ../../..  ../../..    ...    ...    ...    ...

    REPLACE ==INTO-LAB== BY ==DELIMITED SIZE INTO LAB-RECORD POINTER LAB-PTR PERFORM LAB-LINE==.
* Z-18-11 CREATE EMPLOYEE TIME LABELS
JL1. PERFORM RD361 PERFORM WRT.
    MOVE 3 TO IXT MOVE 20 TO IXU PERFORM AX-PDIV.
    ACCEPT JL-EDATE LINE 3 COLUMN 47 DEFAULT " " UNDERLINED PROTECTED EDITING.
    MOVE 5 TO IXT MOVE 17 TO IXU MOVE 41 TO IXV PERFORM AX-EMP-R.
    MOVE 6 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT MOVE 11 TO LAB-FLN PERFORM OPEN-LAB.
    MOVE WS-PDIV TO EMPL-DIV OPEN I-O EMPL ALLOWING ALL.

    MOVE WS-PDIV TO E-DIV MOVE EMP1 TO E-NO.
    START EMPL KEY>=E-KEY REGARDLESS INVALID GO JL9.
JL3. READ EMPL NEXT REGARDLESS END GO JL9. IF E-DIV>WS-PDIV OR E-NO>EMP2 GO JL9.
    IF E-DEL=1 GO JL3.
    MOVE " " TO JL-LAST JL-FIRST MOVE 1 TO IX1.
    UNSTRING E-NAME DELIMITED "," INTO JL-LAST POINTER IX1.
    INSPECT E-NAME(IX1:) TALLYING IX1 FOR LEADING " " MOVE E-NAME(IX1:) TO JL-FIRST.
    MOVE E-NO TO JL-DF1 A-U1 MOVE 4 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO JL-DN1.
    MOVE E-DEPT TO JL-DF2 A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO JL-DN2.
    MOVE E-SECT TO JL-DF3 A-U1 MOVE 2 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO JL-DN3.

    STRING "^XA^LH0,0^FWN^FS" INTO-LAB.
    STRING "^FT20,55^A0,40,40^FD" JL-DF1(JL-DN1:) "^FS" INTO-LAB.
    STRING "^FT120,55^A0,30,30^FD" JL-DF2(JL-DN2:) "-" JL-DF3(JL-DN3:) "^FS" INTO-LAB.
    STRING "^FT280,55^AC^FDENDING: ^FS^FT^A0,40,40^FD" JL-EDATE "^FS" INTO-LAB.
    STRING "^FT20,120^A0,70,58^FD" JL-LAST "^FS" INTO-LAB.
    STRING "^FT20,185^A0,70,58^FD" JL-FIRST "^FS" INTO-LAB.
    STRING "^PQ0001,0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    GO JL3.
JL9. CLOSE EMPL PERFORM CLOSE-LAB GO MX9.
    REPLACE OFF.

    REPLACE ==INTO-LAB== BY ==DELIMITED SIZE INTO LAB-RECORD POINTER LAB-PTR PERFORM LAB-LINE==.
* Z-18-12 CREATE EMPLOYEE ADDRESS LABELS
JK1. PERFORM RD362 PERFORM WRT.
    MOVE 3 TO IXT MOVE 20 TO IXU PERFORM AX-PDIV.
    MOVE 5 TO IXT MOVE 17 TO IXU MOVE 41 TO IXV PERFORM AX-EMP-R.
    ACCEPT LAB-FLN LINE 7 COLUMN 19 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    MOVE 7 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-LAB.
    MOVE WS-PDIV TO EMPL-DIV OPEN I-O EMPL ALLOWING ALL.

    MOVE WS-PDIV TO E-DIV MOVE EMP1 TO E-NO.
    START EMPL KEY>=E-KEY REGARDLESS INVALID GO JK9.
JK3. READ EMPL NEXT REGARDLESS END GO JK9. IF E-DIV>WS-PDIV OR E-NO>EMP2 GO JK9.
    IF E-DEL=1 GO JK3.

    STRING "^XA^LH0,0^FWN^FS" INTO-LAB.
    STRING "^FT20,50^A0,30,30^FD" E-NAME "^FS" INTO-LAB.
    STRING "^FT20,90^A0,30,30^FD" E-ADD1 "^FS" INTO-LAB.
    STRING "^FT20,130^A0,30,30^FD" E-ADD2 "^FS" INTO-LAB.
    STRING "^FT20,170^A0,30,30^FD" E-POST "^FS" INTO-LAB.
    STRING "^PQ0001,0,1^FS" INTO-LAB.
    STRING "^FWN^XZ" INTO-LAB.

    GO JK3.
JK9. CLOSE EMPL PERFORM CLOSE-LAB GO MX9.
    REPLACE OFF.

* Z-18-13 EMPTY BUCKETS REPORT
JW1. PERFORM RD151 PERFORM WRT IF S-BAT GO JW2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
JW2. PERFORM DSP-WAIT COMPUTE DATE0=SYS-DATE - 90.
    PERFORM OPEN-PR PERFORM JW-PAGE.
    MOVE " " TO BU-KEY START BUCKET KEY>BU-KEY REGARDLESS INVALID GO JW9.
JW3. READ BUCKET NEXT REGARDLESS END GO JW9. MOVE BU-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-PRIMARY OR BU-WEIGHT>0 OR BU-DATE<DATE0 GO JW3.
    INITIALIZE J-REC MOVE BU-JKEY TO J-KEY READ WORKSHEET REGARDLESS INVALID CONTINUE.
    MOVE BU-NO TO FF428 MOVE BU-MAC TO FF429.
    MOVE BU-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF430.
    MOVE LIT-XDAN(BU-SHIFT + 1:1) TO FF431 MOVE BU-EMP TO FF432.
    MOVE J-PROD TO FF433 MOVE BU-NUM TO FF433A PERFORM JW-LINE GO JW3.
JW9. PERFORM CLOSE-PR GO MX9.

JW-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JW-PAGE.
JW-PAGE. MOVE "EMPTY BUCKETS REPORT" TO FF3.
    MOVE "(EXCLUDING PRIMARY MACHINES)" TO FF4 PERFORM PR-PAGE.
    MOVE "SINCE:" TO A-A1 PERFORM PRANGE-DT.
    MOVE " M.O.   MAC    DATE   SH  CLOCK  PRODUCT       BUCKET" TO PREC PERFORM PR-LINE-3.
*         ......  ...  ../../..  .  ....   ............   ....

* Z-18-14 SCRAP ANALYSIS (SECONDARY OPERATIONS)
EQ1. PERFORM RD363 PERFORM WRT IF S-BAT GO EQ2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EQ2. PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE J-KD MOVE DATE1 TO J-KDATE.
    START WORKSHEET KEY>J-KD REGARDLESS INVALID GO EQ29.
EQ23. READ WORKSHEET NEXT REGARDLESS END GO EQ29. IF J-DATE>DATE2 GO EQ29.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-REJECT GO EQ23.
    PERFORM INIT-RP MOVE J-MAC TO RP-F70 MOVE J-PROD TO RP-F71.
    MOVE J-NO TO RP-F72 MOVE J-KEY TO RP-F72A WRITE RP-RECORD GO EQ23.
EQ29. PERFORM OPEN-PR MOVE 1 TO EQ-STEP PERFORM EQ-PAGE.
    MOVE LOW-VALUES TO EQ-PTOTALS EQ-ATOTALS EQ-GTOTALS EQ-STOTALS.
    MOVE 0 TO OLD-M OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EQ6.
EQ3. READ REPFL NEXT END GO EQ6. MOVE RP-F72A TO J-KEY.
    READ WORKSHEET REGARDLESS INVALID GO EQ3. IF J-MAC=OLD-M GO EQ34.
    IF OLD-M NOT=0 PERFORM EQ-PROD PERFORM EQ-MAC.
    MOVE J-MAC TO OLD-M MOVE " " TO OLD-A MOVE 0 TO OLD-N.
    MOVE J-MAC TO FA830 A-N1 PERFORM RD-MAC MOVE M-DESC1 TO FA831.
EQ34. IF J-PROD=OLD-A GO EQ36. IF OLD-A>" " PERFORM EQ-PROD.
    MOVE J-PROD TO OLD-A MOVE 0 TO OLD-N ADD 1 TO EQ-AP EQ-GP.
    MOVE J-PROD TO FA832 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FA833.
EQ36. IF J-NO=OLD-N GO EQ4. MOVE J-NO TO OLD-N ADD 1 TO EQ-PR EQ-AR EQ-GR.
EQ4. EVALUATE TRUE
      WHEN P-CAT=21 OR 22 OR 23 MOVE 2 TO IX1
      WHEN P-CAT=11 OR 14 OR 33 OR 69 MOVE 3 TO IX1
      WHEN P-CAT=8 OR 31 OR 32 MOVE 4 TO IX1
      WHEN OTHER MOVE 1 TO IX1.
    ADD J-QTY TO EQ-PQ EQ-AQ EQ-GQ EQ-SQ(IX1).
    MOVE J-AWEIGHT TO EQ-WEIGHT IF EQ-WEIGHT=0 MOVE J-WEIGHT TO EQ-WEIGHT.
    ADD EQ-WEIGHT TO EQ-PW EQ-AW EQ-GW EQ-SW(IX1).
    GO EQ3.
EQ6. PERFORM EQ-PROD PERFORM EQ-MAC MOVE 2 TO WS-PR.
    MOVE "*** GRAND TOTALS" TO PREC.
    MOVE EQ-GP TO FA834 MOVE EQ-GR TO FA835.
    MOVE EQ-GQ TO FA836 MOVE EQ-GW TO FA837 MOVE "***" TO FA838 PERFORM PR-LINE.

    MOVE 2 TO EQ-STEP PERFORM EQ-PAGE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE EQ-SDESC(IX1) TO FA840 MOVE EQ-SQ(IX1) TO FA841 MOVE EQ-SW(IX1) TO FA842
      PERFORM EQ-LINE END-PERFORM.
    MOVE 2 TO WS-PR MOVE "** TOTALS" TO PREC.
    MOVE EQ-GQ TO FA841 MOVE EQ-GW TO FA842 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR.
EQ9. GO MX9.

EQ-PROD. MOVE EQ-PR TO FA835 MOVE EQ-PQ TO FA836 MOVE EQ-PW TO FA837.
    PERFORM EQ-LINE MOVE LOW-VALUES TO EQ-PTOTALS.
EQ-MAC. MOVE 2 TO WS-PR MOVE "*** MACHINE TOTALS" TO PREC.
    MOVE EQ-AP TO FA834 MOVE EQ-AR TO FA835.
    MOVE EQ-AQ TO FA836 MOVE EQ-AW TO FA837 MOVE "***" TO FA838.
    PERFORM EQ-LINE 3 TIMES MOVE LOW-VALUES TO EQ-ATOTALS.
EQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EQ-PAGE.
EQ-PAGE. MOVE "SCRAP ANALYSIS (SECONDARY OPERATIONS)" TO FF3.
    IF EQ-STEP=2 MOVE "** CATEGORY SUMMARY **" TO FF4. PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    IF EQ-STEP=1 MOVE
         "MACHINE                            PRODUCT                                        PRODUCTS  ORDERS        QTY         WEIGHT" TO PREC PERFORM PR-LINE-3.
*         .. ..............................  ............  ................................  .....    .....  ...,...,...-  ...,...,...- ...
    IF EQ-STEP=2 MOVE
         "CATEGORY             QTY         WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ........      ...,...,...-  ...,...,...-

* Z-18-15 SCRAP REPORT
KQ1. PERFORM RD289 PERFORM WRT IF S-BAT GO KQ2.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 42 TO IXV PERFORM AX-MAC-R.
    MOVE 4 TO IXT MOVE 16 TO IXU MOVE 42 TO IXV PERFORM AX-PROD-R.
    MOVE 5 TO IXT MOVE 16 TO IXU MOVE 42 TO IXV PERFORM AX-DATE-R.
    MOVE 6 TO IXT MOVE 16 TO IXU MOVE 42 TO IXV PERFORM AX-ORD-R.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
KQ2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    IF MAC2=0 MOVE 9999 TO MAC2. IF PROD2=" " MOVE ALL "Z" TO PROD2.
    IF ORD2=0 MOVE 999999 TO ORD2.
    MOVE 0 TO KQ-PMAC INITIALIZE J-KEY MOVE ORD1 TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO KQ29.
KQ23. READ WORKSHEET NEXT REGARDLESS END GO KQ29. IF J-NO>ORD2 GO KQ29.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-PRIMARY MOVE J-MAC TO KQ-PMAC.
    IF NOT((PROC-SCRAP OR PROC-REJECT) AND (J-DATE>=DATE1 AND<=DATE2)
      AND (J-PROD>=PROD1 AND<=PROD2)) GO KQ23.
    MOVE KQ-PMAC TO KQ-SMAC IF NOT PROC-SCRAP GO KQ26. MOVE J-NAME TO WA1.
    PERFORM VARYING IX1 FROM 5 BY 1 UNTIL IX1>7
      IF WA1(IX1:1) NOT NUMERIC MOVE "0" TO WA1(IX1:1) END-IF END-PERFORM.
    MOVE WA1(5:3) TO WN1 IF WN1>0 MOVE WN1 TO KQ-SMAC.
KQ26. IF NOT(KQ-SMAC>=MAC1 AND<=MAC2) GO KQ23.
    PERFORM INIT-RP MOVE J-PROD TO RP-F440 MOVE KQ-SMAC TO RP-F441.
    MOVE J-DATE TO RP-F442 MOVE J-NO TO RP-F443 MOVE 0 TO RP-F444.
    MOVE J-WEIGHT TO RP-F445 MOVE J-MAC TO RP-F446.
KQ27. WRITE RP-RECORD INVALID IF RP-F444<99 ADD 1 TO RP-F444 GO KQ27 END-IF.
    GO KQ23.
KQ29. PERFORM OPEN-PR PERFORM KQ-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO KQ9.
KQ3. READ REPFL NEXT END GO KQ9. MOVE RP-F440 TO FD513 MOVE RP-F441 TO FD514.
    MOVE RP-F442 TO D-DATE PERFORM D-NM MOVE D-DT TO FD515.
    MOVE RP-F443 TO FD516 MOVE RP-F445 TO FD517 MOVE RP-F446 TO FD518.
    PERFORM KQ-LINE GO KQ3.
KQ9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

KQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM KQ-PAGE.
KQ-PAGE. MOVE "SCRAP REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "DATE RANGE:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR PERFORM PRANGE-MAC MOVE 1 TO WS-PR PERFORM PRANGE-PROD.
    MOVE 1 TO WS-PR PERFORM PRANGE-MO.
    MOVE "PRODUCT       MAC    DATE      M.O.        WEIGHT   PROCESS" TO PREC PERFORM PR-LINE-3.
*         ............  ...  ../../..  ......   ...,...,...-     ..

* Z-18-16 MACHINE/PROCESS TYPES AND GROUPS LISTING
EH1. PERFORM RD48 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR MOVE 1 TO EH-STEP PERFORM EH-PAGE.
    MOVE " " TO ME-KEY START MACTYPE KEY>ME-KEY REGARDLESS INVALID GO EH4.
EH3. READ MACTYPE NEXT REGARDLESS END GO EH4.
    MOVE ME-NO TO FA492 MOVE ME-DESC TO FA493 MOVE ME-CONTRIB TO FA494.
    MOVE ME-COST TO FA495 MOVE ME-CMODE TO FA496 MOVE ME-TOOLCOST TO FA497.
    PERFORM EH-LINE GO EH3.
EH4. MOVE 2 TO EH-STEP PERFORM EH-PAGE MOVE 19 TO T-TBL MOVE 0 TO T-NO.
    START TABLES KEY>T-KEY REGARDLESS INVALID GO EH9.
EH5. READ TABLES NEXT REGARDLESS END GO EH9. IF T-TBL NOT=19 GO EH9.
    MOVE T-NO TO FA492 MOVE T-LINE TO FA493 PERFORM EH-LINE GO EH5.
EH9. PERFORM CLOSE-PR GO MX9.

EH-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EH-PAGE.
EH-PAGE. MOVE "MACHINE/PROCESS TYPES AND GROUPS" TO FF3 PERFORM PR-PAGE.
    IF EH-STEP=1 MOVE
         "TYPE  DESCRIPTION                         CONTRIBUTION   COST  MODE   TOOL EST COST" TO PREC PERFORM PR-LINE-3.
*          ..   ....................................    ....     ....:...  .       ....:...
    IF EH-STEP=2 MOVE
         "GROUP DESCRIPTION" TO PREC PERFORM PR-LINE-3.
*          ..   ....................................

* Z-18-17 IN-PROCESS PRODUCTION ORDERS REPORT
EY1. PERFORM RD290 PERFORM WRT IF S-BAT GO EY2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EY2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO EY29.
EY23. READ PRODORD NEXT REGARDLESS END GO EY29. IF R-QTY-LEFT=0 GO EY23.
* note 132.2
    MOVE 0 TO WN1 INITIALIZE J-KEY MOVE R-NO TO J-NO MOVE 845 TO J-MAC.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO EY234.
EY233. READ WORKSHEET NEXT REGARDLESS END GO EY234.
    IF J-NO NOT=R-NO OR J-MAC>850 GO EY234. MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-RECEIVE OR PROC-BOLTNUT IF J-DATE>WN1 MOVE J-DATE TO WN1. GO EY233.
EY234. PERFORM INIT-RP.
    IF R-QTY-PROD=0 MOVE 100 TO WN2 ELSE IF R-QTY-LEFT<0 MOVE 0 TO WN2
      ELSE COMPUTE WN2 ROUNDED=100 * R-QTY-LEFT / R-QTY-PROD.
    COMPUTE RP-F448 ROUNDED=999 - WN2.
    MOVE R-KEY TO RP-F449 MOVE WN1 TO RP-F450 WRITE RP-RECORD GO EY23.
EY29.

    PERFORM OPEN-PR PERFORM EY-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO EY9.
EY3. READ REPFL NEXT END GO EY9. MOVE RP-F449 TO R-KEY READ PRODORD REGARDLESS.
    COMPUTE EY-PERC=999 - RP-F448.
    IF RP-F450>0 COMPUTE EY-DAYS=SYS-DATE - RP-F450 ELSE MOVE 999 TO EY-DAYS.
    MOVE R-NO TO FD520 MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD521.
    MOVE R-PROD TO FD522 MOVE R-QTY-ORD TO FD523 MOVE R-QTY-PROD TO FD524.
    MOVE R-QTY-REC TO FD525 MOVE R-QTY-LEFT TO FD526 MOVE EY-PERC TO FD527.
    IF RP-F450>0 MOVE RP-F450 TO D-DATE PERFORM D-NM MOVE D-DT TO FD528.
    IF R-FIN=1 MOVE "Y" TO FD529.
    IF EY-DAYS<21 AND EY-PERC>=10 MOVE "*" TO FD530.
    IF EY-DAYS<21 AND EY-PERC<10 MOVE "*" TO FD531.
    IF EY-DAYS<999 IF EY-DAYS>=21 AND EY-PERC>=10 MOVE "*" TO FD532.
    PERFORM EY-LINE GO EY3.
EY9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

EY-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EY-PAGE.
EY-PAGE. MOVE "IN-PROCESS PRODUCTION ORDERS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "  M.O.    DATE    PRODUCT         QTY ORD   QTY PROD   QTY RCVD   QTY LEFT  %LEFT  LAST RCVD  CLS  DAYS SINCE RCVD:  <21   <21   21+" TO PREC PERFORM PR-LINE.
    MOVE "                                                         +ADJ                                         % LEFT TO RCV:  10+  <10   10+" TO PREC PERFORM PR-LINE-3.
*         ......  ../../..  ............ .,...,...- .,...,...- .,...,...- .,...,...-   ...-   ../../..   .                       .    .    .

* Z-18-18 PRODUCTION REPORTS
NY1. PERFORM RD291 PERFORM WRT.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 38 TO IXV PERFORM AX-MAC-R.
NY13. ACCEPT NY-OP LINE 5 COLUMN 15 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    GO NY1410 NY1420 NY1430  DEPENDING NY-OP. PERFORM DSP-ERR2 GO NY13.
NY1410. MOVE 7 TO IXT MOVE 27 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO NY-DATE.
NY1413. ACCEPT XA1 LINE IXT COLUMN 53 DEFAULT "D" UNDERLINED PROTECTED.
    PERFORM CHK-SHIFT IF A-N1=0 OR>3 PERFORM DSP-ERR24 GO NY1413.
    MOVE A-N1 TO NY-SHIFT GO NY18.
NY1420. MOVE 8 TO IXT MOVE 27 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO D-DATE.
    MOVE 1 TO D-N1 PERFORM D-CPREVIOUS MOVE D-DATE TO NY-DATE GO NY18.
NY1430. MOVE 9 TO IXT MOVE 33 TO IXU MOVE 52 TO IXV PERFORM AX-YM-S.
    MOVE D-YY TO NY-YY MOVE D-MM TO NY-MM GO NY18.
NY18. MOVE 10 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-SORT.

    INITIALIZE J-KD.
    IF NY-OP=1 MOVE NY-DATE TO J-KDATE MOVE NY-SHIFT TO J-KSHIFT.
    IF NY-OP=2 MOVE NY-DATE TO J-KDATE.
    IF NY-OP=3 MOVE NY-YY TO D-YY MOVE NY-MM TO D-MM MOVE 1 TO D-DD
      PERFORM D-MN MOVE D-DATE TO J-KDATE.
    START WORKSHEET KEY>=J-KD REGARDLESS INVALID GO NY24.
NY23. READ WORKSHEET NEXT REGARDLESS END GO NY24.
    IF NY-OP=1 IF NOT(J-DATE=NY-DATE AND J-SHIFT=NY-SHIFT) GO NY24.
    IF NY-OP=2 IF J-DATE>NY-DATE + 6 GO NY24.
    IF NY-OP=3 MOVE J-DATE TO D-DATE PERFORM D-NM
      IF NOT(D-YY=NY-YY AND D-MM=NY-MM) GO NY24.
    IF NOT(J-MAC>=MAC1 AND<=MAC2) GO NY23.
    MOVE J-MAC TO SR-F14 A-N1 PERFORM RD-MAC PERFORM PROC-TYPE.
    MOVE J-PROD TO A-A1 PERFORM PROD-RD.
    MOVE J-NO TO SR-F15 MOVE J-EMP TO SR-F16.
    MOVE J-HOURS TO A-D1 PERFORM CALC-TARGET MOVE A-N1 TO WN1 SR-F17.
    COMPUTE WL1 ROUNDED=J-QTY * P-WEIGHT / 100 / 2000.
    MOVE J-QTY TO WN2 IF PROC-HEAT COMPUTE WN2 ROUNDED=J-QTY * P-WEIGHT / 100.
* note 23.3
    MOVE WN2 TO SR-F18 MOVE WL1 TO SR-F19.
    MOVE J-HOURS TO SR-F20 MOVE J-NOTE TO SR-F20A.
    IF NY-OP=2 OR 3 MOVE 0 TO SR-F15 SR-F16 MOVE " " TO SR-F20A.
    WRITE SR-RECORD INVALID READ SORTFL ADD WN1 TO SR-F17 ADD WN2 TO SR-F18
      ADD WL1 TO SR-F19 ADD J-HOURS TO SR-F20 REWRITE SR-RECORD.
    GO NY23.
NY24.
* note 273

    MOVE MAC1 TO M-NO START MACHINE KEY>=M-KEY REGARDLESS INVALID GO NY29.
NY25. READ MACHINE NEXT REGARDLESS END GO NY29. IF M-NO>MAC2 GO NY29.
    MOVE " " TO SR-KEY MOVE M-NO TO SR-F14.
    START SORTFL KEY>SR-KEY INVALID GO NY26.
    READ SORTFL NEXT END GO NY26. IF SR-F14=M-NO GO NY28.
NY26. PERFORM INIT-SR MOVE M-NO TO SR-F14 MOVE 999999 TO SR-F15 SR-F16 WRITE SR-RECORD.
NY28. GO NY25.
NY29.

* note 274
    MOVE 1 TO LAS-NPAGE MOVE 0 TO OLD-N.
NY3. MOVE 50 TO NY-YSZ.
NY31. MOVE " " TO SR-KEY MOVE OLD-N TO SR-F14.
    START SORTFL KEY>SR-KEY INVALID GO NY36. READ SORTFL NEXT.
    MOVE SR-F14 TO OLD-N ADD 50 TO NY-YSZ.
NY33. READ SORTFL NEXT END GO NY36. IF SR-F14=OLD-N ADD 50 TO NY-YSZ GO NY33.
    ADD 20 TO NY-YSZ IF NY-YSZ<2700 MOVE SR-F14 TO OLD-N GO NY31.
    ADD 1 TO LAS-NPAGE MOVE " " TO SR-KEY MOVE OLD-N TO SR-F14.
    START SORTFL KEY>SR-KEY READ SORTFL NEXT.
    MOVE 1 TO SR-F20B REWRITE SR-RECORD GO NY3.
NY36.

    MOVE LOW-VALUES TO NY-TOTALS.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO NY44.
NY43. READ SORTFL NEXT END GO NY44.
    ADD SR-F17 TO NY-TT ADD SR-F18 TO NY-TQ ADD SR-F19 TO NY-TW GO NY43.
NY44. COMPUTE NY-EFF ROUNDED=100 * NY-TQ / NY-TT SIZE ERROR MOVE 0 TO NY-EFF.

    MOVE 7 TO LAS-FLN PERFORM OPEN-LAS PERFORM PCL-INIT PERFORM PCL-START.
    MOVE 1 TO LAS-PAGE PERFORM NY-HEAD MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO NY8.
NY5. READ SORTFL NEXT END GO NY8.
    IF SR-F20B=1 ADD 20 TO NY-YSZ MOVE "`*p000x+20Y`*c2400a4b0P" TO LAS-FLD PERFORM LASF
      PERFORM NY-VLINES PERFORM PCL-FF ADD 1 TO LAS-PAGE PERFORM NY-HEAD GO NY52.
    IF SR-F14=OLD-N MOVE 1 TO NY-KP GO NY54.
    IF OLD-N NOT=0 ADD 20 TO NY-YSZ MOVE "`*p000x+20Y`*c2400a2b0P" TO LAS-FLD PERFORM LASF.
NY52. MOVE SR-F14 TO OLD-N MOVE 0 TO NY-KP.
NY54. ADD 50 TO NY-YSZ MOVE "`*p000x+50Y`(s12h0s0B" TO LAS-FLD PERFORM LASF.
    IF NY-KP=0 MOVE "`*p020X" TO LAS-FLD PERFORM LASF
      MOVE SR-F14 TO FJ-N3 PERFORM LASF.
    IF SR-F15=999999 AND SR-F16=9999
      STRING "`*p1480XN/S" DELIMITED SIZE INTO LAS-FLD PERFORM LASF GO NY58.
    IF NY-OP=1 MOVE "`*p140X" TO LAS-FLD PERFORM LASF MOVE SR-F15 TO FJ-N5 PERFORM LASF.
    IF NY-OP=1 MOVE "`*p310X" TO LAS-FLD PERFORM LASF MOVE SR-F16 TO FJ-N3 PERFORM LASF.
    MOVE "`*p430X" TO LAS-FLD PERFORM LASF MOVE SR-F17 TO FJ-C8 PERFORM LASF.
    MOVE "`*p725X" TO LAS-FLD PERFORM LASF MOVE SR-F18 TO FJ-C8 PERFORM LASF.
    MOVE "`*p1020X" TO LAS-FLD PERFORM LASF MOVE SR-F19 TO FJ-D31 PERFORM LASF.
    COMPUTE WN1 ROUNDED=100 * SR-F18 / SR-F17 SIZE ERROR MOVE 0 TO WN1.
    MOVE "`*p1190X" TO LAS-FLD PERFORM LASF MOVE WN1 TO FJ-N3 PERFORM LASF.
    MOVE "%" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1335X" TO LAS-FLD PERFORM LASF.
    IF NY-OP=1 MOVE SR-F20 TO FJ-D12 ELSE COMPUTE FJ-N4 ROUNDED=SR-F20.
    PERFORM LASF.
    IF NY-OP=1 MOVE "`*p1480X`(s16.66h0s0B" TO LAS-FLD PERFORM LASF
      MOVE SR-F20A TO LAS-FLD PERFORM LASF.
NY58. GO NY5.
NY8. ADD 20 TO NY-YSZ MOVE "`*p000x+20Y`*c2400a4b0P" TO LAS-FLD PERFORM LASF.
    ADD 50 TO NY-YSZ MOVE "`*p000x+50Y`(s12h0s3B" TO LAS-FLD PERFORM LASF.
    MOVE "`*p430X" TO LAS-FLD PERFORM LASF MOVE NY-TT TO FJ-C8 PERFORM LASF.
    MOVE "`*p725X" TO LAS-FLD PERFORM LASF MOVE NY-TQ TO FJ-C8 PERFORM LASF.
    MOVE "`*p1020X" TO LAS-FLD PERFORM LASF.
    IF NY-OP=1 OR 2 MOVE NY-TW TO FJ-D31 ELSE COMPUTE FJ-C4 ROUNDED=NY-TW.
    PERFORM LASF.
    MOVE "`*p1190X" TO LAS-FLD PERFORM LASF MOVE NY-EFF TO FJ-N3 PERFORM LASF.
    MOVE "%" TO LAS-FLD PERFORM LASF.
    MOVE "`*p1480X" TO LAS-FLD PERFORM LASF MOVE "TOTALS" TO LAS-FLD PERFORM LASF.
    ADD 20 TO NY-YSZ MOVE "`*p000x+20Y`*c2400a4b0P" TO LAS-FLD PERFORM LASF.
    PERFORM NY-VLINES PERFORM PCL-ENDFL PERFORM CLOSE-LAS.
    PERFORM CLOSE-SORT.
    MOVE "PRINT2" TO LAS-QUEUE PERFORM PRINT-LAS.
NY9. GO MX9.

NY-VLINES. STRING "`*p000x350Y`*c4a" NY-YSZ "b0P"
      "`*p120X`*c2a" NY-YSZ "b0P`*p290X`*c2a" NY-YSZ "b0P`*p410X`*c2a" NY-YSZ "b0P"
      "`*p705X`*c2a" NY-YSZ "b0P`*p1000X`*c2a" NY-YSZ "b0P`*p1170X`*c2a" NY-YSZ "b0P"
      "`*p1315X`*c2a" NY-YSZ "b0P`*p1460X`*c2a" NY-YSZ "b0P"
      "`*p2396X`*c4a" NY-YSZ "b0P" DELIMITED SIZE INTO LAS-FLD PERFORM LASF.
NY-HEAD. MOVE "`(s10h0s3B`*p000x040YIRVINE FASTENERS" TO LAS-FLD PERFORM LASF.
    IF NY-OP=1 MOVE "SHIFT" TO WA1
      ELSE IF NY-OP=2 MOVE "WEEKLY" TO WA1 ELSE MOVE "MONTHLY" TO WA1.
    STRING "`(s10h0s3B`*p000x250Y" WA1 " PRODUCTION REPORT" DELIMITED "  "
      INTO LAS-FLD PERFORM LASF.
    MOVE "`(s10h0s3B`*p900x250Y" TO LAS-FLD PERFORM LASF.
    MOVE NY-DATE TO D-DATE PERFORM LAS-SET-SDATE.
    IF NY-OP=1 STRING LAS-SDATE " (" LIT-XDAN(NY-SHIFT + 1:1) ")"
      DELIMITED SIZE INTO LAS-FLD PERFORM LASF.
    IF NY-OP=2 STRING "week of " LAS-SDATE DELIMITED SIZE INTO LAS-FLD PERFORM LASF.
    IF NY-OP=3 MOVE NY-MM TO D-MM MOVE NY-YY TO D-YY MOVE 1 TO D-DD
      PERFORM D-MN PERFORM LAS-SET-SDATE MOVE LAS-SDATE(4:) TO LAS-FLD PERFORM LASF.
    MOVE "`(s10h0s3B`*p1600x250Y" TO LAS-FLD PERFORM LASF.
    MOVE NY-EFF TO FJ-N3 PERFORM LASF MOVE "%" TO LAS-FLD PERFORM LASF.

    MOVE MAC1 TO DSP-F31 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN1.
    MOVE MAC2 TO DSP-F32 A-U1 MOVE 3 TO A-N1 PERFORM COUNT-ZERO MOVE A-N1 TO WN2.
    STRING "`(s16.66h0s3B`*p000x330YMACHINE RANGE: "
      DSP-F31(WN1:) " - " DSP-F32(WN2:) DELIMITED SIZE INTO LAS-FLD PERFORM LASF.
    MOVE LAS-PAGE TO LAS-FPAGE1 MOVE LAS-NPAGE TO LAS-FPAGE2.
    STRING "`(s16.66h0s3B`*p2200x330Y" LAS-FPAGE DELIMITED SIZE INTO LAS-FLD PERFORM LASF.

    STRING "`*p000x350Y`*c2400a4b0P`*p000x400Y`*c2400a4b0P"
      "`(s16.66h0s3B`*p020x390YMAC`*p140XM.O.`*p310XOPER"
      "`*p430XTHEOR. PROD.`*p725XACTUAL PROD.`*p1020XTONS"
      "`*p1190XEFF.`*p1335XHRS`*p1480XNOTES" DELIMITED SIZE INTO LAS-FLD PERFORM LASF.
    MOVE "`*p400Y" TO LAS-FLD PERFORM LASF MOVE 50 TO NY-YSZ.

* Z-18-21 MODIFY M.O. COMPLETION INDICATOR
EE1. PERFORM RD64 PERFORM WRT DISPLAY " " LINE 2 ERASE END SCREEN.
    DISPLAY "PASSWORD: _____" LINE 3 BOLD.
    ACCEPT XA5 COLUMN 11 DEFAULT " " UNDERLINED PROTECTED NO ECHO.
    IF XA5 NOT="SUPER" PERFORM DSP-ERR21 GO EE9.
EE3. PERFORM RD64 PERFORM WRT.
EE33. ACCEPT R-NO LINE 3 COLUMN 12 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR R-NO=999999 GO EE9. IF R-NO=0 GO EE33.
    READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO EE33.
    DISPLAY R-FIN LINE 3 COLUMN 37 CONVERSION.
EE35. ACCEPT R-FIN LINE 3 COLUMN 37 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY R-FIN LINE 3 COLUMN 37 CONVERSION IF R-FIN>1 PERFORM DSP-ERR2 GO EE35.
    REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD GO EE3.
EE9. GO MX9.

* Z-18-22 MACHINE TYPE FILE MAINTENANCE
EK1.
EK3. PERFORM RD89 PERFORM WRT.
    MOVE LOW-VALUES TO ME-RECORD INITIALIZE ME-REC.
    ACCEPT ME-NO LINE 3 COLUMN 8 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
* note 256.1
    IF KPF4 OR ME-NO=0 GO EK9.
    READ MACTYPE REGARDLESS INVALID MOVE 0 TO EK-KFIN GO EK4. MOVE 1 TO EK-KFIN.
    DISPLAY ME-DESC LINE 8 COLUMN 15.
    DISPLAY ME-COST LINE 10 COLUMN 8 CONVERSION.
    DISPLAY ME-CMODE LINE 10 COLUMN 32.
    DISPLAY ME-TOOLCOST LINE 10 COLUMN 62 CONVERSION.
    DISPLAY ME-CONTRIB LINE 11 COLUMN 16 CONVERSION.
EK4.
EK5. PERFORM DSP-NEXT ACCEPT EK-OP LINE 3 COLUMN 54 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF EK-OP=0 GO EK3. IF EK-OP>3 PERFORM DSP-ERR1 GO EK5.
    IF EK-OP=1 AND EK-KFIN=1 MOVE "DUPLICATE TYPE" TO ERR-MESG
      PERFORM DSP-ERR GO EK3.
    IF (EK-OP=2 OR 3) AND EK-KFIN=0 PERFORM DSP-ERR30 GO EK3.
    IF EK-OP=3 DELETE MACTYPE GO EK3.

* op=1,2
    ACCEPT ME-DESC LINE 8 COLUMN 15 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT ME-COST LINE 10 COLUMN 8 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY ME-COST LINE 10 COLUMN 8 CONVERSION.
    ACCEPT ME-CMODE LINE 10 COLUMN 32 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT ME-TOOLCOST LINE 10 COLUMN 62 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY ME-TOOLCOST LINE 10 COLUMN 62 CONVERSION.
    ACCEPT ME-CONTRIB LINE 11 COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY ME-CONTRIB LINE 11 COLUMN 16 CONVERSION.
    IF EK-OP=1 WRITE ME-RECORD ALLOWING NO ELSE REWRITE ME-RECORD ALLOWING NO.
    UNLOCK MACTYPE PERFORM DSP-CONT GO EK3.
EK9. GO MX9.

* Z-18-23 PRODUCTION SHORT SCHEDULE MAINTENANCE
GE1. PERFORM WRT132 PERFORM OPEN-MACSCHED.
GE3. PERFORM RD247 PERFORM WRT.
    ACCEPT GE-MAC LINE 1 COLUMN 55 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR GE-MAC=99 GO GE9. IF GE-MAC=0 GO GE3. MOVE GE-MAC TO A-N1 PERFORM RD-MAC.
    MOVE M-DESC1 TO GE-MDESC DISPLAY GE-MDESC LINE 1 COLUMN 58.
    MOVE LOW-VALUES TO MQ-RECORD INITIALIZE MQ-REC MOVE GE-MAC TO MQ-MAC.
    READ MACSCHED REGARDLESS INVALID MOVE 0 TO GE-KFIN GO GE4. MOVE 1 TO GE-KFIN.

    MOVE 1 TO IX1 MOVE 9 TO IXT.
GE37. IF MQ-MO(IX1)=0 GO GE378. DISPLAY MQ-MO(IX1) LINE IXT COLUMN 5 CONVERSION.
    MOVE MQ-MO(IX1) TO R-NO READ PRODORD REGARDLESS INVALID GO GE378.
    PERFORM GE-D DISPLAY GE-LND LINE IXT COLUMN 13 MQ-COM(IX1) COLUMN 98.
GE378. ADD 1 TO IX1 IXT IF IX1<=15 GO GE37.

GE4.
GE5. PERFORM DSP-NEXT ACCEPT GE-OP LINE 1 COLUMN 121 DEFAULT ZERO
      UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF GE-OP=0 GO GE3. IF GE-OP>3 PERFORM DSP-ERR1 GO GE5.
    IF GE-OP=1 AND GE-KFIN=1 MOVE "THIS SCHEDULE ALREADY EXISTS"
      TO ERR-MESG PERFORM DSP-ERR GO GE3.
    IF (GE-OP=2 OR 3) AND GE-KFIN=0 PERFORM DSP-ERR30 GO GE3.
    IF GE-OP=3 MOVE "THIS SCHEDULE WILL BE DELETED - ARE YOU SURE ? ___" TO TMSG
      PERFORM DSP-PROMPT IF XA3="YES" DELETE MACSCHED END-IF GO GE3.

* op=1,2
* note 124
    MOVE 1 TO GE-IXL MOVE 9 TO IXT.
GE53. DISPLAY "MODIFY LINE, OR: 'UP', 'DOWN', PF1 TO INSERT LINE, PF2 TO DELETE LINE, PF3 TO END" LINE 24 BOLD ERASE LINE.
    ACCEPT MQ-MO(GE-IXL) LINE IXT COLUMN 5 DEFAULT CURRENT
      UNDERLINED PROTECTED NO BLANK CONVERSION KEY CKEY PERFORM DSP-ERS.
    IF NOT(MQ-MO(GE-IXL)=0 AND (KPF3 OR KP-UP OR KP-DOWN))
      DISPLAY MQ-MO(GE-IXL) LINE IXT COLUMN 5 CONVERSION.
    IF KPF3 GO GE8.
    IF KP-UP IF GE-IXL>1 SUBTRACT 1 FROM GE-IXL IXT END-IF GO GE53.
    IF KP-DOWN IF GE-IXL<15 ADD 1 TO GE-IXL IXT END-IF GO GE53.
    IF KPF1 GO GE62. IF KPF2 GO GE64. GO GE70.

GE62. PERFORM VARYING IX1 FROM 14 BY -1 UNTIL IX1<GE-IXL
        MOVE MQ-MO(IX1) TO MQ-MO(IX1 + 1)
        MOVE MQ-COM(IX1) TO MQ-COM(IX1 + 1) END-PERFORM.
    INITIALIZE MQ-MO(GE-IXL) MQ-COM(GE-IXL) GO GE66.
GE64. PERFORM VARYING IX1 FROM GE-IXL BY 1 UNTIL IX1=15
        MOVE MQ-MO(IX1 + 1) TO MQ-MO(IX1)
        MOVE MQ-COM(IX1 + 1) TO MQ-COM(IX1) END-PERFORM.
    INITIALIZE MQ-MO(15) MQ-COM(15).
GE66. MOVE GE-IXL TO IX1 MOVE IXT TO GE-IXT COMPUTE IXT=8 + IX1.
GE67. IF MQ-MO(IX1)=0 DISPLAY " " LINE IXT COLUMN 5 ERASE END LINE GO GE68.
    DISPLAY MQ-MO(IX1) LINE IXT COLUMN 5 CONVERSION.
    MOVE MQ-MO(IX1) TO R-NO READ PRODORD REGARDLESS INVALID GO GE68.
    PERFORM GE-D DISPLAY GE-LND LINE IXT COLUMN 13 MQ-COM(IX1) COLUMN 98.
GE68. ADD 1 TO IX1 IXT IF IX1<=15 GO GE67.
    MOVE GE-IXT TO IXT GO GE53.

GE70. MOVE MQ-MO(GE-IXL) TO R-NO READ PRODORD REGARDLESS INVALID PERFORM DSP-ERR11 GO GE53.
    PERFORM GE-D DISPLAY GE-LND LINE IXT COLUMN 13.
    ACCEPT GE-COILS LINE IXT COLUMN 91 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION.
    DISPLAY GE-COILS LINE IXT COLUMN 91 CONVERSION.
    IF GE-COILS NOT=R-COILS MOVE GE-COILS TO R-COILS
      REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    ACCEPT MQ-COM(GE-IXL) LINE IXT COLUMN 98 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ADD 1 TO GE-IXL IXT IF GE-IXL<=15 GO GE53.

GE8. IF GE-OP=1 WRITE MQ-RECORD ALLOWING NO ELSE REWRITE MQ-RECORD ALLOWING NO.
    UNLOCK MACSCHED.
    DISPLAY "PRINT THIS SCHEDULE ? ___ " LINE 24 BOLD.
    ACCEPT XA3 COLUMN 23 DEFAULT " " UNDERLINED PROTECTED PERFORM DSP-ERS.
    IF XA3 NOT="YES" GO GE88.
    MOVE SYS-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO GE-DT.
    ACCEPT SYS-TIME FROM TIME MOVE SYS-TIME(1:2) TO GE-TH MOVE SYS-TIME(3:2) TO GE-TM.
    READ MACSCHED REGARDLESS ADD 1 TO MQ-REV PERFORM GE-P MOVE GE-PDT TO MQ-PDT.
    REWRITE MQ-RECORD ALLOWING NO UNLOCK MACSCHED.
GE88. GO GE3.
GE9. PERFORM WRT80 CLOSE MACSCHED GO MX9.

GE-R. MOVE R-PROD TO GE-PROD A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO GE-DESC.
    MOVE R-QTY-ORD TO GE-QTY MOVE P-CLEAN TO GE-CLEAN MOVE P-ALERT TO GE-ALERT.
    PERFORM SET-PART MOVE PART-NO TO GE-MAT.
    IF R-COILS=0 PERFORM CALC-NCOILS MOVE A-L1 TO GE-COILS ELSE MOVE R-COILS TO GE-COILS.
GE-D. PERFORM GE-R MOVE " " TO GE-LND MOVE GE-PROD TO GE-LD1 MOVE GE-DESC TO GE-LD2.
    MOVE GE-QTY TO GE-LD3 MOVE GE-MAT TO GE-LD4 MOVE GE-CLEAN TO GE-LD5.
    MOVE GE-COILS TO GE-LD6 MOVE GE-ALERT TO GE-LD7.
GE-P. PERFORM GE-P1 THRU GE-P9.
GE-P1. PERFORM DSP-QWAIT.
    MOVE 4 TO LAS-FLN PERFORM OPEN-LAS PERFORM PCL-INIT PERFORM PCL-START.
    PERFORM PCL-BOLD1 MOVE 0 TO LAS-ROW LAS-COL PERFORM PCL-PCR.
    MOVE "PRODUCTION SHORT SCHEDULE" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM3 MOVE 3 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    MOVE "MACHINE:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-BOLD1 MOVE 5 TO LAS-COL PERFORM PCL-PCR.
    MOVE MQ-MAC TO FJ-N2 PERFORM LASF.
    PERFORM PCL-ITAL1 MOVE 10 TO LAS-COL PERFORM PCL-PCR.
    MOVE GE-MDESC TO LAS-FLD PERFORM LASF.

    PERFORM PCL-NORM3 MOVE 3 TO LAS-ROW MOVE 99 TO LAS-COL PERFORM PCL-PCR.
    MOVE "PRINTED:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-BOLD1 MOVE 65 TO LAS-COL PERFORM PCL-PCR.
    MOVE GE-PDT TO LAS-FLD PERFORM LASF.

    PERFORM PCL-NORM3 MOVE 4 TO LAS-ROW MOVE 99 TO LAS-COL PERFORM PCL-PCR.
    MOVE "REVISION:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-BOLD3 MOVE 109 TO LAS-COL PERFORM PCL-PCR.
    MOVE MQ-REV TO FJ-N2 PERFORM LASF.

    PERFORM PCL-NORM3 MOVE 5 TO LAS-ROW MOVE 99 TO LAS-COL PERFORM PCL-PCR.
    MOVE "SUPERSEDES:" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-BOLD3 MOVE 111 TO LAS-COL PERFORM PCL-PCR.
    MOVE MQ-PDT TO LAS-FLD PERFORM LASF.

    PERFORM PCL-NORM1 MOVE 8 TO LAS-ROW MOVE 0 TO LAS-COL PERFORM PCL-PCR.
    MOVE ALL "_" TO LAS-FLD(1:80) PERFORM LASF.
    PERFORM PCL-BOLD3 ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE "          M.O.      PRODUCT                DESCRIPTION                                                  QA" TO LAS-FLD PERFORM LASF.
    ADD 1 TO LAS-ROW PERFORM PCL-PCR.
    MOVE "                            QTY         MATERIAL             CLEAN     COILS       COMMENTS" TO LAS-FLD PERFORM LASF.
    PERFORM PCL-NORM1 PERFORM PCL-PCR MOVE ALL "_" TO LAS-FLD(1:80) PERFORM LASF.
* note 183
*         ..: ......  ............  ................................  ...
*                    ...,...,...  ............  .  ...:.    ..............................

    PERFORM VARYING A-X2 FROM 15 BY -1 UNTIL A-X2=0 OR MQ-MO(A-X2)>0 CONTINUE END-PERFORM.
    MOVE 1 TO A-X1 ADD 2 TO LAS-ROW MOVE 0 TO LAS-COL.
GE-P3. MOVE " " TO GE-LNP1 GE-LNP2.
    MOVE A-X1 TO GE-LP1 MOVE "." TO GE-LP2 IF MQ-MO(A-X1)=0 GO GE-P4.
    MOVE MQ-MO(A-X1) TO GE-LP3 R-NO READ PRODORD REGARDLESS INVALID GO GE-P4.
    PERFORM GE-R MOVE GE-PROD TO GE-LP4 MOVE GE-DESC TO GE-LP5.
    MOVE GE-ALERT TO GE-LP6 MOVE GE-QTY TO GE-LP7 MOVE GE-MAT TO GE-LP8.
    MOVE GE-CLEAN TO GE-LP9 MOVE GE-COILS TO GE-LP10.
    MOVE MQ-COM(A-X1) TO A-A1 PERFORM STR-LTH IF A-N1>0 MOVE A-A1 TO GE-LP11(31 - A-N1:).
GE-P4. MOVE "`(s10.00h0s3B" TO GE-LX1 GE-LX3 GE-LX5 MOVE "`(s10.00h1s0B" TO GE-LX2 GE-LX4.
    PERFORM PCL-PCR MOVE GE-LNP1 TO LAS-FLD PERFORM LASF.
    ADD 1 TO LAS-ROW PERFORM PCL-PCR MOVE GE-LNP2 TO LAS-FLD PERFORM LASF.
    ADD 1 TO LAS-ROW IF A-X1<=A-X2 PERFORM PCL-NORM1 PERFORM PCL-PCR
      MOVE ALL "_" TO LAS-FLD(1:80) PERFORM LASF.
    ADD 1 TO A-X1 LAS-ROW IF A-X1<=15 GO GE-P3.
    PERFORM PCL-ENDFL PERFORM CLOSE-LAS.
    MOVE "PRINT2" TO LAS-QUEUE PERFORM PRINT-LAS PERFORM DSP-ERS.
GE-P9. EXIT.

* Z-18-24 EMPLOYEE FILE MAINTENANCE
EW1. PERFORM OPEN-EMPL.
EW3. PERFORM RD415 PERFORM WRT.
    ACCEPT EW-NO LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR EW-NO=9999 GO EW9. IF EW-NO=0 PERFORM DSP-ERR20 GO EW3.
    ACCEPT EW-OP LINE 3 COLUMN 44 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF EW-OP=9 GO EW9. IF EW-OP=7 GO EW70.
    GO EW40 EW50 EW60 DEPENDING  EW-OP. PERFORM DSP-ERR9 GO EW3.
EW40. MOVE LOW-VALUES TO E-RECORD INITIALIZE E-REC MOVE WS-PDIV TO E-DIV MOVE EW-NO TO E-NO.
    START EMPL REGARDLESS INVALID GO EW42. PERFORM DSP-ERR58 GO EW3.
EW42. PERFORM RD416 MOVE E-NO TO TF637(3) PERFORM WRT.
    PERFORM EW-MSG1.
    ACCEPT E-NAME LINE 5 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    ACCEPT E-ADD1 LINE 6 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    PERFORM EW-MSG2.
    ACCEPT E-ADD2 LINE 7 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING PERFORM DSP-ERS.
    ACCEPT E-POST LINE 8 COLUMN 16 DEFAULT " " UNDERLINED PROTECTED EDITING.
    WRITE E-RECORD ALLOWING NO UNLOCK EMPL GO EW3.
EW50. MOVE WS-PDIV TO E-DIV MOVE EW-NO TO E-NO.
    READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO EW3.
    PERFORM RD417 MOVE E-NO TO TF638(3) MOVE E-NAME TO TF639(3) PERFORM WRT.
    PERFORM RD417A PERFORM WRT.
EW53. ACCEPT EW-FLD LINE 20 COLUMN 21 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    DISPLAY " " LINE 21 COLUMN 30 ERASE END LINE.
    DISPLAY " " LINE 20 COLUMN 30 ERASE END LINE.
    GO EW551 EW552 EW553 EW554 EW555 EW556 EW557
      DEPENDING EW-FLD. GO EW3.
    REPLACE ==ACC-ALP== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED EDITING==
            ==ACC-NUM== BY ==LINE 21 COLUMN 30 DEFAULT CURRENT UNDERLINED PROTECTED CONVERSION==.
EW551. DISPLAY E-NAME COLUMN 30 BOLD PERFORM EW-MSG1 ACCEPT E-NAME ACC-ALP.
    MOVE E-NAME TO WA1 PERFORM RDLK-EMPL MOVE WA1 TO E-NAME PERFORM DSP-ERS GO EW58.
EW552. DISPLAY E-ADD1 COLUMN 30 BOLD ACCEPT E-ADD1 ACC-ALP.
    MOVE E-ADD1 TO WA1 PERFORM RDLK-EMPL MOVE WA1 TO E-ADD1 GO EW58.
EW553. DISPLAY E-ADD2 COLUMN 30 BOLD PERFORM EW-MSG2 ACCEPT E-ADD2 ACC-ALP.
    MOVE E-ADD2 TO WA1 PERFORM RDLK-EMPL MOVE WA1 TO E-ADD2 PERFORM DSP-ERS GO EW58.
EW554. DISPLAY E-POST COLUMN 30 BOLD ACCEPT E-POST ACC-ALP.
    MOVE E-POST TO WA1 PERFORM RDLK-EMPL MOVE WA1 TO E-POST GO EW58.
EW555. DISPLAY E-DEPT COLUMN 30 CONVERSION BOLD ACCEPT E-DEPT ACC-NUM.
    MOVE E-DEPT TO WN1 PERFORM RDLK-EMPL MOVE WN1 TO E-DEPT GO EW58.
EW556. DISPLAY E-SECT COLUMN 30 CONVERSION BOLD ACCEPT E-SECT ACC-NUM.
    MOVE E-SECT TO WN1 PERFORM RDLK-EMPL MOVE WN1 TO E-SECT GO EW58.
EW557. DISPLAY E-DEL COLUMN 30 CONVERSION BOLD ACCEPT E-DEL ACC-NUM.
    MOVE E-DEL TO WN1 PERFORM RDLK-EMPL MOVE WN1 TO E-DEL GO EW58.
EW58. REWRITE E-RECORD ALLOWING NO UNLOCK EMPL GO EW53.
    REPLACE OFF.
EW60. MOVE WS-PDIV TO E-DIV MOVE EW-NO TO E-NO.
    READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO EW3.
    DISPLAY E-NAME LINE 5 COLUMN 13.
    IF E-NAME=" " DELETE EMPL ELSE PERFORM DSP-ERR59. GO EW3.
EW70. MOVE WS-PDIV TO E-DIV MOVE EW-NO TO E-NO.
    READ EMPL REGARDLESS INVALID PERFORM DSP-ERR20 GO EW3.
    MOVE EW-NO TO EW-ONO DISPLAY E-NAME LINE 5 COLUMN 13.
    DISPLAY "   NEW NO.  ____" LINE 4 BOLD.
EW73. DISPLAY "TO LEAVE EMPL. NO. UNCHANGED, LEAVE 'NEW NO.' BLANK" LINE 24 BOLD.
    ACCEPT EW-NO LINE 4 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION PERFORM DSP-ERS.
    IF EW-NO=0 GO EW3. MOVE WS-PDIV TO E-DIV MOVE EW-NO TO E-NO.
    START EMPL REGARDLESS INVALID GO EW74. PERFORM DSP-ERR58 GO EW73.
EW74. MOVE WS-PDIV TO E-DIV MOVE EW-ONO TO E-NO DELETE EMPL.
    MOVE EW-NO TO E-NO WRITE E-RECORD ALLOWING NO UNLOCK EMPL GO EW3.
EW9. CLOSE EMPL GO MX9.
EW-MSG1. DISPLAY "ENTER NAME AS: LAST, COMMA, SPACE, FIRST, SPACE, MIDDLE OR INITIAL(S)" LINE 24 BOLD.
EW-MSG2. DISPLAY "ENTER ADDRESS AS: CITY, COMMA, PROVINCE" LINE 24 BOLD.

* Z-19: RAW MATERIALS FUNCTIONS

* Z-19-1 MATERIAL RUN-OUT REPORT
RA1. PERFORM RD76 PERFORM WRT IF S-BAT GO RA2.
    MOVE 3 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RA2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO RA29.
RA23. READ PRODORD NEXT REGARDLESS END GO RA29.
    IF R-ALLOC>0 OR R-QTY-ORD=0 OR R-QTY-PROD NOT=0 GO RA28.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO RA28. IF P-MAC=99 GO RA28.
    PERFORM INIT-RP MOVE P-DIAM TO RP-F92 MOVE P-GRADE TO RP-F93.
    IF R-LDATE(1)=0 MOVE R-DATE TO RA-MDATE
      ELSE IF R-LDATE(1)<R-DATE MOVE R-LDATE(1) TO RA-MDATE ELSE MOVE R-DATE TO RA-MDATE.
    MOVE RA-MDATE TO RP-F94 MOVE R-KEY TO RP-F95 WRITE RP-RECORD.
RA28. MOVE 0 TO R-LMAT R-LPROC R-LDATE(2) REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
* note 33.1
    GO RA23.
RA29. PERFORM OPEN-PR PERFORM RA-PAGE.
    MOVE LOW-VALUES TO RA-STOTALS RA-GTOTALS MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RA9.
RA3. READ REPFL NEXT END GO RA9.
    MOVE " " TO RA-MAT STRING RP-F92 "-" RP-F93 DELIMITED " " INTO RA-MAT.
    IF RA-MAT=OLD-A GO RA4.
    IF OLD-A>" " IF RA-LSTEP<2 MOVE " " TO PREC ELSE PERFORM RA-SUB.
    MOVE RP-F92 TO RA-DIAM MOVE RP-F93 TO RA-GRADE.
* note 36.2
    MOVE 2 TO WS-PR.
    MOVE 0 TO RA-LSTEP RA-RDATE RA-KPUR RA-IXP RA-QNUM RA-QDT1 RA-QDT2.
    PERFORM INIT-PH MOVE RA-MAT TO PH-NO OLD-A FF259.
    READ PART REGARDLESS INVALID MOVE "*** NO PART RECORD ***" TO FF260
      PERFORM RA-LINE 2 TIMES MOVE 2 TO RA-LSTEP. PERFORM PART-TYPE.
    MOVE PH-HAND TO RA-TOT RA-TOTP SUBTRACT PH-PROC-HAND(1) FROM RA-TOTP.
RA4. MOVE RP-F95 TO R-KEY READ PRODORD REGARDLESS MOVE RP-F94 TO RA-MDATE.
    MOVE R-PROD TO A-A1 PERFORM PROD-RGD.
    MOVE R-QTY-ORD TO A-N1 PERFORM CALC-GWEIGHT MOVE A-N1 TO RA-WEIGHT.
    SUBTRACT RA-WEIGHT FROM RA-TOT RA-TOTP MOVE 0 TO WS1.
    IF RA-LSTEP>0 OR RA-LSTEP=0 AND RA-TOT<0 MOVE 1 TO R-LMAT WS1.
    IF RA-LSTEP>0 OR RA-LSTEP=0 AND RA-TOTP<0 MOVE 1 TO R-LPROC WS1.
    IF WS1=1 REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    IF RA-LSTEP<2 AND RA-TOT>=0 GO RA3.

    IF RA-LSTEP=0 GO RA50. IF RA-LSTEP=1 GO RA6.
* lstep=2
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>RA-IXP
      IF RA-PDATE(IX1)>0 AND<=RA-MDATE ADD RA-PQTY(IX1) TO RA-TOT
        MOVE 0 TO RA-PDATE(IX1) END-IF END-PERFORM.
    GO RA8.

RA50. MOVE 1 TO RA-LSTEP MOVE 0 TO RA-MILL-DATE.
    MOVE " " TO ML-KEY START MILL KEY>ML-KEY REGARDLESS INVALID GO RA58.
RA53. READ MILL NEXT REGARDLESS END GO RA58.
    IF NOT(ML-STATUS=0 AND ML-DIAM=RA-DIAM) GO RA53. MOVE 0 TO IX1.
RA55. ADD 1 TO IX1 IF IX1>ML-GNUM GO RA56.
    IF ML-GRADE(IX1)=RA-GRADE MOVE ML-CYCLE TO RA-MILL-CYCLE
      COMPUTE RA-MILL-DATE=ML-DATE + 15 GO RA58.
    GO RA55.
RA56. GO RA53.
RA58. MOVE RA-MILL-DATE TO A-N1 PERFORM FIND-PO-LATE.

    MOVE PH-NO TO LK-PART MOVE 0 TO LK-DATE-REQ.
    START PURLIN KEY>=LK-KP REGARDLESS INVALID GO RA64.
RA6.
RA63. READ PURLIN NEXT REGARDLESS END GO RA64. IF LK-PART NOT=PH-NO GO RA64.
    IF LK-BLANKET=1 GO RA63. PERFORM CALC-LKQTY IF A-T1<=0 GO RA63.
    IF LK-DATE-TMP>RA-MDATE MOVE 1 TO RA-KPUR GO RA64.
    ADD A-T1 TO RA-TOT ROUNDED IF RA-TOT<0 GO RA63.
    GO RA3.
RA64. IF -RA-TOT<=0.25 * RA-WEIGHT MOVE 0 TO RA-TOT
       IF RA-KPUR=1 MOVE 0 TO RA-KPUR START PURLIN KEY=LK-KP REGARDLESS END-IF
       GO RA3.
* note 67.1
    MOVE 2 TO RA-LSTEP MOVE "RUN-OUT:" TO FF261.
    MOVE RA-MDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF262.
    MOVE "MAT AVL:" TO FF263.
    IF RA-KPUR=0
      IF RA-MILL-DATE>0 MOVE RA-MILL-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF264
        MOVE "CYCLE:" TO FF265 MOVE RA-MILL-CYCLE TO FF266
        MOVE RA-MILL-DATE TO RA-RDATE END-IF
      PERFORM RA-LINE 2 TIMES GO RA8.

    MOVE LK-DATE-TMP TO RA-RDATE MOVE 0 TO RA-KFIR.
RA65. MOVE LK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FF264.
    IF RA-KFIR=0 MOVE " P.O.:" TO FF265 MOVE "WEIGHT:" TO FF267.
    PERFORM CALC-LKQTY MOVE LK-ORD TO FF266 COMPUTE FF268 ROUNDED=A-T1.
    IF LK-DATE-TMP NOT=LK-DATE-REQ MOVE "LATE" TO FF268A.
    PERFORM RA-LINE MOVE 1 TO RA-KFIR.
    IF RA-IXP<10 ADD 1 TO RA-IXP MOVE LK-DATE-REQ TO RA-PDATE(RA-IXP)
      COMPUTE RA-PQTY(RA-IXP) ROUNDED=A-T1.
RA67. READ PURLIN NEXT REGARDLESS END GO RA68. IF LK-PART NOT=PH-NO GO RA68.
    IF LK-BLANKET=1 GO RA67. PERFORM CALC-LKQTY IF A-T1<=0 GO RA67. GO RA65.
RA68. PERFORM RA-LINE.

RA8. IF TOT-IND=1 OR RA-LSTEP=2 AND (RA-MILL-DATE>0 AND<RA-MDATE) GO RA84.
    IF RA-TOT>0 ADD 1 TO RA-QNUM
      IF RA-QDT1=0 MOVE RA-MDATE TO RA-QDT1 END-IF
      IF RA-QDT2=0 MOVE RA-MDATE TO RA-QDT2 END-IF
      IF RA-MDATE<RA-QDT1 MOVE RA-MDATE TO RA-QDT1 END-IF
      IF RA-MDATE>RA-QDT2 MOVE RA-MDATE TO RA-QDT2 END-IF
     ELSE IF RA-QNUM>0 PERFORM RA-Q END-IF
      ADD R-QTY-ORD TO RA-STOT(1) RA-GTOT(1) ADD RA-WEIGHT TO RA-STOT(2) RA-GTOT(2)
      MOVE R-NO TO FF250 MOVE R-PROD TO FF251 MOVE PRO-DESC(1) TO FF252
      MOVE RA-MDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF253
      MOVE R-QTY-ORD TO FF255 MOVE RA-WEIGHT TO FF256 COMPUTE FF257=-RA-TOT PERFORM RA-LINE.
RA84. MOVE RA-RDATE TO R-LDATE(2) REWRITE R-RECORD ALLOWING NO UNLOCK PRODORD.
    GO RA3.
RA9. PERFORM RA-SUB MOVE 3 TO WS-PR MOVE "** GRAND TOTALS" TO FF252.
    MOVE RA-GTOT(1) TO FF255 MOVE RA-GTOT(2) TO FF256 MOVE "**" TO FF256A PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

RA-SUB. IF TOT-IND=0 AND RA-QNUM>0 PERFORM RA-Q.
    MOVE 2 TO WS-PR MOVE "** GRADE TOTALS" TO FF252.
    MOVE RA-STOT(1) TO FF255 MOVE RA-STOT(2) TO FF256 MOVE "**" TO FF256A.
    PERFORM RA-LINE 2 TIMES MOVE LOW-VALUES TO RA-STOTALS.
RA-Q. MOVE "NO SHORTAGE FOR" TO FF222 MOVE RA-QNUM TO FF223.
    IF RA-QNUM=1 MOVE " ORDER" TO FF224 ELSE MOVE " ORDERS" TO FF224.
    MOVE RA-QDT1 TO D-DATE PERFORM D-NM MOVE D-DT TO FF225.
    IF RA-QDT2 NOT=RA-QDT1 MOVE "-" TO FF226
      MOVE RA-QDT2 TO D-DATE PERFORM D-NM MOVE D-DT TO FF227.
    PERFORM RA-LINE MOVE 0 TO RA-QNUM RA-QDT1 RA-QDT2.
RA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RA-PAGE.
RA-PAGE. MOVE "MATERIAL RUN-OUT REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "  M.O.  PRODUCT                                        START DATE      QTY        WEIGHT   CUM. SHORTAGE" TO PREC PERFORM PR-LINE-3.
*         ......  ............  ................................  ../../.. ...,...,...- ..,...,...-..  ..,...,...-
*         ...........    .........................
*                         RUN-OUT: ../../..    MAT AVL: ../../..     P.O.: ........   WEIGHT: ...,...  ....
*                                   NO SHORTAGE FOR ... ORDERS    ../../.. - ../../..

* Z-19-2 STOCK TRANSACTIONS REPORT
RH1. PERFORM RD78 PERFORM WRT IF S-BAT MOVE S-S1 TO RH-KBIN GO RH2.
    ACCEPT XA3 LINE 3 COLUMN 17 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO RH-KBIN ELSE MOVE 0 TO RH-KBIN.
    MOVE 5 TO IXT MOVE 13 TO IXU MOVE 42 TO IXV PERFORM AX-PART-R.
    MOVE 6 TO IXT MOVE 13 TO IXU MOVE 42 TO IXV PERFORM AX-PBIN-R.
    MOVE 7 TO IXT MOVE 13 TO IXU MOVE 42 TO IXV PERFORM AX-DATE-R.
    MOVE 9 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE RH-KBIN TO S-S1 GO MX9.
RH2. PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE PT-KEY MOVE PART1 TO PT-PART.
    START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO RH29.
RH23. READ PARTRANS NEXT REGARDLESS END GO RH29. IF PT-PART>PART2 GO RH29.
    IF PT-FBIN>" " AND PT-FBIN>=PBIN1 AND<=PBIN2 GO RH24.
    IF PT-TBIN>" " AND PT-TBIN>=PBIN1 AND<=PBIN2 GO RH24. GO RH23.
RH24. IF NOT(PT-DATE>=DATE1 AND<=DATE2) GO RH23. PERFORM INIT-RP.
    IF RH-KBIN=0 MOVE PT-PART TO RP-F89
      ELSE IF PT-FBIN>" " MOVE PT-FBIN TO RP-F89 ELSE MOVE PT-TBIN TO RP-F89.
    MOVE PT-DATE TO RP-F90 MOVE PT-KEY TO RP-F91 WRITE RP-RECORD GO RH23.
RH29. PERFORM OPEN-PR PERFORM RH-PAGE.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RH9.
RH3. READ REPFL NEXT END GO RH9. MOVE RP-F91 TO PT-KEY READ PARTRANS REGARDLESS.
    MOVE PT-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF269.
    MOVE PT-TRANS TO FF270 MOVE PT-PART TO FF271 MOVE PT-FBIN TO FF272.
    MOVE PT-TBIN TO FF273 MOVE PT-QTY TO FF274 MOVE PT-PCODE TO FF277.
    MOVE PT-COILS TO FF278 MOVE PT-CWEIGHT TO FF279 MOVE PT-HEAT TO FF280.
    PERFORM RH-LINE GO RH3.
RH9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

RH-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RH-PAGE.
RH-PAGE. MOVE "STOCK TRANSACTIONS REPORT" TO FF3.
    IF RH-KBIN=0 MOVE "** BY PART **" TO FF4
      ELSE MOVE "** BY BIN **" TO FF4.
    PERFORM PR-PAGE MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR PERFORM PRANGE-PART MOVE 1 TO WS-PR PERFORM PRANGE-PBIN.
    MOVE "  DATE  TRANS PART NO.     FROM     TO            QTY               PRO COILS  WEIGHT  HEAT" TO PREC PERFORM PR-LINE-3.
*         ../../.. ...  ............ ........ ........ .,...,...-              .  ...-    .,...  ..........

* Z-19-3 MATERIAL DEMAND REPORT
RQ1. PERFORM RD386 PERFORM WRT IF S-BAT MOVE S-S1 TO RQ-KSP GO RQ2.
    ACCEPT XA3 LINE 3 COLUMN 22 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO RQ-KSP ELSE MOVE 0 TO RQ-KSP.
    MOVE 4 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE RQ-KSP TO S-S1 GO MX9.
RQ2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO RQ29.
RQ23. READ PRODUCT NEXT REGARDLESS END GO RQ29.
    IF P-CAT>60 OR RQ-KSP=0 AND P-CAT>21 GO RQ23. PERFORM INIT-RP.
    PERFORM SET-PART MOVE PART-NO TO RP-F57.
    MOVE P-PROC TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO RP-F58.
    MOVE P-WIRE TO RP-F59 MOVE P-NO TO RP-F60 WRITE RP-RECORD GO RQ23.
RQ29. PERFORM OPEN-PR PERFORM RQ-PAGE.
    IF TOT-IND=0 MOVE 2 TO RQ-LN ELSE MOVE 1 TO RQ-LN.
    MOVE 0 TO RQ-WWEIGHT RQ-PWEIGHT RQ-MWEIGHT RQ-GWEIGHT RQ-KPR.
    MOVE " " TO OLD-A MOVE -1 TO OLD-N OLD-V.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RQ9.
RQ3. READ REPFL NEXT END GO RQ9. IF RP-F57=OLD-A GO RQ34.
    IF OLD-A>" " PERFORM RQ-W PERFORM RQ-P PERFORM RQ-M.
    MOVE RP-F57 TO OLD-A MOVE -1 TO OLD-N OLD-V.
RQ34. IF RP-F58=OLD-N GO RQ36. IF OLD-N NOT=-1 PERFORM RQ-W PERFORM RQ-P.
    MOVE RP-F58 TO OLD-N MOVE -1 TO OLD-V.
RQ36. IF RP-F59=OLD-V GO RQ4. IF OLD-V NOT=-1 PERFORM RQ-W. MOVE RP-F59 TO OLD-V.
RQ4. MOVE RP-F60 TO FD10 A-A1 PERFORM PROD-RD MOVE PRO-DESC(1) TO FD11.
    MOVE P-DIAM TO FD12 MOVE P-GRADE TO FD13 MOVE P-PROC TO FD14.
    MOVE P-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FD15.
    MOVE P-ROP TO FD16 A-N1 PERFORM CALC-GWEIGHT MOVE A-N1 TO FD17.
    ADD A-N1 TO RQ-WWEIGHT RQ-PWEIGHT RQ-MWEIGHT RQ-GWEIGHT.
    IF TOT-IND=0 PERFORM RQ-LINE
     ELSE IF RQ-KPR=0 MOVE " " TO PREC(1:48) PREC(76:) PERFORM RQ-LINE MOVE 1 TO RQ-KPR
      ELSE MOVE " " TO PREC.
    GO RQ3.
RQ9. PERFORM RQ-W PERFORM RQ-P PERFORM RQ-M.
    MOVE "*** GRAND TOTAL" TO FD11 MOVE RQ-GWEIGHT TO FD17 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

RQ-W. MOVE "  * WIRE TOTAL" TO FD11.
    MOVE RQ-WWEIGHT TO FD17 PERFORM RQ-LINE RQ-LN TIMES MOVE 0 TO RQ-WWEIGHT RQ-KPR.
RQ-P. MOVE " ** PROCESS TOTAL" TO FD11.
    MOVE RQ-PWEIGHT TO FD17 PERFORM RQ-LINE RQ-LN TIMES MOVE 0 TO RQ-PWEIGHT.
RQ-M. MOVE "*** MATERIAL TOTAL" TO FD11.
    MOVE RQ-MWEIGHT TO FD17 PERFORM RQ-LINE RQ-LN TIMES PERFORM RQ-LINE MOVE 0 TO RQ-MWEIGHT.
RQ-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RQ-PAGE.
RQ-PAGE. MOVE "MATERIAL DEMAND REPORT" TO FF3.
    IF RQ-KSP=0 MOVE "** EXCLUDING SPECIALS **" TO FF4
      ELSE MOVE "** INCLUDING SPECIALS **" TO FF4.
    PERFORM PR-PAGE.
    MOVE "PRODUCT       DESCRIPTION                       DIAM.  GRADE   PROC  WIRE       R.O.P.     WEIGHT" TO PREC PERFORM PR-LINE-3.
*         ............  ................................  ...... ........  .   ......  .,...,...  .,...,...
*                       ..................                ...... ........  .   ......

* Z-19-4 MATERIAL REQUIREMENTS REPORT
RT1. PERFORM RD387 PERFORM WRT IF S-BAT GO RT2.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 48 TO IXV PERFORM AX-MAT-R.
    MOVE 5 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RT2. PERFORM DSP-WAIT PERFORM SET-SHORT-SCHED PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO RT29.
RT23. READ PRODORD NEXT REGARDLESS END GO RT29.
    IF R-FIN=1 OR R-QTY-ORD<=R-QTY-PROD OR R-ALLOC>0 GO RT23.
    MOVE R-PROD TO A-A1 PERFORM PROD-GEN IF P-MAC=99 GO RT23.
    PERFORM SET-PART IF NOT(PART-NO>=MAT1 AND<=MAT2) GO RT23.
    PERFORM INIT-RP MOVE PART-NO TO RP-F387.
    MOVE P-PROC TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO RP-F388.
    MOVE P-WIRE TO RP-F389.
* note 191.3
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL XM-F6(IX1)=0
      IF R-NO=XM-F8(IX1) MOVE 0 TO RP-F390
        MOVE XM-F7(IX1) TO RP-F391 MOVE 0 TO RP-F392 GO RT26 END-IF END-PERFORM.
    MOVE 1 TO RP-F390 MOVE 0 TO RP-F391 MOVE R-DATE TO RP-F392.
RT26. MOVE R-PROD TO RP-F393 MOVE R-KEY TO RP-F394 WRITE RP-RECORD GO RT23.
RT29. PERFORM OPEN-PR PERFORM RT-PAGE.
    IF TOT-IND=0 MOVE 2 TO RT-LN ELSE MOVE 1 TO RT-LN.
    MOVE LOW-VALUES TO RT-WTOTALS RT-PTOTALS RT-MTOTALS RT-GTOTALS.
    MOVE " " TO OLD-A MOVE -1 TO OLD-N OLD-V.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RT9.
RT3. READ REPFL NEXT END GO RT9. MOVE RP-F394 TO R-KEY READ PRODORD REGARDLESS.
    IF RP-F387=OLD-A GO RT34.
    IF OLD-A>" " PERFORM RT-W PERFORM RT-P PERFORM RT-M
      IF TOT-IND=0 PERFORM RT-PAGE ELSE PERFORM RT-LINE 2 TIMES.
    MOVE RP-F387 TO OLD-A MOVE -1 TO OLD-N OLD-V.
    MOVE "MATERIAL:" TO FD203 MOVE OLD-A TO FD204 PERFORM RT-LINE RT-LN TIMES.
RT34. IF RP-F388=OLD-N GO RT36. IF OLD-N NOT=-1 PERFORM RT-W PERFORM RT-P.
    MOVE RP-F388 TO OLD-N MOVE -1 TO OLD-V.
RT36. IF RP-F389=OLD-V GO RT4. IF OLD-V NOT=-1 PERFORM RT-W. MOVE RP-F389 TO OLD-V.
RT4. MOVE R-PROD TO A-A1 PERFORM PROD-GEN.
    MOVE P-CAT TO FD205 MOVE P-NO TO FD206 MOVE P-PROC TO FD207.
    IF P-PROC=4 MOVE P-WIRE TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FD208.
    MOVE R-NO TO FD209 IF RP-F390=0 MOVE "*" TO FD209A.
    COMPUTE RT-LEFT=R-QTY-ORD - R-QTY-PROD.
    MOVE R-QTY-ORD TO FD210(1) MOVE R-QTY-PROD TO FD210(2) MOVE RT-LEFT TO FD210(3).
    MOVE R-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD212.
    MOVE R-DATE TO D-DATE PERFORM D-CURR COMPUTE IX1=D-N1 + 1.
    IF IX1<1 MOVE 1 TO IX1. IF IX1>4 MOVE 4 TO IX1.
    MOVE RT-LEFT TO A-N1 PERFORM CALC-GWEIGHT MOVE A-N1 TO FD213(IX1).
    ADD A-N1 TO RT-WTOT(IX1) RT-PTOT(IX1) RT-MTOT(IX1) RT-GTOT(IX1).
    IF TOT-IND=0 PERFORM RT-LINE ELSE MOVE " " TO PREC. GO RT3.
RT9. PERFORM RT-W PERFORM RT-P PERFORM RT-M.
    MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE RT-GTOT(IX1) TO FD213(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

RT-W. IF OLD-N=4 MOVE "  * WIRE TOTALS" TO PREC
       IF TOT-IND=1 MOVE OLD-V TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FD208 END-IF
       PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE RT-WTOT(IX1) TO FD213(IX1) END-PERFORM
       PERFORM RT-LINE RT-LN TIMES.
    MOVE LOW-VALUES TO RT-WTOTALS.
RT-P. MOVE " ** PROCESS TOTALS" TO PREC IF TOT-IND=1 MOVE OLD-N TO FD207.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE RT-PTOT(IX1) TO FD213(IX1) END-PERFORM.
    PERFORM RT-LINE RT-LN TIMES MOVE LOW-VALUES TO RT-PTOTALS.
RT-M. MOVE "*** MATERIAL TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE RT-MTOT(IX1) TO FD213(IX1) END-PERFORM.
    PERFORM RT-LINE MOVE LOW-VALUES TO RT-MTOTALS.
RT-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RT-PAGE.
RT-PAGE. MOVE "MATERIAL REQUIREMENTS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-MAT.
    MOVE "CAT PRODUCT       PROC  WIRE      M.O. S/S   ORDERED   PRODUCED      LEFT   DATE REQ     CURRENT    FUTURE 1    FUTURE 2    FUTURE 3" TO PREC PERFORM PR-LINE-3.
*         .. ............     .   ......  ......  .  .,...,...  .,...,...  .,...,...  ../../..  ..,...,...  ..,...,...  ..,...,...  ..,...,...

* Z-19-5 CALCULATE ROLLING MILL ORDERS
RC1. PERFORM RD74 PERFORM WRT IF S-BAT GO RC2.
    MOVE 3 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RC2. PERFORM DSP-WAIT.
    MOVE " " TO ML-KEY START MILL KEY>ML-KEY REGARDLESS INVALID GO RC24.
RC23. READ MILL NEXT REGARDLESS END GO RC24.
    MOVE 0 TO ML-WEI-REQ ML-GNUM MULTIPLY 2000 BY ML-WEI-MAX.
    REWRITE ML-RECORD ALLOWING NO UNLOCK MILL GO RC23.
RC24.
* note 136.1
    PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO RC29.
RC25. READ PRODORD NEXT REGARDLESS END GO RC29.
    IF R-FIN=1 OR R-QTY-ORD<=R-QTY-PROD OR R-ALLOC>0 GO RC25.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO RC25. IF P-MAC=99 GO RC25.
    PERFORM INIT-RP PERFORM SET-PART MOVE PART-NO TO RP-F320.
    COMPUTE RP-F321=999999 - R-DATE MOVE R-NO TO RP-F322.
    COMPUTE A-N1=R-QTY-ORD - R-QTY-PROD PERFORM CALC-GWEIGHT MOVE A-N1 TO RP-F323.
    WRITE RP-RECORD GO RC25.
RC29.

    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO RC8.
RC3. READ PART NEXT REGARDLESS END GO RC8. PERFORM PART-TYPE IF NOT PART-MAT GO RC3.
    COMPUTE RC-PWEI ROUNDED=PH-DEMAND + PH-ROP / 3 - PH-HAND - PH-ORDER.
    IF RC-PWEI<=0 GO RC3. UNSTRING PH-NO DELIMITED "-" INTO RC-DIAM RC-GRADE.
    MOVE " " TO RP-KEY MOVE PH-NO TO RP-F320.
    START REPFL KEY>RP-KEY INVALID GO RC6.
RC5. READ REPFL NEXT END GO RC6. IF RP-F320>PH-NO GO RC6.
    COMPUTE RC-MDATE=999999 - RP-F321 MOVE RP-F323 TO RC-MWEI.
    MOVE RC-DIAM TO ML-KDIAM MOVE 0 TO ML-ZDATE.
    START MILL KEY>ML-KD REGARDLESS INVALID GO RC58.
RC53. READ MILL NEXT REGARDLESS END GO RC58.
    IF ML-DIAM>RC-DIAM OR ML-DATE + 15<SYS-DATE GO RC58.
    IF ML-STATUS>0 OR ML-DATE + 15>RC-MDATE GO RC53.
    IF ML-WEI-MAX=0 MOVE 0 TO RC-LWEI GO RC54. IF ML-WEI-REQ>=ML-WEI-MAX GO RC53.
    COMPUTE RC-LWEI=RC-MWEI - (ML-WEI-MAX - ML-WEI-REQ).
    IF RC-LWEI>0 SUBTRACT RC-LWEI FROM RC-MWEI ELSE MOVE 0 TO RC-LWEI.
RC54. PERFORM RC-W IF A-S1=1 GO RC56.
    SUBTRACT RC-MWEI FROM RC-PWEI IF RC-PWEI<0 MOVE 0 TO RC-PWEI.
    ADD RC-MWEI TO ML-WEI-REQ REWRITE ML-RECORD ALLOWING NO UNLOCK MILL.
    IF RC-LWEI=0 GO RC58. MOVE RC-LWEI TO RC-MWEI.
RC56. GO RC53.
RC58. IF RC-PWEI>0 GO RC5.
RC6.

* note 136.2
    IF RC-PWEI=0 GO RC78. MOVE RC-PWEI TO RC-MWEI.
    MOVE " " TO ML-KEY START MILL KEY>ML-KEY REGARDLESS INVALID GO RC78.
RC73. READ MILL NEXT REGARDLESS END GO RC78.
    IF NOT(ML-STATUS=0 AND ML-DIAM=RC-DIAM AND ML-DATE + 15>=SYS-DATE) GO RC73.
    IF ML-WEI-MAX=0 MOVE 0 TO RC-LWEI GO RC74. IF ML-WEI-REQ>=ML-WEI-MAX GO RC73.
    COMPUTE RC-LWEI=RC-MWEI - (ML-WEI-MAX - ML-WEI-REQ).
    IF RC-LWEI>0 SUBTRACT RC-LWEI FROM RC-MWEI ELSE MOVE 0 TO RC-LWEI.
RC74. PERFORM RC-W IF A-S1=1 GO RC78.
    ADD RC-MWEI TO ML-WEI-REQ REWRITE ML-RECORD ALLOWING NO UNLOCK MILL.
    IF RC-LWEI>0 MOVE RC-LWEI TO RC-MWEI GO RC73.
RC78. GO RC3.
RC8. PERFORM CLOSE-REP.

    MOVE " " TO ML-KEY START MILL KEY>ML-KEY REGARDLESS INVALID GO RC89.
RC83. READ MILL NEXT REGARDLESS END GO RC89. MOVE 0 TO ML-WEI-REQ IX1.
RC85. ADD 1 TO IX1 IF IX1>ML-GNUM GO RC86.
    DIVIDE ML-WEI(IX1) BY 2000 GIVING WN1 REMAINDER WN2 IF WN2>0 ADD 1 TO WN1.
    MOVE WN1 TO ML-WEI(IX1) ADD WN1 TO ML-WEI-REQ GO RC85.
RC86. DIVIDE 2000 INTO ML-WEI-MAX ROUNDED.
    REWRITE ML-RECORD ALLOWING NO UNLOCK MILL GO RC83.
RC89.
RC9. GO MX9.

RC-W. PERFORM RC-W1 THRU RC-W9.
RC-W1. MOVE 0 TO A-S1 A-X1.
RC-W3. ADD 1 TO A-X1 IF A-X1>10 MOVE 1 TO A-S1 GO RC-W9.
    IF A-X1>ML-GNUM MOVE A-X1 TO ML-GNUM
      MOVE RC-GRADE TO ML-GRADE(A-X1) MOVE RC-MWEI TO ML-WEI(A-X1) GO RC-W9.
    IF RC-GRADE=ML-GRADE(A-X1) ADD RC-MWEI TO ML-WEI(A-X1) GO RC-W9. GO RC-W3.
RC-W9. EXIT.

* Z-19-6 ROLLING MILL TABLE LISTING
RB1. PERFORM RD75 PERFORM WRT IF S-BAT GO RB2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RB2. PERFORM DSP-WAIT PERFORM OPEN-SORT PERFORM OPEN-PR PERFORM RB-PAGE.
    MOVE " " TO ML-KEY START MILL KEY>ML-KEY REGARDLESS INVALID GO RB8.
RB3. READ MILL NEXT REGARDLESS END GO RB8.
    MOVE ML-CYCLE TO FF240 MOVE ML-DIAM TO FF241 MOVE ML-STATUS TO FF242.
    MOVE ML-WEI-MAX TO FF243 MOVE ML-WEI-REQ TO FF244.
    MOVE ML-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FF245.
    COMPUTE D-DATE=ML-DATE + 15 PERFORM D-NM MOVE D-DT TO FF246.
    IF ML-GNUM=0 PERFORM RB-LINE GO RB3. MOVE 1 TO IX1 PR-IXP.
RB5. IF IX1>ML-GNUM GO RB6. IF PR-IXP>4 PERFORM PR-LINE MOVE 1 TO PR-IXP.
    MOVE ML-GRADE(IX1) TO FF247(PR-IXP) MOVE ":" TO FF247A(PR-IXP).
    MOVE ML-WEI(IX1) TO FF247B(PR-IXP).
    PERFORM INIT-SR MOVE ML-GRADE(IX1) TO SR-F1 MOVE ML-WEI(IX1) TO SR-F2.
    WRITE SR-RECORD INVALID READ SORTFL ADD ML-WEI(IX1) TO SR-F2 REWRITE SR-RECORD.
    ADD 1 TO IX1 PR-IXP GO RB5.
RB6. IF PR-IXP>1 PERFORM RB-LINE. GO RB3.
RB8. MOVE 4 TO WS-PR MOVE "GRADE TOTALS" TO PREC PERFORM RB-LINE MOVE 0 TO WN1.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO RB88.
RB83. READ SORTFL NEXT END GO RB88.
    MOVE SR-F1 TO FF249 MOVE SR-F2 TO FF249A ADD SR-F2 TO WN1.
    PERFORM RB-LINE GO RB83.
RB88. MOVE 2 TO WS-PR MOVE "** TOTAL" TO FF249 MOVE WN1 TO FF249A PERFORM PR-LINE.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR.
RB9. GO MX9.

RB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RB-PAGE.
RB-PAGE. MOVE "ROLLING MILL TABLE LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE "CYCLE DIAM.  STAT  MAX QTY  REQ QTY  ROL DATE  AVL DATE     GRADE:QTY" TO PREC PERFORM PR-LINE-3.
*         ....  ......  .     .....    .....   ../../..  ../../..     .....:.....     .....:..... x4

* Z-19-7 PRODUCT LISTING BY CLEANING CODE
RW1. PERFORM RD411 PERFORM WRT IF S-BAT GO RW2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RW2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO P-NO START PRODUCT KEY>P-KEY REGARDLESS INVALID GO RW29.
RW23. READ PRODUCT NEXT REGARDLESS END GO RW29.
    IF P-GEN>" " OR P-CAT>=65 OR P-MAC=99 OR P-CLEAN=0 AND P-PROC=4 GO RW23.
    PERFORM INIT-RP MOVE P-CLEAN TO RP-F246 MOVE P-NO TO RP-F247.
    WRITE RP-RECORD GO RW23.
RW29. PERFORM OPEN-PR PERFORM RW-PAGE MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RW9.
RW3. READ REPFL NEXT END GO RW9. IF RP-F246=OLD-N GO RW34.
    IF OLD-N NOT=-1 IF PR-IXP>1 PERFORM RW-LINE END-IF PERFORM RW-LINE 2 TIMES.
    MOVE RP-F246 TO OLD-N.
    MOVE "CLEANING CODE" TO FA391 MOVE OLD-N TO FA392 PERFORM RW-LINE 2 TIMES.
    MOVE 1 TO PR-IXP.
RW34. MOVE RP-F247 TO FA393(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>8 PERFORM RW-LINE MOVE 1 TO PR-IXP. GO RW3.
RW9. PERFORM PR-LASTLN.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

RW-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RW-PAGE.
RW-PAGE. MOVE "PRODUCT LISTING BY CLEANING CODE" TO FF3 PERFORM PR-PAGE.
    PERFORM PR-LINE.

* Z-19-8 HEAT LOCATION REPORT
RF1. PERFORM RD321 PERFORM WRT IF S-BAT GO RF2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 40 TO IXV PERFORM AX-HEAT-R.
    MOVE SYS-DATE TO D-DATE MOVE 5 TO IXT MOVE 33 TO IXU PERFORM AX-DT-DEF.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RF2. PERFORM DSP-WAIT PERFORM RDR-INFO PERFORM OPEN-REP.
    MOVE " " TO BH-KEY START PURBIN KEY>BH-KEY REGARDLESS INVALID GO RF29.
RF23. READ PURBIN NEXT REGARDLESS END GO RF29.
    IF BH-NO(1:2)="SQ" OR NOT(BH-HEAT>=HEAT1 AND<=HEAT2) GO RF23.
    MOVE BH-HEAT TO HE-NO READ HEAT REGARDLESS INVALID GO RF23.
    IF HE-DATE=0 OR>=DATE0 GO RF23.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID GO RF23.
    PERFORM PART-TYPE IF NOT PART-MAT GO RF23.
    PERFORM INIT-RP MOVE BH-HEAT TO RP-F308 MOVE BH-PART TO RP-F309.
    MOVE BH-NO TO RP-F310 MOVE HE-DATE TO RP-F312 WRITE RP-RECORD GO RF23.
RF29. PERFORM OPEN-PR PERFORM RF-PAGE.
    MOVE LOW-VALUES TO RF-HTOTALS RF-GTOTALS MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RF9.
RF3. READ REPFL NEXT END GO RF9. IF RP-F308=OLD-A GO RF34.
    IF OLD-A>" " PERFORM RF-H. MOVE RP-F308 TO OLD-A.
RF34. MOVE RP-F308 TO FG158 MOVE RP-F310 TO FG158A A-A1 PERFORM RD-PURBIN.
    MOVE BH-PART TO FG159 PH-NO READ PART REGARDLESS MOVE PH-DESC1 TO FG160.
    MOVE RP-F312 TO D-DATE PERFORM D-NM MOVE D-DT TO FG161.
    MOVE BH-COILS TO FG162 MOVE BH-PCODE TO FG163.
    MOVE PH-LDCOST TO WT1.
    IF BH-PCODE>=1 AND<=8 MOVE IF-RMPROC(BH-PCODE) TO WD1
      IF PH-CAT=130 AND BH-PCODE<=2 MOVE IF-RMPROC-A(BH-PCODE) TO WD1 END-IF
      ADD WD1 TO WT1.
    COMPUTE A-T1=BH-QTY * WT1 PERFORM DIV-PAMT COMPUTE WD1 ROUNDED=A-T1.
    MOVE WT1 TO FG164 MOVE BH-QTY TO FG165 MOVE WD1 TO FG166.
    ADD BH-QTY TO RF-HW RF-GW ADD WD1 TO RF-HV RF-GV.
    PERFORM RF-LINE GO RF3.
RF9. PERFORM RF-H MOVE 2 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    MOVE RF-GW TO FG165 MOVE RF-GV TO FG166 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

RF-H. MOVE 2 TO WS-PR MOVE " ** HEAT TOTALS" TO PREC.
    MOVE RF-HW TO FG165 MOVE RF-HV TO FG166 MOVE "*" TO FG167.
    PERFORM RF-LINE 2 TIMES MOVE LOW-VALUES TO RF-HTOTALS.
RF-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RF-PAGE.
RF-PAGE. MOVE "HEAT LOCATION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "HEATS OLDER THAN:" TO A-A1 PERFORM PRANGE-DT.
    MOVE 1 TO WS-PR PERFORM PRANGE-HEAT.
    MOVE "HEAT        BIN       PART NO.      DESCRIPTION                         DATE  COILS  PROC    COST      WEIGHT        VALUE" TO PREC PERFORM PR-LINE-3.
*         ..........  ........  ............  ................................  ../../.. ...-   .  .,...:... ..,...,...- .,...,...:..-..

* Z-19-9 MATERIAL AGING REPORT
RY1. PERFORM RD388 PERFORM WRT IF S-BAT GO RY2.
    MOVE 3 TO IXT MOVE 14 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.
    MOVE 4 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RY2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM RY-PAGE.
    MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-YEAR TO RY-YEAR.
    MOVE LOW-VALUES TO RY-PTOTALS RY-GTOTALS MOVE " " TO OLD-A.
    INITIALIZE BH-KP START PURBIN KEY>BH-KP REGARDLESS INVALID GO RY9.
RY3. READ PURBIN NEXT REGARDLESS END GO RY9.
    IF BH-NO(1:2)="SQ" OR BH-PART=" " GO RY3.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID GO RY3.
    PERFORM PART-TYPE IF NOT PART-MAT GO RY3.
    IF BH-PART=OLD-A GO RY4. IF OLD-A>" " PERFORM RY-P.
    MOVE PH-NO TO OLD-A FD398 MOVE PH-DESC1 TO FD399 PERFORM RY-LINE.
RY4. MOVE BH-NO TO FD400 IF BH-HEAT=" " GO RY48.
    MOVE BH-HEAT TO FD401 HE-NO READ HEAT REGARDLESS INVALID GO RY48.
    IF HE-DATE=0 GO RY48. MOVE HE-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD402.
    COMPUTE IX1=RY-YEAR - D-YEAR IF IX1<0 MOVE 0 TO IX1. IF IX1>4 MOVE 4 TO IX1.
    ADD 2 TO IX1 MOVE BH-QTY TO FD403(IX1).
    ADD BH-QTY TO RY-PTOT(IX1) RY-PTOT(1) RY-GTOT(IX1) RY-GTOT(1).
    IF TOT-IND=0 PERFORM RY-LINE.
RY48. MOVE " " TO PREC GO RY3.
RY9. PERFORM RY-P MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE RY-GTOT(IX1) TO FD403(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-PR GO MX9.

RY-P. MOVE "** TOTALS" TO FD399.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6 MOVE RY-PTOT(IX1) TO FD403(IX1) END-PERFORM.
    PERFORM RY-LINE MOVE LOW-VALUES TO RY-PTOTALS.
RY-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RY-PAGE.
RY-PAGE. MOVE "MATERIAL AGING REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "AGING DATE:" TO A-A1 PERFORM PRANGE-DT.
    MOVE "PART NO.      DESCRIPTION" TO PREC PERFORM PR-LINE.
*         ............  ................................
    MOVE "              BIN       HEAT       HEAT DATE       TOTAL     CURRENT      1 YEAR     2 YEARS     3 YEARS     4 YEARS" TO PREC PERFORM PR-LINE-3.
*                       ........  ..........  ../../..  ..,...,...- ..,...,...- ..,...,...- ..,...,...- ..,...,...- ..,...,...-

    REPLACE ==UNSTR-RECORD== BY ==UNSTRING ED-RECORD DELIMITED ED-SEP OR ED-NL==.
* Z-19-10 READ CLEANED COILS BIN FILE
RJ1. PERFORM RD389 PERFORM WRT.
    IF S-BAT MOVE S-A1 TO EDI-ID MOVE S-S1 TO RJ-KUP GO RJ2.
    MOVE "IRVFAST" TO EDI-ID.
    ACCEPT EDI-ID LINE 3 COLUMN 12 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    PERFORM OPEN-EDI IF EDI-ID=" " GO MX9. CLOSE EDI.
    ACCEPT XA3 LINE 4 COLUMN 18 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO RJ-KUP ELSE MOVE 0 TO RJ-KUP.
    MOVE 5 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE EDI-ID TO S-A1 MOVE RJ-KUP TO S-S1 GO MX9.
RJ2. PERFORM DSP-WAIT PERFORM OPEN-EDI IF EDI-ID=" " GO MX9.
    MOVE X"1C" TO ED-NL MOVE "," TO ED-SEP.

    IF RJ-KUP=0 GO RJ28.
    MOVE " " TO BH-KEY START PURBIN KEY>BH-KEY REGARDLESS INVALID GO RJ28.
RJ23. READ PURBIN NEXT REGARDLESS END GO RJ28. IF BH-PART=" " GO RJ23.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID GO RJ26.
    PERFORM PART-TYPE IF NOT PART-MAT GO RJ26.
    MOVE BH-PART TO BH-TMP-PART MOVE BH-QTY TO BH-TMP-QTY.
    MOVE BH-HEAT TO BH-TMP-HEAT MOVE BH-PCODE TO BH-TMP-PCODE.
    MOVE BH-COILS TO BH-TMP-COILS.
    MOVE 0 TO BH-COILS PERFORM CHK-PBIN-EMPTY REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 MOVE 0 TO PH-PROC-HAND(IX1) END-PERFORM.
    MOVE 0 TO PH-HAND REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
RJ26. GO RJ23.
RJ28. MOVE 0 TO PR-NUM PERFORM OPEN-PR MOVE 1 TO RJ-STEP PERFORM RJ-PAGE.
    IF RJ-KUP=1 PERFORM OPEN-MAINTA.

RJ3. READ EDI END GO RJ6. PERFORM EL-CSV MOVE 1 TO ED-PTR.
    MOVE 0 TO RJ-KM RJ-KB MOVE 1 TO RJ-KP.
    INITIALIZE RJ-BIN RJ-PART RJ-PCODE RJ-COILS RJ-AVG RJ-HEAT RJ-DATE.
    UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR.
    MOVE 0 TO IX1 INSPECT ED-LINE(1:ED-LTH) TALLYING IX1 FOR CHARACTERS BEFORE "-".
    IF IX1=ED-LTH MOVE ED-LINE(1:ED-LTH) TO RJ-PART MOVE 1 TO RJ-KM GO RJ4.
    ADD 1 TO IX1 COMPUTE IX2=IX1 + 1.
    INSPECT ED-LINE(IX2:ED-LTH - IX2 + 1) TALLYING IX1 FOR CHARACTERS BEFORE "-".
    MOVE ED-LINE(1:IX1) TO RJ-PART IF IX1=ED-LTH GO RJ38.
    IF IX1 + 3<=ED-LTH AND ED-LINE(IX1 + 2:1)="A" MOVE ED-LINE(IX1 + 3:1) TO ED-VCA
      IF ED-VCA NUMERIC MOVE ED-VCN TO RJ-PCODE GO RJ38.
    IF IX1 + 4<=ED-LTH AND ED-LINE(IX1 + 2:3)="ANN" MOVE 8 TO RJ-PCODE GO RJ38.
    IF IX1 + 5<=ED-LTH AND ED-LINE(IX1 + 2:4)="SAFS" MOVE 8 TO RJ-PCODE GO RJ38.
    GO RJ4.
RJ38. MOVE 0 TO RJ-KP.

RJ4. UNSTR-RECORD INTO RJ-HEAT RJ-BIN ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO RJ-COILS.
    UNSTR-RECORD INTO ED-LINE COUNT ED-LTH POINTER ED-PTR.
    PERFORM EL-RDVAL MOVE ED-VAL TO RJ-AVG.
    UNSTR-RECORD INTO ED-LINE ED-LINE COUNT ED-LTH POINTER ED-PTR.
    MOVE "102" TO ED-DFQUAL PERFORM EL-RDATE MOVE D-DATE TO RJ-DATE.

    MOVE RJ-BIN TO FG3 MOVE RJ-PART TO FG4 MOVE RJ-PCODE TO FG5.
    MOVE RJ-COILS TO FG6 MOVE RJ-AVG TO FG7 MOVE RJ-HEAT TO FG8.
    MOVE RJ-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG9.

    IF RJ-KM=1 MOVE "INVALID MATERIAL" TO FG10 GO RJ58.
    MOVE RJ-PART TO PH-NO READ PART REGARDLESS INVALID
      PERFORM INIT-PH MOVE RJ-PART TO PH-NO PH-KANO PH-KVNO MOVE 100 TO PH-CAT
      MOVE "PART ADDED BY THE SYSTEM" TO PH-DESC1 MOVE SYS-DATE TO PH-CRDATE
      IF RJ-KUP=1 WRITE PH-RECORD ALLOWING NO UNLOCK PART END-IF
      MOVE "NO MAT. RECORD" TO FG10.
    PERFORM PART-TYPE IF NOT PART-MAT MOVE "PART IS NOT MAT." TO FG10.
    IF RJ-KP=0 IF RJ-PCODE>8 MOVE 0 TO RJ-PCODE MOVE 1 TO RJ-KP.
    IF RJ-KP=1 MOVE "INVALID PROCESS" TO FG10.
    IF RJ-BIN="ANN" OR "CLN" OR "PAD" MOVE 1 TO RJ-KB.
* note 255
RJ5. MOVE RJ-BIN TO BH-NO READ PURBIN REGARDLESS INVALID
      PERFORM INIT-BH MOVE RJ-BIN TO BH-NO BH-KNO
      IF RJ-KUP=1 WRITE BH-RECORD ALLOWING NO UNLOCK PURBIN END-IF
      MOVE "NO BIN RECORD" TO FG10.
    IF BH-COILS=0 GO RJ54.
    IF RJ-KB=0 MOVE "DUPL. BIN ENTRY" TO FG10 GO RJ58.
    IF RJ-BIN(5:1)=" " MOVE 0 TO RJ-BN1.
    IF RJ-BIN(6:1)=" " IF RJ-BN1<9 ADD 1 TO RJ-BN1 ELSE MOVE 10 TO RJ-BN2 END-IF
      ELSE ADD 1 TO RJ-BN2.
    MOVE RJ-BIN TO FG3 GO RJ5.
RJ54. IF RJ-KUP=0 GO RJ58. COMPUTE RJ-QTY=RJ-COILS * RJ-AVG.
    MOVE RJ-PART TO BH-PART MOVE RJ-DATE TO BH-DATE MOVE RJ-QTY TO BH-QTY.
    MOVE RJ-HEAT TO BH-HEAT MOVE " " TO BH-PO MOVE RJ-PCODE TO BH-PCODE.
    MOVE RJ-COILS TO BH-COILS REWRITE BH-RECORD ALLOWING NO UNLOCK PURBIN.
    IF NOT(BH-PART=BH-TMP-PART AND BH-QTY=BH-TMP-QTY AND BH-HEAT=BH-TMP-HEAT
      AND BH-PCODE=BH-TMP-PCODE AND BH-COILS=BH-TMP-COILS) WRITE MFA-RECORD FROM PREC.
    ADD RJ-QTY TO PH-HAND PH-PROC-HAND(RJ-PCODE + 1).
    REWRITE PH-RECORD ALLOWING NO UNLOCK PART.
RJ58. PERFORM RJ-LINE GO RJ3.

RJ6. IF RJ-KUP=0 GO RJ8.
    CLOSE MAINTA OPEN INPUT MAINTA MOVE 2 TO RJ-STEP PERFORM RJ-PAGE.
RJ63. READ MAINTA END GO RJ68. MOVE MFA-RECORD TO PREC PERFORM RJ-LINE GO RJ63.
RJ68. CLOSE MAINTA.

RJ8. IF WS-LINES>50 PERFORM RJ-PAGE. COMPUTE WS-PR=50 - WS-LINES.
    MOVE "EXCEPTIONS" TO PREC PERFORM PR-LINE.
    MOVE "==========" TO PREC PERFORM PR-LINE.
    MOVE "INVALID MATERIAL: INVALID MATERIAL DESCRIPTION" TO PREC PERFORM PR-LINE.
    MOVE "NO MAT. RECORD:   MATERIAL RECORD NOT FOUND - ADDED BY THE SYSTEM" TO PREC PERFORM PR-LINE.
    MOVE "PART IS NOT MAT.: PART IS NOT A MATERIAL - ASSUMED CORRECT" TO PREC PERFORM PR-LINE.
    MOVE "INVALID PROCESS:  INVALID PROCESS CODE - 0 ASSUMED" TO PREC PERFORM PR-LINE.
    MOVE "NO BIN RECORD:    BIN RECORD NOT FOUND - ADDED BY THE SYSTEM" TO PREC PERFORM PR-LINE.
    MOVE "DUPL. BIN ENTRY:  DUPLICATE BIN ENTRY - LINE IGNORED" TO PREC PERFORM PR-LINE.
    CLOSE EDI PERFORM CLOSE-PR.
    MOVE "PRINT2" TO PR-QUEUE PERFORM PRINT-PR.
RJ9. GO MX9.

RJ-LINE. PERFORM PR-LINE IF WS-LINES>58 PERFORM RJ-PAGE.
RJ-PAGE. MOVE "CLEANED COILS BIN FILE PROCESSING" TO FF3Y PERFORM PR-PAGE-80 MOVE 1 TO WS-PR.
    IF RJ-STEP=1 AND RJ-KUP=0 MOVE "   (FILES NOT UPDATED)" TO FF3Y PERFORM PR-LINE.
    IF RJ-STEP=2 MOVE "   (MODIFIED BINS ONLY)" TO FF3Y PERFORM PR-LINE.
    MOVE 2 TO WS-PR.
    MOVE "BIN       MATERIAL   PROC  COILS  AVG WT  HEAT         DATE    EXCEPTION" TO PREC PERFORM PR-LINE-3.
*         ........  ............ .   ...    ..,...  .......... ../../..  .................
    REPLACE OFF.

* Z-19-11 DAILY MATERIAL REQUIREMENTS REPORT
IK1. PERFORM RD239 PERFORM WRT IF S-BAT GO IK2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
IK2. PERFORM DSP-WAIT PERFORM OPEN-MACSCHED PERFORM OPEN-SORT.
    MOVE " " TO MQ-KEY START MACSCHED KEY>MQ-KEY REGARDLESS INVALID GO IK4.
IK3. READ MACSCHED NEXT REGARDLESS END GO IK4.
    MOVE MQ-MAC TO A-N1 PERFORM RD-MAC MOVE 0 TO IK-IXN.
IK31. ADD 1 TO IK-IXN IF IK-IXN>15 GO IK39. IF MQ-MO(IK-IXN)=0 GO IK31.
    MOVE MQ-MO(IK-IXN) TO R-NO READ PRODORD REGARDLESS INVALID GO IK31.
    MOVE R-QTY-ORD TO IK-PQTY INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO IK34.
IK33. READ WORKSHEET NEXT REGARDLESS END GO IK34. IF J-NO NOT=R-NO GO IK34.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE.
    IF PROC-PRIMARY SUBTRACT J-QTY FROM IK-PQTY. IF PROC-REJECT ADD J-QTY TO IK-PQTY.
    GO IK33.
IK34. IF IK-PQTY<=0 GO IK38. MOVE R-PROD TO A-A1 PERFORM PROD-RT.
    PERFORM GROSS-WEIGHT PERFORM SET-PART.
    MOVE M-HOURS TO WN1 IF WN1=0 MOVE 15 TO WN1.
    PERFORM CALC-PRATE COMPUTE IK-MQTY=A-N1 * WN1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 COMPUTE WN1=IK-PQTY - IK-MQTY
      IF WN1>=0 MOVE IK-MQTY TO IK-DN(IX1) MOVE WN1 TO IK-PQTY
        ELSE MOVE IK-PQTY TO IK-DN(IX1) MOVE 0 TO IK-PQTY END-IF END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>5 OR IK-DN(IX1)=0
      MOVE IX1 TO SR-F198 MOVE PART-NO TO SR-F199
      MOVE P-PROC TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO SR-F200
      MOVE P-WIRE TO SR-F201
      COMPUTE WN1 ROUNDED=IK-DN(IX1) * PRO-GROSS / 100 MOVE WN1 TO SR-F202
      WRITE SR-RECORD INVALID READ SORTFL
        ADD WN1 TO SR-F202 REWRITE SR-RECORD END-WRITE END-PERFORM.
IK38. GO IK31.
IK39. GO IK3.
IK4.

    PERFORM OPEN-PR PERFORM IK-PAGE.
    COMPUTE IK-DATE=SYS-DATE - 1 MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO IK9.
IK5. READ SORTFL NEXT END GO IK9. IF SR-F198=OLD-N GO IK54.
    PERFORM TEST AFTER UNTIL D-N1=0 ADD 1 TO IK-DATE
      MOVE IK-DATE TO D-DATE PERFORM D-OFFDAY END-PERFORM.
    MOVE IK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD500.
    IF OLD-N>0 MOVE 2 TO WS-PR. MOVE SR-F198 TO OLD-N.
IK54. MOVE SR-F199 TO FD501 MOVE SR-F200 TO FD502.
    MOVE SR-F201 TO PRO-WIRE PERFORM CHK-WIRE MOVE PRO-AWIRE TO FD503.
    MOVE SR-F202 TO FD504 PERFORM IK-LINE GO IK5.
IK9. CLOSE MACSCHED PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

IK-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM IK-PAGE.
IK-PAGE. MOVE "DAILY MATERIAL REQUIREMENTS REPORT" TO FF3.
    MOVE "(BASED ON SHORT SCHEDULE & CURRENT WORKSHEETS)" TO FF4 PERFORM PR-PAGE.
    MOVE "  DATE    MATERIAL     PROC  WIRE    WEIGHT REQD" TO PREC PERFORM PR-LINE-3.
*         ../../..  ............   .   ......  .,...,...

* Z-19-12 WEEKLY MATERIAL REQUIREMENTS REPORT
RK1. PERFORM RD240 PERFORM WRT IF S-BAT GO RK2.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
RK2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 0 TO R-NO START PRODORD KEY>R-KEY REGARDLESS INVALID GO RK29.
RK23. READ PRODORD NEXT REGARDLESS END GO RK29.
    IF R-FIN=1 OR R-QTY-ORD<=R-QTY-PROD OR R-ALLOC>0 GO RK23.
    MOVE R-PROD TO A-A1 PERFORM PROD-GEN IF P-MAC=99 GO RK23.
    PERFORM SET-PART PERFORM INIT-RP MOVE PART-NO TO RP-F288.
    MOVE P-PROC TO A-N1 PERFORM CHK-ZERO MOVE A-N1 TO RP-F289.
    MOVE R-NO TO RP-F290 MOVE R-DATE TO RP-F291.
    COMPUTE A-N1=R-QTY-ORD - R-QTY-PROD PERFORM CALC-GWEIGHT MOVE A-N1 TO RP-F292.
    WRITE RP-RECORD GO RK23.
RK29. MOVE SYS-DATE TO D-DATE MOVE 1 TO D-N1 PERFORM D-CPREVIOUS.
    MOVE D-DATE TO RK-DT(1).
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>8
      COMPUTE RK-DT(IX1)=RK-DT(IX1 - 1) + 7 END-PERFORM.
    MOVE RK-DT(8) TO D-DATE PERFORM D-INCMTH.
    PERFORM D-NM MOVE D-DD TO WN1 MOVE 1 TO D-DD PERFORM D-MN.
    IF WN1>15 PERFORM D-INCMTH. MOVE D-DATE TO RK-DT(9).

    PERFORM OPEN-PR PERFORM RK-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE "material`process" TO RK-HD1.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>7 MOVE "`week" TO RK-HD2(IX1)
      MOVE RK-DT(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO RK-HD3(IX1) END-PERFORM.
    MOVE "`" TO RK-HD4 MOVE RK-DT(8) TO D-DATE PERFORM D-NM MOVE D-DT TO RK-HD5.
    MOVE " -" TO RK-HD6 COMPUTE D-DATE=RK-DT(9) - 1 PERFORM D-NM MOVE D-DT TO RK-HD7.
    MOVE "`" TO RK-HD8 MOVE RK-DT(9) TO D-DATE PERFORM D-NM MOVE D-DT TO RK-HD9.
    MOVE " and later" TO RK-HD10 MOVE RK-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE LOW-VALUES TO RK-PTOTALS RK-MTOTALS RK-GTOTALS.
    MOVE " " TO OLD-A MOVE -1 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO RK9.
RK3. READ REPFL NEXT END GO RK9. IF RP-F288=OLD-A GO RK4.
    IF OLD-A>" " PERFORM RK-P PERFORM RK-M. MOVE RP-F288 TO OLD-A MOVE -1 TO OLD-N.
RK4. IF RP-F289 NOT=OLD-N IF OLD-N NOT=-1 PERFORM RK-P END-IF MOVE RP-F289 TO OLD-N.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8 OR RP-F291<RK-DT(IX1 + 1) CONTINUE END-PERFORM.
    ADD RP-F292 TO RK-PTOT(IX1) RK-MTOT(IX1) RK-GTOT(IX1) GO RK3.
RK9. PERFORM RK-P PERFORM RK-M MOVE 2 TO WS-PR MOVE "** GRAND TOTALS" TO PREC.
    MOVE RK-GTOTALS TO RK-XTOTALS PERFORM RK-F PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

RK-P. MOVE OLD-A TO FD480 EXP-A PERFORM EXPF MOVE OLD-N TO FD481 EXP-N PERFORM EXPF.
    MOVE RK-PTOTALS TO RK-XTOTALS PERFORM RK-F PERFORM RK-LINE.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9 MOVE RK-PTOT(IX1) TO EXP-N PERFORM EXPF END-PERFORM.
    PERFORM EXP-LINE MOVE LOW-VALUES TO RK-PTOTALS.
RK-M. MOVE "* TOTALS" TO FD480.
    MOVE RK-MTOTALS TO RK-XTOTALS PERFORM RK-F PERFORM RK-LINE 2 TIMES.
    MOVE LOW-VALUES TO RK-MTOTALS.
RK-F. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>7 MOVE RK-XTOT(IX1) TO FD482(IX1) END-PERFORM.
    PERFORM VARYING IX1 FROM 8 BY 1 UNTIL IX1>9 MOVE RK-XTOT(IX1) TO FD483(IX1) END-PERFORM.
RK-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM RK-PAGE.
RK-PAGE. MOVE "WEEKLY MATERIAL REQUIREMENTS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "MATERIAL    PROC     WEEK OF     WEEK OF     WEEK OF     WEEK OF     WEEK OF     WEEK OF     WEEK OF    FROM ../../..    ../../.." TO PREC.
    MOVE RK-DT(8) TO D-DATE PERFORM D-NM MOVE D-DT TO FD485.
    MOVE RK-DT(9) TO D-DATE PERFORM D-NM MOVE D-DT TO FD486 PERFORM PR-LINE.
    MOVE "                     ../../..    ../../..    ../../..    ../../..    ../../..    ../../..    ../../..     TO ../../..    AND LATER" TO PREC.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>7
      MOVE RK-DT(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO FD487(IX1) END-PERFORM.
    COMPUTE D-DATE=RK-DT(9) - 1 PERFORM D-NM MOVE D-DT TO FD488 PERFORM PR-LINE-3.
*         ............  .   ...,...,... ...,...,... ...,...,... ...,...,... ...,...,... ...,...,... ...,...,...     ...,...,... ...,...,...

* Z-20: PURCHASING AND A/P FUNCTIONS

* Z-20-1 INVENTORY REPORTS
II1. PERFORM RD154 PERFORM WRT PERFORM RDR-INFO.
    IF S-BAT MOVE S-S1 TO II-KFULL MOVE S-S2 TO II-KSHORT MOVE S-S3 TO II-KTRAN
      MOVE S-N1 TO II-MIN GO II2.
    PERFORM AX-SEL IF SEL-N=0 OR>3 GO MX1.
    IF Y2 GO II14. IF Y3 GO II16.
* Y1
    PERFORM RD154A PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 39 TO IXV PERFORM AX-PCAT-R.
    MOVE 0 TO II-KFULL II-KSHORT II-KTRAN II-MIN.
    ACCEPT XA3 LINE 4 COLUMN 55 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO II-KFULL GO II12.
    ACCEPT XA3 LINE 5 COLUMN 21 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO II-KSHORT
      DISPLAY II-MIN LINE 6 COLUMN 51 CONVERSION
      ACCEPT II-MIN LINE 6 COLUMN 51 DEFAULT CURRENT UNDERLINED PROTECTED NO BLANK CONVERSION
      DISPLAY II-MIN LINE 6 COLUMN 51 CONVERSION.
II12. ACCEPT XA3 LINE 7 COLUMN 47 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO II-KTRAN.
    MOVE 8 TO IXT MOVE 18 TO IXU PERFORM AX-SUM-S.
    MOVE 10 TO IXT GO II18.
II14. PERFORM RD154B PERFORM WRT.
    MOVE 3 TO IXT MOVE 16 TO IXU MOVE 38 TO IXV PERFORM AX-MAC-R.
    MOVE 5 TO IXT MOVE 18 TO IXU PERFORM AX-SUM-S.
    MOVE 7 TO IXT GO II18.
II16. PERFORM RD154C PERFORM WRT.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 39 TO IXV PERFORM AX-PCAT-R.
    MOVE 5 TO IXT.
II18. PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE II-KFULL TO S-S1 MOVE II-KSHORT TO S-S2 MOVE II-KTRAN TO S-S3
      MOVE II-MIN TO S-N1 GO MX9.
II2. PERFORM DSP-WAIT.
    MOVE 2 TO II-NP2 MOVE 3 TO II-NP3 IF SUM-IND=1 MOVE 1 TO II-NP2 MOVE 2 TO II-NP3.
    IF Y2 GO II4. IF Y3 GO II6.

* Y1
    PERFORM OPEN-REP.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO II29.
II23. READ PART NEXT REGARDLESS END GO II29. IF NOT(PH-CAT>=PCAT1 AND<=PCAT2) GO II23.
    IF II-KFULL=0 AND II-KSHORT=0 IF PH-HAND>0 GO II24 ELSE GO II23.
    IF II-KFULL=0 AND II-KSHORT=1
      IF PH-ROP>=II-MIN AND PH-HAND + PH-ORDER - PH-DEMAND<0.9 * PH-ROP GO II24 ELSE GO II23.
* kfull=1 and kshort=0
II24. PERFORM PART-TYPE.
    PERFORM INIT-RP MOVE PH-CAT TO RP-F107 MOVE PH-MTYPE TO RP-F108.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO RP-F109 MOVE PH-KEY TO RP-F110.
    WRITE RP-RECORD GO II23.
II29. PERFORM OPEN-PR PERFORM II-PAGE MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    IF II-KTRAN=1 MOVE II-HEADLN1 TO EXP-RECORD ELSE MOVE II-HEADLN2 TO EXP-RECORD.
    PERFORM EXP-HEADLN.
    MOVE -1 TO OLD-M MOVE 0 TO OLD-N MOVE " " TO OLD-A.
    COMPUTE II-OGROUP=PCAT1 / 100 MULTIPLY 100 BY II-OGROUP.
    MOVE LOW-VALUES TO II-MTOTALS II-CTOTALS II-RTOTALS II-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO II39.
II3. READ REPFL NEXT END GO II39.
    MOVE RP-F110 TO PH-KEY READ PART REGARDLESS PERFORM PART-TYPE.
    IF PH-CAT=OLD-N GO II32. IF OLD-N NOT=0 PERFORM II-M PERFORM II-C.
    MOVE PH-CAT TO OLD-N MOVE -1 TO OLD-M MOVE " " TO OLD-A.
    COMPUTE II-GROUP=PH-CAT / 100 MULTIPLY 100 BY II-GROUP.
    IF II-GROUP NOT=II-OGROUP PERFORM II-R MOVE II-GROUP TO II-OGROUP.
    MOVE II-NP3 TO WS-PR MOVE "CAT" TO FA60 MOVE OLD-N TO FA61.
    IF OLD-N NOT=0 MOVE 10 TO T-TBL MOVE OLD-N TO T-NO
      PERFORM RD-TBL MOVE T-LINE TO FA62.
    PERFORM II-LINE II-NP2 TIMES.
II32. IF PH-MTYPE=OLD-M GO II34. IF OLD-M NOT=-1 PERFORM II-M.
    MOVE PH-MTYPE TO OLD-M MOVE " " TO OLD-A.
    MOVE II-NP3 TO WS-PR MOVE "MACHINE TYPE" TO FA63.
    MOVE OLD-M TO FA64 A-N1 PERFORM RD-MACTYPE MOVE ME-DESC TO FA65.
    PERFORM II-LINE II-NP2 TIMES.
II34. IF RP-F109=OLD-A GO II36. IF SUM-IND=0 PERFORM II-LINE. MOVE RP-F109 TO OLD-A.
II36. PERFORM II-L.
    ADD PH-HAND TO II-MH II-CH II-RH II-GH ADD II-VAL TO II-MV II-CV II-RV II-GV.
    IF PART-MAT PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      ADD II-XPH(IX1) TO II-MPH(IX1) II-CPH(IX1) II-RPH(IX1) II-GPH(IX1)
      ADD II-XPV(IX1) TO II-MPV(IX1) II-CPV(IX1) II-RPV(IX1) II-GPV(IX1) END-PERFORM.
    IF SUM-IND=0 PERFORM II-LINE MOVE 1 TO II-KPR PERFORM II-P ELSE MOVE " " TO PREC.
    GO II3.
II39. IF OLD-M NOT=-1 PERFORM II-M. PERFORM II-C.
    COMPUTE II-GROUP=(PCAT2 + 100) / 100 MULTIPLY 100 BY II-GROUP PERFORM II-R.
    MOVE 3 TO WS-PR MOVE "GRAND TOTALS" TO FA10.
    MOVE II-GH TO FA14 MOVE II-GV TO FA19 PERFORM PR-LINE.
    MOVE II-GPTOT TO II-XPTOT MOVE 0 TO II-KPR PERFORM II-P.
    PERFORM CLOSE-REP PERFORM CLOSE-PR PERFORM CLOSE-EXP GO II9.

II4. PERFORM OPEN-REP.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO II49.
II43. READ PART NEXT REGARDLESS END GO II49.
    PERFORM PART-TYPE IF NOT(PART-TOOL AND (PH-MTYPE>=MAC1 AND<=MAC2)) GO II43.
    PERFORM INIT-RP MOVE 0 TO RP-F107 MOVE PH-MTYPE TO RP-F108.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO RP-F109 MOVE PH-KEY TO RP-F110.
    WRITE RP-RECORD GO II43.
II49. PERFORM OPEN-PR PERFORM II-PAGE MOVE -1 TO OLD-M MOVE " " TO OLD-A.
    MOVE LOW-VALUES TO II-MTOTALS II-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO II59.
II5. READ REPFL NEXT END GO II59.
    MOVE RP-F110 TO PH-KEY READ PART REGARDLESS PERFORM PART-TYPE.
    IF PH-MTYPE=OLD-M GO II54. IF OLD-M NOT=-1 PERFORM II-M.
    MOVE PH-MTYPE TO OLD-M MOVE " " TO OLD-A.
    MOVE II-NP3 TO WS-PR MOVE "MACHINE TYPE" TO FA63.
    MOVE OLD-M TO FA64 A-N1 PERFORM RD-MACTYPE MOVE ME-DESC TO FA65.
    PERFORM II-LINE II-NP2 TIMES.
II54. IF RP-F109=OLD-A GO II56. IF SUM-IND=0 PERFORM II-LINE. MOVE RP-F109 TO OLD-A.
II56. PERFORM II-L.
    ADD PH-HAND TO II-MH II-GH ADD II-VAL TO II-MV II-GV.
    IF SUM-IND=0 PERFORM II-LINE ELSE MOVE " " TO PREC. GO II5.
II59. IF OLD-M NOT=-1 PERFORM II-M.
    MOVE 3 TO WS-PR MOVE "GRAND TOTALS" TO FA10.
    MOVE II-GH TO FA14 MOVE II-GV TO FA19 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO II9.

II6. PERFORM OPEN-REP.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO II69.
II63. READ PART NEXT REGARDLESS END GO II69. IF NOT(PH-CAT>=PCAT1 AND<=PCAT2) GO II63.
    PERFORM PART-TYPE IF NOT PART-TOOL GO II63.
    COMPUTE WN1=PH-CAT / 100 MULTIPLY 100 BY WN1 IF PH-CAT - WN1=95 GO II63.
    COMPUTE WN1=PH-HAND + PH-ORDER - PH-DEMAND.
    IF PH-ROP=0 COMPUTE II-SUR=WN1 - 2 ELSE COMPUTE II-SUR=WN1 - 4 * PH-ROP.
    IF II-SUR<=0 GO II63.
    PERFORM INIT-RP MOVE PH-CAT TO RP-F360 MOVE PH-KEY TO RP-F361.
    MOVE II-SUR TO RP-F362 WRITE RP-RECORD GO II63.
II69. PERFORM OPEN-PR PERFORM II-PAGE MOVE LOW-VALUES TO II-ATOTALS II-STOTALS.
    MOVE 0 TO OLD-N MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO II79.
II7. READ REPFL NEXT END GO II79. MOVE RP-F361 TO PH-KEY READ PART REGARDLESS.
    IF PH-CAT=OLD-N GO II72. IF OLD-N NOT=0 PERFORM II-A.
    MOVE PH-CAT TO OLD-N MOVE 3 TO WS-PR MOVE "CAT" TO FA60 MOVE OLD-N TO FA61.
    IF OLD-N NOT=0 MOVE 10 TO T-TBL MOVE OLD-N TO T-NO
      PERFORM RD-TBL MOVE T-LINE TO FA62.
    PERFORM II-LINE 2 TIMES.
II72. PERFORM PART-TYPE MOVE PH-NO TO FA810.
    PERFORM DRAW-EXP-PH MOVE A-A1 TO FA811 MOVE PH-DESC1 TO FA812.
    MOVE PH-HAND TO FA813 MOVE PH-ORDER TO FA814 MOVE PH-DEMAND TO FA815.
    MOVE PH-LDCOST TO FA816 MOVE RP-F362 TO II-SUR FA817.
    COMPUTE A-T1=II-SUR * PH-LDCOST PERFORM DIV-PAMT.
    COMPUTE II-VAL ROUNDED=A-T1 MOVE II-VAL TO FA818.
    ADD II-SUR TO II-AS II-SS ADD II-VAL TO II-AV II-SV.
    PERFORM II-LINE GO II7.
II79. PERFORM II-A MOVE 3 TO WS-PR MOVE "GRAND TOTALS" TO FA10.
    MOVE II-SS TO FA817 MOVE II-SV TO FA818 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO II9.

II9. GO MX9.

    REPLACE ==AEXPF== BY ==IF Y1 PERFORM EXPF END-IF==.
II-L. PERFORM II-L1 THRU II-L9.
II-L1. MOVE LOW-VALUES TO II-XTOTALS MOVE 0 TO II-VAL.
    MOVE PH-NO TO FA11 EXP-A AEXPF MOVE PH-CAT TO EXP-N AEXPF.
    MOVE RP-F109 TO FA12 EXP-A AEXPF MOVE PH-DESC1 TO FA13 EXP-A AEXPF.
    MOVE PH-HAND TO FA14 EXP-N AEXPF MOVE PH-ORDER TO FA15 EXP-N AEXPF.
    MOVE PH-BLINES TO FA15A EXP-N AEXPF MOVE PH-DEMAND TO FA16 EXP-N AEXPF.
    MOVE PH-LIFE TO FA16A EXP-N AEXPF MOVE PH-ROP TO FA17 EXP-N AEXPF.
    IF PH-LEVEL=3 MOVE PH-LEVEL TO FA17A EXP-N. AEXPF.
    MOVE PH-LDCOST TO FA18 EXP-T AEXPF.
    IF NOT Y1 GO II-L4.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PH-NO TO PU-PART.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO II-L2.
    READ PURHIST NEXT REGARDLESS END GO II-L2.
    IF NOT(PU-DIV=WS-DIV AND PU-PART=PH-NO) GO II-L2.
    PERFORM PART-TYPE MOVE PU-AMT TO A-T1 PERFORM MUL-PAMT.
    COMPUTE EXP-T ROUNDED=A-T1 / PU-QTY SIZE ERROR CONTINUE. AEXPF.
    MOVE PU-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT AEXPF GO II-L4.
II-L2. AEXPF AEXPF.
II-L4. IF NOT PART-MAT COMPUTE A-T1=PH-HAND * PH-LDCOST PERFORM DIV-PAMT
      COMPUTE II-VAL ROUNDED=A-T1 GO II-L6.
    MOVE PH-LDCOST TO II-XPRICE(1).
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>8
      MOVE IF-RMPROC(IX1) TO WD1 IF PH-CAT=130 AND IX1<=2 MOVE IF-RMPROC-A(IX1) TO WD1 END-IF
      COMPUTE II-XPRICE(IX1 + 1)=PH-LDCOST + WD1 END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
      MOVE PH-PROC-HAND(IX1) TO II-XPH(IX1)
      COMPUTE A-T1=PH-PROC-HAND(IX1) * II-XPRICE(IX1) PERFORM DIV-PAMT
      COMPUTE II-XPV(IX1) ROUNDED=A-T1 ADD II-XPV(IX1) TO II-VAL END-PERFORM.
II-L6. MOVE II-VAL TO FA19 EXP-D AEXPF.
    IF PH-HAND + PH-ORDER<PH-DEMAND MOVE "*" TO FA20 EXP-A. AEXPF.
    IF PH-HAND + PH-ORDER - PH-DEMAND<0.9 * PH-ROP MOVE "*" TO FA21 EXP-A. AEXPF.
    IF NOT Y1 GO II-L9. IF II-KTRAN=0 GO II-L8.

    INITIALIZE II-TRTBL IX1 PT-KEY MOVE PH-NO TO PT-PART.
    START PARTRANS KEY>PT-KEY REGARDLESS INVALID GO II-L78.
II-L73. READ PARTRANS NEXT REGARDLESS END GO II-L78. IF PT-PART NOT=PH-NO GO II-L78.
    IF NOT(PT-TRANS="ISS" OR "OUT" OR "ADJ") GO II-L73.
    IF IX1<5 ADD 1 TO IX1 GO II-L74.
    PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>4
      MOVE II-TRX(IX2 + 1) TO II-TRX(IX2) END-PERFORM.
II-L74. MOVE PT-TRANS TO II-TRANS(IX1) MOVE PT-DATE TO II-TDATE(IX1).
    MOVE PT-QTY TO II-TQTY(IX1) GO II-L73.
II-L78. PERFORM VARYING IX1 FROM 5 BY -1 UNTIL IX1=0 OR II-TRANS(IX1)>" " CONTINUE END-PERFORM.
    MOVE IX1 TO WN1.
    PERFORM UNTIL IX1=0 MOVE II-TRANS(IX1) TO EXP-A PERFORM EXPF
      MOVE II-TDATE(IX1) TO D-DATE PERFORM D-NM MOVE D-DT TO EXP-DT PERFORM EXPF
      MOVE II-TQTY(IX1) TO EXP-N PERFORM EXPF SUBTRACT 1 FROM IX1 END-PERFORM.
    COMPUTE A-N1=3 * (5 - WN1) PERFORM EXPFN.
II-L8. PERFORM EXP-LINE.
II-L9. EXIT.
    REPLACE OFF.
II-P. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>9
       IF NOT(II-XPH(IX1)=0 AND II-XPV(IX1)=0)
         MOVE "PROCESS" TO FA66 COMPUTE FA67=IX1 - 1 MOVE ":" TO FA68
         MOVE II-XPH(IX1) TO FA14 MOVE II-XPV(IX1) TO FA19
         IF II-KPR=1 MOVE II-XPRICE(IX1) TO FA18 END-IF
         PERFORM II-LINE END-IF END-PERFORM.
II-M. MOVE II-NP2 TO WS-PR MOVE OLD-M TO FA9 MOVE "MACHINE TYPE TOTALS" TO FA10.
    MOVE II-MH TO FA14 MOVE II-MV TO FA19 PERFORM II-LINE.
    MOVE II-MPTOT TO II-XPTOT MOVE 0 TO II-KPR PERFORM II-P.
    PERFORM II-LINE II-NP2 TIMES MOVE LOW-VALUES TO II-MTOTALS.
II-C. MOVE II-NP2 TO WS-PR MOVE OLD-N TO FA9 MOVE "CATEGORY TOTALS" TO FA10.
    MOVE II-CH TO FA14 MOVE II-CV TO FA19 PERFORM II-LINE.
    MOVE II-CPTOT TO II-XPTOT MOVE 0 TO II-KPR PERFORM II-P.
    PERFORM II-LINE II-NP2 TIMES MOVE LOW-VALUES TO II-CTOTALS.
II-R. MOVE II-OGROUP TO FA7 MOVE "-" TO FA8.
    COMPUTE FA9=II-GROUP - 1 MOVE "CATEGORY GROUP TOTALS" TO FA10.
    MOVE II-RH TO FA14 MOVE II-RV TO FA19 PERFORM II-LINE.
    MOVE II-RPTOT TO II-XPTOT MOVE 0 TO II-KPR PERFORM II-P.
    PERFORM II-LINE 2 TIMES MOVE LOW-VALUES TO II-RTOTALS.
II-A. MOVE 2 TO WS-PR MOVE OLD-N TO FA9 MOVE "CATEGORY TOTALS" TO FA10.
    MOVE II-AS TO FA817 MOVE II-AV TO FA818 PERFORM II-LINE 2 TIMES.
    MOVE LOW-VALUES TO II-ATOTALS.
II-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM II-PAGE.
II-PAGE. MOVE "INVENTORY REPORT" TO FF3.
    IF Y1 MOVE "** BY CATEGORY **" TO FF4
      IF II-KFULL=1 MOVE "** BY CATEGORY (FULL REPORT) **" TO FF4 END-IF
      IF II-KSHORT=1 MOVE "** BY CATEGORY (SHORTAGE REPORT) **" TO FF4 END-IF.
    IF Y2 MOVE "** BY MACHINE TYPE **" TO FF4.
    IF Y3 MOVE "** TOOL SURPLUS **" TO FF4.
    IF Y1 OR Y3 PERFORM PR-IPAGE ELSE PERFORM PR-PAGE. MOVE 2 TO WS-PR.
    IF Y1 PERFORM PRANGE-PCAT
      IF II-KSHORT=1 MOVE "INCLUDES ONLY PARTS WITH MINIMUM R.O.P.:" TO FA52
        MOVE II-MIN TO FA53 MOVE 1 TO WS-PR PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF Y2 PERFORM PRANGE-MAC. IF Y3 PERFORM PRANGE-PCAT.
    IF Y1 OR Y2 MOVE
         "PART NO.     DRAWING        DESCRIPTION                  ON HAND  ON ORDER BLK  DEMAND  LIFE  R.O.P. L3  LD COST  VAL ON HAND  DM BL" TO PREC.
*         ............ .............. .......................... ....,...- ....,...- .. ....,...- .... ...,...-. .,...:... .,...,...:..-  .  .
    IF Y3 MOVE
         "PART NO.     DRAWING        DESCRIPTION                        ON HAND   ON ORDER   DEMAND    LD COST   SURPLUS       VALUE" TO PREC.
*         ............ .............. ................................ ....,...- ....,...- ....,...-  .,...:... ....,...- .,...,...:..-
    PERFORM PR-LINE-3.

* Z-20-2 EMPTY BINS REPORT
EV1. PERFORM RD155 PERFORM WRT IF S-BAT GO EV2.
    MOVE 3 TO IXT MOVE 12 TO IXU MOVE 34 TO IXV PERFORM AX-PBIN-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
EV2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM EV-PAGE MOVE 1 TO PR-IXP.
    MOVE PBIN1 TO BH-NO START PURBIN KEY>BH-KEY REGARDLESS INVALID GO EV9.
EV3. READ PURBIN NEXT REGARDLESS END GO EV9. IF BH-NO>PBIN2 GO EV9.
    IF BH-QTY NOT=0 GO EV3.
    MOVE BH-NO TO FA22(PR-IXP) MOVE BH-PART TO FA23(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>5 PERFORM EV-LINE MOVE 1 TO PR-IXP. GO EV3.
EV9. PERFORM PR-LASTLN PERFORM CLOSE-PR GO MX9.

EV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM EV-PAGE.
EV-PAGE. MOVE "EMPTY BINS REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PBIN PERFORM PR-LINE-2.

* Z-20-3 BIN CONTENTS REPORT
BD1. PERFORM RD156 PERFORM WRT IF S-BAT MOVE S-S1 TO BD-KBIN GO BD2.
BD13. MOVE 0 TO BD-KBIN ACCEPT XA1 LINE 3 COLUMN 20 DEFAULT " " UNDERLINED PROTECTED.
    IF XA1=" " ACCEPT XA1 LINE 4 COLUMN 20 DEFAULT " " UNDERLINED PROTECTED
      IF XA1>" " MOVE 1 TO BD-KBIN ELSE PERFORM DSP-ERR14 GO BD13.
    IF BD-KBIN=0 MOVE 3 TO IXT MOVE 43 TO IXU MOVE 66 TO IXV PERFORM AX-PCAT-R
      ELSE MOVE 4 TO IXT MOVE 38 TO IXU MOVE 61 TO IXV PERFORM AX-PBIN-R.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE BD-KBIN TO S-S1 GO MX9.
BD2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM BD-PAGE.
    MOVE 0 TO BD-KMAT MOVE LOW-VALUES TO BD-GTOTALS.
    IF BD-KBIN=0 INITIALIZE BH-KP START PURBIN KEY>BH-KP REGARDLESS INVALID GO BD9 END-START
      ELSE MOVE PBIN1 TO BH-NO START PURBIN KEY>=BH-KEY REGARDLESS INVALID GO BD9.
BD3. READ PURBIN NEXT REGARDLESS END GO BD9. IF BD-KBIN=1 IF BH-NO>PBIN2 GO BD9.
    IF BH-PART=" " OR BH-QTY=0 GO BD3.
    MOVE BH-NO TO FA24 MOVE BH-PART TO FA25 MOVE BH-QTY TO FA27.
    MOVE BH-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA28.
    MOVE BH-PART TO PH-NO READ PART REGARDLESS INVALID
      MOVE "*** NO PART RECORD ***" TO FA26 PERFORM BD-LINE GO BD8.
    IF BD-KBIN=0 IF NOT(PH-CAT>=PCAT1 AND<=PCAT2) MOVE " " TO PREC GO BD8.
    PERFORM PART-TYPE MOVE PH-DESC1 TO FA26.
    IF PART-MAT MOVE BH-PCODE TO FA25A MOVE BH-COILS TO FA29 MOVE BH-HEAT TO FA30
      MOVE 1 TO BD-KMAT ADD BH-QTY TO BD-GQ ADD BH-COILS TO BD-GC.
    PERFORM BD-LINE IF PH-DESC2>" " MOVE PH-DESC2 TO FA26 PERFORM BD-LINE.
BD8. GO BD3.
BD9. IF BD-KMAT=1 MOVE 3 TO WS-PR MOVE "*** MATERIAL TOTALS" TO FA26
       MOVE BD-GQ TO FA27 MOVE BD-GC TO FA29 PERFORM PR-LINE.
    PERFORM CLOSE-PR GO MX9.

BD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM BD-PAGE.
BD-PAGE. MOVE "BIN CONTENTS REPORT" TO FF3.
    IF BD-KBIN=0 MOVE "** BY PART **" TO FF4
      ELSE MOVE "** BY BIN **" TO FF4.
    PERFORM PR-PAGE MOVE 2 TO WS-PR.
    IF BD-KBIN=0 PERFORM PRANGE-PCAT ELSE PERFORM PRANGE-PBIN.
    MOVE "BIN      PART NO.   PROC  DESCRIPTION                            QTY      SINCE    COILS  HEAT" TO PREC PERFORM PR-LINE-3.
*         ......   ............ .   ................................ ..,...,...-  ../../..  .,...-  ..........

* Z-20-4 BIN INVALID CONTENTS REPORT
IB1. PERFORM RD157 PERFORM WRT IF S-BAT GO IB2.
    MOVE 5 TO IXT MOVE 12 TO IXU MOVE 34 TO IXV PERFORM AX-PBIN-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
IB2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM IB-PAGE MOVE 1 TO PR-IXP.
    MOVE PBIN1 TO BH-NO START PURBIN KEY>BH-KEY REGARDLESS INVALID GO IB9.
IB3. READ PURBIN NEXT REGARDLESS END GO IB9. IF BH-NO>PBIN2 GO IB9.
    IF NOT(BH-PART=" " AND BH-QTY NOT=0) GO IB3. MOVE BH-NO TO FA59(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>13 PERFORM IB-LINE MOVE 1 TO PR-IXP. GO IB3.
IB9. PERFORM PR-LASTLN PERFORM CLOSE-PR GO MX9.

IB-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM IB-PAGE.
IB-PAGE. MOVE "BIN INVALID CONTENTS REPORT" TO FF3.
    MOVE "** BINS THAT HAVE A QUANTITY BUT NO PART **" TO FF4 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PBIN PERFORM PR-LINE-2.

* Z-20-5 PART LOCATION REPORT
PN1. PERFORM RD160 PERFORM WRT IF S-BAT MOVE S-S1 TO PN-KFIN GO PN2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 42 TO IXV PERFORM AX-PART-R.
    ACCEPT XA3 LINE 5 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO PN-KFIN ELSE MOVE 0 TO PN-KFIN.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE PN-KFIN TO S-S1 GO MX9.
PN2. PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM PN-PAGE.
    MOVE PART1 TO PH-NO START PART KEY>=PH-KEY REGARDLESS INVALID GO PN9.
PN3. READ PART NEXT REGARDLESS END GO PN9. IF PH-NO>PART2 GO PN9.
    MOVE PH-NO TO FA57 MOVE 1 TO PR-IXP INITIALIZE BH-KP MOVE PH-NO TO BH-PART.
    START PURBIN KEY>=BH-KP REGARDLESS INVALID GO PN6.
PN5. READ PURBIN NEXT REGARDLESS END GO PN6. IF BH-PART NOT=PH-NO GO PN6.
    MOVE BH-NO TO FA58(PR-IXP).
    ADD 1 TO PR-IXP IF PR-IXP>11 PERFORM PN-LINE MOVE 1 TO PR-IXP. GO PN5.
PN6. IF PN-KFIN=1 OR PR-IXP>1 PERFORM PN-LINE. GO PN3.
PN9. PERFORM CLOSE-PR GO MX9.

PN-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PN-PAGE.
PN-PAGE. MOVE "PART LOCATION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PART PERFORM PR-LINE.

* Z-20-6 DELETE OLD ORDERS
DV1. PERFORM RD161 PERFORM WRT IF S-BAT GO DV2.
    MOVE 3 TO IXT MOVE 23 TO IXU PERFORM AX-DT-VAL.
    MOVE 7 TO IXT PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
DV2. PERFORM DSP-WAIT MOVE " " TO DV-ORD.
DV3. MOVE DV-ORD TO OK-NO MOVE 0 TO DV-IXD.
    START PURORD KEY>OK-KEY REGARDLESS INVALID GO DV9.
DV33. READ PURORD NEXT REGARDLESS END GO DV9. MOVE OK-NO TO DV-ORD.
    IF OK-BLANKET=1 OR OK-DATE>=DATE0 GO DV33.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO DV6.
DV5. READ PURLIN NEXT REGARDLESS END GO DV6. IF LK-ORD NOT=OK-NO GO DV6.
    IF LK-QTY-REC<LK-QTY GO DV88. GO DV5.
DV6. DELETE PURORD MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO DV8.
DV7. READ PURLIN NEXT REGARDLESS END GO DV8. IF LK-ORD NOT=OK-NO GO DV8.
    DELETE PURLIN GO DV7.
DV8. ADD 1 TO DV-IXD IF DV-IXD>50 CLOSE PURORD PURLIN
      OPEN I-O PURORD ALLOWING ALL PURLIN ALLOWING ALL GO DV3.
DV88. GO DV33.
DV9. GO MX9.

* Z-20-7 PURCHASE ORDERS DUE REPORT
PD1. PERFORM RD159 PERFORM WRT IF S-BAT GO PD2.
    MOVE 3 TO IXT MOVE 15 TO IXU MOVE 37 TO IXV PERFORM AX-VEN-R.
    MOVE 5 TO IXT MOVE 51 TO IXU MOVE 70 TO IXV PERFORM AX-DATE-R.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
PD2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO OK-KEY START PURORD KEY>OK-KEY REGARDLESS INVALID GO PD29.
PD23. READ PURORD NEXT REGARDLESS END GO PD29. IF OK-HOLD=1 OR OK-BLANKET=1 GO PD23.
    IF NOT((OK-VENDOR>=VEN1 AND<=VEN2) AND (OK-DATE-REQ>=DATE1 AND<=DATE2)) GO PD23.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO PD26.
PD25. READ PURLIN NEXT REGARDLESS END GO PD26. IF LK-ORD NOT=OK-NO GO PD26.
    IF LK-QTY>LK-QTY-REC PERFORM INIT-RP
      MOVE OK-VENDOR TO RP-F111 MOVE OK-KEY TO RP-F112 WRITE RP-RECORD GO PD26.
* note 104
    GO PD25.
PD26. GO PD23.
PD29. PERFORM OPEN-PR PERFORM PD-PAGE MOVE 0 TO PD-VAMT PD-GAMT OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PD9.
PD3. READ REPFL NEXT END GO PD9. MOVE RP-F112 TO OK-KEY READ PURORD REGARDLESS.
    IF OK-VENDOR=OLD-N GO PD4. IF OLD-N NOT=0 PERFORM PD-V.
    MOVE "VENDOR" TO FA182 MOVE OK-VENDOR TO OLD-N FA183 A-N1 PERFORM RD-VEN.
    MOVE V-NAME TO FA184 PERFORM PD-LINE 2 TIMES.
PD4. MOVE 2 TO WS-PR MOVE OK-NO TO FA185.
    MOVE OK-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA186.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA187.
    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO PD6.
PD5. READ PURLIN NEXT REGARDLESS END GO PD6. IF LK-ORD NOT=OK-NO GO PD6.
    IF LK-QTY<=LK-QTY-REC GO PD5.
    MOVE LK-QTY TO FA188 MOVE LK-QTY-REC TO FA188A.
    MOVE LK-UNIT TO FA189 MOVE LK-PART TO FA190 MOVE LK-DESC1 TO FA191.
    MOVE LK-PRICE TO FA192 MOVE LK-MODE TO FA193.
    COMPUTE CL-QTY=LK-QTY - LK-QTY-REC PERFORM KPRICE-CALC.
    MOVE CL-AMT TO FA194 ADD CL-AMT TO PD-VAMT PD-GAMT PERFORM PD-LINE.
    IF LK-DESC2>" " MOVE LK-DESC2 TO FA191 PERFORM PD-LINE.
    IF LK-DRAW>" " PERFORM DRAW-EXP-LK
      MOVE "DRAWING:" TO FA191 MOVE A-A2 TO FA191(10:) PERFORM PD-LINE.
    GO PD5.
PD6. GO PD3.
PD9. PERFORM PD-V MOVE 2 TO WS-PR.
    MOVE "*** GRAND TOTAL:" TO FA195 MOVE PD-GAMT TO FA196 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

PD-V. MOVE 2 TO WS-PR MOVE "**  VENDOR TOTAL:" TO FA195 MOVE PD-VAMT TO FA196.
    PERFORM PD-LINE 4 TIMES MOVE 0 TO PD-VAMT.
PD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PD-PAGE.
PD-PAGE. MOVE "PURCHASE ORDERS DUE REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "DUE DURING:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE 1 TO WS-PR PERFORM PRANGE-VEN.
    MOVE "ORDER      DATE   REQUIRED        QTY      RECVD  UNIT  PART NO.     DESCRIPTION                           PRICE  MODE     TOTAL" TO PREC PERFORM PR-LINE-3.
*         ........ ../../.. ../../.. ..,...,...- .,...,...- ....  ............ ................................ ...,...:... .... ...,...:..

* Z-20-8 PURCHASE HISTORY REPORTS
PA1. PERFORM RD172 PERFORM WRT.
    IF S-BAT MOVE S-A1 TO PA-PART MOVE S-N1 TO PA-NGL MOVE S-S1 TO PA-KEF
      MOVE S-S2 TO PA-KRAN GO PA2.
    PERFORM AX-SEL IF SEL-N=0 OR>6 GO MX1.
    IF Y2 GO PA12. IF Y3 GO PA14. IF Y4 OR Y5 OR Y6 GO PA18.
* Y1
    ACCEPT PA-PART LINE 3 COLUMN 57 DEFAULT " " UNDERLINED PROTECTED EDITING.
    GO PA18.
PA12. MOVE 4 TO IXT MOVE 67 TO IXU MOVE 74 TO IXV PERFORM AX-VEN-R.
    MOVE 5 TO IXT MOVE 63 TO IXU PERFORM AX-SUM-S.
    ACCEPT XA3 LINE 6 COLUMN 73 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO PA-KRAN ELSE MOVE 0 TO PA-KRAN. GO PA18.
PA14. MOVE 0 TO PA-NGL MOVE 6 TO IXT.
PA15. ADD 1 TO PA-NGL IXT MOVE 58 TO IXU MOVE 0 TO WS-GL PERFORM AX-GL.
    IF WS-GL=0 SUBTRACT 1 FROM PA-NGL GO PA16. MOVE WS-GL TO RGL(PA-NGL).
    IF PA-NGL<5 GO PA15.
PA16.
PA18. MOVE 17 TO IXT MOVE 48 TO IXU PERFORM AX-DT-INV.
    IF DATE0>0 MOVE 1 TO PA-KEF MOVE DATE0 TO DATE1
      MOVE 68 TO IXU PERFORM AX-DT-VAL MOVE DATE0 TO DATE2
     ELSE MOVE 0 TO AP-KEF MOVE 18 TO IXT MOVE 48 TO IXU MOVE 68 TO IXV PERFORM AX-DATE-R.
    MOVE 20 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE PA-PART TO S-A1 MOVE PA-NGL TO S-N1 MOVE PA-KEF TO S-S1
      MOVE PA-KRAN TO S-S2 GO MX9.
PA2. PERFORM DSP-WAIT.
    IF Y2 GO PA4. IF Y3 OR Y4 OR Y5 GO PA6. IF Y6 GO PA8.

* Y1
    PERFORM INIT-PH MOVE PA-PART TO PH-NO MOVE 0 TO PA-KFIN.
    READ PART REGARDLESS INVALID MOVE 1 TO PA-KFIN MOVE "** INVALID PART **" TO PH-DESC1.
    MOVE " " TO PA-TITLE STRING "FOR: " PA-PART "  " PH-DESC1 DELIMITED SIZE INTO PA-TITLE.
    PERFORM OPEN-REP INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV MOVE PA-PART TO PU-PART.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO PA29.
PA23. READ PURHIST NEXT REGARDLESS END GO PA29.
    IF PU-DIV>WS-DIV OR PU-PART>PA-PART GO PA29. PERFORM PA-R IF A-S1=0 GO PA23.
    PERFORM INIT-RP MOVE PU-VENDOR TO RP-F177 MOVE PU-KEY TO RP-F178.
    WRITE RP-RECORD GO PA23.
PA29. PERFORM OPEN-PR MOVE 1 TO PA-STEP PERFORM PA-PAGE.
    MOVE LOW-VALUES TO PA-CTOTALS PA-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PA39.
PA33. READ REPFL NEXT END GO PA39. MOVE RP-F178 TO PU-KEY READ PURHIST REGARDLESS.
    IF PU-VENDOR=OLD-N GO PA34. IF OLD-N NOT=0 PERFORM PA-S.
    MOVE PU-VENDOR TO OLD-N FA311 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA312.
    PERFORM PA-LINE 2 TIMES.
PA34. PERFORM PA-P PERFORM PA-LINE GO PA33.
PA39. PERFORM PA-S PERFORM PA-G.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO PA9.

PA4. MOVE "FOR SELECTED VENDORS" TO PA-TITLE PERFORM OPEN-REP.
    INITIALIZE PU-KV MOVE WS-DIV TO PU-VDIV MOVE VEN1 TO PU-VENDOR.
    START PURHIST KEY>PU-KV REGARDLESS INVALID GO PA419.
PA413. READ PURHIST NEXT REGARDLESS END GO PA419.
    IF PU-DIV>WS-DIV OR PU-VENDOR>VEN2 GO PA419. PERFORM PA-R IF A-S1=0 GO PA413.
    PERFORM INIT-RP MOVE PU-VENDOR TO RP-F177 MOVE PU-KEY TO RP-F178.
    WRITE RP-RECORD GO PA413.
PA419. PERFORM OPEN-SORT PERFORM OPEN-PR MOVE 1 TO PA-STEP PERFORM PA-PAGE.
    MOVE LOW-VALUES TO PA-VTOTALS PA-CTOTALS PA-GTOTALS.
    MOVE 0 TO OLD-N MOVE " " TO OLD-A.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PA49.
PA43. READ REPFL NEXT END GO PA49. MOVE RP-F178 TO PU-KEY READ PURHIST REGARDLESS.
    IF PU-VENDOR=OLD-N GO PA432. IF OLD-N>0 PERFORM PA-L PERFORM PA-V.
    MOVE PU-VENDOR TO OLD-N FA311 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA312.
    IF SUM-IND=0 PERFORM PA-LINE 2 TIMES ELSE MOVE " " TO PREC.
PA432. IF PU-PART=OLD-A GO PA48. IF OLD-A>" " PERFORM PA-L.
    MOVE PU-PART TO OLD-A FA326.
    PERFORM INIT-PH MOVE PU-PART TO PH-NO MOVE 0 TO PA-KFIN.
    READ PART REGARDLESS INVALID MOVE 1 TO PA-KFIN MOVE "** NOT FOUND **" TO PH-DESC1.
    MOVE PH-DESC1 TO FA327.
PA48. PERFORM PA-P IF SUM-IND=0 PERFORM PA-LINE ELSE MOVE " " TO PREC.
    MOVE PU-VENDOR TO SR-F127.
    MOVE PU-QTY TO SR-F128 MOVE PU-AMT TO SR-F129 MOVE PA-LDA TO SR-F130.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD PU-QTY TO SR-F128 ADD PU-AMT TO SR-F129 ADD PA-LDA TO SR-F130 REWRITE SR-RECORD.
    GO PA43.
PA49. PERFORM PA-L PERFORM PA-V PERFORM PA-G.
    PERFORM CLOSE-REP.

    IF PA-KRAN=0 GO PA59. PERFORM OPEN-REP.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO PA54.
PA53. READ SORTFL NEXT END GO PA54. PERFORM INIT-RP.
    IF SR-F129>0 MOVE 0 TO RP-F368 COMPUTE RP-F368A=999999999 - SR-F129
      ELSE MOVE 1 TO RP-F368 COMPUTE RP-F368A=-SR-F129.
    MOVE SR-F127 TO RP-F369 MOVE SR-F128 TO RP-F370 MOVE SR-F129 TO RP-F371.
    MOVE SR-F130 TO RP-F372 WRITE RP-RECORD GO PA53.
PA54. MOVE 2 TO PA-STEP MOVE "TOP 25 VENDOR RANKING" TO PA-TITLE PERFORM PA-PAGE.
    MOVE 0 TO WN1 MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PA58.
PA55. READ REPFL NEXT END GO PA58. ADD 1 TO WN1 IF WN1>25 GO PA58.
    MOVE WN1 TO FA338.
    MOVE RP-F369 TO FA339 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA339A.
    MOVE RP-F370 TO FA340 MOVE RP-F371 TO FA340A MOVE RP-F372 TO FA340B.
    PERFORM PA-LINE GO PA55.
PA58. PERFORM CLOSE-REP.
PA59. PERFORM CLOSE-SORT PERFORM CLOSE-PR GO PA9.

PA6. IF Y3 MOVE "FOR SELECTED G/L ACCOUNTS" TO PA-TITLE.
    IF Y4 MOVE "FOR RAW MATERIALS" TO PA-TITLE.
    IF Y5 MOVE "FOR PURCHASED FINISHED GOODS" TO PA-TITLE.
    PERFORM OPEN-REP INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO PA629.
PA623. READ PURHIST NEXT REGARDLESS END GO PA629. IF PU-DIV>WS-DIV GO PA629.
    PERFORM PA-R IF A-S1=0 GO PA623.
    IF Y3 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>PA-NGL
      IF PU-GL=RGL(IX1) GO PA626 END-IF END-PERFORM.
    IF Y4 MOVE PU-GL TO WS-GL
      IF WS-GL1=424401 AND WS-GL2=0 AND WS-GL3=0 GO PA626.
    IF Y5 MOVE PU-GL TO WS-GL
      IF IFAST AND WS-GL1=426301 OR INUT AND (WS-GL1=344725 OR 344728) GO PA626.
    GO PA623.
PA626. PERFORM INIT-RP MOVE PU-VENDOR TO RP-F177 MOVE PU-KEY TO RP-F178.
    WRITE RP-RECORD GO PA623.
PA629.

    PERFORM OPEN-PR MOVE 1 TO PA-STEP PERFORM PA-PAGE.
    IF Y4 OR Y5 PERFORM OPEN-SORT.
    MOVE LOW-VALUES TO PA-CTOTALS PA-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PA68.
PA63. READ REPFL NEXT END GO PA68. MOVE RP-F178 TO PU-KEY READ PURHIST REGARDLESS.
    IF PU-VENDOR=OLD-N GO PA64. IF OLD-N NOT=0 PERFORM PA-S.
    MOVE PU-VENDOR TO OLD-N FA311 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA312.
    PERFORM PA-LINE 2 TIMES.
PA64. PERFORM INIT-PH MOVE PU-PART TO PH-NO MOVE 0 TO PA-KFIN.
    READ PART REGARDLESS INVALID MOVE 1 TO PA-KFIN. IF Y5 PERFORM PA-W.
    PERFORM PA-P PERFORM PA-LINE.

    IF Y3 GO PA66. IF Y4 GO PA652. IF Y5 GO PA654.
PA652. MOVE PU-PART TO A-A1 PERFORM STR-LTH.
    MOVE 0 TO IX1 INSPECT PU-PART TALLYING IX1 FOR CHARACTERS BEFORE "-".
    IF IX1 + 2<=A-N1 MOVE PU-PART(IX1 + 2:) TO PA-GRADE ELSE MOVE " " TO PA-GRADE.
    MOVE PU-VENDOR TO SR-F35 MOVE PA-GRADE TO SR-F36.
    MOVE PU-QTY TO SR-F37 MOVE PA-LDA TO SR-F37B.
    WRITE SR-RECORD INVALID READ SORTFL
      ADD PU-QTY TO SR-F37 ADD PA-LDA TO SR-F37B REWRITE SR-RECORD.
    GO PA66.
PA654. MOVE PU-VENDOR TO SR-F35 MOVE PA-CAT TO SR-F36A.
    MOVE PU-QTY TO SR-F37 MOVE PA-WEIGHT TO SR-F37A MOVE PA-LDA TO SR-F37B.
    WRITE SR-RECORD INVALID READ SORTFL ADD PU-QTY TO SR-F37
      ADD PA-WEIGHT TO SR-F37A ADD PA-LDA TO SR-F37B REWRITE SR-RECORD.
    GO PA66.
PA66. GO PA63.
PA68. PERFORM PA-S PERFORM PA-G.
    PERFORM CLOSE-REP.

    IF Y3 GO PA69. MOVE 2 TO PA-STEP.
    IF Y4 MOVE "FOR RAW MATERIALS - GRADE SUMMARY" TO PA-TITLE.
    IF Y5 MOVE "FOR PURCHASED FINISHED GOODS - CATEGORY SUMMARY" TO PA-TITLE.
    PERFORM PA-PAGE.
    MOVE LOW-VALUES TO PA-CTOTALS PA-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO PA688.
PA683. READ SORTFL NEXT END GO PA688.
    IF SR-F35=OLD-N GO PA684. IF OLD-N NOT=0 PERFORM PA-T.
    MOVE SR-F35 TO OLD-N FA313 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA314.
PA684. IF Y4 MOVE SR-F36 TO FA315 MOVE SR-F37 TO FA316 MOVE SR-F37B TO FA317.
    IF Y5 MOVE SR-F36A TO FA320 MOVE SR-F37 TO FA321
      MOVE SR-F37A TO FA322 MOVE SR-F37B TO FA323.
    ADD SR-F37 TO PA-CQTY PA-GQTY IF Y5 ADD SR-F37A TO PA-CWEIGHT PA-GWEIGHT.
    ADD SR-F37B TO PA-CLDA PA-GLDA PERFORM PA-LINE GO PA683.
PA688. PERFORM PA-T MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    IF Y4 MOVE PA-GQTY TO FA316 MOVE PA-GLDA TO FA317
      COMPUTE FA318 ROUNDED=PA-GLDA * 2000 / PA-GQTY SIZE ERROR CONTINUE.
    IF Y5 MOVE PA-GQTY TO FA321 MOVE PA-GWEIGHT TO FA322 MOVE PA-GLDA TO FA323.
    PERFORM PR-LINE.
    PERFORM CLOSE-SORT.
PA69. PERFORM CLOSE-PR GO PA9.

PA8. MOVE "FOR PURCHASED FINISHED GOODS - BY INVOICE" TO PA-TITLE.
    PERFORM OPEN-REP INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO PA829.
PA823. READ PURHIST NEXT REGARDLESS END GO PA829. IF PU-DIV>WS-DIV GO PA829.
    PERFORM PA-R IF A-S1=0 GO PA823. MOVE PU-GL TO WS-GL.
    IF NOT(IFAST AND WS-GL1=426301 OR INUT AND (WS-GL1=344725 OR 344728)) GO PA823.
    PERFORM PA-W PERFORM INIT-RP MOVE PU-INV TO RP-F452.
    MOVE PU-VENDOR TO RP-F453 COMPUTE RP-F454=999999 - PU-ZDATE PERFORM PA-AT.
    WRITE RP-RECORD INVALID READ REPFL PERFORM PA-AT REWRITE RP-RECORD.
    GO PA823.
PA829.

    PERFORM OPEN-PR PERFORM PA-PAGE MOVE LOW-VALUES TO PA-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PA89.
PA83. READ REPFL NEXT END GO PA89. MOVE RP-F452 TO FD534.
    MOVE RP-F454 TO D-DATE PERFORM D-NM MOVE D-DT TO FD535.
    MOVE RP-F455 TO FD536 MOVE RP-F456 TO FD537 MOVE RP-F457 TO FD538.
    MOVE RP-F453 TO FD539 A-N1 PERFORM RD-VEN MOVE V-NAME TO FD540.
    ADD RP-F455 TO PA-GQTY ADD RP-F456 TO PA-GWEIGHT ADD RP-F457 TO PA-GAMT.
    PERFORM PA-LINE GO PA83.
PA89. MOVE "** TOTALS" TO FD534 MOVE PA-GQTY TO FD536 MOVE PA-GWEIGHT TO FD537.
    MOVE PA-GAMT TO FD538 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO PA9.

PA9. GO MX9.

PA-AT. ADD PU-QTY TO RP-F455 ADD PA-WEIGHT TO RP-F456 ADD PU-AMT TO RP-F457.
PA-R. MOVE 0 TO A-S1.
    IF PA-KEF=1 AND (999999 - PU-ZDATE>=DATE1 AND<=DATE2)
      OR PA-KEF=0 AND (PU-INV-DATE>=DATE1 AND<=DATE2) MOVE 1 TO A-S1.
PA-W. MOVE PU-PART TO A-A1 PERFORM STR-LTH.
    IF INUT AND A-N1>2 AND PU-PART(A-N1 - 1:1)="-" SUBTRACT 2 FROM A-N1.
    MOVE PU-PART(1:A-N1) TO A-A1 PERFORM PROD-RT.
    MOVE P-CAT TO PA-CAT COMPUTE PA-WEIGHT ROUNDED=PU-QTY * P-WEIGHT / 100.
PA-P. PERFORM PA-P1 THRU PA-P9.
PA-P1. IF PA-KFIN=1 MOVE PU-CAT TO PH-CAT MOVE PU-MODE TO PH-MODE.
* note 96
    PERFORM PART-TYPE.
    COMPUTE A-T1=PU-QTY * PU-LDCOST PERFORM DIV-PAMT COMPUTE PA-LDA ROUNDED=A-T1.
    IF Y5 MOVE PU-PART TO FA341 MOVE PU-ORD TO FA341A MOVE PU-INV TO FA341B
      COMPUTE D-DATE=999999 - PU-ZDATE PERFORM D-NM MOVE D-DT TO FA342
      MOVE PU-QTY TO FA343 MOVE PA-WEIGHT TO FA344 MOVE PU-AMT TO FA345
      MOVE PU-LDCOST TO FA346 MOVE PA-LDA TO FA347
     ELSE IF Y1 OR Y3 OR Y4 MOVE PU-PART TO FA331 END-IF
      MOVE PU-ORD TO FA331A MOVE PU-INV TO FA331B
      COMPUTE D-DATE=999999 - PU-ZDATE PERFORM D-NM MOVE D-DT TO FA332
      MOVE PU-QTY TO FA333 MOVE PU-AMT TO FA335 MOVE PU-LDCOST TO FA336
      MOVE PA-LDA TO FA337.
    IF Y2 MOVE PU-DATE-REQ TO D-DATE MOVE 3 TO D-DAYS PERFORM D-WDIFF
      IF D-DATE<=PU-INV-DATE MOVE "*" TO FA337A ADD PU-QTY TO PA-VLQTY PA-CLQTY PA-GLQTY.
    ADD PU-QTY TO PA-CQTY PA-GQTY ADD PU-AMT TO PA-CAMT PA-GAMT ADD PA-LDA TO PA-CLDA PA-GLDA.
    IF Y2 ADD PU-QTY TO PA-VQTY ADD PU-AMT TO PA-VAMT ADD PA-LDA TO PA-VLDA.
    IF Y5 ADD PA-WEIGHT TO PA-CWEIGHT PA-GWEIGHT.
PA-P9. EXIT.
PA-S. MOVE 2 TO WS-PR MOVE " ** VENDOR TOTALS" TO PREC.
    IF Y5 MOVE PA-CQTY TO FA343 MOVE PA-CWEIGHT TO FA344
      MOVE PA-CAMT TO FA345 MOVE PA-CLDA TO FA347
     ELSE MOVE PA-CQTY TO FA333 MOVE PA-CAMT TO FA335 MOVE PA-CLDA TO FA337.
    PERFORM PA-LINE 2 TIMES MOVE LOW-VALUES TO PA-CTOTALS.
PA-T. MOVE 2 TO WS-PR MOVE " ** VENDOR TOTALS" TO PREC.
    IF Y4 MOVE PA-CQTY TO FA316 MOVE PA-CLDA TO FA317
      COMPUTE FA318 ROUNDED=PA-CLDA * 2000 / PA-CQTY SIZE ERROR CONTINUE.
    IF Y5 MOVE PA-CQTY TO FA321 MOVE PA-CWEIGHT TO FA322 MOVE PA-CLDA TO FA323.
    PERFORM PA-LINE 2 TIMES MOVE LOW-VALUES TO PA-CTOTALS.
PA-V. IF SUM-IND=0 MOVE 2 TO WS-PR MOVE " ** VENDOR TOTALS" TO PREC
       ELSE MOVE OLD-N TO FA311 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA312.
    MOVE PA-VQTY TO FA333 MOVE PA-VAMT TO FA335 MOVE PA-VLDA TO FA337.
    COMPUTE FA337B ROUNDED=PA-VLQTY * 100 / PA-VQTY SIZE ERROR CONTINUE END-COMPUTE.
    MOVE "%" TO FA337C.
    IF SUM-IND=0 PERFORM PA-LINE 2 TIMES ELSE PERFORM PA-LINE.
    MOVE LOW-VALUES TO PA-VTOTALS.
PA-L. PERFORM PA-L1 THRU PA-L9.
PA-L1. IF SUM-IND=1 GO PA-L8. MOVE 2 TO WS-PR MOVE " ** PART TOTALS" TO PREC.
    MOVE PA-CQTY TO FA333 MOVE PA-CAMT TO FA335 MOVE PA-CLDA TO FA337.
    COMPUTE FA337B ROUNDED=PA-CLQTY * 100 / PA-CQTY SIZE ERROR CONTINUE END-COMPUTE.
    MOVE "%" TO FA337C PERFORM PA-LINE 2 TIMES.
PA-L8. MOVE LOW-VALUES TO PA-CTOTALS.
PA-L9. EXIT.
PA-G. MOVE 3 TO WS-PR MOVE "*** GRAND TOTALS" TO PREC.
    IF Y5 MOVE PA-GQTY TO FA343 MOVE PA-GWEIGHT TO FA344
       MOVE PA-GAMT TO FA345 MOVE PA-GLDA TO FA347
      ELSE MOVE PA-GQTY TO FA333 MOVE PA-GAMT TO FA335 MOVE PA-GLDA TO FA337.
    IF Y2 COMPUTE FA337B ROUNDED=PA-GLQTY * 100 / PA-GQTY SIZE ERROR CONTINUE END-COMPUTE
      MOVE "%" TO FA337C.
    PERFORM PR-LINE.
PA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PA-PAGE.
PA-PAGE. MOVE "PURCHASE HISTORY REPORT" TO FF3 MOVE PA-TITLE TO FF4 PERFORM PR-PAGE.
    IF PA-KEF=1 MOVE "EFF. DATE PERIOD:" TO A-A1 ELSE MOVE "INV. DATE PERIOD:" TO A-A1.
    PERFORM PRANGE-DATE.
    IF Y2 MOVE 1 TO WS-PR PERFORM PRANGE-VEN.
    IF Y3 MOVE 1 TO WS-PR MOVE "G/L ACCOUNTS:" TO FA328
      PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>PA-NGL
        MOVE RGL(PR-IX1) TO FA329(PR-IX1)
        IF PR-IX1<PA-NGL MOVE "," TO FA330(PR-IX1) ELSE MOVE "." TO FA330(PR-IX1) END-IF END-PERFORM
      PERFORM PR-LINE MOVE 2 TO WS-PR.
    IF Y1 OR Y3 OR Y4 AND PA-STEP=1 MOVE
         "VENDOR                  PART NO.      ORDER    INVOICE           DATE         QTY        AMOUNT     LD COST   LDC AMOUNT" TO PREC.
*         ....  ....................................
*                                 ............  ........ ............... ../../.. .,...,...- .,...,...:..- ..,...:... .,...,...:..-
    IF Y5 AND PA-STEP=1 MOVE
         "VENDOR                  PART NO.      ORDER    INVOICE           DATE         QTY     WEIGHT        AMOUNT     LD COST   LDC AMOUNT" TO PREC.
*         ....  ....................................
*                                 ............  ........ ............... ../../.. .,...,...- .,...,...- .,...,...:..- ..,...:... .,...,...:..-
    IF Y2 AND PA-STEP=1 IF SUM-IND=0 MOVE
         "PART NO.      DESCRIPTION             ORDER    INVOICE         INV DATE       QTY        AMOUNT     LD COST   LDC AMOUNT    LATE REC" TO PREC
      ELSE MOVE
         "                                                                              QTY        AMOUNT               LDC AMOUNT    LATE REC" TO PREC.
*         ............ ........................ ........ ............... ../../.. .,...,...- .,...,...:..- ..,...:... .,...,...:..-      ...%
    IF Y2 AND PA-STEP=2 MOVE
         "    VENDOR                                            QTY         AMOUNT     LDC AMOUNT" TO PREC.
*         ..  ....  ....................................  .,...,...-  .,...,...:..-  .,...,...:..-
    IF Y4 AND PA-STEP=2 MOVE
         "VENDOR                                      GRADE          QTY        LDC AMOUNT        COST/TON" TO PREC.
*         ....  ....................................  ........   .,...,...-   .,...,...:..-   .,...,...:..-
    IF Y5 AND PA-STEP=2 MOVE
         "VENDOR                                      CAT      QTY        WEIGHT      LDC AMOUNT" TO PREC.
*         ....  ....................................  ..   .,...,...-  .,...,...-   .,...,...:..-
    IF Y6 MOVE
         "INVOICE            DATE         QTY       WEIGHT         AMOUNT   VENDOR" TO PREC.
*         ...............  ../../..  .,...,...-  .,...,...-  .,...,...:..-  ....  ....................................
    PERFORM PR-LINE-3.

* Z-20-9 PURCHASING DISTRIBUTION REPORT
GD1. PERFORM RD173 PERFORM WRT IF S-BAT MOVE S-S1 TO GD-KFUL GO GD2.
    MOVE 3 TO IXT MOVE 22 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.
    MOVE 7 TO IXU MOVE 1 TO IX1.
GD13. ACCEPT GD-GL1(IX1) LINE 6 COLUMN IXU DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF GD-GL1(IX1) NOT=0 ADD 7 TO IXU ADD 1 TO IX1 IF IX1<=10 GO GD13.
    MOVE 0 TO GD-KFUL IF IX1=1 MOVE 1 TO GD-KFUL.
    MOVE 8 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE GD-KFUL TO S-S1 GO MX9.
GD2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE DATE0 TO D-DATE PERFORM D-NM MOVE D-YY TO GD-YY MOVE D-MM TO GD-MM.
    INITIALIZE PU-KEY MOVE WS-DIV TO PU-DIV.
    START PURHIST KEY>PU-KEY REGARDLESS INVALID GO GD29.
GD23. READ PURHIST NEXT REGARDLESS END GO GD29. IF PU-DIV>WS-DIV GO GD29.
    COMPUTE D-DATE=999999 - PU-ZDATE PERFORM D-NM IF NOT(D-YY=GD-YY AND D-MM=GD-MM) GO GD23.
    MOVE PU-GL TO WS-GL IF GD-KFUL=1 GO GD26.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10 OR GD-GL1(IX1)=0
      IF WS-GL1=GD-GL1(IX1) GO GD26 END-IF END-PERFORM.
    GO GD23.
GD26. PERFORM INIT-RP MOVE WS-GL TO RP-F119 MOVE PU-KEY TO RP-F120.
    WRITE RP-RECORD GO GD23.
GD29. PERFORM OPEN-PR PERFORM GD-PAGE.
    MOVE 0 TO GD-SQTY GD-SAMT GD-GAMT MOVE -1 TO GD-OA.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO GD9.
GD3. READ REPFL NEXT END GO GD9. MOVE RP-F120 TO PU-KEY READ PURHIST REGARDLESS.
    MOVE RP-F119 TO WS-GL IF WS-GL=GD-OA GO GD4. IF GD-OA NOT=-1 PERFORM GD-S.
    MOVE WS-GL TO GD-OA INITIALIZE G-REC MOVE WS-DIV TO G-DIV MOVE GD-OA TO G-GL.
    READ GLDIST REGARDLESS INVALID CONTINUE. MOVE G-GL TO FA255 MOVE G-DESC TO FA256.
GD4. MOVE PU-QTY TO FA257 MOVE PU-AMT TO FA258 MOVE PU-PART TO FA260.
    MOVE PU-CAT TO FA261 MOVE PU-VENDOR TO FA262.
    ADD PU-QTY TO GD-SQTY ADD PU-AMT TO GD-SAMT GD-GAMT PERFORM GD-LINE GO GD3.
GD9. PERFORM GD-S MOVE 3 TO WS-PR MOVE "     *** GRAND TOTALS" TO FA256.
    MOVE GD-GAMT TO FA258 MOVE "***" TO FA259 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

GD-S. MOVE 2 TO WS-PR MOVE GD-OA TO FA255 MOVE "      ** TOTALS" TO FA256.
    MOVE GD-SQTY TO FA257 MOVE GD-SAMT TO FA258 MOVE "**" TO FA259.
    PERFORM GD-LINE 3 TIMES MOVE 0 TO GD-SQTY GD-SAMT.
GD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GD-PAGE.
GD-PAGE. MOVE "PURCHASING DISTRIBUTION REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "A/P EFFECTIVE DATE:" TO A-A1 PERFORM PRANGE-DT.
    MOVE 1 TO WS-PR MOVE "ACCOUNTS SELECTED:" TO FA263.
    PERFORM VARYING PR-IX1 FROM 1 BY 1 UNTIL PR-IX1>10 OR GD-GL1(PR-IX1)=0
      MOVE GD-GL1(PR-IX1) TO FA264(PR-IX1) END-PERFORM.
    PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "ACCOUNT                DESCRIPTION                  QTY MTD        AMT MTD       PART NO.     CAT  VENDOR" TO PREC PERFORM PR-LINE-3.
*         ...... ... .. .......  .........................  .,...,...-  .,...,...:..-...   ............ ...   ....

* Z-20-10 PURCHASING PERFORMANCE REPORT
JA1. PERFORM RD318 PERFORM WRT IF S-BAT GO JA2.
    MOVE 3 TO IXT MOVE 17 TO IXU MOVE 39 TO IXV PERFORM AX-PCAT-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
JA2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE " " TO PH-NO START PART KEY>PH-KEY REGARDLESS INVALID GO JA29.
JA23. READ PART NEXT REGARDLESS END GO JA29. IF NOT(PH-CAT>=PCAT1 AND<=PCAT2) GO JA23.
    IF PH-LAST=0 OR PH-ALAST=0 OR PH-YTD=0 GO JA23.
    PERFORM INIT-RP MOVE PH-CAT TO RP-F186 MOVE PH-KEY TO RP-F187.
    WRITE RP-RECORD GO JA23.
JA29. PERFORM OPEN-PR PERFORM JA-PAGE MOVE 0 TO OLD-N.
    COMPUTE JA-OGROUP=PCAT1 / 100 MULTIPLY 100 BY JA-OGROUP.
    MOVE LOW-VALUES TO JA-CTOTALS JA-RTOTALS JA-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JA9.
JA3. READ REPFL NEXT END GO JA9.
    MOVE RP-F187 TO PH-KEY READ PART REGARDLESS PERFORM PART-TYPE.
    IF PH-CAT=OLD-N GO JA4. IF OLD-N NOT=0 PERFORM JA-C. MOVE PH-CAT TO OLD-N.
    COMPUTE JA-GROUP=PH-CAT / 100 MULTIPLY 100 BY JA-GROUP.
    IF JA-GROUP NOT=JA-OGROUP PERFORM JA-R MOVE JA-GROUP TO JA-OGROUP.
    MOVE 4 TO WS-PR MOVE "CAT" TO FA75 MOVE OLD-N TO FA75A.
    IF OLD-N NOT=0 MOVE 10 TO T-TBL MOVE OLD-N TO T-NO
      PERFORM RD-TBL MOVE T-LINE TO FA75B.
    PERFORM JA-LINE 2 TIMES.
JA4. MOVE PH-NO TO FA79 MOVE PH-DESC1 TO FA80.
    MOVE PH-ALAST TO FA81 A-T1 PERFORM MUL-PAMT.
    COMPUTE JA-COST ROUNDED=A-T1 / PH-LAST MOVE JA-COST TO FA82.
    MOVE PH-YTD TO FA83 COMPUTE A-T1=PH-YTD * JA-COST PERFORM DIV-PAMT.
    COMPUTE JA-BAMT ROUNDED=A-T1 MOVE JA-BAMT TO FA84.
    MOVE PH-AYTD TO FA85 COMPUTE FA86=PH-AYTD - JA-BAMT.
    COMPUTE WN1 ROUNDED=(PH-AYTD - JA-BAMT) * 100 / JA-BAMT SIZE ERROR MOVE 0 TO WN1.
    MOVE WN1 TO FA86A IF WN1<0 COMPUTE WN1=-WN1.
    IF WN1<50 ADD PH-AYTD TO JA-CA JA-RA JA-GA ADD JA-BAMT TO JA-CB JA-RB JA-GB
      ELSE MOVE "*" TO FA86B.
    PERFORM JA-LINE GO JA3.
JA9. PERFORM JA-C.
    COMPUTE JA-GROUP=(PCAT2 + 100) / 100 MULTIPLY 100 BY JA-GROUP PERFORM JA-R.
    MOVE 3 TO WS-PR MOVE "GRAND TOTALS" TO FA78.
    MOVE JA-GB TO FA84 MOVE JA-GA TO FA85 COMPUTE FA86=JA-GA - JA-GB.
    COMPUTE FA86A ROUNDED=(JA-GA - JA-GB) * 100 / JA-GB SIZE ERROR CONTINUE.
    PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

JA-C. MOVE 2 TO WS-PR MOVE OLD-N TO FA77 MOVE "CATEGORY TOTALS" TO FA78.
    MOVE JA-CB TO FA84 MOVE JA-CA TO FA85 COMPUTE FA86=JA-CA - JA-CB.
    COMPUTE FA86A ROUNDED=(JA-CA - JA-CB) * 100 / JA-CB SIZE ERROR CONTINUE.
    PERFORM JA-LINE 3 TIMES MOVE LOW-VALUES TO JA-CTOTALS.
JA-R. MOVE JA-OGROUP TO FA76 MOVE "-" TO FA76A.
    COMPUTE FA77=JA-GROUP - 1 MOVE "CATEGORY GROUP TOTALS" TO FA78.
    MOVE JA-RB TO FA84 MOVE JA-RA TO FA85 COMPUTE FA86=JA-RA - JA-RB.
    COMPUTE FA86A ROUNDED=(JA-RA - JA-RB) * 100 / JA-RB SIZE ERROR CONTINUE.
    PERFORM PR-LINE PERFORM JA-PAGE MOVE LOW-VALUES TO JA-RTOTALS.
JA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JA-PAGE.
JA-PAGE. MOVE "PURCHASING PERFORMANCE REPORT" TO FF3 PERFORM PR-IPAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-PCAT.
    MOVE "PART NO.      DESCRIPTION                          BASE AMT   BASE COST   QTY YTD   x BASE COST       AMT YTD     DIFFERENCE   %  ER" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ .,...,...:..-  ..,...:..-  ...,...- .,...,...:..- .,...,...:..- .,...,...:..-  ...- .

* Z-20-11 CONTRACTOR PERFORMANCE REPORT
JI1. PERFORM RD317 PERFORM WRT IF S-BAT GO JI2.
    MOVE 3 TO IXT MOVE 13 TO IXU MOVE 35 TO IXV PERFORM AX-DATE-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
JI2. PERFORM DSP-WAIT PERFORM OPEN-SORT.
    MOVE " " TO J-KEY START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO JI29.
JI23. READ WORKSHEET NEXT REGARDLESS END GO JI29.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF NOT PROC-PRIMARY GO JI24.
    IF NOT(J-DATE>=DATE1 AND<=DATE2) GO JI23. MOVE J-NO TO SR-F77.
    MOVE J-MAC TO SR-F78 MOVE 0 TO SR-F79 SR-F80 MOVE J-PROD TO SR-F81.
    WRITE SR-RECORD INVALID CONTINUE. GO JI28.
JI24. MOVE J-MAC TO A-N1 PERFORM CHK-SUBCON IF A-S1=1 GO JI26.
    MOVE J-MAC TO A-N1 PERFORM PROC-TYPE IF PROC-OUTCON GO JI26.
    GO JI28.
JI26. MOVE J-NO TO SR-F77 MOVE 0 TO SR-F78 SR-F79 SR-F80.
    START SORTFL KEY>SR-KEY INVALID GO JI28. READ SORTFL NEXT END GO JI28.
    IF NOT(SR-F77=J-NO AND SR-F79=0) GO JI28.
    MOVE J-MAC TO SR-F78 MOVE J-DATE TO SR-F79 MOVE 0 TO SR-F80.
    MOVE J-WEIGHT TO SR-F82.
JI27. WRITE SR-RECORD INVALID IF SR-F80<99 ADD 1 TO SR-F80 GO JI27 END-IF.
JI28. GO JI23.
JI29.
* note 39
    PERFORM OPEN-REP MOVE 0 TO JI-NO.
JI3. MOVE " " TO SR-KEY MOVE JI-NO TO SR-F77 MOVE 999 TO SR-F78.
    START SORTFL KEY>SR-KEY INVALID GO JI6.
JI33. READ SORTFL NEXT END GO JI6. IF SR-F79 NOT=0 GO JI33.
    MOVE SR-F77 TO JI-NO MOVE SR-F81 TO JI-PROD OP-PROD MOVE SR-F78 TO OP-MAC.
    READ OPERATIONS REGARDLESS INVALID GO JI3. MOVE 0 TO JI-CNUM MOVE 1 TO IX1.
JI35. MOVE OP-OPER(IX1) TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO JI36.
    MOVE OP-OPER(IX1) TO M-NO READ MACHINE REGARDLESS INVALID GO JI36.
    IF JI-CNUM<3 ADD 1 TO JI-CNUM MOVE M-NO TO JI-CMAC(JI-CNUM)
      MOVE M-LDAYS TO JI-CDAYS(JI-CNUM) MOVE M-OPDESC TO JI-CCON(JI-CNUM).
JI36. ADD 1 TO IX1 IF IX1<=12 GO JI35. IF JI-CNUM=0 GO JI3.

    MOVE 1 TO JI-IXC.
JI5. MOVE JI-CMAC(JI-IXC) TO JI-IMAC A-N1 MOVE JI-IXC TO A-X1.
    PERFORM CALC-OUTCON MOVE A-N1 TO JI-OMAC.

JI51. MOVE " " TO SR-KEY MOVE JI-NO TO SR-F77 MOVE JI-IMAC TO SR-F78.
    MOVE 0 TO SR-F79 SR-F80 START SORTFL KEY>SR-KEY INVALID GO JI59.
JI53. READ SORTFL NEXT END GO JI59.
    IF NOT(SR-F77=JI-NO AND SR-F78=JI-IMAC) GO JI59. IF SR-F82A=1 GO JI53.
    MOVE 1 TO SR-F82A REWRITE SR-RECORD.
    MOVE SR-F82 TO JI-IWEIGHT MOVE SR-F79 TO JI-IDATE.

    MOVE 0 TO JI-OWEIGHT JI-ODATE.
    MOVE " " TO SR-KEY MOVE JI-NO TO SR-F77 MOVE JI-OMAC TO SR-F78.
    MOVE 0 TO SR-F79 SR-F80 START SORTFL KEY>SR-KEY INVALID GO JI56.
JI55. READ SORTFL NEXT END GO JI56.
    IF NOT(SR-F77=JI-NO AND SR-F78=JI-OMAC) GO JI56. IF SR-F82=0 GO JI55.
    IF JI-ODATE=0 MOVE SR-F79 TO JI-ODATE. COMPUTE WN1=JI-IWEIGHT - JI-OWEIGHT.
    IF SR-F82<WN1 ADD SR-F82 TO JI-OWEIGHT MOVE 0 TO SR-F82
      ELSE MOVE JI-IWEIGHT TO JI-OWEIGHT SUBTRACT WN1 FROM SR-F82.
    REWRITE SR-RECORD IF JI-OWEIGHT<JI-IWEIGHT GO JI55.
JI56. PERFORM INIT-RP MOVE JI-CCON(JI-IXC) TO RP-F236.
    MOVE JI-NO TO RP-F237 MOVE 0 TO RP-F237A MOVE JI-PROD TO RP-F238.
    MOVE JI-CMAC(JI-IXC) TO RP-F239 MOVE JI-CDAYS(JI-IXC) TO RP-F240.
    MOVE JI-IWEIGHT TO RP-F241 MOVE JI-ODATE TO RP-F242 MOVE JI-IDATE TO RP-F243.
    MOVE JI-ODATE TO D-DATE MOVE JI-CDAYS(JI-IXC) TO D-DAYS.
    PERFORM D-WDIFF IF D-DATE<=JI-IDATE MOVE 1 TO RP-F244.
    COMPUTE RP-F245=JI-OWEIGHT - JI-IWEIGHT.
JI57. WRITE RP-RECORD INVALID IF RP-F237A<99 ADD 1 TO RP-F237A GO JI57 END-IF.
    GO JI51.
JI59. ADD 1 TO JI-IXC IF JI-IXC<=JI-CNUM GO JI5. GO JI3.

JI6. PERFORM OPEN-PR PERFORM JI-PAGE.
    MOVE " " TO OLD-A MOVE LOW-VALUES TO JI-VTOTALS JI-GTOTALS.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO JI9.
JI7. READ REPFL NEXT END GO JI9. IF RP-F236=OLD-A GO JI74.
    IF OLD-A>" " PERFORM JI-V. MOVE RP-F236 TO OLD-A FG299.
JI74. MOVE RP-F237 TO FG300 MOVE RP-F238 TO A-A1 PERFORM PROD-RD.
    MOVE P-NO TO FG301 MOVE PRO-DESC(1) TO FG302.
    MOVE RP-F239 TO FG303 MOVE RP-F240 TO FG304.
    MOVE RP-F241 TO FG306 ADD RP-F241 TO JI-VW JI-GW.
    MOVE RP-F242 TO D-DATE PERFORM D-NM MOVE D-DT TO FG307.
    MOVE RP-F243 TO D-DATE PERFORM D-NM MOVE D-DT TO FG308.
    IF RP-F244=1 MOVE "*" TO FG309 ADD JI-IWEIGHT TO JI-VL JI-GL.
    IF RP-F245 NOT=0 MOVE RP-F245 TO FG310.
    PERFORM JI-LINE GO JI7.
JI9. PERFORM JI-V MOVE "*** GRAND TOTAL" TO PREC MOVE JI-GW TO FG306.
    COMPUTE FG309A ROUNDED=JI-GL * 100 / JI-GW SIZE ERROR CONTINUE.
    MOVE "%" TO FG309B PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

JI-V. MOVE 2 TO WS-PR MOVE "** VENDOR TOTAL" TO PREC MOVE JI-VW TO FG306.
    COMPUTE FG309A ROUNDED=JI-VL * 100 / JI-VW SIZE ERROR CONTINUE.
    MOVE "%" TO FG309B PERFORM PR-LINE-3 MOVE LOW-VALUES TO JI-VTOTALS.
JI-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM JI-PAGE.
JI-PAGE. MOVE "CONTRACTOR PERFORMANCE REPORT" TO FF3 PERFORM PR-PAGE.
    MOVE "FOR PERIOD:" TO A-A1 PERFORM PRANGE-DATE.
    MOVE "CONTRACTOR    M.O.  PRODUCT       DESCRIPTION                        PROC LDAYS     WEIGHT    OUT      IN    LATE     MISMATCH" TO PREC PERFORM PR-LINE-3.
*         ..........  ......  ............  ................................   ...   ...  .,...,...- ../../.. ../../..  .    ..,...,...-
*                                                                                                                      ...%

* Z-20-18 WORK IN PROGRESS REPORT (Irvine Tools function)
FN1. IF NOT ITOOL GO MX1.
    PERFORM RD412 PERFORM WRT IF S-BAT GO FN2.
    MOVE 3 TO IXT MOVE 14 TO IXU PERFORM AX-DT-VAL.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
FN2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE 10000 TO R-NO START PRODORD KEY>=R-KEY REGARDLESS INVALID GO FN29.
FN23. READ PRODORD NEXT REGARDLESS END GO FN29. IF R-FIN=0 OR R-QTY-LEFT<=0 GO FN23.
    MOVE R-PROD TO A-A1 PERFORM PROD-RT PERFORM GET-OP IF A-S1=1 GO FN23.
    MOVE P-MAC TO CST-MAC PERFORM COST-MULT-INIT.
    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO FN28.
FN25. READ WORKSHEET NEXT REGARDLESS END GO FN28. IF J-NO NOT=R-NO GO FN28.
    IF J-DATE>DATE0 GO FN25. MOVE 0 TO WT1 MOVE 1 TO IX1.
FN263. IF OP-OPER(IX1) NOT=J-MAC GO FN266.
    MOVE J-MAC TO M-NO READ MACHINE REGARDLESS INVALID GO FN266.
    MOVE J-MAC TO A-N1 PERFORM CHK-SUBCON.
    IF A-S1=1
      IF OP-COST(IX1)>0 MOVE OP-COST(IX1) TO CST-WAMT ELSE MOVE M-COST TO CST-WAMT END-IF
      COMPUTE WT1 ROUNDED=CST-WAMT * CST-NET / 100
     ELSE IF M-TQTY=0 GO FN266 END-IF MOVE M-TYPE TO A-N1 PERFORM RD-MACTYPE
      COMPUTE WT1 ROUNDED=ME-COST * M-HOURS / M-TQTY.
    PERFORM INIT-RP MOVE P-NO TO RP-F275 MOVE R-NO TO RP-F276.
    MOVE J-MAC TO RP-F277 MOVE R-QTY-LEFT TO RP-F278 MOVE WT1 TO RP-F279.
    MOVE J-QTY TO RP-F280.
    WRITE RP-RECORD INVALID READ REPFL ADD J-QTY TO RP-F280 REWRITE RP-RECORD.
    GO FN269.
FN266. ADD 1 TO IX1 IF IX1<=12 GO FN263.
FN269. GO FN25.
FN28. MOVE " " TO CST-MAT STRING P-DIAM P-GRADE DELIMITED " " INTO CST-MAT.
    IF CST-MAT=" " OPEN I-O IFPART ALLOWING ALL MOVE P-NO TO IFPH-NO
      READ IFPART INTO PH-RECORD REGARDLESS INVALID MOVE " " TO PH-MATERIAL END-READ
      MOVE PH-MATERIAL TO CST-MAT CLOSE IFPART.
    MOVE CST-MAT TO A-A1 PERFORM RD-PART MOVE PH-LDCOST TO CST-M-MAT.
    IF PH-UNIT="LB" COMPUTE CST-M-MAT ROUNDED=CST-M-MAT * CST-GROSS / 100.
* note 43.1
    PERFORM INIT-RP MOVE P-NO TO RP-F275 MOVE R-NO TO RP-F276.
    MOVE 9001 TO RP-F277 MOVE R-QTY-LEFT TO RP-F278 RP-F280.
    MOVE CST-M-MAT TO RP-F279 WRITE RP-RECORD.
    MOVE 99 TO A-N1 PERFORM RD-MACTYPE.
    PERFORM INIT-RP MOVE P-NO TO RP-F275 MOVE R-NO TO RP-F276.
    MOVE 9002 TO RP-F277 MOVE R-QTY-LEFT TO RP-F278 RP-F280.
    MOVE ME-COST TO RP-F279 WRITE RP-RECORD.
    GO FN23.
FN29. PERFORM OPEN-PR PERFORM FN-PAGE.
    MOVE LOW-VALUES TO FN-PTOTALS FN-GTOTALS MOVE " " TO OLD-A MOVE 0 TO OLD-N OLD-M.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO FN9.
FN3. READ REPFL NEXT END GO FN9. IF RP-F275=OLD-A GO FN32.
    IF OLD-A>" " PERFORM FN-P. MOVE RP-F275 TO FF474 A-A1 PERFORM PROD-RD.
    MOVE PRO-DESC(1) TO FF475 MOVE RP-F275 TO OLD-A MOVE 0 TO OLD-N OLD-M.
FN32. IF RP-F276=OLD-N GO FN34. MOVE RP-F276 TO FF476 MOVE RP-F278 TO FF476A.
    MOVE 0 TO CST-ITHOURS MOVE RP-F276 TO OLD-N MOVE 0 TO OLD-M.
FN34. IF RP-F277=OLD-M GO FN4.
    IF RP-F277<=999 MOVE RP-F277 TO FF477 A-N1 PERFORM RD-MAC MOVE M-OPDESC TO FF478
      ELSE IF RP-F277=9001 MOVE "MATERIAL" TO FF478
      ELSE IF RP-F277=9002 MOVE "GEN OVERHD" TO FF478.
    MOVE RP-F279 TO FF479.
FN4. MOVE RP-F280 TO WN1 IF RP-F278<WN1 MOVE RP-F278 TO WN1.
    MOVE RP-F277 TO A-N1 PERFORM CHK-SUBCON.
    IF RP-F277<=999 AND A-S1=0
      COMPUTE CST-ITHOURS ROUNDED=CST-ITHOURS + WN1 * M-HOURS / M-TQTY.
    IF RP-F277=9002 COMPUTE FF480 ROUNDED=CST-ITHOURS
      COMPUTE WD1 ROUNDED=CST-ITHOURS * RP-F279
     ELSE MOVE WN1 TO FF481 COMPUTE WD1 ROUNDED=WN1 * RP-F279.
    MOVE WD1 TO FF482 ADD WD1 TO FN-PV FN-GV PERFORM FN-LINE GO FN3.
FN9. PERFORM FN-P MOVE "*** GRAND TOTALS" TO FF475.
    MOVE FN-GV TO FF482 MOVE "**" TO FF483 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

FN-P. MOVE FN-PV TO FF482 MOVE "*" TO FF483 PERFORM FN-LINE.
    MOVE LOW-VALUES TO FN-PTOTALS.
FN-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM FN-PAGE.
FN-PAGE. MOVE "WORK IN PROGRESS REPORT (IRVINE TOOLS)" TO FF3 PERFORM PR-PAGE.
    MOVE "ON:" TO A-A1 PERFORM PRANGE-DT.
    MOVE "PRODUCT       DESCRIPTION                        M.O.  QTY LEFT  PROCESS            COST    HRS   QTY        VALUE" TO PREC PERFORM PR-LINE-3.
*         ............  ................................ ......  ..,...-   ... ..........  ...:...  ..:.. .,...-  ...,...:..-..

* Z-20-19 OPERATIONS REPORT (Irvine Tools function)
QP1. IF NOT ITOOL GO MX1.
    PERFORM RD380 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM OPEN-SORT.
    OPEN I-O IFPURORD ALLOWING ALL IFPURLIN ALLOWING ALL.
    MOVE 1 TO QP-STEP PERFORM QP-PAGE.

    MOVE " " TO IFOK-KEY START IFPURORD KEY>IFOK-KEY REGARDLESS INVALID GO QP9.
QP3. READ IFPURORD NEXT INTO OK-RECORD REGARDLESS END GO QP9. IF OK-VENDOR NOT=9250 GO QP3.
    IF OK-NO(1:5) NUMERIC MOVE OK-NO(1:5) TO QP-BMO
      ELSE IF OK-NO(2:5) NUMERIC MOVE OK-NO(2:5) TO QP-BMO ELSE GO QP3.
* note 95
    MOVE IFOK-NO TO IFLK-ORD MOVE 0 TO IFLK-LINE.
    START IFPURLIN KEY>IFLK-KEY REGARDLESS INVALID GO QP8.
QP5. READ IFPURLIN NEXT INTO LK-RECORD REGARDLESS END GO QP8. IF IFLK-ORD NOT=IFOK-NO GO QP8.
    IF LK-QTY-REC>0 GO QP5. MOVE 0 TO QP-IXM.
    MOVE QP-BMO TO R-NO READ PRODORD REGARDLESS INVALID GO QP52.
    ADD 1 TO QP-IXM MOVE R-NO TO QP-MO(QP-IXM).
QP52. MOVE 1 TO IX1.
QP53. COMPUTE R-NO=QP-BMO * 10 + IX1 READ PRODORD REGARDLESS INVALID GO QP54.
    ADD 1 TO QP-IXM MOVE R-NO TO QP-MO(QP-IXM).
QP54. ADD 1 TO IX1 IF IX1<=9 GO QP53. IF QP-IXM=0 GO QP8.

    MOVE 0 TO QP-IXL.
QP7. ADD 1 TO QP-IXL IF QP-IXL>QP-IXM GO QP8.
    MOVE QP-MO(QP-IXL) TO R-NO READ PRODORD REGARDLESS INVALID GO QP78.
    MOVE R-PROD TO P-NO READ PRODUCT REGARDLESS INVALID GO QP78.
    PERFORM GET-OP IF A-S1=1 GO QP78. INITIALIZE QP-OPX MOVE 1 TO IX1.
QP71. IF OP-OPER(IX1)>0
       PERFORM VARYING IX2 FROM 1 BY 1 UNTIL QP-OP(IX2)=0 OR OP-OPER(IX1) CONTINUE END-PERFORM
       MOVE OP-OPER(IX1) TO QP-OP(IX2) ADD LK-QTY TO QP-QTY(IX2).
    ADD 1 TO IX1 IF IX1<=12 GO QP71.

    INITIALIZE J-KEY MOVE R-NO TO J-NO.
    START WORKSHEET KEY>J-KEY REGARDLESS INVALID GO QP74.
QP73. READ WORKSHEET NEXT REGARDLESS END GO QP74. IF J-NO NOT=R-NO GO QP74.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL QP-OP(IX1)=0
      IF QP-OP(IX1)=J-MAC SUBTRACT J-QTY FROM QP-QTY(IX1) GO QP738 END-IF END-PERFORM.
QP738. GO QP73.
QP74. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL QP-OP(IX1)=0
       MOVE 5 TO T-TBL MOVE QP-OP(IX1) TO T-NO PERFORM RD-TBL
       MULTIPLY T-OPM BY QP-QTY(IX1)
       IF QP-QTY(IX1)<0 MOVE 0 TO QP-QTY(IX1) END-IF END-PERFORM.
    MOVE 0 TO WS1 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL QP-OP(IX1)=0
      IF QP-QTY(IX1)>0 MOVE 1 TO WS1 END-IF END-PERFORM.
    IF WS1=0 GO QP78.

    MOVE OK-NO TO FF434 MOVE LK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FF435.
    MOVE QP-MO(QP-IXL) TO FF436 MOVE P-NO TO FF437 MOVE LK-QTY TO FF438.
    MOVE 0 TO IX2.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL QP-OP(IX1)=0 IF QP-QTY(IX1)>0
      IF IX2<10 ADD 1 TO IX2
        IF QP-QTY(IX1)<=999 MOVE QP-OP(IX1) TO FF440(IX2)
          MOVE ":" TO FF441(IX2) MOVE QP-QTY(IX1) TO FF442(IX2)
         ELSE MOVE QP-OP(IX1) TO FF443(IX2)
          MOVE ":" TO FF444(IX2) MOVE QP-QTY(IX1) TO FF445(IX2) END-IF END-IF
      MOVE QP-OP(IX1) TO SR-F169 MOVE QP-QTY(IX1) TO SR-F170
      WRITE SR-RECORD INVALID READ SORTFL ADD QP-QTY(IX1) TO SR-F170 REWRITE SR-RECORD END-WRITE
      END-IF END-PERFORM.
    PERFORM QP-LINE.
QP78. GO QP7.
QP8. GO QP3.
QP9. MOVE 2 TO QP-STEP PERFORM QP-SUM.
    CLOSE IFPURORD IFPURLIN PERFORM CLOSE-SORT PERFORM CLOSE-PR GO MX9.

QP-SUM. PERFORM QP-SM1 THRU QP-SM9.
QP-SM1. PERFORM QP-PAGE.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO QP-SM4.
QP-SM3. READ SORTFL NEXT END GO QP-SM4.
    MOVE SR-F169 TO FG1 MOVE SR-F170 TO FG2 PERFORM QP-LINE GO QP-SM3.
QP-SM4.
QP-SM9. EXIT.
QP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QP-PAGE.
QP-PAGE. MOVE "OPERATIONS REPORT (IRVINE TOOLS)" TO FF3.
    IF QP-STEP=1 MOVE "** TIME REQUIRED **" TO FF4.
    IF QP-STEP=2 MOVE "** SUMMARY **" TO FF4. PERFORM PR-PAGE.
    IF QP-STEP=1 MOVE
         "ORDER      REQD     M.O.  PART NO.     QTY  PROCESS:MINUTES REQUIRED" TO PREC PERFORM PR-LINE-3.
*         ........ ../../.. ......  ............ ...  ...:...  ...:... (x10)
    IF QP-STEP=2 MOVE
         "PROCESS  MINUTES" TO PREC PERFORM PR-LINE-3.
*           ...    ..,...

* Z-20-20 GENERATE SALES ORDERS (Irvine Tools function)
QD1. IF NOT ITOOL GO MX1.
    PERFORM RD381 PERFORM WRT.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM QD-PAGE.
    OPEN I-O IFPART ALLOWING ALL IFPURORD ALLOWING ALL IFPURLIN ALLOWING ALL
      IFTOOLS ALLOWING ALL IFTOOLPROD ALLOWING ALL.

    MOVE " " TO IFOK-KEY START IFPURORD KEY>IFOK-KEY REGARDLESS INVALID GO QD9.
QD3. READ IFPURORD NEXT INTO OK-RECORD REGARDLESS END GO QD9.
    IF NOT(OK-VENDOR=9250 AND OK-ITORD=0) GO QD3.
    MOVE IFOK-NO TO IFLK-ORD MOVE 0 TO IFLK-LINE.
    START IFPURLIN KEY>IFLK-KEY REGARDLESS INVALID GO QD34.
QD33. READ IFPURLIN NEXT INTO LK-RECORD REGARDLESS END GO QD34. IF IFLK-ORD NOT=IFOK-NO GO QD34.
    IF LK-QTY-REC>0 GO QD3. GO QD33.
QD34. PERFORM INIT-O MOVE 0 TO QD-KERR.
    IF OK-NO(1:5) NUMERIC MOVE OK-NO(1:5) TO O-NO
      ELSE IF OK-NO(1:3)="IRV"
        IF OK-NO(4:5) NUMERIC MOVE OK-NO(4:5) TO O-NO ELSE MOVE 1 TO QD-KERR END-IF
       ELSE IF OK-NO(2:5) NUMERIC MOVE OK-NO(2:5) TO O-NO
         ELSE MOVE 0 TO O-NO MOVE 1 TO QD-KERR.
    IF QD-KERR=1 GO QD4. READ SAORD REGARDLESS INVALID GO QD4. MOVE 1 TO QD-KERR.
QD4. MOVE "9200" TO O-CUS MOVE OK-NO TO O-CUSORD MOVE OK-DATE TO O-DATE.
    MOVE "IRVINE FASTENERS" TO O-NAME MOVE "160 RICHMOND STREET" TO O-ADD1.
    MOVE "SPRINGHILL, ONTARIO" TO O-ADD2 MOVE "N1K 5R6" TO O-POST.
    MOVE OK-DATE-REQ TO O-DATE-REQ MOVE OK-TERMS TO O-TERMS MOVE OK-FOB TO O-FOB.
    MOVE O-NO TO FG311 MOVE O-CUSORD TO FG312.
    MOVE O-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FG313.
    IF QD-KERR=1 MOVE "*" TO FG314 PERFORM QD-LINE GO QD82.

    MOVE IFOK-NO TO IFLK-ORD MOVE 0 TO IFLK-LINE QD-LN.
    START IFPURLIN KEY>IFLK-KEY REGARDLESS INVALID GO QD8.
QD5. READ IFPURLIN NEXT INTO LK-RECORD REGARDLESS END GO QD8.
    IF IFLK-ORD NOT=IFOK-NO GO QD8. ADD 1 TO QD-LN.
    PERFORM INIT-L MOVE O-NO TO L-ORD MOVE QD-LN TO L-LINE.
    MOVE O-CUS TO L-CUS MOVE LK-PART TO L-PROD MOVE LK-DATE-REQ TO L-DATE-REQ.
    MOVE LK-PRICE TO L-PRICE MOVE LK-MODE TO L-MODE.
    MOVE LK-QTY TO L-QTY L-QTY-LEFT MOVE LK-CAT TO L-CAT.
    WRITE L-RECORD ALLOWING NO UNLOCK SALIN.
    MOVE " " TO QD-DESC IF LK-DRAW>" " PERFORM DRAW-EXP-LK MOVE A-A2 TO QD-DESC.
    MOVE LK-QTY TO FG315 MOVE LK-PART TO FG316 MOVE LK-DESC1 TO FG317.
    MOVE QD-DESC TO FG317A MOVE LK-PRICE TO FG317B PERFORM QD-LINE.

    MOVE LK-PART TO IFPH-NO READ IFPART INTO PH-RECORD REGARDLESS INVALID GO QD68.
    PERFORM INIT-P MOVE LK-PART TO P-NO.
    READ PRODUCT REGARDLESS INVALID GO QD52. GO QD6.
QD52. MOVE 42 TO P-CAT MOVE 9200 TO P-VENDOR.
    MOVE LK-DESC1 TO P-DESC MOVE LK-DESC2 TO P-EDESC1 MOVE QD-DESC TO P-EDESC2.
    MOVE LK-PRICE TO P-PRICE1 MOVE LK-MODE TO P-MODE.
    WRITE P-RECORD ALLOWING NO UNLOCK PRODUCT PERFORM QD-A.
QD6. PERFORM PART-TYPE IF NOT(PART-TOOL AND PH-ASM=1) GO QD68.
    MOVE P-NO TO A-A1 PERFORM TL-SET-ASM IF A-S1=1 GO QD68. MOVE 1 TO TL-IXF.
QD63. PERFORM TL-SET-TBL IF TS-TOOL(TL-FLD)=" " OR "N/R" GO QD66.
    IF NOT(TL-PAGE>0 AND TL-STN=TL-ASTN AND TL-CAT=TL-ACAT AND TL-LOC>0) GO QD66.
    PERFORM INIT-P MOVE TS-TOOL(TL-FLD) TO P-NO.
    READ PRODUCT REGARDLESS INVALID GO QD64. GO QD66.
QD64. MOVE P-NO TO IFPH-NO READ IFPART INTO PH-RECORD REGARDLESS INVALID GO QD66.
    MOVE 42 TO P-CAT MOVE 9200 TO P-VENDOR.
    MOVE PH-DESC1 TO P-DESC MOVE PH-DESC2 TO P-EDESC1.
    IF PH-DRAW>" " PERFORM DRAW-EXP-PH MOVE A-A2 TO P-EDESC2.
    PERFORM PRI-CHKVEN IF A-X1<=3 MOVE PH-PRICE(A-X1) TO P-PRICE1.
    MOVE PH-MODE TO P-MODE.
    WRITE P-RECORD ALLOWING NO UNLOCK PRODUCT PERFORM QD-A.
QD66. ADD 1 TO TL-IXF IF TL-IXF<=TL-NUM GO QD63.
QD68. GO QD5.
QD8. MOVE QD-LN TO O-LINES WRITE O-RECORD ALLOWING NO UNLOCK SAORD.
QD82. MOVE 1 TO OK-ITORD REWRITE IFOK-RECORD FROM OK-RECORD ALLOWING NO UNLOCK IFPURORD.
    GO QD3.
QD9. CLOSE IFPART IFPURORD IFPURLIN IFTOOLS IFTOOLPROD PERFORM CLOSE-PR GO MX9.

QD-A. MOVE LOW-VALUES TO AL-RECORD MOVE P-NO TO AL-PROD MOVE " " TO AL-ALT.
    WRITE AL-RECORD ALLOWING NO UNLOCK ALTERNATES.
QD-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QD-PAGE.
QD-PAGE. MOVE "SALES ORDERS GENERATION (IRVINE TOOLS)" TO FF3 PERFORM PR-PAGE.
    MOVE " ORDER  CUST ORD    DATE  ERR  QTY  PART NO.      DESCRIPTION                       DRAWING                   PRICE" TO PREC PERFORM PR-LINE-3.
*         ......  ........  ../../.. .  ....  ............  ................................  .................... ....,...:..

* Z-20-21 A/P JOURNAL
AP1. PERFORM RD174 PERFORM WRT.
    MOVE 4 TO IXT MOVE 25 TO IXU PERFORM AX-DT-INV.
    IF DATE0>0 MOVE 1 TO AP-KEF
      ELSE MOVE 0 TO AP-KEF MOVE 4 TO IXT MOVE 56 TO IXU PERFORM AX-DT-VAL.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-REP INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO AP29.
AP23. READ APTR NEXT REGARDLESS END GO AP29. IF AT-DIV>WS-DIV GO AP29.
    IF AT-MANUAL=0 GO AP23.
    IF AP-KEF=0 AND AT-DATE NOT=DATE0 OR AP-KEF=1 AND AT-EFF-DATE NOT=DATE0 GO AP23.
    MOVE AT-VEN TO A-N1 PERFORM RD-VEN.
    PERFORM INIT-RP MOVE V-NAME TO RP-F213 MOVE AT-KEY TO RP-F214.
    WRITE RP-RECORD GO AP23.
AP29. PERFORM OPEN-PR PERFORM AP-PAGE MOVE 0 TO AP-TOT1 AP-TOT2 AP-TOT3.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO AP9.
AP3. READ REPFL NEXT END GO AP9. MOVE RP-F214 TO AT-KEY READ APTR REGARDLESS.
    MOVE AT-VEN TO FA100 A-N1 PERFORM RD-VEN MOVE AT-INV TO FA101.
    IF AP-KEF=0 MOVE AT-EFF-DATE TO D-DATE ELSE MOVE AT-DATE TO D-DATE.
    PERFORM D-NM MOVE D-DT TO FA103.
    MOVE AT-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA104.
    MOVE AT-DUE-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA105.
    MOVE AT-PROJECT TO FA106 MOVE AT-MEMO TO FA106A.
    MOVE 0 TO AP-KVEN MOVE 1 TO IX1.
AP5. MOVE AT-GL(IX1) TO FA107 MOVE AT-AMT(IX1) TO FA108.
    IF IX1=2 MOVE V-NAME TO FA112 MOVE 1 TO AP-KVEN.
    PERFORM AP-LINE ADD 1 TO IX1 IF IX1<=10 AND AT-GL(IX1) NOT=0 GO AP5.
    MOVE "GST" TO FA107X MOVE AT-GST TO FA108.
    IF AP-KVEN=0 MOVE V-NAME TO FA112. PERFORM AP-LINE.
    IF AT-PST NOT=0 MOVE "PST" TO FA107X MOVE AT-PST TO FA108 PERFORM AP-LINE.
    MOVE AT-GROSS TO FA108 MOVE "*" TO FA109.
    IF AT-EXCH=0 ADD AT-GROSS TO AP-TOT1
      ELSE MOVE "US" TO FA110 MOVE AT-EXCH TO FA110A
        COMPUTE WD1 ROUNDED=AT-NET * AT-EXCH
        MOVE WD1 TO FA111 ADD AT-GROSS TO AP-TOT2 ADD WD1 TO AP-TOT3.
    PERFORM AP-LINE.
    IF AT-DISC NOT=0 MOVE "DISCOUNT" TO FA107X MOVE AT-DISC TO FA108 PERFORM AP-LINE.
    IF AT-FREIGHT NOT=0 MOVE "FREIGHT" TO FA107X MOVE AT-FREIGHT TO FA108 PERFORM AP-LINE.
    PERFORM AP-LINE GO AP3.
AP9. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO FA112.
    MOVE AP-TOT1 TO FA108 MOVE "*" TO FA109 PERFORM PR-LINE.
    MOVE AP-TOT2 TO FA108 MOVE "*" TO FA109.
    MOVE "US" TO FA110 MOVE AP-TOT3 TO FA111 PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

AP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AP-PAGE.
AP-PAGE. MOVE "ACCOUNTS PAYABLE JOURNAL" TO FF3 PERFORM PR-IPAGE.
    IF AP-KEF=0 MOVE "CREATED ON:" TO A-A1 ELSE MOVE "A/P EFFECTIVE DATE:" TO A-A1.
    PERFORM PRANGE-DT.
    MOVE "VEND INVOICE         ........ INV-DATE DUE-DATE   PROJ MEMO              DISTRIBUTION ACCOUNT       AMOUNT      EXCH      CDN EQUIV" TO PREC.
*         .... ............... ../../.. ../../.. ../../.. ...... ................. ...... ... .. ....... .,...,...:..-:.. .:.... .,...,...:..-
*         ....................................
    IF AP-KEF=0 MOVE "EFF-DATE" TO PREC(22:8) ELSE MOVE "CREATED" TO PREC(22:8).
    PERFORM PR-LINE-3.

* Z-20-22 A/P TRIAL BALANCE
AV1. PERFORM RD312 PERFORM WRT.
    IF S-BAT MOVE S-S1 TO AV-KCOM MOVE S-S2 TO AV-KBAL MOVE S-S3 TO AV-KADD GO AV2.
    MOVE 0 TO AV-KCOM AV-KBAL AV-KADD.
    ACCEPT XA3 LINE 3 COLUMN 29 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO AV-KCOM.
    ACCEPT XA3 LINE 4 COLUMN 38 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO AV-KBAL.
    ACCEPT XA3 LINE 5 COLUMN 23 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3="YES" MOVE 1 TO AV-KADD.
    MOVE 7 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE AV-KCOM TO S-S1 MOVE AV-KBAL TO S-S2 MOVE AV-KADD TO S-S3 GO MX9.
AV2. PERFORM DSP-WAIT PERFORM OPEN-REP MOVE WS-DIV TO V-DIV MOVE 0 TO V-NO.
    START VENDOR KEY>V-KEY REGARDLESS INVALID GO AV29.
AV23. READ VENDOR NEXT REGARDLESS END GO AV29. IF V-DIV>WS-DIV GO AV29.
    PERFORM INIT-RP.
    IF V-NO<9000 MOVE 1 TO RP-F215 ELSE MOVE 2 TO RP-F215.
    IF AV-KCOM=0 MOVE 0 TO RP-F215A ELSE MOVE V-CLASS TO RP-F215A.
    IF AV-KBAL=0 MOVE 0 TO RP-F215B
      ELSE PERFORM AV-B MOVE AV-NET(1) TO WN1
        IF AV-NET(2)>WN1 MOVE AV-NET(2) TO WN1 END-IF
        IF WN1<0 MOVE 0 TO WN1 END-IF COMPUTE RP-F215B=99999999 - WN1.
    MOVE V-NAME TO RP-F216 MOVE V-NO TO RP-F217 WRITE RP-RECORD GO AV23.
AV29. PERFORM OPEN-PR PERFORM AV-PAGE.
    MOVE LOW-VALUES TO AV-CTOTALS AV-STOTALS AV-GTOTALS.
    MOVE -1 TO OLD-N MOVE 0 TO OLD-T.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO AV9.
AV3. READ REPFL NEXT END GO AV9. MOVE RP-F217 TO A-N1 PERFORM RD-VEN.
    IF RP-F215=OLD-T GO AV32.
    IF OLD-T NOT=0 PERFORM AV-COM PERFORM AV-SUB PERFORM AV-PAGE.
    MOVE RP-F215 TO OLD-T MOVE -1 TO OLD-N.
AV32. IF AV-KCOM=0 OR RP-F215A=OLD-N GO AV34.
    IF OLD-N NOT=-1 PERFORM AV-COM PERFORM AV-PAGE. MOVE RP-F215A TO OLD-N.
    MOVE "COMMODITY CLASS" TO FA129 MOVE OLD-N TO FA130.
    IF OLD-N NOT=0 MOVE 9 TO T-TBL MOVE OLD-N TO T-NO
      PERFORM RD-TBL MOVE T-LINE TO FA130A.
    PERFORM AV-LINE 2 TIMES.
AV34. MOVE V-NO TO FA131 MOVE V-NAME TO FA132 MOVE V-DISC TO FA133.
    MOVE V-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA136.
    PERFORM AV-B MOVE 1 TO IX1 PERFORM AV-M PERFORM AV-LINE.
    IF AV-GROSS(2)=0 AND AV-NET(2)=0 AND V-PUR-YTD(2)=0 AND V-PUR-LAST(2)=0
      IF AV-KADD=1 PERFORM AV-AP END-IF
     ELSE MOVE "US$" TO FA133A MOVE 2 TO IX1 PERFORM AV-M
      IF AV-KADD=1 PERFORM AV-AP ELSE PERFORM AV-LINE.
    PERFORM AV-LINE GO AV3.
AV9. PERFORM AV-COM PERFORM AV-SUB MOVE 4 TO WS-PR.
    MOVE "*** GRAND TOTALS" TO FA132 MOVE 1 TO IX1 PERFORM AV-G.
    MOVE "***          US$" TO FA132 MOVE 2 TO IX1 PERFORM AV-G.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

AV-B. PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
       MOVE V-GROSS(IX1) TO AV-GROSS(IX1) MOVE V-NET(IX1) TO AV-NET(IX1) END-PERFORM.
AV-AP. MOVE V-ADD1 TO FA132 PERFORM AV-LINE MOVE V-ADD2 TO FA132 PERFORM AV-LINE.
    MOVE V-POST TO FA132 PERFORM AV-LINE.
AV-M. MOVE AV-GROSS(IX1) TO FA134(1) MOVE AV-NET(IX1) TO FA134(2).
    MOVE V-PUR-YTD(IX1) TO FA135(1) MOVE V-PUR-LAST(IX1) TO FA135(2).
    MOVE V-PUR-2(IX1) TO FA135(3) MOVE V-DISC-YTD(IX1) TO FA135(4).
    ADD AV-GROSS(IX1) TO AV-CTOT(IX1,1) AV-STOT(IX1,1) AV-GTOT(IX1,1).
    ADD AV-NET(IX1) TO AV-CTOT(IX1,2) AV-STOT(IX1,2) AV-GTOT(IX1,2).
    ADD V-PUR-YTD(IX1) TO AV-CTOT(IX1,3) AV-STOT(IX1,3) AV-GTOT(IX1,3).
    ADD V-PUR-LAST(IX1) TO AV-CTOT(IX1,4) AV-STOT(IX1,4) AV-GTOT(IX1,4).
    ADD V-PUR-2(IX1) TO AV-CTOT(IX1,5) AV-STOT(IX1,5) AV-GTOT(IX1,5).
    ADD V-DISC-YTD(IX1) TO AV-CTOT(IX1,6) AV-STOT(IX1,6) AV-GTOT(IX1,6).
AV-G. MOVE AV-GTOT(IX1,1) TO FA134(1) MOVE AV-GTOT(IX1,2) TO FA134(2).
    MOVE AV-GTOT(IX1,3) TO FA135(1) MOVE AV-GTOT(IX1,4) TO FA135(2).
    MOVE AV-GTOT(IX1,5) TO FA135(3) MOVE AV-GTOT(IX1,6) TO FA135(4).
    PERFORM AV-LINE.
AV-SUB. MOVE 3 TO WS-PR.
    MOVE "*** SUB-TOTALS" TO FA132 MOVE 1 TO IX1 PERFORM AV-S.
    MOVE "***        US$" TO FA132 MOVE 2 TO IX1 PERFORM AV-S.
    MOVE LOW-VALUES TO AV-STOTALS.
AV-S. MOVE AV-STOT(IX1,1) TO FA134(1) MOVE AV-STOT(IX1,2) TO FA134(2).
    MOVE AV-STOT(IX1,3) TO FA135(1) MOVE AV-STOT(IX1,4) TO FA135(2).
    MOVE AV-STOT(IX1,5) TO FA135(3) MOVE AV-STOT(IX1,6) TO FA135(4).
    PERFORM AV-LINE.
AV-COM. PERFORM AV-COM1 THRU AV-COM9.
AV-COM1. IF AV-KCOM=0 GO AV-COM9. MOVE 3 TO WS-PR.
    MOVE "*** COMMODITY CLASS TOTALS" TO FA132 MOVE 1 TO IX1 PERFORM AV-C.
    MOVE "***                    US$" TO FA132 MOVE 2 TO IX1 PERFORM AV-C.
    MOVE LOW-VALUES TO AV-CTOTALS.
AV-COM9. EXIT.
AV-C. MOVE AV-CTOT(IX1,1) TO FA134(1) MOVE AV-CTOT(IX1,2) TO FA134(2).
    MOVE AV-CTOT(IX1,3) TO FA135(1) MOVE AV-CTOT(IX1,4) TO FA135(2).
    MOVE AV-CTOT(IX1,5) TO FA135(3) MOVE AV-CTOT(IX1,6) TO FA135(4).
    PERFORM AV-LINE.
AV-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM AV-PAGE.
AV-PAGE. MOVE "ACCOUNTS PAYABLE TRIAL BALANCE" TO FF3.
    IF AV-KCOM=1 MOVE "** BY COMMODITY CLASS **" TO FF4. PERFORM PR-IPAGE.
    MOVE "VEND  NAME                                 DISC   TOTAL GROSS    TOTAL NET   PURCH---  YTD    LST YR  2 YRS AGO  DISC YTD   LAST INV" TO PREC PERFORM PR-LINE-3.
*         ....  .................................... .:..   ...,...:..-   ...,...:..-        ...,...-  ...,...-  ...,...-  ...,...-   ../../..

* Z-20-23 OUTSTANDING INVOICES REPORTS
CR1. PERFORM RD374 PERFORM WRT IF S-BAT MOVE S-S1 TO CR-KOUT GO CR2.
CR13. ACCEPT XA3 LINE 3 COLUMN 33 DEFAULT " " UNDERLINED PROTECTED.
    MOVE 5 TO IXT MOVE 0 TO CR-KOUT.
    IF XA3="YES" MOVE 1 TO CR-KOUT PERFORM AX-EFF-DATE PERFORM AX-VEN
      ELSE IF S-DEF MOVE "CANNOT RUN 'CASH REQUIREMENTS' IN BATCH MODE"
             TO ERR-MESG PERFORM DSP-ERR GO CR13 END-IF
        PERFORM APS-AXSEL.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF MOVE CR-KOUT TO S-S1 GO MX9.
CR2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    MOVE -1 TO OLD-N INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO CR29.
CR23. READ APTR NEXT REGARDLESS END GO CR29. IF AT-DIV>WS-DIV GO CR29.
    IF AT-VEN NOT=OLD-N MOVE AT-VEN TO OLD-N A-N1 PERFORM RD-VEN.
    IF CR-KOUT=0 PERFORM APS-CHKTR IF A-S1=0 GO CR23 END-IF
      ELSE IF NOT((AT-VEN>=VEN1 AND<=VEN2) AND AT-IND=0 AND AT-EFF-DATE<=DATE0) GO CR23.
    PERFORM INIT-RP MOVE V-NAME TO RP-F101 MOVE AT-KEY TO RP-F102.
    WRITE RP-RECORD GO CR23.
CR29. PERFORM OPEN-PR.
    IF CR-KOUT=0 MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP
      MOVE CR-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    PERFORM CR-PAGE MOVE LOW-VALUES TO CR-WTOTALS CR-GTOTALS MOVE 0 TO OLD-N.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO CR9.
CR3. READ REPFL NEXT END GO CR9. MOVE RP-F102 TO AT-KEY READ APTR REGARDLESS.
    IF AT-VEN=OLD-N GO CR4. IF OLD-N NOT=0 PERFORM CR-TOT. PERFORM CR-LINE.
    MOVE AT-VEN TO OLD-N FA113 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA114.
    PERFORM CR-LINE.
CR4. MOVE AT-INV TO FA115 MOVE AT-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA116.
    MOVE AT-DUE-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA117.
    MOVE AT-PROJECT TO FA118.
    MOVE AT-GROSS TO FA119 MOVE AT-DISC TO FA120 MOVE AT-NET TO FA121.
    IF AT-EXCH=0
      ADD AT-NET TO CR-WTOT(1,1) CR-GTOT(1,1)
      ADD AT-GROSS TO CR-WTOT(1,2) CR-GTOT(1,2)
     ELSE MOVE "US" TO FA123
      ADD AT-NET TO CR-WTOT(2,1) CR-GTOT(2,1)
      ADD AT-GROSS TO CR-WTOT(2,2) CR-GTOT(2,2)
      COMPUTE WD1 ROUNDED=AT-NET * AT-EXCH ADD WD1 TO CR-GTOT(3,1)
      COMPUTE WD1 ROUNDED=AT-GROSS * AT-EXCH ADD WD1 TO CR-GTOT(3,2).
    PERFORM CR-LINE GO CR3.
CR9. PERFORM CR-TOT MOVE "*** GRAND TOTALS" TO PREC.
    MOVE 1 TO IX1 PERFORM CR-G PERFORM PR-LINE.
    MOVE 2 TO IX1 PERFORM CR-G PERFORM PR-LINE-2.
    MOVE "CDN EQUIV" TO FA125 MOVE 3 TO IX1 PERFORM CR-G PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR IF CR-KOUT=0 PERFORM CLOSE-EXP.
    GO MX9.

CR-TOT. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO FA125.
    MOVE 1 TO IX1 PERFORM CR-W PERFORM PR-LINE.
    IF CR-WTOT(2,1) NOT=0 MOVE 2 TO IX1 PERFORM CR-W PERFORM CR-LINE.
    IF CR-KOUT=0 MOVE 1 TO IX1 PERFORM CR-F
      IF CR-WTOT(2,1) NOT=0 MOVE 2 TO IX1 PERFORM CR-F.
    PERFORM CR-LINE MOVE LOW-VALUES TO CR-WTOTALS.
CR-W. MOVE CR-WTOT(IX1,2) TO FA119 MOVE CR-WTOT(IX1,1) TO FA121.
    COMPUTE FA120=CR-WTOT(IX1,2) - CR-WTOT(IX1,1).
    MOVE V-NET(IX1) TO A-D1.
    IF CR-KOUT=1 IF A-D1 NOT=CR-WTOT(IX1,1) MOVE "ERROR" TO FA124
      MOVE A-D1 TO FA126 MOVE "*" TO FA127 IF IX1=2 MOVE "US" TO FA128.
    MOVE "*" TO FA122 IF IX1=2 MOVE "US" TO FA123.
CR-F. MOVE V-NAME TO EXP-A PERFORM EXPF MOVE V-NO TO EXP-N PERFORM EXPF.
    IF V-CLASS>0 MOVE 9 TO T-TBL MOVE V-CLASS TO T-NO PERFORM RD-TBL MOVE T-LINE TO EXP-A.
    PERFORM EXPF MOVE CR-WTOT(IX1,1) TO EXP-D PERFORM EXPF.
    IF IX1=2 MOVE "US" TO EXP-A. PERFORM EXPF PERFORM EXP-LINE.
CR-G. MOVE CR-GTOT(IX1,2) TO FA119 MOVE CR-GTOT(IX1,1) TO FA121.
    COMPUTE FA120=CR-GTOT(IX1,2) - CR-GTOT(IX1,1).
    MOVE "*" TO FA122 IF IX1=2 MOVE "US" TO FA123.
CR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM CR-PAGE.
CR-PAGE. IF CR-KOUT=1 MOVE "OUTSTANDING INVOICES REPORT" TO FF3
      ELSE MOVE "CASH REQUIREMENTS REPORT" TO FF3.
    PERFORM PR-PAGE.
    IF CR-KOUT=1 MOVE "A/P EFFECTIVE DATE:" TO A-A1 PERFORM PRANGE-DT
      MOVE 1 TO WS-PR PERFORM PRANGE-VEN
     ELSE IF WS-PAGE=1 MOVE 2 TO WS-PR
      MOVE "VENDORS   PAY CODE  INVOICE DATE  DUE DATE" TO PREC PERFORM PR-LINE
*           .... - ....   .       ../../..    ../../..
      PERFORM VARYING APS-IX1 FROM 1 BY 1 UNTIL APS-IX1>APS-SN
        MOVE APS-VEN1(APS-IX1) TO FA143 MOVE "-" TO FA143A MOVE APS-VEN2(APS-IX1) TO FA143B
        IF APS-PAY(APS-IX1)=0 MOVE "-" TO FA144 ELSE MOVE APS-PAY(APS-IX1) TO FA144A END-IF
        MOVE APS-DATE(APS-IX1) TO D-DATE PERFORM D-NM
        IF APS-KDUE(APS-IX1)=0 MOVE D-DT TO FA145 ELSE MOVE D-DT TO FA146 END-IF
        PERFORM PR-LINE END-PERFORM
      MOVE 2 TO WS-PR.
    MOVE "VEND  NAME  INVOICE           INV DATE  DUE DATE    PROJ        GROSS       DISC            NET" TO PREC PERFORM PR-LINE-3.
*         ....  ....................................
*                     ...............   ../../..  ../../..  ......  .,...,...:..- ...,...:..-  .,...,...:..-...

* Z-20-24 GENERATE CHEQUES
PC1. PERFORM RD375 PERFORM WRT PERFORM AX-US PERFORM APS-AXSEL.
    PERFORM AX-CHQ IF WS-CHQNO>0 SUBTRACT 1 FROM WS-CHQNO.
    MOVE WS-DIV TO AH-DIV MOVE USD-IND TO AH-US MOVE WS-CHQNO TO AH-NO.
    START APCHQ KEY>AH-KEY REGARDLESS INVALID GO PC14. READ APCHQ NEXT REGARDLESS.
    IF AH-DIV>WS-DIV OR AH-US NOT=USD-IND OR AH-NO>WS-CHQNO + 1000 GO PC14.
    MOVE " " TO ERR-MESG STRING "CANNOT PROCEED - CHEQUE NO. " AH-NO " ALREADY EXISTS"
      DELIMITED SIZE INTO ERR-MESG PERFORM DSP-ERR GO MX1.
PC14. ADD 1 TO IXT MOVE 1 TO IXU PERFORM AX-CHQDATE ADD 1 TO IXT.
PC143. DISPLAY "'OLD' FOR OLD CHEQUES: ___ " LINE IXT BOLD.
    ACCEPT XA3 LINE IXT COLUMN 24 DEFAULT " " UNDERLINED PROTECTED.
    IF XA3=" " MOVE 0 TO PC-KOLD ELSE IF XA3="OLD" MOVE 1 TO PC-KOLD
      ELSE PERFORM DSP-ERR14 GO PC143.
    PERFORM AX-PRNUM.
    ADD 1 TO IXT DISPLAY "PRINT FILE NO. FOR CHEQUE REGISTER REPORT: __" LINE IXT BOLD.
    ACCEPT PC-PR1 LINE IXT COLUMN 44 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    ADD 1 TO IXT DISPLAY "PRINT FILE NO. FOR REMITTANCE DETAILS: __" LINE IXT BOLD.
    ACCEPT PC-PR2 LINE IXT COLUMN 40 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM OPEN-PR ADD 1 TO IXT.
    PERFORM RDR-INFO IF IF-PRINTER=1 MOVE X"2A" TO EPS-PGL
      STRING EPS-INIT EPS-SKIPN EPS-PGLIN DELIMITED SIZE INTO PREC.
    PERFORM PR-LINE MOVE 1 TO PC-KAL.
PC15. IF PC-KAL=0 MOVE 6 TO WS-PR ELSE MOVE 5 TO WS-PR MOVE 0 TO PC-KAL.
    MOVE LIT-NUM9 TO FA728.
    IF PC-KOLD=1 MOVE LIT-ALP9 TO FA729 ELSE MOVE LIT-NUM9 TO FA730. PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE LIT-ALP9 TO FA731 PERFORM PR-LINE.
    MOVE LIT-ALP9 TO FA731 MOVE LIT-NUM9 TO FA732 PERFORM PR-LINE.
    MOVE 2 TO WS-PR MOVE LIT-ALP9 TO FA734 PERFORM PR-LINE.
    MOVE LIT-ALP9 TO FA734 PERFORM PR-LINE.
    MOVE LIT-ALP9 TO FA734 PERFORM PR-LINE.
    MOVE LIT-ALP9 TO FA734 PERFORM PR-LINE.
    MOVE 10 TO WS-PR MOVE LIT-ALP9 TO FA736 FA738.
    MOVE LIT-NUM9 TO FA735 FA737 FA739 PERFORM PR-LINE.
    MOVE 15 TO WS-PR MOVE LIT-NUM9 TO FA742 FA744 FA745 PERFORM PR-LINE.
    WRITE PREC AFTER PAGE.
    DISPLAY "ALIGNMENT TEST ('OK' TO START): __" LINE IXT BOLD.
    ACCEPT XA2 LINE IXT COLUMN 33 DEFAULT " " UNDERLINED PROTECTED IF XA2 NOT="OK" GO PC15.
    PERFORM DSP-WAIT PERFORM OPEN-REP.

* note 153
    MOVE " " TO V-KN START VENDOR KEY>=V-KN REGARDLESS INVALID GO PC29.
PC23. READ VENDOR NEXT REGARDLESS END GO PC29. IF V-DIV NOT=WS-DIV GO PC23.
    MOVE V-NO TO APS-VEN PERFORM APS-CHKVEN IF A-S1=0 GO PC23.
    MOVE 0 TO PC-NET.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO PC26.
PC25. READ APTR NEXT REGARDLESS END GO PC26. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO PC26.
    PERFORM PC-K IF A-S1=1 ADD AT-NET TO PC-NET.
    MOVE 0 TO AT-WIND REWRITE AT-RECORD ALLOWING NO UNLOCK APTR GO PC25.
PC26. IF PC-NET>0 PERFORM INIT-RP
       MOVE V-NO TO A-N1 PERFORM CHK-VENSP
       IF A-N1=0 MOVE 0 TO RP-F333 ELSE MOVE 1 TO RP-F333 END-IF
       MOVE V-NAME TO RP-F334 MOVE V-KEY TO RP-F335 WRITE RP-RECORD.
    GO PC23.
PC29.

    PERFORM OPEN-MAINTA PERFORM OPEN-MAINTB.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PC6.
PC3. READ REPFL NEXT END GO PC6. MOVE RP-F333 TO PC-KSP.
    MOVE RP-F335 TO V-KEY READ VENDOR REGARDLESS.
* note 199
    ADD 1 TO WS-CHQNO MOVE 0 TO PC-LNUM INITIALIZE PC-ATOTALS.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO PC34.
PC33. READ APTR NEXT REGARDLESS END GO PC34. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO PC34.
    PERFORM PC-K IF A-S1=0 GO PC33. ADD 1 TO PC-LNUM.
    IF AT-EXCH=0 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1.
    ADD AT-NET TO PC-NET PC-VNET(IX1) ADD AT-GROSS TO PC-GROSS PC-VGROSS(IX1).
    MOVE 1 TO AT-WIND REWRITE AT-RECORD ALLOWING NO UNLOCK APTR GO PC33.
PC34. MOVE WS-CHQNO TO RP-F336 MOVE PC-ATOTALS TO RP-F337 REWRITE RP-RECORD.
    IF PC-KSP=1 GO PC50.

    PERFORM PC-HEAD.
    IF PC-LNUM>14 MOVE "CHEQUE NO." TO FA740 MOVE WS-CHQNO TO FA740A
      MOVE WS-CHQDATE TO FA740B MOVE V-NO TO FA741 MOVE PC-NAD(1) TO FA741A
      MOVE 0 TO A-N1 PERFORM PC-WRB.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO PC44.
PC43. READ APTR NEXT REGARDLESS END GO PC44. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO PC44.
    IF AT-WIND=0 GO PC43. PERFORM PC-K IF A-S1=0 GO PC43. PERFORM PC-DETAIL.
    IF PC-LNUM>14 MOVE 1 TO A-N1 PERFORM PC-WRB
      ELSE PERFORM PR-LINE ADD 1 TO PC-LN.
    GO PC43.
PC44. MOVE PC-GROSS TO A-D1 MOVE PC-NET TO A-D2 PERFORM PC-END.
    IF PC-LNUM>14 MOVE 2 TO A-N1 PERFORM PC-WRB
      ELSE COMPUTE WS-PR=16 - PC-LN PERFORM PR-LINE.
    WRITE PREC AFTER PAGE GO PC58.

PC50. MOVE 1 TO PC-KFIR.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO PC54.
PC53. READ APTR NEXT REGARDLESS END GO PC54. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO PC54.
    IF AT-WIND=0 GO PC53. PERFORM PC-K IF A-S1=0 GO PC53.
    IF PC-KFIR=1 MOVE 0 TO PC-KFIR ELSE ADD 1 TO WS-CHQNO.
    PERFORM PC-HEAD PERFORM PC-DETAIL PERFORM PR-LINE ADD 1 TO PC-LN.
    MOVE AT-GROSS TO A-D1 MOVE AT-NET TO A-D2 PERFORM PC-END.
    COMPUTE WS-PR=16 - PC-LN PERFORM PR-LINE WRITE PREC AFTER PAGE GO PC53.
PC54. GO PC58.

PC58. GO PC3.
PC6. PERFORM RDR-INFO IF IF-PRINTER=1 STRING EPS-INIT DELIMITED SIZE INTO PREC PERFORM PR-LINE.
    PERFORM CLOSE-PR.

* note 154
    MOVE " " TO PC-PRA STRING "PRINT PR" PR-NUM ".PRN" DELIMITED SIZE INTO PC-PRA.
    DISPLAY "PRINT COMMAND: _" LINE IXT BOLD ERASE LINE "'OK' TO PRINT: __" COLUMN 62 BOLD.
    ACCEPT PC-PRA LINE IXT COLUMN 16 DEFAULT CURRENT UNDERLINED PROTECTED EDITING.
    ACCEPT XA2 LINE IXT COLUMN 77 DEFAULT " " UNDERLINED PROTECTED.
    IF XA2="OK" PERFORM DSP-QWAIT MOVE PC-PRA TO A-A1 PERFORM AUTO-PRINT PERFORM DSP-ERS.
    ADD 2 TO IXT DISPLAY "'OK' IF CHEQUES WERE PRINTED CORRECTLY: __" LINE IXT BOLD.
    ACCEPT XA2 LINE IXT COLUMN 41 DEFAULT " " UNDERLINED PROTECTED.
    ADD 2 TO IXT.
    IF XA2 NOT="OK" DISPLAY "DATA FILES WERE *NOT* UPDATED - YOU MUST RUN THIS FUNCTION AGAIN" LINE IXT BOLD
      PERFORM DSP-CONT GO PC9.
    DISPLAY "UPDATING DATA FILES - PLEASE WAIT ..." LINE IXT.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO PC79.
PC73. READ REPFL NEXT END GO PC79. MOVE RP-F333 TO PC-KSP.
    MOVE RP-F335 TO V-KEY READ VENDOR REGARDLESS.
    MOVE RP-F336 TO WS-CHQNO MOVE RP-F337 TO PC-ATOTALS MOVE 1 TO PC-KFIR.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO PC76.
PC75. READ APTR NEXT REGARDLESS END GO PC76. IF AT-DIV>WS-DIV OR AT-VEN NOT=V-NO GO PC76.
    IF AT-WIND=0 GO PC75. PERFORM PC-K IF A-S1=0 GO PC75.
    IF PC-KSP=1 IF PC-KFIR=1 MOVE 0 TO PC-KFIR ELSE ADD 1 TO WS-CHQNO END-IF
      PERFORM PC-CHQ.
    MOVE WS-CHQNO TO AT-CHQNO MOVE WS-CHQDATE TO AT-CHQDATE.
    MOVE 1 TO AT-IND REWRITE AT-RECORD ALLOWING NO UNLOCK APTR GO PC75.
PC76. IF PC-KSP=0 PERFORM PC-CHQ. PERFORM RDLK-VENDOR.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      SUBTRACT PC-VNET(IX1) FROM V-NET(IX1)
      SUBTRACT PC-VGROSS(IX1) FROM V-GROSS(IX1) END-PERFORM.
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR GO PC73.
PC79.

    CLOSE MAINTA OPEN INPUT MAINTA.
    MOVE PC-PR1 TO PR-NUM EXP-FLN PERFORM OPEN-PR PERFORM OPEN-EXP.
    MOVE PC-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.
    PERFORM PC-PAGE MOVE LOW-VALUES TO PC-GTOTALS.
PC83. READ MAINTA END GO PC84. MOVE MFA-F37 TO FA138 A-N1 PERFORM RD-VEN.
    MOVE MFA-F38 TO FA139 MOVE MFA-F39 TO FA140 MOVE WS-CHQDATE TO FA141.
    COMPUTE WD1=MFA-F40 - MFA-F41.
    MOVE MFA-F40 TO FA142(1) MOVE WD1 TO FA142(2) MOVE MFA-F41 TO FA142(3).
    ADD MFA-F40 TO PC-GTOT(1) ADD WD1 TO PC-GTOT(2) ADD MFA-F41 TO PC-GTOT(3).
    PERFORM PC-LINE.
    MOVE MFA-F38 TO EXP-A PERFORM EXPF MOVE MFA-F37 TO EXP-N PERFORM EXPF.
    IF V-CLASS>0 MOVE 9 TO T-TBL MOVE V-CLASS TO T-NO PERFORM RD-TBL MOVE T-LINE TO EXP-A.
    PERFORM EXPF MOVE MFA-F41 TO EXP-D PERFORM EXPF PERFORM EXP-LINE GO PC83.
PC84. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO FA139.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>3 MOVE PC-GTOT(IX1) TO FA142(IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-PR PERFORM CLOSE-EXP.

    CLOSE MAINTB OPEN INPUT MAINTB MOVE PC-PR2 TO PR-NUM PERFORM OPEN-PR.
PC85. READ MAINTB END GO PC86.
    IF MFB-F4=0 MOVE MFB-F5 TO PC-RHEAD PERFORM PC-RPAGE.
    IF MFB-F4=1 MOVE MFB-F5 TO PREC PERFORM PC-RLINE.
    IF MFB-F4=2 MOVE MFB-F5 TO PREC MOVE 2 TO WS-PR PERFORM PC-RLINE PERFORM PR-RESET.
    GO PC85.
PC86. PERFORM CLOSE-PR.
PC9. PERFORM CLOSE-REP CLOSE MAINTA MAINTB PERFORM DELETE-MAINT GO MX9.

PC-K. MOVE 0 TO A-S1.
    IF USD-IND=0 AND AT-EXCH=0 OR USD-IND=1 AND AT-EXCH NOT=0 PERFORM APS-CHKTR.
PC-HEAD. IF PC-KSP=1 MOVE AT-NET TO DSA-VAL ELSE MOVE PC-NET TO DSA-VAL.
    PERFORM DESC-AMT.
    PERFORM UNTIL DSA-LINE(4)>" " MOVE DSA-LINE(3) TO DSA-LINE(4)
      MOVE DSA-LINE(2) TO DSA-LINE(3) MOVE DSA-LINE(1) TO DSA-LINE(2)
      MOVE " " TO DSA-LINE(1) END-PERFORM.
    MOVE 6 TO WS-PR MOVE DSA-LINE(1) TO FA731 MOVE WS-CHQNO TO FA728.
    IF PC-KOLD=1 MOVE WS-CHQDATE TO FA729 ELSE MOVE WS-CHLDATE TO FA730.
    PERFORM PR-LINE.
    MOVE DSA-LINE(2) TO FA731 PERFORM PR-LINE.
    MOVE DSA-LINE(3) TO FA731 PERFORM PR-LINE.
    MOVE DSA-LINE(4) TO FA731.
    IF PC-KSP=1 MOVE AT-NET TO FA732 ELSE MOVE PC-NET TO FA732.
    MOVE "*" TO FA733 PERFORM PR-LINE.
    IF V-PAY=9 MOVE "***" TO PC-NAD(1) MOVE "FOR:" TO PC-NAD(2)
       MOVE V-NAME TO PC-NAD(3) MOVE " " TO PC-NAD(4)
     ELSE IF PC-KSP=1 MOVE AT-NAME TO PC-NAD(1) MOVE AT-ADD1 TO PC-NAD(2)
       MOVE AT-ADD2 TO PC-NAD(3) MOVE AT-POST TO PC-NAD(4)
     ELSE MOVE V-NAME TO PC-NAD(1) MOVE V-ADD1 TO PC-NAD(2)
       MOVE V-ADD2 TO PC-NAD(3) MOVE V-POST TO PC-NAD(4).
    MOVE 2 TO WS-PR PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4
      MOVE PC-NAD(IX1) TO FA734 PERFORM PR-LINE END-PERFORM.
    MOVE 0 TO PC-LN MOVE 10 TO WS-PR.

    MOVE V-NO TO MFA-F37 MOVE PC-NAD(1) TO MFA-F38 MOVE WS-CHQNO TO MFA-F39.
    IF PC-KSP=1 MOVE AT-GROSS TO MFA-F40 MOVE AT-NET TO MFA-F41
      ELSE MOVE PC-GROSS TO MFA-F40 MOVE PC-NET TO MFA-F41.
    WRITE MFA-RECORD.
PC-END. IF A-D1 NOT=A-D2 MOVE A-D1 TO FA742
      MOVE "DISCOUNT:" TO FA743 COMPUTE FA744=A-D1 - A-D2.
    MOVE A-D2 TO FA745.
PC-DETAIL. MOVE AT-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA735.
    MOVE AT-MEMO TO FA736 IF AT-DISC NOT=0 MOVE AT-DISC TO FA737.
    MOVE AT-INV TO FA738 MOVE AT-NET TO FA739.
PC-CHQ. MOVE LOW-VALUES TO AH-RECORD INITIALIZE AH-REC.
    MOVE WS-DIV TO AH-DIV MOVE USD-IND TO AH-US MOVE WS-CHQNO TO AH-NO.
    MOVE V-NO TO AH-VEN MOVE WS-CHQDATE TO AH-CHQDATE MOVE WS-CHNDATE TO AH-CHNDATE.
    IF PC-KSP=1 MOVE AT-GROSS TO AH-GROSS MOVE AT-NET TO AH-NET
      ELSE MOVE PC-GROSS TO AH-GROSS MOVE PC-NET TO AH-NET.
    WRITE AH-RECORD ALLOWING NO UNLOCK APCHQ.
    MOVE 0 TO GRT-KCAN PERFORM GRT-CHQ.
PC-WRB. MOVE A-N1 TO MFB-F4 MOVE PREC TO MFB-F5 WRITE MFB-RECORD MOVE " " TO PREC.
PC-RLINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PC-RPAGE.
PC-RPAGE. ADD 1 TO WS-PAGE MOVE PC-RHEAD TO PREC.
    IF WS-PAGE=1 WRITE PREC AFTER 0 ELSE WRITE PREC AFTER PAGE. MOVE " " TO PREC.
    MOVE 1 TO WS-LINES MOVE 2 TO WS-PR.
    MOVE "  DETAILS                                  INVOICE NO.             AMOUNT" TO PREC PERFORM PR-LINE-2.
*           ../../.. ..................  ....,...:..-............... ...,...,...:..-
*           ....,...:..-        ......... ...,...:..-                ...,...,...:..-
PC-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PC-PAGE.
PC-PAGE. MOVE "CHEQUE REGISTER" TO FF3.
    IF USD-IND=1 MOVE "- US$ -" TO FF4 ELSE MOVE "- CN$ -" TO FF4. PERFORM PR-IPAGE.
    MOVE "VEND  NAME                                     CHQ    DATE              GROSS       DISCOUNT           NET" TO PREC PERFORM PR-LINE-3.
*         ....  ....................................   ......   ..........  .,...,...:..-  .,...,...:..-  .,...,...:..-

* Z-20-25 OUTSTANDING CHEQUES REPORT
QC1. PERFORM RD376 PERFORM WRT MOVE 3 TO IXT MOVE 9 TO IXU PERFORM AX-US-S.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM OPEN-SORT.
    MOVE 1 TO QC-STEP PERFORM QC-PAGE MOVE LOW-VALUES TO QC-GTOTALS.
    MOVE WS-DIV TO AH-DIV MOVE USD-IND TO AH-US MOVE WS-CHQNO TO AH-NO.
    START APCHQ KEY>=AH-KEY REGARDLESS INVALID GO QC4.
QC3. READ APCHQ NEXT REGARDLESS END GO QC4. IF AH-DIV>WS-DIV GO QC4.
    IF AH-US NOT=USD-IND GO QC3.
    MOVE AH-VEN TO FA820 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA821.
    MOVE AH-NO TO FA822 MOVE AH-CHQDATE TO FA823 MOVE AH-NET TO FA824.
    IF AH-MDATE>0 MOVE AH-MDATE TO D-DATE PERFORM D-NM MOVE D-DT TO FA825.
    MOVE V-CLASS TO FA826 PERFORM QC-LINE.
    IF V-NO<9000 MOVE 1 TO IX1 ELSE MOVE 2 TO IX1.
    IF AH-MDATE=0 MOVE 1 TO IX2 ELSE MOVE 2 TO IX2.
    PERFORM INIT-SR MOVE V-CLASS TO SR-F124 MOVE AH-NET TO SR-F125(IX1,IX2).
    WRITE SR-RECORD INVALID READ SORTFL ADD AH-NET TO SR-F125(IX1,IX2) REWRITE SR-RECORD.
    ADD AH-NET TO QC-GTOT(1) GO QC3.
QC4. MOVE 2 TO WS-PR MOVE "*** TOTAL" TO FA821 MOVE QC-GTOT(1) TO FA824.
    PERFORM PR-LINE.

    MOVE 2 TO QC-STEP PERFORM QC-PAGE MOVE LOW-VALUES TO QC-GTOTALS QC-CTOTALS.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO QC6.
QC5. READ SORTFL NEXT END GO QC6. MOVE SR-F124 TO FA827.
    IF SR-F124>0 MOVE 9 TO T-TBL MOVE SR-F124 TO T-NO PERFORM RD-TBL MOVE T-LINE TO FA828.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
    PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>2
      MOVE SR-F125(IX1,IX2) TO FA829(IX1,IX2)
      ADD SR-F125(IX1,IX2) TO QC-CTOT(IX1,IX2) QC-GTOT(IX2) END-PERFORM END-PERFORM.
    PERFORM QC-LINE GO QC5.
QC6. MOVE 2 TO WS-PR MOVE "*** TOTALS" TO FA828.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
    PERFORM VARYING IX2 FROM 1 BY 1 UNTIL IX2>2
      MOVE QC-CTOT(IX1,IX2) TO FA829(IX1,IX2) END-PERFORM END-PERFORM.
    PERFORM PR-LINE-2 MOVE "*** COMBINED TOTALS" TO FA828.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      MOVE QC-GTOT(IX1) TO FA829(1,IX1) END-PERFORM.
    PERFORM PR-LINE.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR.
QC9. GO MX9.

QC-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM QC-PAGE.
QC-PAGE. MOVE "OUTSTANDING CHEQUES REPORT" TO FF3.
    IF USD-IND=1 MOVE "- US$ -" TO FF4 ELSE MOVE "- CN$ -" TO FF4. PERFORM PR-PAGE.
    IF QC-STEP=1 MOVE
         "VEND  NAME                                     CHQ    DATE               NET      MAILED   COM CLS" TO PREC PERFORM PR-LINE-3.
*         ....  ....................................   ......   ..........  .,...,...:..-  ../../..    ...
    IF QC-STEP=2 MOVE "SUMMARY BY COMMODITY CLASS" TO PREC PERFORM PR-LINE-3
      MOVE
         "CLASS                                                                  TRADE                              AFFILIATES" TO PREC PERFORM PR-LINE
      MOVE
         "                                                             ON HAND           MAILED              ON HAND           MAILED" TO PREC PERFORM PR-LINE-3.
*         ...  .............................................       ..,...,...:..-   ..,...,...:..-       ..,...,...:..-   ..,...,...:..-

* Z-20-26 PRINT G/L CHART OF ACCOUNTS
CA1. PERFORM RD364 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM CA-PAGE.
    MOVE WS-DIV TO G-DIV MOVE 0 TO G-GL.
    START GLDIST KEY>G-KEY REGARDLESS INVALID GO CA9.
CA3. READ GLDIST NEXT REGARDLESS END GO CA9. IF G-DIV>WS-DIV GO CA9.
    MOVE G-GL TO FA173 MOVE G-DESC TO FA174 MOVE G-NGL TO FA175.
    PERFORM CA-LINE GO CA3.
CA9. PERFORM CLOSE-PR GO MX9.

CA-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM CA-PAGE.
CA-PAGE. MOVE "G/L CHART OF ACCOUNTS" TO FF3 PERFORM PR-PAGE.
    MOVE "G/L ACCOUNT              DESCRIPTION                  NEW G/L ACCOUNT" TO PREC PERFORM PR-LINE-3.
*         ...... ... .. .......    .........................    ...... ...... .... ..

* Z-20-27 A/P DISTRIBUTION AND ACCRUAL REPORTS
GL1. PERFORM RD323 PERFORM WRT IF S-BAT GO GL2.
    PERFORM AX-SEL IF SEL-N=0 OR>4 GO MX1.
    IF Y1 OR Y2 PERFORM AX-AP-DATE PERFORM AX-GLAC.
    IF Y3 OR Y4 PERFORM AX-DATE
      ADD 1 TO IXT DISPLAY "G/L A/C: _____________________ " LINE IXT BOLD
      MOVE 10 TO IXU MOVE 0 TO WS-GL PERFORM AX-GL MOVE WS-GL TO GLAC1.
    PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
GL2. PERFORM DSP-WAIT PERFORM OPEN-REP.
    IF Y1 OR Y2
      MOVE DATE0 TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO GL-MTH.
    IF Y3 OR Y4
      MOVE DATE1 TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO GL-MTH1
      MOVE DATE2 TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO GL-MTH2.
    INITIALIZE GT-KEY MOVE WS-DIV TO GT-DIV.
    START GLTR KEY>GT-KEY REGARDLESS INVALID GO GL29.
GL23. READ GLTR NEXT REGARDLESS END GO GL29. IF GT-DIV>WS-DIV GO GL29.
    IF Y1 OR Y2 IF NOT(GT-GL>=GLAC1 AND<=GLAC2) GO GL23.
    IF Y3 OR Y4 IF GT-GL NOT=GLAC1 GO GL23.
    MOVE GT-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE GT-MM TO D-MM.
    PERFORM D-MTHS.
    IF Y1 OR Y2 IF D-N1 NOT=GL-MTH GO GL23.
    IF Y3 OR Y4 IF NOT(D-N1>=GL-MTH1 AND<=GL-MTH2) GO GL23.
    IF Y2 MOVE GT-INV-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS
      IF D-N1>=GL-MTH GO GL23.
    PERFORM INIT-RP MOVE GT-GL TO RP-F125.
    IF Y1 OR Y2 MOVE GT-VEN TO RP-F127 MOVE GT-INV TO RP-F128.
    IF Y3 MOVE GT-INV TO RP-F129.
    IF Y4 IF GT-AMT>=0 MOVE GT-AMT TO WD1 ELSE COMPUTE WD1=-GT-AMT END-IF
      COMPUTE RP-F130=999999999.99 - WD1.
    MOVE GT-TYPE TO RP-F131 MOVE GT-SYS TO RP-F132.
    MOVE 0 TO RP-F133 MOVE GT-KEY TO RP-F134.
GL27. WRITE RP-RECORD INVALID IF RP-F133<999 ADD 1 TO RP-F133 GO GL27 END-IF.
* note 201
    GO GL23.
GL29. PERFORM OPEN-PR PERFORM GL-PAGE.
    MOVE LOW-VALUES TO GL-ATOTALS GL-BTOTALS GL-CTOTALS GL-GTOTALS.
    MOVE -1 TO GL-OA GL-OB GL-OC.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO GL9.
GL3. READ REPFL NEXT END GO GL9. MOVE RP-F134 TO GT-KEY READ GLTR REGARDLESS.
    MOVE GT-GL(1:6) TO GL-OX IF GL-OX=GL-OC GO GL34.
    IF GL-OC NOT=-1 PERFORM GL-A PERFORM GL-B PERFORM GL-C.
    MOVE GL-OX TO GL-OC MOVE -1 TO GL-OA GL-OB.
GL34. MOVE GT-GL(1:9) TO GL-OX IF GL-OX=GL-OB GO GL36.
    IF GL-OB NOT=-1 PERFORM GL-A PERFORM GL-B.
    MOVE GL-OX TO GL-OB MOVE -1 TO GL-OA.
GL36. IF GT-GL=GL-OA GO GL4. IF GL-OA NOT=-1 PERFORM GL-A. MOVE GT-GL TO GL-OA.
    INITIALIZE G-REC MOVE WS-DIV TO G-DIV MOVE GL-OA TO G-GL FA152.
    READ GLDIST REGARDLESS INVALID CONTINUE. MOVE G-DESC TO FA153.
    MOVE 2 TO WS-PR PERFORM GL-LINE 2 TIMES.
GL4. MOVE GT-VEN TO FA157 A-N1 PERFORM RD-VEN MOVE V-NAME TO FA158.
    IF GT-TYPE=1 MOVE "X" TO FA159. IF GT-TYPE=3 MOVE "C" TO FA159.
    IF GT-TYPE=6 MOVE "F" TO FA159. IF GT-TYPE=7 MOVE "E" TO FA159.
    MOVE GT-INV TO FA160 MOVE GT-AMT TO FA161.
    ADD GT-AMT TO GL-ATOT(1) GL-BTOT(1) GL-CTOT(1) GL-GTOT(1).
    ADD GT-QTY TO GL-ATOT(2) GL-BTOT(2) GL-CTOT(2) GL-GTOT(2).
    PERFORM GL-LINE GO GL3.
GL9. PERFORM GL-A PERFORM GL-B PERFORM GL-C.
    MOVE "*** PROOF" TO FA153 MOVE GL-GTOT(1) TO FA154 MOVE GL-GTOT(2) TO FA155.
    MOVE 3 TO WS-PR PERFORM PR-LINE.
    PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

GL-A. MOVE GL-OA TO FA152 MOVE "  * TOTAL" TO FA153 MOVE "*" TO FA156.
    MOVE GL-ATOT(1) TO FA154 MOVE GL-ATOT(2) TO FA155.
    PERFORM GL-LINE MOVE LOW-VALUES TO GL-ATOTALS.
GL-B. MOVE GL-OB TO FA164 MOVE " ** TOTAL" TO FA153 MOVE "**" TO FA156.
    MOVE GL-BTOT(1) TO FA154 MOVE GL-BTOT(2) TO FA155.
    MOVE 2 TO WS-PR PERFORM GL-LINE 2 TIMES MOVE LOW-VALUES TO GL-BTOTALS.
GL-C. MOVE GL-OC TO FA163 MOVE "*** TOTAL" TO FA153 MOVE "***" TO FA156.
    MOVE GL-CTOT(1) TO FA154 MOVE GL-CTOT(2) TO FA155.
    MOVE 2 TO WS-PR PERFORM GL-LINE 2 TIMES MOVE LOW-VALUES TO GL-CTOTALS.
GL-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM GL-PAGE.
GL-PAGE. IF Y1 OR Y3 OR Y4 MOVE "A/P DISTRIBUTION REPORT" TO FF3.
    IF Y2 MOVE "A/P ACCRUAL REPORT" TO FF3.
    IF Y3 MOVE "(BY INVOICE)" TO FF4.
    IF Y4 MOVE "(BY AMOUNT)" TO FF4. PERFORM PR-IPAGE.
    IF Y1 OR Y2 MOVE "A/P EFFECTIVE DATE:" TO A-A1 PERFORM PRANGE-DT
      MOVE 1 TO WS-PR PERFORM PRANGE-GL.
    IF Y3 OR Y4 MOVE "MONTH RANGE:" TO A-A1 PERFORM PRANGE-MONTH
      MOVE GLAC1 TO DSP-GL1 STRING "A/C SELECTED: " DSP-GL1 DELIMITED SIZE INTO PREC
      MOVE 1 TO WS-PR PERFORM PR-LINE MOVE 2 TO WS-PR.
    MOVE "G/L ACCOUNT            DESCRIPTION                     AMT MTD     QTY MTD                   INVOICE                AMOUNT" TO PREC PERFORM PR-LINE-3.
*         ...... ... .. .......  .........................  .,...,...:..-  .,...,...-...
*                                                          .... .................................... . ...............  .,...,...:..-

* Z-20-28 A/P AGE ANALYSIS
PY1. PERFORM RD377 PERFORM WRT IF S-BAT GO PY2.
    MOVE 3 TO IXT MOVE 14 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.
    MOVE 4 TO IXT MOVE 17 TO IXU PERFORM AX-TOT-S.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    IF S-DEF GO MX9.
PY2. PERFORM DSP-WAIT PERFORM OPEN-REP MOVE -1 TO OLD-N.
    MOVE DATE0 TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO PY-MTHS.
    INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO PY29.
PY23. READ APTR NEXT REGARDLESS END GO PY29. IF AT-DIV>WS-DIV GO PY29.
    IF AT-IND=1 GO PY23.
    IF AT-VEN NOT=OLD-N MOVE AT-VEN TO OLD-N A-N1 PERFORM RD-VEN.
    PERFORM INIT-RP IF AT-VEN<9000 MOVE 1 TO RP-F329 ELSE MOVE 2 TO RP-F329.
    IF AT-EXCH=0 MOVE 1 TO RP-F329A ELSE MOVE 2 TO RP-F329A.
    MOVE V-NAME TO RP-F330 MOVE AT-KEY TO RP-F331 WRITE RP-RECORD GO PY23.
PY29. PERFORM OPEN-PR MOVE LOW-VALUES TO PY-STOTALS MOVE 1 TO PY-STEP.

PY3. PERFORM PY-PAGE MOVE LOW-VALUES TO PY-VTOTALS MOVE 0 TO OLD-M OLD-N.
    MOVE " " TO RP-KEY MOVE PY-STEP TO RP-F329.
    START REPFL KEY>RP-KEY INVALID GO PY8.
PY33. READ REPFL NEXT END GO PY8. IF RP-F329>PY-STEP GO PY8.
    MOVE RP-F331 TO AT-KEY READ APTR REGARDLESS.
    IF RP-F329A=OLD-M GO PY34. IF OLD-M NOT=0 PERFORM PY-V PERFORM PY-PAGE.
    MOVE RP-F329A TO OLD-M MOVE 0 TO OLD-N.
PY34. IF AT-VEN=OLD-N GO PY4. IF OLD-N NOT=0 PERFORM PY-V.
    MOVE AT-VEN TO OLD-N FD384 A-N1 PERFORM RD-VEN MOVE V-NAME TO FD385.
    PERFORM PY-LINE.
PY4. MOVE AT-INV TO FD386 MOVE AT-INV-DATE TO D-DATE PERFORM D-NM MOVE D-DT TO FD387.
    MOVE AT-INV-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS COMPUTE IX1=PY-MTHS - D-N1.
    IF IX1<0 MOVE 0 TO IX1. IF IX1>4 MOVE 4 TO IX1. ADD 2 TO IX1.
    MOVE PY-STEP TO IX2.
    IF AT-EXCH=0 ADD AT-NET TO PY-STOT(IX2,1,IX1) PY-STOT(3,1,IX1) PY-STOT(IX2,1,1) PY-STOT(3,1,1)
     ELSE ADD AT-NET TO PY-STOT(IX2,2,IX1) PY-STOT(3,2,IX1) PY-STOT(IX2,2,1) PY-STOT(3,2,1)
      COMPUTE WD1 ROUNDED=AT-NET * AT-EXCH
      ADD WD1 TO PY-STOT(IX2,3,IX1) PY-STOT(3,3,IX1) PY-STOT(IX2,3,1) PY-STOT(3,3,1).
    MOVE AT-NET TO FD388(IX1) ADD AT-NET TO PY-VTOT(IX1) PY-VTOT(1).
    IF TOT-IND=0 PERFORM PY-LINE ELSE MOVE " " TO PREC. GO PY33.
PY8. PERFORM PY-V IF PY-STEP=1 MOVE 2 TO PY-STEP GO PY3.

    MOVE 0 TO PY-STEP PERFORM PY-PAGE MOVE 1 TO IX2.
PY83. MOVE 4 TO WS-PR.
    IF IX2=1 MOVE "TOTALS EXCLUDING AFFILIATES" TO PREC.
    IF IX2=2 MOVE "TOTALS AFFILIATES" TO PREC.
    IF IX2=3 MOVE "TOTALS ALL VENDORS" TO PREC.
    PERFORM PR-LINE-2.
    MOVE "** CN$ TOTALS" TO PREC PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      MOVE PY-STOT(IX2,1,IX1) TO FD388(IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    MOVE "** US$ TOTALS" TO PREC PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      MOVE PY-STOT(IX2,2,IX1) TO FD388(IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    MOVE "** CN$ EQUIV" TO PREC PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      MOVE PY-STOT(IX2,3,IX1) TO FD388(IX1) END-PERFORM.
    PERFORM PR-LINE-2.
    MOVE "*** GRAND TOTALS" TO PREC PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
      COMPUTE FD388(IX1)=PY-STOT(IX2,1,IX1) + PY-STOT(IX2,3,IX1) END-PERFORM.
    PERFORM PR-LINE-2 ADD 1 TO IX2 IF IX2<=3 GO PY83.
PY9. PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

PY-V. MOVE "** TOTALS" TO FD386 PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>6
       MOVE PY-VTOT(IX1) TO FD388(IX1) END-PERFORM.
    PERFORM PY-LINE 2 TIMES MOVE LOW-VALUES TO PY-VTOTALS.
PY-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM PY-PAGE.
PY-PAGE. MOVE "ACCOUNTS PAYABLE AGE ANALYSIS" TO FF3.
    IF PY-STEP=1 MOVE "(EXCLUDING AFFILIATES)" TO FF4.
    IF PY-STEP=2 MOVE "(AFFILIATES)" TO FF4. PERFORM PR-IPAGE.
    MOVE "AGING DATE:" TO A-A1 PERFORM PRANGE-DT.
    MOVE "VEND  NAME" TO PREC PERFORM PR-LINE.
    MOVE "      INVOICE            DATE          TOTAL       CURRENT       30 DAYS       60 DAYS       90 DAYS      120 DAYS" TO PREC PERFORM PR-LINE-3.
*         ....  ....................................
*               ...............  ../../.. .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..- .,...,...:..-

* Z-20-29 GENERATE SUBCONTRACTOR INVOICES
IH1. PERFORM RD378 PERFORM WRT.
    PERFORM RDR-INFO MOVE SYS-DATE TO D-DATE PERFORM D-NM.
    ADD 1 TO IXT DISPLAY "A/P EFFECTIVE DATE: " LINE IXT BOLD D-DT.
    PERFORM AX-EXCH PERFORM AX-PRNUM PERFORM AX-ACC IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    OPEN I-O TMPURORD ALLOWING ALL TMPURLIN ALLOWING ALL
      SUBCON ALLOWING ALL SUBINV ALLOWING ALL.

    MOVE " " TO SL-KEY START SUBINV KEY>SL-KEY REGARDLESS INVALID GO IH29.
IH23. READ SUBINV NEXT REGARDLESS END GO IH29. IF SL-IND=1 GO IH23.
    PERFORM INIT-RP MOVE SL-SLIP TO RP-F338.
    WRITE RP-RECORD INVALID CONTINUE. GO IH23.
IH29. PERFORM OPEN-PR PERFORM IH-PAGE.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO IH8.
IH3. READ REPFL NEXT END GO IH8. PERFORM INIT-AT MOVE RP-F338 TO AT-INV FF530.
    MOVE 0 TO IH-IXR IH-NORD IH-TWEIGHT IH-PFREIGHT MOVE " " TO IH-OLDNO.
    INITIALIZE SL-KS MOVE RP-F338 TO SL-SLIP.
    START SUBINV KEY>SL-KS REGARDLESS INVALID GO IH6.
IH33. READ SUBINV NEXT REGARDLESS END GO IH6. IF SL-SLIP>RP-F338 GO IH6.
    IF SL-IND=1 GO IH33. IF IH-IXR=30 GO IH6. MOVE 0 TO IH-ERR.
    MOVE SL-MAC TO SJ-MAC MOVE SL-MO TO SJ-MO MOVE SL-SUFFIX TO SJ-SUFFIX.
    MOVE SL-LOT TO SJ-LOT MOVE SL-PROD TO SJ-PROD.
    READ SUBCON REGARDLESS INVALID MOVE 1 TO IH-ERR GO IH48.
    MOVE SJ-MAC TO FF531 MOVE SJ-LOT TO FF532.
    MOVE SL-ORD TO FF533 OK-NO READ PURORD REGARDLESS INVALID MOVE 2 TO IH-ERR GO IH48.
    MOVE SJ-MAC TO A-N1 PERFORM RD-MAC MOVE M-LOT-CHARGE TO IH-LOT-CHARGE.
    MOVE M-BATCH-CHARGE TO IH-BATCH-CHARGE MOVE M-SURCHARGE TO IH-SURCHARGE.
    MOVE OK-VENDOR TO FF534.

    IF OK-NO=IH-OLDNO GO IH36.
    MOVE OK-FOB TO IH-FOB MOVE OK-US TO IH-US MOVE OK-PSTPAY TO IH-PSTPAY.
    MOVE WS-DIV TO V-DIV MOVE OK-VENDOR TO V-NO.
    READ VENDOR REGARDLESS INVALID MOVE 3 TO IH-ERR GO IH48.
    MOVE V-FREIGHT-STD TO IH-FSTD MOVE V-FREIGHT-RATE TO IH-FRATE.
    MOVE V-FRPAY TO IH-FRPAY MOVE V-DISC TO IH-DISC.

    MOVE WS-DIV TO AT-DIV MOVE V-NO TO AT-VEN MOVE 0 TO AT-TYPE.
    READ APTR REGARDLESS INVALID GO IH34. MOVE 4 TO IH-ERR GO IH48.
IH34. PERFORM GRT-CHKDUP IF A-S1=1 MOVE 5 TO IH-ERR GO IH48.
    IF INUT MOVE SL-INV-DATE TO AT-INV-DATE ELSE MOVE SYS-DATE TO AT-INV-DATE.
    MOVE AT-INV-DATE TO D-DATE PERFORM CALC-DUE-DATE MOVE D-DATE TO AT-DUE-DATE.
    IF IH-US=1 MOVE WS-EXCH TO AT-EXCH.
    ADD 1 TO IH-IXR MOVE OK-NO TO IH-ORD(IH-IXR) AT-ORD IH-OLDNO MOVE IH-IXR TO IH-NORD.

    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IH344.
IH343. READ PURLIN NEXT REGARDLESS END GO IH344. IF LK-ORD NOT=OK-NO GO IH344.
    IF NOT(LK-QTY-LAST=0 AND LK-TOTAL-LAST=0 AND LK-CHARGE-LAST=" ")
      INITIALIZE LK-QTY-LAST LK-TOTAL-LAST LK-CHARGE-LAST
      REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    GO IH343.
IH344.

IH36. MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IH46.
IH43. READ PURLIN NEXT REGARDLESS END GO IH46. IF LK-ORD NOT=OK-NO GO IH46.
    IF INUT MOVE SJ-MAC TO A-U1 PERFORM LEAD-ZERO MOVE A-U1(A-N1:) TO WA1
      IF WA1 NOT=LK-PART GO IH43 END-IF
     ELSE IF NOT(LK-SUB-MAC=SJ-MAC AND LK-SUB-MO=SJ-MO
       AND LK-SUB-SUFFIX=SJ-SUFFIX AND LK-SUB-LOT=SJ-LOT) GO IH43.
* note 118
    INITIALIZE IH-COST IH-CMODE MOVE SJ-PROD TO A-A1 PERFORM PROD-RT.
    PERFORM GET-OP IF A-S1=1 GO IH446. MOVE 1 TO IX1.
IH443. MOVE OP-OPER(IX1) TO A-N1 PERFORM CHK-SUBCON IF A-S1=0 GO IH444.
    IF OP-OPER(IX1) NOT=SJ-MAC GO IH444.
    IF OP-COST(IX1)>0 MOVE OP-COST(IX1) TO IH-COST MOVE OP-CMODE(IX1) TO IH-CMODE
      ELSE MOVE M-COST TO IH-COST MOVE M-CMODE TO IH-CMODE.
    GO IH446.
IH444. ADD 1 TO IX1 IF IX1<=12 GO IH443.
IH446. IF IH-COST>0 AND IH-CMODE>" "
        IF IH-CMODE="G" OR "N" MOVE "C" TO LK-MODE
          COMPUTE LK-PRICE ROUNDED=IH-COST * 100 / 2000
         ELSE MOVE "M" TO LK-MODE MOVE IH-COST TO LK-PRICE.
    IF LK-MODE="M" MOVE SL-QTY TO LK-QTY-LAST ELSE MOVE SL-WEIGHT TO LK-QTY-LAST.
    MOVE LK-QTY-LAST TO CL-QTY PERFORM KPRICE-CALC MOVE CL-AMT TO LK-TOTAL-LAST.

* note 190
    IF INUT MOVE IH-LOT-CHARGE TO WD1
      ELSE COMPUTE WD1 ROUNDED=IH-LOT-CHARGE * LK-QTY-LAST / LK-QTY.
    IF LK-TOTAL-LAST<WD1 MOVE WD1 TO LK-TOTAL-LAST MOVE "L" TO LK-CHARGE-LAST(2:1).
    IF IH-BATCH-CHARGE>0
      PERFORM VARYING WD1 FROM 0 BY IH-BATCH-CHARGE UNTIL WD1>=LK-TOTAL-LAST CONTINUE END-PERFORM
      IF WD1>LK-TOTAL-LAST MOVE WD1 TO LK-TOTAL-LAST MOVE "B" TO LK-CHARGE-LAST(1:1).
    IF IH-SURCHARGE>0 COMPUTE WD1 ROUNDED=LK-TOTAL-LAST * IH-SURCHARGE / 100
      ADD WD1 TO LK-TOTAL-LAST MOVE "S" TO LK-CHARGE-LAST(3:1).
    IF SL-PALLETS NOT=0 COMPUTE WD1=SL-PALLETS * 3
      ADD WD1 TO LK-TOTAL-LAST MOVE "P" TO LK-CHARGE-LAST(4:1).
    IF SL-TRUCK=1 ADD 100 TO IH-PFREIGHT MOVE "T" TO LK-CHARGE-LAST(5:1).
    IF SL-LTLOAD=1 ADD 50 TO IH-PFREIGHT MOVE "X" TO LK-CHARGE-LAST(6:1).
    IF SL-METRO=1 ADD 50 TO IH-PFREIGHT MOVE "M" TO LK-CHARGE-LAST(7:1).
    IF SL-RBUCKETS NOT=0 COMPUTE WD1 ROUNDED=SL-RBUCKETS * 0.75
      ADD WD1 TO LK-TOTAL-LAST MOVE "R" TO LK-CHARGE-LAST(8:1).
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    ADD SL-WEIGHT TO IH-TWEIGHT.
    MOVE SL-QTY TO FF535 MOVE SL-WEIGHT TO FF536.
    MOVE LK-PRICE TO FF537 MOVE LK-MODE TO FF537A.
    MOVE CL-DTXT(1:9) TO FF538 MOVE LK-TOTAL-LAST TO FF539.
    MOVE LK-CHARGE-LAST TO FF540.
IH46.
IH48. PERFORM IH-LINE.
    IF IH-ERR>0 MOVE "   ** ERROR:" TO FF527 EVALUATE TRUE
      WHEN IH-ERR=1 MOVE "NO SUBCON RECORD" TO FF528
      WHEN IH-ERR=2 MOVE "NO P.O. RECORD" TO FF528
      WHEN IH-ERR=3 MOVE "NO VENDOR RECORD" TO FF528
      WHEN IH-ERR=4 MOVE "DUPLICATE APTR RECORD" TO FF528
      WHEN IH-ERR=5 MOVE "DUPLICATE GLTR RECORD" TO FF528
      END-EVALUATE PERFORM IH-LINE.
    MOVE 1 TO SL-IND REWRITE SL-RECORD ALLOWING NO UNLOCK SUBINV.
* note 218
    IF IH-ERR=0 AND SL-MO NOT=0 MOVE SL-JMAC TO A-N1 PERFORM IH-JADD
      IF SL-JRET=1 MOVE 599 TO A-N1 PERFORM IH-JADD.
    GO IH33.

IH6. MOVE 0 TO IH-IXR IX1.
IH61. ADD 1 TO IH-IXR IF IH-IXR>IH-NORD GO IH66.
    MOVE IH-ORD(IH-IXR) TO OK-NO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IH64.
IH63. READ PURLIN NEXT REGARDLESS END GO IH64. IF LK-ORD NOT=OK-NO GO IH64.
    IF LK-QTY-LAST=0 OR LK-GL=0 GO IH63. MOVE 0 TO IX2.
IH633. ADD 1 TO IX2 IF IX2>IX1 GO IH634.
    IF LK-GL=AT-GL(IX2)
      ADD LK-TOTAL-LAST TO AT-AMT(IX2) ADD LK-QTY-LAST TO AT-QTY(IX2) GO IH636.
    GO IH633.
IH634. IF IX1<10 ADD 1 TO IX1 MOVE LK-GL TO AT-GL(IX1)
         MOVE LK-TOTAL-LAST TO AT-AMT(IX1) MOVE LK-QTY-LAST TO AT-QTY(IX1).
IH636. GO IH63.
IH64. GO IH61.
IH66.

    MOVE 2 TO WS-PR.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>10 OR AT-GL(IX1)=0
      ADD AT-AMT(IX1) TO AT-GROSS AT-TOTAL
      MOVE AT-GL(IX1) TO FF541 MOVE AT-AMT(IX1) TO FF542 PERFORM IH-LINE END-PERFORM.

    IF IH-FSTD>0 MOVE IH-FSTD TO AT-FREIGHT
      ELSE COMPUTE AT-FREIGHT ROUNDED=IH-FRATE * IH-TWEIGHT / 100.
    ADD IH-PFREIGHT TO AT-FREIGHT.
    MOVE IH-FRPAY TO AT-FRPAY IF IH-FRPAY=1 ADD AT-FREIGHT TO AT-GROSS.
    IF V-GST-IND=0
      IF IH-US=0 MOVE AT-TOTAL TO WD1 IF IH-FRPAY=1 ADD AT-FREIGHT TO WD1 END-IF
        COMPUTE AT-GST ROUNDED=WD1 * IF-GST / 100 END-IF
      ADD AT-GST TO AT-GROSS.
    IF IH-PSTPAY=1 COMPUTE AT-PST ROUNDED=AT-TOTAL * IF-PST / 100
      ADD AT-PST TO AT-GROSS.
    IF V-DISC=0 MOVE AT-GROSS TO AT-NET
      ELSE COMPUTE AT-DISC ROUNDED=AT-TOTAL * IH-DISC / 100
        COMPUTE AT-NET=AT-GROSS - AT-DISC.
    MOVE SYS-DATE TO AT-DATE AT-EFF-DATE.
    MOVE "**" TO FF541X(20:) MOVE AT-TOTAL TO FF542.
    IF AT-FRPAY<=1 MOVE LIT-NY(AT-FRPAY + 1:1) TO FF543.
    MOVE AT-FREIGHT TO FF544(1) MOVE AT-GST TO FF544(2) MOVE AT-PST TO FF544(3).
    MOVE AT-GROSS TO FF544(4) MOVE AT-NET TO FF544(5) PERFORM IH-LINE 2 TIMES.

    PERFORM RDLK-VENDOR IF AT-EXCH=0 MOVE 1 TO IH-IXE ELSE MOVE 2 TO IH-IXE.
    ADD AT-TOTAL TO V-PUR-YTD(IH-IXE) ROUNDED MOVE AT-INV-DATE TO V-INV-DATE.
    ADD AT-GROSS TO V-GROSS(IH-IXE) ADD AT-NET TO V-NET(IH-IXE).
    ADD AT-DISC TO V-DISC-YTD(IH-IXE) ROUNDED.
    REWRITE V-RECORD ALLOWING NO UNLOCK VENDOR.

    MOVE 0 TO IH-IXR.
IH71. ADD 1 TO IH-IXR IF IH-IXR>IH-NORD GO IH76.
    MOVE IH-ORD(IH-IXR) TO OK-NO READ PURORD REGARDLESS. MOVE AT-INV TO OK-INV.
    IF IH-IXR=1 MOVE AT-DISC TO OK-DISC MOVE AT-FREIGHT TO OK-FREIGHT
      MOVE AT-FRPAY TO OK-FRPAY MOVE AT-GST TO OK-GST MOVE AT-PST TO OK-PST
     ELSE MOVE 0 TO OK-DISC OK-FREIGHT OK-FRPAY OK-GST OK-PST.
    MOVE AT-INV-DATE TO OK-INV-DATE-LAST MOVE AT-DUE-DATE TO OK-DUE-DATE-LAST.
    MOVE AT-EFF-DATE TO OK-EFF-DATE-LAST.
    REWRITE OK-RECORD ALLOWING NO UNLOCK PURORD.
    MOVE LOW-VALUES TO YOK-RECORD MOVE OK-NO TO YOK-ORD MOVE 0 TO YOK-SEQ.
    MOVE 2 TO YOK-PR MOVE USN-USER TO YOK-USER MOVE OK-RECORD TO YOK-DATA.
IH713. WRITE YOK-RECORD ALLOWING NO INVALID ADD 1 TO YOK-SEQ GO IH713. UNLOCK TMPURORD.
* note 175.1

    MOVE OK-NO TO LK-ORD MOVE 0 TO LK-LINE.
    START PURLIN KEY>LK-KEY REGARDLESS INVALID GO IH74.
IH73. READ PURLIN NEXT REGARDLESS END GO IH74. IF LK-ORD NOT=OK-NO GO IH74.
    IF LK-QTY-LAST=0 GO IH73. MOVE SYS-DATE TO LK-DATE-LAST.
    ADD LK-QTY-LAST TO LK-QTY-REC ROUNDED ADD LK-TOTAL-LAST TO LK-TOTAL-REC.
    REWRITE LK-RECORD ALLOWING NO UNLOCK PURLIN.
    MOVE LK-ORD TO YLK-ORD MOVE YOK-SEQ TO YLK-SEQ MOVE LK-LINE TO YLK-LINE.
    MOVE LK-RECORD TO YLK-DATA WRITE YLK-RECORD ALLOWING NO UNLOCK TMPURLIN.

    COMPUTE IH-QTY ROUNDED=LK-QTY-LAST.
    MOVE 0 TO WD1 IF AT-EXCH NOT=0 COMPUTE WD1 ROUNDED=AT-TOTAL * (AT-EXCH - 1).
    COMPUTE IH-AMT ROUNDED=LK-TOTAL-LAST + (AT-FREIGHT + WD1) * LK-TOTAL-LAST / AT-TOTAL
      SIZE ERROR MOVE 0 TO IH-AMT.
    MOVE IH-AMT TO A-T1 PERFORM MUL-PAMT COMPUTE IH-LDAMT ROUNDED=A-T1.
    COMPUTE IH-LDCOST ROUNDED=IH-LDAMT / IH-QTY SIZE ERROR MOVE 0 TO IH-LDCOST.

    PERFORM INIT-PU MOVE AT-INV-DATE TO PU-INV-DATE.
    MOVE LK-TOTAL-LAST TO PU-AMT MOVE IH-QTY TO PU-QTY MOVE IH-LDCOST TO PU-LDCOST.
    WRITE PU-RECORD ALLOWING NO UNLOCK PURHIST GO IH73.
IH74. GO IH71.
IH76.

    PERFORM SET-ATKD WRITE AT-RECORD ALLOWING NO UNLOCK APTR.
    MOVE V-NO TO GRT-VEN PERFORM GRT-PROC.
    GO IH3.
IH8. CLOSE TMPURORD TMPURLIN SUBCON SUBINV.
    PERFORM CLOSE-REP PERFORM CLOSE-PR.
IH9. GO MX9.

IH-JADD. PERFORM INIT-J MOVE SL-MO TO J-NO MOVE A-N1 TO J-MAC.
    MOVE SL-JDATE TO J-DATE MOVE SL-PROD TO J-PROD.
    MOVE " " TO J-NOTE STRING "P/S " SL-SLIP DELIMITED SIZE INTO J-NAME.
    MOVE SL-QTY TO J-QTY MOVE SL-WEIGHT TO J-WEIGHT.
    PERFORM SET-JKD WRITE J-RECORD ALLOWING NO INVALID READ WORKSHEET REGARDLESS
      MOVE J-NAME TO A-A1 PERFORM STR-LTH
      IF A-N1<=18 MOVE SL-SLIP TO J-NAME(A-N1 + 2:) END-IF
      ADD SL-QTY TO J-QTY ADD SL-WEIGHT TO J-WEIGHT REWRITE J-RECORD ALLOWING NO.
    UNLOCK WORKSHEET.
IH-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM IH-PAGE.
IH-PAGE. MOVE "SUBCONTRACTOR INVOICE GENERATION" TO FF3 PERFORM PR-PAGE.
    MOVE "INVOICE     SUBCON  LOT      P.O.      VEN        QTY    WEIGHT    PRICE  MODE  DISCOUNT    AMOUNT  BLSPTXMR" TO PREC PERFORM PR-LINE.
    MOVE "                                    G/L DISTRIBUTION          AMOUNT    FR-V  FREIGHT      GST        PST      GROSS        NET" TO PREC PERFORM PR-LINE-3.
*         ..........   ...    .......  ........  .... ..,...,...- ...,...- .,...:... ..   ......... ..,...:..-........
*                                             ...... ... .. .......  ...,...:..-   . ..,...:..- ..,...:..- ..,...:..- ..,...:..- ..,...:..-

* Z-20-30 VENDOR LISTING
VE1. PERFORM RD379 PERFORM WRT.
    MOVE 3 TO IXT MOVE 15 TO IXU MOVE 37 TO IXV PERFORM AX-VEN-R.
    MOVE 5 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-PR PERFORM VE-PAGE.
    MOVE PR-NUM TO EXP-FLN PERFORM OPEN-EXP.
    MOVE VE-HEADLN TO EXP-RECORD PERFORM EXP-HEADLN.

    MOVE " " TO V-KN START VENDOR KEY>=V-KN REGARDLESS INVALID GO VE9.
VE3. READ VENDOR NEXT REGARDLESS END GO VE9.
    IF NOT(V-DIV=WS-DIV AND V-NO>=VEN1 AND<=VEN2) GO VE3.
    MOVE V-NO TO FA854 MOVE V-NAME TO FA855 MOVE V-ADD1 TO FA856.
    MOVE V-ADD2 TO FA857 MOVE V-POST TO FA858 MOVE V-PAY TO FA859.
    MOVE V-CLASS TO FA860 PERFORM VE-LINE.

    COMPUTE WN1=V-PUR-YTD(1) + V-PUR-LAST(1) + V-PUR-2(1).
    COMPUTE WN2=V-PUR-YTD(2) + V-PUR-LAST(2) + V-PUR-2(2).
    IF WN1=0 AND WN2=0 GO VE8.
    MOVE V-NO TO EXP-N PERFORM EXPF MOVE V-NAME TO EXP-A PERFORM EXPF.
    MOVE V-ADD1 TO EXP-A PERFORM EXPF MOVE V-ADD2 TO EXP-A PERFORM EXPF.
    MOVE V-POST TO EXP-A PERFORM EXPF.
    IF WN1 NOT=0 MOVE "CAN" TO EXP-A ELSE MOVE "USD" TO EXP-A. PERFORM EXPF.
    IF V-GST-IND=0 MOVE "YES" TO EXP-A ELSE MOVE "NO" TO EXP-A. PERFORM EXPF.
    MOVE V-CLASS TO EXP-N PERFORM EXPF.
    COMPUTE EXP-N=V-PUR-YTD(1) + V-PUR-YTD(2) PERFORM EXPF.
    COMPUTE EXP-N=V-PUR-LAST(1) + V-PUR-LAST(2) PERFORM EXPF.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>4 MOVE V-CONTACT(IX1) TO EXP-A PERFORM EXPF END-PERFORM.
    PERFORM EXP-LINE.
VE8. GO VE3.
VE9. PERFORM CLOSE-PR PERFORM CLOSE-EXP GO MX9.

VE-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM VE-PAGE.
VE-PAGE. MOVE "VENDOR LISTING" TO FF3 PERFORM PR-PAGE.
    MOVE 2 TO WS-PR PERFORM PRANGE-VEN.
    MOVE "VEND  NAME                                 ADDRESS LINE 1                       ADDRESS LINE 2           POST CD  PAY CD  COM CLS" TO PREC PERFORM PR-LINE-3.
*         ....  .................................... .................................... ........................ .......    .       ...

* Z-20-31 CREATE G/L EXPORT FILE
SP1. PERFORM RD169 PERFORM WRT.
    ACCEPT SP-OP LINE 3 COLUMN 13 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION KEY CKEY.
    IF KPF4 OR SP-OP=99 GO SP9. IF SP-OP=0 OR>9 GO SP1.
    IF SP-OP=1 OR 2 OR 8 MOVE 0 TO A-S1 MOVE 3 TO IXT MOVE 31 TO IXU
      PERFORM AX-NY MOVE A-S1 TO SP-US.
    EVALUATE TRUE
      WHEN SP-OP=1 MOVE "ACCOUNTS PAYABLE" TO SP-JDESC
        MOVE "7900" TO SP-JOURNAL MOVE "GLAP" TO GLAP-NAME
      WHEN SP-OP=2 MOVE "ACCOUNTS PAYABLE ACCRUAL" TO SP-JDESC
        MOVE "9500" TO SP-JOURNAL MOVE "GLAC" TO GLAP-NAME
      WHEN SP-OP=3 MOVE "PAYROLL IRVINE FAST HRLY" TO SP-JDESC
        MOVE "0505" TO SP-JOURNAL MOVE "GL30" TO GLAP-NAME MOVE 30 TO WS-PDIV
      WHEN SP-OP=4 MOVE "PAYROLL IRVINE FAST SAL" TO SP-JDESC
        MOVE "0510" TO SP-JOURNAL MOVE "GL35" TO GLAP-NAME MOVE 35 TO WS-PDIV
      WHEN SP-OP=5 MOVE "PAYROLL IRVINE NUTS HRLY" TO SP-JDESC
        MOVE "0515" TO SP-JOURNAL MOVE "GL40" TO GLAP-NAME MOVE 40 TO WS-PDIV
      WHEN SP-OP=6 MOVE "PAYROLL IRVINE NUTS SAL" TO SP-JDESC
        MOVE "0520" TO SP-JOURNAL MOVE "GL45" TO GLAP-NAME MOVE 45 TO WS-PDIV
      WHEN SP-OP=7 MOVE "PAYROLL IRVINE TOOLS" TO SP-JDESC
        MOVE "0525" TO SP-JOURNAL MOVE "GL50" TO GLAP-NAME MOVE 50 TO WS-PDIV
      WHEN SP-OP=8 MOVE "ACCOUNTS RECEIVABLE" TO SP-JDESC
        MOVE "0220" TO SP-JOURNAL MOVE "GLAR" TO GLAP-NAME
      WHEN SP-OP=9 MOVE "TOOL COST" TO SP-JDESC
        MOVE "0445" TO SP-JOURNAL MOVE "GLTL" TO GLAP-NAME
      END-EVALUATE.

    MOVE SYS-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS MOVE D-N1 TO SP-SMTHS.
    PERFORM RD169A PERFORM WRT DISPLAY SP-JDESC LINE 1 COLUMN 35 BOLD.
    MOVE 3 TO IXT MOVE 18 TO IXU MOVE SYS-DATE TO D-DATE PERFORM AX-DT-DEF.
    MOVE DATE0 TO SP-ENTRY-DATE D-DATE PERFORM D-NM PERFORM D-MTHS.
    IF SP-OP=2 MOVE D-N1 TO SP-MTHS.
SP13. MOVE 5 TO IXT MOVE 18 TO IXU PERFORM AX-DT-VAL.
    MOVE DATE0 TO SP-EFFECTIVE-DATE D-DATE PERFORM D-NM PERFORM D-MTHS.
    IF SP-OP NOT=2 MOVE D-N1 TO SP-MTHS.
    COMPUTE WN1=SP-SMTHS - D-N1 IF WN1=1 GO SP14.
    MOVE "DATE MUST BE THE MONTH BEFORE THE CURRENT MONTH" TO ERR-MESG MOVE " " TO XA2.
    IF WN1=0 OR 2 PERFORM DSP-OK ELSE PERFORM DSP-ERR. IF XA2 NOT="OK" GO SP13.
SP14. MOVE D-MM TO SP-PERIOD MOVE D-YY TO SP-YY.
    MOVE "01" TO SP-ENTITY MOVE "IRV" TO SP-LEDGER.
SP17. ACCEPT SP-BATCH LINE 5 COLUMN 42 DEFAULT ZERO UNDERLINED PROTECTED CONVERSION.
    IF SP-BATCH=0 PERFORM DSP-ERR2 GO SP17.
    DISPLAY SP-YY LINE 7 COLUMN 8 CONVERSION SP-PERIOD COLUMN 23 CONVERSION
      SP-ENTITY COLUMN 38 SP-JOURNAL COLUMN 56 SP-LEDGER COLUMN 73.
    MOVE SP-PERIOD TO GLAP-NUM MOVE SP-BATCH TO GLAP-BATCH.
    DISPLAY GLAP-ID LINE 8 COLUMN 15.
    MOVE 10 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT EVALUATE TRUE
      WHEN SP-OP=1 OR 2 PERFORM SP-A
      WHEN SP-OP>=3 AND<=7 PERFORM SP-B
      WHEN SP-OP=8 PERFORM SP-C
      WHEN SP-OP=9 PERFORM SP-D
      END-EVALUATE.
SP9. GO MX9.

SP-A. PERFORM SP-A1 THRU SP-A9.
SP-A1. PERFORM OPEN-REP INITIALIZE GT-KEY MOVE WS-DIV TO GT-DIV.
    START GLTR KEY>GT-KEY REGARDLESS INVALID GO SP-A29.
SP-A23. READ GLTR NEXT REGARDLESS END GO SP-A29. IF GT-DIV>WS-DIV GO SP-A29.
    MOVE GT-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE GT-MM TO D-MM.
    PERFORM D-MTHS IF D-N1 NOT=SP-MTHS GO SP-A23.
    IF SP-OP=2 MOVE GT-INV-DATE TO D-DATE PERFORM D-NM PERFORM D-MTHS
      IF D-N1>=SP-MTHS GO SP-A23.

    IF GT-TYPE=7 OR GT-GL=GRT-PGL(9) GO SP-A23.
    IF GT-GL=GRT-PGL(2) OR GRT-PGL(4) OR GRT-PGL(6)
      IF SP-US=0 GO SP-A23 ELSE GO SP-A26.
    MOVE GT-TYPE TO WN1 MOVE 7 TO GT-TYPE.
    MOVE 1 TO WS1 READ GLTR REGARDLESS INVALID MOVE 0 TO WS1.
    MOVE WN1 TO GT-TYPE START GLTR REGARDLESS READ GLTR NEXT REGARDLESS.
    IF WS1 NOT=SP-US GO SP-A23.

SP-A26. PERFORM INIT-RP MOVE GT-GL TO RP-F113 MOVE GT-VEN TO RP-F114.
    MOVE GT-INV TO RP-F115 MOVE GT-TYPE TO RP-F116 MOVE GT-SYS TO RP-F117.
    WRITE RP-RECORD GO SP-A23.
SP-A29.

    PERFORM OPEN-SORT PERFORM OPEN-PR PERFORM SP-PAGE.
    MOVE 0 TO SP-OGL SP-ONGL SP-TOT SP-PROOF MOVE " " TO SP-ODESC.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SP-A8.
SP-A3. READ REPFL NEXT END GO SP-A8.
    MOVE WS-DIV TO GT-DIV MOVE RP-F113 TO GT-GL MOVE RP-F114 TO GT-VEN.
    MOVE RP-F115 TO GT-INV MOVE RP-F116 TO GT-TYPE MOVE RP-F117 TO GT-SYS.
    READ GLTR REGARDLESS.
    MOVE WS-DIV TO G-DIV MOVE GT-GL TO G-GL READ GLDIST REGARDLESS INVALID GO SP-A3.
    MOVE 0 TO SP-IXG MOVE GT-AMT TO SP-AMT PERFORM SP-SR.
    IF G-GL=SP-OGL GO SP-A4. IF SP-OGL NOT=0 PERFORM SP-T.
    MOVE G-GL TO SP-OGL MOVE G-DESC TO SP-ODESC MOVE G-NGL TO SP-ONGL.
SP-A4. ADD GT-AMT TO SP-TOT SP-PROOF GO SP-A3.
SP-A8. PERFORM SP-T MOVE 3 TO WS-PR MOVE "*** PROOF" TO FD641.
    MOVE SP-PROOF TO FD644 PERFORM PR-LINE PERFORM SP-RGL.
    PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR.
SP-A9. EXIT.

SP-B. PERFORM SP-B1 THRU SP-B9.
SP-B1. MOVE WS-PDIV TO LDTBL-DIV LDTR-DIV.
    OPEN I-O LDTBL ALLOWING ALL LDTR ALLOWING ALL PERFORM OPEN-REP.
    MOVE 0 TO SP-CTOT SP-PTOT INITIALIZE LY-KEY MOVE WS-PDIV TO LY-DIV.
    START LDTR KEY>LY-KEY REGARDLESS INVALID GO SP-B29.
SP-B23. READ LDTR NEXT REGARDLESS END GO SP-B29. IF LY-DIV>WS-PDIV GO SP-B29.
    MOVE LY-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO D-YEAR MOVE LY-MM TO D-MM.
    PERFORM D-MTHS IF D-N1 NOT=SP-MTHS GO SP-B23. IF LY-CODE=199 GO SP-B23.
    IF LY-CODE=280 OR 281 OR 285 OR 286 OR 287 ADD LY-AMT TO SP-CTOT.
    IF LY-CODE=283 ADD LY-AMT TO SP-PTOT.
    MOVE WS-PDIV TO GP-DIV MOVE LY-CODE TO GP-CODE.
    READ LDTBL REGARDLESS INVALID MOVE 0 TO GP-GL. PERFORM INIT-RP.
    MOVE GP-GL TO RP-F121 MOVE LY-DEPT TO RP-F122 MOVE LY-SECT TO RP-F123.
    MOVE LY-CONTRA TO RP-F124 MOVE LY-KEY TO RP-F124A WRITE RP-RECORD GO SP-B23.
SP-B29. PERFORM INIT-RP MOVE 0 TO RP-F124.
    IF WS-PDIV=35 OR 45 MOVE 543105 TO RP-F121 MOVE 77 TO RP-F122 MOVE 5 TO RP-F123
      ELSE MOVE 235805 TO RP-F121 MOVE 49 TO RP-F122 MOVE 6 TO RP-F123.
    MOVE "CTOT" TO RP-F124A WRITE RP-RECORD.
    MOVE 543104 TO RP-F121 MOVE 77 TO RP-F122 MOVE 5 TO RP-F123.
    MOVE "DPTOT" TO RP-F124A WRITE RP-RECORD.
    MOVE 133545 TO RP-F121 MOVE 0 TO RP-F122 RP-F123.
    MOVE "CPTOT" TO RP-F124A WRITE RP-RECORD.
* note 113

    PERFORM OPEN-SORT PERFORM OPEN-PR PERFORM SP-PAGE.
    MOVE 0 TO SP-OGL SP-ONGL SP-TOT SP-PROOF MOVE " " TO SP-ODESC.
    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO SP-B8.
SP-B3. READ REPFL NEXT END GO SP-B8. MOVE LOW-VALUES TO LY-RECORD.
    IF RP-F124A="CTOT" COMPUTE LY-AMT=-SP-CTOT
     ELSE IF RP-F124A="DPTOT" COMPUTE LY-AMT=-SP-PTOT
      ELSE IF RP-F124A="CPTOT" COMPUTE LY-AMT=SP-PTOT
       ELSE MOVE RP-F124A TO LY-KEY READ LDTR REGARDLESS.
    MOVE RP-F121 TO WS-GL1 MOVE RP-F122 TO WS-GL2 MOVE RP-F123 TO WS-GL3 MOVE RP-F124 TO WS-GL4.
    MOVE WS-DIV TO G-DIV MOVE WS-GL TO G-GL READ GLDIST REGARDLESS INVALID GO SP-B3.
    MOVE 0 TO SP-IXG MOVE LY-AMT TO SP-AMT PERFORM SP-SR.
    IF G-GL=SP-OGL GO SP-B4. IF SP-OGL NOT=0 PERFORM SP-T.
    MOVE G-GL TO SP-OGL MOVE G-DESC TO SP-ODESC MOVE G-NGL TO SP-ONGL.
SP-B4. ADD LY-AMT TO SP-TOT SP-PROOF GO SP-B3.
SP-B8. PERFORM SP-T MOVE 3 TO WS-PR MOVE "*** PROOF" TO FD641.
    MOVE SP-PROOF TO FD644 PERFORM PR-LINE PERFORM SP-RGL.
    CLOSE LDTBL LDTR PERFORM CLOSE-REP PERFORM CLOSE-SORT PERFORM CLOSE-PR.
SP-B9. EXIT.

SP-C. PERFORM SP-C1 THRU SP-C9.
SP-C1. PERFORM OPEN-SORT PERFORM OPEN-PR PERFORM SP-PAGE PERFORM RDR-INFO.
    MOVE 0 TO SP-PROOF MOVE 1 TO SP-IXF.
SP-C3. MOVE SP-FPOS(SP-IXF) TO SP-IXG.
* note 246
    IF IFAST AND SP-US=0 IF SP-IXG=26 OR 27 GO SP-C4.
    IF IFAST AND SP-US=1 IF SP-IXG=5 OR 6 OR>=22 AND<=25 GO SP-C4.
    IF INUT IF SP-IXG=5 OR 6 OR>=22 AND<=27 GO SP-C4.
    MOVE WS-DIV TO G-DIV MOVE SP-SGL(SP-IXG) TO G-GL.
    READ GLDIST REGARDLESS INVALID GO SP-C4.
    MOVE IF-SALVAL(SP-US + 1,SP-IXG) TO SP-AMT PERFORM SP-SR.
    MOVE G-GL TO FD640 MOVE G-DESC TO FD641 MOVE G-NGL TO FD643.
    MOVE SP-AMT TO FD644 ADD SP-AMT TO SP-PROOF PERFORM SP-LINE.
SP-C4. ADD 1 TO SP-IXF IF SP-IXF<=27 GO SP-C3.

    MOVE 3 TO WS-PR MOVE "*** PROOF" TO FD641.
    MOVE SP-PROOF TO FD644 PERFORM PR-LINE PERFORM SP-RGL.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR.
SP-C9. EXIT.

SP-D. PERFORM SP-D1 THRU SP-D9.
SP-D1. OPEN I-O GLTOOLCOST ALLOWING ALL.
    PERFORM OPEN-SORT PERFORM OPEN-PR PERFORM SP-PAGE MOVE 0 TO SP-PROOF.
    MOVE " " TO GTC-KEY START GLTOOLCOST KEY>GTC-KEY REGARDLESS INVALID GO SP-D8.
SP-D3. READ GLTOOLCOST NEXT REGARDLESS END GO SP-D8.
    MOVE WS-DIV TO G-DIV MOVE GTC-GL TO G-GL READ GLDIST REGARDLESS INVALID GO SP-D3.
    MOVE 0 TO SP-IXG MOVE GTC-AMT TO SP-AMT PERFORM SP-SR.
    MOVE G-GL TO FD640 MOVE G-DESC TO FD641 MOVE G-NGL TO FD643.
    MOVE SP-AMT TO FD644 ADD SP-AMT TO SP-PROOF PERFORM SP-LINE GO SP-D3.
SP-D8. MOVE 3 TO WS-PR MOVE "*** PROOF" TO FD641.
    MOVE SP-PROOF TO FD644 PERFORM PR-LINE PERFORM SP-RGL.
    CLOSE GLTOOLCOST PERFORM CLOSE-SORT PERFORM CLOSE-PR.
SP-D9. EXIT.

SP-SR. PERFORM INIT-SR MOVE G-NGL TO SR-F6A MOVE 0 TO SR-F6B MOVE SP-IXG TO SR-F7.
    MOVE G-DESC TO SR-F8 MOVE SP-AMT TO SR-F9.
    WRITE SR-RECORD INVALID READ SORTFL ADD SP-AMT TO SR-F9 REWRITE SR-RECORD.
SP-T. MOVE SP-OGL TO FD640 MOVE SP-ODESC TO FD641.
    IF SP-OP=1 OR 2 IF INUT MOVE 623 TO FD642 ELSE MOVE 621 TO FD642.
    MOVE SP-ONGL TO FD643 MOVE SP-TOT TO FD644 PERFORM SP-LINE MOVE 0 TO SP-TOT.
SP-RGL. PERFORM SP-R1 THRU SP-R9.
SP-R1. MOVE 0 TO SP-LNUM SP-DEBIT SP-CREDIT.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO SP-R14.
SP-R13. READ SORTFL NEXT END GO SP-R14. ADD 1 TO SP-LNUM.
    IF SR-F9>=0 ADD SR-F9 TO SP-DEBIT
      ELSE COMPUTE WD1=-SR-F9 ADD WD1 TO SP-CREDIT.
    GO SP-R13.
SP-R14. IF SP-LNUM=0 GO SP-R9. OPEN OUTPUT GLAP.
    MOVE "1" TO GLK-REC-TYPE PERFORM SP-R-K.
    MOVE "06" TO GLM-JOURNAL-TYPE MOVE SP-JDESC TO GLM-JOURNAL-DESC.
    MOVE "00" TO GLM-TRAN-CODE MOVE "0000" TO GLM-REV-JOURNAL.
    MOVE "00" TO GLM-BATCH-STATUS.
    MOVE SP-DEBIT TO GLM-CTL-DEBITS MOVE SP-CREDIT TO GLM-CTL-CREDITS.
    MOVE SP-LNUM TO GLM-CTL-LINES.
    MOVE SP-ENTRY-DATE TO D-DATE PERFORM D-NC MOVE D-N1 TO GLM-ENTRY-CDATE.
    MOVE " " TO GLM-PROCESS-DATE GLM-BAL-REQD-SW GLM-BACKUP-SW GLM-OPT-FIELD.
    MOVE 0 TO GLM-ASSIGNED-BATCH.
    MOVE SP-EFFECTIVE-DATE TO D-DATE PERFORM D-NC MOVE D-N1 TO GLM-EFFECTIVE-CDATE.
    MOVE "IFAP" TO GLM-SOURCE-SYSTEM MOVE " " TO GLM-TRANSL_JRNL_SW GLM-TRANSL_FROM_SEG.
    MOVE " " TO GLM-FILL1 WRITE GLK-RECORD.

    MOVE 0 TO SP-LNUM.
    MOVE " " TO SR-KEY START SORTFL KEY>SR-KEY INVALID GO SP-R4.
SP-R3. READ SORTFL NEXT END GO SP-R4. MOVE "2" TO GLK-REC-TYPE PERFORM SP-R-K.
    ADD 1 TO SP-LNUM MOVE SP-LNUM TO GLD-LINE.
    MOVE SR-F6 TO GLD-ACCT-ID MOVE SR-F8 TO GLD-LINE-DESC.
    MOVE "00" TO GLD-TRAN-CODE GLD-LINE-STATUS.
    MOVE 0 TO GLD-CREDIT GLD-DEBIT.
    IF SR-F9>=0 MOVE SR-F9 TO GLD-DEBIT
      ELSE COMPUTE WD1=-SR-F9 MOVE WD1 TO GLD-CREDIT.
    MOVE " " TO GLD-UPDATE-SW GLD-OPT-FIELD GLD-POSTED-SW.
    MOVE SP-EFFECTIVE-DATE TO D-DATE PERFORM D-NC MOVE D-N1 TO GLD-EFFECTIVE-CDATE.
    MOVE " " TO GLD-REF1 GLD-REF2 GLD-REF3 GLD-REF4 MOVE 0 TO GLD-STAT-AMT.
    MOVE " " TO GLD-FILL1 WRITE GLK-RECORD GO SP-R3.
SP-R4. CLOSE GLAP.
SP-R9. EXIT.
SP-R-K. MOVE SP-LEDGER TO GLK-LEDGER.
    MOVE SP-YY TO D-Y1 PERFORM D-YCONV MOVE D-Y1 TO GLK-YEAR.
    MOVE SP-ENTITY TO GLK-ENTITY MOVE SP-JOURNAL TO GLK-JOURNAL.
    MOVE SP-PERIOD TO GLK-PERIOD MOVE SP-BATCH TO GLK-BATCH.
SP-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM SP-PAGE.
SP-PAGE. MOVE "CREATE G/L EXPORT FILE" TO FF3 MOVE " " TO A-A1.
    IF SP-OP=1 OR 2 OR 8 IF SP-US=0 MOVE " - CN$" TO A-A1 ELSE MOVE " - US$" TO A-A1.
    STRING SP-JDESC A-A1 DELIMITED "  " INTO FF4 PERFORM PR-PAGE.
    MOVE "G/L ACCOUNT              DESCRIPTION                 DIV  EXTERNAL G/L ACCOUNT          AMOUNT" TO PREC PERFORM PR-LINE-3.
*         ...... ... .. .......    .........................   ...  ...... ...... .... ..   .,...,...:..-

* Z-20-32 GENERATE DUMMY INVOICES
DI1. PERFORM RD170 PERFORM WRT.
    PERFORM AX-SEL IF SEL-N=0 OR>2 GO MX1.
    MOVE 6 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-REP.
    OPEN I-O TMPURORD ALLOWING ALL TMPURLIN ALLOWING ALL.

    MOVE " " TO YOK-KEY START TMPURORD KEY>YOK-KEY REGARDLESS INVALID GO DI29.
DI23. READ TMPURORD NEXT REGARDLESS END GO DI29.
    IF NOT(Y1 AND YOK-PR=0 OR Y2 AND YOK-PR=2) GO DI23.
* note 175.2
    MOVE YOK-DATA TO OK-RECORD MOVE OK-VENDOR TO A-N1 PERFORM RD-VEN.
    PERFORM INIT-RP MOVE V-NAME TO RP-F143 MOVE OK-INV TO RP-F143A.
    MOVE YOK-KEY TO RP-F144 WRITE RP-RECORD GO DI23.
DI29. PERFORM OPEN-PR WRITE PREC AFTER PAGE MOVE " " TO DI-OINV.

    MOVE " " TO RP-KEY START REPFL KEY>RP-KEY INVALID GO DI9.
DI3. READ REPFL NEXT END GO DI9.
* note 170
    IF RP-F143A=DI-OINV MOVE RP-F144 TO YOK-KEY READ TMPURORD REGARDLESS
      MOVE YOK-DATA TO OK-RECORD GO DI34.
    IF DI-OINV>" " PERFORM DI-END WRITE PREC AFTER PAGE.
    MOVE RP-F144 TO YOK-KEY READ TMPURORD REGARDLESS MOVE YOK-DATA TO OK-RECORD.
    MOVE OK-VENDOR TO A-N1 PERFORM RD-VEN.
    MOVE RP-F143A TO DI-OINV MOVE " " TO DI-OORD.
    MOVE LOW-VALUES TO DI-ITOTALS MOVE 0 TO WS-PAGE PERFORM DI-PAGE.
DI34. IF OK-NO NOT=DI-OORD MOVE "ORDER:" TO FA207 MOVE OK-NO TO FA208 DI-OORD PERFORM DI-LINE.

    MOVE YOK-ORD TO YLK-ORD MOVE YOK-SEQ TO YLK-SEQ MOVE 0 TO YLK-LINE.
    START TMPURLIN KEY>YLK-KEY REGARDLESS INVALID GO DI6.
DI5. READ TMPURLIN NEXT REGARDLESS END GO DI6.
    IF NOT(YLK-ORD=YOK-ORD AND YLK-SEQ=YOK-SEQ) GO DI6.
    MOVE YLK-DATA TO LK-RECORD MOVE LK-CAT TO PH-CAT PERFORM PART-TYPE.
* note 80
    IF PART-MAT MOVE LK-QTY-LAST TO FA211 ELSE COMPUTE FA210 ROUNDED=LK-QTY-LAST.
    MOVE LK-UNIT TO FA212.
    IF LK-SUB-MAC=0 MOVE LK-PART TO FA214
      IF LK-DISC NOT=0 MOVE LK-QTY-LAST TO CL-QTY PERFORM KPRICE-CALC
        MOVE "DIS:" TO FA215 MOVE CL-DTXT(1:9) TO FA216 END-IF
     ELSE MOVE LK-SUB-PROD TO FA217 MOVE LK-SUB-MO TO FA218
      IF LK-SUB-SUFFIX>" " MOVE "-" TO FA219 MOVE LK-SUB-SUFFIX TO FA220 END-IF
      MOVE LK-SUB-LOT TO FA221.
    MOVE LK-PRICE TO FA226 MOVE LK-MODE TO FA227 MOVE LK-TOTAL-LAST TO FA228.
    MOVE LK-CHARGE-LAST(1:4) TO FA229 PERFORM DI-LINE.
    IF LK-SUB-MAC=0 MOVE LK-DESC1 TO FA213
      ELSE MOVE LK-SUB-MAC TO FA222 MOVE LK-DESC1 TO FA223.
    MOVE "G/L:" TO FA230 MOVE LK-GL TO FA230A.
    MOVE LK-CHARGE-LAST(5:4) TO FA229 PERFORM DI-LINE.
    IF LK-DESC2>" " MOVE LK-DESC2 TO FA213 PERFORM DI-LINE.
    IF LK-DRAW>" " PERFORM DRAW-EXP-LK
      MOVE "DRAWING:" TO FA224 MOVE A-A2 TO FA225 PERFORM DI-LINE.
    IF LK-CHARGE-LAST(5:1)>" "
      MOVE "TRUCK CHARGE" TO FA213 PERFORM DI-LINE.
    IF LK-CHARGE-LAST(6:1)>" "
      MOVE "LESS THAN TRUCK LOAD - PREMIUM" TO FA213 PERFORM DI-LINE.
    IF LK-CHARGE-LAST(7:1)>" "
      MOVE "METRO DELIVERY" TO FA213 PERFORM DI-LINE.
    IF LK-CHARGE-LAST(8:1)>" "
      MOVE "TRUCK CHARGE - EMPTY BUCKETS" TO FA213 PERFORM DI-LINE.
    PERFORM VARYING IX2 FROM 15 BY -1 UNTIL IX2=0 OR LK-NOTE(IX2)>" " CONTINUE END-PERFORM.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>IX2
      MOVE LK-NOTE(IX1) TO FA209 PERFORM DI-LINE END-PERFORM.
    ADD LK-TOTAL-LAST TO DI-TOTAL GO DI5.
DI6. ADD OK-DISC TO DI-DISC ADD OK-FREIGHT TO DI-FREIGHT.
    ADD OK-GST TO DI-GST ADD OK-PST TO DI-PST.
    IF OK-US=1 MOVE 1 TO DI-US. IF OK-FRPAY=1 MOVE 1 TO DI-FRPAY.
* note 171
    MOVE 1 TO YOK-PR REWRITE YOK-RECORD ALLOWING NO UNLOCK TMPURORD GO DI3.
DI9. IF DI-OINV>" " PERFORM DI-END.
    CLOSE TMPURORD TMPURLIN PERFORM CLOSE-REP PERFORM CLOSE-PR GO MX9.

DI-END. PERFORM DI-LINE.
    IF DI-FREIGHT NOT=0 AND DI-FRPAY=1
      MOVE "FREIGHT" TO FA213 MOVE DI-FREIGHT TO FA228
      ADD DI-FREIGHT TO DI-TOTAL PERFORM DI-LINE.
    IF DI-GST NOT=0 MOVE "GST" TO FA213 MOVE DI-GST TO FA228
      ADD DI-GST TO DI-TOTAL PERFORM DI-LINE.
    IF DI-PST NOT=0 MOVE "PST" TO FA213 MOVE DI-PST TO FA228
      ADD DI-PST TO DI-TOTAL PERFORM DI-LINE.
    MOVE "TOTAL" TO FA213 MOVE DI-TOTAL TO FA228 PERFORM DI-LINE 2 TIMES.
    IF DI-FREIGHT NOT=0 AND DI-FRPAY=0
      MOVE "FREIGHT NOT PAID TO VENDOR" TO FA213 MOVE DI-FREIGHT TO FA228 PERFORM DI-LINE.
    IF DI-DISC NOT=0 MOVE "DISCOUNT" TO FA213 MOVE DI-DISC TO FA228 PERFORM DI-LINE.
    IF DI-US=1 MOVE "PAYABLE IN US$" TO FA213 PERFORM PR-LINE.
DI-LINE. PERFORM PR-LINE IF WS-LINES>58
      MOVE 2 TO WS-PR MOVE "---- CONTINUED ----" TO FA213 PERFORM PR-LINE
      WRITE PREC AFTER PAGE PERFORM DI-PAGE PERFORM PR-LINE.
DI-PAGE. ADD 1 TO WS-PAGE MOVE 1 TO WS-LINES MOVE 1 TO WS-PR.
    MOVE WS-DIV-NAME TO PREC PERFORM PR-LINE-3.
    MOVE "D U M M Y   I N V O I C E" TO PREC(26:) PERFORM PR-LINE-3.
    MOVE "VENDOR:" TO FA197 MOVE OK-VENDOR TO FA198.
    MOVE "PREPARED BY:" TO FA199 MOVE YOK-USER TO FA200.
    MOVE "PAGE" TO FA201 MOVE WS-PAGE TO FA202 PERFORM PR-LINE-2.
    MOVE V-NAME TO FA203 MOVE "REQ DATE:" TO FA204.
    MOVE OK-DATE-REQ TO D-DATE PERFORM D-NM MOVE D-DT TO FA206 PERFORM PR-LINE.
    MOVE V-ADD1 TO FA203 MOVE "EFF DATE:" TO FA204.
    MOVE OK-EFF-DATE-LAST TO D-DATE PERFORM D-NM MOVE D-DT TO FA206 PERFORM PR-LINE.
    MOVE V-ADD2 TO FA203 MOVE "INV DATE:" TO FA204.
    MOVE OK-INV-DATE-LAST TO D-DATE PERFORM D-NM MOVE D-DT TO FA206 PERFORM PR-LINE.
    MOVE V-POST TO FA203 MOVE "DUE DATE:" TO FA204.
    MOVE OK-DUE-DATE-LAST TO D-DATE PERFORM D-NM MOVE D-DT TO FA206 PERFORM PR-LINE.
    MOVE "INVOICE:" TO FA204 MOVE DI-OINV TO FA205 PERFORM PR-LINE-3.
    MOVE "   QUANTITY   DESCRIPTION                           PRICE            AMOUNT" TO PREC PERFORM PR-LINE.
    MOVE "--------------------------------------------------------------------------------" TO PREC PERFORM PR-LINE.
*         ....,...-.... ............      DIS: .........  ..,...:... .... ....,...:..-....
*         ....,...-.... ............  ......-.  .......   ..,...:... .... ....,...:..-....
*                       ................................   G/L: ...... ... .. ....... ....

* Z-20-33 CASH REQUIREMENTS SUMMARY REPORT
UR1. PERFORM RD175 PERFORM WRT.
    MOVE 3 TO IXT PERFORM AX-PR PERFORM AX-OK IF XA2 NOT="OK" GO MX1.
    PERFORM DSP-WAIT PERFORM OPEN-SORT.

* note 117
    MOVE LOW-VALUES TO UR-WEEKS MOVE SYS-DATE TO D-DATE.
UR23. PERFORM D-WKDAY IF D-N1 NOT=5 SUBTRACT 1 FROM D-DATE GO UR23.
    MOVE D-DATE TO UR-DATE(1).
    PERFORM VARYING IX1 FROM 2 BY 1 UNTIL IX1>19
      ADD 7 TO D-DATE MOVE D-DATE TO UR-DATE(IX1) END-PERFORM.
    MOVE 123169 TO D-DT PERFORM D-MN MOVE D-DATE TO UR-DATE(20).

    MOVE 0 TO OLD-N INITIALIZE AT-KEY MOVE WS-DIV TO AT-DIV.
    START APTR KEY>AT-KEY REGARDLESS INVALID GO UR4.
UR3. READ APTR NEXT REGARDLESS END GO UR4. IF AT-DIV>WS-DIV GO UR4.
    IF AT-IND=1 GO UR3.
    IF AT-VEN=OLD-N GO UR34. MOVE WS-DIV TO V-DIV MOVE AT-VEN TO OLD-N V-NO.
    READ VENDOR REGARDLESS INVALID MOVE 0 TO V-CLASS.
UR34. PERFORM VARYING UR-IXW FROM 1 BY 1 UNTIL UR-IXW>20
       IF AT-DUE-DATE<=UR-DATE(UR-IXW) GO UR36 END-IF END-PERFORM.
UR36. IF UR-IXW>20 MOVE 20 TO UR-IXW.
    IF AT-EXCH=0 MOVE 1 TO UR-IXE ELSE MOVE 2 TO UR-IXE. PERFORM INIT-SR.
    IF AT-VEN<9000 MOVE 1 TO SR-F25 ELSE MOVE 2 TO SR-F25.
    MOVE UR-IXW TO SR-F25A.
    MOVE V-CLASS TO SR-F25B IF V-CLASS>500 MOVE 500 TO SR-F25B.
    MOVE AT-NET TO SR-F26(UR-IXE).
    WRITE SR-RECORD INVALID READ SORTFL ADD AT-NET TO SR-F26(UR-IXE) REWRITE SR-RECORD.
    ADD AT-NET TO UR-WTOT(UR-IXW,UR-IXE) GO UR3.
UR4. PERFORM VARYING UR-IXL FROM 19 BY -1 UNTIL UR-IXL=0
      IF UR-WTOTALS(UR-IXL) NOT=LOW-VALUES GO UR42 END-IF END-PERFORM.
UR42. IF UR-WTOTALS(1)=LOW-VALUES MOVE 0 TO UR-KW1 ELSE MOVE 1 TO UR-KW1.

    PERFORM OPEN-PR MOVE 1 TO UR-STEP.
UR5. PERFORM UR-PAGE MOVE 1 TO UR-IXW.
UR53. IF UR-IXW=1 OR (UR-IXW>UR-IXL AND<=19)
       IF UR-WTOTALS(UR-IXW)=LOW-VALUES GO UR58.
    MOVE "       WEEK       ENDING            (000'S)" TO PREC.
    PERFORM UR-W MOVE UR-DATE(UR-IXW) TO D-DATE PERFORM D-NM MOVE D-DT TO FA277.
    PERFORM PR-LINE.
    MOVE "          CLASS                                                    CN$       US$" TO PREC.
*                    ...  .............................................  ...,...-  ...,...-
    PERFORM UR-LINE 2 TIMES MOVE LOW-VALUES TO UR-TOTALS.
    MOVE " " TO SR-KEY MOVE UR-STEP TO SR-F25 MOVE UR-IXW TO SR-F25A MOVE 0 TO SR-F25B.
    START SORTFL KEY>=SR-KEY INVALID GO UR56.
UR55. READ SORTFL NEXT END GO UR56. IF NOT(SR-F25=UR-STEP AND SR-F25A=UR-IXW) GO UR56.
    MOVE SR-F25B TO FA278.
    IF SR-F25B=500 MOVE "MISCELLANEOUS - CLASSES 500+" TO FA279
      ELSE IF SR-F25B NOT=0 MOVE 9 TO T-TBL MOVE SR-F25B TO T-NO
        PERFORM RD-TBL MOVE T-LINE TO FA279.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2
      COMPUTE WN1 ROUNDED=SR-F26(IX1) / 1000
      MOVE WN1 TO FA280(IX1) ADD WN1 TO UR-TOT(IX1) END-PERFORM.
    PERFORM UR-LINE GO UR55.
UR56. MOVE 2 TO WS-PR MOVE "TOTALS WEEK" TO PREC PERFORM UR-W.
    PERFORM VARYING IX1 FROM 1 BY 1 UNTIL IX1>2 MOVE UR-TOT(IX1) TO FA280(IX1) END-PERFORM.
    PERFORM UR-LINE 3 TIMES.
UR58. ADD 1 TO UR-IXW IF UR-IXW<=20 GO UR53.
    IF UR-STEP=1 MOVE 2 TO UR-STEP GO UR5.
    PERFORM CLOSE-SORT PERFORM CLOSE-PR.
UR9. GO MX9.

UR-W. IF UR-IXW=20 MOVE 99 TO FA276 ELSE IF UR-KW1=1 MOVE UR-IXW TO FA276
        ELSE COMPUTE FA276=UR-IXW - 1.
UR-LINE. PERFORM PR-LINE IF WS-LINES>60 PERFORM UR-PAGE.
UR-PAGE. MOVE "CASH REQUIREMENTS SUMMARY REPORT" TO FF3.
    IF UR-STEP=1 MOVE "(EXCLUDING AFFILIATES)" TO FF4.
    IF UR-STEP=2 MOVE "(AFFILIATES)" TO FF4.
    PERFORM PR-PAGE PERFORM PR-LINE.

END-OF-PROGRAM.

